prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4001
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4001 - Oracle APEX App Builder
--
-- Application Export:
--   Application:     4001
--   Name:            Oracle APEX App Builder
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    862
--       Items:                4,755
--       Computations:           610
--       Validations:          1,243
--       Processes:            1,270
--       Regions:              3,824
--       Buttons:              2,332
--       Dynamic Actions:      1,219
--     Shared Components:
--       Logic:
--         Items:                 31
--         Processes:             12
--         Computations:           7
--         Build Options:          7
--       Navigation:
--         Lists:                259
--         Breadcrumbs:            1
--           Entries:            790
--         NavBar Entries:         3
--       Security:
--         Authentication:         1
--         Authorization:         20
--       User Interface:
--         Templates:
--           Page:                10
--           Region:              45
--           Label:               11
--           List:                16
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               7
--           Report:              20
--         LOVs:                 929
--         Shortcuts:              9
--         Plug-ins:              28
--       Globalization:
--         Messages:             499
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX App Builder')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110293920940329297')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110838'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'es'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(532421019614096524.4001)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'T:O'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_friendly_url=>'N'
,p_substitution_string_01=>'HELP'
,p_substitution_value_01=>'Ayuda'
,p_substitution_string_02=>'PRODUCT_NAME'
,p_substitution_value_02=>'Oracle APEX'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Espacio de Trabajo: &COMPANY.'
,p_substitution_string_04=>'MSG_LANGUAGE'
,p_substitution_value_04=>'Idioma'
,p_substitution_string_05=>'MSG_COPYRIGHT'
,p_substitution_value_05=>'Copyright &copy; 1999, 2021, Oracle y/o sus filiales.'
,p_substitution_string_06=>'MSG_USER'
,p_substitution_value_06=>'Usuario'
,p_substitution_string_07=>'MSG_JSCRIPT'
,p_substitution_value_07=>'Debe ejecutar este producto con JavaScript activado.'
,p_substitution_string_08=>'MSG_TBL_SUMMARY'
,p_substitution_value_08=>unistr('Tabla de Dise\00F1o de P\00E1gina')
,p_substitution_string_09=>'EDIT'
,p_substitution_value_09=>'Editar'
,p_substitution_string_10=>'DONE'
,p_substitution_value_10=>'Listo'
,p_substitution_string_11=>'TOP'
,p_substitution_value_11=>'Principal'
,p_substitution_string_12=>'CLOSE'
,p_substitution_value_12=>'Cerrar'
,p_substitution_string_13=>'CONFIRM'
,p_substitution_value_13=>'Confirmar'
,p_substitution_string_14=>'DATE_FORMAT'
,p_substitution_value_14=>'dd/mm/rr'
,p_substitution_string_15=>'LONG_DATE_FORMAT'
,p_substitution_value_15=>'fmDay dd "de" Month "de" yyyy'
,p_substitution_string_16=>'TIME_FORMAT'
,p_substitution_value_16=>'hh24:mi:ss'
,p_substitution_string_17=>'DATE_TIME_FORMAT'
,p_substitution_value_17=>'dd/mm/rr hh24:mi:ss'
,p_substitution_string_18=>'RETURN_TO_APP'
,p_substitution_value_18=>unistr('Volver a la Aplicaci\00F3n')
,p_substitution_string_19=>'DELETE_MSG'
,p_substitution_value_19=>unistr('\00BFDesea realizar esta acci\00F3n de supresi\00F3n?')
,p_substitution_string_20=>'PAGE'
,p_substitution_value_20=>unistr('P\00E1gina')
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112128'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>13
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_tab_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(5297709875.4001)
,p_name=>'shared.components.tab.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(450480819599472048.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Separadores'
,p_list_item_link_target=>'f?p=&APP_ID.:643:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'643'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46189308080649570.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Gestionar Separadores'
,p_list_item_link_target=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9000:9005'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(155545004712893410.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Vista de Juego de Separadores'
,p_list_item_link_target=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'77'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'77'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(155551816129903365.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Editar Separadores Est\00E1ndar')
,p_list_item_link_target=>'f?p=&APP_ID.:123:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'123'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(36310824965543438.4001)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'Editar Separadores Principales'
,p_list_item_link_target=>'f?p=&APP_ID.:331:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'331'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(188150925414136195.4001)
,p_list_item_display_sequence=>56
,p_list_item_link_text=>unistr('Visualizaci\00F3n Condicional')
,p_list_item_link_target=>'f?p=&APP_ID.:562:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'562'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4187304378934429.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&FLOW_ID.:200:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'200'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31647421041127463.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Gesti\00F3n de Separador Principal')
,p_list_item_link_target=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'398'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'398'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11162415001016997.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=4000:58:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'58'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_template_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(12437772301.4001)
,p_name=>'shared.components.template.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12439783039.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Plantillas'
,p_list_item_link_target=>'f?p=&FLOW_ID.:4003:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4003'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181570910687524006.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Suscripci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'124'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103318918740149314.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Publicar'
,p_list_item_link_target=>'f?p=&APP_ID.:727:&SESSION.::&DEBUG.:727:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'727:651'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12441785324.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4656,707'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7436519543386292.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=4000:368:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'368'
);
end;
/
prompt --application/shared_components/navigation/lists/export_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(12802829107.4001)
,p_name=>'Export_options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486267822373422835.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Exportar'
,p_list_item_link_target=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'523'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(79096314289012168.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Espacio de Trabajo'
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'76'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(45716606101005971.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4900'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(189447213907433212.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Exportaci\00F3n e Informes de XML')
,p_list_item_link_target=>'f?p=4850:1:&SESSION.'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60513615035446206.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Temas'
,p_list_item_link_target=>'f?p=&FLOW_ID.:224:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'224'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30477123909319995.4001)
,p_list_item_display_sequence=>85
,p_list_item_link_text=>'Plugins'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4460'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(145288215599412878.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Valores por Defecto de Interfaz de Usuario'
,p_list_item_link_target=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'479,541'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(472191226795751981.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'689'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3743275033992392.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>unistr('Cat\00E1logo')
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/pull_templates
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(320074633987.4001)
,p_name=>'pull_templates'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(320076637876.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(320078641296.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'26:4320:4069:86:4321:241:219:655:468:177'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(150871808522531061.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Identificar Tema'
,p_list_item_link_target=>'f?p=&FLOW_ID.:498:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'498:225:343:353:412:413:415:418:423'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(177583606462600141.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nuevas Plantillas'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'144:158:159:167:168:242:223:657:469'
);
end;
/
prompt --application/shared_components/navigation/lists/p4500_create_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3734458575652.4001)
,p_name=>'P4500 Create Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3734460575652.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:181,259,380,311:::'
,p_list_text_01=>'pd-create-page'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3734467605558.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('P\00E1gina como Copia')
,p_list_item_link_target=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:618,301,302,305,308,309:::'
,p_list_text_01=>'pd-create-copy-page'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1478127242456137222.4001)
,p_list_item_display_sequence=>17
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1477161567189313896.4001)
,p_list_item_display_sequence=>19
,p_list_item_link_text=>unistr('Componente de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:97:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(337326867726113326.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Regi\00F3n de Ruta de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:263:&SESSION.:PD:&DEBUG.:259,181,380:::'
,p_list_text_01=>'pd-create-breadcrumb-region'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3734469612579.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Componente Compartido'
,p_list_item_link_target=>'f?p=&APP_ID.:364:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'pd-create-shared-component'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1557581895922320741.4001)
,p_list_item_display_sequence=>52
,p_list_item_link_text=>unistr('Grupo de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:521:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1478127597899141859.4001)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3734471629609.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Comentario del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.:1234:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(45451535915378438.4001)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Incidencia'
,p_list_item_link_target=>'f?p=4600:110:&SESSION.::&DEBUG.::P110_ASSOCIATED_APP,P110_ASSOCIATED_PAGE:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p4500_utilities_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3741507057557.4001)
,p_name=>'P4500 Utilities Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3759689081747.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Suprimir P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1557582117917328385.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3741509057557.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Asesor'
,p_list_item_link_target=>'javascript:apex.navigation.popup({ url: ''f?p=&APP_ID.:8101:&SESSION.::&DEBUG.:8101:P8101_PAGE_ID:'' + pe.getCurrentPageId(), width: 1000, height: 800 }); void(0);'
,p_list_text_01=>'pd-advisor'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1557573865167095591.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Cach\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:RP,14:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3759733090282.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(591681741179830880.4001)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Total de control'
,p_list_item_link_target=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.:109:P109_COMPONENT:PAGE:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3759730086463.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Exportar'
,p_list_item_link_target=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1564223914175232731.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168415028897876470.4001)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Mostrar'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(84646475110887465.4001)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Pistas'
,p_parent_list_item_id=>wwv_flow_api.id(168415028897876470.4001)
,p_list_text_01=>'pd-enable-tooltips'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168639226669446654.4001)
,p_list_item_display_sequence=>175
,p_list_item_link_text=>'----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(168415028897876470.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168416197532917059.4001)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>unistr('Vista de dise\00F1o')
,p_parent_list_item_id=>wwv_flow_api.id(168415028897876470.4001)
,p_list_text_01=>'pd-show-layout-view'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(715120241154282785.4001)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>unistr('Dise\00F1o')
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(715121304457300310.4001)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Modo de dos paneles'
,p_parent_list_item_id=>wwv_flow_api.id(715120241154282785.4001)
,p_list_text_01=>'pd-two-column'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(715121981042303143.4001)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Modo de tres paneles'
,p_parent_list_item_id=>wwv_flow_api.id(715120241154282785.4001)
,p_list_text_01=>'pd-three-column'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(715122647048306435.4001)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(715120241154282785.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(715123600559310924.4001)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>unistr('Restablecer Dise\00F1o')
,p_parent_list_item_id=>wwv_flow_api.id(715120241154282785.4001)
,p_list_text_01=>'pd-reset-tab-layout'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_script_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(940230882533174.4001)
,p_name=>'Application Script Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(940613006537413.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Ver Resumen de Instalaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:RP:P2106_DEPLOYMENT_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10221704948316206.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Exportar Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23417101078571978.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Instalar Objetos de Soporte'
,p_list_item_link_target=>'f?p=4000:2100:&SESSION.::NO:RP,2100,2101,2102,2103,2104,2105:P2100_CANCEL_PAGE:2'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(57806406935019088.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Actualizar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150:P2150_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23486008772829647.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Desinstalar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:155:FB_FLOW_ID,P2110_CANCEL_PAGE:&FB_FLOW_ID.,2:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from WWV_FLOW_INSTALL where FLOW_ID = :fb_flow_id and sys.dbms_lob.getlength(DEINSTALL_SCRIPT) > 2'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10173510414062342.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Eliminar Todos los Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:632:&SESSION.::&DEBUG.:632:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4800287802045379.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Crear paquete de datos'
,p_list_item_link_target=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:6000:P850_SCRIPT_SOURCE:DATA:'
,p_security_scheme=>wwv_flow_api.id(3200591188196688)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_flashchart
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1192927752498551.4001)
,p_name=>'Wizard FlashChart'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(27749716114059996.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Tipo de Gr\00E1fico')
,p_list_item_link_target=>'f?p=&APP_ID.:751:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'751,752,616,4716,731,642,647,680, 265, 266'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'751:752'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1193504812510850.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Atributos de P\00E1gina y de Regi\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'616'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1194207367521038.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                    p_application_id     => :FB_FLOW_ID, ',
'                    p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523939281792733010.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(269543464571718472.4001)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Origen'
,p_list_item_link_target=>'f?p=&APP_ID.:265:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P751_CHART_ENGINE = ''JET_CHART'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'265'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(269548583138844638.4001)
,p_list_item_display_sequence=>66
,p_list_item_link_text=>unistr('Asignaci\00F3n de Columna')
,p_list_item_link_target=>'f?p=&APP_ID.:266:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P751_CHART_ENGINE = ''JET_CHART'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'266'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_master_detail
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1929128107331631.4001)
,p_name=>'Wizard_Master_Detail'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1930804474343713.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Opciones Maestras'
,p_list_item_link_target=>'f?p=&FLOW_ID.:293:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'293'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1931112785346142.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Dise\00F1o')
,p_list_item_link_target=>'f?p=&FLOW_ID.:15:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'15'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1931425599349830.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_link_target=>'f?p=&FLOW_ID.:18:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18:24'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1931710838355078.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523944833973084232.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1932018457357222.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&FLOW_ID.:35:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'35'
);
end;
/
prompt --application/shared_components/navigation/lists/rest_source_catalog_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2036513182725270.4001)
,p_name=>'REST Source Catalog Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2038981474767972.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Importar Cat\00E1logo')
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:RP,460:P460_FILE_TYPE:CATALOG:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2039418623771813.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Exportar cat\00E1logo')
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:RP,1965:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2036724084725272.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Gestionar Grupos de Cat\00E1logos')
,p_list_item_link_target=>'f?p=&APP_ID.:1968:&SESSION.::&DEBUG.:RP,1968:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_email_templates_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2306436841283369.4001)
,p_name=>'shared.components.email_templates.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2306693158283381.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Plantillas de correo electr\00F3nico')
,p_list_item_link_target=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2307095200283385.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:4862:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3100533916025399.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:4863:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_automations_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2700189206621868.4001)
,p_name=>'shared.components.automations.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2700397035621879.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Automatizaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:7020:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2700767814621880.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Log de Ejecuci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:7025:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7025,7026'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2701101624621880.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:7027:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(2778715503937249.4001)
,p_name=>'Workspace Utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(699057997282634091.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Todas las Utilidades del Espacio de Trabajo'
,p_list_item_link_target=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1500'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2779125546940169.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Valores por Defecto del Creador de Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-ui-defaults'
,p_list_text_01=>unistr('Definir configuraci\00F3n de aplicaci\00F3n, temas y atributos de globalizaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'800'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(525225511743184058.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Servicios de SQL activados para REST'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-ords-rest'
,p_list_text_01=>'Gestione referencias a servicios de SQL activados para REST externos.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(533164636995207229.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Servidores Remotos'
,p_list_item_link_target=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-database-object'
,p_list_text_01=>unistr('Gestione objetos de servidor remoto utilizados para or\00EDgenes de datos de REST y autenticaciones.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(91019908621880192.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Grupos de Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:722:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-app-groups'
,p_list_text_01=>unistr('Organizar aplicaciones en grupos l\00F3gicos.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'722'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(522749587305194510.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Credenciales web'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-security-profiles'
,p_list_text_01=>'Gestione credenciales seguras para conectar a servicios de SQL activados para REST u otros servicios de REST.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(113574116563879249.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Temas de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-workspace-themes'
,p_list_text_01=>unistr('Cualquier aplicaci\00F3n del espacio de trabajo puede utilizar la gesti\00F3n de temas de espacio de trabajo.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'763'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(787290498859273399.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Exportar...'
,p_list_item_link_target=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-export-repository'
,p_list_text_01=>'Exportar Componentes de Espacio de Trabajo.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201138622968628415.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Vistas de &PRODUCT_NAME.'
,p_list_item_link_target=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-apex-views'
,p_list_text_01=>'Consultar las diferentes vistas de los metadatos de &PRODUCT_NAME.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'714,905'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47677831332249228.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_list_item_link_target=>'f?p=&APP_ID.:9009:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-cross-app-reports'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'182'
,p_list_text_01=>'Revisar diferentes informes de atributos, comparaciones, seguridad e interfaz de usuario para espacio de trabajo.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9009'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(70887011747382286.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Gestionar copias de seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-apex-backup'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_backup.backup_limit() > 0'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Vea y gestione las copias de seguridad en todas las aplicaciones de este espacio de trabajo'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2035130738670100.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>unistr('Cat\00E1logos de origen de REST')
,p_list_item_link_target=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-sc-data-references'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_backup.backup_limit() > 0'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('Gestione cat\00E1logos de or\00EDgenes de REST para integrarlos a las aplicaciones')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_data_load_method
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3306223094711954.4001)
,p_name=>'Wizard Create Data Load Method'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3306442061711970.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3306814575711971.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de'
,p_list_item_link_target=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3307245062711971.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Copiar'
,p_list_item_link_target=>'f?p=&APP_ID.:1817:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/rest_catalog_services_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(3816997850663267.4001)
,p_name=>'REST Catalog Services Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3817572751663269.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Exportar cat\00E1logo')
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:RP,1965:P1965_CATALOG_ID:&P1963_CATALOG_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3817166638663268.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Refrescar Cat\00E1logo')
,p_list_item_link_target=>'f?p=&APP_ID.:1967:&SESSION.::&DEBUG.:RP,1967:P1967_ID:&P1963_CATALOG_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'from wwv_web_src_catalogs ',
'where security_group_id = :WORKSPACE_ID ',
'and id = :P1963_CATALOG_ID ',
'and endpoint_url is not null'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_process_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4020210037479119.4001)
,p_name=>'shared.components.application_process.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4030001947619598.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Procesos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4207'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11000225909481279.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'42'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_data_load_definitions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4115808439009126.4001)
,p_name=>'Wizard Create Data Load Definitions'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4116092287009128.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Destino'
,p_list_item_link_target=>'f?p=&APP_ID.:1811:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1810,1811,1812'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4201581850045538.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Datos de ejemplo'
,p_list_item_link_target=>'f?p=&APP_ID.:1810:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1810,1811,1812'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4201904650049010.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Asignar columnas'
,p_list_item_link_target=>'f?p=&APP_ID.:1812:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1810,1811,1812'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4202219917056524.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('P\00E1gina Cargar')
,p_list_item_link_target=>'f?p=&APP_ID.:1813:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1813, 1814'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4202527391061819.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4202874397063680.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4203129166068677.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Origen de Datos'
,p_list_item_link_target=>'f?p=&APP_ID.:1814:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1813, 1814, 4716'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1814'
);
end;
/
prompt --application/shared_components/navigation/lists/create_installation_script
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4589709522084091.4001)
,p_name=>'Create Installation Script'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4590429608089842.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'850'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4611332135223026.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Atributos de Script'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'nvl(:P850_MODE,''INSTALL'') in (''INSTALL'',''UPGRADE'')'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'855,6000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4591211039093928.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Definir Script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'856:857:858:578:669:6001'
);
end;
/
prompt --application/shared_components/navigation/lists/run_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4717527352803690.4001)
,p_name=>'run.page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4717913977809214.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Ejecutar P\00E1gina &FB_FLOW_PAGE_ID.')
,p_list_item_link_target=>'f?p=&APP_ID.:RUN_PAGE:&SESSION.:BRANCH_TO_PAGE_ACCEPT:&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui',
' where p.flow_id = :FB_FLOW_ID',
'   and p.id      = :FB_FLOW_PAGE_ID',
'   and ui.id     = p.user_interface_id',
'   and ( ui.global_page_id  <> :FB_FLOW_PAGE_ID',
'       or ui.global_page_id is null',
'       )'))
,p_list_text_01=>'runPage'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5741512908621046.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Editar P\00E1gina &FB_FLOW_PAGE_ID.')
,p_list_item_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.:'
,p_list_text_01=>'editPage'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1521230401042075.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Componentes Compartidos'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'9'
,p_list_text_01=>'sharedComponents'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(445219706544405464.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Utilidades de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(123487516760321097.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Exportar P\00E1gina &FB_FLOW_PAGE_ID.')
,p_list_item_link_target=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID,FB_FLOW_ID:&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'23,268,201,523,8'
,p_list_text_01=>'export'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4844126798254470.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Buscar'
,p_list_item_link_target=>'javascript:popUpNamed(''f?p=4000:273:&SESSION.:::RP:F4000_P273_PAGE:&FB_FLOW_PAGE_ID.'',''Finder'');'
,p_list_text_01=>'findItem'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/script_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4852514958421306.4001)
,p_name=>'Script Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(24081006745684565.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Propiedades del Script'
,p_list_item_link_target=>'javascript:pageSubmit(''APPLY_CHANGES_328'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'328'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4853228464425278.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Editor de Script'
,p_list_item_link_target=>'javascript:pageSubmit(''APPLY_CHANGES_865'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'865'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_tree_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4884503079390537.4001)
,p_name=>'shared.components.tree.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4888317947398805.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\00C1rboles')
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'28'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4889111693401694.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from WWV_FLOW_TREES where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'202'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11042723644717174.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'45'
);
end;
/
prompt --application/shared_components/navigation/lists/websrcmodule_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(4900739432788654.4001)
,p_name=>'websrcmodule.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4901345879788687.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Gestionar sincronizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:1951:P1951_WEB_SRC_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2700581299603832.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Cat\00E1logos de origen de REST')
,p_list_item_link_target=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:1960:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_tasks_4301
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(5093603989423342.4001)
,p_name=>'Page Tasks 4301'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5093917495427251.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Suprimir Varias P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5094530439440376.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Gestionar Grupos de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(5094707714443306.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Gestionar Bloqueos de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/finder_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6207014968942318.4001)
,p_name=>'Finder Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12888222063068359.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Elementos'
,p_list_item_link_target=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'273'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6208031937947265.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:516:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'516'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6284502070657757.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Consultas'
,p_list_item_link_target=>'f?p=&APP_ID.:527:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'527'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6207727781946089.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Tablas'
,p_list_item_link_target=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'514'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60548519958087566.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'PL/SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:431:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'431'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(451355613725606074.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Depurar'
,p_list_item_link_target=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'939,19'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(451401219021090108.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Sesi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'34'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(483658821697886476.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Errores'
,p_list_item_link_target=>'f?p=&APP_ID.:959:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'959'
);
end;
/
prompt --application/shared_components/navigation/lists/list_item_edit_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6276618987043262.4001)
,p_name=>'list item edit tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6277013577051156.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Cambiar Lista Principal'
,p_list_item_link_target=>'f?p=&APP_ID.:4053:&SESSION.::&DEBUG.:4053:P4053_ID:&F4000_P4052_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_security
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6730409642972302.4001)
,p_name=>'shared.components.security'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(131581022927862632.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Atributos de Seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6731321416975780.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Esquemas de Autenticaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6731930074978251.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Esquemas de Autorizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(715703720905977567.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Control de acceso a la aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:2300:&SESSION.::&DEBUG.:RP,2300:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(107341512439481992.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154637234323820007.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Credenciales web'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:1620:::'
,p_list_text_03=>'has-arrow'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_user_interface
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6736213021992272.4001)
,p_name=>'shared.components.user.interface'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(355051223966396435.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Atributos de Interfaz de Usuario'
,p_list_item_link_target=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(716516312898369111.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Temas'
,p_list_item_link_target=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(136592605767706703.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Plantillas'
,p_list_item_link_target=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6742208088009777.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Listas de Valores'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6744131637016530.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('M\00E9todos Abreviados')
,p_list_item_link_target=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(27476131766793984.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Plugins'
,p_list_item_link_target=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14966220663089761.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Valores de Componente'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6746028090034478.4001)
,p_name=>'shared.components.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6747207789038012.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Listas'
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1404393804983091259.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:RIR:IR_IS_NAVMENU:1:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'  where flow_id = :fb_flow_id ',
'     and security_group_id = :flow_security_group_id ',
'     and navigation_type = ''L'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6748930298044550.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores (heredados)'
,p_list_item_link_target=>'f?p=&APP_ID.:643:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'  where flow_id = :fb_flow_id ',
'     and security_group_id = :flow_security_group_id ',
'     and navigation_type <> ''L'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6748216793040621.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Rutas de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6748621987042177.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Entradas de Barra de Navegaci\00F3n Cl\00E1sicas')
,p_list_item_link_target=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_user_interfaces',
'where nav_bar_type = ''NAVBAR''',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1418265896610430063.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Lista de Barra de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:RIR:IR_IS_NAVBAR:1:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_user_interfaces',
'where nav_bar_type = ''LIST''',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6753822621133458.4001)
,p_name=>'shared component tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(204067027873902941.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Exportar Componentes de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23409530421523625.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Gestionar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694983664029694709.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Editar Comentario de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.::F4000_P4310_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185215606520315768.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185215915524318393.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Calendario de Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_translations
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6868813338465446.4001)
,p_name=>'shared.components.translations'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(131583418902870966.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de Globalizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:506:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6873620180486312.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Mensajes de Texto'
,p_list_item_link_target=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6870414162475145.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Traducir Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_files
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(6874810268492937.4001)
,p_name=>'shared.components.files'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9999913109548888.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
,p_list_item_link_target=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6777811617190566.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
,p_list_item_link_target=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/application_monitor_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(7285601119000778.4001)
,p_name=>'Application Monitor Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7286509084003017.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Controlar Actividad de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.::NO:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35256609257872204.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ver Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_process2
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(8047824983989923.4001)
,p_name=>'Wizard Create Process2'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_summarypage
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(8771208191950732.4001)
,p_name=>'wizard_SummaryPage'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8776908610965769.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5100'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12306121730146667.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523948471338130108.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(8878700445197468.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Atributos de Elemento'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5105'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(9251713948619425.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Elementos de Resumen'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5110'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7559603306884347.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'303'
);
end;
/
prompt --application/shared_components/navigation/lists/supporting_objects_installation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10025113710400997.4001)
,p_name=>'Supporting Objects Installation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10025907954408780.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Requisitos'
,p_list_item_link_target=>'f?p=&APP_ID.:631:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10026522499412995.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Cadenas de Sustituci\00F3n de Aplicaci\00F3n ')
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_SUBSTR_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(19115930214978417.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:511:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_BUILD_OPT_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10026826654414177.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Validaciones Previas a la Instalaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:RP:::'
,p_list_text_01=>'&P2_PRE_INS_VAL_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10117115357770425.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Scripts de Instalaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:RP:::'
,p_list_text_01=>'&P2_INST_SCRIPT_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47099730350498293.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Mensajes'
,p_list_item_link_target=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/supporting_objects_deinstallation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(10121209647806692.4001)
,p_name=>'Supporting Objects Deinstallation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10122025231811196.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Script de Desinstalaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_DE_INS_SCRIPT_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47101131567536488.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Mensaje de Desinstalaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.#DEINSTALL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_web_service_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11271810048283515.4001)
,p_name=>'shared.components.web_service.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11272321130286719.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Referencias de Servicio Web'
,p_list_item_link_target=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'170'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11279906285310777.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'63'
);
end;
/
prompt --application/shared_components/navigation/lists/page_branch_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11286824340344465.4001)
,p_name=>'page.branch.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11288626203354383.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Bifurcaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:4202:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4202'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(58002325682402982.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Suprimir Varias Bifurcaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:746:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'746'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194567927186940748.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:881:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'881:563:885'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11287304385348126.4001)
,p_list_item_display_sequence=>64
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'64'
);
end;
/
prompt --application/shared_components/navigation/lists/page_process_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11322022496485821.4001)
,p_name=>'page.process.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11322821242494955.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Procesos'
,p_list_item_link_target=>'f?p=&APP_ID.:4201:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4201'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(57980905334378187.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Suprimir Varios Procesos'
,p_list_item_link_target=>'f?p=&APP_ID.:745:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'745'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193857202841290851.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:482:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'482:213:552:866'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11323227822496829.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'65'
);
end;
/
prompt --application/shared_components/navigation/lists/create_breadcrumb
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(11694125812505020.4001)
,p_name=>'create breadcrumb'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11694630293505024.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Ruta de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:288:&SESSION.:'
,p_list_item_current_for_pages=>'288'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_view_mode
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(12991522578387911.4001)
,p_name=>'page.region.view.mode'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17995509153269699.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Atributos de Calendario'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_CALENDAR'');'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from  wwv_flow_page_plugs ',
'where PLUG_SOURCE_TYPE = ''NATIVE_CALENDAR''',
'and   id = :F4000_P4651_ID and :APP_PAGE_ID NOT IN (122,697,670,661,836)'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(85461617780828062.4001)
,p_list_item_display_sequence=>95
,p_list_item_link_text=>'Atributos de Informe'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_NATIVE_IR''); '
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_page_plugs ',
'where page_id = :fb_flow_page_id and',
'      flow_id = :fb_flow_id and',
'      :flow_page_id not in (754,370) and',
'      ((PLUG_SOURCE_TYPE = ''NATIVE_IR'' ',
'       and',
'      id = :F4000_P4651_ID ) or :flow_page_id in (601,687,694,742))'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'601:687:694'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11159118868729265.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>unistr('Atributos de Impresi\00F3n')
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_PRINT_ATTR'');'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plugs ',
' where page_id = :fb_flow_page_id',
'   and flow_id = :fb_flow_id',
'   and :flow_page_id not in (754,370)',
'   and (  (PLUG_SOURCE_TYPE in ( ''NATIVE_SQL_REPORT'',',
'                                 ''NATIVE_TABFORM'',',
'                                 ''NATIVE_IR'' )',
'          and id = :F4000_P4651_ID)',
'       or :flow_page_id in (960,774))'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'960,774'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22186214630159256.4001)
,p_list_item_display_sequence=>115
,p_list_item_link_text=>unistr('Definici\00F3n')
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_CALENDAR_DEFINITION'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'697'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22153400161060412.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Calendario Mensual'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_MONTHLY_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'122'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16872109954486071.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Calendario Semanal'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_WEEKLY_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'670'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16872929001491541.4001)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Calendario Diario'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_DAILY_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'661'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30766002077732772.4001)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Calendario Personalizado'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_CUSTOM_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'836'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3696311919048128.4001)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Calendario de Lista'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_AGENDA_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'80'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(13987931263515071.4001)
,p_name=>'page.region.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(13996410232565779.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Regiones'
,p_list_item_link_target=>'f?p=&APP_ID.:4650:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4650'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(58023120665439320.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Suprimir Varias Regiones'
,p_list_item_link_target=>'f?p=&APP_ID.:747:&SESSION.::&DEBUG.:RP,747:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'747'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(189958910147635012.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:853:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'853:249:480:70:157:438:459:128:247:217:212:864:136:690'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11228932521987173.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'60'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_component_settings_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(14972101971160040.4001)
,p_name=>'shared.components.component_settings.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14972319391160042.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Valores de Componente'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14972912989160044.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:4447:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_comparison
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15030113309394959.4001)
,p_name=>'Cross Application Reports / Comparison'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15030613786404487.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.:NORUN:&DEBUG.::::'
,p_list_item_icon=>'icon-util-app-compare'
,p_list_text_01=>'Diferencias de consulta en los nombres de componentes.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17208701402593062.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Recuentos de Resumen de Componentes'
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.:NORUN:&DEBUG.::::'
,p_list_item_icon=>'icon-util-component-counts'
,p_list_text_01=>'Diferencias de consulta en los recuentos de componentes.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_load_tables
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15132926917246073.4001)
,p_name=>'shared.component.load.tables'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15133112993246073.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Definiciones de Carga de Datos'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2902795457911853.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:1821:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15134306858246075.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:1808:&SESSION.:'
,p_list_item_current_for_pages=>'1808'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_form_on_ws
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15577802944637145.4001)
,p_name=>'wizard_form_on_ws'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15578929956644992.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'605'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15579201690646275.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523950262441140962.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15578618528641637.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Seleccionar Servicio'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'600'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15579621083651886.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Elementos de Pantalla'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'620:884'
);
end;
/
prompt --application/shared_components/navigation/lists/create_page_introduction
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15960618523591402.4001)
,p_name=>'create.page.introduction'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15961725795593556.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'259,4700,751,752'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15962230990595065.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Definir'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'500,849'
);
end;
/
prompt --application/shared_components/navigation/lists/create_component_introduction
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(16004105550701290.4001)
,p_name=>'create.component.introduction'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16006006374710902.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identificar Control'
,p_list_item_link_target=>'f?p=&APP_ID.:0:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'323,364,336'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'323,364'
);
end;
/
prompt --application/shared_components/navigation/lists/create_menu_with_menu_option
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(16141621180084222.4001)
,p_name=>'create.menu.with.menu.option'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16142629838086700.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de Regi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:263:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'263'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16143922350093999.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:264:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'264'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16144801703097508.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:286:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'286'
);
end;
/
prompt --application/shared_components/navigation/lists/page_button_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(16353308133052510.4001)
,p_name=>'page.button.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16359625373152129.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Botones'
,p_list_item_link_target=>'f?p=&APP_ID.:4203:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4203'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(51143127397134983.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Suprimir Varios Botones'
,p_list_item_link_target=>'f?p=&APP_ID.:724:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'724'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(189959220536638052.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:852:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'852:250:446:548:878'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11249424312117274.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'61,'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_legacy_data_load_wizard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(16993520375207189.4001)
,p_name=>'Wizard Create Legacy Data Load Wizard'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(585808545428825920.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tabla de Carga de Datos'
,p_list_item_link_target=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(585808884340828845.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Reglas de Transformaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1702:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(585809128851831410.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Consultas de Tabla'
,p_list_item_link_target=>'f?p=&APP_ID.:1701:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20142616358500970.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Atributos de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523936815498664127.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16994623223207192.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(307986230539557923.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Botones y Bifurcaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1706:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1706'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(17113830931867323.4001)
,p_name=>'home.page.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(53347908603459381.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Suprimir esta Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:RP,2110:FB_FLOW_ID,FB_FLOW_PAGE_ID,P2110_CANCEL_PAGE:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.,1:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
':app_page_id = ''1'''))
,p_security_scheme=>wwv_flow_api.id(12472323342703137)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(115201606939032288.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Copiar esta Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:499:&SESSION.::&DEBUG.:499,611:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(212830002493156758.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Grupos de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.:RP:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(34528309073406519.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Bloqueos de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47796518629853915.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dependencias'
,p_list_item_link_target=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(198461526128088208.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Repositorio de Exportaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(210726611906133664.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Controlar Actividad de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'71'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6996930509253802.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Panel de Control de Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'71,300,70'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4065812606027121.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Panel de Control de Actividad'
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(70886790977359157.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Gestionar copias de seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':APP_PAGE_ID in (1) and wwv_flow_backup.backup_limit() > 0'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(500599555964351445.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Examinar por facetas'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_computation_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(17446232715505772.4001)
,p_name=>'page.computation.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17447319340511375.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('C\00E1lculos')
,p_list_item_link_target=>'f?p=&APP_ID.:4204:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4204'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(57947507450331474.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Suprimir Varios C\00E1lculos')
,p_list_item_link_target=>'f?p=&APP_ID.:744:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'744'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193688712738615625.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:847:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'847:215:549:877'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17448822934521895.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'152'
);
end;
/
prompt --application/shared_components/navigation/lists/create_page_dropdown
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18268207632995006.4001)
,p_name=>'CREATE PAGE DROPDOWN'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18538906655275187.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1gina en Blanco')
,p_list_item_link_target=>'f?p=&APP_ID.:4714:&SESSION.::&DEBUG.:4714,4716,78,81,82,79,80,83:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18730913062805985.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('\00C1rbol')
,p_list_item_link_target=>'f?p=4000:112:&SESSION.::::P259_CHOOSE_PAGE_TYPE,P4700_SELECT_REPORT_TYPE:TREE,TREE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18729403103784151.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Informe'
,p_list_item_link_target=>'f?p=4000:4700:&SESSION.::::P259_CHOOSE_PAGE_TYPE,P4700_SELECT_REPORT_TYPE:REPORT,SQL_REPORT'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18539619122278798.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Gr\00E1fico')
,p_list_item_link_target=>'f?p=4000:4700:&SESSION.::::P259_CHOOSE_PAGE_TYPE,P4700_SELECT_REPORT_TYPE:CHART,BAR_HTML'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18729709683786044.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Pantalla'
,p_list_item_link_target=>'f?p=4000:4700:&SESSION.::::P259_CHOOSE_PAGE_TYPE,P4700_SELECT_REPORT_TYPE:FORM,FORM_ON_A_TABLE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18730018341788537.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Asistente'
,p_list_item_link_target=>'f?p=4000:4700:&SESSION.::::P259_CHOOSE_PAGE_TYPE,P4700_SELECT_REPORT_TYPE:WIZARD,SIMPLE_WIZARD'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18730312238796287.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Calendario'
,p_list_item_link_target=>'f?p=4000:4700:&SESSION.::::P259_CHOOSE_PAGE_TYPE,P4700_SELECT_REPORT_TYPE:CALENDAR,CALENDAR'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18739623123960261.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('P\00E1gina de Conexi\00F3n')
,p_list_item_link_target=>'f?p=4000:500:&SESSION.::NO:::'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18564606387816293.4001)
,p_name=>'wizard Copy Page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203365725936637465.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>unistr('Opci\00F3n de Copia de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'618'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18565123356821261.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1gina a Copiar')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'301'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18565729375832463.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'305:316'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523947008998118995.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Separadores'
,p_list_item_link_target=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'305:316'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20734321130916756.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Nuevos Nombres'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'302'
);
end;
/
prompt --application/shared_components/navigation/lists/create_calendar_template
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(19035021988626357.4001)
,p_name=>'create calendar template'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(19036431470638590.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&FLOW_ID.:161:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'161'
);
end;
/
prompt --application/shared_components/navigation/lists/report_layout_creation_steps
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(19263904166280419.4001)
,p_name=>'Report Layout Creation Steps'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(19265711569292026.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>unistr('Tipo de Dise\00F1o')
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1401'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(19266719244398256.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Origen de Dise\00F1o')
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1402,1406'
);
end;
/
prompt --application/shared_components/navigation/lists/switch_theme
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(20663215911569971.4001)
,p_name=>'switch.theme'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20663630109574042.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identificar Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'179'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20664529201583245.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Verificar Compatibilidad'
,p_list_item_link_target=>'f?p=&APP_ID.:386:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'386'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(20670121761618936.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmar Cambio'
,p_list_item_link_target=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'180'
);
end;
/
prompt --application/shared_components/navigation/lists/web_service_reference_wizard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(22410710903630445.4001)
,p_name=>'web service reference wizard'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33465030663752652.4001)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'Detalles de REST'
,p_list_item_link_target=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'REST'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'871'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33473413946041089.4001)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>'Entradas de REST'
,p_list_item_link_target=>'f?p=&APP_ID.:872:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'REST'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'872'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33478806692190351.4001)
,p_list_item_display_sequence=>13
,p_list_item_link_text=>'Salidas de REST'
,p_list_item_link_target=>'f?p=&APP_ID.:873:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'REST'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'873'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22495103330356887.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Ubicaci\00F3n WSDL')
,p_list_item_link_target=>'f?p=&APP_ID.:580:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'WSDL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'580'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22505817687597564.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Detalles de Servicio Web'
,p_list_item_link_target=>'f?p=&APP_ID.:585:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'WSDL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'585'
);
end;
/
prompt --application/shared_components/navigation/lists/deployment_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(22452018965176093.4001)
,p_name=>'deployment tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22452810092182983.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Mensajes'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_567'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'567'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22521803109426954.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Requisitos'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_631'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'631'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22503614097373329.4001)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Sustituciones'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_17'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'17'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22516317738412258.4001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_511'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'511'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22484008809315095.4001)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'Validaciones'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_445'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'445'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22468026031263279.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Instalar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_473'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'473'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23543014930276179.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Actualizar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_667'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'667'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22498325263357607.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Desinstalar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_576'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'576,579'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22452401088180364.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Exportar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_633'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'633'
);
end;
/
prompt --application/shared_components/navigation/lists/create_shared_query_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(22638505565903517.4001)
,p_name=>'create shared query train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22639713530905876.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Definici\00F3n de Consulta de Informe')
,p_list_item_link_target=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1110'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22640625305909268.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Consultas de Origen'
,p_list_item_link_target=>'f?p=&APP_ID.:1113:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1113, 1119'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22641406735913386.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Descargar Definici\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1115'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(112560706550636283.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Cargar Dise\00F1o de Informe')
,p_list_item_link_target=>'f?p=&APP_ID.:1118:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1118'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22641712623915044.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:1114:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1114'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(22726621018248639.4001)
,p_name=>'shared.components.reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11534830686211676.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Consultas de Informe'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18838121614544449.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Dise\00F1os de Informe')
,p_list_item_link_target=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_application_attributes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23333311543130294.4001)
,p_name=>'shared component application attributes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23334104055137553.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Editar Definici\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23346722503199625.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Editar Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.::F4000_P4310_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/supporting_object_upgrade
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23445516456661592.4001)
,p_name=>'Supporting Object Upgrade'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23447506544668156.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Archivos de Comandos de Actualizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_UPG_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47100700053527309.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Mensaje de Actualizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.#UPGRADE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_application
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23817524863605164.4001)
,p_name=>'Copy Application'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23817717317605164.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identificar Destino de Copia'
,p_list_item_link_target=>'f?p=&APP_ID.:499:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23818031260605166.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:611:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'611'
);
end;
/
prompt --application/shared_components/navigation/lists/script_results_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(24172418538839346.4001)
,p_name=>'script results tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(24173525249850711.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Instalar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.::P2100_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(80633901866542564.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Actualizar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150,2151,2152,2153,2154:P2150_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(24173116592848238.4001)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>unistr('Desinstalar Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:2110:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(24257620317868232.4001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>unistr('Editar Archivos de Comandos de Instalaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'2106'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(24256800577862502.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Gestionar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'2106'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37122929947493126.4001)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>unistr('Editar Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(96986426278147432.4001)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>unistr('Ejecutar Aplicaci\00F3n')
,p_list_item_link_target=>'&P2106_HOME_LINK.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'2106'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(98381926501308170.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Ver y Descargar Script \00DAnico')
,p_list_item_link_target=>'f?p=&APP_ID.:432:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :FLOW_PAGE_ID = 473 then',
'  for c1 in (select null',
'             from #OWNER#.wwv_flow_install_scripts',
'             where flow_id = :fb_flow_id ',
'             and security_group_id = :flow_security_group_id',
'             and nvl(script_type,''INSTALL'') = ''INSTALL'')',
'  loop',
'      return true;',
'  end loop;',
'end if;',
'return false;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(403371215736939990.4001)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>unistr('Ver y Descargar Script \00DAnico')
,p_list_item_link_target=>'f?p=&APP_ID.:457:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :FLOW_PAGE_ID = 667 then',
'  for c1 in (select 1',
'             from #OWNER#.wwv_flow_install_scripts',
'             where flow_id = :fb_flow_id ',
'             and security_group_id = :flow_security_group_id',
'             and nvl(script_type,''INSTALL'') = ''UPGRADE'')',
'  loop',
'      return true;',
'  end loop;',
'end if;',
'return false;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(403375103864031484.4001)
,p_list_item_display_sequence=>13
,p_list_item_link_text=>unistr('Ver y Descargar Script \00DAnico')
,p_list_item_link_target=>'f?p=&APP_ID.:462:&SESSION.::&DEBUG.:462:::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :flow_page_id = 576 then',
'  for c1 in (select null',
'             from wwv_flow_install',
'             where flow_id = :fb_flow_id',
'             and security_group_id = :flow_security_group_id',
'             and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0)',
'  loop',
'      return true;',
'  end loop;',
'end if;',
'return false;',
''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(118217100108549882.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Crear Script de DDL de Aplicaci\00F3n')
,p_list_item_link_target=>'javascript:doSubmit(''DDL_SCRIPT'')'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'1=2'
,p_list_item_disp_condition2=>'SQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(236577109798623828.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Cambiar Secuencia de Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:802:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_install_scripts',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''INSTALL''',
'and :APP_PAGE_ID = 473'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(380042987976769926.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Cambiar Secuencia de Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:38:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_install_scripts',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'and :APP_PAGE_ID = 667'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4700464872031326.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Crear paquete de datos'
,p_list_item_link_target=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:6000:P850_SCRIPT_SOURCE:DATA:'
,p_security_scheme=>wwv_flow_api.id(3200591188196688)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_dynamic_action
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(25338502483800688.4001)
,p_name=>'create.dynamic_action'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/mb_context_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(25800649414501670.4001)
,p_name=>'MB Context Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25800842464501683.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Restaurar'
,p_list_item_link_target=>'f?p=&APP_ID.:974:&SESSION.::&DEBUG.:974:P974_ID,P974_FLOW_ID:$backupid$,$flowid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25801216993501684.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Descargar'
,p_list_item_link_target=>'p?n=$objectid$'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25801607394501685.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Ver Detalles'
,p_list_item_link_target=>'f?p=&APP_ID.:973:&SESSION.::&DEBUG.:973:P973_ID:$backupid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25802068672501685.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gestionar bloqueo'
,p_list_item_link_target=>'f?p=&APP_ID.:976:&SESSION.::&DEBUG.:976:P976_ID:$backupid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25803493813511373.4001)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25803138133508799.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Suprimir'
,p_list_item_link_target=>'f?p=&APP_ID.:977:&SESSION.::&DEBUG.:977:P977_FLOW_ID,P977_ID:$flowid$,$backupid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_application_process
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(25941806450198106.4001)
,p_name=>'create.application.process'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25942514415200446.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Identificaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'147'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25943018571201605.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Origen'
,p_list_item_link_target=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'148'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25955304550235459.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Condicionalidad'
,p_list_item_link_target=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'150'
);
end;
/
prompt --application/shared_components/navigation/lists/multi_table_create_application
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(26219416632336505.4001)
,p_name=>'multi-table create application'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170634803652169586.4001)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'Componentes Compartidos'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'17:476:433'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_resources
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(26512283167477231.4001)
,p_name=>'developer.resources'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(26512415103477231.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Iconos de fuente APEX'
,p_list_item_link_target=>'https://apex.oracle.com/fontapex'
,p_list_text_02=>'target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_plugins_edit_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(27884204995681439.4001)
,p_name=>'shared.components.plugins.edit.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15025526109384601.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Valores de Componente'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:4445,CIR:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.has_application_attributes (',
'    p_application_id => :P4410_FLOW_ID,',
'    p_plugin_type    => :P4410_PLUGIN_TYPE,',
'    p_plugin_name    => :P4410_NAME )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28084903887018683.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Exportar Plugin'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:RP,4460:P4460_PLUGIN_ID:&P4410_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(27884715851681468.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:RP,CIR:IR_DISPLAY_NAME:&P4410_DISPLAY_NAME.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_plugins_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(27943608569240649.4001)
,p_name=>'shared.components.plugins.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28086530815045307.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Exportar Plugin'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:RP,4460:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_dynamic_action_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(28119925264668131.4001)
,p_name=>'page.dynamic_action.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28120209465673032.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Acciones Din\00E1micas')
,p_list_item_link_target=>'f?p=&APP_ID.:773:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'773'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28120415005674680.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Suprimir Varias Acciones Din\00E1micas')
,p_list_item_link_target=>'f?p=&APP_ID.:794:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'794'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194156219281175220.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'863:699'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28120618815675737.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:795:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'795'
);
end;
/
prompt --application/shared_components/navigation/lists/web_service_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(28359907580129646.4001)
,p_name=>'web service tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28360319831142579.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crear Referencia de Servicio Web Manualmente'
,p_list_item_link_target=>'f?p=&APP_ID.:199:&SESSION.::&DEBUG.:196:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/synchronize_defaults
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(28511519360309024.4001)
,p_name=>'Synchronize Defaults'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/form_on_ws_with_rpt
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(30094110886480012.4001)
,p_name=>'form_on_ws_with_rpt'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30094627509484763.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Seleccionar Servicio y Operaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'700'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30094903052487151.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Atributos de P\00E1gina y de Regi\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'705'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30095522099492672.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Elementos de Entrada'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'720:880'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22663523536956076.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>unistr('Autenticaci\00F3n')
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30095815304500150.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Resultados de Servicio Web'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'725:842'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30096124308502737.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Par\00E1metros del Informe')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'730:882:848'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30095212402489886.4001)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1556523170111727633.4001)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30096432619505205.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'735'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities_line3
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(30782715391876326.4001)
,p_name=>'application.utilities.line3'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30782921600876331.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Informes Guardados'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:RP,RIR:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(30783226672876332.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Suscripciones'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RP,RIR:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/caching
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(31086920674251816.4001)
,p_name=>'Caching'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31098728732310986.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Todas las P\00E1gina en Cach\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31087325522253253.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Todas las Regiones en Cach\00E9')
,p_list_item_link_target=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sqlquery_on_ws_result
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(31960916110521509.4001)
,p_name=>'sqlquery_on_ws_result'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31962812085529789.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Informaci\00F3n de Referencia Web')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'760,775,784'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31963927323534138.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Opciones y Par\00E1metros de Informe')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'765,780,790'
);
end;
/
prompt --application/shared_components/navigation/lists/list_utility_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(33430506092105266.4001)
,p_name=>'list utility options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12826927626041434.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>unistr('Agregar esta lista a la p\00E1gina actual')
,p_list_item_link_target=>'f?p=&APP_ID.:4016:&SESSION.::&DEBUG.:181,4016,4017,4018,259,380:P4016_SOURCE_TYPE,P407_IDENTIFY_LIST,F4000_P4016_TITLE:LIST,&F4000_P4050_LIST_ID.,&P4050_LIST_NAME.:'
,p_list_item_disp_cond_type=>'NOT_EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from WWV_FLOW_PAGE_PLUGS ',
'where list_id = :F4000_P4050_LIST_ID AND ',
'PAGE_ID = :fb_flow_page_id and ',
'flow_id = :fb_flow_id'))
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33455121161147439.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copiar Lista'
,p_list_item_link_target=>'f?p=&APP_ID.:658:&SESSION.::&DEBUG.:602,658,663:P602_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33431712672107181.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar Entradas de Lista de una Lista a Otra'
,p_list_item_link_target=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.:477:P477_COPY_LIST_FROM:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    list_type = ''STATIC'''))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33434024793110611.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Crear Nuevo Principal de Entradas de Lista en esta Lista'
,p_list_item_link_target=>'f?p=&APP_ID.:2222:&SESSION.::&DEBUG.::P2222_LIST_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and   list_type = ''STATIC'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40745428326672193.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Gestionar Entradas de Lista Hu\00E9rfanas')
,p_list_item_link_target=>'f?p=&APP_ID.:712:&SESSION.::&DEBUG.:RP:P712_LIST_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    list_type = ''STATIC'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(170300712666400884.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Cambiar Secuencia de Entradas de Lista'
,p_list_item_link_target=>'f?p=&APP_ID.:536:&SESSION.::&DEBUG.::P536_LIST_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    list_type = ''STATIC'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_list_entries
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(33731702665524035.4001)
,p_name=>'Copy List Entries'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33733202927543059.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identificar Destino de Copia'
,p_list_item_link_target=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'477'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33733511584545617.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirmar Copia de Entrada de Lista'
,p_list_item_link_target=>'f?p=&APP_ID.:478:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'478'
);
end;
/
prompt --application/shared_components/navigation/lists/lock_functions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(34740016606195595.4001)
,p_name=>'lock.functions'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(34740422493197305.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Bloqueos de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'291'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(34740830804199645.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Bloquear Administraci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:299:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'299'
);
end;
/
prompt --application/shared_components/navigation/lists/standard_tab_management
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(35060712015585948.4001)
,p_name=>'standard.tab.management'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35061409029594543.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Mover Separador Est\00E1ndar Resaltado a un Separador Principal Diferente')
,p_list_item_link_target=>'f?p=&FLOW_ID.:77:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from WWV_FLOW_TOPLEVEL_TABS',
' where flow_id = :fb_flow_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35061718033597155.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_list_item_link_target=>'f?p=&FLOW_ID.:345:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_tabs where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35062024959599144.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Cambiar Secuencia de Orden de Visualizaci\00F3n')
,p_list_item_link_target=>'f?p=&FLOW_ID.:123:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_tabs where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35062632017610572.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Asociar P\00E1ginas a Separador Est\00E1ndar Seleccionado')
,p_list_item_link_target=>'f?p=&APP_ID.:9005:&SESSION.::&DEBUG.:9005:F4000_P9005_TAB_ID:&F4000_CUR_STD_TAB.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_tabs where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35097012080765730.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>unistr('Crear Nuevo Separador Est\00E1ndar')
,p_list_item_link_target=>'f?p=4000:90:&SESSION.::NO:92,94,95,96,4722,4723,4724'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(35063015871615372.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Crear Nuevo Juego de Separadores Est\00E1ndar')
,p_list_item_link_target=>'f?p=4000:9000:&SESSION.::::F4000_P9000_CUR_PTAB,F4000_CUR_STD_TAB:999999999999,'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/install_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(37438506954816730.4001)
,p_name=>'Install Progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37439316651819553.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Objetos de Soporte'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2100:2115'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37439619768820400.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Licencia'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2101'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37440226347822326.4001)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>unistr('Sustituciones de Aplicaci\00F3n')
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2103'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(13556731674021001.4001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2107'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37439922884821393.4001)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Validaciones'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2102:2108'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37440529810823352.4001)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>unistr('Confirmaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2104'
);
end;
/
prompt --application/shared_components/navigation/lists/import_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(37899301707472090.4001)
,p_name=>'import progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37899710018474406.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Especificar Archivo'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'460'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37900017290476513.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Confirmaci\00F3n de Importaci\00F3n de Archivo')
,p_list_item_link_target=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'163'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(37910625087516631.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Instalar'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'49:67:166:409:253:321:598:4450:929:494:612:1966'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(272780339297125857.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Peticiones de datos'
,p_list_item_link_target=>'f?p=&APP_ID.:2160:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/repository
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(38836703962860678.4001)
,p_name=>'repository'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(38837209849862399.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Gestionar Repositorio de Exportaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'460,163,48,644'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226337903706179254.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Vista Previa de Archivo'
,p_list_item_link_target=>'javascript:popupURL(''f?p=&FLOW_ID.:2120:&SESSION.::&DEBUG.::P2120_FILE_ID:&P163_FILE_ID.'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'163,49,48,494,644'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_calendar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(41547421928169148.4001)
,p_name=>'Wizard Create Calendar'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_md_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(42519297248600803.4001)
,p_name=>'Wizard Create MD Page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42519403820600804.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'32,326,98,961'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42520260714600807.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_user_interface_dev.supports_tabs (',
'          p_application_id     => :FB_FLOW_ID, ',
'          p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42519866060600806.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42521082419600808.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen Maestro'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P29_MD_TYPE'
,p_list_item_disp_condition2=>'MD_SINGLE_PG:MD_TWO_PG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'239'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42521842664600808.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen Maestro/Detalle'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P29_MD_TYPE'
,p_list_item_disp_condition2=>'MD_EMAIL_STYLE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'99'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42522643669600809.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Origen de Detalles'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P29_MD_TYPE'
,p_list_item_disp_condition2=>'MD_SINGLE_PG:MD_TWO_PG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'257'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_dashboard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(43062373542725339.4001)
,p_name=>'Wizard Create Dashboard'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(43062548622725340.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'326,759,98,961'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(43063368505725341.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_user_interface_dev.supports_tabs (',
'          p_application_id     => :FB_FLOW_ID, ',
'          p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(43062989624725341.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(43064541793725341.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Dise\00F1o del panel de control')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'962'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_apex_4_0_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(46890703166185102.4001)
,p_name=>'Home Page APEX 4.0 list'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46891214941188463.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Ejecutar Aplicaci\00F3n')
,p_list_item_link_target=>'&F4000_P1_RUN_LINK.'
,p_list_item_icon=>'app-builder-run-app'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46891420828190182.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-sql-script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46891900873193850.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Componentes Compartidos'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.:'
,p_list_item_icon=>'app-builder-shared-components'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(177830030226412242.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(46892107107195637.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Exportar/Importar'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.:'
,p_list_item_icon=>'app-builder-export-import'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_utilities_report_regions
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47104812669691866.4001)
,p_name=>'page.region.utilities.report.regions'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47106211554691868.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todas las Cabeceras de Columna de Informe Est\00E1ndar')
,p_list_item_link_target=>'f?p=&APP_ID.:217:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(445540813206505532.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todas las Cabeceras de Columna de Informe Interactivo')
,p_list_item_link_target=>'f?p=&APP_ID.:690:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47106522548691869.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todos los Mensajes de Datos No Encontrados')
,p_list_item_link_target=>'f?p=&APP_ID.:212:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492651908993878213.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Actualizar Configuraci\00F3n de Informes Interactivos')
,p_list_item_link_target=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47105918660691868.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Origen de Regi\00F3n de Consulta SQL')
,p_list_item_link_target=>'f?p=&APP_ID.:247:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492644402142781679.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Suscripciones de Informe Interactivo'
,p_list_item_link_target=>'f?p=4350:92:&SESSION.::&DEBUG.:RIR:IR_NFLOW_ID:&FB_FLOW_ID.'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_security
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47648606548052805.4001)
,p_name=>'Cross Application Reports / Security'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47650319458052824.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Perfiles de Seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:9014:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-security-profiles'
,p_list_text_01=>unistr('Ver detalles de seguridad de cada aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47650917494052824.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Esquemas de Autenticaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:9015:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-auth-scheme'
,p_list_text_01=>unistr('Ver todos los esquemas de autenticaci\00F3n de cada aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47650613876052824.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Elementos de Contrase\00F1a')
,p_list_item_link_target=>'f?p=&APP_ID.:7777:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-password'
,p_list_text_01=>unistr('Revisar elementos de contrase\00F1a individual y su configuraci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_user_interface
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47656832568088745.4001)
,p_name=>'Cross Application Reports / User Interface'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47658830638088749.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Resumen del Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:737:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-theme-summary'
,p_list_text_01=>'Ver tema por defecto y recuento de temas.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_item_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47807005066095922.4001)
,p_name=>'shared.components.application_item.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47807417533099513.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Elementos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4100'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47808827230102390.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'130'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192556407703412832.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:533:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'533'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_computation_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47827519966525945.4001)
,p_name=>'shared.components.application_computation.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47827910747532792.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4101'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47828120790535668.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'43'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_build_option_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(47909111131552473.4001)
,p_name=>'shared.components.build_option.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47909728792557644.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4910'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47909902258559446.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:203:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'203'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192566112775480588.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:535:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'535'
);
end;
/
prompt --application/shared_components/navigation/lists/delete_multiple_pages
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(48377323742917579.4001)
,p_name=>'delete Multiple Pages'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48377606904922202.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Suprimir P\00E1ginas Comprobadas')
,p_list_item_link_target=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.:339:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'339'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48377811406923459.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Suprimir P\00E1ginas por Rango')
,p_list_item_link_target=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:72:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'72'
);
end;
/
prompt --application/shared_components/navigation/lists/install_progress_upgrade
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(48681713885605105.4001)
,p_name=>'Install Progress (Upgrade)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48681921050605105.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Objetos de Soporte'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2150'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48682216352605105.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Licencia'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2151'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48682518004605105.4001)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>unistr('Sustituciones de Aplicaci\00F3n')
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2153'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48682805062605105.4001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2157'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48683114640605105.4001)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Validaciones'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2152,2158'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48683423866605106.4001)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>unistr('Confirmaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2154'
);
end;
/
prompt --application/shared_components/navigation/lists/structured_query
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(55535125515641311.4001)
,p_name=>'Structured_Query'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/create_web_reference_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(57083604297327751.4001)
,p_name=>'create_web_reference_tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1030018641100391162.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Crear Referencia Web RESTFul'
,p_list_item_link_target=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.:871:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(57084621958332785.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Crear Referencia Web Manualmente'
,p_list_item_link_target=>'f?p=&APP_ID.:199:&SESSION.::&DEBUG.:199:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/install_preview_upgrade
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(57809829707044603.4001)
,p_name=>'Install Preview (Upgrade)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(57810025849044605.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Vista Previa de Archivos de Comandos de Actualizaci\00F3n')
,p_list_item_link_target=>'javascript:popupURL(''f?p=&APP_ID.:2109:&SESSION.::&DEBUG.::P2109_MODE:UPGRADE'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/export_install_navigate
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(58916220936178306.4001)
,p_name=>'export.install.navigate'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(58917130286181031.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Gestionar Repositorio de Exportaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486309116766298442.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Exportar'
,p_list_item_link_target=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'461'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(445307613122457455.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Exportaci\00F3n de Componente')
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'680'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_theme_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(58949101764235429.4001)
,p_name=>'shared.components.theme.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1030175014751098308.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Temas'
,p_list_item_link_target=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(44080124445670825.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Informes'
,p_list_item_link_target=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:RP:P173_SHOW:1:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'173,435,491,492'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193120127053383246.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:681:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'681'
);
end;
/
prompt --application/shared_components/navigation/lists/view_ui_default
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(59836303269637894.4001)
,p_name=>'view.ui.default'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(59850310111658783.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Ver Valores por Defecto de Tabla'
,p_list_item_link_target=>'javascript:popupURL(''f?p=4000:391:&SESSION.:::391,RP:P391_SCHEMA,P391_TABLE:&UI_SCHEMA.,&UI_TABLE.'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'769,4795,4811,4017'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(177740131510804118.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Editar Diccionario de Tablas'
,p_list_item_link_target=>'f?p=4500:802:&SESSION.::NO:RP,802:P800_SCHEMA,P802_TABLE_ID:&UI_SCHEMA.,&UI_TABLE_ID.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'769,4795,4811,4017'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491980431480090226.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Ver Diccionario de Atributos'
,p_list_item_link_target=>'javascript:popupURL(''f?p=4000:579:&SESSION.:::RIR:P391_SCHEMA:&UI_SCHEMA.'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491968306537007365.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Editar Diccionario de Atributos'
,p_list_item_link_target=>'f?p=4500:6:&SESSION.::NO:RIR:P800_SCHEMA:&UI_SCHEMA.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/theme_home_page_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(60448901162323653.4001)
,p_name=>'theme home page utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60452220471348108.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Copiar Tema'
,p_list_item_link_target=>'f?p=&FLOW_ID.:401:&SESSION.::&DEBUG.:401::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60458828136378754.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Suprimir Tema'
,p_list_item_link_target=>'f?p=&FLOW_ID.:221:&SESSION.::&DEBUG.:221::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60449412936327043.4001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Exportar Tema'
,p_list_item_link_target=>'f?p=&FLOW_ID.:224:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60449817785328400.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Importar Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.::P460_FILE_TYPE:THEME:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(60460231384389174.4001)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>unistr('Cambiar N\00FAmero de Identificaci\00F3n')
,p_list_item_link_target=>'f?p=&FLOW_ID.:397:&SESSION.::&DEBUG.:397::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1433728355595982335.4001)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>unistr('Restaurar Suscripci\00F3n a Tema')
,p_list_item_link_target=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:117:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(112939916055325918.4001)
,p_list_item_display_sequence=>8
,p_list_item_link_text=>'Gestionar Temas de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.:RP,764,789,762:P764_FLOW_ID:&FB_FLOW_ID.:'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_auth_scheme
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(61117217587002695.4001)
,p_name=>'Wizard Create Auth Scheme'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_queryandupdate
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(61344818353755082.4001)
,p_name=>'Wizard_QueryAndUpdate'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(228553803814437231.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(  wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''CLASSIC_REPORT'' )',
'    or wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''INTERACTIVE_REPORT'' )',
'   or wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''INTERACTIVE_GRID'' )',
'    )',
'and :P4041_TYPE <> ''L''',
''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4041'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(236520428554356872.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('P\00E1gina de Vista de Lista')
,p_list_item_link_target=>'f?p=&APP_ID.:4041:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'   p_user_interface_id => :P259_USER_INTERFACE_ID,',
'   p_name              => ''JQM_LIST_VIEW'' )',
'and :P4041_TYPE = ''L''',
''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(244226925625575227.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523946278406098620.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(61345251703760834.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen de Datos'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P4041_IMPLEMENTATION'
,p_list_item_disp_condition2=>'INTERACTIVE:CLASSIC:LISTVIEW:IG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4703'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1830144361723993.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Origen de Datos'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P4041_IMPLEMENTATION'
,p_list_item_disp_condition2=>'INTERACTIVE:CLASSIC:LISTVIEW:IG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4735'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(61345778748773642.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('P\00E1gina de Pantalla')
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4039'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(61346217753778866.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('P\00E1gina de Pantalla')
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P4041_IMPLEMENTATION'
,p_list_item_disp_condition2=>'INTERACTIVE:CLASSIC:LISTVIEW'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'339,4776'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1831622212746953.4001)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>unistr('P\00E1gina de Pantalla')
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P4041_IMPLEMENTATION'
,p_list_item_disp_condition2=>'INTERACTIVE:CLASSIC:LISTVIEW'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4736'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_basicreport_2
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(61699916790121470.4001)
,p_name=>'Wizard_BasicReport(2)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109443311830022928.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523920690482388878.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
end;
/
prompt --application/shared_components/navigation/lists/authorization_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(62154210909909582.4001)
,p_name=>'authorization.reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(62154920044921741.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1ginas de Informe con Esquemas de Autorizaci\00F3n')
,p_list_item_link_target=>'javascript:popupURL(''f?p=4000:4046:&SESSION.::&DEBUG.::P4046_OPT:1'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(62154609655918761.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('P\00E1ginas de Informe sin Esquemas de Autorizaci\00F3n')
,p_list_item_link_target=>'javascript:popupURL(''f?p=4000:4046:&SESSION.::&DEBUG.::P4046_OPT:2'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_calendar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(62236810622390487.4001)
,p_name=>'Wizard_Calendar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(62237153018397042.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4785'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109671331726211248.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523940665752859180.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(62237436934399132.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen'
,p_list_item_disp_condition2=>'EASY_CALENDAR'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4790'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(62384616373249992.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Atributos de Calendario'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4791'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7148525331174291.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'281'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7148830872175915.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Correcto'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'282'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'282'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_list_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(62973516530710918.4001)
,p_name=>'shared.components.list.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(16379422446669293.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Listas'
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'405'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(188592804007726720.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Detalles de Lista'
,p_list_item_link_target=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4050'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3734320150685363.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Definici\00F3n')
,p_list_item_link_target=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4050'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165042505638783535.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Entradas'
,p_list_item_link_target=>'f?p=&FLOW_ID.:145:&SESSION.::&DEBUG.::F4000_P4051_ID:&F4000_P4050_LIST_ID.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'145,2,17'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'145,2,17'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(152909708490771744.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'No Utilizado'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_lists where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'10'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(188112617636897422.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Entradas Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:557:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'557'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(3698822128638837.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_lists where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'156,417'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11021905065645615.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'44'
);
end;
/
prompt --application/shared_components/navigation/lists/p1500_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(63310734885303893.4001)
,p_name=>'p1500 tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183788272600635275.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gestionar copias de seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:970:::'
,p_list_item_icon=>'icon-apex-backup'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(500597206178327494.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Examinar por facetas'
,p_list_item_link_target=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/breadcrumb_entry_views
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(65506221314219691.4001)
,p_name=>'breadcrumb entry views'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_formonequijoin
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(70041819940286906.4001)
,p_name=>'Wizard_FormOnEquijoin'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(70044515443302336.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4810'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111107623526670500.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P4810_PAGE_ID) = false',
'and',
'not wwv_flow_user_interface_dev.supports_tabs (',
'          p_application_id     => :FB_FLOW_ID, ',
'          p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523942466683902769.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P4810_PAGE_ID) = false',
'and',
'wwv_flow_user_interface_dev.supports_tabs (',
'    p_application_id     => :FB_FLOW_ID, ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(70045210197305060.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Origen'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P4810_FORM_TYPE'
,p_list_item_disp_condition2=>'FORMONSQL:FORM'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4735'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(280259037283041066.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Origen'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P4810_FORM_TYPE'
,p_list_item_disp_condition2=>'FORMONPROC'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4711'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(70045988490306843.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Atributos de Pantalla'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P4700_SELECT_REPORT_TYPE'
,p_list_item_disp_condition2=>'FORM'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4812'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_button_template
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(79547928409156701.4001)
,p_name=>'Wizard Create Button Template'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(79552721077160159.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(79555017842161642.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Detalles'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'218'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(82926628922893097.4001)
,p_name=>'wizard Create Page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(82928115767899188.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4714'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(82930304553904440.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523948020363125451.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(82934321362911818.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'79'
);
end;
/
prompt --application/shared_components/navigation/lists/application_group_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(91618427870317883.4001)
,p_name=>'Application Group Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(92285408876511015.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Gestionar Asignaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:RP,736:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(91618806877321244.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Gestionar No Asignados'
,p_list_item_link_target=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:RP,736:P736_SHOW:UNASSIGNED:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ir_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(91747231305508774.4001)
,p_name=>'ir_tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(196353019228502005.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ver Actividad de Informe Guardado'
,p_list_item_link_target=>'f?p=4350:93:&SESSION.:::RIR,CIR:IR_APPLICATION_ID,IR_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(442777026341677254.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Gestionar Suscripciones'
,p_list_item_link_target=>'f?p=4350:92:&SESSION.:::RIR,CIR:IR_NFLOW_ID,IR_NPAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_interactive_report_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(92836304316872750.4001)
,p_name=>'wizard_create_interactive_report_page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(92837021977877846.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'326,759,98,961'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(92837632366880883.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'  p_flow_id => :fb_flow_id, ',
'  p_page_id => :F4000_P4701_FLOW_STEP_ID',
') = false',
'and',
'not wwv_flow_user_interface_dev.supports_tabs (',
'          p_application_id     => :FB_FLOW_ID, ',
'          p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523948867681134525.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'  p_flow_id => :fb_flow_id, ',
'  p_page_id => :F4000_P4701_FLOW_STEP_ID',
') = false',
'and',
'wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID)'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(92911312702130656.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Origen del Informe'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_list_item_disp_condition=>'P759_REPORT_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'769'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(13234382971300604.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Atributos de tarjetas'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :P759_REPORT_TYPE = ''CARD'' ) or',
'( :P759_REPORT_TYPE = ''FACETED_SEARCH'' and :P769_FS_DISPLAY_AS = ''CARD'' )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'770'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(235189540462900083.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Tipo de Referencia Web'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P759_REPORT_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'778'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(235190199021968007.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Informaci\00F3n de Referencia Web')
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P759_REPORT_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'779:781:859'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(235190496270971838.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('Par\00E1metros y Opciones')
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P759_REPORT_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'782:783:860'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_page_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(92837202675352059.4001)
,p_name=>'edit Page Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(200213907900661288.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Editar Comentario de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.::F4000_P4310_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4001'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'f?p=4000:4310:&SESSION.::::F4000_P4310_ID:&FB_FLOW_ID.'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(138317724706866221.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Editar Tema &P4003_THEME.'
,p_list_item_link_target=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.::P267_ID:&P4003_THEME_ID.:'
,p_list_item_disp_cond_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_list_item_disp_condition=>'P4003_THEME'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(59111509360577354.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Sustituya las plantillas de esta aplicaci\00F3n por las plantillas de otra aplicaci\00F3n.')
,p_list_item_link_target=>'f?p=&APP_ID.:220:&SESSION.::&DEBUG.:220,222:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4003'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(93046821589098546.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Ver Listas de Valores con Nombre'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID = 4311 and',
':P4311_NAMED_LOV is not null'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(31490816073500952.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Agregar Selector de Filas'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_ADD_CHECK'');'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    has_row_selector boolean := false;',
'begin',
'    for c1 in (',
'        select 1 from ',
'    	wwv_flow_region_report_column',
'    	where region_id = :P420_REGION_ID',
'    	and column_alias like ''CHECK$%''',
'    ) loop',
'        has_row_selector := true;',
'    end loop;	',
'    return not has_row_selector',
'           and :FLOW_PAGE_ID     = 420',
'           and :P420_REGION_TYPE = wwv_flow_region_native.c_tabform;',
'end;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(36704211967171442.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Agregar Enlace de Columna'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_ADD_LINK'');'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':FLOW_PAGE_ID=420'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(36802112434805591.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Agregar Columna Derivada'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_ADD_COLUMN'');'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':FLOW_PAGE_ID=420'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(205489829874815043.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Informes de Temas'
,p_list_item_link_target=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4003'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(98663518101847762.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Cabeceras de Columna de Informe'
,p_list_item_link_target=>'f?p=&APP_ID.:217:&SESSION.::&DEBUG.:RP,217:P217_PAGE:&FB_FLOW_PAGE_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'422'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(90724807717089029.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Sustituir Plantillas'
,p_list_item_link_target=>'f?p=&APP_ID.:708:&SESSION.::&DEBUG.:708,711,713:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4003'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(95667030632845330.4001)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>unistr('Anular Suscripci\00F3n de Plantillas')
,p_list_item_link_target=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:540:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'4311'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/button_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(97266605334780088.4001)
,p_name=>'Button.Tasks'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_region
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(99487325551482211.4001)
,p_name=>'Wizard Create Region'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(99491916062486630.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de Visualizaci\00F3n')
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'474'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4016,91,2002,2003,799,313'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(99492810454489250.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Origen'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id = case',
'                   when :F4000_P4016_SOURCE_TYPE like ''NATIVE_%'' then 4411',
'                   else to_number(:FB_FLOW_ID)',
'                 end',
'   and plugin_type = ''REGION TYPE''',
'   and name        = substr(:F4000_P4016_SOURCE_TYPE, 8)',
'   and instr('':''||standard_attributes||'':'', '':SOURCE'') > 0',
'union all',
'select 1',
'  from dual',
' where substr(:F4000_P4016_SOURCE_TYPE, 1, 7) not in (''NATIVE_'', ''PLUGIN_'',''JSTREE'')',
'   and substr(:P4016_SOURCE_TYPE,1,7) not in (''JSTREE'')',
'   and :APP_PAGE_ID <> 7000'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4017,407,683'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(99494305710491468.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Visualizaci\00F3n Condicional')
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'474'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4018:692'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_button
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(99644130313723164.4001)
,p_name=>'Wizard Create Button'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_item
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(99795626246952886.4001)
,p_name=>'Wizard Create Item'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(99797121286955232.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Nombre y Posici\00F3n de Visualizaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4717,690'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(99797817188957126.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Atributos de Elemento'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id = case',
'                   when :F4000_P4717_DISPLAY_AS like ''NATIVE_%'' then 4411',
'                   else to_number(:FB_FLOW_ID)',
'                 end',
'   and plugin_type = ''ITEM TYPE''',
'   and name        = substr(:F4000_P4717_DISPLAY_AS, 8)',
'   and instr('':''||standard_attributes||'':'', '':VISIBLE:'') > 0'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4721'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(99798513522958795.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'690'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4718,691'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_computation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(100146402180654207.4001)
,p_name=>'Wizard Create Computation'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_validation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(100288425710144762.4001)
,p_name=>'Wizard Create Validation'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_branches
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(100367812684257161.4001)
,p_name=>'Wizard Create Branches'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_process
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(100583211191032690.4001)
,p_name=>'Wizard Create Process'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_parent_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(100804924518345585.4001)
,p_name=>'Wizard Create Parent Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(100806819126348134.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Separador Principal'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4725'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(100810614813350139.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Destino'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4726'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(100812510716351983.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Secuencia y Visualizaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4727'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_standard_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(100922117111440207.4001)
,p_name=>'Wizard Create Standard Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(101132401201918650.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Juego de Separadores Nuevo o Existente'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'90'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(101135523617923462.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Juego de Separadores'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'93:94'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(101900810245789723.4001)
,p_list_item_display_sequence=>16
,p_list_item_link_text=>'Separador Principal'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'95'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(101901507441790975.4001)
,p_list_item_display_sequence=>17
,p_list_item_link_text=>'Nombre de Separador'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'96'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(100923610426443280.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('P\00E1gina Actual')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4722'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(100924705466445586.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Secuencia e Im\00E1genes')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4723'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(100925402231447156.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Condiciones de Visualizaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4724'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(101374521774334568.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'92'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_asynchronous_actions_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(103622378763412957.4001)
,p_name=>'shared.components.asynchronous_actions.navigation'
,p_list_status=>'PUBLIC'
,p_required_patch=>wwv_flow_api.id(103621306777465158.4001)
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103622584173412956.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Acciones as\00EDncronas')
,p_list_item_link_target=>'f?p=&APP_ID.:7000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103622949684412955.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Detalles de acci\00F3n as\00EDncrona')
,p_list_item_link_target=>'f?p=&APP_ID.:7005:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103623310655412955.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Log de Ejecuci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:7009:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103623751064412955.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:7010:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(103870209211856610.4001)
,p_name=>'Wizard Create Navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(196983008322003866.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,497,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'22'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(196902902998292741.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tipo'
,p_list_item_link_target=>'f?p=&APP_ID.:392:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,497,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'392'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103874127098863515.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Atributos'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4023'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103875221491866142.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Destino'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4024'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(103876314806869217.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Condici\00F3n de Visualizaci\00F3n')
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4025'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(196965009680777178.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:497:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'497'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'497'
);
end;
/
prompt --application/shared_components/navigation/lists/create_theme_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(106473613360356705.4001)
,p_name=>'create.theme.progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106476128944361283.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'207'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(274111320953713585.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Interfaz de Usuario'
,p_list_item_link_target=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106477412106365802.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identificar Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:208:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'208,267'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106508026960460990.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:210:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1207,207,208,210'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'210'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_theme
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(106491204103410821.4001)
,p_name=>'copy.theme'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106491709991412525.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copiar Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'401'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106495009083421774.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:410:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'410'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_region_template
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(106501409747300331.4001)
,p_name=>'Wizard - Create Region Template'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17580228667075703.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tipo de Plantilla'
,p_list_item_link_target=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'162'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106505327419307356.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'901:920:931:941:951:238:211:348'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106947820318367086.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Nombre'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'902:924:935:945:955:240:225:652:349:350'
);
end;
/
prompt --application/shared_components/navigation/lists/theme_change_identification_number
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(106512001249472508.4001)
,p_name=>'theme.change.identification.number'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106514712808485302.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('N\00FAmero de Tema')
,p_list_item_link_target=>'f?p=&APP_ID.:397:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'397'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106515019042487151.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'400'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_asynchronous_action_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(106873536031910266.4001)
,p_name=>'copy asynchronous action train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106873705662910265.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:7002:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(103621306777465158.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7002'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106874144154910264.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Identificar acci\00F3n as\00EDncrona')
,p_list_item_link_target=>'f?p=&APP_ID.:7003:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_api.id(103621306777465158.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7003,7004'
);
end;
/
prompt --application/shared_components/navigation/lists/p7005_asynchronous_action_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(106944141274550933.4001)
,p_name=>'P7005 asynchronous action utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106944732788550932.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Copiar acci\00F3n as\00EDncrona')
,p_list_item_link_target=>'f?p=&APP_ID.:7002:&SESSION.::&DEBUG.:7002,7003,7004:P7003_ID:&P7005_ACTION_TRIGGER_ID.:'
,p_required_patch=>wwv_flow_api.id(103621306777465158.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(106946388576550930.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Cambiar secuencia de acciones'
,p_list_item_link_target=>'f?p=&APP_ID.:7008:&SESSION.::&DEBUG.::P7008_ACTION_TRIGGER_ID:&P7005_ACTION_TRIGGER_ID.:'
,p_required_patch=>wwv_flow_api.id(103621306777465158.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7008'
);
end;
/
prompt --application/shared_components/navigation/lists/sssc
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(107370720292626153.4001)
,p_name=>'sssc'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(107372308995632305.4001)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>unistr('P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:512:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/page_64.gif'
,p_list_item_icon_attributes=>'height="64" width="64" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(107373730120638467.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Elemento de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:513:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/edit_64.gif'
,p_list_item_icon_attributes=>'height="64" width="64" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(107789910275250763.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Elemento de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:518:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/prod_apex_64.gif'
,p_list_item_icon_attributes=>'height="64" width="64" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sss_standard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(109521305294221172.4001)
,p_name=>'sss.standard'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109521827242236960.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('Protecci\00F3n de estado de la sesi\00F3n desactivada.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(110690209142337959.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>unistr('Las p\00E1ginas de la aplicaci\00F3n no necesitar\00E1n totales de control.')
,p_list_item_link_target=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109522205902240205.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Los elementos de la aplicaci\00F3n se pueden definir mediante argumentos transferidos en una direcci\00F3n URL (con excepci\00F3n de los elementos restringidos).')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(110689114205329908.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Los elementos de la p\00E1gina se pueden definir mediante argumentos definidos en una direcci\00F3n URL (con excepci\00F3n de los elementos restringidos).')
,p_list_item_link_target=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(110694132391373080.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('El atributo <i>Escape en Entrada HTTP</i> de los elementos de la p\00E1gina se seguir\00E1 teniendo en cuenta.')
,p_list_item_link_target=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sss_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(109642120442735590.4001)
,p_name=>'sss.progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109642530139738374.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Seleccionar Acci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'525'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114177918693680391.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Atributos de P\00E1gina y de Elemento')
,p_list_item_link_target=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9006'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109642810530742159.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9007,9008'
);
end;
/
prompt --application/shared_components/navigation/lists/authenitcation_create
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(109993128340686080.4001)
,p_name=>'authenitcation.create'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109993532150687193.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'815'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(109993802845688109.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Esquema'
,p_list_item_link_target=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'816,818'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_template
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(110615031296644849.4001)
,p_name=>'Copy Template'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(110663804762646615.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Copiar Plantilla de Otra Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/view_templates_task
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(111435127334933550.4001)
,p_name=>'View Templates Task'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111437316383939828.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Ver Plantillas'
,p_list_item_link_target=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:4003,RIR:IR_THEME,P4003_THEME:&FB_THEME_ID.,&FB_THEME_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1218253654992416500.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Suprimir Tema'
,p_list_item_link_target=>'f?p=&FLOW_ID.:221:&SESSION.::&DEBUG.:221::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_breadcrumb_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(111619820846587947.4001)
,p_name=>'shared.components.breadcrumb.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111620411281594656.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('Rutas de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'546'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183475506631296658.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(14900821723122972.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Crear Nuevo Principal de Entradas'
,p_list_item_link_target=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111620004355592595.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:365:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'365'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(111620206086593181.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:369:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'369'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_sqlquery_on_ws_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(114018423833281484.4001)
,p_name=>'wizard_sqlquery_on_ws_page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(206858322178171502.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina y de Regi\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'776'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(206858932567174539.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523950895298145683.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114018618816281486.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tipo de Referencia Web'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'778'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114018928354281487.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Informaci\00F3n de Referencia Web')
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'779:781:859'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114019202992281488.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Par\00E1metros y Opciones')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'782:783:860'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114162210486514180.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_for_pages=>'786'
);
end;
/
prompt --application/shared_components/navigation/lists/sss_extended
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(114371329791585494.4001)
,p_name=>'sss.extended'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114418321983210267.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1ginas: &P9007_PAGE_LEVEL.')
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114418726485211591.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Elementos de Aplicaci\00F3n: &P9007_APP_ITEM_LEVEL.')
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114420921767219662.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Elementos de Entrada de Datos: &P9007_DATA_ENTRY_ITEM_LEVEL.'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114421526616221094.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Elementos de S\00F3lo Visualizaci\00F3n: &P9007_DISPLAY_ONLY_ITEM_LEVEL.')
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114422831464222441.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Protecci\00F3n de Scripts de Sitios de Elemento de P\00E1gina: &P9007_PAGE_ITEM_ESCAPE.')
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_theme_progress
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(114829600122838504.4001)
,p_name=>'workspace theme progress'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114830714320842637.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identificar Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'754'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'764'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114831221593844797.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Identificar Nombre'
,p_list_item_link_target=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'754'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'789'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(114831926787846213.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:762:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'754'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'762'
);
end;
/
prompt --application/shared_components/navigation/lists/dependencies_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(117039522797176386.4001)
,p_name=>'Dependencies Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(117040128338177988.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Generar DDL'
,p_list_item_link_target=>'f?p=&APP_ID.:637:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_app_from_spreasheet_opt
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(118042377093675208.4001)
,p_name=>'create.app.from.spreasheet.opt'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(118042502492675209.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Cargar archivo'
,p_list_item_link_target=>'f?p=4500:3100:&SESSION.:::3100,3110,3120:P3100_SOURCE_TYPE:FILE'
,p_list_item_icon=>'a-Icon icon-region- icon-file-upload'
,p_list_text_01=>'Upload CSV, XLSX, XML, JSON data'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(118042942497675210.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar y Pegar'
,p_list_item_link_target=>'f?p=4500:3100:&SESSION.:::3100,3110,3120:P3100_SOURCE_TYPE:COPY_PASTE'
,p_list_item_icon=>'a-Icon icon-region- icon-clipboard'
,p_list_text_01=>'Copy and paste CSV data'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/comments
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(123545913988020430.4001)
,p_name=>'comments'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(123546321607022623.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crear Comentario'
,p_list_item_link_target=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1234'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(123546700960026141.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ver Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1235'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(123547007539028056.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Editar Comentario'
,p_list_item_link_target=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1236'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1236'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(125612105656334840.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Suprimir Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1237,1238'
);
end;
/
prompt --application/shared_components/navigation/lists/create_application_image_nav
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(128724959151960807.4001)
,p_name=>'Create Application - Image Nav'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(128725983083960807.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Nueva Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250:::'
,p_list_item_icon=>'gi-icon-app-builder'
,p_list_text_01=>unistr('Agregue p\00E1ginas a datos existentes, seleccione funciones de aplicaci\00F3n, defina el tema y configure otras opciones.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(128728137528960809.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Desde un archivo'
,p_list_item_link_target=>'f?p=4500:3100:&SESSION.:::3100,3110,3120,APEX$DATALOAD_COLUMNS:P3100_SOURCE_TYPE:FILE'
,p_list_item_icon=>'gi-icon-create-app-websheet'
,p_list_text_01=>unistr('Cargue un archivo CSV, XLSX, XML o JSON, o copie y pegue datos y, a continuaci\00F3n, cree la aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(128728733474960809.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Aplicaci\00F3n inicial')
,p_list_item_link_target=>'f?p=4750:50:&SESSION.::&DEBUG.:50:::'
,p_list_item_icon=>'gi-icon-create-app-pkg-apps'
,p_list_text_01=>unistr('Instale una de las muchas aplicaciones iniciales y de ejemplo de la galer\00EDa.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_application_step_1
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(139866417493663090.4001)
,p_name=>'create application step 1'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(139870325374684265.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'56'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(139870631607686094.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Seleccionar Aplicaci\00F3n')
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'84,3009'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'887'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23857907389713612.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Identificar Destino de Copia'
,p_list_item_link_target=>'f?p=&APP_ID.:3009:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'3009,84'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(139871004034687499.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'130,84'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_createwizard
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(147241516822234215.4001)
,p_name=>'Wizard_CreateWizard'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(147245007333238659.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('P\00E1ginas')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'107'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(149094527075064841.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523941800717896380.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(147245704529239920.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'108'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_createtree
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(147901626307825228.4001)
,p_name=>'Wizard_CreateTree'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(147904320916827688.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'112'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(157593326518482453.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523941400867890059.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(156039022711192668.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Propietario y Nombre de Tabla/Vista'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'114'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(156305124810057724.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Consulta'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'116'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(157687416449669471.4001)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'Where y Order by'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'126'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(12341809367052610.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Atributos de \00C1rbol')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'68'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7244112889498460.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Confirmar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'284'
);
end;
/
prompt --application/shared_components/navigation/lists/confirm_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(148407226188594759.4001)
,p_name=>'confirm.page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(148409915022610438.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>unistr('Ejecutar P\00E1gina')
,p_list_item_link_target=>'f?p=&FB_FLOW_ID.:&F4000_RUN_EDIT_PAGE.:&SESSION.'
,p_list_item_icon=>'htmldb/builder/run_flow.gif'
,p_list_item_icon_attributes=>'width="100" height="75" alt="&F4000_RUN."'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(148417611521656692.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Editar P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.:'
,p_list_item_icon=>'htmldb/builder/edit_page.gif'
,p_list_item_icon_attributes=>'width="100" height="75" alt="&EDIT."'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p4651_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(153106004753776646.4001)
,p_name=>'p4651_tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153106418259780522.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Deshacer Origen de Regi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.::P88_TABLE,P88_COLUMN,P88_ID,P88_CALLING_FIELD,P88_FLOW:WWV_FLOW_PAGE_PLUGS,PLUG_SOURCE,&F4000_P4651_ID.,F4000_P4651_PLUG_SOURCE,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(22605518586883916.4001)
,p_list_item_display_sequence=>46
,p_list_item_link_text=>unistr('Actualizar a Gr\00E1fico HTML5')
,p_list_item_link_target=>'f?p=&APP_ID.:280:&SESSION.::&DEBUG.::P280_REGION_ID:&F4000_P4651_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':F4000_P4651_PLUG_SOURCE_TYPE = wwv_flow_region_native.c_legacy_simple_chart'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p4307_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(153171308852373878.4001)
,p_name=>'P4307_TASKS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153178223312397008.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Buscar Elementos'
,p_list_item_link_target=>'javascript:popUp(''f?p=4000:273:&SESSION.::::F4000_P273_PAGE:&FB_FLOW_PAGE_ID.'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153174705173382332.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Deshacer Plantilla de Cabecera'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.:88:P88_TABLE,P88_COLUMN,P88_ID,P88_CALLING_FIELD,P88_FLOW:WWV_FLOW_TEMPLATES,HEADER_TEMPLATE,&F4000_P4307_ID.,F4000_P4307_HEADER_TEMPLATE,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153175014524385009.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Deshacer Plantilla de Cuerpo'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.:88:P88_TABLE,P88_COLUMN,P88_ID,P88_CALLING_FIELD,P88_FLOW:WWV_FLOW_TEMPLATES,BOX,&F4000_P4307_ID.,F4000_P4307_BOX,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153175723181387558.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Deshacer Plantilla de Pie de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.::P88_TABLE,P88_COLUMN,P88_ID,P88_CALLING_FIELD,P88_FLOW:WWV_FLOW_TEMPLATES,FOOTER_TEMPLATE,&F4000_P4307_ID.,F4000_P4307_FOOTER_TEMPLATE,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p4653_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(153210815104527139.4001)
,p_name=>'P4653_TASKS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153212128263530955.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Buscar Elementos'
,p_list_item_link_target=>'javascript:popUp(''f?p=4000:273:&SESSION.::::F4000_P273_PAGE:&FB_FLOW_PAGE_ID.'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(153214009001534772.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Deshacer Origen de Plantilla'
,p_list_item_link_target=>'f?p=&APP_ID.:88:&SESSION.::&DEBUG.:88:P88_TABLE,P88_COLUMN,P88_ID,P88_CALLING_FIELD,P88_FLOW:WWV_FLOW_PAGE_PLUG_TEMPLATES,TEMPLATE,&F4000_P4653_ID.,F4000_P4653_TEMPLATE,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_remote_servers_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(154051976265844427.4001)
,p_name=>'shared.components.remote_servers.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154052121551844430.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'SQL activado para REST'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1600'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154052580732844434.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1602'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154052913913844434.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1603'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_credential_stores_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(154583731613661573.4001)
,p_name=>'shared.components.credential_stores.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154583988141661575.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Credenciales web'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:1620:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1620'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154584303580661578.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:1622:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1622'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154584705715661578.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:1623:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1623'
);
end;
/
prompt --application/shared_components/navigation/lists/export_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(158038003748775992.4001)
,p_name=>'Export Page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(158038407557777097.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Exportar P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(25720216186980294.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Gestionar Objetos de Soporte'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(200682401972525159.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Exportaci\00F3n de Componente')
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'FB_FLOW_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168868615219020507.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Gestionar Repositorio de Exportaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_lov
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(161740513874429436.4001)
,p_name=>'Wizard Create LOV'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202904909845918905.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Origen'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'137'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(161742306326432962.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nombre y Tipo'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4004'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11540348458195148.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen de lista de valores'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4080'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(161745627233438452.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Valores Est\00E1ticos')
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'F4000_P4004_TYPE'
,p_list_item_disp_condition2=>'STATIC'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4014'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11542493794381119.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Asignaciones de Columnas'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'F4000_P4004_TYPE'
,p_list_item_disp_condition2=>'DYNAMIC'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4081'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_attributes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(162360828277873558.4001)
,p_name=>'Cross Application Reports / Attributes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162361613863878819.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:9010:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-application-attributes'
,p_list_text_01=>unistr('Ver recuentos de componentes de cada aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(205251931899374098.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Estado de Creaci\00F3n y Estado de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-app-status'
,p_list_text_01=>unistr('Revisar los estados de cada aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162362223560881642.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:9012:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-build-options'
,p_list_text_01=>unistr('Ver opciones de creaci\00F3n en todas las aplicaciones.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(131390824277396235.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-comments'
,p_list_text_01=>'Revisar comentarios de todas las aplicaciones.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(217724513488899294.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Calendario de Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:665:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-comments-calendar'
,p_list_text_01=>unistr('Ver fecha de creaci\00F3n de los comentarios.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/translation_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(165621520543370755.4001)
,p_name=>'translation.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(171880500668996222.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Mensajes de Texto'
,p_list_item_link_target=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-create-manage-text'
,p_list_text_01=>'Crear y gestionar mensajes de texto.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165622300589374384.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Traducciones Din\00E1micas')
,p_list_item_link_target=>'f?p=&APP_ID.:4756:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-manage-dynamic-translation'
,p_list_text_01=>unistr('Gestionar el repositorio de traducci\00F3n din\00E1mica.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(28665818452018310.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Repositorio de Traducci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-manually-edit-translation'
,p_list_text_01=>unistr('Edite manualmente el texto traducido en el repositorio de traducci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/parent_tab_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(165863110284077420.4001)
,p_name=>'parent.tab.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165865017557079566.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Cambiar Nombre de Juego de Separadores Principales'
,p_list_item_link_target=>'f?p=&FLOW_ID.:332:&SESSION.::&DEBUG.:332::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165865522059080812.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Cambiar Secuencia de Orden de Visualizaci\00F3n')
,p_list_item_link_target=>'f?p=&FLOW_ID.:331:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165867932102083690.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Crear Nuevo Separador Principal'
,p_list_item_link_target=>'f?p=&FLOW_ID.:4725:&SESSION.::&DEBUG.:4725,4726,4727::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/standard_tab_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(165876716780098264.4001)
,p_name=>'standard.tab.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165879130286102126.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Gestionar Separadores Est\00E1ndar')
,p_list_item_link_target=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.::F4000_P9000_PAGE:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/parent_tab_tasks_p9000
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(165884427300110704.4001)
,p_name=>'parent_tab_tasks_p9000'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165885332495112173.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Gestionar Separadores Principales'
,p_list_item_link_target=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/tasks_page_4714
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(165935217145249689.4001)
,p_name=>'tasks_page_4714'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165938632036253973.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Crear P\00E1gina de Conexi\00F3n')
,p_list_item_link_target=>'f?p=4000:500:&SESSION.::NO'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/how_to_translate
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(165943028704262550.4001)
,p_name=>'how_to_translate'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165944104940265156.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Definir Idiomas de la Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4751:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-map-primary-language'
,p_list_text_01=>unistr('Asignar la aplicaci\00F3n del idioma primario a aplicaciones traducidas.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165945811520267011.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Extraer Texto Traducible'
,p_list_item_link_target=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.::P385_ACTION:SEED:'
,p_list_item_icon=>'icon-util-seed-translatable-text'
,p_list_text_01=>unistr('Copiar el texto traducible de la aplicaci\00F3n primaria al repositorio de traducci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162434002630201887.4001)
,p_list_item_display_sequence=>24
,p_list_item_link_text=>unistr('Descargar archivos de traducci\00F3n XLIFF')
,p_list_item_link_target=>'f?p=&APP_ID.:4750:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-download-xlif-translation'
,p_list_text_01=>unistr('Descargue archivos con texto traducible del repositorio de traducci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165947319138269194.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Traducir Texto'
,p_list_item_link_target=>'f?p=&APP_ID.:306:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-translate-text'
,p_list_text_01=>unistr('Enviar archivos XLIFF para la traducci\00F3n o editar manualmente el repositorio de traducci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(165949127796271740.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Aplicar Archivos de Traducci\00F3n XLIFF')
,p_list_item_link_target=>'f?p=&APP_ID.:4758:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-upload-apply-xliff'
,p_list_text_01=>unistr('Cargar archivos XLIFF con texto traducido y aplicar traducciones al repositorio de traducci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(162434303453211574.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Publicar aplicaciones traducidas'
,p_list_item_link_target=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.::P385_ACTION:PUBLISH:'
,p_list_item_icon=>'icon-util-publish-translated-applications'
,p_list_text_01=>unistr('Haga que las aplicaciones traducidas est\00E9n disponibles para los usuarios.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_nav_bar_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(166766500720858594.4001)
,p_name=>'shared.components.nav_bar.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(166769319685865035.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Entradas de Barra de Navegaci\00F3n Cl\00E1sicas')
,p_list_item_link_target=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4005'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(166770609981869522.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_list_item_link_target=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_icon_bar where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'153'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201265401410394101.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Suscripci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_icon_bar where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'54'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10056426696402671.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:394:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_icon_bar where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'394'
);
end;
/
prompt --application/shared_components/navigation/lists/replace_templates_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(168734227577365586.4001)
,p_name=>'replace templates train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168734406930369089.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Tipo de Plantilla'
,p_list_item_link_target=>'f?p=&APP_ID.:708:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'708'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168734718358372471.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identificar Plantillas'
,p_list_item_link_target=>'f?p=&APP_ID.:711:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'711'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(168734923899374008.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:713:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'713'
);
end;
/
prompt --application/shared_components/navigation/lists/create_list_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(169186610834587350.4001)
,p_name=>'create list train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10678101114291405.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Origen'
,p_list_item_link_target=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'105'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(169186923301591019.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Nombre y Tipo'
,p_list_item_link_target=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'427'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(169189328373658702.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Valores Est\00E1ticos o de Consulta')
,p_list_item_link_target=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'440,464'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(169192814961711597.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:529:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'529,734'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(171723423034567648.4001)
,p_name=>'page.region.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6821101659113491.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todos los T\00EDtulos de Regi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:438:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193870804947518508.4001)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>unistr('Atributos de Regi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(171780931017721336.4001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Regiones de PL/SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:480:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11339330772242551.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Regiones Personalizadas'
,p_list_item_link_target=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47911925376585041.4001)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Regiones Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:864:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_button_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(171743703949609405.4001)
,p_name=>'page.button.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(240733721440954144.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todas las Etiquetas de Botones')
,p_list_item_link_target=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193784520531105981.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Botones por P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194556907147613285.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Botones Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:878:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_item_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(171752432131627079.4001)
,p_name=>'page.item.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(233014630647109050.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todas las Etiquetas de Elemento')
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(233013122336106602.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todo el Texto de Ayuda de Elementos')
,p_list_item_link_target=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(251134632073178851.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Suscripciones de Ayuda de Elemento'
,p_list_item_link_target=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.:RIR:IR_FLOW_STEP_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193917900275255057.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Todos los Elementos de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:547:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15591500615424210.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Elementos de Contrase\00F1a')
,p_list_item_link_target=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194531425614476695.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Elementos Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:869:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_validation_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(171763620666671065.4001)
,p_name=>'page.validation.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(240772729414032103.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todos los Mensajes de Error de Validaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:214:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(242557604450198238.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Validaciones por P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194198200000377701.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Validaciones Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:883:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_computation_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(171769406383685886.4001)
,p_name=>'page.computation.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(240790724743068620.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todos los Mensajes de Error de C\00E1lculo')
,p_list_item_link_target=>'f?p=&APP_ID.:215:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(224269225570329050.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('C\00E1lculos por P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194540617827512267.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('C\00E1lculos Condicionales')
,p_list_item_link_target=>'f?p=&APP_ID.:877:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_process_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(171773504090694644.4001)
,p_name=>'page.process.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(240759729367003715.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todos los Mensajes de Proceso')
,p_list_item_link_target=>'f?p=&APP_ID.:213:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(225375711989419725.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Procesos por P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:552:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194248225420820252.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Procesos Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:866:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(177830919883437702.4001)
,p_name=>'Application Utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(177833406770462269.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Panel de Control de Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-app-dashboard'
,p_list_text_01=>unistr('Revisar un resumen de esta aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1885595358268728653.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Asesor'
,p_list_item_link_target=>'javascript:apex.navigation.popup({ url: ''f?p=&APP_ID.:8101:&SESSION.::&DEBUG.:8101'', width: 1000, height: 800 }); void(0);'
,p_list_item_icon=>'icon-util-advisor'
,p_list_text_01=>unistr('Realizar varias comprobaciones en la aplicaci\00F3n, incluidos los errores de programaci\00F3n y mejores pr\00E1cticas.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1661255424982169004.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Actualizar Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-upgrade-app'
,p_list_text_01=>unistr('Despu\00E9s de la actualizaci\00F3n a una nueva versi\00F3n, revisar componentes para actualizar e incluir las \00FAltimas funciones.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(466865607820087113.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('P\00E1ginas Actualizadas Recientemente')
,p_list_item_link_target=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:RIR:IR_UPDATED_BY:&APP_USER.:'
,p_list_item_icon=>'icon-util-recent-pages'
,p_list_text_01=>unistr('Ver historial de actualizaciones de p\00E1gina realizadas en esta aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1160235601024416138.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Diccionario de Atributos'
,p_list_item_link_target=>'f?p=&APP_ID.:889:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-attribute-dictionary'
,p_list_text_01=>unistr('Gestionar valores por defecto de elemento/columna de interfaz de usuario para una p\00E1gina seleccionada.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(177831203693437706.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Historial de Cambios'
,p_list_item_link_target=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-change-history'
,p_list_text_01=>unistr('Ver informe detallado de las actualizaciones de componentes realizadas en esta aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1160225427040278954.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Dependencias de Objetos de Base de Datos'
,p_list_item_link_target=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-object-dependencies'
,p_list_text_01=>unistr('Revisar objetos de base de datos a los que hace referencia esta aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492241124877437516.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>unistr('Mensajes de Depuraci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-debug-messages'
,p_list_text_01=>unistr('Revisar mensajes de depuraci\00F3n generados por esta aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1173931504465813227.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Vistas de &PRODUCT_NAME.'
,p_list_item_link_target=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-apex-views'
,p_list_text_01=>'Consultar las diferentes vistas de los metadatos de &PRODUCT_NAME.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492240609162423534.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Repositorio de Exportaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-export-repository'
,p_list_text_01=>unistr('Ver historial de exportaciones de la aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(70885805484327683.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Gestionar copias de seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:971:::'
,p_list_item_icon=>'icon-apex-backup'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_backup.backup_limit() > 0'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>unistr('Revisar historial de copias de seguridad, realizar una copia de seguridad manual o una restauraci\00F3n a partir de una copia de seguridad')
,p_list_text_02=>'P971_APPLICATION_ID:100'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1205104966610419.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>unistr('C\00F3digo embebido')
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RP,101:::'
,p_list_item_icon=>'icon-util-embedded-code'
,p_list_text_01=>unistr('C\00F3digo de revisi\00F3n como SQL, PL/SQL, JavaScript, etc.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(569740971924292915.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>unistr('Total de control de la aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.:109:P109_COMPONENT:APPLICATION:'
,p_list_item_icon=>'icon-check-circle'
,p_list_text_01=>unistr('El total de control de la aplicaci\00F3n ofrece un m\00E9todo sencillo para saber si la misma aplicaci\00F3n est\00E1 desplegada en distintos espacios de trabajo.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(576931365336902572.4001)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Iconos de fuente APEX'
,p_list_item_link_target=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110:::'
,p_list_item_icon=>'icon-util-font-apex'
,p_list_text_01=>'Find Font APEX icons and HTML Markup'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(597489289435573267.4001)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>unistr('Totales de control de p\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:RP,111:P109_COMPONENT:APPLICATION:'
,p_list_item_icon=>'icon-check-circle'
,p_list_text_01=>unistr('El informe de total de control de p\00E1gina ofrece un m\00E9todo sencillo para comparar los despliegues de dos aplicaciones y comprobar qu\00E9 p\00E1ginas son iguales y cu\00E1les diferentes')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_item
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(179572716597169307.4001)
,p_name=>'Wizard Copy Item'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(197073903769725734.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Nueva P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'171'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(179579323055181481.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nuevo Elemento'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'172'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_authentication_scheme_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(180433926348108856.4001)
,p_name=>'shared.components.authentication_scheme.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180435618514116022.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Esquemas de Autenticaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'801'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180437106178121918.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Suscripci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:817:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'817'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192776728065739452.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:554:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'554'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_authorization_scheme_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(180462022520306486.4001)
,p_name=>'shared.components.authorization_scheme.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180462914339313581.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Esquemas de Autorizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4070'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180463224729316523.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Suscripci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'129'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47955811298564811.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'por Componente'
,p_list_item_link_target=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'340'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180463832347318756.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:4045:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4045'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(192784124265814091.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:558:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'558'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_button
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(181185105878280365.4001)
,p_name=>'Wizard Copy Button'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(15213429898992140.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Nueva P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'231'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181188725059286630.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Nuevo Bot\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'191'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_dynamic_action
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(181501623296103719.4001)
,p_name=>'copy.dynamic_action'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181503411306109716.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Acci\00F3n Din\00E1mica que Copiar')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'728'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181503816154111137.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('En P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'796'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181504222388112936.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Nueva Acci\00F3n Din\00E1mica')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'797'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_map
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(183700922666750405.4001)
,p_name=>'Wizard Map'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183701218164750406.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Mapa'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'798'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183701622501750407.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Origen de Mapa'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'894'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183702018273750407.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'895'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183702427699750407.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID, ',
'                   p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523939647506761828.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183703223516750408.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Atributos de Mapa'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'900'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(183703610515750408.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Consulta'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'833'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_map_region
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(185155905837041142.4001)
,p_name=>'Wizard Create Map Region'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185157403628041147.4001)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Origen de Mapa'
,p_list_item_link_target=>'f?p=&APP_ID.:840:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P181_REGION_TYPE = ''Map'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'840'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185157801641041147.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de Visualizaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4016,91,2002,2003,799,313'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185159024483041149.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Consulta'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4017,407,683,537'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185159826358041149.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Visualizaci\00F3n Condicional')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4018:692'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_shortcut
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(185305822581982553.4001)
,p_name=>'Wizard Create Shortcut'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185307615464985837.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185308412229987392.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Atributos de M\00E9todo Abreviado')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'174'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_pull_shortcuts
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(185309707700989517.4001)
,p_name=>'Wizard Pull Shortcuts'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185313922784997656.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185314719980998966.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'132'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(185315516746000474.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Nuevos M\00E9todos Abreviados')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'133'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_shortcut_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(186543329326722942.4001)
,p_name=>'shared.components.shortcut.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186545123935725534.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todos Abreviados')
,p_list_item_link_target=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4047'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186545918543727968.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Suscripci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:175:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from WWV_FLOW_SHORTCUTS where flow_id = :FB_FLOW_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'175'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(10983506807371682.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'41'
);
end;
/
prompt --application/shared_components/navigation/lists/page_item_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(186703109122914661.4001)
,p_name=>'page.item.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186714413638927747.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Elementos'
,p_list_item_link_target=>'f?p=4000:4200:&SESSION.::NO:4200'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4200'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(40289317195455624.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Suprimir Varios Elementos'
,p_list_item_link_target=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(47958103726591074.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:854:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'854:408:6:547:59:869:389'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11258131416157207.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'62'
);
end;
/
prompt --application/shared_components/navigation/lists/page_validation_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(186826132498329280.4001)
,p_name=>'page.validation.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186832108129340579.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Validaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:4205:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4205'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(57912215798286576.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Suprimir Varias Validaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:743:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'743'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193767726569918515.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=&APP_ID.:851:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'851:214:501:883'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(11340930817563888.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'66'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_pull_security_schemes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(186904126354727159.4001)
,p_name=>'Wizard Pull Security Schemes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186905916218731926.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'184'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186906712336733691.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'185'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186907507376736030.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nombres'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'186'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_authorization_schemes
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(186911322244744240.4001)
,p_name=>'Wizard Create Authorization Schemes'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186913114912747650.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'184'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(186914408226750829.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Detalles'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'188'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_plug_in_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(188993730020080349.4001)
,p_name=>'shared.components.plug-in.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(188994312836084773.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Plugins'
,p_list_item_link_target=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4400'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(188994619762086758.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4420'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193358210391475853.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'841'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_report_query_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(193369209650497455.4001)
,p_name=>'shared.components.report_query.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193369600778504265.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Consultas de Informe'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1100'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193369910128507049.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'843'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_report_layout_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(193374517232546937.4001)
,p_name=>'shared.components.report_layout.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193374801581546942.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Dise\00F1os de Informe')
,p_list_item_link_target=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1400'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193375221285546942.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:844:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'844'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_navbar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(193684503309130516.4001)
,p_name=>'Wizard Copy NavBar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193686328960133836.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'22'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193687125078135642.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'134'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193688421627137255.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nuevos Nombres'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'135'
);
end;
/
prompt --application/shared_components/navigation/lists/page_dynamic_action_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(194153003566161205.4001)
,p_name=>'page.dynamic_action.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194154929885168734.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Todas las Acciones Din\00E1micas')
,p_list_item_link_target=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_utilities_region_counts
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(194250609883844198.4001)
,p_name=>'page.region.utilities.region.counts'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194252923250844202.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Recuento por Tipo de Regi\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:128:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_region.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194253310565844203.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Recuento por Punto de Visualizaci\00F3n de Plantilla de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:459:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_region.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_branch_utilities
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(194565421168929524.4001)
,p_name=>'page.branch.utilities'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194566126273929526.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Bifurcaciones por P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:563:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(194566502198929526.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ramas Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:885:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_feedback_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(197011632441427104.4001)
,p_name=>'create feedback page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(197011929178427105.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Crear P\00E1gina de Comentarios')
,p_list_item_link_target=>'f?p=&APP_ID.:849:&SESSION.::&DEBUG.:849:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'894'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_region
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(197233420990021629.4001)
,p_name=>'Wizard Copy Region'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(197241701365030751.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('En P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'194'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(197243528741033202.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Nueva Regi\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'195'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_views_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(200452609222306546.4001)
,p_name=>'APEX Views Navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(200453224460311015.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Vista de Informe'
,p_list_item_link_target=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'714'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(201268128688684688.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Vista de \00C1rbol')
,p_list_item_link_target=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'905'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(200453701734313844.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Seleccionar Columnas'
,p_list_item_link_target=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P892_VIEW_NAME is not null or',
':APP_PAGE_ID = ''892'''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'892'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(200454107275315499.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Filtro'
,p_list_item_link_target=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P892_SELECTED_COLS'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'893'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(200454411431316639.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Resultados'
,p_list_item_link_target=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P892_SELECTED_COLS'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'896'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_page_wiz_steps
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(202931703979545993.4001)
,p_name=>'copy_page_wiz_steps'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202933009304556968.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Opci\00F3n de Copia de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'618'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202934128351562472.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('P\00E1gina a Copiar')
,p_list_item_link_target=>'f?p=&APP_ID.:621:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'621'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1556125534907719472.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P621_NAVIGATION_TYPE'
,p_list_item_disp_condition2=>'L'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'671'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(204089926319940378.4001)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Separadores'
,p_list_item_link_target=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_list_item_disp_condition=>'P621_NAVIGATION_TYPE'
,p_list_item_disp_condition2=>'L'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'671'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202934605626565380.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Plantillas'
,p_list_item_link_target=>'f?p=&APP_ID.:622:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'622'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202935113937567735.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Listas de Valores'
,p_list_item_link_target=>'f?p=&APP_ID.:623:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'623'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202935522249570117.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Listas'
,p_list_item_link_target=>'f?p=&APP_ID.:625:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'625'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202935827097571532.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Esquemas de Autorizaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'627'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(208023117796803899.4001)
,p_list_item_display_sequence=>75
,p_list_item_link_text=>'Bifurcaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'593'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202936132291573046.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'628'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_pull_lov
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(202952222735973765.4001)
,p_name=>'Wizard Pull LOV'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202954017990975969.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo de Creaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'137'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202954813893977815.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de '
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'138'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202955610442979398.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nuevas Listas de Valores'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'139'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_lov_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(203029530177365353.4001)
,p_name=>'shared.components.lov.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203035015081372358.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Listas de Valores'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4110'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(184816719223361035.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Editar Texto Nulo'
,p_list_item_link_target=>'f?p=&APP_ID.:169:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'169'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(184821331999411979.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Definici\00F3n Local')
,p_list_item_link_target=>'f?p=&APP_ID.:419:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'419'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(184821605811413905.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_list_item_link_target=>'f?p=&APP_ID.:178:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'178'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(188105422784870512.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Entradas Condicionales'
,p_list_item_link_target=>'f?p=&APP_ID.:556:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'556'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(203035810552374398.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Suscripci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1  from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :FB_FLOW_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(631171523671392471.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1  from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :FB_FLOW_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'87'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(193350901986416680.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:686:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'686'
);
end;
/
prompt --application/shared_components/navigation/lists/p224_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(205602222789276628.4001)
,p_name=>'p224 tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1036212995590553756.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Gestionar Temas'
,p_list_item_link_target=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/export_component_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(207503732215648915.4001)
,p_name=>'export component tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(207504110528652105.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Componentes'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.:AC:&DEBUG.::P688_MODE:AC:'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'nvl(:P688_MODE,''AC'') = ''AC'''
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(207504421956655470.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Componentes por P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.:PD:&DEBUG.::P688_MODE:PD:'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'nvl(:P688_MODE,''PD'') = ''PD'''
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(228921921121485140.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Estado de Opci\00F3n de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::P688_MODE:BO:'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'nvl(:P688_MODE,''AC'') = ''BO'''
,p_list_item_current_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/lists/install_preview
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(210424614987781460.4001)
,p_name=>'Install Preview'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(210426801959787134.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Vista Previa de Script de Instalaci\00F3n')
,p_list_item_link_target=>'javascript:popupURL(''f?p=&APP_ID.:2109:&SESSION.::&DEBUG.::P2109_MODE:INSTALL'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/component_export_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(210787017222419064.4001)
,p_name=>'component export train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(210787424148421054.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identificar Componentes'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'688'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(210787931074423052.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Exportar Componentes'
,p_list_item_link_target=>'f?p=&APP_ID.:637:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'637'
);
end;
/
prompt --application/shared_components/navigation/lists/page_group_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(213192710092707758.4001)
,p_name=>'page.group.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(213193117365709843.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Grupos de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'520:521'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(7889418131882539.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Asignaciones de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:RP,522:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'522'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(213326924824175665.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('P\00E1ginas por Grupo de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:528:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'528'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_template
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(222829818333256486.4001)
,p_name=>'Wizard Copy Template'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(222830025179256507.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Plantilla a Copiar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'584'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(222830500690256514.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Nueva Plantilla'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'538:568:569:571:564:573:574:636'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_rest_data_source
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(226545212901831813.4001)
,p_name=>'Wizard Create REST Data Source'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226545418188831828.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'General'
,p_list_item_link_target=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226545892098831833.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Servidor remoto'
,p_list_item_link_target=>'f?p=&APP_ID.:1942:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1295970335077570.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Configuraci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226546270015831833.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Autenticaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1943:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226680867806416802.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Par\00E1metros')
,p_list_item_link_target=>'f?p=&APP_ID.:1944:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1944'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226546658284831833.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Vista Previa'
,p_list_item_link_target=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/deinstall_preview
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(227753031474767408.4001)
,p_name=>'Deinstall Preview'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(227754420869773895.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Vista Previa de Script de Desinstalaci\00F3n')
,p_list_item_link_target=>'javascript:popupURL(''f?p=&APP_ID.:2109:&SESSION.::&DEBUG.::P2109_MODE:DEINSTALL'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_process
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(227766223920945009.4001)
,p_name=>'Wizard Copy Process'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(227766422394945011.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Proceso a Copiar'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'590'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(227766714836945011.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Opciones de Proceso'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'645'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_validation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(228167614670175482.4001)
,p_name=>'Wizard Copy Validation'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_branch
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(228256415837925869.4001)
,p_name=>'Wizard Copy Branch'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(228256632661925872.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Bifurcaci\00F3n a Copiar')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'587'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(228256900182925873.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Opciones de Bifurcaci\00F3n')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'685'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_computation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(228264919955974373.4001)
,p_name=>'Wizard Copy Computation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(228266003117978994.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('C\00E1lculo a Copiar')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'592'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(228266412121981558.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Opciones de C\00E1lculo')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'597'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_list_train
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(231136205422723196.4001)
,p_name=>'copy list train'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(231137016157726205.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:658:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'658'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(231137725854729050.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identificar Lista'
,p_list_item_link_target=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'602,663'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_web_sources_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(241353531173849237.4001)
,p_name=>'shared.components.web_sources.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(241353749272849252.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Or\00EDgenes de Datos de REST')
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(564743301883397522.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Sincronizaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:1955:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(241354167823849253.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:1902:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(247801890036355717.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:1903:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/remoteserver_create
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(249337602894822823.4001)
,p_name=>'remoteserver.create'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/remoteserver_createnew
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(249355742923907578.4001)
,p_name=>'remoteserver.createnew'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(249355942729907578.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'General'
,p_list_item_link_target=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(249356348643907578.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>unistr('Autenticaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1616:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/websrcmodule_create
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(249385562937130742.4001)
,p_name=>'websrcmodule.create'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(249385724604130742.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(249386134393130742.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar de'
,p_list_item_link_target=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'COPY'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4600351737385437.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Crear desde cat\00E1logo')
,p_list_item_link_target=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1908'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1903006796784570.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Seleccionar Servicios'
,p_list_item_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1911'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1904581007791181.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Resumen'
,p_list_item_link_target=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1910'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(249386558688130742.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Copiar'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_attributes_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(274897624522614662.4001)
,p_name=>'application attributes tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(274898302490617757.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Definici\00F3n')
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_DEFN'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4001'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(274905604268646630.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Seguridad'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_SEC'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'509'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(33757928911956810.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Globalizaci\00F3n')
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_GLOBAL'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'506'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(42233410928343483.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Interfaz de Usuario'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_USERINTERFACE'');'
,p_required_patch=>wwv_flow_api.id(235700916833599805.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'197, 677'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(384736293175059813.4001)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(387750990921837996.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Administraci\00F3n')
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(488619320836057116.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Gestionar Servicio'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697357627145483514.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Gestionar Servicio'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697357856198483516.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(572699887011597076.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Realizar una Solicitud de Servicio'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697358175538483516.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Definir Preferencias de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=4350:17:&SESSION.::NO:RP::'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697358473589483516.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Definir mensaje de espacio de trabajo'
,p_list_item_link_target=>'f?p=4350:35:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(180638709312604050.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Definir banner de entorno'
,p_list_item_link_target=>'f?p=4350:105:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(322860788157413129.4001)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Uso de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(572044671779464700.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(195346789722904026.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gestionar Usuarios y Grupos'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(572046067324491819.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Controlar Actividad'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(10593027526205581)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(327720126528125003.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Paneles de Control'
,p_list_item_link_target=>'f?p=4350:33:&SESSION.'
,p_security_scheme=>wwv_flow_api.id(10593027526205581)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1250496483207165958.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Cambiar Mi Contrase\00F1a')
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(10593027526205581)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(384991882401692897.4001)
,p_name=>'APEX 5 - Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Creador de Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::P1500_SHOW::'
,p_list_item_icon_alt_attribute=>'Aumentar Detalle de Creador de Aplicaciones'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_api.id(178938910382761975)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384997181185692900.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Aplicaciones de Base de Datos'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::P1500_SHOW:DATABASE:'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697212495047631708.4001)
,p_list_item_display_sequence=>125
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384998086804692900.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Crear'
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384998642350692901.4001)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Importar'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384998906454692901.4001)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Exportar'
,p_list_item_link_target=>'f?p=4000:523:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697375495888714842.4001)
,p_list_item_display_sequence=>155
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Utilidades del Espacio de Trabajo'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(699060618186707760.4001)
,p_list_item_display_sequence=>161
,p_list_item_link_text=>'Todas las Utilidades del Espacio de Trabajo'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(699060810272707760.4001)
,p_list_item_display_sequence=>162
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697218772666647649.4001)
,p_list_item_display_sequence=>163
,p_list_item_link_text=>'Valores por Defecto del Creador de Aplicaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697219764020653222.4001)
,p_list_item_display_sequence=>165
,p_list_item_link_text=>'Temas de Espacio de Trabajo'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697219311840650861.4001)
,p_list_item_display_sequence=>166
,p_list_item_link_text=>'Grupos de Aplicaciones'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697220796797659605.4001)
,p_list_item_display_sequence=>167
,p_list_item_link_text=>'Vistas de Application Express'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697220390514657026.4001)
,p_list_item_display_sequence=>168
,p_list_item_link_text=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(385002826736692904.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697375794010714843.4001)
,p_list_item_display_sequence=>169
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(384992396663692898.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384992635866692898.4001)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Taller de SQL'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'Aumentar Detalle de Taller de SQL'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_api.id(178939331963761975)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384993534292692898.4001)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Explorador de Objetos'
,p_list_item_link_target=>'f?p=4500:1001:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(384992635866692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384993809500692899.4001)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Comandos SQL'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(384992635866692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697366669537617727.4001)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Scripts SQL'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(384992635866692898.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Utilidades'
,p_parent_list_item_id=>wwv_flow_api.id(384992635866692898.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697367098027622850.4001)
,p_list_item_display_sequence=>241
,p_list_item_link_text=>'Todas las Utilidades'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697367200739625365.4001)
,p_list_item_display_sequence=>242
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697367573471631495.4001)
,p_list_item_display_sequence=>243
,p_list_item_link_text=>'Taller&nbsp;de&nbsp;Datos'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697367739947635075.4001)
,p_list_item_display_sequence=>244
,p_list_item_link_text=>'Generador de Consultas'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(713688567094388045.4001)
,p_list_item_display_sequence=>245
,p_list_item_link_text=>unistr('SQL r\00E1pido')
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(670876181059880723.4001)
,p_list_item_display_sequence=>246
,p_list_item_link_text=>'Juegos de datos de ejemplo'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697367942849638524.4001)
,p_list_item_display_sequence=>247
,p_list_item_link_text=>'Generar DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697368124231641328.4001)
,p_list_item_display_sequence=>248
,p_list_item_link_text=>'Valores por Defecto de Interfaz de Usuario'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697369742087658694.4001)
,p_list_item_display_sequence=>249
,p_list_item_link_text=>unistr('Comparaci\00F3n de Esquema')
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697368385017644833.4001)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>unistr('M\00E9todos de las Tablas')
,p_list_item_link_target=>'f?p=4500:120:&SESSION.::NO::P117_CREATE_PACKAGE:TABLE'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697370148167661241.4001)
,p_list_item_display_sequence=>251
,p_list_item_link_text=>'Papelera de Reciclaje'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697369196932653004.4001)
,p_list_item_display_sequence=>252
,p_list_item_link_text=>'Informes de Objeto'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697368631376650206.4001)
,p_list_item_display_sequence=>253
,p_list_item_link_text=>'Acerca de la Base Datos'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697369518797655840.4001)
,p_list_item_display_sequence=>254
,p_list_item_link_text=>'Control de Base de Datos'
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(697366891742619697.4001)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(385003728877692904.4001)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Servicios RESTful'
,p_list_item_link_target=>'f?p=4850:500:&SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(384992635866692898.4001)
,p_security_scheme=>wwv_flow_api.id(802892920094782611)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384992969361692898.4001)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Desarrollo de Equipos'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Aumentar Detalle de Desarrollo de Equipos'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_api.id(178939812163761988)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384995344172692899.4001)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Etiquetas'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(384992969361692898.4001)
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384995062424692899.4001)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Hitos'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(384992969361692898.4001)
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384995637536692899.4001)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Plantillas'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_api.id(384992969361692898.4001)
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(384995957053692899.4001)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Utilidades'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(384992969361692898.4001)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697376668510727547.4001)
,p_list_item_display_sequence=>355
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(384992969361692898.4001)
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697269568743762526.4001)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Comentarios'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(384992969361692898.4001)
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(657003378451122018.4001)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>unistr('Galer\00EDa')
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities_managebackups
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(392874975855473167.4001)
,p_name=>'application.utilities.managebackups'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(392875192940473167.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Todas las copias de seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:970:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(482121222077403370.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Todos los detalles de copia de seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:979:&SESSION.::&DEBUG.:RP,979:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/attribute_dictionary
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(445192614743849621.4001)
,p_name=>'Attribute Dictionary'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(445192924596849626.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Acceder al Diccionario de Atributos'
,p_list_item_link_target=>'f?p=4500:6:&SESSION.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p164_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(445352903500710112.4001)
,p_name=>'P164_TASKS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(445353209286710113.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Exportar Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.:'
,p_list_item_current_for_pages=>'4900'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(445353627788710114.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Exportar Componentes'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.:'
,p_list_item_current_for_pages=>'688'
);
end;
/
prompt --application/shared_components/navigation/lists/standard_tab_display
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(454874132315440955.4001)
,p_name=>'Standard Tab Display'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454874414531440958.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('La p\00E1gina identifica un <strong>juego de separadores est\00E1ndar</strong>.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454881521635541944.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('La <strong>entrada de separador</strong> identifica la p\00E1gina como <strong>P\00E1gina de Separador</strong> o <strong>Separador Tambi\00E9n Actual para P\00E1ginas</strong>.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454874801932440962.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('La <strong>plantilla de p\00E1gina</strong> de la p\00E1gina puede mostrar <strong>separadores est\00E1ndar</strong>.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454875215155440962.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('La <strong>condici\00F3n de visualizaci\00F3n</strong> de las entradas de separador no impiden que se muestre el separador')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(454920400070828946.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('El <strong>esquema de autorizaci\00F3n</strong> de las entradas de separador no impide que se muestre el separador.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/parent_tab_display
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(455042113172478942.4001)
,p_name=>'Parent Tab Display'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(455042409640478944.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('La p\00E1gina se muestra correctamente como <strong>separador est\00E1ndar</strong>.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(455051127155492375.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('El <strong>separador est\00E1ndar</strong> identifica el <strong>juego de separadores principales</strong> correcto.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(455060118431660179.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>unistr('El <strong>separador principal</strong> identifica el juego de separadores correcto del atributo <strong>Actual en Juego de Separadores Est\00E1ndar</strong>.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(455051817936499217.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('La <strong>plantilla de p\00E1gina</strong> de la p\00E1gina puede mostrar <strong>separadores est\00E1ndar</strong> y <strong>separadores principales</strong>.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(455054405216552285.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('La <strong>condici\00F3n de visualizaci\00F3n</strong> de los separadores est\00E1ndar no impide que se muestre el separador principal.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(455055223701567123.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('El <strong>esquema de autorizaci\00F3n</strong> de los separadores est\00E1ndar no impide que se muestre el separador principal.')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_advanced_migration
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(484017424976766961.4001)
,p_name=>'Wizard_Advanced_Migration'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(499114818402832919.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('Seleccionar P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(484017612155766970.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Seleccionar Validaciones que Actualizar'
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'86'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(484017930508766978.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Seleccionar Botones para No Ejecutar Validaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'646'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(631593123192499955.4001)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Seleccionar Validaciones que Ejecutar Siempre'
,p_list_item_link_target=>'f?p=&APP_ID.:862:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'862'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492683002038349240.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Actualizar'
,p_list_item_link_target=>'f?p=&APP_ID.:383:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'383'
);
end;
/
prompt --application/shared_components/navigation/lists/export
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(486268530815434681.4001)
,p_name=>'Export'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486269231292444337.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Espacio de Trabajo'
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-workspace'
,p_list_text_01=>'Exportar un espacio de trabajo, que incluya grupos de usuarios, usuarios y datos de desarrollo de equipos, pero no aplicaciones.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486268818479440607.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Aplicaciones de Base de Datos'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-app-database'
,p_list_text_01=>unistr('Exportar aplicaciones de base de datos, p\00E1ginas individuales y componentes compartidos.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486271016233477824.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Temas de la Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-workspace-themes'
,p_list_text_01=>unistr('Exportar temas de una aplicaci\00F3n de base de datos espec\00EDfica.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486271223505479946.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Plugins'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:4460:::'
,p_list_item_icon=>'icon-sc-plugin'
,p_list_text_01=>'Exportar plugins utilizados en aplicaciones de base de datos.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486271911862486037.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Valores por Defecto de Interfaz de Usuario'
,p_list_item_link_target=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-ui-defaults'
,p_list_text_01=>unistr('Exportar propiedades de dise\00F1o por defecto de valores predeterminados de la interfaz de usuario de atributos o tabla.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486272411647495352.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Comentarios de Desarrollo de Equipos'
,p_list_item_link_target=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-page-feedback'
,p_list_text_01=>'Exportar comentarios proporcionados por los usuarios de aplicaciones en este espacio de trabajo.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(4117748652625154.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>unistr('Cat\00E1logo de origen de REST')
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-sc-data-references'
,p_list_text_01=>'Export REST Source Catalogs to be imported into other workspaces.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/export_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(486307715596288607.4001)
,p_name=>'export tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486307910526288621.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Repositorio de Exportaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.:'
,p_list_item_current_for_pages=>'73'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486308216101288623.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Importar'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.:'
,p_list_item_current_for_pages=>'460'
);
end;
/
prompt --application/shared_components/navigation/lists/ui_def_export_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(486427731138207743.4001)
,p_name=>'ui def export tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486428118802213684.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Diccionario de Tablas'
,p_list_item_link_target=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.:479:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'479'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(486428330923217163.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Diccionario de Atributos'
,p_list_item_link_target=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:541:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'541'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(488490120498750288.4001)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(488490330263750290.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Documentaci\00F3n')
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2105950689804969205.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Foro de Discusi\00F3n')
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2185440048625469825.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('M\00E1s informaci\00F3n sobre Oracle APEX')
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1493545637548007510.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Introducci\00F3n al Dise\00F1ador de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':APP_ID = 4000 and :APP_PAGE_ID = 4500'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(488495081334766183.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('M\00E9todos Abreviados')
,p_list_item_link_target=>'#'
,p_list_text_01=>'keyboardShortcuts'
,p_list_text_03=>'true'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(488616497367046354.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(488492468953750295.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Acerca de'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities_other
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(492631804585583697.4001)
,p_name=>'application.utilities.other'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492632127095590176.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Utilidades de P\00E1gina Cruzada')
,p_list_item_link_target=>'f?p=&APP_ID.:553:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(404527353730174909.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Grupos de P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492632330558591213.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilidades de Regiones'
,p_list_item_link_target=>'f?p=&APP_ID.:853:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492632500560591999.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Utilidades de Botones'
,p_list_item_link_target=>'f?p=&APP_ID.:852:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492632703677592889.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilidades de Elementos'
,p_list_item_link_target=>'f?p=&APP_ID.:854:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492632906448593646.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Utilidades de C\00E1lculo')
,p_list_item_link_target=>'f?p=&APP_ID.:847:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(821538007832540402.4001)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>unistr('Utilidades de Validaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:851:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492633108872594367.4001)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Utilidades de Proceso'
,p_list_item_link_target=>'f?p=&APP_ID.:482:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492633311642595224.4001)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>unistr('Utilidades de Acciones Din\00E1micas')
,p_list_item_link_target=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492633614413596002.4001)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Utilidades de Rama'
,p_list_item_link_target=>'f?p=&APP_ID.:881:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_utilities_cross_page
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(492636810051679904.4001)
,p_name=>'page.utilities.cross.page'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492638225897703413.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Edici\00F3n de Cuadr\00EDculas de Todas las P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:243:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492638629491713849.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Suprimir Varias P\00E1ginas')
,p_list_item_link_target=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492638421180711426.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:484:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492639008497717241.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Bloqueos de P\00E1gina')
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/advisor_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(504056409460898231.4001)
,p_name=>'Advisor Tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(504056630453898233.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Guardar como Mis Preferencias '
,p_list_item_link_target=>'javascript:apex.submit(''SAVE_PREF'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_workspace_objects
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(525226966024198272.4001)
,p_name=>'shared.components.workspace_objects'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(525227999285198277.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
,p_list_item_link_target=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(525227596268198277.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Credenciales'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(525227186638198275.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'SQL activado para REST'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(533134053205118467.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Servidores Remotos'
,p_list_item_link_target=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_remote_servers
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(533145899605135270.4001)
,p_name=>'shared.components.remote_servers'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(533146052588135270.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Servidores Remotos'
,p_list_item_link_target=>'f?p=&APP_ID.:1931:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(533146454181135274.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Uso'
,p_list_item_link_target=>'f?p=&APP_ID.:1933:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(533187009031297607.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historial'
,p_list_item_link_target=>'f?p=&APP_ID.:1934:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_get_started_list
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(583541659513985598.4001)
,p_name=>'Home Page Get Started List'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(583609906498114141.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>unistr('Crear Nueva Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56:::'
,p_list_item_icon=>'icon-check-circle'
,p_list_text_01=>unistr('Comience a crear su primera aplicaci\00F3n en Application Express.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(583541885189985600.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Instalar una aplicaci\00F3n inicial o de ejemplo')
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.'
,p_list_item_icon=>'icon-util-install'
,p_list_text_01=>unistr('Seleccione de entre m\00E1s de 20 aplicaciones de ejemplo e iniciales.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/remoteprintserver_create
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(608916658335678510.4001)
,p_name=>'remoteprintserver.create'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608916854583678511.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Agregar servidor de impresi\00F3n remoto')
,p_list_item_link_target=>'f?p=&APP_ID.:1935:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(608917221616678511.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Agregar credenciales del servidor de impresi\00F3n remoto')
,p_list_item_link_target=>'f?p=&APP_ID.:1936:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/legacy_data_load_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(675812107017852883.4001)
,p_name=>'LEGACY_DATA_LOAD_TASKS'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(675812305879852884.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Crear p\00E1ginas con esta carga de datos heredada')
,p_list_item_link_target=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:1704,1706:F4000_P1700_NAME,P1700_EXISTS:&P1801_NAME.,yes:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_components
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(694733590452503217.4001)
,p_name=>'shared.components.components'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694734693779503223.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Lista de Valores'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694735222077503223.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Plugins'
,p_list_item_link_target=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694735518639503226.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Valores de Componente'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(697104363364517738.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('\00C1rboles')
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   WWV_FLOW_TREES t',
'where  flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694734925778503223.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('M\00E9todos Abreviados')
,p_list_item_link_target=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(680965773582442489.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>unistr('Plantillas de correo electr\00F3nico')
,p_list_item_link_target=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_logic
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(694736922570524377.4001)
,p_name=>'shared.components.application_logic'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694739304257531368.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de Definici\00F3n de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694737191989524378.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Elementos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694737422504524378.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Procesos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694737701535524378.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(659490721011613496.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4850:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(2900257312389557.4001)
,p_list_item_display_sequence=>49
,p_list_item_link_text=>'Automatizaciones'
,p_list_item_link_target=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154811378368453381.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_references
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(694855238818571795.4001)
,p_name=>'shared.components.references'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694857216757571796.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Definiciones de Carga de Datos'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(154069177738949720.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'SQL activado para REST'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_text_03=>'has-arrow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(226162637659581893.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>unistr('Or\00EDgenes de Datos de REST')
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(694856635326571796.4001)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Referencias de servicio web heredado'
,p_list_item_link_target=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(702923103587108064.4001)
,p_name=>'Cross Application Reports'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702928892130158098.4001)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Todos los Empleados'
,p_list_item_link_target=>'f?p=&APP_ID.:9009:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'182'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702923320676108064.4001)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>unistr('Atributos de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:9010:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-application-attributes'
,p_list_text_01=>unistr('Ver recuentos de componentes de cada aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9010'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702923966900108065.4001)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>unistr('Estado de Creaci\00F3n y de la Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-app-status'
,p_list_text_01=>unistr('Revisar estados de cada aplicaci\00F3n.')
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'103'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702924515837108067.4001)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>unistr('Opciones de Creaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:9012:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-build-options'
,p_list_text_01=>unistr('Ver opciones de creaci\00F3n en todas las aplicaciones.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9012'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702923668978108065.4001)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-comments'
,p_list_text_01=>'Revisar comentarios de todas las aplicaciones.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'380'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702924262274108066.4001)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Calendario de Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:665:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-comments-calendar'
,p_list_text_01=>unistr('Ver fecha de creaci\00F3n de los comentarios.')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'665'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702925980864149602.4001)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.:NORUN:&DEBUG.::::'
,p_list_text_01=>'Diferencias de consulta en los nombres de componentes.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_for_pages=>'1300'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702926244508149602.4001)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>unistr('Comparaci\00F3n de Componentes')
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.:NORUN:&DEBUG.::::'
,p_list_text_01=>'Diferencias de consulta en los recuentos de componentes.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702926528050149602.4001)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Perfiles de Seguridad'
,p_list_item_link_target=>'f?p=&APP_ID.:9014:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'9014'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702926833196149603.4001)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>unistr('Esquemas de Autenticaci\00F3n')
,p_list_item_link_target=>'f?p=&APP_ID.:9015:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'9015'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702927168153149603.4001)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>unistr('Elementos de Contrase\00F1a')
,p_list_item_link_target=>'f?p=&APP_ID.:7777:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'7777'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(702927429794149604.4001)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'Resumen del Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:737:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_comments_navigation
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(784788000174894142.4001)
,p_name=>'developer.comments.navigation'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(784788282093894144.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(784788561594894145.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Calendario de Comentarios del Desarrollador'
,p_list_item_link_target=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.::::'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_comments_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(786331487669013778.4001)
,p_name=>'developer.comments.tasks'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(786331600475013783.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Suprimir Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/app_builder_homepage_image_nav
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(787106333147859999.4001)
,p_name=>'App Builder Homepage - Image Nav'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(787106515252860000.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Crear'
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:::'
,p_list_item_icon=>'app-builder-create-app'
,p_security_scheme=>wwv_flow_api.id(12472323342703137)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(787106820469860001.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Importar'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_list_item_icon=>'app-builder-import-app'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(787107719682860001.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Panel de Control'
,p_list_item_link_target=>'f?p=&APP_ID.:160:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-dashboards'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(787107428027860001.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilidades del Espacio de Trabajo'
,p_list_item_link_target=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_page_plugin
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(808644729415608533.4001)
,p_name=>'create_page_plugin'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(808899406699687141.4001)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Tipo'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4461'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(808644907636608535.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Atributos de P\00E1gina')
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4462'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(808645227449608539.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID, ',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1523941050764866656.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Separadores'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'               p_application_id     => :FB_FLOW_ID, ',
'               p_user_interface_id => :P259_USER_INTERFACE_ID);'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(808645506170608540.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Origen'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4462_REGION_TYPE is not null and (',
''':''||',
'wwv_flow_plugin_dev.get_standard_attributes (',
'    p_application_id => :FB_FLOW_ID,',
'    p_plugin_type    => ''REGION TYPE'',',
'    p_plugin_name    => :P4462_REGION_TYPE ) ||'':'' like ''%:SOURCE%:'')'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4464'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(808845305052667724.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>unistr('Configuraci\00F3n')
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id         = case',
'                             when substr(:P4462_REGION_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                             else to_number(:FB_FLOW_ID)',
'                           end',
'   and p.plugin_type     = ''REGION TYPE''',
'   and p.name            = substr(:P4462_REGION_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id       = p.id',
'   and a.attribute_scope = ''COMPONENT''',
'   and a.show_in_wizard  = ''Y'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4465'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(936810670133035025.4001)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>unistr('Crear/Editar P\00E1gina')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'' and ( :P4465_CSS_CAL_EDIT_MOB = ''Y'' or (:P4465_CSS_CAL_NEW_PAGE = ''Y'' and :P4465_CSS_CAL_EDIT_PAGE = ''Y''))'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'234,274,53'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1858877314670538244.4001)
,p_list_item_display_sequence=>46
,p_list_item_link_text=>unistr('Crear P\00E1gina')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'' and :P4465_CSS_CAL_NEW_PAGE = ''Y'' and :P4465_CSS_CAL_EDIT_PAGE = ''N'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'234,274,53'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1858877642851542014.4001)
,p_list_item_display_sequence=>47
,p_list_item_link_text=>unistr('Editar P\00E1gina')
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'' and :P4465_CSS_CAL_NEW_PAGE = ''N'' and :P4465_CSS_CAL_EDIT_PAGE = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'234,274,53'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1899432406275505294.4001)
,p_list_item_display_sequence=>48
,p_list_item_link_text=>'Arrastrar y Soltar'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'' and :P4465_CSS_CAL_NEW_PAGE = ''N'' and :P4465_CSS_CAL_EDIT_PAGE = ''N'' and :P4465_CSS_CAL_DRAG_CODE = ''Y''',
''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'274'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(808645801337608540.4001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Confirmar'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4466'
);
end;
/
prompt --application/shared_components/navigation/lists/delete_theme
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1029750209782685847.4001)
,p_name=>'delete.theme'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1029750412409686103.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Suprimir Tema'
,p_list_item_link_target=>'f?p=&APP_ID.:221:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1029750729764686109.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirmar'
,p_list_item_link_target=>'f?p=&APP_ID.:229:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/replace_templates_from_different_application
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1127562677974975992.4001)
,p_name=>'Replace Templates From Different Application'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1127562895657976062.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copiar Plantillas de'
,p_list_item_link_target=>'f?p=&APP_ID.:220:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1127563065821976070.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Configurar'
,p_list_item_link_target=>'f?p=&APP_ID.:222:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/new_comments
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1284942185735713564.4001)
,p_name=>'new comments'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1284942644091713566.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Ver Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1235'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1284942921905713567.4001)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Editar Comentario'
,p_list_item_link_target=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1236'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1236'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1284943266884713568.4001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Suprimir Comentarios'
,p_list_item_link_target=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1237,1238'
);
end;
/
prompt --application/shared_components/navigation/lists/plugin_create
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1434105688733324411.4001)
,p_name=>'plugin.create'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1434105853379324421.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('M\00E9todo')
,p_list_item_link_target=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1435745785714405537.4001)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Copiar de'
,p_list_item_link_target=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P4402_ACTION'
,p_list_item_disp_condition2=>'COPY'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1434106176547324425.4001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copiar'
,p_list_item_link_target=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_utilization_tasks
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(1598999842830947024.4001)
,p_name=>'Template Utilization Tasks '
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(1599000030969947024.4001)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Eliminar Plantillas no Utilizadas'
,p_list_item_link_target=>'f?p=&APP_ID.:46:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(233833500443227.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(970498439392559.4001)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14848431076940926.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(92010790354572457.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99821115378888928.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(174677809582024970.4001)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176117893097506806.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592208520316709428.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072046903712054.4001)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831722437189993876.4001)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917679704307940123.4001)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2010954470365119059.4001)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/security/authorizations/user_may_edit_current_application
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(317822338466.4001)
,p_name=>'User May Edit Current Application'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_security.user_is_internal then',
'   return true;',
'elsif wwv_flow_security.user_can_develop_flow(p_flow_id=>:FB_FLOW_ID) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_error_message=>unistr('El usuario &USER. no tiene los privilegios necesarios para editar la aplicaci\00F3n en cuesti\00F3n.')
,p_reference_id=>786944233424207200.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(10593027526205581.4001)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>unistr('No est\00E1 autorizado para acceder a los paneles de control y la actividad de supervisi\00F3n.')
,p_reference_id=>786936829326142579.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_create
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12472323342703137.4001)
,p_name=>'Flow: CREATE'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'CREATE'
,p_error_message=>unistr('No est\00E1 autorizado para crear o suprimir aplicaciones')
,p_reference_id=>786942708067207200.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12510423405283164.4001)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>unistr('No est\00E1 autorizado para editar aplicaciones')
,p_reference_id=>12480509677812756.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(12511519296310366.4001)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>unistr('No est\00E1 autorizado para administrar aplicaciones')
,p_reference_id=>12511219858301010.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/developer_may_edit_page
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(34674432490821717.4001)
,p_name=>'Developer may edit page'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps s',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and id      = to_number(:FB_FLOW_PAGE_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and not exists (',
'         select 1',
'           from wwv_flow_lock_page l',
'          where l.flow_id    = s.flow_id',
'            and l.object_id  = s.id',
'            and l.locked_by != :APP_USER )'))
,p_error_message=>unistr('Puede que el desarrollador no haya editado la p\00E1gina')
,p_reference_id=>786942462038207200.4001
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/user_auth_to_access_schema
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(74725624313588476.4001)
,p_name=>'User_auth_to_access_schema'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
'where  c.security_group_id = :flow_security_group_id and',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :flow_user and',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'        instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0) and',
'        c.schema = :P391_SCHEMA'))
,p_error_message=>'No dispone de acceso al esquema seleccionado.'
,p_reference_id=>786944588379207201.4001
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/user_has_edit_priv
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(74845831538733642.4001)
,p_name=>'USER_HAS_EDIT_PRIV'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_security.user_can_develop_any_flow;'
,p_error_message=>'No tiene privilegios para editar aplicaciones.'
,p_reference_id=>786943988629207200.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/is_real_application_security_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(125788121598195155.4001)
,p_name=>'Is Real Application Security enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_platform.get_preference(''ALLOW_RAS'')=''Y'';'
,p_error_message=>unistr('Real Application Security no est\00E1 activado')
,p_reference_id=>786943379004207200.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178938910382761975.4001)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>unistr('No tiene privilegios para realizar esta operaci\00F3n')
,p_reference_id=>786516029127697713.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178939331963761975.4001)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>unistr('No est\00E1 autorizado a utilizar Taller de SQL.')
,p_reference_id=>786516265251697717.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178939812163761988.4001)
,p_name=>'APEX 5.0 Team Development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'No se ha activado el desarrollo de equipos para este espacio de trabajo'
,p_reference_id=>786516861027697723.4001
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_websheets_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178940313582761989.4001)
,p_name=>'APEX 5.0 Websheets Enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, wwv_flow_fnd_user u',
'where nvl(w.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'''))
,p_error_message=>unistr('No tiene privilegios para realizar esta operaci\00F3n')
,p_reference_id=>786517166823697723.4001
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(331660423436603298.4001)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>unistr('SSO de creador no est\00E1 activado')
,p_reference_id=>6738410669854771.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/attribute_dictionary_columns_defined
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(499915500493760557.4001)
,p_name=>'Attribute Dictionary Columns Defined'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_hnt_column_dict',
' where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_error_message=>unistr('No hay ning\00FAn atributo definido en el diccionario de atributos.')
,p_reference_id=>786942219366207200.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/team_dev_file_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(692489888034486589.4001)
,p_name=>'Team Dev File Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_team_file.team_dev_file_enabled then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_error_message=>unistr('Para acceder a esta p\00E1gina es necesario activar los archivos de desarrollo de equipos.')
,p_reference_id=>786943600005207200.4001
,p_caching=>'NOCACHE'
);
end;
/
prompt --application/shared_components/security/authorizations/websheet_create_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(770886849281707823.4001)
,p_name=>'Websheet Create Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WEBSHEET_CREATE_ENABLED''), ''N'' ) = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('Para acceder a esta p\00E1gina, es necesario activar la aplicaci\00F3n de hoja de c\00E1lculo web.')
,p_reference_id=>771322804043281981.4001
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(802892920094782611.4001)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>unistr('No tiene privilegios para realizar esta operaci\00F3n')
,p_reference_id=>786519856057734816.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/developer_may_edit_supporting_object_script
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(857903402130335025.4001)
,p_name=>'Developer may edit supporting object script'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_lock.user_can_edit_script (',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_script_id => :P865_SCRIPT_ID,',
'    p_override  => :P865_MODE = ''NEW'' -- allow viewing if create',
'    );'))
,p_error_message=>'Puede que el desarrollador no haya editado el script.'
,p_caching=>'NOCACHE'
);
end;
/
prompt --application/shared_components/security/authorizations/service_requests_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(917540220622028585.4001)
,p_name=>'Service Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('No tiene privilegios para realizar esta operaci\00F3n.')
,p_reference_id=>786932326296107981.4001
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(1361802214166928.4001)
,p_icon_sequence=>10
,p_icon_subtext=>'Espacio de Trabajo de &COMPANY.'
,p_icon_target=>'#'
,p_icon_image_alt=>'Espacio de Trabajo de &COMPANY.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(331551200056558688.4001)
,p_icon_sequence=>40
,p_icon_subtext=>'( <span style="text-decoration:underline;">Cambiar Espacio de Trabajo</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'Cambiar Espacio de Trabajo'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_api.id(331660423436603298)
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(39804528545736393.4001)
,p_icon_sequence=>50
,p_icon_subtext=>'( <span style="text-decoration:underline;">Desconectar</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Desconectar'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/returnnothing
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(26098116757095708.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'returnNothing'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_process_comment=>'this is useful for setting item values where no return value is needed.'
);
end;
/
prompt --application/shared_components/logic/application_processes/p872_add_parameter
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(33555511200784610.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'P872_ADD_PARAMETER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => wwv_flow.g_x01,',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c003 => wwv_flow.g_f04,',
'  p_c004 => wwv_flow.g_f05,',
'  p_c005 => wwv_flow.g_f06 );',
'wwv_flow_collection.add_member(p_collection_name =>wwv_flow.g_x01, p_c004 =>''N'');'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/p875_test_rest
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(33809312666721107.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'P875_TEST_REST'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.test_legacy_rest_service (',
'    p_url             => wwv_flow.g_x01,',
'    p_proxy_override  => wwv_flow.g_x02,',
'    p_method          => wwv_flow.g_x03,',
'    p_username        => wwv_flow.g_x04,',
'    p_password        => wwv_flow.g_x05,',
'    p_body            => wwv_flow.g_x06,',
'    p_parm_name       => wwv_flow.g_f01,',
'    p_parm_value      => wwv_flow.g_f02,',
'    p_http_headers    => wwv_flow.g_f03,',
'    p_http_hdr_values => wwv_flow.g_f04 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/p872_remove_parameter
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(33980127084358949.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'P872_REMOVE_PARAMETER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => wwv_flow.g_x01,',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c003 => wwv_flow.g_f04,',
'  p_c004 => wwv_flow.g_f05,',
'  p_c005 => wwv_flow.g_f06 );',
'if nvl(wwv_flow.g_x03,''x'') != ''update'' then',
'  wwv_flow_collection.delete_member(wwv_flow.g_x01,wwv_flow.g_x02);',
'  wwv_flow_collection.resequence_collection(wwv_flow.g_x01);',
'else',
'  for c1 in (select c003',
'               from wwv_flow_collections',
'              where collection_name = wwv_flow.g_x01',
'                and seq_id = wwv_flow.g_x02 ) loop',
'    wwv_flow_collection.update_member(',
'      p_collection_name => wwv_flow.g_x01, ',
'      p_seq             => wwv_flow.g_x02,',
'      p_c001            => ''marked for delete'',',
'      p_c003            => c1.c003,',
'      p_c004            => ''D'' );',
'  end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/ajax_collect_clob
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(49827831510641638.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'AJAX_COLLECT_CLOB'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code clob := empty_clob;',
'begin',
'   sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'   for i in 1..wwv_flow.g_f01.count loop',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));',
'    end loop;',
'apex_collection.create_or_truncate_collection(p_collection_name=>''CLOB_CONTENT'');',
'apex_collection.add_member(p_collection_name=>''CLOB_CONTENT'',p_clob001=>l_code);',
'sys.htp.prn(''SUCCESS'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/parse_report_query
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(59589024396402332.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'PARSE_REPORT_QUERY'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_owner varchar2(4000)  := null;',
'  l_query varchar2(32767) := null;',
'  l_error varchar2(32767) := null;',
'begin',
'',
'  l_owner := wwv_flow_security.flow_owner ( ',
'     p_flow_id           =>:FB_FLOW_ID, ',
'     p_security_group_id =>:FLOW_SECURITY_GROUP_ID',
'  );',
'',
'  for c1 in (',
'    select clob001 ',
'    from wwv_flow_collections ',
'    where collection_name = ''REPORT_QUERY_TEMP''',
'  ) loop',
'    l_query := c1.clob001;',
'    l_error := wwv_flow_f4000_util.is_valid_report_query (',
'      p_plug_source      => l_query,',
'      p_plug_source_type => wwv_flow_region_native.c_sql_report,',
'      p_owner            => l_owner',
'    );',
'  end loop;',
'         ',
'  if l_error is null then',
'    sys.htp.p(''1''||wwv_flow_lang.system_message(''REPORT_QUERIES.VALID_QUERY''));',
'  else',
'    sys.htp.p(''0''||wwv_flow_utilities.striphtml(l_error));',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/spotlightindex
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(233703836072822139.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'spotlightIndex'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_spotlight_dev.emit_spotlight_index(',
'    p_app_id           => wwv_flow.g_x01,',
'    p_get_apps_list    => wwv_flow.g_x02,',
'    p_is_page_designer => true);'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_processes/developertoolbar
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(241203394876147425.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'developerToolbar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_developer_toolbar.ajax;',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_processes/get_plugin_sql_examples
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(468201615965604310.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_plugin_sql_examples'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.htp.p (',
'        wwv_flow_plugin_dev.get_sql_examples (',
'            p_application_id => :FB_FLOW_ID,',
'            p_plugin_type    => wwv_flow.g_x01,',
'            p_plugin_name    => wwv_flow.g_x02 ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/ajax_set_ui_mode
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(559208518059277022.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ajax_set_ui_mode'
,p_process_sql_clob=>'wwv_flow_4000_ui.ajax_set_ui_mode;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_processes/theme_roller
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(1199152637279464946.4001)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'theme_roller'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_theme_dev.theme_roller_ajax;',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
);
end;
/
prompt --application/shared_components/logic/application_processes/set_flow_page
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(72694123644888753.4001)
,p_process_sequence=>1
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flow page'
,p_process_sql_clob=>'wwv_flow_f4000_util.set_flow_page;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_when=>'1000,460,514,516,527,273,2100,2101,2102,2103,2104,2105,2106,2107,2108,2109,2111,2115,1500,163,56,176,189,433,447,448,451,454,458,494,495,496,3001,3002,3005,3020,49,57,8000,8101'
,p_process_when_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_security_scheme=>wwv_flow_api.id(12510423405283164)
,p_process_comment=>'Used to set env when two browsers are working on different apps in the same session.  Prevents a wizard from creating a component in the wrong application.'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_temporary_item
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(6191718445268266.4001)
,p_name=>'AJAX_TEMPORARY_ITEM'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/cascading_selectlist_item_1
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(187760430466726137.4001)
,p_name=>'CASCADING_SELECTLIST_ITEM_1'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(323366420862.4001)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Prints workspace name referenced in page templates'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_check
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(137222915098326064.4001)
,p_name=>'F4000_CHECK'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used to display system message "Check".'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_copy_to_theme
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2461529447025552654.4001)
,p_name=>'F4000_COPY_TO_THEME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_cur_std_tab
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(49554522682292670.4001)
,p_name=>'F4000_CUR_STD_TAB'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_find_label
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(2573484773802618001.4001)
,p_name=>'F4000_FIND_LABEL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_last_portal_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(201664305800188161.4001)
,p_name=>'F4000_LAST_PORTAL_VIEW'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_last_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(46180307972.4001)
,p_name=>'F4000_LAST_VIEW'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_p35_demo_flows
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(174779207867417973.4001)
,p_name=>'F4000_P35_DEMO_FLOWS'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'an item used for demostrations'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_region_selected
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(60363923165055254.4001)
,p_name=>'F4000_REGION_SELECTED'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used to dynamically compute button postions for that region'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_run
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(137215819075289336.4001)
,p_name=>'F4000_RUN'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Item used to display system message "Run".'
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_run_edit_page
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(148405327096585472.4001)
,p_name=>'F4000_RUN_EDIT_PAGE'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(40006855470898.4001)
,p_name=>'FB_FLOW_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Identifies the flow.'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_name
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(40006856470899.4001)
,p_name=>'FB_FLOW_NAME'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Y'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_page_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(40006857470899.4001)
,p_name=>'FB_FLOW_PAGE_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Identifies the flow page.'
);
end;
/
prompt --application/shared_components/logic/application_items/fb_theme_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(146658914296443870.4001)
,p_name=>'FB_THEME_ID'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fp_max_rows_per_page
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(76847111472614227.4001)
,p_name=>'FP_MAX_ROWS_PER_PAGE'
,p_escape_on_http_output=>'N'
,p_item_comment=>'obsolete this item when you get a chance'
);
end;
/
prompt --application/shared_components/logic/application_items/fp_pref_show_information
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(76852381884625214.4001)
,p_name=>'FP_PREF_SHOW_INFORMATION'
,p_escape_on_http_output=>'N'
,p_item_comment=>'obosolete this item when you get a chance'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(61573406162429920.4001)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
);
end;
/
prompt --application/shared_components/logic/application_items/g_bc_parent_label
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(4102236188852409.4001)
,p_name=>'G_BC_PARENT_LABEL'
,p_protection_level=>'I'
,p_item_comment=>'Used to dynamically set the parent entry label in complex breadcrumb setups.'
);
end;
/
prompt --application/shared_components/logic/application_items/g_parse_as_schema_override
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(3692062815389.4001)
,p_name=>'G_PARSE_AS_SCHEMA_OVERRIDE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/last_step
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(22788166245.4001)
,p_name=>'LAST_STEP'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Y'
);
end;
/
prompt --application/shared_components/logic/application_items/monitor_user
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(453606206.4001)
,p_name=>'MONITOR_USER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by monitoring Utility'
);
end;
/
prompt --application/shared_components/logic/application_items/recent_pages
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(163678415474826275.4001)
,p_name=>'RECENT_PAGES'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/theme_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(12973032052396511.4001)
,p_name=>'THEME_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/theme_next_page
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(52224418686048921.4001)
,p_name=>'THEME_NEXT_PAGE'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ui_schema
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(60734732002851561.4001)
,p_name=>'UI_SCHEMA'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ui_table
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(60735102005852345.4001)
,p_name=>'UI_TABLE'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ui_table_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(114948426092978491.4001)
,p_name=>'UI_TABLE_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/wizard_entry_page
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(106733613326936844.4001)
,p_name=>'WIZARD_ENTRY_PAGE'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(323368422455.4001)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name;'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'No se ha podido calcular el nombre del espacio de trabajo.'
);
end;
/
prompt --application/shared_components/logic/application_computations/fb_flow_id
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(40006858470900.4001)
,p_computation_sequence=>1
,p_computation_item=>'FB_FLOW_ID'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'SET_ITEM_EQUAL_THIS_PREFERENCE'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'FB_FLOW_ID'
,p_compute_when_type=>'NEVER'
,p_computation_error_message=>unistr('No se ha podido obtener la preferencia para la aplicaci\00F3n.')
);
end;
/
prompt --application/shared_components/logic/application_computations/fb_flow_page_id
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(40006860470902.4001)
,p_computation_sequence=>2
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'SET_ITEM_EQUAL_THIS_PREFERENCE'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'FB_FLOW_PAGE_ID'
,p_compute_when=>'FB_FLOW_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>unistr('No se ha podido obtener la preferencia para el ID de p\00E1gina de creador de aplicaciones.')
);
end;
/
prompt --application/shared_components/logic/application_computations/fb_flow_name
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(40006859470901.4001)
,p_computation_sequence=>3
,p_computation_item=>'FB_FLOW_NAME'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'ON_NEW_INSTANCE'
,p_computation=>'wwv_flow_escape.html(v(''FB_FLOW_NAME''))'
,p_computation_error_message=>unistr('No se ha podido determinar el nombre de la aplicaci\00F3n.')
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_run
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(137218026825301058.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_check
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(137224006571333058.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_CHECK'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''F4500_CHECK'')'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_last_portal_view
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(201669928216192952.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_PORTAL_VIEW'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'ON_NEW_INSTANCE'
,p_computation=>'page_definition'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/4500_ui_def_alignment_l_c_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(200094129140149873.4001)
,p_lov_name=>'4500 UI DEF ALIGNMENT L.C.R'
,p_reference_id=>260501806598530292.4001
,p_lov_query=>'.'||wwv_flow_api.id(200094129140149873.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441093505492065867.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'L'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441093315770065865.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Centro'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441093715747065867.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/4700_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21175516989935412.4001)
,p_lov_name=>'4700 PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(21175516989935412.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27347459598934566.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Informe Interactivo'
,p_lov_return_value=>'INTERACTIVE'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-IR'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''INTERACTIVE_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246582238858911524.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuadr\00EDcula Interactiva')
,p_lov_return_value=>'GRID'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-IG'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''INTERACTIVE_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2493355178753248.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('B\00FAsqueda por facetas')
,p_lov_return_value=>'FACETED_SEARCH'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-FS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_CHOOSE_PAGE_TYPE = ''REPORT'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4500600983248959.4001)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Filtros inteligentes'
,p_lov_return_value=>'SMART_FILTERS'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-SMART-FILTERS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_CHOOSE_PAGE_TYPE = ''REPORT'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1509281511332471.4001)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'Tarjetas'
,p_lov_return_value=>'CARD'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CARDS-REPORT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_CHOOSE_PAGE_TYPE = ''REPORT'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21176006373935415.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Informe Cl\00E1sico')
,p_lov_return_value=>'CLASSIC'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-SQL-REPORT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''CLASSIC_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(230450390826227467.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Informe con formulario'
,p_lov_return_value=>'REPORTANDFORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-table-report'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''INTERACTIVE_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10795014720095875.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Vista de Lista'
,p_lov_return_value=>'LISTVIEW'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-JQM-LIST-VIEW'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''JQM_LIST_VIEW'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(653851210587797943.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Informe de Conmutaci\00F3n de Columnas')
,p_lov_return_value=>'COLUMNTOGGLE'
,p_lov_template=>'#DISPLAY_VALUE#|native-jqm-column-toggle'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''JQM_COLUMN_TOGGLE'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(653851747288800529.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Informe de Reflujo'
,p_lov_return_value=>'REFLOW'
,p_lov_template=>'#DISPLAY_VALUE#|native-jqm-reflow'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_CHOOSE_PAGE_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''JQM_REFLOW_TABLE'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21176218444935415.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Informe con formulario en tabla'
,p_lov_return_value=>'REPORT_WITH_FORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-table-report'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'REPORT XX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21187613405000544.4001)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>'Pantalla'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-table'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(714137469566757848.4001)
,p_lov_disp_sequence=>96
,p_lov_disp_value=>unistr('Cuadr\00EDcula Interactiva Editable')
,p_lov_return_value=>'EDITABLE_GRID'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-IG'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_CHOOSE_PAGE_TYPE = ''FORM'' ',
'and ',
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''INTERACTIVE_GRID'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21189232105005988.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Informe con formulario'
,p_lov_return_value=>'REPORTANDFORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-table-report'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''FORM''',
'and (  wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''CLASSIC_REPORT'' )',
'    or wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''INTERACTIVE_REPORT'' )',
'    )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236493430582249579.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Vista de lista con pantalla'
,p_lov_return_value=>'LISTVIEWFORM'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-JQM-LIST-VIEW'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''FORM''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''JQM_LIST_VIEW'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21187920677002697.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Pantalla basada en procedimiento local'
,p_lov_return_value=>'FORMONPROC'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-procedure'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21209407489121901.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Calendario Sencillo'
,p_lov_return_value=>'EZCALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CSS-CALENDAR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(156093025691342628.4001)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CSSCALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CSS-CALENDAR'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21213125974136706.4001)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Asistente Sencillo'
,p_lov_return_value=>'SIMPLE_WIZARD'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'WIZARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21219222212163984.4001)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'TREE'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-JSTREE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P259_CHOOSE_PAGE_TYPE = ''TREE''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''JSTREE'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246500450369268408.4001)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Oracle JET'
,p_lov_return_value=>'JET_CHART'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_CHOOSE_PAGE_TYPE = ''CHART'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21189504185007384.4001)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>unistr('P\00E1gina de Resumen')
,p_lov_return_value=>'SUMMARY'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-summary'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'LEGACY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114174512180561978.4001)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'Informe sobre servicio web heredado'
,p_lov_return_value=>'WEBSERVICE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-report-webservice'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'LEGACY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21190519076011733.4001)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>'Pantalla basada en servicio web heredado'
,p_lov_return_value=>'FORMWS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-report-webservice'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'LEGACY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30111210090697363.4001)
,p_lov_disp_sequence=>320
,p_lov_disp_value=>'Informe y pantalla basados en servicio web heredado'
,p_lov_return_value=>'REPORTANDFORMWS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-report-webservice'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'LEGACY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203469713384401835.4001)
,p_lov_disp_sequence=>900
,p_lov_disp_value=>'Calendario Heredado'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CSS-CALENDAR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21188626910004453.4001)
,p_lov_disp_sequence=>910
,p_lov_disp_value=>'Pantalla Basada en Consulta SQL'
,p_lov_return_value=>'FORMONSQL'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-sql'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(581813879797183337.4001)
,p_lov_disp_sequence=>920
,p_lov_disp_value=>'Carga de datos heredada'
,p_lov_return_value=>'LEGACY_DATA_LOAD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-data-loading'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P259_CHOOSE_PAGE_TYPE'
,p_lov_disp_cond2=>'LEGACY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/4791_url_or_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6718617245289867.4001)
,p_lov_name=>'4791_URL_OR_PAGE'
,p_lov_query=>'.'||wwv_flow_api.id(6718617245289867.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6718912393289869.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Crear Nueva P\00E1gina de Edici\00F3n')
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6719410796297458.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00E1gina en esta aplicaci\00F3n')
,p_lov_return_value=>'FLOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6719129689289872.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(598109125486803480.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Excluir Destino de Enlace'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/9999_url_or_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(191802018719438597.4001)
,p_lov_name=>'9999_URL_OR_PAGE'
,p_lov_query=>'.'||wwv_flow_api.id(191802018719438597.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191802221865438607.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina en esta Aplicaci\00F3n')
,p_lov_return_value=>'FLOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191802417355438613.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191803319328457621.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Javascript'
,p_lov_return_value=>'JAVASCRIPT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/advanced_upgrade_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(499502202331793325.4001)
,p_lov_name=>'ADVANCED_UPGRADE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(499502202331793325.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(499504213089793331.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Actualizar Elemento de Texto a Campo Num\00E9rico')
,p_lov_return_value=>'NUMBER_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(499502630417793330.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Actualizar Selector de Fechas a Selector de Fechas Nuevo'
,p_lov_return_value=>'DATE_PICKER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(499504425018793331.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Cambiar Atributo de Elemento Necesario a S\00ED')
,p_lov_return_value=>'REQUIRED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/aggregate_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(167761011505168202.4001)
,p_lov_name=>'AGGREGATE BY'
,p_lov_query=>'.'||wwv_flow_api.id(167761011505168202.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(167761226870168212.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SUM'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(167761407532168218.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'AVG'
,p_lov_return_value=>'AVG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(167761632408168219.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'MIN'
,p_lov_return_value=>'MIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(167761817557168219.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'MAX'
,p_lov_return_value=>'MAX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(167776619311284077.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'COUNT'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/aggregate_function
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(49455515219053317.4001)
,p_lov_name=>'AGGREGATE_FUNCTION'
,p_lov_query=>'.'||wwv_flow_api.id(49455515219053317.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(49455814570053330.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Suma'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(49456006581053331.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Media'
,p_lov_return_value=>'AVG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/aggregate_functions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(101016778607432389.4001)
,p_lov_name=>'AGGREGATE_FUNCTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(101016778607432389.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(101017392766432406.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Recuento'
,p_lov_return_value=>'COUNT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155331225296971782.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Recuento de los Valores Distintos'
,p_lov_return_value=>'COUNT_DISTINCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155331592721974019.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Recuento de los Valores Distintos Aprox.'
,p_lov_return_value=>'APPROX_COUNT_DISTINCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155331898423975434.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('M\00EDnimo')
,p_lov_return_value=>'MIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155332158908977182.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('M\00E1ximo')
,p_lov_return_value=>'MAX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(101017723584432406.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Suma'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155335855601993887.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Media'
,p_lov_return_value=>'AVG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166230555723037356.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Mediana'
,p_lov_return_value=>'MEDIAN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/alignment_l_c_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84702113000663314.4001)
,p_lov_name=>'ALIGNMENT_L_C_R'
,p_lov_query=>'.'||wwv_flow_api.id(84702113000663314.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84702319979663314.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'inicio'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84702526646663315.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'centro'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84702722814663315.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'final'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_items_page_and_application
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(194317808992054940.4001)
,p_lov_name=>'ALL ITEMS (PAGE AND APPLICATION)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, name r',
'from wwv_flow_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id',
'union all',
'select name d, name r',
'from wwv_flow_step_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/allow_page_repost
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84920132510743677.4001)
,p_lov_name=>'ALLOW PAGE REPOST'
,p_lov_query=>'.'||wwv_flow_api.id(84920132510743677.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84920305972743677.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('No: Evitar que Se Vuelva a Enviar la P\00E1gina')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84920515901743678.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('S\00ED: Permitir Volver a Enviar la P\00E1gina')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/allowed_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86630311100418314.4001)
,p_lov_name=>'ALLOWED OPERATIONS'
,p_lov_query=>'.'||wwv_flow_api.id(86630311100418314.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88151603016962504.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Insertar'
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88151802892962505.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Actualizar'
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(605643319539148456.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Suprimir'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_end_users
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1741323331892226882.4001)
,p_lov_name=>'APEX END USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_name d, user_name r',
'from wwv_flow_fnd_user u',
'where security_group_id = :flow_security_group_id',
'and not exists (select null',
'                from wwv_flow_developers d',
'                where d.security_group_id = u.security_group_id',
'                and d.userid            = u.user_name',
'                and (instr(d.developer_role,''ADMIN'') > 0',
'                     or instr(d.developer_role,''EDIT'') > 0))',
'and nvl(u.account_locked,''N'') = ''N''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_views_filter_conditions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(200640422229340739.4001)
,p_lov_name=>'APEX VIEWS FILTER CONDITIONS'
,p_lov_query=>'.'||wwv_flow_api.id(200640422229340739.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200640620893340743.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200640809968340743.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200641025381340743.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'LIKE'
,p_lov_return_value=>'LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200641212319340743.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'NOT LIKE'
,p_lov_return_value=>'NOT LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200641411936340743.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200641614080340743.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200642026032340743.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'IS NULL'
,p_lov_return_value=>'IS NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(193463382693188419.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'IS NOT NULL'
,p_lov_return_value=>'IS NOT NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_computation_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84926512995804334.4001)
,p_lov_name=>'APP COMPUTATION TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84926512995804334.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84927104623804335.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Expresi\00F3n')
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84926706354804335.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84926905769804335.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Valor de Elemento'
,p_lov_return_value=>'ITEM_VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84927328096804335.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484391218230836490.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Consulta SQL (devolver valores separados por dos puntos)'
,p_lov_return_value=>'QUERY_COLON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84927527354804336.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Definir Elemento Igual a Preferencia'
,p_lov_return_value=>'SET_ITEM_EQUAL_THIS_PREFERENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84928121322804336.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Asignaci\00F3n Est\00E1tica')
,p_lov_return_value=>'STATIC_ASSIGNMENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_diff_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15166510896787111.4001)
,p_lov_name=>'APP DIFF COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(15166510896787111.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15166729440787257.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15166920981787257.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Regi\00F3n de P\00E1gina')
,p_lov_return_value=>'PAGE.REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15167616090788599.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Elemento de P\00E1gina')
,p_lov_return_value=>'PAGE.ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15214625580576733.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bot\00F3n de P\00E1gina')
,p_lov_return_value=>'PAGE.BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15272703827450402.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15275406775489081.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB.ENTRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15280612335642113.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lista de Valores'
,p_lov_return_value=>'LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15282816060662069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Entrada de Lista de Valores'
,p_lov_return_value=>'LOV.ENTRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15286423211730438.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bifurcaci\00F3n de P\00E1gina')
,p_lov_return_value=>'PAGE.BRANCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15289020964767588.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Proceso de P\00E1gina')
,p_lov_return_value=>'PAGE.PROCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15405712412659795.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entrada de Barra de Navegaci\00F3n')
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15407718009765502.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Validaci\00F3n de P\00E1gina')
,p_lov_return_value=>'PAGE.VALIDATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16035403732024287.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Proceso de Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION.PROCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16049914242661216.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('C\00E1lculo de Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION.COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16051425979711899.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Separador'
,p_lov_return_value=>'TAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16053917069766164.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Separador Principal'
,p_lov_return_value=>'PARENT.TAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16055929929798216.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Elemento de Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION.ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16057603787828581.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Opci\00F3n de Creaci\00F3n')
,p_lov_return_value=>'BUILD.OPTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16059007512848565.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16061027392939460.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Entrada de Lista'
,p_lov_return_value=>'LIST.ENTRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16063928309005945.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('M\00E9todo Abreviado')
,p_lov_return_value=>'SHORTCUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16064814158030207.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'TREE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16066121917117672.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Esquema de Autenticaci\00F3n')
,p_lov_return_value=>'AUTHENTICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17120709519005837.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION.ATTRIBUTES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17177423445965489.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Columna de Informe'
,p_lov_return_value=>'REPORT.COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17180127956042460.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Esquema de Autorizaci\00F3n')
,p_lov_return_value=>'AUTHORIZATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17181701739167324.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tema'
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17182812400265020.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de P\00E1gina')
,p_lov_return_value=>'TEMPLATE.PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23040505396709149.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de Regi\00F3n')
,p_lov_return_value=>'TEMPLATE.REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23059602943831450.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Lista'
,p_lov_return_value=>'TEMPLATE.LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23060207099832682.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Etiqueta'
,p_lov_return_value=>'TEMPLATE.LABEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23065614980853874.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'TEMPLATE.BREADCRUMB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23072813388938597.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Informe'
,p_lov_return_value=>'TEMPLATE.REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23111731368066835.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Calendario'
,p_lov_return_value=>'TEMPLATE.CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23112607258069299.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Lista de Valores Emergente'
,p_lov_return_value=>'TEMPLATE.POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23114220071073019.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de Bot\00F3n')
,p_lov_return_value=>'TEMPLATE.BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27856206573040810.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plugin'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27856417308043979.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Carga de Datos'
,p_lov_return_value=>'DATA.LOADING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27863524730206971.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mensaje de Texto'
,p_lov_return_value=>'TEXT.MESSAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30579828593361171.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Servicio Web'
,p_lov_return_value=>'WEB.SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(101938626726557494.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Impresi\00F3n de Regi\00F3n')
,p_lov_return_value=>'REGION PRINTING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(493071332668111886.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('C\00E1lculo de P\00E1gina')
,p_lov_return_value=>'PAGE.COMPUTATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_extend_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84881512912473090.4001)
,p_lov_name=>'APP EXTEND OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84881512912473090.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84881732492473090.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('P\00E1gina en blanco')))
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84881910860473091.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('P\00E1gina de conexi\00F3n')))
,p_lov_return_value=>'LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84882130890473091.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('P\00E1gina o componente de la aplicaci\00F3n')))
,p_lov_return_value=>'WIZARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_extend_options2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84884222524494810.4001)
,p_lov_name=>'APP EXTEND OPTIONS2'
,p_lov_query=>'.'||wwv_flow_api.id(84884222524494810.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84884418462494811.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('P\00E1gina en blanco')))
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84884606421494811.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('P\00E1gina de conexi\00F3n')))
,p_lov_return_value=>'LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84884814299494811.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('P\00E1gina o componente de la aplicaci\00F3n')))
,p_lov_return_value=>'WIZARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_groups_assigned_unassigned
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(92271115231446627.4001)
,p_lov_name=>'APP GROUPS ASSIGNED UNASSIGNED'
,p_lov_query=>'.'||wwv_flow_api.id(92271115231446627.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(92271314455446628.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'- Todo -'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(92271714863446629.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Asignado'
,p_lov_return_value=>'ASSIGNED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(92271520282446629.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'No Asignado'
,p_lov_return_value=>'UNASSIGNED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_print_server_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6801471089410875.4001)
,p_lov_name=>'APP PRINT SERVER TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(6801471089410875.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6802190151410888.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Impresi\00F3n nativa')
,p_lov_return_value=>'NATIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6802558698410888.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Servidor de impresi\00F3n remoto')
,p_lov_return_value=>'REMOTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6801733822410887.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Utilizar configuraci\00F3n de instancia')
,p_lov_return_value=>'INSTANCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_wizard_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(149548310855791684.4001)
,p_lov_name=>'APP WIZARD PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(149548310855791684.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149548517242791690.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina en Blanco')
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149548725452791693.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina de Informe')
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149548909667791693.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Informe con formulario de edici\00F3n en una segunda p\00E1gina')
,p_lov_return_value=>'REPORTANDFORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149549130170791694.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cuadr\00EDcula Interactiva Editable')
,p_lov_return_value=>'TABULARFORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149549303695791694.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Pantalla con Inserci\00F3n, Actualizaci\00F3n y Supresi\00F3n')
,p_lov_return_value=>'FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147022416546025322.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Maestro/Detalle de una Sola P\00E1gina')
,p_lov_return_value=>'MASTERDETAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618762604165647502.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('P\00E1gina de Gr\00E1ficos')
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236361118648814472.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('P\00E1gina de Vista de Lista')
,p_lov_return_value=>'LISTVIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236361514982816147.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Vista de Lista con Pantalla de Edici\00F3n en la Segunda P\00E1gina')
,p_lov_return_value=>'LISTVIEWANDFORM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_groups_and_unassigned_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(91658312614512198.4001)
,p_lov_name=>'APPLICATION GROUPS AND UNASSIGNED GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, id',
'  from (',
'select group_name, id, 2 ob',
'  from wwv_flow_application_groups ',
' where security_group_id = :flow_security_group_id ',
'union all',
'select ''- ''||wwv_flow_lang.system_message(''Unassigned'')||'' -'' group_name, -1 id, 1 ob',
'  from dual',
')',
'order by ob, group_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_logo_image_or_text
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(210991102136588089.4001)
,p_lov_name=>'APPLICATION LOGO IMAGE OR TEXT'
,p_lov_query=>'.'||wwv_flow_api.id(210991102136588089.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(210991321100588090.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Imagen'
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(210991511506588095.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Texto'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(238999874444009828.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Imagen y texto'
,p_lov_return_value=>'IT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239000212173009829.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461314228761951916.4001)
,p_lov_name=>'APPLICATION STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(461314228761951916.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461314410157951917.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461315009499955796.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No Disponible'
,p_lov_return_value=>'UNAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_themes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60317311466182536.4001)
,p_lov_name=>'APPLICATION THEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_themes_active
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8544631431632408.4001)
,p_lov_name=>'APPLICATION THEMES (ACTIVE)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id||''. '' ||t.theme_name as d,',
'       t.theme_id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_themes t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = i.flow_id',
'   and t.theme_id          = i.theme_id',
'   and t.security_group_id = :WORKSPACE_ID',
' order by i.display_seq'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(183877501727908015.4001)
,p_lov_name=>'APPLICATION TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(183877501727908015.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183877711618908017.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostrar Todo'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183877900209908017.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Hoja de C\00E1lculo Web')
,p_lov_return_value=>'WEBSHEET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183878115670908017.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Base de Datos'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_type_database_or_websheet
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461305204810840905.4001)
,p_lov_name=>'APPLICATION TYPE DATABASE OR WEBSHEET'
,p_lov_query=>'.'||wwv_flow_api.id(461305204810840905.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461305420164840905.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Base de Datos'
,p_lov_return_value=>'Database'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461305630940840907.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Hoja de C\00E1lculo Web')
,p_lov_return_value=>'Websheet'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_compatibility_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(207464823363457503.4001)
,p_lov_name=>'APPLICATION.COMPATIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(207464823363457503.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48215073577260787.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'21.2'
,p_lov_return_value=>'21.2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183105967630838029.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'19.2 / 20.1 / 20.2 / 21.1'
,p_lov_return_value=>'19.2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218606250087580379.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'19.1'
,p_lov_return_value=>'19.1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(610184552140315733.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'5.1 / 18.1 / 18.2'
,p_lov_return_value=>'5.1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4967401114954788.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'5.0'
,p_lov_return_value=>'5.0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(207465025563457504.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'4.2'
,p_lov_return_value=>'4.2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(207465319619457504.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'4.1'
,p_lov_return_value=>'4.1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(207465627664457504.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Anterior a 4.1'
,p_lov_return_value=>'4.0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_menus
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(149605524191093671.4001)
,p_lov_name=>'APPLICATION.MENUS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/applications
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15049727442569349.4001)
,p_lov_name=>'APPLICATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(100224418521422119.4001)
,p_lov_name=>'APPLICATION_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flows f',
' where security_group_id = 11 ',
'   and not exists ( select null',
'                      from wwv_flow_language_map',
'                     where translation_flow_id = f.id',
'                       and security_group_id = 11 )',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_view_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84241428998396992.4001)
,p_lov_name=>'APPLICATION_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(84241428998396992.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84241625056396993.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Detalle'
,p_lov_return_value=>'DETAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84241814483396993.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_acl_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(92479731157354006.4001)
,p_lov_name=>'APP_ACL_GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d,',
'       id r',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_auth_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1814979507688651821.4001)
,p_lov_name=>'APP_AUTH_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(1814979507688651821.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1814979824886651823.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cuentas de Application Express'
,p_lov_return_value=>'APEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1814980014644651823.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle Cloud Identity Management'
,p_lov_return_value=>'IDM'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(288183120240134690.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Variable de Cabecera HTTP'
,p_lov_return_value=>'HTTP_HEADER_VARIABLE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>' wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_HHEAD'') = ''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(288183408656134690.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Directorio LDAP'
,p_lov_return_value=>'LDAP'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>' wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_LDAP'') = ''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(288183730099134690.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Oracle Application Server Single Sign-On'
,p_lov_return_value=>'IAS_SSO'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>' wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_SSO'') = ''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_char_set
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86591912420238949.4001)
,p_lov_name=>'APP_CHAR_SET'
,p_lov_query=>'.'||wwv_flow_api.id(86591912420238949.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87520523148833682.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (US-ASCII)')
,p_lov_return_value=>'US-ASCII'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87520707773833682.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unicode (UTF8)'
,p_lov_return_value=>'UTF8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87520910595833682.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Occidental (Windows-1252)'
,p_lov_return_value=>'Windows-1252'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(87521104177833683.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Occidental (ISO-8859-1)'
,p_lov_return_value=>'iso-8859-1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_computation_points
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48425308522403722.4001)
,p_lov_name=>'APP_COMPUTATION_POINTS'
,p_lov_query=>'.'||wwv_flow_api.id(48425308522403722.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48425626846403752.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En una Nueva Instancia (nueva sesi\00F3n)')
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48425926823403752.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Despu\00E9s de Autenticaci\00F3n')
,p_lov_return_value=>'AFTER_LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48426208730403756.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Antes de Cabecera'
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48426516073403756.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Despu\00E9s de Cabecera')
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48426820582403756.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Antes de Regiones'
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48427107076403756.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Despu\00E9s de Regiones')
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48427419682403756.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Antes de Pie de P\00E1gina')
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48427721551403760.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Despu\00E9s de Pie de P\00E1gina')
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48428021631403760.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('Despu\00E9s de Ejecuci\00F3n')
,p_lov_return_value=>'AFTER_SUBMIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_copy_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84341526733632941.4001)
,p_lov_name=>'APP_COPY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84341526733632941.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(171495412485960439.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Temas de Interfaz de Usuario'
,p_lov_return_value=>'THEMES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84341707833632941.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Listas de Valores'
,p_lov_return_value=>'LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1435744414125343373.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Plugins'
,p_lov_return_value=>'PLUGIN'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84341922244632941.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Entradas de Barra de Navegaci\00F3n')
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84342129977632942.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Esquemas de Autorizaci\00F3n')
,p_lov_return_value=>'AUTHORIZATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(106274302385250184.4001)
,p_lov_disp_sequence=>1040
,p_lov_disp_value=>unistr('Esquemas de Autenticaci\00F3n')
,p_lov_return_value=>'AUTHENTICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_item_scope
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(211617631947367477.4001)
,p_lov_name=>'APP_ITEM_SCOPE'
,p_lov_query=>'.'||wwv_flow_api.id(211617631947367477.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(211617908937367477.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Aplicaci\00F3n')
,p_lov_return_value=>'APP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(211618207033367479.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Global'
,p_lov_return_value=>'GLOBAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_populate_roles
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177081808679947721.4001)
,p_lov_name=>'APP_POPULATE_ROLES'
,p_lov_query=>'.'||wwv_flow_api.id(177081808679947721.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177082156363947748.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Asignaciones de rol de usuario de control de acceso'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177082551234947749.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Esquema de Autenticaci\00F3n')
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177082986222947749.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('C\00F3digo personalizado')
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(367839101511546508.4001)
,p_lov_name=>'APP_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(367839101511546508.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367839421855546509.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Aplicaci\00F3n Est\00E1ndar')
,p_lov_return_value=>'STANDARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367839606331546509.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Plantilla de Aplicaci\00F3n')
,p_lov_return_value=>'TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367839807571546510.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Aplicaci\00F3n de Ejemplo')
,p_lov_return_value=>'SAMPLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_type_selection
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1427060334943927449.4001)
,p_lov_name=>'APP_TYPE_SELECTION'
,p_lov_query=>'.'||wwv_flow_api.id(1427060334943927449.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1427060547778927452.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Solo Aplicaciones de Base de Datos'
,p_lov_return_value=>'DATABASE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1427060827174927457.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Aplicaciones de Escritorio y Hojas de C\00E1lculo Web')
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1427061134601927458.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Solo Aplicaciones de Hoja de C\00E1lculo Web')
,p_lov_return_value=>'WEBSHEET'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_web_sources_for_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3852199756927887.4001)
,p_lov_name=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_wiz_chart_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161900516722838362.4001)
,p_lov_name=>'APP_WIZ_CHART_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(161900516722838362.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161900809488838368.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna 3D'
,p_lov_return_value=>'3DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618825618287796251.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Columna de Rango 3D'
,p_lov_return_value=>'Range3DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617394520554093313.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Columna Apilada 3D'
,p_lov_return_value=>'Stacked3DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617394723671094261.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Columna Apilada 3D (Porcentaje)'
,p_lov_return_value=>'3DSTACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161901023475838370.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Columna 2D'
,p_lov_return_value=>'2DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618825824520798054.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Columna de Rango 2D'
,p_lov_return_value=>'Range2DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617394927827095426.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Columna Apilada 2D'
,p_lov_return_value=>'Stacked2DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615715300950879723.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras 3D')
,p_lov_return_value=>'Horizontal3DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617395131982096613.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Columna Apilada 2D (Porcentaje)'
,p_lov_return_value=>'2DSTACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618826103873801635.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras de Rango 3D')
,p_lov_return_value=>'HorizontalRange3DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617404612290119346.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras Apiladas 3D')
,p_lov_return_value=>'StackedHorizontal3DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617404817138120730.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras Apiladas 3D (Porcentaje)')
,p_lov_return_value=>'3DHSTACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615715506838881495.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras 2D')
,p_lov_return_value=>'Horizontal2DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618826408029802793.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras de Rango 2D')
,p_lov_return_value=>'HorizontalRange2DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617405825103123010.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras Apiladas 2D')
,p_lov_return_value=>'StackedHorizontal2DColumn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(617406029951124372.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Gr\00E1fico de Barras Apiladas 2D (Porcentaje)')
,p_lov_return_value=>'2DHSTACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615716321729885785.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('L\00EDnea')
,p_lov_return_value=>'2DLine'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618826615301804931.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('Marcador de Dispersi\00F3n')
,p_lov_return_value=>'ScatterMarker'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615715710647882561.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Tarta 3D'
,p_lov_return_value=>'3DPie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615715914110883599.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tarta 2D'
,p_lov_return_value=>'2DPie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615716117573884523.4001)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Donut 2D'
,p_lov_return_value=>'2DDoughnut'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615716629694888045.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Dial'
,p_lov_return_value=>'GaugeChart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618827129500808965.4001)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Dial (Porcentaje)'
,p_lov_return_value=>'DIAL_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618826920842806469.4001)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Vela'
,p_lov_return_value=>'Candlestick'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618827332616809914.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Gantt de Proyecto'
,p_lov_return_value=>'ProjectGantt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(618827502965810767.4001)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Gantt de Recursos'
,p_lov_return_value=>'ResourceGantt'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_wiz_create_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161818726905576357.4001)
,p_lov_name=>'APP_WIZ_CREATE_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(161818726905576357.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161819017462576362.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00F3lo Lectura')
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161819201423576364.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lectura y Escritura'
,p_lov_return_value=>'RW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(192763415498955359.4001)
,p_lov_name=>'AUDIT ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(192763415498955359.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192763609015955370.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Insertar'
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192763829535955373.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Actualizar'
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192764030537955373.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Suprimir'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_naming
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(192773330531006109.4001)
,p_lov_name=>'AUDIT_NAMING'
,p_lov_query=>'.'||wwv_flow_api.id(192773330531006109.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192773504494006111.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Atributos de Aplicaci\00F3n')
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192773719028006113.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Plantilla de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192773912582006113.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Barra de Navegaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192774132498006113.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Proceso de Aplicaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192774324088006113.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento de Aplicaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192774507402006114.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00E1lculo de Aplicaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192774728974006114.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separadores'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192774924389006115.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separador Principal'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192775116232006115.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Valores'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES$'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192775308893006115.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Entrada de Lista de Valores'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES_DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192775506134006116.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Atributos de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192775729209006116.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192775914488006116.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcaci\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192776105194006116.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Argumentos de Bifurcaci\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCH_ARGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192776313341006117.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192776518774006117.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00E1lculo de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192776728927006117.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Validaci\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192776908821006117.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Proceso de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192777132334006118.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Plantilla de Regi\00F3n')
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192777326352006118.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plantilla de Fila'
,p_lov_return_value=>'WWV_FLOW_ROW_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192777504961006118.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plantilla de Lista'
,p_lov_return_value=>'WWV_FLOW_LIST_TEMPLATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192777704768006118.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Atributos de Regi\00F3n')
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192777913070006119.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mensajes'
,p_lov_return_value=>'WWV_FLOW_MESSAGES$'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192778131775006119.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Opciones de Creaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_PATCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192778311606006120.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Desarrolladores de Aplicaciones (Administraci\00F3n)')
,p_lov_return_value=>'WWV_FLOW_DEVELOPERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192778526631006120.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Listas'
,p_lov_return_value=>'WWV_FLOW_LISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192778710948006120.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elemento de Lista'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192778903034006120.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Identificador de Usuario Efectivo (Administraci\00F3n)')
,p_lov_return_value=>'WWV_FLOW_EFFECTIVE_USERID_MAP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192779106904006121.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('M\00E9todos Abreviados')
,p_lov_return_value=>'WWV_FLOW_SHORTCUTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192779305727006121.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Texto de Ayuda de Elemento de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_HELP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192779523562006121.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Configuraciones de Autenticaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_AUTHENTICATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192779703226006121.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Puntos de Entrada'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192779919153006122.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Argumentos de Punto de Entrada'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINT_ARGS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192814127076119594.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192918929997948694.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Temas'
,p_lov_return_value=>'WWV_FLOW_THEMES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_scheme_component_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(19565023708932258.4001)
,p_lov_name=>'AUTH SCHEME COMPONENT LIST'
,p_lov_query=>'.'||wwv_flow_api.id(19565023708932258.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4401945308904583.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Acci\00F3n Din\00E1mica')
,p_lov_return_value=>'WWV_FLOW_PAGE_DA_EVENTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4402224443904585.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Acci\00F3n din\00E1mica: acci\00F3n')
,p_lov_return_value=>'WWV_FLOW_PAGE_DA_ACTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19565408576932259.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00E1lculo de Aplicaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19565616823932259.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Entrada de Barra de Navegaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19565811243932259.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Entrada de Lista'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19566018968932260.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19566229367932260.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Proceso de Aplicaci\00F3n')
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19566425485932260.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcaci\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19566609500932260.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19566827943932260.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00E1lculo de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19567024556932261.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19567203422932261.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Proceso de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19567427523932261.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Validaci\00F3n de P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19567631501932261.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Separador Est\00E1ndar')
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19567802034932262.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separador Principal'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19568016566932263.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19664501543326267.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna de Informe'
,p_lov_return_value=>'WWV_FLOW_REGION_REPORT_COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19664915179339682.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_methods2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62983620392370890.4001)
,p_lov_name=>'AUTHENTICATION_METHODS2'
,p_lov_query=>'.'||wwv_flow_api.id(62983620392370890.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(124262609673589368.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Esquema (preparado para ejecutarse o creado por el usuario)'
,p_lov_return_value=>'CUSTOM2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62984185221370917.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'INTERNA (repositorio de cuenta local)'
,p_lov_return_value=>'COOKIE'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_schemes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(166264006489001223.4001)
,p_lov_name=>'AUTHENTICATION_SCHEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_flow_authentications',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_scheme_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(346988529123216543.4001)
,p_lov_name=>'AUTHENTICATION_SCHEME_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHENTICATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHENTICATION TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authorization_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11239432234132441.4001)
,p_lov_name=>'AUTHORIZATION TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHORIZATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHORIZATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHORIZATION TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authz_scheme_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84861720259380643.4001)
,p_lov_name=>'AUTHZ_SCHEME_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84861720259380643.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84861902602380643.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Consulta SQL Exists'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84862521867380644.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Consulta SQL NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84862132654380644.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Elemento en Expresi\00F3n 1 Nulo')
,p_lov_return_value=>'ITEM_IS_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84862305726380644.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Elemento en Expresi\00F3n 1 No Nulo')
,p_lov_return_value=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84862724485380644.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL que Devuelve Valor Booleano')
,p_lov_return_value=>'FUNCTION_RETURNING_BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84862924429380645.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Valor de Preferencia en Expresi\00F3n 1 Equivale a Expresi\00F3n 2')
,p_lov_return_value=>'PREFERENCE_EQ_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84863130627380645.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Valor de Preferencia en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2')
,p_lov_return_value=>'PREFERENCE_NOT_EQ_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84863509444380645.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Valor de Elemento en Expresi\00F3n 1 Equivale a Expresi\00F3n 2')
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84863327213380645.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Valor de Elemento en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2')
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND_TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_scheme_caching
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84860700520374929.4001)
,p_lov_name=>'AUTH_SCHEME_CACHING'
,p_lov_query=>'.'||wwv_flow_api.id(84860700520374929.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84861103921374931.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Una Vez por Sesi\00F3n')
,p_lov_return_value=>'BY_USER_BY_SESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84860914895374930.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Una Vez por Vista de P\00E1gina')
,p_lov_return_value=>'BY_USER_BY_PAGE_VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(360366921153074028.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Una Vez por Componente'
,p_lov_return_value=>'BY_COMPONENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(360367209904074033.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Siempre (Sin Almacenamiento en Cach\00E9)')
,p_lov_return_value=>'NOCACHE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_scheme_refresh
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86574617605164667.4001)
,p_lov_name=>'AUTH_SCHEME_REFRESH'
,p_lov_query=>'select wwv_flow_lang.system_message(''INITCAP_REFRESH'')  a,''Y'' b from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_wiz_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84347110372647083.4001)
,p_lov_name=>'AUTH_WIZ_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84347110372647083.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88152606479963512.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88152800735963512.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Como Copia de un Esquema de Autorizaci\00F3n Existente')
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1378606678543833.4001)
,p_lov_name=>'AUTOMATIONS'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'WWV_FLOW_AUTOMATIONS'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_all_result_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1356468048734066.4001)
,p_lov_name=>'AUTOMATION_ALL_RESULT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(1356468048734066.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1356737017734067.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Filas Devueltas'
,p_lov_return_value=>'ROWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1357181724734067.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No se ha devuelto ninguna fila'
,p_lov_return_value=>'NO_ROWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1357517577734067.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PL/SQL que devuelve valor booleano'
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1357960373734067.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_object_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1387977807801823.4001)
,p_lov_name=>'AUTOMATION_OBJECT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(1387977807801823.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1388285199801823.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Automatizaci\00F3n')
,p_lov_return_value=>'AUTOMATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1388637743801823.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Acci\00F3n de automatizaci\00F3n')
,p_lov_return_value=>'AUTOMATION ACTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_polling_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1358229692738259.4001)
,p_lov_name=>'AUTOMATION_POLLING_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(1358229692738259.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1358558106738259.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activo'
,p_lov_return_value=>'ACTIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1358916784738259.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'DISABLED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1359379608738259.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Desactivado (error)'
,p_lov_return_value=>'ERROR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_result_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601105473256773090.4001)
,p_lov_name=>'AUTOMATION_RESULT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601105473256773090.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601105601663773090.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Filas Devueltas'
,p_lov_return_value=>'ROWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601106078134773091.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Ninguna Fila Devuelta'
,p_lov_return_value=>'NO_ROWS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_trigger_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1355426926728029.4001)
,p_lov_name=>'AUTOMATION_TRIGGER_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1355426926728029.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1355759872728032.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('A Petici\00F3n')
,p_lov_return_value=>'API'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1356183046728033.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Programado'
,p_lov_return_value=>'POLLING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/axis_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84866925931391695.4001)
,p_lov_name=>'AXIS_INTERVAL'
,p_lov_query=>'.'||wwv_flow_api.id(84866925931391695.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84867111432391695.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Definir Intervalo de Eje'
,p_lov_return_value=>'DEFINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84867324796391696.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Mostrar Intervalo de Eje Autom\00E1ticamente')
,p_lov_return_value=>'AUTO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/Begin_on_new_line
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(67832807038215585.4001)
,p_lov_name=>'BEGIN ON NEW LINE'
,p_lov_query=>'.'||wwv_flow_api.id(67832807038215585.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(67833101831215595.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Empezar en Nueva L\00EDnea')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/Begin_on_new_field
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86067527340770119.4001)
,p_lov_name=>'BEGIN_ON_NEW_FIELD'
,p_lov_query=>'.'||wwv_flow_api.id(86067527340770119.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88282922464772458.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Empezar en Nuevo Campo'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_format_content_disposition_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(317509508537932808.4001)
,p_lov_name=>'BLOB_FORMAT_CONTENT_DISPOSITION_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLOB_FORMAT_ATTACHMENT'') d, ''Attachment'' r',
'     from dual',
'union',
'select wwv_flow_lang.system_message(''BLOB_FORMAT_INLINE'') d, ''Inline'' r',
'     from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_format_mask_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(317502218630715477.4001)
,p_lov_name=>'BLOB_FORMAT_MASK_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLOB_FORMAT_DOWNLOAD'') d, ''DOWNLOAD'' r',
'     from dual',
'union',
'select wwv_flow_lang.system_message(''BLOB_FORMAT_IMAGE'') d, ''IMAGE'' r',
'     from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/branch_points_condensed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(185544520425574805.4001)
,p_lov_name=>'BRANCH.POINTS.CONDENSED'
,p_lov_query=>'.'||wwv_flow_api.id(185544520425574805.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(185544824823574814.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Antes de C\00E1lculo')
,p_lov_return_value=>'BEFORE_COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(185545021461574815.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Antes de Validaci\00F3n')
,p_lov_return_value=>'BEFORE_VALIDATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(185545229692574815.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Antes de Procesamiento'
,p_lov_return_value=>'BEFORE_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(185545414740574816.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Despu\00E9s de Procesamiento')
,p_lov_return_value=>'AFTER_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(185545628448574816.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Antes de Cabecera'
,p_lov_return_value=>'BEFORE_HEADER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/breadcrumb_entry_or_container
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(205111517140679117.4001)
,p_lov_name=>'BREADCRUMB ENTRY OR CONTAINER'
,p_lov_query=>'.'||wwv_flow_api.id(205111517140679117.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205111902995679137.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205345212580624072.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'REGION'
,p_lov_template=>'#DISPLAY_VALUE#'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flow_menus where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id;'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_on_report_positions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(83332708448288963.4001)
,p_lov_name=>'BREAK.ON.REPORT.POSITIONS'
,p_lov_query=>'.'||wwv_flow_api.id(83332708448288963.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88283729044774273.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Primera Columna'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88283921634774274.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Primera y Segunda Columna'
,p_lov_return_value=>'1:2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88284111739774274.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Primera, Segunda y Tercera Columna'
,p_lov_return_value=>'1:2:3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86602811774267145.4001)
,p_lov_name=>'BREAK_COLUMNS'
,p_lov_query=>'.'||wwv_flow_api.id(86602811774267145.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88287205065786323.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Columna 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88287428523786324.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Columna 1 y 2'
,p_lov_return_value=>'1:2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88287603244786324.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Columna 1, 2 y 3'
,p_lov_return_value=>'1:2:3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_on_report_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84247004458418293.4001)
,p_lov_name=>'BREAK_ON_REPORT_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84247004458418293.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84247211888418294.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Primera Columna'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84247432172418294.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Primera y Segunda Columna'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84247624024418294.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Primera, Segunda y Tercera Columna'
,p_lov_return_value=>'123'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_type_flag
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84369008472684429.4001)
,p_lov_name=>'BREAK_TYPE_FLAG'
,p_lov_query=>'.'||wwv_flow_api.id(84369008472684429.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84369227840684431.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Repetir Cabeceras Divisorias'
,p_lov_return_value=>'REPEAT_HEADINGS_ON_BREAK_1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84369407631684431.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Formato de Divisi\00F3n por Defecto')
,p_lov_return_value=>'DEFAULT_BREAK_FORMATTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/browser_cache
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(875788205897309215.4001)
,p_lov_name=>'BROWSER_CACHE'
,p_lov_query=>'.'||wwv_flow_api.id(875788205897309215.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(875788522508309218.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activado'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(875788730295309223.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/browser_frame
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1098055005642193053.4001)
,p_lov_name=>'BROWSER_FRAME'
,p_lov_query=>'.'||wwv_flow_api.id(1098055005642193053.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1098055323316193055.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Denegar'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1098055511785193055.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Permitir del Mismo Origen'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1098055725585193055.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Permitir'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/build_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84305510710571518.4001)
,p_lov_name=>'BUILD_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(84305510710571518.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84305709177571518.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00F3lo Ejecutar Aplicaci\00F3n')
,p_lov_return_value=>'RUN_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84305911098571518.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Ejecutar y Crear Aplicaci\00F3n')
,p_lov_return_value=>'RUN_AND_BUILD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(43576623634636183.4001)
,p_lov_name=>'BUTTON THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(43576623634636183.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43576912701636189.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43584317316653265.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n, Alternativa 1')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43584619394653936.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n, Alternativa 2')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44139910490884391.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n, Alternativa 3')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43588706496669090.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43592228791685003.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43592532254685982.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43592802256686769.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43593427883694186.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43593729961694767.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43594031692695331.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43594301695696066.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'13'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(147003111936901406.4001)
,p_lov_name=>'BUTTON.ATTRIBUTES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES ) ba, rtrim(BUTTON_CATTRIBUTES ) r',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_is_reset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84945521447891923.4001)
,p_lov_name=>'BUTTON.IS.RESET'
,p_lov_query=>'.'||wwv_flow_api.id(84945521447891923.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84945714043891924.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bot\00F3n para Restablecer')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/buttons_current_and_global_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6214918033450806.4001)
,p_lov_name=>'BUTTONS_CURRENT_AND_GLOBAL_PAGE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :FB_FLOW_PAGE_ID',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:FB_FLOW_PAGE_ID, ui.global_page_id)',
'         order by x, bn ',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(458463318087925002.4001)
,p_lov_name=>'BUTTON_ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(458463318087925002.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(458465032417938534.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Ejecutar P\00E1gina')
,p_lov_return_value=>'SUBMIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(458463516386925008.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Redirigir a P\00E1gina en esta Aplicaci\00F3n')
,p_lov_return_value=>'REDIRECT_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(393410308299183569.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Redirigir a P\00E1gina en una Aplicaci\00F3n Diferente')
,p_lov_return_value=>'REDIRECT_APP'
,p_lov_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_lov_disp_cond=>'4314'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(458463707481925009.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Redirigir a URL'
,p_lov_return_value=>'REDIRECT_URL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2217226943030013.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('Definida por Acci\00F3n Din\00E1mica')
,p_lov_return_value=>'DEFINED_BY_DA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(460984115025005702.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Descargar Versi\00F3n para Impresora de Consulta de Informe')
,p_lov_return_value=>'REPORT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_SHARED_QUERIES',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id',
'   and :APP_PAGE_ID = 4732'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3791885581293.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Restablecer P\00E1gina')
,p_lov_return_value=>'RESET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3791888582683.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('P\00E1gina Siguiente (EN DESUSO)')
,p_lov_return_value=>'NEXT_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3791891583799.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('P\00E1gina Anterior (EN DESUSO)')
,p_lov_return_value=>'PREVIOUS_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_alignment_body
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1791921829301402873.4001)
,p_lov_name=>'BUTTON_ALIGNMENT_BODY'
,p_lov_query=>'.'||wwv_flow_api.id(1791921829301402873.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791928140531406086.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Centro'
,p_lov_return_value=>'CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791992121273442944.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Centro inferior'
,p_lov_return_value=>'CENTER-BOTTOM'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791992586609442944.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Centro centro'
,p_lov_return_value=>'CENTER-CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791992941985442945.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Centro superior'
,p_lov_return_value=>'CENTER-TOP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791922115849402875.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791994711029455023.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Inicio (Inferior)'
,p_lov_return_value=>'LEFT-BOTTOM'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791995189708455023.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Inicio (Centro)'
,p_lov_return_value=>'LEFT-CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791995570954455023.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Inicio (Superior)'
,p_lov_return_value=>'LEFT-TOP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791922578885402875.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'RIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791995970458455024.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Fin (Inferior)'
,p_lov_return_value=>'RIGHT-BOTTOM'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791996381262455024.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Fin (Centro)'
,p_lov_return_value=>'RIGHT-CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1791996791436455025.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Fin (Superior)'
,p_lov_return_value=>'RIGHT-TOP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_alignment_l_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84754827158805413.4001)
,p_lov_name=>'BUTTON_ALIGNMENT_L_R'
,p_lov_query=>'.'||wwv_flow_api.id(84754827158805413.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84755030664805414.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84755202951805414.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_display_positions2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62990572348595109.4001)
,p_lov_name=>'BUTTON_DISPLAY_POSITIONS2'
,p_lov_query=>'.'||wwv_flow_api.id(62990572348595109.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62990815665595115.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Antes del T\00EDtulo de la P\00E1gina')
,p_lov_return_value=>'LEFT_OF_TITLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62991037953595115.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Despu\00E9s del T\00EDtulo de la P\00E1gina')
,p_lov_return_value=>'RIGHT_OF_TITLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62991212359595118.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Encima de la Regi\00F3n')
,p_lov_return_value=>'ABOVE_BOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62991440121595118.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Parte Superior de la Regi\00F3n')
,p_lov_return_value=>'TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62991617521595119.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Parte Inferior de la Regi\00F3n')
,p_lov_return_value=>'BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62991820415595119.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Partes Superior e Inferior de la Regi\00F3n')
,p_lov_return_value=>'TOP_AND_BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62992017822595122.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Debajo de la Regi\00F3n')
,p_lov_return_value=>'BELOW_BOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62992218359595123.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Posici\00F3n #DEFAULT# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'TEMPLATE_DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(92320911107933644.4001)
,p_lov_disp_sequence=>9.5
,p_lov_disp_value=>unistr('Posici\00F3n #CHANGE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CHANGE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where (p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CHANGE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id) '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62992810843595124.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Posici\00F3n #CLOSE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CLOSE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CLOSE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93091020144798464.4001)
,p_lov_disp_sequence=>10.1
,p_lov_disp_value=>unistr('Posici\00F3n #COPY# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_COPY'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#COPY#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62992615015595124.4001)
,p_lov_disp_sequence=>10.2
,p_lov_disp_value=>unistr('Posici\00F3n #CREATE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CREATE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94882719481696997.4001)
,p_lov_disp_sequence=>10.3
,p_lov_disp_value=>unistr('Posici\00F3n #CREATE2# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CREATE2'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE2#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(92332909801949409.4001)
,p_lov_disp_sequence=>10.5
,p_lov_disp_value=>unistr('Posici\00F3n #DELETE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_DELETE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#DELETE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62992414762595123.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Posici\00F3n #EDIT# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_EDIT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EDIT#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62993052778595124.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Posici\00F3n #EXPAND# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_EXPAND'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EXPAND#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62993213440595125.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Posici\00F3n #HELP# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_HELP'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#HELP#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91088720180648151.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('Posici\00F3n #NEXT# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_NEXT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#NEXT#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91089316514649842.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Posici\00F3n #PREVIOUS# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_PREVIOUS'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#PREVIOUS#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138976531453546871.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Barra de B\00FAsqueda a la Derecha del Informe Interactivo')
,p_lov_return_value=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624319995418870652.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Cuerpo'
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_display_positions_p4314
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1905973109443967318.4001)
,p_lov_name=>'BUTTON_DISPLAY_POSITIONS_P4314'
,p_lov_query=>'.'||wwv_flow_api.id(1905973109443967318.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905973494553967321.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Antes del T\00EDtulo de la P\00E1gina')
,p_lov_return_value=>'LEFT_OF_TITLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905973847440967326.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Despu\00E9s del T\00EDtulo de la P\00E1gina')
,p_lov_return_value=>'RIGHT_OF_TITLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905974225968967326.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Encima de la Regi\00F3n')
,p_lov_return_value=>'ABOVE_BOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905974643088967327.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Parte Superior de la Regi\00F3n')
,p_lov_return_value=>'TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905975001534967328.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Parte Inferior de la Regi\00F3n')
,p_lov_return_value=>'BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905975451050967328.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Partes Superior e Inferior de la Regi\00F3n')
,p_lov_return_value=>'TOP_AND_BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905975896920967328.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Debajo de la Regi\00F3n')
,p_lov_return_value=>'BELOW_BOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905976264022967329.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Posici\00F3n #DEFAULT# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'TEMPLATE_DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905976604330967330.4001)
,p_lov_disp_sequence=>9.5
,p_lov_disp_value=>unistr('Posici\00F3n #CHANGE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CHANGE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where (p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CHANGE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id) '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905977013205967330.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Posici\00F3n #CLOSE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CLOSE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CLOSE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905977454417967330.4001)
,p_lov_disp_sequence=>10.1
,p_lov_disp_value=>unistr('Posici\00F3n #COPY# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_COPY'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#COPY#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905977884980967330.4001)
,p_lov_disp_sequence=>10.2
,p_lov_disp_value=>unistr('Posici\00F3n #CREATE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CREATE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905978269729967331.4001)
,p_lov_disp_sequence=>10.3
,p_lov_disp_value=>unistr('Posici\00F3n #CREATE2# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_CREATE2'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE2#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905978605947967331.4001)
,p_lov_disp_sequence=>10.5
,p_lov_disp_value=>unistr('Posici\00F3n #DELETE# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_DELETE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#DELETE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905979000705967331.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Posici\00F3n #EDIT# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_EDIT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EDIT#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905979400972967331.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Posici\00F3n #EXPAND# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_EXPAND'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EXPAND#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905979808782967331.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Posici\00F3n #HELP# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_HELP'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#HELP#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905980225496967331.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('Posici\00F3n #NEXT# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_NEXT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#NEXT#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905980687897967331.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Posici\00F3n #PREVIOUS# de Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION_TEMPLATE_PREVIOUS'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#PREVIOUS#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905981095145967332.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Barra de B\00FAsqueda a la Derecha del Informe Interactivo')
,p_lov_return_value=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1905981421062967332.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Cuerpo'
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86073927602789091.4001)
,p_lov_name=>'BUTTON_STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(86073927602789091.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88291012122797801.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bot\00F3n HTML')
,p_lov_return_value=>'HTML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88291203722797802.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Bot\00F3n Basado en Plantilla')
,p_lov_return_value=>'BUTTON_TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88291406025797802.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Imagen'
,p_lov_return_value=>'IMAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_tag_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159064700887669967.4001)
,p_lov_name=>'BUTTON_TAG_ATTRIBUTES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct TAG_ATTRIBUTES d, tag_attributes r',
'from wwv_flow_step_items',
'where flow_id = :fb_flow_id and DISPLAY_AS = ''BUTTON''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_template
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86577503884170242.4001)
,p_lov_name=>'BUTTON_TEMPLATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id r',
'from   wwv_flow_button_templates',
'where  flow_id = :fb_flow_id and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(template_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_template_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(287725102195676672.4001)
,p_lov_name=>'BUTTON_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(287725102195676672.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(287725414983676674.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(287725628953676674.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Directo'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86072317559786247.4001)
,p_lov_name=>'BUTTON_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''HTML_BUTTON'') d,''TEXT'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''TEMPLATE_DRIVEN'') d, ''TEMPLATE'' r from dual where exists (select 1 from wwv_flow_button_templates where flow_id = :FB_FLOW_ID) ',
'union all',
'select initcap(wwv_flow_lang.system_message(''IMAGE'')) d,''IMAGE'' r from dual order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cache_mode_page_and_region
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22602312173782467.4001)
,p_lov_name=>'CACHE_MODE (PAGE AND REGION)'
,p_lov_query=>'.'||wwv_flow_api.id(22602312173782467.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22602526326782467.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'NOCACHE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22602720414782468.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Activado'
,p_lov_return_value=>'CACHE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22602908361782468.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cach\00E9 por Usuario')
,p_lov_return_value=>'USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(672312620996057364.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Cach\00E9 por Sesi\00F3n')
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/caching_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225840272947805161.4001)
,p_lov_name=>'CACHING_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(225840272947805161.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225840584522805162.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Para todos los usuarios'
,p_lov_return_value=>'ALL_USERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225840998538805162.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Por Usuario'
,p_lov_return_value=>'USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225841321120805163.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Por Sesi\00F3n')
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cal_display_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(37322928139444048.4001)
,p_lov_name=>'CAL.DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(37322928139444048.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37323215840444057.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna'
,p_lov_return_value=>'COL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37323417633444059.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'CUS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37323623070444059.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Ning\00FAn Valor de Visualizaci\00F3n')
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_item_link_open_in
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(412002629772063159.4001)
,p_lov_name=>'CALENDAR ITEM LINK OPEN IN'
,p_lov_query=>'.'||wwv_flow_api.id(412002629772063159.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(412002801622063164.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Misma Ventana'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(412003126365063165.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Ventana Emergente'
,p_lov_return_value=>'P'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(43619531898960304.4001)
,p_lov_name=>'CALENDAR THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43619801874960319.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43621609988960339.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Calendario, Alternativa 1'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(52331910898784713.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Calendario Peque\00F1o')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43620000338960319.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43620205626960337.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43620400113960337.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43620604334960337.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43620830451960338.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43621023248960338.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43621201713960338.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43621428586960338.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'11'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_date_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(597767214994667976.4001)
,p_lov_name=>'CALENDAR_DATE_FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(597767214994667976.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(597767532504667980.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00F3lo Fecha')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(597767714309667984.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Fecha y Hora'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113156910229994686.4001)
,p_lov_name=>'CALENDAR_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.STANDARD_CALENDAR'') d, ''S'' r from dual union all',
'select wwv_flow_lang.system_message(''CONFIRM.PARTIAL_REFRESH_CALENDAR'') d, ''A'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cards_layout_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12784439638072063.4001)
,p_lov_name=>'CARDS_LAYOUT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(12784439638072063.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12785155574072076.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cuadr\00EDcula')
,p_lov_return_value=>'GRID'
,p_lov_template=>'#DISPLAY_VALUE#|card-grid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12785568359072076.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Flotante'
,p_lov_return_value=>'FLOAT'
,p_lov_template=>'#DISPLAY_VALUE#|card-float'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12785968016072076.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Horizontal (fila)'
,p_lov_return_value=>'ROW'
,p_lov_template=>'#DISPLAY_VALUE#|card-row'
);
end;
/
prompt --application/shared_components/user_interface/lovs/case_sensitive
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(574890434307383427.4001)
,p_lov_name=>'CASE SENSITIVE'
,p_lov_query=>'.'||wwv_flow_api.id(574890434307383427.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(574890771059383430.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Sensible a may\00FAsculas/min\00FAsculas')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/catalog_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2707908862132331.4001)
,p_lov_name=>'CATALOG_GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv',
'from WWV_WEB_SRC_CATALOG_GROUPS',
'where security_group_id = :WORKSPACE_ID',
'order by name'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_query_table=>'WWV_WEB_SRC_CATALOG_GROUPS'
,p_return_column_name=>'RV'
,p_display_column_name=>'DV'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_bar_color
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84324431881606062.4001)
,p_lov_name=>'CHART_BAR_COLOR'
,p_lov_query=>'.'||wwv_flow_api.id(84324431881606062.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84324600310606063.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Negro'
,p_lov_return_value=>'BLACK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84324819442606063.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Azul'
,p_lov_return_value=>'BLUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84325003884606064.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Marr\00F3n')
,p_lov_return_value=>'BROWN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84325217038606064.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Verde'
,p_lov_return_value=>'GREEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84325407670606064.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Naranja'
,p_lov_return_value=>'ORANGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84325609277606064.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Morado'
,p_lov_return_value=>'PURPLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84325828072606065.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Rojo'
,p_lov_return_value=>'RED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84326022893606065.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Amarillo'
,p_lov_return_value=>'YELLOW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_label_opts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84785018266011049.4001)
,p_lov_name=>'CHART_LABEL_OPTS'
,p_lov_query=>'.'||wwv_flow_api.id(84785018266011049.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84785213250011049.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostrar Burbuja'
,p_lov_return_value=>'BUBBLE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84785432162011050.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mostrar Valor'
,p_lov_return_value=>'VALUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_link_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(193530927208786945.4001)
,p_lov_name=>'CHART_LINK_COLUMN'
,p_lov_query=>'.'||wwv_flow_api.id(193530927208786945.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(193531126012786958.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enlace a Destino Personalizado'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(193531303307786960.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Usar Valor de Columna LINK'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_query_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2944917074050416.4001)
,p_lov_name=>'CHART_QUERY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(2944917074050416.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2945205253050420.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Realizar Validaci\00F3n de Consultas')
,p_lov_return_value=>'PARSE_CHART_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2945401126050421.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Guardar Consulta sin Validar'
,p_lov_return_value=>'IGNORE_CHART_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_theme
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84770023535917923.4001)
,p_lov_name=>'CHART_THEME'
,p_lov_query=>'.'||wwv_flow_api.id(84770023535917923.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84770217422917924.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Aspecto 1'
,p_lov_return_value=>'RED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84770421612917924.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Aspecto 2'
,p_lov_return_value=>'ARG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84770630757917924.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Aspecto 3'
,p_lov_return_value=>'LOOK_3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_wizard_dial_maxvalue
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(249428101086098299.4001)
,p_lov_name=>'CHART_WIZARD_DIAL_MAXVALUE'
,p_lov_query=>'.'||wwv_flow_api.id(249428101086098299.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249428318833098301.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'100%'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249457015809140458.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'MAX'
,p_lov_return_value=>'MAX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249457621350142006.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SUM'
,p_lov_return_value=>'SUM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_show_page_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(145937328496747754.4001)
,p_lov_name=>'CHECKBOX SHOW PAGE COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(145937328496747754.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(145937826343747822.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Componentes de P\00E1gina')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_show_shared_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(144512500887046057.4001)
,p_lov_name=>'CHECKBOX SHOW SHARED COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(144512500887046057.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144512826218046101.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Componentes Compartidos'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_show_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(152029513350781444.4001)
,p_lov_name=>'CHECKBOX SHOW TEMPLATES'
,p_lov_query=>'.'||wwv_flow_api.id(152029513350781444.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152029929235781496.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plantillas'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_update_all_strings
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(149088633646846887.4001)
,p_lov_name=>'CHECKBOX_UPDATE_ALL_STRINGS'
,p_lov_query=>'.'||wwv_flow_api.id(149088633646846887.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149088975938846888.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Actualizar las &P704_COUNT. incidencias de esta cadena'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_yes_noprompt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84718210763776190.4001)
,p_lov_name=>'CHECKBOX_YES_NOPROMPT'
,p_lov_query=>'.'||wwv_flow_api.id(84718210763776190.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84718405875776191.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_y_noprompt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84715102189754797.4001)
,p_lov_name=>'CHECKBOX_Y_NOPROMPT'
,p_lov_query=>'.'||wwv_flow_api.id(84715102189754797.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84715319258754797.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/check_all
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84334521061621823.4001)
,p_lov_name=>'CHECK_ALL'
,p_lov_query=>'.'||wwv_flow_api.id(84334521061621823.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84334731772621824.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'CHECK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/choose_page_type_p259
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21148926321786721.4001)
,p_lov_name=>'CHOOSE_PAGE_TYPE_P259'
,p_lov_query=>'.'||wwv_flow_api.id(21148926321786721.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15949709341550987.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina en Blanco')
,p_lov_return_value=>'BLANK'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-blank'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21149204648786725.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#|native-sql-report'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21149614655786727.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Pantalla'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27291240406742869.4001)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>'Maestro/Detalle'
,p_lov_return_value=>'MD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-master-detail'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_PAGE_TYPE = ''PAGE'' and',
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''MASTER_DETAIL'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(809524612783878190.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Plugins'
,p_lov_return_value=>'PLUGIN'
,p_lov_template=>'#DISPLAY_VALUE#|plugin'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21149424262786726.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#|native-flash-chart5'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2001654404894012.4001)
,p_lov_disp_sequence=>52
,p_lov_disp_value=>'Mapa'
,p_lov_return_value=>'MAP_REGION'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-map'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33699164280412023.4001)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Panel de Control'
,p_lov_return_value=>'DASHBOARD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-dashboard'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21150022003786727.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-calendar'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21150200501786727.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'TREE'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-JSTREE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_PAGE_TYPE = ''PAGE'' and (',
'wwv_flow_user_interface_dev.supports_feature ( ',
'       p_user_interface_id => :P259_USER_INTERFACE_ID,',
'       p_name              => ''JSTREE'' )',
'or :P259_SHOW_UNSUPPORTED = ''Y'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20260312249878297.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Carga de Datos'
,p_lov_return_value=>'DATALOAD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-data-loading'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_PAGE_TYPE = ''PAGE'' and (',
'wwv_flow_user_interface_dev.supports_feature ( ',
'       p_user_interface_id => :P259_USER_INTERFACE_ID,',
'       p_name              => ''DATA_LOADING'' )',
'or :P259_SHOW_UNSUPPORTED = ''Y'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21149822778786727.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Asistente'
,p_lov_return_value=>'WIZARD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-wizard'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3240924233313161.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>unistr('P\00E1gina Global')
,p_lov_return_value=>'GLOBAL'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-global'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_user_interfaces',
' where id             = :P259_USER_INTERFACE_ID',
'   and flow_id        = :FB_FLOW_ID',
'   and global_page_id is null',
'   and :P259_PAGE_TYPE = ''PAGE'''))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(562132756869367211.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('P\00E1gina Heredada')
,p_lov_return_value=>'LEGACY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''PAGE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8678021377313480.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>'Control de Acceso'
,p_lov_return_value=>'ACCESSCONTROL'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-access-control'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'nvl(:P259_PAGE_TYPE,''X'') = ''FEATURE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16040025645782722.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>unistr('P\00E1gina de Conexi\00F3n')
,p_lov_return_value=>'LOGIN'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-login'
,p_lov_disp_cond_type=>'NOT_EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_steps',
'  where page_component_map = 12',
'    and user_interface_id = :P259_USER_INTERFACE_ID',
'    and flow_id =  :FB_FLOW_ID',
'    and security_group_id = :WORKSPACE_ID',
'    and :P259_PAGE_TYPE = ''PAGE'''))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(96683075561618717.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>unistr('Informes de correo electr\00F3nico')
,p_lov_return_value=>'EMAILREPORTING'
,p_lov_template=>'#DISPLAY_VALUE#| icon-envelope'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''FEATURE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(96683337624618719.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>'Informes de trabajo'
,p_lov_return_value=>'JOBREPORTING'
,p_lov_template=>'#DISPLAY_VALUE#| icon-database-object'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_jobs_dev',
' where owner = (select owner',
'                  from wwv_flows',
'                 where id = :FB_FLOW_ID',
'                   and security_group_id = :FLOW_SECURITY_GROUP_ID)',
'   and :P259_PAGE_TYPE = ''FEATURE'''))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(196186932485762243.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>'Comentarios'
,p_lov_return_value=>'FEEDBACK'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-feedback'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''FEATURE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(645390692062221400.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>unistr('Selecci\00F3n de estilo de tema')
,p_lov_return_value=>'THEMESELECTION'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sc-ui'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''FEATURE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(645391959842230222.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>'Informes de actividad'
,p_lov_return_value=>'ACTIVITYREPORTING'
,p_lov_template=>'#DISPLAY_VALUE#| icon-util-developer-activity'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''FEATURE'' '
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(662212992416408184.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>unistr('Opciones de Configuraci\00F3n')
,p_lov_return_value=>'CONFIGOPTIONS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-item-native-checkbox'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''FEATURE'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(662216621039470829.4001)
,p_lov_disp_sequence=>2000
,p_lov_disp_value=>unistr('Acerca de la P\00E1gina')
,p_lov_return_value=>'ABOUTAPP'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-help-text'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P259_PAGE_TYPE = ''FEATURE'''
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_heading_sort
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113075615286820438.4001)
,p_lov_name=>'COLUMN_HEADING_SORT'
,p_lov_query=>'.'||wwv_flow_api.id(113075615286820438.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113075923766820443.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Usar Ordenaci\00F3n de Cabecera de Columna')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_link_checksum_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(106733132624028207.4001)
,p_lov_name=>'COLUMN_LINK_CHECKSUM_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(106733132624028207.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(106733331539028208.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Nivel de Aplicaci\00F3n: Enlace reutilizable por parte de cualquier usuario')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(106733500292028209.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nivel de Usuario: Enlace reutilizable por parte del usuario actual'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84700223258656794.4001)
,p_lov_name=>'COLUMN_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84700223258656794.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84700401229656794.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Derivado de Columnas de Consulta'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84700609402656795.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Columnas Gen\00E9ricas')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_width_units
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(137868513981838198.4001)
,p_lov_name=>'COLUMN_WIDTH_UNITS'
,p_lov_query=>'.'||wwv_flow_api.id(137868513981838198.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137868804503838258.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Porcentaje'
,p_lov_return_value=>'PERCENTAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137869020870838259.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Punto'
,p_lov_return_value=>'POINTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/comment_mgt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131122619933750813.4001)
,p_lov_name=>'COMMENT MGT'
,p_lov_query=>'.'||wwv_flow_api.id(131122619933750813.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131122805830750820.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suprimir Todos los Comentarios'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131123017423750828.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Suprimir Todos los Comentarios del Desarrollador'
,p_lov_return_value=>'DEVELOPER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131123206286750828.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Suprimir Comentarios por Fecha'
,p_lov_return_value=>'DATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/component_export_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(377667910269420728.4001)
,p_lov_name=>'COMPONENT EXPORT TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, type_name',
'  from wwv_flow_appl_component_types',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'TYPE_NAME'
,p_display_column_name=>'DISPLAY_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DISPLAY_NAME'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/component_export_types_no_app_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(219174618713592113.4001)
,p_lov_name=>'COMPONENT EXPORT TYPES (NO APP ATTRIBUTES)'
,p_lov_query=>'.'||wwv_flow_api.id(219174618713592113.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27856632677057884.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plugin'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27863315726204362.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mensaje de Texto'
,p_lov_return_value=>'MESSAGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42344010960230413.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Carga de Datos'
,p_lov_return_value=>'DATA LOADING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(68335292197942905.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Servidor remoto'
,p_lov_return_value=>'REMOTE SERVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(68335681892942906.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Credencial'
,p_lov_return_value=>'CREDENTIAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88136025596580349.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Consulta de Informe'
,p_lov_return_value=>'SHARED QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88136305988584229.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Dise\00F1o de Informe')
,p_lov_return_value=>'REPORT LAYOUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(160795105281345158.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Origen de Datos de REST'
,p_lov_return_value=>'WEB SOURCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219174814389592127.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219175013995592129.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219175232752592129.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de Bot\00F3n')
,p_lov_return_value=>'BUTTON TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219175403520592129.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de Regi\00F3n')
,p_lov_return_value=>'REGION TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219175624120592129.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Lista'
,p_lov_return_value=>'LIST TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219175816990592129.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Informe'
,p_lov_return_value=>'REPORT TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219176032395592130.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Etiqueta'
,p_lov_return_value=>'LABEL TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219176207318592130.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219176423240592130.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Lista de Valores Emergente'
,p_lov_return_value=>'POPUP LOV TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219176631734592130.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantilla de Calendario'
,p_lov_return_value=>'CALENDAR TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219176806484592131.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('M\00E9todo Abreviado')
,p_lov_return_value=>'SHORTCUTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219177013573592131.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantilla de P\00E1gina')
,p_lov_return_value=>'PAGE TEMPLATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219177221576592131.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219177427540592131.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Separador'
,p_lov_return_value=>'TAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219177604186592131.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lista de Valores'
,p_lov_return_value=>'LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219177807693592132.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Separador Principal'
,p_lov_return_value=>'PARENT TAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219178031878592132.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entrada de Barra de Navegaci\00F3n')
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219178207428592132.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Esquema de Autorizaci\00F3n')
,p_lov_return_value=>'SECURITY SCHEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219178405025592132.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'TREE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219178614268592132.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Proceso de Aplicaci\00F3n')
,p_lov_return_value=>'APP PROCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219178830557592133.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Elemento de Aplicaci\00F3n')
,p_lov_return_value=>'APP ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219179018777592133.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('C\00E1lculo de Aplicaci\00F3n')
,p_lov_return_value=>'APP COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219179226730592133.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB ENTRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219179423538592133.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Servicio Web'
,p_lov_return_value=>'WEB SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219179610668592133.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Esquema de Autenticaci\00F3n')
,p_lov_return_value=>'AUTH SETUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(219179805578592134.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Opci\00F3n de Creaci\00F3n')
,p_lov_return_value=>'BUILD OPTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(683805038458933638.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Valor de aplicaci\00F3n')
,p_lov_return_value=>'APP SETTING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(727757877803458898.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Rol de control de acceso a la aplicaci\00F3n')
,p_lov_return_value=>'APP ACL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/computation_item
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86610204202293298.4001)
,p_lov_name=>'COMPUTATION_ITEM'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''APPLICATION'')||'': ''||name d, name v',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select wwv_flow_lang.system_message(''PAGE'')||'': ''||flow_step_id||'' ''||name d, name v',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/condition_control_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179476200494904933.4001)
,p_lov_name=>'CONDITION CONTROL TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(179476200494904933.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179477608235904943.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcaci\00F3n')
,p_lov_return_value=>'BRANCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179492924267978066.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179477001828904942.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('C\00E1lculo')
,p_lov_return_value=>'COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179476801795904940.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Elemento'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179477429719904942.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Proceso'
,p_lov_return_value=>'PROCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179476625958904939.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179477227849904942.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Validaci\00F3n')
,p_lov_return_value=>'VALIDATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/condition_check
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(435017812694464482.4001)
,p_lov_name=>'CONDITION_CHECK'
,p_lov_query=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(435018014601464492.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('No validar el c\00F3digo (analizar c\00F3digo s\00F3lo en tiempo de ejecuci\00F3n).')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/confirm_component_removal
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(54171005356999729.4001)
,p_lov_name=>'CONFIRM_COMPONENT_REMOVAL'
,p_lov_query=>'.'||wwv_flow_api.id(54171005356999729.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(54171311988999730.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED: eliminar componentes')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/consolidate_template_names_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(94009001670849130.4001)
,p_lov_name=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/content_delivery_network
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16362507680404890.4001)
,p_lov_name=>'CONTENT DELIVERY NETWORK'
,p_lov_query=>'.'||wwv_flow_api.id(16362507680404890.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16362719475404893.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Google'
,p_lov_return_value=>'GOOGLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16362912968404893.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Microsoft'
,p_lov_return_value=>'MICROSOFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16363119553404893.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'jQuery'
,p_lov_return_value=>'JQUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/content_disposition
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(137375920403903467.4001)
,p_lov_name=>'CONTENT_DISPOSITION'
,p_lov_query=>'.'||wwv_flow_api.id(137375920403903467.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137376221863903468.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Adjunto'
,p_lov_return_value=>'ATTACHMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137376416435903468.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('En L\00EDnea')
,p_lov_return_value=>'INLINE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_asynch_action_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(108520683650237775.4001)
,p_lov_name=>'COPY ASYNCH ACTION OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(108520683650237775.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108520999008237765.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Acci\00F3n as\00EDncrona en esta aplicaci\00F3n')
,p_lov_return_value=>'SAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108521351556237764.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Acci\00F3n as\00EDncrona en otra aplicaci\00F3n')
,p_lov_return_value=>'DIFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_list_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(231048823449529621.4001)
,p_lov_name=>'COPY LIST OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(231048823449529621.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(231049006115529624.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista en esta aplicaci\00F3n')
,p_lov_return_value=>'SAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(231049208911529628.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Lista en otra aplicaci\00F3n')
,p_lov_return_value=>'DIFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_lists
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(10919919806296646.4001)
,p_lov_name=>'COPY LISTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists ',
' where flow_id = v(''FB_FLOW_ID'') ',
'   and id <> :P477_COPY_LIST_FROM',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
' order by 1',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_page_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(200992128346618114.4001)
,p_lov_name=>'COPY_PAGE_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(200992128346618114.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200992325093618118.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina en esta aplicaci\00F3n')
,p_lov_return_value=>'SAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(200992505592618121.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('P\00E1gina en otra aplicaci\00F3n')
,p_lov_return_value=>'DIFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_sc_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(201061511357162008.4001)
,p_lov_name=>'COPY_SC_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(201061511357162008.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201061731765162010.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No Copiar'
,p_lov_return_value=>'NO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201061913763162012.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Copiar'
,p_lov_return_value=>'COPY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201062131688162012.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Usar Existente'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9000141896148406.4001)
,p_lov_name=>'COPY_SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(9000141896148406.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9000407308148423.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Esta aplicaci\00F3n')
,p_lov_return_value=>'THIS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9000858936148423.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Otra aplicaci\00F3n')
,p_lov_return_value=>'OTHER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_application_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(59753909083040661.4001)
,p_lov_name=>'CREATE APPLICATION OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(59753909083040661.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40660315892684513.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Nueva Aplicaci\00F3n')
,p_lov_return_value=>'DBAPP'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84640459791812785.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Desde una hoja de c\00E1lculo')
,p_lov_return_value=>'SPREADSHEET'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-create-app-websheet'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40660629052688301.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Hoja de C\00E1lculo Web')
,p_lov_return_value=>'WEBSHEET'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-create-app-websheet'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40660901478689821.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Aplicaci\00F3n de productividad')
,p_lov_return_value=>'PKGAPP'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-create-app-pkg-apps'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_application_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(139812219112455338.4001)
,p_lov_name=>'CREATE APPLICATION PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(139812219112455338.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139812423391455342.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Agregar P\00E1gina en Blanco a Aplicaci\00F3n')
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139813830194458580.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Agregar Informe'
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(386128979761969541.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Agregar Informe de Tabla de Reflujo'
,p_lov_return_value=>'REFLOWTABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(386129452191973929.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Agregar Informe de Conmutaci\00F3n de Columnas')
,p_lov_return_value=>'COLUMNTOGGLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139812618398455343.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Agregar informe con formulario de edici\00F3n en una segunda p\00E1gina')
,p_lov_return_value=>'REPORTANDFORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(228985906117785632.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('Agregar Vista de Lista con Pantalla de Edici\00F3n en una Segunda P\00E1gina')
,p_lov_return_value=>'LISTVIEWANDFORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139812820281455343.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Agregar una Cuadr\00EDcula Interactiva Editable')
,p_lov_return_value=>'TABULARFORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139813027803455343.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Agregar Pantalla con Inserci\00F3n, Actualizaci\00F3n y Supresi\00F3n')
,p_lov_return_value=>'FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(111750431837325937.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Agregar Maestro/Detalle de una Sola P\00E1gina')
,p_lov_return_value=>'MASTERDETAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615632927102875004.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Agregar Gr\00E1fico')
,p_lov_return_value=>'CHART'
,p_lov_disp_cond=>'(:APP_USER = ''HILARY'')'
,p_lov_disp_cond2=>'HILARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(236338032309717022.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Agregar Vista de Lista'
,p_lov_return_value=>'LISTVIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_cal_type2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(637546843740095966.4001)
,p_lov_name=>'CREATE CAL TYPE2'
,p_lov_query=>'.'||wwv_flow_api.id(637546843740095966.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(637547104132095967.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendario Heredado'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(637547448261095970.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CSSCALENDAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_install_script_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4579300425024699.4001)
,p_lov_name=>'CREATE INSTALL SCRIPT OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(4579300425024699.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4579506061024700.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Crear Nuevo'
,p_lov_return_value=>'SCRATCH'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-blank'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4579908206024701.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Crear desde Archivo'
,p_lov_return_value=>'FILE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-blank'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(534084776604619224.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Crear a Partir de Objeto de Base de Datos'
,p_lov_return_value=>'DB'
,p_lov_template=>'#DISPLAY_VALUE#| icon-database-object'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P850_MODE'
,p_lov_disp_cond2=>'UPGRADE:DEINSTALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1602302547430022.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Paquete de datos'
,p_lov_return_value=>'DATA'
,p_lov_template=>'#DISPLAY_VALUE#| icon-util-apex-views'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 18'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_multiple_items_p256
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162048107844243840.4001)
,p_lov_name=>'CREATE MULTIPLE ITEMS P256'
,p_lov_query=>'.'||wwv_flow_api.id(162048107844243840.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162048426183243882.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Campo de Texto'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162048628552243882.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('\00C1rea de Texto')
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162048825522243882.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Casilla de Control'
,p_lov_return_value=>'CHECKBOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162049013715243883.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Grupo de Botones de Radio'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162049424562243883.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Oculto'
,p_lov_return_value=>'HIDDEN_PROTECTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_tree_from_table_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(94457102341894843.4001)
,p_lov_name=>'CREATE TREE FROM TABLE LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P112_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_app_auth_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(175155625648607577.4001)
,p_lov_name=>'CREATE.APP.AUTH.OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.CLOUD_IDM'') d ,''CLOUD_IDM'' v from dual',
'where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'')d ,:PRODUCT_NAME v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.SSO'') d ,''SSO'' v from dual',
'where wwv_flow_authentication_dev.can_use_sso_yn = ''Y''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'') d,''DBACCOUNT'' v',
'from dual',
'where wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'') d,''DATABASE'' v from dual',
')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_cal_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16354319751573808.4001)
,p_lov_name=>'CREATE.CAL.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(16354319751573808.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(389128299383656476.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CSSCALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CSS-CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16354825012573816.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Calendario Heredado'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CALENDAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_flow_auth_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(52256503410339865.4001)
,p_lov_name=>'CREATE.FLOW.AUTH.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(52256503410339865.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(52257006525339871.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Autenticaci\00F3n de Application Express')
,p_lov_return_value=>'HTML DB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(52257200649339871.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Sin Autenticaci\00F3n')
,p_lov_return_value=>'DATABASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_region_chart_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(59940502744006894.4001)
,p_lov_name=>'CREATE.REGION.CHART.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(59940502744006894.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59940825061006894.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Gr\00E1fico HTML<br /><a href="f?p=4000:4016:&SESSION.::::P4016_SOURCE_TYPE:SIMPLE_CHART"><img src="#IMAGE_PREFIX#wwv_example_chart.gif" alt=Gr\00E1fico HTML" height="115" width="140"></a>')
,p_lov_return_value=>'SIMPLE_CHART'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_region_report_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(59918611599848626.4001)
,p_lov_name=>'CREATE.REGION.REPORT.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(59918611599848626.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76763631583167906.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Informe Interactivo'
,p_lov_return_value=>'IRR'
,p_lov_template=>'#DISPLAY_VALUE#|native-ir'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P181_REGION_TYPE = ''REPORT''',
'and wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_name              => ''INTERACTIVE_REPORT'' )',
''))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59918906003848628.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Informe Cl\00E1sico')
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#|native-sql-report'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''CLASSIC_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10802610245671765.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Vista de Lista'
,p_lov_return_value=>'LISTVIEW'
,p_lov_template=>'#DISPLAY_VALUE#|native-jqm-list-view'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'           p_user_interface_id => :P259_USER_INTERFACE_ID,',
'           p_name              => ''JQM_LIST_VIEW'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(653899240632953552.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Informe de Conmutaci\00F3n de Columnas')
,p_lov_return_value=>'COLUMNTOGGLE'
,p_lov_template=>'#DISPLAY_VALUE#|native-jqm-column-toggle'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''JQM_COLUMN_TOGGLE'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(360378100712086268.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Informe de Reflujo'
,p_lov_return_value=>'REFLOW'
,p_lov_template=>'#DISPLAY_VALUE#|native-jqm-reflow'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''JQM_REFLOW_TABLE'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32036408472068130.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Resultado de Servicio Web'
,p_lov_return_value=>'WEBSERVICE'
,p_lov_template=>'#DISPLAY_VALUE#|native-sql-report'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_region_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(59797407819674174.4001)
,p_lov_name=>'CREATE.REGION.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(59797407819674174.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59797715581674175.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Contenido Est\00E1tico')
,p_lov_return_value=>'BLANK'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16128700870012129.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Varios Contenidos Est\00E1ticos')
,p_lov_return_value=>'MULTIPLE'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59798114152674175.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-SQL-REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25496822963244246.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Pantalla'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33173307277765071.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Plugins'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5427307791424375.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'JSTREE'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-JSTREE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''JSTREE'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16271616260345715.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59798531129674176.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-LIST'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from WWV_FLOW_LISTS where flow_id = :fb_flow_id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59798712525674176.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'MENU'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-BREADCRUMB'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from WWV_FLOW_MENUS where flow_id = :fb_flow_id and 1 = 2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16132517193045207.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'MENUREGION'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-BREADCRUMB'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from WWV_FLOW_MENUS where flow_id = :fb_flow_id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59798906900674177.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('Contenido Din\00E1mico PL/SQL')
,p_lov_return_value=>'PLSQL_PROCEDURE'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5429217488427188.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
,p_lov_template=>'#DISPLAY_VALUE#|native-url'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22347623933545778.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_lov_return_value=>'RDS'
,p_lov_template=>'#DISPLAY_VALUE#|native-display-selector'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38870528920787636.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Texto de Ayuda'
,p_lov_return_value=>'HELP_TEXT'
,p_lov_template=>'#DISPLAY_VALUE#|native-help-text'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_tabs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84948109242907300.4001)
,p_lov_name=>'CREATE.TABS'
,p_lov_query=>'.'||wwv_flow_api.id(84948109242907300.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84948313600907300.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ning\00FAn Separador')
,p_lov_return_value=>'NO_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84948509310907301.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Un Nivel de Separadores'
,p_lov_return_value=>'SINGLE_LEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84948706961907301.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Dos Niveles de Separadores'
,p_lov_return_value=>'TWO_LEVEL_TABS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_template_opts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88108326304250090.4001)
,p_lov_name=>'CREATE.TEMPLATE.OPTS'
,p_lov_query=>'.'||wwv_flow_api.id(88108326304250090.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88108531928250090.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seleccione uno del repositorio de &PRODUCT_NAME.'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
,p_lov_disp_cond=>'161'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88108720351250091.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88108928823250091.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_app_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(238931611476537918.4001)
,p_lov_name=>'CREATE_APP_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(238931611476537918.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(238931830914537923.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Empezar desde el Principio'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24117720307079483.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Incluir P\00E1gina Inicial')
,p_lov_return_value=>'INCLUDE_HOME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(238932009935537927.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Usar Modelo de Aplicaci\00F3n Creado Previamente')
,p_lov_return_value=>'MODEL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_button_loc
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84893616038549667.4001)
,p_lov_name=>'CREATE_BUTTON_LOC'
,p_lov_query=>'.'||wwv_flow_api.id(84893616038549667.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84894000323549667.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Crear Bot\00F3n en una Posici\00F3n de la Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84893831137549667.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Crear Bot\00F3n Mostrado entre los Elementos de esta Regi\00F3n')
,p_lov_return_value=>'ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_edit_build_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84363508688675017.4001)
,p_lov_name=>'CREATE_EDIT_BUILD_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84363508688675017.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84363715344675017.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Todas las Opciones'
,p_lov_return_value=>'ALL_OPTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84363903362675018.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Opciones Excluidas'
,p_lov_return_value=>'EXCLUDED_OPTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84364127083675018.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Opciones Incluidas'
,p_lov_return_value=>'INCLUDED_OPTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_page_wiz_report_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(229526604906633214.4001)
,p_lov_name=>'CREATE_PAGE_WIZ_REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(229526604906633214.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(229526903566633217.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Informe Interactivo'
,p_lov_return_value=>'INTERACTIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(229527314006633219.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Informe Cl\00E1sico')
,p_lov_return_value=>'CLASSIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(229527755815633220.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Informe Basado en Servicio Web'
,p_lov_return_value=>'WEBSERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246582799020000524.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Cuadr\00EDcula Interactiva')
,p_lov_return_value=>'GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2492748530737796.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('B\00FAsqueda por facetas')
,p_lov_return_value=>'FACETED_SEARCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4700607937986792.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Tarjetas'
,p_lov_return_value=>'CARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1500806028588547.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Mapa'
,p_lov_return_value=>'MAP_REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4501933264264256.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Filtros inteligentes'
,p_lov_return_value=>'SMART_FILTERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_ws_auth_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460639712672013129.4001)
,p_lov_name=>'CREATE_WS_AUTH_OPTIONS'
,p_reference_id=>174618728240220381.4001
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  :product_name||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/admin_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d ,''HTML DB'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/opendoor_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DATABASE'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/dbauth_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DBACCOUNT'' v from dual)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/credentials_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(154078822199034715.4001)
,p_lov_name=>'CREDENTIALS_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(154079142215034718.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Autenticaci\00F3n B\00E1sica')
,p_lov_return_value=>'BASIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(154079510909034719.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Flujo de credenciales de cliente de OAuth2'
,p_lov_return_value=>'OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(549452051899386464.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Token Web JSON'
,p_lov_return_value=>'JWT'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1341457865820980.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Infraestructura de Oracle Cloud (OCI)'
,p_lov_return_value=>'OCI'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 18'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1701546541659999.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Par de claves privada/de certificado'
,p_lov_return_value=>'CERTIFICATE_PAIR'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_platform.get_preference(''SAML_ENABLED'')=''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1800745749591458.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Cabecera HTTP'
,p_lov_return_value=>'HTTP_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1801015961593233.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Cadena de consulta de URL'
,p_lov_return_value=>'HTTP_QUERY_STRING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/css_categories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2672426264055159.4001)
,p_lov_name=>'CSS CATEGORIES'
,p_lov_query=>'.'||wwv_flow_api.id(2672426264055159.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2672601779055159.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tama\00F1os Absolutos')
,p_lov_return_value=>'ABSOLUTE SIZES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2672821707055159.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tama\00F1os Relativos')
,p_lov_return_value=>'RELATIVE SIZES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2686105588181625.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Etiquetas de Anclaje'
,p_lov_return_value=>'ANCHOR TAGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/current_page_only
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(574892035638384809.4001)
,p_lov_name=>'CURRENT PAGE ONLY'
,p_lov_query=>'.'||wwv_flow_api.id(574892035638384809.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(574892359277384813.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Solo p\00E1gina actual')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/customizable_opts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84780904844988257.4001)
,p_lov_name=>'CUSTOMIZABLE_OPTS'
,p_lov_query=>'.'||wwv_flow_api.id(84780904844988257.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84781129653988258.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizable y No Mostrado por Defecto'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84781315535988258.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Personalizable y Mostrado por Defecto'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84781523668988259.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'No Personalizable por Usuarios Finales'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dashboard_chart_aggregate
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(657384343573981564.4001)
,p_lov_name=>'DASHBOARD_CHART_AGGREGATE'
,p_lov_query=>'.'||wwv_flow_api.id(657384343573981564.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657384641982981565.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Valor de columna'
,p_lov_return_value=>'COLVALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657385056655981565.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Suma'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657385482368981565.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Recuento'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dashboard_chart_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(657346995959744232.4001)
,p_lov_name=>'DASHBOARD_CHART_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(657346995959744232.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657347261583744232.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea')
,p_lov_return_value=>'area'
,p_lov_template=>'<span class="a-Icon icon-region-chart-area" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657347677252744233.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Barra'
,p_lov_return_value=>'bar'
,p_lov_template=>'<span class="a-Icon icon-region-chart-bar" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657350049661744234.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('L\00EDnea')
,p_lov_return_value=>'line'
,p_lov_template=>'<span class="a-Icon icon-region-chart-line" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(657350886473744235.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tarta'
,p_lov_return_value=>'pie'
,p_lov_template=>'<span class="a-Icon icon-region-chart-pie" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_case_sensitivity_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15543021487067885.4001)
,p_lov_name=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15543516355067889.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15543328204067888.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_skip_validation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(380391855980609161.4001)
,p_lov_name=>'DATA LOAD SKIP VALIDATION'
,p_lov_query=>'.'||wwv_flow_api.id(380391855980609161.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(380392176743609168.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(380392454037609170.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_table_names
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(371957315073004609.4001)
,p_lov_name=>'DATA LOAD TABLE NAMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, TABLE_NAME return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where name = :P1801_NAME order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_loading_rules_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(141003727830690827.4001)
,p_lov_name=>'DATA LOADING RULES TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(141003727830690827.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141004022216690828.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('A May\00FAsculas')
,p_lov_return_value=>'TO_UPPER_CASE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141004200887690829.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('A Min\00FAsculas')
,p_lov_return_value=>'TO_LOWER_CASE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141004413247690829.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sustituir'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141004630986690829.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Recorte'
,p_lov_return_value=>'TRIM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(675452628395802315.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Recortar a la Izquierda'
,p_lov_return_value=>'LTRIM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(675463400475803720.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Recortar a la Derecha'
,p_lov_return_value=>'RTRIM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141004815818690829.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('\00DAnico Espacio en Blanco')
,p_lov_return_value=>'SINGLE_WHITESPACES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141005014039690829.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Expresi\00F3n PLSQL')
,p_lov_return_value=>'PLSQL_EXPRESSION'
,p_required_patch=>-wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141005230162690829.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('Expresi\00F3n Regular')
,p_lov_return_value=>'REGULAR_EXPRESSION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13800125404733346.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cuerpo de Funci\00F3n PL/SQL')
,p_lov_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13800313005733348.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'SQL_QUERY_SINGLE_VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13800507980733349.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Consulta SQL (devolver valores separados por dos puntos)'
,p_lov_return_value=>'SQL_QUERY_SEMI_COLON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_loading_tables_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15574010985556882.4001)
,p_lov_name=>'DATA LOADING TABLES LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, ID return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_create_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3313626961776680.4001)
,p_lov_name=>'DATA.LOAD.CREATE_METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(3313626961776680.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3313925521776688.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nueva'
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3314383794776689.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Como copia de una definici\00F3n de carga de datos existente')
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_col_delimiter
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1963861252255121.4001)
,p_lov_name=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov_query=>'.'||wwv_flow_api.id(1963861252255121.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1964152277255145.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>','
,p_lov_return_value=>','
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1964578744255147.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>';'
,p_lov_return_value=>';'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1964926636255147.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'|'
,p_lov_return_value=>'|'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1965387007255150.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'#'
,p_lov_return_value=>'#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1965775882255150.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'tabulador'
,p_lov_return_value=>'tab'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_enclosed_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1966044064255150.4001)
,p_lov_name=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov_query=>'.'||wwv_flow_api.id(1966044064255150.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1966448886255152.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'None'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1966850775255152.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'"'
,p_lov_return_value=>'"'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1967240441255152.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>''''
,p_lov_return_value=>''''
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_data_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2505800285473362.4001)
,p_lov_name=>'DATA.LOAD.DATA_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(2505800285473362.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2506199905473375.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Archivo'
,p_lov_return_value=>'FILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2506506206473376.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Pegar datos delimitados'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_error_handling
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2102956113429319.4001)
,p_lov_name=>'DATA.LOAD.ERROR_HANDLING'
,p_lov_query=>'.'||wwv_flow_api.id(2102956113429319.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2103697193429319.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ignorar'
,p_lov_return_value=>'IGNORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2103238683429319.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Parar'
,p_lov_return_value=>'ABORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2104081805429319.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Registrar error en recopilaci\00F3n')
,p_lov_return_value=>'LOG_ROWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4800818508627308.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Registrar en log de errores'
,p_lov_return_value=>'ERROR_LOG'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P1820_TARGET_TYPE'
,p_lov_disp_cond2=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_first_line
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1311667928909742.4001)
,p_lov_name=>'DATA.LOAD.FIRST_LINE'
,p_lov_query=>'.'||wwv_flow_api.id(1311667928909742.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1311961412909759.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('La primera l\00EDnea contiene cabeceras')
,p_lov_return_value=>'HEADERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2101544010414427.4001)
,p_lov_name=>'DATA.LOAD.METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(2101544010414427.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2102263743414445.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Agregar'
,p_lov_return_value=>'APPEND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2101835504414444.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Fusionar'
,p_lov_return_value=>'MERGE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P1820_TARGET_TYPE'
,p_lov_disp_cond2=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2102647126414445.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Sustituir'
,p_lov_return_value=>'REPLACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_sample_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1805213661837379.4001)
,p_lov_name=>'DATA.LOAD.SAMPLE_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1805213661837379.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1805549653837381.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cargar Archivo'
,p_lov_return_value=>'FILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1805939151837382.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copiar y Pegar'
,p_lov_return_value=>'COPY_PASTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_selector_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5203249727555533.4001)
,p_lov_name=>'DATA.LOAD.SELECTOR_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(5203249727555533.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5203574623555536.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nombre'
,p_lov_return_value=>'NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5203977449555537.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Secuencia'
,p_lov_return_value=>'SEQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(580688454483788977.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Expresi\00F3n Regular')
,p_lov_return_value=>'REGEXP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_target_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1633774479940540.4001)
,p_lov_name=>'DATA.LOAD.TARGET_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1633774479940540.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1634008299940542.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabla'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1634440835940544.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Recopilaci\00F3n')
,p_lov_return_value=>'COLLECTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_transform_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4818478622110870.4001)
,p_lov_name=>'DATA.LOAD.TRANSFORM_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(4818478622110870.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4818717517110876.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Expresi\00F3n SQL')
,p_lov_return_value=>'SQL_EXPRESSION'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4819193073110876.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'SQL_QUERY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4819525559110876.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Recortar a la Izquierda'
,p_lov_return_value=>'LTRIM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4819919107110877.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Recortar a la Derecha'
,p_lov_return_value=>'RTRIM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4820398208110877.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Recorte'
,p_lov_return_value=>'TRIM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4820732892110877.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Sustituir'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4821110204110877.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('A Min\00FAsculas')
,p_lov_return_value=>'LOWER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4821569297110877.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('A May\00FAsculas')
,p_lov_return_value=>'UPPER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4821998789110877.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Null If'
,p_lov_return_value=>'NULLIF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4822345396110877.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Expresi\00F3n regular Replace')
,p_lov_return_value=>'REGEXP_REPLACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4822789377110878.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Expresi\00F3n regular Null If')
,p_lov_return_value=>'REGEXP_NULLIF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/database_action_button_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(147433904650386326.4001)
,p_lov_name=>'DATABASE_ACTION BUTTON LOV'
,p_lov_query=>'.'||wwv_flow_api.id(147433904650386326.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147434227021386334.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Acci\00F3n INSERT de SQL')
,p_lov_return_value=>'INSERT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147434419098386340.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Acci\00F3n UPDATE de SQL')
,p_lov_return_value=>'UPDATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147434607832386340.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Acci\00F3n DELETE de SQL')
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_profile_col_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(242159593404725778.4001)
,p_lov_name=>'DATA_PROFILE_COL_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(242159593404725778.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(242159828107725785.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Datos'
,p_lov_return_value=>'DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4815028055049796.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Consulta'
,p_lov_return_value=>'LOOKUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(242160239919725788.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Expresi\00F3n SQL')
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4815374705052172.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'SQL_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_profile_data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225929676126476839.4001)
,p_lov_name=>'DATA_PROFILE_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(225929676126476839.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225929903268476840.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225930368549476840.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225930744436476841.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225931138522476841.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225931522008476841.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225931923485476841.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249232043458816550.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1700989732317797.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Geometr\00EDa (SDO_GEOMETRY)')
,p_lov_return_value=>'SDO_GEOMETRY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_utilities.db_version_is_at_least(''12.2'') and wwv_flow_db_version.c_has_locator'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(263573975956906615.4001)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Documento JSON'
,p_lov_return_value=>'DOCUMENT_FRAGMENT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_utilities.db_version_is_at_least(''12.1'')'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_profile_date_format_masks
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225940310284555905.4001)
,p_lov_name=>'DATA_PROFILE_DATE_FORMAT_MASKS'
,p_lov_query=>'.'||wwv_flow_api.id(225940310284555905.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225940649643555906.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'2016-12-01'
,p_lov_return_value=>'YYYY-MM-DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225941017139555907.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2016-12-01T20:00:00'
,p_lov_return_value=>'YYYY-MM-DD"T"HH24:MI:SS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225941432549555907.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'2016-12-02T20:00:00.516'
,p_lov_return_value=>'YYYY-MM-DD"T"HH24:MI:SS.FF3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225941811998555907.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'2016-12-02T20:00:00.516Z'
,p_lov_return_value=>'YYYY-MM-DD"T"HH24:MI:SS.FF3TZR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4412319045213134.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'$5,234.10'
,p_lov_return_value=>'FML999G999G999G999G990D00'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4412618495214033.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'5,234.10'
,p_lov_return_value=>'999G999G999G999G990D00'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4412945048216241.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5,234'
,p_lov_return_value=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4413218817217822.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'-5,234.10'
,p_lov_return_value=>'S999G999G999G999G990D00'
);
end;
/
prompt --application/shared_components/user_interface/lovs/date_format_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460719917105668922.4001)
,p_lov_name=>'DATE_FORMAT_LOV'
,p_reference_id=>460140315153255042.4001
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/days_of_the_week
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(185376216434149048.4001)
,p_lov_name=>'DAYS OF THE WEEK'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'   select to_char(to_date(''19721105'',''YYYYMMDD''),''Day'') d,19721105 r from dual',
'   union all',
'   select to_char(to_date(''19721106'',''YYYYMMDD''),''Day''),19721106 from dual',
'   union all',
'   select to_char(to_date(''19721107'',''YYYYMMDD''),''Day''),19721107 from dual',
'   union all',
'   select to_char(to_date(''19721108'',''YYYYMMDD''),''Day''),19721108 from dual',
'   union all',
'   select to_char(to_date(''19721109'',''YYYYMMDD''),''Day''),19721109 from dual',
'   union all',
'   select to_char(to_date(''19721110'',''YYYYMMDD''),''Day''),19721110 from dual',
'   union all',
'   select to_char(to_date(''19721111'',''YYYYMMDD''),''Day''),19721111 from dual',
')',
'order by 2 '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_column_items
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(156839505926131127.4001)
,p_lov_name=>'DB.COLUMN.ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name a,name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :fb_flow_id',
'',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'',
'and security_group_id = :flow_security_group_id',
'',
'and source_type = ''DB_COLUMN'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deep_linking
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(34319101845334424.4001)
,p_lov_name=>'DEEP_LINKING'
,p_lov_query=>'.'||wwv_flow_api.id(34319101845334424.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34319403683334426.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activado'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34319716050334427.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/default_error_display_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(191207805708435328.4001)
,p_lov_name=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_api.id(191207805708435328.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191208023843435360.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En L\00EDnea con Campo y en Notificaci\00F3n')
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191208231710435370.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('En L\00EDnea con Campo')
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191208402756435370.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('En L\00EDnea en Notificaci\00F3n')
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deinstall_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17717826931614902.4001)
,p_lov_name=>'DEINSTALL OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(17717826931614902.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17718426349614906.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('No Realizar Ninguna Acci\00F3n')
,p_lov_return_value=>'NOT_ACCEPTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37670813248983399.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Suprimir Definici\00F3n de Aplicaci\00F3n')
,p_lov_return_value=>'DROP_APP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17718232517614906.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Borrar Objetos de Base de Datos'
,p_lov_return_value=>'DROP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17718011536614905.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Borrar Objetos de Base de Datos y Suprimir Definici\00F3n de Aplicaci\00F3n')
,p_lov_return_value=>'DROP_AND_DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/delete_application_actions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15857613201776764.4001)
,p_lov_name=>'DELETE APPLICATION ACTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(15857613201776764.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15857829844776765.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ejecutar Script de Desinstalaci\00F3n de la Aplicaci\00F3n (recomendado)')
,p_lov_return_value=>'SCRIPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15858025445776766.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Suprimir Definici\00F3n de Aplicaci\00F3n')
,p_lov_return_value=>'DEL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/delete_corresponding_list_entries
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(139182915633902523.4001)
,p_lov_name=>'DELETE CORRESPONDING LIST ENTRIES'
,p_lov_query=>'.'||wwv_flow_api.id(139182915633902523.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139183129828902528.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED: Suprimir Entradas de Lista Correspondientes')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(139183303567902531.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No: No Suprimir Entradas de Lista Correspondientes'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/delete_assoc_tabs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84243720472403985.4001)
,p_lov_name=>'DELETE_ASSOC_TABS'
,p_lov_query=>'.'||wwv_flow_api.id(84243720472403985.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84243909960403986.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No: No Suprimir Separadores Correspondientes'
,p_lov_return_value=>'NO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84244120450403986.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('S\00ED: Suprimir cualquier Separador Asociado')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deployment_build_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(19372012243626156.4001)
,p_lov_name=>'DEPLOYMENT BUILD OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name||'' (''||wwv_flow_lang.system_message(patch_status)||'')'' d, id r ',
'  from wwv_flow_patches ',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deployment_license_acceptance
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(110337521891120166.4001)
,p_lov_name=>'DEPLOYMENT LICENSE ACCEPTANCE'
,p_lov_query=>'.'||wwv_flow_api.id(110337521891120166.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110337709187120166.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Acepto'
,p_lov_return_value=>'ACCEPTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(110337913130120172.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No Acepto'
,p_lov_return_value=>'NOT_ACCEPTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/developers_with_comments
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(125707019629972839.4001)
,p_lov_name=>'DEVELOPERS WITH COMMENTS'
,p_lov_query=>'select distinct created_by d, created_by r from wwv_flow_app_comments where flow_id = :fb_flow_id order by upper(created_by)'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dialog_page_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(44400703264122475.4001)
,p_lov_name=>'DIALOG_PAGE_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(44400703264122475.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44401020446122476.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'NORMAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44401312153122478.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cuadro de Di\00E1logo Modal')
,p_lov_return_value=>'MODAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44401624389122478.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Cuadro de Di\00E1logo No Modal')
,p_lov_return_value=>'NON_MODAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dialog_page_mode_create_wizard
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1497542689968615899.4001)
,p_lov_name=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov_query=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1497542930985615927.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'NORMAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1497543374287615927.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cuadro de Di\00E1logo Modal')
,p_lov_return_value=>'MODAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dialog_page_mode_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(887851591470130537.4001)
,p_lov_name=>'DIALOG_PAGE_MODE_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(887851591470130537.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(887851822217130538.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cuadro de Di\00E1logo Modal')
,p_lov_return_value=>'MODAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(887852157397130546.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cuadro de Di\00E1logo No Modal')
,p_lov_return_value=>'NON_MODAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_3d_graph_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88110219855257765.4001)
,p_lov_name=>'DISPLAY.3D.GRAPH.Y'
,p_lov_query=>'.'||wwv_flow_api.id(88110219855257765.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88110415537257766.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Mostrar Gr\00E1fico 3D')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_default_when
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(89803912916156290.4001)
,p_lov_name=>'DQ_COLUMN_DEFAULT_WHEN'
,p_lov_query=>'.'||wwv_flow_api.id(89803912916156290.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89804223419156291.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Al crear o actualizar filas sin ning\00FAn valor proporcionado')
,p_lov_return_value=>'WHEN_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89804424514156291.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('S\00F3lo al crear nuevas filas')
,p_lov_return_value=>'WHEN_INSERTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(135655901614273908.4001)
,p_lov_name=>'DQ_COLUMN_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(135655901614273908.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197867120372745037.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ocultar'
,p_lov_return_value=>'HIDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135656201051273908.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ordenar'
,p_lov_return_value=>'SORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135656409479273908.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Filtro'
,p_lov_return_value=>'FILTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47292224899070718.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Resaltar'
,p_lov_return_value=>'HIGHLIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135656630770273909.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Divisi\00F3n de Control')
,p_lov_return_value=>'BREAK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135656816892273909.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Agregar'
,p_lov_return_value=>'AGGREGATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135657009007273909.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Calcular'
,p_lov_return_value=>'COMPUTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135657212463273909.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1542409404810451.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Agrupar por'
,p_lov_return_value=>'GROUP_BY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367035115416400374.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Din\00E1mica')
,p_lov_return_value=>'PIVOT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_group_show
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(90206330144997352.4001)
,p_lov_name=>'DQ_COLUMN_GROUP_SHOW'
,p_lov_query=>'.'||wwv_flow_api.id(90206330144997352.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(90206602571997357.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Todas las Columnas'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(90206830794997359.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Columnas no Asignadas'
,p_lov_return_value=>'UNASSIGNED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_lov_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(89795021349092520.4001)
,p_lov_name=>'DQ_COLUMN_LOV_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(89795021349092520.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89795329939092520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Valores de Columna Distintos'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89795515067092520.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Dominio de Valores Est\00E1tico')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(89661604165746991.4001)
,p_lov_name=>'DQ_COLUMN_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(89661604165746991.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89661921597746991.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cadena	'
,p_lov_return_value=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89662130353746991.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('N\00FAmero')
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89662330603746991.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Fecha'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89662503487746992.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Documento'
,p_lov_return_value=>'DOCUMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89662722742746992.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Calculado'
,p_lov_return_value=>'COMPUTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91733204209169832.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Enlace de Detalle'
,p_lov_return_value=>'DETAIL_LINK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_detail_page_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93896321430905901.4001)
,p_lov_name=>'DQ_DETAIL_PAGE_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(93896321430905901.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93896600582905901.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Permitir Exclusi\00F3n de Valores Nulos')
,p_lov_return_value=>'EXCLUDE_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93896828769905901.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Permitir Columnas Mostradas'
,p_lov_return_value=>'HIDE_EXTR_COL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_display_in_def_rpt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(94105402933265699.4001)
,p_lov_name=>'DQ_DISPLAY_IN_DEF_RPT'
,p_lov_query=>'.'||wwv_flow_api.id(94105402933265699.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94105722376265699.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostrar en Informe por Defecto'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_display_text_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113775430732356381.4001)
,p_lov_name=>'DQ_DISPLAY_TEXT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(113775430732356381.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113775715473356384.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Columna de Informe Est\00E1ndar')
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113776305444356385.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mostrar como Texto (caracteres especiales de escape)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450124406392222095.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Mostrar como Texto (basado en la lista de valores, caracteres especiales de escape)'
,p_lov_return_value=>'LOV_ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(442890225057859433.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Eliminar HTML y caracteres especiales de escape'
,p_lov_return_value=>'STRIP_HTML_ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135238030911430173.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Oculto'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_download_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(91727320467023155.4001)
,p_lov_name=>'DQ_DOWNLOAD_FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(91727320467023155.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91727602780023159.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CSV'
,p_lov_return_value=>'CSV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3830908039991257.4001)
,p_lov_disp_sequence=>1.5
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9204300405839444.4001)
,p_lov_disp_sequence=>1.7
,p_lov_disp_value=>unistr('Correo Electr\00F3nico *')
,p_lov_return_value=>'EMAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91727810512023162.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'XLS'
,p_lov_return_value=>'XLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91728030204023162.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PDF'
,p_lov_return_value=>'PDF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91728214017023162.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'RTF'
,p_lov_return_value=>'RTF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_filter_date_range
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113891626211903772.4001)
,p_lov_name=>'DQ_FILTER_DATE_RANGE'
,p_lov_query=>'.'||wwv_flow_api.id(113891626211903772.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113891914381903774.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Todo'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113892122745903775.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Anterior'
,p_lov_return_value=>'PAST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113892318530903775.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Futuro'
,p_lov_return_value=>'FUTURE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_non_pub_rpt_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(480571702359614063.4001)
,p_lov_name=>'DQ_NON_PUB_RPT_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(480571702359614063.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(480574929174614071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guardar Informe'
,p_lov_return_value=>'RPT_SAVING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(480575104904614071.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Guardar Informe P\00FAblico')
,p_lov_return_value=>'SAVE_RPT_PUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(480574106814614069.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Suscripci\00F3n')
,p_lov_return_value=>'NOTIFY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_rpt_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93890902683872023.4001)
,p_lov_name=>'DQ_RPT_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(93890902683872023.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93891207939872035.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seleccionar Columnas'
,p_lov_return_value=>'SELECT_COLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93891430852872035.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Filtro'
,p_lov_return_value=>'FILTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445491215210900584.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Filas por P\00E1gina')
,p_lov_return_value=>'ROWS_PER_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93891616940872035.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Ordenar'
,p_lov_return_value=>'SORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141674418886754015.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Divisi\00F3n de Control')
,p_lov_return_value=>'BREAK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93891825853872035.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Resaltar'
,p_lov_return_value=>'HIGHLIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93893009214872050.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Calcular'
,p_lov_return_value=>'COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93892010217872035.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Agregar'
,p_lov_return_value=>'AGGREGATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(96144107239525391.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1541019690680918.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Agrupar por'
,p_lov_return_value=>'GROUP_BY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367023902558041646.4001)
,p_lov_disp_sequence=>105
,p_lov_disp_value=>unistr('Din\00E1mica')
,p_lov_return_value=>'PIVOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93892230261872036.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93892430175872036.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Flashback'
,p_lov_return_value=>'FLASHBACK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(480714630007218066.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Guardar Informe *'
,p_lov_return_value=>'RPT_SAVING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(480714802780219726.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('Guardar Informe P\00FAblico *')
,p_lov_return_value=>'SAVE_RPT_PUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93892610127872036.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Restablecer'
,p_lov_return_value=>'RESET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135686220155392741.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Ayuda'
,p_lov_return_value=>'HELP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93892800927872050.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Descargar'
,p_lov_return_value=>'DOWNLOAD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(480715008321221245.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('Suscripci\00F3n *')
,p_lov_return_value=>'NOTIFY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93893414283872050.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>unistr('Permitir Categor\00EDas de Informe')
,p_lov_return_value=>'RPT_CATEGORY'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_rpt_list_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93938623554284943.4001)
,p_lov_name=>'DQ_RPT_LIST_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(93938623554284943.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93938902214284943.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131717516025931094.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_same_label_for_detail_view
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(96419205216695800.4001)
,p_lov_name=>'DQ_SAME_LABEL_FOR_DETAIL_VIEW'
,p_lov_query=>'.'||wwv_flow_api.id(96419205216695800.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(96419521321695807.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Usar Mismo Texto para Vista de Una Sola Fila'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_search_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131635032236756030.4001)
,p_lov_name=>'DQ_SEARCH_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(131635032236756030.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131635314260756031.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Campo de B\00FAsqueda')
,p_lov_return_value=>'SEARCH_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131635716026756031.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Lista Desplegable del Buscador'
,p_lov_return_value=>'FINDER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(192533912617244035.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n de Informes')
,p_lov_return_value=>'REPORTS_SELECT_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131635520752756031.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Selector de Filas por P\00E1gina')
,p_lov_return_value=>'ROW_CNT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135033300784021288.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Men\00FA de Acciones')
,p_lov_return_value=>'ACTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_worksheet_pagination
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(89240132490172141.4001)
,p_lov_name=>'DQ_WORKSHEET_PAGINATION'
,p_lov_query=>'.'||wwv_flow_api.id(89240132490172141.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89240414406172201.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Rangos de Fila X a Y de Z'
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89240620434172201.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Rangos de Fila X a Y'
,p_lov_return_value=>'ROWS_X_TO_Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_worksheet_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(89234523991056148.4001)
,p_lov_name=>'DQ_WORKSHEET_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(89234523991056148.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89234802427056220.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disponible para Propietario'
,p_lov_return_value=>'AVAILABLE_FOR_OWNER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89235015173056220.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No Disponible'
,p_lov_return_value=>'NOT_AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89235209196056220.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(89235410026056220.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Lista de Control de Acceso'
,p_lov_return_value=>'ACL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_aff_elem_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42588011898494805.4001)
,p_lov_name=>'DYNAMIC ACTION AFF ELEM TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(42588011898494805.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42588307156494808.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elementos'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(206201404272235955.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42588501084494810.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42588703168494810.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Columna'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42588930101494810.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Objeto DOM [en desuso]'
,p_lov_return_value=>'DOM_OBJECT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID <> 591',
'or ( :APP_PAGE_ID = 591 and :P591_AFFECTED_ELEMENTS_TYPE = ''DOM_OBJECT'' )'))
,p_lov_disp_cond2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42589125805494810.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Selector de jQuery'
,p_lov_return_value=>'JQUERY_SELECTOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(855875291459963705.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Expresi\00F3n JavaScript')
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486612219500089929.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Elemento Disparador'
,p_lov_return_value=>'TRIGGERING_ELEMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486612426080091815.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Origen de Evento'
,p_lov_return_value=>'EVENT_SOURCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_bind_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(34818831818567513.4001)
,p_lov_name=>'DYNAMIC ACTION BIND TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(34818831818567513.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34819108605567514.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est\00E1tico')
,p_lov_return_value=>'bind'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34819317513567514.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Din\00E1mico')
,p_lov_return_value=>'live'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47188804631100745.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Una Vez'
,p_lov_return_value=>'one'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_condition
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4505805282372682.4001)
,p_lov_name=>'DYNAMIC ACTION CONDITION'
,p_lov_query=>'.'||wwv_flow_api.id(4505805282372682.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4506012984372684.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'igual que'
,p_lov_return_value=>'EQUALS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4506219163372689.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'distinto de'
,p_lov_return_value=>'NOT_EQUALS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4506429627372689.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'mayor que'
,p_lov_return_value=>'GREATER_THAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(485047623220016520.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'mayor o igual que'
,p_lov_return_value=>'GREATER_THAN_OR_EQUAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4506629608372689.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'menor que'
,p_lov_return_value=>'LESS_THAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(485047828414018007.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'menor o igual que'
,p_lov_return_value=>'LESS_THAN_OR_EQUAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4506817808372689.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'es nulo'
,p_lov_return_value=>'NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4507030226372689.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'no es nulo'
,p_lov_return_value=>'NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5702509159891012.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'en lista'
,p_lov_return_value=>'IN_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5703019894894122.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'no en lista'
,p_lov_return_value=>'NOT_IN_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(36337703765902045.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Expresi\00F3n JavaScript')
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_trigg_elem_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(34817614503562438.4001)
,p_lov_name=>'DYNAMIC ACTION TRIGG ELEM TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(34817614503562438.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34817919388562441.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elementos'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34818325097562443.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34818131975562443.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34818512066562444.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Objeto DOM [en desuso]'
,p_lov_return_value=>'DOM_OBJECT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID not in ( 423, 793, 797 )',
'or ( :APP_PAGE_ID = 793 and :P793_TRIGGERING_ELEMENT_TYPE = ''DOM_OBJECT'' )',
'or ( :APP_PAGE_ID = 797 and :P797_TRIGGERING_ELEMENT_TYPE = ''DOM_OBJECT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34818720680562446.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Selector de jQuery'
,p_lov_return_value=>'JQUERY_SELECTOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(855887929978084842.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Expresi\00F3n JavaScript')
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(176908416123204266.4001)
,p_lov_name=>'DYNAMIC ACTION TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(176908416123204266.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(176908631630204301.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Mostrar'
,p_lov_return_value=>'NATIVE_SHOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181460730381992265.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ocultar'
,p_lov_return_value=>'NATIVE_HIDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(176908832156204306.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Activar'
,p_lov_return_value=>'NATIVE_ENABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184818803817394386.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Desactivar'
,p_lov_return_value=>'NATIVE_DISABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_actions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(34830410796693863.4001)
,p_lov_name=>'DYNAMIC ACTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''DA_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix as r',
'  from wwv_flow_native_plugins',
' where plugin_type = ''DYNAMIC ACTION''',
' union all',
'select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'       ''PLUGIN_'' || name as r',
'  from wwv_flow_plugins',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type = ''DYNAMIC ACTION''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_actions_old
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4507311169374329.4001)
,p_lov_name=>'DYNAMIC ACTIONS OLD'
,p_lov_query=>'.'||wwv_flow_api.id(4507311169374329.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4507509318374330.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostrar'
,p_lov_return_value=>'SHOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4507707037374331.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Ocultar'
,p_lov_return_value=>'HIDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(25500603273005492.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Ocultar y Borrar'
,p_lov_return_value=>'HIDE_AND_CLEAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4507925307374331.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Activar'
,p_lov_return_value=>'ENABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4508112618374331.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Desactivar'
,p_lov_return_value=>'DISABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4508306180374331.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Mostrar Fila de Elementos'
,p_lov_return_value=>'SHOW_ITEM_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4508511742374331.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Ocultar Fila de Elementos'
,p_lov_return_value=>'HIDE_ITEM_ROW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_theme_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(317672930832099392.4001)
,p_lov_name=>'DYNAMIC_THEME_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''<br/><a href="f?p=4000:''||:THEME_NEXT_PAGE||'':''||:APP_SESSION||''::::THEME_ID:''||t.theme_id||''"><img src="#IMAGE_PREFIX#themes/theme_''||t.theme_id||''/themeshot.png" alt="''||wwv_flow_lang.'
||'system_message(''THEME'')||'' ''||t.theme_id||''" title="''||wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''" width="150" height="80" class="htmldbthemeshots" /></a>'' display_value, t.theme_id ',
'from (',
'    select substr(object_name,16) theme_id ',
'    from   user_objects ',
'    where  object_name like ''WWV_FLOW_THEME_%''',
'    and    object_type = ''PACKAGE''',
'    and    substr(object_name,16) in (',
'        ''1'',''2'',''3'',''4'',''5'',''6'',''7'',''8'',''9'',''10'',',
'        ''11'',''12'',''13'',''14'',''15'',''16'',''17'',''18'',''19'',''20'',',
'        ''21'',''22'',''23'',''24'',''25'',''26'',''27'',''28'',''29'',''30'',',
'        ''31'',''32'',''33'',''34'',''35'',''36'',''37'',''38'',''39'',''40'',',
'        ''41'',''42'',''43'',''44'',''45'',''46'',''47'',''48'',''49'',''50'',',
'        ''51'',''52'',''53'',''54'',''55'',''56'',''57'',''58'',''59'',''60'',',
'        ''61'',''62'',''63'',''64'',''65'',''66'',''67'',''68'',''69'',''70'',',
'        ''71'',''72'',''73'',''74'',''75'',''76'',''77'',''78'',''79'',''80'',',
'        ''81'',''82'',''83'',''84'',''85'',''86'',''87'',''88'',''89'',''90'',',
'        ''91'',''92'',''93'',''94'',''95'',''96'',''97'',''98'',''99'',''100''',
'    )',
') t',
'where t.theme_id not in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) ',
'order by to_number(t.theme_id)',
'',
'',
'',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enabled_disabled_returns_y_or_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(91439803955181562.4001)
,p_lov_name=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91440204684181564.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91440020513181563.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Activado'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_calendar_data_add
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7062800325985451.4001)
,p_lov_name=>'ENABLE_CALENDAR_DATA_ADD'
,p_lov_query=>'select wwv_flow_lang.system_message(''CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'') d, ''Y'' r from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_calendar_drag_drop
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7041321387979610.4001)
,p_lov_name=>'ENABLE_CALENDAR_DRAG_DROP'
,p_lov_query=>'select wwv_flow_lang.system_message(''CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'') d, ''Y'' r from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_csv_export
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113206414430374390.4001)
,p_lov_name=>'ENABLE_CSV_EXPORT'
,p_lov_query=>'.'||wwv_flow_api.id(113206414430374390.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113206730666374392.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activar Salida de CSV'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_disable
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84865108269386627.4001)
,p_lov_name=>'ENABLE_DISABLE'
,p_lov_query=>'.'||wwv_flow_api.id(84865108269386627.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84865322430386628.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Desactivar'
,p_lov_return_value=>'DISABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84865528406386628.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Activar'
,p_lov_return_value=>'ENABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/error_display_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(175855211406623797.4001)
,p_lov_name=>'ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_api.id(175855211406623797.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175855515052623815.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En L\00EDnea con Campo y en Notificaci\00F3n')
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175855711259623816.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('En L\00EDnea con Campo')
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175855923896623816.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('En L\00EDnea en Notificaci\00F3n')
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175856114844623817.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('En P\00E1gina de Error')
,p_lov_return_value=>'ON_ERROR_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exact_match
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(165376410332055484.4001)
,p_lov_name=>'EXACT_MATCH'
,p_lov_query=>'.'||wwv_flow_api.id(165376410332055484.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(165376716320055488.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Coincidencia Exacta'
,p_lov_return_value=>'y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exact_subs_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84908521896674445.4001)
,p_lov_name=>'EXACT_SUBS_Y_N'
,p_lov_query=>'.'||wwv_flow_api.id(84908521896674445.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84908724352674446.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('No: Realizar Sustituciones No Exactas Tambi\00E9n')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84908932193674446.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('S\00ED: Realizar S\00F3lo Sustituciones Exactas')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3842073961668883.4001)
,p_lov_name=>'EXEC_LOCATION'
,p_lov_query=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3842372126668884.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Base de Datos Local'
,p_lov_return_value=>'LOCAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3842783209668886.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Servicio de SQL activado para REST'
,p_lov_return_value=>'REMOTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3843166174668886.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Origen de Datos de REST'
,p_lov_return_value=>'WEB_SOURCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_sql_data_source_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601107956819795211.4001)
,p_lov_name=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(601107956819795211.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601108186629795212.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tabla'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601108576965795212.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Consulta SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601108991977795212.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n que devuelve un SQL')
,p_lov_return_value=>'FUNC_BODY_RETURNING_SQL'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'4111'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_sql_locations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601110993871808630.4001)
,p_lov_name=>'EXEC_SQL_LOCATIONS'
,p_lov_query=>'.'||wwv_flow_api.id(601110993871808630.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601111150897808630.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Base de Datos Local'
,p_lov_return_value=>'LOCAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601111502081808631.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Servicio de SQL activado para REST'
,p_lov_return_value=>'REMOTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_web_source_post_processing
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601113045750817318.4001)
,p_lov_name=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov_query=>'.'||wwv_flow_api.id(601113045750817318.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601113231405817319.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'NONE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'4111'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601113600388817319.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cl\00E1usula WHERE')
,p_lov_return_value=>'WHERE_ORDER_BY_CLAUSE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601114018041817319.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Consulta SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601114450986817320.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n que devuelve una consulta SQL')
,p_lov_return_value=>'FUNC_BODY_RETURNING_SQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_component_application_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(201561021137913944.4001)
,p_lov_name=>'EXPORT COMPONENT APPLICATION ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(201561021137913944.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201561202964913947.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Plantilla de P\00E1gina por Defecto')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201561427317913952.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Logotipo')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201561612262913952.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: URL de Desconexi\00F3n')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201561802624913952.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Notificaci\00F3n Global')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201562020313913952.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Autenticaci\00F3n')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201589706900307265.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Enlace de P\00E1gina Inicial')
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201590720753311215.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Prefijo de Imagen')
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201591029064313600.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Conexi\00F3n (S\00ED o No)')
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201591602183315334.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Propietario de Aplicaci\00F3n')
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201592417767319814.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Cadenas de Sustituci\00F3n Est\00E1ticas')
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201603224693321841.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Mensaje y Estado de Aplicaci\00F3n')
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201604303007325019.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Activar Depuraci\00F3n (S\00ED o No)')
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204137731018130907.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Nombre de la Aplicaci\00F3n')
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204138001713131913.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Alias de Aplicaci\00F3n')
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204138307946133739.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Modo de Sustituci\00F3n Exacta')
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204139019721137188.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Esquema de Seguridad')
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204139423184138143.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Servidor Proxy')
,p_lov_return_value=>'17'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204140027339139375.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Protecci\00F3n de P\00E1gina')
,p_lov_return_value=>'18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(204140631495140521.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>unistr('Atributo de Aplicaci\00F3n: Base de Datos Privada Virtual')
,p_lov_return_value=>'19'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(45348605156549399.4001)
,p_lov_name=>'EXPORT.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(45348605156549399.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(45349208290549436.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Importar'
,p_lov_return_value=>'IMPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1846115445438584.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Exportar'
,p_lov_return_value=>'EXPORT'
,p_lov_disp_cond_type=>'NOT_EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(45349021845549425.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Exportar'
,p_lov_return_value=>'EXPORT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_options_with_icons
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(805553919796597674.4001)
,p_lov_name=>'EXPORT.OPTIONS WITH ICONS'
,p_lov_query=>'.'||wwv_flow_api.id(805553919796597674.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(805554221842597674.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Importar'
,p_lov_return_value=>'IMPORT'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-import-app'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(805554564333597675.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Exportar'
,p_lov_return_value=>'EXPORT'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-export-app'
,p_lov_disp_cond_type=>'NOT_EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(805554842111597676.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Exportar'
,p_lov_return_value=>'EXPORT'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-export-app'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3401075102772765.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Despliegue remoto'
,p_lov_return_value=>'DEPLOY'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-remote-deploy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_targets_no_xml
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(43935029932609535.4001)
,p_lov_name=>'EXPORT.TARGETS.no.xml'
,p_lov_query=>'.'||wwv_flow_api.id(43935029932609535.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43935319566609536.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43935500793609538.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(107236303690563927.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Base de Datos'
,p_lov_return_value=>'DB'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''APP_EXPORT_TO_DB_ENABLED''),''Y'') = ''Y'' and :APP_PAGE_ID = 4900 then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_feedback_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(472293315458205653.4001)
,p_lov_name=>'EXPORT_FEEDBACK_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(472293315458205653.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(472293519211205655.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exportar Comentarios a Desarrollo'
,p_lov_return_value=>'TO_DEVELOPMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(472293702716205659.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Exportar Respuesta a Despliegue'
,p_lov_return_value=>'TO_DEPLOYMENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_file_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84829617133304005.4001)
,p_lov_name=>'EXPORT_FILE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84829617133304005.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84829803958304006.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Exportaci\00F3n de Aplicaci\00F3n, P\00E1gina o Componente de Base de Datos')
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30414604424207501.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Plugin'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84830627988304007.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Exportaci\00F3n de Script')
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141375217080001896.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Exportaci\00F3n de Temas')
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(158557719334534776.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Valores por Defecto de Interfaz de Usuario'
,p_lov_return_value=>'UI_DEFAULTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(472592924227766354.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Comentarios de Desarrollo de Equipos'
,p_lov_return_value=>'FEEDBACK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3820800835815571.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Cat\00E1logo de origen de REST')
,p_lov_return_value=>'CATALOG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_sup_obj_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(388231942990864305.4001)
,p_lov_name=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(388231942990864305.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(388232203970864308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(388232554971864310.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(388232860273864310.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('S\00ED e Instalar al Importar Autom\00E1ticamente')
,p_lov_return_value=>'I'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84313028848586180.4001)
,p_lov_name=>'EXPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84313028848586180.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84313210243586181.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Espacios de Trabajo'
,p_lov_return_value=>'COMPANY_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84313400691586181.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Aplicaciones de Base de Datos'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(504409922096580868.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('Aplicaciones de Hoja de C\00E1lculo Web')
,p_lov_return_value=>'WEBSHEET_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84313629140586181.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('P\00E1ginas')
,p_lov_return_value=>'PAGE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30460601502095997.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Plugin'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84313822161586182.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'CSS'
,p_lov_return_value=>'CSS_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84314021666586182.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Im\00E1genes')
,p_lov_return_value=>'IMAGE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84314231797586182.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Archivos'
,p_lov_return_value=>'FILE_EXPORT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84314413534586182.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Archivos de Comandos'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218848421565947069.4001)
,p_lov_disp_sequence=>75
,p_lov_disp_value=>unistr('Exportaci\00F3n de Archivo Est\00E1tico')
,p_lov_return_value=>'FILE_EXPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217881026720006951.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Temas'
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(217881302263009316.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Valores por Defecto de Interfaz de Usuario'
,p_lov_return_value=>'UI_DEFAULTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39083219682790387.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Comentarios de Desarrollo de Equipos'
,p_lov_return_value=>'FEEDBACK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3931071348171445.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('Cat\00E1logo de origen de REST')
,p_lov_return_value=>'CATALOG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4000_pt0x
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(104345318793564176.4001)
,p_lov_name=>'F4000_PT0X'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :F4000_PTN1 d, 1 r from dual ',
'where  :F4000_PTN1 is not null',
'union all',
'select :F4000_PTN2 d, 2 r from dual',
'where  :F4000_PTN2 is not null',
'union all',
'select :F4000_PTN3 d, 3 r from dual',
'where  :F4000_PTN3 is not null',
'union all',
'select :F4000_PTN4 d, 4 r from dual',
'where  :F4000_PTN4 is not null',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/feedback_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1498508547672379782.4001)
,p_lov_name=>'FEEDBACK STATUS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||the_name the_name, id ',
'from wwv_flow_feedback_status ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/feedback_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(692564541295242869.4001)
,p_lov_name=>'FEEDBACK TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(692564541295242869.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(720957220062547736.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Comentario del Desarrollador'
,p_lov_return_value=>'COMMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(692565162163242874.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bug'
,p_lov_return_value=>'BUG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(692564818123242871.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Tarea'
,p_lov_return_value=>'TODO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fieldtemplate
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93450900806779850.4001)
,p_lov_name=>'FIELDTEMPLATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where  flow_id = :fb_flow_id and ',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/field_alignment
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84354125395660958.4001)
,p_lov_name=>'FIELD_ALIGNMENT'
,p_lov_query=>'.'||wwv_flow_api.id(84354125395660958.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84354312984660959.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Centro'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84354513344660959.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Centro inferior'
,p_lov_return_value=>'CENTER-BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84354712797660959.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Centro centro'
,p_lov_return_value=>'CENTER-CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84354917729660959.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Centro superior'
,p_lov_return_value=>'CENTER-TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84355106101660960.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84355327264660960.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Inicio (Abajo)'
,p_lov_return_value=>'LEFT-BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84355517743660961.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Inicio (Centro)'
,p_lov_return_value=>'LEFT-CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84355723004660961.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Inicio (Arriba)'
,p_lov_return_value=>'LEFT-TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84355913470660961.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'RIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84356104865660961.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Fin (Abajo)'
,p_lov_return_value=>'RIGHT-BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84356323660660962.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Fin Centro'
,p_lov_return_value=>'RIGHT-CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84356511314660962.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Fin (Arriba)'
,p_lov_return_value=>'RIGHT-TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_extensions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(152392614641425297.4001)
,p_lov_name=>'FILE EXTENSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(152392614641425297.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152392917070425300.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'gif'
,p_lov_return_value=>'gif'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152393102499425300.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'jpg'
,p_lov_return_value=>'jpg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152393306933425300.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'png'
,p_lov_return_value=>'png'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152393526593425301.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'js'
,p_lov_return_value=>'js'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152393720879425301.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'ico'
,p_lov_return_value=>'ico'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152393912392425301.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'swf'
,p_lov_return_value=>'swf'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152561112881547769.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'css'
,p_lov_return_value=>'css'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84322414566600975.4001)
,p_lov_name=>'FILE_FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(84322414566600975.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84322611093600976.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84322801136600976.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/find_files_report_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(152121930169975580.4001)
,p_lov_name=>'FIND FILES REPORT OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(152121930169975580.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152122103854975582.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Con contexto'
,p_lov_return_value=>'CONTEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152122325945975584.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Sin contexto'
,p_lov_return_value=>'NO_CONTEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/first_item
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88125512675662566.4001)
,p_lov_name=>'FIRST.ITEM'
,p_lov_query=>'.'||wwv_flow_api.id(88125512675662566.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88125727281662567.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Primer Elemento en la P\00E1gina')
,p_lov_return_value=>'AUTO_FIRST_ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88125912388662567.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No Enfocar Cursor'
,p_lov_return_value=>'NO_FIRST_ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fixed_header_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1591954790699969778.4001)
,p_lov_name=>'FIXED_HEADER_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(1591954790699969778.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1591955066049969781.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1591955376065969785.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1591955690098969785.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fk_col_source_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(61279713459133078.4001)
,p_lov_name=>'FK_COL_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(61279713459133078.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(61280232645133087.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento (nombre de elemento de aplicaci\00F3n o p\00E1gina)')
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137617420490097969.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n o Expresi\00F3n PL/SQL')
,p_lov_return_value=>'FUNCTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flash_chart_query_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6026412205740110.4001)
,p_lov_name=>'FLASH_CHART_QUERY_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(6026412205740110.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6026711255740110.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Consulta SQL'
,p_lov_return_value=>'SQL_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6026911236740110.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve una Consulta SQL')
,p_lov_return_value=>'FUNCTION_RETURNING_SQL_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_process_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179311318624565491.4001)
,p_lov_name=>'FLOW.PROCESS.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(179311318624565491.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179311622483565552.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En Carga: Antes de Cabecera (cabecera de plantilla de p\00E1gina)')
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179311831825565556.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('En Carga: Despu\00E9s de Cabecera (cabecera de plantilla de p\00E1gina)')
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179312200871565557.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'En Carga: Antes de Regiones de "Cuerpo"'
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179312423113565557.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('En Carga: Despu\00E9s de Regiones de "Cuerpo"')
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179312600387565558.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('En Carga: Antes de Pie de P\00E1gina (pie de p\00E1gina de plantilla de p\00E1gina)')
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179312827063565558.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('En Carga: Despu\00E9s de Pie de P\00E1gina (pie de p\00E1gina de plantilla de p\00E1gina)')
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3451613729145560.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('En Ejecuci\00F3n: Despu\00E9s de Ejecuci\00F3n de P\00E1gina - Antes de C\00E1lculos y Validaciones')
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179313012514565558.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('En Ejecuci\00F3n: Despu\00E9s de Ejecuci\00F3n de P\00E1gina - Despu\00E9s de C\00E1lculos y Validaciones')
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179313403662565559.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('En una Nueva Instancia (nueva sesi\00F3n)')
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48424707885351870.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Despu\00E9s de Autenticaci\00F3n')
,p_lov_return_value=>'AFTER_LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(195926500168560659.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Devoluci\00F3n de Llamada de AJAX: Ejecute este proceso de aplicaci\00F3n cuando se lo solicite el proceso de p\00E1gina.')
,p_lov_return_value=>'ON_DEMAND'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flowchart_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84246225797415032.4001)
,p_lov_name=>'FLOWCHART_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84246225797415032.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88293501517804182.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostrar Todo'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88293722687804182.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mostrar Usado'
,p_lov_return_value=>'USED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_page_process_point
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(842344044.4001)
,p_lov_name=>'FLOW_PAGE_PROCESS_POINT'
,p_lov_query=>'.'||wwv_flow_api.id(842344044.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88153412020965107.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('En una Nueva Instancia (nueva sesi\00F3n)')
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88153630053965109.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'En Carga: Antes de Cabecera'))
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88153816621965110.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Cabecera')))
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88154016104965110.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'En Carga: Antes de Regiones'))
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88154204450965110.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Regiones')))
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88154401617965110.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Antes de Pie de P\00E1gina')))
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88154630856965111.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Pie de P\00E1gina')))
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88154821308965111.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Ejecuci\00F3n: Antes de C\00E1lculos y Validaciones ')))
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88155019536965111.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Ejecuci\00F3n: Despu\00E9s de C\00E1lculos y Validaciones')))
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180086820088274193.4001)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>unistr('Devoluci\00F3n de Llamada de AJAX: Ejecute este proceso cuando lo solicite AJAX')
,p_lov_return_value=>'ON_DEMAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88155215743965111.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('En Error: Despu\00E9s de Cabecera')
,p_lov_return_value=>'AFTER_ERROR_HEADER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88155426385965112.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('En Error: Antes de Pie de P\00E1gina')
,p_lov_return_value=>'BEFORE_ERROR_FOOTER'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_page_process_types_used_by_layout_plb
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(173924028038191229.4001)
,p_lov_name=>'FLOW_PAGE_PROCESS_TYPES (USED BY LAYOUT.PLB)'
,p_lov_query=>'.'||wwv_flow_api.id(173924028038191229.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5385505863234534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Obtener Valor de Clave Primaria Anterior o Siguiente'
,p_lov_return_value=>'GET_NEXT_OR_PREV_PK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24106509225424138.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n para Todas las P\00E1ginas')
,p_lov_return_value=>'INITIALIZE_PAGINATION_FOR_ALL_PAGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24106822384427913.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n para P\00E1ginas (Identificador de P\00E1gina, Identificador de P\00E1gina, Identificador de P\00E1gina)')
,p_lov_return_value=>'INITIALIZE_PAGE_PAGINATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37703005830510688.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Aplicaci\00F3n Actual (elimina todos los estados de sesi\00F3n para la aplicaci\00F3n actual)')
,p_lov_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37703320721515055.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Aplicaciones (elimina todos los estados de sesi\00F3n para las aplicaciones mostradas)')
,p_lov_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55952701190174406.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Agregar Filas a Pantalla Tabular'
,p_lov_return_value=>'ADD_ROWS_TO_TABULAR_FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91224603956641545.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Servicio Web'
,p_lov_return_value=>'WEB_SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108355614250314633.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cerrar Ventana Emergente'
,p_lov_return_value=>'CLOSE_WINDOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173924310985191301.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bloque An\00F3nimo PL/SQL')
,p_lov_return_value=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173924502801191303.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('PL/SQL DBMS JOB (ejecuta el bloque an\00F3nimo de forma as\00EDncrona)')
,p_lov_return_value=>'PLSQL_DBMS_JOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173924700917191304.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n')
,p_lov_return_value=>'RESET_PAGINATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173924903829191304.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Todos los Elementos de P\00E1ginas (Identificador de P\00E1gina, Identificador de P\00E1gina, Identificador de P\00E1gina)')
,p_lov_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173925127021191304.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Elementos (ITEM,ITEM,ITEM)')
,p_lov_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173925314775191305.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Recuperaci\00F3n Autom\00E1tica de Filas')
,p_lov_return_value=>'DML_FETCH_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173925531897191305.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Procesamiento Autom\00E1tico de Filas (DML)')
,p_lov_return_value=>'DML_PROCESS_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173925724656191305.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Definir Preferencia en Valor de Elemento'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173925923660191306.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Definir preferencia en valor de elemento si el elemento no es nulo (Nombre de Preferencia:ITEM)'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173926131005191309.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Actualizaci\00F3n de Varias Filas')
,p_lov_return_value=>'MULTI_ROW_UPDATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173926306818191309.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Sesi\00F3n Actual (elimina todos los estados para la sesi\00F3n actual)')
,p_lov_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174071729595622534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Restablecer Preferencias (elimina todas las preferencias para el usuario actual)'
,p_lov_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(195164405401312743.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Inicializar Todos los Elementos de P\00E1gina')
,p_lov_return_value=>'INITIALIZE_ALL_PAGE_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(196226115576823870.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Devoluci\00F3n de Llamada de AJAX: Ejecute un proceso de aplicaci\00F3n "Devoluci\00F3n de Llamada de AJAX"')
,p_lov_return_value=>'ON_DEMAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31585223737231743.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Supresi\00F3n de Varias Filas')
,p_lov_return_value=>'MULTI_ROW_DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_button_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(78596914570530945.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_BUTTON_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_button_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'     build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'     exists (',
'      select 1 from wwv_flow_developers',
'      where userid = :flow_user and (flow_id = f.id or flow_id is null) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_cal_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(38779012258862870.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_CAL_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, 0 r from dual',
'union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_cal_templates',
'where flow_id != nvl(:fb_flow_id,0) and flow_id in (',
' select f.id',
' from   wwv_flows f',
' where  security_group_id = :flow_security_group_id',
'  and  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'  and  exists (',
'   select 1 ',
'   from wwv_flow_developers',
'   where userid = :flow_user ',
'     and (flow_id is null or flow_id = f.id)',
'     and security_group_id = :flow_security_group_id)',
')',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_field_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164770817986385686.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_FIELD_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_field_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_item_help
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(36938013073570429.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_ITEM_HELP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_ITEM''))||',
''' -''  d, 0 r from dual union all',
'select i.flow_id||'' : ''||wwv_flow_escape.html(i.name) d, i.id r',
'from   wwv_flow_step_items i, wwv_flow_step_item_help h',
'where  i.id = h.flow_item_id',
'and i.flow_id = nvl(:fb_flow_id,0) and i.flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_list_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164157520028033233.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_LIST_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from(',
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -''  d, 0 r, 1 ob',
'  from dual ',
' union all',
'select flow_id||'' : ''||wwv_flow_escape.html(list_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r,2 ob',
'  from wwv_flow_list_templates',
' where flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'    select f.id',
'      from wwv_flows f',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID and',
'           build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'       and exists (',
'               select 1 ',
'                 from wwv_flow_developers',
'                where userid = :FLOW_USER ',
'                  and ( flow_id is null or flow_id = f.id )',
'                  and security_group_id = :FLOW_SECURITY_GROUP_ID)',
'',
'))',
'order by ob,d'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_lovs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(202133627659471272.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_LOVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_LOV'')||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(LOV_NAME) d, id r',
'from   wwv_flow_lists_of_values$',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_menu_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13324505967815786.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_MENU_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') n, id r',
'from   wwv_flow_menu_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_navbars
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(200972808971926486.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_NAVBARS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''LAYOUT.T_NO''))||'' '' ||wwv_flow_lang.system_message(''NAVBAR'')||',
'''  -'' d, 0 r from dual union all',
'select flow_id||'' : ''||',
'icon_image_alt d,',
'id r',
'from   wwv_flow_icon_bar',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_page_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162657018721377376.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_PAGE_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select d, r from (',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id) and security_group_id = :flow_security_group_id)',
')',
'order by 1',
')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_plugins
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(32725318570538377.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_PLUGINS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.flow_id||'' : ''||wwv_flow_escape.html(p.display_name) as d,',
'       p.id as r',
'  from wwv_flow_plugins p,',
'       wwv_flows f',
' where p.flow_id          != to_number(:FB_FLOW_ID)',
'   and p.security_group_id = to_number(:WORKSPACE_ID)',
'   and f.id                = p.flow_id',
'   and f.build_status     not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_popuplov_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13178025111508374.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_POPUPLOV_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'       lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
'       '' -'' d, 0 r',
'  from dual',
' union all',
'select flow_id||'' : ''||',
'       lower(wwv_flow_lang.system_message(''POPUP_LOV''))||'' ''||',
'       lower(wwv_flow_lang.system_message(''TEMPLATE''))||decode(theme_id,null,'''','' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_popup_lov_template',
' where flow_id != nvl(:fb_flow_id,0)',
'  and flow_id in ( select f.id',
'                     from wwv_flow_visible_flows f',
'                    where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') )',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_region_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164027403622318790.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_REGION_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id||'' : ''||wwv_flow_escape.html(page_plug_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_report_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(164380503095031318.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_REPORT_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(row_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_row_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_security_schemes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178729613950854599.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_SECURITY_SCHEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'')||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_security_schemes',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_shortcuts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(185072604868032254.4001)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_SHORTCUTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_SHORTCUT'')||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(shortcut_name) d, id r',
'from   wwv_flow_shortcuts',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fnd_users
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48667231497347248.4001)
,p_lov_name=>'FND_USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) u, user_name r',
'from wwv_flow_fnd_user',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/font_categories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1362022415318990531.4001)
,p_lov_name=>'FONT_CATEGORIES'
,p_lov_query=>'.'||wwv_flow_api.id(1362022415318990531.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497170667382843497.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sexo'
,p_lov_return_value=>'GENDER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497171279425847351.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mano'
,p_lov_return_value=>'HAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497171505282849539.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Transporte'
,p_lov_return_value=>'TRANSPORTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362022731262990536.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Aplicaci\00F3n Web')
,p_lov_return_value=>'WEB_APPLICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362023055345990537.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tipo de Archivo'
,p_lov_return_value=>'FILE_TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362023361612990537.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Selector'
,p_lov_return_value=>'SPINNER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362023649634990537.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Control de Pantalla'
,p_lov_return_value=>'FORM_CONTROL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362023956430990537.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pago'
,p_lov_return_value=>'PAYMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362024258223990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362024591404990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Divisa'
,p_lov_return_value=>'CURRENCY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362024827423990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Editor de Texto'
,p_lov_return_value=>'TEXT_EDITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362025156564990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Direccional'
,p_lov_return_value=>'DIRECTIONAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362025474226990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Reproductor de V\00EDdeo')
,p_lov_return_value=>'VIDEO_PLAYER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362025761844990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marca'
,p_lov_return_value=>'BRAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362026047790990538.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('M\00E9dico')
,p_lov_return_value=>'MEDICAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1498481689694180020.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1498482021426180027.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Emoji'
,p_lov_return_value=>'EMOJI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1498482476450180027.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00FAmeros')
,p_lov_return_value=>'NUMBERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(32743907454195192.4001)
,p_lov_name=>'FORMAT MASK'
,p_lov_query=>'.'||wwv_flow_api.id(32743907454195192.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32744227838195194.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'$5.234,10'
,p_lov_return_value=>'FML999G999G999G999G990D00'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32744409098195194.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5.234,10'
,p_lov_return_value=>'FM999G999G999G999G990'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32744605601195195.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'5.234,1000'
,p_lov_return_value=>'FM999G999G999G999G990D0000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32744816704195195.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'12-ENE-04'
,p_lov_return_value=>'DD-MON-RR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32745005542195195.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'12-ENE-2004'
,p_lov_return_value=>'DD-MON-YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32745228650195198.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'12-ENE'
,p_lov_return_value=>'DD-MON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32745408887195198.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Lunes, 12 de enero de 2004'
,p_lov_return_value=>'FMDay, Month DDth YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32745602717195199.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'12-ENE-2004 14:30'
,p_lov_return_value=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(102480222352871523.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'10-ENE-2004 14:22:10'
,p_lov_return_value=>'DD-MON-YYYY HH24:MI:SS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32745830450195199.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'12-ENE-2004 2:30PM'
,p_lov_return_value=>'DD-MON-YYYY HH:MIPM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32746002562195199.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Enero'
,p_lov_return_value=>'Month'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_for_charts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(100170629844530853.4001)
,p_lov_name=>'FORMAT.MASK.FOR.CHARTS'
,p_lov_query=>'.'||wwv_flow_api.id(100170629844530853.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(100170923893530859.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'$5.234,10'
,p_lov_return_value=>'FML999G999G999G999G990D00'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(100171118880530862.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5.234,10'
,p_lov_return_value=>'FM999,999,999,999,990.00'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(100171313816530862.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'5.234,1000'
,p_lov_return_value=>'FM999,999,999,999,990.0000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_for_charts_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(44804526758842632.4001)
,p_lov_name=>'FORMAT.MASK.FOR.CHARTS.DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char((5234.1),''FML999G999G999G999G990D00'') d, ''FML999G999G999G999G990D00'' r from dual',
'    union all',
'select trim(to_char((5234.1),''999G999G999G999G990D00'')) d, ''999G999G999G999G990D00'' r from dual',
'    union all',
'select trim(to_char((5234.1),''999G999G999G999G990D0000'')) d, ''999G999G999G999G990D0000'' r from dual',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(44798420131812391.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(114314002567890312.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''S''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(170713321121898589.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(49243501559614579.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''S''',
'',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(170713631164901556.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_tzr
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(49243714718618311.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''S''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_tzr_no_since
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(170713910516904980.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_numbers
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(441970320516445261.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_NUMBERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''N''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_w_download
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(189097425865243903.4001)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_W_DOWNLOAD'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from (',
'select d, r, t',
'  from wwv_flow_format_masks',
'union',
'select wwv_flow_lang.system_message(''BLOB_FORMAT'') d, ''BLOB'' r, ''A''',
'  from dual',
'order by 3 desc)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_item_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(276983704971116375.4001)
,p_lov_name=>'FORM_ITEM_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(276983704971116375.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(276983927598116379.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elementos de Entrada de Datos'
,p_lov_return_value=>'FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(276984120590116380.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Elementos de S\00F3lo Visualizaci\00F3n')
,p_lov_return_value=>'DISPLAY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_on_sp_item_display_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161974832535033307.4001)
,p_lov_name=>'FORM_ON_SP.ITEM_DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(161974832535033307.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24105515005047067.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea de Texto')
,p_lov_return_value=>'NATIVE_TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161975121396033308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00F3lo Visualizaci\00F3n')
,p_lov_return_value=>'NATIVE_DISPLAY_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161975324655033308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oculto'
,p_lov_return_value=>'NATIVE_HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161975507223033308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Contrase\00F1a')
,p_lov_return_value=>'NATIVE_PASSWORD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161975722167033309.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Campo de Texto'
,p_lov_return_value=>'NATIVE_TEXT_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161976700263033310.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha'
,p_lov_return_value=>'NATIVE_DATE_PICKER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_pagination_tables_in_schema
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8278125741110451.4001)
,p_lov_name=>'FORM_PAGINATION_TABLES_IN_SCHEMA'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P165_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_validation_data_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(197490902498999083.4001)
,p_lov_name=>'FORM_VALIDATION_DATA_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(197490902498999083.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197491131615999084.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(197491316482999084.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR'
,p_lov_return_value=>'VARCHAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/generic_report_layout
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(141528024100206812.4001)
,p_lov_name=>'GENERIC_REPORT_LAYOUT'
,p_lov_query=>'.'||wwv_flow_api.id(141528024100206812.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141542620899224770.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Crear Dise\00F1o de Informe Basado en Archivo')
,p_lov_return_value=>'FILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141528328048206813.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Usar Dise\00F1o de Informe Gen\00E9rico')
,p_lov_return_value=>'GENERIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/global_session_state_security
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(109607612170295323.4001)
,p_lov_name=>'GLOBAL.SESSION.STATE.SECURITY'
,p_lov_query=>'.'||wwv_flow_api.id(109607612170295323.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109608209132295340.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Desactivar'
,p_lov_return_value=>'DISABLE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''Y'''
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109608009604295340.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Activar'
,p_lov_return_value=>'ENABLE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''N'''
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(165639226722055203.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Configurar'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/global_set_session_state_security
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(114140130498629709.4001)
,p_lov_name=>'GLOBAL.SET.SESSION.STATE.SECURITY'
,p_lov_query=>'.'||wwv_flow_api.id(114140130498629709.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114140303209629712.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activar'
,p_lov_return_value=>'APP_ONLY'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:9007:&SESSION.::&DEBUG.:9006:P526_ACTION:APP_ONLY"><img src="#IMAGE_PREFIX#htmldb/builder/edit_page.gif" height="75" width="100" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114140503745629714.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Activar y Definir'
,p_lov_return_value=>'ALL'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:9006:&SESSION.::&DEBUG.:9006:P526_ACTION:ALL"><img src="#IMAGE_PREFIX#htmldb/builder/edit_page.gif" height="75" width="100" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/globalization_nls_comp
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(326783910743783589.4001)
,p_lov_name=>'GLOBALIZATION.NLS_COMP'
,p_lov_query=>'.'||wwv_flow_api.id(326783910743783589.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(340064531506850448.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Valor NLS de Sesi\00F3n de la Base de Datos (por defecto)')
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(326784217193783591.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Binario'
,p_lov_return_value=>'BINARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(326784521494783591.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Ling\00FC\00EDstica')
,p_lov_return_value=>'LINGUISTIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/grid_layout_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(203356809012666718.4001)
,p_lov_name=>'GRID_LAYOUT.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(203356809012666718.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203357017969666729.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tabla HTML'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203357326722666733.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('N\00FAmero Fijo de Columnas')
,p_lov_return_value=>'FIXED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(203357625148666733.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('N\00FAmero de Columnas Variable')
,p_lov_return_value=>'VARIABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/group_picker
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(212924308633451870.4001)
,p_lov_name=>'GROUP PICKER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hash_function
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(367957504585280755.4001)
,p_lov_name=>'HASH_FUNCTION'
,p_lov_query=>'.'||wwv_flow_api.id(367957504585280755.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367957804400280757.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SHA-1'
,p_lov_return_value=>'SH1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367958102306280760.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SHA-2, 256 bits (se necesita 12c)'
,p_lov_return_value=>'SH256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367958428314280760.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SHA-2, 384 bits (se necesita 12c)'
,p_lov_return_value=>'SH384'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367958707602280760.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SHA-2, 512 bits (se necesita 12c)'
,p_lov_return_value=>'SH512'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367959005808280761.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'MD5 [En desuso]'
,p_lov_return_value=>'MD5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hidden_or_hidden_and_protected
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131237822858809392.4001)
,p_lov_name=>'HIDDEN OR HIDDEN AND PROTECTED'
,p_lov_query=>'.'||wwv_flow_api.id(131237822858809392.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131238012226809394.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oculto y Protegido'
,p_lov_return_value=>'HIDDEN_PROTECTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131238205714809394.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Oculto'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/home_page_display_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(430811903296261990.4001)
,p_lov_name=>'HOME PAGE DISPLAY MODE'
,p_lov_query=>'.'||wwv_flow_api.id(430811903296261990.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(430812126757261993.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Utilizar Iconos'
,p_lov_return_value=>'ICONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(430812320446262006.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Utilizar Botones'
,p_lov_return_value=>'BUTTONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/horizontal_n_vertical_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(148121507217144506.4001)
,p_lov_name=>'HORIZONTAL_N_VERTICAL_Y'
,p_lov_query=>'.'||wwv_flow_api.id(148121507217144506.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(148122607695144519.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(148123400557144527.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/html_escaping_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(314983827117600277.4001)
,p_lov_name=>'HTML_ESCAPING_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(314983827117600277.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(314984126950600278.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('B\00E1sico')
,p_lov_return_value=>'B'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(314984408541600278.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Ampliado'
,p_lov_return_value=>'E'
);
end;
/
prompt --application/shared_components/user_interface/lovs/http_response_header
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(137613906194173724.4001)
,p_lov_name=>'HTTP_RESPONSE_HEADER'
,p_lov_query=>'.'||wwv_flow_api.id(137613906194173724.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137614421689173725.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Valores de Informe'
,p_lov_return_value=>'APEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(137614228757173725.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Servidor de Impresi\00F3n')
,p_lov_return_value=>'SERVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(144796827445692396.4001)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_lov_query=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9135511113548516.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Little Endian de Unicode UTF-16'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9205201229849121.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Big Endian de Unicode UTF-16'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(69601501664557233.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144797117419692400.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rabe (ISO-8859-6)')
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144797316057692402.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rabe (Windows 1256)')
,p_lov_return_value=>'windows-1256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144797500330692402.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chino (Big5)'
,p_lov_return_value=>'big5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144797708396692402.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chino (GBK)'
,p_lov_return_value=>'gbk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144797916474692403.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cir\00EDlico (ISO-8859-5)')
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144798131344692405.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cir\00EDlico (KOI8-R)')
,p_lov_return_value=>'koi8-r'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144798312837692405.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cir\00EDlico (KOI8-U)')
,p_lov_return_value=>'koi8-u'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144798504968692405.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cir\00EDlico (Windows 1251)')
,p_lov_return_value=>'windows-1251'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144798718838692405.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europeo Oriental (ISO-8859-2)'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144798932645692407.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europeo Oriental (Windows 1250)'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144799110457692407.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Griego (ISO-8859-7)'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144799314923692407.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Griego (Windows 1253)'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144799532216692407.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebreo (ISO-8859-8-i)'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144799706409692408.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebreo (Windows 1255)'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144799927372692408.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Japon\00E9s (EUC)')
,p_lov_return_value=>'euc-jp'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144800108899692408.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Japon\00E9s (Shift JIS)')
,p_lov_return_value=>'shift_jis'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144800330988692408.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Coreano (EUC)'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144800519069692409.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Noreuropeo (ISO-8859-4)'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144800711990692409.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Noreuropeo (Windows 1257)'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144800919398692409.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sudeuropeo (ISO-8859-3)'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144801121569692409.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Tailand\00E9s (TIS-620)')
,p_lov_return_value=>'tis-620'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144801321138692410.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turco (ISO-8859-9)'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144801513548692410.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turco (Windows 1254)'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144801730411692410.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode (UTF-8)'
,p_lov_return_value=>'utf-8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144801927440692410.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamita (Windows 1258)'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144802114623692411.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europeo Occidental (ISO-8859-1)'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144802329838692411.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Europeo Occidental (Windows 1252)'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_db_charset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(144802427115692411.4001)
,p_lov_name=>'I18N_IANA_DB_CHARSET'
,p_lov_query=>'.'||wwv_flow_api.id(144802427115692411.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144802705132692411.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (ISO-8859-6)')
,p_lov_return_value=>'AR8ISO8859P6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144802901122692412.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('\00C1rabe (Windows 1256)')
,p_lov_return_value=>'AR8MSWIN1256'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144803127029692412.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chino (Big5)'
,p_lov_return_value=>'ZHT16MSWIN950'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144803324377692412.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Chino (GBK)'
,p_lov_return_value=>'ZHS16GBK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144803513705692412.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Cir\00EDlico (ISO-8859-5)')
,p_lov_return_value=>'CL8ISO8859P5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144803729051692412.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Cir\00EDlico (KOI8-R)')
,p_lov_return_value=>'CL8KOI8R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144803903575692413.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Cir\00EDlico (KOI8-U)')
,p_lov_return_value=>'CL8KOI8U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144804107518692413.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Cir\00EDlico (Windows 1251)')
,p_lov_return_value=>'CL8MSWIN1251'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144804326415692413.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Europeo Oriental (ISO-8859-2)'
,p_lov_return_value=>'EE8ISO8859P2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144804519494692413.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Europeo Oriental (Windows 1250)'
,p_lov_return_value=>'EE8MSWIN1250'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144804719388692414.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Griego (ISO-8859-7)'
,p_lov_return_value=>'EL8ISO8859P7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144804930073692414.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Griego (Windows 1253)'
,p_lov_return_value=>'EL8MSWIN1253'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144805102017692414.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Hebreo (ISO-8859-8-i)'
,p_lov_return_value=>'IW8ISO8859P8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144805316824692414.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Hebreo (Windows 1255)'
,p_lov_return_value=>'IW8MSWIN1255'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144805529478692415.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('Japon\00E9s (EUC)')
,p_lov_return_value=>'JA16EUC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144805708758692415.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('Japon\00E9s (Shift JIS)')
,p_lov_return_value=>'JA16SJIS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144805930377692415.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Coreano (EUC)'
,p_lov_return_value=>'KO16MSWIN949'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144806119293692416.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Noreuropeo (ISO-8859-4)'
,p_lov_return_value=>'NEE8ISO8859P4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144806300284692416.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Noreuropeo (Windows 1257)'
,p_lov_return_value=>'BLT8MSWIN1257'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144806517452692416.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Sudeuropeo (ISO-8859-3)'
,p_lov_return_value=>'SE8ISO8859P3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144806722982692416.4001)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>unistr('Tailand\00E9s (TIS-620)')
,p_lov_return_value=>'TH8TISASCII'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144806902960692420.4001)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Turco (ISO-8859-9)'
,p_lov_return_value=>'WE8ISO8859P9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144807116856692420.4001)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Turco (Windows 1254)'
,p_lov_return_value=>'TR8MSWIN1254'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144807330588692420.4001)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Unicode (UTF-8)'
,p_lov_return_value=>'AL32UTF8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9135825312552564.4001)
,p_lov_disp_sequence=>242
,p_lov_disp_value=>'Big Endian de Unicode UTF-16'
,p_lov_return_value=>'AL16UTF16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9136032238554585.4001)
,p_lov_disp_sequence=>244
,p_lov_disp_value=>'Little Endian de Unicode UTF-16'
,p_lov_return_value=>'AL16UTF16LE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(69721018333590467.4001)
,p_lov_disp_sequence=>248
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'US7ASCII'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144807508184692421.4001)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Vietnamita (Windows 1258)'
,p_lov_return_value=>'VN8MSWIN1258'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144807715067692421.4001)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Europeo Occidental (ISO-8859-1)'
,p_lov_return_value=>'WE8ISO8859P1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(144807907122692421.4001)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'Europeo Occidental (Windows 1252)'
,p_lov_return_value=>'WE8MSWIN1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(107899321117195063.4001)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_lov_query=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62331376945397671.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaiyano (az)'
,p_lov_return_value=>'az'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109801549002953044.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Serbio (cir\00EDlico)(sr-cyrl)')
,p_lov_return_value=>'sr-cyrl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109801808436950709.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbio (latino)(sr-latn)'
,p_lov_return_value=>'sr-latn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198763720924437003.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198763917931437003.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (ar)')
,p_lov_return_value=>'ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198764111074437003.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Argelia) (ar-dz)')
,p_lov_return_value=>'ar-dz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198764302926437004.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Bahrein) (ar-bh)')
,p_lov_return_value=>'ar-bh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198764518950437004.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Egipto) (ar-eg)')
,p_lov_return_value=>'ar-eg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198764707881437004.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Irak) (ar-iq)')
,p_lov_return_value=>'ar-iq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198764920585437004.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Jordania) (ar-jo)')
,p_lov_return_value=>'ar-jo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198765125710437005.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Kuwait) (ar-kw)')
,p_lov_return_value=>'ar-kw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198765301909437005.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (L\00EDbano) (ar-lb)')
,p_lov_return_value=>'ar-lb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198765514908437005.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Libia) (ar-ly)')
,p_lov_return_value=>'ar-ly'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198765710657437005.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Marruecos) (ar-ma)')
,p_lov_return_value=>'ar-ma'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198765921945437006.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Om\00E1n) (ar-om)')
,p_lov_return_value=>'ar-om'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198766127407437006.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Qatar) (ar-qa)')
,p_lov_return_value=>'ar-qa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198766300363437006.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Arabia Saud\00ED) (ar-sa)')
,p_lov_return_value=>'ar-sa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198766505773437006.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Siria) (ar-sy)')
,p_lov_return_value=>'ar-sy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198766707839437007.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (T\00FAnez) (ar-tn)')
,p_lov_return_value=>'ar-tn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198766917417437007.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (E.A.U.) (ar-ae)')
,p_lov_return_value=>'ar-ae'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198767112053437007.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C1rabe (Yemen) (ar-ye)')
,p_lov_return_value=>'ar-ye'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198767312340437007.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Asam\00E9s (as)')
,p_lov_return_value=>'as'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198767522099437008.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vasco (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198767726246437008.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bielorruso (be)'
,p_lov_return_value=>'be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198767919601437008.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bengal\00ED (bn)')
,p_lov_return_value=>'bn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198768103556437008.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('B\00FAlgaro (bg)')
,p_lov_return_value=>'bg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198768313681437009.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Catal\00E1n (ca)')
,p_lov_return_value=>'ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198768503476437009.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chino (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198768717157437009.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chino (China) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198768915177437009.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chino (SAR de Hong Kong) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198769104560437010.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chino (SAR de Macao) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198769309316437010.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chino (Singapur) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198769519659437010.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Chino (Taiw\00E1n) (zh-tw)')
,p_lov_return_value=>'zh-tw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198769707113437011.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croata (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198769930859437011.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Checo (cs)'
,p_lov_return_value=>'cs'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198770121194437011.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Dan\00E9s (da)')
,p_lov_return_value=>'da'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198770321280437011.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Holand\00E9s (B\00E9lgica) (nl-be)')
,p_lov_return_value=>'nl-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198770514114437012.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Holand\00E9s (Pa\00EDses Bajos) (nl)')
,p_lov_return_value=>'nl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198770704682437012.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (en)')
,p_lov_return_value=>'en'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198770926869437012.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Australia) (en-au)')
,p_lov_return_value=>'en-au'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198771101039437012.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Belice) (en-bz)')
,p_lov_return_value=>'en-bz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198771311078437013.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Canad\00E1) (en-ca)')
,p_lov_return_value=>'en-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198771515830437013.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Irlanda) (en-ie)')
,p_lov_return_value=>'en-ie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198771701647437013.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Jamaica) (en-jm)')
,p_lov_return_value=>'en-jm'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198771911421437013.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Nueva Zelanda) (en-nz)')
,p_lov_return_value=>'en-nz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198772116247437014.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Filipinas) (en-ph)')
,p_lov_return_value=>'en-ph'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198772303293437014.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Sud\00E1frica) (en-za)')
,p_lov_return_value=>'en-za'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198772506232437014.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Trinidad) (en-tt)')
,p_lov_return_value=>'en-tt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198772709014437014.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Reino Unido) (en-gb)')
,p_lov_return_value=>'en-gb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198772921663437015.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Estados Unidos) (en-us)')
,p_lov_return_value=>'en-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198773103842437015.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s (Zimbabwe) (en-zw)')
,p_lov_return_value=>'en-zw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198773302783437015.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonio (et)'
,p_lov_return_value=>'et'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198773520055437015.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Macedonio FYRO (mk)'
,p_lov_return_value=>'mk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198773712018437016.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Fero\00E9s (fo)')
,p_lov_return_value=>'fo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198773905928437016.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198774118945437016.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s (Suiza) (fr-ch)')
,p_lov_return_value=>'fr-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198774304989437016.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Finland\00E9s (fi)')
,p_lov_return_value=>'fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198774521702437017.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s (B\00E9lgica) (fr-be)')
,p_lov_return_value=>'fr-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198774726368437017.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s (Canad\00E1) (fr-ca)')
,p_lov_return_value=>'fr-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198774928038437017.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s (Francia) (fr)')
,p_lov_return_value=>'fr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198775114927437017.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s (Luxemburgo) (fr-lu)')
,p_lov_return_value=>'fr-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198775332434437018.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s (M\00F3naco) (fr-mc)')
,p_lov_return_value=>'fr-mc'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198775527857437018.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ga\00E9lico (gd)')
,p_lov_return_value=>'gd'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198775711321437018.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gallego (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198775904103437018.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alem\00E1n (Austria) (de-at)')
,p_lov_return_value=>'de-at'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198776121734437019.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alem\00E1n (Alemania) (de)')
,p_lov_return_value=>'de'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198776332647437019.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alem\00E1n (Liechtenstein) (de-li)')
,p_lov_return_value=>'de-li'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198776529287437019.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alem\00E1n (Luxemburgo) (de-lu)')
,p_lov_return_value=>'de-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198776722310437019.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alem\00E1n (Suiza) (de-ch)')
,p_lov_return_value=>'de-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198776930154437020.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Griego (el)'
,p_lov_return_value=>'el'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198777117663437020.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gujarat\00ED (gu)')
,p_lov_return_value=>'gu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198777314234437020.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hebreo (he)'
,p_lov_return_value=>'he'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198777520312437020.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198777700475437021.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('H\00FAngaro (hu)')
,p_lov_return_value=>'hu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198777911922437021.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Island\00E9s (is)')
,p_lov_return_value=>'is'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198778128567437021.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesio (in)'
,p_lov_return_value=>'id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198778324997437021.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italiano (Italia) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198778510434437022.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italiano (Suiza) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198778714304437022.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Japon\00E9s (ja)')
,p_lov_return_value=>'ja'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198778912949437022.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Canar\00E9s (kn)')
,p_lov_return_value=>'kn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198779115578437022.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazajo (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198779329622437023.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198779521470437023.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Coreano (ko)'
,p_lov_return_value=>'ko'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198779730912437023.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kirguizo (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198779928215437023.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Let\00F3n (lv)')
,p_lov_return_value=>'lv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198780118707437024.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lituano (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198780313346437024.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayo (Malasia) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198780501262437024.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198780716986437024.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Malt\00E9s (mt)')
,p_lov_return_value=>'mt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198780925915437025.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198781122126437025.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Nepal\00ED (India) (ne)')
,p_lov_return_value=>'ne'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198781323201437025.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Noruego (Bokmal) (nb-no)'
,p_lov_return_value=>'nb-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198781531339437026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Noruego (Bokmal) (no)'
,p_lov_return_value=>'no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198781717582437026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Noruego (Nynorsk) (nn-no)'
,p_lov_return_value=>'nn-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198781901148437026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198782123357437026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polaco (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198782308585437026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Portugu\00E9s (Brasil) (pt-br)')
,p_lov_return_value=>'pt-br'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198782515205437027.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Portugu\00E9s (Portugal) (pt)')
,p_lov_return_value=>'pt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198782712809437027.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Punjab\00ED (pa)')
,p_lov_return_value=>'pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198782926250437027.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Rumano (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198783103701437028.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ruso (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198783313683437028.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ruso (Moldavia) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198783525893437028.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbio (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198783706765437028.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Eslovaco (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198783923934437029.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Esloveno (sl)'
,p_lov_return_value=>'sl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198784123775437029.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Argentina) (es-ar)')
,p_lov_return_value=>'es-ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198784305305437029.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Bolivia) (es-bo)')
,p_lov_return_value=>'es-bo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198784503555437029.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Chile) (es-cl)')
,p_lov_return_value=>'es-cl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198784728332437030.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Colombia) (es-co)')
,p_lov_return_value=>'es-co'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198784908380437030.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Costa Rica) (es-cr)')
,p_lov_return_value=>'es-cr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198785110585437030.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Rep\00FAblica Dominicana) (es-do)')
,p_lov_return_value=>'es-do'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198785309022437030.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Ecuador) (es-ec)')
,p_lov_return_value=>'es-ec'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198785513360437031.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (El Salvador) (es-sv)')
,p_lov_return_value=>'es-sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198785722922437031.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Guatemala) (es-gt)')
,p_lov_return_value=>'es-gt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198785903148437031.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Honduras) (es-hn)')
,p_lov_return_value=>'es-hn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198786119876437031.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (M\00E9xico) (es-mx)')
,p_lov_return_value=>'es-mx'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198786323820437032.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Nicaragua) (es-ni)')
,p_lov_return_value=>'es-ni'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198786501745437032.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Panam\00E1) (es-pa)')
,p_lov_return_value=>'es-pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198786728889437032.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Paraguay) (es-py)')
,p_lov_return_value=>'es-py'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198786926053437032.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Per\00FA) (es-pe)')
,p_lov_return_value=>'es-pe'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198787110239437033.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Puerto Rico) (es-pr)')
,p_lov_return_value=>'es-pr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198787325084437033.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Alfabeto Tradicional) (es)')
,p_lov_return_value=>'es'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198787517364437033.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Estados Unidos) (es-us)')
,p_lov_return_value=>'es-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198787727100437033.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Uruguay) (es-uy)')
,p_lov_return_value=>'es-uy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198787927315437033.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol (Venezuela) (es-ve)')
,p_lov_return_value=>'es-ve'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198788117011437034.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sueco (sv)'
,p_lov_return_value=>'sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198788328010437034.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sueco (Finlandia) (sv-fi)'
,p_lov_return_value=>'sv-fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198788517641437034.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamil (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198788706442437034.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Telugu (te)'
,p_lov_return_value=>'te'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198788903837437035.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tailand\00E9s (th)')
,p_lov_return_value=>'th'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198789120777437035.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turco (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198789331021437035.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ucraniano (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198789522886437035.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Urdu (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198789714421437036.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbeco (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198789914419437036.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamita (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(315594104997431311.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Irland\00E9s (ga)')
,p_lov_return_value=>'ga'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(315594428276435636.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gal\00E9s (cy)')
,p_lov_return_value=>'cy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(398755246199483774.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suajili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379664228886224616.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alban\00E9s')
,p_lov_return_value=>'sq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2379664559826228007.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Armenio'
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales_mapped_to_fb_flow_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(756583801210846491.4001)
,p_lov_name=>'I18N_LANGUAGES_LOCALES_MAPPED_TO_FB_FLOW_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov(translation_flow_language_code,''I18N_LANGUAGES_LOCALES'') d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_territories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(634612723768159258.4001)
,p_lov_name=>'I18N_TERRITORIES'
,p_lov_query=>'.'||wwv_flow_api.id(634612723768159258.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62332080749407778.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Azerbaiy\00E1n')
,p_lov_return_value=>'AZERBAIJAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634612925634159272.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argelia'
,p_lov_return_value=>'ALGERIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617325415178665.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Am\00E9rica')
,p_lov_return_value=>'AMERICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617416564179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentina'
,p_lov_return_value=>'ARGENTINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617520069179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Australia'
,p_lov_return_value=>'AUSTRALIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617601920179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Austria'
,p_lov_return_value=>'AUSTRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617719730179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bahr\00E9in')
,p_lov_return_value=>'BAHRAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617805450179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BANGLADESH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634617904577179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('B\00E9lgica')
,p_lov_return_value=>'BELGIUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618014801179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Brasil'
,p_lov_return_value=>'BRAZIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618131872179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgaria'
,p_lov_return_value=>'BULGARIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618228314179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Canad\00E1')
,p_lov_return_value=>'CANADA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618317133179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Catalu\00F1a')
,p_lov_return_value=>'CATALONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618420611179068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chile'
,p_lov_return_value=>'CHILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618517466179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'China'
,p_lov_return_value=>'CHINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618625184179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colombia'
,p_lov_return_value=>'COLOMBIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618732595179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'COSTA RICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618800875179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croacia'
,p_lov_return_value=>'CROATIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634618907315179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Rep\00FAblica Checa')
,p_lov_return_value=>'CZECH REPUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619005552179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dinamarca'
,p_lov_return_value=>'DENMARK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619102819179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ecuador'
,p_lov_return_value=>'ECUADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619206088179069.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Egipto'
,p_lov_return_value=>'EGYPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619329332179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'EL SALVADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619417007179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonia'
,p_lov_return_value=>'ESTONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619515038179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finlandia'
,p_lov_return_value=>'FINLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619624034179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Francia'
,p_lov_return_value=>'FRANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619712611179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Macedonia'
,p_lov_return_value=>'FYR MACEDONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619819469179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Alemania'
,p_lov_return_value=>'GERMANY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634619901797179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Grecia'
,p_lov_return_value=>'GREECE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620000995179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GUATEMALA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620128980179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HONG KONG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620216260179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Hungr\00EDa')
,p_lov_return_value=>'HUNGARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620321313179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Islandia'
,p_lov_return_value=>'ICELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620414838179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'India'
,p_lov_return_value=>'INDIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620531315179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesia'
,p_lov_return_value=>'INDONESIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620623190179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irak'
,p_lov_return_value=>'IRAQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620713620179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irlanda'
,p_lov_return_value=>'IRELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620825502179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Israel'
,p_lov_return_value=>'ISRAEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634620901008179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italia'
,p_lov_return_value=>'ITALY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621030274179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Jap\00F3n')
,p_lov_return_value=>'JAPAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621118591179070.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jordania'
,p_lov_return_value=>'JORDAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621221080179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Kazajst\00E1n')
,p_lov_return_value=>'KAZAKHSTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621324332179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Corea'
,p_lov_return_value=>'KOREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621428808179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kuwait'
,p_lov_return_value=>'KUWAIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621523349179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Letonia'
,p_lov_return_value=>'LATVIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621617780179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('L\00EDbano')
,p_lov_return_value=>'LEBANON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621730434179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libia'
,p_lov_return_value=>'LIBYA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621829023179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lituania'
,p_lov_return_value=>'LITHUANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634621931936179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Luxemburgo'
,p_lov_return_value=>'LUXEMBOURG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622011057179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malasia'
,p_lov_return_value=>'MALAYSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622121433179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('M\00E9xico')
,p_lov_return_value=>'MEXICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622209971179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marruecos'
,p_lov_return_value=>'MOROCCO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622316274179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nueva Zelanda'
,p_lov_return_value=>'NEW ZEALAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622424344179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NICARAGUA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622503049179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Noruega'
,p_lov_return_value=>'NORWAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622621796179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Om\00E1n')
,p_lov_return_value=>'OMAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622713614179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Panam\00E1')
,p_lov_return_value=>'PANAMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622824986179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Per\00FA')
,p_lov_return_value=>'PERU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634622920268179071.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Filipinas'
,p_lov_return_value=>'PHILIPPINES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623021563179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polonia'
,p_lov_return_value=>'POLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623129496179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PORTUGAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623217645179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Puerto Rico'
,p_lov_return_value=>'PUERTO RICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623330760179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QATAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623423279179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ruman\00EDa')
,p_lov_return_value=>'ROMANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623511418179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Rusia'
,p_lov_return_value=>'RUSSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623619236179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabia Saud\00ED')
,p_lov_return_value=>'SAUDI ARABIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623720537179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbia y Montenegro'
,p_lov_return_value=>'SERBIA AND MONTENEGRO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623812184179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Singapur'
,p_lov_return_value=>'SINGAPORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634623911000179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Eslovaquia'
,p_lov_return_value=>'SLOVAKIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624029069179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Eslovenia'
,p_lov_return_value=>'SLOVENIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624129059179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Sud\00E1frica')
,p_lov_return_value=>'SOUTH AFRICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624207346179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1a')
,p_lov_return_value=>'SPAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624313399179072.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suecia'
,p_lov_return_value=>'SWEDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624425936179076.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suiza'
,p_lov_return_value=>'SWITZERLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624529496179076.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Siria'
,p_lov_return_value=>'SYRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624617557179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Taiw\00E1n')
,p_lov_return_value=>'TAIWAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624710505179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tailandia'
,p_lov_return_value=>'THAILAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624807493179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Pa\00EDses Bajos')
,p_lov_return_value=>'THE NETHERLANDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634624919495179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('T\00FAnez')
,p_lov_return_value=>'TUNISIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625012403179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Turqu\00EDa')
,p_lov_return_value=>'TURKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625126075179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ucrania'
,p_lov_return_value=>'UKRAINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625205397179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Emiratos \00C1rabes Unidos')
,p_lov_return_value=>'UNITED ARAB EMIRATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625306022179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Reino Unido'
,p_lov_return_value=>'UNITED KINGDOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625413970179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Uzbekist\00E1n')
,p_lov_return_value=>'UZBEKISTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625513954179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Venezuela'
,p_lov_return_value=>'VENEZUELA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625626005179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnam'
,p_lov_return_value=>'VIETNAM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(634625710240179077.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yemen'
,p_lov_return_value=>'YEMEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_animation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(577722878770995845.4001)
,p_lov_name=>'ICON ANIMATION'
,p_lov_query=>'.'||wwv_flow_api.id(577722878770995845.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577723171929995847.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Rotaci\00F3n')
,p_lov_return_value=>'fa-anim-spin'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577723576533995850.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Rotaci\00F3n en pasos')
,p_lov_return_value=>'fa-anim-spin-step'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577723961937995850.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Flash'
,p_lov_return_value=>'fa-anim-flash'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577724321745995850.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Movimiento horizontal'
,p_lov_return_value=>'fa-anim-horizontal-shake'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577724777139995850.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Movimiento vertical'
,p_lov_return_value=>'fa-anim-vertical-shake'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_categories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(577691284053554107.4001)
,p_lov_name=>'ICON CATEGORIES'
,p_lov_query=>'.'||wwv_flow_api.id(577691284053554107.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577691593627554111.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Accesibilidad'
,p_lov_return_value=>'ACCESSIBILITY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577691952823554114.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577692301824554114.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577692726882554115.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Divisa'
,p_lov_return_value=>'CURRENCY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577693122003554115.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Direccional'
,p_lov_return_value=>'DIRECTIONAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577693541847554115.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Emoji'
,p_lov_return_value=>'EMOJI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577693922238554115.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tipo de Archivo'
,p_lov_return_value=>'FILE_TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577694301523554116.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Control de Pantalla'
,p_lov_return_value=>'FORM_CONTROL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577694781188554116.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Sexo'
,p_lov_return_value=>'GENDER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577695129448554116.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mano'
,p_lov_return_value=>'HAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577695507696554116.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('M\00E9dico')
,p_lov_return_value=>'MEDICAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577695969229554116.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('N\00FAmeros')
,p_lov_return_value=>'NUMBERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577696377143554117.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Pago'
,p_lov_return_value=>'PAYMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577696741617554117.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Selector'
,p_lov_return_value=>'SPINNER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577697186360554125.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Editor de Texto'
,p_lov_return_value=>'TEXT_EDITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577697771170564752.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Transporte'
,p_lov_return_value=>'TRANSPORTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577698096318564753.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('Reproductor de V\00EDdeo')
,p_lov_return_value=>'VIDEO_PLAYER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577698486427564753.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('Aplicaci\00F3n Web')
,p_lov_return_value=>'WEB_APPLICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(610340742405479426.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Mapas'
,p_lov_return_value=>'MAPS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_modifier
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(577742586590147796.4001)
,p_lov_name=>'ICON MODIFIER'
,p_lov_query=>'.'||wwv_flow_api.id(577742586590147796.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577742891771147796.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'25 %'
,p_lov_return_value=>'fam-25-percent'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577743228175147797.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'50 %'
,p_lov_return_value=>'fam-50-percent'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577743621479147797.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'75 %'
,p_lov_return_value=>'fam-75-percent'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577744006243147798.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'100 %'
,p_lov_return_value=>'fam-100-percent'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577744453509147798.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Flecha hacia abajo'
,p_lov_return_value=>'fam-arrow-down'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577744861593147798.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Flecha hacia izquierda'
,p_lov_return_value=>'fam-arrow-left'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577745253038147799.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Flecha hacia derecha'
,p_lov_return_value=>'fam-arrow-right'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577745695304147799.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Flecha hacia arriba'
,p_lov_return_value=>'fam-arrow-up'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577746022797147800.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'En Blanco'
,p_lov_return_value=>'fam-blank'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577746460643147800.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Comprobar'
,p_lov_return_value=>'fam-check'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577746806145147800.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('C\00EDrculo')
,p_lov_return_value=>'fam-circle'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577747264625147800.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Reloj'
,p_lov_return_value=>'fam-clock'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577747665892147800.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Puntos suspensivos horizontales'
,p_lov_return_value=>'fam-ellipsis-h'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577748081928147801.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Puntos suspensivos verticales'
,p_lov_return_value=>'fam-ellipsis-v'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577748430278147801.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Coraz\00F3n')
,p_lov_return_value=>'fam-heart'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577748910803151858.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Informaci\00F3n')
,p_lov_return_value=>'fam-information'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577749226646151858.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Menos'
,p_lov_return_value=>'fam-minus'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577749667009151858.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Pausar'
,p_lov_return_value=>'fam-pause'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577750392660159601.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('M\00E1s')
,p_lov_return_value=>'fam-plus'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577750060574159600.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Reproducir'
,p_lov_return_value=>'fam-play'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577750790392159601.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>unistr('Suspensi\00F3n')
,p_lov_return_value=>'fam-sleep'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577751113904159601.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Estrella'
,p_lov_return_value=>'fam-star'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577751577178159601.4001)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Parar'
,p_lov_return_value=>'fam-stop'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577751997570159603.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Advertencia'
,p_lov_return_value=>'fam-warning'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577752309659159603.4001)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'X'
,p_lov_return_value=>'fam-x'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_modifier_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(577752611204165565.4001)
,p_lov_name=>'ICON MODIFIER STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(577752611204165565.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577752963565165565.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Correcto'
,p_lov_return_value=>'fam-is-success'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577753360332165565.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Advertencia'
,p_lov_return_value=>'fam-is-warning'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577753798850165565.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Peligro'
,p_lov_return_value=>'fam-is-danger'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577754112742165566.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Informaci\00F3n')
,p_lov_return_value=>'fam-is-info'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577754522499165566.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'fam-is-disabled'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_preview_repository
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1845902759442614704.4001)
,p_lov_name=>'ICON PREVIEW REPOSITORY'
,p_lov_query=>'.'||wwv_flow_api.id(1845902759442614704.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1845903084419614712.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Iconos Utilizados Previamente'
,p_lov_return_value=>'STANDARD_ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(483162162223780333.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Fuente APEX'
,p_lov_return_value=>'FONTAPEX'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flow_user_interfaces ui',
' where ui.flow_id           = :FB_FLOW_ID',
'   and ui.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id            = ui.flow_id',
'   and t.theme_id           = ui.theme_id',
'   and t.security_group_id  = ui.security_group_id',
'   and t.icon_library       = ''FONTAPEX'''))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1845904233620614716.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Iconos de Font Awesome'
,p_lov_return_value=>'FONTAWESOME'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flow_user_interfaces ui',
' where ui.flow_id           = :FB_FLOW_ID',
'   and ui.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id            = ui.flow_id',
'   and t.theme_id           = ui.theme_id',
'   and t.security_group_id  = ui.security_group_id',
'   and t.icon_library       = ''FONTAWESOME'''))
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_rotate
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(577740129346133895.4001)
,p_lov_name=>'ICON ROTATE'
,p_lov_query=>'.'||wwv_flow_api.id(577740129346133895.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577740415199133896.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Girar 90'
,p_lov_return_value=>'fa-rotate-90'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577740873415133896.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Girar 180'
,p_lov_return_value=>'fa-rotate-180'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577741280627133896.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Girar 270'
,p_lov_return_value=>'fa-rotate-270'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577741676385133896.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Invertir horizontalmente'
,p_lov_return_value=>'fa-flip-horizontal'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577742097112133897.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Invertir verticalmente'
,p_lov_return_value=>'fa-flip-vertical'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_size
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(577725423197001069.4001)
,p_lov_name=>'ICON SIZE'
,p_lov_query=>'.'||wwv_flow_api.id(577725423197001069.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577725702259001069.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Peque\00F1o')
,p_lov_return_value=>'SMALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(577726102930001069.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Grande'
,p_lov_return_value=>'LARGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_libraries
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1284197032342757201.4001)
,p_lov_name=>'ICON_LIBRARIES'
,p_lov_query=>'.'||wwv_flow_api.id(1284197032342757201.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(482960538470359174.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Fuente APEX'
,p_lov_return_value=>'FONTAPEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(72460945675795418.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Fuente APEX - M\00E1s reciente')
,p_lov_return_value=>'FONTAPEX_LATEST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/image_preview_repository
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2545625667361279.4001)
,p_lov_name=>'IMAGE PREVIEW REPOSITORY'
,p_lov_query=>'.'||wwv_flow_api.id(2545625667361279.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2545817600361279.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Im\00E1genes Est\00E1ndar')
,p_lov_return_value=>'STANDARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2546030307361279.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Im\00E1genes de Espacio de Trabajo')
,p_lov_return_value=>'WORKSPACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2546221573361279.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Im\00E1genes de Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(483093902289716002.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Fuente APEX'
,p_lov_return_value=>'FONTAPEX'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flow_user_interfaces ui',
' where ui.flow_id           = :FB_FLOW_ID',
'   and ui.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id            = ui.flow_id',
'   and t.theme_id           = ui.theme_id',
'   and t.security_group_id  = ui.security_group_id',
'   and t.icon_library       = ''FONTAPEX'''))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1362021991963894895.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Iconos de Font Awesome'
,p_lov_return_value=>'FONTAWESOME'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flow_user_interfaces ui',
' where ui.flow_id           = :FB_FLOW_ID',
'   and ui.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id            = ui.flow_id',
'   and t.theme_id           = ui.theme_id',
'   and t.security_group_id  = ui.security_group_id',
'   and t.icon_library       = ''FONTAWESOME'''))
);
end;
/
prompt --application/shared_components/user_interface/lovs/image_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84856825191363086.4001)
,p_lov_name=>'IMAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84856825191363086.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84857007575363086.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Todas las Im\00E1genes')
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84857400079363087.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('S\00F3lo Im\00E1genes de Espacio de Trabajo')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84857607859363087.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('S\00F3lo Im\00E1genes de Aplicaci\00F3n')
,p_lov_return_value=>'3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_functions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60545525798060811.4001)
,p_lov_name=>'INCLUDE FUNCTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(60545525798060811.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60545732724060813.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Funciones'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_packages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60546306536064747.4001)
,p_lov_name=>'INCLUDE PACKAGES'
,p_lov_query=>'.'||wwv_flow_api.id(60546306536064747.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60546524313064747.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Paquetes'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_procedures
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(60547120735068828.4001)
,p_lov_name=>'INCLUDE PROCEDURES'
,p_lov_query=>'.'||wwv_flow_api.id(60547120735068828.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(60547315471068829.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Procedimientos'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_table_and_form_query_and_update
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(91319600010962461.4001)
,p_lov_name=>'INCLUDE TABLE AND FORM (QUERY AND UPDATE)'
,p_lov_query=>'.'||wwv_flow_api.id(91319600010962461.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91319803768962466.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00F3lo Consulta')
,p_lov_return_value=>'QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91320004153962467.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Consulta y Actualizaci\00F3n')
,p_lov_return_value=>'UPDATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6397115937331647.4001)
,p_lov_name=>'INCLUDE VIEWS'
,p_lov_query=>'.'||wwv_flow_api.id(6397115937331647.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6397327633331648.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vistas'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_analysis_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(168959914296647601.4001)
,p_lov_name=>'INCLUDE_ANALYSIS_PAGES'
,p_lov_query=>'.'||wwv_flow_api.id(168959914296647601.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168960106462647608.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Incluir P\00E1ginas de An\00E1lisis')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_custom_calendar
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(497222811063840780.4001)
,p_lov_name=>'INCLUDE_CUSTOM_CALENDAR'
,p_lov_query=>'select wwv_flow_lang.system_message(''CONFIRM.INCLUDE_CUSTOM_CALENDAR'') d, ''Y'' r from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_exclude
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84357332667662999.4001)
,p_lov_name=>'INCLUDE_EXCLUDE'
,p_lov_query=>'.'||wwv_flow_api.id(84357332667662999.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84357508456662999.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Excluir'
,p_lov_return_value=>'EXCLUDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84357711858663000.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Incluir'
,p_lov_return_value=>'INCLUDE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_legacy_javascript
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(723325277005791161.4001)
,p_lov_name=>'INCLUDE_LEGACY_JAVASCRIPT'
,p_lov_query=>'.'||wwv_flow_api.id(723325277005791161.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(723325530060791162.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Anterior a 18.1'
,p_lov_return_value=>'PRE18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(723325916568791163.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'18.x'
,p_lov_return_value=>'18'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_shared_components_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(417652505855073319.4001)
,p_lov_name=>'INCLUDE_SHARED_COMPONENTS_Y'
,p_lov_query=>'.'||wwv_flow_api.id(417652505855073319.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(417652808595073320.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Incluir Componentes Compartidos'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_success_message
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84362432452672420.4001)
,p_lov_name=>'INCLUDE_SUCCESS_MESSAGE'
,p_lov_query=>'.'||wwv_flow_api.id(84362432452672420.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84362620952672421.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'incluir mensaje de proceso correcto'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_flow_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(73071600194414972.4001)
,p_lov_name=>'INSTALL.FLOW.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(73071600194414972.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(73072113397414978.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Asignar Autom\00E1ticamente Nuevo Identificador de Aplicaci\00F3n')
,p_lov_return_value=>'AUTO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(73071919023414978.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Volver a Usar Identificador de Aplicaci\00F3n &P49_IMP_FLOW_ID. del Archivo de Exportaci\00F3n')
,p_lov_return_value=>'REUSE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(73106501130701222.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cambiar Identificador de Aplicaci\00F3n')
,p_lov_return_value=>'SPECIFY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/installer_build_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(35684329623125996.4001)
,p_lov_name=>'INSTALLER BUILD OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name, id from wwv_flow_patches ',
'where id in (select build_opt_id from wwv_flow_install_build_opt',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_condition_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2610902469203915.4001)
,p_lov_name=>'INSTALL_CONDITION_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2610902469203915.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2611107226203916.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Exists (la consulta SQL devuelve al menos una fila)'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2611302822203917.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NOT Exists (la consulta SQL no devuelve ninguna fila)'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2611722452203917.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Expresi\00F3n')
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2611903369203917.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n que devuelve un valor booleano')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2612125323203917.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Valor de Preferencia del Usuario en Expresi\00F3n 1 = Expresi\00F3n 2')
,p_lov_return_value=>'USER_PREF_IN_COND_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2612300618203918.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Valor de Preferencia del Usuario en Expresi\00F3n 1 != Expresi\00F3n 2')
,p_lov_return_value=>'USER_PREF_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2612510467203918.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 Incluido en el Texto de Expresi\00F3n 2')
,p_lov_return_value=>'DISPLAY_COND_IN_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2612716470203918.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 no Incluido en el Texto de Expresi\00F3n 2')
,p_lov_return_value=>'DISPLAY_COND_NOT_IN_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2612916275203918.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 = Expresi\00F3n 2 (incluye sustituciones &amp;ITEM)')
,p_lov_return_value=>'DISPLAY_COND_EQUAL_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2613122730203919.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 != Expresi\00F3n 2 (incluye sustituciones &amp;ITEM)')
,p_lov_return_value=>'DISP_COND_NOT_EQUAL_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2613308299203919.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Idioma Actual Incluido en Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_IN_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2613518327203919.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Idioma Actual no Incluido en Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_NOT_IN_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2613719056203919.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('Idioma Actual != Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_NOT_EQ_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2613931075203919.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Idioma Actual = Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_EQ_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2614914590207416.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Cuando CGI_ENV DAD_NAME = Expresi\00F3n 1')
,p_lov_return_value=>'DAD_NAME_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2615524633210304.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('Cuando CGI_ENV DAD_NAME != Expresi\00F3n 1')
,p_lov_return_value=>'DAD_NAME_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2615829827211851.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('Cuando CGI_ENV SERVER_NAME = Expresi\00F3n 1')
,p_lov_return_value=>'SERVER_NAME_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2616102946213515.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>unistr('Cuando CGI_ENV SERVER_NAME != Expresi\00F3n 1')
,p_lov_return_value=>'SERVER_NAME_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2616407448214867.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuando CGI_ENV HTTP_HOST = Expresi\00F3n 1')
,p_lov_return_value=>'HTTP_HOST_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2616711258215952.4001)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>unistr('Cuando CGI_ENV HTTP_HOST != Expresi\00F3n 1')
,p_lov_return_value=>'HTTP_HOST_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35854932212539564.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('El esquema de aplicaci\00F3n est\00E1 en forma de lista separada por comas en la Expresi\00F3n 1')
,p_lov_return_value=>'SCHEMA_IN_LIST'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'1=0'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35855211911543166.4001)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>unistr('El esquema de aplicaci\00F3n no est\00E1 en forma de lista separada por comas en la Expresi\00F3n 1')
,p_lov_return_value=>'SCHEMA_NOT_IN_LIST'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'1=0'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47908326353191665.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Versi\00F3n de Software Anterior < Versi\00F3n Especificada en Expresi\00F3n 1')
,p_lov_return_value=>'PREV_VERSION_LESS_THAN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47908631893193277.4001)
,p_lov_disp_sequence=>41
,p_lov_disp_value=>unistr('Versi\00F3n de Software Anterior = Versi\00F3n Especificada en Expresi\00F3n 1')
,p_lov_return_value=>'PREV_VERSION_EQUALS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47908904320194771.4001)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>unistr('Versi\00F3n de Software Anterior > Versi\00F3n Especificada en Expresi\00F3n 1')
,p_lov_return_value=>'PREV_VERSION_GREATER_THAN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2617015067217035.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Nunca'
,p_lov_return_value=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2617419223218210.4001)
,p_lov_disp_sequence=>101
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_script_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4626801323289842.4001)
,p_lov_name=>'INSTALL_SCRIPT_SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(4626801323289842.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4627023954289843.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4627422435289843.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Desde Archivo'
,p_lov_return_value=>'FILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(534087945348728527.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'A Partir de Objeto de Base de Datos'
,p_lov_return_value=>'DB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1711580816703200.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Paquete de datos'
,p_lov_return_value=>'DATA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_ws_app_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(504711916337338970.4001)
,p_lov_name=>'INSTALL_WS_APP_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(504711916337338970.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(504712121140338973.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Asignar Autom\00E1ticamente Nuevo Identificador de Aplicaci\00F3n')
,p_lov_return_value=>'AUTO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(504712330088338973.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Volver a Usar Identificador de Aplicaci\00F3n &P494_IMP_WS_APP_ID. desde Archivo de Exportaci\00F3n')
,p_lov_return_value=>'REUSE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(504712504417338973.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cambiar Identificador de Aplicaci\00F3n')
,p_lov_return_value=>'SPECIFY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/irr_rowid_or_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(114719118636380285.4001)
,p_lov_name=>'IRR.ROWID_OR_COLS'
,p_lov_query=>'.'||wwv_flow_api.id(114719118636380285.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114719413876380287.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ROWID'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114719616889380287.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Columna \00DAnica')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/irr_column_filter_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(147261022842307147.4001)
,p_lov_name=>'IRR_COLUMN_FILTER_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(147261022842307147.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147261325305307148.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147261517398307148.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Valor por Defecto Basado en Tipo de Columna'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147261708729307148.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Utilizar Lista de Valores Definida para Filtrar Coincidencia Exacta'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46425214824687279.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Utilizar Lista de Valores Definida para Filtrar la Palabra Contiene'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450175625286008190.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Utilice Lista de Valores con Nombre para Filtrar Coincidencia Exacta'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450177224509026910.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Utilizar Lista de Valores con Nombre para Filtrar la Palabra Contiene'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/irr_link_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(134903721394714997.4001)
,p_lov_name=>'IRR_LINK_COLUMN'
,p_lov_query=>'.'||wwv_flow_api.id(134903721394714997.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(134904030028714997.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Enlace a Vista de Una Sola Fila'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(134905202132718861.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Enlace a Destino Personalizado'
,p_lov_return_value=>'C'
,p_lov_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_lov_disp_cond=>'601'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(134904219905714998.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Excluir Columna de Enlace'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30663301353708410.4001)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_api.id(30663301353708410.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30663617752708413.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Diario'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30663926891708420.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Semanal'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30664230138708420.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mensual'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30664415898712648.4001)
,p_lov_name=>'IR_NOTIFY_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(30664415898712648.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30664728283712648.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ejecutado'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30665008213712648.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Enviado'
,p_lov_return_value=>'SENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(30665313148712651.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'ERROR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1703941607612344.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Omitido'
,p_lov_return_value=>'SKIPPED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_report_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(591769261601865016.4001)
,p_lov_name=>'IR_REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(591769261601865016.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(591769521956865020.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Por Defecto Primario'
,p_lov_return_value=>'PRIMARY_DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(591769894133865024.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Por Defecto Alternativo'
,p_lov_return_value=>'ALTERNATIVE_DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(591770186081865024.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('P\00FAblico')
,p_lov_return_value=>'PUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(591770409876865025.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Privado'
,p_lov_return_value=>'PRIVATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/iscolumn_name_text
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23469230991802389.4001)
,p_lov_name=>'ISCOLUMN.NAME.TEXT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<span class="instructiontext">''||',
'wwv_flow_lang.system_message(''F4300_INSTRUCT_TEXT'')||''</span>'' d, ''Y'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_and_report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(146337627678444760.4001)
,p_lov_name=>'ITEM AND REPORT'
,p_lov_query=>'.'||wwv_flow_api.id(146337627678444760.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(146337822091444773.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento de P\00E1gina')
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(146338027107444777.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_protection_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17287012676783081.4001)
,p_lov_name=>'ITEM PROTECTION LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(17287012676783081.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17287200195783083.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Restringido'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17287400587783083.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Total de Control Necesario: Nivel de Aplicaci\00F3n')
,p_lov_return_value=>'B'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17287603082783083.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Total de Control Necesario: Nivel de Usuario'
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17287806322783083.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Total de Control Necesario: Nivel de Sesi\00F3n')
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17304317734788157.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Restringido: No se puede definir desde el explorador'
,p_lov_return_value=>'I'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_protection_level_d
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(109261519627066371.4001)
,p_lov_name=>'ITEM PROTECTION LEVEL D'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(PAGE_PROTECTION_ENABLED_Y_N,''N'') p from wwv_flows where id = :FB_FLOW_ID) loop',
'    if c1.p = ''Y'' then',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_APPLICATION'''') d, ''''B'''' r',
'                  from dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_USER'''') d, ''''P'''' r',
'                  from dual union all               ',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_SESSION'''') d, ''''S'''' r',
'                  from dual union all               ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from dual'';',
'    else',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from dual union all ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from dual'';',
'    end if;',
'end loop;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_protection_level_no_restricted
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(109314413723246310.4001)
,p_lov_name=>'ITEM PROTECTION LEVEL NO RESTRICTED'
,p_lov_query=>'.'||wwv_flow_api.id(109314413723246310.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109314629939246312.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Restringido'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109314820854246316.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Total de Control Necesario: Nivel de Aplicaci\00F3n')
,p_lov_return_value=>'B'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109315024526246316.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Total de Control Necesario: Nivel de Usuario'
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109315221763246316.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Total de Control Necesario: Nivel de Sesi\00F3n')
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_caching_rule
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84930714296823567.4001)
,p_lov_name=>'ITEM.CACHING.RULE'
,p_lov_query=>'.'||wwv_flow_api.id(84930714296823567.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84930930267823568.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Siempre, sustituyendo cualquier valor existente en el estado de sesi\00F3n')
,p_lov_return_value=>'NO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84931103028823568.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('S\00F3lo cuando el valor de sesi\00F3n actual en el estado de sesi\00F3n sea nulo')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_default_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(38747715987262349.4001)
,p_lov_name=>'ITEM.DEFAULT.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(38747715987262349.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38748018541262374.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Texto Est\00E1tico con Sustituciones de Estado de Sesi\00F3n')
,p_lov_return_value=>'STATIC_TEXT_WITH_SUBSTITUTIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38748231848262376.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_lov_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38748428126262376.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL')
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_help_search
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84895631752563737.4001)
,p_lov_name=>'ITEM.HELP.SEARCH'
,p_lov_query=>'.'||wwv_flow_api.id(84895631752563737.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84895800944563739.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Todas las P\00E1ginas')
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84896012258563739.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00E1gina Actual')
,p_lov_return_value=>'CURRENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_button_template
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(387672699225327824.4001)
,p_lov_name=>'ITEM_BUTTON_TEMPLATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, ''template:''||id r',
'from   wwv_flow_button_templates',
'where  flow_id = :fb_flow_id and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(template_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_current_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84729824360877320.4001)
,p_lov_name=>'ITEM_CURRENT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84729824360877320.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14501616510583410.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina Actual es Destino')
,p_lov_return_value=>'TARGET_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84730000591877321.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84730215547877321.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Lista Delimitada por Comas de P\00E1ginas')
,p_lov_return_value=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84730407325877321.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Consulta SQL Exists'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84730612612877322.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Nunca'
,p_lov_return_value=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84730804253877322.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Consulta SQL NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84731025371877322.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Expresi\00F3n')
,p_lov_return_value=>'EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_source_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(129889837649.4001)
,p_lov_name=>'ITEM_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(129889837649.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(129890840816.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nulo'
,p_lov_return_value=>'ALWAYS_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(129891851389.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Asignaci\00F3n Est\00E1tica (el valor equivale al atributo de origen)')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(129892852681.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(458482816683473299.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Consulta SQL (devolver valores separados por dos puntos)'
,p_lov_return_value=>'QUERY_COLON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(129893855391.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Elemento (nombre de elemento de aplicaci\00F3n o p\00E1gina)')
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(129894857627.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Expresi\00F3n')
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(133432340478.4001)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(129895858879.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Columna de Base de Datos'
,p_lov_return_value=>'DB_COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76368092101.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Preferencia'
,p_lov_return_value=>'PREFERENCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_requires_application_context
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(29353308376249352.4001)
,p_lov_name=>'ITEM_TYPES (REQUIRES APPLICATION CONTEXT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name_with_prefix',
'  from wwv_flow_native_plugins',
' where plugin_type = ''ITEM TYPE''',
' union all',
'select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX''),',
'       ''PLUGIN_'' || name',
'  from wwv_flow_plugins',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type = ''ITEM TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_without_plugins
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(29544521926748713.4001)
,p_lov_name=>'ITEM_TYPES (WITHOUT PLUGINS)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_native_plugins varchar2(255);',
'begin',
'    l_native_plugins := '' union all select display_name as d, name_with_prefix as r from wwv_flow_native_plugins where plugin_type = ''''ITEM TYPE'''' order by 1'';',
'',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        return ''select display_name as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    else',
'        return ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    end if;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_including_button_requires_application_context
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(828112523658823842.4001)
,p_lov_name=>'ITEM_TYPES INCLUDING BUTTON (REQUIRES APPLICATION CONTEXT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lov varchar2(32767);',
'begin',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        l_lov := ''select display_name as d, name as r from wwv_flow_standard_item_types'';',
'    else',
'        l_lov := ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types'';',
'    end if;',
'',
'    return l_lov ||',
'           '' union all ''||',
'           ''select display_name, name_with_prefix from wwv_flow_native_plugins ''||',
'           ''where plugin_type = ''''ITEM TYPE''''''||',
'           '' union all ''||',
'           ''select display_name||wwv_flow_lang.system_message(''''PLUGIN.DISPLAY_NAME_POSTFIX''''), ''''PLUGIN_''''||name from wwv_flow_plugins ''||',
'           ''where flow_id = to_number(:FB_FLOW_ID) and security_group_id = to_number(:WORKSPACE_ID) and plugin_type = ''''ITEM TYPE'''' order by 1'';',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/iud_select
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88127426312675871.4001)
,p_lov_name=>'IUD.SELECT'
,p_lov_query=>'.'||wwv_flow_api.id(88127426312675871.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88156615137966014.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Insertar'
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88156828112966014.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Actualizar'
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88157015984966014.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Suprimir'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_coordinate
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(272269905187811870.4001)
,p_lov_name=>'JET_CHART_COORDINATE'
,p_lov_query=>'.'||wwv_flow_api.id(272269905187811870.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272270240012811871.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Polar'
,p_lov_return_value=>'polar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272270622978811872.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cartesiano'
,p_lov_return_value=>'cartesian'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_gallery
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(246508417548358609.4001)
,p_lov_name=>'JET_CHART_GALLERY'
,p_lov_query=>'.'||wwv_flow_api.id(246508417548358609.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246508701590358611.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea')
,p_lov_return_value=>'area'
,p_lov_template=>'#DISPLAY_VALUE#|chart-area'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246509129938358611.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Barra'
,p_lov_return_value=>'bar'
,p_lov_template=>'#DISPLAY_VALUE#|chart-bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205873042229302453.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('\00C1reas')
,p_lov_return_value=>'boxPlot'
,p_lov_template=>'#DISPLAY_VALUE#|chart-box-plot'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246509548297358616.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Burbuja'
,p_lov_return_value=>'bubble'
,p_lov_template=>'#DISPLAY_VALUE#|chart-bubble'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246509973226358616.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Combinaci\00F3n')
,p_lov_return_value=>'combo'
,p_lov_template=>'#DISPLAY_VALUE#|chart-combo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246510306110358617.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Indicador de Estado'
,p_lov_return_value=>'dial'
,p_lov_template=>'#DISPLAY_VALUE#|chart-dial'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308729675689444557.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Anillo'
,p_lov_return_value=>'donut'
,p_lov_template=>'#DISPLAY_VALUE#|chart-donut'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246510750377358617.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Embudo'
,p_lov_return_value=>'funnel'
,p_lov_template=>'#DISPLAY_VALUE#|chart-funnel'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(558148316798907518.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Gantt'
,p_lov_return_value=>'GANTT'
,p_lov_template=>'#DISPLAY_VALUE#|chart-gantt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246511142688358617.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('L\00EDnea')
,p_lov_return_value=>'line'
,p_lov_template=>'#DISPLAY_VALUE#|chart-line'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246511596688358617.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('L\00EDnea con \00C1rea')
,p_lov_return_value=>'lineWithArea'
,p_lov_template=>'#DISPLAY_VALUE#|chart-line-area'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246511943759358621.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Tarta'
,p_lov_return_value=>'pie'
,p_lov_template=>'#DISPLAY_VALUE#|chart-pie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308729953426446044.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Polar'
,p_lov_return_value=>'polar'
,p_lov_template=>'#DISPLAY_VALUE#|chart-polar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155504274794633386.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Pir\00E1mide')
,p_lov_return_value=>'pyramid'
,p_lov_template=>'#DISPLAY_VALUE#|chart-pyramid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308730221520447970.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Radial'
,p_lov_return_value=>'radar'
,p_lov_template=>'#DISPLAY_VALUE#|chart-radar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308730765229451160.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Rango'
,p_lov_return_value=>'range'
,p_lov_template=>'#DISPLAY_VALUE#|chart-range-bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246512388827358624.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('Dispersi\00F3n')
,p_lov_return_value=>'scatter'
,p_lov_template=>'#DISPLAY_VALUE#|chart-scatter'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(246512701000358624.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Stock'
,p_lov_return_value=>'stock'
,p_lov_template=>'#DISPLAY_VALUE#|chart-stock'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_legend
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(272324713923013998.4001)
,p_lov_name=>'JET_CHART_LEGEND'
,p_lov_query=>'.'||wwv_flow_api.id(272324713923013998.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272325099342014001.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'none'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272325497871014002.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Autom\00E1tico')
,p_lov_return_value=>'auto'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272325879803014002.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inferior'
,p_lov_return_value=>'bottom'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272326207002014002.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'end'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272326686037014003.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'start'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272327073014014003.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Principal'
,p_lov_return_value=>'top'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_orientation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(272256574572764306.4001)
,p_lov_name=>'JET_CHART_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_api.id(272256574572764306.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272256824856764320.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'horizontal'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(272257282840764322.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'vertical'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(285041260607381464.4001)
,p_lov_name=>'JET_CHART_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(285041260607381464.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285041507970381478.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea')
,p_lov_return_value=>'area'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285041919546381481.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Barra'
,p_lov_return_value=>'bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285042396209381481.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Burbuja'
,p_lov_return_value=>'bubble'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285042788719381482.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Combinaci\00F3n')
,p_lov_return_value=>'combo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285043177232381482.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Indicador de Estado'
,p_lov_return_value=>'dial'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308720430074729586.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Anillo'
,p_lov_return_value=>'donut'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285043586888381482.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Embudo'
,p_lov_return_value=>'funnel'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285043903336381482.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('L\00EDnea')
,p_lov_return_value=>'line'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285044346749381483.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('L\00EDnea con \00C1rea')
,p_lov_return_value=>'lineWithArea'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285044729648381483.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tarta'
,p_lov_return_value=>'pie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308719871403728110.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Polar'
,p_lov_return_value=>'polar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308720132434728806.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Radial'
,p_lov_return_value=>'radar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(308719513006727167.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Rango'
,p_lov_return_value=>'range'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285045130826381483.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('Dispersi\00F3n')
,p_lov_return_value=>'scatter'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285045589583381483.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Stock'
,p_lov_return_value=>'stock'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(155509538047810000.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('Pir\00E1mide')
,p_lov_return_value=>'pyramid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205878611297350098.4001)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>unistr('\00C1reas')
,p_lov_return_value=>'boxPlot'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_gauge_orientation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21606267597566254.4001)
,p_lov_name=>'JET_GAUGE_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_api.id(21606267597566254.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21606569316566254.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Circular'
,p_lov_return_value=>'circular'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21606931960566254.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'horizontal'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21607248117566255.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'vertical'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jstree_themes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(445986021038615393.4001)
,p_lov_name=>'JSTREE_THEMES'
,p_lov_query=>'.'||wwv_flow_api.id(445986021038615393.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445986827650615404.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Valor por Defecto'
,p_lov_return_value=>'default'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445986226113615399.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Azul'
,p_lov_return_value=>'apple'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445986611271615404.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Cl\00E1sica')
,p_lov_return_value=>'classic'
);
end;
/
prompt --application/shared_components/user_interface/lovs/label_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(43828319065855502.4001)
,p_lov_name=>'LABEL THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(43828319065855502.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43828604595855506.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Etiqueta Opcional con Ayuda'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43828821955855506.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Etiqueta Necesaria con Ayuda'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43829026521855506.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Etiqueta Opcional'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43829216754855507.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Etiqueta Necesaria'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44168504088920423.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sin Etiqueta'
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43829403095855507.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43829614163855507.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43829811310855507.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43830028586855508.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43830230461855508.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43830425504855508.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43830605003855508.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43830820404855509.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'12'
);
end;
/
prompt --application/shared_components/user_interface/lovs/label_alignment
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84757522618851451.4001)
,p_lov_name=>'LABEL_ALIGNMENT'
,p_lov_query=>'.'||wwv_flow_api.id(84757522618851451.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84757729764851451.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arriba'
,p_lov_return_value=>'ABOVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84757914076851452.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Abajo'
,p_lov_return_value=>'BELOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84758122408851452.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Centro'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84758309833851452.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Centro inferior'
,p_lov_return_value=>'CENTER-BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84758526184851452.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Centro Centro'
,p_lov_return_value=>'CENTER-CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84758718640851453.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Centro superior'
,p_lov_return_value=>'CENTER-TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84758917390851453.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84759122923851453.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Inicio (Abajo)'
,p_lov_return_value=>'LEFT-BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84759320284851453.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Inicio (Centro)'
,p_lov_return_value=>'LEFT-CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84759518480851454.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Inicio (Arriba)'
,p_lov_return_value=>'LEFT-TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84759731211851454.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'RIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84759903007851454.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Fin (Abajo)'
,p_lov_return_value=>'RIGHT-BOTTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84760105209851455.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Fin (Centro)'
,p_lov_return_value=>'RIGHT-CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84760318434851455.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Fin (Arriba)'
,p_lov_return_value=>'RIGHT-TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/label_template_wiz
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86598309219256908.4001)
,p_lov_name=>'LABEL_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_api.id(86598309219256908.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88294304634805085.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seleccione uno del repositorio de &PRODUCT_NAME.'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91902324410976802.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91903301685979689.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/languages_installed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(631619712812572565.4001)
,p_lov_name=>'LANGUAGES_INSTALLED'
,p_lov_query=>'.'||wwv_flow_api.id(631619712812572565.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631619916261572566.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ingl\00E9s')
,p_lov_return_value=>'en'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''zh-cn'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631620120219572571.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chino (China)'
,p_lov_return_value=>'zh-cn'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''zh-cn'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631620319438572571.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Chino (Taiw\00E1n)')
,p_lov_return_value=>'zh-tw'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''zh-tw'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631620524976572571.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Espa\00F1ol')
,p_lov_return_value=>'es'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''es'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631620730994572572.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italiano'
,p_lov_return_value=>'it'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''it'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631620918813572572.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franc\00E9s')
,p_lov_return_value=>'fr'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''fr'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631621107621572572.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Alem\00E1n')
,p_lov_return_value=>'de'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''de'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631621331959572572.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Japon\00E9s')
,p_lov_return_value=>'ja'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''ja'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631621516834572572.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Portugu\00E9s (Brasil)')
,p_lov_return_value=>'pt-br'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''pt-br'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797107324849116848.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Coreano'
,p_lov_return_value=>'ko'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''ko'')'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_derived_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(73566910745435962.4001)
,p_lov_name=>'LANGUAGE_DERIVED_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(73566910745435962.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88294907751806000.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Sin NLS (Aplicaci\00F3n no traducida)')
,p_lov_return_value=>'0'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88295118806806000.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Idioma Primario de la Aplicaci\00F3n')
,p_lov_return_value=>'FLOW_PRIMARY_LANGUAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88295311143806000.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Explorador (usar preferencia de idioma de explorador)'
,p_lov_return_value=>'BROWSER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88295501503806001.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Preferencia de Aplicaci\00F3n (usar FSP_LANGUAGE_PREFERENCE)')
,p_lov_return_value=>'FLOW_PREFERENCE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88295718259806001.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Preferencia de Elemento (usar elemento que contenga la preferencia)'
,p_lov_return_value=>'ITEM_PREFERENCE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(253845925497886980.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Sesi\00F3n')
,p_lov_return_value=>'SESSION'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_ssl_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(487674627120619297.4001)
,p_lov_name=>'LDAP_SSL_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(487674627120619297.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(487674822640619303.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SSL'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(487675029047619305.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('SSL con Autenticaci\00F3n')
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(487675215263619306.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sin SSL'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_ssl_plugin_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(29453800248365382.4001)
,p_lov_name=>'LDAP_SSL_PLUGIN_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(29453800248365382.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(29454107923365385.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SSL'
,p_lov_return_value=>'SSL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(29454406015365389.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('SSL con Autenticaci\00F3n')
,p_lov_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(29454730782365389.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sin SSL'
,p_lov_return_value=>'NO_SSL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_username_escaping
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(39475531325852002.4001)
,p_lov_name=>'LDAP_USERNAME_ESCAPING'
,p_lov_query=>'.'||wwv_flow_api.id(39475531325852002.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39475812001852003.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est\00E1ndar')
,p_lov_return_value=>'STD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39476117154852003.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('S\00F3lo caracteres especiales')
,p_lov_return_value=>'ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39476413911852003.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sin Escape'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/line_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84878309186453156.4001)
,p_lov_name=>'LINE_STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(84878309186453156.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84878510088453156.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Con Punto 1'
,p_lov_return_value=>'DOTTED_1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84878703174453157.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Con Punto 2'
,p_lov_return_value=>'DOTTED_2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84878910394453157.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Con Punto 3'
,p_lov_return_value=>'DOTTED_3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84879114364453157.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('S\00F3lido')
,p_lov_return_value=>'STRAIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/line_weight
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244579719911969185.4001)
,p_lov_name=>'LINE_WEIGHT'
,p_lov_query=>'.'||wwv_flow_api.id(244579719911969185.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244580030013969188.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244580206494969189.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244580404944969189.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244580616739969190.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244580829606969190.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244581020219969190.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244581203664969190.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'7'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244581404612969190.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244581619284969191.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'9'
,p_lov_return_value=>'9'
);
end;
/
prompt --application/shared_components/user_interface/lovs/link_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84330300975616054.4001)
,p_lov_name=>'LINK_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(84330300975616054.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88296717080806862.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nada'
,p_lov_return_value=>'NOTHING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88296510521806862.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Elemento de Aplicaci\00F3n Existente')
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/link_target
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84811707811178296.4001)
,p_lov_name=>'LINK_TARGET'
,p_lov_query=>'.'||wwv_flow_api.id(84811707811178296.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84811912899178296.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Aplicaci\00F3n Actual')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84812101106178297.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Todas las Aplicaciones'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84812328270178297.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL Remota'
,p_lov_return_value=>'E'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_deployment_p529
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(169222400131754330.4001)
,p_lov_name=>'LIST DEPLOYMENT P529'
,p_lov_query=>'.'||wwv_flow_api.id(169222400131754330.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(169222607062754337.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No Crear Regiones de Lista'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(169222802542754344.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Crear regi\00F3n de lista en p\00E1gina actual')
,p_lov_return_value=>'CURRENT_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(169223024966754344.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Crear regi\00F3n de lista para cada p\00E1gina de destino')
,p_lov_return_value=>'EACH_ENTRY'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'734'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_exportable_flows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(189999522998166355.4001)
,p_lov_name=>'LIST EXPORTABLE FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(312074852.4001)
,p_lov_name=>'LIST FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_items
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(918311972218937.4001)
,p_lov_name=>'LIST ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_item_link_text) d, id from (',
'select lpad('' '',4*(level-1),''.'')|| list_item_link_text list_item_link_text, id',
'from ( ',
'  select id, parent_list_item_id, list_item_display_sequence, list_item_link_text',
'  from wwv_flow_list_items i',
'  where flow_id = :FB_FLOW_ID',
'  and list_id = :F4000_P4052_LIST_ID',
'  and id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :F4000_P4052_LIST_ID',
'    start with id = :F4000_P4052_ID ',
'    connect by prior id = parent_list_item_id',
'  ))',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence',
')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_items_inline_edit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(108645906791566587.4001)
,p_lov_name=>'LIST ITEMS (INLINE EDIT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :P373_LIST_ID',
'    start with id = :P373_ID ',
'    connect by prior id = parent_list_item_id',
')',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P373_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_other_flows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(51319520349273399.4001)
,p_lov_name=>'LIST OTHER FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_page_regions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(246039671.4001)
,p_lov_name=>'LIST PAGE REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name, id from (',
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id,',
'       upper(plug_name) pn,',
'       1 x',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
'union',
'select wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'') ||',
'       r.plug_name || '' ('' || r.plug_display_sequence || '')'' as plug_name,',
'       r.id,',
'       upper(r.plug_name) pn,',
'       2 x',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and i.id                = p.user_interface_id',
'   and i.global_page_id   <> :fb_flow_page_id',
'   and r.flow_id           = i.flow_id',
'   and r.page_id           = i.global_page_id',
' order by 4, 3) v'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(313088181.4001)
,p_lov_name=>'LIST PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'N'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(556215676601931892.4001)
,p_query_column_name=>'ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(556216095466931893.4001)
,p_query_column_name=>'D'
,p_heading=>unistr('P\00E1gina')
,p_display_sequence=>20
,p_data_type=>'NUMBER'
);
wwv_flow_api.create_list_of_values_cols(
 p_id=>wwv_flow_api.id(556216448153931893.4001)
,p_query_column_name=>'N'
,p_heading=>'Nombre'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages_by_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3783172060018.4001)
,p_lov_name=>'LIST PAGES BY MODE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_page_mode varchar2(10);',
'  l_where     varchar2(100) := '''';',
'begin',
'  l_page_mode := wwv_flow_page_dev.get_page_mode(p_application_id => :FB_FLOW_ID, p_page_id => :FB_FLOW_PAGE_ID);',
'  ',
'  if l_page_mode <> ''NORMAL'' then',
'    l_where := ''and page_mode=''''''||l_page_mode||'''''' '';',
'  end if;',
'',
'    return ''select id||'''' ''''||name n, id ''||',
'           ''from wwv_flow_steps ''||',
'           ''where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id ''||l_where||',
'           ''order by 2 '';',
'',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages_escaped
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(375967232722946469.4001)
,p_lov_name=>'LIST PAGES ESCAPED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||wwv_flow_escape.html(name) n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pagetemplates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4569556776.4001)
,p_lov_name=>'LIST PAGETEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = (case when :P4301_PAGE_MODE = ''NORMAL'' then ''N'' else ''Y'' end)',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(43918610013174571.4001)
,p_lov_name=>'LIST THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(43918610013174571.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43918904551174576.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista Desordenada Vertical con Vi\00F1etas')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43919114507174577.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista Ordenada Vertical'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43919317508174577.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Enlaces Horizontal'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43919513966174577.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Im\00E1genes Horizontales con Lista de Etiquetas')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43919702448174577.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista de Im\00E1genes Vertical')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43919925901174577.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Botones'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43920119551174578.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista de Navegaci\00F3n con Tabuladores')
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43935130193237152.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Progreso del Asistente'
,p_lov_return_value=>'17'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(58168303369425651.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista Desordenada Vertical sin Vi\00F1etas')
,p_lov_return_value=>'18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(111810925131441282.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Men\00FA Desplegable')
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(111811229980442636.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Men\00FA Desplegable con Imagen')
,p_lov_return_value=>'21'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(165320913369513737.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Barras Laterales Vertical'
,p_lov_return_value=>'19'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43920508983174578.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43920717140174578.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43920901196174579.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43921121313174579.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43921328149174579.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43921510615174579.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43921731720174580.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43922216940176602.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172045731559260808.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ampliaci\00F3n Jer\00E1rquica')
,p_lov_return_value=>'22'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172048114721265462.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>unistr('Ampliado Jer\00E1rquico')
,p_lov_return_value=>'23'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_hosts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159071014187759020.4001)
,p_lov_name=>'LIST.LDAP.HOSTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_01 d,',
'       attribute_01 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_01 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_ports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159071623191761652.4001)
,p_lov_name=>'LIST.LDAP.PORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_02 d,',
'       attribute_02 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_02 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_search_filter
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(492934916113886709.4001)
,p_lov_name=>'LIST.LDAP.SEARCH_FILTER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_06 d,',
'       attribute_06 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_06 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_strings
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159072229424763439.4001)
,p_lov_name=>'LIST.LDAP.STRINGS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_04 d,',
'       attribute_04 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_04 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_username_edit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159073420552770275.4001)
,p_lov_name=>'LIST.LDAP.USERNAME.EDIT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_07 d,',
'       attribute_07 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_07 is not null',
'   and security_group_id = :WORKSPACE_ID',
' union',
'select ''return wwv_flow_custom_auth_std.ldap_dnprep;'' as d,',
'       ''return wwv_flow_custom_auth_std.ldap_dnprep;'' as r',
'  from dual',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_security_schemes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(166867621769552393.4001)
,p_lov_name=>'LIST.SECURITY.SCHEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, to_char(id) id',
'  from wwv_flow_security_schemes',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''MUST_NOT_BE_PUBLIC_USER'' name, ''MUST_NOT_BE_PUBLIC_USER'' id',
'  from sys.dual',
' order by name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_web_services
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(156841902941139735.4001)
,p_lov_name=>'LIST.WEB.SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/listallitems
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(598060166.4001)
,p_lov_name=>'LISTALLITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||wwv_flow_escape.html(name) a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||wwv_flow_escape.html(name) a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lists
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158508012343182689.4001)
,p_lov_name=>'LISTS'
,p_lov_query=>'select wwv_flow_escape.html(name) d, id from wwv_flow_lists where flow_id = :FB_FLOW_ID order by upper(name)'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(304941591413.4001)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(64000716365052273.4001)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_button_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62093031232114360.4001)
,p_lov_name=>'LIST_BUTTON_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''BUTTON''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_calendar_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62098012232137239.4001)
,p_lov_name=>'LIST_CALENDAR_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''CALENDAR''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_dialog_page_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(136602725312225757.4001)
,p_lov_name=>'LIST_DIALOG_PAGE_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = ''Y''',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flow_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(634347472712995.4001)
,p_lov_name=>'LIST_FLOW_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(634347472712995.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88157618253966938.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disponible'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88157826171966938.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Disponible con Barra de Herramientas de Desarrollador'
,p_lov_return_value=>'AVAILABLE_W_EDIT_LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88158015347966939.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Disponible S\00F3lo para Desarrolladores')
,p_lov_return_value=>'DEVELOPERS_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88158201893966939.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Acceso Restringido'
,p_lov_return_value=>'RESTRICTED_ACCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88158430795966939.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'No Disponible'
,p_lov_return_value=>'UNAVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88158618218966939.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'No Disponible (Estado Mostrado con PL/SQL)'
,p_lov_return_value=>'UNAVAILABLE_PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88158822851966939.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'No Disponible (Redirigir a URL)'
,p_lov_return_value=>'UNAVAILABLE_URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_label_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62099525391141046.4001)
,p_lov_name=>'LIST_LABEL_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_list_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62101404051144326.4001)
,p_lov_name=>'LIST_LIST_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_menu_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62102615133147515.4001)
,p_lov_name=>'LIST_MENU_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''MENU''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_page_items
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5818802865968207.4001)
,p_lov_name=>'LIST_PAGE_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''APPLICATION''))||',
''':''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_page_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62094620627120744.4001)
,p_lov_name=>'LIST_PAGE_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_parent_tabsets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(130412625318.4001)
,p_lov_name=>'LIST_PARENT_TABSETS'
,p_lov_query=>'select distinct wwv_flow_escape.html(tab_set) d, tab_set r from wwv_flow_toplevel_tabs where flow_id = :fb_flow_id order by 1'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_patches
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(198057397.4001)
,p_lov_name=>'LIST_PATCHES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_region_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62103530370151962.4001)
,p_lov_name=>'LIST_REGION_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_report_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62104811455155975.4001)
,p_lov_name=>'LIST_REPORT_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REPORT''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_schema
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(385522518549261442.4001)
,p_lov_name=>'LIST_SCHEMA'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flows',
' where id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_schemas_have_privs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(77465221343784725.4001)
,p_lov_name=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_tabsets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(130408529381.4001)
,p_lov_name=>'LIST_TABSETS'
,p_lov_query=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_template_wiz
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86596530905253701.4001)
,p_lov_name=>'LIST_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_api.id(86596530905253701.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88297313984807785.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seleccione uno del repositorio de &PRODUCT_NAME.'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88297514924807786.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88297709869807786.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_trees
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42828313831634427.4001)
,p_lov_name=>'LIST_TREES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(tree_name)||'' (''||initcap(tree_type)||'')'' d,',
'',
'       id',
'',
'from   wwv_flow_trees',
'',
'where  flow_id = :fb_flow_id and',
'',
'       security_group_id = :flow_security_group_id',
'',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_wiz_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(10676432019281440.4001)
,p_lov_name=>'LIST_WIZ_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(10676432019281440.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10676700422281446.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10676912271281449.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Como Copia de una Lista Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/load_data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23733127290776847.4001)
,p_lov_name=>'LOAD_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(23733127290776847.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23733404759776862.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23733619464776862.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23733832697776862.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23734009833776862.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23734214688776863.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'BINARY_FLOAT'
,p_lov_return_value=>'BINARY_FLOAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23734413485776863.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'BINARY_DOUBLE'
,p_lov_return_value=>'BINARY_DOUBLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173822017218331590.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'JSON CLOB'
,p_lov_return_value=>'JSON_CLOB'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version > 12 or (sys.dbms_db_version.version = 12 and sys.dbms_db_version.release >= 2)'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/locally_defined_lov_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3801130412459159.4001)
,p_lov_name=>'LOCALLY_DEFINED_LOV_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''SC.LOV.PAGE_ITEM'') d,',
'       ''PAGE_ITEM'' r',
'from sys.dual',
'union all',
'select wwv_flow_lang.system_message(''SC.LOV.IG_COLUMN'') d,',
'       ''IG_COLUMN'' r',
'from sys.dual'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'D'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lock_status_report_values
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(37430113453704739.4001)
,p_lov_name=>'LOCK STATUS REPORT VALUES'
,p_lov_query=>'.'||wwv_flow_api.id(37430113453704739.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37430310670704743.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Todas las P\00E1ginas')
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37430529682704745.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00E1ginas Bloqueadas')
,p_lov_return_value=>'LOCKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37430723675704745.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('P\00E1ginas Desbloqueadas')
,p_lov_return_value=>'UNLOCKED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lock_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(857850100888646856.4001)
,p_lov_name=>'LOCK_ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(857850100888646856.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(857850431729646858.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bloquear'
,p_lov_return_value=>'LOCK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(857850739143646859.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Desbloquear'
,p_lov_return_value=>'UNLOCK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(857851004836646859.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Actualizar'
,p_lov_return_value=>'UPDATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86589528912234244.4001)
,p_lov_name=>'LOGIN_PAGE_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'    select initcap(',
'wwv_flow_lang.system_message(''USE_PAGE_AS_LOGIN_PAGE'',id)) d, ''LOGIN'' r, 4 ob from wwv_flow_steps where flow_id=:FB_FLOW_ID and upper(alias) = ''LOGIN''',
'  union all',
'    select initcap(',
'wwv_flow_lang.system_message(''CREATE_NEW_LOGIN_PAGE'')) d, ''CREATE'' r,2 ob from dual where',
'not exists (select 1 from wwv_flow_steps where flow_id=:FB_FLOW_ID and upper(alias) = ''LOGIN'')',
'  union all',
'    select initcap(',
'wwv_flow_lang.system_message(''USE_BUILTIN_LOGIN_PAGE''))  d,''-BUILTIN-'' r, 9 ob from dual)',
'order by ob'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/logo_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461376702019738964.4001)
,p_lov_name=>'LOGO ATTRIBUTES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84909926183685150.4001)
,p_lov_name=>'LOV.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84909926183685150.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84910313696685150.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Est\00E1tico')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84910101277685150.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Din\00E1mico')
,p_lov_return_value=>'DYNAMIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_column_display_roles
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23061073014556223.4001)
,p_lov_name=>'LOV_COLUMN_DISPLAY_ROLES'
,p_lov_query=>'.'||wwv_flow_api.id(23061073014556223.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23061734797556224.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostrado (primario)'
,p_lov_return_value=>'PRIMARY_DISPLAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23062121904556224.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Mostrado'
,p_lov_return_value=>'DISPLAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23062584379556225.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Agrupar por'
,p_lov_return_value=>'GROUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23062990524556225.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Icono'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23195602034190758.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Oculto'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_credential_stores
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(154515733779642473.4001)
,p_lov_name=>'LOV_CREDENTIAL_STORES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_translated
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86578518083174290.4001)
,p_lov_name=>'LOV_TRANSLATED'
,p_lov_query=>'.'||wwv_flow_api.id(86578518083174290.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88298317101808717.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_wiz_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84344914743638898.4001)
,p_lov_name=>'LOV_WIZ_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(84344914743638898.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88299120564809761.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88299310826809761.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Como Copia de una Lista de Valores Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lanugagecodes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(61396703881.4001)
,p_lov_name=>'LanugageCodes'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select translation_flow_language_code',
'',
'from   wwv_flow_language_map',
'',
'where  primary_language_flow_id = :FB_FLOW_ID',
'',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/manage_dev_pref_view_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93546719421230687.4001)
,p_lov_name=>'MANAGE_DEV_PREF_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(93546719421230687.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93546924483230689.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Iconos'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93547106760230689.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Detalles'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_geometry_column_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2214661182663976.4001)
,p_lov_name=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(2214661182663976.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2214906878663985.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Columna de Geometr\00EDa')
,p_lov_return_value=>'GEOMETRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2215331932663988.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Dos columnas num\00E9ricas')
,p_lov_return_value=>'NUMBER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_layer_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2204527800561582.4001)
,p_lov_name=>'MAP_REGION_LAYER_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(2204527800561582.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2204840421561687.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Puntos'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#|map-points'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2205270686561690.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('L\00EDneas')
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#|map-lines'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2205538404561690.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Pol\00EDgonos')
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#|map-polygons'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2205977070561690.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Mapa de Calor'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#|map-heatmap'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2206380320561695.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Pol\00EDgonos extruidos')
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#|map-extruded-polgygons'
);
end;
/
prompt --application/shared_components/user_interface/lovs/marctest
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(125887329626694870.4001)
,p_lov_name=>'MARCTEST'
,p_lov_query=>'.'||wwv_flow_api.id(125887329626694870.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125887611763694871.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'aaa'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125887930721694872.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'bbb'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125888224602694872.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'ccc'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125888508873694872.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'ddd'
,p_lov_return_value=>'40'
);
end;
/
prompt --application/shared_components/user_interface/lovs/marker_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84879717151455385.4001)
,p_lov_name=>'MARKER_STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(84879717151455385.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84879905128455386.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('C\00EDrculo')
,p_lov_return_value=>'CIRCLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84880123391455386.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Diamante'
,p_lov_return_value=>'DIAMOND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84880312259455387.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Cuadrado'
,p_lov_return_value=>'SQUARE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84880528001455387.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Tri\00E1ngulo')
,p_lov_return_value=>'TRIANGLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/maximum_rows_per_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84800803131139158.4001)
,p_lov_name=>'MAXIMUM ROWS PER PAGE'
,p_lov_query=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180345125591578775.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84801031902139159.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84801207012139159.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84801406447139159.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84801631719139159.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239238717004567042.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84801809006139160.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84802017106139160.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'75'
,p_lov_return_value=>'75'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84802230048139160.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84802410431139160.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84802619722139161.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84802809542139161.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(43945521366272493.4001)
,p_lov_name=>'MENU THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(43945521366272493.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43945822796272497.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43946021659272497.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Jer\00E1rquico')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43946200038272497.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43946403201272498.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43946615168272498.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43946827418272498.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43947018619272498.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43947229068272498.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43947419430272499.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(43947619554272499.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'10'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(146659516889284778.4001)
,p_lov_name=>'MENU.TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id',
'  from wwv_flow_menu_templates',
' where flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_start_with
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84876111826444446.4001)
,p_lov_name=>'MENU_START_WITH'
,p_lov_query=>'.'||wwv_flow_api.id(84876111826444446.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84876328851444446.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entradas de Ruta de Navegaci\00F3n Secundarias')
,p_lov_return_value=>'CHILD_MENU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84876509333444446.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n Actual')
,p_lov_return_value=>'CURRENT_MENU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84876719009444447.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Entradas de Ruta de Navegaci\00F3n Principales')
,p_lov_return_value=>'PARENT_MENU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84876912643444447.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Principal a Hoja (estilo de ruta de navegaci\00F3n)')
,p_lov_return_value=>'PARENT_TO_LEAF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_template_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86077012626803751.4001)
,p_lov_name=>'MENU_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(86077012626803751.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88299923681810664.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88300108885810665.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/mobile_page_template
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4794802534531342.4001)
,p_lov_name=>'MOBILE_PAGE_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_api.id(4794802534531342.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4795112307531465.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Explorador Est\00E1ndar')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_users
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(240554501608741323.4001)
,p_lov_name=>'MODEL USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(m.created_by) d, m.created_by r',
'from wwv_flow_models m, wwv_flow_model_pages p, wwv_flow_company_schemas s',
'where m.id = p.model_id ',
'and   m.owner = s.schema',
'and m.security_group_id = :flow_security_group_id',
'and s.security_group_id = :flow_security_group_id',
'and m.model_complete = ''Y''',
'group by m.created_by'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_link_extra_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(148927707220116911.4001)
,p_lov_name=>'MODEL_LINK_EXTRA_COLUMN'
,p_lov_query=>'.'||wwv_flow_api.id(148927707220116911.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(148928000552116912.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Usar Columna Adicional para Mostrar Enlace'
,p_lov_return_value=>'LINK_COLUMN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_link_to_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(152446125589862819.4001)
,p_lov_name=>'MODEL_LINK_TO_PAGE'
,p_lov_query=>'.'||wwv_flow_api.id(152446125589862819.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152446325930862821.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bot\00F3n Editar Espec\00EDfico del Tema')
,p_lov_return_value=>'LINK_COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147361702073726841.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Columna de Informe'
,p_lov_return_value=>'REPORT_COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(147371230863763536.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Enlace Personalizado'
,p_lov_return_value=>'CUSTOM_LINK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_use_theme_button
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153128814386643499.4001)
,p_lov_name=>'MODEL_USE_THEME_BUTTON'
,p_lov_query=>'.'||wwv_flow_api.id(153128814386643499.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153129027237643499.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Utilice el bot\00F3n de edici\00F3n espec\00EDfico del tema')
,p_lov_return_value=>'THEME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/named_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5278749326.4001)
,p_lov_name=>'NAMED_LOV'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(lov_name) d, lov_name r',
'',
'from wwv_flow_lists_of_values$',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/named_lov_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(73045019699242595.4001)
,p_lov_name=>'NAMED_LOV_RETURNING_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(lov_name) d, id',
'',
'from wwv_flow_lists_of_values$',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/navigation_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(402883664167278311.4001)
,p_lov_name=>'NAVIGATION LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.name, l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/navigation_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174541309940513694.4001)
,p_lov_name=>'NAVIGATION TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(174541309940513694.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174541620822513696.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separadores'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174541910206513699.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'L'
);
end;
/
prompt --application/shared_components/user_interface/lovs/navigation_bar_position
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1383752466189575385.4001)
,p_lov_name=>'NAVIGATION_BAR_POSITION'
,p_lov_query=>'.'||wwv_flow_api.id(1383752466189575385.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1383752716721575387.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Principal'
,p_lov_return_value=>'TOP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1383753025830575387.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cara'
,p_lov_return_value=>'SIDE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_bar_create_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84245132593407471.4001)
,p_lov_name=>'NAV_BAR_CREATE_METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(84245132593407471.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88302321041819363.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nueva'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88302522891819363.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Como Copia de Barra de Navegaci\00F3n Existente')
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_bar_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1383750926477562234.4001)
,p_lov_name=>'NAV_BAR_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(1383750926477562234.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1383751231985562235.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cl\00E1sica')
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1383751513527562236.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_menu_position_icons
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1856613427542451349.4001)
,p_lov_name=>'NAV_MENU_POSITION_ICONS'
,p_lov_query=>'.'||wwv_flow_api.id(1856613427542451349.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1856613755632451354.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Principal'
,p_lov_return_value=>'TOP'
,p_lov_template=>'<span class="a-Icon icon-nav-top" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1856614196674451355.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cara'
,p_lov_return_value=>'SIDE'
,p_lov_template=>'<span class="a-Icon icon-nav-side" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41348803113175334.4001)
,p_lov_name=>'NEW'
,p_lov_query=>'.'||wwv_flow_api.id(41348803113175334.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41353729217192272.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Nueva P\00E1gina')
,p_lov_return_value=>'NEW_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41349526190175350.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n en esta P\00E1gina')
,p_lov_return_value=>'NEW_REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41349127275175345.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Control de P\00E1gina en esta P\00E1gina')
,p_lov_return_value=>'NEW_PAGE_CONTROL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41349322741175350.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Control Compartido'
,p_lov_return_value=>'NEW_SHARED_COMPONENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_flow_component
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(56261603527740250.4001)
,p_lov_name=>'NEW.FLOW.COMPONENT'
,p_lov_query=>'.'||wwv_flow_api.id(56261603527740250.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155882395637829140.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00E1lculo de Aplicaci\00F3n')
,p_lov_return_value=>'APP_COMPUTATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155881827328817113.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Elemento de Aplicaci\00F3n')
,p_lov_return_value=>'APP_ITEM'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155879848948783070.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Proceso de Aplicaci\00F3n')
,p_lov_return_value=>'APP_PROCESS'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155883932250884540.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Esquema de Autenticaci\00F3n')
,p_lov_return_value=>'AUTHENTICATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155878330459754175.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Esquema de Autorizaci\00F3n')
,p_lov_return_value=>'AUTH_SCHEME'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(56262910363740259.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'MENU'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155884584340896995.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Opci\00F3n de Creaci\00F3n')
,p_lov_return_value=>'BUILD_OPT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(56262729926740259.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(56262512111740259.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Lista de Valores'
,p_lov_return_value=>'LOV'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(56261902885740255.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Entrada de Barra de Navegaci\00F3n')
,p_lov_return_value=>'NAVBAR'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(56262124240740258.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Separador Principal'
,p_lov_return_value=>'PTAB'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155885541473911064.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Plugin'
,p_lov_return_value=>'PLUGIN'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155876629693724292.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Dise\00F1o de Informe')
,p_lov_return_value=>'REP_LAYOUT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155875729258709848.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Consulta de Informe'
,p_lov_return_value=>'REP_QRY'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155877287613732395.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('M\00E9todo Abreviado')
,p_lov_return_value=>'SHORTCUT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(56262327091740258.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Separador Est\00E1ndar')
,p_lov_return_value=>'STAB'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155880688440799375.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('Archivo de Aplicaci\00F3n Est\00E1tico')
,p_lov_return_value=>'APP_FILE'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155881249285807487.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('Archivo de Espacio de Trabajo Est\00E1tico')
,p_lov_return_value=>'WS_FILE'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155885032437902193.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Plantilla'
,p_lov_return_value=>'TEMPLATE'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155879177309770213.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mensaje de Texto'
,p_lov_return_value=>'TEXT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1155874775728640463.4001)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Referencia de Servicio Web'
,p_lov_return_value=>'WS_REF'
,p_lov_template=>'#DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_form_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(54502713568963394.4001)
,p_lov_name=>'NEW.FORM.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(54502713568963394.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(54503231398963400.4001)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Pantalla Basada en Tabla'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-table'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(54503811384963401.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Pantalla Basada en Consulta SQL'
,p_lov_return_value=>'FORMONSQL'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-sql'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(54503606699963400.4001)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Pantalla Basada en Procedimiento'
,p_lov_return_value=>'FORMONPROC'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-procedure'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(202747215734446805.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Pantalla Basada en Servicio Web'
,p_lov_return_value=>'FORMWS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-report-webservice'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_page_component_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(55966712494123138.4001)
,p_lov_name=>'NEW.PAGE.COMPONENT.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(55966712494123138.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55967204428123139.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Elemento'
,p_lov_return_value=>'ITEM'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55967628285123140.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55967422140123139.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Bifurcaci\00F3n')
,p_lov_return_value=>'BRANCH'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55967827403123140.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('C\00E1lculo')
,p_lov_return_value=>'COMPUTATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55968021272123140.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Proceso'
,p_lov_return_value=>'PROCESS'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55968210751123141.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Validaci\00F3n')
,p_lov_return_value=>'VALIDATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/no_show_success_in_future
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84732526223887360.4001)
,p_lov_name=>'NO_SHOW_SUCCESS_IN_FUTURE'
,p_lov_query=>'.'||wwv_flow_api.id(84732526223887360.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84732711793887361.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('No Mostrar P\00E1gina Correcta en el Futuro')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(277431029384153056.4001)
,p_lov_name=>'OBJECT.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(277431029384153056.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277431204230153061.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Funci\00F3n')
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277431400869153065.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('\00CDndice')
,p_lov_return_value=>'INDEX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277431613646153065.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Paquete'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277431823408153065.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Procedimiento'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277432017860153065.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Secuencia'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277432208891153066.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Sin\00F3nimo')
,p_lov_return_value=>'SYNONYM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277432406661153066.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tabla'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277432614868153066.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Disparador'
,p_lov_return_value=>'TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(277432808078153066.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Ver'
,p_lov_return_value=>'VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(51094563587826026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tipo'
,p_lov_return_value=>'TYPE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/on_demand_processes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(156837711683123346.4001)
,p_lov_name=>'ON.DEMAND.PROCESSES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(process_name) d, id r',
'',
'  from wwv_flow_processing',
'',
'where flow_id = :fb_flow_id and process_point = ''ON_DEMAND''',
'',
' order by process_name',
'',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/on_off
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9165706597746719.4001)
,p_lov_name=>'ON_OFF'
,p_lov_query=>'.'||wwv_flow_api.id(9165706597746719.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9165915858746727.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Activado'
,p_lov_return_value=>'ON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9166117224746730.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'OFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/orphaned_lists_display
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(94838211998345101.4001)
,p_lov_name=>'ORPHANED_LISTS_DISPLAY'
,p_lov_query=>'.'||wwv_flow_api.id(94838211998345101.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94838503112345102.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Hu\00E9rfano')
,p_lov_return_value=>'O'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94838713034345102.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Todo'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p104_sync_page_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(123726144609302218.4001)
,p_lov_name=>'P104_SYNC_PAGE_NAME'
,p_lov_query=>'.'||wwv_flow_api.id(123726144609302218.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(123726345582302214.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('sincronice el nombre y el t\00EDtulo de la p\00E1gina')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p105_all_my_files
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153643805218811160.4001)
,p_lov_name=>'P105_ALL_MY_FILES'
,p_lov_query=>'.'||wwv_flow_api.id(153643805218811160.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153644123892811161.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mis Archivos'
,p_lov_return_value=>'MY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153644329503811161.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Todos los Archivos'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p143_grid_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(217410917274629373.4001)
,p_lov_name=>'P143.GRID_COLUMN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P143_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1556_display_selections
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(112777512483182861.4001)
,p_lov_name=>'P1556_DISPLAY_SELECTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(112777512483182861.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112777702670182866.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'- Todo -'
,p_lov_return_value=>'All'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112777913428182869.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Etiqueta'
,p_lov_return_value=>'L'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112778103167182870.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mostrar como'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112778319856182870.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Formato'
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112778517171182870.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Valor por Defecto de Pantalla'
,p_lov_return_value=>'V'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112778711439182870.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Tama\00F1o de Visualizaci\00F3n')
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112778913135182870.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Ayuda de Pantalla'
,p_lov_return_value=>'H'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112779121557182871.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Alineaci\00F3n de Informes')
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1610_actions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(249294887509698711.4001)
,p_lov_name=>'P1610_ACTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(249294887509698711.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249295104828698712.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nueva'
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249295509034698713.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Como copia de un servicio de SQL activado para REST'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1612_copy
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(249334505721803809.4001)
,p_lov_name=>'P1612.COPY'
,p_lov_query=>'.'||wwv_flow_api.id(249334505721803809.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249334893554803810.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249335284311803810.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(249335642186803811.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copiar y Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P1611_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1700_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(381833322409586869.4001)
,p_lov_name=>'P1700_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p173_show
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48989614083583743.4001)
,p_lov_name=>'P173_SHOW'
,p_lov_query=>'.'||wwv_flow_api.id(48989614083583743.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48989812927583749.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Plantillas de Aplicaci\00F3n')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48990014681583750.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Recuentos de Plantillas de Tema'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205410028377606456.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Referencias de Archivo'
,p_lov_return_value=>'FILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205425424268633678.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Referencias de Clase'
,p_lov_return_value=>'CLASS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(205426329116635065.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Cadenas de Sustituci\00F3n de Plantillas')
,p_lov_return_value=>'TEMPLATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p176_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(714200985818178118.4001)
,p_lov_name=>'P176_PAGE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(714200985818178118.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(714201271961178121.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Informe y Pantalla'
,p_lov_return_value=>'REPORT_AND_FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(714201627845178122.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Una P\00E1gina')
,p_lov_return_value=>'SINGLE_PG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p176_report_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(329353513116624468.4001)
,p_lov_name=>'P176_REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(329353513116624468.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(329353826739624470.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Informe Interactivo'
,p_lov_return_value=>'INTERACTIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(713173926577991309.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuadr\00EDcula Interactiva')
,p_lov_return_value=>'IG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(329354106024624470.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Informe Cl\00E1sico')
,p_lov_return_value=>'CLASSIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1801_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1172046023461279303.4001)
,p_lov_name=>'P1801_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1801_table_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(705239800153899318.4001)
,p_lov_name=>'P1801_TABLE_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, ID return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where name = :P1801_NAME',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1802_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(694138215390835955.4001)
,p_lov_name=>'P1802_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1812_collection_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3007625702757031.4001)
,p_lov_name=>'P1812_COLLECTION_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :OWNER',
'and table_name = ''WWV_FLOW_COLLECTIONS''',
'and data_type not in ( ''BLOB'', ''XMLTYPE'' )',
'and column_name not in ( ''SEQ_ID'', ''MD5_ORIGINAL'', ''COLLECTION_NAME'' )',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1812_table_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2132493628676085.4001)
,p_lov_name=>'P1812_TABLE_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :P1811_TABLE_OWNER',
'and table_name = :P1811_TABLE_NAME',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1817_copy
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3387269549000655.4001)
,p_lov_name=>'P1817.COPY'
,p_lov_query=>'.'||wwv_flow_api.id(3387269549000655.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3387527981001063.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3387951318001064.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3388361761001064.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copiar y Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P1816_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1905_actions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(247678451096396264.4001)
,p_lov_name=>'P1905_ACTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(247678451096396264.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(247678721347396266.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nueva'
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(247679191058396269.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Como copia de un origen de datos de REST existente'
,p_lov_return_value=>'COPY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4200940468413888.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Desde un cat\00E1logo de origen de REST')
,p_lov_return_value=>'CATALOG'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from WWV_WEB_SRC_CATALOGS c',
' where security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_web_src_catalog_services s',
'                 where security_group_id = :WORKSPACE_ID',
'                   and s.catalog_id = c.id )'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1907_copy
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(247782857688295098.4001)
,p_lov_name=>'P1907.COPY'
,p_lov_query=>'.'||wwv_flow_api.id(247782857688295098.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(247783143135295099.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(247783588055295099.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(247783952074295099.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copiar y Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P1906_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1925_data_profile_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(607713258081514419.4001)
,p_lov_name=>'P1925_DATA_PROFILE_FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(607713258081514419.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(607713548960514424.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CSV'
,p_lov_return_value=>'CSV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(607713952628514429.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'JSON'
,p_lov_return_value=>'JSON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(607714315537514429.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'XLSX'
,p_lov_return_value=>'XLSX'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P1925_IS_WEB_SRC_PROFILE'
,p_lov_disp_cond2=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(607714737048514430.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'XML'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1926_data_profile_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4483925603898914.4001)
,p_lov_name=>'P1926_DATA_PROFILE_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'NAME'
,p_display_column_name=>'NAME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1926_lookup_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4458615411627104.4001)
,p_lov_name=>'P1926_LOOKUP_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_NAME'
,p_display_column_name=>'COLUMN_NAME_ESC'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_max_requests_exc_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601125790424873502.4001)
,p_lov_name=>'P1951_MAX_REQUESTS_EXC_ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(601125790424873502.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601125956648873502.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Emitir Error'
,p_lov_return_value=>'ERROR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601126391695873506.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Esperar'
,p_lov_return_value=>'WAIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_new_or_existing_table
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601127065669873845.4001)
,p_lov_name=>'P1951_NEW_OR_EXISTING_TABLE'
,p_lov_query=>'.'||wwv_flow_api.id(601127065669873845.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601127244730873845.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nueva Tabla'
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601127625076873845.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tabla Existente'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_replace_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601128335146874196.4001)
,p_lov_name=>'P1951_REPLACE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601128335146874196.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601128505255874196.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'DELETE (transaccional)'
,p_lov_return_value=>'DELETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601128965924874196.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'TRUNCATE (no transaccional)'
,p_lov_return_value=>'TRUNCATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_script_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601129636599874441.4001)
,p_lov_name=>'P1951_SCRIPT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601129636599874441.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601129868183874441.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Instalar'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601130273688874441.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Actualizar'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_sync_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601130955295874684.4001)
,p_lov_name=>'P1951_SYNC_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601130955295874684.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601131122496874684.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Agregar'
,p_lov_return_value=>'APPEND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601131505261874685.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Fusionar'
,p_lov_return_value=>'MERGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601131967547874685.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Sustituir'
,p_lov_return_value=>'REPLACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p195_parent_regions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(170777029602529928.4001)
,p_lov_name=>'P195_PARENT_REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :F4000_P194_COPY_TO_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p207_create_template
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41876318884405056.4001)
,p_lov_name=>'P207_CREATE_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_api.id(41876318884405056.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41876627082405062.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'A partir del Repositorio'
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1215440504952239567.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Como copia de otra aplicaci\00F3n')
,p_lov_return_value=>'COPY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59285019370204245.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Nueva'
,p_lov_return_value=>'NEW_THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(245682104880497308.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('De Exportaci\00F3n')
,p_lov_return_value=>'IMPORT_THEME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2222_list_entries_start_with
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(63393015128868636.4001)
,p_lov_name=>'P2222 LIST ENTRIES START WITH'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P2222_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p230_page_process_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(360899411445143497.4001)
,p_lov_name=>'P230_PAGE_PROCESS_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d)||',
'       case when is_supported = ''N'' then '' '' || wwv_flow_lang.system_message(''BUILDER.UNSUPPORTED_COMPONENT'') end d,',
'       r',
'  from ( select display_name     as d,',
'                name_with_prefix as r,',
'                case when instr (',
'                              '':'' || supported_ui_types || '':'',',
'                              ( select '':'' || wwv_flow_page_dev.get_ui_type(:FB_FLOW_ID, :FB_FLOW_PAGE_ID) || '':''',
'                                  from dual )',
'                              ) > 0 then ''Y'' else ''N''',
'                end              as is_supported,',
'                case name',
'                  when ''PLSQL''               then ''process_plsql_xl''',
'                  when ''SEND_EMAIL''          then ''process_send_email''',
'                  when ''CLOSE_WINDOW''        then ''close_popup''',
'                  when ''SESSION_STATE''       then ''process_cache_management_xl''',
'                  when ''USER_PREFERENCES''    then ''process_cache_management_xl''',
'                  when ''RESET_PAGINATION''    then ''process_report_pagination_xl''',
'                  else                            ''process_plugins_xl''',
'                end||''.gif'' as icon',
'           from wwv_flow_native_plugins',
'          where plugin_type = ''PROCESS TYPE''',
'            and name in (''PLSQL'', ''CLOSE_WINDOW'', ''RESET_PAGINATION'', ''SEND_EMAIL'', ''SESSION_STATE'', ''USER_PREFERENCES'')',
'          union all',
'         select wwv_flow_lang.system_message(''BUILDER.PLUGINS'') as d,',
'                ''PLUGINS'' as r,',
'                ''Y''       as is_supported,',
'                ''process_plugins_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Data Manipulation'') as d,',
'                ''DATA_MANIPULATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_data_manipulation_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Web Services'') as d,',
'                ''WEB_SERVICES'' as r,',
'                ''Y''       as is_supported,',
'                ''process_webservice_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Form Pagination'') as d,',
'                ''FORM_PAGINATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_form_pagination_xl.gif'' as icon',
'           from dual',
'          order by 3 desc, d',
'       )',
' where :P366_SHOW_UNSUPPORTED = ''Y''',
'    or is_supported = ''Y''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p230_tabular_form_process_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361313530258501558.4001)
,p_lov_name=>'P230_TABULAR_FORM_PROCESS_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d)||',
'       case when is_supported = ''N'' then '' '' || wwv_flow_lang.system_message(''BUILDER.UNSUPPORTED_COMPONENT'') end ||',
'       ''<br /><a href="javascript:$s(''''P230_PAGE_PROCESS_TYPE'''',''||',
'       wwv_flow_escape.js_literal(r)||',
'       '');apex.submit(''''NEXT'''');"><img src="#IMAGE_PREFIX#htmldb/builder/''||icon|| ''" height="90" width="140" alt="''||',
'       wwv_flow_escape.html(d)||''" class="htmldbGreenIcons" /></a>'' d,',
'       r',
'  from ( select display_name     as d,',
'                name_with_prefix as r,',
'                case when instr (',
'                              '':'' || supported_ui_types || '':'',',
'                              ( select '':'' || wwv_flow_page_dev.get_ui_type(:FB_FLOW_ID, :FB_FLOW_PAGE_ID) || '':''',
'                                  from dual )',
'                              ) > 0 then ''Y'' else ''N''',
'                end              as is_supported,',
'                case name',
'                  when ''SEND_EMAIL''          then ''process_send_email''',
'                  when ''PLSQL''               then ''process_plsql_xl''',
'                  when ''CLOSE_WINDOW''        then ''close_popup''',
'                  when ''SESSION_STATE''       then ''process_cache_management_xl''',
'                  else                            ''process_plugins_xl''',
'                end||''.gif'' as icon',
'           from wwv_flow_native_plugins',
'          where plugin_type = ''PROCESS TYPE''',
'            and name        in (''SEND_MAIL'', ''PLSQL'', ''PAGINATION'', ''DATA_MANIPULATION'', ''WEB_SERVICES'')',
'          union all',
'         select wwv_flow_lang.system_message(''RESET_PAGINATION'') as d,',
'                ''PAGINATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_report_pagination_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''BUILDER.PLUGINS'') as d,',
'                ''PLUGINS'' as r,',
'                ''Y''       as is_supported,',
'                ''process_plugins_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Data Manipulation'') as d,',
'                ''DATA_MANIPULATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_data_manipulation_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Web Services'') as d,',
'                ''WEB_SERVICES'' as r,',
'                ''Y''       as is_supported,',
'                ''process_webservice_xl.gif'' as icon',
'           from dual',
'          order by 3 desc, d',
'       )',
' where :P366_SHOW_UNSUPPORTED = ''Y''',
'    or is_supported = ''Y''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p239_master_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(513694619806813998.4001)
,p_lov_name=>'P239_MASTER_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE',
'   and :P239_MASTER_TABLE is not null'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p239_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(513693579931809611.4001)
,p_lov_name=>'P239_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P239_MASTER_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p248_page_item_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(10095011768327386.4001)
,p_lov_name=>'P248_PAGE_ITEM_LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(10095011768327386.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10095312279327391.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento de P\00E1gina')
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179919107133518638.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p248_tabular_form_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7865801174075257.4001)
,p_lov_name=>'P248_TABULAR_FORM_LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(7865801174075257.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7866117948075285.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna'
,p_lov_return_value=>'COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7866503344075287.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Fila de Pantalla Tabular'
,p_lov_return_value=>'ROW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p257_detail_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(536224523160620304.4001)
,p_lov_name=>'P257_DETAIL_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P257_DETAIL_OWNER',
'   and table_name = :P257_DETAIL_TABLE',
'   and :P257_DETAIL_TABLE is not null'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p257_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(536224160727617714.4001)
,p_lov_name=>'P257_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q varchar2(32767);',
'begin',
'    if nvl(:P257_SHOW_RELATED_TABLES,''N'') = ''N'' then',
'        q := ''select object_name_esc, object_name from wwv_flow_tables_views_dev where owner = :P257_DETAIL_OWNER order by 1'';',
'    else',
'        q := ''select detail_table_name d, detail_table_name r',
'                 from wwv_flow_detail_tables_dev',
'                where master_owner      = :P239_MASTER_OWNER',
'                  and detail_owner      = :P257_DETAIL_OWNER',
'                  and master_table_name = :P239_MASTER_TABLE',
'                order by 1'';',
'    end if;',
'    return q;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p260_report_view_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(229358215992778552.4001)
,p_lov_name=>'P260.REPORT.VIEW.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(229358215992778552.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(229358405044778555.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vista Detallada'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(229358605815778557.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Vista de Resumen'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p294_validation_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(194217322088478746.4001)
,p_lov_name=>'P294 VALIDATION TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(194217322088478746.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(194217509741478748.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Valor Booleano')
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(194217703862478748.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(194217926009478748.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Exists'
,p_lov_return_value=>'EXISTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p29_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158089917773275899.4001)
,p_lov_name=>'P29_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P29_OWNER',
'   and table_name = :P29_TABLE_NAME',
'   and data_type  <> ''BLOB'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p29_md_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(27314867128775183.4001)
,p_lov_name=>'P29_MD_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(27314867128775183.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27319937658775186.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Apilado'
,p_lov_return_value=>'MD_SINGLE_PG'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-md-stacked'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27320716133775188.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'En paralelo'
,p_lov_return_value=>'MD_EMAIL_STYLE'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-md-side-by-side'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27320309659775188.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Aumentar Detalle'
,p_lov_return_value=>'MD_TWO_PG'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-md-drill-down'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3010_app_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(836710215886022128.4001)
,p_lov_name=>'P3010_APP_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(836710215886022128.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(836710505990022129.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Base de Datos'
,p_lov_return_value=>'DATABASE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(836710724541022129.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Hoja de C\00E1lculo Web')
,p_lov_return_value=>'WEBSHEET'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p32_pk1
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158099515873313257.4001)
,p_lov_name=>'P32_PK1'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P29_OWNER',
'   and table_name = :P29_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p32_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158100123838315488.4001)
,p_lov_name=>'P32_PK2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P29_OWNER',
'   and table_name = :P29_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p32_upd_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158098907908310888.4001)
,p_lov_name=>'P32_UPD_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :F4000_P29_OWNER',
'  and table_name = :P29_TABLE_NAME ',
'  and instr('':''||:P29_COLUMNS||'':'','':''||column_name||'':'') > 0',
'  and column_name <> :P32_UPD_PK',
'  and column_name <> nvl(:P32_UPD_PK2,'''''''')',
'  and data_type <> ''BLOB'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p341_tabs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158428705418480516.4001)
,p_lov_name=>'P341_TABS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME),tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :F4000_P33_TAB_SET'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p352_tabs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162492123577109461.4001)
,p_lov_name=>'P352_TABS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME),tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :F4000_P4810_TAB_SET'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p356_avail_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153676505798953184.4001)
,p_lov_name=>'P356_AVAIL_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev a',
' where owner      = :P356_OWNER',
'   and table_name = :P356_Q_T1',
'   and not exists (select null from wwv_flow_collections',
'                              where collection_name = ''COLUMNS''',
'                                and c002 = a.table_name',
'                                and c003 = a.column_name )',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p356_selected_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153677215841956147.4001)
,p_lov_name=>'P356_SELECTED_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c002)||''.''||wwv_flow_escape.html(c003) d, seq_id v ',
'  from wwv_flow_collections',
' where collection_name = ''COLUMNS''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p36_breadcrumb_start_with
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(32867404643224989.4001)
,p_lov_name=>'P36 BREADCRUMB START WITH'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT rpad('' '',(level-1)*3,''...................................'')||'' ''||wwv_flow_escape.html(short_name) sn,',
'       id',
'FROM wwv_flow_menu_options',
'WHERE flow_id = :fb_flow_id and ',
'      menu_id = :P36_MENU_ID',
'START WITH NVL(parent_id,0) = 0',
'CONNECT BY PRIOR id = parent_id',
'ORDER siblings BY short_name, OPTION_SEQUENCE'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p361_data_manipulation_process_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8375625955210867.4001)
,p_lov_name=>'P361_DATA_MANIPULATION_PROCESS_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(8375625955210867.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8375916603210869.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Recuperaci\00F3n Autom\00E1tica de Filas')
,p_lov_return_value=>'DML_FETCH_ROW'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8376104476210869.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Procesamiento Autom\00E1tico de Filas (DML)')
,p_lov_return_value=>'DML_PROCESS_ROW'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8376321824210870.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Actualizaci\00F3n de Varias Filas')
,p_lov_return_value=>'MULTI_ROW_UPDATE'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31591023007278924.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Supresi\00F3n de Varias Filas')
,p_lov_return_value=>'MULTI_ROW_DELETE'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(55950301751165195.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Agregar Filas a Pantalla Tabular'
,p_lov_return_value=>'ADD_ROWS_TO_TABULAR_FORM'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p374_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(219858620208528757.4001)
,p_lov_name=>'P374.GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P374_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p374_parent_regions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(171212231306813752.4001)
,p_lov_name=>'P374_PARENT_REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id = :FB_FLOW_ID',
'   and page_id = :FB_FLOW_PAGE_ID',
'   and id not in ( select id /* not the current region and its sub regions */',
'                     from wwv_flow_page_plugs',
'                    start with id = :P374_ID',
'                   connect by prior id = parent_plug_id )',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p375_tabs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162120332451402350.4001)
,p_lov_name=>'P375_TABS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME),tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :F4000_P4710_TAB_SET'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p376_new_chart
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41719408402645098.4001)
,p_lov_name=>'P376_NEW_CHART'
,p_lov_query=>'.'||wwv_flow_api.id(41719408402645098.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41719727700645195.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Barra (HTML)'
,p_lov_return_value=>'SIMPLE_CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41719919282645197.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Barra, Horizontal'
,p_lov_return_value=>'HBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41720106551645197.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Barra, Vertical'
,p_lov_return_value=>'VBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41720312256645197.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Barra Agrupada, Horizontal'
,p_lov_return_value=>'HCLUSTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41720527382645197.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Barra Agrupada, Vertical'
,p_lov_return_value=>'CLUSTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41720723957645198.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Dial'
,p_lov_return_value=>'DIAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41720918900645198.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Dial (con Barrido)'
,p_lov_return_value=>'DIALSWEEP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41721102267645198.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('L\00EDnea')
,p_lov_return_value=>'LINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41721323279645198.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Tarta'
,p_lov_return_value=>'PIE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41721519830645199.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Barra Apilada, Horizontal'
,p_lov_return_value=>'HSTACKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41721717772645206.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Barra Apilada, Vertical'
,p_lov_return_value=>'STACKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41721904067645206.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Barra Apilada de Porcentajes, Horizontal'
,p_lov_return_value=>'HSTACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41722123718645206.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Barra Apilada de Porcentajes, Vertical'
,p_lov_return_value=>'STACKED_PCT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p392_create_nav_bar_entry_type_selector
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(196955313648664768.4001)
,p_lov_name=>'P392 CREATE NAV BAR ENTRY TYPE SELECTOR'
,p_lov_query=>'.'||wwv_flow_api.id(196955313648664768.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(196955502204664773.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Navegaci\00F3n a URL')
,p_lov_return_value=>'URL'
,p_lov_template=>'#DISPLAY_VALUE#|native-url'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(196955720823664774.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Comentarios'
,p_lov_return_value=>'FEEDBACK'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-feedback'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p399_cols_avail
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153085921741582798.4001)
,p_lov_name=>'P399_COLS_AVAIL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev a',
' where owner      = :P399_OWNER',
'   and table_name = :P399_Q_T1',
'   and not exists (select null from wwv_flow_collections',
'                    where collection_name = ''COLUMNS''',
'                      and c002 = a.table_name',
'                      and c003 = a.column_name )',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p399_cols_selected
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153086529706585093.4001)
,p_lov_name=>'P399_COLS_SELECTED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c002)||''.''||wwv_flow_escape.html(c003) d, seq_id v ',
'  from wwv_flow_collections',
' where collection_name = ''COLUMNS''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4015_listallitems
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22161709183858677.4001)
,p_lov_name=>'P4015_LISTALLITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''APPLICATION''))||',
''': ''||name a, name b ',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and :F4000_P4026_IS = ''FLOW_ITEM''',
' union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'  from wwv_flow_step_items',
' where flow_id = :FB_FLOW_ID',
'   and :F4000_P4026_IS != ''FLOW_ITEM''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4017_varchar_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(123878420043886379.4001)
,p_lov_name=>'P4017_VARCHAR_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c003) d, seq_id v from wwv_flow_collections',
' where collection_name = ''REGION_QUERY_COLL''',
'order by seq_id',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4041_report_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(313152813488687118.4001)
,p_lov_name=>'P4041_REPORT TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(313152813488687118.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(313153124387687119.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Informe Interactivo'
,p_lov_return_value=>'INTERACTIVE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''INTERACTIVE_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(712075980814684267.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuadr\00EDcula Interactiva')
,p_lov_return_value=>'IG'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''INTERACTIVE_GRID'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(313153421407687119.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Informe Cl\00E1sico')
,p_lov_return_value=>'CLASSIC'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P259_USER_INTERFACE_ID,',
'    p_name              => ''CLASSIC_REPORT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p424_column_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21951418381350663.4001)
,p_lov_name=>'P424_COLUMN_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :p104_owner',
'  and table_name = :p106_table '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p424_date_column_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(799718429786902737.4001)
,p_lov_name=>'P424_DATE_COLUMN_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :p104_owner',
'  and table_name = :p106_table ',
'  and (data_type = ( ''DATE'')',
'       or data_type like  (''TIMESTAMP%''))'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p424_numeric_column_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(21951700504354877.4001)
,p_lov_name=>'P424_NUMERIC_COLUMN_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :p104_owner',
'  and table_name = :p106_table ',
'  and data_type in ( ''NUMBER'' , ''FLOAT'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p426_seq
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178172632134522245.4001)
,p_lov_name=>'P426_SEQ'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sequence_name_esc, sequence_name',
'  from wwv_flow_sequences_dev',
' where owner = :F4000_P29_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4311_grid_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(214426422068195312.4001)
,p_lov_name=>'P4311.GRID_COLUMN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P4311_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4311_grid_label_column_span
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1570705881299751507.4001)
,p_lov_name=>'P4311.GRID_LABEL_COLUMN_SPAN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level-1 as d, level-1 as r',
'   from sys.dual',
'connect by level-1 < nvl( :P4311_GRID_COLUMN_SPAN, :P4311_GRID_MAX_COLUMNS )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_in_map_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23490921670855286.4001)
,p_lov_name=>'P4312_IN_MAP_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(23490921670855286.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23491218407855289.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elemento'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23491408926855290.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Valor Est\00E1tico')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47089421019946824.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Funci\00F3n')
,p_lov_return_value=>'FUNCTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_out_map_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23495520416864363.4001)
,p_lov_name=>'P4312_OUT_MAP_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(23495520416864363.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23495831550864364.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elementos'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23496013407864364.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Recopilaci\00F3n')
,p_lov_return_value=>'COLLECTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_process_point
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9405302986939246.4001)
,p_lov_name=>'P4312_PROCESS_POINT'
,p_lov_query=>'.'||wwv_flow_api.id(9405302986939246.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9405616193939261.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('En una Nueva Instancia (nueva sesi\00F3n)')
,p_lov_return_value=>'ON_NEW_INSTANCE'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9405815372939263.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'En Carga: Antes de Cabecera'))
,p_lov_return_value=>'BEFORE_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9406027772939263.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Cabecera')))
,p_lov_return_value=>'AFTER_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9406214595939263.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'En Carga: Antes de Regiones'))
,p_lov_return_value=>'BEFORE_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9406420830939263.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Regiones')))
,p_lov_return_value=>'AFTER_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9406605804939263.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Antes de Pie de P\00E1gina')))
,p_lov_return_value=>'BEFORE_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9406822975939263.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Pie de P\00E1gina')))
,p_lov_return_value=>'AFTER_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9407005058939263.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Ejecuci\00F3n: Antes de C\00E1lculos y Validaciones ')))
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9407219704939264.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Ejecuci\00F3n: Despu\00E9s de C\00E1lculos y Validaciones')))
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9407419438939264.4001)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>unistr('Devoluci\00F3n de Llamada de AJAX: Ejecute este proceso cuando lo solicite AJAX')
,p_lov_return_value=>'ON_DEMAND'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9407614667939264.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('En Error: Despu\00E9s de Cabecera')
,p_lov_return_value=>'AFTER_ERROR_HEADER'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9407800424939264.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('En Error: Antes de Pie de P\00E1gina')
,p_lov_return_value=>'BEFORE_ERROR_FOOTER'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_web_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23280706593687071.4001)
,p_lov_name=>'P4312_WEB_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_ws_operations',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4402_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1434173283114513679.4001)
,p_lov_name=>'P4402.ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(1434173283114513679.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1434173551836514263.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'De Cero'
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1434173808978514269.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Como Copia de un Plugin Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4406_copy
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1434176433131599379.4001)
,p_lov_name=>'P4406.COPY'
,p_lov_query=>'.'||wwv_flow_api.id(1434176433131599379.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1434176711169599381.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1434177041222599383.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1434177399061599383.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copiar y Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P4404_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4464_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(687485607578537752.4001)
,p_lov_name=>'P4464_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P4464_TABLE_OWNER',
'   and table_name = :P4464_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4464_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(687479964621979286.4001)
,p_lov_name=>'P4464_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4464_TABLE_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4495_invalid_session_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(364180307858056288.4001)
,p_lov_name=>'P4495_INVALID_SESSION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(364180307858056288.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(364180530446056289.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina de Conexi\00F3n')
,p_lov_return_value=>'LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(364180725680056289.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00E1gina de Conexi\00F3n Incorporada')
,p_lov_return_value=>'BUILTIN_LOGIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(364181121070056289.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4495_logout_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(369466420839722403.4001)
,p_lov_name=>'P4495_LOGOUT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(369466420839722403.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(369466702957722404.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina Inicial')
,p_lov_return_value=>'HOME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(369467107778722404.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4500_is_regexp
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(687426829609667755.4001)
,p_lov_name=>'P4500_IS_REGEXP'
,p_lov_query=>'.'||wwv_flow_api.id(687426829609667755.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(687427092362667763.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Expresi\00F3n Regular')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4500_match_case
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(687435969419956417.4001)
,p_lov_name=>'P4500_MATCH_CASE'
,p_lov_query=>'.'||wwv_flow_api.id(687435969419956417.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(687436173011956419.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Coincidir May\00FAsculas/Min\00FAsculas')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p462_download_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(403387737278446376.4001)
,p_lov_name=>'P462_DOWNLOAD_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(403387737278446376.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(403387926098446380.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Script de Desinstalaci\00F3n')
,p_lov_return_value=>'DEINSTALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(403547684590197232.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Eliminar Aplicaci\00F3n')
,p_lov_return_value=>'APP_REMOVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p462_include_app_remove
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(403388354521448419.4001)
,p_lov_name=>'P462_INCLUDE_APP_REMOVE'
,p_lov_query=>'.'||wwv_flow_api.id(403388354521448419.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(403388543370448419.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Incluir Eliminaci\00F3n de Aplicaci\00F3n')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4651_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(214425820290166388.4001)
,p_lov_name=>'P4651.GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P4651_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4651_list_plug_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(110270516023569639.4001)
,p_lov_name=>'P4651_LIST_PLUG_TYPES'
,p_lov_query=>'return wwv_flow_builder.region_source_type_lov(p_current_value => :F4000_P4651_PLUG_SOURCE_TYPE)'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4651_parent_regions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(170577717522662003.4001)
,p_lov_name=>'P4651_PARENT_REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id = :FB_FLOW_ID',
'   and page_id = :FB_FLOW_PAGE_ID',
'   and id not in ( select id /* not the current region and its sub regions */',
'                     from wwv_flow_page_plugs',
'                    start with id = :F4000_P4651_ID',
'                   connect by prior id = parent_plug_id )',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p466_avail_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(155828317190371371.4001)
,p_lov_name=>'P466_AVAIL_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev a',
' where owner      = :P466_OWNER',
'   and table_name = :P466_Q_T1',
'   and not exists (select null from wwv_flow_collections',
'                              where collection_name = ''COLUMNS''',
'                                and c003 = a.table_name',
'                                and c005 = a.column_name',
'                                and c006 != ''D'' )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p466_selected_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(155829628964374834.4001)
,p_lov_name=>'P466_SELECTED_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c003)||''.''||wwv_flow_escape.html(c005) d, seq_id v ',
'  from wwv_flow_collections',
' where collection_name = ''COLUMNS''',
'   and c006 != ''D''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4734_process_points
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9100501365042451.4001)
,p_lov_name=>'P4734_PROCESS_POINTS'
,p_lov_query=>'.'||wwv_flow_api.id(9100501365042451.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9100809612042466.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('En una Nueva Instancia (nueva sesi\00F3n)')
,p_lov_return_value=>'ON_NEW_INSTANCE'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9101011884042466.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'En Carga: Antes de Cabecera'))
,p_lov_return_value=>'BEFORE_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9101200813042466.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Cabecera')))
,p_lov_return_value=>'AFTER_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9101425102042466.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'En Carga: Antes de Regiones'))
,p_lov_return_value=>'BEFORE_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9101620856042466.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Regiones')))
,p_lov_return_value=>'AFTER_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9101828034042466.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Antes de Pie de P\00E1gina')))
,p_lov_return_value=>'BEFORE_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9102024546042467.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Carga: Despu\00E9s de Pie de P\00E1gina')))
,p_lov_return_value=>'AFTER_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9102223263042467.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Ejecuci\00F3n: Antes de C\00E1lculos y Validaciones ')))
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9102400883042467.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('En Ejecuci\00F3n: Despu\00E9s de C\00E1lculos y Validaciones')))
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9102608720042467.4001)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>unistr('Devoluci\00F3n de Llamada de AJAX: Ejecute este proceso cuando lo solicite AJAX')
,p_lov_return_value=>'ON_DEMAND'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9102821905042467.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('En Error: Despu\00E9s de Cabecera')
,p_lov_return_value=>'AFTER_ERROR_HEADER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9103006400042467.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('En Error: Antes de Pie de P\00E1gina')
,p_lov_return_value=>'BEFORE_ERROR_FOOTER'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4735_service_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23946805549926694.4001)
,p_lov_name=>'P4735_SERVICE_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :F4000_P4735_WEB_SERVICE'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4780_chart_scale
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162187100656572875.4001)
,p_lov_name=>'P4780_CHART_SCALE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 400 d, 400 r from dual ',
'union ',
'select 200 d, 200 r from dual ',
'union ',
'select 600 d, 600 r from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4795_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1273317695384915524.4001)
,p_lov_name=>'P4795_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P4795_TABLE_OWNER',
'   and table_name = :P4795_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4795_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(201375931366550586.4001)
,p_lov_name=>'P4795_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4795_TABLE_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4796_varchar_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(109940315866524802.4001)
,p_lov_name=>'P4796_VARCHAR_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c003) d, wwv_flow_escape.html(c003) v from wwv_flow_collections',
' where collection_name = ''LOV_COLL''',
'order by seq_id',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p494_summary_col1
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(150739316469381909.4001)
,p_lov_name=>'P494_SUMMARY_COL1'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b                ',
'from wwv_flow_collections ',
'where collection_name=''EXCEL_IMPORT''',
'and c004 = ''Y''',
'and c002 != ''CLOB''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p494_summary_col2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(150742225173412831.4001)
,p_lov_name=>'P494_SUMMARY_COL2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b                ',
'from wwv_flow_collections ',
'where collection_name=''CSV_IMPORT''',
'and c004 = ''Y''',
'and c002 != ''CLOB''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p495_agg_col1
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(150843204404482597.4001)
,p_lov_name=>'P495_AGG_COL1'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b',
'from wwv_flow_collections',
'where collection_name=''EXCEL_IMPORT''',
'and c004 = ''Y''',
'and c002 = ''NUMBER'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p495_agg_col2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(150845803496491785.4001)
,p_lov_name=>'P495_AGG_COL2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b',
'from wwv_flow_collections',
'where collection_name=''CSV_IMPORT''',
'and c004 = ''Y''',
'and c002 = ''NUMBER'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p560_case_sensitive
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13359205666146756.4001)
,p_lov_name=>'P560_CASE_SENSITIVE'
,p_lov_query=>'.'||wwv_flow_api.id(13359205666146756.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13359510355146757.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('sensible a may\00FAsculas/min\00FAsculas')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p560_exact_match
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13356927698143693.4001)
,p_lov_name=>'P560_EXACT_MATCH'
,p_lov_query=>'.'||wwv_flow_api.id(13356927698143693.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13357217040143696.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'coincidencia exacta'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p560_search_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(39290016198591148.4001)
,p_lov_name=>'P560_SEARCH_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(39290016198591148.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39290330944591151.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Nombre del Negocio'
,p_lov_return_value=>'BUS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39290532350591153.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nombre del Servicio'
,p_lov_return_value=>'SERV'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p600_service_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15589721785727739.4001)
,p_lov_name=>'P600_SERVICE_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P600_WS_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p600_web_ref_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(191288700473281420.4001)
,p_lov_name=>'P600_WEB_REF_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(191288700473281420.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191288912474281428.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Manual'
,p_lov_return_value=>'MANUAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191289104429281431.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Basado en WSDL'
,p_lov_return_value=>'NEW_SCHOOL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(191289332191281431.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'RESTful'
,p_lov_return_value=>'REST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p600_web_services
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15587132043721216.4001)
,p_lov_name=>'P600_WEB_SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p675_affected_elements_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(623954005465160350.4001)
,p_lov_name=>'P675_AFFECTED_ELEMENTS_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(623954005465160350.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623954804586160353.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elementos'
,p_lov_return_value=>'ITEM'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''ITEM'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(206240722890573621.4001)
,p_lov_disp_sequence=>1.5
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'            p_application_id => :FB_FLOW_ID,',
'            p_true_action    => :P653_TRUE_ACTION,',
'            p_false_action   => :P198_FALSE_ACTION,',
'            p_type           => ''BUTTON'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623955231150160353.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'            p_application_id => :FB_FLOW_ID,',
'            p_true_action    => :P653_TRUE_ACTION,',
'            p_false_action   => :P198_FALSE_ACTION,',
'            p_type           => ''REGION'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623954201427160352.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Columna'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''COLUMN'' );'))
,p_lov_disp_cond2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623955012034160353.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Selector de jQuery'
,p_lov_return_value=>'JQUERY_SELECTOR'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''JQUERY_SELECTOR'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(855877380156007050.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Expresi\00F3n JavaScript')
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''JAVASCRIPT_EXPRESSION'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623955413415160353.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Elemento Disparador'
,p_lov_return_value=>'TRIGGERING_ELEMENT'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''TRIGGERING_ELEMENT'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623954631117160352.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Origen de Evento'
,p_lov_return_value=>'EVENT_SOURCE'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''EVENT_SOURCE'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p700_service_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30137708159892825.4001)
,p_lov_name=>'P700_SERVICE_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P700_WS_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7020_copy_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601116568254832030.4001)
,p_lov_name=>'P7020_COPY_SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(601116568254832030.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601116766374832030.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Esta aplicaci\00F3n')
,p_lov_return_value=>'THIS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601117120524832032.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Otra aplicaci\00F3n')
,p_lov_return_value=>'OTHER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4100219380261370.4001)
,p_lov_name=>'P7021_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P7021_TABLE_OWNER',
'   and table_name = :P7021_TABLE_NAME',
'   and :P7021_TABLE_NAME is not null',
'   and :P7021_REPORT_SOURCE_TYPE = ''TABLE'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_commit_each_row
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601100928341755832.4001)
,p_lov_name=>'P7021_COMMIT_EACH_ROW'
,p_lov_query=>'.'||wwv_flow_api.id(601100928341755832.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601101161297755832.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Una Vez'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601101578470755833.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Cada fila'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_error_handling_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601102221885756461.4001)
,p_lov_name=>'P7021_ERROR_HANDLING_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601102221885756461.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601102495495756461.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ignorar'
,p_lov_return_value=>'IGNORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601102885695756461.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Abortar automatizaci\00F3n')
,p_lov_return_value=>'ABORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601103294616756461.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Desactivar automatizaci\00F3n')
,p_lov_return_value=>'DISABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601093532765741216.4001)
,p_lov_name=>'P7021_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601093532765741216.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601093732932741217.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Consulta'
,p_lov_return_value=>'QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601094151666741217.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n que devuelve un valor booleano')
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601094507652741219.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3504279958146176.4001)
,p_lov_name=>'P7021_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P7021_TABLE_OWNER, wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID ) )',
''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'OBJECT_NAME'
,p_display_column_name=>'OBJECT_NAME_ESC'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'OBJECT_NAME_ESC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7025_status_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2000855720872191.4001)
,p_lov_name=>'P7025_STATUS_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(2000855720872191.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2001129595872205.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En ejecuci\00F3n')
,p_lov_return_value=>'RUNNING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2001536872872206.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Correcto'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2001964408872206.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Ninguna Acci\00F3n')
,p_lov_return_value=>'NO_ACTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2002386953872206.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Incompleto'
,p_lov_return_value=>'INCOMPLETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2002788561872207.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Fallo'
,p_lov_return_value=>'FAILURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2003180778872207.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Abortado'
,p_lov_return_value=>'ABORTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2003513333872207.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('El trabajo ya se est\00E1 ejecutando')
,p_lov_return_value=>'JOB_ALREADY_RUNNING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7026_msg_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4601034447346038.4001)
,p_lov_name=>'P7026_MSG_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(4601034447346038.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4601315751346042.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Informaci\00F3n')
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4601704640346043.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Advertencia'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4602167309346043.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'E'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7030_polling_interval_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601120036396834677.4001)
,p_lov_name=>'P7030_POLLING_INTERVAL_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601120036396834677.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601120223229834677.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Diario'
,p_lov_return_value=>'DAILY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601120623881834677.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Por horas'
,p_lov_return_value=>'HOURLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601121042951834677.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Por minutos'
,p_lov_return_value=>'MINUTELY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7030_polling_predefined
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601117964216834048.4001)
,p_lov_name=>'P7030_POLLING_PREDEFINED'
,p_lov_query=>'.'||wwv_flow_api.id(601117964216834048.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601118147447834048.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Cada 15 Minutos'
,p_lov_return_value=>'15M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601118543260834048.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'A la hora'
,p_lov_return_value=>'T1H'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601118986022834048.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Diariamente a medianoche'
,p_lov_return_value=>'MIDNIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601119395266834049.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7030_result_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601121722896835768.4001)
,p_lov_name=>'P7030_RESULT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(601121722896835768.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601121962684835769.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Consulta'
,p_lov_return_value=>'QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601122304775835769.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p725_arrays
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30163920479050503.4001)
,p_lov_name=>'P725_ARRAYS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p755_message_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(40231925790463373.4001)
,p_lov_name=>'P755.MESSAGE.STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(40231925790463373.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40232212679463374.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Literal'
,p_lov_return_value=>'literal'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40232431421463374.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Codificado'
,p_lov_return_value=>'encoded'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p755_soap_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(40229315139441290.4001)
,p_lov_name=>'P755.SOAP.STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(40229315139441290.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40229627356441290.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Documento'
,p_lov_return_value=>'document'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40229803305441290.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'RPC'
,p_lov_return_value=>'rpc'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p755_webreference_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(40198901222257565.4001)
,p_lov_name=>'P755.WEBREFERENCE.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(40198901222257565.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40199230524257566.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Creado Manualmente'
,p_lov_return_value=>'775'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(40199413274257566.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Generado desde WSDL'
,p_lov_return_value=>'760'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(170453128566645522.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'REST'
,p_lov_return_value=>'784'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_card_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(586301924665521297.4001)
,p_lov_name=>'P769_CARD_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P769_TABLE_OWNER',
'   and table_name = :P769_TABLE_NAME',
'   and :P769_TABLE_NAME is not null',
'    and (data_type in (''VARCHAR2'',''NUMBER'',''FLOAT'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'COLUMN_NAME'
,p_display_column_name=>'COLUMN_NAME_ESC'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'COLUMN_NAME_ESC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1273385793898560086.4001)
,p_lov_name=>'P769_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P769_TABLE_OWNER',
'   and table_name = :P769_TABLE_NAME',
'   and :P769_TABLE_NAME is not null',
'   and :P769_REPORT_SOURCE_TYPE = ''TABLE'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_columns_web_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3856585339019898.4001)
,p_lov_name=>'P769_COLUMNS_WEB_SOURCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''WEB_SOURCE'',',
'        p_web_src_module_id => :P769_WEB_SRC_MODULE_ID,',
'        p_query_type        => null ) )    ',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_facet_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(525330093618033199.4001)
,p_lov_name=>'P769_FACET_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(525330093618033199.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525330343522033201.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Buscar'
,p_lov_return_value=>'SEARCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525330747019033201.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Casilla de Control'
,p_lov_return_value=>'CHECKBOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525331172178033201.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Grupo de Botones de Radio'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525331571723033201.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n')
,p_lov_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525331971543033202.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Rango'
,p_lov_return_value=>'RANGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525332356377033202.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Campo de Texto'
,p_lov_return_value=>'TEXT_FIELD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_fk_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9401459374283589.4001)
,p_lov_name=>'P769_FK_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P769_TABLE_NAME',
'and c.child_owner = :P769_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'CHILD_COLUMN'
,p_display_column_name=>'CHILD_COLUMN'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'POSITION'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_fs_display_as
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(592389652645199591.4001)
,p_lov_name=>'P769_FS_DISPLAY_AS'
,p_lov_query=>'.'||wwv_flow_api.id(592389652645199591.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(592389945959199592.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'CR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(592390301964199592.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tarjetas'
,p_lov_return_value=>'CARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_seq
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(268279611657759740.4001)
,p_lov_name=>'P769_SEQ'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sequence_name_esc, sequence_name',
'  from wwv_flow_sequences_dev',
' where owner = :P769_TABLE_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p769_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1273385580487558141.4001)
,p_lov_name=>'P769_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P769_TABLE_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p76_export_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2046972184417676036.4001)
,p_lov_name=>'P76_EXPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(2046972184417676036.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2046972496837676036.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Completo'
,p_lov_return_value=>'FULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2046972881111676038.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('M\00EDnimo')
,p_lov_return_value=>'MIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p770_card_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12735952572583112.4001)
,p_lov_name=>'P770_CARD_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select column_name_esc,',
'           column_name,',
'           data_type',
'    from table(wwv_flow_exec_dev.get_query_columns(',
'        p_location          => :P769_LOCATION,',
'        p_query_type        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REPORT_SOURCE_TYPE',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REMOTE_REPORT_SOURCE_TYPE',
'                                    end',
'                                end,',
'        p_owner             =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_OWNER',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_OWNER',
'                                    end',
'                                end,',
'        p_table_name        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_NAME',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_NAME',
'                                    end',
'                                end,',
'        p_sql_query         =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_SQL',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_REMOTE_SQL',
'                                    end',
'                                end,      ',
'        p_web_src_module_id =>  case when :P769_LOCATION = ''WEB_SOURCE'' then',
'                                    :P769_WEB_SRC_MODULE_ID',
'                                end,',
'        p_remote_server_id  =>  case when :P769_LOCATION = ''REMOTE'' then',
'                                    :P769_REMOTE_SERVER_ID',
'                                end )) )',
'select c.column_name_esc column_display,',
'       c.column_name',
'from rpt_columns c'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_NAME'
,p_display_column_name=>'COLUMN_DISPLAY'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p778_webref_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(114277222597792014.4001)
,p_lov_name=>'P778_WEBREF_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(114277222597792014.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(193948926790152005.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'REST'
,p_lov_return_value=>'860'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114277727331792020.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Generado desde WSDL'
,p_lov_return_value=>'782'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(114277531767792019.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Creado Manualmente'
,p_lov_return_value=>'783'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p779_arrays
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(114317921745905322.4001)
,p_lov_name=>'P779_ARRAYS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P779_OPERATION_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p779_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(114316827501897556.4001)
,p_lov_name=>'P779_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P779_WS_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p779_wsdl_services
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1033194508949434213.4001)
,p_lov_name=>'P779_WSDL_SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''NEW_SCHOOL''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p806_inv_session_target
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159056930707631319.4001)
,p_lov_name=>'P806_INV_SESSION_TARGET'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'''select d,r from (',
'    select :PRODUCT_NAME||'''' ''''||',
'    wwv_flow_lang.system_message(''''F4000_P806_BUILTIN_LOGIN_PG'''') d,',
'    ''''BUILTIN'''' r, 1 ob from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_PAGE_IN_THIS_FLOW'''') d,',
'    ''''PAGE'''' r, 2 ob from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_URL'''') d,',
'    ''''URL'''' r,3 ob from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_SSO_SERVER'''') d,',
'    ''''-PORTAL_SSO-'''' r, 4 ob',
'    from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_NONE'''') d,',
'    ''''NONE'''' r, 5 ob from dual)',
'order by ob'';'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p808_auth_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159070400681755094.4001)
,p_lov_name=>'P808_AUTH_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'    select wwv_flow_lang.system_message(''F4000_P808_AUTH_TYPE'',',
'      :PRODUCT_NAME) d, ''BUILTIN'' r, 1 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_DBAUTH_TYPE'') d, ',
'    ''DBACCOUNT'' r, 2 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_NO_VERIFY_CRED'') d,',
'      ''ALLOW'' r, 3 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_USE_LDAP'') d,',
'      ''LDAP'' r,4 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_USE_CUSTOM'') d,',
'      ''PLUGIN'' r,5 ob from dual)',
'order by ob'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p856_sql_scripts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4671330627638944.4001)
,p_lov_name=>'P856_SQL_SCRIPTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename, id from wwv_flow_files',
' where file_type = ''SCRIPT''',
' order by filename'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p865_script_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(686919732026917492.4001)
,p_lov_name=>'P865_SCRIPT_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(686919732026917492.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(686920044595917503.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Solo Especificaciones de Paquete'
,p_lov_return_value=>'PACKAGE_SPEC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(686920318192917509.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Solo Cuerpos de Paquete'
,p_lov_return_value=>'PACKAGE_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(686920640544917509.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Incluir DDL Relacionado con Tablas'
,p_lov_return_value=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p872_input_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48714213128492554.4001)
,p_lov_name=>'P872_INPUT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(48714213128492554.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48714425928492556.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pares de Nombre y Valor'
,p_lov_return_value=>'nvp'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48714607865492557.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Cuerpo Especificado con Sustituciones'
,p_lov_return_value=>'body'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48714805586492557.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Elemento de Carga de Archivo'
,p_lov_return_value=>'file'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48715023064492557.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve CLOB')
,p_lov_return_value=>'function'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p892_p893_apex_view_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(200660406244440996.4001)
,p_lov_name=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p962_dashboard_layout
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42907758825155833.4001)
,p_lov_name=>'P962_DASHBOARD_LAYOUT'
,p_lov_query=>'.'||wwv_flow_api.id(42907758825155833.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42908060078155834.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gr\00E1ficos primarios y 2 secundarios')
,p_lov_return_value=>'PRIMARY_2_SECONDARY'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-dashboard-1-top-2-bottom'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42908446519155834.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuadr\00EDcula de 4 gr\00E1ficos')
,p_lov_return_value=>'4_GRIDS'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-dashboard-2-top-2-bottom'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42908853030155834.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Gr\00E1ficos primarios y 3 secundarios')
,p_lov_return_value=>'PRIMARY_3_SECONDARY'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-dashboard-1-top-3-bottom'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(49787787520832477.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Cuadr\00EDcula de 6 gr\00E1ficos')
,p_lov_return_value=>'6_GRIDS'
,p_lov_template=>'#DISPLAY_VALUE#| icon--page-layout icon-dashboard-3-top-3-bottom'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p98_validation_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9550628667575751.4001)
,p_lov_name=>'P98_VALIDATION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(9550628667575751.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9550909293575752.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Exists'
,p_lov_return_value=>'EXISTS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9551319496575752.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9551120973575752.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Expresi\00F3n SQL')
,p_lov_return_value=>'SQL_EXPRESSION'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7881132116718054.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL')
,p_lov_return_value=>'PLSQL_EXPRESSION'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7881306967720263.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Error PL/SQL'
,p_lov_return_value=>'PLSQL_ERROR'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7881518049723496.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Valor Booleano')
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7881728438726511.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Texto de Error')
,p_lov_return_value=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885327754801946.4001)
,p_lov_disp_sequence=>101
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 contiene al menos uno de los caracteres de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885423393801947.4001)
,p_lov_disp_sequence=>102
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 contiene s\00F3lo caracteres de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885501665801947.4001)
,p_lov_disp_sequence=>103
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 no es igual que el literal de cadena de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885603045801949.4001)
,p_lov_disp_sequence=>104
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 no contiene ning\00FAn car\00E1cter de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885713922801950.4001)
,p_lov_disp_sequence=>105
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 es igual que el literal de cadena de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885830063801950.4001)
,p_lov_disp_sequence=>106
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 no est\00E1 incluido en la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_NOT_IN_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16873715743689357.4001)
,p_lov_disp_sequence=>106
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 coincide con la expresi\00F3n regular de la Expresi\00F3n 2')
,p_lov_return_value=>'REGULAR_EXPRESSION'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'REGULAR_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7885909912801950.4001)
,p_lov_disp_sequence=>107
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 est\00E1 incluido en la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_IN_STRING2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16871227077635806.4001)
,p_lov_disp_sequence=>107
,p_lov_disp_value=>'El elemento/columna especificado NO NULO'
,p_lov_return_value=>'ITEM_NOT_NULL'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'ITEM_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886006126801950.4001)
,p_lov_disp_sequence=>108
,p_lov_disp_value=>'El elemento/columna especificado NO es cero'
,p_lov_return_value=>'ITEM_NOT_ZERO'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886124431801950.4001)
,p_lov_disp_sequence=>109
,p_lov_disp_value=>'El elemento/columna especificado no contiene espacios'
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886229374801950.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'El elemento/columna especificado es NO NULO o cero'
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886325240801950.4001)
,p_lov_disp_sequence=>111
,p_lov_disp_value=>unistr('El elemento/columna especificado es alfanum\00E9rico')
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886417269801950.4001)
,p_lov_disp_sequence=>112
,p_lov_disp_value=>unistr('El elemento/columna especificado es num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NUMERIC'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886520068801954.4001)
,p_lov_disp_sequence=>113
,p_lov_disp_value=>unistr('El elemento/columna especificado es una fecha v\00E1lida')
,p_lov_return_value=>'ITEM_IS_DATE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7886628893801954.4001)
,p_lov_disp_sequence=>115
,p_lov_disp_value=>unistr('El elemento/columna especificado es un registro de hora v\00E1lido')
,p_lov_return_value=>'ITEM_IS_TIMESTAMP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P91_VALIDATION'
,p_lov_disp_cond2=>'STRING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p99_detail_tables
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(193991118753574010.4001)
,p_lov_name=>'P99_DETAIL_TABLES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P99_MASTER_TABLE',
'and c.parent_owner = :P99_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'CHILD_TABLE'
,p_display_column_name=>'CHILD_TABLE'
,p_default_sort_column_name=>'CHILD_TABLE'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p99_table_views
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(27232360928864447.4001)
,p_lov_name=>'P99_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P99_TABLE_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/packaged_app_auth_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(357549619892228030.4001)
,p_lov_name=>'PACKAGED_APP_AUTH_OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r',
'  from wwv_flow_native_plugins',
' where plugin_type = ''AUTHENTICATION TYPE''',
'   and (          name_with_prefix = ''NATIVE_APEX_ACCOUNTS''',
'         or (     name_with_prefix = ''NATIVE_HTTP_HEADER_VARIABLE''',
'              and :P81_APP_TYPE    = ''DATABASE'' /* not yet implemented for websheets */',
'              and wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_HHEAD'') = ''Y'' )',
'         or (     name_with_prefix = ''NATIVE_LDAP''',
'              and :P81_APP_TYPE    = ''DATABASE'' /* not yet implemented for websheets */',
'              and wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_LDAP'') = ''Y'' )',
'         or (     name_with_prefix = ''NATIVE_IAS_SSO''',
'              and :P81_APP_TYPE    = ''DATABASE'' /* not yet implemented for websheets */',
'              and wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_SSO'') = ''Y'' ))',
'union all',
'select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_CLOUD_IDM''),',
'       ''NATIVE_CLOUD_IDM''',
'  from sys.dual',
' where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_group_returns_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(576061658331941850.4001)
,p_lov_name=>'PAGE GROUP (RETURNS NAME)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_groups_with_unassigned_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5085026803855916.4001)
,p_lov_name=>'PAGE GROUPS WITH UNASSIGNED OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, id',
'from wwv_flow_page_groups g',
'where flow_id = :fb_flow_id ',
'union',
'select wwv_flow_lang.system_message(''UNASSIGNED''), 111222333444 id',
'from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_items_of_current_and_global_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(455235230206380434.4001)
,p_lov_name=>'PAGE ITEMS OF CURRENT AND GLOBAL PAGE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       name as r',
'  from (',
'select name,',
'       flow_step_id,',
'       item_sequence',
'  from wwv_flow_step_items',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' union',
'select i.name,',
'       i.flow_step_id,',
'       i.item_sequence',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui,',
'       wwv_flow_step_items i',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and ui.id               = p.user_interface_id',
'   and ui.global_page_id  <> :fb_flow_page_id',
'   and i.flow_id           = ui.flow_id',
'   and i.flow_step_id      = ui.global_page_id',
'   and i.security_group_id = :WORKSPACE_ID',
')',
'order by flow_step_id, item_sequence, name',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_mode_dynamic_or_static
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(26630118049466478.4001)
,p_lov_name=>'PAGE MODE DYNAMIC OR STATIC'
,p_lov_query=>'.'||wwv_flow_api.id(26630118049466478.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26630403516466478.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Din\00E1mico')
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26630601816466479.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cach\00E9 Creada')
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26630824926466479.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Almacenado en Cach\00E9')
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131011417048612773.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Procesamiento de P\00E1gina')
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(116684427784528179.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina Parcial')
,p_lov_return_value=>'P'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_protection_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17255429593772638.4001)
,p_lov_name=>'PAGE PROTECTION LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(17255429593772638.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17255616290772804.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Restringido'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17255831690772804.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Los Argumentos Deben Tener Total de Control'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17256023739772805.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No se Permiten Argumentos'
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17256209897772805.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'No hay Acceso a URL'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41972431732112027.4001)
,p_lov_name=>'PAGE THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(41972431732112027.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41972715993112030.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separadores de Un Nivel'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41972909583112031.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separadores de Dos Niveles'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41973110092112031.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ning\00FAn Separador')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41973323433112031.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Emergente'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41973521858112032.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Versi\00F3n para Impresora')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41973730212112032.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Conectar'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(49461924616084412.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separadores de Un Nivel con Barra Lateral'
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(49462610895089957.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ning\00FAn Separador con Barra Lateral')
,p_lov_return_value=>'17'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(49463017128091735.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Separadores de Dos Niveles con Barra Lateral'
,p_lov_return_value=>'18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41977231648130915.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41977703036132119.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41978112040134702.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48394414687308491.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48394916765309025.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48395619189309771.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48396021613310403.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48396424037311168.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'15'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_url
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(276391518317957635.4001)
,p_lov_name=>'PAGE URL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_view_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5035605136660409.4001)
,p_lov_name=>'PAGE VIEW MODE'
,p_lov_query=>'.'||wwv_flow_api.id(5035605136660409.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5035918715660410.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Iconos'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5036125439660410.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Detalles'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_branch_points
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179397725241870240.4001)
,p_lov_name=>'PAGE.BRANCH.POINTS'
,p_lov_query=>'.'||wwv_flow_api.id(179397725241870240.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179398028859870243.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En Ejecuci\00F3n: Antes de C\00E1lculo (Antes de C\00E1lculo, Validaci\00F3n y Procesamiento)')
,p_lov_return_value=>'BEFORE_COMPUTATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179398229442870244.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('En Ejecuci\00F3n: Antes de Validaci\00F3n: (Despu\00E9s de C\00E1lculo y Antes de Validaci\00F3n y Procesamiento)')
,p_lov_return_value=>'BEFORE_VALIDATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179398419489870245.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('En Ejecuci\00F3n: Antes de Procesamiento: (Despu\00E9s de C\00E1lculo, Validaci\00F3n y Antes de Procesamiento)')
,p_lov_return_value=>'BEFORE_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179398614240870246.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('En Ejecuci\00F3n: Despu\00E9s de Procesamiento (Despu\00E9s de C\00E1lculo, Validaci\00F3n y Procesamiento)')
,p_lov_return_value=>'AFTER_PROCESSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179398805923870247.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'En Carga: Antes de Cabecera'
,p_lov_return_value=>'BEFORE_HEADER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_branch_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15652127549539076.4001)
,p_lov_name=>'PAGE.BRANCH.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(15652127549539076.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15652422295539123.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcar a Procesamiento de Aceptaci\00F3n de P\00E1gina (no com\00FAn)')
,p_lov_return_value=>'BRANCH_TO_PAGE_ACCEPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15652604683539128.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcar a P\00E1gina')
,p_lov_return_value=>'BRANCH_TO_STEP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15652814858539128.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bifurcar a Procedimiento PL/SQL'
,p_lov_return_value=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15653010159539128.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcar a P\00E1gina o URL')
,p_lov_return_value=>'REDIRECT_URL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15653228401539129.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcar a P\00E1gina Identificada por Elemento (Usar Nombre del Elemento)')
,p_lov_return_value=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15653413667539129.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bifurcar a URL Identificada por Elemento (Usar Nombre del Elemento)'
,p_lov_return_value=>'BRANCH_TO_URL_IDENT_BY_ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15653610612539129.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcar a Funci\00F3n que Devuelve una URL')
,p_lov_return_value=>'BRANCH_TO_FUNCTION_RETURNING_URL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24865323058688299.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bifurcar a Funci\00F3n que Devuelve una P\00E1gina')
,p_lov_return_value=>'BRANCH_TO_FUNCTION_RETURNING_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_public
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84921112902747500.4001)
,p_lov_name=>'PAGE.PUBLIC'
,p_lov_query=>'.'||wwv_flow_api.id(84921112902747500.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84921502289747501.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('La P\00E1gina Necesita Autenticaci\00F3n')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84921330545747501.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina P\00FAblica')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_subtitle_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84922124330750817.4001)
,p_lov_name=>'PAGE.SUBTITLE.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84922124330750817.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84923527403750819.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Expresi\00F3n SQL')
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84923723303750819.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Texto con Sustituciones'
,p_lov_return_value=>'TEXT_WITH_SUBSTITUTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pages_in_current_app
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(257008601524719157.4001)
,p_lov_name=>'PAGES IN CURRENT APP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_and_popup_transitions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16215309545314300.4001)
,p_lov_name=>'PAGE_AND_POPUP_TRANSITIONS'
,p_lov_query=>'.'||wwv_flow_api.id(16215309545314300.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16219511258513530.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16215606084314306.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Difuminar'
,p_lov_return_value=>'FADE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16215829338314308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aparecer'
,p_lov_return_value=>'POP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16216017778314308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Invertir'
,p_lov_return_value=>'FLIP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16216202625314308.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Girar'
,p_lov_return_value=>'TURN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16216419460314309.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Flujo'
,p_lov_return_value=>'FLOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16216618829314309.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Deslizar'
,p_lov_return_value=>'SLIDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16216809885314309.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Deslizar hacia Arriba'
,p_lov_return_value=>'SLIDEUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16217001457314310.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Deslizar hacia Abajo'
,p_lov_return_value=>'SLIDEDOWN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16218310256465838.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Deslizar Difuminado'
,p_lov_return_value=>'SLIDEFADE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_computation_points2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62981024179015035.4001)
,p_lov_name=>'PAGE_COMPUTATION_POINTS2'
,p_lov_query=>'.'||wwv_flow_api.id(62981024179015035.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62981313883015043.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('En una Nueva Instancia (nueva sesi\00F3n)')
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62981519102015043.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Antes de Cabecera'
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62981718705015044.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Despu\00E9s de Cabecera')
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62981911645015044.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Antes de Regiones'
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62982168927015047.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Despu\00E9s de Regiones')
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62982312758015047.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Antes de Pie de P\00E1gina')
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62982513587015048.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Despu\00E9s de Pie de P\00E1gina')
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62982747036015048.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>unistr('Despu\00E9s de Ejecuci\00F3n')
,p_lov_return_value=>'AFTER_SUBMIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_computation_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86604122856270295.4001)
,p_lov_name=>'PAGE_COMPUTATION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(86604122856270295.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88303124504820277.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento en esta P\00E1gina')
,p_lov_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88303320734820277.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Elemento en Otra  P\00E1gina')
,p_lov_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88303522865820278.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Elemento de Nivel de Aplicaci\00F3n')
,p_lov_return_value=>'FLOW_ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_computation_types2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(62977815884897285.4001)
,p_lov_name=>'PAGE_COMPUTATION_TYPES2'
,p_lov_query=>'.'||wwv_flow_api.id(62977815884897285.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62978121078897312.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Asignaci\00F3n Est\00E1tica')
,p_lov_return_value=>'STATIC_ASSIGNMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62978343008897315.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62978514164897316.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(458512309400745522.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Consulta SQL (devolver valores separados por dos puntos)'
,p_lov_return_value=>'QUERY_COLON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62978711197897316.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Expresi\00F3n SQL')
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62978941617897319.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Expresi\00F3n PLSQL')
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22684624604995500.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Valor de Elemento'
,p_lov_return_value=>'ITEM_VALUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_display_point
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131723061838.4001)
,p_lov_name=>'PAGE_DISPLAY_POINT'
,p_lov_query=>'.'||wwv_flow_api.id(131723061838.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3695509594759.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cuerpo de Plantilla de P\00E1gina')
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(259083013010648721.4001)
,p_lov_name=>'PAGE_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(259083013010648721.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259083317127648724.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Explorador Est\00E1ndar')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259083521309648727.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Explorador M\00F3vil')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_process_button_ids
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(874104981.4001)
,p_lov_name=>'PAGE_PROCESS_BUTTON_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :FB_FLOW_PAGE_ID',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:FB_FLOW_PAGE_ID, ui.global_page_id)',
'         order by x, bn ',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_size_units
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11205810538925547.4001)
,p_lov_name=>'PAGE_SIZE_UNITS'
,p_lov_query=>'.'||wwv_flow_api.id(11205810538925547.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11206106459925548.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Puntos'
,p_lov_return_value=>'POINTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11206318132925548.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Pulgadas'
,p_lov_return_value=>'INCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11206525283925548.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Mil\00EDmetros')
,p_lov_return_value=>'MILIMETERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11206721741925548.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Cent\00EDmetros')
,p_lov_return_value=>'CENTIMETERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(141264908196813501.4001)
,p_lov_name=>'PAGE_SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141265101710813505.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabla'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(141265331215813507.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Consulta SQL'
,p_lov_return_value=>'QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_template_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361310216348385184.4001)
,p_lov_name=>'PAGE_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(361310216348385184.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361310505494385184.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina de Cuadro de Di\00E1logo')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361310808301385185.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('P\00E1gina Normal')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_template_wiz
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86592719346240927.4001)
,p_lov_name=>'PAGE_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_api.id(86592719346240927.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88304318793821260.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88304522228821260.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_type_selection
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(497897080593180120.4001)
,p_lov_name=>'PAGE_TYPE_SELECTION'
,p_lov_query=>'.'||wwv_flow_api.id(497897080593180120.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497897377095180126.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Componente'
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497897731033180129.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n')
,p_lov_return_value=>'FEATURE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_validation_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131915151655.4001)
,p_lov_name=>'PAGE_VALIDATION_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(131915151655.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88159421716967927.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88159624014967927.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Valor Booleano')
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88159825561967927.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Texto de Error')
,p_lov_return_value=>'FUNC_BODY_RETURNING_ERR_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88160001279967928.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'El elemento/columna especificado NO NULO'
,p_lov_return_value=>'ITEM_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88162620381967931.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88163214798967932.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL')
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88163626551967932.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Expresi\00F3n SQL')
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88162807376967931.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Error PL/SQL'
,p_lov_return_value=>'PLSQL_ERROR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88161630524967930.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'El elemento/columna especificado NO es cero'
,p_lov_return_value=>'ITEM_NOT_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88161809824967930.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'El elemento/columna especificado no contiene espacios'
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88162030394967930.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'El elemento/columna especificado es NO NULO o cero'
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88162230185967930.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>unistr('El elemento/columna especificado es alfanum\00E9rico')
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88162428823967931.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('El elemento/columna especificado es num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42663306349689860.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('El elemento/columna especificado es una fecha v\00E1lida')
,p_lov_return_value=>'ITEM_IS_DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168169815429274616.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('El elemento/columna especificado es un registro de hora v\00E1lido')
,p_lov_return_value=>'ITEM_IS_TIMESTAMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88161023720967929.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 es igual que el literal de cadena de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_EQ_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88160629326967929.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 no es igual que el literal de cadena de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88163405736967932.4001)
,p_lov_disp_sequence=>195
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 coincide con la expresi\00F3n regular de la Expresi\00F3n 2')
,p_lov_return_value=>'REGULAR_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88161429567967930.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 est\00E1 incluido en la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_IN_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88161215339967929.4001)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 no est\00E1 incluido en la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_NOT_IN_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88160205381967928.4001)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 contiene al menos uno de los caracteres de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88160405596967928.4001)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 contiene s\00F3lo caracteres de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88160803174967929.4001)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>unistr('El elemento/columna en la Expresi\00F3n 1 no contiene ning\00FAn car\00E1cter de la Expresi\00F3n 2')
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(886430412165364351.4001)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Se ha activado al menos un selector de fila'
,p_lov_return_value=>'ROW_SELECTORS_CHECKED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(886493804678371606.4001)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>unistr('Los valores de columna enviados son \00FAnicos')
,p_lov_return_value=>'UNIQUE_COLUMN'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_view_mode_002
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84240119994394393.4001)
,p_lov_name=>'PAGE_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(84240119994394393.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84240330663394394.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84240527246394394.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Detalle'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pagination
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(99817717480817679.4001)
,p_lov_name=>'PAGINATION'
,p_lov_query=>'.'||wwv_flow_api.id(99817717480817679.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99818003503817701.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Rangos de Fila X a Y de Z (sin paginaci\00F3n)')
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99818224386817703.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Rangos de Fila X a Y (sin paginaci\00F3n)')
,p_lov_return_value=>'ROWS_X_TO_Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99818416060817704.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Motor de B\00FAsqueda 1,2,3,4 (paginaci\00F3n basada en juegos)')
,p_lov_return_value=>'SEARCH_ENGINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99818616394817704.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Usar Botones de Paginaci\00F3n Creados Externamente')
,p_lov_return_value=>'COMPUTED_BUT_NOT_DISPLAYED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99818822634817704.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Rangos de Fila 1-15 16-30  (con paginaci\00F3n de juego)')
,p_lov_return_value=>'ROW_RANGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99819028134817704.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Rangos de Fila 1-15 16-30 en Lista de Selecci\00F3n (con paginaci\00F3n)')
,p_lov_return_value=>'ROW_RANGES_IN_SELECT_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99819821574817706.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Rangos de Fila X a Y de Z (con paginaci\00F3n)')
,p_lov_return_value=>'ROW_RANGES_WITH_LINKS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39002816961800537.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Rangos de Fila X a Y (con enlaces siguientes y anteriores)'
,p_lov_return_value=>'NEXT_PREVIOUS_LINKS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pagination_display_position
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3941822825486065.4001)
,p_lov_name=>'PAGINATION.DISPLAY.POSITION'
,p_lov_query=>'.'||wwv_flow_api.id(3941822825486065.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88164425179968925.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Abajo - Inicio'
,p_lov_return_value=>'BOTTOM_LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88164621858968925.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Abajo - Final'
,p_lov_return_value=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88164803008968926.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Arriba - Inicio'
,p_lov_return_value=>'TOP_LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88165000666968926.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Arriba - Final'
,p_lov_return_value=>'TOP_RIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88165212735968926.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Arriba y Abajo - Inicio'
,p_lov_return_value=>'TOP_AND_BOTTOM_LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88165425741968928.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Arriba y Abajo - Final'
,p_lov_return_value=>'TOP_AND_BOTTOM_RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/parent_list_list_items
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6467729263888343.4001)
,p_lov_name=>'PARENT_LIST.LIST_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :P4053_LIST_ID',
'    start with id = :P4053_ID ',
'    connect by prior id = parent_list_item_id',
')',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P4053_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/parent_regions_current_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(171055708949151026.4001)
,p_lov_name=>'PARENT_REGIONS_CURRENT_PAGE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/parent_tab_set
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(83376300088038016.4001)
,p_lov_name=>'PARENT_TAB_SET'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(tab_set) d, tab_set r',
'',
'from wwv_flow_toplevel_tabs',
'',
'where flow_id = nv(''FB_FLOW_ID'') and',
'',
'      security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/persistence_opts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84831517957313758.4001)
,p_lov_name=>'PERSISTENCE_OPTS'
,p_lov_query=>'.'||wwv_flow_api.id(84831517957313758.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84831715807313758.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Por sesi\00F3n (disco)')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84831914478313759.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Por usuario (disco)'
,p_lov_return_value=>'U'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(74481706551378214.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Por solicitud (solo memoria)'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_custom_css_link
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(353335506996711467.4001)
,p_lov_name=>'PICK CUSTOM CSS LINK'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#IMAGE''||''_PREFIX#themes/theme_''||theme_id||''/svg.css'' d,',
'''#IMAGE''||''_PREFIX#themes/theme_''||theme_id||''/svg.css'' r',
'from   wwv_flow_themes where flow_id = :fb_flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_item_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8907709900373021.4001)
,p_lov_name=>'PICK.ITEM.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(8907709900373021.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3267203309997582.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (HTML5)'
,p_lov_return_value=>'NATIVE_DATE_PICKER_HTML5'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DATE_PICKER_HTML5'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8908006653373023.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Campo de Texto'
,p_lov_return_value=>'NATIVE_TEXT_FIELD'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_TEXT_FIELD'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8908224799373024.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea de Texto')
,p_lov_return_value=>'NATIVE_TEXTAREA'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_TEXTAREA'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_area.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8908418989373024.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n')
,p_lov_return_value=>'NATIVE_SELECT_LIST'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_SELECT_LIST'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_pulldwn.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8908601172373024.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bot\00F3n de Radio')
,p_lov_return_value=>'NATIVE_RADIOGROUP'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_RADIOGROUP'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_radio.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8908828638373027.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oculto'
,p_lov_return_value=>'NATIVE_HIDDEN'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_HIDDEN'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_hidden.gif"  height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8909015142373027.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Casilla de Control'
,p_lov_return_value=>'NATIVE_CHECKBOX'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_CHECKBOX'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_check.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8909408222373028.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Contrase\00F1a')
,p_lov_return_value=>'NATIVE_PASSWORD'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_PASSWORD'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_pswd.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8909609752373028.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00F3lo Visualizaci\00F3n')
,p_lov_return_value=>'NATIVE_DISPLAY_ONLY'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DISPLAY_ONLY'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_html2.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8909813534373028.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Valores Emergente'
,p_lov_return_value=>'POPUP'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''POPUP'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_popup.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8910208834373029.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Gestor de Listas'
,p_lov_return_value=>'NATIVE_LIST_MANAGER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_LIST_MANAGER'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_listmgr.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9404502489953110.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Exploraci\00F3n de Archivos')
,p_lov_return_value=>'NATIVE_FILE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_FILE'');apex.submit(''NEXT'');" alt="File Browse Control Type"><img src="#IMAGE_PREFIX#htmldb/icons/text_fileupload.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10594217053221501.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED/No')
,p_lov_return_value=>'NATIVE_YES_NO'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_YES_NO'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/item_generic.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10719314000450668.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Gu\00EDa de Desplazamiento')
,p_lov_return_value=>'NATIVE_SLIDER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_SLIDER'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/item_generic.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(27291000242248919.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plugins'
,p_lov_return_value=>'PLUGINS'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''PLUGINS'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_custom_item.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28057322773126767.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Parar e Iniciar Dise\00F1o de Cuadr\00EDcula (En desuso)')
,p_lov_return_value=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_STOP_AND_START_HTML_TABLE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_start_stop_html.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
,p_lov_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41159810857656724.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector'
,p_lov_return_value=>'NATIVE_SHUTTLE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_SHUTTLE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/shuttle.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178424424982076732.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Campo de texto con terminaci\00F3n autom\00E1tica')
,p_lov_return_value=>'NATIVE_AUTO_COMPLETE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_AUTO_COMPLETE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(186385501532616826.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Editor de Texto Enriquecido'
,p_lov_return_value=>'NATIVE_RICH_TEXT_EDITOR'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_RICH_TEXT_EDITOR'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/rich_text_editor.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(262392928279878232.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha'
,p_lov_return_value=>'NATIVE_DATE_PICKER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DATE_PICKER'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_cal.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(429342610723553668.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Campo Num\00E9rico')
,p_lov_return_value=>'NATIVE_NUMBER_FIELD'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_NUMBER_FIELD'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(483847108707511533.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostrar Imagen'
,p_lov_return_value=>'NATIVE_DISPLAY_IMAGE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DISPLAY_IMAGE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/display_image.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_plsql_validation_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9572322050621169.4001)
,p_lov_name=>'PICK.PLSQL.VALIDATION.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(9572322050621169.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9572609687621171.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL')
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9572832523621172.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Error PL/SQL'
,p_lov_return_value=>'PLSQL_ERROR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9573017854621172.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Valor Booleano')
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9573212373621172.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Funci\00F3n que Devuelve Texto de Error')
,p_lov_return_value=>'FUNC_BODY_RETURNING_ERR_TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_validation_category
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11226805981881336.4001)
,p_lov_name=>'PICK.VALIDATION.CATEGORY'
,p_lov_query=>'.'||wwv_flow_api.id(11226805981881336.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11227126312881337.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('SQL<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_sql.gif" height="75" width="100" alt="Marcador de Posici\00F3n" />')
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11227327505881337.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('PL/SQL<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_plsql.gif" height="75" width="100" alt="Marcador de Posici\00F3n" />')
,p_lov_return_value=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11227532202881337.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Elemento No Nulo<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_notnull.gif" height="75" width="100" alt="Marcador de Posici\00F3n" />')
,p_lov_return_value=>'NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11227705592881338.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Comparaci\00F3n de Cadenas de Elementos<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_stringcompare.gif" height="75" width="100" alt="Marcador de Posici\00F3n" />')
,p_lov_return_value=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11227907063881338.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Expresi\00F3n Regular<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_regexp.gif" height="75" width="100" alt="Marcador de Posici\00F3n" />')
,p_lov_return_value=>'REGEX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_validation_category_with_images
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9536028012528261.4001)
,p_lov_name=>'PICK.VALIDATION.CATEGORY (WITH IMAGES)'
,p_lov_query=>'.'||wwv_flow_api.id(9536028012528261.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9536732257528264.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'No Nulo'
,p_lov_return_value=>'ITEM_NOT_NULL'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P248_LEVEL'
,p_lov_disp_cond2=>'ITEM:COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9536927140528265.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Comparaci\00F3n de Cadenas')
,p_lov_return_value=>'STRING'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P248_LEVEL'
,p_lov_disp_cond2=>'ITEM:COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9537131769528265.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Expresi\00F3n Regular')
,p_lov_return_value=>'REGULAR_EXPRESSION'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P248_LEVEL'
,p_lov_disp_cond2=>'ITEM:COLUMN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9536313428528264.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9536510909528264.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'PL/SQL'
,p_lov_return_value=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_export_flowid_user_has_priv_on
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361587217232122032.4001)
,p_lov_name=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000L1 */ distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_flowid_user_has_priv_on
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(138126827261.4001)
,p_lov_name=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_image_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(136371109397.4001)
,p_lov_name=>'PICK_IMAGE_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(484873618926179854.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(484873618926179854.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484874402027179857.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484873806464179857.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484874211660179857.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484874012442179857.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL')
,p_lov_return_value=>'P'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_appontab_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(354663504966529830.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.APPONTAB.PK2'
,p_lov_query=>'.'||wwv_flow_api.id(354663504966529830.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354663817551529832.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:322:&SESSION.::::P322_PK2_SOURCE_TYPE:T"><img src="#IMAGE_PREFIX#htmldb/builder/pk_frm_tgr.gif" width="140" height="115" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354664018203529833.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:322:&SESSION.::::P322_PK2_SOURCE_TYPE:F"><img src="#IMAGE_PREFIX#htmldb/builder/pk_frm_fkt.gif" width="140" height="115" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354664228766529833.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:322:&SESSION.::::P322_PK2_SOURCE_TYPE:S"><img src="#IMAGE_PREFIX#htmldb/builder/pk_frm_seq.gif" width="140" height="115" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_detail_table
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(352799013917119271.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.DETAIL_TABLE'
,p_lov_query=>'.'||wwv_flow_api.id(352799013917119271.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352799326578119281.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352799504982119287.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352799732085119287.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_detail_table_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(354857822180853056.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.DETAIL_TABLE.pk2'
,p_lov_query=>'.'||wwv_flow_api.id(354857822180853056.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354858126082853060.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354858324350853060.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354858518105853060.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_and_rpt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(353086022864435670.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_AND_RPT'
,p_lov_query=>'.'||wwv_flow_api.id(353086022864435670.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353086319474435683.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353086510084435684.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353086701342435684.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_and_rpt_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(353531720082576530.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_AND_RPT.PK2'
,p_lov_query=>'.'||wwv_flow_api.id(353531720082576530.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353532022777576538.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353532228693576540.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353532421265576540.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_on_table
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(352937431933900311.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_ON_TABLE'
,p_lov_query=>'.'||wwv_flow_api.id(352937431933900311.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352937713224900316.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352937930916900317.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352938101747900317.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_on_table_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(353234920560769172.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_ON_TABLE_PK2'
,p_lov_query=>'.'||wwv_flow_api.id(353234920560769172.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353235227228769175.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353235416326769176.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(353235618729769176.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_master_table
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(109748910763779674.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.MASTER_TABLE'
,p_lov_query=>'.'||wwv_flow_api.id(109748910763779674.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109749110982779676.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109749305139779677.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(109749520411779678.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(354777930196648711.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.PK2'
,p_lov_query=>'.'||wwv_flow_api.id(354777930196648711.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354778214608648715.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354778400953648715.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354778619727648715.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_tabular_form
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(352924107252836399.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.TABULAR_FORM'
,p_lov_query=>'.'||wwv_flow_api.id(352924107252836399.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352924419959836410.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352924610617836410.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(352924831123836410.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_tabular_form_pk2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(354918920831899336.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.TABULAR_FORM.pk2'
,p_lov_query=>'.'||wwv_flow_api.id(354918920831899336.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354919209780899342.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354919401744899342.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Funci\00F3n PL/SQL Personalizada')
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(354919621470899342.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_wiz_form_and_rpt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(230311169888029514.4001)
,p_lov_name=>'PK_COL_SOURCE_TYPES.WIZ.FORM_AND_RPT'
,p_lov_query=>'.'||wwv_flow_api.id(230311169888029514.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(230311440988029534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disparador Existente'
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(230311848885029538.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Secuencia Existente'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plsql_anonymous_block
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84783318827001758.4001)
,p_lov_name=>'PLSQL_ANONYMOUS_BLOCK'
,p_lov_query=>'.'||wwv_flow_api.id(84783318827001758.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84783500539001759.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Ejecutar c\00F3digo')
,p_lov_return_value=>'NATIVE_PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plsql_validation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(111144330433082822.4001)
,p_lov_name=>'PLSQL_VALIDATION'
,p_lov_query=>'.'||wwv_flow_api.id(111144330433082822.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(111144523380082823.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('No validar el c\00F3digo (analizar c\00F3digo s\00F3lo en tiempo de ejecuci\00F3n).')
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plug_chart_axis
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84913307529708111.4001)
,p_lov_name=>'PLUG.CHART.AXIS'
,p_lov_query=>'.'||wwv_flow_api.id(84913307529708111.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84913517211708112.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Valor Medio de la Serie'
,p_lov_return_value=>'AVG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84913719258708112.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Primer Valor de la Serie'
,p_lov_return_value=>'FIRST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84913917773708112.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('\00DAltimo Valor de la Serie')
,p_lov_return_value=>'LAST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84914531578708113.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Cero'
,p_lov_return_value=>'ZERO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_column_data_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(24174232595113027.4001)
,p_lov_name=>'PLUGIN.ATTRIBUTE.COLUMN_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(24174232595113027.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24174501605113034.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Varchar2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24174710587113038.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('N\00FAmero')
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24174906128113038.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Fecha'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24175108781113038.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Registro de Hora'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24175310330113038.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Registro de Hora con Zona Horaria'
,p_lov_return_value=>'TIMESTAMP_TZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24175504536113038.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Registro de Hora con Zona Horaria Local'
,p_lov_return_value=>'TIMESTAMP_LTZ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24175729866113038.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Intervalo de A\00F1o a Mes')
,p_lov_return_value=>'INTERVAL_Y2M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24175905278113038.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Intervalo de D\00EDa a Segundo')
,p_lov_return_value=>'INTERVAL_D2S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24176102810113039.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Blob'
,p_lov_return_value=>'BLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24176327601113039.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Clob'
,p_lov_return_value=>'CLOB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24176518608113039.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Bfile'
,p_lov_return_value=>'BFILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24337427838636550.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Rowid'
,p_lov_return_value=>'ROWID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_condition_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(189411726584965751.4001)
,p_lov_name=>'PLUGIN.ATTRIBUTE.CONDITION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(189411726584965751.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(189411926786965763.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'igual que'
,p_lov_return_value=>'EQUALS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(189412102027965767.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'distinto de'
,p_lov_return_value=>'NOT_EQUALS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(189413112877965767.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'en lista'
,p_lov_return_value=>'IN_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(189413328847965767.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'no en lista'
,p_lov_return_value=>'NOT_IN_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(189412704581965767.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'es nulo'
,p_lov_return_value=>'NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(189412916403965767.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'es no nulo'
,p_lov_return_value=>'NOT_NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_scope
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(32688601172502165.4001)
,p_lov_name=>'PLUGIN.ATTRIBUTE.SCOPE'
,p_lov_query=>'.'||wwv_flow_api.id(32688601172502165.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32689504325502172.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32688926523502169.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Componente'
,p_lov_return_value=>'COMPONENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548117909782258520.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Columna de Regi\00F3n')
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id          = ( select to_number(v(',
'                                  case :APP_PAGE_ID',
'                                    when ''4410'' then ''P4410_ID''',
'                                    when ''4415'' then ''P4415_PLUGIN_ID''',
'                                  end ))',
'                         from dual )',
'   and plugin_type = ''REGION TYPE''',
'   and '':'' || standard_attributes || '':'' like ''%:COLUMNS:%'''))
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(28057124498012298.4001)
,p_lov_name=>'PLUGIN.ATTRIBUTE.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(28057124498012298.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1503862373833569.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('ID de definici\00F3n de carga de datos')
,p_lov_return_value=>'DATA LOAD DEFINITION ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1800728647881167.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Plantilla de correo electr\00F3nico')
,p_lov_return_value=>'EMAIL TEMPLATE ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2200241845369098.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lenguaje de c\00F3digo')
,p_lov_return_value=>'CODE LANGUAGE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2200565089373416.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript (MLE)'
,p_lov_return_value=>'MLE JAVASCRIPT'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2200896501380458.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Expresi\00F3n de JavaScript (MLE) que devuelve VARCHAR2')
,p_lov_return_value=>'MLE JAVASCRIPT EXPRESSION VARCHAR2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2201131765383626.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Expresi\00F3n de JavaScript (MLE) que devuelve VALOR BOOLEANO')
,p_lov_return_value=>'MLE JAVASCRIPT EXPRESSION BOOLEAN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2201413213388324.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n JavaScript (MLE) que devuelve VARCHAR2')
,p_lov_return_value=>'MLE JAVASCRIPT FUNCTION BODY VARCHAR2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2201759703390771.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n JavaScript (MLE) que devuelve VALOR BOOLEANO')
,p_lov_return_value=>'MLE JAVASCRIPT FUNCTION BODY BOOLEAN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6374820124387388.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Casillas de Control'
,p_lov_return_value=>'CHECKBOXES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20774004730407858.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Columna de Sentencia SQL de Regi\00F3n')
,p_lov_return_value=>'REGION SOURCE COLUMN'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id          = ( select to_number(v(',
'                                  case :APP_PAGE_ID',
'                                    when ''4410'' then ''P4410_ID''',
'                                    when ''4415'' then ''P4415_PLUGIN_ID''',
'                                  end ))',
'                         from dual )',
'   and plugin_type = ''REGION TYPE'''))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28057401464012301.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n')
,p_lov_return_value=>'SELECT LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28057622942012301.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Texto'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28057826100012301.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea de Texto')
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28058027106012301.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED/No')
,p_lov_return_value=>'CHECKBOX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48007808620320962.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('N\00FAmero')
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48008112083321912.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Entero'
,p_lov_return_value=>'INTEGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48008315200322857.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elemento de P\00E1gina')
,p_lov_return_value=>'PAGE ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48008519355324004.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elementos de P\00E1gina')
,p_lov_return_value=>'PAGE ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48008932169327789.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Consulta SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48009102864328704.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00F3digo PL/SQL')
,p_lov_return_value=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48010110829331087.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('N\00FAmero de P\00E1gina')
,p_lov_return_value=>'PAGE NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48406119103097620.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL que Devuelve VARCHAR2')
,p_lov_return_value=>'PLSQL EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361900618419930085.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('N\00FAmeros de P\00E1gina')
,p_lov_return_value=>'PAGE NUMBERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(362599722274410565.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Propietario'
,p_lov_return_value=>'OWNER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(362600020118411553.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabla'
,p_lov_return_value=>'TABLE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(362600317314412921.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381665885535326362.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Enlace a URL/P\00E1gina de Destino')
,p_lov_return_value=>'LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428534230926850149.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n PL/SQL que Devuelve VARCHAR2')
,p_lov_return_value=>'PLSQL FUNCTION BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(452899578203741582.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('C\00F3digo JavaScript')
,p_lov_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(671170332524876191.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Identificador de Tabla de Carga de Datos'
,p_lov_return_value=>'DATA LOAD TABLE ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1480587753813774720.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Color'
,p_lov_return_value=>'COLOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1480588039301781153.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1480588346234783062.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Icono'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1480588694006809077.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL que Devuelve BOOLEANO')
,p_lov_return_value=>'PLSQL EXPRESSION BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1480589799621825268.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n PL/SQL que Devuelve VALOR BOOLEANO')
,p_lov_return_value=>'PLSQL FUNCTION BODY BOOLEAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1480590833192849865.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'XML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1568894080086807607.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Grupos de autorizaci\00F3n')
,p_lov_return_value=>'AUTHORIZATION GROUPS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225313893310167436.4001)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Credenciales'
,p_lov_return_value=>'CREDENTIAL ID'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411:4050'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2600591329258094.4001)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>unistr('Marcadores de posici\00F3n de plantilla')
,p_lov_return_value=>'PLACEHOLDER JSON'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_authentication_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(332110302021701175.4001)
,p_lov_name=>'PLUGIN.AUTHENTICATION_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(332110302021701175.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(332112222407701179.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Tiene Atributo "Sesi\00F3n No V\00E1lida"')
,p_lov_return_value=>'INVALID_SESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1448982795495050063.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Contiene P\00E1gina de Conexi\00F3n en la Aplicaci\00F3n')
,p_lov_return_value=>'LOGIN_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_category
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(626799404677287430.4001)
,p_lov_name=>'PLUGIN.CATEGORY'
,p_lov_query=>'.'||wwv_flow_api.id(626799404677287430.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3788202634702.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Navegaci\00F3n')
,p_lov_return_value=>'NAVIGATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626799631439287435.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Estilo'
,p_lov_return_value=>'STYLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626799816855287438.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Varios'
,p_lov_return_value=>'MISC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626800015856287439.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Efecto'
,p_lov_return_value=>'EFFECT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626800225391287439.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Notificaci\00F3n')
,p_lov_return_value=>'NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626800411496287439.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ejecuci\00F3n')
,p_lov_return_value=>'EXECUTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626800619508287439.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Componente'
,p_lov_return_value=>'COMPONENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(626808308823562993.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Inicializaci\00F3n')
,p_lov_return_value=>'INIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_dynamic_action_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(439399613733990280.4001)
,p_lov_name=>'PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(439399613733990280.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439399829752990280.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Para Elementos'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(206181812441168171.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Bot\00F3n Para')
,p_lov_return_value=>'BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439400021759990284.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Para Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439401323346011992.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Para Selector de jQuery'
,p_lov_return_value=>'JQUERY_SELECTOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(855920777887326142.4001)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>unistr('Para Expresi\00F3n JavaScript')
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623898502368610777.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Para Elemento Disparador'
,p_lov_return_value=>'TRIGGERING_ELEMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623898707908612350.4001)
,p_lov_disp_sequence=>47
,p_lov_disp_value=>'Para Origen de Evento'
,p_lov_return_value=>'EVENT_SOURCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439490210997742654.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Elementos Afectado Necesario'
,p_lov_return_value=>'REQUIRED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439490428658747711.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Activar "Disparar al inicializar"'
,p_lov_return_value=>'ONLOAD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439401513087018475.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Tiene Atributo de "Detenci\00F3n de Sesi\00F3n en Caso de Error"')
,p_lov_return_value=>'STOP_EXECUTION_ON_ERROR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23170927204051838.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Tiene Atributo "Espera de Resultados"'
,p_lov_return_value=>'WAIT_FOR_RESULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(835398202170249455.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('Tiene el Atributo "C\00F3digo JavaScript de Inicializaci\00F3n"')
,p_lov_return_value=>'INIT_JAVASCRIPT_CODE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_item_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(27295207392317233.4001)
,p_lov_name=>'PLUGIN.ITEM TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(display_name) as d,',
'       ''PLUGIN_'' || name as r',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''ITEM TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_item_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(439387913761867364.4001)
,p_lov_name=>'PLUGIN.ITEM_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(439387913761867364.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439388100102867367.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Es Widget Visible'
,p_lov_return_value=>'VISIBLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1426966529506570479.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Elemento de Pantalla Est\00E1ndar')
,p_lov_return_value=>'FORM_ELEMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439388310531867374.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Estado de Sesi\00F3n Cambiable')
,p_lov_return_value=>'SESSION_STATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441070411568686266.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Tiene Atributo de S\00F3lo Lectura')
,p_lov_return_value=>'READONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439389300381867375.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tiene Atributo "Caracteres Especiales de Escape"'
,p_lov_return_value=>'ESCAPE_OUTPUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439389107985867375.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Tiene Atributos de Listas de Valores'
,p_lov_return_value=>'QUICKPICK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441062726095189003.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Tiene Atributos de Origen'
,p_lov_return_value=>'SOURCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441950109070290537.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('M\00E1scara de Formato S\00F3lo para Fecha')
,p_lov_return_value=>'FORMAT_MASK_DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441963709603404191.4001)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>unistr('M\00E1scara de Formato S\00F3lo para N\00FAmero')
,p_lov_return_value=>'FORMAT_MASK_NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(442053408974983944.4001)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Tiene Atributos de Elemento'
,p_lov_return_value=>'ELEMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441379627757227124.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Tiene Atributos de Ancho'
,p_lov_return_value=>'WIDTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439388531474867374.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Tiene Atributo de Altura'
,p_lov_return_value=>'HEIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445142109307930388.4001)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>unistr('Tiene Atributo de Opci\00F3n de Elemento')
,p_lov_return_value=>'ELEMENT_OPTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2972426563463903.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Tiene Atributo de Marcador de Posici\00F3n')
,p_lov_return_value=>'PLACEHOLDER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(656826758503014879.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Tiene Atributo de Icono'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(441292332046487512.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Tiene Atributo de Cifrado de Estado de Sesi\00F3n')
,p_lov_return_value=>'ENCRYPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439388725246867374.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Tiene Lista de Valores'
,p_lov_return_value=>'LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445130924273840076.4001)
,p_lov_disp_sequence=>115
,p_lov_disp_value=>unistr('Tiene Atributos Nulos de Visualizaci\00F3n de Lista de Valores')
,p_lov_return_value=>'LOV_DISPLAY_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(455253123560548840.4001)
,p_lov_disp_sequence=>117
,p_lov_disp_value=>'Tiene Atributos de Lista de Valores en Cascada'
,p_lov_return_value=>'CASCADING_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(649667573866335830.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('Lista de Valores de Uni\00F3n para Visualizaci\00F3n de Columna')
,p_lov_return_value=>'JOIN_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(253162868502236618.4001)
,p_lov_disp_sequence=>127
,p_lov_disp_value=>'Tiene Filtro'
,p_lov_return_value=>'FILTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(253163140954237733.4001)
,p_lov_disp_sequence=>137
,p_lov_disp_value=>'Tiene Enlace'
,p_lov_return_value=>'LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(835397432361242933.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('Tiene el Atributo "C\00F3digo JavaScript de Inicializaci\00F3n"')
,p_lov_return_value=>'INIT_JAVASCRIPT_CODE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2508829793665868.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Faceta: Recopilar incidencias'
,p_lov_return_value=>'FC_HAS_FEEDBACK'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2509174100671781.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Faceta: Mostar seleccionadas primero'
,p_lov_return_value=>'FC_SHOW_SELECTED_FIRST'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2509475818676107.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>unistr('Faceta: M\00E1ximo de entradas mostradas')
,p_lov_return_value=>'FC_SHOW_MORE_COUNT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2509782310680033.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Faceta: Filtrado del cliente'
,p_lov_return_value=>'FC_FILTER_VALUES'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(598133888019449803.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Faceta: Mostrar valor nulo de lista de valores'
,p_lov_return_value=>'FC_LOV_DISPLAY_NULL'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_process_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(471074120618926840.4001)
,p_lov_name=>'PLUGIN.PROCESS TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name    as d,',
'       ''PLUGIN_''||name as r',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''PROCESS TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_process_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(366693502933776161.4001)
,p_lov_name=>'PLUGIN.PROCESS_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(366693502933776161.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366693829534776162.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(366694131496776164.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n Necesaria')
,p_lov_return_value=>'REGION_REQUIRED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_region_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(33181601315857917.4001)
,p_lov_name=>'PLUGIN.REGION TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name    as d,',
'       ''PLUGIN_''||name as r',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''REGION TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_region_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(439394121736945367.4001)
,p_lov_name=>'PLUGIN.REGION_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(439394121736945367.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153189234261472126.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('La opci\00F3n Origen de regi\00F3n soporta diferentes or\00EDgenes de datos')
,p_lov_return_value=>'SOURCE_LOCATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439395528858945372.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('El origen de regi\00F3n es una sentencia SQL [en desuso]')
,p_lov_return_value=>'SOURCE_SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(384618513952478181.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('El Origen de Regi\00F3n es una Sentencia PL/SQL')
,p_lov_return_value=>'SOURCE_PLSQL'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(384618889206489831.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('El origen de regi\00F3n es el cuerpo de la funci\00F3n PL/SQL [en desuso]')
,p_lov_return_value=>'SOURCE_PLSQL_FUNCTION'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(385143330920680664.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('El Origen de Regi\00F3n es HTML')
,p_lov_return_value=>'SOURCE_HTML'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439436520368796393.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('El Origen de Regi\00F3n es Texto sin Formato')
,p_lov_return_value=>'SOURCE_PLAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(18432507772059146.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Tiene Atributo "Elementos de P\00E1gina que Ejecutar"')
,p_lov_return_value=>'AJAX_ITEMS_TO_SUBMIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(21670917336024482.4001)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>unistr('Tiene Atributo "N\00FAmero de Filas Recuperadas"')
,p_lov_return_value=>'FETCHED_ROWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22580629800196411.4001)
,p_lov_disp_sequence=>37
,p_lov_disp_value=>unistr('Tiene Atributo "Mensaje No se ha encontrado ning\00FAn dato"')
,p_lov_return_value=>'NO_DATA_FOUND_MESSAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(18419625995054930.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Tiene Atributo de Regi\00F3n "Caracteres Especiales de Escape"')
,p_lov_return_value=>'ESCAPE_OUTPUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(835394704716201109.4001)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>unistr('Tiene el Atributo "C\00F3digo JavaScript de Inicializaci\00F3n"')
,p_lov_return_value=>'INIT_JAVASCRIPT_CODE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548119689276281859.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Tiene "Columnas de Regi\00F3n"')
,p_lov_return_value=>'COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548987824966885830.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Tiene Atributo de Columna "Cabecera"'
,p_lov_return_value=>'COLUMN_HEADING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548989786890952346.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Tiene Atributo de Columna "Alineaci\00F3n de Cabecera"')
,p_lov_return_value=>'HEADING_ALIGNMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548990018583954291.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Tiene Atributo de Columna "Alineaci\00F3n"')
,p_lov_return_value=>'VALUE_ALIGNMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548990319028956610.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Tiene Atributo de Columna "Clase CSS"'
,p_lov_return_value=>'VALUE_CSS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548990626095958042.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Tiene Atributo de Columna "Atributos Personalizados"'
,p_lov_return_value=>'VALUE_ATTRIBUTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(548990943632960667.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Tiene Atributo de Columna "Caracteres Especiales de Escape"'
,p_lov_return_value=>'VALUE_ESCAPE_OUTPUT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(32850007287563326.4001)
,p_lov_name=>'PLUGIN.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(32850007287563326.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1203035157777517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Origen de Datos de REST'
,p_lov_return_value=>'WEB SOURCE TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10801624058272206.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Tipo de Esquema de Autorizaci\00F3n')
,p_lov_return_value=>'AUTHORIZATION TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32850301282563333.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32850532265563335.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Elemento'
,p_lov_return_value=>'ITEM TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34962508350286283.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Acci\00F3n Din\00E1mica')
,p_lov_return_value=>'DYNAMIC ACTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(185355615983053829.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna de Informe'
,p_lov_return_value=>'REPORT COLUMN TYPE'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(331855316556629721.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Tipo de Esquema de Autenticaci\00F3n')
,p_lov_return_value=>'AUTHENTICATION TYPE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471054818560027488.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Proceso'
,p_lov_return_value=>'PROCESS TYPE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_web_source_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1416444037632936.4001)
,p_lov_name=>'PLUGIN.WEB_SOURCE_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_api.id(1416444037632936.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1416731728632988.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Punto final por defecto'
,p_lov_return_value=>'ENDPOINT_HINT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pluginpagetypes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(393518083752056962.4001)
,p_lov_name=>'PLUGINPAGETYPES'
,p_lov_query=>'.'||wwv_flow_api.id(393518083752056962.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(393518374793056965.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendario CSS'
,p_lov_return_value=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(393518647212056970.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Vista de Lista'
,p_lov_return_value=>'NATIVE_JQM_LIST_VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(393518972587056970.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Tabla de Respuesta'
,p_lov_return_value=>'NATIVE_JQM_RESPONSIVE_TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugins
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(30477426464330230.4001)
,p_lov_name=>'PLUGINS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       id           as r',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by display_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_lov_on_delete
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361908530213065178.4001)
,p_lov_name=>'PLUGIN_ATTRIBUTE_LOV_ON_DELETE'
,p_lov_query=>'.'||wwv_flow_api.id(361908530213065178.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361908726901065178.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Cascada'
,p_lov_return_value=>'WEAK_CASCADE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361909027322065178.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Definir en NULO'
,p_lov_return_value=>'WEAK_NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_lov_scope
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361909922032072224.4001)
,p_lov_name=>'PLUGIN_ATTRIBUTE_LOV_SCOPE'
,p_lov_query=>'.'||wwv_flow_api.id(361909922032072224.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361910110952072224.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina Actual')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361910432729072225.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00E1gina Actual y P\00E1gina Global')
,p_lov_return_value=>'PAGE_AND_GLOBAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361910726090072225.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'En Componente Principal'
,p_lov_return_value=>'PARENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361911031653072225.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Tema Actual'
,p_lov_return_value=>'THEME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_lov_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361905807263001770.4001)
,p_lov_name=>'PLUGIN_ATTRIBUTE_LOV_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(361905807263001770.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361906028094001770.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Est\00E1tico')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361906321494001771.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Componente'
,p_lov_return_value=>'COMPONENT'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_set_text_case
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(361901313057946615.4001)
,p_lov_name=>'PLUGIN_ATTRIBUTE_SET_TEXT_CASE'
,p_lov_query=>'.'||wwv_flow_api.id(361901313057946615.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361901512487946618.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('May\00FAsculas')
,p_lov_return_value=>'UPPER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(361901832142946620.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Min\00FAsculas')
,p_lov_return_value=>'LOWER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_item_type_component_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(513667640463524657.4001)
,p_lov_name=>'PLUGIN_ITEM_TYPE_COMPONENT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(513667640463524657.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(513667952736524660.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elementos de P\00E1gina')
,p_lov_return_value=>'APEX_APPLICATION_PAGE_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(513668320889524662.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Columnas de Cuadr\00EDcula Interactiva')
,p_lov_return_value=>'APEX_APPL_PAGE_IG_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2000801925703610.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Facetas'
,p_lov_return_value=>'APEX_APPL_PAGE_FACETS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2000867299582467.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Elementos de grupo de facetas'
,p_lov_return_value=>'APEX_APPL_PAGE_FACET_GRP_ITEMS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2200783911728139.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Filtros'
,p_lov_return_value=>'APEX_APPL_PAGE_SFILTERS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2201027090728164.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Filtrar elementos de grupo'
,p_lov_return_value=>'APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_process_type_component_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1800185422847060.4001)
,p_lov_name=>'PLUGIN_PROCESS_TYPE_COMPONENT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(1800185422847060.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1800462806847098.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Procesos de P\00E1gina')
,p_lov_return_value=>'APEX_APPLICATION_PAGE_PROC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1800841216847099.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Acciones de automatizaci\00F3n')
,p_lov_return_value=>'APEX_APPL_AUTOMATION_ACTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plug_chart_axis_002
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84331708594618216.4001)
,p_lov_name=>'PLUG_CHART_AXIS'
,p_lov_query=>'.'||wwv_flow_api.id(84331708594618216.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84331906767618217.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Valor Medio de la Serie'
,p_lov_return_value=>'AVG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84332132650618217.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Primer Valor de la Serie'
,p_lov_return_value=>'FIRST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84332309505618218.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('\00DAltimo Valor de la Serie')
,p_lov_return_value=>'LAST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84332528115618218.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Valor M\00E1ximo de la Serie')
,p_lov_return_value=>'MAX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84332710962618218.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Valor M\00EDnimo de la Serie')
,p_lov_return_value=>'MIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84332909633618218.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Cero'
,p_lov_return_value=>'ZERO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plug_chart_font_size
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84691009705624527.4001)
,p_lov_name=>'PLUG_CHART_FONT_SIZE'
,p_lov_query=>'.'||wwv_flow_api.id(84691009705624527.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84691205352624528.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'-3'
,p_lov_return_value=>'-3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84691410423624528.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'-2'
,p_lov_return_value=>'-2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84691626959624528.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'-1'
,p_lov_return_value=>'-1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84691800905624529.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'+0'
,p_lov_return_value=>'+0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84692006310624529.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'+1'
,p_lov_return_value=>'+1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84692221772624529.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'+2'
,p_lov_return_value=>'+2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84692428366624529.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'+3'
,p_lov_return_value=>'+3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84692607861624530.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'+4'
,p_lov_return_value=>'+4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84692824991624530.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'+5'
,p_lov_return_value=>'+5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84693026747624530.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'+6'
,p_lov_return_value=>'+6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84693202667624530.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'+7'
,p_lov_return_value=>'+7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/popup_lov_template_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(59418530750879398.4001)
,p_lov_name=>'POPUP LOV TEMPLATE THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(59418530750879398.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(59418812008879404.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est\00E1ndar')
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/popup_table_finder_view_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(171249216657727210.4001)
,p_lov_name=>'POPUP TABLE FINDER VIEW OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(171249216657727210.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(171249406596727214.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tablas y Vistas'
,p_lov_return_value=>'TABLES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(171249600269727216.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Columnas de Tabla Seleccionadas'
,p_lov_return_value=>'COLUMNS'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P514_TABLE_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(171249804476727216.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Consulta en Tabla Seleccionada'
,p_lov_return_value=>'QUERY'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P514_TABLE_NAME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preserve_case_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(215454417816546080.4001)
,p_lov_name=>'PRESERVE.CASE.Y'
,p_lov_query=>'.'||wwv_flow_api.id(215454417816546080.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(215454707655546082.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Mantener May\00FAsculas/Min\00FAsculas')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prez
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84371212244732793.4001)
,p_lov_name=>'PREZ'
,p_lov_query=>'.'||wwv_flow_api.id(84371212244732793.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84371421765732793.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'George W. Bush'
,p_lov_return_value=>'gwbush.jpg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84371617057732794.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Bill Clinton'
,p_lov_return_value=>'clinton.jpg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84371811280732794.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'George Washington'
,p_lov_return_value=>'washington.gif'
);
end;
/
prompt --application/shared_components/user_interface/lovs/primary_key_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11186021931343531.4001)
,p_lov_name=>'PRIMARY_KEY_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(11186021931343531.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11186317316343531.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Gestionado por Base de Datos (ROWID)'
,p_lov_return_value=>'ROWID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11186522675343532.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Seleccionar Columnas de Clave Primaria'
,p_lov_return_value=>'PKCOLS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/primary_key_type_calendar
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(623711109271847205.4001)
,p_lov_name=>'PRIMARY_KEY_TYPE_CALENDAR'
,p_lov_query=>'.'||wwv_flow_api.id(623711109271847205.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623711411862847210.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Gestionado por Base de Datos (ROWID)'
,p_lov_return_value=>'ROWID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(623711613430847214.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Seleccionar Columna de Clave Primaria'
,p_lov_return_value=>'PKCOLS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/printer_friendly
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(148325219515185885.4001)
,p_lov_name=>'PRINTER_FRIENDLY)'
,p_lov_query=>'.'||wwv_flow_api.id(148325219515185885.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(148325416715185890.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Versi\00F3n para Impresora')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/print_att_include_link
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(57998911830398981.4001)
,p_lov_name=>'PRINT_ATT_INCLUDE_LINK'
,p_lov_query=>'.'||wwv_flow_api.id(57998911830398981.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(57999115213398981.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(57999327144398981.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No (enlace manual)'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/print_items
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(29642100479782966.4001)
,p_lov_name=>'PRINT_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ('' || t || '') '' d,name r from (',
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where  flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where flow_id = :fb_flow_id',
'order by 4 asc nulls first, 1 asc',
')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/print_server_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6300179213172122.4001)
,p_lov_name=>'PRINT_SERVER_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(6300179213172122.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6300400826172138.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oracle Analytics Publisher'
,p_lov_return_value=>'BIP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6300856841172138.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'APEX Office Print'
,p_lov_return_value=>'AOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_conditional_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(66513426858953865.4001)
,p_lov_name=>'PRN_CONDITIONAL_Y_N'
,p_lov_query=>'.'||wwv_flow_api.id(66513426858953865.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(66513706760953868.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(66513908212953868.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_fonts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14413827328266173.4001)
,p_lov_name=>'PRN_FONTS'
,p_lov_query=>'.'||wwv_flow_api.id(14413827328266173.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14414108222266173.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Helvetica'
,p_lov_return_value=>'Helvetica'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14414321991266173.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Times'
,p_lov_return_value=>'Times'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14414502041266173.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Courier'
,p_lov_return_value=>'Courier'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_font_weight
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16555331301241275.4001)
,p_lov_name=>'PRN_FONT_WEIGHT'
,p_lov_query=>'.'||wwv_flow_api.id(16555331301241275.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16555620164241278.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'normal'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16555806266241278.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Negrita'
,p_lov_return_value=>'bold'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(16950902829395371.4001)
,p_lov_name=>'PRN_FORMAT'
,p_lov_query=>'.'||wwv_flow_api.id(16950902829395371.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16951202412395371.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PDF'
,p_lov_return_value=>'PDF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16951406045395371.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Word'
,p_lov_return_value=>'RTF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16951613265395371.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Excel'
,p_lov_return_value=>'XLS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16951828641395371.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131706624505895733.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'XML'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_page_orientation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14317429014888204.4001)
,p_lov_name=>'PRN_PAGE_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_api.id(14317429014888204.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14317704218888204.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'VERTICAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14317927446888204.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'HORIZONTAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_page_units
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14280128827774584.4001)
,p_lov_name=>'PRN_PAGE_UNITS'
,p_lov_query=>'.'||wwv_flow_api.id(14280128827774584.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14280419832774585.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Puntos'
,p_lov_return_value=>'POINTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14280620486774585.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Pulgadas'
,p_lov_return_value=>'INCHES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14280802207774585.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Mil\00EDmetros')
,p_lov_return_value=>'MILLIMETERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14281015797774585.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Cent\00EDmetros')
,p_lov_return_value=>'CENTIMETERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_paper_size
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(14283929435793739.4001)
,p_lov_name=>'PRN_PAPER_SIZE'
,p_lov_query=>'.'||wwv_flow_api.id(14283929435793739.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14284211408793739.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'CUSTOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14284428810793739.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Carta'
,p_lov_return_value=>'LETTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14284613426793739.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Legal'
,p_lov_return_value=>'LEGAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14284802250793739.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Tabloide'
,p_lov_return_value=>'TABLOID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14285022720793739.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'A4'
,p_lov_return_value=>'A4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14285218818793739.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'A3'
,p_lov_return_value=>'A3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/process_error_display_location
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4297030283172730.4001)
,p_lov_name=>'PROCESS_ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_api.id(4297030283172730.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4298230649172745.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('En L\00EDnea en Notificaci\00F3n')
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4298418936172745.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('En P\00E1gina de Error')
,p_lov_return_value=>'ON_ERROR_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/process_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(362343527524601835.4001)
,p_lov_name=>'PROCESS_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select display_name as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''PROCESS TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''PROCESS TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_personal
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84916217834730025.4001)
,p_lov_name=>'PUBLIC.PERSONAL'
,p_lov_query=>'.'||wwv_flow_api.id(84916217834730025.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84916402749730026.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personal'
,p_lov_return_value=>'PERSONAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84916603755730026.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00FAblico')
,p_lov_return_value=>'PUBLIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/publish_application_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(167669830217852225.4001)
,p_lov_name=>'PUBLISH APPLICATION ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000Lpubappid */ primary_language_flow_id||'' &gt;&gt; ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'       translation_flow_id r ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/publish_on_save
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(763360160878777085.4001)
,p_lov_name=>'PUBLISH_ON_SAVE'
,p_lov_query=>'.'||wwv_flow_api.id(763360160878777085.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(763360485051777149.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Publicar al Guardar'
,p_lov_return_value=>'PUBLISH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_debug_age
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(624059001579304056.4001)
,p_lov_name=>'PURGE_DEBUG_AGE'
,p_lov_query=>'.'||wwv_flow_api.id(624059001579304056.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624059225073304105.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('1 d\00EDa')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624059406874304105.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('2 d\00EDas')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624059604336304105.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('3 d\00EDas')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624059807883304105.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('4 d\00EDas')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624060031681304106.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'1 semana'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624060212455304106.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'2 semanas'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624060427460304106.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'3 semanas'
,p_lov_return_value=>'21'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624060618915304106.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'4 semanas'
,p_lov_return_value=>'28'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_debug_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(624047408693069523.4001)
,p_lov_name=>'PURGE_DEBUG_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(624047408693069523.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624047606508069524.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Depurar Todos los Mensajes'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624047819967069525.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Depurar Mensajes por Duraci\00F3n')
,p_lov_return_value=>'AGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624048000762069525.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Depurar Mensajes de Sesi\00F3n Actual')
,p_lov_return_value=>'SESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(624048203677069525.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Depurar por Identificador de Vista'
,p_lov_return_value=>'IDENTIFIER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pwa_manifest_display
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1687503362489571.4001)
,p_lov_name=>'PWA_MANIFEST_DISPLAY'
,p_lov_query=>'.'||wwv_flow_api.id(1687503362489571.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1687842433489584.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pantalla completa'
,p_lov_return_value=>'fullscreen'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1688200412489585.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Independiente'
,p_lov_return_value=>'standalone'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1688659493489586.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('IU m\00EDnima')
,p_lov_return_value=>'minimal-ui'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1689030494489586.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Explorador'
,p_lov_return_value=>'browser'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pwa_manifest_orientation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1689369179497016.4001)
,p_lov_name=>'PWA_MANIFEST_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_api.id(1689369179497016.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1689618233497016.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cualquiera'
,p_lov_return_value=>'any'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1690091857497016.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Natural'
,p_lov_return_value=>'natural'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1690479300497016.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'landscape'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1690803540497017.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Principal horizontal'
,p_lov_return_value=>'landscape-primary'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1691278072497017.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Secundario horizontal'
,p_lov_return_value=>'landscape-secondary'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1691665400497017.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'portrait'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1692030992497017.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Principal vertical'
,p_lov_return_value=>'portrait-primary'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1692490290497017.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Secundario vertical'
,p_lov_return_value=>'portrait-secondary'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84937920230853735.4001)
,p_lov_name=>'QUERY.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84937920230853735.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84938130889853736.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Usar Nombres de Columna Espec\00EDficos de Consulta y Validar Consulta')
,p_lov_return_value=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84938325410853736.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Usar Nombres de Columna Gen\00E9ricos (analizar consulta s\00F3lo en tiempo de ejecuci\00F3n)')
,p_lov_return_value=>'GENERIC_REPORT_COLUMNS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_headings_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84301323392565701.4001)
,p_lov_name=>'QUERY_HEADINGS_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84301323392565701.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84301521685565702.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Nombres de Columna'))
,p_lov_return_value=>'QUERY_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84301704281565702.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Nombres de Columna (May\00FAscula Inicial)')))
,p_lov_return_value=>'QUERY_COLUMNS_INITCAP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84301925334565702.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Personalizar'))
,p_lov_return_value=>'COLON_DELMITED_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84302118859565703.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'PL/SQL'))
,p_lov_return_value=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84302301898565703.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Ninguno'))
,p_lov_return_value=>'NO_HEADINGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ras_dynamic_roles
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(360317412154680283.4001)
,p_lov_name=>'RAS_DYNAMIC_ROLES'
,p_lov_query=>'select name n,name v from sys.dba_xs_dynamic_roles where system_defined=''NO'' order by 1'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ras_namespace_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(360317608272682130.4001)
,p_lov_name=>'RAS_NAMESPACE_TEMPLATES'
,p_lov_query=>'select name n,name v from sys.dba_xs_ns_templates where name not like ''XS$%'' order by 1'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/read_only_condition_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17050611946108603.4001)
,p_lov_name=>'READ_ONLY_CONDITION_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(17050611946108603.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17050929764108615.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists (la consulta SQL devuelve al menos una fila)'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17051100605108619.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists (la consulta SQL no devuelve ninguna fila)'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17051511707108619.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Expresi\00F3n')
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17051707362108619.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n que devuelve valor booleano')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17051923308108619.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Solicitud = Expresi\00F3n 1&nbsp;')
,p_lov_return_value=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17052122488108620.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Solicitud != Expresi\00F3n 1')
,p_lov_return_value=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17052329069108620.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Solicitud Incluida en Expresi\00F3n 1&nbsp;')
,p_lov_return_value=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17052506526108622.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Solicitud no Incluida en Expresi\00F3n 1&nbsp;')
,p_lov_return_value=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17052700466108622.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 = Expresi\00F3n 2')
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17052913964108622.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 != Expresi\00F3n 2')
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17053117063108622.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es NULO')
,p_lov_return_value=>'ITEM_IS_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17053331189108622.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es NO NULO')
,p_lov_return_value=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17053523987108622.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 = Cero')
,p_lov_return_value=>'ITEM_IS_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17053716908108622.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 != Cero')
,p_lov_return_value=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17053914469108622.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es NULO o cero')
,p_lov_return_value=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17054109879108622.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>unistr('El valor del elemento/columna en Expresi\00F3n 1 es NO nulo y el elemento es NO cero')
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17054310717108623.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 no contiene espacios')
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17054506909108623.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17054729773108623.4001)
,p_lov_disp_sequence=>201
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es no num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NOT_NUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17054921234108623.4001)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es alfanum\00E9rico')
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17055116000108624.4001)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>unistr('Valor de Elemento/Columna en Expresi\00F3n 1 Incluido en la Lista Delimitada por Dos Puntos en Expresi\00F3n 2')
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17055324881108624.4001)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>unistr('Valor de Elemento/Columna en Expresi\00F3n 1 NO Incluido en la Lista Delimitada por Dos Puntos en Expresi\00F3n 2')
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17055526320108624.4001)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>unistr('Valor de Preferencia del Usuario en Expresi\00F3n 1 = Expresi\00F3n 2')
,p_lov_return_value=>'USER_PREF_IN_COND_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17055716799108624.4001)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>unistr('Valor de Preferencia del Usuario en Expresi\00F3n 1 != Expresi\00F3n 2')
,p_lov_return_value=>'USER_PREF_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17055919181108624.4001)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>unistr('P\00E1gina Actual = Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_PAGE_EQUALS_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17056117265108624.4001)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>unistr('P\00E1gina Actual != Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17056315812108624.4001)
,p_lov_disp_sequence=>280
,p_lov_disp_value=>unistr('P\00E1gina Actual Incluida en Expresi\00F3n 1 (lista de p\00E1ginas delimitada por comas)&nbsp;')
,p_lov_return_value=>'CURRENT_PAGE_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17056510827108624.4001)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>unistr('P\00E1gina Actual no Incluida en Expresi\00F3n 1 (lista de p\00E1ginas delimitada por comas)&nbsp;')
,p_lov_return_value=>'CURRENT_PAGE_NOT_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17056715597108624.4001)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>unistr('P\00E1gina Actual = P\00E1gina Ejecutada (se ha enviado esta p\00E1gina)')
,p_lov_return_value=>'WHEN_THIS_PAGE_SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17056928044108624.4001)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>unistr('P\00E1gina Actual != P\00E1gina Ejecutada (\00E9sta no es la p\00E1gina enviada)')
,p_lov_return_value=>'WHEN_THIS_PAGE_NOT_SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17057121568108624.4001)
,p_lov_disp_sequence=>320
,p_lov_disp_value=>unistr('P\00E1gina Actual en modo Versi\00F3n para Impresora')
,p_lov_return_value=>'PAGE_IS_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17057319272108624.4001)
,p_lov_disp_sequence=>330
,p_lov_disp_value=>unistr('P\00E1gina Actual no en modo Versi\00F3n para Impresora')
,p_lov_return_value=>'PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17057520836108624.4001)
,p_lov_disp_sequence=>340
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 Incluida en el Valor del Elemento/Columna en Expresi\00F3n 2')
,p_lov_return_value=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17057700160108624.4001)
,p_lov_disp_sequence=>350
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 Incluido en el Texto de Expresi\00F3n 2')
,p_lov_return_value=>'DISPLAY_COND_IN_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17057917017108624.4001)
,p_lov_disp_sequence=>360
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 no Incluido en el Texto de Expresi\00F3n 2')
,p_lov_return_value=>'DISPLAY_COND_NOT_IN_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17058129556108624.4001)
,p_lov_disp_sequence=>370
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 = Expresi\00F3n 2 (incluye sustituciones &amp;ITEM.)')
,p_lov_return_value=>'DISPLAY_COND_EQUAL_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17058302599108624.4001)
,p_lov_disp_sequence=>380
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 != Expresi\00F3n 2 (incluye sustituciones &amp;ITEM.)')
,p_lov_return_value=>'DISP_COND_NOT_EQUAL_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17058500424108624.4001)
,p_lov_disp_sequence=>390
,p_lov_disp_value=>unistr('Usuario Autenticado  (no p\00FAblico)')
,p_lov_return_value=>'USER_IS_NOT_PUBLIC_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17058726811108624.4001)
,p_lov_disp_sequence=>400
,p_lov_disp_value=>unistr('El Usuario es el Usuario P\00FAblico (el usuario no se ha autenticado)')
,p_lov_return_value=>'USER_IS_PUBLIC_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17058904202108624.4001)
,p_lov_disp_sequence=>410
,p_lov_disp_value=>unistr('Errores de Validaci\00F3n en L\00EDnea Mostrados')
,p_lov_return_value=>'DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17059101306108625.4001)
,p_lov_disp_sequence=>420
,p_lov_disp_value=>unistr('Errores de Validaci\00F3n en L\00EDnea No Mostrados')
,p_lov_return_value=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17059327206108625.4001)
,p_lov_disp_sequence=>430
,p_lov_disp_value=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Adelante)')
,p_lov_return_value=>'MAX_ROWS_LT_ROWS_FETCHED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17059504523108625.4001)
,p_lov_disp_sequence=>440
,p_lov_disp_value=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Atr\00E1s)')
,p_lov_return_value=>'MIN_ROW_GT_THAN_ONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17059703304108625.4001)
,p_lov_disp_sequence=>450
,p_lov_disp_value=>'Explorador del Cliente: Mozilla, Netscape 6.x/7x o superior'
,p_lov_return_value=>'BROWSER_IS_NSCP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17059928814108625.4001)
,p_lov_disp_sequence=>460
,p_lov_disp_value=>'Explorador del Cliente: Microsoft Internet Explorer 5.5, 6.0 o superior'
,p_lov_return_value=>'BROWSER_IS_MSIE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17060118387108625.4001)
,p_lov_disp_sequence=>470
,p_lov_disp_value=>'Explorador del Cliente: Explorador Compatible con XHTML / CSS'
,p_lov_return_value=>'BROWSER_IS_MSIE_OR_NSCP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17060301979108625.4001)
,p_lov_disp_sequence=>480
,p_lov_disp_value=>unistr('Explorador del Cliente: Otros exploradores (o versi\00F3n anterior)')
,p_lov_return_value=>'BROWSER_IS_OTHER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17060502945108625.4001)
,p_lov_disp_sequence=>490
,p_lov_disp_value=>unistr('Idioma Actual Incluido en Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_IN_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17060706361108625.4001)
,p_lov_disp_sequence=>500
,p_lov_disp_value=>unistr('Idioma Actual no Incluido en Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_NOT_IN_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17060905285108625.4001)
,p_lov_disp_sequence=>510
,p_lov_disp_value=>unistr('Idioma Actual != Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_NOT_EQ_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17061114830108626.4001)
,p_lov_disp_sequence=>520
,p_lov_disp_value=>unistr('Idioma Actual = Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_EQ_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17061318820108626.4001)
,p_lov_disp_sequence=>530
,p_lov_disp_value=>unistr('Cuando CGI_ENV DAD_NAME = Expresi\00F3n 1')
,p_lov_return_value=>'DAD_NAME_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17061519255108626.4001)
,p_lov_disp_sequence=>540
,p_lov_disp_value=>unistr('Cuando CGI_ENV DAD_NAME != Expresi\00F3n 1')
,p_lov_return_value=>'DAD_NAME_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17061714239108626.4001)
,p_lov_disp_sequence=>550
,p_lov_disp_value=>unistr('Cuando CGI_ENV SERVER_NAME = Expresi\00F3n 1')
,p_lov_return_value=>'SERVER_NAME_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17061919406108627.4001)
,p_lov_disp_sequence=>560
,p_lov_disp_value=>unistr('Cuando CGI_ENV SERVER_NAME != Expresi\00F3n 1')
,p_lov_return_value=>'SERVER_NAME_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17062113867108627.4001)
,p_lov_disp_sequence=>570
,p_lov_disp_value=>unistr('Cuando CGI_ENV HTTP_HOST = Expresi\00F3n 1')
,p_lov_return_value=>'HTTP_HOST_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17062302529108627.4001)
,p_lov_disp_sequence=>580
,p_lov_disp_value=>unistr('Cuando CGI_ENV HTTP_HOST != Expresi\00F3n 1')
,p_lov_return_value=>'HTTP_HOST_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17062522015108627.4001)
,p_lov_disp_sequence=>590
,p_lov_disp_value=>'Cuando se ha Ejecutado un Proceso de la Lista de Identificadores de Proceso Delimitada por Comas'
,p_lov_return_value=>'WHEN_PROCESS_IN_COMMA_DELIMITED_LIST_OF_PROCESS_IDS_HAS_RUN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17062711434108627.4001)
,p_lov_disp_sequence=>600
,p_lov_disp_value=>unistr('Cuando ha Cambiado alg\00FAn Elemento de la Lista de Elementos Delimitada por Comas')
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_COMMA_DELIMITED_LIST_OF_ITEMS_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17062902568108627.4001)
,p_lov_disp_sequence=>610
,p_lov_disp_value=>unistr('Cuando ha Cambiado alg\00FAn Elemento de la Lista de P\00E1ginas Delimitada por Comas')
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_COMMA_DELIMITED_LIST_OF_PAGES_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17063119820108627.4001)
,p_lov_disp_sequence=>620
,p_lov_disp_value=>unistr('Cuando ha Cambiado alg\00FAn Elemento de la P\00E1gina Actual')
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_CURRENT_PAGE_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17063325444108627.4001)
,p_lov_disp_sequence=>630
,p_lov_disp_value=>unistr('Cuando ha Cambiado alg\00FAn Elemento de la Aplicaci\00F3n Actual')
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_CURRENT_FLOW_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17063504629108630.4001)
,p_lov_disp_sequence=>640
,p_lov_disp_value=>unistr('Cuando ha Cambiado alg\00FAn Elemento de la Sesi\00F3n Actual')
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_CURRENT_SESSION_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17063727309108630.4001)
,p_lov_disp_sequence=>999
,p_lov_disp_value=>'Nunca'
,p_lov_return_value=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17063920324108630.4001)
,p_lov_disp_sequence=>1000
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/real_application_security_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(125789401878207743.4001)
,p_lov_name=>'REAL APPLICATION SECURITY MODE'
,p_lov_query=>'.'||wwv_flow_api.id(125789401878207743.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125789707509207748.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125790005075207754.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Usuarios Externos'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(125790331290207754.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Usuarios Internos'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time_static
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(94747000503182513.4001)
,p_lov_name=>'RECENT TIME STATIC'
,p_lov_query=>'.'||wwv_flow_api.id(94747000503182513.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94747313637182517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'10 segundos'
,p_lov_return_value=>'.000115740740740740740740740740740740741'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94747518394182517.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'1 minuto'
,p_lov_return_value=>'.000694444444444444444444444444444444444'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94747729794182517.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'5 minutos'
,p_lov_return_value=>'.003472222222222222222222222222222222222'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94747926598182517.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'10 minutos'
,p_lov_return_value=>'.0069444444444444444444444444'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94748115620182518.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'15 minutos'
,p_lov_return_value=>'.010416666666666666666666666666666666667'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94748310633182518.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'30 minutos'
,p_lov_return_value=>'.020833333333333333333333333333333333333'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94748508572182518.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'1 hora'
,p_lov_return_value=>'.041666666666666666666666666666666666667'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94748724431182518.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'2 horas'
,p_lov_return_value=>'.083333333333333333333333333333333333333'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94748910187182518.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'3 horas'
,p_lov_return_value=>'.125'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94749125599182518.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'4 horas'
,p_lov_return_value=>'.166666666666666666666666666666666666667'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94749323491182518.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'5 horas'
,p_lov_return_value=>'.208333333333333333333333333333333333333'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94749508725182518.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'6 horas'
,p_lov_return_value=>'.25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94749718151182518.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'8 horas'
,p_lov_return_value=>'.333333333333333333333333333333333333333'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94749910023182518.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'10 horas'
,p_lov_return_value=>'.416666666666666666666666666666666666667'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94750119132182518.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'12 horas'
,p_lov_return_value=>'.5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(104466705973961841.4001)
,p_lov_disp_sequence=>15.5
,p_lov_disp_value=>unistr('1 d\00EDa')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94750607429184466.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('2 d\00EDas')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94750911239185592.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('3 d\00EDas')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94751214355186496.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('4 d\00EDas')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94751517818187469.4001)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>unistr('5 d\00EDas')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94751822667188850.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('6 d\00EDas')
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94752125783189729.4001)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'1 semana'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94752428900190721.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'2 semanas'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94752702366192454.4001)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'4 semanas'
,p_lov_return_value=>'28'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(94753006521193682.4001)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>unistr('1 a\00F1o')
,p_lov_return_value=>'365'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_func_parms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1633884855696516.4001)
,p_lov_name=>'REDACT_FUNC_PARMS'
,p_lov_query=>'.'||wwv_flow_api.id(1633884855696516.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1634225720696517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Redactar Cinco Primeros SSN de EE. UU.'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1634682713696517.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Redactar Cuatro \00DAltimos SSN de EE. UU.')
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,6,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1635042489696517.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redactar SSN de EE. UU. Completo'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1635427075696517.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Redactar Cinco Primeros SSN de EE. UU. Num\00E9ricos')
,p_lov_return_value=>'9,1,5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1635810749696517.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Redactar Cuatro \00DAltimos SSN de EE. UU. Num\00E9ricos')
,p_lov_return_value=>'9,6,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1636220044696517.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Redactar SSN de EE. UU. Num\00E9rico Completo')
,p_lov_return_value=>'9,1,9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1636653305696517.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Redactar C\00F3digo Postal de EE. UU. Num\00E9rico')
,p_lov_return_value=>'9,1,5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1637023272696517.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Redactar Doce Primeros N\00FAmeros de la Tarjeta de Cr\00E9dito')
,p_lov_return_value=>'VVVVFVVVVFVVVVFVVVV,VVVV-VVVV-VVVV-VVVV,*,1,12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1637410132696517.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Redactar Fecha Millenium'
,p_lov_return_value=>'m1d1y2000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1637887521696518.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Redactar Fecha Epoch'
,p_lov_return_value=>'m1d1y1970'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_pattern
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1638174978696518.4001)
,p_lov_name=>'REDACT_REGEXP_PATTERN'
,p_lov_query=>'.'||wwv_flow_api.id(1638174978696518.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1638514624696518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('N\00FAmero de Seguridad Social de EE. UU.')
,p_lov_return_value=>'(\d\d\d)-(\d\d)-(\d\d\d\d)'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1638993085696518.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Parte Central de la Tarjeta de Cr\00E9dito con 6 D\00EDgitos Iniciales y 4 D\00EDgitos Finales')
,p_lov_return_value=>'(\d\d\d\d\d\d)(\d\d\d*)(\d\d\d\d)'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1639339518696518.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Cualquier d\00EDgito')
,p_lov_return_value=>'\d'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1639794019696518.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('N\00FAmero de Tel\00E9fono de EE. UU.')
,p_lov_return_value=>'(\(\d\d\d\)|\d\d\d)-(\d\d\d)-(\d\d\d\d)'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1640131927696518.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Direcci\00F3n de Correo Electr\00F3nico')
,p_lov_return_value=>'([A-Za-z0-9._%+-]+)@([A-Za-z0-9.-]+\.[A-Za-z]{2,4})'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1640514119696518.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Direcci\00F3n IP')
,p_lov_return_value=>'(\d{1,3}\.\d{1,3}\.\d{1,3})\.\d{1,3}'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_repl_str
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1640893349696518.4001)
,p_lov_name=>'REDACT_REGEXP_REPL_STR'
,p_lov_query=>'.'||wwv_flow_api.id(1640893349696518.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1641298348696519.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Redactar D\00EDgitos de la Parte Central de la Tarjeta de Cr\00E9dito')
,p_lov_return_value=>'\1XXXXXX\3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1641658067696519.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Redactar con una Sola X'
,p_lov_return_value=>'X'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1642047513696519.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redactar con un Solo 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1642452306696519.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Redactar Tel\00E9fono de EE. UU.')
,p_lov_return_value=>'\1-XXX-XXXX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1642847604696519.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Redactar Nombre de Correo Electr\00F3nico')
,p_lov_return_value=>'xxxx@\2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1643249986696519.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Redactar Dominio de Correo Electr\00F3nico')
,p_lov_return_value=>'\1 (at) xxxxx.com'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1643607252696519.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Redactar Correo Electr\00F3nico Completo')
,p_lov_return_value=>'xxxx (at) xxxxx.com'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1644004648696519.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Redactar Direcci\00F3n IP')
,p_lov_return_value=>'\1.999'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redirect_branch
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84944714521889885.4001)
,p_lov_name=>'REDIRECT.BRANCH'
,p_lov_query=>'.'||wwv_flow_api.id(84944714521889885.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84944918356889886.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('bifurcar a p\00E1gina utilizando el redireccionamiento )')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/referrer_policy
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(576106643072201397.4001)
,p_lov_name=>'REFERRER_POLICY'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value disp,',
'       x.column_value ret',
'  from table(wwv_flow_t_varchar2 (',
'                 ''no-referrer'',',
'                 ''no-referrer-when-downgrade'',',
'                 ''origin'',',
'                 ''origin-when-cross-origin'',',
'                 ''same-origin'',',
'                 ''strict-origin'',',
'                 ''strict-origin-when-cross-origin'',',
'                 ''unsafe-url'' )) x',
''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'RET'
,p_display_column_name=>'DISP'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/refresh_label_template
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84317322746593889.4001)
,p_lov_name=>'REFRESH_LABEL_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_api.id(84317322746593889.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88305802126823296.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Refrescar'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/refresh_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86078519684815185.4001)
,p_lov_name=>'REFRESH_Y'
,p_lov_query=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88306405589824278.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Refrescar'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/regexp_match_param
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1644350231696519.4001)
,p_lov_name=>'REGEXP_MATCH_PARAM'
,p_lov_query=>'.'||wwv_flow_api.id(1644350231696519.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1644787956696520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
,p_lov_return_value=>'c'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1645191392696520.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('No Sensible a May\00FAsculas/Min\00FAsculas')
,p_lov_return_value=>'i'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1645521141696520.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Varias l\00EDneas')
,p_lov_return_value=>'m'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1645928592696520.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Comod\00EDn de nueva l\00EDnea')
,p_lov_return_value=>'n'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1646395316696520.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ignorar Espacio en Blanco'
,p_lov_return_value=>'x'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_name_lookup
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7873722064289469.4001)
,p_lov_name=>'REGION NAME LOOKUP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name, id',
'  from wwv_flow_page_plugs'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42003622222572861.4001)
,p_lov_name=>'REGION THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(42003622222572861.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42003905055572869.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ocultar y Mostrar Regi\00F3n')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42004121899572869.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Barra Lateral')
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42004332039572870.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Barra Lateral, Alternativa 1')
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42004527982572870.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Bot\00F3n con T\00EDtulo')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42004707368572870.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Navegaci\00F3n')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42004922993572870.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Ruta de Navegaci\00F3n')
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42005318792572871.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Pantalla')
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42005510332572871.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Informes')
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42005908156572871.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n sin T\00EDtulo')
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42006130670572872.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n del Asistente')
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42006320789572872.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ancho 100% de Regi\00F3n de Informes')
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42009203091586314.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Navegaci\00F3n, Alternativa 1')
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42011722484591850.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Bot\00F3n sin T\00EDtulo')
,p_lov_return_value=>'17'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42016007687644405.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n entre Par\00E9ntesis')
,p_lov_return_value=>'18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42017128465650351.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n sin Botones ni T\00EDtulo')
,p_lov_return_value=>'19'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44193631287041740.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n del Asistente con Icono')
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(52367908380077344.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n sin Borde')
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(52369713490097781.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Informes, Alternativa 1')
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(75207904105349056.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Lista con Icono')
,p_lov_return_value=>'29'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76147331941126624.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Filtro de Informe (Una Fila)'
,p_lov_return_value=>'31'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76177513165215809.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Filtro de Informe (Varias Filas)'
,p_lov_return_value=>'32'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225619930801333589.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Regi\00F3n de Gr\00E1fico')
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44237530397202360.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'21'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44237832475202975.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'22'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44238101439203525.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'23'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44238403516204084.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'24'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44238705594204669.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44239007326205203.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'26'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44239309404205768.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'27'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44239611135206317.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'28'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_title_translation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17378610268487082.4001)
,p_lov_name=>'REGION TITLE TRANSLATION'
,p_lov_query=>'.'||wwv_flow_api.id(17378610268487082.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17378825153487082.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('excluir t\00EDtulo de traducci\00F3n')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_item_display_point
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(39812312012046225.4001)
,p_lov_name=>'REGION.ITEM_DISPLAY_POINT'
,p_lov_query=>'.'||wwv_flow_api.id(39812312012046225.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39812524545046226.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sobre el Contenido'
,p_lov_return_value=>'ABOVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(39812805656046228.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Bajo el Contenido'
,p_lov_return_value=>'BELOW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(663424044.4001)
,p_lov_name=>'REGION.TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_types_for_display_only_includes_legacy_values
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(538211928069052506.4001)
,p_lov_name=>'REGION.TYPES (FOR DISPLAY ONLY - INCLUDES LEGACY VALUES)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(wwv_flow_lang.system_message(''REGION_NAME.''||name_with_prefix), display_name) D,',
'       name_with_prefix R',
'  from wwv_flow_native_plugins',
' where plugin_type = ''REGION TYPE''',
' union all',
'select display_name||wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') D,',
'       ''PLUGIN_''||name R',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''REGION TYPE''',
' union all',
'select wwv_flow_lang.system_message(''DYNAMIC_QUERY'') D, ''DYNAMIC_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'') D, ''SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR'') D, ''REGION_DISPLAY_SELECTOR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||initcap(wwv_flow_lang.system_message(''STRUCTURED_QUERY''))||'')'' D, ''STRUCTURED_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||wwv_flow_lang.system_message(''FUNCTION_BODY_RETURNING_QUERY'')||'')'' D,''FUNCTION_RETURNING_SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'') D, ''STATIC_TEXT'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''PLSQL_PROCEDURE'')||'' (''||wwv_flow_lang.system_message(''ANONYMOUS_BLOCK'')||'')'' D, ''PLSQL_PROCEDURE'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''WEB_SERVICE_RESULT'')) D,''WEB_SERVICE'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''WEB_SERVICE_RESULT'')) D,''SQL_QUERY_WS'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''HELP_TEXT'')) D, ''HELP_TEXT'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'')||'' (''||wwv_flow_lang.system_message(''ESCAPE_SC'')||'')'' D, ''STATIC_TEXT_ESCAPE_SC'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'')||'' (''||wwv_flow_lang.system_message(''WITH_SHORTCUTS'')||'')'' D, ''STATIC_TEXT_WITH_SHORTCUTS'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||wwv_flow_lang.system_message(''UPDATEABLE_REPORT'')||'')'' D, ''UPDATABLE_SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''URL'') D, ''URL'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''F4000_TREE'')) D, ''JSTREE'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''LEGACY_CALENDAR'') D, ''CALENDAR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''CALENDAR_EASY_TYPE'') D, ''EASY_CALENDAR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''REGION_NAME.NATIVE_LIST'') D, ''LIST'' R from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_types_requires_application_context
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(32361488916.4001)
,p_lov_name=>'REGION.TYPES (REQUIRES APPLICATION CONTEXT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select D,R from(',
'select display_name D, name_with_prefix R, 3 OB from wwv_flow_native_plugins where plugin_type = ''REGION TYPE''',
' union all',
'select display_name||wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') D, ''PLUGIN_''||name R, 3 OB from wwv_flow_plugins where flow_id = to_number(:FB_FLOW_ID) and security_group_id = to_number(:WORKSPACE_ID) and plugin_type = ''REGION TYPE''',
' union all',
'select ''___________________________________________________'' D,''FLOWS_DIVIDER'' R,4 OB from dual',
'order by 1)',
'order by OB'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_comment
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86070721237777807.4001)
,p_lov_name=>'REGION_COMMENT'
,p_lov_query=>'.'||wwv_flow_api.id(86070721237777807.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88309409052825302.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Volver a la P\00E1gina')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_display_point_all
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(31553701621903696.4001)
,p_lov_name=>'REGION_DISPLAY_POINT_ALL'
,p_lov_query=>'.'||wwv_flow_api.id(31553701621903696.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1475524458526082046.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Cuerpo de Plantilla de P\00E1gina')
,p_lov_return_value=>'BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31554207818903702.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cuerpo de Plantilla de P\00E1gina (1)')
,p_lov_return_value=>'BODY_1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31554402066903703.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cuerpo de Plantilla de P\00E1gina (2)')
,p_lov_return_value=>'BODY_2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31554629662903703.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Cuerpo de Plantilla de P\00E1gina (3)')
,p_lov_return_value=>'BODY_3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31555003059903703.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Posici\00F3n 1 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_01'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31555213544903704.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Posici\00F3n 2 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_02'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31555419855903704.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Posici\00F3n 3 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_03'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31555606434903704.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Posici\00F3n 4 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_04'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31555807935903704.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('Posici\00F3n 5 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_05'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31556000647903704.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('Posici\00F3n 6 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_06'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31556202527903705.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('Posici\00F3n 7 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_07'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31556400273903705.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>unistr('Posici\00F3n 8 de la Regi\00F3n de Plantilla de P\00E1gina')
,p_lov_return_value=>'REGION_POSITION_08'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31554031866903701.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('Despu\00E9s de Cabecera')
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31554812516903703.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('Antes de Pie de P\00E1gina')
,p_lov_return_value=>'BEFORE_FOOTER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_template_wiz
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86595203201245715.4001)
,p_lov_name=>'REGION_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_api.id(86595203201245715.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88310014246826768.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seleccione uno del repositorio de &PRODUCT_NAME.'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88310206716826770.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88310407341826770.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rejoin_existing_sessions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(492680965578161495.4001)
,p_lov_name=>'REJOIN_EXISTING_SESSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(492680965578161495.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492681259501161497.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492681550873161501.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Activado para Sesiones P\00FAblicas')
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492681867549161501.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Activado para Todas las Sesiones'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_print_server
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6609670475356322.4001)
,p_lov_name=>'REMOTE_PRINT_SERVER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''PRINT_SERVER''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_server_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(154020705287547277.4001)
,p_lov_name=>'REMOTE_SERVER_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(154020705287547277.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(525215053516054024.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Autenticaci\00F3n')
,p_lov_return_value=>'AUTHENTICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5900616837046045.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Servidor de Impresi\00F3n')
,p_lov_return_value=>'PRINT_SERVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(154021086016547295.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Origen de Datos de REST'
,p_lov_return_value=>'WEB_SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(154021427047547298.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SQL activado para REST'
,p_lov_return_value=>'REMOTE_SQL'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1932'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_sql_servers
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3916281406910608.4001)
,p_lov_name=>'REMOTE_SQL_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remove_application_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(69499523734506806.4001)
,p_lov_name=>'REMOVE APPLICATION OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(69499523734506806.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(69499727417506807.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Eliminar Definici\00F3n de Aplicaci\00F3n')
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(69499914386506809.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Desinstalar Objetos de Soporte'
,p_lov_return_value=>'DBOBJECTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remove_supporting_objects_confirm
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48392517652618439.4001)
,p_lov_name=>'REMOVE SUPPORTING OBJECTS CONFIRM'
,p_lov_query=>'.'||wwv_flow_api.id(48392517652618439.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48393218492618442.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Desinstalar Objetos de Soporte'
,p_lov_return_value=>'DBOBJECTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/replace_subsribe
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153629328412742095.4001)
,p_lov_name=>'REPLACE_SUBSRIBE'
,p_lov_query=>'.'||wwv_flow_api.id(153629328412742095.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153629608857742097.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sustituir'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153629812815742097.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sustituir/Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/repoer_query_xml_structure
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(75124227694454957.4001)
,p_lov_name=>'REPOER_QUERY_XML_STRUCTURE'
,p_lov_query=>'.'||wwv_flow_api.id(75124227694454957.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(75124714171454958.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Incluir Informaci\00F3n de Aplicaci\00F3n y Sesi\00F3n')
,p_lov_return_value=>'APEX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layout_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(98487819468346730.4001)
,p_lov_name=>'REPORT LAYOUT TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(98487819468346730.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(98488104584346730.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Usar Dise\00F1o de Informe Gen\00E9rico')
,p_lov_return_value=>'G'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(98488321656346730.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Cargar Archivo de Dise\00F1o de Informe Basado en XSL-FO')
,p_lov_return_value=>'F'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_options_on_create_application
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(91329908068021523.4001)
,p_lov_name=>'REPORT OPTIONS ON CREATE APPLICATION'
,p_lov_query=>'.'||wwv_flow_api.id(91329908068021523.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91330107385021523.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Filtro de Informe'
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91347711073164360.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Orden de Columna'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91348319384166779.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Enlace de Descarga'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_theme_class_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(44022800298370465.4001)
,p_lov_name=>'REPORT THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_api.id(44022800298370465.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44023108057370466.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est\00E1ndar')
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44023306894370466.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est\00E1ndar, Colores de Fila Alternativos')
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44023505444370467.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista Desordenada de Una Columna'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44023703003370467.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Borde Horizontal'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44040305502447718.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pares de Valor/Atributo'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44040817276451119.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sin Borde'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44024106645370467.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 1'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44024306507370468.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 2'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44024511658370468.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 3'
,p_lov_return_value=>'9'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44024705287370468.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 4'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44024932615370468.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 5'
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44025103039370479.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 6'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44025325537370479.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 7'
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(44025506216370479.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personalizado 8'
,p_lov_return_value=>'14'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layout_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(19274704924460373.4001)
,p_lov_name=>'REPORT.LAYOUT.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(19274704924460373.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19275219111460374.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Columnas Gen\00E9ricas (XSL-FO)')
,p_lov_return_value=>'XSL_GENERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19275015143460374.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Columnas con Nombre (RTF)'
,p_lov_return_value=>'RTF_FILE'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_server        wwv_flow_print_util.t_print_server;',
'begin',
'    l_server   := wwv_flow_print_util.get_print_server (',
'        p_flow_id => :FB_FLOW_ID);',
'    return l_server.server_type = ''ADVANCED'';',
'end;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(65039129482276544.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Columnas con Nombre (XSL-FO)'
,p_lov_return_value=>'XSL_FILE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_region_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20772130624604116.4001)
,p_lov_name=>'REPORT.REGION.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(20772130624604116.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20772311900604119.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Informe SQL'
,p_lov_return_value=>'NATIVE_SQL_REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20772502048604122.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Pantalla Tabular'
,p_lov_return_value=>'NATIVE_TABFORM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_templates
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(31573884244.4001)
,p_lov_name=>'REPORT.TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layouts
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(24313105570265439.4001)
,p_lov_name=>'REPORT_LAYOUTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  wwv_flow_escape.html(report_layout_name) d, ',
'  id r',
'from   wwv_flow_report_layouts',
'where  flow_id = :fb_flow_id ',
'order by upper(report_layout_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_queries
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(116512322599902216.4001)
,p_lov_name=>'REPORT_QUERIES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  name,',
'  id    ',
'from ',
'  wwv_flow_shared_queries',
'where ',
'  flow_id = :fb_flow_id and ',
'  security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_templates_002
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84308802529578634.4001)
,p_lov_name=>'REPORT_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME3'') d, 3 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME4'') d, 4 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME5'') d, 5 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME11'') d, 11 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME12'') d, 12 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME13'') d, 13 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME14'') d, 14 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||wwv_flow_escape.html(row_template_name) d, id r ',
'  from wwv_flow_row_templates where flow_id = :FB_FLOW_ID',
' and (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(349021129284645044.4001)
,p_lov_name=>'REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(349021129284645044.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(349021416349645045.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Interactiva'
,p_lov_return_value=>'INTERACTIVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(349021707529645045.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Cl\00E1sica')
,p_lov_return_value=>'CLASSIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84834330555326798.4001)
,p_lov_name=>'REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84834330555326798.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84834520323326798.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Consulta SQL'
,p_lov_return_value=>'NATIVE_SQL_REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_wiz_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86600327227262164.4001)
,p_lov_name=>'REPORT_WIZ_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(86600327227262164.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88311017363827760.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seleccione uno del repositorio de &PRODUCT_NAME.'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88311204775827761.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88311406704827761.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Como Copia de una Plantilla Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/required_system_privielges
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(38912529512012913.4001)
,p_lov_name=>'REQUIRED SYSTEM PRIVIELGES'
,p_lov_query=>'.'||wwv_flow_api.id(38912529512012913.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38912711366012914.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TABLE'
,p_lov_return_value=>'CREATE TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38912923572012916.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE VIEW'
,p_lov_return_value=>'CREATE VIEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38913303206012917.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PROCEDURE'
,p_lov_return_value=>'CREATE PROCEDURE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38913506769012917.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TRIGGER'
,p_lov_return_value=>'CREATE TRIGGER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38919419731029097.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE OPERATOR'
,p_lov_return_value=>'CREATE OPERATOR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38919924233030353.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE INDEXTYPE'
,p_lov_return_value=>'CREATE INDEXTYPE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38920506010034595.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TYPE '
,p_lov_return_value=>'CREATE TYPE '
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38921321940039162.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SYNONYM'
,p_lov_return_value=>'CREATE SYNONYM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38921928173040971.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE DATABASE LINK'
,p_lov_return_value=>'CREATE DATABASE LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(104583500287639787.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SEQUENCE'
,p_lov_return_value=>'CREATE SEQUENCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(104583805482641282.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE MATERIALIZED VIEW'
,p_lov_return_value=>'CREATE MATERIALIZED VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/required_role
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(283664112341.4001)
,p_lov_name=>'REQUIRED_ROLE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_grid
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1859045918048678074.4001)
,p_lov_name=>'RESET GRID'
,p_lov_query=>'.'||wwv_flow_api.id(1859045918048678074.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1859046605976678092.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Restablecer Posiciones de Regi\00F3n Fijas')
,p_lov_return_value=>'REGIONONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1859047081603678092.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Restablecer Toda la Configuraci\00F3n de Regi\00F3n y Cuadr\00EDcula de Elemento')
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_pagination_scope
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(10281732604346186.4001)
,p_lov_name=>'RESET PAGINATION SCOPE'
,p_lov_query=>'.'||wwv_flow_api.id(10281732604346186.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10281906395346188.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina Actual')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10282110564346190.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Varias P\00E1ginas')
,p_lov_return_value=>'PAGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(10282302589346191.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Todas las P\00E1ginas')
,p_lov_return_value=>'APP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_pagination
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84827913193293462.4001)
,p_lov_name=>'RESET_PAGINATION'
,p_lov_query=>'.'||wwv_flow_api.id(84827913193293462.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84828126818293462.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_pagination_paren
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84877500529450588.4001)
,p_lov_name=>'RESET_PAGINATION_PAREN'
,p_lov_query=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84877715480450589.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('restablecer paginaci\00F3n para esta p\00E1gina')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/restricted_characters
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2137019810509690868.4001)
,p_lov_name=>'RESTRICTED_CHARACTERS'
,p_lov_query=>'.'||wwv_flow_api.id(2137019810509690868.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2137020431618690875.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Lista de permitidos para a-Z, 0-9 y espacio'
,p_lov_return_value=>'US_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2137020026035690873.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Caracteres de comando HTML de la lista de bloqueados (<>")'
,p_lov_return_value=>'WEB_SAFE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2137020602276690875.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Lista de bloqueados &<>\"/;,*|=% y --'
,p_lov_return_value=>'NO_SPECIAL_CHAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2137020219582690875.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Lista de bloqueados &<>\005C"/;,*|=% o -- y nueva l\00EDnea')
,p_lov_return_value=>'NO_SPECIAL_CHAR_NL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(426503525299715372.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Esquema de Espacio de Trabajo'
,p_lov_return_value=>'WORKSPACE_SCHEMA'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_security.g_security_group_id=10'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_http_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(33996111639139709.4001)
,p_lov_name=>'REST_HTTP_METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(33996111639139709.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33996316405139719.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'GET'
,p_lov_return_value=>'GET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33996526720139722.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'HEAD'
,p_lov_return_value=>'HEAD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33996731839139722.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'POST'
,p_lov_return_value=>'POST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33996909427139722.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'PUT'
,p_lov_return_value=>'PUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33997106044139722.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'DELETE'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_input_parameter_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(33552428712278769.4001)
,p_lov_name=>'REST_INPUT_PARAMETER_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(33552428712278769.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33552726333278771.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cadena'
,p_lov_return_value=>'string'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33552914074278772.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Binario'
,p_lov_return_value=>'binary'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_output_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(33563708997950496.4001)
,p_lov_name=>'REST_OUTPUT_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(33563708997950496.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33564030843950503.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'xml'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33564222947950504.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Texto'
,p_lov_return_value=>'text'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(295282210117418318.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'JSON'
,p_lov_return_value=>'json'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_web_services
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(170459828884768626.4001)
,p_lov_name=>'REST_WEB_SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''REST''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/return_error_message_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84906211376661916.4001)
,p_lov_name=>'RETURN.ERROR.MESSAGE.Y'
,p_lov_query=>'.'||wwv_flow_api.id(84906211376661916.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84906418542661917.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00BFDevolver Mensaje de Error?')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/return_to_page_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84870610048415471.4001)
,p_lov_name=>'RETURN_TO_PAGE_Y'
,p_lov_query=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84870825641415472.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Volver a la P\00E1gina')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/right_to_left
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(124580607576171078.4001)
,p_lov_name=>'RIGHT-TO-LEFT'
,p_lov_query=>'.'||wwv_flow_api.id(124580607576171078.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(124580923879171083.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'De Izquierda a Derecha'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(124581359286171085.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'De Derecha a Izquierda'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(153414216516104717.4001)
,p_lov_name=>'ROW_COLUMN'
,p_lov_query=>'.'||wwv_flow_api.id(153414216516104717.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153414507220104721.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Columna'
,p_lov_return_value=>'GENERIC_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(153414716223104730.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Fila'
,p_lov_return_value=>'NAMED_COLUMNS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_template_cond
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84772600380939607.4001)
,p_lov_name=>'ROW_TEMPLATE_COND'
,p_lov_query=>'.'||wwv_flow_api.id(84772600380939607.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84772803392939608.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('N\00FAmeros de Filas Pares')
,p_lov_return_value=>'EVEN_ROW_NUMBERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84773017173939608.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No Condicional'
,p_lov_return_value=>'NOT_CONDITIONAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84773214166939609.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('N\00FAmeros de Filas Impares')
,p_lov_return_value=>'ODD_ROW_NUMBERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_template_cond2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84871821607428292.4001)
,p_lov_name=>'ROW_TEMPLATE_COND2'
,p_lov_query=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84872030804428293.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Usar Basado en Expresi\00F3n PL/SQL')
,p_lov_return_value=>'NOT_CONDITIONAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84872231653428294.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Usar para Filas Numeradas Pares'
,p_lov_return_value=>'EVEN_ROW_NUMBERS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84872405949428294.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Usar para Filas Numeradas Impares'
,p_lov_return_value=>'ODD_ROW_NUMBERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_template_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84775019904954668.4001)
,p_lov_name=>'ROW_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84775019904954668.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84775203595954669.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Columnas Gen\00E9ricas (plantilla de columna)')
,p_lov_return_value=>'GENERIC_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84775417405954670.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Columna con Nombre (plantilla de fila)'
,p_lov_return_value=>'NAMED_COLUMNS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rpt_edit_link
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(158022218250867826.4001)
,p_lov_name=>'RPT_EDIT_LINK'
,p_lov_query=>'.'||wwv_flow_api.id(158022218250867826.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(65569417483157832.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'<IMG SRC="#IMAGE_PREFIX#e2.gif" alt="&EDIT.">'
,p_lov_return_value=>'e2.gif'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(158022531259867827.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'<IMG SRC="#IMAGE_PREFIX#edit_big.gif" alt="&EDIT.">'
,p_lov_return_value=>'edit_big.gif'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(158022707875867828.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'<IMG SRC="#IMAGE_PREFIX#ed-item.gif" alt="&EDIT.">'
,p_lov_return_value=>'ed-item.gif'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(172484126127501725.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" height="16" width="16" alt="&EDIT.">'
,p_lov_return_value=>'menu/pencil16x16.gif'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(158023321688867829.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Editar'
,p_lov_return_value=>'Edit'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(158023522361867829.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Otra Imagen'
,p_lov_return_value=>'Other'
);
end;
/
prompt --application/shared_components/user_interface/lovs/run_stateful_process_when
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84835322721333991.4001)
,p_lov_name=>'RUN_STATEFUL_PROCESS_WHEN'
,p_lov_query=>'.'||wwv_flow_api.id(84835322721333991.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84835504796333991.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Una Vez por Sesi\00F3n o al Restablecer')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84835721953333992.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Una Vez por Visita de P\00E1gina (valor por defecto)')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sample_data_spreadsheets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(716356186809790186.4001)
,p_lov_name=>'SAMPLE.DATA.SPREADSHEETS'
,p_lov_query=>'.'||wwv_flow_api.id(716356186809790186.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(149723684457672201.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Acad\00E9mico')
,p_lov_return_value=>'ACADEMIC'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(716357248405790188.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Departamentos y empleados cl\00E1sicos')
,p_lov_return_value=>'DEPT_EMP'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(726144908377227108.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('F\00F3rmula 1')
,p_lov_return_value=>'F1'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(150181083020036213.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Datos de prueba estructurados y JSON'
,p_lov_return_value=>'JSON_TEST'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(176278124270074590.4001)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Datos de prueba solo JSON'
,p_lov_return_value=>'JSON'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(732887738842814881.4001)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>unistr('Pel\00EDculas')
,p_lov_return_value=>'MOVIE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(716356887500790188.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Proyecto y Tareas'
,p_lov_return_value=>'PROJECTS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(724044540844893278.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Ventas'
,p_lov_return_value=>'SALES'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(725116269981095762.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Tenis'
,p_lov_return_value=>'TENNIS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(724037064656719501.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Velocidad de veh\00EDculo')
,p_lov_return_value=>'SPEED'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(725325190828392565.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Copa mundial'
,p_lov_return_value=>'WORLDCUP'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(716356418611790188.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Poblaci\00F3n mundial')
,p_lov_return_value=>'WORLD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
end;
/
prompt --application/shared_components/user_interface/lovs/save_model
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(239865426281311683.4001)
,p_lov_name=>'SAVE MODEL'
,p_lov_query=>'.'||wwv_flow_api.id(239865426281311683.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239865606836311683.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Guardar esta Definici\00F3n como Modelo de Dise\00F1o para Reutilizaci\00F3n')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/save_state_before_branching
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(19772421278475486.4001)
,p_lov_name=>'SAVE_STATE_BEFORE_BRANCHING'
,p_lov_query=>'.'||wwv_flow_api.id(19772421278475486.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19772713449475497.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('guardar estado antes de bifurcaci\00F3n')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/schedule_builder_byday
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601095219556747684.4001)
,p_lov_name=>'SCHEDULE_BUILDER_BYDAY'
,p_lov_query=>'.'||wwv_flow_api.id(601095219556747684.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601095400505747685.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lun'
,p_lov_return_value=>'MON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601095817105747685.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mar'
,p_lov_return_value=>'TUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601096242136747685.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Mi\00E9')
,p_lov_return_value=>'WED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601096661742747686.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Jue'
,p_lov_return_value=>'THU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601097002601747686.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Vie'
,p_lov_return_value=>'FRI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601097459306747686.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('S\00E1b')
,p_lov_return_value=>'SAT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601097847875747687.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Dom'
,p_lov_return_value=>'SUN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/schedule_builder_frequency
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601098854036755106.4001)
,p_lov_name=>'SCHEDULE_BUILDER_FREQUENCY'
,p_lov_query=>'.'||wwv_flow_api.id(601098854036755106.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601099035732755106.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Semanal'
,p_lov_return_value=>'WEEKLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601099445265755107.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Diario'
,p_lov_return_value=>'DAILY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601099887531755107.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Por horas'
,p_lov_return_value=>'HOURLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601100292402755107.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Por minutos'
,p_lov_return_value=>'MINUTELY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4766813181334483.4001)
,p_lov_name=>'SEARCH_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(4766813181334483.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4767009070334486.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Coincidir May\00FAsculas/Min\00FAsculas')
,p_lov_return_value=>'CASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(218750809842831008.4001)
,p_lov_name=>'SECONDS'
,p_lov_query=>'.'||wwv_flow_api.id(218750809842831008.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218754417461833265.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'10 segundos'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218751030263831063.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 minuto'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218751217877831100.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'10 minutos'
,p_lov_return_value=>'600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218751411947831100.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'30 minutos'
,p_lov_return_value=>'1800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218751606758831101.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'1 hora'
,p_lov_return_value=>'3600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218751804764831101.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'2 horas'
,p_lov_return_value=>'7200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218752012635831101.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'3 horas'
,p_lov_return_value=>'10800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218752221460831101.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'4 horas'
,p_lov_return_value=>'14400'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218752413453831101.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'6 horas'
,p_lov_return_value=>'21600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218752623840831102.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'12 horas'
,p_lov_return_value=>'43200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218752826160831102.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('1 d\00EDa')
,p_lov_return_value=>'86400'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218753022810831102.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('2 d\00EDas')
,p_lov_return_value=>'172800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218753207360831102.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('3 d\00EDas')
,p_lov_return_value=>'259200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218753416227831102.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('4 d\00EDas')
,p_lov_return_value=>'345600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218753611463831103.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'1 semana'
,p_lov_return_value=>'604800'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(218753812160831103.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'2 semanas'
,p_lov_return_value=>'1209600'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(224123526155787261.4001)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>'4 semanas'
,p_lov_return_value=>'2419200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(224116700875779908.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'10 semanas'
,p_lov_return_value=>'6048000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(224124404815790588.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('1 a\00F1o')
,p_lov_return_value=>'31536000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds_small
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(433752258048536863.4001)
,p_lov_name=>'SECONDS_SMALL'
,p_lov_query=>'.'||wwv_flow_api.id(433752258048536863.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(433752591581536864.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 minuto'
,p_lov_return_value=>'60'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(433752927587536866.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 minutos'
,p_lov_return_value=>'120'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(433753313173536866.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 minutos'
,p_lov_return_value=>'180'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(433753718809536866.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 minutos'
,p_lov_return_value=>'240'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(433754195947536866.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 minutos'
,p_lov_return_value=>'300'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(433754557049536866.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'10 minutos'
,p_lov_return_value=>'600'
);
end;
/
prompt --application/shared_components/user_interface/lovs/select_cache_management_process_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8261624729096999.4001)
,p_lov_name=>'SELECT.CACHE.MANAGEMENT.PROCESS.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(8261624729096999.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8261900096097002.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Aplicaciones (elimina todos los estados de sesi\00F3n para las aplicaciones mostradas)')
,p_lov_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8262130496097003.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Aplicaci\00F3n Actual (elimina todos los estados de sesi\00F3n para la aplicaci\00F3n actual)')
,p_lov_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8262316343097003.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Sesi\00F3n Actual (elimina todos los estados para la sesi\00F3n actual)')
,p_lov_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8262529998097003.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Elementos (ITEM,ITEM,ITEM)')
,p_lov_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8262724410097004.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Borrar Cach\00E9 para Todos los Elementos de P\00E1ginas (Identificador de P\00E1gina, Identificador de P\00E1gina, Identificador de P\00E1gina)')
,p_lov_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8262912312097004.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Inicializar Todos los Elementos de P\00E1gina')
,p_lov_return_value=>'INITIALIZE_ALL_PAGE_ITEMS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8263116418097004.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Restablecer Preferencias (elimina todas las preferencias para el usuario actual)'
,p_lov_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8263331569097004.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Definir preferencia en valor de elemento (Nombre de Preferencia:ITEM)'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8263502372097005.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Definir preferencia en valor de elemento si el elemento no es nulo (Nombre de Preferencia:ITEM)'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/select_pagination_process_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(8208625525879595.4001)
,p_lov_name=>'SELECT.PAGINATION.PROCESS.TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(8208625525879595.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8208910190879598.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n')
,p_lov_return_value=>'RESET_PAGINATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8209131484879599.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n para Todas las P\00E1ginas')
,p_lov_return_value=>'INITIALIZE_PAGINATION_FOR_ALL_PAGES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8209325215879600.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Restablecer Paginaci\00F3n para P\00E1ginas (Identificador de P\00E1gina, Identificador de P\00E1gina, Identificador de P\00E1gina)')
,p_lov_return_value=>'INITIALIZE_PAGE_PAGINATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_cookie_sharing
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(46630896750249951.4001)
,p_lov_name=>'SESSION COOKIE SHARING'
,p_lov_query=>'.'||wwv_flow_api.id(46630896750249951.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46631189628249955.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Aplicaci\00F3n (no de uso compartido)')
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46631517972249955.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Uso compartido de espacio de trabajo'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46631998587249955.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_state_view_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(201460728952037663.4001)
,p_lov_name=>'SESSION STATE VIEW OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(201460728952037663.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201460911220037664.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Elementos de P\00E1gina')
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201461105565037666.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Elementos de Aplicaci\00F3n')
,p_lov_return_value=>'I'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201461325287037666.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Estado de la Sesi\00F3n')
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(201461505002037666.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Recopilaciones'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(116336811370337963.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Todo'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_joining
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(487255841087229838.4001)
,p_lov_name=>'SESSION_JOINING'
,p_lov_query=>'.'||wwv_flow_api.id(487255841087229838.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(487256183344229845.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Activado'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(487256453829229849.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Desactivado'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/shared_component_conditions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179567005218713166.4001)
,p_lov_name=>'SHARED COMPONENT CONDITIONS'
,p_lov_query=>'.'||wwv_flow_api.id(179567005218713166.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179575608989761516.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Separadores Est\00E1ndar')
,p_lov_return_value=>'TAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179575911760762378.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Separadores Principales'
,p_lov_return_value=>'PTAB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/shortcut_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84752421139794200.4001)
,p_lov_name=>'SHORTCUT_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84752421139794200.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84752622050794201.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n de devuelve VARCHAR2')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84752832725794201.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Texto HTML'
,p_lov_return_value=>'HTML_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84753011629794202.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Texto HTML con Caracteres Especiales de Escape'
,p_lov_return_value=>'HTML_TEXT_ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84753228273794202.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Imagen'
,p_lov_return_value=>'IMAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11964900251347159.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Texto con Comillas Simples de Escape JavaScript'
,p_lov_return_value=>'TEXT_ESCAPE_JS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11965906831349042.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Mensaje'
,p_lov_return_value=>'MESSAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11968015488351531.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Mensaje con Comillas Simples de Escape JavaScript'
,p_lov_return_value=>'MESSAGE_ESCAPE_JS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/shortcut_wiz_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84343606432636502.4001)
,p_lov_name=>'SHORTCUT_WIZ_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84343606432636502.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88312022558829215.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nuevo'
,p_lov_return_value=>'BLANK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88312201540829216.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Como Copia de Acceso Directo Existente'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(138231514317962802.4001)
,p_lov_name=>'SHOW ALL LOV'
,p_lov_query=>'.'||wwv_flow_api.id(138231514317962802.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138231707947962807.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Todo'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(138231929246962812.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('S\00F3lo Emergentes')
,p_lov_return_value=>'POPUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_temp_subscribed_all_or_not
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(76989619199545586.4001)
,p_lov_name=>'SHOW TEMP SUBSCRIBED ALL OR NOT'
,p_lov_query=>'.'||wwv_flow_api.id(76989619199545586.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76990030696545589.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Todas las Plantillas'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76989818710545588.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plantillas Suscritas'
,p_lov_return_value=>'REF'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(76990727856548087.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Plantillas no Suscritas'
,p_lov_return_value=>'NOT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_themes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(131260202585040081.4001)
,p_lov_name=>'SHOW THEMES'
,p_lov_query=>'.'||wwv_flow_api.id(131260202585040081.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131260406218040082.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Todos los Temas'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131260813106040083.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Temas Est\00E1ndar')
,p_lov_return_value=>'STANDARD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131260606234040083.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Temas Personalizados'
,p_lov_return_value=>'CUSTOM'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t',
' where t.theme_security_group_id is null',
'   and t.security_group_id = 11',
'   and t.flow_id in (select id from wwv_flows where application_type = ''STANDARD'' and security_group_id = 11)',
'   and t.theme_id > 99',
'   and t.navigation_type = :P3000_NAVIGATION_TYPE',
'union',
'select 1',
'  from wwv_flow_themes t',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11   ',
'   and t.navigation_type = :P3000_NAVIGATION_TYPE'))
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(46613624991069841.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Temas Heredados'
,p_lov_return_value=>'LEGACY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P3000_UI_TYPE_ID = 1 and :P3000_NAVIGATION_TYPE = ''T'''
,p_lov_disp_cond2=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_computations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86066623184768918.4001)
,p_lov_name=>'SHOW_ALL_COMPUTATIONS'
,p_lov_query=>'.'||wwv_flow_api.id(86066623184768918.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88312825674830068.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'999999999999'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88313032367830069.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'No'))
,p_lov_return_value=>'15'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_grid
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(3278509884198440.4001)
,p_lov_name=>'SHOW_GRID'
,p_lov_query=>'.'||wwv_flow_api.id(3278509884198440.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3278823071198441.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Mostrar L\00EDnea de Cuadr\00EDcula')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_legend
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84866116927389078.4001)
,p_lov_name=>'SHOW_LEGEND'
,p_lov_query=>'.'||wwv_flow_api.id(84866116927389078.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84866317039389078.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mostrar Leyenda'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_success_in_future
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84242708005400457.4001)
,p_lov_name=>'SHOW_SUCCESS_IN_FUTURE'
,p_lov_query=>'.'||wwv_flow_api.id(84242708005400457.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84242917723400457.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('No Mostrar P\00E1gina Correcta en el Futuro')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_template_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84336604916626643.4001)
,p_lov_name=>'SHOW_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84336604916626643.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84337430906626644.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'Menu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84336821420626643.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'Button'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47822118021181823.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Calendario Heredado'
,p_lov_return_value=>'Calendar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84337026704626644.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Campo'
,p_lov_return_value=>'Field'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84337230566626644.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'List'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84337622898626644.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'Page'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84337805044626645.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'Region'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84338018705626645.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'Report'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1467333588944879614.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Lista de Valores Emergente'
,p_lov_return_value=>'Popuplov'
);
end;
/
prompt --application/shared_components/user_interface/lovs/simplechart_paginationstyles
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93470022413475791.4001)
,p_lov_name=>'SIMPLECHART.PAGINATIONSTYLES'
,p_lov_query=>'.'||wwv_flow_api.id(93470022413475791.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93470332223475797.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n')
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93470502299475799.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Motor de B\00FAsqueda')
,p_lov_return_value=>'E'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93470704611475799.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Filas X -Y de Z (con botones siguiente y anterior)'
,p_lov_return_value=>'P'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(99827615159625086.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Ninguna Paginaci\00F3n')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/simplechart_summary
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(85992212281453507.4001)
,p_lov_name=>'SIMPLECHART.SUMMARY'
,p_lov_query=>'.'||wwv_flow_api.id(85992212281453507.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85992527482453514.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('N\00FAmero de Puntos de Datos')
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85992719931453514.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Eje'
,p_lov_return_value=>'A'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85992930659453515.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Valor M\00EDnimo ')
,p_lov_return_value=>'M'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85993100384453515.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Valor M\00E1ximo')
,p_lov_return_value=>'X'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85993304681453515.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Valor Medio'
,p_lov_return_value=>'V'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85993522601453515.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Suma de Todos los Valores'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85993713082453516.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Primer Valor'
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85993914783453516.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('\00DAltimo Valor')
,p_lov_return_value=>'L'
);
end;
/
prompt --application/shared_components/user_interface/lovs/simplified_region_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(28331928066600148.4001)
,p_lov_name=>'SIMPLIFIED.REGION.TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(28331928066600148.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28332230854600155.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28332427630600158.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Servicio Web'
,p_lov_return_value=>'WEB_SERVICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28332629807600158.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28332816374600158.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Texto de Ayuda'
,p_lov_return_value=>'HELP_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28333024667600158.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Contenido Est\00E1tico')
,p_lov_return_value=>'HTML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28333221783600159.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'TREE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28333403597600159.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL'
,p_lov_return_value=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28333621226600159.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28333810937600159.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28334027077600160.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Men\00FA')
,p_lov_return_value=>'MENU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28334201168600160.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(28370021803071485.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pantalla Tabular'
,p_lov_return_value=>'TABULAR_FORM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sort_nulls
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(93797019007450994.4001)
,p_lov_name=>'SORT NULLS'
,p_lov_query=>'.'||wwv_flow_api.id(93797019007450994.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93797213790450997.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Primero'
,p_lov_return_value=>'F'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(93797405616450997.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('\00DAltimo')
,p_lov_return_value=>'L'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sort_directions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(601135878417900624.4001)
,p_lov_name=>'SORT_DIRECTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(601135878417900624.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601136053597900624.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ascendente (nulos al final)'
,p_lov_return_value=>'ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601136431456900625.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Ascendente (nulos al principio)'
,p_lov_return_value=>'ASC_NULLS_FIRST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601136832942900625.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Descendente (nulos al final)'
,p_lov_return_value=>'DESC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(601137274557900625.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Descendente (nulos al principio)'
,p_lov_return_value=>'DESC_NULLS_FIRST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_icon_sizes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1700420804690087.4001)
,p_lov_name=>'STANDARD ICON SIZES'
,p_lov_query=>'.'||wwv_flow_api.id(1700420804690087.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(208694932527642212.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'16x16'
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(130922308813815749.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'20x20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1700832074690087.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'32x32'
,p_lov_return_value=>'32'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1700624248690087.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'64x64'
,p_lov_return_value=>'64'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112354600646082973.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'128x128'
,p_lov_return_value=>'128'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(145794820863445874.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'140x90'
,p_lov_return_value=>'140'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_icon_sizes_2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(208711104382927390.4001)
,p_lov_name=>'STANDARD ICON SIZES 2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''12x12''	 d, 12  r from dual union all',
'select ''16x16''	 d, 16  r from dual union all',
'select ''20x20''	 d, 20  r from dual union all',
'select ''32x32''	 d, 32  r from dual union all',
'select ''64x64''	 d, 64  r from dual union all',
'select ''128x128'' d, 128 r from dual union all',
'select ''140x90''	 d, 140 r from dual',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_page_codes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5402514727348886.4001)
,p_lov_name=>'STANDARD PAGE CODES'
,p_lov_query=>'.'||wwv_flow_api.id(5402514727348886.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5739801369768982.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'13'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5831629645510743.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>unistr('P\00E1gina Global')
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5402701440348886.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pantalla Tabular'
,p_lov_return_value=>'01'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5402909385348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pantalla DML'
,p_lov_return_value=>'02'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5403122972348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'03'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5403327785348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Gr\00E1fico')
,p_lov_return_value=>'04'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5403520568348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Servicio Web'
,p_lov_return_value=>'05'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5403731475348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Navegaci\00F3n')
,p_lov_return_value=>'06'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5403924082348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rbol')
,p_lov_return_value=>'07'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5404107694348887.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'08'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5404331595348888.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'09'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5404515117348888.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('HTML Din\00E1mico')
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5404700114348888.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('HTML Est\00E1tico')
,p_lov_return_value=>'11'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5719116485489493.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Conectar'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5866501145720101.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'En Blanco'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8481401022510038.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Pantalla Din\00E1mica')
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(8486621763563293.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Pantalla de Navegaci\00F3n')
,p_lov_return_value=>'17'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(95820812557710460.4001)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Informe Interactivo'
,p_lov_return_value=>'18'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_condition_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13602414170805697.4001)
,p_lov_name=>'STANDARD_CONDITION_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13603123074805757.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists (la consulta SQL devuelve al menos una fila)'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13603317895805758.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists (la consulta SQL no devuelve ninguna fila)'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13602817848805747.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>unistr('Expresi\00F3n')
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13989216069093119.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Cuerpo de la funci\00F3n que devuelve valor booleano')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15047020206284804.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Solicitud = Expresi\00F3n 1&nbsp;')
,p_lov_return_value=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15047716971286340.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Solicitud != Expresi\00F3n 1')
,p_lov_return_value=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15165118412046187.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('Solicitud Incluida en Expresi\00F3n 1&nbsp;')
,p_lov_return_value=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15166516040047219.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Solicitud no Incluida en Expresi\00F3n 1&nbsp;')
,p_lov_return_value=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13603921598805759.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 = Expresi\00F3n 2')
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13604123781805759.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 != Expresi\00F3n 2')
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13603529275805758.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es NULO')
,p_lov_return_value=>'ITEM_IS_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13603702602805758.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es NO NULO')
,p_lov_return_value=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15011515800134964.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 = Cero')
,p_lov_return_value=>'ITEM_IS_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15045831204279794.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 != Cero')
,p_lov_return_value=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13990910462095775.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es NULO o cero')
,p_lov_return_value=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15470011873930461.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>unistr('El valor del elemento/columna en Expresi\00F3n 1 es NO nulo y el elemento es NO cero')
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15491720474956815.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 no contiene espacios')
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15476321781941049.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(85622123329305508.4001)
,p_lov_disp_sequence=>201
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es no num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NOT_NUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15471900443935744.4001)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>unistr('El valor del elemento/columna de Expresi\00F3n 1 es alfanum\00E9rico')
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(16378325840224231.4001)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>unistr('Valor de Elemento/Columna en Expresi\00F3n 1 Incluido en la Lista Delimitada por Dos Puntos en Expresi\00F3n 2')
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37749811129022200.4001)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>unistr('Valor de Elemento/Columna en Expresi\00F3n 1 NO Incluido en la Lista Delimitada por Dos Puntos en Expresi\00F3n 2')
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14091700023206920.4001)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>unistr('Valor de Preferencia del Usuario en Expresi\00F3n 1 = Expresi\00F3n 2')
,p_lov_return_value=>'USER_PREF_IN_COND_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14093528694208826.4001)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>unistr('Valor de Preferencia del Usuario en Expresi\00F3n 1 != Expresi\00F3n 2')
,p_lov_return_value=>'USER_PREF_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14021821208136360.4001)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>unistr('P\00E1gina Actual = Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_PAGE_EQUALS_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14267417194095422.4001)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>unistr('P\00E1gina Actual != Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14001701823114905.4001)
,p_lov_disp_sequence=>280
,p_lov_disp_value=>unistr('P\00E1gina Actual Incluida en Expresi\00F3n 1 (lista de p\00E1ginas delimitada por comas)&nbsp;')
,p_lov_return_value=>'CURRENT_PAGE_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14003630925116682.4001)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>unistr('P\00E1gina Actual no Incluida en Expresi\00F3n 1 (lista de p\00E1ginas delimitada por comas)&nbsp;')
,p_lov_return_value=>'CURRENT_PAGE_NOT_IN_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15039116780255999.4001)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>unistr('P\00E1gina Actual = P\00E1gina Ejecutada (se ha enviado esta p\00E1gina)')
,p_lov_return_value=>'WHEN_THIS_PAGE_SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15039807291260459.4001)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>unistr('P\00E1gina Actual != P\00E1gina Ejecutada (\00E9sta no es la p\00E1gina enviada)')
,p_lov_return_value=>'WHEN_THIS_PAGE_NOT_SUBMITTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15037208597244692.4001)
,p_lov_disp_sequence=>320
,p_lov_disp_value=>unistr('P\00E1gina Actual en modo Versi\00F3n para Impresora')
,p_lov_return_value=>'PAGE_IS_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15037905362246171.4001)
,p_lov_disp_sequence=>330
,p_lov_disp_value=>unistr('P\00E1gina Actual no en modo Versi\00F3n para Impresora')
,p_lov_return_value=>'PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17138426279336021.4001)
,p_lov_disp_sequence=>340
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 Incluida en el Valor del Elemento/Columna en Expresi\00F3n 2')
,p_lov_return_value=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15008126596114779.4001)
,p_lov_disp_sequence=>350
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 Incluido en el Texto de Expresi\00F3n 2')
,p_lov_return_value=>'DISPLAY_COND_IN_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15008817538118931.4001)
,p_lov_disp_sequence=>360
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 no Incluido en el Texto de Expresi\00F3n 2')
,p_lov_return_value=>'DISPLAY_COND_NOT_IN_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15006711512106511.4001)
,p_lov_disp_sequence=>370
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 = Expresi\00F3n 2 (incluye sustituciones &ITEM.)')
,p_lov_return_value=>'DISPLAY_COND_EQUAL_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15007405258109453.4001)
,p_lov_disp_sequence=>380
,p_lov_disp_value=>unistr('Texto en Expresi\00F3n 1 != Expresi\00F3n 2 (incluye sustituciones &ITEM.)')
,p_lov_return_value=>'DISP_COND_NOT_EQUAL_COND_TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17067417234166851.4001)
,p_lov_disp_sequence=>385
,p_lov_disp_value=>unistr('P\00E1gina/Regi\00F3n Es de S\00F3lo Lectura')
,p_lov_return_value=>'IS_READ_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17067626931169663.4001)
,p_lov_disp_sequence=>387
,p_lov_disp_value=>unistr('P\00E1gina/Regi\00F3n NO Es de S\00F3lo Lectura')
,p_lov_return_value=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13995619938106517.4001)
,p_lov_disp_sequence=>390
,p_lov_disp_value=>unistr('Usuario Autenticado  (no p\00FAblico)')
,p_lov_return_value=>'USER_IS_NOT_PUBLIC_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13994228133102772.4001)
,p_lov_disp_sequence=>400
,p_lov_disp_value=>unistr('El Usuario es el Usuario P\00FAblico (el usuario no se ha autenticado)')
,p_lov_return_value=>'USER_IS_PUBLIC_USER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4814310982912915.4001)
,p_lov_disp_sequence=>410
,p_lov_disp_value=>unistr('Errores de Validaci\00F3n en L\00EDnea Mostrados')
,p_lov_return_value=>'DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4815518518924629.4001)
,p_lov_disp_sequence=>420
,p_lov_disp_value=>unistr('Errores de Validaci\00F3n en L\00EDnea No Mostrados')
,p_lov_return_value=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17189121220460009.4001)
,p_lov_disp_sequence=>430
,p_lov_disp_value=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Adelante)')
,p_lov_return_value=>'MAX_ROWS_LT_ROWS_FETCHED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17186825533457975.4001)
,p_lov_disp_sequence=>440
,p_lov_disp_value=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Atr\00E1s)')
,p_lov_return_value=>'MIN_ROW_GT_THAN_ONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4929605646440424.4001)
,p_lov_disp_sequence=>450
,p_lov_disp_value=>'Explorador del Cliente: Mozilla, Netscape 6.x/7x o superior'
,p_lov_return_value=>'BROWSER_IS_NSCP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4928131488438441.4001)
,p_lov_disp_sequence=>460
,p_lov_disp_value=>'Explorador del Cliente: Microsoft Internet Explorer 5.5, 6.0 o superior'
,p_lov_return_value=>'BROWSER_IS_MSIE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5886202180257756.4001)
,p_lov_disp_sequence=>470
,p_lov_disp_value=>'Explorador del Cliente: Explorador Compatible con XHTML / CSS'
,p_lov_return_value=>'BROWSER_IS_MSIE_OR_NSCP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5886511530260376.4001)
,p_lov_disp_sequence=>480
,p_lov_disp_value=>unistr('Explorador del Cliente: Otros exploradores (o versi\00F3n anterior)')
,p_lov_return_value=>'BROWSER_IS_OTHER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15016115991165257.4001)
,p_lov_disp_sequence=>490
,p_lov_disp_value=>unistr('Idioma Actual Incluido en Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_IN_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15016810384167816.4001)
,p_lov_disp_sequence=>500
,p_lov_disp_value=>unistr('Idioma Actual no Incluido en Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_NOT_IN_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15015429146159113.4001)
,p_lov_disp_sequence=>510
,p_lov_disp_value=>unistr('Idioma Actual != Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_NOT_EQ_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15014702201156470.4001)
,p_lov_disp_sequence=>520
,p_lov_disp_value=>unistr('Idioma Actual = Expresi\00F3n 1')
,p_lov_return_value=>'CURRENT_LANG_EQ_COND1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14059905871173891.4001)
,p_lov_disp_sequence=>530
,p_lov_disp_value=>unistr('Cuando CGI_ENV DAD_NAME = Expresi\00F3n 1')
,p_lov_return_value=>'DAD_NAME_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14063031307177276.4001)
,p_lov_disp_sequence=>540
,p_lov_disp_value=>unistr('Cuando CGI_ENV DAD_NAME != Expresi\00F3n 1')
,p_lov_return_value=>'DAD_NAME_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14035803295159838.4001)
,p_lov_disp_sequence=>550
,p_lov_disp_value=>unistr('Cuando CGI_ENV SERVER_NAME = Expresi\00F3n 1')
,p_lov_return_value=>'SERVER_NAME_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14039027868163631.4001)
,p_lov_disp_sequence=>560
,p_lov_disp_value=>unistr('Cuando CGI_ENV SERVER_NAME != Expresi\00F3n 1')
,p_lov_return_value=>'SERVER_NAME_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14028423999150274.4001)
,p_lov_disp_sequence=>570
,p_lov_disp_value=>unistr('Cuando CGI_ENV HTTP_HOST = Expresi\00F3n 1')
,p_lov_return_value=>'HTTP_HOST_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(14030116882153510.4001)
,p_lov_disp_sequence=>580
,p_lov_disp_value=>unistr('Cuando CGI_ENV HTTP_HOST != Expresi\00F3n 1')
,p_lov_return_value=>'HTTP_HOST_NOT_EQ_CONDITION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13966801644069447.4001)
,p_lov_disp_sequence=>999
,p_lov_disp_value=>'Nunca'
,p_lov_return_value=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(167852523543243817.4001)
,p_lov_disp_sequence=>1000
,p_lov_disp_value=>'Siempre'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/start_tree
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84323624609603883.4001)
,p_lov_name=>'START_TREE'
,p_lov_query=>'.'||wwv_flow_api.id(84323624609603883.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88313628445830962.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basado en un Elemento Existente'
,p_lov_return_value=>'ITEM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88313830642830963.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Basado en Consulta SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88314026283830963.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Basado en un Valor Est\00E1tico')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492838704369360119.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'El valor es NULL'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/static_or_item
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(194124529474988937.4001)
,p_lov_name=>'STATIC OR ITEM'
,p_lov_query=>'.'||wwv_flow_api.id(194124529474988937.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(194124717685988940.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Valor Est\00E1tico')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(194124922999988942.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nombre del Elemento'
,p_lov_return_value=>'ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/static_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84786916665020021.4001)
,p_lov_name=>'STATIC_DYNAMIC'
,p_lov_query=>'.'||wwv_flow_api.id(84786916665020021.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84787126609020022.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Din\00E1mico')
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84787325791020022.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Est\00E1tico')
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/static_files
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84307528025576497.4001)
,p_lov_name=>'STATIC_FILES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'initcap(',
'wwv_flow_lang.system_message(''ALL_STATIC_FILES''))d , -1 r',
'  from dual',
'union all',
'select wwv_flow_lang.system_message(''STATIC_FILES_NO_APPLICATION'') d, 0 r',
'  from dual',
'union all',
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/stay
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86063932403762069.4001)
,p_lov_name=>'STAY'
,p_lov_query=>'.'||wwv_flow_api.id(86063932403762069.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88314631562831853.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Volver a la P\00E1gina')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/stay_on_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159773503131383335.4001)
,p_lov_name=>'STAY_ON_PAGE'
,p_lov_query=>'.'||wwv_flow_api.id(159773503131383335.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159773814876383337.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/steps_std_tab
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84327116428611002.4001)
,p_lov_name=>'STEPS_STD_TAB'
,p_lov_query=>'.'||wwv_flow_api.id(84327116428611002.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88315201910832737.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Todos los pasos utilizan el mismo separador est\00E1ndar')
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88315426760832737.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Un separador est\00E1ndar por paso')))
,p_lov_return_value=>'ONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/subscribed_unsubscribed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84896716300568756.4001)
,p_lov_name=>'SUBSCRIBED.UNSUBSCRIBED'
,p_lov_query=>'.'||wwv_flow_api.id(84896716300568756.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84896922929568758.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suscrito'
,p_lov_return_value=>'SUB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84897130563568758.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No Suscrito'
,p_lov_return_value=>'UNSUB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/supporting_object_script_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(57799129745997268.4001)
,p_lov_name=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(57799329552997269.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Instalar'
,p_lov_return_value=>'INSTALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(57799516609997270.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Actualizar'
,p_lov_return_value=>'UPGRADE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(57930331990310140.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Desinstalar'
,p_lov_return_value=>'DEINSTALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/svg_chart_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(13873818427997807.4001)
,p_lov_name=>'SVG CHART TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(13873818427997807.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13874110086997853.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Barra, Vertical'
,p_lov_return_value=>'VBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13874324361997857.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Barra, Horizontal'
,p_lov_return_value=>'HBAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(13874508985997857.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Tarta'
,p_lov_return_value=>'PIE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5312118250963733.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('L\00EDnea')
,p_lov_return_value=>'LINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17478122660443416.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Dispersi\00F3n')
,p_lov_return_value=>'SCATTER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3224907007165166.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Barra Apilada, Vertical'
,p_lov_return_value=>'STACKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3225213587167083.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Barra Apilada de Porcentajes, Vertical'
,p_lov_return_value=>'STACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3225520859169124.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Barra Agrupada, Vertical'
,p_lov_return_value=>'CLUSTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3364901558270620.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Barra Apilada, Horizontal'
,p_lov_return_value=>'HSTACKED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3365407792272446.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Barra Apilada de Porcentajes, Horizontal'
,p_lov_return_value=>'HSTACKED_PCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3366407576281829.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Barra Agrupada, Horizontal'
,p_lov_return_value=>'HCLUSTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3369215672293634.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Dial'
,p_lov_return_value=>'DIAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(5845103014129124.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Dial (con Barrido)'
,p_lov_return_value=>'DIALSWEEP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/svg_font_face
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15705700831360468.4001)
,p_lov_name=>'SVG_FONT_FACE'
,p_lov_query=>'.'||wwv_flow_api.id(15705700831360468.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15706010936360500.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arial'
,p_lov_return_value=>'Arial'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15706203457360504.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Helvetica'
,p_lov_return_value=>'Helvetica'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15706413226360504.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Geneva'
,p_lov_return_value=>'Geneva'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15706631186360504.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Sans-serif'
,p_lov_return_value=>'sans-serif'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(32373929116515333.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Verdana'
,p_lov_return_value=>'Verdana'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35182603175246497.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Tahoma'
,p_lov_return_value=>'Tahoma'
);
end;
/
prompt --application/shared_components/user_interface/lovs/svg_font_size
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(15707232345369601.4001)
,p_lov_name=>'SVG_FONT_SIZE'
,p_lov_query=>'.'||wwv_flow_api.id(15707232345369601.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15707524079369601.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15707707938369603.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15707930580369603.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15708109634369603.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15708306344369603.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15708523904369603.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'12'
,p_lov_return_value=>'12'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15708808135369609.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'14'
,p_lov_return_value=>'14'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15709011308369609.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'16'
,p_lov_return_value=>'16'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15709231985369609.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'18'
,p_lov_return_value=>'18'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15709413368369610.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15709630193369614.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'22'
,p_lov_return_value=>'22'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sync_breadcrumb
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(47143021317359827.4001)
,p_lov_name=>'SYNC BREADCRUMB'
,p_lov_query=>'.'||wwv_flow_api.id(47143021317359827.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(47143222442359827.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Nombre y T\00EDtulo de la P\00E1gina')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabform_execute_condition
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7569601081513754.4001)
,p_lov_name=>'TABFORM_EXECUTE_CONDITION'
,p_lov_query=>'.'||wwv_flow_api.id(7569601081513754.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7569930183513774.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Para Cada Fila'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7570109252513777.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Una Vez'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabform_only_for_changed_rows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(9364428304832423.4001)
,p_lov_name=>'TABFORM_ONLY_FOR_CHANGED_ROWS'
,p_lov_query=>'.'||wwv_flow_api.id(9364428304832423.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9364904590832430.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Para Filas Creadas y Modificadas'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(9364732183832426.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Todas las Filas Enviadas'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/table_view_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84298131918558733.4001)
,p_lov_name=>'TABLE_VIEW_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P29_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabs_for_800
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2804200546103254.4001)
,p_lov_name=>'TABS (FOR 800)'
,p_lov_query=>'.'||wwv_flow_api.id(2804200546103254.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2804500147103257.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ning\00FAn Separador')
,p_lov_return_value=>'NO_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2804718846103257.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Un Nivel de Separadores'
,p_lov_return_value=>'SINGLE_LEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2804919057103257.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Dos Niveles de Separadores'
,p_lov_return_value=>'TWO_LEVEL_TABS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabs_page_3020
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(140133614691303751.4001)
,p_lov_name=>'TABS (PAGE 3020)'
,p_lov_query=>'.'||wwv_flow_api.id(140133614691303751.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(140133828025303756.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ning\00FAn Separador')
,p_lov_return_value=>'NO_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(140134000483303758.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Un Nivel de Separadores'
,p_lov_return_value=>'SINGLE_LEVEL_TABS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(140134208841303758.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Dos Niveles de Separadores'
,p_lov_return_value=>'TWO_LEVEL_TABS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabsets_with_empty_sets_unioned
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(28738517235744577.4001)
,p_lov_name=>'TABSETS WITH EMPTY SETS UNIONED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d) d, r',
'  from wwv_flow_tabset_view2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_date_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(19853917765280516.4001)
,p_lov_name=>'TABULAR_FORM_DATE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(19853917765280516.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19855422713280526.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19855601684280526.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19855806360280526.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19861607507280532.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19861831615280533.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19862013188280533.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19862220933280533.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19862400541280533.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19862629132280533.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19862821146280534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19863007312280534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19863209393280534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19863428929280534.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19863623755280535.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19863819825280535.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19864208396280535.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Selector de Fecha (usar m\00E1scara de formato de aplicaci\00F3n)')
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22073306493718862.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22073913765720916.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22074820692722982.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22075421515732683.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22075729134734808.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22076002946736752.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22076430304744622.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22076704462746660.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22077606802766286.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22077915113768696.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22078530482782518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22078805679784843.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22079112951786930.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22080512389796225.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22080917930797806.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22081227281800546.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41125203906793852.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41126623299799507.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(92184003441504374.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Selector de Fecha (usar m\00E1scara de formato de elemento)')
,p_lov_return_value=>'PICK_DATE_USING_FORMAT_MASK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108027020146849063.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Selector de Fecha (Usar Formato de Fecha de Aplicaci\00F3n)')
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_display_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(41868019518520883.4001)
,p_lov_name=>'TABULAR_FORM_DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(41868019518520883.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41868709480520899.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Columna de Informe Est\00E1ndar')
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(146115508440728992.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Mostrar como Texto (basado en la lista de valores, no guarda el estado)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41868501071520899.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Mostrar como Texto (guarda el estado)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41868905439520899.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Mostrar como Texto (caracteres especiales de escape, no guarda el estado)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41870530818520901.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>unistr('Selector de Fecha (Cl\00E1sico)')
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(619170920138130822.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Selector de Fecha'
,p_lov_return_value=>'DATE_PICKER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41869114721520900.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Campo de Texto'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41869313403520900.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>unistr('\00C1rea de Texto')
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41869519454520900.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n (Lista de Valores Est\00E1tica)')
,p_lov_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42037708820188188.4001)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n (Lista de Valores con Nombre)')
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41869932445520901.4001)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n (Lista de Valores Basada en Consultas)')
,p_lov_return_value=>'SELECT_LIST_FROM_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184369431308294796.4001)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>unistr('Grupo de Botones de Radio (lista de valores est\00E1tica)')
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184369607198297304.4001)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Grupo de Botones de Radio (lista de valores con nombre)'
,p_lov_return_value=>'RADIOGROUP_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184369915163299514.4001)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Grupo de Botones de Radio (lista de valores basada en consulta)	'
,p_lov_return_value=>'RADIOGROUP_FROM_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41870102302520901.4001)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Oculto '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(41870309076520901.4001)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Lista de Valores Emergente (Lista de Valores con Nombre)'
,p_lov_return_value=>'POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(90288409721242959.4001)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Lista de Valores Emergente (Lista de Valores Basada en Consultas)'
,p_lov_return_value=>'POPUP_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184154525058674461.4001)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Lista de Valores Clave Emergente (Lista de Valores con Nombre)'
,p_lov_return_value=>'POPUPKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184156407181678728.4001)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Lista de Valores Clave Emergente (Lista de Valores Basada en Consultas)'
,p_lov_return_value=>'POPUPKEY_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(615558619134956199.4001)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Casilla de Control Simple'
,p_lov_return_value=>'SIMPLE_CHECKBOX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(37374013079477607.4001)
,p_lov_name=>'TABULAR_FORM_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(37374013079477607.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37374309130477610.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00F3lo Actualizar')
,p_lov_return_value=>'UPDATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37374515762477611.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Actualizar e Insertar'
,p_lov_return_value=>'INSERT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37374718899477611.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Actualizar, Insertar y Suprimir'
,p_lov_return_value=>'INSERT_AND_DELETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(37374901857477611.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Actualizar y Suprimir'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84311114650582100.4001)
,p_lov_name=>'TAB_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84311114650582100.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88316005027833611.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No utilizar separadores'
,p_lov_return_value=>'NO_TAB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88316224819833612.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Todas las p\00E1ginas utilizan el mismo separador est\00E1ndar')))
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88316424372833612.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Un separador est\00E1ndar por p\00E1gina')))
,p_lov_return_value=>'ONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_sequence
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(151879426590303081.4001)
,p_lov_name=>'TAB_SEQUENCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct tab_sequence a, tab_sequence b',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_set_choice
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84320304523598135.4001)
,p_lov_name=>'TAB_SET_CHOICE'
,p_lov_query=>'.'||wwv_flow_api.id(84320304523598135.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84320517347598135.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Crear un nuevo juego de separadores y un nuevo separador en el juego de separadores.'
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84320714112598136.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Utilizar un juego de separadores existente y crear un nuevo separador en el juego de separadores existente.'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_set_choice_all
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84778506791979282.4001)
,p_lov_name=>'TAB_SET_CHOICE_ALL'
,p_lov_query=>'.'||wwv_flow_api.id(84778506791979282.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84778716079979282.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No utilizar separadores'
,p_lov_return_value=>'NO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84779119299979283.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Utilizar un juego de separadores existente y crear un nuevo separador en el juego de separadores existente.'
,p_lov_return_value=>'EXISTING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84779323082979285.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Utilizar un juego de separadores existente y volver a utilizar un separador existente de ese juego de separadores.'
,p_lov_return_value=>'EXISTING2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/team_dev_fs_limit
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2541932940202319161.4001)
,p_lov_name=>'TEAM_DEV_FS_LIMIT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_cosolidation_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(97572901159694386.4001)
,p_lov_name=>'TEMPLATE COSOLIDATION TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(97572901159694386.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97573226909694391.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:920:&SESSION.:::920,921,922,924,26,144"><img src="#IMAGE_PREFIX#htmldb/builder/blank_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97573426902694392.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:901:&SESSION.:::4653,901,902,4320,158"><img src="#IMAGE_PREFIX#htmldb/builder/region_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97573611581694392.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:951:&SESSION.:::951,955,4321,168"><img src="#IMAGE_PREFIX#htmldb/builder/report_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97573811962694392.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Etiqueta'
,p_lov_return_value=>'LABEL'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:941:&SESSION.:::941,86,167,650,652"><img src="#IMAGE_PREFIX#htmldb/builder/label_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97574031815694393.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:931:&SESSION.:::931,934,935,4069,159"><img src="#IMAGE_PREFIX#htmldb/builder/list_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97574222180694393.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:211:&SESSION.:::211,218,219,223,224,225"><img src="#IMAGE_PREFIX#htmldb/builder/button_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97574415983694393.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'MENU'
,p_lov_template=>'#DISPLAY_VALUE# <br /><a href="f?p=4000:238:&SESSION.:::238,240,241,242"><img src="#IMAGE_PREFIX#htmldb/builder/menu_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(97574627093694393.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:161:&SESSION.:::161"><img src="#IMAGE_PREFIX#htmldb/builder/calendar_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_match
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1382206179278736769.4001)
,p_lov_name=>'TEMPLATE MATCH'
,p_lov_query=>'.'||wwv_flow_api.id(1382206179278736769.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1382206400153736789.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Por Identificador de Plantilla'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1382206845980736790.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Por Nombre de Plantilla'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_option_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(655584409399418944.4001)
,p_lov_name=>'TEMPLATE OPTION TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(655584409399418944.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655584729952418948.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655585048066418950.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655585342316418950.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655585628425418951.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'BREADCRUMB'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655585948924418951.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655586205931418951.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Campo'
,p_lov_return_value=>'FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(655586597916418951.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types_page_708
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(168736405114387476.4001)
,p_lov_name=>'TEMPLATE TYPES PAGE 708'
,p_lov_query=>'.'||wwv_flow_api.id(168736405114387476.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168736704180387479.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168736918167387480.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168737102241387480.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168737309288387480.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Etiqueta'
,p_lov_return_value=>'LABEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168737511127387480.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168737715707387480.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168737909969387480.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'MENU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(168738110866387480.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Calendario Heredado'
,p_lov_return_value=>'CALENDAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types_returning_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(282026017647000169.4001)
,p_lov_name=>'TEMPLATE TYPES RETURNING NAME'
,p_lov_query=>'.'||wwv_flow_api.id(282026017647000169.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282026324068000178.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282026529832000180.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282026713154000180.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Etiqueta'
,p_lov_return_value=>'LABEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282026918534000181.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'LIST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282027107889000181.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Lista de Valores Emergente'
,p_lov_return_value=>'POPUP_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282027307751000181.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282027500156000181.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'MENU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282027714036000182.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'BUTTON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(282027909056000182.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_yes_no_subscribe
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(150847232623403358.4001)
,p_lov_name=>'TEMPLATE YES.NO.SUBSCRIBE'
,p_lov_query=>'.'||wwv_flow_api.id(150847232623403358.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(150847503925403360.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(150847709120403362.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(150847907139403362.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copiar y Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :F4000_COPY_TO_THEME',
'and reference_id is null'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types_all
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(90737426296160594.4001)
,p_lov_name=>'TEMPLATE.TYPES.ALL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/templates_view_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(230524412593007607.4001)
,p_lov_name=>'TEMPLATES.VIEW.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(230524412593007607.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(230524708572007610.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plantillas con Referencia'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(230525020430007613.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Plantillas sin Referencia'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(230525214548007613.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Todas las Plantillas'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_report_on
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84836411424340211.4001)
,p_lov_name=>'TEMPLATE_REPORT_ON'
,p_lov_query=>'.'||wwv_flow_api.id(84836411424340211.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84836624193340211.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'Page'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84836806641340212.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'Region'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84837004299340212.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'Report'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84837213121340212.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'List'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84837423252340212.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Etiqueta'
,p_lov_return_value=>'Field'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84837618414340213.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'Button'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84837825455340213.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'Menu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19425309920595509.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Calendario'
,p_lov_return_value=>'Calendar'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_subscription_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1467334342209901488.4001)
,p_lov_name=>'TEMPLATE_SUBSCRIPTION_STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(1467334342209901488.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1467334665943901490.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Coincidencia'
,p_lov_return_value=>'MATCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1467334924557901491.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No Sincronizado'
,p_lov_return_value=>'OUT_OF_SYNC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1474343776393848287.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'No Coincidencia de Opciones de Plantilla'
,p_lov_return_value=>'TEMPLATE_OPTIONS_MISMATCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1475854067168452196.4001)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>unistr('No Definido en Tema de Suscripci\00F3n')
,p_lov_return_value=>'MISSING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1592357805860111979.4001)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'No Suscrito'
,p_lov_return_value=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_themes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(26326826556101977.4001)
,p_lov_name=>'TEMPLATE_THEMES'
,p_lov_query=>'.'||wwv_flow_api.id(26326826556101977.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26337621754128975.4001)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Todos los Temas'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26327121768101985.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Azul y Marr\00F3n Claro')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26327331118101989.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Rojo'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26327522154101989.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Independiente del Color'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26327728603101990.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Azul Marino y Gris'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26327900997101990.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Verde Oliva'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26328104545101990.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Granate'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(26328332634101992.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Azul Claro y Marr\00F3n Claro')
,p_lov_return_value=>'7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84868022945400324.4001)
,p_lov_name=>'TEMPLATE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(84868022945400324.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84869015029400326.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('P\00E1gina')
,p_lov_return_value=>'f?p=4000:920:&SESSION.:::920,921,922,924,26,144'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-page'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84869224199400326.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Regi\00F3n')
,p_lov_return_value=>'f?p=4000:901:&SESSION.:::4653,901,902,4320,158'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-region'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84869423577400327.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Informe'
,p_lov_return_value=>'f?p=4000:951:&SESSION.:::951,955,4321,168'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-report'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84868407785400325.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Etiqueta'
,p_lov_return_value=>'f?p=4000:941:&SESSION.:::941,86,167,650,652'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-label'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84868623129400326.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Lista'
,p_lov_return_value=>'f?p=4000:931:&SESSION.:::931,934,935,4069,159'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-list'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84868225653400325.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Bot\00F3n')
,p_lov_return_value=>'f?p=4000:211:&SESSION.:::211,218,219,223,224,225'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-button'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84868806178400326.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>unistr('Ruta de Navegaci\00F3n')
,p_lov_return_value=>'f?p=4000:238:&SESSION.:::238,240,241,242'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-breadcrumb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(19410014805549665.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Calendario Heredado'
,p_lov_return_value=>'f?p=4000:161:&SESSION.:::122'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-css-calendar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(74989224462749317.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Emergente'
,p_lov_return_value=>'f?p=4000:350:&SESSION.:::350'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-popup'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_list_for_ws_preferences
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2823513415211031.4001)
,p_lov_name=>'THEME LIST FOR WS PREFERENCES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''|| wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||'')''||',
'       ''<a href="#" ><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme-preview theme_''||t.theme_id||''" alt="''||wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.theme_id) theme_id',
'       from wwv_flow_themes t, wwv_flow_user_interfaces ui ',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P800_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P800_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P800_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P800_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P800_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P800_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P800_SHOW = ''ALL'')',
'        )  ',
'        and ui.flow_id = t.flow_id',
'        and ui.theme_id = t.theme_id',
'        and ui.ui_type_id = :P800_UI_TYPE_ID',
'        order by t.flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1399872256703479206.4001)
,p_lov_name=>'THEME SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(1399872256703479206.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1399872521466479209.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Tema de Aplicaci\00F3n')
,p_lov_return_value=>'app'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1399872968543479210.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tema de Espacio de Trabajo'
,p_lov_return_value=>'workspace'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1399873345848479210.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Tema P\00FAblico')
,p_lov_return_value=>'public'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1399873718982479211.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Tema de Oracle'
,p_lov_return_value=>'oracle'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_16_supplied_themes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(48664803510648896.4001)
,p_lov_name=>'THEME_16 (SUPPLIED THEMES)'
,p_lov_query=>'.'||wwv_flow_api.id(48664803510648896.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48665104317648900.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tema 1'
,p_lov_return_value=>'1'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:1"><img src="#IMAGE_PREFIX#themes/theme_1/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 1 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48979517706471248.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tema 2'
,p_lov_return_value=>'2'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:2"><img src="#IMAGE_PREFIX#themes/theme_2/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 2 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48979822208472580.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Tema 3'
,p_lov_return_value=>'3'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:3"><img src="#IMAGE_PREFIX#themes/theme_3/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 3 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48980126710473810.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Tema 4'
,p_lov_return_value=>'4'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:4"><img src="#IMAGE_PREFIX#themes/theme_4/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 4 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48980431558475223.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Tema 5'
,p_lov_return_value=>'5'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:5"><img src="#IMAGE_PREFIX#themes/theme_5/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 5 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48980705023477033.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Tema 6'
,p_lov_return_value=>'6'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:6"><img src="#IMAGE_PREFIX#themes/theme_6/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 6 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48981010218478513.4001)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tema 7'
,p_lov_return_value=>'7'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:7"><img src="#IMAGE_PREFIX#themes/theme_7/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 7 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48981316798480442.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Tema 8'
,p_lov_return_value=>'8'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:8"><img src="#IMAGE_PREFIX#themes/theme_8/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 8 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48981623031482219.4001)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Tema 9'
,p_lov_return_value=>'9'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:9"><img src="#IMAGE_PREFIX#themes/theme_9/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 9 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48981927533483540.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tema 10'
,p_lov_return_value=>'10'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:10"><img src="#IMAGE_PREFIX#themes/theme_10/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 10 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48982231689484760.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Tema 11'
,p_lov_return_value=>'11'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:11"><img src="#IMAGE_PREFIX#themes/theme_11/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 11 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(48982504116486251.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Tema 12'
,p_lov_return_value=>'12'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:12"><img src="#IMAGE_PREFIX#themes/theme_12/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 12 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_install
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(143032610843100694.4001)
,p_lov_name=>'THEME_INSTALL'
,p_lov_query=>'.'||wwv_flow_api.id(143032610843100694.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(143032931826100703.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Refrescar Tema Existente'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(143033131431100704.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Crear Nuevo Tema'
,p_lov_return_value=>'CREATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_list
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(240131711033281817.4001)
,p_lov_name=>'THEME_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''||t.theme_id||'')<a href="f?p=4000:''||:THEME_NEXT_PAGE ||    ',
'       '':''||:APP_SESSION||''::::P496_THEME:''|| t.id ||    ',
'       ''"><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme_''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.id) theme_app_id',
'       from wwv_flow_themes t, wwv_flow_user_interfaces ui ',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P496_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P496_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P496_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P496_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P496_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P496_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P496_SHOW = ''ALL'')',
'        )  ',
'        and ui.flow_id = t.flow_id',
'        and ui.theme_id = t.theme_id',
'        and ui.ui_type_id = 1',
'        order by t.theme_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_list_p208
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(137137412186907673.4001)
,p_lov_name=>'THEME_LIST P208'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''|| wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||'')''||''<a href="f?p=4000:''||:THEME_NEXT_PAGE ||    ',
'       '':''||:APP_SESSION||''::::P208_THEME:''|| t.id ||    ',
'       ''"><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme_''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.id) theme_app_id',
'       from wwv_flow_themes t',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P208_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P208_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P208_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P208_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P208_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P208_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P208_SHOW = ''ALL'')',
'        )  ',
'        and t.ui_type_id = :P208_UI_TYPE_ID',
'        and t.theme_id not in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id)',
'        order by t.flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/time_format
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(61814624023212717.4001)
,p_lov_name=>'TIME FORMAT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(to_date(''06-26-1977 01:00'',''mm-dd-yyyy hh12:mi''),''am'') d,''AM'' r from dual ',
'UNION',
'select to_char(to_date(''06-26-1977 23:00'',''mm-dd-yyyy hh24:mi''),''am'') d,''PM'' r from dual ',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translatable_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84791208054045923.4001)
,p_lov_name=>'TRANSLATABLE_Y'
,p_lov_query=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84791403521045924.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Traducible'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translate_returning_language_code
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162455420955680205.4001)
,p_lov_name=>'TRANSLATE - RETURNING LANGUAGE CODE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' &gt;&gt; ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'       translation_flow_language_code ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translate_select_language_mapping
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162395031982879189.4001)
,p_lov_name=>'TRANSLATE SELECT LANGUAGE MAPPING'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' >> ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'       translation_flow_language_code ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translation_mapping_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(640493208817215668.4001)
,p_lov_name=>'TRANSLATION MAPPING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' >> ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'      translation_flow_id ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID',
'order by primary_language_flow_id, translation_flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_button_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84309708763580409.4001)
,p_lov_name=>'TREE_BUTTON_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84309708763580409.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84309922751580409.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Reducir Todo'
,p_lov_return_value=>'CONTRACT_ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84310126642580409.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Ampliar Todo'
,p_lov_return_value=>'EXPAND_ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84310313038580410.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Restablecer \00C1rbol')
,p_lov_return_value=>'RESET_TREE'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_click_action
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(483643112199322673.4001)
,p_lov_name=>'TREE_CLICK_ACTION'
,p_lov_query=>'.'||wwv_flow_api.id(483643112199322673.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(483643306184322681.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Un Solo Clic'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(483643530500322682.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Doble Clic'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_page_wiz_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12214332556403296.4001)
,p_lov_name=>'TREE_PAGE_WIZ_LOV'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_query_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84328725778613735.4001)
,p_lov_name=>'TREE_QUERY_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84328725778613735.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84328916472613735.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Din\00E1mico: De Consulta SQL')
,p_lov_return_value=>'DYNAMIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_template
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84339517383630187.4001)
,p_lov_name=>'TREE_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_api.id(84339517383630187.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445593824081293882.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Valor por Defecto'
,p_lov_return_value=>'default'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:114:&SESSION.::::F4000_P112_TREE_TEMPLATE:default"><img style="border: #cccccc 1px solid;" src="#IMAGE_PREFIX#apex/builder/tree_theme_default.png" width="150" height="75" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445593228106285605.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Azul'
,p_lov_return_value=>'apple'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:114:&SESSION.::::F4000_P112_TREE_TEMPLATE:apple"><img style="border: #cccccc 1px solid;" src="#IMAGE_PREFIX#apex/builder/tree_theme_apple.png" width="150" height="75" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(445593021872283767.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Cl\00E1sica')
,p_lov_return_value=>'classic'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:114:&SESSION.::::F4000_P112_TREE_TEMPLATE:classic"><img style="border: #cccccc 1px solid;" src="#IMAGE_PREFIX#apex/builder/tree_theme_classic.png" width="150" height="75" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_tooltip_option
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(484108402301064790.4001)
,p_lov_name=>'TREE_TOOLTIP_OPTION'
,p_lov_query=>'.'||wwv_flow_api.id(484108402301064790.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484108625829064799.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484108831383064804.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Asignaci\00F3n Est\00E1tica (el valor equivale al atributo de origen de la ayuda de burbuja)')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484109010056064804.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Columna de Base de Datos'
,p_lov_return_value=>'DB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84296320837555546.4001)
,p_lov_name=>'TREE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(84296320837555546.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84296510914555547.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Din\00E1mico: De Consulta SQL')
,p_lov_return_value=>'DYNAMIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/trim_conditions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(23846801132546001.4001)
,p_lov_name=>'TRIM_CONDITIONS'
,p_lov_query=>'.'||wwv_flow_api.id(23846801132546001.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23847125579546001.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Final'
,p_lov_return_value=>'trailing'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23847315260546002.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inicial'
,p_lov_return_value=>'leading'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23847528860546002.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Ambos'
,p_lov_return_value=>'both'
);
end;
/
prompt --application/shared_components/user_interface/lovs/true_false
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(34832921541772639.4001)
,p_lov_name=>'TRUE_FALSE'
,p_lov_query=>'.'||wwv_flow_api.id(34832921541772639.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34833224822772639.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Verdadero'
,p_lov_return_value=>'TRUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(34833403317772639.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Falso'
,p_lov_return_value=>'FALSE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(169775011419315124.4001)
,p_lov_name=>'UI'
,p_lov_query=>'.'||wwv_flow_api.id(169775011419315124.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(169775220892315128.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Usar Temas de Interfaz de Usuario Incorporados'
,p_lov_return_value=>'THEME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(169775418154315131.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Usar Tema desde una Aplicaci\00F3n Existente')
,p_lov_return_value=>'APPLICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_with_without_defaults
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113914515973189452.4001)
,p_lov_name=>'UI DEF WITH WITHOUT DEFAULTS'
,p_lov_query=>'.'||wwv_flow_api.id(113914515973189452.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113914915015189457.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Con Valores por Defecto'
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113915116496189457.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sin Valores por Defecto'
,p_lov_return_value=>'WO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_type_returns_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5268701303966420.4001)
,p_lov_name=>'UI TYPE (RETURNS ID)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name name,',
'   id',
'  from wwv_flow_ui_types_dev',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_type_unused_returns_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(276475400156590626.4001)
,p_lov_name=>'UI TYPE (UNUSED, RETURNS ID)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_ui_types_dev',
'where id not in (',
'    select t.id ',
'      from wwv_flow_ui_types_dev t, wwv_flow_user_interfaces i',
'     where i.ui_type_id = t.id ',
'      and i.flow_id = :fb_flow_id',
') and id = 1 order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_types_returns_name
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5267730430927525.4001)
,p_lov_name=>'UI TYPES (RETURNS NAME)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name',
'  from wwv_flow_ui_types_dev',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_alignment_l_c_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(112376223175417562.4001)
,p_lov_name=>'UI_DEF_ALIGNMENT.L.C.R'
,p_lov_query=>'.'||wwv_flow_api.id(112376223175417562.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112376421979417567.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Inicio'
,p_lov_return_value=>'L'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112376611541417570.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Centro'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112376830150417570.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Fin'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_display_as_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(285506029323635827.4001)
,p_lov_name=>'UI_DEF_DISPLAY_AS_REPORTS'
,p_lov_query=>'.'||wwv_flow_api.id(285506029323635827.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285507912489635846.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Columna de Informe Est\00E1ndar (s\00F3lo visualizaci\00F3n, no guarda el estado)')
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285508121787635846.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Mostrar como Texto (basado en la lista de valores, no guarda el estado)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285508323130635846.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Mostrar como Texto (guarda el estado)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285508512290635846.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Mostrar como Texto (caracteres especiales de escape, no guarda el estado)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(285508705553635847.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Oculto '
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_display_as_tabular_forms
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(285508811785635847.4001)
,p_lov_name=>'UI_DEF_DISPLAY_AS_TABULAR_FORMS'
,p_lov_query=>'.'||wwv_flow_api.id(285508811785635847.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23386007190363514.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Columna de Informe Est\00E1ndar (s\00F3lo visualizaci\00F3n, no guarda el estado)')
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23386208097363516.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostrar como Texto (basado en la lista de valores, no guarda el estado)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23386432155363516.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostrar como Texto (guarda el estado)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23386602692363517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Mostrar como Texto (caracteres especiales de escape, no guarda el estado)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23386811273363517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Campo de Texto'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23387002416363517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('\00C1rea de Texto')
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23387228952363517.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Lista de Selecci\00F3n')
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23387404497363518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oculto '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23387613926363518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lista de Valores Emergente'
,p_lov_return_value=>'POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23387831146363518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23388023682363518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Selector de Fecha (usar m\00E1scara de formato de aplicaci\00F3n)')
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23388204001363518.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23388403010363519.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23388608852363519.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23388832659363519.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23389014256363519.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23389220299363519.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23389405903363520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23389626534363520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23389823356363520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23390022127363520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23390200308363520.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23390417928363521.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23390628670363521.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23390808396363521.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23391024110363521.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23391223682363522.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23391412522363522.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23391629784363522.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23391815191363522.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23392011300363522.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23392230314363523.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23392427090363523.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23392612438363523.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23392821075363523.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23393008662363523.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23393230056363524.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23393405112363524.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23393616405363524.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23393814391363524.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23394014250363525.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23394208845363525.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23394414236363525.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(23394602109363525.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Selector de Fecha (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(108055312200998132.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Selector de Fecha (Usar Formato de Fecha de Aplicaci\00F3n)')
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/upgrade_app_validation_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(630881727193397263.4001)
,p_lov_name=>'UPGRADE_APP.VALIDATION_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(630881727193397263.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(630881931512397264.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Nulo'
,p_lov_return_value=>'ITEM_NOT_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(630882130251397264.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Num\00E9rico')
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(630882332428397264.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Fecha V\00E1lida')
,p_lov_return_value=>'ITEM_IS_DATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/upgrade_application_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(484799616606261493.4001)
,p_lov_name=>'UPGRADE_APPLICATION_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(484799616606261493.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484800018242261496.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Actualizar Elemento de Campo de Texto a Elemento de Campo Num\00E9rico, donde sea adecuado')
,p_lov_return_value=>'NUMBER_FIELD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484800813451261496.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Actualizar Atributo de Elemento Valor Necesario a S\00ED, donde sea necesario')
,p_lov_return_value=>'REQUIRED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484801405136261496.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Eliminar %null% de Valor de Retorno Nulo de LOV de Elementos de P\00E1gina')
,p_lov_return_value=>'LOV_NULL_VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484800413922261496.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Actualizar FCKEditor 2 a CKEditor 4'
,p_lov_return_value=>'CKEDITOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(491599022386863640.4001)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Activar Agrupar por para Informes Interactivos'
,p_lov_return_value=>'IR_GROUP_BY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(491599221824872943.4001)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Activar Guardar Informe P\00FAblico para Informes Interactivos')
,p_lov_return_value=>'IR_SAVE_PUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(491599601439895418.4001)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Activar Suscripci\00F3n para Informes Interactivos')
,p_lov_return_value=>'IR_SUBSCRIBE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(491604409666916783.4001)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('Activar Selector de Filas por P\00E1gina para Informes Interactivos')
,p_lov_return_value=>'IR_ROWS_PER_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(367019127224665540.4001)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Activar Din\00E1mica para Informes Interactivos')
,p_lov_return_value=>'IR_PIVOT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(629252116720996156.4001)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Actualizaciones de los elementos num\00E9ricos, necesarios y del selector de fechas en funci\00F3n de las validaciones condicionales')
,p_lov_return_value=>'ADVANCED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3792189388439.4001)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Convertir Tema Basado en Calendario a Calendario CSS'
,p_lov_return_value=>'CALENDAR_TO_CSS_CALENDAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1595320122944031539.4001)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>unistr('Activar cabeceras de informe fijas en parte superior de la p\00E1gina, para informes interactivos')
,p_lov_return_value=>'IR_FIXED_HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(430765451682359447.4001)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>unistr('Cambiar Versi\00F3n de Pantalla Tabular a Cuadr\00EDcula Interactiva')
,p_lov_return_value=>'TABULAR_TO_IG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1332733641538249759.4001)
,p_lov_disp_sequence=>48
,p_lov_disp_value=>unistr('Actualizar grupos de botones de radio S\00ED/No y seleccionar listas que cambiar')
,p_lov_return_value=>'SWITCH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(180339313137164134.4001)
,p_lov_disp_sequence=>58
,p_lov_disp_value=>unistr('Actualizar la p\00E1gina de pantalla heredada a la p\00E1gina que contenga la pantalla de regi\00F3n, seg\00FAn corresponda')
,p_lov_return_value=>'FORM_REGION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3500993843400161.4001)
,p_lov_disp_sequence=>68
,p_lov_disp_value=>'Actualizar selector de fechas (jQuery) a selector de fechas nuevo'
,p_lov_return_value=>'DATE_PICKER_JET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1120321098982407.4001)
,p_lov_disp_sequence=>78
,p_lov_disp_value=>'Actualizar regiones de calendario a FullCalendar 5'
,p_lov_return_value=>'CSS_CALENDAR_V3_TO_V5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7502547990939218.4001)
,p_lov_disp_sequence=>88
,p_lov_disp_value=>unistr('Actualizar botones para utilizar di\00E1logos de confirmaci\00F3n declarativa en lugar de JavaScript en URL')
,p_lov_return_value=>'BUTTON_CONFIRM_LINK_TO_NATIVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/url_or_page
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84796030957080920.4001)
,p_lov_name=>'URL_OR_PAGE'
,p_lov_query=>'.'||wwv_flow_api.id(84796030957080920.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84796226344080921.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('P\00E1gina en esta Aplicaci\00F3n')
,p_lov_return_value=>'FLOW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84796415445080921.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_editor
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22675300914059322.4001)
,p_lov_name=>'USE EDITOR'
,p_lov_query=>'.'||wwv_flow_api.id(22675300914059322.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22675521873059323.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Usar Editor'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_shared_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(198929422047616235.4001)
,p_lov_name=>'USE SHARED COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(198929422047616235.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198929800039616236.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'COPY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198929605827616235.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'DEFAULT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/user_interfaces
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(5351212231959574.4001)
,p_lov_name=>'USER INTERFACES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.display_name,',
'       i.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/user_interfaces_in_current_app
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(214397326205045090.4001)
,p_lov_name=>'USER INTERFACES (IN CURRENT APP)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''ADD_USER_INTERFACE'') d, 0 r from dual',
'union',
'select i.display_name, t.id ',
'from wwv_flow_ui_types_dev t, wwv_flow_user_interfaces i',
'where i.ui_type_id = t.id',
'and i.flow_id = :fb_flow_id ',
'order by 1',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_cache_before_default
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(86061111625756135.4001)
,p_lov_name=>'USE_CACHE_BEFORE_DEFAULT'
,p_lov_query=>'.'||wwv_flow_api.id(86061111625756135.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88317315070836550.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00F3lo cuando el valor es nulo (de lo contrario, utilice el valor almacenado en cach\00E9)')
,p_lov_return_value=>'YES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88317518565836550.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Del origen cada vez que aparece el elemento.'))
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/values_1_9
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84704207936671347.4001)
,p_lov_name=>'VALUES_1-9'
,p_lov_query=>'.'||wwv_flow_api.id(84704207936671347.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84704402727671348.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84704610060671349.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84704817905671349.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'3'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84705030502671349.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84705211955671349.4001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84705410247671350.4001)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84705606131671350.4001)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'7'
,p_lov_return_value=>'7'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84705812253671350.4001)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84706018237671353.4001)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'9'
,p_lov_return_value=>'9'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_list_or_icons
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(116048926655714272.4001)
,p_lov_name=>'VIEW AS LIST OR ICONS'
,p_lov_query=>'.'||wwv_flow_api.id(116048926655714272.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(116049325234714289.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Iconos'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(131719518320129235.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Detalles'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_list_icon_or_group
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(91143304715922587.4001)
,p_lov_name=>'VIEW AS LIST, ICON, OR GROUP'
,p_lov_query=>'.'||wwv_flow_api.id(91143304715922587.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91143619792922590.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Iconos'
,p_lov_return_value=>'ICON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91143828888922592.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Detalles'
,p_lov_return_value=>'DETAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(91144701861940682.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Por Grupo'
,p_lov_return_value=>'GROUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_page_cache
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(223958418889243758.4001)
,p_lov_name=>'VIEW PAGE CACHE'
,p_lov_query=>'.'||wwv_flow_api.id(223958418889243758.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(223958608319243766.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Todas las P\00E1ginas')
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(223958827202243779.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('P\00E1ginas en Cach\00E9')
,p_lov_return_value=>'CACHED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_tree_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84875324854438753.4001)
,p_lov_name=>'VIEW_AS_TREE_Y'
,p_lov_query=>'.'||wwv_flow_api.id(84875324854438753.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84875508375438754.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Vista de \00C1rbol')
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_services_old
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(92907332256756059.4001)
,p_lov_name=>'WEB SERVICES OLD'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_discovery_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(226025716904355846.4001)
,p_lov_name=>'WEB SOURCE DISCOVERY TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(226025716904355846.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226026440938355847.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTTP simple'
,p_lov_return_value=>'HTTP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226026019836355847.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle REST Data Services'
,p_lov_return_value=>'ORDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(685217609643094733.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Servicio REST de aplicaciones de Oracle Cloud (SaaS)'
,p_lov_return_value=>'ADFBC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1341040228791031.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Infraestructura de Oracle Cloud (OCI)'
,p_lov_return_value=>'OCI'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 18'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_authentication
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460742018651713171.4001)
,p_lov_name=>'WEBSHEET AUTHENTICATION'
,p_reference_id=>444727703759035884.4001
,p_lov_query=>'.'||wwv_flow_api.id(460742018651713171.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484544702053764572.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cuenta de Application Express'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484544926320764580.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Single Sign-On'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484545121410764580.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'LDAP'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1954804012689141259.4001)
,p_lov_disp_sequence=>4.5
,p_lov_disp_value=>'Oracle Cloud Identity Management'
,p_lov_return_value=>'5'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(847804486615311545.4001)
,p_lov_disp_sequence=>4.6
,p_lov_disp_value=>'SAML'
,p_lov_return_value=>'6'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_platform.get_preference(''SAML_ENABLED'')=''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(484545319312764580.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'4'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_export_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(486263618489166258.4001)
,p_lov_name=>'WEBSHEET EXPORT OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(486263618489166258.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486263817119166258.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Datos de Cuadr\00EDcula de Datos')
,p_lov_return_value=>'DATAGRID_DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486264019926166265.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Anotaciones de Cuadr\00EDcula de Datos (archivos, enlaces, notas, etiquetas)')
,p_lov_return_value=>'DATAGRID_ANNOTATIONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(486264204698166265.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>unistr('Anotaciones de P\00E1gina (archivos, notas, etiquetas)')
,p_lov_return_value=>'PAGE_ANNOTATIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_home_page_selector_p933
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460760512122978635.4001)
,p_lov_name=>'WEBSHEET HOME PAGE SELECTOR (P933)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :P933_ID and',
'      security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_name_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(486262710393154460.4001)
,p_lov_name=>'WEBSHEET NAME RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from  WWV_FLOW_WS_APPLICATIONS f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       (',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ',
'             flow_id is null and ',
'             security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ',
'             flow_id = f.id and ',
'             security_group_id = :flow_security_group_id ))',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_reference_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(33398606197612456.4001)
,p_lov_name=>'WEB_REFERENCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(33398606197612456.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33398907058612460.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'REST'
,p_lov_return_value=>'REST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33399114142612461.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Basado en WSDL'
,p_lov_return_value=>'WSDL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(33399327791612461.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Manual'
,p_lov_return_value=>'MANUAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_authent_servers
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(11627272774641932.4001)
,p_lov_name=>'WEB_SOURCE_AUTHENT_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''AUTHENTICATION''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_comp_param_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(358243382603181986.4001)
,p_lov_name=>'WEB_SOURCE_COMP_PARAM_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(358243382603181986.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358243668175182002.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Est\00E1tico')
,p_lov_return_value=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358244096383182004.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Elemento'
,p_lov_return_value=>'ITEM'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1952'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358244479273182005.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Consulta SQL (devolver valor \00FAnico)')
,p_lov_return_value=>'SQL_QUERY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358244886829182005.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>unistr('Expresi\00F3n PL/SQL')
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358245299838182005.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358245602423182006.4001)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Recopilaci\00F3n (CLOB)')
,p_lov_return_value=>'COLLECTION'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1952'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(358246012358182006.4001)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Nulo'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_database_operations
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225834585600778166.4001)
,p_lov_name=>'WEB_SOURCE_DATABASE_OPERATIONS'
,p_lov_query=>'.'||wwv_flow_api.id(225834585600778166.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225834820793778167.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Recuperar filas'
,p_lov_return_value=>'FETCH_COLLECTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225835206083778167.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Recuperar una fila'
,p_lov_return_value=>'FETCH_SINGLE_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225835636769778167.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Insertar Fila'
,p_lov_return_value=>'INSERT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225836011822778168.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Actualizar fila'
,p_lov_return_value=>'UPDATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225836493789778168.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Suprimir fila'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_http_methods
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225847729464891335.4001)
,p_lov_name=>'WEB_SOURCE_HTTP_METHODS'
,p_lov_query=>'.'||wwv_flow_api.id(225847729464891335.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225848018952891335.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'GET'
,p_lov_return_value=>'GET'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225848434282891336.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'POST'
,p_lov_return_value=>'POST'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225848823876891336.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PUT'
,p_lov_return_value=>'PUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225849221328891336.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'DELETE'
,p_lov_return_value=>'DELETE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225849669829891336.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'PATCH'
,p_lov_return_value=>'PATCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_modules
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(529320221428437841.4001)
,p_lov_name=>'WEB_SOURCE_MODULES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id as r',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_module_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1213221291228531.4001)
,p_lov_name=>'WEB_SOURCE_MODULE_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_param_directions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(226101569473456167.4001)
,p_lov_name=>'WEB_SOURCE_PARAM_DIRECTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(226101569473456167.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226101897314456185.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Entrada'
,p_lov_return_value=>'IN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226102209648456186.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Salida'
,p_lov_return_value=>'OUT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226102635196456186.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Entrada/Salida'
,p_lov_return_value=>'IN_OUT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_param_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(226045111811519566.4001)
,p_lov_name=>'WEB_SOURCE_PARAM_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226045498681519566.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cabecera HTTP'
,p_lov_return_value=>'HEADER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(364666922734822564.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cookie HTTP'
,p_lov_return_value=>'COOKIE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226045806403519566.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Variable de patr\00F3n de URL')
,p_lov_return_value=>'URL_PATTERN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226046295199519568.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Variable de cadena de consulta'
,p_lov_return_value=>'QUERY_STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(226046619802519568.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Cuerpo de solicitud/respuesta'
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_remote_servers
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225850679597910405.4001)
,p_lov_name=>'WEB_SOURCE_REMOTE_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''WEB_SERVICE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(225832058197705607.4001)
,p_lov_name=>'WEB_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(225832058197705607.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225832325691705613.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTTP simple'
,p_lov_return_value=>'HTTP_FEED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225832737890705617.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle REST Data Services (sintaxis heredada)'
,p_lov_return_value=>'ORDS_2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(225833124357705617.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Oracle REST Data Services'
,p_lov_return_value=>'ORDS_3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(685218421813102358.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Servicio REST de aplicaciones de Oracle Cloud (SaaS)'
,p_lov_return_value=>'ADFBC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1794465163292936.4001)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Infraestructura de Oracle Cloud (OCI)'
,p_lov_return_value=>'OCI'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 18'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/when_item_or_page_button_pressed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(273753232224499618.4001)
,p_lov_name=>'WHEN.ITEM.OR.PAGE.BUTTON.PRESSED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :FB_FLOW_PAGE_ID',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:FB_FLOW_PAGE_ID, ui.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_adminpage_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(31963614629360602.4001)
,p_lov_name=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31964362200360605.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Crea una nueva p\00E1gina')
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(31964780094360605.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Identificar una p\00E1gina existente')
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_navigationlist_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(925221062390507339.4001)
,p_lov_name=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(925221921118507355.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('No asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n')
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(925221371828507342.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Crear nueva entrada del men\00FA de navegaci\00F3n')
,p_lov_return_value=>'NEW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(925221619952507355.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Identificar una entrada del men\00FA de navegaci\00F3n existente para esta p\00E1gina')
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_tab_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(35310611267199336.4001)
,p_lov_name=>'WIZARD.TAB.OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35310910983199398.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No utilizar separadores'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35311119318199402.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Utilizar un juego de separadores existente y crear un nuevo separador en el juego de separadores existente.'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(35311304949199402.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Utilizar un juego de separadores existente y volver a utilizar un separador existente de ese juego de separadores.'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_page_report_labels
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(152065307451147996.4001)
,p_lov_name=>'WIZARD_PAGE_REPORT_LABELS'
,p_lov_query=>'.'||wwv_flow_api.id(152065307451147996.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152065527589148005.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Elementos de P\00E1gina')
,p_lov_return_value=>'FORM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(152065724052148006.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Columnas de Informe'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_wiz_tab_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84345829981643314.4001)
,p_lov_name=>'WIZ_WIZ_TAB_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(84345829981643314.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84346018173643315.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Utilizar un juego de separadores existente y crear un nuevo separador en el juego de separadores existente.'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84346203959643315.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Utilizar un juego de separadores existente y volver a utilizar un separador existente de ese juego de separadores.'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspace_theme_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(113820707988557953.4001)
,p_lov_name=>'WORKSPACE THEME OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(113820707988557953.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(113820906685557954.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Crear'
,p_lov_return_value=>'CREATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135526931799036577.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Suprimir'
,p_lov_return_value=>'DELETE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  security_group_id = 11 and',
'       THEME_SECURITY_GROUP_ID = :flow_security_group_id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(135608115850230686.4001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Ver Existentes'
,p_lov_return_value=>'VIEW'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  security_group_id = 11 and',
'       THEME_SECURITY_GROUP_ID = :flow_security_group_id'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_acl_privs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(488361730864557325.4001)
,p_lov_name=>'WS_ACL_PRIVS'
,p_reference_id=>451333930142995878.4001
,p_lov_query=>'.'||wwv_flow_api.id(488361730864557325.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(488363300264557359.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lector'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(488363122132557358.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Contribuyente'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(488362909889557358.4001)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Administrador'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_acl_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460746220203713213.4001)
,p_lov_name=>'WS_APP_ACL_TYPE'
,p_reference_id=>450940100671567605.4001
,p_lov_query=>'.'||wwv_flow_api.id(460746220203713213.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(460747302042713218.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Valor por Defecto'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(460747103102713218.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Personalizado'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_admin_user_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1740196320530053227.4001)
,p_lov_name=>'WS_APP_ADMIN_USER_METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(1740196320530053227.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1740197213951053228.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Usar Usuario Existente'
,p_lov_return_value=>'E'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1740197832363053228.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Crear Nuevo Usuario'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_include_getting_started
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1736992503665130556.4001)
,p_lov_name=>'WS_INCLUDE_GETTING_STARTED'
,p_lov_query=>'.'||wwv_flow_api.id(1736992503665130556.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1736992805000130557.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Incluir Gu\00EDa de Introducci\00F3n')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_logo_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461275327966469166.4001)
,p_lov_name=>'WS_LOGO_TYPES'
,p_reference_id=>461278502171499627.4001
,p_lov_query=>'.'||wwv_flow_api.id(461275327966469166.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461280508998501659.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ninguno'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461280730923501659.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Texto'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461280331003501659.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Imagen Cargada'
,p_lov_return_value=>'IMAGE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461280109443501659.4001)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Ruta de Acceso del Archivo'
,p_lov_return_value=>'FILEPATH'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_soap_version
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(439439004288980949.4001)
,p_lov_name=>'WS_SOAP_VERSION'
,p_lov_query=>'.'||wwv_flow_api.id(439439004288980949.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439439222910980951.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1.1'
,p_lov_return_value=>'1.1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(439439430311980951.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'1.2'
,p_lov_return_value=>'1.2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wwv_flow_runtime_api_usage
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(561570937398567414.4001)
,p_lov_name=>'WWV_FLOW-RUNTIME_API_USAGE'
,p_lov_query=>'.'||wwv_flow_api.id(561570937398567414.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561571212445567415.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Modificar Esta Aplicaci\00F3n')
,p_lov_return_value=>'T'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561571509577567417.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modificar Otras Aplicaciones'
,p_lov_return_value=>'O'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(561571812827567417.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Modificar Repositorio de Espacio de Trabajo'
,p_lov_return_value=>'W'
);
end;
/
prompt --application/shared_components/user_interface/lovs/xliff_elements_include
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(102649602892386356.4001)
,p_lov_name=>'XLIFF_ELEMENTS_INCLUDE'
,p_lov_query=>'.'||wwv_flow_api.id(102649602892386356.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(102649911269386359.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Todos los Elementos Traducibles'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(102650132340386359.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('S\00F3lo Elementos que Necesitan Traducci\00F3n')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/xliff_target_include
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(42166827828941188.4001)
,p_lov_name=>'XLIFF_TARGET_INCLUDE'
,p_lov_query=>'.'||wwv_flow_api.id(42166827828941188.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(42167111083941194.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Incluir Elementos de Destino XLIFF'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/xml_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(112611429059992822.4001)
,p_lov_name=>'XML_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(112611429059992822.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112611722136992824.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Datos XML'
,p_lov_return_value=>'XML'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(112611900413992824.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Esquema XML'
,p_lov_return_value=>'XSD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_1_0
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(198612221943560137.4001)
,p_lov_name=>'YES, NO RETURNS 1, 0'
,p_lov_query=>'.'||wwv_flow_api.id(198612221943560137.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198612404411560139.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(198612632486560142.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_subscribe
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(309317735965282153.4001)
,p_lov_name=>'YES.NO.SUBSCRIBE'
,p_lov_query=>'.'||wwv_flow_api.id(309317735965282153.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(309318063170282177.4001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(309318402035282181.4001)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(309318793940282183.4001)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copiar y Suscribir'
,p_lov_return_value=>'SUBSCRIBE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_returns_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84886607679518894.4001)
,p_lov_name=>'YES.RETURNS.Y'
,p_lov_query=>'.'||wwv_flow_api.id(84886607679518894.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84886832024518895.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_n_or_y
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84282932564530536.4001)
,p_lov_name=>'YES_NO_RETURNS_N_OR_Y'
,p_lov_query=>'.'||wwv_flow_api.id(84282932564530536.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84283132061530537.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84283318278530537.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_yes_or_no
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84270019143507704.4001)
,p_lov_name=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov_query=>'.'||wwv_flow_api.id(84270019143507704.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84270401651507705.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'YES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84270215696507704.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_or_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84259319526460470.4001)
,p_lov_name=>'YES_NO_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84259519184460471.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84259724142460471.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(84887415298521126.4001)
,p_lov_name=>'Y_N'
,p_lov_query=>'.'||wwv_flow_api.id(84887415298521126.4001)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84887627279521126.4001)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(84887809648521127.4001)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('S\00ED')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/app_builder_breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(6341600034528019.4001)
,p_name=>'App Builder Breadcrumb'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(799613605926722.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Objetos de Soporte'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
,p_page_id=>2
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(855100382282348.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_page_id=>2100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(869027208612693.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Editar Sustituciones'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(965315472705309.4001)
,p_parent_id=>wwv_flow_api.id(22464532161251314.4001)
,p_short_name=>'Propiedades del Script'
,p_link=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:::'
,p_page_id=>328
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1001331461925880.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>unistr('Validaci\00F3n')
,p_link=>'f?p=&APP_ID.:376:&SESSION.::&DEBUG.:::'
,p_page_id=>376
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1192111495229516.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('Crear Gr\00E1fico')
,p_link=>'f?p=&APP_ID.:616:&SESSION.::&DEBUG.:::'
,p_page_id=>616
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1308911481947279.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'<span class="u-VisuallyHidden">Creador de Aplicaciones</span><span class="a-Icon icon-breadcrumb-previous" title="App Builder"></span>'
,p_link=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
,p_page_id=>1500
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1358650661486623.4001)
,p_parent_id=>wwv_flow_api.id(2549660762513182.4001)
,p_short_name=>unistr('Log de Ejecuci\00F3n')
,p_link=>'f?p=&APP_ID.:7025:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>7025
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1411154832911151.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('C\00F3digo embebido')
,p_link=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:101::'
,p_page_id=>101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1702645656042207.4001)
,p_parent_id=>wwv_flow_api.id(2550040639513183.4001)
,p_short_name=>unistr('Editar Acci\00F3n')
,p_link=>'f?p=&APP_ID.:7022:&SESSION.::&DEBUG.:::'
,p_page_id=>7022
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1805178818697444.4001)
,p_parent_id=>wwv_flow_api.id(15135828644258802.4001)
,p_short_name=>unistr('Detalles de Definici\00F3n de Carga de Datos')
,p_link=>'f?p=&APP_ID.:1820:&SESSION.::&DEBUG.:::'
,p_page_id=>1820
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1901893890995229.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Gestionar copias de seguridad'
,p_link=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:970::'
,p_page_id=>970
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1902075798009204.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Gestionar copias de seguridad'
,p_link=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:971::'
,p_page_id=>971
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1910515857284691.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1911710897286970.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1912706152289134.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1913700761291636.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1915025334295420.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:293:&SESSION.::&DEBUG.:::'
,p_page_id=>293
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1916320158297870.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:::'
,p_page_id=>15
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1917316707299485.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_page_id=>18
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1918313041301140.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:::'
,p_page_id=>24
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1920305277304710.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::'
,p_page_id=>35
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2000951442910272.4001)
,p_parent_id=>wwv_flow_api.id(221168815878138814.4001)
,p_short_name=>unistr('Editar Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:104:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>104
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2034249953651264.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>unistr('Cat\00E1logos de origen de REST')
,p_link=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:::'
,p_page_id=>1960
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2141810057477568.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Utilizaci\00F3n de Elemento de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
,p_page_id=>130
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2305319228274490.4001)
,p_parent_id=>wwv_flow_api.id(680963074297437695.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&APP_ID.:4862:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>4862
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2405460176806715.4001)
,p_parent_id=>wwv_flow_api.id(680963074297437695.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:4863:&SESSION.::&DEBUG.:::'
,p_page_id=>4863
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2549660762513182.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Automatizaciones'
,p_link=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.:::'
,p_page_id=>7020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2550040639513183.4001)
,p_parent_id=>wwv_flow_api.id(2549660762513182.4001)
,p_short_name=>'&P7021_NAME.'
,p_link=>'f?p=&APP_ID.:7021:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>7021
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2601704129770062.4001)
,p_parent_id=>wwv_flow_api.id(4789520415461435.4001)
,p_short_name=>'Paquete de datos'
,p_link=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:::'
,p_page_id=>6000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2788029629984590.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Valores por Defecto del Creador de Aplicaciones'
,p_link=>'f?p=&APP_ID.:800:&SESSION.::&DEBUG.:::'
,p_page_id=>800
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2801449870741965.4001)
,p_parent_id=>wwv_flow_api.id(4789520415461435.4001)
,p_short_name=>'Paquete de datos'
,p_link=>'f?p=&APP_ID.:6001:&SESSION.::&DEBUG.:::'
,p_page_id=>6001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2821803379590494.4001)
,p_parent_id=>wwv_flow_api.id(492636106117616338.4001)
,p_short_name=>unistr('Suprimir Varias P\00E1ginas')
,p_link=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.:::'
,p_page_id=>339
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3007099013503414.4001)
,p_parent_id=>wwv_flow_api.id(45432327870093655.4001)
,p_short_name=>'Servidor de despliegue remoto'
,p_link=>'f?p=&APP_ID.:4905:&SESSION.'
,p_page_id=>4905
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3125161068266187.4001)
,p_parent_id=>wwv_flow_api.id(2034249953651264.4001)
,p_short_name=>'&P1963_CATALOG_NAME.'
,p_link=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.:::'
,p_page_id=>1963
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3201123196120267.4001)
,p_parent_id=>wwv_flow_api.id(15135828644258802.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&APP_ID.:1821:&SESSION.::&DEBUG.:::'
,p_page_id=>1821
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3206923152925971.4001)
,p_parent_id=>wwv_flow_api.id(3125161068266187.4001)
,p_short_name=>'&P1964_NAME.'
,p_link=>'f?p=&APP_ID.:1964:&SESSION.::&DEBUG.:::'
,p_page_id=>1964
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3237531197294662.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina: Confirmaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:698:&SESSION.'
,p_page_id=>698
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3320654420728496.4001)
,p_parent_id=>wwv_flow_api.id(45432327870093655.4001)
,p_short_name=>'Opciones de despliegue remoto'
,p_link=>'f?p=&APP_ID.:4906:&SESSION.'
,p_page_id=>4906
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3600249891202556.4001)
,p_parent_id=>wwv_flow_api.id(1358650661486623.4001)
,p_short_name=>'Mensajes'
,p_link=>'f?p=&APP_ID.:7026:&SESSION.::&DEBUG.:::'
,p_page_id=>7026
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3691700327027879.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:::'
,p_page_id=>80
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3746494644600815.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:::'
,p_page_id=>1965
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3800905874609467.4001)
,p_parent_id=>wwv_flow_api.id(3600263368521940.4001)
,p_short_name=>'Editar Archivo'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''PLUGIN'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3801388702626905.4001)
,p_parent_id=>wwv_flow_api.id(6490322331050183.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''APP'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3801648445638850.4001)
,p_parent_id=>wwv_flow_api.id(26484923558914183.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''WORKSPACE'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3802125115659448.4001)
,p_parent_id=>wwv_flow_api.id(3803609664693374.4001)
,p_short_name=>'Editar Archivo'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''THEME'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3818189874234693.4001)
,p_parent_id=>wwv_flow_api.id(2034249953651264.4001)
,p_short_name=>unistr('Grupos de cat\00E1logo de REST')
,p_link=>'f?p=&APP_ID.:1968:&SESSION.::&DEBUG.:RP,1968::'
,p_page_id=>1968
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4026476214335011.4001)
,p_parent_id=>wwv_flow_api.id(45432327870093655.4001)
,p_short_name=>unistr('Importar cat\00E1logo REST')
,p_link=>'f?p=&APP_ID.:1966:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1966
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4522303667073067.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Utilidades de Acciones Din\00E1micas')
,p_link=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.:::'
,p_page_id=>699
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4523532407080682.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Copiar Acci\00F3n Din\00E1mica')
,p_link=>'f?p=&FLOW_ID.:728:&SESSION.'
,p_page_id=>728
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4700862005838378.4001)
,p_parent_id=>wwv_flow_api.id(225892393724191781.4001)
,p_short_name=>unistr('Sincronizaci\00F3n')
,p_link=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:::'
,p_page_id=>1951
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4788028610457659.4001)
,p_parent_id=>wwv_flow_api.id(22464532161251314.4001)
,p_short_name=>'Editor de Script'
,p_link=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:::'
,p_page_id=>865
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4789520415461435.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Crear Script'
,p_link=>'f?p=&FLOW_ID.:850:&SESSION.'
,p_page_id=>850
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4791400358470727.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Crear Script'
,p_link=>'f?p=&FLOW_ID.:855:&SESSION.'
,p_page_id=>855
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4794822343475771.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Crear Script'
,p_link=>'f?p=&FLOW_ID.:857:&SESSION.'
,p_page_id=>857
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5001582690003326.4001)
,p_parent_id=>wwv_flow_api.id(2549660762513182.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:7027:&SESSION.::&DEBUG.:::'
,p_page_id=>7027
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5443523467188014.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:4716:&SESSION.'
,p_page_id=>4716
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6069927502983470.4001)
,p_parent_id=>wwv_flow_api.id(6349507415570925.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:186:&SESSION.::&DEBUG.:::'
,p_page_id=>186
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6342315964532655.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Aplicaci\00F3n &FB_FLOW_ID.')
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&FB_FLOW_ID.'
,p_page_id=>1
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6346400957558726.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Regiones'
,p_link=>'f?p=&APP_ID.:4650:&SESSION.::&DEBUG.:::'
,p_page_id=>4650
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6348417766566072.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Plantillas'
,p_link=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_page_id=>4003
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6349507415570925.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_link=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:::'
,p_page_id=>4070
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6350702023573393.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Referencias de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:170:&SESSION.::&DEBUG.:::'
,p_page_id=>170
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6351829184575999.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('M\00E9todos Abreviados')
,p_link=>'f?p=&FLOW_ID.:4047:&SESSION.::&DEBUG.:::'
,p_page_id=>4047
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6355112362583811.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('\00C1rboles')
,p_link=>'f?p=&FLOW_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6356205677586897.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Listas de Valores'
,p_link=>'f?p=&FLOW_ID.:4110:&SESSION.::&DEBUG.:::'
,p_page_id=>4110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6357300501589343.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Separadores'
,p_link=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
,p_page_id=>9000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6358428525591525.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Entradas de Barra de Navegaci\00F3n Cl\00E1sicas')
,p_link=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.:::'
,p_page_id=>4005
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6359523564593791.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.:::'
,p_page_id=>4101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6360618820595993.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Elementos de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:::'
,p_page_id=>4100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6361712997598750.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Procesos de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.:::'
,p_page_id=>4207
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6362806096601891.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina')
,p_link=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:::'
,p_page_id=>4700
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6367802417618817.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina')
,p_link=>'f?p=&APP_ID.:4714:&SESSION.::&DEBUG.:::'
,p_page_id=>4714
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6386406453692928.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Editar Separador Principal'
,p_link=>'f?p=&FLOW_ID.:4318:&SESSION.'
,p_page_id=>4318
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6395029707727734.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:::'
,p_page_id=>4111
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6396317415733372.4001)
,p_parent_id=>wwv_flow_api.id(6395029707727734.4001)
,p_short_name=>'Entrada'
,p_link=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:::'
,p_page_id=>4113
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6399720422747215.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Elemento'
,p_link=>'f?p=&APP_ID.:4721:&SESSION.::&DEBUG.:::'
,p_page_id=>4721
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6401513642581053.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Cambiar Lista'
,p_long_name=>'Cambiar Lista'
,p_link=>'f?p=&APP_ID.:4053:&SESSION.::&DEBUG.:::'
,p_page_id=>4053
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6403032486756853.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:::'
,p_page_id=>56
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6419208930828506.4001)
,p_parent_id=>wwv_flow_api.id(492636106117616338.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Todas las P\00E1ginas')
,p_link=>'f?p=&APP_ID.:243:&SESSION.::&DEBUG.:::'
,p_page_id=>243
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6422722720837321.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Sustituir Plantillas'
,p_link=>'f?p=&FLOW_ID.:220:&SESSION.'
,p_page_id=>220
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6423910643842876.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Sustituir Plantillas'
,p_link=>'f?p=&APP_ID.:222:&SESSION.::&DEBUG.:::'
,p_page_id=>222
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6424804389845860.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:263:&SESSION.::&DEBUG.:::'
,p_page_id=>263
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6425831765848304.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:264:&SESSION.::&DEBUG.:::'
,p_page_id=>264
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6426726589850683.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:286:&SESSION.::&DEBUG.:::'
,p_page_id=>286
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6431810187873541.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Botones'
,p_link=>'f?p=&FLOW_ID.:4203:&SESSION.'
,p_page_id=>4203
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6432905873875539.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Elementos de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:4200:&SESSION.'
,p_page_id=>4200
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6434032172878572.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('C\00E1lculos')
,p_link=>'f?p=&APP_ID.:4204:&SESSION.::&DEBUG.:::'
,p_page_id=>4204
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6437409527889066.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Validaciones'
,p_link=>'f?p=&APP_ID.:4205:&SESSION.::&DEBUG.:::'
,p_page_id=>4205
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6438900038893444.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Procesos de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:4201:&SESSION.'
,p_page_id=>4201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6440026552896363.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Bifurcaciones'
,p_link=>'f?p=&FLOW_ID.:4202:&SESSION.::&DEBUG.:::'
,p_page_id=>4202
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6441213828902170.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.:::'
,p_page_id=>4308
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6443000457908410.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_link=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.:::'
,p_page_id=>153
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6444819423914788.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4051:&SESSION.::&DEBUG.:::'
,p_page_id=>4051
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6448120058929726.4001)
,p_parent_id=>wwv_flow_api.id(6351829184575999.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4048:&SESSION.::&DEBUG.:::'
,p_page_id=>4048
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6449609059934771.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:196:&SESSION.::&DEBUG.:::'
,p_page_id=>196
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6450831044939823.4001)
,p_parent_id=>wwv_flow_api.id(6361712997598750.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:::'
,p_page_id=>147
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6452120045944932.4001)
,p_parent_id=>wwv_flow_api.id(6360618820595993.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:::'
,p_page_id=>4303
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6453707968950476.4001)
,p_parent_id=>wwv_flow_api.id(6359523564593791.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:::'
,p_page_id=>4304
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6456718523960790.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_page_id=>22
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6458403858967582.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:4708:&SESSION.::&DEBUG.:::'
,p_page_id=>4708
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6459729510970921.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Crear Pantalla Basada en Procedimiento'
,p_link=>'f?p=&APP_ID.:4711:&SESSION.::&DEBUG.:::'
,p_page_id=>4711
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6462116139977149.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4703:&SESSION.::&DEBUG.:::'
,p_page_id=>4703
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6464801042984164.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Origen de Regi\00F3n de Consulta SQL')
,p_link=>'f?p=&APP_ID.:247:&SESSION.::&DEBUG.:::'
,p_page_id=>247
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6466027772986895.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla Basada en Consulta'
,p_link=>'f?p=&APP_ID.:4810:&SESSION.::&DEBUG.:::'
,p_page_id=>4810
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6467323027989165.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>unistr('P\00E1gina de Resumen')
,p_link=>'f?p=&FLOW_ID.:5100:&SESSION.::&DEBUG.:::'
,p_page_id=>5100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6472201246999222.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Calendario'
,p_link=>'f?p=&FLOW_ID.:4785:&SESSION.::&DEBUG.:::'
,p_page_id=>4785
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6473526034002921.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Asistente'
,p_link=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:::'
,p_page_id=>107
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6474917408006959.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('\00C1rbol')
,p_link=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:::'
,p_page_id=>112
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6476306193012140.4001)
,p_parent_id=>wwv_flow_api.id(6349507415570925.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:::'
,p_page_id=>4008
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6478220630020590.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Editar Definici\00F3n de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:::'
,p_page_id=>4001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6479907044026887.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:::'
,p_page_id=>4900
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6481002299029073.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Traducir'
,p_link=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
,p_page_id=>4761
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6482129244031803.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>'Mensajes de Texto'
,p_link=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.:::'
,p_page_id=>4006
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6483519971036105.4001)
,p_parent_id=>wwv_flow_api.id(6482129244031803.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:::'
,p_page_id=>4009
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6490322331050183.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
,p_link=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.'
,p_page_id=>40
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6491917155052610.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Opciones de Creaci\00F3n')
,p_link=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:::'
,p_page_id=>4910
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6495901843059687.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Editar Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:4307:&SESSION.'
,p_page_id=>4307
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6499020162066439.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Editar Plantilla de Regi\00F3n')
,p_link=>'f?p=&FLOW_ID.:4653:&SESSION.'
,p_page_id=>4653
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6504200753075396.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:258:&SESSION.'
,p_page_id=>258
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6506517346082898.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Lista'
,p_link=>'f?p=&FLOW_ID.:4655:&SESSION.'
,p_page_id=>4655
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6515503938134714.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Listas de Valores, Editar Texto Nulo'
,p_link=>'f?p=&APP_ID.:169:&SESSION.::&DEBUG.:::'
,p_page_id=>169
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6527917703173888.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Lista de Valores Emergente'
,p_link=>'f?p=&APP_ID.:251:&SESSION.::&DEBUG.:::'
,p_page_id=>251
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6529805411179605.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Editar Plantilla de Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:204:&SESSION.'
,p_page_id=>204
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6532523945186178.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Etiqueta'
,p_link=>'f?p=&FLOW_ID.:85:&SESSION.'
,p_page_id=>85
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6534205183194898.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:4654:&SESSION.'
,p_page_id=>4654
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6537319404203528.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Vista Previa de Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:4029:&SESSION.'
,p_page_id=>4029
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6550329946228991.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Uso de Plantilla'
,p_link=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:::'
,p_page_id=>4656
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6551625202231243.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Suscripci\00F3n de Plantilla')
,p_link=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::'
,p_page_id=>124
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6554908596238944.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Uso de Separadores'
,p_link=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:::'
,p_page_id=>200
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6556700185242813.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Editar Juego de Separadores por P\00E1gina')
,p_link=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:::'
,p_page_id=>77
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6558424327246804.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Editar Separadores Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:123:&SESSION.::&DEBUG.:::'
,p_page_id=>123
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6562100389257933.4001)
,p_parent_id=>wwv_flow_api.id(450480426634467558.4001)
,p_short_name=>unistr('Editar Separador Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:4305:&SESSION.::&DEBUG.:::'
,p_page_id=>4305
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6564718492264726.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Suscripci\00F3n de Lista de Valores')
,p_link=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:::'
,p_page_id=>142
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6567501873287658.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:901:&SESSION.::&DEBUG.:::'
,p_page_id=>901
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6579019533309819.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:920:&SESSION.'
,p_page_id=>920
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6580511985313322.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:951:&SESSION.'
,p_page_id=>951
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6581706809315674.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Lista'
,p_link=>'f?p=&FLOW_ID.:931:&SESSION.'
,p_page_id=>931
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6583001202318295.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Etiqueta'
,p_link=>'f?p=&FLOW_ID.:941:&SESSION.'
,p_page_id=>941
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6584223618323157.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:238:&SESSION.::&DEBUG.:::'
,p_page_id=>238
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6592504843346989.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_link=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.:::'
,p_page_id=>145
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6594228985351058.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Uso de Lista'
,p_link=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:::'
,p_page_id=>156
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6603923150368917.4001)
,p_parent_id=>wwv_flow_api.id(6355112362583811.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6613125713398111.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Suscripci\00F3n de M\00E9todo Abreviado')
,p_link=>'f?p=&APP_ID.:175:&SESSION.::&DEBUG.:::'
,p_page_id=>175
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6617305441407485.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:90:&SESSION.'
,p_page_id=>90
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6618930661411032.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Crear Separador Principal'
,p_link=>'f?p=&FLOW_ID.:4725:&SESSION.'
,p_page_id=>4725
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6626722681414758.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>unistr('Exportaci\00F3n de XLIFF')
,p_link=>'f?p=&FLOW_ID.:4750:&SESSION.'
,p_page_id=>4750
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6629708879421074.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>'Asignaciones de Idioma'
,p_link=>'f?p=&APP_ID.:4751:&SESSION.::&DEBUG.:::'
,p_page_id=>4751
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6632530217426427.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>unistr('Traducciones Din\00E1micas')
,p_link=>'f?p=&FLOW_ID.:4756:&SESSION.'
,p_page_id=>4756
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6656111405495930.4001)
,p_parent_id=>wwv_flow_api.id(6491917155052610.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:::'
,p_page_id=>4911
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6658800838500771.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Uso de Opci\00F3n de Creaci\00F3n')
,p_link=>'f?p=&APP_ID.:203:&SESSION.::&DEBUG.:::'
,p_page_id=>203
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6661610099511746.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Repositorio de Exportaci\00F3n')
,p_link=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_page_id=>73
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6662704276514381.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:::'
,p_page_id=>76
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6683703949651360.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Confirmar Publicaci\00F3n de Componente')
,p_link=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_page_id=>149
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6715210092785244.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n')
,p_link=>'f?p=&FLOW_ID.:20:&SESSION.'
,p_page_id=>20
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6735531807989290.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Componentes Compartidos'
,p_link=>'f?p=&FLOW_ID.:9:&SESSION.'
,p_page_id=>9
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6795302837254265.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Detalles de Lista'
,p_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
,p_page_id=>4050
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6911427546266971.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4320:&SESSION.::&DEBUG.:::'
,p_page_id=>4320
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(6914203177278186.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:144:&SESSION.'
,p_page_id=>144
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7002213940754247.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Esquemas de Autenticaci\00F3n')
,p_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_page_id=>801
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7008224141803165.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Suscripci\00F3n de Esquema de Autenticaci\00F3n')
,p_link=>'f?p=&APP_ID.:817:&SESSION.::&DEBUG.:::'
,p_page_id=>817
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7010702360813269.4001)
,p_parent_id=>wwv_flow_api.id(7002213940754247.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.:::'
,p_page_id=>816
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7011929736815673.4001)
,p_parent_id=>wwv_flow_api.id(7002213940754247.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:::'
,p_page_id=>815
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7037014806883404.4001)
,p_parent_id=>wwv_flow_api.id(7002213940754247.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:::'
,p_page_id=>4495
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7044908059962472.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Suscripci\00F3n de Entrada de Barra de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7080421195245074.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:4321:&SESSION.'
,p_page_id=>4321
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7081514725248136.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:168:&SESSION.'
,p_page_id=>168
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7152101514588506.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Crear Separador Principal'
,p_link=>'f?p=&FLOW_ID.:4726:&SESSION.::&DEBUG.:::'
,p_page_id=>4726
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7154823930593293.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Crear Separador Principal'
,p_link=>'f?p=&FLOW_ID.:4727:&SESSION.::&DEBUG.:::'
,p_page_id=>4727
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7161412703613679.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:96:&SESSION.::&DEBUG.:::'
,p_page_id=>96
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7163206881616420.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:4722:&SESSION.::&DEBUG.:::'
,p_page_id=>4722
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7164601489618915.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:4723:&SESSION.::&DEBUG.:::'
,p_page_id=>4723
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7166328003621815.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:4724:&SESSION.::&DEBUG.:::'
,p_page_id=>4724
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7168518514626247.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_page_id=>92
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7178316764657376.4001)
,p_parent_id=>wwv_flow_api.id(83259325931667653.4001)
,p_short_name=>'Extraer Ayuda de Elemento'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7188708341676529.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'&P4041_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4041:&SESSION.::&DEBUG.:::'
,p_page_id=>4041
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7191825797683623.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4775:&SESSION.::&DEBUG.:::'
,p_page_id=>4775
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7193221268685688.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Pantalla e Informe'
,p_link=>'f?p=&APP_ID.:4778:&SESSION.::&DEBUG.:::'
,p_page_id=>4778
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7195514798688693.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4039:&SESSION.::&DEBUG.:::'
,p_page_id=>4039
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7199632470695744.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4776:&SESSION.::&DEBUG.:::'
,p_page_id=>4776
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7201126431698544.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4777:&SESSION.::&DEBUG.:::'
,p_page_id=>4777
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7202421040701003.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4783:&SESSION.::&DEBUG.:::'
,p_page_id=>4783
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7204213923704318.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:296:&SESSION.::&DEBUG.:::'
,p_page_id=>296
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7344218375857109.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Uso de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:365:&SESSION.::&DEBUG.:::'
,p_page_id=>365
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7353730606927328.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar Regi\00F3n')
,p_link=>'f?p=&FLOW_ID.:195:&SESSION.::&DEBUG.:::'
,p_page_id=>195
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7354622842930948.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar Regi\00F3n')
,p_link=>'f?p=&FLOW_ID.:194:&SESSION.::&DEBUG.:::'
,p_page_id=>194
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7356901276940875.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Copiar Elemento'
,p_link=>'f?p=&APP_ID.:171:&SESSION.::&DEBUG.:::'
,p_page_id=>171
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7358027359944057.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Copiar Elemento'
,p_link=>'f?p=&APP_ID.:172:&SESSION.::&DEBUG.:::'
,p_page_id=>172
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7408431450215623.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:231:&SESSION.::&DEBUG.:::'
,p_page_id=>231
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7409526921217764.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:191:&SESSION.::&DEBUG.:::'
,p_page_id=>191
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7415405761257899.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:4713:&SESSION.::&DEBUG.:::'
,p_page_id=>4713
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7416532275260839.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:4771:&SESSION.::&DEBUG.:::'
,p_page_id=>4771
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7418722570265291.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:4772:&SESSION.::&DEBUG.:::'
,p_page_id=>4772
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7419816963267952.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:4773:&SESSION.::&DEBUG.:::'
,p_page_id=>4773
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7420910493270877.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:255:&SESSION.::&DEBUG.:::'
,p_page_id=>255
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7432727672354081.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Plantillas'
,p_link=>'f?p=&APP_ID.:368:&SESSION.::&DEBUG.:::'
,p_page_id=>368
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7451619366494706.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Rutas de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:369:&SESSION.::&DEBUG.:::'
,p_page_id=>369
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7471411863672817.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Atributos de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.:::'
,p_page_id=>249
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7472506903675102.4001)
,p_parent_id=>wwv_flow_api.id(193782110098056426.4001)
,p_short_name=>'Editar Etiquetas de Botones'
,p_link=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:::'
,p_page_id=>250
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7478909047689311.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Procedimiento'
,p_link=>'f?p=&APP_ID.:4705:&SESSION.::&DEBUG.:::'
,p_page_id=>4705
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7491427569711076.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Pantalla Basada en Consulta'
,p_link=>'f?p=&APP_ID.:4811:&SESSION.::&DEBUG.:::'
,p_page_id=>4811
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7493719590714867.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Pantalla Basada en Consulta'
,p_link=>'f?p=&APP_ID.:4812:&SESSION.::&DEBUG.:::'
,p_page_id=>4812
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7496910317719139.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Pantalla Basada en Consulta'
,p_link=>'f?p=&APP_ID.:272:&SESSION.::&DEBUG.:::'
,p_page_id=>272
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7499828635725844.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>unistr('P\00E1gina de Resumen')
,p_link=>'f?p=&FLOW_ID.:5105:&SESSION.::&DEBUG.:::'
,p_page_id=>5105
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7501423244728309.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>unistr('P\00E1gina de Resumen')
,p_link=>'f?p=&FLOW_ID.:5110:&SESSION.::&DEBUG.:::'
,p_page_id=>5110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7503017637730875.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>unistr('P\00E1gina de Resumen')
,p_link=>'f?p=&FLOW_ID.:303:&SESSION.::&DEBUG.:::'
,p_page_id=>303
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7520013730763123.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Calendario'
,p_link=>'f?p=&FLOW_ID.:4790:&SESSION.::&DEBUG.:::'
,p_page_id=>4790
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7521309417765117.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Calendario'
,p_link=>'f?p=&FLOW_ID.:4791:&SESSION.::&DEBUG.:::'
,p_page_id=>4791
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7530906817781560.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Calendario'
,p_link=>'f?p=&FLOW_ID.:281:&SESSION.::&DEBUG.:::'
,p_page_id=>281
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7536418666791260.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Asistente'
,p_link=>'f?p=&APP_ID.:108:&SESSION.::&DEBUG.:::'
,p_page_id=>108
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7545710674810131.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('\00C1rbol')
,p_link=>'f?p=&APP_ID.:114:&SESSION.::&DEBUG.:::'
,p_page_id=>114
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7547901400814447.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('\00C1rbol')
,p_link=>'f?p=&APP_ID.:116:&SESSION.::&DEBUG.:::'
,p_page_id=>116
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7549029855816447.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('\00C1rbol')
,p_link=>'f?p=&APP_ID.:126:&SESSION.::&DEBUG.:::'
,p_page_id=>126
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7552317131822339.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('\00C1rbol')
,p_link=>'f?p=&APP_ID.:284:&SESSION.::&DEBUG.:::'
,p_page_id=>284
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7664420265391505.4001)
,p_parent_id=>wwv_flow_api.id(221168815878138814.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:288:&SESSION.::&DEBUG.:::'
,p_page_id=>288
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7665912286395269.4001)
,p_parent_id=>wwv_flow_api.id(6351829184575999.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7667003659399234.4001)
,p_parent_id=>wwv_flow_api.id(6351829184575999.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:174:&SESSION.::&DEBUG.:::'
,p_page_id=>174
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7832105639591954.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::'
,p_page_id=>201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7914701005989088.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:::'
,p_page_id=>137
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7915827303992094.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4004:&SESSION.::&DEBUG.:::'
,p_page_id=>4004
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7916921696994671.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4014:&SESSION.::&DEBUG.:::'
,p_page_id=>4014
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7919430957005615.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4023:&SESSION.::&DEBUG.:::'
,p_page_id=>4023
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7920525781008029.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4024:&SESSION.::&DEBUG.:::'
,p_page_id=>4024
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7921621468010029.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4025:&SESSION.::&DEBUG.:::'
,p_page_id=>4025
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7923014567013198.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:134:&SESSION.::&DEBUG.:::'
,p_page_id=>134
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(7924110469015106.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.:::'
,p_page_id=>135
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8075321485195951.4001)
,p_parent_id=>wwv_flow_api.id(6351829184575999.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:::'
,p_page_id=>132
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8077714369199249.4001)
,p_parent_id=>wwv_flow_api.id(6351829184575999.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:::'
,p_page_id=>133
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8079505311203450.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:211:&SESSION.::&DEBUG.:::'
,p_page_id=>211
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8083124924209514.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:218:&SESSION.::&DEBUG.:::'
,p_page_id=>218
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8084520395211660.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:219:&SESSION.::&DEBUG.:::'
,p_page_id=>219
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8086011121215923.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:223:&SESSION.::&DEBUG.:::'
,p_page_id=>223
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8106615841244156.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Lista'
,p_link=>'f?p=&FLOW_ID.:4069:&SESSION.'
,p_page_id=>4069
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8108013253245302.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Lista'
,p_link=>'f?p=&FLOW_ID.:159:&SESSION.'
,p_page_id=>159
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8118716260259107.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:26:&SESSION.'
,p_page_id=>26
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8128628109268771.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:158:&SESSION.::&DEBUG.:::'
,p_page_id=>158
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8131420777272255.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:955:&SESSION.'
,p_page_id=>955
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8259502568660499.4001)
,p_parent_id=>wwv_flow_api.id(6629708879421074.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4754:&SESSION.::&DEBUG.:::'
,p_page_id=>4754
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8277523018696647.4001)
,p_parent_id=>wwv_flow_api.id(6632530217426427.4001)
,p_short_name=>unistr('Crear/Editar Traducci\00F3n Din\00E1mica')
,p_link=>'f?p=&APP_ID.:4757:&SESSION.::&DEBUG.:::'
,p_page_id=>4757
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8303409826748280.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Uso de \00C1rbol')
,p_link=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:::'
,p_page_id=>202
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8352524348299917.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:79:&SESSION.::&DEBUG.:::'
,p_page_id=>79
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8602403040190431.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Esquemas de Autorizaci\00F3n por Componente')
,p_link=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:::'
,p_page_id=>340
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8641230102314695.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Mensajes de Objetos de Soporte'
,p_link=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.:::'
,p_page_id=>567
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(8711816389536515.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>'Control de Acceso'
,p_link=>'f?p=&APP_ID.:572:&SESSION.::&DEBUG.:::'
,p_page_id=>572
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9594412395161749.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Cach\00E9')
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9744321690510681.4001)
,p_parent_id=>wwv_flow_api.id(7002213940754247.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:818:&SESSION.::&DEBUG.:::'
,p_page_id=>818
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9761223545616180.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Suscripci\00F3n de Esquema de Autorizaci\00F3n')
,p_link=>'f?p=&APP_ID.:129:&SESSION.::&DEBUG.:::'
,p_page_id=>129
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9763216644619430.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Uso de Esquema de Autorizaci\00F3n')
,p_link=>'f?p=&APP_ID.:4045:&SESSION.::&DEBUG.:::'
,p_page_id=>4045
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9766004998624840.4001)
,p_parent_id=>wwv_flow_api.id(6349507415570925.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:::'
,p_page_id=>184
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9767400685626788.4001)
,p_parent_id=>wwv_flow_api.id(6349507415570925.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:188:&SESSION.::&DEBUG.:::'
,p_page_id=>188
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9769129787628491.4001)
,p_parent_id=>wwv_flow_api.id(6349507415570925.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:185:&SESSION.::&DEBUG.:::'
,p_page_id=>185
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(9966712969094387.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Requisitos'
,p_link=>'f?p=&APP_ID.:631:&SESSION.::&DEBUG.:::'
,p_page_id=>631
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10077912702550901.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Entradas de Barra de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:394:&SESSION.::&DEBUG.:::'
,p_page_id=>394
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10171012622051760.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Eliminar Todos los Objetos de Soporte'
,p_link=>'f?p=&APP_ID.:632:&SESSION.::&DEBUG.:::'
,p_page_id=>632
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10195213589188051.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>unistr('Estado de Exportaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:633:&SESSION.'
,p_page_id=>633
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10236303196165887.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:21:&SESSION.'
,p_page_id=>21
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10267803313287401.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Rutas de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10357129571342417.4001)
,p_parent_id=>wwv_flow_api.id(193915914105228860.4001)
,p_short_name=>'Editar Etiquetas de Elemento'
,p_link=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:::'
,p_page_id=>6
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10536107887762771.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:93:&SESSION.'
,p_page_id=>93
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10538801849765550.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:94:&SESSION.::&DEBUG.:::'
,p_page_id=>94
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10540331597766939.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Crear Separador Est\00E1ndar')
,p_link=>'f?p=&FLOW_ID.:95:&SESSION.::&DEBUG.:::'
,p_page_id=>95
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10597823088892387.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Crear '
,p_link=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:::'
,p_page_id=>138
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10599019637894058.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.:::'
,p_page_id=>139
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10604820056908970.4001)
,p_parent_id=>wwv_flow_api.id(6361712997598750.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:::'
,p_page_id=>148
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10609306901915170.4001)
,p_parent_id=>wwv_flow_api.id(6361712997598750.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::'
,p_page_id=>150
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10621115084926482.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:154:&SESSION.::&DEBUG.:::'
,p_page_id=>154
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10645411621943305.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Importar'
,p_link=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_page_id=>163
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10647309248944370.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Exportar P\00E1gina')
,p_link=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.:::'
,p_page_id=>164
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10654722176953591.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Listas de Valores')
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>178
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10679727343314460.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&FLOW_ID.:105:&SESSION.'
,p_page_id=>105
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10681004612431355.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&FLOW_ID.:464:&SESSION.'
,p_page_id=>464
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10735320290151987.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Pruebas'
,p_link=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.:::'
,p_page_id=>226
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10748931048177465.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:240:&SESSION.::&DEBUG.:::'
,p_page_id=>240
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10750825657179959.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:241:&SESSION.::&DEBUG.:::'
,p_page_id=>241
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10752121775181753.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:242:&SESSION.::&DEBUG.:::'
,p_page_id=>242
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10768230808207960.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Calendario'
,p_link=>'f?p=&APP_ID.:282:&SESSION.::&DEBUG.:::'
,p_page_id=>282
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10770012383068687.4001)
,p_parent_id=>wwv_flow_api.id(3320654420728496.4001)
,p_short_name=>'Despliegue remoto correcto'
,p_link=>'f?p=&APP_ID.:4907:&SESSION.'
,p_page_id=>4907
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10985516388385355.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de M\00E9todos Abreviados')
,p_link=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:::'
,p_page_id=>41
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(10993710960433463.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Procesos de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11011406560541853.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de C\00E1lculos de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11020231921636428.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Listas'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11041108796707910.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de \00C1rboles')
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11160403095007768.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Separadores'
,p_link=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::'
,p_page_id=>58
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11194603230372300.4001)
,p_parent_id=>wwv_flow_api.id(7002213940754247.4001)
,p_short_name=>unistr('Confirmar Publicaci\00F3n de Esquema')
,p_link=>'f?p=&APP_ID.:821:&SESSION.::&DEBUG.:::'
,p_page_id=>821
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11228126661984416.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Historial de Regiones'
,p_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_page_id=>60
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11254230851134407.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Historial de Botones'
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11268606598267240.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Historial de Elementos de P\00E1gina')
,p_link=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:::'
,p_page_id=>62
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11281004620313756.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Referencias de Servicio Web'
,p_link=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
,p_page_id=>63
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11292413197370563.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Historial de Bifurcaciones'
,p_link=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:::'
,p_page_id=>64
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11314228718673680.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_page_id=>2103
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11315821157692395.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_page_id=>2102
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11318304336700174.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::'
,p_page_id=>2104
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11333517694709200.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2105:&SESSION.::&DEBUG.:::'
,p_page_id=>2105
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11339503991557114.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Historial de Procesos de P\00E1gina')
,p_link=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:::'
,p_page_id=>65
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11342913252567976.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Historial de Validaciones'
,p_link=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_page_id=>66
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11429006112436881.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&FLOW_ID.:734:&SESSION.'
,p_page_id=>734
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11539704173277683.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Consultas de Informe'
,p_link=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_page_id=>1100
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(11654121930393742.4001)
,p_parent_id=>wwv_flow_api.id(855100382282348.4001)
,p_short_name=>'Error'
,p_link=>'f?p=&FLOW_ID.:2115:&SESSION.'
,p_page_id=>2115
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13557905417023023.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2107:&SESSION.'
,p_page_id=>2107
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13602017599154121.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2101:&SESSION.'
,p_page_id=>2101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13769708611662541.4001)
,p_parent_id=>wwv_flow_api.id(11315821157692395.4001)
,p_short_name=>'Error'
,p_link=>'f?p=&FLOW_ID.:2108:&SESSION.'
,p_page_id=>2108
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13844100310061418.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Resumen de Instalaci\00F3n')
,p_link=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:::'
,p_page_id=>2106
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13918029879549172.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Desinstalar'
,p_link=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:::'
,p_page_id=>2110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(13920032011578513.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Desinstalar'
,p_link=>'f?p=&APP_ID.:2111:&SESSION.::&DEBUG.:::'
,p_page_id=>2111
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14800472336097080.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Crear Nuevo Principal de Entradas de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:::'
,p_page_id=>106
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14890017142621948.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Valores de Componente'
,p_link=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:::'
,p_page_id=>4445
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14923413480797232.4001)
,p_parent_id=>wwv_flow_api.id(14890017142621948.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4446:&SESSION.'
,p_page_id=>4446
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(14971917454141291.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Configuraci\00F3n de Componente')
,p_link=>'f?p=&APP_ID.:4447:&SESSION.::&DEBUG.:::'
,p_page_id=>4447
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15036126595436273.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.:::'
,p_page_id=>1300
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15135828644258802.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Definiciones de Carga de Datos'
,p_link=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
,p_page_id=>1800
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15156017832458046.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Definici\00F3n de Carga de Datos')
,p_link=>'f?p=&APP_ID.:1808:&SESSION.::&DEBUG.:::'
,p_page_id=>1808
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15591026729420129.4001)
,p_parent_id=>wwv_flow_api.id(193915914105228860.4001)
,p_short_name=>unistr('Elementos de Contrase\00F1a')
,p_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:::'
,p_page_id=>59
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15797702766949336.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla Basada en Servicio Web'
,p_link=>'f?p=&APP_ID.:600:&SESSION.::&DEBUG.:::'
,p_page_id=>600
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15814118349953843.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla Basada en Servicio Web'
,p_link=>'f?p=&APP_ID.:605:&SESSION.::&DEBUG.:::'
,p_page_id=>605
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15889514867947581.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>unistr('Opciones de Creaci\00F3n')
,p_link=>'f?p=&APP_ID.:511:&SESSION.::&DEBUG.:::'
,p_page_id=>511
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(15991000339058129.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Elementos de Contrase\00F1a')
,p_link=>'f?p=&FLOW_ID.:7777:&SESSION.'
,p_page_id=>7777
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(16358606741741103.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>unistr('Instalar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:67:&SESSION.::&DEBUG.:::'
,p_page_id=>67
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(16773830395421252.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Listas'
,p_link=>'f?p=&FLOW_ID.:405:&SESSION.::&DEBUG.:::'
,p_page_id=>405
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(16937906748551854.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Panel de Control de Aplicaciones'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>71
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17037523781612052.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>'Carga de Datos'
,p_link=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:::'
,p_page_id=>1704
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17191702841394320.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Recuentos de Comparaci\00F3n de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:1301:&SESSION.::&DEBUG.:::'
,p_page_id=>1301
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17287522385778639.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.:::'
,p_page_id=>670
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17460432491552675.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Historial de C\00E1lculos')
,p_link=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:::'
,p_page_id=>152
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17911903538190945.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.:::'
,p_page_id=>661
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(17992125037245873.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Atributos de Calendario'
,p_long_name=>'Atributos de Calendario'
,p_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
,p_page_id=>2000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18285502523148221.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>'Regiones Personalizadas'
,p_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:::'
,p_page_id=>70
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(18832229785461633.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Dise\00F1os de Informe')
,p_long_name=>unistr('Dise\00F1os de Informe')
,p_link=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_page_id=>1400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19022319454443147.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::'
,p_page_id=>122
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19032123742471581.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.:::'
,p_page_id=>161
,p_display_when_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_display_when_condition=>'161'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19258329571249505.4001)
,p_parent_id=>wwv_flow_api.id(18832229785461633.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_page_id=>1401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19419401868575307.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.:::'
,p_page_id=>162
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19894618913813791.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:301:&SESSION.::&DEBUG.:::'
,p_page_id=>301
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19896313737816242.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:305:&SESSION.'
,p_page_id=>305
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19937509097955070.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:308:&SESSION.'
,p_page_id=>308
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(19939204568957219.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:309:&SESSION.'
,p_page_id=>309
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20043923532731419.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Uso de Punto de Visualizaci\00F3n de Regi\00F3n')
,p_link=>'f?p=&FLOW_ID.:206:&SESSION.'
,p_page_id=>206
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(20647319360774865.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:3009:&SESSION.'
,p_page_id=>3009
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(21173412948919620.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina')
,p_link=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_page_id=>259
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22164400994144140.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.:::'
,p_page_id=>697
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22457404822203283.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Validaciones'
,p_link=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:::'
,p_page_id=>445
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22464532161251314.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Scripts'
,p_link=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
,p_page_id=>473
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22494031119345991.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:580:&SESSION.::&DEBUG.:::'
,p_page_id=>580
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22494629499343773.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>unistr('Script de Desinstalaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:576:&SESSION.'
,p_page_id=>576
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22505427599590969.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:585:&SESSION.::&DEBUG.:::'
,p_page_id=>585
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22506626466040885.4001)
,p_parent_id=>wwv_flow_api.id(3803609664693374.4001)
,p_short_name=>'Crear Archivo'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''THEME'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22572807015669847.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:::'
,p_page_id=>1110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22655821130934008.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_page_id=>716
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22666606636975220.4001)
,p_parent_id=>wwv_flow_api.id(22464532161251314.4001)
,p_short_name=>unistr('Script de Instalaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:578:&SESSION.'
,p_page_id=>578
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(22673821761009565.4001)
,p_parent_id=>wwv_flow_api.id(18832229785461633.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_page_id=>1402
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(23761404070459334.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:84:&SESSION.'
,p_page_id=>84
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(24415726992637074.4001)
,p_parent_id=>wwv_flow_api.id(18832229785461633.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:::'
,p_page_id=>1405
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(24448222218694942.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Actualizar'
,p_link=>'f?p=&FLOW_ID.:667:&SESSION.'
,p_page_id=>667
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26225010322357939.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
,p_page_id=>3000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26276826533862190.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:3001:&SESSION.::&DEBUG.:::'
,p_page_id=>3001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26314303002960839.4001)
,p_parent_id=>wwv_flow_api.id(6361712997598750.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4309:&SESSION.::&DEBUG.:::'
,p_page_id=>4309
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26467114976744807.4001)
,p_parent_id=>wwv_flow_api.id(6490322331050183.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''APP'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26484923558914183.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
,p_link=>'f?p=&APP_ID.:312:&SESSION.'
,p_page_id=>312
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26497601066968748.4001)
,p_parent_id=>wwv_flow_api.id(26484923558914183.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''WORKSPACE'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(26719617493740595.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:3005:&SESSION.::&DEBUG.:::'
,p_page_id=>3005
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27035504969935275.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('Crear Gr\00E1fico')
,p_link=>'f?p=&APP_ID.:751:&SESSION.::&DEBUG.:::'
,p_page_id=>751
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27348317124101692.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Regi\00F3n de Calendario')
,p_link=>'f?p=&FLOW_ID.:470:&SESSION.'
,p_page_id=>470
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27355913750296249.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Regi\00F3n de Calendario')
,p_link=>'f?p=&FLOW_ID.:615:&SESSION.'
,p_page_id=>615
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27415113636276739.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Suprimir Varios Elementos'
,p_link=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::'
,p_page_id=>7
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27799320681844329.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Plugins'
,p_link=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
,p_page_id=>4400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27855116546326915.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Utilizaci\00F3n de Plugin')
,p_link=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:::'
,p_page_id=>4420
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(27902008881734561.4001)
,p_parent_id=>wwv_flow_api.id(27799320681844329.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410:P4410_ID,FB_FLOW_ID:,&FB_FLOW_ID.'
,p_page_id=>4410
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'P4410_ID'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28090518824128438.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Acciones Din\00E1micas')
,p_link=>'f?p=&APP_ID.:773:&SESSION.::&DEBUG.:::'
,p_page_id=>773
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28660023095978630.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>unistr('Repositorio de Traducci\00F3n')
,p_link=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
,p_page_id=>702
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28660317933978631.4001)
,p_parent_id=>wwv_flow_api.id(28660023095978630.4001)
,p_short_name=>'Editar Texto Traducible'
,p_link=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.:::'
,p_page_id=>704
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28691420118449496.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Recuento por Tipo de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:128:&SESSION.::&DEBUG.:::'
,p_page_id=>128
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28731306901690116.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Recuento por Punto de Visualizaci\00F3n')
,p_link=>'f?p=&APP_ID.:459:&SESSION.::&DEBUG.:::'
,p_page_id=>459
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28919928791404969.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:345:&SESSION.::&DEBUG.:::'
,p_page_id=>345
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(28947630899464790.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:346:&SESSION.::&DEBUG.:::'
,p_page_id=>346
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(29079632388284659.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:347:&SESSION.::&DEBUG.:::'
,p_page_id=>347
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(29655930553843283.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1114:&SESSION.::&DEBUG.:::'
,p_page_id=>1114
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(29881014393620137.4001)
,p_parent_id=>wwv_flow_api.id(3600263368521940.4001)
,p_short_name=>'Crear Archivo'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''PLUGIN'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30089524645427141.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:700:&SESSION.::&DEBUG.:::'
,p_page_id=>700
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30089908846432101.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:705:&SESSION.::&DEBUG.:::'
,p_page_id=>705
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30090803090439908.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:720:&SESSION.::&DEBUG.:::'
,p_page_id=>720
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30091112094442467.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:725:&SESSION.::&DEBUG.:::'
,p_page_id=>725
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30091426292446571.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:730:&SESSION.::&DEBUG.:::'
,p_page_id=>730
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30091712571452107.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:735:&SESSION.::&DEBUG.:::'
,p_page_id=>735
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30302731462358764.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Informes Interactivos Guardados'
,p_link=>'f?p=&APP_ID.:37:&SESSION.'
,p_page_id=>37
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30450428822739510.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Suprimir Varias Acciones Din\00E1micas')
,p_link=>'f?p=&APP_ID.:794:&SESSION.::&DEBUG.:::'
,p_page_id=>794
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30457608873900217.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Historial de Acciones Din\00E1micas')
,p_link=>'f?p=&APP_ID.:795:&SESSION.::&DEBUG.:::'
,p_page_id=>795
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30468518358262614.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:::'
,p_page_id=>4460
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30498215610469161.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Instalar Plugin'
,p_link=>'f?p=&APP_ID.:4450:&SESSION.::&DEBUG.:::'
,p_page_id=>4450
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30640927390365885.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Suscripciones'
,p_link=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::'
,p_page_id=>39
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30739614365181356.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Editar Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.:::'
,p_page_id=>836
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(30785800441167235.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Listas de Valores Definidas Localmente'
,p_link=>'f?p=&APP_ID.:419:&SESSION.::&DEBUG.:::'
,p_page_id=>419
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(31042308063790472.4001)
,p_parent_id=>wwv_flow_api.id(9594412395161749.4001)
,p_short_name=>unistr('Regiones en Cach\00E9')
,p_link=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:::'
,p_page_id=>656
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(31650524804146842.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Informe de Separadores Principales'
,p_link=>'f?p=&FLOW_ID.:398:&SESSION.'
,p_page_id=>398
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(32815330203586117.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Editar Separadores Principales'
,p_link=>'f?p=&APP_ID.:331:&SESSION.::&DEBUG.:::'
,p_page_id=>331
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(32866018483682765.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Cambiar Nombre de Juego de Separadores Principales'
,p_link=>'f?p=&APP_ID.:332:&SESSION.::&DEBUG.:::'
,p_page_id=>332
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(32869310503686430.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>'Cambiar Nombre de Juego de Separadores Principales'
,p_link=>'f?p=&APP_ID.:333:&SESSION.::&DEBUG.:::'
,p_page_id=>333
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33396205771549676.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:::'
,p_page_id=>870
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33404507616674451.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.:::'
,p_page_id=>871
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33462229310688402.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:872:&SESSION.::&DEBUG.:::'
,p_page_id=>872
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33477504160168267.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:873:&SESSION.::&DEBUG.:::'
,p_page_id=>873
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33528118901761498.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Crear Nuevo Principal'
,p_link=>'f?p=&APP_ID.:2222:&SESSION.::&DEBUG.:::'
,p_page_id=>2222
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33595328303408157.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Probar'
,p_link=>'f?p=&APP_ID.:875:&SESSION.::&DEBUG.:::'
,p_page_id=>875
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33766511907980118.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Editar Atributos de Globalizaci\00F3n')
,p_link=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::'
,p_page_id=>506
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(33987924944919169.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:876:&SESSION.::&DEBUG.:::'
,p_page_id=>876
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34479620623171629.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_page_id=>880
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34486714324302987.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:882:&SESSION.::&DEBUG.:::'
,p_page_id=>882
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34529526845409561.4001)
,p_parent_id=>wwv_flow_api.id(492636106117616338.4001)
,p_short_name=>unistr('Bloqueos de P\00E1gina')
,p_link=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.:::'
,p_page_id=>291
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34893003789899070.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:884:&SESSION.::&DEBUG.:::'
,p_page_id=>884
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34919800042540097.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Bloquear Administraci\00F3n')
,p_link=>'f?p=&APP_ID.:299:&SESSION.::&DEBUG.:::'
,p_page_id=>299
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(34983512563904574.4001)
,p_parent_id=>wwv_flow_api.id(34919800042540097.4001)
,p_short_name=>unistr('Editar Bloqueo de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:330:&SESSION.::&DEBUG.:::'
,p_page_id=>330
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(35045730676235051.4001)
,p_parent_id=>wwv_flow_api.id(34529526845409561.4001)
,p_short_name=>'Editar Comentario de Bloqueo'
,p_link=>'f?p=&FLOW_ID.:337:&SESSION.::&DEBUG.:::'
,p_page_id=>337
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(35080631019682256.4001)
,p_parent_id=>wwv_flow_api.id(6357300501589343.4001)
,p_short_name=>unistr('Agregar Asociaci\00F3n de Separador')
,p_link=>'f?p=&APP_ID.:9005:&SESSION.::&DEBUG.:::'
,p_page_id=>9005
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(36775909817926063.4001)
,p_parent_id=>wwv_flow_api.id(193915914105228860.4001)
,p_short_name=>'Suscripciones de Ayuda de Elemento'
,p_link=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.:::'
,p_page_id=>389
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(37885708427140508.4001)
,p_parent_id=>wwv_flow_api.id(34529526845409561.4001)
,p_short_name=>unistr('Bloquear P\00E1ginas')
,p_link=>'f?p=&FLOW_ID.:444:&SESSION.'
,p_page_id=>444
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(38412104081069219.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Calendario Heredado'
,p_long_name=>'Crear Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:468:&SESSION.::&DEBUG.:::'
,p_page_id=>468
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(38412811700071392.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Calendario Heredado'
,p_long_name=>'Crear Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:469:&SESSION.::&DEBUG.:::'
,p_page_id=>469
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(39308104330344265.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Componente de P\00E1gina')
,p_link=>'f?p=&APP_ID.:323:&SESSION.::&DEBUG.:::'
,p_page_id=>323
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40400718662461634.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Crear Componente de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:364:&SESSION.::&DEBUG.:::'
,p_page_id=>364
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40426904951619920.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Comentarios de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.:::'
,p_page_id=>4310
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(40741805928664126.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>unistr('Gestionar Entradas de Lista Hu\00E9rfanas')
,p_link=>'f?p=&APP_ID.:712:&SESSION.::&DEBUG.:::'
,p_page_id=>712
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(41874016096395037.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.:::'
,p_page_id=>207
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(41926616964652864.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:208:&SESSION.::&DEBUG.:::'
,p_page_id=>208
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(41947223600710637.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:210:&SESSION.::&DEBUG.:::'
,p_page_id=>210
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42095611506558026.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Atributos de Columna'
,p_link=>'f?p=&FLOW_ID.:422:&SESSION.::&DEBUG.:::'
,p_page_id=>422
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42228527428329871.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Interfaces de Usuario'
,p_link=>'f?p=&APP_ID.:197:&SESSION.'
,p_page_id=>197
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42239113024348195.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:599:&SESSION.::&DEBUG.:::'
,p_page_id=>599
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42239606229355665.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Ver'
,p_link=>'f?p=&APP_ID.:589:&SESSION.::&DEBUG.:::'
,p_page_id=>589
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(42239918004359113.4001)
,p_parent_id=>wwv_flow_api.id(6350702023573393.4001)
,p_short_name=>'Probar'
,p_link=>'f?p=&APP_ID.:588:&SESSION.::&DEBUG.:::'
,p_page_id=>588
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(44047420694470997.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Informes de Temas'
,p_link=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_page_id=>173
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(44092007432082923.4001)
,p_parent_id=>wwv_flow_api.id(6594228985351058.4001)
,p_short_name=>unistr('Referencias de P\00E1gina')
,p_link=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:::'
,p_page_id=>417
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(44862032766498285.4001)
,p_parent_id=>wwv_flow_api.id(6482129244031803.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_link=>'f?p=&FLOW_ID.:888:&SESSION.'
,p_page_id=>888
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(45432327870093655.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Exportar/Importar'
,p_link=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_page_id=>461
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(45679206524935706.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>unistr('Archivos de Traducci\00F3n XLIFF')
,p_link=>'f?p=&FLOW_ID.:4758:&SESSION.'
,p_page_id=>4758
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(46338004382099030.4001)
,p_parent_id=>wwv_flow_api.id(95667010592946781.4001)
,p_short_name=>'Alias de Nombres de Columna'
,p_link=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:::'
,p_page_id=>1805
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(46371404489562105.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Importar'
,p_link=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_page_id=>460
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47680324905951993.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:682:&SESSION.::&DEBUG.:::'
,p_page_id=>682
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47702420424012761.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n de Base de Datos')
,p_link=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_page_id=>49
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(47890813442207291.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Historial de Cambios'
,p_link=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:::'
,p_page_id=>358
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48375032377887349.4001)
,p_parent_id=>wwv_flow_api.id(492636106117616338.4001)
,p_short_name=>unistr('Suprimir Varias P\00E1ginas')
,p_link=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:::'
,p_page_id=>72
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48381702709598053.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Desinstalar Objetos de Soporte'
,p_link=>'f?p=&APP_ID.:155:&SESSION.'
,p_page_id=>155
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48414026097213196.4001)
,p_parent_id=>wwv_flow_api.id(27902008881734561.4001)
,p_short_name=>'Editar Atributo'
,p_link=>'f?p=&FLOW_ID.:4415:&SESSION.'
,p_page_id=>4415
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48446526579705279.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>'Instalar Imagen'
,p_link=>'f?p=&FLOW_ID.:409:&SESSION.::&DEBUG.:::'
,p_page_id=>409
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48578110317738240.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Dise\00F1ador de P\00E1ginas')
,p_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
,p_page_id=>4500
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48643012706424118.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2150:&SESSION.'
,p_page_id=>2150
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48656725459443596.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2151:&SESSION.'
,p_page_id=>2151
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(48663025959454948.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2152:&SESSION.'
,p_page_id=>2152
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(49204000503875094.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Lista')
,p_link=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.:::'
,p_page_id=>278
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(49260504263115354.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de P\00E1gina')
,p_link=>'f?p=&APP_ID.:298:&SESSION.::&DEBUG.:::'
,p_page_id=>298
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(51135515383124124.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Suprimir Varios Botones'
,p_link=>'f?p=&FLOW_ID.:724:&SESSION.'
,p_page_id=>724
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(51370918597464994.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2153:&SESSION.'
,p_page_id=>2153
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(56073623850337643.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:453:&SESSION.::&DEBUG.:::'
,p_page_id=>453
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(56552316290752041.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>unistr('\00C1rbol')
,p_link=>'f?p=&APP_ID.:68:&SESSION.::&DEBUG.:::'
,p_page_id=>68
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(56571426174792979.4001)
,p_parent_id=>wwv_flow_api.id(45679206524935706.4001)
,p_short_name=>'Carga de XLIFF'
,p_link=>'f?p=&FLOW_ID.:4760:&SESSION.'
,p_page_id=>4760
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57402008958641680.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2154:&SESSION.'
,p_page_id=>2154
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57409130281645336.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2155:&SESSION.'
,p_page_id=>2155
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57430104579660620.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2157:&SESSION.'
,p_page_id=>2157
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57440225865676749.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Error'
,p_link=>'f?p=&FLOW_ID.:2158:&SESSION.'
,p_page_id=>2158
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57481112855728406.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2166:&SESSION.'
,p_page_id=>2166
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57557104867216371.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Cambiar Tema'
,p_link=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:::'
,p_page_id=>179
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57558317334219907.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Cambiar Tema'
,p_link=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.:::'
,p_page_id=>180
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57677029210705977.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Suprimir'
,p_link=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.:::'
,p_page_id=>221
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57801802413038850.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Suprimir'
,p_link=>'f?p=&APP_ID.:229:&SESSION.::&DEBUG.:::'
,p_page_id=>229
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57892000082254726.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Suprimir Varias Validaciones'
,p_link=>'f?p=&FLOW_ID.:743:&SESSION.'
,p_page_id=>743
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57960416328352825.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Suprimir Varios C\00E1lculos')
,p_link=>'f?p=&FLOW_ID.:744:&SESSION.'
,p_page_id=>744
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57976310474373623.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Suprimir Varios Procesos'
,p_link=>'f?p=&APP_ID.:745:&SESSION.::&DEBUG.:::'
,p_page_id=>745
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(57995107400396507.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Suprimir Varias Bifurcaciones'
,p_link=>'f?p=&FLOW_ID.:746:&SESSION.'
,p_page_id=>746
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(58018323080431042.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Suprimir Varias Regiones'
,p_link=>'f?p=&APP_ID.:747:&SESSION.::&DEBUG.:::'
,p_page_id=>747
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(59091202259431920.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Crear/Editar Tema'
,p_link=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:267:P267_ID,FB_FLOW_ID:&P267_ID.,&FB_FLOW_ID.'
,p_page_id=>267
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(59327103752427404.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Cambiar Tema'
,p_link=>'f?p=&APP_ID.:386:&SESSION.::&DEBUG.:::'
,p_page_id=>386
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(60196720153711959.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_link=>'f?p=&APP_ID.:397:&SESSION.::&DEBUG.:::'
,p_page_id=>397
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(60229931206838111.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
,p_page_id=>400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(60307011719125820.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(60307318991127996.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:410:&SESSION.::&DEBUG.:::'
,p_page_id=>410
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(60519601156521547.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:::'
,p_page_id=>224
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(61422109882617052.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:::'
,p_page_id=>1116
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(61439918645696793.4001)
,p_parent_id=>wwv_flow_api.id(61422109882617052.4001)
,p_short_name=>'Consulta de Origen'
,p_link=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.:::'
,p_page_id=>1117
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(61780222135354731.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:307:&SESSION.::&DEBUG.:::'
,p_page_id=>307
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(62062513318815833.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:924:&SESSION.::&DEBUG.:::'
,p_page_id=>924
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(62062718859817408.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Lista'
,p_link=>'f?p=&FLOW_ID.:935:&SESSION.::&DEBUG.:::'
,p_page_id=>935
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(62547120512258610.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:302:&SESSION.'
,p_page_id=>302
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(62590614310357796.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina de Conexi\00F3n')
,p_long_name=>unistr('Crear P\00E1gina de Conexi\00F3n')
,p_link=>'f?p=&FLOW_ID.:500:&SESSION.::&DEBUG.:::'
,p_page_id=>500
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(62967931336852582.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:1121:&SESSION.::&DEBUG.:::'
,p_page_id=>1121
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(63109602699977365.4001)
,p_parent_id=>wwv_flow_api.id(18832229785461633.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:::'
,p_page_id=>1122
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(67875614692050047.4001)
,p_parent_id=>wwv_flow_api.id(95667010592946781.4001)
,p_short_name=>unistr('Reglas de Transformaci\00F3n')
,p_link=>'f?p=&APP_ID.:1804:&SESSION.::&DEBUG.:::'
,p_page_id=>1804
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(73646502412639523.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1113:&SESSION.::&DEBUG.:::'
,p_page_id=>1113
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(75670229803852849.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>'Sustituir'
,p_link=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_page_id=>48
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(77256925975128112.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>'Instalar'
,p_link=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_page_id=>57
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78978224218406311.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>'Editar Mensajes'
,p_link=>'f?p=&APP_ID.:212:&SESSION.::&DEBUG.:::'
,p_page_id=>212
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79204403826546075.4001)
,p_parent_id=>wwv_flow_api.id(193856726464283476.4001)
,p_short_name=>'Editar Mensajes de Proceso'
,p_link=>'f?p=&APP_ID.:213:&SESSION.::&DEBUG.:::'
,p_page_id=>213
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79267021325765840.4001)
,p_parent_id=>wwv_flow_api.id(193766813255904989.4001)
,p_short_name=>'Editar Mensajes de Error'
,p_link=>'f?p=&APP_ID.:214:&SESSION.::&DEBUG.:::'
,p_page_id=>214
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79282824498840307.4001)
,p_parent_id=>wwv_flow_api.id(193687816503601756.4001)
,p_short_name=>'Editar Mensajes de Error'
,p_link=>'f?p=&APP_ID.:215:&SESSION.::&DEBUG.:::'
,p_page_id=>215
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79404406301213449.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Editar Cabeceras de Columna de Informe Est\00E1ndar')
,p_link=>'f?p=&APP_ID.:217:&SESSION.::&DEBUG.:::'
,p_page_id=>217
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(79918583149078897.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>unistr('Crear origen de datos de REST: Cat\00E1logo')
,p_link=>'f?p=&APP_ID.:1908:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1908
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(83259325931667653.4001)
,p_parent_id=>wwv_flow_api.id(193915914105228860.4001)
,p_short_name=>'Editar Texto de Ayuda de Elemento'
,p_link=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.:::'
,p_page_id=>408
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(87895810674830166.4001)
,p_parent_id=>wwv_flow_api.id(18832229785461633.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.:::'
,p_page_id=>1406
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(89290906690646629.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Atributos de Consulta Din\00E1mica')
,p_link=>'f?p=&FLOW_ID.:687:&SESSION.'
,p_page_id=>687
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(90113801987389954.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Grupos de Columnas'
,p_link=>'f?p=&APP_ID.:694:&SESSION.::&DEBUG.:::'
,p_page_id=>694
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(90377510935749472.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Uso de Plantilla'
,p_link=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:::'
,p_page_id=>707
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(90734228848148157.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Sustituir Plantillas'
,p_link=>'f?p=&APP_ID.:708:&SESSION.::&DEBUG.:::'
,p_page_id=>708
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(90747004454189845.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Sustituir Plantillas'
,p_link=>'f?p=&APP_ID.:711:&SESSION.::&DEBUG.:::'
,p_page_id=>711
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(90748600357191706.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Sustituir Plantillas'
,p_link=>'f?p=&APP_ID.:713:&SESSION.::&DEBUG.:::'
,p_page_id=>713
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(91017830060853347.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Grupos de Aplicaciones'
,p_link=>'f?p=&APP_ID.:722:&SESSION.::&DEBUG.:::'
,p_page_id=>722
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(91045931065932064.4001)
,p_parent_id=>wwv_flow_api.id(91017830060853347.4001)
,p_short_name=>'Grupo de Aplicaciones'
,p_link=>'f?p=&FLOW_ID.:726:&SESSION.'
,p_page_id=>726
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(91621226770329390.4001)
,p_parent_id=>wwv_flow_api.id(91017830060853347.4001)
,p_short_name=>'Gestionar Asignaciones de Grupos de Aplicaciones'
,p_link=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:::'
,p_page_id=>736
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(92827822623864115.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Interactivo'
,p_link=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:::'
,p_page_id=>759
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(92898722246061726.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Interactivo'
,p_link=>'f?p=&APP_ID.:769:&SESSION.::&DEBUG.:::'
,p_page_id=>769
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(94569703469105837.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Publicar Plantillas'
,p_link=>'f?p=&APP_ID.:727:&SESSION.::&DEBUG.:::'
,p_page_id=>727
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(95655705018786533.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Anular Suscripci\00F3n de Plantillas')
,p_link=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:::'
,p_page_id=>540
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(95667010592946781.4001)
,p_parent_id=>wwv_flow_api.id(15135828644258802.4001)
,p_short_name=>'Carga de datos heredada'
,p_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
,p_page_id=>1801
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(97822916515667432.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Publicar Plantillas'
,p_link=>'f?p=&FLOW_ID.:651:&SESSION.'
,p_page_id=>651
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(104385112024157526.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Estado de Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:733:&SESSION.'
,p_page_id=>733
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(104933404458744311.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_page_id=>1115
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(104951728751856925.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.:::'
,p_page_id=>1119
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(105094119363311752.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Confirmar Cambio de Regi\00F3n de Informe Interactivo')
,p_link=>'f?p=&APP_ID.:729:&SESSION.::&DEBUG.:::'
,p_page_id=>729
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(107237015875905749.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Editar Atributos de Seguridad'
,p_link=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:::'
,p_page_id=>509
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(107340613778477687.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_link=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
,p_page_id=>510
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(107378015355659275.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>unistr('por P\00E1gina')
,p_link=>'f?p=&APP_ID.:512:&SESSION.::&DEBUG.:::'
,p_page_id=>512
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(107541219987325697.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>unistr('Definir P\00E1gina y Protecci\00F3n de Elemento')
,p_link=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:::'
,p_page_id=>515
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(107580516018433845.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>'por Elemento'
,p_link=>'f?p=&APP_ID.:513:&SESSION.::&DEBUG.:::'
,p_page_id=>513
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(107807706268289266.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>unistr('por Elemento de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:518:&SESSION.::&DEBUG.:::'
,p_page_id=>518
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(109504303498128012.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_page_id=>525
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(109519507330187086.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>'Desactivar'
,p_link=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.:::'
,p_page_id=>9008
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(109587519846938835.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&FLOW_ID.:538:&SESSION.'
,p_page_id=>538
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(110590227693558637.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&APP_ID.:569:&SESSION.::&DEBUG.:::'
,p_page_id=>569
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(112548105724617824.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1118:&SESSION.::&DEBUG.:::'
,p_page_id=>1118
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(113585132510930484.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Tema de Espacio de Trabajo'
,p_link=>'f?p=&APP_ID.:762:&SESSION.::&DEBUG.:::'
,p_page_id=>762
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(113626503368049158.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Temas de Espacio de Trabajo'
,p_link=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.:::'
,p_page_id=>763
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(113841012584615990.4001)
,p_parent_id=>wwv_flow_api.id(113626503368049158.4001)
,p_short_name=>'Crear Tema de Espacio de Trabajo'
,p_link=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.:::'
,p_page_id=>764
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(113870516423876080.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_page_id=>602
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(113936004199440283.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:603:&SESSION.::&DEBUG.:::'
,p_page_id=>603
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114028028739330135.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:776:&SESSION.'
,p_page_id=>776
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114044014921679563.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:481:&SESSION.::&DEBUG.:::'
,p_page_id=>481
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114051800144368750.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:778:&SESSION.'
,p_page_id=>778
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114060700049385731.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:779:&SESSION.'
,p_page_id=>779
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114090607634408249.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:781:&SESSION.'
,p_page_id=>781
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114111118245435536.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:782:&SESSION.'
,p_page_id=>782
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114127205640452275.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:783:&SESSION.'
,p_page_id=>783
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114158724210504878.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:786:&SESSION.'
,p_page_id=>786
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114188508847866753.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>'Activar'
,p_link=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.:::'
,p_page_id=>9007
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114300919862740460.4001)
,p_parent_id=>wwv_flow_api.id(107340613778477687.4001)
,p_short_name=>'Configurar'
,p_link=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.:::'
,p_page_id=>9006
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114703706139322862.4001)
,p_parent_id=>wwv_flow_api.id(6358428525591525.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:485:&SESSION.::&DEBUG.:::'
,p_page_id=>485
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(114757003254593118.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Tema de Espacio de Trabajo'
,p_link=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.:::'
,p_page_id=>789
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(115178103851908301.4001)
,p_parent_id=>wwv_flow_api.id(6349507415570925.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:493:&SESSION.::&DEBUG.:::'
,p_page_id=>493
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(115199004729023834.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Copiar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:499:&SESSION.'
,p_page_id=>499
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(115200531243026756.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Copiar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:611:&SESSION.'
,p_page_id=>611
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(115276620473263231.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla de Lista'
,p_link=>'f?p=&APP_ID.:573:&SESSION.::&DEBUG.:::'
,p_page_id=>573
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(115638218243483150.4001)
,p_parent_id=>wwv_flow_api.id(11539704173277683.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:1112:&SESSION.::&DEBUG.:::'
,p_page_id=>1112
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(115678105236786168.4001)
,p_parent_id=>wwv_flow_api.id(6351829184575999.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.:::'
,p_page_id=>617
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(120128322008989756.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:::'
,p_page_id=>902
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(120138725518019136.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:349:&SESSION.::&DEBUG.:::'
,p_page_id=>349
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(120139804178022439.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla Emergente'
,p_link=>'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:::'
,p_page_id=>350
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(125696810110909836.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Comentarios del Desarrollador'
,p_link=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:::'
,p_page_id=>606
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(131391613326402590.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>'Comentarios del Desarrollador'
,p_link=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:::'
,p_page_id=>380
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(135993121714361133.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Informes de Temas'
,p_link=>'f?p=&APP_ID.:435:&SESSION.::&DEBUG.:::'
,p_page_id=>435
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(136552508251247413.4001)
,p_parent_id=>wwv_flow_api.id(113626503368049158.4001)
,p_short_name=>'Editar Tema de Espacio de Trabajo'
,p_link=>'f?p=&APP_ID.:756:&SESSION.::&DEBUG.:::'
,p_page_id=>756
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(137021224528556329.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Migrar a Informe Interactivo'
,p_link=>'f?p=&APP_ID.:758:&SESSION.::&DEBUG.:::'
,p_page_id=>758
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(139373910461217836.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Recuentos de Temas por Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:737:&SESSION.'
,p_page_id=>737
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(141400217689131996.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>'Instalar Tema'
,p_link=>'f?p=&APP_ID.:253:&SESSION.::&DEBUG.:::'
,p_page_id=>253
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(145762826362643090.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.:::'
,p_page_id=>479
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(149654224766911057.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Informes de Temas'
,p_link=>'f?p=&APP_ID.:491:&SESSION.::&DEBUG.:::'
,p_page_id=>491
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(149658623852924840.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Informes de Temas'
,p_link=>'f?p=&APP_ID.:492:&SESSION.::&DEBUG.:::'
,p_page_id=>492
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(150882216015541693.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:498:&SESSION.::&DEBUG.:::'
,p_page_id=>498
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(151993517365697434.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:225:&SESSION.::&DEBUG.:::'
,p_page_id=>225
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(152080223449888448.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Informe'
,p_link=>'f?p=&FLOW_ID.:343:&SESSION.::&DEBUG.:::'
,p_page_id=>343
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(152910808417776655.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Listas no Utilizadas'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(153000101526828257.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Etiqueta'
,p_link=>'f?p=&APP_ID.:655:&SESSION.::&DEBUG.:::'
,p_page_id=>655
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(153007213794852904.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Etiqueta'
,p_link=>'f?p=&APP_ID.:657:&SESSION.::&DEBUG.:::'
,p_page_id=>657
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154028932045622478.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'SQL activado para REST'
,p_link=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:::'
,p_page_id=>1600
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154029809453638559.4001)
,p_parent_id=>wwv_flow_api.id(154028932045622478.4001)
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:::'
,p_page_id=>1601
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154065306503882365.4001)
,p_parent_id=>wwv_flow_api.id(154028932045622478.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.:::'
,p_page_id=>1603
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154549600882195703.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Lista'
,p_link=>'f?p=&FLOW_ID.:412:&SESSION.::&DEBUG.:::'
,p_page_id=>412
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154576065012566142.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Credenciales web'
,p_link=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:::'
,p_page_id=>1620
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154598203203414099.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:415:&SESSION.::&DEBUG.:::'
,p_page_id=>415
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154602037791686576.4001)
,p_parent_id=>wwv_flow_api.id(154576065012566142.4001)
,p_short_name=>'Crear&#x2F;Editar'
,p_link=>'f?p=&APP_ID.:1621:&SESSION.'
,p_page_id=>1621
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154624717149474872.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Calendario Heredado'
,p_link=>'f?p=&APP_ID.:418:&SESSION.::&DEBUG.:::'
,p_page_id=>418
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154636025026761954.4001)
,p_parent_id=>wwv_flow_api.id(154576065012566142.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:1623:&SESSION.'
,p_page_id=>1623
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154695337185795841.4001)
,p_parent_id=>wwv_flow_api.id(154576065012566142.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&APP_ID.:1622:&SESSION.'
,p_page_id=>1622
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(154793529653781222.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_link=>'f?p=&APP_ID.:413:&SESSION.::&DEBUG.:::'
,p_page_id=>413
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(158644126867435867.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Etiqueta'
,p_link=>'f?p=&FLOW_ID.:652:&SESSION.::&DEBUG.:::'
,p_page_id=>652
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(160755307544646925.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>'Instalar Valores por Defecto de Interfaz de Usuario'
,p_link=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:::'
,p_page_id=>321
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(161813712083563669.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Etiqueta')
,p_link=>'f?p=&FLOW_ID.:348:&SESSION.'
,p_page_id=>348
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(161815107338565828.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Bot\00F3n')
,p_link=>'f?p=&FLOW_ID.:502:&SESSION.'
,p_page_id=>502
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(161818120481574928.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:503:&SESSION.::&DEBUG.:::'
,p_page_id=>503
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(161820015952577079.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Calendario Heredado')
,p_link=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.:::'
,p_page_id=>504
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162360425664871103.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_link=>'f?p=&APP_ID.:9009:&SESSION.::&DEBUG.:::'
,p_page_id=>9009
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162374325122008014.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Atributos de Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:9010:&SESSION.'
,p_page_id=>9010
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162376931363020383.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Opciones de Creaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:9012:&SESSION.'
,p_page_id=>9012
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162379501171034352.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>'Perfiles de Seguridad'
,p_link=>'f?p=&APP_ID.:9014:&SESSION.::&DEBUG.:::'
,p_page_id=>9014
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162380821862039909.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Esquemas de Autenticaci\00F3n')
,p_link=>'f?p=&APP_ID.:9015:&SESSION.::&DEBUG.:::'
,p_page_id=>9015
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162450914277621500.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>'Traducir Texto'
,p_link=>'f?p=&APP_ID.:306:&SESSION.::&DEBUG.:::'
,p_page_id=>306
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(162452108227639507.4001)
,p_parent_id=>wwv_flow_api.id(6481002299029073.4001)
,p_short_name=>'Extraer y Publicar'
,p_link=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.:::'
,p_page_id=>385
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(165418722196771382.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:::'
,p_page_id=>507
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(165570524142028754.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Maestro/Detalle'
,p_link=>'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:::'
,p_page_id=>508
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(168965907799367480.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Pantalla Basada en Tabla'
,p_link=>'f?p=&APP_ID.:442:&SESSION.::&DEBUG.:::'
,p_page_id=>442
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(169026027097495242.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:443:&SESSION.::&DEBUG.:::'
,p_page_id=>443
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(169186218227566038.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.:::'
,p_page_id=>427
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(169188309807640845.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.:::'
,p_page_id=>440
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(169196020236747043.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:529:&SESSION.::&DEBUG.:::'
,p_page_id=>529
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(170052511890818404.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('P\00E1ginas Actualizadas Recientemente')
,p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(170300003306388723.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Cambiar Secuencia de Entradas de Lista'
,p_link=>'f?p=&APP_ID.:536:&SESSION.::&DEBUG.:::'
,p_page_id=>536
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171699124709464076.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>'Regiones de PL/SQL'
,p_link=>'f?p=&APP_ID.:480:&SESSION.::&DEBUG.:::'
,p_page_id=>480
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171877905296973607.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Resultados'
,p_link=>'f?p=&APP_ID.:8101:&SESSION.::&DEBUG.:::'
,p_page_id=>8101
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171905003724893273.4001)
,p_parent_id=>wwv_flow_api.id(492636106117616338.4001)
,p_short_name=>unistr('Atributos de P\00E1gina')
,p_link=>'f?p=&APP_ID.:484:&SESSION.::&DEBUG.:::'
,p_page_id=>484
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174703620660828013.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:3020:&SESSION.::&DEBUG.:::'
,p_page_id=>3020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174788904891863226.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Obj Base de Datos Referencia'
,p_link=>'f?p=&APP_ID.:268:&SESSION.::&DEBUG.:::'
,p_page_id=>268
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177829529391401676.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>'Utilidades'
,p_link=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
,p_page_id=>674
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(182505732052858978.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Editar Plantilla de Ruta de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:289:&SESSION.::&DEBUG.:::'
,p_page_id=>289
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(184663820849027926.4001)
,p_parent_id=>wwv_flow_api.id(48414026097213196.4001)
,p_short_name=>'Editar Valor'
,p_link=>'f?p=&FLOW_ID.:4416:&SESSION.'
,p_page_id=>4416
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(188100621615832352.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Entradas de Listas de Valores Condicionales'
,p_link=>'f?p=&APP_ID.:556:&SESSION.::&DEBUG.:::'
,p_page_id=>556
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(188108816910881685.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Entradas de Lista Condicionales'
,p_link=>'f?p=&FLOW_ID.:557:&SESSION.'
,p_page_id=>557
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(188150209489131290.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Visualizaci\00F3n Condicional de Separadores')
,p_link=>'f?p=&APP_ID.:562:&SESSION.::&DEBUG.:::'
,p_page_id=>562
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(190002104978248634.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Dependencias de Objetos de Base de Datos'
,p_link=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.:::'
,p_page_id=>425
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(190138606995764363.4001)
,p_parent_id=>wwv_flow_api.id(190002104978248634.4001)
,p_short_name=>unistr('Referencias de P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:434:&SESSION.'
,p_page_id=>434
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(192555809351400735.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Elementos de Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:533:&SESSION.'
,p_page_id=>533
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(192564311271466695.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Opciones de Creaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:535:&SESSION.'
,p_page_id=>535
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(192625619892729357.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Crear/Editar'
,p_link=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:::'
,p_page_id=>4052
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(192764909884723601.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Esquemas de Autenticaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:554:&SESSION.'
,p_page_id=>554
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(192783704238809048.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Esquemas de Autorizaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:558:&SESSION.'
,p_page_id=>558
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193119829696374981.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Temas'
,p_link=>'f?p=&FLOW_ID.:681:&SESSION.'
,p_page_id=>681
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193350432188403940.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Listas de Valores'
,p_link=>'f?p=&FLOW_ID.:686:&SESSION.'
,p_page_id=>686
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193355419042451698.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Plugins'
,p_link=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.:::'
,p_page_id=>841
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193368710626376391.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Historial de Consultas de Informe'
,p_link=>'f?p=&FLOW_ID.:843:&SESSION.'
,p_page_id=>843
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193374131543539461.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Historial de Dise\00F1os de Informe')
,p_link=>'f?p=&FLOW_ID.:844:&SESSION.'
,p_page_id=>844
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193687816503601756.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Utilidades de C\00E1lculo')
,p_link=>'f?p=&APP_ID.:847:&SESSION.::&DEBUG.:::'
,p_page_id=>847
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193705211223861131.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_page_id=>842
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193711914243872120.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Pantalla e Informe Basados en Servicio Web'
,p_link=>'f?p=&APP_ID.:848:&SESSION.::&DEBUG.:::'
,p_page_id=>848
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193766813255904989.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Utilidades de Validaci\00F3n')
,p_link=>'f?p=&APP_ID.:851:&SESSION.::&DEBUG.:::'
,p_page_id=>851
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193782110098056426.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Utilidades de Botones'
,p_link=>'f?p=&APP_ID.:852:&SESSION.::&DEBUG.:::'
,p_page_id=>852
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193856726464283476.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Utilidades de Proceso'
,p_link=>'f?p=&APP_ID.:482:&SESSION.::&DEBUG.:::'
,p_page_id=>482
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193869708580501594.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Utilidades de Regiones'
,p_link=>'f?p=&APP_ID.:853:&SESSION.::&DEBUG.:::'
,p_page_id=>853
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193915914105228860.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Utilidades de Elementos'
,p_link=>'f?p=&APP_ID.:854:&SESSION.::&DEBUG.:::'
,p_page_id=>854
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193940422363104089.4001)
,p_parent_id=>wwv_flow_api.id(6362806096601891.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:859:&SESSION.'
,p_page_id=>859
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(193946420117118951.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Informe Basado en Resultado de Servicio Web'
,p_link=>'f?p=&FLOW_ID.:860:&SESSION.'
,p_page_id=>860
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194188915515325710.4001)
,p_parent_id=>wwv_flow_api.id(194564807352908073.4001)
,p_short_name=>unistr('Bifurcaciones por P\00E1gina')
,p_link=>'f?p=&APP_ID.:563:&SESSION.::&DEBUG.:::'
,p_page_id=>563
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194204902902418301.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:864:&SESSION.::&DEBUG.:::'
,p_page_id=>864
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194240024554788875.4001)
,p_parent_id=>wwv_flow_api.id(193856726464283476.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:866:&SESSION.::&DEBUG.:::'
,p_page_id=>866
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194518712088362500.4001)
,p_parent_id=>wwv_flow_api.id(193915914105228860.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:869:&SESSION.::&DEBUG.:::'
,p_page_id=>869
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194534516750486783.4001)
,p_parent_id=>wwv_flow_api.id(193687816503601756.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:877:&SESSION.::&DEBUG.:::'
,p_page_id=>877
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194550309891571022.4001)
,p_parent_id=>wwv_flow_api.id(193782110098056426.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:878:&SESSION.::&DEBUG.:::'
,p_page_id=>878
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194564807352908073.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Utilidades de Rama'
,p_link=>'f?p=&APP_ID.:881:&SESSION.::&DEBUG.:::'
,p_page_id=>881
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194571017770949039.4001)
,p_parent_id=>wwv_flow_api.id(193766813255904989.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:883:&SESSION.::&DEBUG.:::'
,p_page_id=>883
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194580430162010948.4001)
,p_parent_id=>wwv_flow_api.id(194564807352908073.4001)
,p_short_name=>'Condicional'
,p_link=>'f?p=&APP_ID.:885:&SESSION.::&DEBUG.:::'
,p_page_id=>885
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194634117689659288.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>'Regiones por Tipo'
,p_link=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:::'
,p_page_id=>136
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(194857168593967619.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('P\00E1gina &FB_FLOW_PAGE_ID.')
,p_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_page_id=>4500
,p_display_when_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_display_when_condition=>'4500'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(196190910831857780.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:849:&SESSION.'
,p_page_id=>849
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(196890422814216715.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear Barra de Navegaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:392:&SESSION.'
,p_page_id=>392
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(196961610477749464.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Crear Barra de Navegaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:497:&SESSION.'
,p_page_id=>497
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200451015171287637.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Vistas de Application Express'
,p_link=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.:::'
,p_page_id=>714
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200456909973365514.4001)
,p_parent_id=>wwv_flow_api.id(200451015171287637.4001)
,p_short_name=>'Seleccionar Columnas'
,p_link=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.:::'
,p_page_id=>892
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200560105669886915.4001)
,p_parent_id=>wwv_flow_api.id(200451015171287637.4001)
,p_short_name=>'Filtro'
,p_link=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.:::'
,p_page_id=>893
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200567620998923812.4001)
,p_parent_id=>wwv_flow_api.id(200451015171287637.4001)
,p_short_name=>'Resultados'
,p_link=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.:::'
,p_page_id=>896
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200898422299282402.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:618:&SESSION.'
,p_page_id=>618
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200901232195308145.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:621:&SESSION.'
,p_page_id=>621
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200902429176309509.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:622:&SESSION.'
,p_page_id=>622
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(200903626372310872.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:623:&SESSION.'
,p_page_id=>623
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201141118631650761.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Vistas de Application Express'
,p_link=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:::'
,p_page_id=>905
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201355804967508727.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:625:&SESSION.'
,p_page_id=>625
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(201379522121622319.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:627:&SESSION.'
,p_page_id=>627
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(203484913118434124.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.:::'
,p_page_id=>477
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(203514430081517401.4001)
,p_parent_id=>wwv_flow_api.id(6795302837254265.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:478:&SESSION.::&DEBUG.:::'
,p_page_id=>478
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(203819226726711009.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:628:&SESSION.'
,p_page_id=>628
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(204122928382059758.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:671:&SESSION.'
,p_page_id=>671
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(205094930753634778.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>unistr('Estado de Creaci\00F3n y Estado de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:::'
,p_page_id=>103
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(205099108540645099.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Ruta de Navegaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:465:&SESSION.'
,p_page_id=>465
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(205279003609407006.4001)
,p_parent_id=>wwv_flow_api.id(205094930753634778.4001)
,p_short_name=>unistr('Editar Estado de Creaci\00F3n')
,p_link=>'f?p=&APP_ID.:467:&SESSION.::&DEBUG.:::'
,p_page_id=>467
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(205875316195651101.4001)
,p_parent_id=>wwv_flow_api.id(6479907044026887.4001)
,p_short_name=>unistr('Exportaci\00F3n de Componente')
,p_link=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:::'
,p_page_id=>688
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(208025501375807758.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>unistr('Copiar P\00E1gina')
,p_link=>'f?p=&FLOW_ID.:593:&SESSION.'
,p_page_id=>593
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(209921323872407276.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Instalar Componentes de Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:598:&SESSION.::&DEBUG.:::'
,p_page_id=>598
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(210772504184349096.4001)
,p_parent_id=>wwv_flow_api.id(6479907044026887.4001)
,p_short_name=>unistr('Exportaci\00F3n de Componente')
,p_link=>'f?p=&APP_ID.:637:&SESSION.::&DEBUG.:::'
,p_page_id=>637
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(212276525707666019.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:2116:&SESSION.'
,p_page_id=>2116
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(212832024367160609.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Grupos de P\00E1ginas')
,p_link=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.:::'
,p_page_id=>520
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(212878912813317924.4001)
,p_parent_id=>wwv_flow_api.id(212832024367160609.4001)
,p_short_name=>unistr('Grupo de P\00E1ginas')
,p_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:::'
,p_page_id=>521
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(212936631655476340.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Asignaciones de Grupos de P\00E1ginas')
,p_link=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:::'
,p_page_id=>522
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(213314913518106173.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('P\00E1ginas por Grupo de P\00E1ginas')
,p_link=>'f?p=&APP_ID.:528:&SESSION.::&DEBUG.:::'
,p_page_id=>528
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(217586628504429796.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Calendario de Comentarios del Desarrollador'
,p_link=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.:::'
,p_page_id=>594
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(217721100387894207.4001)
,p_parent_id=>wwv_flow_api.id(162360425664871103.4001)
,p_short_name=>'Calendario de Comentarios del Desarrollador'
,p_link=>'f?p=&APP_ID.:665:&SESSION.::&DEBUG.:::'
,p_page_id=>665
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(218850916548983451.4001)
,p_parent_id=>wwv_flow_api.id(6661610099511746.4001)
,p_short_name=>unistr('Instalar Archivos Est\00E1ticos')
,p_link=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_page_id=>612
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(219158611394417994.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Instalar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2117:&SESSION.::&DEBUG.:::'
,p_page_id=>2117
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(221168815878138814.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Rutas de Navegaci\00F3n')
,p_link=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:::'
,p_page_id=>546
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(221229216805384320.4001)
,p_parent_id=>wwv_flow_api.id(193915914105228860.4001)
,p_short_name=>unistr('Elementos de P\00E1gina')
,p_link=>'f?p=&APP_ID.:547:&SESSION.::&DEBUG.:::'
,p_page_id=>547
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(222588214943495167.4001)
,p_parent_id=>wwv_flow_api.id(193782110098056426.4001)
,p_short_name=>unistr('Botones de P\00E1gina')
,p_link=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.:::'
,p_page_id=>548
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(222848520344127566.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&APP_ID.:584:&SESSION.::&DEBUG.:::'
,p_page_id=>584
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(222852405462198957.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&APP_ID.:568:&SESSION.::&DEBUG.:::'
,p_page_id=>568
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(223171208059454358.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&FLOW_ID.:636:&SESSION.'
,p_page_id=>636
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(224101606989701160.4001)
,p_parent_id=>wwv_flow_api.id(9594412395161749.4001)
,p_short_name=>unistr('P\00E1ginas en Cach\00E9')
,p_link=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:::'
,p_page_id=>638
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(224247219739285835.4001)
,p_parent_id=>wwv_flow_api.id(193687816503601756.4001)
,p_short_name=>unistr('C\00E1lculos por P\00E1gina')
,p_link=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:::'
,p_page_id=>549
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(225314227644373359.4001)
,p_parent_id=>wwv_flow_api.id(193856726464283476.4001)
,p_short_name=>unistr('Procesos por P\00E1gina')
,p_link=>'f?p=&APP_ID.:552:&SESSION.::&DEBUG.:::'
,p_page_id=>552
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(225891858843186075.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Or\00EDgenes de Datos de REST')
,p_link=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:::'
,p_page_id=>1901
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(225892393724191781.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>'&P1921_BREADCRUMB_NAME.'
,p_link=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:::'
,p_page_id=>1921
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(229167313944963222.4001)
,p_parent_id=>wwv_flow_api.id(225892393724191781.4001)
,p_short_name=>'Perfil de Datos'
,p_link=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:::'
,p_page_id=>1925
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(229198344371064517.4001)
,p_parent_id=>wwv_flow_api.id(225892393724191781.4001)
,p_short_name=>unistr('Operaci\00F3n')
,p_link=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:::'
,p_page_id=>1922
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(231166627894776995.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:658:&SESSION.::&DEBUG.:::'
,p_page_id=>658
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(231172611880791231.4001)
,p_parent_id=>wwv_flow_api.id(16773830395421252.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:::'
,p_page_id=>663
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(231334612269180150.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Aplicaci\00F3n Instalada')
,p_link=>'f?p=&FLOW_ID.:2140:&SESSION.'
,p_page_id=>2140
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(232926602436928559.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Editar T\00EDtulos de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:438:&SESSION.::&DEBUG.:::'
,p_page_id=>438
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(236298214357728332.4001)
,p_parent_id=>wwv_flow_api.id(154028932045622478.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.:::'
,p_page_id=>1602
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(236543116135568980.4001)
,p_parent_id=>wwv_flow_api.id(22464532161251314.4001)
,p_short_name=>unistr('Cambiar Secuencia de Scripts de Instalaci\00F3n')
,p_link=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
,p_page_id=>802
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(240164301523392650.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Crear Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:433:&SESSION.::&DEBUG.:::'
,p_page_id=>433
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(241361771869873980.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&APP_ID.:1902:&SESSION.'
,p_page_id=>1902
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(242224030662625650.4001)
,p_parent_id=>wwv_flow_api.id(229198344371064517.4001)
,p_short_name=>'Resultados de la prueba'
,p_link=>'f?p=&APP_ID.:1927:&SESSION.::&DEBUG.:::'
,p_page_id=>1927
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(242513213859156159.4001)
,p_parent_id=>wwv_flow_api.id(193766813255904989.4001)
,p_short_name=>unistr('Validaciones por P\00E1gina')
,p_link=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.:::'
,p_page_id=>501
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(247673724692352491.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>unistr('Crear origen de datos de REST: M\00E9todo')
,p_link=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:::'
,p_page_id=>1905
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(247685482384424709.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1906:&SESSION.'
,p_page_id=>1906
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(247700619009474725.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>'Copiar'
,p_link=>'f?p=&APP_ID.:1907:&SESSION.'
,p_page_id=>1907
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(247792552823343318.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:1903:&SESSION.'
,p_page_id=>1903
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(249343822808868772.4001)
,p_parent_id=>wwv_flow_api.id(154028932045622478.4001)
,p_short_name=>'Crear Nuevo'
,p_link=>'f?p=&APP_ID.:1615:&SESSION.'
,p_page_id=>1615
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(249362552874932995.4001)
,p_parent_id=>wwv_flow_api.id(154028932045622478.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:1616:&SESSION.'
,p_page_id=>1616
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(253963607633373765.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Diccionario de Atributos'
,p_link=>'f?p=&APP_ID.:889:&SESSION.::&DEBUG.:::'
,p_page_id=>889
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(254017812776206966.4001)
,p_parent_id=>wwv_flow_api.id(428271320102552345.4001)
,p_short_name=>'Actualizar Utilizando Elementos'
,p_link=>'f?p=&APP_ID.:890:&SESSION.::&DEBUG.:::'
,p_page_id=>890
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(257001006001664029.4001)
,p_parent_id=>wwv_flow_api.id(428271320102552345.4001)
,p_short_name=>'Actualizar Diccionario de Atributos'
,p_link=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:::'
,p_page_id=>906
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(257126724392643061.4001)
,p_parent_id=>wwv_flow_api.id(428271320102552345.4001)
,p_short_name=>'Actualizar Diccionario de Atributos'
,p_link=>'f?p=&APP_ID.:907:&SESSION.::&DEBUG.:::'
,p_page_id=>907
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(257310231384323421.4001)
,p_parent_id=>wwv_flow_api.id(428271320102552345.4001)
,p_short_name=>'Actualizar Uso de Columnas de Informe'
,p_link=>'f?p=&APP_ID.:897:&SESSION.::&DEBUG.:::'
,p_page_id=>897
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(274110007727705515.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Interfaz de Usuario'
,p_link=>'f?p=&APP_ID.:1207:&SESSION.'
,p_page_id=>1207
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(275501504241784015.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Informe')
,p_link=>'f?p=&APP_ID.:505:&SESSION.::&DEBUG.:::'
,p_page_id=>505
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(294926122622741686.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Crear Plantilla de Etiqueta'
,p_link=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.:::'
,p_page_id=>353
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(307837328746538120.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>'Carga de Datos'
,p_link=>'f?p=&APP_ID.:1706:&SESSION.::&DEBUG.:::'
,p_page_id=>1706
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(309903827724755760.4001)
,p_parent_id=>wwv_flow_api.id(699056895544610173.4001)
,p_short_name=>'Servidores Remotos'
,p_link=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.:::'
,p_page_id=>1931
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(327358221301817083.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Sincronizar Orden de Columnas con Origen de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:276:&SESSION.::&DEBUG.:::'
,p_page_id=>276
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(327665506273148385.4001)
,p_parent_id=>wwv_flow_api.id(28660023095978630.4001)
,p_short_name=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_link=>'f?p=&APP_ID.:891:&SESSION.::&DEBUG.:891::'
,p_page_id=>891
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(366556404137741695.4001)
,p_parent_id=>wwv_flow_api.id(59091202259431920.4001)
,p_short_name=>'Estilos de Tema'
,p_link=>'f?p=&FLOW_ID.:177:&SESSION.'
,p_page_id=>177
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(380041921403746617.4001)
,p_parent_id=>wwv_flow_api.id(24448222218694942.4001)
,p_short_name=>unistr('Cambiar Secuencia de Scripts de Actualizaci\00F3n')
,p_link=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:::'
,p_page_id=>38
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(386913179276970625.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('P\00E1gina Global')
,p_link=>'f?p=&FLOW_ID.:0:&SESSION.'
,p_page_id=>0
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(394075449806720627.4001)
,p_parent_id=>wwv_flow_api.id(22464532161251314.4001)
,p_short_name=>'Script SQL'
,p_link=>'f?p=&APP_ID.:432:&SESSION.::&DEBUG.:::'
,p_page_id=>432
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(403370909018934213.4001)
,p_parent_id=>wwv_flow_api.id(24448222218694942.4001)
,p_short_name=>'Script'
,p_link=>'f?p=&APP_ID.:457:&SESSION.::&DEBUG.:::'
,p_page_id=>457
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(403372480392000869.4001)
,p_parent_id=>wwv_flow_api.id(22494629499343773.4001)
,p_short_name=>'Script'
,p_link=>'f?p=&APP_ID.:462:&SESSION.::&DEBUG.:::'
,p_page_id=>462
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(427745549021846101.4001)
,p_parent_id=>wwv_flow_api.id(6342315964532655.4001)
,p_short_name=>unistr('Buscar p\00E1ginas de aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(428271320102552345.4001)
,p_parent_id=>wwv_flow_api.id(194857168593967619.4001)
,p_short_name=>'Diccionario de Atributos'
,p_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
,p_page_id=>912
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(444637522100159006.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Actualizar Aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
,p_page_id=>89
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(445531401578394152.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>'Editar Cabeceras de Columna de Informe Interactivo'
,p_link=>'f?p=&FLOW_ID.:690:&SESSION.'
,p_page_id=>690
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(446031725196062481.4001)
,p_parent_id=>wwv_flow_api.id(428271320102552345.4001)
,p_short_name=>'Actualizar Elementos'
,p_link=>'f?p=&FLOW_ID.:921:&SESSION.'
,p_page_id=>921
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(446120818406960365.4001)
,p_parent_id=>wwv_flow_api.id(428271320102552345.4001)
,p_short_name=>'Actualizar Columnas de Informe'
,p_link=>'f?p=&FLOW_ID.:922:&SESSION.'
,p_page_id=>922
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(450480426634467558.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Separadores'
,p_link=>'f?p=&APP_ID.:643:&SESSION.::&DEBUG.:::'
,p_page_id=>643
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(451217904250711518.4001)
,p_parent_id=>wwv_flow_api.id(623973113062360507.4001)
,p_short_name=>'Depurar Datos de Mensaje'
,p_link=>'f?p=&APP_ID.:938:&SESSION.::&DEBUG.:::'
,p_page_id=>938
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(451363105591759348.4001)
,p_parent_id=>wwv_flow_api.id(193869708580501594.4001)
,p_short_name=>unistr('Actualizar Configuraci\00F3n de Informes Interactivos')
,p_link=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.:::'
,p_page_id=>940
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459820809191755570.4001)
,p_parent_id=>wwv_flow_api.id(444637522100159006.4001)
,p_short_name=>'Actualizar'
,p_link=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::'
,p_page_id=>911
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(460752226925843770.4001)
,p_parent_id=>wwv_flow_api.id(460758329010914370.4001)
,p_short_name=>unistr('Confirmar Supresi\00F3n')
,p_link=>'f?p=&APP_ID.:936:&SESSION.::&DEBUG.:::'
,p_page_id=>936
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(460758329010914370.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>unistr('Propiedades de Hoja de C\00E1lculo Web &P933_ID.')
,p_link=>'f?p=&APP_ID.:933:&SESSION.::&DEBUG.:::'
,p_page_id=>933
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472187826172691526.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.:::'
,p_page_id=>689
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472557222703196880.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Buscar aplicaciones'
,p_link=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:RP::'
,p_page_id=>69
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472703113122672343.4001)
,p_parent_id=>wwv_flow_api.id(45432327870093655.4001)
,p_short_name=>'Importar Comentarios'
,p_link=>'f?p=&FLOW_ID.:929:&SESSION.'
,p_page_id=>929
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(477698219810900844.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&APP_ID.:574:&SESSION.::&DEBUG.:::'
,p_page_id=>574
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(477728918687919422.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&APP_ID.:564:&SESSION.::&DEBUG.:::'
,p_page_id=>564
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(477729623320930173.4001)
,p_parent_id=>wwv_flow_api.id(6348417766566072.4001)
,p_short_name=>'Copiar Plantilla'
,p_link=>'f?p=&APP_ID.:571:&SESSION.::&DEBUG.:::'
,p_page_id=>571
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(480498430720969430.4001)
,p_parent_id=>wwv_flow_api.id(107237015875905749.4001)
,p_short_name=>unistr('Anular Validaci\00F3n de Marcadores')
,p_link=>'f?p=&APP_ID.:517:&SESSION.::&DEBUG.:::'
,p_page_id=>517
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(484013427405581669.4001)
,p_parent_id=>wwv_flow_api.id(444637522100159006.4001)
,p_short_name=>'Actualizar'
,p_link=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_page_id=>86
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(486266928105411132.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:::'
,p_page_id=>523
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(486423714718175502.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Exportar'
,p_link=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:::'
,p_page_id=>541
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(486480628544732443.4001)
,p_parent_id=>wwv_flow_api.id(460758329010914370.4001)
,p_short_name=>'Objetos Sugeridos'
,p_link=>'f?p=&APP_ID.:559:&SESSION.::&DEBUG.:::'
,p_page_id=>559
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(488268527287879679.4001)
,p_parent_id=>wwv_flow_api.id(460758329010914370.4001)
,p_short_name=>'Lista de Control de Acceso'
,p_link=>'f?p=&APP_ID.:934:&SESSION.::&DEBUG.:::'
,p_page_id=>934
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(488313704933990887.4001)
,p_parent_id=>wwv_flow_api.id(488268527287879679.4001)
,p_short_name=>'Detalles de Entrada'
,p_link=>'f?p=&APP_ID.:937:&SESSION.::&DEBUG.:::'
,p_page_id=>937
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(492050414626710006.4001)
,p_parent_id=>wwv_flow_api.id(444637522100159006.4001)
,p_short_name=>'Actualizar'
,p_link=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.:::'
,p_page_id=>646
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(492636106117616338.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Utilidades de P\00E1gina Cruzada')
,p_link=>'f?p=&APP_ID.:553:&SESSION.::&DEBUG.:::'
,p_page_id=>553
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(495865506686956046.4001)
,p_parent_id=>wwv_flow_api.id(444637522100159006.4001)
,p_short_name=>'Actualizar'
,p_link=>'f?p=&APP_ID.:383:&SESSION.::&DEBUG.:::'
,p_page_id=>383
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(533149940857152602.4001)
,p_parent_id=>wwv_flow_api.id(309903827724755760.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&APP_ID.:1933:&SESSION.::&DEBUG.:::'
,p_page_id=>1933
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(533184927171295694.4001)
,p_parent_id=>wwv_flow_api.id(309903827724755760.4001)
,p_short_name=>'Historial'
,p_link=>'f?p=&APP_ID.:1934:&SESSION.'
,p_page_id=>1934
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(564744424516402988.4001)
,p_parent_id=>wwv_flow_api.id(225891858843186075.4001)
,p_short_name=>'Sincronizaciones'
,p_link=>'f?p=&APP_ID.:1955:&SESSION.::&DEBUG.:::'
,p_page_id=>1955
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(577470581050015566.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>'Fuente APEX'
,p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::'
,p_page_id=>110
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(584640985236978343.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Crear Script: Seleccionar Objetos'
,p_link=>'f?p=&APP_ID.:858:&SESSION.'
,p_page_id=>858
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(597508154994597521.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Informe de total de control de p\00E1gina')
,p_link=>'f?p=&APP_ID.:111:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>111
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(623973113062360507.4001)
,p_parent_id=>wwv_flow_api.id(177829529391401676.4001)
,p_short_name=>unistr('Mensajes de Depuraci\00F3n')
,p_link=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:::'
,p_page_id=>666
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(624021011236959577.4001)
,p_parent_id=>wwv_flow_api.id(623973113062360507.4001)
,p_short_name=>unistr('Depurar Mensajes de Depuraci\00F3n')
,p_link=>'f?p=&APP_ID.:748:&SESSION.::&DEBUG.:::'
,p_page_id=>748
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(631170709627388717.4001)
,p_parent_id=>wwv_flow_api.id(6356205677586897.4001)
,p_short_name=>'Uso'
,p_link=>'f?p=&FLOW_ID.:87:&SESSION.'
,p_page_id=>87
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(631612905189532653.4001)
,p_parent_id=>wwv_flow_api.id(444637522100159006.4001)
,p_short_name=>unistr('Actualizar Aplicaci\00F3n')
,p_link=>'f?p=&FLOW_ID.:862:&SESSION.'
,p_page_id=>862
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(659464448337551065.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:4850:&SESSION.'
,p_page_id=>4850
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(659500903805635280.4001)
,p_parent_id=>wwv_flow_api.id(659464448337551065.4001)
,p_short_name=>'Detalles'
,p_link=>'f?p=&APP_ID.:4851:&SESSION.::&DEBUG.:::'
,p_page_id=>4851
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(680963074297437695.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Plantillas de correo electr\00F3nico')
,p_link=>'f?p=&APP_ID.:4860:&SESSION.'
,p_page_id=>4860
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(681164084121866571.4001)
,p_parent_id=>wwv_flow_api.id(680963074297437695.4001)
,p_short_name=>'Detalles'
,p_link=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:::'
,p_page_id=>4861
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(687109918814982030.4001)
,p_parent_id=>wwv_flow_api.id(59091202259431920.4001)
,p_short_name=>'Grupos de Opciones de Plantilla'
,p_link=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_page_id=>81
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(693288905982721697.4001)
,p_parent_id=>wwv_flow_api.id(95667010592946781.4001)
,p_short_name=>'Consultas de Tabla'
,p_link=>'f?p=&APP_ID.:1802:&SESSION.::&DEBUG.:::'
,p_page_id=>1802
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(699056895544610173.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Utilidades del Espacio de Trabajo'
,p_link=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_page_id=>182
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(715723076367144322.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>unistr('Control de acceso a la aplicaci\00F3n')
,p_link=>'f?p=&APP_ID.:2300:&SESSION.::&DEBUG.:::'
,p_page_id=>2300
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(740988995699531167.4001)
,p_parent_id=>wwv_flow_api.id(6735531807989290.4001)
,p_short_name=>'Temas'
,p_link=>'f?p=&FLOW_ID.:260:&SESSION.'
,p_page_id=>260
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(787143871474093343.4001)
,p_parent_id=>wwv_flow_api.id(1308911481947279.4001)
,p_short_name=>'Panel de Control'
,p_link=>'f?p=&APP_ID.:160:&SESSION.'
,p_page_id=>160
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(803059030754798247.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>' &P4462_REGION_TYPE_DISPLAY_NAME.'
,p_link=>'f?p=&APP_ID.:4461:&SESSION.::&DEBUG.:::'
,p_page_id=>4461
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(803539216636852734.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>'&P4462_REGION_TYPE_DISPLAY_NAME.'
,p_link=>'f?p=&APP_ID.:4462:&SESSION.::&DEBUG.:::'
,p_page_id=>4462
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(806101909704251085.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>' &P4462_REGION_TYPE_DISPLAY_NAME.'
,p_link=>'f?p=&APP_ID.:4464:&SESSION.::&DEBUG.:::'
,p_page_id=>4464
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(807119006646409672.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>' &P4462_REGION_TYPE_DISPLAY_NAME.'
,p_link=>'f?p=&APP_ID.:4465:&SESSION.::&DEBUG.:::'
,p_page_id=>4465
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(807922215717507828.4001)
,p_parent_id=>wwv_flow_api.id(21173412948919620.4001)
,p_short_name=>' &P4462_REGION_TYPE_DISPLAY_NAME.'
,p_link=>'f?p=&APP_ID.:4466:&SESSION.::&DEBUG.:::'
,p_page_id=>4466
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(857797331467455145.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>unistr('Editar Columna de Regi\00F3n')
,p_link=>'f?p=&APP_ID.:4486:&SESSION.'
,p_page_id=>4486
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(857902555832260947.4001)
,p_parent_id=>wwv_flow_api.id(799613605926722.4001)
,p_short_name=>'Bloquear Script'
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(936713755243179424.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Calendario y Pantalla'
,p_link=>'f?p=&APP_ID.:234:&SESSION.'
,p_page_id=>234
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(936743079352383003.4001)
,p_parent_id=>wwv_flow_api.id(.4001)
,p_short_name=>'Crear Calendario y Pantalla'
,p_link=>'f?p=&APP_ID.:274:&SESSION.'
,p_page_id=>274
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1141854268573856037.4001)
,p_parent_id=>wwv_flow_api.id(36775909817926063.4001)
,p_short_name=>'Editar Ayuda de Elemento'
,p_link=>'f?p=&APP_ID.:390:&SESSION.::&DEBUG.:::'
,p_page_id=>390
);
end;
/
begin
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1146699911367401673.4001)
,p_parent_id=>wwv_flow_api.id(36775909817926063.4001)
,p_short_name=>'Publicar Ayuda de Elemento'
,p_link=>'f?p=&APP_ID.:449:&SESSION.::&DEBUG.:::'
,p_page_id=>449
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1433725849092861525.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_short_name=>unistr('Restaurar Suscripci\00F3n a Tema')
,p_link=>'f?p=&APP_ID.:117:&SESSION.'
,p_page_id=>117
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1434105149541321464.4001)
,p_parent_id=>wwv_flow_api.id(27799320681844329.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:::'
,p_page_id=>4402
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1434160321580350908.4001)
,p_parent_id=>wwv_flow_api.id(27799320681844329.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:::'
,p_page_id=>4404
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(1434164955894375409.4001)
,p_parent_id=>wwv_flow_api.id(27799320681844329.4001)
,p_short_name=>'Crear'
,p_link=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.:::'
,p_page_id=>4406
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3801099868410190.4001)
,p_parent_id=>wwv_flow_api.id(27799320681844329.4001)
,p_option_sequence=>20
,p_short_name=>'Editar'
,p_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410:P4410_ID,FB_FLOW_ID:&P4410_ID.,&FB_FLOW_ID.'
,p_page_id=>4410
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P4410_ID is not null and :APP_PAGE_ID = 4410'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3600263368521940.4001)
,p_parent_id=>wwv_flow_api.id(27799320681844329.4001)
,p_option_sequence=>30
,p_short_name=>'&G_BC_PARENT_LABEL!HTML.'
,p_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410:FB_FLOW_ID,P4410_ID:&P118_APP_ID.,&P118_PLUGIN_ID.'
,p_page_id=>4410
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''PLUGIN'''
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(3803609664693374.4001)
,p_parent_id=>wwv_flow_api.id(740988995699531167.4001)
,p_option_sequence=>30
,p_short_name=>'&G_BC_PARENT_LABEL!HTML.'
,p_link=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::'
,p_page_id=>267
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''THEME'''
,p_display_when_condition2=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_restful_web_services
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(4868606398075172.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - RESTful Web Services.es'
,p_internal_name=>'APEX_5.0_RESTFUL_WEB_SERVICES'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="a-Page--webservices #PAGE_CSS_CLASSES#">',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <aside class="a-Side a-Side--left a-Side--large">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>754942495369044641.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140159404335347963.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140159518217347963.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140159650934347963.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140159717720347963.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140159827783347963.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140159992452347963.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140160081457347962.4001)
,p_page_template_id=>wwv_flow_api.id(4868606398075172.4001)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_popup
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(19943204431962826.4001)
,p_theme_id=>3
,p_name=>'APEX 4.2 - Popup.es'
,p_internal_name=>'APEX_4.2_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title><link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head><body #ONLOAD# style="min-width:380px;"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>',
'  <div id="RP2">#REGION_POSITION_02#</div>',
'  <div id="RP3">#REGION_POSITION_03#</div>',
'  <div id="RP4">#REGION_POSITION_04#</div>',
'  <div id="RP5">#REGION_POSITION_05#</div>',
'  <div class="popupContent" id="ContentArea">#BODY#</div>',
'</div>',
'<div id="RP8" style="text-align:middle;">#REGION_POSITION_08#</div>',
'<br />',
'<br />',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>36144306570651063.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004808615349557.4001)
,p_page_template_id=>wwv_flow_api.id(19943204431962826.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004909056349556.4001)
,p_page_template_id=>wwv_flow_api.id(19943204431962826.4001)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140005027126349556.4001)
,p_page_template_id=>wwv_flow_api.id(19943204431962826.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140005118168349556.4001)
,p_page_template_id=>wwv_flow_api.id(19943204431962826.4001)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140005249925349556.4001)
,p_page_template_id=>wwv_flow_api.id(19943204431962826.4001)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140005380643349556.4001)
,p_page_template_id=>wwv_flow_api.id(19943204431962826.4001)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(120871216744825711.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.es'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140003943334349560.4001)
,p_page_template_id=>wwv_flow_api.id(120871216744825711.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004078776349560.4001)
,p_page_template_id=>wwv_flow_api.id(120871216744825711.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004185188349560.4001)
,p_page_template_id=>wwv_flow_api.id(120871216744825711.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_page_designer
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(384711093594980574.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Page Designer.es'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER'
,p_is_popup=>false
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( apex.jQuery( "#successMessage" ).length > 0 ) {',
'    window.pageDesigner.showNotification( apex.jQuery( "#successMessage" ).text() );',
'}'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="#PAGE_CSS_CLASSES#">',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_01#',
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" style="display: none;" id="pdNotification">',
' <div class="a-AlertMessages-item">',
'  <div id="pdNotificationState" class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span id="pdNotificationIcon" class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="pdNotificationMessage">#PD_MESSAGE#</h5>',
'      <button id="pdNotificationClose" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'',
'',
'<div id="a_PageDesigner" class="a-PageDesigner resize">',
'  #REGION_POSITION_02#',
'  #REGION_POSITION_03#',
'  #REGION_POSITION_04#',
'  #BODY#',
'  <div style="display:none;">',
'  #REGION_POSITION_06#',
'  </div>',
'</div>',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>-->',
'<div style="display: none;" id="successMessage">#SUCCESS_MESSAGE#</div>',
''))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE" role="alert">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>'<div class="apex-container">#ROWS#</div>'
,p_grid_row_template=>'<div class="apex-row">#COLUMNS#</div>'
,p_grid_column_template=>'<div class="apex-col apex-col-#COLUMN_NUMBER# #CSS_CLASSES#">#CONTENT#</div>'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004292269349560.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004303977349560.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004499387349560.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004526708349560.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004674063349559.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140004731594349559.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(384711329924980579.4001)
,p_page_template_id=>wwv_flow_api.id(384711093594980574.4001)
,p_name=>'Dialog Area'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>-1
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(386677207130845076.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.es'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159300761622279879.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159301243760279879.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159301719600279879.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159302291339279880.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159302700966279880.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159303216654279880.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159303746287279881.4001)
,p_page_template_id=>wwv_flow_api.id(386677207130845076.4001)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(438185046231548086.4001)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search.es'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <aside class="a-Side" style="width: 280px">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438192043812548123.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438192528643548124.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438193042673548124.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438193521457548124.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438194005030548125.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438194527791548137.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(438195022645548137.4001)
,p_page_template_id=>wwv_flow_api.id(438185046231548086.4001)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(689065306389965836.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.es'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140006862099349553.4001)
,p_page_template_id=>wwv_flow_api.id(689065306389965836.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140006923169349553.4001)
,p_page_template_id=>wwv_flow_api.id(689065306389965836.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007089908349553.4001)
,p_page_template_id=>wwv_flow_api.id(689065306389965836.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(689605897838965863.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.es'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007104240349553.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007221272349552.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007391386349552.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007474838349552.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007568053349552.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007609548349552.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159305641815279892.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(159306106760279894.4001)
,p_page_template_id=>wwv_flow_api.id(689605897838965863.4001)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(698674781428105900.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.es'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007757838349552.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007893423349552.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140007946445349551.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008040660349551.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008183755349551.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008233068349551.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008309141349551.4001)
,p_page_template_id=>wwv_flow_api.id(698674781428105900.4001)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(702688271851047856.4001)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.es'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_height=>'auto'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4001
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008471641349551.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008515886349551.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008607982349551.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008787326349551.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008854286349550.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140008955441349550.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140009097252349550.4001)
,p_page_template_id=>wwv_flow_api.id(702688271851047856.4001)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3705362896815.4001)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4001
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3770144455858.4001)
,p_template_name=>'APEX 5.0 - Icon Badge Menu Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_reference_id=>631020159860848910.4001
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3781715377307.4001)
,p_template_name=>'APEX 5.0 - Icon Badge Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><span class="a-But'
||'ton-badge"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><spa'
||'n class="a-Button-badge"></span></button>'
,p_reference_id=>631020282344854024.4001
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(183227826797404355.4001)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4001
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(354034308421865099.4001)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4001
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(651364628215578370.4001)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4001
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon_not_escaped
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(2045667935478789095.4001)
,p_template_name=>'APEX 5.0 - Button with Icon - NOT ESCAPED'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON_NOT_ESCAPED'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/gray_box_c_htmldbgraybox
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(344742548.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion altHeading editRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'      <a href="#" class="aIconButton" onclick="uF();return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" class="upIcon" alt="&TOP." /></a>',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'Gray Box (c:htmldbGrayBox)'
,p_internal_name=>'GRAY_BOX_C:HTMLDBGRAYBOX'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>17353903289599940.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395037301344623.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395145826344623.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395281285344623.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395311482344623.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395471309344623.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395569094344623.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395665125344622.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395739243344622.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395828187344622.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140395930074344622.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396077981344622.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396113974344622.4001)
,p_plug_template_id=>wwv_flow_api.id(344742548.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/search_and_replace_region_editor
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(4753713214324595.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <script type="text/javascript">  ',
'    function toggleFind() {',
'      html_ToggleElement(''body#REGION_ID#'');  ',
'    }',
'  </script>',
'  <div id="body#REGION_ID#" style="display:none;">',
'    <table cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">',
'      <tr>',
'        <td valign="top">#BODY#</td>',
'        <td valign="top">#CLOSE##EDIT##DELETE##CREATE##CREATE2##PREVIOUS##NEXT#</td>',
'      </tr>',
'    </table>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Search and Replace Region (Editor)'
,p_internal_name=>'SEARCH_AND_REPLACE_REGION_EDITOR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>112829305325461983.4001
,p_translate_this_template=>'N'
,p_template_comment=>'Gray Head, white body'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396230160344622.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396321604344622.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396439781344622.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396591472344621.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396678974344621.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396747943344621.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396863647344621.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140396964945344621.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397003450344621.4001)
,p_plug_template_id=>wwv_flow_api.id(4753713214324595.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(5938210987232439.4001)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #COMPONENT_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397172451344621.4001)
,p_plug_template_id=>wwv_flow_api.id(5938210987232439.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397281962344621.4001)
,p_plug_template_id=>wwv_flow_api.id(5938210987232439.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(29434107863295859.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397307205344621.4001)
,p_plug_template_id=>wwv_flow_api.id(29434107863295859.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397435646344621.4001)
,p_plug_template_id=>wwv_flow_api.id(29434107863295859.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_gray_top
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(32617604264695688.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion smallRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Small (Gray Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_GRAY_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>32612420016685806.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397591502344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397650493344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397716283344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397830201344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140397918894344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398009671344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398178740344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398240997344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398313626344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398408435344620.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398595705344619.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398616222344619.4001)
,p_plug_template_id=>wwv_flow_api.id(32617604264695688.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_wide
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(35941518945222321.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-wiz-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="width:100%;">',
'  <div class="rc-blue-top"><div class="rc-blue-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box (wide)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_WIDE'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>35936104232216540.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398781936344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398801838344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140398952884344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399018295344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399109889344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399235561344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399389639344619.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399480806344618.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399523263344618.4001)
,p_plug_template_id=>wwv_flow_api.id(35941518945222321.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(40778201261099606.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399643312344618.4001)
,p_plug_template_id=>wwv_flow_api.id(40778201261099606.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399727295344618.4001)
,p_plug_template_id=>wwv_flow_api.id(40778201261099606.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(42025417508627628.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399828908344618.4001)
,p_plug_template_id=>wwv_flow_api.id(42025417508627628.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140399949608344618.4001)
,p_plug_template_id=>wwv_flow_api.id(42025417508627628.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(42027416946637016.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400008431344618.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400181633344618.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400240233344618.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400344130344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400409174344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400540962344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400636248344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400768428344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400887356344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140400910787344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401006354344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140401108933344617.4001)
,p_plug_template_id=>wwv_flow_api.id(42027416946637016.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91980429263284255.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box'
,p_internal_name=>'APEX_4.0_WIZARD_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411729869344606.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411895304344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140411951416344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412048814344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412117996344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412277736344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412349660344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412431507344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412503024344605.4001)
,p_plug_template_id=>wwv_flow_api.id(91980429263284255.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/finder_help
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(107834009497616535.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Finder Help'
,p_internal_name=>'FINDER_HELP'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412630127344605.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412723365344605.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412836059344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140412997194344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413014008344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413191530344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413207270344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413382894344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413443454344604.4001)
,p_plug_template_id=>wwv_flow_api.id(107834009497616535.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/page_edit_standard_content
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(109502816944998716.4001)
,p_layout=>'TABLE'
,p_template=>'<section class="aRegion smallHeading noPadding componentRegion #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>#BODY#</section>'
,p_page_plug_template_name=>'Page Edit - Standard Content'
,p_internal_name=>'PAGE_EDIT_STANDARD_CONTENT'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413549144344604.4001)
,p_plug_template_id=>wwv_flow_api.id(109502816944998716.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413698329344604.4001)
,p_plug_template_id=>wwv_flow_api.id(109502816944998716.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_page_edit_component_top_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(109512004324037517.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="componentViewHeader aRegion #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <h1>#TITLE#</h1>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Page Edit Component Top Bar'
,p_internal_name=>'APEX_4.2_PAGE_EDIT_COMPONENT_TOP_BAR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413714652344604.4001)
,p_plug_template_id=>wwv_flow_api.id(109512004324037517.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413830300344603.4001)
,p_plug_template_id=>wwv_flow_api.id(109512004324037517.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(148578007466880598.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Confirm)'
,p_internal_name=>'WIZARD_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140413912749344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414001393344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414129571344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414275936344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414359659344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414427796344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414590612344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414600188344603.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414767571344602.4001)
,p_plug_template_id=>wwv_flow_api.id(148578007466880598.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_success
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(149181713705350218.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion successRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Success)'
,p_internal_name=>'WIZARD_BOX_SUCCESS'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>149030901078827666.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414881667344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140414917287344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415018701344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415160909344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415291256344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415318548344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415498625344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415574401344602.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415650822344601.4001)
,p_plug_template_id=>wwv_flow_api.id(149181713705350218.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_fail
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(163253924606461507.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion failRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Fail)'
,p_internal_name=>'WIZARD_BOX_FAIL'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>160023608986860686.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415765658344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415875788344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140415970303344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416057327344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416105194344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416243068344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416360460344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416418192344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416553147344601.4001)
,p_plug_template_id=>wwv_flow_api.id(163253924606461507.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_box_warning
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(163254430635461528.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion warningRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'Wizard Box (Warning)'
,p_internal_name=>'WIZARD_BOX_WARNING'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>162320107014603380.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416631715344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416797002344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416812452344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140416969886344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417087210344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417150114344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417257655344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417364084344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417427241344600.4001)
,p_plug_template_id=>wwv_flow_api.id(163254430635461528.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_accordion
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(174783926560064866.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Accordion resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  #SUB_REGIONS#',
'</div>',
''))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Accordion-item">',
'#SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Accordion'
,p_internal_name=>'APEX_5.0_ACCORDION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174746301430371105.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417575310344600.4001)
,p_plug_template_id=>wwv_flow_api.id(174783926560064866.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417635884344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174783926560064866.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(174784422470064928.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageColumn-header">',
'    <h2 class="a-PageColumn-heading">#TITLE#</h2>',
'  </div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417721055344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174784422470064928.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417851643344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174784422470064928.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_body
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(174793821995076649.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn-body resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (Body)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_BODY'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174630015632506596.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140417917728344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174793821995076649.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418006847344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174793821995076649.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(174794400314076650.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4001
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418172384344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418260651344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418351949344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418414618344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418529474344599.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418636797344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418763104344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418859322344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140418902392344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419059943344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419186879344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419248006344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419300815344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_top_buttons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(174795123140076650.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--left">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--right">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Top Buttons)'
,p_internal_name=>'APEX_5.0_REGION_TOP_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174747104640428780.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419491187344598.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419509329344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419612902344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419705397344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419821969344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140419985519344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420080177344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420143678344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420247822344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420305481344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420426695344597.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420598080344596.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420689387344596.4001)
,p_plug_template_id=>wwv_flow_api.id(174795123140076650.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(174795802901076650.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420788205344596.4001)
,p_plug_template_id=>wwv_flow_api.id(174795802901076650.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420810795344596.4001)
,p_plug_template_id=>wwv_flow_api.id(174795802901076650.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140420965384344596.4001)
,p_plug_template_id=>wwv_flow_api.id(174795802901076650.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421079419344596.4001)
,p_plug_template_id=>wwv_flow_api.id(174795802901076650.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_nested_splitter
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(177373906751600776.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="resize #REGION_CSS_CLASSES#"> ',
'#BODY#',
'<div id="#REGION_STATIC_ID#_content" class="resize">',
'#SUB_REGIONS#',
'</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Nested Splitter'
,p_internal_name=>'APEX_5.0_NESTED_SPLITTER'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421177672344596.4001)
,p_plug_template_id=>wwv_flow_api.id(177373906751600776.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421224592344596.4001)
,p_plug_template_id=>wwv_flow_api.id(177373906751600776.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(183219627032331552.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>',
''))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#">#SUB_REGION_TITLE#</a></li>'
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUB_REGION#',
''))
,p_page_plug_template_name=>'APEX 5.0 - Tabs'
,p_internal_name=>'APEX_5.0_TABS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>183211208341566300.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421373124344596.4001)
,p_plug_template_id=>wwv_flow_api.id(183219627032331552.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421425002344596.4001)
,p_plug_template_id=>wwv_flow_api.id(183219627032331552.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421515797344595.4001)
,p_plug_template_id=>wwv_flow_api.id(183219627032331552.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(196613003429111883.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421697143344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421799391344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421841776344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140421975125344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422071601344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422128681344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422260357344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422373957344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422426402344595.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422507323344594.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422650044344594.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422709485344594.4001)
,p_plug_template_id=>wwv_flow_api.id(196613003429111883.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_page_edit_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202157003786000649.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion pageEditBar #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'	<div class="gotoPage">',
'	#BODY##EXPAND#',
'	</div>',
'	<span class="lButtonContainer">',
'		#EDIT##CLOSE##CREATE##CREATE2##HELP##DELETE##COPY##PREVIOUS#',
'	</span>',
'	<div class="pageEditRight">',
'        <div class="rButtonContainer">',
'        #NEXT#',
'        </div>',
'		#SUB_REGIONS#',
'	</div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Page Edit Bar '
,p_internal_name=>'APEX_4.2_PAGE_EDIT_BAR_'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>202152130536978817.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422829646344594.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140422986640344594.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423065383344594.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423137925344594.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423251477344594.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423331257344594.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423471779344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423538786344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423670984344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423717044344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423831441344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140423985378344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202157003786000649.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_confirm
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202282905326760449.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Wizard Box (Confirm)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424016773344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424159230344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424245905344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424363860344593.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424444508344592.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424593037344592.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424665290344592.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424783455344592.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424899079344592.4001)
,p_plug_template_id=>wwv_flow_api.id(202282905326760449.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(208928010704475743.4001)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140424948273344592.4001)
,p_plug_template_id=>wwv_flow_api.id(208928010704475743.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425090523344592.4001)
,p_plug_template_id=>wwv_flow_api.id(208928010704475743.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(461857003642592155.4001)
,p_plug_template_id=>wwv_flow_api.id(208928010704475743.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(751335717669944972.4001)
,p_plug_template_id=>wwv_flow_api.id(208928010704475743.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_no_heading
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(226071526010722245.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (No Heading)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_NO_HEADING'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425149448344592.4001)
,p_plug_template_id=>wwv_flow_api.id(226071526010722245.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425277336344591.4001)
,p_plug_template_id=>wwv_flow_api.id(226071526010722245.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_for_list_buttons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(254081231995084695.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="topbar" style="width:100%;clear:both;" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="topbar-top"><div class="topbar-top-r"></div></div>',
'  <div class="topbar-body"><div class="topbar-body-r"><div class="topbar-content">',
'     #BODY#',
'   </div></div></div>',
'  <div class="topbar-bottom"><div class="topbar-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'APEX 4.0 - Top Bar (for list buttons)'
,p_internal_name=>'APEX_4.0_TOP_BAR_FOR_LIST_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>254074518265073133.4001
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425355129344591.4001)
,p_plug_template_id=>wwv_flow_api.id(254081231995084695.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425438089344591.4001)
,p_plug_template_id=>wwv_flow_api.id(254081231995084695.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(399849897040726767.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425574896344591.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425623657344591.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425784573344591.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425820488344591.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140425957577344591.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426056939344591.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426143002344590.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426278295344590.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426362238344590.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426494649344590.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426550836344590.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426666978344590.4001)
,p_plug_template_id=>wwv_flow_api.id(399849897040726767.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_19_1_blank_grid
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(461857790551605627.4001)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 19.1 - Blank (Grid)'
,p_internal_name=>'APEX_19.1_BLANK_GRID'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426760356344590.4001)
,p_plug_template_id=>wwv_flow_api.id(461857790551605627.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426845854344590.4001)
,p_plug_template_id=>wwv_flow_api.id(461857790551605627.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140426993300344590.4001)
,p_plug_template_id=>wwv_flow_api.id(461857790551605627.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427058644344590.4001)
,p_plug_template_id=>wwv_flow_api.id(461857790551605627.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_dialog
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(557449278618308550.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#"  class="a-DialogRegion js-regionDialog #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="a-DialogRegion-body">',
'#BODY#',
'  </div>',
'  <div class="a-DialogRegion-buttons">',
'     <div class="a-ButtonRegion a-ButtonRegion--dialogRegion">',
'       <div class="a-ButtonRegion-wrap">',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region Dialog'
,p_internal_name=>'APEX_5.0_REGION_DIALOG'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'js-draggable:js-modal:js-resizable'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>428597701677720079.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427121796344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427204159344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427356358344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427407993344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427516747344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427661422344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427730327344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427830013344589.4001)
,p_plug_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(646287526247383209.4001)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140427975876344589.4001)
,p_plug_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428018083344588.4001)
,p_plug_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428184417344588.4001)
,p_plug_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428238120344588.4001)
,p_plug_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(655568879441187677.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>698829239393878937.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428377726344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428476044344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428577951344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428637960344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428776825344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428856936344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140428928759344588.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429049284344587.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429155635344587.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429216533344587.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429388874344587.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429478120344587.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429553951344587.4001)
,p_plug_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(689274781922315777.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429659340344587.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429761770344587.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429800116344587.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140429957868344587.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430031826344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430165469344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430270073344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430361766344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430473959344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(689970285456172024.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430549322344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430683328344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430794407344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430841689344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140430940765344586.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431022213344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431115814344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431279247344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431335444344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431449446344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431596765344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431671162344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431728456344585.4001)
,p_plug_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(703488066986172098.4001)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431862554344585.4001)
,p_plug_template_id=>wwv_flow_api.id(703488066986172098.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140431948794344584.4001)
,p_plug_template_id=>wwv_flow_api.id(703488066986172098.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(770240542605907344.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432078751344584.4001)
,p_plug_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432104385344584.4001)
,p_plug_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432257438344584.4001)
,p_plug_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432348433344584.4001)
,p_plug_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432486846344584.4001)
,p_plug_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432571446344584.4001)
,p_plug_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_1_tabs_with_icons_text
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1094670710611261973.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="a-Tabs-label">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'APEX 5.1 - Tabs with Icons + Text'
,p_internal_name=>'APEX_5.1_TABS_WITH_ICONS_+_TEXT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1094662472079256126.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432618038344584.4001)
,p_plug_template_id=>wwv_flow_api.id(1094670710611261973.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432797085344584.4001)
,p_plug_template_id=>wwv_flow_api.id(1094670710611261973.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432850253344584.4001)
,p_plug_template_id=>wwv_flow_api.id(1094670710611261973.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1147295105621079968.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140432902361344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1147295105621079968.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433048816344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1147295105621079968.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_grouping_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#" role="group" aria-labelledby="#REGION_STATIC_ID#_label">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_label">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Grouping Region'
,p_internal_name=>'APEX_5.0_GROUPING_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody:a-Region--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1157694368668532777.4001
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433199078344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433247455344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433376303344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433435208344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433574389344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433683298344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433771848344583.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433817528344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140433965887344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434066420344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434133054344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434216526344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434366560344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_tree_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1493521415868700099.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-PageDesigner-treeRegion resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>',
'  <div class="a-Toolbar a-Toolbar-pageColumn a-Toolbar--treeRegion">',
'    <div class="a-Toolbar-items a-Toolbar-items--left">',
'      <h3 id="#REGION_STATIC_ID#_title" class="a-PageDesigner-treeTitle">#TITLE#</h3>',
'    </div>',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  <div class="a-PageDesigner-treeWrap u-ScrollingViewport resize">',
'    #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Tree Region'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_TREE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>1493511686675667790.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434473313344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1493521415868700099.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434531495344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1493521415868700099.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434634893344582.4001)
,p_plug_template_id=>wwv_flow_api.id(1493521415868700099.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs_with_icons
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(2046260646916292813.4001)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="u-VisuallyHidden">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'APEX 5.0 - Tabs with Icons'
,p_internal_name=>'APEX_5.0_TABS_WITH_ICONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2046249791523279568.4001
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434760072344582.4001)
,p_plug_template_id=>wwv_flow_api.id(2046260646916292813.4001)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434829875344581.4001)
,p_plug_template_id=>wwv_flow_api.id(2046260646916292813.4001)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140434937378344581.4001)
,p_plug_template_id=>wwv_flow_api.id(2046260646916292813.4001)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(3712705120335.4001)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(35066701739635046.4001)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(40780006081223991.4001)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/horizontal_list_with_images_fixed_width_30pxc_htmldblistimageshfw
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(74758915661371633.4001)
,p_list_template_current=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon" /></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_noncurrent=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon"/></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_name=>'Horizontal List with Images Fixed Width 30px(c:htmldbListImagesHFW)'
,p_internal_name=>'HORIZONTAL_LIST_WITH_IMAGES_FIXED_WIDTH_30PXC:HTMLDBLISTIMAGESHFW'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="htmldbListImages30px" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_reference_id=>338219701416750315.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(115202108671032786.4001)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728.4001
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/unordered_list_without_links
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(137847231212506770.4001)
,p_list_template_current=>'<li><span class="fielddata">#TEXT#</span></li>'
,p_list_template_noncurrent=>'<li><span class="fielddata">#TEXT#</a></li>'
,p_list_template_name=>'unordered list without links'
,p_internal_name=>'UNORDERED_LIST_WITHOUT_LINKS'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="htmldbUl">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(168712225287236339.4001)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705.4001
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_run_edit_bar
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(210393202311761690.4001)
,p_list_template_current=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_noncurrent=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_name=>'APEX 4.2 - Run / Edit Bar'
,p_internal_name=>'APEX_4.2_RUN_/_EDIT_BAR'
,p_theme_id=>3
,p_theme_class_id=>3
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="aRunEditBar">',
'  <li><span class="currentPage">&PAGE. &FB_FLOW_PAGE_ID.</span></li>'))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>210390516819756900.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_pull_down_button_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(253875121745621830.4001)
,p_list_template_current=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton #A01#" type="button"><span>#TEXT#</span></button> '
,p_list_template_noncurrent=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton #A01#" type="button"><span>#TEXT#</span></button> '
,p_list_template_name=>'APEX 4.0 - Pull Down Button List'
,p_internal_name=>'APEX_4.0_PULL_DOWN_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="rButtonContainer dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton #A01#" type="button"><span>#TEXT#</span></button> '
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></span></button> ',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>253872418832604079.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(384714985827023169.4001)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(481294291606549740.4001)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4001
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/unordered_list_no_links
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(492140130336707768.4001)
,p_list_template_current=>'<li>#TEXT#</li>'
,p_list_template_noncurrent=>'<li>#TEXT#</li>'
,p_list_template_name=>'Unordered List (no links)'
,p_internal_name=>'UNORDERED_LIST_NO_LINKS'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="htmldbUl">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(693422331030340241.4001)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(697214733556634905.4001)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1141991473595113955.4001)
,p_list_template_current=>'<li class="a-List-item is-current"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-List-item"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Basic List'
,p_internal_name=>'APEX_5.0_BASIC_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>1141986383000090627.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list_no_links
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1141992015120113961.4001)
,p_list_template_current=>'<li class="a-List-item is-current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li class="a-List-item">#TEXT#</li>'
,p_list_template_name=>'APEX 5.0 - Basic List (no links)'
,p_internal_name=>'APEX_5.0_BASIC_LIST_NO_LINKS'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List a-List--basic #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>1141988805895106920.4001
);
end;
/
prompt --application/shared_components/user_interface/templates/report/embedded_code_analysis
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1310649889953751.4001)
,p_row_template_name=>'Embedded Code'
,p_internal_name=>'EMBEDDED_CODE_ANALYSIS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-EmbeddedCode ">',
'  <div class="a-EmbeddedCode-header">',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--primary">',
'      <div class="a-EmbeddedCode-attr">#SCOPE_NAME#</div>',
'      <div class="a-EmbeddedCode-attr">#COMPONENT_TYPE_NAME#: #COMPONENT_NAME#</div>',
'    </div>',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--secondary">',
'      <div class="a-EmbeddedCode-attr">#GROUP_NAME#</div>',
'      <div class="a-EmbeddedCode-attr">#PROPERTY_NAME#</div>',
'    </div>',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--buttons">',
'      <!-- button data-link="" data-appid="#FLOW_ID#" data-pageid="#PAGE_ID#" data-typeid="#COMPONENT_TYPE_ID#" data-componentid="#COMPONENT_ID#">View</button -->',
'    </div>',
'  </div>',
'  <div class="a-EmbeddedCode-body">',
'    <!-- Code --><pre>#PROPERTY_SOURCE#</pre>',
'  </div>',
'</div>'))
,p_row_template_before_rows=>'<div class="apex-grid-container">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p1911_rest_services
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(4900642989550776.4001)
,p_row_template_name=>'P1911_REST_SERVICES'
,p_internal_name=>'P1911_REST_SERVICES'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <div class="a-ContentRowReport-itemWrap" id="service_#ID#">',
'    <div class="a-ContentRowReport-itemBody">',
'      <a class="a-ContentRowReport-itemContent" href="#" tabindex="0" style="text-decoration: none;" title="#LINK_TITLE#">',
'        <h3  class="a-ContentRowReport-itemTitle">#NAME#</h3>',
'        <div class="a-ContentRowReport-itemDescription">#DESCRIPTION#</div>',
'        <div class="a-ContentRowReport-itemDescription">#OPERATIONS_HTML#</div>',
'      </a>',
'      <div class="a-ContentRowReport-itemActions" aria-hidden="true">',
'          <span class="fa #ICON_CLASS#"></span>',
'      </div>',
'    </div>',
'  </div>',
''))
,p_row_template_before_rows=>' '
,p_row_template_after_rows=>' '
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(11667910335347890.4001)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/result
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(33634627411119986.4001)
,p_row_template_name=>'Result'
,p_internal_name=>'RESULT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td align="left" class="header" style="width:70px;">#COLUMN_HEADER#</th><td#ALIGNMENT#>#COLUMN_VALUE#</td></tr>',
''))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'table.htmldbStandard3 td.header { vertical-align:middle; }',
'table.htmldbStandard3 td.pagination { border: medium none; }',
'</style>',
'<table width="100%" cellpadding="0" cellspacing="0" class="htmldbStandard3" role="presentation" datatable=0 summary="">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>',
''))
,p_row_template_after_last=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>',
'<p/>',
'<table width="100%" cellpadding="0" cellspacing="0" class="htmldbStandard3" role="presentation" datatable=0 summary="">',
'<tbody>'))
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>6
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_2_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(47141516446071328.4001)
,p_row_template_name=>'APEX 4.2 - Portlet Row Template'
,p_internal_name=>'APEX_4.2_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_2_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(47939419129227350.4001)
,p_row_template_name=>'APEX 4.2 - Portlet Column Template'
,p_internal_name=>'APEX_4.2_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(82116118900238363.4001)
,p_row_template_name=>'Vertical Standard'
,p_internal_name=>'VERTICAL_STANDARD'
,p_row_template1=>'<tr><td scope="row" class="label">#COLUMN_HEADER#</td><td class="data">#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRegion2"  summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>' '
,p_row_template_after_last=>'<tr><td class="blank"><br /></td><td class="blank"><br /></td></tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>81978430803840109.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_vertical_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(82408032331628644.4001)
,p_row_template_name=>'APEX 5.0 - Vertical Report'
,p_internal_name=>'APEX_5.0_VERTICAL_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'  <td class="a-Report-cell a-Report-cell--header" scope="row">#COLUMN_HEADER#</td>',
'  <td class="a-Report-cell">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report a-Report--vertical a-Report--staticRowColors #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>' '
,p_row_template_after_last=>' '
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>1126924627125205941.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard_mru_ajax_sortable
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(113079930235887192.4001)
,p_row_template_name=>'Standard (MRU AJAX SORTABLE)'
,p_internal_name=>'STANDARD_MRU_AJAX_SORTABLE'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="u-Report"  border="0" summary="#REGION_TITLE#" id="report_#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'<tfoot>#PAGINATION#</tfoot>',
'</table>',
'<script type="text/javascript">',
'var g_rpreview_global = ''report_#REGION_ID#'';',
'var g_#REGION_ID#;',
'function f_#REGION_ID#(){',
'		g_#REGION_ID# =  new apex.tabular.sort(''report_#REGION_ID#'');',
'		g_#REGION_ID#.row.after_move = function(){rpreview()}',
'}',
'addLoadEvent(f_#REGION_ID#)',
'</script>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>113076128479881902.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(123728124628276646.4001)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/no_background
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(249244707741859303.4001)
,p_row_template_name=>'No Background'
,p_internal_name=>'NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# id="td#ROWNUM#_#COLNUM#" headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="htmldbRptNoBackground" summary="#REGION_TITLE#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr id="row#ROWNUM#">'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>237868603542157245.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p890_ad_matching_items
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(254124201814387924.4001)
,p_row_template_name=>'P890_AD_MATCHING_ITEMS'
,p_internal_name=>'P890_AD_MATCHING_ITEMS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#I_NAME#</td><td>#I_LABEL#</td><td>#I_HELP_TEXT#</td><td>#I_FORMAT_MASK#</td><td>#I_FORMAT_MASK2#</td><td>#I_DEFAULT#</td><td>#I_WIDTH#</td><td>#I_HEIGHT#</td><td>#I_DATA_TYPE#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>#C_COLUMN_NAME#</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_FORM_FORMAT_MASK#</td><td>#C_DEFAULT_VALUE#</td><td>#C_FORM_DISPLAY_WIDTH#</td><td>#C_FORM_DISPLAY_HEIGHT#</td><td>#C_'
||'FORM_DATA_TYPE#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p897_ad_matching_rc
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(257016805324994583.4001)
,p_row_template_name=>'P897_AD_MATCHING_RC'
,p_internal_name=>'P897_AD_MATCHING_RC'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#RC_NAME#</td><td>#RC_LABEL#</td><td>#RC_HELP_TEXT#</td><td>#RC_FORMAT_MASK#</td><td>#RC_FORMAT_MASK2#</td><td>#RC_REPORT_COL_ALIGN#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>&nbsp;</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_REPORT_FORMAT_MASK#</td><td>#C_REPORT_COL_ALIGN#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p921_ad_matching_items
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(446094518404500200.4001)
,p_row_template_name=>'P921_AD_MATCHING_ITEMS'
,p_internal_name=>'P921_AD_MATCHING_ITEMS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#I_NAME#</td><td>#I_LABEL#</td><td>#I_HELP_TEXT#</td><td>#I_FORMAT_MASK#</td><td>#I_DEFAULT#</td><td>#I_WIDTH#</td><td>#I_HEIGHT#</td><td>#I_DATA_TYPE#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>#C_COLUMN_NAME#</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_DEFAULT_VALUE#</td><td>#C_FORM_DISPLAY_WIDTH#</td><td>#C_FORM_DISPLAY_HEIGHT#</td><td>#C_FORM_DATA_TYPE#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p922_ad_matching_rc
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(446251712544425577.4001)
,p_row_template_name=>'P922_AD_MATCHING_RC'
,p_internal_name=>'P922_AD_MATCHING_RC'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#RC_NAME#</td><td>#RC_LABEL#</td><td>#RC_HELP_TEXT#</td><td>#RC_FORMAT_MASK#</td><td>#RC_REPORT_COL_ALIGN#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>&nbsp;</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_REPORT_COL_ALIGN#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041639921134406508.4001)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AppCards a-AppCards--slim  a-AppCards--stacked">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041645002243406588.4001)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041645860037406591.4001)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041646592238406593.4001)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(4923925522744860.4001)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional_no_labelonly_for_radiogroup
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(43067330834852524.4001)
,p_template_name=>'FormField_Optional (no label-only for radiogroup)'
,p_internal_name=>'FORMFIELD_OPTIONAL_NO_LABELONLY_FOR_RADIOGROUP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43065615312847035.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_4_0_top_bar_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(57731626458856526.4001)
,p_template_name=>'APEX 4.0 - Top Bar Label'
,p_internal_name=>'APEX_4.0_TOP_BAR_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(93372822814585113.4001)
,p_template_name=>'FormField_Optional'
,p_internal_name=>'FORMFIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041.4001
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/columnheader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(94297512553409964.4001)
,p_template_name=>'ColumnHeader'
,p_internal_name=>'COLUMNHEADER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041.4001
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(452656722938220607.4001)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(561547836135222071.4001)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(561549638722251517.4001)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(561549716994252345.4001)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(566010921977401124.4001)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(566053095724681231.4001)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="" aria-label="" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span>'
||'</button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4001
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(3705314539083.4001)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4001
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(10217320099610442.4001)
,p_page_name=>'winlov'
,p_page_title=>unistr('B\00FAsqueda')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Buscar'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Cerrar'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Siguiente &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Anterior'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Filas #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4001
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(48746021817975821.4001)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4001
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(72328790154483268.4001)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(204021106338377303.4001)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556394191660089195.4001)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(556394903837090864.4001)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(557449644465308555.4001)
,p_theme_id=>3
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Predefined dialog sizes'
,p_null_text=>'Default Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689275479820315778.4001)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689276459702315779.4001)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689609975484986633.4001)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689612194925986634.4001)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868183333651274.4001)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868297807651274.4001)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868381320651274.4001)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868416983651275.4001)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868559342651275.4001)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868654527651275.4001)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868765490651276.4001)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868817587651276.4001)
,p_theme_id=>3
,p_name=>'MAX_HEIGHT'
,p_display_name=>'Max Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Max Height'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689868920676651276.4001)
,p_theme_id=>3
,p_name=>'MIN_HEIGHT'
,p_display_name=>'Min Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Min Height'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689869052561651276.4001)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689869144051651276.4001)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689869268409651276.4001)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689869335183651277.4001)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689869421097651277.4001)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689869558173651277.4001)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(689974585962172027.4001)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(693422786205340253.4001)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(696621762127145456.4001)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(697227913650708839.4001)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(740999402311610211.4001)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(740999733250610212.4001)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741000588924610212.4001)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(741000825482610212.4001)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(770240942803907358.4001)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(557450019695308556.4001)
,p_theme_id=>3
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_api.id(557449644465308555)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(557450481324308556.4001)
,p_theme_id=>3
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_api.id(557449644465308555)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(557450884814308556.4001)
,p_theme_id=>3
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_api.id(557449644465308555)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(557451214013308556.4001)
,p_theme_id=>3
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be moved.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(557451669999308556.4001)
,p_theme_id=>3
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
,p_help_text=>'Display as modal.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(557452054623308557.4001)
,p_theme_id=>3
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(557449278618308550.4001)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be resized.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697208282774627562.4001)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697208599626627562.4001)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697208841349627562.4001)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697209169260627562.4001)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697209451926627562.4001)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697209751633627562.4001)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697210078067627562.4001)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697210336187627563.4001)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697210620803627563.4001)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(697210944203627563.4001)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741089654519003588.4001)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741089874408003588.4001)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741090096334003588.4001)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741090264686003589.4001)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741090448934003589.4001)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741090694411003589.4001)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741090865640003590.4001)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(740999402311610211)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741091001367003591.4001)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741091228485003591.4001)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(689868183333651274)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741091450592003591.4001)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741091609300003591.4001)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741091829391003591.4001)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741092059119003591.4001)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(689868183333651274)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741092244160003591.4001)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(741000588924610212)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741092481259003591.4001)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(741000825482610212)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741092636692003591.4001)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(689868297807651274)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741092876511003591.4001)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(689868559342651275)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741093074530003591.4001)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(689868654527651275)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741093290797003592.4001)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(689868183333651274)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741093445931003592.4001)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(689868416983651275)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741093643245003592.4001)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(689868381320651274)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741093760024003592.4001)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741093930595003592.4001)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(689868297807651274)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741094134610003592.4001)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(689868559342651275)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741094365819003592.4001)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(689868654527651275)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741094405091003592.4001)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741094500525003592.4001)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741106414101342390.4001)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741106693350342391.4001)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741106839320342397.4001)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741107026275342397.4001)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741107203618342399.4001)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741107306045342399.4001)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741107560569342399.4001)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(741107715180342399.4001)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689274781922315777.4001)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770242153138907403.4001)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770242217774907403.4001)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770242455742907403.4001)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770242628364907403.4001)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770242837432907403.4001)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770243035659907403.4001)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770243278580907403.4001)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770243316570907403.4001)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(770243580216907404.4001)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(770240542605907344.4001)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787114313200949704.4001)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(689869052561651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787114559371949704.4001)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(689869558173651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787114799989949705.4001)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787114909189949705.4001)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787115121173949705.4001)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787115251459949705.4001)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(787115445447949705.4001)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(123728124628276646.4001)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(689869421097651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(928526155605885181.4001)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(928526230711885181.4001)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(940695146455341564.4001)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041642598877406586.4001)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041642782980406586.4001)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041642919363406586.4001)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041643122919406586.4001)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041643316814406586.4001)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041643534111406586.4001)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041643755288406586.4001)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041643993798406587.4001)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041644125366406587.4001)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041644335394406587.4001)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041644531040406588.4001)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041644798256406588.4001)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1041644987372406588.4001)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(1041640454953406573.4001)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131767082685193976.4001)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(82408032331628644.4001)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(689869558173651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131767234242193977.4001)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(82408032331628644.4001)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131767367046193977.4001)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(82408032331628644.4001)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131767505289193977.4001)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(82408032331628644.4001)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131767726172193977.4001)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(82408032331628644.4001)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(689869421097651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1131767933421193977.4001)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(82408032331628644.4001)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157703657591546357.4001)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157703851151546357.4001)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157704045732546357.4001)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157704296302546362.4001)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157704476411546362.4001)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157704697318546362.4001)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157704791946546362.4001)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157704943766546362.4001)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157705149026546362.4001)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157705301596546363.4001)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1157705569971546363.4001)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(1157701840355546344.4001)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1199561996520032428.4001)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(689868416983651275)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1241666629605396955.4001)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1147295105621079968.4001)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525650263272182045.4001)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525650309409182045.4001)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525650489655182045.4001)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525650593590182045.4001)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525650727471182049.4001)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525650922468182049.4001)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525666591122182129.4001)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525666601935182129.4001)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525666759120182129.4001)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525666870164182129.4001)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525667010590182130.4001)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1525667204783182130.4001)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544814692647477977.4001)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(11667910335347890.4001)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544814737392477978.4001)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(11667910335347890.4001)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1544814888710477978.4001)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(11667910335347890.4001)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554810431372408369.4001)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554810659695408369.4001)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554810897146408369.4001)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554811060927408369.4001)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554811297403408370.4001)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554811421358408370.4001)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554811633484408370.4001)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554811807637408370.4001)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554812055317408370.4001)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554812141738408370.4001)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554812303379408370.4001)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(174794400314076650.4001)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554833614262526816.4001)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554833748011526816.4001)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554833844943526816.4001)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(646287526247383209.4001)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554842901348542264.4001)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554843076144542264.4001)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554843225147542265.4001)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554843436268542265.4001)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554843620652542265.4001)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554843876432542265.4001)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554844000995542265.4001)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554844269412542265.4001)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554844448441542265.4001)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554844621223542265.4001)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(689970285456172024.4001)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554870725945550824.4001)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554870994093550824.4001)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554871126221550824.4001)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554871306470550825.4001)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554871539071550825.4001)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554871719655550825.4001)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554871913363550825.4001)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554872192256550825.4001)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554872363548550825.4001)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554872549647550825.4001)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(655568879441187677.4001)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(2045668162252789162.4001)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(2045667935478789095.4001)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(689868416983651275)
,p_template_types=>'BUTTON'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(30797216641778508.4001)
,p_build_option_name=>'Remove in APEX 5.1'
,p_build_option_status=>'INCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(103621306777465158.4001)
,p_build_option_name=>'Asynchronous Actions'
,p_build_option_status=>'INCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(121426746309283317.4001)
,p_build_option_name=>'Remove in APEX 22.1'
,p_build_option_status=>'EXCLUDE'
,p_build_option_comment=>'Used for components that are deleted as part of APEX-1012 task'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(170786031904296885.4001)
,p_build_option_name=>'Commented Out'
,p_build_option_status=>'EXCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(235700916833599805.4001)
,p_build_option_name=>'Do Not Include in APEX 4.2 EA1'
,p_build_option_status=>'INCLUDE'
,p_default_on_export=>'INCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(693447794026530907.4001)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(1338185675372185029.4001)
,p_build_option_name=>'Build Query Button'
,p_build_option_status=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759700770282107)
,p_name=>'APEX.REMOTESQL.OAUTH_IS_RECOMMENDED'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: Oracle recomienda el uso de credenciales de cliente de OAuth2 para la autenticaci\00F3n con SQL activado para REST.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757829173282105)
,p_name=>'APEX.WEBSRC.HIDE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Ocultar columnas seleccionadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757945112282105)
,p_name=>'APEX.WEBSRC.SHOW_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Mostrar columnas seleccionadas'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758915435282106)
,p_name=>'BUTTON.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795142606282133)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791916163282130)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795276219282133)
,p_name=>'CODE_EDITOR.FIND_INPUT'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792070057282131)
,p_name=>'CODE_EDITOR.FIND_NEXT'
,p_message_language=>'es'
,p_message_text=>'Buscar Siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792162715282131)
,p_name=>'CODE_EDITOR.FIND_PREV'
,p_message_language=>'es'
,p_message_text=>'Buscar Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792372840282131)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'es'
,p_message_text=>unistr('Terminar Autom\00E1ticamente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793014561282131)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Sangr\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792826851282131)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Espacios Insertados en Tabulaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794940015282133)
,p_name=>'CODE_EDITOR.MATCH_CASE'
,p_message_language=>'es'
,p_message_text=>unistr('Coincidir May\00FAsculas/Min\00FAsculas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795095647282133)
,p_name=>'CODE_EDITOR.MATCH_RE'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Regular')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797724334282135)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'es'
,p_message_text=>'Generador de Consultas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791847539282130)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'es'
,p_message_text=>'Rehacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792253872282131)
,p_name=>'CODE_EDITOR.REPLACE'
,p_message_language=>'es'
,p_message_text=>'Sustituir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795484999282133)
,p_name=>'CODE_EDITOR.REPLACE_ALL'
,p_message_language=>'es'
,p_message_text=>'Sustituir Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795344429282133)
,p_name=>'CODE_EDITOR.REPLACE_INPUT'
,p_message_language=>'es'
,p_message_text=>'Sustituir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795552731282133)
,p_name=>'CODE_EDITOR.REPLACE_SKIP'
,p_message_language=>'es'
,p_message_text=>'Omitir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792599766282131)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793266538282131)
,p_name=>'CODE_EDITOR.SHORTCUT_TITLE'
,p_message_language=>'es'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792704740282131)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar N\00FAmeros de L\00EDnea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794486166282132)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'es'
,p_message_text=>'Mostrar Regla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792960285282131)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Tabulaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793123303282131)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'es'
,p_message_text=>'Temas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791729212282130)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'es'
,p_message_text=>'Deshacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792655186282131)
,p_name=>'CODE_EDITOR.USE_PLAIN_TEXT_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Usar Editor de Texto sin Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97792480284282131)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'es'
,p_message_text=>'Validar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791494706282130)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n Correcta')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790718455282130)
,p_name=>'CREATE_LOV_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Crear Entrada'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755889522282104)
,p_name=>'F4000.ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755711215282104)
,p_name=>'F4000.ASYNCH_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n as\00EDncrona')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754274746282103)
,p_name=>'FILE_EDITOR.COULD_NOT_OPEN_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('No se han podido leer los contenidos de este archivo. Aseg\00FArese de que la codificaci\00F3n real del archivo sea UTF-8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752811896282102)
,p_name=>'FILE_EDITOR.CREATED'
,p_message_language=>'es'
,p_message_text=>'Archivo creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752929744282102)
,p_name=>'FILE_EDITOR.CREATED_PLURAL'
,p_message_language=>'es'
,p_message_text=>'Archivos creados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752775623282102)
,p_name=>'FILE_EDITOR.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753003275282102)
,p_name=>'FILE_EDITOR.DELETED'
,p_message_language=>'es'
,p_message_text=>'Archivo suprimido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753605134282102)
,p_name=>'FILE_EDITOR.ERROR_COMPILATION'
,p_message_language=>'es'
,p_message_text=>'No se ha podido compilar el archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753592320282102)
,p_name=>'FILE_EDITOR.ERROR_MINIFICATION'
,p_message_language=>'es'
,p_message_text=>'No se ha podido minimizar el archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753932811282103)
,p_name=>'FILE_EDITOR.EXTENSION_UNCHANGEABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Es posible que no se cambie la extensi\00F3n de archivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752101668282101)
,p_name=>'FILE_EDITOR.FILE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'Archivo no encontrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753750902282102)
,p_name=>'FILE_EDITOR.LINE_COL'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea %0: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755911355282104)
,p_name=>'FILE_EDITOR.NAME_EMPTY'
,p_message_language=>'es'
,p_message_text=>'Se debe proporcionar un nombre de archivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753885418282102)
,p_name=>'FILE_EDITOR.NAME_TAKEN'
,p_message_language=>'es'
,p_message_text=>'Ya existe un archivo con este nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756054926282104)
,p_name=>'FILE_EDITOR.NAME_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de archivo es demasiado largo. El l\00EDmite es de 255 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753145529282102)
,p_name=>'FILE_EDITOR.SAVED'
,p_message_language=>'es'
,p_message_text=>'Archivo guardado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753224672282102)
,p_name=>'FILE_EDITOR.SAVED_COMPILED'
,p_message_language=>'es'
,p_message_text=>'Archivo guardado y compilado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753399670282102)
,p_name=>'FILE_EDITOR.SAVED_MINIFIED'
,p_message_language=>'es'
,p_message_text=>'Archivo guardado y minimizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97753453814282102)
,p_name=>'FILE_EDITOR.SAVED_MINIFIED_COMPILED'
,p_message_language=>'es'
,p_message_text=>'Archivo guardado, compilado y minimizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752609017282102)
,p_name=>'FILE_EDITOR.UPLOAD'
,p_message_language=>'es'
,p_message_text=>'Cargar archivo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772532062282116)
,p_name=>'GL.BTN_POS_L'
,p_message_language=>'es'
,p_message_text=>'%0 (izquierda)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772691733282116)
,p_name=>'GL.BTN_POS_R'
,p_message_language=>'es'
,p_message_text=>'%0 (derecha)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772805339282116)
,p_name=>'GL.DRAG_COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772745326282116)
,p_name=>'GL.REGION_CONTENT'
,p_message_language=>'es'
,p_message_text=>unistr('Contenido de la Regi\00F3n')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775947104282119)
,p_name=>'LOV_DIALOG.GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776014175282119)
,p_name=>'LOV_DIALOG.LOV_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Lista de Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776160935282119)
,p_name=>'LOV_DIALOG.SELECT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797578764282135)
,p_name=>'LOV_DIALOG.SELECT_VALUE'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791141007282130)
,p_name=>'MODEL.CALLBACKS.CLASSIC_RPT_TABFORM_COLUMN.NO_SORTING'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede utilizar la ordenaci\00F3n de cabecera de columna si la consulta contiene una cl\00E1usula "ORDER BY".')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790496947282129)
,p_name=>'MODEL.CALLBACKS.IG.HAS_ORDER_BY'
,p_message_language=>'es'
,p_message_text=>unistr('La cl\00E1usula ORDER BY no est\00E1 soportada. Utilice la ordenaci\00F3n de columnas en su lugar.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799658938282136)
,p_name=>'MODEL.CALLBACKS.LEGACY_CALENDAR.ONLY_ONE_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo est\00E1 permitido un calendario por p\00E1gina.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771816457282116)
,p_name=>'MODEL.CALLBACKS.LEGACY_CALENDAR.WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Esta acci\00F3n solo crear\00E1 el calendario y no los botones y elementos de p\00E1gina asociados. Para generar los botones y elementos de p\00E1gina relacionados, utilice el Asistente de Creaci\00F3n de P\00E1ginas/Creaci\00F3n de Regiones.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791017922282130)
,p_name=>'MODEL.CALLBACKS.TABFORM.ONLY_ONE_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo puede agregar una Pantalla Tabular por p\00E1gina.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771796567282116)
,p_name=>'MODEL.CALLBACKS.TABFORM.WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Esta acci\00F3n solo crear\00E1 la pantalla tabular y no las validaciones y los procesos asociados. Para generar las validaciones y los procesos relacionados, utilice el Asistente de Creaci\00F3n de P\00E1ginas.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759602247282107)
,p_name=>'MODEL.CALLBACKS.WEB_SRC_PARAM.REQUIRES_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('El par\00E1metro necesita un valor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768659111282113)
,p_name=>'MODEL.DEL.REFERENCE_EXISTS'
,p_message_language=>'es'
,p_message_text=>'No se puede suprimir porque el componente ''%0'' hace referencia a este componente.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765398222282111)
,p_name=>'MODEL.HELP.ABOUT_PLUGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Consulte <a href="%0" target="_blank">P\00E1gina Inicial de Plugin</a> para obtener m\00E1s informaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798956949282136)
,p_name=>'MODEL.HELP.ADDITIONAL_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n Adicional')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765166921282111)
,p_name=>'MODEL.HELP.AVAILABLE_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'Las opciones disponibles incluyen:'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764564602282110)
,p_name=>'MODEL.HELP.BIND_VARIABLES'
,p_message_language=>'es'
,p_message_text=>'Variables de Enlace Soportadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797993804282135)
,p_name=>'MODEL.HELP.DEPRECATED.ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta funci\00F3n est\00E1 en desuso. Revise %0 Funciones En desuso en las notas t\00E9cnicas sobre la versi\00F3n para obtener m\00E1s informaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798046365282135)
,p_name=>'MODEL.HELP.DEPRECATED.LOV_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta funci\00F3n est\00E1 en desuso. Revise %0 Funciones En desuso en las notas t\00E9cnicas sobre la versi\00F3n para obtener m\00E1s informaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765241759282111)
,p_name=>'MODEL.HELP.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>'Ejemplos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764813302282110)
,p_name=>'MODEL.HELP.MAX_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de Columnas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765042999282111)
,p_name=>'MODEL.HELP.MAX_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor M\00E1ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764777142282110)
,p_name=>'MODEL.HELP.MIN_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo de Columnas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764917264282110)
,p_name=>'MODEL.HELP.MIN_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor M\00EDnimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764378983282110)
,p_name=>'MODEL.HELP.MULTIPLE. '
,p_message_language=>'es'
,p_message_text=>'un espacio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764282613282110)
,p_name=>'MODEL.HELP.MULTIPLE.,'
,p_message_language=>'es'
,p_message_text=>'una coma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764451581282110)
,p_name=>'MODEL.HELP.MULTIPLE.:'
,p_message_language=>'es'
,p_message_text=>'un punto y coma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764138934282110)
,p_name=>'MODEL.HELP.MULTIPLE.TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Separar M\00FAltiples Valores con %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763984493282110)
,p_name=>'MODEL.HELP.NO_TEXT'
,p_message_language=>'es'
,p_message_text=>'No hay texto de ayuda disponible.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750476339282100)
,p_name=>'MODEL.HELP.PROP_TYPE.CODE LANGUAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Lenguaje de programaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766596335282112)
,p_name=>'MODEL.HELP.PROP_TYPE.COLOR'
,p_message_language=>'es'
,p_message_text=>'Color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766452977282112)
,p_name=>'MODEL.HELP.PROP_TYPE.COMBOBOX'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766633639282112)
,p_name=>'MODEL.HELP.PROP_TYPE.CSS'
,p_message_language=>'es'
,p_message_text=>'Hoja de Estilo en Cascada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766978357282112)
,p_name=>'MODEL.HELP.PROP_TYPE.HTML'
,p_message_language=>'es'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787633328282127)
,p_name=>'MODEL.HELP.PROP_TYPE.ICON'
,p_message_language=>'es'
,p_message_text=>'Icono'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767180037282112)
,p_name=>'MODEL.HELP.PROP_TYPE.INTEGER'
,p_message_language=>'es'
,p_message_text=>'Entero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767378309282112)
,p_name=>'MODEL.HELP.PROP_TYPE.ITEM'
,p_message_language=>'es'
,p_message_text=>'Elemento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766830113282112)
,p_name=>'MODEL.HELP.PROP_TYPE.JAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>'JavaScript'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766748792282112)
,p_name=>'MODEL.HELP.PROP_TYPE.LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Enlace a URL/P\00E1gina de Destino')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750552472282100)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo del lado del servidor JavaScript (MLE)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750682438282100)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT EXPRESSION BOOLEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n del lado del servidor JavaScript (MLE) que devuelve VALOR BOOLEANO')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750736613282100)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT EXPRESSION VARCHAR2'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n del lado del servidor JavaScript (MLE) que devuelve VARCHAR2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750807353282100)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY BOOLEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n del lado del servidor JavaScript (MLE) que devuelve VALOR BOOLEANO')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751024070282100)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY SQL'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n del lado del servidor JavaScript (MLE) que devuelve una consulta SQL')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750936897282100)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY VARCHAR2'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n del lado del servidor JavaScript (MLE) que devuelve VARCHAR2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767268109282112)
,p_name=>'MODEL.HELP.PROP_TYPE.NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757655661282105)
,p_name=>'MODEL.HELP.PROP_TYPE.ORDER BY CLAUSE'
,p_message_language=>'es'
,p_message_text=>unistr('Cl\00E1usula Order By')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767497963282113)
,p_name=>'MODEL.HELP.PROP_TYPE.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750151299282100)
,p_name=>'MODEL.HELP.PROP_TYPE.PLACEHOLDER JSON'
,p_message_language=>'es'
,p_message_text=>unistr('Marcadores de posici\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767552353282113)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767734258282113)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL EXPRESSION BOOLEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL que Devuelve BOOLEANO')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767626502282113)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL EXPRESSION VARCHAR2'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL que Devuelve VARCHAR2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767942343282113)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY BOOLEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PLSQL que Devuelve BOOLEANO')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759551076282107)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY SQL'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL Que Devuelve una Consulta SQL')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767814313282113)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY VARCHAR2'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PLSQL que Devuelve VARCHAR2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768074020282113)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768151448282113)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760372375282107)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL EXPRESSION BOOLEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL que devuelve BOOLEANO')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756171702282104)
,p_name=>'MODEL.HELP.PROP_TYPE.STATIC LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768586940282113)
,p_name=>'MODEL.HELP.PROP_TYPE.TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Tabla, Vista o Sin\00F3nimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768282058282113)
,p_name=>'MODEL.HELP.PROP_TYPE.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768472696282113)
,p_name=>'MODEL.HELP.PROP_TYPE.TEXT EDITOR'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768390018282113)
,p_name=>'MODEL.HELP.PROP_TYPE.TEXTAREA'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757589140282105)
,p_name=>'MODEL.HELP.PROP_TYPE.WHERE CLAUSE'
,p_message_language=>'es'
,p_message_text=>unistr('Cl\00E1usula WHERE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97767042247282112)
,p_name=>'MODEL.HELP.PROP_TYPE.XML'
,p_message_language=>'es'
,p_message_text=>'XML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765473209282111)
,p_name=>'MODEL.HELP.REF_SCOPE.COMPONENT'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n, Elementos de P\00E1gina y Variables de Sistema')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765650903282111)
,p_name=>'MODEL.HELP.REF_SCOPE.DEPENDS'
,p_message_language=>'es'
,p_message_text=>'Depende'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765527777282111)
,p_name=>'MODEL.HELP.REF_SCOPE.ROW'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n, Elementos de P\00E1gina, Columnas de Regi\00F3n y Variables de Sistema')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766178654282111)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.NO_SPECIAL_CHAR'
,p_message_language=>'es'
,p_message_text=>'No se permiten &<>"/;,*|=%--'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766225350282112)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.NO_SPECIAL_CHAR_NL'
,p_message_language=>'es'
,p_message_text=>unistr('No se permiten &<>"/;,*|=%-- y nuevas l\00EDneas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766361736282112)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.SAFE_COMPONENT_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('No se permiten espacios, nueva l\00EDneas ni :&,.''+?"^')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765815001282111)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.US_ONLY'
,p_message_language=>'es'
,p_message_text=>'Solo a-z, A-Z, 0-9 y espacios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765973141282111)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.US_ONLY_NO_SPACE'
,p_message_language=>'es'
,p_message_text=>'Solo a-z, A-Z y 0-9'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791328335282130)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.US_ONLY_UNDERSCORE_NO_SPACE'
,p_message_language=>'es'
,p_message_text=>'Solo a-z, A-Z, 0-9 y guion bajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97766087029282111)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.WEB_SAFE'
,p_message_language=>'es'
,p_message_text=>'No se permiten <>"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97765725734282111)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS_LABEL'
,p_message_language=>'es'
,p_message_text=>'Caracteres Restringidos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764647185282110)
,p_name=>'MODEL.HELP.SUBSTITUTIONS'
,p_message_language=>'es'
,p_message_text=>'Sustituciones Soportadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788002455282128)
,p_name=>'MODEL.HELP.TEMPLATE_DIRECTIVE'
,p_message_language=>'es'
,p_message_text=>'Soporta directivas de plantilla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97764030764282110)
,p_name=>'MODEL.HELP.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761266517282108)
,p_name=>'MODEL.LOCKED.BY_OTHER_USER'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina ya est\00E1 bloqueada por el usuario ''%0''.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758028791282106)
,p_name=>'MODEL.LOV.ABSOLUTE_COLUMN_NO'
,p_message_language=>'es'
,p_message_text=>'%0. Columna [en desuso]'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762146036282108)
,p_name=>'MODEL.LOV.APEX_EVENTS'
,p_message_language=>'es'
,p_message_text=>'Eventos de Marco'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762054724282108)
,p_name=>'MODEL.LOV.BROWSER_EVENTS'
,p_message_language=>'es'
,p_message_text=>'Eventos de Explorador'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763745041282110)
,p_name=>'MODEL.LOV.COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Dato Incorrecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762262001282109)
,p_name=>'MODEL.LOV.COMPONENT_EVENTS'
,p_message_language=>'es'
,p_message_text=>'Eventos de Componente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762317688282109)
,p_name=>'MODEL.LOV.CUSTOM_EVENT'
,p_message_language=>'es'
,p_message_text=>'Evento Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761862347282108)
,p_name=>'MODEL.LOV.DATE_FORMAT_MASKS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scaras de Formato de Fecha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761635226282108)
,p_name=>'MODEL.LOV.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'es'
,p_message_text=>unistr('No Debe Ser Usuario P\00FAblico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761401859282108)
,p_name=>'MODEL.LOV.NO'
,p_message_language=>'es'
,p_message_text=>'No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761790275282108)
,p_name=>'MODEL.LOV.NOT_W_ARGUMENT'
,p_message_language=>'es'
,p_message_text=>'{No %0}'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761912342282108)
,p_name=>'MODEL.LOV.NUMBER_FORMAT_MASKS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scaras Formato Num\00E9rico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787161065282127)
,p_name=>'MODEL.LOV.TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Utilizar Valores por Defecto de Plantilla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787815896282127)
,p_name=>'MODEL.LOV.TEMPLATE_OPTIONS.DEFAULT.DESC'
,p_message_language=>'es'
,p_message_text=>'Utilice las opciones de la plantilla por defecto especificadas para la plantilla seleccionada.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761507155282108)
,p_name=>'MODEL.LOV.UNKNOWN_LOOKUP'
,p_message_language=>'es'
,p_message_text=>'Valor de Consulta Desconocido ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761388697282108)
,p_name=>'MODEL.LOV.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780784348282122)
,p_name=>'MODEL.MULTIPLE_COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Varios Componentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762441461282109)
,p_name=>'MODEL.PLACEHOLDER.PLEASE_CHANGE'
,p_message_language=>'es'
,p_message_text=>'Nuevo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762507195282109)
,p_name=>'MODEL.PLACEHOLDER.PRINT_LINK_TEXT'
,p_message_language=>'es'
,p_message_text=>'Imprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761124527282108)
,p_name=>'MODEL.POSTFIX.GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 [P\00E1gina Global]')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754042117282103)
,p_name=>'MODEL.POSTFIX.LEGACY'
,p_message_language=>'es'
,p_message_text=>'%0 [heredado]'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97761055669282108)
,p_name=>'MODEL.POSTFIX.PLUGIN'
,p_message_language=>'es'
,p_message_text=>'%0 [Plugin]'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760985132282108)
,p_name=>'MODEL.POSTFIX.UNSUPPORTED'
,p_message_language=>'es'
,p_message_text=>'%0 [No Soportado]'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762729692282109)
,p_name=>'MODEL.SAVE.FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo al guardar los cambios. Consulte los mensajes para obtener m\00E1s informaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762635244282109)
,p_name=>'MODEL.SAVE.FIX_ERRORS'
,p_message_language=>'es'
,p_message_text=>'Antes de guardar, se deben corregir todos los errores.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793572143282132)
,p_name=>'MODEL.TRANSACTION.CHANGE_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'Cambiar %0 > %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793941059282132)
,p_name=>'MODEL.TRANSACTION.CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793853955282132)
,p_name=>'MODEL.TRANSACTION.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794223321282132)
,p_name=>'MODEL.TRANSACTION.DELETE.MULTIPLE'
,p_message_language=>'es'
,p_message_text=>'Suprimir %0 Componentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793761818282132)
,p_name=>'MODEL.TRANSACTION.DUPLICATE'
,p_message_language=>'es'
,p_message_text=>'Duplicar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794145681282132)
,p_name=>'MODEL.TRANSACTION.DUPLICATE.MULTIPLE'
,p_message_language=>'es'
,p_message_text=>'Duplicar %0 Componentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793605420282132)
,p_name=>'MODEL.TRANSACTION.MOVE'
,p_message_language=>'es'
,p_message_text=>'Mover %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794044340282132)
,p_name=>'MODEL.TRANSACTION.MOVE.MULTIPLE'
,p_message_language=>'es'
,p_message_text=>'Mover %0 Componentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794326322282132)
,p_name=>'MODEL.TRANSACTION.UNDO'
,p_message_language=>'es'
,p_message_text=>'Deshacer: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763588383282109)
,p_name=>'MODEL.VAL.COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de dato incorrecto.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763667202282110)
,p_name=>'MODEL.VAL.COLUMN_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Columna no v\00E1lida.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762967624282109)
,p_name=>'MODEL.VAL.HAS_RESTRICTED_CHAR'
,p_message_language=>'es'
,p_message_text=>unistr('Contiene un car\00E1cter no v\00E1lido ''%0''.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97762857876282109)
,p_name=>'MODEL.VAL.IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Es necesario.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763408952282109)
,p_name=>'MODEL.VAL.MUST_BE_INTEGER'
,p_message_language=>'es'
,p_message_text=>'Debe ser un entero.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763399797282109)
,p_name=>'MODEL.VAL.MUST_BE_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('Debe ser num\00E9rico.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763875277282110)
,p_name=>'MODEL.VAL.MUST_BE_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('Debe ser \00FAnico.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763214783282109)
,p_name=>'MODEL.VAL.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('El valor es mayor que el valor m\00E1ximo especificado: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763130573282109)
,p_name=>'MODEL.VAL.VALUE_LESS_MIN_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('El valor es menor que el m\00EDnimo especificado: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97763098558282109)
,p_name=>'MODEL.VAL.VALUE_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>'Valor demasiado largo por %0 caracteres.'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789441783282129)
,p_name=>'PD.ACTION.GOTO_BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Botones de Galer\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788709558282128)
,p_name=>'PD.ACTION.GOTO_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Acciones Din\00E1micas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789095742282128)
,p_name=>'PD.ACTION.GOTO_GLV'
,p_message_language=>'es'
,p_message_text=>'Ir a Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788503859282128)
,p_name=>'PD.ACTION.GOTO_HELP'
,p_message_language=>'es'
,p_message_text=>'Ir a la Ayuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789393490282129)
,p_name=>'PD.ACTION.GOTO_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Elementos de Galer\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789506236282129)
,p_name=>'PD.ACTION.GOTO_MSGS'
,p_message_language=>'es'
,p_message_text=>'Ir a Mensajes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789135140282128)
,p_name=>'PD.ACTION.GOTO_PE'
,p_message_language=>'es'
,p_message_text=>'Ir a Editor de Propiedades'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751369772282101)
,p_name=>'PD.ACTION.GOTO_PE_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Ir a Editor de propiedades - Atributos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751282832282101)
,p_name=>'PD.ACTION.GOTO_PE_MAIN'
,p_message_language=>'es'
,p_message_text=>'Ir a Editor de propiedades - Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751406893282101)
,p_name=>'PD.ACTION.GOTO_PE_PRINTING'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Editor de propiedades - Impresi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788803337282128)
,p_name=>'PD.ACTION.GOTO_PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Ir a Procesamiento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789249496282128)
,p_name=>'PD.ACTION.GOTO_REGIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Regiones de Galer\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788623138282128)
,p_name=>'PD.ACTION.GOTO_RENDERING'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Presentaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788978479282128)
,p_name=>'PD.ACTION.GOTO_SHARED'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Componentes Compartidos de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789646020282129)
,p_name=>'PD.ACTION.PAGE_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779796844282122)
,p_name=>'PD.ALL_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Todas las P\00E1ginas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785685678282126)
,p_name=>'PD.APPLY_CHANGES'
,p_message_language=>'es'
,p_message_text=>'Aplicar Cambios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785843983282126)
,p_name=>'PD.BEFORE_AJAX_UNSAVED_CHANGES'
,p_message_language=>'es'
,p_message_text=>unistr('Hay cambios sin guardar. Pulse Aceptar para desechar los cambios o Cancelar para volver a la p\00E1gina actual.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780273781282122)
,p_name=>'PD.BEFORE_PAGE_UNLOAD_UNSAVED_CHANGES'
,p_message_language=>'es'
,p_message_text=>unistr('Actualmente hay cambios sin guardar en esta p\00E1gina. Para guardar los cambios, permanezca en esta p\00E1gina y pulse el bot\00F3n Guardar P\00E1gina.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778164366282120)
,p_name=>'PD.BUGS'
,p_message_language=>'es'
,p_message_text=>'Bugs'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778506230282121)
,p_name=>'PD.BUGS_N'
,p_message_language=>'es'
,p_message_text=>'Bugs (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785508858282126)
,p_name=>'PD.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778733830282121)
,p_name=>'PD.CHANGES_SAVED'
,p_message_language=>'es'
,p_message_text=>'Se han guardado los cambios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779136563282121)
,p_name=>'PD.CHANGES_SAVED_DIALOG_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se han guardado los cambios. Las p\00E1ginas del cuadro de di\00E1logo no se pueden ejecutar directamente desde el dise\00F1ador de p\00E1ginas. Revise esta p\00E1gina ejecutando una que inicie el cuadro de di\00E1logo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787500311282127)
,p_name=>'PD.CHANGES_SAVED_GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se han guardado los cambios. Las p\00E1ginas globales no se pueden ejecutar directamente desde el dise\00F1ador de p\00E1ginas. Revise los componentes globales ejecutando una p\00E1gina que incluya contenido de la p\00E1gina global.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788175792282128)
,p_name=>'PD.CMD.EXECUTE_FAILED'
,p_message_language=>'es'
,p_message_text=>'Fallo al ejecutar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788322842282128)
,p_name=>'PD.CMD.REDO_FAILED'
,p_message_language=>'es'
,p_message_text=>'Fallo al rehacer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788275456282128)
,p_name=>'PD.CMD.UNDO_FAILED'
,p_message_language=>'es'
,p_message_text=>'Fallo al deshacer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790586444282129)
,p_name=>'PD.COMMENTS_BADGE_TITLE'
,p_message_language=>'es'
,p_message_text=>'Comentarios del Desarrollador (%0 comentarios)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779927705282122)
,p_name=>'PD.CURRENT_GROUP'
,p_message_language=>'es'
,p_message_text=>'Grupo Actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780065022282122)
,p_name=>'PD.CURRENT_UI'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario Actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757435946282105)
,p_name=>'PD.CV.CLASSIC_REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Informe Cl\00E1sico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759867014282107)
,p_name=>'PD.CV.CREATE_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Crear %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757085369282105)
,p_name=>'PD.CV.INVALID_POSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n no V\00E1lida [No Presentada]')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757345104282105)
,p_name=>'PD.CV.LEGACY_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario Heredado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799135792282136)
,p_name=>'PD.CV.NAVIGATION_BAR_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757249221282105)
,p_name=>'PD.CV.NAVIGATION_MENU_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756992598282105)
,p_name=>'PD.CV.NO_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina y Botones sin Regi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757125059282105)
,p_name=>'PD.CV.TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756899141282105)
,p_name=>'PD.CV.TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772101241282116)
,p_name=>'PD.DEL'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756395097282104)
,p_name=>'PD.ENABLE_VIEW_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('Es necesario volver a cargar la p\00E1gina para mostrar esta vista. \00BFDesea volver a cargar la p\00E1gina ahora?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772006443282116)
,p_name=>'PD.EXPAND'
,p_message_language=>'es'
,p_message_text=>'Ampliar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777938091282120)
,p_name=>'PD.FEATURES'
,p_message_language=>'es'
,p_message_text=>'Funciones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778364781282121)
,p_name=>'PD.FEATURES_N'
,p_message_language=>'es'
,p_message_text=>'Funciones (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778235054282121)
,p_name=>'PD.FEEDBACK_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Comentarios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778606082282121)
,p_name=>'PD.FEEDBACK_ENTRIES_N'
,p_message_language=>'es'
,p_message_text=>'Entradas de Comentarios (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778891690282121)
,p_name=>'PD.FOCUS_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Enfocar P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774812201282118)
,p_name=>'PD.GAL.HOT_BTN'
,p_message_language=>'es'
,p_message_text=>'%0 [Directo]'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774901669282118)
,p_name=>'PD.GAL.MI.ADD2'
,p_message_language=>'es'
,p_message_text=>'Agregar a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786983938282127)
,p_name=>'PD.GAL.MI.SHOW_LEGACY'
,p_message_language=>'es'
,p_message_text=>'Mostrar Componentes Heredados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775091587282118)
,p_name=>'PD.GAL.MI.SHOW_UNSUP'
,p_message_language=>'es'
,p_message_text=>'Mostrar Componentes No Soportados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774756323282118)
,p_name=>'PD.GAL.NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('Este componente no est\00E1 soportado en la interfaz de usuario %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773005402282117)
,p_name=>'PD.GLV.CMD.COPY'
,p_message_language=>'es'
,p_message_text=>'copiar ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773178040282117)
,p_name=>'PD.GLV.CMD.CREATE'
,p_message_language=>'es'
,p_message_text=>'crear nuevo %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773287705282117)
,p_name=>'PD.GLV.CMD.DEL'
,p_message_language=>'es'
,p_message_text=>'suprimir ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773389951282117)
,p_name=>'PD.GLV.CMD.DEL_N'
,p_message_language=>'es'
,p_message_text=>'suprimir %0 componentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772911265282117)
,p_name=>'PD.GLV.CMD.MOVE'
,p_message_language=>'es'
,p_message_text=>'mover ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773468008282117)
,p_name=>'PD.GLV.DP_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773519605282117)
,p_name=>'PD.GLV.EMPTY_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna p\00E1gina o la p\00E1gina no tiene ninguna plantilla')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773662953282117)
,p_name=>'PD.GLV.MI.DISP_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar desde P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773747115282117)
,p_name=>'PD.GLV.MI.DISP_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar desde Aqu\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774306447282118)
,p_name=>'PD.GLV.MI.HIDE_BTNS'
,p_message_language=>'es'
,p_message_text=>'Ocultar Botones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773961055282117)
,p_name=>'PD.GLV.MI.HIDE_COND_COMP'
,p_message_language=>'es'
,p_message_text=>'Ocultar Componentes Condicionales'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774151102282117)
,p_name=>'PD.GLV.MI.HIDE_EMPTY'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar Posiciones Vac\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774229294282118)
,p_name=>'PD.GLV.MI.HIDE_GLOBAL'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar Componentes de P\00E1gina Global')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774401793282118)
,p_name=>'PD.GLV.MI.HIDE_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Ocultar Elementos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774022653282117)
,p_name=>'PD.GLV.MI.HIDE_LEGACY'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar Posiciones Heredadas Vac\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97773810567282117)
,p_name=>'PD.GLV.MI.NEW_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar Nueva Cuadr\00EDcula')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774580564282118)
,p_name=>'PD.GLV.MI.ZOOM'
,p_message_language=>'es'
,p_message_text=>'Zoom'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97774676012282118)
,p_name=>'PD.GLV.MI.ZOOM_N'
,p_message_language=>'es'
,p_message_text=>'%0%%'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779536626282121)
,p_name=>'PD.GROUP'
,p_message_language=>'es'
,p_message_text=>'Grupo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799495950282136)
,p_name=>'PD.HELP.DEFAULT'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione un componente y, a continuaci\00F3n, seleccione un atributo en el editor de propiedades para mostrar la ayuda sobre ese atributo.</p>')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789879635282129)
,p_name=>'PD.HELP.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Proporcionar Comentarios sobre la Ayuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760712341282107)
,p_name=>'PD.ISSUES'
,p_message_language=>'es'
,p_message_text=>'Problemas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760816622282108)
,p_name=>'PD.ISSUES_N'
,p_message_language=>'es'
,p_message_text=>'Problemas (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97788404606282128)
,p_name=>'PD.KBD_SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todos Abreviados del Teclado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783128308282124)
,p_name=>'PD.LINK.APPLICATION_N'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n %0:%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759240899282106)
,p_name=>'PD.LINK.GOTO_APPLICATION_N'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a Aplicaci\00F3n %0:%1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759106914282106)
,p_name=>'PD.LINK.GOTO_PAGE_N'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a P\00E1gina %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759394349282106)
,p_name=>'PD.LINK.GOTO_URL'
,p_message_language=>'es'
,p_message_text=>'Ir a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783014011282124)
,p_name=>'PD.LINK.PAGE_N'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777242714282120)
,p_name=>'PD.LOCK'
,p_message_language=>'es'
,p_message_text=>'Bloquear'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777165608282120)
,p_name=>'PD.LOCK_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Bloquear P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756212662282104)
,p_name=>'PD.MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772374427282116)
,p_name=>'PD.MI.COPY2'
,p_message_language=>'es'
,p_message_text=>'Copiar en'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772295374282116)
,p_name=>'PD.MI.MOVE2'
,p_message_language=>'es'
,p_message_text=>'Mover a'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794721401282132)
,p_name=>'PD.NAV_NEXT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a la p\00E1gina siguiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794814367282133)
,p_name=>'PD.NAV_PREV_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a la p\00E1gina anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777680416282120)
,p_name=>'PD.OK'
,p_message_language=>'es'
,p_message_text=>'Aceptar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759949842282107)
,p_name=>'PD.PAGE_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Alias de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780351205282122)
,p_name=>'PD.PAGE_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina especificada no existe.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780190567282122)
,p_name=>'PD.PAGE_FINDER'
,p_message_language=>'es'
,p_message_text=>unistr('Buscador de P\00E1ginas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777560691282120)
,p_name=>'PD.PAGE_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Bloqueada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777009004282120)
,p_name=>'PD.PAGE_LOCKED_BY'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina bloqueada por %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776970603282120)
,p_name=>'PD.PAGE_LOCKED_BY_YOU'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Bloqueada por el Usuario')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779375121282121)
,p_name=>'PD.PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779219815282121)
,p_name=>'PD.PAGE_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798182728282135)
,p_name=>'PD.PAGE_PICKER.RECENTLY_EDITED'
,p_message_language=>'es'
,p_message_text=>'Editado Recientemente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779604429282122)
,p_name=>'PD.PAGE_PICKER.SHOW'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776862059282119)
,p_name=>'PD.PAGE_UNLOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Desbloqueada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786649474282127)
,p_name=>'PD.PE.ALL_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Todas las P\00E1ginas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781356244282123)
,p_name=>'PD.PE.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799379013282136)
,p_name=>'PD.PE.BUTTON_NO_ID_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n seleccionado utiliza una plantilla de bot\00F3n que no contiene la cadena de sustituci\00F3n #BUTTON_ID#')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780873307282122)
,p_name=>'PD.PE.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797338268282134)
,p_name=>'PD.PE.CATEGORY'
,p_message_language=>'es'
,p_message_text=>unistr('Categor\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780961047282122)
,p_name=>'PD.PE.CLEAR'
,p_message_language=>'es'
,p_message_text=>'Borrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783998468282125)
,p_name=>'PD.PE.CODE_EDITOR.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Editor de C\00F3digos: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785164842282125)
,p_name=>'PD.PE.COLLAPSE_ALL'
,p_message_language=>'es'
,p_message_text=>'Reducir Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799755194282136)
,p_name=>'PD.PE.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784752434282125)
,p_name=>'PD.PE.COMMENT'
,p_message_language=>'es'
,p_message_text=>'Comentario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784363284282125)
,p_name=>'PD.PE.CURRENT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786506198282127)
,p_name=>'PD.PE.CURRENT_UI'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario Actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797455883282134)
,p_name=>'PD.PE.CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784491749282125)
,p_name=>'PD.PE.CUSTOM_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Personalizada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791551537282130)
,p_name=>'PD.PE.EDITOR.UNSAVED_CHANGES'
,p_message_language=>'es'
,p_message_text=>'Se han realizado los cambios. Pulse Aceptar para cerrar el editor sin guardar los cambios.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789754786282129)
,p_name=>'PD.PE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>'Ejemplos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785034178282125)
,p_name=>'PD.PE.EXPAND_ALL'
,p_message_language=>'es'
,p_message_text=>'Ampliar Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791215213282130)
,p_name=>'PD.PE.FA.ACCESSIBILITY'
,p_message_language=>'es'
,p_message_text=>'Accesibilidad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797189681282134)
,p_name=>'PD.PE.FA.BRAND'
,p_message_language=>'es'
,p_message_text=>'Marca'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798249602282135)
,p_name=>'PD.PE.FA.CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796684157282134)
,p_name=>'PD.PE.FA.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796739583282134)
,p_name=>'PD.PE.FA.CURRENCY'
,p_message_language=>'es'
,p_message_text=>'Divisa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786843277282127)
,p_name=>'PD.PE.FA.CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796956025282134)
,p_name=>'PD.PE.FA.DIRECTIONAL'
,p_message_language=>'es'
,p_message_text=>'Direccional'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798361493282135)
,p_name=>'PD.PE.FA.EMOJI'
,p_message_language=>'es'
,p_message_text=>'Emoji'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796220234282134)
,p_name=>'PD.PE.FA.FILE_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Archivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796444246282134)
,p_name=>'PD.PE.FA.FORM_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Pantalla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760484648282107)
,p_name=>'PD.PE.FA.GENDER'
,p_message_language=>'es'
,p_message_text=>'Sexo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760514239282107)
,p_name=>'PD.PE.FA.HAND'
,p_message_language=>'es'
,p_message_text=>'Mano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787354671282127)
,p_name=>'PD.PE.FA.MAPS'
,p_message_language=>'es'
,p_message_text=>'Mapas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797227542282134)
,p_name=>'PD.PE.FA.MEDICAL'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9dico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798416392282135)
,p_name=>'PD.PE.FA.NUMBERS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmeros')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796588629282134)
,p_name=>'PD.PE.FA.PAYMENT'
,p_message_language=>'es'
,p_message_text=>'Pago'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796321524282134)
,p_name=>'PD.PE.FA.SPINNER'
,p_message_language=>'es'
,p_message_text=>'Selector'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796827931282134)
,p_name=>'PD.PE.FA.TEXT_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Editor de Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760645794282107)
,p_name=>'PD.PE.FA.TRANSPORTATION'
,p_message_language=>'es'
,p_message_text=>'Transporte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797041878282134)
,p_name=>'PD.PE.FA.VIDEO_PLAYER'
,p_message_language=>'es'
,p_message_text=>unistr('Reproductor de V\00EDdeo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796108123282134)
,p_name=>'PD.PE.FA.WEB_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n Web')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784506409282125)
,p_name=>'PD.PE.GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Global')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793389265282131)
,p_name=>'PD.PE.GO_TO_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Ir a %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756586903282104)
,p_name=>'PD.PE.ICON.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756716074282105)
,p_name=>'PD.PE.ICON.LARGE'
,p_message_language=>'es'
,p_message_text=>'Grande'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756698836282105)
,p_name=>'PD.PE.ICON.SMALL'
,p_message_language=>'es'
,p_message_text=>unistr('Peque\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97756414769282104)
,p_name=>'PD.PE.ICON.STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754142576282103)
,p_name=>'PD.PE.INVALID_FALSE_ACTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Las acciones ''falsas'' solo se ejecutar\00E1n cuando la acci\00F3n din\00E1mica tenga una ''condici\00F3n'' definida en los atributos ''When''. Esta acci\00F3n din\00E1mica no tiene tal ''condici\00F3n''.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786114503282126)
,p_name=>'PD.PE.IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Es necesario.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784100954282125)
,p_name=>'PD.PE.ITEM_SCOPE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1mbito de Elemento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785225671282126)
,p_name=>'PD.PE.KEEP_LABELS_ABOVE'
,p_message_language=>'es'
,p_message_text=>'Mantener Etiquetas sobre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784052812282125)
,p_name=>'PD.PE.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799242297282136)
,p_name=>'PD.PE.LINK.ADDITIONAL_PARAMETERS'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros Adicionales')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758183167282106)
,p_name=>'PD.PE.LINK.ANCHOR'
,p_message_language=>'es'
,p_message_text=>'Anclaje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758632326282106)
,p_name=>'PD.PE.LINK.CLEAR_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758366857282106)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.CLEAR_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Borrar regiones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758234687282106)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.NONE'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758536519282106)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.RESET_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer Paginaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758453401282106)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.RESET_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Restablecer regiones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781699439282123)
,p_name=>'PD.PE.LINK.CLEAR_CACHE'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Cach\00E9')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783501720282124)
,p_name=>'PD.PE.LINK.DG.ADVANCED'
,p_message_language=>'es'
,p_message_text=>'Avanzado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783435702282124)
,p_name=>'PD.PE.LINK.DG.CLEAR_SESSION'
,p_message_language=>'es'
,p_message_text=>'Borrar/Restablecer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783395040282124)
,p_name=>'PD.PE.LINK.DG.SET_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Definir Elementos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783284900282124)
,p_name=>'PD.PE.LINK.DG.TARGET'
,p_message_language=>'es'
,p_message_text=>'Destino'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781912331282123)
,p_name=>'PD.PE.LINK.ITEM_N_NAME'
,p_message_language=>'es'
,p_message_text=>'Elemento %0: Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782167499282123)
,p_name=>'PD.PE.LINK.ITEM_N_NAME_LOV'
,p_message_language=>'es'
,p_message_text=>'Elemento %0: Lista de Valores de Nombres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782080668282123)
,p_name=>'PD.PE.LINK.ITEM_N_VALUE'
,p_message_language=>'es'
,p_message_text=>'Elemento %0: Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782220375282123)
,p_name=>'PD.PE.LINK.ITEM_N_VALUE_LOV'
,p_message_language=>'es'
,p_message_text=>'Elemento %0: Lista de Valores de Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782310849282124)
,p_name=>'PD.PE.LINK.NAME_LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Nombre: Lista de Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782941497282124)
,p_name=>'PD.PE.LINK.NO_LINK_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ning\00FAn enlace')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781494999282123)
,p_name=>'PD.PE.LINK.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782796337282124)
,p_name=>'PD.PE.LINK.REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782801444282124)
,p_name=>'PD.PE.LINK.REMOVE_ITEM_N'
,p_message_language=>'es'
,p_message_text=>'Eliminar Elemento %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781548377282123)
,p_name=>'PD.PE.LINK.REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782523812282124)
,p_name=>'PD.PE.LINK.SUCCESS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781106811282123)
,p_name=>'PD.PE.LINK.TITLE'
,p_message_language=>'es'
,p_message_text=>'Creador de Enlaces: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783779603282124)
,p_name=>'PD.PE.LINK.TYPE.PAGE_IN_DIFF_APP'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina en una Aplicaci\00F3n Diferente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783674352282124)
,p_name=>'PD.PE.LINK.TYPE.PAGE_IN_THIS_APP'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina en esta aplicaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782674398282124)
,p_name=>'PD.PE.LINK.URL'
,p_message_language=>'es'
,p_message_text=>'URL'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781874556282123)
,p_name=>'PD.PE.LINK.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97782476789282124)
,p_name=>'PD.PE.LINK.VALUE_LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Valor : Lista de Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97791616123282130)
,p_name=>'PD.PE.LOV.UNKNOWN_LOOKUP'
,p_message_language=>'es'
,p_message_text=>'Valor de Consulta Desconocido ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780610963282122)
,p_name=>'PD.PE.MULTIPLE_TYPES'
,p_message_language=>'es'
,p_message_text=>'Varios Tipos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781777593282123)
,p_name=>'PD.PE.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786028662282126)
,p_name=>'PD.PE.OK'
,p_message_language=>'es'
,p_message_text=>'Aceptar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760021083282107)
,p_name=>'PD.PE.PAGE_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Alias de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786473943282126)
,p_name=>'PD.PE.PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786202650282126)
,p_name=>'PD.PE.PAGE_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785995907282126)
,p_name=>'PD.PE.PICK'
,p_message_language=>'es'
,p_message_text=>'Seleccionar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97796059675282133)
,p_name=>'PD.PE.PREVIEW'
,p_message_language=>'es'
,p_message_text=>'Vista Previa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758863036282106)
,p_name=>'PD.PE.PROPERTY.VALUE_VARIES'
,p_message_language=>'es'
,p_message_text=>unistr('El valor var\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786379146282126)
,p_name=>'PD.PE.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776367733282119)
,p_name=>'PD.PE.SHOW_ALL'
,p_message_language=>'es'
,p_message_text=>'Mostrar Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776268389282119)
,p_name=>'PD.PE.SHOW_COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Com\00FAn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799573439282136)
,p_name=>'PD.PE.SHOW_HIDE_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('''Mostrar'' y ''Ocultar'' no son acciones soportadas para las columnas de cuadr\00EDcula interactiva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787013695282127)
,p_name=>'PD.PE.SHOW_LEGACY'
,p_message_language=>'es'
,p_message_text=>'Mostrar Heredados...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754367111282103)
,p_name=>'PD.PE.STATIC_LOV.GROUP.SORT'
,p_message_language=>'es'
,p_message_text=>'Ordenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754547193282103)
,p_name=>'PD.PE.STATIC_LOV.GROUP.VALUES'
,p_message_language=>'es'
,p_message_text=>'Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755483418282104)
,p_name=>'PD.PE.STATIC_LOV.MOVE_DOWN'
,p_message_language=>'es'
,p_message_text=>'Mover hacia abajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755610220282104)
,p_name=>'PD.PE.STATIC_LOV.MOVE_DOWN_VALUE_N'
,p_message_language=>'es'
,p_message_text=>'Mover hacia abajo valor %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755324981282104)
,p_name=>'PD.PE.STATIC_LOV.MOVE_UP'
,p_message_language=>'es'
,p_message_text=>'Mover hacia arriba'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755530477282104)
,p_name=>'PD.PE.STATIC_LOV.MOVE_UP_VALUE_N'
,p_message_language=>'es'
,p_message_text=>'Mover hacia arriba valor %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754934555282103)
,p_name=>'PD.PE.STATIC_LOV.PROP.SORT'
,p_message_language=>'es'
,p_message_text=>unistr('Ordenar en tiempo de ejecuci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754497255282103)
,p_name=>'PD.PE.STATIC_LOV.PROP.VALUES'
,p_message_language=>'es'
,p_message_text=>'Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754749781282103)
,p_name=>'PD.PE.STATIC_LOV.REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755072006282103)
,p_name=>'PD.PE.STATIC_LOV.REMOVE_VALUE_N'
,p_message_language=>'es'
,p_message_text=>'Eliminar valor %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754839226282103)
,p_name=>'PD.PE.STATIC_LOV.VALUE.DISPLAY'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Visualizaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97754618835282103)
,p_name=>'PD.PE.STATIC_LOV.VALUE.RETURN'
,p_message_language=>'es'
,p_message_text=>'Valor de Retorno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755293331282104)
,p_name=>'PD.PE.STATIC_LOV.VALUE_N_DISPLAY'
,p_message_language=>'es'
,p_message_text=>'Valor %0: mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97755113913282103)
,p_name=>'PD.PE.STATIC_LOV.VALUE_N_RETURN'
,p_message_language=>'es'
,p_message_text=>'Valor %0: devolver'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784841984282125)
,p_name=>'PD.PE.TABLES'
,p_message_language=>'es'
,p_message_text=>'Tablas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784201428282125)
,p_name=>'PD.PE.TARGET_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Destino')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790327747282129)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'es'
,p_message_text=>'Avanzado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790268962282129)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('Com\00FAn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787903632282128)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'es'
,p_message_text=>'General'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97793401378282132)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.NONE_SELECTED'
,p_message_language=>'es'
,p_message_text=>'Ninguno Seleccionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752355264282101)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.ASSIGN_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Asignar elementos o valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752088281282101)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752463465282101)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Marcador de Posici\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751674215282101)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.NONE_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Sin marcadores de posici\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751752262282101)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.PLACEHOLDERS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 marcadores de posici\00F3n, %1 sin asignar.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752267730282101)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Definir valores de marcador de posici\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97752589556282102)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.VALUE'
,p_message_language=>'es'
,p_message_text=>'Elemento o valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780409243282122)
,p_name=>'PD.PE.TITLE'
,p_message_language=>'es'
,p_message_text=>'Editor de Propiedades'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97780567206282122)
,p_name=>'PD.PE.TITLE_WITH_TYPE'
,p_message_language=>'es'
,p_message_text=>'Editor de Propiedades: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781237874282123)
,p_name=>'PD.PE.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784680561282125)
,p_name=>'PD.PE.USER_INTERFACE'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795990531282133)
,p_name=>'PD.PE.UTILIZED'
,p_message_language=>'es'
,p_message_text=>'Utilizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97781020023282123)
,p_name=>'PD.PE.VALIDATE'
,p_message_language=>'es'
,p_message_text=>'Validar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97784969745282125)
,p_name=>'PD.PE.VIEWS'
,p_message_language=>'es'
,p_message_text=>'Vistas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785438312282126)
,p_name=>'PD.REDO'
,p_message_language=>'es'
,p_message_text=>'Rehacer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771922141282116)
,p_name=>'PD.RESTORE'
,p_message_language=>'es'
,p_message_text=>'Restaurar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778962646282121)
,p_name=>'PD.RUN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785766370282126)
,p_name=>'PD.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777708047282120)
,p_name=>'PD.SHOW_LABELS'
,p_message_language=>'es'
,p_message_text=>'Mostrar Etiquetas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777888342282120)
,p_name=>'PD.SHOW_NAMES'
,p_message_language=>'es'
,p_message_text=>'Mostar Nombres'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790680724282129)
,p_name=>'PD.TEAM_DEV_BADGE_TITLE'
,p_message_language=>'es'
,p_message_text=>'Desarrollo de Equipos (%0 elementos)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778014640282120)
,p_name=>'PD.TODOS'
,p_message_language=>'es'
,p_message_text=>'Tareas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97778403992282121)
,p_name=>'PD.TODOS_N'
,p_message_language=>'es'
,p_message_text=>'Tareas (%0)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751590823282101)
,p_name=>'PD.TREE.BELOW'
,p_message_language=>'es'
,p_message_text=>'Abajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795891051282133)
,p_name=>'PD.TREE.CLASSIC_REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Informe Cl\00E1sico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769395875282114)
,p_name=>'PD.TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'es'
,p_message_text=>'Reducir Todo Debajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760261619282107)
,p_name=>'PD.TREE.COLUMN_NOT_NULL_VALIDATION'
,p_message_language=>'es'
,p_message_text=>'#COLUMN_HEADER# debe tener un valor.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750384668282100)
,p_name=>'PD.TREE.COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Componentes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97786726423282127)
,p_name=>'PD.TREE.COPY_SHARED_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Copiar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769140418282114)
,p_name=>'PD.TREE.COPY_TO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar en Otra P\00E1gina...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768795514282114)
,p_name=>'PD.TREE.CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751840845282101)
,p_name=>'PD.TREE.CREATE.BUTTON.BELOW'
,p_message_language=>'es'
,p_message_text=>unistr('Crear bot\00F3n a continuaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751946781282101)
,p_name=>'PD.TREE.CREATE.ITEM.BELOW'
,p_message_language=>'es'
,p_message_text=>unistr('Crear elemento de p\00E1gina a continuaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750295848282100)
,p_name=>'PD.TREE.CREATE.REGION.BELOW'
,p_message_language=>'es'
,p_message_text=>unistr('Crear regi\00F3n a continuaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790001555282129)
,p_name=>'PD.TREE.CREATE_SHARED_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Crear...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768919955282114)
,p_name=>'PD.TREE.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97768898579282114)
,p_name=>'PD.TREE.DUPLICATE'
,p_message_language=>'es'
,p_message_text=>'Duplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769810460282114)
,p_name=>'PD.TREE.DYNAMIC_ACTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones Din\00E1micas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97789915706282129)
,p_name=>'PD.TREE.EDIT_SHARED_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Editar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771438359282115)
,p_name=>'PD.TREE.EVENTS'
,p_message_language=>'es'
,p_message_text=>'Eventos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769245387282114)
,p_name=>'PD.TREE.EXPAND_ALL_BELOW'
,p_message_language=>'es'
,p_message_text=>'Ampliar Todo Debajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97760139540282107)
,p_name=>'PD.TREE.FACETS'
,p_message_language=>'es'
,p_message_text=>'Facetas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769587192282114)
,p_name=>'PD.TREE.FALSE'
,p_message_language=>'es'
,p_message_text=>'Falso'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769702483282114)
,p_name=>'PD.TREE.FALSE_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n FALSE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771649931282116)
,p_name=>'PD.TREE.FIRED_ON_PAGE_LOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones Disparadas al Cargar P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790146814282129)
,p_name=>'PD.TREE.GOTO_TARGET_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a P\00E1gina de Destino')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770790465282115)
,p_name=>'PD.TREE.INVALID_POSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n no V\00E1lida [No Presentada]')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770354050282115)
,p_name=>'PD.TREE.ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795778078282133)
,p_name=>'PD.TREE.LEGACY_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario Heredado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799004483282136)
,p_name=>'PD.TREE.NAVIGATION_BAR_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797655999282135)
,p_name=>'PD.TREE.NAVIGATION_MENU_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770839923282115)
,p_name=>'PD.TREE.NO_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina y Botones sin Regi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769908851282114)
,p_name=>'PD.TREE.OPPOSITE_DYNAMIC_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Contraria')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771220820282115)
,p_name=>'PD.TREE.PAGE_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda de P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771153352282115)
,p_name=>'PD.TREE.PAGE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0: %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771030776282115)
,p_name=>'PD.TREE.POST_RENDERING'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n Posterior')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770981402282115)
,p_name=>'PD.TREE.PRE_RENDERING'
,p_message_language=>'es'
,p_message_text=>unistr('Representaci\00F3n Previa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771355600282115)
,p_name=>'PD.TREE.REFERENCED_BY'
,p_message_language=>'es'
,p_message_text=>'Con Referencia de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770479982282115)
,p_name=>'PD.TREE.REGION_BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('Botones de Regi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769074256282114)
,p_name=>'PD.TREE.RENAME'
,p_message_language=>'es'
,p_message_text=>'Cambiar Nombre...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770229714282115)
,p_name=>'PD.TREE.REPORT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770609759282115)
,p_name=>'PD.TREE.ROW_SELECTOR'
,p_message_language=>'es'
,p_message_text=>'Selector de Filas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97751137097282101)
,p_name=>'PD.TREE.SFILTERS'
,p_message_language=>'es'
,p_message_text=>'Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770096922282114)
,p_name=>'PD.TREE.SUB_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Subregi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770178990282114)
,p_name=>'PD.TREE.SUB_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Subregiones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790878884282130)
,p_name=>'PD.TREE.SYNCHRONIZE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Sincronizar columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97750003981282100)
,p_name=>'PD.TREE.SYNCHRONIZE_PAGE_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Sincronizar elementos de p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798886900282136)
,p_name=>'PD.TREE.TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97795643756282133)
,p_name=>'PD.TREE.TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769488039282114)
,p_name=>'PD.TREE.TRUE'
,p_message_language=>'es'
,p_message_text=>'Verdadero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97769698554282114)
,p_name=>'PD.TREE.TRUE_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n TRUE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97771505270282115)
,p_name=>'PD.TREE.UNDEFINED_EVENT'
,p_message_language=>'es'
,p_message_text=>'No Especificado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97770511587282115)
,p_name=>'PD.TREE.VIRTUAL_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna Virtual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779097524282121)
,p_name=>'PD.TRY_AGAIN'
,p_message_language=>'es'
,p_message_text=>'Volver a Intentar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97785381490282126)
,p_name=>'PD.UNDO'
,p_message_language=>'es'
,p_message_text=>'Deshacer %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777430449282120)
,p_name=>'PD.UNLOCK'
,p_message_language=>'es'
,p_message_text=>'Desbloquear'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97777383223282120)
,p_name=>'PD.UNLOCK_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Desbloquear P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97772490471282116)
,p_name=>'PD.UNSUPPORTED'
,p_message_language=>'es'
,p_message_text=>'%0 [No Soportado]'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779485301282121)
,p_name=>'PD.USER_INTERFACE'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97783860285282125)
,p_name=>'PE.CODE_EDITOR'
,p_message_language=>'es'
,p_message_text=>unistr('Editor de C\00F3digos: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776440257282119)
,p_name=>'PE.COLLAPSE'
,p_message_language=>'es'
,p_message_text=>'Reducir %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97797852181282135)
,p_name=>'PE.COLOR_PICKER'
,p_message_language=>'es'
,p_message_text=>'Selector de Color: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775750052282119)
,p_name=>'PE.EDIT_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Editar Componente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798556933282135)
,p_name=>'PE.ERROR_POSTFIX'
,p_message_language=>'es'
,p_message_text=>' (Error)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776518243282119)
,p_name=>'PE.EXPAND'
,p_message_language=>'es'
,p_message_text=>'Ampliar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787259527282127)
,p_name=>'PE.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794588908282132)
,p_name=>'PE.FILTER_NO_MATCH'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn resultado.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97794654132282132)
,p_name=>'PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn resultado. Pruebe a buscar todas las propiedades haciendo clic en el bot\00F3n "Mostrar Todo" anterior.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759423421282107)
,p_name=>'PE.FILTER_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>'Propiedades de Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775590311282118)
,p_name=>'PE.INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('%0 (No V\00E1lido)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775371157282118)
,p_name=>'PE.LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775169165282118)
,p_name=>'PE.NO'
,p_message_language=>'es'
,p_message_text=>'No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775487409282118)
,p_name=>'PE.NO_COMMON_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>unistr('Los componentes seleccionados no tienen propiedades en com\00FAn.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787448441282127)
,p_name=>'PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('Actualmente no se ha seleccionado ning\00FAn componente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775850258282119)
,p_name=>'PE.PICK'
,p_message_language=>'es'
,p_message_text=>'Seleccionar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97759024985282106)
,p_name=>'PE.PIN_FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro de pin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97787707943282127)
,p_name=>'PE.QUICK_PICK'
,p_message_language=>'es'
,p_message_text=>'Listas de Valores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97790948815282130)
,p_name=>'PE.QUICK_PICK.CLEAR'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Selecci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776672888282119)
,p_name=>'PE.REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Necesario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97779808092282122)
,p_name=>'PE.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775279208282118)
,p_name=>'PE.SELECT'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798734985282136)
,p_name=>'PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'es'
,p_message_text=>unistr(' (El valor var\00EDa)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97775602553282119)
,p_name=>'PE.WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97798667383282136)
,p_name=>'PE.WARNING_POSTFIX'
,p_message_language=>'es'
,p_message_text=>' (Advertencia)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97776753461282119)
,p_name=>'PE.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97799844097282136)
,p_name=>'RESTORE'
,p_message_language=>'es'
,p_message_text=>'Restaurar'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97758718819282106)
,p_name=>'WIZARD.IG.ACTIONS_MENU_LABEL'
,p_message_language=>'es'
,p_message_text=>'Acciones'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(97757727231282105)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Especificaci\00F3n de lista de valores no v\00E1lida para la columna %s. Debe ser una lista de valores que devuelva 2 columnas.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(57515217372887724.4001)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('\00BFSeguro que desea salir de esta p\00E1gina sin guardar?')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(59030208829181524.4001)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('\00BFDesea realizar esta acci\00F3n de supresi\00F3n?')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/page_template_popup
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(64022328345714803.4001)
,p_shortcut_name=>'PAGE_TEMPLATE_POPUP'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="javascript:callPageTemplatePopup(document.forms[0].#CURRENT_FORM_ELEMENT#, ''&FLOW_SESSION.'', &FB_FLOW_ID., &FB_FLOW_PAGE_ID.);"  class="a-Button a-Button--popupLOV">',
'  <span class="a-Icon icon-popup-lov">',
'    <span class="visuallyhidden">  ',
unistr('      Buscar Punto de Visualizaci\00F3n en Plantilla de P\00E1gina'),
'    </span>',
'  </span>',
'</a>',
''))
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/breadcrumb_parent
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(115510732068279066.4001)
,p_shortcut_name=>'BREADCRUMB_PARENT'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_shortcut=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767) := null;',
'begin',
'    x:=x||''<span class="a-Form-quickPicks">''||chr(10);',
'    x:=x||''<a href="javascript:setValue(''''#CURRENT_ITEM_NAME#'''',''''''||wwv_flow_lang.system_message(''NO_PARENT'')||'''''');setValue(''''#CURRENT_ITEM_NAME#_ID'''',''''0'''');" class="a-Form-quickPicks-link">[''||wwv_flow_lang.system_message(''NO_PARENT'')||'']</a>''||c'
||'hr(10);',
'    x:=x||''</span>''||chr(10);',
'    return x;',
'end; '))
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/jquery_and_version
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(427587403475368438.4001)
,p_shortcut_name=>'JQUERY_AND_VERSION'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'jQuery 1.7.1'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/no_plugins_installed
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(889405628525700213.4001)
,p_shortcut_name=>'NO_PLUGINS_INSTALLED'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p></p>',
'<p>',
'<strong>No hay plugins instalados.</strong>',
'</p>',
'<p>',
unistr('Un plugin es una extensi\00F3n de los tipos incorporados de &PRODUCT_NAME.. Los siguientes tipos son extensibles con plugins:'),
'<ul>',
'  <li>Elementos</li>',
'  <li>Regiones</li>',
unistr('  <li>Acciones Din\00E1micas</li>'),
unistr('  <li>Procesos de P\00E1gina</li>'),
unistr('  <li>Esquemas de Autenticaci\00F3n</li>'),
unistr('  <li>Esquemas de Autorizaci\00F3n</li>'),
'</ul>',
'</p>',
'<p>',
unistr('Los plugins pueden ser descargados, importados y creados en <strong>Componentes Compartidos</strong> y utilizarlos despu\00E9s en la aplicaci\00F3n.'),
'</p>'))
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/list_image_lov_title
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(1119263810878461105.4001)
,p_shortcut_name=>'LIST_IMAGE_LOV_TITLE'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_shortcut=>'return wwv_flow_lang.system_message(''ITEM_NAME.POPUP_LIST_OF_VALUES'')||'': ''||wwv_flow_lang.system_message(''IMAGE'');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/chart_degrees
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(1142979828869056091.4001)
,p_shortcut_name=>'CHART_DEGREES'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_shortcut=>'return wwv_flow_lang.system_message(''CHART_DEGREES'');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/list_icon_lov_title
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(1846485616473772275.4001)
,p_shortcut_name=>'LIST_ICON_LOV_TITLE'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_shortcut=>'return wwv_flow_lang.system_message(''ITEM_NAME.POPUP_LIST_OF_VALUES'')||'': ''||wwv_flow_lang.system_message(''UTR.LESS.ICON'');'
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(532421019614096524.4001)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040.4001
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_language
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1807557483699566.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_LANGUAGE'
,p_display_name=>unistr('Lenguaje de c\00F3digo')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_LANGUAGE'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_language'
,p_validation_function=>'wwv_flow_f4000_plugins.validate_code_language'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>1801904462214602.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1616586820081253.4001)
,p_plugin_id=>wwv_flow_api.id(1807557483699566.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Default Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Automatically Picked'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1616932854081253.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1616586820081253.4001)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1617453369081254.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1616586820081253.4001)
,p_display_sequence=>20
,p_display_value=>'PL/SQL'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1617916473081254.4001)
,p_plugin_id=>wwv_flow_api.id(1807557483699566.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Type Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1618399660081255.4001)
,p_plugin_id=>wwv_flow_api.id(1807557483699566.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Hide SQL'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1617916473081254.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_plugin_dynamic_attribute
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6480508142096556.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_display_name=>unistr('Atributo Din\00E1mico de Plugin')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_plugin_attribute'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_plugin_attribute'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12452111455491580.4001)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>unistr('Autorizaci\00F3n de Desarrollador')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651560577046363790.4001)
,p_plugin_id=>wwv_flow_api.id(12452111455491580.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651560903552363790.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651561436837363791.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651561918897363791.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651562405708363791.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651562954297363792.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651563444327363792.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651563916984363792.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651564412258363793.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651564940419363794.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651565434632363794.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651565979151363794.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651566416123363795.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(651560577046363790.4001)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/process_type/com_oracle_apex_download_as_zip
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(30813821679475084.4001)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.ORACLE.APEX.DOWNLOAD_AS_ZIP'
,p_display_name=>'Descargar como Zip'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.ORACLE.APEX.DOWNLOAD_AS_ZIP'),'')
,p_api_version=>1
,p_execution_function=>'wwv_flow_f4000_plugins.execute_download_as_zip'
,p_substitute_attributes=>true
,p_reference_id=>30809327244259788.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(30820929057719747.4001)
,p_plugin_id=>wwv_flow_api.id(30813821679475084.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Zip File Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'myfile.zip'
,p_display_length=>60
,p_max_length=>255
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(30821313350719747.4001)
,p_plugin_id=>wwv_flow_api.id(30813821679475084.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'SQL Statement'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name,',
'       file_content',
'  from my_files',
' where security_group_id = :WORKSPACE_ID'))
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_subscriptions
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(33337730749616691.4001)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_display_name=>'Suscripciones'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.SUBSCRIPTIONS'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_subscriptions'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(33338020837623261.4001)
,p_plugin_id=>wwv_flow_api.id(33337730749616691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Table Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(33338531226626280.4001)
,p_plugin_id=>wwv_flow_api.id(33337730749616691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Name Column'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'NAME'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(33339313695630694.4001)
,p_plugin_id=>wwv_flow_api.id(33337730749616691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'PK Item Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Pxxx_ID'
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(33340003437637190.4001)
,p_plugin_id=>wwv_flow_api.id(33337730749616691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Reference Item Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Pxxx_REFERENCE_ID'
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(33340415904640767.4001)
,p_plugin_id=>wwv_flow_api.id(33337730749616691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'System Message Prefix'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'SUBSCRIBE_XXX'
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(44505855544251869.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(73267156331555162.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>unistr('Cuadro de B\00FAsqueda')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513164197626229978.4001)
,p_plugin_id=>wwv_flow_api.id(73267156331555162.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513164528396229983.4001)
,p_plugin_id=>wwv_flow_api.id(73267156331555162.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(113745221597665418.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>unistr('Autenticaci\00F3n de Apex')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(118542747372907112.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>unistr('INTERNAL: Inicio de sesi\00F3n en medios sociales')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328076617805426969.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328077041228426969.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328077596141426971.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328078021857426971.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328078533596426971.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328079013213426972.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328079498740426972.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328079809170426974.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328080269307426974.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328080688373426974.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Application Express automatically adds the "openid" scope. The authent'
||'ication provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328081093700426974.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328081437731426974.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328081869797426975.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328082288122426975.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328082678203426975.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(328076617805426969.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328083019987426977.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328082678203426975.4001)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328083519789426977.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328082678203426975.4001)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328084079375426977.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328082678203426975.4001)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(328084514360426978.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(328082678203426975.4001)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328085073834426978.4001)
,p_plugin_id=>wwv_flow_api.id(118542747372907112.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (e.g. "email_verified" for Username Attribute "email"). If this is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_showrequired
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(168887529524073617.4001)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.SHOWREQUIRED'
,p_display_name=>'Mostrar Necesario'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.SHOWREQUIRED'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_show_required'
,p_standard_attributes=>'REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_hiderequired
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(168887711994078043.4001)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.HIDEREQUIRED'
,p_display_name=>'Ocultar Necesario'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.HIDEREQUIRED'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_hide_required'
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_condition_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(186814901672118890.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CONDITION_LIST'
,p_display_name=>unistr('Tipo de Condici\00F3n')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CONDITION_LIST'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_condition_type'
,p_validation_function=>'wwv_flow_f4000_plugins.validate_condition_type'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:QUICKPICK:SOURCE:ELEMENT:LOV:LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(186815126952126271.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Expression 1 Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'PXXX_DISPLAY_WHEN'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(186815604227129139.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Expression 2 Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'PXXX_DISPLAY_WHEN2'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(186850620259616261.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Read Only Attribute Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435006624881297772.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Check Expression Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'PXXX_DISPLAY_WHEN_CHECK'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9108120561208861.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Check Condition for each Row Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(17008114447614272.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONDITION'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(17013718256615389.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>10
,p_display_value=>'Condition'
,p_return_value=>'CONDITION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(17014223451616874.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>20
,p_display_value=>'Read Only'
,p_return_value=>'READ_ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(17015529684618682.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>30
,p_display_value=>'Validation'
,p_return_value=>'VALIDATION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(17016001418619960.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>40
,p_display_value=>'Cache'
,p_return_value=>'CACHE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(17025627831684357.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>50
,p_display_value=>'Install'
,p_return_value=>'INSTALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1147161874794101092.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>60
,p_display_value=>'Wizard'
,p_return_value=>'WIZARD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2523021215376825.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(17008114447614272.4001)
,p_display_sequence=>70
,p_display_value=>'Data Loading'
,p_return_value=>'DATA_LOADING'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1502656613845364.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>25
,p_prompt=>'Language Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'PXXX_LANG'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154403169834506.4001)
,p_plugin_id=>wwv_flow_api.id(186814901672118890.4001)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_ui_component_select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(274985426340249335.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.UI_COMPONENT_SELECT_LIST'
,p_display_name=>unistr('Lista de Selecci\00F3n de Componentes de la Interfaz de Usuario')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.UI_COMPONENT_SELECT_LIST'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_ui_component_selectlist'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(274985715126254465.4001)
,p_plugin_id=>wwv_flow_api.id(274985426340249335.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Current application ID page item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'FB_FLOW_ID'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(274987711601347260.4001)
,p_plugin_id=>wwv_flow_api.id(274985426340249335.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Current page ID page item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'FB_FLOW_PAGE_ID'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154544647834507.4001)
,p_plugin_id=>wwv_flow_api.id(274985426340249335.4001)
,p_name=>'LOV'
,p_sql_min_column_count=>4
,p_sql_max_column_count=>4
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select wwv_flow_lang.system_message(''DA_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r,',
'       nvl(category, ''MISC'') as category,',
'       supported_ui_types    as supported_ui_types',
'  from wwv_flow_native_plugins',
' where plugin_type = ''DYNAMIC ACTION''',
' order by decode(category, ''MISC'', 1, 0), category, 1',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_splitter
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(330671351658403453.4001)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.SPLITTER'
,p_display_name=>'Divisor'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.SPLITTER'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_splitter'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_splitter'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Un divisor divide din\00E1micamente el espacio disponible de dos subregiones de forma horizontal o vertical. La regi\00F3n del divisor debe tener exactamente dos subregiones. Se puede utilizar casi cualquier plantilla de regi\00F3n, siempre que tenga un atrib')
||unistr('uto de ID, pero algunas tendr\00E1n mejor aspecto que otras. Evite las plantillas de regiones con m\00E1rgenes o relleno. Si la plantilla de regi\00F3n tiene un elemento que ajusta las subregiones, se debe introducir un selector de CSS que selecciona el elemento')
||' de ajuste en la propiedad Selector.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(349220632388568598.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Splitter Keyboard Navigation'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If yes a global keyboard handler will be added to support using Ctrl-F6 to navigate to the next splitter and Shift-Ctrl-F6 to navigate to the previous splitter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330688557661299917.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>400
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An optional CSS selector that identifies the element that contains the two sub regions. The selector should start with the the static region id. If omitted the region id or static id will be used. ',
'<p>',
'Example:<br>',
'#regonStaticId > .container',
'<p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330688948819304091.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Orientation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'horizontal'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'A horizontal splitter has the two sub regions side by side. A vertical splitter has the two sub regions one on top of the other. The first sub region is always on the left or top.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(330689346016305383.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(330688948819304091.4001)
,p_display_sequence=>10
,p_display_value=>'Horizontal'
,p_return_value=>'horizontal'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(330689738036309021.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(330688948819304091.4001)
,p_display_sequence=>20
,p_display_value=>'Vertical'
,p_return_value=>'vertical'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330690450316318564.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Positioned From'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'begin'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This determines from which side the position of the splitter is measured and to which side the splitter will collapse. Choose Begin to collapse to the left (right if direction is RTL) or top. Choose End to collapse to the right (left if direction is '
||'RTL) or bottom.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(336045355822788793.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(330690450316318564.4001)
,p_display_sequence=>10
,p_display_value=>'Begin (left/top)'
,p_return_value=>'begin'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(336045754312789475.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(330690450316318564.4001)
,p_display_sequence=>20
,p_display_value=>'End (right/bottom)'
,p_return_value=>'end'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330690840827322937.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Position'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'This is the initial position in pixels of the splitter bar. If the splitter is initially collapsed this is the position used when the splitter is first expanded. If Persist State is Yes then if there is a saved position it overrides this value.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330691231338327320.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Collapsed'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1272749710877634174.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter is initially collapsed. If Persist State is Yes then if there is a saved collapsed state it overrides this value.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330691658499329931.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Snap'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'Optional. The number of pixels the splitter moves in each increment when dragging or with the arrow keys. If not specified the splitter can be dragged with single pixel precision.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330692042109337535.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Keyboard Increment'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(330691658499329931.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Optional. The number of pixels to move the splitter for each arrow key press. If not specified the default is 10.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330692435208340781.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Minimum Size'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'The minimum position of the splitter before it automatically collapses. If not specified the default of 60 is used.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330692860643344184.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Continuous Resize'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the two sub regions are sized on each movement of the splitter while dragging or moving with the arrow keys. Otherwise the sub regions are sized only when the splitter stops moving. This should be set to No if the sub regions are computational'
||'ly expensive to resize.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330693249645349258.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Restore Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is collapsed. If not specified a default is provided.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330693643391352153.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Collapse Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is expanded. If not specified a default is provided.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(330694038430354494.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter bar. Providing a title for each splitter is helpful for accessibility especially when there are multiple splitters.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(336050456955985813.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>12
,p_prompt=>'Persist State'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If Yes the state of the splitter is persisted as a user preference.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272749710877634174.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>45
,p_prompt=>'Can Collapse '
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'When set to Yes the splitter can collapse or expand by clicking on the handle or pressing Enter or Space. When set to No the splitter can only be moved to its minimum size.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272751944026669582.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Sub Region Contains iframe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Only set to Yes if either sub region of the splitter contains an iframe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1272753284660692508.4001)
,p_plugin_id=>wwv_flow_api.id(330671351658403453.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Drag To Collapse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1272749710877634174.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter can be collapsed by dragging past the minimum size. If No the splitter can only be dragged to the minimum size.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356672915595447685.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNA: Oracle Cloud Identity Management'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356675223794447688.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNA: Cuentas de Base de Datos'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356678515020447691.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNA: Variable de Cabecera HTTP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43305921330381426.4001)
,p_plugin_id=>wwv_flow_api.id(356678515020447691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43307659880381426.4001)
,p_plugin_id=>wwv_flow_api.id(356678515020447691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43309695751381427.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(43307659880381426.4001)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43311885072381427.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(43307659880381426.4001)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43313923761381427.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(43307659880381426.4001)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43316199809381427.4001)
,p_plugin_id=>wwv_flow_api.id(356678515020447691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43307659880381426.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43318102923381428.4001)
,p_plugin_id=>wwv_flow_api.id(356678515020447691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(43307659880381426.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43320057408381428.4001)
,p_plugin_id=>wwv_flow_api.id(356678515020447691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(43307659880381426.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'BUILTIN_URL,URL'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43321849497381428.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(43320057408381428.4001)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(43323780834381428.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(43320057408381428.4001)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(43326239863381428.4001)
,p_plugin_id=>wwv_flow_api.id(356678515020447691.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356745016189447752.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNA: Directorio LDAP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528.4001
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de usuario y la contrase\00F1a para la autenticaci\00F3n en el directorio LDAP identificado en la p\00E1gina de conexi\00F3n. Recuerde que las contrase\00F1as pueden ser sensibles a may\00FAsculas/min\00FAsculas.</p>'),
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356745323877447752.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356745710232447753.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356746109049447753.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356746532190447753.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(356746109049447753.4001)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356747029958447753.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(356746109049447753.4001)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356747527068447753.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(356746109049447753.4001)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356748002271447753.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356748421799447754.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356748822347447754.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(356748421799447754.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356749220453447755.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(356749630581447755.4001)
,p_plugin_id=>wwv_flow_api.id(356745016189447752.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356750031552447755.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(356749630581447755.4001)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356750523626447755.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(356749630581447755.4001)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(356751008833447756.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(356749630581447755.4001)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(356819511256447808.4001)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNA: Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_tempalte_opt_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(584703820034565801.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_display_name=>unistr('Casilla de Control de Opci\00F3n de Plantilla')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_template_opt_checkbox'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_template_opt_checkbox'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(621147512543205393.4001)
,p_plugin_id=>wwv_flow_api.id(584703820034565801.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Include Default Option'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(625522324747628292.4001)
,p_plugin_id=>wwv_flow_api.id(584703820034565801.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Include Groups'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(628606941434451878.4001)
,p_plugin_id=>wwv_flow_api.id(584703820034565801.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Include Ungrouped Options'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154719817834512.4001)
,p_plugin_id=>wwv_flow_api.id(584703820034565801.4001)
,p_name=>'LOV'
,p_sql_min_column_count=>6
,p_sql_max_column_count=>8
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       css_classes as r,',
'       default_options,',
'       preset_options,',
'       description,',
'       unique_group_name,',
'       advanced_group,',
'       null_text',
'from ...'))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_internal_page_popuplov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(925354130594891115.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_display_name=>unistr('Lista de Valores Emergente de P\00E1gina Interna')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_internal_page_popuplov'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:HEIGHT'
,p_substitute_attributes=>true
,p_reference_id=>925323717983648481.4001
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_plugin_id=>wwv_flow_api.id(925354130594891115.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Target'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'4000_246'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513309322451425448.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>10
,p_display_value=>'Item (4000:246)'
,p_return_value=>'4000_246'
,p_help_text=>'Popup page 4000.246 for item selection'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513312335211425454.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>15
,p_display_value=>'Item Substitution (4000:414)'
,p_return_value=>'4000_414'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513309825576425448.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>20
,p_display_value=>'Pick Action Info (4000:845)'
,p_return_value=>'4000_845'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513310347097425449.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>30
,p_display_value=>'Pick Color (4000:723)'
,p_return_value=>'4000_723'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513308842769425446.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>40
,p_display_value=>'Pick Report Column (4000:416)'
,p_return_value=>'4000_416'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513310802437425453.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>50
,p_display_value=>'Pick Chart Column (4000:322)'
,p_return_value=>'4000_322'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513311317968425453.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>60
,p_display_value=>'Pick Interactive Report Column (4000:721)'
,p_return_value=>'4000_721'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513312841640425455.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>70
,p_display_value=>'Item Values (callItempopUp)'
,p_return_value=>'callItempopUp'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513311807605425454.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_display_sequence=>999
,p_display_value=>'JavaScript'
,p_return_value=>'javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513313371492425455.4001)
,p_plugin_id=>wwv_flow_api.id(925354130594891115.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4000_246'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513313735701425455.4001)
,p_plugin_id=>wwv_flow_api.id(925354130594891115.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Link Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513314138954425455.4001)
,p_plugin_id=>wwv_flow_api.id(925354130594891115.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'JavaScript Code'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1513308453290425442.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'javascript'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_hierarchical_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1009908742651634862.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.HIERARCHICAL_CHECKBOX'
,p_display_name=>unistr('Casilla de Control Jer\00E1rquica')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.HIERARCHICAL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_hierarchical_checkbox'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'<br />'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845155134238834519.4001)
,p_plugin_id=>wwv_flow_api.id(1009908742651634862.4001)
,p_name=>'LOV'
,p_sql_min_column_count=>3
,p_sql_max_column_count=>3
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ename as d,',
'       empno as r,',
'       level',
'  from emp',
' start with mgr is null',
' connect by prior empno = mgr',
' order siblings by ename'))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_EDITOR'
,p_display_name=>unistr('Editor de C\00F3digos')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_code_editor'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ENCRYPT'
,p_substitute_attributes=>true
,p_reference_id=>1114646612921244845.4001
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752247167059115238.4001)
,p_plugin_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752248011501115238.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752247532177115238.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752252576551115241.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752248562331115239.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752253027019115244.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752249000056115239.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752249546422115239.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752250050544115240.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>60
,p_display_value=>'PL/SQL Functions/Procedures'
,p_return_value=>'PLSQL_FUNCTIONS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752250568154115240.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752251074841115240.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752251524791115240.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752252030385115241.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript'
,p_return_value=>'mle-javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752253503616115244.4001)
,p_plugin_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752253933934115244.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752253503616115244.4001)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(752254456523115245.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(752253503616115244.4001)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752254904107115254.4001)
,p_plugin_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Query Builder'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752255330916115254.4001)
,p_plugin_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Adjustable Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'If Yes the user can adjust the height of the code editor.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752255764171115254.4001)
,p_plugin_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote  Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify a page item containing the remote database ID to use for code validation.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(752256197646115254.4001)
,p_plugin_id=>wwv_flow_api.id(1020525824503843147.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(752247167059115238.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'',
'<p>An event listener will be placed on this item, so when its value changes, the editor will change accordingly.</p>',
'',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_clob_code_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_display_name=>unistr('Editor de C\00F3digo CLOB')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.CLOB_CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_code_editor'
,p_standard_attributes=>'SOURCE_SQL:NO_DATA_FOUND_MESSAGE:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(737301671038224013.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mode'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737302053570224013.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737302588034224013.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737303085199224013.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737303575308224014.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737307073304224016.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737304079359224014.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737304508295224014.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737305013069224015.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737305589342224015.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PL/SQL_FUNCTION_BODY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737306049142224015.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737306517665224015.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript'
,p_return_value=>'mle-javascript'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(737307541411224016.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Height'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737307931475224016.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>1
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737308465414224017.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>2
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737308998878224019.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>3
,p_display_value=>'20'
,p_return_value=>'20'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737309407171224019.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>10
,p_display_value=>'30'
,p_return_value=>'30'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737309991623224022.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>20
,p_display_value=>'60'
,p_return_value=>'60'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737310437617224022.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>25
,p_display_value=>'80'
,p_return_value=>'80'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737311005249224022.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737307541411224016.4001)
,p_display_sequence=>30
,p_display_value=>'Automatic'
,p_return_value=>'AUTO'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(737311433484224023.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Read Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(737311871442224023.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737312216415224023.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737311871442224023.4001)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
,p_help_text=>'VARCHAR2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(737312779941224023.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(737311871442224023.4001)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(737313291640224024.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Specify the an item containing the ID of the remote database to use for code validation.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(737313625324224024.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(737301671038224013.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'<p>An event listener will further be placed on this item, so that when its value changes, the editor will change accordingly.</p>',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(20502400833202827.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(737317685398224028.4001)
,p_plugin_id=>wwv_flow_api.id(1041616815958164797.4001)
,p_name=>'SOURCE_SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob_content',
'from demo_scripts'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1198924687353295733.4001)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Agregar Casilla de Control Activar Todo'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512.4001
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La acci\00F3n din\00E1mica "Agregar Casilla de Control Activar Todo" convierte la cabecera de columna que contiene la cadena #CHECK_ALL_CHECKBOX# en una casilla de control de estilo Activar Todo accesible, que permite activar y desactivar todas las casill')
||'as de control en su columna correspondiente.<p>',
'<p>',
unistr('Para utilizar este plugin, aseg\00FArese de que est\00E1n definidos los siguientes atributos:'),
'<ol>',
'<li>En la columna de informe, ''#CHECK_ALL_CHECKBOX#'' definido como valor de cabecera.</li>',
unistr('<li>Para el atributo Cu\00E1ndo de Acci\00F3n Din\00E1mica, seleccione la regi\00F3n de informe que contenga la columna.</li>'),
unistr('<li>Defina la acci\00F3n din\00E1mica para que se dispare ''Despu\00E9s de Refrescamiento'' y la acci\00F3n en ''Arrancar al Cargar P\00E1gina''. (Ambos se definir\00E1n por defecto de forma adecuada si la acci\00F3n din\00E1mica se crea mediante la selecci\00F3n de la regi\00F3n en la secci\00F3n')
||unistr(' ''Presentaci\00F3n'' del Dise\00F1ador de P\00E1ginas y la creaci\00F3n de la acci\00F3n din\00E1mica desde ah\00ED.</li>'),
unistr('<li>Con esto no se manejar\00E1 la accesibilidad de las casillas de control que se presentan en cada fila. Esto se debe realizar por separado en el origen de regi\00F3n. (Consulte la regi\00F3n 4000:656 ''Regiones'' para obtener un ejemplo).</li>'),
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_group_select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1484532036002681868.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.GROUP_SELECT_LIST'
,p_display_name=>unistr('Lista de Selecci\00F3n de Grupos')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.GROUP_SELECT_LIST'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- The render procedure is responsible for the rendering of the actual HTML control',
'-- of the new widget. APEX still takes care of the table cell for the layout,',
'-- the label, pre- and post element text. Only the html code between the pre- and',
'-- post element text is rendered by the plug-in. The render procedure has a',
'-- defined interface which every plug-in has to implement. It''s designed in a way',
'-- that future enhancements to the interface will not break existing plug-ins.',
'function render_group_selectlist (',
'    p_item                in apex_plugin.t_page_item,',
'    p_plugin              in apex_plugin.t_plugin,',
'    p_value               in varchar2,',
'    p_is_readonly         in boolean,',
'    p_is_printer_friendly in boolean )',
'    return apex_plugin.t_page_item_render_result',
'is',
'    -- value without the lov null value',
'    l_value             varchar2(32767) := case when p_value = p_item.lov_null_value then null else p_value end;',
'',
'    l_name              varchar2(30);',
'    l_display_value     varchar2(32767);',
'    l_is_selected       boolean := false;',
'    l_value_found       boolean := false;',
'    l_column_value_list wwv_flow_plugin_util.t_column_value_list;',
'    l_group_value       varchar2(4000);',
'    l_last_group_value  varchar2(4000);',
'    l_open_group        boolean := false;',
'    l_result            wwv_flow_plugin_api.t_page_item_render_result;',
'    ',
'    procedure print_option_local (',
'        p_display_value in varchar2,',
'        p_return_value  in varchar2,',
'        p_compare_value in varchar2 )',
'    is',
'        l_is_selected boolean := false;',
'    begin',
'        if not l_value_found and',
'           (  p_return_value = p_compare_value',
'           or p_return_value is null and p_compare_value is null',
'           )',
'        then',
'            l_value_found := true;',
'            l_is_selected := true;',
'        end if;',
'        -- add list entry',
'        apex_plugin_util.print_option (',
'            p_display_value => p_display_value,',
'            p_return_value  => p_return_value,',
'            p_is_selected   => l_is_selected,',
'            p_attributes    => p_item.element_option_attributes );',
'    end print_option_local;',
'begin',
'    -- During plug-in development it''s very helpful to have some debug information',
'    if wwv_flow.g_debug then',
'        apex_plugin_util.debug_page_item (',
'            p_plugin              => p_plugin,',
'            p_page_item           => p_item,',
'            p_value               => p_value,',
'            p_is_readonly         => p_is_readonly,',
'            p_is_printer_friendly => p_is_printer_friendly );',
'    end if;',
'',
'    -- Based on the flags we normally generate different HTML code, but that',
'    -- depends on the plug-in.',
'    if p_is_readonly or p_is_printer_friendly then',
'        apex_plugin_util.print_hidden_if_readonly (',
'            p_item_name           => p_item.name,',
'            p_value               => p_value,',
'            p_is_readonly         => p_is_readonly,',
'            p_is_printer_friendly => p_is_printer_friendly );',
'',
'        -- get the display value',
'        l_display_value := apex_plugin_util.get_display_data (',
'                               p_sql_statement     => p_item.lov_definition,',
'                               p_min_columns       => 3, -- LOV requires 3 column',
'                               p_max_columns       => 3,',
'                               p_component_name    => p_item.name,',
'                               p_display_column_no => 1,',
'                               p_search_column_no  => 2,',
'                               p_search_string     => l_value,',
'                               p_display_extra     => p_item.lov_display_extra );',
'',
'        -- emit display span with the value',
'        apex_plugin_util.print_display_only (',
'            p_item_name        => p_item.name,',
'            p_display_value    => l_display_value,',
'            p_show_line_breaks => false,',
'            p_escape           => true,',
'            p_attributes       => p_item.element_attributes );',
'    else',
'        -- If a page item saves state, we have to call the get_input_name_for_page_item',
'        -- to render the internal hidden p_arg_names field. It will also return the',
'        -- HTML field name which we have to use when we render the HTML input field.',
'        l_name := apex_plugin.get_input_name_for_page_item(false);',
'        sys.htp.prn(''<select name="''||l_name||''" id="''||p_item.name||''" ''||',
'                  coalesce(p_item.element_attributes, ''class="group_selectlist"'')||''>'');',
'',
'        -- add display null entry',
'        if p_item.lov_display_null then',
'            --wwv_flow_utilities.add_null_value_entry(''ITEM'', l_name, p_item.lov_null_value);',
'            -- add list entry',
'            print_option_local (',
'                    p_display_value => p_item.lov_null_text,',
'                    p_return_value  => p_item.lov_null_value,',
'                    p_compare_value => nvl(l_value, p_item.lov_null_value) );',
'        end if;',
'',
'        -- get all values',
'        l_column_value_list := apex_plugin_util.get_data (',
'                                   p_sql_statement      => p_item.lov_definition,',
'                                   p_min_columns        => 3,',
'                                   p_max_columns        => 3,',
'                                   p_component_name     => p_item.name );',
'',
'        -- loop through the result',
'        for i in 1 .. l_column_value_list(1).count /* display value */',
'        loop',
'            l_group_value := l_column_value_list(3)(i); /* group column */',
'            -- has the group changed?',
'            if (l_group_value <> l_last_group_value) or',
'               (l_group_value is     null and l_last_group_value is not null) or',
'               (l_group_value is not null and l_last_group_value is     null)',
'            then',
'                if l_open_group then',
'                    sys.htp.p(''</optgroup>'');',
'                    l_open_group := false;',
'                end if;',
'                if l_group_value is not null then',
'                    sys.htp.p (''<optgroup label="''||wwv_flow_escape.html(l_group_value)||''">'');',
'                    l_open_group := true;',
'                end if;',
'                l_last_group_value := l_group_value;',
'            end if;',
'            -- add list entry',
'            print_option_local (',
'                p_display_value => l_column_value_list(1)(i),',
'                p_return_value  => l_column_value_list(2)(i),',
'                p_compare_value => l_value );',
'        end loop;',
'',
'        if l_open_group then',
'            sys.htp.p(''</optgroup>'');',
'        end if;',
'        -- Show at least the value if it hasn''t been found in the database',
'        if not l_value_found and l_value is not null and p_item.lov_display_extra then',
'            print_option_local (',
'                p_display_value => l_value,',
'                p_return_value  => l_value,',
'                p_compare_value => l_value );',
'        end if;',
'        -- close our select list',
'        sys.htp.p(''</select>'');',
'       ',
'        wwv_flow_javascript.add_onload_code (',
'            p_code => ''apex.builder.plugin.groupSelectList(''||',
'                wwv_flow_javascript.add_value(''#''||p_item.name)||',
'                ''{''||',
'                wwv_flow_javascript.add_attribute(''nullValue'',      p_item.lov_null_value, false, false)||',
'                ''});'' );',
'        ',
'        -- Tell APEX that this field is navigable',
'        l_result.is_navigable := true;',
'    end if;',
'    return l_result;',
'end render_group_selectlist;'))
,p_api_version=>1
,p_render_function=>'render_group_selectlist'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
,p_about_url=>'http://www.oracleapex.info/'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845155281774834521.4001)
,p_plugin_id=>wwv_flow_api.id(1484532036002681868.4001)
,p_name=>'LOV'
,p_sql_min_column_count=>3
,p_sql_max_column_count=>3
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select e.ename as d,',
'       e.empno as r,',
'       d.dname as grp',
'  from emp e,',
'       dept d',
' where d.deptno = e.deptno',
' order by d.dname, e.ename',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3260301366184169092.4001)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>unistr('Selecci\00F3n de Asistente')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369043407812412665.4001)
,p_plugin_id=>wwv_flow_api.id(3260301366184169092.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(369044006087413465.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(369043407812412665.4001)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(369044404793414074.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(369043407812412665.4001)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(369044803715414606.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(369043407812412665.4001)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(452918641523598191.4001)
,p_plugin_id=>wwv_flow_api.id(3260301366184169092.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845155356484834522.4001)
,p_plugin_id=>wwv_flow_api.id(3260301366184169092.4001)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_html5_bar_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_display_name=>unistr('Gr\00E1fico de Barras HTML 5 ***')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.HTML5_BAR_CHART'),'#IMAGE_PREFIX#plugins/com.oracle.apex.html5_bar_chart/1.0/')
,p_javascript_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.js'
,p_css_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.css'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FUNCTION RENDER (',
'    P_REGION IN APEX_PLUGIN.T_REGION,',
'    P_PLUGIN IN APEX_PLUGIN.T_PLUGIN,',
'    P_IS_PRINTER_FRIENDLY IN BOOLEAN',
') RETURN APEX_PLUGIN.T_REGION_RENDER_RESULT IS',
'BEGIN',
'    sys.HTP.PRN(''<div id="''||APEX_ESCAPE.HTML_ATTRIBUTE(P_REGION.STATIC_ID)||''_chart" class="hbc">'');',
'    sys.HTP.PRN(''</div>'');',
'    ',
'    APEX_JAVASCRIPT.ADD_ONLOAD_CODE (',
'        P_CODE => ''com_oracle_apex_html5_bar_chart(''||',
'            APEX_JAVASCRIPT.ADD_VALUE(P_REGION.STATIC_ID)||',
'            ''{''||',
'                -- Why is this attribute needed if is not used?',
'                APEX_JAVASCRIPT.ADD_ATTRIBUTE(',
'                    ''pageItems'', ',
'                    APEX_PLUGIN_UTIL.PAGE_ITEM_NAMES_TO_JQUERY(P_REGION.AJAX_ITEMS_TO_SUBMIT)',
'                )||',
'                APEX_JAVASCRIPT.ADD_ATTRIBUTE(',
'                    ''ajaxIdentifier'', ',
'                    APEX_PLUGIN.GET_AJAX_IDENTIFIER, ',
'                    FALSE, ',
'                    FALSE',
'                )||',
'            ''}''||',
'        '');''',
'    );',
'    ',
'    RETURN NULL;',
'END RENDER;',
'',
'FUNCTION AJAX (',
'    P_REGION IN APEX_PLUGIN.T_REGION,',
'    P_PLUGIN IN APEX_PLUGIN.T_PLUGIN',
') RETURN APEX_PLUGIN.T_REGION_AJAX_RESULT IS',
'    -- Map region attributes to function constants',
'    -- MODERN, CLASSIC',
'    C_CHART_TYPE CONSTANT VARCHAR2(7) := P_REGION.ATTRIBUTE_15;',
'    -- MODERN, MODERN_2, SOLAR, METRO, CUSTOM, COLUMN',
'    C_COLOR_SCHEME CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_17;',
'    C_CUSTOM_CHART_COLORS CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_10;',
'    C_COLOR_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_19;',
'    -- NONE, IMAGE, ICON, INITIALS',
'    C_ICON_TYPE CONSTANT VARCHAR2(8) := case when C_CHART_TYPE = ''ICON'' then P_REGION.ATTRIBUTE_01 end;',
'    C_LABEL_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_02;',
'    C_LABEL_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_03;',
'    C_VALUE_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_04;',
'    C_VALUE_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_05;',
'    -- ABOVE, AROUND',
'    C_TEXT_POSITION VARCHAR2(6) := P_REGION.ATTRIBUTE_18;',
'    C_CHART_CSS_CLASSES CONSTANT VARCHAR2(32767) := P_REGION.ATTRIBUTE_06;',
'    C_IMAGE_URL CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_07;',
'    C_CSS_ICON_CLASS_NAME CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_08;',
'    C_INITIALS_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_09;',
'    -- ABSOLUTE, RELATIVE',
'    C_BAR_WIDTH_CALCULATION CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_16;',
'    C_DISPLAY CONSTANT VARCHAR2(19) := P_REGION.ATTRIBUTE_11;',
'    C_PREFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_12;',
'    C_POSTFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_13;',
'    C_MAXIMUM_ROWS CONSTANT NUMBER := P_REGION.ATTRIBUTE_14;',
'    C_MESSAGE_WHEN_NO_DATA_FOUND CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_20;',
'    ',
'    L_COLOR_COLUMN_NUMBER PLS_INTEGER;',
'    L_LABEL_COLUMN_NUMBER PLS_INTEGER;',
'    L_VALUE_COLUMN_NUMBER PLS_INTEGER;',
'    L_INITIALS_COLUMN_NUMBER PLS_INTEGER;',
'    ',
'    L_COLUMN_VALUE_LIST APEX_PLUGIN_UTIL.T_COLUMN_VALUE_LIST2;',
'    ',
'    L_COLOR VARCHAR2(4000) := NULL;',
'    L_LABEL VARCHAR2(4000) := NULL;',
'    L_LABEL_LINK VARCHAR2(4000) := NULL;',
'    L_VALUE VARCHAR2(4000) := NULL;',
'    L_VALUE_LINK VARCHAR2(4000) := NULL;',
'    L_IMAGE_URL VARCHAR2(4000) := NULL;',
'    L_CSS_ICON_CLASS_NAME VARCHAR2(4000) := NULL;',
'    L_INITIALS VARCHAR2(4000) := NULL;',
'    L_MESSAGE_WHEN_NO_DATA_FOUND VARCHAR2(4000) := NULL;',
'',
'    L_CUSTOM_CHART_COLORS_TABLE APEX_APPLICATION_GLOBAL.VC_ARR2;',
'    L_CUSTOM_CHART_COLORS VARCHAR2(32767) := NULL;',
'BEGIN',
'    L_COLUMN_VALUE_LIST := APEX_PLUGIN_UTIL.GET_DATA2(',
'        P_SQL_STATEMENT  => P_REGION.SOURCE,',
'        P_MIN_COLUMNS    => 1,',
'        P_MAX_COLUMNS    => NULL,',
'        P_COMPONENT_NAME => P_REGION.NAME,',
'        P_MAX_ROWS => C_MAXIMUM_ROWS',
'    );',
'',
'    L_COLOR_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Color Column'',',
'        P_COLUMN_ALIAS      => C_COLOR_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => C_COLOR_SCHEME = ''COLUMN'',',
'        P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_LABEL_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Label Column'',',
'        P_COLUMN_ALIAS      => C_LABEL_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_VALUE_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Value Column'',',
'        P_COLUMN_ALIAS      => C_VALUE_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    if C_ICON_TYPE = ''INITIALS'' then',
'        L_INITIALS_COLUMN_NUMBER := APEX_PLUGIN_UTIL.GET_COLUMN_NO (',
'            P_ATTRIBUTE_LABEL   => ''Initials Column'',',
'            P_COLUMN_ALIAS      => C_INITIALS_COLUMN,',
'            P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'            P_IS_REQUIRED       => true,',
'            P_DATA_TYPE         => APEX_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'        );',
'    end if;',
'    -- Begin output as JSON',
'    sys.OWA_UTIL.MIME_HEADER(''application/json'', FALSE);',
'    sys.HTP.P(''Cache-Control: no-cache'');',
'    sys.HTP.P(''Pragma: no-cache'');',
'    sys.OWA_UTIL.HTTP_HEADER_CLOSE;',
'    ',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        L_CUSTOM_CHART_COLORS_TABLE := APEX_UTIL.STRING_TO_TABLE(CASE WHEN C_CUSTOM_CHART_COLORS IS NOT NULL THEN TRIM(BOTH '''''''' FROM APEX_ESCAPE.JS_LITERAL(C_CUSTOM_CHART_COLORS)) END, '':'');',
'        L_CUSTOM_CHART_COLORS := ''"color_scheme":['';',
'        FOR I IN L_CUSTOM_CHART_COLORS_TABLE.FIRST .. L_CUSTOM_CHART_COLORS_TABLE.LAST LOOP',
'            IF I > 1 THEN',
'                L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||'','';',
'            END IF;',
'            L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''"''||L_CUSTOM_CHART_COLORS_TABLE(I)||''"'';',
'        END LOOP;',
'        L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''],'';',
'    END IF;',
'',
'    L_MESSAGE_WHEN_NO_DATA_FOUND := APEX_ESCAPE.HTML_WHITELIST(',
'        APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                P_VALUE  => C_MESSAGE_WHEN_NO_DATA_FOUND,',
'                P_ESCAPE => FALSE',
'            )',
'        );',
'',
'    sys.HTP.PRN(',
'        ''{''||',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''chart_type'',',
'                C_CHART_TYPE,',
'                FALSE,',
'                TRUE',
'            )',
'    );',
'    sys.HTP.PRN(',
'        APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'            ''message_when_no_data_found'',',
'            L_MESSAGE_WHEN_NO_DATA_FOUND,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'            ''chart_css_class_names'',',
'            C_CHART_CSS_CLASSES,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'            ''icon_type'',',
'            C_ICON_TYPE,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        sys.HTP.PRN(',
'            L_CUSTOM_CHART_COLORS',
'        );',
'    ELSE',
'        sys.HTP.PRN(',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''color_scheme'',',
'                C_COLOR_SCHEME,',
'                TRUE,',
'                TRUE',
'            )',
'        );',
'    END IF;',
'    sys.HTP.PRN(',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''text_position'',',
'                C_TEXT_POSITION,',
'                FALSE,',
'                TRUE',
'            )||',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''bar_width_calculation'',',
'                C_BAR_WIDTH_CALCULATION,',
'                FALSE,',
'                TRUE',
'            )||',
'            APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                ''display'',',
'                C_DISPLAY,',
'                FALSE,',
'                TRUE',
'            )||',
'            CASE ',
'            	WHEN C_DISPLAY IN (''VALUE'') THEN',
'					APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''prefix_for_value'',',
'						C_PREFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)||',
'					APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''postfix_for_value'',',
'						C_POSTFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)',
'			END||',
'            ''"items":[''',
'    );',
'    ',
'    --FOR L_ROW_NUMBER IN L_COLUMN_VALUE_LIST(1).VALUE_LIST.FIRST .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.LAST LOOP',
'    FOR L_ROW_NUMBER IN 1 .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.COUNT LOOP',
'        BEGIN',
'            APEX_PLUGIN_UTIL.SET_COMPONENT_VALUES (',
'                P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'                P_ROW_NUM => L_ROW_NUMBER ',
'            );',
'            ',
'            IF L_ROW_NUMBER > 1 THEN',
'            	sys.HTP.PRN('', '');',
'            END IF;',
'            ',
'            sys.HTP.PRN(''{'');',
'            ',
'            L_LABEL := APEX_PLUGIN_UTIL.ESCAPE (',
'                APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                    P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).DATA_TYPE,',
'                    P_VALUE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                ),',
'                P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''label'',',
'                    L_LABEL,',
'                    FALSE',
'            	)',
'            );',
'            L_LABEL_LINK := ',
'                CASE ',
'                    WHEN C_LABEL_LINK IS NOT NULL THEN ',
'                        APEX_UTIL.PREPARE_URL (',
'                            APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_LABEL_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'            sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''label_link'',',
'                    L_LABEL_LINK',
'                )',
'            );',
'            L_VALUE := APEX_PLUGIN_UTIL.ESCAPE (',
'               APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                   P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).DATA_TYPE,',
'                   P_VALUE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'               ),',
'               P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''value'',',
'                    L_VALUE,',
'                    FALSE,',
'                    C_VALUE_LINK IS NOT NULL OR L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            L_VALUE_LINK := ',
'                CASE ',
'                    WHEN C_VALUE_LINK IS NOT NULL THEN ',
'                        APEX_UTIL.PREPARE_URL (',
'                            APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_VALUE_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'             sys.HTP.PRN(',
'            	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    ''value_link'',',
'                    L_VALUE_LINK,',
'                    TRUE,',
'                    L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            IF L_COLOR_COLUMN_NUMBER IS NOT NULL THEN',
'                L_COLOR := APEX_PLUGIN_UTIL.ESCAPE (',
'                   APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                       P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).DATA_TYPE,',
'                       P_VALUE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                   ),',
'                   P_REGION.ESCAPE_OUTPUT',
'                );',
'                sys.HTP.PRN(',
'                    APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                        ''color'',',
'                        L_COLOR,',
'                        FALSE,',
'                        C_CHART_TYPE = ''ICON''',
'                    )',
'                );',
'            END IF;',
'            IF C_ICON_TYPE = ''IMAGE'' THEN',
'				L_IMAGE_URL := ',
'                    CASE ',
'                        WHEN C_IMAGE_URL IS NOT NULL THEN ',
'                            APEX_UTIL.PREPARE_URL (',
'                                APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                    P_VALUE  => C_IMAGE_URL,',
'                                    P_ESCAPE => FALSE',
'                                )',
'                            )',
'                    END;',
'				sys.HTP.PRN(',
'					APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''image_url'',',
'						L_IMAGE_URL,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''ICON'' THEN',
'				L_CSS_ICON_CLASS_NAME := APEX_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                    P_VALUE  => C_CSS_ICON_CLASS_NAME,',
'                    P_ESCAPE => TRUE',
'                );',
'				sys.HTP.PRN(',
'                	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'						''icon_css_class_name'',',
'						L_CSS_ICON_CLASS_NAME,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''INITIALS'' THEN',
'				L_INITIALS := APEX_PLUGIN_UTIL.ESCAPE (',
'					APEX_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'						P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).DATA_TYPE,',
'						P_VALUE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'					),',
'					P_REGION.ESCAPE_OUTPUT',
'				);',
'				sys.HTP.PRN(',
'                	APEX_JAVASCRIPT.ADD_ATTRIBUTE (',
'                    	''initials'',',
'	                    L_INITIALS,',
'	                    FALSE,',
'	                    FALSE',
'    	            )',
'    	        );',
'            END IF;',
'            ',
'			sys.HTP.PRN(''}'');',
'            ',
'            APEX_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'        EXCEPTION',
'            WHEN OTHERS THEN',
'                APEX_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'                RAISE;',
'        END;',
'    END LOOP;',
'    sys.HTP.PRN(',
'            '']''||',
'        ''}''',
'    );',
'    ',
'    RETURN NULL;',
'END AJAX;'))
,p_api_version=>1
,p_render_function=>'RENDER'
,p_ajax_function=>'AJAX'
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_reference_id=>5610141522737396215.4001
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Este plugin crea gr\00E1ficos de barras horizontales que contienen etiquetas, valores e incluso iconos</p>')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INITIALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702322154391247789.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Image</strong>: Adds an image HTML element on the left side of the chart.</li>',
'    <li><strong>CSS Icon</strong>: Unlike the &quot;Image&quot; icon, instead of displaying an image HTML element, it displays an icon with the given CSS class.</li>',
'    <li><strong>Initials</strong>: Opposed to both, the &quot;Image&quot; and &quot;CSS Icon&quot; icons, this one displays a colored circle containing the given initials.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702314400089247749.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_display_sequence=>10
,p_display_value=>'Image'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702314934323247750.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_display_sequence=>20
,p_display_value=>'CSS Icon'
,p_return_value=>'ICON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702315423649247750.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_display_sequence=>30
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702315964881247752.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Label Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702316376575247752.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Label Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the label is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702316703235247786.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Value Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given. Notice that this value is not displayed on the chart items when the chart has been configured to display the bar width percentage instead.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702317188143247786.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Value Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the displayed value is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702317539007247786.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Chart CSS Class Names'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'<p>CSS class names to be added to the root element of the chart separated with spaces.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702317934333247786.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>13
,p_prompt=>'Image URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_help_text=>'<p>The Image URL to be displayed as the chart icon. This attribute supports Substitution strings referring to som query column like in <strong>&amp;IMAGE_URL.</strong> which would reference the <strong>IMAGE_URL</strong> column value for each of the '
||'bars presented on the char. Notice that substitutions with no value will be replaced with an empty string.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702318377760247787.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>12
,p_prompt=>'CSS Icon Class Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_help_text=>'<p>The Icon CSS Class Name.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702318725963247787.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>14
,p_prompt=>'Initials Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702314010879247748.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'<p>A query column from which initials to be displayed as an icon are given.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702319144504247787.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>7
,p_prompt=>'Custom Chart Colors'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'CUSTOM'
,p_help_text=>'<p>A list of CSS supported colors separated by colons.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702319520452247788.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Display'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Displays either the item value or the calculated bar width on the right most text in the chart item.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702319913806247788.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702319520452247788.4001)
,p_display_sequence=>10
,p_display_value=>'Value'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702320403431247788.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702319520452247788.4001)
,p_display_sequence=>20
,p_display_value=>'Bar Width'
,p_return_value=>'BAR_WIDTH'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702320901819247788.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Prefix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1702319520452247788.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is prepended to it.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702321301810247789.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Postfix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1702319520452247788.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is appended to it.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702321709351247789.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Maximum Rows'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_help_text=>'<p>The maximum number of items to be displayed inside the region. Notice bar width calculations are made based on the number of items displayed.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702322154391247789.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>4
,p_prompt=>'Chart Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines how the chart will be displayed. There are two types of chart: </p>',
'<ul>',
'    <li><strong>Icon Chart</strong>: Displays bars with the label and value above and add an icon on the left.</li>',
'    <li><strong>Text Chart</strong>: Displays bars with the label and value either above or inline with the bar.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702322552294247789.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702322154391247789.4001)
,p_display_sequence=>10
,p_display_value=>'Icon Chart'
,p_return_value=>'ICON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702323097395247790.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702322154391247789.4001)
,p_display_sequence=>20
,p_display_value=>'Text Chart'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702323567631247790.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>105
,p_prompt=>'Bar Width Calculation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ABSOLUTE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Bar widths for each one of the chart items can be calculated in two ways:</p>',
'<ul>',
'    <li><strong>Absolute</strong>: 100% bar width is represented by the maximum value on the displayed chart items.</li>',
'    <li><strong>Relative</strong>: 100% bar width is represented by the sum of the values of all the displayed chart items.</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702323943852247790.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702323567631247790.4001)
,p_display_sequence=>10
,p_display_value=>'Absolute'
,p_return_value=>'ABSOLUTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702324478736247791.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702323567631247790.4001)
,p_display_sequence=>20
,p_display_value=>'Relative'
,p_return_value=>'RELATIVE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>6
,p_prompt=>'Color Scheme'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MODERN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The colors to be used in the chart bars. There are two special types of configuration: </p>',
'<ul>',
'    <li><strong>Custom</strong>: Provides a text box to receive a colon separated list of css supported colors.</li>',
'</ul>',
'<ul>',
'    <li><strong>Query Column</strong>: Provides a select list with the query columns which expects a css valid color.</li>',
'</ul>',
''))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702325359834247791.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>5
,p_display_value=>'Default'
,p_return_value=>'DEFAULT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702325867654248011.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>10
,p_display_value=>'Modern'
,p_return_value=>'MODERN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702326211699248013.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>20
,p_display_value=>'Modern 2'
,p_return_value=>'MODERN_2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702326798928248016.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>30
,p_display_value=>'Solar'
,p_return_value=>'SOLAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702327218421248016.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>40
,p_display_value=>'Metro'
,p_return_value=>'METRO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702327735065248017.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>50
,p_display_value=>'Custom'
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702328258259248017.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_display_sequence=>60
,p_display_value=>'Query Column'
,p_return_value=>'COLUMN'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702328793407248017.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>55
,p_prompt=>'Text Position'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AROUND'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702322154391247789.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'TEXT'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When displaying a text chart, two options are available for displaying the label and value texts:</p>',
'<ul>',
'    <li><strong>Above the bar</strong>: The label and value texts are displayed above the bar at the left and right most sides of it respectively.</li>',
'    <li><strong>Inline with the bar</strong>: The label, the bar and the value are displayed in one line on that order.</li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702329113022248018.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702328793407248017.4001)
,p_display_sequence=>10
,p_display_value=>'Above the bar'
,p_return_value=>'ABOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702329653191248018.4001)
,p_plugin_attribute_id=>wwv_flow_api.id(1702328793407248017.4001)
,p_display_sequence=>20
,p_display_value=>'Inline with the bar'
,p_return_value=>'AROUND'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702330199798248018.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>8
,p_prompt=>'Chart Colors Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1702324943371247791.4001)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'COLUMN'
,p_help_text=>'<p>A query column from which CSS supported colors are given.</p>'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1702330572647248018.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>'Message When No Data Found'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'No data found.'
,p_is_translatable=>true
,p_help_text=>'<p>Message to be displayed when no data was found.</p>'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1702334286876248033.4001)
,p_plugin_id=>wwv_flow_api.id(3347174819831483585.4001)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4970031699302343.4001)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Escritorio'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=4000:1500:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>.4001
,p_navigation_list_position=>'SIDE'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('P\00E1gina Global')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_comment=>'Global attributes for all pages'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162055500354530228.4001)
,p_plug_name=>'Global Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'apex.builder.gApplicationId="&FB_FLOW_ID.";',
'apex.builder.gPageId="&FB_FLOW_PAGE_ID.";',
'</script>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'4500'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386900176106343571.4001)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-app-builder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386900501419360208.4001)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_api.id(386900176106343571.4001)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386866421782888461.4001)
,p_plug_name=>'Home Link'
,p_parent_plug_id=>wwv_flow_api.id(386900501419360208.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386867521811919469.4001)
,p_plug_name=>'APEX 5 - Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_api.id(386900501419360208.4001)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(384991882401692897.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(384714985827023169.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386903916606439383.4001)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_api.id(386900501419360208.4001)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<a href="''',
'          ||apex_util.prepare_url(''f?p=4500:1000:''||:APP_SESSION||''::''||:DEBUG||''::::'')',
'          ||''" class="a-Header-logo" title="''||wwv_flow_lang.system_message(''HOME_NAV'')',
'          ||''"><span class="a-Header-apexLogo"><span class="u-VisuallyHidden">''',
'          ||wwv_flow_lang.system_message(''HOME_NAV'')||''</span></span></a>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386900769360361408.4001)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_api.id(386900176106343571.4001)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386868520035950353.4001)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_api.id(386900769360361408.4001)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>25
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(384693505787932850.4001)
,p_plug_name=>'Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(488490120498750288.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386922861102419764.4001)
,p_plug_name=>'Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(384736293175059813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386870749356009641.4001)
,p_plug_name=>'APEX 5 - Account'
,p_parent_plug_id=>wwv_flow_api.id(386900769360361408.4001)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>35
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702958167090571310.4001)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_api.id(386900769360361408.4001)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_search_label varchar2(255) := wwv_flow_lang.system_message(case when :APP_PAGE_ID = 1500 then ''WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'' else ''WWV_FLOW_QUICK_FLOW.SEARCH.APPS'' end);',
'begin',
'    sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'    sys.htp.p(''  <div class="a-SearchBox-field">'');',
'    sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'    sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">''||l_search_label||''</label>'');',
'    sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||l_search_label||''">'');',
'    sys.htp.p(''  </div>'');',
'    sys.htp.p(''</div>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386911214938955189.4001)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-app-builder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1500, 4500'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386911642894962070.4001)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_api.id(386911214938955189.4001)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386912872680970625.4001)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_api.id(386911642894962070.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(6341600034528019.4001)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(3705314539083.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386912265387964452.4001)
,p_plug_name=>'APEX 5 - Control Bar Right'
,p_parent_plug_id=>wwv_flow_api.id(386911214938955189.4001)
,p_region_css_classes=>'a-ControlBar-col'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2104,2105,2106,2107,2108,2109,2111,2115,163,56,176,189,433,447,448,451,454,458,494,495,496,3001,3002,3005,3020,49,57,3000,2116,598,2117,73,227,20,800,2150,2151,2152,2153,2154,2155,2157,733,870,871,872'
||',873,580,585,588,589,599,226,875,876,700,705,720,725,730,735,880,882,600,605,615,620,625,630,635,884,886,196,722,523,689,4460,479,224,4900,76,441,933,559,934,78,279,50,81,82,83,209,650,680,160'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33628224409605418.4001)
,p_plug_name=>'Run Page'
,p_region_name=>'apex-control-icons'
,p_parent_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4717527352803690.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(210393202311761690.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2104,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2104,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2'
||'150,2151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,44'
||'1,11005,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(386916710302082539.4001)
,p_plug_name=>'Page Selector'
,p_parent_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_region_css_classes=>'a-PageSelect a-PageSelect--separate a-PageSelect--readOnly'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<span class="a-PageSelect-icon a-Icon icon-page"></span>&FB_FLOW_PAGE_ID.'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1617426373817257725.4001)
,p_plug_name=>'Container for global hidden items'
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(591706539339020444.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Actualizaci\00F3n disponible')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-calendar u-info-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(591706620458020445.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Actualizaci\00F3n en Curso')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-warning u-danger-text'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(233600616656079605.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_button_name=>'Spotlight'
,p_button_static_id=>'header-spotlightSearch'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('B\00FAsqueda Spotlight')
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-actionButton a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-search'
,p_button_cattributes=>'data-action="spotlight-search"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386866668508896430.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(386866421782888461.4001)
,p_button_name=>'HOME'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Inicio'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4500:1000:&SESSION.::&DEBUG.::::'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-home'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386869270812963957.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_button_name=>'ADMINISTRATION'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Administraci\00F3n')
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386869633187969036.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_button_name=>'Feedback'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Comentarios'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_api.id(693447794026530907.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386920635912182000.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_button_name=>'DEVELOPER_COMMENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Comentario del Desarrollador'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.:NONE,1234:P1234_FLOW_ID:&FB_FLOW_ID.'
,p_button_css_classes=>'a-Button a-Button--noLabel a-Button--padLeft'
,p_icon_css_classes=>'icon-add-comment'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2573485248212629191.4001)
,p_button_sequence=>55
,p_button_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_button_name=>'FIND'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Buscar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.popup({url:"f?p=4000:273:&APP_SESSION.:::273:F4000_P273_PAGE:&FB_FLOW_PAGE_ID.",name:''Finder'',width:800,height:600});'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-find'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386869842992971065.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(386868520035950353.4001)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386914913915018339.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_button_name=>'SHARED_COMPONENTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Componentes Compartidos'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button a-Button--noLabel a-Button--padLeft'
,p_icon_css_classes=>'icon-shared-components'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386915504377040843.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(2045667935478789095.4001)
,p_button_image_alt=>unistr('<span class="u-\2248">Editar p\00E1gina</span> &FB_FLOW_PAGE_ID. ')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--withIcon a-Button--gapLeft a-Button--editPageButton a-Button--iconTopAction'
,p_icon_css_classes=>'icon-edit-page'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(386916235869059617.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(386912265387964452.4001)
,p_button_name=>'RUN_PAGE'
,p_button_static_id=>'button-run-page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Ejecutar P\00E1gina &FB_FLOW_PAGE_ID.')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:RUN_PAGE:&SESSION.:BRANCH_TO_PAGE_ACCEPT:&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui',
' where p.flow_id = :FB_FLOW_ID',
'   and p.id      = :FB_FLOW_PAGE_ID',
'   and ui.id     = p.user_interface_id',
'   and ( ui.global_page_id  <> :FB_FLOW_PAGE_ID',
'       or ui.global_page_id is null',
'       )',
'   and p.page_mode = ''NORMAL'''))
,p_button_condition_type=>'EXISTS'
,p_button_css_classes=>'launch-aut a-Button a-Button--noLabel a-Button--withIcon a-Button--iconTopAction a-Button--padLeft'
,p_icon_css_classes=>'icon-run-page'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72688801649844540.4001)
,p_name=>'P0_FLOWPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(162055500354530228.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'&FB_FLOW_ID.;&FB_FLOW_PAGE_ID.|&F4000_LAST_VIEW.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>'1000,460,514,516,527,273,2100,2101,2102,2103,2104,2105,2106,2107,2108,2109,2111,2115,1500,163,56,176,189,433,447,448,451,454,458,494,495,496,3001,3002,3005,3020,49,57'
,p_display_when_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(385808383792243608.4001)
,p_name=>'P0_WINDOW_MGMT_MODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1617426373817257725.4001)
,p_item_default=>'FOCUS'
,p_source=>'APEX_WINDOW_MGMT_MODE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(385808740658243612.4001)
,p_name=>'P0_WINDOW_MGMT_SHARE_WINDOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1617426373817257725.4001)
,p_item_default=>'N'
,p_source=>'APEX_WINDOW_MGMT_SHARE_WINDOW'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Creador de Aplicaciones'
,p_alias=>'HOME'
,p_step_title=>'Creador de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'function submitenter(e)',
'{',
'var keycode;',
'if (window.event) keycode = window.event.keyCode;',
'else if (e) keycode = e.which;',
'else return true;',
'',
'if (keycode == 13)',
'   {',
'   apex.submit(''PAGE'');',
'   return false;',
'   }',
'else',
'   return true;',
'}',
'',
'//-->',
'</script>'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Developer Toolbar integration */',
'apex.builder.nameBuilderWindow();',
'apex.jQuery(''#apex_pages_irr_toolbar'').wrap(''<div class="a-IRR-toolbarWrap" id="apps_irr_wrap_toolbar"></div>'');',
'apex.builder.initStickyHeader(''apps_irr_wrap_toolbar'');',
'apex.theme.defaultStickyTop = function() { return $("#apps_irr_wrap_toolbar").outerHeight(); }',
'',
''))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(74845831538733642)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(3273609219075266.4001)
,p_name=>unistr('P\00E1ginas Editadas Recientemente')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('El informe no contiene ning\00FAn dato')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3273926620075269.4001)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3274009553075269.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3326719762130228.4001)
,p_plug_name=>unistr('P\00E1ginas')
,p_region_name=>'apex_pages_irr'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>60
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P1 */',
'   p.id,',
'   p.flow_id the_flow,',
'   name,',
'   tab_set,',
'   p.id||'' - ''||name icon_text, ',
'   last_updated_on updated,',
'   lower(last_updated_by) last_updated_by,',
'   created_on,',
'   lower(created_by) created_by,',
'   case when p.page_mode = ''NORMAL'' and page_component_map <> 14',
'        then ''<button type="button" data-link="f?p=4000:RUN_PAGE:''||:app_session||',
'            '':BRANCH_TO_PAGE_ACCEPT:::FB_FLOW_PAGE_ID,FB_FLOW_ID:''||p.id||'',''||p.flow_id ||',
'            ''" title="''||wwv_flow_lang.system_message(''RUN_PAGE_ID'', p.id)||',
'            ''" aria-label="''||wwv_flow_lang.system_message(''RUN_PAGE_ID'', p.id)||',
'            ''" class="a-Button a-Button--noLabel a-Button--withIcon launch-aut a-Button--noUI"><span class="a-Icon icon-run-page" aria-hidden="true"></span></button>''',
'   else '' '' end actions,',
'   decode(',
'       l.locked_by,',
'       null,',
'      ''<span class="a-Icon icon-unlock" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_ID_UNLOCKED'', p.id)||''</span>'',',
'      ''<span class="a-Icon icon-lock" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_ID_UNLOCKED'', p.id)||''</span>'') Locked,',
'   decode(',
'       l.locked_by,',
'       null,',
'      ''f?p=4000:444:''||:app_session||'':::444:P337_ID,FB_FLOW_PAGE_ID,P444_LOCK_PAGES:,''||p.id||'',''||p.id||'',''||p.id,',
'      ''f?p=4000:337:''||:app_session||'':::337:P337_ID,FB_FLOW_PAGE_ID:''||l.id||'',''||p.id) locked_link,',
'      nvl(g.group_name,sm.t_unassigned) group_name,',
'      decode(g.group_name, null, ''f?p=4000:520:''||:app_session||'':::520:'',''f?p=4000:521:''||:app_session||'':::521,RP,RIR:P521_ID:''||g.id) group_link,',
'      decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''19'',sm.apex_map,',
'         ''20'',sm.apex_jstree,',
'         ''21'',sm.apex_ig,    ',
'         ''22'',sm.apex_faceted_search,',
'         ''23'',sm.apex_cards,',
'         ''unknown'') page_type,',
'   p.page_mode,',
'   -- icon columns',
'   decode(substr(nvl(page_component_map,''00''),1,2),',
'         ''01'',''icon-page-form-tabular'',',
'         ''02'',''icon-page-form'',',
'         ''03'',''icon-page-report'', ',
'         ''04'',''icon-page-chart'',',
'         ''05'',''icon-page-webservice'',',
'         ''06'',''icon-page-nav'',',
'         ''07'',''icon-page-tree'',',
'         ''08'',''icon-page-calendar'',',
'         ''09'',''icon-page-url'',',
'         ''10'',''icon-page-dynamic'',',
'         ''11'',''icon-page-static'',',
'         ''12'',''icon-page-login'',',
'         ''13'',''icon-page-home'',',
'         ''14'',''icon-page-global'',',
'         ''15'','' '',',
'         ''16'',''icon-page-dynamic-form'',',
'         ''17'',''icon-page-wizard'',',
'         ''18'',''icon-page-ir'',',
'         ''19'',''icon-page-map'',',
'         ''20'',''icon-page-tree'',',
'         ''21'',''icon-page-report'', ',
'         ''22'',''icon-page-faceted-search'',',
'         ''23'',''icon-page-cards'',',
'         '' '') page_type_class,',
'   ''f?p=4000:4500:''||:app_session||',
'     ''::::FB_FLOW_ID,FB_FLOW_PAGE_ID:''||',
'     p.flow_id||'',''||p.id edit_page_url,',
'     lower(ALIAS) alias,',
'     STEP_TITLE Page_title,',
'     user_interface_id,',
'     decode(first_item,',
'        ''NO_FIRST_ITEM'',sm.t_no,',
'        ''AUTO_FIRST_ITEM'',sm.auto_first_item,',
'        sm.t_no) FIRST_ITEM,',
'     decode(INCLUDE_APEX_CSS_JS_YN,',
'        ''Y'',sm.t_yes,',
'        ''N'',sm.t_no,',
'        INCLUDE_APEX_CSS_JS_YN)',
'        INCLUDE_APEX_CSS_JS,',
'     HELP_TEXT,',
'     FOOTER_TEXT,',
'     welcome_text header_text,',
'     (select name from wwv_flow_templates t where p.STEP_TEMPLATE = t.id)',
'         page_template,',
'     case',
'     when p.required_role = ''MUST_NOT_BE_PUBLIC_USER'' then t_must_not_be_public_user',
'     else (select case when p.required_role like ''!%'' then ''{'' end||',
'                  max(name) ||',
'                  case when p.required_role like ''!%'' then ''}'' end',
'             from wwv_flow_security_schemes s ',
'            where s.flow_id = p.flow_id and to_char(s.id) = ltrim(p.REQUIRED_ROLE,''!''))',
'     end authorization_scheme,',
'     (select patch_name',
'      from WWV_FLOW_PATCHES bo',
'      where bo.id = p.REQUIRED_PATCH) build_option,',
'     HTML_PAGE_HEADER,',
'     HTML_PAGE_ONLOAD,',
'     decode(ALLOW_DUPLICATE_SUBMISSIONS,',
'        ''Y'',sm.t_yes,',
'        ''N'',sm.t_no,',
'        sm.t_yes) ALLOW_DUPLICATE_SUBMISSIONS,',
'     ON_DUP_SUBMISSION_GOTO_URL,',
'     decode(PAGE_IS_PUBLIC_Y_N,',
'        ''Y'',sm.t_yes,',
'        ''N'',sm.t_no,',
'        PAGE_IS_PUBLIC_Y_N) PAGE_IS_PUBLIC,',
'     decode(protection_level,',
'        ''D'',sm.NO_URL_ACCESS,',
'        ''N'',sm.Unrestricted,',
'        ''U'',sm.no_arguments_allowed,',
'        ''C'',sm.arguments_must_have_checksum,',
'        sm.Unrestricted',
'        ) PROTECTION_LEVEL,',
'     ERROR_NOTIFICATION_TEXT,',
'     decode(CACHE_MODE,',
'        ''NOCACHE'',sm.t_no,',
'        sm.t_yes)',
'        CACHE_PAGE,',
'     CACHE_TIMEOUT_SECONDS,',
'     PAGE_COMMENT,',
'     sm.edit',
'from  wwv_flow_steps p,',
'      WWV_FLOW_LOCK_PAGE l,',
'      (select ',
'           wwv_flow_lang.system_message(''LOCKED'') locked,',
'           wwv_flow_lang.system_message(''RUN'') run,',
'           wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'           wwv_flow_lang.system_message(''EDIT'') edit,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''LAYOUT.MAP'') apex_map,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_jstree,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'           wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') t_must_not_be_public_user,',
'           wwv_flow_lang.system_message(''REGION_NAME.NATIVE_IG'') apex_ig,',
'           wwv_flow_lang.system_message(''REGION_NAME.NATIVE_FACETED_SEARCH'') apex_faceted_search,',
'           wwv_flow_lang.system_message(''REGION_NAME.NATIVE_CARDS'') apex_cards',
'       from sys.dual)  sm,',
'      WWV_FLOW_PAGE_GROUPS g',
'where p.flow_id           = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id ',
'  and p.flow_id           = l.flow_id   (+)',
'  and p.id                = l.object_id (+) ',
'  and p.group_id          = g.id        (+) '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_comment=>'apex 4 rounded corner no top = page template alt'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3326806401130228.4001)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#EDIT_PAGE_URL#" class="a-IRR-icon a-IRR-icon--page">',
'    <span class="a-Icon #PAGE_TYPE_CLASS#" aria-hidden="true"></span>',
'    <span class="a-Icon a-IRR-pageIcon"></span>',
'    <span class="a-IRR-iconName">#ICON_TEXT#</span>',
'</a>'))
,p_icon_view_columns_per_row=>6
,p_description=>'prueba'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327015271130235.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327219782130236.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:#THE_FLOW#,#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3598317434824474.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>12
,p_column_identifier=>'N'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327325700130237.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>22
,p_column_identifier=>'D'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327405430130237.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>32
,p_column_identifier=>'E'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327822682130239.4001)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>42
,p_column_identifier=>'I'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327706045130239.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>52
,p_column_identifier=>'H'
,p_column_label=>'Grupo'
,p_column_link=>'#GROUP_LINK#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327631385130239.4001)
,p_db_column_name=>'LOCKED'
,p_display_order=>62
,p_column_identifier=>'G'
,p_column_label=>'Bloquear'
,p_column_link=>'#LOCKED_LINK#'
,p_column_linktext=>'#LOCKED#'
,p_column_link_attr=>'class="a-Button a-Button--noUI a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327503654130239.4001)
,p_db_column_name=>'ACTIONS'
,p_display_order=>72
,p_column_identifier=>'F'
,p_column_label=>'Ejecutar'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3327114487130236.4001)
,p_db_column_name=>'THE_FLOW'
,p_display_order=>82
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3529506898210201.4001)
,p_db_column_name=>'TAB_SET'
,p_display_order=>102
,p_column_identifier=>'M'
,p_column_label=>'Juego de Separadores'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3598430351824474.4001)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>112
,p_column_identifier=>'O'
,p_column_label=>unistr('T\00EDtulo de P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5386400008191216.4001)
,p_db_column_name=>'USER_INTERFACE_ID'
,p_display_order=>122
,p_column_identifier=>'AU'
,p_column_label=>'Interfaz de Usuario'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(5351212231959574)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3598524038824474.4001)
,p_db_column_name=>'FIRST_ITEM'
,p_display_order=>132
,p_column_identifier=>'P'
,p_column_label=>'Centrarse en Primer Elemento'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3598618419824474.4001)
,p_db_column_name=>'INCLUDE_APEX_CSS_JS'
,p_display_order=>142
,p_column_identifier=>'Q'
,p_column_label=>'Incluir APEX CSS JS'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3598714437824475.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>152
,p_column_identifier=>'R'
,p_column_label=>'Texto de Ayuda'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3598805627824475.4001)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>162
,p_column_identifier=>'S'
,p_column_label=>unistr('Esquema de Autorizaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599027723824478.4001)
,p_db_column_name=>'HTML_PAGE_HEADER'
,p_display_order=>172
,p_column_identifier=>'U'
,p_column_label=>unistr('Cabecera de P\00E1gina HTML')
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599106523824478.4001)
,p_db_column_name=>'HTML_PAGE_ONLOAD'
,p_display_order=>182
,p_column_identifier=>'V'
,p_column_label=>unistr('Carga de P\00E1gina HTML')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599205564824478.4001)
,p_db_column_name=>'ALLOW_DUPLICATE_SUBMISSIONS'
,p_display_order=>192
,p_column_identifier=>'W'
,p_column_label=>'Permitir Ejecuciones Duplicadas'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599308440824478.4001)
,p_db_column_name=>'ON_DUP_SUBMISSION_GOTO_URL'
,p_display_order=>202
,p_column_identifier=>'X'
,p_column_label=>'En las Ejecuciones Duplicadas, Ir a URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599423888824478.4001)
,p_db_column_name=>'PAGE_IS_PUBLIC'
,p_display_order=>212
,p_column_identifier=>'Y'
,p_column_label=>unistr('P\00E1gina P\00FAblica')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599520887824479.4001)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>222
,p_column_identifier=>'Z'
,p_column_label=>unistr('Nivel de Protecci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599601799824479.4001)
,p_db_column_name=>'ERROR_NOTIFICATION_TEXT'
,p_display_order=>232
,p_column_identifier=>'AA'
,p_column_label=>unistr('Texto de Notificaci\00F3n de Error')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599719727824479.4001)
,p_db_column_name=>'CACHE_PAGE'
,p_display_order=>242
,p_column_identifier=>'AB'
,p_column_label=>unistr('P\00E1gina en Cach\00E9')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599809426824479.4001)
,p_db_column_name=>'CACHE_TIMEOUT_SECONDS'
,p_display_order=>252
,p_column_identifier=>'AC'
,p_column_label=>unistr('Segundos de Timeout de Cach\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3599927201824479.4001)
,p_db_column_name=>'PAGE_COMMENT'
,p_display_order=>262
,p_column_identifier=>'AD'
,p_column_label=>unistr('Comentario de P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3615527514130105.4001)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>272
,p_column_identifier=>'AE'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3619721860270356.4001)
,p_db_column_name=>'FOOTER_TEXT'
,p_display_order=>282
,p_column_identifier=>'AF'
,p_column_label=>unistr('Texto de Pie de P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3619818778270357.4001)
,p_db_column_name=>'HEADER_TEXT'
,p_display_order=>292
,p_column_identifier=>'AG'
,p_column_label=>'Texto de Cabecera'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3619925056270357.4001)
,p_db_column_name=>'PAGE_TEMPLATE'
,p_display_order=>302
,p_column_identifier=>'AH'
,p_column_label=>unistr('Plantilla de P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3942706230112994.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>312
,p_column_identifier=>'AP'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3942805862112994.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>322
,p_column_identifier=>'AQ'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(876204521585178807.4001)
,p_db_column_name=>'LOCKED_LINK'
,p_display_order=>332
,p_column_identifier=>'AS'
,p_column_label=>'Enlace Bloqueado'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(17232419477873067.4001)
,p_db_column_name=>'EDIT'
,p_display_order=>342
,p_column_identifier=>'AT'
,p_column_label=>'Editar'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(246103625365182038.4001)
,p_db_column_name=>'PAGE_TYPE_CLASS'
,p_display_order=>352
,p_column_identifier=>'AV'
,p_column_label=>unistr('Clase de Tipo de P\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(246246315567566509.4001)
,p_db_column_name=>'ICON_TEXT'
,p_display_order=>362
,p_column_identifier=>'AX'
,p_column_label=>'Texto de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(44907214251292068.4001)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>372
,p_column_identifier=>'AY'
,p_column_label=>unistr('Modo de P\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(44400703264122475)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(404733460492551882.4001)
,p_db_column_name=>'GROUP_LINK'
,p_display_order=>382
,p_column_identifier=>'AZ'
,p_column_label=>'Enlace de Grupos'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(112547833936702807.4001)
,p_db_column_name=>'EDIT_PAGE_URL'
,p_display_order=>392
,p_column_identifier=>'BA'
,p_column_label=>unistr('Editar URL de P\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18275317375026217.4001)
,p_plug_name=>'List For Button Dropdown'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>80
,p_list_id=>wwv_flow_api.id(18268207632995006.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25168428029007326.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17113830931867323.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(70878048211225901.4001)
,p_plug_name=>unistr('\00DAltima Copia de Seguridad')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p><a href="f?p=&APP_ID.:971:&APP_SESSION_VISIBLE.:::971">&P1_LAST_BACKUP.</a></p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_backup.backup_limit() > 0 and :P1_LAST_BACKUP is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74808517252457688.4001)
,p_plug_name=>unistr('Aplicaci\00F3n &P1_APPLICATION.')
,p_region_css_classes=>'a-Region--bottomBorder'
,p_region_sub_css_classes=>'app-builder'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(46890703166185102.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(481294291606549740.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
,p_plug_comment=>'keep this one'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117232502747823413.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177874126414161443.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice la p\00E1gina inicial de Aplicaci\00F3n para ejecutar, editar, importar, exportar, copiar o suprimir una aplicaci\00F3n. Seleccione una p\00E1gina para editar sus propiedades o haga clic en <strong>Crear P\00E1gina</strong> para agregar una p\00E1gina a la aplica')
||unistr('ci\00F3n.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-application-home-page.html">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30829506106300681.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(74808517252457688.4001)
,p_button_name=>'EDIT_APPLICATION_PROPERTIES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Propiedades de Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4299319680596709.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3326719762130228.4001)
,p_button_name=>'CREATE_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear P\00E1gina')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:181,259,380,311,4716::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112826802284807604.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(318597845254.4001)
,p_name=>'F4000_P1_RUN_LINK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7000812679286535.4001)
,p_name=>'P1_GOTO_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19152423570961323.4001)
,p_name=>'P1_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20216022830028036.4001)
,p_name=>'P1_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(74808517252457688.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(70878103917225902.4001)
,p_name=>'P1_LAST_BACKUP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_format_mask=>'SINCE'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  htmldb_util.get_since(max(nvl(last_updated_on, created_on)))',
'from wwv_flow_backups$',
'where application_id = :FB_FLOW_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95753101893550270.4001)
,p_name=>'F4000_P1_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109273914819088651.4001)
,p_name=>'F4000_P1_FLOW'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137085400245224134.4001)
,p_name=>'P1_EDIT_PAGE_ALT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_source=>'wwv_flow_lang.system_message(''EDIT_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430810030823232090.4001)
,p_name=>'P1_DISPLAY_MODE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(117232502747823413.4001)
,p_source=>'ICONS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'U'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4913821892.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(19796816493002091.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select wwv_flow_escape.html(name) from wwv_flows where id = :fb_flow_id'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4814887487.4001)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'when user creates a new flow then set the current flow ID to null.'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(430814706460291255.4001)
,p_computation_sequence=>40
,p_computation_item=>'P1_DISPLAY_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ICONS'
,p_compute_when=>'P1_DISPLAY_MODE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168729305152340203.4001)
,p_computation_sequence=>50
,p_computation_item=>'P1_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' - ''||name n',
'from wwv_flows f',
'where f.id = :fb_flow_id and ',
'      f.security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548124028089409874.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>5
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4299319680596709.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(551184684186821404.4001)
,p_event_id=>wwv_flow_api.id(548124028089409874.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lFlowId     = this.data.FB_FLOW_ID,',
'    lPageId     = this.data.FB_FLOW_PAGE_ID,',
'    lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'    lUrl        = ''f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:'' + lFlowId + '','' + lPageId;',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
' setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(692817912007250941.4001)
,p_name=>'Tasks Options - Dialog Closed'
,p_event_sequence=>15
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(25168428029007326.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(692818077017250942.4001)
,p_event_id=>wwv_flow_api.id(692817912007250941.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lFlowId     = this.data.FB_FLOW_ID,',
'    lPageId     = this.data.FB_FLOW_PAGE_ID,',
'    lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'    lUrl        = ''f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:'' + lFlowId + '','' + lPageId;',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
' setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(43612743682.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_FOOTER'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Flow Information'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE'
,p_attribute_02=>'FB_FLOW_ID'
,p_attribute_03=>'FB_FLOW_ID'
,p_process_error_message=>'Error al definir preferencias.'
,p_process_when=>'FB_FLOW_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57206698643424399.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flow, page, and run link'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_page_component_map varchar2(255) := null;',
'  l_date date := null;',
'begin',
'wwv_flow_dev.set_flow_builder_state;',
'l_date := to_date(:p1_date,''YYYY.MM.DD.HH24:MI:SS'');',
'wwv_flow_page_map.set_current_application(p_application_id=>v(''FB_FLOW_ID''),p_date=>l_date);',
':p1_date := to_char(sysdate,''YYYY.MM.DD.HH24:MI:SS'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al realizar el proceso.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(97259817770153242.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process audit trail purge'
,p_process_sql_clob=>'delete from WWV_FLOW_BUILDER_AUDIT_TRAIL where AUDIT_DATE < (sysdate - 365);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al depurar la pista de auditor\00EDa del desarrollador.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(31379609401682856.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_error_message=>unistr('Error al restablecer la paginaci\00F3n.')
,p_process_when=>'v(''REQUEST'') is null or v(''REQUEST'') = ''GO'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(238686021281822187.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => apex_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from sys.dual where :FB_FLOW_ID is null',
'union all',
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'intersect',
'select 1',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Objetos de Soporte'
,p_step_title=>'Objetos de Soporte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(937004432516012.4001)
,p_plug_name=>'Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Utilice esta utilidad para establecer las definiciones de objetos de base de datos, im\00E1genes y datos iniciales que se incluir\00E1n con la exportaci\00F3n de la aplicaci\00F3n.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(941221663539994.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(940230882533174.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10027605661417559.4001)
,p_plug_name=>unistr('Instalaci\00F3n')
,p_region_css_classes=>'u-Height h280'
,p_icon_css_classes=>'icon-util-installation-scripts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(10025113710400997.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10122802506814085.4001)
,p_plug_name=>unistr('Desinstalaci\00F3n')
,p_region_css_classes=>'u-Height h280'
,p_icon_css_classes=>'icon-util-deinstallation-scripts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(10121209647806692.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23444102604657520.4001)
,p_plug_name=>'Actualizar'
,p_region_css_classes=>'u-Height h280'
,p_icon_css_classes=>'icon-util-upgrade-scripts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(23445516456661592.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492257309498748106.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice objetos de soporte para definir los scripts de instalaci\00F3n de objetos de base de datos a los que se llamar\00E1 durante el proceso de importaci\00F3n de una aplicaci\00F3n. Tambi\00E9n puede definir scripts de desinstalaci\00F3n para borrar objetos durante el')
||unistr(' proceso de supresi\00F3n de una aplicaci\00F3n. Los objetos de soporte permiten empaquetar la aplicaci\00F3n y los objetos de base de datos necesarios en un \00FAnico archivo.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_plug_name=>'Hidden Items'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8634913737291889.4001)
,p_branch_action=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(938119323520376.4001)
,p_name=>'P2_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(937004432516012.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'select id||'': ''||name from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10185825315142303.4001)
,p_name=>'P2_INCLUDE_IN_EXPORT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(937004432516012.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Incluir en Exportaci\00F3n:')
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las definiciones de objeto de soporte se pueden exportar de manera opcional con la aplicaci\00F3n. Se incluyen todas las opciones de configuraci\00F3n y todos los scripts.</p>'),
'<ul>',
'<li>',
unistr('<strong>S\00ED</strong> incluye las definiciones de objeto de soporte en la exportaci\00F3n de la aplicaci\00F3n. No carga autom\00E1ticamente objetos de soporte de cuando se llaman desde una l\00EDnea de comandos.'),
'<li>',
'<li>',
unistr('<strong>No</strong> no incluye las definiciones de objeto de soporte en la exportaci\00F3n.'),
'</li>',
'<li>',
unistr('<strong>S\00ED e Instalar al Importar Autom\00E1ticamente</strong> incluye definiciones de objeto soporte y una llamada para instalar los objetos de soporte en la exportaci\00F3n de la aplicaci\00F3n. Esta opci\00F3n solo es v\00E1lida para instalaciones de la l\00EDnea de coma')
||unistr('ndos. Cuando la aplicaci\00F3n importa desde la l\00EDnea de comandos, instala o actualiza autom\00E1ticamente los objetos de soporte.'),
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<a title="'' || wwv_flow_escape.html( wwv_flow_lang.system_message( p_name => ''F4000.P2.UPDATE_EXPORT_SETTINGS'' ) ) ||',
'           ''" href="'' ||',
'           wwv_flow_utilities.prepare_url( ''f?p=&APP_ID.:633:'' || :APP_SESSION ) ||',
'           ''">'' || wwv_flow_escape.html( wwv_flow_item.text_from_lov( p_value => :P2_INCLUDE_IN_EXPORT,',
'                                                                      p_lov   => ''EXPORT_SUP_OBJ_OPTIONS'' ) ) ||',
'           ''</a>'' );'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24034827712753809.4001)
,p_name=>'P2_PROMPT_FOR_LICENSE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(937004432516012.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Solicitar Licencia:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(LICENSE_MESSAGE,null,''N'',''Y'') i',
'from WWV_FLOW_INSTALL where FLOW_ID = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si se proporciona el texto de la licencia, el asistente de instalaci\00F3n solicitar\00E1 que se acepte la licencia. Si no se proporciona ning\00FAn texto de licencia, el asistente de instalaci\00F3n no solicitar\00E1 que se acepte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24880218657941536.4001)
,p_name=>'P2_SYS_PRIVS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(937004432516012.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Verificar Privilegios del Sistema:'
,p_post_element_text=>'&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(REQUIRED_SYS_PRIVS,null,''N'',''Y'') REQUIRED_SYS_PRIVS',
'from WWV_FLOW_INSTALL ',
'where FLOW_ID = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El valor <strong>S\00ED</strong> indica que se comprobar\00E1n los privilegios del sistema identificados antes de la instalaci\00F3n de objetos de soporte. El valor <strong>No</strong> indica que no se comprobar\00E1n los privilegios del sistema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40726008959304027.4001)
,p_name=>'P2_REQUIRED_FREE_KB'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(937004432516012.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'KB Libres Necesarios:'
,p_post_element_text=>'&nbsp;'
,p_source=>'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G990'') kb from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la cantidad de espacio libre necesaria para instalar los objetos de soporte. No se comprobar\00E1 el espacio libre si el valor es cero.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40743517681486330.4001)
,p_name=>'P2_CHECK_OBJECTS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(937004432516012.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comprobar Objetos:'
,p_post_element_text=>'&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(REQUIRED_NAMES_AVAILABLE,null,''N'',''Y'') ',
'from wwv_flow_install ',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El valor <strong>S\00ED</strong> indica que se impedir\00E1 la instalaci\00F3n de objetos de soporte si hay objetos especificados en el esquema de an\00E1lisis. El valor <strong>No</strong> indica que no se realizar\00E1 ninguna comprobaci\00F3n de la existencia de objetos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525390710807024435.4001)
,p_name=>'P2_PREREQ_CNT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Prereq Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525390922767024436.4001)
,p_name=>'P2_SUBSTR_CNT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Substr Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525391163823024436.4001)
,p_name=>'P2_BUILD_OPT_CNT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Build Opt Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525391320830024436.4001)
,p_name=>'P2_PRE_INS_VAL_CNT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Pre Ins Val Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525391586725024437.4001)
,p_name=>'P2_INST_SCRIPT_CNT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Inst Script Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525391797857024437.4001)
,p_name=>'P2_MESSAGE_CNT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Message Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525391973271024437.4001)
,p_name=>'P2_UPG_CNT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Upg Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525392194868024438.4001)
,p_name=>'P2_UPG_MSG_CNT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'Upg Msg Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525392357055024438.4001)
,p_name=>'P2_DE_INS_SCRIPT_CNT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'De Ins Script Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1525392577959024439.4001)
,p_name=>'P2_DE_INS_MSG_CNT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(1525384191848007107.4001)
,p_prompt=>'De Ins Msg Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1020666694269825025.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => apex_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1525395170219042414.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'calculate counts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2_PREREQ_CNT  := ''0'';	',
':P2_SUBSTR_CNT  := ''0'';	',
':P2_BUILD_OPT_CNT  := ''0'';	',
':P2_PRE_INS_VAL_CNT  := ''0'';	',
':P2_INST_SCRIPT_CNT  := ''0'';	',
':P2_MESSAGE_CNT  := ''0'';	',
':P2_UPG_CNT  := ''0'';	',
':P2_UPG_MSG_CNT  := ''0'';	',
':P2_DE_INS_SCRIPT_CNT  := ''0'';	',
':P2_DE_INS_MSG_CNT  := ''0'';	',
'',
'select trim(to_char(count(*),''999G999G990'')) into :P2_INST_SCRIPT_CNT from WWV_FLOW_INSTALL_SCRIPTS where FLOW_ID = :fb_flow_id and nvl(script_type,''INSTALL'') = ''INSTALL'';',
'',
'select trim(to_char(count(*),''999G999G990'')) into :P2_UPG_CNT from WWV_FLOW_INSTALL_SCRIPTS where FLOW_ID = :fb_flow_id and nvl(script_type,''INSTALL'') = ''UPGRADE'';',
'',
'select trim(to_char(count(*),''999G999G990'')) into :P2_PRE_INS_VAL_CNT from WWV_FLOW_INSTALL_CHECKS where FLOW_ID = :fb_flow_id;',
'',
'select trim(to_char(count(*),''999G999G990'')) into :P2_BUILD_OPT_CNT from WWV_FLOW_INSTALL_BUILD_OPT where FLOW_ID = :fb_flow_id;',
'',
'for c1 in (',
'select ',
'decode(PROMPT_SUBSTITUTION_01_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_02_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_03_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_04_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_05_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_06_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_07_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_09_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_09_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_10_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_11_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_12_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_13_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_14_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_15_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_16_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_17_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_18_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_19_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_20_YN,''Y'',1,0) s',
' from wwv_flow_install where FLOW_ID = :fb_flow_id ) loop',
'    :P2_SUBSTR_CNT := c1.s;',
'end loop;',
'',
'select trim(to_char(count(*),''999G999G990''))',
'  into :P2_DE_INS_SCRIPT_CNT',
'  from WWV_FLOW_INSTALL',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script), 0) > 0;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10156003432956263.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'seed row'
,p_process_sql_clob=>'insert into wwv_flow_install (id, flow_id, include_in_export_yn) values (wwv_flow_id.next_val,:fb_flow_id, ''Y'');'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido iniciar la fila de la tabla wwv_flow_install.'
,p_process_when=>'select 1 from wwv_flow_install where flow_id = :fb_flow_id'
,p_process_when_type=>'NOT_EXISTS'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Rutas de Navegaci\00F3n')
,p_step_title=>unistr('Edici\00F3n de Cuadr\00EDculas de Rutas de Navegaci\00F3n')
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24600496863590512.4001)
,p_plug_name=>'Breadcrumb Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MENU_OPTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :FB_FLOW_ID ',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Entradas de Ruta de Navegaci\00F3n')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24600739791590514.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_ID,P104_MENU_ID:&ID.,&MENU_ID.'
,p_link_text=>'<span class="a-Icon icon-edit" title="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24600786875590515.4001)
,p_name=>'PARENT_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARENT_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24600947634590516.4001)
,p_name=>'MENU_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MENU_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Ruta de Navegaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_menus',
'where flow_id = :fb_flow_id and  ',
'security_group_id = :flow_security_group_id'))
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601016664590517.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601122311590518.4001)
,p_name=>'OPTION_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OPTION_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601266711590519.4001)
,p_name=>'SHORT_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SHORT_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Abreviatura'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601321006590520.4001)
,p_name=>'LONG_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LONG_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Nombre Completo'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601449617590521.4001)
,p_name=>'LINK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LINK'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601485172590522.4001)
,p_name=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID:&PAGE_ID.'
,p_link_text=>'&PAGE_ID.'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601607761590523.4001)
,p_name=>'ALSO_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ALSO_CURRENT_FOR_PAGES'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>120
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601688766590524.4001)
,p_name=>'DISPLAY_WHEN_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_WHEN_COND_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>130
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601864561590525.4001)
,p_name=>'DISPLAY_WHEN_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_WHEN_CONDITION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>140
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601880569590526.4001)
,p_name=>'DISPLAY_WHEN_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_WHEN_CONDITION2'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>150
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24601978952590527.4001)
,p_name=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_SCHEME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>unistr('Esquema de Autorizaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(283664112341)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602168880590528.4001)
,p_name=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REQUIRED_PATCH'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>unistr('Opci\00F3n de Creaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(198057397)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602268232590529.4001)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>180
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602350254590530.4001)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>190
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602431225590531.4001)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>200
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602492132590532.4001)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>210
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602590525590533.4001)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>220
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602714604590534.4001)
,p_name=>'MENU_OPTION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MENU_OPTION_COMMENT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>230
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602822737590535.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(24602954191590536.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(24600637779590513.4001)
,p_internal_uid=>24600637779590513
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'NONE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183473316974271281.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(111619820846587947.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5384689205657857.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12641615093980826.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(24600496863590512.4001)
,p_validation_name=>'SHORT_NAME not null'
,p_validation_sequence=>10
,p_validation=>'SHORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #COLUMN_HEADER#.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'SHORT_NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3710938572235157.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(24600496863590512.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Breadcrumb Entries - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han guardado los cambios.'
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_api.create_page(
 p_id=>6.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Etiquetas de Elemento'
,p_step_title=>'Editar Etiquetas de Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11795108225707440.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>94
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(78163530548203170.4001)
,p_name=>'Edit Labels For All Items In Application'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"ID" pk1_DISPLAY,',
'"FLOW_ID",',
'"FLOW_STEP_ID",',
'"NAME",',
'"ITEM_SEQUENCE",',
'"PROMPT"',
'from "#OWNER#"."WWV_FLOW_STEP_ITEMS"',
'where flow_id = :fb_flow_id and ',
'      (:P6_LABEL_CONTAINS is null or ',
'        instr(upper(prompt),upper(:P6_LABEL_CONTAINS)) > 0) and',
'      (:P6_label_does_not_contain is null or ',
'        instr(upper(prompt),upper(:P6_label_does_not_contain)) = 0) and',
'      DISPLAY_AS != ''NATIVE_HIDDEN''',
'order by flow_step_id, item_sequence'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('El informe no contiene ning\00FAn dato')
,p_query_num_rows_item=>'P6_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'descargar'
,p_plug_query_exp_filename=>'items.csv'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 10-JUL-2003 20:46:55'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78163903754203179.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78164031621203179.4001)
,p_query_column_id=>2
,p_column_alias=>'PK1_DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Primary Key'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78164102510203179.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78164230232203179.4001)
,p_query_column_id=>4
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>4
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP:FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78164320289203179.4001)
,p_query_column_id=>5
,p_column_alias=>'NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5120:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78164428153203179.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>6
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78164532058203179.4001)
,p_query_column_id=>7
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>7
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78166616481208588.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78166724876208595.4001)
,p_column_sequence=>2
,p_query_column_name=>'PK1_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78166827798208595.4001)
,p_column_sequence=>3
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78166925411208595.4001)
,p_column_sequence=>4
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78167010962208595.4001)
,p_column_sequence=>5
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78167104556208596.4001)
,p_column_sequence=>6
,p_query_column_name=>'ITEM_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78167204138208596.4001)
,p_column_sequence=>7
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194134523895034626.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240634807391760869.4001)
,p_plug_name=>'Etiquetas de Elementos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice este informe para asegurar la consistencia de las etiquetas de elementos de todas las p\00E1ginas de la aplicaci\00F3n.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78171209471225515.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(11795108225707440.4001)
,p_button_name=>'P6_GO'
,p_button_static_id=>'P6_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78164731599203180.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11795108225707440.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78165601513203186.4001)
,p_branch_action=>'f?p=&FLOW_ID.:6:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 10-JUL-2003 20:46:55'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78170505315224353.4001)
,p_name=>'P6_LABEL_CONTAINS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11795108225707440.4001)
,p_prompt=>'La Etiqueta Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Filtre por nombre de etiqueta. Introduzca la cadena que desea incluir en los resultados de la b\00FAsqueda y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78185526617268342.4001)
,p_name=>'P6_LABEL_DOES_NOT_CONTAIN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11795108225707440.4001)
,p_prompt=>'La Etiqueta No Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Filtre por nombre de etiqueta. Introduzca la cadena que no desea incluir en los resultados de la b\00FAsqueda y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(93622315611579574.4001)
,p_name=>'P6_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(11795108225707440.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de elementos que se mostrar\00E1n y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78165200379203184.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(78163530548203170.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEMS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(78164731599203180.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 10-JUL-2003 20:46:55'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1997727808552704785.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_api.create_page(
 p_id=>7.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Varios Elementos'
,p_step_title=>'Suprimir Varios Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40282027968411412.4001)
,p_name=>'Seleccionar Elementos a Eliminar'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<input type="checkbox" name="f01" id="f01_''||wwv_flow_escape.html(id)||''" value="''||wwv_flow_escape.html(id)||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"/>'' c,',
'    item_sequence,',
'    prompt,',
'    name,',
'    display_as,',
'    (select plug_name ',
'     from wwv_flow_page_plugs ',
'     where id = i.item_plug_id) as item_plug_id',
'from WWV_FLOW_STEP_ITEMS i',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and ',
'      (nvl(:P7_SHOW_REGION,''0'') = 0 or i.item_plug_id = :P7_SHOW_REGION)',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('El informe no contiene ning\00FAn dato')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Imprimir'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(153381618716039074.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(153381717621039074.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia de Elementos'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1059810135742457638.4001)
,p_query_column_id=>3
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>5
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(153381808050039074.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(153381904844039074.4001)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Mostrar como'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29353308376249352)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(153382029956039075.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40316127303638345.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40344600048762936.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40285402388432366.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(40316127303638345.4001)
,p_button_name=>'P7_GO'
,p_button_static_id=>'P7_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40317621678655611.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(40316127303638345.4001)
,p_button_name=>'REMOVE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Elementos'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_step_items i',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40286713816435745.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40316127303638345.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40286110007434616.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(40316127303638345.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40282322534411417.4001)
,p_branch_name=>'Go To Page 7'
,p_branch_action=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40284222558419288.4001)
,p_name=>'P7_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40316127303638345.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1gina. Para cambiarlo, seleccione o introduzca un nuevo n\00FAmero y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1137920690415608249.4001)
,p_name=>'P7_SHOW_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40316127303638345.4001)
,p_item_default=>'0'
,p_prompt=>'Mostrar Regiones'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGE REGIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name, id from (',
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id,',
'       upper(plug_name) pn,',
'       1 x',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
'union',
'select wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'') ||',
'       r.plug_name || '' ('' || r.plug_display_sequence || '')'' as plug_name,',
'       r.id,',
'       upper(r.plug_name) pn,',
'       2 x',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and i.id                = p.user_interface_id',
'   and i.global_page_id   <> :fb_flow_page_id',
'   and r.flow_id           = i.flow_id',
'   and r.page_id           = i.global_page_id',
' order by 4, 3) v'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todas las Regiones -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Para filtrar elementos por regi\00F3n, seleccione un nombre de regi\00F3n y haga clic en <span class="fielddatabold">Ir</span>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(40337007966736774.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(40341119179749521.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P7_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>':REQUEST is null or :REQUEST = ''GO'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(166969112605013377.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un elemento que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(40317621678655611.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157777850232618623.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(40282027968411412.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157777958324618624.4001)
,p_event_id=>wwv_flow_api.id(1157777850232618623.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40352017971786996.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from wwv_flow_step_items ',
'   where id = wwv_flow.g_f01(i) and',
'         flow_id = :fb_flow_id and',
'         flow_step_id = :fb_flow_page_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al eliminar elementos.'
,p_process_when_button_id=>wwv_flow_api.id(40317621678655611.4001)
,p_process_success_message=>'Elementos eliminados.'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_api.create_page(
 p_id=>8.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('P\00E1ginas Actualizadas Recientemente')
,p_step_title=>unistr('P\00E1ginas Actualizadas Recientemente')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(170054914261851800.4001)
,p_plug_name=>unistr('P\00E1ginas Recientes')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>140
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id page_id,',
'       p.flow_id application_id, ',
'       p.name page_name,',
'       nvl(p.last_updated_on,p.created_on) last_updated,',
'       nvl(p.last_updated_by,p.created_by) updated_by,',
'       (select count(*)',
'        from wwv_flow_page_plugs',
'        where flow_id = p.flow_id and',
'              page_id = p.id) regions,',
'       (select count(*)',
'        from wwv_flow_step_items',
'        where flow_id = p.flow_id and',
'              flow_step_id = p.id) items,',
'       p.created_on created,',
'       p.created_by created_by,',
'       (select group_name ',
'        from WWV_FLOW_PAGE_GROUPS g',
'        where g.id = p.group_id) page_group_name',
'from wwv_flow_steps p',
'where p.flow_id = :fb_flow_id and ',
'      p.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(170055004572851800.4001)
,p_name=>'Recent Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171251900783826691.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'I'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID,FB_FLOW_ID:#PAGE_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170056320275879428.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170056520473889227.4001)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170077124144821898.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170077225497821899.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170077301076821899.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170077914363838032.4001)
,p_db_column_name=>'PAGE_GROUP_NAME'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('Grupo de P\00E1ginas')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171254708234866673.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171254800662866674.4001)
,p_db_column_name=>'ITEMS'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Elementos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(171255311481877107.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>10
,p_column_identifier=>'L'
,p_column_label=>unistr('Identificador de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194062601696675323.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(170054914261851800.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:8,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(170083208223892979.4001)
,p_branch_action=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Componentes Compartidos'
,p_step_title=>'Componentes Compartidos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.smallRegion {',
'    height: 240px;',
'}'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_sc_about.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6717929419930781.4001)
,p_plug_name=>unistr('L\00F3gica de Aplicaci\00F3n')
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder:a-Region--noTopBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(694736922570524377.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6733813582982988.4001)
,p_plug_name=>'Seguridad'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-security'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder:a-Region--noTopBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(6730409642972302.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6738231375997556.4001)
,p_plug_name=>'Interfaz de Usuario'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-ui'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(6736213021992272.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6749911036048434.4001)
,p_plug_name=>unistr('Or\00EDgenes de datos')
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-data-references'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(694855238818571795.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6754602426074365.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los componentes compartidos se pueden mostrar o aplicar en cualquier p\00E1gina de la aplicaci\00F3n. Esta p\00E1gina proporciona una lista de los componentes compartidos disponibles.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/shared-components-page.html#GUID-2CDE44A1-E219-44BC-B983-B6780266F315l">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6755001974136930.4001)
,p_plug_name=>'Tareas'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(6753822621133458.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6871226629478707.4001)
,p_plug_name=>unistr('Globalizaci\00F3n')
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-globalization'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_api.id(6868813338465446.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6877001049499703.4001)
,p_plug_name=>'Archivos'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-files'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(6874810268492937.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22725217770238206.4001)
,p_plug_name=>'Informes'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-reports'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(22726621018248639.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23327731451098175.4001)
,p_plug_name=>unistr('Aplicaci\00F3n')
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(23333311543130294.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(470836700216277717.4001)
,p_plug_name=>'Refrescar Tema'
,p_region_name=>'refresh_thm_conf'
,p_region_css_classes=>'js-dialog-autoheight'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Parece que su aplicaci\00F3n tiene uno o varios estilos de tema personalizados. Una vez que el tema se refresque, deber\00E1 utilizar el acumulador de temas para volver a guardar su estilo de tema personalizado y definirlo como actual. </p>'),
'',
unistr('<p>Puede obtener m\00E1s informaci\00F3n sobre este proceso visitando la secci\00F3n Gu\00EDas de migraci\00F3n de la <a rel="noreferrer" href="https://apex.oracle.com/ut" target="_blank">aplicaci\00F3n Tema universal</a>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(522798082125429248.4001)
,p_plug_name=>'Objetos de espacio de trabajo'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(525226966024198272.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Los objetos del espacio de trabajo se almacenan a nivel de espacio de trabajo y son visibles en todas las aplicaciones.</p>'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(553718161835361902.4001)
,p_plug_name=>unistr('Actualizaci\00F3n a tema universal disponible')
,p_region_css_classes=>'a-Alert--page'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Hay una nueva versi\00F3n del tema universal disponible. Puede refrescar el tema para aprovechar las nuevas funciones, mejoras y correcciones de bugs.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P9_CURRENT_UT_THEME_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(574349133365630526.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-nav'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_api.id(6746028090034478.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(574349291023630527.4001)
,p_plug_name=>'Otros Componentes'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-util-page-group'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder:a-Region--noTopBorder'
,p_component_template_options=>'a-LinksList--nowrap'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(694733590452503217.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28216468481136412.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(553718161835361902.4001)
,p_button_name=>'REFRESH_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Tema'
,p_button_position=>'NEXT'
,p_button_condition=>'P9_HAS_CUSTOM_STYLE'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(470837088149277720.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(470836700216277717.4001)
,p_button_name=>'REFRESH_THEME_DIALOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Tema'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(470836610885277716.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(553718161835361902.4001)
,p_button_name=>'REFRESH_THEME_CUSTOM'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Tema'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P9_HAS_CUSTOM_STYLE'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28216559563136413.4001)
,p_name=>'P9_CURRENT_UT_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6738231375997556.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28216764128136415.4001)
,p_name=>'P9_HAS_CUSTOM_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(553718161835361902.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28216939022136417.4001)
,p_name=>'P9_CURRENT_UT_APEX_VERSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(553718161835361902.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28217544026136423.4001)
,p_name=>'P9_THEME_REF_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6738231375997556.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(131586723535881749.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'9'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(470836876451277718.4001)
,p_name=>'Open Refresh Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(470836610885277716.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(470836947950277719.4001)
,p_event_id=>wwv_flow_api.id(470836876451277718.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(470836700216277717.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28217439905136422.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P9_THEME_REF_ID,',
'    p_subscribing_theme_id => :P9_CURRENT_UT_THEME_ID',
');',
'-- Reset so the conditional region won''t show up again.',
':P9_CURRENT_UT_THEME_ID := null;',
':P9_THEME_REF_ID := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH_THEME, REFRESH_THEME_DIALOG'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Se ha refrescado correctamente al \00FAltimo tema.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1020628401159693462.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => apex_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28217605394136424.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Reset. So this value will not get carried over',
'-- to the this Shared Components page of other apps',
':P9_CURRENT_UT_THEME_ID := null;',
'',
'-- Should we display The refresh theme region?',
'for c1 in (',
'    select id,',
'           reference_id',
'      from wwv_flow_themes t',
'     where t.theme_id = 42',
'       and t.theme_internal_name = ''UNIVERSAL_THEME''',
'       and t.theme_id = (  select max(theme_id) as current_theme_id',
'                              from wwv_flow_user_interfaces ',
'                             where flow_id= :FB_FLOW_ID',
'                               and ui_type_id = t.ui_type_id)      ',
'        and regexp_instr( t.file_prefix, ''/21\.2/$'') = 0',
'        and t.flow_id  = :FB_FLOW_ID',
'        and security_group_id = :FLOW_SECURITY_GROUP_ID',
') loop',
'',
'    if c1.reference_id is not null then',
'        :P9_CURRENT_UT_THEME_ID := c1.id;',
'        :P9_THEME_REF_ID := c1.reference_id;',
'    end if;',
'',
'end loop;',
'',
'if :P9_CURRENT_UT_THEME_ID is not null then',
'    -- Is custom style used in current theme style?',
'    for c2 in (',
'        select ''Y'' as yes',
'          from WWV_FLOW_THEME_STYLES s',
'         where s.THEME_ROLLER_CONFIG is not null',
'           and is_current = ''Y''',
'           and s.flow_id  = :FB_FLOW_ID',
'           and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    ) loop',
'        :P9_HAS_CUSTOM_STYLE := c2.yes;',
'    end loop;',
'',
'    -- Get APEX version mapping based on theme version',
'    for c3 in (',
'        select decode(',
'                    substr(',
'                        t.file_prefix,',
'                        instr( t.file_prefix , ''/'', -2)',
'                    ),',
'                    ''/1.0/'', ''5.0'',',
'                    ''/1.1/'', ''5.1'',',
'                    ''/1.2/'', ''18.1'',',
'                    ''/1.3/'', ''19.1'',',
'                    ''/1.4/'', ''19.2'',',
'                    ''/1.5/'', ''20.1'',',
'                    ''/1.6/'', ''20.2'',',
'                    ''/21.1/'', ''21.1'',',
'                    ''/21.2/'', ''21.2''',
'               ) as ut_version',
'          from wwv_flow_themes t',
'         where t.id = :P9_CURRENT_UT_THEME_ID',
'           and t.flow_id  = :FB_FLOW_ID',
'           and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    ) loop',
'        :P9_CURRENT_UT_APEX_VERSION := c3.ut_version;',
'    end loop;',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_api.create_page(
 p_id=>10.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Listas no Utilizadas'
,p_step_title=>'Listas no Utilizadas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48549912169384160.4001)
,p_plug_name=>'Listas no Utilizadas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P10a */ list_id,',
'       flow_number,',
'       list_name,',
'       list_entries,',
'       created_on,',
'       created_by,',
'       last_updated_on,',
'       last_updated_by,',
'       APEX_ITEM.CHECKBOX(1,wwv_flow_escape.html(list_id),null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') , wwv_flow_lang.system_message(''DELETE_LABEL'',wwv_flow_escape.html(list_name)) ) the_checkbox',
'from (',
'select list.id list_id,',
'       list.flow_id flow_number,',
'       list.name list_name,',
'       (select count(*) ',
'        from wwv_flow_list_items i',
'        where list.id = i.list_id) list_entries,',
'       list.created_on,',
'       list.created_by,',
'       list.last_updated_on,',
'       list.last_updated_by',
'  from wwv_flow_lists list ',
' where list.flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and not exists (select 1',
'                     from wwv_flow_page_plugs r ',
'                    where r.flow_id = list.flow_id',
'                      and r.list_id = list.id)',
'   and not exists (select 1',
'                     from wwv_flow_steps p ',
'                    where p.flow_id            = list.flow_id',
'                      and p.navigation_list_id = list.id)',
'   and not exists (select 1',
'                     from wwv_flow_user_interfaces ui ',
'                    where ui.flow_id            = list.flow_id',
'                      and ui.navigation_list_id = list.id)',
') q'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48550008997384160.4001)
,p_name=>'Unused Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('El informe no contiene ning\00FAn dato')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48550220609384182.4001)
,p_db_column_name=>'LIST_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Editar'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48550326450384188.4001)
,p_db_column_name=>'FLOW_NUMBER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Identificador de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48550403478384189.4001)
,p_db_column_name=>'LIST_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Lista'
,p_column_link=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.:4050:F4000_P4050_LIST_ID:#LIST_ID#'
,p_column_linktext=>'#LIST_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(111550012133481400.4001)
,p_db_column_name=>'LIST_ENTRIES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Entradas de Lista'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(111550230833486710.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(111550327985486710.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(111550616550501539.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(111550728835501539.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(111551610148537515.4001)
,p_db_column_name=>'THE_CHECKBOX'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Suprimir'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152914005205808581.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152943919197897776.4001)
,p_plug_name=>'Listas no Utilizadas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina identifica listas que no se utilizan en esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188939910930895934.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48549912169384160.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:10,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(111550810794509403.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48549912169384160.4001)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(111551932574562992.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete selected unused lists'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from wwv_flow_lists',
'   where flow_id = :fb_flow_id and',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_api.create_page(
 p_id=>13.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Extraer Ayuda de Elemento'
,p_step_title=>'Extraer Ayuda de Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85960108210083362.4001)
,p_plug_name=>'Extraer Ayuda de Elemento'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Utilice esta utilidad para definir el texto de ayuda para todos los elementos de la aplicaci\00F3n actual que no tienen texto de ayuda actualmente.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080990226223523935.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(85961127994088572.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1080990226223523935.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240668412249837987.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1080990226223523935.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(86469122641929623.4001)
,p_branch_action=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86035902696658898.4001)
,p_name=>'P13_DEFAULT_HELP_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(85960108210083362.4001)
,p_prompt=>'Texto de Ayuda por Defecto'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el texto de ayuda que se aplicar\00E1 a todos los elementos que actualmente no tienen ayuda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(86082311849822444.4001)
,p_validation_name=>'required message'
,p_validation_sequence=>10
,p_validation=>'P13_DEFAULT_HELP_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(86035902696658898.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(86075612495794255.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'seed non existent messages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'insert into WWV_FLOW_STEP_ITEM_HELP (FLOW_ITEM_ID,HELP_TEXT,FLOW_ID)',
'select id, :P13_DEFAULT_HELP_TEXT m, flow_id',
'from wwv_flow_step_items',
'where id not in (select flow_item_id from wwv_flow_step_item_help where flow_id = :fb_flow_id)',
'      and flow_id = :fb_flow_id and',
'      DISPLAY_AS not in ( ''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'') and prompt is not null;',
'',
'delete from wwv_flow_step_item_help h',
'where flow_id = :fb_flow_id and',
'      exists (select 1 from',
'              wwv_flow_step_items',
'              where id = h.FLOW_ITEM_ID and',
'                    display_as in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE''));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido iniciar el texto de ayuda de nivel de elemento.'
,p_process_when_button_id=>wwv_flow_api.id(85961127994088572.4001)
,p_process_success_message=>'Elementos sin texto de ayuda iniciado.'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_api.create_page(
 p_id=>14.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cach\00E9')
,p_step_title=>unistr('Cach\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'preface.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31087728292254007.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(31086920674251816.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47787001885565213.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47883828808092400.4001)
,p_name=>unistr('Regiones en Cach\00E9')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select region_name, cached_on',
'from (',
'select ',
'   r.plug_name region_name,',
'  cached_on',
'from wwv_flow_page_cache c,',
'     wwv_flow_page_plugs r',
'where c.region_id(+) = r.id and',
'      c.flow_id(+) = r.flow_id and',
'      r.flow_id = :fb_flow_id and ',
'      r.security_group_id = :flow_security_group_id and ',
'      c.region_id is not null and',
'      r.page_id = :P14_page_id ',
'order by 2 desc',
')',
'where rownum < 8'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47141516446071328.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay regiones en cach\00E9.')
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47883828808092400.4001)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47884409546096302.4001)
,p_query_column_id=>1
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47884523449096303.4001)
,p_query_column_id=>2
,p_column_alias=>'CACHED_ON'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47889025485176587.4001)
,p_name=>unistr('P\00E1ginas en Cach\00E9')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LANGUAGE,',
'       CACHED_ON,',
'       case',
'         when valid_until < sysdate then m.expired',
'         else m.unexpired',
'       end cache_status',
'from (',
'select c.LANGUAGE,',
'       c.CACHED_ON,',
'       c.valid_until',
'  from WWV_FLOW_PAGE_CACHE c,',
'       wwv_flow_steps p',
' where c.flow_id = :fb_flow_id',
'   and c.flow_id = p.flow_id',
'   and c.page_id = p.id',
'   and p.id = :fb_flow_page_id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.cache_mode <> ''NOCACHE''',
'order by 1',
'),',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired',
' from sys.dual) m',
'where rownum < 8'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(47141516446071328.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay p\00E1ginas en cach\00E9.')
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47889025485176587.4001)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(450463705691363985.4001)
,p_query_column_id=>1
,p_column_alias=>'LANGUAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(450463827683363985.4001)
,p_query_column_id=>2
,p_column_alias=>'CACHED_ON'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(450465415518376225.4001)
,p_query_column_id=>3
,p_column_alias=>'CACHE_STATUS'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47919210363646906.4001)
,p_name=>unistr('P\00E1ginas Editadas Recientemente')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('El informe no contiene ning\00FAn dato')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47919416222646922.4001)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:14:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,P14_PAGE_ID:&FB_FLOW_ID.,#ID#,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47919511948646926.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080990315097523936.4001)
,p_plug_name=>'Regiones'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184302302519207936.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47787001885565213.4001)
,p_button_name=>'P14_SET'
,p_button_static_id=>'P14_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450468132057399936.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47889025485176587.4001)
,p_button_name=>'MANAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Gestionar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:RP,638,RIR:IR_ID,IR_APPLICATION:&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47884813617116371.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(47883828808092400.4001)
,p_button_name=>'MANAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Gestionar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:RP,656,RIR:IR_PAGE_ID,IR_APPLICATION_ID:&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(198312403858815719.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47787001885565213.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:14,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47922932105747760.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47787001885565213.4001)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Editar P\00E1gina')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47923227997747766.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47922932105747760.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47835110868816623.4001)
,p_branch_action=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47833932555813419.4001)
,p_name=>'P14_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47787001885565213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name||decode(alias,null,null,'' (''||alias||'')'') n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'order by id'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione una p\00E1gina que desee ver.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47888310894144042.4001)
,p_name=>'P14_TIME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47787001885565213.4001)
,p_item_default=>'1'
,p_prompt=>'Desde'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME STATIC'
,p_lov=>'.'||wwv_flow_api.id(94747000503182513.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Limite el informe de la actividad de la p\00E1gina al periodo de tiempo seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(47837727622830904.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&P14_PAGE_ID.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47838825114849107.4001)
,p_validation_name=>'P14_PAGE_ID'
,p_validation_sequence=>10
,p_validation=>'P14_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El identificador de p\00E1gina debe ser num\00E9rico')
,p_when_button_pressed=>wwv_flow_api.id(184302302519207936.4001)
,p_associated_item=>wwv_flow_api.id(47833932555813419.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_api.create_page(
 p_id=>16.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Bloquear Script'
,p_page_mode=>'MODAL'
,p_step_title=>'&P16_DIALOG_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(857293913086873803.4001)
,p_plug_name=>'Lock Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.user_can_edit_script (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_script_id => :P16_LOCK_SCRIPT_ID',
'    )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Al bloquear un script, se asegura de que ning\00FAn otro desarrollador cambiar\00E1 la definici\00F3n del script bloqueado.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(857809279363486436.4001)
,p_name=>'Historial de Bloqueos'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.action, lower(l.locked_by) locked_by, l.action_date, l.lock_comment',
'from wwv_flow_lock_script_log l',
'where l.flow_id = :fb_flow_id',
'and l.security_group_id = :flow_security_group_id',
'and l.script_id = :P16_LOCK_SCRIPT_ID',
'order by action_date desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(857809520225486469.4001)
,p_query_column_id=>1
,p_column_alias=>'ACTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(857850100888646856)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(857809602446486470.4001)
,p_query_column_id=>2
,p_column_alias=>'LOCKED_BY'
,p_column_display_sequence=>2
,p_column_heading=>'Por'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(857809705448486470.4001)
,p_query_column_id=>3
,p_column_alias=>'ACTION_DATE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Fecha de Acci\00F3n')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(857809821861486470.4001)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Comentario de Bloqueo'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(857863288085728296.4001)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926468845781223113.4001)
,p_plug_name=>'Script Bloqueado'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_lock.user_can_edit_script (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_script_id => :P16_LOCK_SCRIPT_ID',
'    ) and :P16_LOCK_ID is not null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(925767723087802479.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(857863288085728296.4001)
,p_button_name=>'UNLOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Desbloquear'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P16_LOCK_SCRIPT_ID ) and :P16_LOCK_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(857294308077873806.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(857863288085728296.4001)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Bloquear Script'
,p_button_position=>'NEXT'
,p_button_condition=>'not wwv_flow_lock.script_locked ( p_flow_id => :FB_FLOW_ID, p_script_id => :P16_LOCK_SCRIPT_ID ) and :P16_LOCK_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(925768245001805108.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(857863288085728296.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P16_LOCK_SCRIPT_ID ) and :P16_LOCK_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(857294120953873806.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(857863288085728296.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(857294522125873807.4001)
,p_name=>'P16_LOCK_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(857293913086873803.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Bloquear Script:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_install_scripts',
'where id = :P16_LOCK_SCRIPT_ID',
'and security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nombre del script que se va a bloquear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(857295009620873810.4001)
,p_name=>'P16_LOCK_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(857293913086873803.4001)
,p_prompt=>'Comentario'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Comentario que se aplicar\00E1 al script bloqueado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(857367779517306179.4001)
,p_name=>'P16_LOCK_SCRIPT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(857293913086873803.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(857368496709311259.4001)
,p_name=>'P16_LOCK_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(857293913086873803.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926470319613246860.4001)
,p_name=>'P16_LOCKED_SCRIPT_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(926468845781223113.4001)
,p_prompt=>'Nombre del Script'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nombre del script que est\00E1 bloqueado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926470737226249910.4001)
,p_name=>'P16_LOCKED_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(926468845781223113.4001)
,p_prompt=>'Bloqueado el'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Fecha en la que se bloque\00F3 el script.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926471089519252574.4001)
,p_name=>'P16_LOCKED_BY'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(926468845781223113.4001)
,p_prompt=>'Bloqueado por'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>'Nombre del desarrollador que tiene actualmente el bloqueo de script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926591597780542250.4001)
,p_name=>'P16_LOCKED_BY2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(857293913086873803.4001)
,p_prompt=>'Bloqueado por'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P16_LOCK_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>'Nombre del desarrollador que tiene actualmente el bloqueo de script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926764581682021791.4001)
,p_name=>'P16_DIALOG_TITLE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(857293913086873803.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(933185021779887582.4001)
,p_name=>'P16_STEAL_LOCK_LINK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(926468845781223113.4001)
,p_prompt=>'Eliminar Bloqueo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<a href="''||wwv_flow_utilities.prepare_url(''f?p=4000:342:''||wwv_flow.g_instance||'':::342:P342_LOCK_SCRIPT_ID:''||:P16_LOCK_SCRIPT_ID)||',
'          ''">''||wwv_flow_escape.html(wwv_flow_lang.system_message(''STEAL_LOCK''))||''</a>'');'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(857372917911602720.4001)
,p_computation_sequence=>10
,p_computation_item=>'P16_LOCK_COMMENT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lock_comment',
'from wwv_flow_lock_script',
'where id = :P16_LOCK_ID',
'and security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_compute_when=>'P16_LOCK_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(926764764486030995.4001)
,p_computation_sequence=>10
,p_computation_item=>'P16_DIALOG_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P16_LOCK_ID is not null then',
'     return  wwv_flow_lang.system_message(''EDIT_LOCK'');',
'else',
'     return  wwv_flow_lang.system_message(''LOCK_SCRIPT'');',
'end if;',
'  '))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(857295664133873811.4001)
,p_validation_name=>'P16_LOCK_COMMENT'
,p_validation_sequence=>10
,p_validation=>'P16_LOCK_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>'LOCK, APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_when_button_pressed=>wwv_flow_api.id(857294308077873806.4001)
,p_associated_item=>wwv_flow_api.id(857295009620873810.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(933181156432819747.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(857294120953873806.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(933181453950819748.4001)
,p_event_id=>wwv_flow_api.id(933181156432819747.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(857295705674873816.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.lock_script (',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_script_id => :P16_LOCK_SCRIPT_ID,',
'    p_comment   => :P16_LOCK_COMMENT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido bloquear el script.'
,p_process_when_button_id=>wwv_flow_api.id(857294308077873806.4001)
,p_process_success_message=>'Script bloqueado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(925770973953909129.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlock script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.unlock_script (',
'    p_id        => :P16_LOCK_ID,',
'    p_flow_id   => :FB_FLOW_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido desbloquear el script.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(925767723087802479.4001)
,p_process_when=>'P16_LOCK_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Script desbloqueado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(925771119057935970.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update lock comment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.update_script_lock_comment (',
'    p_id        => :P16_LOCK_ID,',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_comment => :P16_LOCK_COMMENT );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido actualizar el comentario.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(925768245001805108.4001)
,p_process_when=>'P16_LOCK_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Comentario actualizado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(933181755880823470.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(926575287274348044.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate locked script display items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select name',
'           from wwv_flow_install_scripts',
'           where id = :P16_LOCK_SCRIPT_ID',
'           and security_group_id = :flow_security_group_id',
'           and flow_id = :fb_flow_id)',
'loop',
'    :P16_LOCKED_SCRIPT_NAME := c1.name;',
'end loop;',
'',
'for c1 in (select locked_on, locked_by',
'                from wwv_flow_lock_script',
'                where id = :P16_LOCK_ID',
'                and security_group_id = :flow_security_group_id',
'                and flow_id = :fb_flow_id)',
'loop',
'    :P16_LOCKED_DATE := htmldb_util.get_since(c1.locked_on);',
'    :P16_LOCKED_BY := lower(c1.locked_by);',
'    :P16_LOCKED_BY2 := lower(c1.locked_by);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P16_LOCKED_ID'
,p_process_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_api.create_page(
 p_id=>17.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituciones'
,p_step_title=>'Sustituciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(6077013252398487.4001)
,p_name=>unistr('Sustituciones de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ss as (select substitution_string_01 ss01, substitution_value_01 sv01, htmldb_item.checkbox(1,01,decode(PROMPT_SUBSTITUTION_01_YN,''Y'',''CHECKED'',null)) c01, htmldb_item.text(2,install_prompt_01,40,255) p01,',
'                   substitution_string_02 ss02, substitution_value_02 sv02, htmldb_item.checkbox(1,02,decode(PROMPT_SUBSTITUTION_02_YN,''Y'',''CHECKED'',null)) c02, htmldb_item.text(2,install_prompt_02,40,255) p02,',
'                   substitution_string_03 ss03, substitution_value_03 sv03, htmldb_item.checkbox(1,03,decode(PROMPT_SUBSTITUTION_03_YN,''Y'',''CHECKED'',null)) c03, htmldb_item.text(2,install_prompt_03,40,255) p03,',
'                   substitution_string_04 ss04, substitution_value_04 sv04, htmldb_item.checkbox(1,04,decode(PROMPT_SUBSTITUTION_04_YN,''Y'',''CHECKED'',null)) c04, htmldb_item.text(2,install_prompt_04,40,255) p04,',
'                   substitution_string_05 ss05, substitution_value_05 sv05, htmldb_item.checkbox(1,05,decode(PROMPT_SUBSTITUTION_05_YN,''Y'',''CHECKED'',null)) c05, htmldb_item.text(2,install_prompt_05,40,255) p05,',
'                   substitution_string_06 ss06, substitution_value_06 sv06, htmldb_item.checkbox(1,06,decode(PROMPT_SUBSTITUTION_06_YN,''Y'',''CHECKED'',null)) c06, htmldb_item.text(2,install_prompt_06,40,255) p06,',
'                   substitution_string_07 ss07, substitution_value_07 sv07, htmldb_item.checkbox(1,07,decode(PROMPT_SUBSTITUTION_07_YN,''Y'',''CHECKED'',null)) c07, htmldb_item.text(2,install_prompt_07,40,255) p07,',
'                   substitution_string_08 ss08, substitution_value_08 sv08, htmldb_item.checkbox(1,08,decode(PROMPT_SUBSTITUTION_08_YN,''Y'',''CHECKED'',null)) c08, htmldb_item.text(2,install_prompt_08,40,255) p08,',
'                   substitution_string_09 ss09, substitution_value_09 sv09, htmldb_item.checkbox(1,09,decode(PROMPT_SUBSTITUTION_09_YN,''Y'',''CHECKED'',null)) c09, htmldb_item.text(2,install_prompt_09,40,255) p09,',
'                   substitution_string_10 ss10, substitution_value_10 sv10, htmldb_item.checkbox(1,10,decode(PROMPT_SUBSTITUTION_10_YN,''Y'',''CHECKED'',null)) c10, htmldb_item.text(2,install_prompt_10,40,255) p10,',
'                   substitution_string_11 ss11, substitution_value_11 sv11, htmldb_item.checkbox(1,11,decode(PROMPT_SUBSTITUTION_11_YN,''Y'',''CHECKED'',null)) c11, htmldb_item.text(2,install_prompt_11,40,255) p11,',
'                   substitution_string_12 ss12, substitution_value_12 sv12, htmldb_item.checkbox(1,12,decode(PROMPT_SUBSTITUTION_12_YN,''Y'',''CHECKED'',null)) c12, htmldb_item.text(2,install_prompt_12,40,255) p12,',
'                   substitution_string_13 ss13, substitution_value_13 sv13, htmldb_item.checkbox(1,13,decode(PROMPT_SUBSTITUTION_13_YN,''Y'',''CHECKED'',null)) c13, htmldb_item.text(2,install_prompt_13,40,255) p13,',
'                   substitution_string_14 ss14, substitution_value_14 sv14, htmldb_item.checkbox(1,14,decode(PROMPT_SUBSTITUTION_14_YN,''Y'',''CHECKED'',null)) c14, htmldb_item.text(2,install_prompt_14,40,255) p14,',
'                   substitution_string_15 ss15, substitution_value_15 sv15, htmldb_item.checkbox(1,15,decode(PROMPT_SUBSTITUTION_15_YN,''Y'',''CHECKED'',null)) c15, htmldb_item.text(2,install_prompt_15,40,255) p15,',
'                   substitution_string_16 ss16, substitution_value_16 sv16, htmldb_item.checkbox(1,16,decode(PROMPT_SUBSTITUTION_16_YN,''Y'',''CHECKED'',null)) c16, htmldb_item.text(2,install_prompt_16,40,255) p16,',
'                   substitution_string_17 ss17, substitution_value_17 sv17, htmldb_item.checkbox(1,17,decode(PROMPT_SUBSTITUTION_17_YN,''Y'',''CHECKED'',null)) c17, htmldb_item.text(2,install_prompt_17,40,255) p17,',
'                   substitution_string_18 ss18, substitution_value_18 sv18, htmldb_item.checkbox(1,18,decode(PROMPT_SUBSTITUTION_18_YN,''Y'',''CHECKED'',null)) c18, htmldb_item.text(2,install_prompt_18,40,255) p18,',
'                   substitution_string_19 ss19, substitution_value_19 sv19, htmldb_item.checkbox(1,19,decode(PROMPT_SUBSTITUTION_19_YN,''Y'',''CHECKED'',null)) c19, htmldb_item.text(2,install_prompt_19,40,255) p19,',
'                   substitution_string_20 ss20, substitution_value_20 sv20, htmldb_item.checkbox(1,20,decode(PROMPT_SUBSTITUTION_20_YN,''Y'',''CHECKED'',null)) c20, htmldb_item.text(2,install_prompt_20,40,255) p20',
'              from wwv_flows, wwv_flow_install',
'             where wwv_flows.id = wwv_flow_install.flow_id',
'               and wwv_flows.id = :FB_FLOW_ID',
'               and wwv_flows.security_group_id = :flow_security_group_id)',
'select * from (',
'(select ss01 s, sv01 v, c01 c, p01 p, 01 ord from ss) union',
'(select ss02 s, sv02 v, c02 c, p02 p, 02 ord from ss) union',
'(select ss03 s, sv03 v, c03 c, p03 p, 03 ord from ss) union',
'(select ss04 s, sv04 v, c04 c, p04 p, 04 ord from ss) union',
'(select ss05 s, sv05 v, c05 c, p05 p, 05 ord from ss) union',
'(select ss06 s, sv06 v, c06 c, p06 p, 06 ord from ss) union',
'(select ss07 s, sv07 v, c07 c, p07 p, 07 ord from ss) union',
'(select ss08 s, sv08 v, c08 c, p08 p, 08 ord from ss) union',
'(select ss09 s, sv09 v, c09 c, p09 p, 09 ord from ss) union',
'(select ss10 s, sv10 v, c10 c, p10 p, 10 ord from ss) union',
'(select ss11 s, sv11 v, c11 c, p11 p, 11 ord from ss) union',
'(select ss12 s, sv12 v, c12 c, p12 p, 12 ord from ss) union',
'(select ss13 s, sv13 v, c13 c, p13 p, 13 ord from ss) union',
'(select ss14 s, sv14 v, c14 c, p14 p, 14 ord from ss) union',
'(select ss15 s, sv15 v, c15 c, p15 p, 15 ord from ss) union',
'(select ss16 s, sv16 v, c16 c, p16 p, 16 ord from ss) union',
'(select ss17 s, sv17 v, c17 c, p17 p, 17 ord from ss) union',
'(select ss18 s, sv18 v, c18 c, p18 p, 18 ord from ss) union',
'(select ss19 s, sv19 v, c19 c, p19 p, 19 ord from ss) union',
'(select ss20 s, sv20 v, c20 c, p20 p, 20 ord from ss))',
'where s is not null',
'order by ord'))
,p_header=>unistr('<p>Identifique las cadenas de sustituci\00F3n de aplicaci\00F3n que un usuario puede cambiar al instalar esta aplicaci\00F3n.</p>')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La aplicaci\00F3n no tiene sustituciones.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6077324496398511.4001)
,p_query_column_id=>1
,p_column_alias=>'S'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Cadena de Sustituci\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6077407868398514.4001)
,p_query_column_id=>2
,p_column_alias=>'V'
,p_column_display_sequence=>3
,p_column_heading=>'Valor Actual'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6081409368492000.4001)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>unistr('\00BFPreguntar?')
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7142703348111918.4001)
,p_query_column_id=>4
,p_column_alias=>'P'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Texto de la Petici\00F3n de Datos')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7218207578368645.4001)
,p_query_column_id=>5
,p_column_alias=>'ORD'
,p_column_display_sequence=>5
,p_column_heading=>'Ord'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22504624486376355.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24432314869923448.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34010017345903944.4001)
,p_plug_name=>'Sustituciones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>125
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(805631924001213.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34010017345903944.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(805419391001212.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34010017345903944.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29828621631478615.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(806212022001219.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(806418611001222.4001)
,p_name=>'P17_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(6077013252398487.4001)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29832404447483121.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(908310264063515.4001)
,p_computation_sequence=>10
,p_computation_item=>'P17_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6121000261706964.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process sub strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  yn wwv_flow_global.vc_arr2;',
'  prompts wwv_flow_global.vc_arr2;',
'begin',
'  for i in 1..20 loop',
'    yn(i) := ''N'';',
'    if i <= htmldb_application.g_f02.count then',
'      prompts(i) := htmldb_application.g_f02(i);',
'    else',
'      prompts(i) := null;',
'    end if;',
'  end loop;',
'  ',
'  for i in 1..htmldb_application.g_f01.count loop',
'    yn(htmldb_application.g_f01(i)) := ''Y'';',
'  end loop;',
'  ',
'  update wwv_flow_install',
'     set prompt_substitution_01_yn = yn(01), install_prompt_01 = prompts(1),',
'         prompt_substitution_02_yn = yn(02), install_prompt_02 = prompts(2),',
'         prompt_substitution_03_yn = yn(03), install_prompt_03 = prompts(3),',
'         prompt_substitution_04_yn = yn(04), install_prompt_04 = prompts(4),',
'         prompt_substitution_05_yn = yn(05), install_prompt_05 = prompts(5),',
'         prompt_substitution_06_yn = yn(06), install_prompt_06 = prompts(6),',
'         prompt_substitution_07_yn = yn(07), install_prompt_07 = prompts(7),',
'         prompt_substitution_08_yn = yn(08), install_prompt_08 = prompts(8),',
'         prompt_substitution_09_yn = yn(09), install_prompt_09 = prompts(9),     ',
'         prompt_substitution_10_yn = yn(10), install_prompt_10 = prompts(10),',
'         prompt_substitution_11_yn = yn(11), install_prompt_11 = prompts(11),',
'         prompt_substitution_12_yn = yn(12), install_prompt_12 = prompts(12),',
'         prompt_substitution_13_yn = yn(13), install_prompt_13 = prompts(13),',
'         prompt_substitution_14_yn = yn(14), install_prompt_14 = prompts(14),',
'         prompt_substitution_15_yn = yn(15), install_prompt_15 = prompts(15),',
'         prompt_substitution_16_yn = yn(16), install_prompt_16 = prompts(16),',
'         prompt_substitution_17_yn = yn(17), install_prompt_17 = prompts(17),',
'         prompt_substitution_18_yn = yn(18), install_prompt_18 = prompts(18),',
'         prompt_substitution_19_yn = yn(19), install_prompt_19 = prompts(19),',
'         prompt_substitution_20_yn = yn(20), install_prompt_20 = prompts(20)',
'   where flow_id = :FB_FLOW_ID',
'     and security_group_id = :flow_security_group_id;',
'     ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido actualizar las peticiones de datos de la cadena de sustituci\00F3n. ')
,p_process_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'' or v(''REQUEST'')=''SAVE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_api.create_page(
 p_id=>19.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Depurar Datos de Mensaje'
,p_step_title=>'Depurar Datos de Mensaje'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451745516764288584.4001)
,p_plug_name=>unistr('Eventos de P\00E1gina de Depuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*min(session_id)||',
'       case',
'         when min(session_id)<>max(session_id)',
'         then ''-''||max(session_id)',
'       end session_id,*/',
'',
'       case',
'         when min(case when session_id > 0 then session_id end)<>max(session_id)',
'         then min(case when session_id > 0 then session_id end)||''-''',
'       end||',
'       max(session_id) session_id,',
'',
'       max(apex_user) apex_user,',
'       page_view_id,',
'       max(flow_id)||''.''||max(page_id) application_page,',
'       min(message_timestamp) message_timestamp,',
'       count(*) debug_entries,',
'       max(flow_id) application_id,',
'       max(page_id) page_id,',
'       max(elap) elapsed,',
'       substr (',
'           max(case',
'               when message like ''R E Q U E S T accept%'' then ''4''||substr(message, 15)',
'               when message like ''R E Q U E S T %'' then ''3''||substr(message, 15)',
'               when message = ''CGI: PATH_INFO = /f''    then ''2show''',
'               when message like ''CGI: PATH_INFO =%'' then ''1''||substr(message, 19)',
'               end),',
'           2 ) path_info',
'  from ( select * from wwv_flow_debug_messages',
'          union all',
'         select * from wwv_flow_debug_messages2 )',
' where security_group_id = :flow_security_group_id',
' group by page_view_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(451745617575288584.4001)
,p_name=>'Debug Page Events'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451745915660288595.4001)
,p_db_column_name=>'APEX_USER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451746027116288596.4001)
,p_db_column_name=>'PAGE_VIEW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Identificador de Vista'
,p_column_link=>'f?p=&APP_ID.:939:&SESSION.::&DEBUG.:RP,939:P939_PAGE_VIEW_ID:#PAGE_VIEW_ID#'
,p_column_linktext=>'#PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200285411217572207.4001)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>4
,p_column_identifier=>'O'
,p_column_label=>unistr('Identificador de Sesi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451746423209288600.4001)
,p_db_column_name=>'DEBUG_ENTRIES'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Entradas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451757121762330962.4001)
,p_db_column_name=>'APPLICATION_PAGE'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>unistr('P\00E1gina de Aplicaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451758608748337865.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451758726364337866.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452246807467087260.4001)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Registro de hora'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452246921820087280.4001)
,p_db_column_name=>'ELAPSED'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Segundos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200165700725954119.4001)
,p_db_column_name=>'PATH_INFO'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>unistr('Informaci\00F3n de Ruta de Acceso')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451750804531307064.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451761424794350824.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(451745516764288584.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:19,RIR::'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_api.create_page(
 p_id=>20.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n')
,p_step_title=>unistr('Confirmar Supresi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(105023911750.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Ha solicitado la supresi\00F3n permanente de la aplicaci\00F3n <strong>&P20_APP_NAME. (&FB_FLOW_ID.)</strong>. Confirme la solicitud de supresi\00F3n.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(30939528178552245.4001)
,p_name=>unistr('P\00E1ginas')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' - ''||name n',
'from wwv_flow_steps',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna p\00E1gina')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30940117776552261.4001)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46518431282125423.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(67457413423328017.4001)
,p_name=>'Borrar en Cascada para Incluir Aplicaciones Traducidas'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TRANSLATION_FLOW_ID,',
'       TRANSLATION_COMMENTS,',
'       PRIMARY_LANGUAGE_FLOW_ID',
'  from WWV_FLOW_LANGUAGE_MAP',
' where PRIMARY_LANGUAGE_FLOW_ID = :fb_flow_id',
' order by TRANSLATION_FLOW_ID'))
,p_display_when_condition=>'select 1 c from wwv_flow_language_map where primary_language_flow_id = :fb_flow_id'
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('El informe no contiene ning\00FAn dato')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(67459100081328032.4001)
,p_query_column_id=>1
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n de Traducci\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(67459305999328032.4001)
,p_query_column_id=>2
,p_column_alias=>'TRANSLATION_COMMENTS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Comentarios de Traducci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(67463710300345599.4001)
,p_query_column_id=>3
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n de Idioma Primario')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747136922680138150.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(105031946218.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46518431282125423.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(105027942711.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46518431282125423.4001)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir Ahora Permanentemente'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17859517579729759.4001)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(105027942711.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(105034946220.4001)
,p_branch_action=>'1500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6524159070526318.4001)
,p_name=>'P20_DELETE_FEEDBACK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(105023911750.4001)
,p_prompt=>'Suprimir Comentario'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_feedback',
' where application_id = :F4000_P20_FLOW_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si tiene previsto volver a crear esta aplicaci\00F3n usando el mismo ID, puede que desee mantener los comentarios. En caso contrario, debe suprimirlos para que en el futuro no se asocien a otra aplicaci\00F3n que use este n\00FAmero de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57270914427796939.4001)
,p_name=>'F4000_P20_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(105023911750.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'F4000_P20_FLOW_ID'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193632127365783582.4001)
,p_name=>'P20_APP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(105023911750.4001)
,p_source=>'select name from wwv_flows where id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201886806068920618.4001)
,p_name=>'P20_APPLICATION_DELETED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(105023911750.4001)
,p_source=>'wwv_flow_lang.system_message(''APPLICATION_DELETED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193661817584799666.4001)
,p_computation_sequence=>10
,p_computation_item=>'P20_APP_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from wwv_flows where id = :FB_FLOW_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10110312617445696.4001)
,p_validation_name=>'not a restricted schema or workspace'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.restricted_schema(',
'   p_schema => v(''USER''), ',
'   p_workspace_name => v(''USER'')) then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El espacio de trabajo restringido no puede realizar esta acci\00F3n.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(390436471194898140.4001)
,p_name=>'Show Success Message'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(105027942711.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(390436584917898141.4001)
,p_event_id=>wwv_flow_api.id(390436471194898140.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(105038046820.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P20_DELETE_FEEDBACK = ''Y'' then',
'    wwv_flow_api.remove_application (',
'    p_application_id  => :F4000_P20_FLOW_ID,',
'    p_delete_feedback => true);',
'else',
'    wwv_flow_api.remove_application (',
'    p_application_id  => :F4000_P20_FLOW_ID);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al suprimir la aplicaci\00F3n &F4000_P20_FLOW_ID..')
,p_process_when_button_id=>wwv_flow_api.id(105027942711.4001)
,p_process_success_message=>unistr('Aplicaci\00F3n &F4000_P20_FLOW_ID. suprimida.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(813180162.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean up Cache on Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.update_cache_with_write (''FB_FLOW_ID'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_NAME'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',null);',
'',
'for c1 in (select min(id) min_id ',
'             from wwv_flows ',
'            where security_group_id = :flow_security_group_id',
'              and build_status = ''RUN_AND_BUILD'') loop',
'   wwv_flow.update_cache_with_write (''FB_FLOW_ID'',c1.min_id);',
'   wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',c1.min_id);',
'   for c2 in (select min(id) p from wwv_flow_steps where flow_id = nv(''FB_FLOW_ID'')) loop',
'      wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',c2.p);',
'      wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',c2.p);',
'   end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al realizar el proceso.'
,p_process_when_button_id=>wwv_flow_api.id(105027942711.4001)
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_api.create_page(
 p_id=>21.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de P\00E1gina')
,p_step_title=>unistr('Confirmar Supresi\00F3n de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(105124238853.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ha solicitado la supresi\00F3n permanente de la p\00E1gina &FB_FLOW_PAGE_ID. de la aplicaci\00F3n &FB_FLOW_ID., confirme la solicitud de supresi\00F3n.'),
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(139075200358595324.4001)
,p_name=>'Entradas de Lista Correspondientes'
,p_parent_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 (select name from wwv_flow_lists where id = WWV_FLOW_LIST_ITEMS.list_id) list_name,',
'	 LIST_ITEM_LINK_TARGET,',
'         LIST_ITEM_LINK_TEXT',
' from	 WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and ',
'upper(LIST_ITEM_LINK_TARGET) like ''F?P=%:''||:fb_flow_page_id||'':%''',
'and security_group_id = :flow_security_group_id',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and upper(LIST_ITEM_LINK_TARGET) like ''F?P=%:''||:fb_flow_page_id||'':%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(139105515090713159.4001)
,p_query_column_id=>1
,p_column_alias=>'LIST_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Lista'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(139075714642595328.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(139105612305713160.4001)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Entrada de Lista'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(161346930548564972.4001)
,p_name=>'Elementos de Lista Asociados'
,p_parent_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  l.name list_name,',
'  i.LIST_ITEM_LINK_TEXT,',
'  i.LIST_ITEM_LINK_TARGET,',
'  i.LIST_ITEM_CURRENT_FOR_PAGES',
'from',
'  WWV_FLOW_LIST_ITEMS i,',
'  WWV_FLOW_LISTS l',
'where ',
'  l.flow_id = :fb_flow_id and',
'  i.list_id = l.id and',
'  i.LIST_ITEM_CURRENT_FOR_PAGES = :fb_flow_page_id',
'and l.security_group_id = :flow_security_group_id',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  l.name list_name,',
'  i.LIST_ITEM_LINK_TEXT',
'from',
'  WWV_FLOW_LIST_ITEMS i,',
'  WWV_FLOW_LISTS l',
'where ',
'  l.flow_id = :fb_flow_id and',
'  i.list_id = l.id and',
'  i.LIST_ITEM_CURRENT_FOR_PAGES = :fb_flow_page_id'))
,p_display_condition_type=>'EXISTS'
,p_header=>unistr('Se eliminar\00E1 la siguiente lista de elementos.')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161347503194564990.4001)
,p_query_column_id=>1
,p_column_alias=>'LIST_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Lista'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161347618377564990.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de Elemento de Lista'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161354614533579276.4001)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Destino'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161408529228744348.4001)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Elemento de Lista Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(161383715544702576.4001)
,p_name=>'Separadores Asociados'
,p_parent_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  tab_set,',
'  tab_name,',
'  TAB_ALSO_CURRENT_FOR_PAGES',
'from wwv_flow_tabs ',
'where flow_id = :fb_flow_id ',
'and TAB_STEP = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  tab_set,',
'  tab_name',
'from wwv_flow_tabs ',
'where flow_id = :fb_flow_id and TAB_STEP = :fb_flow_page_id;'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161385123986714466.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161385208462714467.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de Separador'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161392522040723379.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Separador tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(161418114599759022.4001)
,p_name=>unistr('Entradas de Ruta de Navegaci\00F3n Asociadas')
,p_parent_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  m.name menu_name,',
'  o.SHORT_NAME,',
'  o.LONG_NAME,',
'  o.link,',
'  o.ALSO_CURRENT_FOR_PAGES',
'from WWV_FLOW_MENUS m, WWV_FLOW_MENU_OPTIONS o',
'where m.flow_id = :fb_flow_id and',
'    o.flow_id = :fb_flow_id and',
'    o.page_id = :fb_flow_page_id and',
'    o.ALSO_CURRENT_FOR_PAGES is null',
'and o.security_group_id = :flow_security_group_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  m.name menu_name,',
'  o.SHORT_NAME,',
'  o.LONG_NAME,',
'  o.link,',
'  o.ALSO_CURRENT_FOR_PAGES',
'from WWV_FLOW_MENUS m, WWV_FLOW_MENU_OPTIONS o',
'where m.flow_id = :fb_flow_id and',
'    o.flow_id = :fb_flow_id and',
'    o.page_id = :fb_flow_page_id and',
'    o.ALSO_CURRENT_FOR_PAGES is null'))
,p_display_condition_type=>'EXISTS'
,p_header=>unistr('Se eliminar\00E1n las siguientes entradas de ruta de navegaci\00F3n.')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161420715553778211.4001)
,p_query_column_id=>1
,p_column_alias=>'MENU_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre de Ruta de Navegaci\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161420801943778212.4001)
,p_query_column_id=>2
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Abreviatura'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161420931215778212.4001)
,p_query_column_id=>3
,p_column_alias=>'LONG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre Completo'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161421026223778212.4001)
,p_query_column_id=>4
,p_column_alias=>'LINK'
,p_column_display_sequence=>4
,p_column_heading=>'Enlace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161421129376778212.4001)
,p_query_column_id=>5
,p_column_alias=>'ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26542213329538061.4001)
,p_name=>'Regiones'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name',
'from wwv_flow_page_plugs',
'where flow_id = :fb_flow_id and',
'      page_id = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ninguna regi\00F3n')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26542828334538074.4001)
,p_query_column_id=>1
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'PLUG_NAME'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26544728004551739.4001)
,p_name=>'Elementos'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_step_items',
'where flow_id = :fb_flow_id',
'and flow_step_id = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26545331557551744.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'NAME'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26548102640563422.4001)
,p_name=>'Botones'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name',
'from wwv_flow_step_buttons',
'where flow_id = :fb_flow_id and',
' flow_step_id = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn bot\00F3n')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26548706540563426.4001)
,p_query_column_id=>1
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'BUTTON_NAME'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26551316969576946.4001)
,p_name=>'Procesos'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name',
'from wwv_flow_step_processing',
'where flow_id = :fb_flow_id and',
'      flow_step_id = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn proceso')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26551909978576951.4001)
,p_query_column_id=>1
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'PROCESS_NAME'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26554712383594620.4001)
,p_name=>unistr('C\00E1lculos')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COMPUTATION_ITEM',
'from wwv_flow_step_computations',
'where flow_id = :fb_flow_id and',
'      flow_step_id = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn c\00E1lculo')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26555304790594636.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPUTATION_ITEM'
,p_column_display_sequence=>1
,p_column_heading=>'COMPUTATION_ITEM'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26556621864606836.4001)
,p_name=>'Bifurcaciones'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(BRANCH_ACTION,1,25)',
'from   WWV_FLOW_STEP_BRANCHES',
'where flow_id = :fb_flow_id and',
'      flow_step_id = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna bifurcaci\00F3n')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(11504814665567615.4001)
,p_query_column_id=>1
,p_column_alias=>'SUBSTR(BRANCH_ACTION,1,25)'
,p_column_display_sequence=>1
,p_column_heading=>'Substr(Branch Action,1,25)'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(26572606514744244.4001)
,p_name=>'Validaciones'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select VALIDATION_NAME',
'from WWV_FLOW_STEP_VALIDATIONS',
'where FLOW_ID = :fb_flow_id and',
'      FLOW_STEP_ID = :fb_flow_page_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna validaci\00F3n')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26573209627744265.4001)
,p_query_column_id=>1
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre de Validaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108099828357520038.4001)
,p_plug_name=>'Advertencia'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>60
,p_plug_source=>unistr('La supresi\00F3n de la p\00E1gina de conexi\00F3n puede convertir la aplicaci\00F3n en no utilizable.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and alias = ''LOGIN'' and id = :fb_flow_page_id'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231664327969078921.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747137049340138150.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(105116238844.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(231664327969078921.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(105114238843.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(231664327969078921.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir Permanentemente P\00E1gina')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(105118238845.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(105114238843.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(105120238845.4001)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(105116238844.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60428831890275742.4001)
,p_name=>'P21_P'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'wwv_flow_builder.get_current_page_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la p\00E1gina que se va a suprimir.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121359621776405514.4001)
,p_name=>'F4000_P21_DELETE_TABS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NO'
,p_prompt=>unistr('Supresi\00F3n en Cascada')
,p_source=>'NO'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DELETE_ASSOC_TABS'
,p_lov=>'.'||wwv_flow_api.id(84243720472403985.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  tab_set,',
'  tab_name,',
'  TAB_ALSO_CURRENT_FOR_PAGES',
'from wwv_flow_tabs ',
'where flow_id = :fb_flow_id and TAB_STEP = :fb_flow_page_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si se deben suprimir los separadores correspondientes a esta p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(139141730383821612.4001)
,p_name=>'P21_DELETE_CORRESPONDING_LIST_ENTRIES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(105124238853.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Supresi\00F3n en Cascada')
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DELETE CORRESPONDING LIST ENTRIES'
,p_lov=>'.'||wwv_flow_api.id(139182915633902523.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and upper(LIST_ITEM_LINK_TARGET) ',
'like ''F?P=%:''||:fb_flow_page_id||'':%'';'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Especifique si las entradas de lista correspondientes a esta p\00E1gina se deben suprimir. Las entradas de lista correspondientes son las que especifican un enlace de URL a esta p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(166803822650787345.4001)
,p_validation_name=>'check page lock'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from wwv_flow_lock_page where OBJECT_ID = :FB_FLOW_PAGE_ID and flow_id = :fb_flow_id',
'and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede suprimir una p\00E1gina bloqueada por otro usuario.')
,p_when_button_pressed=>wwv_flow_api.id(105114238843.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(105122238851.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Page'
,p_process_sql_clob=>'delete from wwv_flow_steps where flow_id = :fb_flow_id and id = :fb_flow_page_id;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al suprimir la p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
,p_process_success_message=>unistr('P\00E1gina suprimida.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(121368524961464774.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cascade Deletes to Tabs'
,p_process_sql_clob=>'delete from wwv_flow_tabs where flow_id = :fb_flow_id and TAB_STEP = :fb_flow_page_id;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al suprimir en cascada los separadores de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
,p_process_when=>'F4000_P21_DELETE_TABS'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'YES'
,p_process_success_message=>unistr('&nbsp;&nbsp;Separador est\00E1ndar eliminado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(93007001017007408.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade deletes to menus'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id from wwv_flow_menu_options',
'               where flow_id = :FB_FLOW_ID ',
'                 and page_id = :FB_FLOW_PAGE_ID',
'                 and also_current_for_pages is null) loop',
'    --',
'    -- First, set to null the parent_id of the menu options which have the one we''re deleting as a parent',
'    --',
'    update wwv_flow_menu_options',
'       set parent_id = null',
'     where parent_id = c1.id',
'       and flow_id = :FB_FLOW_ID;',
'       ',
'    -- Then, delete this one',
'    delete from wwv_flow_menu_options',
'     where id = c1.id',
'       and flow_id = :FB_FLOW_ID',
'       and page_id = :FB_FLOW_PAGE_ID;',
'       ',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(161378116667683902.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade delete to list items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and LIST_ITEM_CURRENT_FOR_PAGES = :fb_flow_page_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido eliminar los elementos de la lista correspondiente.'
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(139153232639860156.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Corresponding List Entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and upper(LIST_ITEM_LINK_TARGET) ',
'like ''F?P=%:''||:fb_flow_page_id||'':%'';'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido eliminar las entradas de la lista correspondiente.'
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
,p_process_when=>'P21_DELETE_CORRESPONDING_LIST_ENTRIES'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_process_success_message=>' Entradas de lista correspondiente eliminadas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46460004215313279.4001)
,p_process_sequence=>55
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade delete IR'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_worksheet_rpts',
'where page_id = :fb_flow_page_id',
'and flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162086029610097517.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete locked page'
,p_process_sql_clob=>'delete from wwv_flow_lock_page where object_id = :fb_flow_page_id and flow_id = :fb_flow_id;'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162029321720000696.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset current page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id from wwv_flow_steps where flow_id = :fb_flow_id and id > 0 order by id) loop',
'   :fb_flow_page_id := c1.id;',
'   exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(105114238843.4001)
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_api.create_page(
 p_id=>22.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n: M\00E9todo')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46446211382215703.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193535105470741906.4001)
,p_plug_name=>'Select Navigation Bar Creation Method'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(23828816607086312.4001)
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_col_allignments=>'L:L:L:L:L:L:L:L'
,p_plug_query_break_cols=>'0'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:NO:NO:NO'
,p_plug_query_number_formats=>':::::::'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear entradas de barra de navegaci\00F3n nuevas o copiarlas de otra aplicaci\00F3n. La copia de entradas le proporciona un marco que puede modificar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196981121351998160.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(103870209211856610.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193535424797741908.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46446211382215703.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193535714903741910.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46446211382215703.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193536613283741916.4001)
,p_branch_action=>'134'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193535714903741910.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P22_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197005017887347141.4001)
,p_branch_action=>'f?p=&APP_ID.:392:&SESSION.::&DEBUG.:392::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193536000806741912.4001)
,p_name=>'F4000_P22_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(193535105470741906.4001)
,p_item_default=>'BLANK'
,p_prompt=>unistr('Crear Entrada de Barra de Navegaci\00F3n:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NAV_BAR_CREATE_METHOD'
,p_lov=>'.'||wwv_flow_api.id(84245132593407471.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo con el que desea crear el nuevo icono de la barra de navegaci\00F3n y haga clic en <strong>Siguiente</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573754179473229722.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193535424797741908.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573754220843229723.4001)
,p_event_id=>wwv_flow_api.id(573754179473229722.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_api.create_page(
 p_id=>26.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asistente de Plantillas de P\00E1gina: Copiar de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Asistente de Plantillas de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47947818362720924.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176866410930258995.4001)
,p_plug_name=>unistr('Crear Plantilla de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176867605048259001.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176868205270259010.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47947818362720924.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177576213949589943.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47947818362720924.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176892509159292264.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47947818362720924.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(176868831660259044.4001)
,p_branch_action=>'225'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(177576213949589943.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589949443937621439.4001)
,p_branch_action=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(176892509159292264.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176866717827258996.4001)
,p_name=>'F4000_P26_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(176866410930258995.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar plantillas.')
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'select name||'' (''||id||'')'', id from wwv_flows where id = v(''FB_FLOW_ID'')'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177568115964580552.4001)
,p_validation_name=>'F4000_P26_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P26_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(176866717827258996.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589949229289621437.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(176868205270259010.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589949333181621438.4001)
,p_event_id=>wwv_flow_api.id(589949229289621437.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1997571893328693489.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_api.create_page(
 p_id=>27.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Elementos de Interfaz de Usuario de \00C1rbol')
,p_step_title=>unistr('Editar \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41660313778446370.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'R1'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 13-MAR-2001 22:41:22'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41670955697548778.4001)
,p_plug_name=>'Plantillas de Texto de Nodo'
,p_region_name=>'R6'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41673516284578820.4001)
,p_plug_name=>unistr('Plantillas de Nodo Est\00E1ticas')
,p_region_name=>'R4'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>10
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41680540604674592.4001)
,p_plug_name=>unistr('\00C1rboles')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique atributos de \00E1rbol.</p>'),
unistr('<p>Los \00E1rboles est\00E1n basados en una consulta y devuelven datos que se pueden representar en una jerarqu\00EDa.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41680814605688605.4001)
,p_plug_name=>'Consulta'
,p_region_name=>'R2'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInstructionText">Sintaxis: select id, pid, name, link, a1, a2 from ... where ... order by ...',
'<ol>',
'<li>Todos los nombres de columna deben utilizar los alias mostrados anteriormente (por ejemplo, id, pid, name, link, a1, a2)</li>',
'<li>Debe seleccionar al menos 4 columnas (por ejemplo, id, pid, name, link)</li>',
unistr('<li>Todos los PID (ID principales) de referencia deben ser tambi\00E9n ID</li>'),
unistr('<li>El orden s\00F3lo controla los elementos de un solo nodo</li>'),
'</ol>',
'<strong>Ejemplo</strong>:<br />',
'select empno id, mgr pid, ename name, null link<br />',
'from emp<br />',
'order by ename',
'</div>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46154923902612559.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58226716348068103.4001)
,p_plug_name=>'Plantillas de Enlace'
,p_region_name=>'R7'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58227138260077767.4001)
,p_plug_name=>unistr('Antes y Despu\00E9s')
,p_region_name=>'R3'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58247015661740508.4001)
,p_plug_name=>unistr('Plantillas Din\00E1micas')
,p_region_name=>'R5'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>10
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>unistr('Plantillas de nodo de \00E1rbol de ampliaci\00F3n y reducci\00F3n din\00E1mica.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91201614411380148.4001)
,p_plug_name=>unistr('\00C1rbol')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628876928431702685.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_TREES',
'where id = :F4000_P27_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P27_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P27_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41660613435446375.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(91201614411380148.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41660814005446377.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(91201614411380148.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P27_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41661020245446377.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(91201614411380148.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P27_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41661217579446378.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(91201614411380148.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear \00C1rbol')
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P27_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41659616901446365.4001)
,p_branch_action=>'28'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41659847523446366.4001)
,p_branch_action=>'28'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Delete'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41660060408446367.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41661418554446388.4001)
,p_name=>'F4000_P27_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(41660313778446370.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41661616997446395.4001)
,p_name=>'F4000_P27_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(41660313778446370.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41661855827446397.4001)
,p_name=>'F4000_P27_TREE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(41660313778446370.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de \00C1rbol')
,p_source=>'TREE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifica el nombre de \00E1rbol que se utiliza por motivos de desarrollo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41662017225446398.4001)
,p_name=>'F4000_P27_TREE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(41660313778446370.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de \00C1rbol')
,p_source=>'TREE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84296320837555546.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifica el origen del \00E1rbol (por ejemplo, una consulta SQL).')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41662285728446399.4001)
,p_name=>'F4000_P27_TREE_QUERY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(41680814605688605.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Consulta de \00C1rbol')
,p_source=>'TREE_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>20
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la consulta que se utilizar\00E1 para generar este \00E1rbol.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41662642214446403.4001)
,p_name=>'F4000_P27_MAX_LEVELS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(41660313778446370.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'5'
,p_prompt=>unistr('Niveles M\00E1ximos')
,p_source=>'MAX_LEVELS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select i d, i r from wwv_flow_dual100 order by 1'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo especifica el n\00FAmero de niveles que van a aparecer cuando se muestre un \00E1rbol por primera vez. Cuando el usuario empiece a navegar por un \00E1rbol, el estado de la sesi\00F3n recordar\00E1 su \00FAltima posici\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41662818017446403.4001)
,p_name=>'F4000_P27_UNEXPANDED_PARENT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(58247015661740508.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<td><a href="#DRILL_DOWN#"><img src="#IMAGE_PREFIX#Fndtre02.gif" width=16 height=22 border=0></a></td>'
,p_prompt=>'Principal No Ampliado (usar #DRILL_DOWN# para ampliar y reducir el enlace)'
,p_source=>'UNEXPANDED_PARENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la plantilla para nodos principales no ampliados. Utilice la cadena de sustituci\00F3n #DRILL_DOWN# para el enlace de ampliaci\00F3n y de no ampliaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41663018811446404.4001)
,p_name=>'F4000_P27_UNEXPANDED_PARENT_LAST'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(58247015661740508.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00DAltimo Principal No Ampliado (usar  #DRILL_DOWN# para ampliar y reducir el enlace)')
,p_source=>'UNEXPANDED_PARENT_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la plantilla para el \00FAltimo nodo principal no ampliado. Utilice la cadena de sustituci\00F3n #DRILL_DOWN# para el enlace de ampliaci\00F3n y de no ampliaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41663217470446406.4001)
,p_name=>'F4000_P27_EXPANDED_PARENT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(58247015661740508.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Principal Ampliado (usar #DRILL_DOWN# para ampliar y reducir el enlace)'
,p_source=>'EXPANDED_PARENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la plantilla para el nodo principal ampliado. Utilice la cadena de sustituci\00F3n #DRILL_DOWN# para el enlace de ampliaci\00F3n y de no ampliaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41663414146446408.4001)
,p_name=>'F4000_P27_EXPANDED_PARENT_LAST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(58247015661740508.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00DAltimo Principal Ampliado (usar #DRILL_DOWN# para ampliar y reducir el enlace)')
,p_source=>'EXPANDED_PARENT_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la plantilla para el \00FAltimo nodo principal ampliado. Utilice la cadena de sustituci\00F3n #DRILL_DOWN# para el enlace de ampliaci\00F3n y de no ampliaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41663616502446408.4001)
,p_name=>'F4000_P27_LEAF_NODE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(41673516284578820.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<td align=left><img src="#IMAGE_PREFIX#Fndtre07.gif" width=16 height=22 border=0></td>'
,p_prompt=>unistr('Nodo de Hoja (el \00FAltimo nodo no tiene capacidades de cambio de nivel)')
,p_source=>'LEAF_NODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este atributo controla el texto que aparece antes de mostrar el texto del nodo de hoja. Un nodo de hoja es un nodo de \00E1rbol que no tiene secundarios. Este atributo se aplica solo a los nodos de hoja que no son los \00FAltimos nodos de hoja del \00E1rbol. Por')
||' ejemplo:',
'<pre>',
'&lt;td align=left>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre07.gif" width=16 height=22 border=0>&lt;/td>',
'</pre>',
'Fndtre07.gif = <img src="#IMAGE_PREFIX#Fndtre07.gif" width="16" height="22" border="2">'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41663866477446409.4001)
,p_name=>'F4000_P27_LEAF_NODE_LAST'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(41673516284578820.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<td align=left><img src="#IMAGE_PREFIX#Fndtre08.gif" width=16 height=22 border=0></td>'
,p_prompt=>unistr('\00DAltimo Nodo de Hoja (el \00FAltimo nodo no tiene capacidades de cambio de nivel)')
,p_source=>'LEAF_NODE_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este atributo controla el texto que aparece antes de mostrar el texto del nodo de hoja. Un nodo de hoja es un nodo de \00E1rbol que no tiene secundarios. Este atributo se aplica solo a los nodos de hoja que no son los \00FAltimos nodos de hoja del \00E1rbol. Por')
||' ejemplo:',
'<pre>',
'&lt;td align=left>&lt;img src="#IMAGE_PREFIX#Fndtre08.gif" width="16" height="22" border="0" alt="Nodo">&lt;/td>',
'</pre>',
'',
'Fndtre07.gif = <img src="&#35;IMAGE_PREFIX&#35;Fndtre08.gif" width="16" height="22" border="2" alt="Nodo">'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41664015640446410.4001)
,p_name=>'F4000_P27_DRILL_UP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(41673516284578820.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Reducir Detalle (texto de enlace para #DRILL_UP# en la plantilla del nodo ra\00EDz)')
,p_source=>'DRILL_UP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este atributo identifica el texto de enlace que aparece si se puede reducir el detalle en el \00E1rbol. Al utilizar \00E1rboles, puede mostrar un \00E1rbol que empiece por un punto que no sea el nodo ra\00EDz. Para facilitar la navegaci\00F3n del usuario por los nodos p')
||'rincipales, debe reducir el detalle del enlace. Por ejemplo:',
'<pre>',
'&amp;nbsp;(arriba)',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41664210620446410.4001)
,p_name=>'F4000_P27_NAME_LINK_ANCHOR_TAG'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(58226716348068103.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<a href="#LINK#"><font class="nounderline" size=-3>#NAME#</font></a>'
,p_prompt=>'Etiqueta de Anclaje de Enlace de Nombre (se utiliza en caso de que exista un enlace)'
,p_source=>'NAME_LINK_ANCHOR_TAG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo identifica el modo de presentaci\00F3n de un nombre si \00E9ste tiene un enlace. Utilice las cadenas de sustituci\00F3n #LINK# y #NAME#.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41664412639446412.4001)
,p_name=>'F4000_P27_NAME_LINK_NOT_ANCHOR_TAG'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(58226716348068103.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<font size=-3>#NAME#</font>'
,p_prompt=>'Etiqueta que no es de Anclaje de Enlace de Nombre'
,p_source=>'NAME_LINK_NOT_ANCHOR_TAG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la etiqueta de nombre para los nombres de nodo que no sean enlaces. Utilice la cadena de sustituci\00F3n #NAME#.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41664618922446416.4001)
,p_name=>'F4000_P27_INDENT_VERTICAL_LINE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(41673516284578820.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicar Sangr\00EDa a L\00EDnea Vertical')
,p_source=>'INDENT_VERTICAL_LINE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este atributo controla la l\00EDnea vertical o el espaciado entre peers. Observe el siguiente ejemplo. F\00EDjese en que Jones, Smith y Thomas son peers y que se utiliza una l\00EDnea vertical a la izquierda de la organizaci\00F3n de Smith.'),
'<pre>',
'+-+ Jones',
'',
' + Smith',
'',
' | |',
'',
' | + Frank',
'',
' | + Scott',
'',
' + Thomas',
'',
'</pre>',
'',
'Observe el siguiente ejemplo:',
'<pre>',
'&lt;td>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre09.gif" width="16" height="22" border="0" alt="Branch">&lt;/td>',
'</pre>',
'<br/>',
'Fndtre09.gif = <img src="#IMAGE_PREFIX#Fndtre09.gif" width="16" height="22" border="2" alt="Branch">'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41664816744446416.4001)
,p_name=>'F4000_P27_INDENT_VERTICAL_LINE_LAST'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(41673516284578820.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicar Sangr\00EDa a \00DAltima L\00EDnea Vertical (espacio en blanco aka)')
,p_source=>'INDENT_VERTICAL_LINE_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este atributo controla un espacio en blanco. En el siguiente ejemplo, f\00EDjese en el espacio en blanco debajo de Thomas y antes de Marks.'),
'<pre>',
'+-+ Jones',
'',
'  + Smith',
'',
'  | |',
'',
'  | + Frank',
'',
'  | + Scott',
'',
'  + Thomas',
'',
'    |',
'',
'    Marks',
'',
'</pre>',
'',
'Observe el siguiente ejemplo:',
'<pre>',
'&lt;td>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre10.gif" width=16 height=22 border=0>&lt;/td>',
'</pre>',
'</p>',
'Fndtre10.gif = <img src="#IMAGE_PREFIX#Fndtre10.gif" width=16 height=22 border=2>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41665044534446417.4001)
,p_name=>'F4000_P27_BEFORE_TREE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(58227138260077767.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table border=0 cellspacing=0 cellpadding=0>'
,p_prompt=>unistr('Antes de \00C1rbol (Muestra este HTML antes de imprimir el \00E1rbol)')
,p_source=>'BEFORE_TREE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Muestra este texto antes que cualquier nodo del \00E1rbol. Normalmente se utiliza para abrir una tabla HTML. Por ejemplo:'),
'<pre>',
'&lt;table border=0 cellspacing=0 cellpadding=0&gt;',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41665295973446418.4001)
,p_name=>'F4000_P27_AFTER_TREE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(58227138260077767.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>unistr('Despu\00E9s de \00C1rbol')
,p_source=>'AFTER_TREE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Muestra este texto despu\00E9s de los nodos del \00E1rbol. Normalmente se utiliza para cerrar una tabla HTML. Por ejemplo:'),
'<pre>',
'&lt;/table&gt;',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41665415561446419.4001)
,p_name=>'F4000_P27_LEVEL_1_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(41670955697548778.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr>#INDENT#<td colspan=#COLSPAN# valign="CENTER">#NAME##A1##A2# #DRILL_UP#</td></tr>'
,p_prompt=>unistr('Plantilla de Nodo Principal (utilizado para el nodo ra\00EDz) Utilice #NAME#, #DRILL_UP#, #A1#, #A2#, #COLSPAN#.')
,p_source=>'LEVEL_1_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Cuando se especifique este atributo:',
'<ul>',
'<li>#NAME# especifica el valor a partir de la columna de nombre de la consulta</li>',
unistr('<li>#DRILL_UP# es el enlace para reducir el detalle encima de la ra\00EDz</li>'),
'<li>#A1# hace referencia a a1 desde la consulta</li>',
'<li>#A2# hace referencia a a2 desde la consulta</li>',
unistr('<li>#COLSPAN# especifica los niveles m\00E1ximos (nivel actual + 1).'),
'Utilice #COLSPAN# para generar tablas HTML adecuadas utilizando el estilo de plantilla por defecto.',
'</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41665692746446419.4001)
,p_name=>'F4000_P27_LEVEL_2_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(41670955697548778.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr>#INDENT#<td colspan=#COLSPAN# valign="CENTER">#NAME##A1##A2#</td></tr>'
,p_prompt=>unistr('Plantilla de Texto de Nodo (#NAME# se ampl\00EDa mediante la siguiente plantilla de enlace de hipertexto) Utilice #NAME#, #A1#, #A2#, #COLSPAN#')
,p_source=>'LEVEL_2_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la plantilla para el texto del nodo. Utilice las cadenas de sustituci\00F3n #NAME#, #A1#, #A2# y #COLSPAN#.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42827836936288330.4001)
,p_name=>'F4000_P27_FLOW_ITEM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(41660313778446370.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Elemento de Aplicaci\00F3n')
,p_source=>'FLOW_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||wwv_flow_escape.html(name) a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||wwv_flow_escape.html(name) a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este atributo identifica un elemento de aplicaci\00F3n o de p\00E1gina que especifica el punto inicial del \00E1rbol (el primer nodo). La consulta que define el \00E1rbol identifica una posici\00F3n inicial. El valor de este elemento debe ser igual que la clave primaria')
||unistr(' del \00E1rbol.'),
'<br/><br/>',
unistr('El principal del primer nodo es normalmente un valor cero o nulo. Si es otro valor, aparece un enlace ascendente para facilitar la reducci\00F3n del detalle.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41681910493722669.4001)
,p_validation_name=>'F4000_P27_TREE_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P27_TREE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de \00E1rbol.')
,p_associated_item=>wwv_flow_api.id(41661855827446397.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41682118938722674.4001)
,p_validation_name=>'F4000_P27_TREE_TYPE Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P27_TREE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el tipo de \00E1rbol.')
,p_associated_item=>wwv_flow_api.id(41662017225446398.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41682327682722675.4001)
,p_validation_name=>'F4000_P27_MAX_LEVELS Not Null'
,p_validation_sequence=>30
,p_validation=>'F4000_P27_MAX_LEVELS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se deben especificar los niveles m\00E1ximos.')
,p_associated_item=>wwv_flow_api.id(41662642214446403.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41682514521722675.4001)
,p_validation_name=>'F4000_P27_TREE_QUERY Not Null'
,p_validation_sequence=>40
,p_validation=>'F4000_P27_TREE_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la consulta de \00E1rbol.')
,p_associated_item=>wwv_flow_api.id(41662285728446399.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(106551420103727021.4001)
,p_validation_name=>'F4000_P27_FLOW_ITEM not null'
,p_validation_sequence=>50
,p_validation=>'F4000_P27_FLOW_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el elemento de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(41661020245446377.4001)
,p_associated_item=>wwv_flow_api.id(42827836936288330.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41667012370446430.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_TREES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TREES'
,p_attribute_03=>'F4000_P27_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>unistr('Error al obtener los atributos de \00E1rbol.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41667232451446438.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_TREES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TREES'
,p_attribute_03=>'F4000_P27_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al realizar el proceso.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_api.create_page(
 p_id=>28.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('\00C1rboles')
,p_step_title=>unistr('\00C1rboles')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4893702635405949.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(4884503079390537.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41669337920492677.4001)
,p_plug_name=>unistr('\00C1rboles')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Un \00E1rbol es un mecanismo de navegaci\00F3n jer\00E1rquica. Puede crear uno a partir de una consulta que especifique una relaci\00F3n jer\00E1rquica, mediante la identificaci\00F3n de la columna de identificador y de identificador principal en una tabla o vista.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48497310933562027.4001)
,p_plug_name=>unistr('\00C1rboles')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P28a */ ID,',
'       tree_name, ',
'       tree_type,',
'       TREE_QUERY,',
'       tree_comment,',
'       ''icon-sc-tree'' icon_class,',
'       replace(tree_name,''_'','' '') icon_title,',
'       ''f?p=4000:27:''||:app_session||''::NO::F4000_P27_ID:''||ID edit_link,',
'       tree_name img_name,',
'       nvl(last_updated_by,created_by) updated_by,',
'       nvl(last_updated_on,created_on) updated',
'from   WWV_FLOW_TREES t',
'where  flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48497413326562027.4001)
,p_name=>'Trees'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48497727234562030.4001)
,p_db_column_name=>'TREE_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::F4000_P27_ID:#ID#'
,p_column_linktext=>'#TREE_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48497808682562031.4001)
,p_db_column_name=>'TREE_TYPE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48497624593562029.4001)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48497932373562031.4001)
,p_db_column_name=>'TREE_QUERY'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Consulta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48498018293562032.4001)
,p_db_column_name=>'TREE_COMMENT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Comentarios'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48498520970562034.4001)
,p_db_column_name=>'IMG_NAME'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Nombre de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48498607309562034.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48498714815562035.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656964258839061330.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656964392968061330.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656964485914061330.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188982523974842051.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48497310933562027.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:28,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(89007306708091375.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'28'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_api.create_page(
 p_id=>29.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_welcome_text=>' '
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region.help-region {',
'    margin: 0 28px;',
'}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32463635783181029.4001)
,p_plug_name=>'Crear Maestro/Detalle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(71514955753382049.4001)
,p_plug_name=>'wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(275644731777510025.4001)
,p_plug_name=>'Ayuda'
,p_region_css_classes=>'help-region'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
unistr('<li>Apilado: una \00FAnica p\00E1gina maestro-detalle que utiliza cuadr\00EDculas interactivas editables.</li>'),
unistr('<li>En paralelo: una \00FAnica p\00E1gina maestro-detalle que utiliza dise\00F1o en paralelo y regiones de informe con ventanas de edici\00F3n modal.</li>'),
unistr('<li>Aumentar detalle: consta de en una p\00E1gina de informe que aumenta el detalle de una p\00E1gina en la que el maestro seleccionado consiste en elementos de formulario est\00E1ndar y las tablas detalladas utilizan cuadr\00EDculas interactivas editables.</li>'),
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27294346188760426.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(71514955753382049.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27294702588760426.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(71514955753382049.4001)
,p_button_name=>'HELP_R'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./HTMDB/creating-report-create-page-wizard.htm#HTMDB-GUID-0B017672-7523-412D-ADB2-E299D6CFACF5'');'
,p_button_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_button_condition2=>'REPORT'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27295145397760426.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(71514955753382049.4001)
,p_button_name=>'HELP_F'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./HTMDB/using-a-wizard-to-create-a-form.htm#GUID-A4B9D6BA-6C59-4B0A-88E1-E36D0682FFAE'');'
,p_button_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_button_condition2=>'FORM'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27295553431760427.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(71514955753382049.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27295911221760427.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(71514955753382049.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27306104097760436.4001)
,p_branch_name=>'Stacked'
,p_branch_action=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:32,4716,239,257::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>210
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P29_MD_TYPE'
,p_branch_condition_text=>'MD_SINGLE_PG'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27306999411760437.4001)
,p_branch_name=>'Drill Down'
,p_branch_action=>'f?p=&APP_ID.:326:&SESSION.::&DEBUG.:326,4716,239,257:P759_REPORT_TYPE:&P29_MD_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>220
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P29_MD_TYPE'
,p_branch_condition_text=>'MD_TWO_PG'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27298154943760430.4001)
,p_branch_name=>'Side by Side'
,p_branch_action=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:759,4716,98,99:P759_REPORT_TYPE:&P29_MD_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>230
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P29_MD_TYPE'
,p_branch_condition_text=>'MD_EMAIL_STYLE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27306568317760436.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(27295911221760427.4001)
,p_branch_sequence=>200
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27293280565760424.4001)
,p_name=>'P29_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32463635783181029.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27293670843760424.4001)
,p_name=>'P29_MD_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32463635783181029.4001)
,p_item_default=>'MD_SINGLE_PG'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P29_MD_TYPE'
,p_lov=>'.'||wwv_flow_api.id(27314867128775183.4001)||'.'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'a-IconList--layouts'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(27296705173760428.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(27294346188760426.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(27297201721760429.4001)
,p_event_id=>wwv_flow_api.id(27296705173760428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_api.create_page(
 p_id=>30.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Introducci\00F3n al Dise\00F1ador de P\00E1ginas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Introducci\00F3n al Dise\00F1ador de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_css_classes=>'a-Dialog--pageDesignerGetStarted'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(153764270703903309.4001)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-app-builder'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_PAGE_DESIGNER'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1493543391999991810.4001)
,p_plug_name=>'Ayuda'
,p_region_css_classes=>'a-Dialog-textContent'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<big>El dise\00F1ador de p\00E1ginas es un entorno de desarrollo integrado (IDE) global que se utiliza para mantener y mejorar p\00E1ginas en las aplicaciones de Oracle Application Express.</big>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1104689117393514433.4001)
,p_plug_name=>unistr('Barra de Herramientas del Dise\00F1ador de P\00E1ginas')
,p_parent_plug_id=>wwv_flow_api.id(1493543391999991810.4001)
,p_region_css_classes=>'a-Region--textContent'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La barra de herramientas situada en la parte superior del dise\00F1ador de p\00E1ginas incluye varias capacidades:</p>'),
'<ul>',
unistr('  <li><strong>Selector de p\00E1gina</strong>: muestra la p\00E1gina actual. Tambi\00E9n puede introducir un n\00FAmero de p\00E1gina directamente o hacer clic en la lista emergente de valores para seleccionar una p\00E1gina. </li>'),
unistr('  <li><strong>Mensajes</strong>: cuando agrega un nuevo componente a una p\00E1gina, se muestran los errores y advertencias actuales. Al hacer clic en un mensaje, se cambia el enfoque en el editor de propiedades al atributo correspondiente asociado al er')
||'ror o advertencia.</li>',
unistr('  <li><strong>Bloquear p\00E1gina</strong>: indica si la p\00E1gina est\00E1 desbloqueada (desactivada), bloqueada por el usuario (rojo) o bloqueada por otro desarrollador (rojo con una persona).<br/>'),
unistr('    Si hace clic en este icono, puede bloquear o desbloquear la p\00E1gina, siempre que no la haya bloqueado otro desarrollador.</li>'),
unistr('  <li><strong>Deshacer cambios</strong>: haga clic para deshacer la actualizaci\00F3n anterior realizada en el dise\00F1ador de p\00E1ginas.</li>'),
unistr('  <li><strong>Rehacer cambios</strong>: haga clic para volver a aplicar la \00FAltima actualizaci\00F3n que haya deshecho con Deshacer cambios.</li>'),
unistr('  <li><strong>Crear</strong>: permite crear nuevas p\00E1ginas, copiar p\00E1ginas, crear regiones, gestionar componentes compartidos, gestionar grupos de p\00E1ginas, agregar comentarios del desarrollador y crear incidencias de desarrollo de equipos.</li>'),
unistr('  <li><strong>Utilidades</strong>: permite suprimir p\00E1ginas, ejecutar el asesor para realizar una comprobaci\00F3n, ver el almacenamiento en cach\00E9, consultar el historial de p\00E1ginas y visualizar el total de control de p\00E1gina, as\00ED como exportar, activar o')
||unistr(' desactivar las pistas y el separador Dise\00F1o, o utilizar Dise\00F1o para conmutar entre el modo de dos paneles y el de tres paneles.<br/>'),
unistr('  <li><strong>Componentes compartidos</strong>: permite navegar a la p\00E1gina Componentes compartidos.</li>'),
unistr('  <li><strong>Guardar</strong>: permite guardar todos los cambios realizados en la p\00E1gina actual.</li>'),
unistr('  <li><strong>Guardar y ejecutar p\00E1gina</strong>: permite guardar todos los cambios y, a continuaci\00F3n, ejecutar la p\00E1gina actual.<br/>'),
unistr('    <em>Nota: No podr\00E1 ejecutar p\00E1ginas modales y no modales directamente con Guardar y ejecutar p\00E1gina. En su lugar, tendr\00E1 que navegar a una p\00E1gina normal y ejecutar la p\00E1gina desde all\00ED y, a continuaci\00F3n, navegar dentro de la aplicaci\00F3n en ejecuci')
||unistr('\00F3n a la p\00E1gina modal o no modal.</em></li>'),
'</ul><br/>',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/page-designer-toolbar.html#GUID-5E911CA1-4A87-40B4-AAB7-57387D576DA0">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1498784482317536966.4001)
,p_plug_name=>'Paneles Principales'
,p_parent_plug_id=>wwv_flow_api.id(1493543391999991810.4001)
,p_region_css_classes=>'a-Region--textContent'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El dise\00F1ador de p\00E1ginas contiene tres paneles principales:</p>'),
'<ul>',
unistr('  <li><strong>Panel izquierdo</strong>: incluye los separadores Presentaci\00F3n, Acciones din\00E1micas, Procesamiento y Componentes compartidos. En cada separador, se muestra una lista de los tipos de componentes y componentes correspondientes creados en l')
||unistr('a p\00E1gina actual.<br/>'),
unistr('    Haga clic con el bot\00F3n derecho para acceder a los men\00FAs contextuales. Tambi\00E9n puede arrastrar componentes hacia arriba o hacia abajo en los \00E1rboles para cambiar la posici\00F3n o el orden del componente seleccionado.</li>'),
unistr('  <li><strong>Panel central</strong>: incluye los separadores Dise\00F1o, B\00FAsqueda de p\00E1gina y Ayuda.<br/>'),
unistr('    En <em>Dise\00F1o</em>, se muestra una representaci\00F3n visual de la p\00E1gina. Puede agregar nuevos componentes de p\00E1gina haciendo clic con el bot\00F3n derecho para acceder a un men\00FA contextual o arrastr\00E1ndolos desde el separador Galer\00EDa, en la parte inferi')
||unistr('or, y solt\00E1ndolos en Dise\00F1o.<br/>'),
unistr('   <em>B\00FAsqueda de p\00E1gina</em> permite buscar cualquier metadato de p\00E1gina, como regiones, elementos, botones, acciones din\00E1micas, columnas, etc.<br/>'),
unistr('   En <em>Ayuda</em>, se muestra la ayuda espec\00EDfica del atributo. Haga clic en el nombre del atributo en el editor de propiedades para ver informaci\00F3n y ejemplos para ese atributo.</li>'),
'  <li><strong>Panel derecho</strong>: se muestra el editor de propiedades. Utilice el editor de propiedades para actualizar los atributos para los componentes seleccionados.<br/>',
unistr('    Cuando selecciona varios componentes, el editor de propiedades solo muestra los atributos comunes. Al actualizar un atributo com\00FAn, se actualizar\00E1 ese atributo para todos los componentes seleccionados.</li>'),
'</ul>',
'<p>&nbsp;</p>',
unistr('<p>Para cambiar el tama\00F1o de cada panel, seleccione y deslice los divisores verticales y horizontales. Para ampliar o reducir cada panel, haga clic en el peque\00F1o tri\00E1ngulo con la etiqueta <strong>Reducir</strong> situado en el centro de cada divisor.')
||'</p>',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/understanding-page-designer-ui-elements.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81564783738352513.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(153764270703903309.4001)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Introducci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/go/get_started_page_designer'');'
,p_button_css_classes=>'a-Button--dark'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_api.create_page(
 p_id=>31.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Iconos'
,p_step_title=>'Iconos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function passBack(x,return_item) {',
'    opener.$x(return_item).value = x;',
'	opener.$x(return_item).focus()',
'	close();',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.fa-icon-block {',
'    display: inline-block;',
'}',
'.fa-icon-block a,',
'.fa-icon-block a:hover {',
'    text-decoration: none;',
'}',
'.fa-icon-block a {',
'    display: inline-block;',
'    width: 160px;',
'    padding: 8px;',
'    height: 90px;',
'    text-align: center;',
'    border-radius: 2px;',
'    vertical-align: top;',
'}',
'.fa-icon-block a:hover {',
'    background-color: #F8F8F8;',
'    box-shadow: 0 0 0 1px rgba(0,0,0,.1)',
'}',
'.fa-icon-block .fa {',
'    font-size: 42px;',
'    display: inline-block;',
'    color: #707070;',
'    line-height: 1.25;',
'}',
'.fa-icon-block .icon-label {',
'    font-size: 12px;',
'    line-height: 16px;',
'    display: block;',
'    color: #404040;',
'}'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1845883349389589583.4001)
,p_plug_name=>'Images'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_popup_images(',
'    p_return_item => ''P4314_ICON_CSS_CLASSES'',',
'    p_image_size  => :P31_ICON_SIZE,',
'    p_show        => :P31_SHOW, ',
'    p_category    => :P31_ICON_CATEGORY);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1845883779315589585.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1845887618347589599.4001)
,p_plug_name=>'Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<p>Haga clic en un icono para seleccionarlo y cierre esta ventana.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1845884556922589586.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(1845883779315589585.4001)
,p_button_name=>'P31_GO'
,p_button_static_id=>'P654_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1845884161570589585.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1845883779315589585.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1845888119844589605.4001)
,p_branch_action=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1845884993327589587.4001)
,p_name=>'P31_SHOW'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(1845883779315589585.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_icon_library wwv_flow_themes.icon_library%type;',
'begin',
'    select min( icon_library )',
'      into l_icon_library',
'      from wwv_flow_themes t,',
'           wwv_flow_user_interfaces ui',
'     where ui.flow_id = :FB_FLOW_ID',
'       and ui.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and t.flow_id            = ui.flow_id',
'       and t.theme_id           = ui.theme_id',
'       and t.security_group_id  = ui.security_group_id;',
'',
'  return nvl( l_icon_library, ''STANDARD_ICON'' );',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON PREVIEW REPOSITORY'
,p_lov=>'.'||wwv_flow_api.id(1845902759442614704.4001)||'.'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Los iconos utilizados previamente son iconos que forman parte de la distribuci\00F3n de Oracle Application Express y que se han utilizado previamente en la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1845885841404589598.4001)
,p_name=>'P31_ICON_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1845883779315589585.4001)
,p_item_default=>'64'
,p_prompt=>unistr('Tama\00F1o de Icono')
,p_source=>'64'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'STANDARD ICON SIZES 2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''12x12''	 d, 12  r from dual union all',
'select ''16x16''	 d, 16  r from dual union all',
'select ''20x20''	 d, 20  r from dual union all',
'select ''32x32''	 d, 32  r from dual union all',
'select ''64x64''	 d, 64  r from dual union all',
'select ''128x128'' d, 128 r from dual union all',
'select ''140x90''	 d, 140 r from dual',
'order by 2'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tama\00F1o de imagen de aplicaci\00F3n est\00E1ndar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1845886725298589599.4001)
,p_name=>'P31_ICON_CATEGORY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1845883779315589585.4001)
,p_prompt=>unistr('Categor\00EDa')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FONT_CATEGORIES'
,p_lov=>'.'||wwv_flow_api.id(1362022415318990531.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Categor\00EDa -')
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>':P31_SHOW is null or :P31_SHOW in ( ''FONTAPEX'', ''FONTAWESOME'' )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la categor\00EDa Font Awesome.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00032
begin
wwv_flow_api.create_page(
 p_id=>32.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86483234935190648.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(134797710971304317.4001)
,p_plug_name=>'Crear Maestro/Detalle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(134931526483342807.4001)
,p_plug_name=>unistr('navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(42519297248600803.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42093844236457388.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(86483234935190648.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42094288903457389.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(86483234935190648.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(42094674440457389.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(86483234935190648.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42112292913457445.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(42094288903457389.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42112624051457445.4001)
,p_branch_name=>'Breadcrumb Selection'
,p_branch_action=>'f?p=&APP_ID.:32:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P32_BREADCRUMB_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42097063685457411.4001)
,p_name=>'P32_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P32_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina.<p />'),
'',
unistr('Si identifica un n\00FAmero de p\00E1gina existente, el asistente agrega el componente a esa p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42097997752457415.4001)
,p_name=>'P32_PAGE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42098845067457415.4001)
,p_name=>'P32_PAGE_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: la p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: la p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en la ventanilla, que permanece activa y centrada hasta que el usuario final la cierra')
||unistr('. La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42099701424457416.4001)
,p_name=>'P32_GROUP_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. '),
unistr('  Los grupos de p\00E1ginas ayudan a los desarrolladores a identificar y gestionar las p\00E1ginas en una aplicaci\00F3n.</p>'),
unistr('<p>Nota: Para crear grupos de p\00E1ginas, vaya a <strong>Utilidades: Grupos de p\00E1ginas</strong> en Utilidades espec\00EDficas de p\00E1gina en la barra lateral derecha.</p>'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42101574087457418.4001)
,p_name=>'P32_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42102423313457419.4001)
,p_name=>'P32_BREADCRUMB_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P32_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P32_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P32_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42102859746457420.4001)
,p_name=>'P32_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(134797710971304317.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P32_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(42105397708457433.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P32_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(42104549299457432.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(42104918078457432.4001)
,p_computation_sequence=>30
,p_computation_item=>'P32_PAGE_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_page_dev.get_page_mode(p_application_id => :FB_FLOW_ID, p_page_id => :P32_PAGE_ID);'
,p_compute_when=>'P32_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42106133338457434.4001)
,p_validation_name=>'Page Name Not Null'
,p_validation_sequence=>20
,p_validation=>'P32_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_validation_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and id = :P32_PAGE_ID'
,p_validation_condition_type=>'NOT_EXISTS'
,p_associated_item=>wwv_flow_api.id(42097997752457415.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'Only verify page names for new pages.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42106505059457435.4001)
,p_validation_name=>'P32_BREADCRUMB_NAME'
,p_validation_sequence=>30
,p_validation=>'P32_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P32_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(42094288903457389.4001)
,p_associated_item=>wwv_flow_api.id(42102859746457420.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42107302820457436.4001)
,p_validation_name=>'P32_PAGE_ID positive, whole number'
,p_validation_sequence=>70
,p_validation=>'trunc(abs(:P32_PAGE_ID)) = :P32_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P32_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(42094288903457389.4001)
,p_associated_item=>wwv_flow_api.id(42097063685457411.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42106906145457435.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P32_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P32_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(42094288903457389.4001)
,p_associated_item=>wwv_flow_api.id(42099701424457416.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(42107661735457436.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P32_BREADCRUMB_ID'
,p_condition_element=>'P32_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(42108194996457437.4001)
,p_event_id=>wwv_flow_api.id(42107661735457436.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P32_BREADCRUMB_PARENT_ID,P32_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(42108630135457438.4001)
,p_event_id=>wwv_flow_api.id(42107661735457436.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P32_BREADCRUMB_PARENT_ID,P32_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(42109081432457438.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(42093844236457388.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(42109563505457442.4001)
,p_event_id=>wwv_flow_api.id(42109081432457438.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(42109965510457442.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P32_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(42110459324457443.4001)
,p_event_id=>wwv_flow_api.id(42109965510457442.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P32_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P32_PAGE_NAME'
,p_attribute_07=>'P32_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(42110837079457443.4001)
,p_name=>'Page Exists'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P32_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(42111351620457444.4001)
,p_event_id=>wwv_flow_api.id(42110837079457443.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P32_PAGE_MODE,P32_GROUP_NAME,P32_PAGE_NAME,P32_BREADCRUMB_ID,P32_BREADCRUMB_PARENT_ID,P32_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_api.create_page(
 p_id=>33.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('P\00E1ginas de Aplicaci\00F3n')
,p_step_title=>unistr('P\00E1ginas de Aplicaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var facets = ["P33_LOCKED", "P33_GROUP", "P33_HAS_ALIAS", "P33_PAGE_MODE", ',
'              "P33_PAGE_IS_PUBLIC", "P33_CREATED_MONTH"],',
'    facetsVisible = false,',
'    region = apex.region("pageFacets"),',
'    btn$ = $("#showHideFacets"),',
'    btnLabels = btn$.text().split("|");',
'',
'function showHideFacets( visible ) {',
'    btn$.text( btnLabels[facetsVisible ? 1 : 0]);',
'    facets.forEach(function (f) {',
'        if ( visible ) {',
'            region.showFacet(f);',
'        } else {',
'            region.hideFacet(f);',
'        }',
'    });',
'}',
'',
'btn$.click(function() {',
'    facetsVisible = !facetsVisible;',
'    showHideFacets(facetsVisible);',
'});',
'showHideFacets(facetsVisible);'))
,p_inline_css=>'#showHideFacets { display: block; margin: 8px auto 16px auto;}'
,p_step_template=>wwv_flow_api.id(438185046231548086.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(390434885782898124.4001)
,p_plug_name=>'Facets Header'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(427665843253594857.4001)
,p_name=>unistr('P\00E1ginas de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P33 */',
'   p.id,',
'   p.flow_id the_flow,',
'   name page_name, ',
'   last_updated_on updated,',
'   to_char(created_on,''YYYY.MM'') created_month,',
'   nvl(l.locked_by,sm.unlocked) locked,',
'   nvl(g.group_name,sm.t_unassigned) group_name,',
'   decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''19'',sm.apex_map,',
'         ''20'',sm.apex_jstree,',
'         ''21'',sm.apex_ig,',
'         ''22'',sm.apex_faceted_search,',
'         sm.apex_unknown) page_type,',
'   p.page_mode,',
'     ALIAS,',
'     decode(alias,null,sm.t_no,sm.t_yes) has_alias,',
'     nvl((select name from wwv_flow_templates t where p.STEP_TEMPLATE = t.id),sm.apex_default) page_template,',
'     --',
'     nvl(case',
'     when p.required_role = ''MUST_NOT_BE_PUBLIC_USER'' then t_must_not_be_public_user',
'     else (select case when p.required_role like ''!%'' then ''{'' end||',
'                  max(name) ||',
'                  case when p.required_role like ''!%'' then ''}'' end',
'             from wwv_flow_security_schemes s ',
'            where s.flow_id = p.flow_id and to_char(s.id) = ltrim(p.REQUIRED_ROLE,''!''))',
'     end,sm.apex_NO_AUTHORIZATION_SCHEME) authorization_scheme,',
'     --',
'     nvl((select replace(patch_name,'':'',''-'')',
'      from WWV_FLOW_PATCHES bo',
'      where bo.id = p.REQUIRED_PATCH),''No build option'') build_option,',
'      --',
'     decode(PAGE_IS_PUBLIC_Y_N,',
'        ''Y'',sm.t_yes,',
'        ''N'',sm.t_no,',
'        PAGE_IS_PUBLIC_Y_N) PAGE_IS_PUBLIC,',
'     decode(protection_level,',
'        ''D'',sm.NO_URL_ACCESS,',
'        ''N'',sm.Unrestricted,',
'        ''U'',sm.no_arguments_allowed,',
'        ''C'',sm.arguments_must_have_checksum,',
'        sm.Unrestricted',
'        ) PROTECTION_LEVEL,',
'     decode(CACHE_MODE,',
'        ''NOCACHE'',sm.t_no,',
'        sm.t_yes)',
'        CACHE_PAGE,',
'     nvl(lower(last_updated_by),sm.apex_unknown) last_updated_by,',
'     nvl(lower(created_by),sm.apex_unknown) created_by',
'from  wwv_flow_steps p,',
'      WWV_FLOW_LOCK_PAGE l,',
'      (select ',
'           wwv_flow_lang.system_message(''LOCKED'') locked,',
'           wwv_flow_lang.system_message(''RUN'') run,',
'           wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'           wwv_flow_lang.system_message(''EDIT'') edit,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''LAYOUT.MAP'') apex_map,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_jstree,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'           wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') t_must_not_be_public_user,',
'           wwv_flow_lang.system_message(''REGION_NAME.NATIVE_IG'') apex_ig,',
'           wwv_flow_lang.system_message(''FACETED_SEARCH'')apex_faceted_search,',
'           wwv_flow_lang.system_message(''DEFAULT'')apex_default,',
'           wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'')apex_NO_AUTHORIZATION_SCHEME,',
'           wwv_flow_lang.system_message(''UNKNOWN'')apex_unknown',
'       from sys.dual)  sm,',
'      WWV_FLOW_PAGE_GROUPS g',
'where p.flow_id           = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id ',
'  and p.flow_id           = l.flow_id   (+)',
'  and p.id                = l.object_id (+) ',
'  and p.group_id          = g.id        (+)'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427667390167594883.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Identificador'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427667758364594890.4001)
,p_query_column_id=>2
,p_column_alias=>'THE_FLOW'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395886561955084623.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'#EDIT_PAGE_URL#'
,p_column_linktext=>'#PAGE_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427669300784594891.4001)
,p_query_column_id=>4
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>18
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395886776990084625.4001)
,p_query_column_id=>5
,p_column_alias=>'CREATED_MONTH'
,p_column_display_sequence=>17
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427671316119594894.4001)
,p_query_column_id=>6
,p_column_alias=>'LOCKED'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427672150554594895.4001)
,p_query_column_id=>7
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427672987174594897.4001)
,p_query_column_id=>8
,p_column_alias=>'PAGE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Tipo de P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427673335449594898.4001)
,p_query_column_id=>9
,p_column_alias=>'PAGE_MODE'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427674555198594899.4001)
,p_query_column_id=>10
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>9
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395886699744084624.4001)
,p_query_column_id=>11
,p_column_alias=>'HAS_ALIAS'
,p_column_display_sequence=>16
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427677729650594904.4001)
,p_query_column_id=>12
,p_column_alias=>'PAGE_TEMPLATE'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Plantilla de P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427678102341594904.4001)
,p_query_column_id=>13
,p_column_alias=>'AUTHORIZATION_SCHEME'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427678527195594905.4001)
,p_query_column_id=>14
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427680554813594915.4001)
,p_query_column_id=>15
,p_column_alias=>'PAGE_IS_PUBLIC'
,p_column_display_sequence=>13
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427680942409594918.4001)
,p_query_column_id=>16
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>14
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(427681721586594918.4001)
,p_query_column_id=>17
,p_column_alias=>'CACHE_PAGE'
,p_column_display_sequence=>15
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395887907733084637.4001)
,p_query_column_id=>18
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>19
,p_column_heading=>'Actualizado por'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395888154491084639.4001)
,p_query_column_id=>19
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>20
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(427665956719594857.4001)
,p_plug_name=>'Buscar'
,p_region_name=>'pageFacets'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(427665843253594857.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'N'
,p_attribute_13=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178182682696189933.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_button_name=>'SHOW_HIDE'
,p_button_static_id=>'showHideFacets'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Mostrar todo|Mostrar com\00FAn')
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(427666804632594870.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(390434885782898124.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:RR,33::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395886863972084626.4001)
,p_name=>'P33_LOCKED'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>'Bloqueado'
,p_source=>'LOCKED'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395886982278084627.4001)
,p_name=>'P33_GROUP'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_source=>'GROUP_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887002156084628.4001)
,p_name=>'P33_PAGE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('Tipo de P\00E1gina')
,p_source=>'PAGE_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887195142084629.4001)
,p_name=>'P33_HAS_ALIAS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>'Tiene alias'
,p_source=>'HAS_ALIAS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887249730084630.4001)
,p_name=>'P33_PAGE_MODE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>'Modo'
,p_source=>'PAGE_MODE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887305834084631.4001)
,p_name=>'P33_PAGE_IS_PUBLIC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('Es P\00FAblico')
,p_source=>'PAGE_IS_PUBLIC'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887401867084632.4001)
,p_name=>'P33_PAGE_TEMPLATE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>'Plantilla'
,p_source=>'PAGE_TEMPLATE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887541206084633.4001)
,p_name=>'P33_AUTHORIZATION_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('Autorizaci\00F3n')
,p_source=>'AUTHORIZATION_SCHEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887674127084634.4001)
,p_name=>'P33_BUILD_OPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'BUILD_OPTION'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395887873039084636.4001)
,p_name=>'P33_CREATED_MONTH'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('Mes de creaci\00F3n')
,p_source=>'CREATED_MONTH'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395888013399084638.4001)
,p_name=>'P33_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>unistr('\00DAltima Actualizaci\00F3n por')
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(395888242759084640.4001)
,p_name=>'P33_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>'Creado por'
,p_source=>'CREATED_BY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(427666437262594869.4001)
,p_name=>'P33_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(427665956719594857.4001)
,p_prompt=>'Buscar'
,p_source=>'NAME,TAB_SET,ICON_TEXT,LAST_UPDATED_BY,CREATED_BY,ACTIONS,LOCKED,LOCKED_LINK,GROUP_NAME,GROUP_LINK,PAGE_TYPE,PAGE_MODE,PAGE_TYPE_CLASS,EDIT_PAGE_URL,ALIAS,PAGE_TITLE,FIRST_ITEM,INCLUDE_APEX_CSS_JS,FOOTER_TEXT,HEADER_TEXT,PAGE_TEMPLATE,AUTHORIZATION_S'
||'CHEME,BUILD_OPTION,HTML_PAGE_ONLOAD,ALLOW_DUPLICATE_SUBMISSIONS,ON_DUP_SUBMISSION_GOTO_URL,PAGE_IS_PUBLIC,PROTECTION_LEVEL,ERROR_NOTIFICATION_TEXT,CACHE_PAGE,PAGE_COMMENT,EDIT'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_show_chart=>false
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_api.create_page(
 p_id=>34.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Estado de la Sesi\00F3n')
,p_step_title=>unistr('Estado de la Sesi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213427413171456110)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'concept_ses_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720811677650848.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(77549119545304597.4001)
,p_name=>unistr('Elementos de P\00E1gina')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id       flow,',
'       page_id              page,',
'       item_name            name,',
'       item_prompt          prompt,',
'       item_display_as      display_as,',
'       data_item_id         id,',
'       item_value_decrypted item_value,',
'       session_state_status,',
'       is_encrypted         encrypted',
'  from wwv_flow_data_view',
' where session_id        = :F4000_P34_SESSION',
'   and application_id    = :f4000_p34_flow',
'   and security_group_id = :flow_security_group_id',
'   and page_id           = :f4000_p34_page',
'   and (   :P34_FIND is null',
'        or instr(item_name,upper(:P34_FIND)) > 0',
'        or instr(upper(item_value),upper(:P34_FIND)) > 0)'))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'P:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' '
,p_query_no_data_found=>unistr('La p\00E1gina no tiene ning\00FAn elemento. ')
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'July-10-2003: Added this region to use SQL QUERY instead of PL/SQL block.'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77549528962304616.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_column_css_class=>'instructiontext'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77549619255304618.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77549704980304618.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77549819529304618.4001)
,p_query_column_id=>4
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77549925620304618.4001)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Mostrar'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29353308376249352)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77550008482304618.4001)
,p_query_column_id=>6
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77778013919022076.4001)
,p_query_column_id=>7
,p_column_alias=>'ITEM_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Valor de Elemento'
,p_column_hit_highlight=>'&P34_FIND.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77680223403778203.4001)
,p_query_column_id=>8
,p_column_alias=>'SESSION_STATE_STATUS'
,p_column_display_sequence=>8
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15256524524201747.4001)
,p_query_column_id=>9
,p_column_alias=>'ENCRYPTED'
,p_column_display_sequence=>9
,p_column_heading=>'Cifrado'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(77898026254716368.4001)
,p_name=>'Application Environment'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :F4000_P34_SESSION flow_session,',
'       :F4000_P34_USER flow_user,',
'       :flow_security_group_id flow_security_group_id,',
'       :browser_language browser_language',
' from dual'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' '
,p_query_break_cols=>'0'
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'July-10-2003: Added this region to use SQL QUERY instead of PL/SQL block.'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77901015996722940.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_SESSION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Sesi\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77901117677722947.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_USER'
,p_column_display_sequence=>2
,p_column_heading=>'Usuario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77901220077722947.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_SECURITY_GROUP_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Espacio de Trabajo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77901322766722947.4001)
,p_query_column_id=>4
,p_column_alias=>'BROWSER_LANGUAGE'
,p_column_display_sequence=>4
,p_column_heading=>'Idioma del Explorador'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(77908104484738534.4001)
,p_name=>unistr('Estado de la Sesi\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id  flow_id,',
'       page_id         flow_step_id,',
'       item_name       name,',
'       item_value      item_Val,',
'       item_display_as disp,',
'       item_prompt,',
'       data_item_id,',
'       is_encrypted    encrypted',
'  from wwv_flow_data_view',
' where session_id = :F4000_P34_SESSION',
'   and security_group_id = :flow_security_group_id',
'   and (application_id = :F4000_P34_FLOW or item_scope = ''GLOBAL'')',
'   and (   :P34_FIND is null',
'       or instr(item_name,upper(:P34_FIND)) > 0',
'       or instr(upper(item_value),upper(:P34_FIND)) > 0)',
' order by 1,2,3'))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'S:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' '
,p_query_no_data_found=>unistr('Ning\00FAn elemento de estado de sesi\00F3n.')
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'July-10-2003: Added this region to use SQL QUERY instead of PL/SQL block.'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77908719748738543.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77908803379738543.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77908917456738544.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77923009388844042.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_VAL'
,p_column_display_sequence=>4
,p_column_heading=>'Valor de Elemento'
,p_column_hit_highlight=>'&P34_FIND.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77922415144836261.4001)
,p_query_column_id=>5
,p_column_alias=>'DISP'
,p_column_display_sequence=>5
,p_column_heading=>'Mostrar'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29544521926748713)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(77923419777847040.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_PROMPT'
,p_column_display_sequence=>6
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(217301406366276681.4001)
,p_query_column_id=>7
,p_column_alias=>'DATA_ITEM_ID'
,p_column_display_sequence=>8
,p_column_heading=>'Identificador de Elemento de Datos'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15257118075209375.4001)
,p_query_column_id=>8
,p_column_alias=>'ENCRYPTED'
,p_column_display_sequence=>7
,p_column_heading=>'Cifrado'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(163722811206966904.4001)
,p_name=>unistr('Elementos de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id flow,',
'       item_name,',
'       item_value',
'  from wwv_flow_data_view',
' where session_id        = :F4000_P34_SESSION',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and (application_id   = :F4000_P34_FLOW or application_id is null)',
'   and item_scope in (''APP'',''GLOBAL'')',
'   and (   :P34_FIND is null',
'        or instr(item_name,upper(:P34_FIND))         > 0',
'        or instr(upper(item_value),upper(:P34_FIND)) > 0)'))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'I:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(163723113316966914.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(217263027532962986.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Elemento'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3704929527307.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Valor de Elemento'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(243294006587845793.4001)
,p_plug_name=>'Recopilaciones'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>80
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    c.collection_name, m.seq_id, ',
'    m.c001, m.c002, m.c003, m.c004, m.c005, m.c006, m.c007, ',
'    m.c008, m.c009, m.c010, m.c011, m.c012, m.c013, m.c014,',
'    m.c015, m.c016, m.c017, m.c018, m.c019, m.c020, m.c021,',
'    m.c022, m.c023, m.c024, m.c025, m.c026, m.c027, m.c028,',
'    m.c029, m.c030, m.c031, m.c032, m.c033, m.c034, m.c035,',
'    m.c036, m.c037, m.c038, m.c039, m.c040, m.c041, m.c042,',
'    m.c043, m.c044, m.c045, m.c046, m.c047, m.c048, m.c049,',
'    m.c050, m.n001, m.n002, m.n003, m.n004,',
'    m.n005, m.d001, m.d002, m.d003, m.d004, m.d005, ',
'    sys.dbms_lob.substr(m.clob001,500,1) clob001, ',
'    case when xmltype001 is null then null else sys.dbms_lob.substr(extract(xmltype001,''*'').getclobval(),500,1) || ''...'' end xmltype001,',
'm.md5_original ',
'from wwv_flow_collections$ c, ',
'     wwv_flow_collection_members$ m ',
'where c.session_id = :F4000_P34_SESSION',
'        and c.security_group_id = :flow_security_group_id',
'        and c.id = m.collection_id ',
'        and c.flow_id = :fb_flow_id and',
'       (:P34_FIND is null or ',
'        instr(upper(c.collection_name),upper(:P34_FIND)) > 0)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P34_VIEW'
,p_plug_display_when_cond2=>'C:A'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(243294104975845793.4001)
,p_name=>'Collections'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de #MAX_ROW_COUNT# filas; filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294327893845805.4001)
,p_db_column_name=>'COLLECTION_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Nombre de la Recopilaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294422127845812.4001)
,p_db_column_name=>'SEQ_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294519172845812.4001)
,p_db_column_name=>'C001'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'C001'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294601176845812.4001)
,p_db_column_name=>'C002'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'C002'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294731145845812.4001)
,p_db_column_name=>'C003'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'C003'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294809175845812.4001)
,p_db_column_name=>'C004'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'C004'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243294910660845813.4001)
,p_db_column_name=>'C005'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'C005'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295003743845813.4001)
,p_db_column_name=>'C006'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'C006'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295111869845813.4001)
,p_db_column_name=>'C007'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'C007'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295213287845813.4001)
,p_db_column_name=>'C008'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'C008'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295328081845813.4001)
,p_db_column_name=>'C009'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'C009'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295406510845813.4001)
,p_db_column_name=>'C010'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'C010'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295517956845813.4001)
,p_db_column_name=>'C011'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'C011'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295623806845813.4001)
,p_db_column_name=>'C012'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'C012'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295703683845813.4001)
,p_db_column_name=>'C013'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'C013'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295805033845813.4001)
,p_db_column_name=>'C014'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'C014'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243295926447845813.4001)
,p_db_column_name=>'C015'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'C015'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296013885845814.4001)
,p_db_column_name=>'C016'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'C016'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296114134845814.4001)
,p_db_column_name=>'C017'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'C017'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296222613845814.4001)
,p_db_column_name=>'C018'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'C018'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296306146845814.4001)
,p_db_column_name=>'C019'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'C019'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296417367845814.4001)
,p_db_column_name=>'C020'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'C020'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296507042845815.4001)
,p_db_column_name=>'C021'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'C021'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296619652845815.4001)
,p_db_column_name=>'C022'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'C022'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296722552845815.4001)
,p_db_column_name=>'C023'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'C023'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296822938845815.4001)
,p_db_column_name=>'C024'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'C024'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243296901401845815.4001)
,p_db_column_name=>'C025'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'C025'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297017091845815.4001)
,p_db_column_name=>'C026'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'C026'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297123610845815.4001)
,p_db_column_name=>'C027'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'C027'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297224510845815.4001)
,p_db_column_name=>'C028'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'C028'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297315457845816.4001)
,p_db_column_name=>'C029'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'C029'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297427399845816.4001)
,p_db_column_name=>'C030'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'C030'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297509787845816.4001)
,p_db_column_name=>'C031'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'C031'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297626094845816.4001)
,p_db_column_name=>'C032'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'C032'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297707700845816.4001)
,p_db_column_name=>'C033'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'C033'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297825557845816.4001)
,p_db_column_name=>'C034'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'C034'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243297930390845816.4001)
,p_db_column_name=>'C035'
,p_display_order=>37
,p_column_identifier=>'AK'
,p_column_label=>'C035'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298012437845817.4001)
,p_db_column_name=>'C036'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'C036'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298101973845817.4001)
,p_db_column_name=>'C037'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'C037'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298212273845817.4001)
,p_db_column_name=>'C038'
,p_display_order=>40
,p_column_identifier=>'AN'
,p_column_label=>'C038'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298321482845817.4001)
,p_db_column_name=>'C039'
,p_display_order=>41
,p_column_identifier=>'AO'
,p_column_label=>'C039'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298411370845817.4001)
,p_db_column_name=>'C040'
,p_display_order=>42
,p_column_identifier=>'AP'
,p_column_label=>'C040'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298527060845817.4001)
,p_db_column_name=>'C041'
,p_display_order=>43
,p_column_identifier=>'AQ'
,p_column_label=>'C041'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298608650845817.4001)
,p_db_column_name=>'C042'
,p_display_order=>44
,p_column_identifier=>'AR'
,p_column_label=>'C042'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298708661845817.4001)
,p_db_column_name=>'C043'
,p_display_order=>45
,p_column_identifier=>'AS'
,p_column_label=>'C043'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298829758845817.4001)
,p_db_column_name=>'C044'
,p_display_order=>46
,p_column_identifier=>'AT'
,p_column_label=>'C044'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243298908965845817.4001)
,p_db_column_name=>'C045'
,p_display_order=>47
,p_column_identifier=>'AU'
,p_column_label=>'C045'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299001764845817.4001)
,p_db_column_name=>'C046'
,p_display_order=>48
,p_column_identifier=>'AV'
,p_column_label=>'C046'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299101936845817.4001)
,p_db_column_name=>'C047'
,p_display_order=>49
,p_column_identifier=>'AW'
,p_column_label=>'C047'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299221765845817.4001)
,p_db_column_name=>'C048'
,p_display_order=>50
,p_column_identifier=>'AX'
,p_column_label=>'C048'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299332668845817.4001)
,p_db_column_name=>'C049'
,p_display_order=>51
,p_column_identifier=>'AY'
,p_column_label=>'C049'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299408069845817.4001)
,p_db_column_name=>'C050'
,p_display_order=>52
,p_column_identifier=>'AZ'
,p_column_label=>'C050'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299507658845817.4001)
,p_db_column_name=>'N001'
,p_display_order=>53
,p_column_identifier=>'BA'
,p_column_label=>'N001'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299631780845817.4001)
,p_db_column_name=>'N002'
,p_display_order=>54
,p_column_identifier=>'BB'
,p_column_label=>'N002'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299730252845817.4001)
,p_db_column_name=>'N003'
,p_display_order=>55
,p_column_identifier=>'BC'
,p_column_label=>'N003'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299811939845819.4001)
,p_db_column_name=>'N004'
,p_display_order=>56
,p_column_identifier=>'BD'
,p_column_label=>'N004'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243299909032845819.4001)
,p_db_column_name=>'N005'
,p_display_order=>57
,p_column_identifier=>'BE'
,p_column_label=>'N005'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300015354845819.4001)
,p_db_column_name=>'D001'
,p_display_order=>58
,p_column_identifier=>'BF'
,p_column_label=>'D001'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300100289845819.4001)
,p_db_column_name=>'D002'
,p_display_order=>59
,p_column_identifier=>'BG'
,p_column_label=>'D002'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300211790845819.4001)
,p_db_column_name=>'D003'
,p_display_order=>60
,p_column_identifier=>'BH'
,p_column_label=>'D003'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300312477845819.4001)
,p_db_column_name=>'D004'
,p_display_order=>61
,p_column_identifier=>'BI'
,p_column_label=>'D004'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300404785845819.4001)
,p_db_column_name=>'D005'
,p_display_order=>62
,p_column_identifier=>'BJ'
,p_column_label=>'D005'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300511996845820.4001)
,p_db_column_name=>'CLOB001'
,p_display_order=>63
,p_column_identifier=>'BK'
,p_column_label=>'CLOB001'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300629402845820.4001)
,p_db_column_name=>'XMLTYPE001'
,p_display_order=>64
,p_column_identifier=>'BL'
,p_column_label=>'XMLTYPE001'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
end;
/
begin
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(243300711365845820.4001)
,p_db_column_name=>'MD5_ORIGINAL'
,p_display_order=>65
,p_column_identifier=>'BM'
,p_column_label=>'MD5_ORIGINAL'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451400804130085872.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(483665625206265911.4001)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_help_link (',
'   p_lang           => ''en'',',
'   p_session_id     => :app_session,',
'   p_application_id => 4000,',
'   p_page_id        => wwv_flow.g_flow_step_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(719111677573587.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_button_name=>'F4000_P34_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(719311677576698.4001)
,p_branch_action=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::F4000_P34_SESSION,F4000_P34_PAGE,F4000_P34_FLOW:&F4000_P34_SESSION.,&F4000_P34_PAGE.,&F4000_P34_FLOW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(718511677506223.4001)
,p_name=>'F4000_P34_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Para buscar una p\00E1gina, introduzca el n\00FAmero de p\00E1gina y haga clic en <strong>Definir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(721411677695023.4001)
,p_name=>'F4000_P34_FLOW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(77898026254716368.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el nombre de la aplicaci\00F3n, el identificador de sesi\00F3n, el usuario actual, el identificador de espacio de trabajo y el idioma del explorador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(725311677988291.4001)
,p_name=>'F4000_P34_SESSION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68360718344072070.4001)
,p_name=>'F4000_P34_USER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'select username from wwv_flow_sessions$ where id=:F4000_P34_SESSION'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(116334620243331046.4001)
,p_name=>'P34_FIND'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Definir</strong>. Se utilizar\00E1 para buscar el nombre y el valor del elemento o el nombre de la recopilaci\00F3n (seg\00FAn la vista). ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201433822925950722.4001)
,p_name=>'P34_ROWS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_item_default=>'50'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de elementos que desea mostrar y haga clic en <strong>Definir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201438430806971908.4001)
,p_name=>'P34_VIEW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(720811677650848.4001)
,p_item_default=>'P'
,p_prompt=>'Ver'
,p_source=>'P'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION STATE VIEW OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(201460728952037663.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el informe de estado de sesi\00F3n que desea visualizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(72929729404680409.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P34_SESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:F4000_P34_SESSION)'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72930309449684133.4001)
,p_validation_name=>'session numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P34_SESSION'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El identificador de sesi\00F3n debe ser num\00E9rico.')
,p_associated_item=>wwv_flow_api.id(725311677988291.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240742516161971580.4001)
,p_validation_name=>'page numeric'
,p_validation_sequence=>20
,p_validation=>'F4000_P34_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La p\00E1gina debe ser un n\00FAmero.')
,p_validation_condition=>'GO'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(718511677506223.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216992649250910232.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session number;',
'begin',
'    if :F4000_P34_SESSION is not null then',
'        select id',
'          into l_session',
'          from wwv_flow_sessions$',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and id                = :F4000_P34_SESSION;',
'    end if;',
'exception when no_data_found then',
'    wwv_flow_error.raise_internal_error (',
'        p_error_code => ''APEX.SESSION.EXPIRED'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201458301248029637.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(719111677573587.4001)
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_api.create_page(
 p_id=>37.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Informes Interactivos Guardados'
,p_step_title=>'Informes Interactivos Guardados'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30303226880414948.4001)
,p_plug_name=>'Informes Guardados'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(1, r.id,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'                           wwv_flow_lang.system_message(''REPORT_LABEL'',wwv_flow_escape.html(r.name))',
'                          )',
'end id,',
'i.page_id npage_id,',
'i.region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    sm.primary_rpt',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       r.application_user) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt',
' from dual) sm',
'where r.worksheet_id = i.id',
'and r.websheet_id is null',
'and r.session_id is null',
'and r.security_group_id = :flow_security_group_id',
'and i.flow_id = :fb_flow_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30303327946414950.4001)
,p_name=>'Saved Reports'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn informe guardado.')
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>30303327946414950
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30303526233414986.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30303722914414986.4001)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=4000:4500:&SESSION.::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30303821823414986.4001)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Identificador de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30303906070414986.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Nombre de la Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30304016299414986.4001)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Tipo de Informe'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30304122522414987.4001)
,p_db_column_name=>'NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Nombre del Informe'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30304206177414987.4001)
,p_db_column_name=>'OWNER'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Propietario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30304306872414987.4001)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30304426408414987.4001)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Alias de Informe'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30324714693282004.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30303226880414948.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30324929238286111.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(30303226880414948.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_worksheets i, wwv_flow_worksheet_rpts r',
'where i.id = r.worksheet_id',
'and i.security_group_id = :flow_security_group_id',
'and i.flow_id = :fb_flow_id',
'and r.session_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30325900893339192.4001)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30325532608309216.4001)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionarse un informe que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(30324929238286111.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199172901973878405.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(30303226880414948.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199173020724878406.4001)
,p_event_id=>wwv_flow_api.id(1199172901973878405.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30325609245337109.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select id report_id, worksheet_id, application_user, is_default, report_type',
'               from wwv_flow_worksheet_rpts',
'               where id = wwv_flow.g_f01(i)',
'               and security_group_id=:flow_security_group_id',
'               and flow_id = :fb_flow_id)',
'    loop                ',
'        wwv_flow_worksheet_api.delete_saved_report (            ',
'            p_worksheet_id      => c1.worksheet_id,               ',
'            p_report_id         => c1.report_id,',
'            p_is_default        => c1.is_default);        ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir el informe.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30324929238286111.4001)
,p_process_success_message=>'Se han eliminado los informes.'
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_api.create_page(
 p_id=>38.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cambiar Secuencia de Scripts de Actualizaci\00F3n')
,p_step_title=>unistr('Cambiar Secuencia de Scripts de Actualizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_def_common.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(380040721789746578.4001)
,p_plug_name=>'Cambiar Secuencia'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>unistr('<p>Cambie la secuencia de los scripts de actualizaci\00F3n mediante el incremento en 10 de los n\00FAmeros de secuencia.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1080990639647523939.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(380041184606746588.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1080990639647523939.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Secuencia'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(380040933054746581.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1080990639647523939.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(380042328067746625.4001)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(380042053236746621.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Resequence upgrade scripts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number := 0;',
'begin',
'  for c1 in (',
'    select id, sequence',
'    from wwv_flow_install_scripts',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'    order by sequence)',
'  loop',
'    s := s + 10;',
'    update wwv_flow_install_scripts',
'    set sequence = s',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id ',
'    and id = c1.id',
'    and sequence != s;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(380041184606746588.4001)
,p_process_success_message=>unistr('Se ha cambiado la secuencia de los scripts de actualizaci\00F3n.')
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_api.create_page(
 p_id=>39.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suscripciones'
,p_step_title=>'Suscripciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30639114984365858.4001)
,p_plug_name=>'Suscripciones'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'wwv_flow_item.checkbox(1, n.id, null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''IR_SUBSCRIPTION_LABEL'',i.flow_id,i.page_id,n.owner)) id,',
'i.page_id npage_id,',
'region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'n.session_id,',
'n.owner    application_user,',
'n.language language,',
'decode(n.download_format,',
'    ''XLSX'',''Excel'',',
'    n.download_format) download_format,',
'decode(n.strip_rich_text,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) strip_rich_text,',
'decode(n.data_only,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no,',
'    m.m_no) data_only,',
'decode(n.pdf_page_size,',
'    ''A3'',m.m_a3,',
'    ''A4'',m.m_a4,',
'    ''LEGAL'',m.m_legal,',
'    ''LETTER'',m.m_letter,',
'    ''CUSTOM'',m.m_custom,',
'    ''TABLOID'',m.m_tabloid,',
'    pdf_page_size) pdf_page_size,',
'decode(n.pdf_page_orientation,',
'    ''VERTICAL'',m.m_vertical,',
'    ''HORIZONTAL'',m.m_horizontal,',
'    pdf_page_orientation) pdf_page_orientation,',
'decode(n.pdf_accessible,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) pdf_accessible,',
'decode(n.skip_no_data_found,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) skip_no_data_found,',
'n.start_date at time zone sessiontimezone start_date,',
'n.end_date at time zone sessiontimezone end_date,',
'case when nvl(n.end_date,systimestamp) >= systimestamp then',
'    n.offset_date',
'end offset_date,',
'n.notify_interval notify_interval,',
'n.status,',
'n.notify_error,',
'n.email_from,',
'n.email_address,',
'n.email_subject,',
'n.created_by,',
'n.created_on',
'from wwv_flow_worksheet_notify n,',
'wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_VERTICAL'') m_vertical,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_HORIZONTAL'') m_horizontal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A3'') m_a3,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A4'') m_a4,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LEGAL'') m_legal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LETTER'') m_letter,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_CUSTOM'') m_custom,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_TABLOID'') m_tabloid',
'from dual) m',
'where n.worksheet_id = i.id',
'and n.report_id = r.id',
'and n.websheet_id is null',
'and n.security_group_id = :flow_security_group_id',
'and i.flow_id = :fb_flow_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30639312830365860.4001)
,p_name=>'Saved Reports'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>unistr('No se ha encontrado ninguna suscripci\00F3n.')
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:EMAIL'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>30639312830365860
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30639415394365869.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30639512230365871.4001)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=4000:4500:&SESSION.::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30639624413365871.4001)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Identificador de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30639726708365871.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170215980944860901.4001)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>15
,p_column_identifier=>'S'
,p_column_label=>unistr('Sesi\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642123922422753.4001)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>25
,p_column_identifier=>'G'
,p_column_label=>unistr('Suscripci\00F3n por')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642232486422753.4001)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>35
,p_column_identifier=>'H'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642300481422753.4001)
,p_db_column_name=>'START_DATE'
,p_display_order=>45
,p_column_identifier=>'I'
,p_column_label=>'Fecha de Inicio'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642411525422754.4001)
,p_db_column_name=>'END_DATE'
,p_display_order=>55
,p_column_identifier=>'J'
,p_column_label=>unistr('Fecha de Finalizaci\00F3n')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642508608422754.4001)
,p_db_column_name=>'OFFSET_DATE'
,p_display_order=>65
,p_column_identifier=>'K'
,p_column_label=>'Fecha de Desplazamiento'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642628163422754.4001)
,p_db_column_name=>'NOTIFY_INTERVAL'
,p_display_order=>75
,p_column_identifier=>'L'
,p_column_label=>'Frecuencia'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(30663301353708410)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642721569422754.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>85
,p_column_identifier=>'M'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(30664415898712648)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642830411422755.4001)
,p_db_column_name=>'NOTIFY_ERROR'
,p_display_order=>95
,p_column_identifier=>'N'
,p_column_label=>'Mensaje de Error'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30642927635422755.4001)
,p_db_column_name=>'EMAIL_FROM'
,p_display_order=>105
,p_column_identifier=>'O'
,p_column_label=>unistr('Correo Electr\00F3nico De')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30643029636422755.4001)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>115
,p_column_identifier=>'P'
,p_column_label=>unistr('Correo Electr\00F3nico Para')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(170216061811860902.4001)
,p_db_column_name=>'EMAIL_SUBJECT'
,p_display_order=>125
,p_column_identifier=>'T'
,p_column_label=>unistr('Asunto de correo electr\00F3nico')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30643122722422755.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30643222015422755.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801378576307211.4001)
,p_db_column_name=>'DOWNLOAD_FORMAT'
,p_display_order=>155
,p_column_identifier=>'U'
,p_column_label=>'Formato'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801481928307212.4001)
,p_db_column_name=>'STRIP_RICH_TEXT'
,p_display_order=>165
,p_column_identifier=>'V'
,p_column_label=>'Borrar texto enriquecido'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801547111307213.4001)
,p_db_column_name=>'DATA_ONLY'
,p_display_order=>175
,p_column_identifier=>'W'
,p_column_label=>unistr('S\00F3lo Datos')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801678518307214.4001)
,p_db_column_name=>'PDF_PAGE_SIZE'
,p_display_order=>185
,p_column_identifier=>'X'
,p_column_label=>unistr('Tama\00F1o de p\00E1gina de PDF')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801716487307215.4001)
,p_db_column_name=>'PDF_PAGE_ORIENTATION'
,p_display_order=>195
,p_column_identifier=>'Y'
,p_column_label=>unistr('Orientaci\00F3n de p\00E1gina de PDF')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3801860859307216.4001)
,p_db_column_name=>'PDF_ACCESSIBLE'
,p_display_order=>205
,p_column_identifier=>'Z'
,p_column_label=>'PDF accesible'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4162648286589921.4001)
,p_db_column_name=>'SKIP_NO_DATA_FOUND'
,p_display_order=>215
,p_column_identifier=>'AA'
,p_column_label=>'Omitir si no se encuentran datos'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30638505571365853.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30639114984365858.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30638732721365856.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(30639114984365858.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'where n.worksheet_id = w.id',
'and w.flow_id = :fb_flow_id',
'and n.security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30643806733439663.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(30639114984365858.4001)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Todo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'where n.worksheet_id = w.id',
'and w.flow_id = :fb_flow_id',
'and n.security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30641511796365894.4001)
,p_branch_action=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30641102324365888.4001)
,p_validation_name=>'must select subscription to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar la suscripci\00F3n que desea suprimir.')
,p_when_button_pressed=>wwv_flow_api.id(30638732721365856.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199173149398878407.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(30639114984365858.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199173284957878408.4001)
,p_event_id=>wwv_flow_api.id(1199173149398878407.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30641204591365889.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select n.id,',
'                  n.worksheet_id,',
'                  n.report_id,',
'                  n.created_by',
'               from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'               where n.worksheet_id = w.id',
'               and w.flow_id = :fb_flow_id',
'               and n.security_group_id = :flow_security_group_id',
'               and n.id = wwv_flow.g_f01(i))           ',
'    loop',
'        wwv_flow_worksheet_api.delete_notify (',
'            p_worksheet_id    => c1.worksheet_id,',
'            p_app_user        => c1.created_by,',
'            p_report_id       => c1.report_id,',
'            p_notify_id       => c1.id);',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido suprimir las suscripciones.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30638732721365856.4001)
,p_process_success_message=>'Se han suprimido las suscripciones.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30671321102789866.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete all'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select n.id,',
'                  n.worksheet_id,',
'                  n.report_id,',
'                  n.created_by',
'           from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'           where n.worksheet_id = w.id',
'           and w.flow_id = :fb_flow_id',
'           and n.security_group_id = :flow_security_group_id)           ',
'loop',
'    wwv_flow_worksheet_api.delete_notify (',
'        p_worksheet_id    => c1.worksheet_id,',
'        p_app_user        => c1.created_by,',
'        p_report_id       => c1.report_id,',
'        p_notify_id       => c1.id);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido suprimir las suscripciones.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30643806733439663.4001)
,p_process_success_message=>unistr('Se han suprimido todas las suscripciones de la aplicaci\00F3n actual.')
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_api.create_page(
 p_id=>40.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
,p_step_title=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215592520464926917)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_file_upload.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48117108751266087.4001)
,p_plug_name=>'Archivos'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, wwv_flow_escape.html(id)) cb,',
'       id,',
'       security_group_id,',
'       null as icon,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       round( sys.dbms_lob.getLength(file_content) / 1024 / 1024, 2 )  as file_size_in_mb,',
'       file_charset,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'            p_scope     => ''APP'',',
'            p_app_id    => :FB_FLOW_ID,',
'            p_file_name => file_name ) as reference,',
'       case when file_ext in (''html'', ''js'', ''css'', ''json'', ''xml'') then ''icon-file-'' || file_ext',
'            when lower(mime_type) like ''image/%'' then ''icon-ws-image''',
'            else ''icon-sc-file''',
'       end as icon_class,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_ID,P118_SCOPE,P118_APP_ID'',',
'           p_values      => id || '',APP,'' || flow_id',
'        ) as edit_link,',
'       last_updated_on          as updated,',
'       lower(last_updated_by)   as updated_by,',
'       created_on               as created,',
'       lower(created_by)        as created_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_static_files f)',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48117227188266087.4001)
,p_name=>'Files'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn archivo de aplicaci\00F3n est\00E1tico.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#EDIT_LINK#" class="a-IRR-icon">',
'    <span class="a-Icon #ICON_CLASS#"></span>',
'    <span class="a-IRR-iconName">#FILE_NAME#</span>',
'</a>'))
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48117426988266089.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3566931599979611.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>11
,p_column_identifier=>'Z'
,p_column_label=>'Identificador de Grupo de Seguridad'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4904498771807742.4001)
,p_db_column_name=>'CB'
,p_display_order=>21
,p_column_identifier=>'AA'
,p_column_label=>'&nbsp;'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21698888312753940.4001)
,p_db_column_name=>'ICON'
,p_display_order=>31
,p_column_identifier=>'Y'
,p_column_label=>'&nbsp;'
,p_column_html_expression=>'<span class="a-Icon #ICON_CLASS#" aria-hidden="true"></span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26449719289558522.4001)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>41
,p_column_identifier=>'D'
,p_column_label=>'Nombre'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48117621656266090.4001)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>51
,p_column_identifier=>'C'
,p_column_label=>'Tipo MIME'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26449825965558526.4001)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>61
,p_column_identifier=>'E'
,p_column_label=>unistr('Tama\00F1o')
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30211109671089156.4001)
,p_db_column_name=>'FILE_CHARSET'
,p_display_order=>71
,p_column_identifier=>'J'
,p_column_label=>'Juego de Caracteres de Archivo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(144796827445692396)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26449918105558526.4001)
,p_db_column_name=>'FILE_CONTENT'
,p_display_order=>81
,p_column_identifier=>'F'
,p_column_label=>'Archivo'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_STATIC_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME::FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(261792125788022050.4001)
,p_db_column_name=>'REFERENCE'
,p_display_order=>91
,p_column_identifier=>'K'
,p_column_label=>'Referencia'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656775043555444485.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>101
,p_column_identifier=>'L'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(361062077292469305.4001)
,p_db_column_name=>'FILE_SIZE_IN_MB'
,p_display_order=>111
,p_column_identifier=>'N'
,p_column_label=>unistr('Tama\00F1o de archivo en MB')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4502499052515822.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>121
,p_column_identifier=>'O'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21696862494753920.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>131
,p_column_identifier=>'U'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21696962494753921.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>141
,p_column_identifier=>'V'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21697046647753922.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>151
,p_column_identifier=>'W'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21697167987753923.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>161
,p_column_identifier=>'X'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61358313623209746.4001)
,p_plug_name=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los archivos de aplicaci\00F3n est\00E1ticos solo est\00E1n disponibles en la aplicaci\00F3n actual. Utilice <code><strong>&#35;APP_FILES#</strong></code> en la aplicaci\00F3n para hacer referencia a un archivo.</p>'),
'',
unistr('<p>Utilice esta p\00E1gina para crear, editar y suprimir archivos est\00E1ticos.</p>'),
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-static-application-files.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188934631091807160.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48117108751266087.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:40,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4904572338807743.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48117108751266087.4001)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29769008715122829.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48117108751266087.4001)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Todo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30092611793871223.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(48117108751266087.4001)
,p_button_name=>'DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar como Zip'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61586311331473472.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(48117108751266087.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Archivo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE,P118_APP_ID:APP,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29786806302194308.4001)
,p_branch_name=>'Reset Pagination after delete all'
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(29769008715122829.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4904668099807744.4001)
,p_name=>'Delete Checked'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4904572338807743.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4904708140807745.4001)
,p_event_id=>wwv_flow_api.id(4904668099807744.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los archivos seleccionados?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4904833481807746.4001)
,p_event_id=>wwv_flow_api.id(4904668099807744.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_CHECKED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(29769822483145737.4001)
,p_name=>'Delete All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(29769008715122829.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29770105437145744.4001)
,p_event_id=>wwv_flow_api.id(29769822483145737.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los archivos?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29770331344152238.4001)
,p_event_id=>wwv_flow_api.id(29769822483145737.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4904919441807747.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1 .. wwv_flow.g_f01.count loop',
'   wwv_flow_file_editor_dev.delete_file (',
'       p_id     => wwv_flow.g_f01(i),',
'       p_scope  => ''APP'',',
'       p_app_id => :FB_FLOW_ID );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4904572338807743.4001)
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29770407854160432.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(29769008715122829.4001)
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30816415335489937.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'PLUGIN_COM.ORACLE.APEX.DOWNLOAD_AS_ZIP'
,p_process_name=>'Download as Zip'
,p_attribute_01=>'f&FB_FLOW_ID._static_application_files.zip'
,p_attribute_02=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name,',
'       file_content',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30092611793871223.4001)
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_api.create_page(
 p_id=>41.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de M\00E9todos Abreviados')
,p_step_title=>unistr('Historial de M\00E9todos Abreviados')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10984427931377806.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(186543329326722942.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178477724913086626.4001)
,p_plug_name=>unistr('Historial de M\00E9todos Abreviados')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los m\00E9todos abreviados de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193356305758465047.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SHORTCUTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193356508497465048.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193356611761465069.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193356707913465070.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193356827768465070.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193356901768465071.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193357024322465072.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193357115008465073.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193357206527465073.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188991707548026498.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193356305758465047.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:41,RIR::'
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_api.create_page(
 p_id=>42.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Procesos de Aplicaci\00F3n')
,p_step_title=>unistr('Historial de Procesos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11001418768488718.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(4020210037479119.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47815719987196218.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PROCESSING'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47815815177196218.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47816828160196312.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47816905432196313.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47817202270196314.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47818224862205729.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47818503056205738.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47819724479239691.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192778227550777174.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179880415861754655.4001)
,p_plug_name=>unistr('Historial de Procesos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los procesos de aplicaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188877925572856627.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47815719987196218.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_api.create_page(
 p_id=>43.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de C\00E1lculos')
,p_step_title=>unistr('Historial de C\00E1lculos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47829819105563603.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47827519966525945.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179882503309769998.4001)
,p_plug_name=>unistr('Historial de C\00E1lculos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los c\00E1lculos de aplicaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192578206532753093.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_COMPUTATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192578428447753104.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192578723511753110.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192578811721753111.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192579014963753112.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192579105294753113.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192579329210753115.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192579404931753115.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192579528837753116.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188922818634179166.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192578206532753093.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:43,RIR::'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_api.create_page(
 p_id=>44.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Listas'
,p_step_title=>'Historial de Listas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11023119264649745.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180934307196721365.4001)
,p_plug_name=>'Historial de Listas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las listas y entradas de lista de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192971527924071247.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.LIST_INITCAP'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LISTS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.LIST_ITEM'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LIST_ITEMS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192971700145071263.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192971826504071267.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192971911263071268.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192972101092071270.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192972208850071271.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192972322792071271.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192972420788071272.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192972532494071273.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193005932603110435.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188941126299909859.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192971527924071247.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:44,RIR::'
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_api.create_page(
 p_id=>45.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de \00C1rboles')
,p_step_title=>unistr('Historial de \00C1rboles')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11039813470704815.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(4884503079390537.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11041908060712694.4001)
,p_plug_name=>unistr('Historial de \00C1rboles')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las recientes modificaciones realizadas en los \00E1rboles de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193078029767279936.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P45a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TREES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193078208814279939.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078331675279940.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078411006279941.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078530574279941.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078630819279942.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078720050279943.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078820471279944.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193078921328279944.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188983902334873681.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193078029767279936.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:45,RIR::'
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_api.create_page(
 p_id=>46.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Eliminar Plantillas no Utilizadas'
,p_page_mode=>'MODAL'
,p_step_title=>'Eliminar Plantillas no Utilizadas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_dialog_height=>'500'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932808077499193724.4001)
,p_plug_name=>'Botones'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1599002002482970065.4001)
,p_plug_name=>unistr('Confirmar Eliminaci\00F3n de Plantilla')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Seleccione el tema del que desea eliminar las plantillas no utilizadas. Se considera que una plantilla se est\00E1 utilizando cuando un componente hace referencia a ella directamente, se utiliza como una de las plantillas por defecto del tema o se ha ')
||unistr('suscrito a ella desde otra plantilla. Tenga en cuenta que si el propio tema est\00E1 suscrito a un tema de otra aplicaci\00F3n o al tema maestro, al refrescar un tema se restaurar\00E1n todas las plantillas definidas en el tema maestro. </p>')
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932808381486193727.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(932808077499193724.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932808101375193725.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(932808077499193724.4001)
,p_button_name=>'REMOVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Plantillas'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(932808739506193731.4001)
,p_branch_action=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932807937166193723.4001)
,p_name=>'P46_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1599002002482970065.4001)
,p_prompt=>'Tema'
,p_source=>'P4656_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(932808473536193728.4001)
,p_name=>'Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(932808381486193727.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(932808515389193729.4001)
,p_event_id=>wwv_flow_api.id(932808473536193728.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932808617803193730.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Templates'
,p_process_sql_clob=>'wwv_flow_templates_util.remove_ununsed_templates (:FB_FLOW_ID, :P46_THEME_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al eliminar las plantillas'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_api.create_page(
 p_id=>47.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Eliminar Plantillas no Utilizadas'
,p_page_mode=>'MODAL'
,p_step_title=>'Eliminar Plantillas no Utilizadas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_dialog_height=>'500'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(932809341058193737.4001)
,p_name=>unistr('Resumen de Eliminaci\00F3n de Plantilla')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'a-Region--paddedBody'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  c003 template_type,',
'  n001 delete_count',
'from wwv_flow_collections where collection_name = ''TEMPLATE_CLEANUP'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041646592238406593.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932809600949193740.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Plantilla'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(282026017647000169)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932809787496193741.4001)
,p_query_column_id=>2
,p_column_alias=>'DELETE_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Plantillas Suprimidas'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1599146158139213535.4001)
,p_plug_name=>'Botones'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1599146563176213536.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1599146158139213535.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(932809290061193736.4001)
,p_branch_action=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1599146563176213536.4001)
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_api.create_page(
 p_id=>48.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituir'
,p_step_title=>'Sustituir'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24121815754638425.4001)
,p_plug_name=>unistr('Confirmar Sustituci\00F3n de Diccionario de Atributos')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>165
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ha solicitado que el Diccionario de Atributo de Valores por Defecto de Interfaz de Usuario existente en este espacio de trabajo se',
'actualice con el Diccionario de Atributo de Valores por Defecto de Interfaz de Usuario que se va a instalar. Si se encuentran atributos coincidentes,',
unistr('se actualizar\00E1n. Confirme esta solicitud.</p>'),
'',
'<p>Antes de sustituirlos, es conveniente exportar los valores por defecto de interfaz de usuario como copia de seguridad.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UI_DEFAULTS_AD'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30513005339674214.4001)
,p_plug_name=>unistr('Confirmar Sustituci\00F3n de Plugin')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ha solicitado la sustituci\00F3n del plugin existente en <strong>&P4450_DISPLAY_NAME. (&P4450_NAME.)</strong>, en la'),
unistr('aplicaci\00F3n <strong>&P4450_NEW_FLOW_ID.</strong>, por el plugin que se va a instalar. Confirme'),
'esta solicitud.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PLUGIN'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(75651209346653682.4001)
,p_plug_name=>unistr('Confirmar Sustituci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ha solicitado que la aplicaci\00F3n existente <strong>&P49_NEW_FLOW_ID. - &P48_APPLICATION_NAME.</strong> se elimine y'),
unistr('sustituya por la aplicaci\00F3n que se va a instalar: <strong>&P49_IMP_FLOW_ID. - &P48_IMP_APP_NAME.</strong>. Confirme esta solicitud.</p>'),
'',
unistr('<p>Antes de sustituir una aplicaci\00F3n, es conveniente crear una copia de seguridad.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'FLOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78171812934226554.4001)
,p_plug_name=>unistr('Confirmar Sustituci\00F3n de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ha solicitado que la p\00E1gina existente &P67_IMP_PAGE_ID. de la aplicaci\00F3n <strong>&FB_FLOW_ID.</strong> se'),
unistr('elimine y sustituya por la p\00E1gina que se va a instalar. Confirme esta solicitud.</p>'),
'',
unistr('<p>Antes de sustituir la p\00E1gina, es conveniente crear una copia de seguridad. Puede crear una copia de seguridad de toda la aplicaci\00F3n o'),
unistr('s\00F3lo de las p\00E1ginas seleccionadas.</p>')))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PAGE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(141828919165478596.4001)
,p_plug_name=>'Confirmar Refrescamiento de Tema'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ha solicitado refrescar el tema existente &P253_ORIGINAL_THEME_ID. de la aplicaci\00F3n <b>&P253_NEW_FLOW_ID. con el tema que se va a importar.  '),
'Confirme esta solicitud.</p>',
'',
unistr('<p>Antes de refrescar un tema, es conveniente exportar la aplicaci\00F3n como copia de seguridad.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'THEME'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(160743029989473652.4001)
,p_plug_name=>unistr('Confirmar Sustituci\00F3n de Diccionario de Tabla')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>160
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ha solicitado que el diccionario de tabla de valores por defecto de la interfaz de usuario existente del',
'esquema de espacio de trabajo <strong>&P321_SCHEMA_NAME.</strong> se elimine y sustituya por el diccionario de tabla de valores por defecto de la interfaz de usuario',
'que se va a instalar. Confirme esta solicitud.</p>',
'',
'<p>Antes de sustituirlos, es conveniente exportar los valores por defecto de interfaz de usuario como copia de seguridad.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UI_DEFAULTS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(210947513275299904.4001)
,p_plug_name=>'Sustituir Componentes'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>180
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ha solicitado que se sustituyan uno o m\00E1s componentes de aplicaci\00F3n existentes por'),
unistr('los componentes definidos en el archivo de exportaci\00F3n. Confirme esta solicitud.</p>'),
'',
unistr('<p>Antes de sustituir los componentes de una aplicaci\00F3n, es conveniente crear una copia de seguridad.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and nvl(:P48_EMPTY_MANIFEST, ''N'') = ''N'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(211587310604227425.4001)
,p_plug_name=>unistr('Manifiesto Vac\00EDo')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>170
,p_plug_source=>unistr('<p>El archivo de exportaci\00F3n de componentes no contiene ning\00FAn componente para la importaci\00F3n o la secci\00F3n de manifiesto del archivo de exportaci\00F3n est\00E1 corrupta.</p>')
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and :P48_EMPTY_MANIFEST = ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(230829210468863513.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>190
,p_list_id=>wwv_flow_api.id(38836703962860678.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388072302664289607.4001)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78193700691289249.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>'FLOW'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78199718006294230.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>'PAGE'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211588622856240436.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and :P48_EMPTY_MANIFEST = ''Y'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210935320239904510.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and nvl(:P48_EMPTY_MANIFEST, ''N'') = ''N'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24122010325638427.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>'UI_DEFAULTS_AD'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160745415837497944.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>'UI_DEFAULTS'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30525330413766555.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>'PLUGIN'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(141839519558507069.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_condition=>'THEME'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78203024586296152.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Sustituir Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>'FLOW'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75653600324653710.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Sustituir P\00E1gina')
,p_button_position=>'CREATE'
,p_button_condition=>'PAGE'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(211633819027788173.4001)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Sustituir Componentes de Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and nvl(:P48_EMPTY_MANIFEST, ''N'') = ''N'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24122200558638428.4001)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Diccionario de Atributos'
,p_button_position=>'CREATE'
,p_button_condition=>'UI_DEFAULTS_AD'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(160746128304501541.4001)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sustituir Diccionario de Tabla'
,p_button_position=>'CREATE'
,p_button_condition=>'UI_DEFAULTS'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30525613922771212.4001)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sustituir Plugin Existente'
,p_button_position=>'CREATE'
,p_button_condition=>'PLUGIN'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(141840225099508626.4001)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(388072302664289607.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Tema Existente'
,p_button_position=>'CREATE'
,p_button_condition=>'THEME'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75703306759082671.4001)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78203024586296152.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'FLOW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78315807392574990.4001)
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78203024586296152.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(141845904367531076.4001)
,p_branch_action=>'f?p=&APP_ID.:253:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(141840225099508626.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'THEME'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160742420985471083.4001)
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(160746128304501541.4001)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24123626451688831.4001)
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(24122200558638428.4001)
,p_branch_sequence=>65
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS_AD'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(210937707819929333.4001)
,p_branch_action=>'f?p=&APP_ID.:598:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78203024586296152.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(211589225411250663.4001)
,p_branch_action=>'f?p=&APP_ID.:598:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78203024586296152.4001)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30513621316707212.4001)
,p_branch_action=>'f?p=&APP_ID.:4450:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30525613922771212.4001)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78318221722588609.4001)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78193700691289249.4001)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'FLOW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78320209732594647.4001)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78193700691289249.4001)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(141843830425519626.4001)
,p_branch_action=>'f?p=&FLOW_ID.:253:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(141839519558507069.4001)
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'THEME'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160747431552511958.4001)
,p_branch_action=>'f?p=&FLOW_ID.:321:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(160745415837497944.4001)
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24123202210681894.4001)
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(24122010325638427.4001)
,p_branch_sequence=>115
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(210936923618924476.4001)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78193700691289249.4001)
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(211589531298252361.4001)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(141839519558507069.4001)
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30513322570698023.4001)
,p_branch_action=>'f?p=&APP_ID.:4450:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30525330413766555.4001)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78173624015229740.4001)
,p_name=>'P48_TYPE'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_source=>'v(''REQUEST'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103586633047901307.4001)
,p_name=>'P48_APPLICATION_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(75651209346653682.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(120780655919320601.4001)
,p_name=>'P48_IMP_APP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(75651209346653682.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211569931803138974.4001)
,p_name=>'P48_EMPTY_MANIFEST'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(210947513275299904.4001)
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(230865730039907082.4001)
,p_name=>'P48_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(210947513275299904.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(230885900266974107.4001)
,p_name=>'P48_APPLICATION2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(78171812934226554.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(211576409602179834.4001)
,p_computation_sequence=>10
,p_computation_item=>'P48_EMPTY_MANIFEST'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_manifest clob;',
'    l_start pls_integer;',
'    l_stop pls_integer;',
'    l_line varchar2(4000);',
'    l_loop pls_integer := 1;',
'begin',
'    select wwv_flow_imp_parser.get_component_manifest(:P49_FILE_ID) into l_manifest from dual;',
'    l_start := 1;',
'',
'while sys.dbms_lob.instr(l_manifest,''--'',l_start) > 0 and l_loop < 1000 loop',
'	l_loop := l_loop+1;',
'	l_start := sys.dbms_lob.instr(l_manifest,''--'',l_start);',
'	l_stop := sys.dbms_lob.instr(l_manifest,chr(10),l_start);',
'	l_line := sys.dbms_lob.substr(l_manifest,l_stop-l_start,l_start);',
'	return ''N'';',
'	l_start := sys.dbms_lob.instr(l_manifest,''--'',l_stop+1);',
'end loop;',
'',
'return ''Y'';',
'',
'exception when others then null;',
'end;'))
,p_compute_when=>'COMP'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(103586858644901309.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Application Information'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    for c1 in (',
'        select name',
'        from wwv_flows',
'        where id = :P49_NEW_FLOW_ID',
'        and security_group_id = :flow_security_group_id',
'    ) loop',
'        :P48_APPLICATION_NAME := c1.name;',
'    end loop;',
'',
'    :P48_IMP_APP_NAME := wwv_flow_imp_parser.get_app_name(:P163_FILE_ID);',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_api.create_page(
 p_id=>49.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n de Base de Datos')
,p_step_title=>unistr('Instalar Aplicaci\00F3n de Base de Datos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37909911927512833.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47632929379498967.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) = false'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>unistr('<p>Al instalar una aplicaci\00F3n que tiene el mismo identificador que la aplicaci\00F3n existente en el espacio de trabajo actual, la aplicaci\00F3n existente se suprimir\00E1 y se sustituir\00E1 por la nueva aplicaci\00F3n. Si intenta instalar una aplicaci\00F3n con el mismo ')
||unistr('identificador que la aplicaci\00F3n existente en un espacio de trabajo diferente, aparecer\00E1 un mensaje de error que no producir\00E1 ning\00FAn da\00F1o. Si est\00E1 importando una aplicaci\00F3n &PRODUCT_NAME., el asistente de instalaci\00F3n le permitir\00E1 instalar los objetos ')
||'de soporte.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79479717773383002.4001)
,p_plug_name=>unistr('Archivo no V\00E1lido')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('El archivo no es un archivo de exportaci\00F3n de la aplicaci\00F3n &PRODUCT_NAME. v\00E1lido.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) = true'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201406304504703645.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227304924717377510.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(38836703962860678.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747137283199138151.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n de Base de Datos')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47637304969529814.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201406304504703645.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47638615358532853.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(201406304504703645.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Instalar Aplicaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217551631815327396.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(201406304504703645.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(224688012029789109.4001)
,p_branch_action=>'f?p=&APP_ID.:2117:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37975103840576773.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47638615358532853.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :FB_FLOW_ID and :FB_FLOW_ID is not null'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47640408909540415.4001)
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:FLOW:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73118923864773968.4001)
,p_branch_action=>'f?p=&FLOW_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(209198226551507783.4001)
,p_branch_action=>'f?p=&APP_ID.:598:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_imp_parser.is_component_export (p_file_id => :p49_file_id)'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78016223614075187.4001)
,p_branch_action=>'67'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_imp_parser.get_page_id (p_file_id => :p49_file_id) is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51448131973367122.4001)
,p_branch_action=>'f?p=&APP_ID.:154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47638615358532853.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id = :P49_NEW_FLOW_ID',
'   and (    security_group_id <> :P49_LOGGED_IN_COMPANY',
'         or build_status      =  ''RUN_ONLY'' )'))
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73107224679708034.4001)
,p_branch_action=>'f?p=&FLOW_ID.:48:&SESSION.:FLOW:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47638615358532853.4001)
,p_branch_sequence=>80
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
'where v(''P49_NEW_FLOW_OPT'') in (''REUSE'',''SPECIFY'') and',
'id = :P49_NEW_FLOW_ID',
'and security_group_id = :P49_LOGGED_IN_COMPANY;'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47644600991566557.4001)
,p_name=>'P49_LOGGED_IN_COMPANY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'&WORKSPACE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47645615882570805.4001)
,p_name=>'P49_IMP_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador de Aplicaci\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_flow_id (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identificador de la aplicaci\00F3n exportada.  '),
'',
unistr('Si hay un identificador de aplicaci\00F3n duplicado en el espacio de trabajo actual, la aplicaci\00F3n existente se suprimir\00E1 y se instalar\00E1 la nueva. Si el identificador de aplicaci\00F3n duplicado est\00E1 en un espacio de trabajo distinto, se generar\00E1 un error. S')
||unistr('e debe a que el identificador de aplicaci\00F3n debe ser \00FAnico en todos los espacios de trabajo.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47646409087578322.4001)
,p_name=>'P49_PARSE_AS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_prompt=>unistr('Esquema de An\00E1lisis')
,p_source=>'wwv_flow_imp_parser.get_parse_as_schema (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('La instalaci\00F3n de la aplicaci\00F3n terminar\00E1 con esta selecci\00F3n. Cuando termine la instalaci\00F3n de forma correcta, se utilizar\00E1 para definir el propietario de la aplicaci\00F3n ahora instalada. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47659712784721297.4001)
,p_name=>'P49_IMP_COMPANY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador de Espacio de Trabajo de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el espacio de trabajo del que se exporta la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47661103911728224.4001)
,p_name=>'P49_IMP_FLOW_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_parse_as_schema (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Es el propietario de la aplicaci\00F3n instalada. La selecci\00F3n realizada en <strong>Analizar como Esquema</strong> ser\00E1 el propietario de la nueva aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48075028683667245.4001)
,p_name=>'P49_COMPANY_ACTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_prompt=>unistr('Origen de Aplicaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el origen de la aplicaci\00F3n que se est\00E1 instalando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48333316682715628.4001)
,p_name=>'P49_LOGGED_IN_COMPANY2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Espacio de Trabajo Actual:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el espacio de trabajo actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48337002400730366.4001)
,p_name=>'P49_IMP_COMPANY2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_item_default=>'&COMPANY.'
,p_prompt=>unistr('Espacio de Trabajo de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p49_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el espacio de trabajo del que se exporta la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53701615454623778.4001)
,p_name=>'P49_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(56513630434665840.4001)
,p_name=>'P49_IMP_VERSION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Versi\00F3n de &PRODUCT_NAME. de la que se exporta la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59206517015336606.4001)
,p_name=>'P49_BUILD_STATUS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_prompt=>unistr('Estado de Creaci\00F3n')
,p_source=>'wwv_flow_imp_parser.get_build_status (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_api.id(84305510710571518.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Estado de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Estado de creaci\00F3n que se define para la aplicaci\00F3n resultante.  '),
'</p>',
'',
'<p>',
unistr('Nota: Si cambia el estado a Solo Ejecutar Aplicaci\00F3n y desea cambiarlo a Ejecutar y Crear Aplicaci\00F3n,'),
'debe conectarse como administrador de una instancia.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72898709763530334.4001)
,p_name=>'P49_NEW_FLOW_OPT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_item_default=>'AUTO'
,p_prompt=>unistr('Opciones de Instalaci\00F3n de Aplicaci\00F3n:')
,p_source=>'AUTO'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'INSTALL.FLOW.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(73071600194414972.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione c\00F3mo instalar esta aplicaci\00F3n. Las opciones disponibles incluyen:'),
'</p>',
'',
'<p><ul>',
unistr('<li>Asignar Autom\00E1ticamente Nuevo ID de Aplicaci\00F3n: se crear\00E1 un nuevo ID de aplicaci\00F3n.</li>'),
unistr('<li>Volver a Usar ID de Aplicaci\00F3n del Archivo de Exportaci\00F3n: se utilizar\00E1 el ID de aplicaci\00F3n existente.</li>'),
unistr('<li>Cambiar ID de Aplicaci\00F3n: especifique un nuevo ID de aplicaci\00F3n.</li>'),
'</ul>',
'</p>',
'',
'<p>',
unistr('Recuerde que debe especificar un ID de aplicaci\00F3n que sea \00FAnico en todos los espacios de trabajo de &PRODUCT_NAME.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73052424192272620.4001)
,p_name=>'P49_ADJUST_OFFSETS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_prompt=>'Assign New Internal Object IDs ('
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73108017537715434.4001)
,p_name=>'P49_NEW_FLOW_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(47632929379498967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nueva Aplicaci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique un nuevo identificador de aplicaci\00F3n que sea un valor entero que identifique la aplicaci\00F3n. El identificador de aplicaci\00F3n debe ser \00FAnico en la instancia de &PRODUCT_NAME.'),
'<br /><br />',
unistr('&PRODUCT_NAME. reserva los identificadores de aplicaci\00F3n incluidos en el rango de 3000 a 9000 para utilizarlos de forma interna.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(73083719288517204.4001)
,p_computation_sequence=>10
,p_computation_item=>'P49_NEW_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P49_IMP_FLOW_ID'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'P49_NEW_FLOW_OPT'
,p_compute_when_text=>'REUSE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(73086102234531170.4001)
,p_computation_sequence=>20
,p_computation_item=>'P49_NEW_FLOW_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_utilities.minimum_free_flow;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>':P49_NEW_FLOW_OPT = ''AUTO'' and v(''REQUEST'') = ''INSTALL'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(225115916305424325.4001)
,p_computation_sequence=>30
,p_computation_item=>'P2117_SUBMITTED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'NO'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(228930401344526766.4001)
,p_computation_sequence=>40
,p_computation_item=>'P2100_CANCEL_PAGE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(248776121681030473.4001)
,p_computation_sequence=>50
,p_computation_item=>'P163_FILE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>':P49_FILE_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(56432910873347878.4001)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p49_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if   l_calling_version > l_runtime_version',
'      or l_calling_version = ''20150701'' -- APEX 5.1 EA1',
'    then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de &PRODUCT_NAME.)')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(338249619399057431.4001)
,p_validation_name=>'New Flow ID Not Null'
,p_validation_sequence=>20
,p_validation=>'P49_NEW_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_validation_condition=>'P49_NEW_FLOW_OPT'
,p_validation_condition2=>'SPECIFY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(73108017537715434.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(73122718501810340.4001)
,p_validation_name=>'new flow id is numeric'
,p_validation_sequence=>30
,p_validation=>'P49_NEW_FLOW_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El identificador de aplicaci\00F3n debe ser num\00E9rico.')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(73108017537715434.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(75674329288890481.4001)
,p_validation_name=>'specify new flow not same flow'
,p_validation_sequence=>40
,p_validation=>'ltrim(:P49_NEW_FLOW_ID,''0'') != nvl(:P49_IMP_FLOW_ID,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El identificador de aplicaci\00F3n especificado debe ser diferente del antiguo identificador de aplicaci\00F3n al utilizar esta opci\00F3n. Para volver a utilizar el identificador de aplicaci\00F3n, utilice el bot\00F3n de radio ''Volver a Usar Identificador de Aplicaci\00F3')
||unistr('n del Archivo de Exportaci\00F3n''.')
,p_validation_condition=>':P49_NEW_FLOW_OPT = ''SPECIFY'' and wwv_flow_utilities.is_numeric(:P49_NEW_FLOW_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(73108017537715434.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(338252426718087928.4001)
,p_validation_name=>'reserved flow id check 2'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.get_app_id_reserved_reason (',
'           p_security_group_id => :flow_security_group_id,',
'           p_application_id    => :P49_NEW_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P49_NEW_FLOW_OPT = ''SPECIFY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(59210409312353336.4001)
,p_validation_name=>'build status not null'
,p_validation_sequence=>70
,p_validation=>'P49_BUILD_STATUS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el estado de creaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(59206517015336606.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47684431812925489.4001)
,p_validation_name=>'parse as not null'
,p_validation_sequence=>80
,p_validation=>'P49_PARSE_AS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el an\00E1lisis como esquema.')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(47646409087578322.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47812121666857962.4001)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ((:P49_IMP_COMPANY is null)/* and (:P49_NEW_FLOW_ID is null)*/ and(:P49_IMP_FLOW_OWNER is null)) or',
'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de la aplicaci\00F3n &PRODUCT_NAME. v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51925119200045924.4001)
,p_validation_name=>'cannot import invalid range flow'
,p_validation_sequence=>100
,p_validation=>':P49_NEW_FLOW_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La aplicaci\00F3n que est\00E1 intentando instalar est\00E1 reservada.')
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P49_IMP_FLOW_ID is not null) and (wwv_flow_utilities.is_numeric(:P49_NEW_FLOW_ID) = true)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(47645615882570805.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(484652413021609778.4001)
,p_validation_name=>'P49_NEW_FLOW_ID positive, whole number'
,p_validation_sequence=>110
,p_validation=>'P49_NEW_FLOW_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de aplicaci\00F3n debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P49_NEW_FLOW_ID is not null and',
':P49_NEW_FLOW_OPT = ''SPECIFY'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(47638615358532853.4001)
,p_associated_item=>wwv_flow_api.id(73108017537715434.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(382393636208769611.4001)
,p_name=>'Set Focus on New Application ID'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P49_NEW_FLOW_OPT'
,p_display_when_cond2=>'SPECIFY'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(382393781319769612.4001)
,p_event_id=>wwv_flow_api.id(382393636208769611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(382393873371769613.4001)
,p_name=>'Show New App ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P49_NEW_FLOW_OPT'
,p_condition_element=>'P49_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(382393999889769614.4001)
,p_event_id=>wwv_flow_api.id(382393873371769613.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(382394085941769615.4001)
,p_event_id=>wwv_flow_api.id(382393873371769613.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(382394131710769616.4001)
,p_event_id=>wwv_flow_api.id(382393873371769613.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48121120970958297.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine flow import company action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :flow_security_group_id = wwv_flow_imp_parser.get_security_group_id(:p49_file_id) then',
'  :p49_company_action := wwv_flow_lang.system_message(''F4000.APP_EXPORT_CURR_WS'');',
'else',
'  :p49_company_action := wwv_flow_lang.system_message(''F4000.APP_EXPORT_NON_CURR_WS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25458208466179758.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean Up Reserved Application IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flows_reserved ',
'where id in (select id from wwv_flows where security_group_id = :FLOW_SECURITY_GROUP_ID );',
'commit;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_api.create_page(
 p_id=>50.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Mostrar Descripciones de Atributos de Plantillas'
,p_page_mode=>'MODAL'
,p_step_title=>'Mostrar Descripciones de Atributos de Plantillas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1533932968307629863.4001)
,p_plug_name=>'Barra Superior'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n #A01# - #A10# son atributos opcionales que se pueden utilizar en una plantilla de lista, para hacer referencia a valores de componentes. Seleccione un tema y la plantilla de lista asociada para ver las descripciones que se ')
||unistr('han definido para estas cadenas de sustituci\00F3n y en qu\00E9 lugar de la plantilla de lista seleccionada se han utilizado.')
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1533933130769636360.4001)
,p_name=>'Atributos de Plantilla de Lista'
,p_template=>wwv_flow_api.id(646287526247383209.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select A01_LABEL,',
'       A02_LABEL,',
'       A03_LABEL,',
'       A04_LABEL,',
'       A05_LABEL,',
'       A06_LABEL,',
'       A07_LABEL,',
'       A08_LABEL,',
'       A09_LABEL,',
'       A10_LABEL',
'  from WWV_FLOW_LIST_TEMPLATES',
' where id = :P50_LIST_TEMPLATE_ID',
'   and security_group_id = :flow_security_group_id',
'   and flow_id = :FB_FLOW_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P50_LIST_TEMPLATE_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No se ha seleccionado ninguna plantilla de lista.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373148833065040.4001)
,p_query_column_id=>1
,p_column_alias=>'A01_LABEL'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Descripci\00F3n de #A01#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373246763065041.4001)
,p_query_column_id=>2
,p_column_alias=>'A02_LABEL'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Descripci\00F3n de #A02#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373379356065042.4001)
,p_query_column_id=>3
,p_column_alias=>'A03_LABEL'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Descripci\00F3n de #A03#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373478910065043.4001)
,p_query_column_id=>4
,p_column_alias=>'A04_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Descripci\00F3n de #A04#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373538961065044.4001)
,p_query_column_id=>5
,p_column_alias=>'A05_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Descripci\00F3n de #A05#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373666692065045.4001)
,p_query_column_id=>6
,p_column_alias=>'A06_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Descripci\00F3n de #A06#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373794269065046.4001)
,p_query_column_id=>7
,p_column_alias=>'A07_LABEL'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Descripci\00F3n de #A07#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373813275065047.4001)
,p_query_column_id=>8
,p_column_alias=>'A08_LABEL'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Descripci\00F3n de #A08#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301373949620065048.4001)
,p_query_column_id=>9
,p_column_alias=>'A09_LABEL'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Descripci\00F3n de #A09#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301374081447065049.4001)
,p_query_column_id=>10
,p_column_alias=>'A10_LABEL'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Descripci\00F3n de #A10#')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1500323050132760214.4001)
,p_name=>'P50_THEME_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1533932968307629863.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(theme_name)||'' - ''||theme_id theme_name, theme_id',
'  from wwv_flow_themes',
'where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'order by upper(theme_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tema -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tema asociado a esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1533324667053624070.4001)
,p_name=>'P50_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1533932968307629863.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1533930926254603049.4001)
,p_name=>'P50_LIST_TEMPLATE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1533932968307629863.4001)
,p_prompt=>'Plantilla de Lista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_template_name) list_template_name, id',
'  from wwv_flow_list_templates',
'where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and theme_id = :P50_THEME_ID',
'order by upper(list_template_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla de Lista -'
,p_lov_cascade_parent_items=>'P50_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de lista que desea ver. Los atributos de cadena de sustituci\00F3n se mostrar\00E1n autom\00E1ticamente para la plantilla de lista seleccionada. Las descripciones de los atributos ayudan a los desarrolladores a comprender el uso de las ca')
||unistr('denas de sustituci\00F3n opcionales #A01# - #A10# dentro de una plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1533931119542609584.4001)
,p_name=>'Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P50_LIST_TEMPLATE_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1301374128305065050.4001)
,p_event_id=>wwv_flow_api.id(1533931119542609584.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1533933130769636360.4001)
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_api.create_page(
 p_id=>51.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'IU no soportada'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1440167474392501.4001)
,p_plug_name=>'Interfaz de usuario no soportada'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('jQuery Mobile ya no est\00E1 soportado. Esta aplicaci\00F3n solo tiene definida una interfaz de usuario m\00F3vil. Para agregar p\00E1ginas nuevas a esta aplicaci\00F3n, primero debe a\00F1adir una interfaz de usuario de escritorio.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1440445662392504.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1440842374392508.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1440167474392501.4001)
,p_button_name=>'manage_ui'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Gestionar interfaces de usuario'
,p_button_position=>'BELOW_BOX'
,p_button_redirect_url=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1440521040392505.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1440445662392504.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1440626005392506.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1440521040392505.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1440744149392507.4001)
,p_event_id=>wwv_flow_api.id(1440626005392506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_api.create_page(
 p_id=>52.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Convertir a lista de valores compartida'
,p_page_mode=>'MODAL'
,p_step_title=>'Convertir a lista de valores compartida'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_inline_css=>'.lov-source-region pre {margin: 0;}'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(681994650910644701.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(681995236069644707.4001)
,p_plug_name=>'Form Region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Convierta una lista de valores definida en un nivel de elemento en una lista de valores compartida. Una vez convertida, cualquier elemento de la aplicaci\00F3n actual podr\00E1 hacer referencia a la lista de valores.')
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3348608179229757717.4001)
,p_plug_name=>'Origen de lista de valores'
,p_region_css_classes=>'lov-source-region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor lov_data',
'    is',
'    select',
'          substr(i.lov,1,4000) lov',
'      from wwv_flow_step_items i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM''',
'    union all',
'    select',
'          substr(i.lov_source,1,4000) lov',
'      from wwv_flow_region_columns i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'';',
'begin',
'    for c1 in lov_data',
'    loop',
'        sys.htp.p(''<pre>''||apex_escape.html(c1.lov)||''</pre>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681994824368644703.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(681994650910644701.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681994761845644702.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(681994650910644701.4001)
,p_button_name=>'CONVERT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Convertir Lista de Valores'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2701819071095216.4001)
,p_name=>'F4000_P52_SOURCE_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(681995236069644707.4001)
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LOCALLY_DEFINED_LOV_TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''SC.LOV.PAGE_ITEM'') d,',
'       ''PAGE_ITEM'' r',
'from sys.dual',
'union all',
'select wwv_flow_lang.system_message(''SC.LOV.IG_COLUMN'') d,',
'       ''IG_COLUMN'' r',
'from sys.dual'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681995360652644708.4001)
,p_name=>'F4000_P52_LOV_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(681995236069644707.4001)
,p_prompt=>'Nombre de Lista de Valores Compartida'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(708643875646067001.4001)
,p_name=>'F4000_P52_LOV_SOURCE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(681995236069644707.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(708643954372067002.4001)
,p_name=>'F4000_P52_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(681995236069644707.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3348608091212757716.4001)
,p_name=>'F4000_P52_SOURCE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(681995236069644707.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3348608530308757721.4001)
,p_validation_name=>'name not already in use'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where FLOW_ID = :fb_flow_id',
'   and upper(LOV_NAME) = upper(:F4000_P52_LOV_NAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre debe ser \00FAnico en la aplicaci\00F3n')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(681994915812644704.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(681994824368644703.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(681995058088644705.4001)
,p_event_id=>wwv_flow_api.id(681994915812644704.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348608460260757720.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Local Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor lov_data',
'    is',
'    select',
'          flow_step_id page_id,',
'          name,',
'          (select name',
'             from wwv_flow_steps p',
'            where p.id = i.flow_step_id',
'              and flow_id = :FB_FLOW_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID) page_name',
'      from wwv_flow_step_items i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM''',
'    union all',
'    select',
'          page_id,',
'          name,',
'          (select name',
'             from wwv_flow_steps p',
'            where p.id = i.page_id',
'              and flow_id = :FB_FLOW_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID) page_name',
'      from wwv_flow_region_columns i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'';',
'begin',
'    for c1 in lov_data',
'    loop',
'        :F4000_P52_LOV_NAME := c1.name;',
'        :F4000_P52_LOV_SOURCE_NAME := c1.name;',
'        :F4000_P52_PAGE_NAME := c1.page_id ||''. ''||c1.page_name;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3348608235093757718.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor lov_data',
'    is',
'    select',
'          i.lov lov',
'      from wwv_flow_step_items i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM''',
'    union all',
'    select',
'          i.lov_source lov',
'      from wwv_flow_region_columns i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'';',
'    l_id  number;',
'begin',
'    -- create shared LOV',
'    for c1 in lov_data',
'    loop',
'        wwv_flow_lov_dev.create_named_lov (',
'            p_id      => l_id,',
'            p_flow_id => :FB_FLOW_ID,',
'            p_name    => :F4000_P52_LOV_NAME,',
'            p_query   => c1.LOV );',
'    end loop;',
'    -- update page item or IG column to use shared LOV',
'    if :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM'' then',
'        update wwv_flow_step_items',
'           set named_lov = upper(:F4000_P52_LOV_NAME)',
'         where id = :F4000_P52_SOURCE_ID',
'           and flow_id = :FB_FLOW_ID',
'           and security_group_id = :flow_security_group_id;',
'    elsif :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'' then',
'        update wwv_flow_region_columns',
'           set lov_type = ''SHARED'',',
'               lov_id = l_id',
'         where id = :F4000_P52_SOURCE_ID',
'           and flow_id = :FB_FLOW_ID',
'           and security_group_id = :flow_security_group_id;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear la lista de valores compartida.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(681994761845644702.4001)
,p_process_success_message=>'Lista de valores compartida "&F4000_P52_LOV_NAME." creada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(681995112839644706.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_api.create_page(
 p_id=>54.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Suscripci\00F3n de Entrada de Barra de Navegaci\00F3n')
,p_step_title=>unistr('Suscripci\00F3n de Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'    function checkAll()  {          ',
'        for ( var i=0; i < document.wwv_flow.elements.length; i++ )          ',
'        {              var e = document.wwv_flow.elements[i];              ',
'        if ( e.name == "f01" || e.name == "f03" ||  e.name == "f05" ||e.name == "f07" ||  e.name == "f09" ){',
'            if ( e.length > 1 ) { for ( j=0;j<e.length;j++ ) ',
'                if ( !e[j].checked ) ',
'                  e[j].click();} ',
'                else ',
'                    if ( !e.checked ) ',
'                         e.click(); ',
'            }',
'         }',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201227528849320624.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ninguna barra de navegaci\00F3n.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201233514400327310.4001)
,p_plug_name=>unistr('Suscripci\00F3n de Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestran las entradas de barra de navegaci\00F3n suscritas en la aplicaci\00F3n.</p>')
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ninguna barra de navegaci\00F3n.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(201238512231343527.4001)
,p_name=>'Subscribed Navigation Bars'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q varchar2(32767) := null;',
'begin',
'    q :=q||''select /* APEX 4000P54a */ '';',
'    q :=q||''wwv_flow_item.checkbox(1,id), '';',
'    q :=q||''wwv_flow_item.hidden(2,reference_id), '';',
'    q :=q||''flow_id, '';   ',
'    q :=q||''wwv_flow_escape.html(icon_image_alt) name, '';',
'    q :=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(icon_image_alt) '';',
'    q :=q||''from wwv_flow_icon_bar where id = s.reference_id) cp_from '';      ',
'    q :=q||''from wwv_flow_icon_bar s '';',
'    q :=q||''where s.flow_id = :fb_flow_id '';',
'    q :=q||''and s.security_group_id = :flow_security_group_id '';',
'    q :=q||''and s.reference_id is not null '';',
'    return q;',
'end;'))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48552904796770781.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553010591770781.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553111660770781.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553220325770782.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Entrada de Barra de Navegaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553301951770782.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Copiado de'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553407592770782.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553510657770782.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553620694770782.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553711219770782.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553821962770782.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48553910556770782.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554030900770782.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554124185770783.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554210905770783.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48554320007770783.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134508307399752849.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134508423207752851.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134508511257752851.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134508607977752851.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134508706135752851.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748315258590144.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748409188590147.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748530114590147.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748612398590147.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748704077590147.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748827906590147.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176748924293590147.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749000134590148.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749111331590148.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749223268590148.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749321262590148.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749419617590148.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749527600590148.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749622600590148.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749726171590149.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749806706590149.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176749903004590149.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750026259590149.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750121162590149.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750209943590149.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750313326590149.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750424238590149.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750528228590150.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750626203590150.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750721718590150.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750808993590150.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176750904715590150.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751010218590150.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751109115590150.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751232623590151.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751325093590151.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751416019590151.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751517668590151.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751612465590151.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751706601590151.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751818691590151.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176751928362590152.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176752021366590152.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176752122217590152.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176752229824590152.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201268225336398200.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(166766500720858594.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201248202877360033.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201227528849320624.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_icon_bar s',
' where s.flow_id = :fb_flow_id',
'   and s.reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201248602877360037.4001)
,p_branch_action=>'54'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(201248202877360033.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201251422126369286.4001)
,p_name=>'F4000_P54_CHECK_ALL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(201227528849320624.4001)
,p_prompt=>'</a><a href="javascript:checkAll()">Activar Todo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'select 1 from wwv_flow_icon_bar s where s.flow_id = :fb_flow_id and s.reference_id is not null'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Haga clic para activarlo todo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201257425996382675.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked NavBars'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_navbar(    ',
'    p_subscribing_navbar_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing NavBars. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar las barras de navegaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(201248202877360033.4001)
,p_process_success_message=>unistr('Barras de navegaci\00F3n seleccionadas refrescadas.')
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_api.create_page(
 p_id=>56.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Aplicaci\00F3n: M\00E9todo')
,p_step_title=>unistr('Crear Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212889110308348288)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_css_classes=>'a-Page--createApp'
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_wiz.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40668424316895037.4001)
,p_plug_name=>'Additional Create Application Options'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c_category_name varchar2(10) := ''Sample'';',
'  l_category_id   number       := 0;',
'begin ',
'',
'  sys.htp.prn(''<p class="u-tC">'');',
'  sys.htp.prn(''<a href="f?p=4500:1100:''||:app_session||''::NO:::">''||wwv_flow_lang.system_message(''QUICK_SQL'')||''</a>'');',
'  sys.htp.prn(''&nbsp;&nbsp;&nbsp;&middot;&nbsp;&nbsp;&nbsp;'');',
'  sys.htp.prn(''<a href="f?p=4000:3009:''||:app_session||''::NO:3009::">''||wwv_flow_lang.system_message(''COPY_EXISTING_APP'')||''</a>'');',
'  sys.htp.prn(''&nbsp;&nbsp;&nbsp;&middot;&nbsp;&nbsp;&nbsp;'');',
'  sys.htp.prn(''<a target="_blank" href="&SYSTEM_HELP_URL./htmdb/about-create-app-wizard.html">''||wwv_flow_lang.system_message(''HELP'')||''</a>'');',
'  sys.htp.prn(''</p>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(369051111555895735.4001)
,p_plug_name=>unistr('Opciones de Aplicaci\00F3n')
,p_region_css_classes=>'mxw780 margin-auto margin-top-lg margin-bottom-lg'
,p_region_sub_css_classes=>'a-MediaList--featuredBlocks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>5
,p_list_id=>wwv_flow_api.id(128724959151960807.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(703476091007162401.4001)
,p_plug_name=>unistr('Crear una Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3328105265902167.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>' '
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(280296731127526810.4001)
,p_name=>'Add Featured Modifier Class to Icon List'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_da_event_comment=>'Currently the Icon List widget does not support having modifier classes applied via the Advanced CSS Class property for items. This dynamic action removes the "a-IconList--wizard" modifier and adds the class "a-IconList--featured" instead.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(280296944651526812.4001)
,p_event_id=>wwv_flow_api.id(280296731127526810.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-IconList'
,p_attribute_01=>'a-IconList--wizard'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(280296886041526811.4001)
,p_event_id=>wwv_flow_api.id(280296731127526810.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-IconList'
,p_attribute_01=>'a-IconList--featured'
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_api.create_page(
 p_id=>57.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Instalar'
,p_step_title=>'Instalar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219194320039549095.4001)
,p_plug_name=>unistr('Aplicaci\00F3n Instalada')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''DATABASE_APP_SUCCESS_MSG'', :P49_NEW_FLOW_ID ) || ''</p>'' );',
'',
'sys.htp.p( ''<p>'' ||',
'           wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) ||',
'           ''</p>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'FLOW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219194817530567271.4001)
,p_plug_name=>'app success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'FLOW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219201628153712228.4001)
,p_plug_name=>unistr('P\00E1gina Instalada')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''PAGE_INSTALL_SUCCESS_MSG'' ) || ''</p>'');',
'',
'sys.htp.p( ''<p>'' ||',
'           wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) ||',
'           ''</p>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PAGE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219201911662716950.4001)
,p_plug_name=>'page success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PAGE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219205609069754096.4001)
,p_plug_name=>'comp success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COMP'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219206719458757054.4001)
,p_plug_name=>'Componentes Instalados'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>110
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''COMP_SUCCESS_MSG'' ) || ''</p>'' );',
'',
'sys.htp.p( ''<p>'' ||',
'           wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) ||',
'           ''</p>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COMP'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229716424236536365.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>130
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(58916220936178306.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'NEVER'
,p_plug_header=>unistr('<p>El archivo importado est\00E1 situado en el repositorio de exportaci\00F3n. A menos que desee volver a instalar, debe eliminarlo.</p>')
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219195822641587691.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(219194817530567271.4001)
,p_button_name=>'RUN_APP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'&P57_HOME_LINK.'
,p_button_css_classes=>'launch-aut'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219206202354754098.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(219205609069754096.4001)
,p_button_name=>'RUN_APP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'&P57_HOME_LINK.'
,p_button_css_classes=>'launch-aut'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219204427854740565.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(219201911662716950.4001)
,p_button_name=>'RUN_PAGE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar P\00E1gina')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&FB_FLOW_ID.:&FB_FLOW_PAGE_ID.:&SESSION.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219195416622576434.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(219194817530567271.4001)
,p_button_name=>'UPGRADE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Actualizar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219205831117754097.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(219205609069754096.4001)
,p_button_name=>'UPGRADE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Actualizar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219195600131581141.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(219194817530567271.4001)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219206026347754098.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(219205609069754096.4001)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219203627723731062.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(219201911662716950.4001)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219203912270736065.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(219201911662716950.4001)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar P\00E1gina')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77263312394218861.4001)
,p_branch_action=>'f?p=&FB_FLOW_ID.:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'RUN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77264815988229366.4001)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'VIEW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77263923129221887.4001)
,p_branch_action=>'f?p=4000:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(219379223497988145.4001)
,p_name=>'P57_HOME_LINK'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(229716424236536365.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(219379410558994145.4001)
,p_computation_sequence=>10
,p_computation_item=>'P57_HOME_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_dev.get_run_url (p_application_id => :FB_FLOW_ID )'
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_api.create_page(
 p_id=>58.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Separadores'
,p_step_title=>'Historial de Separadores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11161705304014192.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181024709573043764.4001)
,p_plug_name=>'Historial de Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los separadores de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193057010449179752.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P58a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.STANDARD_TAB'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TABS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.PARENT_TAB'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TOPLEVEL_TABS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193057228298179754.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057304306179756.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057426610179757.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057527702179757.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057624193179758.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057706916179759.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057816404179760.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193057902683179760.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193058025027179761.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188937907290857066.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193057010449179752.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:58,RIR::'
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_api.create_page(
 p_id=>59.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Elementos de Contrase\00F1a')
,p_step_title=>unistr('Elementos de Contrase\00F1a')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15594313642437577.4001)
,p_plug_name=>unistr('Elementos de Contrase\00F1a')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    p.id                            page_id,',
'    p.name                          page_name,',
'    --',
'    i.name                          item_name,',
'    case i.is_persistent when ''N'' then m_yes else m_no end as dnss,',
'    decode(i.encrypt_session_state_yn,''Y'',m.m_yes,m.m_no) encrypt_state,',
'    decode(nvl(p.AUTOCOMPLETE_ON_OFF,''ON''),',
'       ''ON'',m_on,',
'       ''OFF'',m_off,',
'       p.AUTOCOMPLETE_ON_OFF) AUTOCOMPLETE_ON_OFF,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',m.m_no,',
'      case i.is_persistent when ''N'' then m_no else m_yes end) at_risk,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',''N'',',
'      case i.is_persistent when ''N'' then ''N'' else ''Y'' end) at_risk_code,',
'    --',
'    i.ITEM_SEQUENCE                 display_sequence,',
'    (select plug_name',
'     from wwv_flow_page_plugs',
'     where id = i.ITEM_PLUG_ID)     region,',
'    i.item_plug_id                  region_id,',
'    --',
'    decode(',
'      i.USE_CACHE_BEFORE_DEFAULT,',
'      ''NO'',''Always, replacing any existing value in session state'',',
'      ''YES'',''Only when current value in session state is null'',',
'      i.USE_CACHE_BEFORE_DEFAULT)   source_used,',
'    --',
'    i.PROMPT                        label,',
'    --',
'    i.csize                         item_element_width,',
'    i.cmaxlength                    item_element_max_length,',
'    --',
'    i.cattributes                   html_table_cell_attr_label,',
'    i.cattributes_element           html_table_cell_attr_element,',
'    i.tag_attributes                html_form_element_attributes,',
'    i.tag_attributes2               form_element_option_attributes,',
'    --',
'    (select max(help_text) h',
'    from wwv_flow_step_item_help',
'    where FLOW_ITEM_ID = i.id)      item_help_text,',
'    --',
'    nvl(i.LAST_UPDATED_BY,i.created_by) last_updated_by,',
'    nvl(i.LAST_UPDATED_ON,i.created_on) last_updated_on,',
'    i.ITEM_COMMENT                  component_comment,',
'    i.id                            item_id',
'from wwv_flow_step_items i,',
'     wwv_flow_steps p,',
'     wwv_flows f,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''F4000_ON'') m_on,',
'       wwv_flow_lang.system_message(''F4000_OFF'') m_off',
'from dual) m',
'where i.flow_step_id = p.id and',
'      i.flow_id = :fb_flow_id and',
'      i.display_as = ''NATIVE_PASSWORD'' and',
'      i.security_group_id = :flow_security_group_id and',
'      i.flow_id = f.id and',
'      p.flow_id = i.flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(15594407150437577.4001)
,p_name=>'Password Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15594609499437593.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15594708763437594.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15594812585437594.4001)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre del Elemento'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5120:#ITEM_ID#'
,p_column_linktext=>'#ITEM_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(435149329052617533.4001)
,p_db_column_name=>'DNSS'
,p_display_order=>4
,p_column_identifier=>'BO'
,p_column_label=>'No guarda el estado'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15600810076437607.4001)
,p_db_column_name=>'ENCRYPT_STATE'
,p_display_order=>5
,p_column_identifier=>'BK'
,p_column_label=>'Cifrar Estado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15604401317500135.4001)
,p_db_column_name=>'AUTOCOMPLETE_ON_OFF'
,p_display_order=>6
,p_column_identifier=>'BL'
,p_column_label=>unistr('Terminaci\00F3n Autom\00E1tica de Pantalla')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15987703711740894.4001)
,p_db_column_name=>'AT_RISK'
,p_display_order=>7
,p_column_identifier=>'BN'
,p_column_label=>'En Riesgo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(65056799821493646.4001)
,p_db_column_name=>'AT_RISK_CODE'
,p_display_order=>17
,p_column_identifier=>'BR'
,p_column_label=>unistr('Est\00E1 en Riesgo')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15595118041437594.4001)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>27
,p_column_identifier=>'F'
,p_column_label=>unistr('Secuencia de Visualizaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15595202595437594.4001)
,p_db_column_name=>'REGION'
,p_display_order=>37
,p_column_identifier=>'G'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15595324068437595.4001)
,p_db_column_name=>'REGION_ID'
,p_display_order=>47
,p_column_identifier=>'H'
,p_column_label=>unistr('Identificador de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15595410594437595.4001)
,p_db_column_name=>'SOURCE_USED'
,p_display_order=>57
,p_column_identifier=>'I'
,p_column_label=>'Origen Usado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15595702334437595.4001)
,p_db_column_name=>'LABEL'
,p_display_order=>67
,p_column_identifier=>'L'
,p_column_label=>'Etiqueta de Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15597922585437599.4001)
,p_db_column_name=>'ITEM_ELEMENT_WIDTH'
,p_display_order=>77
,p_column_identifier=>'AH'
,p_column_label=>'Ancho de Elemento'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15598029536437599.4001)
,p_db_column_name=>'ITEM_ELEMENT_MAX_LENGTH'
,p_display_order=>87
,p_column_identifier=>'AI'
,p_column_label=>unistr('Longitud M\00E1xima de Elemento')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15598231843437599.4001)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_LABEL'
,p_display_order=>97
,p_column_identifier=>'AK'
,p_column_label=>'Etiqueta de Atributo de Celda de Tabla HTML'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15598304235437599.4001)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_ELEMENT'
,p_display_order=>107
,p_column_identifier=>'AL'
,p_column_label=>'Elemento de Atributo de Celda de Tabla HTML'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15598405005437599.4001)
,p_db_column_name=>'HTML_FORM_ELEMENT_ATTRIBUTES'
,p_display_order=>117
,p_column_identifier=>'AM'
,p_column_label=>'Atributos de Elemento de Pantalla HTML'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15598528843437600.4001)
,p_db_column_name=>'FORM_ELEMENT_OPTION_ATTRIBUTES'
,p_display_order=>127
,p_column_identifier=>'AN'
,p_column_label=>unistr('Atributos de Opci\00F3n de Elemento de Pantalla')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15600300111437606.4001)
,p_db_column_name=>'ITEM_HELP_TEXT'
,p_display_order=>137
,p_column_identifier=>'BF'
,p_column_label=>'Texto de Ayuda de Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15600417284437606.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>147
,p_column_identifier=>'BG'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15600510870437606.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>157
,p_column_identifier=>'BH'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15600606604437606.4001)
,p_db_column_name=>'COMPONENT_COMMENT'
,p_display_order=>167
,p_column_identifier=>'BI'
,p_column_label=>'Comentario de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15600707979437607.4001)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>177
,p_column_identifier=>'BJ'
,p_column_label=>'Item ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193992105890562275.4001)
,p_plug_name=>unistr('Elementos de Contrase\00F1a')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Oracle recomienda que los elementos de tipo contrase\00F1a no guarden el estado de la sesi\00F3n. Para definir un elemento de contrase\00F1a para que no guarde el estado, edite el elemento haciendo clic en <strong>Nombre del Elemento</strong> y edite el atrib')
||unistr('uto <strong>No guarda el estado</strong>. Para los elementos de tipo contrase\00F1a que necesitan que se mantenga el estado de la sesi\00F3n entre las vistas de p\00E1gina, Oracle recomienda cifrar el estado de la sesi\00F3n. Para cifrar el estado de la sesi\00F3n del e')
||'lemento, edite el elemento y ajuste el atributo de elemento <strong>Cifrado</strong>.</p>',
'',
unistr('<p>Oracle tambi\00E9n recomienda que en las p\00E1ginas con contrase\00F1as se desactive la terminaci\00F3n autom\00E1tica de la pantalla HTML. Para desactivar la terminaci\00F3n autom\00E1tica, edite los atributos de p\00E1gina. Haga clic en el n\00FAmero de p\00E1gina y, a continuaci\00F3n, ')
||unistr('seleccione el nombre de la p\00E1gina en la pesta\00F1a de Presentaci\00F3n y defina el atributo <strong>Terminaci\00F3n Autom\00E1tica de Pantalla</strong> en <strong>Desactivado</strong>.</p>'),
'',
unistr('<p>Los elementos de contrase\00F1a en riesgo son elementos que guardan el estado y no est\00E1n cifrados.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194142516286108125.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194143519095109785.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15594313642437577.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:59,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15610405660614960.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'59'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00060
begin
wwv_flow_api.create_page(
 p_id=>60.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Regiones'
,p_step_title=>'Historial de Regiones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11230923648994087.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251125116349739079.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PAGE_PLUGS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251125321598739080.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251125404345739081.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251125530685739084.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251125604677739085.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251125713972739086.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251125807374739087.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251125908175739088.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251126009952739089.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251320816875793842.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251184216534602929.4001)
,p_plug_name=>'Historial de Regiones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las regiones de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todas las regiones en la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251126818212749073.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251125116349739079.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:60,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(167698628594577197.4001)
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_api.create_page(
 p_id=>61.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Botones'
,p_step_title=>'Historial de Botones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11250130199119064.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251067602395902502.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_BUTTONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251067823788902504.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251067906850902510.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251068023048902511.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251068108648902512.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251068214077902513.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251068325640902514.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251068400511902516.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251068521338902517.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251328025906023504.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251196212697724816.4001)
,p_plug_name=>'Historial de Botones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los botones de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todos los botones en la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251070604089950313.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251067602395902502.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:61,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_api.create_page(
 p_id=>62.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Elementos de P\00E1gina')
,p_step_title=>unistr('Historial de Elementos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11258803150158506.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251083714600237140.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>123
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_ITEMS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251083922869237142.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084021126237144.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084111017237146.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084215727237148.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084326234237149.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084400768237151.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084501340237152.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251084613537237153.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251330321797050755.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251196704863731972.4001)
,p_plug_name=>'Historial de Elementos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>33
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los elementos de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todos los elementos de p\00E1gina en la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251083506289234786.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251083714600237140.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:62,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00063
begin
wwv_flow_api.create_page(
 p_id=>63.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Referencias de Servicio Web'
,p_step_title=>'Historial de Referencias de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11279127625307557.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11271810048283515.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179888826044842771.4001)
,p_plug_name=>'Historial de Referencias de Servicio Web'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las referencias de servicio Web de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192583611558792389.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P63a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SHARED_WEB_SERVICES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192583809228792438.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584114336792441.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584230115792442.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584412045792443.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584514864792444.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584718866792446.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584825072792446.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192584903390792447.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188924515780197240.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192583611558792389.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:63,RIR::'
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_api.create_page(
 p_id=>64.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Bifurcaciones'
,p_step_title=>'Historial de Bifurcaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11290925987363786.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11286824340344465.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251072023829955972.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_BRANCHES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251072206714955974.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251316521498728929.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072815632955988.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>2
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072919356955989.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>3
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072610518955987.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>4
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072525258955986.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>5
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072312666955983.4001)
,p_db_column_name=>'SCN'
,p_display_order=>6
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072728008955987.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>7
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251072406606955985.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251198808681808820.4001)
,p_plug_name=>'Historial de Bifurcaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las ramas de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todas las ramas de la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251074330540967375.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251072023829955972.4001)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:64,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_api.create_page(
 p_id=>65.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Procesos de P\00E1gina')
,p_step_title=>unistr('Historial de Procesos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11325624143505197.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251113915376568491.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_PROCESSING'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251114129067568492.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114204969568493.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114330502568494.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114401813568495.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114524341568496.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114623341568497.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114710670568498.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251114817189568499.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251337601113101539.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251197331659749150.4001)
,p_plug_name=>unistr('Historial de Procesos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los procesos de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todos los procesos de p\00E1gina en la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251113000831564363.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251113915376568491.4001)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:65,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_api.create_page(
 p_id=>66.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Validaciones'
,p_step_title=>'Historial de Validaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11342006360566338.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11350028439591610.4001)
,p_plug_name=>'Historial de Validaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las validaciones de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todas las validaciones de p\00E1gina de la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251105912728501492.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_VALIDATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251106109719501494.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106208710501495.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106306076501498.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106400612501499.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106518079501500.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106615475501501.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106730319501503.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251106815383501503.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251339907954122409.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251108524633514468.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251105912728501492.4001)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:66,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_api.create_page(
 p_id=>67.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar P\00E1gina')
,p_step_title=>unistr('Instalar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38853522961187869.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44694318083706152.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77700532331857019.4001)
,p_plug_name=>unistr('Instalar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Al instalar una p\00E1gina que tiene el mismo identificador que la p\00E1gina existente en la aplicaci\00F3n actual, la p\00E1gina existente se suprimir\00E1 y se instalar\00E1 la nueva. Esta acci\00F3n s\00F3lo se puede realizar si la p\00E1gina no est\00E1 bloqueada. En el caso de que')
||unistr(' todas las sentencias sean correctas, la instalaci\00F3n se confirma y se hace permanente. Si se encuentran errores, se realiza un rollback de la instalaci\00F3n sin ning\00FAn cambio permanente.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747137439162138152.4001)
,p_plug_name=>unistr('Instalar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77701720320857034.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44694318083706152.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77701419437857029.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44694318083706152.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Instalar P\00E1gina')
,p_button_position=>'CREATE'
,p_button_condition=>'P67_INSTALL'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77713702027857087.4001)
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:PAGE:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77713131797857083.4001)
,p_branch_action=>'f?p=&FLOW_ID.:48:&SESSION.:PAGE:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(77701419437857029.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_steps',
'where',
'flow_id = :P67_IMP_FLOW_ID',
'and security_group_id = :P67_LOGGED_IN_COMPANY',
'and id = :P67_IMP_PAGE_ID;'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77702001982857036.4001)
,p_name=>'P67_IMP_VERSION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el n\00FAmero de versi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77702329973857039.4001)
,p_name=>'P67_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Id'
,p_source=>'P49_FILE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77702909494857041.4001)
,p_name=>'P67_COMPANY_ACTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_prompt=>unistr('Origen de P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica el origen de la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77703805471857046.4001)
,p_name=>'P67_LOGGED_IN_COMPANY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_source=>'&WORKSPACE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77704415612857049.4001)
,p_name=>'P67_IMP_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_prompt=>unistr('Aplicaci\00F3n de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si hay un identificador de aplicaci\00F3n duplicado en el espacio de trabajo actual, la aplicaci\00F3n existente se suprimir\00E1 y se instalar\00E1 la nueva. Si el identificador de aplicaci\00F3n duplicado est\00E1 en un espacio de trabajo distinto, se generar\00E1 un error.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77706512070857055.4001)
,p_name=>'P67_IMP_COMPANY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_prompt=>unistr('Identificador de Espacio de Trabajo de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p67_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identificador de espacio de trabajo de archivo de instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77707132064857056.4001)
,p_name=>'P67_LOGGED_IN_COMPANY2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Conectado al Espacio de Trabajo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el espacio de trabajo actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77707431676857057.4001)
,p_name=>'P67_IMP_COMPANY2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&COMPANY.'
,p_prompt=>unistr('Espacio de Trabajo de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p67_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el espacio de trabajo actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77818414153164103.4001)
,p_name=>'P67_IMP_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_prompt=>unistr('P\00E1gina de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si hay un n\00FAmero de p\00E1gina duplicado en la aplicaci\00F3n actual, se suprime la p\00E1gina existente y se instala la nueva.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78155021058115358.4001)
,p_name=>'P67_PARSE_AS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176941429530050057.4001)
,p_name=>'P67_INSTALL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(77700532331857019.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(78155912878122370.4001)
,p_computation_sequence=>10
,p_computation_item=>'P67_PARSE_AS'
,p_computation_type=>'QUERY'
,p_computation=>'select owner from wwv_flows where id = :FB_FLOW_ID and security_group_id = :P67_LOGGED_IN_COMPANY;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'INSTALL:REPLACE'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(77709607606857063.4001)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p67_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No Compatible (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de &PRODUCT_NAME.)')
,p_when_button_pressed=>wwv_flow_api.id(77701419437857029.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(77790404747057323.4001)
,p_validation_name=>'valid export file'
,p_validation_sequence=>20
,p_validation=>'(:P67_IMP_COMPANY is not null) and (:P67_IMP_FLOW_ID is not null) and (:P67_IMP_PAGE_ID is not null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de &PRODUCT_NAME. v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(77701419437857029.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(176934026705904699.4001)
,p_validation_name=>'page export from same app'
,p_validation_sequence=>30
,p_validation=>'(:P67_IMP_FLOW_ID = :FB_FLOW_ID) and (:flow_security_group_id = wwv_flow_imp_parser.get_security_group_id(:p49_file_id))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La p\00E1gina no se ha exportado desde esta aplicaci\00F3n o se ha exportado desde un espacio de trabajo diferente.')
,p_when_button_pressed=>wwv_flow_api.id(77701419437857029.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(77712212771857073.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_imp_parser.parse (',
'     p_file_id          => :P67_FILE_ID,',
'     p_parse_as_schema  => :P67_PARSE_AS,',
'     p_install_as_flow  => :FB_FLOW_ID,',
'     p_original_flow_id => wwv_flow_imp_parser.get_flow_id(:P67_FILE_ID),',
'     p_adjust_offset    => false',
'     );',
':FB_FLOW_PAGE_ID := :P67_IMP_PAGE_ID;',
':F4000_P1_PAGE := :P67_IMP_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al instalar la p\00E1gina.')
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('P\00E1gina &P67_NEW_PAGE_ID. instalada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(479780812892535082.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P67_IMP_COMPANY := wwv_flow_imp_parser.get_security_group_id (p_file_id => :P49_FILE_ID);',
':P67_IMP_FLOW_ID := wwv_flow_imp_parser.get_flow_id (p_file_id => :P49_FILE_ID);',
':P67_IMP_PAGE_ID := wwv_flow_imp_parser.get_page_id (p_file_id => :P49_FILE_ID);',
':P67_IMP_VERSION := wwv_flow_imp_parser.get_version (:P49_FILE_ID);',
'',
'if :flow_security_group_id = :P67_IMP_COMPANY and',
'  :P67_IMP_FLOW_ID = :FB_FLOW_ID then',
'  :P67_INSTALL := ''Y'';',
'  :P67_company_action := wwv_flow_lang.system_message(''F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'');',
'else',
'  :P67_INSTALL := ''N'';',
'  :P67_company_action := ',
'    wwv_flow_lang.system_message(''F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'');',
'end if;',
'',
'for c1 in (',
'select locked_by',
'  from wwv_flow_steps p,',
'       WWV_FLOW_LOCK_PAGE l',
' where p.flow_id = :P67_IMP_FLOW_ID',
'   and p.id      = :P67_IMP_PAGE_ID',
'   and p.flow_id = l.flow_id(+)',
'   and p.id      = l.object_id(+)',
'   and p.security_group_id = :flow_security_group_id )',
'loop',
'   if c1.locked_by is not null then',
'      :P67_INSTALL := ''N'';',
'      :P67_company_action := ',
'           wwv_flow_lang.system_message(''F4000.P67.PAGE_LOCKED'');',
'   end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00068
begin
wwv_flow_api.create_page(
 p_id=>68.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asistente de \00C1rboles')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12314822012744006.4001)
,p_plug_name=>unistr('Crear \00C1rbol')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Identifique el bot\00F3n, la ayuda de burbuja y los atributos de enlace que desee definir en el \00E1rbol. Para convertir un texto de nodo de hoja en un enlace, seleccione <strong>Elemento de Aplicaci\00F3n Existente</strong>.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12316721797753450.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147901626307825228.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44710016230771834.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12317802188757170.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44710016230771834.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12319617772761735.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44710016230771834.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12318710500759647.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44710016230771834.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(484409901757342538.4001)
,p_branch_action=>'f?p=&APP_ID.:284:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(12319617772761735.4001)
,p_branch_sequence=>10
,p_branch_condition=>'P68_LINK_OPTION'
,p_branch_condition_text=>'NOTHING'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12319028553759648.4001)
,p_branch_action=>'126'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(12318710500759647.4001)
,p_branch_sequence=>2
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12227717562616643.4001)
,p_name=>'P68_LINK_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>unistr('P\00E1gina de Enlace')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||wwv_flow_escape.html(name) n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar P\00E1gina -')
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la p\00E1gina en la que existe el elemento de aplicaci\00F3n de enlace.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12228228297619694.4001)
,p_name=>'P68_LINK_PAGE_ITEM'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>'Enlazar Elemento'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||'': ''||name a, name b',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'union all',
'select ''Page: ''||flow_step_id||'': ''||name a, name b',
'  from wwv_flow_step_items',
' where flow_id = :FB_FLOW_ID',
'   and FLOW_STEP_ID = decode(:P68_LINK_PAGE_ID,''%null%'',null,:P68_LINK_PAGE_ID)',
' order by 1'))
,p_lov_cascade_parent_items=>'P68_LINK_PAGE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el elemento de aplicaci\00F3n para enlazar el texto de nodo de hoja.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12323419812809609.4001)
,p_name=>'P68_TREE_BUTTON_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_item_default=>'CONTRACT_ALL:EXPAND_ALL'
,p_prompt=>'Incluir Botones:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TREE_BUTTON_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(84309708763580409.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Seleccione los botones que se van a incluir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12868313257562055.4001)
,p_name=>'P68_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12869226416565848.4001)
,p_name=>'P68_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>'Page:'
,p_source=>'F4000_P112_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484393521581979290.4001)
,p_name=>'P68_SHOW_TOOLTIP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_item_default=>'N'
,p_prompt=>'Ayuda de Burbuja:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_TOOLTIP_OPTION'
,p_lov=>'.'||wwv_flow_api.id(484108402301064790.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Para ver una ayuda de burbuja al pasar el cursor sobre un nodo de hoja, seleccione una de las siguientes opciones:',
'<ul>',
unistr('<li>Asignaci\00F3n Est\00E1tica</li>'),
'<li>Columna de Base de Datos</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484394029892981675.4001)
,p_name=>'P68_TOOLTIP_TEXT'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>'Origen de Ayuda de Burbuja:'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'class="tabledata" nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Defina el texto que aparecer\00E1 como la ayuda de burbuja de los nodos de hoja.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484394507513984718.4001)
,p_name=>'P68_TOOLTIP_DB'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_item_default=>'ENAME'
,p_prompt=>'Columna de Ayuda de Burbuja:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_PAGE_WIZ_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el texto que aparecer\00E1 en la ayuda de burbuja de los nodos de hoja.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484395017556987667.4001)
,p_name=>'P68_LINK_OPTION'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>unistr('Opci\00F3n de Enlace:')
,p_source=>'NOTHING'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LINK_OPTION'
,p_lov=>'.'||wwv_flow_api.id(84330300975616054.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Para convertir el texto del nodo de hoja en enlace, seleccione <strong>Elemento de Aplicaci\00F3n Existente</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(797853405911419779.4001)
,p_name=>'P68_SELECTED_NODE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(12314822012744006.4001)
,p_prompt=>unistr('Elemento de P\00E1gina de Nodo Seleccionado')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'ALL ITEMS (PAGE AND APPLICATION)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, name r',
'from wwv_flow_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id',
'union all',
'select name d, name r',
'from wwv_flow_step_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id'))
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el elemento de aplicaci\00F3n o p\00E1gina para el que desee aplicar el valor de nodo seleccionado. Dicho elemento se puede utilizar para guardar el estado de \00E1rbol. Para ello, debe contener el valor del \00FAltimo nodo seleccionado. Este valor se pue')
||unistr('de guardar en el elemento seleccionado a trav\00E9s del atributo de enlace de nodo o de un proceso de p\00E1gina. Cuando se vuelva a cargar el \00E1rbol, \00E9ste se abrir\00E1 por el \00FAltimo nodo seleccionado. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488155611591485945.4001)
,p_validation_name=>'P68_TOOLTIP_TEXT Should not be null'
,p_validation_sequence=>10
,p_validation=>'P68_TOOLTIP_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe introducir un valor est\00E1tico en el campo Origen de Ayuda de Burbuja.')
,p_validation_condition=>'P68_SHOW_TOOLTIP'
,p_validation_condition2=>'STATIC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(12319617772761735.4001)
,p_associated_item=>wwv_flow_api.id(484394029892981675.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12239630225809505.4001)
,p_validation_name=>'Link Page Cannot Be Null'
,p_validation_sequence=>20
,p_validation=>'P68_LINK_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina de enlace.')
,p_validation_condition=>'P68_LINK_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(12319617772761735.4001)
,p_associated_item=>wwv_flow_api.id(12227717562616643.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12239807154812291.4001)
,p_validation_name=>'Link Item Cannot Be Null'
,p_validation_sequence=>30
,p_validation=>'P68_LINK_PAGE_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el elemento de enlace.'
,p_validation_condition=>'P68_LINK_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(12319617772761735.4001)
,p_associated_item=>wwv_flow_api.id(12228228297619694.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(484395506605993881.4001)
,p_name=>'DB Tooltip'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_SHOW_TOOLTIP'
,p_condition_element=>'P68_SHOW_TOOLTIP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DB'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484395805938993895.4001)
,p_event_id=>wwv_flow_api.id(484395506605993881.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P68_TOOLTIP_DB'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484396017087993897.4001)
,p_event_id=>wwv_flow_api.id(484395506605993881.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P68_TOOLTIP_DB'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(484396416648996816.4001)
,p_name=>'Static Tooltip'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_SHOW_TOOLTIP'
,p_condition_element=>'P68_SHOW_TOOLTIP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484396732451996816.4001)
,p_event_id=>wwv_flow_api.id(484396416648996816.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P68_TOOLTIP_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484396904111996817.4001)
,p_event_id=>wwv_flow_api.id(484396416648996816.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P68_TOOLTIP_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(12231402156649989.4001)
,p_name=>'Existing Link Option'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P68_LINK_OPTION'
,p_condition_element=>'P68_LINK_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12231730212649993.4001)
,p_event_id=>wwv_flow_api.id(12231402156649989.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P68_LINK_PAGE_ID,P68_LINK_PAGE_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12231908094649994.4001)
,p_event_id=>wwv_flow_api.id(12231402156649989.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P68_LINK_PAGE_ID,P68_LINK_PAGE_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549111431145558759.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(12317802188757170.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549111707065558759.4001)
,p_event_id=>wwv_flow_api.id(549111431145558759.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00069
begin
wwv_flow_api.create_page(
 p_id=>69.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('B\00FAsqueda por facetas de aplicaciones')
,p_step_title=>unistr('B\00FAsqueda por facetas de aplicaciones')
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'#showHideFacets { display: block; margin: 8px auto 16px auto;}'
,p_step_template=>wwv_flow_api.id(438185046231548086.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472529554367148622.4001)
,p_plug_name=>'Buscar'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(900178488329740816.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'N'
,p_attribute_13=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(900178488329740816.4001)
,p_name=>'Aplicaciones'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4000P69 */',
'app_id,',
'COMPATIBILITY_MODE,',
'theme,',
'authentication_scheme,',
'link,',
'app_name,',
'build_status,',
'last_updated_on,',
'page_count,',
'created,',
'groupname,',
'application_security_scheme,',
'logging,',
'page_protection_enabled_y_n,',
'flow_language',
'from (',
'    select',
'        f.id app_id,',
'        compatibility_mode,',
'        (select min(t.theme_name ||'' - '' || t.theme_id )',
'        from wwv_flow_user_interfaces l, ',
'             wwv_flow_themes t',
'        where l.flow_id    = f.id',
'            and t.flow_id  = l.flow_id',
'            and t.theme_id = l.theme_id) theme,',
'        (select max(name)',
'           from wwv_flow_authentications a',
'          where a.id = f.authentication_id',
'        ) as authentication_scheme,',
'        decode(f.build_status,',
'          ''RUN_ONLY'',',
'          ''f?p=4000:733:''||:app_session||''::::FB_FLOW_ID:''||f.id,',
'          ''f?p=4000:1:''||:app_session||''::''||:debug||',
'               '':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||f.id||'',''||f.id||'',''||f.id',
'        ) link,',
'        f.name as app_name,',
'        decode(f.build_status,',
'          ''RUN_AND_BUILD'', sm.run_and_build,',
'          ''RUN_ONLY'',sm.run_only,',
'          f.build_status) build_status,',
'        f.last_updated_on,',
'        (select count(*)',
'          from wwv_flow_steps',
'          where flow_id = f.id)',
'          page_count,',
'        f.created_on created,',
'        decode(group_id,null,sm.t_unassigned,',
'            (select max(group_name) n',
'            from wwv_flow_application_groups',
'            where id = f.group_id))',
'          groupname,',
'        nvl((select max(name)',
'           from   wwv_flow_security_schemes',
'           where flow_id = f.id and to_char(id) = f.security_scheme),sm.apex_no_authorization_scheme)',
'           application_security_scheme,',
'        decode(f.webdb_logging,''YES'',sm.t_yes,''NO'',sm.t_no,f.webdb_logging) logging,',
'        decode(f.page_protection_enabled_y_n,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          sm.t_no)',
'          page_protection_enabled_y_n,',
'        decode(f.rejoin_existing_sessions,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          rejoin_existing_sessions)',
'          rejoin_existing_sessions,',
'        f.flow_language',
'    from   wwv_flow_visible_flows f,',
'          (select wwv_flow_lang.system_message(''RUN'') run,',
'                  wwv_flow_lang.system_message(''EDIT'') edit,',
'                  wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'                  wwv_flow_lang.system_message(''F4000_F1500_LOCKED'') locked,',
'                  wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'                  wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                  wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'                  wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'                  wwv_flow_lang.system_message(''APP_TYPE_WEBSHEET'') app_type_websheet,',
'                  wwv_flow_lang.system_message(''APP_TYPE_DATABASE'') app_type_database,',
'                  wwv_flow_lang.system_message(''AVAILABLE'') available,',
'                  wwv_flow_lang.system_message(''AVAILABLE_WITH_EDIT_LINKS'') available_with_edit_links,',
'                  wwv_flow_lang.system_message(''AVAILABLE_TO_DEVELOPERS_ONLY'') available_to_developers_only,',
'                  wwv_flow_lang.system_message(''RESTRICTED_ACCESS'') restricted_access,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'') unavailable_plsql,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_REDIRECT_TO_URL'') unavailable_redirect_to_url,                                        ',
'                  wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'') apex_no_authorization_scheme,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE'') unavailable',
'           from dual) sm',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or (:P1500_SHOW = ''DATABASE''))',
'    union all',
'    select',
'        f.id app_id,',
'        '''' compatibility_mode,',
'        '''' theme,',
'        ''TBD'' authentication_scheme,',
'        ''f?p=4000:933:''||:app_session||''::''||:DEBUG||'':RP:P933_ID:''||f.id as link,',
'        f.name as app_name,',
'        null build_status,',
'        f.updated_on last_updated_on,',
'        (select count(*) c from WWV_FLOW_WS_WEBPAGES where WS_APP_ID = f.id) page_count,',
'        f.created_on created,',
'        ''N/A''  groupname,',
'        ''N/A''  application_security_scheme,',
'        ''Y''    logging,',
'        ''N/A''  page_protection_enabled_y_n,',
'        ''N/A''  rejoin_existing_sessions,',
'        ''N/A''  flow_language',
'    from  WWV_FLOW_WS_APPLICATIONS f,',
'          (select wwv_flow_lang.system_message(''RUN'') run,',
'                  wwv_flow_lang.system_message(''EDIT'') edit,',
'                  wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'                  wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'                  wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                  wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'                  wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'                  wwv_flow_lang.system_message(''APP_TYPE_WEBSHEET'') app_type_websheet,',
'                  wwv_flow_lang.system_message(''APP_TYPE_PACKAGED_WS'') app_type_packaged_ws,',
'                  wwv_flow_lang.system_message(''UI_TYPE.DESKTOP'') ui_type,',
'                  wwv_flow_lang.system_message(''AVAILABLE'') available,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE'') unavailable',
'           from sys.dual ) sm',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or :P1500_SHOW = ''WEBSHEET'')',
'      and f.security_group_id = :flow_security_group_id',
'      and exists (',
'           select 1 from wwv_flow_developers',
'           where userid            = :flow_user',
'             and (flow_id is null  or flow_id = f.id)',
'             and security_group_id = :flow_security_group_id)',
')'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395888387250084641.4001)
,p_query_column_id=>1
,p_column_alias=>'APP_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('ID de aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472530996849148636.4001)
,p_query_column_id=>2
,p_column_alias=>'COMPATIBILITY_MODE'
,p_column_display_sequence=>31
,p_column_heading=>'Compatibilidad'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472531227396148639.4001)
,p_query_column_id=>3
,p_column_alias=>'THEME'
,p_column_display_sequence=>41
,p_column_heading=>'Tema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395888573290084643.4001)
,p_query_column_id=>4
,p_column_alias=>'AUTHENTICATION_SCHEME'
,p_column_display_sequence=>11
,p_column_heading=>unistr('Esquema de Autenticaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395888679917084644.4001)
,p_query_column_id=>5
,p_column_alias=>'LINK'
,p_column_display_sequence=>51
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(395888856174084646.4001)
,p_query_column_id=>6
,p_column_alias=>'APP_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#APP_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472527576117148602.4001)
,p_query_column_id=>7
,p_column_alias=>'BUILD_STATUS'
,p_column_display_sequence=>17
,p_column_heading=>unistr('Estado de Creaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472527744149148604.4001)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>21
,p_column_heading=>unistr('\00DAltima Actualizaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472527814194148605.4001)
,p_query_column_id=>9
,p_column_alias=>'PAGE_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>unistr('P\00E1ginas')
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472528005208148607.4001)
,p_query_column_id=>10
,p_column_alias=>'CREATED'
,p_column_display_sequence=>20
,p_column_heading=>'Creado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472528396835148610.4001)
,p_query_column_id=>11
,p_column_alias=>'GROUPNAME'
,p_column_display_sequence=>61
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472528491819148611.4001)
,p_query_column_id=>12
,p_column_alias=>'APPLICATION_SECURITY_SCHEME'
,p_column_display_sequence=>71
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472528535173148612.4001)
,p_query_column_id=>13
,p_column_alias=>'LOGGING'
,p_column_display_sequence=>81
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472528803860148615.4001)
,p_query_column_id=>14
,p_column_alias=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_column_display_sequence=>91
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(472529035122148617.4001)
,p_query_column_id=>15
,p_column_alias=>'FLOW_LANGUAGE'
,p_column_display_sequence=>101
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(971848600399010722.4001)
,p_plug_name=>'Facets Header'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472527011036145986.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(971848600399010722.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:RR,69::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472529694774148623.4001)
,p_name=>'P69_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Nuevo'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472529743229148624.4001)
,p_name=>'P69_AUTHENTICATION_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>unistr('Autenticaci\00F3n')
,p_source=>'AUTHENTICATION_SCHEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472529939157148626.4001)
,p_name=>'P69_BUILD_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>unistr('Estado de Creaci\00F3n')
,p_source=>'BUILD_STATUS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472530040461148627.4001)
,p_name=>'P69_FLOW_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Idioma'
,p_source=>'FLOW_LANGUAGE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472530153075148628.4001)
,p_name=>'P69_LOGGING'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Registro'
,p_source=>'LOGGING'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472530249147148629.4001)
,p_name=>'P69_APP_SECURITY_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Esquema de Seguridad'
,p_source=>'APPLICATION_SECURITY_SCHEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472530716214148634.4001)
,p_name=>'P69_PAGE_COUNT'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>unistr('P\00E1ginas')
,p_source=>'PAGE_COUNT'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:1 to 10;|11,11 - 50;11|51,51 - 100;51|101,101 - 200;101|201,> 200;201|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472530896423148635.4001)
,p_name=>'P69_GROUPNAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Grupo'
,p_source=>'GROUPNAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472531042786148637.4001)
,p_name=>'P69_COMPATIBILITY_MODE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Compatibilidad'
,p_source=>'COMPATIBILITY_MODE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472531164541148638.4001)
,p_name=>'P69_PAGE_PROTECTION_ENABLED_Y_N'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_source=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472531318995148640.4001)
,p_name=>'P69_THEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472529554367148622.4001)
,p_prompt=>'Tema'
,p_source=>'THEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_api.create_page(
 p_id=>70.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Regiones Personalizadas'
,p_step_title=>'Regiones Personalizadas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193875214737578082.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193881218370698706.4001)
,p_plug_name=>'Regiones Personalizadas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="''',
'        ||apex_util.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''',
'            ||wwv_flow_escape.html(page_id))',
'        ||''">''||wwv_flow_escape.html(page_id)||''</a>'' PAGE_ID, ',
'    ''<a href="''||apex_util.prepare_url(''f?p=4000:4500:''||:flow_session',
'        ||'':::4500:FB_FLOW_PAGE_ID:''||wwv_flow_escape.html(page_id))||''#5110:'' || wwv_flow_escape.html(id) || ''">''',
'        ||wwv_flow_escape.html(PLUG_NAME)||''</a>''',
'    region_name, ',
'    PLUG_DISPLAY_SEQUENCE, ',
'    PLUG_DISPLAY_COLUMN,',
'    PLUG_CUSTOMIZED,',
'    PLUG_CUSTOMIZED_NAME cn,',
'    LAST_UPDATED_BY, LAST_UPDATED_ON',
'from WWV_FLOW_PAGE_PLUGS',
'where flow_id = :fb_flow_id and',
'      plug_customized is not null and',
'      plug_customized > ''0'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193881326920698706.4001)
,p_name=>'Customized Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193881520087698709.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193881612946698710.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193881703189698711.4001)
,p_db_column_name=>'PLUG_DISPLAY_SEQUENCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193881803257698712.4001)
,p_db_column_name=>'PLUG_DISPLAY_COLUMN'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Columna'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193881903887698713.4001)
,p_db_column_name=>'PLUG_CUSTOMIZED'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Personalizado'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193882008321698713.4001)
,p_db_column_name=>'CN'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Nombre de Personalizaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193882116954698714.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193882218927698715.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Fecha'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193878809552652309.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193881218370698706.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:70,RIR::'
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_api.create_page(
 p_id=>71.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Panel de Control de Aplicaciones'
,p_step_title=>'Panel de Control de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#pagesbytype .rc-content-bin'').css(''height'',''300px'');',
'apex.jQuery(''#applicationcomponents .rc-content-bin'').css(''height'',''300px'');',
'apex.jQuery(''#pagecomponents .rc-content-bin'').css(''height'',''300px'');'))
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47933510325044189.4001)
,p_name=>unistr('Componentes de P\00E1gina')
,p_region_name=>'pagecomponents'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  n n,',
'  ''<a href="f?p=4000:''||wwv_flow_escape.html(p)||'':''||:app_session||''">''||',
'    to_char(wwv_flow_escape.html(c),''999G999G999G999G990'')||''</a>'' v,',
'  c',
'from ',
'(',
'select wwv_flow_lang.system_message(''BUTTONS'')  n, count(*) c, 548 p',
'from wwv_flow_step_buttons where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''REGIONS'')  n, count(*) c, 249 p',
'from wwv_flow_page_plugs where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''ITEMS'')  n, count(*) c, 547 p ',
'from wwv_flow_step_items where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''BRANCHES'')  n, count(*) c, 563 p ',
'from wwv_flow_step_branches where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''PROCESSES'')  n, count(*) c, 552 p',
'from WWV_FLOW_STEP_PROCESSING where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''DYNAMIC ACTIONS'') n, count(*) c, 699 p',
'from wwv_flow_page_da_events where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''CLASSIC_REPORT_COLUMNS'')  n, count(*) c, 217 p',
'from wwv_flow_region_report_column where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''IR_COLUMNS'') n, count(*) c, 690 p',
'from wwv_flow_worksheet_columns where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''COMPUTATIONS'') n, count(*) c, 549 p',
'from wwv_flow_step_computations where flow_id = :fb_flow_id',
') x',
'order by 3 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041646592238406593.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47933510325044189.4001)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47933811156044203.4001)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47933914604044205.4001)
,p_query_column_id=>2
,p_column_alias=>'V'
,p_column_display_sequence=>2
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47934330757050138.4001)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47934922755095158.4001)
,p_name=>unistr('Componentes de Aplicaci\00F3n')
,p_region_name=>'applicationcomponents'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  n n,',
'  ''<a href="f?p=4000:''||wwv_flow_escape.html(p)||'':''||:app_session||''">''||',
'    to_char(wwv_flow_escape.html(c),''999G999G999G999G990'')||''</a>'' v,',
'  c',
'from ',
'(',
'select wwv_flow_lang.system_message(''LAYOUT.T_LISTS'') n, count(*) c, 405  p',
'from wwv_flow_lists where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''SHORTCUTS'') n, count(*) c, 4047  p',
'from wwv_flow_shortcuts where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''LAYOUT.T_LOV'') n, count(*) c, 4110 p',
'from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''LAYOUT.T_ALT_STD_TAB'') n, count(*)  c, 9000  p',
'from wwv_flow_tabs where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''APPLICACTION_PROCESS'') n, count(*) c, 4207 p',
'from wwv_flow_processing where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''APPLICACTION_COMPUTATIONS'') n, count(*) c, 4101 p',
'from wwv_flow_computations where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''APPLICATION_ITEMS'') n, count(*) c, 4100 p',
'from wwv_flow_items where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''BUILDER.PLUGINS'') n, count(*) c, 4400 p',
'from wwv_flow_plugins where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
') x',
'order by 3 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041646592238406593.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47934922755095158.4001)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47935313339095159.4001)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47935132457095159.4001)
,p_query_column_id=>2
,p_column_alias=>'V'
,p_column_display_sequence=>2
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47935200415095159.4001)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47936724757190349.4001)
,p_name=>unistr('P\00E1ginas por Tipo')
,p_region_name=>'pagesbytype'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'      decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''21'',sm.apex_interactive_grid,',
'         ''22'',sm.apex_faceted_search,',
'         ''unknown'') page_type,',
'         c',
'from',
'(',
'select PAGE_COMPONENT_MAP,       ',
'       count(*) c',
'from  ',
'     (select PAGE_COMPONENT_MAP from wwv_flow_steps where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id) p',
'group by page_component_map',
'order by 2 desc',
') q,',
'      (select ',
'           wwv_flow_lang.system_message(''LOCKED'') locked,',
'           wwv_flow_lang.system_message(''RUN'') run,',
'           wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''INTERACTIVE_GRID'') apex_interactive_grid,',
'           wwv_flow_lang.system_message(''REGION_NAME.NATIVE_FACETED_SEARCH'') apex_faceted_search,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual)  sm'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041646592238406593.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47936724757190349.4001)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47938028567191395.4001)
,p_query_column_id=>1
,p_column_alias=>'PAGE_TYPE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47937009479190352.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>1
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47938203333212486.4001)
,p_name=>unistr('Visi\00F3n General de la Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       alias,',
'       name,',
'       trim(to_char((',
'         select count(*) from wwv_flow_steps where flow_id = f.id),',
'         ''999G999G990'')) pages,',
'       owner parsing_schema,',
'       (select group_name',
'        from WWV_FLOW_APPLICATION_GROUPS g ',
'        where g.id = f.group_id) application_group',
'from wwv_flows f',
'where id = :fb_flow_id and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47938718571216899.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Identificador'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47941804765241333.4001)
,p_query_column_id=>2
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>4
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47938831927216900.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47941514677234658.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGES'
,p_column_display_sequence=>6
,p_column_heading=>unistr('P\00E1ginas')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47942302127262422.4001)
,p_query_column_id=>5
,p_column_alias=>'PARSING_SCHEMA'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Esquema de An\00E1lisis')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47943602004316184.4001)
,p_query_column_id=>6
,p_column_alias=>'APPLICATION_GROUP'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47944910793328206.4001)
,p_name=>'Seguridad'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       (select a.name',
'          from wwv_flow_authentications a',
'         where a.id                = f.authentication_id',
'           and a.security_group_id = f.security_group_id ) application_authentication,',
'       (select count(*) ',
'        from wwv_flow_steps p',
'        where p.flow_id = f.id and nvl(PAGE_IS_PUBLIC_Y_N,''N'') = ''Y'') ',
'        public_pages,',
'       (select count(*) ',
'        from wwv_flow_steps p',
'        where p.flow_id = f.id and nvl(PAGE_IS_PUBLIC_Y_N,''N'') = ''N'') ',
'        pages_requiring_authentication,',
'       (select count(*) ',
'        from WWV_FLOW_SECURITY_SCHEMES s',
'        where s.flow_id = f.id) authorization_schemes',
'',
'from wwv_flows f',
'where id = :fb_flow_id and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(47944910793328206.4001)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47946627546342517.4001)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_AUTHENTICATION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Autenticaci\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47946723201342517.4001)
,p_query_column_id=>2
,p_column_alias=>'PUBLIC_PAGES'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1ginas P\00FAblicas')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47946810958342518.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGES_REQUIRING_AUTHENTICATION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('No P\00FAblico')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47947111878356845.4001)
,p_query_column_id=>4
,p_column_alias=>'AUTHORIZATION_SCHEMES'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Esquemas de Autorizaci\00F3n')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(84541872937706844.4001)
,p_plug_name=>unistr('Uso de regi\00F3n de plugin')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>119
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,8)'))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(84541920403706845.4001)
,p_region_id=>wwv_flow_api.id(84541872937706844.4001)
,p_chart_type=>'bar'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(84542085397706846.4001)
,p_chart_id=>wwv_flow_api.id(84541920403706845.4001)
,p_seq=>10
,p_name=>'Componentes'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(substr(plug_source_type,12),''_'','' '') region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type  like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,12)',
'order by 2 desc'))
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(84542170092706847.4001)
,p_chart_id=>wwv_flow_api.id(84541920403706845.4001)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(84542213584706848.4001)
,p_chart_id=>wwv_flow_api.id(84541920403706845.4001)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(632975865957652814.4001)
,p_name=>'Plantillas'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>35
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p name,',
'    c',
'from (  select count(*) c, wwv_flow_lang.system_message_lit(''F4000.BUTTON'') p',
'        from wwv_flow_button_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''LABEL'') p',
'        from wwv_flow_field_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') p',
'        from wwv_flow_list_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.PAGE'') p',
'        from wwv_flow_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.REGION'') p',
'        from wwv_flow_page_plug_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') p',
'        from wwv_flow_popup_lov_template where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''REPORT'') p',
'        from wwv_flow_row_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') p',
'        from wwv_flow_cal_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''BREADCRUMB'') p',
'        from wwv_flow_menu_templates where flow_id = :FB_FLOW_ID',
')',
'order by c desc, p'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041646592238406593.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(632975865957652814.4001)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632976679950666980.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632976273620652819.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RIR,4003:IR_T:#NAME#'
,p_column_linktext=>'#C#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3348608641169757722.4001)
,p_plug_name=>unistr('Uso de componente de regi\00F3n nativo')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>109
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           ''FACETED_SEARCH'',wwv_flow_lang.system_message(''FACETED_SEARCH''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,8)'))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(3348608791771757723.4001)
,p_region_id=>wwv_flow_api.id(3348608641169757722.4001)
,p_chart_type=>'bar'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
end;
/
begin
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(3348608870920757724.4001)
,p_chart_id=>wwv_flow_api.id(3348608791771757723.4001)
,p_seq=>10
,p_name=>'Componentes'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           ''FACETED_SEARCH'',wwv_flow_lang.system_message(''FACETED_SEARCH''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,8)',
'order by 2 desc'))
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(3348609002035757726.4001)
,p_chart_id=>wwv_flow_api.id(3348608791771757723.4001)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(3348608950094757725.4001)
,p_chart_id=>wwv_flow_api.id(3348608791771757723.4001)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00072
begin
wwv_flow_api.create_page(
 p_id=>72.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Suprimir Varias P\00E1ginas')
,p_step_title=>unistr('Suprimir Varias P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25052209152935832.4001)
,p_plug_name=>unistr('Suprimir Varias P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Al suprimir una p\00E1gina, se suprimen los correspondientes separadores, rutas de navegaci\00F3n y entradas de lista. S\00F3lo puede suprimir las p\00E1ginas que haya bloqueado o desbloqueado el usuario. '),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48375508589894234.4001)
,p_plug_name=>unistr('Suprimir P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119584224506190502.4001)
,p_plug_name=>'Botones'
,p_parent_plug_id=>wwv_flow_api.id(48375508589894234.4001)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48378020410926089.4001)
,p_plug_name=>'delete Multiple Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(48377323742917579.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48376123760897143.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1119584224506190502.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir P\00E1ginas')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48375918631897142.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119584224506190502.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48376431445900902.4001)
,p_name=>'P72_FROM_PAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48375508589894234.4001)
,p_prompt=>unistr('Desde P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Rango inicial de n\00FAmeros de p\00E1gina que se van a suprimir.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48376609066903899.4001)
,p_name=>'P72_TO_PAGE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48375508589894234.4001)
,p_prompt=>unistr('Hasta P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Rango final de n\00FAmeros de p\00E1gina que se van a suprimir.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1301369776665065006.4001)
,p_validation_name=>'No Pages in Defined Range'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select count(p.id) page_cnt',
'       from wwv_flow_steps p,',
'            wwv_flow_lock_page l',
'      where p.flow_id = :fb_flow_id',
'        and p.security_group_id = :flow_security_group_id',
'        and p.id between to_number(:P72_FROM_PAGE) and to_number(:P72_TO_PAGE)',
'        and p.flow_id = l.flow_id (+)',
'        and p.id = l.object_id (+)',
'        and (l.locked_by is null or',
'             l.locked_by = :APP_USER) ) loop',
'    if c1.page_cnt = 0 then ',
'      return false;',
'    else',
'      return true;',
'    end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No existe ninguna p\00E1gina en el rango de p\00E1ginas que ha definido.')
,p_validation_condition=>':P72_FROM_PAGE is not null and :P72_TO_PAGE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(48376123760897143.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48376704695912050.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete Multiple Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'',
'   select p.id page_id',
'     from wwv_flow_steps p,',
'          wwv_flow_lock_page l',
'    where p.flow_id = :fb_flow_id',
'      and p.security_group_id = :flow_security_group_id',
'      and p.id between to_number(:P72_FROM_PAGE) and to_number(:P72_TO_PAGE)',
'      and p.flow_id = l.flow_id (+)',
'      and p.id = l.object_id (+)',
'      and (l.locked_by is null or',
'           l.locked_by = :APP_USER) )',
'loop',
'',
'   -- delete page',
'   delete from wwv_flow_steps',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and id = c1.page_id;',
'',
'   -- tabs',
'   delete from wwv_flow_tabs',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and TAB_STEP = c1.page_id;',
'',
'   -- menus (breadcrumbs)',
'   delete from WWV_FLOW_MENU_OPTIONS',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and page_id = c1.page_id',
'      and ALSO_CURRENT_FOR_PAGES is null;',
'',
'   -- list items',
'   delete from WWV_FLOW_LIST_ITEMS',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id ',
'      and LIST_ITEM_CURRENT_FOR_PAGES = to_char(c1.page_id);',
'',
'   -- list item entries',
'   delete from WWV_FLOW_LIST_ITEMS',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id ',
'      and upper(LIST_ITEM_LINK_TARGET) like ''F?P=%:''||to_char(c1.page_id)||'':%'';',
'',
'   -- locked page',
'   delete from wwv_flow_lock_page',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and object_id = c1.page_id;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(48376123760897143.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id page_id',
'     from wwv_flow_steps p,',
'          wwv_flow_lock_page l',
'    where p.flow_id = :fb_flow_id',
'      and p.security_group_id = :flow_security_group_id',
'      and p.id between to_number(:P72_FROM_PAGE) and to_number(:P72_TO_PAGE)',
'      and p.flow_id = l.flow_id (+)',
'      and p.id = l.object_id (+)',
'      and (l.locked_by is null or',
'           l.locked_by = :APP_USER) '))
,p_process_when_type=>'EXISTS'
,p_process_success_message=>unistr('P\00E1ginas suprimidas')
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_api.create_page(
 p_id=>73.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Repositorio de Exportaci\00F3n')
,p_step_title=>unistr('Repositorio de Exportaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49518014041474783.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(78240013758270704.4001)
,p_name=>unistr('Repositorio de Exportaci\00F3n')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' q varchar2(32767) := null;',
' l_install varchar2(4000) := wwv_flow_lang.system_message(''F4050.INSTALL'');',
'begin',
'  q:=''select '';  ',
'  q:=q||''''''<input type="checkbox" NAME="f01" VALUE="''''||id||''''" TITLE="''''||wwv_flow_lang.system_message(''''DELETE_LABEL'''',wwv_flow_escape.html(title))||''''">'''' cb, '';',
'  q:=q||''flow_id, '';',
'  q:=q||''decode(wwv_flow_imp_parser.flow_exists(flow_id),1,''''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''''||wwv_flow_lang.system_message(''''YES'''')||''''</span>'''',null) exist, '';',
'  q:=q||''wwv_flow_escape.html(title) title, '';',
'  q:=q||''wwv_flow_escape.html(mime_type) mime_type, '';',
'  q:=q||''doc_size, '';',
'  q:=q||''wwv_flow_escape.html(created_by) created_by, '';',
'  q:=q||''created_on co, '';',
'  q:=q||''file_type, '';',
'  q:=q||''id, '';',
'  q:=q||''decode(file_type,'';',
'  q:=q||''''''FLOW_EXPORT'''','';',
'  q:=q||''htf.anchor(''''f?p=&FLOW_ID.:49:''||:flow_session||'':::49:P49_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''WEBSHEET_EXPORT'''','';',
'  q:=q||''htf.anchor(''''f?p=&FLOW_ID.:494:''||:flow_session||'':::494:P494_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''PLUGIN'''','';',
'  q:=q||''sys.htf.anchor(''''f?p=&FLOW_ID.:4450:''||:flow_session||'':::4450:P4450_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''PAGE_EXPORT'''','';',
'  q:=q||''sys.htf.anchor(''''f?p=&FLOW_ID.:67:''||:flow_session||'':::67:P49_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''THEME'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:253:''||:flow_session||'':::253:P253_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''UI_DEFAULTS'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:321:''||:flow_session||'':::321:P321_FILE_ID:''''||id,'''''' || l_install || ''''''),'';      ',
'  q:=q||''''''FEEDBACK'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:929:''||:flow_session||'':::929:P929_FILE_ID:''''||id,'''''' || l_install || ''''''),'';  ',
'  q:=q||''''''CATALOG'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:1966:''||:flow_session||'':::1966:P1966_FILE_ID:''''||id,'''''' || l_install || ''''''),'';  ',
'  q:=q||''null) action, '';',
'  q:=q||''created_on + delete_after_days to_be_deleted '';',
'  q:=q||''from WWV_FLOW_FILE_OBJECTS$, (select wwv_flow_platform.get_preference(''''DELETE_UPLOADED_FILES_AFTER_DAYS'''') delete_after_days from dual) x '';',
'  q:=q||''where security_group_id = :flow_security_group_id and  '';',
'  q:=q||''   deleted_as_of = to_date(''''01.01.0001'''',''''MM.DD.YYYY'''') and  '';',
'  ',
'  if replace(:p73_show,''%''||''null%'',null) is not null then',
'    q:=q||''   file_type = :P73_SHOW'';',
'  else',
'    q:=q||''   file_type in (''''FLOW_EXPORT'''',''''WEBSHEET_EXPORT'''',''''PLUGIN'''', ''''PAGE_EXPORT'''',''''CSS_EXPORT'''',''''IMAGE_EXPORT'''',''''THEME'''',''''UI_DEFAULTS'''',''''FILE_EXPORT'''',''''FEEDBACK'''',''''CATALOG'''') ''; ',
'  end if;',
'  if trim(:P73_FIND) is not null then',
'    q:=q||'' and instr(to_char(flow_id)||'''' ''''||upper(created_by)||'''' ''''||upper(title),upper(:P73_FIND)) > 0 '';',
'  end if;',
'',
'  if :P73_OWNER is not null and :P73_OWNER != ''0'' then',
'    q:=q||'' and created_by = :P73_OWNER '';',
'  end if;',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna exportaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 31-JUL-2001 13:40:41'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739301214771908.4001)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739402835771908.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(53516718608859766.4001)
,p_query_column_id=>3
,p_column_alias=>'EXIST'
,p_column_display_sequence=>10
,p_column_heading=>unistr('La aplicaci\00F3n existe')
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739510203771908.4001)
,p_query_column_id=>4
,p_column_alias=>'TITLE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('T\00EDtulo del Contenido')
,p_column_link=>'p?n=#ID#'
,p_column_linktext=>'#TITLE#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739627939771908.4001)
,p_query_column_id=>5
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'MimeType'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739728426771908.4001)
,p_query_column_id=>6
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Tama\00F1o del Documento')
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739827912771909.4001)
,p_query_column_id=>7
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Creado por'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48739905785771909.4001)
,p_query_column_id=>8
,p_column_alias=>'CO'
,p_column_display_sequence=>7
,p_column_heading=>'Creado'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48740014995771909.4001)
,p_query_column_id=>9
,p_column_alias=>'FILE_TYPE'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Tipo de Exportaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84313028848586180)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48740113675771909.4001)
,p_query_column_id=>10
,p_column_alias=>'ID'
,p_column_display_sequence=>9
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(53489604868713799.4001)
,p_query_column_id=>11
,p_column_alias=>'ACTION'
,p_column_display_sequence=>11
,p_column_heading=>unistr('Acci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(173652221918037574.4001)
,p_query_column_id=>12
,p_column_alias=>'TO_BE_DELETED'
,p_column_display_sequence=>12
,p_column_heading=>'Para Suprimir'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226286701160894667.4001)
,p_plug_name=>'Report Current Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :fb_flow_id is null then',
'    sys.htp.prn(''<span class="htmldbRunEdit">''||',
'       wwv_flow_lang.system_message(''no_application_selected'')||''&nbsp;</span>'');',
'else',
'   sys.htp.prn(''<span class="htmldbRunEdit">''||',
'    wwv_flow_lang.system_message(''application'')||'': ''||:fb_flow_id||''&nbsp;</span>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49560212440483792.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(49518014041474783.4001)
,p_button_name=>'P73_GO'
,p_button_static_id=>'P73_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Definir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78283817054597201.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(49518014041474783.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47003300946069934.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(49518014041474783.4001)
,p_button_name=>'IMPORT_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Importar Archivo'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:459,460:P461_EXPIMP:IMPORT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226294601900923228.4001)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49556722006477082.4001)
,p_name=>'P73_SHOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(49518014041474783.4001)
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(84313028848586180.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tipo de contenido y haga clic en <span class="fielddatabold">Ir</span>.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(131910701379655614.4001)
,p_name=>'P73_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(49518014041474783.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(217479517429209651.4001)
,p_name=>'P73_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(49518014041474783.4001)
,p_prompt=>'Propietario'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct created_by d, created_by r',
'from WWV_FLOW_FILE_OBJECTS$',
'where security_group_id = :flow_security_group_id and',
'deleted_as_of = to_date(''01.01.0001'',''MM.DD.YYYY'') and ',
'       created_by != ''HTMLDB_PUBLIC_USER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Propietarios -'
,p_lov_null_value=>'0'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un propietario y haga clic en <span class="fielddatabold">Ir</span>.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78294225357608359.4001)
,p_validation_name=>'File Selection Not Null'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Seleccione los archivos que desea suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(78283817054597201.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157777646309618621.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(78240013758270704.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157777798660618622.4001)
,p_event_id=>wwv_flow_api.id(1157777646309618621.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78289504019603042.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i) and',
'           security_group_id = :flow_security_group_id',
'   ;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir los archivos.'
,p_process_when_button_id=>wwv_flow_api.id(78283817054597201.4001)
,p_process_success_message=>'Archivos suprimidos.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49561122829486861.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00075
begin
wwv_flow_api.create_page(
 p_id=>75.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Verificar Suscripci\00F3n a Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Verificar Suscripci\00F3n a Tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1449460199854055504.4001)
,p_plug_name=>unistr('Estado de la Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--success:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_source=>'El tema actual coincide con el tema maestro '
,p_plug_display_condition_type=>'ITEM_IS_ZERO'
,p_plug_display_when_condition=>'P75_TEMPLATE_ERRORS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1449467212952099784.4001)
,p_name=>unistr('Estado de la Suscripci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  c001 flow_id,',
'  c002 theme_id,',
'  c003 template_type,',
'  c004 template_name,',
'  c005 template_id,',
'  c006 reference_id,',
'  c007 status',
'from wwv_flow_collections where collection_name = ''THEME_COMPARE'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449583210096285755.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449583397045285757.4001)
,p_query_column_id=>2
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Theme ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449583435185285757.4001)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Plantilla'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84336604916626643)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449583525390285757.4001)
,p_query_column_id=>4
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre de la Plantilla'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449583674162285757.4001)
,p_query_column_id=>5
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Template Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449583797518285757.4001)
,p_query_column_id=>6
,p_column_alias=>'REFERENCE_ID'
,p_column_display_sequence=>6
,p_column_heading=>'Reference Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1449588256960314290.4001)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(1467334342209901488)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1467171150731485943.4001)
,p_plug_name=>unistr('Estado de la Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_source=>'El tema actual no coincide con el tema maestro'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'ITEM_IS_NOT_ZERO'
,p_plug_display_when_condition=>'P75_TEMPLATE_ERRORS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1475880097081627409.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1475880158104627410.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1475880097081627409.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1467336217105916237.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1475880097081627409.4001)
,p_button_name=>'REFRESH_THEME'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Tema'
,p_button_position=>'NEXT'
,p_button_condition=>'P75_TEMPLATE_ERRORS'
,p_button_condition_type=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1449460366604055506.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1475880097081627409.4001)
,p_button_name=>'OK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aceptar'
,p_button_position=>'NEXT'
,p_button_condition=>'P75_TEMPLATE_ERRORS'
,p_button_condition_type=>'ITEM_IS_ZERO'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1467362574290930207.4001)
,p_branch_name=>'Go To Page 267'
,p_branch_action=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'REFRESH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449460203341055505.4001)
,p_name=>'P75_TEMPLATE_ERRORS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1449467212952099784.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1467562397353981872.4001)
,p_name=>'P75_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1449467212952099784.4001)
,p_prompt=>'Theme Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1467562577956983855.4001)
,p_name=>'P75_REFERENCE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1449467212952099784.4001)
,p_prompt=>'Reference Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1476828701981906515.4001)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1467336217105916237.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1476829074977906517.4001)
,p_event_id=>wwv_flow_api.id(1476828701981906515.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1467337210462923661.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P75_REFERENCE_ID,',
'    p_subscribing_theme_id => :P75_THEME_ID',
');',
'',
'declare ',
'  l_template_errors number := 0;',
'begin',
'  l_template_errors := wwv_flow_copy_metadata.compare_themes(:P267_ID);',
'  apex_util.set_session_state(',
'    p_name => ''P75_TEMPLATE_ERRORS'',',
'    p_value => l_template_errors);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1476829321397910969.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1475880158104627410.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1449460422627055507.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Ok'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1449460366604055506.4001)
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_api.create_page(
 p_id=>76.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar Espacio de Trabajo'
,p_step_title=>'Exportar Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_users.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79092524857007202.4001)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_header=>'Exporta el espacio de trabajo, grupos de usuarios, usuarios y datos de desarrollo de equipos.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79093621622008691.4001)
,p_plug_name=>'Exportar Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina s\00F3lo est\00E1 disponible para administradores de espacio de trabajo.</p> '),
unistr('<p>Utilice esta p\00E1gina para crear un script SQL de texto ASCII de usuarios, grupos de usuarios y datos de desarrollo de equipos (si los hay).</p>'),
unistr('<p>Tambi\00E9n puede utilizar esta p\00E1gina para exportar privilegios de desarrollador y para mover los desarrolladores que ha creado de una instalaci\00F3n de &PRODUCT_NAME. a otra.</p>'),
unistr('<p>No incluya datos de desarrollo de equipos si desea importar el espacio de trabajo a un entorno s\00F3lo de tiempo de ejecuci\00F3n.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79102928295020779.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168863917634945552.4001)
,p_plug_name=>'Exportar Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486306511850160598.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168863917634945552.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:76::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79100309577017218.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168863917634945552.4001)
,p_button_name=>'Export'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(99856404704792438.4001)
,p_name=>'P76_FILE_FORMAT'
,p_item_sequence=>33
,p_item_plug_id=>wwv_flow_api.id(79092524857007202.4001)
,p_source=>'UNIX'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162691910539389529.4001)
,p_name=>'P76_FILE_CHARSET'
,p_item_sequence=>43
,p_item_plug_id=>wwv_flow_api.id(79092524857007202.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Caracteres de Archivo:'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486366513365294425.4001)
,p_name=>'P76_WORKSPACE_USER_COUNT'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(79092524857007202.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Recuento de Usuarios de Espacio de Trabajo:'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_source=>'select count(*) from wwv_flow_fnd_user where security_group_id = :flow_security_group_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica el n\00FAmero de usuarios que se van a exportar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(618935020457553799.4001)
,p_name=>'P76_INCLUDE_TEAM_DEVELOPMENT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_api.id(79092524857007202.4001)
,p_item_default=>'Y'
,p_prompt=>'Incluir Desarrollo de Equipos'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Def\00EDnala en <strong>Activado</strong> si desea incluir datos de desarrollo de equipos como funciones, hitos, tareas, bugs, comentarios, enlaces y noticias en el'),
unistr('archivo de exportaci\00F3n del espacio de trabajo.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1796417873996006107.4001)
,p_name=>'P76_MINIMAL'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(79092524857007202.4001)
,p_item_default=>'MIN'
,p_prompt=>unistr('Tipo de Exportaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P76_EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2046972184417676036.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina el valor en <strong>Completo</strong> solo si desea replicar en otra instancia todos los artefactos del espacio de trabajo, incluidos los scripts SQL, el historial de comandos SQL, el SQL guardado, los modelos de SQL r\00E1pido guardados, las pref')
||unistr('erencias del usuario, el historial de conexiones del desarrollador, los logs de correo electr\00F3nico y los valores por defecto de la interfaz de usuario. En la mayor\00EDa de los casos, no debe cambiar el valor <strong>M\00EDnimo</strong> por defecto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651513622966755629.4001)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(79100309577017218.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651513777578755630.4001)
,p_event_id=>wwv_flow_api.id(651513622966755629.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'Export'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79119417641132091.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'wwv_flow_utilities.print_download_header (',
'    p_mime_type     => ''application/x-sql'',',
'    p_mime_charset  => ''utf-8'',',
'    p_file_name     => wwv_flow_security.find_company_name(wwv_flow_security.g_security_group_id)||''.sql'',',
'    p_is_attachment => false );',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_utilities.export_workspace (',
'    p_workspace_id             => wwv_flow_security.g_security_group_id,',
'    p_format                   => :P76_FILE_FORMAT,',
'    p_include_team_development => (nvl(:P76_INCLUDE_TEAM_DEVELOPMENT, ''Y'') = ''Y''),',
'    p_minimal                  => (nvl(:P76_MINIMAL,''x'') = ''MIN''));',
'',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al exportar el espacio de trabajo.'
,p_process_when_button_id=>wwv_flow_api.id(79100309577017218.4001)
,p_process_success_message=>'Espacio de trabajo exportado.'
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_api.create_page(
 p_id=>77.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Juego de Separadores por P\00E1gina')
,p_step_title=>unistr('Editar Juego de Separadores por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function nullRange(){',
'document.forms.wwv_flow.p_t01.value = "";',
'document.forms.wwv_flow.p_t02.value = "";}',
'',
'function nullIn(){',
'document.forms.wwv_flow.p_t03.value = "";}',
'</script>',
''))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48954132099847673.4001)
,p_plug_name=>unistr('Mover Separador Est\00E1ndar a Nuevo Separador Principal')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P77_UNDER_PARENT'
,p_plug_display_when_cond2=>'NO'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49823719674810720.4001)
,p_plug_name=>unistr('Mover Separador Est\00E1ndar a Nuevo Juego de Separadores')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P77_UNDER_PARENT'
,p_plug_display_when_cond2=>'NO'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155243816069447478.4001)
,p_plug_name=>unistr('Juegos de Separadores de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>17
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice esta p\00E1gina para mover un separador est\00E1ndar y todas las p\00E1ginas asociadas a otro separador principal o juego de separadores.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155330907966603259.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings=>':Page #:Name:Tab Set'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49766122928588025.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48954132099847673.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49761509768584187.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48954132099847673.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206913911977418459.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(49823719674810720.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206922416479419784.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(49823719674810720.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49763913390585689.4001)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(49761509768584187.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49898814856904164.4001)
,p_branch_action=>'77'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>100
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49766528261588026.4001)
,p_branch_action=>'9000'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(49766122928588025.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36228925724023202.4001)
,p_name=>'P77_CURRENT_PARENT_TAB'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_api.id(48954132099847673.4001)
,p_prompt=>'Separador Principal Actual:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.tab_text tab_text',
'                 from wwv_flow_tabs s,wwv_flow_toplevel_tabs p',
'                where s.tab_set = p.current_on_tabset',
'                  and s.flow_id = :fb_flow_id',
'                  and p.flow_id = :fb_flow_id',
'                  and s.id = :F4000_CUR_STD_TAB'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el separador principal actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49006017397900148.4001)
,p_name=>'F4000_P77_UNDER_PARENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48954132099847673.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49672926632473200.4001)
,p_name=>'F4000_P77_PARENT_TAB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48954132099847673.4001)
,p_prompt=>'Nuevo Separador Principal:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID',
'  from wwv_flow_toplevel_tabs',
' where id = :F4000_P77_UNDER_PARENT'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,id from(',
'    select wwv_flow_escape.html(tab_text) name,ID,1 ob',
'      from wwv_flow_toplevel_tabs',
'     where id = v(''F4000_P77_UNDER_PARENT'')',
'    union all',
'    select ''----------------------'' name,0 id,2 ob from dual',
'    union all',
'    select wwv_flow_escape.html(tab_text) name,ID,3 ob',
'      from wwv_flow_toplevel_tabs',
'     where flow_id = v(''fb_flow_id'')',
'       and id != v(''F4000_P77_UNDER_PARENT'')',
')',
'order by ob'))
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nuevo separador principal.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49832719649841078.4001)
,p_name=>'F4000_P77_EXISTING_TABSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(49823719674810720.4001)
,p_prompt=>'Juego de Separadores'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(tab_set)',
'',
'  from wwv_flow_tabs',
'',
' where id = v(''F4000_CUR_STD_TAB'')'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from(',
'    select wwv_flow_escape.html(tab_set) d,tab_set r,1 ob',
'      from wwv_flow_tabs',
'     where id = v(''F4000_CUR_STD_TAB'')',
'     union all',
'        select ''-------------------------'' d,''0'' r,2 ob from dual',
'     union all',
'        select ''**    ''||initcap(wwv_flow_lang.system_message(''NEW_TABSET''))||''    **'' d,''02271975'' r,3 ob from dual',
'     union all',
'        select ''-------------------------'' d,''0'' r,4 ob from dual',
'     union all',
'    select wwv_flow_escape.html(d),r,5 ob from (',
'        select distinct tab_set d,tab_set r',
'          from wwv_flow_tabs',
'         where flow_id = v(''fb_flow_id'')',
'         minus',
'        select tab_set d,tab_set r',
'          from wwv_flow_tabs',
'         where id = v(''F4000_CUR_STD_TAB''))',
')',
'order by ob'))
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el juego de separadores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49911401269910423.4001)
,p_name=>'F4000_P77_NEW_STD_TABSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(49823719674810720.4001)
,p_prompt=>'Nuevo Juego de Separadores'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_display_when=>'F4000_P77_EXISTING_TABSET'
,p_display_when2=>'02271975'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifique el nuevo nombre del juego de separadores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(50148603917365014.4001)
,p_name=>'F4000_P77_TAB_NAME'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(48954132099847673.4001)
,p_prompt=>unistr('Separador Est\00E1ndar:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<strong>''||tab_text||''</strong>'' d',
'',
'  from wwv_flow_tabs',
'',
' where id = :F4000_CUR_STD_TAB'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el separador est\00E1ndar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(50396601248730878.4001)
,p_name=>'F4000_P77_TAB_NAME2'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(49823719674810720.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<strong>''||tab_text||''</strong>'' d',
'',
'  from wwv_flow_tabs',
'',
' where id = :F4000_CUR_STD_TAB'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre del separador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(49023612196932917.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P77_UNDER_PARENT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'    l_return    varchar2(255) := ''NO'';',
'',
'begin',
'    for c1 in (select p.id',
'',
'                 from wwv_flow_tabs s,wwv_flow_toplevel_tabs p',
'',
'                where s.tab_set = p.current_on_tabset',
'',
'                  and s.flow_id = :fb_flow_id',
'',
'                  and p.flow_id = :fb_flow_id',
'',
'                  and s.id = :F4000_CUR_STD_TAB)',
'',
'    loop',
'',
'        l_return := c1.id;',
'',
'    end loop;',
'',
'',
'',
'   return l_return;',
'',
'end;'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(207042018126439193.4001)
,p_validation_name=>'Validate new parent tab'
,p_validation_sequence=>10
,p_validation=>'F4000_P77_PARENT_TAB'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>unistr('Separador principal no v\00E1lido')
,p_when_button_pressed=>wwv_flow_api.id(49761509768584187.4001)
,p_associated_item=>wwv_flow_api.id(49672926632473200.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(50473004650790104.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New Tabset'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.move_tab_new_tabset(',
'    p_flow         => :fb_flow_id,',
'    p_tab_id       => :F4000_CUR_STD_TAB,',
'    p_tabset       => :F4000_P77_EXISTING_TABSET,',
'    p_new_tabset   => :F4000_P77_NEW_STD_TABSET',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P77_UNDER_PARENT = ''NO''',
'AND',
':REQUEST = ''APPLY_CHANGES'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P77_UNDER_PARENT = ''NO''',
'',
'AND',
'',
':REQUEST = ''APPLY_CHANGES'''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(50110603726334675.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update - New Parent Tab'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.move_tab_new_ptab(',
'    p_flow              => :fb_flow_id,',
'    p_tab_id            => :F4000_CUR_STD_TAB,',
'    p_new_parent_tab    => :F4000_P77_PARENT_TAB',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al mover el separador est\00E1ndar.')
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P77_UNDER_PARENT != ''NO''',
'AND',
':REQUEST = ''APPLY_CHANGES'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Separador actualizado.'
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_api.create_page(
 p_id=>78.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Informaci\00F3n de actualizaci\00F3n')
,p_alias=>'UPGRADE-INFORMATION'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Actualizaci\00F3n de &PRODUCT_NAME.')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'470'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(591706749341020446.4001)
,p_plug_name=>unistr('Actualizaci\00F3n disponible')
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_icon_css_classes=>'icon-calendar'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(wwv_flow_lang.system_message(',
'    p_name => ''F4000_P78_UPGRADE_AVAILABLE'',',
'    p0     => wwv_flow_cloud_db_services.get_upgrade_status().upgrade_version,',
'    p1     => to_char(wwv_flow_cloud_db_services.get_upgrade_status().upgrade_date, ''fmMonth DD, YYYY''),',
'    p2     => ''https://apex.oracle.com/adb-latest''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UPGRADE_AVAILABLE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(591706814243020447.4001)
,p_plug_name=>unistr('Actualizaci\00F3n en Curso')
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_icon_css_classes=>'icon-warning'
,p_region_template_options=>'a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(wwv_flow_lang.system_message(',
'    p_name => ''F4000_P78_UPGRADING'',',
'    p0     => ''&PRODUCT_NAME.'',',
'    p1     => ''3''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UPGRADE_IN_PROGRESS'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_api.create_page(
 p_id=>79.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina en Blanco: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina en Blanco')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44012131009200371.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82971717190004896.4001)
,p_plug_name=>'Navigate'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(82926628922893097.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82975931196013609.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Creaci\00F3n de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_page (',
'    p_flow_id    => :FB_FLOW_ID,',
'    p_page_id    => :F4000_P4714_PAGE_ID,',
'    p_page_name  => :P4714_PAGE_NAME,',
'    p_page_title => :P4714_PAGE_TITLE );',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626617657.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44012131009200371.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"  tabindex="1"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(83024209283147660.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44012131009200371.4001)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(84109811626666844.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44012131009200371.4001)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_cattributes=>'class="button10" '
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(83024609334147664.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(83024209283147660.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403334118161459267.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P4714_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4714_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(626617657.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548118751099278028.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(84109811626666844.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548119015167278029.4001)
,p_event_id=>wwv_flow_api.id(548118751099278028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(629698157.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_theme_id           number;',
'    l_region_template_id number;',
'    l_group_id           number := null;',
'begin',
'    l_theme_id           := wwv_flow_user_interface_dev.get_current_theme_id (',
'                                p_application_id    => :FB_FLOW_ID,',
'                                p_user_interface_id => :P259_USER_INTERFACE_ID );',
'',
'    l_region_template_id := wwv_flow_theme_dev.get_region_template_id (',
'                                p_application_id => :FB_FLOW_ID,',
'                                p_theme_id       => l_theme_id );',
'                                ',
'    if :P4714_GROUP_NAME is not null then',
'        l_group_id := wwv_flow_utilities.get_page_group_id(p_group_name => :P4714_GROUP_NAME, p_application_id => :FB_FLOW_ID);',
'        -- Create New Page Group if no existing group matching name provided',
'        if l_group_id is null then',
'            l_group_id := wwv_flow_id.next_val;',
'            wwv_flow_api.create_page_group(p_id => l_group_id, p_flow_id => :FB_FLOW_ID, p_group_name => :P4714_GROUP_NAME);                    ',
'        end if;',
'    end if;    ',
'',
'    wwv_flow_wizard_api.create_page (',
'        p_flow_id              => :FB_FLOW_ID,',
'        p_page_id              => :F4000_P4714_PAGE_ID,',
'        p_name                 => :P4714_PAGE_NAME,',
'        p_page_mode            => :P4714_PAGE_MODE,',
'        p_group_id             => l_group_id,',
'        p_user_interface_id    => :P259_USER_INTERFACE_ID,',
'        p_alias                => :F4000_P4714_ALIAS,',
'        p_title                => :P4714_PAGE_TITLE,',
'        --',
'        p_tab_set              => :P4716_TAB_SET,',
'        p_tab_name             => :P4716_TAB_NAME,',
'        p_tab_label            => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id        => :P4714_BREADCRUMB_ID,',
'        p_breadcrumb_name      => :P4714_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id => :P4714_BREADCRUMB_PARENT_ID );',
'',
'    wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',v(''F4000_P4714_PAGE_ID''));',
'',
'    :F4000_RUN_EDIT_PAGE   := :F4000_P4714_PAGE_ID;',
'    :FB_FLOW_PAGE_ID       := :F4000_P4714_PAGE_ID;',
'    ',
'',
'    for i in 1..5 loop',
'      if v(''P4714_REGION_0''||i) is not null then',
'          wwv_flow_api.create_page_plug (',
'              p_id                          => wwv_flow_id.next_val,',
'              p_flow_id                     => :FB_FLOW_ID,',
'              p_page_id                     => :F4000_P4714_PAGE_ID,',
'              p_plug_name                   => v(''P4714_REGION_0''||i),',
'              p_plug_template               => l_region_template_id,',
'              p_region_template_options     => wwv_flow_wizard_api.get_preset_template_options (l_region_template_id,''REGION''),  ',
'              p_plug_display_sequence       => to_char(i*10),',
'              p_plug_display_point          => ''BODY'',',
'              p_plug_item_display_point     => ''ABOVE'',',
'              p_plug_source                 => null,',
'              p_plug_source_type            => ''STATIC_TEXT_ESCAPE_SC'',',
'              p_plug_display_when_condition => null,',
'              p_plug_display_when_cond2     => null,',
'              p_plug_display_condition_type => null,',
'              p_plug_required_role          => null,',
'              p_menu_template_id            => null);',
'      end if;',
'  end loop; ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la p\00E1gina &F4000_P4714_PAGE_ID..')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(626617657.4001)
,p_process_success_message=>unistr('Se ha creado la p\00E1gina &F4000_P4714_PAGE_ID.')
,p_process_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'F4000_P78_NEW_TAB_SET_NAME',
'',
'',
'',
'sleuniss 08.16.2002  changed p_first_item to default of NO_FIRST_ITEM'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(548118557921273858.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_process_error_message=>unistr('Error al crear la p\00E1gina &F4000_P4714_PAGE_ID..')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(626617657.4001)
,p_process_success_message=>unistr('Se ha creado la p\00E1gina &F4000_P4714_PAGE_ID.')
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_api.create_page(
 p_id=>80.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Calendario'
,p_step_title=>'Editar Plantilla de Calendario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3680213801027852.4001)
,p_plug_name=>'Formatos de Vista de Lista'
,p_region_name=>'AGENDA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3683623156027862.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3689808822027871.4001)
,p_plug_name=>'Plantillas de Calendario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de calendario controlan el aspecto y colocaci\00F3n de un calendario. Estas plantillas utilizan las tablas HTML frecuentemente para organizar las fechas.</p>'),
unistr('<p>Puede colocar los atributos de calendario utilizando cadenas de sustituci\00F3n como #DD# y #MONTH#. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).</p>')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3690729585027872.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n de formato de fecha:</p>'),
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'</ul>',
unistr('<p>Si coloca "I" delante de cualquier cadena, el texto tendr\00E1 may\00FAscula inicial.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3690920930027872.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12991522578387911.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3704800210224490.4001)
,p_plug_name=>'Plantilla de Calendario'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46155527569612562.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3684807277027866.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3684612246027866.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3684003789027864.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3684409219027866.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P80_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3683808714027862.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3693700429027887.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P80_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3684612246027866.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3693908559027887.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P80_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3684807277027866.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3694323549027887.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3694504694027887.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3694718599027887.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3708315232238253.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3694919674027888.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3695125791027888.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P80_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3695324303027888.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3695514015027888.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3685013148027867.4001)
,p_name=>'P80_ID_NEXT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_prompt=>'P80_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3685205262027867.4001)
,p_name=>'P80_ID_PREV'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_prompt=>'P80_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3685408597027867.4001)
,p_name=>'P80_ID_COUNT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_prompt=>'Plantilla de Calendario: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3690011485027871.4001)
,p_name=>'P80_STAY'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(3689808822027871.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3691829356027879.4001)
,p_name=>'P80_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_api.id(3683623156027862.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3705009478224491.4001)
,p_name=>'P80_ID_1'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3704800210224490.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3705227467224491.4001)
,p_name=>'P80_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3704800210224490.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define un nombre que identifica la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3705711451224491.4001)
,p_name=>'P80_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3704800210224490.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_cSize=>2
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3705907163224492.4001)
,p_name=>'P80_THEME_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3704800210224490.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3706423706224492.4001)
,p_name=>'P80_THEME_CLASS_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3704800210224490.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7778908831187447.4001)
,p_name=>'P80_AGENDA_TODAY_DAY_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa Presente')
,p_source=>'AGENDA_TODAY_DAY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7779524761191996.4001)
,p_name=>'P80_AGENDA_TODAY_ENTRY_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Datos Presente'
,p_source=>'AGENDA_TODAY_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7780213118198098.4001)
,p_name=>'P80_AGENDA_FUTURE_DAY_FORMAT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa Futuro')
,p_source=>'AGENDA_FUTURE_DAY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7780901914261162.4001)
,p_name=>'P80_AGENDA_FUTURE_ENTRY_FORMAT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Datos Futuro'
,p_source=>'AGENDA_FUTURE_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7836613810548435.4001)
,p_name=>'P80_AGENDA_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura/Cierre de Lista'
,p_source=>'AGENDA_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7838016365558609.4001)
,p_name=>'P80_AGENDA_PAST_DAY_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa Pasado')
,p_source=>'AGENDA_PAST_DAY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7840407838565631.4001)
,p_name=>'P80_AGENDA_PAST_ENTRY_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3680213801027852.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Datos Pasado'
,p_source=>'AGENDA_PAST_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3692120163027882.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P80_THEME_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397284515489266400.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P80_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397284807039266401.4001)
,p_event_id=>wwv_flow_api.id(397284515489266400.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3684807277027866.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397284921376268078.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P80_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397285202719268079.4001)
,p_event_id=>wwv_flow_api.id(397284921376268078.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3684612246027866.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3692218601027882.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P80_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3692427028027884.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P80_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P80_ID_NEXT'
,p_attribute_10=>'P80_ID_PREV'
,p_attribute_13=>'P80_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3692625818027884.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P80_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la plantilla de calendario.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3692819078027884.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_api.id(3684409219027866.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3693017234027884.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P80_REFERENCE_ID,',
'    p_subscribing_template_id    => :P80_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>'P80_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3693216642027884.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:P80_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'P80_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Identificador de referencia eliminado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3693410156027884.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P80_REFERENCE_ID,',
'    p_subscribing_template_id    => :P80_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(3683808714027862.4001)
,p_process_when=>':P80_REFERENCE_ID is not null and :P80_REFRESH = ''Y'''
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Plantilla copiada.'
);
end;
/
prompt --application/pages/page_00081
begin
wwv_flow_api.create_page(
 p_id=>81.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Grupos de Opciones de Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Grupos de Opciones de Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'540'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687105780636946470.4001)
,p_plug_name=>'Grupos de Opciones de Plantilla'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ROWID", ',
'"ID",',
'"FLOW_ID",',
'"THEME_ID",',
'"NAME",',
'"DISPLAY_NAME",',
'"DISPLAY_SEQUENCE",',
'"TEMPLATE_TYPES",',
'"HELP_TEXT",',
'"NULL_TEXT",',
'"IS_ADVANCED"',
'from "#OWNER#"."WWV_FLOW_TEMPLATE_OPT_GROUPS"',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P81_THEME_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(687105831569946470.4001)
,p_name=>'Template Option Groups'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MARC'
,p_internal_uid=>687105831569946470
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106042904946478.4001)
,p_db_column_name=>'ROWID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Editar'
,p_column_link=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.::P82_ROWID:#ROWID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#e2.gif"  border="0">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'OTHER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106177811946479.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106297627946479.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Identificador de Flujo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106332665946479.4001)
,p_db_column_name=>'THEME_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'ID de Tema'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106454022946479.4001)
,p_db_column_name=>'NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106555838946480.4001)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:82:P82_ROWID:#ROWID#:'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106669044946480.4001)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Secuencia de Visualizaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106701755946480.4001)
,p_db_column_name=>'TEMPLATE_TYPES'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Tipos de Plantilla'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106835566946480.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Texto de Ayuda'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687106934144946480.4001)
,p_db_column_name=>'NULL_TEXT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Texto Nulo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(687107038623946480.4001)
,p_db_column_name=>'IS_ADVANCED'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Avanzada'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687752996374377782.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687062648956932983.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(687752996374377782.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:82:&SESSION.::&DEBUG.:82:P82_FLOW_ID,P82_THEME_ID:&FB_FLOW_ID.,&P81_THEME_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687753596740387508.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(687752996374377782.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687110812363004760.4001)
,p_name=>'P81_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(687105780636946470.4001)
,p_prompt=>'Theme ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(93372822814585113.4001)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(687603574112687584.4001)
,p_name=>'refresh report after edit'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(687105780636946470.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(687603895897687586.4001)
,p_event_id=>wwv_flow_api.id(687603574112687584.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(687105780636946470.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1119157604737390639.4001)
,p_name=>'Close Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(687753596740387508.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1119157750505390640.4001)
,p_event_id=>wwv_flow_api.id(1119157604737390639.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_00082
begin
wwv_flow_api.create_page(
 p_id=>82.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar Grupo de Opciones de Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear/Editar Grupo de Opciones de Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'540'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687055435195932930.4001)
,p_plug_name=>'Create/Edit Template Option Group'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687124870455267718.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687055868883932934.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(687124870455267718.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P82_ROWID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687055733288932934.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(687124870455267718.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P82_ROWID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687055695835932934.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(687124870455267718.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P82_ROWID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687055997868932934.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(687124870455267718.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(687754630495405388.4001)
,p_branch_action=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687056970442932943.4001)
,p_name=>'P82_ROWID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Rowid'
,p_source=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(93372822814585113.4001)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687057199729932962.4001)
,p_name=>'P82_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687057302636932963.4001)
,p_name=>'P82_FLOW_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687057564274932963.4001)
,p_name=>'P82_THEME_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687057783895932964.4001)
,p_name=>'P82_NAME'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador de Grupo'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cHeight=>1
,p_read_only_when=>'P82_ROWID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Define el nombre interno del grupo de opciones de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687057914293932964.4001)
,p_name=>'P82_DISPLAY_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Grupo'
,p_source=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Define el nombre de visualizaci\00F3n del grupo de opciones de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687058153938932964.4001)
,p_name=>'P82_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>unistr('Secuencia de Visualizaci\00F3n')
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Define la secuencia de visualizaci\00F3n en la que el grupo de opciones de plantilla aparece en la p\00E1gina de edici\00F3n de componentes.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687058395440932964.4001)
,p_name=>'P82_TEMPLATE_TYPES'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Plantilla'
,p_source=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE OPTION TYPES'
,p_lov=>'.'||wwv_flow_api.id(655584409399418944.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_read_only_when=>'P82_TEMPLATE_TYPES'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Define el tipo de plantilla para el que est\00E1 disponible el grupo de opciones de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687058599588932964.4001)
,p_name=>'P82_HELP_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Texto de ayuda que describe el objetivo del grupo de opciones de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687058756504932965.4001)
,p_name=>'P82_NULL_TEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto Nulo'
,p_source=>'NULL_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Texto que aparecer\00E1 para la opci\00F3n nula')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687058996820932965.4001)
,p_name=>'P82_IS_ADVANCED'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(687055435195932930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Avanzada'
,p_source=>'IS_ADVANCED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica si el grupo de opciones de plantilla es un grupo avanzado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(687126366867288299.4001)
,p_computation_sequence=>10
,p_computation_item=>'P82_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return upper(replace(:P82_DISPLAY_NAME,'' '',''_''));'
,p_compute_when=>'P82_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(687851086573424050.4001)
,p_name=>'upper case identifier'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P82_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P82_ROWID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(687851398039424054.4001)
,p_event_id=>wwv_flow_api.id(687851086573424050.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P82_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P82_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(687851720005437807.4001)
,p_name=>'update identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P82_DISPLAY_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P82_ROWID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(687852068769437807.4001)
,p_event_id=>wwv_flow_api.id(687851720005437807.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P82_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P82_DISPLAY_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(687060304116932967.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_TEMPLATE_OPT_GROUPS'
,p_attribute_02=>'WWV_FLOW_TEMPLATE_OPT_GROUPS'
,p_attribute_03=>'P82_ROWID'
,p_attribute_04=>'ROWID'
,p_attribute_11=>'I:U:D'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(687060555644932970.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_TEMPLATE_OPT_GROUPS'
,p_attribute_02=>'WWV_FLOW_TEMPLATE_OPT_GROUPS'
,p_attribute_03=>'P82_ROWID'
,p_attribute_04=>'ROWID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(687060704432932971.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(687055868883932934.4001)
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_api.create_page(
 p_id=>83.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Verificar Suscripci\00F3n a Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Verificar Suscripci\00F3n a Tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1475856076343506021.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_plug_name=>'Verificar'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Este asistente consulta todos los atributos de temas, plantillas y opciones de plantilla en el tema de suscripci\00F3n y genera errores para aquellos que no est\00E9n sincronizados con el tema maestro. El asistente tambi\00E9n resalta todas las plantillas defini')
||unistr('das en el tema maestro, pero que a\00FAn no se han publicado en el tema de suscripci\00F3n. Para publicar cambios del tema maestro en el tema de suscripci\00F3n, pulse el bot\00F3n "Refrescar" al final del asistente.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1475856217437509963.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1475856076343506021.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1475856786032519198.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1475856076343506021.4001)
,p_button_name=>'VERIFY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Verificar'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1475857069006520103.4001)
,p_branch_action=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1475856786032519198.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475879250893627401.4001)
,p_name=>'P83_MASTER_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_prompt=>'ID de Tema Maestro'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id from wwv_flow_themes',
'where id = :P75_REFERENCE_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475879344552627402.4001)
,p_name=>'P83_MASTER_THEME_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_prompt=>'Nombre de Tema Maestro'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name from wwv_flow_themes',
'where id = :P75_REFERENCE_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475879698953627405.4001)
,p_name=>'P83_SUB_THEME_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_prompt=>unistr('ID de Tema de Suscripci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id from wwv_flow_themes',
'where id = :P75_THEME_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475879715459627406.4001)
,p_name=>'P83_SUB_THEME_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_prompt=>unistr('Nombre del Tema de Suscripci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name from wwv_flow_themes',
'where id = :P75_THEME_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475879865707627407.4001)
,p_name=>'P83_MASTER_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_prompt=>unistr('ID de Aplicaci\00F3n Maestra')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_themes',
'where id = :P75_REFERENCE_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475879923815627408.4001)
,p_name=>'P83_SUB_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1475879495831627403.4001)
,p_prompt=>unistr('ID de Aplicaci\00F3n de Suscripci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_themes',
'where id = :P75_THEME_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1475857718994531054.4001)
,p_name=>'Submit '
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1475856786032519198.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1475858042511531062.4001)
,p_event_id=>wwv_flow_api.id(1475857718994531054.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'VERIFY'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1475856497652512191.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1475856217437509963.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1475857289831523296.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_template_errors number := 0;',
'begin',
'  l_template_errors := wwv_flow_copy_metadata.compare_themes(:P267_ID);',
'  apex_util.set_session_state(',
'    p_name => ''P75_TEMPLATE_ERRORS'',',
'    p_value => l_template_errors);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'VERIFY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_api.create_page(
 p_id=>84.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Aplicaci\00F3n: Confirmar')
,p_step_title=>unistr('Crear Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23757007845437601.4001)
,p_plug_name=>unistr('Crear Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.copy_application (',
'    p_old_app_id      => :P3009_COPY_FROM,',
'    p_old_app_name    => :P84_COPY_FROM_NAME,',
'    p_new_app_id      => :P3009_NEW_APP_ID,',
'    p_new_app_name    => :P3009_COPY_TO,',
'    p_copy_deployment => :P3009_COPY_DEPLOYMENT',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23763022898462655.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(139866417493663090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(245910428558834687.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747137633701138152.4001)
,p_plug_name=>unistr('Crear Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23757207073437601.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(245910428558834687.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23757415100437602.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(245910428558834687.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Aplicaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23757611720437603.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(245910428558834687.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(23758304938437609.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(23757415100437602.4001)
,p_branch_sequence=>21
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(23758532228437609.4001)
,p_branch_action=>'f?p=&APP_ID.:3009:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(23757611720437603.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23777122215538115.4001)
,p_name=>'P84_COPY_FROM_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23757007845437601.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23758028049437605.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.copy_application (',
'    p_old_application_id => :P3009_COPY_FROM,',
'    p_new_application_id => :P3009_NEW_APP_ID,',
'    p_new_name           => :P3009_COPY_TO,',
'    p_export_sup_objects => :P3009_COPY_DEPLOYMENT );',
'',
':FB_FLOW_ID      := :P3009_NEW_APP_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P3009_NEW_APP_ID;',
':F4000_P1_PAGE   := ''1'';  ',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar la aplicaci\00F3n &P3009_COPY_FROM..')
,p_process_when_button_id=>wwv_flow_api.id(23757415100437602.4001)
,p_process_success_message=>unistr('Aplicaci\00F3n creada correctamente.')
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_api.create_page(
 p_id=>85.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Plantillas de Etiqueta'
,p_step_title=>'Editar Plantilla de Etiqueta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_field_templates t, wwv_flow_themes th',
'where t.id = :F4000_P85_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_label.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15137524109292531.4001)
,p_plug_name=>'Contenedor de Campo'
,p_region_name=>'FC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33419222793056919.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P85_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_02=>'TEMPLATE_NAME'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'F4000_P85_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46155810950612564.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92676922957336244.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92731110501398600.4001)
,p_plug_name=>'Plantillas de Etiqueta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de etiqueta est\00E1n dise\00F1adas para gestionar de forma centralizada los marcadores HTML de las etiquetas de elementos de p\00E1gina.</p> '),
unistr('<p>Puede controlar el modo de visualizaci\00F3n de las etiquetas utilizando plantillas de etiqueta. Por ejemplo, puede crear una plantilla de etiqueta denominada "Campo Necesario" que contenga los controles de fuente HTML que indiquen al usuario que el c')
||'ampo es necesario mediante el cambio de color de la etiqueta.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92735416527411011.4001)
,p_plug_name=>unistr('Definici\00F3n')
,p_region_name=>'STD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92736513293412529.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92740432474418784.4001)
,p_plug_name=>'Label Templates'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92859200616502822.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117328027016407678.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166032826430627441.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_name=>'S'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.label_template_sub_str (',
'    p_template_id => :F4000_P85_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n se utilizan en las plantillas para hacer referencia a los valores del componente. Este informe detalla el uso de la cadena de sustituci\00F3n para esta plantilla.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174456326258809270.4001)
,p_plug_name=>unistr('Visualizaci\00F3n de Error')
,p_region_name=>'ERR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617460819542020156.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>190
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_FIELD_TEMPLATES',
'where id = :F4000_P85_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P85_ID,',
'      p_component_type => ''Label Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(628818477181073259.4001)
,p_name=>'Opciones de Plantilla'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and field_template_id  = :F4000_P85_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P85_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(628819119287073260.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(628818745959073260.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688536360652340440.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(628818830068073260.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688536430856340440.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688536509975340440.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(688600483414811731.4001)
,p_name=>'Opciones de Plantilla Global'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_parent_plug_id=>wwv_flow_api.id(628818477181073259.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>190
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o,',
'       wwv_flow_field_templates t',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.security_group_id  = :WORKSPACE_ID',
'   and o.template_types = ''FIELD''',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P85_ID    '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P85_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688601163675811732.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688600999212811732.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688600629126811732.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688601087825811732.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688600729989811732.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688600840356811732.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932806954683193713.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P85_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P85_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(134194118755432829.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(134194006039432829.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166470213174105062.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33419222793056919.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P85_ID.,&FLOW_PAGE_ID.,FIELD'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_field_templates',
'',
'where reference_id = :F4000_P85_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164764703441381497.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33419222793056919.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_field_templates',
'',
'where id = :F4000_P85_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(628819231396073260.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(628818477181073259.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_FIELD_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P85_THEME.,&F4000_P85_ID.,FIELD'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92677205290336246.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92677508451336246.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:348:&SESSION.::&DEBUG.::P348_ID:&F4000_P85_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P85_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92677422219336246.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P85_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92677307778336246.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P85_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(134199918519432862.4001)
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::F4000_P85_ID:&P85_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(134194006039432829.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(134200328530432866.4001)
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::F4000_P85_ID:&P85_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(134194118755432829.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164765129393381502.4001)
,p_branch_action=>'85'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(164764703441381497.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27987623723767701.4001)
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P85_STAY_ON_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92678417298336252.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>70
,p_branch_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15138708095306882.4001)
,p_name=>'P85_BEFORE_ITEM'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(15137524109292531.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes de Etiqueta y Elemento'
,p_source=>'BEFORE_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML que se va a mostrar antes de la etiqueta y el elemento. Normalmente se utiliza para encapsular un elemento en un contenedor DIV o juego de campos. El atributo Antes de Etiqueta y Elemento s\00F3lo se presenta para p\00E1ginas que no uti')
||unistr('lizan una cuadr\00EDcula de tabla para mostrar los elementos de pantalla. Esto incluye cualquier p\00E1gina que utilice una plantilla de p\00E1gina m\00F3vil.</p>'),
'<p>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#CURRENT_ITEM_CONTAINER_ID#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15139000953314202.4001)
,p_name=>'P85_AFTER_ITEM'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(15137524109292531.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s de Etiqueta y Elemento')
,p_source=>'AFTER_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se va a mostrar despu\00E9s de la etiqueta y el elemento. Normalmente se utiliza para encapsular un elemento en un contenedor DIV o juego de campos. El atributo de despu\00E9s de elemento y etiqueta s\00F3lo se presenta para p\00E1ginas que no')
||unistr(' utilizan una cuadr\00EDcula de tabla para mostrar los elementos de pantalla. Esto incluye cualquier p\00E1gina que utilice una plantilla de p\00E1gina m\00F3vil.'),
'',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'</ul>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24153717149540645.4001)
,p_name=>'P85_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(92676922957336244.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Comprobar si es traducible.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27978600511685311.4001)
,p_name=>'F4000_P85_STAY_ON_PAGE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(92731110501398600.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35448530366673284.4001)
,p_name=>'F4000_P85_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33419222793056919.4001)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_LABEL_TEMPLATE'
,p_lov=>'.'||wwv_flow_api.id(84317322746593889.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_field_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P85_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40817606973410538.4001)
,p_name=>'P85_NAME'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'select TEMPLATE_NAME from WWV_FLOW_FIELD_TEMPLATES where id = :F4000_P85_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la plantilla'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43714724672336692.4001)
,p_name=>'P85_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(92676922957336244.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43838323482875713.4001)
,p_name=>'P85_THEME_CLASS_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(92676922957336244.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LABEL THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43828319065855502.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92679028424336256.4001)
,p_name=>'F4000_P85_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(117328027016407678.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92679924863336270.4001)
,p_name=>'F4000_P85_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(92676922957336244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Define un nombre que identifica la plantilla.<p />',
'Utilice la casilla de control <strong>Se Puede Convertir</strong> para indicar que la plantilla contiene cadenas de texto que hay que convertir.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92680221480336272.4001)
,p_name=>'F4000_P85_TEMPLATE_BODY1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes de Etiqueta'
,p_source=>'TEMPLATE_BODY1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML que aparecer\00E1 antes de una etiqueta de elemento.</div>'),
unistr('<div class="htmldbInfoBodyP">Nota: la etiqueta aparecer\00E1 autom\00E1ticamente despu\00E9s del HTML en esta regi\00F3n. Por lo tanto, al abrir una etiqueta &lt;a&gt;, por ejemplo, se debe cerrar en la regi\00F3n Despu\00E9s de Etiqueta.</div>'),
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#LABEL_ID#</li>',
'<li>#LABEL_COLUMN_SPAN_NUMBER#</li>',
'<li>#LABEL_COLUMN_SPAN_ALPHA#</li>',
'<li>#LABEL_COLUMN_SPAN_WORD#</li>',
'<li>#LABEL_COLUMN_SPAN_PLURAL#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>',
'&lt;label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"&gt;<br>&lt;a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',<br>&nbsp;&nbsp;''&amp;SESSION.'',''&amp;CLOSE.'')" &gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92680511350336273.4001)
,p_name=>'F4000_P85_TEMPLATE_COMMENT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(92736513293412529.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92781318166516655.4001)
,p_name=>'F4000_P85_TEMPLATE_BODY2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s de Etiqueta')
,p_source=>'TEMPLATE_BODY2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML que aparecer\00E1 despu\00E9s de una etiqueta de elemento.</div>'),
unistr('<div class="htmldbInfoBodyP">NOTA: la etiqueta aparecer\00E1 autom\00E1ticamente antes del HTML en esta regi\00F3n. Por lo tanto, aqu\00ED se debe cerrar cualquier etiqueta HTML abierta en la regi\00F3n Antes de Etiqueta.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'</ul>',
'</div>',
'',
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>',
'&lt;/a&gt;&lt;/label&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(134197704797432845.4001)
,p_name=>'P85_ID_NEXT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(117328027016407678.4001)
,p_prompt=>'P85_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(134198124866432849.4001)
,p_name=>'P85_ID_PREV'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(117328027016407678.4001)
,p_prompt=>'P85_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(134198526515432851.4001)
,p_name=>'P85_ID_COUNT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(92740432474418784.4001)
,p_prompt=>'Plantilla de Etiqueta: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de etiqueta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164789621894411360.4001)
,p_name=>'F4000_P85_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33419222793056919.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_FIELD_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_field_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174593500252568645.4001)
,p_name=>'F4000_P85_ON_ERROR_BEFORE_LABEL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(174456326258809270.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'En Error Antes de Etiqueta'
,p_source=>'ON_ERROR_BEFORE_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML que va a preceder a la etiqueta de elemento cuando una aplicaci\00F3n muestre un mensaje de error de validaci\00F3n en l\00EDnea para el elemento.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'</ul>',
'</div>',
'',
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;font class="fieldtitleleft"&gt;#ERROR_MESSAGE#&lt;/font&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174594825256572260.4001)
,p_name=>'F4000_P85_ON_ERROR_AFTER_LABEL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(174456326258809270.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('En Error Despu\00E9s de Etiqueta')
,p_source=>'ON_ERROR_AFTER_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML que se va a agregar a la etiqueta de elemento cuando una aplicaci\00F3n muestre un mensaje de error de validaci\00F3n en l\00EDnea para el elemento. Por ejemplo:</div>'),
'<pre>',
'&amp;nbsp;]&lt;/font&gt;',
'</pre>',
unistr('<div class="htmldbInfoBodyP">Este ejemplo agregar\00EDa un espacio y un corchete de cierre a la etiqueta de elemento mostrada con el error.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'</ul>',
'</div>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485601558507146365.4001)
,p_name=>'P85_BEFORE_ELEMENT'
,p_item_sequence=>92
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes del Elemento'
,p_source=>'BEFORE_ELEMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo HTML que se va a mostrar directamente antes del elemento de pantalla. Normalmente se utiliza para encapsular un elemento en un contenedor DIV o para mostrar un bot\00F3n de ayuda antes o despu\00E9s del elemento de pantalla. </p>'),
'<p>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#CURRENT_ITEM_CONTAINER_ID#</li>',
'<li>#ITEM_PRE_TEXT#</li>',
'<li>#HELP_TEMPLATE#</li>',
'<li>#INLINE_HELP_TEMPLATE#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'<li>#ITEM_COLUMN_SPAN_NUMBER#</li>',
'<li>#ITEM_COLUMN_SPAN_ALPHA#</li>',
'<li>#ITEM_COLUMN_SPAN_WORD#</li>',
'<li>#ITEM_COLUMN_SPAN_PLURAL#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485602045834156005.4001)
,p_name=>'P85_AFTER_ELEMENT'
,p_item_sequence=>122
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s del Elemento')
,p_source=>'AFTER_ELEMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo HTML que se va a mostrar directamente despu\00E9s del elemento de pantalla. Normalmente se utiliza para encapsular un elemento en un contenedor DIV o para mostrar un bot\00F3n de ayuda antes o despu\00E9s del elemento de pantalla. </p>'),
'<p>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#ITEM_POST_TEXT#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#CURRENT_ITEM_CONTAINER_ID#</li>',
'<li>#HELP_TEMPLATE#</li>',
'<li>#INLINE_HELP_TEMPLATE#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485603564569198386.4001)
,p_name=>'P85_HELP_LINK'
,p_item_sequence=>152
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Ayuda'
,p_source=>'HELP_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('La subplantilla de ayuda permite definir el enlace o bot\00F3n utilizado para llamar a la ayuda de nivel de elemento. Esta subplantilla solo se presenta para elementos que tienen definida la ayuda. '),
'</p>',
'<p>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_LABEL#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(505633752141058243.4001)
,p_name=>'P85_ERROR_TEMPLATE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(174456326258809270.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Error'
,p_source=>'ERROR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML presentado para mostrar el mensaje de error de validaci\00F3n en l\00EDnea. Utilice la cadena de sustituci\00F3n #ERROR_MESSAGE# para hacer referencia al texto del mensaje. La plantilla de error se puede incluir antes o despu\00E9s de los atributo')
||unistr('s de elementos mediante la cadena de sustituci\00F3n #ERROR_TEMPLATE#.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582266286585682833.4001)
,p_name=>'P85_INLINE_HELP_TEXT'
,p_item_sequence=>162
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de Ayuda en L\00EDnea')
,p_source=>'INLINE_HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('La subplantilla de ayuda permite definir el texto de ayuda en l\00EDnea que se va a mostrar inmediatamente con el elemento. Esta subplantilla solo se presenta para elementos que tienen definido el texto de ayuda en l\00EDnea. '),
'</p>',
'<p>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_LABEL#</li>',
'<li>#CURRENT_ITEM_INLINE_HELP_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582266754792682838.4001)
,p_name=>'P85_ITEM_PRE_TEXT'
,p_item_sequence=>132
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto Previo de Elemento'
,p_source=>'ITEM_PRE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca c\00F3digo HTML para que la subplantilla "Texto previo de elemento" formatee el contenido del atributo <strong>Anterior a texto</strong>. Se puede hacer referencia luego a esta plantilla en la plantilla <strong>Antes de elemento</strong> co')
||unistr('n la sustituci\00F3n #ITEM_PRE_TEXT#.</p>'),
'<p>',
unistr('<div class="htmldbInfoBodyP">Hay disponibles las siguientes cadenas de sustituci\00F3n para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_PRE_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582266852717682839.4001)
,p_name=>'P85_ITEM_POST_TEXT'
,p_item_sequence=>142
,p_item_plug_id=>wwv_flow_api.id(92735416527411011.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto Posterior de Elemento'
,p_source=>'ITEM_POST_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca c\00F3digo HTML para que la subplantilla "Texto posterior de elemento" formatee el contenido del atributo <strong>Posterior a texto</strong>. Se puede hacer referencia luego a esta plantilla en la plantilla <strong>Despu\00E9s de elemento</stro')
||unistr('ng> con la sustituci\00F3n #ITEM_POST_TEXT#.</p>'),
'<p>',
unistr('<div class="htmldbInfoBodyP">Hay disponibles las siguientes cadenas de sustituci\00F3n para este atributo:'),
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_POST_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628819408105073262.4001)
,p_name=>'P85_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(628818477181073259.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select o.display_name as d,',
'         o.css_classes as r,',
'         null default_template_options,',
'         null,',
'         o.help_text,',
'         (select display_name ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text         ',
'    from wwv_flow_template_options o,',
'         wwv_flow_field_templates t',
'   where o.flow_id = :FB_FLOW_ID',
'     and o.template_types = ''FIELD''',
'     and (o.field_template_id = :F4000_P85_ID or o.field_template_id is NULL)',
'     and o.template_types = ''FIELD''',
'     and o.theme_id = t.theme_id',
'     and t.id = :F4000_P85_ID           ',
'  order by advanced_group nulls first, group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628819650337073262.4001)
,p_name=>'P85_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>235
,p_item_plug_id=>wwv_flow_api.id(628818477181073259.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_field_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.field_template_id',
'   and field_template_id = :F4000_P85_ID',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(757097056956899232.4001)
,p_name=>'F4000_P85_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(92676922957336244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449463313394055536.4001)
,p_name=>'P85_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>245
,p_item_plug_id=>wwv_flow_api.id(628818477181073259.4001)
,p_source=>'P85_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104554249597408892.4001)
,p_name=>'P85_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(92676922957336244.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(146679113978670858.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P85_THEME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104570321156417112.4001)
,p_computation_sequence=>20
,p_computation_item=>'P85_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_field_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P85_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35453411819681960.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P85_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(90835616177711401.4001)
,p_validation_name=>'TemplateNameMand'
,p_validation_sequence=>10
,p_validation=>'F4000_P85_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(92677422219336246.4001)
,p_associated_item=>wwv_flow_api.id(92679924863336270.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164805403335435117.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P85_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(164764703441381497.4001)
,p_associated_item=>wwv_flow_api.id(164789621894411360.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164813222516441453.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P85_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(164764703441381497.4001)
,p_associated_item=>wwv_flow_api.id(164789621894411360.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397288330998365438.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P85_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397288601940365438.4001)
,p_event_id=>wwv_flow_api.id(397288330998365438.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(134194118755432829.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397288708273368392.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P85_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397289009991368392.4001)
,p_event_id=>wwv_flow_api.id(397288708273368392.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(134194006039432829.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(628887945949296204.4001)
,p_name=>'refresh template options'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(628819231396073260.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751677657772805.4001)
,p_event_id=>wwv_flow_api.id(628887945949296204.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(628818477181073259.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:85:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(628888905522308632.4001)
,p_name=>'refresh template options after edit'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(628818477181073259.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751710867772806.4001)
,p_event_id=>wwv_flow_api.id(628888905522308632.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(628818477181073259.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:85:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(92680927070336277.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error al recuperar la fila.'
,p_process_comment=>'Generated 04-OCT-2001 17:03:21'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(134199514652432857.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'TEMPLATE_NAME'
,p_attribute_09=>'P85_ID_NEXT'
,p_attribute_10=>'P85_ID_PREV'
,p_attribute_13=>'P85_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164822026170454934.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh field template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_field_template (',
'    p_master_template_id         => :F4000_P85_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P85_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(164764703441381497.4001)
,p_process_when=>'F4000_P85_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(92681202519336282.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al actualizar la plantilla de etiqueta.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Plantilla de etiqueta actualizada.'
,p_process_comment=>'Generated 04-OCT-2001 17:03:21'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35459624315691365.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_field_template (',
'    p_master_template_id         => :F4000_P85_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P85_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>':F4000_P85_REFERENCE_ID is not null and :F4000_P85_REFRESH = ''Y'' and (upper(:request) like ''APPLY%'' or upper(:request) like ''SAVE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1449463447340055537.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_field_tmplopt_presets(:F4000_P85_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P85_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P85_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164826810858462036.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_field_reference_id (:F4000_P85_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_api.create_page(
 p_id=>86.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Aplicaci\00F3n')
,p_step_title=>unistr('Actualizar Aplicaci\00F3n: Seleccionar Validaciones que Actualizar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202555930603939361.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484011119835581586.4001)
,p_plug_name=>'Validaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when c009 is not null then null',
'            else apex_item.checkbox(1, n002,(',
'                 select ''CHECKED'' from apex_collections ',
'                  where collection_name = ''UPGRADE_VALIDATIONS'' ',
'                    and n001 = v.n002),null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''VALIDATION_LABEL'',wwv_flow_escape.html(c005))) ',
'            end checkbox,',
'       c004 item_name,',
'       c005 validation_name,',
'       c006 validation_type,',
'       c009 additional_info,',
'       c010 page_locked_by,',
'       c007 button_name,',
'       c008 condition,',
'       c011 cond_exp1,',
'       c012 cond_exp2',
'  from apex_collections v',
' where collection_name = ''ADV_UPGRADE_REPORT''',
'   and n001 = :P86_PAGE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(484011313289581594.4001)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ninguna validaci\00F3n para la migraci\00F3n.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492607622837106443.4001)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>1
,p_column_identifier=>'F'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492043509244609378.4001)
,p_db_column_name=>'VALIDATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de Validaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631192612011521069.4001)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>3
,p_column_identifier=>'I'
,p_column_label=>'Nombre del Elemento'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631192830811521069.4001)
,p_db_column_name=>'VALIDATION_TYPE'
,p_display_order=>4
,p_column_identifier=>'K'
,p_column_label=>unistr('Tipo de Validaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(630881727193397263)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(692607705216923380.4001)
,p_db_column_name=>'ADDITIONAL_INFO'
,p_display_order=>5
,p_column_identifier=>'O'
,p_column_label=>unistr('Informaci\00F3n Adicional')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(692607805513923383.4001)
,p_db_column_name=>'PAGE_LOCKED_BY'
,p_display_order=>6
,p_column_identifier=>'P'
,p_column_label=>unistr('P\00E1gina Bloqueada por')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492043708517609378.4001)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>7
,p_column_identifier=>'D'
,p_column_label=>unistr('Bot\00F3n Asociado')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631192904691521070.4001)
,p_db_column_name=>'CONDITION'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>unistr('Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631193011047521070.4001)
,p_db_column_name=>'COND_EXP1'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631193115661521070.4001)
,p_db_column_name=>'COND_EXP2'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484018600220797746.4001)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-WizardSteps--slim'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(484017424976766961.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(499049722727446319.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747137722601138152.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(615673214634571526.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202555930603939361.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(484012205657581654.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202555930603939361.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p86_page is null then',
'  return true;',
'else',
'  for c1 in (select 1 x from wwv_flow_lock_page where locked_by is not null and flow_id = :fb_flow_id and object_id = :p86_page) loop',
'     return false;',
'  end loop;',
'end if;',
'return true;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(499677731748000481.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202555930603939361.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(484014412205581703.4001)
,p_branch_action=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.::P646_PAGE_ID:&P86_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(484012205657581654.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(493043430085874630.4001)
,p_name=>'P86_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(499049722727446319.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(499813525383339193.4001)
,p_validation_name=>'requires object selection'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos una validaci\00F3n para continuar.')
,p_when_button_pressed=>wwv_flow_api.id(484012205657581654.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045580542019367802.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(484011119835581586.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045580620939367803.4001)
,p_event_id=>wwv_flow_api.id(2045580542019367802.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492598111175961164.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_collection_status number;',
'   l_id                number;',
'   l_count             number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''UPGRADE_VALIDATIONS'');',
'    for i in 1..apex_application.g_f01.count ',
'    loop',
'        l_id := apex_application.g_f01(i);',
'        select count(*) into l_count ',
'          from wwv_flow_collections ',
'         where n001            = l_id ',
'           and collection_name = ''UPGRADE_VALIDATIONS'';',
'        if l_count = 0 then ',
'            l_collection_status := wwv_flow_collection.add_member(',
'                 p_collection_name => ''UPGRADE_VALIDATIONS'',',
'                 p_n001            => l_id);',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(631633708927666117.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(',
'   p_collection_name => ''UPGRADE_VALIDATIONS'');',
'wwv_flow_collection.create_or_truncate_collection(',
'   p_collection_name => ''UPGRADE_BUTTONS'');',
'wwv_flow_collection.create_or_truncate_collection(',
'   p_collection_name => ''UPGRADE_VALIDATIONS2'');'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_api.create_page(
 p_id=>87.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso de Lista de Valores'
,p_step_title=>'Uso de Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631175403847405645.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631182627915434600.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000P87a lov_util */ id, lov_name, ',
'(select count(*) ',
' from wwv_flow_step_items i',
' where flow_id = :fb_flow_id and i.named_lov = a.lov_name)',
' item_references,',
'(select count(*) ',
' from wwv_flow_region_report_column c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and c.named_lov = a.id) +',
'(select count(*) ',
' from wwv_flow_region_columns c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and ( c.lov_id = a.id or c.filter_lov_id = a.id )) ',
' report_column_references,',
'(select count(*)',
'from wwv_flow_worksheet_columns c',
'where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and',
'          c.rpt_named_lov = a.id) ir_references,',
'(select count(*) ',
' from wwv_flow_step_items i',
' where flow_id = :fb_flow_id and i.named_lov = a.lov_name)',
' +',
'(select count(*) ',
' from wwv_flow_region_report_column c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and c.named_lov = a.id) ',
' +',
'(select count(*) ',
' from wwv_flow_region_columns c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and ( c.lov_id = a.id or c.filter_lov_id = a.id ))',
'+',
'(select count(*)',
'from wwv_flow_worksheet_columns c',
'where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and',
'          c.rpt_named_lov = a.id)',
'  total_references',
'from WWV_FLOW_LISTS_OF_VALUES$ a',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(631182707640434600.4001)
,p_name=>'Utilization'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631182924063434607.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631183011459434609.4001)
,p_db_column_name=>'LOV_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:4111:F4000_P4111_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.:'
,p_column_linktext=>'#LOV_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631183127036434609.4001)
,p_db_column_name=>'ITEM_REFERENCES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Referencias de Elemento'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631187225842449831.4001)
,p_db_column_name=>'REPORT_COLUMN_REFERENCES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Referencias de Columnas de Informe'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631190215631484751.4001)
,p_db_column_name=>'IR_REFERENCES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Referencias de Informe Interactivo'
,p_allow_filtering=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631198409856691182.4001)
,p_db_column_name=>'TOTAL_REFERENCES'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Total de Referencias'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(631190424635487365.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(631182627915434600.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:87,RIR,CIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(631193904981536440.4001)
,p_branch_action=>'f?p=&FLOW_ID.:87:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(631200914975787319.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'87'
);
end;
/
prompt --application/pages/page_00088
begin
wwv_flow_api.create_page(
 p_id=>88.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Deshacer (Flashback)'
,p_alias=>'UNDO'
,p_page_mode=>'MODAL'
,p_step_title=>'Deshacer (Flashback)'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'function passBack(source)',
'{',
'    temp = document.getElementById(''P88_CALLING_FIELD'').value;',
'    targetField = window.opener.document.getElementById(temp);',
'    targetField.value = document.getElementById(source).value;',
'    targetField.focus;',
'    close();',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(23943311758365986.4001)
,p_name=>'Origen Actual'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P88_TABLE in (',
'  ''WWV_FLOW_PAGE_PLUGS'',',
'  ''WWV_FLOW_TEMPLATES'',',
'  ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  ''WWV_FLOW_STEP_PROCESSING'') and',
'  :P88_COLUMN in (',
'  ''PLUG_SOURCE'',',
'  ''HEADER_TEMPLATE'',',
'  ''BOX'',',
'  ''FOOTER_TEMPLATE'',',
'  ''TEMPLATE'',',
'  ''PROCESS_SQL_CLOB''',
'  ) then',
'return ''select ''''<div class="htmldbTiny"><pre>''''||',
'case when sys.dbms_lob.getlength(''||:P88_COLUMN||'') > 2000 then wwv_flow_escape.html(sys.dbms_lob.substr(''||',
':P88_COLUMN||'',1000,1))||chr(10)||''''.''''||chr(10)||''''.''''||chr(10)||''''.'''' else wwv_flow_escape.html(''||:P88_COLUMN||'') end||''''</pre></div>'''' thevalue',
'   from #OWNER#.''||:P88_TABLE||'' where id = :P88_ID and security_group_id = :flow_security_group_id'';',
'else',
'   return null;',
'end if;'))
,p_display_when_condition=>'P88_SCN'
,p_display_condition_type=>'ITEM_IS_ZERO'
,p_header=>'<div style="white-space:preserve;">'
,p_footer=>'</div>'
,p_lazy_loading=>false
,p_plug_query_max_columns=>10
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519104458490105.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519227158490105.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519311398490105.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519415045490105.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519512697490105.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519616507490107.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519730922490107.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519813952490107.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66519910107490107.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66520020614490107.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(24016204054082933.4001)
,p_name=>'Origen Pasado: SCN'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P88_TABLE in (',
'  ''WWV_FLOW_PAGE_PLUGS'',',
'  ''WWV_FLOW_TEMPLATES'',',
'  ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  ''WWV_FLOW_STEP_PROCESSING'')',
'  and',
'  :P88_COLUMN in (',
'  ''PLUG_SOURCE'',',
'  ''HEADER_TEMPLATE'',',
'  ''BOX'',',
'  ''FOOTER_TEMPLATE'',',
'  ''TEMPLATE'',',
'  ''PROCESS_SQL_CLOB''',
'  )',
'then',
'return ''select ''''<div class="htmldbTiny"><pre>''''||',
'case when sys.dbms_lob.getlength(''||:P88_COLUMN||'') > 2000 then wwv_flow_escape.html_trunc(''||',
':P88_COLUMN||'',1000)||chr(10)||''''.''''||chr(10)||''''.''''||chr(10)||''''.'''' else wwv_flow_escape.html(''||:P88_COLUMN||'') end||''''</pre></div>'''' thevalue',
'  from #OWNER#.''||:P88_TABLE|| ''',
'       as of scn :P88_SCN',
' where id = :P88_ID',
'   and (flow_id = :P88_FLOW',
'        or',
'        :P88_FLOW is null) and security_group_id = :flow_security_group_id'';',
'else',
'  return null;',
'end if;'))
,p_display_when_condition=>'P88_SCN'
,p_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_lazy_loading=>false
,p_plug_query_max_columns=>10
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P88_TABLE in (',
'  ''WWV_FLOW_PAGE_PLUGS'',',
'  ''WWV_FLOW_TEMPLATES'',',
'  ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  ''WWV_FLOW_STEP_PROCESSING'') ',
'  and',
'  :P88_COLUMN in (',
'  ''PLUG_SOURCE'',',
'  ''HEADER_TEMPLATE'',',
'  ''BOX'',',
'  ''FOOTER_TEMPLATE'',',
'  ''TEMPLATE'',',
'  ''PROCESS_SQL_CLOB''',
'  )',
'then',
'return ''select ''''<div class="htmldbTiny"><pre><a href="javascript:passBack(''''''''P88_HIDDEN_SOURCE'''''''');" class="noVisist">''''||htf.escape_sc(dbms_lob.substr(''||',
':P88_COLUMN||'',1000,1))||''''</a></pre></div>'''' thevalue',
'  from #OWNER#.''||:P88_TABLE|| ''',
'       as of scn :P88_SCN',
' where id = :P88_ID',
'   and (flow_id = :P88_FLOW',
'        or',
'        :P88_FLOW is null) and security_group_id = :flow_security_group_id'';',
'else',
'  return null;',
'end if;'))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66517607873490049.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66517706822490049.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66517814606490049.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66517914919490049.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66518012733490049.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66518105230490049.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66518218015490049.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66518302568490050.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66518413761490050.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66518528893490050.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31301207595076703.4001)
,p_plug_name=>'Undo Period'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>125
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_retention pls_integer;',
'begin',
'   for c1 in (SELECT (VALUE/60/60) the_val',
'                FROM V$PARAMETER ',
'               WHERE NAME =''undo_retention'')',
'   loop',
'       l_retention := c1.the_val;',
'   end loop;',
'   sys.htp.p(wwv_flow_lang.system_message(''F4000_P88_SELECT_TIME'')||''<br />'');',
'   sys.htp.p(wwv_flow_lang.system_message(''F4000_P88_FLASHBACK_QUERY'',:PRODUCT_NAME)||''<br />'');',
'   sys.htp.p(wwv_flow_lang.system_message(''F4000_P88_UNDO_RETENTION'',l_retention)||''<br />'');',
'/*',
'   sys.htp.p(''<div class="htmldbInstructionText">''||wwv_flow_lang.system_message(''F4000_P88_SELECT_TIME'')||''</div><br />'');',
'   sys.htp.p(''<div class="htmldbInstructionText">''||wwv_flow_lang.system_message(''F4000_P88_FLASHBACK_QUERY'',:PRODUCT_NAME)||''</div><br />'');',
'   sys.htp.p(''<div class="htmldbInstructionText">''||wwv_flow_lang.system_message(''F4000_P88_UNDO_RETENTION'',l_retention)||''</div><br />'');',
'*/',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119584365535190503.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(23954108042421738.4001)
,p_button_sequence=>95
,p_button_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_button_name=>'P88_SEARCH'
,p_button_static_id=>'P88_SEARCH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(294886360549503966.4001)
,p_button_sequence=>105
,p_button_plug_id=>wwv_flow_api.id(1119584365535190503.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1119584478839190504.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119584365535190503.4001)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(23972412684508264.4001)
,p_branch_action=>'88'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23937520191302195.4001)
,p_name=>'P88_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23938429195304828.4001)
,p_name=>'P88_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23939206123307607.4001)
,p_name=>'P88_PK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23939808894308429.4001)
,p_name=>'P88_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24013206908064820.4001)
,p_name=>'P88_SCN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_prompt=>'Hora de Cambio'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(AUDIT_DATE,''Day, Month DD HH24:MI:SS'') d,scn',
'  from WWV_FLOW_BUILDER_AUDIT_TRAIL',
' where FLOW_TABLE_PK = :P88_ID',
'   and AUDIT_DATE > (SELECT sysdate - (VALUE/60/60/24) the_val',
'                       FROM V$PARAMETER ',
'                      WHERE NAME =''undo_retention'')',
'   and scn   in (select max(scn) scn',
'                   from WWV_FLOW_BUILDER_AUDIT_TRAIL',
'                  where FLOW_TABLE_PK = :P88_ID',
'                  group by audit_date)',
' order by scn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Origen Actual -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la hora del cambio de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24040221612305631.4001)
,p_name=>'P88_CALLING_FIELD'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24074527134505901.4001)
,p_name=>'P88_HIDDEN_SOURCE'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_api.id(24016204054082933.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24078322201523437.4001)
,p_name=>'P88_HIDDEN_ORIG_SOURCE'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_api.id(23943311758365986.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P88_TABLE in (',
'  ''WWV_FLOW_PAGE_PLUGS'',',
'  ''WWV_FLOW_TEMPLATES'',',
'  ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  ''WWV_FLOW_STEP_PROCESSING'') ',
'  and',
'  :P88_COLUMN in (',
'  ''PLUG_SOURCE'',',
'  ''HEADER_TEMPLATE'',',
'  ''BOX'',',
'  ''FOOTER_TEMPLATE'',',
'  ''TEMPLATE'',',
'  ''PROCESS_SQL_CLOB''',
'  )',
'then',
'  declare',
'    l_thevalue varchar2(32767);',
'  begin',
'    execute immediate',
'        ''begin''||chr(10)||',
'        ''select ''||wwv_flow_assert.enquote_name(v(''P88_COLUMN''))||chr(10)||',
'        ''  into :1''||chr(10)||',
'        ''  from ''||wwv_flow_assert.enquote_name(v(''P88_TABLE''))||chr(10)||',
'        '' where id     = :2''||chr(10)||',
'        ''   and rownum = 1;''||chr(10)||',
'        ''end;''',
'        using out l_thevalue,',
'               in :P88_ID;',
'',
'    return l_thevalue;',
'  exception when NO_DATA_FOUND then return null;',
'  end;',
'else',
'  return null;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(66523807212505308.4001)
,p_name=>'P88_FLOW'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(31301207595076703.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(24076418954513009.4001)
,p_computation_sequence=>10
,p_computation_item=>'P88_HIDDEN_SOURCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P88_TABLE in (',
'  ''WWV_FLOW_PAGE_PLUGS'',',
'  ''WWV_FLOW_TEMPLATES'',',
'  ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  ''WWV_FLOW_STEP_PROCESSING'') ',
'  and',
'  :P88_COLUMN in (',
'  ''PLUG_SOURCE'',',
'  ''HEADER_TEMPLATE'',',
'  ''BOX'',',
'  ''FOOTER_TEMPLATE'',',
'  ''TEMPLATE'',',
'  ''PROCESS_SQL_CLOB''',
'  )',
'then',
'  declare',
'    l_thevalue varchar2(32767);',
'  begin',
'    execute immediate',
'        ''begin''||chr(10)||',
'        ''select ''||wwv_flow_assert.enquote_name(v(''P88_COLUMN''))||chr(10)||',
'        ''  into :1''||chr(10)||',
'        ''  from ''||wwv_flow_assert.enquote_name(v(''P88_TABLE''))||'' as of scn :2''||chr(10)||',
'        '' where id     = :3''||chr(10)||',
'        ''   and rownum = 1;''||chr(10)||',
'        ''end;''',
'        using out l_thevalue,',
'               in :P88_SCN,',
'               in :P88_ID;',
'',
'    return l_thevalue;',
'  exception when NO_DATA_FOUND then return null;',
'  end;',
'else',
'  return null;',
'end if;'))
,p_computation_comment=>'return ''select ''||:P88_COLUMN||'' thevalue from ''||:P88_TABLE||'' as of scn :P88_SCN where id = :P88_ID'';'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'P88_SCN'
,p_compute_when_type=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(294442275128534118.4001)
,p_name=>'close and set source'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(294886360549503966.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(294442383562534119.4001)
,p_event_id=>wwv_flow_api.id(294442275128534118.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
,p_attribute_01=>'P88_HIDDEN_SOURCE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1119584535219190505.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Cancel Modal'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1119584478839190504.4001)
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_api.create_page(
 p_id=>89.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Aplicaci\00F3n')
,p_step_title=>unistr('Actualizar Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(444636405193158991.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Los tipos de actualizaci\00F3n disponibles se muestran junto al n\00FAmero de objetos que se pueden actualizar. Haga clic en el recuento de objetos para revisar los candidatos y actualizar.'),
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(444642525765435028.4001)
,p_plug_name=>unistr('Resumen de la Actualizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ob,',
'       migration_type,',
'       migration_type as migration_type_code,',
'       object_count',
'  from ( select 1 ob, ',
'                ''NUMBER_FIELD''    as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items i,',
'                wwv_flow_step_validations v',
'          where i.flow_id           = :FB_FLOW_ID',
'            and i.security_group_id = :WORKSPACE_ID',
'            and i.display_as        in (''TEXT'',''NATIVE_TEXT_FIELD'')',
'            and v.flow_id           = i.flow_id',
'            and v.flow_step_id      = i.flow_step_id',
'            and v.validation_type   = ''ITEM_IS_NUMERIC''',
'            and v.validation        = i.name',
'            and v.validation_condition_type is null',
'            and v.when_button_pressed       is null',
'         having count(*) > 0',
'          union',
'         select 3 ob, ',
'                ''REQUIRED''        as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items i,',
'                wwv_flow_step_validations v',
'          where i.flow_id           = :FB_FLOW_ID',
'            and i.security_group_id = :WORKSPACE_ID',
'            and v.flow_id           = i.flow_id',
'            and v.flow_step_id      = i.flow_step_id',
'            and v.validation_type   = ''ITEM_NOT_NULL''',
'            and v.validation        = i.name',
'            and v.validation_condition_type is null',
'            and v.when_button_pressed       is null',
'         having count(*) > 0',
'          union',
'         select 15 ob, ',
'                ''ADVANCED''        as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items i,',
'                wwv_flow_step_validations v',
'          where i.flow_id           = :FB_FLOW_ID',
'            and i.security_group_id = :WORKSPACE_ID',
'            and v.flow_id           = i.flow_id',
'            and v.flow_step_id      = i.flow_step_id',
'            and ((v.validation_type = ''ITEM_IS_NUMERIC'' and ',
'                  i.display_as in (''TEXT'',''NATIVE_TEXT_FIELD'')) or',
'                 v.validation_type in (''ITEM_NOT_NULL'',''ITEM_IS_DATE''))',
'            and v.validation        = i.name',
'            and (v.when_button_pressed is not null or',
'                 v.validation_condition_type is not null)',
'         having count(*) > 0',
'          union',
'         select 5 ob, ',
'                ''LOV_NULL_VALUE''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and lov_null_value    = ''%null%''',
'         having count(*) > 0',
'          union',
'         select 6 ob, ',
'                ''DATE_PICKER''     as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and display_as        = ''NATIVE_DATE_PICKER_CLASSIC''',
'         having count(*) > 0',
'          union',
'         select 7 ob, ',
'                ''CKEDITOR''        as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and display_as        = ''NATIVE_RICH_TEXT_EDITOR''',
'            and attribute_01      = ''FCKEDITOR2''',
'         having count(*) > 0',
'          union',
'         select 11 ob, ',
'                ''IR_GROUP_BY''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and show_group_by     = ''N''',
'            and show_search_bar   = ''Y''',
'            and show_actions_menu = ''Y''',
'         having count(*) > 0',
'          union',
'         select 12 ob, ',
'                ''IR_SAVE_PUBLIC''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id               = :FB_FLOW_ID',
'            and security_group_id     = :WORKSPACE_ID',
'            and allow_save_rpt_public = ''N''',
'            and show_search_bar       = ''Y''',
'            and show_actions_menu     = ''Y''',
'         having count(*) > 0',
'          union',
'         select 13 ob, ',
'                ''IR_SUBSCRIBE''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and show_notify       = ''N''',
'            and show_search_bar   = ''Y''',
'            and show_actions_menu = ''Y''',
'         having count(*) > 0',
'           union',
'         select 14 ob, ',
'                ''IR_ROWS_PER_PAGE''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id            = :FB_FLOW_ID',
'            and security_group_id  = :WORKSPACE_ID',
'            and show_display_row_count = ''N''',
'            and show_search_bar    = ''Y''',
'         having count(*) > 0',
'           union',
'        select 15 ob, ',
'                ''IR_PIVOT''  as migration_type,',
'                count(*)    as object_count',
'           from wwv_flow_worksheets',
'          where flow_id            = :FB_FLOW_ID',
'            and security_group_id  = :WORKSPACE_ID',
'            and show_pivot         = ''N''',
'            and show_search_bar    = ''Y''',
'         having count(*) > 0',
'            union',
'         select 17 ob, ',
'                ''CALENDAR_TO_CSS_CALENDAR''    as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_page_plugs',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and plug_source_type  = ''NATIVE_CALENDAR''',
'         having count(*) > 0',
'           union',
'         select 19 ob, ',
'                ''IR_FIXED_HEADER'' as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and fixed_header      = ''NONE''',
'         having count(*) > 0',
'           union',
'         select 21 ob, ',
'                ''TABULAR_TO_IG'' as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_page_plugs',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id =  :WORKSPACE_ID',
'            and plug_source_type  = ''NATIVE_TABFORM''',
'         having count(*) > 0       ',
'                  union',
'         select 22 ob, ',
'                ''SWITCH''   as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id =  :WORKSPACE_ID',
'            and display_as        in ( ''NATIVE_SELECT_LIST'', ''NATIVE_RADIOGROUP'')',
'            and wwv_flow_upgrade_app.can_update_to_switch( flow_id, lov, named_lov, lov_display_extra, lov_display_null, display_as, attribute_01, attribute_02, attribute_03 ) = ''Y''',
'         having count(*) > 0',
'                  union',
'         select 23 ob, ',
'                ''FORM_REGION''   as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_steps',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id =  :WORKSPACE_ID',
'            and wwv_flow_upgrade_app.can_update_to_form_region( flow_id, id ) = ''Y''',
'         having count(*) > 0   ',
'                  union',
'         select 24 ob, ',
'                ''DATE_PICKER_JET'' as migration_type,',
'                count(*)          as object_count',
'           from ( select 1 ',
'                    from wwv_flow_step_items',
'                   where flow_id = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and display_as        = ''NATIVE_DATE_PICKER''',
'                union all ',
'                  select 1',
'                    from wwv_flow_region_columns',
'                   where flow_id = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and item_type         = ''NATIVE_DATE_PICKER'' )',
'         having count(*) > 0',
'                  union',
'         select 25 ob, ',
'                ''CSS_CALENDAR_V3_TO_V5''    as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_page_plugs',
'          where flow_id                     = :FB_FLOW_ID',
'            and security_group_id           = :WORKSPACE_ID',
'            and plug_source_type            = ''NATIVE_CSS_CALENDAR''',
'            and attribute_23                = ''3''',
'            and attribute_12                is null',
'            and attribute_15                is null',
'            and plugin_init_javascript_code is null',
'         having count(*) > 0',
'                  union',
'         select 26 ob, ',
'                ''BUTTON_CONFIRM_LINK_TO_NATIVE'' as migration_type,',
'                count(*)                        as object_count',
'           from wwv_flow_step_buttons',
'          where flow_id             = :FB_FLOW_ID',
'            and security_group_id   = :WORKSPACE_ID',
'            and button_action       = ''REDIRECT_URL''',
'            and button_name         = regexp_substr(button_redirect_url, q''{javascript:apex.confirm\(htmldb_delete_message,''(.+)''\);}'', 1, 1, null, 1)',
'            and confirm_enabled     = ''N''',
'         having count(*) > 0',
'       )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(444642604334435028.4001)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn elemento para la actualizaci\00F3n.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(629276118592081823.4001)
,p_db_column_name=>'OB'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>unistr('Secuencia de Visualizaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484806625030472038.4001)
,p_db_column_name=>'MIGRATION_TYPE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>unistr('Tipo de Actualizaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(484799616606261493)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484806725795472039.4001)
,p_db_column_name=>'MIGRATION_TYPE_CODE'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>unistr('C\00F3digo de Tipo de Migraci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484806800223472039.4001)
,p_db_column_name=>'OBJECT_COUNT'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Objetos Candidatos'
,p_column_link=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:RP,911:P911_UPGRADE_TYPE:#MIGRATION_TYPE_CODE#'
,p_column_linktext=>'#OBJECT_COUNT#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(444639125839159043.4001)
,p_branch_action=>'f?p=&FLOW_ID.:89:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_api.create_page(
 p_id=>90.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Juego de Separadores Nuevo o Existente')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46531111870668614.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100947024191482524.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Los separadores se agrupan en recopilaciones denominadas juego de separadores. Todos los separadores deben formar parte de un juego de separadores. Un separador puede tener una relaci\00F3n de uno a uno con una p\00E1gina o puede ser el "separador actual"')
||unistr(' de varias p\00E1ginas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(100997430155570916.4001)
,p_name=>'Juegos de Separadores Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
' tab_sequence, ',
' tab_step, ',
' substr(tab_text,1,50) tab_text,',
' TAB_ALSO_CURRENT_FOR_PAGES',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn juego de tabuladores.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48873218651772683.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48873323050772683.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48873413021772683.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48873509183772683.4001)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200002702335706812.4001)
,p_query_column_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Separador tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101139312403928576.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100953301640492391.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46531111870668614.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100950323673489322.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46531111870668614.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(100950727522489326.4001)
,p_branch_action=>'93'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(100950323673489322.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P4722_TAB_SET_CHOICE'
,p_branch_condition_text=>'EXISTING'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101908723794829013.4001)
,p_branch_action=>'94'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(100950323673489322.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P4722_TAB_SET_CHOICE'
,p_branch_condition_text=>'NEW'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100959114893517184.4001)
,p_name=>'F4000_P4722_TAB_SET_CHOICE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(100947024191482524.4001)
,p_item_default=>'EXISTING'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TAB_SET_CHOICE'
,p_lov=>'.'||wwv_flow_api.id(84320304523598135.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione una de las siguientes opciones:',
'<p/>',
'<ul class="noIndent">',
'<li>Si el juego de separadores no existe, seleccione <strong>Crear un nuevo juego de separadores y un nuevo separador en el juego de separadores.</strong>. ',
'<li>Si existe el juego de separadores, seleccione <strong>Utilizar un juego de separadores existente y crear un nuevo separador en el juego de separadores existente.</strong>.',
unistr('Utilice esta opci\00F3n si ya tiene un juego de separadores y desea tener un nuevo separador dentro de este juego.'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100967617253531308.4001)
,p_name=>'F4000_P90_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100947024191482524.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574037695052616907.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(100953301640492391.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574037755179616908.4001)
,p_event_id=>wwv_flow_api.id(574037695052616907.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(101924313633864135.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate flow selected'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :FB_FLOW_ID is null then',
'   raise_application_error(''-20000'',''No flow selected'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(100950323673489322.4001)
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_api.create_page(
 p_id=>91.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Indicador de progreso de c\00F3digo embebido')
,p_alias=>'EMBEDDED-CODE-PROGRESS-INDICATOR'
,p_step_title=>unistr('Indicador de progreso de c\00F3digo embebido')
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var myTimer = setInterval(checkProgress, 2000); // check every 2 seconds (2000 ms)',
'',
'function stopMyTimer() {',
'  console.log(''stopping time'');',
'  clearInterval(myTimer);',
'}',
'',
'function checkProgress () {',
'    console.log(''checkProgress begin'');',
'    apex.server.process( "CHECK_PROGRESS", {}, {',
'        success: function( data )  {',
'            // do something here',
'            if (data && data.item) {',
'            for (i = 0; i < data.item.length; i++) {',
'                item = data.item[i];',
'                $s(item.id, item.value); //, null, true );',
'',
'                if (item.id === ''P91_PROGRESS'') {',
'                    $(''.progress-bar'').width(item.value+''%'');',
'                    $(''.progress-bar'').html(item.value+''%'');',
'                    }',
'                console.log(item.id+'':''+item.value);',
'                }',
'            }',
'        },',
'        error: function( jqXHR, textStatus, errorThrown ) {',
'        // handle error',
'        console.log(textStatus);',
'        }',
'    } );',
'    console.log(''checkProgress end'');',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.progress-bar {',
'    display: -ms-flexbox;',
'    display: flex;',
'    -ms-flex-direction: column;',
'    flex-direction: column;',
'    -ms-flex-pack: center;',
'    justify-content: center;',
'    color: #fff;',
'    text-align: center;',
'    white-space: nowrap;',
'    background-color: #007bff;',
'    transition: width .6s ease;',
'}',
'',
'.progress {',
'    display: -ms-flexbox;',
'    display: flex;',
'    height: 8rem;',
'    overflow: hidden;',
'    font-size: 3rem;',
'    background-color: #cfdae4;',
'    border-radius: .5rem;',
'    margin:4rem 25%;',
'}'))
,p_step_template=>wwv_flow_api.id(438185046231548086.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2002043381920114.4001)
,p_plug_name=>'Barra de Progreso'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span>',
'  <div class="progress">',
'    <div class="progress-bar" style="width:0%"></div>',
'  </div>',
'</span>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2002175280920115.4001)
,p_plug_name=>'Elementos de barra de progreso'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2136875641414613.4001)
,p_name=>unistr('Resultados de la B\00FAsqueda')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_EMBEDDED_CODE'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1310649889953751.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2140000612414659.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Identificador de Flujo'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2140470148414659.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Identificador de P\00E1gina')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2140800932414660.4001)
,p_query_column_id=>3
,p_column_alias=>'PROPERTY_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Identificador de propiedad'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2141222841414660.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Identificador de Componente'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2141698213414660.4001)
,p_query_column_id=>5
,p_column_alias=>'COMPONENT_TYPE_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Identificador de tipo de componente'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2142092555414660.4001)
,p_query_column_id=>6
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2142411574414661.4001)
,p_query_column_id=>7
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Nombre del Componente'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2142841999414661.4001)
,p_query_column_id=>8
,p_column_alias=>'COMPONENT_TYPE_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Nombre de Tipo de Componente'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2143259854414661.4001)
,p_query_column_id=>9
,p_column_alias=>'PROPERTY_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Nombre de la propiedad'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2143696208414661.4001)
,p_query_column_id=>10
,p_column_alias=>'PROPERTY_TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Tipo de Propiedad'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2144068485414662.4001)
,p_query_column_id=>11
,p_column_alias=>'CODE_TYPE'
,p_column_display_sequence=>11
,p_column_heading=>'Code Type'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2144458629414662.4001)
,p_query_column_id=>12
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>12
,p_column_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2144800546414662.4001)
,p_query_column_id=>13
,p_column_alias=>'SCOPE_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Scope Name'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2145299118414663.4001)
,p_query_column_id=>14
,p_column_alias=>'PROPERTY_SOURCE'
,p_column_display_sequence=>14
,p_column_heading=>'Property Source'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2136910672414613.4001)
,p_plug_name=>'Buscar'
,p_region_name=>'FACETS'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(2136875641414613.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'Y'
,p_attribute_12=>'10000'
,p_attribute_13=>'Y'
,p_attribute_15=>'10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2002266873920116.4001)
,p_name=>'P91_STATUS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2002175280920115.4001)
,p_prompt=>'Estado'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2002314894920117.4001)
,p_name=>'P91_PROGRESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2002175280920115.4001)
,p_prompt=>'Estado'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2002433892920118.4001)
,p_name=>'P91_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2002175280920115.4001)
,p_prompt=>'Estado'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2137416661414621.4001)
,p_name=>'P91_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2136910672414613.4001)
,p_prompt=>'Buscar'
,p_source=>'PAGE_NAME,COMPONENT_NAME,COMPONENT_TYPE_NAME,PROPERTY_NAME,PROPERTY_TYPE,CODE_TYPE,GROUP_NAME,SCOPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2137862944414624.4001)
,p_name=>'P91_COMPONENT_TYPE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2136910672414613.4001)
,p_prompt=>'Tipo de Componente'
,p_source=>'COMPONENT_TYPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2138284373414624.4001)
,p_name=>'P91_CODE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2136910672414613.4001)
,p_prompt=>'Idioma'
,p_source=>'CODE_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2138687102414624.4001)
,p_name=>'P91_SCOPE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2136910672414613.4001)
,p_prompt=>unistr('\00C1mbito')
,p_source=>'SCOPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dv, rv ',
'from (',
'    select distinct scope_name as dv, scope_name as rv, -1 as page_id',
'    from wwv_flow_embedded_code ',
'    where page_id is null ',
'    union all ',
'    select distinct scope_name as dv, scope_name as rv, page_id',
'    from wwv_flow_embedded_code',
'    where page_id is not null',
'    order by page_id',
')',
'order by page_id;'))
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>true
,p_fc_sort_by_top_counts=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2002628846920120.4001)
,p_name=>'Toggle Working'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P91_STATUS'
,p_condition_element=>'P91_STATUS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WORKING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2002720490920121.4001)
,p_event_id=>wwv_flow_api.id(2002628846920120.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2002043381920114.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2004041215920134.4001)
,p_event_id=>wwv_flow_api.id(2002628846920120.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2002043381920114.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2002969276920123.4001)
,p_name=>'Toggle Complete'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P91_STATUS'
,p_condition_element=>'P91_STATUS'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'WORKING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003011457920124.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'stopMyTimer();'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003934757920133.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2136875641414613.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003296736920126.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2136910672414613.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003821666920132.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2136910672414613.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003367823920127.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2136875641414613.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003465704920128.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.region("FACETS").fetchCounts();'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2003522150920129.4001)
,p_event_id=>wwv_flow_api.id(2002969276920123.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2136875641414613.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2004126703920135.4001)
,p_name=>'Cache Embedded Code'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2004245836920136.4001)
,p_event_id=>wwv_flow_api.id(2004126703920135.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'wwv_flow_property_devx.cache_embedded_code(:FB_FLOW_ID, ''P91'');'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2001913839920113.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Progress Bar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.truncate_collection(''FLOW_EMBEDDED_CODE'');',
'exception ',
'    -- truncate might fail if this is the first time running in this session. Just ignore the error.',
'    when others then null;',
'end;',
':P91_STATUS := ''WORKING'';',
':P91_PROGRESS := 0;',
':P91_MESSAGE := ''Initializing...'';',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2002543960920119.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CHECK_PROGRESS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- this should probably be put into a package and made generic so that you pass in the prefix, or the item names',
'-- but leave as is until I get the functionality working',
'apex_json.open_object;',
'apex_json.write(''status'', ''OK'');',
'apex_json.open_array(''item'');',
'apex_json.open_object;',
'apex_json.write(''id'', ''P91_PROGRESS'');',
'apex_json.write(''value'', :P91_PROGRESS);',
'apex_json.close_object;',
'apex_json.open_object;',
'apex_json.write(''id'', ''P91_STATUS'');',
'apex_json.write(''value'', :P91_STATUS);',
'apex_json.close_object;',
'apex_json.open_object;',
'apex_json.write(''id'', ''P91_MESSAGE'');',
'apex_json.write(''value'', :P91_MESSAGE);',
'apex_json.close_object;',
'apex_json.close_array;',
'apex_json.close_object;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_api.create_page(
 p_id=>92.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46537707508752518.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101350830881269568.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_standard_tab (',
'    p_flow_id                      => :FB_FLOW_ID,',
'    p_new_parent_tabset            => :F4000_P4722_NEW_PARENT_TABSET,',
'    p_new_parent_tab_text          => v(''F4000_P4722_NEW_PARENT_TAB_TEXT''),',
'    p_parent_tab_set               => :F4000_P4722_PARENT_TAB_SET,',
'    p_tab_set_choice               => :F4000_P4722_TAB_SET_CHOICE,   ',
'    p_tab_set                      => :F4000_P4722_TABSET,    ',
'    p_new_tab_display_text         => v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),',
'    p_tab_sequence                 => :F4000_P4722_TAB_SEQUENCE,',
'    p_current_page                 => :F4000_P4722_CURRENT_PAGE,    ',
'    p_current_image                => :F4000_P4722_CURRENT_IMAGE,',
'    p_non_current_page             => :F4000_P4722_NON_CURRENT_PAGE,',
'    p_image_attributes             => :F4000_P4722_IMAGE_ATTRIBUTES,',
'    p_display_condition            => :F4000_P4722_DISPLAY_CONDITION,',
'    p_condition_type               => :F4000_P4722_CONDITION_TYPE,',
'    p_display_condition_text       => v(''F4000_P4722_DISPLAY_CONDITION_TEXT''),',
'    p_build_option                 => :F4000_P4722_BUILD_OPTION);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101376815088337671.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101357126367284941.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46537707508752518.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130446514359.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46537707508752518.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Separador'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101353724158274798.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46537707508752518.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130469708224.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130446514359.4001)
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101354120578274801.4001)
,p_branch_action=>'4724'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101353724158274798.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573755952054229740.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(101357126367284941.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573756050060229741.4001)
,p_event_id=>wwv_flow_api.id(573755952054229740.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(130447519223.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Tab'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n varchar2(4000);',
'begin',
'    n := replace(v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),'' '',null);',
'    n := replace(n,''&'',null);',
'    n := replace(n,''_'',null);',
'    n := replace(n,''<'',null);',
'    n := replace(n,''>'',null);',
'    n := replace(n,''?'',null);',
'    n := replace(n,''%'',null);',
'    n := upper(substr(n,1,30));',
'    n := ''T_''||n;',
'    ',
'    if v(''F4000_P4722_TAB_SET_CHOICE'') = ''EXISTING'' then',
'        wwv_flow_api.create_tab (',
'            p_flow_id                    => nv(''FB_FLOW_ID''),',
'            p_tab_set                    => v(''F4000_P4722_TABSET''),',
'            p_tab_sequence               => v(''F4000_P4722_TAB_SEQUENCE''),',
'            p_tab_name                   => n,',
'            p_tab_image                  => v(''F4000_P4722_CURRENT_IMAGE''),',
'            p_tab_non_current_image      => v(''F4000_P4722_NON_CURRENT_IMAGE''),',
'            p_tab_image_attributes       => v(''F4000_P4722_IMAGE_ATTRIBUTES''),',
'            p_tab_text                   => v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),',
'            p_tab_step                   => v(''F4000_P4722_CURRENT_PAGE''),',
'            p_tab_also_current_for_pages => null,',
'            p_tab_parent_tabset          => replace(v(''F4000_P4722_PARENT_TAB_SET''),''%null''||''%'',null),',
'            p_tab_plsql_condition        => v(''F4000_P4722_DISPLAY_CONDITION''),',
'            p_tab_disp_cond_text         => v(''F4000_P4722_DISPLAY_CONDITION_TEXT''),',
'            p_display_condition_type     => replace(v(''F4000_P4722_CONDITION_TYPE''),''%null''||''%'',null),',
'            p_required_patch             => replace(v(''F4000_P4722_BUILD_OPTION''),''%null''||''%'',null),',
'            p_tab_comment                => null);',
'            ',
'    elsif v(''F4000_P4722_TAB_SET_CHOICE'') = ''NEW'' then',
'        wwv_flow_api.create_tab (',
'            p_flow_id                    => nv(''FB_FLOW_ID''),',
'            p_tab_set                    => v(''F4000_P4722_TABSET''),',
'            p_tab_sequence               => v(''F4000_P4722_TAB_SEQUENCE''),',
'            p_tab_name                   => n,',
'            p_tab_image                  => v(''F4000_P4722_CURRENT_IMAGE''),',
'            p_tab_non_current_image      => v(''F4000_P4722_NON_CURRENT_IMAGE''),',
'            p_tab_image_attributes       => v(''F4000_P4722_IMAGE_ATTRIBUTES''),',
'            p_tab_text                   => v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),',
'            p_tab_step                   => v(''F4000_P4722_CURRENT_PAGE''),',
'            p_tab_also_current_for_pages => null,',
'            p_tab_parent_tabset          => replace(v(''F4000_P4722_NEW_PARENT_TABSET''),''%null''||''%'',null),',
'            p_tab_plsql_condition        => v(''F4000_P4722_DISPLAY_CONDITION''),',
'            p_tab_disp_cond_text         => v(''F4000_P4722_DISPLAY_CONDITION_TEXT''),',
'            p_display_condition_type     => replace(v(''F4000_P4722_CONDITION_TYPE''),''%null''||''%'',null),',
'            p_required_patch             => replace(v(''F4000_P4722_BUILD_OPTION''),''%null''||''%'',null),',
'            p_tab_comment                => null,',
'            P_AUTO_PARENT_TAB_SET        => v(''F4000_P4722_NEW_PARENT_TABSET''),',
'            P_AUTO_PARENT_TAB_TEXT       => v(''F4000_P4722_NEW_PARENT_TAB_TEXT''));',
'    end if;  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear el separador.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Separador &F4000_P4722_NEW_TAB_DISPLAY_TEXT. creado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(573756177462229742.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(130446514359.4001)
,p_process_success_message=>'Separador &F4000_P4722_NEW_TAB_DISPLAY_TEXT. creado.'
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_api.create_page(
 p_id=>93.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Seleccionar Juego de Separadores Existente'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101770219049479046.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para crear un separador dentro de un juego de separadores existente. Seleccione dicho juego de la lista.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101770831165479048.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(101771118248479049.4001)
,p_name=>'Juegos de Separadores Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48825309314772402.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48825411703772403.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48825527122772403.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48825624636772403.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200345431939216583.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101767832553479034.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200345431939216583.4001)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101767523339479033.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200345431939216583.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101767228219479031.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200345431939216583.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101768103975479036.4001)
,p_branch_action=>'96'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101767523339479033.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101768416978479037.4001)
,p_branch_action=>'96'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P4722_TAB_SET_CHOICE'
,p_branch_condition_text=>'EXISTING'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101769300058479040.4001)
,p_branch_action=>'90'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101767228219479031.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101769606186479042.4001)
,p_name=>'F4000_P4722_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(101770219049479046.4001)
,p_prompt=>'Identificar Juego de Separadores Existente'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(tab_set) d, tab_set v',
'  from wwv_flow_tabs ',
' where flow_id = v(''FB_FLOW_ID'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Seleccione un juego de separadores existente. Si no desea utilizar un juego de separadores existente, haga clic en <strong>Anterior</strong> para seleccionar una opci\00F3n diferente.<p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101769920531479044.4001)
,p_validation_name=>'F4000_P4722_TABSET Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4722_TABSET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el juego de separadores existente.'
,p_associated_item=>wwv_flow_api.id(101769606186479042.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-AUG-2001 00:00'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574037409900616905.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(101767832553479034.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574037568606616906.4001)
,p_event_id=>wwv_flow_api.id(574037409900616905.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00094
begin
wwv_flow_api.create_page(
 p_id=>94.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Juego de Separadores')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46529923036652873.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(101778604849484664.4001)
,p_name=>'Separadores'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48587921546771050.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48588023946771050.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48588125278771050.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48588228035771050.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101779228119484667.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para especificar el nuevo juego de separadores que desea crear. Un juego de separadores identifica una recopilaci\00F3n de separadores.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101779529963484668.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Tab Set:Page:Tab:Also Current For Pages'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101776231745484652.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46529923036652873.4001)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101775920280484651.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46529923036652873.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101775631337484650.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46529923036652873.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101776511272484653.4001)
,p_branch_action=>'95'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101776807882484654.4001)
,p_branch_action=>'90'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101775631337484650.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101777714596484659.4001)
,p_name=>'F4000_P4722_NEW_TAB_SET_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(101779228119484667.4001)
,p_prompt=>'Nuevo Juego de Separadores'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre para el nuevo juego de separadores que desea crear. Un juego de separadores identifica una recopilaci\00F3n de separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(101778029412484660.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4722_TABSET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&F4000_P4722_NEW_TAB_SET_NAME.'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101778326694484663.4001)
,p_validation_name=>'F4000_P4722_NEW_TAB_SET_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4722_NEW_TAB_SET_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nuevo juego de separadores.'
,p_associated_item=>wwv_flow_api.id(101777714596484659.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-AUG-2001 21:58'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574037251413616903.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(101776231745484652.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574037378385616904.4001)
,p_event_id=>wwv_flow_api.id(574037251413616903.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_api.create_page(
 p_id=>95.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Separador Principal')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46532100704684349.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101796821567496663.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>unistr('<p>Para crear separadores principales para esta p\00E1gina debe realizar una de las siguientes acciones: (1) seleccionar un juego de separadores principales existentes de la lista o (2) crear un nuevo juego de separadores principales introduciendo un nom')
||'bre de juego de separadores y el texto de la etiqueta.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101797426979496666.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Tab Set:Page:Tab:Also Current For Pages'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101794130013496653.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46532100704684349.4001)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101793832448496652.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46532100704684349.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101793523974496651.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46532100704684349.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101794716478496655.4001)
,p_branch_action=>'96'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101793832448496652.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101795321588496656.4001)
,p_branch_action=>'94'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101793523974496651.4001)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101795617663496658.4001)
,p_name=>'F4000_P4722_PARENT_TAB_SET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(101796821567496663.4001)
,p_prompt=>'Juego de Separadores Principales'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PARENT_TAB_SET'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(tab_set) d, tab_set r',
'',
'from wwv_flow_toplevel_tabs',
'',
'where flow_id = nv(''FB_FLOW_ID'') and',
'',
'      security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores Principales -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Seleccione un juego de separadores principales existentes de la lista.</div> ',
''))
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101795913646496659.4001)
,p_name=>'F4000_P95_X'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(101796821567496663.4001)
,p_prompt=>'- o -'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101796221176496660.4001)
,p_name=>'F4000_P4722_NEW_PARENT_TABSET'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(101796821567496663.4001)
,p_prompt=>'Nuevo Juego de Separadores Principales'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Esta opci\00F3n crea un juego de separadores principales nuevo. Introduzca un nuevo nombre de juego de separadores principales.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101796521230496661.4001)
,p_name=>'F4000_P4722_NEW_PARENT_TAB_TEXT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(101796821567496663.4001)
,p_prompt=>'Nuevo Texto de Separador Principal'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Esta opci\00F3n crea un juego de separadores principales nuevo. Este atributo define el texto que aparece en el separador. Si el separador es una imagen, introduzca texto para describir el separador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574037099461616901.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(101794130013496653.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574037194856616902.4001)
,p_event_id=>wwv_flow_api.id(574037099461616901.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00096
begin
wwv_flow_api.create_page(
 p_id=>96.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Nombre de Separador')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46533525769700978.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101786821889489659.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>unistr('<p>Los separadores forman parte de un juego de separadores. Utilice esta p\00E1gina para especificar un separador en el juego de separadores.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101787402566489665.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Tab Set:Page:Tab:Also Current For Pages'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(199998726661694911.4001)
,p_name=>'Juegos de Separadores Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_step, ',
' substr(tab_text,1,50) tab_text, TAB_ALSO_CURRENT_FOR_PAGES',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199999028826694916.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199999106397694917.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199999219301694917.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199999330433694917.4001)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199999419992694917.4001)
,p_query_column_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Separador tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101783814639489630.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46533525769700978.4001)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101783519889489629.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46533525769700978.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101783228269489628.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46533525769700978.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1828328417328731.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4722:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>41
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(810620502384714357.4001)
,p_branch_action=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(101783228269489628.4001)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101785921664489638.4001)
,p_name=>'F4000_P96_TS'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(101786821889489659.4001)
,p_prompt=>'Nuevo Juego de Separadores'
,p_source=>'v(''F4000_P4722_NEW_TAB_SET_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_display_when=>'v(''F4000_P4722_TAB_SET_CHOICE'') = ''NEW'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Introduzca una etiqueta de separador.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(101786222597489657.4001)
,p_name=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(101786821889489659.4001)
,p_prompt=>'Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto de la etiqueta de separador. Esta etiqueta aparecer\00E1 en el separador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102241931358132208.4001)
,p_name=>'F4000_P96_TS2'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_api.id(101786821889489659.4001)
,p_prompt=>'Juego de Separadores:'
,p_source=>'F4000_P4722_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_display_when=>'v(''F4000_P4722_TAB_SET_CHOICE'') = ''EXISTING'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Juego de separadores seleccionado actualmente.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101786519403489658.4001)
,p_validation_name=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el texto de visualizaci\00F3n del separador.')
,p_associated_item=>wwv_flow_api.id(101786222597489657.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-AUG-2001 23:46'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573756854634229749.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(101783814639489630.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573756933107229750.4001)
,p_event_id=>wwv_flow_api.id(573756854634229749.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00097
begin
wwv_flow_api.create_page(
 p_id=>97.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('C\00F3mo Crear Componentes de P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('C\00F3mo Crear Componentes de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1474233099802765822.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1477171307612322861.4001)
,p_plug_name=>'Ayuda'
,p_region_template_options=>'a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El dise\00F1ador de p\00E1ginas proporciona varias opciones para la creaci\00F3n de nuevos componentes de p\00E1gina.'),
unistr('Para crear regiones, elementos y botones, puede arrastrar y soltar componentes en el separador Dise\00F1o en el panel central o utilizar los men\00FAs contextuales en el separador Presentaci\00F3n del panel izquierdo.'),
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1104687824864514420.4001)
,p_plug_name=>unistr('Creaci\00F3n de Regiones, Elementos y Botones con Arrastrar y Soltar')
,p_parent_plug_id=>wwv_flow_api.id(1477171307612322861.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Para arrastrar y soltar nuevos componentes:</p>',
'<ol>',
unistr('  <li>Seleccione el separador Dise\00F1o en el panel central.</li>'),
unistr('  <li>En la galer\00EDa de la parte inferior del panel, seleccione Regi\00F3n, Elemento o Bot\00F3n.</li>'),
unistr('  <li>Haga clic y mantenga pulsado el mouse sobre el componente que desea crear y arr\00E1strelo al separador Dise\00F1o.</li>'),
unistr('  <li>Mueva el componente a la ubicaci\00F3n deseada dentro de la p\00E1gina y suelte el mouse.</li>'),
'  <li>Introduzca los detalles correspondientes en el editor de propiedades.</li>',
unistr('  <li>Haga clic en <strong>Guardar</strong> o <strong>Guardar y Ejecutar P\00E1gina</strong>.</li>'),
'</ol>      ',
unistr('<p><em>Nota: Los componentes solo se pueden soltar en las zonas de colocaci\00F3n adecuadas, que se muestran en amarillo, seg\00FAn determina el tipo de componente.'),
unistr('  Despu\00E9s de pasar el mouse sobre una zona de colocaci\00F3n existente, la visualizaci\00F3n en amarillo cambia para mostrar un cuadro negro en la zona de colocaci\00F3n relevante.<br/>'),
unistr('  Si desea colocar el nuevo componente junto a un componente existente, arrastre el nuevo componente a la derecha y col\00F3quelo al mismo nivel que el componente existente y espere un momento hasta que se muestre la nueva zona de colocaci\00F3n.</em></p>'),
unistr('<p>El separador Dise\00F1o tambi\00E9n incluye men\00FAs contextuales. Si selecciona y hace clic con el bot\00F3n derecho en un componente, puede suprimirlo, moverlo o copiarlo en otras regiones o nuevas regiones de la p\00E1gina.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-page-designer.html#GUID-EFBD65EB-58A1-423F-A575-9738E242E6C0">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1104687995506514421.4001)
,p_plug_name=>unistr('Creaci\00F3n de Bifurcaciones, C\00E1lculos y Procesos de Representaci\00F3n Previa')
,p_parent_plug_id=>wwv_flow_api.id(1477171307612322861.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para crear bifurcaciones, c\00E1lculos y procesos que se ejecuten antes de representar la p\00E1gina:</p>'),
'<ol>',
unistr('  <li>Seleccione el separador Representaci\00F3n en el panel izquierdo.</li>'),
unistr('  <li>Ampl\00EDe el nodo <strong>Representaci\00F3n previa</strong> en la parte superior del \00E1rbol Representaci\00F3n.</li>'),
unistr('  <li>Haga clic con el bot\00F3n derecho en Antes de Cabecera, Despu\00E9s de Cabecera, Antes de Regiones para mostrar el men\00FA contextual para ese punto de procesamiento.</li>'),
unistr('  <li>Seleccione <strong>Crear Bifurcaci\00F3n</strong>, <strong>Crear C\00E1lculo</strong> o <strong>Crear Proceso</strong>.</li>'),
'  <li>Introduzca los detalles correspondientes en el editor de propiedades.</li>',
unistr('  <li>Haga clic en <strong>Guardar</strong> o <strong>Guardar y Ejecutar P\00E1gina</strong>.</li>'),
'</ol>',
unistr('<p><em>Nota: Si ha cambiado la visualizaci\00F3n por defecto para agrupar componentes por tipo de componente, debe navegar al separador Procesamiento para mantener los componentes de representaci\00F3n previa.</em></p>'),
unistr('<p>Tambi\00E9n puede utilizar los men\00FAs contextuales para duplicar, suprimir y copiar un componente en otras p\00E1ginas.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1104688010835514422.4001)
,p_plug_name=>unistr('Creaci\00F3n de Bifurcaciones, Validaciones, C\00E1lculos y Procesos de Ejecuci\00F3n de P\00E1gina')
,p_parent_plug_id=>wwv_flow_api.id(1477171307612322861.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para crear bifurcaciones, validaciones, c\00E1lculos y procesos que se ejecuten al ejecutar la p\00E1gina:</p>'),
'<ol>',
'  <li>Seleccione el separador Procesamiento en el panel izquierdo.</li>',
unistr('  <li>Navegue a Despu\00E9s de Ejecuci\00F3n, Validando, Procesamiento o Despu\00E9s de Procesamiento seg\00FAn corresponda en el \00E1rbol de procesamiento.</li>'),
unistr('  <li>Haga clic con el bot\00F3n derecho en el identificador o en un componente existente para mostrar el men\00FA contextual para ese punto de procesamiento.</li>'),
unistr('  <li>Seleccione <strong>Crear Bifurcaci\00F3n</strong>, <strong>Crear Validaci\00F3n</strong>, <strong>Crear C\00E1lculo</strong> o <strong>Crear Proceso</strong>.</li>'),
'  <li>Introduzca los detalles correspondientes en el editor de propiedades.</li>',
unistr('  <li>Haga clic en <strong>Guardar</strong> o <strong>Guardar y Ejecutar P\00E1gina</strong>.</li>'),
'</ol>',
unistr('<p>Tambi\00E9n puede utilizar los men\00FAs contextuales para duplicar, suprimir y copiar un componente en otras p\00E1ginas.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1104689404381514436.4001)
,p_plug_name=>unistr('Creaci\00F3n de Regiones, Elementos y Botones mediante Men\00FAs Contextuales')
,p_parent_plug_id=>wwv_flow_api.id(1477171307612322861.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para crear nuevos componentes en el separador Presentaci\00F3n:</p>'),
'<ol>',
unistr('  <li>Seleccione el separador Presentaci\00F3n en el panel izquierdo.</li>'),
unistr('  <li>Navegue a la regi\00F3n, el elemento o el bot\00F3n de regi\00F3n adecuado.</li>'),
unistr('  <li>Haga clic con el bot\00F3n derecho en el identificador o en un componente existente para mostrar el men\00FA contextual para ese tipo de componente.</li>'),
unistr('  <li>Seleccione <strong>Crear Regi\00F3n</strong>, <strong>Crear Subregi\00F3n</strong>, <strong>Crear Elemento de P\00E1gina</strong> o <strong>Crear Bot\00F3n</strong>.</li>'),
'  <li>Introduzca los detalles correspondientes en el editor de propiedades.</li>',
unistr('  <li>Haga clic en <strong>Guardar</strong> o en <strong>Guardar y Ejecutar P\00E1gina</strong>.</li>'),
'</ol>',
unistr('<p>Tambi\00E9n puede utilizar los men\00FAs contextuales en el separador Presentaci\00F3n para duplicar, suprimir y copiar un componente en otras p\00E1ginas.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1474233168701765823.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1474233099802765822.4001)
,p_button_name=>'close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1474233250895765824.4001)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1474233168701765823.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1474233385337765825.4001)
,p_event_id=>wwv_flow_api.id(1474233250895765824.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00098
begin
wwv_flow_api.create_page(
 p_id=>98.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212737511585785636.4001)
,p_plug_name=>'Falta la plantilla necesaria'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('La aplicaci\00F3n no dispone de la plantilla de informe "Lista de medios" necesaria para la p\00E1gina maestro/detalle en paralelo. Refresque el tema universal a la \00FAltima versi\00F3n para agregar dicha plantilla.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_media_list_exists boolean := false;',
'begin',
'    for l_media_list in (',
'        select r.id',
'        from wwv_flow_row_templates r, wwv_flow_themes t, wwv_flow_user_interfaces ui',
'        where r.theme_id = t.theme_id',
'        and r.flow_id = t.flow_id',
'        and r.security_group_id = t.security_group_id',
'        and t.theme_id = ui.theme_id',
'        and t.flow_id = ui.flow_id',
'        and t.security_group_id = ui.security_group_id',
'        and r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'        and r.flow_id = :FB_FLOW_ID',
'        and t.theme_internal_name = ''UNIVERSAL_THEME''',
'        and r.internal_name = ''MEDIA_LIST'' )',
'    loop',
'        l_media_list_exists := true;',
'    end loop;',
'    ',
'    if :P259_IS_UT_BASED = ''Y'' and not l_media_list_exists then',
'        return true;',
'    end if;',
'    return false;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(645493924075825804.4001)
,p_plug_name=>'Crear Maestro/Detalle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_media_list_exists boolean := false;',
'begin',
'    for l_media_list in (',
'        select r.id',
'        from wwv_flow_row_templates r, wwv_flow_themes t, wwv_flow_user_interfaces ui',
'        where r.theme_id = t.theme_id',
'        and r.flow_id = t.flow_id',
'        and r.security_group_id = t.security_group_id',
'        and t.theme_id = ui.theme_id',
'        and t.flow_id = ui.flow_id',
'        and t.security_group_id = ui.security_group_id',
'        and r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'        and r.flow_id = :FB_FLOW_ID',
'        and t.theme_internal_name = ''UNIVERSAL_THEME''',
'        and r.internal_name = ''MEDIA_LIST'' )',
'    loop',
'        l_media_list_exists := true;',
'    end loop;',
'    ',
'    if :P259_IS_UT_BASED = ''Y'' and l_media_list_exists then',
'        return true;',
'    end if;',
'    return false;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(815472491381979280.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(42519297248600803.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_media_list_exists boolean := false;',
'begin',
'    for l_media_list in (',
'        select r.id',
'        from wwv_flow_row_templates r, wwv_flow_themes t, wwv_flow_user_interfaces ui',
'        where r.theme_id = t.theme_id',
'        and r.flow_id = t.flow_id',
'        and r.security_group_id = t.security_group_id',
'        and t.theme_id = ui.theme_id',
'        and t.flow_id = ui.flow_id',
'        and t.security_group_id = ui.security_group_id',
'        and r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'        and r.flow_id = :FB_FLOW_ID',
'        and t.theme_internal_name = ''UNIVERSAL_THEME''',
'        and r.internal_name = ''MEDIA_LIST'' )',
'    loop',
'        l_media_list_exists := true;',
'    end loop;',
'    ',
'    if :P259_IS_UT_BASED = ''Y'' and l_media_list_exists then',
'        return true;',
'    end if;',
'    return false;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(847662786636270381.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1121401663577472647.4001)
,p_plug_name=>'Compatibilidad de Temas'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Maestro-detalle en paralelo requiere una aplicaci\00F3n basada en el tema universal. '),
unistr('Oracle recomienda actualizar al tema universal. Para obtener m\00E1s informaci\00F3n, consulte la <a rel="noreferrer" href="https://apex.oracle.com/ut" target="_blank">aplicaci\00F3n del tema universal (Universal Theme)</a>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_IS_UT_BASED'
,p_plug_display_when_cond2=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26453435431299493.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(847662786636270381.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26453877484299495.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(847662786636270381.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_media_list_exists boolean := false;',
'begin',
'    for l_media_list in (',
'        select r.id',
'        from wwv_flow_row_templates r, wwv_flow_themes t, wwv_flow_user_interfaces ui',
'        where r.theme_id = t.theme_id',
'        and r.flow_id = t.flow_id',
'        and r.security_group_id = t.security_group_id',
'        and t.theme_id = ui.theme_id',
'        and t.flow_id = ui.flow_id',
'        and t.security_group_id = ui.security_group_id',
'        and r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'        and r.flow_id = :FB_FLOW_ID',
'        and t.theme_internal_name = ''UNIVERSAL_THEME''',
'        and r.internal_name = ''MEDIA_LIST'' )',
'    loop',
'        l_media_list_exists := true;',
'    end loop;',
'    ',
'    if :P259_IS_UT_BASED = ''Y'' and l_media_list_exists then',
'        return true;',
'    end if;',
'    return false;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26454206545299496.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(847662786636270381.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(26463832077299522.4001)
,p_branch_name=>'Go To Navigation/Tab'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(26453877484299495.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(26463420666299522.4001)
,p_branch_action=>'f?p=&APP_ID.:98:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P98_BREADCRUMB_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15806470604054542.4001)
,p_name=>'P98_MD_BC_NAME'
,p_item_sequence=>161
,p_item_plug_id=>wwv_flow_api.id(645493924075825804.4001)
,p_prompt=>unistr('Nombre de entrada de p\00E1gina Maestro/Detalle')
,p_source=>'P98_MD_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de ruta de navegaci\00F3n para la p\00E1gina maestra/de detalle.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26446147979299476.4001)
,p_name=>'P98_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(645493924075825804.4001)
,p_prompt=>unistr('N\00FAmero de p\00E1gina inicial')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado. El asistente crear\00E1 varias p\00E1ginas que empezar\00E1n por el n\00FAmero especificado.</p>'),
unistr('<p>El n\00FAmero por defecto es el primer n\00FAmero de p\00E1gina disponible en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26447063301299478.4001)
,p_name=>'P98_MD_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>91
,p_item_plug_id=>wwv_flow_api.id(645493924075825804.4001)
,p_prompt=>unistr('Nombre de p\00E1gina Maestro/Detalle')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la p\00E1gina Maestro/Detalle que contenga regiones Maestro/Detalle en paralelo. En el lado izquierdo, encontrar\00E1 la lista maestra para navegar a un registro maestro diferente. En el lado derecho, se encuentra el registro maestro ')
||'seleccionado y el informe de detalles asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26449764216299479.4001)
,p_name=>'P98_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>141
,p_item_plug_id=>wwv_flow_api.id(645493924075825804.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26450693300299482.4001)
,p_name=>'P98_BREADCRUMB_PARENT_ID'
,p_item_sequence=>151
,p_item_plug_id=>wwv_flow_api.id(645493924075825804.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P98_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P98_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P98_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(26455111268299503.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P98_MD_PAGE_NAME'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(26457173110299506.4001)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>55
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plugs',
'where flow_id = :fb_flow_id',
'and   page_id = :P98_MD_PAGE_ID',
'and   menu_id is not null',
'and   :P98_BREADCRUMB_ID is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina especificada ya tiene una regi\00F3n de ruta de navegaci\00F3n.')
,p_validation_condition=>'wwv_flow_utilities.is_numeric( p_str => :P98_MASTER_PAGE_ID) and wwv_flow_utilities.is_numeric( p_str => :P98_DETAIL_PAGE_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(26453877484299495.4001)
,p_associated_item=>wwv_flow_api.id(26449764216299479.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33865564174899631.4001)
,p_validation_name=>'breadcrumb name not null'
,p_validation_sequence=>65
,p_validation=>'P98_MD_BC_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P98_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(26453877484299495.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15807080994054548.4001)
,p_validation_name=>'P98_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>75
,p_validation=>'P98_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(26453877484299495.4001)
,p_associated_item=>wwv_flow_api.id(26446147979299476.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15807105046054549.4001)
,p_validation_name=>'P98_STARTING_PAGE_ID reserved'
,p_validation_sequence=>85
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P98_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P98_STARTING_PAGE_ID is not null and',
'wwv_flow_utilities.is_numeric(:P98_STARTING_PAGE_ID)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(26453877484299495.4001)
,p_associated_item=>wwv_flow_api.id(26446147979299476.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(26457420461299508.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P98_BREADCRUMB_ID'
,p_condition_element=>'P98_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(26457991066299510.4001)
,p_event_id=>wwv_flow_api.id(26457420461299508.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P98_BREADCRUMB_PARENT_ID,P98_MD_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(26458472270299511.4001)
,p_event_id=>wwv_flow_api.id(26457420461299508.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P98_BREADCRUMB_PARENT_ID,P98_MD_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(26458818772299511.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(26453435431299493.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(26459362441299516.4001)
,p_event_id=>wwv_flow_api.id(26458818772299511.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(26461574235299518.4001)
,p_name=>'set master-detail bc name'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P98_MD_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(26462066967299519.4001)
,p_event_id=>wwv_flow_api.id(26461574235299518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P98_MD_BC_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P98_MD_PAGE_NAME'
,p_attribute_07=>'P98_MD_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_api.create_page(
 p_id=>99.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(556104629458697813.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(556106780709697837.4001)
,p_plug_name=>unistr('Regi\00F3n Maestra')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(556118298705697862.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(42519297248600803.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26532645063634598.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(556104629458697813.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4389356717035632942.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(556104629458697813.4001)
,p_button_name=>'ADVANCED'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Avanzado'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:239:&SESSION.::&DEBUG.:RP,239,257:P29_MD_TYPE:MD_EMAIL_STYLE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26533034067634598.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(556104629458697813.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26533461379634599.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(556104629458697813.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15806686358054544.4001)
,p_name=>'P99_PRIMARY_LABEL'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n primaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P99_TABLE_OWNER',
'   and table_name = :P99_MASTER_TABLE',
'   and :P99_MASTER_TABLE is not null',
'   and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar columna de etiqueta -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna primaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15806711994054545.4001)
,p_name=>'P99_SECONDARY_LABEL'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n secundaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P99_TABLE_OWNER',
'   and table_name = :P99_MASTER_TABLE',
'   and :P99_MASTER_TABLE is not null',
'   and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar columna de etiqueta -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna secundaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26535043361634600.4001)
,p_name=>'P99_TABLE_OWNER'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Esquema -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que va a crear la p\00E1gina Maestro/Detalle.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26535936202634600.4001)
,p_name=>'P99_MASTER_TABLE'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>'Tabla Maestra'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P99_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P99_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o la vista maestra. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26550206379666012.4001)
,p_name=>'P99_DETAIL_TABLE1'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>'Tabla de Detalles'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P99_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P99_MASTER_TABLE',
'and c.parent_owner = :P99_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la tabla o vista de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(275643055625510008.4001)
,p_name=>'P99_DETAIL_TABLE2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>'Tabla de Detalles 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P99_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P99_MASTER_TABLE',
'and c.parent_owner = :P99_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la tabla o vista de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(275643605590510014.4001)
,p_name=>'P99_DETAIL_TABLE3'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>'Tabla de Detalles 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P99_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P99_MASTER_TABLE',
'and c.parent_owner = :P99_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la tabla o vista de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(275644079198510018.4001)
,p_name=>'P99_DETAIL_TABLE4'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(556106780709697837.4001)
,p_prompt=>'Tabla de Detalles 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P99_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'from wwv_dictionary_cache_fkcon c',
'where c.parent_table = :P99_MASTER_TABLE',
'and c.parent_owner = :P99_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la tabla o vista de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(26542591724634604.4001)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P99_TABLE_OWNER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(610851491757282105.4001)
,p_validation_name=>'Chosen Table exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P99_TABLE_OWNER',
'   and object_name = :P99_MASTER_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P99_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_when_button_pressed=>wwv_flow_api.id(26533034067634598.4001)
,p_associated_item=>wwv_flow_api.id(26535936202634600.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(26543646539634605.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(26532645063634598.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(26544139828634605.4001)
,p_event_id=>wwv_flow_api.id(26543646539634605.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(275643325763510011.4001)
,p_name=>'Toggle Detail 2'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DETAIL_TABLE1'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P99_DETAIL_TABLE1'') !== '''''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275643483591510012.4001)
,p_event_id=>wwv_flow_api.id(275643325763510011.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275643503563510013.4001)
,p_event_id=>wwv_flow_api.id(275643325763510011.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(275643781755510015.4001)
,p_name=>'Toggle Detail 3'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DETAIL_TABLE2'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P99_DETAIL_TABLE2'') !== '''''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275643897689510016.4001)
,p_event_id=>wwv_flow_api.id(275643781755510015.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275643921160510017.4001)
,p_event_id=>wwv_flow_api.id(275643781755510015.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(275644132652510019.4001)
,p_name=>'Toggle Detail 4'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_DETAIL_TABLE3'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P99_DETAIL_TABLE3'') !== '''''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275644229552510020.4001)
,p_event_id=>wwv_flow_api.id(275644132652510019.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275644370908510021.4001)
,p_event_id=>wwv_flow_api.id(275644132652510019.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE4'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(193530166607845805.4001)
,p_name=>'set data dictionary cache'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P99_MASTER_TABLE'
,p_condition_element=>'P99_MASTER_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(193530283194845806.4001)
,p_event_id=>wwv_flow_api.id(193530166607845805.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'         p_workspace_name          => l_workspace_name,',
'         p_schema                  => :P99_TABLE_OWNER,',
'         p_table_name              => :P99_MASTER_TABLE,',
'         p_flow_id                 => :FB_FLOW_ID,',
'         p_cache_fk_references     => true,',
'         p_cache_child_tables      => true );',
'end;'))
,p_attribute_02=>'P99_TABLE_OWNER,P99_MASTER_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632193794017032128.4001)
,p_event_id=>wwv_flow_api.id(193530166607845805.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P99_DETAIL_TABLE1,P99_DETAIL_TABLE2,P99_DETAIL_TABLE3,P99_DETAIL_TABLE4'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33865097953899626.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Side by Side MD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_md_side_by_side(',
'    p_app_id                    => :FB_FLOW_ID,',
'    p_user_interface_id         => :P259_USER_INTERFACE_ID,',
'    p_starting_page_id          => :P98_STARTING_PAGE_ID,',
'    p_md_page_name              => :P98_MD_PAGE_NAME,',
'    --',
'    p_table_owner               => :P99_TABLE_OWNER,',
'    p_master_table              => :P99_MASTER_TABLE,',
'    p_primary_label_col         => :P99_PRIMARY_LABEL,',
'    p_secondary_label_col       => :P99_SECONDARY_LABEL,',
'    p_detail_table_1            => :P99_DETAIL_TABLE1,',
'    p_detail_table_2            => :P99_DETAIL_TABLE2,',
'    p_detail_table_3            => :P99_DETAIL_TABLE3,',
'    p_detail_table_4            => :P99_DETAIL_TABLE4,',
'    --',
'    p_tab_set                   => :P4716_TAB_SET,',
'    p_tab_name                  => :P4716_TAB_NAME,',
'    p_tab_text                  => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id               => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id   => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name  => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_breadcrumb_id             => :P98_BREADCRUMB_ID,',
'    p_breadcrumb_name           => :P98_MD_BC_NAME,',
'    p_parent_bc_id              => :P98_BREADCRUMB_PARENT_ID );',
'',
':FB_FLOW_PAGE_ID       := :P98_STARTING_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P98_STARTING_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33864215140899618.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(26533034067634598.4001)
,p_process_success_message=>unistr('P\00E1gina Maestro/Detalle creada.')
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_api.create_page(
 p_id=>100.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Anulaci\00F3n de Suscripci\00F3n a Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Confirmar Anulaci\00F3n de Suscripci\00F3n a Tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_height=>'400'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932805961191193703.4001)
,p_plug_name=>'Dialog Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932806341172193707.4001)
,p_plug_name=>unistr('Confirmar Anulaci\00F3n de Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Confirme que desea anular la suscripci\00F3n al tema actual desde su tema maestro. La anulaci\00F3n de la suscripci\00F3n a un tema impedir\00E1 que se apliquen futuras actualizaciones al tema. No es una operaci\00F3n trivial volver a suscribirse a un tema una vez an')
||unistr('ulada su suscripci\00F3n, ya que implica copiar y cambiar temas.</p>'),
unistr('<p>Tenga en cuenta que los temas suscritos se pueden ampliar mediante la adici\00F3n de plantillas, estilos y archivos que sean locales para el tema, por ejemplo, con la creaci\00F3n de una nueva plantilla o la copia de una plantilla suscrita. Las plantillas')
||unistr(', los estilos y los archivos agregados a un tema suscrito se podr\00E1n editar; sin embargo, los componentes suscritos ser\00E1n de solo lectura.</p>'),
unistr('<p>Al anular la suscripci\00F3n a un tema, se anula tambi\00E9n la suscripci\00F3n a todas las plantillas, Javascript y CSS, opciones, iconos y estilos de plantilla global, lo que permitir\00E1 personalizar cualquiera de los componentes suscritos actualmente.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932806140294193705.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(932805961191193703.4001)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932806038468193704.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(932805961191193703.4001)
,p_button_name=>'Unsubscribe'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Anular Suscripci\00F3n a Tema')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(932806537367193709.4001)
,p_branch_name=>'back to theme edit page'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932806265733193706.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'New'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(932806140294193705.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932806431931193708.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_theme(:P267_ID);',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al anular la suscripci\00F3n al tema.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(932806038468193704.4001)
,p_process_success_message=>unistr('Se ha anulado la suscripci\00F3n al tema y a la plantilla.')
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('C\00F3digo embebido')
,p_alias=>'EMBEDDED-CODE'
,p_step_title=>unistr('C\00F3digo embebido')
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_searchResults#MIN#.js'
,p_step_template=>wwv_flow_api.id(438185046231548086.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2600902150396862.4001)
,p_name=>unistr('Resultados de la B\00FAsqueda')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_EMBEDDED_CODE'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1310649889953751.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2604058026396983.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2604463528396984.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Identificador de P\00E1gina')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2604837636396985.4001)
,p_query_column_id=>3
,p_column_alias=>'PROPERTY_ID'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2605211195396985.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_ID'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2605662403396985.4001)
,p_query_column_id=>5
,p_column_alias=>'COMPONENT_TYPE_ID'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2606021809396985.4001)
,p_query_column_id=>6
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2606447986396986.4001)
,p_query_column_id=>7
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Nombre del Componente'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2606815919396986.4001)
,p_query_column_id=>8
,p_column_alias=>'COMPONENT_TYPE_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2607220772396986.4001)
,p_query_column_id=>9
,p_column_alias=>'PROPERTY_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Nombre de la propiedad'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2607686629396987.4001)
,p_query_column_id=>10
,p_column_alias=>'PROPERTY_TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2503656722458636.4001)
,p_query_column_id=>11
,p_column_alias=>'CODE_TYPE'
,p_column_display_sequence=>22
,p_column_heading=>unistr('Tipo de C\00F3digo')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2503772851458637.4001)
,p_query_column_id=>12
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>32
,p_column_heading=>'Nombre de Grupo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2503898987458638.4001)
,p_query_column_id=>13
,p_column_alias=>'SCOPE_NAME'
,p_column_display_sequence=>42
,p_column_heading=>unistr('Nombre de \00C1mbito')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2608445018396987.4001)
,p_query_column_id=>14
,p_column_alias=>'PROPERTY_SOURCE'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2601090955396862.4001)
,p_plug_name=>'Buscar'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(2600902150396862.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<div id="active_facets"></div>'
,p_attribute_01=>'N'
,p_attribute_06=>'E'
,p_attribute_08=>'#active_facets'
,p_attribute_09=>'Y'
,p_attribute_12=>'10000'
,p_attribute_13=>'Y'
,p_attribute_15=>'10'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2603070942396873.4001)
,p_plug_name=>unistr('C\00F3digo embebido')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_source=>'<!-- div id="active_facets"></div -->'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1602020543325526.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2600902150396862.4001)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Descargar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2603557068396875.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2603070942396873.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RR,101::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2504142698458641.4001)
,p_name=>'P101_CODE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2601090955396862.4001)
,p_prompt=>'Idioma'
,p_source=>'CODE_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2504244793458642.4001)
,p_name=>'P101_SCOPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2601090955396862.4001)
,p_prompt=>unistr('\00C1mbito')
,p_source=>'SCOPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dv, rv ',
'from (',
'    select distinct scope_name as dv, scope_name as rv, -1 as page_id',
'    from wwv_flow_embedded_code ',
'    where page_id is null ',
'    union all ',
'    select distinct scope_name as dv, scope_name as rv, page_id',
'    from wwv_flow_embedded_code',
'    where page_id is not null',
'    order by page_id',
');'))
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>true
,p_fc_sort_by_top_counts=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2601570002396870.4001)
,p_name=>'P101_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2601090955396862.4001)
,p_prompt=>'Buscar'
,p_source=>'PAGE_NAME,COMPONENT_NAME,COMPONENT_TYPE_NAME,PROPERTY_NAME,PROPERTY_TYPE,HCLASS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2602331284396873.4001)
,p_name=>'P101_COMPONENT_TYPE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2601090955396862.4001)
,p_prompt=>'Tipo de Componente'
,p_source=>'COMPONENT_TYPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1602266964332619.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID or :FB_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :FB_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1602580579335924.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Source Zip'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_embedded_code (',
'    p_application_id => :FB_FLOW_ID);',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al exportar el flujo &FB_FLOW_ID.. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(1602020543325526.4001)
,p_process_success_message=>unistr('Se ha exportado la aplicaci\00F3n &FB_FLOW_ID.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1601659872321907.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cache Embedded Code'
,p_process_sql_clob=>'wwv_flow_property_dev.cache_embedded_code(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00103
begin
wwv_flow_api.create_page(
 p_id=>103.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Estado de Creaci\00F3n')
,p_step_title=>unistr('Estado de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47672626351203105.4001)
,p_plug_name=>unistr('Informe de Estado de Creaci\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P103a */',
'ID,',
'OWNER,',
'NAME,',
'BUILD_STATUS,',
'flow_status,',
'id application',
'from WWV_FLOWS f',
'where ',
'f.security_group_id = :flow_security_group_id',
'and f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47672728272203105.4001)
,p_name=>'Application Build Status Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47673429078203114.4001)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'F'
,p_column_label=>'APPLICATION'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47672909730203110.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:467:&SESSION.::&DEBUG.:NONE,467:P467_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47673024002203111.4001)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>unistr('Esquema de An\00E1lisis')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47673121532203112.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47673206390203112.4001)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Estado de Creaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84305510710571518)
,p_rpt_show_filter_lov=>'1'
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47673319976203113.4001)
,p_db_column_name=>'FLOW_STATUS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>unistr('Estado de Aplicaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(634347472712995)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702930752262201276.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(755297901357836845.4001)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(47672626351203105.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(755298036596836846.4001)
,p_event_id=>wwv_flow_api.id(755297901357836845.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(47672626351203105.4001)
);
end;
/
prompt --application/pages/page_00104
begin
wwv_flow_api.create_page(
 p_id=>104.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Ruta de Navegaci\00F3n')
,p_alias=>'EDIT-BREADCRUMB'
,p_step_title=>unistr('Editar Ruta de Navegaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'// below legacy code is not moved to builder.js file',
'// this plugin "Internal Page Popup LOV" must be replaced with new one anyway',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp(url);',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div.searchBar {display: flex;}',
'',
'div#P104_SEARCH_CONTAINER {position: relative;}',
'',
'div#P104_SEARCH_CONTAINER div.a-Form-inputContainer {padding-right:0;}',
'',
'input#P104_SEARCH {',
'    padding-left: 32px;',
'    height: 32px;',
'    line-height: 24px;',
'    border-top-right-radius: 0;',
'    border-bottom-right-radius: 0;',
'    -webkit-box-sizing: border-box;',
'    box-sizing: border-box;',
'}    ',
'',
'div#P104_SEARCH_CONTAINER .apex-item-icon {',
'    position: absolute;',
'    top: 0;',
'    left: 0;',
'    padding: 0;',
'    margin: 16px;',
'}',
'',
'button#clear {',
'    height: 32px;',
'    margin: 8px 8px 0 0;    ',
'}',
'',
'div#bcEntries {',
'    height: calc(90vh - 100px);',
'    overflow-y: auto;',
'}',
''))
,p_step_template=>wwv_flow_api.id(4868606398075172.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2300916966269809.4001)
,p_plug_name=>unistr('Detalles de entrada de ruta de navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MENU_OPTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'menu_id = :P104_MENU_ID',
'and flow_id = :FB_FLOW_ID  ',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P104_MENU_ID IS NOT NULL AND (:P104_ID IS NOT NULL or :REQUEST = ''NEW_ENTRY'')'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2303586761269835.4001)
,p_plug_name=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2303863961269838.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2303931297269839.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2428884315300722.4001)
,p_plug_name=>'Comentarios'
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13853237952413056.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'COND'
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31178079384755103.4001)
,p_plug_name=>'Destino'
,p_region_name=>'TAR'
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617637922231599942.4001)
,p_plug_name=>'Historial de entradas'
,p_parent_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_MENU_OPTIONS',
'where id = :P104_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P104_ID,',
'      p_component_type => ''Breadcrumb'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P104_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3701695051555005.4001)
,p_plug_name=>'Buscar'
,p_region_css_classes=>'searchBar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20904792963355447.4001)
,p_plug_name=>unistr('Entradas de Ruta de Navegaci\00F3n')
,p_region_name=>'bcEntries'
,p_region_css_classes=>'a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with bc_data as',
'(',
'    select name short_name,',
'           ''icon-sc-tree'' icon,',
'           ''bc''||menus.id id,',
'           null as parent_id,',
'           null as option_sequence,',
'           null as page_id,',
'           null as menu_option_id,',
'           menus.id as menu_id',
'      from wwv_flow_menus menus',
'     where menus.id                = :P104_MENU_ID',
'       and menus.flow_id           = :FB_FLOW_ID',
'       and menus.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    union all',
'    select options.short_name,',
'           null as icon,',
'           to_char(options.id) id,',
'           case',
'               when options.parent_id is null or options.parent_id = 0 then ''bc''||options.menu_id',
'               else to_char(options.parent_id)',
'           end parent_id,',
'           option_sequence,',
'           options.page_id,',
'           options.id menu_option_id,',
'           options.menu_id',
'      from wwv_flow_menu_options options',
'     where options.menu_id           = :P104_MENU_ID',
'       and options.flow_id           = :FB_FLOW_ID',
'       and options.security_group_id = :FLOW_SECURITY_GROUP_ID',
'), bc_tree as',
'(',
'    select short_name,',
'           icon,',
'           id,',
'           parent_id,',
'           option_sequence,',
'           page_id,',
'           menu_option_id,',
'           menu_id,',
'           sys_connect_by_path(id, '':'')||'':'' as bc_entry_path',
'      from bc_data',
'     start with parent_id is null or parent_id = ''0''',
'   connect by prior id = parent_id',
'     order siblings by option_sequence',
'), bc_filtered_data as',
'(',
'    select short_name,',
'           icon,',
'           id,',
'           parent_id,',
'           option_sequence,',
'           page_id,',
'           menu_option_id,',
'           menu_id',
'      from bc_data bcd',
'     where :P104_SEARCH is null',
'        OR exists (select *',
'                     from (',
'                         select inn.bc_entry_path',
'                           from bc_tree inn',
'                          where upper(inn.short_name) like ''%''||upper(:P104_SEARCH)||''%'') bep',
'                    where bep.bc_entry_path like ''%:''||bcd.id||'':%'')',
')',
'-- ideally bc_filtered_data can be used as final output, but we can''t do that',
'-- because filering sometimes changes the order of rows, however tree rendering has strict dependency on the order',
'-- so we must again use start with and connect by to make hierarchical query',
'-- otherwise we will get apex_error_code: JSON.WRITER.CLOSE_ARRAY error, sometimes.',
' select case',
'            when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else -1',
'        end as status,',
'        level lvl,',
'        short_name,',
'        icon,',
'        id,',
'        parent_id,',
'        case',
'            when page_id is not null then wwv_flow_lang.system_message( ''PAGE'' )||'' ''||page_id',
'            else null',
'        end tooltip,',
'        wwv_flow_page_api.get_url(',
'            p_page        => :APP_PAGE_ID,',
'            p_clear_cache => :APP_PAGE_ID,',
'            p_items       => ''P104_ID,P104_MENU_ID,P104_SEARCH'',',
'            p_values      => menu_option_id||'',''||menu_id||'',''||:P104_SEARCH) link',
'   from bc_filtered_data',
'  start with parent_id is null or parent_id = ''0''',
'connect by prior id = parent_id',
'  order siblings by option_sequence, short_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_ajax_items_to_submit=>'P104_SEARCH'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P104_MENU_ID'
,p_attribute_02=>'S'
,p_attribute_03=>'P104_SELECTED_NODE'
,p_attribute_04=>'DB'
,p_attribute_08=>'a-Icon'
,p_attribute_09=>'icon-sc-breadcrumb'
,p_attribute_10=>'SHORT_NAME'
,p_attribute_11=>'LVL'
,p_attribute_12=>'ICON'
,p_attribute_15=>'STATUS'
,p_attribute_20=>'ID'
,p_attribute_22=>'TOOLTIP'
,p_attribute_23=>'LEVEL'
,p_attribute_24=>'LINK'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20904804175355448.4001)
,p_plug_name=>unistr('Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MENUS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P104_MENU_ID IS NOT NULL AND :P104_ID IS NULL AND :REQUEST IS NULL'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8469795847051403.4001)
,p_plug_name=>unistr('Historial de Rutas de Navegaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_MENUS',
'where id = :P104_MENU_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P104_MENU_ID,',
'      p_component_type => ''Breadcrumb'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(170645131771366897.4001)
,p_name=>unistr('Uso de Ruta de Navegaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  p.page_id, ',
'     s.name, p.plug_name, m.SHORT_NAME',
'from wwv_flow_menu_options m, ',
'    wwv_flow_page_plugs p,',
'    wwv_flow_steps s',
'where p.menu_id           = m.menu_id',
'  and p.page_id           = m.page_id',
'  and p.flow_id           = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id',
'  and m.menu_id           = :P104_MENU_ID',
'  and s.id                = p.page_id',
'  and s.flow_id           = :fb_flow_id',
'order by p.page_id'))
,p_display_when_condition=>':P104_MENU_ID IS NOT NULL AND :P104_ID IS NULL AND :REQUEST IS NULL'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_header=>unistr('<p>Al suprimir una ruta de navegaci\00F3n se producir\00E1 una supresi\00F3n en cascada de todas las regiones que hagan referencia a dicha ruta de navegaci\00F3n.</p>')
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2700533532194196.4001)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2700840963194198.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2701275852194199.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2701624960194199.4001)
,p_query_column_id=>4
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3100954151676304.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3701695051555005.4001)
,p_button_name=>'CLEAR'
,p_button_static_id=>'clear'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Borrar'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-remove'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2311925385292714.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2428782330300721.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_button_name=>'CANCEL_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2304445449269844.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_button_name=>'DELETE_ENTRY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Entrada'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2312385894292715.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P104_MENU_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2304515876269845.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_button_name=>'NEW_ENTRY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Nueva entrada'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:104:&SESSION.:NEW_ENTRY:&DEBUG.:104:P104_MENU_ID:&P104_MENU_ID.'
,p_button_condition=>':P104_ID IS NULL AND :REQUEST IS NULL'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8470736556051413.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_button_name=>'NEW_ENTRY_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Nueva entrada'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:104:&SESSION.:NEW_ENTRY:&DEBUG.:104:P104_MENU_ID,P104_PARENT_ID:&P104_MENU_ID.,&P104_ID.'
,p_button_condition=>':P104_ID IS NOT NULL'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2305002498269850.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_button_name=>'CREATE_ENTRY_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2304767400269847.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_button_name=>'CREATE_ENTRY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Entrada'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2312767914292715.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_MENU_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2304873252269848.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_button_name=>'SAVE_ENTRY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2304910483269849.4001)
,p_branch_name=>'Delete Breadcrumb'
,p_branch_action=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2312385894292715.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8469674742051402.4001)
,p_branch_name=>'Create and Create Another'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.:NEW_ENTRY:&DEBUG.::P104_ID,P104_PARENT_ID:,&P104_PARENT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2305002498269850.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8469917147051405.4001)
,p_branch_name=>'Delete Entry'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_MENU_ID:&P104_MENU_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2304445449269844.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1801318894462312.4001)
,p_name=>'P104_SYNC_PAGE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'&nbsp;'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P104_SYNC_PAGE_NAME'
,p_lov=>'.'||wwv_flow_api.id(123726144609302218.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sincronice el t\00EDtulo y nombre de p\00E1gina correspondientes con la abreviatura de la ruta de navegaci\00F3n.'),
'<br><br>',
unistr('Active la casilla de control del nombre y t\00EDtulo de la p\00E1gina de sincronizaci\00F3n y haga clic en <strong>Aplicar cambios</strong>')))
,p_attribute_01=>'1'
,p_item_comment=>'Label can''t be empty when help text exists, if we keep label empty, then help dialog is not being shown when we click the help icon. As a workaround, dummy label &nbsp; is added for this item.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2300175345269801.4001)
,p_name=>'P104_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_item_source_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2300209457269802.4001)
,p_name=>'P104_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_item_source_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2300345616269803.4001)
,p_name=>'P104_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_item_source_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2300872609269808.4001)
,p_name=>'P104_MENU_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_item_source_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_prompt=>' Comentarios'
,p_source=>'MENU_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301209129269812.4001)
,p_name=>'P104_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301332269269813.4001)
,p_name=>'P104_PARENT_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>'Entrada Principal'
,p_source=>'PARENT_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||p||'' ''||page_id||'')'' name, id',
'from wwv_flow_menu_options, (select wwv_flow_lang.system_message(''PAGE'') p from sys.dual) x',
'where menu_id = :P104_MENU_ID',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguna Entrada Principal -'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la entrada de ruta de navegaci\00F3n que es la principal de esta entrada. Cualquier ruta de navegaci\00F3n debe tener s\00F3lo un nodo ra\00EDz, identificado como elemento sin ning\00FAn identificador principal.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301499265269814.4001)
,p_name=>'P104_OPTION_MENU_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_source=>'MENU_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301699240269816.4001)
,p_name=>'P104_OPTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>'OPTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301717367269817.4001)
,p_name=>'P104_SHORT_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>'Abreviatura'
,p_source=>'SHORT_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Identifique la abreviatura de esta entrada de ruta de navegaci\00F3n. Desde la plantilla de ruta de navegaci\00F3n se puede hacer referencia tanto a la abreviatura como al nombre completo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301884739269818.4001)
,p_name=>'P104_LONG_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>'Nombre Completo'
,p_source=>'LONG_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Identifique el nombre completo de esta entrada de ruta de navegaci\00F3n. Desde la plantilla de ruta de navegaci\00F3n se puede hacer referencia tanto a la abreviatura como al nombre completo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2301901379269819.4001)
,p_name=>'P104_LINK'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_source=>'LINK'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2302032647269820.4001)
,p_name=>'P104_PAGE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2303586761269835.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_item_default=>'FB_FLOW_PAGE_ID'
,p_item_default_type=>'ITEM'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'PAGE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la p\00E1gina asociada a esta ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2302109751269821.4001)
,p_name=>'P104_ALSO_CURRENT_FOR_PAGES'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_source=>'ALSO_CURRENT_FOR_PAGES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2302586353269825.4001)
,p_name=>'P104_SECURITY_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2303863961269838.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Puede seleccionar un esquema de autorizaci\00F3n. Dicho esquema debe dar un resultado TRUE para que este componente se presente o se procese.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2302624969269826.4001)
,p_name=>'P104_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2303931297269839.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2303233667269832.4001)
,p_name=>'P104_MENU_OPTION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(2428884315300722.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>'Comentarios'
,p_source=>'MENU_OPTION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2427207209300706.4001)
,p_name=>'P104_SELECTED_NODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20904792963355447.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2427444541300708.4001)
,p_name=>'P104_PAGE_SUCCESS_MSG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20904792963355447.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3369056058172375.4001)
,p_name=>'P104_URL_OR_FLOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_item_default=>'FLOW'
,p_prompt=>'El destino es'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_api.id(84796030957080920.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Destino -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique si el destino es una p\00E1gina o una direcci\00F3n URL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3369910974172376.4001)
,p_name=>'P104_TARGET_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el n\00FAmero de p\00E1gina o el alias. Para restablecer la paginaci\00F3n de esa p\00E1gina, seleccione <span class="fielddatabold">restablecer paginaci\00F3n para esta p\00E1gina</span>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3370821776172378.4001)
,p_name=>'P104_CLEAR_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>'&nbsp;'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla de control para restablecer la paginaci\00F3n a la que est\00E1 enlazada.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3371798536172378.4001)
,p_name=>'P104_REQUEST'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca el texto para el que desea definir el elemento de aplicaci\00F3n incorporado denominado REQUEST. \00C9ste es tambi\00E9n el elemento definido con el nombre de un bot\00F3n en el que se ha hecho clic.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3372617253172378.4001)
,p_name=>'P104_CLEAR_CACHE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>unistr('Borrar Cach\00E9')
,p_post_element_text=>unistr('<span class="instructionText">(n\00FAmeros de p\00E1gina separados por comas)</span>')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca los n\00FAmeros de p\00E1gina, separados por comas, de las p\00E1ginas para las que desea que se limpie el estado de la sesi\00F3n del usuario. Otras entradas v\00E1lidas:</div>'),
'<ul class="noIndent">',
unistr('<li>APPLICATION: Restablece el estado de la sesi\00F3n del usuario para toda la aplicaci\00F3n'),
unistr('<li>SESSION: Restablece el estado de la sesi\00F3n del usuario completamente'),
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3373595794172379.4001)
,p_name=>'P104_ARG_NAMES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>'Defina estos elementos'
,p_post_element_text=>'<span class="instructionText">(lista de nombres separados por comas)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la lista de nombres de elementos de aplicaci\00F3n, separados por comas, para los que desea definir el estado de la sesi\00F3n (proporcionar un valor al elemento mostrado).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3374478931172379.4001)
,p_name=>'P104_ARG_VALUES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>'Con estos valores'
,p_post_element_text=>'<span class="instructionText">(lista de valores separados por comas)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una lista de valores delimitada por comas para los elementos especificados en <span class="fielddatabold">Defina estos elementos</span>. Puede especificar valores est\00E1ticos o sintaxis de sustituci\00F3n (por ejemplo, &amp;APP_ITEM_NAME.). '),
'<pre>&amp;APP_ITEM_NAME.</pre>',
unistr('<div class="htmldbInfoBodyP">Los valores de los elementos que se transfieren a <span class="fielddatabold">f?p=</span> en la direcci\00F3n URL nunca pueden contener un signo de dos puntos (:). Los valores de los elementos tampoco pueden contener comas a ')
||'menos que incluya todo el valor entre caracteres de barra invertida. Por ejemplo:</div>',
'<pre>\1234,56\</pre>',
unistr('<div class="htmldbInfoBodyP">Esto resulta \00FAtil cuando hay que transferir valores decimales donde el car\00E1cter separador de decimales de NLS es una coma.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3375397848172379.4001)
,p_name=>'P104_URL_TARGET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(31178079384755103.4001)
,p_prompt=>'Destino de URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Identifique la direcci\00F3n URL a la que ir cuando se haga clic en la entrada de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3701719101555006.4001)
,p_name=>'P104_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3701695051555005.4001)
,p_prompt=>'Buscar'
,p_placeholder=>unistr('Buscar entradas de ruta de navegaci\00F3n...')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_icon_css_classes=>'a-Icon icon-search'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4268679504696921.4001)
,p_name=>'P104_DISPLAY_WHEN_COND_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(13853237952413056.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'DISPLAY_WHEN_COND_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista. Esta condici\00F3n se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P104_DISPLAY_WHEN_CONDITION'
,p_attribute_02=>'P104_DISPLAY_WHEN_CONDITION2'
,p_attribute_04=>'P104_DISPLAY_WHEN_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'P104_DISPLAY_WHEN_COND_LANG'
,p_item_comment=>'Generated 30-APR-2002 21:01:54'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4269590506696925.4001)
,p_name=>'P104_DISPLAY_WHEN_COND_LANG'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(13853237952413056.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4270499400696925.4001)
,p_name=>'P104_DISPLAY_WHEN_CONDITION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(13853237952413056.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'DISPLAY_WHEN_CONDITION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o procesa')
||' el componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 21:01:55'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4271374812696926.4001)
,p_name=>'P104_DISPLAY_WHEN_CONDITION_CHECK'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(13853237952413056.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4271717788696926.4001)
,p_name=>'P104_DISPLAY_WHEN_CONDITION2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(13853237952413056.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2300916966269809.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'DISPLAY_WHEN_CONDITION2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 21:01:55'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20905008149355450.4001)
,p_name=>'P104_MENU_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_item_source_plug_id=>wwv_flow_api.id(20904804175355448.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2304195256269841.4001)
,p_computation_sequence=>10
,p_computation_item=>'P104_OPTION_MENU_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P104_MENU_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(9168306596345114.4001)
,p_computation_sequence=>20
,p_computation_item=>'P104_LINK'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clear_cache varchar2(4000);',
'begin',
'    if :P104_URL_OR_FLOW = ''FLOW'' then',
'        if :P104_CLEAR_PAGE = ''YES'' then',
'            l_clear_cache := ''RP,''||:P104_CLEAR_CACHE;',
'        else',
'            l_clear_cache := :P104_CLEAR_CACHE;',
'        end if;',
'        return ''f?p=&''||''APP_ID.:''||:P104_TARGET_PAGE_ID||'':&''||''SESSION.:''||:P104_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P104_ARG_NAMES||'':''||:P104_ARG_VALUES;',
'    elsif :P104_URL_OR_FLOW = ''0'' then',
'        return null;',
'    else ',
'        return :P104_URL_TARGET;',
'    end if;',
'end;'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2427515248300709.4001)
,p_computation_sequence=>30
,p_computation_item=>'P104_PAGE_SUCCESS_MSG'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(DECODE(:REQUEST,''CREATE_ENTRY'',''SC.BC.BCE_INSERTED'',''CREATE_ENTRY_AGAIN'',''SC.BC.BCE_INSERTED'',''SAVE_ENTRY'',''SC.BC.BCE_UPDATED'',''DELETE_ENTRY'',''SC.BC.BCE_DELETED'',''SAVE'',''SC.BC.BC_UPDATED'',''DELETE'',''SC.BC.BC_DELETED'
||''',''GENERIC.CHANGES_SAVED'')) msg',
'from sys.dual'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(8474338540051449.4001)
,p_computation_sequence=>10
,p_computation_item=>'P104_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_menu_options',
'where menu_id = :P104_MENU_ID',
'and page_id = :P104_PAGE_ID',
'and flow_id = :FB_FLOW_ID  ',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and rownum = 1',
''))
,p_compute_when=>':P104_MENU_ID is not null and :P104_PAGE_ID is not null and :P104_ID is null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2427345029300707.4001)
,p_computation_sequence=>20
,p_computation_item=>'P104_SELECTED_NODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce(:P104_ID,''bc''||:P104_MENU_ID)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2428388409300717.4001)
,p_computation_sequence=>30
,p_computation_item=>'P104_SEARCH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'sys.utl_url.unescape(:P104_SEARCH)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470095755051406.4001)
,p_validation_name=>'P104_PAGE_ID is not null'
,p_validation_sequence=>10
,p_validation=>'P104_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2302032647269820.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470338116051409.4001)
,p_validation_name=>'P104_PAGE_ID is unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'from wwv_flow_menu_options',
'where menu_id = :P104_MENU_ID',
'and page_id = :P104_PAGE_ID',
'and flow_id = :FB_FLOW_ID  ',
'and security_group_id = :flow_security_group_id',
'-- ignore current breadcrumb entry',
'and id != :P104_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina ya tiene asociada una entrada de ruta de navegaci\00F3n asociada. Debe seleccionar otra p\00E1gina.')
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2302032647269820.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470213474051408.4001)
,p_validation_name=>'P104_PAGE_ID is numeric'
,p_validation_sequence=>40
,p_validation=>'P104_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('#LABEL# debe ser num\00E9rica.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470115948051407.4001)
,p_validation_name=>'P104_SHORT_NAME is not null'
,p_validation_sequence=>50
,p_validation=>'P104_SHORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2301717367269817.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470498327051410.4001)
,p_validation_name=>'P104_TARGET_PAGE_ID is not null'
,p_validation_sequence=>60
,p_validation=>'P104_TARGET_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'') and :P104_URL_OR_FLOW = ''FLOW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3369910974172376.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470555035051411.4001)
,p_validation_name=>'P104_URL_TARGET is not null'
,p_validation_sequence=>70
,p_validation=>'P104_URL_TARGET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'') and :P104_URL_OR_FLOW = ''URL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3375397848172379.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8470686159051412.4001)
,p_validation_name=>'P104_PARENT_ID != P104_ID'
,p_validation_sequence=>80
,p_validation=>'coalesce(:P104_PARENT_ID,5555555566666666) != coalesce(:P104_ID,9999999988888888)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La entrada de ruta de navegaci\00F3n no puede identificarse como su principal.')
,p_when_button_pressed=>wwv_flow_api.id(2304873252269848.4001)
,p_associated_item=>wwv_flow_api.id(2301332269269813.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(10768689833283437.4001)
,p_name=>'Hide FLOW Choice'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P104_URL_OR_FLOW'
,p_condition_element=>'P104_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'FLOW,0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10769021618283457.4001)
,p_event_id=>wwv_flow_api.id(10768689833283437.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_URL_TARGET'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10769574989283458.4001)
,p_event_id=>wwv_flow_api.id(10768689833283437.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_URL_TARGET'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(10868589641303115.4001)
,p_name=>'Hide URL choice'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P104_URL_OR_FLOW'
,p_condition_element=>'P104_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'URL,0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10868944410303128.4001)
,p_event_id=>wwv_flow_api.id(10868589641303115.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_TARGET_PAGE_ID,P104_CLEAR_CACHE,P104_CLEAR_PAGE,P104_REQUEST,P104_ARG_NAMES,P104_ARG_VALUES'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10869405871303128.4001)
,p_event_id=>wwv_flow_api.id(10868589641303115.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_TARGET_PAGE_ID,P104_CLEAR_CACHE,P104_CLEAR_PAGE,P104_REQUEST,P104_ARG_NAMES,P104_ARG_VALUES'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(8470898405051414.4001)
,p_name=>'Delete Breadcrumb'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2312385894292715.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8470999259051415.4001)
,p_event_id=>wwv_flow_api.id(8470898405051414.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.confirm(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(8471138820051417.4001)
,p_name=>'Delete Breadcrumb Entry'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2304445449269844.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8471269558051418.4001)
,p_event_id=>wwv_flow_api.id(8471138820051417.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.confirm(htmldb_delete_message,''DELETE_ENTRY'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3701880007555007.4001)
,p_name=>'Search'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P104_SEARCH'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.which === 13'
,p_bind_type=>'bind'
,p_bind_event_type=>'keydown'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2427782509300711.4001)
,p_event_id=>wwv_flow_api.id(3701880007555007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20904792963355447.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3101075834676305.4001)
,p_name=>'Clear Search'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3100954151676304.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3101147159676306.4001)
,p_event_id=>wwv_flow_api.id(3101075834676305.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_SEARCH'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2428275874300716.4001)
,p_event_id=>wwv_flow_api.id(3101075834676305.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20904792963355447.4001)
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2427937204300713.4001)
,p_name=>'Highlight Search Results'
,p_event_sequence=>70
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(20904792963355447.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3701918308555008.4001)
,p_event_id=>wwv_flow_api.id(2427937204300713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.treeUtil.search ($v("P104_SEARCH"),''bcEntries'',''a-Property-highlight'');'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2429010819300724.4001)
,p_name=>'Focus Tree Node'
,p_event_sequence=>100
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2429180549300725.4001)
,p_event_id=>wwv_flow_api.id(2429010819300724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.treeUtil.focus("bcEntries");'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3676064321250177.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Target Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy varchar2(255);',
'begin',
'    for c1 in (select link',
'                 from wwv_flow_menu_options',
'                where id = :P104_ID) loop    ',
'        wwv_flow_builder.split_url(',
'            p_url         => c1.link,',
'            p_flow        => l_dummy,',
'            p_page        => :P104_TARGET_PAGE_ID,',
'            p_session     => l_dummy,',
'            p_request     => :P104_REQUEST,',
'            p_debug       => l_dummy,',
'            p_clear_cache => :P104_CLEAR_CACHE,',
'            p_arg_names   => :P104_ARG_NAMES,',
'            p_arg_values  => :P104_ARG_VALUES,',
'            p_success_msg => l_dummy);    ',
'        if :P104_TARGET_PAGE_ID is null then',
'            if c1.link is not null then',
'                :P104_URL_TARGET := c1.link;',
'                :P104_URL_OR_FLOW := ''URL'';',
'            else',
'                :P104_URL_OR_FLOW := ''0'';',
'            end if;',
'        else ',
'            :P104_URL_TARGET := null;',
'            :P104_URL_OR_FLOW := ''FLOW'';',
'            if instr(:P104_CLEAR_CACHE,''RP'') = 1 then',
'              :P104_CLEAR_PAGE := ''YES'';',
'              :P104_CLEAR_CACHE := ltrim(replace(:P104_CLEAR_CACHE,''RP'',null),'','');',
'            else',
'              :P104_CLEAR_PAGE := null;',
'            end if;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P104_ID'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11468369998820719.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Breadcrumb Regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_page_plugs',
' where menu_id           = :P104_MENU_ID',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido suprimir las regiones de ruta de navegaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2312385894292715.4001)
,p_process_when=>'P104_MENU_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2304200083269842.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(20904804175355448.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Save Breadcrumb Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''SAVE'',''DELETE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P104_PAGE_SUCCESS_MSG.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2304393691269843.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(2300916966269809.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Save Breadcrumb Entry Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'',''DELETE_ENTRY'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P104_PAGE_SUCCESS_MSG.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8474235047051448.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'On Delete Entry - Update Parent ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_menu_options',
'   set parent_id = null',
' where parent_id         = :P104_ID',
'   and menu_id           = :P104_MENU_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2304445449269844.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1801409794462313.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync Page Name and Title'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_steps',
'   set name       = :P104_SHORT_NAME,',
'       step_title = :P104_SHORT_NAME',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and id                = :P104_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'') and :P104_SYNC_PAGE_NAME = ''YES'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('El t\00EDtulo y el nombre de p\00E1gina se han sincronizado con la abreviatura de la ruta de navegaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20904941992355449.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(20904804175355448.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Breadcrumb'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2301168541269811.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(2300916966269809.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Breadcrumb Entry'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00105
begin
wwv_flow_api.create_page(
 p_id=>105.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista: Origen'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1417613820896865.4001)
,p_plug_name=>'Crear Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<div class="htmldbInfoBodyP">Una lista es una definici\00F3n est\00E1tica o din\00E1mica utilizada para visualizar un tipo espec\00EDfico de elemento de p\00E1gina, como, por ejemplo, barras de progreso o listas de men\00FAs de navegaci\00F3n.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1418713860896875.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(169186610834587350.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44558414509146866.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1417802668896870.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44558414509146866.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1418012790896871.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44558414509146866.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1419223686896876.4001)
,p_branch_action=>'427'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1418012790896871.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'P105_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1419412150896878.4001)
,p_branch_action=>'658'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1418012790896871.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'P105_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1418226311896871.4001)
,p_name=>'P105_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1417613820896865.4001)
,p_item_default=>'BLANK'
,p_prompt=>'Crear Lista:'
,p_source=>'BLANK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LIST_WIZ_LOV'
,p_lov=>'.'||wwv_flow_api.id(10676432019281440.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Especifique la forma de crear una lista. Puede crear una lista desde el principio o bien como copia de una lista existente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574041800712616949.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1417802668896870.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574041920085616950.4001)
,p_event_id=>wwv_flow_api.id(574041800712616949.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1418901482896875.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear cache'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'137:138:139'
,p_process_when_button_id=>wwv_flow_api.id(1417802668896870.4001)
);
end;
/
prompt --application/pages/page_00106
begin
wwv_flow_api.create_page(
 p_id=>106.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Nuevo Principal de Entradas de Ruta de Navegaci\00F3n')
,p_alias=>'REPARENT-BREADCRUMB-ENTRIES'
,p_step_title=>unistr('Crear Nuevo Principal de Entradas de Ruta de Navegaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2429381632300727.4001)
,p_plug_name=>'Seleccionar un nodo principal'
,p_region_name=>'bcEntriesParent'
,p_region_css_classes=>'a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with breadcrumb_tree',
'as',
'(',
'    select name short_name,',
'           ''icon-sc-tree'' icon,',
'           ''bc''||menus.id id,',
'           null as parent_id,',
'           null as page_id,',
'           null as option_sequence',
'      from wwv_flow_menus menus',
'     where menus.id                = :P106_MENU_ID',
'       and menus.flow_id           = :FB_FLOW_ID',
'       and menus.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and ( :P106_SELECTED_NODES is null or instr('':''||:P106_SELECTED_NODES||'':'', '':bc''||id||'':'') = 0 )',
'    union all',
'    select options.short_name,',
'           null as icon,',
'           to_char(options.id) id,',
'           case when options.parent_id is null or options.parent_id = 0',
'           then',
'                ''bc''||:P106_MENU_ID',
'           else to_char(options.parent_id)',
'           end parent_id,',
'           options.page_id,',
'           option_sequence           ',
'      from wwv_flow_menu_options options',
'     where options.menu_id            = :P106_MENU_ID',
'       and options.flow_id            = :FB_FLOW_ID',
'       and options.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'       and ( :P106_SELECTED_NODES is null or instr('':''||:P106_SELECTED_NODES||'':'', '':''||id||'':'') = 0 )',
')',
' select case',
'            when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else -1',
'        end as status,',
'        level,',
'        short_name,',
'        icon,',
'        id,',
'        parent_id,',
'        case',
'            when page_id is not null then wwv_flow_lang.system_message( ''PAGE'' )||'' ''||page_id',
'            else null',
'        end tooltip,',
'        null as link',
'   from breadcrumb_tree',
'  start with parent_id is null or parent_id = ''0''',
'connect by prior id = parent_id',
'  order siblings by option_sequence, short_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_ajax_items_to_submit=>'P106_MENU_ID,P106_SELECTED_NODES'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_02=>'D'
,p_attribute_04=>'DB'
,p_attribute_08=>'a-Icon'
,p_attribute_09=>'icon-sc-breadcrumb'
,p_attribute_10=>'SHORT_NAME'
,p_attribute_11=>'LEVEL'
,p_attribute_12=>'ICON'
,p_attribute_15=>'STATUS'
,p_attribute_20=>'ID'
,p_attribute_21=>'javascript:apex.builder.breadcrumb.moveNodes( ''bcEntriesParent'', ''bcEntries'' );'
,p_attribute_22=>'TOOLTIP'
,p_attribute_23=>'LEVEL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3101398367676308.4001)
,p_plug_name=>'Barra Superior'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35904920662511686.4001)
,p_plug_name=>unistr('Entradas de Ruta de Navegaci\00F3n')
,p_region_name=>'bcEntries'
,p_region_css_classes=>'a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with breadcrumb_tree',
'as',
'(',
'    select name short_name,',
'           ''icon-sc-tree''||'' id-''||''bc''||menus.id as icon,',
'           ''bc''||menus.id id,',
'           null as parent_id,',
'           null as page_id,',
'           null as option_sequence',
'      from wwv_flow_menus menus',
'     where menus.id                = :P106_MENU_ID',
'       and menus.flow_id           = :FB_FLOW_ID',
'       and menus.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    union all',
'    select options.short_name,',
'           ''icon-sc-breadcrumb''||'' id-''||to_char(options.id) as icon,',
'           to_char(options.id) id,',
'           case when options.parent_id is null or options.parent_id = 0',
'           then',
'                ''bc''||:P106_MENU_ID',
'           else to_char(options.parent_id)',
'           end parent_id,',
'           options.page_id,',
'           option_sequence           ',
'      from wwv_flow_menu_options options',
'     where options.menu_id            = :P106_MENU_ID',
'       and options.flow_id            = :FB_FLOW_ID',
'       and options.security_group_id  = :FLOW_SECURITY_GROUP_ID',
')',
' select case',
'            when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else -1',
'        end as status,',
'        level,',
'        short_name,',
'        icon,',
'        id,',
'        parent_id,',
'        case',
'            when page_id is not null then wwv_flow_lang.system_message( ''PAGE'' )||'' ''||page_id',
'            else null',
'        end tooltip,',
'        null as link',
'   from breadcrumb_tree',
'  start with parent_id is null or parent_id = ''0''',
'connect by prior id = parent_id',
'  order siblings by option_sequence, short_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_ajax_items_to_submit=>'P106_MENU_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(options) {',
'    options.dragAndDrop = true;',
'    options.multiple = true;',
'    options.dragMultiple = true;',
'    options.dragCursor = "move";',
'    options.dragOpacity = 0.6;',
'    options.dragCursorAt = { left: 20, bottom: -20 };',
'    options.dragHelper = true;',
'    options.delay = 10;',
'    options.distance = 5;',
'    options.dragAppendTo = document.body;',
'    options.dragScroll = true;',
'    // tree node adapter',
'    options.makeNodeAdapter = function (data, types, hasIdentity) {',
'        var lAdapter;',
'        lAdapter = $.apex.treeView.makeDefaultNodeAdapter( data, types, hasIdentity );',
'        lAdapter.types.default.operations = {',
'            canAdd: true, // moving and copying may involve adding nodes to new parent',
'            canDrag: true,',
'            canDelete: true, // moving may involve deleting from one parent',
'            drag: { normal: "move", ctrl: "copy" }',
'        };',
'        // by default it''s not possible to add children to lead nodes ',
'        // add empty children to enable adding (dropping nodes) to leaf nodes',
'        apex.builder.treeUtil.traverse(lAdapter.root());',
'        lAdapter.validateMove = apex.builder.breadcrumb.validateMove;',
'        return lAdapter;',
'    };',
'    // tree context menu',
'    var lSelection$,',
'        lTree$,',
'        lSelectedNodes,',
'        lAjaxRequest,',
'        lExpandAll,',
'        lCollapseAll,',
'        lExpandAllBelow,',
'        lCollapseAllBelow;',
'',
'    // context menu labels',
'    lExpandAll = apex.lang.getMessage( "TREE.EXPAND_ALL" );',
'    lCollapseAll = apex.lang.getMessage( "TREE.COLLAPSE_ALL" );',
'    lExpandAllBelow = apex.lang.getMessage( "TREE.EXPAND_ALL_BELOW" );',
'    lCollapseAllBelow = apex.lang.getMessage( "TREE.COLLAPSE_ALL_BELOW" );',
'',
'    options.contextMenuId = "bcTreeMenu";',
'    options.contextMenu = {',
'        items: [',
'            {',
'                type: "action",',
'                label: lExpandAll, ',
'                action: function( _, el ) {',
'                    lTree$.treeView("expandAll");',
'                }',
'            },',
'            {',
'                type: "action",',
'                label: lCollapseAll, ',
'                action: function( event, el ) {',
'                    lTree$.treeView("collapseAll");',
'                }',
'            },',
'            {',
'                type: "action",',
'                label: lExpandAllBelow,',
'                action: function( _, el ) {',
'                    lTree$.treeView("expandAll", lSelection$);',
'                }',
'            },',
'            {',
'                type: "action",',
'                label: lCollapseAllBelow,',
'                action: function( event, el ) {',
'                    lTree$.treeView("collapseAll", lSelection$);',
'                }',
'            },',
'            {',
'                type: "separator"',
'            },',
'            {',
'                type: "action",',
'                label: "Reparent",',
'                action: function( _, el ) {',
'                    apex.builder.breadcrumb.showParentTree( lSelectedNodes, "P106_SELECTED_NODES", "bcEntriesParent" );',
'                },',
'                disabled: function () { return ( lSelection$.length === 0 || ( lSelection$.length === 1 && ( lSelectedNodes[0].id ).indexOf( "bc" ) === 0 ) );}',
'            }',
'        ],',
'        beforeOpen: function( event, data ) {',
'            lTree$         = data.treeView;',
'            lSelection$    = data.selection;',
'            lSelectedNodes = data.selectedNodes;',
'        }',
'    }    ',
'    return options;',
'}'))
,p_attribute_02=>'S'
,p_attribute_04=>'DB'
,p_attribute_08=>'a-Icon'
,p_attribute_09=>'icon-sc-breadcrumb'
,p_attribute_10=>'SHORT_NAME'
,p_attribute_11=>'LEVEL'
,p_attribute_12=>'ICON'
,p_attribute_15=>'STATUS'
,p_attribute_20=>'ID'
,p_attribute_22=>'TOOLTIP'
,p_attribute_23=>'LEVEL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50608686167121130.4001)
,p_plug_name=>unistr('Crear Nuevo Principal de Entradas de Ruta de Navegaci\00F3n')
,p_region_name=>'bcEntries'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta p\00E1gina se utiliza para gestionar una jerarqu\00EDa de ruta de navegaci\00F3n. Arrastre y suelte para crear un nuevo principal de las entradas de ruta de navegaci\00F3n. Los cambios se guardan autom\00E1ticamente.'),
unistr('<br /><br />Es posible crear un nuevo principal de las entradas utilizando el men\00FA contextual. Seleccione una o varias entradas de ruta navegaci\00F3n y, a continuaci\00F3n, haga clic con el bot\00F3n derecho y seleccione la opci\00F3n "Crear nuevo principal". Al ha')
||unistr('cerlo, aparecer\00E1 un \00E1rbol secundario con todas las entradas principales v\00E1lidas posibles. Seleccione una y haga clic en el bot\00F3n "Crear nuevo principal", o pulse la tecla "Intro". Esta acci\00F3n crear\00E1 un nuevo principal de las entradas seleccionadas en')
||' la nueva entrada principal.'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(126520849800705750.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(111619820846587947.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2429591377300729.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(35904920662511686.4001)
,p_button_name=>'TREE_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Men\00FA de \00E1rbol')
,p_button_position=>'ABOVE_BOX'
,p_button_alignment=>'LEFT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="bcTreeMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3101555629676310.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3101398367676308.4001)
,p_button_name=>'GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1154969520888084240.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2429381632300727.4001)
,p_button_name=>'REPARENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Nuevo Principal'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2429411018300728.4001)
,p_name=>'P106_SELECTED_NODES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2429381632300727.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3101469216676309.4001)
,p_name=>'P106_MENU_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3101398367676308.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2427689972300710.4001)
,p_computation_sequence=>10
,p_computation_item=>'P106_MENU_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select min(id)',
'   from wwv_flow_menus',
'  where flow_id           = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_computation_comment=>'By Default show any breadcrumb from current application. If P106_MENU_ID is not null, ensure it''s from current application. Otherwise load any breadcrumb from current application. '
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select *',
'   from wwv_flow_menus',
'  where flow_id           = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'    and id                = coalesce(to_number(:P106_MENU_ID),-1)'))
,p_compute_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2429622506300730.4001)
,p_name=>'Parent Tree - Focus Root Node'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(2429381632300727.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2429742540300731.4001)
,p_event_id=>wwv_flow_api.id(2429622506300730.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// by default select root node',
'apex.builder.treeUtil.selectRoot( "bcEntriesParent" );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2429885001300732.4001)
,p_name=>'Main Tree - Focus Root Node'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(35904920662511686.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2429934660300733.4001)
,p_event_id=>wwv_flow_api.id(2429885001300732.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// by default select root node',
'apex.builder.treeUtil.selectRoot( "bcEntries" );'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1154969623682084241.4001)
,p_name=>'Reparent Selected Entries'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1154969520888084240.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1154969741918084242.4001)
,p_event_id=>wwv_flow_api.id(1154969623682084241.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.breadcrumb.moveNodes( ''bcEntriesParent'', ''bcEntries'' );'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15100295260267560.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAVE_CHANGES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.save_breadcrumb_changes(',
'    p_menu_id           => :P106_MENU_ID,',
'    p_app_id            => :FB_FLOW_ID,',
'    p_workspace_id      => :FLOW_SECURITY_GROUP_ID,',
'    p_changes           => apex_application.g_f01);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00107
begin
wwv_flow_api.create_page(
 p_id=>107.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asistente de Creaci\00F3n: P\00E1ginas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Asistente de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214145517801857461)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146510124645504466.4001)
,p_plug_name=>unistr('Asistente de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147249024142245989.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147241516822234215.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201977726675903807.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146513028580513034.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201977726675903807.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146519323516521023.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(201977726675903807.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279434300417253578.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(201977726675903807.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548855438124009834.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::P4716_PREV_PAGE_ID:&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(146519323516521023.4001)
,p_branch_sequence=>5
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(151036917677426108.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(146513028580513034.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548852786714981360.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279434300417253578.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45282714387511764.4001)
,p_name=>'P107_PAGE_MODE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146522008242527197.4001)
,p_name=>'F4000_P107_STEPS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_item_default=>'5'
,p_prompt=>unistr('Crear este N\00FAmero de P\00E1ginas:')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'VALUES_1-9'
,p_lov=>'.'||wwv_flow_api.id(84704207936671347.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el n\00FAmero de pasos (o "p\00E1ginas") que va a crear este asistente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146537731915577046.4001)
,p_name=>'F4000_P107_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148529822306769104.4001)
,p_name=>'P107_TAB_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_source=>'ALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(149260616173011921.4001)
,p_name=>'F4000_P107_INFO_REGION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_item_default=>'N'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Seleccione si las p\00E1ginas nuevas deben tener una regi\00F3n de informaci\00F3n en la parte derecha.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(149534507323821280.4001)
,p_name=>'F4000_P107_PREV_STEPS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403224251597478668.4001)
,p_name=>'P107_GROUP_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1007564743502031507.4001)
,p_name=>'P107_BREADCRUMB_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1007564874336031508.4001)
,p_name=>'P107_BREADCRUMB_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P107_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P107_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P107_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1007564908956031509.4001)
,p_name=>'P107_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P107_WIZARD_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1331350895200223310.4001)
,p_name=>'P107_WIZARD_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(146510124645504466.4001)
,p_prompt=>'Nombre del Asistente'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para este asistente. El nombre del asistente se mostrar\00E1 en el t\00EDtulo del cuadro de di\00E1logo al utilizar cuadros de di\00E1logo modales.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1007566077043031520.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P107_WIZARD_NAME'
,p_computation_error_message=>' '
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45283210290513611.4001)
,p_validation_name=>'P107_PAGE_MODE Not Null'
,p_validation_sequence=>10
,p_validation=>'P107_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(146519323516521023.4001)
,p_associated_item=>wwv_flow_api.id(45282714387511764.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403224770856480337.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P107_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P107_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(146519323516521023.4001)
,p_associated_item=>wwv_flow_api.id(403224251597478668.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548851931390979677.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(146513028580513034.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548852285768979677.4001)
,p_event_id=>wwv_flow_api.id(548851931390979677.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1007565061105031510.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P107_BREADCRUMB_ID'
,p_condition_element=>'P107_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1007565121568031511.4001)
,p_event_id=>wwv_flow_api.id(1007565061105031510.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P107_BREADCRUMB_PARENT_ID,P107_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1007565212006031512.4001)
,p_event_id=>wwv_flow_api.id(1007565061105031510.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P107_BREADCRUMB_PARENT_ID,P107_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1007565349543031513.4001)
,p_name=>'is modal'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P107_PAGE_MODE'
,p_condition_element=>'P107_PAGE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'MODAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1007565491362031514.4001)
,p_event_id=>wwv_flow_api.id(1007565349543031513.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P107_BREADCRUMB_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1007565571956031515.4001)
,p_event_id=>wwv_flow_api.id(1007565349543031513.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P107_BREADCRUMB_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1007565686936031516.4001)
,p_event_id=>wwv_flow_api.id(1007565349543031513.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P107_BREADCRUMB_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1007565860673031518.4001)
,p_name=>'set breadcrumb name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P107_WIZARD_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1007565903212031519.4001)
,p_event_id=>wwv_flow_api.id(1007565860673031518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P107_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P107_WIZARD_NAME'
,p_attribute_07=>'P107_WIZARD_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(151033032557419235.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unreserve pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c002 page_id',
'             from wwv_flow_collections',
'             where collection_name = ''CREATE_WIZARD'') loop',
'     wwv_flow_builder.unreserve_flow_page(',
'          p_flow_id       => :fb_flow_id,',
'          p_page_id       => c1.page_id,',
'          p_flow_session  => :flow_session',
'          );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(146513028580513034.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(146705305583941567.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create wizard collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare  ',
'  l_min_free_page number := 0;  ',
'begin',
'  for c1 in (select c002 page_id',
'             from wwv_flow_collections',
'             where collection_name = ''CREATE_WIZARD'') loop',
'     wwv_flow_builder.unreserve_flow_page(',
'          p_flow_id       => :fb_flow_id,',
'          p_page_id       => c1.page_id,',
'          p_flow_session  => :flow_session',
'          );',
'  end loop;',
'  wwv_flow_collection.create_or_truncate_collection(''CREATE_WIZARD'');',
'  for i in 1..:F4000_P107_STEPS loop',
'       l_min_free_page := wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1);',
'       ',
'       wwv_flow_collection.add_member(',
'        p_collection_name => ''CREATE_WIZARD'',',
'        p_c001            => i,',
'        p_c002            => l_min_free_page,',
'        p_c003            => wwv_flow_lang.system_message(''F400_P107_STEP'',i),',
'        p_c004            => 1',
'        );        ',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error de inicializaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(146519323516521023.4001)
);
end;
/
prompt --application/pages/page_00108
begin
wwv_flow_api.create_page(
 p_id=>108.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asistente de Creaci\00F3n: Atributos de P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Asistente de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214145517801857461)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(146550608612603033.4001)
,p_name=>unistr('Asistente de Creaci\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'    l_max number            := :F4000_P107_STEPS;',
'    q     varchar2(32767);',
'',
'begin',
'    if wwv_flow_collection.collection_member_count(''CREATE_WIZARD'') > 0 then  ',
'        q:=''select '';',
'        q:=q||''c001||''''.'''' a, '';',
'        q:=q||'' wwv_flow_item.text(1,c002,null,null,''''id="page''''||rownum||''''" title="''''||wwv_flow_lang.system_message(''''CONFIRM.DATA_LOAD_PAGE'''')||'''' ''''||c002||''''"'''') b, '';',
'        q:=q||'' wwv_flow_item.text(2,c003,null,null,''''id="name''''||rownum||''''" title="''''||wwv_flow_lang.system_message(''''F4000.PAGE_NAME'''')||'''' ''''||c003||''''"'''') c, '';',
'        q:=q||'' wwv_flow_item.select_list(3,c004,''''1,2,3,4,5,6,7,8,9'''',''''id="items''''||rownum||''''" title="''''||wwv_flow_lang.system_message(''''PAGE ITEMS'''')||'''' ''''||c004||''''"'''') d '';',
'        q:=q||''from wwv_flow_collections '';',
'        q:=q||''where collection_name = ''''CREATE_WIZARD'''' '';    ',
'    end if;',
'',
'    return q;',
'end;'))
,p_header=>unistr('<p>Esta p\00E1gina proporciona una abreviatura descriptiva de cada una de las p\00E1ginas. Estas abreviaturas ayudan a identificar y editar posteriormente el contenido de dicha p\00E1gina. Los nombres de p\00E1gina se utilizan tambi\00E9n como nombres por defecto de las')
||unistr(' regiones. Cada p\00E1gina incluye una regi\00F3n que agrupar\00E1 <i>n</i> n\00FAmero de elementos.</p>')
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''&nbsp;:''||',
'       wwv_flow_lang.system_message(''F4000.PAGE'')||'':''||',
'       wwv_flow_lang.system_message(''F4000.PAGE_NAME'')||'':''||',
'       wwv_flow_lang.system_message(''CONFIRM.ITEMS'');'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>50
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880207490772731.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880318445772731.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880421478772731.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880518963772732.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880601604772732.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880700544772732.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880803556772732.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48880903701772732.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881032318772732.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881132730772732.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881202946772732.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881303693772733.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881419549772733.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881529605772733.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48881621939772733.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74310309989905159.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74310423460905159.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74310525548905159.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74310630148905159.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(74310705119905160.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157769829717773553.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157769931933773555.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770007058773555.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770112940773555.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770226081773556.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770316204773556.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770417524773556.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770515088773556.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770618779773556.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770720089773556.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770803686773556.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157770912790773557.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771005828773557.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771110937773557.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771206758773557.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771326365773557.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771406095773557.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771512917773557.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771619482773557.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771727521773557.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771806747773558.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157771927378773558.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772019113773558.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772118604773558.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772211889773558.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772307554773558.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772429405773558.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772510016773559.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772602942773559.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772705353773559.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772830326773559.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157772921764773559.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773030929773559.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773101810773559.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773209425773560.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773322093773560.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773421848773560.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773530451773560.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773606330773561.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157773727470773561.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147250916378249660.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147241516822234215.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201979717634948505.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1161096727807451327.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146579030077721608.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201979717634948505.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146585519819728131.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(201979717634948505.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146580909083724997.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(201979717634948505.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(146585903623728134.4001)
,p_branch_name=>'Go To Page 110'
,p_branch_action=>'110'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(146585519819728131.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(151060809888460167.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(146579030077721608.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38850610617540199.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(146580909083724997.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1997177262658100192.4001)
,p_name=>'P108_FINISH_BRANCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1161096727807451327.4001)
,p_prompt=>unistr('Bifurcar Aqu\00ED al Finalizar')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_display_when=>'P107_PAGE_MODE'
,p_display_when2=>'NORMAL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un n\00FAmero de p\00E1gina a la que bifurcar cuando el usuario haga clic en <strong>Terminar</strong>.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1997178098117102425.4001)
,p_name=>'P108_CANCEL_BRANCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1161096727807451327.4001)
,p_prompt=>unistr('Bifurcar Aqu\00ED al Cancelar')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_display_when=>'P107_PAGE_MODE'
,p_display_when2=>'NORMAL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un n\00FAmero de p\00E1gina a la que bifurcar cuando el usuario haga clic en <strong>Cancelar</strong>.</p>'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(158475500512075213.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'return wwv_flow.g_f01(1);',
'exception when others then null;',
'end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(147219922682185912.4001)
,p_validation_name=>'page name not null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f02.count loop',
'',
'  if replace(wwv_flow.g_f02(i),''%''||''null%'') is null then',
'',
'    return false;',
'',
'  end if;',
'',
'end  loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(146585519819728131.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(148563306513837239.4001)
,p_validation_name=>'page id not null'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'',
'  if wwv_flow.g_f01(i) is null then',
'',
'    return false;',
'',
'  end if;',
'',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se deben especificar todos los n\00FAmeros de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(146585519819728131.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(149339702998306727.4001)
,p_validation_name=>'page exists'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'',
'if wwv_flow_wizard_api.page_exists (',
'',
'   p_flow_id => :FB_FLOW_ID,',
'',
'   p_page_id => wwv_flow.g_f01(i)) = true then',
'',
'  return false;',
'',
'end if;',
'',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ya existe el n\00FAmero de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(146585519819728131.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(484143006962302654.4001)
,p_validation_name=>'page ids positive, whole number'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'',
'  if trunc(abs(wwv_flow.g_f01(i))) != wwv_flow.g_f01(i) then',
'',
'    return false;',
'',
'  end if;',
'',
'end  loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Los n\00FAmeros de p\00E1gina deben ser n\00FAmeros enteros y positivos.')
,p_when_button_pressed=>wwv_flow_api.id(146585519819728131.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1997188979112321601.4001)
,p_validation_name=>'Finish Branch numeric'
,p_validation_sequence=>60
,p_validation=>'P108_FINISH_BRANCH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina del destino de bifurcaci\00F3n debe ser num\00E9rico.')
,p_associated_item=>wwv_flow_api.id(1997177262658100192.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1997189001555321602.4001)
,p_validation_name=>'Cancel Branch numeric'
,p_validation_sequence=>70
,p_validation=>'P108_CANCEL_BRANCH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina del destino de bifurcaci\00F3n debe ser num\00E9rico.')
,p_associated_item=>wwv_flow_api.id(1997178098117102425.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548871467985081763.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(146579030077721608.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548871739517081763.4001)
,p_event_id=>wwv_flow_api.id(548871467985081763.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(151057917437456659.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unreserve pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c002 page_id',
'             from wwv_flow_collections',
'             where collection_name = ''CREATE_WIZARD'') loop',
'     wwv_flow_builder.unreserve_flow_page(',
'          p_flow_id       => :fb_flow_id,',
'          p_page_id       => c1.page_id,',
'          p_flow_session  => :flow_session',
'          );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(146579030077721608.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(146755629219036969.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update create_wizard member'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'',
'  wwv_flow_collection.update_member(',
'      p_collection_name => ''CREATE_WIZARD'',',
'      p_seq             => i,',
'      p_c001            => i,',
'      p_c002            => wwv_flow.g_f01(i),                  -- page id',
'      p_c003            => nvl(wwv_flow.g_f02(i),''Step ''||i),  -- page name',
'      p_c004            => wwv_flow.g_f03(i)                   -- total number of items',
'      );',
'  ',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(146585519819728131.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1997189187608321603.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create wizard creating wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_first_page_id number := null;',
'begin  ',
'  for c1 in (select c002 page_id',
'             from wwv_flow_collections',
'             where collection_name = ''CREATE_WIZARD''',
'             order by seq_id) loop',
'      l_first_page_id := c1.page_id;',
'      exit;',
'  end loop;',
'    ',
'  wwv_flow_wizard_api.create_wizard (',
'   p_flow_id                  => :FB_FLOW_ID,   ',
'   p_steps                    => :F4000_P107_STEPS,',
'   p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'   p_page_mode                => :P107_PAGE_MODE,',
'   p_group_name               => :P107_GROUP_NAME,',
'   --',
'   p_tab_type                 => ''ALL'',',
'   p_tab_set                  => :P4716_TAB_SET,',
'   p_tab_name                 => :P4716_TAB_NAME,',
'   p_tab_text                 => :P4716_TAB_LABEL,',
'   --',
'   p_nav_list_id              => :P4716_NAVLIST_ID,',
'   p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'   p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'   --',
'   p_region_template          => replace(:F4000_P107_REGION_TEMPLATE,''%''||''null%'',null), ',
'   p_info_region              => :F4000_P107_INFO_REGION,   ',
'   p_info_region_template     => replace(:F4000_P107_INFO_REG_TEMPLATE,''%''||''null%'',null),',
'   p_info_default_text        => :F4000_P107_DEFAULT_INFO_TEXT,',
'   --',
'   p_cancel_branch            => :P108_CANCEL_BRANCH,',
'   p_finish_branch            => :P108_FINISH_BRANCH,  ',
'   p_cancel_button_name       => wwv_flow_lang.system_message(''CANCEL''),',
'   p_finish_button_name       => wwv_flow_lang.system_message(''FINISH''),',
'   p_previous_button_name     => wwv_flow_lang.system_message(''PREVIOUS''),',
'   p_next_button_name         => wwv_flow_lang.system_message(''NEXT''));',
'   ',
'   ',
'   :fb_flow_page_id       := l_first_page_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear el asistente. #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(146585519819728131.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1997189276098321604.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'El asistente se ha creado correctamente.'
);
end;
/
prompt --application/pages/page_00109
begin
wwv_flow_api.create_page(
 p_id=>109.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Total de control de componente'
,p_alias=>'COMPONENT-CHECKSUM'
,p_page_mode=>'MODAL'
,p_step_title=>'Total de control'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_javascript_code=>'var lSpinner$;'
,p_javascript_code_onload=>'lSpinner$ = apex.util.showSpinner(''.a-Dialog-body''); '
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,height:320'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(632165757692856031.4001)
,p_plug_name=>'Dialog Body'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(590828197353847074.4001)
,p_plug_name=>'Checksum'
,p_parent_plug_id=>wwv_flow_api.id(632165757692856031.4001)
,p_region_css_classes=>'margin-left-md margin-right-md a-Form--large'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P109_COMPONENT = ''APPLICATION'' then',
'    sys.htp.p(wwv_flow_lang.message(''APEX.APPLICATION.CHECKSUM.DESCRIPTION''));',
'elsif :P109_COMPONENT = ''PAGE'' then',
'    sys.htp.p(wwv_flow_lang.message(''APEX.PAGE.CHECKSUM.DESCRIPTION''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(591702465565020403.4001)
,p_name=>'Page Information'
,p_parent_plug_id=>wwv_flow_api.id(632165757692856031.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       null details,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_page_plugs   where flow_id = fs.flow_id and page_id = fs.id) regions,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_step_items   where flow_id = fs.flow_id and flow_step_id = fs.id) items,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_step_buttons where flow_id = fs.flow_id and flow_step_id = fs.id) buttons',
'from wwv_flow_steps fs',
'where flow_id = :FB_FLOW_ID and id = :fb_flow_page_id and security_group_id = :flow_security_group_id '))
,p_display_when_condition=>'P109_COMPONENT'
,p_display_when_cond2=>'PAGE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(591702666299020405.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(591702504636020404.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#NAME#</strong>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(591702788904020406.4001)
,p_query_column_id=>3
,p_column_alias=>'DETAILS'
,p_column_display_sequence=>30
,p_column_heading=>'Detalles'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#REGIONS# Regiones, #ITEMS# Elementos, #BUTTONS# Botones'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(591702901827020408.4001)
,p_query_column_id=>4
,p_column_alias=>'REGIONS'
,p_column_display_sequence=>50
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(591703031873020409.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEMS'
,p_column_display_sequence=>60
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(591703189655020410.4001)
,p_query_column_id=>6
,p_column_alias=>'BUTTONS'
,p_column_display_sequence=>70
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(632164936929856023.4001)
,p_name=>'Application Information'
,p_parent_plug_id=>wwv_flow_api.id(632165757692856031.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       null details,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_steps where flow_id = f.id) pages,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_page_plugs where flow_id = f.id) regions,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_items where flow_id = f.id) items',
'from wwv_flows f',
'where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id '))
,p_display_when_condition=>'P109_COMPONENT'
,p_display_when_cond2=>'APPLICATION'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632165182214856025.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632165388699856027.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#NAME#</strong>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632166040647856034.4001)
,p_query_column_id=>3
,p_column_alias=>'DETAILS'
,p_column_display_sequence=>40
,p_column_heading=>'Detalles'
,p_use_as_row_header=>'N'
,p_column_html_expression=>unistr('#PAGES# P\00E1ginas, #REGIONS# Regiones, #ITEMS# Elementos')
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632165468252856028.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGES'
,p_column_display_sequence=>50
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632165821374856032.4001)
,p_query_column_id=>5
,p_column_alias=>'REGIONS'
,p_column_display_sequence=>60
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(632165953500856033.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEMS'
,p_column_display_sequence=>70
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(569703810529235083.4001)
,p_name=>'P109_CHECKSUM_VALUE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(590828197353847074.4001)
,p_prompt=>'Valor de total de control'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'u-tC'
,p_tag_attributes=>'readonly style="font-size: 24px; line-height: 64px;"'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth a-Form-fieldContainer--stretch a-Form-fieldContainer--noPadding margin-bottom-md'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(575876134884387127.4001)
,p_name=>'P109_COMPONENT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(590828197353847074.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(632164065770856014.4001)
,p_name=>'P109_CHECKSUM_HIDDEN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(590828197353847074.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(632163699863856010.4001)
,p_name=>'Load Checksum'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632163702640856011.4001)
,p_event_id=>wwv_flow_api.id(632163699863856010.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P109_CHECKSUM_VALUE,P109_CHECKSUM_HIDDEN'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_export wwv_flow_t_export_files;',
'begin',
'    if :P109_COMPONENT = ''APPLICATION'' then',
'        l_export := wwv_flow_export_api.get_application (',
'                        p_application_id => :FB_FLOW_ID,',
'                        p_type           => ''CHECKSUM-SH1'' );',
'    elsif :P109_COMPONENT = ''PAGE'' then',
'        l_export := wwv_flow_export_api.get_application (',
'                        p_application_id => :FB_FLOW_ID,',
'                        p_components    => wwv_flow_t_varchar2(''PAGE:''||:FB_FLOW_PAGE_ID),',
'                        p_type           => ''CHECKSUM-SH1'' );',
'    end if;',
'    return l_export(1).contents;',
'end;'))
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(632164185083856015.4001)
,p_name=>'Show Checksum'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P109_CHECKSUM_HIDDEN'
,p_condition_element=>'P109_CHECKSUM_HIDDEN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632164244353856016.4001)
,p_event_id=>wwv_flow_api.id(632164185083856015.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(632165757692856031.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632164338106856017.4001)
,p_event_id=>wwv_flow_api.id(632164185083856015.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(632165757692856031.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632163931090856013.4001)
,p_event_id=>wwv_flow_api.id(632164185083856015.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lSpinner$.remove();',
'$("#P109_CHECKSUM_VALUE").focus().select();',
''))
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_api.create_page(
 p_id=>110.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Iconos de fuente APEX'
,p_alias=>'FONT-APEX'
,p_step_title=>'Iconos de fuente APEX'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.iconBuilder = apex.iconBuilder || {};',
'',
'(function( $, iconBuilder ){',
'',
'    iconBuilder.open = function( pIcon ){',
'        var icon = $(pIcon).text();',
'        $s( ''P110_ICONCLASS'', icon );',
'        $("#icon_dialog").dialog({',
'            title: icon,',
'            width: 600,',
'            modal: true,',
'        }).dialog( "open" );',
'        ',
'        iconBuilder.renderIconPreview ( icon );',
'    };',
'',
'    iconBuilder.renderIconPreview = function( ) {',
'        var iconClass = $v( ''P110_ICONCLASS'' );',
'            iconSize = $v(''P110_FA_SIZE'') === ''LARGE'' ? ''fa-lg'' : '''',',
'            iconScale = $v(''P110_ICON_SIZE'') !== ''null'' ? $v(''P110_ICON_SIZE'') : '''',',
'            iconModStatus = $v(''P110_MODIFIER'') ? $v(''P110_MODIFIER_STATUS'') : '''';',
'',
'        var iconModifiers = iconScale +'' ''+ $v(''P110_ANIMATION'') +'' ''+ $v(''P110_ROTATE'') +'' ''+ $v(''P110_MODIFIER'') +'' ''+ iconModStatus +'' ''+ iconSize;',
'        $("#icon_preview span").removeAttr("class").addClass("fa " + iconClass +'' ''+ iconModifiers).attr("aria-hidden","true");',
'        $("#icon_code").text($("#icon_preview").html());',
'        $("#icon_classes").text($("#icon_preview span").attr("class").substr(3));',
'    };',
'',
'    var removeDuplicates = function(){',
'        var ids = [];',
'',
'        $( ".a-CardView-item" ).each(function(){',
'            var card$ = $( this ),',
'                dataId = card$.attr( "data-id" );',
'',
'            if ( ids.includes( dataId ) ) {',
'                card$.remove();',
'            } else {',
'                ids.push( dataId );',
'            }',
'        });',
'    };',
'',
'    $( "#icons" ).on( "tablemodelviewpagechange", function( event, data ) {',
'        removeDuplicates();',
'    } );',
'',
'})( apex.jQuery, apex.iconBuilder );'))
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/font-apex/2.2.1/css/font-apex.min.css'
,p_step_template=>wwv_flow_api.id(438185046231548086.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563231405920439007.4001)
,p_plug_name=>'Buscar'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(563231781790439010.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'10000'
,p_attribute_13=>'Y'
,p_attribute_15=>'10'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563231781790439010.4001)
,p_plug_name=>'Iconos'
,p_region_name=>'icons'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       i.icon_name,',
'       i.icon_filters,',
'       p.column_value as icon_category -- use js to remove duplicates to workaround : delimited categories',
'  from wwv_flow_standard_icons i, table( wwv_flow_string.split( i.icon_category, '':'' ) ) p',
' where icon_library = ''FONTAPEX''',
' order by i.icon_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(563232749835439020.4001)
,p_region_id=>wwv_flow_api.id(563231781790439010.4001)
,p_layout_type=>'GRID'
,p_component_css_classes=>'a-FA-cards'
,p_title_adv_formatting=>false
,p_title_column_name=>'ICON_NAME'
,p_sub_title_adv_formatting=>false
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_icon_source_type=>'DYNAMIC_CLASS'
,p_icon_class_column_name=>'ICON_NAME'
,p_icon_css_classes=>'fa'
,p_icon_position=>'START'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'ID'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(563233179291439024.4001)
,p_card_id=>wwv_flow_api.id(563232749835439020.4001)
,p_action_type=>'FULL_CARD'
,p_display_sequence=>10
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'javascript:void(0);'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563233046477439023.4001)
,p_plug_name=>unistr('Cuadro de di\00E1logo Icono')
,p_region_name=>'icon_dialog'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'js-dialog-autoheight'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563233503304439028.4001)
,p_plug_name=>'Vista previa del icono'
,p_parent_plug_id=>wwv_flow_api.id(563233046477439023.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="icon_preview" class="dm-IconDialog-preview"><span></span></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563233680466439029.4001)
,p_plug_name=>'Formulario Icono'
,p_parent_plug_id=>wwv_flow_api.id(563233046477439023.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(563233788250439030.4001)
,p_plug_name=>'Instrucciones para iconos'
,p_parent_plug_id=>wwv_flow_api.id(563233046477439023.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-IconDialog-info ">',
'    <span class="dm-IconDialog-infoTitle">HTML <button type="button" title="Copy HTML Markup" class="a-Button a-Button--iconTextButton a-Button--withIcon a-Button--gapLeft a-Button--iconLeft a-Button--small" data-clipboard-source="#icon_code"><span a'
||'ria-hidden="true" class="a-Icon icon-copy"></span>Copiar</button></span>',
'    <div class="dm-IconDialog-infoBody">',
'        <code id="icon_code"></code>',
'    </div>',
'</div>',
'<div class="dm-IconDialog-info ">',
'    <span class="dm-IconDialog-infoTitle">Icono <button type="button" title="Copy Icon Class" class="a-Button a-Button--iconTextButton a-Button--withIcon a-Button--gapLeft a-Button--iconLeft a-Button--small" data-clipboard-source="#icon_classes"><spa'
||'n aria-hidden="true" class="a-Icon icon-copy"></span>Copiar</button> </span>',
'    <div class="dm-IconDialog-infoBody">',
'        <code id="icon_classes"></code>',
'        <small>Introduzca la propiedad Icono para los botones, las regiones y otros componentes.</small>',
'    </div>',
'</div>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(830858711838132553.4001)
,p_plug_name=>'Fuente APEX'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Puede usar esta p\00E1gina para buscar los iconos de Fuente APEX.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(563235599368439048.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(563233046477439023.4001)
,p_button_name=>'RESET_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Icono Restablecer'
,p_button_position=>'TOP'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-ig-refresh'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563232590529439018.4001)
,p_name=>'P110_CATEGORY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(563231405920439007.4001)
,p_prompt=>unistr('Categor\00EDa')
,p_source=>'ICON_CATEGORY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'ICON CATEGORIES'
,p_lov=>'.'||wwv_flow_api.id(577691284053554107.4001)||'.'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>false
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>50
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_toggleable=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563232643900439019.4001)
,p_name=>'P110_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(563231405920439007.4001)
,p_prompt=>'Buscar'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>false
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563233855248439031.4001)
,p_name=>'P110_FA_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(563233680466439029.4001)
,p_prompt=>unistr('Tama\00F1o')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ICON SIZE'
,p_lov=>'.'||wwv_flow_api.id(577725423197001069.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563233901508439032.4001)
,p_name=>'P110_ICON_SIZE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(563233680466439029.4001)
,p_item_default=>'null'
,p_prompt=>'Escala'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:1x;null,2x;fa-2x,3x;fa-3x,4x;fa-4x,5x;fa-5x'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563234015219439033.4001)
,p_name=>'P110_ANIMATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(563233680466439029.4001)
,p_prompt=>unistr('Animaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON ANIMATION'
,p_lov=>'.'||wwv_flow_api.id(577722878770995845.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Est\00E1tico')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563234154061439034.4001)
,p_name=>'P110_ROTATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(563233680466439029.4001)
,p_prompt=>'Girar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON ROTATE'
,p_lov=>'.'||wwv_flow_api.id(577740129346133895.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Normal'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563234200520439035.4001)
,p_name=>'P110_MODIFIER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(563233680466439029.4001)
,p_prompt=>'Modificador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON MODIFIER'
,p_lov=>'.'||wwv_flow_api.id(577742586590147796.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguno'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563234393997439036.4001)
,p_name=>'P110_MODIFIER_STATUS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(563233680466439029.4001)
,p_item_default=>'fam-is-success'
,p_prompt=>'Estado'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON MODIFIER STATUS'
,p_lov=>'.'||wwv_flow_api.id(577752611204165565.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563234423454439037.4001)
,p_name=>'P110_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(563231405920439007.4001)
,p_item_default=>'SMALL'
,p_prompt=>'Nuevo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ICON SIZE'
,p_lov=>'.'||wwv_flow_api.id(577725423197001069.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(563235044567439043.4001)
,p_name=>'P110_ICONCLASS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(563233046477439023.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(563233229939439025.4001)
,p_name=>'Open Icon Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.a-CardView-fullLink'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(563233341041439026.4001)
,p_event_id=>wwv_flow_api.id(563233229939439025.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconBuilder.open(this.triggeringElement);'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(563234561203439038.4001)
,p_name=>'Toggle Icon Size'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_SIZE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(563234646070439039.4001)
,p_event_id=>wwv_flow_api.id(563234561203439038.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var size = $v(''P110_SIZE''),',
'    icons$ = $( ''#icons'' ),',
'    L_CLASS = ''force-fa-lg'';',
'if ( size === ''LARGE'' ) {',
'    icons$.addClass( L_CLASS );',
'} else {',
'    icons$.removeClass( L_CLASS );',
'}'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(563235178446439044.4001)
,p_event_id=>wwv_flow_api.id(563234561203439038.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_FA_SIZE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P110_SIZE'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(563234856755439041.4001)
,p_name=>'Apply Modifier to Icon'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_ICON_SIZE,P110_ANIMATION,P110_ROTATE,P110_MODIFIER,P110_MODIFIER_STATUS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(563234991722439042.4001)
,p_event_id=>wwv_flow_api.id(563234856755439041.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconBuilder.renderIconPreview()'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(563235225948439045.4001)
,p_name=>'Set Icon Size'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_FA_SIZE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(563235393135439046.4001)
,p_event_id=>wwv_flow_api.id(563235225948439045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P110_SIZE'',$v(''P110_FA_SIZE''));',
'apex.iconBuilder.renderIconPreview();',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(563235638533439049.4001)
,p_name=>'Reset Icon Settings'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(563235599368439048.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(563235754978439050.4001)
,p_event_id=>wwv_flow_api.id(563235638533439049.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_ANIMATION,P110_ROTATE,P110_MODIFIER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(577766600675741001.4001)
,p_event_id=>wwv_flow_api.id(563235638533439049.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P110_ICON_SIZE'',''null'');',
'apex.iconBuilder.renderIconPreview();'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(577766931804741004.4001)
,p_name=>'Toggle P110_MODIFIER_STATUS'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_MODIFIER'
,p_condition_element=>'P110_MODIFIER'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(577767061631741005.4001)
,p_event_id=>wwv_flow_api.id(577766931804741004.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_MODIFIER_STATUS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(577767193595741006.4001)
,p_event_id=>wwv_flow_api.id(577766931804741004.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_MODIFIER_STATUS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(577767251342741007.4001)
,p_event_id=>wwv_flow_api.id(577766931804741004.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_MODIFIER_STATUS'
);
end;
/
prompt --application/pages/page_00111
begin
wwv_flow_api.create_page(
 p_id=>111.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Informe de total de control de p\00E1gina')
,p_alias=>'PAGE-CHECKSUM-REPORT'
,p_step_title=>unistr('Informe de total de control de p\00E1gina')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Note how generic this code is. The only thing specific to the example is',
'// the name of the menu (ir_context_menu) and the button class (ir-actions-btn).',
'// It could easily be turned into a function and moved to a JavaScript file to',
'// be used from any number of reports.',
'var i, item,',
'    items = $("#mb_context_menu").menu("option").items, ',
'    // for some reason the list options are getting double encoded when referencing application pages so ',
'    // I had to create two sets of regular expressions to make this work.',
'    regLong =  /\\u002524\w+\\u002524/,',
'    regLongG = /\\u002524(\w+)\\u002524/g,',
'    regDollar = /\$\w+\$/,',
'    regDollarG = /\$(\w+)\$/g;',
'',
'// The URLs used in the menu are not complete as is.',
'// They have $attr$ substitution symbols that act as a template. This code',
'// moves decodes the $ symbol and copies the href to hrefTemplate property',
'// so it can be used each time the menu opens',
'for (i = 0; i < items.length; i++) {',
'    item = items[i];',
'    if ( (item.href && regLong.exec(item.href)) || (item.href && regDollar.exec(item.href)) ) {',
'        console.log(item.href);',
'        item.hrefTemplate = item.href;',
'    }',
'}',
'',
'// When the menu opens',
'$("#mb_context_menu").on("menubeforeopen", function(event, data) {',
'    var i, item, disabled,',
'        items = data.menu.items,',
'        // This is how to get the context. Would be nice if the beforeopen',
'        // event could tell you directly what button opened it',
'        context$ = $(".ir-actions-btn.is-active"); ',
'    // for each menu item',
'    for( i = 0; i < items.length; i++ ) {',
'        item = items[i];',
'        item.disabled = false;',
'        // if it has a template href with the long pattern',
'        if (item.hrefTemplate && regLong.exec(item.hrefTemplate)) {',
'            // This replace function will replace all $name$ tokens with the',
'            // value of attribute "data-name" on the context element.',
'            // If a context attribute doesn''t exist then disable the menu item',
'            item.href = item.hrefTemplate.replace(regLongG, function(m, token) {',
'                var data = context$.attr("data-" + token);',
'                //if (data === undefined || data === "") {',
'                //    item.disabled = true;',
'                //}',
'                return data;',
'            });',
'        }',
'        // if it has a template href with the dollar-sign pattern',
'        if (item.hrefTemplate && regDollar.exec(item.hrefTemplate)) {',
'            // This replace function will replace all $name$ tokens with the',
'            // value of attribute "data-name" on the context element.',
'            // If a context attribute doesn''t exist then disable the menu item',
'            item.href = item.hrefTemplate.replace(regDollarG, function(m, token) {',
'                var data = context$.attr("data-" + token);',
'                //if (data === undefined || data === "") {',
'                //    item.disabled = true;',
'                //}',
'                return data;',
'            });',
'        }',
'    }',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.t-Body-inlineDialogs {border: 0;clip: rect(0 0 0 0);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}',
''))
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(610017009942816902.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>El informe de total de control de p\00E1gina ofrece un m\00E9todo sencillo para comparar los despliegues de dos aplicaciones y comprobar qu\00E9 p\00E1ginas son iguales y cu\00E1les diferentes.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(612592719653511854.4001)
,p_plug_name=>'Checksum Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'     id     page,',
'     name   page_name,',
'     lower(alias) alias,',
'     step_title page_title,',
'     group_id,',
'     wwv_flow_export_dev.page_checksum(flow_id,id) checksum,',
'     created_on, ',
'     created_by, ',
'     last_updated_on,',
'     last_updated_by',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(607327911392998416.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se han creado copias de seguridad para la aplicaci\00F3n &FB_FLOW_ID.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'DBLISS'
,p_internal_uid=>607327911392998416
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632166648887856040.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>20
,p_column_identifier=>'AL'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632167578865856049.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>30
,p_column_identifier=>'AU'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632167465092856048.4001)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>40
,p_column_identifier=>'AT'
,p_column_label=>'Grupo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(212924308633451870)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632166766689856041.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>50
,p_column_identifier=>'AM'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632167304338856047.4001)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>60
,p_column_identifier=>'AS'
,p_column_label=>unistr('T\00EDtulo')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632166846425856042.4001)
,p_db_column_name=>'CHECKSUM'
,p_display_order=>70
,p_column_identifier=>'AN'
,p_column_label=>'Total de control'
,p_column_html_expression=>'<code>#CHECKSUM#</code>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632166933922856043.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>80
,p_column_identifier=>'AO'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632167089953856044.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>90
,p_column_identifier=>'AP'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632167130606856045.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>100
,p_column_identifier=>'AQ'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632167276880856046.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>110
,p_column_identifier=>'AR'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(597503865818597508.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(612592719653511854.4001)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:RR,971::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(632167616644856050.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(612592719653511854.4001)
,p_button_name=>'VIEW_APP_CHECKSUM'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Ver total de control de aplicaci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.:109:P109_COMPONENT:APPLICATION'
);
end;
/
prompt --application/pages/page_00112
begin
wwv_flow_api.create_page(
 p_id=>112.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear \00C1rbol: Propietario y Nombre de Tabla/Vista')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44690109510684757.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147804329556743822.4001)
,p_plug_name=>unistr('Crear \00C1rbol')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Este asistente crea un \00E1rbol. Un \00E1rbol es un mecanismo de navegaci\00F3n jer\00E1rquica. Los \00E1rboles se implementan utilizando una consulta jer\00E1rquica \00FAnica que identifica la fila que se utilizar\00E1 como el inicio de la consulta y la relaci\00F3n entre las fila')
||unistr('s principales y secundarias de la jerarqu\00EDa.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147908710995832356.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147901626307825228.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147799819623743799.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44690109510684757.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147800130441743800.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44690109510684757.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279438824306303203.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44690109510684757.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(163005129649785461.4001)
,p_branch_name=>'Go To Page 113'
,p_branch_action=>'114'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(147800130441743800.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (:FB_FLOW_ID,:F4000_P112_PAGE_ID)'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(147801019909743804.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(147800130441743800.4001)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(122192522460995880.4001)
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P112_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549106922379526344.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279438824306303203.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45044608993904708.4001)
,p_name=>'P112_PAGE_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122191513456993258.4001)
,p_name=>'P112_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122194015779001002.4001)
,p_name=>'P112_BREADCRUMB_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'F4000_P112_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148077425450083922.4001)
,p_name=>'F4000_P112_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione la p\00E1gina en la que se debe crear el \00E1rbol.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148083902806094389.4001)
,p_name=>'F4000_P112_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000.P112.TREE_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si el \00E1rbol se va a incluir en una p\00E1gina nueva, introduzca un nombre de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(155944901694792088.4001)
,p_name=>'F4000_P112_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156576025202495003.4001)
,p_name=>'F4000_P112_REGION_TEMPLATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select default_region_template from wwv_flow_themes where flow_id = :fb_flow_id',
'and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una plantilla de regi\00F3n para la regi\00F3n de \00E1rbol.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156578314203500073.4001)
,p_name=>'F4000_P112_REGION_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_item_default=>'initcap(wwv_flow_lang.system_message(''TREE''))'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre para la regi\00F3n que contiene el \00E1rbol.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381757291639463086.4001)
,p_name=>'P112_BREADCRUMB_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P112_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P112_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P112_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403439421971973030.4001)
,p_name=>'P112_GROUP_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(147804329556743822.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(59130704489225382.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P112_PAGE_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940946740165779866.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P112_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165327706012530526.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(148125728851143129.4001)
,p_validation_name=>'page id positive, whole number'
,p_validation_sequence=>10
,p_validation=>'F4000_P112_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(147800130441743800.4001)
,p_associated_item=>wwv_flow_api.id(148077425450083922.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(148130621519146491.4001)
,p_validation_name=>'page name not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P112_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(148083902806094389.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45045104896906563.4001)
,p_validation_name=>'page mode not null'
,p_validation_sequence=>25
,p_validation=>'P112_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(147800130441743800.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(156586512897515880.4001)
,p_validation_name=>'region name not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P112_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de regi\00F3n de \00E1rbol.')
,p_associated_item=>wwv_flow_api.id(156578314203500073.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(80149929751769508.4001)
,p_validation_name=>'PageIdNumeric'
,p_validation_sequence=>50
,p_validation=>'F4000_P112_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La p\00E1gina debe ser num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(147800130441743800.4001)
,p_associated_item=>wwv_flow_api.id(148077425450083922.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(134657119087483318.4001)
,p_validation_name=>'prevent multiple trees on same page'
,p_validation_sequence=>60
,p_validation=>'select 1 from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = :F4000_P112_PAGE_ID and plug_source_type = ''NATIVE_TREE'''
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('S\00F3lo se puede crear un componente de \00E1rbol por p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(148077425450083922.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403439979160974638.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P112_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P112_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(147800130441743800.4001)
,p_associated_item=>wwv_flow_api.id(403439421971973030.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381757497561469252.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P112_BREADCRUMB_ID'
,p_condition_element=>'P112_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381757749690469253.4001)
,p_event_id=>wwv_flow_api.id(381757497561469252.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P112_BREADCRUMB_NAME,P112_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381757914077469253.4001)
,p_event_id=>wwv_flow_api.id(381757497561469252.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P112_BREADCRUMB_NAME,P112_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549106397149523661.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(147799819623743799.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549106652131523661.4001)
,p_event_id=>wwv_flow_api.id(549106397149523661.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1940945444382778966.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P112_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940946346777778968.4001)
,p_event_id=>wwv_flow_api.id(1940945444382778966.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P112_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P112_PAGE_NAME'
,p_attribute_07=>'F4000_P112_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940945826961778968.4001)
,p_event_id=>wwv_flow_api.id(1940945444382778966.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P112_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P112_PAGE_NAME'
,p_attribute_07=>'F4000_P112_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00114
begin
wwv_flow_api.create_page(
 p_id=>114.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear \00C1rbol: Propietario y Nombre de Tabla/Vista')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44696615444714811.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147990930940959787.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147901626307825228.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155982316932876242.4001)
,p_plug_name=>unistr('Crear \00C1rbol')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Seleccione el propietario de la tabla o vista desde donde desea realizar la consulta de \00E1rbol.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147804910693743826.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44696615444714811.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147805231092743826.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44696615444714811.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147805131453743826.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44696615444714811.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(147806622379743832.4001)
,p_branch_action=>'116'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(147805231092743826.4001)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(147806105641743830.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(147805131453743826.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'not wwv_flow_wizard_api.page_exists (:FB_FLOW_ID,:F4000_P112_PAGE_ID)'
,p_branch_condition_text=>'PLSQL'
,p_branch_comment=>'Generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(969051569983554602.4001)
,p_branch_name=>'Goto Page 112'
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(147805131453743826.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12072711292962005.4001)
,p_name=>'P114_TABLE_NAME'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(155982316932876242.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'CREATE TREE FROM TABLE LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P112_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla -'
,p_lov_cascade_parent_items=>'F4000_P112_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione o introduzca el nombre de una tabla o vista en la que se basar\00E1 el \00E1rbol. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(155995802206959006.4001)
,p_name=>'F4000_P112_OWNER'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(155982316932876242.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Propietario -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que se basar\00E1 el \00E1rbol.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156008729329007254.4001)
,p_name=>'F4000_P114_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(155982316932876242.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156012018331012309.4001)
,p_name=>'F4000_P114_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(155982316932876242.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P112_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(156072413160273027.4001)
,p_validation_name=>'table owner not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P112_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el propietario de la tabla.'
,p_associated_item=>wwv_flow_api.id(155995802206959006.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12128302943006931.4001)
,p_validation_name=>'table/view exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_match varchar2(30);',
'begin',
'  l_match := wwv_flow_builder.is_valid_table_or_view',
'    (:F4000_P112_OWNER,:P114_TABLE_NAME);',
'  if l_match = ''E'' then',
'    return true;',
'  elsif l_match = ''U'' then',
'    :P114_TABLE_NAME := upper(:P114_TABLE_NAME);',
'    return true;',
'  else',
'    return false;',
'  end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La tabla &P114_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_when_button_pressed=>wwv_flow_api.id(147805231092743826.4001)
,p_associated_item=>wwv_flow_api.id(12072711292962005.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549109662152547192.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(147804910693743826.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549109978232547193.4001)
,p_event_id=>wwv_flow_api.id(549109662152547192.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12129125677079667.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P112_OWNER is not null and :P114_TABLE_NAME is not null and :P114_TABLE_NAME <> ''0'' then',
'    wwv_flow_sw_api.check_priv_object(',
'        p_application_id => :FB_FLOW_ID,',
'        p_schema         => :F4000_P112_OWNER,',
'        p_object         => :P114_TABLE_NAME);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Esquema no V\00E1lido')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12128714811067078.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate schema'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(:F4000_P112_OWNER);'
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00116
begin
wwv_flow_api.create_page(
 p_id=>116.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear \00C1rbol: Consulta')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44700007048731340.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147809921494743850.4001)
,p_plug_name=>unistr('Crear \00C1rbol')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Un \00E1rbol se basa en una consulta y devuelve datos que se pueden representar en una jerarqu\00EDa. Se utilizar\00E1 una cl\00E1usula <strong>start with .. connect by</strong> para generar la consulta jer\00E1rquica para el \00E1rbol. Utilice esta p\00E1gina para identific')
||unistr('ar la columna que desea utilizar como el identificador, el identificador principal y el texto que deber\00E1 aparecer en los nodos. La columna Empezar por se utilizar\00E1 para especificar la ra\00EDz de la consulta jer\00E1rquica; y su valor se puede basar en un el')
||unistr('emento existente, un valor est\00E1tico o en una consulta SQL que devuelva un valor \00FAnico.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(156104025632312872.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147901626307825228.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484509428411674748.4001)
,p_plug_name=>'Ejemplo de Consulta Empezar por'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>110
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<pre>',
'<strong>''||wwv_flow_lang.system_message(''TREE_EXAMPLES_EXISTING_ITEM'')||'': <i>P1_ID</i></strong>',
'select ENAME as id,',
'       EMPNO as value',
'from EMP',
'start with MGR = :<strong><i>P1_ID</i></strong>',
'connect by prior EMPNO = MGR',
'<br><strong>''||wwv_flow_lang.system_message(''TREE_EXAMPLES_SQL_QUERY'')||'': <i>select empno from emp where ename = ''''KING''''</i></strong>',
'select ENAME as id,',
'       EMPNO as value',
'from EMP',
'start with MGR = (<strong><i>select empno from emp where ename = ''''KING''''</i></strong>)',
'connect by prior EMPNO = MGR',
'<br><strong>''||wwv_flow_lang.system_message(''TREE_EXAMPLES_STATIC_VALUE'')||'': <i>''''KING''''</i></strong>',
'select ENAME as id,',
'       EMPNO as value',
'from EMP',
'start with ENAME = <strong><i>''''KING''''</i></strong>',
'connect by prior EMPNO = MGR',
'<br><strong>''||wwv_flow_lang.system_message(''TREE_EXAMPLES_START_NULL'')||''</strong>',
'select ENAME as id,',
'       EMPNO as value',
'from EMP',
'start with MGR is <strong><i>null</i></strong>',
'connect by prior EMPNO = MGR',
'</pre>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147810530050743852.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44700007048731340.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147810820495743852.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44700007048731340.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147810726015743852.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44700007048731340.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(156698727213998351.4001)
,p_branch_action=>'126'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(147810820495743852.4001)
,p_branch_sequence=>32
,p_branch_condition=>'F4000_P112_LINK_OPTION'
,p_branch_condition_text=>'NOTHING'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(147811709321743856.4001)
,p_branch_action=>'114'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(147810726015743852.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(147810315833743851.4001)
,p_name=>'F4000_P112_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_item_default=>'EMPNO'
,p_prompt=>'Identificador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_PAGE_WIZ_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea utilizar como identificador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 13-DEC-2001 14:16:52'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156121810677410908.4001)
,p_name=>'F4000_P116_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P112_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el propietario del esquema de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156126329427417466.4001)
,p_name=>'F4000_P116_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P114_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el nombre de la tabla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156132310017426426.4001)
,p_name=>'F4000_P112_PID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_item_default=>'MGR'
,p_prompt=>'Identificador Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_PAGE_WIZ_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea utilizar como identificador principal.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(156141410855456406.4001)
,p_name=>'F4000_P112_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_item_default=>'ENAME'
,p_prompt=>'Texto de Nodo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_PAGE_WIZ_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el texto que aparecer\00E1 en los nodos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484457104320128578.4001)
,p_name=>'P116_START_NODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_item_default=>'MGR'
,p_prompt=>'Empezar por'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_PAGE_WIZ_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna que se utilizar\00E1 para especificar la ra\00EDz de la consulta de \00E1rbol jer\00E1rquica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484460803421213485.4001)
,p_name=>'P116_START_TREE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_item_default=>'NULL'
,p_prompt=>unistr('Iniciar \00C1rbol')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'START_TREE'
,p_lov=>'.'||wwv_flow_api.id(84323624609603883.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione la forma en la que desea iniciar la consulta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484469527279267677.4001)
,p_name=>'P116_START_STATIC_VALUE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_prompt=>'Valor de Inicio'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca un valor est\00E1tico que se utilizar\00E1 como el valor ra\00EDz de la columna Empezar por seleccionada. Para definir el valor de inicio en nulo, deje el elemento de texto vac\00EDo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484475730761420023.4001)
,p_name=>'P116_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_prompt=>unistr('Iniciar \00C1rbol seg\00FAn Consulta SQL')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca una consulta SQL que devuelva una sola fila y una sola columna. El valor devuelto se utilizar\00E1 como el valor ra\00EDz de la columna Empezar por seleccionada.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484486510815499413.4001)
,p_name=>'P116_START_ITEM'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(147809921494743850.4001)
,p_prompt=>'Elemento de Inicio'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'ALL ITEMS (PAGE AND APPLICATION)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, name r',
'from wwv_flow_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id',
'union all',
'select name d, name r',
'from wwv_flow_step_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Seleccione un elemento de p\00E1gina o aplicaci\00F3n existente. En el proceso, guarde el valor que se utilizar\00E1 como el valor ra\00EDz de la columna Empezar por.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(487685810656851115.4001)
,p_validation_name=>'Start Tree: SQL'
,p_validation_sequence=>10
,p_validation=>'P116_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar una consulta SQL para el valor del nodo de inicio.'
,p_validation_condition=>'P116_START_TREE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(147810820495743852.4001)
,p_associated_item=>wwv_flow_api.id(484475730761420023.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(503382103399058268.4001)
,p_validation_name=>'Invalid SQL statement'
,p_validation_sequence=>20
,p_validation=>'return wwv_flow_f4000_util.is_valid_start_query(:P116_SQL);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La consulta SQL de Iniciar \00C1rbol no es v\00E1lida. La consulta debe devolver un \00FAnico valor.')
,p_validation_condition=>':P116_SQL IS NOT NULL and :P116_START_TREE = ''SQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(147810820495743852.4001)
,p_associated_item=>wwv_flow_api.id(484475730761420023.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(484472007848309311.4001)
,p_name=>'Static Start Value'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P116_START_TREE'
,p_condition_element=>'P116_START_TREE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484472319527309313.4001)
,p_event_id=>wwv_flow_api.id(484472007848309311.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P116_START_STATIC_VALUE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484472514155309314.4001)
,p_event_id=>wwv_flow_api.id(484472007848309311.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P116_START_STATIC_VALUE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(484477317301444477.4001)
,p_name=>'SQL Start Value'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P116_START_TREE'
,p_condition_element=>'P116_START_TREE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484477622867444478.4001)
,p_event_id=>wwv_flow_api.id(484477317301444477.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P116_SQL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484477805824444479.4001)
,p_event_id=>wwv_flow_api.id(484477317301444477.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P116_SQL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(484505929141627663.4001)
,p_name=>'Item Start Value'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P116_START_TREE'
,p_condition_element=>'P116_START_TREE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484506220993627665.4001)
,p_event_id=>wwv_flow_api.id(484505929141627663.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P116_START_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(484506429048627666.4001)
,p_event_id=>wwv_flow_api.id(484505929141627663.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P116_START_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549110200448550801.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(147810530050743852.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549110513958550802.4001)
,p_event_id=>wwv_flow_api.id(549110200448550801.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(69995424846462837.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Owner'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv_object(',
'    p_application_id => :fb_flow_id,',
'    p_schema => :F4000_P112_OWNER,',
'    p_object => :P114_TABLE_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Esquema no V\00E1lido')
);
end;
/
prompt --application/pages/page_00117
begin
wwv_flow_api.create_page(
 p_id=>117.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Restaurar Suscripci\00F3n a Tema')
,p_step_title=>unistr('Restaurar Suscripci\00F3n a Tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_plug_name=>unistr('Restaurar Suscripci\00F3n a Tema')
,p_region_template_options=>'#DEFAULT#:a-Form-fixedLabelsLarge'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Al restaurar una suscripci\00F3n a un tema, el tema actual se suscribir\00E1 al tema maestro seleccionado y cualquier plantilla con una plantilla correspondiente en el tema maestro (por ejemplo, una plantilla con un identificador o un nombre que coincida ')
||unistr('con los estipulados) se suscribir\00E1 a esa plantilla. Todas las plantillas que no tengan su plantilla correspondiente en el tema maestro se considerar\00E1n plantillas locales.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1433724712373861519.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106512001249472508.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1433724958099861520.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1433725564470861522.4001)
,p_plug_name=>unistr('Restaurar Suscripci\00F3n a Tema')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1433725113968861520.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1433724958099861520.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1433725380623861521.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1433724958099861520.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Restaurar Suscripci\00F3n')
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(932809856659193742.4001)
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1364682539598820103.4001)
,p_name=>'P117_MATCH_BY_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_item_default=>'N'
,p_prompt=>'Plantilla de Coincidencia:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE MATCH'
,p_lov=>'.'||wwv_flow_api.id(1382206179278736769.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se pueden buscar coincidencias con las plantillas por identificador o nombre de plantilla. Se suele preferir la coincidencia por identificador de plantilla, ya que los identificadores no se pueden modificar despu\00E9s de la creaci\00F3n de la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1399864828901453701.4001)
,p_name=>'P117_THEMES_SOURCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_item_default=>'app'
,p_prompt=>'Origen del Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'THEME SOURCE'
,p_lov=>'.'||wwv_flow_api.id(1399872256703479206.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1399864974479453702.4001)
,p_name=>'P117_SHARED_MASTER_THEME_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_prompt=>'Tema Maestro'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, id r from wwv_flow_themes ',
'where ((:P117_THEMES_SOURCE=''oracle'' and security_group_id = 12) or (:P117_THEMES_SOURCE in (''public'',''workspace'') and security_group_id = 11))',
'and ui_type_id in (select ui_type_id from wwv_flow_themes where flow_id = :fb_flow_id and id = :P117_SUBSCRIBING_THEME_ID )',
'and navigation_type in (select navigation_type from wwv_flow_themes where flow_id = :fb_flow_id and id = :P117_SUBSCRIBING_THEME_ID )',
'and ((:P117_THEMES_SOURCE=''oracle'') or (:P117_THEMES_SOURCE=''public'' and theme_security_group_id is null) or (:P117_THEMES_SOURCE=''workspace'' and theme_security_group_id = :flow_security_group_id))',
'order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tema Maestro - '
,p_lov_cascade_parent_items=>'P117_THEMES_SOURCE'
,p_ajax_items_to_submit=>'P117_SUBSCRIBING_THEME_ID,P117_THEMES_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione el tema maestro al que suscribir el tema actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1433723242914861505.4001)
,p_name=>'P117_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1433723779913861514.4001)
,p_name=>'P117_SUBSCRIBING_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_prompt=>unistr('Tema de Suscripci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, id r from wwv_flow_themes where flow_id = :fb_flow_id',
'order by theme_id'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema que desea suscribir a un tema maestro.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1433724276498861515.4001)
,p_name=>'P117_MASTER_THEME_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_prompt=>'Tema Maestro'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, id r from wwv_flow_themes ',
'where flow_id = :P117_MASTER_APP_ID',
'and ui_type_id in (select ui_type_id from wwv_flow_themes where flow_id = :fb_flow_id and id = :P117_SUBSCRIBING_THEME_ID )',
'order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tema Maestro - '
,p_lov_cascade_parent_items=>'P117_MASTER_APP_ID'
,p_ajax_items_to_submit=>'P117_SUBSCRIBING_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Seleccione el tema maestro al que suscribir el tema actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1626110118247726820.4001)
,p_name=>'P117_MASTER_APP_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1433723048148861501.4001)
,p_prompt=>unistr('Aplicaci\00F3n de Tema Maestro')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n de Tema Maestro - ')
,p_lov_cascade_parent_items=>'P117_SUBSCRIBING_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n maestra para la suscripci\00F3n de tema. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1399865675632453709.4001)
,p_validation_name=>'template identifier allowed'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P117_SUBSCRIBING_THEME_ID',
'and theme_internal_name is not null;'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Este tema no permite la coincidencia de plantillas por identificadores de plantilla porque no hay ning\00FAn identificador de plantilla definido.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1399865081780453703.4001)
,p_name=>'Show master theme selection'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P117_THEMES_SOURCE'
,p_condition_element=>'P117_THEMES_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'app'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1399865101159453704.4001)
,p_event_id=>wwv_flow_api.id(1399865081780453703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_MASTER_THEME_ID,P117_MASTER_APP_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1399865255988453705.4001)
,p_event_id=>wwv_flow_api.id(1399865081780453703.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_SHARED_MASTER_THEME_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1399865399490453706.4001)
,p_event_id=>wwv_flow_api.id(1399865081780453703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_SHARED_MASTER_THEME_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1399865462192453707.4001)
,p_event_id=>wwv_flow_api.id(1399865081780453703.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_MASTER_THEME_ID,P117_MASTER_APP_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932809935794193743.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'resubscribe theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_master_theme_id number;',
'    ',
'begin',
'',
'    if :P117_THEMES_SOURCE = ''app'' then',
'        l_master_theme_id := :P117_MASTER_THEME_ID;',
'    else',
'        l_master_theme_id := :P117_SHARED_MASTER_THEME_ID;',
'    end if;',
'    ',
'',
'    -- map theme and template references by name',
'    wwv_flow_copy_metadata.resubscribe_theme(',
'        p_master_theme_id      => l_master_theme_id,',
'        p_subscribing_theme_id => :P117_SUBSCRIBING_THEME_ID,',
'        p_match_by_name        => :P117_MATCH_BY_NAME',
'    );',
'',
'    -- refresh theme and templates from master',
'    wwv_flow_copy_metadata.subscribe_theme (',
'        p_master_theme_id      => l_master_theme_id,',
'        p_subscribing_theme_id => :P117_SUBSCRIBING_THEME_ID',
'    );',
'    ',
'end;    '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suscribirse al tema: #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1433725380623861521.4001)
,p_process_success_message=>unistr('Suscripci\00F3n correcta al tema ')
);
end;
/
prompt --application/pages/page_00118
begin
wwv_flow_api.create_page(
 p_id=>118.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editor de Archivos'
,p_alias=>'FILE-EDITOR'
,p_step_title=>'Editor de Archivos'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p118#MIN#.js'
,p_javascript_code_onload=>'fileEditor.initPage();'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4501448736515812.4001)
,p_plug_name=>'Origen'
,p_region_name=>'editor'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>4
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- get contents as base64 to avoid db-charser-related data corruption',
'-- conversion to back to plain text happens in javascript',
'select wwv_flow_file_editor_dev.get_file_as_base64 (',
'    p_id        => :P118_ID,',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID ) as content',
'  from sys.dual'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P118_ID is not null and :P118_IS_EDITABLE = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(editorOptions){',
'    return fileEditor.configureEditor(editorOptions);',
'}'))
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'AUTO'
,p_attribute_03=>'N'
,p_attribute_06=>'P118_LANGUAGE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4503346701515831.4001)
,p_plug_name=>'Detalles de Archivo'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18703871381360909.4001)
,p_plug_name=>'Archivo minimizado'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Est\00E1 intentando editar un archivo ya minimizado. Edite el archivo base en su lugar.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P118_ID is not null and (:P118_NAME like ''%.min.js'' or :P118_NAME like ''%.min.css'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(43903163431919823.4001)
,p_plug_name=>'&P118_NAME_ORIGINAL!HTML.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_07'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46330642508795914.4001)
,p_plug_name=>'UTF-8'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Solo se pueden editar los contenidos de los archivos codificados en UTF-8.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P118_ID       is not null and',
':P118_LANGUAGE is not null and',
':P118_IS_EDITABLE = ''N'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(66318979344810579.4001)
,p_plug_name=>'Crear un nuevo archivo'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Cargue un archivo ya existente o cree uno en blanco introduciendo un nombre (por ejemplo, script.js).</p>'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_plug_query_break_cols=>'1'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P118_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(137232781242518009.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(43903163431919823.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'&P118_RETURN_TO_URL.'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14705596924332836.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(43903163431919823.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14705888105332839.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(43903163431919823.4001)
,p_button_name=>'CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14705356502332834.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(43903163431919823.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14706575909332846.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(43903163431919823.4001)
,p_button_name=>'SAVE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar cambios'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:$(''body'').trigger(''SAVE'');'
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18704022972360911.4001)
,p_branch_name=>'Create - Then Edit File'
,p_branch_action=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_ID,P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,P118_THEME_ID:&P118_ID.,&P118_SCOPE.,&P118_APP_ID.,&P118_PLUGIN_ID.,&P118_THEME_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(14705356502332834.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14706111347332842.4001)
,p_branch_name=>'Create and Create Another - Refresh'
,p_branch_action=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,P118_THEME_ID:&P118_SCOPE.,&P118_APP_ID.,&P118_PLUGIN_ID.,&P118_THEME_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(14705888105332839.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14706420184332845.4001)
,p_branch_name=>'Delete - APP'
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.::FB_FLOW_ID:&P118_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''APP'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4902765799807725.4001)
,p_branch_name=>'Delete - WORKSPACE'
,p_branch_action=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''WORKSPACE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4902950564807727.4001)
,p_branch_name=>'Delete - PLUGIN'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.::FB_FLOW_ID,P4410_ID:&P118_APP_ID.,&P118_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''PLUGIN'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4903048708807728.4001)
,p_branch_name=>'Delete - THEME'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''THEME'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3570122062979643.4001)
,p_name=>'P118_NAME_ORIGINAL'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4501019631515808.4001)
,p_name=>'P118_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4501120989515809.4001)
,p_name=>'P118_SCOPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4501366668515811.4001)
,p_name=>'P118_LANGUAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4504108365515839.4001)
,p_name=>'P118_CONTENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_prompt=>'Contenido'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_tag_attributes=>'data-show-progress="true"'
,p_display_when=>'P118_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Archivos para cargar.'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'Y'
,p_attribute_12=>'DROPZONE_INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6412366580218605.4001)
,p_name=>'P118_LAST_MOD'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.get_file_last_modified (',
'    p_id        => :P118_ID,',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P118_IS_EDITABLE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14702647126332807.4001)
,p_name=>'P118_MIME_TYPE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_prompt=>'Tipo MIME'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P118_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'El tipo MIME del archivo'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14702737423332808.4001)
,p_name=>'P118_CHARSET'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Caracteres de Archivo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cHeight=>1
,p_read_only_when=>'P118_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indica la codificaci\00F3n del juego de caracteres del archivo. Cuando se carga el archivo, este atributo solo se aplica a los archivos de texto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14703326440332814.4001)
,p_name=>'P118_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_prompt=>'Nombre de Archivo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre del archivo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14705086813332831.4001)
,p_name=>'P118_APP_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14705167063332832.4001)
,p_name=>'P118_PLUGIN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14705285341332833.4001)
,p_name=>'P118_THEME_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17602186898203758.4001)
,p_name=>'P118_UNZIP'
,p_is_required=>true
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_prompt=>'Descomprimir Archivo'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Si selecciona <strong>Activado</strong>, el archivo zip cargado se descomprime autom\00E1ticamente y se almacena en el directorio especificado. Tenga en cuenta que el archivo zip como tal no se almacena.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17802337393434799.4001)
,p_name=>'P118_DIRECTORY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_prompt=>'Directorio'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, ',
'       column_value r',
'  from table( wwv_flow_file_editor_dev.get_directories(',
'        p_scope     => :P118_SCOPE,',
'        p_app_id    => :P118_APP_ID,',
'        p_plugin_id => :P118_PLUGIN_ID,',
'        p_theme_id  => :P118_THEME_ID ))',
' order by column_value'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Ra\00EDz')
,p_cSize=>40
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del directorio en el que se debe almacenar el archivo. Si no se especifica ning\00FAn directorio, el archivo se almacenar\00E1 en el directorio ra\00EDz.</p>'),
'<p>Ejemplos:',
'<ul>',
'<li>css</li>',
'<li>css/images</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18703023552360901.4001)
,p_name=>'P118_REFERENCE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Referencia'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--small a-Button--simple" id="copy_ref_btn" type="button" title="&"APP_TEXT$APEX.IG.COPY_CB".">',
'    <span class="a-Icon icon-copy"></span>',
'</button>'))
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.get_file_reference (',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID,',
'    p_file_name => :P118_NAME_ORIGINAL )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P118_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18703290019360903.4001)
,p_name=>'P118_CONTENT_IMAGE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_prompt=>'Imagen'
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_tag_attributes=>'style="max-width: 100%;"'
,p_display_when=>'lower(:P118_MIME_TYPE) like ''image/%'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Contenido de imagen del archivo.'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content as image,',
'       file_name    as alt_text,',
'       file_name    as filename,',
'       mime_type    as mimetype',
'  from (',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_static_files',
'         where :P118_SCOPE = ''APP''',
'           and flow_id     = :P118_APP_ID',
'',
'         union all',
'',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_company_static_files',
'         where :P118_SCOPE = ''WORKSPACE''',
'',
'         union all',
'',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_plugin_files',
'         where :P118_SCOPE = ''PLUGIN''',
'           and flow_id     = :P118_APP_ID',
'           and plugin_id   = :P118_PLUGIN_ID',
'',
'         union all',
'',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_theme_files',
'         where :P118_SCOPE = ''THEME''',
'           and flow_id     = :P118_APP_ID',
'           and theme_id    = :P118_THEME_ID',
'       )',
' where security_group_id = :WORKSPACE_ID',
'   and id                = :P118_ID;'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46330382557795911.4001)
,p_name=>'P118_IS_EDITABLE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137232870920518010.4001)
,p_name=>'P118_RETURN_TO_URL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4503346701515831.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3570559038979647.4001)
,p_computation_sequence=>10
,p_computation_item=>'P118_DIRECTORY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_file_api.clean_dirname(:P118_DIRECTORY)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3570656389979648.4001)
,p_computation_sequence=>20
,p_computation_item=>'P118_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_file_api.get_file_name(:P118_DIRECTORY, :P118_NAME)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18703480055360905.4001)
,p_validation_name=>'Create Empty File - Name must be provided'
,p_validation_sequence=>10
,p_validation=>'P118_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'&"APP_TEXT$FILE_EDITOR.NAME_EMPTY".'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(14703326440332814.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3570867559979650.4001)
,p_validation_name=>'Create Empty File - File name must contain an extension'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_string_util.get_file_extension(:P118_NAME) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nombre de archivo debe contener una extensi\00F3n')
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(14703326440332814.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18706265474360933.4001)
,p_validation_name=>'Create Empty File - Extension must be allowed'
,p_validation_sequence=>30
,p_validation=>'wwv_flow_string_util.get_file_extension(:P118_NAME) in (''js'', ''css'', ''html'', ''json'', ''less'', ''xml'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Los archivos vac\00EDos deben ser uno de los siguientes: js, css, html, json, less, xml')
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(14703326440332814.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18706107999360932.4001)
,p_validation_name=>'Create Empty File - Name must be unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_file_editor_dev.file_name_is_taken (',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID,',
'    p_name      => :P118_NAME,',
'    p_ignore_id => :P118_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&"APP_TEXT$FILE_EDITOR.NAME_TAKEN".'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(14703326440332814.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78409105978861207.4001)
,p_validation_name=>'Create/Edit - File name <= 255 characters'
,p_validation_sequence=>50
,p_validation=>'lengthb( :P118_NAME ) <= 255'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&"APP_TEXT$FILE_EDITOR.NAME_TOO_LONG".'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4504721218515845.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- creates an empty file if p_content is not provided',
'-- or loads the uploaded file named by p_content',
':P118_ID := wwv_flow_file_editor_dev.create_file (',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID,',
'    p_name      => :P118_NAME,',
'    p_directory => :P118_DIRECTORY,',
'    p_content   => :P118_CONTENT,',
'    p_unzip     => :P118_UNZIP,',
'    p_charset   => :P118_CHARSET );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Archivo(s) creado(s)'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4904033233807738.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.update_file_name (',
'    p_id        => :P118_ID,',
'    p_name      => :P118_NAME,',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'UPDATE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4904175075807739.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update - Dummy'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- dummy process to show page success and reset page state',
'-- when an editable file has been renamed',
'null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'UPDATE_DUMMY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Se han guardado los cambios'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3568285912979624.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.delete_file (',
'    p_id               => :P118_ID,',
'    p_scope            => :P118_SCOPE,',
'    p_app_id           => :P118_APP_ID,',
'    p_plugin_id        => :P118_PLUGIN_ID,',
'    p_theme_id         => :P118_THEME_ID,',
'    p_delete_artifacts => true );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4502211707515820.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- performs sanity checks, populates items, loads needed libraries and text messages',
'wwv_flow_file_editor_dev.init_page (',
'    -- scope',
'    p_scope             => :P118_SCOPE,',
'    p_app_id            => :P118_APP_ID,',
'    p_plugin_id         => :P118_PLUGIN_ID,',
'    p_theme_id          => :P118_THEME_ID,',
'    p_id                => :P118_ID,',
'    -- items',
'    p_out_directory     => :P118_DIRECTORY,',
'    p_out_name          => :P118_NAME,',
'    p_out_name_original => :P118_NAME_ORIGINAL,',
'    p_out_mime_type     => :P118_MIME_TYPE,',
'    p_out_charset       => :P118_CHARSET,',
'    p_out_language      => :P118_LANGUAGE,',
'    p_out_is_editable   => :P118_IS_EDITABLE,',
'    p_out_return_to_url => :P118_RETURN_TO_URL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4501761426515815.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAVE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- saves and writes back status via apex_json',
'wwv_flow_file_editor_dev.save_ajax (',
'    p_id            => :P118_ID,',
'    p_scope         => :P118_SCOPE,',
'    p_app_id        => :P118_APP_ID,',
'    p_plugin_id     => :P118_PLUGIN_ID,',
'    p_theme_id      => :P118_THEME_ID,',
'',
'    p_file_1        => wwv_flow.g_f01,',
'    p_file_1_name   => wwv_flow.g_x01,',
'    p_file_2        => wwv_flow.g_f02,',
'    p_file_2_name   => wwv_flow.g_x02,',
'    p_file_3        => wwv_flow.g_f03,',
'    p_file_3_name   => wwv_flow.g_x03,',
'',
'    p_last_mod      => :P118_LAST_MOD,',
'    p_name_original => :P118_NAME_ORIGINAL );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00119
begin
wwv_flow_api.create_page(
 p_id=>119.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Control de Acceso'
,p_step_title=>'Control de Acceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(488391710691971044)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.wsACLTable {',
'  border-left:1px solid #cccccc;',
'  border-top:1px solid #cccccc;',
'}',
'.wsACLTable th {',
'  border-right:1px solid #cccccc;',
'  border-bottom:1px solid #cccccc;',
'  padding:4px;',
'}',
'.wsACLTable td {',
'  border-right:1px solid #cccccc;',
'  border-bottom:1px solid #cccccc;',
'  padding:4px;',
'}',
'</style>'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628479127831219789.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628483621434294817.4001)
,p_plug_name=>'Control de Acceso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628479310128219790.4001)
,p_plug_name=>'acl table'
,p_parent_plug_id=>wwv_flow_api.id(628483621434294817.4001)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p>''||wwv_flow_ws_api.get_acl_table||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628483014723283380.4001)
,p_plug_name=>'Intro Text'
,p_parent_plug_id=>wwv_flow_api.id(628483621434294817.4001)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p>''||wwv_flow_lang.system_message(''ACL_TABLE.INTRO_TEXT'')||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(628480212206225986.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(628479127831219789.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(628480418439227763.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Window'
,p_process_when_button_id=>wwv_flow_api.id(628480212206225986.4001)
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_api.create_page(
 p_id=>120.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar plantilla de correo electr\00F3nico')
,p_alias=>'COPY-EMAIL-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar plantilla de correo electr\00F3nico')
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'750'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2200811737471405.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5280359035337706.4001)
,p_plug_name=>unistr('Copiar plantilla de correo electr\00F3nico')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3900773948149484.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2200811737471405.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3901147747149485.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2200811737471405.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar plantilla de correo electr\00F3nico')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4700769082957403.4001)
,p_branch_name=>'Show Copied Email Template'
,p_branch_action=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:4861:F4000_P4861_ID:&P120_COPY_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3901147747149485.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3901552512149488.4001)
,p_name=>'P120_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5280359035337706.4001)
,p_item_default=>'THIS'
,p_prompt=>'Copiar de'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COPY_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(9000141896148406.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Decida si se va a copiar la plantilla de correo electr\00F3nico desde esta u otra aplicaci\00F3n.')
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3902489863149492.4001)
,p_name=>'P120_FROM_APPLICATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5280359035337706.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde donde se va a copiar la plantilla de correo electr\00F3nico.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3903376734149493.4001)
,p_name=>'P120_FROM_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5280359035337706.4001)
,p_prompt=>unistr('Copiar plantilla de correo electr\00F3nico')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ||'' ( ''||static_id||'' )'' d,',
'       id r',
'  from wwv_flow_email_templates',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :P120_FROM_APPLICATION_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P120_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una plantilla de correo electr\00F3nico para copiar.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Ideally we should use "Popup LOV" item here, but we can''t use it because of accessibility bug 31676267. This bug makes Popup LOV item unusable on modal pages.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3904222911149494.4001)
,p_name=>'P120_COPY_NEW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5280359035337706.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3904640810149494.4001)
,p_name=>'P120_COPY_NEW_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5280359035337706.4001)
,p_prompt=>'Nombre Nuevo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>unistr('Proporcione un nombre para la plantilla de correo electr\00F3nico copiada.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3905522938149494.4001)
,p_name=>'P120_COPY_NEW_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(5280359035337706.4001)
,p_prompt=>unistr('Nuevo identificador est\00E1tico')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione un identificador est\00E1tico \00FAnico para la plantilla de correo electr\00F3nico copiada.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7801372789142419.4001)
,p_validation_name=>'P120_COPY_NEW_STATIC_ID must be Unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_email_templates',
' where static_id         = upper( :P120_COPY_NEW_STATIC_ID )',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otra plantilla de correo electr\00F3nico ya est\00E1 utilizando #LABEL#.')
,p_when_button_pressed=>wwv_flow_api.id(3901147747149485.4001)
,p_associated_item=>wwv_flow_api.id(3905522938149494.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7801645844143964.4001)
,p_validation_name=>'P120_COPY_NEW_STATIC_ID is alphanumeric'
,p_validation_sequence=>50
,p_validation=>'P120_COPY_NEW_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('#LABEL# solo puede contener caracteres alfanum\00E9ricos y "_".')
,p_when_button_pressed=>wwv_flow_api.id(3901147747149485.4001)
,p_associated_item=>wwv_flow_api.id(3905522938149494.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4100380995166583.4001)
,p_name=>'Toggle P120_FROM_APPLICATION_ID'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_COPY_SOURCE'
,p_condition_element=>'P120_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4100717337166607.4001)
,p_event_id=>wwv_flow_api.id(4100380995166583.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_FROM_APPLICATION_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4101194530166607.4001)
,p_event_id=>wwv_flow_api.id(4100380995166583.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_FROM_APPLICATION_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4101620981166607.4001)
,p_event_id=>wwv_flow_api.id(4100380995166583.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_FROM_APPLICATION_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'&FB_FLOW_ID.'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4102180875166607.4001)
,p_event_id=>wwv_flow_api.id(4100380995166583.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_FROM_APPLICATION_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2201215533471409.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3900773948149484.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2201316123471410.4001)
,p_event_id=>wwv_flow_api.id(2201215533471409.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7800336189137481.4001)
,p_name=>'Update Static ID'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_COPY_NEW_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7800730418137501.4001)
,p_event_id=>wwv_flow_api.id(7800336189137481.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_COPY_NEW_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P120_COPY_NEW_NAME'').replace(/\s+/g, ''_'')'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4700628395957402.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Email Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P120_COPY_NEW_ID := wwv_flow_mail_dev.copy_email_template (',
'    p_id                  => :P120_FROM_ID,',
'    p_to_name             => :P120_COPY_NEW_NAME,',
'    p_to_static_id        => :P120_COPY_NEW_STATIC_ID,',
'    p_to_application_id   => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3901147747149485.4001)
,p_process_success_message=>unistr('Se ha copiado la plantilla de correo electr\00F3nico.')
);
end;
/
prompt --application/pages/page_00122
begin
wwv_flow_api.create_page(
 p_id=>122.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Calendario'
,p_step_title=>'Editar Plantilla de Calendario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16891607435128742.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12991522578387911.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18452530451155428.4001)
,p_plug_name=>unistr('Formato de Visualizaci\00F3n de Datos')
,p_region_name=>'DATA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>620
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18877709410714380.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18886121578746206.4001)
,p_plug_name=>'Plantilla de Calendario'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18886415062746206.4001)
,p_plug_name=>unistr('Suscripci\00F3n de Plantilla')
,p_region_name=>'SUB'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i number := null;',
'  c number := 0;',
'begin',
'for c1 in (select reference_id ',
'           from wwv_flow_cal_templates ',
'           where id = :P122_ID) loop',
'   i := c1.reference_id;',
'end loop;',
'',
'if i is not null then',
'  for c1 in (select flow_id, name ',
'             from wwv_flow_cal_templates',
'             where  id = i',
'             and security_group_id = wwv_flow_security.g_security_group_id) loop',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P204_COPIED_FROM_APP'')||'': ''|| ',
'    c1.flow_id||'', ''||wwv_flow_escape.html(c1.name)||''</div>'');',
'  end loop;',
'else',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P204_MASTER_COPY'')||''</div>'');',
'end if;',
'',
'for c1 in (select flow_id, name ',
'           from wwv_flow_cal_templates ',
'           where reference_id = :P122_ID',
'           and security_group_id = wwv_flow_security.g_security_group_id) loop',
'   c := c + 1;',
'   if c = 1 then',
'      sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P122_CAL_TEMPL'')||'': </div><ul>'');',
'   end if;',
'   sys.htp.p(''<li> ''||c1.flow_id||'' - ''|| wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'  sys.htp.p(''</ul>'');',
'if c = 0 then',
'   if i is not null then',
'      sys.htp.p(''<br />'');',
'   end if;',
'   sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P204_NO_SUBSCIRBERS'')||''</div>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18921417890029022.4001)
,p_plug_name=>'Formatos de Mes'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18921727767029023.4001)
,p_plug_name=>'Formatos de Semana'
,p_region_name=>'WEEK'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>310
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18922128903029024.4001)
,p_plug_name=>unistr('Formatos de D\00EDa de la Semana')
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18922517182029025.4001)
,p_plug_name=>unistr('Formatos de D\00EDa del Mes Anterior')
,p_region_name=>'NON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18922910505029025.4001)
,p_plug_name=>'Formatos de Fin de Semana'
,p_region_name=>'END'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>610
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18971803326223540.4001)
,p_plug_name=>'Plantillas de Calendario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de calendario controlan el aspecto y colocaci\00F3n de un calendario. Estas plantillas utilizan las tablas HTML frecuentemente para organizar las fechas.</p>'),
unistr('<p>Puede colocar los atributos de calendario utilizando cadenas de sustituci\00F3n como #DD# y #MONTH#. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).</p>')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46166630604774866.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(234115915333599671.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>710
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n de formato de fecha:</p>'),
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>TIME</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'<li>FMHH</li>',
'<li>FMMI</li>',
'</ul>',
unistr('<p>Si coloca "I" delante de cualquier cadena, el texto tendr\00E1 may\00FAscula inicial.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38642223341465708.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(18886415062746206.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'BOTTOM'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates',
'where id = :P122_ID',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38642928882467332.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(18886415062746206.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P122_ID.,&FLOW_PAGE_ID.,CALENDAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates',
'where reference_id = :P122_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(285855120692624393.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(285855023241624393.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18849830415687048.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18850126609687048.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P122_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18850014025687048.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(285865727582624447.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P122_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(285855023241624393.4001)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(285866118421624451.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P122_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(285855120692624393.4001)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(358388523833432008.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(38642223341465708.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17311115223820625.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>32
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17928410687201254.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>34
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30771031569845440.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22188331038173394.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>38
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3709923113259480.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>48
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18986200649279586.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P122_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18993421820314018.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>139
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18851818152687065.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18454005779167197.4001)
,p_name=>'P122_MONTH_DATA_FORMAT'
,p_item_sequence=>118
,p_item_plug_id=>wwv_flow_api.id(18452530451155428.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura/Cierre de Datos'
,p_source=>'MONTH_DATA_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para que se muestren los datos del calendario juntos en una celda individual. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". #DAYS# se sustituir\00E1 por filas de datos.'),
'',
'Por ejemplo: ',
'<ul>',
'#DAYS#',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18454924825172784.4001)
,p_name=>'P122_MONTH_DATA_ENTRY_FORMAT'
,p_item_sequence=>128
,p_item_plug_id=>wwv_flow_api.id(18452530451155428.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Datos'
,p_source=>'MONTH_DATA_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para saber c\00F3mo se mostrar\00E1n los datos del calendario de forma individual. '),
unistr('Incluya cadenas de sustituci\00F3n para incorporar contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". #DATA# se utiliza para sustituir los datos del calendario real.'),
'',
'Por ejemplo: ',
'<li>',
'#DATA#',
'</li>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18852208962687070.4001)
,p_name=>'P122_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_api.id(18886121578746206.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18852606345687082.4001)
,p_name=>'P122_NAME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(18886121578746206.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define un nombre que identifica la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18853415396687087.4001)
,p_name=>'P122_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_api.id(18886121578746206.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_cSize=>2
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18853814896687088.4001)
,p_name=>'P122_MONTH_TITLE_FORMAT'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_api.id(18921417890029022.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Mes')
,p_source=>'MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para el t\00EDtulo mensual que aparece en la parte superior de cada mes. \00C9sta es la primera parte de un calendario que se imprime en la p\00E1gina. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18854220278687090.4001)
,p_name=>'P122_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_api.id(18921417890029022.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de D\00EDa de la Semana')
,p_source=>'DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18854608281687091.4001)
,p_name=>'P122_MONTH_OPEN_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18921417890029022.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Mes'
,p_source=>'MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un mes. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18855009923687092.4001)
,p_name=>'P122_MONTH_CLOSE_FORMAT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(18921417890029022.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Mes'
,p_source=>'MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un mes. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en el "Formato de Apertura de Mes".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18855424509687093.4001)
,p_name=>'P122_DAY_TITLE_FORMAT'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa')
,p_source=>'DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para el t\00EDtulo del d\00EDa, que es lo primero que se imprime detr\00E1s del "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18855816337687094.4001)
,p_name=>'P122_DAY_OPEN_FORMAT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Apertura de D\00EDa')
,p_source=>'DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime para cada d\00EDa. Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incorporar contenido din\00E1mico. Consulte la lista comple')
||unistr('ta en "Cadenas de Sustituci\00F3n". Al incluir #DATA# se sustituye el valor del atributo de formato de datos, se debe utilizar #DATA# para visualizar los datos del calendario. Por ejemplo:'),
'<pre>',
' &lt;td&gt;#DATA#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18856206615687095.4001)
,p_name=>'P122_DAY_CLOSE_FORMAT'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Cierre de D\00EDa')
,p_source=>'DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de D\00EDa".'),
unistr('Incluya cadenas de sustituci\00F3n para incorporar contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Al incluir #DATA# se sustituye el valor del atributo de formato de datos, se debe utilizar #DATA# para visualizar los datos del')
||' calendario. ',
'',
'Por ejemplo: ',
'<pre>',
'  #DATA#&lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18856610273687096.4001)
,p_name=>'P122_TODAY_OPEN_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hoy'
,p_source=>'TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir la fecha actual. Normalmente se trata de una etiqueta HTML que es un contenedor, como un td, y que no coincide exactamente con "Formato de Apertura de D\00EDa". Incluya cadenas de sustituci\00F3n para incorporar')
||unistr(' contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Al incluir #DATA# se sustituye el valor del atributo de formato de datos, se debe utilizar #DATA# para visualizar los datos del calendario. Por ejemplo:'),
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;#DATA#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18857024534687097.4001)
,p_name=>'P122_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_api.id(18922910505029025.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Fin de Semana')
,p_source=>'WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para un d\00EDa de fin de semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18857425215687099.4001)
,p_name=>'P122_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_api.id(18922910505029025.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Fin de Semana'
,p_source=>'WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa de fin de semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como TD. Incluya cadenas de sustituci\00F3n para incorporar contenido din\00E1mico. Consulte la lista completa en "Cadenas')
||unistr(' de Sustituci\00F3n". Al incluir #DATA# se sustituye el valor del atributo de formato de datos, se debe utilizar #DATA# para visualizar los datos del calendario. Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18857706167687100.4001)
,p_name=>'P122_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_api.id(18922910505029025.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Fin de Semana'
,p_source=>'WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa de fin de semana. \00C9ste es el \00FAltimo elemento de cada fin de semana que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Format')
||'o de Apertura de Fin de Semana"',
unistr('Incluya cadenas de sustituci\00F3n para incorporar contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Al incluir #DATA# se sustituye el valor del atributo de formato de datos, se debe utilizar #DATA# para visualizar los datos del')
||' calendario. ',
'',
'Por ejemplo: ',
'<pre>',
'  #DATA# &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18858119260687101.4001)
,p_name=>'P122_NONDAY_TITLE_FORMAT'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(18922517182029025.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa del Mes Anterior')
,p_source=>'NONDAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para formatear el t\00EDtulo de un d\00EDa del mes anterior. Por ejemplo, el primer d\00EDa de un mes es un lunes, pero la semana empieza en domingo. Como domingo no pertenece al mes actual, domingo ser\00EDa un d\00EDa del mes anteri')
||'or.',
unistr('<p> Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  #DD#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18858508945687102.4001)
,p_name=>'P122_NONDAY_OPEN_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18922517182029025.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Apertura de D\00EDa del Mes Anterior')
,p_source=>'NONDAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML para abrir un d\00EDa del mes anterior. Por ejemplo, el primer d\00EDa de un mes es un lunes, pero la semana empieza en domingo. Como domingo no pertenece al mes actual, domingo ser\00EDa un d\00EDa del mes anterior.'),
'',
unistr('<p>Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18858918031687103.4001)
,p_name=>'P122_NONDAY_CLOSE_FORMAT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(18922517182029025.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Cierre de D\00EDa del Mes Anterior')
,p_source=>'NONDAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que cerrar\00E1 un d\00EDa del mes anterior. Por ejemplo, cuando el primer d\00EDa de un mes es un lunes y la semana empieza en domingo, domingo no tendr\00EDa una fecha en el mes actual y por tanto ser\00EDa un d\00EDa del mes anterior.'),
unistr('<p>Normalmente se trata de una etiqueta HTML que cierra la etiqueta utilizada en "Formato de Apertura de D\00EDa del Mes Anterior".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18859319271687104.4001)
,p_name=>'P122_WEEK_TITLE_FORMAT'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(18921727767029023.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Semana')
,p_source=>'WEEK_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se imprimir\00E1 como t\00EDtulo de un calendario de vista semanal.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18859723762687105.4001)
,p_name=>'P122_WEEK_OPEN_FORMAT'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(18921727767029023.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Semana'
,p_source=>'WEEK_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir una semana. \00C9ste se imprime para cada semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como tr. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista co')
||unistr('mpleta en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18860129599687106.4001)
,p_name=>'P122_WEEK_CLOSE_FORMAT'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_api.id(18921727767029023.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Semana'
,p_source=>'WEEK_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una semana. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de Semana".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18860511605687107.4001)
,p_name=>'P122_DAILY_TITLE_FORMAT'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo Diario')
,p_source=>'DAILY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 como t\00EDtulo de un calendario de vista diaria.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18860929357687108.4001)
,p_name=>'P122_DAILY_OPEN_FORMAT'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura Diario'
,p_source=>'DAILY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa en un calendario de vista diaria.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18861304283687108.4001)
,p_name=>'P122_DAILY_CLOSE_FORMAT'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(18922128903029024.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre Diario'
,p_source=>'DAILY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa en un calendario de vista diaria.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18861717044687109.4001)
,p_name=>'P122_REFERENCE_ID'
,p_item_sequence=>28
,p_item_plug_id=>wwv_flow_api.id(18886415062746206.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Etiqueta Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_CAL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, 0 r from dual',
'union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_cal_templates',
'where flow_id != nvl(:fb_flow_id,0) and flow_id in (',
' select f.id',
' from   wwv_flows f',
' where  security_group_id = :flow_security_group_id',
'  and  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'  and  exists (',
'   select 1 ',
'   from wwv_flow_developers',
'   where userid = :flow_user ',
'     and (flow_id is null or flow_id = f.id)',
'     and security_group_id = :flow_security_group_id)',
')',
''))
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18983103635270949.4001)
,p_name=>'P122_STAY'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_api.id(18971803326223540.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38641001178459260.4001)
,p_name=>'P122_REFRESH'
,p_item_sequence=>48
,p_item_plug_id=>wwv_flow_api.id(18886415062746206.4001)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates',
'where reference_id is null',
'and id = :P122_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43597419749729663.4001)
,p_name=>'P122_THEME_ID'
,p_item_sequence=>58
,p_item_plug_id=>wwv_flow_api.id(18886121578746206.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43624130644969418.4001)
,p_name=>'P122_THEME_CLASS_ID'
,p_item_sequence=>68
,p_item_plug_id=>wwv_flow_api.id(18886121578746206.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(285863528641624431.4001)
,p_name=>'P122_ID_NEXT'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_prompt=>'P122_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(285863927865624433.4001)
,p_name=>'P122_ID_PREV'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_prompt=>'P122_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(285864329438624435.4001)
,p_name=>'P122_ID_COUNT'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_api.id(18877709410714380.4001)
,p_prompt=>'Plantilla de Calendario: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(146914813480910295.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P122_THEME_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397289523641382309.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P122_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397289811293382310.4001)
,p_event_id=>wwv_flow_api.id(397289523641382309.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(285855120692624393.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397289929874384084.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P122_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397290229849384084.4001)
,p_event_id=>wwv_flow_api.id(397289929874384084.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(285855023241624393.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18862218917687113.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P122_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(285865301678624444.4001)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P122_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P122_ID_NEXT'
,p_attribute_10=>'P122_ID_PREV'
,p_attribute_13=>'P122_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18862605198687116.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P122_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la plantilla de calendario.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18863028809687117.4001)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_api.id(18850126609687048.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38774611116730118.4001)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P122_REFERENCE_ID,',
'    p_subscribing_template_id    => :P122_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(38642223341465708.4001)
,p_process_when=>'P122_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(39018716264070765.4001)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:P122_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'P122_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Identificador de referencia eliminado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(358391920286449981.4001)
,p_process_sequence=>32
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P122_REFERENCE_ID,',
'    p_subscribing_template_id    => :P122_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(18850014025687048.4001)
,p_process_when=>':P122_REFERENCE_ID is not null and :P122_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
end;
/
prompt --application/pages/page_00123
begin
wwv_flow_api.create_page(
 p_id=>123.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Vista de Cuadr\00EDcula de Etiqueta de Separador')
,p_step_title=>unistr('Editar Separadores Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48819323334958123.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(155207503157382410.4001)
,p_name=>'Edit Standard Tab Labels, Sequences, and Names'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P123a */',
'ID,',
'sys.htf.anchor(''f?p=4000:4305:''||:flow_session||',
'  ''::::F4000_P4305_ID:''||id,',
'  ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'') e,',
'TAB_SET,',
'TAB_SEQUENCE,',
'TAB_NAME,',
'TAB_TEXT,',
'TAB_STEP,',
'TAB_ALSO_CURRENT_FOR_PAGES,',
'TAB_PARENT_TABSET',
'  from WWV_FLOW_TABS',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and (replace(:F4000_P123_TABSET,''%''||''null%'',null) is null or :F4000_P123_TABSET = tab_set)'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn separador.')
,p_query_num_rows_item=>'F4000_P123_MAX_ROWS'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 28-DEC-2001 14:50:24'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48583720900771031.4001)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48583822433771031.4001)
,p_query_column_id=>2
,p_column_alias=>'E'
,p_column_display_sequence=>2
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48583911921771031.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>3
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48584029289771031.4001)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48584124308771031.4001)
,p_query_column_id=>5
,p_form_element_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>22
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48584211205771031.4001)
,p_query_column_id=>6
,p_form_element_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>22
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48584315555771032.4001)
,p_query_column_id=>7
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>7
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48584405174771032.4001)
,p_query_column_id=>8
,p_form_element_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Tambi\00E9n P\00E1ginas Actuales')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>24
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48584519168771032.4001)
,p_query_column_id=>9
,p_column_alias=>'TAB_PARENT_TABSET'
,p_column_display_sequence=>9
,p_column_heading=>'Juego de Separadores Principales'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208110652382444.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155469804813777736.4001)
,p_column_sequence=>2
,p_query_column_name=>'E'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208316028382445.4001)
,p_column_sequence=>3
,p_query_column_name=>'TAB_SET'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208410999382445.4001)
,p_column_sequence=>4
,p_query_column_name=>'TAB_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208506902382445.4001)
,p_column_sequence=>5
,p_query_column_name=>'TAB_NAME'
,p_display_as=>'TEXT'
,p_column_width=>22
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208618396382445.4001)
,p_column_sequence=>6
,p_query_column_name=>'TAB_TEXT'
,p_display_as=>'TEXT'
,p_column_width=>22
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208703555382445.4001)
,p_column_sequence=>7
,p_query_column_name=>'TAB_STEP'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208809326382445.4001)
,p_column_sequence=>8
,p_query_column_name=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_display_as=>'TEXT'
,p_column_width=>24
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(155208930758382446.4001)
,p_column_sequence=>9
,p_query_column_name=>'TAB_PARENT_TABSET'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155293631294546820.4001)
,p_plug_name=>unistr('Separadores Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta p\00E1gina para editar los separadores de una aplicaci\00F3n o un juego de separadores concretos. Puede editar varias etiquetas de separador o nombres y secuencias para varias p\00E1ginas.</p>'),
'<p><strong>Secuencia</strong> controla las secuencias de separadores o el orden en un juego de separadores.</p>',
'<p><strong>Etiqueta</strong> identifica el texto de etiqueta de separador que se muestra al usuario.</p>',
unistr('<p><strong>Nombre</strong> identifica el nombre del separador. Los nombres de separador deben ser \00FAnicos en un juego de separadores y diferentes de los nombres de bot\00F3n.</p>')))
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_item=>'F4000_P123_MAX_ROWS'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155519414022843491.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(155288808662542129.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48819323334958123.4001)
,p_button_name=>'F4000_P123_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(155209321115382448.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48819323334958123.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(155210200188382465.4001)
,p_branch_action=>'123'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(155209321115382448.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 28-DEC-2001 14:50:25'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(155299523962550207.4001)
,p_branch_action=>'123'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(155274902420529775.4001)
,p_name=>'F4000_P123_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48819323334958123.4001)
,p_prompt=>unistr('Juego de Separadores Est\00E1ndar')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Juegos de Separadores -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un juego de separadores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(155629015143055726.4001)
,p_name=>'F4000_P123_MAX_ROWS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48819323334958123.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(155209800752382457.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(155207503157382410.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_TABS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(155209321115382448.4001)
,p_process_success_message=>'#MRU_COUNT# separador(es) actualizado(s).'
,p_process_comment=>'Generated 28-DEC-2001 14:50:24'
);
end;
/
prompt --application/pages/page_00124
begin
wwv_flow_api.create_page(
 p_id=>124.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Plantillas Suscritas'
,p_step_title=>unistr('Suscripci\00F3n de Plantilla')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</SCRIPT>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_rpts.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181499524342168233.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra plantillas de suscripci\00F3n en la aplicaci\00F3n.</p>'),
unistr('<p>Para refrescar el contenido copiado de la plantilla maestra, seleccione lo que desea refrescar y haga clic en <strong>Refrescar Selecci\00F3n</strong>.</p>')))
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No se ha encontrado ninguna plantilla suscrita.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'3:4'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181579916929536274.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181903622922384410.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>93
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(181911325929398179.4001)
,p_name=>'Template Subscription'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>95
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q                varchar2(32767) := null;',
'    t_application varchar2(255) := wwv_flow_lang.system_message(''F4000_P801_FLOW'');',
'    t_page varchar2(255) := wwv_flow_lang.system_message(''F4000.PAGE'');',
'    t_region varchar2(255) := wwv_flow_lang.system_message(''F4000.REGION'');',
'    t_report varchar2(255) := wwv_flow_lang.system_message(''REPORT'');',
'    t_list varchar2(255) := initcap(wwv_flow_lang.system_message(''LIST''));',
'    t_label varchar2(255) := wwv_flow_lang.system_message(''LABEL'');',
'    t_menu varchar2(255) := wwv_flow_lang.system_message(''F4000.MENU'');',
'    t_button varchar2(255) := wwv_flow_lang.system_message(''F4000.BUTTON'');',
'    t_calendar varchar2(255) := wwv_flow_lang.system_message(''LEGACY_CALENDAR'');',
'begin',
'    if (:F4000_P124_SHOW = ''Page'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(1,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(name))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(2,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_page||'''''', '';',
'      q :=q||''wwv_flow_escape.html(name), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(name) '';',
'      q :=q||''from wwv_flow_templates where id = p.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_templates p '';',
'      q :=q||''where p.flow_id = :fb_flow_id '';',
'      q :=q||''and p.security_group_id = :flow_security_group_id '';',
'      q :=q||''and p.reference_id is not null '';',
'    end if;',
'    if (:F4000_P124_SHOW = ''Region'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(3,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(4,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_region||'''''', '';',
'      q :=q||''wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(page_plug_template_name) '';',
'      q :=q||''from wwv_flow_page_plug_templates where id = r.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_page_plug_templates r '';',
'      q :=q||''where r.flow_id = :fb_flow_id '';',
'      q :=q||''and r.security_group_id = :flow_security_group_id '';',
'      q :=q||''and r.reference_id is not null '';',
'    end if;    ',
'    if (:F4000_P124_SHOW = ''Report'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(5,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(ROW_TEMPLATE_NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(6,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_report||'''''', '';',
'      q :=q||''wwv_flow_escape.html(ROW_TEMPLATE_NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(row_template_name) '';',
'      q :=q||''from wwv_flow_row_templates where id = ro.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_row_templates ro '';',
'      q :=q||''where ro.flow_id = :fb_flow_id '';',
'      q :=q||''and ro.security_group_id = :flow_security_group_id '';',
'      q :=q||''and ro.reference_id is not null '';',
'    end if;',
'    if (:F4000_P124_SHOW = ''List'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(7,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(LIST_TEMPLATE_NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(8,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_list||'''''', '';',
'      q :=q||''wwv_flow_escape.html(LIST_TEMPLATE_NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(list_template_name) '';',
'      q :=q||''from wwv_flow_list_templates where id = l.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_list_templates l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''and l.reference_id is not null '';',
'    end if;',
'    if (:F4000_P124_SHOW = ''Field'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(9,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(TEMPLATE_NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(10,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_label||'''''', '';',
'      q :=q||''wwv_flow_escape.html(TEMPLATE_NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(template_name) '';',
'      q :=q||''from wwv_flow_field_templates where id = f.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_field_templates f '';',
'      q :=q||''where f.flow_id = :fb_flow_id '';',
'      q :=q||''and f.security_group_id = :flow_security_group_id '';',
'      q :=q||''and f.reference_id is not null '';',
'    end if;',
'    if (:F4000_P124_SHOW = ''Button'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(11,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(TEMPLATE_NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(12,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_button||'''''', '';',
'      q :=q||''wwv_flow_escape.html(TEMPLATE_NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(template_name) '';',
'      q :=q||''from wwv_flow_button_templates where id = b.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_button_templates b '';',
'      q :=q||''where b.flow_id = :fb_flow_id '';',
'      q :=q||''and b.security_group_id = :flow_security_group_id '';',
'      q :=q||''and b.reference_id is not null '';',
'    end if;',
'    if (:F4000_P124_SHOW = ''Menu'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(13,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(14,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_menu||'''''', '';',
'      q :=q||''wwv_flow_escape.html(NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(name) '';',
'      q :=q||''from wwv_flow_menu_templates where id = m.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_menu_templates m '';',
'      q :=q||''where m.flow_id = :fb_flow_id '';',
'      q :=q||''and m.security_group_id = :flow_security_group_id '';',
'      q :=q||''and m.reference_id is not null '';',
'    end if;',
'    if (:F4000_P124_SHOW = ''Calendar'') or ',
'       (replace(:F4000_P124_SHOW,''%''||''null%'',null) is null) then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''wwv_flow_item.checkbox(15,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(NAME))||''''"''''), '';',
'      q :=q||''wwv_flow_item.hidden(16,reference_id), '';',
'      q :=q||''flow_id, '';',
'      q :=q||''''''''||t_calendar||'''''', '';',
'      q :=q||''wwv_flow_escape.html(NAME), '';',
'      q :=q||''(select ''''''||t_application ||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(name) '';',
'      q :=q||''from wwv_flow_cal_templates where id = l.reference_id) cp_from '';      ',
'      q :=q||''from wwv_flow_cal_templates l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''and l.reference_id is not null '';',
'    end if;',
'',
'    q := ltrim(q,''union all'');',
'    return q;',
'end;'))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay ninguna plantilla de suscripci\00F3n disponible.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867220597772659.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867307038772659.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867406703772660.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867506887772660.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867607538772660.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Plantilla'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867715515772660.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Copiado de'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867800504772660.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48867926608772660.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868021725772660.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868119343772660.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868222976772660.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868301675772661.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868417589772661.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868520198772661.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48868626889772661.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133287908242213765.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133288006184213770.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133288132456213770.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133288220903213770.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(133288329431213770.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736030717906682.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736106299906683.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736220991906683.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736317150906683.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736418052906683.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736514969906683.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736600482906684.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736708125906684.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736815512906684.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(736919714906684.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737000162906684.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737111466906684.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737209132906684.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737326295906684.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737412905906685.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737512473906685.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737603770906685.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737710497906685.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737807522906685.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(737916758906685.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738024961906685.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738101953906685.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738206928906686.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738301105906686.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738415108906686.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738507259906686.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738604848906686.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738722602906686.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738824383906686.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738921214906687.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739031314906687.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739122175906687.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739231788906687.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739330967906687.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739405493906687.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739521908906687.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739626103906687.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739732503906687.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739813794906688.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(739922914906688.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(87231809713468209.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(181903622922384410.4001)
,p_button_name=>'P124_GO'
,p_button_static_id=>'P124_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181590632003554484.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(181903622922384410.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if replace(:F4000_P124_SHOW,''%''||''null%'',null) is null then',
'        for c1 in (',
'            select 1 from wwv_flow_templates p where p.flow_id = :fb_flow_id and p.reference_id is not null      ',
'            union all',
'            select 1 from wwv_flow_page_plug_templates r where r.flow_id = :fb_flow_id and r.reference_id is not null',
'            union all',
'            select 1 from wwv_flow_row_templates ro where ro.flow_id = :fb_flow_id and ro.reference_id is not null  ',
'            union all',
'            select 1 from wwv_flow_list_templates l where l.flow_id = :fb_flow_id and l.reference_id is not null      ',
'            union all',
'            select 1 from wwv_flow_field_templates f where f.flow_id = :fb_flow_id and f.reference_id is not null',
'             union all',
'            select 1 from wwv_flow_button_templates b where b.flow_id = :fb_flow_id and b.reference_id is not null ',
'            union all',
'            select 1 from wwv_flow_menu_templates m where m.flow_id = :fb_flow_id  and m.reference_id is not null) loop',
'        --',
'            return true;',
'        end loop;',
'        return false;',
'    else',
'        if :F4000_P124_SHOW = ''Page'' then',
'            for c1 in (select 1 from wwv_flow_templates p where p.flow_id = :fb_flow_id and p.reference_id is not null) loop ',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Region'' then',
'            for c1 in (select 1 from wwv_flow_page_plug_templates r where r.flow_id = :fb_flow_id and r.reference_id is not null) loop',
'                return true; ',
'            end loop;',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Report'' then',
'            for c1 in (select 1 from wwv_flow_row_templates ro where ro.flow_id = :fb_flow_id and ro.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''List'' then',
'            for c1 in (select 1 from wwv_flow_list_templates l where l.flow_id = :fb_flow_id and l.reference_id is not null) loop ',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Field'' then',
'            for c1 in (select 1 from wwv_flow_field_templates f where f.flow_id = :fb_flow_id and f.reference_id is not null) loop ',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Button'' then',
'            for c1 in (select 1 from wwv_flow_button_templates b where b.flow_id = :fb_flow_id and b.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Menu'' then',
'            for c1 in (select 1 from wwv_flow_menu_templates m where m.flow_id = :fb_flow_id  and m.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Calendar'' then',
'            for c1 in (select 1 from wwv_flow_cal_templates m where m.flow_id = :fb_flow_id  and m.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        end if;',
'        return true;',
'    end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
end;
/
begin
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181591019903554494.4001)
,p_branch_action=>'124'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181612113226583662.4001)
,p_name=>'F4000_P124_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(181903622922384410.4001)
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHOW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84336604916626643.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Tipos -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrinja los resultados seleccionando un tipo de plantilla y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157779601446618641.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(181911325929398179.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157779706979618642.4001)
,p_event_id=>wwv_flow_api.id(1157779601446618641.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181704614131795876.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_page_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing page templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'    wwv_flow_copy_metadata.refresh_region_template (',
'    p_subscribing_template_id    => wwv_flow.g_f03(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing region templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f05.count loop',
'    wwv_flow_copy_metadata.refresh_report_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f05(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing report templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f07.count loop',
'    wwv_flow_copy_metadata.refresh_list_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f07(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing list templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f09.count loop',
'    wwv_flow_copy_metadata.refresh_field_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f09(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing field templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f11.count loop',
'    wwv_flow_copy_metadata.refresh_button_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f11(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing button templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f13.count loop',
'    wwv_flow_copy_metadata.refresh_menu_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f13(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing menu templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f15.count loop',
'    wwv_flow_copy_metadata.refresh_calendar_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f15(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing calendar templates. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar plantillas.'
,p_process_when_button_id=>wwv_flow_api.id(181590632003554484.4001)
,p_process_success_message=>'Plantillas seleccionadas refrescadas.'
);
end;
/
prompt --application/pages/page_00126
begin
wwv_flow_api.create_page(
 p_id=>126.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asistente de \00C1rboles: Cl\00E1usula Where y Order By')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44704315275752620.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157617305321568311.4001)
,p_plug_name=>'Create Tree'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Identifique una cl\00E1usula opcional where y ordene los hermanos por columna en la consulta.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157620429678572209.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147901626307825228.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157734323442818183.4001)
,p_plug_name=>'Consulta Actual'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_start_value varchar2(4000) := null;',
'  l_tooltip     varchar2(4000) := null;',
'begin',
'',
'  -- Start With Column Value',
'  if :P116_START_TREE = ''ITEM'' then',
'      l_start_value := '':''||:P116_START_ITEM;',
'  elsif :P116_START_TREE = ''STATIC'' then',
'      l_start_value := :P116_START_STATIC_VALUE;',
'  elsif :P116_START_TREE = ''SQL'' then',
'      l_start_value := ''(''||:P116_SQL||'')'';',
'  end if;',
'',
'  -- Tooltip',
'  if :P68_SHOW_TOOLTIP = ''STATIC'' then',
'      l_tooltip := ''''''''||:P68_TOOLTIP_TEXT||'''''''';',
'  elsif :P68_SHOW_TOOLTIP = ''DB'' then',
'      l_tooltip := ''"''||:P68_TOOLTIP_DB||''"'';',
'  else',
'      l_tooltip := ''null'';',
'  end if;',
'',
'  sys.htp.p(''<pre>''||wwv_flow_escape.html(',
'  wwv_flow_wizard_api.generate_tree_region_query( ',
'         p_flow_id      => :FB_FLOW_ID,',
'         p_owner        => :F4000_P112_OWNER,',
'         p_table_name   => :P114_TABLE_NAME,',
'         p_id           => :F4000_P112_ID,',
'         p_pid          => :F4000_P112_PID,',
'         p_name         => :F4000_P112_NAME,',
'         p_start_item   => :P116_START_NODE,',
'         p_start_value  => l_start_value,',
'         p_link_option  => :F4000_P112_LINK_OPTION,',
'         p_link_page_id => :F4000_P112_LINK_PAGE_ID, ',
'         p_link_item    => :F4000_P112_LINK_ITEM,',
'         p_where        => :F4000_P112_WHERE,',
'         p_order_by     => :F4000_P112_ORDER_BY,',
'         p_tooltip      => l_tooltip,',
'         p_icon         => null))||''</pre>''',
'  );',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157623618392576214.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44704315275752620.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157672212037640564.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44704315275752620.4001)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_button_condition=>':F4000_P112_START_OPTION in (''SQL'',''STATIC'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157628208134582725.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44704315275752620.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente '
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157625932590580273.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44704315275752620.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157666507428628047.4001)
,p_branch_action=>'68'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(157628208134582725.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157668804193629614.4001)
,p_branch_action=>'116'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(157625932590580273.4001)
,p_branch_sequence=>10
,p_branch_condition=>'P68_LINK_OPTION'
,p_branch_condition_text=>'EXISTING'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157631630529586963.4001)
,p_name=>'F4000_P126_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(157617305321568311.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157634922765590531.4001)
,p_name=>'F4000_P126_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(157617305321568311.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'F4000_P112_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157640007884597512.4001)
,p_name=>'F4000_P112_WHERE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(157617305321568311.4001)
,p_prompt=>unistr('Cl\00E1usula Where (por ejemplo, ename = ''JONES'')')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca una cl\00E1usula WHERE. Por ejemplo:</div>'),
'<pre>',
'ename=''JONE''',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157650519086607514.4001)
,p_name=>'F4000_P112_ORDER_BY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(157617305321568311.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ordenar Hermanos por (por ejemplo, ENAME)'
,p_source=>'F4000_P112_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_PAGE_WIZ_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'from wwv_flow_table_columns_dev',
'where owner = :F4000_P112_OWNER',
'and table_name = :P114_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Seleccione los hermanos de la clasificaci\00F3n por columna, como ENAME. El valor por defecto se basa en la columna Texto de Nodo que haya seleccionado.</div> <div class="htmldbInfoBodyP">')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549110877347554533.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(157623618392576214.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549111157981554533.4001)
,p_event_id=>wwv_flow_api.id(549110877347554533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00128
begin
wwv_flow_api.create_page(
 p_id=>128.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Recuento de Regiones por Tipo de Regi\00F3n')
,p_step_title=>unistr('Recuento de Regiones por Tipo de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(28394706425150973.4001)
,p_name=>'Application Regions by Type'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT',
'    plug_source_type,',
'    region_type,',
'    count(*) region_count,',
'    count(distinct page_id) pages_referenced,',
'    count(distinct PLUG_DISPLAY_POINT) display_points_used',
'FROM (',
'   select ',
'   plug_source_type,',
'   case',
'    when PLUG_SOURCE_TYPE like ''NATIVE%'' then wwv_flow_lang.system_message(''REGION_NAME.''||plug_source_type)',
'    else plug_source_type',
'    end region_type,',
'    page_id,',
'    plug_display_point',
'FROM',
'   WWV_FLOW_PAGE_PLUGS',
'WHERE',
'   FLOW_ID = :fb_flow_id)',
'group by ',
'   plug_source_type, region_type',
'order by 1'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna regi\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Imprimir'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 14-MAY-2004 10:40:29'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(136572532696782738.4001)
,p_query_column_id=>1
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Type'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_include_in_export=>'N'
,p_print_col_width=>'0'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28405914718182947.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Tipo de Regi\00F3n')
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(28331928066600148)
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'40'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28697318218486798.4001)
,p_query_column_id=>3
,p_column_alias=>'REGION_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Recuento de Regiones'
,p_column_format=>'999G999G999G999G990'
,p_column_html_expression=>'<a href="f?p=&APP_ID.:136:&SESSION.:::RIR,136:IR_PLUG_SOURCE_TYPE:#PLUG_SOURCE_TYPE#" title="&P128_VIEW_PAGES_TEXT.">#REGION_COUNT#</a>'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28697419354486799.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGES_REFERENCED'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1ginas con Referencia')
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28697500722486799.4001)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_POINTS_USED'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Puntos de Visualizaci\00F3n Usados')
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193876003094584211.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28399921846151016.4001)
,p_branch_action=>'f?p=&FLOW_ID.:128:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177586817411723873.4001)
,p_name=>'P128_VIEW_PAGES_TEXT'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_source=>'wwv_flow_lang.system_message(''F4000_P128.VIEW_PAGES'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00129
begin
wwv_flow_api.create_page(
 p_id=>129.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Esquemas de Autorizaci\00F3n Suscritos')
,p_step_title=>unistr('Suscripci\00F3n de Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'     function checkAll()  {          ',
'        for ( var i=0; i < document.wwv_flow.elements.length; i++ ){',
'            var e = document.wwv_flow.elements[i];              ',
'            if ( e.name == "f01" ||e.name == "f03" ||  e.name == "f05" || e.name == "f07" || e.name == "f09" ){                      ',
'                if ( e.length > 1 ) {',
'                    for ( j=0;j<e.length;j++ )',
'                        if ( !e[j].checked )  e[j].click();}                      ',
'                else if ( !e.checked ) ',
'                    e.click();              ',
'             }',
'         }',
'     }',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180466004905329772.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(180462022520306486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(183075524876689047.4001)
,p_name=>'Subscribed Authorization Schemes'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4129a */',
'  wwv_flow_item.checkbox(1,wwv_flow_escape.html(id),''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'') cb,',
'  wwv_flow_item.hidden(2,reference_id) hr,',
'  flow_id,',
'  name n,',
'  scheme_type t,',
'  (select flow_id||'', ''||name',
'   from wwv_flow_security_schemes where id = s.reference_id) cp_from ',
' from wwv_flow_security_schemes s',
'where s.flow_id = :fb_flow_id ',
'  and s.security_group_id = :flow_security_group_id',
'  and s.reference_id is not null'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(430770413155050990.4001)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(430770511524050990.4001)
,p_query_column_id=>2
,p_column_alias=>'HR'
,p_column_display_sequence=>2
,p_column_heading=>'Hidden'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(430770613037050991.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(430770724766050991.4001)
,p_query_column_id=>4
,p_column_alias=>'N'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Nombre de la Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(430770802346050991.4001)
,p_query_column_id=>5
,p_column_alias=>'T'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo de Esquema'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(11239432234132441)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(430770923263050991.4001)
,p_query_column_id=>6
,p_column_alias=>'CP_FROM'
,p_column_display_sequence=>6
,p_column_heading=>'Suscrito desde'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183076702295689062.4001)
,p_plug_name=>unistr('Suscripci\00F3n de Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se muestran los esquemas de autorizaci\00F3n suscritos en la aplicaci\00F3n.</p>'),
unistr('<p>Para refrescar un esquema de autorizaci\00F3n, seleccione los esquemas que desea refrescar y a continuaci\00F3n, haga clic en <strong>Refrescar Selecci\00F3n</strong>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183077305476689066.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183077631660689068.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(183077305476689066.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flow_security_schemes s where s.flow_id = :fb_flow_id and s.reference_id is not null'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(183077916156689076.4001)
,p_branch_action=>'129'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157779432523618639.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(183075524876689047.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157779560158618640.4001)
,p_event_id=>wwv_flow_api.id(1157779432523618639.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(183078232417689080.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked schemes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_security_scheme (    ',
'    p_subscribing_scheme_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing authorization schemes. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar los esquemas de autorizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(183077631660689068.4001)
,p_process_success_message=>unistr('Esquemas de autorizaci\00F3n seleccionados refrescados.')
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_api.create_page(
 p_id=>130.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilizaci\00F3n de Elemento de Aplicaci\00F3n')
,p_step_title=>unistr('Uso del Elemento de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5051813440678195.4001)
,p_plug_name=>unistr('Elementos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       wwv_flow_computation.get_computation_points( :FB_FLOW_ID, name ) as comps,',
'       id',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(5051906577678195.4001)
,p_name=>'Appliation Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5052119857678207.4001)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Elemento de Aplicaci\00F3n')
,p_column_link=>'f?p=4000:4303:&SESSION.::NO::F4000_P4303_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5052232745678207.4001)
,p_db_column_name=>'COMPS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Uso'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5052303163678207.4001)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47811023683120211.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47807005066095922.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47826831348500844.4001)
,p_plug_name=>unistr('Utilizaci\00F3n de Elemento de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Este informe especifica d\00F3nde se utiliza cada elemento de la aplicaci\00F3n.</p>')
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188873318206797764.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5051813440678195.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:130,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(6415013990672239.4001)
,p_branch_action=>'f?p=&FLOW_ID.:130:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6415510085673100.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(188873318206797764.4001)
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_api.create_page(
 p_id=>131.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Acceso Directo: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Acceso Directo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47728616931641902.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185245721349814176.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(185305822581982553.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185246023181814186.4001)
,p_plug_name=>'Crear Acceso Directo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear accesos directos nuevos o copiarlos de otra aplicaci\00F3n. La copia de accesos directos le proporciona un marco que puede modificar posteriormente.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185246312970814192.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47728616931641902.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185246631115814195.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47728616931641902.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185247522516814210.4001)
,p_branch_action=>'132'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185246631115814195.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P131_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185247821238814216.4001)
,p_branch_action=>'174'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185246631115814195.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P131_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185248126606814220.4001)
,p_branch_action=>'4047'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185246312970814192.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185246920821814198.4001)
,p_name=>'F4000_P131_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185246023181814186.4001)
,p_prompt=>'Crear Acceso Directo:'
,p_source=>'BLANK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SHORTCUT_WIZ_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84343606432636502.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'<p>Seleccione la forma de crear accesos directos.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589950181609621446.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(185246312970814192.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589950286076621447.4001)
,p_event_id=>wwv_flow_api.id(589950181609621446.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185248715359814230.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'131:132:133'
,p_process_when_button_id=>wwv_flow_api.id(185246312970814192.4001)
);
end;
/
prompt --application/pages/page_00132
begin
wwv_flow_api.create_page(
 p_id=>132.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Acceso Directo: Copiar de'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Acceso Directo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47731920441671255.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185251706524816972.4001)
,p_plug_name=>'Crear Acceso Directo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Esta p\00E1gina permite copiar accesos directos de otra aplicaci\00F3n o dentro de la aplicaci\00F3n actual. Seleccione la aplicaci\00F3n de la que desea copiar los accesos directos.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185253512469816999.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(185309707700989517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185252312566816980.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47731920441671255.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185252618380816982.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47731920441671255.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185252021651816976.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47731920441671255.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185254427925817008.4001)
,p_branch_action=>'133'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185253812124817002.4001)
,p_branch_action=>'4047'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185252312566816980.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185254121835817005.4001)
,p_branch_action=>'131'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185252021651816976.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185252932657816987.4001)
,p_name=>'F4000_P132_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185251706524816972.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar accesos directos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'select name||'' (''||id||'')'', id from wwv_flows where id = v(''FB_FLOW_ID'')'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185254708259817013.4001)
,p_validation_name=>'F4000_P132_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P132_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(185252932657816987.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590010813975897501.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(185252312566816980.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590010906638897502.4001)
,p_event_id=>wwv_flow_api.id(590010813975897501.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00133
begin
wwv_flow_api.create_page(
 p_id=>133.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Acceso Directo: Nuevos Accesos Directos'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Acceso Directo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47732920918680897.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185257704683820013.4001)
,p_name=>'Crear Acceso Directo'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'  q:=''select '';',
'  q:=q||''flow_id, '';  ',
'  q:=q||''shortcut_name, '';',
'  q:=q||'' wwv_flow_item.text(1,wwv_flow_lang.system_message(''''F4000.P158.COPY_OF'''',shortcut_name),40,null,''''id="name''''||rownum||''''" title="''''||wwv_flow_lang.system_message(''''COPY_TO_NAME'''')||''''"''''), '';',
'  q:=q||'' wwv_flow_item.select_list_from_lov(2,''''N'''',''''YES.NO.SUBSCRIBE'''','''' title="''''||wwv_flow_lang.system_message(''''LAYOUT.T_ALT_COPY'''')||''''" id="copy''''||rownum||''''"'''',''''N''''), '';  ',
'  q:=q||''wwv_flow_item.hidden(3,id) '';  ',
'  q:=q||''from wwv_flow_shortcuts '';',
'  q:=q||''where flow_id = :F4000_P132_COPY_FROM_FLOW_ID '';',
'  q:=q||''and security_group_id = :flow_security_group_id'';',
' ',
'  return q;',
'end;'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca los nombres de los accesos directos que se van a copiar y seleccione la opci\00F3n Copiar entre las siguientes:<p/>'),
'<ul>',
unistr('<li><strong>S\00ED.</strong> Introducir nuevo nombre de acceso directo.</li>'),
'<li><strong>No.</strong> No copiar este acceso directo.</li>',
'<li><strong>Copiar y Suscribir.</strong> Copiar y suscribirse a este acceso directo.</li>',
'</ul><br/>'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>500
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ning\00FAn m\00E9todo abreviado.</font>')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48698920029771705.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699007315771705.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'De Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699129612771705.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'A Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699216963771705.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Copiar'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699325973771705.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699408072771706.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699502393771706.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699624046771706.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699700843771706.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699809241771706.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48699903007771706.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48700030935771706.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48700102099771706.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48700229393771706.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48700303853771707.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091010162493699.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091127654493703.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091200212493703.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091314294493703.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091413806493703.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091524751493704.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091620881493704.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091719417493704.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091811500493704.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166091903030493704.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092025460493704.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092102619493704.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092222542493705.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092318882493706.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092410859493706.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092509732493706.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092611856493706.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092704747493706.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092820483493706.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166092921835493706.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093008221493706.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093108353493706.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093222114493707.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093322369493707.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093418036493707.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093514753493707.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093621122493707.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093719263493707.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093812091493707.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166093901369493708.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094006575493708.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094125133493708.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094217123493708.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094307961493708.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094432324493708.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094515029493708.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094632574493708.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094719773493709.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094830626493709.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166094928615493709.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166095000925493709.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166095102808493709.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166095220849493709.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166095310285493709.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166095410798493709.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185259229487820044.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(185309707700989517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ninguna plantilla de p\00E1gina.</font>')
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185258328517820025.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47732920918680897.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185258008310820016.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47732920918680897.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Acceso Directo'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flow_shortcuts where flow_id = :F4000_P132_COPY_FROM_FLOW_ID'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185258616437820026.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47732920918680897.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185260109701820052.4001)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185258008310820016.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185259511066820045.4001)
,p_branch_action=>'4047'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185258328517820025.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185259804698820050.4001)
,p_branch_action=>'132'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185258616437820026.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590011058635897503.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(185258328517820025.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590011185797897504.4001)
,p_event_id=>wwv_flow_api.id(590011058635897503.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185260418354820054.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Shortcut'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_shortcut_id number;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_shortcut_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_copy_util.copy_shortcut (',
'      p_copy_from_flow_id  => :F4000_P132_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_shortcut_id   => wwv_flow.g_f03(i),',
'      p_to_shortcut_name   => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'      p_to_shortcut_id     => l_shortcut_id',
'      );',
'    if wwv_flow.g_f02(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_shortcut (',
'      p_master_shortcut_id         => wwv_flow.g_f03(i),',
'      p_subscribing_shortcut_id    => l_shortcut_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar los accesos directos.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(185258008310820016.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_fnd boolean := false;',
'begin',
'  for i in 1.. wwv_flow.g_f02.count loop',
'    if wwv_flow.g_f02(i) != ''N'' then',
'      l_fnd := true;',
'      exit;',
'    end if;',
'  end loop;',
'  return l_fnd;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('M\00E9todos abreviados copiados.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590011213801897505.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(185258008310820016.4001)
,p_process_success_message=>unistr('M\00E9todos abreviados copiados.')
);
end;
/
prompt --application/pages/page_00134
begin
wwv_flow_api.create_page(
 p_id=>134.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n: Copiar de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193570125052895218.4001)
,p_plug_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193571927628895233.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(193684503309130516.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ninguna barra de navegaci\00F3n.</font>')
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205143813168463328.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193570726971895224.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(205143813168463328.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193571025138895225.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205143813168463328.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193570403843895222.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205143813168463328.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193572827711895238.4001)
,p_branch_action=>'135'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193571025138895225.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193572201834895235.4001)
,p_branch_action=>'4005'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193570726971895224.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193572508306895237.4001)
,p_branch_action=>'22'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193570403843895222.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193571318962895227.4001)
,p_name=>'F4000_P134_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(193570125052895218.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione una aplicaci\00F3n desde la que copiar una opci\00F3n de barra de navegaci\00F3n y haga clic en <strong>Siguiente</strong>.</p>.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193573132745895240.4001)
,p_validation_name=>'F4000_P134_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P134_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(193571025138895225.4001)
,p_associated_item=>wwv_flow_api.id(193571318962895227.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573754687601229727.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193570726971895224.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573754768039229728.4001)
,p_event_id=>wwv_flow_api.id(573754687601229727.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00135
begin
wwv_flow_api.create_page(
 p_id=>135.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n: Nuevos Nombres')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193576510750901030.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(193684503309130516.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ninguna barra de navegaci\00F3n.</font>')
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(193576821859901031.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
' flow_id,  ',
' wwv_flow_escape.html(icon_image_alt)|| wwv_flow_item.hidden(3,wwv_flow_escape.html(id)) image_name,',
' wwv_flow_item.text(1,wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',wwv_flow_escape.html(icon_image_alt)),40, 4000, ''title="''||wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',wwv_flow_escape.html(icon_image_alt))||''"'') copy_to,',
' wwv_flow_item.select_list_from_lov(2,''N'',''YES.NO.SUBSCRIBE'',''title="''||wwv_flow_lang.system_message(''F4000.P135.COPY'',wwv_flow_escape.html(icon_image_alt))||''"'',''NO'') subscribe',
' ',
'from wwv_flow_icon_bar',
'where flow_id = :F4000_P134_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique el nombre de las entradas de barra de navegaci\00F3n que se van a copiar y seleccione la opci\00F3n de copia. Las opciones de copia incluyen:</p>'),
'<ul class="noIndent">',
unistr('<li><strong>S\00ED.</strong> Introducir nuevo nombre.</li>'),
'<li><strong>No.</strong> No copiar esta entrada.</li>',
'<li><strong>Copiar y Suscribir.</strong> Copiar y suscribirse a esta entrada.</li>',
'</ul>'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ninguna barra de navegaci\00F3n.</font>')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(287736001944824470.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(287736114427824471.4001)
,p_query_column_id=>2
,p_column_alias=>'IMAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(287736210927824471.4001)
,p_query_column_id=>3
,p_column_alias=>'COPY_TO'
,p_column_display_sequence=>3
,p_column_heading=>'Copiar en'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(287736317710824471.4001)
,p_query_column_id=>4
,p_column_alias=>'SUBSCRIBE'
,p_column_display_sequence=>4
,p_column_heading=>'Copiar'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205146227151476750.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193577424587901033.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205146227151476750.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193577130912901032.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(205146227151476750.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar Entradas de Barra de Navegaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193577715490901034.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205146227151476750.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193578612527901042.4001)
,p_branch_action=>'4005'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193577130912901032.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193578030073901035.4001)
,p_branch_action=>'4005'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193577424587901033.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193578316309901038.4001)
,p_branch_action=>'134'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(193577715490901034.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573754859823229729.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193577424587901033.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573754930157229730.4001)
,p_event_id=>wwv_flow_api.id(573754859823229729.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(193578908300901043.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy NavBar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_navbar_id number;',
'lc number := wwv_flow.g_f03.count;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_navbar_id := wwv_flow_id.next_val;',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_copy_util.copy_navbar (',
'      p_copy_from_flow_id  => :F4000_P134_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_navbar_id     => wwv_flow.g_f03(i),',
'      p_to_navbar_name     => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'      p_to_navbar_id       => l_navbar_id    ',
'      );      ',
'    if wwv_flow.g_f02(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_navbar (',
'      p_master_navbar_id         => wwv_flow.g_f03(i),',
'      p_subscribing_navbar_id    => l_navbar_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar las entradas de barra de navegaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(193577130912901032.4001)
,p_process_success_message=>unistr('Entradas de barra de navegaci\00F3n copiadas.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(573755035470229731.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(193577130912901032.4001)
,p_process_success_message=>unistr('Entradas de barra de navegaci\00F3n copiadas.')
);
end;
/
prompt --application/pages/page_00136
begin
wwv_flow_api.create_page(
 p_id=>136.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Regiones por Tipo, Punto de Visualizaci\00F3n y Plantilla')
,p_step_title=>unistr('Regiones por Tipo, Punto de Visualizaci\00F3n y Plantilla')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194633408721659272.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194635525077685524.4001)
,p_plug_name=>unistr('Regiones por Tipo, Punto de Visualizaci\00F3n y Plantilla')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>112
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   all_regions.PLUG_DISPLAY_POINT, ',
'   all_regions.PLUG_NAME, ',
'   all_regions.PAGE_ID, ',
'   ( select name',
'       from wwv_flow_templates',
'      where id = ( select wwv_flow_page_dev.get_template_id ( all_regions.flow_id, all_regions.page_id ) from dual )',
'   ) as page_template,',
'   all_regions.PLUG_SOURCE_TYPE,',
'   all_regions.PLUG_DISPLAY_CONDITION_TYPE,',
'   all_regions.flow_id,',
'   PAGE_PLUG_TEMPLATE_NAME,',
'   all_regions.region_id',
'from (',
'SELECT ',
'   id region_id,',
'   flow_id,',
'   LAST_UPDATED_BY, ',
'   LAST_UPDATED_ON, ',
'   PLUG_DISPLAY_POINT, ',
'   PLUG_NAME, ',
'   PAGE_ID, ',
'   plug_template,',
'   PLUG_SOURCE_TYPE,',
'   decode(PLUG_DISPLAY_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') ',
'   PLUG_DISPLAY_CONDITION_TYPE',
'FROM ',
'   WWV_FLOW_PAGE_PLUGS',
'WHERE FLOW_ID = :fb_flow_id) all_regions,',
'WWV_FLOW_PAGE_PLUG_TEMPLATES t',
'where ',
'all_regions.plug_template = t.id(+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194635626214685524.4001)
,p_name=>'Regions by Type, Display Point, and Template'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194636223371685577.4001)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>unistr('Tipo de Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194636030583685575.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_link_attr=>'title="&P497_VIEW_PAGE_DEF_TEXT."'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194635903669685574.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>unistr('Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#REGION_ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194635819967685573.4001)
,p_db_column_name=>'PLUG_DISPLAY_POINT'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>unistr('Punto de Visualizaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194636532259685579.4001)
,p_db_column_name=>'PAGE_PLUG_TEMPLATE_NAME'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>unistr('Plantilla de Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194636322349685577.4001)
,p_db_column_name=>'PLUG_DISPLAY_CONDITION_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194636122065685576.4001)
,p_db_column_name=>'PAGE_TEMPLATE'
,p_display_order=>7
,p_column_identifier=>'D'
,p_column_label=>unistr('Plantilla de P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194636421324685578.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Identificador de Flujo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100575188990284409.4001)
,p_db_column_name=>'REGION_ID'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>unistr('Identificador de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194640304300757190.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194635525077685524.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:136,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(194634326691659288.4001)
,p_name=>'P497_VIEW_PAGE_DEF_TEXT'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_source=>'wwv_flow_lang.system_message(''F4000_P497.VIEW_PAGE_DEF'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00137
begin
wwv_flow_api.create_page(
 p_id=>137.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista de Valores: Origen'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44762511550082790.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202759021091609841.4001)
,p_plug_name=>'Crear Lista de Valores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<div class="htmldbInfoBodyP">Una lista de valores es una definici\00F3n est\00E1tica o din\00E1mica utilizada para visualizar un tipo espec\00EDfico de elemento de p\00E1gina, como por ejemplo listas de valores emergentes, una lista de selecci\00F3n, una casilla de control,')
||unistr(' un grupo de botones de radio o listas de selecci\00F3n m\00FAltiple.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202907703159922057.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(161740513874429436.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202769930547624567.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44762511550082790.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202773210939628365.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44762511550082790.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202932410898948800.4001)
,p_branch_action=>'4004'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(202773210939628365.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P137_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202773616194628367.4001)
,p_branch_action=>'138'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(202773210939628365.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P137_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(202778430124635978.4001)
,p_name=>'F4000_P137_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(202759021091609841.4001)
,p_prompt=>'Crear Lista de Valores:'
,p_source=>'BLANK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LOV_WIZ_LOV'
,p_lov=>'.'||wwv_flow_api.id(84344914743638898.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Especifique la forma de crear una lista de valores. Puede crear una lista de valores desde el principio o bien como copia de una lista de valores existente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574039250149616923.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(202769930547624567.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574039381544616924.4001)
,p_event_id=>wwv_flow_api.id(574039250149616923.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(202783214165643420.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear cache'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'137:138:139'
,p_process_when_button_id=>wwv_flow_api.id(202769930547624567.4001)
);
end;
/
prompt --application/pages/page_00138
begin
wwv_flow_api.create_page(
 p_id=>138.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista de Valores: Copiar de'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44775211166129981.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202795805526662588.4001)
,p_plug_name=>'Crear Lista de Valores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Copie las listas de valores de la aplicaci\00F3n actual o de otra aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202958400522984032.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202952222735973765.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202800315965667604.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44775211166129981.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202806005360674011.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44775211166129981.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202802927739671072.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44775211166129981.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(171114422492457612.4001)
,p_branch_action=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(202806005360674011.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202803305809671074.4001)
,p_branch_action=>'137'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(202802927739671072.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(202814618225687156.4001)
,p_name=>'F4000_P138_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(202795805526662588.4001)
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n desde la que desea copiar listas de valores.</p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(202816913912689145.4001)
,p_validation_name=>'F4000_P138_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P138_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(202814618225687156.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-APR-2002 15:52'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574038248072616913.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(202800315965667604.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574038323505616914.4001)
,p_event_id=>wwv_flow_api.id(574038248072616913.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00139
begin
wwv_flow_api.create_page(
 p_id=>139.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista de Valores: Nueva Lista de Valores'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44777004717137510.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(202824917997702398.4001)
,p_name=>'Crear Lista de Valores'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'  ''<div title="''||wwv_flow_escape.html(v.lov_name)||',
'     ''" style="width:200px; overflow:hidden">''||',
'     wwv_flow_escape.html(v.lov_name)||''</div>''',
'     from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',lov_name) to_name,',
'  ''N'' Sub',
'from wwv_flow_lists_of_values$ v',
'where flow_id = :F4000_P138_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indique el nombre de las listas de valores que se van a copiar y seleccione la opci\00F3n de copia. Las opciones de copia incluyen:</p>'),
'<ul class="noIndent">',
unistr('<li><strong>S\00ED.</strong> Introducir nuevo nombre de lista de valores.</li>'),
'<li><strong>No.</strong> No copiar esta lista de valores.</li>',
'<li><strong>Copiar y Suscribir.</strong> Copiar y suscribirse a esta lista de valores.</li>',
'</ul>'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna lista de valores.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Imprimir'
,p_prn_units=>'MILLIMETERS'
,p_prn_paper_size=>'A4'
,p_prn_width=>297
,p_prn_height=>210
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289813428793814357.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289813508814814357.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289813612988814357.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289813701369814357.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289813808431814358.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(309317735965282153)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202960721860989374.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202952222735973765.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202841116751724584.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44777004717137510.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202846810302732194.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44777004717137510.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Lista de Valores'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202843728872728139.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44777004717137510.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(289882326116870396.4001)
,p_branch_name=>'Go To Page 4110'
,p_branch_action=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(202846810302732194.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(574038188111616912.4001)
,p_branch_action=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(202843728872728139.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36099000144565166.4001)
,p_validation_name=>'nothing to copy'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'No hay ninguna lista de valores para copiar.'
,p_when_button_pressed=>wwv_flow_api.id(202846810302732194.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291077815324830905.4001)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select lov_name',
'                  from WWV_FLOW_LISTS_OF_VALUES$',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and lov_name = wwv_flow.g_f02(i) ) loop',
'         if c1.lov_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.lov_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.lov_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000_LOV_NAME_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(202846810302732194.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574037834170616909.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(202841116751724584.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574037976332616910.4001)
,p_event_id=>wwv_flow_api.id(574037834170616909.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(202854401582740437.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_lov_id number;',
'begin',
'',
'wwv_flow.debug(''............'');',
'wwv_flow.debug(''............''||wwv_flow.g_f03.count);',
'wwv_flow.debug(''ID............''||wwv_flow.g_f01(1)||''.'');',
'wwv_flow.debug(''NAME............''||wwv_flow.g_f02(1)||''.'');',
'wwv_flow.debug(''COPY............''||wwv_flow.g_f03(1)||''.'');',
'wwv_flow.debug(''FROM............''||:F4000_P138_COPY_FROM_FLOW_ID);',
'wwv_flow.debug(''TO............''||:fb_flow_id);',
'wwv_flow.debug(''............'');',
'',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_lov_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_lov_dev.copy_named_lov(',
'        p_copy_from_flow_id => :F4000_P138_COPY_FROM_FLOW_ID,',
'        p_flow_id           => :fb_flow_id,',
'        p_lov_id_from       => wwv_flow.g_f01(i),',
'        p_lov_name_to       => wwv_flow.g_f02(i),',
'        p_lov_id_to         => l_lov_id',
'        );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_lov (',
'      p_master_lov_id         => wwv_flow.g_f01(i),',
'      p_subscribing_lov_id    => l_lov_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar listas de valores.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(202846810302732194.4001)
,p_process_success_message=>'Listas de valores copiadas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574038084178616911.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Listas de valores copiadas.'
);
end;
/
prompt --application/pages/page_00142
begin
wwv_flow_api.create_page(
 p_id=>142.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Lista de Valores Suscrita'
,p_step_title=>unistr('Suscripci\00F3n de Lista de Valores')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function checkAll()  { ',
'        for ( var i=0; i < document.wwv_flow.elements.length; i++ ) {',
'            var e = document.wwv_flow.elements[i]; ',
'                if ( e.name == "f01" || e.name == "f03" || e.name == "f05" || e.name == "f07" || e.name == "f09" ){',
'                    if ( e.length > 1 ) {',
'                        for ( j=0;j<e.length;j++ )',
'                            if ( !e[j].checked )',
'                                e[j].click();}',
'                    else                        ',
'                        if ( !e.checked )',
'                            e.click();',
'                    }      ',
'        }',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203046420244385134.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203049209246390236.4001)
,p_plug_name=>unistr('Suscripci\00F3n de Lista de Valores')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra listas de valores suscritas en la aplicaci\00F3n. Para refrescar las listas de valores, seleccione las deseadas y haga clic en <strong>Refrescar Selecci\00F3n</strong>.</p>')
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(203053725408397937.4001)
,p_name=>'Listas de Valores Suscritas'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    q                varchar2(32767) := null;',
'   t_application varchar2(255) := wwv_flow_lang.system_message(''F4000_P801_FLOW'');',
'begin',
'    q :=q||''select '';',
'    q :=q||''wwv_flow_item.checkbox(1,id), '';',
'    q :=q||'' reference_id, '';',
'    q :=q||''flow_id, '';   ',
'    q :=q||''wwv_flow_escape.html(lov_name), '';',
'    q :=q||''(select ''''''||t_application||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(lov_name) '';',
'    q :=q||''from wwv_flow_lists_of_values$ where id = s.reference_id) cp_from '';      ',
'    q :=q||''from wwv_flow_lists_of_values$ s '';',
'    q :=q||''where s.flow_id = :fb_flow_id '';',
'    q :=q||''and s.security_group_id = :flow_security_group_id '';',
'    q :=q||''and s.reference_id is not null '';',
'    return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609020968771174.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609114610771174.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609201202771174.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609302048771174.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609400476771174.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Copiado de'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609513908771174.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609627523771174.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609706381771174.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609801771771174.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48609900408771175.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48610002704771175.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48610117855771175.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48610201263771175.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48610313081771175.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48610411536771175.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134716413426839724.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134716532407839724.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134716604351839724.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134716730024839724.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134716812780839724.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12290424443076280.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12290521290076281.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12290631639076281.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12290715879076281.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12290819828076281.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12290927254076281.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291001047076281.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291113340076282.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291230732076282.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291323109076282.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291412186076282.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291514258076282.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291620791076282.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291714339076282.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291829885076282.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12291907413076283.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292010450076283.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292107140076283.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292232123076283.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292324653076283.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292417885076283.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292508785076283.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292623180076283.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292720578076284.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292817149076284.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12292922937076284.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293008189076284.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293100624076284.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293218994076284.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293326581076284.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293410000076284.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293531949076285.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293603028076285.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293729980076285.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293829014076285.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12293917336076285.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12294003284076285.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12294109704076285.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12294226891076285.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12294313411076286.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203057232081410003.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203066402898420776.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(203046420244385134.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flow_lists_of_values$ s where s.flow_id = :fb_flow_id and s.reference_id is not null'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203066827961420779.4001)
,p_branch_name=>'Go To Page 142'
,p_branch_action=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(60603500008127245.4001)
,p_validation_name=>'At least 1 checked'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f01(i) is not null then',
'        return true;',
'    end if;',
'end loop;',
'return false;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Seleccione al menos 1 lista de valores para refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(203066402898420776.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203076319345431079.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_lov(',
'    p_subscribing_lov_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing LOVs. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar listas de valores.'
,p_process_when_button_id=>wwv_flow_api.id(203066402898420776.4001)
,p_process_success_message=>'Se han refrescado las listas de valores seleccionadas.'
);
end;
/
prompt --application/pages/page_00144
begin
wwv_flow_api.create_page(
 p_id=>144.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de P\00E1gina: Nuevas Plantillas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47953200410819832.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(177594010116613582.4001)
,p_name=>unistr('Crear Plantillas de P\00E1gina')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id,',
'  name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name) to_name,',
'  ''N'' Sub',
'  from wwv_flow_templates ',
'  where flow_id = :F4000_P26_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P225_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ninguna plantilla de p\00E1gina.</font>')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291256720911211008.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291256825142211008.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291256915856211009.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291257022937211009.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291257105799211009.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177690302851799341.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177596609148616902.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47953200410819832.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176868520698259014.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47953200410819832.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar Plantillas de P\00E1gina')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177600019537619931.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47953200410819832.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152009915943744349.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589950068358621445.4001)
,p_branch_action=>'f?p=&APP_ID.:225:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177600019537619931.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74507924042493708.4001)
,p_name=>'P144_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177594010116613582.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copiar en Tema:'
,p_source=>'P225_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291260905721235005.4001)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Debe seleccionar al menos una plantilla que copiar.',
'',
''))
,p_when_button_pressed=>wwv_flow_api.id(176868520698259014.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291261916456238121.4001)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select name',
'                  from WWV_FLOW_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and name = wwv_flow.g_f02(i) ) loop',
'         if c1.name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(176868520698259014.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589949878421621443.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(177596609148616902.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589949918274621444.4001)
,p_event_id=>wwv_flow_api.id(589949878421621443.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176869729127259084.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) = ''Y'' then',
'    wwv_flow_templates_util.copy_template (',
'      p_copy_from_flow_id    => :F4000_P26_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :fb_flow_id,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p144_theme,',
'      p_include_subscription => false',
'      );',
'  elsif wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'    wwv_flow_templates_util.copy_template (',
'      p_copy_from_flow_id    => :F4000_P26_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :fb_flow_id,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p144_theme,',
'      p_include_subscription => true      ',
'      );',
'    wwv_flow_copy_metadata.subscribe_page_template (',
'      p_master_template_id         => wwv_flow.g_f01(i),',
'      p_subscribing_template_id    => l_template_id',
'      );',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar las plantillas de p\00E1gina.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(176868520698259014.4001)
,p_process_success_message=>unistr('Plantillas de p\00E1gina copiadas.')
);
end;
/
prompt --application/pages/page_00145
begin
wwv_flow_api.create_page(
 p_id=>145.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Entradas de Lista')
,p_step_title=>unistr('Edici\00F3n de Cuadr\00EDculas de Entradas de Lista')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164875231475558821.4001)
,p_plug_name=>'Lista: &F4000_P145_LIST_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205870912685621708.4001)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(660073452414686901.4001)
,p_plug_name=>'Editar Entradas de Lista'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ RESULT_CACHE */ id,',
'       list_id,',
'       flow_id,',
'       LIST_ITEM_DISPLAY_SEQUENCE,',
'       LIST_ITEM_LINK_TEXT,',
'       LIST_ITEM_LINK_TARGET,',
'       LIST_ITEM_CURRENT_TYPE,',
'       LIST_ITEM_CURRENT_FOR_PAGES,',
'       LIST_ITEM_ICON,',
'       LIST_TEXT_01,',
'       LIST_TEXT_02,',
'       LIST_TEXT_03,',
'       list_text_04,',
'       list_text_05,',
'       list_text_06,',
'       list_text_07,',
'       list_text_08,',
'       list_text_09,',
'       list_text_10,',
'       list_text_11,',
'       list_text_12,',
'       ( select nullif( count( c.id ), 0 )',
'           from wwv_flow_list_items c',
'          where list_id           = :F4000_P145_LIST_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID              ',
'          start with c.parent_list_item_id = p.id ',
'        connect by c.parent_list_item_id = prior c.id ) as child_item_count,',
'        --',
'       ( select case when count( c.id ) > 0 then ''U'' else ''UD'' end',
'           from wwv_flow_list_items c',
'          where list_id           = :F4000_P145_LIST_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID              ',
'          start with c.parent_list_item_id = p.id ',
'        connect by c.parent_list_item_id = prior c.id  ) as allowed_operations,',
'        --',
'       ( select hierarchy_level from (',
'             select id, level as hierarchy_level',
'               from (',
'                      select * ',
'                        from wwv_flow_list_items',
'                       where list_id           = :F4000_P145_LIST_ID',
'                         and flow_id           = :FB_FLOW_ID',
'                         and security_group_id = :WORKSPACE_ID              ',
'                    ) c',
'              start with c.parent_list_item_id is null',
'            connect by c.parent_list_item_id = prior c.id  ) where id = p.id ) as this_level',
'  from wwv_flow_list_items p',
' where list_id           = :F4000_P145_LIST_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'F4000_P145_LIST_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(96782086750601228.4001)
,p_name=>'CHILD_ITEM_COUNT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CHILD_ITEM_COUNT'
,p_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Secundarios'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>250
,p_value_alignment=>'RIGHT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>unistr('Si el elemento de lista act\00FAa como elemento <em>principal</em>, el n\00FAmero total de elementos secundarios se registra a continuaci\00F3n. Los elementos con elementos secundarios existentes no se pueden suprimir.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(96782146753601229.4001)
,p_name=>'ALLOWED_OPERATIONS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ALLOWED_OPERATIONS'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>260
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(96782253577601230.4001)
,p_name=>'THIS_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THIS_LEVEL'
,p_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Nivel de Jerarqu\00EDa')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>270
,p_value_alignment=>'RIGHT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>unistr('Representa el nivel de jerarqu\00EDa del elemento de lista.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(109877407947242513.4001)
,p_name=>'LIST_ITEM_ICON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_ICON'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Icono'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567417293406994714.4001)
,p_name=>'LIST_ITEM_LINK_TARGET'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_LINK_TARGET'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567417393605994715.4001)
,p_name=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('P\00E1ginas')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567417420102994716.4001)
,p_name=>'LIST_TEXT_01'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_01'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 1'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567417525313994717.4001)
,p_name=>'LIST_TEXT_02'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_02'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 2'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567417695136994718.4001)
,p_name=>'LIST_TEXT_03'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_03'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 3'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567418119622994723.4001)
,p_name=>'LIST_ITEM_CURRENT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_CURRENT_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>100
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'TARGET_PAGE'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(660073602812686903.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(660073721702686904.4001)
,p_name=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Secuencia'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>70
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(660073835983686905.4001)
,p_name=>'LIST_ITEM_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_LINK_TEXT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Texto'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(660074458811686911.4001)
,p_name=>'LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P145_LIST_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(660074631141686913.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_label=>'Acciones'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>20
,p_value_alignment=>'CENTER'
,p_enable_hide=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(660074785922686914.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_enable_hide=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(714513746100810145.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(714514287014810150.4001)
,p_name=>'LIST_TEXT_04'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_04'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 4'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717649989335356601.4001)
,p_name=>'LIST_TEXT_05'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_05'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 5'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650021643356602.4001)
,p_name=>'LIST_TEXT_06'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_06'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 6'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>180
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650102736356603.4001)
,p_name=>'LIST_TEXT_07'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_07'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 7'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>190
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650257309356604.4001)
,p_name=>'LIST_TEXT_08'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_08'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 8'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>200
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650368049356605.4001)
,p_name=>'LIST_TEXT_09'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_09'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 9'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>210
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650468097356606.4001)
,p_name=>'LIST_TEXT_10'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_10'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 10'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>220
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650541003356607.4001)
,p_name=>'LIST_TEXT_11'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_11'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 11'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>230
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(717650650690356608.4001)
,p_name=>'LIST_TEXT_12'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_12'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Atributo 12'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>240
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(660073549657686902.4001)
,p_internal_uid=>660073549657686902
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_edit_row_operations_column=>'ALLOWED_OPERATIONS'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164701431818308013.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(164875231475558821.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164947326936669872.4001)
,p_branch_name=>'Go To Page 145'
,p_branch_action=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164747816971368005.4001)
,p_name=>'F4000_P145_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(205870912685621708.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926448243219861801.4001)
,p_name=>'F4000_P145_LIST_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(205870912685621708.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'select name from wwv_flow_lists where id = :F4000_P145_LIST_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(660074825193686915.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(660073452414686901.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Edit List Entries - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han guardado los cambios de lista.'
);
end;
/
prompt --application/pages/page_00147
begin
wwv_flow_api.create_page(
 p_id=>147.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Proceso de Aplicaci\00F3n: Identificaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Proceso de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25944302772206558.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(25941806450198106.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46528306282638612.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195451713511262987.4001)
,p_plug_name=>unistr('Crear Proceso de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Los procesos de aplicaci\00F3n ejecutan l\00F3gica PL/SQL en puntos espec\00EDficos para cada p\00E1gina de una aplicaci\00F3n, o como definan las condiciones en las que est\00E1n definidas para arrancarse. Tenga en cuenta que los procesos "Devoluci\00F3n de Llamada de AJAX"')
||unistr(' solo se arrancan cuando se llaman desde p\00E1ginas concretas.</p>')
,p_plug_footer=>unistr('<p>Los procesos "Devoluci\00F3n de Llamada de AJAX" se deben declarar en el nivel de p\00E1gina siempre que sea posible.  </p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195471007455288048.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46528306282638612.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195468429141284770.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46528306282638612.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(195468816421284787.4001)
,p_branch_action=>'148'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(195468429141284770.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195626216635398270.4001)
,p_name=>'F4000_P147_PROCESS_POINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(195451713511262987.4001)
,p_item_default=>'BEFORE_HEADER'
,p_prompt=>'Punto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLOW.PROCESS.TYPE'
,p_lov=>'.'||wwv_flow_api.id(179311318624565491.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifique el punto en el que se ejecutar\00E1 este proceso. Tenga en cuenta que el punto "Devoluci\00F3n de Llamada de Ajax" se arrancar\00E1 solo cuando un proceso de p\00E1gina lo solicite.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195670026087439503.4001)
,p_name=>'F4000_P4147_PROCESS_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(195451713511262987.4001)
,p_item_default=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica lo que realiza el proceso, por ejemplo, es PL/SQL o un tipo "incorporado".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195677709481447180.4001)
,p_name=>'F4000_P147_PROCESS_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(195451713511262987.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre que identifica este proceso de nivel de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195708922463653857.4001)
,p_name=>'F4000_P147_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(195451713511262987.4001)
,p_item_default=>'1'
,p_prompt=>'Secuencia'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el n\00FAmero de secuencia para este proceso. El n\00FAmero de secuencia determina el orden en que se eval\00FAa el proceso en relaci\00F3n con otros procesos que se ejecutan en el mismo punto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(195755022580775425.4001)
,p_validation_name=>'F4000_P147_PROCESS_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P147_PROCESS_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(195677709481447180.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-MAR-2002 16:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(195755313285775428.4001)
,p_validation_name=>'F4000_P147_SEQUENCE Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P147_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia.'
,p_associated_item=>wwv_flow_api.id(195708922463653857.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-MAR-2002 16:19'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590011835254897511.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(195471007455288048.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590011902307897512.4001)
,p_event_id=>wwv_flow_api.id(590011835254897511.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00148
begin
wwv_flow_api.create_page(
 p_id=>148.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Proceso de Aplicaci\00F3n: Origen')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Proceso de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".a-Dialog-page, .a-Dialog, .a-Dialog-wrap, .a-Dialog-body, .a-Wizard-regionBody, .a-CodeEditor").addClass("resize");',
'apex.jQuery("#F4000_P147_PROCESS_SQL_CONTAINER").addClass("resize").children(".a-Form-inputContainer").addClass("resize");',
'apex.jQuery(".a-Dialog-body, .a-Dialog-footer").css("position", "static");',
'apex.jQuery(".a-Dialog-body").css("overflow", "hidden");',
'apex.theme.pageResizeInit();',
''))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25946216971210693.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(25941806450198106.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46686929212250797.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195492418219306446.4001)
,p_plug_name=>unistr('Crear Proceso de Aplicaci\00F3n')
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195511810272317225.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46686929212250797.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195500921915311105.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46686929212250797.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195505731612313874.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46686929212250797.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(195501309948311108.4001)
,p_branch_action=>'150'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(195500921915311105.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(195506110878313877.4001)
,p_branch_action=>'147'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(195505731612313874.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104701319799601.4001)
,p_name=>'P148_LANGUAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(195492418219306446.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4836007603949294.4001)
,p_name=>'P148_CHECK_SYNTAX'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(195492418219306446.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comprobar sintaxis'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLSQL_VALIDATION'
,p_lov=>'.'||wwv_flow_api.id(111144330433082822.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195720222451669075.4001)
,p_name=>'F4000_P147_PROCESS_SQL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(195492418219306446.4001)
,p_prompt=>unistr('C\00F3digo')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>30000
,p_cHeight=>16
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el c\00F3digo del proceso de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_04=>'N'
,p_attribute_06=>'P148_LANGUAGE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4833519791806883.4001)
,p_validation_name=>'Syntax Check'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code (',
'           p_type     => wwv_flow_code_exec_dev.c_check_block,',
'           p_code     => :F4000_P147_PROCESS_SQL,',
'           p_language => :P148_LANGUAGE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P148_CHECK_SYNTAX, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(195720222451669075.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590012056700897513.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(195511810272317225.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590012177831897514.4001)
,p_event_id=>wwv_flow_api.id(590012056700897513.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00149
begin
wwv_flow_api.create_page(
 p_id=>149.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Publicaci\00F3n de Componente Compartido')
,p_step_title=>unistr('Confirmar Publicaci\00F3n de Componente Compartido')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2102433914346922.4001)
,p_plug_name=>unistr('\00BFDesea publicar esta definici\00F3n de carga de datos?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>330
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flow_load_tables',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and data_profile_id is not null',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_DATA_LOAD'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in ( select flow_id, name',
'             from wwv_flow_load_tables',
'            where reference_id      = :F4000_P149_ID',
'              and data_profile_id is not null',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'            order by flow_id, name )',
'loop',
'    sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P149_TEMPLATE_TYPE'
,p_plug_display_when_cond2=>'DATA_LOAD'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13233630654631577.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Lista de Valores Emergente?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>230
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_popup_lov constant wwv_flow_messages$.message_text%type :=',
'                         wwv_flow_lang.system_message( p_name => ''SUBSCRIBE_TEMPLATE.POPUP_LOV'' );',
'begin',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'',',
'                                                      p0     => c_popup_lov ) || ''</p>'' );',
'',
'    sys.htp.p(''<ul class="a-List a-List--basic">'');',
'    for c in (select flow_id',
'                from wwv_flow_popup_lov_template',
'               where reference_id = :F4000_P149_ID',
'                 and security_group_id = wwv_flow_security.g_security_group_id',
'               order by flow_id ) loop',
'       sys.htp.p(''<li>'' || wwv_flow_escape.html( c.flow_id || '' - '' || c_popup_lov ) || ''</li>'');',
'    end loop;',
'    sys.htp.p(''</ul>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''POPUPLOV'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13296109205763005.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Ruta de Navegaci\00F3n?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>250
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flow_menu_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, name',
'            from wwv_flow_menu_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''MENU'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32745206926244622.4001)
,p_plug_name=>unistr('\00BFPublicar este Plugin?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>310
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select display_name as name',
'              from wwv_flow_plugins',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_PLUGIN'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in ( select flow_id, display_name as name',
'             from wwv_flow_plugins',
'            where reference_id      = :F4000_P149_ID',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'            order by flow_id, name )',
'loop',
'    sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P149_TEMPLATE_TYPE'
,p_plug_display_when_cond2=>'PLUGIN'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38648713607510190.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Calendario?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>290
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flow_cal_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_CALENDAR_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, name',
'            from wwv_flow_cal_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''CALENDAR'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78694102266697856.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Bot\00F3n?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>270
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select template_name as name',
'              from wwv_flow_button_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_BUTTON_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, template_name as name',
'            from wwv_flow_button_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''BUTTON'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(165212025694064824.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de P\00E1gina?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flow_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_PAGE_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, name',
'            from wwv_flow_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''PAGE'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166279314943803574.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Lista?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select list_template_name as name',
'              from wwv_flow_list_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_LIST_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, list_template_name as name',
'            from wwv_flow_list_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''LIST'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166315312078880915.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Regi\00F3n?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select page_plug_template_name as name',
'              from wwv_flow_page_plug_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_REGION_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, page_plug_template_name as name',
'            from wwv_flow_page_plug_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''REGION'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166350221530922165.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Informe?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select row_template_name as name',
'              from wwv_flow_row_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_REPORT_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, row_template_name as name',
'            from wwv_flow_row_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
'',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''REPORT'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166366801880961619.4001)
,p_plug_name=>unistr('\00BFPublicar esta Plantilla de Etiqueta?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>160
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select template_name as name',
'              from wwv_flow_field_templates',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_FIELD_TEMPLATE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, template_name as name',
'            from wwv_flow_field_templates',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''FIELD'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178804212027098631.4001)
,p_plug_name=>unistr('\00BFPublicar este Esquema de Autorizaci\00F3n?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>170
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flow_security_schemes',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_AUTHORIZATION'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, name',
'            from wwv_flow_security_schemes',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''SECURITY'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185172207511427351.4001)
,p_plug_name=>unistr('\00BFPublicar este Acceso Directo?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>170
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select shortcut_name as name',
'              from wwv_flow_shortcuts',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_SHORTCUT'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, shortcut_name as name',
'            from wwv_flow_shortcuts',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''SHORTCUT'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201107408978101972.4001)
,p_plug_name=>unistr('\00BFPublicar esta Entrada de Barra de Navegaci\00F3n?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>180
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select nvl( icon_subtext, icon_image_alt ) as name',
'              from wwv_flow_icon_bar',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_NAVBAR'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, nvl( icon_image_alt, icon_subtext ) as name',
'            from wwv_flow_icon_bar',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''NAVBAR'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202446510435867459.4001)
,p_plug_name=>unistr('\00BFPublicar esta Lista de Valores?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>210
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select lov_name as name',
'              from wwv_flow_lists_of_values$',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_LOV'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) ) || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in (select flow_id, lov_name as name',
'            from wwv_flow_lists_of_values$',
'           where reference_id = :F4000_P149_ID',
'             and security_group_id = wwv_flow_security.g_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P149_TEMPLATE_TYPE = ''LOV'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(247726434160524630.4001)
,p_plug_name=>unistr('\00BFPublicar este origen de datos de REST?')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>320
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flow_web_src_modules',
'             where security_group_id = wwv_flow_security.g_security_group_id',
'               and id = :F4000_P149_ID )',
'loop',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( p_name => ''F4000.P149.PUBLISH_WEB_SRC_MODULE'',',
'                                                      p0     => wwv_flow_escape.html( c1.name ) )  || ''</p>'' );',
'end loop;',
'',
'sys.htp.p(''<ul class="a-List a-List--basic">'');',
'for c in ( select flow_id, name',
'             from wwv_flow_web_src_modules',
'            where reference_id      = :F4000_P149_ID',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'            order by flow_id, name )',
'loop',
'    sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P149_TEMPLATE_TYPE'
,p_plug_display_when_cond2=>'WEB_SOURCE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2102591367346923.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2102433914346922.4001)
,p_button_name=>'CANCEL14'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'BELOW_BOX'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247726535413524631.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(247726434160524630.4001)
,p_button_name=>'CANCEL13_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'BELOW_BOX'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2102692832346924.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2102433914346922.4001)
,p_button_name=>'REFRESH_DATA_LOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'BELOW_BOX'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247726635004524632.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(247726434160524630.4001)
,p_button_name=>'REFRESH_WEB_SRC_MODULE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'BELOW_BOX'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13241311484650443.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(13233630654631577.4001)
,p_button_name=>'CANCEL10'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13304827732778163.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(13296109205763005.4001)
,p_button_name=>'CANCEL11'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78705621087714962.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(78694102266697856.4001)
,p_button_name=>'CANCEL12'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(165212325525064833.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(165212025694064824.4001)
,p_button_name=>'CANCEL1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202453001365886841.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202446510435867459.4001)
,p_button_name=>'CANCEL9'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166377309608971486.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(166279314943803574.4001)
,p_button_name=>'CANCEL3'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166290009290848439.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(166315312078880915.4001)
,p_button_name=>'CANCEL2'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166383131425977806.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(166350221530922165.4001)
,p_button_name=>'CANCEL4'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166394318743983572.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(166366801880961619.4001)
,p_button_name=>'CANCEL5'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32745503763244628.4001)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(32745206926244622.4001)
,p_button_name=>'CANCEL13'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185200114582536616.4001)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(185172207511427351.4001)
,p_button_name=>'CANCEL7'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201119402255150627.4001)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(201107408978101972.4001)
,p_button_name=>'CANCEL8'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38654607552546300.4001)
,p_button_sequence=>190
,p_button_plug_id=>wwv_flow_api.id(38648713607510190.4001)
,p_button_name=>'CANCEL12'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13244630531655950.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(13233630654631577.4001)
,p_button_name=>'REFRESH_POPUPLOV'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78709404595719642.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(78694102266697856.4001)
,p_button_name=>'REFRESH_BUTTON_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202454828526889454.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202446510435867459.4001)
,p_button_name=>'REFRESH_LOV'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13308109163782246.4001)
,p_button_sequence=>11
,p_button_plug_id=>wwv_flow_api.id(13296109205763005.4001)
,p_button_name=>'REFRESH_MENU'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(165212617271064835.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(165212025694064824.4001)
,p_button_name=>'REFRESH_PAGE_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166380821383974934.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(166279314943803574.4001)
,p_button_name=>'REFRESH_LIST_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166292321757852009.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(166315312078880915.4001)
,p_button_name=>'REFRESH_REGION_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166389310432981245.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(166350221530922165.4001)
,p_button_name=>'REFRESH_REPORT_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166396828440986374.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(166366801880961619.4001)
,p_button_name=>'REFRESH_FIELD_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10_69c"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32745725562244629.4001)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(32745206926244622.4001)
,p_button_name=>'REFRESH_PLUGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185204132590541824.4001)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(185172207511427351.4001)
,p_button_name=>'REFRESH_SHORTCUT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10_69c"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201121229416153255.4001)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(201107408978101972.4001)
,p_button_name=>'REFRESH_NAVBAR'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38655312400547696.4001)
,p_button_sequence=>200
,p_button_plug_id=>wwv_flow_api.id(38648713607510190.4001)
,p_button_name=>'REFRESH_CAL_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178810407150115903.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(178804212027098631.4001)
,p_button_name=>'REFRESH_SECURITY_SCHEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178808125720111854.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(178804212027098631.4001)
,p_button_name=>'CANCEL6'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(669972044101014001.4001)
,p_branch_name=>'Go To Page &F4000_P149_PAGE_ID.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   (:F4000_P149_PAGE_ID =   85 and :F4000_P85_STAY_ON_PAGE     = ''YES'')',
'or (:F4000_P149_PAGE_ID =  204 and :F4000_P204_RETURN_TO_PAGE  = ''YES'')',
'or (:F4000_P149_PAGE_ID =  251 and :F4000_P251_RTP             = ''YES'')',
'or (:F4000_P149_PAGE_ID =  258 and :F4000_P258_RETUEN_TO_SELF  = ''YES'')',
'or (:F4000_P149_PAGE_ID =  289 and :F_4000_P289_STAY_ON_PAGE   = ''YES'')',
'or (:F4000_P149_PAGE_ID =  697 and :P697_STAY                  = ''YES'')',
'or (:F4000_P149_PAGE_ID = 4307 and :F4000_P4307_RETURN_TO_PAGE = ''YES'')',
'or (:F4000_P149_PAGE_ID = 4653 and :F4000_P4653_RETURN_TO_PAGE = ''YES'')',
'or (:F4000_P149_PAGE_ID = 4655 and :F4000_P4655_RETURN_TO_PAGE = ''YES'')',
'or (:F4000_P149_PAGE_ID = 4410)'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32763713271454625.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST like ''REFRESH%'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30707516463433544.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165820922595140347.4001)
,p_name=>'F4000_P149_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'F4000_P149_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165893116303188811.4001)
,p_name=>'F4000_P149_PAGE_ID'
,p_item_sequence=>20
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'F4000_P149_PAGE_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(166263802546672605.4001)
,p_name=>'F4000_P149_TEMPLATE_TYPE'
,p_item_sequence=>30
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'F4000_P149_TEMPLATE_TYPE'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78715904182727300.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Button Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_button_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de bot\00F3n de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(78709404595719642.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de bot\00F3n de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13248519415667098.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Popup LOV Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_popuplov_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de lista de valores emergente de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(13244630531655950.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de lista de valores emergente de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13312015866790390.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Menu Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_menu_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de ruta de navegaci\00F3n de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(13308109163782246.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de ruta de navegaci\00F3n de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201131030266168028.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All NavBars'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_navbar(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las barras de navegaci\00F3n de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(201121229416153255.4001)
,p_process_success_message=>unistr('Se han refrescado todas las barras de navegaci\00F3n de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(202459101137902160.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All LOVs'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_lov(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las listas de valores de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(202454828526889454.4001)
,p_process_success_message=>unistr('Se han refrescado todas las lista de valores de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178815716316127062.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Security Scheme'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_security_scheme(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todos los esquemas de seguridad de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(178810407150115903.4001)
,p_process_success_message=>unistr('Se han refrescado todos los esquemas de seguridad de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185215322280557269.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Shortcuts'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_shortcut(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todos los m\00E9todos abreviados de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(185204132590541824.4001)
,p_process_success_message=>unistr('Se han refrescado todos los m\00E9todos abreviados de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(165214120792064848.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Page Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_page_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de p\00E1gina de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(165212617271064835.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de p\00E1gina de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166410608732019218.4001)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Region Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_region_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de regi\00F3n de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(166292321757852009.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de regi\00F3n de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166426024882042160.4001)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All List Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_list_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de lista de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(166380821383974934.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de lista de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166432411079048488.4001)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Report Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_report_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de informe de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(166389310432981245.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de informe de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166440630692054609.4001)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Field Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_field_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de campo de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(166396828440986374.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de campo de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38657830885562441.4001)
,p_process_sequence=>130
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Calendar Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_calendar_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de bot\00F3n de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(38655312400547696.4001)
,p_process_success_message=>'Se han refrescado todas las plantillas de calendario.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(32746425111287723.4001)
,p_process_sequence=>140
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Plug-in'
,p_process_sql_clob=>'wwv_flow_plugin_dev.push_plugin(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar todos los plugin.'
,p_process_when_button_id=>wwv_flow_api.id(32745725562244629.4001)
,p_process_success_message=>unistr('Se han refrescado todos los plugin de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(247726726938524633.4001)
,p_process_sequence=>150
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All REST Data Sources'
,p_process_sql_clob=>'wwv_flow_web_src_dev.push_web_src_module(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todos los or\00EDgenes de datos de REST de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(247726635004524632.4001)
,p_process_success_message=>unistr('Se han refrescado todos los or\00EDgenes de datos de REST de suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2102748395346925.4001)
,p_process_sequence=>160
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Data Load'
,p_process_sql_clob=>'wwv_flow_data_loader_dev.push_data_load(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las definiciones de carga de datos de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(2102692832346924.4001)
,p_process_success_message=>unistr('Se han refrescado todas las definiciones de carga de datos de suscripci\00F3n.')
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_api.create_page(
 p_id=>150.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Proceso de Aplicaci\00F3n: Condicionalidad')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Proceso de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25954318618230080.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(25941806450198106.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46696825880259308.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195523607855326447.4001)
,p_plug_name=>unistr('Crear Proceso de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(236699304404828727.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>Los procesos de nivel de aplicaci\00F3n Devoluci\00F3n de Llamada de AJAX se crear\00E1n con el esquema de autorizaci\00F3n "No Debe Ser Usuario P\00FAblico".</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P147_PROCESS_POINT'
,p_plug_display_when_cond2=>'ON_DEMAND'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195539232698342574.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46696825880259308.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195534819884338899.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46696825880259308.4001)
,p_button_name=>'CreateFlowProcess'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Proceso'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(195529124602330828.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46696825880259308.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(195535230889338903.4001)
,p_branch_action=>'4207'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(195534819884338899.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(195529527027330831.4001)
,p_branch_action=>'148'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(195529124602330828.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1500978898824314.4001)
,p_name=>'F4000_P150_PROCESS_WHEN_LANG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17810125791998856.4001)
,p_name=>'F4000_P150_PROCESS_WHEN2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195815600440226308.4001)
,p_name=>'F4000_P150_PROCESS_WHEN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Utilice este atributo para controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n seleccionado. Si se cumple la condici\00F3n especificada, se presenta o procesa el ')
||'componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195818329758227939.4001)
,p_name=>'F4000_P150_PROCESS_WHEN_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'F4000_P147_PROCESS_WHEN_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista. Esta condici\00F3n se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P150_PROCESS_WHEN'
,p_attribute_02=>'F4000_P150_PROCESS_WHEN2'
,p_attribute_04=>'F4000_P150_PROCESS_WHEN_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'F4000_P150_PROCESS_WHEN_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195907029523516671.4001)
,p_name=>'F4000_P150_PROCESS_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P4147_PROCESS_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tipo de proceso.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195912532098530661.4001)
,p_name=>'F4000_P150_PROCESS_POINT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P147_PROCESS_POINT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifica el punto de proceso.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435032821193654756.4001)
,p_name=>'F4000_P150_PROCESS_WHEN_CHECK'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(195523607855326447.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590012271653897515.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(195539232698342574.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590012348771897516.4001)
,p_event_id=>wwv_flow_api.id(590012271653897515.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(195787020990140788.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create flow process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_flow_process (',
'    p_flow_id => :fb_flow_id,',
'    p_process_sequence       => :F4000_P147_SEQUENCE,',
'    p_process_point          => :F4000_P147_PROCESS_POINT,',
'    p_process_type           => :F4000_P4147_PROCESS_TYPE,',
'    p_process_name           => :F4000_P147_PROCESS_NAME,',
'    p_process_sql_clob       => :F4000_P147_PROCESS_SQL,',
'    p_process_clob_language  => :P148_LANGUAGE,',
'    p_error_display_location => case',
'                                  when :F4000_P147_PROCESS_POINT in (''ON_SUBMIT_BEFORE_COMPUTATION'', ''AFTER_SUBMIT'') then',
'                                      wwv_flow_error_api.c_inline_in_notification',
'                                  else',
'                                      wwv_flow_error_api.c_on_error_page',
'                                end,',
'    p_process_when           => :F4000_P150_PROCESS_WHEN,',
'    p_process_when_type      => replace(:F4000_P150_PROCESS_WHEN_TYPE,''%null%'',null),',
'    p_process_when2          => :F4000_P150_PROCESS_WHEN2,',
'    p_process_when_type2     => null,',
'    p_security_scheme        => case when :F4000_P147_PROCESS_POINT = ''ON_DEMAND'' then ''MUST_NOT_BE_PUBLIC_USER'' else null end,',
'    p_required_patch         => null );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear el proceso de nivel de aplicaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(195534819884338899.4001)
,p_process_success_message=>'Proceso creado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590012477246897517.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(195534819884338899.4001)
,p_process_success_message=>'Proceso creado.'
);
end;
/
prompt --application/pages/page_00152
begin
wwv_flow_api.create_page(
 p_id=>152.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de C\00E1lculos')
,p_step_title=>unistr('Historial de C\00E1lculos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17468530992581007.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251089817295332531.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>160
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_COMPUTATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251090013737332532.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090119125332534.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090211465332535.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090302961332536.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090421358332537.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090502481332538.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090617770332539.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251090725010332540.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251335414356086391.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251197006725742003.4001)
,p_plug_name=>unistr('Historial de C\00E1lculos')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los c\00E1lculos de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todos los c\00E1lculos de p\00E1gina en la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251092431279346040.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251089817295332531.4001)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:152,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00153
begin
wwv_flow_api.create_page(
 p_id=>153.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Entradas de Barra de Navegaci\00F3n')
,p_step_title=>unistr('Edici\00F3n de Cuadr\00EDculas de Entradas de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(166070830263906494.4001)
,p_name=>unistr('Editar Entradas de Barra de Navegaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4153a */',
'ID,',
'ICON_SEQUENCE,',
'ICON_IMAGE,',
'ICON_SUBTEXT,',
'ICON_IMAGE_ALT,',
'ICON_HEIGHT,',
'ICON_WIDTH,',
'ICON_TARGET,',
'ONCLICK',
'from WWV_FLOW_ICON_BAR',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by ICON_SEQUENCE'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 23-JAN-2002 20:06:26'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48756731896772039.4001)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48756823045772039.4001)
,p_query_column_id=>2
,p_form_element_id=>2
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48756910674772039.4001)
,p_query_column_id=>3
,p_form_element_id=>3
,p_column_alias=>'ICON_IMAGE'
,p_column_display_sequence=>3
,p_column_heading=>'Imagen1'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48757000505772039.4001)
,p_query_column_id=>4
,p_form_element_id=>4
,p_column_alias=>'ICON_SUBTEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Subtexto1'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48757108435772040.4001)
,p_query_column_id=>5
,p_form_element_id=>5
,p_column_alias=>'ICON_IMAGE_ALT'
,p_column_display_sequence=>5
,p_column_heading=>'Texto alternativo'
,p_use_as_row_header=>'Y'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48757205929772040.4001)
,p_query_column_id=>6
,p_form_element_id=>6
,p_column_alias=>'ICON_HEIGHT'
,p_column_display_sequence=>6
,p_column_heading=>'Altura'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48757311333772040.4001)
,p_query_column_id=>7
,p_form_element_id=>7
,p_column_alias=>'ICON_WIDTH'
,p_column_display_sequence=>7
,p_column_heading=>'Ancho'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48757400782772040.4001)
,p_query_column_id=>8
,p_form_element_id=>8
,p_column_alias=>'ICON_TARGET'
,p_column_display_sequence=>8
,p_column_heading=>'Destino'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48757504207772040.4001)
,p_query_column_id=>9
,p_column_alias=>'ONCLICK'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071106869906496.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071229705906496.4001)
,p_column_sequence=>2
,p_query_column_name=>'ICON_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>8
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071316018906496.4001)
,p_column_sequence=>3
,p_query_column_name=>'ICON_IMAGE'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071402290906496.4001)
,p_column_sequence=>4
,p_query_column_name=>'ICON_SUBTEXT'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071502987906496.4001)
,p_column_sequence=>5
,p_query_column_name=>'ICON_IMAGE_ALT'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071601538906497.4001)
,p_column_sequence=>6
,p_query_column_name=>'ICON_HEIGHT'
,p_display_as=>'TEXT'
,p_column_width=>8
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071722147906497.4001)
,p_column_sequence=>7
,p_query_column_name=>'ICON_WIDTH'
,p_display_as=>'TEXT'
,p_column_width=>8
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(176318218517966690.4001)
,p_column_sequence=>8
,p_query_column_name=>'ICON_TARGET'
,p_display_as=>'TEXT'
,p_column_width=>30
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(166071813882906497.4001)
,p_column_sequence=>9
,p_query_column_name=>'ONCLICK'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166113803812969530.4001)
,p_plug_name=>unistr('Entradas de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166774401354873564.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(166766500720858594.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2159731444663655.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(166070830263906494.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Entrada'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:addRow();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166072014030906498.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(166113803812969530.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(166072904040906503.4001)
,p_branch_action=>'153'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(166072014030906498.4001)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 23-JAN-2002 20:06:26'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3832732439560151.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(166070830263906494.4001)
,p_validation_name=>'ICON_SEQUENCE'
,p_validation_sequence=>10
,p_validation=>'ICON_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #COLUMN_HEADER#.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'ICON_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166072529422906502.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(166070830263906494.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_ICON_BAR'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(166072014030906498.4001)
,p_process_success_message=>unistr('#MRU_COUNT# entrada(s) de barra de navegaci\00F3n actualizada(s).')
,p_process_comment=>'Generated 23-JAN-2002 20:06:26'
);
end;
/
prompt --application/pages/page_00154
begin
wwv_flow_api.create_page(
 p_id=>154.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51437001311244754.4001)
,p_plug_name=>unistr('Error de Instalaci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>No se ha podido instalar la aplicaci\00F3n porque ya existe en otro espacio de trabajo. Si desea instalar la aplicaci\00F3n, realice lo siguiente:</p>'),
'<ol>',
unistr('<li>Elimine la aplicaci\00F3n existente del espacio de trabajo en el que existe actualmente.</li>'),
'</ol>',
'O',
'<ol>',
unistr('<li>Cambie el identificador de aplicaci\00F3n en el archivo de exportaci\00F3n. Un identificador de aplicaci\00F3n que actualmente est\00E1 disponible y que puede utilizar es &P154_FLOW_ID..</li>'),
unistr('<li>Cargue el archivo de exportaci\00F3n cambiado en el repositorio y vuelva a instalar la aplicaci\00F3n.</li>'),
'</ol>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_security_group_id number := null;',
'begin',
'  for c1 in (select security_group_id',
'             from wwv_flows',
'             where id = :P49_NEW_FLOW_ID)',
'  loop',
'    l_security_group_id := c1.security_group_id;',
'  end loop;',
'  if l_security_group_id is not null then',
'    if l_security_group_id != :P49_LOGGED_IN_COMPANY then',
'       return true;    ',
'    end if;',
'  end if;',
'  return false;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(103586452520901305.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249630630203034086.4001)
,p_plug_name=>unistr('Error de Instalaci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p />La aplicaci\00F3n no se ha podido instalar porque el estado de creaci\00F3n es <i>S\00F3lo ejecutar aplicaci\00F3n</i>. Si desea instalar la aplicaci\00F3n, primero debe conectarse como administrador de espacio de trabajo y cambiar el estado de la aplicaci\00F3n con la')
||'s utilidades del espacio de trabajo.',
'<p />'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id                = :P49_NEW_FLOW_ID',
'   and build_status      = ''RUN_ONLY'' ',
'   and security_group_id = :P49_LOGGED_IN_COMPANY'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(103586577457901306.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(103586452520901305.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51446112926361623.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(51437001311244754.4001)
,p_button_name=>'EXPORT_REPOSITORY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Volver a Repositorio de Exportaci\00F3n')
,p_button_position=>'EDIT'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249718211482927579.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(249630630203034086.4001)
,p_button_name=>'EXPORT_REPOSITORY2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Volver a Repositorio de Exportaci\00F3n')
,p_button_position=>'EDIT'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51446409308361626.4001)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51442830887338415.4001)
,p_name=>'P154_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(51437001311244754.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(51444319244344517.4001)
,p_computation_sequence=>10
,p_computation_item=>'P154_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_flow'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00155
begin
wwv_flow_api.create_page(
 p_id=>155.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Desinstalar Objetos de Soporte'
,p_step_title=>'Desinstalar Objetos de Soporte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Add more spacing for checkboxes */',
'.apex-item-option {margin-bottom: 8px;margin-top: 4px;}',
'/* Floating radio group left so help icons shows correctly */',
'.apex-item-group {float: left;}'))
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_del.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85794765234345702.4001)
,p_plug_name=>'Desinstalar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86068574232737354.4001)
,p_plug_name=>unistr('Mensaje de Desinstalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
'where flow_id = :FB_FLOW_ID and deinstall_message is not null'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(276131761882380158.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(227753031474767408.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(971952811697342045.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(971952869494342046.4001)
,p_plug_name=>'Desinstalar Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48380550253598046.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(971952811697342045.4001)
,p_button_name=>'DEINSTALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Desinstalar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48380972505598051.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(971952811697342045.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P155_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48386122997598062.4001)
,p_branch_name=>'Go To Page 2111'
,p_branch_action=>'f?p=&APP_ID.:2111:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48380550253598046.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48377060636598038.4001)
,p_name=>'P155_PARSING_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(85794765234345702.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis')
,p_source=>'select owner from wwv_flows where id = :fb_flow_id and :fb_flow_id is not null'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica el esquema por defecto de la aplicaci\00F3n. El script de desinstalaci\00F3n tambi\00E9n se analizar\00E1 como este esquema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48377993629598039.4001)
,p_name=>'P155_DEINSTALLATION_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(85794765234345702.4001)
,p_prompt=>unistr('Opciones de Desinstalaci\00F3n')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REMOVE SUPPORTING OBJECTS CONFIRM'
,p_lov=>'.'||wwv_flow_api.id(48392517652618439.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Se ejecutar\00E1 el script de desinstalaci\00F3n definido en las definiciones de objeto de soporte de la aplicaci\00F3n &FB_FLOW_ID..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48378880912598040.4001)
,p_name=>'P155_CANCEL_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(85794765234345702.4001)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48379525713598043.4001)
,p_name=>'P155_DEINSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(86068574232737354.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags(deinstall_message) from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48382018936598055.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2111_DEINSTALL_SUCCESS_MESSAGE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(deinstall_success_message,',
'         null, ',
'         wwv_flow_lang.system_message(''INSTALLER.DEINSTALL_SUCCESS_MESSAGE''),',
'         wwv_flow_utilities.esc_non_basic_tags(deinstall_success_message))',
'  from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48382427829598055.4001)
,p_computation_sequence=>20
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48383210763598056.4001)
,p_computation_sequence=>30
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48382807176598055.4001)
,p_computation_sequence=>30
,p_computation_item=>'P155_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(:P155_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48383632013598056.4001)
,p_validation_name=>'P155_DEINSTALLATION_OPTIONS'
,p_validation_sequence=>10
,p_validation=>'P155_DEINSTALLATION_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe activar la casilla de control de desinstalaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(48377993629598039.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48385128041598060.4001)
,p_name=>'Deinstall'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(48380550253598046.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48385613890598061.4001)
,p_event_id=>wwv_flow_api.id(48385128041598060.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DEINSTALL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48383910898598056.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deinstall Database Objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.deinstall (',
'      p_install_id  => c1.id,',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_schema      => c1.owner',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido desinstalar la aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(48380550253598046.4001)
,p_process_when=>'DBOBJECTS'
,p_process_when_type=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
,p_process_when2=>'P155_DEINSTALLATION_OPTIONS'
,p_process_success_message=>unistr('Desinstalaci\00F3n correcta. ')
);
end;
/
prompt --application/pages/page_00156
begin
wwv_flow_api.create_page(
 p_id=>156.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso de Lista'
,p_step_title=>'Uso de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3702113071642994.4001)
,p_plug_name=>'Uso de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra todas las listas incluidas en la aplicaci\00F3n actual.</p>'),
unistr('<p>Para editar las entradas de lista, seleccione el nombre de la lista. Para ver las p\00E1ginas en las que aparece la lista, haga clic en el n\00FAmero en la columna P\00E1ginas.</p>')))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_col_allignments=>'L:R'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3707632683649133.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48551711725399629.4001)
,p_plug_name=>'Uso de Lista'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P156a */',
'       l.name as link, ',
'       ( select count(*)',
'           from wwv_flow_page_plugs p',
'          where p.list_id           = l.id',
'            and p.flow_id           = l.flow_id',
'            and p.security_group_id = l.security_group_id ) +',
'       ( select count(*)',
'           from wwv_flow_steps s',
'          where s.navigation_list_id = l.id',
'            and s.flow_id            = l.flow_id',
'            and s.security_group_id  = l.security_group_id ) +',
'       ( select count(*)',
'           from wwv_flow_user_interfaces ui',
'          where l.id                 in (ui.navigation_list_id, ui.nav_bar_list_id)',
'            and ui.flow_id            = l.flow_id',
'            and ui.security_group_id  = l.security_group_id ) as c,',
'       ( select count(*)',
'           from wwv_flow_list_items li',
'          where li.list_id           = l.id',
'            and li.flow_id           = l.flow_id',
'            and li.security_group_id = l.security_group_id ) as list_item_count,',
'       l.id as list_id',
'  from wwv_flow_lists l',
' where l.flow_id = :fb_flow_id',
'   and l.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48551809017399629.4001)
,p_name=>'List Utilization'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48552004606399636.4001)
,p_db_column_name=>'LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.::F4000_P4050_LIST_ID:#LIST_ID#'
,p_column_linktext=>'#LINK#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48552115184399639.4001)
,p_db_column_name=>'C'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1ginas')
,p_column_link=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:RIR,CIR:IR_LIST_ID,F4000_LAST_VIEW:#LIST_ID#,156'
,p_column_linktext=>'#C#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48552225361399641.4001)
,p_db_column_name=>'LIST_ITEM_COUNT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Entradas de Lista'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48552315666399642.4001)
,p_db_column_name=>'LIST_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'List_Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188939407336885460.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48551711725399629.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:156,RIR::'
);
end;
/
prompt --application/pages/page_00158
begin
wwv_flow_api.create_page(
 p_id=>158.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Regi\00F3n: Nuevas Plantillas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47962017388900492.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(177853322975972315.4001)
,p_name=>unistr('Crear Plantillas de Regi\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'id,',
'flow_id, ',
'PAGE_PLUG_TEMPLATE_NAME from_name,',
'wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',PAGE_PLUG_TEMPLATE_NAME) to_name,',
'''N'' Sub',
'from wwv_flow_page_plug_templates',
'where flow_id = :F4000_P4320_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and theme_id = :P498_COPY_FROM_THEME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ninguna plantilla de regi\00F3n.</font>')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150874821141661366.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150874408588661365.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291264412909256044.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(150877308719670809.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>50
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291264526399256044.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177859514348976310.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177861716897978727.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47962017388900492.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(275752210.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(47962017388900492.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar Plantillas de Regi\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177866831095982858.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47962017388900492.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(279888699.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(275752210.4001)
,p_branch_sequence=>22
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589948147255621426.4001)
,p_branch_action=>'f?p=&APP_ID.:498:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177866831095982858.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74592512361547109.4001)
,p_name=>'P158_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177853322975972315.4001)
,p_prompt=>'Copiar en Tema:'
,p_source=>'P498_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291367819751276943.4001)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Debe seleccionar al menos una plantilla que copiar.',
'',
''))
,p_when_button_pressed=>wwv_flow_api.id(275752210.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291369800835280950.4001)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select page_plug_template_name',
'                  from wwv_flow_page_plug_templates',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and page_plug_template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.page_plug_template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.page_plug_template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.page_plug_template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(275752210.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589947908221621424.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(177861716897978727.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589948010092621425.4001)
,p_event_id=>wwv_flow_api.id(589947908221621424.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(278815634.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Region Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_plug (',
'      p_copy_from_flow_id    => :F4000_P4320_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :FB_FLOW_ID,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p158_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'      );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_region_template (',
'        p_master_template_id      => wwv_flow.g_f01(i),',
'        p_subscribing_template_id => l_template_id',
'      );',
'    end if;    ',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar las plantillas de regi\00F3n.#SQLERRM_TEXT#')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(275752210.4001)
,p_process_success_message=>unistr('Plantillas de regi\00F3n copiadas.')
);
end;
/
prompt --application/pages/page_00159
begin
wwv_flow_api.create_page(
 p_id=>159.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Lista: Nuevas Plantillas'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(178279512234518293.4001)
,p_name=>'Crear Plantilla de Lista'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id, ',
'  list_template_name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',list_template_name) to_name,',
'  ''N'' sub',
'  from wwv_flow_list_templates ',
'  where flow_id = :F4000_P4069_COPY_FROM_FLOW_ID',
'  and security_group_id = :flow_security_group_id',
'  and theme_id = :P412_COPY_FROM_THEME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No se ha encontrado ninguna plantilla de lista.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289893601622920030.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289893710237920030.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289893814618920030.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289893931542920031.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289894002600920031.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178283102961522594.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186374530491150301.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178289517345529249.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(186374530491150301.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12260552258.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186374530491150301.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Plantillas de Lista'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178292114359537840.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186374530491150301.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154533528577128011.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585125414403099817.4001)
,p_branch_action=>'f?p=&APP_ID.:412:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178292114359537840.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74789601635619728.4001)
,p_name=>'P159_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178279512234518293.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P412_COPY_TO_THEME.'
,p_prompt=>'Copiar en Tema:'
,p_source=>'&P412_COPY_TO_THEME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(289900226518974544.4001)
,p_validation_name=>'template selected to copy'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos una plantilla que copiar.'
,p_when_button_pressed=>wwv_flow_api.id(12260552258.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(289918828615126548.4001)
,p_validation_name=>'NoDupeNames'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select list_template_name',
'                  from WWV_FLOW_LIST_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and list_template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.list_template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.list_template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.list_template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(12260552258.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585125239274099815.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(178289517345529249.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585125367701099816.4001)
,p_event_id=>wwv_flow_api.id(585125239274099815.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12282618489.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_list_template (',
'      p_copy_from_flow_id => :F4000_P4069_COPY_FROM_FLOW_ID,',
'      p_to_flow_id => :FB_FLOW_ID,',
'      p_from_template_id => wwv_flow.g_f01(i),',
'      p_to_template_name => wwv_flow.g_f02(i),',
'      p_to_template_id   => l_template_id,',
'      p_to_theme_id      => :p159_theme, ',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_list_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar las plantillas de lista.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(12260552258.4001)
,p_process_success_message=>'Plantillas de lista copiadas.'
);
end;
/
prompt --application/pages/page_00160
begin
wwv_flow_api.create_page(
 p_id=>160.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Panel de Control'
,p_step_title=>'Panel de Control'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176250390163916903.4001)
,p_plug_name=>unistr('Uso de componente de regi\00F3n nativo')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(176250498555916904.4001)
,p_region_id=>wwv_flow_api.id(176250390163916903.4001)
,p_chart_type=>'bar'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(176250538400916905.4001)
,p_chart_id=>wwv_flow_api.id(176250498555916904.4001)
,p_seq=>10
,p_name=>'Uso de componente nativo'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from   wwv_flow_page_plugs r',
'where  plug_source_type not like ''PLUGIN%'' and ',
'       security_group_id = :flow_security_group_id',
'group by substr(plug_source_type,8)',
'order by 2 desc',
''))
,p_max_row_count=>100
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(176250637211916906.4001)
,p_chart_id=>wwv_flow_api.id(176250498555916904.4001)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(176250798597916907.4001)
,p_chart_id=>wwv_flow_api.id(176250498555916904.4001)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698803155967413324.4001)
,p_plug_name=>unistr('Recuento de P\00E1ginas por Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id||'': ''||application_name d, (select count(*) from apex_application_pages p where p.application_id = a.application_id) c ',
'from apex_applications a',
'where WORKSPACE_ID = :FLOW_SECURITY_GROUP_ID ',
'order by 2 desc'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'INITIALS'
,p_attribute_02=>'D'
,p_attribute_04=>'C'
,p_attribute_11=>'VALUE'
,p_attribute_14=>'25'
,p_attribute_15=>'TEXT'
,p_attribute_16=>'ABSOLUTE'
,p_attribute_17=>'DEFAULT'
,p_attribute_18=>'AROUND'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698804112339413334.4001)
,p_plug_name=>'Aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session varchar2(255) := :APP_SESSION;',
'    l_security_group_id number := :FLOW_SECURITY_GROUP_ID;',
'begin',
'    -- applications',
'    for c1 in ( select /* APEX4000160SR66 */ count(*) applications',
'                from wwv_flows',
'                where security_group_id = l_security_group_id',
'            ) loop',
'',
'            sys.htp.p(''<div class="a-BadgeChart">'');',
'            sys.htp.p(''  <a href="f?p=4000:1500:''||l_session||''::::P1500_SHOW:DATABASE" title="''||wwv_flow_lang.system_message(''F4000_APPLICATIONS'')||''" class="a-BadgeChart-link">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-value">''||c1.applications||'' </span> '');',
'            sys.htp.p(''  </a>'');',
'            sys.htp.p(''  <div class="a-BadgeChart-text">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-label">''||wwv_flow_lang.system_message(''F4000_APPLICATIONS'')||''</span>'');',
'            sys.htp.p(''    <span class="a-BadgeChart-desc">'');',
'            sys.htp.p(''    </span>'');',
'            sys.htp.p(''  </div>'');',
'            sys.htp.p(''</div>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698804288016413335.4001)
,p_plug_name=>unistr('Total de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session varchar2(255) := :APP_SESSION;',
'    l_security_group_id number := :FLOW_SECURITY_GROUP_ID;',
'begin',
'    -- applications',
'    for c1 in ( select /* APEX4000160SR66 */ count(*) pages',
'                from wwv_flow_steps',
'                where security_group_id = l_security_group_id',
'            ) loop',
'',
'            sys.htp.p(''<div class="a-BadgeChart">'');',
'            sys.htp.p(''  <a href="#" title="''||wwv_flow_lang.system_message(''CONFIRM.PAGES'')||''" class="a-BadgeChart-link">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-value">''||to_char(c1.pages,''999G999G990'')||'' </span> '');',
'            sys.htp.p(''  </a>'');',
'            sys.htp.p(''  <div class="a-BadgeChart-text">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-label">''||wwv_flow_lang.system_message(''PAGES'')||''</span>'');',
'            sys.htp.p(''    <span class="a-BadgeChart-desc">'');',
'            sys.htp.p(''    </span>'');',
'            sys.htp.p(''  </div>'');',
'            sys.htp.p(''</div>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698804436098413337.4001)
,p_plug_name=>unistr('Aplicaciones de Hoja de C\00E1lculo Web')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session varchar2(255) := :APP_SESSION;',
'    l_security_group_id number := :FLOW_SECURITY_GROUP_ID;',
'begin',
'    for c1 in ( select /* APEXDASHMJH66WS */ count(*) cnt',
'                from wwv_flow_ws_applications',
'                where security_group_id = l_security_group_id',
'            ) loop',
'',
'            sys.htp.p(''<div class="a-BadgeChart">'');',
'            sys.htp.p(''  <a href="f?p=4000:1500:''||l_session||''::::P1500_SHOW:WEBSHEET" title="''||wwv_flow_lang.system_message(''WEBSHEETS'')||''" class="a-BadgeChart-link">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-value">''||to_char(c1.cnt,''999G999G990'')||'' </span> '');',
'            sys.htp.p(''  </a>'');',
'            sys.htp.p(''  <div class="a-BadgeChart-text">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-label">''||wwv_flow_lang.system_message(''WEBSHEETS'')||''</span>'');',
'            sys.htp.p(''    <span class="a-BadgeChart-desc">'');',
'            sys.htp.p(''    </span>'');',
'            sys.htp.p(''  </div>'');',
'            sys.htp.p(''</div>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
,p_plug_required_role=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(713095952865315417.4001)
,p_plug_name=>unistr('Eventos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(713096089636315418.4001)
,p_region_id=>wwv_flow_api.id(713095952865315417.4001)
,p_chart_type=>'lineWithArea'
,p_height=>'414'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>false
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(713096128083315419.4001)
,p_chart_id=>wwv_flow_api.id(713096089636315418.4001)
,p_seq=>10
,p_name=>unistr('Eventos de P\00E1gina')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    to_date(to_char(time_stamp,''DDMMYYYYHH24''), ''DDMMYYYYHH24'') day,',
'    count(*) page_events',
'from WWV_FLOW_ACTIVITY_LOG l',
'where time_stamp > sysdate - 7 and security_group_id = :FLOW_SECURITY_GROUP_ID',
'group by to_date(to_char(time_stamp,''DDMMYYYYHH24''), ''DDMMYYYYHH24'')',
'order by 1'))
,p_items_value_column_name=>'PAGE_EVENTS'
,p_items_label_column_name=>'DAY'
,p_color=>'#EB4C4C'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(713096385359315421.4001)
,p_chart_id=>wwv_flow_api.id(713096089636315418.4001)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(713096232914315420.4001)
,p_chart_id=>wwv_flow_api.id(713096089636315418.4001)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(713096464448315422.4001)
,p_plug_name=>unistr('P\00E1ginas con Mayor Actividad')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(713096515470315423.4001)
,p_region_id=>wwv_flow_api.id(713096464448315422.4001)
,p_chart_type=>'bar'
,p_height=>'414'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(713096608011315424.4001)
,p_chart_id=>wwv_flow_api.id(713096515470315423.4001)
,p_seq=>10
,p_name=>unistr('Aciertos de P\00E1gina')
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'    select /* APEX4350P190aMJH */',
'          flow_id||'':''||step_id d,',
'          rnk r,',
'          cnt, ',
'          round(( rtr * 100),2) rtr',
'      from(',
'        select flow_id,step_id,cnt,',
'               dense_rank() over(order by cnt desc) rnk,',
'               ratio_to_report(cnt) over () rtr',
'          from (',
'            select flow_id,step_id,count(*) cnt',
'              from wwv_flow_activity_log l',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID and page_mode != ''A''',
'             group by flow_id,step_id',
'            having exists',
'                     (select 1',
'                        from wwv_flows',
'                       where id = l.flow_id',
'                         and security_group_id = :FLOW_SECURITY_GROUP_ID))',
'          ) xf',
'    order by 4 desc',
') where rownum < 6'))
,p_items_value_column_name=>'CNT'
,p_items_label_column_name=>'D'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(713096792414315425.4001)
,p_chart_id=>wwv_flow_api.id(713096515470315423.4001)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(713096842246315426.4001)
,p_chart_id=>wwv_flow_api.id(713096515470315423.4001)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(713096981940315427.4001)
,p_plug_name=>unistr('Actividad del Desarrollador (\00DAltimos 2 D\00EDas)')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(713097091860315428.4001)
,p_region_id=>wwv_flow_api.id(713096981940315427.4001)
,p_chart_type=>'pie'
,p_height=>'414'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_value_format_type=>'decimal'
,p_value_decimal_places=>0
,p_value_format_scaling=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_pie_other_threshold=>0
,p_pie_selection_effect=>'highlight'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ){ ',
'',
'    this.pieSliceLabel = function(dataContext){',
'        var percent = Math.round(dataContext.value/dataContext.totalValue*100);',
'        return dataContext.seriesData.name +" "+percent+"% ("+dataContext.value+")";',
'    }',
'',
'    options.dataLabel = pieSliceLabel; ',
'    return options; ',
'}',
'',
'',
'       '))
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(713097103881315429.4001)
,p_chart_id=>wwv_flow_api.id(713097091860315428.4001)
,p_seq=>10
,p_name=>'Nuevo'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  flow_user developer,',
'  count(*) page_views',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - 2 and ',
'  security_group_id = :flow_security_group_id',
'group by ',
'  flow_user'))
,p_items_value_column_name=>'PAGE_VIEWS'
,p_items_label_column_name=>'DEVELOPER'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideSlice'
,p_items_label_display_as=>'LABEL'
,p_threshold_display=>'onIndicator'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(787290833226287714.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>M\00E9tricas sobre aplicaciones en su espacio de trabajo.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(787393288932481892.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00161
begin
wwv_flow_api.create_page(
 p_id=>161.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Calendario Heredado: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Calendario Heredado'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18898316360877050.4001)
,p_plug_name=>'Crear Plantilla de Calendario Heredado'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p> ')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18899106801877060.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(19035021988626357.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186386405791285108.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18899911747877068.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186386405791285108.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18900324527877072.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186386405791285108.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41910113670602318.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186386405791285108.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18910702334901555.4001)
,p_branch_action=>'f?p=&FLOW_ID.:349:&SESSION.::&DEBUG.:RP,349::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(18900324527877072.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P161_TYPE'
,p_branch_condition_text=>'BLANK'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38360630082953713.4001)
,p_branch_action=>'f?p=&FLOW_ID.:468:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(18900324527877072.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P161_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589886436114923009.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(41910113670602318.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18900707135877074.4001)
,p_name=>'P161_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18898316360877050.4001)
,p_item_default=>'COPY'
,p_prompt=>'Crear Plantilla de Calendario:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.TEMPLATE.OPTS'
,p_lov=>'.'||wwv_flow_api.id(88108326304250090.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla de calendario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589886277488923007.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(18899911747877068.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589886312228923008.4001)
,p_event_id=>wwv_flow_api.id(589886277488923007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00162
begin
wwv_flow_api.create_page(
 p_id=>162.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17578608235069855.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19408132682545305.4001)
,p_plug_name=>'Crear Plantilla'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47945303593650508.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19417212643567978.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47945303593650508.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19415731905564047.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47945303593650508.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19433615769644543.4001)
,p_branch_action=>'P162_TEMPLATE_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_URL_IDENT_BY_ITEM'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19411632467554734.4001)
,p_name=>'P162_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19408132682545305.4001)
,p_prompt=>'Tipo de Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''f?p=4000:920:&''||',
'       ''SESSION.:::920,921,922,923,924,26,144'' x ',
'from dual'))
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'TEMPLATE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(84868022945400324.4001)||'.'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tipo de plantilla que desea crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589948349959621428.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(19417212643567978.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589948446304621429.4001)
,p_event_id=>wwv_flow_api.id(589948349959621428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00163
begin
wwv_flow_api.create_page(
 p_id=>163.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Importar: Confirmaci\00F3n de Importaci\00F3n de Archivo')
,p_step_title=>unistr('Importar: Confirmaci\00F3n de Importaci\00F3n de Archivo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215592520464926917)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37905502661491226.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44690514705686202.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(53544817709944619.4001)
,p_plug_name=>'Archivo Importado Correctamente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El archivo de exportaci\00F3n se ha importado correctamente.</p>'),
unistr('<p>Si desea instalarlo ahora, haga clic en el bot\00F3n <strong>Siguiente</strong>. Tambi\00E9n puede instalar este archivo m\00E1s tarde'),
unistr('navegando al repositorio de exportaci\00F3n.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226318928584082367.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(38836703962860678.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138052634138153.4001)
,p_plug_name=>'Importar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75642906699411821.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44690514705686202.4001)
,p_button_name=>'CANCEL1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53562032001005557.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44690514705686202.4001)
,p_button_name=>'Install'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217434614987057517.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44690514705686202.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(53562303043005561.4001)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49:P49_FILE_ID:&P163_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562032001005557.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'FLOW_EXPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(503962203312827415.4001)
,p_branch_name=>'Go To Page 494'
,p_branch_action=>'f?p=&APP_ID.:494:&SESSION.::&DEBUG.:494:P494_FILE_ID:&P163_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562032001005557.4001)
,p_branch_sequence=>15
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'WEBSHEET_EXPORT'
,p_save_state_before_branch_yn=>'Y'
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77826408668266575.4001)
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::P49_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562032001005557.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'PAGE_EXPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(141394706662121859.4001)
,p_branch_action=>'f?p=&APP_ID.:253:&SESSION.::&DEBUG.::P253_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562032001005557.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'THEME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(160720230953218415.4001)
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.::P321_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562032001005557.4001)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30416132128215446.4001)
,p_branch_name=>'Go To Page 4450'
,p_branch_action=>'f?p=&APP_ID.:4450:&SESSION.::&DEBUG.:4450:P4450_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(53562032001005557.4001)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'PLUGIN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472715209002804237.4001)
,p_branch_action=>'f?p=&APP_ID.:929:&SESSION.::&DEBUG.::P929_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'FEEDBACK'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2717654105216211.4001)
,p_branch_name=>'Go To Page 1966'
,p_branch_action=>'f?p=&APP_ID.:1966:&SESSION.::&DEBUG.:1966:P1966_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'CATALOG'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53575930756090336.4001)
,p_name=>'P163_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(53544817709944619.4001)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(53792028070788310.4001)
,p_validation_name=>'only internal can import company'
,p_validation_sequence=>10
,p_validation=>':flow_security_group_id = 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('S\00F3lo el espacio de trabajo interno puede instalar informaci\00F3n de espacio de trabajo.')
,p_validation_condition=>'P460_FILE_TYPE'
,p_validation_condition2=>'COMPANY_EXPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(53562032001005557.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00164
begin
wwv_flow_api.create_page(
 p_id=>164.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Exportar P\00E1gina')
,p_step_title=>unistr('Exportar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44698213151723625.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47041117428339658.4001)
,p_plug_name=>unistr('Exportar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_header=>unistr('<p>Exportar la p\00E1gina seleccionada. Las p\00E1ginas pueden hacer referencia a los componentes compartidos que se van a exportar. Para exportar toda la aplicaci\00F3n debe realizar la exportaci\00F3n de la aplicaci\00F3n completa. La exportaci\00F3n de cada p\00E1gina no es ')
||unistr('lo mismo que la exportaci\00F3n de una aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(234484820705989157.4001)
,p_plug_name=>'interesting page attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445354008407710115.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445352903500710112.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138145611138153.4001)
,p_plug_name=>unistr('Exportar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(44700521940735619.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44698213151723625.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47047810549366053.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44698213151723625.4001)
,p_button_name=>'ExportMultiplePages'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Exportar P\00E1gina')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47057024279436255.4001)
,p_branch_action=>'f?p=&FLOW_ID.:164:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2856950911881118.4001)
,p_name=>'P164_EXPORT_ZIP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar como ZIP'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para exportar como un archivo ZIP que contiene archivos SQL distintos para la p\00E1gina.</p>'),
'',
'<p>',
unistr('Seleccione <strong>Desactivado</strong> para exportar como un \00FAnico archivo SQL.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2857627886881125.4001)
,p_name=>'P164_WITH_INSTALL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Incluir archivos de instalaci\00F3n')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para generar un archivo ZIP que incluya archivos de instalaci\00F3n espec\00EDficos para la p\00E1gina exportada (por ejemplo, install.sql, set_environment.sql y end_environment.sql).</p>'),
'<p>',
unistr('Seleccione <strong>Desactivado</strong> para generar un archivo ZIP sin los archivos de instalaci\00F3n. Se recomienda esta opci\00F3n al guardar los archivos en un sistema de control de versiones, de forma que los archivos de instalaci\00F3n de la aplicaci\00F3n no')
||' se sobrescriban. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47042006478345945.4001)
,p_name=>'P143_MPAGE_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n que desea exportar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47042917213349049.4001)
,p_name=>'P164_MEXPORT_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||wwv_flow_escape.html(name) n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>10
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifique la p\00E1gina que desea exportar. S\00F3lo puede seleccionar una p\00E1gina para la exportaci\00F3n a la vez.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47043825871351563.4001)
,p_name=>'P164_MPAGE_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo se formatear\00E1n las filas del archivo de exportaci\00F3n:'),
'<ul>',
unistr('<li>Seleccione <strong>UNIX</strong> para que el archivo resultante contenga filas delimitadas por saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>DOS</strong> para que el archivo resultante contenga filas delimitadas por retornos de carro y saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47044702799354284.4001)
,p_name=>'P164_FLASHBACK_MIN_AGO'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_prompt=>'A partir de'
,p_post_element_text=>'<span class="fielddata">minutos antes (~ 5 minutos de retraso)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_display_when=>'P164_MPAGE_FORMAT'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Especifique un tiempo en minutos para volver atr\00E1s en la exportaci\00F3n. Esta opci\00F3n permite volver en el tiempo en la aplicaci\00F3n, quiz\00E1s para recuperar un objeto suprimido.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Esta utilidad utiliza el <code>paquete dbms_flashback</code>. La asignaci\00F3n de registro de hora a SCN (N\00FAmero de Cambio del Sistema) se refresca cada 5 minutos aproximadamente, por lo que tal vez tenga que esperar ese esp')
||unistr('acio de tiempo para obtener la versi\00F3n que est\00E1 buscando. El tiempo que se mantiene la informaci\00F3n de deshacer depende del par\00E1metro de inicio <code>undo_retention</code> (tres horas por defecto), pero esto s\00F3lo afecta al tama\00F1o del tablespace de des')
||'hacer.</div>',
unistr('<div class="htmldbInfoBodyP">Mientras que dos bases de datos pueden tener el mismo par\00E1metro <code>undo_retention</code>, puede volver atr\00E1s en el tiempo en la base de datos con menos transacciones, ya que las transacciones no est\00E1n rellenando el tab')
||unistr('lespace de deshacer, forzando as\00ED el archivado de los datos m\00E1s antiguos.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160653406658964518.4001)
,p_name=>'P164_MPAGE_FILE_CHARSET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(47041117428339658.4001)
,p_prompt=>'Juego de Caracteres de Archivo'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el juego de caracteres en el que se codificar\00E1 el archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(234429809005891173.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   r varchar2(255) := null;',
'   n number;',
'begin',
'   begin',
'      n := v(''P164_PAGE'');',
'      return :P164_PAGE;',
'   exception when others then',
'   for c1 in (select id from wwv_flow_steps where flow_id = :fb_flow_id and alias = upper(:P164_PAGE)) loop',
'       r := c1.id;',
'   end loop;',
'   return nvl(r,:FB_FLOW_PAGE_ID);',
'   end;',
'end;'))
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(234437824720905188.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare p number := 1;',
'begin',
'if wwv_flow.g_request = ''PREVIOUS'' then',
'  select max(id) into p from wwv_flow_steps where id < :FB_FLOW_PAGE_ID',
'  and flow_id = :FB_FLOW_ID;',
'  return p;',
'elsif wwv_flow.g_request = ''NEXT'' then',
'  select min(id) into p from wwv_flow_steps where id > :FB_FLOW_PAGE_ID',
'  and flow_id = :FB_FLOW_ID;',
'  return p;',
'end if;',
'end;'))
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(77328108177604625.4001)
,p_validation_name=>'pages not null'
,p_validation_sequence=>10
,p_validation=>'P164_MEXPORT_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Seleccione al menos una p\00E1gina para exportar.')
,p_when_button_pressed=>wwv_flow_api.id(47047810549366053.4001)
,p_associated_item=>wwv_flow_api.id(47042917213349049.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2857721043881126.4001)
,p_name=>'Toggle Installation Files'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P164_EXPORT_ZIP'
,p_condition_element=>'P164_EXPORT_ZIP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2857896893881127.4001)
,p_event_id=>wwv_flow_api.id(2857721043881126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P164_WITH_INSTALL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2857908877881128.4001)
,p_event_id=>wwv_flow_api.id(2857721043881126.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P164_WITH_INSTALL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(620127025.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_page (',
'    p_application_id    => :P143_MPAGE_FLOW,',
'    p_page_id           => :P164_MEXPORT_PAGE_ID,',
'    p_format            => case ',
'                           when :P164_EXPORT_ZIP = ''Y'' then ''ZIP_UNIX'' ',
'                           else ''UNIX'' ',
'                           end,',
'    p_flashback_min_ago => :P164_FLASHBACK_MIN_AGO, ',
'                           -- always include install when NOT a zip',
'    p_with_install      => :P164_EXPORT_ZIP != ''Y'' or ',
'                           -- export install if requested when zip',
'                           :P164_WITH_INSTALL = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al exportar la p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(47047810549366053.4001)
,p_process_success_message=>unistr('P\00E1ginas exportadas.')
);
end;
/
prompt --application/pages/page_00168
begin
wwv_flow_api.create_page(
 p_id=>168.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Informe: Nuevas Plantillas'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47969405492963267.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(178534708443203867.4001)
,p_name=>'Crear Plantilla de Informe'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'  ROW_TEMPLATE_NAME from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',ROW_TEMPLATE_NAME) to_name,',
'  ''N'' Sub',
'from wwv_flow_row_templates ',
'where flow_id = :F4000_P4321_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P343_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No se ha encontrado ninguna plantilla de informe.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289909810335026626.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289909909719026626.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289910015611026626.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289910105457026626.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289910226324026626.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178537831722208232.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178542728164213645.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47969405492963267.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(395455264.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47969405492963267.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Plantillas de Informe'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178545305785216600.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47969405492963267.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152102513500942314.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589946142770621406.4001)
,p_branch_action=>'f?p=&APP_ID.:343:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178545305785216600.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74734020635596860.4001)
,p_name=>'P168_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178534708443203867.4001)
,p_prompt=>'Copiar en Tema:'
,p_source=>'P343_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(289914212984093608.4001)
,p_validation_name=>'template select to copy'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos una plantilla que copiar.'
,p_when_button_pressed=>wwv_flow_api.id(395455264.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(93415326260429643.4001)
,p_validation_name=>'NoDupTemplateNames'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select row_template_name',
'                  from WWV_FLOW_ROW_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and row_template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.row_template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.row_template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.row_template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error.'
,p_when_button_pressed=>wwv_flow_api.id(395455264.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589945954508621404.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(178542728164213645.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589946053808621405.4001)
,p_event_id=>wwv_flow_api.id(589945954508621404.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(398503355.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Row Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_row_template (',
'    p_copy_from_flow_id    => :F4000_P4321_COPY_FROM_FLOW_ID,',
'    p_to_flow_id           => :FB_FLOW_ID,',
'    p_from_template_id     => wwv_flow.g_f01(i),',
'    p_to_template_name     => wwv_flow.g_f02(i),',
'    p_to_template_id       => l_template_id,',
'    p_to_theme_id          => :p168_theme,',
'    p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_report_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar las plantillas de informe.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(395455264.4001)
,p_process_success_message=>'Plantillas de informe copiadas.'
);
end;
/
prompt --application/pages/page_00169
begin
wwv_flow_api.create_page(
 p_id=>169.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Lista de Valores, Editar Texto Nulo'
,p_step_title=>'Lista de Valores, Editar Texto Nulo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47154208064258102.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(81020318009647954.4001)
,p_name=>'Edit List of Values Null Display Values'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P169a */',
'"ID",',
'"FLOW_STEP_ID",',
'"NAME",',
'DISPLAY_AS,',
'LOV_DISPLAY_NULL,',
'"LOV_NULL_TEXT",',
'"LOV_NULL_VALUE"',
'  from WWV_FLOW_STEP_ITEMS',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id',
'   and lov is not null ',
'   and (:P169_LOV_NULL_TEXT_CONTAINS is null or',
'        instr(upper(lov_null_text),upper(:P169_LOV_NULL_TEXT_CONTAINS)) > 0) and',
'        (:P169_SHOW is null or :P169_SHOW = ''ALL'' or display_as = ''NATIVE_POPUP_LOV'')',
'   and (:P169_DISPLAY_NULL is null or :P169_DISPLAY_NULL = ''0'' or lov_display_null = :P169_DISPLAY_NULL)',
' order by flow_step_id, name'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P169_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 14-JUL-2003 17:41:02'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81020828595647963.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81020927299647965.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81021007796647965.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Elemento'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(138202529261849308.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>4
,p_column_heading=>'Mostrar como'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29353308376249352)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(138207420645882790.4001)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISPLAY_NULL'
,p_column_display_sequence=>5
,p_column_heading=>'Mostrar Nulo'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84270019143507704)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81021102346647965.4001)
,p_query_column_id=>6
,p_column_alias=>'LOV_NULL_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Texto Nulo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>30
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81021229652647966.4001)
,p_query_column_id=>7
,p_column_alias=>'LOV_NULL_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Valor de Retorno'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(81025531237652930.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(81025620204652930.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(81025703546652930.4001)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(138202221502849299.4001)
,p_column_sequence=>4
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(138207116991882788.4001)
,p_column_sequence=>5
,p_query_column_name=>'LOV_DISPLAY_NULL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(81025825527652930.4001)
,p_column_sequence=>6
,p_query_column_name=>'LOV_NULL_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(81025931301652930.4001)
,p_column_sequence=>7
,p_query_column_name=>'LOV_NULL_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187935715440862725.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81043404057682918.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_button_name=>'P169_GO'
,p_button_static_id=>'P169_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188988724554984090.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:169:&SESSION.::&DEBUG.:RP,169::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(81021414803647967.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(81022232708647975.4001)
,p_branch_action=>'f?p=&FLOW_ID.:169:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 14-JUL-2003 17:41:03'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81042425397679583.4001)
,p_name=>'P169_LOV_NULL_TEXT_CONTAINS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_prompt=>'El Texto Contiene:'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Busque el texto nulo de lista de valores que contenga esta cadena. Introduzca una cadena y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138224427514919344.4001)
,p_name=>'P169_DISPLAY_NULL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_prompt=>'Mostrar Nulo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov=>'.'||wwv_flow_api.id(84270019143507704.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione <strong>S\00ED</strong> para mostrar listas de valores que incluyan una opci\00F3n nula. Seleccione <strong>No</strong> para mostrar listas de valores que no incluyan una opci\00F3n nula.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138229807606951438.4001)
,p_name=>'P169_SHOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_item_default=>'ALL'
,p_prompt=>'Mostrar'
,p_source=>'ALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHOW ALL LOV'
,p_lov=>'.'||wwv_flow_api.id(138231514317962802.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtre por listas de valores emergentes. Seleccione <strong>S\00F3lo Emergentes</strong> y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180347417064585718.4001)
,p_name=>'P169_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(187935715440862725.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de entradas que aparecer\00E1n y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(81021801411647970.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(81020318009647954.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEMS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(81021414803647967.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_process_comment=>'Generated 14-JUL-2003 17:41:03'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(138223032232911292.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(81043404057682918.4001)
);
end;
/
prompt --application/pages/page_00170
begin
wwv_flow_api.create_page(
 p_id=>170.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Referencias de Servicio Web'
,p_step_title=>'Referencias de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11272929095288976.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11271810048283515.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47844726510922430.4001)
,p_plug_name=>'Referencias de Servicio Web'
,p_region_name=>'WS_REPORT'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P170a */',
'   name as e,',
'   decode( action,',
'           ''NEW_SCHOOL'', wwv_flow_utilities.prepare_url( ''f?p=4000:599:'' || :flow_SESSION || ''::NO::P599_ID:'' ||',
'                                                         wwv_flow_escape.html(ID) ),',
'           ''REST'', wwv_flow_utilities.prepare_url( ''f?p=4000:876:'' || :flow_SESSION || ''::NO:876:P876_ID:'' ||',
'                                                   wwv_flow_escape.html(ID) ),',
'           wwv_flow_utilities.prepare_url( ''f?p=4000:196:'' || :flow_SESSION || ''::NO:196:F4000_P196_ID:'' ||',
'                                           wwv_flow_escape.html(ID) )',
'         ) as e_link,',
'   decode( action,',
'           ''NEW_SCHOOL'', ''<a href="'' || wwv_flow_utilities.prepare_url( ''f?p=4000:589:'' || :flow_session || ''::NO:589:P589_ID:'' ||',
'                                                                        wwv_flow_escape.html(id) ) ||',
'                         ''" class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI">'' ||',
'                         ''<span class="a-Icon icon-search"></span></a>'',',
'           '''') as n,',
'   URL,',
'   decode( action,',
'           ''NEW_SCHOOL'', wwv_flow_utilities.prepare_url( ''f?p=4000:588:'' || :flow_session ||',
'                                                         ''::NO:588:P588_ID:'' || wwv_flow_escape.html(id) ),',
'           ''REST'', wwv_flow_utilities.prepare_url( ''f?p=4000:875:'' || :flow_session || ''::NO:875:P875_ID:'' ||',
'                                                   wwv_flow_escape.html(id) ),',
'           wwv_flow_utilities.prepare_url( ''f?p=4000:226:'' || :flow_session || ''::NO:226:F4000_P226_ID:'' ||',
'                                           wwv_flow_escape.html(id) )',
'         ) as run,',
'   ''icon-sc-web-service'' as icon,',
'   name as alt,',
'   decode( action,',
'           ''NEW_SCHOOL'', wwv_flow_utilities.prepare_url( ''f?p=4000:599:'' || :flow_SESSION || ''::NO::P599_ID:'' || ID ),',
'           ''REST'', wwv_flow_utilities.prepare_url( ''f?p=4000:876:'' || :flow_SESSION || ''::NO:876:P876_ID:'' || ID ),',
'           wwv_flow_utilities.prepare_url( ''f?p=4000:196:'' || :flow_SESSION || ''::NO::F4000_P196_ID:'' || ID )',
'         ) as image_link,',
'LAST_UPDATED_BY, ',
'LAST_UPDATED_ON,',
'created_by,',
'created_on ',
'from   WWV_FLOW_SHARED_WEB_SERVICES',
'where SECURITY_GROUP_ID = :flow_security_group_id and FLOW_ID = :fb_flow_id ',
'order  by upper(name)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47844825293922430.4001)
,p_name=>'Web Service References'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>' '
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#IMAGE_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#ALT#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47845008893922438.4001)
,p_db_column_name=>'E'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_link=>'#E_LINK#'
,p_column_linktext=>'#E#'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1143245000653567403.4001)
,p_db_column_name=>'E_LINK'
,p_display_order=>11
,p_column_identifier=>'M'
,p_column_label=>unistr('Enlace de Correo Electr\00F3nico')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47845210094922439.4001)
,p_db_column_name=>'URL'
,p_display_order=>21
,p_column_identifier=>'C'
,p_column_label=>'URL'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47845324327922440.4001)
,p_db_column_name=>'RUN'
,p_display_order=>31
,p_column_identifier=>'D'
,p_column_label=>'Probar'
,p_column_link=>'#RUN#'
,p_column_linktext=>'<span class="a-Icon icon-run-script"></span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47845106848922439.4001)
,p_db_column_name=>'N'
,p_display_order=>41
,p_column_identifier=>'B'
,p_column_label=>'Ver'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47845513191922441.4001)
,p_db_column_name=>'ALT'
,p_display_order=>51
,p_column_identifier=>'F'
,p_column_label=>'Alternativo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47845609753922441.4001)
,p_db_column_name=>'IMAGE_LINK'
,p_display_order=>61
,p_column_identifier=>'G'
,p_column_label=>'Enlace de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47852530842964278.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>71
,p_column_identifier=>'H'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47852601685964279.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>81
,p_column_identifier=>'I'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47852717475964279.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>91
,p_column_identifier=>'J'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47852825783964280.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>101
,p_column_identifier=>'K'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(646446985035509110.4001)
,p_db_column_name=>'ICON'
,p_display_order=>111
,p_column_identifier=>'L'
,p_column_label=>'ICONO'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86327928867226192.4001)
,p_plug_name=>'Referencias de Servicio Web'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El motor de &PRODUCT_NAME. puede utilizar las referencias de servicio web para acceder a un servicio web a trav\00E9s de la red. El servicio web realiza'),
unistr('una acci\00F3n y, a continuaci\00F3n, devuelve una respuesta.</p>'),
'',
'<p>Para editar una referencia existente, haga clic en el nombre de la referencia. Para probar una referencia, haga clic en el icono <strong>Probar</strong>. Para ver detalles',
unistr('de la referencia, haga clic en el icono <strong>Ver</strong>. Para crear una nueva referencia web, haga clic en el bot\00F3n <strong>Crear</strong>.</p>'),
'',
'<p><strong>Nota:</strong> Para ver los iconos <strong>Probar</strong> y <strong>Ver</strong>, debe estar en la vista de informe y no en la vista de icono. Haga clic',
unistr('en el bot\00F3n <strong>Ver informe</strong> en la barra de b\00FAsqueda de informes interactiva.</p>'),
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/implementing-web-services.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188924027769191278.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47844726510922430.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:170,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86304928130192435.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47844726510922430.4001)
,p_button_name=>'CREATE'
,p_button_static_id=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:565,580,585,870,871,872,873,875,REST_INPUT_PARMS,REST_OUTPUT_PARMS,REST_HTTP_HEADERS::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(86305829110192440.4001)
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(86305207738192437.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P196_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(620268917096646840.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#CREATE, #WS_REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(620269213610646842.4001)
,p_event_id=>wwv_flow_api.id(620268917096646840.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00171
begin
wwv_flow_api.create_page(
 p_id=>171.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Elemento: Nueva P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46215312519471998.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(81864708116445654.4001)
,p_name=>'Copiar de Elemento'
,p_template=>wwv_flow_api.id(42027416946637016.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  i.flow_id flow_id,',
'  i.flow_step_id flow_step_id,',
'  i.prompt prompt,',
'  i.name name,',
'  p.plug_name,',
'  i.item_sequence item_sequence,',
'  i.source_type source_type,',
'  i.source source',
'from ',
'  wwv_flow_step_items i, wwv_flow_page_plugs p',
'where ',
'  i.item_plug_id = p.id and',
'  i.id = :F4000_P171_COPY_FROM_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865107804445663.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865212101445665.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865309750445665.4001)
,p_query_column_id=>3
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865405774445665.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81924200385585353.4001)
,p_query_column_id=>5
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Regi\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865627848445666.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>6
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865713982445666.4001)
,p_query_column_id=>7
,p_column_alias=>'SOURCE_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Tipo de Origen'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(129889837649)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81865818893445666.4001)
,p_query_column_id=>8
,p_column_alias=>'SOURCE'
,p_column_display_sequence=>8
,p_column_heading=>'Origen'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(162455703078684509.4001)
,p_name=>unistr('P\00E1ginas Editadas Recientemente')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna p\00E1gina.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162455909483684521.4001)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162456009776684521.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196860515637446705.4001)
,p_plug_name=>'Copiar Elemento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196951302407543996.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(179572716597169307.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196866901048449192.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46215312519471998.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196878501179458725.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46215312519471998.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196878906267458727.4001)
,p_branch_action=>'172'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(196878501179458725.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179139114511526452.4001)
,p_branch_action=>'f?p=&APP_ID.:172:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196960124177549112.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(196866901048449192.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196882110664464177.4001)
,p_name=>'F4000_P171_COPY_FROM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(196860515637446705.4001)
,p_prompt=>'F4000_P171_COPY_FROM_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196884905273466721.4001)
,p_name=>'F4000_P171_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(196860515637446705.4001)
,p_prompt=>'F4000_P171_COPY_FROM_PAGE_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196906129390501097.4001)
,p_name=>'F4000_P171_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(196860515637446705.4001)
,p_prompt=>unistr('Nueva P\00E1gina')
,p_source=>'F4000_P171_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en que desea copiar el elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(197091831718819158.4001)
,p_validation_name=>'new page id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P171_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(196906129390501097.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(167035408817934715.4001)
,p_validation_name=>'check page locks'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter ',
'           from wwv_flow_lock_page ',
'           where OBJECT_ID = :F4000_P171_COPY_TO_PAGE_ID ',
'           and flow_id = :fb_flow_id',
'           and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede copiar elementos en una p\00E1gina bloqueada por otro usuario.')
,p_when_button_pressed=>wwv_flow_api.id(196878501179458725.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590119711872572033.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(196866901048449192.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590119817271572034.4001)
,p_event_id=>wwv_flow_api.id(590119711872572033.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00172
begin
wwv_flow_api.create_page(
 p_id=>172.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Elemento: Nuevo Elemento'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46217516805482728.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(81928627743593181.4001)
,p_name=>'Copiar de Elemento'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  i.flow_id flow_id,',
'  i.flow_step_id flow_step_id,',
'  i.prompt prompt,',
'  i.name name,',
'  p.plug_name,',
'  i.item_sequence item_sequence,',
'  i.source_type source_type,',
'  i.source source',
'from ',
'  wwv_flow_step_items i, wwv_flow_page_plugs p',
'where ',
'  i.item_plug_id = p.id and',
'  i.id = :F4000_P171_COPY_FROM_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929017169593187.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929105914593187.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929224045593188.4001)
,p_query_column_id=>3
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929303335593188.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929415264593188.4001)
,p_query_column_id=>5
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929526788593188.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>6
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929627036593188.4001)
,p_query_column_id=>7
,p_column_alias=>'SOURCE_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Tipo de Origen'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(129889837649)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81929710058593188.4001)
,p_query_column_id=>8
,p_column_alias=>'SOURCE'
,p_column_display_sequence=>8
,p_column_heading=>'Origen '
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179585307096188874.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(179572716597169307.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179651808242370756.4001)
,p_plug_name=>'Copiar Elemento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179503222227001843.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46217516805482728.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179508106775006805.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46217516805482728.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179505531578004551.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46217516805482728.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1300954621.4001)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179538715987124001.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(179503222227001843.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179505903254004558.4001)
,p_branch_action=>'171'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(179505531578004551.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1290748955.4001)
,p_name=>'F4000_P172_COPY_TO_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(179651808242370756.4001)
,p_item_default=>'P&F4000_P172_COPY_TO_PAGE_ID._'
,p_prompt=>'Nombre del Elemento'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca un nombre para el elemento que se va a crear. El creador de aplicaciones mostrar\00E1 la primera parte de un nombre para que lo edite, basado en el nombre del elemento del que se copi\00F3. Utilice este formato para completar el nombre o introd')
||'uzca un nombre completamente nuevo.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1291784778.4001)
,p_name=>'F4000_P172_COPY_TO_SEQ'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(179651808242370756.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Nueva Secuencia de Elementos'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(item_sequence) + 10',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :fb_flow_id',
'',
'and flow_step_id = :F4000_P171_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177290142430915728.4001)
,p_name=>'F4000_P172_COPY_TO_POSITION'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(179651808242370756.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Posici\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_display_point',
'from wwv_flow_step_items',
'where id = :F4000_P171_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dp.name as d,',
'       dp.placeholder as r ',
'  from wwv_flow_page_tmpl_disp_points dp ',
' where :F4000_P172_COPY_TO_REGION is null',
'   and dp.security_group_id = :WORKSPACE_ID',
'   and dp.flow_id           = :FB_FLOW_ID',
'   and dp.has_item_support  = ''Y''',
'   and dp.page_template_id  = ( select coalesce( p.step_template, ( select t.default_page_template',
'                                                                      from wwv_flow_user_interfaces ui,',
'                                                                           wwv_flow_themes t',
'                                                                     where ui.security_group_id = dp.security_group_id ',
'                                                                       and ui.flow_id           = dp.flow_id',
'                                                                       and t.security_group_id  = ui.security_group_id ',
'                                                                       and t.flow_id            = ui.flow_id',
'                                                                       and t.theme_id           = ui.theme_id ) )',
'                                 from wwv_flow_steps p',
'                                where p.security_group_id = dp.security_group_id ',
'                                  and p.flow_id           = dp.flow_id',
'                                  and p.id                = :F4000_P171_COPY_TO_PAGE_ID )',
'',
'union all',
'',
'-- region positions',
'select dp.name as d,',
'       dp.placeholder as r ',
'  from wwv_flow_plug_tmpl_disp_points dp ',
' where :F4000_P172_COPY_TO_REGION is not null',
'   and dp.security_group_id = :WORKSPACE_ID',
'   and dp.flow_id           = :FB_FLOW_ID',
'   and dp.has_item_support  = ''Y''',
'   and dp.plug_template_id  = ( select p.plug_template',
'                                  from wwv_flow_page_plugs p',
'                                 where p.security_group_id = dp.security_group_id ',
'                                   and p.flow_id           = dp.flow_id',
'                                   and p.page_id           = :F4000_P171_COPY_TO_PAGE_ID',
'                                   and p.id                = :F4000_P172_COPY_TO_REGION )',
'',
'union all',
'',
'-- fallback when region has no template',
'select wwv_flow_lang.system_message(''LAYOUT.T_BODY'') as d,',
'       ''BODY'' as r',
'  from dual ',
' where :F4000_P172_COPY_TO_REGION is not null',
'   and not exists ( select 1',
'                      from wwv_flow_plug_tmpl_disp_points dp ',
'                     where :F4000_P172_COPY_TO_REGION is not null',
'                       and dp.security_group_id = :WORKSPACE_ID',
'                       and dp.flow_id           = :FB_FLOW_ID',
'                       and dp.has_item_support  = ''Y''',
'                       and dp.plug_template_id  = ( select p.plug_template',
'                                                      from wwv_flow_page_plugs p',
'                                                     where p.security_group_id = dp.security_group_id ',
'                                                       and p.flow_id           = dp.flow_id',
'                                                       and p.page_id           = :F4000_P171_COPY_TO_PAGE_ID',
'                                                       and p.id                = :F4000_P172_COPY_TO_REGION ) )',
'',
'order by 1'))
,p_lov_cascade_parent_items=>'F4000_P172_COPY_TO_REGION'
,p_ajax_optimize_refresh=>'N'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Identifica la posici\00F3n de regi\00F3n en la que se mostrar\00E1 este elemento. La secuencia de visualizaci\00F3n del elemento es relativa a la posici\00F3n de regi\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(179685701217525886.4001)
,p_name=>'F4000_P172_COPY_TO_PROMPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(179651808242370756.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt',
'',
'from wwv_flow_step_items',
'',
'where id = :F4000_P171_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo identifica la etiqueta de campo del elemento de p\00E1gina. La etiqueta se muestra en la p\00E1gina s\00F3lo si aparece el elemento. La etiqueta se mostrar\00E1 en su propia celda de tabla HTML en algunas configuraciones de visualizaci\00F3n, y en la mi')
||unistr('sma celda de otras en funci\00F3n de la alineaci\00F3n de etiqueta.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(179690131169542372.4001)
,p_name=>'F4000_P172_COPY_TO_REGION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(179651808242370756.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_plug_id',
'from wwv_flow_step_items',
'where id = :F4000_P171_COPY_FROM_ID',
'and :F4000_P171_COPY_FROM_PAGE_ID = :F4000_P171_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when r.page_id = ui.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || r.plug_name || '' ('' || r.plug_display_sequence || '')'' as d,',
'       r.id as r',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P171_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and ui.id               = p.user_interface_id',
'   and r.flow_id           = ui.flow_id',
'   and r.page_id          in (:F4000_P171_COPY_TO_PAGE_ID, ui.global_page_id)',
' order by case when r.page_id = ui.global_page_id then 2 else 1 end, r.plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Regi\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('<p>Identifica la regi\00F3n en la que se mostrar\00E1 este elemento. La secuencia de visualizaci\00F3n del elemento es relativa a la regi\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196966932144560615.4001)
,p_name=>'F4000_P172_COPY_TO_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(179651808242370756.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'F4000_P171_COPY_TO_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(179936617765384312.4001)
,p_validation_name=>'F4000_P172_COPY_TO_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P172_COPY_TO_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre del elemento.'
,p_associated_item=>wwv_flow_api.id(1290748955.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-FEB-2002 14:28'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(179937219130384322.4001)
,p_validation_name=>'F4000_P172_COPY_TO_SEQ Not Null'
,p_validation_sequence=>30
,p_validation=>'F4000_P172_COPY_TO_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la nueva secuencia de elementos.'
,p_associated_item=>wwv_flow_api.id(1291784778.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-FEB-2002 14:28'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(69375918759877491.4001)
,p_validation_name=>'not dup flow or item name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_builder.is_item_name_used(p_flow=>:FB_FLOW_ID,',
'p_name=>upper(:F4000_P172_COPY_TO_NAME))'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nombre del elemento ya lo est\00E1 utilizando un elemento de aplicaci\00F3n o de p\00E1gina existente.')
,p_when_button_pressed=>wwv_flow_api.id(179508106775006805.4001)
,p_associated_item=>wwv_flow_api.id(1290748955.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(150731426429303925.4001)
,p_validation_name=>'ValidItemName'
,p_validation_sequence=>70
,p_validation=>'F4000_P172_COPY_TO_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('El nombre s\00F3lo puede contener caracteres alfanum\00E9ricos y de subrayado "_".')
,p_when_button_pressed=>wwv_flow_api.id(179508106775006805.4001)
,p_associated_item=>wwv_flow_api.id(1290748955.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590119424688572030.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(179503222227001843.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590119535252572031.4001)
,p_event_id=>wwv_flow_api.id(590119424688572030.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1297916466.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.copy_page_item (',
'    p_copy_from_item_id     => :F4000_P171_COPY_FROM_ID,',
'    p_copy_to_page_id       => :F4000_P171_COPY_TO_PAGE_ID,',
'    p_copy_to_item_name     => :F4000_P172_COPY_TO_NAME,',
'    p_copy_to_item_sequence => :F4000_P172_COPY_TO_SEQ,',
'    p_copy_to_item_plug     => :F4000_P172_COPY_TO_REGION,',
'    p_copy_to_item_position => :F4000_P172_COPY_TO_POSITION,',
'    p_copy_to_prompt        => :F4000_P172_COPY_TO_PROMPT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar el elemento de p\00E1gina.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Elemento copiado en la p\00E1gina &F4000_P171_COPY_TO_PAGE_ID..')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590119645628572032.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Elemento copiado en la p\00E1gina &F4000_P171_COPY_TO_PAGE_ID..')
);
end;
/
prompt --application/pages/page_00173
begin
wwv_flow_api.create_page(
 p_id=>173.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Informes de Temas'
,p_step_title=>'Informes de Temas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44085020552688568.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(58949101764235429.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(44089632373720400.4001)
,p_name=>'Theme Definition'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P173b */ decode(lov_name,',
'         ''REPORT THEME CLASS ID'', wwv_flow_lang.system_message_lit(''REPORT''),',
'         ''MENU THEME CLASS ID'', wwv_flow_lang.system_message_lit(''F4000.MENU''),',
'         ''LIST THEME CLASS ID'', wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'         ''LABEL THEME CLASS ID'', wwv_flow_lang.system_message_lit(''LABEL''),',
'         ''CALENDAR THEME CLASS ID'', wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'         ''PAGE THEME CLASS ID'', wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'         ''BUTTON THEME CLASS ID'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'         ''REGION THEME CLASS ID'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'         ''POPUP LOV TEMPLATE THEME CLASS ID'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'')) template_type,',
'       lov_disp_value,',
'       lov_return_value,',
'       lov_disp_sequence,',
'	   CASE',
'	     when lov_name = ''POPUP LOV TEMPLATE THEME CLASS ID'' then -- POPUP ',
'		   (select count(*) from wwv_flow_popup_lov_template where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''PAGE THEME CLASS ID'' then -- PAGE ',
'		   (select count(*) from wwv_flow_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''REPORT THEME CLASS ID'' then -- REPORT ',
'		   (select count(*) from wwv_flow_row_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''MENU THEME CLASS ID'' then -- MENU ',
'		   (select count(*) from wwv_flow_menu_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''LIST THEME CLASS ID'' then -- LIST ',
'		   (select count(*) from wwv_flow_list_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''LABEL THEME CLASS ID'' then -- LABEL ',
'		   (select count(*) from wwv_flow_field_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''CALENDAR THEME CLASS ID'' then ',
'	   (select count(*) from wwv_flow_cal_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''BUTTON THEME CLASS ID'' then -- BUTTON ',
'		   (select count(*) from wwv_flow_button_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''REGION THEME CLASS ID'' then -- REGION ',
'		   (select count(*) from wwv_flow_page_plug_templates where flow_id = :fb_flow_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	   end counter ',
'from   wwv_flow_list_of_values_data d, WWV_FLOW_LISTS_OF_VALUES$ l,',
' (select wwv_flow.get_translated_app_id tflow_id from dual) t',
'where  d.lov_id = l.id',
'  and l.flow_id =  t.tflow_id',
'  and lov_name in (',
'         ''PAGE THEME CLASS ID'' ,',
'         ''REPORT THEME CLASS ID'' ,',
'         ''MENU THEME CLASS ID'' ,',
'         ''LIST THEME CLASS ID'' ,',
'         ''LABEL THEME CLASS ID'' ,',
'         ''CALENDAR THEME CLASS ID'' , ',
'         ''BUTTON THEME CLASS ID'' , ',
'         ''REGION THEME CLASS ID'' ,',
'         ''POPUP LOV TEMPLATE THEME CLASS ID'' )',
'   and (:P173_SHOW_CUSTOM = ''1'' or lov_disp_sequence != 10)',
'order by lov_id, lov_disp_sequence, lov_disp_value'))
,p_display_when_condition=>'P173_SHOW'
,p_display_when_cond2=>'2'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>20000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(44090207125720421.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(44090332255720421.4001)
,p_query_column_id=>2
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Clase'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(44090429962720421.4001)
,p_query_column_id=>3
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Class ID'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(44103132073748731.4001)
,p_query_column_id=>4
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48617529811154922.4001)
,p_query_column_id=>5
,p_column_alias=>'COUNTER'
,p_column_display_sequence=>5
,p_column_heading=>'Recuento de Plantillas'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45482402383915030.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48447115370583016.4001)
,p_name=>'Plantillas de Tema'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P173a */',
'  decode(template_type,',
'  ''PAGE'',wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'  ''REGION'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'  ''LABEL'',wwv_flow_lang.system_message_lit(''LABEL''),',
'  ''LIST'',wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''CALENDAR'',wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'  ''MENU'',wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'  ''BUTTON'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'  ''REPORT'',wwv_flow_lang.system_message_lit(''REPORT''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''trans-''||template_type) t, ',
'  template_name n,',
'  theme_class,',
'  theme_id',
'from (',
'select ',
'''POPUP_LOV'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''POPUP LOV TEMPLATE THEME CLASS ID'') theme_class,',
'''<a href="f?p=4000:251:''||:flow_session||''::NO:251:F4000_P251_ID:''||id||',
'''">Popup LOV</a>'' template_name,',
'last_updated_on, last_updated_by, null reference_id,',
'1 is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_popup_lov_template plt',
' where plt.flow_id = :fb_flow_id',
'   and plt.security_group_id = :flow_security_group_id',
'   and (theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''CALENDAR'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''CALENDAR THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:122:''||:FLOW_SESSION||''::NO:122:P122_ID:''||id||',
'''">''||wwv_flow_escape.html(NAME)||''</a>'' ',
'template_name,',
'last_updated_on, last_updated_by, reference_id,',
'0 is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_cal_templates c',
' where c.flow_id = :fb_flow_id  ',
'   and c.security_group_id = :flow_security_group_id',
'   and (c.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''MENU'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''MENU THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:289:''||:FLOW_SESSION||''::NO:289:F4000_P289_ID:''||id||',
'''">''||wwv_flow_escape.html(NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = m.theme_id',
'    and default_menu_template = m.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_menu_templates m',
' where m.flow_id = :fb_flow_id    ',
'   and m.security_group_id = :flow_security_group_id',
'   and (m.theme_id = :p173_theme or :p173_theme = 0) ',
'union all',
'select ',
'''BUTTON'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''BUTTON THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:204:''||:FLOW_SESSION||''::NO:204:F4000_P204_ID:''||id||',
'''">''||wwv_flow_escape.html(TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = b.theme_id',
'    and default_button_template = b.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_button_templates b',
' where b.flow_id = :fb_flow_id',
'   and b.security_group_id = :flow_security_group_id',
'   and (b.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select ''LABEL'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''LABEL THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:85:''||:flow_session||''::NO:85:F4000_P85_ID:''||id||',
'''">''||wwv_flow_escape.html(TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = f.theme_id',
'    and default_label_template = f.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_field_templates f',
' where f.flow_id = :fb_flow_id',
'   and f.security_group_id = :flow_security_group_id',
'   and (f.theme_id = :p173_theme or :p173_theme = 0)',
'union all ',
'select ',
'''LIST'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''LIST THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:4655:''||:FLOW_SESSION||''::NO:4655:F4000_P4655_ID:''||id||    ',
'''">''||wwv_flow_escape.html(l.LIST_TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = l.theme_id',
'    and default_list_template = l.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_list_templates l',
' where l.flow_id = :fb_flow_id',
'   and l.security_group_id = :flow_security_group_id',
'   and (l.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''REPORT'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''REPORT THEME CLASS ID'' ) theme_class,',
'decode(ROW_TEMPLATE_TYPE,''GENERIC_COLUMNS'',',
'''<a href="f?p=4000:258:''||:flow_session||''::NO::F4000_P258_ID:''||id||''">'',',
'''<a href="f?p=4000:4654:''||:flow_session||''::NO:4654:F4000_P4654_ID:''||id||''">'')||',
'wwv_flow_escape.html(ROW_TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = ro.theme_id',
'    and default_report_template = ro.id ) is_default,',
'ro.id preview,',
'theme_id',
'  from wwv_flow_row_templates ro',
' where ro.flow_id = :fb_flow_id',
'   and ro.security_group_id = :flow_security_group_id',
'   and (ro.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''PAGE'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''PAGE THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:4307:''||:FLOW_SESSION||''::NO:4307:F4000_P4307_ID:''||id||''">''||wwv_flow_escape.html(name)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = p.theme_id',
'    and DEFAULT_PAGE_TEMPLATE=p.id ) is_default,',
'p.id preview,',
'theme_id',
'  from wwv_flow_templates p',
' where p.flow_id = :fb_flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and (p.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''REGION'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
' where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''REGION THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:4653:''||:flow_session||''::NO:4653:F4000_P4653_ID:''||id||''">''||wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = r.theme_id',
'    and default_region_template = r.id ) is_default,',
'r.id preview,',
'theme_id',
'  from wwv_flow_page_plug_templates r',
' where r.flow_id = :fb_flow_id',
'   and r.security_group_id = :flow_security_group_id',
'   and (r.theme_id = :p173_theme or nvl(:p173_theme,''0'') = ''0'')',
') x ',
'where',
'(:P4003_FIND is null or instr(upper(template_name),upper(:P4003_FIND)) > 0)',
'order by 1, 2'))
,p_display_when_condition=>'P173_SHOW'
,p_display_when_cond2=>'1'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 02-JUN-2004 17:33:01'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48447409064583022.4001)
,p_query_column_id=>1
,p_column_alias=>'T'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48447520266583022.4001)
,p_query_column_id=>2
,p_column_alias=>'N'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de la Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48448221603584838.4001)
,p_query_column_id=>3
,p_column_alias=>'THEME_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'Clase de Plantilla'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48447600846583022.4001)
,p_query_column_id=>4
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Tema'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45488609571935985.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(45482402383915030.4001)
,p_button_name=>'P173_GO'
,p_button_static_id=>'P173_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205412114656611987.4001)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.::&DEBUG.:RP:P435_SHOW:FILE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P173_SHOW'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205427506738638013.4001)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.::&DEBUG.:RP:P491_SHOW:CLASS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P173_SHOW'
,p_branch_condition_text=>'CLASS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205431332711645589.4001)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.::&DEBUG.:RP:P492_SHOW:TEMPLATE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P173_SHOW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45488926884935992.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45490813165946457.4001)
,p_name=>'P173_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(45482402383915030.4001)
,p_item_default=>'0'
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tema y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48987918801575678.4001)
,p_name=>'P173_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(45482402383915030.4001)
,p_item_default=>'1'
,p_prompt=>'Informe'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_api.id(48989614083583743.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tipo de informe y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(135661018056004082.4001)
,p_name=>'P173_SHOW_CUSTOM'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(45482402383915030.4001)
,p_prompt=>'Mostrar Personalizado'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:;1'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'P173_SHOW'
,p_display_when2=>'2'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione esta opci\00F3n para incluir clases de plantillas personalizadas en este informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(44137715553876365.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'173'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00174
begin
wwv_flow_api.create_page(
 p_id=>174.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Acceso Directo: Atributos de Acceso Directo'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Acceso Directo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186264016206277053.4001)
,p_plug_name=>'Origen'
,p_region_name=>'SRC'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>125
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186266114986277081.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(185305822581982553.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,2,3\1|&nbsp;:',
'',
'<font color="black" class="nounderline">Name<font>:',
'',
'<font color="black" class="nounderline">Sequence</font>:',
'',
'<font color="black" class="nounderline">Type</font>'))
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:R:L:L:L:L:L'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186266724136277086.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Los accesos directos constituyen un repositorio de HTML est\00E1tico o din\00E1mico compartido. Si utiliza un acceso directo, puede evitar la recodificaci\00F3n del mismo HTML o de la funci\00F3n PL/SQL varias veces. La creaci\00F3n de accesos directos en etiquetas d')
||unistr('e elementos de p\00E1gina y atributos de texto posterior al elemento de p\00E1gina puede incluir las siguientes cadenas de sustituci\00F3n: #CURRENT_FORM_ELEMENT#, #CURRENT_ITEM_ID#, #CURRENT_ITEM_NAME#.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186270332432277105.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186270607721277109.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(186270332432277105.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186271512764277112.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(186270332432277105.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186299015471307027.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186270332432277105.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186273314453277133.4001)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186299432667307029.4001)
,p_branch_action=>'131'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186299015471307027.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2408108417709292.4001)
,p_name=>'F4000_P174_SHORTCUT_LANG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(186264016206277053.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P174_SHORTCUT_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186264327799277061.4001)
,p_name=>'F4000_P174_SHORTCUT_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(186264016206277053.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML_TEXT'
,p_prompt=>'Tipo'
,p_source=>'SHORTCUT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHORTCUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84752421139794200.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Identifica el texto de m\00E9todo abreviado real que se muestra al usuario. Este campo es necesario.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186264630551277068.4001)
,p_name=>'F4000_P174_SHORTCUT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(186264016206277053.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo Abreviado')
,p_source=>'SHORTCUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>85
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Texto del m\00E9todo abreviado. El m\00E9todo abreviado debe tener menos de 30.000 caracteres. El texto se procesa seg\00FAn el tipo de m\00E9todo abreviado.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186264930390277070.4001)
,p_name=>'F4000_P174_ERROR_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(186264016206277053.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Error'
,p_source=>'ERROR_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>85
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca el texto que aparecer\00E1 si se produce un error durante el procesamiento de un m\00E9todo abreviado.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186267002382277087.4001)
,p_name=>'F4000_P174_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(186266724136277086.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186267302163277089.4001)
,p_name=>'F4000_P174_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(186266724136277086.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186267623343277090.4001)
,p_name=>'F4000_P174_SHORTCUT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(186266724136277086.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'SHORTCUT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nombre del m\00E9todo abreviado y nombre con el que se hace referencia al mismo.</p>'),
unistr('<p>Para hacer referencia a un m\00E9todo abreviado, utilice la sintaxis <strong>"SHORTCUT_NAME"</strong> donde se permita un m\00E9todo abreviado. El nombre aparecer\00E1 en may\00FAsculas autom\00E1ticamente. Todas las referencias a m\00E9todos abreviados se deben mostrar ')
||unistr('en may\00FAsculas.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186362824817436410.4001)
,p_validation_name=>'F4000_P174_SHORTCUT_TYPE Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P174_SHORTCUT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el tipo.'
,p_associated_item=>wwv_flow_api.id(186264327799277061.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-MAR-2002 12:45'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186363107795436411.4001)
,p_validation_name=>'F4000_P174_SHORTCUT_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'F4000_P174_SHORTCUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(186267623343277090.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-MAR-2002 12:45'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(373230829336848414.4001)
,p_validation_name=>'check pl/sql'
,p_validation_sequence=>12
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    :F4000_P174_SHORTCUT,',
'    :FB_FLOW_ID,',
'    :FLOW_SECURITY_GROUP_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P174_SHORTCUT_TYPE = ''FUNCTION_BODY'' and :F4000_P174_SHORTCUT_LANG = ''PLSQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(186271512764277112.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589950313785621448.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(186270607721277109.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589950470539621449.4001)
,p_event_id=>wwv_flow_api.id(589950313785621448.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(186276332538277157.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHORTCUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHORTCUTS'
,p_attribute_03=>'F4000_P174_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error al procesar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(186271512764277112.4001)
,p_process_success_message=>'Acceso directo creado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(589950563632621450.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(186271512764277112.4001)
,p_process_success_message=>'Acceso directo creado.'
);
end;
/
prompt --application/pages/page_00175
begin
wwv_flow_api.create_page(
 p_id=>175.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('M\00E9todos Abreviados Suscritos')
,p_step_title=>unistr('Suscripci\00F3n de M\00E9todo Abreviado')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'    function checkAll()  {          ',
'        for ( var i=0; i < document.wwv_flow.elements.length; i++ ){              ',
'            var e = document.wwv_flow.elements[i];              ',
'            if ( e.name == "f01" || e.name == "f03" || e.name == "f05" || e.name == "f07" || e.name == "f09" ) {',
'                if ( e.length > 1 ){',
'                    for ( j=0;j<e.length;j++ )',
'                        if ( !e[j].checked )',
'                             e[j].click();}',
'                        else',
'                            if ( !e.checked )',
'                                e.click(); ',
'                        }      ',
'          }    ',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(186568922151753406.4001)
,p_name=>'Subscribed Shortcuts'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   q  varchar2(32767) := null;',
'   t_application varchar2(255) := wwv_flow_lang.system_message(''F4000_P801_FLOW'');',
'begin',
'    q :=q||''select '';',
'    q :=q||''wwv_flow_item.checkbox(1,id, ''''title="''''||wwv_flow_lang.system_message(''''INITCAP_REFRESH'''')||''''"''''), '';',
'    q :=q||''wwv_flow_item.hidden(2,reference_id), '';',
'    q :=q||''flow_id, '';   ',
'    q :=q||''wwv_flow_escape.html(shortcut_name), '';',
'    q :=q||''(select ''''''||t_application||''''''||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(shortcut_name) '';',
'    q :=q||''from wwv_flow_shortcuts where id = s.reference_id) cp_from '';      ',
'    q :=q||''from wwv_flow_shortcuts s '';',
'    q :=q||''where s.flow_id = :fb_flow_id '';',
'    q :=q||''and s.security_group_id = :flow_security_group_id '';',
'    q :=q||''and s.reference_id is not null '';',
'    return q;',
'end;'))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959306956773302.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Refrescar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959402360773302.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959517982773302.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959613765773302.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>unistr('M\00E9todo Abreviado')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959716476773302.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Copiado de'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959805409773302.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48959913512773302.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960002615773302.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960119695773303.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960216113773303.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960300730773303.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960407521773303.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960505548773303.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960623019773303.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48960717140773303.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134801220240983652.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134801316983983655.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134801422628983659.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134801517097983659.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(134801612621983659.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12539716234906522.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12539800135906522.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12539922742906522.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540001228906523.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540127773906523.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540222736906523.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540300321906523.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540415643906523.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540509784906523.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540626158906523.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540732361906524.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540826800906524.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12540918373906524.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541030722906526.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541106754906526.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541209898906526.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541332031906526.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541417693906526.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541502868906526.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541616076906526.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541721092906526.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541815999906527.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12541923494906527.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542016993906527.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542102399906527.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542227985906527.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542310504906527.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542407759906527.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542524913906528.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542630752906528.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542732608906528.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542823162906528.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12542915616906528.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543011100906528.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543125688906528.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543200604906528.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543321251906528.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543408465906529.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543522661906529.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(12543629410906529.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186570106911753415.4001)
,p_plug_name=>unistr('Suscripci\00F3n de M\00E9todo Abreviado')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra m\00E9todos abreviados suscritos en la aplicaci\00F3n. Para refrescar los m\00E9todos abreviados, seleccione los deseados y haga clic en <strong>Refrescar Selecci\00F3n</strong>.</p>')
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No se ha encontrado ninguna plantilla suscrita.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'3:4'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186570427989753418.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(186543329326722942.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186570729986753419.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ning\00FAn m\00E9todo abreviado.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186571024466753420.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(186570729986753419.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flow_shortcuts s where s.flow_id = :fb_flow_id and s.reference_id is not null'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186571629303753425.4001)
,p_branch_action=>'175'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(150972628466170107.4001)
,p_validation_name=>'SomethingChecked'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe seleccionar al menos un m\00E9todo abreviado para refrescarlo.')
,p_when_button_pressed=>wwv_flow_api.id(186571024466753420.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(186571924537753428.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked shortcuts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_shortcut(    ',
'    p_subscribing_shortcut_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing shortcuts. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar los m\00E9todos abreviados.')
,p_process_when_button_id=>wwv_flow_api.id(186571024466753420.4001)
,p_process_success_message=>unistr('M\00E9todos abreviados seleccionados refrescados.')
);
end;
/
prompt --application/pages/page_00177
begin
wwv_flow_api.create_page(
 p_id=>177.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Estilos de Tema'
,p_step_title=>'Estilos de Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(366542826267187546.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(366550824763408792.4001)
,p_plug_name=>'Estilos de Tema'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Los estilos de temas son archivos CSS a los que se hacen referencia en la plantilla de p\00E1gina mediante la cadena de sustituci\00F3n #THEME_STYLE_CSS#. El motor de &PRODUCT_NAME. sustituye esta cadena de sustituci\00F3n por las referencias del archivo CSS def')
||'inido en los atributos de estilo de tema. Utilice los estilos de tema para personalizar temas, cambiar a un esquema de colores diferente, aplicar un aspecto plano, o crear una respuesta de tema. Un tema puede tener varios estilos de temas con un jueg'
||'o de estilo activo.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(366551909488451625.4001)
,p_plug_name=>'Estilos de Tema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(387910631715294595.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1217752994466777301.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1217753042936777302.4001)
,p_plug_name=>'Atributos de Acumulador de Temas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1791805889514360410.4001)
,p_plug_name=>unistr('Configuraci\00F3n de JSON de Acumulador de Temas')
,p_parent_plug_id=>wwv_flow_api.id(1217753042936777302.4001)
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(366543416075187549.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(366551909488451625.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(366543211381187548.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(366551909488451625.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P177_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(366543109584187548.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(366551909488451625.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P177_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(366543030051187548.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(366551909488451625.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P177_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(366544032567187552.4001)
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366544202510187555.4001)
,p_name=>'P177_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(93372822814585113.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366544406952187564.4001)
,p_name=>'P177_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Proporcione una abreviatura descriptiva para el estilo del tema, con el fin de distinguirlo de otros estilos del tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366544601073187565.4001)
,p_name=>'P177_CSS_FILE_URLS'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar en cada p\00E1gina si el estilo del tema es actual. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la ca')
||unistr('dena de sustituci\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depu')
||unistr('raci\00F3n. Tambi\00E9n tiene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
unistr('<p>Las URL de archivo que introduzca aqu\00ED sustituir\00E1n a la cadena de sustituci\00F3n <code>#THEME_STYLE_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo del directorio del tema.'),
'      <pre>#THEME_IMAGES#main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), se indica al explorador que siempre ca')
||unistr('rgue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366544826936187569.4001)
,p_name=>'P177_IS_CURRENT'
,p_is_required=>true
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Es Actual'
,p_source=>'IS_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione si este estilo es el estilo actual que utiliza el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366545027195187569.4001)
,p_name=>'P177_COMPONENT_COMMENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1217752994466777301.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMPONENT_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366558014630816978.4001)
,p_name=>'P177_FLOW_ID'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366558900815838536.4001)
,p_name=>'P177_THEME_ID'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(879701970656493841.4001)
,p_name=>'P177_IS_PUBLIC'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Es P\00FAblico')
,p_source=>'IS_PUBLIC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione si los usuarios finales pueden elegir este estilo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(879702088607493842.4001)
,p_name=>'P177_IS_ACCESSIBLE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Accesibilidad Probada'
,p_source=>'IS_ACCESSIBLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique si este estilo de tema se ha probado con las directrices de accesibilidad aplicables. Para los estilos de tema creados por Oracle, consulte nuestro VPAT de productos para ver las directrices de accesibilidad que seguimos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1217753164876777303.4001)
,p_name=>'P177_THEME_ROLLER_INPUT_FILE_URLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1217753042936777302.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL de Archivos de Par\00E1metros de Entrada')
,p_source=>'THEME_ROLLER_INPUT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca las URL del archivo LESS que se utilizar\00E1n para generar este estilo de tema al utilizar el acumulador de temas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1217753214828777304.4001)
,p_name=>'P177_THEME_ROLLER_OUTPUT_FILE_URL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1217753042936777302.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo CSS de Salida'
,p_source=>'THEME_ROLLER_OUTPUT_FILE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>82
,p_cMaxlength=>4000
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la URL del archivo CSS que generar\00E1 el acumulador de temas para este estilo de tema. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1217753366427777305.4001)
,p_name=>'P177_THEME_ROLLER_READ_ONLY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1217753042936777302.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('S\00F3lo Lectura')
,p_source=>'THEME_ROLLER_READ_ONLY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione <strong>Activado</strong> para evitar actualizaciones del estilo de tema. Seleccione <strong>Desactivado</strong> para permitir que se edite y se sobrescriba el estilo de tema con el acumulador de temas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1323587497460848827.4001)
,p_name=>'P177_CSS_CLASSES'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(366542826267187546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clases CSS'
,p_source=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>82
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca las clases CSS que se van a agregar a la cadena de sustituci\00F3n #PAGE_CSS_CLASSES# y a aplicar a cada una de las p\00E1ginas de la aplicaci\00F3n si este estilo de tema est\00E1 actualmente activo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1791909606437372803.4001)
,p_name=>'P177_THEME_ROLLER_CONFIG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1791805889514360410.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Configuraci\00F3n de JSON')
,p_source=>'THEME_ROLLER_CONFIG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cHeight=>5
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El acumulador de temas genera la configuraci\00F3n de JSON cuando se guarda el estilo de tema.</p>'),
unistr('<p>Oracle no recomienda la actualizaci\00F3n manual de la configuraci\00F3n. Sin embargo, puede copiar una configuraci\00F3n de JSON de otro estilo de tema, como un estilo de tema en otra aplicaci\00F3n, para actualizar manualmente la configuraci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1864600915247700701.4001)
,p_name=>'P177_NOTE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1791805889514360410.4001)
,p_pre_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<strong>Nota:</strong> al guardar un estilo de tema en el acumulador de temas, se generar\00E1 la configuraci\00F3n de JSON. <br/>'),
unistr('Al actualizar manualmente una configuraci\00F3n generada, se pueden producir errores o resultados inesperados.')))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1791988207698429412.4001)
,p_validation_name=>'P177_CSS_FILE_URLS'
,p_validation_sequence=>10
,p_validation=>'P177_CSS_FILE_URLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se necesita una URL de archivo de estilo de tema, a menos que se utilice el acumulador de temas y se defina la URL de archivo de par\00E1metros de entrada del acumulador de temas.')
,p_validation_condition=>'P177_THEME_ROLLER_INPUT_FILE_URLS'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_associated_item=>wwv_flow_api.id(366544601073187565.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1475883114853627440.4001)
,p_validation_name=>'P177_CSS_FILE_URLS_1'
,p_validation_sequence=>20
,p_validation=>'P177_THEME_ROLLER_INPUT_FILE_URLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se necesita una URL de archivo de par\00E1metros de entrada del acumulador de temas, a menos que se defina una URL de archivo de estilo de tema.')
,p_validation_condition=>'P177_CSS_FILE_URLS'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_associated_item=>wwv_flow_api.id(1217753164876777303.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(366545824442187570.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEME_STYLES'
,p_attribute_02=>'WWV_FLOW_THEME_STYLES'
,p_attribute_03=>'P177_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(366600703522413099.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset theme styles'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_theme_styles',
'set is_current = ''N''',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P177_THEME_ID',
'and id <> nvl(:P177_ID,0);',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P177_IS_CURRENT'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(366546027981187572.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_THEME_STYLES'
,p_attribute_02=>'WWV_FLOW_THEME_STYLES'
,p_attribute_03=>'P177_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1909961414063636113.4001)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update current theme style'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_current_found boolean := false;',
'',
'begin',
'',
'  for c1 in (',
'    select * from wwv_flow_theme_styles',
'    where flow_id = :FB_FLOW_ID',
'    and theme_id = :P177_THEME_ID',
'    and is_current = ''Y''',
'  ) loop',
'    l_current_found := true;',
'  end loop;',
'  ',
'  if not l_current_found then',
'',
'    for c2 in (',
'      select * from wwv_flow_theme_styles',
'      where flow_id = :FB_FLOW_ID',
'      and theme_id = :P177_THEME_ID',
'      and rownum = 1',
'      order by id',
'    ) loop',
'',
'      update wwv_flow_theme_styles',
'      set is_current = ''Y''',
'      where flow_id = :FB_FLOW_ID',
'      and theme_id = :P177_THEME_ID',
'      and id = c2.id;',
'',
'    end loop;',
'',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(366546204770187572.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(366543211381187548.4001)
);
end;
/
prompt --application/pages/page_00178
begin
wwv_flow_api.create_page(
 p_id=>178.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Lista de Valores')
,p_step_title=>unistr('Edici\00F3n de Cuadr\00EDculas de Lista de Valores')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7360030733387942.4001)
,p_plug_name=>'Listas de Valores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina permite buscar y editar entradas de listas de valores est\00E1ticas en todas las listas de valores est\00E1ticas. Utilice esta p\00E1gina para estandarizar el texto de visualizaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(78381930700790807.4001)
,p_name=>'Edit Static Display Entries'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P178a */',
'"ID",',
'"ID" pk1_DISPLAY,',
'lov_id fk,',
'(select wwv_flow_escape.html(lov_name) lov_name',
'   from WWV_FLOW_LISTS_OF_VALUES$ l',
'  where l.id = lov_id',
'    and l.security_group_id = :flow_security_group_id',
'  ) "LOV_ID",',
'"LOV_DISP_SEQUENCE",',
'"LOV_DISP_VALUE",',
'LOV_RETURN_VALUE',
'  from WWV_FLOW_LIST_OF_VALUES_DATA',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and (:P178_NAME_CONTAINS is null or ',
'        instr(upper(lov_disp_value),upper(:P178_NAME_CONTAINS)) > 0)',
'   and (:P178_ITEM_NAME_DOES_NC is null or ',
'        instr(upper(lov_disp_value),upper(:P178_ITEM_NAME_DOES_NC)) = 0) ',
' order by lov_id, lov_disp_sequence, lov_disp_value'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>20
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 10-JUL-2003 22:24:51'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78382408978790814.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78382519544790814.4001)
,p_query_column_id=>2
,p_column_alias=>'PK1_DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Pk1'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(222727513847820017.4001)
,p_query_column_id=>3
,p_column_alias=>'FK'
,p_column_display_sequence=>7
,p_column_heading=>'Foreign Key'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78382621993790814.4001)
,p_query_column_id=>4
,p_column_alias=>'LOV_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre de Lista de Valores'
,p_column_link=>'f?p=4000:4111:&SESSION.::&DEBUG.:4111:F4000_P4111_ID:#FK#'
,p_column_linktext=>'#LOV_ID#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78382725441790814.4001)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78382804104790814.4001)
,p_query_column_id=>6
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Texto de Visualizaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>60
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(222721305994802392.4001)
,p_query_column_id=>7
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>6
,p_column_heading=>'Valor de Retorno'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78385825643797902.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78385931942797902.4001)
,p_column_sequence=>2
,p_query_column_name=>'PK1_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(222727012254820014.4001)
,p_column_sequence=>3
,p_query_column_name=>'FK'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78386014751797902.4001)
,p_column_sequence=>4
,p_query_column_name=>'LOV_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78386127559797902.4001)
,p_column_sequence=>5
,p_query_column_name=>'LOV_DISP_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(78386216052797903.4001)
,p_column_sequence=>6
,p_query_column_name=>'LOV_DISP_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(222721231402802382.4001)
,p_column_sequence=>7
,p_query_column_name=>'LOV_RETURN_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184825020271437011.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187936615571872203.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78389608936812053.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(187936615571872203.4001)
,p_button_name=>'P178_GO'
,p_button_static_id=>'P178_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188990116158000646.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(187936615571872203.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:178:&SESSION.::&DEBUG.:RP,178::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78383012331790815.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(187936615571872203.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78383925174790819.4001)
,p_branch_action=>'f?p=&FLOW_ID.:178:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 10-JUL-2003 22:24:51'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78388828891808355.4001)
,p_name=>'P178_NAME_CONTAINS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(187936615571872203.4001)
,p_prompt=>unistr('El Texto de Visualizaci\00F3n Contiene')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Filtre por nombre. Introduzca todo o parte del nombre de la lista de valores que desea buscar y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78391123135816127.4001)
,p_name=>'P178_ITEM_NAME_DOES_NC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(187936615571872203.4001)
,p_prompt=>unistr('El Texto de Visualizaci\00F3n No Contiene')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Filtre por nombre. Introduzca todo o parte del nombre de la lista de valores que no desea buscar y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(222729605908828323.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'178'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78383503389790818.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(78381930700790807.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'ID'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(78383012331790815.4001)
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_process_comment=>'Generated 10-JUL-2003 22:24:51'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78390315170813791.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00179
begin
wwv_flow_api.create_page(
 p_id=>179.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Tema: Identificar Tema'
,p_step_title=>'Cambiar Tema: Identificar Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20665725177591580.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(20663215911569971.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57540512543180628.4001)
,p_plug_name=>'Cambiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un tema es una recopilaci\00F3n de plantillas. Cuando se cambia un tema, todas las plantillas asignadas a los componentes de un tema se asignan a las plantillas de otro tema. &PRODUCT_NAME. realiza la asignaci\00F3n de plantillas mediante la asignaci\00F3n de')
||' identificadores de clase de plantilla.</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(144843624145857063.4001)
,p_plug_name=>'Error al Cambiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Debe tener instalados al menos dos temas para poder cambiar. Cree un nuevo tema y vuelva a intentar esta opci\00F3n.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return true;',
'  else',
'    return false;',
'  end if;',
'end loop;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200241204601309738.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138472822138154.4001)
,p_plug_name=>'Cambiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(144849804667870344.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(200241204601309738.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18898923178668757.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200241204601309738.4001)
,p_button_name=>'CREATE_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Tema'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57541302915180632.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200241204601309738.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(52394221434083809.4001)
,p_branch_name=>'skip mapping'
,p_branch_action=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>'select 1 from wwv_flow_themes where flow_id = :FB_FLOW_ID and theme_id = :P179_OLD_THEME and ui_type_id = 2;'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57542602782180654.4001)
,p_branch_name=>'Go To Page 386'
,p_branch_action=>'f?p=&FLOW_ID.:386:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57542128541180635.4001)
,p_name=>'P179_NEW_THEME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(57540512543180628.4001)
,p_prompt=>'Cambiar a Tema:'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t_new.theme_id||''. ''||t_new.theme_name as d,',
'       t_new.theme_id',
'  from wwv_flow_themes t_old,',
'       wwv_flow_themes t_new',
' where t_old.flow_id    = :FB_FLOW_ID',
'   and t_old.theme_id   = :P179_OLD_THEME',
'   and t_old.security_group_id = :WORKSPACE_ID',
'   and t_new.flow_id    = t_old.flow_id',
'   and t_new.theme_id  <> t_old.theme_id',
'   --and t_new.ui_type_id = t_old.ui_type_id',
'   and t_new.security_group_id = :WORKSPACE_ID',
' order by t_new.theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Nuevo Tema -'
,p_lov_cascade_parent_items=>'P179_OLD_THEME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57563303743234936.4001)
,p_name=>'P179_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57540512543180628.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57564313786237858.4001)
,p_name=>'P179_OLD_THEME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(57540512543180628.4001)
,p_prompt=>'Tema Activo Actualmente:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES (ACTIVE)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id||''. '' ||t.theme_name as d,',
'       t.theme_id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_themes t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = i.flow_id',
'   and t.theme_id          = i.theme_id',
'   and t.security_group_id = :WORKSPACE_ID',
' order by i.display_seq'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tema Antiguo - '
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1403861677396685859.4001)
,p_name=>'P179_MATCHING_TEMPLATES_ONLY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(57540512543180628.4001)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Al cambiar a un nuevo tema, el creador de aplicaciones asigna todas las plantillas utilizadas actualmente a una plantilla del nuevo tema',
'mediante la clase de plantilla. Cuando <strong>Coincidir con clase de plantilla</strong> se define en <strong>No</strong>, las plantillas se pueden cambiar a cualquier plantilla',
'con el mismo tipo, independientemente de la clase de plantilla.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1403940863419758219.4001)
,p_name=>'P179_RESET_GRID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(57540512543180628.4001)
,p_item_default=>'ALL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Al cambiar de un tema a otro, puede restablecer la configuraci\00F3n de regi\00F3n y de cuadr\00EDcula de elemento. La configuraci\00F3n de cuadr\00EDcula define el posicionamiento de las regiones y los elementos en una p\00E1gina. Las regiones podr\00EDan posicionarse unas ')
||unistr('junto a las otras o podr\00EDa haber una pantalla con dos o m\00E1s elementos en una sola fila. Al restablecer la cuadr\00EDcula, se eliminar\00E1 esta configuraci\00F3n y se presentar\00E1n todas las regiones y elementos apilados en sentido vertical. </p>'),
'',
unistr('<p>Al cambiar de un tema que utiliza una cuadr\00EDcula basada en tabla, como Tema 26 (Aplicaciones de Productividad), a un tema que utiliza una cuadr\00EDcula basada en DIV, como Tema 42 (Tema Universal), cualquier regi\00F3n que tenga una posici\00F3n fija se tend')
||unistr('r\00E1 que restablecer, es decir, se tiene que seleccionar la opci\00F3n "Restablecer Posiciones de Regi\00F3n Fijas".  </p>'),
'',
unistr('<p>Al cambiar de un tema a otro, cuando ambos temas utilizan el mismo tipo de cuadr\00EDcula, no es necesario restablecer y se puede seleccionar la opci\00F3n "Mantener Configuraci\00F3n de Regi\00F3n y Cuadr\00EDcula de Elemento Actual".</p>'),
'',
unistr('<p>Tambi\00E9n se puede restablecer la cuadr\00EDcula para todas las regiones y elementos. Esto resulta \00FAtil al cambiar de un tema antiguo a uno m\00E1s reciente basado en DIV para preparar la remodelaci\00F3n de la p\00E1gina y el dise\00F1o de pantalla de todas las p\00E1gina')
||unistr('s. Tenga en cuenta que toda la configuraci\00F3n de posici\00F3n de elementos y regiones anteriores se perder\00E1 al seleccionar esta opci\00F3n.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2123446896307517682.4001)
,p_validation_name=>'theme compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_theme_manager.is_theme_switch_allowed (',
'        p_flow_id    => :fb_flow_id,',
'        p_from_theme => :P179_OLD_THEME,',
'        p_to_theme   => :P179_NEW_THEME ',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error'
,p_associated_item=>wwv_flow_api.id(57542128541180635.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00180
begin
wwv_flow_api.create_page(
 p_id=>180.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Tema: Confirmar'
,p_step_title=>'Cambiar Tema: Confirmar'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20670800897981927.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(20663215911569971.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57550105400205036.4001)
,p_plug_name=>'Confirmar Cambio de Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div class="htmldbInfoBodyP">Un cambio de tema puede producir problemas en la plantilla si se definen varias plantillas con el mismo identificador de clase de plantilla. Antes de cambiar una plantilla, se recomienda crear una copia de seguridad de la'
||unistr(' aplicaci\00F3n.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200242619277323456.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138588615138154.4001)
,p_plug_name=>'Cambiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57551727484205045.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200242619277323456.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57550920594205040.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200242619277323456.4001)
,p_button_name=>'SWITCH_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Tema'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57551303628205044.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200242619277323456.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:386:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57553006772205064.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57552132231205047.4001)
,p_name=>'P180_CURRENTLY_ACTIVE_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(57550105400205036.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema Activo Actualmente:'
,p_source=>'P179_OLD_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57807623669054439.4001)
,p_name=>'P180_SWITCH_TO_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(57550105400205036.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cambiar a Tema:'
,p_source=>'P179_NEW_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57815203499067515.4001)
,p_name=>'P180_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57550105400205036.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57552632028205061.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'switch theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    wwv_flow.g_import_in_progress := true;',
'    wwv_flow_theme_manager.switch_theme (',
'        p_flow_id    => :fb_flow_id,',
'        p_from_theme => :P179_OLD_THEME,',
'        p_to_theme   => :P179_NEW_THEME );',
'    wwv_flow.g_import_in_progress := false;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido cambiar el tema.'
,p_process_when_button_id=>wwv_flow_api.id(57550920594205040.4001)
,p_process_success_message=>'Tema activo cambiado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1859459502655404972.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset grid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    -- reset grid, either only for regions in fixed positions, or all regions and items, or none if reset not selected',
'',
'    if :P179_RESET_GRID = ''REGIONONLY'' then',
'',
'        update wwv_flow_page_plugs',
'           set plug_new_grid         = ''N'',',
'               plug_new_grid_row     = ''Y'',',
'               plug_new_grid_column  = ''Y'',',
'               plug_display_column   = null,',
'               plug_grid_column_span = null',
'         where flow_id = :fb_flow_id',
'           and plug_display_column is not null;',
'         ',
'    elsif :P179_RESET_GRID = ''ALL'' then',
'',
'        -- reset item grid',
'        update wwv_flow_step_items',
'           set new_grid            = ''N'',',
'               begin_on_new_line   = ''Y'',',
'               begin_on_new_field  = ''Y'',',
'               colspan             = null,',
'               rowspan             = null',
'         where flow_id = :fb_flow_id;',
'',
'        -- reset region grid',
'        update wwv_flow_page_plugs',
'           set plug_new_grid         = ''N'',',
'               plug_new_grid_row     = ''Y'',',
'               plug_new_grid_column  = ''Y'',',
'               plug_display_column   = null,',
'               plug_grid_column_span = null',
'         where flow_id = :fb_flow_id;',
'',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(57550920594205040.4001)
);
end;
/
prompt --application/pages/page_00182
begin
wwv_flow_api.create_page(
 p_id=>182.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades del Espacio de Trabajo'
,p_step_title=>'Utilidades del Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699056466931610167.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699448947770355317.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina contiene enlaces a utilidades de espacio de trabajo com\00FAn como la definici\00F3n de Valores por Defecto de la Aplicaci\00F3n, Gesti\00F3n de Noticias, Temas de Espacio de Trabajo, etc.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-workspace-utilities.html#GUID-E4A28533-BBF6-4DFC-A68B-FB2C9E906622">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702929143076173489.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699057074956610180.4001)
,p_branch_action=>'f?p=&FLOW_ID.:182:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00184
begin
wwv_flow_api.create_page(
 p_id=>184.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autorizaci\00F3n: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46430908800978376.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186773307550199098.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(186911322244744240.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ning\00FAn esquema de seguridad.</font>')
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186773601550199100.4001)
,p_plug_name=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Especifique c\00F3mo desea crear el esquema de autorizaci\00F3n. Puede crear uno nuevo o copiarlo de otra aplicaci\00F3n. Si copia un esquema de autorizaci\00F3n, lo puede modificar m\00E1s tarde.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186773928558199101.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46430908800978376.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186774212285199102.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46430908800978376.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186775126956199109.4001)
,p_branch_action=>'185'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186774212285199102.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P184_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186775404827199112.4001)
,p_branch_action=>'188'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186774212285199102.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P184_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186775703907199113.4001)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186773928558199101.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186774500955199104.4001)
,p_name=>'F4000_P184_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(186773601550199100.4001)
,p_item_default=>'BLANK'
,p_prompt=>unistr('Crear Esquema de Autorizaci\00F3n:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTH_WIZ_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84347110372647083.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Seleccione la forma en la que desea crear el esquema de autorizaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574333632303476048.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(186773928558199101.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574333701398476049.4001)
,p_event_id=>wwv_flow_api.id(574333632303476048.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00185
begin
wwv_flow_api.create_page(
 p_id=>185.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autorizaci\00F3n: Copiar de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46432109623988163.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186778011895202645.4001)
,p_plug_name=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para copiar esquemas de autorizaci\00F3n de la aplicaci\00F3n actual o entre aplicaciones.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186779818719202661.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(186904126354727159.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ning\00FAn esquema de seguridad.</font>')
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186778628039202649.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46432109623988163.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186778909954202650.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46432109623988163.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186778318308202647.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46432109623988163.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186780722310202667.4001)
,p_branch_action=>'186'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186778909954202650.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186780402454202665.4001)
,p_branch_action=>'184'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186778318308202647.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186780102470202663.4001)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186778628039202649.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186779206811202652.4001)
,p_name=>'F4000_P185_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(186778011895202645.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n desde la que desea copiar esquemas de autorizaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'select name||'' (''||id||'')'', id from wwv_flows where id = v(''FB_FLOW_ID'')'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186781009833202668.4001)
,p_validation_name=>'F4000_P185_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P185_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(186779206811202652.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574333490919476046.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(186778628039202649.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574333519912476047.4001)
,p_event_id=>wwv_flow_api.id(574333490919476046.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00186
begin
wwv_flow_api.create_page(
 p_id=>186.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autorizaci\00F3n: Nombres')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46433406768006193.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186783329924204965.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(186904126354727159.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fieldtitleleft">No se ha encontrado ning\00FAn esquema de seguridad.</font>')
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(186783619515204966.4001)
,p_name=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       flow_id,',
'       name,',
'       wwv_flow_item.text(1,wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name),40) to_name,',
'       wwv_flow_item.select_list (',
'           2,',
'           ''N'',',
'           m_yes||'';Y,''||m_no||'';N,''||m_copy_sub||'';SUBSCRIBE'') copy_subscribe,',
'       wwv_flow_item.hidden(3,id) id',
'  from wwv_flow_security_schemes,',
'       ( select wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'                wwv_flow_lang.system_message(''F4000.NO'')  m_no,',
'                wwv_flow_lang.system_message(''F4000_COPY_AND_SUBSCRIBE'') m_copy_sub',
'           from dual',
'       )',
' where flow_id           = :F4000_P185_COPY_FROM_FLOW_ID ',
'   and security_group_id = :flow_security_group_id',
' order by 1,2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('La aplicaci\00F3n &F4000_P185_COPY_FROM_FLOW_ID!HTML. no contiene ning\00FAn esquema de autorizaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576240862744008.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576384367744009.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'De Nombre'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576461173744010.4001)
,p_query_column_id=>3
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'A Nombre'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576580191744011.4001)
,p_query_column_id=>4
,p_column_alias=>'COPY_SUBSCRIBE'
,p_column_display_sequence=>4
,p_column_heading=>'Copiar'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#COPY_SUBSCRIBE##ID#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576613084744012.4001)
,p_query_column_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186784206001204969.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46433406768006193.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186783919387204968.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46433406768006193.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_security_schemes',
'where flow_id = :F4000_P185_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186784501461204970.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46433406768006193.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186785416089204975.4001)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186783919387204968.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186784819829204972.4001)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186784206001204969.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186785105515204974.4001)
,p_branch_action=>'185'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186784501461204970.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574333185197476043.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(186784206001204969.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574333219235476044.4001)
,p_event_id=>wwv_flow_api.id(574333185197476043.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(186785732448204976.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Security Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_debug.enter (',
'   ''Copy Security Scheme'',',
'   ''g_f01.count'', wwv_flow.g_f01.count,',
'   ''g_f02.count'', wwv_flow.g_f02.count,',
'   ''g_f03.count'', wwv_flow.g_f03.count,',
'   ''g_f04.count'', wwv_flow.g_f04.count );',
'for i in 1..wwv_flow.g_f03.count loop',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_copy_util.copy_security_scheme (',
'      p_copy_from_flow_id  => :F4000_P185_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_scheme_id     => wwv_flow.g_f03(i),',
'      p_to_scheme_name     => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'      p_subscribe          => (wwv_flow.g_f02(i) = ''SUBSCRIBE'') );',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar los esquemas de autorizaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(186783919387204968.4001)
,p_process_success_message=>unistr('Esquemas de autorizaci\00F3n copiados.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574333355827476045.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(186783919387204968.4001)
,p_process_success_message=>unistr('Esquemas de autorizaci\00F3n copiados.')
);
end;
/
prompt --application/pages/page_00188
begin
wwv_flow_api.create_page(
 p_id=>188.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autorizaci\00F3n: Detalles')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10823606153399570.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the F4000_P188_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_type_page_item_name => ''F4000_P188_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P188_'',',
'        p_user_interface_id   => null,',
'        p_is_wizard           => true );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186970606141820893.4001)
,p_plug_name=>unistr('Punto de Evaluaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186971220738820895.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186972714623820901.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(186911322244744240.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186973018734820902.4001)
,p_plug_name=>unistr('Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para definir un esquema de autorizaci\00F3n. Al crear esquemas de autorizaci\00F3n, podr\00E1 proteger aplicaciones, p\00E1ginas y componentes de aplicaciones, as\00ED como ampliar la seguridad proporcionada por el esquema de autenticaci\00F3n de la a')
||unistr('plicaci\00F3n. Puede utilizar esquemas de autorizaci\00F3n para identificar seguridad adicional que vaya m\00E1s all\00E1 de la simple autenticaci\00F3n del usuario. Por ejemplo, es posible que un usuario con derechos de administraci\00F3n necesite tener acceso a m\00E1s iconos')
||unistr(' de barra de navegaci\00F3n, p\00E1ginas y separadores que otros usuarios.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 09-DEC-2000 21:06:40'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186974225235820906.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186976325397820915.4001)
,p_plug_name=>unistr('Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186971513800820896.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186971220738820895.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186972400577820899.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186971220738820895.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Esquema de Autorizaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(187051016967915954.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186971220738820895.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186978129570820942.4001)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186972400577820899.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(187051403321915958.4001)
,p_branch_action=>'184'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(187051016967915954.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186979001171820946.4001)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(186971513800820896.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10831832472407136.4001)
,p_name=>'P188_ATTRIBUTE_01'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10832028398407137.4001)
,p_name=>'P188_ATTRIBUTE_02'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10832230802407137.4001)
,p_name=>'P188_ATTRIBUTE_03'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10832432505407137.4001)
,p_name=>'P188_ATTRIBUTE_04'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10832617540407138.4001)
,p_name=>'P188_ATTRIBUTE_05'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10832831374407141.4001)
,p_name=>'P188_ATTRIBUTE_06'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10833001084407141.4001)
,p_name=>'P188_ATTRIBUTE_07'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10833221837407141.4001)
,p_name=>'P188_ATTRIBUTE_08'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10833404437407141.4001)
,p_name=>'P188_ATTRIBUTE_09'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10833616508407142.4001)
,p_name=>'P188_ATTRIBUTE_10'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10833819349407142.4001)
,p_name=>'P188_ATTRIBUTE_11'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10834002041407142.4001)
,p_name=>'P188_ATTRIBUTE_12'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10834218697407142.4001)
,p_name=>'P188_ATTRIBUTE_13'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10834415036407143.4001)
,p_name=>'P188_ATTRIBUTE_14'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10834622868407143.4001)
,p_name=>'P188_ATTRIBUTE_15'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186970910581820894.4001)
,p_name=>'F4000_P188_CACHING'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(186970606141820893.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_USER_BY_SESSION'
,p_prompt=>unistr('Validar Esquema de Autorizaci\00F3n:')
,p_source=>'CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTH_SCHEME_CACHING'
,p_lov=>'.'||wwv_flow_api.id(84860700520374929.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Los esquemas de autorizaci\00F3n se eval\00FAan en el primer uso de una sesi\00F3n.'),
unistr('El atributo <em>Validar Esquema de Autorizaci\00F3n</em> controla si las utilizaciones futuras generan nuevas evaluaciones y cu\00E1ndo se puede tomar en su lugar un resultado memorizado.'),
'La siguiente lista describe las opciones disponibles:',
'</p>',
'<ul>',
unistr('<li><strong>Una Vez por Sesi\00F3n:</strong> evaluar solo una vez y utilizar siempre el resultado memorizado posteriormente.</li>'),
unistr('<li><strong>Una Vez por Vista de P\00E1gina:</strong> evaluar una vez para cada solicitud que se procesa. Utilizar el resultado memorizado si se hace referencia al esquema de autorizaci\00F3n en m\00E1s de un componente en la p\00E1gina.</li>'),
unistr('<li><strong>Una Vez por Componente:</strong> evaluar una vez para cada componente que hace referencia al esquema de autorizaci\00F3n, pero guardar el resultado en la sesi\00F3n. Las dem\00E1s solicitudes para presentar o procesar el esquema utilizan el resultado')
||' memorizado.</li>',
unistr('<li><strong>Siempre (Sin Almacenamiento en Cach\00E9):</strong> el esquema de autorizaci\00F3n se evaluar\00E1 siempre.</li>'),
'</ul>',
'<p>',
unistr('El valor por defecto <em>Una Vez por Sesi\00F3n</em> es el m\00E1s eficiente.'),
unistr('Debe seleccionar otro valor si la comprobaci\00F3n de autorizaci\00F3n depende del cambio de estado de la sesi\00F3n u otros factores que no son consistentes en una sesi\00F3n completa.'),
unistr('Las opciones <em>Una Vez por Componente</em> y <em>Siempre (Sin Almacenamiento en Cach\00E9)</em> proporcionan informaci\00F3n adicional sobre el componente que se protege mediante el esquema de autorizaci\00F3n.'),
unistr('En los plugins de autorizaci\00F3n, puede utilizar los atributos <em>component.type</em>, <em>component.id</em> y <em>component.name</em> del par\00E1metro <em>t_authorization</em>.'),
unistr('Para los tipos de esquema <em>Consulta SQL Exists</em> y <em>Funci\00F3n PL/SQL</em> incorporados, hay disponibles variables de enlace <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> y <em>:APP_COMPONENT_NAME</em> equivalentes.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186973320389820903.4001)
,p_name=>'F4000_P188_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(186973018734820902.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<p>Identifica la aplicaci\00F3n actual.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186973612706820904.4001)
,p_name=>'F4000_P188_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(186973018734820902.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre \00FAnico que identifica este esquema de autorizaci\00F3n.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186973925391820905.4001)
,p_name=>'F4000_P188_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(186973018734820902.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186974523106820907.4001)
,p_name=>'F4000_P188_COMMENTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(186974225235820906.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186976606472820937.4001)
,p_name=>'F4000_P188_SCHEME_TYPE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Esquema'
,p_source=>'SCHEME_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHORIZATION TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHORIZATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHORIZATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHORIZATION TYPE''',
'       )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Esquema de Autorizaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la forma en la que se aplicar\00E1 este esquema de autorizaci\00F3n. Se soportan los siguientes tipos incorporados:</p>'),
'<ul>',
unistr('<li><strong>Consulta SQL Exists</strong>: consulta que hace que se apruebe el esquema de autorizaci\00F3n si devuelve al menos una fila y provoca que \00E9ste falle si no devuelve ninguna</li>'),
unistr('<li><strong>Consulta SQL NOT Exists</strong>: consulta que hace que se apruebe el esquema de autorizaci\00F3n si no devuelve ninguna fila y provoca que \00E9ste falle si devuelve una o m\00E1s filas</li>'),
unistr('<li><strong>Funci\00F3n PL/SQL Que Devuelve Valor Booleano</strong>: cuerpo de la funci\00F3n PL/SQL que devuelve un valor true o false. Un valor false provoca que el esquema de autorizaci\00F3n falle. Un valor true hace que se apruebe.</li>'),
unistr('<li><strong>Elemento en Expresi\00F3n 1 Nulo</strong>: el valor del elemento especificado en la expresi\00F3n 1 es nulo.</li>'),
unistr('<li><strong>Elemento en Expresi\00F3n 1 No Nulo</strong>: el valor del elemento especificado en la expresi\00F3n 1 no es nulo.</li>'),
unistr('<li><strong>Valor de Preferencia en Expresi\00F3n 1 Equivale a Expresi\00F3n 2</strong>: el valor de preferencia especificado en la expresi\00F3n 1 equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Valor de Preferencia en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2</strong>: el valor de preferencia especificado en la expresi\00F3n 1 no equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Valor de Elemento en Expresi\00F3n 1 Equivale a Expresi\00F3n 2</strong>: el valor del elemento especificado en la expresi\00F3n 1 equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Valor de Elemento en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2</strong>: el valor del elemento especificado en la expresi\00F3n 1 no equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Est\00E1 en el Grupo</strong>: introduzca un nombre de grupo.'),
unistr('La autorizaci\00F3n es correcta si el grupo est\00E1 activado como un grupo din\00E1mico para la sesi\00F3n (consulte APEX_AUTHORIZATION.ENABLE_DYNAMIC_GROUPS).'),
unistr('Si la aplicaci\00F3n utiliza la autenticaci\00F3n de cuentas de Application Express,'),
unistr('esta comprobaci\00F3n tambi\00E9n incluye los grupos de espacios de trabajo que se otorgan al usuario.'),
unistr('Si se utiliza la autenticaci\00F3n de base de datos, esta comprobaci\00F3n tambi\00E9n incluye los roles de base de datos que se otorgan al usuario.</li>'),
unistr('<li><strong>No Est\00E1 en el Grupo</strong>: el grupo no est\00E1 activado o no se ha otorgado al usuario. Consulte <strong>Est\00E1 en el Grupo</strong> para obtener m\00E1s informaci\00F3n.</li>    '),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186977502755820940.4001)
,p_name=>'F4000_P188_ERROR_MESSAGE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(186976325397820915.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje de error de identificaci\00F3n que aparece cuando se ha violado un esquema')
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C9ste es el texto de error que aparece cuando este esquema de autorizaci\00F3n se aplica a una p\00E1gina o aplicaci\00F3n.</p>'),
unistr('<p>Si el esquema de autorizaci\00F3n falla (es decir, falla la comprobaci\00F3n de seguridad del usuario actual), aparece este texto.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(270558972915579257.4001)
,p_validation_name=>'Name Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from WWV_FLOW_SECURITY_SCHEMES',
'where security_group_id = :flow_security_group_id ',
'and   flow_id = :FB_FLOW_ID ',
'and   id != nvl(:F4000_P188_ID, -1)',
'and   name = :F4000_P188_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('#LABEL# debe ser un valor \00FAnico.')
,p_when_button_pressed=>wwv_flow_api.id(186972400577820899.4001)
,p_associated_item=>wwv_flow_api.id(186973612706820904.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186999700604845441.4001)
,p_validation_name=>'naming convention on name'
,p_validation_sequence=>20
,p_validation=>'substr(:F4000_P188_NAME,1,1) not in (''!'',''0'',''1'',''2'',''3'',''4'',''5'',''6'',''7'',''8'',''9'','' '')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(186973612706820904.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-MAR-2002 16:40'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10823531517387974.4001)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P188_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P188_'',',
'        p_user_interface_id => null );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574333882181476050.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(186971513800820896.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585123867968099801.4001)
,p_event_id=>wwv_flow_api.id(574333882181476050.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2250979484123294437.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P188_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P188_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(186981729774820956.4001)
,p_process_sequence=>25
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error al procesar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(585123983398099802.4001)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(186972400577820899.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203930583112288837.4001)
,p_process_sequence=>15
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P188_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P188_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00191
begin
wwv_flow_api.create_page(
 p_id=>191.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Bot\00F3n: Nuevo Bot\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45388811726521042.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57460003451115880.4001)
,p_name=>unistr('Bot\00F3n Copiar de')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id,',
'flow_step_id,',
'BUTTON_IMAGE_ALT,',
'button_name,',
'(select plug_name from wwv_flow_page_plugs p where p.id = BUTTON_PLUG_ID) region,',
'button_sequence',
'from wwv_flow_step_buttons',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57460415797116011.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57460501067116011.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57460605830116011.4001)
,p_query_column_id=>3
,p_column_alias=>'BUTTON_IMAGE_ALT'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57460704905116011.4001)
,p_query_column_id=>4
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57460821440116011.4001)
,p_query_column_id=>5
,p_column_alias=>'REGION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57460907802116011.4001)
,p_query_column_id=>6
,p_column_alias=>'BUTTON_SEQUENCE'
,p_column_display_sequence=>6
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180771506850346588.4001)
,p_plug_name=>unistr('Copiar Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181195014492291571.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181185105878280365.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180781500828351759.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45388811726521042.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180821926371378056.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45388811726521042.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180791218143356765.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45388811726521042.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180822309138378064.4001)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(180821926371378056.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180781915611351770.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(180781500828351759.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180791619613356773.4001)
,p_branch_action=>'231'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(180791218143356765.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15196000144860545.4001)
,p_name=>'F4000_P191_COPY_TO_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(180771506850346588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :F4000_P231_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177290258519915729.4001)
,p_name=>'F4000_P191_COPY_TO_POSITION'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(180771506850346588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Posici\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_position',
'from wwv_flow_step_buttons',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dp.name as d,',
'       dp.placeholder as r ',
'  from wwv_flow_page_tmpl_disp_points dp ',
' where :F4000_P191_COPY_TO_REGION is null',
'   and dp.security_group_id  = :WORKSPACE_ID',
'   and dp.flow_id            = :FB_FLOW_ID',
'   and dp.has_button_support = ''Y''',
'   and dp.page_template_id   = ( select coalesce( p.step_template, ( select t.default_page_template',
'                                                                       from wwv_flow_user_interfaces ui,',
'                                                                            wwv_flow_themes t',
'                                                                      where ui.security_group_id = dp.security_group_id ',
'                                                                        and ui.flow_id           = dp.flow_id',
'                                                                        and t.security_group_id  = ui.security_group_id ',
'                                                                        and t.flow_id            = ui.flow_id',
'                                                                        and t.theme_id           = ui.theme_id ) )',
'                                   from wwv_flow_steps p',
'                                  where p.security_group_id = dp.security_group_id ',
'                                    and p.flow_id           = dp.flow_id',
'                                    and p.id                = :F4000_P231_COPY_TO_PAGE_ID )',
'',
'union all',
'',
'-- region positions',
'select dp.name as d,',
'       dp.placeholder as r ',
'  from wwv_flow_plug_tmpl_disp_points dp ',
' where :F4000_P191_COPY_TO_REGION is not null',
'   and dp.security_group_id = :WORKSPACE_ID',
'   and dp.flow_id           = :FB_FLOW_ID',
'   and dp.has_button_support = ''Y''',
'   and dp.plug_template_id  = ( select p.plug_template',
'                                  from wwv_flow_page_plugs p',
'                                 where p.security_group_id = dp.security_group_id ',
'                                   and p.flow_id           = dp.flow_id',
'                                   and p.page_id           = :F4000_P231_COPY_TO_PAGE_ID',
'                                   and p.id                = :F4000_P191_COPY_TO_REGION )',
'',
'union all',
'',
'-- fallback when region has no template',
'select wwv_flow_lang.system_message(''LAYOUT.T_BODY'') as d,',
'       ''BODY'' as r',
'  from dual ',
' where :F4000_P191_COPY_TO_REGION is not null',
'   and not exists ( select 1',
'                      from wwv_flow_plug_tmpl_disp_points dp ',
'                     where :F4000_P191_COPY_TO_REGION is not null',
'                       and dp.security_group_id = :WORKSPACE_ID',
'                       and dp.flow_id           = :FB_FLOW_ID',
'                       and dp.has_button_support = ''Y''',
'                       and dp.plug_template_id  = ( select p.plug_template',
'                                                      from wwv_flow_page_plugs p',
'                                                     where p.security_group_id = dp.security_group_id ',
'                                                       and p.flow_id           = dp.flow_id',
'                                                       and p.page_id           = :F4000_P231_COPY_TO_PAGE_ID',
'                                                       and p.id                = :F4000_P191_COPY_TO_REGION ) )',
'',
'order by 1'))
,p_lov_cascade_parent_items=>'F4000_P191_COPY_TO_REGION'
,p_ajax_optimize_refresh=>'N'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Identifica la posici\00F3n de regi\00F3n en la que aparecer\00E1 el bot\00F3n.</p> ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180909522698475978.4001)
,p_name=>'F4000_P191_COPY_TO_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(180771506850346588.4001)
,p_prompt=>unistr('Nombre del Bot\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select BUTTON_NAME',
'',
'from wwv_flow_step_buttons',
'',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nombre de aplicaci\00F3n interna para el bot\00F3n. Utilice este nombre para hacer referencia al valor del bot\00F3n. Por ejemplo, para implantar un bot\00F3n Cancelar, utilice un nombre de bot\00F3n <strong>CANCELAR</strong>. A continuaci\00F3n puede realizar una bifurc')
||unistr('aci\00F3n a una p\00E1gina concreta cuando la solicitud sea igual a <strong>CANCELAR</strong>.</p>'),
unistr('<p>Aunque el texto real del bot\00F3n se puede traducir a otros idiomas, el bot\00F3n se ejecutar\00E1 siempre con el nombre que se especifique aqu\00ED. Tenga en cuenta que el nombre del bot\00F3n define el valor de REQUEST.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180912717091478628.4001)
,p_name=>'F4000_P191_COPY_TO_REGION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(180771506850346588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_plug_id',
'from wwv_flow_step_buttons',
'where id = :F4000_P231_COPY_FROM_ID',
'and :F4000_P231_COPY_FROM_PAGE_ID = :F4000_P231_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when r.page_id = ui.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || r.plug_name || '' ('' || r.plug_display_sequence || '')'' as d,',
'       r.id as r',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P231_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and ui.id               = p.user_interface_id',
'   and r.flow_id           = ui.flow_id',
'   and r.page_id          in (:F4000_P231_COPY_TO_PAGE_ID, ui.global_page_id)',
' order by case when r.page_id = ui.global_page_id then 2 else 1 end, r.plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Regi\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Identifica la regi\00F3n en la que aparecer\00E1 el bot\00F3n.</p> ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180917507602482987.4001)
,p_name=>'F4000_P191_COPY_TO_SEQ'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(180771506850346588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DECODE(max(button_sequence),NULL,0,max(button_sequence)) + 10',
'',
'from wwv_flow_step_buttons',
'',
'where flow_id = :fb_flow_id',
'',
'and flow_step_id = :F4000_P231_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181132410734141286.4001)
,p_name=>'F4000_P191_COPY_TO_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(180771506850346588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select BUTTON_IMAGE_ALT',
'',
'from wwv_flow_step_buttons',
'',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Si el bot\00F3n es texto, \00E9ste es el texto que aparece en el bot\00F3n. Si el bot\00F3n es una imagen, este texto se convierte en la etiqueta alternativa. Si este campo es nulo, se establecer\00E1 por defecto en el nombre del bot\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181216816371366640.4001)
,p_validation_name=>'F4000_P191_COPY_TO_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P191_COPY_TO_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de bot\00F3n.')
,p_associated_item=>wwv_flow_api.id(180909522698475978.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 21-FEB-2002 09:52'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181217110143366641.4001)
,p_validation_name=>'F4000_P191_COPY_TO_LABEL Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P191_COPY_TO_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la etiqueta.'
,p_associated_item=>wwv_flow_api.id(181132410734141286.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 21-FEB-2002 09:52'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181217721915366643.4001)
,p_validation_name=>'F4000_P191_COPY_TO_SEQ Not Null'
,p_validation_sequence=>40
,p_validation=>'F4000_P191_COPY_TO_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia de botones.'
,p_associated_item=>wwv_flow_api.id(180917507602482987.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 21-FEB-2002 09:52'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186008502136940308.4001)
,p_validation_name=>'Validate valid button name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_builder.is_valid_item_name ( ',
'    p_name => :F4000_P191_COPY_TO_NAME )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nombre de bot\00F3n "&F4000_P191_COPY_TO_NAME." no puede contener los caracteres :&,.+?%''" ni espacios.')
,p_when_button_pressed=>wwv_flow_api.id(180821926371378056.4001)
,p_associated_item=>wwv_flow_api.id(180909522698475978.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590120192174572037.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(180781500828351759.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590120225645572038.4001)
,p_event_id=>wwv_flow_api.id(590120192174572037.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110036124053898528.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CopyButton'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.copy_button (',
'    p_button_id_from  => :F4000_P231_COPY_FROM_ID,',
'    p_button_name_to  => :F4000_P191_COPY_TO_NAME,',
'    p_button_text_to  => :F4000_P191_COPY_TO_LABEL,',
'    p_button_page_id_to  => :F4000_P231_COPY_TO_PAGE_ID,',
'    p_button_sequence_to => :F4000_P191_COPY_TO_SEQ,',
'    p_button_region_to => :F4000_P191_COPY_TO_REGION,',
'    p_button_position_to => :F4000_P191_COPY_TO_POSITION',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar el bot\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Bot\00F3n copiado en la p\00E1gina &F4000_P231_COPY_TO_PAGE_ID..')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590120349816572039.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Bot\00F3n copiado en la p\00E1gina &F4000_P231_COPY_TO_PAGE_ID..')
);
end;
/
prompt --application/pages/page_00194
begin
wwv_flow_api.create_page(
 p_id=>194.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Regi\00F3n: En P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7792622760472461.4001)
,p_name=>unistr('Copiar de Validaciones de Regi\00F3n')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_sequence,',
'       validation_name',
'  from wwv_flow_step_validations',
' where flow_id      = :fb_flow_id',
'   and flow_step_id = :fb_flow_page_id',
'   and security_group_id = :flow_security_group_id',
'   and tabular_form_region_id in (',
'           select id',
'             from wwv_flow_page_plugs',
'            where flow_id           = :FB_FLOW_ID',
'              and page_id           = :FB_FLOW_PAGE_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            start with id = :F4000_P194_PLUG_ID_FROM',
'          connect by prior id = parent_plug_id )',
' order by validation_sequence, validation_name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_validations (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La regi\00F3n no tiene validaciones.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7793511116478623.4001)
,p_query_column_id=>1
,p_column_alias=>'VALIDATION_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Secuencia de Validaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7793603243478623.4001)
,p_query_column_id=>2
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre de Validaci\00F3n')
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7793718042480620.4001)
,p_name=>unistr('Copiar de Procesos de Regi\00F3n')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_sequence,',
'       process_name',
'  from wwv_flow_step_processing',
' where flow_id      = :fb_flow_id',
'   and flow_step_id = :fb_flow_page_id',
'   and security_group_id = :flow_security_group_id',
'   and region_id in (',
'           select id',
'             from wwv_flow_page_plugs',
'            where flow_id           = :FB_FLOW_ID',
'              and page_id           = :FB_FLOW_PAGE_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            start with id = :F4000_P194_PLUG_ID_FROM',
'          connect by prior id = parent_plug_id )',
' order by process_sequence, process_name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_processes (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La regi\00F3n no tiene procesos.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7794509516487530.4001)
,p_query_column_id=>1
,p_column_alias=>'PROCESS_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia de Proceso'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7794616602487530.4001)
,p_query_column_id=>2
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Proceso'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45373922050344248.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(81934329568650544.4001)
,p_name=>unistr('Copiar de Regi\00F3n')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  flow_id,',
'  page_id,',
'  plug_name,',
'  plug_display_sequence,',
'  plug_source_type        ',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81934724668650553.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81934830885650553.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81934924932650553.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81935028229650554.4001)
,p_query_column_id=>4
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Secuencia de Visualizaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81935310525650554.4001)
,p_query_column_id=>5
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo de Origen'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32361488916)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(115839224419800245.4001)
,p_name=>unistr('Copiar de Elementos de Regi\00F3n')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ITEM_SEQUENCE,',
'       NAME,',
'       PROMPT',
'  from WWV_FLOW_STEP_ITEMS',
' where flow_id      = :fb_flow_id',
'   and flow_step_id = :fb_flow_page_id',
'   and security_group_id = :flow_security_group_id',
'   and item_plug_id in (',
'           select id',
'             from wwv_flow_page_plugs',
'            where flow_id           = :FB_FLOW_ID',
'              and page_id           = :FB_FLOW_PAGE_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            start with id = :F4000_P194_PLUG_ID_FROM',
'          connect by prior id = parent_plug_id )'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_items (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La regi\00F3n no tiene elementos.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115839513682800253.4001)
,p_query_column_id=>1
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Secuencia de Visualizaci\00F3n')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115839610576800253.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115839717149800253.4001)
,p_query_column_id=>3
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(162415522135065533.4001)
,p_name=>unistr('P\00E1ginas Editadas Recientemente')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna p\00E1gina.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162415700932065535.4001)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162415811080065535.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(170756904725276796.4001)
,p_name=>'Copiar de Subregiones'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as hierarchy_level,',
'        plug_display_sequence,',
'        plug_name',
'   from wwv_flow_page_plugs',
'  where flow_id           = :FB_FLOW_ID',
'    and page_id           = :FB_FLOW_PAGE_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  start with parent_plug_id = :F4000_P194_PLUG_ID_FROM',
'connect by prior id = parent_plug_id',
'  order siblings by plug_display_sequence, plug_name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_sub_regions (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La regi\00F3n no tiene subregiones.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(170757605726324406.4001)
,p_query_column_id=>1
,p_column_alias=>'HIERARCHY_LEVEL'
,p_column_display_sequence=>1
,p_column_heading=>'Nivel'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(170757712731324406.4001)
,p_query_column_id=>2
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Secuencia de Visualizaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(170757822550324406.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197255110195041780.4001)
,p_plug_name=>unistr('Copiar Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Identifique la p\00E1gina para la nueva regi\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197271418377053263.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(197233420990021629.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(224505023496694888.4001)
,p_name=>'Botones Copiar de'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_sequence,',
'       button_name',
'  from ( select button_sequence,',
'                button_name,',
'                button_plug_id',
'           from wwv_flow_step_buttons',
'          where flow_id           = :FB_FLOW_ID',
'            and flow_step_id      = :FB_FLOW_PAGE_ID',
'            and security_group_id = :FLOW_SECURITY_GROUP_ID )',
' where button_plug_id in (',
'           select id',
'             from wwv_flow_page_plugs',
'            where flow_id           = :FB_FLOW_ID',
'              and page_id           = :FB_FLOW_PAGE_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            start with id = :F4000_P194_PLUG_ID_FROM',
'          connect by prior id = parent_plug_id )'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_buttons (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La regi\00F3n no tiene botones.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(224505811506700827.4001)
,p_query_column_id=>1
,p_column_alias=>'BUTTON_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Secuencia de Visualizaci\00F3n')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(224505913290700828.4001)
,p_query_column_id=>2
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197283023632061317.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45373922050344248.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197291613027067689.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45373922050344248.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197292028437067692.4001)
,p_branch_action=>'195'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_branch_condition=>'Cancel,Previous'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178096212823209603.4001)
,p_branch_action=>'f?p=&APP_ID.:194:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197283407585061320.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(197283023632061317.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7789519381452606.4001)
,p_name=>'P194_COPY_VALIDATIONS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Validaciones:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_validations (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar las validaciones de esta regi\00F3n. Seleccione <strong>S\00ED</strong> o <strong>No</strong>.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7790821936462730.4001)
,p_name=>'P194_COPY_PROCESSES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Procesos:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_processes (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar los procesos de esta regi\00F3n. Seleccione <strong>S\00ED</strong> o <strong>No</strong>.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115830017100769784.4001)
,p_name=>'P194_COPY_REGION_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Copiar Elementos de Regi\00F3n:')
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_items (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar los elementos de esta regi\00F3n. Seleccione <strong>S\00ED</strong> o <strong>No</strong>.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170771909021363143.4001)
,p_name=>'P194_COPY_SUB_REGIONS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Subregiones:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_sub_regions (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar las subregiones de esta regi\00F3n. Seleccione <strong>S\00ED</strong> o <strong>No</strong>.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197382112875192507.4001)
,p_name=>'F4000_P194_PLUG_ID_FROM'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Copy Region'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197403725358217145.4001)
,p_name=>'F4000_P194_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'F4000_P194_COPY_FROM_PAGE_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197410701204228348.4001)
,p_name=>'F4000_P194_COPY_TO_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_prompt=>unistr('En P\00E1gina')
,p_source=>'F4000_P194_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en que se copiar\00E1 esta regi\00F3n.')
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(224504126004676698.4001)
,p_name=>'P194_COPY_BUTTONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Botones:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_buttons (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar los botones en esta regi\00F3n. Seleccione <strong>S\00ED</strong> o <strong>No</strong>.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(364974104995887564.4001)
,p_name=>'P194_USER_INTERFACE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(197255110195041780.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(364974330215891116.4001)
,p_computation_sequence=>10
,p_computation_item=>'P194_USER_INTERFACE_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_interface_id',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :F4000_P194_COPY_TO_PAGE_ID'))
,p_compute_when=>'F4000_P194_COPY_TO_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(55668018204386734.4001)
,p_validation_name=>'must choose existing page'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P194_COPY_TO_PAGE_ID) then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe especificar una p\00E1gina existente.')
,p_validation_condition=>'Cancel,Previous'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(197410701204228348.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(197416008956239909.4001)
,p_validation_name=>'new page id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P194_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo identificador de p\00E1gina.')
,p_validation_condition=>'Cancel,Previous'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(197410701204228348.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(166834530924837051.4001)
,p_validation_name=>'check page lock'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from wwv_flow_lock_page where OBJECT_ID = :F4000_P194_COPY_TO_PAGE_ID and flow_id = :fb_flow_id',
'and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede copiar en una p\00E1gina bloqueada por otro usuario.')
,p_validation_condition=>'Cancel,Previous'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(242410630611969213.4001)
,p_validation_name=>'Only 1 Calendar Per Page'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from wwv_flow_cals c, wwv_flow_page_plugs p',
' where c.plug_id = p.id',
' and   p.flow_id = :FB_FLOW_ID',
' and   p.page_id = :F4000_P194_COPY_TO_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('S\00F3lo est\00E1 soportado un calendario por p\00E1gina.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM',
'and   plug_source_type = ''NATIVE_CALENDAR''',
'and nvl(:REQUEST,''x'') not in (''Cancel'',''Previous'')'))
,p_validation_condition_type=>'EXISTS'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115984121871266126.4001)
,p_validation_name=>'verify new page if cp items'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P194_COPY_REGION_ITEMS = ''Y'' and :F4000_P194_COPY_TO_PAGE_ID = :fb_flow_page_id then ',
'    return false; ',
'else ',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('S\00F3lo puede copiar elementos en una p\00E1gina diferente.')
,p_when_button_pressed=>wwv_flow_api.id(197291613027067689.4001)
,p_associated_item=>wwv_flow_api.id(115830017100769784.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(364974600023905138.4001)
,p_validation_name=>'IR only allowed on Desktop page'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P194_COPY_TO_PAGE_ID is not null ',
'    and wwv_flow_wizard_api.page_exists ( ',
'            p_flow_id => :fb_flow_id, ',
'            p_page_id => :F4000_P194_COPY_TO_PAGE_ID) ',
'    and',
'        wwv_flow_user_interface_dev.supports_feature ( ',
'            p_user_interface_id => :P194_USER_INTERFACE_ID,',
'            p_name              => ''INTERACTIVE_REPORT'' ) then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Un informe interactivo s\00F3lo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.ir_report_exists( ',
'    p_flow_id   => :FB_FLOW_ID, ',
'    p_page_id   => :FB_FLOW_PAGE_ID,',
'    p_region_id => :F4000_P194_PLUG_ID_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(197291613027067689.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(364976810023067632.4001)
,p_validation_name=>'Tree only allowed on Desktop page'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P194_COPY_TO_PAGE_ID is not null ',
'    and wwv_flow_wizard_api.page_exists ( ',
'            p_flow_id => :fb_flow_id, ',
'            p_page_id => :F4000_P194_COPY_TO_PAGE_ID) ',
'    and',
'        wwv_flow_user_interface_dev.supports_feature ( ',
'            p_user_interface_id => :P194_USER_INTERFACE_ID,',
'            p_name              => ''JSTREE'' ) then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Una regi\00F3n de jsTree s\00F3lo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.jstree_exists( ',
'    p_flow_id   => :FB_FLOW_ID, ',
'    p_page_id   => :FB_FLOW_PAGE_ID,',
'    p_region_id => :F4000_P194_PLUG_ID_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(197291613027067689.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(365040532511044779.4001)
,p_validation_name=>'Tabular Form only allowed on Desktop page'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P194_COPY_TO_PAGE_ID is not null ',
'    and wwv_flow_wizard_api.page_exists ( ',
'            p_flow_id => :fb_flow_id, ',
'            p_page_id => :F4000_P194_COPY_TO_PAGE_ID) ',
'    and',
'        wwv_flow_user_interface_dev.supports_feature ( ',
'            p_user_interface_id => :P194_USER_INTERFACE_ID,',
'            p_name              => ''TABULAR_FORM'' ) then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Una regi\00F3n de pantalla tabular s\00F3lo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.tabular_form_exists( ',
'    p_flow_id   => :FB_FLOW_ID, ',
'    p_page_id   => :FB_FLOW_PAGE_ID,',
'    p_region_id => :F4000_P194_PLUG_ID_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(197291613027067689.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590120929031572045.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(197283023632061317.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590121008915572046.4001)
,p_event_id=>wwv_flow_api.id(590120929031572045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00195
begin
wwv_flow_api.create_page(
 p_id=>195.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Regi\00F3n: Nueva Regi\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45380423613382551.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(81942219188723227.4001)
,p_name=>unistr('Copiar de Regi\00F3n')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  flow_id,',
'  page_id,',
'  plug_name,',
'  plug_display_sequence,',
'  plug_display_point,',
'  plug_source_type        ',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81942631723723231.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81942723109723232.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81942809816723232.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81942909090723232.4001)
,p_query_column_id=>4
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Secuencia de Visualizaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81943116619723232.4001)
,p_query_column_id=>5
,p_column_alias=>'PLUG_DISPLAY_POINT'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Punto de Visualizaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(131723061838)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(81943208962723232.4001)
,p_query_column_id=>6
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo de Origen'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32361488916)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171468430718689397.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197299403916075146.4001)
,p_plug_name=>unistr('Copiar Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197306822882081519.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(197233420990021629.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(225787614827384691.4001)
,p_name=>unistr('Copiar en Regiones de P\00E1gina')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  plug_name,',
'  plug_display_sequence,',
'  plug_display_point,',
'  plug_source_type        ',
'from wwv_flow_page_plugs',
'where page_id = :F4000_P194_COPY_TO_PAGE_ID and ',
'flow_id = :fb_flow_id  ',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(225788010895384698.4001)
,p_query_column_id=>1
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(225788120256384698.4001)
,p_query_column_id=>2
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Secuencia de Visualizaci\00F3n')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(225788320813384698.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUG_DISPLAY_POINT'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Punto de Visualizaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(131723061838)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(225788403749384698.4001)
,p_query_column_id=>4
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo de Origen'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32361488916)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197309504632084261.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45380423613382551.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197319129220091370.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45380423613382551.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(197312114675087163.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45380423613382551.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197319531599091373.4001)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(197319129220091370.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197309902322084263.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(197309504632084261.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197312513819087166.4001)
,p_branch_action=>'194'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(197312114675087163.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7796205884524383.4001)
,p_name=>'P195_COPY_VALIDATIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Validaciones:'
,p_source=>'&P194_COPY_VALIDATIONS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar las validaciones de esta regi\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7797703245533024.4001)
,p_name=>'P195_COPY_PROCESSES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Procesos:'
,p_source=>'&P194_COPY_PROCESSES.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar los procesos de esta regi\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115861009968852840.4001)
,p_name=>'P195_COPY_REGION_ITEMS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Copiar Elementos de Regi\00F3n:')
,p_source=>'&P194_COPY_REGION_ITEMS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Determine si desea que estos elementos de regi\00F3n se copien en la regi\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163521714679993315.4001)
,p_name=>'P195_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Identifica la p\00E1gina desde la que se est\00E1 copiando la regi\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170775630248501772.4001)
,p_name=>'P195_PARENT_PLUG_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(171468430718689397.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P195_PARENT_REGIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :F4000_P194_COPY_TO_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Principal -'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Define la regi\00F3n principal a la que pertenece la nueva regi\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170778515582563761.4001)
,p_name=>'P195_COPY_SUB_REGIONS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Subregiones:'
,p_source=>'&P194_COPY_SUB_REGIONS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar las subregiones de esta regi\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197428227250277038.4001)
,p_name=>'F4000_P195_COPY_TO_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Copiar en P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :F4000_P194_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197433726806292377.4001)
,p_name=>'F4000_P195_REGION_NAME'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El nombre de regi\00F3n identifica el nombre de una regi\00F3n para los desarrolladores de aplicaciones. Tambi\00E9n es el nombre que se sustituye por la cadena de sustituci\00F3n #TITLE# identificada en la plantilla de regi\00F3n.<p> '),
unistr('</p>Si no se selecciona ninguna plantilla de regi\00F3n, no aparecer\00E1 el t\00EDtulo de la regi\00F3n. Este nombre de regi\00F3n puede incluir cadenas de sustituci\00F3n &ITEM.')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197441222049309865.4001)
,p_name=>'F4000_P195_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(plug_display_sequence), 0) + 10',
'  from wwv_flow_page_plugs',
' where flow_id = :fb_flow_id',
'   and page_id = :F4000_P194_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197473727163383418.4001)
,p_name=>'F4000_P195_DISPLAY_POINT'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(171468430718689397.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Punto de Visualizaci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_display_point',
'',
'from wwv_flow_page_plugs',
'',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_DISPLAY_POINT'
,p_lov=>'.'||wwv_flow_api.id(131723061838.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('<p>Este atributo controla el lugar donde se muestran regiones de p\00E1gina. Las regiones de p\00E1gina se pueden mostrar en distintos puntos de una p\00E1gina.</p>')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(224522525171941394.4001)
,p_name=>'P195_COPY_BUTTONS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copiar Botones:'
,p_source=>'&P194_COPY_BUTTONS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Determine si tambi\00E9n desea copiar los botones en esta regi\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(568325029966890739.4001)
,p_name=>'P195_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(197299403916075146.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador Est\00E1tico')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select region_name',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM',
'and region_name is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Introduzca un valor para identificar esta regi\00F3n. Puede hacer referencia a este valor con la cadena de sustituci\00F3n #REGION_STATIC_ID#. La referencia a este valor puede ser de utilidad al desarrollar JavaScript personalizado.<p/>Si no se introduce un ')
||unistr('nuevo ID est\00E1tico, se puede producir un comportamiento inesperado del c\00F3digo que se basa en la unicidad del ID est\00E1tico. ')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(171295425174344668.4001)
,p_name=>'Parent Region'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P195_PARENT_PLUG_ID'
,p_condition_element=>'P195_PARENT_PLUG_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(171296019418352484.4001)
,p_event_id=>wwv_flow_api.id(171295425174344668.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P195_DISPLAY_POINT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(171296606389358131.4001)
,p_event_id=>wwv_flow_api.id(171295425174344668.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P195_DISPLAY_POINT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590120639318572042.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(197309504632084261.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590120788609572043.4001)
,p_event_id=>wwv_flow_api.id(590120639318572042.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(197377304476181228.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy region'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_region (',
'        p_flow_id_from      => :FB_FLOW_ID,   ',
'        p_page_id_from      => :FB_FLOW_PAGE_ID,',
'        p_region_id_from    => :F4000_P194_PLUG_ID_FROM,',
'        p_flow_id_to        => :FB_FLOW_ID,    ',
'        p_page_id_to        => :F4000_P194_COPY_TO_PAGE_ID, ',
'        p_plug_name_to      => :F4000_P195_REGION_NAME,',
'        p_parent_plug_id_to => :P195_PARENT_PLUG_ID,    ',
'        p_display_seq_to    => :F4000_P195_DISPLAY_SEQ,',
'        p_display_point_to  => :F4000_P195_DISPLAY_POINT,',
'        p_copy_items        => (nvl(:P194_COPY_REGION_ITEMS, ''N'') = ''Y''),',
'        p_copy_buttons      => (nvl(:P194_COPY_BUTTONS,      ''N'') = ''Y''),',
'        p_copy_validations  => (nvl(:P194_COPY_VALIDATIONS,  ''N'') = ''Y''),',
'        p_copy_processes    => (nvl(:P194_COPY_PROCESSES,    ''N'') = ''Y''),',
'        p_copy_sub_regions  => (nvl(:P194_COPY_SUB_REGIONS,  ''N'') = ''Y''),',
'        p_region_name_to    => :P195_STATIC_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar las regiones &F4000_P194_PLUG_ID_FROM. to page &F4000_P194_COPY_TO_PAGE_ID..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(197319129220091370.4001)
,p_process_success_message=>unistr('Regiones copiadas en la p\00E1gina &F4000_P194_COPY_TO_PAGE_ID..')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590120897674572044.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Regiones copiadas en la p\00E1gina &F4000_P194_COPY_TO_PAGE_ID..')
);
end;
/
prompt --application/pages/page_00196
begin
wwv_flow_api.create_page(
 p_id=>196.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Servicio Web'
,p_step_title=>'Editar Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31199123761425877.4001)
,p_plug_name=>'Respuesta SOAP'
,p_region_name=>'R6'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46167825315774873.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86294025202192356.4001)
,p_plug_name=>'Servicio Web'
,p_region_name=>'R1'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 31-JUL-2002 20:44:47'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86333719809230389.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86372813302279015.4001)
,p_plug_name=>unistr('Descripci\00F3n de Servicio')
,p_region_name=>'R2'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86373608558281192.4001)
,p_plug_name=>'Elemento Envelope de SOAP'
,p_region_name=>'R3'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86408801200315023.4001)
,p_plug_name=>'Servicios Web'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El protocolo simple de acceso a objetos (SOAP), es un protocolo est\00E1ndar World Wide Web Consortium http://www.w3.org/ (W3C), o de consorcio de la Web, para definir el formato de las solicitudes de servicio Web.</p> '),
unistr('<p>Existe un intercambio de mensajes de SOAP entre el proveedor y el usuario del servicio en elementos envelope de SOAP. Los elementos envelope de SOAP contienen una solicitud para algunas acciones y el resultado de \00E9stas, y tienen un formato XML, qu')
||unistr('e las hacen f\00E1ciles de decodificar.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86294314768192362.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(86333719809230389.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86294620751192362.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(86333719809230389.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P196_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86294409655192362.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(86333719809230389.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P196_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86294501619192362.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(86333719809230389.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P196_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(86965711084064912.4001)
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29970604015456327.4001)
,p_name=>'P196_BASIC_AUTH'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(86372813302279015.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n B\00E1sica:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_read_only_when=>'F4000_P196_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si este servicio Web necesita autenticaci\00F3n b\00E1sica. Las credenciales de autenticaci\00F3n b\00E1sica se env\00EDan como parte de la solicitud HTTP sin cifrar. Los servicios Web que utilizan autenticaci\00F3n b\00E1sica, normalmente tambi\00E9n utilizan el protoco')
||unistr('lo HTTPS (SSL) ya que el nombre de usuario y la contrase\00F1a se env\00EDan sin cifrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31201426540502324.4001)
,p_name=>'P196_RESPONSE_COLLECTION'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(31199123761425877.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Almacenar Respuesta en Recopilaci\00F3n')
,p_source=>'STATIC_PARM_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de una recopilaci\00F3n para almacenar la respuesta del servicio Web. La respuesta se almacenar\00E1 en la columna CLOB001 de la recopilaci\00F3n introducida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86296104013192382.4001)
,p_name=>'F4000_P196_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(86294025202192356.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86296427033192396.4001)
,p_name=>'F4000_P196_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(86294025202192356.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86296701655192398.4001)
,p_name=>'F4000_P196_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(86294025202192356.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Nombre de este servicio Web dentro del contexto del creador. Este nombre solo se utiliza dentro de la herramienta Creador de aplicaciones.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86297317225192400.4001)
,p_name=>'F4000_P196_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(86372813302279015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la URL utilizada para enviar la solicitud de SOAP por HTTP. Corresponde a la ubicaci\00F3n soap:address de un puerto'),
unistr('   de servicio en WSDL. Puede hacer referencia al estado de sesi\00F3n en la URL con la convenci\00F3n <code>&amp;ITEM_NAME.</code>.</p>'),
'<p>Por ejemplo:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86297610683192401.4001)
,p_name=>'F4000_P196_ACTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(86372813302279015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Acci\00F3n')
,p_source=>'ACTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Indica el intento de la solicitud de HTTP de SOAP. El valor es una URI que identifica el intento.</p> <p>SOAP no incluye restricciones en el formato, en la precisi\00F3n de la URI o que sea resolutiva.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86298228587192403.4001)
,p_name=>'F4000_P196_PROXY_OVERRIDE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(86372813302279015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy'
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esto sustituye al proxy HTTP definido por el sistema para la solicitud. El proxy puede incluir un n\00FAmero de puerto TCP/IP opcional en el'),
'   que recibe el servidor proxy. Utilice la siguiente sintaxis:</p>',
'<pre>[http://]host[:port][/]</pre>',
'<p>Por ejemplo:</p>',
'<pre>www-proxy.ejemplo.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86298826087192404.4001)
,p_name=>'F4000_P196_SOAP_ENVELOPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(86373608558281192.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Elemento Envelope de SOAP'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique el elemento Envelope de SOAP que se va a utilizar para la solicitud de SOAP al servicio Web. Este elemento Envelope puede contener sustituciones de elementos de la pantalla #ITEM_NAME#.</p>',
'<p>Por ejemplo:</p>',
'<pre>&lt;SOAP-ENV:Envelope',
'xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"',
'',
'  xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"',
'',
'  xmlns:xsd="http://www.w3.org/1999/XMLSchema"',
'',
'  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">',
'',
'  &lt;SOAP-ENV:Body>&lt;LocalTimeByZipCode xmlns="http://www.alethea.net/webservices/">&lt;ZipCode xsi:type="xsd:string">#Fxxxx_Pyyy_ZIP_CODE#&lt;/ZipCode>&lt;/LocalTimeByZipCode></SOAP-ENV:Body>&lt;/SOAP-ENV:Envelope>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439439703858999767.4001)
,p_name=>'P196_SOAP_VERSION'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(86372813302279015.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1.1'
,p_prompt=>unistr('Versi\00F3n SOAP:')
,p_source=>'SOAP_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_SOAP_VERSION'
,p_lov=>'.'||wwv_flow_api.id(439439004288980949.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Elija la versi\00F3n de la especificaci\00F3n SOAP que utiliza este servicio web, 1.1 o 1.2.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30004122444717111.4001)
,p_computation_sequence=>10
,p_computation_item=>'P196_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_ws_operations',
'            where name = ''BASIC_AUTH''',
'              and ws_id = :F4000_P196_ID ) loop',
'  return ''Y'';',
'  exit;',
'end loop;',
'',
'return ''N'';'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(86499321996457354.4001)
,p_validation_name=>'F4000_P196_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P196_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(86296701655192398.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:28'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72395421424008219.4001)
,p_validation_name=>'URL Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P196_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la direcci\00F3n URL del servicio Web.')
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(86297317225192400.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72398304717022294.4001)
,p_validation_name=>'SOAP Envelope not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P196_SOAP_ENVELOPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el elemento Envelope de SOAP asociado al servicio Web.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(86298826087192404.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(86302828338192418.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P196_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(86303119203192421.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P196_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'F4000_P196_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>unistr('Error al actualizar la definici\00F3n de servicio Web.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Definici\00F3n de servicio Web actualizada.')
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(92606502028283804.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Preparse item substitutions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_items clob;',
'begin',
'    l_items := wwv_flow_web_services.parse( :F4000_P196_SOAP_ENVELOPE );',
'',
'    update wwv_flow_shared_web_services ',
'       set flow_items_comma_delimited = l_items',
'     where id = :F4000_P196_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29995505719579902.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create basic auth operation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_operations_id number;',
'  l_id number;',
'begin',
'',
'  l_operations_id := wwv_flow_id.next_val;',
'',
'  insert into wwv_flow_ws_operations (id, ws_id, name)     ',
'  values (l_operations_id, :F4000_P196_ID, ''BASIC_AUTH'');',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''username'', ''A'');         ',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''password'', ''A'');',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(86294409655192362.4001)
,p_process_when=>':P196_BASIC_AUTH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00197
begin
wwv_flow_api.create_page(
 p_id=>197.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Interfaces de Usuario'
,p_step_title=>'Editar Interfaces de Usuario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_api.id(235700916833599805.4001)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28154408216362812.4001)
,p_plug_name=>'Interfaz de usuario'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>400
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOWS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(314888924704274854.4001)
,p_plug_name=>'General'
,p_parent_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(314912623768407097.4001)
,p_plug_name=>'Logotipo'
,p_parent_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>420
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(879699542547493817.4001)
,p_plug_name=>'Favicon'
,p_parent_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>430
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42237425257357106.4001)
,p_plug_name=>unistr('Atributos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_api.id(274897624522614662.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42241822749375265.4001)
,p_plug_name=>unistr('Aplicaci\00F3n &FB_FLOW_ID.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>200
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(314914514202413808.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Editar las definiciones de interfaz de usuario de la aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(314916312648451181.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>300
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_plug_name=>'Detalles de interfaz de usuario'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>500
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_USER_INTERFACES'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72766345492681456.4001)
,p_plug_name=>'Atributos'
,p_parent_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(935666971301945228.4001)
,p_name=>'Archivos Concatenados'
,p_region_name=>'cont_file'
,p_parent_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>560
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       combined_file_url,',
'       page_id,',
'       required_patch',
'  from wwv_flow_combined_files',
' where user_interface_id = :P197_UI_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P197_UI_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28177847720421910.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28178244311421912.4001)
,p_query_column_id=>2
,p_column_alias=>'COMBINED_FILE_URL'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Direcci\00F3n URL de Archivo')
,p_column_link=>'f?p=&APP_ID.:209:&SESSION.::&DEBUG.:RP,209:P209_ID:#ID#:'
,p_column_linktext=>'#COMBINED_FILE_URL#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28178634193421912.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Solo para P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(28179064484421913.4001)
,p_query_column_id=>4
,p_column_alias=>'REQUIRED_PATCH'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Opci\00F3n de Creaci\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(198057397)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(954613046208277179.4001)
,p_plug_name=>unistr('Men\00FA de Navegaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>520
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'  where flow_id = :fb_flow_id ',
'     and security_group_id = :flow_security_group_id ',
'     and navigation_type = ''L'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(965345241777755622.4001)
,p_plug_name=>'JavaScript'
,p_region_name=>'JAVASCRIPT'
,p_parent_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>530
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(974623159349045062.4001)
,p_plug_name=>'Hojas de Estilo en Cascada'
,p_region_name=>'CSS'
,p_parent_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>550
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1329538546154482129.4001)
,p_plug_name=>unistr('Barra de Navegaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>540
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P197_UI_TYPE_ID'
,p_plug_display_when_cond2=>'2'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28179438634421914.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(935666971301945228.4001)
,p_button_name=>'CREATE_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Crear Archivo Concatenado'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:209:&SESSION.::&DEBUG.:RP,209:P209_USER_INTERFACE_ID:&P197_UI_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(314915609111433272.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(42241822749375265.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(314915805876434764.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(42241822749375265.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''FB_FLOW_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42566501117233036.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42465100256920542.4001)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>11
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42459503205850081.4001)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42447608221572721.4001)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:RP,506:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42465706836922507.4001)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42563915006189711.4001)
,p_branch_name=>'Go To Page 197'
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26446402851095196.4001)
,p_name=>'P197_FILE_PREFIX'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(314888924704274854.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_prompt=>unistr('Prefijo de Archivo Est\00E1tico')
,p_source=>'FILE_PREFIX'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina la ruta virtual que utiliza el servidor web para apuntar a los archivos est\00E1ticos al utilizar la cadena de sustituci\00F3n <code>&#35;APP_IMAGES&#35;</code>.</p>'),
'',
unistr('<p>No especifique nada para hacer referencia a los archivos que se almacenan con su definici\00F3n de aplicaci\00F3n en la base de datos.</p>'),
'',
unistr('<p>Por motivos de rendimiento, tambi\00E9n puede almacenar sus archivos de aplicaci\00F3n en el servidor web o en una red de entrega de contenido (CDN). Utilice una URL v\00E1lida para hacer referencia a los mismos.</p>'),
'',
'<p>Ejemplos:',
'<ul>',
'  <li>/misArchivos/</li>',
'  <li>https://www.ejemplo.com/misArchivos/</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28129920563289586.4001)
,p_name=>'P197_UI_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28131218836289586.4001)
,p_name=>'P197_UI_TYPE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_source=>'UI_TYPE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28133906624289590.4001)
,p_name=>'P197_THEME_IDENTIFIER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28135548333290946.4001)
,p_name=>'P197_IS_DEFAULT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_source=>'USE_AUTO_DETECT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>unistr('Seleccione si la interfaz de usuario es la interfaz por defecto para la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28136490921290947.4001)
,p_name=>'P197_THEME_STYLE_BY_USER_PREF'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'Permitir a los usuarios finales seleccionar el estilo de tema'
,p_source=>'THEME_STYLE_BY_USER_PREF'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Cuando se define en <strong>Activado</strong>, los usuarios finales pueden elegir un estilo de tema para sus sesiones dentro de un cuadro de di\00E1logo de personalizaci\00F3n. Solo son aptos para su selecci\00F3n los estilos de tema marcados como "P\00FAblico".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28137307244290947.4001)
,p_name=>'P197_BUILT_WITH_LOVE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Agregar "Creado con APEX" al pie de p\00E1gina')
,p_source=>'BUILT_WITH_LOVE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Si esta opci\00F3n se define en <strong>Activado</strong>, Oracle Application Express a\00F1adir\00E1 el texto <em>Creado con amor con Oracle APEX</em> en el pie de cada p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28138249354290948.4001)
,p_name=>'P197_HOME_URL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('URL de P\00E1gina Inicial')
,p_source=>'HOME_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique la p\00E1gina inicial de la aplicaci\00F3n para la interfaz de usuario actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28139190467290948.4001)
,p_name=>'P197_LOGIN_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('URL de Conexi\00F3n')
,p_source=>'LOGIN_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique la p\00E1gina de conexi\00F3n de la aplicaci\00F3n para la interfaz de usuario actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28140059122290949.4001)
,p_name=>'P197_THEME_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select theme_name d, theme_id r from wwv_flow_themes where flow_id = :FB_FLOW_ID'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Muestra el tema asociado actualmente a la interfaz de usuario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28140927579290949.4001)
,p_name=>'P197_ACTIVE_STYLE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (',
'select "ID"',
'from "WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P197_ID',
'   and theme_id          = :P197_THEME_ID',
'   and security_group_id = :WORKSPACE_ID  ',
'   and is_current = ''Y''',
') loop',
'return c1.id;',
'end loop;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Estilo de Tema:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "NAME", "ID"',
'from "WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P197_ID',
'   and theme_id          = :P197_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Estilo de Tema -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from "WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P197_ID',
'   and theme_id          = :P197_THEME_ID',
'   and security_group_id = :WORKSPACE_ID  '))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28141391013290950.4001)
,p_name=>'P197_GLOBAL_PAGE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(72766345492681456.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('P\00E1gina Global:')
,p_source=>'GLOBAL_PAGE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Muestra la p\00E1gina global de la aplicaci\00F3n, si se ha definido alguna.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- 2012-08-03 CNEUMUEL: removed Post-Calculation Computation, since it caused errors on update',
'--                      if the page was null (the message text can not be saved in a number column)',
'nvl(:P197_GLOBAL_PAGE_ID, wwv_flow_lang.system_message(''USER_INTERFACE.NO_GLOBAL_PAGE''));'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28163713099415366.4001)
,p_name=>'P197_DISPLAY_NAV'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_prompt=>unistr('Mostrar Navegaci\00F3n')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28164168624415366.4001)
,p_name=>'P197_NAVIGATION_LIST_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('Lista de Men\00FAs de Navegaci\00F3n')
,p_source=>'NAVIGATION_LIST_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LISTS'
,p_lov=>'select wwv_flow_escape.html(name) d, id from wwv_flow_lists where flow_id = :FB_FLOW_ID order by upper(name)'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Lista de Navegaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la lista utilizada para el men\00FA de navegaci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28165085833415367.4001)
,p_name=>'P197_NAVIGATION_POSITION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('Posici\00F3n')
,p_source=>'NAVIGATION_LIST_POSITION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NAV_MENU_POSITION_ICONS'
,p_lov=>'.'||wwv_flow_api.id(1856613427542451349.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la posici\00F3n en la que desea que se coloque el men\00FA de navegaci\00F3n en esta aplicaci\00F3n.  '),
'<br/><br/>',
unistr('Si la posici\00F3n se define en <strong>Lateral</strong>, la plantilla de lista del men\00FA de navegaci\00F3n se presentar\00E1 en la posici\00F3n #SIDE_GLOBAL_NAVIGATION_LIST# de la plantilla de p\00E1gina. '),
'<br/><br/>',
unistr('Si la posici\00F3n se define en <strong>Arriba</strong>, la plantilla de lista del men\00FA de navegaci\00F3n se presentar\00E1 en la posici\00F3n #TOP_GLOBAL_NAVIGATION_LIST# de la plantilla de p\00E1gina. '),
'<br/><br/>',
unistr('Por ejemplo, si selecciona <strong>Lateral</strong>, la navegaci\00F3n se podr\00EDa presentar como un \00E1rbol en el lado izquierdo de las p\00E1ginas; si selecciona <strong>Arriba</strong>, la navegaci\00F3n se puede presentar como una barra de men\00FAs en la cabecera d')
||unistr('e las p\00E1ginas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28165905363415367.4001)
,p_name=>'P197_NAVIGATION_LIST_TEMPLATE'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'Plantilla de Lista'
,p_source=>'NAVIGATION_LIST_TEMPLATE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Seleccione la plantilla de lista utilizada para presentar el men\00FA de navegaci\00F3n para la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28166832707415368.4001)
,p_name=>'P197_NAV_LIST_TEMPLATE_OPTIONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'Opciones de Plantilla'
,p_source=>'NAV_LIST_TEMPLATE_OPTIONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       t.preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group        ',
'  from wwv_flow_template_options o,',
'       wwv_flow_list_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.list_template_id',
'   and list_template_id = :P197_NAVIGATION_LIST_TEMPLATE',
'union',
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group         ',
'  from wwv_flow_template_options o',
' where o.flow_id = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types = ''LIST''',
') order by advanced_group nulls first,  group_name nulls first, d',
''))
,p_lov_cascade_parent_items=>'P197_NAVIGATION_LIST_TEMPLATE'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina las opciones de plantilla para la plantilla de lista utilizada para la lista del men\00FA de navegaci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28167739385415369.4001)
,p_name=>'P197_TOP_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28168142425415369.4001)
,p_name=>'P197_SIDE_TEMPLATE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(954613046208277179.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28168866070417121.4001)
,p_name=>'P197_NAV_BAR_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1329538546154482129.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_item_default=>'NAVBAR'
,p_prompt=>unistr('Implantaci\00F3n')
,p_source=>'NAV_BAR_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAV_BAR_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1383750926477562234.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea implantar la barra de navegaci\00F3n en esta aplicaci\00F3n.  '),
'<br/><br/>',
unistr('Si se define en <strong>Cl\00E1sica</strong>, la barra de navegaci\00F3n se presentar\00E1 como una barra de navegaci\00F3n cl\00E1sica en la posici\00F3n #NAVIGATION_BAR# de la plantilla de p\00E1gina. '),
'<br/><br/>',
unistr('Si se define en <strong>Lista</strong>, la barra de navegaci\00F3n se presentar\00E1 como una lista, con la lista seleccionada y la plantilla de lista en la posici\00F3n #NAVIGATION_BAR# de la plantilla de p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28169758250417121.4001)
,p_name=>'P197_NAV_BAR_LIST_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1329538546154482129.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('Lista de Barra de Navegaci\00F3n')
,p_source=>'NAV_BAR_LIST_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LISTS'
,p_lov=>'select wwv_flow_escape.html(name) d, id from wwv_flow_lists where flow_id = :FB_FLOW_ID order by upper(name)'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Lista de Navegaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la lista utilizada para la barra de navegaci\00F3n de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28170642165417122.4001)
,p_name=>'P197_NAV_BAR_LIST_TEMPLATE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1329538546154482129.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    r number null;',
'begin',
'    for c1 in (select default_nav_bar_list_template ',
'                 from wwv_flow_themes ',
'                where flow_id = :fb_flow_id',
'                  and theme_id = :fb_theme_id',
'                  and security_group_id = :flow_security_group_id)',
'    loop',
'        r := c1.default_nav_bar_list_template;',
'    end loop;',
'    return r;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Lista'
,p_source=>'NAV_BAR_LIST_TEMPLATE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Seleccione la plantilla de lista utilizada para presentar la barra de navegaci\00F3n de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28171558111417124.4001)
,p_name=>'P197_NAV_BAR_TEMPLATE_OPTIONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1329538546154482129.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'Opciones de Plantilla'
,p_source=>'NAV_BAR_TEMPLATE_OPTIONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       t.preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group        ',
'  from wwv_flow_template_options o,',
'       wwv_flow_list_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.list_template_id',
'   and list_template_id = :P197_NAV_BAR_LIST_TEMPLATE_ID',
'union',
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group         ',
'  from wwv_flow_template_options o',
' where o.flow_id = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types = ''LIST''',
') order by advanced_group nulls first,  group_name nulls first, d'))
,p_lov_cascade_parent_items=>'P197_NAV_BAR_LIST_TEMPLATE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina las opciones de plantilla para la plantilla de lista utilizada para la barra de navegaci\00F3n de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28172736415419385.4001)
,p_name=>'P197_CONTENT_DELIVERY_NETWORK'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(965345241777755622.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'Red de Entrega de Contenido'
,p_source=>'CONTENT_DELIVERY_NETWORK'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONTENT DELIVERY NETWORK'
,p_lov=>'.'||wwv_flow_api.id(16362507680404890.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguno (Usar Servidor Web)'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la red de entrega de contenido (CDN) que &PRODUCT_NAME. intentar\00E1 utilizar para cargar las bibliotecas de jQuery. Si &PRODUCT_NAME. no puede cargar estas bibliotecas de la CDN, se cargar\00E1n desde su servidor web en su lugar.</p>'),
unistr('<p>El uso de una CDN puede reducir el tiempo de carga de la aplicaci\00F3n si el usuario ya ha visitado otros sitios web que tambi\00E9n utilizan la misma CDN para cargar las mismas bibliotecas.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28173662495419386.4001)
,p_name=>'P197_JAVASCRIPT_FILE_URLS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(965345241777755622.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'URL de Archivo'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivos JavaScript para el c\00F3digo que se va a cargar en cada p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code>')
||unistr(' para incluir <code>.min</code>, o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n.</p>'),
'',
unistr('<p>Las URL de archivos JavaScript que ha introducido aqu\00ED reemplazan la cadena de sustituci\00F3n <code>#APPLICATION_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre. Solo escriba la URL.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de /myjs/minified/ para vistas de p\00E1gina normales y main.js de /myjs/ en modo de depuraci\00F3n:'),
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca tambi\00E9n se utiliza desde una llamada obligatoria RequireJS. El nombre de definici\00F3n debe coincidir con lo que se utiliza en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global exp')
||'uesto por la biblioteca. Solo se aplica cuando se utiliza RequireJS. Esto evita que RequireJS cargue esa biblioteca por segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28174547620419386.4001)
,p_name=>'P197_INCLUDE_LEGACY_JAVASCRIPT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(965345241777755622.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('Incluir funciones de Javascript en desuso o que ya no est\00E1n soportadas')
,p_source=>'INCLUDE_LEGACY_JAVASCRIPT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_LEGACY_JAVASCRIPT'
,p_lov=>'.'||wwv_flow_api.id(723325277005791161.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica si las funciones JavaScript en desuso o que ya no se soportan se incluyen en todas las p\00E1ginas de la aplicaci\00F3n. Las funciones que ya no se soportan o en desuso se muestran en las notas t\00E9cnicas sobre la versi\00F3n de cada versi\00F3n. Si est\00E1 se')
||unistr('guro de que su aplicaci\00F3n no contiene ninguna referencia a esas funciones, no marque ninguna casilla de control para reducir el tama\00F1o total de los archivos JavaScript cargados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28175452091419387.4001)
,p_name=>'P197_INCLUDE_JQUERY_MIGRATE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(965345241777755622.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>unistr('Incluir Migraci\00F3n de jQuery')
,p_source=>'INCLUDE_JQUERY_MIGRATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica si el plugin de <strong>migraci\00F3n de jQuery</strong> se debe incluir en cada p\00E1gina de la aplicaci\00F3n.</p>'),
'',
unistr('<p>El plugin restaura las funciones y los comportamientos en desuso de jQuery de forma que el c\00F3digo JavaScript y los plugins de jQuery antiguos se seguir\00E1n ejecutando correctamente con la versi\00F3n de jQuery cargada por &PRODUCT_NAME.</p>'),
'',
unistr('<p>Si est\00E1 seguro de que la aplicaci\00F3n y cualquier plugin de jQuery utilizado no contiene ninguna referencia a las funciones de jQuery en desuso, def\00EDnalo en <strong>Desactivado</strong> para reducir el tama\00F1o general de los archivos JavaScript carga')
||'dos.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28176661045420819.4001)
,p_name=>'P197_CSS_FILE_URLS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(974623159349045062.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar en cada p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#<')
||unistr('/code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a l')
||unistr('a cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
unistr('<p>Las URL de archivo que introduzca aqu\00ED reemplazar\00E1n la cadena de sustituci\00F3n <code>#APPLICATION_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/mycss/main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), se indica al explorador que siempre ca')
||unistr('rgue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28216151114136409.4001)
,p_name=>'P197_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253749558706349701.4001)
,p_name=>'P197_LOGO_CUSTOM'
,p_item_sequence=>740
,p_item_plug_id=>wwv_flow_api.id(314912623768407097.4001)
,p_prompt=>'HTML personalizado'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El \00E1rea de texto del logotipo personalizado se puede utilizar para obtener el control total de la marca del logotipo de su aplicaci\00F3n. El valor de este campo se insertar\00E1 en la cadena de sustituci\00F3n <code>#LOGO#</code> de la plantilla de la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314889621071274857.4001)
,p_name=>'F4000_P197_FLOW_IMAGE_PREFIX'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(314888924704274854.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_prompt=>'Prefijo de Imagen'
,p_source=>'FLOW_IMAGE_PREFIX'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina la ruta virtual que utiliza el servidor web para apuntar al directorio de im\00E1genes distribuido con &PRODUCT_NAME.. Durante la instalaci\00F3n, la ruta de acceso virtual se configura normalmente como <code>/i/</code>. Si no est\00E1 seguro, p\00F3nga')
||'se en contacto con el administrador.<p/>',
'',
unistr('<p>Al embeber una imagen en un texto est\00E1tico (por ejemplo, en cabeceras o pies de regi\00F3n o p\00E1gina), puede hacer referencia a la imagen con la cadena de sustituci\00F3n <code>&#35;IMAGE_PREFIX&#35;</code>. Por ejemplo, para hacer referencia a la imagen g')
||'o.gif, debe utilizar la sintaxis siguiente:',
'<pre>',
'&lt;img src="&#35;IMAGE_PREFIX&#35;go.gif"&gt;',
'</pre>',
'</p>',
'',
unistr('<p>Nota: Si el prefijo de imagen introducido es igual al prefijo de imagen de instancia, el atributo de nivel de aplicaci\00F3n siempre ser\00E1 nulo. De esta manera, se facilita el movimiento de una aplicaci\00F3n a trav\00E9s de diferentes instancias que pueden te')
||'ner diferentes prefijos de imagen.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314891625715274859.4001)
,p_name=>'F4000_P197_MEDIA_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(314888924704274854.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_prompt=>unistr('Tipo de Medio F\00EDsico')
,p_source=>'MEDIA_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el tipo de medio de Internet. Un tipo de medio de Internet es un identificador de dos partes para los formatos de archivo de Internet. Un tipo de medio est\00E1 compuesto al menos por dos partes: un tipo y un subtipo, y puede contener uno o')
||unistr(' m\00E1s par\00E1metros opcionales. Este tipo de medio se utiliza en la cabecera HTTP de tipo de contenido al presentar la p\00E1gina.</p>'),
'',
unistr('<p>Si los valores a nivel de p\00E1gina y de aplicaci\00F3n del tipo de medio son <code>NULL</code>, se utiliza <code>text/html</code>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314912815596407098.4001)
,p_name=>'P197_LOGO_TYPE'
,p_item_sequence=>710
,p_item_plug_id=>wwv_flow_api.id(314912623768407097.4001)
,p_prompt=>'Logotipo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'APPLICATION LOGO IMAGE OR TEXT'
,p_lov=>'.'||wwv_flow_api.id(210991102136588089.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguno'
,p_lov_null_value=>'NO'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Utilice este elemento para definir el logotipo de su aplicaci\00F3n. El logotipo de una aplicaci\00F3n puede ser una imagen, un texto o una combinaci\00F3n de imagen y texto, o bien estar basado en una marca personalizada. Si desea utilizar esta funci\00F3n, la plan')
||unistr('tilla de la p\00E1gina debe incluir la cadena de sustituci\00F3n #LOGO#.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314913319176407098.4001)
,p_name=>'P197_LOGO'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>720
,p_item_plug_id=>wwv_flow_api.id(314912623768407097.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_prompt=>'URL de imagen'
,p_source=>'LOGO'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la direcci\00F3n URL de la imagen que se va a utilizar como logotipo junto con la extensi\00F3n del nombre de archivo, como en el siguiente ejemplo:'),
'',
'<pre><strong>#</strong><strong>APP_IMAGES</strong><strong>#</strong>my-logo.png</pre>',
'',
unistr('Tenga en cuenta que, para utilizar esta funci\00F3n, la plantilla de la p\00E1gina debe contener la cadena de sustituci\00F3n <code>#LOGO#</code>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314913802590407103.4001)
,p_name=>'P197_LOGO_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>730
,p_item_plug_id=>wwv_flow_api.id(314912623768407097.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_prompt=>'Texto'
,p_source=>'LOGO_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto que desea que se muestre en el logotipo de la aplicaci\00F3n.'),
'',
unistr('Tenga en cuenta que, para utilizar esta funci\00F3n, la plantilla de la p\00E1gina debe contener la cadena de sustituci\00F3n <code>#LOGO#</code>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(879699985997493821.4001)
,p_name=>'P197_FAVICONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(879699542547493817.4001)
,p_item_source_plug_id=>wwv_flow_api.id(28154408216362812.4001)
,p_prompt=>'HTML de Favicon'
,p_source=>'FAVICONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione el c\00F3digo HTML del icono de favoritos. Para utilizar esta funci\00F3n, la plantilla de p\00E1gina debe incluir la cadena de sustituci\00F3n <code>#FAVICONS#</code>. Ejemplo:</p>'),
'<pre>',
'&lt;link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico"&gt;',
'&lt;link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#favicon-16x16.png"&gt;',
'&lt;link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#favicon-32x32.png"&gt;',
'&lt;link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#favicon-180x180.png"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29175276403846594.4001)
,p_computation_sequence=>30
,p_computation_item=>'P197_DISPLAY_NAV'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P197_NAVIGATION_LIST_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(254002063678826501.4001)
,p_validation_name=>'Logo Image Required'
,p_validation_sequence=>10
,p_validation=>'P197_LOGO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La imagen URL no se puede dejar en blanco.'
,p_validation_condition=>'P197_LOGO_TYPE'
,p_validation_condition2=>'I:IT'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(254002182301826502.4001)
,p_validation_name=>'Logo Text Required'
,p_validation_sequence=>20
,p_validation=>'P197_LOGO_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El texto del logotipo no se puede dejar en blanco.'
,p_validation_condition=>'P197_LOGO_TYPE'
,p_validation_condition2=>'T:IT'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(254002275739826503.4001)
,p_validation_name=>'Logo Custom HTML Required'
,p_validation_sequence=>30
,p_validation=>'P197_LOGO_CUSTOM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El HTML personalizado del logotipo no se puede dejar en blanco.'
,p_validation_condition=>'P197_LOGO_TYPE'
,p_validation_condition2=>'C'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(28307521873928299.4001)
,p_validation_name=>'Navigation List Template not null'
,p_validation_sequence=>40
,p_validation=>'P197_NAVIGATION_LIST_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>'P197_NAVIGATION_LIST_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(314915805876434764.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(28307864308929545.4001)
,p_validation_name=>'Must Select Navigation Bar List'
,p_validation_sequence=>50
,p_validation=>'P197_NAV_BAR_LIST_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe seleccionar una lista de barras de navegaci\00F3n.')
,p_validation_condition=>'P197_NAV_BAR_TYPE'
,p_validation_condition2=>'LIST'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(314915805876434764.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(253749681717349702.4001)
,p_name=>'Toggle Logo Type Items'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_LOGO_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(253749712202349703.4001)
,p_event_id=>wwv_flow_api.id(253749681717349702.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var logoType    = $v(this.triggeringElement),',
'    itemImage   = apex.item(''P197_LOGO''),',
'    itemText    = apex.item(''P197_LOGO_TEXT''),',
'    itemCustom  = apex.item(''P197_LOGO_CUSTOM'');',
'',
'    // Hide All Items',
'    itemImage.hide();',
'    itemText.hide();',
'    itemCustom.hide();',
'',
'if ( logoType === ''I'' ) {',
'    // Image Logo',
'    itemImage.show();',
'} else if ( logoType === ''IT'' ) {',
'    // Image and Text Logo',
'    itemImage.show();',
'    itemText.show();',
'} else if ( logoType === ''T'' ) {',
'    // Text Only Logo',
'    itemText.show();',
'} else if ( logoType === ''C'' ) {',
'    // Custom Logo',
'    itemCustom.show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28416496256556820.4001)
,p_name=>'Manage Navigation Bar Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_NAV_BAR_TYPE'
,p_condition_element=>'P197_NAV_BAR_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LIST'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28416895792556837.4001)
,p_event_id=>wwv_flow_api.id(28416496256556820.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAV_BAR_LIST_ID,P197_NAV_BAR_LIST_TEMPLATE_ID,P197_NAV_BAR_TEMPLATE_OPTIONS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28417396688556846.4001)
,p_event_id=>wwv_flow_api.id(28416496256556820.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAV_BAR_LIST_ID,P197_NAV_BAR_LIST_TEMPLATE_ID,P197_NAV_BAR_TEMPLATE_OPTIONS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28417713490559450.4001)
,p_name=>'Handle No Navigation'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_DISPLAY_NAV'
,p_condition_element=>'P197_DISPLAY_NAV'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28418160188559451.4001)
,p_event_id=>wwv_flow_api.id(28417713490559450.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_LIST_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28418682069559451.4001)
,p_event_id=>wwv_flow_api.id(28417713490559450.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_LIST_ID,P197_NAVIGATION_LIST_TEMPLATE,P197_NAV_LIST_TEMPLATE_OPTIONS,P197_NAVIGATION_POSITION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28419106475559451.4001)
,p_event_id=>wwv_flow_api.id(28417713490559450.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_LIST_ID,P197_NAVIGATION_LIST_TEMPLATE,P197_NAV_LIST_TEMPLATE_OPTIONS,P197_NAVIGATION_POSITION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28419630855559452.4001)
,p_event_id=>wwv_flow_api.id(28417713490559450.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_POSITION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TOP'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28420099206561302.4001)
,p_name=>'Set List Template based on Position'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_NAVIGATION_POSITION'
,p_condition_element=>'P197_THEME_IDENTIFIER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'UNIVERSAL_THEME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28420474456561311.4001)
,p_event_id=>wwv_flow_api.id(28420099206561302.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var template$ = $("#P197_NAVIGATION_LIST_TEMPLATE");',
'if ($v(this.triggeringElement) == ''TOP'') {',
'    $s("P197_NAVIGATION_LIST_TEMPLATE",$v("P197_TOP_TEMPLATE_ID"));',
'} else if ($v(this.triggeringElement) == ''SIDE'') {',
'    $s("P197_NAVIGATION_LIST_TEMPLATE",$v("P197_SIDE_TEMPLATE_ID"));',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28420850710563478.4001)
,p_name=>'Refresh after Dialog Closed'
,p_event_sequence=>50
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(935666971301945228.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28421217861563480.4001)
,p_event_id=>wwv_flow_api.id(28420850710563478.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(935666971301945228.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(314894006050297923.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(314915805876434764.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28217703706136425.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(28154408216362812.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process WWV_FLOWS'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(314915805876434764.4001)
,p_process_success_message=>' '
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28154390006362811.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process WWV_FLOW_USER_INTERFACES'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(314915805876434764.4001)
,p_process_success_message=>'Interfaz de usuario actualizada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253749806750349704.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Logo'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_logo_type varchar2(2);',
'    l_logo      varchar2(4000);',
'    l_logo_text varchar2(4000);',
'begin',
'    -- Cache logo type',
'    l_logo_type := :P197_LOGO_TYPE;',
'    ',
'    -- Handle No Logo',
'    if l_logo_type = ''NO'' then ',
'        l_logo_type := null;',
'        l_logo      := null;',
'        l_logo_text := null;',
'    end if;',
'',
'    -- Set logo source based on type',
'    if l_logo_type = ''C'' then',
'        l_logo := :P197_LOGO_CUSTOM;',
'    elsif l_logo_type in (''I'',''IT'') then ',
'        l_logo := :P197_LOGO;',
'    end if;',
'    ',
'    -- Set logo text for text or image and text type',
'    if l_logo_type in (''T'',''IT'') then',
'        l_logo_text := :P197_LOGO_TEXT;',
'    end if;',
'',
'    -- Update logo',
'    update wwv_flows',
'    set ',
'        logo_type = l_logo_type,',
'        logo = l_logo,',
'        logo_text = l_logo_text',
'    where ',
'        id = :FB_FLOW_ID and',
'        security_group_id = :WORKSPACE_ID;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(314915805876434764.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28308015494933849.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update theme style'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update "WWV_FLOW_THEME_STYLES" ',
'set is_current = ''Y''',
' where security_group_id = :WORKSPACE_ID  ',
'   and flow_id = :P197_ID',
'   and id = :P197_ACTIVE_STYLE',
'   and theme_id = :P197_THEME_ID;',
'   ',
'update "WWV_FLOW_THEME_STYLES" ',
'set is_current = ''N''',
' where security_group_id = :WORKSPACE_ID  ',
'   and flow_id = :P197_ID',
'   and (id <> :P197_ACTIVE_STYLE or :P197_ACTIVE_STYLE is null)',
'   and theme_id = :P197_THEME_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(314915805876434764.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28308332558940494.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset default user interfaces'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  update wwv_flow_user_interfaces',
'  set is_default = ''N''',
'  where flow_id = :FB_FLOW_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and id <> :P197_UI_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(314915805876434764.4001)
,p_process_when=>'P197_IS_DEFAULT'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(314893626697294425.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28193838155607550.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Theme Identifier and Navigation Template Ids'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P197_ID := :FB_FLOW_ID;',
':P197_ACTIVE_STYLE := null;',
'',
'for ui in (',
'    select *',
'      from WWV_FLOW_USER_INTERFACES',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'       and ui_type_id = 1',
'       and is_default = ''Y''',
'       and rownum = 1',
')',
'loop',
'    :P197_UI_ID := ui.id; ',
'end loop;',
'',
'for c1 in (',
'    select ui.theme_id,',
'           tm.id,',
'           tm.theme_internal_name',
'      from wwv_flow_user_interfaces ui, wwv_flow_themes tm',
'     where ui.id = :P197_UI_ID and',
'           tm.theme_id = ui.theme_id and',
'           tm.flow_id = :FB_FLOW_ID',
')',
'loop',
'  :FB_THEME_ID := c1.theme_id;',
'  :P197_THEME_IDENTIFIER := c1.theme_internal_name;',
'  ',
'  if :P197_THEME_IDENTIFIER = ''UNIVERSAL_THEME'' then',
'      for c2 in (',
'          select ',
'          (select id from wwv_flow_list_templates where theme_id = :FB_THEME_ID and flow_id = :FB_FLOW_ID and internal_name = ''TOP_NAVIGATION_MENU'') top_id,',
'          (select id from wwv_flow_list_templates where theme_id = :FB_THEME_ID and flow_id = :FB_FLOW_ID and internal_name = ''SIDE_NAVIGATION_MENU'') side_id',
'          from dual',
'      ) loop',
'        :P197_TOP_TEMPLATE_ID := c2.top_id;',
'        :P197_SIDE_TEMPLATE_ID := c2.side_id;',
'      end loop;',
'  end if;',
'  ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28154588402362813.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(28154408216362812.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize WWV_FLOWS Form'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1244612368441539142.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(1244612221141539141.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize WWV_FLOW_USER_INTERFACES Form'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253750031521349706.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Logo Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select ',
'        logo,',
'        logo_type,',
'        logo_text',
'    from ',
'        wwv_flows',
'    where',
'        id = :FB_FLOW_ID and',
'        security_group_id = :WORKSPACE_ID',
') loop',
'    :P197_LOGO_TYPE := nvl(c1.logo_type,''NO'');',
'    ',
'    -- Reset all items to null',
'    :P197_LOGO_TEXT := null;',
'    :P197_LOGO_CUSTOM := null;',
'    :P197_LOGO := null;',
'',
'    -- Set page items based on logo type',
'    if c1.logo_type = ''C'' then',
'        :P197_LOGO_CUSTOM := c1.logo;',
'    end if;',
'    ',
'    if c1.logo_type in (''I'',''IT'') then ',
'        :P197_LOGO := c1.logo;',
'    end if;',
'    ',
'    if c1.logo_type in (''T'',''IT'') then ',
'        :P197_LOGO_TEXT := c1.logo_text;',
'    end if;',
'    ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00199
begin
wwv_flow_api.create_page(
 p_id=>199.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia de Servicio Web: Manual'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(741449156151373031.4001)
,p_plug_name=>'Servicio Web'
,p_region_name=>'R1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El protocolo simple de acceso a objetos (SOAP) es un protocolo est\00E1ndar World Wide Web Consortium (W3C) para definir'),
'   el formato de las solicitudes de servicio web.</p>',
'<p>Existe un intercambio de mensajes de SOAP entre el proveedor y el usuario del servicio en elementos envelope de SOAP. Los elementos',
unistr('   envelope de SOAP contienen una solicitud para algunas acciones y el resultado de \00E9stas, y tienen un formato XML, que las hacen f\00E1ciles de decodificar.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 31-JUL-2002 20:44:47'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(741450571308373035.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(741451197014373036.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(741450571308373035.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P199_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(741466512945434197.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(741450571308373035.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(741450915625373035.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(741450571308373035.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(741458121571373069.4001)
,p_branch_name=>'Go To Page 170'
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(741458571111373072.4001)
,p_branch_action=>'870'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(741466512945434197.4001)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741448406937373016.4001)
,p_name=>'P199_RESPONSE_COLLECTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Almacenar Respuesta en Recopilaci\00F3n')
,p_source=>'STATIC_PARM_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de una recopilaci\00F3n para almacenar la respuesta del servicio Web. La respuesta se almacenar\00E1 en la columna CLOB001 de la recopilaci\00F3n introducida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741449332749373034.4001)
,p_name=>'F4000_P199_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741449525566373034.4001)
,p_name=>'F4000_P199_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741450007131373034.4001)
,p_name=>'F4000_P199_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Nombre de este servicio web dentro del contexto del creador. Este nombre solo se utiliza dentro de la herramienta Creador de aplicaciones.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741451700842373037.4001)
,p_name=>'F4000_P199_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la URL utilizada para enviar la solicitud de SOAP por HTTP. Corresponde a la ubicaci\00F3n soap:address de un puerto'),
unistr('   de servicio en WSDL. Puede hacer referencia al estado de sesi\00F3n en la URL con la convenci\00F3n <code>&amp;ITEM_NAME.</code>.</p>'),
'<p>Por ejemplo:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741452228277373038.4001)
,p_name=>'F4000_P199_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Acci\00F3n')
,p_source=>'ACTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Indica el intento de la solicitud de HTTP de SOAP. El valor es una URI que identifica el intento.</p> <p>SOAP no incluye restricciones en el formato, en la precisi\00F3n de la URI o que sea resolutiva.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741452799822373039.4001)
,p_name=>'F4000_P199_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy'
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esto sustituye al proxy HTTP definido por el sistema para la solicitud. El proxy puede incluir un n\00FAmero de puerto TCP/IP opcional en el que recibe el servidor proxy. Utilice la siguiente sintaxis:</p>'),
'<pre>[http://]host[:port][/]</pre>',
'<p>Por ejemplo:</p>',
'<pre>www-proxy.ejemplo.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741453221339373039.4001)
,p_name=>'P199_SOAP_VERSION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1.1'
,p_prompt=>unistr('Versi\00F3n SOAP:')
,p_source=>'SOAP_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_SOAP_VERSION'
,p_lov=>'.'||wwv_flow_api.id(439439004288980949.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Elija la versi\00F3n de la especificaci\00F3n SOAP que utiliza este servicio web, 1.1 o 1.2.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741453709212373039.4001)
,p_name=>'P199_BASIC_AUTH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n B\00E1sica:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_read_only_when=>'F4000_P199_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si este servicio Web necesita autenticaci\00F3n b\00E1sica. Las credenciales de autenticaci\00F3n b\00E1sica se env\00EDan como parte de la solicitud HTTP sin cifrar. Los servicios Web que utilizan autenticaci\00F3n b\00E1sica, normalmente tambi\00E9n utilizan el protoco')
||unistr('lo HTTPS (SSL) ya que el nombre de usuario y la contrase\00F1a se env\00EDan sin cifrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741454415858373040.4001)
,p_name=>'F4000_P199_SOAP_ENVELOPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(741449156151373031.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Elemento Envelope de SOAP'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique el elemento Envelope de SOAP que se va a utilizar para la solicitud de SOAP al servicio Web. Este elemento Envelope puede contener sustituciones de elementos de la pantalla #ITEM_NAME#.</p>',
'<p>Por ejemplo:</p>',
'<pre>&lt;SOAP-ENV:Envelope',
'xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"',
'',
'  xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"',
'',
'  xmlns:xsd="http://www.w3.org/1999/XMLSchema"',
'',
'  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">',
'',
'  &lt;SOAP-ENV:Body>&lt;LocalTimeByZipCode xmlns="http://www.alethea.net/webservices/">&lt;ZipCode xsi:type="xsd:string">#Fxxxx_Pyyy_ZIP_CODE#&lt;/ZipCode>&lt;/LocalTimeByZipCode></SOAP-ENV:Body>&lt;/SOAP-ENV:Envelope>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(741455914202373045.4001)
,p_computation_sequence=>10
,p_computation_item=>'P199_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_ws_operations',
'            where name = ''BASIC_AUTH''',
'              and ws_id = :F4000_P199_ID ) loop',
'  return ''Y'';',
'  exit;',
'end loop;',
'',
'return ''N'';'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(741456190836373050.4001)
,p_validation_name=>'F4000_P199_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P199_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(741450007131373034.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:28'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(741456335131373054.4001)
,p_validation_name=>'URL Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P199_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la direcci\00F3n URL del servicio Web.')
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(741451700842373037.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(741456527646373055.4001)
,p_validation_name=>'SOAP Envelope not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P199_SOAP_ENVELOPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el elemento Envelope de SOAP asociado al servicio Web.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(741454415858373040.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(741457687291373057.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(741450915625373035.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(741457946227373066.4001)
,p_event_id=>wwv_flow_api.id(741457687291373057.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741456664292373055.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P199_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741456884280373055.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P199_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'F4000_P199_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>unistr('Error al actualizar la definici\00F3n de servicio Web.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Definici\00F3n de servicio Web actualizada.')
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741457017889373055.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Preparse item substitutions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_items clob;',
'begin',
'    l_items := wwv_flow_web_services.parse( :F4000_P199_SOAP_ENVELOPE );',
'',
'    update wwv_flow_shared_web_services ',
'       set flow_items_comma_delimited = l_items',
'     where id = :F4000_P199_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741457291525373056.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create basic auth operation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_operations_id number;',
'  l_id number;',
'begin',
'',
'  l_operations_id := wwv_flow_id.next_val;',
'',
'  insert into wwv_flow_ws_operations (id, ws_id, name)     ',
'  values (l_operations_id, :F4000_P199_ID, ''BASIC_AUTH'');',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''username'', ''A'');         ',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''password'', ''A'');',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(741451197014373036.4001)
,p_process_when=>':P199_BASIC_AUTH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741457447562373056.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00200
begin
wwv_flow_api.create_page(
 p_id=>200.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso de Separadores'
,p_step_title=>'Uso de Separadores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4178830473922312.4001)
,p_plug_name=>'Uso de Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Este informe muestra los separadores est\00E1ndar utilizados en la aplicaci\00F3n actual.</p>')
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4180128748923137.4001)
,p_name=>'Standard Tab Utilization'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'  l_not_referenced  varchar2(200);',
'begin',
'',
'select wwv_flow_lang.system_message(''F4000.NOT_REFERENCED'')',
'  into l_not_referenced',
'  from dual;',
'',
'  q:= ''select /* APEX 4000P200a */ s.tab_set, '';',
'  q:=q||''decode((select count(*) from wwv_flow_steps pg  '';',
'  q:=q||''where pg.tab_set = s.tab_set '';',
'  q:=q||''and pg.flow_id = :fb_flow_id and pg.security_group_id = :flow_security_group_id),0,''''''||l_not_referenced||'''''', '';',
'  q:=q||''(select count(*) from wwv_flow_steps pg  '';',
'  q:=q||''where pg.tab_set = s.tab_set '';',
'  q:=q||''and pg.flow_id = :fb_flow_id '';',
'  q:=q||''and pg.security_group_id = :flow_security_group_id)) u, '';       ',
'  q:=q||''htf.anchor(''''f?p=4000:4305:''''||:flow_session||''''::::F4000_P4305_ID:''''||s.id,wwv_flow_escape.html(s.tab_name)) name, '';',
'  q:=q||''wwv_flow_escape.html(s.tab_text), '';',
'  q:=q||''htf.anchor(''''f?p=4000:4500:''''||:flow_session||''''::NO::FB_FLOW_PAGE_ID:''''||s.tab_step,s.tab_step) step, '';',
'  q:=q||''tab_parent_tabset '';',
'  q:=q||''from wwv_flow_tabs s '';',
'  q:=q||''where s.flow_id = :fb_flow_id '';',
'  q:=q||''and s.security_group_id = :flow_security_group_id ''; ',
'  q:=q||''order by 1,2,3 '';',
'',
'  return q;',
'end;'))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>8
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>unistr('No se ha utilizado ning\00FAn separador en la aplicaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870004879772673.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870122525772673.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Referencias de P\00E1gina')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870201528772673.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre de Separador'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870319980772673.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Texto de Separador'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870405543772673.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>unistr('P\00E1gina de Separador')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870518648772673.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Juego de Separadores Principales'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870604441772673.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48870710851772673.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4181922709925926.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4184507280930534.4001)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00201
begin
wwv_flow_api.create_page(
 p_id=>201.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de P\00E1ginas')
,p_alias=>'PHIST'
,p_step_title=>unistr('Historial de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7124527812558841.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169482631222656580.4001)
,p_plug_name=>unistr('Historial de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>150
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   decode(t.page_id,',
'      null,s.a,',
'     p.a) component_type,',
'   t.flow_user,',
'   t.flow_id,',
'   t.page_id p, ',
'   t.audit_date d, ',
'   t.audit_date last_updated,',
'  initcap(',
'  replace(replace(replace(replace(replace(replace(replace(replace(',
'  replace(replace(t.flow_table,',
'     ''LIST_ITEMS'',''List Entry''),',
'     ''WWV_FLOWS'',''Application''),',
'     ''WWV_FLOW_'',null),''_'','' ''),',
'     ''FLOW'',''Application''),',
'     ''STEP'',''Page''),',
'     ''PLUG'',''Region''),',
'     ''OPTION'',''Entry''),',
'     ''MENU'',''Breadcrumb''),',
'     ''$'',null)',
'  ) flow_table, ',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) c,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name  ',
'from   wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''PAGE'') a from dual) p,',
'  (select wwv_flow_lang.system_message(''SHARED'') a from dual) s',
'where  t.security_group_id = :flow_security_group_id and',
'       t.flow_id = :fb_flow_id and ',
'(',
'       t.page_id = :fb_flow_page_id or ',
'       (:P201_INCLUDE_SC = ''Y'' and',
'        flow_table_pk in',
'(',
'',
'select distinct t.id',
'from wwv_flow_page_plugs p,',
'     WWV_FLOW_PAGE_PLUG_TEMPLATES t',
'where p.flow_id = :fb_flow_id and ',
'      p.page_id = :fb_flow_page_id and',
'      p.plug_template = t.id (+) and',
'      t.PAGE_PLUG_TEMPLATE_NAME is not null',
'union all',
'select distinct p.id',
'from wwv_flow_templates p',
'where p.flow_id = :fb_flow_id and ',
'      id = ( select wwv_flow_page_dev.get_template_id(:FB_FLOW_ID, :FB_FLOW_PAGE_ID) from dual )',
'union all',
'select distinct f.id',
'from wwv_flow_field_templates f,',
'     wwv_flow_step_items i',
'where ',
'      i.flow_id = :fb_flow_id and',
'     i.ITEM_FIELD_TEMPLATE = f.id(+) and',
'     i.flow_step_id = :fb_flow_page_id and',
'     template_name is not null',
'union all',
'select t.id',
'from WWV_FLOW_POPUP_LOV_TEMPLATE t',
'where flow_id = :FB_FLOW_ID ',
'and theme_id = (select theme_id from wwv_flows where id = :FB_FLOW_ID)',
'and exists (select 1',
'              from wwv_flow_step_items i',
'              where ',
'                    i.flow_id = :FB_FLOW_ID and',
'                    i.flow_step_id = :FB_FLOW_PAGE_ID and',
'                    display_as = ''NATIVE_POPUP_LOV'')',
'union all',
'select t.id    ',
'from wwv_flow_button_templates t,',
'     wwv_flow_step_buttons b',
'where b.flow_id = :FB_FLOW_ID',
'and b.flow_step_id = :FB_FLOW_PAGE_ID',
'and t.id = b.button_template_id',
'and t.security_group_id = b.security_group_id',
'union all',
'select t.id    ',
'from  wwv_flow_cal_templates t, ',
'      wwv_flow_cals c, ',
'      wwv_flow_page_plugs r',
'where t.flow_id = :FB_FLOW_ID and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.plug_id = r.id and ',
'      r.page_id = :FB_FLOW_PAGE_ID and',
'      r.flow_Id = :FB_FLOW_ID and',
'      t.id      = c.template_id',
'union all',
'select t.id    ',
'from wwv_flow_menu_templates t, wwv_flow_page_plugs r',
'where t.flow_id = :FB_FLOW_ID and',
'      r.flow_id = :FB_FLOW_ID and',
'      r.page_id = :FB_FLOW_PAGE_ID and',
'      r.menu_template_id = t.id',
'union all',
'select ro.id',
'from wwv_flow_row_templates ro,',
'     wwv_flow_page_plugs r',
'where ro.flow_id = :FB_FLOW_ID and',
'      r.flow_id = :FB_FLOW_ID and',
'      r.page_id = :FB_FLOW_PAGE_ID and',
'      r.PLUG_QUERY_ROW_TEMPLATE = ro.id and',
'      r.plug_source_type in (''NATIVE_SQL_REPORT'', ''NATIVE_TABFORM'')',
'union all ',
'select t.id',
'from WWV_FLOW_LIST_TEMPLATES t, ',
'     wwv_flow_page_plugs r',
'where t.flow_id = :FB_FLOW_ID and',
'      r.flow_id = :FB_FLOW_ID and',
'      r.list_template_id = t.id and',
'      r.page_id = :FB_FLOW_PAGE_ID ',
'union all',
'select l.id',
'  from wwv_flow_lists l,',
'       wwv_flow_page_plugs p',
' where p.list_id = l.id',
'   and p.flow_id = :FB_FLOW_ID ',
'   and p.page_id = :FB_FLOW_PAGE_ID',
'union all',
'select o.id',
'from   WWV_FLOW_MENU_OPTIONS o, wwv_flow_menus m',
'where  m.flow_id = :FB_FLOW_ID and ',
'       o.page_id = :FB_FLOW_PAGE_ID and',
'       m.id = o.menu_id',
'union all',
'select id l',
'from   WWV_FLOW_LISTS_OF_VALUES$ l',
'where  flow_id = :FB_FLOW_ID and',
'       lov_name in ( select distinct named_lov',
'          from wwv_flow_step_items i',
'         where flow_id = :FB_FLOW_ID and ',
'               flow_step_id = :FB_FLOW_PAGE_ID and',
'               named_lov is not null ) ',
')',
')',
')',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(169482721810656581.4001)
,p_name=>'Recent Changes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169482930972656589.4001)
,p_db_column_name=>'FLOW_USER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169483015925656590.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169483131870656591.4001)
,p_db_column_name=>'P'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169483213300656591.4001)
,p_db_column_name=>'D'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169483507157656592.4001)
,p_db_column_name=>'C'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169483332551656592.4001)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>7
,p_column_identifier=>'E'
,p_column_label=>unistr('\00DAltima Actualizaci\00F3n')
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169483421312656592.4001)
,p_db_column_name=>'FLOW_TABLE'
,p_display_order=>8
,p_column_identifier=>'F'
,p_column_label=>'Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169546809483832616.4001)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169578010269239638.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(250971123812404428.4001)
,p_db_column_name=>'SCN'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(250971210994404432.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(250971308049404433.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251184621092708260.4001)
,p_plug_name=>unistr('Historial de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en todos los elementos de la p\00E1gina actual.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(257176801354807079.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(7124527812558841.4001)
,p_button_name=>'P201_SET'
,p_button_static_id=>'P201_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(250973106113446610.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7124527812558841.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169578405037285426.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(7124527812558841.4001)
,p_button_name=>'APPLICATION_HISTORY'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Historial de Aplicaciones'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4350:42:&SESSION.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168251008194220440.4001)
,p_branch_action=>'201'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253851919909207001.4001)
,p_name=>'P201_INCLUDE_SC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(7124527812558841.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_SHARED_COMPONENTS_Y'
,p_lov=>'.'||wwv_flow_api.id(417652505855073319.4001)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(294769106665459666.4001)
,p_name=>'P201_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7124527812558841.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de la P\00E1gina:')
,p_source=>'select name from wwv_flow_steps where flow_id = :fb_flow_id and id = :fb_flow_page_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<p>Identifica el nombre de la p\00E1gina seleccionada actualmente.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(127729823028905539.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine lock status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_region_layout.set_lock_status (p_flow=>:fb_flow_id, p_page=>:fb_flow_page_id);',
'exception when others then null;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00202
begin
wwv_flow_api.create_page(
 p_id=>202.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Uso de \00C1rboles')
,p_step_title=>unistr('Uso de \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4873732637361578.4001)
,p_plug_name=>unistr('Uso de \00C1rbol')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina identifica los \00E1rboles utilizados en la aplicaci\00F3n actual.</p>')
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4891407164403819.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(4884503079390537.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48520116378288694.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P202a */ t.id,',
'       t.tree_name name, ',
'       (select count(distinct r.page_id) ',
'          from wwv_flow_page_plugs r ',
'         where r.flow_id = :fb_flow_id ',
'           and r.security_group_id = :flow_security_group_id ',
'           and r.plug_source_type = ''NATIVE_TREE'' ',
'           and sys.dbms_lob.instr(r.plug_source,t.id) > 0) util_cnt',
'  from wwv_flow_trees t ',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id ',
' order by 1,2'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48520212165288694.4001)
,p_name=>'Utilization'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48520424295288702.4001)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::F4000_P27_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48520616256288705.4001)
,p_db_column_name=>'UTIL_CNT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Referencias de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48521225987297309.4001)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188983424798851732.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48520116378288694.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:202,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48521730059317406.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'202'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
end;
/
prompt --application/pages/page_00203
begin
wwv_flow_api.create_page(
 p_id=>203.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Uso de Opci\00F3n de Creaci\00F3n')
,p_step_title=>unistr('Uso de Opci\00F3n de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4974829597177484.4001)
,p_name=>'Build Option Utilization'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>'return wwv_flow_f4000_util.get_build_opt_util;'
,p_display_when_condition=>'F4000_P203_BUILDOPT'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>2
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48724125733771805.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Punto'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48724213710771805.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Descripci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47914229316595621.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(47909111131552473.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94765120703025917.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5065412311021125.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(94765120703025917.4001)
,p_button_name=>'F4000_P203_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5094401072056730.4001)
,p_branch_action=>'203'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GO'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5063616840019071.4001)
,p_name=>'F4000_P203_BUILDOPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(94765120703025917.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(157083825594119867.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'203'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00204
begin
wwv_flow_api.create_page(
 p_id=>204.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Plantillas de Bot\00F3n')
,p_step_title=>unistr('Editar Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_button_templates t, wwv_flow_themes th',
'where t.id = :F4000_P204_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_but.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33346500180901136.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P204_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_02=>'TEMPLATE_NAME'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'F4000_P204_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46185929138892976.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77939612306912704.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77962514350090426.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77963812193091410.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77971829434098596.4001)
,p_plug_name=>unistr('Definici\00F3n')
,p_region_name=>'D'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(77977209377107934.4001)
,p_plug_name=>unistr('Plantillas de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta p\00E1gina para editar una plantilla de bot\00F3n.</p>'),
unistr('<p>Las plantillas de bot\00F3n permiten a los desarrolladores personalizar el aspecto del bot\00F3n. Para crear un bot\00F3n, puede utilizar diversas im\00E1genes o etiquetas HTML. El uso de plantillas de bot\00F3n es opcional.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117330718143414549.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166069024164863346.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_name=>'SS'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.button_template_sub_str (',
'    p_template_id => :F4000_P204_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n se utilizan en las subplantillas para hacer referencia a los valores del componente. Este informe detalla el uso de la cadena de sustituci\00F3n para esta plantilla.')
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(615788632607651459.4001)
,p_name=>'Opciones de Plantilla'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and button_template_id = :F4000_P204_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P204_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(615789494326651464.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(615788919180651464.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688532794326235640.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(615789087084651464.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688532892001235641.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688532908109235641.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(688605826047856548.4001)
,p_name=>'Opciones de Plantilla Global'
,p_parent_plug_id=>wwv_flow_api.id(615788632607651459.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o,',
'       wwv_flow_button_templates t',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.security_group_id  = :WORKSPACE_ID',
'   and o.template_types = ''BUTTON''',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P204_ID    '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P204_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688606590194856549.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688606310552856548.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688606052538856548.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688606473219856549.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688606149913856548.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688606205854856548.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617469813702046883.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_BUTTON_TEMPLATES',
'where id = :F4000_P204_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P204_ID,',
'      p_component_type => ''Button Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932806706613193711.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P204_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P204_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(189810724719646927.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(189810618410646927.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78588700805519814.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33346500180901136.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P204_ID.,&FLOW_PAGE_ID.,BUTTON'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_button_templates',
'',
'where reference_id = :F4000_P204_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78582924092507589.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33346500180901136.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_button_templates',
'',
'where id = :F4000_P204_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(615789510018651465.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(615788632607651459.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_BUTTON_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P204_THEME.,&F4000_P204_ID.,BUTTON'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77939901558912707.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77940205997912707.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:502:&SESSION.::&DEBUG.::P502_ID:&F4000_P204_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P204_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77940001894912707.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P204_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(77940123945912707.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P204_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(189815621525646981.4001)
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.::F4000_P204_ID:&P204_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(189810618410646927.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(189816027230646985.4001)
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.::F4000_P204_ID:&P204_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(189810724719646927.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78664025785671693.4001)
,p_branch_action=>'204'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(78582924092507589.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27975409468659525.4001)
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P204_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(77941122437912714.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>50
,p_branch_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24157228146562762.4001)
,p_name=>'P204_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(77939612306912704.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Traducible'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--noLabelCheckbox'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27970213923632356.4001)
,p_name=>'F4000_P204_RETURN_TO_PAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(77977209377107934.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40820410352430418.4001)
,p_name=>'P204_N'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'select TEMPLATE_NAME  from WWV_FLOW_BUTTON_TEMPLATES where id = :F4000_P204_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la plantilla'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43573221294616569.4001)
,p_name=>'P204_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(77939612306912704.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'THEME_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''||t.theme_id||'')<a href="f?p=4000:''||:THEME_NEXT_PAGE ||    ',
'       '':''||:APP_SESSION||''::::P496_THEME:''|| t.id ||    ',
'       ''"><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme_''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.id) theme_app_id',
'       from wwv_flow_themes t, wwv_flow_user_interfaces ui ',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P496_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P496_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P496_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P496_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P496_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P496_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P496_SHOW = ''ALL'')',
'        )  ',
'        and ui.flow_id = t.flow_id',
'        and ui.theme_id = t.theme_id',
'        and ui.ui_type_id = 1',
'        order by t.theme_id'))
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tema al que est\00E1 asociada esta plantilla. Un tema es un grupo de plantillas que proporcionan el dise\00F1o y el estilo a una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43578820994644863.4001)
,p_name=>'P204_THEME_CLASS_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(77939612306912704.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUTTON THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43576623634636183.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77941726867912721.4001)
,p_name=>'F4000_P204_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(117330718143414549.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77942316895912737.4001)
,p_name=>'F4000_P204_TEMPLATE_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(77939612306912704.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifica el nombre de la plantilla. Este atributo se puede cambiar en cualquier momento y no tiene efecto en la funcionalidad de las plantillas de bot\00F3n.</p>'),
'',
'Utilice la casilla de control <strong>Se Puede Convertir</strong> para indicar si la plantilla contiene cadenas de texto que hay que convertir.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77942616804912740.4001)
,p_name=>'F4000_P204_TEMPLATE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(77971829434098596.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Normal'
,p_source=>'TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la plantilla de bot\00F3n que se muestra si el tipo de bot\00F3n es ''Normal''. Puede incluir sustituciones de aplicaci\00F3n est\00E1ndar. Por ejemplo, los valores &amp;ITEM_NAME. se pueden sustituir en el momento de la presentaci\00F3')
||'n.</div>',
unistr('<div class="htmldbInfoBodyP">Las plantillas de bot\00F3n soportan las siguientes cadenas de sustituci\00F3n:'),
'<ul class="noIndent">',
unistr('<li><code>#LABEL#</code> se sustituye por una etiqueta de bot\00F3n.</li>'),
unistr('<li><code>#LINK#</code> se sustituye por el c\00F3digo JavaScript generado para controlar el comportamiento del bot\00F3n. Seg\00FAn la acci\00F3n de un bot\00F3n, este c\00F3digo puede ser una llamada a <code>apex.submit</code> para ejecutar la p\00E1gina, <code>redirect</code')
||unistr('> para una p\00E1gina, <code>redirect</code> para otra URL proporcionada, la ejecuci\00F3n de un c\00F3digo JavaScript personalizado o <code>void(0)</code> para no hacer nada (donde el comportamiento se puede definir por separado con acciones din\00E1micas). Nota: <')
||unistr('code>#LINK#</code> coloca al c\00F3digo JavaScript generado el prefijo ''javascript:'', por lo que se debe utilizar en un atributo <code>href</code>.</li>'),
unistr('<li><code>#JAVASCRIPT#</code> se sustituye por el c\00F3digo JavaScript generado para controlar el comportamiento del bot\00F3n. Seg\00FAn la acci\00F3n de un bot\00F3n, este c\00F3digo puede ser una llamada a <code>apex.submit</code> para ejecutar la p\00E1gina, <code>redirect')
||unistr('</code> para una p\00E1gina, <code>redirect</code> para otra URL proporcionada, la ejecuci\00F3n de un c\00F3digo JavaScript personalizado o <code>void(0)</code> para no hacer nada (donde el comportamiento se puede definir por separado con acciones din\00E1micas). '),
unistr('<p><strong>Nota:</strong> <code>#JAVASCRIPT#</code> no coloca al c\00F3digo JavaScript generado el prefijo ''javascript:'', por lo que se debe utilizar en un atributo <code>onclick</code>.</li>'),
unistr('<li><code>#BUTTON_ID#</code> se sustituye por el ID del bot\00F3n. Ser\00E1 el ID est\00E1tico del bot\00F3n si se ha definido, o en caso contrario ser\00E1 un ID generado internamente con el formato <pre>''B'' || [Internal Button ID]</pre></li>'),
unistr('<li><code>#BUTTON_CSS_CLASSES#</code> se sustituye por la propiedad de clases CSS de bot\00F3n de la definici\00F3n de bot\00F3n.</li>'),
unistr('<li><code>#BUTTON_ATTRIBUTES#</code> se sustituye por la propiedad de atributos de bot\00F3n de la definici\00F3n de bot\00F3n.</li>'),
unistr('<li><code>#ICON_CSS_CLASSES#</code> se sustituye por la propiedad de clases CSS de icono de la definici\00F3n de bot\00F3n.</li>'),
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Todas las cadenas de sustituci\00F3n deben estar en may\00FAsculas.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77942922701912740.4001)
,p_name=>'F4000_P204_TEMPLATE_COMMENT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(77962514350090426.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77943207379912743.4001)
,p_name=>'F4000_P204_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33346500180901136.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_BUTTON_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_button_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'     build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'     exists (',
'      select 1 from wwv_flow_developers',
'      where userid = :flow_user and (flow_id = f.id or flow_id is null) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78611122002551967.4001)
,p_name=>'F4000_P204_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33346500180901136.4001)
,p_item_default=>'Y'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_button_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P204_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--noLabelCheckbox'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189813421122646947.4001)
,p_name=>'P204_ID_NEXT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(117330718143414549.4001)
,p_prompt=>'P204_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189813832427646952.4001)
,p_name=>'P204_ID_PREV'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(117330718143414549.4001)
,p_prompt=>'P204_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189814223623646955.4001)
,p_name=>'P204_ID_COUNT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(77963812193091410.4001)
,p_prompt=>unistr('Plantillas de Bot\00F3n: ')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Edite una plantilla de bot\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(266602103340641101.4001)
,p_name=>'P204_HOT_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(77971829434098596.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Directa'
,p_source=>'HOT_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la plantilla de bot\00F3n que se muestra si el tipo de bot\00F3n es ''Directo''. Puede incluir sustituciones de aplicaci\00F3n est\00E1ndar. Por ejemplo, los valores &amp;ITEM_NAME. se pueden sustituir en el momento de la presentaci')
||unistr('\00F3n.</div>'),
unistr('<div class="htmldbInfoBodyP">Las plantillas de bot\00F3n soportan las siguientes cadenas de sustituci\00F3n:'),
'<ul class="noIndent">',
unistr('<li><code>#LABEL#</code> se sustituye por una etiqueta de bot\00F3n.</li>'),
unistr('<li><code>#LINK#</code> se sustituye por el c\00F3digo JavaScript generado para controlar el comportamiento del bot\00F3n. Seg\00FAn la acci\00F3n de un bot\00F3n, este c\00F3digo puede ser una llamada a <code>apex.submit</code> para ejecutar la p\00E1gina, <code>redirect</code')
||unistr('> para una p\00E1gina, <code>redirect</code> para otra URL proporcionada, la ejecuci\00F3n de un c\00F3digo JavaScript personalizado o <code>void(0)</code> para no hacer nada (donde el comportamiento se puede definir por separado con acciones din\00E1micas). Nota: <')
||unistr('code>#LINK#</code> coloca al c\00F3digo JavaScript generado el prefijo ''javascript:'', por lo que se debe utilizar en un atributo <code>href</code>.</li>'),
unistr('<li><code>#JAVASCRIPT#</code> se sustituye por el c\00F3digo JavaScript generado para controlar el comportamiento del bot\00F3n. Seg\00FAn la acci\00F3n de un bot\00F3n, este c\00F3digo puede ser una llamada a <code>apex.submit</code> para ejecutar la p\00E1gina, <code>redirect')
||unistr('</code> para una p\00E1gina, <code>redirect</code> para otra URL proporcionada, la ejecuci\00F3n de un c\00F3digo JavaScript personalizado o <code>void(0)</code> para no hacer nada (donde el comportamiento se puede definir por separado con acciones din\00E1micas). '),
unistr('<p><strong>Nota:</strong> <code>#JAVASCRIPT#</code> no coloca al c\00F3digo JavaScript generado el prefijo ''javascript:'', por lo que se debe utilizar en un atributo <code>onclick</code>.</li>'),
unistr('<li><code>#BUTTON_ID#</code> se sustituye por el ID del bot\00F3n. Ser\00E1 el ID est\00E1tico del bot\00F3n si se ha definido, o en caso contrario ser\00E1 un ID generado internamente con el formato <pre>''B'' || [ID de Bot\00F3n Interno]</pre></li>'),
unistr('<li><code>#BUTTON_CSS_CLASSES#</code> se sustituye por la propiedad de clases CSS de bot\00F3n de la definici\00F3n de bot\00F3n.</li>'),
unistr('<li><code>#BUTTON_ATTRIBUTES#</code> se sustituye por la propiedad de atributos de bot\00F3n de la definici\00F3n de bot\00F3n.</li>'),
unistr('<li><code>#ICON_CSS_CLASSES#</code> se sustituye por la propiedad de clases CSS de icono de la definici\00F3n de bot\00F3n.</li>'),
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Todas las cadenas de sustituci\00F3n deben estar en may\00FAsculas.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628657317169705624.4001)
,p_name=>'P204_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(615788632607651459.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text          ',
'  from wwv_flow_template_options o,',
'       wwv_flow_button_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and template_types = ''BUTTON''',
'   and (button_template_id = :F4000_P204_ID or button_template_id is NULL)',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P204_ID    ',
'order by  advanced_group nulls first, group_name nulls first, display_sequence, display_name',
''))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628658112568713194.4001)
,p_name=>'P204_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(615788632607651459.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_button_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.button_template_id',
'   and button_template_id = :F4000_P204_ID',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1007564634910031506.4001)
,p_name=>'F4000_P204_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(77939612306912704.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449463557347055538.4001)
,p_name=>'P204_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(615788632607651459.4001)
,p_source=>'P204_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104497288070349685.4001)
,p_name=>'P204_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(77939612306912704.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104497860119358904.4001)
,p_computation_sequence=>10
,p_computation_item=>'P204_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_button_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P204_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(78616127382564645.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P204_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78620400855576959.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P204_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(78582924092507589.4001)
,p_associated_item=>wwv_flow_api.id(77943207379912743.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78628209241603451.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>40
,p_validation=>'F4000_P204_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(78582924092507589.4001)
,p_associated_item=>wwv_flow_api.id(77943207379912743.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397290708319396751.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P204_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397291018780396751.4001)
,p_event_id=>wwv_flow_api.id(397290708319396751.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(189810724719646927.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397291114553398584.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P204_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397291404568398584.4001)
,p_event_id=>wwv_flow_api.id(397291114553398584.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(189810618410646927.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(615861832900809383.4001)
,p_name=>'refresh template options after edit'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(615788632607651459.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751431538772803.4001)
,p_event_id=>wwv_flow_api.id(615861832900809383.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(615788632607651459.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:204:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(615862848924814665.4001)
,p_name=>'refresh template options'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(615789510018651465.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751584509772804.4001)
,p_event_id=>wwv_flow_api.id(615862848924814665.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(615788632607651459.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:204:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(77943627642912746.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
,p_process_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(189815222514646975.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'ID'
,p_attribute_09=>'P204_ID_NEXT'
,p_attribute_10=>'P204_ID_PREV'
,p_attribute_13=>'P204_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78639507288619482.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_button_template (',
'    p_master_template_id         => :F4000_P204_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P204_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(78582924092507589.4001)
,p_process_when=>'F4000_P204_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(77943909177912750.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78643324744626650.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_button_template (',
'    p_master_template_id         => :F4000_P204_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P204_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>':F4000_P204_REFERENCE_ID is not null and :F4000_P204_REFRESH = ''Y'' and (upper(:request) like ''APPLY%'' or upper(:request) = ''SAVE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1449463652826055539.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_button_tmplopt_presets(:F4000_P204_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P204_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P204_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78647110942633003.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:F4000_P204_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'F4000_P204_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Identificador de referencia eliminado.'
);
end;
/
prompt --application/pages/page_00207
begin
wwv_flow_api.create_page(
 p_id=>207.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Tema: M\00E9todo')
,p_step_title=>'Crear Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41875032605399594.4001)
,p_plug_name=>'Crear Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44546724673083504.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106502626005441775.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106473613360356705.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138756852138155.4001)
,p_plug_name=>'Crear Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41879410011411999.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44546724673083504.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41879712202412002.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44546724673083504.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41935730864673440.4001)
,p_branch_action=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'THEME'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(59303916786317064.4001)
,p_branch_action=>'f?p=4000:267:&SESSION.::NO:267::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'NEW_THEME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(245683510898508513.4001)
,p_branch_action=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.::P460_FILE_TYPE:THEME'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(41879712202412002.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'IMPORT_THEME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1215440895769246856.4001)
,p_branch_action=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:401::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(41879712202412002.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41878501007409351.4001)
,p_name=>'P207_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(41875032605399594.4001)
,p_item_default=>'THEME'
,p_prompt=>'Procedimiento'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P207_CREATE_TEMPLATE'
,p_lov=>'.'||wwv_flow_api.id(41876318884405056.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00208
begin
wwv_flow_api.create_page(
 p_id=>208.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Tema: Identificar Tema'
,p_step_title=>'Crear Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_css_file_urls=>'#IMAGE_PREFIX#css/apex_ui_themes.css'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41928809954657956.4001)
,p_plug_name=>'Crear Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas que define la interfaz de usuario de la aplicaci\00F3n. Cada tema contiene plantillas para cada tipo de componente de aplicaci\00F3n y de control de p\00E1gina, incluidas las p\00E1ginas individuales, las regio')
||unistr('nes, los informes, las listas, las etiquetas, las rutas de navegaci\00F3n, los botones y las listas de valores. Las plantillas contienen texto HTML y variables que el motor de &PRODUCT_NAME. sustituye por valores din\00E1micos en tiempo de ejecuci\00F3n.'),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44553913769118278.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106505002026453850.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106473613360356705.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138860578138155.4001)
,p_plug_name=>'Crear Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41930020343660942.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44553913769118278.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41930332263660943.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44553913769118278.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41931124845662259.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44553913769118278.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41949415935716470.4001)
,p_branch_action=>'f?p=&APP_ID.:210:&SESSION.::&DEBUG.::THEME_ID:&P208_THEME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(41930332263660943.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(137254000365225921.4001)
,p_branch_action=>'f?p=&APP_ID.:208:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41940107577685674.4001)
,p_name=>'P208_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(41928809954657956.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema'
,p_source=>'select max(theme_id)+1 from wwv_flow_themes where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'THEME_LIST P208'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''|| wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||'')''||''<a href="f?p=4000:''||:THEME_NEXT_PAGE ||    ',
'       '':''||:APP_SESSION||''::::P208_THEME:''|| t.id ||    ',
'       ''"><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme_''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.id) theme_app_id',
'       from wwv_flow_themes t',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P208_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P208_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P208_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P208_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P208_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P208_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P208_SHOW = ''ALL'')',
'        )  ',
'        and t.ui_type_id = :P208_UI_TYPE_ID',
'        and t.theme_id not in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id)',
'        order by t.flow_id'))
,p_lov_cascade_parent_items=>'P208_UI_TYPE_ID'
,p_ajax_items_to_submit=>'P208_SHOW'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'apex-pick-theme'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tema. Un tema identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137143416950927980.4001)
,p_name=>'P208_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(41928809954657956.4001)
,p_item_default=>'STANDARD'
,p_prompt=>'Tipo de Tema'
,p_source=>'STANDARD'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHOW THEMES'
,p_lov=>'.'||wwv_flow_api.id(131260202585040081.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de tema. Se proporcionan temas est\00E1ndar con &PRODUCT_NAME.. Los temas personalizados son temas adicionales disponibles para su uso.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(276307017339304655.4001)
,p_name=>'P208_UI_TYPE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(41928809954657956.4001)
,p_prompt=>'Ui Type ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57844929565131889.4001)
,p_computation_sequence=>10
,p_computation_item=>'THEME_NEXT_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'210'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276330620838774046.4001)
,p_computation_sequence=>10
,p_computation_item=>'P208_UI_TYPE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  if :P1207_USER_INTERFACE_ID > 0 then',
'    return :P1207_USER_INTERFACE_ID;',
'  else',
'    return :P1207_UI_TYPE_ID;',
'  end if;',
'end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(141503921244428824.4001)
,p_validation_name=>'P208_THEME'
,p_validation_sequence=>10
,p_validation=>'P208_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(41930332263660943.4001)
,p_associated_item=>wwv_flow_api.id(41940107577685674.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00209
begin
wwv_flow_api.create_page(
 p_id=>209.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar Archivo Concatenado'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear/Editar Archivo Concatenado'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(907489970216523325.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926153161992220060.4001)
,p_plug_name=>'Archivo Concatenado'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(926153579716220060.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(907489970216523325.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P209_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(926153433597220060.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(907489970216523325.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P209_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(926153373759220060.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(907489970216523325.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P209_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(926153664262220060.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(907489970216523325.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926154799924220074.4001)
,p_name=>'P209_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926154981029220083.4001)
,p_name=>'P209_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926155128518220084.4001)
,p_name=>'P209_USER_INTERFACE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'USER_INTERFACE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926155388199220084.4001)
,p_name=>'P209_COMBINED_FILE_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo Concatenado'
,p_source=>'COMBINED_FILE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Introduzca la URL del archivo concatenado que se va a cargar, en lugar de varios archivos CSS o JavaScript individuales.',
'</p>',
'',
'<p>',
unistr('El uso de un archivo concatenado puede aumentar el rendimiento de carga de la p\00E1gina, ya que, en lugar de emitir varias solicitudes HTTP para cada archivo individual, el explorador solo tiene que cargar un archivo.'),
unistr('Tambi\00E9n le proporcionar\00E1 la libertad de utilizar archivos modulares m\00E1s peque\00F1os durante el desarrollo, pero se utilizar\00E1 el archivo concatenado \00FAnico al ejecutar la aplicaci\00F3n fuera del entorno de desarrollo de &PRODUCT_NAME..'),
'</p>',
'',
unistr('<p>Nota: el archivo concatenado se cargar\00E1 en cuanto se encuentre la URL exacta de un archivo CSS o JavaScript solicitado al presentar una p\00E1gina. Por ejemplo, si el archivo se define en el atributo <em>URL de Archivo JavaScript</em> o <em>URL de Arc')
||unistr('hivo CSS</em> para la p\00E1gina actual, o se carga por otros medios, como a trav\00E9s de las API <code>apex_javascript</code> o <code>apex_css</code>, o a trav\00E9s de otro atributo de nivel de aplicaci\00F3n en el que se pueden incluir archivos.</p>'),
'',
'<p>',
'Ejemplo:',
'<pre>',
'&#35;APP_IMAGES&#35;js/all.min.js?version=&#35;APP_VERSION&#35;',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926155519628220084.4001)
,p_name=>'P209_SINGLE_FILE_URLS'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL de Archivo \00DAnico')
,p_source=>'SINGLE_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca varias URL de archivo para las que se debe cargar un archivo concatenado en su lugar. Cada URL se debe escribir en una nueva l\00EDnea.'),
'</p>',
'',
'<p>',
unistr('La URL de archivo individual solo se debe incluir en un archivo concatenado, a menos que \00E9ste se haya creado para una p\00E1gina espec\00EDfica.'),
'</p>',
'',
unistr('<p>Nota: el archivo concatenado se cargar\00E1 en cuanto se encuentre la URL exacta de un archivo CSS o JavaScript solicitado al presentar una p\00E1gina. Por ejemplo, si el archivo se define en el atributo <em>URL de Archivo JavaScript</em> o <em>URL de Arc')
||unistr('hivo CSS</em> para la p\00E1gina actual, o se carga por otros medios, como a trav\00E9s de las API <code>apex_javascript</code> o <code>apex_css</code>, o a trav\00E9s de otro atributo de nivel de aplicaci\00F3n en el que se pueden incluir archivos.</p>'),
'',
'<p>',
'Ejemplo:',
'<pre>',
'&#35;APP_IMAGES&#35;js/core.min.js?version=&#35;APP_VERSION&#35;',
'&#35;APP_IMAGES&#35;js/search.widget.min.js?version=&#35;APP_VERSION&#35;',
'&#35;APP_IMAGES&#35;js/profile.widget.min.js?version=&#35;APP_VERSION&#35;',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926155989253220084.4001)
,p_name=>'P209_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Solo para P\00E1gina')
,p_source=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_cMaxlength=>20
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un n\00FAmero de p\00E1gina si el archivo concatenado especificado solo se debe utilizar en una p\00E1gina concreta.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289129234639528128.4001)
,p_name=>'P209_REQUIRED_PATCH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(926153161992220060.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1882906085240161210.4001)
,p_validation_name=>'Page# exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id = :FB_FLOW_ID',
'   and id      = :P209_PAGE_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Se debe seleccionar una p\00E1gina existente.')
,p_validation_condition=>'P209_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(926155989253220084.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(926153758142220060.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(926153664262220060.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(926154124596220069.4001)
,p_event_id=>wwv_flow_api.id(926153758142220060.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(926156492026220085.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMBINED_FILES'
,p_attribute_02=>'WWV_FLOW_COMBINED_FILES'
,p_attribute_03=>'P209_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(926156662156220086.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMBINED_FILES'
,p_attribute_02=>'WWV_FLOW_COMBINED_FILES'
,p_attribute_03=>'P209_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(926156893716220086.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(926153579716220060.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(926157086192220087.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00210
begin
wwv_flow_api.create_page(
 p_id=>210.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Confirmar Tema'
,p_step_title=>'Crear Tema'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_css_file_urls=>'#IMAGE_PREFIX#css/apex_ui_themes.css'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41950628056719962.4001)
,p_plug_name=>'Confirmar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44556004681134597.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106506616225457885.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106473613360356705.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747138999415138155.4001)
,p_plug_name=>'Crear Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41952110501722073.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44556004681134597.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41951402560722071.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44556004681134597.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41951731567722072.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44556004681134597.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:208:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41960717807802206.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41953314335725527.4001)
,p_name=>'P210_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(41950628056719962.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<div class="apex-pick-theme">''||theme_name || '' ('' ||theme_id|| '')</div>''',
'from wwv_flow_themes          ',
'where security_group_id in (11,12)',
'and id = :P208_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(41959913305800856.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.add_theme_to_application (',
'   p_application_id=>:FB_FLOW_ID,',
'   p_theme_id=>:P208_THEME',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido crear el tema.'
,p_process_when_button_id=>wwv_flow_api.id(41951402560722071.4001)
,p_process_success_message=>'Tema creado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(276432603517109031.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create user interface'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'  select theme_id from wwv_flow_themes where id = :P208_THEME',
') loop',
'',
'  wwv_flow_wizard_api.create_user_interface (',
'    p_flow_id         => :FB_FLOW_ID,',
'    p_ui_type_name    => :P1207_UI_TYPE_NAME,',
'    p_display_name    => :P1207_DISPLAY_NAME,',
'    p_display_seq     => :P1207_DISPLAY_SEQ,',
'    p_use_auto_detect => :P1207_USE_AUTO_DETECT,',
'    p_is_default      => ''N'',',
'    p_theme_id        => c1.theme_id,',
'    p_home_url        => :P1207_HOME_URL,',
'    p_login_url       => :P1207_LOGIN_URL,',
'    p_global_page_id  => :P1207_GLOBAL_PAGE_ID',
'  );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1207_USER_INTERFACE_ID=0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00211
begin
wwv_flow_api.create_page(
 p_id=>211.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Bot\00F3n: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78824330215791185.4001)
,p_plug_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p> ')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78858022427825215.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186376431100169333.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78831313955798012.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186376431100169333.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78836125383801282.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186376431100169333.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19626603886845412.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186376431100169333.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78836512822801284.4001)
,p_branch_action=>'218'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(78836125383801282.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P211_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78984619309948262.4001)
,p_branch_action=>'219'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(78836125383801282.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P211_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585126298834099825.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19626603886845412.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78840318773811685.4001)
,p_name=>'F4000_P211_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(78824330215791185.4001)
,p_item_default=>'COPY'
,p_prompt=>unistr('Crear Plantilla de Bot\00F3n:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.TEMPLATE.OPTS'
,p_lov=>'.'||wwv_flow_api.id(88108326304250090.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla de bot\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585126009190099823.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(78831313955798012.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585126171503099824.4001)
,p_event_id=>wwv_flow_api.id(585126009190099823.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00212
begin
wwv_flow_api.create_page(
 p_id=>212.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Mensajes de Datos No Encontrados'
,p_step_title=>'Editar Mensajes de Datos No Encontrados'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11406909155048814.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(78970201021313521.4001)
,p_name=>'Edit Messages For All Pages'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_ID",',
'"PAGE_ID",',
'wwv_flow_escape.html(plug_name) "PLUG_NAME",',
'"PLUG_DISPLAY_SEQUENCE",',
'"PLUG_SOURCE_TYPE",',
'"PLUG_QUERY_NO_DATA_FOUND",',
'id return_id',
'from "WWV_FLOW_PAGE_PLUGS"',
'where flow_id = :fb_flow_id and ',
'      plug_source_type in (',
'         ''NATIVE_SQL_REPORT'',',
'         ''NATIVE_TABFORM'') and',
'    (:P212_message_contains is null or ',
'     instr(upper(PLUG_QUERY_NO_DATA_FOUND),upper(:P212_message_contains)) > 0)',
'     and',
'    (:P212_message_does_not_contain is null or ',
'      instr(upper(PLUG_QUERY_NO_DATA_FOUND),',
'      upper(:P212_message_does_not_contain)) = 0)',
'order by page_id, plug_name'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna regi\00F3n.')
,p_query_num_rows_item=>'P212_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 11-JUL-2003 19:18:38'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78970727793313529.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78970807271313529.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78970909431313529.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78971006920313529.4001)
,p_query_column_id=>4
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Regi\00F3n de Informe')
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID:#PAGE_ID##5110:#RETURN_ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78971130448313529.4001)
,p_query_column_id=>5
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78971207649313529.4001)
,p_query_column_id=>6
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Source Type'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(78971300119313530.4001)
,p_query_column_id=>7
,p_column_alias=>'PLUG_QUERY_NO_DATA_FOUND'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Mensaje No se ha encontrado ning\00FAn dato')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>60
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79112706318185306.4001)
,p_query_column_id=>8
,p_column_alias=>'RETURN_ID'
,p_column_display_sequence=>8
,p_column_heading=>'Return'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79092820659073499.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79092919896073501.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79093032725073502.4001)
,p_column_sequence=>3
,p_query_column_name=>'PAGE_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79093102588073502.4001)
,p_column_sequence=>4
,p_query_column_name=>'PLUG_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79093200134073502.4001)
,p_column_sequence=>5
,p_query_column_name=>'PLUG_DISPLAY_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79093306379073502.4001)
,p_column_sequence=>6
,p_query_column_name=>'PLUG_SOURCE_TYPE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79093414399073502.4001)
,p_column_sequence=>7
,p_query_column_name=>'PLUG_QUERY_NO_DATA_FOUND'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79112620532185305.4001)
,p_column_sequence=>8
,p_query_column_name=>'RETURN_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193876617638588369.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79122501069228736.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(11406909155048814.4001)
,p_button_name=>'P212_GO'
,p_button_static_id=>'P212_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78971530812313531.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11406909155048814.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78972400474313538.4001)
,p_branch_action=>'f?p=&FLOW_ID.:212:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 11-JUL-2003 19:18:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11360023640325682.4001)
,p_name=>'P212_ROWS'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(11406909155048814.4001)
,p_item_default=>'15'
,p_prompt=>'Filas'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79121827604226947.4001)
,p_name=>'P212_MESSAGE_CONTAINS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11406909155048814.4001)
,p_prompt=>'El Mensaje Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca criterios de consulta y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79128100423256919.4001)
,p_name=>'P212_MESSAGE_DOES_NOT_CONTAIN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(11406909155048814.4001)
,p_prompt=>'El Mensaje No Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca criterios de consulta y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78972007917313536.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(78970201021313521.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_PAGE_PLUGS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(78971530812313531.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 11-JUL-2003 19:18:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79123916653233252.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00213
begin
wwv_flow_api.create_page(
 p_id=>213.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Mensajes de Proceso'
,p_step_title=>'Editar Mensajes de Proceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12024601065631294.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(79187820301491793.4001)
,p_name=>'Edit messages for application'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_ID",',
'FLOW_STEP_ID,',
'PROCESS_SEQUENCE,',
'PROCESS_NAME,',
'PROCESS_ERROR_MESSAGE,',
'PROCESS_SUCCESS_MESSAGE',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and',
'  (:P213_MESSAGE_CONTAINS is null or',
'   instr(upper(process_error_message),upper(:P213_MESSAGE_CONTAINS)) > 0 or',
'   instr(upper(process_success_message),upper(:P213_MESSAGE_CONTAINS)) > 0) and',
'  (:P213_not_contain is null or ',
'   instr(upper(process_error_message),upper(:P213_not_contain )) = 0 or',
'   instr(upper(process_success_message),upper(:P213_not_contain )) = 0)',
'order by flow_step_id, process_name'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn proceso.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 13-JUL-2003 10:41:41'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188317457491839.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188418724491839.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188520792491839.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188614112491839.4001)
,p_query_column_id=>4
,p_column_alias=>'PROCESS_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188700853491839.4001)
,p_query_column_id=>5
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Proceso'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5530:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188809055491839.4001)
,p_query_column_id=>6
,p_column_alias=>'PROCESS_ERROR_MESSAGE'
,p_column_display_sequence=>6
,p_column_heading=>'Mensaje de Error'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>50
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79188910724491839.4001)
,p_query_column_id=>7
,p_column_alias=>'PROCESS_SUCCESS_MESSAGE'
,p_column_display_sequence=>7
,p_column_heading=>'Mensaje Correcto'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>50
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191031394494536.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191116587494537.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191218390494537.4001)
,p_column_sequence=>3
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191312523494537.4001)
,p_column_sequence=>4
,p_query_column_name=>'PROCESS_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191409088494538.4001)
,p_column_sequence=>5
,p_query_column_name=>'PROCESS_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191529310494538.4001)
,p_column_sequence=>6
,p_query_column_name=>'PROCESS_ERROR_MESSAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79191602105494538.4001)
,p_column_sequence=>7
,p_query_column_name=>'PROCESS_SUCCESS_MESSAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193860606276414824.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79209218936566636.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(12024601065631294.4001)
,p_button_name=>'P213_GO'
,p_button_static_id=>'P213_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79189101722491840.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(12024601065631294.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(79190017362491854.4001)
,p_branch_action=>'f?p=&FLOW_ID.:213:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 13-JUL-2003 10:41:41'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79208511664564530.4001)
,p_name=>'P213_MESSAGE_CONTAINS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(12024601065631294.4001)
,p_prompt=>'El Mensaje Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca criterios de consulta y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79705024893324836.4001)
,p_name=>'P213_NOT_CONTAIN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(12024601065631294.4001)
,p_prompt=>'Los Mensajes No Contienen'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca criterios de consulta y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79189621495491850.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(79187820301491793.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_PROCESSING'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(79189101722491840.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 13-JUL-2003 10:41:41'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79209926555568786.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00214
begin
wwv_flow_api.create_page(
 p_id=>214.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Mensajes de Error de Validaci\00F3n')
,p_step_title=>unistr('Editar Mensajes de Error de Validaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8171818253527348.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(79252715279714925.4001)
,p_name=>'Edit all validation error messages for application'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'ID,',
'FLOW_ID,',
'FLOW_STEP_ID,',
'"VALIDATION_NAME",',
'initcap(replace(validation_type,''_'','' '')) VALIDATION_TYPE,',
'ERROR_MESSAGE',
'from WWV_FLOW_STEP_VALIDATIONS',
'where flow_id = :fb_flow_id and',
'   (:P214_MESSAGE_CONTAINS is null or',
'    instr(upper(error_message),upper(:P214_MESSAGE_CONTAINS)) > 0) and',
'   (:P214_SEARCH is null or',
'    instr(upper(validation_name),upper(:P214_SEARCH)) > 0)',
'order by flow_step_id, validation_name'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna validaci\00F3n.')
,p_query_num_rows_item=>'P214_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 13-JUL-2003 11:18:52'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79253201811714931.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79253330843714931.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79253419488714931.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79253526807714931.4001)
,p_query_column_id=>4
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Validaci\00F3n')
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5510:#ID#'
,p_column_linktext=>'#VALIDATION_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79253626978714935.4001)
,p_query_column_id=>5
,p_column_alias=>'VALIDATION_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79253731112714936.4001)
,p_query_column_id=>6
,p_column_alias=>'ERROR_MESSAGE'
,p_column_display_sequence=>6
,p_column_heading=>'Mensaje de Error'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>70
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79256928997720960.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79257019852720960.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79257111031720960.4001)
,p_column_sequence=>3
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79257230897720960.4001)
,p_column_sequence=>4
,p_query_column_name=>'VALIDATION_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79257309432720960.4001)
,p_column_sequence=>5
,p_query_column_name=>'VALIDATION_TYPE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79257409289720961.4001)
,p_column_sequence=>6
,p_query_column_name=>'ERROR_MESSAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193771424669955839.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79265225712757859.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8171818253527348.4001)
,p_button_name=>'P214_GO'
,p_button_static_id=>'P214_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79253916896714936.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8171818253527348.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(79254808240714938.4001)
,p_branch_action=>'f?p=&FLOW_ID.:214:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 13-JUL-2003 11:18:52'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11372103517367138.4001)
,p_name=>'P214_ROWS'
,p_data_type=>'NUMBER'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(8171818253527348.4001)
,p_item_default=>'15'
,p_prompt=>'Filas'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79264720171756260.4001)
,p_name=>'P214_MESSAGE_CONTAINS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8171818253527348.4001)
,p_prompt=>'El Mensaje Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98413316539109443.4001)
,p_name=>'P214_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8171818253527348.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79254406998714938.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(79252715279714925.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_VALIDATIONS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(79253916896714936.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 13-JUL-2003 11:18:52'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79260512637735161.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00215
begin
wwv_flow_api.create_page(
 p_id=>215.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Mensajes de Error de C\00E1lculo')
,p_step_title=>unistr('Editar Mensajes de Error de C\00E1lculo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11301814033227070.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(79275824767809478.4001)
,p_name=>'Bulk edit computation error messages for all pages'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>125
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_STEP_ID",',
'"COMPUTATION_ITEM",',
'"COMPUTATION_ERROR_MESSAGE"',
'from #OWNER#.WWV_FLOW_STEP_COMPUTATIONS',
'where flow_id = :fb_flow_id ',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and',
' (:P215_MESSAGE_CONTAINS is null or',
'  instr(upper(computation_error_message),upper(:P215_MESSAGE_CONTAINS))>0)',
'order by flow_step_id, computation_item'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn c\00E1lculo.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 13-JUL-2003 11:34:38'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79276315856809483.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79276431855809483.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#:::RP:FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79276518156809483.4001)
,p_query_column_id=>3
,p_column_alias=>'COMPUTATION_ITEM'
,p_column_display_sequence=>3
,p_column_heading=>'Calcular Elemento'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5520:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79276610232809483.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPUTATION_ERROR_MESSAGE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Mensaje de Error de C\00E1lculo')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>70
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79283526545843243.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79283618243843243.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79283711832843243.4001)
,p_column_sequence=>3
,p_query_column_name=>'COMPUTATION_ITEM'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79283824670843243.4001)
,p_column_sequence=>4
,p_query_column_name=>'COMPUTATION_ERROR_MESSAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193689411615634157.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79285903605855562.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11301814033227070.4001)
,p_button_name=>'P215_GO'
,p_button_static_id=>'P215_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79276808621809484.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11301814033227070.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(79277718459809486.4001)
,p_branch_action=>'f?p=&FLOW_ID.:215:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 13-JUL-2003 11:34:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79288532348863805.4001)
,p_name=>'P215_MESSAGE_CONTAINS'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(11301814033227070.4001)
,p_prompt=>'El Mensaje Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un criterio de consulta que no sea sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79277305833809485.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(79275824767809478.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_COMPUTATIONS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(79276808621809484.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 13-JUL-2003 11:34:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79286913994858498.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00217
begin
wwv_flow_api.create_page(
 p_id=>217.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Cabeceras de Columna de Informe Est\00E1ndar')
,p_step_title=>unistr('Editar Cabeceras de Columna de Informe Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11665905213788711.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(79386829253142658.4001)
,p_name=>'Edit all report columns for this application'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, region_name, page, column_alias, column_display_sequence, column_heading, region_id',
'from',
'(',
'select ',
'"ID",',
'(select wwv_flow_escape.html(plug_name) plug_name from wwv_flow_page_plugs where id = region_id) region_name,',
'(select page_id from wwv_flow_page_plugs where id = region_id) page,',
'COLUMN_ALIAS,',
'COLUMN_DISPLAY_SEQUENCE,',
'COLUMN_HEADING,',
'region_id',
'from WWV_FLOW_REGION_REPORT_COLUMN',
'where flow_id = :fb_flow_id and',
'      nvl(hidden_column,''N'') != ''Y'' and',
'      exists (select 1 from wwv_flow_page_plugs where ',
'      plug_source_type in (',
'         ''NATIVE_SQL_REPORT'',',
'         ''NATIVE_TABFORM'') and id = region_id) and',
'    (:P217_COLUMN_CONTAINS is null or',
'     instr(upper(column_heading),upper(:P217_COLUMN_CONTAINS)) > 0)',
')',
'where (:P217_PAGE is null or page = :P217_PAGE)',
'order by 3,2,5',
''))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P217_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 13-JUL-2003 12:30:09'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100574933940284407.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79387331022142665.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100575019977284408.4001)
,p_query_column_id=>3
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79390915816156985.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79387504635142665.4001)
,p_query_column_id=>5
,p_column_alias=>'COLUMN_ALIAS'
,p_column_display_sequence=>5
,p_column_heading=>'Columna'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:1,4500:FB_FLOW_PAGE_ID,F4000_P1_PAGE:#PAGE#,#PAGE##7320:#ID#'
,p_column_linktext=>'#COLUMN_ALIAS#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79387614321142665.4001)
,p_query_column_id=>6
,p_column_alias=>'COLUMN_DISPLAY_SEQUENCE'
,p_column_display_sequence=>6
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79387717650142665.4001)
,p_query_column_id=>7
,p_column_alias=>'COLUMN_HEADING'
,p_column_display_sequence=>7
,p_column_heading=>'Cabecera de Columna'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>60
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79387400952142665.4001)
,p_query_column_id=>8
,p_column_alias=>'REGION_ID'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79390331908156981.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79390429630156981.4001)
,p_column_sequence=>2
,p_query_column_name=>'REGION_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79390519058156981.4001)
,p_column_sequence=>3
,p_query_column_name=>'PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79390615633156982.4001)
,p_column_sequence=>4
,p_query_column_name=>'COLUMN_ALIAS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79390715100156982.4001)
,p_column_sequence=>5
,p_query_column_name=>'COLUMN_DISPLAY_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79390806372156983.4001)
,p_column_sequence=>6
,p_query_column_name=>'COLUMN_HEADING'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193876412098586741.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79407415641228006.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(11665905213788711.4001)
,p_button_name=>'P217_GO'
,p_button_static_id=>'P217_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79387915103142666.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11665905213788711.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(79388715155142670.4001)
,p_branch_action=>'f?p=&FLOW_ID.:217:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 13-JUL-2003 12:30:10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79406911139226703.4001)
,p_name=>'P217_COLUMN_CONTAINS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11665905213788711.4001)
,p_prompt=>'La Columna Contiene:'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98666104033853156.4001)
,p_name=>'P217_PAGE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(11665905213788711.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtre por n\00FAmero de p\00E1gina. Introduzca el n\00FAmero de p\00E1gina y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(275478930813384878.4001)
,p_name=>'P217_ROWS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(11665905213788711.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,25,50,100'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que desea que aparezcan y haga clic en <span class="fielddatabold">Ir</span>.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79388303211142669.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(79386829253142658.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_REGION_REPORT_COLUMN'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(79387915103142666.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 13-JUL-2003 12:30:10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79408120142229345.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00218
begin
wwv_flow_api.create_page(
 p_id=>218.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Bot\00F3n: Detalles')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78872417886842560.4001)
,p_plug_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Las plantillas de bot\00F3n permiten a los desarrolladores de aplicaciones personalizar el aspecto de un bot\00F3n. Para crear un bot\00F3n, puede utilizar varias im\00E1genes o etiquetas HTML. No todos los botones utilizan plantillas de bot\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79577608784165807.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(79547928409156701.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186380405089209124.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78875616688846128.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186380405089209124.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78881331579850437.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186380405089209124.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78878724999848545.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186380405089209124.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101874031088197573.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585127643545099839.4001)
,p_branch_action=>'f?p=&APP_ID.:211:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(78878724999848545.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(105556709879210306.4001)
,p_name=>'P218_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(78872417886842560.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el nombre de la plantilla de bot\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106749420615213455.4001)
,p_name=>'P218_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(78872417886842560.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108371203777218044.4001)
,p_name=>'P218_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(78872417886842560.4001)
,p_prompt=>'Clase de Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUTTON THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43576623634636183.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la clase de tema.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(109295011396220235.4001)
,p_validation_name=>'P218_NAME'
,p_validation_sequence=>10
,p_validation=>'P218_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(78881331579850437.4001)
,p_associated_item=>wwv_flow_api.id(105556709879210306.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(110324219361222568.4001)
,p_validation_name=>'P218_THEME'
,p_validation_sequence=>20
,p_validation=>'P218_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(78881331579850437.4001)
,p_associated_item=>wwv_flow_api.id(106749420615213455.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(111449726979224768.4001)
,p_validation_name=>'P218_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P218_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(78881331579850437.4001)
,p_associated_item=>wwv_flow_api.id(108371203777218044.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585127471833099837.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(78875616688846128.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585127528263099838.4001)
,p_event_id=>wwv_flow_api.id(585127471833099837.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78955408550922792.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Button Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_button_templates (',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_template_name                 => :P218_NAME,',
'    p_template                      => ''<a href="#LINK#">#LABEL#</a>'',',
'    p_template_comment              => null,',
'    p_theme_id                      => :p218_theme,',
'    p_theme_class_id                => :p218_theme_class',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la plantilla de bot\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(78881331579850437.4001)
,p_process_success_message=>unistr('Plantilla de bot\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(585127382089099836.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(78881331579850437.4001)
,p_process_success_message=>unistr('Plantilla de bot\00F3n creada.')
);
end;
/
prompt --application/pages/page_00219
begin
wwv_flow_api.create_page(
 p_id=>219.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Bot\00F3n: Copiar de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78937032070896692.4001)
,p_plug_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>20
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78995810670967396.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|3,3\1,2|',
'',
'<font color="black" class="nounderline">&nbsp;</font>:',
'',
'<font color="black" class="nounderline">&nbsp;</font>:',
'',
'<font color="black" class="nounderline">Flow</font>:',
'',
'<font color="black" class="nounderline">ExportTitle</font>:',
'',
'<font color="black" class="nounderline">MimeType</font>:',
'',
'<font color="black" class="nounderline">DocSize</font>:',
'',
'<font color="black" class="nounderline">CreatedBy</font>:',
'',
'<font color="black" class="nounderline">Created</font>:',
'',
'<font color="black" class="nounderline">FileType</font>'))
,p_plug_query_num_rows=>20
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186377503311180257.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78999724625971425.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186377503311180257.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79010714366977909.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186377503311180257.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79005805709975417.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186377503311180257.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154563201491214857.4001)
,p_branch_action=>'f?p=&FLOW_ID.:413:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585126507658099828.4001)
,p_branch_action=>'f?p=&APP_ID.:211:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(79005805709975417.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79016305482985032.4001)
,p_name=>'F4000_P219_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(78937032070896692.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(79020800306987465.4001)
,p_validation_name=>'F4000_P219_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P219_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(79010714366977909.4001)
,p_associated_item=>wwv_flow_api.id(79016305482985032.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-JUL-2002 13:21'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585126321257099826.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(78999724625971425.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585126450569099827.4001)
,p_event_id=>wwv_flow_api.id(585126321257099826.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00220
begin
wwv_flow_api.create_page(
 p_id=>220.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituir Plantillas: Copiar Plantillas de'
,p_step_title=>'Sustituir Plantillas: Copiar Plantillas de'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36090124003134931.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_no_data_found=>unistr('No se ha encontrado ning\00FAn argumento para este procedimiento almacenado.')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_plug_header=>unistr('Utilice este asistente para copiar varias plantillas de otra aplicaci\00F3n y sustituir, a continuaci\00F3n, las plantillas en una aplicaci\00F3n existente. Seleccione la aplicaci\00F3n y la interfaz de usuario de la que desea copiar las plantillas.')
,p_plug_footer=>'<p>&nbsp;<p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200172715664161527.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747139095917138155.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(887631277228273347.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(1127562677974975992.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36092831304138085.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200172715664161527.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36095107540140671.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200172715664161527.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36095501695140673.4001)
,p_branch_action=>'222'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(36095107540140671.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36100522481150803.4001)
,p_name=>'F4000_P220_FROM_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(36090124003134931.4001)
,p_prompt=>unistr('Sustituir de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar plantillas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200355513125407083.4001)
,p_name=>'P220_USER_INTERFACE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(36090124003134931.4001)
,p_prompt=>'Interfaz de Usuario'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(initcap(f.display_name)) d, f.ui_type_id r',
'  from wwv_flow_user_interfaces f',
' where flow_id = :F4000_P220_FROM_FLOW',
'   and exists ( select null',
'                  from wwv_flow_visible_flows f2',
'                 where f2.id = f.flow_id )',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Interfaz de Usuario -'
,p_lov_cascade_parent_items=>'F4000_P220_FROM_FLOW'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de interfaz de usuario para la que ha sido desarrollada esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36106700915160771.4001)
,p_validation_name=>'from flow not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P220_FROM_FLOW'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_associated_item=>wwv_flow_api.id(36100522481150803.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36709326744741412.4001)
,p_validation_name=>'replace from flow not current flow'
,p_validation_sequence=>20
,p_validation=>':fb_flow_id != :F4000_P220_FROM_FLOW'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Seleccione una aplicaci\00F3n que no sea la aplicaci\00F3n actual desde la que se realizar\00E1 la copia.')
,p_when_button_pressed=>wwv_flow_api.id(36095107540140671.4001)
,p_associated_item=>wwv_flow_api.id(36100522481150803.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200356705780425650.4001)
,p_validation_name=>'P220_USER_INTERFACE'
,p_validation_sequence=>30
,p_validation=>'P220_USER_INTERFACE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_when_button_pressed=>wwv_flow_api.id(36095107540140671.4001)
,p_associated_item=>wwv_flow_api.id(200355513125407083.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00221
begin
wwv_flow_api.create_page(
 p_id=>221.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Tema'
,p_step_title=>'Suprimir Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57672322563700420.4001)
,p_plug_name=>'Identificar Tema a Suprimir'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58439930744285175.4001)
,p_plug_name=>'Suprimir Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Un tema es una recopilaci\00F3n de plantillas. Solo puede suprimir temas inactivos. Al suprimir un tema, el creador de aplicaciones eliminar\00E1 las plantillas inactivas.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(144906022460884948.4001)
,p_plug_name=>'Error al Suprimir Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('No hay ning\00FAn tema inactivo para suprimir. No se ha podido continuar con esta acci\00F3n.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where flow_id  = :fb_flow_id',
'   and theme_id not in ( select theme_id',
'                           from wwv_flow_user_interfaces',
'                          where flow_id = :fb_flow_id )'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200244012959340575.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(928046614226850015.4001)
,p_plug_name=>'Lista de Progreso del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(1029750209782685847.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(928046821756850017.4001)
,p_plug_name=>'Suprimir Tema'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57673506818700425.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200244012959340575.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(144906928001886565.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200244012959340575.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57675609157700443.4001)
,p_branch_action=>'f?p=&FLOW_ID.:229:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57674318785700429.4001)
,p_name=>'P221_REMOVE_THEME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(57672322563700420.4001)
,p_prompt=>'Suprimir Tema:'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||theme_name as d,',
'       theme_id',
'  from wwv_flow_themes',
' where flow_id  = :fb_flow_id',
'   and theme_id not in ( select theme_id',
'                           from wwv_flow_user_interfaces',
'                          where flow_id = :fb_flow_id )',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Seleccione el tema que se va a eliminar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57674709683700434.4001)
,p_name=>'P221_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57672322563700420.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
end;
/
prompt --application/pages/page_00222
begin
wwv_flow_api.create_page(
 p_id=>222.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituir Plantillas: Configurar'
,p_step_title=>'Sustituir Plantillas: Configurar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_inline_css=>'.a-Report-report select {width:160px;}'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(36130132161176698.4001)
,p_name=>'Plantillas'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'  --',
'  -- page template',
'  --',
'  q:=''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''PAGE'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(1,p.id), '';',
'  if :P220_USER_INTERFACE = 1 then',
'    q:=q||''decode((select count(*) from wwv_flow_themes f where f.flow_id = :fb_flow_id and f.default_page_template = p.id and f.ui_type_id = :P220_USER_INTERFACE),0,''''F''''||flow_id||'''':''''||wwv_flow_escape.html(name),''''F''''||flow_id||'''':''''||wwv_flow_es'
||'cape.html(name)||'''' *'''') replace, '';',
'  else  ',
'      q:=q||''decode((select count(*) from wwv_flow_themes f where f.flow_id = :fb_flow_id and f.mobile_page_template = p.id and f.ui_type_id = :P220_USER_INTERFACE),0,''''F''''||flow_id||'''':''''||wwv_flow_escape.html(name),''''F''''||flow_id||'''':''''||wwv_flow_e'
||'scape.html(name)||'''' *'''') replace, '';',
'  end if;',
'',
'  q:=q||''wwv_flow_item.select_list_from_query(2,null,''''select ''''''''F''''''''||flow_id||'''''''' ''''''''||name n,id from wwv_flow_templates where flow_id = :F4000_P220_FROM_FLOW '''', ''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_esc'
||'ape.html(name))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(3,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_templates p '';',
'  q:=q||''where p.flow_id = :FB_FLOW_ID '';',
'  q:=q||''and p.security_group_id = :flow_security_group_id '';',
'  if :P220_USER_INTERFACE = 1 then',
'      q:=q||''and (id in (select default_page_template from wwv_flow_themes where flow_id = :fb_flow_id and ui_type_id = :P220_USER_INTERFACE)) '';',
'  else',
'      q:=q||''and (id in (select mobile_page_template from wwv_flow_themes where flow_id = :fb_flow_id and ui_type_id = :P220_USER_INTERFACE)) '';',
'',
'  end if;',
'',
'  q:=q||''union all '';',
'  ',
'  --',
'  -- region template',
'  --',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''REGION'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(4,r.id), '';  ',
'  if :P220_USER_INTERFACE = 1 then',
'     q:=q||''decode((select count(*) from wwv_flow_themes f where f.flow_id = :fb_flow_id and f.default_region_template = r.id  and f.ui_type_id = :P220_USER_INTERFACE),0,''''F''''||r.flow_id||'''':''''||wwv_flow_escape.html(r.page_plug_template_name),''''F''''||'
||'r.flow_id||'''':''''||wwv_flow_escape.html(r.page_plug_template_name)||''''*'''') replace, '';  ',
'  else',
'      q:=q||''decode((select count(*) from wwv_flow_themes f where f.flow_id = :fb_flow_id and f.mobile_region_template = r.id  and f.ui_type_id = :P220_USER_INTERFACE),0,''''F''''||r.flow_id||'''':''''||wwv_flow_escape.html(r.page_plug_template_name),''''F''''||'
||'r.flow_id||'''':''''||wwv_flow_escape.html(r.page_plug_template_name)||''''*'''') replace, '';',
'  end if;',
'',
'  q:=q||''wwv_flow_item.select_list_from_query(5,null,''''select n,id from (select replace(''''''''F''''''''||r2.flow_id||'''''''' ''''''''||page_plug_template_name,'''''''','''''''',null) n,id,1 ob from wwv_flow_page_plug_templates r2 where r2.flow_id = :F4000_P220_FROM_FLOW '
||'union select wwv_flow_lang.system_message(''''''''REGION_TEMPLATES_NO_TEMPLATE'''''''',''''''''No Template'''''''') n,0 id,2 ob from dual) order by ob'''', ''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_escape.html(r.page_plug_template_n'
||'ame))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(6,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(r.page_plug_template_name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_page_plug_templates r '';',
'  q:=q||''where r.flow_id = :fb_flow_id '';',
'  q:=q||''and r.security_group_id = :flow_security_group_id '';',
'  if :P220_USER_INTERFACE = 1 then',
'      q:=q||''and (id in (select plug_template from wwv_flow_page_plugs where flow_id = :fb_flow_id) or id in (select default_region_template from wwv_flow_themes where flow_id = :fb_flow_id  and ui_type_id = :P220_USER_INTERFACE)) '';',
'  else',
'      q:=q||''and (id in (select plug_template from wwv_flow_page_plugs where flow_id = :fb_flow_id) or id in (select mobile_region_template from wwv_flow_themes where flow_id = :fb_flow_id  and ui_type_id = :P220_USER_INTERFACE)) '';',
'  end if;',
'  q:=q||''union all '';',
'  ',
'  --',
'  -- report template',
'  --',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''REPORT'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(7,rr.id), '';  ',
'  q:=q||''''''F''''||rr.flow_id||'''':''''||wwv_flow_escape.html(rr.row_template_name) replace, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_query(8,null,''''select replace(''''''''F''''''''||rr2.flow_id||'''''''' ''''''''||wwv_flow_escape.html(rr2.row_template_name),'''''''','''''''',null) n,rr2.id from  wwv_flow_row_templates rr2 where rr2.flow_id = :F4000_P220_FROM_FLOW '''
||''', ''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_escape.html(rr.row_template_name))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(9,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(rr.row_template_name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_row_templates rr '';',
'  q:=q||''where rr.flow_id = :fb_flow_id '';',
'  q:=q||''and rr.security_group_id = :flow_security_group_id '';',
'  q:=q||''and rr.id in (select plug_query_row_template from wwv_flow_page_plugs where flow_id = :fb_flow_id) '';',
'  q:=q||''union all '';',
'  ',
'  --',
'  -- list template',
'  --',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''LIST'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(10,li.id), '';  ',
'  q:=q||''''''F''''||li.flow_id||'''':''''||wwv_flow_escape.html(li.list_template_name) replace, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_query(11,null,''''select replace(''''''''F''''''''||li2.flow_id||'''''''' ''''''''||wwv_flow_escape.html(li2.list_template_name),'''''''','''''''',null) n,li2.id from   wwv_flow_list_templates li2 where li2.flow_id = :F4000_P220_FROM_FL'
||'OW '''', ''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_escape.html(li.list_template_name))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(12,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(li.list_template_name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_list_templates li '';',
'  q:=q||''where li.flow_id = :fb_flow_id '';',
'  q:=q||''and li.security_group_id = :flow_security_group_id '';',
'  q:=q||''union all '';',
'  ',
'  --',
'  -- label template',
'  --',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''LABEL'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(13,f.id), '';  ',
'  q:=q||''''''F''''||f.flow_id||'''':''''||wwv_flow_escape.html(f.template_name) replace, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_query(14,null,''''select replace(''''''''F''''''''||f2.flow_id||'''''''' ''''''''||wwv_flow_escape.html(f2.template_name),'''''''','''''''',null) n,f2.id from   wwv_flow_field_templates f2 where f2.flow_id = :F4000_P220_FROM_FLOW '''', '''''
||'title="''''||wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_escape.html(f.template_name))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(15,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(f.template_name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_field_templates f '';',
'  q:=q||''where f.flow_id = :fb_flow_id '';',
'  q:=q||''and f.security_group_id = :flow_security_group_id '';',
'  q:=q||''and f.id in (select item_field_template from wwv_flow_step_items where flow_id = :fb_flow_id) '';',
'  q:=q||''union all '';',
'  ',
'  --',
'  -- menu template',
'  --',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''MENU'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(16,m.id), '';  ',
'  q:=q||''''''F''''||m.flow_id||'''':''''||wwv_flow_escape.html(m.name) replace, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_query(17,null,''''select replace(''''''''F''''''''||m2.flow_id||'''''''' ''''''''||wwv_flow_escape.html(m2.name),'''''''','''''''',null) n,m2.id from   wwv_flow_menu_templates m2 where m2.flow_id = :F4000_P220_FROM_FLOW '''', ''''title="''''|'
||'|wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_escape.html(m.name))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(18,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(m.name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_menu_templates m '';',
'  q:=q||''where m.flow_id = :fb_flow_id '';',
'  q:=q||''and m.security_group_id = :flow_security_group_id '';',
'  q:=q||''and m.id in (select menu_template_id from wwv_flow_page_plugs where flow_id = :fb_flow_id) '';',
'  q:=q||''union all '';',
'  ',
'  -- popup lov template',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''POPUP_LOV'''') from dual) type, '';',
'  q:=q||''wwv_flow_item.hidden(19,pop.id), '';  ',
'  q:=q||''''''F''''||pop.flow_id||'''':Popup LOV Template'''' replace, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_query(20,null,''''select ''''''''F''''''''||pop2.flow_id||''''''''Popup LOV Template'''''''' n,pop2.id from wwv_flow_popup_lov_template pop2 where pop2.flow_id = :F4000_P220_FROM_FLOW '''', ''''title="''''||wwv_flow_lang.system_messag'
||'e(''''TEMPLATE.NEW_TEMPLATE'''', ''''Popup LOV Template'''')||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(21,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', ''''Popup LOV Template'''')||''''"'''') opt '';',
'  q:=q||''from wwv_flow_popup_lov_template pop '';',
'  q:=q||''where pop.flow_id = :fb_flow_id '';',
'  q:=q||''and pop.security_group_id = :flow_security_group_id ''; ',
'  q:=q||''union all '';',
'',
'  --',
'  -- button template',
'  --',
'  q:=q||''select '';',
'  q:=q||''(select wwv_flow_lang.system_message(''''BUTTON'''') from dual)  type, '';',
'  q:=q||''wwv_flow_item.hidden(22,b.id), '';  ',
'  q:=q||''''''F''''||b.flow_id||'''':''''||wwv_flow_escape.html(b.template_name) replace, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_query(23,null,''''select replace(''''''''F''''''''||b2.flow_id||'''''''' ''''''''||wwv_flow_escape.html(b2.template_name),'''''''','''''''',null) n,b2.id from   wwv_flow_button_templates b2 where b2.flow_id = :F4000_P220_FROM_FLOW '''', '''
||'''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.NEW_TEMPLATE'''', wwv_flow_escape.html(b.template_name))||''''"'''') rwith, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov(24,''''REPLACE'''',''''REPLACE_SUBSRIBE'''',''''title="''''||wwv_flow_lang.system_message(''''TEMPLATE.ACTION'''', wwv_flow_escape.html(b.template_name))||''''"'''') opt '';',
'  q:=q||''from wwv_flow_button_templates b '';',
'  q:=q||''where b.flow_id = :fb_flow_id '';',
'  q:=q||''and b.security_group_id = :flow_security_group_id '';',
'  q:=q||''and b.id in (select button_template_id from wwv_flow_step_buttons where flow_id = :fb_flow_id) '';',
'  ',
'  return q;',
'  ',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>10
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48877505103772723.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48877624719772723.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'<br />'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48877701347772723.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre de la Plantilla'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48877812336772723.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Nueva Plantilla'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48877905898772723.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Acci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48878022108772723.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48878105784772724.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48878202946772724.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48878311627772724.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48878429962772724.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36665923749712415.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El informe muestra todas las plantillas que se est\00E1n utilizando actualmente. Puede sustituir cualquier cantidad de estas plantillas por otras de la aplicaci\00F3n seleccionada. Puede copiar estas plantillas de dos formas, mediante <strong>Sustituir</s')
||'trong> y <strong>Suscribir</strong>.</p> ',
unistr('<p>Si elige <strong>Sustituir</strong>, se copia la definici\00F3n de plantilla. '),
unistr('Si elige <strong>Suscribir</strong>, se copian las plantillas y se agrega una suscripci\00F3n.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(479279618614124199.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747139207972138156.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1127563753450994995.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(1127562677974975992.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36133309796179203.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(479279618614124199.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36141207156187914.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(479279618614124199.4001)
,p_button_name=>'Replace'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sustituir Plantillas'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36136117761181518.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(479279618614124199.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36136519936181520.4001)
,p_branch_action=>'220'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(36136117761181518.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36145600675191348.4001)
,p_branch_action=>'4003'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(22782301189768282.4001)
,p_validation_name=>'cannot have same region template name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Region Template',
'-- g_f04 = copy to template id',
'-- g_f05 = copy from template id',
'-- g_f06 = copy option',
'--',
'declare',
'  l_replace_template_name       varchar2(4000) := null;',
'  l_replace_with_template_name  varchar2(4000) := null;  ',
'begin ',
'  for i in 1..wwv_flow.g_f04.count',
'  loop ',
'    l_replace_template_name := null;',
'    l_replace_with_template_name := null;',
'    for c1 in (select page_plug_template_name',
'               from   wwv_flow_page_plug_templates',
'               where  flow_id = :F4000_P220_FROM_FLOW ',
'               and id = replace(wwv_flow.g_f05(i),''%''||''null%''))',
'    loop',
'      l_replace_with_template_name := c1.page_plug_template_name;	',
'    end loop;',
'    ',
'    for c1 in (select page_plug_template_name',
'               from   wwv_flow_page_plug_templates',
'               where  flow_id = :FB_FLOW_ID ',
'               and id = wwv_flow.g_f04(i)) ',
'    loop      ',
'      l_replace_template_name := c1.page_plug_template_name;',
'    end loop;  ',
'         ',
'    if l_replace_with_template_name != l_replace_template_name then',
'      for c1 in (select page_plug_template_name',
'                 from   wwv_flow_page_plug_templates',
'                 where  flow_id = :FB_FLOW_ID ',
'                 and page_plug_template_name = l_replace_with_template_name) ',
'      loop       ',
'        -- the same template name exists',
'        return false;',
'      end loop;      ',
'    end if; ',
'  end loop;',
'  ',
'  return true; ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla de regi\00F3n ya existe en la aplicaci\00F3n actual.')
,p_when_button_pressed=>wwv_flow_api.id(36141207156187914.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(22847000842118359.4001)
,p_validation_name=>'cannot have same report template name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Report Template',
'-- g_f07 = copy to template id',
'-- g_f08 = copy from template id',
'-- g_f09 = copy option',
'--',
'declare',
'  l_replace_template_name       varchar2(4000) := null;',
'  l_replace_with_template_name  varchar2(4000) := null;  ',
'begin ',
'  for i in 1..wwv_flow.g_f07.count',
'  loop ',
'    l_replace_template_name := null;',
'    l_replace_with_template_name := null;',
'    for c1 in (select row_template_name',
'               from   wwv_flow_row_templates',
'               where  flow_id = :F4000_P220_FROM_FLOW ',
'               and id = replace(wwv_flow.g_f08(i),''%''||''null%''))',
'    loop',
'      l_replace_with_template_name := c1.row_template_name;	',
'    end loop;',
'    ',
'    for c1 in (select row_template_name',
'               from   wwv_flow_row_templates',
'               where  flow_id = :FB_FLOW_ID ',
'               and id = wwv_flow.g_f07(i)) ',
'    loop      ',
'      l_replace_template_name := c1.row_template_name;',
'    end loop;  ',
'         ',
'    if l_replace_with_template_name != l_replace_template_name then',
'      for c1 in (select row_template_name',
'                 from   wwv_flow_row_templates',
'                 where  flow_id = :FB_FLOW_ID ',
'                 and row_template_name = l_replace_with_template_name) ',
'      loop       ',
'        -- the same template name exists',
'        return false;',
'      end loop;      ',
'    end if; ',
'  end loop;',
'  ',
'  return true; ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La aplicaci\00F3n actual tiene el mismo nombre de plantilla de informe que el utilizado para sustituirla.')
,p_when_button_pressed=>wwv_flow_api.id(36141207156187914.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(22851102059156493.4001)
,p_validation_name=>'cannot have same list template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace List Template',
'-- g_f10 = copy to template id',
'-- g_f11 = copy from template id',
'-- g_f12 = copy option',
'--',
'declare',
'  l_replace_template_name       varchar2(4000) := null;',
'  l_replace_with_template_name  varchar2(4000) := null;  ',
'begin ',
'  for i in 1..wwv_flow.g_f10.count',
'  loop ',
'    l_replace_template_name := null;',
'    l_replace_with_template_name := null;',
'    for c1 in (select list_template_name',
'               from   wwv_flow_list_templates',
'               where  flow_id = :F4000_P220_FROM_FLOW ',
'               and id = replace(wwv_flow.g_f11(i),''%''||''null%''))',
'    loop',
'      l_replace_with_template_name := c1.list_template_name;	',
'    end loop;',
'    ',
'    for c1 in (select list_template_name',
'               from   wwv_flow_list_templates',
'               where  flow_id = :FB_FLOW_ID ',
'               and id = wwv_flow.g_f10(i)) ',
'    loop      ',
'      l_replace_template_name := c1.list_template_name;',
'    end loop;  ',
'         ',
'    if l_replace_with_template_name != l_replace_template_name then',
'      for c1 in (select list_template_name',
'                 from   wwv_flow_list_templates',
'                 where  flow_id = :FB_FLOW_ID ',
'                 and list_template_name = l_replace_with_template_name) ',
'      loop       ',
'        -- the same template name exists',
'        return false;',
'      end loop;      ',
'    end if; ',
'  end loop;',
'  ',
'  return true; ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla de lista ya existe en la aplicaci\00F3n actual.')
,p_when_button_pressed=>wwv_flow_api.id(36141207156187914.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(36664625690711557.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'replace page templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Page Template',
'-- g_f01 = copy to template id',
'-- g_f02 = copy from template id',
'-- g_f03 = copy option',
'--',
'',
'for i in 1..wwv_flow.g_f01.count loop',
' if replace(wwv_flow.g_f02(i),''%''||''null%'',null) is not null then      ',
'    if wwv_flow.g_f03(i) in (''REPLACE'',''SUBSCRIBE'') then',
'     wwv_flow_templates_util.replace_template (',
'      p_from_flow_id   => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id             => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f02(i),      ',
'      p_to_template_id      => wwv_flow.g_f01(i)',
'      );',
'     commit;',
'',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_page_template (',
'        p_master_template_id         => wwv_flow.g_f02(i),',
'        p_subscribing_template_id    => wwv_flow.g_f01(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al sustituir las plantillas de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
,p_process_success_message=>'Plantillas sustituidas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37274925971957323.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process region templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Region Template',
'-- g_f04 = copy to template id',
'-- g_f05 = copy from template id',
'-- g_f06 = copy option',
'--',
'',
'for i in 1..wwv_flow.g_f04.count loop',
' if replace(wwv_flow.g_f05(i),''%''||''null%'',null) is not null then    ',
'  if wwv_flow.g_f06(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    --sys.htp.p(''p_from_template_id''||i||wwv_flow.g_f05(i));',
'    --sys.htp.p(''p_to_template_id''||i||wwv_flow.g_f04(i));',
'',
'    wwv_flow_templates_util.replace_region_template (',
'      p_from_flow_id   => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id             => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f05(i),      ',
'      p_to_template_id      => wwv_flow.g_f04(i)',
'      );',
'    if wwv_flow.g_f06(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_region_template (',
'        p_master_template_id         => wwv_flow.g_f05(i),',
'        p_subscribing_template_id    => wwv_flow.g_f04(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar la plantilla de regi\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37281314972962429.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'report template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Report Template',
'-- g_f07 = copy to template id',
'-- g_f08 = copy from template id',
'-- g_f09 = copy option',
'--',
'for i in 1..wwv_flow.g_f07.count loop',
' if replace(wwv_flow.g_f08(i),''%''||''null%'',null) is not null then  ',
'  if wwv_flow.g_f09(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.replace_report_template (',
'      p_from_flow_id        => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id          => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f08(i),',
'      p_to_template_id      => wwv_flow.g_f07(i)',
'      );',
'    if wwv_flow.g_f09(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_report_template (',
'        p_master_template_id         => wwv_flow.g_f08(i),',
'        p_subscribing_template_id    => wwv_flow.g_f07(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al sustituir las plantillas de informe.'
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37285305914966603.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'list template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace List Template',
'-- g_f10 = copy to template id',
'-- g_f11 = copy from template id',
'-- g_f12 = copy option',
'--',
'for i in 1..wwv_flow.g_f10.count loop',
' if replace(wwv_flow.g_f11(i),''%''||''null%'',null) is not null then    ',
'  if wwv_flow.g_f12(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.replace_list_template (',
'      p_from_flow_id        => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id          => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f11(i),      ',
'      p_to_template_id      => wwv_flow.g_f10(i)',
'      );',
'    if wwv_flow.g_f12(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_list_template (',
'        p_master_template_id         => wwv_flow.g_f11(i),',
'        p_subscribing_template_id    => wwv_flow.g_f10(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al sustituir las plantillas de lista.'
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37289329624970857.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'label'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Label Template',
'-- g_f13 = copy to template id',
'-- g_f14 = copy from template id',
'-- g_f15 = copy option',
'--',
'for i in 1..wwv_flow.g_f13.count loop',
' if replace(wwv_flow.g_f14(i),''%''||''null%'',null) is not null then    ',
'  if wwv_flow.g_f15(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.replace_field_template (',
'      p_from_flow_id        => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id          => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f14(i),      ',
'      p_to_template_id      => wwv_flow.g_f13(i)',
'      );',
'    if wwv_flow.g_f15(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_field_template (',
'        p_master_template_id         => wwv_flow.g_f14(i),',
'        p_subscribing_template_id    => wwv_flow.g_f13(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al sustituir las plantillas de etiqueta.'
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37293321861974381.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'menu templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Menu Template',
'-- g_f16 = copy to template id',
'-- g_f17 = copy from template id',
'-- g_f18 = copy option',
'--',
'for i in 1..wwv_flow.g_f16.count loop',
' if replace(wwv_flow.g_f17(i),''%''||''null%'',null) is not null then    ',
'  if wwv_flow.g_f18(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.replace_menu_template (',
'      p_from_flow_id        => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id          => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f17(i),      ',
'      p_to_template_id      => wwv_flow.g_f16(i)',
'      );',
'    if wwv_flow.g_f18(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_menu_template (',
'        p_master_template_id         => wwv_flow.g_f17(i),',
'        p_subscribing_template_id    => wwv_flow.g_f16(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al sustituir las plantillas de ruta de navegaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37302012587978764.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lov templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Popup LOV Template',
'-- No need for a copy of an lov template',
'-- g_f19 = copy to template id',
'-- g_f20 = copy from template id',
'-- g_f21 = copy option',
'--',
'for i in 1..wwv_flow.g_f19.count loop',
' if replace(wwv_flow.g_f20(i),''%''||''null%'',null) is not null then',
'  if wwv_flow.g_f21(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.replace_popup_lov_template (',
'      p_from_flow_id        => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id          => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f20(i),      ',
'      p_to_template_id      => wwv_flow.g_f19(i)',
'      );',
'    if wwv_flow.g_f21(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_popuplov_template (',
'        p_master_template_id         => wwv_flow.g_f20(i),',
'        p_subscribing_template_id    => wwv_flow.g_f19(i)',
'      );',
'    end if;    ',
'  end if; ',
' end if; ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al sustituir las plantillas de listas de valores.'
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79921420478631396.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'button template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- Replace Button Template',
'-- g_f22 = copy to template id',
'-- g_f23 = copy from template id',
'-- g_f24 = copy option',
'--',
'for i in 1..wwv_flow.g_f22.count loop',
' if replace(wwv_flow.g_f23(i),''%''||''null%'',null) is not null then    ',
'  if wwv_flow.g_f24(i) in (''REPLACE'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.replace_button_template (',
'      p_from_flow_id        => :F4000_P220_FROM_FLOW,',
'      p_to_flow_id          => :FB_FLOW_ID,',
'      p_from_template_id    => wwv_flow.g_f23(i),      ',
'      p_to_template_id      => wwv_flow.g_f22(i)',
'      );',
'    if wwv_flow.g_f24(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_button_template (',
'        p_master_template_id         => wwv_flow.g_f23(i),',
'        p_subscribing_template_id    => wwv_flow.g_f22(i)',
'      );',
'    end if;    ',
'  end if;',
' end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al sustituir las plantillas de bot\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(36141207156187914.4001)
);
end;
/
prompt --application/pages/page_00223
begin
wwv_flow_api.create_page(
 p_id=>223.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Bot\00F3n: Nuevas Plantillas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(79037325082006306.4001)
,p_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id,',
'  template_name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',template_name) to_name,  ',
'  ''N'' Sub ',
'  from wwv_flow_button_templates ',
'  where flow_id = :F4000_P219_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P413_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ninguna plantilla de bot\00F3n.</font>')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291212700208110402.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291212812720110403.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291212910615110403.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291213012573110403.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291213126199110403.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79072408476013995.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186379505997200005.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79075916968016548.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186379505997200005.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79082801516021503.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186379505997200005.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar Plantillas de Bot\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_button_templates',
'where flow_id = :F4000_P219_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79079723548018440.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186379505997200005.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154569907771245074.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585127217510099835.4001)
,p_branch_action=>'f?p=&APP_ID.:413:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(79079723548018440.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74794830724628143.4001)
,p_name=>'P223_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(79037325082006306.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P413_COPY_TO_THEME.'
,p_prompt=>'Copiar en Tema:'
,p_source=>'P413_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291219023888126752.4001)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Debe seleccionar al menos una plantilla que copiar.',
'',
''))
,p_when_button_pressed=>wwv_flow_api.id(79082801516021503.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291223520902135378.4001)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select template_name',
'                  from wwv_flow_button_templates',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(79082801516021503.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585127098058099833.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(79075916968016548.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585127103134099834.4001)
,p_event_id=>wwv_flow_api.id(585127098058099833.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79487226696142335.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy button template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then   ',
'    wwv_flow_templates_util.copy_button_template (',
'      p_copy_from_flow_id    => :F4000_P219_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :FB_FLOW_ID,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p223_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) in (''SUBSCRIBE'') then',
'      wwv_flow_copy_metadata.subscribe_button_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar las plantillas de bot\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(79082801516021503.4001)
,p_process_success_message=>unistr('Plantillas de bot\00F3n copiadas.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(585126957721099832.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(79082801516021503.4001)
,p_process_success_message=>unistr('Plantillas de bot\00F3n copiadas.')
);
end;
/
prompt --application/pages/page_00224
begin
wwv_flow_api.create_page(
 p_id=>224.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar Tema'
,p_step_title=>'Exportar Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'exprt_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60514600060460890.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60520626473525286.4001)
,p_plug_name=>'Exportar Tema'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168864819843955649.4001)
,p_plug_name=>'Exportar Tema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205603713223283346.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(205602222789276628.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205606001233289349.4001)
,p_plug_name=>'Exportar Tema'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice esta p\00E1gina para exportar una definici\00F3n de temas a un archivo. Cuando haya exportado un tema, podr\00E1 importarlo.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486280919368630117.4001)
,p_plug_name=>unistr('Elegir Aplicaci\00F3n &REQUEST.')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>23
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60527206911557455.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168864819843955649.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486388619159589351.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(168864819843955649.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:224::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60522504786528459.4001)
,p_name=>'P224_A'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(486280919368630117.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'&P224_A.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST EXPORTABLE FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n que contenga el tema que desea exportar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60525717169550955.4001)
,p_name=>'P224_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(60520626473525286.4001)
,p_prompt=>'Exportar Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tema -'
,p_lov_null_value=>'%null%'
,p_lov_cascade_parent_items=>'P224_A'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60541507435595404.4001)
,p_name=>'P224_FILE_CHAR_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(60520626473525286.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Caracteres de Archivo:'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(241092122553560086.4001)
,p_name=>'P224_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(60520626473525286.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(937788573544878610.4001)
,p_validation_name=>'P244_THEME cannot be null'
,p_validation_sequence=>10
,p_validation=>'P224_THEME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_always_execute=>'Y'
,p_when_button_pressed=>wwv_flow_api.id(60527206911557455.4001)
,p_associated_item=>wwv_flow_api.id(60525717169550955.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651511347740755606.4001)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(60527206911557455.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651511401227755607.4001)
,p_event_id=>wwv_flow_api.id(651511347740755606.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(61027317326538036.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_theme (',
'    p_application_id => :P224_A, --:FB_FLOW_ID,',
'    p_theme_id       => :P224_THEME,',
'    p_format         => :P224_FORMAT );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al exportar el tema'
,p_process_when_button_id=>wwv_flow_api.id(60527206911557455.4001)
,p_process_success_message=>'Tema Exportado'
);
end;
/
prompt --application/pages/page_00225
begin
wwv_flow_api.create_page(
 p_id=>225.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de P\00E1gina: Identificar Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47949104472764295.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(151702327009495805.4001)
,p_plug_name=>unistr('Crear Plantilla de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(151702703807495809.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(151703906460495813.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47949104472764295.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(151704732582495820.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47949104472764295.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(151704327075495817.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47949104472764295.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(151710117394495850.4001)
,p_branch_action=>'f?p=&FLOW_ID.:144:&SESSION.::&DEBUG.:144::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(151704732582495820.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589949729811621442.4001)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(151704327075495817.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151705110557495822.4001)
,p_name=>'P225_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151705805378495835.4001)
,p_name=>'P225_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'F4000_P26_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151706501435495838.4001)
,p_name=>'P225_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151707203352495840.4001)
,p_name=>'P225_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151707901068495841.4001)
,p_name=>'P225_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151708610122495842.4001)
,p_name=>'P225_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P26_COPY_FROM_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151709323167495843.4001)
,p_name=>'P225_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(151702327009495805.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2461532381542560379.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P225_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589949594060621440.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(151703906460495813.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589949675059621441.4001)
,p_event_id=>wwv_flow_api.id(589949594060621440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00226
begin
wwv_flow_api.create_page(
 p_id=>226.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Prueba de Servicios Web'
,p_step_title=>'Prueba de Servicios Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30009431242804826.4001)
,p_plug_name=>'Elemento Envelope de SOAP'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30014321686887232.4001)
,p_plug_name=>unistr('Autenticaci\00F3n B\00E1sica')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''BASIC_AUTH''',
'   and ws_id = :F4000_P226_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86555214170536943.4001)
,p_plug_name=>'Identificar Servicio'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86556512445537718.4001)
,p_plug_name=>'Respuesta'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86575626438561642.4001)
,p_plug_name=>'Servicios Web'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />Seleccione el servicio web de la lista para probarlo.',
unistr('<p />Introduzca un nombre de usuario y una contrase\00F1a para el servicio web si aparece la regi\00F3n Autenticaci\00F3n B\00E1sica.'),
unistr('<p />Modifique el elemento Envelope de SOAP de la forma necesaria sustituyendo las referencias a #ITEM# por los valores est\00E1ticos que desea probar.'),
unistr('<p />Haga clic en Probar para probar el servicio web con el elemento Envelope de SOAP en el \00E1rea de texto. Compruebe los resultados en el \00E1rea de texto Resultado.'),
'<p />Haga clic en Editar para editar los atributos del servicio web.'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86560930207546868.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(86555214170536943.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86642432640623325.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(86555214170536943.4001)
,p_button_name=>'Clear'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Borrar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86677212171664689.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(86555214170536943.4001)
,p_button_name=>'Edit'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Editar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(86571505188558575.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(86555214170536943.4001)
,p_button_name=>'Test'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Probar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(190957021196827831.4001)
,p_branch_action=>'f?p=&FLOW_ID.:196:&SESSION.::&DEBUG.::F4000_P196_ID:&F4000_P226_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(86677212171664689.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(94641014947653996.4001)
,p_branch_action=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30010111287808515.4001)
,p_name=>'P226_ENVELOPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(30009431242804826.4001)
,p_prompt=>'Elemento Envelope de SOAP'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Esta \00E1rea de texto se rellena con el elemento Envelope de SOAP asociado a la referencia Web. Cambie las sustituciones de #ITEM# por valores est\00E1ticos para probar el servicio.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30016206233892256.4001)
,p_name=>'P226_USERNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(30014321686887232.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de usuario para autenticarse en este servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30017114891894760.4001)
,p_name=>'P226_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(30014321686887232.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a para autenticarse en este servicio Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86565409629554218.4001)
,p_name=>'F4000_P226_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(86555214170536943.4001)
,p_prompt=>'Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_flow_shared_web_services a',
' where (action != ''NEW_SCHOOL'' or action is null)',
'   and security_group_id = :flow_security_group_id',
'   and flow_id = :FB_FLOW_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Servicio Web -'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Seleccione el servicio Web que se va a probar.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86581914361567262.4001)
,p_name=>'F4000_P226_RESULT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(86556512445537718.4001)
,p_prompt=>'Resultado'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Esta \00E1rea de texto muestra la respuesta del servicio Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(86750631429787251.4001)
,p_name=>'F4000_P226_FORMATTED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(86555214170536943.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30011808695845624.4001)
,p_computation_sequence=>10
,p_computation_item=>'P226_ENVELOPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select soap_envelope',
'             from wwv_flow_shared_web_services',
'            where id = :F4000_P226_ID ) loop',
'  return wwv_flow_utilities.clob_to_varchar2(c1.soap_envelope);',
'end loop;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(86649910430629809.4001)
,p_validation_name=>'F4000_P226_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P226_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el servicio Web.'
,p_validation_condition=>'TEST,EDIT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(86565409629554218.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:57'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(86694028712682076.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear item'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4000_P226_RESULT:F4000_P226_FORMATTED'
,p_process_error_message=>'Error al borrar el resultado.'
,p_process_when_button_id=>wwv_flow_api.id(86642432640623325.4001)
,p_process_success_message=>'Resultado limpiado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(86593111545583751.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process web service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_response clob;',
'    l_response_var varchar2(32767);',
'    l_url varchar2(4000);',
'    l_action varchar2(4000);',
'    l_soap_version varchar2(30);',
'    l_proxy_override varchar2(4000);',
'    l_app_proxy varchar2(4000);',
'    l_wallet wwv_flow_security.t_wallet;',
'    l_env clob;',
'begin',
'',
'    l_env := :P226_ENVELOPE;',
'',
'    select url, action, nvl(soap_version,''1.1''), proxy_override ',
'      into l_url, l_action, l_soap_version, l_proxy_override',
'      from wwv_flow_shared_web_services',
'     where id = :f4000_p226_id;',
'    ',
'    l_app_proxy := wwv_flow_web_services.find_proxy(:FB_FLOW_ID);',
'',
'    l_wallet := wwv_flow_security.get_wallet;',
'',
'    if sys.dbms_lob.substr(l_env,5) != ''<?xml'' then',
'        l_env := ''<?xml version=''''1.0'''' encoding=''''UTF-8''''?>''||l_env;',
'    end if;',
'',
'    l_response := wwv_flow_web_services.make_request(',
'                      p_url            => l_url,',
'                      p_action         => l_action,',
'                      p_version        => l_soap_version,',
'                      p_envelope       => l_env,',
'                      p_username       => :P226_USERNAME,',
'                      p_password       => :P226_PASSWORD,',
'                      p_proxy_override => nvl(l_proxy_override,l_app_proxy),',
'                      p_wallet_path    => l_wallet.wallet_path,',
'                      p_wallet_pwd     => l_wallet.wallet_pwd);',
'    ',
'   l_response_var := wwv_flow_utilities.clob_to_varchar2(l_response);',
'   wwv_flow.update_cache_with_write(''F4000_P226_RESULT'',substr(l_response_var,1,32000));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al probar el servicio.'
,p_process_when_button_id=>wwv_flow_api.id(86571505188558575.4001)
,p_process_success_message=>'Servicio probado.'
);
end;
/
prompt --application/pages/page_00229
begin
wwv_flow_api.create_page(
 p_id=>229.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Tema'
,p_step_title=>'Suprimir Tema'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57687023301725935.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n de Tema')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>131
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'&nbsp;'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200244914821350562.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(928047061287850019.4001)
,p_plug_name=>'Suprimir Tema'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1029840900020751021.4001)
,p_plug_name=>'Lista de Progreso del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>151
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(1029750209782685847.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57687802420725937.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200244914821350562.4001)
,p_button_name=>'REMOVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir Tema'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57688224484725938.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200244914821350562.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57688618408725938.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200244914821350562.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(928046994220850018.4001)
,p_branch_name=>'Delete theme'
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57687802420725937.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57689007735725939.4001)
,p_name=>'P229_REMOVE_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57687023301725935.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Suprimir Tema:'
,p_source=>'P221_REMOVE_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id r from wwv_flow_themes where flow_id = :fb_flow_id'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57689530579725943.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_theme_manager.delete_theme(p_flow_id => :fb_flow_id, p_theme_id => :P221_REMOVE_THEME);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido eliminar el tema.'
,p_process_when_button_id=>wwv_flow_api.id(57687802420725937.4001)
,p_process_success_message=>'Tema eliminado.'
);
end;
/
prompt --application/pages/page_00231
begin
wwv_flow_api.create_page(
 p_id=>231.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Bot\00F3n: Nueva P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15144819360777868.4001)
,p_plug_name=>unistr('Copiar Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15214209943995787.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181185105878280365.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45386429462431518.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57468915890242535.4001)
,p_name=>unistr('Bot\00F3n Copiar de')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id,',
'flow_step_id,',
'BUTTON_IMAGE_ALT,',
'button_name,',
'(select plug_name from wwv_flow_page_plugs p where p.id = BUTTON_PLUG_ID) region,',
'button_sequence',
'from wwv_flow_step_buttons',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57469304915242540.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57469409747242540.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57469500241242540.4001)
,p_query_column_id=>3
,p_column_alias=>'BUTTON_IMAGE_ALT'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57469611870242540.4001)
,p_query_column_id=>4
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57469709405242540.4001)
,p_query_column_id=>5
,p_column_alias=>'REGION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57469801831242541.4001)
,p_query_column_id=>6
,p_column_alias=>'BUTTON_SEQUENCE'
,p_column_display_sequence=>6
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15147026417789395.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45386429462431518.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15149015120795592.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45386429462431518.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15149301379795595.4001)
,p_branch_action=>'191'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(15149015120795592.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15147314750789401.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(15147026417789395.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15151821485806920.4001)
,p_name=>'F4000_P231_COPY_FROM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15144819360777868.4001)
,p_prompt=>'Copy From Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15152400145810215.4001)
,p_name=>'F4000_P231_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15144819360777868.4001)
,p_prompt=>'Copy From Page Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15153410319822639.4001)
,p_name=>'F4000_P231_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15144819360777868.4001)
,p_prompt=>unistr('P\00E1gina de Destino')
,p_source=>'F4000_P231_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en el que desea copiar este bot\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15154627634827604.4001)
,p_validation_name=>'F4000_P231_COPY_TO_PAGE_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P231_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(15153410319822639.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-OCT-2002 11:50'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(167037203753942735.4001)
,p_validation_name=>'check page locks'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter ',
'           from wwv_flow_lock_page ',
'           where OBJECT_ID = :F4000_P231_COPY_TO_PAGE_ID ',
'           and flow_id = :fb_flow_id',
'           and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede copiar en una p\00E1gina bloqueada por otro usuario.')
,p_when_button_pressed=>wwv_flow_api.id(15149015120795592.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590120424992572040.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(15147026417789395.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590120588079572041.4001)
,p_event_id=>wwv_flow_api.id(590120424992572040.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00232
begin
wwv_flow_api.create_page(
 p_id=>232.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Eliminar componentes'
,p_page_mode=>'MODAL'
,p_step_title=>'Eliminar componentes'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'540'
,p_dialog_width=>'600'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(52410809441114515.4001)
,p_plug_name=>'Eliminar componentes'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('\00BFSeguro que desea eliminar de manera permanente todos los componentes de la aplicaci\00F3n asociados a esta opci\00F3n de creaci\00F3n?')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(52410779965114514.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(52410809441114515.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar componentes'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'disabled'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(52412315756114530.4001)
,p_branch_name=>'Branch to Build Option detail page'
,p_branch_action=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:RP,4911:F4000_P4911_ID:&F4000_P232_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52411111658114518.4001)
,p_name=>'F4000_P232_BUILDOPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(52410809441114515.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52411200670114519.4001)
,p_name=>'F4000_P232_BUILDOPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(52410809441114515.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(52411460330114521.4001)
,p_name=>'P232_CONFIRM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(52410809441114515.4001)
,p_prompt=>'Confirmar'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONFIRM_COMPONENT_REMOVAL'
,p_lov=>'.'||wwv_flow_api.id(54171005356999729.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(710589345112275246.4001)
,p_name=>'F4000_P232_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(52410809441114515.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(52411383228114520.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P232_BUILDOPT_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name ',
'from wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID and ',
'      id = :F4000_P232_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(52411930691114526.4001)
,p_validation_name=>'Must Confirm'
,p_validation_sequence=>10
,p_validation=>'P232_CONFIRM'
,p_validation2=>'Y'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Debe confirmar esta acci\00F3n para continuar.')
,p_associated_item=>wwv_flow_api.id(52411460330114521.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(52411544208114522.4001)
,p_name=>'Toggle Button'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P232_CONFIRM'
,p_condition_element=>'P232_CONFIRM'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52411668022114523.4001)
,p_event_id=>wwv_flow_api.id(52411544208114522.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(52410779965114514.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(52411837673114525.4001)
,p_event_id=>wwv_flow_api.id(52411544208114522.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(52410779965114514.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(52412220252114529.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_steps                where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_computations         where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_processing           where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from WWV_FLOW_ICON_BAR             where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from WWV_FLOW_LIST_ITEMS           where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_lists                where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_list_of_values_data  where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_templates            where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_combined_files       where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_page_plugs           where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_region_columns       where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_region_report_column where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_worksheet_columns    where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from WWV_FLOW_STEP_BUTTONS         where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from WWV_FLOW_STEP_ITEMS           where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_step_computations    where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_step_processing      where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_step_validations     where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_step_branches        where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_page_da_events       where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_jet_chart_series     where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from WWV_FLOW_TABS                 where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from WWV_FLOW_TOPLEVEL_TABS        where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;',
'delete from wwv_flow_app_settings         where flow_id = :FB_FLOW_ID and required_patch = :F4000_P232_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Componentes eliminados.'
);
end;
/
prompt --application/pages/page_00233
begin
wwv_flow_api.create_page(
 p_id=>233.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Publicaci\00F3n de Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Confirmar Publicaci\00F3n de Tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_height=>'360'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1403935393827712480.4001)
,p_plug_name=>'Dialog Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1403935974802712489.4001)
,p_plug_name=>unistr('Confirmar Publicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Confirme que desea publicar el tema actual en todas las aplicaciones que se muestran a continuaci\00F3n.</p>'),
unistr('<p>Si solo desea actualizar una selecci\00F3n de las aplicaciones, puede acceder a cada una de las aplicaciones que necesitan actualizaci\00F3n, navegar al tema y pulsar ''Refrescar''.</p>'),
'',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1119685869158584503.4001)
,p_name=>'Applications referencing this theme'
,p_parent_plug_id=>wwv_flow_api.id(1403935974802712489.4001)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.flow_id||'' - ''||f.name application, t.theme_name theme',
'from wwv_flow_themes t, wwv_flows f',
'where t.flow_id = f.id ',
'and t.reference_id = :P267_ID',
'order by t.flow_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119685953314584504.4001)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119686070366584505.4001)
,p_query_column_id=>2
,p_column_alias=>'THEME'
,p_column_display_sequence=>2
,p_column_heading=>'Tema'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1403935783744712486.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1403935393827712480.4001)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1403935552807712484.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1403935393827712480.4001)
,p_button_name=>'Publish'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar Tema'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1403936695369712499.4001)
,p_branch_name=>'back to theme edit page'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2411516663880763101.4001)
,p_name=>'Publish'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1403935552807712484.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2411516786718763102.4001)
,p_event_id=>wwv_flow_api.id(2411516663880763101.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PUBLISH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1403936180836712491.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'New'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1403935783744712486.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1403936356234712493.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Publish Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select id',
'              from wwv_flow_themes',
'             where reference_id = :P267_ID',
'               and security_group_id  = :WORKSPACE_ID',
'             order by flow_id, id',
') loop',
'    wwv_flow_copy_metadata.subscribe_theme (',
'        p_master_theme_id      => :P267_ID,',
'        p_subscribing_theme_id => c1.id',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al publicar el tema.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'PUBLISH'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'El tema se ha publicado.'
);
end;
/
prompt --application/pages/page_00235
begin
wwv_flow_api.create_page(
 p_id=>235.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Suprimir opci\00F3n de creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Suprimir opci\00F3n de creaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'540'
,p_dialog_width=>'600'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(121338939969762742.4001)
,p_plug_name=>'Eliminar componentes'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00BFSeguro que desea suprimir esta opci\00F3n de creaci\00F3n? Al suprimir una opci\00F3n de creaci\00F3n, los componentes asociados a la opci\00F3n no se suprimen.</p>'),
unistr('<p><em><strong>Nota:</strong> Antes de suprimir una opci\00F3n de creaci\00F3n, examine los componentes de aplicaci\00F3n de <strong>Componentes asociados</strong> para determinar si los componentes se deben eliminar antes de suprimir la opci\00F3n de creaci\00F3n. Para')
||' eliminar los componentes asociados, haga clic en <strong>Eliminar componentes</strong>.</em></p>',
'',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68928811043648234.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(121338939969762742.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir opci\00F3n de creaci\00F3n')
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(68933199182648259.4001)
,p_branch_name=>'Branch to Build Options Page'
,p_branch_action=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68929293853648237.4001)
,p_name=>'F4000_P235_BUILDOPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(121338939969762742.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68930012983648241.4001)
,p_name=>'F4000_P235_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(121338939969762742.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(68930582704648255.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P235_BUILDOPT_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name ',
'from wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID and ',
'      id = :F4000_P235_ID'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(68931622824648256.4001)
,p_name=>'Toggle Button'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P235_CONFIRM'
,p_condition_element=>'P235_CONFIRM'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(68932100741648258.4001)
,p_event_id=>wwv_flow_api.id(68931622824648256.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(68928811043648234.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(68932612611648258.4001)
,p_event_id=>wwv_flow_api.id(68931622824648256.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(68928811043648234.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(68931281860648255.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Build Option'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID and id = :F4000_P235_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(68928811043648234.4001)
,p_process_success_message=>unistr('Opci\00F3n de creaci\00F3n eliminada.')
);
end;
/
prompt --application/pages/page_00238
begin
wwv_flow_api.create_page(
 p_id=>238.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13969523414074532.4001)
,p_plug_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p> ')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14261632075088500.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186381516995222024.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13978319084082174.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186381516995222024.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13985114021090195.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186381516995222024.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19628203802864348.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186381516995222024.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14136003437250918.4001)
,p_branch_action=>'240'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(13985114021090195.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P238_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14393112708310279.4001)
,p_branch_action=>'241'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(13985114021090195.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P238_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585127954462099842.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19628203802864348.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13993128780102430.4001)
,p_name=>'F4000_P238_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13969523414074532.4001)
,p_item_default=>'COPY'
,p_prompt=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MENU_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(86077012626803751.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585127722299099840.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(13978319084082174.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585127887333099841.4001)
,p_event_id=>wwv_flow_api.id(585127722299099840.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00239
begin
wwv_flow_api.create_page(
 p_id=>239.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529572729351063216.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529574880602063240.4001)
,p_plug_name=>unistr('Regi\00F3n Maestra')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178084365704726537.4001)
,p_plug_name=>'Base de Datos Local'
,p_parent_plug_id=>wwv_flow_api.id(529574880602063240.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178084505516726539.4001)
,p_plug_name=>'Base de Datos Remota'
,p_parent_plug_id=>wwv_flow_api.id(529574880602063240.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183463552982452620.4001)
,p_plug_name=>'Tabla de servidor remoto'
,p_parent_plug_id=>wwv_flow_api.id(178084505516726539.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183461899797452603.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(529574880602063240.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183464019642452625.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(183461899797452603.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529586398598063265.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(42519297248600803.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529573505722063228.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(529572729351063216.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(513675427269698806.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(529572729351063216.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529574384748063229.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(529572729351063216.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P239_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(529603924741063318.4001)
,p_branch_name=>'Define detail region'
,p_branch_action=>'f?p=&APP_ID.:257:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(513675427269698806.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178084247951726536.4001)
,p_name=>'P239_MASTER_LOCATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(529574880602063240.4001)
,p_item_default=>'LOCAL'
,p_prompt=>unistr('Ubicaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Permite seleccionar el tipo de <em>origen de datos</em> para el maestro.',
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se originan en la base de datos local.</li>',
'    <li><strong>Servicio de SQL activado para REST</strong><br>',
unistr('    Los datos se originan en una base de datos remota, donde la conexi\00F3n se define utilizando el servicio SQL activado para REST. Para crear o conservar las referencias de SQL activadas para REST, acceda a Componentes compartidos, SQL activado para R')
||'EST.',
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos se originan en un servicio web RESTful que se ha definido utilizando or\00EDgenes de datos de REST. Para crear o conservar los or\00EDgenes de datos de REST, acceda a Componentes compartidos.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178084630228726540.4001)
,p_name=>'P239_MASTER_R_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P239_MASTER_R_SERVER, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178084779715726541.4001)
,p_name=>'P239_MASTER_R_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P239_MASTER_R_SERVER, ''TABLE'', :P239_MASTER_R_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P239_MASTER_R_OWNER'
,p_ajax_items_to_submit=>'P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la tabla o vista maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178084857351726542.4001)
,p_name=>'P239_MASTER_R_PK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_item_default=>'ROWID'
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P239_MASTER_R_OWNER,',
'      p_table_name        => :P239_MASTER_R_TABLE,',
'      p_remote_server_id  => :P239_MASTER_R_SERVER ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'ROWID'
,p_lov_null_value=>'ROWID'
,p_lov_cascade_parent_items=>'P239_MASTER_R_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_R_OWNER,P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178084917223726543.4001)
,p_name=>'P239_MASTER_R_PK2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P239_MASTER_R_OWNER,',
'      p_table_name        => :P239_MASTER_R_TABLE,',
'      p_remote_server_id  => :P239_MASTER_R_SERVER ) )',
' where column_name != :P239_MASTER_R_PK'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_R_TABLE,P239_MASTER_R_PK'
,p_ajax_items_to_submit=>'P239_MASTER_R_OWNER,P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178085048108726544.4001)
,p_name=>'P239_MASTER_R_NAV_ORDER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_prompt=>unistr('Orden de Navegaci\00F3n de Pantalla')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P239_MASTER_R_OWNER,',
'      p_table_name        => :P239_MASTER_R_TABLE,',
'      p_remote_server_id  => :P239_MASTER_R_SERVER ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_R_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_R_OWNER,P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_TWO_PG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna de orden de navegaci\00F3n utilizada por los botones Anterior y Siguiente de la p\00E1gina de detalle, que navega a un registro maestro diferente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178085136169726545.4001)
,p_name=>'P239_MASTER_R_COLUMNS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''REMOTE'',',
'                  p_remote_server_id  => :P239_MASTER_R_SERVER,',
'                  p_owner             => :P239_MASTER_R_OWNER,',
'                  p_table_name        => :P239_MASTER_R_TABLE,',
'                  p_query_type        => ''TABLE'' ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;',
'',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P239_MASTER_R_OWNER,',
'      p_table_name        => :P239_MASTER_R_TABLE,',
'      p_remote_server_id  => :P239_MASTER_R_SERVER ) )'))
,p_lov_cascade_parent_items=>'P239_MASTER_R_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_R_OWNER,P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178085281250726546.4001)
,p_name=>'P239_MASTER_R_SERVER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178084505516726539.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el servicio de SQL activado para REST que se utilizar\00E1.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183462178259452606.4001)
,p_name=>'P239_MASTER_W_PK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(183464019642452625.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila en el origen de datos de REST.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183462235662452607.4001)
,p_name=>'P239_MASTER_W_PK2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(183464019642452625.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
' where column_name != :P239_MASTER_W_PK'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_W_WEB_SRC,P239_MASTER_W_PK'
,p_ajax_items_to_submit=>'P239_MASTER_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila en el origen de datos de REST.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183462326546452608.4001)
,p_name=>'P239_MASTER_W_NAV_ORDER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(183464019642452625.4001)
,p_prompt=>unistr('Orden de Navegaci\00F3n de Pantalla')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_TWO_PG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna de orden de navegaci\00F3n utilizada por los botones Anterior y Siguiente de la p\00E1gina de detalle, que navega a un registro maestro diferente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183462425131452609.4001)
,p_name=>'P239_MASTER_W_COLUMNS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(183464019642452625.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'        from table(wwv_flow_exec_dev.get_query_columns(',
'                       p_location             => ''WEB_SOURCE'',',
'                       p_query_type           => null,',
'                       p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
''))
,p_lov_cascade_parent_items=>'P239_MASTER_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183463957434452624.4001)
,p_name=>'P239_MASTER_W_WEB_SRC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(183461899797452603.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id as r',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccione -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el origen de datos de REST que se va a utilizar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(513678791286698839.4001)
,p_name=>'P239_MASTER_PK2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE',
'   and column_name != :P239_MASTER_PK'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_TABLE,P239_MASTER_PK'
,p_ajax_items_to_submit=>'P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529575266326063241.4001)
,p_name=>'P239_MASTER_REGION_TITLE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(529574880602063240.4001)
,p_prompt=>unistr('T\00EDtulo de Regi\00F3n Maestra')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_SINGLE_PG:MD_EMAIL_STYLE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la regi\00F3n maestra.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529576435064063251.4001)
,p_name=>'P239_MASTER_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Esquema -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529577373429063253.4001)
,p_name=>'P239_MASTER_TABLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P239_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P239_MASTER_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la p\00E1gina maestra. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529578201497063255.4001)
,p_name=>'P239_MASTER_COLUMNS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    if :P239_MASTER_OWNER is not null and :P239_MASTER_TABLE is not null then',
'        for l_column in (',
'            select column_name',
'              from wwv_flow_table_columns_dev',
'             where owner      = :P239_MASTER_OWNER',
'               and table_name = :P239_MASTER_TABLE',
'        ) loop',
'            l_columns := l_columns || l_column.column_name || '':'';',
'        end loop;',
'    end if;',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P239_MASTER_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE',
'   and :P239_MASTER_TABLE is not null'))
,p_lov_cascade_parent_items=>'P239_MASTER_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529581806910063260.4001)
,p_name=>'P239_MASTER_PK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'ROWID'
,p_lov_null_value=>'ROWID'
,p_lov_cascade_parent_items=>'P239_MASTER_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(650879489910770406.4001)
,p_name=>'P239_MASTER_NAV_ORDER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_prompt=>unistr('Orden de Navegaci\00F3n de Pantalla')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_TWO_PG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna de orden de navegaci\00F3n utilizada por los botones Anterior y Siguiente de la p\00E1gina de detalle, que navega a un registro maestro diferente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389355879420632933.4001)
,p_name=>'P239_MASTER_DISP_COL1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n primaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna primaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389355931912632934.4001)
,p_name=>'P239_MASTER_DISP_COL2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(178084365704726537.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n secundaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P239_MASTER_OWNER',
'   and table_name = :P239_MASTER_TABLE',
'   and column_name !=:P239_MASTER_DISP_COL1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_DISP_COL1'
,p_ajax_items_to_submit=>'P239_MASTER_TABLE,P239_MASTER_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna secundaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389356037665632935.4001)
,p_name=>'P239_MASTER_R_DISP_COL1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n primaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P239_MASTER_R_OWNER,',
'      p_table_name        => :P239_MASTER_R_TABLE,',
'      p_remote_server_id  => :P239_MASTER_R_SERVER ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_R_TABLE'
,p_ajax_items_to_submit=>'P239_MASTER_R_OWNER,P239_MASTER_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna primaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389356171095632936.4001)
,p_name=>'P239_MASTER_R_DISP_COL2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(183463552982452620.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n secundaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P239_MASTER_R_OWNER,',
'      p_table_name        => :P239_MASTER_R_TABLE,',
'      p_remote_server_id  => :P239_MASTER_R_SERVER ) )',
'where column_name != :P239_MASTER_R_DISP_COL1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_R_DISP_COL1'
,p_ajax_items_to_submit=>'P239_MASTER_R_OWNER,P239_MASTER_R_SERVER,P239_MASTER_R_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna secundaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389356225215632937.4001)
,p_name=>'P239_MASTER_W_DISP_COL1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(183464019642452625.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n primaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna primaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389356378959632938.4001)
,p_name=>'P239_MASTER_W_DISP_COL2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(183464019642452625.4001)
,p_prompt=>unistr('Columna de visualizaci\00F3n secundaria')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
'where column_name != :P239_MASTER_W_DISP_COL1',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P239_MASTER_W_DISP_COL1'
,p_ajax_items_to_submit=>'P239_MASTER_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna que desea mostrar como columna secundaria en el informe para navegar a un registro maestro diferente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4389356808493632943.4001)
,p_name=>'P239_BACK_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(529574880602063240.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4389356941917632944.4001)
,p_computation_sequence=>10
,p_computation_item=>'P239_BACK_TO_PAGE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P29_MD_TYPE = ''MD_EMAIL_STYLE'' then ''99'' else ''4716'' end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(529588152682063290.4001)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P239_MASTER_OWNER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183464817103452633.4001)
,p_validation_name=>'Local Table Name NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P239_MASTER_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(529577373429063253.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(610851298793282103.4001)
,p_validation_name=>'Chosen Table exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P239_MASTER_OWNER',
'   and object_name = :P239_MASTER_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P239_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P239_MASTER_LOCATION = ''LOCAL'' and :P239_MASTER_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(529577373429063253.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465073641452635.4001)
,p_validation_name=>'Local PK Column 1 NOT NULL'
,p_validation_sequence=>40
,p_validation=>'P239_MASTER_PK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(529581806910063260.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74473376501949610.4001)
,p_validation_name=>'Local Primary Display NOT NULL'
,p_validation_sequence=>50
,p_validation=>'P239_MASTER_DISP_COL1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P29_MD_TYPE = ''MD_EMAIL_STYLE'' and :P239_MASTER_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(4389355879420632933.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(422533307257564418.4001)
,p_validation_name=>'No ROWID for Side-by-Side MD'
,p_validation_sequence=>60
,p_validation=>'P239_MASTER_PK'
,p_validation2=>'ROWID'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'No se soporta ROWID como clave maestra para maestro detalle en paralelo.'
,p_validation_condition=>':P29_MD_TYPE = ''MD_EMAIL_STYLE'' and :P239_MASTER_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(529581806910063260.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(422533444779564419.4001)
,p_validation_name=>'No ROWID for Side-by-Side MD Remote'
,p_validation_sequence=>70
,p_validation=>'P239_MASTER_R_PK'
,p_validation2=>'ROWID'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'No se soporta ROWID como clave maestra para maestro detalle en paralelo.'
,p_validation_condition=>':P29_MD_TYPE = ''MD_EMAIL_STYLE'' and :P239_MASTER_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(178084857351726542.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465163343452636.4001)
,p_validation_name=>'Local Form Nav Order NOT NULL'
,p_validation_sequence=>80
,p_validation=>'P239_MASTER_NAV_ORDER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P29_MD_TYPE = ''MD_TWO_PG'' and :P239_MASTER_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(650879489910770406.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465291238452637.4001)
,p_validation_name=>'Local Columns NOT NULL'
,p_validation_sequence=>90
,p_validation=>'P239_MASTER_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(529578201497063255.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465311138452638.4001)
,p_validation_name=>'Remote Server NOT NULL'
,p_validation_sequence=>100
,p_validation=>'P239_MASTER_R_SERVER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(178085281250726546.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465898720452643.4001)
,p_validation_name=>'Remote Table Name NOT NULL'
,p_validation_sequence=>110
,p_validation=>'P239_MASTER_R_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(178084779715726541.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465492656452639.4001)
,p_validation_name=>'Remote PK Column 1 NOT NULL'
,p_validation_sequence=>120
,p_validation=>'P239_MASTER_R_PK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(178084857351726542.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74473487222949611.4001)
,p_validation_name=>'Remote Master Display Column NOT NULL'
,p_validation_sequence=>130
,p_validation=>'P239_MASTER_R_DISP_COL1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P29_MD_TYPE = ''MD_EMAIL_STYLE'' and :P239_MASTER_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(4389356037665632935.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465593780452640.4001)
,p_validation_name=>'Remote Form Nav Order NOT NULL'
,p_validation_sequence=>140
,p_validation=>'P239_MASTER_R_NAV_ORDER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P29_MD_TYPE = ''MD_TWO_PG'' and :P239_MASTER_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(178085048108726544.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465766279452642.4001)
,p_validation_name=>'Remote Columns NOT NULL'
,p_validation_sequence=>150
,p_validation=>'P239_MASTER_R_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(178085136169726545.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183465979455452644.4001)
,p_validation_name=>'Web Src Module ID NOT NULL'
,p_validation_sequence=>160
,p_validation=>'P239_MASTER_W_WEB_SRC'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(183463957434452624.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183466056673452645.4001)
,p_validation_name=>'Web Src PK Column 1 NOT NULL'
,p_validation_sequence=>170
,p_validation=>'P239_MASTER_W_PK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(183462178259452606.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74473536122949612.4001)
,p_validation_name=>'Web Src Master Display Column NOT NULL'
,p_validation_sequence=>180
,p_validation=>'P239_MASTER_W_DISP_COL1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P29_MD_TYPE = ''MD_EMAIL_STYLE'' and :P239_MASTER_LOCATION = ''WEB_SOURCE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(4389356225215632937.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183466194253452646.4001)
,p_validation_name=>'Web Src Form Nav Order NOT NULL'
,p_validation_sequence=>190
,p_validation=>'P239_MASTER_W_NAV_ORDER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P29_MD_TYPE = ''MD_TWO_PG'' and :P239_MASTER_LOCATION = ''WEB_SOURCE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(183462326546452608.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183466268483452647.4001)
,p_validation_name=>'Web Src Columns NOT NULL'
,p_validation_sequence=>200
,p_validation=>'P239_MASTER_W_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P239_MASTER_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(513675427269698806.4001)
,p_associated_item=>wwv_flow_api.id(183462425131452609.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(529594811962063302.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(529573505722063228.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(529595326807063303.4001)
,p_event_id=>wwv_flow_api.id(529594811962063302.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(513678591058698837.4001)
,p_name=>'if pk1 is ROWID don''t show pk2'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_PK'
,p_condition_element=>'P239_MASTER_PK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ROWID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513678601888698838.4001)
,p_event_id=>wwv_flow_api.id(513678591058698837.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P239_MASTER_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513678828231698840.4001)
,p_event_id=>wwv_flow_api.id(513678591058698837.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P239_MASTER_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183462996152452614.4001)
,p_name=>'if pk1 is ROWID don''t show pk2_1'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_R_PK'
,p_condition_element=>'P239_MASTER_R_PK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ROWID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183463036358452615.4001)
,p_event_id=>wwv_flow_api.id(183462996152452614.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P239_MASTER_R_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183463116162452616.4001)
,p_event_id=>wwv_flow_api.id(183462996152452614.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P239_MASTER_R_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(178085393859726547.4001)
,p_name=>'Location LOCAL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_LOCATION'
,p_condition_element=>'P239_MASTER_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(178085470240726548.4001)
,p_event_id=>wwv_flow_api.id(178085393859726547.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(178084365704726537.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(178085558344726549.4001)
,p_event_id=>wwv_flow_api.id(178085393859726547.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(178084365704726537.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(178085619642726550.4001)
,p_name=>'Location REMOTE'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_LOCATION'
,p_condition_element=>'P239_MASTER_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183461604518452601.4001)
,p_event_id=>wwv_flow_api.id(178085619642726550.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(178084505516726539.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183461704079452602.4001)
,p_event_id=>wwv_flow_api.id(178085619642726550.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(178084505516726539.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183462660753452611.4001)
,p_name=>'Location WEB_SOURCE'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_LOCATION'
,p_condition_element=>'P239_MASTER_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183462735628452612.4001)
,p_event_id=>wwv_flow_api.id(183462660753452611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183461899797452603.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183462849367452613.4001)
,p_event_id=>wwv_flow_api.id(183462660753452611.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183461899797452603.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183463277185452617.4001)
,p_name=>'Show REST Data Source PK2'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_W_PK'
,p_condition_element=>'P239_MASTER_W_PK'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183463323055452618.4001)
,p_event_id=>wwv_flow_api.id(183463277185452617.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P239_MASTER_W_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183463435019452619.4001)
,p_event_id=>wwv_flow_api.id(183463277185452617.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P239_MASTER_W_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183463626616452621.4001)
,p_name=>'Remote Server IS NOT NULL'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_R_SERVER'
,p_condition_element=>'P239_MASTER_R_SERVER'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183463749167452622.4001)
,p_event_id=>wwv_flow_api.id(183463626616452621.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183463552982452620.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183463895408452623.4001)
,p_event_id=>wwv_flow_api.id(183463626616452621.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183463552982452620.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183464260819452627.4001)
,p_name=>'REST Data Source NOT NULL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P239_MASTER_W_WEB_SRC'
,p_condition_element=>'P239_MASTER_W_WEB_SRC'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183464383286452628.4001)
,p_event_id=>wwv_flow_api.id(183464260819452627.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183464019642452625.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183464438122452629.4001)
,p_event_id=>wwv_flow_api.id(183464260819452627.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183464019642452625.4001)
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00240
begin
wwv_flow_api.create_page(
 p_id=>240.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n: Nombre')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14175805433447528.4001)
,p_plug_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14274001223118093.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186385628039272606.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14181305971456820.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186385628039272606.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14189708180466946.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186385628039272606.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14183617745460281.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186385628039272606.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112031716983250230.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589886029832923005.4001)
,p_branch_action=>'f?p=&APP_ID.:238:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(14183617745460281.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112069011358267587.4001)
,p_name=>'P240_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14175805433447528.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el nombre de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112072422786270823.4001)
,p_name=>'P240_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(14175805433447528.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112074006987275731.4001)
,p_name=>'P240_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(14175805433447528.4001)
,p_prompt=>'Clase de Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43945521366272493.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la clase de tema.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112075517723278843.4001)
,p_validation_name=>'P240_NAME'
,p_validation_sequence=>10
,p_validation=>'P240_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(14189708180466946.4001)
,p_associated_item=>wwv_flow_api.id(112069011358267587.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112076824649280811.4001)
,p_validation_name=>'P240_THEME'
,p_validation_sequence=>20
,p_validation=>'P240_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(14189708180466946.4001)
,p_associated_item=>wwv_flow_api.id(112072422786270823.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112077931575282803.4001)
,p_validation_name=>'P240_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P240_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(14189708180466946.4001)
,p_associated_item=>wwv_flow_api.id(112074006987275731.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589885886073923003.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(14181305971456820.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589885904729923004.4001)
,p_event_id=>wwv_flow_api.id(589885886073923003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14217027084862962.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Menu Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_menu_template (',
'    p_flow_id                  => :FB_FLOW_ID,',
'    p_name                     => :p240_name,',
'    p_before_first             => null,',
'    p_current_page_option      => ''#NAME#'',',
'    p_non_current_page_option  => ''<a href="#LINK#">#NAME#</a>'',',
'    p_menu_link_attributes     => null,',
'    p_between_levels           => ''&nbsp;&gt;&nbsp;'',',
'    p_after_last               => null,',
'    p_max_levels               => ''12'',',
'    p_start_with_node          => ''PARENT_TO_LEAF'',',
'    p_template_comments        => null,',
'    p_theme_id                 => :p240_theme,',
'    p_theme_class_id           => :p240_theme_class',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha creado la plantilla.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(14189708180466946.4001)
,p_process_success_message=>'Plantilla creada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(589886105719923006.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(14189708180466946.4001)
,p_process_success_message=>'Plantilla creada.'
);
end;
/
prompt --application/pages/page_00241
begin
wwv_flow_api.create_page(
 p_id=>241.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n: Copiar de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14294921673154184.4001)
,p_plug_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14405005147328943.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186382517472231644.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14299931943164561.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186382517472231644.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14307302423174944.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186382517472231644.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14304726879172555.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186382517472231644.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154589123326372523.4001)
,p_branch_action=>'f?p=&FLOW_ID.:415:&SESSION.::&DEBUG.:415::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585128297727099845.4001)
,p_branch_action=>'f?p=&APP_ID.:238:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(14304726879172555.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14312919048200907.4001)
,p_name=>'F4000_P241_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14294921673154184.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(14316405677207154.4001)
,p_validation_name=>'F4000_P241_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P241_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(14312919048200907.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-MAY-2002 14:33'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585128061850099843.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(14299931943164561.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585128114394099844.4001)
,p_event_id=>wwv_flow_api.id(585128061850099843.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00242
begin
wwv_flow_api.create_page(
 p_id=>242.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n: Nuevas Plantillas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14328329375226565.4001)
,p_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id, ',
'  NAME from_name, ',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name) to_name,    ',
'  ''N'' sub  ',
'  from wwv_flow_menu_templates ',
'  where flow_id = :F4000_P241_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P415_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ninguna plantilla de men\00FA.</font>')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289924820743181091.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289924904419181091.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289925026455181091.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289925102472181092.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289925221463181092.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14407300618331077.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186384617042250444.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14333306326232888.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186384617042250444.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14344019270246074.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186384617042250444.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar Plantilla de Ruta de Navegaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14335916368235731.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186384617042250444.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154595529953402877.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589885623218923001.4001)
,p_branch_action=>'f?p=&APP_ID.:415:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(14335916368235731.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74799021851635044.4001)
,p_name=>'P242_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(14328329375226565.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P415_COPY_TO_THEME.'
,p_prompt=>'Copiar en Tema:'
,p_source=>'P415_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(150693609086071855.4001)
,p_validation_name=>'MustSelectOne'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos una plantilla que copiar.'
,p_when_button_pressed=>wwv_flow_api.id(14344019270246074.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(106471827081351272.4001)
,p_validation_name=>'TemplateNameNotNull'
,p_validation_sequence=>15
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      if wwv_flow.g_f02(i) is null then',
'        return false;',
'      end if;',
'    end if;',
'  end loop;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe proporcionar un nombre de plantilla para todas las plantillas que se han seleccionado para copiar.'
,p_when_button_pressed=>wwv_flow_api.id(14344019270246074.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(290023816157198599.4001)
,p_validation_name=>'NoDupeNames'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select name',
'                  from wwv_flow_menu_templates ',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and name = wwv_flow.g_f02(i) ) loop',
'         if c1.name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(14344019270246074.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585128652833099849.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(14333306326232888.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585128729853099850.4001)
,p_event_id=>wwv_flow_api.id(585128652833099849.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14419108154342723.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy menu templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_menu_template (',
'      p_copy_from_flow_id    => :F4000_P241_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :FB_FLOW_ID,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p242_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE''));',
'    if wwv_flow.g_f03(i) in (''SUBSCRIBE'') then',
'      wwv_flow_copy_metadata.subscribe_menu_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar las plantillas de ruta de navegaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(14344019270246074.4001)
,p_process_success_message=>unistr('Plantillas de ruta de navegaci\00F3n copiadas.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(589885733937923002.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(14344019270246074.4001)
,p_process_success_message=>unistr('Plantillas de ruta de navegaci\00F3n copiadas.')
);
end;
/
prompt --application/pages/page_00243
begin
wwv_flow_api.create_page(
 p_id=>243.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Edici\00F3n de Cuadr\00EDculas de P\00E1ginas')
,p_step_title=>unistr('Edici\00F3n de Cuadr\00EDculas de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5467424850229114.4001)
,p_name=>'Edit Pages not locked by others'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'ID,',
'FLOW_ID,',
'''<a href="f?p=4000:4500:''||:flow_session||''::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:''||flow_id||'',''||ID||',
'    ''"><span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''WWV_FLOW.EDIT'')||',
'    ''</span>'' edit_link,',
'ID display_pk1,',
'NAME,',
'ALIAS,',
'STEP_TITLE,',
'STEP_TEMPLATE,',
'REQUIRED_ROLE',
'from WWV_FLOW_STEPS s',
'where flow_id = :FB_FLOW_ID',
'  and user_interface_id = :P243_USER_INTERFACE_ID',
'  and (',
'   :P243_TITLE is null or instr(upper(step_title),upper(:P243_TITLE)) > 0)',
'and not exists (select object_id from wwv_flow_lock_page where flow_id = :fb_flow_id and object_id = s.id and locked_by != :app_user) ',
'order by ID'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 01-OCT-2002 09:13:02'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48669801704771571.4001)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48669912730771571.4001)
,p_query_column_id=>2
,p_form_element_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670002444771571.4001)
,p_query_column_id=>3
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>3
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670109803771572.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_PK1'
,p_column_display_sequence=>4
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670223213771572.4001)
,p_query_column_id=>5
,p_form_element_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670324303771572.4001)
,p_query_column_id=>6
,p_form_element_id=>4
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>6
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670413729771572.4001)
,p_query_column_id=>7
,p_form_element_id=>5
,p_column_alias=>'STEP_TITLE'
,p_column_display_sequence=>7
,p_column_heading=>unistr('T\00EDtulo')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670611259771572.4001)
,p_query_column_id=>8
,p_form_element_id=>7
,p_column_alias=>'STEP_TEMPLATE'
,p_column_display_sequence=>8
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select theme_id||''. ''||wwv_flow_escape.html(name) d,id from wwv_flow_templates where flow_id = :FB_FLOW_ID and theme_id = :fb_theme_id'
,p_lov_show_nulls=>'YES'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48670711533771572.4001)
,p_query_column_id=>9
,p_form_element_id=>8
,p_column_alias=>'REQUIRED_ROLE'
,p_column_display_sequence=>9
,p_column_heading=>'Seguridad'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''MUST_NOT_BE_PUBLIC_USER'' d,''MUST_NOT_BE_PUBLIC_USER'' r from dual',
'union all',
'select substr(wwv_flow_escape.html(name),1,50),to_char(id)',
'from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'union all',
'select ''{''||wwv_flow_lang.system_message(''NOT'') ||''}''||substr(wwv_flow_escape.html(name),1,50) d, ''!''||to_char(id) r',
'from   wwv_flow_security_schemes ',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_show_nulls=>'YES'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5467718332229117.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5467802033229117.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5481815669365490.4001)
,p_column_sequence=>3
,p_query_column_name=>'EDIT_LINK'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5467901089229117.4001)
,p_column_sequence=>4
,p_query_column_name=>'DISPLAY_PK1'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5468009414229117.4001)
,p_column_sequence=>5
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5468129995229117.4001)
,p_column_sequence=>6
,p_query_column_name=>'ALIAS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5468226850229117.4001)
,p_column_sequence=>7
,p_query_column_name=>'STEP_TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5527803835685178.4001)
,p_column_sequence=>8
,p_query_column_name=>'STEP_TEMPLATE'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select name,id from wwv_flow_templates where flow_id = :FB_FLOW_ID'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(5468506333229118.4001)
,p_column_sequence=>9
,p_query_column_name=>'REQUIRED_ROLE'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select name,id from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5470606040316859.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78080912354384260.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(5470606040316859.4001)
,p_button_name=>'P243_GO'
,p_button_static_id=>'P243_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5468710530229118.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5470606040316859.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5492404196458243.4001)
,p_branch_action=>'243'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5623004963969526.4001)
,p_name=>'P243_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5470606040316859.4001)
,p_prompt=>'Interfaz de Usuario'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'USER INTERFACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.display_name,',
'       i.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78080303004381558.4001)
,p_name=>'P243_TITLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5470606040316859.4001)
,p_prompt=>unistr('El T\00EDtulo Contiene')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca los criterios de consulta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5624727043994823.4001)
,p_computation_sequence=>5
,p_computation_item=>'P243_USER_INTERFACE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5475129720333095.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'243'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(157587721255898301.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P243_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185740105422203168.4001)
,p_validation_name=>'page names not null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_message varchar2(255) := null;',
'begin',
'  for i in 1..wwv_flow.g_f03.count loop',
'    if wwv_flow.g_f03(i) is null then',
'      l_message := wwv_flow_lang.system_message(''PAGE_NAME_REQUIRED'');',
'    end if;',
'  end loop;',
'  return l_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error'
,p_when_button_pressed=>wwv_flow_api.id(5468710530229118.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20814230009966815.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(5467424850229114.4001)
,p_validation_name=>'No duplicate page aliases'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from WWV_FLOW_STEPS s',
' where flow_id            = :FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and alias              = upper(:ALIAS)',
'   and id                != :ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El alias de p\00E1gina ya est\00E1 en uso para otra p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(5468710530229118.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'ALIAS'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4604617806261567.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination 2'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5469228085229125.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(5467424850229114.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEPS'
,p_attribute_03=>'ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(5468710530229118.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_process_comment=>'Generated 01-OCT-2002 09:13:02'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5513308801592065.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'RESET_PG'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00246
begin
wwv_flow_api.create_page(
 p_id=>246.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Buscador de Elementos'
,p_step_title=>'Buscador de Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function passBack(pValue)',
'{',
'  var lTargetField = window.opener.document.getElementById($v(''F4000_P246_CALLING_FIELD''));',
'  try {',
'    if ($v(''P246_APPEND'') === ''Y'') {',
'      opener.$s(lTargetField, lTargetField.value + ((lTargetField.value != "")?",":"") + pValue);',
'    } else {',
'      opener.$s(lTargetField, pValue);',
'    }',
'  } catch(e) {}',
'  lTargetField.focus();',
'  close();',
'};'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14708111879935279.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14709513852935304.4001)
,p_name=>'Elementos'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name1 , t.msg t, 0 p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') msg from dual) t',
'where (instr(name,upper(:F4000_P246_SEARCH)) > 0 OR :F4000_P246_SEARCH IS NULL) and',
'   :F4000_P246_PAGE is null',
'and flow_id = :fb_flow_id',
'union all',
'select ''<a href="javascript:passBack(''||wwv_flow_escape.js_literal(name)||'');">''||wwv_flow_escape.html(name)||''</a>'' name1 , t.msg t, flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') msg from dual) t',
'where (instr(name,upper(:F4000_P246_SEARCH)) > 0 OR :F4000_P246_SEARCH IS NULL) and',
'   (:F4000_P246_PAGE is null or :F4000_P246_PAGE = flow_step_id)',
'and flow_id = :fb_flow_id',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_num_rows_item=>'F4000_P246_MAX_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48614319501771198.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME1'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48614431969771198.4001)
,p_query_column_id=>2
,p_column_alias=>'T'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48614511956771198.4001)
,p_query_column_id=>3
,p_column_alias=>'P'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14709231916935300.4001)
,p_button_sequence=>119
,p_button_plug_id=>wwv_flow_api.id(14708111879935279.4001)
,p_button_name=>'F4000_P246_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14711003638935348.4001)
,p_branch_action=>'246'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6543623047119484.4001)
,p_name=>'P246_APPEND'
,p_item_sequence=>129
,p_item_plug_id=>wwv_flow_api.id(14709513852935304.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14708325447935287.4001)
,p_name=>'F4000_P246_SEARCH'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(14708111879935279.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14708614977935296.4001)
,p_name=>'F4000_P246_PAGE'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(14708111879935279.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>2000
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1gina de la aplicaci\00F3n. Para cambiar el n\00FAmero de p\00E1gina, seleccione o introduzca un nuevo n\00FAmero y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14708917076935296.4001)
,p_name=>'F4000_P246_MAX_ROWS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(14708111879935279.4001)
,p_item_default=>'15'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14718624586974892.4001)
,p_name=>'F4000_P246_CALLING_FIELD'
,p_item_sequence=>109
,p_item_plug_id=>wwv_flow_api.id(14709513852935304.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1410028720582325.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P246_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'     if REGEXP_LIKE(:F4000_P246_PAGE,''^[0-9]*$'')  then  ',
'        return :F4000_P246_PAGE;',
'     else',
'         return null;',
'     end if;',
'exception when others then ',
'   return null;',
'end ;'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14711323676935353.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00247
begin
wwv_flow_api.create_page(
 p_id=>247.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Origen de Regi\00F3n de Consulta SQL')
,p_step_title=>unistr('Origen de Regi\00F3n de Consulta SQL')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1255819686143641.4001)
,p_plug_name=>'Regiones SQL'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>131
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, ',
'       plug_name, ',
'       ''<div class="code_text">''||',
'       wwv_flow_escape.html_trunc(plug_source,3000)||',
'       ''</div>'' Source,',
'       sys.dbms_lob.getlength(plug_source) query_length,',
'       id,',
'       page_id the_page_id,',
'       (select name from wwv_flow_steps where id = r.page_id and flow_id = r.flow_id) page_name,',
'       decode(plug_source_type,',
'         ''NATIVE_SQL_REPORT'',''SQL Report'',',
'         ''NATIVE_TABFORM'',''Tabular Form'',',
'         ''NATIVE_IR'',''Interactive Report'') report_type',
'from wwv_flow_page_plugs r',
'where flow_id = :fb_flow_id and',
'      plug_source_type in (',
'        ''NATIVE_IR'',',
'        ''NATIVE_SQL_REPORT'',',
'        ''NATIVE_TABFORM'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1255909022143641.4001)
,p_name=>'SQL Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1256128235143643.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1256219291143643.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1256324881143643.4001)
,p_db_column_name=>'SOURCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Origen de Regi\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1256430754143643.4001)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1256501723143643.4001)
,p_db_column_name=>'THE_PAGE_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1257615795150784.4001)
,p_db_column_name=>'QUERY_LENGTH'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Longitud de Consulta'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1260513895188084.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1260622237188085.4001)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Tipo de Informe'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193876207596585492.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193879222365655926.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1255819686143641.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:247:&SESSION.::&DEBUG.:247,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(240716413858904681.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'247'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00249
begin
wwv_flow_api.create_page(
 p_id=>249.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Atributos de Regi\00F3n')
,p_step_title=>unistr('Atributos de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1223327285547695.4001)
,p_plug_name=>unistr('Atributos de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>140
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, ',
'       (select name from wwv_flow_steps ',
'        where flow_id = p.flow_id and id = p.page_id) page_name,',
'       plug_header region_header,',
'       plug_footer region_footer,',
'       id region_id,',
'       p.flow_id application_id, ',
'       p.plug_name region_name,',
'       p.PLUG_SOURCE_TYPE,',
'   decode(replace(replace(',
'     PLUG_DISPLAY_CONDITION_TYPE,''%''||''null%'',null),''0'',null),',
'      null,''No'',''Yes'') is_conditional,',
'decode(plug_source_type,',
'''NATIVE_SQL_REPORT'',''SQL Report'',',
'''NATIVE_TABFORM'',''Tabular Form'',',
'''NATIVE_IR'',''Interactive Report'',',
'null) report_type,',
'decode(plug_source_type,',
'''NATIVE_SQL_REPORT'',''Yes'',',
'''NATIVE_TABFORM'',''Yes'',',
'''NATIVE_IR'',''Yes'',',
'''No'') is_report,',
'       p.PLUG_DISPLAY_SEQUENCE display_sequence,',
'       (select	 WWV_FLOW_ROW_TEMPLATES.ROW_TEMPLATE_NAME',
'        from     WWV_FLOW_ROW_TEMPLATES',
'        where    WWV_FLOW_ROW_TEMPLATES.ID = p.plug_query_row_template)',
'       report_template,',
'       p.plug_query_row_template report_template_id,',
'       PRN_OUTPUT,',
'       last_updated_on,',
'       last_updated_by,',
'       sys.dbms_lob.getlength(PLUG_SOURCE) source_size,',
'       sys.dbms_lob.substr(plug_source,50,1) source_snipit,',
'   PLUG_DISPLAY_POINT display_position,',
'   (select name from wwv_flow_templates where id = (select max(STEP_TEMPLATE) from wwv_flow_steps where flow_id = p.flow_id and id = p.page_id)) page_template',
'from wwv_flow_page_plugs p',
'where flow_id = :fb_flow_id',
'      and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1223405038547695.4001)
,p_name=>'Region Attributes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1223610599547698.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1223815780547698.4001)
,p_db_column_name=>'REGION_FOOTER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Pie de P\00E1gina de Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1223927577547698.4001)
,p_db_column_name=>'REGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Identificador de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224029724547699.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224130858547699.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Nombre de la Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#REGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224215307547702.4001)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Tipo de Origen'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(32361488916)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224318844547702.4001)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Secuencia de Visualizaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224412359547702.4001)
,p_db_column_name=>'REPORT_TEMPLATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Plantilla de Informe'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224529572547702.4001)
,p_db_column_name=>'REPORT_TEMPLATE_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Identificador de Plantilla de Informe'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224626388547702.4001)
,p_db_column_name=>'PRN_OUTPUT'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Salida de Impresi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224715409547703.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1224805190547703.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1225215852554774.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1230724631841096.4001)
,p_db_column_name=>'REGION_HEADER'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Cabecera de Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1230816914841096.4001)
,p_db_column_name=>'SOURCE_SIZE'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Tama\00F1o de Origen')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1230904790841096.4001)
,p_db_column_name=>'SOURCE_SNIPIT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Origen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1235810226922130.4001)
,p_db_column_name=>'DISPLAY_POSITION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Posici\00F3n de Visualizaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1235906069922130.4001)
,p_db_column_name=>'PAGE_TEMPLATE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Plantilla de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1240715514980441.4001)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tipo de Informe'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1240811411980442.4001)
,p_db_column_name=>'IS_REPORT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Es Informe'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1247600763061274.4001)
,p_db_column_name=>'IS_CONDITIONAL'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Es Condicional'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193874805040575317.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193878400024611659.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1223327285547695.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.:249,RIR::'
);
end;
/
prompt --application/pages/page_00250
begin
wwv_flow_api.create_page(
 p_id=>250.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Etiquetas de Botones'
,p_step_title=>'Editar Etiquetas de Botones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11868906211287030.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(79624315807352531.4001)
,p_name=>'Edit all button labels in application'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_STEP_ID",',
'BUTTON_NAME,',
'BUTTON_IMAGE_ALT,',
'decode(BUTTON_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden" >''||wwv_flow_lang.system_message(''YES'')||''</span>'') BUTTON_CONDITION_TYPE,',
'BUTTON_IMAGE',
'from WWV_FLOW_STEP_BUTTONS',
'where flow_id = :fb_flow_id and',
'  (:P250_TEXT_CONTAINS is null or ',
'    instr(upper(button_image_alt),upper(:P250_TEXT_CONTAINS)) > 0) ',
'order by flow_step_id'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P250_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 13-JUL-2003 18:38:28'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79624828410352537.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79624922683352537.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79625031824352537.4001)
,p_query_column_id=>3
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre del Bot\00F3n')
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5130:#ID#'
,p_column_linktext=>'#BUTTON_NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(79625127573352537.4001)
,p_query_column_id=>4
,p_column_alias=>'BUTTON_IMAGE_ALT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>50
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27924302379446000.4001)
,p_query_column_id=>5
,p_column_alias=>'BUTTON_CONDITION_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Condicional'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27924400293446001.4001)
,p_query_column_id=>6
,p_column_alias=>'BUTTON_IMAGE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Imagen de Bot\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79628429883361130.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79628527622361130.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79628631564361130.4001)
,p_column_sequence=>3
,p_query_column_name=>'BUTTON_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(79628729687361130.4001)
,p_column_sequence=>4
,p_query_column_name=>'BUTTON_IMAGE_ALT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(27924016507445982.4001)
,p_column_sequence=>5
,p_query_column_name=>'BUTTON_CONDITION_TYPE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(27924115715445982.4001)
,p_column_sequence=>6
,p_query_column_name=>'BUTTON_IMAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193783721655087424.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79639121403396504.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(11868906211287030.4001)
,p_button_name=>'P250_GO'
,p_button_static_id=>'P250_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(79625307240352538.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11868906211287030.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(79626200742352548.4001)
,p_branch_action=>'f?p=&FLOW_ID.:250:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 13-JUL-2003 18:38:28'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27920319352425800.4001)
,p_name=>'P250_ROWS'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(11868906211287030.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,50,100'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79638617594395448.4001)
,p_name=>'P250_TEXT_CONTAINS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11868906211287030.4001)
,p_prompt=>'El Texto Contiene:'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Introduzca criterios de consulta y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79625815653352547.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(79624315807352531.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_BUTTONS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(79625307240352538.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 13-JUL-2003 18:38:28'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(79627408412354938.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'PAGES'
,p_attribute_02=>'250'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00251
begin
wwv_flow_api.create_page(
 p_id=>251.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Lista de Valores'
,p_step_title=>'Editar Plantilla de Lista de Valores Emergente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_popup_lov_template t, wwv_flow_themes th',
'where t.id = :F4000_P251_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6461528787495835.4001)
,p_plug_name=>unistr('Campo de B\00FAsqueda')
,p_region_name=>'SEARCH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6571310709829366.4001)
,p_plug_name=>'Plantilla de Lista de Valores Emergente'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6579903580847814.4001)
,p_plug_name=>'Icono'
,p_region_name=>'ICON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6598112829873957.4001)
,p_plug_name=>'Botones'
,p_region_name=>'BUTTON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6599410672874927.4001)
,p_plug_name=>'Ventana'
,p_region_name=>'WINDOW'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6617813679888708.4001)
,p_plug_name=>unistr('Paginaci\00F3n')
,p_region_name=>'PAGE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6624928116897254.4001)
,p_plug_name=>unistr('Atributos de P\00E1gina')
,p_region_name=>'PG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:R:R:L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6693421116022054.4001)
,p_plug_name=>'Plantillas de Lista de Valores Emergente'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta plantilla controla el modo en el que las listas de valores emergentes aparecen en esta aplicaci\00F3n para todos los elementos del tipo Lista de Valores Emergente.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7782616425041280.4001)
,p_plug_name=>unistr('Aplicaci\00F3n')
,p_region_name=>'A'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11655301433858148.4001)
,p_plug_name=>'Juego de Resultados'
,p_region_name=>'RS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33422401163164175.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'IS_NOT_READ_ONLY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_02=>'wwv_flow_lang.system_message(''SUBSCRIBE_TEMPLATE.POPUP_LOV'')'
,p_attribute_03=>'F4000_P251_ID'
,p_attribute_04=>'F4000_P251_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46189705609907184.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92864020833518069.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617461808376035864.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_POPUP_LOV_TEMPLATE',
'where id = :F4000_P251_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P251_ID,',
'      p_component_type => ''PopUp LOV Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1660132543413741832.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>25
,p_plug_source=>unistr('Esta plantilla est\00E1 suscrita a la plantilla correspondiente del tema maestro. Para modificar esta plantilla, edite la plantilla maestra y, a continuaci\00F3n, refresque el tema. Tambi\00E9n puede crear una copia local, cuya suscripci\00F3n se haya anulado, de es')
||unistr('ta plantilla. Las plantillas cuya suscripci\00F3n se ha anulado se pueden editar y no se sobrescribir\00E1n con el refrescamiento de un tema. ')
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'IS_READ_ONLY'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13150422632483322.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33422401163164175.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P251_ID.,&FLOW_PAGE_ID.,POPUPLOV'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_popup_lov_template',
'',
'where reference_id = :F4000_P251_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13134411073470549.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33422401163164175.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_popup_lov_template',
'',
'where id = :F4000_P251_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6461810453495837.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(6571310709829366.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6461903905495837.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(6571310709829366.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P251_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11474930400495249.4001)
,p_branch_action=>'251'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P251_RTP'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13225603315583410.4001)
,p_branch_action=>'251'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(13134411073470549.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(362990217517450053.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6463032173495845.4001)
,p_name=>'F4000_P251_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6461528787495835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6463313051495848.4001)
,p_name=>'F4000_P251_POPUP_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6579903580847814.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icono Emergente'
,p_source=>'POPUP_ICON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el icono que aparecer\00E1 a la derecha de un campo de pantalla para los elementos de tipo POPUP. Por defecto, el motor de &PRODUCT_NAME. utiliza un icono por defecto basado en CSS.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6463625593495850.4001)
,p_name=>'F4000_P251_POPUP_ICON_ATTR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6579903580847814.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributo de Icono Emergente'
,p_source=>'POPUP_ICON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique atributos de imagen (como altura y ancho) que se utilizan para mostrar el icono emergente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6463931078495851.4001)
,p_name=>'F4000_P251_PAGE_NAME'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(6624928116897254.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Name'
,p_source=>'PAGE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6464200077495853.4001)
,p_name=>'F4000_P251_PAGE_TITLE'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(6624928116897254.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('T\00EDtulo de P\00E1gina')
,p_source=>'PAGE_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define el t\00EDtulo de la p\00E1gina emergente. \00C9ste es el atributo de cabecera de p\00E1gina TITLE HTML.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6464523496495855.4001)
,p_name=>'F4000_P251_PAGE_HTML_HEAD'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(6624928116897254.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cabecera HTML de P\00E1gina')
,p_source=>'PAGE_HTML_HEAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Define el texto que se va a incluir en la cabecera de p\00E1gina de la lista de valores emergente. Utilice esta \00E1rea para incluir las hojas de estilo. Por ejemplo:'),
'',
'<pre>',
'&lt;link rel="stylesheet" href="&#35;IMAGE_PREFIX&#35;platform2.css" type="text/css"&gt;',
'#THEME_CSS#',
'</pre>',
'</p>',
'',
unistr('<p>Est\00E1n soportadas las siguientes cadenas de sustituci\00F3n:'),
'',
'<ul>',
'<li>#THEME_CSS#</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6464814784495856.4001)
,p_name=>'F4000_P251_PAGE_BODY_ATTR'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(6624928116897254.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Atributos de Cuerpo de P\00E1gina')
,p_source=>'PAGE_BODY_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Define el texto que se agrega al cuerpo HTML de la lista de valores emergente. Tenga en cuenta que la p\00E1gina incluye un JavaScript denominado <code>first_field</code>. Por ejemplo: <pre>bgcolor="white" OnLoad="first_field()"</pre>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6465126989495857.4001)
,p_name=>'F4000_P251_BEFORE_FIELD_TEXT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6461528787495835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes de Campo de Texto'
,p_source=>'BEFORE_FIELD_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define el texto que aparece antes de mostrar el campo de b\00FAsqueda de la lista de valores emergente. Por ejemplo:</div>'),
'<pre>Buscar&lt;br&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6465406682495859.4001)
,p_name=>'F4000_P251_FILTER_WIDTH'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(6461528787495835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ancho de Filtro'
,p_source=>'FILTER_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Mostrar el widget HTML INPUT TYPE = TEXT utilizando este ancho.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6465709785495860.4001)
,p_name=>'F4000_P251_FILTER_MAX_WIDTH'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(6461528787495835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ancho M\00E1ximo de Filtro')
,p_source=>'FILTER_MAX_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Mostrar el widget HTML INPUT TYPE = TEXT utilizando este ancho m\00E1ximo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6466008764495862.4001)
,p_name=>'F4000_P251_FILTER_TEXT_ATTR'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(6461528787495835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Texto de Filtro'
,p_source=>'FILTER_TEXT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Mostrar el widget HTML INPUT TYPE = TEXT utilizando estos atributos. Se incluir\00E1 dentro de la etiqueta de entrada HTML.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6466311744495863.4001)
,p_name=>'F4000_P251_FIND_BUTTON_TEXT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Texto del Bot\00F3n Buscar')
,p_source=>'FIND_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define el texto que aparece en el nombre del bot\00F3n utilizado para buscar en la p\00E1gina emergente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6466604290495865.4001)
,p_name=>'F4000_P251_FIND_BUTTON_IMAGE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Find Button Image'
,p_source=>'FIND_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6466925590495866.4001)
,p_name=>'F4000_P251_FIND_BUTTON_ATTR'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Buscar Atributos de Bot\00F3n')
,p_source=>'FIND_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define atributos adicionales para el bot\00F3n Buscar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6467218582495868.4001)
,p_name=>'F4000_P251_CLOSE_BUTTON_TEXT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Texto del Bot\00F3n Cerrar')
,p_source=>'CLOSE_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define el nombre del bot\00F3n Cerrar. El bot\00F3n Cerrar descarta la p\00E1gina de lista de valores emergente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6467511855495869.4001)
,p_name=>'F4000_P251_CLOSE_BUTTON_IMAGE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Close Button Image'
,p_source=>'CLOSE_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6467829509495871.4001)
,p_name=>'F4000_P251_CLOSE_BUTTON_ATTR'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cerrar Atributos de Bot\00F3n')
,p_source=>'CLOSE_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define atributos adicionales del bot\00F3n Cerrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6468112415495872.4001)
,p_name=>'F4000_P251_NEXT_BUTTON_TEXT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Texto del Bot\00F3n Siguiente')
,p_source=>'NEXT_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define el nombre del bot\00F3n Siguiente utilizado al paginar juegos de resultados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6468400865495874.4001)
,p_name=>'F4000_P251_NEXT_BUTTON_IMAGE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Button Image'
,p_source=>'NEXT_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6468719065495875.4001)
,p_name=>'F4000_P251_NEXT_BUTTON_ATTR'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Atributo del Bot\00F3n Siguiente')
,p_source=>'NEXT_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define atributos adicionales para el bot\00F3n Siguiente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6469027954495877.4001)
,p_name=>'F4000_P251_PREV_BUTTON_TEXT'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Texto del Bot\00F3n Anterior')
,p_source=>'PREV_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Define el nombre del bot\00F3n P\00E1gina Anterior. Este bot\00F3n se utiliza para paginar juegos de resultados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6469302467495879.4001)
,p_name=>'F4000_P251_PREV_BUTTON_IMAGE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prev Button Image'
,p_source=>'PREV_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6469622652495880.4001)
,p_name=>'F4000_P251_PREV_BUTTON_ATTR'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(6598112829873957.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Atributos del Bot\00F3n Anterior')
,p_source=>'PREV_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define atributos adicionales del bot\00F3n Anterior.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6469906873495881.4001)
,p_name=>'F4000_P251_AFTER_FIELD_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(6461528787495835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s de Campo de Texto')
,p_source=>'AFTER_FIELD_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Mostrar este texto despu\00E9s de mostrar el campo de b\00FAsqueda, el bot\00F3n Buscar y el bot\00F3n Cerrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6470217455495883.4001)
,p_name=>'F4000_P251_SCROLLBARS'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(6599410672874927.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Barras de Desplazamiento'
,p_source=>'SCROLLBARS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las listas de valores emergentes se ejecutan mediante JavaScript. Utilice este atributo para controlar los valores de <code>scrollbars=</code>. El valor por defecto es 1. Los valores v\00E1lidos son 1 y 0. Un valor cero (0) indica que la ventana de di\00E1lo')
||'go emergente no es desplazable.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6470527953495884.4001)
,p_name=>'F4000_P251_RESIZABLE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(6599410672874927.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Redimensionable'
,p_source=>'RESIZABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las listas de valores emergentes se ejecutan mediante JavaScript. Utilice este atributo para controlar el valor de <code>resizable=</code>. El valor por defecto es 1. Los valores v\00E1lidos son 1 y 0. Un valor cero indica que la ventana de di\00E1logo emerg')
||'ente no es redimensionable.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6470809525495886.4001)
,p_name=>'F4000_P251_WIDTH'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(6599410672874927.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ancho'
,p_source=>'WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Las listas de valores emergentes se ejecutan mediante JavaScript. Utilice este atributo para controlar los valores de <code>width=</code>. El valor por defecto es 450.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6471126752495887.4001)
,p_name=>'F4000_P251_HEIGHT'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(6599410672874927.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Altura'
,p_source=>'HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Las listas de valores emergentes se ejecutan mediante JavaScript. Utilice este atributo para controlar los valores de <code>heigth=</code>. El valor por defecto es 400.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6471400957495889.4001)
,p_name=>'F4000_P251_RESULT_ROW_X_OF_Y'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(6617813679888708.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Fila de Resultados X de Y'
,p_source=>'RESULT_ROW_X_OF_Y'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Define el modo de visualizaci\00F3n de los resultados del recuento de filas. Utilice las cadenas de sustituci\00F3n #FIRST_ROW# y #LAST_ROW#.'),
'</p>',
'<p>Por ejemplo</p>',
'<pre>#FIRST_ROW# - #LAST_ROW#</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6471712271495890.4001)
,p_name=>'F4000_P251_RESULT_ROWS_PER_PG'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(6617813679888708.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mostrar'
,p_source=>'RESULT_ROWS_PER_PG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Define el n\00FAmero de filas por p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9448702712976950.4001)
,p_name=>'F4000_P251_PAGE_HEADING_TEXT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(6624928116897254.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Texto de Cabecera de P\00E1gina')
,p_source=>'PAGE_HEADING_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Define el texto que aparecer\00E1 despu\00E9s de abrir la pantalla pero antes de mostrar ning\00FAn texto. Este texto va antes de Antes de Campo de Texto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9449530520979254.4001)
,p_name=>'F4000_P251_PAGE_FOOTER_TEXT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(6624928116897254.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Texto de Pie de P\00E1gina')
,p_source=>'PAGE_FOOTER_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Define el texto que aparecer\00E1 despu\00E9s de mostrar la p\00E1gina emergente que incluye los resultados de la lista de b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11471714238487514.4001)
,p_name=>'F4000_P251_RTP'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(6693421116022054.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11732328963936560.4001)
,p_name=>'F4000_P251_AFTER_RESULT_SET'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(11655301433858148.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s de Juego de Resultados')
,p_source=>'AFTER_RESULT_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Mostrar este texto despu\00E9s del juego de resultados. El juego de resultados es el resultado de la consulta de lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11750522900969722.4001)
,p_name=>'F4000_P251_BEFORE_RESULT_SET'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(11655301433858148.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes de Juego de Resultados'
,p_source=>'BEFORE_RESULT_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Mostrar este texto antes que el juego de resultados. El juego de resultados es el resultado de la consulta de lista de valores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13162025590497159.4001)
,p_name=>'F4000_P251_REFERENCE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33422401163164175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_POPUPLOV_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'       lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
'       '' -'' d, 0 r',
'  from dual',
' union all',
'select flow_id||'' : ''||',
'       lower(wwv_flow_lang.system_message(''POPUP_LOV''))||'' ''||',
'       lower(wwv_flow_lang.system_message(''TEMPLATE''))||decode(theme_id,null,'''','' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_popup_lov_template',
' where flow_id != nvl(:fb_flow_id,0)',
'  and flow_id in ( select f.id',
'                     from wwv_flow_visible_flows f',
'                    where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') )',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar Plantilla</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15972308994805131.4001)
,p_name=>'P251_POPUP_ICON2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(6579903580847814.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icono de Selector de Color Emergente'
,p_source=>'POPUP_ICON2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el icono que aparecer\00E1 a la derecha de un campo de pantalla para los elementos de tipo Selector de Color Emergente. Por defecto, el motor de &PRODUCT_NAME. muestra un icono de paleta de colores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15973216266807314.4001)
,p_name=>'P251_POPUP_ICON_ATTR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6579903580847814.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributo de Icono de Selector de Color Emergente'
,p_source=>'POPUP_ICON_ATTR2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique atributos de imagen (como altura y ancho) que se utilizan para mostrar el icono del selector de color emergente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24158632433573402.4001)
,p_name=>'P251_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7782616425041280.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Indica si esta plantilla de lista de valores es traducible.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35517702471777425.4001)
,p_name=>'F4000_P251_REFRESH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33422401163164175.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from  WWV_FLOW_POPUP_LOV_TEMPLATE',
'',
'where reference_id is null',
'',
'and id = :F4000_P251_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identifique la preferencia de refrescamiento de la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58972605368321642.4001)
,p_name=>'P251_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7782616425041280.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59399317937875688.4001)
,p_name=>'P251_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(7782616425041280.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'POPUP LOV TEMPLATE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(59418530750879398.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.<p />',
'Utilice la casilla de control <strong>Se puede convertir</strong> para indicar si esta plantilla contiene cadenas de texto que hay que convertir. ',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35524002675792473.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P251_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13200930513540445.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P251_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(13134411073470549.4001)
,p_associated_item=>wwv_flow_api.id(13162025590497159.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13205914985547651.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P251_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(13134411073470549.4001)
,p_associated_item=>wwv_flow_api.id(13162025590497159.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6472104708495893.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_03=>'F4000_P251_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
,p_process_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13216008072566081.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'referesh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_popuplov_template (',
'    p_master_template_id         => :F4000_P251_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P251_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(13134411073470549.4001)
,p_process_when=>'F4000_P251_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6472416068495897.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_03=>'F4000_P251_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35528815818801571.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_popuplov_template (',
'    p_master_template_id         => :F4000_P251_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P251_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(6461903905495837.4001)
,p_process_when=>':F4000_P251_REFERENCE_ID is not null and :F4000_P251_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13221817549576893.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_popuplov_reference_id (:F4000_P251_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(6461903905495837.4001)
,p_process_when=>'F4000_P251_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Restablecer identificador de referencia.'
);
end;
/
prompt --application/pages/page_00253
begin
wwv_flow_api.create_page(
 p_id=>253.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Instalar Tema'
,p_step_title=>'Instalar Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38856906254201972.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47632929379498968.4001)
,p_plug_name=>'Instalar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79479717773383003.4001)
,p_plug_name=>unistr('Archivo no V\00E1lido')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('El archivo no es un archivo de exportaci\00F3n de temas de &PRODUCT_NAME. v\00E1lido.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205167923987797584.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747139770527138157.4001)
,p_plug_name=>'Instalar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47637304969529815.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205167923987797584.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6490304224631074.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(79479717773383003.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47638615358532854.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205167923987797584.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Instalar Tema'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47640408909540416.4001)
,p_branch_action=>'f?p=&FLOW_ID.:260:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73118923864773969.4001)
,p_branch_action=>'f?p=&FLOW_ID.:253:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(143131410984185804.4001)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47637304969529815.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73107224679708035.4001)
,p_branch_action=>'f?p=&FLOW_ID.:48:&SESSION.:THEME:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47638615358532854.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P253_INSTALL_OPTION'
,p_branch_condition_text=>'REPLACE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53701615454623779.4001)
,p_name=>'P253_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(56513630434665841.4001)
,p_name=>'P253_IMP_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72898709763530335.4001)
,p_name=>'P253_NEW_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Instalar en Aplicaci\00F3n')
,p_source_post_computation=>'wwv_flow_escape.html(:P253_NEW_FLOW_ID)'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede instalar el tema en la misma aplicaci\00F3n de origen o en una aplicaci\00F3n diferente en el espacio de trabajo. Deje el identificador de aplicaci\00F3n como est\00E1 o seleccione otro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142932124032631309.4001)
,p_name=>'P253_NEW_THEME_PK'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142941623994678665.4001)
,p_name=>'P253_ORIGINAL_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Exportado desde Identificador de Aplicaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_flow_id(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142944625164688469.4001)
,p_name=>'P253_ORIGINAL_THEME_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador de Tema Exportado:'
,p_source=>'wwv_flow_imp_parser.get_theme_id(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_source_post_computation=>'wwv_flow_escape.html(:P253_ORIGINAL_THEME_ID)'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142984030433945447.4001)
,p_name=>'P253_INSTALL_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'CREATE'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'select 1 from wwv_flow_themes where flow_id=:P253_NEW_FLOW_ID and theme_id=:P253_ORIGINAL_THEME_ID and :p253_original_theme_id != (select nvl(theme_id,-1) from wwv_flows where id = :P253_NEW_FLOW_ID)'
,p_display_when_type=>'EXISTS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Al refrescar un tema, se actualizan el tema y la definici\00F3n de plantilla del tema actual con la definici\00F3n del tema importado. Para que ocurra, es necesario que ambos temas sean compatibles y utilicen los mismos identificadores de tema y plantilla')
||'s.</p>',
'<p>Al crear un nuevo tema, se instala el tema importado junto con el tema actual, lo que permite cambiar del tema antiguo al nuevo y asignar manualmente las plantillas.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143018502916051053.4001)
,p_name=>'P253_ACTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_original_theme_id number := wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID);',
'begin',
'if :P253_NEW_FLOW_ID is null and :P253_INSTALL_OPTION is null then',
'  for c1 in (select 1 from wwv_flow_themes ',
'    where flow_id = :FB_FLOW_ID ',
'      and theme_id = l_original_theme_id',
'      and not exists (select 1 from wwv_flows where id = :FB_FLOW_ID and nvl(theme_id,-1) = l_original_theme_id)) loop',
'    :P253_INSTALL_OPTION := ''REPLACE'';',
'    return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_REPLACE'',:FB_FLOW_ID);',
'  end loop;',
'  :P253_INSTALL_OPTION := ''CREATE'';',
'  return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:FB_FLOW_ID);',
'elsif :P253_NEW_FLOW_ID is not null and :P253_INSTALL_OPTION is null then',
'  for c1 in (select 1 from wwv_flow_themes ',
'    where flow_id = :P253_NEW_FLOW_ID ',
'      and theme_id = l_original_theme_id',
'      and not exists (select 1 from wwv_flows where id = :P253_NEW_FLOW_ID and nvl(theme_id,-1) = l_original_theme_id)) loop',
'    :P253_INSTALL_OPTION := ''REPLACE'';',
'    return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_REPLACE'',:P253_NEW_FLOW_ID);',
'  end loop;',
'  :P253_INSTALL_OPTION := ''CREATE'';',
'  return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:P253_NEW_FLOW_ID);',
'elsif :P253_NEW_FLOW_ID is not null and :P253_INSTALL_OPTION is not null then',
'  for c1 in (select 1 from wwv_flow_themes ',
'    where flow_id = :P253_NEW_FLOW_ID ',
'      and theme_id = l_original_theme_id',
'      and not exists (select 1 from wwv_flows where id = :P253_NEW_FLOW_ID and nvl(theme_id,-1) = l_original_theme_id)) loop',
'    if :P253_INSTALL_OPTION = ''CREATE'' then',
'      return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:P253_NEW_FLOW_ID);',
'    else',
'      return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_REPLACE'',:P253_NEW_FLOW_ID);',
'    end if;',
'  end loop;',
'  :P253_INSTALL_OPTION := ''CREATE'';',
'  return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:P253_NEW_FLOW_ID);  ',
'elsif :P253_NEW_FLOW_ID is null and :P253_INSTALL_OPTION is not null  then',
'  :P253_INSTALL_OPTION := null;',
'  return null;',
'end if;',
'return null;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146463506734195615.4001)
,p_name=>'P253_THEME_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47632929379498968.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre del Tema Exportado:'
,p_source=>'wwv_flow_imp_parser.get_theme_name(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47812121666857963.4001)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de temas de &PRODUCT_NAME. v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532854.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(56432910873347879.4001)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p253_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de la aplicaci\00F3n.)')
,p_when_button_pressed=>wwv_flow_api.id(47638615358532854.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46353812810485581.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_create_theme boolean :=false;',
'begin',
'  if :P253_INSTALL_OPTION = ''CREATE'' then',
'    l_create_theme := true;',
'  end if;',
'  for c1 in (select owner from wwv_flows ',
'             where id = :P253_NEW_FLOW_ID ',
'             and security_group_id = :flow_security_group_id) loop',
'      wwv_flow_imp_parser.parse (',
'         p_file_id          => :P253_FILE_ID,',
'         p_parse_as_schema  => c1.owner,',
'         p_install_as_flow  => :P253_NEW_FLOW_ID,',
'         p_original_flow_id => wwv_flow_imp_parser.get_flow_id(:P253_FILE_ID),',
'         p_adjust_offset    => true,',
'         p_create_theme     => l_create_theme',
'         );',
'  end loop;',
':FB_FLOW_ID := :P253_NEW_FLOW_ID;',
':F4000_P1_FLOW := :P253_NEW_FLOW_ID;',
':F4000_P1_PAGE := ''1'';',
'',
':P253_NEW_THEME_PK  := null;',
'for c1 in (select id from wwv_flow_themes where flow_id=:P253_NEW_FLOW_ID and',
'  theme_id = wwv_flow.g_flow_theme_id) loop',
'  :P253_NEW_THEME_PK := c1.id;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al instalar el tema.'
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Tema instalado.'
);
end;
/
prompt --application/pages/page_00257
begin
wwv_flow_api.create_page(
 p_id=>257.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529608709597093346.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529610890318093348.4001)
,p_plug_name=>unistr('Regi\00F3n de Detalles')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183890143848322706.4001)
,p_plug_name=>'Base de Datos Local'
,p_parent_plug_id=>wwv_flow_api.id(529610890318093348.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(362003702720288095.4001)
,p_plug_name=>'Base de Datos Remota'
,p_parent_plug_id=>wwv_flow_api.id(529610890318093348.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(367382750186014176.4001)
,p_plug_name=>'Tabla de servidor remoto'
,p_parent_plug_id=>wwv_flow_api.id(362003702720288095.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(367398025925083643.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(529610890318093348.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(367400145770083665.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(367398025925083643.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529622414797093357.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(42519297248600803.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529609576717093346.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(529608709597093346.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529609141995093346.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(529608709597093346.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529609948922093347.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(529608709597093346.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:239:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183890269069322707.4001)
,p_name=>'P257_DETAIL_LOCATION'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(529610890318093348.4001)
,p_prompt=>unistr('Ubicaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Permite seleccionar el tipo de <em>origen de datos</em> para el detalle.',
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se originan en la base de datos local.</li>',
'    <li><strong>Servicio de SQL activado para REST</strong><br>',
unistr('    Los datos se originan en una base de datos remota, donde la conexi\00F3n se define utilizando el servicio SQL activado para REST. Para crear o conservar las referencias de SQL activadas para REST, acceda a Componentes compartidos, SQL activado para R')
||'EST.',
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos se originan en un servicio web RESTful que se ha definido utilizando or\00EDgenes de datos de REST. Para crear o conservar los or\00EDgenes de datos de REST, acceda a Componentes compartidos.'),
'    </li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183891280072322717.4001)
,p_name=>'P257_DETAIL_R_DETAIL_COL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_prompt=>'Columna de Detalle'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P257_DETAIL_R_OWNER,',
'      p_table_name        => :P257_DETAIL_R_TABLE,',
'      p_remote_server_id  => :P257_DETAIL_R_SERVER ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_R_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_R_OWNER,P257_DETAIL_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna de la tabla, vista u origen de datos de REST que se corresponde con la columna maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183892274262322727.4001)
,p_name=>'P257_DETAIL_W_DETAIL_COL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(367400145770083665.4001)
,p_prompt=>'Columna de Detalle'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P257_DETAIL_W_WEB_SRC ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna de la tabla, vista u origen de datos de REST que se corresponde con la columna maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183919404486561565.4001)
,p_name=>'P257_DETAIL_R_SERVER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(362003702720288095.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el servicio de SQL activado para REST que se va a utilizar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183920185983561567.4001)
,p_name=>'P257_DETAIL_R_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P257_DETAIL_R_SERVER, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P257_DETAIL_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183921005927561572.4001)
,p_name=>'P257_DETAIL_R_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P257_DETAIL_R_SERVER, ''TABLE'', :P257_DETAIL_R_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P257_DETAIL_R_OWNER'
,p_ajax_items_to_submit=>'P257_DETAIL_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la tabla o vista maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183921976444561573.4001)
,p_name=>'P257_DETAIL_R_PK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_item_default=>'ROWID'
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P257_DETAIL_R_OWNER,',
'      p_table_name        => :P257_DETAIL_R_TABLE,',
'      p_remote_server_id  => :P257_DETAIL_R_SERVER ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'ROWID'
,p_lov_null_value=>'ROWID'
,p_lov_cascade_parent_items=>'P257_DETAIL_R_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_R_OWNER,P257_DETAIL_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183922878432561586.4001)
,p_name=>'P257_DETAIL_R_PK2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P257_DETAIL_R_OWNER,',
'      p_table_name        => :P257_DETAIL_R_TABLE,',
'      p_remote_server_id  => :P257_DETAIL_R_SERVER ) )',
' where column_name != :P257_DETAIL_R_PK'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_R_TABLE,P257_DETAIL_R_PK'
,p_ajax_items_to_submit=>'P257_DETAIL_R_OWNER,P257_DETAIL_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183923760139561588.4001)
,p_name=>'P257_DETAIL_R_MASTER_COL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_prompt=>'Columna Maestra'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => :P239_MASTER_LOCATION,',
'      p_query_type           => case when :P239_MASTER_LOCATION in ( ''LOCAL'', ''REMOTE'' ) then ''TABLE'' end,',
'      p_remote_server_id     => :P239_MASTER_R_SERVER,',
'      p_owner                => case :P239_MASTER_LOCATION',
'                                    when ''LOCAL'' then :P239_MASTER_OWNER',
'                                    when ''REMOTE'' then :P239_MASTER_R_OWNER',
'                                end,',
'      p_table_name           => case :P239_MASTER_LOCATION',
'                                    when ''LOCAL'' then :P239_MASTER_TABLE',
'                                    when ''REMOTE'' then :P239_MASTER_R_TABLE',
'                                end,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_read_only_when=>'P29_MD_TYPE'
,p_read_only_when2=>'MD_EMAIL_STYLE'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna de clave primaria de la tabla o vista maestra que se corresponde con la columna de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183924640601561589.4001)
,p_name=>'P257_DETAIL_R_COLUMNS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(367382750186014176.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''REMOTE'',',
'                  p_remote_server_id  => :P257_DETAIL_R_SERVER,',
'                  p_owner             => :P257_DETAIL_R_OWNER,',
'                  p_table_name        => :P257_DETAIL_R_TABLE,',
'                  p_query_type        => ''TABLE'' ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;',
'',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location          => ''REMOTE'',',
'      p_query_type        => ''TABLE'',',
'      p_owner             => :P257_DETAIL_R_OWNER,',
'      p_table_name        => :P257_DETAIL_R_TABLE,',
'      p_remote_server_id  => :P257_DETAIL_R_SERVER ) )'))
,p_lov_cascade_parent_items=>'P257_DETAIL_R_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_R_OWNER,P257_DETAIL_R_SERVER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183936484365631041.4001)
,p_name=>'P257_DETAIL_W_WEB_SRC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(367398025925083643.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id as r',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccione -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el origen de datos de REST que se va a utilizar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183937022537631044.4001)
,p_name=>'P257_DETAIL_W_PK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(367400145770083665.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P257_DETAIL_W_WEB_SRC ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila en el origen de datos de REST.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183937936690631044.4001)
,p_name=>'P257_DETAIL_W_PK2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(367400145770083665.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P257_DETAIL_W_WEB_SRC ) )',
' where column_name != :P257_DETAIL_W_PK'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_W_WEB_SRC,P257_DETAIL_W_PK'
,p_ajax_items_to_submit=>'P257_DETAIL_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila en el origen de datos de REST.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183938851290631047.4001)
,p_name=>'P257_DETAIL_W_MASTER_COL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(367400145770083665.4001)
,p_prompt=>'Columna Maestra'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => :P239_MASTER_LOCATION,',
'      p_query_type           => case when :P239_MASTER_LOCATION in ( ''LOCAL'', ''REMOTE'' ) then ''TABLE'' end,',
'      p_remote_server_id     => :P239_MASTER_R_SERVER,',
'      p_owner                => case :P239_MASTER_LOCATION',
'                                    when ''LOCAL'' then :P239_MASTER_OWNER',
'                                    when ''REMOTE'' then :P239_MASTER_R_OWNER',
'                                end,',
'      p_table_name           => case :P239_MASTER_LOCATION',
'                                    when ''LOCAL'' then :P239_MASTER_TABLE',
'                                    when ''REMOTE'' then :P239_MASTER_R_TABLE',
'                                end,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_read_only_when=>'P29_MD_TYPE'
,p_read_only_when2=>'MD_EMAIL_STYLE'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna de clave primaria de la p\00E1gina maestra que se corresponde con la columna de detalles.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183939704581631047.4001)
,p_name=>'P257_DETAIL_W_COLUMNS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(367400145770083665.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'        from table(wwv_flow_exec_dev.get_query_columns(',
'                       p_location             => ''WEB_SOURCE'',',
'                       p_query_type           => null,',
'                       p_web_src_module_id    => :P257_DETAIL_W_WEB_SRC ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => ''WEB_SOURCE'',',
'      p_query_type           => null,',
'      p_web_src_module_id    => :P257_DETAIL_W_WEB_SRC ) )',
''))
,p_lov_cascade_parent_items=>'P257_DETAIL_W_WEB_SRC'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(513677252340698824.4001)
,p_name=>'P257_MASTER_COL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_prompt=>'Columna Maestra'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location             => :P239_MASTER_LOCATION,',
'      p_query_type           => case when :P239_MASTER_LOCATION in ( ''LOCAL'', ''REMOTE'' ) then ''TABLE'' end,',
'      p_remote_server_id     => :P239_MASTER_R_SERVER,',
'      p_owner                => case :P239_MASTER_LOCATION',
'                                    when ''LOCAL'' then :P239_MASTER_OWNER',
'                                    when ''REMOTE'' then :P239_MASTER_R_OWNER',
'                                end,',
'      p_table_name           => case :P239_MASTER_LOCATION',
'                                    when ''LOCAL'' then :P239_MASTER_TABLE',
'                                    when ''REMOTE'' then :P239_MASTER_R_TABLE',
'                                end,',
'      p_web_src_module_id    => :P239_MASTER_W_WEB_SRC ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_read_only_when=>'P29_MD_TYPE'
,p_read_only_when2=>'MD_EMAIL_STYLE'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna de clave primaria de la tabla o vista maestra que se corresponde con la columna de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(513677815128698830.4001)
,p_name=>'P257_DETAIL_FK_CONS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_prompt=>'Clave Ajena de Maestro/Detalle'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with cc as (',
'    select /*+materialize*/',
'           cc.owner,',
'           cc.constraint_name,',
'           cc.table_name,',
'           cc.column_name,',
'           cc.position',
'      from sys.dba_cons_columns cc',
'     where cc.owner      = :P239_MASTER_OWNER',
'       and cc.table_name in ( :P239_MASTER_TABLE, :P257_DETAIL_TABLE ) ),',
'cons_cols as (',
'    select cc.owner,',
'           cc.constraint_name,',
'           cc.table_name,',
'           cc.column_name,',
'           cc.position,',
'           c.constraint_type,',
'           c.r_owner,',
'           c.r_constraint_name',
'      from cc,',
'           sys.dba_constraints  c',
'     where cc.owner           =  c.owner',
'       and cc.constraint_name =  c.constraint_name',
'       and c.constraint_type  in (''R'', ''P'', ''U'') )',
'select LISTAGG(parent.column_name, '', '') WITHIN GROUP (ORDER BY parent.position)||',
'       '' -> ''||',
'       LISTAGG(child.column_name, '', '')  WITHIN GROUP (ORDER BY child.position)  d,',
'       child.constraint_name r',
'    from cons_cols child,cons_cols parent',
'    where child.constraint_type  =  ''R''',
'    and parent.constraint_type  in (''P'',''U'')',
'    and child.r_constraint_name =  parent.constraint_name',
'    and child.r_owner           =  parent.owner',
'    and child.position          =  parent.position',
'    and parent.table_name       =  :P239_MASTER_TABLE',
'group by child.constraint_name   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Relaci\00F3n Maestro/Detalle -')
,p_lov_cascade_parent_items=>'P257_DETAIL_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la clave ajena que relaciona las tablas maestra y de detalles.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(513678195208698833.4001)
,p_name=>'P257_DETAIL_PK2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc d,',
'       column_name r',
'  from wwv_flow_table_columns_dev',
' where owner      = :P257_DETAIL_OWNER',
'   and table_name = :P257_DETAIL_TABLE',
'   and column_name != :P257_DETAIL_PK'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_TABLE,P257_DETAIL_PK'
,p_ajax_items_to_submit=>'P257_DETAIL_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529611248487093348.4001)
,p_name=>'P257_DETAIL_REGION_TITLE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(529610890318093348.4001)
,p_prompt=>unistr('T\00EDtulo de Regi\00F3n de Detalles')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>'P29_MD_TYPE'
,p_display_when2=>'MD_SINGLE_PG:MD_EMAIL_STYLE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la regi\00F3n de detalles.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529612560640093349.4001)
,p_name=>'P257_DETAIL_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario de Tabla/Vista'
,p_source=>'P239_MASTER_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el propietario de la tabla o la vista en la que va a crear una cuadr\00EDcula interactiva.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529613438090093350.4001)
,p_name=>'P257_DETAIL_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P257_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q varchar2(32767);',
'begin',
'    if nvl(:P257_SHOW_RELATED_TABLES,''N'') = ''N'' then',
'        q := ''select object_name_esc, object_name from wwv_flow_tables_views_dev where owner = :P257_DETAIL_OWNER order by 1'';',
'    else',
'        q := ''select detail_table_name d, detail_table_name r',
'                 from wwv_flow_detail_tables_dev',
'                where master_owner      = :P239_MASTER_OWNER',
'                  and detail_owner      = :P257_DETAIL_OWNER',
'                  and master_table_name = :P239_MASTER_TABLE',
'                order by 1'';',
'    end if;',
'    return q;',
'end;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P257_SHOW_RELATED_TABLES,P257_DETAIL_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la p\00E1gina de detalle. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529614372240093350.4001)
,p_name=>'P257_DETAIL_COLUMNS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    if :P257_DETAIL_OWNER is not null and :P257_DETAIL_TABLE is not null then',
'        for l_column in (',
'            select column_name',
'              from wwv_flow_table_columns_dev',
'             where owner      = :P257_DETAIL_OWNER',
'               and table_name = :P257_DETAIL_TABLE',
'        ) loop',
'            l_columns := l_columns || l_column.column_name || '':'';',
'        end loop;',
'    end if;',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P257_DETAIL_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P257_DETAIL_OWNER',
'   and table_name = :P257_DETAIL_TABLE',
'   and :P257_DETAIL_TABLE is not null'))
,p_lov_cascade_parent_items=>'P257_DETAIL_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529617994105093353.4001)
,p_name=>'P257_DETAIL_PK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_item_default=>'ROWID'
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''ROWID'' d, ''ROWID'' r',
'from dual',
'union all',
'select column_name_esc d,',
'       column_name r',
'  from wwv_flow_table_columns_dev',
' where owner      = :P257_DETAIL_OWNER',
'   and table_name = :P257_DETAIL_TABLE'))
,p_lov_cascade_parent_items=>'P257_DETAIL_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna que identifica de forma \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529620589103093355.4001)
,p_name=>'P257_DETAIL_COL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_prompt=>'Columna de Detalle'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P257_DETAIL_OWNER',
'   and table_name = :P257_DETAIL_TABLE'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P257_DETAIL_TABLE'
,p_ajax_items_to_submit=>'P257_DETAIL_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la columna de la tabla, vista u origen de datos de REST de detalles que se corresponda con la columna maestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537663623064061330.4001)
,p_name=>'P257_SHOW_RELATED_TABLES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(183890143848322706.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Mostrar S\00F3lo Tablas Relacionadas:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si se va a limitar la lista de tablas de detalles a s\00F3lo las relacionadas con la tabla maestra.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(183890470936322709.4001)
,p_computation_sequence=>70
,p_computation_item=>'P257_DETAIL_LOCATION'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P239_MASTER_LOCATION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(529623836156093359.4001)
,p_computation_sequence=>50
,p_computation_item=>'P257_DETAIL_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(529624223080093359.4001)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P257_DETAIL_OWNER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513678953937698841.4001)
,p_validation_name=>'Local master detail FK required if related'
,p_validation_sequence=>50
,p_validation=>'P257_DETAIL_FK_CONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P257_SHOW_RELATED_TABLES = ''Y'' and :P257_DETAIL_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(513677815128698830.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513679086681698842.4001)
,p_validation_name=>'Local master column NOT NULL if not related'
,p_validation_sequence=>60
,p_validation=>'P257_MASTER_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P257_SHOW_RELATED_TABLES != ''Y'' and :P257_DETAIL_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(513677252340698824.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513679102265698843.4001)
,p_validation_name=>'Local detail column NOT NULL not null if not related'
,p_validation_sequence=>70
,p_validation=>'P257_DETAIL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P257_SHOW_RELATED_TABLES != ''Y'' and :P257_DETAIL_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(529620589103093355.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893279963322737.4001)
,p_validation_name=>'Local Detail Table NOT NULL'
,p_validation_sequence=>80
,p_validation=>'P257_DETAIL_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(529609141995093346.4001)
,p_associated_item=>wwv_flow_api.id(529613438090093350.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893370902322738.4001)
,p_validation_name=>'Local Detail PK NOT NULL'
,p_validation_sequence=>90
,p_validation=>'P257_DETAIL_PK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(529617994105093353.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893491322322739.4001)
,p_validation_name=>'Local Detail Columns NOT NULL'
,p_validation_sequence=>100
,p_validation=>'P257_DETAIL_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'LOCAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(529614372240093350.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893591367322740.4001)
,p_validation_name=>'Remote Server NOT NULL'
,p_validation_sequence=>110
,p_validation=>'P257_DETAIL_R_SERVER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183919404486561565.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893692481322741.4001)
,p_validation_name=>'Remote Detail Table NOT NULL'
,p_validation_sequence=>120
,p_validation=>'P257_DETAIL_R_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183921005927561572.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893745744322742.4001)
,p_validation_name=>'Remote Detail PK NOT NULL'
,p_validation_sequence=>130
,p_validation=>'P257_DETAIL_R_PK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183921976444561573.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893852096322743.4001)
,p_validation_name=>'Remote Master Column NOT NULL'
,p_validation_sequence=>140
,p_validation=>'P257_DETAIL_R_MASTER_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183923760139561588.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183893992087322744.4001)
,p_validation_name=>'Remote Detail Column NOT NULL'
,p_validation_sequence=>150
,p_validation=>'P257_DETAIL_R_DETAIL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183891280072322717.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183894062874322745.4001)
,p_validation_name=>'Remote Detail Columns NOT NULL'
,p_validation_sequence=>160
,p_validation=>'P257_DETAIL_R_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183924640601561589.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183894104806322746.4001)
,p_validation_name=>'Web Src Module ID NOT NULL'
,p_validation_sequence=>170
,p_validation=>'P257_DETAIL_W_WEB_SRC'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183936484365631041.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183894292294322747.4001)
,p_validation_name=>'Web Src Detail PK NOT NULL'
,p_validation_sequence=>180
,p_validation=>'P257_DETAIL_W_PK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183937022537631044.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183894376398322748.4001)
,p_validation_name=>'Web Src Master Column NOT NULL'
,p_validation_sequence=>190
,p_validation=>'P257_DETAIL_W_MASTER_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183938851290631047.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183894507985322750.4001)
,p_validation_name=>'Web Src Detail Columns NOT NULL'
,p_validation_sequence=>200
,p_validation=>'P257_DETAIL_W_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183939704581631047.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(183894495712322749.4001)
,p_validation_name=>'Web Src Detail Column NOT NULL'
,p_validation_sequence=>210
,p_validation=>'P257_DETAIL_W_DETAIL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P257_DETAIL_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(183892274262322727.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(610851316486282104.4001)
,p_validation_name=>'Chosen Table exists'
,p_validation_sequence=>220
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P257_DETAIL_OWNER',
'   and object_name = :P257_DETAIL_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P257_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P257_DETAIL_LOCATION = ''LOCAL'' and :P257_DETAIL_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(529609141995093346.4001)
,p_associated_item=>wwv_flow_api.id(529613438090093350.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(529630922405093364.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(529609576717093346.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(529631413572093365.4001)
,p_event_id=>wwv_flow_api.id(529630922405093364.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(513677522554698827.4001)
,p_name=>'md tables related'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_SHOW_RELATED_TABLES'
,p_condition_element=>'P257_SHOW_RELATED_TABLES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513677607780698828.4001)
,p_event_id=>wwv_flow_api.id(513677522554698827.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_FK_CONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513677742805698829.4001)
,p_event_id=>wwv_flow_api.id(513677522554698827.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_MASTER_COL,P257_DETAIL_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513677921672698831.4001)
,p_event_id=>wwv_flow_api.id(513677522554698827.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_MASTER_COL,P257_DETAIL_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513678081001698832.4001)
,p_event_id=>wwv_flow_api.id(513677522554698827.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_FK_CONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(513678242364698834.4001)
,p_name=>'if pk1 ROWID don''t show pk2'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_PK'
,p_condition_element=>'P257_DETAIL_PK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ROWID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513678388656698835.4001)
,p_event_id=>wwv_flow_api.id(513678242364698834.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513678491230698836.4001)
,p_event_id=>wwv_flow_api.id(513678242364698834.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183890554139322710.4001)
,p_name=>'Local Database'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_LOCATION'
,p_condition_element=>'P257_DETAIL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183890671779322711.4001)
,p_event_id=>wwv_flow_api.id(183890554139322710.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183890143848322706.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183890752751322712.4001)
,p_event_id=>wwv_flow_api.id(183890554139322710.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(183890143848322706.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183891321793322718.4001)
,p_name=>'Remote Database'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_LOCATION'
,p_condition_element=>'P257_DETAIL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183891439595322719.4001)
,p_event_id=>wwv_flow_api.id(183891321793322718.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(362003702720288095.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183891527494322720.4001)
,p_event_id=>wwv_flow_api.id(183891321793322718.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(362003702720288095.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183892627840322731.4001)
,p_name=>'REST Data Source'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_LOCATION'
,p_condition_element=>'P257_DETAIL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183892716555322732.4001)
,p_event_id=>wwv_flow_api.id(183892627840322731.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(367398025925083643.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183892828783322733.4001)
,p_event_id=>wwv_flow_api.id(183892627840322731.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(367398025925083643.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183890837444322713.4001)
,p_name=>'Handle Show Related Tables'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P239_MASTER_LOCATION'
,p_display_when_cond2=>'LOCAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183890982577322714.4001)
,p_event_id=>wwv_flow_api.id(183890837444322713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_SHOW_RELATED_TABLES'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183891037207322715.4001)
,p_event_id=>wwv_flow_api.id(183890837444322713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_SHOW_RELATED_TABLES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183891633291322721.4001)
,p_name=>'Remote Server NOT NULL'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_R_SERVER'
,p_condition_element=>'P257_DETAIL_R_SERVER'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183891792738322722.4001)
,p_event_id=>wwv_flow_api.id(183891633291322721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(367382750186014176.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183891880973322723.4001)
,p_event_id=>wwv_flow_api.id(183891633291322721.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(367382750186014176.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183891945456322724.4001)
,p_name=>'Show Second PK'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_R_PK'
,p_condition_element=>'P257_DETAIL_R_PK'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'ROWID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183892035841322725.4001)
,p_event_id=>wwv_flow_api.id(183891945456322724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_R_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183892123313322726.4001)
,p_event_id=>wwv_flow_api.id(183891945456322724.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_R_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183892348565322728.4001)
,p_name=>'Show or Hide REST Data Source PK2 column'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_W_PK'
,p_condition_element=>'P257_DETAIL_W_PK'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183892485400322729.4001)
,p_event_id=>wwv_flow_api.id(183892348565322728.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_W_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183892532900322730.4001)
,p_event_id=>wwv_flow_api.id(183892348565322728.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P257_DETAIL_W_PK2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183892935735322734.4001)
,p_name=>'Web Src Module is NOT NULL'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P257_DETAIL_W_WEB_SRC'
,p_condition_element=>'P257_DETAIL_W_WEB_SRC'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183893010505322735.4001)
,p_event_id=>wwv_flow_api.id(183892935735322734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(367400145770083665.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183893143522322736.4001)
,p_event_id=>wwv_flow_api.id(183892935735322734.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(367400145770083665.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(529627337925093361.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create master detail page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_master  wwv_flow_wizard_api.t_md;',
'    l_detail  wwv_flow_wizard_api.t_md;',
'    l_details wwv_flow_wizard_api.t_mds;',
'begin',
'    l_master.location     := :P239_MASTER_LOCATION;',
'    l_detail.location     := :P257_DETAIL_LOCATION;',
'    case',
'        when l_master.location = ''LOCAL'' then',
'            l_master.owner                := :P239_MASTER_OWNER;',
'            l_master.table_name           := :P239_MASTER_TABLE;',
'            l_master.cols                 := :P239_MASTER_COLUMNS;',
'            l_master.pk_col               := :P239_MASTER_PK;',
'            l_master.pk_col2              := :P239_MASTER_PK2;',
'            l_master.navigation_order_col := :P239_MASTER_NAV_ORDER;',
'            l_master.primary_label_col    := :P239_MASTER_DISP_COL1;',
'            l_master.secondary_label_col  := :P239_MASTER_DISP_COL2;',
'        when l_master.location = ''REMOTE'' then',
'            l_master.owner                := :P239_MASTER_R_OWNER;',
'            l_master.table_name           := :P239_MASTER_R_TABLE;',
'            l_master.remote_server_id     := :P239_MASTER_R_SERVER;',
'            l_master.cols                 := :P239_MASTER_R_COLUMNS;',
'            l_master.pk_col               := :P239_MASTER_R_PK;',
'            l_master.pk_col2              := :P239_MASTER_R_PK2;',
'            l_master.navigation_order_col := :P239_MASTER_R_NAV_ORDER;',
'            l_master.primary_label_col    := :P239_MASTER_R_DISP_COL1;',
'            l_master.secondary_label_col  := :P239_MASTER_R_DISP_COL2;',
'        when l_master.location = ''WEB_SOURCE'' then',
'            l_master.web_src_module_id    := :P239_MASTER_W_WEB_SRC;',
'            l_master.cols                 := :P239_MASTER_W_COLUMNS;',
'            l_master.pk_col               := :P239_MASTER_W_PK;',
'            l_master.pk_col2              := :P239_MASTER_W_PK2;',
'            l_master.navigation_order_col := :P239_MASTER_W_NAV_ORDER;',
'            l_master.primary_label_col    := :P239_MASTER_W_DISP_COL1;',
'            l_master.secondary_label_col  := :P239_MASTER_W_DISP_COL2;',
'    end case;',
'',
'    case',
'        when l_detail.location = ''LOCAL'' then',
'            l_detail.owner                := :P257_DETAIL_OWNER;',
'            l_detail.table_name           := :P257_DETAIL_TABLE;',
'            l_detail.cols                 := :P257_DETAIL_COLUMNS;',
'            l_detail.pk_col               := :P257_DETAIL_PK;',
'            l_detail.pk_col2              := :P257_DETAIL_PK2;',
'            l_detail.fk_con               := :P257_DETAIL_FK_CONS;',
'            l_detail.master_col           := :P257_MASTER_COL;',
'            l_detail.detail_col           := :P257_DETAIL_COL;',
'        when l_detail.location = ''REMOTE'' then',
'            l_detail.owner                := :P257_DETAIL_R_OWNER;',
'            l_detail.table_name           := :P257_DETAIL_R_TABLE;',
'            l_detail.remote_server_id     := :P257_DETAIL_R_SERVER;   ',
'            l_detail.cols                 := :P257_DETAIL_R_COLUMNS;',
'            l_detail.pk_col               := :P257_DETAIL_R_PK;',
'            l_detail.pk_col2              := :P257_DETAIL_R_PK2;',
'            l_detail.master_col           := :P257_DETAIL_R_MASTER_COL;',
'            l_detail.detail_col           := :P257_DETAIL_R_DETAIL_COL;',
'        when l_detail.location = ''WEB_SOURCE'' then',
'            l_detail.web_src_module_id    := :P257_DETAIL_W_WEB_SRC;',
'            l_detail.cols                 := :P257_DETAIL_W_COLUMNS;',
'            l_detail.pk_col               := :P257_DETAIL_W_PK;',
'            l_detail.pk_col2              := :P257_DETAIL_W_PK2;',
'            l_detail.master_col           := :P257_DETAIL_W_MASTER_COL;',
'            l_detail.detail_col           := :P257_DETAIL_W_DETAIL_COL;',
'    end case;',
'',
'    ',
'    if :P29_MD_TYPE = ''MD_SINGLE_PG'' then',
'        l_master.region_title := :P239_MASTER_REGION_TITLE;',
'        l_detail.region_title := :P257_DETAIL_REGION_TITLE;',
'        wwv_flow_wizard_api.create_md_single_page (',
'            p_application_id           => :FB_FLOW_ID,',
'            p_page_id                  => :P32_PAGE_ID,',
'            p_page_name                => :P32_PAGE_NAME,',
'            p_page_mode                => :P32_PAGE_MODE,',
'            p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'            --      ',
'            p_tab_set                  => :P4716_TAB_SET,',
'            p_tab_name                 => :P4716_TAB_NAME,',
'            p_tab_text                 => :P4716_TAB_LABEL,',
'            --',
'            p_nav_list_id              => :P4716_NAVLIST_ID,',
'            p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'            --',
'            p_breadcrumb_id            => :P32_BREADCRUMB_ID,',
'            p_breadcrumb_name          => :P32_BREADCRUMB_NAME,',
'            p_parent_bc_id             => :P32_BREADCRUMB_PARENT_ID,',
'            --',
'            p_master_region            => l_master,',
'            p_detail_region            => l_detail  );',
'',
'        :fb_flow_page_id       := :P32_PAGE_ID;',
'        :F4000_RUN_EDIT_PAGE   := :P32_PAGE_ID;',
'',
'    elsif :P29_MD_TYPE = ''MD_EMAIL_STYLE'' then',
'',
'        l_master.page_id := wwv_flow_utilities.minimum_free_page( p_flow_id => :FB_FLOW_ID, p_start_page => :P32_PAGE_ID );',
'        l_detail.page_id := wwv_flow_utilities.minimum_free_page( p_flow_id => :FB_FLOW_ID, p_start_page => :P32_PAGE_ID );',
'',
'        l_master.singular_name := :P239_MASTER_REGION_TITLE;',
'        l_master.plural_name   := :P239_MASTER_REGION_TITLE;',
'        l_detail.singular_name := :P257_DETAIL_REGION_TITLE;',
'        l_detail.plural_name   := :P257_DETAIL_REGION_TITLE;',
'',
'        l_details( 1 ) := l_detail;',
'',
'        wwv_flow_wizard_api.create_md_side_by_side (',
'            p_app_id                   => :FB_FLOW_ID,',
'            p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'            --',
'            p_md_page_id               => :P98_STARTING_PAGE_ID,',
'            p_md_page_name             => :P98_MD_PAGE_NAME,',
'            p_md_page_mode             => wwv_flow_page.c_page_mode_normal,',
'            --',
'            p_table_owner              => l_master.owner,',
'            p_master                   => l_master,',
'            p_details                  => l_details,',
'            --      ',
'            p_tab_set                  => :P4716_TAB_SET,',
'            p_tab_name                 => :P4716_TAB_NAME,',
'            p_tab_text                 => :P4716_TAB_LABEL,',
'            --',
'            p_nav_list_id              => :P4716_NAVLIST_ID,',
'            p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'            --',
'            p_breadcrumb_id            => :P98_BREADCRUMB_ID,',
'            p_breadcrumb_name          => :P98_MD_BC_NAME,',
'            p_parent_bc_id             => :P98_BREADCRUMB_PARENT_ID );',
'            ',
'        :fb_flow_page_id       := :P98_STARTING_PAGE_ID;',
'        :F4000_RUN_EDIT_PAGE   := :P98_STARTING_PAGE_ID;',
'            ',
'    elsif :P29_MD_TYPE = ''MD_TWO_PG'' then',
'        l_master.page_id              := :P326_MASTER_PAGE_ID;',
'        l_master.page_name            := :P326_MASTER_PAGE_NAME;',
'        l_master.breadcrumb_name      := :P326_MASTER_BC_NAME;',
'        l_master.region_title         := :P326_MASTER_PAGE_NAME;',
'        l_master.navigation_order_col := :P239_MASTER_NAV_ORDER;',
'',
'        l_detail.page_id              := :P326_DETAIL_PAGE_ID;',
'        l_detail.page_name            := :P326_DETAIL_PAGE_NAME;',
'        l_detail.page_mode            := wwv_flow_page.c_page_mode_normal;',
'        l_detail.breadcrumb_name      := :P326_DETAIL_BC_NAME;',
'        l_detail.region_title         := :P326_DETAIL_PAGE_NAME;',
'',
'        wwv_flow_wizard_api.create_md_two_page (',
'            p_application_id            => :FB_FLOW_ID,',
'            p_user_interface_id         => :P259_USER_INTERFACE_ID,',
'            --',
'            p_tab_set                   => :P4716_TAB_SET,',
'            p_tab_name                  => :P4716_TAB_NAME,',
'            p_tab_text                  => :P4716_TAB_LABEL,',
'            --',
'            p_nav_list_id               => :P4716_NAVLIST_ID,',
'            p_nav_list_parent_item_id   => :P4716_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name  => :P4716_NAVLIST_ENTRY_NAME,',
'            --',
'            p_breadcrumb_id             => :P326_BREADCRUMB_ID,',
'            p_parent_bc_id              => :P326_BREADCRUMB_PARENT_ID,',
'            --',
'            p_master                    => l_master,',
'            p_detail                    => l_detail );',
'',
'        :fb_flow_page_id       := :P326_MASTER_PAGE_ID;',
'        :F4000_RUN_EDIT_PAGE   := :P326_MASTER_PAGE_ID;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la p\00E1gina maestra/de detalles. #SQLERRM#')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(529609141995093346.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(513676273762698814.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'close dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(529609141995093346.4001)
,p_process_success_message=>unistr('P\00E1gina Maestro/Detalle creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4389357063486632945.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Preset Master PK Column'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P257_MASTER_COL := case :P239_MASTER_LOCATION',
'                            when ''LOCAL''      then :P239_MASTER_PK',
'                            when ''REMOTE''     then :P239_MASTER_R_PK',
'                            when ''WEB_SOURCE'' then :P239_MASTER_W_PK',
'                        end;',
'    :P257_DETAIL_R_MASTER_COL := :P257_MASTER_COL;',
'    :P257_DETAIL_W_MASTER_COL := :P257_MASTER_COL;',
'end;',
'    ',
'       '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00258
begin
wwv_flow_api.create_page(
 p_id=>258.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Informe'
,p_step_title=>'Editar Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_row_templates t, wwv_flow_themes th',
'where t.id = :F4000_P258_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_report.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2346347658087535.4001)
,p_plug_name=>'button box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2346347659089700.4001)
,p_plug_name=>'Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2346347660092590.4001)
,p_plug_name=>'Plantillas de Columna'
,p_region_name=>'ROW'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2346347661118096.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COM'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>240
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2346347662147428.4001)
,p_plug_name=>'Plantillas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Las plantillas de informe permiten controlar los resultados de la fila de una consulta SQL. Esta plantilla define una celda no una fila completa.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6669756982775382.4001)
,p_plug_name=>unistr('Subplantilla de Paginaci\00F3n')
,p_region_name=>'PG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8660015968075276.4001)
,p_plug_name=>unistr('Despu\00E9s de Cada Fila')
,p_region_name=>'AFTER'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28562360017818729.4001)
,p_plug_name=>'Antes de Filas'
,p_region_name=>'BEFORE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31959320827513361.4001)
,p_plug_name=>'Resaltado de Fila '
,p_region_name=>'HIGH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33633213596068637.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P258_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_02=>'ROW_TEMPLATE_NAME'
,p_attribute_03=>'F4000_P258_ID'
,p_attribute_04=>'F4000_P258_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46188623746907178.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81716255746380489.4001)
,p_plug_name=>'Cabeceras de Columna'
,p_region_name=>'COL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92864800532521708.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202662218617305708.4001)
,p_plug_name=>'Antes de Cada Fila'
,p_region_name=>'BER'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202666727537327236.4001)
,p_plug_name=>unistr('Despu\00E9s de Filas')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(631926347929070683.4001)
,p_name=>'Opciones de Plantilla'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and report_template_id = :F4000_P258_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P258_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(631927068092070688.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(631926608214070688.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688542701649461323.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(631926769650070688.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688542886016461323.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688542932971461323.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(688543512972468528.4001)
,p_name=>'Opciones de Plantilla Global'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_parent_plug_id=>wwv_flow_api.id(631926347929070683.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o,',
'       wwv_flow_row_templates t',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types     = ''REPORT''',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P258_ID   ',
'   and o.security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P258_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688544241100468528.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688544083520468528.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688543764270468528.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688544186391468528.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688543864672468528.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688543947562468528.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932807415022193718.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P258_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P258_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1094586559791933034.4001)
,p_plug_name=>'Hoja de Estilo en Cascada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>230
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1094586653151933035.4001)
,p_plug_name=>'JavaScript'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(168807056558718055.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33633213596068637.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P258_ID.,&FLOW_PAGE_ID.,REPORT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_row_templates',
'',
'where reference_id = :F4000_P258_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166704164225630527.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33633213596068637.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_row_templates',
'',
'where id = :F4000_P258_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(286272007882736617.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(286271918926736617.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(631927126472070688.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(631926347929070683.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_REPORT_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P258_THEME.,&F4000_P258_ID.,REPORT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2346347629058231.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2346347630058235.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:505:&SESSION.::&DEBUG.::P505_ID:&F4000_P258_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P258_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2346347631058235.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P258_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2346347632058235.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P258_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(286284130594736673.4001)
,p_branch_action=>'f?p=&APP_ID.:258:&SESSION.::&DEBUG.::F4000_P258_ID:&P258_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(286271918926736617.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(286284513168736674.4001)
,p_branch_action=>'f?p=&APP_ID.:258:&SESSION.::&DEBUG.::F4000_P258_ID:&P258_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(286272007882736617.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2346398057989414.4001)
,p_branch_action=>'258'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'v(''F4000_P258_RETUEN_TO_SELF'') = ''YES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(166704548187630530.4001)
,p_branch_action=>'258'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(166704164225630527.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2346347634058243.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(837440512748841416.4001)
,p_branch_name=>'Page Designer: Redirect to Column Template'
,p_branch_action=>'f?p=&APP_ID.:4654:&SESSION.::&DEBUG.:RP,4654:F4000_P4654_ID:&F4000_P258_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where id                = :F4000_P258_ID',
'   and row_template_type = ''NAMED_COLUMNS'''))
,p_branch_comment=>'This branch is needed for Page Designer which can''t distinguish between the different report template types, that''s why Page Designer always branches to the Generic Template page.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347636058249.4001)
,p_name=>'F4000_P258_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347638058255.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Plantilla'
,p_source=>'ROW_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifica un nombre para esta plantilla.',
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347639058255.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE1'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Columna 1'
,p_source=>'ROW_TEMPLATE1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la plantilla de columna. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul class="noIndent">',
unistr('<li>#COLUMN_VALUE#: se sustituir\00E1 por el valor de una columna</li>'),
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Un ejemplo t\00EDpico ser\00EDa:</div>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>',
'',
'<div class="instructiontext">Puede definir hasta cuatro plantillas de columna, las cuales pueden ser condicionales. Por ejemplo, puede tener colores de fondo diferentes para las filas pares y las impares, o bien resaltar las filas que cumplan una con'
||unistr('dici\00F3n definida PL/SQL.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347640058257.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION1'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Columna 1')
,p_source=>'ROW_TEMPLATE_CONDITION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">S\00F3lo se utiliza si la condici\00F3n de columna est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite aplicar formato a columnas seg\00FAn los datos de dicha fila.</div>'),
unistr('<div class="htmldbInfoBodyP">Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</div>'),
'<pre>',
':SAL &gt; 2000',
'</pre>',
unistr('<div class="htmldbInfoBodyP">Tenga en cuenta que se debe hacer referencia a los nombres de columna mediante la sintaxis de variable de enlace, es decir, utilice :SAL en lugar de #SAL#. Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</d')
||'iv>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347641058257.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Columna 2 '
,p_source=>'ROW_TEMPLATE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la plantilla de columna. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul class="noIndent">',
unistr('<li>#COLUMN_VALUE#: se sustituir\00E1 por el valor de una columna</li>'),
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Define la plantilla de columna. Un ejemplo t\00EDpico ser\00EDa:</div>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347642058257.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Columna 2')
,p_source=>'ROW_TEMPLATE_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">S\00F3lo se utiliza si la condici\00F3n de columna est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite aplicar formato a columnas seg\00FAn los datos de dicha fila.</div>'),
unistr('<div class="htmldbInfoBodyP">Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</div>'),
'<pre>',
':SAL &gt; 2000',
'</pre>',
unistr('<div class="htmldbInfoBodyP">Tenga en cuenta que se debe hacer referencia a los nombres de columna mediante la sintaxis de variable de enlace, es decir, utilice :SAL en lugar de #SAL#. Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</d')
||'iv>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347643058258.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE3'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Columna 3'
,p_source=>'ROW_TEMPLATE3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la plantilla de columna. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul class="NoIndent">',
'<li>#COLUMN_VALUE#: se sustituye por el valor de una columna</li>',
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Un ejemplo t\00EDpico ser\00EDa:</div>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347644058258.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION3'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Columna 3')
,p_source=>'ROW_TEMPLATE_CONDITION3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">S\00F3lo se utiliza si la condici\00F3n de columna est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite aplicar formato a columnas seg\00FAn los datos de dicha fila.</div>'),
unistr('<div class="htmldbInfoBodyP">Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</div>'),
'<pre>',
':SAL &gt; 2000',
'</pre>',
unistr('<div class="htmldbInfoBodyP">Tenga en cuenta que se debe hacer referencia a los nombres de columna mediante la sintaxis de variable de enlace, es decir, utilice :SAL en lugar de #SAL#. Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</d')
||'iv>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347645058258.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE4'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Columna 4 '
,p_source=>'ROW_TEMPLATE4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la plantilla de columna. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul class="noIndent">',
'<li>#COLUMN_VALUE#: se sustituye por el valor de una columna</li>',
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Un ejemplo t\00EDpico ser\00EDa:</div>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347646058259.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION4'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Columna 4')
,p_source=>'ROW_TEMPLATE_CONDITION4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">S\00F3lo se utiliza si la condici\00F3n de columna est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite aplicar formato a columnas seg\00FAn los datos de dicha fila.</div>'),
unistr('<div class="htmldbInfoBodyP">Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</div>'),
'<pre>',
':SAL &gt; 2000',
'</pre>',
unistr('<div class="htmldbInfoBodyP">Tenga en cuenta que se debe hacer referencia a los nombres de columna mediante la sintaxis de variable de enlace, es decir, utilice :SAL en lugar de #SAL#. Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</d')
||'iv>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346347647058261.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_COMMENT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(2346347661118096.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'ROW_TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346393976043681.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_BEFORE_ROWS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(28562360017818729.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table>'
,p_prompt=>'Antes de Filas'
,p_source=>'ROW_TEMPLATE_BEFORE_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML que aparecer\00E1 una vez al principio de una plantilla de informe.</p>'),
unistr('<p>El uso m\00E1s com\00FAn de este atributo es abrir una tabla HTML:</p>'),
'<pre>&lt;table&gt;</pre>',
unistr('<p>Si desea mostrar la paginaci\00F3n sobre los informes, la plantilla debe especificar la siguiente cadena de sustituci\00F3n:</p>'),
'<pre>#TOP_PAGINATION#</pre>',
unistr('<p>La cadena de sustituci\00F3n #TOP_PAGINATION# genera el HTML que se inicia con una etiqueta de apertura &lt;tr&gt; y termina en una etiqueta de cierre &lt;/tr&gt;. Normalmente, se incluir\00EDa una etiqueta de tabla abierta y la cadena de sustituci\00F3n #TOP')
||'_PAGINATION#, como se muestra en el siguiente ejemplo:</p>',
'<pre>&lt;table&gt;#TOP_PAGINATION#</pre>',
unistr('<p>Puede utilizar la cadena de sustituci\00F3n #CSV_LINK# si desea soportar la exportaci\00F3n del informe a formato CSV a fin de utilizarlo en hojas de c\00E1lculo.</p>'),
unistr('<p>Tambi\00E9n puede utilizar la cadena de sustituci\00F3n #REPORT_ATTRIBUTES#, que se define por regi\00F3n de informe en la p\00E1gina de atributos del informe.</p>'),
unistr('<p>Tambi\00E9n puede utilizar la cadena de sustituci\00F3n #COMPONENT_CSS_CLASSES#. Esta cadena de sustituci\00F3n se define en la p\00E1gina de edici\00F3n de regi\00F3n</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346393977055422.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_AFTER_ROWS'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(202666727537327236.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>unistr('Despu\00E9s de Filas')
,p_source=>'ROW_TEMPLATE_AFTER_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Este texto aparece despu\00E9s de la \00FAltima fila. Normalmente, aqu\00ED se cierra la etiqueta de tabla HTML.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;/table&gt;</pre>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles:</div>'),
'<ul class="noIndent">',
unistr('<li>#PAGINATION#: se sustituir\00E1 por el atributo de paginaci\00F3n</li>'),
unistr('<li>#COLCOUNT#: n\00FAmero de columnas HTML que se abarcan</li>'),
unistr('<li>#CSV_LINK#: se sustituir\00E1 por el enlace de descarga de CSV, si se activa la exportaci\00F3n de CSV; de lo contrario, no se mostrar\00E1 la cadena</li>'),
unistr('<li>#EXTERNAL_LINK#: se sustituir\00E1 por el enlace de descarga para las exportaciones mediante un motor de procesamiento externo, por ejemplo, la exportaci\00F3n de PDF; si esta funci\00F3n no est\00E1 activada, no se mostrar\00E1 la cadena</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2346398056982355.4001)
,p_name=>'F4000_P258_RETUEN_TO_SELF'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(2346347662147428.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6670379838781921.4001)
,p_name=>'F4000_P258_PAGINATION_TEMPLATE'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(6669756982775382.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de Paginaci\00F3n')
,p_source=>'PAGINATION_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Este atributo se aplica a la subplantilla de paginaci\00F3n completa. Puede realizar m\00E1s modificaciones en cada uno de los elementos de la subplantilla a continuaci\00F3n.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;span class="instructiontext"&gt;#TEXT#&lt;/span&gt;</pre>',
unistr('<div class="htmldbInfoBodyP">Utilice la cadena de sustituci\00F3n #TEXT# donde desee que se muestre la subplantilla de paginaci\00F3n</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6673749541811041.4001)
,p_name=>'F4000_P258_NEXT_PAGE_TEMPLATE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(6669756982775382.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de P\00E1gina Siguiente')
,p_source=>'NEXT_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML para modificar c\00F3mo aparece la parte "P\00E1gina Siguiente" de la subplantilla de paginaci\00F3n .</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;a href="#LINK#"&gt;siguiente&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6674565818815735.4001)
,p_name=>'F4000_P258_PREV_PAGE_TEMPLATE'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(6669756982775382.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de P\00E1gina Anterior')
,p_source=>'PREVIOUS_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML para modificar c\00F3mo aparece la parte "P\00E1gina Anterior" de la subplantilla de paginaci\00F3n.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;a href="#LINK#"&gt;anterior&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6675460061823585.4001)
,p_name=>'F4000_P258_PREV_SET_TEMPLATE'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(6669756982775382.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Juego Anterior'
,p_source=>'PREVIOUS_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML para modificar c\00F3mo aparece la parte "Juego Anterior" de la subplantilla de paginaci\00F3n.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;a href="#LINK#"&gt;juego anterior&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6676169065826187.4001)
,p_name=>'F4000_P258_NEXT_SET_TEMPLATE'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(6669756982775382.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Juego Siguiente'
,p_source=>'NEXT_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML para modificar c\00F3mo aparece la parte "Juego Siguiente" de la subplantilla de paginaci\00F3n.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;a href="#LINK#"&gt;juego siguiente&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24148405197499297.4001)
,p_name=>'P258_TRANSLATABLE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Indique la posibilidad de traducir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28565851390822743.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_BEFORE_FIRST'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(202662218617305708.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes de Cada Fila'
,p_source=>'ROW_TEMPLATE_BEFORE_FIRST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Muestre este texto antes que todas las columnas del informe. Utilice este atributo para abrir una fila HTML nueva. Se utiliza \00FAnicamente para plantillas de columna.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;tr&gt;</pre>',
unistr('<div class="htmldbInfoBodyP">Antes de Cada Fila soporta las siguientes cadenas de sustituci\00F3n:</div>'),
'<ul>',
'<li>#ROWNUM#: Especifica la fila actual</li>',
unistr('<li>#COLCOUNT#: Especifica el n\00FAmero de columnas</li>'),
'<li>#HIGHLIGHT_ROW#: Activa el resalte de filas</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28567177257825935.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_AFTER_LAST'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(8660015968075276.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s de Cada Fila')
,p_source=>'ROW_TEMPLATE_AFTER_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Mostrar este HTML despu\00E9s de todas las columnas de la visualizaci\00F3n de informe. Se suele utilizar para cerrar una fila de tabla HTML. S\00F3lo se utiliza en plantillas de columna.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>&lt;/tr&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31963525591533693.4001)
,p_name=>'P258_ROW_STYLE_CHECKED'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(31959320827513361.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Color de Fondo para Fila Comprobada'
,p_source=>'ROW_STYLE_CHECKED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Este atributo controla el color de fondo de una fila del informe cuando se activa el selector de filas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31968203128555576.4001)
,p_name=>'P258_ROW_STYLE_MOUSE_OVER'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(31959320827513361.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Color de Fondo para Fila Actual'
,p_source=>'ROW_STYLE_MOUSE_OVER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Este atributo controla el color de fondo de una fila del informe cuando el usuario mueve el mouse sobre la fila.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36865470879655498.4001)
,p_name=>'F4000_P258_REFRESH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(33633213596068637.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_row_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P258_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Active para refrescar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(44006313411345884.4001)
,p_name=>'P258_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tema al que est\00E1 asociada esta plantilla. Un tema es un grupo de plantillas que proporcionan el dise\00F1o y el estilo a una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(44032826187396906.4001)
,p_name=>'P258_TEMPLATE_CLASS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(44022800298370465.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico de esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.<p />',
'Utilice la casilla de control <strong>Se puede convertir</strong> para indicar si esta plantilla contiene cadenas de texto que hay que convertir. ',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81544764942145406.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NAMED_COLUMNS'
,p_prompt=>'Tipo de Plantilla:'
,p_source=>'ROW_TEMPLATE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ROW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84775019904954668.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Muestra el tipo de plantilla: <span class="fielddatabold">Columnas con Nombre</span> o <span class="fielddatabold">Columnas Gen\00E9ricas</strong>.</span>'),
unistr('<div class="htmldbInfoBodyP">Las plantillas del tipo Columnas con Nombre hacen referencia a nombres de columna en la plantilla, mientras que las plantillas del tipo Columnas Gen\00E9ricas hacen referencia a #COLUMN_VALUE# en la plantilla.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81562468534234915.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND1'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Columna 1')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Puede seleccionar una condici\00F3n que se debe cumplir para que se aplique esta plantilla de columna. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81567764209252138.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Columna 2')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Puede seleccionar una condici\00F3n que se debe cumplir para que se aplique esta plantilla de columna. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81568460758253709.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND3'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Columna 3')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede seleccionar una condici\00F3n que se debe cumplir para aplicar esta plantilla de columna. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81569158170254910.4001)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND4'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(2346347660092590.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Columna 4')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede seleccionar una condici\00F3n que se debe cumplir para aplicar esta plantilla de columna. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(81717373837402481.4001)
,p_name=>'F4000_P258_COLUMN_HEADING_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(81716255746380489.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Cabecera de Columna'
,p_source=>'COLUMN_HEADING_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Este atributo se utiliza s\00F3lo con plantillas de columnas gen\00E9ricas. Utilice esta plantilla para colorear cada celda de cabecera de columna. El texto de este atributo debe incluir ayuda para indicar d\00F3nde se va a colorear ')
||'el texto de la cabecera de celda.</div>',
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>',
' &lt;th &gt;Texto de Ayuda de Elemento&lt;/th&gt;',
'</pre>',
unistr('<div class="htmldbInfoBodyP">Si no desea ning\00FAn encabezado de columna, introduzca:</div>'),
'<pre>',
'OMIT',
'</pre>',
'<div class="htmldbInfoBodyP">Si utiliza este atributo, el motor &PRODUCT_NAME. aplica la plantilla de encabezado de columna por defecto.</div>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121996405583446302.4001)
,p_name=>'P258_BEFORE_COLUMN_HEADING'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(81716255746380489.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Delante de Cabecera de Columna'
,p_source=>'BEFORE_COLUMN_HEADING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Mostrar este texto delante de las cabeceras de informe.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121997415626449175.4001)
,p_name=>'P258_AFTER_COLUMN_HEADING'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(81716255746380489.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Detr\00E1s de Cabecera de Columna')
,p_source=>'AFTER_COLUMN_HEADING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Mostrar este texto detr\00E1s de las cabeceras de informe.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(166718960697643890.4001)
,p_name=>'F4000_P258_REFERENCE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33633213596068637.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REPORT_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(row_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_row_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(286281925598736656.4001)
,p_name=>'P258_ID_NEXT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_prompt=>'P258_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(286282327774736657.4001)
,p_name=>'P258_ID_PREV'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_prompt=>'P258_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(286282700053736661.4001)
,p_name=>'P258_ID_COUNT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(2346347658087535.4001)
,p_prompt=>'Plantilla de Informe: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la plantilla de informe'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631927337180070693.4001)
,p_name=>'P258_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(631926347929070683.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select o.display_name as d,',
'         o.css_classes as r,',
'         null default_template_options,',
'         null,',
'         o.help_text,',
'         (select display_name ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text         ',
'    from wwv_flow_template_options o,',
'       wwv_flow_row_templates t',
'   where o.flow_id = :FB_FLOW_ID',
'     and o.template_types = ''REPORT''',
'     and (o.report_template_id = :F4000_P258_ID or report_template_id is NULL)',
'     and o.theme_id = t.theme_id',
'     and t.id = :F4000_P258_ID        ',
'  order by advanced_group nulls first, group_name nulls first, display_sequence, display_name',
''))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631927547368070696.4001)
,p_name=>'P258_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>235
,p_item_plug_id=>wwv_flow_api.id(631926347929070683.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_row_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.report_template_id',
'   and report_template_id = :F4000_P258_ID',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094586706434933036.4001)
,p_name=>'P258_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1094586653151933035.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo JavaScript para el c\00F3digo que se va a cargar en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code> ')
||unistr('para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a la caden')
||unistr('a de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre. Incluya solo la URL.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de /myjs/minified/ para vistas de p\00E1gina normales y main.js de /myjs/ en el modo de depuraci\00F3n.'),
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca se utiliza tambi\00E9n desde una llamada de solicitud de RequireJS. El nombre de definici\00F3n debe coincidir con el que se utilice en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global')
||' que muestre la biblioteca. Solo se aplica al utilizar RequireJS. Esto evita que RequireJS cargue la biblioteca una segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que, cuando se cambie la versi\00F3n de la aplicaci\00F3n (y se incremente la versi\00F3n), se indicar\00E1 al explorador que siempre')
||unistr(' cargue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094586832963933037.4001)
,p_name=>'P258_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1094586653151933035.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ejecutar Cuando Se Cargue la P\00E1gina')
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript que se ejecutar\00E1 cuando se cargue la p\00E1gina. Este c\00F3digo se ejecuta despu\00E9s del c\00F3digo JavaScript generado por &PRODUCT_NAME..</p>'),
'',
unistr('<p>Nota: No es necesario agregar etiquetas <code>script</code> de apertura o de cierre, solo el c\00F3digo JavaScript.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094586966491933038.4001)
,p_name=>'P258_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1094586559791933034.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar para esta plantilla de p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci')
||unistr('\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n t')
||unistr('iene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/mycss/main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), se indica al explorador que siempre ca')
||unistr('rgue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1331350164401223303.4001)
,p_name=>'P258_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador de Plantilla'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449462733914055530.4001)
,p_name=>'P258_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>245
,p_item_plug_id=>wwv_flow_api.id(631926347929070683.4001)
,p_source=>'P258_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104771809517963281.4001)
,p_name=>'P258_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2346347659089700.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(147424606635330192.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P258_THEME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104772167942969692.4001)
,p_computation_sequence=>10
,p_computation_item=>'P258_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_row_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P258_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(36873662469659426.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P258_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(166767555916691592.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P258_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(166704164225630527.4001)
,p_associated_item=>wwv_flow_api.id(166718960697643890.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(166777376822697105.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P258_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(166704164225630527.4001)
,p_associated_item=>wwv_flow_api.id(166718960697643890.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(82403813964612670.4001)
,p_validation_name=>'NameNotNull'
,p_validation_sequence=>30
,p_validation=>'F4000_P258_ROW_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe proporcionar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(2346347631058235.4001)
,p_associated_item=>wwv_flow_api.id(2346347638058255.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397291918493409185.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P258_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397292204618409185.4001)
,p_event_id=>wwv_flow_api.id(397291918493409185.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(286272007882736617.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397292324380410866.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P258_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397292600298410866.4001)
,p_event_id=>wwv_flow_api.id(397292324380410866.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(286271918926736617.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(632853201142828724.4001)
,p_name=>'refresh template options'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(631927126472070688.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632853531524828728.4001)
,p_event_id=>wwv_flow_api.id(632853201142828724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:258:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(632854356797834412.4001)
,p_name=>'refresh template options after refresh'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(631926347929070683.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632854671763834412.4001)
,p_event_id=>wwv_flow_api.id(632854356797834412.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(631926347929070683.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:258:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(805660071958101245.4001)
,p_name=>'Row Template Condition 1 Changes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND1'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND1'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(805660125669101246.4001)
,p_event_id=>wwv_flow_api.id(805660071958101245.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(805660228504101247.4001)
,p_event_id=>wwv_flow_api.id(805660071958101245.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(805660387460101248.4001)
,p_name=>'Row Template Condition 2 Changes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND2'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND2'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(805660452134101249.4001)
,p_event_id=>wwv_flow_api.id(805660387460101248.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(805660529092101250.4001)
,p_event_id=>wwv_flow_api.id(805660387460101248.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846215325705982701.4001)
,p_name=>'Row Template Condition 3 Changes'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND3'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND3'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846215445883982702.4001)
,p_event_id=>wwv_flow_api.id(846215325705982701.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846215520026982703.4001)
,p_event_id=>wwv_flow_api.id(846215325705982701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846215660135982704.4001)
,p_name=>'Row Template Condition 4 Changes'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND4'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND4'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846215726551982705.4001)
,p_event_id=>wwv_flow_api.id(846215660135982704.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846215885918982706.4001)
,p_event_id=>wwv_flow_api.id(846215660135982704.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(286283716135736670.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_03=>'F4000_P258_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'ROW_TEMPLATE_NAME'
,p_attribute_09=>'P258_ID_NEXT'
,p_attribute_10=>'P258_ID_PREV'
,p_attribute_13=>'P258_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and ROW_TEMPLATE_TYPE = ''GENERIC_COLUMNS'''
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(115831113618183762.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_03=>'F4000_P258_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166801747924710582.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P258_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P258_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(166704164225630527.4001)
,p_process_when=>'F4000_P258_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2346347649058271.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ROW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P258_ID is null',
'or exists (select 1 from wwv_flow_row_templates',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P258_ID)) loop',
'wwv_flow_dml.process(',
'  p_action => wwv_flow.g_request,',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_ROW_TEMPLATES'',',
'  p_rowid       => v(''F4000_P258_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Cambios en la plantilla de fila &F4000_P258_ROW_TEMPLATE_NAME. procesados.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(36883275611668571.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P258_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P258_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>':F4000_P258_REFERENCE_ID is not null and :F4000_P258_REFRESH = ''Y'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1449462856927055531.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_report_tmplopt_presets(:F4000_P258_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P258_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P258_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166813158695720764.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_report_reference_id (:F4000_P258_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'F4000_P258_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
);
end;
/
prompt --application/pages/page_00259
begin
wwv_flow_api.create_page(
 p_id=>259.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21125311149612013.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_css_classes=>'a-Form a-Form--leftLabels a-Form--fixedLabels'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231172284315226013.4001)
,p_plug_name=>'Non-Universal Theme Warning'
,p_parent_plug_id=>wwv_flow_api.id(21125311149612013.4001)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="margin-bottom: 0"'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Su aplicaci\00F3n solo admite la adici\00F3n de la funci\00F3n <strong>P\00E1gina de conexi\00F3n</strong>. Para el resto de funciones se requieren aplicaciones basadas en Tema universal. '),
unistr('Oracle recomienda actualizar a Tema universal. Para obtener m\00E1s informaci\00F3n, consulte la <a rel="noreferrer" href="https://apex.oracle.com/ut" target="_blank">aplicaci\00F3n Tema universal</a>.</p>')))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P259_IS_UT_BASED = ''N'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231172782341226018.4001)
,p_plug_name=>unistr('Tipos de P\00E1ginas')
,p_parent_plug_id=>wwv_flow_api.id(21125311149612013.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42451407753638887.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21136020022703555.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(42451407753638887.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21135700685703553.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42451407753638887.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1670604042945234721.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42451407753638887.4001)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''&SYSTEM_HELP_URL./htmdb/page-types-create-page-wizard.html'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109877382806242512.4001)
,p_branch_name=>'Change User Interface'
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:RP:P259_USER_INTERFACE_ID:&P259_USER_INTERFACE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P259_USER_INTERFACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29998311632617120.4001)
,p_branch_name=>'Component - Report Page'
,p_branch_action=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:4700::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'REPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1902893975940723.4001)
,p_branch_name=>'Component - Map Region Page'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:4700,759,769,771:P4700_SELECT_REPORT_TYPE,P759_REPORT_TYPE:MAP_REGION,MAP_REGION'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>25
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'MAP_REGION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30001104968634081.4001)
,p_branch_name=>'Component - Chart Page'
,p_branch_action=>'f?p=&APP_ID.:751:&SESSION.::&DEBUG.:751,752,616,642,647,731, 265, 266::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'CHART'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(275644660520510024.4001)
,p_branch_name=>'Component - Dashboard Page'
,p_branch_action=>'f?p=&APP_ID.:961:&SESSION.::&DEBUG.:759,4716,961,962:P759_REPORT_TYPE:&P259_CHOOSE_PAGE_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'DASHBOARD'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30003710294645067.4001)
,p_branch_name=>'Component - Form Page'
,p_branch_action=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:362,4700::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'FORM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(275644439869510022.4001)
,p_branch_name=>'Component - MD Page'
,p_branch_action=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:29,98,99::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'MD'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(809739211229915611.4001)
,p_branch_name=>'Component - Plug-in'
,p_branch_action=>'f?p=&APP_ID.:4461:&SESSION.::&DEBUG.:4462,4464,4465,4466::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21136020022703555.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30007125316658862.4001)
,p_branch_name=>'Component - Calendar Page'
,p_branch_action=>'f?p=&APP_ID.:4462:&SESSION.::&DEBUG.:4462,4464,4465:P4462_REGION_TYPE:NATIVE_CSS_CALENDAR'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30008012980664776.4001)
,p_branch_name=>'Component - Tree Page'
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:112:P4700_SELECT_REPORT_TYPE:TREE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'TREE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16056402620813939.4001)
,p_branch_name=>'Component - Blank Page'
,p_branch_action=>'f?p=&APP_ID.:4714:&SESSION.::&DEBUG.:4714,4716,78,81,82,79,80,83,4716::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'BLANK'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3249903941392480.4001)
,p_branch_name=>'Component - Global Page'
,p_branch_action=>'f?p=&APP_ID.:698:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'GLOBAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(933383007060151476.4001)
,p_branch_name=>'Component - Data Load Page'
,p_branch_action=>'f?p=&APP_ID.:1813:&SESSION.::&DEBUG.:1813,1814:P1813_PREV_PAGE:259'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21136020022703555.4001)
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'DATALOAD'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(809610119625899096.4001)
,p_branch_name=>'Component - Wizard Page'
,p_branch_action=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:107,108,109,110,111,141,CREATE_WIZARD::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21136020022703555.4001)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'WIZARD'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(125976986637155301.4001)
,p_branch_name=>'Component - Legacy Page'
,p_branch_action=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:4700::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21136020022703555.4001)
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'LEGACY'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16053815649808232.4001)
,p_branch_name=>'Feature - Login Page'
,p_branch_action=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:500:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>160
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_branch_condition_text=>'LOGIN'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8706708498480010.4001)
,p_branch_name=>'Feature - Access Control Page'
,p_branch_action=>'f?p=&APP_ID.:572:&SESSION.::&DEBUG.:572,626::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>170
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''ACCESSCONTROL'' and ',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_acl )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196192426092873892.4001)
,p_branch_name=>'Feature - Feedback Page'
,p_branch_action=>'f?p=&APP_ID.:849:&SESSION.::&DEBUG.:849::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>180
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''FEEDBACK'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_feedback )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(693720912075042120.4001)
,p_branch_name=>'Feature - Activity Reporting'
,p_branch_action=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:RP,1310::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>190
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''ACTIVITYREPORTING'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_activity_report )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96767157858853601.4001)
,p_branch_name=>'Feature - Email Reporting'
,p_branch_action=>'f?p=&APP_ID.:1314:&SESSION.::&DEBUG.:RP,1314::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>200
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''EMAILREPORTING'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_email_report )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96767261345853602.4001)
,p_branch_name=>'Feature - Scheduler Job Reporting'
,p_branch_action=>'f?p=&APP_ID.:1315:&SESSION.::&DEBUG.:RP,1315::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>210
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''JOBREPORTING'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_job_report )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(693721477197042125.4001)
,p_branch_name=>'Feature - About this Application'
,p_branch_action=>'f?p=&APP_ID.:1313:&SESSION.::&DEBUG.:RP,1313::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>220
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''ABOUTAPP'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_about_page )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(693721123344042122.4001)
,p_branch_name=>'Feature - Configuration Options'
,p_branch_action=>'f?p=&APP_ID.:1311:&SESSION.::&DEBUG.:RP,1311::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>230
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''CONFIGOPTIONS'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_configuration )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(693721247495042123.4001)
,p_branch_name=>'Feature - Theme Style Selection'
,p_branch_action=>'f?p=&APP_ID.:1312:&SESSION.::&DEBUG.:RP,1312::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>240
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''Y'' and ',
':P259_CHOOSE_PAGE_TYPE = ''THEMESELECTION'' and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'   p_app_id       => :FB_FLOW_ID,',
'   p_feature_name => wwv_flow_app_feature_v3.c_theme_style )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(125977159392155303.4001)
,p_branch_name=>'Universal Theme only feature'
,p_branch_action=>'f?p=&APP_ID.:1316:&SESSION.::&DEBUG.:RP,1316::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>250
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P259_IS_UT_BASED = ''N'' and ',
':P259_CHOOSE_PAGE_TYPE in (',
'  ''ACCESSCONTROL'',',
'  ''FEEDBACK'',',
'  ''ACTIVITYREPORTING'',',
'  ''EMAILREPORTING'',',
'  ''JOBREPORTING'',',
'  ''ABOUTAPP'',',
'  ''CONFIGOPTIONS'',',
'  ''THEMESELECTION''',
'  )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231171700748226008.4001)
,p_branch_name=>'Feature Already Exists'
,p_branch_action=>'f?p=&APP_ID.:1317:&SESSION.::&DEBUG.:RP,1317::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>260
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(    :P259_CHOOSE_PAGE_TYPE = ''ACCESSCONTROL''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_acl )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''FEEDBACK''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_feedback )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''ACTIVITYREPORTING''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_activity_report )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''EMAILREPORTING''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_email_report )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''JOBREPORTING''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_job_report )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''ABOUTAPP''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_about_page )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''CONFIGOPTIONS''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_configuration )',
')',
'or',
'(    :P259_CHOOSE_PAGE_TYPE = ''THEMESELECTION''',
' and not wwv_flow_app_feature_v3.add_feature_page_allowed(',
'           p_app_id       => :FB_FLOW_ID,',
'           p_feature_name => wwv_flow_app_feature_v3.c_theme_style )',
')'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4373663574456977027.4001)
,p_branch_name=>'Invalid UI'
,p_branch_action=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>'select 1 from wwv_flow_user_interfaces where flow_id=:FB_FLOW_ID and security_group_id = :WORKSPACE_ID and ui_type_id = 1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125977052376155302.4001)
,p_name=>'P259_IS_UT_BASED'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(21125311149612013.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_is_ut boolean;',
'begin',
'',
'    l_is_ut := wwv_flow_theme_dev.is_universal_theme ( ',
'        p_application_id => :FB_FLOW_ID, ',
'        p_user_interface_id => :P259_USER_INTERFACE_ID );',
'   ',
'    if l_is_ut then ',
'      return ''Y'';',
'    else ',
'      return ''N'';',
'    end if;',
'',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(279539411008750003.4001)
,p_name=>'P259_SHOW_UNSUPPORTED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(231172782341226018.4001)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('El valor por defecto <strong>No</strong>, solo muestra los tipos de p\00E1ginas dise\00F1ados para la interfaz de usuario especificada. Al especificar <strong>S\00ED</strong>, solo se muestra cualquier tipo de p\00E1gina adicional que se haya dise\00F1ado para otras int')
||'erfaces de usuario.',
'</p>',
unistr('<p>Los tipos de p\00E1ginas que no est\00E1n soportados para la interfaz de usuario actual pueden tener problemas inesperados de tiempo de ejecuci\00F3n. Oracle no garantiza ni proporciona soporte relacionado con el uso de los tipos de p\00E1ginas no soportados y su')
||unistr(' uso es a discreci\00F3n del propio usuario.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367726814753954000.4001)
,p_name=>'P259_CHOOSE_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(231172782341226018.4001)
,p_item_default=>'BLANK'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CHOOSE_PAGE_TYPE_P259'
,p_lov=>'.'||wwv_flow_api.id(21148926321786721.4001)||'.'
,p_lov_cascade_parent_items=>'P259_SHOW_UNSUPPORTED,P259_PAGE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381229947280572397.4001)
,p_name=>'P259_NAVIGATION_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(21125311149612013.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(645332577445941503.4001)
,p_name=>'P259_PAGE_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(21125311149612013.4001)
,p_item_default=>'PAGE'
,p_prompt=>unistr('Tipo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_TYPE_SELECTION'
,p_lov=>'.'||wwv_flow_api.id(497897080593180120.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un tipo de componente de p\00E1gina que le gustar\00EDa crear en su aplicaci\00F3n. <br><br>'),
'<ul>',
unistr('<li>Las p\00E1ginas de <strong>componente</strong> proporcionan funcionalidad de nivel de p\00E1gina y se pueden agregar varias veces a una aplicaci\00F3n determinada. Algunos ejemplos son:'),
unistr('informes, formularios, plugins, gr\00E1ficos, calendarios, etc. </li>'),
unistr('<li>Las p\00E1ginas de <strong>funci\00F3n</strong> proporcionan funcionalidad de nivel de aplicaci\00F3n, y normalmente se agregan una vez por aplicaci\00F3n. Algunos ejemplos son: p\00E1gina Acerca de, Control de acceso, Generaci\00F3n de informes de actividades, Comentar')
||unistr('ios y P\00E1gina de conexi\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(711860359423245731.4001)
,p_name=>'P259_USER_INTERFACE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(21125311149612013.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and rownum = 1 ',
' order by display_seq'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(381231295326635244.4001)
,p_computation_sequence=>10
,p_computation_item=>'P259_NAVIGATION_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where x.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
'   and x.flow_id           = i.flow_id',
'   and i.id                = :P259_USER_INTERFACE_ID',
'   and i.theme_id          = x.theme_id',
' order by 1'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(711860595789245733.4001)
,p_computation_sequence=>10
,p_computation_item=>'P259_USER_INTERFACE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and ui_type_id = 1',
'   and rownum = 1 ',
' order by display_seq'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548117110270252641.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(21135700685703553.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548117413682252648.4001)
,p_event_id=>wwv_flow_api.id(548117110270252641.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(231172359754226014.4001)
,p_name=>'Set Page Type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P259_PAGE_TYPE'
,p_condition_element=>'P259_PAGE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FEATURE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(231172855058226019.4001)
,p_event_id=>wwv_flow_api.id(231172359754226014.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(231172284315226013.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(231172421935226015.4001)
,p_event_id=>wwv_flow_api.id(231172359754226014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(231172284315226013.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(969051635627554603.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Navigation Menu / Tabs'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'4716'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(727967882697812577.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00260
begin
wwv_flow_api.create_page(
 p_id=>260.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Temas'
,p_step_title=>'Temas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40585504519890825.4001)
,p_plug_name=>'Temas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       theme_id, ',
'       current_theme_id,',
'       theme_name || (case when theme_id = current_theme_id then '' *'' end) as theme_name, ',
'       icon_class, ',
'       edit_link, ',
'       case when theme_id = current_theme_id then ''Y'' else ''N'' end as is_current,',
'       case when theme_id = current_theme_id then ''icon-check'' end as is_current_css,',
'       wwv_flow_theme_dev.is_universal_theme_yn(p_theme_id => id) as is_universal_theme,',
'       case when wwv_flow_theme_dev.is_universal_theme_yn(p_theme_id => id)=''Y'' then ''icon-check'' end as is_universal_theme_css,       ',
'       subscribed_from,',
'       subscribers,',
'       ui_type_id,',
'       page_templates + region_templates + button_templates + menu_templates + list_templates + label_templates + report_templates + cal_templates + popup_templates all_templates,',
'       page_templates,',
'       region_templates,',
'       button_templates,',
'       menu_templates,',
'       list_templates,',
'       label_templates,',
'       report_templates,',
'       cal_templates,',
'       popup_templates',
'from (',
'',
'select /* APEX 4000P260a */ id, ',
'      theme_id, ',
'      (select max(theme_id) as current_theme_id from wwv_flow_user_interfaces where flow_id=:fb_flow_id and ui_type_id = t.ui_type_id) as current_theme_id,',
'      theme_name || '' - '' || theme_id as theme_name,       ',
'      ''icon-sc-theme'' icon_class,',
'      ''f?p=4000:267:''||:app_session||'':::267:P267_ID:''||id edit_link,',
'       case when reference_id is not null then',
'           coalesce ( ( select case',
'                                 when security_group_id in ( 11, 12 ) then wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.THEME_REPOSITORY'' )',
'                                 else to_char( flow_id )',
'                               end',
'                          from wwv_flow_themes',
'                         where id                = t.reference_id',
'                           and security_group_id in ( :WORKSPACE_ID, 11, 12 )',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_themes',
'          where reference_id      = t.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       ui_type_id,',
'       (select count(*) from wwv_flow_templates where flow_id = :fb_flow_id and theme_id = t.theme_id) page_templates,',
'       (select count(*) from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) region_templates,',
'       (select count(*) from WWV_FLOW_BUTTON_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) button_templates,',
'       (select count(*) from WWV_FLOW_MENU_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) menu_templates,',
'       (select count(*) from WWV_FLOW_LIST_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) list_templates,',
'       (select count(*) from WWV_FLOW_FIELD_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) label_templates,',
'       (select count(*) from WWV_FLOW_ROW_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) report_templates,',
'       (select count(*) from WWV_FLOW_CAL_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) cal_templates,',
'       (select count(*) from WWV_FLOW_POPUP_LOV_TEMPLATE where flow_id = :fb_flow_id and theme_id = t.theme_id) popup_templates',
'   from WWV_FLOW_THEMES t',
'  where flow_id           = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id',
')',
'',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(40585608941890825.4001)
,p_name=>'Themes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_pivot=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#THEME_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40585822448890851.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40585916838890854.4001)
,p_db_column_name=>'THEME_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('N\00FAmero')
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586030398890855.4001)
,p_db_column_name=>'THEME_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.::P267_ID:#ID#'
,p_column_linktext=>'#THEME_NAME#'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586308175890856.4001)
,p_db_column_name=>'IS_CURRENT'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Es Actual'
,p_column_html_expression=>'<span class="a-Icon #IS_CURRENT_CSS#"><span class="u-VisuallyHidden">#IS_CURRENT#</span></span>'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84538979289706815.4001)
,p_db_column_name=>'IS_UNIVERSAL_THEME'
,p_display_order=>14
,p_column_identifier=>'W'
,p_column_label=>'Es tema universal'
,p_column_html_expression=>'<span class="a-Icon #IS_UNIVERSAL_THEME_CSS#"><span class="u-VisuallyHidden">#IS_UNIVERSAL_THEME#</span></span>'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562746768198337.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>24
,p_column_identifier=>'U'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562836919198338.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>34
,p_column_identifier=>'V'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586211632890855.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>44
,p_column_identifier=>'E'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5386807074278378.4001)
,p_db_column_name=>'UI_TYPE_ID'
,p_display_order=>54
,p_column_identifier=>'P'
,p_column_label=>'Interfaz de Usuario'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(5268701303966420)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586424494890856.4001)
,p_db_column_name=>'PAGE_TEMPLATES'
,p_display_order=>64
,p_column_identifier=>'G'
,p_column_label=>unistr('Plantillas de P\00E1gina')
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586506938890856.4001)
,p_db_column_name=>'REGION_TEMPLATES'
,p_display_order=>74
,p_column_identifier=>'H'
,p_column_label=>unistr('Plantillas de Regi\00F3n')
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586618306890856.4001)
,p_db_column_name=>'BUTTON_TEMPLATES'
,p_display_order=>84
,p_column_identifier=>'I'
,p_column_label=>unistr('Plantillas de Bot\00F3n')
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586708548890856.4001)
,p_db_column_name=>'MENU_TEMPLATES'
,p_display_order=>94
,p_column_identifier=>'J'
,p_column_label=>unistr('Plantillas de Ruta de Navegaci\00F3n')
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586823212890856.4001)
,p_db_column_name=>'LIST_TEMPLATES'
,p_display_order=>104
,p_column_identifier=>'K'
,p_column_label=>'Plantillas de Lista'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40586925234890857.4001)
,p_db_column_name=>'LABEL_TEMPLATES'
,p_display_order=>114
,p_column_identifier=>'L'
,p_column_label=>'Plantillas de Etiqueta'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40587016960890857.4001)
,p_db_column_name=>'REPORT_TEMPLATES'
,p_display_order=>124
,p_column_identifier=>'M'
,p_column_label=>'Plantillas de Informe'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40587122871890857.4001)
,p_db_column_name=>'CAL_TEMPLATES'
,p_display_order=>134
,p_column_identifier=>'N'
,p_column_label=>'Plantillas de Calendario'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(40587216109890857.4001)
,p_db_column_name=>'POPUP_TEMPLATES'
,p_display_order=>144
,p_column_identifier=>'O'
,p_column_label=>'Plantilla Emergente'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(345065204888426150.4001)
,p_db_column_name=>'CURRENT_THEME_ID'
,p_display_order=>154
,p_column_identifier=>'Q'
,p_column_label=>'ID de Tema Actual'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(718743949460466155.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>164
,p_column_identifier=>'R'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(928046701514850016.4001)
,p_db_column_name=>'ALL_TEMPLATES'
,p_display_order=>174
,p_column_identifier=>'S'
,p_column_label=>'Plantillas'
,p_column_link=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP,4003,RIR:IR_THEME,P4003_THEME:#THEME_ID#,#THEME_ID#:'
,p_column_linktext=>'#ALL_TEMPLATES#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1143248183217567434.4001)
,p_db_column_name=>'IS_CURRENT_CSS'
,p_display_order=>184
,p_column_identifier=>'T'
,p_column_label=>'IS_CURRENT_CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(711860292864245730.4001)
,p_db_column_name=>'IS_UNIVERSAL_THEME_CSS'
,p_display_order=>194
,p_column_identifier=>'Y'
,p_column_label=>'Es CSS de tema universal'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58960202850264132.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(58949101764235429.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60309032282141216.4001)
,p_plug_name=>'Temas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas utilizadas para definir la interfaz de usuario de una aplicaci\00F3n.</p>'),
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-themes-and-theme-styles.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60454821641357947.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(60448901162323653.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(35066701739635046.4001)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from wwv_flow_themes where flow_id = :fb_flow_id'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188985409785913641.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(40585504519890825.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:260,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60462304634400305.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40585504519890825.4001)
,p_button_name=>'SWITCH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cambiar Tema'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:179::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer; begin',
'select count(*) into c from WWV_FLOW_THEMES t where FLOW_ID = :fb_flow_id;',
'if c > 1 then return true; else return false; end if;',
'end;'))
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59115302349594269.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(40585504519890825.4001)
,p_button_name=>'CREATE_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.:207,1207,208::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(59118129146611490.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'260'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(928046448457850013.4001)
,p_name=>'Themes report dialog closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(60454821641357947.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(928046526432850014.4001)
,p_event_id=>wwv_flow_api.id(928046448457850013.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(40585504519890825.4001)
);
end;
/
prompt --application/pages/page_00263
begin
wwv_flow_api.create_page(
 p_id=>263.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n: Regi\00F3n de Contenedor de Ruta de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4214301685656288.4001)
,p_plug_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>3
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>unistr('<p>Utilice este asistente para crear un control de navegaci\00F3n de interfaz de usuario de ruta de navegaci\00F3n. Empiece definiendo el nombre, la plantilla y la ubicaci\00F3n del contenedor de la regi\00F3n de la ruta de navegaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 04-DEC-2002 18:37:44'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16150807852118283.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16141621180084222.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46324232098941368.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4215226898656310.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46324232098941368.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4215518907656310.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46324232098941368.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16171505521174308.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46324232098941368.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P181_REGION_TYPE'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4216430060656335.4001)
,p_branch_action=>'481'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(574137709805781533.4001)
,p_branch_action=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(16171505521174308.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4215029716656307.4001)
,p_name=>'P263_REGION_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_item_default=>'wwv_flow_lang.system_message(''BREADCRUMB'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('T\00EDtulo de la Regi\00F3n')
,p_post_element_text=>' '
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('<p>Introduzca un t\00EDtulo para esta regi\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4227008512679725.4001)
,p_name=>'P263_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4230126305694358.4001)
,p_name=>'P263_REGION_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DEFAULT_MENUR_TEMPLATE r ',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<p>Seleccione una plantilla de regi\00F3n. </p>')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4234201287706029.4001)
,p_name=>'P263_DISPLAY_POINT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_template_dev.get_breadcrumb_display_point (',
'    p_application_id   => :FB_FLOW_ID,',
'    p_theme_id         => :FB_THEME_ID )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Punto de Visualizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dp.name as d,',
'       dp.placeholder as r ',
'  from wwv_flow_page_tmpl_disp_points dp ',
' where dp.security_group_id  = :WORKSPACE_ID',
'   and dp.flow_id            = :FB_FLOW_ID',
'   and dp.has_region_support = ''Y''',
'   and dp.page_template_id   = ( select coalesce( p.step_template, ( select t.default_page_template',
'                                                                      from wwv_flow_user_interfaces ui,',
'                                                                           wwv_flow_themes t',
'                                                                     where ui.security_group_id = dp.security_group_id ',
'                                                                       and ui.flow_id           = dp.flow_id',
'                                                                       and t.security_group_id  = ui.security_group_id ',
'                                                                       and t.flow_id            = ui.flow_id',
'                                                                       and t.theme_id           = ui.theme_id ) )',
'                                 from wwv_flow_steps p',
'                                where p.security_group_id = dp.security_group_id ',
'                                  and p.flow_id           = dp.flow_id',
'                                  and p.id                = :FB_FLOW_PAGE_ID )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Punto de Visualizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el punto de visualizaci\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4236606959717166.4001)
,p_name=>'P263_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_prompt=>'Secuencia'
,p_post_element_text=>' '
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4238000856724796.4001)
,p_name=>'P263_REGION_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_prompt=>'Breadcrumb'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4240603065734951.4001)
,p_name=>'P263_MENU_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4214301685656288.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_menu_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_menu_template is not null) loop',
'   return c1.default_menu_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Breadcrumb Template'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165620013985308797.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.get_theme_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101054205105364788.4001)
,p_validation_name=>'RegionTitleMand'
,p_validation_sequence=>10
,p_validation=>'P263_REGION_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el t\00EDtulo de regi\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(4215518907656310.4001)
,p_associated_item=>wwv_flow_api.id(4215029716656307.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101057024151370342.4001)
,p_validation_name=>'DisplayPointMand'
,p_validation_sequence=>20
,p_validation=>'P263_DISPLAY_POINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el punto de visualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(4215518907656310.4001)
,p_associated_item=>wwv_flow_api.id(4234201287706029.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101059000518382425.4001)
,p_validation_name=>'SeqMand'
,p_validation_sequence=>30
,p_validation=>'P263_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia.'
,p_when_button_pressed=>wwv_flow_api.id(4215518907656310.4001)
,p_associated_item=>wwv_flow_api.id(4236606959717166.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574137535995781531.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4215226898656310.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574137687231781532.4001)
,p_event_id=>wwv_flow_api.id(574137535995781531.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00264
begin
wwv_flow_api.create_page(
 p_id=>264.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n: Entrada de Ruta de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4217004399656336.4001)
,p_plug_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Region generated 04-DEC-2002 18:37:44',
'<p>Identify the breadcrumb entry that will be used to identify this page.  You also identify the page which is the hierarchical parent to this page.</p>'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16147128715105369.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16141621180084222.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47746823146842377.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4217911180656339.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47746823146842377.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4218004320656340.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47746823146842377.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4218119404656340.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47746823146842377.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4219616249656343.4001)
,p_branch_action=>'286'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4219122423656342.4001)
,p_branch_action=>'481'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(4218119404656340.4001)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4217718329656339.4001)
,p_name=>'P264_MENU_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Etiqueta de Entrada de Ruta de Navegaci\00F3n')
,p_source=>'select name from wwv_flow_steps where flow_id = :fb_flow_id and id = :fb_flow_page_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Especifique la etiqueta para esta entrada de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4243410946756095.4001)
,p_name=>'P264_MENU_LINK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'''f?p=&''||''FLOW_ID.:''||v(''FB_FLOW_PAGE_ID'')||'':&''||''SESSION.'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Breadcrumb Entry Link'
,p_source=>'''f?p=&''||''FLOW_ID.:''||v(''FB_FLOW_PAGE_ID'')||'':&''||''SESSION.'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4257707314792899.4001)
,p_name=>'P264_PARENT_MENU'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(short_name)||'' (''||page_id||'')'' name, id',
'from wwv_flow_menu_options',
'where menu_id = ltrim(:P481_REGION_TYPE,''M'')',
'order by upper(short_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Principal -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Seleccione el principal jer\00E1rquico de la entrada de esta ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114071712289039011.4001)
,p_name=>'P264_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114083605981131862.4001)
,p_name=>'P264_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n que se va a crear:')
,p_source=>'P263_REGION_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifica la regi\00F3n que se utiliza como contenedor de la ruta de navegaci\00F3n. La regi\00F3n identifica la posici\00F3n de la p\00E1gina donde se colocar\00E1 la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138187904182753297.4001)
,p_name=>'P264_BREADCRUMB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P481_REGION.'
,p_prompt=>unistr('Ruta de Navegaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_menus',
'where flow_id = :fb_flow_id',
'and id = to_number(substr(:P481_REGION_TYPE,2))'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('\00C9ste es el nombre de la ruta de navegaci\00F3n en la que est\00E1 creando una entrada de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138206211080878248.4001)
,p_name=>'P264_EXISTING_BREADCRUMB_LABEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta de Entrada Existente:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SHORT_NAME breadcrumb_entry',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Al crear una regi\00F3n de ruta de navegaci\00F3n, se utilizar\00E1 esta entrada de ruta de navegaci\00F3n existente. Si desea cambiar esta etiqueta de entrada de ruta de navegaci\00F3n, puede hacerlo despu\00E9s de crear la regi\00F3n de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138208119045880585.4001)
,p_name=>'P264_EXISTING_PARENT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4217004399656336.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Principal Existente:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select short_name from wwv_flow_menu_options where id = mo.PARENT_ID) parent_breadcrumb',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el principal jer\00E1rquico de la entrada de esta ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101134722410644210.4001)
,p_validation_name=>'P264_MENU_TEXT Not Null'
,p_validation_sequence=>10
,p_validation=>'P264_MENU_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la etiqueta de opci\00F3n de men\00FA.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_api.id(4218004320656340.4001)
,p_associated_item=>wwv_flow_api.id(4217718329656339.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 25-JUL-2003 12:00'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(101134928787644210.4001)
,p_validation_name=>'P264_MENU_LINK Not Null'
,p_validation_sequence=>20
,p_validation=>'P264_MENU_LINK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la etiqueta de opci\00F3n de men\00FA.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_api.id(4218004320656340.4001)
,p_associated_item=>wwv_flow_api.id(4217718329656339.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 25-JUL-2003 12:00'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574137062020781526.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4217911180656339.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574137134617781527.4001)
,p_event_id=>wwv_flow_api.id(574137062020781526.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00265
begin
wwv_flow_api.create_page(
 p_id=>265.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Gr\00E1fico: Origen')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Gr\00E1fico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213433100273471382)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_cal.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269331629722506191.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269333298161506211.4001)
,p_plug_name=>unistr('Crear Gr\00E1fico')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619337087750855725.4001)
,p_plug_name=>'Base de Datos Local'
,p_parent_plug_id=>wwv_flow_api.id(269333298161506211.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619337133784855726.4001)
,p_plug_name=>'Atributos comunes'
,p_parent_plug_id=>wwv_flow_api.id(269333298161506211.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619337289078855727.4001)
,p_plug_name=>'SQL activado para REST'
,p_parent_plug_id=>wwv_flow_api.id(269333298161506211.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619339435416855749.4001)
,p_plug_name=>unistr('Or\00EDgenes remotos')
,p_parent_plug_id=>wwv_flow_api.id(619337289078855727.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619337849118855733.4001)
,p_plug_name=>unistr('Ubicaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(269333298161506211.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(655321257557394101.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(269333298161506211.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269340749842506226.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1192927752498551.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(269332061311506199.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(269331629722506191.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(269332493145506200.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(269331629722506191.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(269332845964506200.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(269331629722506191.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(269349991685506264.4001)
,p_branch_name=>'Go To Page 266'
,p_branch_action=>'f?p=&APP_ID.:266:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(269332493145506200.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(269350375650506266.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(269332845964506200.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269333628614506212.4001)
,p_name=>'P265_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(619337087750855725.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el origen del nuevo gr\00E1fico. Las regiones pueden estar basadas en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269334581825506218.4001)
,p_name=>'P265_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(619337087750855725.4001)
,p_source=>'P616_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Identifica la p\00E1gina seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269335425812506219.4001)
,p_name=>'P265_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(619337087750855725.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Propietario -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de base de datos propietario de la tabla desde de la que est\00E1 creando un gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269336356418506220.4001)
,p_name=>'P265_TABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(619337087750855725.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc d,object_name v',
'  from wwv_flow_tables_views_dev',
' where owner = :P265_OWNER',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla -'
,p_lov_cascade_parent_items=>'P265_OWNER,P265_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 el gr\00E1fico. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269337675468506222.4001)
,p_name=>'P265_SQL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(619337087750855725.4001)
,p_prompt=>'Consulta SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la consulta SQL SELECT que utilizar\00E1 el gr\00E1fico. Por ejemplo:'),
'<pre>',
'<strong>select * from emp</strong>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269338589922506224.4001)
,p_name=>'P265_FLOW_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(619337133784855726.4001)
,p_source=>'select owner from wwv_flows where id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269338955272506225.4001)
,p_name=>'P265_DATE_COL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(619337087750855725.4001)
,p_prompt=>'Columna de Fecha'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''DATE'',''12'',''180'',''181'',''231'')',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P265_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la columna que se utilizar\00E1 como fecha de inclusi\00F3n de una entrada en el calendario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(281175389696835061.4001)
,p_name=>'P265_AJAX_ITEMS_TO_SUBMIT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(619337133784855726.4001)
,p_prompt=>unistr('Elementos de P\00E1gina que Ejecutar')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE ITEMS OF CURRENT AND GLOBAL PAGE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       name as r',
'  from (',
'select name,',
'       flow_step_id,',
'       item_sequence',
'  from wwv_flow_step_items',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' union',
'select i.name,',
'       i.flow_step_id,',
'       i.item_sequence',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui,',
'       wwv_flow_step_items i',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and ui.id               = p.user_interface_id',
'   and ui.global_page_id  <> :fb_flow_page_id',
'   and i.flow_id           = ui.flow_id',
'   and i.flow_step_id      = ui.global_page_id',
'   and i.security_group_id = :WORKSPACE_ID',
')',
'order by flow_step_id, item_sequence, name',
''))
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca una lista separada por comas de los elementos de p\00E1gina de la p\00E1gina actual que se van a definir en el estado de sesi\00F3n cuando se leen los datos de gr\00E1fico con una solicitud independiente.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(281176178179838017.4001)
,p_name=>'P265_MAX_ROWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(619337133784855726.4001)
,p_prompt=>unistr('M\00E1ximo de Filas')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero m\00E1ximo de filas que desea utilizar para que aparezca el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619337312984855728.4001)
,p_name=>'P265_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(619337289078855727.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619337470371855729.4001)
,p_name=>'P265_REMOTE_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(619339435416855749.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el origen del nuevo gr\00E1fico. Las regiones pueden estar basadas en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619337508757855730.4001)
,p_name=>'P265_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(619339435416855749.4001)
,p_prompt=>'Consulta SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la consulta SQL SELECT que utilizar\00E1 el gr\00E1fico. Por ejemplo:'),
'<pre>',
'<strong>select * from emp</strong>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P265_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619337632190855731.4001)
,p_name=>'P265_REMOTE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(619339435416855749.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P265_REMOTE_SERVER_ID, ''SCHEMAS'')) ',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P265_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de base de datos propietario de la tabla desde de la que est\00E1 creando un gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619337747789855732.4001)
,p_name=>'P265_REMOTE_TABLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(619339435416855749.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P265_REMOTE_SERVER_ID, ''TABLE'', :P265_REMOTE_OWNER,p_filter=>:p$_search_string)) ',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P265_REMOTE_OWNER'
,p_ajax_items_to_submit=>'P265_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de base de datos propietario de la tabla desde de la que est\00E1 creando un gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619337955587855734.4001)
,p_name=>'P265_LOCATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(619337849118855733.4001)
,p_item_default=>'LOCAL'
,p_prompt=>unistr('Ubicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(655321376796394102.4001)
,p_name=>'P265_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(655321257557394101.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(269342055968506249.4001)
,p_computation_sequence=>10
,p_computation_item=>'P265_SQL'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(instr(:P265_SQL,'';''),',
'         length(:P265_SQL), ',
'             substr(:P265_SQL,1,length(:P265_SQL) -1),',
'      :P265_SQL) from dual'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(295647961074349410.4001)
,p_validation_name=>'is valid query (old)'
,p_validation_sequence=>5
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_worksheet_standard.is_valid_ir_query ( ',
'    p_flow_id   => :FB_FLOW_ID,      ',
'    p_query     => :P265_SQL,',
'    p_show_detail_link => ''N'');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition_type=>'NEVER'
,p_associated_item=>wwv_flow_api.id(269337675468506222.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(655322339671394112.4001)
,p_validation_name=>'is valid SQL query'
,p_validation_sequence=>15
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_descr_result wwv_flow_exec_dev.t_describe_result;',
'    ',
'    l_query_type             wwv_flow_exec_api.t_query_type;',
'    l_function_body_language wwv_flow_code_exec.t_language;',
'    l_table                  varchar2(255);',
'    l_owner                  varchar2(255);',
'    l_sql                    varchar2(32767);',
'    l_remote_server_id       number;',
'    l_web_src_module_id      number;',
'    ',
'    procedure set_values ( p_type in varchar2, p_sql in varchar2, p_table in varchar2, p_owner in varchar2 ) ',
'    is',
'    begin',
'        l_query_type := case p_type when ''TABLE'' then wwv_flow_exec_api.c_query_type_table else wwv_flow_exec_api.c_query_type_sql_query end;',
'        if l_query_type = wwv_flow_exec_api.c_query_type_sql_query and (',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''DECLARE'', 1)=1) or',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''BEGIN''  , 1)=1) or',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''RETURN''  , 1)=1) ',
'        ) then',
'            l_query_type             := wwv_flow_exec_api.c_query_type_func_return_sql;',
'            l_function_body_language := wwv_flow_code_exec.c_plsql;',
'        end if;',
'        l_table := p_table;',
'        l_owner := p_owner;',
'        l_sql   := p_sql;',
'    end set_values;',
'begin',
'    if :P265_LOCATION = ''REMOTE'' then',
'        set_values( :P265_REMOTE_SOURCE_TYPE, :P265_REMOTE_SQL, :P265_REMOTE_TABLE, :P265_REMOTE_OWNER );',
'        l_remote_server_id := :P265_REMOTE_SERVER_ID;',
'    elsif :P265_LOCATION = ''LOCAL'' then',
'        set_values( :P265_SOURCE_TYPE, :P265_SQL, :P265_TABLE, :P265_OWNER );',
'    elsif :P265_LOCATION = ''WEB_SOURCE'' then',
'        l_web_src_module_id := :P265_WEB_SRC_MODULE_ID;',
'    end if;                            ',
'    l_descr_result := wwv_flow_exec_dev.check_and_describe(',
'        p_location               => case :P265_LOCATION',
'                                        when ''REMOTE'' then wwv_flow_exec_api.c_location_remote_db',
'                                        when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                        else wwv_flow_exec_api.c_location_local_db end,',
'        p_remote_server_id       => l_remote_server_id,',
'        p_query_type             => l_query_type,',
'        p_owner                  => l_owner,',
'        p_table_name             => l_table,',
'        p_sql_query              => l_sql,',
'        p_function_body          => l_sql,',
'        p_function_body_language => l_function_body_language,',
'        p_web_src_module_id      => l_web_src_module_id );',
'    ',
'    return l_descr_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :P265_LOCATION = ''LOCAL'' and :P265_SOURCE_TYPE = ''SQL'' ) or',
'( :P265_LOCATION = ''REMOTE'' and :P265_REMOTE_SOURCE_TYPE = ''SQL'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(269332493145506200.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(269342443329506250.4001)
,p_validation_name=>'Local Owner Not Null'
,p_validation_sequence=>25
,p_validation=>'P265_OWNER'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar el propietario de la tabla o vista.'
,p_validation_condition=>':P265_SOURCE_TYPE = ''TABLE'' and :P265_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(269332493145506200.4001)
,p_associated_item=>wwv_flow_api.id(269335425812506219.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(269344011943506252.4001)
,p_validation_name=>'Local Table Not Null'
,p_validation_sequence=>35
,p_validation=>'P265_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la tabla.'
,p_validation_condition=>':P265_SOURCE_TYPE = ''TABLE'' and :P265_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(269332493145506200.4001)
,p_associated_item=>wwv_flow_api.id(269336356418506220.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(655322009292394109.4001)
,p_validation_name=>'Remote Table Not Null'
,p_validation_sequence=>55
,p_validation=>'P265_REMOTE_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la tabla.'
,p_validation_condition=>':P265_REMOTE_SOURCE_TYPE = ''TABLE'' and :P265_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(269332493145506200.4001)
,p_associated_item=>wwv_flow_api.id(619337747789855732.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(269343634965506252.4001)
,p_validation_name=>'Local SQL Not Null'
,p_validation_sequence=>65
,p_validation=>'P265_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>':P265_SOURCE_TYPE = ''QUERY'' and :P265_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(269337675468506222.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(655322108543394110.4001)
,p_validation_name=>'Remote SQL Not Null'
,p_validation_sequence=>75
,p_validation=>'P265_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>':P265_REMOTE_SOURCE_TYPE = ''QUERY'' and :P265_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(619337508757855730.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(655322224705394111.4001)
,p_validation_name=>'REST Data Source  Not Null'
,p_validation_sequence=>85
,p_validation=>'P265_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se necesita un origen de datos de REST.'
,p_validation_condition=>'P265_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(269332493145506200.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(610851022209282101.4001)
,p_validation_name=>'Chose Table exists'
,p_validation_sequence=>105
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P265_OWNER',
'   and object_name = :P265_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P265_TABLE!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P265_SOURCE_TYPE = ''TABLE'' and :P265_LOCATION = ''LOCAL''and :P265_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(269332493145506200.4001)
,p_associated_item=>wwv_flow_api.id(269336356418506220.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(269345526197506255.4001)
,p_name=>'show local source attributes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P265_SOURCE_TYPE'
,p_condition_element=>'P265_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269346077056506257.4001)
,p_event_id=>wwv_flow_api.id(269345526197506255.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_SQL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269346531347506258.4001)
,p_event_id=>wwv_flow_api.id(269345526197506255.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_OWNER,P265_TABLE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269347031271506258.4001)
,p_event_id=>wwv_flow_api.id(269345526197506255.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_OWNER,P265_TABLE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269347528185506258.4001)
,p_event_id=>wwv_flow_api.id(269345526197506255.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_SQL'
,p_attribute_01=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619338776300855742.4001)
,p_name=>'show remote source attributes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P265_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P265_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338838543855743.4001)
,p_event_id=>wwv_flow_api.id(619338776300855742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_REMOTE_SQL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338941065855744.4001)
,p_event_id=>wwv_flow_api.id(619338776300855742.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_REMOTE_OWNER,P265_REMOTE_TABLE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619339055131855745.4001)
,p_event_id=>wwv_flow_api.id(619338776300855742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_REMOTE_OWNER,P265_REMOTE_TABLE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619339170787855746.4001)
,p_event_id=>wwv_flow_api.id(619338776300855742.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_REMOTE_SQL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(269348958375506263.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(269332061311506199.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269349469529506263.4001)
,p_event_id=>wwv_flow_api.id(269348958375506263.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619338085975855735.4001)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P265_LOCATION'
,p_condition_element=>'P265_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338187532855736.4001)
,p_event_id=>wwv_flow_api.id(619338085975855735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(619337087750855725.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338286896855737.4001)
,p_event_id=>wwv_flow_api.id(619338085975855735.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(619337087750855725.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338384177855738.4001)
,p_event_id=>wwv_flow_api.id(619338085975855735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_REMOTE_SERVER_ID,P265_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619338467790855739.4001)
,p_name=>'LOCATION "REMOTE"'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P265_LOCATION'
,p_condition_element=>'P265_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338540218855740.4001)
,p_event_id=>wwv_flow_api.id(619338467790855739.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(619337289078855727.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619338627571855741.4001)
,p_event_id=>wwv_flow_api.id(619338467790855739.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(619337289078855727.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(655321433502394103.4001)
,p_event_id=>wwv_flow_api.id(619338467790855739.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619339281892855747.4001)
,p_name=>'Show Remote Attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P265_REMOTE_SERVER_ID'
,p_condition_element=>'P265_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619339355471855748.4001)
,p_event_id=>wwv_flow_api.id(619339281892855747.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(619339435416855749.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619339576865855750.4001)
,p_event_id=>wwv_flow_api.id(619339281892855747.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(619339435416855749.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(655321597643394104.4001)
,p_name=>'Loation "WEB_SOURCE"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P265_LOCATION'
,p_condition_element=>'P265_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(655321618605394105.4001)
,p_event_id=>wwv_flow_api.id(655321597643394104.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(655321257557394101.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(655321730631394106.4001)
,p_event_id=>wwv_flow_api.id(655321597643394104.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(655321257557394101.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(655321831950394107.4001)
,p_event_id=>wwv_flow_api.id(655321597643394104.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P265_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(269345191877506254.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Source Type Preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'WIZARD_SQL_SOURCE_TYPE'
,p_attribute_03=>'P265_SOURCE_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(269332493145506200.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(655322438123394113.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Columns (new)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_descr_result wwv_flow_exec_dev.t_describe_result;',
'    ',
'    l_query_type   wwv_flow_exec_api.t_query_type;',
'    l_table              varchar2(255);',
'    l_owner              varchar2(255);',
'    l_sql                varchar2(32767);',
'    l_remote_server_id   number;',
'    l_web_src_module_id  number;',
'    ',
'    procedure set_values ( p_type in varchar2, p_sql in varchar2, p_table in varchar2, p_owner in varchar2 ) ',
'    is',
'    begin',
'        l_query_type := case p_type when ''TABLE'' then wwv_flow_exec_api.c_query_type_table else wwv_flow_exec_api.c_query_type_sql_query end;',
'        if l_query_type = wwv_flow_exec_api.c_query_type_sql_query and (',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''DECLARE'', 1)=1) or',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''BEGIN''  , 1)=1) or',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''RETURN''  , 1)=1) ',
'        ) then',
'            l_query_type := wwv_flow_exec_api.c_query_type_func_return_sql;',
'        end if;',
'        l_table := p_table;',
'        l_owner := p_owner;',
'        l_sql   := p_sql;',
'    end set_values;',
'begin',
'    if :P265_LOCATION = ''REMOTE'' then',
'        set_values( :P265_REMOTE_SOURCE_TYPE, :P265_REMOTE_SQL, :P265_REMOTE_TABLE, :P265_REMOTE_OWNER );',
'        l_remote_server_id := :P265_REMOTE_SERVER_ID;',
'    elsif :P265_LOCATION = ''LOCAL'' then',
'        set_values( :P265_SOURCE_TYPE, :P265_SQL, :P265_TABLE, :P265_OWNER );',
'    elsif :P265_LOCATION = ''WEB_SOURCE'' then',
'        l_web_src_module_id := :P265_WEB_SRC_MODULE_ID;',
'    end if;                            ',
'    l_descr_result := wwv_flow_exec_dev.check_and_describe(',
'        p_location            => case :P265_LOCATION',
'                                     when ''REMOTE'' then wwv_flow_exec_api.c_location_remote_db',
'                                     when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                     else wwv_flow_exec_api.c_location_local_db end,',
'        p_remote_server_id    => l_remote_server_id,',
'        p_query_type          => l_query_type,',
'        p_owner               => l_owner,',
'        p_table_name          => l_table,',
'        p_sql_query           => l_sql,',
'        p_function_body       => l_sql,',
'        p_web_src_module_id   => l_web_src_module_id );',
'        ',
'    wwv_flow_collection.create_or_truncate_collection(''P265_COLS'');',
'    for i in 1 .. l_descr_result.query_columns.count loop',
'        wwv_flow_collection.add_member( ',
'            ''P265_COLS'', ',
'            l_descr_result.query_columns( i ).name, ',
'            case l_descr_result.query_columns( i ).data_type ',
'                when wwv_flow_exec_api.c_data_type_number then 2',
'                when wwv_flow_exec_api.c_data_type_varchar2 then 1',
'                when wwv_flow_exec_api.c_data_type_date then 12',
'                when wwv_flow_exec_api.c_data_type_rowid then 11',
'                when wwv_flow_exec_api.c_data_type_timestamp then 180',
'                when wwv_flow_exec_api.c_data_type_timestamp_tz then 181',
'                when wwv_flow_exec_api.c_data_type_timestamp_ltz then 231 end );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(269332493145506200.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(269344357779506252.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Schema'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4785_OWNER is not null and :F4000_P4785_OWNER <> ''0'' and :P265_TABLE is not null then',
'    wwv_flow_sw_api.check_priv(:F4000_P4785_OWNER);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Esquema no V\00E1lido')
,p_process_when=>'P265_LOCATION'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'LOCAL'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
end;
/
prompt --application/pages/page_00266
begin
wwv_flow_api.create_page(
 p_id=>266.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Gr\00E1fico: Atributos de Gr\00E1fico')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Gr\00E1fico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5131626840158646)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_cal.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269363539966616790.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269365138485616794.4001)
,p_plug_name=>unistr('Crear Gr\00E1fico')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(269374947168616810.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1192927752498551.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(269363959688616790.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(269363539966616790.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(269364367647616791.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(269363539966616790.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(269364767506616792.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(269363539966616790.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(269385375019616830.4001)
,p_branch_name=>'Go To Page 265'
,p_branch_action=>'f?p=&APP_ID.:265:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(269364767506616792.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(84538477201706810.4001)
,p_name=>'P266_AGGREGATE_FUNCTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_item_default=>'COLVALUE'
,p_prompt=>unistr('Agregaci\00F3n de valores')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AGGREGATE_FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(101016778607432389.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Sin agregaci\00F3n -')
,p_cHeight=>1
,p_display_when=>':P265_SOURCE_TYPE = ''TABLE'' and :P751_JET_CHART_TYPE not in (''GANTT'',''boxPlot'',''scatter'',''stock'',''range'',''bubble'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione c\00F3mo agregar la columna Valor del gr\00E1fico. Al seleccionar <strong>Recuento</strong>, la agregaci\00F3n se basar\00E1 autom\00E1ticamente en la columna Etiqueta seleccionada. Para el resto de opciones de agregaci\00F3n, cuando no se selecciona la columna V')
||unistr('alor, la agregaci\00F3n se basar\00E1 en la columna Etiqueta seleccionada. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269029284940330604.4001)
,p_name=>'P266_LOW_COL'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor Bajo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''2'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'range:stock'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor inferior en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269029315855330605.4001)
,p_name=>'P266_HIGH_COL'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor Alto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''2'' )',
' and   c001 not in :P266_LOW_COL',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_LOW_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'range:stock'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor superior en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269029400627330606.4001)
,p_name=>'P266_OPEN_COL'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor de Apertura'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''2'' )',
' and   c001 not in (:P266_LOW_COL,:P266_HIGH_COL)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_LOW_COL,P266_HIGH_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'stock'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor de apertura en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269029516661330607.4001)
,p_name=>'P266_CLOSE_COL'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor de Cierre'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''2'' )',
' and   c001 not in (:P266_LOW_COL,:P266_HIGH_COL,:P266_OPEN_COL)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_LOW_COL,P266_HIGH_COL,P266_OPEN_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'stock'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor de cierre en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269030425306330616.4001)
,p_name=>'P266_X_COL'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor X'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in (''1'',''2'',''12'',''180'',''181'',''231'')',
'order by 1'))
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'bubble:scatter'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna que se va a utilizar para el valor xlow en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269030519715330617.4001)
,p_name=>'P266_Y_COL'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor Y'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in (''2'')',
' and   c001 not in :P266_X_COL',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_X_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'bubble:scatter'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor y en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269030659075330618.4001)
,p_name=>'P266_STACK_CHART'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Gr\00E1fico de Pila')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si desea generar un gr\00E1fico con los elementos de datos apilados. Los gr\00E1ficos apilados son de cuatro tipos: Gr\00E1ficos de barras, \00E1reas, l\00EDneas y combinaci\00F3n, con la excepci\00F3n de los gr\00E1ficos de rango.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269030707160330619.4001)
,p_name=>'P266_Z_COL'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor Z'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in (''2'')',
' and   c001 not in (:P266_X_COL,:P266_Y_COL)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_X_COL,P266_Y_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'bubble:bar:range:polar:boxPlot'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se utilizar\00E1 para el valor z en el gr\00E1fico. El valor z define el radio de burbuja para un gr\00E1fico de burbujas y el ancho de barra para un gr\00E1fico de barras o de combinaci\00F3n, o un elemento de gr\00E1fico de \00E1reas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269030862405330620.4001)
,p_name=>'P266_TARGET_COL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Valor de Destino'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 = ''2''',
' and   c001 not in (:P266_VALUE_COL)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_VALUE_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'funnel'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor de destino en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269030907029330621.4001)
,p_name=>'P266_MAX_VAL_COL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>unistr('Columna de Valor M\00E1ximo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 = ''2''',
' and   c001 not in (:P266_VALUE_COL)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_VALUE_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'dial'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se va a utilizar para el valor m\00E1ximo en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269031042082330622.4001)
,p_name=>'P266_SERIES_NAME_COL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'area:bar:bubble:combo:line:lineWithArea:scatter'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_help_text=>unistr('Especifique la columna que se utilizar\00E1 como el valor del nombre de la serie en el gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269031124790330623.4001)
,p_name=>'P266_ORIENTATION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_item_default=>'vertical'
,p_prompt=>unistr('Orientaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'JET_CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(272256574572764306.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'area:bar:boxPlot:combo:line:funnel:lineWithArea:range'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la orientaci\00F3n de este gr\00E1fico. Entre las opciones disponibles se incluyen:<p/>'),
unistr('<li><strong>Vertical</strong>: Muestra los elementos de datos del gr\00E1fico verticalmente. Por ejemplo, las barras de un gr\00E1fico de barras se mostrar\00E1n verticalmente.</li>'),
unistr('<li><strong>Horizontal</strong>: Muestra los elementos de datos del gr\00E1fico horizontalmente. Por ejemplo, las barras de un gr\00E1fico de barras se mostrar\00E1n horizontalmente.</li>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269031488579330626.4001)
,p_name=>'P266_VOLUME_COL'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Volumen'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''2'' )',
' and   c001 not in (:P266_LOW_COL,:P266_HIGH_COL,:P266_OPEN_COL)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P266_LOW_COL,P266_HIGH_COL,P266_OPEN_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'stock'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna num\00E9rica que se utilizar\00E1 para el valor de volumen en el gr\00E1fico. Cuando se proporcionan valores, el volumen se muestra en el eje y2.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269031580764330627.4001)
,p_name=>'P266_CHART_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>unistr('Tipo de Gr\00E1fico:')
,p_source=>'P751_JET_CHART_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'JET_CHART_TYPES'
,p_lov=>'.'||wwv_flow_api.id(285041260607381464.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Tipo de gr\00E1fico que se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269031648628330628.4001)
,p_name=>'P266_SPARK_CHART'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Gr\00E1fico de Chispa')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si desea generar un gr\00E1fico de chispa. Los gr\00E1ficos de chispa muestran mejor las tendencia el tiempo, especialmente cuando se empareja con contexto adicional, como en una tabla. Los gr\00E1ficos de chispa son de cuatro tipos: Gr\00E1ficos de barr')
||unistr('as, \00E1reas, l\00EDneas y l\00EDneas con \00E1reas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269365502725616795.4001)
,p_name=>'P266_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_source=>'P616_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Identifica la p\00E1gina seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269366445538616800.4001)
,p_name=>'P266_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_source=>'P265_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el esquema propietario de la tabla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269367383285616801.4001)
,p_name=>'P266_TABLE_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Nombre de Tabla/Vista:'
,p_source=>'P265_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P265_TABLE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Objeto de base de datos (tabla o vista) en el que se basa este gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269368240149616802.4001)
,p_name=>'P266_VALUE_COL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de valores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 = ''2''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'area:bar:combo:dial:funnel:line:lineWithArea:pie:donut:radar:polar:pyramid:boxPlot'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor en este gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(269370011368616804.4001)
,p_name=>'P266_LABEL_COL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de etiquetas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''1'', ''2'', ''12'', ''180'', ''181'', ''231'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'dial:GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir las etiquetas del eje x en el grafico. Para un gr\00E1fico de acciones burs\00E1tiles, la columna debe ser de tipo Fecha/Registro de Hora para representar la informaci\00F3n de las acciones en un eje ')
||'de tiempo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621604016517019637.4001)
,p_name=>'P266_START_DATE_COL'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de Fecha de Inicio'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''12'', ''180'', ''181'', ''231'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de inicio del gr\00E1fico de Gantt. Es necesario introducir una fecha de inicio para representar el gr\00E1fico correctamente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621663887863538405.4001)
,p_name=>'P266_END_DATE_COL'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>unistr('Columna de Fecha de Finalizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''12'', ''180'', ''181'', ''231'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de finalizaci\00F3n del gr\00E1fico de Gantt. Es necesario introducir una fecha de finalizaci\00F3n para representar el gr\00E1fico correctamente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621664037060538407.4001)
,p_name=>'P266_TASK_ID'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de ID de tarea'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''1'', ''2'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el ID de tarea \00FAnico, asociado a cada entrada de tarea que desee representar en el gr\00E1fico de Gantt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621664105207538408.4001)
,p_name=>'P266_TASK_NAME'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de nombre de tarea'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''1'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el nombre de tarea, asociado a cada entrada de tarea que desee representar en el gr\00E1fico de Gantt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621664242208538409.4001)
,p_name=>'P266_TASK_START_DATE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>'Columna de fecha de inicio de tarea'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''12'', ''180'', ''181'', ''231'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de inicio de tarea para el gr\00E1fico de Gantt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621664370683538410.4001)
,p_name=>'P266_TASK_END_DATE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_prompt=>unistr('Columna de fecha de finalizaci\00F3n de tarea')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a,c001 b',
'  from wwv_flow_collections',
' where collection_name  = ''P265_COLS''',
' and   c002 in  ( ''12'', ''180'', ''181'', ''231'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de finalizaci\00F3n de tarea para el gr\00E1fico de Gantt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1119458314636128334.4001)
,p_name=>'P266_GAUGE_ORIENTATION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(269365138485616794.4001)
,p_item_default=>'circular'
,p_prompt=>unistr('Orientaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'JET_GAUGE_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(21606267597566254.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P751_JET_CHART_TYPE'
,p_display_when2=>'dial'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la orientaci\00F3n de este gr\00E1fico de indicador de estado. Entre las opciones disponibles se incluyen:<p/>'),
unistr('<li><strong>Circular</strong>: muestra el valor de m\00E9trica del gr\00E1fico en un eje circular.</li>'),
unistr('<li><strong>Horizontal</strong>: muestra el valor de m\00E9trica del gr\00E1fico en un eje horizontal.</li>'),
unistr('<li><strong>Vertical</strong>: muestra el valor de m\00E9trica del gr\00E1fico en un eje vertical.</li>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(710802618787479803.4001)
,p_validation_name=>'Validate Label'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P751_JET_CHART_TYPE not in (''dial'',''GANTT'') then ',
'        return false;',
'    else',
'        return true;',
'    end if;',
' ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar una columna de etiqueta'
,p_validation_condition=>'P266_LABEL_COL'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_associated_item=>wwv_flow_api.id(269370011368616804.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(710802745538479804.4001)
,p_validation_name=>'Validate Value'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P751_JET_CHART_TYPE in (''area'',''bar'',''combo'',''dial'',''funnel'',''line'',''lineWithArea'',''pie'',''donut'',''radar'',''polar'',''pyramid'',''boxPlot'') then ',
'        return false;',
'    else',
'        return true;',
'    end if;',
' ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar una columna de valor'
,p_validation_condition=>':P266_VALUE_COL is null and :P266_AGGREGATE_FUNCTION is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(269368240149616802.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(121269680034561226.4001)
,p_validation_name=>'Validate Aggregation'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type        varchar(3);',
'begin',
' ',
'    for c1 in ( select c002 dataType',
'                  from wwv_flow_collections',
'                 where collection_name  = ''P265_COLS''',
'                   and c002 in  ( ''1'', ''2'', ''12'', ''180'', ''181'', ''231'' )',
'                   and c001 = :P266_LABEL_COL )',
'    loop',
'        l_data_type := c1.dataType;',
'    end loop;',
'',
'    -- SUM & AVG should only be applied to NUMBER',
'    if :P266_AGGREGATE_FUNCTION in (''SUM'',''AVG'') then ',
'        return false;',
'    -- MEDIAN should not be applied to VARCHAR2    ',
'    elsif :P266_AGGREGATE_FUNCTION = ''MEDIAN'' then ',
'        if l_data_type = ''1'' then',
'            return false;',
'        end if;',
'    -- All other aggregates require Value to be selected regardless of Label Datatype    ',
'    elsif :P266_AGGREGATE_FUNCTION in (''MIN'',''MAX'',''COUNT_DISTINCT'',''APPROX_COUNT_DISTINCT'') then',
'        return false;',
'    elsif :P266_AGGREGATE_FUNCTION = ''COUNT'' then ',
'        return true;',
'    end if;',
'    ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar una columna de valor para la agregaci\00F3n elegida')
,p_validation_condition=>':P266_AGGREGATE_FUNCTION is not null and :P266_LABEL_COL is not null and :P266_VALUE_COL is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(84538477201706810.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(269382531872616827.4001)
,p_name=>'Desktop User Interface'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P266_IS_DESKTOP'
,p_condition_element=>'P266_IS_DESKTOP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(269383983769616828.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(269363959688616790.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269384417984616828.4001)
,p_event_id=>wwv_flow_api.id(269383983769616828.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(269029925201330611.4001)
,p_name=>'Range Chart Selection'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P266_RANGE_CHART'
,p_condition_element=>'P266_RANGE_CHART'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269030068683330612.4001)
,p_event_id=>wwv_flow_api.id(269029925201330611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P266_LOW_COL,P266_HIGH_COL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269030133589330613.4001)
,p_event_id=>wwv_flow_api.id(269029925201330611.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P266_LOW_COL,P266_HIGH_COL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269030249616330614.4001)
,p_event_id=>wwv_flow_api.id(269029925201330611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P266_VALUE_COL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(269030350695330615.4001)
,p_event_id=>wwv_flow_api.id(269029925201330611.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P266_VALUE_COL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(121269077648561220.4001)
,p_name=>'Visibility of Value Column'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P266_AGGREGATE_FUNCTION'
,p_condition_element=>'P266_AGGREGATE_FUNCTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(121269186805561221.4001)
,p_event_id=>wwv_flow_api.id(121269077648561220.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P266_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(121269379817561223.4001)
,p_event_id=>wwv_flow_api.id(121269077648561220.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P266_VALUE_COL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(272273203293836862.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create JET chart'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_series_type  varchar2(1000);',
'    l_display_attr varchar2(4000);',
'',
'    ',
'    l_query_type         wwv_flow_exec_api.t_query_type;',
'    l_table              varchar2(255);',
'    l_owner              varchar2(255);',
'    l_sql                varchar2(32767);',
'    l_remote_server_id   number;',
'    l_web_src_module_id  number;',
'    ',
'    procedure set_values ( p_type in varchar2, p_sql in varchar2, p_table in varchar2, p_owner in varchar2 ) ',
'    is',
'    begin',
'        l_query_type := case p_type when ''TABLE'' then wwv_flow_exec_api.c_query_type_table else wwv_flow_exec_api.c_query_type_sql_query end;',
'        if l_query_type = wwv_flow_exec_api.c_query_type_sql_query and (',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''DECLARE'', 1)=1) or',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''BEGIN''  , 1)=1) or',
'           (instr(replace(replace(replace(upper(p_sql),'' '',''''),wwv_flow.LF,''''),chr(13),''''), ''RETURN''  , 1)=1) ',
'        ) then',
'            l_query_type := wwv_flow_exec_api.c_query_type_func_return_sql;',
'        end if;',
'        l_table := p_table;',
'        l_owner := p_owner;',
'        l_sql   := p_sql;',
'    end set_values;',
'begin',
'    if :P265_LOCATION = ''REMOTE'' then',
'        set_values( :P265_REMOTE_SOURCE_TYPE, :P265_REMOTE_SQL, :P265_REMOTE_TABLE, :P265_REMOTE_OWNER );',
'        l_remote_server_id := :P265_REMOTE_SERVER_ID;',
'    elsif :P265_LOCATION = ''LOCAL'' then',
'        set_values( :P265_SOURCE_TYPE, :P265_SQL, :P265_TABLE, :P265_OWNER );',
'    elsif :P265_LOCATION = ''WEB_SOURCE'' then',
'        l_web_src_module_id := :P265_WEB_SRC_MODULE_ID;',
'    end if; ',
'',
'    -- Series Type',
'  l_series_type := case :P751_JET_CHART_TYPE',
'                       when ''range'' then ''barRange''',
'                       when ''stock'' then ''stock''',
'                       when ''combo'' then ''bar''',
'                       when ''polar'' then ''bar''',
'                       when ''radar'' then ''line''',
'                       when ''GANTT'' then ''gantt''',
'                       else :P751_JET_CHART_TYPE',
'                   end;',
'',
'  wwv_flow_wizard_api.create_jet_chart (',
'    p_flow_id                  => :FB_FLOW_ID,',
'    p_page_id                  => :P616_PAGE_ID,',
'    p_page_name                => :P616_PAGE_NAME,',
'    p_page_mode                => :P616_PAGE_MODE,',
'    p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'    p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                      p_application_id => :FB_FLOW_ID,',
'                                      p_theme_id       => :FB_THEME_ID,',
'                                      p_page_type      => :P259_CHOOSE_PAGE_TYPE),',
'    p_region_name              => :P616_PAGE_NAME,',
'    --',
'    p_tab_set                  => :P4716_TAB_SET,',
'    p_tab_name                 => :P4716_TAB_NAME,',
'    p_tab_text                 => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_breadcrumb_id            => :P616_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P616_BREADCRUMB_NAME,',
'    p_parent_bc_id             => :P616_BREADCRUMB_PARENT_ID,',
'    --',
'    p_sql                      => l_sql,',
'    p_location                 => :P265_LOCATION,',
'    p_query_type               => l_query_type,',
'    p_remote_server_id         => l_remote_server_id,',
'    p_web_src_module_id        => l_web_src_module_id,',
'    p_table_owner              => l_owner,',
'    p_table_name               => l_table,',
'    p_chart_type               => case :P751_JET_CHART_TYPE when ''GANTT'' then ''gantt'' else :P751_JET_CHART_TYPE end,',
'    p_series_type              => l_series_type,',
'    p_max_row_count            => :P265_MAX_ROWS,  ',
'    --',
'    p_items_value_column_name    => :P266_VALUE_COL,',
'    p_items_low_column_name      => :P266_LOW_COL,',
'    p_items_high_column_name     => :P266_HIGH_COL,',
'    p_items_open_column_name     => :P266_OPEN_COL,',
'    p_items_close_column_name    => :P266_CLOSE_COL,   ',
'    p_items_x_column_name        => :P266_X_COL,',
'    p_items_y_column_name        => :P266_Y_COL,',
'    p_items_z_column_name        => :P266_Z_COL,',
'    p_items_target_value         => :P266_TARGET_COL,',
'    p_items_max_value            => :P266_MAX_VAL_COL,',
'    p_group_short_desc_column_name     => :P266_LABEL_COL,',
'    p_items_label_column_name    => :P266_LABEL_COL,',
'    p_aggregate_function         => :P266_AGGREGATE_FUNCTION,',
'    p_ajax_items_to_submit       => :P265_AJAX_ITEMS_TO_SUBMIT,',
'    -- ',
'    p_orientation                => :P266_ORIENTATION,',
'    p_stack                      => (case when :P266_STACK_CHART=''Y'' then ''on'' else ''off'' end),',
'   -- p_spark_chart                => (case when :P266_SPARK_CHART=''Y'' then true else false end),',
'    p_spark_chart                => :P266_SPARK_CHART,',
'    p_show_tooltip               => ''Y'',',
'    p_show_legend                => case when :P751_JET_CHART_TYPE in (''pie'',''donut'') then ''auto'' else ''none'' end,  -- Pre 18.2 - 19.1 was remove; for consistency with Create App wiz, display for Pie & Donut',
'    --',
'    p_gantt_start_date_column    => :P266_START_DATE_COL,',
'    p_gantt_end_date_column      => :P266_END_DATE_COL,  ',
'    p_gantt_task_id              => :P266_TASK_ID,  ',
'    p_gantt_task_name            => :P266_TASK_NAME,',
'    p_gantt_task_start_date      => :P266_TASK_START_DATE,',
'    p_gantt_task_end_date        => :P266_TASK_END_DATE,',
'    --',
'    p_gauge_orientation          => :P266_GAUGE_ORIENTATION',
'    );',
'    ',
'  :fb_flow_page_id       := :P616_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P616_PAGE_ID;    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(269364367647616791.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(269031386974330625.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Gr\00E1fico creado.')
);
end;
/
prompt --application/pages/page_00267
begin
wwv_flow_api.create_page(
 p_id=>267.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar Tema'
,p_step_title=>'Crear/Editar Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_javascript_code=>'htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16223526336631415.4001)
,p_plug_name=>unistr('Valores por Defecto de Transici\00F3n')
,p_region_name=>'TRANSITION_DEFAULTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>62
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16228711370721645.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22486830752876187.4001)
,p_name=>'Archivos'
,p_region_name=>'FILES'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>132
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       security_group_id,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       round( sys.dbms_lob.getLength(file_content) / 1024 / 1024, 2 )  as file_size_in_mb,',
'       file_charset,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'           p_scope      => ''THEME'',',
'           p_app_id     => :FB_FLOW_ID,',
'           p_theme_id   => :P267_THEME_ID,',
'           p_file_name  => file_name ) as reference,',
'       -- unescaping URL to keep whitespaces in G_BC_PARENT_LABEL',
'       utl_url.unescape(apex_page.get_url(',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_SCOPE,P118_APP_ID,P118_THEME_ID,P118_ID,G_BC_PARENT_LABEL'',',
'           p_values      => ''THEME,'' || flow_id || '','' || :P267_THEME_ID || '','' || id || '','' || :P267_THEME_NAME || '' - '' || :P267_THEME_ID ',
'        )) as edit_link,',
'       nvl(last_updated_on, created_on)                 as updated,',
'       nvl(lower(last_updated_by), lower(created_by))   as updated_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_theme_files f)',
' where flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_condition=>'P267_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P267_THEME_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn archivo.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487000323876232.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3567043336979612.4001)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487110071876237.4001)
,p_query_column_id=>3
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Nombre de Archivo'
,p_use_as_row_header=>'N'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487206680876237.4001)
,p_query_column_id=>4
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>31
,p_column_heading=>'Tipo MIME'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487310479876237.4001)
,p_query_column_id=>5
,p_column_alias=>'FILE_SIZE'
,p_column_display_sequence=>51
,p_column_heading=>unistr('Tama\00F1o de Archivo')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3566444589979606.4001)
,p_query_column_id=>6
,p_column_alias=>'FILE_SIZE_IN_MB'
,p_column_display_sequence=>61
,p_column_heading=>unistr('Tama\00F1o de archivo en MB')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3566529443979607.4001)
,p_query_column_id=>7
,p_column_alias=>'FILE_CHARSET'
,p_column_display_sequence=>41
,p_column_heading=>'Juego de Caracteres de Archivo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487429427876239.4001)
,p_query_column_id=>8
,p_column_alias=>'FILE_CONTENT'
,p_column_display_sequence=>81
,p_column_heading=>'Archivo'
,p_use_as_row_header=>'N'
,p_column_format=>'DOWNLOAD:WWV_FLOW_THEME_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME:LAST_UPDATED_ON:FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(261793403347047683.4001)
,p_query_column_id=>9
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>71
,p_column_heading=>'Referencia'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3566613401979608.4001)
,p_query_column_id=>10
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>91
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3566713476979609.4001)
,p_query_column_id=>11
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>101
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3566842384979610.4001)
,p_query_column_id=>12
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>111
,p_column_heading=>'Actualizado por'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(59029014305181516.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60494608771600292.4001)
,p_plug_name=>'Valores por Defecto de Componente'
,p_region_name=>'COMPONENT_DEFAULTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>42
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Especifique los valores por defecto de componente por tipo de componente.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73829002796853667.4001)
,p_plug_name=>unistr('Valores por Defecto de Regi\00F3n')
,p_region_name=>'REGION_DEFAULTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>52
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('Especifique los valores por defecto de regi\00F3n por tipo de componente.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111484730067981625.4001)
,p_plug_name=>'Tareas'
,p_region_name=>'TASKS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(111435127334933550.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(124921420001434175.4001)
,p_plug_name=>'Imagen'
,p_region_name=>'IMAGE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>112
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166329430439530196.4001)
,p_plug_name=>'Tema'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(366546306074187573.4001)
,p_name=>'Estilos'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>122
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ID", ',
'       "NAME",',
'       decode("IS_CURRENT",''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'','''') as is_current,',
'       decode("IS_PUBLIC",''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'','''') as is_public,',
'       decode("IS_ACCESSIBLE",''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'','''') as is_accessible',
'from "#OWNER#"."WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P267_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID  '))
,p_display_when_condition=>'P267_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No se han cargado los estilos de tema.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(366546618955187578.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'IS_NOT_READ_ONLY'
,p_derived_column=>'N'
,p_ref_schema=>'APEX_050000'
,p_ref_table_name=>'WWV_FLOW_THEME_STYLES'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(366546931290187586.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:177:&SESSION.::&DEBUG.:RP,177:P177_ID:#ID#:'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_050000'
,p_ref_table_name=>'WWV_FLOW_THEME_STYLES'
,p_ref_column_name=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(366547125225187586.4001)
,p_query_column_id=>3
,p_column_alias=>'IS_CURRENT'
,p_column_display_sequence=>3
,p_column_heading=>'Es Actual'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>100
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_050000'
,p_ref_table_name=>'WWV_FLOW_THEME_STYLES'
,p_ref_column_name=>'IS_CURRENT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(879702109115493843.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_PUBLIC'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Es P\00FAblico')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>100
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(879702291434493844.4001)
,p_query_column_id=>5
,p_column_alias=>'IS_ACCESSIBLE'
,p_column_display_sequence=>5
,p_column_heading=>'Accesibilidad Probada'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>100
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615357704912673099.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>142
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_THEMES',
'where id = :P267_ID ',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id                 => :P267_ID,',
'      p_component_type     => ''Theme'',',
'      p_last_updated_by    => c1.last_updated_by,',
'      p_last_updated_on    => c1.last_updated_on,',
'      p_created_by         => c1.created_by,',
'      p_created_on         => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(697004804009046662.4001)
,p_plug_name=>unistr('Suscripci\00F3n a Tema')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>12
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attribute_01=>'WWV_FLOW_THEMES'
,p_attribute_02=>'THEME_NAME'
,p_attribute_03=>'P267_ID'
,p_attribute_04=>'P267_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_THEME'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(925260747421540222.4001)
,p_plug_name=>'Opciones de Plantilla Global'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>82
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  initcap(o.template_types) template_types, ',
'  o.id, ',
'  o.display_name,',
'  o.display_name display_name_display,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'   decode(o.is_advanced,''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">Y</span>'',''N'',''<span class="u-VisuallyHidden">N</span>'','''') is_advanced',
'  from wwv_flow_template_options o',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and theme_id = :P267_THEME_ID',
'   and o.security_group_id  = :WORKSPACE_ID',
' order by template_types, display_sequence'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P267_DEFAULT_TEMPLATE_OPTIONS,P267_THEME_ID'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(925260893554540223.4001)
,p_max_row_count=>'1000000'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF:RTF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SHAKEEB'
,p_internal_uid=>925260893554540223
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925260974144540224.4001)
,p_db_column_name=>'TEMPLATE_TYPES'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925261041898540225.4001)
,p_db_column_name=>'ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925261194992540226.4001)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Nombre Mostrado'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:RP,406:P406_THEME_ID,P406_ID:&P267_THEME_ID.,#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_column_type=>'STRING'
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1020223132422120138.4001)
,p_db_column_name=>'DISPLAY_NAME_DISPLAY'
,p_display_order=>40
,p_column_identifier=>'H'
,p_column_label=>'Nombre Mostrado'
,p_column_type=>'STRING'
,p_display_condition_type=>'IS_READ_ONLY'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925261240602540227.4001)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925261379804540228.4001)
,p_db_column_name=>'CSS_CLASSES'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Clases'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925261450025540229.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Grupo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925261531138540230.4001)
,p_db_column_name=>'IS_ADVANCED'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Avanzado'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1055906341587945591.4001)
,p_plug_name=>'Temas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas utilizadas para definir la interfaz de usuario de una aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1104687140829514413.4001)
,p_plug_name=>unistr('Nueva Suscripci\00F3n a <br/>Tema Incorporado')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La suscripci\00F3n a este tema est\00E1 anulada actualmente. Si desea volver a una versi\00F3n suscrita de este tema, debe realizar los siguientes pasos:</p>'),
'<nl>',
unistr('  <li>En Temas, haga clic en la tarea Cambiar N\00FAmero de Identificaci\00F3n (en la barra lateral derecha) y cambie este tema a un nuevo n\00FAmero.</li>'),
'  <li>Vuelva a crear este tema desde el repositorio.</li>',
unistr('  <li>Cambie a la aplicaci\00F3n actual para utilizar este nuevo tema.</li>'),
unistr('  <li>Suprima el tema original cuyo n\00FAmero ha cambiado.</li>'),
'</nl>'))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) = 0',
'and :P267_THEME_ID < 100'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119685727798584502.4001)
,p_plug_name=>unistr('Nueva Suscripci\00F3n a <br/>Tema Personalizado')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La suscripci\00F3n a este tema est\00E1 anulada actualmente. Si desea volver a una versi\00F3n suscrita de este tema desde otra aplicaci\00F3n, debe realizar los siguientes pasos:</p>'),
'<nl>',
unistr('  <li>Cree un nuevo tema como una copia de otra aplicaci\00F3n, la aplicaci\00F3n "maestra", asegur\00E1ndose de que Suscribir Tema est\00E9 definido en S\00ED.</li>'),
unistr('  <li>Cambie a la aplicaci\00F3n para utilizar este nuevo tema.</li>'),
'  <li>Suprima este tema existente.</li>',
'</nl>'))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) = 0',
'and :P267_THEME_ID >= 100'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_plug_name=>'Iconos'
,p_region_name=>'ICONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>102
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1253548287352954907.4001)
,p_plug_name=>'Hojas de Estilo en Cascada y JavaScript'
,p_region_name=>'JS_CSS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>22
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1542908891918063223.4001)
,p_plug_name=>unistr('Valores por Defecto de Cuadro de Di\00E1logo')
,p_region_name=>'DIALOG_DEFAULTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>55
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1449459881694055501.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(697004804009046662.4001)
,p_button_name=>'Verify'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Verificar'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.::P75_THEME_ID,P75_REFERENCE_ID:&P267_ID.,&P267_REFERENCE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) <> 0'))
,p_button_condition_type=>'EXISTS'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1019537897835357487.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(697004804009046662.4001)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular Suscripci\00F3n')
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:RP:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) <> 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(702515877843814128.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(697004804009046662.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Tema'
,p_button_position=>'CHANGE'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) <> 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(702513025194691919.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(697004804009046662.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Tema'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:233:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where reference_id = :P267_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(651993392800217425.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(925260747421540222.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID:&P267_THEME_ID.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(687752411036355153.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(925260747421540222.4001)
,p_button_name=>'EDIT_TEMPLATE_OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Editar Grupos de Opciones de Plantilla'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81:P81_THEME_ID:&P267_THEME_ID.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30850316934009164.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22486830752876187.4001)
,p_button_name=>'FILES_DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Todos los Archivos'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_theme_files',
' where flow_id           = :P267_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59029406622181518.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(166329430439530196.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30850514346010329.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22486830752876187.4001)
,p_button_name=>'FILES_DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar como Zip'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_theme_files',
' where flow_id           = :P267_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59029604353181518.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(166329430439530196.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''P267_ID'') is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22487529555876240.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22486830752876187.4001)
,p_button_name=>'CREATE_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Archivo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE,P118_APP_ID,P118_THEME_ID,G_BC_PARENT_LABEL:THEME,&P267_FLOW_ID.,&P267_THEME_ID.,&P267_THEME_NAME.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59029514259181518.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(166329430439530196.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''P267_ID'') is null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(366547523210187587.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(366546306074187573.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Agregar Estilo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:177:&SESSION.::&DEBUG.:177:P177_THEME_ID:&P267_THEME_ID.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30851608128017763.4001)
,p_branch_name=>'Reset Pagination after delete all theme files'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30850316934009164.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(741112107076403632.4001)
,p_branch_name=>'Refresh'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(702515877843814128.4001)
,p_branch_sequence=>15
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(741115537491559351.4001)
,p_branch_name=>'Publish'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(702513025194691919.4001)
,p_branch_sequence=>16
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22512313811098392.4001)
,p_branch_name=>'Apply Changes and go to Edit Theme File'
,p_branch_action=>'f?p=&APP_ID.:227:&SESSION.::&DEBUG.:RP,227:P227_ID:&P267_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_227'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(59031929589181536.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5268221688943910.4001)
,p_name=>'P267_UI_TYPE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_source=>'UI_TYPE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Especifica la interfaz de usuario para la que est\00E1 dise\00F1ado el tema.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16222316162618962.4001)
,p_name=>'P267_DEFAULT_PAGE_TRANSITION'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(16223526336631415.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NONE'
,p_prompt=>unistr('Transici\00F3n de P\00E1gina')
,p_source=>'DEFAULT_PAGE_TRANSITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_AND_POPUP_TRANSITIONS'
,p_lov=>'.'||wwv_flow_api.id(16215309545314300.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica la transici\00F3n que se debe utilizar al navegar a una nueva p\00E1gina o cuando la p\00E1gina se est\00E1 enviando.'),
'</p>',
'<p>',
unistr('<strong>\00BFS\00F3lo visualiza transiciones de difuminado?</strong> Para ver todos los tipos de transiciones, debe tener un explorador que soporte transformaciones en 3D. Por defecto, los dispositivos que no soportan 3D (como Android 2.x) se reservar\00E1n en "')
||unistr('difuminado" para todos los tipos de transiciones. Consulte la documentaci\00F3n de jQuery Mobile para obtener m\00E1s informaci\00F3n.'),
'</p>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16222930707623224.4001)
,p_name=>'P267_DEFAULT_POPUP_TRANSITION'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(16223526336631415.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NONE'
,p_prompt=>unistr('Transici\00F3n Emergente')
,p_source=>'DEFAULT_POPUP_TRANSITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_AND_POPUP_TRANSITIONS'
,p_lov=>'.'||wwv_flow_api.id(16215309545314300.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica la transici\00F3n que se debe utilizar al abrir un elemento emergente.'),
'</p>',
'<p>',
unistr('<strong>\00BFS\00F3lo visualiza transiciones de difuminado?</strong> Para ver todos los tipos de transiciones, debe tener un explorador que soporte transformaciones en 3D. Por defecto, los dispositivos que no soportan 3D (como Android 2.x) se reservar\00E1n en "')
||unistr('difuminado" para todos los tipos de transiciones. Consulte la documentaci\00F3n de jQuery Mobile para obtener m\00E1s informaci\00F3n.'),
'</p>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22487708554876260.4001)
,p_name=>'P267_FILE_PREFIX'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(22486830752876187.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prefijo de Archivo'
,p_source=>'FILE_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina la ruta virtual que utiliza el servidor web para apuntar a los archivos del tema. Por motivos de rendimiento, puede almacenar los archivos del tema en el servidor web en lugar de hacerlo con la definici\00F3n de tema en la base de datos. Uti')
||unistr('lice <code>&#35;APEX_FILES&#35;</code> o cualquier URL v\00E1lida para hacer referencia a ellos.</p>'),
'',
unistr('<p>No especifique nada para hacer referencia a los archivos que se almacenan con su definici\00F3n de tema en la base de datos. Si especifica el prefijo de archivo y a\00FAn desea hacer referencia a los archivos almacenados con el tema en la base de datos, u')
||'tilice <code>&#35;THEME_DB_FILES&#35;</code> en lugar de <code>&#35;THEME_FILES&#35;</code> en las plantillas.</p>',
'',
'<p>Ejemplos:',
'<ul>',
'  <li>/myFiles/</li>',
'  <li>https://example.com/myFiles/</li>',
'  <li>&#35;APEX_FILES&#35;myFiles/</li>',
'</li>',
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22513229999111559.4001)
,p_name=>'P267_FILE_ID'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(22486830752876187.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45364525279433521.4001)
,p_name=>'P267_DEFAULT_DIALOG_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1542908891918063223.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina de Cuadro de Di\00E1logo')
,p_source=>'DEFAULT_DIALOG_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_DIALOG_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = ''Y''',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla por defecto para visualizar p\00E1ginas de cuadro de di\00E1logo modal o no modal. Si un desarrollador no'),
unistr('selecciona expl\00EDcitamente una plantilla, el motor de &PRODUCT_NAME. utiliza la plantilla especificada aqu\00ED. Esta plantilla'),
unistr('tambi\00E9n se utilizar\00E1 para los errores que aparecen en otra p\00E1gina frente a los que aparecen en l\00EDnea.')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59032321514181540.4001)
,p_name=>'P267_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59032717356181559.4001)
,p_name=>'P267_THEME_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in (select max(theme_id)+1 theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'    if c1.theme_id > 100 then',
'      return c1.theme_id;',
'    else ',
'      return 101;',
'    end if;',
'   end loop;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de Tema')
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_cHeight=>1
,p_read_only_when=>'P267_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('N\00FAmero de identificaci\00F3n de una recopilaci\00F3n de plantillas que definen la interfaz de usuario de una aplicaci\00F3n.')
,p_attribute_03=>'right'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59033517263181567.4001)
,p_name=>'P267_THEME_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'THEME_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Proporciona una abreviatura descriptiva para el tema.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59047223736269265.4001)
,p_name=>'P267_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual. ')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60493329418596699.4001)
,p_name=>'P267_DEFAULT_PAGE_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'DEFAULT_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla por defecto para visualizar p\00E1ginas. Si un desarrollador no selecciona expl\00EDcitamente una plantilla, el motor &PRODUCT_NAME. utiliza la plantilla especificada aqu\00ED. '),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62082221573064205.4001)
,p_name=>'P267_ERROR_TEMPLATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina de Errores')
,p_source=>'ERROR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Opcional. Especifica la plantilla de p\00E1gina que se utilizar\00E1 para los errores que aparecen en otra p\00E1gina frente a los que se muestran en l\00EDnea. Deje este atributo en blanco si no desea utilizar una plantilla dise\00F1ada para mostrar errores. El valor s')
||unistr('olo se aplica a las p\00E1ginas normales.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62082515788064212.4001)
,p_name=>'P267_PRINTER_FIENDLY_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina de Versi\00F3n para Impresora')
,p_source=>'PRINTER_FRIENDLY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica la plantilla que se utilizar\00E1 cuando el motor &PRODUCT_NAME. est\00E9 en modo Versi\00F3n para Impresora. Al llamar a &PRODUCT_NAME. para que represente una p\00E1gina, puede identificar un atributo de versi\00F3n para impreso')
||unistr('ra con los valores S\00CD o NO.</div>'),
unistr('<div class="htmldbInfoBodyP">Si selecciona S\00CD, se utiliza la plantilla de versi\00F3n para impresora para mostrar la p\00E1gina. El motor &PRODUCT_NAME. muestra todo el texto de los campos de pantalla HTML como texto. La plantilla de versi\00F3n para impresora n')
||unistr('o necesita tener las etiquetas <code>#FORM_OPEN#</code> o <code>#FORM_CLOSE#</code>. El objetivo es poder mostrar informaci\00F3n con pocas tablas y en un formato adecuado para su impresi\00F3n.</div>')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62083305677064214.4001)
,p_name=>'P267_BUTTON_TEMPLATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Bot\00F3n')
,p_source=>'DEFAULT_BUTTON_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_BUTTON_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''BUTTON''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de bot\00F3n por defecto utilizada al crear un nuevo bot\00F3n. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62083725704064214.4001)
,p_name=>'P267_REGION_TEMPLATE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n')
,p_source=>'DEFAULT_REGION_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear una nueva regi\00F3n. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62084132531064215.4001)
,p_name=>'P267_CHART_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Gr\00E1ficos')
,p_source=>'DEFAULT_CHART_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de gr\00E1fico por defecto utilizada al crear un gr\00E1fico. Podr\00E1 sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62084501451064216.4001)
,p_name=>'P267_FORM_TEMPLATE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pantallas'
,p_source=>'DEFAULT_FORM_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de pantalla por defecto utilizada al crear una pantalla. Podr\00E1 sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62084903043064217.4001)
,p_name=>'P267_REPORTR_TEMPLATE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Informes'
,p_source=>'DEFAULT_REPORTR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear un informe. Podr\00E1 sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62085714401064218.4001)
,p_name=>'P267_WIZARD_TEMPLATE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Asistentes'
,p_source=>'DEFAULT_WIZARD_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear un nuevo componente de asistente. Podr\00E1 sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62086118351064219.4001)
,p_name=>'P267_MENUR_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Rutas de Navegaci\00F3n')
,p_source=>'DEFAULT_MENUR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear una ruta de navegaci\00F3n. Podr\00E1 sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62086526255064220.4001)
,p_name=>'P267_LISTR_TEMPLATE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Listas'
,p_source=>'DEFAULT_LISTR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear una lista. Podr\00E1 sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73614116621280485.4001)
,p_name=>'P267_REPORT_TEMPLATE'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Informe Cl\00E1sico')
,p_source=>'DEFAULT_REPORT_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REPORT_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REPORT''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear un informe. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73614408283280487.4001)
,p_name=>'P267_LABEL_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta por Defecto'
,p_source=>'DEFAULT_LABEL_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LABEL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de etiqueta por defecto utilizada al crear una nueva etiqueta. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73614806510280489.4001)
,p_name=>'P267_MENU_TEMPLATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_source=>'DEFAULT_MENU_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_MENU_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''MENU''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de ruta de navegaci\00F3n por defecto utilizada al crear una ruta de navegaci\00F3n. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73615217202280490.4001)
,p_name=>'P267_CALENDAR_TEMPLATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Calendario Heredado'
,p_source=>'DEFAULT_CALENDAR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_CALENDAR_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''CALENDAR''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de calendario por defecto utilizada al crear un nuevo calendario. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73615629679280490.4001)
,p_name=>'P267_LIST_TEMPLATE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lista'
,p_source=>'DEFAULT_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de lista por defecto utilizada al crear una nueva lista. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113806709842492190.4001)
,p_name=>'P267_THEME_DESCRIPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'THEME_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporciona una descripci\00F3n breve para el tema.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113812220015504654.4001)
,p_name=>'P267_THEME_IMAGE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(124921420001434175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nueva Imagen 150x80'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Imagen representativa del tema. Debe tener 150 p\00EDxeles de ancho y 80 de alto.')
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_11=>'image/*'
,p_attribute_12=>'INLINE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123747511259733696.4001)
,p_name=>'P267_CURRENT_IMAGE'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(124921420001434175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen de Tema'
,p_source=>'return wwv_flow_theme_manager.get_theme_image_name(p_id=>:P267_ID);'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Imagen actual de este tema.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(124883111325930246.4001)
,p_name=>'P267_CUSTOM_IMAGE'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(124921420001434175.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Imagen Personalizada'
,p_source=>'CUSTOM_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Utilice la imagen de tema por defecto o cargue una imagen de tema personalizada.'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174542317951520703.4001)
,p_name=>'P267_NAVIGATION_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'L'
,p_prompt=>unistr('Tipo de Navegaci\00F3n')
,p_source=>'NAVIGATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVIGATION TYPE'
,p_lov=>'.'||wwv_flow_api.id(174541309940513694.4001)||'.'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''P267_ID'') is not null',
''))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica el tipo de navegaci\00F3n seleccionado. Las opciones v\00E1lidas son: Separadores o Lista.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174544515757567360.4001)
,p_name=>'P267_DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Lista de Men\00FAs de Navegaci\00F3n (Superior)')
,p_source=>'DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de lista de men\00FA navegaci\00F3n por defecto utilizada al crear una nueva lista que se mostrar\00E1 al principio de la p\00E1gina. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198271924908216321.4001)
,p_name=>'P267_IRR_TEMPLATE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(73829002796853667.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Informes Interactivos'
,p_source=>'DEFAULT_IRR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear un informe interactivo. Tendr\00E1 la oportunidad de sustituir este valor por defecto.'),
''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211564805306093452.4001)
,p_name=>'P267_CALENDAR_ICON'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Icono del Selector de Fecha'
,p_source=>'CALENDAR_ICON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el nombre y ubicaci\00F3n de la imagen que se utilizar\00E1 cuando aparezcan elementos de tipo Selector de Fecha.'),
'<p />',
'Ejemplo:',
'<p />',
'<pre>&#35;IMAGE_PREFIX&#35;new_cal.bmp</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211570520853145252.4001)
,p_name=>'P267_CALENDAR_ICON_ATTR'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Icono del Selector de Fecha'
,p_source=>'CALENDAR_ICON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca los atributos de imagen para el icono de Calendario. ',
'<p />',
'Ejemplo: ',
'<p />',
'<pre>width="16" height="16" alt="Mostrar Calendario"</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(219204726283743802.4001)
,p_name=>'P267_DEFAULT_HEADER_TEMPLATE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Barra de Herramientas de Cabecera'
,p_source=>'DEFAULT_HEADER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica la plantilla de regi\00F3n de barra de herramientas de cabecera por defecto cuando crea una nueva p\00E1gina que incluye una cabecera o barras de herramientas de pie de p\00E1gina.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(219206630584756923.4001)
,p_name=>'P267_DEFAULT_FOOTER_TEMPLATE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Barra de Herramientas de Pie de P\00E1gina')
,p_source=>'DEFAULT_FOOTER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica la plantilla de regi\00F3n de barra de herramientas de pie de p\00E1gina por defecto cuando crea una nueva p\00E1gina que incluye una cabecera o barras de herramientas de pie de p\00E1gina.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(389109186894297111.4001)
,p_name=>'P267_DEFAULT_LOGIN_PAGE_TEMPLATE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina de Conexi\00F3n')
,p_source=>'LOGIN_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla por defecto para visualizar p\00E1ginas. Si un desarrollador no selecciona expl\00EDcitamente una plantilla, el motor &PRODUCT_NAME. utiliza la plantilla especificada aqu\00ED. '),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(389109259611297112.4001)
,p_name=>'P267_OPTION_LABEL'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta Opcional'
,p_source=>'DEFAULT_OPTION_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LABEL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de etiqueta opcional por defecto utilizada al crear una nueva etiqueta. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(389109315089297113.4001)
,p_name=>'P267_REQUIRED_LABEL'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta Necesaria'
,p_source=>'DEFAULT_REQUIRED_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LABEL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de etiqueta necesaria por defecto utilizada al crear una nueva etiqueta. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(697009146472135165.4001)
,p_name=>'P267_REFERENCE_ID'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(697004804009046662.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(946447335666624250.4001)
,p_name=>'P267_DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Lista de Men\00FAs de Navegaci\00F3n (Lateral)')
,p_source=>'DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de lista de men\00FA de navegaci\00F3n por defecto utilizada al crear una nueva lista que se mostrar\00E1 en el lateral de la p\00E1gina. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(982227744761899601.4001)
,p_name=>'P267_DEFAULT_NAV_LIST_POSITION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TOP'
,p_prompt=>unistr('Posici\00F3n de Lista de Men\00FAs de Navegaci\00F3n')
,p_source=>'DEFAULT_NAV_LIST_POSITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Top;TOP,Side;SIDE'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la posici\00F3n de la lista de men\00FA de navegaci\00F3n por defecto. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1252826171549086133.4001)
,p_name=>'P267_NAV_BAR_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NAVBAR'
,p_prompt=>unistr('Implantaci\00F3n de Barra de Navegaci\00F3n')
,p_source=>'NAV_BAR_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAV_BAR_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1383750926477562234.4001)||'.'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''P267_ID'') is not null',
''))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica la implantaci\00F3n de la barra de navegaci\00F3n seleccionada. Entre las opciones v\00E1lidas se incluyen: Cl\00E1sica o Lista.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1253548083481954905.4001)
,p_name=>'P267_ICON_LIBRARY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Biblioteca'
,p_source=>'ICON_LIBRARY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON_LIBRARIES'
,p_lov=>'.'||wwv_flow_api.id(1284197032342757201.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Biblioteca -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la biblioteca de iconos que se cargar\00E1 cuando &PRODUCT_NAME. muestre una p\00E1gina. Los iconos de la biblioteca tambi\00E9n se mostrar\00E1n en el selector de iconos del dise\00F1ador de p\00E1ginas.'),
'<br><br>',
unistr('Seleccione <strong>Fuente APEX - M\00E1s reciente</strong> si desea utilizar una versi\00F3n de Fuente APEX m\00E1s reciente que la que se env\00EDa con &PRODUCT_NAME.. Puede obtener la versi\00F3n m\00E1s reciente en GitHub y cargar los archivos en la carpeta <code>librari')
||unistr('es/font-apex/latest/</code> en el directorio de im\00E1genes de &PRODUCT_NAME..')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1253548176122954906.4001)
,p_name=>'P267_CUSTOM_ICON_CLASSES'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clases Personalizadas'
,p_source=>'CUSTOM_ICON_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Especifique una lista delimitada por comas de nombres de clase CSS que se mostrar\00E1n en el selector para la regi\00F3n y el bot\00F3n <strong>Clases CSS de Icono</strong>, que se implanta en el dise\00F1ador de p\00E1ginas.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1284198878924776853.4001)
,p_name=>'P267_CUSTOM_LIBRARY_FILE_URLS'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivos de Biblioteca Personalizada'
,p_source=>'CUSTOM_LIBRARY_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada para iconos personalizados que se van a cargar en cada p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena ')
||unistr('de sustituci\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para obtener una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de d')
||unistr('epuraci\00F3n. Tambi\00E9n tiene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
unistr('<p>Las URL de archivo que introduzca aqu\00ED reemplazar\00E1n la cadena de sustituci\00F3n <code>#THEME_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo del directorio del tema:'),
'      <pre>#THEME_IMAGES#icons.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado icons.min.css de /mycss/minified/ para vistas de p\00E1gina normales e icons.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#icons#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional:',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone_icons.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), el explorador carga el nuevo archivo e')
||unistr(' ignora cualquier archivo almacenado en cach\00E9 anteriormente:'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1284811815656337680.4001)
,p_name=>'P267_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(1253548287352954907.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivos JavaScript'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivos JavaScript para el c\00F3digo que se va a cargar en cada p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code>')
||unistr(' para incluir <code>.min</code>, o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n.</p>'),
'',
unistr('<p>Las URL de archivos JavaScript que ha introducido aqu\00ED reemplazan la cadena de sustituci\00F3n <code>#THEME_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre. Solo escriba la URL.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo desde el directorio de tema:'),
'      <pre>#THEME_IMAGES#main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de /myjs/minified/ para vistas de p\00E1gina normales y main.js de /myjs/ en modo de depuraci\00F3n:'),
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca tambi\00E9n se utiliza desde una llamada obligatoria RequireJS. El nombre de definici\00F3n debe coincidir con lo que se utiliza en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global exp')
||'uesto por la biblioteca. Solo se aplica cuando se utiliza RequireJS. Esto evita que RequireJS cargue esa biblioteca por segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1284812351123340641.4001)
,p_name=>'P267_CSS_FILE_URLS'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(1253548287352954907.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo CSS'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar en cada p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#<')
||unistr('/code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a l')
||unistr('a cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
unistr('<p>Las URL de archivo que introduzca aqu\00ED reemplazar\00E1n la cadena de sustituci\00F3n <code>#THEME_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo del directorio del tema'),
'      <pre>/mycss/main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), se indica al explorador que siempre ca')
||unistr('rgue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1301370800500065017.4001)
,p_name=>'P267_DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(60494608771600292.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Lista de Barra de Navegaci\00F3n')
,p_source=>'DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de lista de barra de navegaci\00F3n por defecto utilizada al definir el tipo de barra de navegaci\00F3n como Lista en la aplicaci\00F3n. Podr\00E1 sustituir este valor por defecto en la configuraci\00F3n de la interfaz de usuario en el nivel de a')
||unistr('plicaci\00F3n.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1331349974716223301.4001)
,p_name=>'P267_THEME_INTERNAL_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(59029014305181516.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'THEME_INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifica el identificador de tema interno.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1499431470721055521.4001)
,p_name=>'P267_CUSTOM_ICON_PREFIX_CLASS'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(1253547956481954904.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Prefijo Personalizada'
,p_source=>'CUSTOM_ICON_PREFIX_CLASS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una clase CSS que, en tiempo de ejecuci\00F3n, se agregar\00E1 como prefijo a las <em>clases CSS de icono</em> definidas para regiones, botones y listas, si no est\00E1n utilizando una clase de la biblioteca de iconos.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1542908747630063222.4001)
,p_name=>'P267_DIALOGR_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1542908891918063223.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n de Contenido de Cuadro de Di\00E1logo')
,p_source=>'DEFAULT_DIALOGR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear una regi\00F3n de contenido en un cuadro de di\00E1logo. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1542909180149063226.4001)
,p_name=>'P267_DIALOGBTNR_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1542908891918063223.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n de Bot\00F3n de Cuadro de Di\00E1logo')
,p_source=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la plantilla de regi\00F3n por defecto utilizada al crear una regi\00F3n de bot\00F3n en un cuadro de di\00E1logo. Podr\00E1 sustituir este valor por defecto.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(146912508847899403.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_themes where id = :P267_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144930106193955936.4001)
,p_validation_name=>'P267_THEME_ID'
,p_validation_sequence=>10
,p_validation=>'P267_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de tema.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(59032717356181559.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144933307840975374.4001)
,p_validation_name=>'p267_theme_id not in use'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select 1 from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :P267_THEME_ID) loop',
'  return false;',
'end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de tema est\00E1 en uso; especifique otro.')
,p_validation_condition=>'CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144936229789991157.4001)
,p_validation_name=>'theme_id > 100'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :p267_theme_id < 100 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Los identificadores de tema por debajo de 100 est\00E1n reservados para Oracle.')
,p_validation_condition=>'CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144947809665032627.4001)
,p_validation_name=>'P267_THEME_NAME'
,p_validation_sequence=>40
,p_validation=>'P267_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre del tema.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(59033517263181567.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1917199210061795462.4001)
,p_validation_name=>'P267_DEFAULT_PAGE_TEMPLATE'
,p_validation_sequence=>80
,p_validation=>'P267_DEFAULT_PAGE_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la plantilla de p\00E1gina por defecto.')
,p_validation_condition=>'P267_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(60493329418596699.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16227008899692544.4001)
,p_name=>'Show/Hide Transition Defaults'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P267_UI_TYPE_ID'
,p_condition_element=>'P267_UI_TYPE_ID'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'2,3,4,5'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16227309441692548.4001)
,p_event_id=>wwv_flow_api.id(16227008899692544.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(16223526336631415.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16227523671692551.4001)
,p_event_id=>wwv_flow_api.id(16227008899692544.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(16223526336631415.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(16231801308917475.4001)
,p_name=>'Show/Hide Image Attributes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P267_CUSTOM_IMAGE'
,p_condition_element=>'P267_CUSTOM_IMAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16232115941917475.4001)
,p_event_id=>wwv_flow_api.id(16231801308917475.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P267_THEME_IMAGE,P267_CURRENT_IMAGE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(16232317374917475.4001)
,p_event_id=>wwv_flow_api.id(16231801308917475.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P267_THEME_IMAGE,P267_CURRENT_IMAGE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(30850621156011988.4001)
,p_name=>'Delete all Files'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30850316934009164.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(30851123380011988.4001)
,p_event_id=>wwv_flow_api.id(30850621156011988.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los archivos?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(30850916991011988.4001)
,p_event_id=>wwv_flow_api.id(30850621156011988.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FILES_DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(652028712498565430.4001)
,p_name=>'refresh template options'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(651993392800217425.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087752068458772809.4001)
,p_event_id=>wwv_flow_api.id(652028712498565430.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(925260747421540222.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1020211977856109164.4001)
,p_name=>'refresh template options'
,p_event_sequence=>60
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(925260747421540222.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1020212254472109165.4001)
,p_event_id=>wwv_flow_api.id(1020211977856109164.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(925260747421540222.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(59034405595181576.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P267_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(59034817493181579.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P267_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_THEMES.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(123739414713658957.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Theme Image'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.f4000_process_theme_image (',
'  p_id=>:P267_ID,',
'  p_THEME_IMAGE=>:P267_THEME_IMAGE,',
'  P_CUSTOM_IMAGE=>:P267_CUSTOM_IMAGE)'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30851225658013316.4001)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete all theme files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_theme_files',
'     where flow_id           = :P267_FLOW_ID',
'       and theme_id          = :P267_THEME_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30850316934009164.4001)
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30851432238015200.4001)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'PLUGIN_COM.ORACLE.APEX.DOWNLOAD_AS_ZIP'
,p_process_name=>'Download Theme Files as Zip'
,p_attribute_01=>'theme_&P267_THEME_ID._files.zip'
,p_attribute_02=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name,',
'       file_content',
'  from wwv_flow_theme_files',
' where flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30850514346010329.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741112591835413522.4001)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P267_REFERENCE_ID,',
'    p_subscribing_theme_id => :P267_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(702515877843814128.4001)
,p_process_success_message=>'Las plantillas y las opciones de plantilla se han refrescado desde los temas maestros.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741114961538527739.4001)
,p_process_sequence=>130
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'publish theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select id from wwv_flow_themes',
'    where reference_id = :P267_ID',
'    and security_group_id  = :WORKSPACE_ID',
') loop',
'    wwv_flow_copy_metadata.subscribe_theme (',
'        p_master_theme_id      => :P267_ID,',
'        p_subscribing_theme_id => c1.id',
'    );',
'end loop;    '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(702513025194691919.4001)
,p_process_success_message=>'Plantillas y opciones de plantilla publicadas.'
);
end;
/
prompt --application/pages/page_00268
begin
wwv_flow_api.create_page(
 p_id=>268.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Obj Base de Datos Referencia'
,p_step_title=>'Obj Base de Datos Referencia'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216995930363945283)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169481221098646108.4001)
,p_plug_name=>unistr('Dependencias de Objetos de Base de Datos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>160
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'decode(c003,''NON-EXISTENT'',null,c001) c001,',
'  c002,',
'nvl(decode(decode(c003,',
'  ''TABLE'',c001,',
'  ''VIEW'',c001,''/1''),',
'   o.owner,',
'   decode(c003,''NON-EXISTENT'',c002,c002)),c002) name,',
'decode(c003,''NON-EXISTENT'',',
'  null,htmldb_item.text_from_lov(c003,''OBJECT.TYPES'')) ',
'  c003,',
'  c004,',
'  c005,',
'  c006,',
'  -- c007 source_code,',
'  c008 application',
'from htmldb_collections c,',
'     (select owner from wwv_flows where id = :fb_flow_id) o',
'where collection_name = ''PAGE_DEPENDENCIES'' and',
'      c008 = :fb_flow_id and',
'      (c005 = nvl(:P268_PAGE_ID,:FB_FLOW_PAGE_ID))',
'and c002 <> ''PLITBLM''',
'order by c001,c002,c003'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(169481329244646108.4001)
,p_name=>'Page Database Object Dependencies'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169481521031646113.4001)
,p_db_column_name=>'C001'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Esquema'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169481620628646115.4001)
,p_db_column_name=>'C002'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'C002'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169481716950646116.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Objeto de Base de Datos'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169481827228646116.4001)
,p_db_column_name=>'C003'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Tipo con Referencia'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169539810260463865.4001)
,p_db_column_name=>'C004'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Componente APEX'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169539932554463866.4001)
,p_db_column_name=>'C005'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169540230823479301.4001)
,p_db_column_name=>'C006'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Identificador de Componente'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(169540420192479303.4001)
,p_db_column_name=>'APPLICATION'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180126220951957019.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(180180721578127550.4001)
,p_name=>unistr('Errores de An\00E1lisis')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c001,',
'c002,',
'c003,',
'c004,',
'c005,',
'c006,',
'c007,',
'c008,',
'c009,',
'c010,',
'c011,',
'c012',
'from htmldb_collections',
'where collection_name = ''PAGE_DEPENDENCIES_ERRORS'' and',
'   (:P268_PAGE_ID is null or c002 = :P268_PAGE_ID)'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from htmldb_collections',
'where collection_name = ''PAGE_DEPENDENCIES_ERRORS'' and',
'   (:p268_page is null or c002 = :p268_page)'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn error de an\00E1lisis')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(180181316286127561.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(180181420348127562.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#C002#'
,p_column_linktext=>'#C002#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(180181519892127562.4001)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(180181611209127562.4001)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'SQL'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(180181701541127563.4001)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186081214616567896.4001)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_column_heading=>'Application'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186081301781567897.4001)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_column_heading=>'Parse Method'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186111529919752006.4001)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_column_heading=>'Dependancies'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186111630519752007.4001)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'Compilado como'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186132522918844604.4001)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'Analizado como'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186134427682864997.4001)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'Estado de Objeto Temporal'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186308608802222083.4001)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>unistr('L\00EDneas')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194098214077747922.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(180126220951957019.4001)
,p_button_name=>'P268_GO'
,p_button_static_id=>'P268_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Definir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169699005490411200.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(180126220951957019.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:268:&SESSION.:COMPUTE:&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180128907364964599.4001)
,p_branch_action=>'f?p=&APP_ID.:268:&SESSION.:COMPUTE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(194096215678738968.4001)
,p_branch_action=>'f?p=&APP_ID.:268:&SESSION.:COMPUTE:&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(194098214077747922.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(194094826713713714.4001)
,p_name=>'P268_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(180126220951957019.4001)
,p_item_default=>'&fb_flow_page_id.'
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||wwv_flow_escape.html(name) n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina en la que desea ver los objetos de base de datos de referencia.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(188301603081117526.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'compute page dependencies'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.find_object_dependencies(',
'  p_flow_id=>:fb_flow_id,',
'  p_page_id=>:P268_PAGE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido calcular las dependencias.'
,p_process_when=>'COMPUTE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(127729420258904747.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine lock status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_region_layout.set_lock_status (p_flow=>:fb_flow_id, p_page=>:P23_PAGE_ID);',
'exception when others then null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
,p_process_comment=>'Set Build Option to "Commented Out" as part of APEX-1012.'
);
end;
/
prompt --application/pages/page_00273
begin
wwv_flow_api.create_page(
 p_id=>273.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Buscador de Elementos'
,p_step_title=>'Buscador de Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6208909558950279.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17534823323057949.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48571526134501952.4001)
,p_plug_name=>'Elementos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, ',
'        (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where ',
'   :F4000_P273_PAGE is null',
'and flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, ',
'        (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where ',
'   (:F4000_P273_PAGE is null or :F4000_P273_PAGE = flow_step_id)',
'and flow_id = :fb_flow_id',
'order by 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48571614952501952.4001)
,p_name=>'Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48571832657501958.4001)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48572019090501960.4001)
,p_db_column_name=>'PROMPT'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Etiqueta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48571912947501959.4001)
,p_db_column_name=>'T'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48572127726501960.4001)
,p_db_column_name=>'P'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::F4000_P273_PAGE:#P#'
,p_column_linktext=>'#P#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17540318418257745.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(17534823323057949.4001)
,p_button_name=>'F4000_P273_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1080990491963523937.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48571526134501952.4001)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.:RP,RIR,273:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164635429079721696.4001)
,p_branch_action=>'f?p=&FLOW_ID.:273:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17561408257292898.4001)
,p_name=>'F4000_P273_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17534823323057949.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1gina de la aplicaci\00F3n. Para cambiar el n\00FAmero de p\00E1gina, seleccione o introduzca un nuevo n\00FAmero y haga clic en <strong>Definir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
end;
/
prompt --application/pages/page_00278
begin
wwv_flow_api.create_page(
 p_id=>278.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Lista')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Lista')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49191031406782532.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(49195501717830717.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||PLUG_NAME name',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id and',
'      r.list_template_id = :p278_id',
'and r.security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(49196130505831149.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(317061106029827931.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747140069854138158.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49191829113791331.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(317061106029827931.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49192117171791333.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(317061106029827931.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49200124489856249.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49198532670849112.4001)
,p_name=>'P278_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(49191031406782532.4001)
,p_prompt=>'Plantilla de Lista:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_TEMPLATE_NAME, id',
'from WWV_FLOW_LIST_TEMPLATES',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la plantilla que se va a suprimir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49215521298949920.4001)
,p_name=>'P278_LIST_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(49191031406782532.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_class_id',
'from WWV_FLOW_LIST_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p278_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43918610013174571.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49220916842977042.4001)
,p_name=>'P278_THEME_ID'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(49191031406782532.4001)
,p_prompt=>'Tema:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from WWV_FLOW_LIST_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p278_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49206601596896907.4001)
,p_validation_name=>'P278_ID'
,p_validation_sequence=>10
,p_validation=>'P278_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(49198532670849112.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49235823993045364.4001)
,p_validation_name=>'Prevent deletion of used templates'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plugs',
' where flow_id          = :fb_flow_id',
'   and list_template_id = :p278_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'No puede suprimir plantillas a las que se hace referencia.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49199317217854124.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>'delete from WWV_FLOW_LIST_TEMPLATES where flow_id = :fb_flow_id and id = :p278_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(49192117171791333.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00284
begin
wwv_flow_api.create_page(
 p_id=>284.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asistente de \00C1rboles')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear \00C1rbol')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213443923391496926)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7234604259372868.4001)
,p_plug_name=>unistr('Crear \00C1rbol')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_start_value varchar2(4000) := null;',
'  l_tooltip     varchar2(4000) := null;',
'begin',
'',
'  -- Start With Column Value',
'  if :P116_START_TREE = ''ITEM'' then',
'      l_start_value := '':''||:P116_START_ITEM;',
'  elsif :P116_START_TREE = ''STATIC'' then',
'      l_start_value := :P116_START_STATIC_VALUE;',
'  elsif :P116_START_TREE = ''SQL'' then',
'      l_start_value := ''(''||:P116_SQL||'')'';',
'  end if;',
'',
'  -- Tooltip',
'  if :P68_SHOW_TOOLTIP = ''STATIC'' then',
'      l_tooltip := ''''''''||:P68_TOOLTIP_TEXT||'''''''';',
'  elsif :P68_SHOW_TOOLTIP = ''DB'' then',
'      l_tooltip := ''"''||:P68_TOOLTIP_DB||''"'';',
'  else',
'      l_tooltip := ''null'';',
'  end if;',
'',
'wwv_flow_wiz_confirm.create_tree (',
'    p_flow_id          => :FB_FLOW_ID,',
'    p_region_template  => replace(:F4000_P112_REGION_TEMPLATE,''%''||''null%'',null),',
'    p_start_option     => :F4000_P112_START_OPTION,',
'    p_owner            => :F4000_P112_OWNER,',
'    p_table_name       => :P114_TABLE_NAME,',
'    p_id               => :F4000_P112_ID,',
'    p_pid              => :F4000_P112_PID,',
'    p_name             => :F4000_P112_NAME,',
'    p_start_item       => :P116_START_NODE,',
'    p_start_value      => l_start_value,',
'    p_link_option      => :P68_LINK_OPTION,',
'    p_link_page_id     => :P68_LINK_PAGE_ID,',
'    p_link_item        => :P68_LINK_PAGE_ITEM,',
'    p_where            => :F4000_P112_WHERE,',
'    p_order_by         => :F4000_P112_ORDER_BY,',
'    p_page_id          => :F4000_P112_PAGE_ID,',
'    p_page_name        => :F4000_P112_PAGE_NAME,',
'    p_region_name      => :F4000_P112_REGION_NAME,',
'    p_tree_name        => :F4000_P112_TREE_NAME,',
'    p_tree_type        => :F4000_P112_TREE_TYPE,',
'    p_max_levels       => null,',
'    p_tooltip          => l_tooltip,',
'    p_icon             => null);',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P107_TAB_TYPE = ''ALL'' then',
'',
'  return ''&nbsp;:Page ID:Page Name:Items'';',
'',
'else',
'',
'  return ''&nbsp;:Page ID:Page Name:Items:Tabset:Tab Label'';',
'',
'end if;'))
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7235830579380513.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(147901626307825228.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44712020170782472.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7240531196475284.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44712020170782472.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7241000717475287.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44712020170782472.4001)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7240723098475285.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44712020170782472.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(492864202786220575.4001)
,p_branch_action=>'68'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(7240723098475285.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P68_LINK_OPTION'
,p_branch_condition_text=>'NOTHING'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403441149947988629.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P112_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P112_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(7241000717475287.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549112021092562603.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(7240531196475284.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549112383423562604.4001)
,p_event_id=>wwv_flow_api.id(549112021092562603.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(444720815599869068.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create APEX Tree'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_start_value varchar2(4000) := null;',
'  l_start_sql   varchar2(4000) := null;',
'  l_tooltip     varchar2(4000) := null;',
'begin',
'  -- Start With Column Value',
'  if :P116_START_TREE = ''ITEM'' then',
'      l_start_value := '':''||:P116_START_ITEM;',
'  elsif :P116_START_TREE = ''STATIC'' then',
'      l_start_value := :P116_START_STATIC_VALUE;',
'  elsif :P116_START_TREE = ''SQL'' then',
'      l_start_sql   := trim(trailing '';'' from :P116_SQL);',
'      l_start_value := ''(''||l_start_sql||'')'';',
'  end if;',
'  ',
'  -- Tooltip',
'  if :P68_SHOW_TOOLTIP = ''STATIC'' then',
'      l_tooltip := ''''''''||:P68_TOOLTIP_TEXT||'''''''';',
'  elsif :P68_SHOW_TOOLTIP = ''DB'' then',
'      l_tooltip := ''"''||:P68_TOOLTIP_DB||''"'';',
'  else',
'      l_tooltip := ''null'';',
'  end if;',
'',
'  wwv_flow_wizard_api.create_jstree (',
'     p_flow_id                  => :FB_FLOW_ID,',
'     p_page_id                  => :F4000_P112_PAGE_ID,',
'     p_page_name                => :F4000_P112_PAGE_NAME,',
'     p_group_name               => :P112_GROUP_NAME,',
'     p_page_mode                => :P112_PAGE_MODE,',
'     p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'     --                        ',
'     p_tab_set                  => :P4716_TAB_SET,',
'     p_tab_name                 => :P4716_TAB_NAME,',
'     p_tab_text                 => :P4716_TAB_LABEL,',
'     --',
'     p_nav_list_id              => :P4716_NAVLIST_ID,',
'     p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'     p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'     --',
'     p_region_template          => :F4000_P112_REGION_TEMPLATE,',
'     p_region_name              => :F4000_P112_REGION_NAME,',
'     p_breadcrumb_id            => :P112_BREADCRUMB_ID,',
'     p_breadcrumb_name          => :P112_BREADCRUMB_NAME,',
'     p_parent_bc_id             => :P112_BREADCRUMB_PARENT_ID,',
'     --   ',
'     --p_tree_template            => :F4000_P112_TREE_TEMPLATE,',
'     p_tree_query               => wwv_flow_wizard_api.generate_tree_region_query (',
'                                       p_flow_id      => :FB_FLOW_ID,',
'                                       p_owner        => wwv_flow_wizard_api.get_owner(',
'                                                        :fb_flow_id,',
'                                                        :F4000_P112_OWNER),',
'                                       p_table_name   => :P114_TABLE_NAME,',
'                                       p_id           => :F4000_P112_ID,',
'                                       p_pid          => :F4000_P112_PID,',
'                                       p_name         => :F4000_P112_NAME,',
'                                       p_start_item   => :P116_START_NODE,',
'                                       p_start_value  => l_start_value,',
'                                       p_link_option  => :P68_LINK_OPTION,',
'                                       p_link_page_id => :P68_LINK_PAGE_ID,',
'                                       p_link_item    => :P68_LINK_PAGE_ITEM,',
'                                       p_where        => :F4000_P112_WHERE,',
'                                       p_order_by     => :F4000_P112_ORDER_BY,',
'                                       p_tooltip      => l_tooltip,',
'                                       p_icon         => null),',
'     p_tree_button_option       => :P68_TREE_BUTTON_OPTIONS,',
'     p_show_hints               => :P68_SHOW_TOOLTIP,',
'     p_tree_hint_text           => :P68_TOOLTIP_TEXT,',
'     p_tree_click_action        => ''S'',',
'     p_selected_node            => :P68_SELECTED_NODE );',
'       ',
'    :fb_flow_page_id       := :F4000_P112_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(7241000717475287.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549112511100564232.4001)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00286
begin
wwv_flow_api.create_page(
 p_id=>286.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4285618469956601.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Creaci\00F3n de Regi\00F3n de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_breadcrumb_region (',
'    p_flow_id         => :fb_flow_id,',
'    p_page_id         => :fb_flow_page_id,',
'    p_region_type     => :P481_REGION_TYPE,',
'    p_region_template => :P263_REGION_TEMPLATE,',
'    p_menu_template   => replace(:P263_MENU_TEMPLATE,''%null''||''%'',null),',
'    p_menu_template2  => replace(:P481_MENU_TEMPLATE,''%null''||''%'',null),',
'    p_parent_menu     => replace(:P264_PARENT_MENU,''%null''||''%'',null),',
'    p_menu_text       => :P264_MENU_TEXT,',
'    p_display_point   => :P263_DISPLAY_POINT);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_comment=>'Region generated 04-DEC-2002 19:27:47'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16146020057102865.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16141621180084222.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47747823969852084.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4286527624956609.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47747823969852084.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4286825242956609.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47747823969852084.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4295403009980952.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47747823969852084.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(302164623681732478.4001)
,p_branch_action=>'f?p=&APP_ID.:286:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4295729966980953.4001)
,p_branch_action=>'264'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(4295403009980952.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4287218990956613.4001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(4286527624956609.4001)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 04-DEC-2002 19:27:47'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574136706995781523.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4286527624956609.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574136829945781524.4001)
,p_event_id=>wwv_flow_api.id(574136706995781523.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4259203636801340.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumb'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_id number;',
'  l_region_template number;',
' l_preset_template_options varchar2(4000);',
'',
'begin',
'  l_id := wwv_flow_id.next_val;',
'',
'  l_preset_template_options := wwv_flow_wizard_api.get_preset_template_options (replace(v(''P481_MENU_TEMPLATE''),''%null''||''%'',null),''BREADCRUMB'');',
'',
'-- determine region or no region',
'  if :P263_REGION_TEMPLATE = 0 then ',
'      l_region_template := null;',
'  else',
'      l_region_template := :P263_REGION_TEMPLATE ;',
'  end if;',
'',
'  -- create region',
'  wwv_flow_api.create_page_plug (',
'    p_id => l_id,',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :FB_FLOW_PAGE_ID,',
'    p_plug_name => :P263_REGION_TITLE,',
'    p_plug_template => l_region_template,',
'    p_region_template_options     => wwv_flow_wizard_api.get_preset_template_options (l_region_template,''REGION''),                    ',
'    p_parent_plug_id => null,',
'    p_plug_display_sequence => nvl(:P263_SEQUENCE,''1''),',
'    p_plug_display_point =>:P263_DISPLAY_POINT,',
'    p_plug_source => null,',
'    p_plug_source_type => :P481_REGION_TYPE,',
'    p_plug_display_when_condition => null,',
'    p_plug_display_when_cond2 => null,',
'    p_plug_display_condition_type => null,',
'    p_plug_required_role=>null,',
'    p_menu_template_id => replace(v(''P481_MENU_TEMPLATE''),''%null''||''%'',null),',
'    p_component_template_options => l_preset_template_options);',
'',
'  -- handle breadcrumbs with no parent defined',
'  if :P264_PARENT_MENU = ''0'' or :P264_PARENT_MENU = ''%''||''null%'' then',
'     :P264_PARENT_MENU := null;',
'  end if;',
'',
'  -- add breadcrumb entry',
'  if :P264_MENU_TEXT is not null then',
'   begin',
'   insert into WWV_FLOW_MENU_OPTIONS (',
'     parent_id, menu_id, option_sequence, short_name, link, page_id)',
'     values (',
'     :P264_PARENT_MENU, to_number(ltrim(:P481_REGION_TYPE,''M'')),',
'     10, :P264_MENU_TEXT, :P264_MENU_LINK, :FB_FLOW_PAGE_ID);',
'   exception when others then null;',
'   end;',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la ruta de navegaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4286825242956609.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574136961495781525.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La ruta de navegaci\00F3n se ha creado correctamente.')
);
end;
/
prompt --application/pages/page_00288
begin
wwv_flow_api.create_page(
 p_id=>288.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Ruta de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9504015503603271.4001)
,p_plug_name=>unistr('Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Una ruta de navegaci\00F3n es una lista jer\00E1rquica de enlaces que se pueden incluir como regi\00F3n. Cada ruta de navegaci\00F3n es un contenedor para las entradas de ruta de navegaci\00F3n. Cuando haya creado la ruta de navegaci\00F3n, podr\00E1 definir las entradas de rut')
||unistr('a de navegaci\00F3n asociadas a las p\00E1ginas. Cada entrada puede tener tambi\00E9n una entrada principal.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 30-APR-2002 20:45:47'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47724226235616200.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9504309370603273.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47724226235616200.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9504420728603273.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(47724226235616200.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P288_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9505514566603278.4001)
,p_branch_name=>'Go To Page 104'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_MENU_ID:&F4000_P288_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9506127798603280.4001)
,p_name=>'F4000_P288_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(9504015503603271.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 30-APR-2002 20:45:47'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9506412786603284.4001)
,p_name=>'F4000_P288_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(9504015503603271.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 30-APR-2002 20:45:47'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9506717288603286.4001)
,p_name=>'F4000_P288_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(9504015503603271.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Ruta de Navegaci\00F3n')
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca un nombre para esta nueva ruta de navegaci\00F3n. Una vez creada una ruta de navegaci\00F3n con nombre, puede agregar entradas de ruta de navegaci\00F3n. El nombre de la ruta de navegaci\00F3n proporciona un modo de asignar un nombre a una recopilaci\00F3n de')
||unistr(' entradas de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 20:45:47'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(60493229398757215.4001)
,p_validation_name=>'menu name required'
,p_validation_sequence=>10
,p_validation=>'F4000_P288_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de men\00FA.')
,p_when_button_pressed=>wwv_flow_api.id(9504420728603273.4001)
,p_associated_item=>wwv_flow_api.id(9506717288603286.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574039705326616928.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(9504309370603273.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574039850125616929.4001)
,p_event_id=>wwv_flow_api.id(574039705326616928.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9507408747603290.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_MENUS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MENUS'
,p_attribute_03=>'F4000_P288_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'F4000_P288_ID'
,p_attribute_11=>'I'
,p_attribute_12=>'Y'
,p_process_error_message=>unistr('Error al procesar la acci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La ruta de navegaci\00F3n se ha creado.')
,p_process_comment=>'Generated 30-APR-2002 20:45:47'
);
end;
/
prompt --application/pages/page_00289
begin
wwv_flow_api.create_page(
 p_id=>289.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Plantilla de Ruta de Navegaci\00F3n')
,p_step_title=>unistr('Editar Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_menu_templates t, wwv_flow_themes th',
'where t.id = :F4000_P289_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_bread.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9800924894050598.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'ID'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No se ha encontrado ninguna plantilla.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9811230937057829.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9872218342170050.4001)
,p_plug_name=>'Tipo de Plantilla'
,p_region_name=>'START'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9873515970171128.4001)
,p_plug_name=>'Atributos de Enlace'
,p_region_name=>'AT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No se ha encontrado ninguna plantilla.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9884830382210051.4001)
,p_plug_name=>unistr('Plantilla de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Una plantilla de ruta de navegaci\00F3n controla la visualizaci\00F3n de los tipos de regi\00F3n de ruta de navegaci\00F3n. La plantilla de ruta de navegaci\00F3n se selecciona cuando se crea una regi\00F3n.</p>')
,p_plug_query_no_data_found=>'No se ha encontrado ninguna plantilla.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11774220719001100.4001)
,p_plug_name=>unistr('Definici\00F3n')
,p_region_name=>'OPT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14473614253795731.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33345632077863019.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P289_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_02=>'NAME'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'F4000_P289_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46191504863907188.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92865607458523737.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117333521045424865.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166122506409151503.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_name=>'SS'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.breadcrumb_template_sub_str (',
'    p_template_id   => :F4000_P289_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n se utilizan en las subplantillas para hacer referencia a los valores del componente. Este informe detalla el uso de la cadena de sustituci\00F3n para esta plantilla.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617475406214054171.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_MENU_TEMPLATES',
'where id = :F4000_P289_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P289_ID,',
'      p_component_type => ''Breadcrumb Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(631088939555287098.4001)
,p_name=>'Opciones de Plantilla'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and breadcrumb_template_id = :F4000_P289_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P289_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(631089641170287108.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(631089211872287108.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688528751604163271.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(631089303863287108.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688528811470163275.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688528909213163275.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(688529668293178610.4001)
,p_name=>'Opciones de Plantilla Global'
,p_region_name=>'GLOBAL_TEMPLATE_OPTIONS'
,p_parent_plug_id=>wwv_flow_api.id(631088939555287098.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id g_id, ',
'  o.display_name g_display_name,',
'  o.display_sequence g_display_sequence, ',
'  o.css_classes g_css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) g_group_name,',
'  o.is_advanced g_is_advanced',
'  from wwv_flow_template_options o,',
'       wwv_flow_menu_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and o.virtual_template_id is NULL',
'   and o.template_types = ''BREADCRUMB''',
'   and o.security_group_id  = :WORKSPACE_ID',
'   and t.theme_id = o.theme_id',
'   and t.id = :F4000_P289_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P289_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887630620908273341.4001)
,p_query_column_id=>1
,p_column_alias=>'G_ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887630743838273342.4001)
,p_query_column_id=>2
,p_column_alias=>'G_DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887630898884273343.4001)
,p_query_column_id=>3
,p_column_alias=>'G_DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887630962849273344.4001)
,p_query_column_id=>4
,p_column_alias=>'G_CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887631029813273345.4001)
,p_query_column_id=>5
,p_column_alias=>'G_GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887631136103273346.4001)
,p_query_column_id=>6
,p_column_alias=>'G_IS_ADVANCED'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932807070079193714.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P289_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P289_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13341913412840293.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33345632077863019.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P289_ID.,&FLOW_PAGE_ID.,MENU'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates',
' where reference_id = :F4000_P289_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13337407740829146.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33345632077863019.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates',
' where id = :F4000_P289_ID',
'   and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(631089777837287108.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(631088939555287098.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_BC_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P289_THEME.,&F4000_P289_ID.,BREADCRUMB'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9801204174050599.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9801517626050599.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:503:&SESSION.::&DEBUG.::P503_ID:&F4000_P289_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P289_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9801410558050599.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P289_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9801317332050599.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P289_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(285878231222665018.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_button_name=>'GET_PREVIOUS_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(285878100347665018.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_button_name=>'GET_NEXT_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27993023901805561.4001)
,p_branch_action=>'f?p=&FLOW_ID.:289:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F_4000_P289_STAY_ON_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13376225256907546.4001)
,p_branch_action=>'289'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(13337407740829146.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9802405431050605.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(285885622820665059.4001)
,p_branch_action=>'f?p=&FLOW_ID.:289:&SESSION.::&DEBUG.::F4000_P289_ID:&P289_ID_PREV.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(285878231222665018.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(285885232263665057.4001)
,p_branch_action=>'f?p=&FLOW_ID.:289:&SESSION.::&DEBUG.::F4000_P289_ID:&P289_ID_NEXT.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(285878100347665018.4001)
,p_branch_sequence=>50
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9803002371050608.4001)
,p_name=>'F4000_P289_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(117333521045424865.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9803615747050612.4001)
,p_name=>'F4000_P289_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(9800924894050598.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifica un nombre para esta plantilla. <p />',
'Utilice la casilla de control <strong>Se Puede Convertir</strong> para indicar que la plantilla contiene cadenas de texto que hay que convertir.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9803912448050613.4001)
,p_name=>'F4000_P289_BEFORE_FIRST'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(11774220719001100.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Antes de la Primera'
,p_source=>'BEFORE_FIRST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Define texto que aparece antes de la primera entrada de ruta de navegaci\00F3n. Puede utilizar la cadena de sustituci\00F3n #COMPONENT_CSS_CLASSES# para aplicar una clase CSS a la plantilla de ruta de navegaci\00F3n. Las clases CSS de componente se definen en la')
||unistr(' p\00E1gina Edici\00F3n de Regi\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9804230611050615.4001)
,p_name=>'F4000_P289_CURRENT_PAGE_OPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(11774220719001100.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Entrada de Ruta de Navegaci\00F3n de P\00E1gina Actual (Usar #LINK#, #NAME#, #NAME_ESC_SC#, #LONG_NAME#)')
,p_source=>'CURRENT_PAGE_OPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Utilice este atributo para definir el aspecto de una entrada de ruta de navegaci\00F3n que se corresponde con la p\00E1gina actual. Utilice las siguientes cadenas de sustituci\00F3n:</div><div class="htmldbInfoBodyP"><table border=1>')
||unistr('<tr><td>#NAME#</td><td>Abreviatura de la entrada de ruta de navegaci\00F3n</td></tr><tr><td>#LINK#</td><td>Destino de anclaje de la ruta de navegaci\00F3n</td></tr><tr><td>#LONG_NAME#</td><td>Nombre completo de la entrada de ruta de navegaci\00F3n</td></tr></tab')
||'le></div><div class="htmldbInfoBodyP">Por ejemplo:</div><pre>&amp;lt;li&amp;gt;&amp;lt;a href="#LINK#"&amp;gt;#NAME#&amp;lt;/a&amp;gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9804530828050617.4001)
,p_name=>'F4000_P289_NON_CURRENT_PAGE_OPTION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(11774220719001100.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Entrada de Ruta de Navegaci\00F3n de P\00E1gina no Actual (Usar #LINK#, #NAME#, #NAME_ESC_SC#, #LONG_NAME#)')
,p_source=>'NON_CURRENT_PAGE_OPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice este atributo para definir el aspecto de una entrada de ruta de navegaci\00F3n que no se corresponde con la p\00E1gina actual. Utilice las siguientes cadenas de sustituci\00F3n:'),
'<div class="htmldbInfoBodyP">',
'<table border=1>',
'',
unistr('<tr><td>#NAME#</td><td>Abreviatura de la entrada de ruta de navegaci\00F3n</td></tr>'),
'',
unistr('<tr><td>#LINK#</td><td>Destino de anclaje de la entrada de ruta de navegaci\00F3n</td></tr>'),
'',
unistr('<tr><td>#LONG_NAME#</td><td>Nombre completo de la entrada de ruta de navegaci\00F3n</td></tr>'),
'',
'</table>',
'</div>',
'</div><div class="htmldbInfoBodyP">Por ejemplo:</div>',
'',
'<pre>',
'&amp;lt;li&amp;gt;&amp;lt;a href="#LINK#"&amp;gt;#NAME#&amp;lt;/a&amp;gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9804825163050618.4001)
,p_name=>'F4000_P289_MENU_LINK_ATTRIBUTES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(9873515970171128.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Atributos de Enlace de Ruta de Navegaci\00F3n')
,p_source=>'MENU_LINK_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Para mostrar el hiperenlace de la entrada de ruta de navegaci\00F3n, agregue el siguiente texto a la etiqueta de anclaje HTML en la posici\00F3n de "X":</div>'),
'',
'<pre>',
'&amp;lt;A HREF="..." X&amp;gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9805114296050619.4001)
,p_name=>'F4000_P289_BETWEEN_LEVELS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(11774220719001100.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Entre Niveles'
,p_source=>'BETWEEN_LEVELS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Define el texto que aparece entre los niveles de entradas de ruta de navegaci\00F3n. Por ejemplo, si las rutas de navegaci\00F3n tienen tres niveles, este texto aparecer\00E1 en lugar de la &quot;X&quot; del siguiente ejemplo:<p />'),
'',
'<code>main X cars X porsche X 911</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9805422925050624.4001)
,p_name=>'F4000_P289_AFTER_LAST'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(11774220719001100.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Despu\00E9s de la \00DAltima')
,p_source=>'AFTER_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Define el texto que aparece despu\00E9s de las \00FAltimas entradas de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9805713626050625.4001)
,p_name=>'F4000_P289_MAX_LEVELS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(11774220719001100.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'99'
,p_prompt=>unistr('Niveles M\00E1ximos')
,p_source=>'MAX_LEVELS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Utilice este atributo para especificar el n\00FAmero de niveles que aparecen al visualizar rutas de navegaci\00F3n en un estilo de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9806029721050627.4001)
,p_name=>'F4000_P289_START_WITH_NODE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(9872218342170050.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'PARENT_TO_LEAF'
,p_prompt=>'Empezar por'
,p_source=>'START_WITH_NODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU_START_WITH'
,p_lov=>'.'||wwv_flow_api.id(84876111826444446.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un estilo de plantilla de ruta de navegaci\00F3n. Las opciones disponibles son:'),
'<ul>',
unistr('<li><strong>Ruta de Navegaci\00F3n Secundaria</strong> muestra todas las entradas de ruta de navegaci\00F3n que son secundarias de la ruta de navegaci\00F3n principal de la p\00E1gina actual (es decir, peers de la ruta de navegaci\00F3n actual).</li>'),
unistr('<li><strong>Ruta de Navegaci\00F3n Actual</strong> muestra todas las entradas de ruta de navegaci\00F3n en secuencia con un principal com\00FAn.</li>'),
unistr('<li><strong>Ruta de Navegaci\00F3n Principal</strong> muestra todas las entradas de ruta de navegaci\00F3n para la ruta de navegaci\00F3n principal de la p\00E1gina actual (es decir, un nivel superior a la ruta de navegaci\00F3n actual).</li>'),
unistr('<li><strong>Principal a Hoja (estilo de ruta de navegaci\00F3n)</strong> muestra la entrada de ruta de navegaci\00F3n de la p\00E1gina actual, con el principal a la izquierda y as\00ED sucesivamente hasta alcanzar el nodo ra\00EDz.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13348005033856166.4001)
,p_name=>'F4000_P289_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33345632077863019.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_MENU_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') n, id r',
'from   wwv_flow_menu_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Seleccione una plantilla existente en esta aplicaci\00F3n u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>'),
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>',
' '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14476901745801560.4001)
,p_name=>'F4000_P289_TEMPLATE_COMMENT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(14473614253795731.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'TEMPLATE_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24155801481555004.4001)
,p_name=>'P289_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(9800924894050598.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27991703815799820.4001)
,p_name=>'F_4000_P289_STAY_ON_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(9884830382210051.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35475318048709434.4001)
,p_name=>'F4000_P289_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33345632077863019.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_menu_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P289_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43943313617260830.4001)
,p_name=>'P289_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(9800924894050598.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tema al que est\00E1 asociada esta plantilla. Un tema es un grupo de plantillas que proporcionan el dise\00F1o y el estilo a una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43994026870321361.4001)
,p_name=>'P289_TEMPLATE_CLASS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(9800924894050598.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43945521366272493.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(285883021673665046.4001)
,p_name=>'P289_ID_NEXT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(117333521045424865.4001)
,p_prompt=>'P289_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(285883432384665047.4001)
,p_name=>'P289_ID_PREV'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(117333521045424865.4001)
,p_prompt=>'P289_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(285883804344665048.4001)
,p_name=>'P289_ID_COUNT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(9811230937057829.4001)
,p_prompt=>unistr('Plantilla de Ruta de Navegaci\00F3n: ')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifica la plantilla de ruta de navegaci\00F3n')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631089939791287110.4001)
,p_name=>'P289_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(631088939555287098.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select o.display_name as d,',
'         o.css_classes as r,',
'         null default_template_options,',
'         null,',
'         o.help_text,',
'         (select display_name ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text          ',
'    from wwv_flow_template_options o, wwv_flow_menu_templates t',
'   where o.flow_id = :FB_FLOW_ID',
'     and o.template_types = ''BREADCRUMB''',
'     and (o.breadcrumb_template_id = :F4000_P289_ID or o.breadcrumb_template_id is NULL)',
'     and t.theme_id = o.theme_id',
'     and t.id = :F4000_P289_ID',
'  order by advanced_group nulls first, group_name nulls first, display_name'))
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631090149605287111.4001)
,p_name=>'P289_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>235
,p_item_plug_id=>wwv_flow_api.id(631088939555287098.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_menu_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.breadcrumb_template_id',
'   and breadcrumb_template_id = :F4000_P289_ID',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1007564516671031505.4001)
,p_name=>'F4000_P289_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(9800924894050598.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449463121932055534.4001)
,p_name=>'P289_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>245
,p_item_plug_id=>wwv_flow_api.id(631088939555287098.4001)
,p_source=>'F4000_P289_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104396921708021397.4001)
,p_name=>'P289_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(9800924894050598.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104397276038036503.4001)
,p_computation_sequence=>10
,p_computation_item=>'P289_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_menu_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P289_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35486527081735646.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P289_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(9965629014301830.4001)
,p_validation_name=>'F4000_P289_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P289_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(9803615747050612.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 30-APR-2002 22:42'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13353812785867719.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P289_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(13337407740829146.4001)
,p_associated_item=>wwv_flow_api.id(13348005033856166.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13359330672874601.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P289_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(13337407740829146.4001)
,p_associated_item=>wwv_flow_api.id(13348005033856166.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(378312204028510813.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P289_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(378312530811510813.4001)
,p_event_id=>wwv_flow_api.id(378312204028510813.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(285878231222665018.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(378312611647513039.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P289_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(378312909800513040.4001)
,p_event_id=>wwv_flow_api.id(378312611647513039.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(285878100347665018.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(631099134753609773.4001)
,p_name=>'refresh template options'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(631089777837287108.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(631099449911609781.4001)
,p_event_id=>wwv_flow_api.id(631099134753609773.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(631088939555287098.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:289:&SESSION.::&DEBUG.'');',
'}, 0);',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(631099700676658653.4001)
,p_name=>'refresh template options after refresh'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(631088939555287098.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(631100005555658655.4001)
,p_event_id=>wwv_flow_api.id(631099700676658653.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(631088939555287098.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:289:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9806421442050629.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_MENU_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
,p_process_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(285884822062665055.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P289_ID_NEXT'
,p_attribute_10=>'P289_ID_PREV'
,p_attribute_13=>'P289_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13366201774888006.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_menu_template (',
'    p_master_template_id         => :F4000_P289_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P289_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(13337407740829146.4001)
,p_process_when=>'F4000_P289_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9806725148050630.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_MENU_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13372203702902353.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_menu_reference_id (:F4000_P289_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(9801410558050599.4001)
,p_process_when=>'F4000_P289_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35491510691743218.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_menu_template (',
'    p_master_template_id         => :F4000_P289_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P289_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(9801410558050599.4001)
,p_process_when=>':F4000_P289_REFERENCE_ID is not null and :F4000_P289_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1449463211432055535.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_bc_tmplopt_presets(:F4000_P289_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P289_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P289_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00291
begin
wwv_flow_api.create_page(
 p_id=>291.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Bloqueos de P\00E1gina')
,p_step_title=>unistr('Bloqueos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213229021839834158)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_locks.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(37419214876657905.4001)
,p_name=>'Bloqueos por Desarrollador'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select locked_by locked_by,',
'       count(*) cnt',
'from wwv_flow_lock_page l, wwv_flow_steps p',
'where l.flow_id = :fb_flow_id and',
'      p.flow_id = :fb_flow_id and',
'      l.object_id = p.id',
'group by locked_by',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196323112284998552.4001)
,p_query_column_id=>1
,p_column_alias=>'LOCKED_BY'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.:291,RIR:IR_LOCKED_BY:#LOCKED_BY#'
,p_column_linktext=>'#LOCKED_BY# #CNT#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196323206311998576.4001)
,p_query_column_id=>2
,p_column_alias=>'CNT'
,p_column_display_sequence=>2
,p_column_heading=>'Cnt'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37437117703762743.4001)
,p_plug_name=>unistr('Bloqueos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>11
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para bloquear una p\00E1gina, active la casilla de control correspondiente a la p\00E1gina y haga clic en <strong>Bloquear Selecci\00F3n</strong>.</p>'),
unistr('<p>Para desbloquear una p\00E1gina, active la casilla de control correspondiente a la p\00E1gina y haga clic en <strong>Desbloquear Selecci\00F3n</strong>.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195810813298176622.4001)
,p_plug_name=>unistr('P\00E1ginas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  apex_item.checkbox(1, wwv_flow_escape.html(p.id), null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''), wwv_flow_lang.system_message(''PAGE_LABEL'',wwv_flow_escape.html(p.name))) checkbox,',
'  p.id page_id,',
'  p.name, ',
'  nvl(l.locked_by,'' '') locked_by,',
'  l.locked_on,',
'  nvl(l.lock_comment,'' '') lock_comment,',
'  p.id object_id,',
'  decode(l.locked_by,null,',
'    ''<span class="a-Icon icon-unlock"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_UNLOCKED'')||''</span>'',',
'    ''<span class="a-Icon icon-lock"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_LOCKED'')||''</span>'' ) status,',
'   last_updated_on page_updated,',
'    l.id lock_id,',
'    p.last_updated_by, ',
'    m.v,',
'    p.flow_id',
'from wwv_flow_lock_page l,',
'     wwv_flow_steps p, (select wwv_flow_lang.system_message(''F4000.P291.VIEW_LOCK'') v from dual) m',
'where p.flow_id = :fb_flow_id and',
'      p.flow_id = l.flow_id(+) and',
'      l.object_id(+) = p.id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(195810900170176622.4001)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195829328011271089.4001)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>1
,p_column_identifier=>'K'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811724834176693.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>2
,p_column_identifier=>'G'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_rpt_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''PAGE_LOCKED'') x from dual ',
'union all',
'select wwv_flow_lang.system_message(''PAGE_UNLOCKED'') x from dual'))
,p_rpt_show_filter_lov=>'C'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811126873176687.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811228294176688.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811309285176689.4001)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Bloqueado por'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811417567176690.4001)
,p_db_column_name=>'LOCKED_ON'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Fecha de Bloqueo'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811821396176694.4001)
,p_db_column_name=>'PAGE_UPDATED'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('P\00E1gina Actualizada')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811522034176691.4001)
,p_db_column_name=>'LOCK_COMMENT'
,p_display_order=>8
,p_column_identifier=>'E'
,p_column_label=>'Comentario de Bloqueo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811623509176692.4001)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195811923089176695.4001)
,p_db_column_name=>'LOCK_ID'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Ver Bloqueo'
,p_column_link=>'f?p=&APP_ID.:337:&SESSION.::&DEBUG.:337:P337_ID,FB_FLOW_PAGE_ID:#LOCK_ID#,#OBJECT_ID#'
,p_column_linktext=>'<span class="a-Icon icon-search"></span><span class="u-VisuallyHidden">#V#</span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(195812017472176696.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'LAST_UPDATED_BY'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1059808080930457617.4001)
,p_db_column_name=>'V'
,p_display_order=>21
,p_column_identifier=>'L'
,p_column_label=>'V'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176250977948916909.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>31
,p_column_identifier=>'M'
,p_column_label=>'Identificador de Flujo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195838228460403664.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(34740016606195595.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_api.id(12511519296310366)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34595125536874843.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(195810813298176622.4001)
,p_button_name=>'UNLOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Desbloquear Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34544605404490574.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(195810813298176622.4001)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Bloquear Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37880920248115204.4001)
,p_branch_name=>'Go To Page 444'
,p_branch_action=>'f?p=&APP_ID.:444:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34544605404490574.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34534825970425228.4001)
,p_branch_action=>'f?p=&FLOW_ID.:291:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(37898729046202847.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'291'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51831500213009272.4001)
,p_validation_name=>'locking pages requires page selection'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos una p\00E1gina que bloquear.')
,p_when_button_pressed=>wwv_flow_api.id(34544605404490574.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1059808123705457618.4001)
,p_validation_name=>'unlocking pages requires page selection'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos una p\00E1gina que desbloquear.')
,p_when_button_pressed=>wwv_flow_api.id(34595125536874843.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(113449032017001828.4001)
,p_validation_name=>'dont allow locking already locked pages'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c int := 0;',
'  l int := 0;',
'begin',
'FOR I in 1..APEX_APPLICATION.G_F01.COUNT LOOP',
'    select count(*) into l ',
'      from WWV_FLOW_LOCK_PAGE ',
'     where flow_id = :fb_flow_id and',
'           object_id = apex_application.g_f01(i) and',
'           locked_by is not null;',
'   c := c + l;',
'END LOOP;',
'if c = 0 then return true; else return false; end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede bloquear p\00E1ginas que ya se hayan bloqueado.')
,p_when_button_pressed=>wwv_flow_api.id(34544605404490574.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1059808256229457619.4001)
,p_validation_name=>'dont allow unlocking already unlocked pages'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c int := 0;',
'  l int := 0;',
'begin',
'FOR I in 1..APEX_APPLICATION.G_F01.COUNT LOOP',
'    select count(*) into l ',
'      from WWV_FLOW_LOCK_PAGE ',
'     where flow_id = :fb_flow_id and',
'           object_id = apex_application.g_f01(i);',
'   c := c + l;',
'END LOOP;',
'if c = 0 then return false; else return true; end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede desbloquear p\00E1ginas que no est\00E9n bloqueadas.')
,p_validation_condition=>'APEX_APPLICATION.G_F01.COUNT <> 0'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(34595125536874843.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157779028285618635.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(195810813298176622.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157779116700618636.4001)
,p_event_id=>wwv_flow_api.id(1157779028285618635.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34565314595606825.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c int;',
'begin',
':P444_LOCK_COMMENT := null;',
':P444_LOCK_PAGES := null;',
'FOR I in 1..APEX_APPLICATION.G_F01.COUNT LOOP',
'    select count(*) a into c ',
'      from WWV_FLOW_LOCK_PAGE ',
'     where flow_id = :fb_flow_id and',
'           object_id = apex_application.g_f01(i) and',
'           locked_by is not null;',
'    if c = 0 then',
'       :P444_LOCK_PAGES := :P444_LOCK_PAGES||apex_application.g_f01(i)||'':'';',
'    end if;',
'END LOOP;',
':P444_LOCK_PAGES := rtrim(:P444_LOCK_PAGES,'':'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido bloquear las p\00E1ginas.')
,p_process_when_button_id=>wwv_flow_api.id(34544605404490574.4001)
,p_process_success_message=>unistr('P\00E1ginas Bloqueadas')
,p_process_comment=>'identify the list of pages to be locked.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34603328053932355.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlock page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FOR I in 1..APEX_APPLICATION.G_F01.COUNT LOOP',
'    delete from WWV_FLOW_LOCK_PAGE ',
'     where object_id = apex_application.g_f01(i) and',
'           flow_id = :fb_flow_id and',
'           locked_by = :app_user;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido desbloquear las p\00E1ginas.')
,p_process_when_button_id=>wwv_flow_api.id(34595125536874843.4001)
,p_process_success_message=>unistr('P\00E1ginas Desbloqueadas')
);
end;
/
prompt --application/pages/page_00298
begin
wwv_flow_api.create_page(
 p_id=>298.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de P\00E1gina')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(49253017607109811.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||NAME n, id',
'  from WWV_FLOW_STEPS p',
' where p.flow_id       = :fb_flow_id',
'   and p.step_template = :p298_id',
'union all',
'select wwv_flow_lang.system_message(''DEFAULT_TEMPLATE'')||'': ''||name n, null id',
'  from WWV_FLOW_TEMPLATES pt,',
'       wwv_flow_themes t',
' where pt.id      = :p298_id',
'   and t.flow_id  = pt.flow_id',
'   and t.theme_id = pt.theme_id',
'  and t.default_page_template = :p298_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(49278928036188445.4001)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#N#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203841011183167634.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49253503210109822.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200308903627839307.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747140365511138158.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49254328662109825.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200308903627839307.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49254710720109828.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200308903627839307.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49258510761109860.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49255114396109830.4001)
,p_name=>'P298_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(49253503210109822.4001)
,p_prompt=>unistr('Plantilla de P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST PAGETEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = (case when :P4301_PAGE_MODE = ''NORMAL'' then ''N'' else ''Y'' end)',
'order  by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la plantilla que se va a suprimir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49255816003109839.4001)
,p_name=>'P298_THEME_ID'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(49253503210109822.4001)
,p_prompt=>'Tema:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p298_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49256510133109842.4001)
,p_name=>'P298_LIST_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(49253503210109822.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_class_id',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p298_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(41972431732112027.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49257715041109851.4001)
,p_validation_name=>'P298_ID'
,p_validation_sequence=>10
,p_validation=>'P298_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(49255114396109830.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49257311083109847.4001)
,p_validation_name=>'Prevent deletion of used templates'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_STEPS',
' where flow_id       = :fb_flow_id',
'   and STEP_TEMPLATE = :p298_id',
' union all',
'select 1',
'  from wwv_flow_themes',
' where flow_id = :fb_flow_id',
'   and default_page_template = :p298_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('No puede suprimir plantillas definidas como por defecto en el tema de la aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49258108370109855.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>'delete from WWV_FLOW_TEMPLATES where flow_id = :fb_flow_id and id = :p298_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(49254710720109828.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00299
begin
wwv_flow_api.create_page(
 p_id=>299.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Bloquear Administraci\00F3n')
,p_step_title=>unistr('Bloquear Administraci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213229021839834158)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_locks.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22395215733416572.4001)
,p_plug_name=>unistr('P\00E1ginas Bloqueadas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  HTMLDB_ITEM.CHECKBOX(1,wwv_flow_escape.html(p.id),null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''), wwv_flow_lang.system_message(''PAGE_LABEL'',wwv_flow_escape.html(p.name))) cb,',
'  p.id page_id,',
'  p.name,',
'  l.locked_by,',
'  l.locked_on,',
'  nvl(l.lock_comment,'' '') lock_comment,',
'  ''<span class="a-Icon icon-lock"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_LOCKED'')||''</span>''  status,',
'    last_updated_on page_updated,',
'    l.id lock_id, ',
'  m.e',
'from wwv_flow_lock_page l,',
'     wwv_flow_steps p, (select wwv_flow_lang.system_message(''EDIT'') e from dual) m',
'where p.flow_id = :fb_flow_id and',
'      p.flow_id = l.flow_id(+) and',
'      l.object_id(+) = p.id and',
'      l.locked_by is not null and',
'      p.security_group_id = :flow_security_group_id  '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(22395308619416572.4001)
,p_name=>'Locked Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22395515809416594.4001)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22396318708416705.4001)
,p_db_column_name=>'LOCK_ID'
,p_display_order=>2
,p_column_identifier=>'I'
,p_column_label=>'Editar'
,p_column_link=>'f?p=&APP_ID.:330:&SESSION.::&DEBUG.::P330_ID:#LOCK_ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">#E#</span>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22396111171416704.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_lov=>'select wwv_flow_lang.system_message(''PAGE_LOCKED'') x from dual'
,p_rpt_show_filter_lov=>'C'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22395601792416702.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22395724374416703.4001)
,p_db_column_name=>'NAME'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22395830635416703.4001)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Bloqueado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22395931257416703.4001)
,p_db_column_name=>'LOCKED_ON'
,p_display_order=>7
,p_column_identifier=>'E'
,p_column_label=>'Fecha de Bloqueo'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22396222005416704.4001)
,p_db_column_name=>'PAGE_UPDATED'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('P\00E1gina Actualizada')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22396014516416704.4001)
,p_db_column_name=>'LOCK_COMMENT'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Comentario de Bloqueo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1059808798325457624.4001)
,p_db_column_name=>'E'
,p_display_order=>19
,p_column_identifier=>'J'
,p_column_label=>'E'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34915019176525555.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(34740016606195595.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35076800837472468.4001)
,p_plug_name=>unistr('Bloquear Administraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>31
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Esta p\00E1gina permite a los administradores de espacio de trabajo desbloquear las p\00E1ginas bloqueadas por cualquier desarrollador de espacio de trabajo. Utilice esta p\00E1gina para editar el propietario del bloqueo y bloquear los atributos de comentario. P')
||unistr('ara gestionar un bloqueo en una p\00E1gina espec\00EDfica, haga clic en el icono <strong>Editar</strong>.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34926609836598547.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22395215733416572.4001)
,p_button_name=>'UNLOCKPAGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Desbloquear P\00E1ginas')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34927413645599678.4001)
,p_branch_action=>'f?p=&FLOW_ID.:299:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157779216107618637.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(22395215733416572.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157779371601618638.4001)
,p_event_id=>wwv_flow_api.id(1157779216107618637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34937122396659003.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlock pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FOR I in 1..apex_application.g_f01.count LOOP',
'    delete from WWV_FLOW_LOCK_PAGE ',
'     where object_id = to_number(apex_application.g_f01(i)) and',
'           flow_id = :fb_flow_id;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido desbloquear las p\00E1ginas')
,p_process_when_button_id=>wwv_flow_api.id(34926609836598547.4001)
,p_process_success_message=>unistr('P\00E1ginas desbloqueadas.')
,p_security_scheme=>wwv_flow_api.id(12511519296310366)
);
end;
/
prompt --application/pages/page_00301
begin
wwv_flow_api.create_page(
 p_id=>301.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: P\00E1gina a Copiar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'function f_NewPageName(){  ',
'var oldPage = html_GetElement("P301_COPY_FROM_S").value;',
'var newPageName = oldPage.substring(oldPage.indexOf('':'')+1,oldPage.length);',
'html_GetElement("P301_COPY_TO_PAGE_NAME").value = newPageName;',
'}',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18344031106016009.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 06-JAN-2003 14:58:56'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18569618340857662.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18564606387816293.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44111408367534414.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18344926854016042.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44111408367534414.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18345210914016042.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44111408367534414.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200994430208628102.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44111408367534414.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18346104732016063.4001)
,p_branch_name=>'Go To Page 305'
,p_branch_action=>'305'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(18345210914016042.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 06-JAN-2003 14:58:56'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(211843308225373247.4001)
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P301_BREADCRUMB_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18344702485016034.4001)
,p_name=>'P301_COPY_FROM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>'Copy From Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 06-JAN-2003 14:58:56'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18354700370037123.4001)
,p_name=>'P301_COPY_TO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>unistr('Nuevo N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nuevo n\00FAmero de p\00E1gina.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18357026353120297.4001)
,p_name=>'P301_COPY_TO_PAGE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>unistr('Nuevo Nombre de P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nuevo nombre de p\00E1gina.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18557102746777400.4001)
,p_name=>'P301_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200848014690872436.4001)
,p_name=>'P301_CP_FROM_APP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211801924399895365.4001)
,p_name=>'P301_BREADCRUMB_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211822711548289046.4001)
,p_name=>'P301_BREADCRUMB_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P301_COPY_TO_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211836506231353711.4001)
,p_name=>'P301_PARENT_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P301_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P301_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P301_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Este elemento muestra si se ha seleccionado una entrada principal para esta entrada de ruta de navegaci\00F3n y cu\00E1l se ha seleccionado.')
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211858203517457010.4001)
,p_name=>'P301_COPY_FROM_S'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>unistr('Copiar de P\00E1gina')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'':''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID ',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name) d, id||'':''||wwv_flow_escape.html(name) r',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="f_NewPageName();"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina que desea copiar.')
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(341747021469735039.4001)
,p_name=>'P301_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_prompt=>'Interfaz de Usuario'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by display_seq'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'USER INTERFACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.display_name,',
'       i.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
' order by 1'))
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select count(*)',
'    from wwv_flow_user_interfaces',
'   where flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID ) > 1'))
,p_display_when2=>'SQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la interfaz de usuario para la p\00E1gina.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345026603547423914.4001)
,p_name=>'P301_UI_TYPE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(513679589099698847.4001)
,p_name=>'P301_DISPLAY_COPY_PUB_RPT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(617278254247216833.4001)
,p_name=>'P301_COPY_PUBLIC_REPORTS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Copiar Informes P\00FAblicos')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Todos los informes por defecto se copian autom\00E1ticamente sin necesidad de especificarlo; si desea copiar informes p\00FAblicos, deber\00E1 especificarlo en la p\00E1gina. Estas son las opciones disponibles:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> para copiar informes p\00FAblicos en la p\00E1gina.</li>'),
unistr('<li><strong>Desactivado</strong> para no copiar informes p\00FAblicos en la p\00E1gina.</li>'),
'</ul>',
'<p />',
unistr('Los informes p\00FAblicos son la configuraci\00F3n de informes compartidos p\00FAblicos que han guardado los usuarios a partir del informe interactivo o la cuadr\00EDcula interactiva.')))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1249072009558304099.4001)
,p_name=>'P301_NAVIGATION_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(18344031106016009.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(211864515684488960.4001)
,p_computation_sequence=>10
,p_computation_item=>'P301_COPY_FROM'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(:P301_COPY_FROM_S,1,instr(:P301_COPY_FROM_S,'':'',1)-1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(881355945277941726.4001)
,p_computation_sequence=>20
,p_computation_item=>'P301_USER_INTERFACE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( ',
'    select t.display_name,',
'         i.id',
'    from wwv_flow_user_interfaces i,',
'         wwv_flow_ui_types_dev t',
'   where i.flow_id           = :FB_FLOW_ID',
'     and i.security_group_id = :WORKSPACE_ID',
'     and t.id                = i.ui_type_id',
'   order by 1',
') loop',
'    return c1.id;',
'end loop;'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select count(*)',
'    from wwv_flow_user_interfaces',
'   where flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID ) = 1'))
,p_compute_when_text=>'SQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(340636715957965845.4001)
,p_computation_sequence=>30
,p_computation_item=>'P301_UI_TYPE_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ui_type_id',
'  from wwv_flow_user_interfaces',
'where flow_id           = :FB_FLOW_ID',
'  and id                = :P301_USER_INTERFACE_ID',
'  and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1249072374734307388.4001)
,p_computation_sequence=>40
,p_computation_item=>'P301_NAVIGATION_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where x.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
'   and x.flow_id           = i.flow_id',
'   and i.id                = :P301_USER_INTERFACE_ID',
'   and i.theme_id          = x.theme_id',
' order by 1'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(345532415865773299.4001)
,p_validation_name=>'Page Contains Interactive Report'
,p_validation_sequence=>5
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_user_interface_dev.supports_feature ( ',
'       p_user_interface_id => :P301_USER_INTERFACE_ID,',
'       p_name              => ''INTERACTIVE_REPORT'' )',
' then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Una p\00E1gina que contiene un informe interactivo s\00F3lo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P301_COPY_FROM is not null and wwv_flow_wizard_api.ir_report_exists( ',
'                                    p_flow_id => :FB_FLOW_ID, ',
'                                    p_page_id => :P301_COPY_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(341747021469735039.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(348223923678037242.4001)
,p_validation_name=>'Page Contains Tree'
,p_validation_sequence=>8
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if  wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P301_USER_INTERFACE_ID,',
'        p_name              => ''JSTREE'' )',
' then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Una p\00E1gina que contiene un \00E1rbol solo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P301_COPY_FROM is not null and wwv_flow_wizard_api.jstree_exists( ',
'                                   p_flow_id => :FB_FLOW_ID, ',
'                                   p_page_id => :P301_COPY_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18357930508121563.4001)
,p_validation_name=>'P301_COPY_FROM_S Not Null'
,p_validation_sequence=>10
,p_validation=>'P301_COPY_FROM_S'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(211858203517457010.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-JAN-2003 15:16'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18358100653121570.4001)
,p_validation_name=>'P301_COPY_TO Not Null'
,p_validation_sequence=>20
,p_validation=>'P301_COPY_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia en p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(18354700370037123.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-JAN-2003 15:16'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(18358311033121570.4001)
,p_validation_name=>'P301_COPY_TO_PAGE_NAME Not Null'
,p_validation_sequence=>30
,p_validation=>'P301_COPY_TO_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo nombre de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(18357026353120297.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-JAN-2003 15:16'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(223855230993900068.4001)
,p_validation_name=>'P301_BREADCRUMB_NAME Not Null'
,p_validation_sequence=>40
,p_validation=>'P301_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P301_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(211822711548289046.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(223856421558916287.4001)
,p_validation_name=>'P301_COPY_TO must be numeric'
,p_validation_sequence=>50
,p_validation=>'P301_COPY_TO'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La copia en p\00E1gina debe ser num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(18354700370037123.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(74579310409510853.4001)
,p_validation_name=>'copy to page does not exist'
,p_validation_sequence=>60
,p_validation=>'select 1 from wwv_flow_steps where id = :P301_COPY_TO and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Esta p\00E1gina ya existe.')
,p_when_button_pressed=>wwv_flow_api.id(18345210914016042.4001)
,p_associated_item=>wwv_flow_api.id(18354700370037123.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614681508581243380.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(18344926854016042.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614681819848243380.4001)
,p_event_id=>wwv_flow_api.id(614681508581243380.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(513679326091698845.4001)
,p_name=>'on copy from page change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_COPY_FROM_S'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513679450314698846.4001)
,p_event_id=>wwv_flow_api.id(513679326091698845.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_display_copy_pub_rpt varchar2(1) := ''N'';',
'begin ',
'    :P301_COPY_FROM := substr( :P301_COPY_FROM_S, 1, instr(:P301_COPY_FROM_S,'':'',1)-1 );',
'    for l_region in (select null',
'                     from wwv_flow_page_plugs',
'                     where flow_id = :FB_FLOW_ID',
'                     and page_id = :P301_COPY_FROM',
'                     and plug_source_type in ( wwv_flow_region_native.c_ir, wwv_flow_region_native.c_ig ) )',
'    loop',
'        l_display_copy_pub_rpt := ''Y'';',
'        exit;',
'    end loop;',
'    :P301_DISPLAY_COPY_PUB_RPT := l_display_copy_pub_rpt;',
'end;'))
,p_attribute_02=>'P301_COPY_FROM_S,P301_COPY_FROM'
,p_attribute_03=>'P301_DISPLAY_COPY_PUB_RPT,P301_COPY_FROM'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(513679759976698849.4001)
,p_name=>'if true show copy public report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_DISPLAY_COPY_PUB_RPT'
,p_condition_element=>'P301_DISPLAY_COPY_PUB_RPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513679806714698850.4001)
,p_event_id=>wwv_flow_api.id(513679759976698849.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(617309055027937201.4001)
,p_event_id=>wwv_flow_api.id(513679759976698849.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(881355460813941721.4001)
,p_name=>'Show breadcrumb attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_BREADCRUMB_ID'
,p_condition_element=>'P301_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(881355576409941722.4001)
,p_event_id=>wwv_flow_api.id(881355460813941721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_BREADCRUMB_NAME,P301_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(881355669367941723.4001)
,p_event_id=>wwv_flow_api.id(881355460813941721.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_BREADCRUMB_NAME,P301_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(881355739693941724.4001)
,p_name=>'Set breadcrumb name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_COPY_TO_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(881355893819941725.4001)
,p_event_id=>wwv_flow_api.id(881355739693941724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P301_COPY_TO_PAGE_NAME'
,p_attribute_07=>'P301_COPY_TO_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19699823582700405.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_1'');',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_2'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_3'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_4'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al suprimir las recopilaciones del Asistente de Copia de P\00E1ginas.')
,p_process_when_button_id=>wwv_flow_api.id(18345210914016042.4001)
);
end;
/
prompt --application/pages/page_00302
begin
wwv_flow_api.create_page(
 p_id=>302.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Nuevos Nombres')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18346717108016066.4001)
,p_name=>unistr('Copiar P\00E1gina')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'')',
'   OR wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'')',
'   OR wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'')',
'   OR wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'')',
'then',
'  q:=''select wwv_flow_lang.system_message(''''F4000.REGION'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(9,c003) o, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(13,c004) s, ''; ',
'  q:=q||''wwv_flow_item.text(1,c001,35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(5,c002) n, '';',
'  q:=q||''wwv_flow_item.text(14,c005,25,255,''''title="''||wwv_flow_lang.system_message(''COPY.PAGE.NEW_STATIC_ID'')||''"'''')||wwv_flow_item.hidden(15,c006) t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_1'''' '';  ',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_ITEM2'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(10,c003) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(2,c001,35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(6,c002) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_2'''' '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''F4000.BUTTON'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(11,c003) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(3,c001,35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(7,c002) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_3'''' '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_BRANCHING'''') c,  '';',
'  q:=q||''wwv_flow_item.display_and_save(12,c003) o, '';',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.textarea(4,c001,3,25,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(8,c002) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_4'''' '';',
'  q:=q||''order by 1,2 '';    ',
'else   ',
'  q:=''select wwv_flow_lang.system_message(''''F4000.REGION'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(9,plug_name) o, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(13,region_name) s, ''; ',
'  q:=q||''wwv_flow_item.text(1,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  plug_name),35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(5,id) n, '';',
'  q:=q||''wwv_flow_item.text(14,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  region_name),25,255,''''title="''||wwv_flow_lang.system_message(''COPY.PAGE.NEW_STATIC_ID'')||''"'''')||wwv_flow_item.hidden(15,id) t '';',
'  q:=q||''from WWV_FLOW_PAGE_PLUGS '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and page_id = :p301_copy_from '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_ITEM2'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(10,prompt) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(2,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  prompt),35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(6,id) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from WWV_FLOW_STEP_ITEMS '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and flow_step_id = :p301_copy_from '';',
'  q:=q||''and prompt is not null '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''F4000.BUTTON'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(11,button_image_alt) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(3,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  button_image_alt),35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(7,id) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from WWV_FLOW_STEP_BUTTONS '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and flow_step_id = :p301_copy_from '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_BRANCHING'''') c,  '';',
'  q:=q||''wwv_flow_item.display_and_save(12,branch_action) o, '';',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.textarea(4,wwv_flow_copy_page.change_page_id_in_branch('';',
'  q:=q||''  :p301_copy_from, '';',
'  q:=q||''  :p301_copy_to, '';',
'  q:=q||''wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  branch_action)),3,25,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(8,id) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from WWV_FLOW_STEP_BRANCHES '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and flow_step_id = :p301_copy_from '';',
'  q:=q||''order by 1,2 '';',
'end if;  ',
'',
'return q;',
'end;'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>8
,p_query_num_rows=>1500
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No se necesitan valores nuevos. La p\00E1gina seleccionada no tiene regiones, elementos, botones ni bifurcaciones.')
,p_query_row_count_max=>5000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 06-JAN-2003 14:58:56'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48795507458772263.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48795628485772263.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Valor Anterior'
,p_column_html_expression=>'<div style="width:200px;overflow:hidden;" title="#COL02#">#COL02#</div>'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48795730147772263.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Identificador Est\00E1tico')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48795801255772263.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Valor Nuevo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48795932190772263.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Nuevo Identificador Est\00E1tico')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48796016406772263.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48796118466772263.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48796219310772263.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18570225958859834.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18564606387816293.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46184808850855937.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18347605105016068.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46184808850855937.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18347920038016069.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46184808850855937.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18347802037016069.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46184808850855937.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(341751132064790577.4001)
,p_branch_name=>'Close dialog'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(18347920038016069.4001)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18348821540016070.4001)
,p_branch_name=>'Go To Page 305'
,p_branch_action=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(18347802037016069.4001)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614680338054240706.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(18347605105016068.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614680691887240706.4001)
,p_event_id=>wwv_flow_api.id(614680338054240706.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19686629797550838.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_1'');',
'end if;',
'if wwv_flow.g_f02.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_2'');',
'end if;',
'if wwv_flow.g_f03.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_3'');',
'end if;',
'if wwv_flow.g_f04.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_4'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear las recopilaciones del Asistente de Copia de P\00E1ginas.')
,p_process_when_button_id=>wwv_flow_api.id(18347920038016069.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19676120559406180.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'and add member'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_1'',',
'      p_c001            => wwv_flow.g_f01,',
'      p_c002            => wwv_flow.g_f05,',
'      p_c003            => wwv_flow.g_f09,',
'      p_c004            => wwv_flow.g_f13,',
'      p_c005            => wwv_flow.g_f14,',
'      p_c006            => wwv_flow.g_f15);',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_2'',',
'      p_c001            => wwv_flow.g_f02,',
'      p_c002            => wwv_flow.g_f06,',
'      p_c003            => wwv_flow.g_f10);',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_3'',',
'      p_c001            => wwv_flow.g_f03,',
'      p_c002            => wwv_flow.g_f07,',
'      p_c003            => wwv_flow.g_f11);',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_4'',',
'      p_c001            => wwv_flow.g_f04,',
'      p_c002            => wwv_flow.g_f08,',
'      p_c003            => wwv_flow.g_f12);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al agregar los miembros de recopilaci\00F3n del Asistente de Copia de P\00E1ginas.')
,p_process_when_button_id=>wwv_flow_api.id(18347920038016069.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(881356176600941728.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_new_region_title     wwv_flow_global.vc_arr2;',
'   l_new_item_label       wwv_flow_global.vc_arr2;',
'   l_new_button_label     wwv_flow_global.vc_arr2;',
'   l_new_branch_value     wwv_flow_global.vc_arr2;',
'   l_new_region_name      wwv_flow_global.vc_arr2;',
'begin',
'select c002||'',''||replace(c001,'','',''___'')',
'BULK COLLECT INTO',
'l_new_region_title',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_1'';',
'',
'select c006||'',''||replace(c005,'','',''___'')',
'BULK COLLECT INTO',
'l_new_region_name',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_1'';',
'',
'select c002||'',''||c001',
'BULK COLLECT INTO',
'l_new_item_label',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_2'';',
'',
'select c002||'',''||c001',
'BULK COLLECT INTO',
'l_new_button_label',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_3'';',
'',
'select c002||'',''||c001',
'BULK COLLECT INTO',
'l_new_branch_value',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_4'';',
'',
'for i in 1..l_new_branch_value.count loop',
'wwv_flow.debug (''copy page new branch value ''||i||'' = "''||wwv_flow_escape.html(l_new_branch_value(i))||''"'');',
'end loop;',
'',
'',
'wwv_flow_copy_page.copy ( ',
'    p_flow_id_from             => :FB_FLOW_ID,   ',
'    p_page_id_from             => :P301_COPY_FROM,',
'    p_flow_id_to               => :FB_FLOW_ID,    ',
'    p_page_id_to               => :P301_COPY_TO,',
'    p_page_name_to             => :P301_COPY_TO_PAGE_NAME,',
'    --       ',
'    p_breadcrumb_id            => :P301_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P301_BREADCRUMB_NAME,',
'    p_parent_id                => :P301_PARENT_ID,    ',
'    --',
'    p_new_region_title         => l_new_region_title,',
'    p_new_item_label           => l_new_item_label,',
'    p_new_button_label         => l_new_button_label,',
'    p_new_branch_value         => l_new_branch_value,',
'    p_new_region_name          => l_new_region_name,',
'    --',
'    p_tab_set                  => :P305_TAB_SET,',
'    p_tab_name                 => :P305_TAB_NAME,',
'    p_tab_label                => :P305_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P305_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P305_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P305_NAVLIST_ENTRY_NAME,',
'    --',
'    p_ui_type_id_to            => :P301_UI_TYPE_ID,',
'    p_copy_public_report       => ( :P301_COPY_PUBLIC_REPORTS = ''Y'' )',
'    );',
'',
'wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',:P301_COPY_TO);',
'end;',
':F4000_RUN_EDIT_PAGE := :P301_COPY_TO;',
':FB_FLOW_PAGE_ID     := :P301_COPY_TO;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(881356220282941729.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_1'');',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_2'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_3'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_4'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00303
begin
wwv_flow_api.create_page(
 p_id=>303.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Resumen: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina de Resumen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214168830839927421)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7548209184810307.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de P\00E1gina de Resumen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_summary_page (',
'    p_flow_id         => :FB_FLOW_ID,',
'    p_page_id         => :F4000_P5100_PAGE_ID,',
'    p_page_name       => :F4000_P5100_PAGE_NAME,',
'    p_region_name     => :F4000_P5105_REGION_NAME,',
'    p_region_template => replace(:F4000_P5105_REGION_TEMPLATE,''%''||''null%''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7549532387817023.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(8771208191950732.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204707517366848377.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7550723645833370.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204707517366848377.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7562700976940434.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204707517366848377.4001)
,p_button_name=>'Addmore'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar M\00E1s')
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7551218694833371.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(204707517366848377.4001)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7550929028833371.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204707517366848377.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7563027647940435.4001)
,p_branch_action=>'5100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(7562700976940434.4001)
,p_branch_sequence=>42
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7553101528855404.4001)
,p_branch_action=>'5110'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(7550929028833371.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403517925360698708.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P5100_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P5100_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(7551218694833371.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549716182004753322.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(7550723645833370.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549716286737753323.4001)
,p_event_id=>wwv_flow_api.id(549716182004753322.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2410124385917354.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CREATE_SUMMARY'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_wizard_api.create_summary_page(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :F4000_P5100_PAGE_ID,',
'      p_page_name                => :F4000_P5100_PAGE_NAME,',
'      p_group_name               => :P5100_GROUP_NAME,',
'      p_page_mode                => :P5100_PAGE_MODE,',
'      p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_region_id                => replace(:F4000_P5105_REGION_ID,''%null%'',null),',
'      p_region_title             => :F4000_P5105_REGION_NAME,',
'      p_region_template          => replace(:F4000_P5105_REGION_TEMPLATE,''%null%'',null),',
'      p_field_template           => replace(:F4000_P5105_FIELD_TEMPLATE,''%null%'',null),',
'      p_label_align              => replace(:F4000_P5105_LABEL_ALIGNMENT,''%null%'',null),',
'      p_tag_attr                 => :F4000_P5105_TAG_ATTRIBUTES,',
'      p_field_align              => replace(:F4000_P5105_FIELD_ALIGNMENT,''%null%'',null)',
'  );',
'  ',
'  :fb_flow_page_id     := :F4000_P5100_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE := :F4000_P5100_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(122284011368617191.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumbs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :F4000_P5100_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P5100_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => nvl(:P5100_BREADCRUMB_NAME, :F4000_P5100_PAGE_NAME),',
'        p_parent_breadcrumb_entry_id => :P5100_BREADCRUMB_PARENT_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549716329236753324.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(7551218694833371.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00305
begin
wwv_flow_api.create_page(
 p_id=>305.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Men\00FA de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18570801155862085.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18564606387816293.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46202708251262627.4001)
,p_plug_name=>'wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1248952503448115942.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>50
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P301_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1248955233972115955.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(1248952503448115942.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P305_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1248955498423115962.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1248955518207115967.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1248955681517115967.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1248955724972115967.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_plug_name=>'List Based Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P301_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18351011391016077.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46202708251262627.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18351119390016077.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46202708251262627.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18351200192016077.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46202708251262627.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18352716941016092.4001)
,p_branch_name=>'Go To Page 302'
,p_branch_action=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(18351119390016077.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(18352209365016091.4001)
,p_branch_name=>'Go To Page 301'
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(18351200192016077.4001)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248953267717115951.4001)
,p_name=>'P305_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1248952503448115942.4001)
,p_item_default=>'0'
,p_prompt=>'Opciones de Separador:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si esta p\00E1gina deber\00EDa tener separadores y haga clic en <strong>Siguiente</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248953752909115952.4001)
,p_name=>'P305_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1248952503448115942.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248954208190115954.4001)
,p_name=>'P305_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1248952503448115942.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248954743504115954.4001)
,p_name=>'P305_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1248952503448115942.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P305_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P305_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248956227336117617.4001)
,p_name=>'P305_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248956469784117618.4001)
,p_name=>'P305_NEW_PARENT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    case ',
'        when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null)  then ',
'            lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'        else ',
'            lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')'' ',
'    end name,',
'    id',
'  from wwv_flow_list_items',
' start with parent_list_item_id is null',
'        and flow_id = :FB_FLOW_ID',
'        and list_id = :P305_NAVLIST_ID',
' connect by prior id = parent_list_item_id',
'        and prior list_id = list_id',
' order siblings by list_item_display_sequence',
'',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248956971025117619.4001)
,p_name=>'P305_NAVLIST_ENTRY_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P301_COPY_TO_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para la nueva entrada de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1248957636293117620.4001)
,p_name=>'P305_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('Preferencia de Navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1554797717055340137.4001)
,p_name=>'P305_EXISTING_PARENT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P305_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1554826395322464093.4001)
,p_name=>'P305_NAVLIST_PARENT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1248955872528117612.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1248980515223124847.4001)
,p_computation_sequence=>50
,p_computation_item=>'P305_TAB_SET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_TAB_OPTIONS'
,p_compute_when_text=>'0'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1248981221471127828.4001)
,p_computation_sequence=>50
,p_computation_item=>'P305_TAB_NAME'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_TAB_OPTIONS'
,p_compute_when_text=>'1'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1248981931818137167.4001)
,p_computation_sequence=>50
,p_computation_item=>'P305_TAB_LABEL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_TAB_OPTIONS'
,p_compute_when_text=>'2:0'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1248982214944138643.4001)
,p_computation_sequence=>50
,p_computation_item=>'P305_NAVLIST_ENTRY_NAME'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1554875940296583200.4001)
,p_computation_sequence=>70
,p_computation_item=>'P305_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P305_NEW_PARENT_ID'
,p_compute_when=>'P305_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1554876177693584945.4001)
,p_computation_sequence=>70
,p_computation_item=>'P305_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P305_EXISTING_PARENT_ID'
,p_compute_when=>'P305_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1264003127515339681.4001)
,p_computation_sequence=>50
,p_computation_item=>'P305_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_lists l       ',
' where l.flow_id = :FB_FLOW_ID',
'   and l.flow_id = i.flow_id',
'   and l.id = i.navigation_list_id',
'   and i.id = :P301_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1248982514907143568.4001)
,p_validation_name=>'tab set not null'
,p_validation_sequence=>50
,p_validation=>'P305_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P305_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(18351119390016077.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1248982712083144731.4001)
,p_validation_name=>'tab label not null'
,p_validation_sequence=>60
,p_validation=>'P305_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P305_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(18351119390016077.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1248982936115145752.4001)
,p_validation_name=>'tab name not null'
,p_validation_sequence=>70
,p_validation=>'P305_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P305_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(18351119390016077.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1554885121522637677.4001)
,p_validation_name=>'New Entry with no List'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P305_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P305_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1248983562578147778.4001)
,p_validation_name=>'P305_NAVLIST_ENTRY_NAME'
,p_validation_sequence=>90
,p_validation=>'P305_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se necesita un nombre de entrada para los nuevos elementos de navegaci\00F3n')
,p_validation_condition=>':P301_NAVIGATION_TYPE=''L'' and :P305_NAVLIST_OPTIONS=''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(18351119390016077.4001)
,p_associated_item=>wwv_flow_api.id(1248956971025117619.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1554887790954707970.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>100
,p_validation=>'P305_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P305_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614679604196237457.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(18351011391016077.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614679929284237457.4001)
,p_event_id=>wwv_flow_api.id(614679604196237457.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1249119521131791584.4001)
,p_name=>'Tab Option 0 Settings'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_TAB_OPTIONS'
,p_condition_element=>'P305_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249119859129791589.4001)
,p_event_id=>wwv_flow_api.id(1249119521131791584.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_SET,P305_TAB_LABEL,P305_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1249119989033793366.4001)
,p_name=>'Tab Option 1 Settings'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_TAB_OPTIONS'
,p_condition_element=>'P305_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249120258878793366.4001)
,p_event_id=>wwv_flow_api.id(1249119989033793366.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_SET,P305_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249120497798793367.4001)
,p_event_id=>wwv_flow_api.id(1249119989033793366.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1249120553266795028.4001)
,p_name=>'Tab Option 2 Settings'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_TAB_OPTIONS'
,p_condition_element=>'P305_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249120813596795028.4001)
,p_event_id=>wwv_flow_api.id(1249120553266795028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_SET,P305_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249121025618795028.4001)
,p_event_id=>wwv_flow_api.id(1249120553266795028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1249121172260796733.4001)
,p_name=>'New Navlist Entry Name'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_condition_element=>'P305_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249121601056796733.4001)
,p_event_id=>wwv_flow_api.id(1249121172260796733.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_ENTRY_NAME,P305_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249121430231796733.4001)
,p_event_id=>wwv_flow_api.id(1249121172260796733.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_ENTRY_NAME,P305_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1554798154785352765.4001)
,p_name=>'Existing NavList Entry'
,p_event_sequence=>95
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_condition_element=>'P305_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1554798427087352781.4001)
,p_event_id=>wwv_flow_api.id(1554798154785352765.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1554798665433352786.4001)
,p_event_id=>wwv_flow_api.id(1554798154785352765.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1249122312230800129.4001)
,p_name=>'Update Tree'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249122690443800130.4001)
,p_event_id=>wwv_flow_api.id(1249122312230800129.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#P305_NAVLIST_PARENT_ID option:contains('' ('')").attr("disabled","disabled");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1249121759611798356.4001)
,p_name=>'Show Navigation Tree'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_condition_element=>'P305_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249122080259798356.4001)
,p_event_id=>wwv_flow_api.id(1249121759611798356.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1249122216414798356.4001)
,p_event_id=>wwv_flow_api.id(1249121759611798356.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00306
begin
wwv_flow_api.create_page(
 p_id=>306.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Traducir Texto'
,p_step_title=>'Traducir Texto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162450423094619414.4001)
,p_plug_name=>'Traducir Texto'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694679637823238904.4001)
,p_plug_name=>'Translate Text'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Normalmente, las traducciones se llevan a cabo mediante un servicio de traducci\00F3n profesional. Se env\00EDa a traducir el'),
unistr('archivo XLIFF a una compa\00F1\00EDa externa y, a continuaci\00F3n, se integran los archivos de traducci\00F3n resultantes y se publican'),
'las aplicaciones traducidas.</p>',
'',
unistr('<p>Tambi\00E9n puede editar el archivo XLIFF personalmente, o bien ignorar la generaci\00F3n XLIFF y cargarlos todos juntos'),
unistr('y editar el repositorio de traducci\00F3n directamente.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694679767912238905.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(694679863558238906.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(694679767912238905.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(166469227943699113.4001)
,p_branch_action=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00307
begin
wwv_flow_api.create_page(
 p_id=>307.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Regi\00F3n')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(49332904673072144.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||PLUG_NAME name',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id and',
'      r.PLUG_TEMPLATE = :p307_id',
'and r.security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(49345701272325144.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49333411517072148.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200328107792916236.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747140495476138159.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49334213861072151.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200328107792916236.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49334600263072154.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200328107792916236.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49338419046072186.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49335032357072158.4001)
,p_name=>'P307_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(49333411517072148.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PLUG_TEMPLATE_NAME, id',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica el nombre de la plantilla que se va a suprimir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49335728578072167.4001)
,p_name=>'P307_THEME_ID'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(49333411517072148.4001)
,p_prompt=>'Tema:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where flow_id = :fb_flow_id and id = :p307_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49336417925072170.4001)
,p_name=>'P307_LIST_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(49333411517072148.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_class_id',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where flow_id = :fb_flow_id and id = :p307_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REGION THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(42003622222572861.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49337630525072175.4001)
,p_validation_name=>'P307_ID'
,p_validation_sequence=>10
,p_validation=>'P307_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(49335032357072158.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49337211746072174.4001)
,p_validation_name=>'Prevent deletion of used templates'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 x',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id and r.PLUG_TEMPLATE = :p307_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'No puede suprimir plantillas a las que se hace referencia.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49338005752072180.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>'delete from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = :fb_flow_id and id = :p307_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(49334600263072154.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00312
begin
wwv_flow_api.create_page(
 p_id=>312.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
,p_step_title=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215592520464926917)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_file_upload.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26482603110914170.4001)
,p_plug_name=>'Archivos'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, wwv_flow_escape.html(id)) cb,',
'       id,',
'       security_group_id,',
'       null as icon,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       round( sys.dbms_lob.getLength(file_content) / 1024 / 1024, 2 )  as file_size_in_mb,',
'       file_charset,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'            p_scope     => ''WORKSPACE'',',
'            p_file_name => file_name ) as reference,',
'       case when file_ext in (''html'', ''js'', ''css'', ''json'', ''xml'') then ''icon-file-'' || file_ext',
'            when lower(mime_type) like ''image/%'' then ''icon-ws-image''',
'            else ''icon-sc-file''',
'       end as icon_class,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_ID,P118_SCOPE'',',
'           p_values      => id || '',WORKSPACE''',
'       ) as edit_link,',
'       last_updated_on          as updated,',
'       lower(last_updated_by)   as updated_by,',
'       created_on               as created,',
'       lower(created_by)        as created_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_company_static_files f)',
' where security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(26482817283914173.4001)
,p_name=>'Files'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn archivo de espacio de trabajo est\00E1tico.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#EDIT_LINK#" class="a-IRR-icon">',
'    <span class="a-Icon #ICON_CLASS#"></span>',
'    <span class="a-IRR-iconName">#FILE_NAME#</span>',
'</a>'))
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>26482817283914173
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26482924107914174.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26483610363914179.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>11
,p_column_identifier=>'I'
,p_column_label=>'Identificador de Grupo de Seguridad'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4905025037807748.4001)
,p_db_column_name=>'CB'
,p_display_order=>21
,p_column_identifier=>'T'
,p_column_label=>'&nbsp;'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21698966710753941.4001)
,p_db_column_name=>'ICON'
,p_display_order=>31
,p_column_identifier=>'O'
,p_column_label=>'&nbsp;'
,p_column_html_expression=>'<span class="a-Icon #ICON_CLASS#" aria-hidden="true"></span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26483111701914176.4001)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>41
,p_column_identifier=>'D'
,p_column_label=>'Nombre'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26483012628914176.4001)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>51
,p_column_identifier=>'C'
,p_column_label=>'Tipo MIME'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26483222455914178.4001)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>61
,p_column_identifier=>'E'
,p_column_label=>unistr('Tama\00F1o')
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30284310737103903.4001)
,p_db_column_name=>'FILE_CHARSET'
,p_display_order=>71
,p_column_identifier=>'J'
,p_column_label=>'Juego de Caracteres de Archivo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(144796827445692396)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26483317617914178.4001)
,p_db_column_name=>'FILE_CONTENT'
,p_display_order=>81
,p_column_identifier=>'F'
,p_column_label=>'Archivo'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_COMPANY_STATIC_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME::FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(261792531167034701.4001)
,p_db_column_name=>'REFERENCE'
,p_display_order=>91
,p_column_identifier=>'K'
,p_column_label=>'Referencia'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656833894631574713.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>101
,p_column_identifier=>'L'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(361062101563469306.4001)
,p_db_column_name=>'FILE_SIZE_IN_MB'
,p_display_order=>111
,p_column_identifier=>'N'
,p_column_label=>unistr('Tama\00F1o de archivo en MB')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656833965796574713.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>121
,p_column_identifier=>'M'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21699075178753942.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>131
,p_column_identifier=>'P'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21699110120753943.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>141
,p_column_identifier=>'Q'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21699225859753944.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>151
,p_column_identifier=>'R'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(21699320828753945.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>161
,p_column_identifier=>'S'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26484331581914182.4001)
,p_plug_name=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los archivos de espacio de trabajo est\00E1ticos est\00E1n disponibles en todas las aplicaciones de un determinado espacio de trabajo. Utilice <code><strong>&#35;WORKSPACE_FILES#</strong></code> en la aplicaci\00F3n para hacer referencia a un archivo.</p>'),
'',
unistr('<p>Utilice esta p\00E1gina para crear, editar y suprimir archivos est\00E1ticos.</p>'),
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-static-workspace-files.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26483931279914180.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(26482603110914170.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:40,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4905147900807749.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(26482603110914170.4001)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30822212442965618.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(26482603110914170.4001)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Todo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30822015245964373.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(26482603110914170.4001)
,p_button_name=>'DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar como Zip'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(26484101155914182.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(26482603110914170.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Archivo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE:WORKSPACE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30824719032982998.4001)
,p_branch_name=>'Reset Pagination after delete all'
,p_branch_action=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30822212442965618.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4905204412807750.4001)
,p_name=>'Delete Checked Files'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4905147900807749.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(6411997454218601.4001)
,p_event_id=>wwv_flow_api.id(4905204412807750.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los archivos seleccionados?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(6412060174218602.4001)
,p_event_id=>wwv_flow_api.id(4905204412807750.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_CHECKED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(30822500893968358.4001)
,p_name=>'Delete All Files'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30822212442965618.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(30823008096968366.4001)
,p_event_id=>wwv_flow_api.id(30822500893968358.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los archivos?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(30822814313968365.4001)
,p_event_id=>wwv_flow_api.id(30822500893968358.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6412150537218603.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1 .. wwv_flow.g_f01.count loop',
'   wwv_flow_file_editor_dev.delete_file (',
'       p_id     => wwv_flow.g_f01(i),',
'       p_scope  => ''WORKSPACE'' );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4905147900807749.4001)
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30823207126970082.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30822212442965618.4001)
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30823411282971295.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'PLUGIN_COM.ORACLE.APEX.DOWNLOAD_AS_ZIP'
,p_process_name=>'Download as Zip'
,p_attribute_01=>'static_workspace_files.zip'
,p_attribute_02=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name,',
'       file_content',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30822015245964373.4001)
);
end;
/
prompt --application/pages/page_00321
begin
wwv_flow_api.create_page(
 p_id=>321.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Instalar Valores por Defecto de Interfaz de Usuario'
,p_step_title=>'Instalar Valores por Defecto de Interfaz de Usuario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38857309371202842.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47632929379499289.4001)
,p_plug_name=>'Instalar Valores por Defecto de Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or ',
'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede instalar una exportaci\00F3n del diccionario de tabla de valores por defecto de la interfaz de usuario en cualquier esquema provisionado en el espacio de trabajo. Al instalar una exportaci\00F3n de diccionario de tabla, se sobrescriben los antiguos ')
||'valores por defecto.</p>',
unistr('<p>Las importaciones del diccionario de tabla de valores por defecto de la interfaz de usuario sustituir\00E1n a cualquier definici\00F3n de atributo coincidente que se encuentre, pero no eliminar\00E1n las definiciones de atributo existentes que no est\00E9 incluid')
||unistr('as en la exportaci\00F3n.</p>'),
unistr('<p>Si la instalaci\00F3n se realiza correctamente, la instalaci\00F3n de los valores por defecto de interfaz de usuario ser\00E1 permanente. Si se encuentran errores, se realiza un rollback de las acciones sin ning\00FAn cambio permanente.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(79479717773383324.4001)
,p_plug_name=>unistr('Archivo no V\00E1lido')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is null and ',
'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('El archivo no es un archivo de exportaci\00F3n de valores por defecto de interfaz de usuario de &PRODUCT_NAME. v\00E1lido.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205187226579460699.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747140815004138160.4001)
,p_plug_name=>'Instalar Valores por Defecto de Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47637304969530136.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205187226579460699.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480397319743348548.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(79479717773383324.4001)
,p_button_name=>'CANCEL2'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47638615358533175.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205187226579460699.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Instalar Valores por Defecto de Interfaz de Usuario'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or',
'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47640408909540737.4001)
,p_branch_action=>'f?p=4500:813:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''INSTALL'' or',
'(:REQUEST = ''REPLACE'' and ',
' (wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or',
'  wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null) )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73118923864774290.4001)
,p_branch_action=>'f?p=&FLOW_ID.:321:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73107224679708356.4001)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:UI_DEFAULTS:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47638615358533175.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_HNT_TABLE_INFO',
' where schema = :P321_SCHEMA_NAME',
'   and wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24121328651623248.4001)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:UI_DEFAULTS_AD:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(47638615358533175.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_HNT_COLUMN_DICT',
' where security_group_id = :flow_security_group_id',
'   and wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53701615454624100.4001)
,p_name=>'P321_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47632929379499289.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146463506734195936.4001)
,p_name=>'P321_SCHEMA_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(47632929379499289.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre del Esquema Exportado:'
,p_source=>'wwv_flow_imp_parser.get_ui_schema(:p321_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('El esquema asociado al diccionario de la tabla de valores por defecto de la interfaz de usuario. Este esquema debe estar asociado al espacio de trabajo actual para que se pueda realizar la importaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160738417213422622.4001)
,p_name=>'P321_ORIGINAL_SGID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(47632929379499289.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Exportado de Espacio de Trabajo:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_file_sgid number := wwv_flow_imp_parser.get_security_group_id(:p321_file_id);',
'begin',
'  for c1 in (select short_name from wwv_flow_companies',
'    where provisioning_company_id = l_file_sgid) loop',
'    return c1.short_name||'' (''||to_char(l_file_sgid)||'')'';',
'  end loop;',
'return to_char(l_file_sgid);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El identificador \00FAnico del espacio de trabajo desde el que se ha exportado este archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163265116213402450.4001)
,p_name=>'P321_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47632929379499289.4001)
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p321_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(163273327828519313.4001)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p321_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de la aplicaci\00F3n.)')
,p_when_button_pressed=>wwv_flow_api.id(47638615358533175.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47812121666858284.4001)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is null and',
'   wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de valores por defecto de interfaz de usuario de &PRODUCT_NAME. v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(47638615358533175.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(628833325240746222.4001)
,p_validation_name=>'file schema associated with workspace - for table defaults'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_exp_schema varchar(255) := wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID);',
'begin',
'   for c1 in (',
'      select c.schema',
'        from wwv_flow_company_schemas c,',
'             wwv_flow_fnd_user u',
'       where c.security_group_id = :flow_security_group_id and',
'             u.security_group_id = :flow_security_group_id and',
'             u.user_name = :flow_user and',
'             (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'              instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0) )',
'   loop',
'      if c1.schema = l_exp_schema then',
'         return true;',
'      end if;',
'   end loop;',
'',
'   return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Exportado de esquema no asociado al espacio de trabajo actual.'
,p_validation_condition=>'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(47638615358533175.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46353812810485902.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install user interface defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_imp_parser.parse (',
'     p_file_id          => :P321_FILE_ID',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al instalar los valores por defecto de interfaz de usuario.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''INSTALL'' or',
'(:REQUEST = ''REPLACE'' and ',
' (wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or',
'  wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null) )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Valores por defecto de interfaz de usuario instalados.'
);
end;
/
prompt --application/pages/page_00326
begin
wwv_flow_api.create_page(
 p_id=>326.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Maestro/Detalle'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Maestro/Detalle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619048424417526349.4001)
,p_plug_name=>unistr('Crear P\00E1gina de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(789026991723679825.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(42519297248600803.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(821217286977970926.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(619068458939844780.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(821217286977970926.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(619068893499844784.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(821217286977970926.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(619069205447844784.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(821217286977970926.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(619086728986844827.4001)
,p_branch_name=>'Go To Navigation/Tab'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(619068893499844784.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(619086342794844827.4001)
,p_branch_action=>'f?p=&APP_ID.:326:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P326_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(619087130743844828.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'29'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(619069205447844784.4001)
,p_branch_sequence=>120
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(617309436030937205.4001)
,p_name=>'P326_DETAIL_BC_NAME'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>unistr('Nombre de Entrada de P\00E1gina de Detalles')
,p_source=>'P326_DETAIL_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID ) and',
':P326_BREADCRUMB_ID is not null',
''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de ruta de navegaci\00F3n para la p\00E1gina de detalles. La ruta de navegaci\00F3n solo se crear\00E1 si el modo de la p\00E1gina de detalles es normal.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619054439829844763.4001)
,p_name=>'P326_MASTER_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina Maestra')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,2)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero de la p\00E1gina maestra que contendr\00E1 la cuadr\00EDcula interactiva maestra de solo lectura. Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina. Si identifica un n\00FAmero de p\00E1gina existente, el asistente agrega e')
||unistr('l componente a esa p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619055347565844765.4001)
,p_name=>'P326_MASTER_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>91
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>unistr('Nombre de P\00E1gina Maestra')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la p\00E1gina maestra.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619057122445844767.4001)
,p_name=>'P326_DETAIL_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>93
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Detalles')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero de la p\00E1gina de detalles que contendr\00E1 la pantalla y la cuadr\00EDcula interactiva editable. Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina. Si identifica un n\00FAmero de p\00E1gina existente, el asistente agreg')
||unistr('a el componente a esa p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619058028683844767.4001)
,p_name=>'P326_DETAIL_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>94
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>unistr('Nombre de P\00E1gina de Detalles')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la p\00E1gina de detalles.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619065103690844776.4001)
,p_name=>'P326_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619066009653844777.4001)
,p_name=>'P326_BREADCRUMB_PARENT_ID'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P326_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P326_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P326_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619066434012844777.4001)
,p_name=>'P326_MASTER_BC_NAME'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(619048424417526349.4001)
,p_prompt=>unistr('Nombre de Entrada de P\00E1gina Maestra')
,p_source=>'P326_MASTER_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de ruta de navegaci\00F3n para la p\00E1gina maestra.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(619075729537844812.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P326_MASTER_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(619071729532844809.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(619077337834844815.4001)
,p_validation_name=>'P326_MASTER_PAGE_ID non numeric'
,p_validation_sequence=>25
,p_validation=>'P326_MASTER_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(619068893499844784.4001)
,p_associated_item=>wwv_flow_api.id(619054439829844763.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(617310990210937220.4001)
,p_validation_name=>'P326_DETAIL_PAGE_ID non numeric'
,p_validation_sequence=>35
,p_validation=>'P326_DETAIL_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(619068893499844784.4001)
,p_associated_item=>wwv_flow_api.id(619057122445844767.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(619077793075844815.4001)
,p_validation_name=>'P326_MASTER_BC_NAME not null'
,p_validation_sequence=>45
,p_validation=>'P326_MASTER_BC_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n de la p\00E1gina maestra.')
,p_validation_condition=>'P326_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(619068893499844784.4001)
,p_associated_item=>wwv_flow_api.id(619066434012844777.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(617310618359937217.4001)
,p_validation_name=>'P326_DETAIL_BC_NAME not null'
,p_validation_sequence=>55
,p_validation=>'P326_DETAIL_BC_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n de la p\00E1gina de detalles.')
,p_validation_condition=>'P326_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(619068893499844784.4001)
,p_associated_item=>wwv_flow_api.id(617309436030937205.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(619078151742844815.4001)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>65
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      select 1',
'      from wwv_flow_page_plugs',
'      where flow_id = :fb_flow_id',
'      and   page_id in (:P326_MASTER_PAGE_ID, :P326_DETAIL_PAGE_ID)',
'      and   menu_id is not null',
'      and   nvl(:P326_BREADCRUMB_ID,0)<>0'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina especificada ya tiene una regi\00F3n de ruta de navegaci\00F3n.')
,p_validation_condition=>'wwv_flow_utilities.is_numeric( p_str => :P326_MASTER_PAGE_ID) and wwv_flow_utilities.is_numeric( p_str => :P326_DETAIL_PAGE_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(619068893499844784.4001)
,p_associated_item=>wwv_flow_api.id(619065103690844776.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619081657186844822.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P326_BREADCRUMB_ID'
,p_condition_element=>'P326_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619082182779844823.4001)
,p_event_id=>wwv_flow_api.id(619081657186844822.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P326_MASTER_BC_NAME,P326_BREADCRUMB_PARENT_ID,P326_DETAIL_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619082650046844823.4001)
,p_event_id=>wwv_flow_api.id(619081657186844822.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P326_MASTER_BC_NAME,P326_BREADCRUMB_PARENT_ID,P326_DETAIL_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619083030838844823.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(619068458939844780.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619083574908844824.4001)
,p_event_id=>wwv_flow_api.id(619083030838844823.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619083932756844824.4001)
,p_name=>'Master Page Exists'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_utilities.is_numeric( p_str =>:P326_MASTER_PAGE_ID ) and',
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P326_MASTER_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619084469407844825.4001)
,p_event_id=>wwv_flow_api.id(619083932756844824.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P326_BREADCRUMB_PARENT_ID,P326_MASTER_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(617310705213937218.4001)
,p_name=>'Detail Page Exists'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_utilities.is_numeric( p_str =>:P326_DETAIL_PAGE_ID ) and',
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P326_DETAIL_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(617310813298937219.4001)
,p_event_id=>wwv_flow_api.id(617310705213937218.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P326_DETAIL_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619084839497844825.4001)
,p_name=>'set master bc name'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P326_MASTER_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619085810202844826.4001)
,p_event_id=>wwv_flow_api.id(619084839497844825.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P326_MASTER_BC_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P326_MASTER_PAGE_NAME'
,p_attribute_07=>'P326_MASTER_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(617310474694937215.4001)
,p_name=>'set detail bc name'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P326_DETAIL_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(617310549270937216.4001)
,p_event_id=>wwv_flow_api.id(617310474694937215.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P326_DETAIL_BC_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P326_DETAIL_PAGE_NAME'
,p_attribute_07=>'P326_DETAIL_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00328
begin
wwv_flow_api.create_page(
 p_id=>328.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Propiedades del Script'
,p_step_title=>'Propiedades del Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function pageSubmit(req) {',
'  apex.submit(req);',
'}',
''))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.db-ValidStatus {',
'    padding: 8px 16px;',
'    text-align: center;',
'}',
'.db-ValidStatus-status {',
'    padding: 8px;',
'    border-radius: 4px;',
'    text-align: center;',
'    box-shadow: 0 0 0 2px rgba(0,0,0,.1) inset;',
'    margin-bottom: 8px;',
'    color: #000;',
'}',
'.db-ValidStatus-status.green {',
'    background-color: #A3F079;',
'}',
'.db-ValidStatus-status.red {',
'    background-color: #F00000;',
'    color: #FFF;',
'}',
'.db-ValidStatus-status.yellow {',
'    background-color: #F3D834;',
'}',
'.db-ValidStatus-link {',
'    font-size: 11px;',
'    color: #707070;',
'}',
'.uSideRegion span.uButtonContainer {',
'display: block;',
'padding: 8px 16px;',
'}',
'.uSideRegion span.uButtonContainer .uButtonLarge {',
'    display: block;',
'}'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_read_only_when_type=>'EXPRESSION'
,p_read_only_when=>'not wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID )'
,p_read_only_when2=>'PLSQL'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(923623550470073.4001)
,p_plug_name=>'Script: &P328_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(933304732487769.4001)
,p_plug_name=>'Script'
,p_region_name=>'SCRIPT'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(952616047632959.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'CONDITIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4853705393428023.4001)
,p_plug_name=>'Separadores de Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>0
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_api.id(4852514958421306.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46235930672678964.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>13
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(925210867036339484.4001)
,p_plug_name=>'Origen'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_region_attributes=>'style="clear:both"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select script',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and id = :P328_ID'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'DDL'
,p_attribute_02=>'20'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(925329487962687617.4001)
,p_plug_name=>'Bloqueos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.display_script_lock_info (',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_script_id => :P328_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(925353646438874243.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(925329487962687617.4001)
,p_button_name=>'LOCK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Bloquear'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:16:P16_LOCK_SCRIPT_ID:&P328_ID.'
,p_button_condition=>'not wwv_flow_lock.script_locked ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(925389882234951313.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(925329487962687617.4001)
,p_button_name=>'UNLOCK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Desbloquear'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:16:P16_LOCK_SCRIPT_ID,P16_LOCK_ID:&P328_ID.,&P328_LOCK_ID.'
,p_button_condition=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4783606441436244.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(933304732487769.4001)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Editar'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_ID:&P328_ID.'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(924109972470088.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(924030159470088.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923906509470088.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923824997470087.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P328_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4869105748503820.4001)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_ID,P865_MODE:&P328_ID.,EDIT:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_865'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(929196032807394224.4001)
,p_branch_name=>'Go To Page 328'
,p_branch_action=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:865:P865_SCRIPT_ID,P865_MODE:&P328_ID.,EDIT:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_328'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(924710023470101.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(924904477470144.4001)
,p_name=>'P328_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(925127884470161.4001)
,p_name=>'P328_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(925511458470194.4001)
,p_name=>'P328_INSTALL_ID'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'INSTALL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(925901158470200.4001)
,p_name=>'P328_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(933304732487769.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de este script de instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(926324801470201.4001)
,p_name=>'P328_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(933304732487769.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero de secuencia de este script de instalaci\00F3n. Los archivos de comandos se ejecutan por n\00FAmero de secuencia en orden ascendente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(927119812470203.4001)
,p_name=>'P328_CONDITION_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(952616047632959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'INSTALL_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2610902469203915.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista que determine si este script se ejecuta durante la instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P328_CONDITION'
,p_attribute_02=>'P328_CONDITION2'
,p_attribute_04=>'P328_CONDITION_CHECK'
,p_attribute_06=>'INSTALL'
,p_attribute_07=>'P328_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(927300256470204.4001)
,p_name=>'P328_CONDITION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(952616047632959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice este atributo para controlar de forma condicional si se va a ejecutar el script actual en la instalaci\00F3n. Introduzca valores en este atributo seg\00FAn el tipo de condici\00F3n concreto seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(927517644470204.4001)
,p_name=>'P328_CONDITION2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(952616047632959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1672854271932288.4001)
,p_name=>'P328_CONDITION_LANG'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(952616047632959.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57790318700946827.4001)
,p_name=>'P328_SCRIPT_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(933304732487769.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'INSTALL'
,p_prompt=>'Tipo de Script'
,p_source=>'SCRIPT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tipo de este script de objeto de soporte.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435033705614654759.4001)
,p_name=>'P328_CONDITION_CHECK'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(952616047632959.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(573141089417686163.4001)
,p_name=>'P328_SCRIPT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(933304732487769.4001)
,p_prompt=>'Nuevo Script'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione un archivo que cargar para sustituir el script existente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(573141527634691114.4001)
,p_name=>'P328_FILE_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(933304732487769.4001)
,p_prompt=>'Juego de Caracteres de Archivo'
,p_source=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el juego de caracteres con el que el script est\00E1 codificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(929001219074024339.4001)
,p_name=>'P328_LOCK_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(923623550470073.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(929001419112034464.4001)
,p_computation_sequence=>10
,p_computation_item=>'P328_LOCK_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_lock_script',
'where script_id = :P328_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and flow_id = :FB_FLOW_ID',
'and locked_by = :APP_USER'))
,p_compute_when=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(926108808470201.4001)
,p_validation_name=>'P328_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P328_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(925901158470200.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(926505451470202.4001)
,p_validation_name=>'P328_SEQUENCE not null'
,p_validation_sequence=>60
,p_validation=>'P328_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La secuencia debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(926324801470201.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(932842459462260186.4001)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(925329487962687617.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(932842796470260190.4001)
,p_event_id=>wwv_flow_api.id(932842459462260186.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:328:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(927707701470208.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P328_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(927923987470222.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P328_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL_SCRIPTS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(928131752470223.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'328'
,p_process_when_button_id=>wwv_flow_api.id(924030159470088.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537839307388118515.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_clob clob;',
'begin',
'for c1 in (select *',
'             from wwv_flow_files ',
'            where name = :P328_SCRIPT)',
'loop',
'',
'  l_clob := wwv_flow_utilities.blob_to_clob( ',
'                p_blob => c1.blob_content, ',
'                p_charset => :P328_FILE_CHARSET );',
'                ',
'  update wwv_flow_install_scripts',
'     set script = l_clob',
'   where flow_id = :fb_flow_id',
'     and security_group_id = :flow_security_group_id',
'     and id = :P328_ID;',
'     ',
'  delete from wwv_flow_files where id = c1.id;     ',
'',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Se ha producido un error al intentar sustituir el script.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(923906509470088.4001)
,p_process_when=>'P328_SCRIPT'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Script sustituido.'
);
end;
/
prompt --application/pages/page_00330
begin
wwv_flow_api.create_page(
 p_id=>330.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Bloqueo de P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Editar Bloqueo de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213229021839834158)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_locks.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34977219677901638.4001)
,p_plug_name=>unistr('Editar Bloqueo de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('Esta p\00E1gina permite a los administradores de espacio de trabajo desbloquear cualquier p\00E1gina.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059809069083457627.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34977605764901644.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1059809069083457627.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:299:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34977927457901644.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1059809069083457627.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Desbloquear'
,p_button_position=>'NEXT'
,p_button_condition=>'P330_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34977816263901644.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1059809069083457627.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P330_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34979600897901653.4001)
,p_branch_action=>'f?p=&APP_ID.:299:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34980027621901664.4001)
,p_name=>'P330_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(34977219677901638.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34980418553901689.4001)
,p_name=>'P330_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34977219677901638.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'OBJECT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este bloqueo es para esta p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34980814477901694.4001)
,p_name=>'P330_LOCK_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(34977219677901638.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'LOCK_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Al igual que cualquier otro desarrollador de espacios de trabajo, como administrador de un espacio de trabajo puede editar comentarios de bloqueo personalmente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34995523029005767.4001)
,p_name=>'P330_LOCKED_BY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(34977219677901638.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Bloqueado por'
,p_source=>'LOCKED_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(userid) d, userid r',
'from wwv_flow_developers',
'where (instr(developer_role,''ADMIN'') > 0 or',
'      instr(developer_role,''EDIT'') > 0)',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Como administrador de un espacio de trabajo, puede definir la p\00E1gina que va a bloquear cualquier desarrollador de aplicaciones v\00E1lido en el espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35025211012134770.4001)
,p_validation_name=>'P330_LOCKED_BY'
,p_validation_sequence=>10
,p_validation=>'P330_LOCKED_BY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(34995523029005767.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1059808873062457625.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(34977605764901644.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1059808907077457626.4001)
,p_event_id=>wwv_flow_api.id(1059808873062457625.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34981300123901698.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P330_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34981708199901700.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P330_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_LOCK_PAGE.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34982116880901701.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'330'
,p_process_when_button_id=>wwv_flow_api.id(34977927457901644.4001)
);
end;
/
prompt --application/pages/page_00331
begin
wwv_flow_api.create_page(
 p_id=>331.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Edici\00F3n de Cuadr\00EDculas de Separadores Principales')
,p_step_title=>'Editar Separadores Principales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(32785704230533968.4001)
,p_name=>'Edit Parent Tabs'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P331a */',
'    ID,',
'    TAB_SEQUENCE,',
'    TAB_NAME,',
'    TAB_TEXT,',
'    TAB_TARGET,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON',
'from WWV_FLOW_TOPLEVEL_TABS',
'where flow_id = :fb_flow_id ',
'and (:P331_TABSET is null or :P331_TABSET = ''0'' or tab_set = :P331_TABSET)',
'and security_group_id = :flow_security_group_id',
'order by tab_set, tab_sequence, tab_name'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn separador principal.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 11-FEB-2003 14:24:40'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48575811244770989.4001)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<br />'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48575928440770989.4001)
,p_query_column_id=>2
,p_form_element_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48576002472770989.4001)
,p_query_column_id=>3
,p_form_element_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48576115826770989.4001)
,p_query_column_id=>4
,p_form_element_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Texto'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48576232078770990.4001)
,p_query_column_id=>5
,p_form_element_id=>5
,p_column_alias=>'TAB_TARGET'
,p_column_display_sequence=>5
,p_column_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>40
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48576303329770990.4001)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Desarrollador'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48576423268770990.4001)
,p_query_column_id=>7
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>7
,p_column_heading=>'Fecha'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32785920052533992.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32786027691533995.4001)
,p_column_sequence=>2
,p_query_column_name=>'TAB_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32786100900533995.4001)
,p_column_sequence=>3
,p_query_column_name=>'TAB_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32786226848533995.4001)
,p_column_sequence=>4
,p_query_column_name=>'TAB_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32786330009533995.4001)
,p_column_sequence=>5
,p_query_column_name=>'TAB_TARGET'
,p_display_as=>'TEXT'
,p_column_width=>40
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32786401210533995.4001)
,p_column_sequence=>6
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(32786518865533995.4001)
,p_column_sequence=>7
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36313406180556893.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48821014939974562.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188145406667102404.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48821014939974562.4001)
,p_button_name=>'P331_GO'
,p_button_static_id=>'P331_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32786908200534003.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48821014939974562.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32787828546534015.4001)
,p_branch_action=>'331'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 11-FEB-2003 14:24:40'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(188144726621098685.4001)
,p_name=>'P331_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48821014939974562.4001)
,p_prompt=>'Juego de Separadores Principales'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(TAB_SET) d, tab_set r ',
'  from WWV_FLOW_TOPLEVEL_TABS',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Juegos de Separadores -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el juego de separadores principales seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(32787417128534011.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(32785704230533968.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_TOPLEVEL_TABS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(32786908200534003.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_process_comment=>'Generated 11-FEB-2003 14:24:40'
);
end;
/
prompt --application/pages/page_00332
begin
wwv_flow_api.create_page(
 p_id=>332.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Nombre de Juego de Separadores Principales'
,p_step_title=>'Cambiar Nombre de Juego de Separadores Principales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32825430112636229.4001)
,p_plug_name=>'Cambiar Nombre de Juego de Separadores Principales'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32825826096636232.4001)
,p_plug_name=>'Juegos de Separadores Principales'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina permite cambiar el nombre de un juego de separadores existente. Un juego de separadores es una recopilaci\00F3n de separadores que aparecen juntos.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32826310509636240.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(32825430112636229.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32826606609636240.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(32825430112636229.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32827520364636251.4001)
,p_branch_action=>'333'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32826606609636240.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32826123070636238.4001)
,p_name=>'P332_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32825430112636229.4001)
,p_prompt=>'Juego de Separadores Principales para Cambiar Nombre'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(TAB_SET) d, tab_set r ',
'from WWV_FLOW_TOPLEVEL_TABS',
'where flow_id = :fb_flow_id ',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el juego de separadores que se va a cambiar de nombre.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32854432668663509.4001)
,p_name=>'P332_NEW_TAB_SET_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32825430112636229.4001)
,p_prompt=>'Nombre Nuevo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre para el nuevo juego de separadores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36261808567254780.4001)
,p_validation_name=>'P332_TABSET Not Null'
,p_validation_sequence=>10
,p_validation=>'P332_TABSET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el juego de separadores al que se va a cambiar el nombre.'
,p_associated_item=>wwv_flow_api.id(32826123070636238.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-FEB-2003 18:24'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36262007852254783.4001)
,p_validation_name=>'P332_NEW_TAB_SET_NAME Not Null'
,p_validation_sequence=>20
,p_validation=>'P332_NEW_TAB_SET_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nuevo nombre de juego de separadores.'
,p_associated_item=>wwv_flow_api.id(32854432668663509.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-FEB-2003 18:24'
);
end;
/
prompt --application/pages/page_00333
begin
wwv_flow_api.create_page(
 p_id=>333.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Nombre de Juego de Separadores Principales'
,p_step_title=>'Cambiar Nombre de Juego de Separadores Principales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32828122646636252.4001)
,p_plug_name=>'Confirmar Solicitud'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119585806625190518.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32829310850636256.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1119585806625190518.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Nombre de Juego de Separadores'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32829200050636256.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119585806625190518.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32829003846636256.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1119585806625190518.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32830715385636259.4001)
,p_branch_action=>'398'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32829310850636256.4001)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32830228699636258.4001)
,p_branch_action=>'332'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(32829200050636256.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36259009821245715.4001)
,p_name=>'P333_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32828122646636252.4001)
,p_prompt=>'Cambiar Nombre de Juego de Separadores Principales de:'
,p_source=>'P332_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre del juego de separadores principales anterior.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36260431292251898.4001)
,p_name=>'P333_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32828122646636252.4001)
,p_prompt=>'Cambiar Nombre de Juego de Separadores Principales a:'
,p_source=>'P332_NEW_TAB_SET_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica un nuevo nombre del juego de separadores principales.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(36269616626313916.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'rename tabset'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update WWV_FLOW_TOPLEVEL_TABS',
'set TAB_SET = :P332_NEW_TAB_SET_NAME',
'where flow_id = :fb_flow_id and',
'      tab_set = :P332_TABSET and',
'      security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_tabs',
'set TAB_PARENT_TABSET = :P332_NEW_TAB_SET_NAME',
'where flow_id = :fb_flow_id and',
'      TAB_PARENT_TABSET = :P332_TABSET and',
'      security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al actualizar el juego de separadores principales.'
,p_process_when_button_id=>wwv_flow_api.id(32829310850636256.4001)
,p_process_success_message=>'Juego de separadores principales actualizado.'
);
end;
/
prompt --application/pages/page_00336
begin
wwv_flow_api.create_page(
 p_id=>336.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Bloqueos'
,p_page_mode=>'MODAL'
,p_step_title=>'Historial de Bloqueos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_width=>'650'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(932326115686786179.4001)
,p_name=>'Historial de Bloqueos'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.action, lower(l.locked_by) locked_by, l.action_date, l.lock_comment',
'from wwv_flow_lock_script_log l',
'where l.flow_id = :fb_flow_id',
'and l.security_group_id = :flow_security_group_id',
'and l.script_id = :P336_LOCK_SCRIPT_ID',
'order by action_date desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn historial de bloqueos.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932326437746786184.4001)
,p_query_column_id=>1
,p_column_alias=>'ACTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(857850100888646856)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932326545567786185.4001)
,p_query_column_id=>2
,p_column_alias=>'LOCKED_BY'
,p_column_display_sequence=>2
,p_column_heading=>'Por'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932326676166786185.4001)
,p_query_column_id=>3
,p_column_alias=>'ACTION_DATE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Fecha de Acci\00F3n')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932326728746786185.4001)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Comentario de Bloqueo'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932327391138794119.4001)
,p_plug_name=>'wizard button'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932327676838796840.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(932327391138794119.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932327170924790782.4001)
,p_name=>'P336_LOCK_SCRIPT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(932326115686786179.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(932327958950799661.4001)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(932327676838796840.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(932328249590799663.4001)
,p_event_id=>wwv_flow_api.id(932327958950799661.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00337
begin
wwv_flow_api.create_page(
 p_id=>337.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Detalles de Bloqueo'
,p_page_mode=>'MODAL'
,p_step_title=>'Detalles de Bloqueo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213229021839834158)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_locks.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35038001734228620.4001)
,p_plug_name=>unistr('Editar Bloqueo de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P337_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(37642622063729156.4001)
,p_name=>'Historial de Bloqueos'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(action) action, lower(developer) developer, action_date, lock_comment',
'from wwv_flow_lock_page_log',
'where lock_flow = :fb_flow_id and',
'      lock_page = :fb_flow_page_id',
'order by action_date desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn historial de bloqueos de p\00E1gina')
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(37643229670729206.4001)
,p_query_column_id=>1
,p_column_alias=>'ACTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(37643314448729206.4001)
,p_query_column_id=>2
,p_column_alias=>'DEVELOPER'
,p_column_display_sequence=>2
,p_column_heading=>'Desarrollador'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(37643411172729206.4001)
,p_query_column_id=>3
,p_column_alias=>'ACTION_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Fecha'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(37643524595729206.4001)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Comentario de Bloqueo'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926587255728474692.4001)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926699198839954689.4001)
,p_plug_name=>'Editar Bloqueo'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059808656537457623.4001)
,p_plug_name=>'Edit Page Lock'
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P337_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35038817480228623.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(926587255728474692.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35039607193228627.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(926587255728474692.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Desbloquear'
,p_button_position=>'NEXT'
,p_button_condition=>'P337_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(41115600050764358.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(926587255728474692.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Bloquear P\00E1gina')
,p_button_position=>'NEXT'
,p_button_condition=>'P337_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(35039214984228626.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(926587255728474692.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P337_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(35044924947228653.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35040030743228629.4001)
,p_name=>'P337_LOCKED_BY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(35038001734228620.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario de Bloqueo:'
,p_source=>'LOCKED_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica el nombre del desarrollador del espacio de trabajo que tiene actualmente el bloqueo de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35041123473228633.4001)
,p_name=>'P337_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(35038001734228620.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35041517762228633.4001)
,p_name=>'P337_OBJECT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(35038001734228620.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'OBJECT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este bloqueo es para esta p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35042222546228635.4001)
,p_name=>'P337_LOCK_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(35038001734228620.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'LOCK_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Al igual que cualquier otro desarrollador de espacios de trabajo, como administrador de un espacio de trabajo puede editar comentarios de bloqueo personalmente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41133917112826111.4001)
,p_name=>'P337_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(35038001734228620.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1059808581493457622.4001)
,p_name=>'P337_NO_LOCK_DETAILS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1059808656537457623.4001)
,p_source=>'wwv_flow_lang.system_message(''F4000.P337.PAGE_UNLOCKED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P337_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35080423955498085.4001)
,p_validation_name=>'P337_LOCK_COMMENT'
,p_validation_sequence=>20
,p_validation=>'P337_LOCK_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(35042222546228635.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(41661607089787512.4001)
,p_validation_name=>'fb flow id must = object id'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :fb_flow_page_id = :P337_OBJECT_ID then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('S\00F3lo puede bloquear la p\00E1gina actual.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1059808321924457620.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(35038817480228623.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1059808403267457621.4001)
,p_event_id=>wwv_flow_api.id(1059808321924457620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35043326331228646.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P337_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_when=>'P337_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35043702582228647.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P337_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_LOCK_PAGE.'
,p_process_success_message=>unistr('Bloqueo de p\00E1gina procesado.')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35044120969228648.4001)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'330'
,p_process_when_button_id=>wwv_flow_api.id(35039607193228627.4001)
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00339
begin
wwv_flow_api.create_page(
 p_id=>339.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Suprimir Varias P\00E1ginas')
,p_step_title=>unistr('Suprimir Varias P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2822625211639047.4001)
,p_plug_name=>unistr('Suprimir P\00E1ginas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when l.locked_by is not null and l.locked_by != :APP_USER',
'            then '' ''',
'            else APEX_ITEM.CHECKBOX(1, ',
'                                    p.id,',
'                                    '''',',
'                                    null,',
'                                    '':'',',
'                                    ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''PAGE_LABEL'',name) ) ',
'            end cb,',
'       p.id,',
'       name page_name,',
'       STEP_TITLE page_title,',
'       ALIAS,',
'       (select count(*) ',
'          from wwv_flow_page_plugs r ',
'         where r.page_id = p.id and r.flow_id = p.flow_id) regions,',
'       decode(REQUIRED_PATCH,null,null,(select PATCH_NAME ',
'                                          from WWV_FLOW_PATCHES b',
'                                         where b.id = p.required_patch)) build_option,',
'       TAB_SET,',
'       PAGE_IS_PUBLIC_Y_N,',
'       lower(created_by) created_by,',
'       last_updated_on last_updated,',
'       lower(last_updated_by) last_updated_by,',
'       decode(GROUP_ID, null, null, (select GROUP_NAME ',
'                                       from WWV_FLOW_PAGE_GROUPS g',
'                                      where p.group_id = g.id)) page_group,',
'       p.user_interface_id,',
'       p.created_on,',
'       l.locked_by',
'  from wwv_flow_steps p,',
'       wwv_flow_lock_page l',
' where p.flow_id = :fb_flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.flow_id = l.flow_id (+)',
'   and p.id = l.object_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2822731905639047.4001)
,p_name=>'Delete Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2822922773639050.4001)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Suprimir'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823004949639051.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823102612639051.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823225230639051.4001)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('T\00EDtulo')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823312136639051.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823427832639051.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823528577639052.4001)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823610588639052.4001)
,p_db_column_name=>'TAB_SET'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Juego de Separadores'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823705384639052.4001)
,p_db_column_name=>'PAGE_IS_PUBLIC_Y_N'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('P\00E1gina P\00FAblica')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823824066639052.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2875015332766145.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>11
,p_column_identifier=>'N'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2823931544639052.4001)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2824030107639052.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2824113592639052.4001)
,p_db_column_name=>'PAGE_GROUP'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>unistr('Grupo de P\00E1ginas')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(25046606185745747.4001)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Bloqueado por'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(280298789054526830.4001)
,p_db_column_name=>'USER_INTERFACE_ID'
,p_display_order=>25
,p_column_identifier=>'P'
,p_column_label=>'Interfaz de Usuario'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_rpt_named_lov=>wwv_flow_api.id(5351212231959574)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25047605455792909.4001)
,p_plug_name=>unistr('Suprimir Varias P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Al suprimir una p\00E1gina, se suprimen los correspondientes separadores, rutas de navegaci\00F3n y entradas de lista. '),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48378308766932116.4001)
,p_plug_name=>'delete Multiple Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(48377323742917579.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2872713292718295.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2822625211639047.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Suprimir P\00E1ginas')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25058619859061965.4001)
,p_validation_name=>'must select something'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if apex_application.g_f01.count = 0',
'   then return false;',
'else return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos una p\00E1gina que suprimir.')
,p_when_button_pressed=>wwv_flow_api.id(2872713292718295.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2875307068792146.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'sys.htp.p(:flow_security_group_id);',
'   -- delete page',
'   delete from wwv_flow_steps',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and id = to_number(wwv_flow.g_f01(i));',
'',
'   -- tabs',
'   delete from wwv_flow_tabs',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and TAB_STEP = to_number(wwv_flow.g_f01(i));',
'',
'   -- menus (breadcrumbs)',
'   delete from WWV_FLOW_MENU_OPTIONS',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and page_id = to_number(wwv_flow.g_f01(i))',
'      and ALSO_CURRENT_FOR_PAGES is null;',
'',
'   -- list items',
'   delete from WWV_FLOW_LIST_ITEMS',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id ',
'      and LIST_ITEM_CURRENT_FOR_PAGES = wwv_flow.g_f01(i);',
'',
'   -- list item entries',
'   delete from WWV_FLOW_LIST_ITEMS',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id ',
'      and upper(LIST_ITEM_LINK_TARGET) like ''F?P=%:''||wwv_flow.g_f01(i)||'':%'';',
'',
'   -- locked page',
'   delete from wwv_flow_lock_page',
'    where security_group_id = :flow_security_group_id',
'      and flow_id = :fb_flow_id',
'      and object_id = to_number(wwv_flow.g_f01(i));',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2872713292718295.4001)
,p_process_success_message=>unistr('P\00E1ginas suprimidas.')
);
end;
/
prompt --application/pages/page_00340
begin
wwv_flow_api.create_page(
 p_id=>340.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Esquema de Autorizaci\00F3n por Componente')
,p_step_title=>unistr('Esquema de Autorizaci\00F3n por Componente')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19655204688204178.4001)
,p_plug_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Para que se represente un componente, \00E9ste debe pasar los esquemas de autorizaci\00F3n ubicados en el nivel del componente, en el nivel de la p\00E1gina y en el nivel de la aplicaci\00F3n. Este informe enumera todos los componentes de esta aplicaci\00F3n que pued')
||unistr('en tener un esquema de autorizaci\00F3n asociado.  </p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47956214199575140.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(180462022520306486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47956823651585341.4001)
,p_plug_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'id, ',
'name, ',
'component_type, ',
'decode(d.authorization_scheme,null,null,nvl((select name from WWV_FLOW_SECURITY_SCHEMES where security_group_id = :flow_security_group_id and to_char(id) = d.authorization_scheme),d.authorization_scheme) )',
'authorization_scheme',
' from ',
'(',
'-- regions',
'select ''WWV_FLOW_PAGE_PLUGS'' component_type,',
'i.page_id id,',
'i.plug_name name,',
'i.PLUG_REQUIRED_ROLE authorization_scheme',
' from WWV_FLOW_PAGE_PLUGS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.plug_required_role is not null',
'union all',
'',
'-- report column',
'select ''WWV_FLOW_REGION_REPORT_COLUMN'' component_type,',
'r.PAGE_ID id,',
'r.plug_name ||'' - ''||i.COLUMN_HEADING name,',
'i.REPORT_COLUMN_REQUIRED_ROLE authorization_scheme',
' from WWV_FLOW_REGION_REPORT_COLUMN i,',
'      wwv_flow_page_plugs r',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and r.id  =i.region_id',
'  and r.security_group_id = :flow_security_group_id',
'  and i.REPORT_COLUMN_REQUIRED_ROLE is not null',
'union all',
'',
'-- tabs',
'select ''WWV_FLOW_TABS'' component_type,',
'i.TAB_STEP id,',
'i.TAB_NAME||'' - ''||TAB_TEXT name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_TABS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- parent tabs',
'select ''WWV_FLOW_TOPLEVEL_TABS'' component_type,',
'null id,',
'i.TAB_NAME||'' - ''||TAB_TEXT name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_TOPLEVEL_TABS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- nav bar',
'select ''WWV_FLOW_ICON_BAR'' component_type,',
'null id,',
'i.ICON_SUBTEXT name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_ICON_BAR i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- breadcrumbs',
'select ''WWV_FLOW_MENU_OPTIONS'' component_type,',
'i.PAGE_ID id,',
'i.SHORT_NAME name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_MENU_OPTIONS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- list entries',
'select ''WWV_FLOW_LIST_ITEMS'' component_type,',
'null id,',
'i.LIST_ITEM_LINK_TEXT name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_LIST_ITEMS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- items',
'select ''WWV_FLOW_STEP_ITEMS'' component_type,',
'i.flow_step_id id,',
'i.name,',
'i.SECURITY_SCHEME authorization_scheme',
' from wwv_flow_step_items i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- dynamic actions (events)',
'select ''WWV_FLOW_PAGE_DA_EVENTS'' component_type,',
'       e.page_id id,',
'       e.name,',
'       e.security_scheme authorization_scheme',
' from wwv_flow_page_da_events e',
'where e.flow_id = :fb_flow_id',
'  and e.security_group_id = :flow_security_group_id',
'  and e.SECURITY_SCHEME is not null',
'union all',
'',
'-- dynamic actions (actions)',
'select ''WWV_FLOW_PAGE_DA_ACTIONS'' component_type,',
'       a.page_id id,',
'       case substr(a.action, 1, 7)',
'         when ''NATIVE_'' then',
'            ( select display_name from wwv_flow_plugins where flow_id = 4411 and plugin_type = ''DYNAMIC ACTION'' and name = substr(a.action, 8) )',
'         when ''PLUGIN_'' then',
'            ( select display_name from wwv_flow_plugins where flow_id = a.flow_id and plugin_type = ''DYNAMIC ACTION'' and name = substr(a.action, 8) )',
'         else a.action',
'       end,',
'       a.security_scheme authorization_scheme',
' from wwv_flow_page_da_actions a',
'where a.flow_id = :fb_flow_id',
'  and a.security_group_id = :flow_security_group_id',
'  and a.SECURITY_SCHEME is not null',
'union all',
'',
'-- validations',
'select ''WWV_FLOW_STEP_VALIDATIONS'' component_type,',
'i.flow_step_id id,',
'i.VALIDATION_NAME name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_STEP_VALIDATIONS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- branches',
'select ''WWV_FLOW_STEP_BRANCHES'' component_type,',
'i.flow_step_id id,',
'nvl(i.branch_name, i.branch_sequence || '' '' || substr(i.branch_action, 1, 30)) as name,',
'i.SECURITY_SCHEME authorization_scheme',
'from WWV_FLOW_STEP_BRANCHES i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'--app computations',
'select ''WWV_FLOW_COMPUTATIONS'' component_type,',
'null id,',
'COMPUTATION_ITEM name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_COMPUTATIONS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'--page computations',
'select ''WWV_FLOW_STEP_COMPUTATIONS'' component_type,',
'i.flow_step_id id,',
'i.COMPUTATION_ITEM name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_STEP_COMPUTATIONS i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'--app processing',
'select ''WWV_FLOW_PROCESSING'' component_type,',
'null id,',
'i.PROCESS_NAME name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_PROCESSING i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'--page processing',
'select ''WWV_FLOW_STEP_PROCESSING'' component_type,',
'i.flow_step_id id,',
'i.PROCESS_NAME name,',
'i.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_STEP_PROCESSING i',
'where i.flow_id = :fb_flow_id',
'  and i.security_group_id = :flow_security_group_id',
'  and i.SECURITY_SCHEME is not null',
'union all',
'',
'-- buttons',
'select ''WWV_FLOW_STEP_BUTTONS'' component_type,',
'b.flow_step_id id,',
'b.button_name name,',
'b.SECURITY_SCHEME authorization_scheme',
' from WWV_FLOW_STEP_BUTTONS b',
'where b.flow_id = :fb_flow_id',
'  and b.security_group_id = :flow_security_group_id',
'  and b.SECURITY_SCHEME is not null',
'union all',
'	',
'-- pages',
'select ',
'''WWV_FLOW_STEPS'' component_type,',
'p.id,',
'p.name,',
'p.required_role authorization_scheme',
' from WWV_FLOW_STEPS p',
'where p.flow_id = :fb_flow_ID',
'  and p.security_group_id = :flow_security_group_id',
'  and p.required_role is not null',
'',
') d'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47956924686585341.4001)
,p_name=>'Authorization Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47957110694585361.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47957317726585362.4001)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(19565023708932258)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47957222799585362.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47957402207585363.4001)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Esquema de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188932628265702323.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47956823651585341.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:340,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8595323225122429.4001)
,p_branch_action=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00342
begin
wwv_flow_api.create_page(
 p_id=>342.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Eliminar Bloqueo'
,p_page_mode=>'MODAL'
,p_step_title=>'Eliminar Bloqueo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932350705263198718.4001)
,p_plug_name=>'wizard button'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932375793685381903.4001)
,p_plug_name=>'Eliminar Bloqueo'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_query_num_rows=>15
,p_plug_header=>unistr('Se eliminar\00E1 el bloqueo del script actual bloqueado por el usuario.')
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932565913341402529.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(932350705263198718.4001)
,p_button_name=>'STEAL_LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Bloqueo'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(932350949723198724.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(932350705263198718.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932351794939198727.4001)
,p_name=>'P342_LOCK_SCRIPT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(932375793685381903.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932565068738394698.4001)
,p_name=>'P342_SCRIPT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(932375793685381903.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre del Script'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_install_scripts',
'where id = :P342_LOCK_SCRIPT_ID',
'and security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nombre del script que est\00E1 bloqueado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932565514419397753.4001)
,p_name=>'P342_LOCK_COMMENT'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(932375793685381903.4001)
,p_prompt=>'Comentario'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Comentario que se aplicar\00E1 al script bloqueado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932567340075442874.4001)
,p_name=>'P342_LOCKED_BY'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(932375793685381903.4001)
,p_prompt=>'Bloqueado por'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>'Nombre del desarrollador que tiene actualmente el bloqueo de script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(932569185718481227.4001)
,p_name=>'P342_LOCKED_ON'
,p_item_sequence=>37
,p_item_plug_id=>wwv_flow_api.id(932375793685381903.4001)
,p_prompt=>'Bloqueado el'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Fecha en la que se bloque\00F3 el script.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(932351990173198731.4001)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(932350949723198724.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(932352222213198732.4001)
,p_event_id=>wwv_flow_api.id(932351990173198731.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932671798447588997.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'steal lock'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.steal_lock(',
'    p_flow_id    => :FB_FLOW_ID,',
'    p_script_id  => :P342_LOCK_SCRIPT_ID,',
'    p_comment    => :P342_LOCK_COMMENT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido eliminar el bloqueo.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(932565913341402529.4001)
,p_process_success_message=>'Bloqueo eliminado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932842180489239150.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(932565913341402529.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(932568775173477906.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate script lock info items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select l.locked_by, l.locked_on',
'		   from wwv_flow_install_scripts s, wwv_flow_lock_script l',
'		   where s.id = l.script_id',
'		   and s.id = :P342_LOCK_SCRIPT_ID',
'		   and l.security_group_id = :flow_security_group_id',
'		   and l.flow_id = :fb_flow_id)',
'loop',
'	:P342_LOCKED_BY := lower(c1.locked_by);',
'	:P342_LOCKED_ON := htmldb_util.get_since(c1.locked_on);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00343
begin
wwv_flow_api.create_page(
 p_id=>343.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Informe: Identificar Tema'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47967601898952736.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152061404310867278.4001)
,p_plug_name=>'Crear Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152061821626867281.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152063003613867284.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47967601898952736.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152063714231867302.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47967601898952736.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152063409581867301.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47967601898952736.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152069131260867326.4001)
,p_branch_action=>'f?p=&FLOW_ID.:168:&SESSION.::&DEBUG.:168::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(152063714231867302.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589945853470621403.4001)
,p_branch_action=>'f?p=&APP_ID.:4321:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(152063409581867301.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152064114285867303.4001)
,p_name=>'P343_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152064828426867310.4001)
,p_name=>'P343_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'F4000_P4321_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152065502897867312.4001)
,p_name=>'P343_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152066227803867316.4001)
,p_name=>'P343_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152066927653867317.4001)
,p_name=>'P343_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152067608440867319.4001)
,p_name=>'P343_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P4321_COPY_FROM_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152068324244867320.4001)
,p_name=>'P343_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(152061404310867278.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2461600896483627038.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P343_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589945604536621401.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(152063003613867284.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589945733760621402.4001)
,p_event_id=>wwv_flow_api.id(589945604536621401.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00345
begin
wwv_flow_api.create_page(
 p_id=>345.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_step_title=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(28924624104410484.4001)
,p_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>121
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="''',
'    ||apex_util.prepare_url(''f?p=4000:346:''||:flow_session||''::NO:346:P346_OLD_TABSET:''||wwv_flow_escape.html(tab_set))',
'    ||''">''||wwv_flow_escape.html(tab_set)||''</a>'' l, ',
'count(*) c ',
'from wwv_flow_tabs ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'group by tab_set'))
,p_header=>'Haga clic en el nombre de juego de separadores que desea cambiar.<p/>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image=>'blue_arrow_up.gif'
,p_query_desc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48737113649771899.4001)
,p_query_column_id=>1
,p_column_alias=>'L'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48737212044771899.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Recuento de Separadores'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28926011768416383.4001)
,p_plug_name=>'Juegos de Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los separadores se agrupan en recopilaciones denominadas <strong>juego de separadores</strong>. Cada separador debe formar parte de un juego de separadores. Un separador puede tener una relaci\00F3n uno a uno con una p\00E1gina o puede ser el "separador a')
||unistr('ctual" para un n\00FAmero de p\00E1ginas.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28948631124469361.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(28924624104410484.4001)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00346
begin
wwv_flow_api.create_page(
 p_id=>346.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_step_title=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28952122943476371.4001)
,p_plug_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>121
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(29054424365129702.4001)
,p_name=>'Separadores que Incluyen el Juego de Separadores "&P346_OLD_TABSET."'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'TAB_SEQUENCE, ',
'TAB_TEXT, ',
'TAB_STEP page, ',
'replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tab_also_current_for_pages',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'and tab_set = :P346_OLD_TABSET',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image=>'blue_arrow_up.gif'
,p_query_desc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48961005426773306.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48961114580773306.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48961228348773306.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48961315681773306.4001)
,p_query_column_id=>4
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29072409708267400.4001)
,p_plug_name=>'Nombres de Juego de Separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Introduzca un nuevo nombre de juego de separadores y haga clic en <strong>Siguiente</strong> para confirmar la solicitud.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46527430261626586.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747140977892138160.4001)
,p_plug_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28954419611484907.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46527430261626586.4001)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28954900123484909.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46527430261626586.4001)
,p_button_name=>'next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28954620319484908.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46527430261626586.4001)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29104828296414680.4001)
,p_branch_action=>'347'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(28954900123484909.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29104022409413021.4001)
,p_branch_action=>'345'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(28954620319484908.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28956531039488244.4001)
,p_name=>'P346_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28952122943476371.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28957516279493452.4001)
,p_name=>'P346_OLD_TABSET'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(28952122943476371.4001)
,p_prompt=>'Nombre Antiguo de Juego de Separadores:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica el nombre del antiguo juego de separadores seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28958600134498243.4001)
,p_name=>'P346_NEW_TABSET_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(28952122943476371.4001)
,p_prompt=>'Nuevo Nombre de Juego de Separadores'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifique el juego de separadores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(29073514210268748.4001)
,p_validation_name=>'P346_NEW_TABSET_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'P346_NEW_TABSET_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nuevo nombre de juego de separadores.'
,p_associated_item=>wwv_flow_api.id(28958600134498243.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-FEB-2003 12:13'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(29419209864254529.4001)
,p_validation_name=>'tabset not used'
,p_validation_sequence=>10
,p_validation=>'select 1 from wwv_flow_tabs where tab_set = :P346_NEW_TABSET_NAME and flow_id = :FB_FLOW_ID'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'El nombre del juego de separadores ya se ha utilizado en otro juego.'
,p_associated_item=>wwv_flow_api.id(28958600134498243.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00347
begin
wwv_flow_api.create_page(
 p_id=>347.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Confirmar Cambio de Nombre de Juego de Separadores'
,p_step_title=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29076009146276765.4001)
,p_plug_name=>unistr('Cambiar Nombre de Juego de Separadores Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ha solicitado el cambio de nombre de un juego de separadores est\00E1ndar. Confirme la solicitud.</p>'),
'<table class="htmldbStandard3" cellspacing="0" cellpadding="0" border="0" role="presentation">',
'<tr>',
'<td >Nombre de Juego de Separadores Antiguo:</td>',
'<td class="htmldbFDB">&P346_OLD_TABSET.</td>',
'</tr>',
'<tr>',
'<td>Nuevo Nombre de Juego de Separadores:</td>',
'<td class="htmldbFDB">&P346_NEW_TABSET_NAME.</td>',
'</tr>',
'</table>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119585903260190519.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29078114376282475.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1119585903260190519.4001)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29077804149282474.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119585903260190519.4001)
,p_button_name=>'confirm'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Nombre de Juego de Separadores'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29077629232282473.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1119585903260190519.4001)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29106108341418454.4001)
,p_branch_action=>'346'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(29077629232282473.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29106716306420743.4001)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29431514282274684.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.rename_tabset(',
'  p_flow_id=>:FB_FLOW_ID,',
'  p_old_name=>:P346_OLD_TABSET,',
'  p_new_name=>:P346_NEW_TABSET_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar el nombre del juego de separadores.'
,p_process_when_button_id=>wwv_flow_api.id(29077804149282474.4001)
,p_process_success_message=>'Nombre de juego de separadores cambiado.'
);
end;
/
prompt --application/pages/page_00348
begin
wwv_flow_api.create_page(
 p_id=>348.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Etiqueta')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Etiqueta')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162623100482486503.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>21
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(162626213988490450.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>41
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id||'': ''||name temp_name ',
'  from wwv_flow_step_items ',
' where flow_id = :fb_flow_id ',
'   and ITEM_FIELD_TEMPLATE = :p348_id ',
' union all ',
'select ''0: Default Label Template'' temp_name',
'  from wwv_flow_themes ',
' where flow_id  = :fb_flow_id ',
'   and theme_id = :fb_theme_id',
'   and default_label_template = :p348_id ',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164886307417632028.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Plantilla'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(769836733955508001.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(769836800315508002.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>51
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164899914437690879.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(769836800315508002.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164900619631692344.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(769836800315508002.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164901431059695672.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162649201830534289.4001)
,p_name=>'P348_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(162623100482486503.4001)
,p_prompt=>'Plantilla:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'FIELDTEMPLATE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where  flow_id = :fb_flow_id and ',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162651009102536345.4001)
,p_name=>'P348_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(162623100482486503.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'select theme_id from wwv_flow_field_templates where id = :p348_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162652519145539216.4001)
,p_name=>'P348_THEME_CLASS_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(162623100482486503.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Tema:'
,p_source=>'select theme_class_id from wwv_flow_field_templates where id = :p348_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LABEL THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43828319065855502.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la clase de tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(164887221616636134.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_field_templates where id = :p348_id'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164897029543685712.4001)
,p_validation_name=>'no references '
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in ( select count(*) counter from ',
'(select name||'' - Page ''||flow_step_id temp_name ',
'from wwv_flow_step_items ',
'where flow_id = :fb_flow_id ',
'and ITEM_FIELD_TEMPLATE = :p348_id ',
'union all ',
'select ''Default Label Template'' temp_name from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_label_template = :p348_id ',
'and theme_id = :fb_theme_id)) loop',
'if c1.counter = 0 then',
'   return true;',
'else',
'   return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'No puede suprimir una plantilla con referencias.'
,p_when_button_pressed=>wwv_flow_api.id(164900619631692344.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164914704010735174.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_field_templates where flow_id = :fb_flow_id and id = :p348_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Plantilla no suprimida.'
,p_process_when_button_id=>wwv_flow_api.id(164900619631692344.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00349
begin
wwv_flow_api.create_page(
 p_id=>349.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Calendario Heredado: Nombre'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Calendario Heredado'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112084125371301165.4001)
,p_plug_name=>'Crear Plantilla de Calendario Heredado'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112084909639301168.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186390426401328828.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112085307015301169.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186390426401328828.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112085703039301171.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186390426401328828.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112086122923301172.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186390426401328828.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112089421043301187.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589887780574923022.4001)
,p_branch_action=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(112086122923301172.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112086513801301173.4001)
,p_name=>'P349_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(112084125371301165.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre de la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112086918113301177.4001)
,p_name=>'P349_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(112084125371301165.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112087327103301179.4001)
,p_name=>'P349_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(112084125371301165.4001)
,p_prompt=>'Clase de Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la clase de tema de plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112087809540301181.4001)
,p_validation_name=>'P349_NAME'
,p_validation_sequence=>10
,p_validation=>'P349_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(112085703039301171.4001)
,p_associated_item=>wwv_flow_api.id(112086513801301173.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112088232480301182.4001)
,p_validation_name=>'P349_THEME'
,p_validation_sequence=>20
,p_validation=>'P349_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(112085703039301171.4001)
,p_associated_item=>wwv_flow_api.id(112086918113301177.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112088601399301183.4001)
,p_validation_name=>'P349_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P349_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(112085703039301171.4001)
,p_associated_item=>wwv_flow_api.id(112087327103301179.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589887578559923020.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112085307015301169.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589887685585923021.4001)
,p_event_id=>wwv_flow_api.id(589887578559923020.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(112089032197301185.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Calendar Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_calendar_template (',
'    p_flow_id                     => :fb_flow_id,',
'    p_cal_template_name           => :p349_name,',
'    p_month_title_format          => ''<table cellspacing="0" cellpadding="0" border="0" role="presentation">',
' <tr>',
'   <td align="center" style="font-weight:bold;">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'',',
'    p_day_of_week_format          => ''<th>#IDAY#</th>'',',
'    p_month_open_format           => ''<table border="1" cellpadding="1" cellspacing="1" role="presentation">'',',
'    p_month_close_format          => ''</table></td>',
'</tr>',
'</table>',
''',',
'    p_day_title_format            => ''<div>#DD#</div><br />'',',
'    p_day_open_format             => ''<td valign="top">'',',
'    p_day_close_format            => ''</td>'',',
'    p_today_open_format           => ''<td valign="top" bgcolor="#d3d3d3">'',',
'    p_weekend_title_format        => ''<div>#DD#</div>'',',
'    p_weekend_open_format         => ''<td valign="top">'',',
'    p_weekend_close_format        => ''</td>'',',
'    p_nonday_title_format         => ''<div>#DD#</div>'',',
'    p_nonday_open_format          => ''<td valign="top">'',',
'    p_nonday_close_format         => ''</td>'',',
'    p_week_title_format           => null,',
'    p_week_open_format            => ''<tr>'',',
'    p_week_close_format           => ''</tr> '',',
'    p_daily_title_format          => null,',
'    p_daily_open_format           => null,',
'    p_daily_close_format          => null,',
'    p_theme_id                    => :p349_theme,',
'    p_theme_class_id              => :p349_theme_class);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha creado la plantilla.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(112085703039301171.4001)
,p_process_success_message=>'Plantilla creada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(589887808317923023.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(112085703039301171.4001)
,p_process_success_message=>'Plantilla creada.'
);
end;
/
prompt --application/pages/page_00350
begin
wwv_flow_api.create_page(
 p_id=>350.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla Emergente'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla Emergente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112117729525395900.4001)
,p_plug_name=>'Crear Plantilla Emergente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112118503768395902.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186391328264338847.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112118900917395903.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186391328264338847.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112119332194395906.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186391328264338847.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112119716966395907.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186391328264338847.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112123024179395925.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589888185156923026.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(112119716966395907.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112120124710395909.4001)
,p_name=>'P350_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(112117729525395900.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre de la plantilla emergente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112120507529395912.4001)
,p_name=>'P350_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(112117729525395900.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema de la plantilla emergente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112120911351395914.4001)
,p_name=>'P350_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(112117729525395900.4001)
,p_prompt=>'Clase de Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'POPUP LOV TEMPLATE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(59418530750879398.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la clase de tema de la plantilla emergente.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112121424680395916.4001)
,p_validation_name=>'P350_NAME'
,p_validation_sequence=>10
,p_validation=>'P350_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(112119332194395906.4001)
,p_associated_item=>wwv_flow_api.id(112120124710395909.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112121800199395918.4001)
,p_validation_name=>'P350_THEME'
,p_validation_sequence=>20
,p_validation=>'P350_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(112119332194395906.4001)
,p_associated_item=>wwv_flow_api.id(112120507529395912.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112122208090395919.4001)
,p_validation_name=>'P350_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P350_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(112119332194395906.4001)
,p_associated_item=>wwv_flow_api.id(112120911351395914.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(112145520914535226.4001)
,p_validation_name=>'no popups in selected theme'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in ( select count(*) counter from wwv_flow_popup_lov_template where flow_id = :fb_flow_id and theme_id = :p350_theme) loop',
'  if c1.counter = 0 then ',
'    return true;',
'  else ',
'    return false;',
'  end if;',
'end loop;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ya existe la lista de valores emergente. S\00F3lo est\00E1 soportada una lista emergente por tema.')
,p_when_button_pressed=>wwv_flow_api.id(112119332194395906.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589887936779923024.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112118900917395903.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589888085734923025.4001)
,p_event_id=>wwv_flow_api.id(589887936779923024.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(112122628763395922.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Popup Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_popup_lov_template (',
'    p_flow_id            => :fb_flow_id,',
'    p_popup_icon         => null,',
'    p_popup_icon_attr    => null,',
'    p_page_name          => :p350_name,',
'    p_page_title         => null,',
'    p_page_html_head     => null,',
'    p_page_body_attr     => null,',
'    p_before_field_text  => null,',
'    p_page_heading_text  => null,',
'    p_page_footer_text   => null,',
'    p_filter_width       => null,',
'    p_filter_max_width   => null,',
'    p_filter_text_attr   => null,',
'    p_find_button_text   => null,',
'    p_find_button_image  => null,',
'    p_find_button_attr   => null,',
'    p_close_button_text  => null,',
'    p_close_button_image => null,',
'    p_close_button_attr  => null,',
'    p_next_button_text   => null,',
'    p_next_button_image  => null,',
'    p_next_button_attr   => null,',
'    p_prev_button_text   => null,',
'    p_prev_button_image  => null,',
'    p_prev_button_attr   => null,',
'    p_after_field_text   => null,',
'    p_scrollbars         => null,',
'    p_resizable          => null,',
'    p_width              => null,',
'    p_height             => null,',
'    p_result_row_x_of_y  => null,',
'    p_result_rows_per_pg => null,',
'    p_before_result_set  => null,',
'    p_after_result_set   => null,',
'    p_when_no_data_found_message     => null,',
'    p_before_first_fetch_message     => null,',
'    p_minimum_characters_required    => null,',
'    p_theme_id                  => :p350_theme,',
'    p_theme_class_id            => :p350_theme_class);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha creado la plantilla.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(112119332194395906.4001)
,p_process_success_message=>'Plantilla creada.'
);
end;
/
prompt --application/pages/page_00353
begin
wwv_flow_api.create_page(
 p_id=>353.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Etiqueta: Identificar Tema'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Etiqueta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46355104431236089.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152070700912872033.4001)
,p_plug_name=>'Crear Plantilla de Etiqueta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152071105573872034.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152072315034872037.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46355104431236089.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152073121403872040.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46355104431236089.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152072729986872040.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46355104431236089.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152078529763872051.4001)
,p_branch_action=>'f?p=&FLOW_ID.:657:&SESSION.::&DEBUG.:657::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(152073121403872040.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589889170720923036.4001)
,p_branch_action=>'f?p=&APP_ID.:655:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(152072729986872040.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152073513592872041.4001)
,p_name=>'P353_X'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152074200119872043.4001)
,p_name=>'P353_FROM_APP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'P655_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152074912195872044.4001)
,p_name=>'P353_COPY_TO'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152075624688872045.4001)
,p_name=>'P353_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152076301888872047.4001)
,p_name=>'P353_TO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152077001397872048.4001)
,p_name=>'P353_COPY_FROM_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P655_COPY_FROM_FLOW_ID ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152077702339872049.4001)
,p_name=>'P353_COPY_TO_THEME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(152070700912872033.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2346316259628914202.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P353_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589888980609923034.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(152072315034872037.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589889028682923035.4001)
,p_event_id=>wwv_flow_api.id(589888980609923034.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00358
begin
wwv_flow_api.create_page(
 p_id=>358.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Cambios'
,p_step_title=>'Historial de Cambios'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47877909964995803.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(7285601119000778.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47878526316995807.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47878927519995809.4001)
,p_plug_name=>'Historial de Cambios'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select   page_id,',
'         decode(audit_action,',
'         ''U'',wwv_flow_lang.system_message(''F4350.CHANGE''),',
'         ''I'',wwv_flow_lang.system_message(''F4350.CREATE''),',
'         ''D'',wwv_flow_lang.system_message(''F4350.DELETE''),',
'         audit_action) audit_action,',
'         developer,',
'         component_type,',
'         nvl(component_name,',
'             wwv_flow_lang.system_message(''F4350.UNKNOWN'')) as component_name,',
'         audit_date,',
'         audit_date date_of_action',
'from',
'(',
'select ',
'  page_id,',
'  audit_date,',
'  audit_action,',
'  t.flow_user developer,',
'  initcap(',
'  replace(replace(replace(replace(replace(replace(replace(replace(replace(',
'  replace(replace(replace(replace(t.flow_table,',
'     ''LIST_ITEMS'',''List Entry''),',
'     ''WWV_FLOWS'',''Application''),',
'     ''WWV_FLOW_'',null),''_'','' ''),',
'     ''FLOW'',''Application''),',
'     ''SECURITY SCHEMES'',''Authorization Scheme''),',
'     ''LOAD TABLES'',''Data Loading''),',
'     ''PLUGINS'',''Plug-in''),',
'     ''STEP'',''Page''),',
'     ''PLUG'',''Region''),',
'     ''OPTION'',''Entry''),',
'     ''MESSAGES$'',''Text Message''),',
'     ''MENU'',''Breadcrumb'')',
'  ) component_type,',
'  t.object_name as component_name',
'from   ',
'  wwv_flow_builder_audit_trail t',
'where  ',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_id = :fb_flow_id and',
'  t.audit_date >= (sysdate - nvl(:P358_SINCE,1))',
'  ) q'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47879115102995816.4001)
,p_name=>'Recent Changes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se han encontrado cambios.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47879627654995835.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47879213576995831.4001)
,p_db_column_name=>'AUDIT_ACTION'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Acci\00F3n de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47879311218995834.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47879430841995834.4001)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47879516483995835.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47921427032680100.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(506148920133198539.4001)
,p_db_column_name=>'DATE_OF_ACTION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Fecha de Acci\00F3n')
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(47920714781667090.4001)
,p_name=>unistr('Filtrar por<br/>P\00E1ginas Editadas Recientemente')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna p\00E1gina.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47920905426667092.4001)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:358:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,IR_PAGE_ID:&FB_FLOW_ID.,#ID#,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(47921008570667093.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(445327224438602721.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47878526316995807.4001)
,p_button_name=>'P358_GO'
,p_button_static_id=>'P358_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(445325411840589586.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47878927519995809.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:358,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47881008850995877.4001)
,p_branch_action=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47880019007995847.4001)
,p_name=>'P358_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(47878526316995807.4001)
,p_item_default=>'1'
,p_prompt=>'Desde'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME STATIC'
,p_lov=>'.'||wwv_flow_api.id(94747000503182513.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Limite el informe a un marco temporal espec\00EDfico. Identifique la cantidad de tiempo que desea incluir en el informe y haga clic en Definir. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00364
begin
wwv_flow_api.create_page(
 p_id=>364.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Componente de Aplicaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Componente de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_wiz.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40391916445401575.4001)
,p_plug_name=>'Crear Control Compartido'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200340401633169901.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40392532375406171.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200340401633169901.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40393019858406178.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200340401633169901.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40403406542483929.4001)
,p_branch_name=>'Create List of Values'
,p_branch_action=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:4004,4007,4014,137,138,139::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'LOV'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40403711044485219.4001)
,p_branch_name=>'Create Standard Tab'
,p_branch_action=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:92,94,95,96,4722,4723,4724::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'STAB'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40404014507486166.4001)
,p_branch_name=>'Create Parent Tab'
,p_branch_action=>'f?p=&APP_ID.:4725:&SESSION.::&DEBUG.:4725,4726,4727::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'PTAB'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40405301132491820.4001)
,p_branch_name=>'Create List'
,p_branch_action=>'f?p=&APP_ID.:4051:&SESSION.::&DEBUG.:4051::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'LIST'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40405605634493071.4001)
,p_branch_action=>'f?p=4000:4050:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'LIST_ITEM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40405910136494395.4001)
,p_branch_name=>'Create Breadcrumb'
,p_branch_action=>'f?p=&APP_ID.:288:&SESSION.::&DEBUG.:288::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'MENU'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40406216024496121.4001)
,p_branch_action=>'f?p=4000:287:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'MENU_ITEM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40406827798499548.4001)
,p_branch_action=>'f?p=4000:196:&SESSION.::NO:196'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'WEB_SERVICE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40407100571501159.4001)
,p_branch_action=>'f?p=4000:4003:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40407404380502220.4001)
,p_branch_name=>'Create Build Option'
,p_branch_action=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:4911::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'BUILD_OPT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40407709228503566.4001)
,p_branch_action=>'f?p=4000:4070:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'SECURITY'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40419102181567825.4001)
,p_branch_name=>'Create Navigation Bar Entry'
,p_branch_action=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:22,4023,4024,4025,134,135::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'NAVBAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40423327030593952.4001)
,p_branch_action=>'f?p=4000:4001:&SESSION.::NO:4001:FB_FLOW_ID:&FB_FLOW_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>170
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'FLOW'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155875498680661301.4001)
,p_branch_name=>'Create Web Service Reference'
,p_branch_action=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:565,580,585,870,871,872,873,875,REST_INPUT_PARMS,REST_OUTPUT_PARMS,REST_HTTP_HEADERS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>180
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'WS_REF'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155876013176715575.4001)
,p_branch_name=>'Create Report Query'
,p_branch_action=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:1110,1112,1113,1114,1115,1116,1117,1118,1119::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>190
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'REP_QRY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155876934469728602.4001)
,p_branch_name=>'Create Report Layout'
,p_branch_action=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:1401,1402,1406::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>200
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'REP_LAYOUT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155877516882738683.4001)
,p_branch_name=>'Create Shortcut'
,p_branch_action=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:131::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>210
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'SHORTCUT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155878629703759808.4001)
,p_branch_name=>'Create Authorization Scheme'
,p_branch_action=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:184,185,186,188::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>220
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'AUTH_SCHEME'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155879496164775394.4001)
,p_branch_name=>'Create Text Message'
,p_branch_action=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:4009:F4000_P4009_MESSAGE_LANGUAGE:&F4000_P4009_MESSAGE_LANGUAGE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>230
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'TEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155880114405787283.4001)
,p_branch_name=>'Create Application Process'
,p_branch_action=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:147,148,150::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>240
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_PROCESS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155880907737803532.4001)
,p_branch_name=>'Create Static Application File'
,p_branch_action=>'f?p=&APP_ID.:271:&SESSION.::&DEBUG.:271::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>250
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_FILE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155881526440811728.4001)
,p_branch_name=>'Create Static Workspace File'
,p_branch_action=>'f?p=&APP_ID.:314:&SESSION.::&DEBUG.:314::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>260
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'WS_FILE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155882191992821901.4001)
,p_branch_name=>'Create Application Item'
,p_branch_action=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:4303::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>270
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_ITEM'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155882661515833036.4001)
,p_branch_name=>'Create Application Computation'
,p_branch_action=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:4304::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>280
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_COMPUTATION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155884294231888804.4001)
,p_branch_name=>'Create Authentication Scheme'
,p_branch_action=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:815, 4495::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>290
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'AUTHENTICATION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155885383447906538.4001)
,p_branch_name=>'Create Template'
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.:162::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>300
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'TEMPLATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1155885885009914156.4001)
,p_branch_name=>'Create Plug-in'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40393019858406178.4001)
,p_branch_sequence=>310
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40397631944425047.4001)
,p_name=>'P364_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40391916445401575.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40399023680450979.4001)
,p_name=>'P364_NEW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(40391916445401575.4001)
,p_item_default=>'LOV'
,p_prompt=>unistr('Cree un componente compartido para su inclusi\00F3n posterior en una p\00E1gina:')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NEW.FLOW.COMPONENT'
,p_lov=>'.'||wwv_flow_api.id(56261603527740250.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el tipo de componente compartido que desea crear. Los componentes compartidos son elementos comunes que se pueden mostrar o aplicar en cualquier p\00E1gina dentro de una aplicaci\00F3n.<p/><p/>'),
unistr('Los temas soportan separadores o listas de men\00FAs de navegaci\00F3n tradicionales. Las opciones Separador Principal y Separador Est\00E1ndar solo se deben utilizar cuando el tema soporte separadores tradicionales.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574040091444616931.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(40392532375406171.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574040150168616932.4001)
,p_event_id=>wwv_flow_api.id(574040091444616931.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00365
begin
wwv_flow_api.create_page(
 p_id=>365.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Informe de Uso de Ruta de Navegaci\00F3n')
,p_step_title=>unistr('Uso de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30202228732481190.4001)
,p_plug_name=>unistr('Informe de Uso de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4000P365a */',
'       p.page_id,',
'       s.name,',
'       p.plug_name,',
'       mo.short_name,',
'       m.name menu_name,',
'       (select short_name from wwv_flow_menu_options where id = mo.parent_id) moparent',
'  from wwv_flow_menus m',
'  join wwv_flow_page_plugs p on (p.menu_id = m.id)',
'  join wwv_flow_steps s      on (s.id = p.page_id)',
'  left outer join wwv_flow_menu_options mo on (mo.menu_id = m.id and mo.page_id = p.page_id)',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and s.flow_id           = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30202319058481190.4001)
,p_name=>'Breadcrumb Utilization Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30202625787481195.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30202703816481196.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Nombre de la Regi\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30202801547481196.4001)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30202924453481196.4001)
,p_db_column_name=>'MENU_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Nombre de Ruta de Navegaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2426900916300703.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>16
,p_column_identifier=>'H'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2428614102300720.4001)
,p_db_column_name=>'MOPARENT'
,p_display_order=>26
,p_column_identifier=>'I'
,p_column_label=>'Entrada Principal'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111621129766609422.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(111619820846587947.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(166963705763992521.4001)
,p_name=>unistr('Entradas de Ruta de Navegaci\00F3n Hu\00E9rfanas')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--flush:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.flow_id,',
'       m.SHORT_NAME option_name,',
'       (select name',
'          from wwv_flow_menus m1',
'         where m1.id = menu_id',
'           and m1.security_group_id = m.security_group_id ) menu_name,',
'       page_id,',
'       menu_id',
'  from wwv_flow_menu_options m',
' where m.flow_id = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists ( select 1',
'                      from wwv_flow_steps',
'                     where flow_id = m.flow_id',
'                       and security_group_id = m.security_group_id',
'                       and m.page_id = id )'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167056300316047754.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166969521263015919.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Flow Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166964216142992544.4001)
,p_query_column_id=>3
,p_column_alias=>'OPTION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Entrada de Ruta de Navegaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_ID,P104_MENU_ID:#ID#,#MENU_ID#'
,p_column_linktext=>'#OPTION_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2427005748300704.4001)
,p_query_column_id=>4
,p_column_alias=>'MENU_NAME'
,p_column_display_sequence=>14
,p_column_heading=>unistr('Nombre de Ruta de Navegaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166964404169992544.4001)
,p_query_column_id=>5
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2427103947300705.4001)
,p_query_column_id=>6
,p_column_alias=>'MENU_ID'
,p_column_display_sequence=>24
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8473756637051443.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(166963705763992521.4001)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir no utilizados'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_options m',
' where m.flow_id = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists ( select 1',
'                      from wwv_flow_steps',
'                     where flow_id = m.flow_id',
'                       and security_group_id = m.security_group_id',
'                       and m.page_id = id )'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188946425746344946.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30202228732481190.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:365:&SESSION.::&DEBUG.:365,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5385086238661972.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'365'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(8473880983051444.4001)
,p_name=>'Delete Unused'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(8473756637051443.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8473965569051445.4001)
,p_event_id=>wwv_flow_api.id(8473880983051444.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFDesea suprimir todas estas entradas de ruta de navegaci\00F3n asociadas a p\00E1ginas suprimidas? Confirme.')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8474001731051446.4001)
,p_event_id=>wwv_flow_api.id(8473880983051444.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8474164479051447.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Unused Breadcrumb Entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_menu_options m',
' where m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists ( select null',
'                      from wwv_flow_steps s',
'                      where s.flow_id           = m.flow_id',
'                        and s.security_group_id = m.security_group_id',
'                        and s.id                = m.page_id ); '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(8473756637051443.4001)
,p_process_success_message=>unistr('Se han suprimido las entradas de ruta de navegaci\00F3n no utilizadas.')
);
end;
/
prompt --application/pages/page_00368
begin
wwv_flow_api.create_page(
 p_id=>368.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Plantillas'
,p_step_title=>'Historial de Plantillas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_rpts.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7437102705390898.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193152223636410658.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a component_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''PAGE_TEMPLATE'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TEMPLATES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a component_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''CONFIRM.REGION_TEMPLATE'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PAGE_PLUG_TEMPLATES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193152421858410659.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193152526530410660.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193152625839410660.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193152711986410661.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193152829291410662.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193152917690410663.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193153022439410664.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193153103626410664.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193169722083447990.4001)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193153618573418570.4001)
,p_plug_name=>'Historial de Plantillas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las plantillas de p\00E1gina y regi\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188986230825938608.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193152223636410658.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:368:&SESSION.::&DEBUG.:368,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7430130922340368.4001)
,p_branch_action=>'368'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00369
begin
wwv_flow_api.create_page(
 p_id=>369.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cambios Recientes de Ruta de Navegaci\00F3n')
,p_step_title=>unistr('Historial de Rutas de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111621726780618003.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(111619820846587947.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180643301348622009.4001)
,p_plug_name=>unistr('Historial de Rutas de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las entradas de ruta de navegaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193060126557222274.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P369a */',
'       t.flow_user developer, ',
'       t.audit_date,',
'       decode(audit_action,',
'              ''I'',i.a,',
'              ''D'',d.a,',
'              u.a) action,',
'       scn,',
'       audit_comment,',
'       flow_table_pk component_key,',
'       t.object_name component_name',
'  from wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
' where t.flow_ID = :FB_FLOW_ID',
'   and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_table = ''WWV_FLOW_MENU_OPTIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193060302178222275.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193060428832222275.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193060516918222276.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193060628953222277.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193060728409222278.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193060803592222279.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193060916167222279.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193061017034222280.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188946915488351368.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193060126557222274.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:369:&SESSION.::&DEBUG.:369,RIR::'
);
end;
/
prompt --application/pages/page_00376
begin
wwv_flow_api.create_page(
 p_id=>376.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Validaci\00F3n')
,p_step_title=>unistr('Validaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(976423384825139.4001)
,p_plug_name=>unistr('Validaci\00F3n: &P376_N.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(986905901847659.4001)
,p_plug_name=>unistr('Validaci\00F3n')
,p_region_name=>'VALIDATION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(987613866849996.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'CONDITIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3171516384488337.4001)
,p_plug_name=>'Validaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice validaciones para asegurarse de que los objetos de base de datos y los datos iniciales de la aplicaci\00F3n se pueden instalar correctamente.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12988913910652688.4001)
,p_plug_name=>'Mensaje de Error'
,p_region_name=>'ERR_MSG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>145
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46233719413678959.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>15
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(976925448825141.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(976801086825140.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P376_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(976706324825140.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P376_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(976626664825140.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P376_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(977523846825147.4001)
,p_branch_action=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(977727157825157.4001)
,p_name=>'P376_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(977901211825165.4001)
,p_name=>'P376_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(978308341825170.4001)
,p_name=>'P376_INSTALL_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'INSTALL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(978714542825171.4001)
,p_name=>'P376_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique un nombre para esta validaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(979108013825172.4001)
,p_name=>'P376_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(trunc(max(sequence)), 0) + 10 s',
'             from wwv_flow_install_checks ',
'            where flow_id = :FB_FLOW_ID',
'              and security_group_id = :flow_security_group_id)',
'loop',
'  return c1.s;',
'end loop;',
'return 10;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Secuencia'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para esta validaci\00F3n. El n\00FAmero de secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(979505692825173.4001)
,p_name=>'P376_CHECK_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo'
,p_source=>'CHECK_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'INSTALL_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2610902469203915.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Validaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista que se debe cumplir durante la instalaci\00F3n para que se ejecuten los archivos de comandos de instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P376_CHECK_CONDITION'
,p_attribute_02=>'P376_CHECK_CONDITION2'
,p_attribute_04=>'P376_CHECK_CHECK'
,p_attribute_06=>'INSTALL'
,p_attribute_07=>'P376_CHECK_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(979707658825177.4001)
,p_name=>'P376_CHECK_CONDITION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'CHECK_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice este atributo para controlar de forma condicional si la instalaci\00F3n puede continuar. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se ejecutar\00E1n los arc')
||unistr('hivos de comandos de instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(979920347825178.4001)
,p_name=>'P376_CHECK_CONDITION2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'CHECK_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(980330757825179.4001)
,p_name=>'P376_FAILURE_MESSAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(12988913910652688.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mensaje de Error'
,p_source=>'FAILURE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 cuando no se cumplan las condiciones de esta validaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(980505425825179.4001)
,p_name=>'P376_CONDITION_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(987613866849996.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'INSTALL_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(2610902469203915.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista que controle de forma condicional si se realiza esta validaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P376_CONDITION'
,p_attribute_02=>'P376_CONDITION2'
,p_attribute_04=>'P376_CONDITION_CHECK'
,p_attribute_06=>'INSTALL'
,p_attribute_07=>'P376_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(980704738825180.4001)
,p_name=>'P376_CONDITION'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(987613866849996.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca valores en este atributo seg\00FAn el tipo de condici\00F3n concreto que se ha seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(980900431825192.4001)
,p_name=>'P376_CONDITION2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(987613866849996.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2319599403209541.4001)
,p_name=>'P376_CHECK_LANG'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2319620358209542.4001)
,p_name=>'P376_CHECK_CHECK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(986905901847659.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2400212563621689.4001)
,p_name=>'P376_CONDITION_LANG'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(987613866849996.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(66627402417442821.4001)
,p_name=>'P376_N'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(976423384825139.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME from wwv_flow_install_checks',
' where id = :P376_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P376_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_help_text=>unistr('Identifica esta validaci\00F3n de instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435036115861654767.4001)
,p_name=>'P376_CONDITION_CHECK'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(987613866849996.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(978926805825171.4001)
,p_validation_name=>'P376_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P376_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(978714542825171.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(979308007825172.4001)
,p_validation_name=>'P376_SEQUENCE not null'
,p_validation_sequence=>60
,p_validation=>'P376_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La secuencia debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(979108013825172.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12990807807660333.4001)
,p_validation_name=>'P376_FAILURE_MESSAGE not null'
,p_validation_sequence=>70
,p_validation=>'P376_FAILURE_MESSAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el mensaje de error de validaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(980330757825179.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(981320544825194.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL_CHECKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_CHECKS'
,p_attribute_03=>'P376_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL_CHECKS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(981514353825195.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'376'
,p_process_when_button_id=>wwv_flow_api.id(976801086825140.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(981113826825193.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL_CHECKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_CHECKS'
,p_attribute_03=>'P376_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
end;
/
prompt --application/pages/page_00380
begin
wwv_flow_api.create_page(
 p_id=>380.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Comentarios del Desarrollador'
,p_step_title=>'Comentarios del Desarrollador'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1290119987568937.4001)
,p_plug_name=>'Comentarios de Desarrollador de Aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P380a */ ',
'    id, ',
'    flow_id,',
'    pages, ',
'    case when length(app_comment) > 200 then',
'        substr(app_comment,1,200)||''...''',
'    else',
'        app_comment',
'    end app_comment,',
'    created_on,',
'    created_by ',
'from',
'    WWV_FLOW_APP_COMMENTS',
'where',
'    security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1290224695568937.4001)
,p_name=>'Application Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." class="editDevComment" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1290432705568942.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'javascript:popupURL(''f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'');'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#e2.gif" border="0" alt="&EDIT." title="&EDIT.">'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1290530733568942.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1290620661568942.4001)
,p_db_column_name=>'PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina(s)')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1290728942568943.4001)
,p_db_column_name=>'APP_COMMENT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1290831346568943.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Fecha de Creaci\00F3n')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1290916920568943.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702930329832197441.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(131380611174316527.4001)
,p_branch_action=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(829439611872671253.4001)
,p_name=>'Submit Page on Create Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(386920635912182000.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(829439977477671287.4001)
,p_event_id=>wwv_flow_api.id(829439611872671253.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(829449136133674453.4001)
,p_name=>'Submit Page on Edit/Delete Dialog Close'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1290119987568937.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(829449417861674455.4001)
,p_event_id=>wwv_flow_api.id(829449136133674453.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00383
begin
wwv_flow_api.create_page(
 p_id=>383.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Aplicaci\00F3n')
,p_step_title=>unistr('Actualizar Aplicaci\00F3n: Confirmar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492679314807343127.4001)
,p_plug_name=>unistr('Men\00FA del Asistente')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(484017424976766961.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631657401702692346.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631721028330747384.4001)
,p_plug_name=>unistr('Confirmar Actualizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747141278381138160.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(615710003197842536.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(631657401702692346.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(493076421119174839.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(631657401702692346.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492680932512343273.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(631657401702692346.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:862:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(492682306513343396.4001)
,p_branch_action=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(493076421119174839.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631722209414751408.4001)
,p_name=>'P383_V1_CNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(631721028330747384.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Validaciones que Sustituir por Configuraci\00F3n de Elementos:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) cnt_validations ',
'  from apex_collections ',
' where collection_name = ''UPGRADE_VALIDATIONS'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631722423877751409.4001)
,p_name=>'P383_B_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(631721028330747384.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Botones que Definir en No Ejecutar Validaciones:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) cnt_buttons ',
'  from apex_collections ',
' where collection_name = ''UPGRADE_BUTTONS'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631722624713751410.4001)
,p_name=>'P383_V2_CNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(631721028330747384.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Validaciones que Definir en Ejecutar Siempre:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) cnt_validations2 ',
'  from apex_collections ',
' where collection_name = ''UPGRADE_VALIDATIONS2'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631757815020932716.4001)
,p_name=>'P383_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(631721028330747384.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492681922468343392.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upgrade Objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_count number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'                      p_collection_name => ''OBJECTS_NOT_UPGRADED'');',
'   wwv_flow_upgrade_app.update_advanced (',
'       p_flow_id   => :FB_FLOW_ID,',
'       p_page_id   => :P383_PAGE_ID );',
'',
'    select count(*) into l_count ',
'      from wwv_flow_collections where collection_name = ''OBJECTS_NOT_UPGRADED'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido actualizar el objeto seleccionado.'
,p_process_when_button_id=>wwv_flow_api.id(493076421119174839.4001)
,p_process_success_message=>'Se han actualizado correctamente los objetos seleccionados.'
);
end;
/
prompt --application/pages/page_00385
begin
wwv_flow_api.create_page(
 p_id=>385.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Extraer y Publicar Texto Traducible'
,p_step_title=>'Extraer y Publicar Texto Traducible'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(543179732397973700.4001)
,p_name=>'Extraer Texto Traducible'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.primary_language_flow_id,',
'       m.translation_flow_id,',
'       m.translation_flow_language_code,',
'       tt.translatable_strings,',
'       tt.distinct_string_estimate,',
'       nvl((select decode(sign(difference),-1,''Y'',''N'')',
'         from ',
'       (select (f2.created_on - f1.last_updated_on) difference, f2.id',
'         from wwv_flows f1, wwv_flows f2, wwv_flow_language_map m',
'        where f1.id = :FB_FLOW_ID',
'          and f1.id = m.primary_language_flow_id',
'          and f2.id = m.translation_flow_id) x',
'        where x.id = m.translation_flow_id),''Y'') requires_synchronization,',
'       (select created_on',
'          from wwv_flows f',
'         where f.id = m.translation_flow_id) translation_created',
'from wwv_flow_language_map m,',
'     (select count(*) translatable_strings,',
'             count(distinct sys.dbms_lob.substr(t.translate_from_text,1000,1)) distinct_string_estimate,',
'             t.translated_flow_id',
'        from wwv_flow_translatable_text$ t',
'       where t.security_group_id = :flow_security_group_id',
'         and t.flow_id = :fb_flow_id',
'       group by t.translated_flow_id) tt',
'where m.primary_language_flow_id = :fb_flow_id',
'  and m.security_group_id = :flow_security_group_id',
'  and tt.translated_flow_id (+)= m.translation_flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna asignaci\00F3n de traducci\00F3n.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(543180021193973703.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_pk_col_source_type=>'T'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_LANGUAGE_MAP'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(543180107482973703.4001)
,p_query_column_id=>2
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LANGUAGE_MAP'
,p_ref_column_name=>'PRIMARY_LANGUAGE_FLOW_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(543180217425973703.4001)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n Traducida')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LANGUAGE_MAP'
,p_ref_column_name=>'TRANSLATION_FLOW_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(546196128741402106.4001)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>5
,p_column_heading=>'Idioma'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(107899321117195063)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(547329826127708872.4001)
,p_query_column_id=>5
,p_column_alias=>'TRANSLATABLE_STRINGS'
,p_column_display_sequence=>7
,p_column_heading=>'Cadenas'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(547329912295708872.4001)
,p_query_column_id=>6
,p_column_alias=>'DISTINCT_STRING_ESTIMATE'
,p_column_display_sequence=>8
,p_column_heading=>'Cadenas Concretas'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(745728014438047227.4001)
,p_query_column_id=>7
,p_column_alias=>'REQUIRES_SYNCHRONIZATION'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Necesita Sincronizaci\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(546655907173533417.4001)
,p_query_column_id=>8
,p_column_alias=>'TRANSLATION_CREATED'
,p_column_display_sequence=>6
,p_column_heading=>'Publicado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(544092226865047804.4001)
,p_query_column_id=>9
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Seleccionar Fila'
,p_column_alignment=>'CENTER'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(543312111534986540.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(543312226141986546.4001)
,p_column_sequence=>2
,p_query_column_name=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(543312331118986546.4001)
,p_column_sequence=>3
,p_query_column_name=>'TRANSLATION_FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(546196010161402105.4001)
,p_column_sequence=>4
,p_query_column_name=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(547329404312708868.4001)
,p_column_sequence=>5
,p_query_column_name=>'TRANSLATABLE_STRINGS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(547329509903708868.4001)
,p_column_sequence=>6
,p_query_column_name=>'DISTINCT_STRING_ESTIMATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(745727821883047224.4001)
,p_column_sequence=>7
,p_query_column_name=>'REQUIRES_SYNCHRONIZATION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(546655713309533414.4001)
,p_column_sequence=>8
,p_query_column_name=>'TRANSLATION_CREATED'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(544359011806081262.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(684188213520699939.4001)
,p_plug_name=>'Publicar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El proceso de publicaci\00F3n crear\00E1 una versi\00F3n traducida de las aplicaciones, combinando la definici\00F3n de aplicaci\00F3n del idioma principal con el texto traducido del repositorio de textos de traducci\00F3n.'),
'<p />',
unistr('Cuando se realiza cualquier modificaci\00F3n en la aplicaci\00F3n primaria, deber\00E1 volver a crear una versi\00F3n actualizada de las aplicaciones traducidas, mediante las opciones "Extraer" y "Publicar".')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(684280303524725394.4001)
,p_plug_name=>'Extraer'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Al extraer la traducci\00F3n, se copia todo el texto traducible en el repositorio de textos de traducci\00F3n. Tras extraer el texto traducido, puede comenzar el proceso de traducci\00F3n de las cadenas de texto.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(739718405174507479.4001)
,p_plug_name=>'Descargar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Despu\00E9s de extraer el texto traducible, los archivos de traducci\00F3n XLIFF podr\00E1 descargarse para su traducci\00F3n. Estos archivos deben permanecer codificados en UTF-8.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(162452530474645087.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(545681517852319631.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_button_name=>'SEED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Extraer'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''PUBLISH'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'seed_btn'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(546875313508554884.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_button_name=>'PUBLISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''SEED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'publish_btn'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(739516315993491691.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Descargar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4750:&SESSION.::&DEBUG.:4750::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(683004802944583352.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_button_name=>'SEED_HOT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Extraer'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''SEED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'seed_btn'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(683019810562585532.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_button_name=>'PUBLISH_HOT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publicar'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''PUBLISH'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'publish_btn'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(162453400607655379.4001)
,p_branch_action=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162455006064675934.4001)
,p_name=>'P385_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(544359011806081262.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n de Idioma Primario:')
,p_source=>':FB_FLOW_ID'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Idioma primario desde el que se va a traducir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(682892320128578847.4001)
,p_name=>'P385_ACTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(543179732397973700.4001)
,p_source=>'SEED'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(206352875617953001.4001)
,p_name=>'Seed'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.seed_btn'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(206352976312953002.4001)
,p_event_id=>wwv_flow_api.id(206352875617953001.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SEED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(206353023246953003.4001)
,p_name=>'Publish'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.publish_btn'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(206353107024953004.4001)
,p_event_id=>wwv_flow_api.id(206353023246953003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PUBLISH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(545420131479257324.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(543179732397973700.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Seed Translatable Text'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select translation_flow_language_code',
'            from wwv_flow_language_map',
'           where id = :ID) loop',
'',
'    wwv_flow_translation_utilities.seed_translations (',
'        p_flow_id     => :FB_FLOW_ID,',
'        p_language    => c1.translation_flow_language_code,',
'        p_insert_only => ''NO'');',
'',
'    exit;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al extraer texto traducible.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'(:APEX$ROW_SELECTOR = ''X'' and :REQUEST in (''SEED'',''SEED_HOT''))'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>unistr('El texto traducible se ha extra\00EDdo correctamente.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(546982023944586238.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(543179732397973700.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Publish Translated Versions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select translation_flow_id',
'            from wwv_flow_language_map',
'           where id = :ID) loop',
'',
'    wwv_flow_translation_utilities.publish_application (',
'        p_from_flow_id     => :FB_FLOW_ID,',
'        p_translated_flow_id => c1.translation_flow_id,',
'        p_security_group_id => :flow_security_group_id );',
'',
'    exit;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al publicar las aplicaciones. Verifique que el ID de la aplicaci\00F3n traducida no lo est\00E1 usando una aplicaci\00F3n existente.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'(:APEX$ROW_SELECTOR = ''X'' and :REQUEST in (''PUBLISH'',''PUBLISH_HOT''))'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Las aplicaciones se han publicado correctamente.'
);
end;
/
prompt --application/pages/page_00386
begin
wwv_flow_api.create_page(
 p_id=>386.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Tema: Verificar Compatibilidad'
,p_step_title=>'Cambiar Tema: Verificar Compatibilidad'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20668725093610407.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(20663215911569971.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(59328013164429554.4001)
,p_plug_name=>'Cambiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, el Creador de Aplicaciones asigna todas las plantillas utilizadas actualmente a una plantilla del nuevo tema mediante la clase de plantilla. Este informe muestra estas asignaciones de pla'
||'ntilla y permite seleccionar otras si no hay ninguna plantilla de alguna clase que coincida.</div>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(121204124843870496.4001)
,p_name=>'Compatibilidad de Temas'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
'select   decode(temp_type,',
'  ''PAGE'',wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'  ''REGION'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'  ''LABEL'',wwv_flow_lang.system_message_lit(''LABEL''),',
'  ''LIST'',wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''CALENDAR'',wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'  ''MENU'',wwv_flow_lang.system_message_lit(''F4000.MENU''),',
'  ''BUTTON'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'  ''REPORT'',wwv_flow_lang.system_message_lit(''REPORT''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''trans-''||temp_type) temp_type, ',
'       theme_class_id ,',
'       from_template, ',
'       CASE',
'         when to_counter  > 1 then',
'             htmldb_item.hidden(1,id)||',
'             htmldb_item.hidden(2,temp_type)||',
'             HTMLDB_ITEM.SELECT_LIST_FROM_QUERY(',
'                 /*p_idx        =>*/ 3,',
'                 /*p_value      =>*/ wwv_flow_templates_util.get_default_template_id(',
'                                         p_flow_id => :fb_flow_id, ',
'                                         p_theme_id => :p179_new_theme, ',
'                                         p_template_type => temp_type',
'                                     ),',
'                 /*p_query      =>*/ ''SELECT name,id ',
'                                    FROM wwv_flow_templates_all ',
'                                   WHERE flow_id=:fb_flow_id''||',
'                                   '' AND theme_id = :p179_new_theme and (:P179_MATCHING_TEMPLATES_ONLY=''''N'''' or theme_class_id = ''||u.theme_class_id|| '')'' ||',
'                                   '' AND temp_type = ''''''||u.temp_type||'''''''',',
'                 /*p_attributes =>*/ ''title="''||wwv_flow_lang.system_message(''F4000.P622.TO_TEMPLATE'')||''"'',',
'                 /*p_show_null  =>*/ ''NO'',',
'                 /*p_null_value =>*/ ''%null%'',',
'                 /*p_null_text  =>*/ ''%'',',
'                 /*p_item_id    =>*/ null,',
'                 /*p_item_label =>*/ null,',
'                 /*p_show_extra =>*/ ''NO'' )',
'         when to_counter = 1 then',
'             htmldb_item.hidden(1,id)||',
'             htmldb_item.hidden(2,temp_type)||',
'             HTMLDB_ITEM.SELECT_LIST_FROM_QUERY(',
'                 /*p_idx        =>*/ 3,',
'                 /*p_value      =>*/ (select id ',
'                                    from wwv_flow_templates_all ',
'                                   where flow_id = :fb_flow_id ',
'                                     and theme_id = :p179_new_theme ',
'                                     and theme_class_id = u.THEME_CLASS_ID ',
'                                     and temp_type = u.TEMP_TYPE ',
'                                     and rownum = 1',
'                                 ),',
'                 /*p_query      =>*/ ''SELECT name,id ',
'                                    FROM wwv_flow_templates_all ',
'                                   WHERE flow_id=:fb_flow_id''||',
'                                   '' AND theme_id = :p179_new_theme and (:P179_MATCHING_TEMPLATES_ONLY=''''N'''' or theme_class_id = ''||u.theme_class_id|| '')'' ||',
'                                   '' AND temp_type = ''''''||u.temp_type||'''''''',',
'                 /*p_attributes =>*/ ''title="''||wwv_flow_lang.system_message(''F4000.P622.TO_TEMPLATE'')||''"'',',
'                 /*p_show_null  =>*/ ''NO'',',
'                 /*p_null_value =>*/ ''%null%'',',
'                 /*p_null_text  =>*/ ''%'',',
'                 /*p_item_id    =>*/ null,',
'                 /*p_item_label =>*/ null,',
'                 /*p_show_extra =>*/ ''NO'' )',
'         when to_counter = 0 then',
'             htmldb_item.hidden(1,id)||',
'             htmldb_item.hidden(2,temp_type)||',
'             HTMLDB_ITEM.SELECT_LIST_FROM_QUERY(',
'                 /*p_idx        =>*/ 3,',
'                 /*p_value      =>*/ wwv_flow_templates_util.get_default_template_id(',
'                                         p_flow_id => :fb_flow_id, ',
'                                         p_theme_id => :p179_new_theme, ',
'                                         p_template_type => temp_type',
'                                     ),',
'                 /*p_query      =>*/ ''SELECT name,id ',
'                                    FROM wwv_flow_templates_all ',
'                                   WHERE flow_id=:fb_flow_id''||',
'                                   '' AND theme_id = :p179_new_theme ''||',
'                                   '' AND temp_type = ''''''||u.temp_type||'''''''',',
'                 /*p_attributes =>*/ ''title="''||wwv_flow_lang.system_message(''F4000.P622.TO_TEMPLATE'')||''"'',',
'                 /*p_show_null  =>*/ ''NO'',',
'                 /*p_null_value =>*/ ''%null%'',',
'                 /*p_null_text  =>*/ ''%'',',
'                 /*p_item_id    =>*/ null,',
'                 /*p_item_label =>*/ null,',
'                 /*p_show_extra =>*/ ''NO'' )',
'       end lov, ',
'       CASE',
'         when to_counter > 1 then',
'             wwv_flow_lang.system_message_lit(''WARNING_MULTIPLE_MATCHES'')',
'         when to_counter = 1 then',
'           ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''THEME.COMPATIBLE'')||''</span>''                                                          ',
'         when to_counter = 0 then',
'             wwv_flow_lang.system_message_lit(''WARNING_MISSING_CLASS'')',
'       end status',
' from ',
'( select distinct u.id,',
'           u.temp_type,',
'       u.theme_class_id ,',
'       u.name from_template, ',
'      (select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = :p179_new_theme and theme_class_id = u.THEME_CLASS_ID and temp_type = u.TEMP_TYPE) to_counter',
' from wwv_flow_templates_used u',
' where u.flow_id = :fb_flow_id',
' and u.theme_id = :p179_old_theme  ',
') u'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select u.id,',
'  		 u.temp_type,',
'	   u.theme_class_id ,',
'	   u.name from_template, ',
'      (select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = :p179_new_theme and theme_class_id = u.THEME_CLASS_ID and temp_type = u.TEMP_TYPE) to_counter',
' from wwv_flow_templates_used u',
' where u.flow_id = :fb_flow_id ',
'  group by u.id,u.temp_type,',
'	   u.theme_class_id ,',
'	   u.name) u 	 '))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(121204418996870526.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMP_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(121204531498870529.4001)
,p_query_column_id=>2
,p_column_alias=>'THEME_CLASS_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Template Class'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(121204606152870529.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_TEMPLATE'
,p_column_display_sequence=>3
,p_column_heading=>'De Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(121204811448870529.4001)
,p_query_column_id=>4
,p_column_alias=>'LOV'
,p_column_display_sequence=>4
,p_column_heading=>'A Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(887629171909273326.4001)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200240121308295637.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(534066036689421417.4001)
,p_plug_name=>'Advertencia'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<strong>Tenga en cuenta que, al cambiar de un tema con separadores a un tema con listas de men\00FAs de navegaci\00F3n, la aplicaci\00F3n se modificar\00E1 para soportar la navegaci\00F3n basada en listas. Incluye la migraci\00F3n de los separadores a una lista de men\00FAs de ')
||unistr('navegaci\00F3n.</strong>')
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.is_navigation_upgrade (',
'  p_flow_id    => :fb_flow_id,',
'  p_from_theme => :P179_OLD_THEME,',
'  p_to_theme   => :P179_NEW_THEME ',
')'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747141364450138161.4001)
,p_plug_name=>'Cambiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59328819397431364.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200240121308295637.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59329520382431368.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200240121308295637.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select distinct u.id,',
'  		 u.temp_type,',
'	   u.theme_class_id ,',
'	   u.name from_template, ',
'      (select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = :p179_new_theme and temp_type = u.TEMP_TYPE) to_counter',
' from wwv_flow_templates_used u',
' where u.flow_id = :fb_flow_id) loop',
'if c1.to_counter = 0 then',
'   return true; ',
'end if;',
'end loop;',
'return true;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(59329127894431367.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200240121308295637.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(59330423899432629.4001)
,p_branch_action=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60063407396112165.4001)
,p_name=>'P386_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(59328013164429554.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60064519517115645.4001)
,p_name=>'P386_ACTIVE_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(59328013164429554.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema Activo Actualmente:'
,p_source=>'P179_OLD_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60067525189126702.4001)
,p_name=>'P386_NEW_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(59328013164429554.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cambiar a Tema:'
,p_source=>'P179_NEW_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(140793710305110434.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Handle Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''TEMPLATES'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''TEMPLATES'',',
'    p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'    p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'    p_generate_md5      => ''YES'' );',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(59329520382431368.4001)
);
end;
/
prompt --application/pages/page_00389
begin
wwv_flow_api.create_page(
 p_id=>389.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suscripciones de Ayuda de Elemento'
,p_step_title=>'Suscripciones de Ayuda de Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">',
'ul.indent1{margin:0em;padding-left:1.7em;margin-left:6px;}',
'ul.indent1 li{',
'    padding: 0em;',
'    margin:-.5em;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36756430377893158.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_customized_name=>unistr('Enlaces de Navegaci\00F3n')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251136311689260191.4001)
,p_plug_name=>'Suscripciones de Elementos'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id,',
'       flow_step_id,',
'       item_id, ',
'       help_id, ',
'       plug_name, ',
'       item, ',
'       substr(help_text,1,2000) help_text, ',
'       item_id2 || s s, ',
'       apex_item.popupkey_from_lov (2 ,s2 , ''flow_subscribe_from_item_help'' ,''30'' ,null ,''0'' , null, null, null,''YES'', ''f''||lpad(''''||3,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''ITEM_LABEL'',name)) sub',
'from ( ',
'select i.flow_id,',
'       i.flow_step_id,',
'       i.id item_id, ',
'       h.id help_id, ',
'       r.PLUG_NAME, ',
'       sys.htf.anchor(wwv_flow_utilities.prepare_url(''f?p=4000:390:''||:flow_session||'':::390:P390_ID,P390_FLOW_ITEM_ID:''||h.id||'',''||i.id),',
'       wwv_flow_escape.html(i.NAME)||decode(i.prompt,null,null,'' (''||wwv_flow_escape.html_trunc(i.PROMPT,30)||'')'')) item, ',
'       substr(h.help_text,1,50) help_text, ',
'       decode(h.reference_id,null,n.a,y.a) s, ',
'       apex_item.hidden(1,i.id) item_id2, ',
'       h.reference_id s2,',
'       i.NAME ',
'  from wwv_flow_page_plugs r, ',
'       wwv_flow_step_items i, ',
'       wwv_flow_step_item_help h,',
'       (select wwv_flow_lang.system_message(''YES'') a from dual) y,',
'       (select wwv_flow_lang.system_message(''NO'') a from dual) n',
' where r.id = i.ITEM_PLUG_ID ',
'   and i.id = h.flow_item_id (+) ',
'   and i.flow_id = :FB_FLOW_ID ',
')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251136406741260191.4001)
,p_name=>'Item Subscriptions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251136618911260199.4001)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador de Elemento'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251136723414260200.4001)
,p_db_column_name=>'HELP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Identificador de Ayuda'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251138012259267699.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>3
,p_column_identifier=>'J'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251138704256312747.4001)
,p_db_column_name=>'FLOW_STEP_ID'
,p_display_order=>4
,p_column_identifier=>'K'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP:FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251136814949260202.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251136926896260203.4001)
,p_db_column_name=>'ITEM'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Elemento'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251137102289260206.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Texto de Ayuda'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251137215849260207.4001)
,p_db_column_name=>'S'
,p_display_order=>10
,p_column_identifier=>'G'
,p_column_label=>'Suscrito'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251137412364260209.4001)
,p_db_column_name=>'SUB'
,p_display_order=>12
,p_column_identifier=>'I'
,p_column_label=>'Suscribirse a'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37304711467337014.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251136311689260191.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36762417773893182.4001)
,p_branch_action=>'389'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
,p_branch_comment=>'branch back to same page'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(36760003529893174.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'389'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37305310547337016.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ApplyMRU'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_cnt number := 0;',
'begin',
'  --sys.htp.p(''f01=''||wwv_flow_utilities.table_to_string2(wwv_flow.g_f01));',
'  --sys.htp.p(''f02=''||wwv_flow_utilities.table_to_string2(wwv_flow.g_f02));',
'  for i in 1..wwv_flow.g_f01.count loop',
'    for c1 in (select count(*) cnt',
'             from wwv_flow_step_item_help',
'             where flow_item_id = wwv_flow.g_f01(i))',
'    loop',
'       l_cnt := c1.cnt;',
'    end loop;',
'    ',
'    --',
'    -- If item help does not exist,',
'    -- do insert before subscribe.',
'    -- Otherwise, subscribe will fail.',
'    --',
'    if l_cnt = 0 then',
'       if wwv_flow.g_f02(i) is not null then',
'          insert into wwv_flow_step_item_help ',
'          (flow_id, flow_item_id) ',
'          values ',
'          (:FB_FLOW_ID, wwv_flow.g_f01(i));',
'       end if;',
'    end if;',
'    ',
'    if wwv_flow.g_f02(i) = 0 then',
'       wwv_flow_copy_metadata.remove_item_help_reference_id (wwv_flow.g_f01(i));',
'    else',
'       wwv_flow_copy_metadata.subscribe_item_help (',
'         p_master_item_id         => wwv_flow.g_f02(i),',
'         p_subscribing_item_id    => wwv_flow.g_f01(i)',
'         );',
'    end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(37304711467337014.4001)
,p_process_when=>'wwv_flow.g_f02.count > 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Actualizaci\00F3n aplicada.')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
,p_process_comment=>'Generated 02-MAY-2003 14:26:25'
);
end;
/
prompt --application/pages/page_00390
begin
wwv_flow_api.create_page(
 p_id=>390.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Ayuda de Elemento'
,p_step_title=>'Editar Ayuda de Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function displayHelpText(theTestItem,theDisItem)',
'{',
'   theTest = eval(document.getElementById(theTestItem));',
'   if (theTest.value != '''') {',
'        disItem = document.getElementById(theDisItem);',
'        disItem.style.background = ''#cccccc'';',
'        disItem.disabled = true;',
'        }        ',
'   else{',
'        disItem = document.getElementById(theDisItem);',
'        disItem.disabled = false;',
'        disItem.style.background = ''#ffffff'';',
'        }',
'}'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36852207337230693.4001)
,p_plug_name=>'Editar Ayuda de Elemento'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="javascript">',
'<!--',
'displayHelpText(''P390_REFERENCE_ID_HIDDENVALUE'',''P390_HELP_TEXT'');',
'//-->',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36861402058248073.4001)
,p_plug_name=>'Editar Ayuda de Elemento'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(36923815554526450.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i number := null;',
'  c number := 0;',
'begin',
'for c1 in (select reference_id ',
'           from wwv_flow_step_item_help ',
'           where flow_item_id = :P390_FLOW_ITEM_ID) loop',
'   i := c1.reference_id;',
'end loop;',
'',
'if i is not null then',
'  for c1 in (select flow_id, name ',
'             from wwv_flow_step_items',
'             where  id = i) loop',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.COPIED_FROM'')||'': ''||',
'          ''<strong>''||c1.flow_id||'', ''||wwv_flow_escape.html(c1.name)||''</strong></div><br />'');',
'  end loop;',
'else',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.MASTER'')||''</div><br />'');',
'end if;',
'',
'for c1 in (select i.flow_id, i.name ',
'             from wwv_flow_step_items i, wwv_flow_step_item_help h ',
'            where i.id = h.flow_item_id',
'            and h.reference_id = :P390_FLOW_ITEM_ID',
'            order by flow_id) loop',
'   c := c + 1;',
'   if c = 1 then',
'      sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.REFERENCE'')||'':</div><br />'');',
'      sys.htp.p(''<ul>'');',
'   end if;',
'   sys.htp.p(''<li> ''||c1.flow_id||'' - ''||',
'         wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'if i is not null then',
'  sys.htp.p(''</ul>'');',
'end if;  ',
'',
'if c = 0 then',
'   if i is not null then',
'      sys.htp.p(''<br />'');',
'   end if;',
'   sys.htp.p(''<div class="htmldbFieldTitleLeft">''||',
'         wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'')||',
'         ''</div>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059810786703457644.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36949401674645381.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(36923815554526450.4001)
,p_button_name=>'COPY_ITEM_HELP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Ayuda de Elemento'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_step_item_help',
'where flow_item_id = :P390_FLOW_ITEM_ID',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36947906953628051.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(36923815554526450.4001)
,p_button_name=>'PUBLISH_ITEM_HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Publicar Ayuda de Elemento'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:449:&SESSION.::&DEBUG.::P449_ID,P449_PAGE_ID:&P390_FLOW_ITEM_ID.,&FLOW_PAGE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_step_item_help',
'where reference_id = :P390_FLOW_ITEM_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'i icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1059810375686457640.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(36861402058248073.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36867307037259054.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(36861402058248073.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1059810627961457643.4001)
,p_branch_name=>'Go to Page 389'
,p_branch_action=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(36867307037259054.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36867612564259060.4001)
,p_branch_name=>'Go To Page 390'
,p_branch_action=>'f?p=&FLOW_ID.:390:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36856901234238370.4001)
,p_name=>'P390_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36857807814240334.4001)
,p_name=>'P390_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36871026215274063.4001)
,p_name=>'P390_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nuevo'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el nombre de la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36878010594316856.4001)
,p_name=>'P390_ITEM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_prompt=>'Elemento:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'and FLOW_STEP_ID = :FB_FLOW_PAGE_ID',
'and id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica el nombre del elemento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36879319036328685.4001)
,p_name=>'P390_FLOW_ITEM_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36892921254414540.4001)
,p_name=>'P390_ITEM_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROMPT',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID and',
'flow_step_id = :FB_FLOW_PAGE_ID and',
'id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la etiqueta del elemento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36895615844422381.4001)
,p_name=>'P390_DISPLAY_AS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_as',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'and id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el m\00E9todo de visualizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36899723941434261.4001)
,p_name=>'P390_HELP_TEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select HELP_TEXT',
'from wwv_flow_step_item_help',
'where flow_id = :fb_flow_id',
'and flow_item_id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Especifique el texto de ayuda del elemento.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36927826767539161.4001)
,p_name=>'P390_REFERENCE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(36923815554526450.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ayuda de Elemento Maestro de Referencia de'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select REFERENCE_ID',
'from wwv_flow_step_item_help',
'where flow_id = :fb_flow_id',
'and flow_item_id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_ITEM_HELP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_ITEM''))||',
''' -''  d, 0 r from dual union all',
'select i.flow_id||'' : ''||wwv_flow_escape.html(i.name) d, i.id r',
'from   wwv_flow_step_items i, wwv_flow_step_item_help h',
'where  i.id = h.flow_item_id',
'and i.flow_id = nvl(:fb_flow_id,0) and i.flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede basar el texto de ayuda del elemento en un texto de ayuda existente de esta o de otra aplicaci\00F3n. A continuaci\00F3n ser\00E1 un suscriptor de ese texto de ayuda de elemento. Busque el elemento que desea utilizar y haga clic en Aplicar. Una copia del t')
||unistr('exto de ayuda de elemento est\00E1 ya disponible para poder aumentar sus fines. Hay un bot\00F3n Refrescar para recuperar una copia nueva del texto de ayuda de elemento maestro siempre que lo necesite. Por supuesto, tendr\00E1 que realizar los cambios necesarios')
||unistr(' en \00E9l.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'onChange="javascript:displayHelpText(''P390_REFERENCE_ID_HIDDENVALUE'',''P390_HELP_TEXT'');"'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36951510462657423.4001)
,p_name=>'P390_REFRESH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(36923815554526450.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37498226080133126.4001)
,p_name=>'P390_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(36852207337230693.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36960804023740741.4001)
,p_validation_name=>'reference is not null'
,p_validation_sequence=>10
,p_validation=>'P390_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de referencia para refrescar la ayuda de elemento.'
,p_when_button_pressed=>wwv_flow_api.id(36949401674645381.4001)
,p_associated_item=>wwv_flow_api.id(36927826767539161.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36961623416746316.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>10
,p_validation=>'P390_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar el elemento.'
,p_when_button_pressed=>wwv_flow_api.id(36949401674645381.4001)
,p_associated_item=>wwv_flow_api.id(36927826767539161.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(40180022010393826.4001)
,p_name=>'P390_HELP_TEXT'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P390_REFERENCE_ID'
,p_condition_element=>'P390_REFERENCE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(40180131145393826.4001)
,p_event_id=>wwv_flow_api.id(40180022010393826.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P390_HELP_TEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(40180220823393826.4001)
,p_event_id=>wwv_flow_api.id(40180022010393826.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P390_HELP_TEXT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37065414833067166.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Item Help 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_item_help (',
'    p_master_item_id         => :P390_REFERENCE_ID,',
'    p_subscribing_item_id    => :P390_FLOW_ITEM_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la ayuda de elemento.'
,p_process_when_button_id=>wwv_flow_api.id(36949401674645381.4001)
,p_process_when=>'P390_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NOT_ZERO'
,p_process_success_message=>'Ayuda del elemento copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37989107350881957.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process item help text'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_step_item_help',
'set  help_text = :P390_HELP_TEXT ',
'where  flow_item_id = :P390_FLOW_ITEM_ID',
'and flow_id = :FB_FLOW_ID; ',
'',
'--',
'-- if the item does not have any help text, insert ',
'--',
'if SQL%ROWCOUNT = 0 then',
'   -- delete any existing item help',
'   delete from wwv_flow_step_item_help',
'   where flow_item_id = :P390_FLOW_ITEM_ID',
'   and flow_id = :FB_FLOW_ID; ',
'   ',
'   insert into wwv_flow_step_item_help',
'      (flow_id,',
'       flow_item_id,',
'       help_text)',
'      values ',
'      (:FB_FLOW_ID,',
'       :P390_FLOW_ITEM_ID,',
'       :P390_HELP_TEXT);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la ayuda de elemento.'
,p_process_when=>'COPY_ITEM_HELP'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Texto de ayuda de la aplicaci\00F3n &FB_FLOW_ID. elemento &P390_ITEM. procesado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37070826916117922.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh item help 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_item_help (',
'    p_master_item_id         => :P390_REFERENCE_ID,',
'    p_subscribing_item_id    => :P390_FLOW_ITEM_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la ayuda de elemento.'
,p_process_when_button_id=>wwv_flow_api.id(36867307037259054.4001)
,p_process_when=>':P390_REFERENCE_ID is not null and :P390_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Ayuda del elemento copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37072610901132232.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_item_help_reference_id (:P390_FLOW_ITEM_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de referencia en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(36867307037259054.4001)
,p_process_when=>'P390_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
);
end;
/
prompt --application/pages/page_00391
begin
wwv_flow_api.create_page(
 p_id=>391.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Ver Valores por Defecto de Tabla'
,p_step_title=>'Ver Valores por Defecto de Tabla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262745606420610180)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(74725624313588476)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(61462903342942480.4001)
,p_name=>'Valores por Defecto de Tabla'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT SCHEMA,',
'       TABLE_NAME, ',
'       FORM_REGION_TITLE, ',
'       REPORT_REGION_TITLE',
'  FROM WWV_FLOW_HNT_TABLE_INFO',
' WHERE SCHEMA = :P391_SCHEMA',
'   AND TABLE_NAME = :P391_TABLE'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los valores por defecto de interfaz de usuario se utilizan para rellenar con valores iniciales las propiedades de regi\00F3n y elemento, a fin de proporcionar consistencia entre p\00E1ginas de una aplicaci\00F3n o de varias aplicaciones.</p>'),
'',
unistr('<p>El diccionario de tablas es espec\00EDfico de las tablas y columnas de un esquema seleccionado. Estos valores por defecto se utilizan en cualquier definici\00F3n del diccionario de atributos.</p>')))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>15
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn valor por defecto de interfaz de usuario de la tabla.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(61464627556942549.4001)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'Esquema:'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'SCHEMA'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(61464809019942550.4001)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de la Tabla:'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'TABLE_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(61465029472942551.4001)
,p_query_column_id=>3
,p_column_alias=>'FORM_REGION_TITLE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('T\00EDtulo de Regi\00F3n de Pantalla:')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'FORM_REGION_TITLE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(61465226770942551.4001)
,p_query_column_id=>4
,p_column_alias=>'REPORT_REGION_TITLE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('T\00EDtulo de Regi\00F3n de Informe:')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'REPORT_REGION_TITLE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61465913384945302.4001)
,p_plug_name=>'HIDDEN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(61609620853136751.4001)
,p_name=>'Valores por Defecto de Interfaz de Usuario de Columna'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT c.TABLE_ID,',
'       c.COLUMN_ID, ',
'       case when g.group_name is null',
'            then 2',
'            else 1',
'            end ob,',
'       g.display_sequence group_display_seq,',
'       nvl(g.group_name,wwv_flow_lang.system_message(''NONE_SPECIFIED'')) group_name,',
'       c.COLUMN_NAME, ',
'       c.LABEL,',
'       decode(c.display_in_report,''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) display_in_report, ',
'       c.DISPLAY_SEQ_REPORT, ',
'       c.DISPLAY_AS_REPORT, -- need lov',
'       c.MASK_REPORT,',
'       c.ALIGNMENT,         -- need lov',
'       c.DISPLAY_AS_TAB_FORM,  -- need lov',
'       decode(wwv_flow_escape.html(c.display_in_form),''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) display_in_form, ',
'       c.DISPLAY_SEQ_FORM, ',
'       c.DISPLAY_AS_FORM,      -- need lov',
'       c.MASK_FORM,',
'       c.DEFAULT_VALUE, ',
'       c.DISPLAY_WIDTH, ',
'       c.MAX_WIDTH, ',
'       c.HEIGHT, ',
'       decode(c.required,''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) required, ',
'       (case when length(c.help_text) > 255 ',
'             then substr(c.help_text,1,255)||'' ...''',
'             else c.help_text',
'             end) help_text, ',
'       (case when length(c.lov_query) > 255 ',
'             then substr(c.LOV_QUERY,1,255)||'' ...''',
'             else c.lov_query',
'             end) lov_query,',
'       (case when length(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(c.COLUMN_ID)) > 255',
'             then substr(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(c.COLUMN_ID),1,255)||'' ...''',
'             else WWV_FLOW_HINT.GET_STATIC_LOV_STRING(c.COLUMN_ID)',
'             end) STATIC_LOV',
'  FROM WWV_FLOW_HNT_COLUMN_INFO c,',
'       wwv_flow_hnt_groups g',
' WHERE c.TABLE_ID = :P391_TABLE_ID',
'   and c.group_id = g.group_id (+)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628110221779238.4001)
,p_query_column_id=>1
,p_column_alias=>'TABLE_ID'
,p_column_display_sequence=>23
,p_column_heading=>'Table Id'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'TABLE_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628218574779240.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>22
,p_column_heading=>'Column Id'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'COLUMN_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492768312997118761.4001)
,p_query_column_id=>3
,p_column_alias=>'OB'
,p_column_display_sequence=>25
,p_column_heading=>'Ob'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492768020354101979.4001)
,p_query_column_id=>4
,p_column_alias=>'GROUP_DISPLAY_SEQ'
,p_column_display_sequence=>24
,p_column_heading=>'Group Display Seq'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492762421805932106.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de Grupo'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628312545779240.4001)
,p_query_column_id=>6
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de Columna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>4
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'COLUMN_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628417505779241.4001)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'LABEL'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628531719779241.4001)
,p_query_column_id=>8
,p_column_alias=>'DISPLAY_IN_REPORT'
,p_column_display_sequence=>4
,p_column_heading=>'Mostrar en<br />Informe'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_IN_REPORT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628609039779241.4001)
,p_query_column_id=>9
,p_column_alias=>'DISPLAY_SEQ_REPORT'
,p_column_display_sequence=>5
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_SEQ_REPORT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628708546779241.4001)
,p_query_column_id=>10
,p_column_alias=>'DISPLAY_AS_REPORT'
,p_column_display_sequence=>6
,p_column_heading=>'Mostrar como Informe'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(285506029323635827)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_AS_REPORT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628806513779241.4001)
,p_query_column_id=>11
,p_column_alias=>'MASK_REPORT'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'MASK_REPORT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140628913251779241.4001)
,p_query_column_id=>12
,p_column_alias=>'ALIGNMENT'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Alineaci\00F3n')
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(200094129140149873)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'ALIGNMENT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629304090779242.4001)
,p_query_column_id=>13
,p_column_alias=>'DISPLAY_AS_TAB_FORM'
,p_column_display_sequence=>9
,p_column_heading=>'Mostrar como<br>Pantalla Tabular'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(285508811785635847)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_AS_TAB_FORM'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629430701779242.4001)
,p_query_column_id=>14
,p_column_alias=>'DISPLAY_IN_FORM'
,p_column_display_sequence=>10
,p_column_heading=>'Mostrar<br>en<br>Pantalla'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_IN_FORM'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629522467779242.4001)
,p_query_column_id=>15
,p_column_alias=>'DISPLAY_SEQ_FORM'
,p_column_display_sequence=>11
,p_column_heading=>'Secuencia<br>en<br>Pantalla'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_SEQ_FORM'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629628978779242.4001)
,p_query_column_id=>16
,p_column_alias=>'DISPLAY_AS_FORM'
,p_column_display_sequence=>12
,p_column_heading=>'Mostrar como Pantalla'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29544521926748713)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_AS_FORM'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629728080779242.4001)
,p_query_column_id=>17
,p_column_alias=>'MASK_FORM'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Pantalla de<br>M\00E1scara')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'MASK_FORM'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629801978779243.4001)
,p_query_column_id=>18
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>14
,p_column_heading=>'Valor<br>por Defecto'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DEFAULT_VALUE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140629907453779243.4001)
,p_query_column_id=>19
,p_column_alias=>'DISPLAY_WIDTH'
,p_column_display_sequence=>15
,p_column_heading=>unistr('Ancho de<br>Visualizaci\00F3n')
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_WIDTH'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140630021271779243.4001)
,p_query_column_id=>20
,p_column_alias=>'MAX_WIDTH'
,p_column_display_sequence=>16
,p_column_heading=>unistr('Ancho<br>M\00E1ximo')
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'MAX_WIDTH'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140630126044779243.4001)
,p_query_column_id=>21
,p_column_alias=>'HEIGHT'
,p_column_display_sequence=>17
,p_column_heading=>'Altura'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'HEIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140630221296779243.4001)
,p_query_column_id=>22
,p_column_alias=>'REQUIRED'
,p_column_display_sequence=>18
,p_column_heading=>'Necesario'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'REQUIRED'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140630314009779243.4001)
,p_query_column_id=>23
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>19
,p_column_heading=>'Texto de Ayuda'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'HELP_TEXT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140630409244779244.4001)
,p_query_column_id=>24
,p_column_alias=>'LOV_QUERY'
,p_column_display_sequence=>20
,p_column_heading=>'Consulta de Lista de Valores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'LOV_QUERY'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(140630509717779244.4001)
,p_query_column_id=>25
,p_column_alias=>'STATIC_LOV'
,p_column_display_sequence=>21
,p_column_heading=>unistr('Lista de Valores Est\00E1tica')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'STATIC_LOV'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178256924733663285.4001)
,p_plug_name=>'Advertencia: Las columnas necesitan la lista de valores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>125
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_hint.check_lov_issues(:P391_TABLE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<img src="#IMAGE_PREFIX#htmldb/icons/alert_warning.gif" alt=""/> Las siguientes columnas tienen tipos de visualizaci\00F3n que necesitan una lista de valores, pero no hay ninguna definida.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(138112412580899990.4001)
,p_branch_action=>'f?p=&FLOW_ID.:391:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61467127929949530.4001)
,p_name=>'P391_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(61465913384945302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61467427689949532.4001)
,p_name=>'P391_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(61465913384945302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61615430550139554.4001)
,p_name=>'P391_TABLE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(61465913384945302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178266403524676064.4001)
,p_name=>'P391_LOV_ISSUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(178256924733663285.4001)
,p_source=>'wwv_flow_hint.check_lov_issues(:P391_TABLE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(61660926871147913.4001)
,p_computation_sequence=>10
,p_computation_item=>'P391_TABLE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id',
'  from wwv_flow_hnt_table_info',
' where :P391_SCHEMA = schema',
'   and :P391_TABLE  = table_name'))
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00392
begin
wwv_flow_api.create_page(
 p_id=>392.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Barra de Navegaci\00F3n: Tipo')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46436118421075787.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196892025844223666.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(103870209211856610.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196904722044298231.4001)
,p_plug_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196905002090301938.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46436118421075787.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196905426511301939.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46436118421075787.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196905231171301939.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46436118421075787.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196958804214680940.4001)
,p_branch_action=>'f?p=&APP_ID.:4023:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P392_ENTRY_TYPE'
,p_branch_condition_text=>'URL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196967827173820034.4001)
,p_branch_action=>'f?p=&APP_ID.:497:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(196905426511301939.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P392_ENTRY_TYPE'
,p_branch_condition_text=>'FEEDBACK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(573754023540229721.4001)
,p_branch_action=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(196905231171301939.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196955105683662453.4001)
,p_name=>'P392_ENTRY_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(196904722044298231.4001)
,p_item_default=>'URL'
,p_prompt=>unistr('Seleccionar Tipo de Entrada de Barra de Navegaci\00F3n:')
,p_source=>'URL'
,p_source_type=>'STATIC'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P392 CREATE NAV BAR ENTRY TYPE SELECTOR'
,p_lov=>'.'||wwv_flow_api.id(196955313648664768.4001)||'.'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de entrada de navegaci\00F3n que se debe agregar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573753883519229719.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(196905002090301938.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573753962046229720.4001)
,p_event_id=>wwv_flow_api.id(573753883519229719.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00394
begin
wwv_flow_api.create_page(
 p_id=>394.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Entradas de Barra de Navegaci\00F3n')
,p_step_title=>unistr('Historial de Entradas de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10078523944553285.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(166766500720858594.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181016801777003664.4001)
,p_plug_name=>unistr('Historial de Entradas de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las entradas de barra de navegaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193081831199308752.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P394a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_ICON_BAR'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193082012240308753.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082111287308754.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082212996308755.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082326102308755.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082401525308756.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082523040308757.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082611829308758.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193082731593308758.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188985015541905789.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193081831199308752.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:394:&SESSION.::&DEBUG.:394,RIR::'
);
end;
/
prompt --application/pages/page_00397
begin
wwv_flow_api.create_page(
 p_id=>397.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_step_title=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema: N\00FAmero de Tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60191729831707231.4001)
,p_plug_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_region_template_options=>'#DEFAULT#:a-Form-fixedLabelsLarge'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Cada tema tiene un n\00FAmero de identificaci\00F3n (o identificador). Utilice esta utilidad para cambiar el n\00FAmero de identificaci\00F3n del tema a otro n\00FAmero. El cambio de n\00FAmero de identificaci\00F3n de tema es \00FAtil si necesita exportar un tema con un n\00FAmero ')
||'diferente.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106531510655579263.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106512001249472508.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200255730583392996.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747141408351138161.4001)
,p_plug_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60192928679707235.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200255730583392996.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60193300146707238.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200255730583392996.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(60195828763707263.4001)
,p_branch_action=>'f?p=&FLOW_ID.:400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60194113481707242.4001)
,p_name=>'P397_CHANGE_TO_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(60191729831707231.4001)
,p_prompt=>unistr('Nuevo N\00FAmero de Identificaci\00F3n de Tema')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca un n\00FAmero de identificaci\00F3n nuevo para el tema seleccionado actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60194514019707248.4001)
,p_name=>'P397_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(60191729831707231.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60194925620707252.4001)
,p_name=>'P397_CHANGE_FROM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(60191729831707231.4001)
,p_prompt=>'Identificar Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id r from wwv_flow_themes where flow_id = :fb_flow_id',
'order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tema para el que desea cambiar el n\00FAmero de identificaci\00F3n de tema.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144913419390912494.4001)
,p_validation_name=>'P397_CHANGE_TO_ID'
,p_validation_sequence=>10
,p_validation=>'P397_CHANGE_TO_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de tema.'
,p_when_button_pressed=>wwv_flow_api.id(60193300146707238.4001)
,p_associated_item=>wwv_flow_api.id(60194113481707242.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35691301057155548.4001)
,p_validation_name=>'P397_CHANGE_TO_ID'
,p_validation_sequence=>20
,p_validation=>'P397_CHANGE_TO_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El n\00FAmero de identificaci\00F3n de tema debe ser num\00E9rico.')
,p_when_button_pressed=>wwv_flow_api.id(60193300146707238.4001)
,p_associated_item=>wwv_flow_api.id(60194113481707242.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(60285216296032571.4001)
,p_validation_name=>'theme_to is greater than 100'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :P397_CHANGE_TO_ID >= 100 or :app_security_group_id = 10  or :app_security_group_id = 20 or :app_security_group_id = 200000 then',
'  return true;',
'end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'El identificador de tema debe ser mayor que 100.'
,p_validation_condition=>'P397_CHANGE_TO_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_api.id(60193300146707238.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(60732408800844816.4001)
,p_validation_name=>'Theme not in use'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select 1 from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :P397_CHANGE_TO_ID) loop',
'  return false;',
'end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El tema est\00E1 en uso. Seleccione otro.')
,p_validation_condition=>'P397_CHANGE_TO_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_api.id(60193300146707238.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(35685704258137583.4001)
,p_validation_name=>'Theme ID must be whole numbers'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_round number := null;',
'begin',
'  if :P397_CHANGE_TO_ID > 100 then',
'    l_round := round(:P397_CHANGE_TO_ID);',
'    if l_round != :P397_CHANGE_TO_ID then',
'      return false;',
'    end if;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El n\00FAmero de identificaci\00F3n de tema debe ser un n\00FAmero entero.')
,p_validation_condition=>'P397_CHANGE_TO_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_api.id(60193300146707238.4001)
,p_associated_item=>wwv_flow_api.id(60194113481707242.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00398
begin
wwv_flow_api.create_page(
 p_id=>398.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Informe de Separadores Principales'
,p_step_title=>'Informe de Separadores Principales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31648722557137314.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(31665218120315803.4001)
,p_name=>'Separadores Principales'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       p.tab_sequence||'': ''||p.tab_set ptset, ',
'       p.tab_text ptext, ',
'       p.CURRENT_ON_TABSET,',
'       s.TAB_SEQUENCE sseq, ',
'       s.TAB_TEXT     stext,',
'       s.id s_id,',
'       p.id p_id',
'from   wwv_flow_toplevel_tabs p, ',
'       wwv_flow_tabs s',
'where  s.flow_id (+) = :FB_FLOW_ID and',
'       p.flow_id = :fb_flow_id and',
'       s.tab_set (+) = p.CURRENT_ON_TABSET',
'order  by 1, 2, 3, 4, 5'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn separador principal.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48653514844771463.4001)
,p_query_column_id=>1
,p_column_alias=>'PTSET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48653601252771463.4001)
,p_query_column_id=>2
,p_column_alias=>'PTEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Separador Principal'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=#FLOW_ID#:4318:#FLOW_SESSION#::::F4000_P4318_ID:#P_ID#'
,p_column_linktext=>'#PTEXT#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48653711021771463.4001)
,p_query_column_id=>3
,p_column_alias=>'CURRENT_ON_TABSET'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Juego de Separadores Est\00E1ndar')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48653819883771463.4001)
,p_query_column_id=>4
,p_column_alias=>'SSEQ'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48653909184771463.4001)
,p_query_column_id=>5
,p_column_alias=>'STEXT'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Separador Est\00E1ndar')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48654008793771463.4001)
,p_query_column_id=>6
,p_column_alias=>'S_ID'
,p_column_display_sequence=>6
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48654117539771463.4001)
,p_query_column_id=>7
,p_column_alias=>'P_ID'
,p_column_display_sequence=>7
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31680303715097026.4001)
,p_plug_name=>'Separadores Principales'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta p\00E1gina identifica los separadores principales y est\00E1ndar definidos para la aplicaci\00F3n actual.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(31682607141145273.4001)
,p_plug_name=>'Tareas de Separador Principal'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(165863110284077420.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35089502899725260.4001)
,p_plug_name=>unistr('Tareas de Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(165876716780098264.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(36279612648350571.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'398'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_api.create_page(
 p_id=>400.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Cambio de N\00FAmero de Identificaci\00F3n de Tema')
,p_step_title=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema: Confirmar')
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60212912924793599.4001)
,p_plug_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>131
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106532720698582206.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106512001249472508.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200256605911404711.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747141585648138161.4001)
,p_plug_name=>unistr('Cambiar N\00FAmero de Identificaci\00F3n de Tema')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60214518168793605.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200256605911404711.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60213704598793603.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200256605911404711.4001)
,p_button_name=>'CHANGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Identificador de Tema'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60214127171793604.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200256605911404711.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:397:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(60215826657793625.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60220731506809852.4001)
,p_name=>'P400_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(60212912924793599.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60221408780812795.4001)
,p_name=>'P400_CHANGE_THEME_FROM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(60212912924793599.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cambiar Identificador de Tema de:'
,p_source=>'P397_CHANGE_FROM_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60222117438815210.4001)
,p_name=>'P400_CHANGE_TO_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(60212912924793599.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cambiar Identificador de Tema a:'
,p_source=>'P397_CHANGE_TO_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determina un n\00FAmero de identificaci\00F3n nuevo para el tema seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(60215425602793620.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Change theme ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.renumber_theme(p_flow_id => :fb_flow_id, p_to_theme => :P397_CHANGE_TO_ID, p_from_theme => :P397_CHANGE_FROM_ID);',
'-- :P397_CHANGE_TO_ID',
'-- :P397_CHANGE_FROM_ID'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido cambiar el identificador de tema.'
,p_process_when_button_id=>wwv_flow_api.id(60213704598793603.4001)
,p_process_success_message=>'Identificador de tema cambiado.'
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_api.create_page(
 p_id=>401.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Tema'
,p_step_title=>'Copiar Tema'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60244815188880674.4001)
,p_plug_name=>'Copiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>21
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Cada tema tiene un n\00FAmero de identificaci\00F3n num\00E9rico (o identificador). Utilice esto para realizar una copia de un tema existente y especificar un nuevo identificador de tema. La copia de temas es \00FAtil si desea exportar un tema con un identificado')
||'r diferente.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106490527175408094.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106491204103410821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200253521186361846.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>41
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747141678510138162.4001)
,p_plug_name=>'Copiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60246011183880677.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200253521186361846.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60246412285880679.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200253521186361846.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(60248501926880695.4001)
,p_branch_action=>'f?p=&FLOW_ID.:410:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60247204839880682.4001)
,p_name=>'P401_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(60244815188880674.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>':FB_FLOW_ID'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60247626161880688.4001)
,p_name=>'P401_COPY_FROM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(60244815188880674.4001)
,p_prompt=>'Copiar de Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id r from wwv_flow_themes where flow_id = :P401_APPLICATION',
'order by 2'))
,p_lov_cascade_parent_items=>'P401_APPLICATION'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tema que desea copiar. Un tema identifica una recopilaci\00F3n de plantillas que definen la interfaz de usuario de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60248022935880689.4001)
,p_name=>'P401_COPY_TO_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(60244815188880674.4001)
,p_prompt=>'Copiar en este ID de Tema'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca un n\00FAmero de identificaci\00F3n nuevo para este tema. Un tema identifica una recopilaci\00F3n de plantillas que definen la interfaz de usuario de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(941779181566559887.4001)
,p_name=>'P401_SUBSCRIBE_THEME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(60244815188880674.4001)
,p_prompt=>'Suscribirse a Tema'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(141257203808789836.4001)
,p_validation_name=>'P401_COPY_TO_ID'
,p_validation_sequence=>10
,p_validation=>'P401_COPY_TO_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de tema.'
,p_when_button_pressed=>wwv_flow_api.id(60246412285880679.4001)
,p_associated_item=>wwv_flow_api.id(60248022935880689.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(141259929435797240.4001)
,p_validation_name=>'Copy to > 100'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :WORKSPACE_ID=20 or :P401_COPY_TO_ID>=100 then',
'  return true;',
'else ',
'  return false;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Los valores por debajo de 100 est\00E1n reservados para Oracle.')
,p_when_button_pressed=>wwv_flow_api.id(60246412285880679.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144917213072929581.4001)
,p_validation_name=>'theme not in use'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select 1 from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :P401_COPY_TO_ID) loop',
'  return false;',
'end loop;',
'return true;',
'exception when others then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El tema ya est\00E1 en uso; seleccione otro.')
,p_when_button_pressed=>wwv_flow_api.id(60246412285880679.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00404
begin
wwv_flow_api.create_page(
 p_id=>404.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Definir Elementos'
,p_step_title=>'Definir Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function passBackItemValues(){',
'    var items  = "",',
'        values = "";',
'',
'    if ($v("P404_ITEM1") != "") {',
'      items = $v("P404_ITEM1") + ",";',
'      values = $v("P404_VALUE1") + ",";',
'    }',
'    if ($v("P404_ITEM2") != "") {',
'      items = items + $v("P404_ITEM2") + ",";',
'      values = values + $v("P404_VALUE2") + ","; }',
'    if ($v("P404_ITEM3") != "") {',
'      items = items + $v("P404_ITEM3") + ",";',
'      values = values + $v("P404_VALUE3") + ","; ',
'    }',
'    if ($v("P404_ITEM4") != "") {',
'      items = items + $v("P404_ITEM4") + ",";',
'      values = values + $v("P404_VALUE4") + ","; ',
'    }',
'    if ($v("P404_ITEM5") != "") {',
'      items = items + $v("P404_ITEM5") + ",";',
'      values = values + $v("P404_VALUE5") + ","; ',
'    }',
'    if ($v("P404_ITEM6") != "") {',
'      items = items + $v("P404_ITEM6") + ",";',
'      values = values + $v("P404_VALUE6") + ","; ',
'    }',
'    if ($v("P404_ITEM7") != "") {',
'      items = items + $v("P404_ITEM7") + ",";',
'      values = values + $v("P404_VALUE7") + ","; ',
'    }',
'    if ($v("P404_ITEM8") != "") {',
'      items = items + $v("P404_ITEM8") + ",";',
'      values = values + $v("P404_VALUE8") + ","; ',
'    }',
'    if ($v("P404_ITEM9") != "") {',
'      items = items + $v("P404_ITEM9") + ",";',
'      values = values + $v("P404_VALUE9") + ","; ',
'    }',
'    if ($v("P404_ITEM10") != "") {',
'      items = items + $v("P404_ITEM10") + ",";',
'      values = values + $v("P404_VALUE10") + ","; ',
'    }',
'    items = items.substr(0,items.lastIndexOf(","));',
'    values = values.substr(0,values.lastIndexOf(","));',
'    ',
'    var return1 = $v(''P404_RETURN1''),',
'        return2 = $v(''P404_RETURN2''),',
'        target1 = window.opener.document.getElementById(return1),',
'        target2 = window.opener.document.getElementById(return2);',
'    window.opener.setValue(target1,items);',
'    window.opener.setValue(target2,values);',
'    target2.focus();',
'    window.close();',
'}',
'',
'function closePopup(){',
'    var target1 = window.opener.document.getElementById($v(''P404_RETURN1''));    ',
'    target1.focus();',
'    window.close();',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'table.formlayout .a-Form-labelContainer {',
'    min-width: 0;',
'}',
'body {',
'padding: 0 !important;',
'}',
'table.formlayout td input[type="text"] {',
'  border-right-width: 0;',
'  border-radius: 2px 0 0 2px;',
'  box-shadow: 0 1px 1px rgba(0,0,0,.05) inset;',
'  border-color: #DBDBDB; ',
'}'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18105609595309302.4001)
,p_plug_name=>'Item/Value Pairs'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(280300246206526845.4001)
,p_plug_name=>'Botones'
,p_region_attributes=>'style="margin: 8px;"'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4106223580403610.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(280300246206526845.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18516214489107148.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(280300246206526845.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:passBackItemValues();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18256106852603439.4001)
,p_name=>'P404_RETURN1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18256712047604967.4001)
,p_name=>'P404_RETURN2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18265703173961925.4001)
,p_name=>'P404_ITEM1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'1'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18265925075961927.4001)
,p_name=>'P404_ITEM2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'2'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18266232575961928.4001)
,p_name=>'P404_ITEM3'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'3'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18266529203961929.4001)
,p_name=>'P404_ITEM4'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'4'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18266820531961929.4001)
,p_name=>'P404_ITEM5'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'5'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18267104910961930.4001)
,p_name=>'P404_ITEM6'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'6'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18267407600961931.4001)
,p_name=>'P404_ITEM7'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'7'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18267722929961931.4001)
,p_name=>'P404_ITEM8'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'8'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18268013961961933.4001)
,p_name=>'P404_ITEM9'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'9'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18268328527961933.4001)
,p_name=>'P404_ITEM10'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'10'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18269313955993408.4001)
,p_name=>'P404_VALUE1'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 1'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18269522678993408.4001)
,p_name=>'P404_VALUE2'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 2'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18269810275993409.4001)
,p_name=>'P404_VALUE3'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 3'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18270126260993409.4001)
,p_name=>'P404_VALUE4'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 4'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18270406424993410.4001)
,p_name=>'P404_VALUE5'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 5'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18270716902993414.4001)
,p_name=>'P404_VALUE6'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 6'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18271031351993414.4001)
,p_name=>'P404_VALUE7'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 7'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18271307333993416.4001)
,p_name=>'P404_VALUE8'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 8'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18271611876993416.4001)
,p_name=>'P404_VALUE9'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 9'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18271915789993417.4001)
,p_name=>'P404_VALUE10'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_prompt=>'Valor 10'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Seleccione o introduzca el valor que se va a transferir al elemento asociado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18632520787988973.4001)
,p_name=>'P404_ITEMS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18633827713990946.4001)
,p_name=>'P404_VALUES'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18783224248390375.4001)
,p_name=>'P404_ITEM_HEADING'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_source=>'''<span class="instructionText">''||wwv_flow_lang.system_message(''LAYOUT.T_ITEM'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18783800830392998.4001)
,p_name=>'P404_VAL_HEADING'
,p_item_sequence=>29
,p_item_plug_id=>wwv_flow_api.id(18105609595309302.4001)
,p_source=>'''<span class="instructionText">''||wwv_flow_lang.system_message(p_name=>''F4000.P404.VALUES'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4106082779403608.4001)
,p_name=>'Focus P404_ITEM1'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4106116665403609.4001)
,p_event_id=>wwv_flow_api.id(4106082779403608.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P404_ITEM1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4106325177403611.4001)
,p_name=>'Close Popup Window'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4106223580403610.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4106436113403612.4001)
,p_event_id=>wwv_flow_api.id(4106325177403611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'closePopup();'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18658022013102856.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_items wwv_flow_global.vc_arr2;',
'  l_item_count number;',
'begin',
'  l_items := wwv_flow_utilities.string_to_table(:P404_ITEMS,''~'');',
'  if l_items.count>10 then',
'    l_item_count := 10;',
'  else',
'    l_item_count := l_items.count;',
'  end if;',
'  for i in 1.. l_item_count loop',
'    wwv_flow.update_cache_with_write(''P404_ITEM''||i,l_items(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P404_ITEMS'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18682513336299056.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_values wwv_flow_global.vc_arr2;',
'  l_value_count number;',
'begin',
'  l_values := wwv_flow_utilities.string_to_table(:P404_VALUES,''~'');',
'  if l_values.count>10 then',
'    l_value_count := 10;',
'  else',
'    l_value_count := l_values.count;',
'  end if;',
'  for i in 1.. l_value_count loop',
'    wwv_flow.update_cache_with_write(''P404_VALUE''||i,l_values(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P404_VALUES'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00405
begin
wwv_flow_api.create_page(
 p_id=>405.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Listas'
,p_step_title=>'Listas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3852226590687921.4001)
,p_plug_name=>'Lists Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P405a */ id,',
'       l.name name,',
'      (select count(*) from wwv_flow_list_items where list_id = l.id) entries,',
'      ( select count(*)',
'           from wwv_flow_page_plugs p',
'          where p.list_id           = l.id',
'            and p.flow_id           = l.flow_id',
'            and p.security_group_id = l.security_group_id ) +',
'       ( select count(*)',
'           from wwv_flow_steps s',
'          where s.navigation_list_id = l.id',
'            and s.flow_id            = l.flow_id',
'            and s.security_group_id  = l.security_group_id ) +',
'       ( select count(*)',
'           from wwv_flow_user_interfaces ui',
'          where l.id                 in (ui.navigation_list_id, ui.nav_bar_list_id)',
'            and ui.flow_id            = l.flow_id',
'            and ui.security_group_id  = l.security_group_id ) as ref,',
'       --',
'       coalesce(l.last_updated_on,l.created_on) list_last_updated,',
'       --',
'       decode(substr(list_query,1,1),null,system_message."STATIC",decode(substr(upper(list_query),1,6),''STATIC'',',
'          system_message."STATIC",system_message."DYNAMIC")) list_type,',
'       --',
'      (select PATCH_NAME',
'         from WWV_FLOW_PATCHES p',
'        where security_group_id = :flow_security_group_id',
'          and flow_id = :fb_flow_id and p.id = l.REQUIRED_PATCH) build_option,',
'       --',
'       LIST_COMMENT,',
'       flow_id appliation_id,',
'       ''icon-sc-list'' icon_class,',
'       replace(replace(l.name,''_'','' ''),''.'','' '') icon_title,',
'       --',
'       ''f?p=4000:4050:''||:app_session||''::NO:4050:F4000_P4050_LIST_ID:''||id edit_link,',
'       --',
'      (select decode(count(nav_bar_list_id),0,''N'',''Y'') from wwv_flow_user_interfaces where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and nav_bar_list_id = l.id) navbar,',
'       --',
'      (select decode(count(nav_bar_list_id),0,0,1) from wwv_flow_user_interfaces where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and nav_bar_list_id = l.id) is_navbar,',
'       --',
'       case',
'         when exists (select 1 from wwv_flow_user_interfaces where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and navigation_list_id = l.id) then ''Y''',
'         when exists (select 1 from wwv_flow_steps where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and navigation_list_id = l.id) then ''Y''',
'         else ''N''',
'       end global_nav,',
'       --',
'       case',
'         when exists (select 1 from wwv_flow_user_interfaces where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and navigation_list_id = l.id) then 1',
'         when exists (select 1 from wwv_flow_steps where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and navigation_list_id = l.id) then 1',
'         else 0',
'       end is_navmenu',
'from   wwv_flow_lists l,',
'      (select wwv_flow_lang.system_message(''F4000.DYNAMIC'') "DYNAMIC",',
'              wwv_flow_lang.system_message(''F4000.STATIC'') "STATIC",',
'              wwv_flow_lang.system_message(''NO'') n, wwv_flow_lang.system_message(''YES'') y',
'         from sys.dual) system_message',
'where  l.flow_id = :fb_flow_id',
'and    l.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3852329031687921.4001)
,p_name=>'Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se ha encontrado ninguna lista.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3852507644687930.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3852618182687936.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10668316510182330.4001)
,p_db_column_name=>'LIST_TYPE'
,p_display_order=>3
,p_column_identifier=>'R'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3852724477687936.4001)
,p_db_column_name=>'ENTRIES'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Entradas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3852807138687936.4001)
,p_db_column_name=>'REF'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Referencias'
,p_column_link=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:RP,RIR,CIR:IR_LIST_ID,F4000_LAST_VIEW:#ID#,405'
,p_column_linktext=>'#REF#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3853302862687940.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3856329660735645.4001)
,p_db_column_name=>'LIST_LAST_UPDATED'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3915601776592979.4001)
,p_db_column_name=>'LIST_COMMENT'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3915711641592979.4001)
,p_db_column_name=>'APPLIATION_ID'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3915918201605603.4001)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655605494227595993.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655605591038595994.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1418271239087539235.4001)
,p_db_column_name=>'NAVBAR'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Barra de Navegaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1418271394145539235.4001)
,p_db_column_name=>'GLOBAL_NAV'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>unistr('Men\00FA de Navegaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2328774080872211736.4001)
,p_db_column_name=>'IS_NAVBAR'
,p_display_order=>32
,p_column_identifier=>'W'
,p_column_label=>unistr('Lista de Barra de Navegaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2328774126972211737.4001)
,p_db_column_name=>'IS_NAVMENU'
,p_display_order=>42
,p_column_identifier=>'X'
,p_column_label=>unistr('Men\00FA de Navegaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16367103652607085.4001)
,p_plug_name=>'Listas'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una lista es una recopilaci\00F3n de enlaces compartidos y controlados por plantillas. Utilice las listas para agregar navegaci\00F3n a la aplicaci\00F3n.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/creating-lists.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16374602660635162.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(109454730738768028.4001)
,p_name=>'Editado Recientemente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P405b */',
'replace(replace(l.name,''_'','' ''),''.'','' '') name, id',
'from ',
'     wwv_flow_lists l',
'where l.flow_id = :fb_flow_id',
'and LAST_UPDATED_ON is not null',
'and security_group_id = :flow_security_group_id',
'order by LAST_UPDATED_ON desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna lista'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Imprimir'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Aplicaci\00F3n &FB_FLOW_ID.: &FB_FLOW_NAME.')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109455021661768062.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:4050:F4000_P4050_LIST_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'N'
,p_print_col_width=>'50'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109456924766785289.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_hidden_column=>'Y'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(872115436319501416.4001)
,p_plug_name=>'Recursos de desarrolladores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(26512283167477231.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188938308113866785.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3852226590687921.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:405,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114718231429405838.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3852226590687921.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:658:&SESSION.::&DEBUG.:602,658,663::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16385219339744086.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(3852226590687921.4001)
,p_button_name=>'CreateNewList'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:105,427,464,734,4051,4050,427,440,529::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1427062035438005792.4001)
,p_name=>'P405_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3852226590687921.4001)
,p_item_default=>'0'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(58978832688376841.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'405'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1427062309054010946.4001)
,p_computation_sequence=>20
,p_computation_item=>'P405_SHOW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
,p_compute_when=>'P1500_SHOW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590030329537081954.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(16385219339744086.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590030624679081954.4001)
,p_event_id=>wwv_flow_api.id(590030329537081954.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590033632395104493.4001)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114718231429405838.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590033931572104493.4001)
,p_event_id=>wwv_flow_api.id(590033632395104493.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00406
begin
wwv_flow_api.create_page(
 p_id=>406.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Opciones de Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Opciones de Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_read_only_when_type=>'EXPRESSION'
,p_read_only_when=>'wwv_flow_templates_util.is_template_readonly(:P406_ID)'
,p_read_only_when2=>'PLSQL'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(549193782902061783.4001)
,p_plug_name=>'Opciones de Plantilla'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(549330659415346504.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(549194233979061783.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(549330659415346504.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(549194159983061783.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(549330659415346504.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>':P406_ID is not null and not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(549194001685061783.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(549330659415346504.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>':P406_ID is not null and not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(549309439060246023.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(549330659415346504.4001)
,p_button_name=>'CREATE_AND_ADD_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Agregar Otra'
,p_button_position=>'NEXT'
,p_button_condition=>':P406_ID is null and not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(549193916092061783.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(549330659415346504.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>':P406_ID is null and not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549312236388253559.4001)
,p_branch_action=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_FLOW_ID,P406_TEMPLATE_TYPES,P406_THEME_ID,P406_REGION_TEMPLATE_ID,P406_FIELD_TEMPLATE_ID,P406_BUTTON_TEMPLATE_ID,P406_LIST_TEMPLATE_ID,P406_PAGE_TEMPLATE_ID,P406_BC_TEMPLATE_ID,P406_REPORT_TEMPLATE_ID:&P406_FLOW_ID.,&P406_TEMPLATE_TYPES.,&P406_THEME_ID.,&P406_REGION_TEMPLATE_ID.,&P406_FIELD_TEMPLATE_ID.,&P406_BUTTON_TEMPLATE_ID.,&P406_LIST_TEMPLATE_ID.,&P406_PAGE_TEMPLATE_ID.,&P406_BC_TEMPLATE_ID.,&P406_REPORT_TEMPLATE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(549309439060246023.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549195369697061785.4001)
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(394022566201649705.4001)
,p_name=>'P406_DISPLAY_NAME'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre Mostrado'
,p_source=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la opci\00F3n de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(394022637627649706.4001)
,p_name=>'P406_CSS_CLASSES'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clases CSS'
,p_source=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>83
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca una o m\00E1s clases CSS que definen esta opci\00F3n de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(549195710255061792.4001)
,p_name=>'P406_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(549195901717061792.4001)
,p_name=>'P406_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>':FB_FLOW_ID'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(549196110576061792.4001)
,p_name=>'P406_THEME_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(549196316970061792.4001)
,p_name=>'P406_TEMPLATE_TYPES'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Plantilla'
,p_source=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE OPTION TYPES'
,p_lov=>'.'||wwv_flow_api.id(655584409399418944.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tipo de Plantilla -'
,p_cHeight=>1
,p_read_only_when=>'P406_TEMPLATE_TYPES'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se ha especificado el tipo de plantilla para la que se ha definido la opci\00F3n de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(549196587926061794.4001)
,p_name=>'P406_NAME'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador de Opci\00F3n')
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_read_only_when=>'P406_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un identificador para la opci\00F3n de plantilla; se trata de identificadores alfanum\00E9ricos con todas las letras en may\00FAscula que se utilizan para asignar una opci\00F3n de plantilla a la opci\00F3n de plantilla correspondiente al cambiar los temas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(549196749494061794.4001)
,p_name=>'P406_HELP_TEXT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca una descripci\00F3n de la opci\00F3n de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(574373004203769030.4001)
,p_name=>'P406_GROUP_ID'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Grupo'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, id ',
'from wwv_flow_template_opt_groups',
'where template_types = :P406_TEMPLATE_TYPES',
'and flow_id = :FB_FLOW_ID',
'and theme_id = :P406_THEME_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Forma Parte de un Grupo -'
,p_lov_cascade_parent_items=>'P406_TEMPLATE_TYPES'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca un nombre de grupo \00FAnico. Los nombres de grupo permiten la agrupaci\00F3n de opciones de plantilla para evitar la selecci\00F3n de opciones en conflicto, por ejemplo, las opciones de plantilla de bot\00F3n como "Grande" y "Peque\00F1o" no se deben utiliza')
||'r al mismo tiempo, por lo que ambas deben estar en el mismo grupo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584644137510001195.4001)
,p_name=>'P406_REGION_TEMPLATE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'REGION_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(615800482373742494.4001)
,p_name=>'P406_BUTTON_TEMPLATE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'BUTTON_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(620341349777296166.4001)
,p_name=>'P406_LIST_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'LIST_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628885463976273888.4001)
,p_name=>'P406_FIELD_TEMPLATE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FIELD_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(629612022569030183.4001)
,p_name=>'P406_PAGE_TEMPLATE_ID'
,p_item_sequence=>71
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'PAGE_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631091571358312228.4001)
,p_name=>'P406_BC_TEMPLATE_ID'
,p_item_sequence=>72
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'BREADCRUMB_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(632851039682805953.4001)
,p_name=>'P406_REPORT_TEMPLATE_ID'
,p_item_sequence=>73
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'REPORT_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687818065760118191.4001)
,p_name=>'P406_IS_ADVANCED'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'IS_ADVANCED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687825847085217779.4001)
,p_name=>'P406_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>74
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>unistr('Secuencia de Visualizaci\00F3n')
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(746236236700736692.4001)
,p_name=>'P406_CSS_CLASSES_HIDDEN'
,p_item_sequence=>112
,p_item_plug_id=>wwv_flow_api.id(549193782902061783.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P406_CSS_CLASSES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Introduzca una o m\00E1s clases CSS que definen esta opci\00F3n de plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549194397326061783.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(549194233979061783.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549194745396061785.4001)
,p_event_id=>wwv_flow_api.id(549194397326061783.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(584682667619140354.4001)
,p_name=>'update identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P406_DISPLAY_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P406_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(584682906069140354.4001)
,p_event_id=>wwv_flow_api.id(584682667619140354.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P406_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P406_DISPLAY_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(584686555000250913.4001)
,p_name=>'upper case identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P406_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P406_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(584686848832250913.4001)
,p_event_id=>wwv_flow_api.id(584686555000250913.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P406_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P406_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549198089994061795.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_TEMPLATE_OPTIONS'
,p_attribute_02=>'WWV_FLOW_TEMPLATE_OPTIONS'
,p_attribute_03=>'P406_ID'
,p_attribute_04=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549198241087061796.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_TEMPLATE_OPTIONS'
,p_attribute_02=>'WWV_FLOW_TEMPLATE_OPTIONS'
,p_attribute_03=>'P406_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(746995296727370332.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'push template option css classes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.push_template_opt_classes (',
'    p_flow_id             => :P406_FLOW_ID,',
'    p_template_types      => :P406_TEMPLATE_TYPES,',
'    p_region_template_id  => :P406_REGION_TEMPLATE_ID,',
'    p_button_template_id  => :P406_BUTTON_TEMPLATE_ID,',
'    p_list_template_id    => :P406_LIST_TEMPLATE_ID,',
'    p_field_template_id   => :P406_FIELD_TEMPLATE_ID,',
'    p_page_template_id    => :P406_PAGE_TEMPLATE_ID,',
'    p_bc_template_id      => :P406_BC_TEMPLATE_ID,',
'    p_report_template_id  => :P406_REPORT_TEMPLATE_ID,',
'    p_old_css_classes     => :P406_CSS_CLASSES_HIDDEN,',
'    p_new_css_classes     => :P406_CSS_CLASSES',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(549194001685061783.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1583082273148900314.4001)
,p_process_sequence=>55
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove template option css classes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.remove_template_opt_classes (',
'    p_flow_id             => :P406_FLOW_ID,',
'    p_template_types      => :P406_TEMPLATE_TYPES,',
'    p_region_template_id  => :P406_REGION_TEMPLATE_ID,',
'    p_button_template_id  => :P406_BUTTON_TEMPLATE_ID,',
'    p_list_template_id    => :P406_LIST_TEMPLATE_ID,',
'    p_field_template_id   => :P406_FIELD_TEMPLATE_ID,',
'    p_page_template_id    => :P406_PAGE_TEMPLATE_ID,',
'    p_bc_template_id      => :P406_BC_TEMPLATE_ID,',
'    p_report_template_id  => :P406_REPORT_TEMPLATE_ID,',
'    p_old_css_classes     => :P406_CSS_CLASSES_HIDDEN',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(549194159983061783.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549198402297061797.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(549194159983061783.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549198687485061797.4001)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00408
begin
wwv_flow_api.create_page(
 p_id=>408.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Texto de Ayuda de Elemento'
,p_step_title=>'Editar Texto de Ayuda de Elemento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_hlp_text.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(83241904638634075.4001)
,p_name=>unistr('Ayuda de Elemento para Todos los Elementos de la Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select h.id, i.flow_step_id flow_item_id, h.help_text,',
'       wwv_flow_escape.html(substr(prompt,1,200))||''<br>''||',
'       ''<a href="f?p=4000:4500:''||:flow_session||''::NO::FB_FLOW_PAGE_ID:''||',
'       i.flow_step_id||''#5120:''||i.id||''">''||wwv_flow_escape.html(i.name)||''</a>'' item_name,',
'       nvl(length(h.help_text),0) text_length, i.display_as display_as,',
'       prompt,',
'       t.template_name label_template',
'  from WWV_FLOW_STEP_ITEM_HELP h, ',
'       wwv_flow_step_items i,',
'       wwv_flow_field_templates t',
' where h.flow_id = :fb_flow_id',
'   and i.id = h.flow_item_id(+) ',
'   and i.item_field_template = t.id (+)',
'   and (:P408_HELP_CONTAINS is null or',
'        instr(upper(h.help_text),upper(:P408_HELP_CONTAINS)) > 0) ',
'   and(:P408_ITEM_LABEL_CONTAINS is null or',
'       exists (select 1 ',
'               from wwv_flow_step_items s ',
'               where upper(s.prompt) like',
'                       ''%''||upper(:P408_ITEM_LABEL_CONTAINS)||''%'' and ',
'                     s.id = h.flow_item_id)) and',
'                     nvl(:P408_min_page,0) <= ',
'                    (select flow_step_id ',
'                     from wwv_flow_step_items ',
'                     where id = h.flow_item_id) ',
'   and (nvl(:P408_LENGTH,''1'') = ''1'' or ',
'        length(h.help_text) >= :P408_LENGTH or ',
'        (:P408_LENGTH = ''0'' and h.help_text is null) )',
'   and (nvl(:P408_MAXIMUM_LENGTH,''4000'') = ''4000'' or ',
'        length(help_text) <= :P408_MAXIMUM_LENGTH or ',
'        (:P408_MAXIMUM_LENGTH = ''0'' and h.help_text is null))',
'order by i.flow_step_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P408_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 16-JUL-2003 16:52:04'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100575450196284412.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>9
,p_column_heading=>'Rowid'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(83242409180634082.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(83242501757634082.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_ITEM_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_ITEM_ID#'
,p_column_linktext=>'#FLOW_ITEM_ID#'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(83242601975634082.4001)
,p_query_column_id=>4
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Texto de Ayuda de Elemento'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXTAREA'
,p_column_width=>50
,p_column_height=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(83382014198640933.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta y Nombre de Elemento'
,p_use_as_row_header=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(83277013096780953.4001)
,p_query_column_id=>6
,p_column_alias=>'TEXT_LENGTH'
,p_column_display_sequence=>8
,p_column_heading=>'Longitud de Texto'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(86954914093835714.4001)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Mostrar como'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29353308376249352)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(232981709567058956.4001)
,p_query_column_id=>8
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(506338411372621393.4001)
,p_query_column_id=>9
,p_column_alias=>'LABEL_TEMPLATE'
,p_column_display_sequence=>7
,p_column_heading=>'Plantilla de Etiqueta'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(83246323649640377.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(83246419054640380.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ITEM_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(83246500178640380.4001)
,p_column_sequence=>3
,p_query_column_name=>'HELP_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(83381800922640931.4001)
,p_column_sequence=>4
,p_query_column_name=>'ITEM_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(83276904305780951.4001)
,p_column_sequence=>5
,p_query_column_name=>'TEXT_LENGTH'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(86954816677835705.4001)
,p_column_sequence=>6
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(232981609633058898.4001)
,p_column_sequence=>7
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(506338313380621387.4001)
,p_column_sequence=>8
,p_query_column_name=>'LABEL_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152757429221968450.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>93
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194137629006054982.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(83268213269713109.4001)
,p_button_sequence=>62
,p_button_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_button_name=>'P408_GO'
,p_button_static_id=>'P408_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(240660527917823543.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_button_name=>'SEED_ITEM_HELP_TEXT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Extraer Texto de Ayuda de Elemento'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(83242820615634083.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(83243726157634087.4001)
,p_branch_action=>'f?p=&FLOW_ID.:408:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 16-JUL-2003 16:52:04'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(83267109459712051.4001)
,p_name=>'P408_HELP_CONTAINS'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_prompt=>'La Ayuda Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Introduzca una consulta para buscar texto de ayuda de elemento y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(83384715158650375.4001)
,p_name=>'P408_ITEM_LABEL_CONTAINS'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_prompt=>'La Etiqueta de Elemento Contiene'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Introduzca una consulta para buscar texto de etiqueta de elemento y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(83401518284727023.4001)
,p_name=>'P408_ROWS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique el n\00FAmero de elementos que aparecer\00E1n en el informe y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(83479318994928899.4001)
,p_name=>'P408_MIN_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_item_default=>'0'
,p_prompt=>unistr('N\00FAmero M\00EDnimo de P\00E1gina')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique el n\00FAmero de p\00E1gina m\00EDnimo que va a devolver esta b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(84374716671828683.4001)
,p_name=>'P408_LENGTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_item_default=>'1'
,p_prompt=>unistr('Longitud M\00EDnima')
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la longitud m\00EDnima de las cadenas de ayuda de elemento que va a devolver esta b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85135225207965242.4001)
,p_name=>'P408_MAXIMUM_LENGTH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(152757429221968450.4001)
,p_prompt=>unistr('Longitud M\00E1xima')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la longitud m\00E1xima de las cadenas de ayuda de elemento que va a devolver esta b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(83243302489634085.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(83241904638634075.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEM_HELP'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(83242820615634083.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(83252621140658581.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00410
begin
wwv_flow_api.create_page(
 p_id=>410.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Confirmar Copia de Tema'
,p_step_title=>'Copiar Tema'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60297525857108229.4001)
,p_plug_name=>'Confirmar Copia de Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>131
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106497805751430232.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106491204103410821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200254321663371405.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747141822577138162.4001)
,p_plug_name=>'Copiar Tema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60299526820108242.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200254321663371405.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60298707061108240.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200254321663371405.4001)
,p_button_name=>'CHANGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Tema'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(60299103865108241.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200254321663371405.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(60301629315108266.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60299912376108248.4001)
,p_name=>'P410_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(60297525857108229.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60300304760108257.4001)
,p_name=>'P410_COPY_THEME_FROM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(60297525857108229.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copiar Identificador de Tema de:'
,p_source=>'P401_COPY_FROM_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60300708612108258.4001)
,p_name=>'P410_COPY_TO_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(60297525857108229.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copiar Identificador de Tema a:'
,p_source=>'P401_COPY_TO_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(60301216009108264.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.copy_theme(',
'  p_from_flow_id    => :P401_APPLICATION, ',
'  p_to_flow_id      => :fb_flow_id, ',
'  p_from_theme      => :P401_COPY_FROM_ID , ',
'  p_to_theme        => :P401_COPY_TO_ID,',
'  p_subscribe_theme => (:P401_SUBSCRIBE_THEME=''Y'')',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar el tema.'
,p_process_when_button_id=>wwv_flow_api.id(60298707061108240.4001)
,p_process_success_message=>'Tema copiado.'
);
end;
/
prompt --application/pages/page_00412
begin
wwv_flow_api.create_page(
 p_id=>412.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Lista: Identificar Tema'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152181100157104536.4001)
,p_plug_name=>'Crear Plantilla de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(152181510374104540.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186373505426133557.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152182729615104543.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186373505426133557.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152183524736104546.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186373505426133557.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(152183120977104546.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186373505426133557.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152188902322104566.4001)
,p_branch_action=>'f?p=&FLOW_ID.:159:&SESSION.::&DEBUG.:159::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(152183524736104546.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585125146735099814.4001)
,p_branch_action=>'f?p=&APP_ID.:4069:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(152183120977104546.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152183920997104548.4001)
,p_name=>'P412_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152184603209104552.4001)
,p_name=>'P412_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'F4000_P4069_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152185312007104555.4001)
,p_name=>'P412_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152186006914104556.4001)
,p_name=>'P412_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152186731846104557.4001)
,p_name=>'P412_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se van a copiar las plantillas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152187412516104559.4001)
,p_name=>'P412_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P4069_COPY_FROM_FLOW_ID  ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152188124711104560.4001)
,p_name=>'P412_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(152181100157104536.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2346316376971914203.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P412_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585124902185099812.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(152182729615104543.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585125087770099813.4001)
,p_event_id=>wwv_flow_api.id(585124902185099812.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00413
begin
wwv_flow_api.create_page(
 p_id=>413.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Bot\00F3n: Identificar Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154552725827206716.4001)
,p_plug_name=>unistr('Crear Plantilla de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154553132414206727.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186378501018189095.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154554304247206734.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186378501018189095.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154555100740206743.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186378501018189095.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154554703210206743.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186378501018189095.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154560510194206783.4001)
,p_branch_action=>'f?p=&FLOW_ID.:223:&SESSION.::&DEBUG.:223::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154555100740206743.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585126834896099831.4001)
,p_branch_action=>'f?p=&APP_ID.:219:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154554703210206743.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154555508995206745.4001)
,p_name=>'P413_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154556224411206754.4001)
,p_name=>'P413_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'F4000_P219_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154556932617206758.4001)
,p_name=>'P413_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154557625846206759.4001)
,p_name=>'P413_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154558319348206760.4001)
,p_name=>'P413_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154559024463206761.4001)
,p_name=>'P413_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P219_COPY_FROM_FLOW_ID   ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154559729010206763.4001)
,p_name=>'P413_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(154552725827206716.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t_to.theme_id||''. '' ||t_to.theme_name as d,',
'       t_to.theme_id',
'  from wwv_flow_themes t_from,',
'       wwv_flow_themes t_to',
' where t_from.flow_id           = :F4000_P219_COPY_FROM_FLOW_ID',
'   and t_from.theme_id          = :P413_COPY_FROM_THEME',
'   and t_from.security_group_id = :WORKSPACE_ID  ',
'   and t_to.flow_id             = :fb_flow_id',
'   and t_to.ui_type_id          = t_from.ui_type_id',
'   and t_to.security_group_id   = :WORKSPACE_ID  ',
' order by t_to.theme_id'))
,p_lov_cascade_parent_items=>'P413_COPY_FROM_THEME'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2346316420352914204.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P413_COPY_TO_THEME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(201412702449870614.4001)
,p_computation_sequence=>10
,p_computation_item=>'P413_COPY_FROM_THEME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P219_COPY_FROM_FLOW_ID   ',
'order by 1'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585126648527099829.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(154554304247206734.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585126707576099830.4001)
,p_event_id=>wwv_flow_api.id(585126648527099829.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00414
begin
wwv_flow_api.create_page(
 p_id=>414.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Buscador de Sustituci\00F3n de Elementos')
,p_step_title=>unistr('Buscador de Sustituci\00F3n de Elementos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'function passBack(x)',
'{',
'    temp = document.getElementById(''P414_CALLING_FIELD'').value;',
'    targetField = window.opener.document.getElementById(temp);',
'    targetField.value = x;',
'    targetField.focus;',
'    close();',
'    //opener.document.forms["wwv_flow"].targetField.value = x;',
'    //opener.document.forms["wwv_flow"].targetField.focus();',
'    //close();',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19710231706789100.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(19710526685789103.4001)
,p_name=>'Elementos'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="javascript:passBack(''''''||''\&''||wwv_flow_escape.html(name)||''.''||'''''');">&''||wwv_flow_escape.html(name)||''.</a>''  name1 , wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t, 0 p ,2 seq',
'from wwv_flow_items',
'where (instr(name,upper(:P414_SEARCH)) > 0 OR :P414_SEARCH IS NULL) and',
'   :P414_PAGE is null',
'and flow_id = :fb_flow_id',
'union all',
'select ''<a href="javascript:passBack(''''''||''\&''||wwv_flow_escape.html(name)||''.''||'''''');">&''||wwv_flow_escape.html(name)||''.</a>'' name1 , wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t, flow_step_id p, 2 seq',
'from wwv_flow_step_items',
'where (instr(name,upper(:P414_SEARCH)) > 0 OR :P414_SEARCH IS NULL) and',
'   (:P414_PAGE is null or :P414_PAGE = flow_step_id)',
'and flow_id = :fb_flow_id',
'order by seq,1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_num_rows_item=>'P414_MAX_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48786014414772209.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME1'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48786121240772209.4001)
,p_query_column_id=>2
,p_column_alias=>'T'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48786224180772209.4001)
,p_query_column_id=>3
,p_column_alias=>'P'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(106619310130591618.4001)
,p_query_column_id=>4
,p_column_alias=>'SEQ'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19712622853789146.4001)
,p_button_sequence=>129
,p_button_plug_id=>wwv_flow_api.id(19710231706789100.4001)
,p_button_name=>'P414_GO'
,p_button_static_id=>'P414_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19711719596789116.4001)
,p_name=>'P414_SEARCH'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(19710231706789100.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>. Para verlo todo, deje el campo en blanco y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19712024851789143.4001)
,p_name=>'P414_PAGE'
,p_item_sequence=>109
,p_item_plug_id=>wwv_flow_api.id(19710231706789100.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Para visualizar s\00F3lo los elementos de una p\00E1gina concreta, seleccione o introduzca un n\00FAmero de p\00E1gina y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19712322858789145.4001)
,p_name=>'P414_MAX_ROWS'
,p_item_sequence=>119
,p_item_plug_id=>wwv_flow_api.id(19710231706789100.4001)
,p_item_default=>'15'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 en el informe y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19712930226789147.4001)
,p_name=>'P414_CALLING_FIELD'
,p_item_sequence=>109
,p_item_plug_id=>wwv_flow_api.id(19710526685789103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19713331669789167.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00415
begin
wwv_flow_api.create_page(
 p_id=>415.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n: Identificar Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154578426244360407.4001)
,p_plug_name=>unistr('Crear Plantilla de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154578800368360412.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186383515872240645.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154580019749360416.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186383515872240645.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154580817404360420.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186383515872240645.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154580422398360420.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186383515872240645.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154586201863360441.4001)
,p_branch_action=>'f?p=&FLOW_ID.:242:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154580817404360420.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585128528551099848.4001)
,p_branch_action=>'f?p=&APP_ID.:241:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154580422398360420.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154581227773360422.4001)
,p_name=>'P415_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'F4000_P241_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154581908878360426.4001)
,p_name=>'P415_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154582621781360427.4001)
,p_name=>'P415_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154583307331360432.4001)
,p_name=>'P415_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154584002607360433.4001)
,p_name=>'P415_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P241_COPY_FROM_FLOW_ID   ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154584731052360434.4001)
,p_name=>'P415_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154585420503360435.4001)
,p_name=>'P415_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(154578426244360407.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2346316632669914206.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P415_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585128342482099846.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(154580019749360416.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585128408497099847.4001)
,p_event_id=>wwv_flow_api.id(585128342482099846.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00417
begin
wwv_flow_api.create_page(
 p_id=>417.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Mostrar Referencias de P\00E1ginas de Uso')
,p_step_title=>unistr('Mostrar Referencias de P\00E1ginas de Uso')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7390729703813409.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>0
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161737509765957489.4001)
,p_plug_name=>'Uso de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Esta p\00E1gina identifica las p\00E1ginas que hacen referencia a la lista seleccionada.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185271801825507433.4001)
,p_plug_name=>unistr('Mostrar Referencias de P\00E1ginas de Uso')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    l.name list_name,',
'    p.page_id,',
'    (select name from wwv_flow_steps where flow_id = :fb_flow_id and id = p.page_Id) page_name,',
'    p.plug_name region_name,',
'    l.id list_id',
'from wwv_flow_page_plugs p,',
'     wwv_flow_lists l',
'where l.flow_id = :fb_flow_id and',
'      p.flow_id = :fb_flow_id and',
'      p.list_id = l.id',
'union all',
'select',
'    l.name list_name,',
'    p.id   as page_id,',
'    p.name as page_name,',
'    null   as region_name,',
'    l.id list_id',
'from wwv_flow_steps p,',
'     wwv_flow_lists l',
'where l.flow_id            = :fb_flow_id and',
'      p.flow_id            = :fb_flow_id and',
'      p.navigation_list_id = l.id',
'union all',
'select',
'    l.name list_name,',
'    null            as page_id,',
'    ui.display_name as page_name,',
'    null            as region_name,',
'    l.id            as list_id',
'from wwv_flow_user_interfaces ui,',
'     wwv_flow_lists l',
'where l.flow_id  = :fb_flow_id and',
'      ui.flow_id = :fb_flow_id and',
'      l.id      in (ui.navigation_list_id, ui.nav_bar_list_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(185271900690507433.4001)
,p_name=>'List Utilization Page References'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185272130425507436.4001)
,p_db_column_name=>'LIST_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre de la Lista'
,p_column_link=>'f?p=#FLOW_ID#:4051:#FLOW_SESSION#:::4052:F4000_P4051_ID:#LIST_ID#'
,p_column_linktext=>'#LIST_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185272424002507438.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185272511819507439.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Nombre de P\00E1gina/Interfaz de Usuario')
,p_column_link=>'f?p=#FLOW_ID#:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185272616709507440.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185272706418507440.4001)
,p_db_column_name=>'LIST_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Lista Seleccionada'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185274814728535753.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(185271801825507433.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(44051606540921535.4001)
,p_branch_action=>'f?p=&FLOW_ID.:417:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(44074931033037275.4001)
,p_name=>'P417_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185271801825507433.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00418
begin
wwv_flow_api.create_page(
 p_id=>418.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Calendario Heredado: Identificar Tema'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Calendario Heredado'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154611503855448015.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154611930364448016.4001)
,p_plug_name=>'Crear Plantilla de Calendario Heredado'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186388517828307448.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154612323383448018.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186388517828307448.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154613117222448020.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186388517828307448.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154612726149448020.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186388517828307448.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154618523699448048.4001)
,p_branch_action=>'f?p=&FLOW_ID.:469:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154613117222448020.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589887020729923015.4001)
,p_branch_action=>'f?p=&APP_ID.:468:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154612726149448020.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154613515130448023.4001)
,p_name=>'P418_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'P468_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154614224756448033.4001)
,p_name=>'P418_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se van a copiar las plantillas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154614927630448035.4001)
,p_name=>'P418_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154615607822448036.4001)
,p_name=>'P418_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se van a copiar las plantillas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154616323914448038.4001)
,p_name=>'P418_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P468_COPY_FROM_FLOW_ID  ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154617000825448039.4001)
,p_name=>'P418_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema al que se van a copiar las plantillas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154617705762448042.4001)
,p_name=>'P418_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(154611930364448016.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2346316795230914207.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P418_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589886807208923013.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(154612323383448018.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589886922936923014.4001)
,p_event_id=>wwv_flow_api.id(589886807208923013.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00419
begin
wwv_flow_api.create_page(
 p_id=>419.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Listas de Valores Definidas Localmente'
,p_step_title=>'Listas de Valores Definidas Localmente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5092501799941838.4001)
,p_plug_name=>'Listas de valores definidas localmente'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id,',
'       name,',
'       substr(lov,1,3000) lov,',
'       id,',
'       flow_id appl_id,',
'       id action,',
'       ''PAGE_ITEM'' source_type,',
'       ''PAGE_ITEM'' source_type_disp       ',
'  from wwv_flow_step_items',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:FLOW_SECURITY_GROUP_ID)',
'   and lov is not null',
'   and named_lov is null',
' union all',
'select page_id flow_step_id,',
'       name,',
'       substr(lov_source,1,3000) lov_source,',
'       id,',
'       flow_id appl_id,',
'       id action,',
'       ''IG_COLUMN'' source_type,',
'       ''IG_COLUMN'' source_type_disp       ',
'  from wwv_flow_region_columns',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:FLOW_SECURITY_GROUP_ID)',
'   and lov_source is not null',
'   and lov_id is null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(5092616502941838.4001)
,p_name=>'All items with a locally defined LOV in application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5093117980941841.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'D'
,p_column_label=>'Editar'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5092818622941841.4001)
,p_db_column_name=>'FLOW_STEP_ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5092909205941841.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5093026781941841.4001)
,p_db_column_name=>'LOV'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Lista de Valores'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5093221938941841.4001)
,p_db_column_name=>'APPL_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Appl_Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(676797610069887615.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>unistr('Acci\00F3n')
,p_column_link=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:RP,52:F4000_P52_SOURCE_ID,F4000_P52_SOURCE_TYPE:#ID#,#SOURCE_TYPE#'
,p_column_linktext=>'Convertir'
,p_column_link_attr=>'class="a-Button a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2701992394095217.4001)
,p_db_column_name=>'SOURCE_TYPE'
,p_display_order=>25
,p_column_identifier=>'G'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2702027978095218.4001)
,p_db_column_name=>'SOURCE_TYPE_DISP'
,p_display_order=>35
,p_column_identifier=>'H'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(3801130412459159)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47155605424266875.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240644224753794260.4001)
,p_plug_name=>'Listas de Valores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice este informe para ver todas las listas de valores que se han definido localmente con la definici\00F3n del elemento o de la columna de cuadr\00EDcula interactiva. Las listas de valores que pueden utilizar varias p\00E1ginas se pueden convertir en list')
||unistr('as de valores compartidas. Al convertir las listas de valores definidas localmente en listas de valores compartidas, se fomenta su reutilizaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188989617066991407.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5092501799941838.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:419:&SESSION.::&DEBUG.:419,RIR::'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(681995446457644709.4001)
,p_name=>'Refresh on Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(5092501799941838.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(681995547673644710.4001)
,p_event_id=>wwv_flow_api.id(681995446457644709.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5092501799941838.4001)
);
end;
/
prompt --application/pages/page_00425
begin
wwv_flow_api.create_page(
 p_id=>425.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Dependencias de Objetos de Base de Datos'
,p_step_title=>'Dependencias de Objetos de Base de Datos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216995930363945283)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117041714963183518.4001)
,p_plug_name=>'Tareas de Dependencias'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>81
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(117039522797176386.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'1=2'
,p_plug_display_when_cond2=>'SQL'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(189978131357209480.4001)
,p_name=>'Database Object Dependencies'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>145
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'decode(c003,''NON-EXISTENT'',wwv_flow_lang.system_message(''LAYOUT.T_PAGE_PUBLIC''),c001) c001,',
'c002,',
'decode(c003,''NON-EXISTENT'',c002, c002) name,',
'initcap(decode(c003,''NON-EXISTENT'',null,htmldb_item.text_from_lov(c003,''OBJECT.TYPES''))) c003,',
'count(*) c,',
'c012',
'from htmldb_collections',
'where collection_name = ''ALL_DEPENDENCIES''',
'  and c008 = :fb_flow_id',
'  and c002 <> ''PLITBLM''',
'group by c001,c002,c003,c012',
'order by 1,2,3'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
'      c002 is null and ',
'      c001 = :fb_flow_id'))
,p_display_condition_type=>'EXISTS'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No se ha encontrado ninguna dependencia'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'c003 != ''NON-EXISTENT'' and -- objects referenced through public synonyms'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189978616640209486.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Propietario'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189978710291209486.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>3
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(217916907698969155.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre con Referencia'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189978820234209486.4001)
,p_query_column_id=>4
,p_column_alias=>'C003'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo con Referencia'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189978515126209485.4001)
,p_query_column_id=>5
,p_column_alias=>'C'
,p_column_display_sequence=>5
,p_column_heading=>'Recuento de Referencias'
,p_column_link=>'f?p=&APP_ID.:434:&SESSION.::&DEBUG.:RP,:P434_OBJECT_NAME,P434_OBJECT_OWNER:#C002#,#C001#'
,p_column_linktext=>'#C#'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199906008859604604.4001)
,p_query_column_id=>6
,p_column_alias=>'C012'
,p_column_display_sequence=>6
,p_column_heading=>'C012'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(189978930676209486.4001)
,p_name=>unistr('Errores de An\00E1lisis')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>151
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c001 obj_name,',
'c002,',
'c003,',
'c004,',
'c005,',
'c006,',
'c007,',
'c008,',
'c009,',
'c010,',
'c011,',
'c012',
'from htmldb_collections',
'where collection_name = ''ALL_DEPENDENCIES_ERRORS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
'      c002 is null and ',
'      c001 = :fb_flow_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn error de an\00E1lisis')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1301369475015065003.4001)
,p_query_column_id=>1
,p_column_alias=>'OBJ_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189979403132209488.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#C002#'
,p_column_linktext=>'#C002#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189979522257209488.4001)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189979611762209488.4001)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189979700821209489.4001)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189980304369209489.4001)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189980417842209489.4001)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189979827650209489.4001)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189979909579209489.4001)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'Compilado como'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189980212117209489.4001)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'Analizado como'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189980015277209489.4001)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'Estado de Objeto Temporal'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189980130700209489.4001)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>unistr('L\00EDneas')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(189980503162209490.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(189983008511209494.4001)
,p_name=>unistr('Par\00E1metros del Informe')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>91
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,c002,c003,c004',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
' c002 is null and ',
' c001 = :fb_flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189983421297209495.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189983524853209495.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#C002#'
,p_column_linktext=>'#C002#'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189983604131209495.4001)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'Report Date'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(189983722367209495.4001)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'Developer'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(199893827728572290.4001)
,p_plug_name=>'Dependencias'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>71
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Este informe identifica los objetos de base de datos a los que hace referencia esta aplicaci\00F3n. Haga clic en el valor de recuento de referencias para ver los componentes que hacen referencia a un objeto de base de datos espec\00EDfico.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(189983829733209496.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(189980503162209490.4001)
,p_button_name=>'COMPUTE_DEPENDENCIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Calcular Dependencias'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(189988600686209526.4001)
,p_branch_action=>'f?p=&FLOW_ID.:425:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(189988201444209523.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate collection'
,p_process_sql_clob=>'wwv_flow_theme_manager.find_object_dependencies(p_flow_id=>:fb_flow_id,p_page_id=>null);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido rellenar la recopilaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(189983829733209496.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(189987812224209522.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00427
begin
wwv_flow_api.create_page(
 p_id=>427.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista: Nombre y Tipo'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear/Editar: Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44559806328153978.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169154800779310998.4001)
,p_plug_name=>'Crear Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Una lista es una recopilaci\00F3n compartida de enlaces y cada enlace se denomina entrada de lista. Puede controlar el aspecto de una lista mediante plantillas de lista. La lista se agrega a la p\00E1gina creando una regi\00F3n de lista. Al suprimir una lista se')
||unistr(' eliminar\00E1n las regiones de referencia.<br /><br />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169187328626601952.4001)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(169186610834587350.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169155810046311006.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44559806328153978.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169156024918311006.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44559806328153978.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169205715557755270.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44559806328153978.4001)
,p_button_name=>'CREATE_LIST'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Lista'
,p_button_position=>'CREATE'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1419724585904043.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44559806328153978.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169206014075755271.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(169205715557755270.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169190626904677153.4001)
,p_branch_action=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P427_LIST_TYPE = ''STATIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1433223199603862.4001)
,p_branch_action=>'f?p=&APP_ID.:464:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(169156024918311006.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P427_LIST_TYPE = ''DYNAMIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1420230603915204.4001)
,p_branch_action=>'f?p=&APP_ID.:105:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1419724585904043.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1424823602357946.4001)
,p_name=>'P427_LIST_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(169154800779310998.4001)
,p_prompt=>'Tipo:'
,p_source=>'STATIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LOV.TYPE'
,p_lov=>'.'||wwv_flow_api.id(84909926183685150.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Seleccione un tipo de lista.</div>',
unistr('<div class="htmldbInfoBodyP">Una lista est\00E1tica se basa en valores de visualizaci\00F3n y de retorno predefinidos. Una lista din\00E1mica se basa en una consulta SQL o funci\00F3n PL/SQL ejecutada en tiempo de ejecuci\00F3n.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169156618404311009.4001)
,p_name=>'P427_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(169154800779310998.4001)
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169157114381311011.4001)
,p_name=>'P427_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(169154800779310998.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca un nombre para la lista que est\00E1 creando. Se permiten los nombres de lista con caracteres num\00E9ricos y alfanum\00E9ricos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169158504652311018.4001)
,p_name=>'P427_REQUIRED_PATCH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(169154800779310998.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(169159500086311023.4001)
,p_validation_name=>'P427_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P427_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(169156618404311009.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-MAY-2002 16:30'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574134511962781501.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(169155810046311006.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574134636451781502.4001)
,p_event_id=>wwv_flow_api.id(574134511962781501.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169214325421487301.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  x number;',
'  p number := null;',
'begin',
'  x := wwv_flow_id.next_val;',
'  begin',
'  p := :P427_REQUIRED_PATCH;',
'  exception when others then p := null;',
'  end;',
' ',
'for c1 in (select id from wwv_flows where id = :fb_flow_id and security_group_id = :flow_security_group_id) loop',
'',
'insert into WWV_FLOW_LISTS (',
'   ID, FLOW_ID , NAME, ',
'   LIST_STATUS, LIST_DISPLAYED,',
'   REQUIRED_PATCH,',
'   CREATED_ON, CREATED_BY)',
'values (',
'   x, c1.id, :P427_NAME,',
'   ''PUBLIC'', ''BY_DEFAULT'',',
'   p,',
'   sysdate, :app_user); ',
'null;',
'end loop;',
'',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(169205715557755270.4001)
,p_process_success_message=>'Lista Creada'
);
end;
/
prompt --application/pages/page_00431
begin
wwv_flow_api.create_page(
 p_id=>431.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Buscador de Procedimientos'
,p_step_title=>'Buscador de Procedimientos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507600580299857)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function refreshArguments(pObjectId, pSubprogramId) {',
'    $s(''P431_OBJECT_ID'', pObjectId);',
'    $s(''P431_SUBPROGRAM_ID'', pSubprogramId);',
'    apex.jQuery(''#ARGUMENTS'').trigger(''apexrefresh'');',
'}'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(794819025526089.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>7
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(60836911211955069.4001)
,p_name=>'Argumentos'
,p_region_name=>'ARGUMENTS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select argument_name,',
'       in_out,',
'       coalesce (',
'           type_name||rtrim(''.''||type_subname, ''.''),',
'           pls_type,',
'           data_type ) data_type,',
'       case defaulted',
'       when ''Y'' then ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''WWV_FLOW_CUSTOMIZE.T_DEFAULT'')||''</span>''',
'       end defaulted',
'  from sys.dba_arguments',
' where object_id             = :P431_OBJECT_ID',
'   and nvl(subprogram_id,-1) = nvl(:P431_SUBPROGRAM_ID,-1)',
'   and data_level            = 0',
'   and argument_name         is not null',
'order by position'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P431_OBJECT_ID,P431_SUBPROGRAM_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1475461848194625323.4001)
,p_query_column_id=>1
,p_column_alias=>'ARGUMENT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre del Argumento'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1475461944955625324.4001)
,p_query_column_id=>2
,p_column_alias=>'IN_OUT'
,p_column_display_sequence=>2
,p_column_heading=>'Entrada y Salida'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1475462026733625325.4001)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo de Dato'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1475462123673625326.4001)
,p_query_column_id=>4
,p_column_alias=>'DEFAULTED'
,p_column_display_sequence=>4
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(478895921312673213.4001)
,p_plug_name=>'Procedimientos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.object_type,',
'       p.object_name,',
'       p.procedure_name,',
'       p.object_id, ',
'       p.subprogram_id,',
'       (select coalesce (',
'                   a.type_name||rtrim(''.''||a.type_subname, ''.''),',
'                   a.pls_type,',
'                   a.data_type )',
'          from sys.dba_arguments a',
'         where a.object_id             = p.object_id',
'           and nvl(a.subprogram_id,-1) = nvl(p.subprogram_id,-1)',
'           and a.data_level            = 0',
'           and a.argument_name         is null ) return_type,',
'       overload',
'  from sys.dba_procedures p',
' where p.owner = (select owner from wwv_flows',
'                   where id                = :fb_flow_id ',
'                     and security_group_id = :flow_security_group_id)',
'   and p.object_name not like ''BIN$%''',
'   and (p.procedure_name is not null',
'        or p.object_type in (''FUNCTION'', ''PROCEDURE''))',
' order by p.object_name, p.procedure_name, p.overload'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'old query',
'select distinct o.object_name as "NAME",',
'       o.object_id, ',
'       o.object_type "Type"',
'  from sys.dba_objects    o, ',
'       sys.dba_procedures p, ',
'       dba_arguments  a',
' Where o.owner = (select owner from wwv_flows',
'                   where id = :fb_flow_id ',
'                     and security_group_id = :flow_security_group_id)',
'   and a.object_id(+) = o.object_id',
'   and p.object_name = o.object_name',
'   and p.owner = o.owner'))
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(478896025956673213.4001)
,p_name=>'Procedures'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'javascript:refreshArguments(#OBJECT_ID#, #SUBPROGRAM_ID#)'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478896322057673356.4001)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Identificador de Objeto'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475461276046625317.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>12
,p_column_identifier=>'D'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475461390426625318.4001)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>22
,p_column_identifier=>'E'
,p_column_label=>'Nombre del Objeto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475461408661625319.4001)
,p_db_column_name=>'PROCEDURE_NAME'
,p_display_order=>32
,p_column_identifier=>'F'
,p_column_label=>'Nombre del Procedimiento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475461557329625320.4001)
,p_db_column_name=>'SUBPROGRAM_ID'
,p_display_order=>42
,p_column_identifier=>'G'
,p_column_label=>'ID de Subprograma'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475462884043625333.4001)
,p_db_column_name=>'RETURN_TYPE'
,p_display_order=>52
,p_column_identifier=>'L'
,p_column_label=>'Tipo de Retorno'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1475462973461625334.4001)
,p_db_column_name=>'OVERLOAD'
,p_display_order=>62
,p_column_identifier=>'M'
,p_column_label=>'Sobrecarga'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(478898901441737230.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(478895921312673213.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:431:&SESSION.::&DEBUG.:RIR,431::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(822730298218559.4001)
,p_branch_action=>'f?p=&APP_ID.:431:&SESSION.:GO:&DEBUG.:RP:P431_OBJECT_ID,P431_PROC_ID:,'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(986304972715987.4001)
,p_name=>'P431_OBJECT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(478895921312673213.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475461720321625322.4001)
,p_name=>'P431_SUBPROGRAM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(478895921312673213.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00432
begin
wwv_flow_api.create_page(
 p_id=>432.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Script'
,p_step_title=>'Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(394076544392764142.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(400150656448459196.4001)
,p_plug_name=>'Script (plug-in)'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Rem''||chr(10)||',
'       ''Rem  ''||name||chr(10)||',
'       ''Rem''||chr(10)||',
'       script||chr(10) script_clob',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''INSTALL''',
'order by sequence, name'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attribute_01=>'DDL'
,p_attribute_02=>'AUTO'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405358991162522181.4001)
,p_plug_name=>unistr('Scripts de Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Utilice scripts de instalaci\00F3n para crear objetos, im\00E1genes y datos iniciales de base de datos cuando se instale esta aplicaci\00F3n.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(394077098167788720.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(394076544392764142.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(394077326193795820.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(394076544392764142.4001)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Descargar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(394435235708863310.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download install script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_init_htp_buffer;',
'wwv_flow_utilities.print_download_header (',
'       p_mime_type     => ''application/x-sql'',',
'       p_mime_charset  => ''utf-8'',',
'       p_file_name     => ''install_script.sql'',',
'       p_is_attachment => true );',
'sys.owa_util.http_header_close;',
'',
'for c1 in (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id',
'               and nvl(script_type,''INSTALL'') = ''INSTALL''',
'               order by sequence, name)',
'loop',
'    sys.htp.p(''Rem'');',
'    sys.htp.p(''Rem  ''||c1.name);',
'    sys.htp.p(''Rem'');',
'    wwv_htp.print_clob(c1.script);',
'    sys.htp.p(chr(10));',
'end loop;',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido descargar los scripts de instalaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(394077326193795820.4001)
);
end;
/
prompt --application/pages/page_00434
begin
wwv_flow_api.create_page(
 p_id=>434.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Dependencias de Objetos de Base de Datos de la Aplicaci\00F3n: Referencias de P\00E1gina')
,p_step_title=>unistr('Referencias de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(216995930363945283)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(190110104426683781.4001)
,p_name=>unistr('Referencias de Objetos por P\00E1gina')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'c005 page,',
'(select max(name) name from wwv_flow_steps where id = to_number(c005) and flow_id = :fb_flow_id) page_name,',
'c004 component_name,',
'c010 component_type,',
'c011 component_class',
'from htmldb_collections',
'where collection_name = ''ALL_DEPENDENCIES'' and',
'      c008 = :fb_flow_id and',
'      (c001 = :P434_object_owner or :P434_object_owner = ''Public'') and',
'      c002 = :P434_object_name',
'order by to_number(c005), c002, c003, c004'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
'      c002 is null and ',
'      c001 = :fb_flow_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No se ha encontrado ninguna dependencia'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(190144201234777460.4001)
,p_query_column_id=>1
,p_column_alias=>'PAGE'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(190150107729798233.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(190137221573759487.4001)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Componente'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(190137329391759487.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(191684829238192510.4001)
,p_query_column_id=>5
,p_column_alias=>'COMPONENT_CLASS'
,p_column_display_sequence=>5
,p_column_heading=>'Component Subtype'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32361488916)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(199887517077550275.4001)
,p_plug_name=>'Referencias de Objetos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Este informe identifica los componentes de aplicaci\00F3n que hacen referencia al objeto de base de datos seleccionado.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(199889607857557029.4001)
,p_plug_name=>'context'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(190114730399691268.4001)
,p_name=>'P434_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(199889607857557029.4001)
,p_prompt=>'Propietario de Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifica el esquema propietario del objeto de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(190116203171692846.4001)
,p_name=>'P434_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(199889607857557029.4001)
,p_prompt=>'Nombre del Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre de objeto de base de datos para el que este informe muestra dependencias.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00435
begin
wwv_flow_api.create_page(
 p_id=>435.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Informes de Temas'
,p_step_title=>'Informes de Temas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(135991313936355968.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(58949101764235429.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(141776100493350165.4001)
,p_name=>'Referencias de Archivo de Plantilla'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'initcap(c001) c001,',
'c002,',
'c003,',
'c004,',
'c005,',
'decode(lower(c006),''js'','''',''css'','''',''<img src="''||c005||''" />'') image,',
'c007 page_id',
'from htmldb_collections',
'where collection_name = ''FILES'''))
,p_display_when_condition=>'P435_SHOW_FILES'
,p_display_when_cond2=>'CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'No se ha encontrado ninguna plantilla'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141776711956350201.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Componente'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141776816603350201.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Tema'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141776922770350202.4001)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'Class'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141777021286350202.4001)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141777101497350202.4001)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'Archivo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141783516816383262.4001)
,p_query_column_id=>6
,p_column_alias=>'IMAGE'
,p_column_display_sequence=>6
,p_column_heading=>'Imagen'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(151997720960707992.4001)
,p_query_column_id=>7
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>7
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(142975707446929316.4001)
,p_plug_name=>'Report Preferences'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>25
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(152136325714002617.4001)
,p_name=>'Referencias de Archivo'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c005 file_name,',
'decode(lower(c006),''js'','''',''css'','''',''<img src="''||c005||''" />'') image',
'from htmldb_collections',
'where collection_name = ''FILES''',
'order by 1'))
,p_display_when_condition=>'P435_SHOW_FILES'
,p_display_when_cond2=>'NO_CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(152136910946002953.4001)
,p_query_column_id=>1
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'FILE_NAME'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(152137017683002953.4001)
,p_query_column_id=>2
,p_column_alias=>'IMAGE'
,p_column_display_sequence=>2
,p_column_heading=>'IMAGE'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(142981418659942037.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_button_name=>'P435_GO'
,p_button_static_id=>'P435_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ir'
,p_button_position=>'NEXT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205457520384727173.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'1'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205461914628734984.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'2'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205464410949743302.4001)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.::&DEBUG.:RP:P491_SHOW:CLASS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'CLASS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205465222031746507.4001)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.::&DEBUG.:RP:P492_SHOW:TEMPLATE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(142981713415942042.4001)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142977624415934264.4001)
,p_name=>'P435_THEME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Temas -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione los temas que se van a incluir en el informe y haga clic en <strong>Ir</strong>. Este informe puede incluir todos los temas, o bien puede seleccionar un tema concreto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142989505761957277.4001)
,p_name=>'P435_SHOW_COMPONENTS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX SHOW SHARED COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(144512500887046057.4001)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Muestre archivos a los que se hace referencia en componentes compartidos y componentes de p\00E1gina adem\00E1s de las plantillas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145935418799744958.4001)
,p_name=>'P435_SHOW_PAGE_COMPONENTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX SHOW PAGE COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(145937328496747754.4001)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152093221549925702.4001)
,p_name=>'P435_SHOW_TEMPLATES'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_prompt=>'Mostrar:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX SHOW TEMPLATES'
,p_lov=>'.'||wwv_flow_api.id(152029513350781444.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el tipo de referencias de archivo que se van a incluir en este informe. Si no realiza ninguna selecci\00F3n, no se devuelven resultados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152118110083969780.4001)
,p_name=>'P435_SHOW_FILES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_prompt=>'Mostrar Archivos:'
,p_source=>'CONTEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FIND FILES REPORT OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(152121930169975580.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el tipo de informe que desea ver.<p/> ',
unistr('<strong>Con contexto</strong> muestra el componente, el identificador de tema, el nombre del componente, la ubicaci\00F3n del archivo, la imagen (si es aplicable) y el n\00FAmero de p\00E1gina relevante. Seleccione el n\00FAmero de p\00E1gina para enlazar a una definici')
||unistr('\00F3n de p\00E1gina espec\00EDfica.<p/> '),
unistr('<strong>Sin contexto</strong> muestra s\00F3lo el nombre de archivo y la imagen (si es aplicable).'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(152396603690431534.4001)
,p_name=>'P435_FILE_EXTENSIONS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_item_default=>'jpg:png:gif:js:ico:css:swf'
,p_prompt=>'Extensiones de Archivos:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FILE EXTENSIONS'
,p_lov=>'.'||wwv_flow_api.id(152392614641425297.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Especifique las extensiones de tipo de archivo que desea buscar. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'8'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205437123969661910.4001)
,p_name=>'P435_SHOW'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(142975707446929316.4001)
,p_item_default=>'1'
,p_prompt=>'Informe'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_api.id(48989614083583743.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el informe que desea ver y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(141773827935339127.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_gif varchar2(1) := ''N'';',
'  l_jpg varchar2(1) := ''N'';',
'  l_png varchar2(1) := ''N'';',
'  l_css varchar2(1) := ''N'';',
'  l_ico varchar2(1) := ''N'';',
'  l_js  varchar2(1) := ''N'';',
'  l_swf varchar2(1) := ''N'';',
'begin',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''gif:'') >0 then l_gif := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''jpg:'') >0 then l_jpg := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''png:'') >0 then l_png := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''css:'') >0 then l_css := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''ico:'') >0 then l_ico := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''js:'')  >0 then l_js  := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''swf:'') >0 then l_swf := ''Y''; end if;',
'wwv_flow_theme_manager.find_template_files(',
'  p_flow_id => :fb_flow_id, ',
'  p_theme => :P435_THEME,',
'  p_show_templates => nvl(:P435_SHOW_TEMPLATES,''N''),',
'  p_show_page_components => nvl(v(''P435_SHOW_PAGE_COMPONENTS''),''N''),',
'  p_show_components=> nvl(:P435_SHOW_COMPONENTS,''N''),',
'  p_show_gif => l_gif,',
'  p_show_jpg => l_jpg,',
'  p_show_png => l_png,',
'  p_show_css => l_css,',
'  p_show_js  => l_js,',
'  p_show_swf => l_swf,',
'  p_show_ico => l_ico',
'  );',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(142984801475946549.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00438
begin
wwv_flow_api.create_page(
 p_id=>438.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar T\00EDtulos de Regi\00F3n')
,p_step_title=>unistr('Editar T\00EDtulos de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193875625472581190.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(232844013154816966.4001)
,p_name=>'Edit Region Titles'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'ID,',
'PAGE_ID,',
'PLUG_NAME,',
'TRANSLATE_TITLE,',
'(select PAGE_PLUG_TEMPLATE_NAME from WWV_FLOW_PAGE_PLUG_TEMPLATES where id = r.plug_template) PLUG_TEMPLATE,',
'PLUG_DISPLAY_SEQUENCE',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'and (',
':P438_FIND is null or instr(upper(plug_name),upper(:P438_FIND)) > 0',
')'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna regi\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(232844709865816990.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(232845025935816991.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PAGE_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(232845120941816991.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('T\00EDtulo de la Regi\00F3n')
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>35
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PLUG_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193885325178787173.4001)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATE_TITLE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Traducir T\00EDtulo')
,p_column_alignment=>'CENTER'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'TRANSLATE_TITLE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(232845226009816991.4001)
,p_query_column_id=>5
,p_column_alias=>'PLUG_TEMPLATE'
,p_column_display_sequence=>6
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PLUG_TEMPLATE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(232845313819816991.4001)
,p_query_column_id=>6
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PLUG_DISPLAY_SEQUENCE'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(232849516674821185.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(232849710181821186.4001)
,p_column_sequence=>2
,p_query_column_name=>'PAGE_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(232849820395821186.4001)
,p_column_sequence=>3
,p_query_column_name=>'PLUG_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(193885024829787170.4001)
,p_column_sequence=>4
,p_query_column_name=>'TRANSLATE_TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(232849923662821186.4001)
,p_column_sequence=>5
,p_query_column_name=>'PLUG_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(232850020411821187.4001)
,p_column_sequence=>6
,p_query_column_name=>'PLUG_DISPLAY_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(232848310786819435.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(232871329880853379.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(232848310786819435.4001)
,p_button_name=>'P438_GO'
,p_button_static_id=>'P438_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(232845507779816998.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(232848310786819435.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(232846728727817013.4001)
,p_branch_action=>'f?p=&APP_ID.:438:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(232869223300851437.4001)
,p_name=>'P438_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(232848310786819435.4001)
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(232846308727817005.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(232844013154816966.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_PAGE_PLUGS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('No se ha podido procesar la actualizaci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(232845507779816998.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(232876922392860694.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00440
begin
wwv_flow_api.create_page(
 p_id=>440.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Lista: Valores Est\00E1ticos')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44562405074163065.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169189407033661932.4001)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(169186610834587350.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169190828420687064.4001)
,p_plug_name=>'Crear Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169191207773690545.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44562405074163065.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169191631872690550.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44562405074163065.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169191411012690550.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44562405074163065.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169195226997733967.4001)
,p_branch_action=>'f?p=&APP_ID.:529:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(574134995697781505.4001)
,p_branch_action=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(169191411012690550.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169196418218797633.4001)
,p_name=>'P440_ENTRY_NAME_01'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>'1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Etiqueta de Entrada de Lista 1'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169196609416797637.4001)
,p_name=>'P440_PAGE_01'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>unistr('Identificador de P\00E1gina de Destino de Entrada de Lista 1 o URL Personalizada')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169196821588797638.4001)
,p_name=>'P440_ENTRY_NAME_02'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>'2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Etiqueta de Entrada de Lista 2'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169197031564797638.4001)
,p_name=>'P440_PAGE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>unistr('Identificador de P\00E1gina de Destino de Entrada de Lista 2 o URL Personalizada')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169197215492797638.4001)
,p_name=>'P440_ENTRY_NAME_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>'3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Etiqueta de Entrada de Lista 3'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169197400812797638.4001)
,p_name=>'P440_PAGE_03'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>unistr('Identificador de P\00E1gina de Destino de Entrada de Lista 3 o URL Personalizada')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169197632441797638.4001)
,p_name=>'P440_ENTRY_NAME_04'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>'4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Etiqueta de Entrada de Lista 4'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169197818409797639.4001)
,p_name=>'P440_PAGE_04'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>unistr('Identificador de P\00E1gina de Destino de Entrada de Lista 4 o URL Personalizada')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169198031550797639.4001)
,p_name=>'P440_ENTRY_NAME_05'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>'5'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Etiqueta de Entrada de Lista 5'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169198232173797639.4001)
,p_name=>'P440_PAGE_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_prompt=>unistr('Identificador de P\00E1gina de Destino de Entrada de Lista 5 o URL Personalizada')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169200608184870408.4001)
,p_name=>'P440_ENTRY_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_source=>'wwv_flow_lang.system_message(''LIST_ENTRY_LABEL'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169200816255870409.4001)
,p_name=>'P440_ENTRY_TARGET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(169190828420687064.4001)
,p_source=>'wwv_flow_lang.system_message(''TARGET_PAGE_ID_OR_CUSTOM_URL'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574134753422781503.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(169191207773690545.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574134890803781504.4001)
,p_event_id=>wwv_flow_api.id(574134753422781503.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00444
begin
wwv_flow_api.create_page(
 p_id=>444.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Bloquear P\00E1ginas')
,p_step_title=>unistr('Bloquear P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213229021839834158)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_locks.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37875907041082998.4001)
,p_plug_name=>unistr('Bloquear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Al bloquear una p\00E1gina se asegura de que ning\00FAn otro desarrollador cambiar\00E1 la definici\00F3n de la p\00E1gina bloqueada.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926592801825554684.4001)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(926694488520890804.4001)
,p_plug_name=>unistr('Bloquear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37891212507179194.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(926592801825554684.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37891523270179199.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(926592801825554684.4001)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Bloquear P\00E1ginas')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37900625714211370.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37877115699085509.4001)
,p_name=>'P444_LOCK_PAGES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37875907041082998.4001)
,p_prompt=>unistr('Bloquear P\00E1ginas:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Lista de p\00E1ginas que se van a bloquear. Esta lista contiene todas las p\00E1ginas disponibles para su bloqueo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37893006751186969.4001)
,p_name=>'P444_LOCK_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(37875907041082998.4001)
,p_prompt=>'Comentario'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Comentario que se aplicar\00E1 a todas las p\00E1ginas bloqueadas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37902918011228095.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  pg wwv_flow_global.vc_arr2;',
'  c  int;',
'begin',
'  pg := wwv_flow_utilities.string_to_table2(:P444_LOCK_PAGES);',
'',
'  for i in 1..pg.count loop',
'',
'    select count(*) a into c from WWV_FLOW_LOCK_PAGE ',
'    where flow_id = :fb_flow_id and object_id = to_number(pg(i)) and locked_by is not null;',
'',
'    if c = 0 then',
'    insert into WWV_FLOW_LOCK_PAGE (',
'        flow_id,',
'        object_id,',
'        LOCK_COMMENT,',
'        locked_by,',
'        locked_on)',
'    values (',
'        :fb_flow_id,',
'        to_number(pg(i)),',
'        :P444_LOCK_COMMENT,',
'        :app_user,',
'        sysdate);',
'    end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido bloquear las p\00E1ginas')
,p_process_when_button_id=>wwv_flow_api.id(37891523270179199.4001)
,p_process_success_message=>unistr('P\00E1ginas Bloqueadas')
);
end;
/
prompt --application/pages/page_00445
begin
wwv_flow_api.create_page(
 p_id=>445.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Validaciones'
,p_step_title=>'Validaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22469712310268780.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22486816559326797.4001)
,p_name=>'Validaciones'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ID", ',
'"NAME",',
'"SEQUENCE",',
'"CHECK_TYPE",',
'"CHECK_CONDITION", ',
'm.e',
'from #OWNER#.WWV_FLOW_INSTALL_CHECKS, (select wwv_flow_lang.system_message(''EDIT'') e from dual) m',
' where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'  '))
,p_header=>unistr('<p>Utilice validaciones para asegurarse de que la base de datos puede ejecutar los scripts de instalaci\00F3n.</p>')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna validaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487000625326798.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_column_link=>'f?p=&APP_ID.:376:&SESSION.::&DEBUG.::P376_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">#E#</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487101068326798.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487212308326798.4001)
,p_query_column_id=>3
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'SEQUENCE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487303196326798.4001)
,p_query_column_id=>4
,p_column_alias=>'CHECK_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tipo de Validaci\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(2610902469203915)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'CHECK_TYPE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22487426901326798.4001)
,p_query_column_id=>5
,p_column_alias=>'CHECK_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Condici\00F3n')
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'CHECK_CONDITION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1119204948525875910.4001)
,p_query_column_id=>6
,p_column_alias=>'E'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24429712314913204.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34012108388929679.4001)
,p_plug_name=>'Validaciones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22550015932506379.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34012108388929679.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22487922446328483.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34012108388929679.4001)
,p_button_name=>'CREATEVAL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:376:&SESSION.::&DEBUG.:376::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29874403379605817.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29873025412602748.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
prompt --application/pages/page_00449
begin
wwv_flow_api.create_page(
 p_id=>449.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Publicaci\00F3n de Ayuda de Elemento')
,p_step_title=>unistr('Confirmar Publicaci\00F3n de Ayuda de Elemento')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37116229602452911.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Publicaci\00F3n de Ayuda de Elemento')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(p_name=>''PUBLISH_ITEM_HELP.CONFIRM'')||''</p>'');',
'sys.htp.p(''<ul>'');',
'for c in (select i.flow_id, i.name',
'          from wwv_flow_step_items i, wwv_flow_step_item_help h',
'          where i.id = h.flow_item_id',
'          and h.reference_id = :P449_ID) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
'sys.htp.p(''<p/>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(p_name=>''PUBLISH_ITEM_HELP.CONFIRM2'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1000723748661503619.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37121313352452948.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1000723748661503619.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37125802036452961.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1000723748661503619.4001)
,p_button_name=>'REFRESH_ITEM_HELP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Todo'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37133015710452981.4001)
,p_branch_action=>'&P449_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(37125802036452961.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37133311206452982.4001)
,p_branch_action=>'&P449_PAGE_ID.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(37121313352452948.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37128403587452969.4001)
,p_name=>'P449_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37128732150452971.4001)
,p_name=>'P449_PAGE_ID'
,p_item_sequence=>20
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(37131524318452978.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Item Helps'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_item_help (:P449_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todas las plantillas de p\00E1gina de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(37125802036452961.4001)
,p_process_success_message=>unistr('Se han refrescado todas las plantillas de p\00E1gina de suscripci\00F3n.')
);
end;
/
prompt --application/pages/page_00457
begin
wwv_flow_api.create_page(
 p_id=>457.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Script de Actualizaci\00F3n')
,p_step_title=>unistr('Script de Actualizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(403368042822913448.4001)
,p_plug_name=>'Script (plug-in)'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Rem''||chr(10)||',
'       ''Rem  ''||name||chr(10)||',
'       ''Rem''||chr(10)||',
'       script||chr(10) script_clob',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'order by sequence, name'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attribute_01=>'DDL'
,p_attribute_02=>'AUTO'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(403368492129913449.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405352281117027978.4001)
,p_plug_name=>unistr('Scripts de Actualizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Utilice scripts de actualizaci\00F3n para actualizar objetos, im\00E1genes y datos iniciales de la base de datos al actualizar a una nueva versi\00F3n de esta aplicaci\00F3n.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(403368610158913449.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(403368492129913449.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(403368819646913451.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(403368492129913449.4001)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Descargar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(403369207759913453.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download upgrade script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_init_htp_buffer;',
'wwv_flow_utilities.print_download_header (',
'       p_mime_type     => ''application/x-sql'',',
'       p_mime_charset  => ''utf-8'',',
'       p_file_name     => ''upgrade_script.sql'',',
'       p_is_attachment => true );',
'sys.owa_util.http_header_close;',
'',
'for c1 in (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id',
'               and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'               order by sequence, name)',
'loop',
'    sys.htp.p(''Rem'');',
'    sys.htp.p(''Rem  ''||c1.name);',
'    sys.htp.p(''Rem'');',
'    wwv_htp.print_clob(c1.script);',
'    sys.htp.p(chr(10));',
'end loop;',
'',
'',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido descargar los scripts de instalaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(403368819646913451.4001)
);
end;
/
prompt --application/pages/page_00459
begin
wwv_flow_api.create_page(
 p_id=>459.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Recuento de Regiones por Punto de Visualizaci\00F3n de Plantilla de P\00E1gina')
,p_step_title=>unistr('Recuento de Regiones por Punto de Visualizaci\00F3n de Plantilla de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1219116120492032.4001)
,p_plug_name=>unistr('Regiones por Punto de Visualizaci\00F3n de Plantilla de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT  ',
'    flow_id application,',
'    PLUG_DISPLAY_POINT,',
'    count(*) region_count,',
'    count(distinct page_id) pages_referenced,',
'    t.total_region_count,',
'    100*count(*)/t.total_region_count pct_of_total,',
'    100*count(*)/t.total_region_count graph',
'FROM ',
'   WWV_FLOW_PAGE_PLUGS p,',
'   (select count(*) total_region_count',
'    from wwv_flow_page_plugs ',
'    where flow_id = :fb_flow_id and ',
'          security_group_id = :FLOW_SECURITY_GROUP_ID) t',
'WHERE',
'   FLOW_ID = :fb_flow_id and',
'   security_group_id = :FLOW_SECURITY_GROUP_ID',
'group by flow_id, PLUG_DISPLAY_POINT, t.total_region_count'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1219200708492032.4001)
,p_name=>'Regions by Page Template Display Point'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1219405392492035.4001)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1219507506492035.4001)
,p_db_column_name=>'PLUG_DISPLAY_POINT'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>unistr('Punto de Visualizaci\00F3n de Plantilla de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1219616354492036.4001)
,p_db_column_name=>'REGION_COUNT'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Regiones con Referencia'
,p_column_link=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.:RP,RIR,CIR:IR_DISPLAY_POSITION:#PLUG_DISPLAY_POINT#'
,p_column_linktext=>'#REGION_COUNT#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1219701780492036.4001)
,p_db_column_name=>'PAGES_REFERENCED'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>unistr('P\00E1ginas con Referencia')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1245325042020983.4001)
,p_db_column_name=>'TOTAL_REGION_COUNT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Recuento Total de Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1245422157020984.4001)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Porcentaje del Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1245530350020984.4001)
,p_db_column_name=>'GRAPH'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>unistr('Gr\00E1fico')
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193875830321582606.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193879015093653828.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1219116120492032.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:459:&SESSION.::&DEBUG.:459,RIR::'
);
end;
/
prompt --application/pages/page_00460
begin
wwv_flow_api.create_page(
 p_id=>460.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Importar: Especificar Archivo'
,p_step_title=>'Importar: Especificar Archivo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Set drag and drop labels',
'var fileUpload$ = apex.jQuery(''.apex-item-group--file:not(.upload-completed) .apex-item-file-dropzone'');',
'',
'fileUpload$.append("<span class=''a-FileDrop-heading''>" + apex.lang.getMessage("ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-action''>" + apex.lang.getMessage("ITEM.FILE_UPLOAD.CHOOSE_FILE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-filename''></span>");',
'',
''))
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_css_classes=>'a-Page--wizardTop'
,p_help_text=>'deploy_import.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37902306340482807.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-WizardSteps--slim'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42445018302528358.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45313425484446190.4001)
,p_plug_name=>'Especificar Archivo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58921030763190638.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_api.id(58916220936178306.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747142504813138164.4001)
,p_plug_name=>'Importar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314316560446194.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42445018302528358.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1670603888557234719.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42445018302528358.4001)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./htmdb/importing-export-files.html'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314626525446194.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(42445018302528358.4001)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45314506548446194.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(42445018302528358.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P460_PREV_PAGE'
,p_button_condition2=>'459'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45316031293446199.4001)
,p_branch_name=>'Go To Page 163'
,p_branch_action=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:WWV_FLOW_IMPORT_REMOTE_SERVERS,WWV_FLOW_IMPORT_CREDENTIALS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45314626525446194.4001)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(317679409969112295.4001)
,p_branch_action=>'f?p=4500:1000:&SESSION.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45314316560446194.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'ITEM_IS_NULL'
,p_branch_condition=>'FB_FLOW_ID'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(317708930532127660.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45314316560446194.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45314128381446191.4001)
,p_name=>'P460_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(45313425484446190.4001)
,p_prompt=>'Archivo a Importar'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-FileDrop a-FileDrop--small margin-bottom-md margin-top-lg'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'DROPZONE_INLINE'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47821015395903429.4001)
,p_name=>'P460_FILE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(45313425484446190.4001)
,p_item_default=>'FLOW_EXPORT'
,p_prompt=>'Tipo de Archivo:'
,p_source=>'FLOW_EXPORT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXPORT_FILE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(84829617133304005.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-TOP'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique el tipo de archivo de exportaci\00F3n que se va a importar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53940826768469260.4001)
,p_name=>'P460_PREV_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(45313425484446190.4001)
,p_prompt=>'Prev Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(144813309454701393.4001)
,p_name=>'P460_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(45313425484446190.4001)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Caracteres de Archivo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indique la codificaci\00F3n del juego de caracteres del archivo que se va a importar.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47823429294935804.4001)
,p_validation_name=>'file not null'
,p_validation_sequence=>10
,p_validation=>'P460_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar el archivo para cargar.'
,p_when_button_pressed=>wwv_flow_api.id(45314626525446194.4001)
,p_associated_item=>wwv_flow_api.id(45314128381446191.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47824006569938696.4001)
,p_validation_name=>'file type not null'
,p_validation_sequence=>20
,p_validation=>'P460_FILE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el tipo de archivo.'
,p_when_button_pressed=>wwv_flow_api.id(45314626525446194.4001)
,p_associated_item=>wwv_flow_api.id(47821015395903429.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(341758707481969404.4001)
,p_validation_name=>'file not 0 byte'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id',
'             from wwv_flow_file_objects$',
'            where name = :P460_FILE',
'              and doc_size = 0)',
'loop',
'    delete from wwv_flow_file_objects$',
'     where id = c1.id',
'       and security_group_id = :flow_security_group_id;',
'',
'    return false;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo no tiene ning\00FAn contenido.')
,p_when_button_pressed=>wwv_flow_api.id(45314626525446194.4001)
,p_associated_item=>wwv_flow_api.id(45314128381446191.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1003712203211784947.4001)
,p_validation_name=>'is SQL or ZIP file'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_import_file in (select id, filename',
'                        from wwv_flow_file_objects$',
'                       where name = :P460_FILE )',
'loop',
'    if lower( l_import_file.filename ) like ''%.sql'' or',
'       lower( l_import_file.filename ) like ''%.zip'' then',
'        return true;',
'    else',
'        delete from wwv_flow_file_objects$',
'         where id = l_import_file.id',
'           and security_group_id = :flow_security_group_id;',
'',
'        return false;',
'    end if;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Tipo de archivo no v\00E1lido. Los tipos de archivo soportados son SQL y ZIP.')
,p_validation_condition=>'P460_FILE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(45314626525446194.4001)
,p_associated_item=>wwv_flow_api.id(45314128381446191.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(932669483786561044.4001)
,p_name=>'Submit page'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(45314626525446194.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(932669597885561045.4001)
,p_event_id=>wwv_flow_api.id(932669483786561044.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1244611542880539134.4001)
,p_name=>'Show File Name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P460_FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1244611658915539135.4001)
,p_event_id=>wwv_flow_api.id(1244611542880539134.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function( $, triggeringElem ){',
'  var filename = $( triggeringElem ).val().split(/(\\|\/)/g).pop();',
'  $(''.a-FileDrop-filename'').text( filename );  ',
'})( apex.jQuery, this.triggeringElement );'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(46711932360845877.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload export file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.upload_export_file (',
'    p_file               => :P460_FILE,',
'    p_file_type          => :P460_FILE_TYPE,',
'    p_security_group_id  => :flow_security_group_id,',
'    p_file_charset       => :P460_FILE_CHARSET,',
'    p_flow_user          => :flow_user',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al cargar el archivo de exportaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(45314626525446194.4001)
,p_process_success_message=>unistr('Archivo de exportaci\00F3n cargado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(53577809201103042.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set p163_file_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P460_FILE)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'  :P163_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(45314626525446194.4001)
);
end;
/
prompt --application/pages/page_00461
begin
wwv_flow_api.create_page(
 p_id=>461.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar/Importar'
,p_step_title=>'Exportar/Importar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_how_to.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44664519703498420.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45316711403446202.4001)
,p_plug_name=>'Exportar/Importar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747142625960138164.4001)
,p_plug_name=>unistr('\00BFQu\00E9 tarea desea realizar?')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45317600429446209.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44664519703498420.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1670603923819234720.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44664519703498420.4001)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./htmdb/how-to-move-an-application-to-another-instance.html'');'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45317931133446209.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44664519703498420.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45403409535967018.4001)
,p_branch_action=>'f?p=&FLOW_ID.:460:&SESSION.::&DEBUG.:460::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P461_EXPIMP'
,p_branch_condition_text=>'IMPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2700881305358307.4001)
,p_branch_name=>'Go to Page 4905'
,p_branch_action=>'f?p=&APP_ID.:4905:&SESSION.::&DEBUG.:RP,4905,4906::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>15
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P461_EXPIMP'
,p_branch_condition_text=>'DEPLOY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45422531624068012.4001)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P461_EXPIMP'
,p_branch_condition_text=>'REPOSITORY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(171790426302478829.4001)
,p_branch_action=>'f?p=&FLOW_ID.:76:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45319322589446216.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4900:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45317931133446209.4001)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45318305962446212.4001)
,p_branch_action=>'f?p=&FLOW_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(45317600429446209.4001)
,p_branch_sequence=>50
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45317431786446206.4001)
,p_name=>'P461_EXPIMP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(45316711403446202.4001)
,p_item_default=>'EXPORT'
,p_prompt=>'Seleccionar Tarea'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'EXPORT.OPTIONS WITH ICONS'
,p_lov=>'.'||wwv_flow_api.id(805553919796597674.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-IconList--featured a-IconList--featured--wide'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(513845106211177695.4001)
,p_name=>'Add Featured Modifier Class to Icon List'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_da_event_comment=>'Currently the Icon List widget does not support having modifier classes applied via the Advanced CSS Class property for items. This dynamic action removes the "a-IconList--wizard" modifier and adds the class "a-IconList--featured" instead.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513845512307177716.4001)
,p_event_id=>wwv_flow_api.id(513845106211177695.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-IconList'
,p_attribute_01=>'a-IconList--wizard'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(513845950748177716.4001)
,p_event_id=>wwv_flow_api.id(513845106211177695.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-IconList'
,p_attribute_01=>'a-IconList--featured'
);
end;
/
prompt --application/pages/page_00462
begin
wwv_flow_api.create_page(
 p_id=>462.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Script de Desinstalaci\00F3n')
,p_step_title=>unistr('Script de Desinstalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(403373707864014016.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(403383791686349173.4001)
,p_plug_name=>'Deinstall Script'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select deinstall_script s',
'from WWV_FLOW_INSTALL',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0',
'and instr(nvl(:P462_DOWNLOAD_OPTION,''DEINSTALL''),''DEINSTALL'') > 0',
'union all',
'select to_clob(',
'	    ''''||chr(10)||',
'       ''prompt -- Remove Application''||chr(10)||',
'       ''begin''||chr(10)||',
'       ''wwv_flow_api.remove_application (p_application_id=>''||:fb_flow_id||'', p_workspace_id=>''||:flow_security_group_id||'');''||chr(10)||',
'       ''commit;''||chr(10)||',
'       ''end;''||chr(10)||',
'       ''/'') s',
'from dual',
'where instr(nvl(:P462_DOWNLOAD_OPTION,''DEINSTALL''),''APP_REMOVE'') > 0'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attribute_01=>'DDL'
,p_attribute_02=>'AUTO'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(403385345576385427.4001)
,p_plug_name=>unistr('Script de Desinstalaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Utilice el script de desinstalaci\00F3n para borrar los objetos de base de datos y los archivos est\00E1ticos que se crean mediante los scripts de instalaci\00F3n. Puede descargar el script de desinstalaci\00F3n e incluir una llamada para eliminar la aplicaci\00F3n. ')
||unistr('Esta descarga se puede utilizar desde la l\00EDnea de comandos para desinstalar y eliminar la aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(403373911537014017.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(403373707864014016.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(403374195288014017.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(403373707864014016.4001)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Descargar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403385830623395386.4001)
,p_name=>'P462_DOWNLOAD_OPTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(403373707864014016.4001)
,p_prompt=>'Descargar'
,p_source=>'DEINSTALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P462_DOWNLOAD_OPTION'
,p_lov=>'.'||wwv_flow_api.id(403387737278446376.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione lo que desea incluir en la descarga del script de desinstalaci\00F3n. La descarga puede incluir el script de desinstalaci\00F3n y eliminar la llamada de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(452937644381035341.4001)
,p_name=>'refresh'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P462_DOWNLOAD_OPTION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(452937928378035343.4001)
,p_event_id=>wwv_flow_api.id(452937644381035341.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(403384225997363413.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download deinstall script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_init_htp_buffer;',
'wwv_flow_utilities.print_download_header (',
'       p_mime_type     => ''application/x-sql'',',
'       p_mime_charset  => ''utf-8'',',
'       p_file_name     => ''f''||:fb_flow_id||''_deinstall_script.sql'',',
'       p_is_attachment => true );',
'sys.owa_util.http_header_close;',
'',
'sys.htp.p(''prompt -- Deinstall Supporting Objects'');',
'if instr(:P462_DOWNLOAD_OPTION,''DEINSTALL'') > 0 then',
'    for c1 in (select deinstall_script',
'               from WWV_FLOW_INSTALL',
'               where flow_id = :fb_flow_id',
'               and security_group_id = :flow_security_group_id',
'               and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0)',
'    loop',
'        wwv_htp.print_clob(c1.deinstall_script);',
'    end loop;',
'end if;',
'',
'if instr(:P462_DOWNLOAD_OPTION,''APP_REMOVE'') > 0 then',
'    sys.htp.p('''');',
'    sys.htp.p(''prompt -- Remove Application'');',
'    sys.htp.p(''begin'');',
'    sys.htp.p(''wwv_flow_api.remove_application (p_application_id=>''||:fb_flow_id||'', p_workspace_id=>''||:flow_security_group_id||'');'');',
'    sys.htp.p(''commit;'');',
'    sys.htp.p(''end;'');',
'    sys.htp.p(''/'');',
'end if;',
'sys.htp.p(''prompt  ...done'');',
'',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido descargar los scripts de instalaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(403374195288014017.4001)
);
end;
/
prompt --application/pages/page_00464
begin
wwv_flow_api.create_page(
 p_id=>464.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista: Consulta'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434304280667092.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(169186610834587350.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434503216667092.4001)
,p_plug_name=>'Ejemplos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ejemplo 1: ',
'<pre>',
'SELECT null, ',
'       ENAME label, ',
'       null target, ',
'       ''YES'' is_current, ',
'       ''&#35;APP_IMAGES&#35;del.gif'' image, ',
'       ''width="20" height="20"'' image_attrib, ',
'       ENAME image_alt',
'FROM  emp ',
'ORDER BY ename',
'</pre>',
'Ejemplo 2 (con variable de enlace): ',
'<pre>',
'SELECT null, ',
'       ENAME label, ',
'       ''f?p=&amp;APP_ID.:1:''||:APP_SESSION||''::::P1_EMPNO:''||empno target, ',
'       null is_current',
'FROM  emp ',
'WHERE deptno = :MY_ITEM ',
'ORDER BY 1',
'</pre>',
unistr('Ejemplo 3 (con consulta SQL jer\00E1rquica):'),
'<pre>',
'select level, ',
'       ENAME label, ',
'       ''f?p=&amp;APP_ID.:1:''||:APP_SESSION||''::::P1_EMPNO:''||empno target,',
'       ''NO'' is_current,',
'       ''&#35;APP_IMAGES&#35;del.gif'' image',
'from EMP',
'start with MGR is null',
'connect by prior EMPNO = MGR',
'order siblings by ENAME',
'</pre>',
unistr('Ejemplo 4 (con funci\00F3n que devuelve una consulta SQL):'),
'<pre>',
'IF :MY_ITEM = ''10'' THEN',
'  RETURN ',
'  ''SELECT null, ename label''||',
'  ''FROM emp ''||',
'  ''WHERE deptno = 10 ORDER BY 1'';',
'ELSE',
'  RETURN ',
'  ''SELECT null, ename label''||',
'  ''FROM emp ''||',
'  ''WHERE deptno = :MY_ITEM ORDER BY 1'';',
'END IF;',
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434728122667093.4001)
,p_plug_name=>'Crear Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47243831909526629.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(758615610992655706.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(1434728122667093.4001)
,p_button_name=>'QUERY_BUILDER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Consulta'
,p_button_redirect_url=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.:RP,542,701,719:P464_LIST_SOURCE_FIELD:P464_QUERY:'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434911958667093.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47243831909526629.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11341627974749057.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47243831909526629.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1435130280667096.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47243831909526629.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11419509280286457.4001)
,p_branch_action=>'f?p=&APP_ID.:734:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(11341627974749057.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1438607505667112.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1438825916667112.4001)
,p_branch_action=>'427'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1435130280667096.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1435501565667096.4001)
,p_name=>'P464_QUERY'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1434728122667093.4001)
,p_prompt=>'Consulta SQL:'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>9
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una consulta SQL de lista o una funci\00F3n que devuelva una consulta SQL para generar una lista din\00E1mica. Haga clic en <strong>Ejemplos</strong> para ver consultas SQL de ejemplo.</p>'),
'<strong>Sintaxis de Consulta SQL:</strong>',
'<pre>',
'select level, labelValue label, ',
'       [targetValue]            target, ',
'       [is_current]             is_current_list_entry,',
'       [imageValue]             image, ',
'       [imageAttributeValue]    image_attribute,',
'       [imageAltValue]          image_alt_attribute,',
'       [attribute1]             attribute1,',
'       [attribute2]             attribute2,',
'       [attribute3]             attribute3,',
'       [attribute4]             attribute4,',
'       [attribute5]             attribute5,',
'       [attribute6]             attribute6,',
'       [attribute7]             attribute7,',
'       [attribute8]             attribute8,',
'       [attribute9]             attribute9,',
'       [attribute10]            attribute10',
'from ...',
'where ...',
'order by ...',
'</pre>',
'',
unistr('<strong>Funci\00F3n que Devuelve una Sintaxis de Consulta SQL:</strong>'),
'<pre>',
'RETURN',
'''select level, labelValue label,''||',
'''       [targetValue]         target,''|| ',
'''       [is_current]          is_current_list_entry,''||',
'''       [imageValue]          image,''||',
'''       [imageAttributeValue] image_attribute, ''||',
'''       [imageAltValue]       image_alt_attribute,''||',
'''       [attribute1]          attribute1,''||',
'''       [attribute2]          attribute2,''||',
'''       [attribute3]          attribute3,''||',
'''       [attribute4]          attribute4,''||',
'''       [attribute5]          attribute5,''||',
'''       [attribute6]          attribute6,''||',
'''       [attribute7]          attribute7,''||',
'''       [attribute8]          attribute8,''||',
'''       [attribute9]          attribute9,''||',
'''       [attribute10]         attribute10''||',
'''from ...''||',
'''where ...''||',
'''order by ...'';',
'</pre>',
'',
unistr('<strong>NOTA:</strong>la columna <i>is_current</i> se puede definir en uno de los tres valores siguientes:<strong>''YES''</strong>,<strong>''NO''</strong> o <strong>NULL</strong>. Si se define en NULL, la moneda de la entrada de lista se basar\00E1 en la p\00E1g')
||'ina de destino de la entrada de lista.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_04=>'Y'
,p_attribute_06=>'P464_EDITOR_MODE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Remove default value: ',
'select ENAME label, NULL target',
'from   EMP',
'order by EMPNO'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1437319745667106.4001)
,p_name=>'P464_SHOW_PREVIEW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1434728122667093.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10687702263549991.4001)
,p_name=>'P464_QUERY_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1434728122667093.4001)
,p_item_default=>'SQL_QUERY'
,p_prompt=>'Consultar Tipo de Origen'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLASH_CHART_QUERY_TYPE'
,p_lov=>'.'||wwv_flow_api.id(6026412205740110.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tipo de origen de consulta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12831404929271461.4001)
,p_name=>'P464_LIST_SOURCE_FIELD'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1434728122667093.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78408855239861204.4001)
,p_name=>'P464_EDITOR_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1434728122667093.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'case when :P464_QUERY_TYPE = ''SQL_QUERY'' then ''SQL'' else ''PLSQL_FUNCTION_BODY'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1437810826667106.4001)
,p_computation_sequence=>10
,p_computation_item=>'P464_SHOW_PREVIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'YES'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1438231567667110.4001)
,p_validation_name=>'is_valid_list_query'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      return wwv_flow_f4000_util.is_valid_list_query(',
'                   p_query      => :P464_QUERY,',
'                   p_query_type => :P464_QUERY_TYPE);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>unistr('La consulta de lista no es v\00E1lida. Se necesita una secuencia, una etiqueta y un valor de destino. Si la consulta contiene una consulta en l\00EDnea, la primera cl\00E1usula FROM de la sentencia SQL no debe pertenecer a la consulta en l\00EDnea.')
,p_when_button_pressed=>wwv_flow_api.id(11341627974749057.4001)
,p_associated_item=>wwv_flow_api.id(1435501565667096.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574135074429781506.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1434911958667093.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574135187287781507.4001)
,p_event_id=>wwv_flow_api.id(574135074429781506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(78408942601861205.4001)
,p_name=>'On P464_QUERY_TYPE Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P464_QUERY_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(78409022940861206.4001)
,p_event_id=>wwv_flow_api.id(78408942601861205.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P464_EDITOR_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P464_QUERY_TYPE'').getValue() === ''SQL_QUERY'' ? ''SQL'' : ''PLSQL_FUNCTION_BODY'''
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00467
begin
wwv_flow_api.create_page(
 p_id=>467.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Estado de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Editar Estado de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205259705444400875.4001)
,p_plug_name=>unistr('Editar Estado de Aplicaci\00F3n y Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846719915735214909.4001)
,p_plug_name=>unistr('Editar Estado de Aplicaci\00F3n y Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(846720064004214910.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(205260101200400877.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(846720064004214910.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(205259924581400876.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(846720064004214910.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P467_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205260618787400882.4001)
,p_branch_action=>'f?p=&APP_ID.:103:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205260808758400883.4001)
,p_name=>'P467_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(205259705444400875.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n: ')
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205261428525400894.4001)
,p_name=>'P467_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(205259705444400875.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de la Aplicaci\00F3n:')
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205261801105400896.4001)
,p_name=>'P467_FLOW_STATUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(205259705444400875.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Estado de Aplicaci\00F3n')
,p_source=>'FLOW_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_FLOW_STATUS'
,p_lov=>'.'||wwv_flow_api.id(634347472712995.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Especifica si la aplicaci\00F3n est\00E1 disponible para su uso.<p />Puede estar disponible, estar disponible con la opci\00F3n Barra de herramientas de desarrollador (con la barra de herramientas del desarrollador incluida en cada p')
||unistr('\00E1gina, es necesario que el desarrollador est\00E9 conectado al creador de aplicaciones en la misma sesi\00F3n del explorador), estar solo disponible para los desarrolladores (usuarios que disponen de cuentas que les permiten ejecutar el creador de aplicacion')
||unistr('es), o bien estar disponible solo para desarrolladores cuyo nombre aparece (por nombre de cuenta) en el atributo de lista restringida de desarrolladores en la p\00E1gina de atributos de aplicaci\00F3n. <p />La aplicaci\00F3n tambi\00E9n puede no estar disponible, lo')
||unistr(' cual significa que no se puede ejecutar: No disponible sin ninguna explicaci\00F3n, no disponible con un mensaje (se debe introducir en el mismo campo de atributo designado para ello), no disponible con una URL a la que se redirigir\00E1 a los usuarios (se ')
||'debe introducir en el mismo campo de atributo), o bien no disponible con un mensaje emitido por PL/SQL introducido en el mismo campo de atributo.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205262022833400897.4001)
,p_name=>'P467_BUILD_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(205259705444400875.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Estado de Creaci\00F3n')
,p_source=>'BUILD_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_api.id(84305510710571518.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un estado de creaci\00F3n. Entre las opciones se incluyen:</p>'),
'<ul>',
unistr('<li><strong>Solo ejecutar aplicaci\00F3n</strong>: los desarrolladores solo pueden ejecutar una aplicaci\00F3n. La aplicaci\00F3n aparecer\00E1 en la lista de aplicaciones que se muestra en el creador de aplicaciones para el espacio de trabajo, pero no se puede edit')
||unistr('ar de ning\00FAn modo.</li>'),
unistr('<li><strong>Ejecutar y crear aplicaci\00F3n</strong>: los desarrolladores pueden ejecutar y editar una aplicaci\00F3n. La aplicaci\00F3n aparecer\00E1 en la lista de aplicaciones del creador de aplicaciones para el espacio de trabajo.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(205261621674400895.4001)
,p_validation_name=>'P467_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P467_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(205261428525400894.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(755297765041836843.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(205260101200400877.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(755297820747836844.4001)
,p_event_id=>wwv_flow_api.id(755297765041836843.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205262230041400900.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'P467_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205262424080400903.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'P467_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOWS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(222858215948540010.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Reset global IDs to avoid "Application not available for edit" errors',
'--:FB_FLOW_ID := null;',
'--:FB_FLOW_PAGE_ID := null;',
'null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(755297606543836842.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00468
begin
wwv_flow_api.create_page(
 p_id=>468.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Calendario Heredado: Copiar de'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Calendario Heredado'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38349806306948665.4001)
,p_plug_name=>'Crear Plantilla de Calendario Heredado'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38350223905948666.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186387513541296806.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38351004698948669.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186387513541296806.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38351822498948672.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(186387513541296806.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38351423917948671.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186387513541296806.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154621222428457477.4001)
,p_branch_action=>'f?p=&FLOW_ID.:418:&SESSION.::&DEBUG.:418::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589886799247923012.4001)
,p_branch_action=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(38351423917948671.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38352211144948676.4001)
,p_name=>'P468_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38349806306948665.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar plantillas.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(38353006404948687.4001)
,p_validation_name=>'P468_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'P468_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(38352211144948676.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-FEB-2002 11:14'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589886564917923010.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(38351004698948669.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589886679856923011.4001)
,p_event_id=>wwv_flow_api.id(589886564917923010.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00469
begin
wwv_flow_api.create_page(
 p_id=>469.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Calendario Heredado: Nuevas Plantillas'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Calendario Heredado'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(38368218867972334.4001)
,p_name=>'Crear Plantilla de Calendario Heredado'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'name From_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name) to_NAME,',
'  ''N'' sub',
'from wwv_flow_cal_templates',
'where flow_id = :P468_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and theme_id = :P418_COPY_FROM_THEME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna plantilla.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289755409410534315.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(287707908141523402.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289797223290765447.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289798101950768791.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(289754604561532905.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(38371005236972344.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186389525924319236.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38372227583972350.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186389525924319236.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38371807608972346.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186389525924319236.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(38372614697972351.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186389525924319236.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154627711739482728.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589887332468923018.4001)
,p_branch_action=>'f?p=&APP_ID.:418:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(38372614697972351.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74851015403642682.4001)
,p_name=>'P469_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(38368218867972334.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copiar en Tema:'
,p_source=>'P418_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(287700713635496617.4001)
,p_name=>'P469_COPY_FROM_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(38368218867972334.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy From Application:'
,p_source=>'&P468_COPY_FROM_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(38373107877972356.4001)
,p_validation_name=>'NoDupTemplateNames'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in (',
'      select name',
'        from WWV_FLOW_cal_TEMPLATES',
'       where flow_id = :FB_FLOW_ID',
'         and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                    from wwv_flow_companies',
'                                   where SHORT_NAME = :COMPANY)',
'         and name = wwv_flow.g_f02(i) )      loop',
'         if c1.name is not null',
'           then if l_found_name is null',
'                    then l_found_name := c1.name;',
'                 else l_found_name := l_found_name||'', ''||c1.name;',
'                 end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null',
'   then return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(38371807608972346.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(290041508201271999.4001)
,p_validation_name=>'OneToCopy'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Debe seleccionar al menos una plantilla que copiar.',
''))
,p_when_button_pressed=>wwv_flow_api.id(38371807608972346.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589887167321923016.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(38372227583972350.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589887225425923017.4001)
,p_event_id=>wwv_flow_api.id(589887167321923016.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38373518186972361.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Calendar Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'  i             number := 0;',
'  l_from        number := :P468_COPY_FROM_FLOW_ID;',
'  l_to          number := :FB_FLOW_ID;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_calendar_template (',
'    p_copy_from_flow_id    => l_from,',
'    p_flow_id              => l_to,',
'    p_from_template_id     => wwv_flow.g_f01(i),',
'    p_to_template_name     => wwv_flow.g_f02(i),',
'    p_to_template_id       => l_template_id,',
'    p_to_theme_id          => :p469_theme,',
'    p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_calendar_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar las plantillas de calendario.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(38371807608972346.4001)
,p_process_success_message=>'Plantillas de calendario copiadas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(589887494227923019.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(38371807608972346.4001)
,p_process_success_message=>'Plantillas de calendario copiadas.'
);
end;
/
prompt --application/pages/page_00473
begin
wwv_flow_api.create_page(
 p_id=>473.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Scripts de Instalaci\00F3n')
,p_step_title=>unistr('Archivos de Comandos de Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12979519988497157.4001)
,p_plug_name=>unistr('Scripts de Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>60
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with upd as',
'(select id',
'  from wwv_flow_install_scripts a',
' where a.security_group_id = :flow_security_group_id',
'   and a.flow_id = :fb_flow_id',
'   and exists (select 1',
'                 from sys.dba_objects b, wwv_flow_install_objects c',
'                where b.object_type = c.object_type',
'                  and b.owner = replace(c.object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner)',
'                  and b.object_name = c.object_name',
'                  and b.last_ddl_time > nvl(a.last_updated_on, a.created_on)',
'                  and a.id = c.script_id)',
'  union',
' select distinct script_id id',
'   from wwv_flow_install_objects a',
' where a.security_group_id = :flow_security_group_id',
'   and a.flow_id = :fb_flow_id',
'   and not exists (select 1',
'                     from sys.dba_objects',
'                    where owner = replace(a.object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner)',
'                      and object_type = a.object_type',
'                      and object_name = a.object_name)',
'    ),',
'ob as',
'( select distinct script_id id',
'    from wwv_flow_install_objects a',
'   where a.security_group_id = :flow_security_group_id',
'     and a.flow_id = :fb_flow_id',
')',
'select ',
's.id,',
'case when (l.locked_by is null) or  (l.locked_by is not null and l.locked_by = :app_user) then',
'    ''<a href="f?p=4000:865:''||:app_session||''::NO:RP,865:P865_SCRIPT_ID,P865_MODE,F4000_LAST_VIEW:''||s.id||'',EDIT,473">''||',
'    ''<img src="#IMAGE_PREFIX#menu/pencil2_16x16.gif" alt="''||sm.edit||''"></a>''',
'end edit_link,',
's.name,',
's.sequence,',
'lower(nvl(s.last_updated_by,s.created_by)) updated_by,',
'nvl(s.last_updated_on,s.created_on) last_updated_on,',
'sys.dbms_lob.substr(s.script,200,1)||(case when sys.dbms_lob.getlength(s.script) > 200 then ''...'' end) script,',
'decode (ob.id, null, sm.manual, sm.database_object) source,',
'decode (upd.id, null, null, sm.need_refresh) status,',
'decode (ob.id, null, null, wwv_flow_item.checkbox(1,ob.id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(s.name))||''"'')) refresh,',
'case when l.locked_by is null then',
'    ''<span class="a-Icon icon-unlock" ></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''SCRIPT_NAME_UNLOCKED'', wwv_flow_escape.html(s.name))||''</span>''',
'else',
'    ''<span class="a-Icon icon-lock" ></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''SCRIPT_NAME_LOCKED'', wwv_flow_escape.html(s.name))||''</span>''',
'end locked,',
'case when l.locked_by is null then',
'    ''f?p=4000:16:''||:app_session||'':::16:P16_LOCK_SCRIPT_ID:''||s.id',
'else',
'    ''f?p=4000:16:''||:app_session||'':::16:P16_LOCK_ID,P16_LOCK_SCRIPT_ID:''||l.id||'',''||s.id',
'end locked_link',
'from "#OWNER#"."WWV_FLOW_INSTALL_SCRIPTS" s, ',
'     upd, ',
'     ob,',
'     wwv_flow_lock_script l,',
'     (select wwv_flow_lang.system_message(''MANUAL'') manual,',
'     	     wwv_flow_lang.system_message(''F4000_P473_DATABASE_OBJECT'') database_object,',
'     	     wwv_flow_lang.system_message(''P473_NEEDS_REFRESH'') need_refresh,',
'     	     wwv_flow_lang.system_message(''EDIT'') edit',
'      from dual) sm',
'where s.flow_id = :fb_flow_id',
'and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'and s.id = ob.id(+)',
'and s.id = upd.id(+)',
'and s.id = l.script_id(+)',
'and nvl(s.script_type,''INSTALL'') = ''INSTALL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(12979631587497157.4001)
,p_name=>'Installation Scripts'
,p_max_row_count=>'100000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de #MAX_ROW_COUNT# filas; filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn script de instalaci\00F3n.')
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(864390440370490068.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Identificador'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879352987753382191.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'<br />'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12979918866497174.4001)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:RP,328:P328_ID,F4000_LAST_VIEW:#ID#,473:'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12980005514497174.4001)
,p_db_column_name=>'SEQUENCE'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12980109021497174.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12980210170497174.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12980316805497174.4001)
,p_db_column_name=>'SCRIPT'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Script'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(621101874714076415.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(621103725734076434.4001)
,p_db_column_name=>'SOURCE'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Origen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(621103814768076435.4001)
,p_db_column_name=>'REFRESH'
,p_display_order=>100
,p_column_identifier=>'I'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(857366177566210226.4001)
,p_db_column_name=>'LOCKED_LINK'
,p_display_order=>110
,p_column_identifier=>'L'
,p_column_label=>'LOCKED_LINK'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(857366481053253714.4001)
,p_db_column_name=>'LOCKED'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Bloquear'
,p_column_link=>'#LOCKED_LINK#'
,p_column_linktext=>'#LOCKED#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22471221660271476.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24424029929889971.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22546618571497665.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(12979519988497157.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(621103964030076436.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(12979519988497157.4001)
,p_button_name=>'Refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22467314949260024.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(12979519988497157.4001)
,p_button_name=>'CREATESCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:850:F4000_LAST_VIEW:473'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29867215584590480.4001)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:&P567_BRANCH_PAGE.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22546825278497667.4001)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29869327359593875.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(857370469719484743.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'APP_PAGE_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(535751809748150806.4001)
,p_validation_name=>'must select one script'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un script para refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(621103964030076436.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(933182140636833415.4001)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(12979519988497157.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(933182491658833417.4001)
,p_event_id=>wwv_flow_api.id(933182140636833415.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:473:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199172759230878403.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(12979519988497157.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199172873524878404.4001)
,p_event_id=>wwv_flow_api.id(1199172759230878403.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(118214803787541456.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create App DDL Script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_schema varchar2(100);',
'  l_objects varchar2(4000);',
'  l_object_types varchar2(4000);',
'  l_name varchar2(4000);',
'  l_clob clob;',
'begin',
'  select owner into l_schema from wwv_flows where id = :FB_FLOW_ID;',
'  wwv_flow_theme_manager.find_object_dependencies(p_flow_id=>:fb_flow_id,p_page_id=>null);',
'',
'  for c1 in (select distinct c002 name',
'             from htmldb_collections',
'             where collection_name = ''ALL_DEPENDENCIES''',
'             and c008 = :fb_flow_id',
'             and c002 <> ''PLITBLM''',
'             and c003 <> ''NON-EXISTENT''',
'             and c001 = (select owner from wwv_flows ',
'                         where id = :FB_FLOW_ID))',
'  loop',
'    l_objects := l_objects||'':''||c1.name;',
'  end loop;',
'',
'  for c1 in (select distinct c003 obj_type',
'             from htmldb_collections',
'             where collection_name = ''ALL_DEPENDENCIES''',
'             and c008 = :fb_flow_id',
'             and c002 <> ''PLITBLM''',
'             and c003 <> ''NON-EXISTENT''',
'             and c001 = (select owner from wwv_flows ',
'                         where id = :FB_FLOW_ID))',
'  loop',
'    l_object_types := l_object_types||'':''||c1.obj_type;',
'  end loop;',
'',
'  l_name := to_char(sysdate(), ''mmddhhmiss'');',
'  ',
'  wwv_flow_generate_ddl.execute_get_ddl(',
'         p_schema       => l_schema,',
'         p_object_types => substr(l_object_types, 2),',
'         p_objects      => substr(l_objects, 2),',
'         p_output_type  => ''SCRIPT'',',
'         p_filename     => ''DDL_SCRIPT''||l_name);',
'',
'  for c1 in (select *',
'               from wwv_flow_files',
'              where filename = ''DDL_SCRIPT''||l_name)',
'  loop',
'      l_clob := wwv_flow_utilities.blob_to_clob( ',
'                p_blob => c1.blob_content, ',
'                p_charset => c1.file_charset );',
'',
'      insert into wwv_flow_install_scripts (name, sequence, script)',
'         values (''Application DDL Script'', ',
'                 1,',
'                 l_clob);',
'  end loop;    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear el script de DLL.'
,p_process_when=>'DDL_SCRIPT'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Script de DDL de la aplicaci\00F3n copiado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(535751771019150805.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Scripts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_clob_arr    wwv_flow.clob_arr;',
'    empty_clob_arr  wwv_flow.clob_arr;',
'    l_object_types varchar2(32767);',
'    l_objects     varchar2(32767);',
'    l_owner       varchar2(255);',
'    i   number;',
'    j   number;',
'    l_script_option varchar2(30);',
'begin',
'',
'    for i in 1.. wwv_flow.g_f01.count loop',
'',
'        l_object_types := null;',
'        l_objects := null;',
'        l_owner := null;',
'        l_script_option := null;',
'        l_code := empty_clob;',
'        l_clob_arr := empty_clob_arr;',
'',
'        for c1 in (select script_option',
'                     from wwv_flow_install_scripts',
'                    where id = wwv_flow.g_f01(i) ) loop',
'            l_script_option := c1.script_option;',
'        end loop;',
'',
'        for c1 in (select distinct replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) object_owner',
'                     from wwv_flow_install_objects',
'                    where script_id =  wwv_flow.g_f01(i) ) loop',
'',
'            for c2 in (select distinct object_type',
'                         from wwv_flow_install_objects',
'                        where replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) = c1.object_owner',
'                          and script_id = wwv_flow.g_f01(i) ) loop',
'                l_object_types := l_object_types||c2.object_type||'':'';',
'            end loop;',
'',
'            for c2 in (select object_name',
'                         from wwv_flow_install_objects',
'                        where replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) = c1.object_owner',
'                          and script_id = wwv_flow.g_f01(i) ) loop',
'                l_objects := l_objects||c2.object_name||'':'';',
'            end loop;',
'',
'            if nvl(l_script_option,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'                l_object_types := l_script_option;',
'            elsif nvl(l_script_option,''x'') = ''TABLE'' then',
'                l_object_types := ''TABLE_RELATED'';',
'            else',
'                l_object_types := rtrim(l_object_types,'':'');',
'            end if;',
'',
'            l_clob_arr := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                              p_schema      => c1.object_owner,',
'                              p_object_type => l_object_types,',
'                              p_objects     => rtrim(l_objects,'':''));',
'',
'            for j in 1..l_clob_arr.count loop',
'                l_code := l_code || l_clob_arr(j)||chr(10)||chr(10);',
'            end loop;',
'        end loop;',
'',
'        update wwv_flow_install_scripts',
'           set script = l_code',
'         where id = wwv_flow.g_f01(i);',
'',
'    end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar los scripts seleccionados. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(621103964030076436.4001)
,p_process_success_message=>'Se han refrescado los scripts seleccionados en el origen de la base de datos.'
);
end;
/
prompt --application/pages/page_00477
begin
wwv_flow_api.create_page(
 p_id=>477.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Entradas de Lista: Identificar Destino de Copia'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Entradas de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33734524398549258.4001)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(33731702665524035.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203453619807378527.4001)
,p_plug_name=>'Copiar Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-JUL-2004 16:26:34'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(203523017988535682.4001)
,p_name=>'Entradas de lista que se van a copiar'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT, LIST_ITEM_LINK_TARGET',
'from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id ',
'and list_id = :P477_COPY_LIST_FROM',
'and security_group_id = :flow_security_group_id',
'order by LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203523623383535699.4001)
,p_query_column_id=>1
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203523728739535701.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203523824883535701.4001)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205209709423692252.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747142823509138164.4001)
,p_plug_name=>'Copiar Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203454830529378538.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205209709423692252.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203455131762378538.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205209709423692252.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203455924104378545.4001)
,p_branch_action=>'f?p=&APP_ID.:478:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203455131762378538.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10915301321281856.4001)
,p_name=>'P477_EXISTING_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(203453619807378527.4001)
,p_prompt=>'Copiar Entradas de Lista en'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'COPY LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists ',
' where flow_id = v(''FB_FLOW_ID'') ',
'   and id <> :P477_COPY_LIST_FROM',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
' order by 1',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Lista -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Lista en la que se copiar\00E1n las entradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203454100034378536.4001)
,p_name=>'P477_COPY_LIST_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203453619807378527.4001)
,p_prompt=>'Copiar Entradas de Lista de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select name, id from wwv_flow_lists where id = :P477_COPY_LIST_FROM'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Lista de la que se copiar\00E1n las entradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203496202657474468.4001)
,p_validation_name=>'P477_COPY_TO_LIST_NAME'
,p_validation_sequence=>10
,p_validation=>'P477_EXISTING_LIST_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(10915301321281856.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1059807888761457615.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(203454830529378538.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1059807902250457616.4001)
,p_event_id=>wwv_flow_api.id(1059807888761457615.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00478
begin
wwv_flow_api.create_page(
 p_id=>478.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Entradas de Lista: Confirmar Copia de Entrada de Lista'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Entradas de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33739122367577089.4001)
,p_plug_name=>'Copiar Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(33731702665524035.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203456609096378547.4001)
,p_plug_name=>'Copiar Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 07-JUL-2004 16:26:34'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(203532331625549056.4001)
,p_name=>'Informe de Nueva Lista Combinada'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max_seq + i.LIST_ITEM_DISPLAY_SEQUENCE LIST_ITEM_DISPLAY_SEQUENCE, i.LIST_ITEM_LINK_TEXT, LIST_ITEM_LINK_TARGET',
'from WWV_FLOW_LIST_ITEMS i,',
'(select ceil(max(list_item_display_sequence)) max_seq ',
'  from   wwv_flow_list_items',
'  where flow_id = :fb_flow_id and list_id = :p477_copy_list_from) m',
'where flow_id = :fb_flow_id and list_id = :P478_COPY_LIST_FROM',
'union all',
'select LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT, LIST_ITEM_LINK_TARGET',
'from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and list_id = :P478_COPY_LIST_TO',
'order by LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203532627252549060.4001)
,p_query_column_id=>1
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203532708330549060.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(203532810108549060.4001)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205211419597704717.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747142929235138164.4001)
,p_plug_name=>'Copiar Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203457405854378548.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205211419597704717.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203457528477378548.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(205211419597704717.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Entradas de Lista'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203457626747378548.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205211419597704717.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203459219016378556.4001)
,p_branch_name=>'Go To Page 4050'
,p_branch_action=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.::F4000_P4050_LIST_ID:&P477_EXISTING_LIST_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203457528477378548.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203457112181378548.4001)
,p_name=>'P478_COPY_LIST_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203456609096378547.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copiar Entradas de Lista de:'
,p_source=>'&P477_COPY_LIST_FROM.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select wwv_flow_escape.html(name) name, id from wwv_flow_lists where id = :P477_COPY_LIST_FROM'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Lista cuyas entradas se copiar\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203504724390499652.4001)
,p_name=>'P478_COPY_LIST_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(203456609096378547.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copiar Entradas de Lista en:'
,p_source=>'&P477_EXISTING_LIST_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COPY LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists ',
' where flow_id = v(''FB_FLOW_ID'') ',
'   and id <> :P477_COPY_LIST_FROM',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
' order by 1',
''))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Lista en la que se copiar\00E1n las entradas de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1059807662526457613.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(203457405854378548.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1059807798603457614.4001)
,p_event_id=>wwv_flow_api.id(1059807662526457613.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203516901235521392.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_id      number;',
'  l_offset  number;',
'  l_max_seq number;',
'begin',
'',
'  l_offset := wwv_flow_id.next_val;  ',
'',
'  l_id := :P477_EXISTING_LIST_ID;',
'',
'  select ceil(max(list_item_display_sequence)) into l_max_seq ',
'  from   wwv_flow_list_items',
'  where flow_id = :fb_flow_id and list_id = :p477_copy_list_from;',
'      ',
'  insert into wwv_flow_list_items(',
'    id,',
'    list_id,',
'    flow_id,',
'    parent_list_item_id,',
'    list_item_type,',
'    list_item_status,',
'    item_displayed,',
'    list_item_display_sequence,',
'    list_item_link_text,',
'    list_item_link_target,',
'    list_item_icon,',
'    list_item_icon_attributes,',
'    list_item_icon_exp,',
'    list_item_icon_exp_attr,',
'    list_item_owner,',
'    list_item_current_for_pages,',
'    list_item_current_type,',
'    list_item_disp_cond_type,',
'    list_item_disp_condition,',
'    list_item_disp_cond_type2,',
'    list_item_disp_condition2,',
'    list_countclicks_y_n,',
'    list_countclicks_cat,',
'    list_text_01,',
'    list_text_02,',
'    list_text_03,',
'    list_text_04,',
'    list_text_05,',
'    list_text_06,',
'    list_text_07,',
'    list_text_08,',
'    list_text_09,',
'    list_text_10,',
'    list_text_11,',
'    list_text_12,',
'    list_text_13,',
'    list_text_14,',
'    list_text_15,',
'    list_text_16,',
'    list_text_17,',
'    list_text_18,',
'    list_text_19,',
'    list_text_20,',
'    required_patch,',
'    security_scheme',
'  ) select ',
'      id + l_offset,',
'      l_id,',
'      flow_id,',
'      parent_list_item_id + l_offset,',
'      list_item_type,',
'      list_item_status,',
'      item_displayed,',
'      l_max_seq + list_item_display_sequence,',
'      list_item_link_text,',
'      list_item_link_target,',
'      list_item_icon,',
'      list_item_icon_attributes,',
'      list_item_icon_exp,',
'      list_item_icon_exp_attr,',
'      list_item_owner,',
'      list_item_current_for_pages,',
'      list_item_current_type,',
'      list_item_disp_cond_type,',
'      list_item_disp_condition,',
'      list_item_disp_cond_type2,',
'      list_item_disp_condition2,',
'      list_countclicks_y_n,',
'      list_countclicks_cat,',
'      list_text_01,',
'      list_text_02,',
'      list_text_03,',
'      list_text_04,',
'      list_text_05,',
'      list_text_06,',
'      list_text_07,',
'      list_text_08,',
'      list_text_09,',
'      list_text_10,',
'      list_text_11,',
'      list_text_12,',
'      list_text_13,',
'      list_text_14,',
'      list_text_15,',
'      list_text_16,',
'      list_text_17,',
'      list_text_18,',
'      list_text_19,',
'      list_text_20,',
'      required_patch,',
'      security_scheme ',
'    from wwv_flow_list_items',
'    where flow_id = :fb_flow_id and list_id = :p477_copy_list_from;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar la lista'
,p_process_when_button_id=>wwv_flow_api.id(203457528477378548.4001)
,p_process_success_message=>'Lista Copiada'
);
end;
/
prompt --application/pages/page_00479
begin
wwv_flow_api.create_page(
 p_id=>479.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar Diccionario de Tablas'
,p_step_title=>'Exportar Diccionario de Tablas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_ui_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145373602748456400.4001)
,p_plug_name=>'Exportar Diccionario de Tablas'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>111
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145375719024461151.4001)
,p_plug_name=>'Exportar Valores por Defecto de Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cuando se exporta el diccionario de tablas, todos los valores por defecto del esquema seleccionado se exportan a un \00FAnico archivo. Puede utilizar este archivo para importar a otra base de datos que tenga &PRODUCT_NAME. instalado.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145771104245665066.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168865624822966581.4001)
,p_plug_name=>'Exportar Valores por Defecto de Interfaz de Usuario'
,p_region_css_classes=>'u-Border--bottom'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486429006597229058.4001)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>101
,p_list_id=>wwv_flow_api.id(486427731138207743.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145379311883468515.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168865624822966581.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486289803110776745.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168865624822966581.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.:479::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(145571206791599566.4001)
,p_branch_action=>'f?p=&FLOW_ID.:479:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145388905565485646.4001)
,p_name=>'P479_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(145373602748456400.4001)
,p_prompt=>'Esquema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Esquema -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Seleccione el nombre del esquema que se va a exportar.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145394225782500905.4001)
,p_name=>'P479_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(145373602748456400.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145542623844585548.4001)
,p_name=>'P479_COMMIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(145373602748456400.4001)
,p_item_default=>'YES'
,p_prompt=>'Commit'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(145933206201731869.4001)
,p_name=>'P479_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(145373602748456400.4001)
,p_item_default=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Caracteres de Archivo:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(145545923629594905.4001)
,p_validation_name=>'Schema not null'
,p_validation_sequence=>10
,p_validation=>'P479_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el esquema.'
,p_when_button_pressed=>wwv_flow_api.id(145379311883468515.4001)
,p_associated_item=>wwv_flow_api.id(145388905565485646.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651512337100755616.4001)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(145379311883468515.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651512483074755617.4001)
,p_event_id=>wwv_flow_api.id(651512337100755616.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(145708826793624227.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'table_dict_export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- set content disposition    ',
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'',
'',
'wwv_flow_utilities.print_download_header(',
'  p_mime_type => ''application/x-sql'',',
'  p_is_attachment => true,',
'  p_file_name => lower(:P479_SCHEMA)||''_uidefaults.sql''',
');',
'',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export(',
'    p_schema => :P479_SCHEMA,',
'    p_format => :P479_FORMAT);',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al exportar los valores por defecto de interfaz de usuario de &P479_SCHEMA. - Diccionario de Tablas. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(145379311883468515.4001)
,p_process_success_message=>'Diccionario de Tablas de &P479_SCHEMA. exportado.'
);
end;
/
prompt --application/pages/page_00480
begin
wwv_flow_api.create_page(
 p_id=>480.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Regiones de PL/SQL'
,p_step_title=>'Regiones de PL/SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1250431356107871.4001)
,p_plug_name=>unistr('Buscar Texto de Regi\00F3n para Todas las P\00E1ginas de esta Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>131
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, ',
'       plug_name, ',
'       ''<div class="code_text">''||',
'       wwv_flow_escape.html_trunc(plug_source,3000)||',
'       ''</div>'' Source,',
'       id,',
'       page_id the_page_id,',
'       nvl(sys.dbms_lob.getlength(plug_source),0) plsql_length',
'from wwv_flow_page_plugs',
'where flow_id = :fb_flow_id and',
'      security_group_id = :flow_security_group_id and',
'      plug_source_type = ''NATIVE_PLSQL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1250523444107871.4001)
,p_name=>'Search region text for all pages in this application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1250730540107875.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1250805053107876.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1251232464107876.4001)
,p_db_column_name=>'PLSQL_LENGTH'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Bytes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1250911460107876.4001)
,p_db_column_name=>'SOURCE'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Origen'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1251015205107876.4001)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1251106549107876.4001)
,p_db_column_name=>'THE_PAGE_ID'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>unistr('Identificador de P\00E1gina')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193875010235576795.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193878604011650692.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1250431356107871.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:480:&SESSION.::&DEBUG.:480,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171687225658399434.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'480'
);
end;
/
prompt --application/pages/page_00481
begin
wwv_flow_api.create_page(
 p_id=>481.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n: Ruta de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46327923834967291.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114044830167684689.4001)
,p_plug_name=>unistr('Crear Regi\00F3n de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Identifique la ruta de navegaci\00F3n, la lista jer\00E1rquica de p\00E1ginas con nombre, que desea que se muestre en esta p\00E1gina.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114047319609719461.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16141621180084222.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114054228706778846.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46327923834967291.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114052028229769270.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46327923834967291.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114053313123774329.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46327923834967291.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114052218081769273.4001)
,p_branch_action=>'f?p=&FLOW_ID.:264:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114052028229769270.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(574137461899781530.4001)
,p_branch_action=>'f?p=&APP_ID.:263:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114053313123774329.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114055323428796274.4001)
,p_name=>'P481_REGION_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114044830167684689.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_post_element_text=>' '
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select upper(wwv_flow_lang.system_message(''MENU''))||'': ''||wwv_flow_escape.html(name) D, ''M''||id R',
'from wwv_flow_menus where flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la ruta de navegaci\00F3n que se va a asociar a esta regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114056203520828316.4001)
,p_name=>'P481_MENU_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114044830167684689.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_menu_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_menu_template is not null) loop',
'   return c1.default_menu_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Plantilla de Ruta de Navegaci\00F3n')
,p_post_element_text=>' '
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id',
'  from wwv_flow_menu_templates',
' where flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Plantilla de Ruta de Navegaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifique la plantilla de ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114058005860847960.4001)
,p_name=>'P481_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114044830167684689.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114082001002120956.4001)
,p_name=>'P481_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114044830167684689.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n que se va a crear:')
,p_source=>'P263_REGION_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifica la regi\00F3n que se utiliza como contenedor de la ruta de navegaci\00F3n. La regi\00F3n identifica la posici\00F3n de la p\00E1gina donde se colocar\00E1 la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574137294511781528.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114054228706778846.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574137329405781529.4001)
,p_event_id=>wwv_flow_api.id(574137294511781528.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00482
begin
wwv_flow_api.create_page(
 p_id=>482.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades de Proceso'
,p_step_title=>'Utilidades de Proceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193855426155283320.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193855629265283328.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193856216099283331.4001)
,p_plug_name=>'Utilidades de Proceso'
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(171773504090694644.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00484
begin
wwv_flow_api.create_page(
 p_id=>484.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Atributos de P\00E1gina')
,p_step_title=>unistr('Atributos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1182112906345794.4001)
,p_plug_name=>unistr('P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'ID,',
'NAME,',
'ALIAS,',
'STEP_TITLE,',
'HTML_PAGE_HEADER,',
'HTML_PAGE_ONLOAD,',
'"PAGE_COMMENT",',
'(select group_name from wwv_flow_page_groups where id = p.group_id) "GROUP_ID",',
'sys.dbms_lob.substr(HELP_TEXT,4000,1) help_text,',
'(select name from wwv_flow_templates where id = step_template) STEP_TEMPLATE,',
'nvl((select name from WWV_FLOW_SECURITY_SCHEMES where to_char(id) = required_role),required_role) REQUIRED_ROLE,',
'      decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''unknown'') page_type,',
'  (select count(*) c ',
'   from wwv_flow_page_plugs ',
'   where flow_id = p.flow_id and page_id =p.id) regions,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = p.flow_id and flow_step_id=p.id) items,',
'  (select count(*) c ',
'   from wwv_flow_step_buttons ',
'   where flow_id = p.flow_id and flow_step_id=p.id) buttons,',
'  (select count(*) c ',
'   from wwv_flow_step_branches ',
'   where flow_id = p.flow_id and flow_step_id=p.id) branches,',
'  (select count(*) c ',
'   from wwv_flow_step_validations ',
'   where flow_id = p.flow_id and flow_step_id=p.id) validations,',
'  (select count(*) c ',
'   from wwv_flow_step_processing ',
'   where flow_id = p.flow_id and flow_step_id=p.id) processes,',
'  (select count(*) c ',
'   from wwv_flow_step_computations ',
'   where flow_id = p.flow_id and flow_step_id=p.id) computations,',
'  (select count(*) c',
'   from wwv_flow_page_da_events',
'   where flow_id = p.flow_id and page_id = p.id) dynamic_actions',
'from WWV_FLOW_STEPS p,',
'  (select ',
'           wwv_flow_lang.system_message(''LOCKED'') locked,',
'           wwv_flow_lang.system_message(''RUN'') run,',
'           wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual)  sm',
'where flow_id = :FB_FLOW_ID and',
'      security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1182204928345794.4001)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1182411833345797.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1182501764345798.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1182628690345798.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1182700111345798.4001)
,p_db_column_name=>'STEP_TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('T\00EDtulo de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1182831664345798.4001)
,p_db_column_name=>'HTML_PAGE_HEADER'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Cabecera de P\00E1gina HTML')
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1182932223345798.4001)
,p_db_column_name=>'HTML_PAGE_ONLOAD'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Carga de P\00E1gina HTML')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1183030516345799.4001)
,p_db_column_name=>'PAGE_COMMENT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1183100400345799.4001)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Grupo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1183200376345799.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Texto de Ayuda'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1183303595345799.4001)
,p_db_column_name=>'STEP_TEMPLATE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Plantilla'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1183411741345799.4001)
,p_db_column_name=>'REQUIRED_ROLE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Rol Necesario:'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185228274412904.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185332038412904.4001)
,p_db_column_name=>'ITEMS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Elementos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185412039412904.4001)
,p_db_column_name=>'BUTTONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Botones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185526368412904.4001)
,p_db_column_name=>'BRANCHES'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Bifurcaciones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185613532412904.4001)
,p_db_column_name=>'VALIDATIONS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Validaciones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185730413412905.4001)
,p_db_column_name=>'PROCESSES'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Procesos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185818455412905.4001)
,p_db_column_name=>'COMPUTATIONS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('C\00E1lculos')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1185900835412905.4001)
,p_db_column_name=>'DYNAMIC_ACTIONS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acciones Din\00E1micas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13186323314901739.4001)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Tipo de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194058513854631467.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1182112906345794.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:484:&SESSION.::&DEBUG.:484,RIR::'
);
end;
/
prompt --application/pages/page_00485
begin
wwv_flow_api.create_page(
 p_id=>485.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Entrada de Barra de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47722221340586399.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114688611078148636.4001)
,p_plug_name=>unistr('Copiar Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114688822983148638.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47722221340586399.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114689023642148642.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47722221340586399.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114690823003148661.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114689226033148644.4001)
,p_name=>'P485_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114688611078148636.4001)
,p_prompt=>unistr('Copiar Entrada de Barra de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ICON_SEQUENCE||''. ''||wwv_flow_escape.html(nvl(ICON_SUBTEXT,ICON_IMAGE_ALT)) d, id',
'from WWV_FLOW_ICON_BAR',
'where flow_id = :fb_flow_id',
'order by icon_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la lista que se va a copiar'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114700709735292976.4001)
,p_name=>'P485_NAVBAR_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114688611078148636.4001)
,p_prompt=>unistr('Nombre de Entrada de Barra de Navegaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre del nuevo componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115337707715713752.4001)
,p_name=>'P485_NAVBAR_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114688611078148636.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(ICON_SEQUENCE),0) + 10 ms',
'from WWV_FLOW_ICON_BAR',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la secuencia de visualizaci\00F3n de este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114690224089148652.4001)
,p_validation_name=>'P485_ID'
,p_validation_sequence=>20
,p_validation=>'P485_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(114689023642148642.4001)
,p_associated_item=>wwv_flow_api.id(114689226033148644.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114702327181307477.4001)
,p_validation_name=>'P485_NAVBAR_NAME'
,p_validation_sequence=>30
,p_validation=>'P485_NAVBAR_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(114689023642148642.4001)
,p_associated_item=>wwv_flow_api.id(114700709735292976.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115338616026716123.4001)
,p_validation_name=>'P485_NAVBAR_SEQUENCE'
,p_validation_sequence=>40
,p_validation=>'P485_NAVBAR_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(114689023642148642.4001)
,p_associated_item=>wwv_flow_api.id(115337707715713752.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115339625723718993.4001)
,p_validation_name=>'P485_NAVBAR_SEQUENCE'
,p_validation_sequence=>50
,p_validation=>'P485_NAVBAR_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El valor debe ser num\00E9rico')
,p_when_button_pressed=>wwv_flow_api.id(114689023642148642.4001)
,p_associated_item=>wwv_flow_api.id(115337707715713752.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590012554459897518.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114688822983148638.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590012600251897519.4001)
,p_event_id=>wwv_flow_api.id(590012554459897518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114690628673148657.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Navigation Bar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * from WWV_FLOW_ICON_BAR where id = :P485_ID) loop',
'insert into WWV_FLOW_ICON_BAR (',
'    ID,',
'    FLOW_ID,',
'    ICON_SEQUENCE,',
'    ICON_IMAGE,',
'    ICON_IMAGE2,',
'    ICON_IMAGE3,',
'    ICON_SUBTEXT,',
'    ICON_SUBTEXT2,',
'    ICON_SUBTEXT3,',
'    ICON_TARGET,',
'    ICON_IMAGE_ALT,',
'    ICON_HEIGHT,',
'    ICON_WIDTH,',
'    ICON_HEIGHT2,',
'    ICON_WIDTH2,',
'    ICON_HEIGHT3,',
'    ICON_WIDTH3,',
'    ICON_BAR_DISP_COND,',
'    ICON_BAR_DISP_COND_TYPE,',
'    ICON_BAR_FLOW_COND_INSTR,',
'    BEGINS_ON_NEW_LINE,',
'    CELL_COLSPAN,',
'    ONCLICK,',
'    REQUIRED_PATCH,',
'    SECURITY_SCHEME,',
'    REFERENCE_ID,',
'    SECURITY_GROUP_ID,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON,',
'    ICON_BAR_COMMENT)',
'values (',
'    wwv_flow.GET_UNIQUE_ID,',
'    c1.FLOW_ID,',
'    :P485_NAVBAR_SEQUENCE,',
'    c1.ICON_IMAGE,',
'    c1.ICON_IMAGE2,',
'    c1.ICON_IMAGE3,',
'    c1.ICON_SUBTEXT,',
'    c1.ICON_SUBTEXT2,',
'    c1.ICON_SUBTEXT3,',
'    c1.ICON_TARGET,',
'    :P485_NAVBAR_NAME,',
'    c1.ICON_HEIGHT,',
'    c1.ICON_WIDTH,',
'    c1.ICON_HEIGHT2,',
'    c1.ICON_WIDTH2,',
'    c1.ICON_HEIGHT3,',
'    c1.ICON_WIDTH3,',
'    c1.ICON_BAR_DISP_COND,',
'    c1.ICON_BAR_DISP_COND_TYPE,',
'    c1.ICON_BAR_FLOW_COND_INSTR,',
'    c1.BEGINS_ON_NEW_LINE,',
'    c1.CELL_COLSPAN,',
'    c1.ONCLICK,',
'    c1.REQUIRED_PATCH,',
'    c1.SECURITY_SCHEME,',
'    c1.REFERENCE_ID,',
'    :flow_security_group_id,',
'    :app_user,',
'    sysdate,',
'    c1.ICON_BAR_COMMENT);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar la entrada de la barra de navegaci\00F3n')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(114689023642148642.4001)
,p_process_success_message=>unistr('Entrada de barra de navegaci\00F3n copiada')
);
end;
/
prompt --application/pages/page_00491
begin
wwv_flow_api.create_page(
 p_id=>491.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Informes de Temas: Referencias de Clase'
,p_step_title=>'Informes de Temas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149650701426899427.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(58949101764235429.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(157973526515079682.4001)
,p_name=>'Referencias de Clase'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'initcap(c001) Component,',
'c002 theme,',
'c003 template_class,',
'c004 component_name,',
'c005 class,',
'c006 page_id',
'from htmldb_collections',
'where collection_name = ''CLASS_REFERENCE'''))
,p_display_when_condition=>'P491_SHOW_CLASSES'
,p_display_when_cond2=>'CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157974014101079802.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Componente'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157974101773079803.4001)
,p_query_column_id=>2
,p_column_alias=>'THEME'
,p_column_display_sequence=>2
,p_column_heading=>'Tema'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157974216222079803.4001)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'Template Class'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157974317106079803.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157974420132079803.4001)
,p_query_column_id=>5
,p_column_alias=>'CLASS'
,p_column_display_sequence=>5
,p_column_heading=>'Clase con Referencia'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(157974518065079803.4001)
,p_query_column_id=>6
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>6
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157992124614116931.4001)
,p_plug_name=>'Report Preferences'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(158155710172245274.4001)
,p_plug_name=>'show extra information or just files'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(158369011351680870.4001)
,p_name=>'Referencias de Clase Distintas'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c005 class',
'from htmldb_collections',
'where collection_name = ''CLASS_REFERENCE''',
'order by 1'))
,p_display_when_condition=>'P491_SHOW_CLASSES'
,p_display_when_cond2=>'NO_CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(158369628271680889.4001)
,p_query_column_id=>1
,p_column_alias=>'CLASS'
,p_column_display_sequence=>1
,p_column_heading=>'Clase con Referencia'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(158184125541259101.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_button_name=>'P491_GO'
,p_button_static_id=>'P491_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ir'
,p_button_position=>'NEXT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205472416406763879.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'1'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205473223332765882.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'2'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205474031990768344.4001)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.::&DEBUG.:RP:P492_SHOW:TEMPLATE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205477712728772261.4001)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.::&DEBUG.::P435_SHOW:FILE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(158184420206259104.4001)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157993331887119003.4001)
,p_name=>'P491_THEME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Temas -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione los temas que se van a incluir en este informe y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157995609508122045.4001)
,p_name=>'P491_SHOW_TEMPLATES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_prompt=>'Mostrar:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX SHOW TEMPLATES'
,p_lov=>'.'||wwv_flow_api.id(152029513350781444.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el tipo de referencias de clase que se van a incluir en este informe. Si no realiza ninguna selecci\00F3n, no se devuelven resultados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(158141225971240320.4001)
,p_name=>'P491_SHOW_COMPONENTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX SHOW SHARED COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(144512500887046057.4001)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Muestre archivos a los que se hace referencia en componentes compartidos y componentes de p\00E1gina adem\00E1s de las plantillas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(158142932205242132.4001)
,p_name=>'P491_SHOW_PAGE_COMPONENTS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX SHOW PAGE COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(145937328496747754.4001)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(158371428320685793.4001)
,p_name=>'P491_SHOW_CLASSES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_prompt=>'Mostrar Nombre de Clase:'
,p_source=>'CONTEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FIND FILES REPORT OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(152121930169975580.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el tipo de informe que desea ver.<p/> ',
unistr('<strong>Con contexto</strong> muestra el componente, el identificador de tema, el nombre del componente, la clase de referencia y el n\00FAmero de p\00E1gina relevante. Seleccione el n\00FAmero de p\00E1gina para enlazar con una definici\00F3n de p\00E1gina.<p/> '),
unistr('<strong>Sin contexto</strong> muestra s\00F3lo la clase de referencia.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205443516266678650.4001)
,p_name=>'P491_SHOW'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(157992124614116931.4001)
,p_item_default=>'1'
,p_prompt=>'Informe'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_api.id(48989614083583743.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el informe que desea ver y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(157986317904105564.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.find_css_classes(',
'  p_flow_id => :fb_flow_id, ',
'  p_theme => :P491_THEME,',
'  p_show_templates => nvl(:P491_SHOW_TEMPLATES,''N''),',
'  p_show_page_components => nvl(v(''P491_SHOW_PAGE_COMPONENTS''),''N''),',
'  p_show_components=> nvl(:P491_SHOW_COMPONENTS,''N'')',
'  );',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la recopilaci\00F3n en la consulta.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(158186001777261730.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00492
begin
wwv_flow_api.create_page(
 p_id=>492.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Informes de Temas: Cadenas de Sustituci\00F3n de Plantillas')
,p_step_title=>'Informes de Temas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149656125227915223.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(58949101764235429.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166929206907896383.4001)
,p_plug_name=>'Preferencias de Informe'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(166937227817911808.4001)
,p_name=>unistr('Cadenas de Sustituci\00F3n de Plantillas')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'initcap(c001) Component,',
'c002 theme,',
'c003 template_class,',
'''<a href="''||wwv_flow_escape.html(c008)||''">''||wwv_flow_escape.html(c004)||''</a>'' component_name,',
'c005 string,',
'c006 attribute,',
'decode(wwv_flow_escape.html(c007),''N'','''',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') referenced,',
'decode(wwv_flow_escape.html(c009),''N'','''',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') required',
'from htmldb_collections',
'where collection_name = ''TEMPLATE_SUB_STRINGS''',
'and (:P492_FIND is null or ',
'     instr(upper(c001),upper(:P492_FIND))>0 or',
'     instr(upper(c003),upper(:P492_FIND))>0 or',
'     instr(upper(c004),upper(:P492_FIND))>0 or',
'     instr(upper(c005),upper(:P492_FIND))>0 or',
'     instr(upper(c006),upper(:P492_FIND))>0)',
'order by 1,2,3,4,5,6'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166937826276911878.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Componente'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166938112082911893.4001)
,p_query_column_id=>2
,p_column_alias=>'THEME'
,p_column_display_sequence=>2
,p_column_heading=>'Tema'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166938202014911893.4001)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'Template Class'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166938319941911893.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Componente'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166938418059911893.4001)
,p_query_column_id=>5
,p_column_alias=>'STRING'
,p_column_display_sequence=>5
,p_column_heading=>'Atributo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166938517302911893.4001)
,p_query_column_id=>6
,p_column_alias=>'ATTRIBUTE'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Cadena de Sustituci\00F3n')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(166938605789911893.4001)
,p_query_column_id=>7
,p_column_alias=>'REFERENCED'
,p_column_display_sequence=>7
,p_column_heading=>'Con Referencia'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(167062920563061193.4001)
,p_query_column_id=>8
,p_column_alias=>'REQUIRED'
,p_column_display_sequence=>8
,p_column_heading=>unistr('T\00EDpica')
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(167042513712964584.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(166929206907896383.4001)
,p_button_name=>'P492_GO'
,p_button_static_id=>'P492_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205480804894779454.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'1'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205481710088780967.4001)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'2'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205482817361783076.4001)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.::&DEBUG.::P435_SHOW:FILE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205484803639788594.4001)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.::&DEBUG.::P491_SHOW:CLASS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'CLASS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(167042810927964593.4001)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(124733503998773902.4001)
,p_name=>'P492_FIND'
,p_item_sequence=>3.5
,p_item_plug_id=>wwv_flow_api.id(166929206907896383.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas para el nombre de un tema y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(166930311063897571.4001)
,p_name=>'P492_THEME'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(166929206907896383.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Temas -'
,p_lov_null_value=>'0'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione los temas que se van a incluir en este informe. Este informe puede incluir todos los temas, o bien puede seleccionar un tema concreto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205444322153680349.4001)
,p_name=>'P492_SHOW'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(166929206907896383.4001)
,p_item_default=>'1'
,p_prompt=>'Informe'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_api.id(48989614083583743.4001)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el informe que desea ver y haga clic en <span class="fielddatabold">Ir</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(167108531195281881.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'492'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(167043921330966783.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(166927427901892913.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.find_substitution_strings (',
'    p_flow_id  => :fb_flow_id,',
'    p_theme    => :p492_theme);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido rellenar la recopilaci\00F3n')
);
end;
/
prompt --application/pages/page_00493
begin
wwv_flow_api.create_page(
 p_id=>493.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Esquema de Autorizaci\00F3n')
,p_step_title=>unistr('Copiar Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114707503591354917.4001)
,p_plug_name=>unistr('Copiar Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(886492598737981501.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(886492604073981502.4001)
,p_plug_name=>unistr('Copiar Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114707704022354918.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(886492598737981501.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114707902322354920.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(886492598737981501.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114709701442354927.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114708107056354921.4001)
,p_name=>'P493_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114707503591354917.4001)
,p_prompt=>unistr('Copiar Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME d, id r',
'from  WWV_FLOW_SECURITY_SCHEMES',
'where flow_id = :fb_flow_ID',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Esquema Existente --'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el esquema de autorizaci\00F3n que se va a copiar')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114708624956354923.4001)
,p_name=>'P493_SECURITY_SCHEME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114707503591354917.4001)
,p_prompt=>unistr('Nuevo Nombre de Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el nombre del nuevo esquema de autorizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114709530282354925.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Security Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_util.copy_security_scheme (',
'      p_copy_from_flow_id  => :fb_flow_id,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_scheme_id     => :P493_ID,',
'      p_to_scheme_name     => :P493_security_scheme );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar el esquema de autorizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(114707902322354920.4001)
,p_process_success_message=>unistr('Esquema de autorizaci\00F3n copiado.')
);
end;
/
prompt --application/pages/page_00497
begin
wwv_flow_api.create_page(
 p_id=>497.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Barra de Navegaci\00F3n: Comentarios')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46444500385193591.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196961823831752882.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(103870209211856610.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196962030758754908.4001)
,p_plug_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Las entradas de navegaci\00F3n de comentarios acceden a p\00E1ginas de comentarios del desarrollo de equipos. Para solicitar comentarios de los usuarios, su aplicaci\00F3n necesitar\00E1 contar con una p\00E1gina de comentarios. Haga clic en la tarea <strong>Crear P\00E1')
||unistr('gina de Comentarios</strong> para crear una p\00E1gina de comentarios y una entrada de barra de navegaci\00F3n si todav\00EDa no existe la p\00E1gina de comentarios.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(197003820180338335.4001)
,p_name=>unistr('Entradas de Barra de Navegaci\00F3n Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ICON_SEQUENCE, ',
'       decode(wwv_flow_escape.html(icon_image),null,null,sys.htf.img(''&IMAGE_PREFIX.''||wwv_flow_escape.html(ICON_IMAGE))) img, ',
'       substr(ICON_IMAGE_ALT,1,20) a,',
'       decode(ICON_BAR_DISP_COND,',
'          null,wwv_flow_lang.system_message(''F4000.NO''),',
'          wwv_flow_lang.system_message(''F4000.YES'')) is_cond',
'from   wwv_flow_icon_bar',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(197004023861338338.4001)
,p_query_column_id=>1
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(197004124485338338.4001)
,p_query_column_id=>2
,p_column_alias=>'IMG'
,p_column_display_sequence=>2
,p_column_heading=>'Imagen'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(197004209532338338.4001)
,p_query_column_id=>3
,p_column_alias=>'A'
,p_column_display_sequence=>3
,p_column_heading=>'Texto ALT'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(197004322186338338.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_COND'
,p_column_display_sequence=>4
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197012316305427110.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(197011632441427104.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196962600610754910.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(46444500385193591.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196962400729754910.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46444500385193591.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196962204502754910.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46444500385193591.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(573754312312229724.4001)
,p_branch_action=>'f?p=&APP_ID.:392:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(196962400729754910.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196968331506859110.4001)
,p_name=>'P497_FEEDBACK_PAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(196962030758754908.4001)
,p_prompt=>unistr('P\00E1gina de Comentarios')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(id) id',
'from wwv_flow_steps',
'where security_group_id = :FLOW_SECURITY_GROUP_ID and',
'         flow_id = :FB_FLOW_ID and ',
'         id ! = 0 and',
'         ALIAS like ''FEEDBACK%'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name n, id',
'from wwv_flow_steps',
'where security_group_id = :FLOW_SECURITY_GROUP_ID and',
'         flow_id = :FB_FLOW_ID and ',
'         id ! = 0',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que ser\00E1 la p\00E1gina de comentarios.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196968508944859110.4001)
,p_name=>'P497_ENTRY_LABEL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(196962030758754908.4001)
,p_prompt=>'Etiqueta de Entrada'
,p_source=>'return wwv_flow_lang.system_message(''FEEDBACK'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Etiqueta de la nueva entrada de la barra de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196988405907078770.4001)
,p_name=>'P497_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(196962030758754908.4001)
,p_prompt=>unistr('Secuencia de Visualizaci\00F3n')
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>30
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Secuencia de la nueva entrada de la barra de navegaci\00F3n. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573752981530229710.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(196962204502754910.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573753050102229711.4001)
,p_event_id=>wwv_flow_api.id(573752981530229710.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(196972424028942109.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Navigation Bar Entry'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_icon_bar_item (',
'  p_flow_id                  => :FB_FLOW_ID,',
'  p_icon_sequence            => :P497_DISPLAY_SEQUENCE,',
'  p_icon_image               => null,',
'  p_icon_image2              => null,',
'  p_icon_image3              => null,',
'  p_icon_subtext             => :P497_ENTRY_LABEL,',
'  p_icon_subtext2            => null,',
'  p_icon_subtext3            => null,',
'  p_icon_target              => ''f?p=''||:FB_FLOW_ID||'':''||:P497_FEEDBACK_PAGE||'':&''||''SESSION.:::''||:P497_FEEDBACK_PAGE||',
'                                '':P''||:P497_FEEDBACK_PAGE||''_APPLICATION_ID,''||',
'                                ''P''||:P497_FEEDBACK_PAGE||''_PAGE_ID:''||',
'                                ''&''||''APP_ID.,''||''&''||''APP_PAGE_ID.'',',
'  p_icon_image_alt           => null,',
'  p_icon_height              => null,',
'  p_icon_width               => null,',
'  p_icon_height2             => null,',
'  p_icon_width2              => null,',
'  p_icon_height3             => null,',
'  p_icon_width3              => null,',
'  p_icon_bar_disp_cond       => null,',
'  p_icon_bar_disp_cond_type  => null,',
'  p_icon_bar_flow_cond_instr => null,',
'  p_begins_on_new_line       => ''NO'',',
'  p_cell_colspan             => ''1'',',
'  p_onclick                  => null,',
'  p_required_patch           => null,',
'  p_nav_entry_is_feedback_yn => ''Y'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(196962600610754910.4001)
,p_process_success_message=>'Entrada Creada'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1119156825179390631.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Enable Feedback'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flows',
'   set allow_feedback_yn = ''Y''',
' where id                = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(allow_feedback_yn, ''N'') = ''N'';',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(196962600610754910.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(allow_feedback_yn, ''N'') = ''N'''))
,p_process_when_type=>'EXISTS'
,p_process_success_message=>unistr('Comentarios activados para la aplicaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(573753166390229712.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(196962600610754910.4001)
,p_process_success_message=>'Entrada Creada'
);
end;
/
prompt --application/pages/page_00498
begin
wwv_flow_api.create_page(
 p_id=>498.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Regi\00F3n: Identificar Tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47961005137887467.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150850830508499550.4001)
,p_plug_name=>unistr('Crear Plantilla de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<div class="htmldbInfoBodyP">Un tema es una recopilaci\00F3n con nombre de plantillas. Una aplicaci\00F3n puede tener uno o m\00E1s temas.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150869430555527912.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(150852002588500985.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47961005137887467.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(150852710366500986.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47961005137887467.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(150852305484500986.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47961005137887467.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(150859305143511165.4001)
,p_branch_action=>'f?p=&FLOW_ID.:158:&SESSION.::&DEBUG.:158::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(150852710366500986.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589947870189621423.4001)
,p_branch_action=>'f?p=&APP_ID.:4320:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(150852305484500986.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150867515664523657.4001)
,p_name=>'P498_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P4320_COPY_FROM_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema desde el que desea copiar plantillas.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150867822066523659.4001)
,p_name=>'P498_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150937226502659256.4001)
,p_name=>'P498_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'F4000_P4320_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n desde la que se va a copiar el tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(150939115205665491.4001)
,p_name=>'P498_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se va a copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151522121971131010.4001)
,p_name=>'P498_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151524714830138481.4001)
,p_name=>'P498_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_prompt=>'Copiar de:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema del que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(151526826258141761.4001)
,p_name=>'P498_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(150850830508499550.4001)
,p_prompt=>'Copiar en:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema al que se va a copiar la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2461538595174568023.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P498_COPY_TO_THEME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589947617364621421.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(150852002588500985.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589947797844621422.4001)
,p_event_id=>wwv_flow_api.id(589947617364621421.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00499
begin
wwv_flow_api.create_page(
 p_id=>499.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Aplicaci\00F3n: Identificar Destino de Copia')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23837626511624502.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(23817524863605164.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46513214819007151.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(115189910267008017.4001)
,p_plug_name=>unistr('Copiar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115190309182008023.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46513214819007151.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115190615887008023.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46513214819007151.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(115190927483008025.4001)
,p_branch_action=>'f?p=&APP_ID.:611:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(115190615887008023.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115190113318008022.4001)
,p_name=>'P499_OLD_APP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(115189910267008017.4001)
,p_prompt=>unistr('Identificador de Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el identificador de aplicaci\00F3n que se va a copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115210214127053223.4001)
,p_name=>'P499_OLD_APP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(115189910267008017.4001)
,p_prompt=>unistr('Nombre de la Aplicaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flows',
'where id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el nombre de aplicaci\00F3n que se va a copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115251924357169706.4001)
,p_name=>'P499_NEW_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(115189910267008017.4001)
,p_prompt=>unistr('Identificador de Nueva Aplicaci\00F3n')
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un valor entero \00FAnico para identificar la aplicaci\00F3n. Tenga en cuenta que los identificadores de aplicaci\00F3n entre 3000 y 9000 est\00E1n reservados para uso interno por parte de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115253814792176447.4001)
,p_name=>'P499_NEW_APP_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(115189910267008017.4001)
,p_prompt=>unistr('Nombre de Nueva Aplicaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flows',
'where id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un breve nombre descriptivo para la aplicaci\00F3n para distinguir la nueva aplicaci\00F3n en los informes y listas de selecci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115519132330298097.4001)
,p_name=>'P499_COPY_DEPLOYMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(115189910267008017.4001)
,p_item_default=>'N'
,p_prompt=>'Copiar Definiciones de Objeto de Soporte'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Puede copiar las definiciones de objetos de soporte, las opciones de configuraci\00F3n y los scripts en la aplicaci\00F3n. '),
'<p />',
unistr('Seleccione <strong>Activado</strong> para incluir definiciones de objetos de base de datos, definiciones de im\00E1genes y sentencias SQL de datos iniciales encapsulados en un solo archivo.'),
'Seleccione <strong>Desactivado</strong> para no incluir definiciones de objetos de soporte.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115258412545213654.4001)
,p_validation_name=>'P499_NEW_APP_ID'
,p_validation_sequence=>10
,p_validation=>'P499_NEW_APP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo identificador de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115261712330223049.4001)
,p_validation_name=>'P499_NEW_APP_NAME'
,p_validation_sequence=>20
,p_validation=>'P499_NEW_APP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo nombre de la aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115253814792176447.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115268807397240517.4001)
,p_validation_name=>'P499_NEW_APP_ID'
,p_validation_sequence=>30
,p_validation=>'P499_NEW_APP_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El nuevo identificador de aplicaci\00F3n debe ser num\00E9rico.')
,p_validation_condition=>'P499_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115274504543258677.4001)
,p_validation_name=>'new ID not same as old ID'
,p_validation_sequence=>40
,p_validation=>'ltrim(:P499_NEW_APP_ID,''0'') != nvl(:P499_OLD_APP_ID,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nuevo identificador de aplicaci\00F3n debe ser diferente al identificador de la aplicaci\00F3n actual.')
,p_validation_condition=>'P499_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115280305366268386.4001)
,p_validation_name=>'Min APP ID'
,p_validation_sequence=>50
,p_validation=>':P499_NEW_APP_ID > 99'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de identificador de aplicaci\00F3n m\00EDnimo es 100. Introduzca un identificador de aplicaci\00F3n de 100 o superior.')
,p_validation_condition=>'wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115284107575278406.4001)
,p_validation_name=>'reserved app id check'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_utilities.is_available_application_id(',
'    p_security_group_id => :flow_security_group_id,',
'    p_application_id    => :P499_NEW_APP_ID,',
'    p_check_reserved    => FALSE ) = FALSE then',
'    --',
'    return FALSE;',
'else',
'    return TRUE;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Identificador de aplicaci\00F3n reservado.')
,p_validation_condition=>':flow_security_group_id != 10 and wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115289825022292912.4001)
,p_validation_name=>'cannot copy invalid range flow'
,p_validation_sequence=>70
,p_validation=>':P499_NEW_APP_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La aplicaci\00F3n que est\00E1 intentando copiar est\00E1 reservada.')
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P499_NEW_APP_ID is not null) and (wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID))'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115557302819384156.4001)
,p_validation_name=>'no deployment exists'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_install_scripts ',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Debe definir al menos un script de instalaci\00F3n para copiar definiciones de objeto de soporte.')
,p_validation_condition=>'P499_COPY_DEPLOYMENT'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115519132330298097.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115647826143674765.4001)
,p_validation_name=>'application ID exists'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flows',
'where id = :P499_NEW_APP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ya existe un nuevo identificador de aplicaci\00F3n.')
,p_validation_condition=>'wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID) and ltrim(:P499_NEW_APP_ID,''0'') != nvl(:P499_OLD_APP_ID,-1)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(115190615887008023.4001)
,p_associated_item=>wwv_flow_api.id(115251924357169706.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1617425155739257713.4001)
,p_validation_name=>'New'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_name (',
'  p_name => :P499_NEW_APP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'error'
,p_associated_item=>wwv_flow_api.id(115253814792176447.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590117327753572009.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(115190309182008023.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590117415002572010.4001)
,p_event_id=>wwv_flow_api.id(590117327753572009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_api.create_page(
 p_id=>500.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Conexi\00F3n')
,p_alias=>'LOGINWIZARD'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina de Conexi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16069709378853765.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15960618523591402.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32946732190131198.4001)
,p_plug_name=>unistr('Crear P\00E1gina de Conexi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44599217082308425.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32962716081438797.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44599217082308425.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32964311364446961.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44599217082308425.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279436002130267974.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44599217082308425.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32964602511446962.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32964311364446961.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32963019980438798.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32962716081438797.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548799500134869720.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279436002130267974.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32950631328168828.4001)
,p_name=>'P500_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(32946732190131198.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select max(id) id',
'             from wwv_flow_steps',
'            where flow_id = :FB_FLOW_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID)',
'loop',
'   return (c1.id + 10);',
'   exit;',
'end loop;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indique el n\00FAmero de p\00E1gina que se va a utilizar para esta p\00E1gina de conexi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32952221679194427.4001)
,p_name=>'P500_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(32946732190131198.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flows',
'             where security_group_id = :flow_security_group_id',
'               and id = :fb_flow_id )',
'loop',
'    return c1.name || '' - '' || wwv_flow_lang.system_message(''LOG_IN'');',
'end loop;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre de la p\00E1gina de conexi\00F3n que se va a crear. Este nombre se utiliza en varias p\00E1ginas e informes de &PRODUCT_NAME..'),
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32953003109198505.4001)
,p_name=>'P500_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(32946732190131198.4001)
,p_prompt=>'Plantilla'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGETEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = (case when :P4301_PAGE_MODE = ''NORMAL'' then ''N'' else ''Y'' end)',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('* Plantilla de Aplicaci\00F3n por Defecto')
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de p\00E1gina que va a utilizar esta p\00E1gina de conexi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32954210606266955.4001)
,p_name=>'P500_USERNAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(32946732190131198.4001)
,p_item_default=>'wwv_flow_lang.system_message(''WWV_FLOW_FND_USER_API.T_USERNAME'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Etiqueta para el Campo "Usuario"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca el valor que aparecer\00E1 junto al petici\00F3n de datos del valor del nombre de usuario que va a capturar esta p\00E1gina de conexi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32955432423273228.4001)
,p_name=>'P500_PASSWORD'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(32946732190131198.4001)
,p_item_default=>'wwv_flow_lang.system_message(''WWV_FLOW_FND_USER_API.T_PASSWORD'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Etiqueta para el Campo "Contrase\00F1a"')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca el valor que aparecer\00E1 junto al petici\00F3n de datos del valor de la contrase\00F1a que va a capturar esta p\00E1gina de conexi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32959421529383580.4001)
,p_name=>'P500_COOKIE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(32946732190131198.4001)
,p_item_default=>'Y'
,p_prompt=>'Guardar Nombre de Usuario en Cookie'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX_Y_NOPROMPT'
,p_lov=>'.'||wwv_flow_api.id(84715102189754797.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165510806451937527.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33278107478590751.4001)
,p_validation_name=>'P500_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P500_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(32964311364446961.4001)
,p_associated_item=>wwv_flow_api.id(32950631328168828.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548798368975867027.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(32962716081438797.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548798653389867030.4001)
,p_event_id=>wwv_flow_api.id(548798368975867027.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33020905280956123.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Login Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_login_page (',
'    p_flow_id              => :FB_FLOW_ID,',
'    p_page_id              => :P500_PAGE_ID,',
'    p_name                 => :P500_NAME,',
'    p_user_interface_id    => :P259_USER_INTERFACE_ID,',
'    p_template             => :P500_TEMPLATE,',
'    p_username             => :P500_USERNAME,',
'    p_password             => :P500_PASSWORD,',
'    p_save_username_cookie => :P500_COOKIE = ''Y'' );',
'',
':FB_FLOW_PAGE_ID := :P500_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina de conexi\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(548799808981876085.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina de conexi\00F3n creada.')
);
end;
/
prompt --application/pages/page_00501
begin
wwv_flow_api.create_page(
 p_id=>501.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Validaciones por P\00E1gina')
,p_step_title=>unistr('Validaciones por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13182325167857933.4001)
,p_plug_name=>unistr('Validaciones de Elementos por P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, ',
'(select count(*) from wwv_flow_step_items where flow_id = :fb_flow_id and flow_step_id = p.id) total_items,',
'vi.validatable_items, ',
'(select count(*) ',
'from WWV_FLOW_STEP_VALIDATIONS ',
'where associated_item in (',
'select id from wwv_flow_step_items ',
'where flow_id = :fb_flow_id and flow_step_id = p.id)) existing_validations,',
'      decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''unknown'') page_type',
'from',
'  wwv_flow_steps p,',
'(',
'select flow_step_id, count(*) validatable_items',
'from wwv_flow_step_items i',
'where ',
'(',
'i.display_as in (''NATIVE_CHECKBOX'', ''NATIVE_FILE'', ''NATIVE_POPUP_LOV'', ''TEXT'', ''TEXT_WITH_ENTER_SUBMIT'', ''NATIVE_SHUTTLE'', ''NATIVE_RICH_TEXT_EDITOR'', ''NATIVE_TEXTAREA'', ''NATIVE_DATE_PICKER'', ''NATIVE_DATE_PICKER_CLASSIC'', ''NATIVE_SELECT_LIST'', ''NATIVE'
||'_RADIOGROUP'' )',
')',
'and flow_id = :fb_flow_id',
'group by flow_step_id',
') vi,',
'  (select ',
'           wwv_flow_lang.system_message(''LOCKED'') locked,',
'           wwv_flow_lang.system_message(''RUN'') run,',
'           wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual)  sm',
'where vi.flow_step_id = p.id and',
'      p.flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(13182414714857933.4001)
,p_name=>'Item Validations by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13182616873857945.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_link_attr=>'View Page Defin'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13182709953857945.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13182803266857945.4001)
,p_db_column_name=>'TOTAL_ITEMS'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Total de Elementos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13182921425857945.4001)
,p_db_column_name=>'VALIDATABLE_ITEMS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Elementos Validables'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13183026265857946.4001)
,p_db_column_name=>'EXISTING_VALIDATIONS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Validaciones Existentes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13184802966876927.4001)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>unistr('Tipo de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193776917574991650.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193779603160996967.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(13182325167857933.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.:501,RIR::'
);
end;
/
prompt --application/pages/page_00502
begin
wwv_flow_api.create_page(
 p_id=>502.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Bot\00F3n')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Bot\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161930829844889424.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(161932106772892299.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>41
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id||'': ''||button_name bname',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id ',
'  and  button_template_id = :p502_id',
'union all',
'select ''0: Default Button Template'' ',
'  from wwv_flow_themes ',
'where  flow_id = :fb_flow_id ',
'  and default_button_template = :p502_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(162350202223212638.4001)
,p_query_column_id=>1
,p_column_alias=>'BNAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre del Bot\00F3n')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692818596424250947.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(692818606378250948.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>51
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161933417854895464.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(692818606378250948.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161934222356896768.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(692818606378250948.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(162472526558276493.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161997222272915675.4001)
,p_name=>'P502_TEMPLATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(161930829844889424.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>'select template_name from wwv_flow_button_templates where id = :p502_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identifique el nombre de la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162000710975921830.4001)
,p_name=>'P502_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(161930829844889424.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'select theme_id from wwv_flow_button_templates where id = :p502_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162003824481925725.4001)
,p_name=>'P502_THEME_CLASS_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(161930829844889424.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Tema:'
,p_source=>'select theme_class_id from wwv_flow_button_templates where id = :p502_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'BUTTON THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43576623634636183.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la clase de tema de la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162059106314034093.4001)
,p_name=>'P502_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(161930829844889424.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(162368407118242495.4001)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in ( select count(*) counter from (',
'select button_name||'' - Page ''||flow_step_id bname',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id ',
'  and  button_template_id = :p502_id',
'union all',
'select ''Default Button Template - Theme ''||theme_id ',
'  from wwv_flow_themes ',
'where  flow_id = :fb_flow_id ',
'  and default_button_template = :p502_id) ',
' ) loop',
'if c1.counter = 0 then ',
' return true;',
'else ',
' return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede suprimir una plantilla de bot\00F3n con referencias.')
,p_when_button_pressed=>wwv_flow_api.id(161934222356896768.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162478916777292542.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_button_templates ',
'where flow_id = :fb_flow_id ',
'and id = :p502_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Plantilla no suprimida.'
,p_process_when_button_id=>wwv_flow_api.id(161934222356896768.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00503
begin
wwv_flow_api.create_page(
 p_id=>503.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Ruta de Navegaci\00F3n')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Ruta de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162628331650495577.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(162629602345496587.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||plug_name l_name ',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and menu_template_id = :p503_id',
'and security_group_id = :flow_security_group_id',
'union all',
'select ''0: Default Menu Template'' l_name ',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_menu_template = :p503_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(164946119126805787.4001)
,p_query_column_id=>1
,p_column_alias=>'L_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Plantillas'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(836646663748559249.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(836646711593559250.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164929404487744770.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(836646711593559250.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164930209336746166.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(836646711593559250.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164955918957843580.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164931221456749676.4001)
,p_name=>'P503_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(162628331650495577.4001)
,p_prompt=>'Plantilla:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'MENU.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id',
'  from wwv_flow_menu_templates',
' where flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(name)'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164932330114752169.4001)
,p_name=>'P503_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(162628331650495577.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'select theme_id from wwv_flow_menu_templates where id = :p503_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifique el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164933003579753989.4001)
,p_name=>'P503_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(162628331650495577.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Tema:'
,p_source=>'select theme_class_id from wwv_flow_menu_templates where id = :p503_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'MENU THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43945521366272493.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la clase de tema de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(164934422626759485.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_menu_templates where id = :p503_id'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164951401511829071.4001)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in ( select count(*) counter from ',
'(select plug_name||'' Page - ''||page_id l_name ',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and menu_template_id = :p503_id',
'union all',
'select ''Default Menu Template'' l_name ',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_menu_template = :p503_id)',
') loop',
'if c1.counter = 0 then',
'  return true;',
'else ',
'  return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'No puede suprimir una plantilla a la que se hace referencia.'
,p_when_button_pressed=>wwv_flow_api.id(164930209336746166.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164953903720839117.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_menu_templates where flow_id = :fb_flow_id and id = :p503_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(164930209336746166.4001)
,p_process_success_message=>'Plantilla Suprimida'
);
end;
/
prompt --application/pages/page_00504
begin
wwv_flow_api.create_page(
 p_id=>504.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Calendario')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Calendario')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162631207193497958.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(162637610656498924.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.page_id||'': ''||p.plug_name ',
'from  WWV_FLOW_CALS c, wwv_flow_page_plugs p ',
'where p.id = c.plug_id',
'and c.template_id = :p504_id ',
'and c.flow_id = :fb_flow_id ',
'union all',
'select ''0: Default Calendar Template'' ',
'from wwv_flow_themes',
'where flow_id = :fb_flow_id ',
'and default_calendar_template = :p504_id',
'and theme_id = :fb_theme_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(165119422598232532.4001)
,p_query_column_id=>1
,p_column_alias=>'P.PAGE_ID||'':''||P.PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(836646418778559247.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(836646524483559248.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164959713894851518.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(836646418778559247.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164960519434853199.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(836646418778559247.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164998709541011159.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164961324975854787.4001)
,p_name=>'P504_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(162631207193497958.4001)
,p_prompt=>'Plantilla:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :fb_flow_id and',
'(:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164962432248856872.4001)
,p_name=>'P504_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(162631207193497958.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'select theme_id from wwv_flow_cal_templates where id = :p504_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164963305021858402.4001)
,p_name=>'P504_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(162631207193497958.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Tema:'
,p_source=>'select theme_class_id from wwv_flow_cal_templates where id = :p504_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica la clase de tema de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(164965306537868313.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_cal_templates where id = :p504_id'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164997005254000463.4001)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from ',
'(select p.plug_name||'' - Page ''||page_id ',
'from  WWV_FLOW_CALS c, wwv_flow_page_plugs p ',
'where p.id = c.plug_id',
'and c.template_id = :p504_id ',
'and c.flow_id = :fb_flow_id ',
'union all',
'select ''Default Calendar Template'' ',
'from wwv_flow_themes',
'where flow_id = :fb_flow_id ',
'and default_calendar_template = :p504_id',
'and theme_id = :fb_theme_id',
')) loop',
'if c1.counter = 0 then ',
'   return true;',
'else ',
'   return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No puede suprimir plantillas definidas como por defecto en el tema de la aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(164960519434853199.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164997901576008848.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_cal_templates where id = :p504_id and flow_id = :fb_flow_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(164960519434853199.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00505
begin
wwv_flow_api.create_page(
 p_id=>505.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n de Plantilla de Informe')
,p_step_title=>unistr('Confirmar Supresi\00F3n de Plantilla de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(165026012341131763.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(165026418570131765.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||plug_name',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and PLUG_QUERY_ROW_TEMPLATE = :p505_id',
'union all',
'select ''0: Default Report Template'' l_name',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_report_template = :p505_id',
'and theme_id = :fb_theme_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna referencia.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(165098512592182326.4001)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID||'':''||PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059809832816457635.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059809932018457636.4001)
,p_plug_name=>unistr('Confirmaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(165026922855131770.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1059809832816457635.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(165027313458131773.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1059809832816457635.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(165030127843131805.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165027727732131775.4001)
,p_name=>'P505_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1059809932018457636.4001)
,p_prompt=>'Plantilla:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165028116605131784.4001)
,p_name=>'P505_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1059809932018457636.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'select theme_id from wwv_flow_row_templates where id = :p505_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165028520420131786.4001)
,p_name=>'P505_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1059809932018457636.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Tema:'
,p_source=>'select theme_class_id from wwv_flow_row_templates where id = :p505_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(44022800298370465.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica la clase de tema de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165029005550131791.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_row_templates where id = :p505_id'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(165029419464131796.4001)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from ',
'(select page_id||'': ''||plug_name',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and PLUG_QUERY_ROW_TEMPLATE = :p505_id',
'and plug_source_type in ( wwv_flow_region_native.c_sql_report,',
'                          wwv_flow_region_native.c_tabform )',
'union all',
'select ''0: Default Report Template'' l_name',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_report_template = :p505_id',
'and theme_id = :fb_theme_id)',
') loop',
'if c1.counter = 0 then ',
'   return true;',
'else ',
'   return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'No puede suprimir una plantilla con referencias.'
,p_when_button_pressed=>wwv_flow_api.id(165027313458131773.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(165029828372131802.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_row_templates where id = :p505_id and flow_id = :fb_flow_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido suprimir la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(165027313458131773.4001)
,p_process_success_message=>'Plantilla suprimida.'
);
end;
/
prompt --application/pages/page_00506
begin
wwv_flow_api.create_page(
 p_id=>506.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Atributos de Globalizaci\00F3n')
,p_step_title=>unistr('Editar Atributos de Globalizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_attr_global.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(107024218396385528.4001)
,p_name=>unistr('Globalizaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>99
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ',
'   TRANSLATION_FLOW_ID, ',
'   TRANSLATION_COMMENTS, ',
'   PRIMARY_LANGUAGE_FLOW_ID,',
'   TRANSLATION_FLOW_LANGUAGE_CODE',
'FROM ',
'   WWV_FLOW_LANGUAGE_MAP',
'WHERE ((PRIMARY_LANGUAGE_FLOW_ID = :fb_flow_id))',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna traducci\00F3n.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107024427914385532.4001)
,p_query_column_id=>1
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Traducido como'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107024526429385532.4001)
,p_query_column_id=>2
,p_column_alias=>'TRANSLATION_COMMENTS'
,p_column_display_sequence=>2
,p_column_heading=>'Comentarios'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107024626570385532.4001)
,p_query_column_id=>3
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Primary Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107024709542385532.4001)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>4
,p_column_heading=>'Idioma'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107025223059385535.4001)
,p_plug_name=>unistr('Aplicaci\00F3n &FB_FLOW_ID.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107153203979618418.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>57
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique los atributos de globalizaci\00F3n de la aplicaci\00F3n. Se puede acceder a las traducciones de la aplicaci\00F3n siguiendo los enlaces que se proporcionan a continuaci\00F3n.<p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/configuring-globalization-attributes.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274910513057658610.4001)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>0
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(274897624522614662.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(314947532453636717.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107028714086385553.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(107025223059385535.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107028525118385553.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(107025223059385535.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''FB_FLOW_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107071506373385695.4001)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480964602957324528.4001)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480964808844326218.4001)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>41
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42447012808555142.4001)
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>51
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107071701891385695.4001)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>159
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480965629669360586.4001)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>5
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107071900797385696.4001)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(107028714086385553.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48813130253484262.4001)
,p_name=>'P506_TIMESTAMP_FORMAT'
,p_item_sequence=>459
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Registro de Hora de Aplicaci\00F3n')
,p_source=>'TIMESTAMP_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el formato del registro de hora que se va a utilizar en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato de registro de hora se utiliza para modificar el valor de sesi\00F3n de base de datos <code>NLS_TIMESTAMP_FORMAT</code> antes de mostrar o ejecutar cualquier p\00E1gina de la aplicaci\00F3n. Este valor puede ser una cadena de literales que conten')
||unistr('ga una m\00E1scara de formato de registro de hora v\00E1lida de Oracle o una referencia de elemento que utilice la sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de registro de hora por defecto se obtiene de la sesi\00F3n de base de datos ')
||unistr('en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM</code></li>',
'<li><code>&amp;MY_TIMESTAMP_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48813609952487826.4001)
,p_name=>'P506_TIMESTAMP_TZ_FORMAT'
,p_item_sequence=>469
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Zona Horaria de Registro de Hora de Aplicaci\00F3n')
,p_source=>'TIMESTAMP_TZ_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el formato del registro de hora con zona horaria que se va a utilizar en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato se utiliza para modificar el valor de sesi\00F3n de base de datos <code>NLS_TIMESTAMP_TZ_FORMAT</code> antes de mostrar o ejecutar cualquier p\00E1gina de la aplicaci\00F3n. Este valor puede ser una cadena de literales que contenga una m\00E1scara de')
||unistr(' formato de registro de hora con zona horaria v\00E1lida de Oracle o una referencia de elemento que utilice la sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de registro de hora con zona horaria por defecto se obtiene de la sesi\00F3n ')
||unistr('de base de datos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM TZR</code></li>',
'<li><code>&amp;MY_TIMESTAMP_TZ_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(104793711550033169.4001)
,p_name=>'P506_DATE_FORMAT'
,p_item_sequence=>439
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Fecha de Aplicaci\00F3n')
,p_source=>'DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el formato de fecha que se va a utilizar en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato de fecha se utiliza para modificar el valor de sesi\00F3n de base de datos <code>NLS_DATE_FORMAT</code> antes de mostrar o ejecutar cualquier p\00E1gina de la aplicaci\00F3n. Este valor puede ser una cadena de literales que contenga una m\00E1scara d')
||unistr('e formato de fecha v\00E1lida de Oracle o una referencia de elemento que utilice una sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de fecha por defecto se deriva de la sesi\00F3n de base de datos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>Mes DD, AAAA</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107046804236385616.4001)
,p_name=>'P506_CHARSET'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Character Set'
,p_source=>'CHARSET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Commented out by JKallman on 14-OCT-2003.  Not used for 10g production.  The character set of the document is determined by the NLS_LANG setting of the Database Authentication Descriptor, and modplsql automatically includes this in the HTTP headers.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107047019283385622.4001)
,p_name=>'506_FB_UPD_FLOW_LANGUAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'en'
,p_prompt=>unistr('Idioma Primario de la Aplicaci\00F3n')
,p_source=>'FLOW_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Idioma Primario -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica el idioma en el que se desarrolla una aplicaci\00F3n. Este idioma es el idioma base a partir del cual se realizan todas las traducciones. Por ejemplo, si la aplicaci\00F3n 100 se ha creado en ingl\00E9s, se ha traducido al')
||unistr(' franc\00E9s y se ha publicado como aplicaci\00F3n 101, el ID de aplicaci\00F3n ser\00EDa transparente para el usuario final, de esta forma, todos los usuarios independientemente del idioma acceder\00EDan a la aplicaci\00F3n 100.</div>'),
unistr('<div class="htmldbInfoBodyP">Todas las modificaciones de la aplicaci\00F3n se deben realizar en el idioma primario especificado aqu\00ED.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107055010603385644.4001)
,p_name=>'P506_FLOW_LANGUAGE_DERIVED_FROM'
,p_item_sequence=>419
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Idioma de Aplicaci\00F3n Derivado de')
,p_source=>'FLOW_LANGUAGE_DERIVED_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGE_DERIVED_FROM'
,p_lov=>'.'||wwv_flow_api.id(73566910745435962.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica la forma en la que &PRODUCT_NAME. obtiene el idioma de la aplicaci\00F3n traducida. El idioma primario de la aplicaci\00F3n puede ser est\00E1tico, derivado del idioma del explorador web o se puede determinar a partir de un elemento o de una preferenc')
||'ia del usuario. Las opciones disponibles incluyen:',
'<ul>',
unistr('<li><strong>Sin NLS (Aplicaci\00F3n no traducida)</strong>: seleccione esta opci\00F3n si no se va a traducir la aplicaci\00F3n.</li>'),
unistr('<li><strong>Usar Idioma Primario de la Aplicaci\00F3n</strong>: determina el idioma de la aplicaci\00F3n traducida seg\00FAn el atributo Idioma Primario de la Aplicaci\00F3n.</li>'),
unistr('<li><strong>Explorador (usar preferencia de idioma de explorador)</strong>: determina el idioma de la aplicaci\00F3n traducida seg\00FAn el idioma del explorador web del usuario.</li>'),
unistr('<li><strong>Preferencia de Aplicaci\00F3n (usar FSP_LANGUAGE_PREFERENCE)</strong>: determina el idioma de la aplicaci\00F3n traducida seg\00FAn un valor definido con la API <code>API APEX_UTIL.SET_PREFERENCE</code>. Seleccione esta opci\00F3n para mantener la prefer')
||'encia de idioma de un usuario en varias conexiones.</li>',
unistr('<li><strong>Preferencia de Elemento (usar elemento que contenga la preferencia)</strong>: determina el idioma de la aplicaci\00F3n traducida seg\00FAn un elemento de nivel de aplicaci\00F3n denominado <code>FSP_LANGUAGE_PREFERENCE</code>. El uso de esta opci\00F3n h')
||unistr('ace necesario que &PRODUCT_NAME. determine la preferencia de idioma adecuada en cada conexi\00F3n del usuario. </li>'),
unistr('<li><strong>Sesi\00F3n</strong>: determina el idioma de la aplicaci\00F3n traducida a partir del valor de sesi\00F3n. El idioma de sesi\00F3n de &PRODUCT_NAME. se puede definir mediante el procedimiento <code>APEX_UTIL.SET_SESSION_LANG</code> o con el par\00E1metro P_LA')
||'NG del procedimiento <code>F</code> en la URL.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123305189457447101.4001)
,p_name=>'P506_DIRECTION_RIGHT_TO_LEFT'
,p_is_required=>true
,p_item_sequence=>429
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Direcci\00F3n del Documento')
,p_source=>'DIRECTION_RIGHT_TO_LEFT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RIGHT-TO-LEFT'
,p_lov=>'.'||wwv_flow_api.id(124580607576171078.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Defina la direcci\00F3n del documento de izquierda a derecha o de derecha a izquierda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173210517040328373.4001)
,p_name=>'P506_AUTO_TIME_ZONE'
,p_item_sequence=>499
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Zona Horaria Autom\00E1tica')
,p_source=>'AUTO_TIME_ZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Controla la definici\00F3n de la zona horaria de la sesi\00F3n de base de datos. Si est\00E1 definida en <strong>Activado</strong>, la zona horaria del cliente se obtiene del explorador web del cliente y define la duraci\00F3n de la sesi\00F3n de &PRODUCT_NAME. En las v')
||unistr('istas de p\00E1gina posteriores, aparecer\00E1 la zona horaria de la sesi\00F3n de base de datos definida correctamente. Una vez definido, este valor se puede sustituir con <code>APEX_UTIL.SET_SESSION_TIME_ZONE</code>, o restablecer utilizando <code>APEX_UTIL.RE')
||'SET_SESSION_TIME_ZONE</code>. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205066501107542043.4001)
,p_name=>'P506_CSV_ENCODING'
,p_item_sequence=>509
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Codificaci\00F3n de CSV Autom\00E1tica')
,p_source=>'CSV_ENCODING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('La codificaci\00F3n de CSV autom\00E1tica controla la codificaci\00F3n de toda la salida de CSV del informe en una aplicaci\00F3n. Si se activa, la salida de CSV del informe se convertir\00E1 correctamente en un juego de caracteres compatible con las aplicaciones de esc')
||unistr('ritorio localizadas. El juego de caracteres para la codificaci\00F3n de CSV estar\00E1 determinado por el valor de idioma de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(317542517791217201.4001)
,p_name=>'P506_NLS_SORT'
,p_item_sequence=>479
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Comparaci\00F3n de Valores de Caracteres')
,p_source=>'NLS_SORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina la secuencia de intercalaci\00F3n para la comparaci\00F3n de valores de caracteres en varias cl\00E1usulas y operaciones SQL, por ejemplo, <code>ORDER BY</code>, <code>LIKE</code>, <code>MIN</code>/<code>MAX</code>.</p>'),
unistr('<p>Este valor se utiliza para modificar el par\00E1metro de sesi\00F3n de la base de datos <code>NLS_SORT</code> para la ejecuci\00F3n de las consultas SQL en las regiones de informes interactivos, informes cl\00E1sicos y vista de lista. Si no se ha especificado nin')
||unistr('g\00FAn valor, se deriva el valor por defecto de la sesi\00F3n de la base de datos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>BINARY</code></li>',
'<li><code>GERMAN</code></li>',
'<li><code>CANADIAN_M</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(317693209361509808.4001)
,p_name=>'P506_NLS_COMP'
,p_item_sequence=>489
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Comportamiento de Comparaci\00F3n de Valores de Caracteres')
,p_source=>'NLS_COMP'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'nvl(:P506_NLS_COMP, ''0'')'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GLOBALIZATION.NLS_COMP'
,p_lov=>'.'||wwv_flow_api.id(326783910743783589.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el comportamiento de intercalaci\00F3n de las operaciones SQL, por ejemplo, <code>LIKE</code>, <code>MIN</code>/<code>MAX</code>.</p>'),
unistr('<p>Este valor se utiliza para modificar el par\00E1metro de sesi\00F3n de la base de datos <code>NLS_COMP</code> para la ejecuci\00F3n de las consultas SQL en las regiones de informes interactivos, informes cl\00E1sicos y vista de lista, as\00ED como en la API de plugin')
||'.</p>',
'Las opciones disponibles son:',
'<ul>',
unistr('<li><strong>Valor NLS de sesi\00F3n de la base de datos (por defecto)</strong>: el valor <code>NLS_COMP</code> se deriva de la sesi\00F3n de base de datos en tiempo de ejecuci\00F3n.</li>'),
unistr('<li><strong>Binario</strong>: las comparaciones en la cl\00E1usula <code>WHERE</code> y otras operaciones SQL son binarias.</li>'),
unistr('<li><strong>Ling\00FC\00EDstica</strong>: las comparaciones en la cl\00E1usula <code>WHERE</code> y en otras operaciones SQL utilizan la ordenaci\00F3n ling\00FC\00EDstica especificada en el atributo de comparaci\00F3n de valores de caracteres (<code>NLS_SORT</code>).</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(592046819599383895.4001)
,p_name=>'P506_DATE_TIME_FORMAT'
,p_item_sequence=>449
,p_item_plug_id=>wwv_flow_api.id(107024218396385528.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Fecha/Hora de Aplicaci\00F3n')
,p_source=>'DATE_TIME_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el formato de fecha y hora que se utilizar\00E1 en la aplicaci\00F3n.</p>'),
unistr('<p>Se puede hacer referencia e este formato de fecha y hora en una aplicaci\00F3n mediante la referencia de sustituci\00F3n <code>&amp;APP_DATE_TIME_FORMAT.</code> o en PL/SQL a trav\00E9s de la funci\00F3n <code>v(''APP_DATE_TIME_FORMAT'')</code>. Este atributo no mo')
||unistr('difica ning\00FAn valor de NLS. Este valor puede ser una cadena de literales que contenga una m\00E1scara de formato de fecha v\00E1lida de Oracle o una referencia de elemento mediante una sintaxis de sustituci\00F3n. Si no se especifica este valor de atributo, una ')
||unistr('referencia a <code>APP_DATE_TIME_FORMAT</code> devolver\00E1 el formato de fecha de sesi\00F3n de la base de datos NLS y el formato de hora de NLS.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>Mes DD, RRRR HH24:MI</code></li>',
'<li><code>&amp;MY_DATE_TIME_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(340090121776885382.4001)
,p_computation_sequence=>10
,p_computation_item=>'P506_NLS_COMP'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nullif(:P506_NLS_COMP, ''0'')'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(317553711210357001.4001)
,p_validation_name=>'P506_NLS_SORT valid'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_found boolean := false;',
'begin',
'    for c1 in (',
'        select null',
'          from sys.v_$nls_valid_values',
'         where parameter = ''SORT''',
'           and value = regexp_replace(upper(:P506_NLS_SORT), ''_(CI|AI)$'', '''')',
'    ) loop',
'        l_found := true;',
'        exit;',
'    end loop;',
'',
'    return l_found;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Introduzca un valor NLS_SORT v\00E1lido.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P506_NLS_SORT is not null',
'and instr(:P506_NLS_SORT, ''&'') = 0'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(317542517791217201.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107070300471385689.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107070513727385691.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107070924366385693.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Aplicaci\00F3n &FB_UPD_ID. procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107071110644385693.4001)
,p_process_sequence=>31
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
end;
/
prompt --application/pages/page_00509
begin
wwv_flow_api.create_page(
 p_id=>509.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Atributos de Seguridad'
,p_step_title=>'Editar Atributos de Seguridad'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_attr_sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6354406057147715.4001)
,p_plug_name=>unistr('Gesti\00F3n de Sesiones')
,p_region_name=>'TIMEOUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46227908343678943.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107178726415706930.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_name=>'A'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>unistr('<p>La autenticaci\00F3n es el proceso que establece la identidad de cada usuario antes de que pueda acceder a la aplicaci\00F3n. Puede definir varios esquemas de autenticaci\00F3n para la aplicaci\00F3n, pero s\00F3lo uno de ellos puede ser el actual. Cuando la aplicaci')
||unistr('\00F3n se ejecuta, se utiliza la l\00F3gica de autenticaci\00F3n del esquema actual.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107178925825706930.4001)
,p_plug_name=>unistr('Aplicaci\00F3n &FB_FLOW_ID.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107179319972706932.4001)
,p_plug_name=>unistr('Sesi\00F3n de Base de Datos')
,p_region_name=>'DBSESSION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107179907066706934.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_name=>'AUTH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>unistr('<p>Los esquemas de autorizaci\00F3n de la aplicaci\00F3n controlan el acceso a todas las p\00E1ginas de una aplicaci\00F3n. El acceso no autorizado a la aplicaci\00F3n, independientemente de la p\00E1gina que se haya solicitado, hace que se muestre una p\00E1gina de error.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107249822848936141.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice esta p\00E1gina para definir valores de seguridad a nivel de aplicaci\00F3n. Edite los componentes de aplicaci\00F3n directamente para gestionar valores m\00E1s espec\00EDficos.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107273213161009008.4001)
,p_plug_name=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_region_name=>'PROTECT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La activaci\00F3n de la protecci\00F3n de estado de la sesi\00F3n puede evitar que los piratas inform\00E1ticos manipulen las direcciones URL de la aplicaci\00F3n. La manipulaci\00F3n de la direcci\00F3n URL puede afectar de forma negativa a la l\00F3gica del programa, al conten')
||unistr('ido del estado de la sesi\00F3n y a la privacidad de la informaci\00F3n.</p>'),
unistr('<p>Si desea activar la protecci\00F3n de estado de la sesi\00F3n para la aplicaci\00F3n, seleccione <strong>Activado</strong> en la lista Protecci\00F3n de Estado de la Sesi\00F3n. Si se activa la protecci\00F3n de estado de la sesi\00F3n, se activar\00E1n los controles de protecci')
||unistr('\00F3n de estado de la sesi\00F3n definidos a nivel de p\00E1gina y elemento. Para configurar Protecci\00F3n de Estado de la Sesi\00F3n, haga clic en <strong>Gestionar Protecci\00F3n de Estado de la Sesi\00F3n</strong>.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274905123876642828.4001)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(274897624522614662.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620042929052352886.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOWS',
'where id = :509_FB_UPD_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :509_FB_UPD_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'509_FB_UPD_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(875541626713267923.4001)
,p_plug_name=>'Seguridad del Explorador'
,p_region_name=>'BROWSER_SECURITY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107299610624150294.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(107178726415706930.4001)
,p_button_name=>'DEFINE_AUTHENTICATION_SCHEMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Definir Esquemas de Autenticaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107303526685164337.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(107179907066706934.4001)
,p_button_name=>'DEFINE_AUTHORIZATION_SCHEMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Definir Esquemas de Autorizaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110151111854207273.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(107273213161009008.4001)
,p_button_name=>'INVALIDATE_BOOKMARKS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Forzar Vencimiento de Marcadores'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:517:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P509_PAGE_PROTECTION_ENABLED'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107339232263468774.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(107273213161009008.4001)
,p_button_name=>'MANAGE_SESSION_STATE_PROTECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Gestionar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107182428765706940.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(107178925825706930.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107182222833706939.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(107178925825706930.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''FB_FLOW_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480964126590312389.4001)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480964331785313932.4001)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42448405020590777.4001)
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107225227543707025.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107225418922707025.4001)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(107182428765706940.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480965818372366792.4001)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6357502772184607.4001)
,p_name=>'P509_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Duraci\00F3n M\00E1xima de la Sesi\00F3n en Segundos')
,p_source=>'MAX_SESSION_LENGTH_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(218750809842831008.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Define cu\00E1nto tiempo (en segundos) pueden existir las sesiones y cu\00E1nto puede utilizarlas esta aplicaci\00F3n.'),
'',
'<ul>',
unistr('    <li>Introduzca un entero positivo para controlar cu\00E1nto tiempo puede existir una sesi\00F3n.</li>'),
'    <li>Introduzca 0 para que las sesiones existan de forma indefinida.</li>',
unistr('    <li>Deje el valor vac\00EDo para utilizar la duraci\00F3n de sesi\00F3n definida en el nivel de espacio de trabajo o el nivel de instancia.</li>'),
'</ul>',
'<br />',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6358230130192576.4001)
,p_name=>'P509_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tiempo M\00E1ximo de Inactividad de Sesi\00F3n en Segundos')
,p_source=>'MAX_SESSION_IDLE_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_api.id(218750809842831008.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El tiempo de inactividad de sesi\00F3n es el tiempo que transcurre entre la \00FAltima solicitud de p\00E1gina y la siguiente.'),
'<ul>',
unistr('    <li>Introduzca un entero positivo para controlar el tiempo de inactividad para las sesiones que utiliza esta aplicaci\00F3n.</li>'),
unistr('    <li>Deje el valor vac\00EDo para utilizar el tiempo de inactividad definido en el nivel de espacio de trabajo o el nivel de instancia.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6358614724225908.4001)
,p_name=>'P509_ON_MAX_SESSION_TIMEOUT_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL con Timeout de Sesi\00F3n')
,p_source=>'ON_MAX_SESSION_TIMEOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca una URL opcional para el redireccionamiento cuando se haya excedido la duraci\00F3n m\00E1xima de la sesi\00F3n.'),
unistr('La p\00E1gina de destino de esta URL, si se implanta en &PRODUCT_NAME., debe ser una p\00E1gina p\00FAblica.'),
unistr('Un uso com\00FAn de esta p\00E1gina es informar al usuario de la caducidad de la sesi\00F3n y presentar un enlace de conexi\00F3n u otras opciones.'),
unistr('Si no introduce una URL, los usuarios ver\00E1n el mensaje "La sesi\00F3n ha sufrido un timeout" y un enlace a la p\00E1gina inicial de la aplicaci\00F3n.'),
unistr('Si introduce #LOGOUT_URL#, &PRODUCT_NAME. ejecutar\00E1 una desconexi\00F3n, como cuando el usuario hace clic en el enlace de desconexi\00F3n de la aplicaci\00F3n.'),
'</p>',
'<p>',
unistr('Solo se soportan tres elementos de sustituci\00F3n en esta URL:'),
'</p>',
'<ul>',
'<li>&amp;APP_SESSION.</li>',
'<li>&amp;SESSION.</li>',
'<li>&amp;APP_ID.</li>',
'</ul>',
'<p>',
unistr('Debido al prop\00F3sito concreto de esta URL, no es necesario incluir &amp;APP_SESSION. ni &amp;SESSION. en el enlace.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6359009660233908.4001)
,p_name=>'P509_ON_MAX_IDLE_TIMEOUT_URL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL de Timeout de Inactividad de Sesi\00F3n')
,p_source=>'ON_MAX_IDLE_TIMEOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca una URL opcional para el redireccionamiento cuando se haya excedido el tiempo m\00E1ximo de inactividad de sesi\00F3n.'),
unistr('La p\00E1gina de destino de esta URL, si se implanta en &PRODUCT_NAME., debe ser una p\00E1gina p\00FAblica.'),
unistr('Un uso com\00FAn de esta p\00E1gina es informar al usuario de la caducidad de la sesi\00F3n y presentar un enlace de conexi\00F3n u otras opciones.'),
unistr('Si no introduce una URL, los usuarios ver\00E1n el mensaje "La sesi\00F3n ha sufrido un timeout" y un enlace a la p\00E1gina inicial de la aplicaci\00F3n.'),
unistr('Si introduce #LOGOUT_URL#, &PRODUCT_NAME. ejecutar\00E1 una desconexi\00F3n, como cuando el usuario hace clic en el enlace de desconexi\00F3n de la aplicaci\00F3n.'),
'</p>',
'<p>',
unistr('Solo se soportan tres elementos de sustituci\00F3n en esta URL:'),
'</p>',
'<ul>',
'<li>&amp;APP_SESSION.</li>',
'<li>&amp;SESSION.</li>',
'<li>&amp;APP_ID.</li>',
'</ul>',
'<p>',
unistr('Debido al prop\00F3sito concreto de esta URL, no es necesario incluir &amp;APP_SESSION. ni &amp;SESSION. en el enlace.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16978325970274016.4001)
,p_name=>'P509_AUTHORIZE_PUBLIC_PAGES_YN'
,p_is_required=>true
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(107179907066706934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ejecutar en P\00E1ginas P\00FAblicas')
,p_source=>'AUTHORIZE_PUBLIC_PAGES_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Controla si se comprueba el esquema de autorizaci\00F3n del nivel de aplicaci\00F3n en las p\00E1ginas p\00FAblicas (es decir, las p\00E1ginas que no necesitan autenticaci\00F3n). Las opciones incluyen:'),
'</p>',
'<ul>',
unistr('<li><strong>Activado</strong>: Si selecciona <strong>Activado</strong> y la p\00E1gina es p\00FAblica, se comprueba la autorizaci\00F3n de aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong>: Si selecciona <strong>Desactivado</strong> y la p\00E1gina es p\00FAblica, se ignora la autorizaci\00F3n de aplicaci\00F3n.</li>'),
'</ul>',
'<p>',
unistr('Nota: Este atributo se ignora si selecciona <strong>No sebe ser usuario p\00FAblico</strong> como esquema de autorizaci\00F3n.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34364122664343194.4001)
,p_name=>'P509_DEEP_LINKING'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Enlace Profundo'
,p_source=>'DEEP_LINKING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DEEP_LINKING'
,p_lov=>'.'||wwv_flow_api.id(34319101845334424.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este atributo activa o impide el enlace profundo a una aplicaci\00F3n. Las opciones incluyen::</p>'),
'<ul>',
unistr('<li><strong>Activado</strong>: la URL a una p\00E1gina espec\00EDfica redirecciona, en \00FAltima instancia, a esta aplicaci\00F3n, posiblemente despu\00E9s de que el usuario se conecte.</li>'),
unistr('<li><strong>Desactivado</strong>: si la URL no contiene un ID de sesi\00F3n v\00E1lido, &PRODUCT_NAME. redirecciona a la p\00E1gina inicial de la aplicaci\00F3n.</li>'),
'</ul>',
unistr('<p>Por ejemplo, los exploradores guardan normalmente las URL de los separadores abiertos e intentan restaurar las sesiones despu\00E9s de reiniciar, creando un enlace profundo. Es posible que no se desee este comportamiento (por ejemplo, si una URL apunt')
||unistr('a a una p\00E1gina en mitad del proceso de un asistente de varios pasos). Al seleccionar Desactivado, &PRODUCT_NAME. inicia una nueva sesi\00F3n y redirecciona a la p\00E1gina inicial de la aplicaci\00F3n.</p>'),
unistr('<p>Puede sobrescribir este valor de aplicaci\00F3n en el nivel de p\00E1gina.</p>'),
unistr('<p>Para simplificar el desarrollo, el enlace profundo se activa siempre que el usuario est\00E9 conectado al entorno de desarrollo.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94182360081544823.4001)
,p_name=>'P509_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Advertencia de timeout de sesi\00F3n en segundos')
,p_source=>'SESSION_TIMEOUT_WARNING_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_api.id(433752258048536863.4001)||'.'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El tiempo de advertencia de timeout define (en segundos) cu\00E1nto tiempo ha de pasar antes de que la sesi\00F3n sufra un timeout (la duraci\00F3n m\00E1xima de sesi\00F3n o el tiempo m\00E1ximo de inactividad de la sesi\00F3n) para advertir al usuario. Si se trata de la ad')
||unistr('vertencia de tiempo m\00E1ximo de inactividad de sesi\00F3n, el usuario tendr\00E1 la oportunidad de ampliar la sesi\00F3n. En el caso de la advertencia de duraci\00F3n m\00E1xima de sesi\00F3n, se le preguntar\00E1 al usuario si desea guardar el trabajo, para evitar que se pierdan')
||unistr(' los datos una vez que se alcance el tiempo m\00E1ximo de sesi\00F3n.</p>'),
'<ul>',
unistr('    <li>Introduzca un entero positivo para controlar el tiempo de advertencia de timeout de sesi\00F3n en las sesiones que utiliza esta aplicaci\00F3n.</li>'),
unistr('    <li>Defina el valor en 0 para desactivar las advertencias de timeout de sesi\00F3n en las sesiones que utiliza esta aplicaci\00F3n.</li>'),
unistr('    <li>Deje el valor vac\00EDo para utilizar el tiempo de advertencia definido en el nivel de espacio de trabajo o el nivel de instancia.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95189813891614248.4001)
,p_name=>'P509_POPULATE_ROLES'
,p_is_required=>true
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(107179907066706934.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'R'
,p_prompt=>'Origen para esquemas de grupos o roles'
,p_source=>'POPULATE_ROLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_POPULATE_ROLES'
,p_lov=>'.'||wwv_flow_api.id(177081808679947721.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Defina lo que deber\00EDa utilizar &PRODUCT_NAME. como origen para los esquemas de autorizaci\00F3n del tipo <em>Est\00E1 en rol o en grupo</em>.'),
'Los valores disponibles son:',
'<ul>',
unistr('<li><strong>Asignaciones de rol de usuario de control de acceso</strong>: active los roles asignados del usuario (en Componentes compartidos/Control de acceso a la aplicaci\00F3n).'),
'</li>',
unistr('<li><strong>Esquema de autenticaci\00F3n</strong>: si el esquema de autenticaci\00F3n de la aplicaci\00F3n es <em>Cuentas de &PRODUCT_NAME., </em>active los grupos asignados del usuario del espacio de trabajo.'),
unistr('Si el esquema de autenticaci\00F3n de la aplicaci\00F3n es <em>Cuentas de base de datos</em>, los roles de base de datos se comprueban cuando se activa el esquema de autorizaci\00F3n.'),
unistr('Si el esquema de autenticaci\00F3n utiliza <em>Real Application Security</em>, active <em>Roles de aplicaci\00F3n din\00E1mica de RAS</em>.'),
'</li>',
unistr('<li><strong>C\00F3digo personalizado</strong>: llame al procedimiento <code>apex_authorization.enable_dynamic_groups</code> en un proceso posterior a la autenticaci\00F3n para rellenar los grupos din\00E1micos.'),
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107187022259706949.4001)
,p_name=>'509_FB_UPD_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107178726415706930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>32
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('N\00FAmero de identificaci\00F3n num\00E9rico (identificador) que identifica la aplicaci\00F3n. Cada aplicaci\00F3n se identifica de forma \00FAnica mediante un identificador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107202523267706980.4001)
,p_name=>'P509_SECURITY_SCHEME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(107179907066706934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Autorizaci\00F3n de Aplicaci\00F3n Necesaria -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Especifique un esquema de autorizaci\00F3n para la aplicaci\00F3n. Los esquemas de autorizaci\00F3n se definen para una aplicaci\00F3n con el fin de controlar el acceso. Para establecer el esquema de autorizaci\00F3n necesario a nivel de la aplicaci\00F3n, todas las p\00E1ginas')
||unistr(' de la misma deber\00E1n pasar la comprobaci\00F3n de autorizaci\00F3n definida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107203001185706981.4001)
,p_name=>'P509_PAGE_PROTECTION_ENABLED'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(107273213161009008.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_source=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Al seleccionar <strong>Activado</strong>, esta funci\00F3n utiliza el atributo de p\00E1gina Protecci\00F3n de Acceso a P\00E1gina y los atributos de elemento Protecci\00F3n de Estado de la Sesi\00F3n junto con los totales de control colocados e')
||unistr('n las direcciones URL f?p=. Al activar esta funci\00F3n se impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Al seleccionar <strong>Desactivado</strong>, el motor de &PRODUCT_NAME. no tendr\00E1 en cuenta los atributos de p\00E1gina Protecci\00F3n de Acceso a P\00E1gina o los atributos de elemento Protecci\00F3n de Estado de la Sesi\00F3n durante la ej')
||unistr('ecuci\00F3n de la aplicaci\00F3n y no incluir\00E1 totales de control en la secci\00F3n f?p=  de las direcciones URL.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Si este atributo se define en <strong>Activado</strong>, al cambiarlo a <strong>Desactivado</strong>, se desactivar\00E1 la Protecci\00F3n de Estado de la Sesi\00F3n, pero se mantendr\00E1 el valor de todos los atributos de p\00E1gina Protec')
||unistr('ci\00F3n de Acceso a P\00E1gina y todos los atributos de elemento Protecci\00F3n de Estado de la Sesi\00F3n.'),
'',
unistr('<div class="htmldbInfoBodyP">Si el atributo se define en <strong>Desactivado</strong>, al cambiarlo a <strong>Activado</strong>, se activar\00E1 la Protecci\00F3n de Estado de la Sesi\00F3n y se mantendr\00E1n todos los atributos de p\00E1gina Protecci\00F3n de Acceso a P\00E1g')
||unistr('ina y todos los atributos de elemento Protecci\00F3n de Estado de la Sesi\00F3n, que se respetar\00E1n durante la ejecuci\00F3n de la aplicaci\00F3n.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Una excepci\00F3n a la regla general sobre los atributos de elemento Protecci\00F3n de Estado de la Sesi\00F3n que tienen s\00F3lo efecto cuando la Protecci\00F3n de Estado de la Sesi\00F3n es <strong>Activado</strong>, es que si un atributo de ')
||unistr('elemento se define en <strong>Protegido</strong>, dicho estado siempre est\00E1 activo. Es decir, los elementos protegidos no se pueden definir a partir de la direcci\00F3n URL, independientemente del valor Activado o Desactivado de Protecci\00F3n de Estado de l')
||unistr('a Sesi\00F3n.</div>')))
,p_encrypt_session_state_yn=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107203519523706982.4001)
,p_name=>'P509_CHECKSUM_SALT_LAST_RESET'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(107273213161009008.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''NULL_IN_PAREN'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Permitir URL Creadas despu\00E9s de')
,p_source=>'select to_char(CHECKSUM_SALT_LAST_RESET,''&DATE_TIME_FORMAT.'') from wwv_flows where id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P509_PAGE_PROTECTION_ENABLED'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP"><strong>Permitir URL Creadas Despu\00E9s de</strong> muestra la fecha y la hora a partir de las cuales se podr\00E1n utilizar los enlaces marcados para acceder a las p\00E1ginas de esta aplicaci\00F3n si el enlace marcado contiene un tot')
||unistr('al de control y la opci\00F3n Protecci\00F3n de Estado de la Sesi\00F3n est\00E1 activada.'),
'<p>',
unistr('Los marcadores creados antes de esta fecha/hora no se pueden utilizar para acceder a esta aplicaci\00F3n si el enlace marcado contiene un total de control y la opci\00F3n Protecci\00F3n de Estado de la Sesi\00F3n est\00E1 activada.'),
'<p>',
'Este atributo no afecta a los marcadores que no contienen totales de control ni a los que contienen totales de control innecesarios. Su uso se determina con otros criterios.',
'<p>',
unistr('Durante el c\00E1lculo y la verificaci\00F3n posterior de los totales de control incluidos en las direcciones URL <code>"f?p="</code> generadas durante la presentaci\00F3n de la p\00E1gina se utiliza un atributo de aplicaci\00F3n oculto (un valor salt de total de contro')
||unistr('l). Los totales de control se incluyen cuando la opci\00F3n Protecci\00F3n de Estado de la Sesi\00F3n est\00E1 activada para la aplicaci\00F3n. Puede restablecer este atributo salt de total de control en cualquier momento haciendo clic en el bot\00F3n <strong>Forzar Vencimi')
||unistr('ento de Marcadores</strong>. Esto provocar\00E1 un fallo si se utilizan las URL marcadas que contengan totales de control generados previamente para acceder a la aplicaci\00F3n.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107204011001706983.4001)
,p_name=>'P509_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107179319972706932.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis')
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Especifica el esquema con el que se analizar\00E1n todos los SQL y PL/SQL de la aplicaci\00F3n. Puede utilizar <code>#OWNER#</code> para hacer referencia a este valor en consultas SQL y en PL/SQL (por ejemplo, en una regi\00F3n o en un proceso).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107206000369706987.4001)
,p_name=>'P509_PUBLIC_USER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(107178726415706930.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'APEX_PUBLIC_USER'
,p_prompt=>unistr('Usuario&nbsp;P\00FAblico')
,p_source=>'PUBLIC_USER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica el esquema (o usuario) de Oracle utilizado para conectarse a la base de datos a trav\00E9s del Descriptor de Acceso a Base de Datos (DAD).</div>'),
unistr('<div class="htmldbInfoBodyP">Una vez que se ha identificado un usuario, el motor de &PRODUCT_NAME. realiza un seguimiento de cada uno de los usuarios definiendo el valor de la cadena de sustituci\00F3n incorporada <code>APP_USER</code>. '),
unistr('<div class="htmldbInfoBodyP">Cuando <code>APP_USER</code> tiene este mismo valor, el motor de &PRODUCT_NAME. considera que se trata de una sesi\00F3n de "usuario p\00FAblico". El motor de &PRODUCT_NAME. soporta las siguientes condiciones de visualizaci\00F3n inc')
||'orporadas:</div>',
'<ul class="noIndent">',
'<li><code>USER_IS_PUBLIC_USER</code>',
'<li><code>USER_IS_NOT_PUBLIC_USER</code>',
'</ul>',
'<br>',
unistr('<div class="htmldbInfoBodyP">Si el usuario de la aplicaci\00F3n actual (<code>APP_USER</code>) coincide con el valor de este atributo, el usuario se conecta como usuario p\00FAblico. Algunas aplicaciones tienen modos p\00FAblico (no conectado) y privado (conecta')
||unistr('do). Si determina si el usuario es p\00FAblico, puede visualizar u ocultar informaci\00F3n de forma condicional.</div>'),
unistr('<div class="htmldbInfoBodyP">Por ejemplo, puede mostrar un bot\00F3n de conexi\00F3n si el usuario es p\00FAblico y un enlace de desconexi\00F3n si el usuario no es p\00FAblico. Haga referencia a este valor en el c\00F3digo PL/SQL con la variable global <code>APEX_APPLICATI')
||'ON.G_PUBLIC_USER</code>.</div>',
unistr('<div class="htmldbInfoBodyP">A continuaci\00F3n aparecen algunos ejemplos de sintaxis v\00E1lida para las referencias a <code>APP_USER</code>:</div>'),
'<ul class="noIndent">',
'<li><code>&amp;APP_USER.</code>',
'<li><code>:APP_USER</code>',
'<li><code>v(''APP_USER'')</code>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107209004573706992.4001)
,p_name=>'P509_VPD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107179319972706932.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo PL/SQL de Inicializaci\00F3n')
,p_source=>'VPD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este atributo para introducir un bloque PL/SQL que define el contexto para la sesi\00F3n de base de datos asociada a la solicitud "mostrar p\00E1gina" o "aceptar p\00E1gina" actual. El bloque que introduzca aqu\00ED se ejecutar\00E1 en un punto inicial durant')
||unistr('e la solicitud de la p\00E1gina, inmediatamente despu\00E9s de que se haya establecido el valor <code>APP_USER</code>. Por lo tanto, el valor de <code>APP_USER</code> (utilizando <code>:APP_USER</code> o <code>v(''APP_USER'')</code>) puede utilizarse dentro de')
||unistr('l bloque. Tambi\00E9n puede hacerse referencia a los valores de otros elementos en el estado de sesi\00F3n, pero dichos elementos deben haberse establecido en el estado de sesi\00F3n anterior a la iniciaci\00F3n de la solicitud de p\00E1gina actual.'),
'Observe el siguiente ejemplo:',
'</p>',
'<pre>',
'dbms_session.set_context(''CTX_USER_QRY'',''USERPRIV'',my_package.my_function(:APP_USER));',
'</pre>',
'',
unistr('<p>Este ejemplo define el valor de <code>USERPRIV</code> en el contexto con nombre <code>CTX_USER_QRY</code> en el valor que devuelve la funci\00F3n <code>my_function</code> en el paquete <code>my_package</code>. La funci\00F3n se transfiere al valor actual ')
||unistr('de <code>APP_USER</code> como un argumento de entrada. Posiblemente, el contexto con nombre se podr\00EDa utilizar en una pol\00EDtica VPD (ya creada dentro del esquema de an\00E1lisis de la aplicaci\00F3n) para aplicar la generaci\00F3n de predicados adecuados al usuar')
||'io autenticado.</p>',
'',
unistr('<p>La Base de Datos Privada Virtual, tambi\00E9n conocida como control de acceso detallado o FGAC, es una funci\00F3n de Oracle Database que proporciona una interfaz de programaci\00F3n de aplicaciones (API) que permite a los desarrolladores asignar pol\00EDticas de')
||unistr(' seguridad a las tablas y vistas de la base de datos. Al utilizar PL/SQL, los desarrolladores pueden crear pol\00EDticas de seguridad con procedimientos almacenados y enlazar los procedimientos a una tabla o vista mediante una llamada a un paquete RDBMS.')
||unistr(' Dichas pol\00EDticas se basan en el contenido de los datos de aplicaci\00F3n almacenados dentro de la base de datos, o en las variables de contexto proporcionadas por Oracle Database. De este modo, VPD permite que se eliminen los mecanismos de seguridad de ')
||unistr('acceso de las aplicaciones y se ubiquen m\00E1s cerca de los esquemas particulares.</p>'),
'',
unistr('<p>El c\00F3digo que se introduzca aqu\00ED no tiene que estar relacionado con VPD/FGAC ni tampoco con la seguridad. Aqu\00ED se puede colocar cualquier c\00F3digo que haya que ejecutar en el punto m\00E1s temprano de una solicitud de p\00E1gina. Por ejemplo, en el siguient')
||unistr('e ejemplo se define la zona horaria de la sesi\00F3n de base de datos para todas las solicitudes de p\00E1gina:</p>'),
'',
'<pre>',
'BEGIN',
'   EXECUTE IMMEDIATE ''alter session set time_zone = ''''Australia/Sydney'''' '';',
'END;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107210615861706995.4001)
,p_name=>'P509_AUTHENTICATION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(107178726415706930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autenticaci\00F3n')
,p_source=>'AUTHENTICATION_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHENTICATION_SCHEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_flow_authentications',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Este atributo identifica el m\00E9todo de autenticaci\00F3n actual que utiliza esta aplicaci\00F3n. El objetivo de la autenticaci\00F3n es determinar la identidad de los usuarios de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209487341993906101.4001)
,p_name=>'P509_AUTHORIZE_BATCH_JOB'
,p_is_required=>true
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(107179907066706934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ejecutar en trabajo en segundo plano'
,p_source=>'AUTHORIZE_BATCH_JOB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Controla si los esquemas de autorizaci\00F3n del nivel de aplicaci\00F3n, p\00E1gina, regi\00F3n y columna se comprueban en el trabajo en segundo plano, como por ejemplo, las suscripciones a informes interactivos. Entre las opciones se incluyen:'),
'</p>',
'<ul>',
unistr('<li><strong>Activado</strong>: si selecciona <strong>Activado</strong>, se comprueba la autorizaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong>: si selecciona <strong>Desactivado</strong>, se ignora la autorizaci\00F3n.</li>'),
'</ul>',
'<p>',
unistr('Nota: La comprobaci\00F3n de autorizaci\00F3n de trabajo en segundo plano utiliza el estado de sesi\00F3n clonado en lugar del estado de sesi\00F3n actual. El estado de sesi\00F3n clonado NO incluye el estado de sesi\00F3n, la configuraci\00F3n de informe ni la recopilaci\00F3n def')
||unistr('inidos durante el proceso posterior a la autenticaci\00F3n. La comprobaci\00F3n de autorizaci\00F3n puede fallar si no se encuentra el estado de sesi\00F3n de la sesi\00F3n clonada.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314984802983606044.4001)
,p_name=>'P509_HTML_ESCAPING_MODE'
,p_is_required=>true
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(875541626713267923.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'E'
,p_prompt=>unistr('Modo de Identificaci\00F3n de HTML')
,p_source=>'HTML_ESCAPING_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HTML_ESCAPING_MODE'
,p_lov=>'.'||wwv_flow_api.id(314983827117600277.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define la forma en que &PRODUCT_NAME. debe identificar los caracteres especiales. Las opciones incluyen:',
'</p>',
'<ul>',
unistr('<li><strong>B\00E1sico</strong>: escape &amp;, &quot;, &lt; y &gt;</li>'),
'<li><strong>Ampliado</strong>: escape &amp;, &quot;, &lt;, &gt;, &#x27;, &#x2F; y caracteres no ASCII si el juego de caracteres de la base de datos no es AL32UTF8</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367969027064292100.4001)
,p_name=>'P509_BOOKMARK_CS_FUNCTION'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(107273213161009008.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n Hash de Marcador')
,p_source=>'BOOKMARK_CHECKSUM_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_api.id(367957504585280755.4001)||'.'
,p_display_when=>'P509_PAGE_PROTECTION_ENABLED'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('La <strong>funci\00F3n hash de marcador</strong> se utiliza para crear totales de control para el nivel de aplicaci\00F3n y totales de control de nivel de usuario en URL marcables.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384786066747553206.4001)
,p_name=>'P509_HTTP_RESPONSE_HEADERS'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(875541626713267923.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cabeceras de Respuesta HTTP'
,p_source=>'HTTP_RESPONSE_HEADERS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca las cabeceras HTTP espec\00EDficas de la aplicaci\00F3n adicionales que &PRODUCT_NAME. debe enviar en cada respuesta y que no soporta de otra forma (por ejemplo, <code>X-Frame-Options</code> con el atributo Incluir en marcos).'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384789975408553245.4001)
,p_name=>'P509_REJOIN_EXISTING_SESSIONS'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Volver a Unir Sesiones'
,p_source=>'REJOIN_EXISTING_SESSIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REJOIN_EXISTING_SESSIONS'
,p_lov=>'.'||wwv_flow_api.id(492680965578161495.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Utilice este atributo para controlar si &PRODUCT_NAME. debe soportar URL de aplicaci\00F3n que no contenga ID de sesi\00F3n.'),
unistr('Cuando la opci\00F3n Volver a Entrar en Sesiones est\00E1 activada, &PRODUCT_NAME. intenta utilizar la cookie de sesi\00F3n para entrar en una sesi\00F3n existente'),
unistr('cuando una URL no contiene un ID de sesi\00F3n.'),
'</p>',
'<p>',
unistr('Un valor de nivel de instancia m\00E1s restrictivo sustituye este valor de nivel de p\00E1gina.'),
'</p>',
'<p>',
'    <strong>Nota:</strong>',
unistr('La activaci\00F3n de Volver a Entrar en Sesiones expone la aplicaci\00F3n a posibles incumplimientos de seguridad, ya que puede permitir a usuarios no autorizados tomar posesi\00F3n de las sesiones de usuario final existentes. Para obtener m\00E1s informaci\00F3n, consu')
||unistr('lte las secciones sobre c\00F3mo volver a entrar en sesiones en "Gesti\00F3n de seguridad de aplicaciones" en Application Builder User''s Guide.'),
'</p>',
'',
'<p>',
'Entre las opciones disponibles se incluyen:    ',
'</p>',
'<ul>',
unistr('    <li><strong>Valor por defecto de la aplicaci\00F3n</strong> - '),
unistr('    Se aplica el valor del nivel de aplicaci\00F3n.'),
'    </li>',
'    <li><strong>Desactivado</strong> - ',
unistr('    Si la URL no contiene un ID de sesi\00F3n, &PRODUCT_NAME. crea una nueva sesi\00F3n.'),
'    </li>',
unistr('    <li><strong>Activado para sesiones p\00FAblicas</strong> - '),
unistr('    Si la URL va a una p\00E1gina p\00FAblica y no contiene un ID de sesi\00F3n,'),
unistr('    &PRODUCT_NAME. intenta utilizar la cookie de sesi\00F3n existente establecida para dicha aplicaci\00F3n.'),
unistr('    Para aplicaciones con p\00E1ginas autenticadas y p\00FAblicas, un ID de sesi\00F3n se define tras la autenticaci\00F3n del usuario final.'),
unistr('    &PRODUCT_NAME. solo entra con la cookie cuando la sesi\00F3n no se ha autenticado todav\00EDa.'),
'    </li>',
'    <li><strong>Activado para todas las sesiones</strong> - ',
unistr('    Si la URL no contiene un ID de sesi\00F3n, &PRODUCT_NAME. intenta utilizar la cookie de sesi\00F3n existente establecida para dicha aplicaci\00F3n,'),
'    siempre que se cumplan las siguientes condiciones:',
'    <ul>',
'        <li>',
unistr('        Protecci\00F3n de estado de la sesi\00F3n est\00E1 activada para la aplicaci\00F3n y la URL incluye un total de control v\00E1lido.'),
unistr('        Para marcadores p\00FAblicos,'),
unistr('        la protecci\00F3n de nivel de elemento m\00E1s restrictiva debe ser <em>No restringido</em> o <em>Total de control necesario: Nivel de aplicaci\00F3n</em>.'),
'        </li>',
'        <li>',
unistr('        O la URL no contiene carga \00FAtil (un par\00E1metro de solicitud, borrado de cach\00E9 o pares de valores de datos).'),
'        </li>',
'    </ul>',
unistr('    Este valor tambi\00E9n requiere que Incluir en marcos se defina en Permitir del mismo origen o en Denegar para la aplicaci\00F3n.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495347874477866239.4001)
,p_name=>'P509_RUNTIME_API_USAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(107179319972706932.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sintaxis de la API en Tiempo de Ejecuci\00F3n')
,p_source=>'RUNTIME_API_USAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'WWV_FLOW-RUNTIME_API_USAGE'
,p_lov=>'.'||wwv_flow_api.id(561570937398567414.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Controle el modo en que esta aplicaci\00F3n puede acceder a las API de &PRODUCT_NAME. que modifican las aplicaciones y los datos de espacio de trabajo, mientras se ejecuta.'),
'</p>',
'<ul>',
unistr('<li>Modificar esta Aplicaci\00F3n: la aplicaci\00F3n se puede modificar por s\00ED misma.</li>'),
unistr('<li>Modificar otras Aplicaciones: la aplicaci\00F3n puede cambiar otras aplicaciones en el espacio de trabajo.</li>'),
unistr('<li>Modificar Repositorio de Espacio de Trabajo: la aplicaci\00F3n puede cambiar usuarios y grupos de espacio de trabajo.</li>    '),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(721525211605207324.4001)
,p_name=>'P509_ACCEPT_OLD_CHECKSUMS'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(107273213161009008.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Aceptar totales de control de URL pre20.2'
,p_source=>'ACCEPT_OLD_CHECKSUMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P509_ACCEPT_OLD_CHECKSUMS'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica si APEX acepta o no marcadores generados con APEX 20.1 y versiones anteriores. Si est\00E1n desactivados, esos marcadores p\00FAblicos y privados emitir\00E1n errores de validaci\00F3n de total de control. Si est\00E1n activados, los marcadores seguir\00E1n funcionan')
||'do.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(815128529788112116.4001)
,p_name=>'P509_REFERRER_POLICY'
,p_is_required=>true
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(875541626713267923.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cabecera Referrer-Policy'
,p_source=>'REFERRER_POLICY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REFERRER_POLICY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value disp,',
'       x.column_value ret',
'  from table(wwv_flow_t_varchar2 (',
'                 ''no-referrer'',',
'                 ''no-referrer-when-downgrade'',',
'                 ''origin'',',
'                 ''origin-when-cross-origin'',',
'                 ''same-origin'',',
'                 ''strict-origin'',',
'                 ''strict-origin-when-cross-origin'',',
'                 ''unsafe-url'' )) x',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Con este atributo se define lo que &PRODUCT_NAME. env\00EDa en la cabecera de la respuesta HTTP <code>Referrer-Policy</code>.'),
unistr('Con <code>Referrer-Policy</code> se controla lo que el explorador env\00EDa a los servidores en las '),
'cabeceras de solicitudes <code>Referer</code> y <code>Origin</code>,',
unistr('cuando los usuarios hacen clic en los enlaces o en las p\00E1ginas Enviar.'),
unistr('Esta informaci\00F3n suele incluir la URL completa, incluidos los ID de sesi\00F3n de &PRODUCT_NAME.,'),
'que los terceros no deben ver.',
'En las aplicaciones nuevas se debe utilizar el valor <code>strict-origin</code>,',
unistr('a menos que existan requisitos espec\00EDficos en la compa\00F1\00EDa para usar otro valor.'),
'</p><p>',
unistr('Consulte la documentaci\00F3n de'),
'<a href="https://www.w3.org/TR/referrer-policy/" referrerpolicy="no-referrer" target="_blank">',
'sobre la cabecera Referrer-Policy y sus valores disponibles',
'</a>',
unistr('para obtener m\00E1s informaci\00F3n.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(875823623343323717.4001)
,p_name=>'P509_BROWSER_CACHE'
,p_is_required=>true
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(875541626713267923.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Cach\00E9')
,p_source=>'BROWSER_CACHE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BROWSER_CACHE'
,p_lov=>'.'||wwv_flow_api.id(875788205897309215.4001)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                  = :FB_FLOW_ID',
'   and compatibility_mode <> ''4.0'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice la cach\00E9 para activar o desactivar el almacenamiento en cach\00E9 del explorador de contenido de las p\00E1ginas de la aplicaci\00F3n. Si se activa, el explorador guarda el contenido de las p\00E1ginas de esta aplicaci\00F3n en su cach\00E9, tanto en memoria como')
||unistr(' en disco. Normalmente, cuando el almacenamiento en cach\00E9 est\00E1 activado y se pulsa el bot\00F3n Atr\00E1s, la p\00E1gina se carga desde la cach\00E9, en lugar de hacerlo desde el servidor. Si se desactiva, se indica al explorador que no guarde el contenido de la p\00E1g')
||unistr('ina de la aplicaci\00F3n y que solicite el \00FAltimo contenido de la p\00E1gina del servidor cada vez que cambie la URL. '),
'</p>',
unistr('<p>Para evitar la posibilidad de guardar datos confidenciales, Oracle recomienda que este atributo est\00E9 desactivado. De lo contrario, es posible volver al historial del explorador despu\00E9s de una desconexi\00F3n y ver el contenido almacenado en cach\00E9 de l')
||unistr('a sesi\00F3n anterior. La desactivaci\00F3n de la cach\00E9 del explorador tambi\00E9n evita problemas con las p\00E1ginas que utilizan refrescamientos de p\00E1gina parciales, como en el caso de los informes interactivos.</p>'),
unistr('<p>Si este atributo se define en <strong>Desactivado</strong>, &PRODUCT_NAME. enviar\00E1 la cabecera HTTP <em>Cache-Control: no-store</em>, que indica al explorador que no almacene en cach\00E9 el contenido de la p\00E1gina ni en el disco ni en la memoria.'),
'</p>',
unistr('<p>Nota: Esta funci\00F3n necesita exploradores actualizados que soporten la variable de respuesta de la cabecera HTTP "Cache-Control".</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(885511105529258340.4001)
,p_name=>'P509_VPD_TEARDOWN_CODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(107179319972706932.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo PL/SQL de Limpieza')
,p_source=>'VPD_TEARDOWN_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este atributo para introducir un bloque PL/SQL que se ejecute al final del procesamiento de p\00E1ginas.'),
'Se puede utilizar para liberar o limpiar recursos que se hayan utilizado, como contextos de VPD o enlaces de base de datos.',
'</p>',
'<p>Ejemplo 1:',
'<pre>',
'dbms_session.clear_context(''CTX_USER_QRY'');',
'</pre>',
unistr('Esta llamada restablece el contexto de aplicaci\00F3n denominado CTX_USER_QRY antes de que la sesi\00F3n de la base de datos se devuelva al pool de sesiones,'),
unistr('para asegurarse de que no se pierda ninguna informaci\00F3n cuando se vuelva a utilizar m\00E1s adelante.'),
'</p>',
'<p>Ejemplo 2:',
'<pre>',
'dbms_session.close_database_link(''SALES'');',
'</pre>',
unistr('Esta llamada cierra el enlace de base de datos SALES, que se podr\00EDa haber abierto en el c\00F3digo PL/SQL de inicializaci\00F3n o de forma impl\00EDcita, simplemente consultando los datos a trav\00E9s del enlace.'),
'De nuevo, esto libera recursos y evita la falta de recursos cuando se vuelva a utilizar la base de datos.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1098121125859208369.4001)
,p_name=>'P260_BROWSER_FRAME'
,p_is_required=>true
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(875541626713267923.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'D'
,p_prompt=>'Incluir en Marcos'
,p_source=>'BROWSER_FRAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BROWSER_FRAME'
,p_lov=>'.'||wwv_flow_api.id(1098055005642193053.4001)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                  = :FB_FLOW_ID',
'   and compatibility_mode <> ''4.0'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Utilice este atributo para controlar si el explorador puede mostrar las p\00E1ginas de su aplicaci\00F3n en un marco:'),
'<ul>',
unistr('<li><strong>Denegar</strong>: la p\00E1gina no se puede mostrar en un marco, independientemente del sitio que lo est\00E9 intentando.</li>'),
unistr('<li><strong>Permitir del mismo origen</strong>: la p\00E1gina solo se puede mostrar en un marco del mismo origen que la propia p\00E1gina.</li>'),
unistr('<li><strong>Permitir</strong>: la p\00E1gina se puede mostrar en cualquier marco.</li>'),
'</ul>',
'</p>',
'<p>',
unistr('Esta opci\00F3n de visualizaci\00F3n de p\00E1ginas en marcos puede ser utilizada de forma incorrecta mediante "clickjacking" (secuestro de clics).'),
unistr('En este caso, el usuario no autorizado utiliza varias capas para enga\00F1ar a un usuario para que haga clic en un bot\00F3n o enlace a otra p\00E1gina cuando en realidad intentaba hacer clic en la p\00E1gina del nivel superior.'),
unistr('Es decir, el usuario no autorizado secuestra los clics (o las pulsaciones de teclas) que van a la p\00E1gina y las redirecciona a otra.'),
'</p>',
'<p>',
unistr('Las p\00E1ginas del cuadro de di\00E1logo se suelen mostrar dentro de un iframe,'),
unistr('lo que no funcionar\00EDa normalmente con el valor de atributo "Denegar".'),
unistr('El atributo <em>Permitir embeber en marcos</em> de una plantilla de p\00E1gina del cuadro de di\00E1logo define si se debe utilizar "Permitir del mismo origen" en lugar de "Denegar"'),
unistr('para p\00E1ginas que utilizan dicha plantilla.'),
'Para protegerse frente al secuestro de clics,',
unistr('&PRODUCT_NAME. utiliza un total de control espec\00EDfico de la p\00E1gina en las URL de p\00E1gina del cuadro de di\00E1logo.'),
'</p>',
'<p>',
unistr('Nota: Esta funci\00F3n necesita exploradores actuales que soporten la variable de respuesta de cabecera HTTP "X-Frame-Options".'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1143248434428567437.4001)
,p_name=>'P509_INSTANCE_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'P509_INSTANCE_MAX_SESSION_IDLE_SEC'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'',',
'    p0     => nvl( wwv_flow_security.get_workspace(',
'                       p_security_group_id => wwv_flow_security.g_security_group_id ).max_session_idle_sec, 0 ) )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P509_MAX_SESSION_IDLE_SEC'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--postItemText'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1143248571179567438.4001)
,p_name=>'P509_INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6354406057147715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'P509_INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'',',
'    p0     => nvl( wwv_flow_security.get_workspace(',
'                       p_security_group_id => wwv_flow_security.g_security_group_id ).max_session_length_sec, 0 ) )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P509_MAX_SESSION_LENGTH_SEC'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--postItemText'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(384790260914553248.4001)
,p_validation_name=>'Validate REJOIN_EXISTING_SESSIONS'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_instance_value constant varchar2(4000) := wwv_flow_platform.get_preference(''REJOIN_EXISTING_SESSIONS'');',
'begin',
'    wwv_flow_debug.trace(''REJOIN.....%s'', :P509_REJOIN_EXISTING_SESSIONS||c_instance_value);',
'    return :P509_REJOIN_EXISTING_SESSIONS||c_instance_value in (''NN'', ''NP'', ''NY'',',
'                                                                ''PP'', ''PY'',',
'                                                                ''YY'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Este valor no est\00E1 soportado en la instancia de &PRODUCT_NAME..')
,p_associated_item=>wwv_flow_api.id(384789975408553245.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(574348776255630522.4001)
,p_validation_name=>'Validate REJOIN_EXISTING_SESSIONS against BROWSER_FRAME'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * disallow rejoin all sessions when embedding in frames is allowed',
' */',
'not (    nvl(:P509_REJOIN_EXISTING_SESSIONS, ''N'') = ''Y''',
'     and nvl(:P260_BROWSER_FRAME           , ''D'') = ''A'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La configuraci\00F3n de Volver a Unir Sesiones de <em>Activado para Todas las Sesiones</em> requiere que <strong>Incluir en Marcos</strong> est\00E9 definido como <em>Permitir del Mismo Origen</em> o <em>Denegar</em> para la aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(384789975408553245.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(107223216874707020.4001)
,p_validation_name=>'validate schema'
,p_validation_sequence=>30
,p_validation=>'wwv_flow_security.current_company_can_build(p_in_schema=>:P509_OWNER)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('No hay ning\00FAn privilegio para crear en el esquema &P509_OWNER. Utilice la lista de valores de la p\00E1gina anterior para seleccionar un esquema en el que tenga privilegios para crear.')
,p_associated_item=>wwv_flow_api.id(107204011001706983.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6373423169504345.4001)
,p_validation_name=>'max session length a positive integer'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare x pls_integer;',
'begin',
'x := :P509_MAX_SESSION_LENGTH_SEC;',
'if x < 0 or to_number(:P509_MAX_SESSION_LENGTH_SEC) <> trunc(to_number(:P509_MAX_SESSION_LENGTH_SEC)) then',
'    return false;',
'else',
'    return true;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'El valor debe ser un entero positivo.'
,p_associated_item=>wwv_flow_api.id(6357502772184607.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6373829188515554.4001)
,p_validation_name=>'max session idle seconds a positive integer'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare x pls_integer;',
'begin',
'x := :P509_MAX_SESSION_IDLE_SEC;',
'if x < 0 or to_number(:P509_MAX_SESSION_IDLE_SEC) <> to_number(trunc(:P509_MAX_SESSION_IDLE_SEC)) then',
'    return false;',
'else',
'    return true;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El valor debe ser un n\00FAmero positivo.')
,p_associated_item=>wwv_flow_api.id(6358230130192576.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(94182446784544824.4001)
,p_validation_name=>'session timeout warning seconds a positive'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare x pls_integer;',
'begin',
'x := :P509_SESSION_TIMEOUT_WARN_SEC;',
'if x < 0 or to_number(:P509_SESSION_TIMEOUT_WARN_SEC) <> to_number(trunc(:P509_SESSION_TIMEOUT_WARN_SEC)) then',
'    return false;',
'else',
'    return true;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El valor debe ser un n\00FAmero positivo.')
,p_associated_item=>wwv_flow_api.id(94182360081544823.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(495347589832866236.4001)
,p_name=>'Show/Hide AUTHORIZE_PUBLIC_PAGES'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P509_SECURITY_SCHEME'
,p_condition_element=>'P509_SECURITY_SCHEME'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'MUST_NOT_BE_PUBLIC_USER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(495347636738866237.4001)
,p_event_id=>wwv_flow_api.id(495347589832866236.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P509_AUTHORIZE_PUBLIC_PAGES_YN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(495347739700866238.4001)
,p_event_id=>wwv_flow_api.id(495347589832866236.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P509_AUTHORIZE_PUBLIC_PAGES_YN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107223823728707022.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107224400935707023.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Aplicaci\00F3n &FB_UPD_ID. procesada.')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107224620333707024.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
end;
/
prompt --application/pages/page_00510
begin
wwv_flow_api.create_page(
 p_id=>510.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_step_title=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107375112935642905.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n del Estado de Sesi\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La activaci\00F3n de la protecci\00F3n de estado de la sesi\00F3n puede evitar que los piratas inform\00E1ticos manipulen las direcciones URL de la aplicaci\00F3n. La manipulaci\00F3n de la direcci\00F3n URL puede afectar de forma negativa a la l\00F3gica del programa, al conten')
||unistr('ido del estado de la sesi\00F3n y a la privacidad de la informaci\00F3n.'),
unistr('<p>Para activar, desactivar o configurar Protecci\00F3n de Estado de la Sesi\00F3n con el asistente, haga clic en <strong>Definir Protecci\00F3n</strong>.</p>')))
,p_plug_footer=>'<p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722893162918355703.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(722893227881355704.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n del Estado de Sesi\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1301369887754065007.4001)
,p_plug_name=>unistr('Configuraci\00F3n de Protecci\00F3n de Estado de la Sesi\00F3n Existente')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_region_attributes=>'style="border: 1px solid #E0E0E0; border-radius: 2px;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1271240655472240403.4001)
,p_name=>unistr('P\00E1ginas')
,p_parent_plug_id=>wwv_flow_api.id(1301369887754065007.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(PROTECTION_LEVEL,''N'') protection',
',      count(''x'') as Count                    ',
'from   #OWNER#.WWV_FLOW_STEPS p',
'where flow_id = :fb_flow_id ',
'and   p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL',
'order by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(1271240655472240403.4001)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1312309225232475801.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Acceso a la P\00E1gina')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17255429593772638)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1271240807146240405.4001)
,p_query_column_id=>2
,p_column_alias=>'COUNT'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1ginas')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1271240975440240406.4001)
,p_name=>unistr('Elementos de P\00E1gina')
,p_parent_plug_id=>wwv_flow_api.id(1301369887754065007.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(PROTECTION_LEVEL,''N'') protection',
',      count(''x'') as Count                    ',
'from   #OWNER#.WWV_FLOW_STEP_ITEMS p',
'where flow_id = :fb_flow_id ',
'and   p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL',
'order by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(1271240975440240406.4001)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1312309350363475802.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Nivel de Acceso a Elemento'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1271241137913240408.4001)
,p_query_column_id=>2
,p_column_alias=>'COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Elementos'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1271241223019240409.4001)
,p_name=>unistr('Elementos de Aplicaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(1301369887754065007.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(PROTECTION_LEVEL,''N'') protection',
',      count(''x'') as Count                    ',
'from   #OWNER#.WWV_FLOW_ITEMS p',
'where flow_id = :fb_flow_id ',
'and   p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL',
'order by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(1271241223019240409.4001)
,p_plug_column_width=>'apex-col--leftBorder apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1312309425282475803.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Nivel de Acceso a Elemento'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1271241482244240411.4001)
,p_query_column_id=>2
,p_column_alias=>'COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Elementos'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1271241539938240412.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1271240975440240406.4001)
,p_button_name=>'GOTOPAGESITEMS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Ir a P\00E1ginas')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:513:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1271241612371240413.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1271241223019240409.4001)
,p_button_name=>'GOTOAPPITEMS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Ir a P\00E1ginas')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:518:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1362277728754195801.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1271240655472240403.4001)
,p_button_name=>'GOTOPAGES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Ir a P\00E1ginas')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:512:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109597028644139221.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(722893162918355703.4001)
,p_button_name=>'SET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Definir Protecci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107364120114588295.4001)
,p_name=>'P510_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107375112935642905.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107369003192611794.4001)
,p_name=>'P510_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107375112935642905.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PROTECTION_ENABLED_Y_N',
'  from wwv_flows',
' where id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00511
begin
wwv_flow_api.create_page(
 p_id=>511.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Opciones de Creaci\00F3n')
,p_step_title=>unistr('Opciones de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13724816425012921.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Identifique las opciones de creaci\00F3n que puede cambiar un usuario al instalar esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22517025703414506.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24433530107927890.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34011006179919668.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13725714531012925.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34011006179919668.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13725916424012927.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34011006179919668.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29855829820547296.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13727714196012940.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13726325680012930.4001)
,p_name=>'P511_BUILD_OPTS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13724816425012921.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Solicitar Opciones de Creaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
'begin ',
'   select build_opt_id ',
'   bulk collect into l_value ',
'   from wwv_flow_install_build_opt ',
'   where flow_id = :FB_FLOW_ID ',
'   and security_group_id = :flow_security_group_id;',
'',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DEPLOYMENT BUILD OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name||'' (''||wwv_flow_lang.system_message(patch_status)||'')'' d, id r ',
'  from wwv_flow_patches ',
' where flow_id = :FB_FLOW_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Las opciones de creaci\00F3n de la aplicaci\00F3n se enumeran a continuaci\00F3n, junto con el valor actual de cada una de ellas. Active la casilla situada junto a una opci\00F3n de creaci\00F3n para permitir a un usuario que instala la aplicaci\00F3n cambiar el valor como ')
||unistr('parte del proceso de instalaci\00F3n. El valor actual ser\00E1 el valor por defecto de cada opci\00F3n de creaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19383321640657223.4001)
,p_name=>'P511_NO_BUILD_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(13724816425012921.4001)
,p_prompt=>unistr('Esta aplicaci\00F3n no tiene ninguna opci\00F3n de creaci\00F3n.')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fielddata"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29854320124544401.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13726721533012932.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process build opts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_build_opts wwv_flow_global.vc_arr2;',
'begin',
'  l_build_opts := wwv_flow_utilities.string_to_table2(:P511_BUILD_OPTS);',
'  delete from wwv_flow_install_build_opt where flow_id = :FB_FLOW_ID;',
'  for i in 1..l_build_opts.count',
'  loop',
'    insert into wwv_flow_install_build_opt (build_opt_id) ',
'         values (l_build_opts(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido actualizar las peticiones de datos de opci\00F3n de creaci\00F3n.')
,p_process_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'' or v(''REQUEST'')=''SAVE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13727528196012940.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'17'
);
end;
/
prompt --application/pages/page_00512
begin
wwv_flow_api.create_page(
 p_id=>512.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n por P\00E1gina')
,p_step_title=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15563507922723490.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n de Estado de la Sesi\00F3n de Nivel de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ID as "PAGE",',
'	 NAME as "Name",',
'	 decode(nvl(PROTECTION_LEVEL,''N''),',
'            ''N'',m.n,',
'            ''C'',m.c,',
'            ''U'',m.u,',
'            ''D'',m.d,',
'            PROTECTION_LEVEL) as "Protection",        ',
'         (select count(*) ',
'          from wwv_flow_step_items ',
'          where flow_step_id = p.id ',
'          and flow_id = :fb_flow_id',
'          and security_group_id = :flow_security_group_id) page_items,',
'         id,',
'      decode(PAGE_COMPONENT_MAP,',
'         ''01'',m.apex_tabular_form,',
'         ''02'',m.apex_form,',
'         ''03'',m.apex_report,',
'         ''04'',m.apex_chart,',
'         ''05'',m.apex_web_service,',
'         ''06'',m.apex_nav_page,',
'         ''07'',m.apex_tree,',
'         ''08'',m.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',m.apex_dynamic_html,',
'         ''11'',m.apex_static_html,',
'         ''12'',m.apex_login,',
'         ''13'',m.apex_home,',
'         ''14'',m.apex_zero,',
'         ''15'',m.apex_empty_page,',
'         ''16'',m.apex_dynamic_form,',
'         ''17'',m.apex_wizard_form,',
'         ''18'',m.apex_interactive_rpt,',
'         ''unknown'') page_type,',
'         nvl(last_updated_on,created_on) updated,',
'         nvl(last_updated_by,created_by) updated_by,',
'         decode(nvl(p.PAGE_IS_PUBLIC_Y_N,''N''),',
'            ''Y'',t_yes,',
'            ''N'',t_no) PAGE_IS_PUBLIC_Y_N,',
'         decode(nvl(p.ALLOW_DUPLICATE_SUBMISSIONS,''Y''),',
'            ''Y'',t_yes,',
'            ''N'',t_no) ALLOW_DUPLICATE_SUBMISSIONS',
' from	 #OWNER#.WWV_FLOW_STEPS p,',
' (select ',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') n,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') c,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') u,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') d,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no',
'  from sys.dual ) m',
'where flow_id = :fb_flow_id ',
'and p.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(15563630191723490.4001)
,p_name=>'Page Level Session State Protection  Controls'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15563809490723495.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:515:P515_FLOW_ID,P515_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15563920668723498.4001)
,p_db_column_name=>'Name'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15564001488723498.4001)
,p_db_column_name=>'Protection'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Protecci\00F3n de Acceso a P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15564102704723498.4001)
,p_db_column_name=>'PAGE_ITEMS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Elementos de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15564213332723499.4001)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15566705831826913.4001)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Tipo de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15567109771837456.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15567224214837461.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47982212654038334.4001)
,p_db_column_name=>'PAGE_IS_PUBLIC_Y_N'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('P\00E1gina P\00FAblica')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47982329750038342.4001)
,p_db_column_name=>'ALLOW_DUPLICATE_SUBMISSIONS'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Permitir Ejecuciones Duplicadas'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107379420123663984.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n del Estado de Sesi\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468051002564332724.4001)
,p_plug_name=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice esta p\00E1gina para especificar los atributos de protecci\00F3n de acceso a p\00E1gina en todas las p\00E1ginas de la aplicaci\00F3n. Utilice el enlace de p\00E1gina para seleccionar una p\00E1gina concreta con el fin de especificar y definir los atributos de protec')
||unistr('ci\00F3n de estado de la sesi\00F3n de elemento y p\00E1gina en dicha p\00E1gina.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107404229668819788.4001)
,p_branch_action=>'f?p=&FLOW_ID.:512:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107380027050665989.4001)
,p_name=>'P512_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107379420123663984.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107381105710669241.4001)
,p_name=>'P512_APPLICATION_SESS_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107379420123663984.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(107684910996777811.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'512'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00513
begin
wwv_flow_api.create_page(
 p_id=>513.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Protecci\00F3n por Elemento')
,p_step_title=>unistr('Protecci\00F3n por Elemento')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15568426358851702.4001)
,p_plug_name=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento ')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4513a */	 "WWV_FLOW_STEPS".ID as "ID",',
'	 "WWV_FLOW_STEPS".NAME as "Page",',
'	 nvl("WWV_FLOW_STEPS".PROTECTION_LEVEL,''N'') as "Page Protection",',
'	 "WWV_FLOW_STEP_ITEMS".NAME as "Item",',
'	 "WWV_FLOW_STEP_ITEMS".ITEM_SEQUENCE as "Sequence",',
'	 (select plug_name from wwv_flow_page_plugs where id = "WWV_FLOW_STEP_ITEMS".ITEM_PLUG_ID) as "Region",',
'	 nvl(WWV_FLOW_STEPS.PROTECTION_LEVEL,''N'') as "PAGE_PROTECTION",',
'	 nvl("WWV_FLOW_STEP_ITEMS".PROTECTION_LEVEL,''N'') as "PROTECTION_LEVEL",',
'         nvl(WWV_FLOW_STEP_ITEMS.last_updated_on,WWV_FLOW_STEP_ITEMS.created_on) updated,',
'         nvl(WWV_FLOW_STEP_ITEMS.last_updated_by,WWV_FLOW_STEP_ITEMS.created_by) updated_by ',
' from	 #OWNER#."WWV_FLOW_STEP_ITEMS" "WWV_FLOW_STEP_ITEMS",',
'	 #OWNER#."WWV_FLOW_STEPS" "WWV_FLOW_STEPS" ',
' where   WWV_FLOW_STEP_ITEMS.FLOW_STEP_ID=WWV_FLOW_STEPS.ID and',
'         WWV_FLOW_STEP_ITEMS.FLOW_ID = :fb_flow_id and',
'         WWV_FLOW_STEPS.FLOW_ID = :fb_flow_id and',
'         wwv_flow_steps.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(15568515892851702.4001)
,p_name=>'Item Session State Protection '
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15568709474851708.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:515:P515_ID,P515_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15568800078851709.4001)
,p_db_column_name=>'Page'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15568915133851709.4001)
,p_db_column_name=>'Page Protection'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Protecci\00F3n de Acceso a URL')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15569000539851709.4001)
,p_db_column_name=>'Item'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nombre del Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15569132662851709.4001)
,p_db_column_name=>'Sequence'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15569223797851709.4001)
,p_db_column_name=>'Region'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15569326705851709.4001)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(109261519627066371)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15570520039906667.4001)
,p_db_column_name=>'PAGE_PROTECTION'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Protecci\00F3n de P\00E1gina')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15573023895936154.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15573107965936154.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47985106468064841.4001)
,p_plug_name=>unistr('Elementos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice esta p\00E1gina para especificar los niveles de protecci\00F3n de estado de la sesi\00F3n para todos los elementos de p\00E1gina de la aplicaci\00F3n. Utilice el enlace de p\00E1gina para seleccionar una p\00E1gina cada vez con el fin de definir los atributos de prot')
||unistr('ecci\00F3n de estado de la sesi\00F3n para los elementos de la p\00E1gina.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107659716874703894.4001)
,p_plug_name=>'Application Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107671012548724159.4001)
,p_branch_action=>'f?p=&FLOW_ID.:513:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107660424839706153.4001)
,p_name=>'P513_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107659716874703894.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107661831765708161.4001)
,p_name=>'P513_APP_SESS_STATE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107659716874703894.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(107685719308780262.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'513'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00514
begin
wwv_flow_api.create_page(
 p_id=>514.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Buscador de Tablas'
,p_step_title=>'Buscador de Tablas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6217914052048898.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6218805138048905.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(6235410232149121.4001)
,p_name=>'Columnas'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name, data_type, data_length, data_precision, data_scale, nullable',
'from sys.user_tab_columns c',
'where table_name = :p514_table_name',
'order by column_id'))
,p_display_when_condition=>':P514_TABLE_NAME is not null and :P514_VIEW = ''COLUMNS'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>50000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P514_APPLICATION_OWNER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6236424561162724.4001)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de Columna'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6236526063162724.4001)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo de Dato'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6236620800162724.4001)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Longitud'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6236730789162724.4001)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Precisi\00F3n')
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6236829909162724.4001)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>5
,p_column_heading=>'Escala'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33943015271890311.4001)
,p_query_column_id=>6
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>6
,p_column_heading=>'Nulo'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6243023354200253.4001)
,p_plug_name=>'Consulta'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q varchar2(32767);',
'begin',
'    q := ''&nbsp;<p />select'';',
'    for c1 in ( select column_name',
'                  from wwv_flow_table_columns_dev c',
'                 where table_name = :p514_table_name )',
'    loop',
'        q := q||''<br />'';',
'        q := q||''&nbsp;&nbsp;&nbsp;&nbsp;''||wwv_flow_escape.html(c1.column_name)||'','';',
'    end loop;',
'    q := rtrim(q,'','')||''<br />from ''||wwv_flow_escape.html(:p514_table_name);',
'    sys.htp.p(q);',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P514_TABLE_NAME is not null and :P514_VIEW = ''QUERY'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(478899929205775865.4001)
,p_plug_name=>'Tablas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id, table_name, num_rows, ',
'       t.last_analyzed, ''TABLE'' object_type',
'from sys.user_tables t, sys.user_objects o',
'where o.object_name = t.table_name',
'and   o.object_type = ''TABLE''',
'union all',
'select object_id, view_name table_name, null num_rows, ',
'       null last_analyzed, ''VIEW'' object_type',
'from sys.user_views v, sys.user_objects o',
'where o.object_name = v.view_name',
'and   o.object_type = ''VIEW'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P514_APPLICATION_OWNER'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P514_VIEW'
,p_plug_display_when_cond2=>'TABLES'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(478900029710775865.4001)
,p_name=>'Tables'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478900326931775900.4001)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Nombre de la Tabla'
,p_column_link=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.:RP:P514_OBJECT_ID,P514_VIEW:#OBJECT_ID#,COLUMNS'
,p_column_linktext=>'#TABLE_NAME#'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478900401730775902.4001)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Filas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478900510317775904.4001)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>unistr('\00DAltimo An\00E1lisis')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478900627368775905.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478900219899775899.4001)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>5
,p_column_identifier=>'A'
,p_column_label=>'Identificador de Objeto'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(478904616126826610.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6217914052048898.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.:RIR,514::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(171289413896152205.4001)
,p_branch_action=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6234831572145899.4001)
,p_name=>'P514_TABLE_NAME'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(6217914052048898.4001)
,p_prompt=>'Tabla:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P514_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Tabla o vista seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(56560405022518846.4001)
,p_name=>'P514_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6235410232149121.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(171246514130594035.4001)
,p_name=>'P514_VIEW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(6217914052048898.4001)
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'POPUP TABLE FINDER VIEW OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(171249216657727210.4001)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Permite cambiar la visualizaci\00F3n despu\00E9s de seleccionar una tabla o vista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238734106943199432.4001)
,p_name=>'P514_APPLICATION_OWNER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6217914052048898.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(238734824951204611.4001)
,p_computation_sequence=>20
,p_computation_item=>'P514_APPLICATION_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(56561327532525319.4001)
,p_computation_sequence=>30
,p_computation_item=>'P514_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name from sys.dba_objects',
'where object_id = :P514_OBJECT_ID',
'and   owner = (select owner from wwv_flows where id = :fb_flow_id)'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171248724360710574.4001)
,p_computation_sequence=>40
,p_computation_item=>'P514_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'TABLES'
,p_compute_when=>'P514_VIEW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00515
begin
wwv_flow_api.create_page(
 p_id=>515.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Definir P\00E1gina y Protecci\00F3n de Elemento')
,p_step_title=>unistr('Definir P\00E1gina y Protecci\00F3n de Elemento')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107452431597085754.4001)
,p_plug_name=>unistr('Definir P\00E1gina y Protecci\00F3n de Elemento')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(107455315318085771.4001)
,p_name=>unistr('Elementos de P\00E1gina (Elementos de Pantalla)')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>125
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_ID",',
'"NAME",',
'"ITEM_SEQUENCE",',
'"ITEM_PLUG_ID",',
'"PROMPT",',
'"DISPLAY_AS",',
'"PROTECTION_LEVEL"',
'from "#OWNER#"."WWV_FLOW_STEP_ITEMS"',
'where "FLOW_ID" = :FB_FLOW_ID and flow_step_id = :p515_ID',
'and display_as not in (''NATIVE_DISPLAY_ONLY'', ''TEXT_DISABLED'', ''NATIVE_STOP_AND_START_HTML_TABLE'')'))
,p_display_when_condition=>':P515_FLOW_ID is not null and :P515_ITEM_TYPE=''FORM'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay elementos de entrada de datos en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107455621420085774.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107455728607085774.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'FLOW_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107455828342085774.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107455925732085774.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>5
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_SEQUENCE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107456021564085774.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_inline_lov=>'select plug_name, id from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = :p515_id'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_PLUG_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107456110175085775.4001)
,p_query_column_id=>6
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>6
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'PROMPT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(107456228953085775.4001)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'DISPLAY_AS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109376012088887101.4001)
,p_query_column_id=>8
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(109314413723246310)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107470709706134079.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107470807208134086.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107470903911134086.4001)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107471020045134086.4001)
,p_column_sequence=>4
,p_query_column_name=>'ITEM_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107471123550134086.4001)
,p_column_sequence=>5
,p_query_column_name=>'ITEM_PLUG_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107471225409134086.4001)
,p_column_sequence=>6
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(107471310390134086.4001)
,p_column_sequence=>7
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109375825680887098.4001)
,p_column_sequence=>8
,p_query_column_name=>'PROTECTION_LEVEL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(109355116414409031.4001)
,p_name=>unistr('Elementos de P\00E1gina (Elementos de S\00F3lo Visualizaci\00F3n)')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>135
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_ID",',
'"NAME",',
'"ITEM_SEQUENCE",',
'"ITEM_PLUG_ID",',
'"PROMPT",',
'"DISPLAY_AS",',
'"PROTECTION_LEVEL"',
'from "#OWNER#"."WWV_FLOW_STEP_ITEMS"',
'where "FLOW_ID" = :FB_FLOW_ID and flow_step_id = :p515_ID',
'and display_as in (''NATIVE_DISPLAY_ONLY'', ''TEXT_DISABLED'', ''NATIVE_STOP_AND_START_HTML_TABLE'')'))
,p_display_when_condition=>':P515_FLOW_ID is not null and :P515_ITEM_TYPE=''DISPLAY'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay elementos de s\00F3lo visualizaci\00F3n en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109355410660409036.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109355501228409036.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'FLOW_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109355614340409036.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109355730378409037.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>5
,p_column_heading=>'Secuencia'
,p_column_alignment=>'CENTER'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_SEQUENCE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109355813836409037.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_inline_lov=>'select plug_name, id from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = :p515_id'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_PLUG_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109355922567409037.4001)
,p_query_column_id=>6
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>6
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'PROMPT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109356030331409037.4001)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>7
,p_column_heading=>'Display As'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>12
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'DISPLAY_AS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109377403449890174.4001)
,p_query_column_id=>8
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109357827281421629.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109357932477421629.4001)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109358001740421629.4001)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109358100051421629.4001)
,p_column_sequence=>4
,p_query_column_name=>'ITEM_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109358202143421629.4001)
,p_column_sequence=>5
,p_query_column_name=>'ITEM_PLUG_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109358315514421629.4001)
,p_column_sequence=>6
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109358423336421629.4001)
,p_column_sequence=>7
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(109377206773890170.4001)
,p_column_sequence=>8
,p_query_column_name=>'PROTECTION_LEVEL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179341427720175757.4001)
,p_plug_name=>unistr('Protecci\00F3n de Elemento y P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>55
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice esta p\00E1gina para especificar y definir el nivel de protecci\00F3n de acceso a p\00E1gina para la p\00E1gina actual y para especificar y definir el nivel de protecci\00F3n de estado de la sesi\00F3n para cada elemento de la p\00E1gina.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(886492704178981503.4001)
,p_plug_name=>unistr('Definir P\00E1gina y Protecci\00F3n de Elemento')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107452915725085755.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(886492704178981503.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107452706382085755.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(886492704178981503.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P515_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109364307588794495.4001)
,p_branch_name=>'Go To Page 515'
,p_branch_action=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P515_ITEM_TYPE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107458201488085786.4001)
,p_branch_action=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107453526628085757.4001)
,p_name=>'P515_FLOW_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107453701465085759.4001)
,p_name=>'P515_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1gina actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107453904227085761.4001)
,p_name=>'P515_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Identifica el nombre de la p\00E1gina actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107454319951085767.4001)
,p_name=>'P515_PAGE_IS_PUBLIC_Y_N'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n de P\00E1gina ')
,p_source=>'PAGE_IS_PUBLIC_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE.PUBLIC'
,p_lov=>'.'||wwv_flow_api.id(84921112902747500.4001)||'.'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Indica si la p\00E1gina necesita autenticaci\00F3n o es una p\00E1gina p\00FAblica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107454504672085768.4001)
,p_name=>'P515_PROTECTION_LEVEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Acceso a P\00E1gina')
,p_source=>'PROTECTION_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_api.id(17255429593772638.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un nivel de protecci\00F3n de acceso a p\00E1gina:'),
'<ul>',
unistr('<li><strong>No Restringido</strong>: La p\00E1gina se puede solicitar mediante una direcci\00F3n URL con o sin argumentos de estado de la sesi\00F3n (Solicitud, Borrar Cach\00E9, Nombre/Valor).</li>'),
unistr('<li><strong>Los Argumentos Deben Tener Total de Control</strong>: Si los argumentos Solicitud, Borrar Cach\00E9 o Nombre/Valor aparecen en la direcci\00F3n URL, tambi\00E9n se debe proporcionar el total de control. El tipo de total de control debe ser compatible')
||unistr(' con el atributo Protecci\00F3n de Estado de la Sesi\00F3n m\00E1s exigente de todos los elementos que se han transferido como argumentos.</li>'),
unistr('<li><strong>No se Permiten Argumentos</strong>: Se puede utilizar una direcci\00F3n URL para solicitar la p\00E1gina pero no se permiten los argumentos Solicitud, Borrar Cach\00E9 o Nombre/Valor.</li>'),
unistr('<li><strong>No Hay Acceso a URL</strong>: No se puede acceder a la p\00E1gina mediante una direcci\00F3n URL; sin embargo, la p\00E1gina puede ser el destino de un tipo de bifurcaci\00F3n Bifurcar a P\00E1gina, que no efect\00FAa un redireccionamiento a la direcci\00F3n URL.</l')
||'i> ',
'</ul>    '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107646522668648728.4001)
,p_name=>'P515_APP_SEC_STATE_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. '),
unistr('<p>Si est\00E1 <strong>activada</strong>, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los totales de control colocados en las direcciones URL "f?p=". ')
||unistr('Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
unistr('<p>Si est\00E1 <strong>desactivada</strong>, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109363408842785369.4001)
,p_name=>'P515_ITEM_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_item_default=>'FORM'
,p_prompt=>'Mostrar Tipo de Elemento:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FORM_ITEM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(276983704971116375.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Muestre los informes individuales de los elementos de entrada de datos y de s\00F3lo visualizaci\00F3n. Los elementos de entrada de datos son elementos que se pueden modificar mediante pantallas e incluyen elementos ocultos. Los elementos de s\00F3lo visualizaci')
||unistr('\00F3n simplemente aparecen en la pantalla y no se ejecutan con la pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(111788926376356410.4001)
,p_name=>'P515_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107452431597085754.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107454714523085768.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_STEPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_STEPS'
,p_attribute_03=>'P515_FLOW_ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'P515_ID'
,p_attribute_06=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_when=>'P515_FLOW_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'&FB_FLOW_ID.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107457318076085783.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(109355116414409031.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEMS'
,p_attribute_03=>'ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('No se ha podido procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(107452706382085755.4001)
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'  #MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107454925018085769.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_STEPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_STEPS'
,p_attribute_03=>'P515_FLOW_ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'P515_ID'
,p_attribute_06=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_STEPS.'
,p_process_when_button_id=>wwv_flow_api.id(107452706382085755.4001)
,p_process_when=>'P515_FLOW_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'&FB_FLOW_ID.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00516
begin
wwv_flow_api.create_page(
 p_id=>516.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Buscador de P\00E1ginas')
,p_step_title=>unistr('Buscador de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6257016079472811.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(478906730209866600.4001)
,p_plug_name=>unistr('P\00E1ginas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>140
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, alias, page_mode,',
'       (select count(*) from wwv_flow_step_items ',
'         where flow_id = :fb_flow_id and flow_step_id = p.id) items, ',
'       step_title, tab_set,',
'       (select count(*) from wwv_flow_page_plugs ',
'         where flow_id = :fb_flow_id and page_id = p.id) regions',
'  from wwv_flow_steps p',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(478906809191866600.4001)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907026507866606.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::F4000_P273_PAGE:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907109093866607.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907213582866609.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907412212866612.4001)
,p_db_column_name=>'STEP_TITLE'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>unistr('T\00EDtulo')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907515351866613.4001)
,p_db_column_name=>'TAB_SET'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Juego de Separadores'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907311087866610.4001)
,p_db_column_name=>'ITEMS'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Elementos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478907626758866615.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(44906829156254720.4001)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Modo de P\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(44400703264122475)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(478909323838885640.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(478906730209866600.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:516:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(6259102851472823.4001)
,p_branch_action=>'f?p=&APP_ID.:516:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00517
begin
wwv_flow_api.create_page(
 p_id=>517.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Confirmar Solicitud para Invalidar Enlaces Marcados'
,p_step_title=>unistr('Confirmar Invalidaci\00F3n de Marcadores')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109449704383328885.4001)
,p_plug_name=>unistr('Confirmar Invalidaci\00F3n de Marcadores')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_header=>unistr('Ha solicitado que se invaliden en este momento los enlaces marcados externamente a las p\00E1ginas de la aplicaci\00F3n &FB_FLOW_ID.. Esto har\00E1 que las direcciones URL marcadas por los usuarios y que contienen totales de control dejen de ser v\00E1lidas para acc')
||unistr('eder a esta aplicaci\00F3n. S\00F3lo se aplica si la aplicaci\00F3n tiene el atributo Protecci\00F3n de Estado de la Sesi\00F3n definido en <i>Activado</i>. Confirme o cancele la solicitud.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119156585936390628.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109454430617328913.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1119156585936390628.4001)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Invalidar Enlaces Marcados'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109454202683328908.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119156585936390628.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109474320921627003.4001)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(109454430617328913.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1146879622660737846.4001)
,p_name=>'P517_BOOKMARK_HASH_FUNCTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(109449704383328885.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n Hash de Marcador')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'coalesce (',
'    wwv_flow_platform.get_preference(''CHECKSUM_HASH_FUNCTION''),',
'    wwv_flow_crypto.c_hash_best )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_api.id(367957504585280755.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el algoritmo de funci\00F3n hash que se debe utilizar para las URL marcables.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(109455826347328930.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Checksum Salt'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_security.reset_app_checksum_salt (',
'    p_flow_id  => :FB_FLOW_ID,',
'    p_function => :P517_BOOKMARK_HASH_FUNCTION );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error durante la invalidaci\00F3n de marcadores.')
,p_process_when_button_id=>wwv_flow_api.id(109454430617328913.4001)
,p_process_success_message=>'Marcadores invalidados.'
);
end;
/
prompt --application/pages/page_00518
begin
wwv_flow_api.create_page(
 p_id=>518.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Protecci\00F3n por Elemento de Aplicaci\00F3n')
,p_step_title=>unistr('Protecci\00F3n por Elemento de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30844021035293190.4001)
,p_plug_name=>unistr('Elementos de Nivel de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P518a */  "WWV_FLOW_ITEMS".NAME,',
'	 "WWV_FLOW_ITEMS".ID,',
'	 decode(nvl("WWV_FLOW_ITEMS".PROTECTION_LEVEL,''N''),',
'          	''N'', ''Unrestricted'',',
'	        ''B'',''Checksum Required - Application Level'',',
'                ''P'',''Checksum Required - User Level'',	 	 ',
'	        ''S'',''Checksum Required - Session Level'',	 	 ',
'	        ''I'', ''Restricted - May not be set from browser'') protection_level',
' from	 "WWV_FLOW_ITEMS" "WWV_FLOW_ITEMS"',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30844101953293190.4001)
,p_name=>'Application Level Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30844430051293195.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30844315176293193.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Elemento de Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:4303:F4000_P4303_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30844525523293195.4001)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107853421113386388.4001)
,p_plug_name=>unistr('Elementos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Los elementos de aplicaci\00F3n son variables de estado de la sesi\00F3n con nombre que no son espec\00EDficos de una p\00E1gina concreta. Utilice esta p\00E1gina para especificar los atributos de protecci\00F3n de estado de la sesi\00F3n para los elementos de aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110188028299524278.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107814429319308964.4001)
,p_branch_action=>'f?p=&FLOW_ID.:518:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110175312051396584.4001)
,p_name=>'P518_APP_SEC_STATE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110188028299524278.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110184315093492024.4001)
,p_name=>'P518_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110188028299524278.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(107842331325351415.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'518'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107815521797310859.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_00520
begin
wwv_flow_api.create_page(
 p_id=>520.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Grupos de P\00E1ginas')
,p_step_title=>unistr('Grupos de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212903908539395030)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1386702222981723.4001)
,p_plug_name=>unistr('Grupos de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       group_name, ',
'       group_desc, ',
'       referenced_pages,',
'       ''icon-sc-page-group'' icon_class,',
'       ''f?p=4000:521:''||:app_session||',
'       '':::521,RP,RIR:P521_ID:''||id edit_link,',
'       replace(group_name,''_'','' '')||',
'           '' (''||referenced_pages||'')'' icon_title, ',
'       round(100*referenced_pages/decode(t.total_pages,0,1,t.total_pages)) pct,',
'       round(100*referenced_pages/decode(t.total_pages,0,1,t.total_pages)) pct2',
'from',
'(',
'select id, ',
'       group_name, ',
'       group_desc,',
'       (select count(*) c ',
'        from wwv_flow_steps ',
'        where group_id = g.id and flow_id = :fb_flow_id) referenced_pages',
'from  wwv_flow_page_groups g',
'where flow_id = :fb_flow_id and',
'      security_group_id = :flow_security_group_id',
') r,',
'(',
'select sum((select count(*) c ',
'from wwv_flow_steps ',
'where group_id = g.id and ',
'      flow_id = :fb_flow_id and',
'      security_group_id = :flow_security_group_id',
'      )) total_pages',
'from wwv_flow_page_groups g',
'where flow_id = :fb_flow_id and',
'   security_group_id = :flow_security_group_id',
') t'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1386831364981723.4001)
,p_name=>'Page Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1387013953981742.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1387130716981748.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre de Grupo'
,p_column_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:RIR:P521_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1387229198981748.4001)
,p_db_column_name=>'GROUP_DESC'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1387319348981748.4001)
,p_db_column_name=>'REFERENCED_PAGES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('P\00E1ginas con Referencia')
,p_column_link=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:RP,RIR:IR_GROUP_ID:#ID#'
,p_column_linktext=>'#REFERENCED_PAGES#'
,p_column_link_attr=>'title="View Assigned Pages"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1387701615981749.4001)
,p_db_column_name=>'PCT'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>'Porcentaje del Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1387801144981749.4001)
,p_db_column_name=>'PCT2'
,p_display_order=>6
,p_column_identifier=>'I'
,p_column_label=>unistr('Gr\00E1fico')
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(649534403931618327.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>17
,p_column_identifier=>'J'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(649534563483618328.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>27
,p_column_identifier=>'K'
,p_column_label=>'EDIT_LINK'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(649534613128618329.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>37
,p_column_identifier=>'L'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212834105872176627.4001)
,p_plug_name=>unistr('Grupos de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los grupos de p\00E1ginas ayudan a organizar las p\00E1ginas. Para utilizar grupos de p\00E1ginas, cree un grupo y, a continuaci\00F3n, as\00EDgnele p\00E1ginas.</p>'),
unistr('<p>Para crear un grupo de p\00E1ginas, haga clic en el bot\00F3n <strong>Crear</strong>.</p>'),
unistr('<p>Para editar un grupo de p\00E1ginas, haga clic en el nombre del grupo.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(213349321501259866.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(213192710092707758.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196747721437578989.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1386702222981723.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.:520,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15587428311356568.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1386702222981723.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:521::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(212870414132286994.4001)
,p_branch_action=>'f?p=&FLOW_ID.:520:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(215671022120022009.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'520'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00521
begin
wwv_flow_api.create_page(
 p_id=>521.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Grupo de P\00E1ginas')
,p_step_title=>unistr('Grupo de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212903908539395030)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1393403386406494.4001)
,p_plug_name=>unistr('P\00E1ginas Asignadas')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''"f?p=4000:4500:''||:app_session||''::NO::FB_FLOW_PAGE_ID:''||id edit_link,',
'        id,',
'        name,',
'      (select count(*) from wwv_flow_page_plugs where flow_id = p.flow_id and page_id = p.id) regions,',
'      decode(p.PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''unknown'') page_type,',
'        created_on,',
'        created_by,',
'        last_updated_on,',
'        last_updated_by',
'from wwv_flow_steps p,',
'      (select ',
'           wwv_flow_lang.system_message(''LOCKED'') locked,',
'           wwv_flow_lang.system_message(''RUN'') run,',
'           wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'           wwv_flow_lang.system_message(''REPORT'') apex_report,',
'           wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'           wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'           wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'           wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'           wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'           wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'           wwv_flow_lang.system_message(''HTML'') apex_html,',
'           wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'           wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'           wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'           wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'           wwv_flow_lang.system_message(''HOME'') apex_home,',
'           wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'           wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'           wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'           wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'           wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'           wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'           wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'           wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'           wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'           wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'           wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'           wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'           wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'           wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'       from dual)  sm',
'where flow_id = :fb_flow_id and ',
'      group_id = :p521_id and ',
'      security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P521_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1393503630406494.4001)
,p_name=>'Assigned Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1393725221406495.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1393832662406495.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1393910366406496.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1394008392406496.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1394125625406496.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1394900111423947.4001)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Tipo de P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1395031397423952.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Actualizado el'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1395124079423953.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1399220936458325.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1404823772988940.4001)
,p_name=>'Todos los Grupos'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select GROUP_NAME, ID',
'from   WWV_FLOW_PAGE_GROUPS ',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id',
'order  by group_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn grupo')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>4000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1405125117988946.4001)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de Grupo'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:521:P521_ID:#ID#'
,p_column_linktext=>'#GROUP_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1410901663136800.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212836709765187884.4001)
,p_plug_name=>unistr('Grupo de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_header=>unistr('<p>Los grupos de p\00E1ginas ayudan a organizar las p\00E1ginas. Cuando haya creado un grupo de p\00E1ginas, asigne p\00E1ginas al grupo.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 08-JUL-2004 19:41:27'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212849630160212045.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(212837507908187898.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(212837304346187886.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P521_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(212837226956187885.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P521_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(212837131436187885.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'P521_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(215489832392634392.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_button_name=>'GET_PREVIOUS_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(215489722982634392.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_button_name=>'GET_NEXT_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(212838811914187903.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(215493125969634418.4001)
,p_branch_action=>'f?p=&FLOW_ID.:521:&SESSION.::&DEBUG.::P521_ID:&P521_ID_NEXT.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(215489722982634392.4001)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(215493500892634420.4001)
,p_branch_action=>'f?p=&FLOW_ID.:521:&SESSION.::&DEBUG.::P521_ID:&P521_ID_PREV.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(215489832392634392.4001)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212839225443187910.4001)
,p_name=>'P521_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(212836709765187884.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212839625948187930.4001)
,p_name=>'P521_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(212836709765187884.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212840020341187932.4001)
,p_name=>'P521_GROUP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(212836709765187884.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212840818565187948.4001)
,p_name=>'P521_GROUP_DESC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(212836709765187884.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'GROUP_DESC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una descripci\00F3n para el grupo de p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(215491019029634401.4001)
,p_name=>'P521_ID_NEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(215491300319634403.4001)
,p_name=>'P521_ID_PREV'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(215491729195634405.4001)
,p_name=>'P521_ID_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(212849630160212045.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P521_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el grupo de p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(212840501756187945.4001)
,p_validation_name=>'P521_GROUP_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P521_GROUP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre de grupo debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(212840020341187932.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(212886724029342739.4001)
,p_validation_name=>'No references on delete'
,p_validation_sequence=>40
,p_validation=>'select 1 from wwv_flow_steps where group_id = :p521_id and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('No puede suprimir un grupo con p\00E1ginas a las que se hace referencia.')
,p_when_button_pressed=>wwv_flow_api.id(212837304346187886.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46079001348093234.4001)
,p_validation_name=>'Group Name not exists on create'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_page_groups',
' where upper(group_name) = upper(:P521_GROUP_NAME)',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'El nombre de grupo ya existe.'
,p_when_button_pressed=>wwv_flow_api.id(212837131436187885.4001)
,p_associated_item=>wwv_flow_api.id(212840020341187932.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(46079404250103546.4001)
,p_validation_name=>'Group name not exists on update'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_page_groups',
' where upper(group_name) = upper(:P521_GROUP_NAME)',
'   and id               != :P521_ID',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'El nombre de grupo ya existe.'
,p_when_button_pressed=>wwv_flow_api.id(212837226956187885.4001)
,p_associated_item=>wwv_flow_api.id(212840020341187932.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(378314007060530635.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P521_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(378314305555530635.4001)
,p_event_id=>wwv_flow_api.id(378314007060530635.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(215489832392634392.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(378314415718533153.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P521_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(378314720405533156.4001)
,p_event_id=>wwv_flow_api.id(378314415718533153.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(215489722982634392.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212841329374187955.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PAGE_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PAGE_GROUPS'
,p_attribute_03=>'P521_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_page_groups',
'where flow_id = :fb_flow_id',
'and id = :P521_ID'))
,p_process_when_type=>'EXISTS'
,p_process_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(215492723502634413.4001)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PAGE_GROUPS'
,p_attribute_03=>'P521_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'GROUP_NAME'
,p_attribute_09=>'P521_ID_NEXT'
,p_attribute_10=>'P521_ID_PREV'
,p_attribute_13=>'P521_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212841712158187958.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PAGE_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PAGE_GROUPS'
,p_attribute_03=>'P521_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_PAGE_GROUPS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212842106915187959.4001)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'521'
,p_process_when_button_id=>wwv_flow_api.id(212837304346187886.4001)
);
end;
/
prompt --application/pages/page_00522
begin
wwv_flow_api.create_page(
 p_id=>522.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Gestionar Asignaciones de Grupos de P\00E1ginas')
,p_step_title=>unistr('Gestionar Asignaciones de Grupos de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212903908539395030)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(95554303973076300.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196855022613956448.4001)
,p_plug_name=>unistr('P\00E1ginas de Grupo')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,wwv_flow_escape.html(id),''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'') id2,',
'       id, ',
'       name,',
'       LAST_UPDATED_BY, ',
'       LAST_UPDATED_ON, ',
'       ALIAS, ',
'      (select count(*) from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = p.id) regions,',
'      (select count(*) from wwv_flow_step_items where flow_id = :fb_flow_id and flow_step_id = p.id) items,',
'       group_id,',
'       decode(group_id,null,un.m,(select max(group_name) ',
'                                   from wwv_flow_page_groups',
'                                  where id = p.group_id)) Groupname',
'from  wwv_flow_steps p,',
'     (select wwv_flow_lang.system_message(''UNASSIGNED'') m from dual) un',
'where flow_id = :fb_flow_id    '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(196855119881956448.4001)
,p_name=>'Group Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855315410956450.4001)
,p_db_column_name=>'ID2'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855406400956492.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_link_attr=>'title="Edit Page Attributes"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855524810956493.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855829521956495.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196856121094956497.4001)
,p_db_column_name=>'GROUPNAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Grupo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196856032083956497.4001)
,p_db_column_name=>'ITEMS'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Elementos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855900555956496.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855623804956493.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'D'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196855700830956494.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480517709820029682.4001)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Grupo Seleccionado'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(216318823962281044.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(213192710092707758.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(216323604401313211.4001)
,p_plug_name=>unistr('Asignaciones de Grupos de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para reasignar p\00E1ginas a un grupo, seleccione un nuevo grupo, seleccione las p\00E1ginas que desea reasignar y haga clic en <strong>Asignar Selecci\00F3n</strong>. Para eliminar una p\00E1gina de un grupo de p\00E1ginas, seleccione <strong>Anular Asignaci\00F3n</stro')
||unistr('ng> y, a continuaci\00F3n, haga clic en <strong>Asignar Selecci\00F3n</strong>.</p>'),
'',
unistr('<p>Para ver s\00F3lo p\00E1ginas no asignadas, agregue un filtro en "Grupo = No Asignado" (haga clic en la cabecera de columna de Grupo y seleccione <strong>No Asignado</strong>).</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196858827071987424.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(95554303973076300.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:522,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95756919390305619.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(95554303973076300.4001)
,p_button_name=>'REASSIGN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Asignar Selecci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(212938926480478794.4001)
,p_branch_action=>'f?p=&FLOW_ID.:522:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(216980426199868369.4001)
,p_name=>'P522_NEW_GROUP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(95554303973076300.4001)
,p_prompt=>'Nuevo Grupo'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GROUP PICKER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Anular Asignaci\00F3n -')
,p_lov_null_value=>'0'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el grupo al que desea volver a asignar p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(216317711842277515.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'522'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(95835116507796728.4001)
,p_validation_name=>'Must have selected something'
,p_validation_sequence=>10
,p_validation=>'apex_application.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe realizar una selecci\00F3n para realizar esta acci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(95756919390305619.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199173576440878411.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(196855022613956448.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199173679889878412.4001)
,p_event_id=>wwv_flow_api.id(1199173576440878411.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212941413181481514.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216987406637900551.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reassign'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  p number;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   p := wwv_flow.g_f01(i);',
'   if :P522_NEW_GROUP = 0 then',
'      update wwv_flow_steps ',
'         set group_id = null',
'       where flow_id = :fb_flow_id ',
'         and id = p;',
'   else',
'      update wwv_flow_steps ',
'         set group_id = :P522_NEW_GROUP ',
'       where flow_id = :fb_flow_id ',
'         and id = p;',
'   end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido volver a asignar los grupos de p\00E1ginas.')
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if v(''REQUEST'') = ''REASSIGN'' and wwv_flow.g_f01.count > 0 then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Grupos de p\00E1ginas reasignados.')
);
end;
/
prompt --application/pages/page_00523
begin
wwv_flow_api.create_page(
 p_id=>523.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar'
,p_step_title=>'Exportar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30790121511720237.4001)
,p_plug_name=>'Exportar Archivos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Ahora pueden exportarse archivos desde componentes compartidos.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(30797216641778508.4001)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486267407482418521.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486269612723448359.4001)
,p_plug_name=>'Exportar'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(486268530815434681.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486293125572454998.4001)
,p_plug_name=>'Exportar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Exporte los metadatos de componente y aplicaci\00F3n a un archivo con formato de script SQL. Puede importar el script SQL en esta instancia'),
'o en otra instancia compatible de &PRODUCT_NAME.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486308512452288623.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(486307715596288607.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00525
begin
wwv_flow_api.create_page(
 p_id=>525.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_step_title=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(109507706670145855.4001)
,p_name=>unistr('Resumen de Protecci\00F3n de Estado de la Sesi\00F3n de Nivel de P\00E1gina')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 nvl(PROTECTION_LEVEL,''N'') Protection,',
'         count(*) c',
' from	 WWV_FLOW_STEPS p',
'where flow_id = :fb_flow_id',
'and p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109507930646145858.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Protecci\00F3n de Acceso a P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17255429593772638)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(109508023981145858.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Recuento de P\00E1ginas')
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109509332296153238.4001)
,p_plug_name=>unistr('Definir Atributos de Protecci\00F3n de Estado de la Sesi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_header=>unistr('<p>Utilice este asistente para activar o desactivar la protecci\00F3n de estado de la sesi\00F3n y definir los atributos de seguridad de p\00E1gina y elemento para toda la aplicaci\00F3n. Despu\00E9s de ejecutar el asistente, tambi\00E9n puede configurar los atributos de se')
||unistr('guridad de p\00E1gina y elemento de forma manual haciendo clic en el icono adecuado de la p\00E1gina Protecci\00F3n de Estado de la Sesi\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109643822089754956.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109642120442735590.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(110619630745303381.4001)
,p_name=>unistr('Resumen de Protecci\00F3n de Estado de la Sesi\00F3n de Elemento de P\00E1gina')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 flow_step_id "Page",',
'         nvl(PROTECTION_LEVEL,''N'') Protection,         ',
'         count(*) c',
' from	 WWV_FLOW_STEP_ITEMS p',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group by flow_step_id, nvl(PROTECTION_LEVEL,''N'')'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(110627826898349572.4001)
,p_query_column_id=>1
,p_column_alias=>'Page'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(110619823321303385.4001)
,p_query_column_id=>2
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(110619920413303385.4001)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Recuento de Elementos'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(110620605942305665.4001)
,p_name=>unistr('Resumen de Protecci\00F3n de Estado de la Sesi\00F3n de Elemento de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 nvl(PROTECTION_LEVEL,''N'') Protection, ',
'         count(*) c',
' from	 WWV_FLOW_ITEMS p',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(110620818361305666.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(110620907862305667.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Recuento de P\00E1ginas')
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110652627618576824.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n del Estado de Sesi\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207767015819710759.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747143286021138165.4001)
,p_plug_name=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109603504496189008.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207767015819710759.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109602624104185240.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(207767015819710759.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109617108632388982.4001)
,p_branch_action=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.:9006::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(109602624104185240.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ENABLE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(165640711850202360.4001)
,p_branch_action=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(109602624104185240.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ALL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109617727679394450.4001)
,p_branch_action=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(109602624104185240.4001)
,p_branch_sequence=>30
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'DISABLE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109611814342352710.4001)
,p_name=>'P525_LEVEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(109509332296153238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Seleccionar Acci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select page_protection_enabled_y_n e from wwv_flows where id = :FB_FLOW_ID) loop',
'  if nvl(c1.e,''N'') = ''N'' then',
'     return ''ENABLE'';',
'  else',
'     return ''DISABLE'';',
'  end if;',
'end loop;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'GLOBAL.SESSION.STATE.SECURITY'
,p_lov=>'.'||wwv_flow_api.id(109607612170295323.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La activaci\00F3n de la protecci\00F3n de estado de la sesi\00F3n es un proceso de dos pasos:'),
'<ol>',
unistr('<li>Activar la funci\00F3n</li>'),
unistr('<li>Configurar los atributos de seguridad de p\00E1gina y de elemento</li>'),
'</ol>',
unistr('Para Seleccionar Acci\00F3n, seleccione una de las siguientes opciones y haga clic en <strong>Siguiente</strong>:'),
'<ul>',
unistr('<li><strong>Desactivar</strong>: Desactiva la protecci\00F3n de estado de la sesi\00F3n. Tenga en cuenta que la desactivaci\00F3n de la protecci\00F3n de estado de la sesi\00F3n no afectar\00E1 a los atributos de seguridad de p\00E1gina y de elemento configurados anteriormente.'),
unistr('<li><strong>Activar</strong>: Activa la protecci\00F3n de estado de la sesi\00F3n. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento Protecci\00F3n de Estado de la Sesi\00F3n junto con los totales de c')
||unistr('ontrol colocados en las direcciones URL "f?p=" para impedir la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
unistr('<li><strong>Configurar</strong>: Configure los atributos de seguridad de p\00E1gina y de elemento y apl\00EDquelos a todas las p\00E1ginas y elementos de la aplicaci\00F3n.'),
unistr('<p><strong>Nota:</strong> Tambi\00E9n puede ajustar manualmente los atributos de seguridad de p\00E1gina y de elemento. Seleccione <strong>Activar</strong>, vuelva a la p\00E1gina Protecci\00F3n de Estado de la Sesi\00F3n y haga clic en el icono adecuado.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110654511127581587.4001)
,p_name=>'P525_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110652627618576824.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110655424286585398.4001)
,p_name=>'P525_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110652627618576824.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00527
begin
wwv_flow_api.create_page(
 p_id=>527.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Buscador de Consultas'
,p_step_title=>'Buscador de Consultas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch_query.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6282308008654572.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(478911017664917969.4001)
,p_plug_name=>'Regiones de consulta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>140
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id, p.name, r.plug_name region_name, r.plug_source',
'from wwv_flow_steps p, wwv_flow_page_plugs r',
'where p.flow_id = :fb_flow_id and',
'      r.flow_id = :fb_flow_id and',
'      p.id = r.page_id and',
'      plug_source_type in  ( ''NATIVE_CALENDAR'',''NATIVE_SQL_REPORT'',''NATIVE_TREE'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(478911116494917969.4001)
,p_name=>'Query Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478911321184917975.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::F4000_P273_PAGE:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478911400429917976.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478911507039917977.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(478911622794917978.4001)
,p_db_column_name=>'PLUG_SOURCE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Origen'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'CLOB'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(478918616313940219.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(478911017664917969.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:527:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(6283921499654577.4001)
,p_branch_action=>'f?p=&APP_ID.:527:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00528
begin
wwv_flow_api.create_page(
 p_id=>528.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('P\00E1ginas por Grupo de P\00E1ginas')
,p_step_title=>unistr('P\00E1ginas por Grupo de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212903908539395030)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196840002224844435.4001)
,p_plug_name=>unistr('Grupos de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       nvl(g.group_name,un.m) group_name, ',
'       p.id,',
'       g.id group_id,',
'       p.name name, ',
'       p.page_comment, ',
'       p.HELP_TEXT',
'from wwv_flow_page_groups g,',
'     wwv_flow_steps p,',
'     (select wwv_flow_lang.system_message(''UNASSIGNED'') m from dual) un',
'where (g.flow_id = :fb_flow_id or g.flow_id is null) and',
'      p.group_id = g.id (+) and',
'      p.flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(196840111859844435.4001)
,p_name=>'Page Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196840328486844440.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre de Grupo'
,p_column_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:RP,521:P521_ID:#GROUP_ID#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196840424148844512.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196840608981844513.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196840716490844514.4001)
,p_db_column_name=>'PAGE_COMMENT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>unistr('Comentario de P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196840809479844515.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Texto de Ayuda'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196840501275844513.4001)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>6
,p_column_identifier=>'C'
,p_column_label=>'Grupo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(213310716345102284.4001)
,p_plug_name=>unistr('Grupos de P\00E1ginas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los grupos de p\00E1ginas ayudan a organizar las p\00E1ginas.</p>'),
unistr('<p>Haga clic en el nombre del grupo para editar la definici\00F3n del grupo de p\00E1ginas.</p>'),
unistr('<p>Haga clic en el n\00FAmero de p\00E1gina para editar la p\00E1gina y asignar o volver a asignar un grupo de p\00E1ginas.</p>'),
unistr('<p>Haga clic en el nombre de la p\00E1gina para ver la definici\00F3n de p\00E1gina.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(213327732443177876.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(213192710092707758.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196839703719819869.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(196840002224844435.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:528:&SESSION.::&DEBUG.:528,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(213311932385102288.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(196840002224844435.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:RP,521::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(213313806698102303.4001)
,p_branch_action=>'f?p=&FLOW_ID.:528:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(213341230458234011.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'528'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00529
begin
wwv_flow_api.create_page(
 p_id=>529.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista: Confirmar'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44565501396171475.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169193619433715962.4001)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(169186610834587350.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(169206124346767265.4001)
,p_plug_name=>'Crear Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169194006430715963.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44565501396171475.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169194410384715965.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44565501396171475.4001)
,p_button_name=>'create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Lista'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(169194224414715965.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44565501396171475.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(169195408774738159.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(574135813665781514.4001)
,p_branch_name=>'Go To Page 440'
,p_branch_action=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(169194224414715965.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169204428408711688.4001)
,p_name=>'P529_DEPLOY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_prompt=>unistr('\00BFDesea crear regiones de lista?')
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST DEPLOYMENT P529'
,p_lov=>'.'||wwv_flow_api.id(169222400131754330.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si se va a crear o no una regi\00F3n de lista y, si es as\00ED, si se va a crear en la p\00E1gina actual o en cada p\00E1gina de destino.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169204609799711689.4001)
,p_name=>'P529_REGION_POSITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_prompt=>unistr('Posici\00F3n de Regi\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_DISPLAY_POINT'
,p_lov=>'.'||wwv_flow_api.id(131723061838.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Posici\00F3n de Visualizaci\00F3n -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la posici\00F3n de regi\00F3n de la nueva regi\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169206420964767273.4001)
,p_name=>'P529_ENTRY_LABEL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_source=>'wwv_flow_lang.system_message(''LIST_ENTRY_LABEL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169206614208767273.4001)
,p_name=>'P529_ENTRY_TARGET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_source=>'wwv_flow_lang.system_message(''TARGET_PAGE_ID_OR_CUSTOM_URL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169206812369767273.4001)
,p_name=>'P529_LIST_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_list_template from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'and default_list_template is not null) loop',
'',
'   return c1.default_list_template;',
'',
'end loop;',
'',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Lista:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Seleccione la plantilla de lista que desea utilizar para controlar el aspecto de la lista.</div>',
unistr('<div class="htmldbInfoBodyP">Puede especificar plantillas por defecto en la p\00E1gina Definir Tema.</div>')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169207712806767345.4001)
,p_name=>'P529_PAGE_01'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_01'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169207909437767345.4001)
,p_name=>'P529_ENTRY_NAME_02'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2'
,p_source=>'P440_ENTRY_NAME_02'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169208101824767345.4001)
,p_name=>'P529_PAGE_02'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_02'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169208303017767345.4001)
,p_name=>'P529_ENTRY_NAME_03'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3'
,p_source=>'P440_ENTRY_NAME_03'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169208503336767345.4001)
,p_name=>'P529_PAGE_03'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_03'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169208730806767346.4001)
,p_name=>'P529_ENTRY_NAME_04'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4'
,p_source=>'P440_ENTRY_NAME_04'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169208908580767346.4001)
,p_name=>'P529_PAGE_04'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_04'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169209109388767346.4001)
,p_name=>'P529_ENTRY_NAME_05'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5'
,p_source=>'P440_ENTRY_NAME_05'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169209315242767346.4001)
,p_name=>'P529_PAGE_05'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_05'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169209508319767347.4001)
,p_name=>'P529_ENTRY_NAME_01'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1'
,p_source=>'P440_ENTRY_NAME_01'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P440_ENTRY_NAME_01'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(169568028380027275.4001)
,p_name=>'P529_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(169206124346767265.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de regi\00F3n para la regi\00F3n nueva.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2238056824663815350.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'  from wwv_flow_steps p, wwv_flow_user_interfaces u',
' where p.flow_id = :FB_FLOW_ID ',
'   and p.id = :FB_FLOW_PAGE_ID',
'   and p.user_interface_id = u.id',
''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(184114421131098722.4001)
,p_validation_name=>'Region Position Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'P529_REGION_POSITION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('Se debe seleccionar una posici\00F3n de regi\00F3n.')
,p_validation_condition=>'P529_DEPLOY'
,p_validation_condition2=>'CURRENT_PAGE:EACH_ENTRY'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(169194410384715965.4001)
,p_associated_item=>wwv_flow_api.id(169204609799711689.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5394518734269553.4001)
,p_name=>'List Region Creation Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P529_DEPLOY'
,p_condition_element=>'P529_DEPLOY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CURRENT_PAGE,EACH_ENTRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5394821185269582.4001)
,p_event_id=>wwv_flow_api.id(5394518734269553.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_REGION_POSITION,P529_REGION_TEMPLATE,P529_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5395010939269586.4001)
,p_event_id=>wwv_flow_api.id(5394518734269553.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_REGION_POSITION,P529_REGION_TEMPLATE,P529_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574135629149781512.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(169194006430715963.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574135752063781513.4001)
,p_event_id=>wwv_flow_api.id(574135629149781512.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1542906604458063201.4001)
,p_name=>'Visibility of Entry 5 name/page pairs'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_05 is null and :P440_PAGE_05 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1542906723771063202.4001)
,p_event_id=>wwv_flow_api.id(1542906604458063201.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_05,P529_ENTRY_NAME_05'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1542906957334063204.4001)
,p_name=>'Visibility of Entry 4 name/page pairs'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_04 is null and :P440_PAGE_04 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1542907030718063205.4001)
,p_event_id=>wwv_flow_api.id(1542906957334063204.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_04,P529_ENTRY_NAME_04'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1542907141165063206.4001)
,p_name=>'Visibility of Entry 3 name/page pairs'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_03 is null and :P440_PAGE_03 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1542907270515063207.4001)
,p_event_id=>wwv_flow_api.id(1542907141165063206.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_03,P529_ENTRY_NAME_03'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1542907341144063208.4001)
,p_name=>'Visibility of Entry 2 name/page pairs'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_02 is null and :P440_PAGE_02 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1542907436600063209.4001)
,p_event_id=>wwv_flow_api.id(1542907341144063208.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_02,P529_ENTRY_NAME_02'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1542907554991063210.4001)
,p_name=>'Visibility of Entry 1 name/page pairs'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_01 is null and :P440_PAGE_01 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1542907627032063211.4001)
,p_event_id=>wwv_flow_api.id(1542907554991063210.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_01,P529_ENTRY_NAME_01'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169203919966699778.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_list (',
'    p_flow_id          => :FB_FLOW_ID,',
'    p_page_id          => :FB_FLOW_PAGE_ID,',
'    p_name             => :P427_NAME,',
'    p_entry_name_01    => :P440_ENTRY_NAME_01,',
'    p_page_01          => :P440_PAGE_01,',
'    p_entry_name_02    => :P440_ENTRY_NAME_02,',
'    p_page_02          => :P440_PAGE_02,',
'    p_entry_name_03    => :P440_ENTRY_NAME_03,',
'    p_page_03          => :P440_PAGE_03,',
'    p_entry_name_04    => :P440_ENTRY_NAME_04,',
'    p_page_04          => :P440_PAGE_04,',
'    p_entry_name_05    => :P440_ENTRY_NAME_05,',
'    p_page_05          => :P440_PAGE_05,',
'    p_deploy           => :P529_DEPLOY,',
'    p_region_template  => :P529_REGION_TEMPLATE,',
'    p_list_template_id => :P529_LIST_TEMPLATE_ID,',
'    p_region_position  => :P529_REGION_POSITION,',
'    p_required_patch   => :P427_REQUIRED_PATCH );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Lista Creada'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574135998446781515.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Lista Creada'
);
end;
/
prompt --application/pages/page_00533
begin
wwv_flow_api.create_page(
 p_id=>533.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Elementos de Aplicaci\00F3n')
,p_step_title=>unistr('Historial de Elementos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192553216982400527.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47807005066095922.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192553415132400529.4001)
,p_plug_name=>unistr('Historial de Elementos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los elementos de aplicaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192554027727400537.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4651a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'  ',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_ITEMS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192554218968400540.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192554510279400547.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192554616916400547.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192554819141400549.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192554930992400550.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192555104601400551.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192555225818400552.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192555315861400553.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192553818570400531.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192554027727400537.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:533:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00535
begin
wwv_flow_api.create_page(
 p_id=>535.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Opciones de Creaci\00F3n')
,p_step_title=>unistr('Historial de Opciones de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192561512772466675.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47909111131552473.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192561722239466675.4001)
,p_plug_name=>unistr('Historial de Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('En esta p\00E1gina se muestran las modificaciones recientes realizadas en las opciones de creaci\00F3n de esta aplicaci\00F3n.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192562308149466677.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PATCHES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192562531983466678.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192562802062466682.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192562917191466683.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192563131687466685.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192563231050466686.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192563427149466687.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192563520629466688.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192563625150466689.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192562107198466677.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192562308149466677.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:535:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00536
begin
wwv_flow_api.create_page(
 p_id=>536.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Secuencia de Entradas de Lista'
,p_step_title=>'Cambiar Secuencia de Entradas de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(170300908642409203.4001)
,p_plug_name=>'Cambiar Secuencia de Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_column=>false
,p_plug_header=>unistr('<p>Cambie la secuencia de las entradas de lista mediante el incremento en 10 de los n\00FAmeros de secuencia.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119156620289390629.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119156734376390630.4001)
,p_plug_name=>'Cambiar Secuencia de Entradas de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(170303107172430644.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119156620289390629.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Secuencia'
,p_button_position=>'NEXT'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(170302917215430643.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1119156620289390629.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(170305232284472776.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170301229074415090.4001)
,p_name=>'P536_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(170300908642409203.4001)
,p_prompt=>'Lista:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'from wwv_flow_lists',
'where flow_id = :FB_FLOW_ID',
'order by upper(name)'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(170302505441427237.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'resequence list entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c pls_integer := 0;',
'begin',
'   for c1 in (',
'      select id ',
'      from WWV_FLOW_LIST_ITEMS ',
'      where flow_id = :fb_flow_id and ',
'                list_id = :P536_LIST_ID and',
'                security_group_id = :flow_security_group_id',
'      order by nvl(PARENT_LIST_ITEM_ID,0), list_item_display_sequence, list_item_link_text',
'      ) loop',
'      c := c + 10;',
'      update WWV_FLOW_LIST_ITEMS ',
'      set list_item_display_sequence = c',
'      where list_id = :P536_LIST_ID and',
'                id = c1.id and',
'                flow_id = :fb_flow_id and',
'                security_group_id = :flow_security_group_id;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Se ha cambiado la secuencia de las entradas de lista'
);
end;
/
prompt --application/pages/page_00538
begin
wwv_flow_api.create_page(
 p_id=>538.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla: Nueva Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46427514677904461.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109555417045544112.4001)
,p_plug_name=>unistr('Copiar Plantilla de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110747909741657571.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222834001588317852.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109555620922544113.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46427514677904461.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109555716876544113.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46427514677904461.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109557727058544127.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(109555716876544113.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109556510763544120.4001)
,p_name=>'P538_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(109555417045544112.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109556901890544121.4001)
,p_name=>'P538_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(109555417045544112.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(109579809097849909.4001)
,p_name=>'P538_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(109555417045544112.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PLUG_TEMPLATE_NAME ',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where id = :P538_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1161094178658451301.4001)
,p_name=>'P538_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(109555417045544112.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(109582131738865990.4001)
,p_validation_name=>'P538_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P538_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla'
,p_when_button_pressed=>wwv_flow_api.id(109555716876544113.4001)
,p_associated_item=>wwv_flow_api.id(109556901890544121.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1161094454082451304.4001)
,p_validation_name=>'P538_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P538_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla'
,p_when_button_pressed=>wwv_flow_api.id(109555716876544113.4001)
,p_associated_item=>wwv_flow_api.id(1161094178658451301.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1161094552650451305.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_page_plug_templates ',
'         where id = :P538_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_page_plug_templates',
'            where page_plug_template_name = :P538_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(109556901890544121.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1161094692086451306.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_page_plug_templates ',
'         where id = :P538_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_page_plug_templates',
'            where internal_name = :P538_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1161094178658451301.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614714486149623631.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(109555620922544113.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614714782138623631.4001)
,p_event_id=>wwv_flow_api.id(614714486149623631.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1161094273110451302.4001)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P538_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1161094380805451303.4001)
,p_event_id=>wwv_flow_api.id(1161094273110451302.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P538_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P538_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(109557513697544124.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy region template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_PAGE_PLUG_TEMPLATES where id = :P538_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'#OWNER#.WWV_FLOW_TEMPLATES_UTIL.COPY_PLUG (',
'   P_COPY_FROM_FLOW_ID => :fb_flow_id,',
'   P_FLOW_ID => :fb_flow_id,',
'   P_FROM_TEMPLATE_ID => :P538_FROM_TEMPLATE_ID,',
'   P_TO_THEME_ID => c1.theme_id,',
'   P_TO_TEMPLATE_NAME => :P538_TO_TEMPLATE_NAME,',
'   P_TO_INTERNAL_NAME => :P538_TO_INTERNAL_NAME,',
'   P_TO_TEMPLATE_ID => wwv_flow.GET_UNIQUE_ID,',
'   P_SHOW_ERRORS =>false,',
'   p_include_subscription  =>false );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'La plantilla no se ha copiado correctamente.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(109555716876544113.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00540
begin
wwv_flow_api.create_page(
 p_id=>540.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Anular Suscripci\00F3n de Plantillas')
,p_step_title=>unistr('Anular Suscripci\00F3n de Plantillas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(95657215085793481.4001)
,p_plug_name=>unistr('Anular Suscripci\00F3n de Plantillas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_column=>false
,p_plug_header=>unistr('<p>Para cancelar la suscripci\00F3n de plantillas de un tipo de plantilla concreto del tema actual, seleccione el tipo de plantilla y haga clic en "Cancelar Suscripci\00F3n". Tenga en cuenta que los dem\00E1s temas no se ver\00E1n afectados. Una plantilla suscrita e')
||unistr('s una plantilla cuya definici\00F3n se mantiene en otra plantilla, la plantilla a la que se hace referencia.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231651032658843722.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747143348832138165.4001)
,p_plug_name=>unistr('Anular Suscripci\00F3n de Plantillas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95657928591797393.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(231651032658843722.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95658129017797394.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(231651032658843722.4001)
,p_button_name=>'unsubscribe'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Anular Suscripci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P540_THEME',
'and reference_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(95660031970817273.4001)
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(95658129017797394.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1449460519535055508.4001)
,p_branch_action=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95662614224831099.4001)
,p_name=>'P540_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(95657215085793481.4001)
,p_prompt=>'Tipo de Plantilla:'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TEMPLATE TYPES RETURNING NAME'
,p_lov=>'.'||wwv_flow_api.id(282026017647000169.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P540_THEME',
'and reference_id is null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione todos los tipos de plantilla para los que se va a anular la suscripci\00F3n y haga clic en <strong>Anular Suscripci\00F3n</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95684317874945672.4001)
,p_name=>'P540_THEME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(95657215085793481.4001)
,p_prompt=>'Tema:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tema -'
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica el tema de aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95788716292456120.4001)
,p_name=>'P540_APPLICATION'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(95657215085793481.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449460625642055509.4001)
,p_name=>'P540_THEME_IS_SUBSCRIBED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(95657215085793481.4001)
,p_prompt=>'Tema Suscrito'
,p_source=>'wwv_flow_lang.system_message(''THEME_IS_SUBSCRIBED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P540_THEME',
'and reference_id is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(95666219896842245.4001)
,p_validation_name=>'P540_TEMPLATE_TYPE'
,p_validation_sequence=>10
,p_validation=>'P540_TEMPLATE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos un tipo de plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(95658129017797394.4001)
,p_associated_item=>wwv_flow_api.id(95662614224831099.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(95660614093821619.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe All Templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if instr(:P540_TEMPLATE_TYPE,''PAGE'') > 0 then',
'   update WWV_FLOW_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''REGION'') > 0 then',
'   update WWV_FLOW_PAGE_PLUG_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''LABEL'') > 0 then',
'   update WWV_FLOW_FIELD_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''LIST'') > 0 then',
'   update WWV_FLOW_LIST_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''POPUP_LOV'') > 0 then',
'   update WWV_FLOW_POPUP_LOV_TEMPLATE set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''CALENDAR'') > 0 then',
'   update WWV_FLOW_CAL_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''MENU'') > 0 then',
'   update WWV_FLOW_MENU_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''BUTTON'') > 0 then',
'   update WWV_FLOW_BUTTON_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''REPORT'') > 0 then',
'   update WWV_FLOW_ROW_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flow_user_interfaces where flow_id = :fb_flow_id);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00541
begin
wwv_flow_api.create_page(
 p_id=>541.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar Diccionario de Atributos'
,p_step_title=>'Exportar Diccionario de Atributos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_ui_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486421024925175481.4001)
,p_plug_name=>'Exportar Valores por Defecto de Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Cuando se exporta el diccionario de atributos, todos los valores por defecto del espacio de trabajo se exportan a un \00FAnico archivo. Puede utilizar este archivo para importar a otra base de datos que tenga &PRODUCT_NAME. instalado.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486421408779175483.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486421604042175484.4001)
,p_plug_name=>'Exportar Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486423025422175486.4001)
,p_plug_name=>'Exportar Valores por Defecto de Interfaz de Usuario'
,p_region_css_classes=>'u-Border--bottom'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486428511661221024.4001)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(486427731138207743.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486421804255175484.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(486423025422175486.4001)
,p_button_name=>'EXPORT_ATTR_DICT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486423225837175487.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(486423025422175486.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:541::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(486424531039175511.4001)
,p_branch_action=>'f?p=&FLOW_ID.:541:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486422019475175485.4001)
,p_name=>'P541_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(486421604042175484.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486422523747175485.4001)
,p_name=>'P541_ATTR_DICT_COUNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(486421604042175484.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Recuento de Columnas:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) count_of_objects',
'  from wwv_flow_hnt_col_dict_syn',
' where security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('N\00FAmero de entradas del diccionario de atributos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486424302941175509.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'attr_dict_export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- set content disposition    ',
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'   ',
'wwv_flow_utilities.print_download_header(',
'    p_mime_type => ''application/x-sql'',',
'    p_is_attachment => true,',
'    p_file_name => lower(wwv_flow.get_company_name(p_escape => false))||''_attr_dict.sql''',
');',
'   ',
'    ',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export_attr_dict(',
'    p_format => :P541_FORMAT);',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al exportar el diccionario de atributos. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(486421804255175484.4001)
,p_process_success_message=>'Diccionario de Atributos exportado.'
);
end;
/
prompt --application/pages/page_00542
begin
wwv_flow_api.create_page(
 p_id=>542.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Lista Din\00E1mica')
,p_page_mode=>'NON_MODAL'
,p_step_title=>unistr('Crear Lista Din\00E1mica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'570'
,p_dialog_width=>'820'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1442429990800503.4001)
,p_plug_name=>unistr('Crear Lista Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754560176195487446.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754560286099487447.4001)
,p_plug_name=>unistr('Crear Lista Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1442832667800503.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(754560176195487446.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1442613116800503.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(754560176195487446.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1444716352800507.4001)
,p_branch_action=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1442832667800503.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1443018948800503.4001)
,p_name=>'P542_TABLE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1442429990800503.4001)
,p_prompt=>'Tabla o Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d,',
'       object_name r',
'  from sys.dba_objects',
' where object_type in (''TABLE'', ''VIEW'')',
'   and owner = :P542_OWNER',
' order by 1'))
,p_lov_cascade_parent_items=>'P542_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Tabla o vista en la que se basar\00E1 la consulta de lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET_FILTER'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1443511606800506.4001)
,p_name=>'P542_OWNER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1442429990800503.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Propietario -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('El propietario seleccionado por defecto para la tabla o la vista es el mismo propietario que se muestra para la aplicaci\00F3n. Si el propietario de la aplicaci\00F3n tiene privilegios SELECT sobre tablas o vistas en otros esquemas, puede seleccionar otro es')
||'quema de la lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1444010322800506.4001)
,p_name=>'P542_RETURN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1442429990800503.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1444326626800506.4001)
,p_validation_name=>'Does table/view exist'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner        = :P542_OWNER',
'   and object_name  = :P542_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>'La tabla o vista no existe.'
,p_validation_condition=>'P542_TABLE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(1442832667800503.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(754560565995487450.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1442613116800503.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(758615135297655701.4001)
,p_event_id=>wwv_flow_api.id(754560565995487450.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1444405527800507.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upper table name (if necessary)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select object_name',
'     from sys.dba_objects',
'    where object_type in (''TABLE'',''VIEW'')',
'      and object_name = upper(:P542_TABLE)',
'      and owner       = :P542_OWNER )',
'loop',
'    :P542_TABLE := c1.object_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(1442832667800503.4001)
,p_process_when=>':P542_TABLE <> upper(:P542_TABLE)'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00546
begin
wwv_flow_api.create_page(
 p_id=>546.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Rutas de Navegaci\00F3n')
,p_step_title=>unistr('Rutas de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213261028690930718)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30205218343531602.4001)
,p_plug_name=>unistr('Informe de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P546a */ id, ',
'       name, ',
'       ''icon-sc-breadcrumb'' icon_class,',
'       replace(replace(name,''_'','' ''),''.'','' '') icon_title,',
'       wwv_flow_page_api.get_url(',
'              p_page   => 104,',
'              p_clear_cache => 104,',
'              p_items  => ''P104_MENU_ID'',',
'              p_values => id) edit_link,',
'       (select count(*) c ',
'          from wwv_flow_menu_options ',
'         where flow_id = :FB_FLOW_ID',
'           and menu_id = m.id) count_of_options,',
'       menu_comment,',
'       last_updated_by updated_by,',
'       last_updated_on updated,',
'       created_by created_by,',
'       created_on created,',
'       wwv_flow_lang.system_message(''EDIT'') edit_text',
'  from wwv_flow_menus m',
' where m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30205316146531602.4001)
,p_name=>'Breadcrumb'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30205511791531605.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Editar'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30205609769531606.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:RP,104:P104_MENU_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30205709895531606.4001)
,p_db_column_name=>'COUNT_OF_OPTIONS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Recuento de Entradas'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30206609058551088.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30206702341551089.4001)
,p_db_column_name=>'MENU_COMMENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30206816211551089.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30206905717551089.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30207009517551089.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30207118361551089.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655628864775789336.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655670554953831545.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1000722229930503604.4001)
,p_db_column_name=>'EDIT_TEXT'
,p_display_order=>22
,p_column_identifier=>'M'
,p_column_label=>'EDIT_TEXT'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111620527557599389.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(111619820846587947.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227955428882937168.4001)
,p_plug_name=>unistr('Rutas de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las rutas de navegaci\00F3n proporcionan una navegaci\00F3n jer\00E1rquica hasta un n\00FAmero infinito de niveles. Tras crear una ruta de navegaci\00F3n, se pueden definir sus entradas. Para definir las entradas de la ruta de navegaci\00F3n, haga clic en el nombre de la')
||unistr(' ruta de navegaci\00F3n.</p>'),
'',
unistr('<p>Las entradas de la ruta de navegaci\00F3n se asocian a las p\00E1ginas y tambi\00E9n identifican una p\00E1gina principal. Las rutas de navegaci\00F3n se pueden mostrar en una p\00E1gina agregando una regi\00F3n de ruta de navegaci\00F3n mediante el asistente de creaci\00F3n de regi')
||'ones.</p>',
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/creating-breadcrumbs.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188944408169320872.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30205218343531602.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:546,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227954421264934980.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(30205218343531602.4001)
,p_button_name=>'CreateMenu'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Ruta de Navegaci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:288:&SESSION.::&DEBUG.:288::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(227952404295930008.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'546'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574153085992054444.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(227954421264934980.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574153354198054445.4001)
,p_event_id=>wwv_flow_api.id(574153085992054444.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00547
begin
wwv_flow_api.create_page(
 p_id=>547.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Elementos de P\00E1gina')
,p_step_title=>unistr('Elementos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12110822814570416.4001)
,p_plug_name=>unistr('Elementos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>140
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    p.id                            page_id,',
'    p.name                          page_name,',
'    --',
'    i.name                          item_name,',
'    i.display_as,',
'    i.ITEM_SEQUENCE                 display_sequence,',
'    (select plug_name',
'     from wwv_flow_page_plugs',
'     where id = i.ITEM_PLUG_ID)     region,',
'    i.item_plug_id                  region_id,',
'    --',
'    i.use_cache_before_default      source_used,',
'    i.ITEM_DEFAULT                  item_default,',
'    i.ITEM_DEFAULT_TYPE             item_default_type,',
'    --',
'    i.PROMPT                        label,',
'    i.PRE_ELEMENT_TEXT              pre_element_text,',
'    i.POST_ELEMENT_TEXT             post_element_text,',
'    i.FORMAT_MASK                   format_mask,',
'    (select template_name',
'     from   wwv_flow_field_templates',
'     where  id = to_char(i.ITEM_FIELD_TEMPLATE)',
'     and    flow_id = f.id)         item_label_template,',
'    i.ITEM_FIELD_TEMPLATE           item_label_template_id,',
'    i.SOURCE                        item_source,',
'    substr(i.source,1,50)           item_source_snipit,',
'    i.source_type                   item_source_type,',
'    i.SOURCE_POST_COMPUTATION       source_post_computation,',
'    -- read only conditionality',
'    i.read_only_when_type           read_only_condition_type,',
'    i.READ_ONLY_WHEN                read_only_condition_exp1,',
'    i.READ_ONLY_WHEN2               read_only_condition_exp2,',
'    i.READ_ONLY_DISP_ATTR           read_only_display_attr,',
'    --',
'    i.NAMED_LOV                     lov_named_lov,',
'    i.LOV                           lov_definition,',
'    i.lov_display_extra,',
'    i.lov_display_null,',
'    i.LOV_NULL_TEXT                 lov_null_text,',
'    i.LOV_NULL_VALUE                lov_null_value,',
'    i.lov_cascade_parent_items,',
'    i.ajax_items_to_submit          lov_items_to_submit,',
'    i.ajax_optimize_refresh         lov_optimize_refresh,',
'    --',
'    i.csize                         item_element_width,',
'    i.cmaxlength                    item_element_max_length,',
'    i.cheight                       item_element_height,',
'    --',
'    i.cattributes                   html_table_cell_attr_label,',
'    i.cattributes_element           html_table_cell_attr_element,',
'    i.tag_attributes                html_form_element_attributes,',
'    i.tag_attributes2               form_element_option_attributes,',
'    --',
'    i.button_image                  item_button_image,',
'    i.button_image_attr             item_button_image_attributes,',
'    --',
'    i.begin_on_new_line             begins_on_new_row,',
'    i.begin_on_new_field            begins_on_new_cell,',
'    i.COLSPAN                       column_span,',
'    i.ROWSPAN                       row_span,',
'    --',
'    i.label_alignment,',
'    i.field_alignment               item_alignment,',
'    --',
'    --i.FIELD_TEMPLATE,',
'    --',
'    i.display_when_type             condition_type,',
'    i.DISPLAY_WHEN                  condition_expression1,',
'    i.DISPLAY_WHEN2                 condition_expression2,',
'    --',
'    i.is_persistent                 maintain_session_state,',
'    nvl(i.protection_level, ''N'')    item_protection_level,',
'    --i.ESCAPE_ON_HTTP_INPUT',
'    i.escape_on_http_output,',
'    --',
'    decode(substr(i.SECURITY_SCHEME,1,1),''!'',''Not '')||',
'    nvl((select name',
'     from   wwv_flow_security_schemes',
'     where  to_char(id) = ltrim(i.SECURITY_SCHEME,''!'')',
'     and    flow_id = f.id),',
'     i.SECURITY_SCHEME)             authorization_scheme,',
'    i.security_scheme               authorization_scheme_id,',
'    (select case when p.required_patch > 0 then PATCH_NAME else ''{Not ''||PATCH_NAME||''}'' end PATCH_NAME',
'     from   wwv_flow_patches',
'     where  id =abs(i.REQUIRED_PATCH))   build_option,',
'    i.REQUIRED_PATCH                build_option_id,',
'    --',
'    (select max(help_text) h',
'    from wwv_flow_step_item_help',
'    where FLOW_ITEM_ID = i.id)      item_help_text,',
'    --',
'    i.LAST_UPDATED_BY               last_updated_by,',
'    i.LAST_UPDATED_ON               last_updated_on,',
'    i.ITEM_COMMENT                  component_comment,',
'    i.id                            item_id,',
'    nvl(i.encrypt_session_state_yn, ''N'') encrypt_state,',
'    nvl(p.autocomplete_on_off, ''ON'') autocomplete_on_off',
'from wwv_flow_step_items i,',
'     wwv_flow_steps p,',
'     wwv_flows f',
'where i.flow_step_id = p.id and',
'      i.flow_id = :fb_flow_id and',
'      i.security_group_id = :flow_security_group_id and',
'      i.flow_id = f.id and',
'      p.flow_id = i.flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(12110932631570416.4001)
,p_name=>'Page Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111122942570438.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111231401570438.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111315905570438.4001)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Elemento'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5120:#ITEM_ID#'
,p_column_linktext=>'#ITEM_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111400669570438.4001)
,p_db_column_name=>'DISPLAY_AS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Mostrar como'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(29353308376249352)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111617563570438.4001)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111714884570439.4001)
,p_db_column_name=>'REGION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111825516570439.4001)
,p_db_column_name=>'REGION_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Identificador de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12111932346570439.4001)
,p_db_column_name=>'SOURCE_USED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Origen Usado'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84930714296823567)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112009227570439.4001)
,p_db_column_name=>'ITEM_DEFAULT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Valor por Defecto de Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112108524570439.4001)
,p_db_column_name=>'ITEM_DEFAULT_TYPE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Tipo de Elemento por Defecto'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(38747715987262349)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112209093570439.4001)
,p_db_column_name=>'LABEL'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Etiqueta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112330730570440.4001)
,p_db_column_name=>'PRE_ELEMENT_TEXT'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Texto Anterior a Elemento '
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112421176570440.4001)
,p_db_column_name=>'POST_ELEMENT_TEXT'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Texto Posterior al Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112526405570440.4001)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('M\00E1scara de Formato')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112627315570440.4001)
,p_db_column_name=>'ITEM_LABEL_TEMPLATE'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Plantilla de Etiqueta de Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112706734570440.4001)
,p_db_column_name=>'ITEM_LABEL_TEMPLATE_ID'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Identificador de Plantilla de Etiqueta de Elemento'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112810096570440.4001)
,p_db_column_name=>'ITEM_SOURCE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Origen del Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12112917741570440.4001)
,p_db_column_name=>'ITEM_SOURCE_TYPE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Tipo de Origen de Elemento'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(129889837649)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113029451570441.4001)
,p_db_column_name=>'SOURCE_POST_COMPUTATION'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('C\00E1lculo Posterior de Origen')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113121033570441.4001)
,p_db_column_name=>'READ_ONLY_CONDITION_TYPE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Tipo de Condici\00F3n de S\00F3lo Lectura')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113214034570441.4001)
,p_db_column_name=>'READ_ONLY_CONDITION_EXP1'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>unistr('Expresi\00F3n de Condici\00F3n de S\00F3lo Lectura 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113319039570441.4001)
,p_db_column_name=>'READ_ONLY_CONDITION_EXP2'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>unistr('Expresi\00F3n de Condici\00F3n de S\00F3lo Lectura 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113401666570441.4001)
,p_db_column_name=>'READ_ONLY_DISPLAY_ATTR'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>unistr('Atributo de Visualizaci\00F3n de S\00F3lo Lectura')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113508556570441.4001)
,p_db_column_name=>'LOV_NAMED_LOV'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Nombre de Lista de Valores'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113608005570441.4001)
,p_db_column_name=>'LOV_DEFINITION'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>unistr('Definici\00F3n de Lista de Valores')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113803919570442.4001)
,p_db_column_name=>'LOV_DISPLAY_EXTRA'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Mostrar Extra de Lista de Valores'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12113931870570442.4001)
,p_db_column_name=>'LOV_DISPLAY_NULL'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'Mostrar Nulo de Lista de Valores'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114007219570442.4001)
,p_db_column_name=>'LOV_NULL_TEXT'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Texto Nulo de Lista de Valores'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114132755570442.4001)
,p_db_column_name=>'LOV_NULL_VALUE'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Valor Nulo de Lista de Valores'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455332720331039832.4001)
,p_db_column_name=>'LOV_CASCADE_PARENT_ITEMS'
,p_display_order=>32
,p_column_identifier=>'BN'
,p_column_label=>'Elementos Principales de Lista de Valores en Cascada'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455332830146039838.4001)
,p_db_column_name=>'LOV_ITEMS_TO_SUBMIT'
,p_display_order=>33
,p_column_identifier=>'BO'
,p_column_label=>unistr('Elementos de P\00E1gina que Ejecutar')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455332917730039839.4001)
,p_db_column_name=>'LOV_OPTIMIZE_REFRESH'
,p_display_order=>34
,p_column_identifier=>'BP'
,p_column_label=>'Optimizar Refrescamiento'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114309836570443.4001)
,p_db_column_name=>'ITEM_ELEMENT_WIDTH'
,p_display_order=>36
,p_column_identifier=>'AG'
,p_column_label=>'Ancho de Elemento'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114415498570443.4001)
,p_db_column_name=>'ITEM_ELEMENT_MAX_LENGTH'
,p_display_order=>37
,p_column_identifier=>'AH'
,p_column_label=>unistr('Longitud M\00E1xima de Elemento')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114524688570444.4001)
,p_db_column_name=>'ITEM_ELEMENT_HEIGHT'
,p_display_order=>38
,p_column_identifier=>'AI'
,p_column_label=>'Altura de Elemento'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114617506570444.4001)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_LABEL'
,p_display_order=>39
,p_column_identifier=>'AJ'
,p_column_label=>'Etiqueta de Atributo de Celda de Tabla HTML'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114714129570444.4001)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_ELEMENT'
,p_display_order=>40
,p_column_identifier=>'AK'
,p_column_label=>'Elemento de Atributo de Celda de Tabla HTML'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114822645570444.4001)
,p_db_column_name=>'HTML_FORM_ELEMENT_ATTRIBUTES'
,p_display_order=>41
,p_column_identifier=>'AL'
,p_column_label=>'Atributos de Elemento de Pantalla HTML'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12114932615570444.4001)
,p_db_column_name=>'FORM_ELEMENT_OPTION_ATTRIBUTES'
,p_display_order=>42
,p_column_identifier=>'AM'
,p_column_label=>unistr('Atributos de Opci\00F3n de Elemento de Pantalla')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115022733570444.4001)
,p_db_column_name=>'ITEM_BUTTON_IMAGE'
,p_display_order=>43
,p_column_identifier=>'AN'
,p_column_label=>unistr('Imagen de Bot\00F3n de Elemento')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115114407570445.4001)
,p_db_column_name=>'ITEM_BUTTON_IMAGE_ATTRIBUTES'
,p_display_order=>44
,p_column_identifier=>'AO'
,p_column_label=>unistr('Atributos de Imagen de Bot\00F3n de Elemento')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115208792570445.4001)
,p_db_column_name=>'BEGINS_ON_NEW_ROW'
,p_display_order=>45
,p_column_identifier=>'AP'
,p_column_label=>'Empieza en la Nueva Fila'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115331998570445.4001)
,p_db_column_name=>'BEGINS_ON_NEW_CELL'
,p_display_order=>46
,p_column_identifier=>'AQ'
,p_column_label=>'Empieza en la Nueva Celda'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115403021570445.4001)
,p_db_column_name=>'COLUMN_SPAN'
,p_display_order=>47
,p_column_identifier=>'AR'
,p_column_label=>unistr('Ampliaci\00F3n de Columna')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115500878570445.4001)
,p_db_column_name=>'ROW_SPAN'
,p_display_order=>48
,p_column_identifier=>'AS'
,p_column_label=>unistr('Ampliaci\00F3n de Fila')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115628426570445.4001)
,p_db_column_name=>'LABEL_ALIGNMENT'
,p_display_order=>49
,p_column_identifier=>'AT'
,p_column_label=>unistr('Alineaci\00F3n de Etiqueta')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84757522618851451)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115721795570446.4001)
,p_db_column_name=>'ITEM_ALIGNMENT'
,p_display_order=>50
,p_column_identifier=>'AU'
,p_column_label=>unistr('Alineaci\00F3n de Elemento')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84354125395660958)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115807735570446.4001)
,p_db_column_name=>'CONDITION_TYPE'
,p_display_order=>51
,p_column_identifier=>'AV'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12115920411570446.4001)
,p_db_column_name=>'CONDITION_EXPRESSION1'
,p_display_order=>52
,p_column_identifier=>'AW'
,p_column_label=>unistr('Expresi\00F3n de Condici\00F3n 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116004438570446.4001)
,p_db_column_name=>'CONDITION_EXPRESSION2'
,p_display_order=>53
,p_column_identifier=>'AX'
,p_column_label=>unistr('Expresi\00F3n de Condici\00F3n 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116106198570446.4001)
,p_db_column_name=>'MAINTAIN_SESSION_STATE'
,p_display_order=>54
,p_column_identifier=>'AY'
,p_column_label=>unistr('Mantener Estado de Sesi\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84831517957313758)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116223562570446.4001)
,p_db_column_name=>'ITEM_PROTECTION_LEVEL'
,p_display_order=>55
,p_column_identifier=>'AZ'
,p_column_label=>unistr('Nivel de Protecci\00F3n de Elemento')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(109261519627066371)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116306373570447.4001)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>56
,p_column_identifier=>'BA'
,p_column_label=>unistr('Esquema de Autorizaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116425780570447.4001)
,p_db_column_name=>'AUTHORIZATION_SCHEME_ID'
,p_display_order=>57
,p_column_identifier=>'BB'
,p_column_label=>unistr('Identificador de Esquema de Autorizaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116527637570447.4001)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>58
,p_column_identifier=>'BC'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116613636570447.4001)
,p_db_column_name=>'BUILD_OPTION_ID'
,p_display_order=>59
,p_column_identifier=>'BD'
,p_column_label=>unistr('Identificador de Opci\00F3n de Creaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116719660570447.4001)
,p_db_column_name=>'ITEM_HELP_TEXT'
,p_display_order=>60
,p_column_identifier=>'BE'
,p_column_label=>'Texto de Ayuda de Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116825412570447.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>61
,p_column_identifier=>'BF'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12116924744570447.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>62
,p_column_identifier=>'BG'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12117018439570448.4001)
,p_db_column_name=>'COMPONENT_COMMENT'
,p_display_order=>63
,p_column_identifier=>'BH'
,p_column_label=>'Comentario de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12117127466570448.4001)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>64
,p_column_identifier=>'BI'
,p_column_label=>'Item ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13188827647940806.4001)
,p_db_column_name=>'ITEM_SOURCE_SNIPIT'
,p_display_order=>65
,p_column_identifier=>'BJ'
,p_column_label=>'Fragmento de Origen de Elemento'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15464926815520489.4001)
,p_db_column_name=>'ENCRYPT_STATE'
,p_display_order=>66
,p_column_identifier=>'BK'
,p_column_label=>'Cifrar Estado'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15605905604510826.4001)
,p_db_column_name=>'AUTOCOMPLETE_ON_OFF'
,p_display_order=>67
,p_column_identifier=>'BL'
,p_column_label=>unistr('Terminaci\00F3n Autom\00E1tica de Pantalla')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(9165706597746719)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450279831685422527.4001)
,p_db_column_name=>'ESCAPE_ON_HTTP_OUTPUT'
,p_display_order=>68
,p_column_identifier=>'BM'
,p_column_label=>'Caracteres especiales de escape'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47958212730593623.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194140607497096059.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(12110822814570416.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:547:&SESSION.::&DEBUG.:547,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231107911777474051.4001)
,p_branch_action=>'f?p=&FLOW_ID.:547:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(94966214009865985.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'547'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(231108818356475936.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00548
begin
wwv_flow_api.create_page(
 p_id=>548.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Botones de P\00E1gina')
,p_step_title=>unistr('Botones de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15359803954507631.4001)
,p_plug_name=>unistr('Botones por P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''F4000.BUTTON'') button_type,',
'id, FLOW_STEP_ID page, ',
'BUTTON_SEQUENCE, ',
'(select plug_name from wwv_flow_page_plugs where id = b.button_plug_id) BUTTON_PLUG_ID, ',
'(select PAGE_PLUG_TEMPLATE_NAME from wwv_flow_page_plug_templates where flow_id = :fb_flow_id and id = (select PLUG_TEMPLATE from wwv_flow_page_plugs where id = b.button_plug_id)) region_template,',
'BUTTON_NAME, ',
'button_name request_value,',
'substr(button_image_alt,1,60) BUTTON_IMAGE_ALT,',
'decode(substr(button_image,1,8),''template'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) template_based,',
'--',
'(select template_name from WWV_FLOW_BUTTON_TEMPLATES where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id and id = ',
'b.button_template_id) template_id,',
'--',
'decode(button_image,null,''template'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) html_based,',
'decode(substr(button_image,1,8),''template'',null,button_image,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') image_based,',
'BUTTON_POSITION,',
'substr(button_redirect_url,1,500) BUTTON_REDIRECT_URL, ',
'decode(button_condition_type,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') BUTTON_CONDITION_TYPE, ',
'BUTTON_IMAGE_ATTRIBUTES, ',
'BUTTON_CATTRIBUTES, ',
'wwv_flow_lang.system_message(database_action) DATABASE_ACTION',
'from WWV_FLOW_STEP_BUTTONS b',
'where flow_id = :fb_flow_id and',
'security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(15359928141507631.4001)
,p_name=>'Buttons by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360209862507641.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360427120507641.4001)
,p_db_column_name=>'BUTTON_PLUG_ID'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360316864507641.4001)
,p_db_column_name=>'BUTTON_SEQUENCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360503932507642.4001)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5130:#ID#'
,p_column_linktext=>'#BUTTON_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360611428507642.4001)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Valor de Solicitud'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360718865507642.4001)
,p_db_column_name=>'BUTTON_IMAGE_ALT'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Etiqueta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361124068507643.4001)
,p_db_column_name=>'BUTTON_POSITION'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>unistr('Posici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361221580507643.4001)
,p_db_column_name=>'BUTTON_REDIRECT_URL'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>'Destino'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361332741507643.4001)
,p_db_column_name=>'BUTTON_CONDITION_TYPE'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361410303507643.4001)
,p_db_column_name=>'BUTTON_IMAGE_ATTRIBUTES'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Atributos de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361507374507643.4001)
,p_db_column_name=>'BUTTON_CATTRIBUTES'
,p_display_order=>11
,p_column_identifier=>'O'
,p_column_label=>'Atributos'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361601817507643.4001)
,p_db_column_name=>'DATABASE_ACTION'
,p_display_order=>12
,p_column_identifier=>'P'
,p_column_label=>unistr('Acci\00F3n de Base de Datos')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360127192507639.4001)
,p_db_column_name=>'ID'
,p_display_order=>13
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360815188507642.4001)
,p_db_column_name=>'TEMPLATE_BASED'
,p_display_order=>14
,p_column_identifier=>'H'
,p_column_label=>'Basado en Plantilla'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15360918941507642.4001)
,p_db_column_name=>'HTML_BASED'
,p_display_order=>15
,p_column_identifier=>'I'
,p_column_label=>'Basado en HTML'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15361026800507642.4001)
,p_db_column_name=>'IMAGE_BASED'
,p_display_order=>16
,p_column_identifier=>'J'
,p_column_label=>'Basado en Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193801811724292700.4001)
,p_db_column_name=>'BUTTON_TYPE'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>unistr('Tipo de Bot\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452287026429811718.4001)
,p_db_column_name=>'TEMPLATE_ID'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Plantilla de Bot\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(452294801607012758.4001)
,p_db_column_name=>'REGION_TEMPLATE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Plantilla de Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47960120957614972.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193799112576179451.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15359803954507631.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.:548,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(619286312340140864.4001)
,p_computation_sequence=>30
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'548'
);
end;
/
prompt --application/pages/page_00549
begin
wwv_flow_api.create_page(
 p_id=>549.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('C\00E1lculos por P\00E1gina')
,p_step_title=>unistr('C\00E1lculos por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193747111445072199.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193747615970081181.4001)
,p_plug_name=>unistr('C\00E1lculos por P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID, ',
'FLOW_STEP_ID page, ',
'COMPUTATION_SEQUENCE, ',
'COMPUTATION_ITEM, ',
'COMPUTATION_POINT, ',
'COMPUTATION, ',
'decode(wwv_flow_escape.html(COMPUTE_WHEN),null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') COMPUTE_WHEN ',
'from WWV_FLOW_STEP_COMPUTATIONS pc',
'where flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193747726257081181.4001)
,p_name=>'Computations by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193748007358081206.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193748115094081206.4001)
,p_db_column_name=>'COMPUTATION_SEQUENCE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193748222735081207.4001)
,p_db_column_name=>'COMPUTATION_ITEM'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Elemento'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5520:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193748328195081208.4001)
,p_db_column_name=>'COMPUTATION_POINT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>unistr('Punto de C\00E1lculo')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193748410997081209.4001)
,p_db_column_name=>'COMPUTATION'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>unistr('C\00E1lculo')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193748510253081210.4001)
,p_db_column_name=>'COMPUTE_WHEN'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193747927406081201.4001)
,p_db_column_name=>'ID'
,p_display_order=>7
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193749009629090584.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193747615970081181.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:549,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(619285316665104248.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'549'
);
end;
/
prompt --application/pages/page_00552
begin
wwv_flow_api.create_page(
 p_id=>552.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Procesos por P\00E1gina')
,p_step_title=>unistr('Procesos por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193860811817416442.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193862432598433906.4001)
,p_plug_name=>unistr('Procesos por P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'FLOW_STEP_ID page, ',
'"PROCESS_SEQUENCE", ',
'"PROCESS_POINT", ',
'wwv_flow_region_layout.get_process_type_desc(flow_id, PROCESS_TYPE) as process_type, ',
'"PROCESS_NAME", ',
'sys.dbms_lob.substr("PROCESS_SQL_CLOB",4000,1) "PROCESS_SQL_CLOB", ',
'decode(PROCESS_WHEN,null,n.a,y.a)  PROCESS_WHEN',
'from WWV_FLOW_STEP_PROCESSING,',
'  (select wwv_flow_lang.system_message(''YES'') a from dual) y,',
'  (select wwv_flow_lang.system_message(''NO'') a from dual) n',
'where flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193862517844433906.4001)
,p_name=>'Processes by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(617358829232197012.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'H'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193862708951433912.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193863130809433919.4001)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>12
,p_column_identifier=>'E'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5530:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193862901272433917.4001)
,p_db_column_name=>'PROCESS_POINT'
,p_display_order=>22
,p_column_identifier=>'C'
,p_column_label=>'Punto de Proceso'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(842344044)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193862808000433916.4001)
,p_db_column_name=>'PROCESS_SEQUENCE'
,p_display_order=>32
,p_column_identifier=>'B'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193863001697433918.4001)
,p_db_column_name=>'PROCESS_TYPE'
,p_display_order=>42
,p_column_identifier=>'D'
,p_column_label=>'Tipo de Proceso'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193863222112433920.4001)
,p_db_column_name=>'PROCESS_SQL_CLOB'
,p_display_order=>52
,p_column_identifier=>'F'
,p_column_label=>'Origen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193863314225433921.4001)
,p_db_column_name=>'PROCESS_WHEN'
,p_display_order=>62
,p_column_identifier=>'G'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193863903206442285.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193862432598433906.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:552:&SESSION.::&DEBUG.:552,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(617488128059287518.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'552'
);
end;
/
prompt --application/pages/page_00553
begin
wwv_flow_api.create_page(
 p_id=>553.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilidades de P\00E1gina Cruzada')
,p_step_title=>unistr('Utilidades de P\00E1gina Cruzada')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492634805116616309.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492635405537616318.4001)
,p_plug_name=>unistr('Utilidades de P\00E1gina Cruzada')
,p_icon_css_classes=>'icon-page-form-summary'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_api.id(492636810051679904.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_column_width=>'apex-col--rightBorder'
);
end;
/
prompt --application/pages/page_00554
begin
wwv_flow_api.create_page(
 p_id=>554.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Esquema de Autenticaci\00F3n')
,p_step_title=>unistr('Historial de Esquemas de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192762122423723510.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(180433926348108856.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192762325780723514.4001)
,p_plug_name=>unistr('Historial de Esquemas de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los elementos de aplicaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192762927286723522.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_AUTHENTICATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192763109168723524.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192763430042723585.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192763524356723585.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192763714398723587.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192763822315723588.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192764014783723589.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192764112624723590.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192764207475723591.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192762705997723518.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192762927286723522.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:554:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00556
begin
wwv_flow_api.create_page(
 p_id=>556.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Entradas de Listas de Valores Condicionales'
,p_step_title=>'Entradas de Listas de Valores Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188103509886859601.4001)
,p_plug_name=>'Entradas de Listas de Valores Condicionales'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_VALUE as "LOV_DISP_VALUE",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_RETURN_VALUE as "LOV_RETURN_VALUE",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA".ID as "ID",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND_TYPE as "LOV_DISP_COND_TYPE",',
'	 "WWV_FLOW_LISTS_OF_VALUES$".LOV_NAME as "LOV_NAME",',
'	 "WWV_FLOW_LISTS_OF_VALUES$".FLOW_ID as "FLOW_ID" ,',
'         "WWV_FLOW_LISTS_OF_VALUES$".ID as LOV_ID,',
'         "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND,',
'         "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND2',
' from	 "WWV_FLOW_LISTS_OF_VALUES$" "WWV_FLOW_LISTS_OF_VALUES$",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA" "WWV_FLOW_LIST_OF_VALUES_DATA" ',
' where   WWV_FLOW_LIST_OF_VALUES_DATA.LOV_ID=WWV_FLOW_LISTS_OF_VALUES$.ID',
'   and   "WWV_FLOW_LISTS_OF_VALUES$".flow_id = :fb_flow_id',
'   and   "WWV_FLOW_LISTS_OF_VALUES$".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_OF_VALUES_DATA".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND_TYPE is not null',
'order by upper(LOV_NAME)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(188103615005859601.4001)
,p_name=>'Conditional Lists of Values Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104014311859606.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104212995859608.4001)
,p_db_column_name=>'LOV_NAME'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>'Lista de Valores'
,p_column_link=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:RP,4111:F4000_P4111_ID:#LOV_ID#'
,p_column_linktext=>'#LOV_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104110367859607.4001)
,p_db_column_name=>'LOV_DISP_COND_TYPE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188103821806859604.4001)
,p_db_column_name=>'LOV_DISP_VALUE'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>unistr('Valor de Visualizaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188103914727859605.4001)
,p_db_column_name=>'LOV_RETURN_VALUE'
,p_display_order=>5
,p_column_identifier=>'B'
,p_column_label=>'Valor de Retorno'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104332635859609.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104419805859609.4001)
,p_db_column_name=>'LOV_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104516997859610.4001)
,p_db_column_name=>'LOV_DISP_COND'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188104632274859611.4001)
,p_db_column_name=>'LOV_DISP_COND2'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188105211356867235.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188990508324007825.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(188103509886859601.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:556:&SESSION.::&DEBUG.:556,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188101031311832358.4001)
,p_branch_action=>'f?p=&FLOW_ID.:556:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(188100804422832355.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(188990508324007825.4001)
);
end;
/
prompt --application/pages/page_00557
begin
wwv_flow_api.create_page(
 p_id=>557.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Entradas de Lista Condicionales'
,p_step_title=>'Entradas de Lista Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188107132231881664.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188111004901892263.4001)
,p_plug_name=>'Entradas de Lista Condicionales'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P557a */ "WWV_FLOW_LISTS".NAME as "LIST_NAME",',
'	 "WWV_FLOW_LISTS".ID as "ID",',
'	 "WWV_FLOW_LISTS".FLOW_ID as "application",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_LINK_TEXT as "entry",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_COND_TYPE as "condition_type",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_CONDITION as "Expression1",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_COND_TYPE2 as "Expression2" ',
' from	 "WWV_FLOW_LIST_ITEMS" "WWV_FLOW_LIST_ITEMS",',
'	 "WWV_FLOW_LISTS" "WWV_FLOW_LISTS" ',
' where   WWV_FLOW_LIST_ITEMS.LIST_ID=WWV_FLOW_LISTS.ID',
'   and   "WWV_FLOW_LISTS".FLOW_ID = :fb_flow_id',
'   and   "WWV_FLOW_LISTS".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_ITEMS".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_COND_TYPE is not null',
'order by upper("WWV_FLOW_LISTS".NAME),',
'         upper("WWV_FLOW_LIST_ITEMS".LIST_ITEM_LINK_TEXT)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(188111124623892263.4001)
,p_name=>'Conditional List Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111331233892264.4001)
,p_db_column_name=>'LIST_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre de la Lista'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:RP,4050:F4000_P4050_LIST_ID:#ID#'
,p_column_linktext=>'#LIST_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111429105892265.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111504602892266.4001)
,p_db_column_name=>'application'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111628781892267.4001)
,p_db_column_name=>'entry'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Entrada'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111727076892268.4001)
,p_db_column_name=>'condition_type'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111832343892268.4001)
,p_db_column_name=>'Expression1'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188111906894892316.4001)
,p_db_column_name=>'Expression2'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188940401365902669.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(188111004901892263.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:557:&SESSION.::&DEBUG.:557,RIR::'
,p_grid_new_row=>'Y'
);
end;
/
prompt --application/pages/page_00558
begin
wwv_flow_api.create_page(
 p_id=>558.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Esquema de Autorizaci\00F3n')
,p_step_title=>unistr('Historial de Esquemas de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192781327431809021.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(180462022520306486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192781522471809024.4001)
,p_plug_name=>unistr('Historial de Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los esquemas de autorizaci\00F3n de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(192782107490809027.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SECURITY_SCHEMES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(192782318329809028.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192782400829809029.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192782518580809029.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192782623046809030.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192782721898809033.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192782826848809034.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192782907987809035.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(192783006661809035.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(192781924503809026.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(192782107490809027.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:558:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00559
begin
wwv_flow_api.create_page(
 p_id=>559.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Objetos Sugeridos'
,p_step_title=>'Objetos Sugeridos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(488391710691971044)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_required_role=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486477814565732399.4001)
,p_plug_name=>'Objeto Sugerido'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486525815907379320.4001)
,p_plug_name=>'Form Fields'
,p_parent_plug_id=>wwv_flow_api.id(486477814565732399.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486480816002736007.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486485109777809939.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los usuarios pueden escribir informes personalizados, as\00ED como utilizar etiquetas SQL en los objetos de base de datos del esquema asociado a este espacio de trabajo. El hecho de identificar una vista o tabla de base de datos como un objeto sugerid')
||unistr('o facilita la escritura de SQL, ya que muestra las columnas de vista y tabla en la p\00E1gina de ayuda.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(486513724462249401.4001)
,p_name=>'Objetos Sugeridos Existentes'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name,',
'       object_comment',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :P933_ID',
' order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No hay objetos asociados.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(486514119934249410.4001)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre del Objeto'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492659607495019741.4001)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_COMMENT'
,p_column_display_sequence=>2
,p_column_heading=>'Comentario'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486478305042732402.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(486480816002736007.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:933:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486478014071732401.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(486480816002736007.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'P559_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(498692515529982765.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(486480816002736007.4001)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'CREATE'
,p_button_condition=>'P559_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486478227917732401.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(486480816002736007.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P559_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486478125910732401.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(486480816002736007.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_condition=>'P559_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(498692811158990943.4001)
,p_branch_action=>'f?p=&APP_ID.:559:&SESSION.:CREATE_AGAIN:&DEBUG.:559::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(498692515529982765.4001)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(486479032107732409.4001)
,p_branch_action=>'f?p=&APP_ID.:933:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486479228636732412.4001)
,p_name=>'P559_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(486525815907379320.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486479622583732430.4001)
,p_name=>'P559_OBJECT_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(486525815907379320.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre del Objeto'
,p_source=>'OBJECT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name || '' '' || wwv_flow_lang.system_message(''TABLE_IN_PAREN'') d,',
'       table_name r',
'  from sys.dba_tables',
' where owner = :P559_DEFAULT_SCHEMA',
'   and table_name not like ''BIN$%''',
'union',
'select view_name || '' '' || wwv_flow_lang.system_message(''VIEW_IN_PAREN'') d,',
'       view_name r',
'  from sys.dba_views',
' where owner = :P559_DEFAULT_SCHEMA',
'union',
'select synonym_name || '' '' || wwv_flow_lang.system_message(''SYNONYM_IN_PAREN'') d,',
'       synonym_name r',
'  from sys.dba_synonyms',
' where owner = :P559_DEFAULT_SCHEMA',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>128
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre de la tabla, vista o sin\00F3nimo al que pueda acceder f\00E1cilmente el m\00E9todo de acceso SQL en esta aplicaci\00F3n. Est\00E1 restringido a los objetos que sean propiedad del esquema en el que se encuentren los objetos de base de datos de la h')
||unistr('oja de c\00E1lculo web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492456121387576234.4001)
,p_name=>'P559_DEFAULT_SCHEMA'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(486525815907379320.4001)
,p_prompt=>'Esquema:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Esquema propietario de los objetos de base de datos de hoja de c\00E1lculo web y que debe ser propietario de cualquier objeto sugerido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492617832468279523.4001)
,p_name=>'P559_OBJECT_COMMENT'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(486525815907379320.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'OBJECT_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Comentarios sobre los datos del objeto y motivo por el que resulta de utilidad para la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1579145556317404872.4001)
,p_name=>'P559_WS_APP_ID'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(486525815907379320.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P933_ID.'
,p_source=>'WS_APP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486479808524732437.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WS_APP_SUG_OBJECTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APP_SUG_OBJECTS'
,p_attribute_03=>'P559_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and ws_app_id = :P933_ID'))
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492593706626931474.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set default schema'
,p_process_sql_clob=>':P559_DEFAULT_SCHEMA := wwv_flow_ws_setup.get_apex$_schema (p_workspace_id=>:flow_security_group_id);'
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486480020204732441.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WS_APP_SUG_OBJECTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APP_SUG_OBJECTS'
,p_attribute_03=>'P559_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and ws_app_id = :P933_ID'))
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'No se ha podido procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486480232397732441.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'559'
,p_process_when_button_id=>wwv_flow_api.id(486478227917732401.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(504764532604617983.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update ALLOW_SQL_YN to Y'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_ws_applications ',
'set ALLOW_SQL_YN = ''Y''',
'where id = :P933_ID',
'and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_fnd boolean := false;',
'begin',
'    for c1 in (select null',
'               from wwv_flow_ws_applications',
'               where allow_sql_yn = ''N''',
'               and id = :P933_ID',
'               and security_group_id = :WORKSPACE_ID)',
'    loop',
'        l_fnd := true;',
'    end loop;',
'',
'     return l_fnd and :REQUEST in (''CREATE'',''CREATE_AGAIN'',''SAVE'');',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00562
begin
wwv_flow_api.create_page(
 p_id=>562.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Visualizaci\00F3n Condicional de Separadores')
,p_step_title=>unistr('Visualizaci\00F3n Condicional de Separadores')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188149320078131278.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188149714542131280.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(188151202342139045.4001)
,p_name=>'Conditional Tabs'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P562a */ FLOW_ID,',
'	 ID ,',
'	 TAB_NAME,',
'	 DISPLAY_CONDITION_TYPE,',
'	 TAB_PLSQL_CONDITION,',
'	 TAB_DISP_COND_TEXT ',
' from "WWV_FLOW_TABS" "WWV_FLOW_TABS"',
'where flow_id = :fb_flow_id',
'  and security_group_id = :flow_security_group_id',
'  and DISPLAY_CONDITION_TYPE is not null'))
,p_display_when_condition=>'P562_COMPONENT'
,p_display_when_cond2=>'TAB'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn separador condicional')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188151429707139046.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'FLOW_ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188151502822139046.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188151630537139046.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188151722185139046.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_CONDITION_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tipo de Condici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(13602414170805697)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188151808887139047.4001)
,p_query_column_id=>5
,p_column_alias=>'TAB_PLSQL_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Expresi\00F3n 1')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188151901610139047.4001)
,p_query_column_id=>6
,p_column_alias=>'TAB_DISP_COND_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Expresi\00F3n 2')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(188152006498140208.4001)
,p_name=>'Conditional Parent Tabs'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P562b */ FLOW_ID,',
'	 ID ,',
'	 TAB_NAME,',
'	 DISPLAY_CONDITION_TYPE,',
'	 display_condition,',
'	 display_condition2 ',
' from	 wwv_flow_toplevel_tabs',
'where    flow_id = :fb_flow_id',
'   and   DISPLAY_CONDITION_TYPE is not null'))
,p_display_when_condition=>'P562_COMPONENT'
,p_display_when_cond2=>'PTAB'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn separador principal condicional')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188152227119140210.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'FLOW_ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188152301973140210.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188152410140140210.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Separador Principal'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188152517902140210.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_CONDITION_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tipo de Condici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(13602414170805697)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188152619955140210.4001)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Expresi\00F3n 1')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(188152729042140210.4001)
,p_query_column_id=>6
,p_column_alias=>'DISPLAY_CONDITION2'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Expresi\00F3n 2')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188154729139156192.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(188149714542131280.4001)
,p_button_name=>'P562_GO'
,p_button_static_id=>'P562_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(188152815848142898.4001)
,p_name=>'P562_COMPONENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(188149714542131280.4001)
,p_item_default=>'TAB'
,p_prompt=>'Tipo de Separador'
,p_source=>'LOV'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHARED COMPONENT CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(179567005218713166.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Mostrar por tipo de separador. Seleccione un tipo y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00563
begin
wwv_flow_api.create_page(
 p_id=>563.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Bifurcaciones por P\00E1gina')
,p_step_title=>unistr('Bifurcaciones por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194574019399976291.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11286824340344465.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194575422626987750.4001)
,p_plug_name=>unistr('Bifurcaciones por P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'FLOW_STEP_ID page, ',
'BRANCH_ACTION, ',
'BRANCH_POINT,',
'BRANCH_TYPE, ',
'BRANCH_SEQUENCE,',
'branch_name,',
'decode(wwv_flow_escape.html(BRANCH_CONDITION_TYPE),null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'')  BRANCH_CONDITION_TYPE',
'from WWV_FLOW_STEP_BRANCHES',
'where flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194575528691987750.4001)
,p_name=>'Branches by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(617485826580230363.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194575702472987754.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194575917406987756.4001)
,p_db_column_name=>'BRANCH_POINT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Punto de Bifurcaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194576118400987757.4001)
,p_db_column_name=>'BRANCH_SEQUENCE'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Secuencia'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_SEQUENCE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194576012426987757.4001)
,p_db_column_name=>'BRANCH_TYPE'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Tipo de Bifurcaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194575803480987755.4001)
,p_db_column_name=>'BRANCH_ACTION'
,p_display_order=>6
,p_column_identifier=>'B'
,p_column_label=>unistr('Acci\00F3n de Bifurcaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194576228284987758.4001)
,p_db_column_name=>'BRANCH_CONDITION_TYPE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(16750604761338328.4001)
,p_db_column_name=>'BRANCH_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Nombre de la sucursal'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194574410346978279.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194575422626987750.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:563:&SESSION.::&DEBUG.:563,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(617488515031293282.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'563'
);
end;
/
prompt --application/pages/page_00564
begin
wwv_flow_api.create_page(
 p_id=>564.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132904725516756515.4001)
,p_plug_name=>'Copiar Plantilla de Calendario'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132905109741756522.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207957624673902588.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222839726971457622.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(132905320737756523.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207957624673902588.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(132905505502756525.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(207957624673902588.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(132907331656756546.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(132905505502756525.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(132905719442756528.4001)
,p_name=>'P564_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(132904725516756515.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(132905924965756533.4001)
,p_name=>'P564_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(132904725516756515.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME',
'from WWV_FLOW_CAL_TEMPLATES',
'where id = :P564_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(132906410349756535.4001)
,p_name=>'P564_TO_TEMPLATE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(132904725516756515.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(757097392290899235.4001)
,p_name=>'P564_TO_INTERNAL_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(132904725516756515.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre del nuevo identificador de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(132906916630756539.4001)
,p_validation_name=>'P564_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P564_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(132905505502756525.4001)
,p_associated_item=>wwv_flow_api.id(132906410349756535.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(757097645831899238.4001)
,p_validation_name=>'P564_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P564_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(132905505502756525.4001)
,p_associated_item=>wwv_flow_api.id(757097392290899235.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(757097753569899239.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_cal_templates ',
'         where id = :P564_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_cal_templates',
'            where name = :P564_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(132906410349756535.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(757097803039899240.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_cal_templates ',
'         where id = :P564_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_cal_templates',
'            where internal_name = :P564_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(757097392290899235.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614717174753668461.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(132905320737756523.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614717407419668462.4001)
,p_event_id=>wwv_flow_api.id(614717174753668461.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(757097490235899236.4001)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P564_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(757097588796899237.4001)
,p_event_id=>wwv_flow_api.id(757097490235899236.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P564_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P564_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(132907106372756541.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Calendar Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id ',
'           from WWV_FLOW_CAL_TEMPLATES',
'           where id = :P564_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'    wwv_flow_templates_util.copy_calendar_template (',
'       p_copy_from_flow_id   => :FB_FLOW_ID,',
'       p_flow_id             => :FB_FLOW_ID,',
'       p_from_template_id    => :P564_FROM_TEMPLATE_ID,',
'       p_to_template_name    => :P564_TO_TEMPLATE_NAME,',
'       p_to_internal_name    => :P564_TO_INTERNAL_NAME,',
'       p_to_template_id      => wwv_flow.GET_UNIQUE_ID,',
'       p_to_theme_id         => c1.theme_id,',
'       p_include_subscription  =>false ',
'    );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(132905505502756525.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00567
begin
wwv_flow_api.create_page(
 p_id=>567.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Mensajes de Objetos de Soporte'
,p_step_title=>'Mensajes de Objetos de Soporte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8621301534284477.4001)
,p_plug_name=>unistr('Confirmaci\00F3n')
,p_region_name=>'CONFIRMATION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8621702960284479.4001)
,p_plug_name=>'Mensajes'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8621925857284480.4001)
,p_plug_name=>'Bienvenido'
,p_region_name=>'WELCOME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8622329958284481.4001)
,p_plug_name=>'Licencia'
,p_region_name=>'LICENSE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8622520399284481.4001)
,p_plug_name=>'Validaciones'
,p_region_name=>'VALIDATIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>165
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8622723142284482.4001)
,p_plug_name=>unistr('Postinstalaci\00F3n')
,p_region_name=>'POST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8623100529284484.4001)
,p_plug_name=>unistr('Desinstalaci\00F3n')
,p_region_name=>'DEINSTALL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>250
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8946512814035107.4001)
,p_plug_name=>unistr('Sustituciones de Aplicaci\00F3n')
,p_region_name=>'CONFIG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>155
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22481913873307004.4001)
,p_plug_name=>'Supporting Object Definition tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24426910798903348.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>180
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35832602590067354.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_name=>'BUILDOPTIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46239524385678972.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57743832572752130.4001)
,p_plug_name=>'Actualizar'
,p_region_name=>'UPGRADE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>230
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8624000324284489.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8621702960284479.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8624404341284491.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8621702960284479.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P567_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8632831286284538.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(8624000324284489.4001)
,p_branch_sequence=>21
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(396481798906910874.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29775621294204175.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(8624404341284491.4001)
,p_branch_sequence=>41
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8624809729284492.4001)
,p_name=>'P567_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(8621702960284479.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8625421128284497.4001)
,p_name=>'P567_WELCOME_MESSAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(8621925857284480.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.WELCOME_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje'
,p_source=>'WELCOME_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'stretch'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Despu\00E9s de una importaci\00F3n e instalaci\00F3n correcta de una definici\00F3n de aplicaci\00F3n, el asistente de instalaci\00F3n le solicitar\00E1 que instale los objetos de soporte para la aplicaci\00F3n.<p /> Utilice este mensaje para introducir la aplicaci\00F3n y describir la')
||unistr('s acciones de los archivos de comandos de instalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8625605364284503.4001)
,p_name=>'P567_LICENSE_MESSAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(8622329958284481.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mensaje'
,p_source=>'LICENSE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Si la utilizaci\00F3n de esta aplicaci\00F3n exige que el usuario acepte una licencia, introd\00FAzcala aqu\00ED. Se solicitar\00E1 al usuario que acepte el mensaje antes de instalar objetos de base de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8625820270284504.4001)
,p_name=>'P567_VALIDATION_MESSAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(8622520399284481.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.VALIDATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje'
,p_source=>'VALIDATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 encima de la lista de validaciones de instalaci\00F3n cuando se instale esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8626009286284504.4001)
,p_name=>'P567_INSTALL_MESSAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(8621301534284477.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje'
,p_source=>'INSTALL_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 durante la confirmaci\00F3n de la instalaci\00F3n, antes de que se ejecuten los archivos de comandos de instalaci\00F3n y se apliquen las opciones de configuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8626207893284505.4001)
,p_name=>'P567_INSTALL_SUCCESS_MESSAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(8622723142284482.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje Correcto de Instalaci\00F3n')
,p_source=>'INSTALL_SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 despu\00E9s de que todos los archivos de comandos de instalaci\00F3n se hayan ejecutado sin errores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8626416202284508.4001)
,p_name=>'P567_INSTALL_FAILURE_MESSAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(8622723142284482.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje de Fallo de Instalaci\00F3n')
,p_source=>'INSTALL_FAILURE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 despu\00E9s de que los archivos de comandos de instalaci\00F3n se hayan ejecutado con errores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8631213639284522.4001)
,p_name=>'P567_DEINSTALL_MESSAGE'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(8623100529284484.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje de Desinstalaci\00F3n')
,p_source=>'DEINSTALL_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 durante la confirmaci\00F3n de desinstalaci\00F3n cuando se desinstale esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8631423719284523.4001)
,p_name=>'P567_DEINSTALL_SUCCESS_MESSAGE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(8623100529284484.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.DEINSTALL_SUCCESS_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Mensaje Posterior a la Desinstalaci\00F3n')
,p_source=>'DEINSTALL_SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 tras ejecutar todos los archivos de comandos de desinstalaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8947811214044111.4001)
,p_name=>'P567_CONFIGURATION_MESSAGE'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(8946512814035107.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.CONFIGURATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje'
,p_source=>'CONFIGURATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 encima de las peticiones de datos de sustituci\00F3n de aplicaci\00F3n cuando se instale esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19106518608937289.4001)
,p_name=>'P567_BUILD_OPTIONS_MESSAGE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(35832602590067354.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.BUILD_OPTIONS_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje'
,p_source=>'BUILD_OPTIONS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 sobre las peticiones de datos de opci\00F3n de creaci\00F3n cuando se instale esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29798324598318647.4001)
,p_name=>'P567_BRANCH_PAGE'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(8621702960284479.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57747725907769185.4001)
,p_name=>'P567_UPGRADE_MESSAGE'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(57743832572752130.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.UPGRADE_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje de Bienvenida'
,p_source=>'UPGRADE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca un mensaje de bienvenida para que se muestre antes de actualizar los objetos de soporte de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58009829276413400.4001)
,p_name=>'P567_UPGRADE_SUCCESS_MESSAGE'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(57743832572752130.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.SUCCESS_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje Correcto'
,p_source=>'UPGRADE_SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 despu\00E9s de que todos los archivos de comandos de actualizaci\00F3n se hayan ejecutado sin errores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58013429753423014.4001)
,p_name=>'P567_UPGRADE_FAILURE_MESSAGE'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(57743832572752130.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(''INSTALLER.FAILURE_MESSAGE'')',
''))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mensaje de Fallo'
,p_source=>'UPGRADE_FAILURE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 despu\00E9s de que los archivos de comandos de actualizaci\00F3n se hayan ejecutado con errores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58015111877427365.4001)
,p_name=>'P567_UPGRADE_CONFIRM_MESSAGE'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(57743832572752130.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Mensaje de Confirmaci\00F3n')
,p_source=>'UPGRADE_CONFIRM_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el mensaje que se mostrar\00E1 durante la confirmaci\00F3n de la actualizaci\00F3n, antes de que se ejecuten los archivos de comandos de actualizaci\00F3n y se apliquen las opciones de configuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(396481578653893676.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(8631817178284524.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8632005234284527.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P567_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8632223977284528.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P567_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00568
begin
wwv_flow_api.create_page(
 p_id=>568.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla: Nueva Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46425823288878522.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110567702071443926.4001)
,p_plug_name=>unistr('Copiar Plantilla de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110747005585656313.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222837515412444820.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110568114205443944.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46425823288878522.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110568323589443952.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46425823288878522.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(110569514100444023.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(110568323589443952.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(477696101755867210.4001)
,p_branch_action=>'f?p=&APP_ID.:568:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110568523931443956.4001)
,p_name=>'P568_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110567702071443926.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110568717548443973.4001)
,p_name=>'P568_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110567702071443926.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME template_name ',
'from WWV_FLOW_TEMPLATES',
'where id = :P568_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110568918785443976.4001)
,p_name=>'P568_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(110567702071443926.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1004723881239877702.4001)
,p_name=>'P568_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(110567702071443926.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(110569110472443993.4001)
,p_validation_name=>'P568_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P568_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110568323589443952.4001)
,p_associated_item=>wwv_flow_api.id(110568918785443976.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004724149508877705.4001)
,p_validation_name=>'P568_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P568_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla.'
,p_associated_item=>wwv_flow_api.id(1004723881239877702.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004724235484877706.4001)
,p_validation_name=>'Unique Name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_templates ',
'         where id = :P568_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_templates',
'            where name = :P568_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1004723881239877702.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004724304426877707.4001)
,p_validation_name=>'Unique Identifier'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_templates ',
'         where id = :P568_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_templates',
'            where internal_name = :P568_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1004723881239877702.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614712992772570985.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(110568114205443944.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614713265814570986.4001)
,p_event_id=>wwv_flow_api.id(614712992772570985.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1004723949030877703.4001)
,p_name=>'Set internal name'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P568_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1004724030717877704.4001)
,p_event_id=>wwv_flow_api.id(1004723949030877703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P568_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P568_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110569307931444012.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Page Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_TEMPLATES where id = :P568_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'   wwv_flow_templates_util.copy_template (',
'      p_copy_from_flow_id    => :fb_flow_id,',
'      p_flow_id              => :fb_flow_id,',
'      p_from_template_id     => :P568_FROM_TEMPLATE_ID,',
'      p_to_template_name     => :P568_TO_TEMPLATE_NAME,',
'      p_to_internal_name     => :P568_TO_INTERNAL_NAME,       ',
'      p_to_template_id       => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id          => c1.theme_id,',
'      p_include_subscription => false',
'      );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'La plantilla no se ha copiado correctamente.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(110568323589443952.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00569
begin
wwv_flow_api.create_page(
 p_id=>569.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46429329269937057.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110587312216553035.4001)
,p_plug_name=>'Copiar Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110666510995648435.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222838705500451466.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110587707162553038.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46429329269937057.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110587919455553040.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46429329269937057.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(110589111730553046.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110588119329553041.4001)
,p_name=>'P569_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110587312216553035.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110588309615553042.4001)
,p_name=>'P569_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110587312216553035.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ROW_TEMPLATE_NAME',
'from WWV_FLOW_ROW_TEMPLATES',
'where id = :P569_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110588501576553042.4001)
,p_name=>'P569_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(110587312216553035.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1161094889250451308.4001)
,p_name=>'P569_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(110587312216553035.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(110588719302553043.4001)
,p_validation_name=>'P569_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P569_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla'
,p_when_button_pressed=>wwv_flow_api.id(110587919455553040.4001)
,p_associated_item=>wwv_flow_api.id(110588501576553042.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1161094757245451307.4001)
,p_validation_name=>'P569_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P569_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla'
,p_when_button_pressed=>wwv_flow_api.id(110587919455553040.4001)
,p_associated_item=>wwv_flow_api.id(1161094889250451308.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1161094970121451309.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_row_templates ',
'         where id = :P569_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_row_templates',
'            where row_template_name = :P569_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(110588501576553042.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1161095036285451310.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_row_templates ',
'         where id = :P569_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_row_templates',
'            where internal_name = :P569_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1161094889250451308.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614715233612636470.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(110587707162553038.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614715514807636470.4001)
,p_event_id=>wwv_flow_api.id(614715233612636470.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1161095172523451311.4001)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P569_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1161095253248451312.4001)
,p_event_id=>wwv_flow_api.id(1161095172523451311.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P569_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P569_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110588923073553044.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Report Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_ROW_TEMPLATES where id = :P569_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
' wwv_flow_templates_util.copy_row_template (',
'    p_copy_from_flow_id   => :fb_flow_id,',
'    p_to_flow_id          => :FB_FLOW_ID,',
'    p_from_template_id    => :P569_FROM_TEMPLATE_ID,',
'    p_to_template_name    => :P569_TO_TEMPLATE_NAME,',
'    p_to_internal_name    => :P569_TO_INTERNAL_NAME,',
'    p_to_template_id      => wwv_flow.GET_UNIQUE_ID,',
'    p_to_theme_id         => c1.theme_id,',
'    p_include_subscription => false',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(110587919455553040.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00571
begin
wwv_flow_api.create_page(
 p_id=>571.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla: Nueva Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46419117373649718.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110864501590722331.4001)
,p_plug_name=>unistr('Copiar Plantilla de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110864903742722334.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222840721908465677.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110865102559722335.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46419117373649718.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110865330989722335.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46419117373649718.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(110867112968722342.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(110865330989722335.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110865521391722336.4001)
,p_name=>'P571_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110864501590722331.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110865708782722336.4001)
,p_name=>'P571_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110864501590722331.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TEMPLATE_NAME',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where id = :P571_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110866224704722339.4001)
,p_name=>'P571_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(110864501590722331.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1004725142395877715.4001)
,p_name=>'P571_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(110864501590722331.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre del nuevo identificador de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(110866728222722340.4001)
,p_validation_name=>'P571_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P571_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110865330989722335.4001)
,p_associated_item=>wwv_flow_api.id(110866224704722339.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004725443634877718.4001)
,p_validation_name=>'P571_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P571_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110865330989722335.4001)
,p_associated_item=>wwv_flow_api.id(1004725142395877715.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1007564351086031503.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_button_templates ',
'         where id = :P571_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_button_templates',
'            where template_name = :P571_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(110866224704722339.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1007564450842031504.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_button_templates ',
'         where id = :P571_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_button_templates',
'            where internal_name = :P571_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1004725142395877715.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614716214717663476.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(110865102559722335.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614716549773663476.4001)
,p_event_id=>wwv_flow_api.id(614716214717663476.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1004725263558877716.4001)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P571_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1004725323925877717.4001)
,p_event_id=>wwv_flow_api.id(1004725263558877716.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P571_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P571_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110866924321722341.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Button Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id ',
'           from WWV_FLOW_BUTTON_TEMPLATES ',
'           where id = :P571_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'    wwv_flow_templates_util.copy_button_template (',
'      p_copy_from_flow_id  => :fb_flow_id,',
'      p_flow_id            => :FB_FLOW_ID,',
'      p_from_template_id   => :P571_FROM_TEMPLATE_ID,',
'      p_to_template_name   => :P571_TO_TEMPLATE_NAME,',
'      p_to_internal_name   => :P571_TO_INTERNAL_NAME,',
'      p_to_template_id     => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id        => c1.theme_id,',
'      p_include_subscription  =>false );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'La plantilla no se ha copiado correctamente.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(110865330989722335.4001)
,p_process_success_message=>unistr('Plantilla de bot\00F3n copiada.')
);
end;
/
prompt --application/pages/page_00572
begin
wwv_flow_api.create_page(
 p_id=>572.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1ginas de control de acceso')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1ginas de control de acceso')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24935825160088375)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_acc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8683003615386510.4001)
,p_plug_name=>'Crear Control de Acceso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Este asistente crea p\00E1ginas para gestionar una lista de control de acceso. Utilice el componente compartido Application Access Control para asociar los roles de la aplicaci\00F3n a los usuarios de la misma. Este asistente tambi\00E9n agrega un rol de <str')
||unistr('ong>lector</strong>, de <strong>contribuyente</strong> y de <strong>administrador</strong>, as\00ED como un esquema de autorizaci\00F3n correspondiente a la aplicaci\00F3n. Aplique estos esquemas de autorizaci\00F3n a las p\00E1ginas y componentes de p\00E1gina para gestion')
||'ar el acceso por usuario y por rol.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Terri - Updated Header Text to adhere to Oracle Style. Removed references to the two tables that are created. It''s in the App Builder User''s Guide, "How Access Control Works."'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(59662218332417742.4001)
,p_plug_name=>'Crear Separador'
,p_parent_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(59661629762417740.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(59662218332417742.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P572_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(54227918011229738.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(54228315226229739.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(54228723180229739.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(54229189603229739.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(979488861935772822.4001)
,p_plug_name=>'Create List Entry'
,p_parent_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44610009033325069.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8683628773386514.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44610009033325069.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8683805819386516.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44610009033325069.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279435611403263589.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44610009033325069.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(100574840201284406.4001)
,p_branch_action=>'f?p=&APP_ID.:575:&SESSION.::&DEBUG.:RP,575::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548800697841882440.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279435611403263589.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8685700067386531.4001)
,p_name=>'P572_ADMIN_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 100, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54224099360229735.4001)
,p_name=>'P572_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(59662218332417742.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54224953519229735.4001)
,p_name=>'P572_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(59662218332417742.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54225876288229737.4001)
,p_name=>'P572_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(59662218332417742.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54226777928229737.4001)
,p_name=>'P572_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(59662218332417742.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P572_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P572_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54230366604232620.4001)
,p_name=>'P572_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(979488861935772822.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54231223646232622.4001)
,p_name=>'P572_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(979488861935772822.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54231609099232622.4001)
,p_name=>'P572_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(979488861935772822.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54232518111232622.4001)
,p_name=>'P572_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(979488861935772822.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when_type=>'NEVER'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54233472361232623.4001)
,p_name=>'P572_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(979488861935772822.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P572_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54234371003232623.4001)
,p_name=>'P572_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(979488861935772822.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P572_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183322228918962193.4001)
,p_name=>'P572_BUILD_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.ACCESS_CONTROL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403321768585284066.4001)
,p_name=>'P572_GROUP_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(688505071411608708.4001)
,p_name=>'P572_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de p\00E1gina inicial')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado. Esta funci\00F3n crear\00E1 varias p\00E1ginas que empiecen por el n\00FAmero especificado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 10, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(688505187143608709.4001)
,p_name=>'P572_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n, a la que se ha agregado una lista, para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(688505278692608710.4001)
,p_name=>'P572_ADMIN_PAGE_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(688505392654608711.4001)
,p_name=>'P572_EXISTING_PAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(8683003615386510.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que se utiliza como p\00E1gina de administraci\00F3n en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1941077982091597347.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_lang.system_message(''WS_ACCESS_CONTROL'');'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(688509042728608748.4001)
,p_computation_sequence=>10
,p_computation_item=>'P572_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688506933307608727.4001)
,p_validation_name=>'P572_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>10
,p_validation=>'P572_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(688505071411608708.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(275642313343510001.4001)
,p_validation_name=>'P572_STARTING_PAGE_ID reserved'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P572_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P572_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(688505071411608708.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(484178723959534634.4001)
,p_validation_name=>'P572_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>40
,p_validation=>'P572_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(8685700067386531.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688507153431608729.4001)
,p_validation_name=>'P572_ADMIN_PAGE_ID not null'
,p_validation_sequence=>50
,p_validation=>'P572_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(8685700067386531.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231172981311226020.4001)
,p_validation_name=>'P572_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P572_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P572_ADMIN_PAGE_OPTION = ''NEW''',
'and :P572_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(8685700067386531.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57926092508361532.4001)
,p_validation_name=>'P572_STARTING_PAGE_ID and P572_ADMIN_PAGE_ID different'
,p_validation_sequence=>80
,p_validation=>':P572_STARTING_PAGE_ID <> :P572_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina inicial y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688507275343608730.4001)
,p_validation_name=>'P572_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>90
,p_validation=>'P572_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(688505278692608710.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688507396563608731.4001)
,p_validation_name=>'P572_EXISTING_PAGE not null'
,p_validation_sequence=>100
,p_validation=>'P572_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(688505392654608711.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231171552720226006.4001)
,p_validation_name=>'P572_EXISTING_PAGE available'
,p_validation_sequence=>110
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P572_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P572_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P572_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(688505392654608711.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688509187662608749.4001)
,p_validation_name=>'P572_TAB_SET not null'
,p_validation_sequence=>120
,p_validation=>'P572_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(54224953519229735.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688509256594608750.4001)
,p_validation_name=>'P572_TAB_LABEL not null'
,p_validation_sequence=>130
,p_validation=>'P572_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(54225876288229737.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57826825676033901.4001)
,p_validation_name=>'P572_TAB_NAME not null'
,p_validation_sequence=>140
,p_validation=>'P572_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(54226777928229737.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57826959794033902.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P572_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P572_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(54230366604232620.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827041602033903.4001)
,p_validation_name=>'P572_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>160
,p_validation=>'P572_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P572_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(54231609099232622.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57839268074068376.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>170
,p_validation=>'P572_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P572_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(8683805819386516.4001)
,p_associated_item=>wwv_flow_api.id(54230366604232620.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548800009409880871.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(8683628773386514.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548800336854880872.4001)
,p_event_id=>wwv_flow_api.id(548800009409880871.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688505459308608712.4001)
,p_name=>'Show / Hide Admin Page Options'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_ADMIN_PAGE_OPTION'
,p_condition_element=>'P572_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688505559381608713.4001)
,p_event_id=>wwv_flow_api.id(688505459308608712.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_ADMIN_PAGE_ID,P572_ADMIN_PAGE_NAME,P572_TAB_OPTIONS,P572_NAVLIST_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688505801503608716.4001)
,p_event_id=>wwv_flow_api.id(688505459308608712.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688505607238608714.4001)
,p_event_id=>wwv_flow_api.id(688505459308608712.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688505702112608715.4001)
,p_event_id=>wwv_flow_api.id(688505459308608712.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_ADMIN_PAGE_ID,P572_ADMIN_PAGE_NAME,P572_TAB_OPTIONS,P572_NAVLIST_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767087840368433.4001)
,p_event_id=>wwv_flow_api.id(688505459308608712.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767147542368434.4001)
,p_event_id=>wwv_flow_api.id(688505459308608712.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688507454630608732.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_TAB_OPTIONS'
,p_condition_element=>'P572_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688507570638608733.4001)
,p_event_id=>wwv_flow_api.id(688507454630608732.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_SET,P572_TAB_LABEL,P572_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57830656461033939.4001)
,p_event_id=>wwv_flow_api.id(688507454630608732.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(59661629762417740.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688507675281608734.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_TAB_OPTIONS'
,p_condition_element=>'P572_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688507760885608735.4001)
,p_event_id=>wwv_flow_api.id(688507675281608734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_SET,P572_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688507809895608736.4001)
,p_event_id=>wwv_flow_api.id(688507675281608734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57830766106033940.4001)
,p_event_id=>wwv_flow_api.id(688507675281608734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(59661629762417740.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688507900807608737.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_TAB_OPTIONS'
,p_condition_element=>'P572_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508052197608738.4001)
,p_event_id=>wwv_flow_api.id(688507900807608737.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_SET,P572_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508148436608739.4001)
,p_event_id=>wwv_flow_api.id(688507900807608737.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57830885395033941.4001)
,p_event_id=>wwv_flow_api.id(688507900807608737.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(59661629762417740.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688508230469608740.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_NAVLIST_OPTIONS'
,p_condition_element=>'P572_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508334328608741.4001)
,p_event_id=>wwv_flow_api.id(688508230469608740.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_ENTRY_NAME,P572_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508422298608742.4001)
,p_event_id=>wwv_flow_api.id(688508230469608740.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_ENTRY_NAME,P572_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688508559022608743.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_NAVLIST_OPTIONS'
,p_condition_element=>'P572_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508694046608744.4001)
,p_event_id=>wwv_flow_api.id(688508559022608743.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508764454608745.4001)
,p_event_id=>wwv_flow_api.id(688508559022608743.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688508873187608746.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688508972592608747.4001)
,p_event_id=>wwv_flow_api.id(688508873187608746.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_ENTRY_NAME,P572_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P572_ADMIN_PAGE_NAME'
,p_attribute_07=>'P572_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00573
begin
wwv_flow_api.create_page(
 p_id=>573.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla: Nueva Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46424719348867887.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110964014865104710.4001)
,p_plug_name=>'Copiar Plantilla de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110964404438104713.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222841709572471595.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110964612278104713.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46424719348867887.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110964823358104714.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46424719348867887.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(110966612860104719.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(110964823358104714.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110965030435104715.4001)
,p_name=>'P573_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110964014865104710.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110965223101104716.4001)
,p_name=>'P573_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110964014865104710.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_TEMPLATE_NAME',
'from WWV_FLOW_LIST_TEMPLATES',
'where id = :P573_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110965705182104717.4001)
,p_name=>'P573_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(110964014865104710.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1145991876860648501.4001)
,p_name=>'P573_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(110964014865104710.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(110966220912104718.4001)
,p_validation_name=>'P573_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P573_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110964823358104714.4001)
,p_associated_item=>wwv_flow_api.id(110965705182104717.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1145992225996648505.4001)
,p_validation_name=>'P573_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P573_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110964823358104714.4001)
,p_associated_item=>wwv_flow_api.id(1145991876860648501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1145992379900648506.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_list_templates ',
'         where id = :P573_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_list_templates',
'            where list_template_name = :P573_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico.')
,p_associated_item=>wwv_flow_api.id(110965705182104717.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1145992488469648507.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_list_templates ',
'         where id = :P573_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_list_templates',
'            where internal_name = :P573_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de la plantilla debe ser \00FAnico.')
,p_associated_item=>wwv_flow_api.id(1145991876860648501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614718084334674334.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(110964612278104713.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614718326912674335.4001)
,p_event_id=>wwv_flow_api.id(614718084334674334.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1145992052999648503.4001)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P573_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1145992137039648504.4001)
,p_event_id=>wwv_flow_api.id(1145992052999648503.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P573_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P573_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110966400476104719.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy List Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_LIST_TEMPLATES where id = :P573_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'',
'  wwv_flow_templates_util.copy_list_template (',
'      p_copy_from_flow_id => :fb_flow_id,',
'      p_to_flow_id        => :FB_FLOW_ID,',
'      p_from_template_id => :P573_FROM_TEMPLATE_ID,',
'      p_to_template_name => :P573_TO_TEMPLATE_NAME,',
'      p_to_internal_name => :P573_TO_INTERNAL_NAME,',
'      p_to_template_id   => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id      => c1.theme_id,',
'      p_include_subscription => false);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'La plantilla no se ha copiado correctamente.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(110964823358104714.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00574
begin
wwv_flow_api.create_page(
 p_id=>574.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46422416447857617.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110984703629136051.4001)
,p_plug_name=>'Copiar Plantilla de Etiqueta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110985101967136053.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222842702084478894.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110985300580136053.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46422416447857617.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(110985526152136054.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46422416447857617.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(110987315868136060.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(110985526152136054.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110985704432136054.4001)
,p_name=>'P574_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110984703629136051.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110985920717136056.4001)
,p_name=>'P574_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110984703629136051.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TEMPLATE_NAME',
'from WWV_FLOW_FIELD_TEMPLATES',
'where id = :P574_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110986427878136057.4001)
,p_name=>'P574_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(110984703629136051.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1127923127596976501.4001)
,p_name=>'P574_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(110984703629136051.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre del nuevo identificador de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(110986922490136058.4001)
,p_validation_name=>'P574_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P574_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110985526152136054.4001)
,p_associated_item=>wwv_flow_api.id(110986427878136057.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1127923424304976504.4001)
,p_validation_name=>'P574_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P574_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(110985526152136054.4001)
,p_associated_item=>wwv_flow_api.id(1127923127596976501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1127923582243976505.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_field_templates ',
'         where id = :P574_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_field_templates',
'            where template_name = :P574_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(110986427878136057.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1127923650469976506.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_field_templates ',
'         where id = :P574_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_field_templates',
'            where internal_name = :P574_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El identificador de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1127923127596976501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614718695474677276.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(110985300580136053.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614718983851677277.4001)
,p_event_id=>wwv_flow_api.id(614718695474677276.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1127923224241976502.4001)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P574_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1127923333276976503.4001)
,p_event_id=>wwv_flow_api.id(1127923224241976502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P574_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P574_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110987114685136059.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Label Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_FIELD_TEMPLATES where id = :P574_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'    wwv_flow_templates_util.copy_field_template (',
'      p_copy_from_flow_id  => :fb_flow_id,',
'      p_flow_id            =>:fb_flow_id,',
'      p_from_template_id   => :P574_FROM_TEMPLATE_ID,',
'      p_to_template_name   => :P574_TO_TEMPLATE_NAME,',
'      p_to_internal_name   => :P574_TO_INTERNAL_NAME,',
'      p_to_template_id     => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id        => c1.theme_id,',
'      p_include_subscription => false);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(110985526152136054.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00575
begin
wwv_flow_api.create_page(
 p_id=>575.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear control de acceso: confirmaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1ginas de control de acceso: confirmaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_comment=>'To be Deleted'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(336661900980368648.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(957479368832976483.4001)
,p_plug_name=>unistr('Confirmaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wiz_confirm.create_acl (',
'        p_flow_id         => :FB_FLOW_ID,',
'        p_page_id         => :P572_STARTING_PAGE_ID,',
'        p_admin_page_id   => :P572_ADMIN_PAGE_ID,',
'        p_admin_page_name => :P572_ADMIN_PAGE_NAME,',
'        p_existing_page   => :P572_EXISTING_PAGE );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(149559481006468683.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(336661900980368648.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(149559801419468685.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(336661900980368648.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(149560226721468686.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(336661900980368648.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:572:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(149562437874468720.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(149559481006468683.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(149562961887468722.4001)
,p_event_id=>wwv_flow_api.id(149562437874468720.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(149562030808468716.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create acl feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P572_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P572_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P572_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P572_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P572_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P572_TAB_SET;',
'    l_admin_page.tab_name                    := :P572_TAB_NAME;',
'    l_admin_page.tab_text                    := :P572_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P572_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P572_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P572_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P572_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P572_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_acl(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_starting_page_id           => :P572_STARTING_PAGE_ID,',
'        p_group_id                   => :P572_GROUP_ID,',
'        p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'        p_admin_page                 => l_admin_page );',
'    ',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la p\00E1gina. #SQLERRM#')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(149559801419468685.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(149561615340468714.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La p\00E1gina se ha creado correctamente.')
);
end;
/
prompt --application/pages/page_00576
begin
wwv_flow_api.create_page(
 p_id=>576.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Script de Desinstalaci\00F3n')
,p_step_title=>unistr('Script de Desinstalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12984929918641915.4001)
,p_plug_name=>'Deinstall Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>131
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.htp.p(''<pre class="code">'');',
'',
'    for c1 in (select id, deinstall_script',
'              from WWV_FLOW_INSTALL',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id',
'                and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0)',
'    loop',
'        wwv_htp.print_clob(c1.deinstall_script);',
'    end loop;',
'    sys.htp.p(''</pre>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Defina un script para borrar los objetos de base de datos y los archivos est\00E1ticos que se crean mediante los archivos de comandos de instalaci\00F3n.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22495516128345571.4001)
,p_plug_name=>'Supporting Object Definition tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24431027552917688.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>41
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34016307311976695.4001)
,p_plug_name=>unistr('Script de Desinstalaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107279720885220346.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(34016307311976695.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:850:P850_MODE,F4000_LAST_VIEW,P865_DEINSTALL_MODE:DEINSTALL,576,CREATE:'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0'))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12986006416663549.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(34016307311976695.4001)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Editar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_MODE,F4000_LAST_VIEW,P865_DEINSTALL_MODE:DEINSTALL,576,EDIT:'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22552102557511924.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34016307311976695.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107433801107962172.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34016307311976695.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29885230653632646.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107434019123962177.4001)
,p_branch_action=>'f?p=&FLOW_ID.:576:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(107433801107962172.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29884325112631016.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107435407818973578.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_install',
'   set deinstall_script = empty_clob',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido suprimir el script de desinstalaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(107433801107962172.4001)
,p_process_success_message=>unistr('Script de desinstalaci\00F3n suprimido.')
);
end;
/
prompt --application/pages/page_00578
begin
wwv_flow_api.create_page(
 p_id=>578.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Script de Instalaci\00F3n')
,p_step_title=>unistr('Script de Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22662428733970080.4001)
,p_plug_name=>unistr('Script de Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22692214560148486.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208096528753998313.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747143461108138166.4001)
,p_plug_name=>unistr('Script de Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22662909207970081.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208096528753998313.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22662616877970080.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208096528753998313.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'P578_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49898232193916120.4001)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22662616877970080.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P578_SCRIPT_TYPE'
,p_branch_condition_text=>'UPGRADE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22663513402970085.4001)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22663701104970087.4001)
,p_name=>'P578_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22662428733970080.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22663904229970095.4001)
,p_name=>'P578_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22662428733970080.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P855_SCRIPT_NAME.'
,p_prompt=>'Nombre:'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nombre del script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22664315733970100.4001)
,p_name=>'P578_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(22662428733970080.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P855_SCRIPT_SEQUENCE.'
,p_prompt=>'Secuencia:'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('N\00FAmero de secuencia del script. Los archivos de comandos se ejecutan en orden ascendente por n\00FAmero de secuencia.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22664728016970101.4001)
,p_name=>'P578_SCRIPT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22662428733970080.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Script de Instalaci\00F3n:')
,p_source=>'SCRIPT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>20
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Edite el script de instalaci\00F3n que se muestra a continuaci\00F3n. Cuando un usuario instala esta aplicaci\00F3n y decide ejecutar archivos de comandos de instalaci\00F3n, este script se ejecuta con las credenciales de base de datos de ese usuario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49845815721722235.4001)
,p_name=>'P578_SCRIPT_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(22662428733970080.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P850_MODE.'
,p_source=>'SCRIPT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(22664907834970103.4001)
,p_validation_name=>'P578_SCRIPT not null'
,p_validation_sequence=>10
,p_validation=>'P578_SCRIPT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El script debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(22664728016970101.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22665109300970104.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P578_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22665300372970108.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P578_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL_SCRIPTS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00580
begin
wwv_flow_api.create_page(
 p_id=>580.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia de Servicio Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13181024405676456.4001)
,p_plug_name=>'Crear Referencia de Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para introducir la direcci\00F3n URL al documento WSDL que describe el servicio en detalle.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20991903444706304.4001)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>145
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22492500298337049.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22410710903630445.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28361114075150413.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(28359907580129646.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204751120735142740.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(36499004331317665.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204751120735142740.4001)
,p_button_name=>'FINISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Terminar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13182513932676458.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(204751120735142740.4001)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13182400685676458.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204751120735142740.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13182205592676458.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204751120735142740.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13184431855676463.4001)
,p_branch_action=>'f?p=&FLOW_ID.:585:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13183011073676459.4001)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13182205592676458.4001)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13271707529806670.4001)
,p_branch_action=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13182400685676458.4001)
,p_branch_sequence=>5
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13181914584676457.4001)
,p_name=>'P580_WSDL_URL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13181024405676456.4001)
,p_prompt=>unistr('Ubicaci\00F3n WSDL')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la direcci\00F3n URL al documento WSDL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20992818335710661.4001)
,p_name=>'P580_USERNAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20991903444706304.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de usuario necesario para acceder a WSDL. Algunos WSDL necesitan credenciales de autenticaci\00F3n b\00E1sica para acceder a ellos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20993628378713565.4001)
,p_name=>'P580_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20991903444706304.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a necesaria para acceder a WSDL. Algunos WSDL necesitan credenciales de autenticaci\00F3n b\00E1sica para acceder a ellos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(14176222735102420.4001)
,p_validation_name=>'P580_WSDL_URL'
,p_validation_sequence=>10
,p_validation=>'P580_WSDL_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar la direcci\00F3n URL al documento WSDL.')
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') in (''NEXT'',''FINISH'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(13181914584676457.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(26757703921481538.4001)
,p_validation_name=>'retrieve and validate WSDL'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P550_UDDI = ''N'' and wwv_flow_collection.collection_exists(''UDDI_DETAILS'') then',
'  wwv_flow_collection.delete_collection(''UDDI_DETAILS'');',
'end if;',
'',
'return wwv_flow_web_services.WSDL_analyze(',
'    p_wsdl_url                      => :P580_WSDL_URL,',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_uddi_details_collection       => ''UDDI_DETAILS'',',
'    p_web_service_collection        => ''WEB_SERVICE'',',
'    p_operations_collection         => ''SERVICE_OPERATIONS'',',
'    p_inputs_collection             => ''SERVICE_OPERATION_INPUTS'',',
'    p_outputs_collection            => ''SERVICE_OPERATION_OUTPUTS'',',
'    p_username                      => :P580_USERNAME,',
'    p_password                      => :P580_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>unistr('Documento WSDL no v\00E1lido.')
,p_validation_condition=>':P580_WSDL_URL is not null and nvl(:REQUEST,''NEXT'') in (''NEXT'',''FINISH'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(43007117954781357.4001)
,p_validation_name=>'name and URL enpoint not null'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001, c002',
'             from wwv_flow_collections',
'            where collection_name = ''WEB_SERVICE''',
'              and seq_id = 1 ) loop',
'  if c1.c001 is null or c1.c002 is null then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;',
'',
'return false;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No se ha podido determinar el nombre del servicio ni el punto final de direcci\00F3n URL del documento WSDL. Haga clic en Siguiente e introduzca esta informaci\00F3n en el siguiente paso.')
,p_when_button_pressed=>wwv_flow_api.id(36499004331317665.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614670108667188711.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(13182205592676458.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614670278979188712.4001)
,p_event_id=>wwv_flow_api.id(614670108667188711.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143247574459567428.4001)
,p_name=>'Submit NEXT'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(13182513932676458.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143247662744567429.4001)
,p_event_id=>wwv_flow_api.id(1143247574459567428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143247747342567430.4001)
,p_name=>'Submit FINISH'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(36499004331317665.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143247891259567431.4001)
,p_event_id=>wwv_flow_api.id(1143247747342567430.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FINISH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(36589522872436626.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create web reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_basic_auth varchar2(1) := ''N'';',
'begin',
'for c1 in (select c001, c002, c003, c004, c005, c006',
'             from wwv_flow_collections',
'            where collection_name = ''WEB_SERVICE'' ) loop',
'  if :P580_USERNAME is not null then',
'    l_basic_auth := ''Y'';',
'  end if;',
'  wwv_flow_web_services.create_web_service(',
'    p_id                            => null,',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_name                          => nvl(c1.c001,''Web Reference''),',
'    p_url                           => c1.c002,',
'    p_target_ns                     => c1.c003,',
'    p_xsd_prefix                    => c1.c004,',
'    p_soap_style                    => c1.c005,',
'    p_soap_version                  => c1.c006,',
'    p_operations_collection         => ''SERVICE_OPERATIONS'',',
'    p_inputs_collection             => ''SERVICE_OPERATION_INPUTS'',',
'    p_outputs_collection            => ''SERVICE_OPERATION_OUTPUTS'',',
'    p_basic_auth                    => l_basic_auth);',
'   exit;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(36499004331317665.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614670389334188713.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(36499004331317665.4001)
,p_process_success_message=>'Referencia web creada.'
);
end;
/
prompt --application/pages/page_00583
begin
wwv_flow_api.create_page(
 p_id=>583.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Validaci\00F3n: Validaci\00F3n a Copiar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Validaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45392602984537423.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112369313902398470.4001)
,p_plug_name=>unistr('Copiar Validaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228170929393217573.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(228167614670175482.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112370909447425534.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45392602984537423.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112371128124425540.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45392602984537423.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112372028494431052.4001)
,p_branch_action=>'f?p=&APP_ID.:596:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112370217974418578.4001)
,p_name=>'P583_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(112369313902398470.4001)
,p_prompt=>unistr('Copiar Validaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_sequence||''. ''||wwv_flow_escape.html(validation_name) vname, id',
'from wwv_flow_step_validations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by validation_sequence'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el componente que desea copiar.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113086812335936587.4001)
,p_name=>'P583_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(112369313902398470.4001)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina de Destino')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en el que se copiar\00E1 este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228232903005770785.4001)
,p_name=>'P583_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(112369313902398470.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 la validaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(228236726517824864.4001)
,p_validation_name=>'Target Page Does Not Exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_count number := 0;',
'begin',
'select 1 into l_count from dual where exists (select 1',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P583_TARGET_PAGE);',
'',
'if l_count = 0 then',
'    return false;',
'else',
'    return true;',
'end if;',
'',
'exception when no_data_found then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe seleccionar una p\00E1gina existente.')
,p_validation_condition_type=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
,p_when_button_pressed=>wwv_flow_api.id(112371128124425540.4001)
,p_associated_item=>wwv_flow_api.id(113086812335936587.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614708266540500257.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112370909447425534.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614708539995500258.4001)
,p_event_id=>wwv_flow_api.id(614708266540500257.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00585
begin
wwv_flow_api.create_page(
 p_id=>585.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia de Servicio Web: Confirmar'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14293705410371886.4001)
,p_plug_name=>'Crear Referencia de Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_row_template=>wwv_flow_api.id(82116118900238363.4001)
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_header=>unistr('<p>Revise los detalles del servicio web y cambie el nombre de la referencia o el punto final de la direcci\00F3n URL. La informaci\00F3n mostrada se ha derivado del documento WSDL. Si sabe que el documento WSDL no es correcto, s\00F3lo debe cambiar el punto fina')
||unistr('l de la direcci\00F3n URL.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14299723034424201.4001)
,p_name=>'Operaciones'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 operation_name',
'  from wwv_flow_collections',
' where collection_name = ''SERVICE_OPERATIONS'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
', c002 input_message, ',
'       c003 output_message, c004 input_message_namespace, ',
'       c008 input_message_style,',
'       c005 output_message_namespace, c007 output_message_style, ',
'       c006 soap_action',
''))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14300401141424218.4001)
,p_query_column_id=>1
,p_column_alias=>'OPERATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre de la Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14302006674438465.4001)
,p_name=>unistr('Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.c001 operation, a.c002 parameter_name, ',
'       a.c003 parameter_type',
'  from wwv_flow_collections a, wwv_flow_collections b',
' where a.collection_name = ''SERVICE_OPERATION_INPUTS''',
'   and b.collection_name = ''SERVICE_OPERATIONS''',
'   and b.c002 = a.c001',
' order by a.seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18551428198600212.4001)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14302702011438470.4001)
,p_query_column_id=>2
,p_column_alias=>'PARAMETER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre del Par\00E1metro')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(14302819684438470.4001)
,p_query_column_id=>3
,p_column_alias=>'PARAMETER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(14306409706458285.4001)
,p_name=>unistr('Par\00E1metros de Salida')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.c001 out_operation,',
'       a.c002 out_parameter_name, ',
'       a.c003 out_parameter_type',
'  from wwv_flow_collections a, wwv_flow_collections b',
' where a.collection_name = ''SERVICE_OPERATION_OUTPUTS''',
'   and b.collection_name = ''SERVICE_OPERATIONS''',
'   and a.c001 = b.c003',
' order by a.seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923579413862744040.4001)
,p_query_column_id=>1
,p_column_alias=>'OUT_OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923579579584744041.4001)
,p_query_column_id=>2
,p_column_alias=>'OUT_PARAMETER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre del Par\00E1metro')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923579615314744042.4001)
,p_query_column_id=>3
,p_column_alias=>'OUT_PARAMETER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22506915656625392.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22410710903630445.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29040514324610977.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(28359907580129646.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204761520052218198.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13186615040676466.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204761520052218198.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Referencia'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13186523001676466.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204761520052218198.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13186331337676466.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204761520052218198.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13187102140676467.4001)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13186331337676466.4001)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13187819442676468.4001)
,p_branch_action=>'f?p=&APP_ID.:580:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13186523001676466.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22273922987240331.4001)
,p_name=>'P585_BASIC_AUTH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n B\00E1sica:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si este servicio Web necesita autenticaci\00F3n b\00E1sica. Las credenciales de autenticaci\00F3n b\00E1sica se env\00EDan como parte de la solicitud HTTP sin cifrar. Los servicios Web que utilizan autenticaci\00F3n b\00E1sica, normalmente tambi\00E9n utilizan el protoco')
||unistr('lo HTTPS (SSL) ya que el nombre de usuario y la contrase\00F1a se env\00EDan sin cifrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923578773433744033.4001)
,p_name=>'P585_WEB_SERVICE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_prompt=>'Nombre del Servicio Web'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923578884721744034.4001)
,p_name=>'P585_SOAP_URL_ENDPOINT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_prompt=>'Punto Final de URL de SOAP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'URL del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923578937008744035.4001)
,p_name=>'P585_SOAP_STYLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_prompt=>'Estilo de SOAP'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923579083180744036.4001)
,p_name=>'P585_SOAP_VERSION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_prompt=>unistr('Versi\00F3n SOAP')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923579137221744037.4001)
,p_name=>'P585_TARGET_NS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923579217569744038.4001)
,p_name=>'P585_XSD_PREFIX'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(14293705410371886.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(22275113075246930.4001)
,p_computation_sequence=>10
,p_computation_item=>'P585_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P580_USERNAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42970206292636128.4001)
,p_validation_name=>'name not null'
,p_validation_sequence=>10
,p_validation=>'length(:P585_WEB_SERVICE_NAME) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe proporcionar un nombre para la referencia del servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(13186615040676466.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42979610841665791.4001)
,p_validation_name=>'url enpoint not null'
,p_validation_sequence=>20
,p_validation=>'length(:P585_SOAP_URL_ENDPOINT) > 11'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe proporcionar un punto final de direcci\00F3n URL que llame al servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(13186615040676466.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614671581818188725.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(13186331337676466.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614671624606188726.4001)
,p_event_id=>wwv_flow_api.id(614671581818188725.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15031128310575243.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create web service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_services.create_web_service(',
'    p_id                            => null,',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_name                          => :P585_WEB_SERVICE_NAME,',
'    p_url                           => :P585_SOAP_URL_ENDPOINT,',
'    p_target_ns                     => :P585_TARGET_NS,',
'    p_xsd_prefix                    => :P585_XSD_PREFIX,',
'    p_soap_style                    => :P585_SOAP_STYLE, ',
'    p_soap_version                  => :P585_SOAP_VERSION,',
'    p_operations_collection         => ''SERVICE_OPERATIONS'',',
'    p_inputs_collection             => ''SERVICE_OPERATION_INPUTS'',',
'    p_outputs_collection            => ''SERVICE_OPERATION_OUTPUTS'',',
'    p_basic_auth                    => :P585_BASIC_AUTH);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear el servicio Web.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(13186615040676466.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614671751860188727.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(13186615040676466.4001)
,p_process_success_message=>'El servicio web se ha creado correctamente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(923579397400744039.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select c001,',
'           c002,',
'           c003,',
'           c004,',
'           c005,',
'           c006',
'      into :P585_WEB_SERVICE_NAME,',
'           :P585_SOAP_URL_ENDPOINT,',
'           :P585_TARGET_NS,',
'           :P585_XSD_PREFIX,',
'           :P585_SOAP_STYLE,',
'           :P585_SOAP_VERSION',
'      from wwv_flow_collections',
'     where collection_name = ''WEB_SERVICE''',
'       and seq_id          = 1;',
'exception when no_data_found then',
'    :P585_WEB_SERVICE_NAME := null;',
'    :P585_SOAP_URL_ENDPOINT := null;',
'    :P585_TARGET_NS := null;',
'    :P585_XSD_PREFIX := null;',
'    :P585_SOAP_STYLE := null;',
'    :P585_SOAP_VERSION := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00587
begin
wwv_flow_api.create_page(
 p_id=>587.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Bifurcaci\00F3n: Bifurcaci\00F3n a Copiar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Bifurcaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46038029088622281.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228238624355843200.4001)
,p_plug_name=>unistr('Copiar Bifurcaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228244712627868153.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(228256415837925869.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228239824555843209.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46038029088622281.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228240005585843210.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46038029088622281.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112386803666606132.4001)
,p_branch_action=>'f?p=&APP_ID.:685:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228238814404843204.4001)
,p_name=>'P587_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(228238624355843200.4001)
,p_prompt=>unistr('Copiar Bifurcaci\00F3n:')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(BRANCH_SEQUENCE||''. ''||wwv_flow_escape.html(nvl(branch_name, BRANCH_ACTION)),1,90) bname, id ',
'from WWV_FLOW_STEP_BRANCHES ',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id ',
'order by BRANCH_SEQUENCE'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Seleccione el componente que desea copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228239314205843205.4001)
,p_name=>'P587_COPY_TO_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(228238624355843200.4001)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina de Destino')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en el que se copiar\00E1 este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228456009123715205.4001)
,p_name=>'P587_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(228238624355843200.4001)
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 la bifurcaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(229047329544045871.4001)
,p_validation_name=>'P587_ID_not_null'
,p_validation_sequence=>10
,p_validation=>'P587_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la bifurcaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(228240005585843210.4001)
,p_associated_item=>wwv_flow_api.id(228238814404843204.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(228269629914996154.4001)
,p_validation_name=>'copy_to_page_exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P587_COPY_TO_PAGE) then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe seleccionar una p\00E1gina existente.')
,p_when_button_pressed=>wwv_flow_api.id(228240005585843210.4001)
,p_associated_item=>wwv_flow_api.id(228239314205843205.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614709153373528500.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(228239824555843209.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614709455223528500.4001)
,p_event_id=>wwv_flow_api.id(614709153373528500.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00588
begin
wwv_flow_api.create_page(
 p_id=>588.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Probar Servicio Web'
,p_step_title=>'Probar Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15252327976163190.4001)
,p_name=>unistr('Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(input_or_output,''I'',wwv_flow_item.display_and_save(1,wwv_flow_escape.html(name)),wwv_flow_item.display_and_save(4,wwv_flow_escape.html(name))) name, ',
'       parm_type type, decode(input_or_output,''I'',wwv_flow_item.text(3,null,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''APEXIR_VALUE'')),wwv_flow_item.text(6,null,null,null,null,''f''||lpad(''''||1,'
||'2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''APEXIR_VALUE''))) value',
'  from wwv_flow_ws_parameters',
' where input_or_output in (''I'',''H'')',
'   and type_is_xsd = ''Y''',
'   and ws_opers_id = :P588_OPERATION',
' order by input_or_output, id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15252721884163193.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(20006920272526582.4001)
,p_query_column_id=>2
,p_column_alias=>'TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15252810352163194.4001)
,p_query_column_id=>3
,p_column_alias=>'VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Valor'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(15252903920163194.4001)
,p_name=>'Detalles de Referencia de Servicio Web'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, url URL_endpoint ',
'  from wwv_flow_shared_web_services',
' where id = :P588_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39149906858314052.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre:'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#NAME#</strong>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15253300634163194.4001)
,p_query_column_id=>2
,p_column_alias=>'URL_ENDPOINT'
,p_column_display_sequence=>2
,p_column_heading=>'Punto Final de URL:&nbsp;'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#URL_ENDPOINT#</strong>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15253417733163195.4001)
,p_plug_name=>'Mensajes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22295516454616910.4001)
,p_name=>unistr('Autenticaci\00F3n B\00E1sica')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(a.name,''username'',wwv_flow_lang.system_message(''ACCESS_CONTROL_USERNAME''),''password'',wwv_flow_lang.system_message(''PASSWORD''),a.name) name, wwv_flow_item.text(7,null,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'')'
||',wwv_flow_lang.system_message(''APEXIR_VALUE'')) value',
'  from wwv_flow_ws_parameters a, wwv_flow_shared_web_services b,',
'       wwv_flow_ws_operations c',
' where input_or_output = ''A''',
'   and a.ws_opers_id = c.id',
'   and c.ws_id = b.id',
'   and b.id = :P588_ID',
'order by a.name desc '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_parameters a, wwv_flow_shared_web_services b,',
'       wwv_flow_ws_operations c',
' where input_or_output = ''A''',
'   and a.ws_opers_id = c.id',
'   and c.ws_id = b.id',
'   and b.id = :P588_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22295710841616911.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22295919836616911.4001)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42253430789485783.4001)
,p_plug_name=>'Probar Referencia de Servicio Web'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Para probar la referencia de servicio Web, seleccione una operaci\00F3n, proporcione los par\00E1metros de entrada si es aplicable y haga clic en <strong>Probar</strong>. A continuaci\00F3n, puede inspeccionar el sobre de solicitud y el sobre de respuesta.</p')
||'>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1142727844742397018.4001)
,p_plug_name=>'Probar Referencia de Servicio Web'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15254207698163197.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1142727844742397018.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15253807301163196.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1142727844742397018.4001)
,p_button_name=>'TEST'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Probar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15257000962163214.4001)
,p_branch_action=>'f?p=&FLOW_ID.:588:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15254605463163199.4001)
,p_name=>'P588_OPERATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15252903920163194.4001)
,p_prompt=>unistr('Operaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P588_ID',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Operaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la operaci\00F3n (es decir, el m\00E9todo que se va a ejecutar) que desea probar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15255006168163202.4001)
,p_name=>'P588_REQUEST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15253417733163195.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'class="instructiontext" readonly="readonly"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('A continuaci\00F3n aparece el elemento envelope de SOAP que ha creado el motor &PRODUCT_NAME. en funci\00F3n de la definici\00F3n de referencia de servicio Web y de los par\00E1metros de entrada proporcionados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15255305815163203.4001)
,p_name=>'P588_RESPONSE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15253417733163195.4001)
,p_prompt=>'Respuesta'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'class="instructiontext" readonly="readonly"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('A continuaci\00F3n aparece el elemento response de SOAP que ha devuelvo el servicio Web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15258316479168000.4001)
,p_name=>'P588_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(15252903920163194.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15256210031163210.4001)
,p_validation_name=>'P588_OPERATION'
,p_validation_sequence=>10
,p_validation=>'nvl(:P588_OPERATION,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe seleccionar una operaci\00F3n.')
,p_validation_condition=>'nvl(:REQUEST,''TEST'') = ''TEST'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(15254605463163199.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143247398542567426.4001)
,p_name=>'Submit page'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(15253807301163196.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143247419242567427.4001)
,p_event_id=>wwv_flow_api.id(1143247398542567426.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'TEST'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(268346116450686734.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear request/response'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P588_REQUEST := null;',
':P588_RESPONSE := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P588_OPERATION'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15256618220163212.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'test webservice'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_soap_env clob;',
'  l_response clob;',
'  l_parm varchar2(4000);',
'  l_action varchar2(4000);',
'  l_url varchar2(4000);',
'  l_soap_version varchar2(30);',
'  l_target_ns varchar2(255);',
'  l_input_ns varchar2(255);',
'  l_input_msg_style varchar2(255);',
'  l_header_msg_style varchar2(255);',
'  l_operation varchar2(255);',
'  l_soap_style varchar2(255);',
'  i integer;',
'  l_response_var varchar2(32767);',
'  l_username varchar2(4000) := null;',
'  l_password varchar2(4000) := null;',
'  l_wallet wwv_flow_security.t_wallet;',
'begin',
'  if wwv_flow.g_f07.count > 0 then',
'    l_username := wwv_flow.g_f07(1);',
'    l_password := wwv_flow.g_f07(2);',
'  end if;',
'  --',
'  for c1 in (select a.url, nvl(a.soap_version,''1.1'') soap_version, a.static_parm_01, ',
'                    a.static_parm_02, b.soap_action, ',
'                    b.name, b.input_message_ns, ',
'                    b.input_message_style, b.header_message_style',
'               from wwv_flow_shared_web_services a, wwv_flow_ws_operations b',
'              where b.ws_id = a.id',
'                and a.id = :P588_ID',
'                and b.id = :P588_OPERATION ) loop',
'    l_url := c1.url;',
'    l_soap_version := c1.soap_version;',
'    l_operation := c1.name;',
'    l_soap_style := c1.static_parm_02;',
'    l_target_ns := c1.static_parm_01;',
'    l_input_ns := c1.input_message_ns;',
'    l_action := c1.soap_action;',
'    l_input_msg_style := c1.input_message_style;',
'    l_header_msg_style := c1.header_message_style;',
'    exit;',
'  end loop;',
'  --',
'  --',
'  wwv_flow_web_services.generate_header(',
'    p_process_id   => null,',
'    p_operation_id => :P588_OPERATION,',
'    p_in_msg_style => l_header_msg_style,',
'    p_ns           => nvl(l_input_ns,l_target_ns),',
'    p_soap_style   => l_soap_style,',
'    p_parm_name    => wwv_flow.g_f04,',
'    p_parm_value   => wwv_flow.g_f06);',
'  --',
'  wwv_flow_web_services.generate_body(',
'    p_process_id   => null,',
'    p_operation_id => :P588_OPERATION,',
'    p_in_msg_style => l_input_msg_style,',
'    p_soap_style   => l_soap_style,',
'    p_parm_name    => wwv_flow.g_f01,',
'    p_parm_value   => wwv_flow.g_f03);',
'',
'  l_soap_env := wwv_flow_web_services.generate_envelope(',
'                  p_operation => l_operation,',
'                  p_style     => l_soap_style,',
'                  p_ns        => nvl(l_input_ns,l_target_ns),',
'                  p_version   => l_soap_version,',
'                  p_body      => wwv_flow_web_services.g_body,',
'                  p_header    => wwv_flow_web_services.g_header );',
'',
'  :P588_REQUEST := l_soap_env;',
'',
'  l_wallet := wwv_flow_security.get_wallet;',
'',
'  l_response := wwv_flow_web_services.make_request(',
'                        p_url            => l_url,',
'                        p_action         => l_action,',
'                        p_version        => l_soap_version,',
'                        p_envelope       => l_soap_env,',
'                        p_username       => l_username,',
'                        p_password       => l_password,',
'                        p_proxy_override => wwv_flow_web_services.find_proxy(:FB_FLOW_ID),',
'                        p_wallet_path    => l_wallet.wallet_path,',
'                        p_wallet_pwd     => l_wallet.wallet_pwd );',
'  l_response_var := wwv_flow_utilities.clob_to_varchar2(l_response);',
'  wwv_flow.update_cache_with_write(''P588_RESPONSE'',substr(l_response_var,1,32000));',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'nvl(:REQUEST,''TEST'') = ''TEST'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00589
begin
wwv_flow_api.create_page(
 p_id=>589.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Ver Referencia Web'
,p_step_title=>'Ver Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(39010425453069021.4001)
,p_name=>'Operaciones'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, soap_action, input_message_ns, input_message_style, ',
'       output_message_ns, output_message_style',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P589_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_row_count_max=>1000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39010906267069024.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Nombre de la Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39011015451069024.4001)
,p_query_column_id=>2
,p_column_alias=>'SOAP_ACTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Acci\00F3n de SOAP')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39047531423155382.4001)
,p_query_column_id=>3
,p_column_alias=>'INPUT_MESSAGE_NS'
,p_column_display_sequence=>4
,p_column_heading=>'Espacio de Nombres de Entrada'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39048131287155383.4001)
,p_query_column_id=>4
,p_column_alias=>'INPUT_MESSAGE_STYLE'
,p_column_display_sequence=>3
,p_column_heading=>'Estilo de Entrada'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39047716690155382.4001)
,p_query_column_id=>5
,p_column_alias=>'OUTPUT_MESSAGE_NS'
,p_column_display_sequence=>6
,p_column_heading=>'Espacio de Nombres de Salida'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39010808948069024.4001)
,p_query_column_id=>6
,p_column_alias=>'OUTPUT_MESSAGE_STYLE'
,p_column_display_sequence=>5
,p_column_heading=>'Estilo de Salida'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(39011118396069024.4001)
,p_name=>unistr('Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.name operation, a.name, a.parm_type',
'  from wwv_flow_ws_parameters a, wwv_flow_ws_operations b',
' where a.input_or_output = ''I''',
'   and a.ws_opers_id = b.id',
'   and b.ws_id = :P589_ID'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39011929972069026.4001)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39011713652069026.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre del Par\00E1metro')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39011819036069026.4001)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(39012004934069026.4001)
,p_name=>unistr('Par\00E1metros de Salida')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.name operation_name, a.name param_name, a.parm_type type,',
'       wwv_flow_web_services.get_path(a.id) xpath',
'  from wwv_flow_ws_parameters a, wwv_flow_ws_operations b',
' where a.input_or_output = ''O''',
'   and a.ws_opers_id = b.id',
'   and b.ws_id = :P589_ID'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142728299288397022.4001)
,p_query_column_id=>1
,p_column_alias=>'OPERATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142728392182397023.4001)
,p_query_column_id=>2
,p_column_alias=>'PARAM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre de Par\00E1metro')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142728426337397024.4001)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39012413295069028.4001)
,p_query_column_id=>4
,p_column_alias=>'XPATH'
,p_column_display_sequence=>4
,p_column_heading=>'Xpath'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(39032520944110024.4001)
,p_name=>'Referencia de Servicio Web'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, url, static_parm_01 target_namespace, static_parm_02 soap_style',
'  from wwv_flow_shared_web_services',
' where id = :P589_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39033415552110050.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39033513034110050.4001)
,p_query_column_id=>2
,p_column_alias=>'URL'
,p_column_display_sequence=>2
,p_column_heading=>'URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(39056620607185588.4001)
,p_query_column_id=>3
,p_column_alias=>'TARGET_NAMESPACE'
,p_column_display_sequence=>3
,p_column_heading=>'Espacio de Nombres de Destino'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6671918493826792.4001)
,p_query_column_id=>4
,p_column_alias=>'SOAP_STYLE'
,p_column_display_sequence=>4
,p_column_heading=>'Estilo de SOAP'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1142727991277397019.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(39062523986205479.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1142727991277397019.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39046308786153781.4001)
,p_name=>'P589_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(39032520944110024.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00590
begin
wwv_flow_api.create_page(
 p_id=>590.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Proceso: Proceso a Copiar'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Proceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45408220083901963.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112441801746840049.4001)
,p_plug_name=>'Copiar Proceso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227765405220939635.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(227766223920945009.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112442216299840053.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45408220083901963.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112442422860840054.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45408220083901963.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112443924384840064.4001)
,p_branch_action=>'f?p=&APP_ID.:645:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112442615566840054.4001)
,p_name=>'P590_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(112441801746840049.4001)
,p_prompt=>'Copiar Proceso'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROCESS_SEQUENCE||''. ''||wwv_flow_escape.html(PROCESS_NAME) pname, id',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by PROCESS_SEQUENCE'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el componente que desea copiar.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113064105952773891.4001)
,p_name=>'P590_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(112441801746840049.4001)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina de Destino')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en el que se copiar\00E1 este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228472404845780263.4001)
,p_name=>'P590_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(112441801746840049.4001)
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 el proceso.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(227793914205140961.4001)
,p_validation_name=>'copy to page exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P590_COPY_TO_PAGE) then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe seleccionar una p\00E1gina existente.')
,p_when_button_pressed=>wwv_flow_api.id(112442422860840054.4001)
,p_associated_item=>wwv_flow_api.id(113064105952773891.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590119200148572028.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112442216299840053.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590119308022572029.4001)
,p_event_id=>wwv_flow_api.id(590119200148572028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00592
begin
wwv_flow_api.create_page(
 p_id=>592.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar C\00E1lculo: C\00E1lculo a Copiar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar C\00E1lculo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46177830836824466.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112460603081064282.4001)
,p_plug_name=>unistr('Copiar C\00E1lculo')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228267900824987700.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(228264919955974373.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112460813571064283.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46177830836824466.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112461004394064283.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46177830836824466.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112462827758064290.4001)
,p_branch_action=>'f?p=&APP_ID.:597:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112461212446064284.4001)
,p_name=>'P592_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(112460603081064282.4001)
,p_prompt=>unistr('Copiar C\00E1lculo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COMPUTATION_SEQUENCE||''. ''||wwv_flow_escape.html(COMPUTATION_ITEM) comp, id',
'from wwv_flow_step_computations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by COMPUTATION_SEQUENCE'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el componente que desea copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228270616193001677.4001)
,p_name=>'P592_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(112460603081064282.4001)
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 el c\00E1lculo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228550409384084302.4001)
,p_name=>'P592_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(112460603081064282.4001)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina de Destino')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en el que se copiar\00E1 este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(228297004184206384.4001)
,p_validation_name=>'Target Page Does Not Exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_count number := 0;',
'begin',
'',
'select count(*) into l_count ',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and id                = :P592_TARGET_PAGE;',
'',
'if l_count = 0 then',
'    return false;',
'else',
'    return true;',
'end if;',
'',
'exception ',
'    when no_data_found then ',
'        return false;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe seleccionar una p\00E1gina existente.')
,p_when_button_pressed=>wwv_flow_api.id(112461004394064283.4001)
,p_associated_item=>wwv_flow_api.id(228550409384084302.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614711943281555012.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112460813571064283.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614712211588555012.4001)
,p_event_id=>wwv_flow_api.id(614711943281555012.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00593
begin
wwv_flow_api.create_page(
 p_id=>593.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Bifurcaciones')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina: Bifurcaciones')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44756111157054257.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(208019104267799361.4001)
,p_name=>'Copiar Bifurcaciones'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_BRANCH'') and',
'   wwv_flow_collection.collection_member_count(p_collection_name => ''COPY_PAGE_BRANCH'') > 0',
'then  ',
'  q:=q||''select wwv_flow_item.display_and_save(3,c003) old_value, '';',
'	q:=q||''wwv_flow_item.textarea(2,c002,3,40) new_value, '';',
'	q:=q||''wwv_flow_item.hidden(1,c001) id '';	',
'  q:=q||''from htmldb_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_BRANCH'''''';	',
'else	 ',
'	q:=q||''select wwv_flow_item.display_and_save(3,branch_action) old_value, '';',
'	q:=q||''wwv_flow_item.textarea(2,'';',
'	q:=q||''wwv_flow_copy_page.change_page_id_in_branch('';',
'  q:=q||'':P621_COPY_FROM_PAGE_ID, '';',
'  q:=q||'':P621_COPY_TO_PAGE_ID, '';',
'	q:=q||''wwv_flow_copy_page.change_item_name('';',
'  q:=q||''to_number(:P621_COPY_FROM_FLOW_ID), '';',
'  q:=q||''to_number(:P621_COPY_FROM_PAGE_ID), '';',
'  q:=q||''to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''to_number(:P621_COPY_TO_PAGE_ID), '';',
'  q:=q||''branch_action)),3,40, '''' title="''''||wwv_flow_lang.system_message(''''F4000.P593.NEW_BRANCH'''')||''''"'''') new_value, '';',
'  q:=q||''wwv_flow_item.hidden(1,id) id '';',
'  q:=q||''from wwv_flow_step_branches '';',
'  q:=q||''where flow_id = :P621_COPY_FROM_FLOW_ID '';',
'  q:=q||''and flow_step_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''and security_group_id = :FLOW_SECURITY_GROUP_ID '';',
'  q:=q||''order by branch_sequence '';	',
'end if;  ',
'',
'return q;',
'end;'))
,p_header=>unistr('<p>Este informe muestra las bifurcaciones definidas en la p\00E1gina de la que est\00E1 copiando. Revise el informe y realice las actualizaciones necesarias.</p>')
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>3
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>unistr('No se ha definido ninguna bifurcaci\00F3n.')
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208658025271239488.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Bifurcaci\00F3n')
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_cattributes=>'valign="top"'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208658119929239489.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nueva Bifurcaci\00F3n')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(210415019396725929.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208020201892799364.4001)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226864407571634523.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(208020408590799364.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44756111157054257.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(208020811179799366.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44756111157054257.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(208020614039799366.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44756111157054257.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(208021807556799373.4001)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:593'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(208020811179799366.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(208021420780799371.4001)
,p_branch_action=>'f?p=&APP_ID.:&P593_PREV_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(208020614039799366.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(208028003513818767.4001)
,p_name=>'P593_PREV_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(208019104267799361.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614678224656227642.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(208020408590799364.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614678544179227642.4001)
,p_event_id=>wwv_flow_api.id(614678224656227642.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(208021208434799368.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save page branch definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_BRANCH'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''COPY_PAGE_BRANCH'',',
'    p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'    p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'    p_generate_md5      => ''YES'' );',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(208020811179799366.4001)
);
end;
/
prompt --application/pages/page_00594
begin
wwv_flow_api.create_page(
 p_id=>594.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Calendario de Comentarios del Desarrollador'
,p_step_title=>'Calendario de Comentarios del Desarrollador'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(259483208258527049.4001)
,p_plug_name=>'Disclaimer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_source=>'sys.htp.p(''<p>This calendar displays a count of developer comments by comment date.</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_LANG_EQ_COND1'
,p_plug_display_when_condition=>'en'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702934977991239724.4001)
,p_plug_name=>'Developer Comments'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(created_on) created_on, ',
'       to_char(created_on,''YYYY.MM.DD'') co, ',
'       lower(created_by) created_by,',
'       created_by link_created_by,',
'       count(*) c',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'group by trunc(created_on), to_char(created_on,''YYYY.MM.DD''), ',
'         lower(created_by), created_by',
''))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attribute_01=>'CREATED_ON'
,p_attribute_03=>'C'
,p_attribute_09=>'month:list:navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(777400336397703807.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(784788000174894142.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(217586224624429790.4001)
,p_branch_action=>'f?p=&FLOW_ID.:594:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217585230773429782.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' wwv_flow_utilities.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar la fecha del calendario.'
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217585631815429787.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' wwv_flow_utilities.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar la fecha del calendario.'
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217586001377429788.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' wwv_flow_utilities.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar la fecha del calendario.'
,p_process_comment=>'Generated 07-JUN-06'
);
end;
/
prompt --application/pages/page_00596
begin
wwv_flow_api.create_page(
 p_id=>596.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Validaci\00F3n: Opciones de Validaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Validaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45395027010553889.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228174021252279715.4001)
,p_plug_name=>unistr('Copiar Validaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228174230898279716.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(228167614670175482.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(228200813219345309.4001)
,p_name=>unistr('Validaciones de P\00E1gina de Destino')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    v.validation_sequence, v.validation_name, v.validation_type, ',
'    (select i.name ',
'       from wwv_flow_step_items i ',
'      where v.associated_item = i.id',
'        and v.flow_id         = i.flow_id',
'        and i.flow_step_id    = v.flow_step_id) associated_item',
'from ',
'    wwv_flow_step_validations v',
'where ',
'    v.flow_step_id = :P583_TARGET_PAGE',
'and v.flow_id      = :fb_flow_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay ninguna validaci\00F3n definida actualmente en la p\00E1gina de destino.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228211922139366833.4001)
,p_query_column_id=>1
,p_column_alias=>'VALIDATION_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228212009645366834.4001)
,p_query_column_id=>2
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228212126142366834.4001)
,p_query_column_id=>3
,p_column_alias=>'VALIDATION_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(131915151655)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228212223516366835.4001)
,p_query_column_id=>4
,p_column_alias=>'ASSOCIATED_ITEM'
,p_column_display_sequence=>4
,p_column_heading=>'Elemento Asociado'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228174913622279718.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45395027010553889.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228175125952279719.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45395027010553889.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228213623571395616.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45395027010553889.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:583:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(228177405672279731.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7776802498028581.4001)
,p_name=>'P596_TABULAR_FORM_REGION_ID'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n Editable')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name,',
'       id',
'  from wwv_flow_page_plugs',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :P583_TARGET_PAGE',
'   and security_group_id = :WORKSPACE_ID',
'   and plug_source_type  in ( ''NATIVE_TABFORM'', ''NATIVE_IG'' )',
' order by 1',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- seleccionar regi\00F3n editable -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_validations',
' where id                     = :P583_ID',
'   and tabular_form_region_id is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228175824249279724.4001)
,p_name=>'P596_VALIDATION_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_prompt=>unistr('Nombre de Validaci\00F3n de Destino')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_name',
'from wwv_flow_step_validations',
'where id = :P583_ID and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique el nombre del nuevo componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228176326836279725.4001)
,p_name=>'P596_VALIDATION_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Secuencia de Validaci\00F3n de Destino')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(validation_sequence), 0) + 10 as r',
'  from wwv_flow_step_validations',
' where flow_id      = :FB_FLOW_ID',
'   and flow_step_id = :P583_TARGET_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(230804716954808682.4001)
,p_name=>'P596_WHEN_BUTTON_PRESSED'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_prompt=>unistr('Si Se Hace Clic en el Bot\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :P583_TARGET_PAGE',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:P583_TARGET_PAGE, ui.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n de Bot\00F3n -')
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este componente s\00F3lo se ejecutar\00E1 si un usuario hace clic en este bot\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231545918917701626.4001)
,p_name=>'P596_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>'P583_COPY_FROM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 la validaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231546810044708580.4001)
,p_name=>'P596_COPY_FROM_VALIDATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_prompt=>unistr('Copiar Validaci\00F3n:')
,p_source=>'P583_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_sequence||''. ''||validation_name vname,id',
'from wwv_flow_step_validations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by validation_sequence'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Validaci\00F3n que se va a copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231547729091714017.4001)
,p_name=>'P596_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(228174021252279715.4001)
,p_prompt=>unistr('P\00E1gina de Destino:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P583_TARGET_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('P\00E1gina a la que se copiar\00E1 la validaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614707603588496332.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(228174913622279718.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614707960374496334.4001)
,p_event_id=>wwv_flow_api.id(614707603588496332.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(228177219107279729.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Validation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_validation in (select * from wwv_flow_step_validations where id = :P583_ID)',
'    loop',
'        wwv_flow_api.create_page_validation (',
'            p_flow_id                   => l_validation.flow_id,',
'            p_flow_step_id              => nvl(:P583_TARGET_PAGE, l_validation.flow_step_id),',
'            p_tabular_form_region_id    => :P596_TABULAR_FORM_REGION_ID,',
'            p_validation_name           => :P596_VALIDATION_NAME,',
'            p_validation_sequence       => :P596_VALIDATION_SEQUENCE,',
'            p_validation                => l_validation.validation,',
'            p_validation2               => l_validation.validation2,',
'            p_validation_type           => l_validation.validation_type,',
'            p_error_message             => l_validation.error_message,',
'            p_always_execute            => l_validation.always_execute,',
'            p_validation_condition      => l_validation.validation_condition,',
'            p_validation_condition2     => l_validation.validation_condition2,',
'            p_validation_condition_type => l_validation.validation_condition_type,',
'            p_exec_cond_for_each_row    => l_validation.exec_cond_for_each_row,',
'            p_only_for_changed_rows     => l_validation.only_for_changed_rows,',
'            p_when_button_pressed       => :P596_WHEN_BUTTON_PRESSED,',
'            p_associated_item           => null,',
'            p_associated_column         => l_validation.associated_column,',
'            p_error_display_location    => l_validation.error_display_location,',
'            p_security_scheme           => l_validation.security_scheme,',
'            p_required_patch            => l_validation.required_patch,',
'            p_validation_comment        => l_validation.validation_comment );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar la validaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(228175125952279719.4001)
,p_process_success_message=>unistr('Validaci\00F3n copiada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614707321677493325.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(228175125952279719.4001)
,p_process_success_message=>unistr('Validaci\00F3n copiada.')
);
end;
/
prompt --application/pages/page_00597
begin
wwv_flow_api.create_page(
 p_id=>597.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar C\00E1lculo: Opciones de C\00E1lculo')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar C\00E1lculo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46180427158832819.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228277012259047608.4001)
,p_plug_name=>unistr('Copiar C\00E1lculo')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228277203418047610.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(228264919955974373.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(228277615545047611.4001)
,p_name=>unistr('C\00E1lculos de P\00E1gina de Destino')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    c.computation_sequence, c.computation_item, c.computation_type, c.computation_point',
'from ',
'    wwv_flow_step_computations c',
'where ',
'    c.flow_step_id = :P592_TARGET_PAGE',
'and c.flow_id      = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay ning\00FAn c\00E1lculo definido actualmente en la p\00E1gina de destino.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228288402790130207.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPUTATION_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228288517835130209.4001)
,p_query_column_id=>2
,p_column_alias=>'COMPUTATION_ITEM'
,p_column_display_sequence=>2
,p_column_heading=>'Elemento'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228288630243130209.4001)
,p_query_column_id=>3
,p_column_alias=>'COMPUTATION_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(62977815884897285)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228878811574293141.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPUTATION_POINT'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Punto de C\00E1lculo')
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(62981024179015035)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228278715597047641.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46180427158832819.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228278911799047642.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46180427158832819.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228279110230047642.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46180427158832819.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:592:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(228280928917047661.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228279302052047643.4001)
,p_name=>'P597_COMPUTATION_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(228277012259047608.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Secuencia de C\00E1lculo de Destino')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(computation_sequence) + 10 r',
'from WWV_FLOW_STEP_COMPUTATIONS',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228890316862351424.4001)
,p_name=>'P597_TARGET_COMP_ITEM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(228277012259047608.4001)
,p_prompt=>'Elemento de Destino a Calcular'
,p_source=>'select computation_item from wwv_flow_step_computations where id = :P592_ID and flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique el elemento que se va a calcular.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231138803475732018.4001)
,p_name=>'P597_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(228277012259047608.4001)
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>'P592_COPY_FROM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 el c\00E1lculo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231143804299741735.4001)
,p_name=>'P597_COPY_COMPUTATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(228277012259047608.4001)
,p_prompt=>unistr('Copiar de C\00E1lculo:')
,p_source=>'P592_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COMPUTATION_SEQUENCE||''. ''||COMPUTATION_ITEM comp, id',
'from wwv_flow_step_computations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by COMPUTATION_SEQUENCE'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('C\00E1lculo que se va a copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231146216766745390.4001)
,p_name=>'P597_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(228277012259047608.4001)
,p_prompt=>unistr('P\00E1gina de Destino:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P592_TARGET_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('P\00E1gina a la que se copiar\00E1 el c\00E1lculo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(229750629393585134.4001)
,p_validation_name=>'P597_TARGET_COMP_ITEM_not_null'
,p_validation_sequence=>10
,p_validation=>'P597_TARGET_COMP_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el elemento de p\00E1gina de destino.')
,p_when_button_pressed=>wwv_flow_api.id(228278911799047642.4001)
,p_associated_item=>wwv_flow_api.id(228890316862351424.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(228280321676047646.4001)
,p_validation_name=>'P597_COMPUTATION_SEQUENCE Not Null'
,p_validation_sequence=>20
,p_validation=>'P597_COMPUTATION_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la secuencia de c\00E1lculo.')
,p_when_button_pressed=>wwv_flow_api.id(228278911799047642.4001)
,p_associated_item=>wwv_flow_api.id(228279302052047643.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614711135766549518.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(228278715597047641.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614711410773549518.4001)
,p_event_id=>wwv_flow_api.id(614711135766549518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(228280729656047660.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Computation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select *',
'              from wwv_flow_step_computations',
'             where id = :P592_ID )',
'loop',
'    wwv_flow_api.create_page_computation (',
'        p_flow_id                   => c1.flow_id,',
'        p_flow_step_id              => nvl(:P592_TARGET_PAGE,c1.flow_step_id),',
'        p_computation_sequence      => :P597_COMPUTATION_SEQUENCE,',
'        p_computation_item          => case when :P597_TARGET_COMP_ITEM = ''%null%'' then c1.computation_item else :P597_TARGET_COMP_ITEM end,',
'        p_computation_point         => c1.computation_point,',
'        p_computation_item_type     => c1.computation_item_type,',
'        p_computation_type          => c1.computation_type,',
'        p_computation_language      => c1.computation_language,',
'        p_computation_processed     => c1.computation_processed,',
'        p_computation               => c1.computation,',
'        p_computation_comment       => c1.computation_comment,',
'        p_compute_when              => c1.compute_when,',
'        p_compute_when_type         => c1.compute_when_type,',
'        p_computation_error_message => c1.computation_error_message,',
'        p_compute_when_text         => c1.compute_when_text,',
'        p_security_scheme           => c1.security_scheme,',
'        p_required_patch            => c1.required_patch );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar el c\00E1lculo.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(228278911799047642.4001)
,p_process_success_message=>unistr('C\00E1lculo copiado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614711657299551659.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(228278911799047642.4001)
,p_process_success_message=>unistr('C\00E1lculo copiado.')
);
end;
/
prompt --application/pages/page_00598
begin
wwv_flow_api.create_page(
 p_id=>598.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Componentes de Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Componentes de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202765631744772348.4001)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(209189830803496670.4001)
,p_plug_name=>'Export details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(209190006085496675.4001)
,p_plug_name=>'Install Components warning'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P598_INSTALL'
,p_plug_display_when_cond2=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Al instalar componentes de un archivo de exportaci\00F3n de componentes en la aplicaci\00F3n actual, los componentes existentes primero'),
unistr('   se suprimen y, a continuaci\00F3n, se instalan los nuevos.</p>'),
unistr('<p>En el caso de que todas las sentencias sean correctas, la instalaci\00F3n se confirma y los cambios se hacen permanentes. Si se encuentran'),
unistr('   errores, se realiza un rollback de la instalaci\00F3n sin ning\00FAn cambio permanente.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(209190421715496677.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217476332405195095.4001)
,p_plug_name=>unistr('No se han podido instalar los componentes de la aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_source=>'sys.htp.p( wwv_flow_lang.system_message( ''F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'' ) );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P598_INSTALL'
,p_plug_display_when_cond2=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747143554198138166.4001)
,p_plug_name=>unistr('Instalar Componentes de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(209190624600496680.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202765631744772348.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>'P598_INSTALL'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217743812889955852.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202765631744772348.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(209190831733496684.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202765631744772348.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(209196915844496731.4001)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:COMP:&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(209196708154496729.4001)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:COMP:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(209190624600496680.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209191031588496687.4001)
,p_name=>'P598_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Id'
,p_source=>'P49_FILE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209191210653496692.4001)
,p_name=>'P598_LOGGED_IN_COMPANY2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Conectado al Espacio de Trabajo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el espacio de trabajo actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209191718095496696.4001)
,p_name=>'P598_LOGGED_IN_COMPANY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_source=>'&WORKSPACE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209191905987496697.4001)
,p_name=>'P598_IMP_COMPANY2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&COMPANY.'
,p_prompt=>unistr('Espacio de Trabajo de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p598_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nombre de espacio de trabajo del archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209192413555496701.4001)
,p_name=>'P598_IMP_COMPANY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_prompt=>unistr('Identificador de Espacio de Trabajo de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p598_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identificador de espacio de trabajo del archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209192919490496703.4001)
,p_name=>'P598_IMP_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_prompt=>unistr('Aplicaci\00F3n de Archivo de Exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Es el identificador de aplicaci\00F3n contenido en el archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209193914713496705.4001)
,p_name=>'P598_IMP_VERSION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p598_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la versi\00F3n de la API en el archivo de exportaci\00F3n. Determina si el archivo de exportaci\00F3n es compatible con la versi\00F3n actual de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209194925270496711.4001)
,p_name=>'P598_PARSE_AS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209195108937496712.4001)
,p_name=>'P598_INSTALL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(209189830803496670.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(209195311350496715.4001)
,p_computation_sequence=>10
,p_computation_item=>'P598_PARSE_AS'
,p_computation_type=>'QUERY'
,p_computation=>'select owner from wwv_flows where id = :P598_IMP_FLOW_ID and security_group_id = :P598_LOGGED_IN_COMPANY;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'INSTALL:REPLACE'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(210918906294143586.4001)
,p_computation_sequence=>20
,p_computation_item=>'P598_IMP_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_imp_parser.get_flow_id (p_file_id => :p49_file_id)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(210914002738085724.4001)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P598_IMP_FLOW_ID'
,p_compute_when=>'select 1 from wwv_flows where id=:P598_IMP_FLOW_ID and security_group_id=:FLOW_SECURITY_GROUP_ID and :FB_FLOW_ID is null'
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(209195511077496719.4001)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p598_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No Compatible (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de &PRODUCT_NAME.)')
,p_when_button_pressed=>wwv_flow_api.id(209190624600496680.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(209195715799496722.4001)
,p_validation_name=>'valid export file'
,p_validation_sequence=>20
,p_validation=>':P598_IMP_COMPANY is not null and :P598_IMP_FLOW_ID is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de componentes de &PRODUCT_NAME. v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(209190624600496680.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(209196129425496723.4001)
,p_validation_name=>'component export from same app'
,p_validation_sequence=>30
,p_validation=>'(:P598_IMP_FLOW_ID = :FB_FLOW_ID) and (:flow_security_group_id = wwv_flow_imp_parser.get_security_group_id(:p49_file_id))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Los componentes no se han exportado desde esta aplicaci\00F3n o se han exportado desde un espacio de trabajo diferente.')
,p_when_button_pressed=>wwv_flow_api.id(209190624600496680.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(209196315059496725.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine page import company action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :flow_security_group_id = wwv_flow_imp_parser.get_security_group_id(:p49_file_id) and',
'  wwv_flow_imp_parser.get_flow_id (p_file_id => :p49_file_id) = :FB_FLOW_ID then',
'  :P598_INSTALL := ''Y'';',
'',
'else',
'  :P598_INSTALL := ''N'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(209196524386496728.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_imp_parser.parse (',
'     p_file_id          => :P598_FILE_ID,',
'     p_parse_as_schema  => :P598_PARSE_AS,',
'     p_install_as_flow  => :FB_FLOW_ID,',
'     p_original_flow_id => wwv_flow_imp_parser.get_flow_id(:P598_FILE_ID),',
'     p_adjust_offset    => false',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al instalar componentes de aplicaci\00F3n.')
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Componentes de aplicaci\00F3n instalados.')
);
end;
/
prompt --application/pages/page_00599
begin
wwv_flow_api.create_page(
 p_id=>599.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Referencia de Servicio Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Editar Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15044202411659238.4001)
,p_plug_name=>'Referencia de Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(716353047314823637.4001)
,p_plug_name=>'Barra de Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15044804120659245.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(716353047314823637.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P599_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15044717260659245.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(716353047314823637.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P599_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15044626319659245.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(716353047314823637.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15046226715659255.4001)
,p_branch_name=>'Go To Page 170'
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15045824324659250.4001)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15044626319659245.4001)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15046624430659260.4001)
,p_name=>'P599_ID'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_api.id(15044202411659238.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15047023078659274.4001)
,p_name=>'P599_NAME'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(15044202411659238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre para la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15047802065659282.4001)
,p_name=>'P599_URL'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(15044202411659238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Punto Final'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la URL utilizada para llamar al servicio web. Puede hacer referencia al estado de sesi\00F3n en la URL con la convenci\00F3n'),
'<code>&amp;ITEM_NAME.</code>.</p>',
'<p>Por ejemplo:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31180714336167685.4001)
,p_name=>'P599_BASIC_AUTH'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(15044202411659238.4001)
,p_prompt=>unistr('Autenticaci\00F3n B\00E1sica:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indica si este servicio web necesita autenticaci\00F3n b\00E1sica. Las credenciales de autenticaci\00F3n b\00E1sica se env\00EDan como parte de la solicitud HTTP sin cifrar. Los servicios web que utilizan autenticaci\00F3n b\00E1sica, normalmente tambi\00E9n utilizan el protocolo H')
||unistr('TTPS (SSL) ya que el nombre de usuario y la contrase\00F1a se env\00EDan sin cifrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439442006590047844.4001)
,p_name=>'P599_SOAP_VERSION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(15044202411659238.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1.1'
,p_prompt=>unistr('Versi\00F3n SOAP:')
,p_source=>'SOAP_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_SOAP_VERSION'
,p_lov=>'.'||wwv_flow_api.id(439439004288980949.4001)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Elija la versi\00F3n de la especificaci\00F3n SOAP que utiliza este servicio web, 1.1 o 1.2.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(31181815506177484.4001)
,p_computation_sequence=>10
,p_computation_item=>'P599_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_ws_operations',
'            where name = ''BASIC_AUTH''',
'              and ws_id = :P599_ID ) loop',
'  return ''Y'';',
'  exit;',
'end loop;',
'',
'return ''N'';'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15047500433659280.4001)
,p_validation_name=>'P599_NAME not null'
,p_validation_sequence=>4
,p_validation=>'P599_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(15047023078659274.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15056100755728156.4001)
,p_validation_name=>'P599_URL not null'
,p_validation_sequence=>14
,p_validation=>'P599_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar una direcci\00F3n URL de punto final.')
,p_when_button_pressed=>wwv_flow_api.id(15044717260659245.4001)
,p_associated_item=>wwv_flow_api.id(15047802065659282.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614672505360188735.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(15044626319659245.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614672634381188736.4001)
,p_event_id=>wwv_flow_api.id(614672505360188735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15048607217659289.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P599_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15049032385659292.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P599_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_SHARED_WEB_SERVICES.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15049400508659292.4001)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'599'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(15044804120659245.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614672738279188737.4001)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,Delete'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00600
begin
wwv_flow_api.create_page(
 p_id=>600.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla Basada en Servicio Web: Seleccionar Servicio Web y Operaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla Basada en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15582816281678881.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15577802944637145.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15583601521684042.4001)
,p_plug_name=>'Crear Pantalla Basada en Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57085813432339838.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_api.id(57083604297327751.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204715020445896617.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15584616543697813.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204715020445896617.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15585701437702997.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204715020445896617.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699462299166665144.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(204715020445896617.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15586127928703003.4001)
,p_branch_name=>'Go To Page 884'
,p_branch_action=>'f?p=&APP_ID.:884:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15585701437702997.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15642829151786604.4001)
,p_branch_name=>'Go To Page 600'
,p_branch_action=>'f?p=&FLOW_ID.:600:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699462321918666727.4001)
,p_branch_name=>'Go To Page 4716'
,p_branch_action=>'4716'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699462299166665144.4001)
,p_branch_sequence=>170
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14509114134384458.4001)
,p_name=>'P600_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(15583601521684042.4001)
,p_prompt=>'Interfaz de Usuario'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by display_seq'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'USER INTERFACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.display_name,',
'       i.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P259_USER_INTERFACE_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select count(*)',
'    from wwv_flow_user_interfaces',
'   where flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID ) = 1'))
,p_read_only_when2=>'SQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15597603824751001.4001)
,p_name=>'P600_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15583601521684042.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Servicio -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15601003955760429.4001)
,p_name=>'P600_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15583601521684042.4001)
,p_prompt=>unistr('Operaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P600_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P600_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('-- Seleccionar Operaci\00F3n --')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'nvl(:P600_WS_ID,''0'') != ''0'' and nvl(:P600_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la operaci\00F3n. La operaci\00F3n es el m\00E9todo que se va a ejecutar.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(191289820259315529.4001)
,p_name=>'P600_WEB_REF_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(15583601521684042.4001)
,p_prompt=>'Tipo de Referencia de Servicio Web'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_REF_TYPE'
,p_lov=>'.'||wwv_flow_api.id(191288700473281420.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'nvl(:P600_WS_ID,''0'') != ''0'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tipo de referencia web: Manual, basado en un WSDL o RESTful.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308896009396895266.4001)
,p_name=>'P600_OUTPUT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(15583601521684042.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(191290216805390292.4001)
,p_computation_sequence=>10
,p_computation_item=>'P600_WEB_REF_TYPE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(action,''NONE'') act ',
'             from wwv_flow_shared_web_services',
'            where id = :P600_WS_ID ) loop',
'  if c1.act in (''REST'',''NEW_SCHOOL'') then',
'    --:P600_IS_REST := ''Y'';',
'    return c1.act;',
'  else',
'    return ''MANUAL'';',
'  end if;',
'end loop;'))
,p_compute_when=>'P600_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(504396922779505413.4001)
,p_computation_sequence=>40
,p_computation_item=>'P600_OPERATION_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P600_WEB_REF_TYPE = ''REST'' then',
'  for c1 in (select id',
'             from wwv_flow_ws_operations',
'            where ws_id = :P600_WS_ID',
'              and name = ''doREST'' ) loop',
'    return c1.id;',
'  end loop;',
'else',
'  return null;',
'end if;'))
,p_compute_when=>'P600_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(309340112619908987.4001)
,p_computation_sequence=>50
,p_computation_item=>'P600_OUTPUT_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(static_parm_05 ,''x'')',
'  from wwv_flow_shared_web_services',
' where id = :P600_WS_ID'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15607611012771937.4001)
,p_validation_name=>'P600_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P600_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(15585701437702997.4001)
,p_associated_item=>wwv_flow_api.id(15597603824751001.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15639519108783722.4001)
,p_validation_name=>'P600_OPERATION_ID'
,p_validation_sequence=>20
,p_validation=>'nvl(:P600_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe seleccionar una operaci\00F3n.')
,p_validation_condition=>'nvl(:P600_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(15585701437702997.4001)
,p_associated_item=>wwv_flow_api.id(15601003955760429.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549716881405753329.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(15584616543697813.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549716959456753330.4001)
,p_event_id=>wwv_flow_api.id(549716881405753329.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14511205223438706.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set User Interface'
,p_process_sql_clob=>':P259_USER_INTERFACE_ID := :P600_USER_INTERFACE_ID;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(15585701437702997.4001)
,p_process_when=>'P600_USER_INTERFACE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17108307404622120.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clean up collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_INPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_OUTPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_OUTPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_AUTH_ITEMS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00602
begin
wwv_flow_api.create_page(
 p_id=>602.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Lista'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44571321397196170.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113499715437108875.4001)
,p_plug_name=>'Copiar Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231141421483737219.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(231136205422723196.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113499909712108877.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44571321397196170.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113500119769108879.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44571321397196170.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231105018441641749.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44571321397196170.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_condition=>':F4000_LAST_VIEW is null or :F4000_LAST_VIEW != 4500'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(113502400755108898.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(113500119769108879.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231105226504641751.4001)
,p_branch_action=>'f?p=&APP_ID.:658:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(231105018441641749.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113500308566108882.4001)
,p_name=>'P602_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(113499715437108875.4001)
,p_prompt=>'Copiar Lista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(NAME) ln, id',
'from WWV_FLOW_LISTS',
'where flow_id = :fb_flow_id ',
'order by upper(name)'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la lista que se va a copiar'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113504505247148611.4001)
,p_name=>'P602_LIST_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(113499715437108875.4001)
,p_prompt=>'Nuevo Nombre de Lista'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre de la lista que desea crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(113502013645108892.4001)
,p_validation_name=>'P602_ID'
,p_validation_sequence=>10
,p_validation=>'P602_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(113500119769108879.4001)
,p_associated_item=>wwv_flow_api.id(113500308566108882.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(113505717714152290.4001)
,p_validation_name=>'P602_LIST_NAME'
,p_validation_sequence=>20
,p_validation=>'P602_LIST_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(113500119769108879.4001)
,p_associated_item=>wwv_flow_api.id(113504505247148611.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574136284604781518.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(113499909712108877.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574136392476781519.4001)
,p_event_id=>wwv_flow_api.id(574136284604781518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(113502205694108895.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.copy_list(',
'  p_copy_from_list_id=> :P602_ID,',
'  p_new_list_name=> :P602_LIST_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar la lista'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(113500119769108879.4001)
,p_process_success_message=>'Lista Copiada'
);
end;
/
prompt --application/pages/page_00603
begin
wwv_flow_api.create_page(
 p_id=>603.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Lista de Valores'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44783904287156380.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113879931093982483.4001)
,p_plug_name=>'Copiar Lista de Valores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113880102948982483.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44783904287156380.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113880325340982485.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44783904287156380.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(113882119110982502.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113880529499982487.4001)
,p_name=>'P603_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(113879931093982483.4001)
,p_prompt=>'Copiar Lista de Valores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LOV_NAME||'' - ''||decode(substr(LOV_QUERY,1,1),''.'',m.s,m.d) n, id',
'from WWV_FLOW_LISTS_OF_VALUES$ lov,',
'  (select wwv_flow_lang.system_message(''F4000.DYNAMIC'') d,',
'          wwv_flow_lang.system_message(''F4000.STATIC'') s',
'   from dual) m',
'where flow_id = :fb_flow_id',
'order by upper(LOV_NAME)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Lista de Valores Existente --'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la lista que se va a copiar'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113881028384982490.4001)
,p_name=>'P603_LIST_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(113879931093982483.4001)
,p_prompt=>'Nuevo Nombre de Lista de Valores'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre de la lista que desea crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(113881529390982493.4001)
,p_validation_name=>'P603_ID'
,p_validation_sequence=>10
,p_validation=>'P603_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(113880325340982485.4001)
,p_associated_item=>wwv_flow_api.id(113880529499982487.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(113881728480982496.4001)
,p_validation_name=>'P603_LIST_NAME'
,p_validation_sequence=>20
,p_validation=>'P603_LIST_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(113880325340982485.4001)
,p_associated_item=>wwv_flow_api.id(113881028384982490.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590015712860897550.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(113880102948982483.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590116543450572001.4001)
,p_event_id=>wwv_flow_api.id(590015712860897550.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(113881917517982498.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy list of values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.copy_named_lov(',
'                    p_copy_from_flow_id => :FB_FLOW_ID,',
'                    p_flow_id     => :fb_flow_id,',
'                    p_lov_id_from => :P603_ID,',
'                    p_lov_name_to => upper(:P603_LIST_NAME),',
'                    p_lov_id_to   => wwv_flow.GET_UNIQUE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar la lista de valores'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(113880325340982485.4001)
,p_process_success_message=>'Lista de valores copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590116663134572002.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(113880325340982485.4001)
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Lista de valores copiada.'
);
end;
/
prompt --application/pages/page_00605
begin
wwv_flow_api.create_page(
 p_id=>605.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla Basada en Servicio Web: Atributos de P\00E1gina y de Regi\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla Basada en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15442908402483978.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15577802944637145.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15443723344483985.4001)
,p_plug_name=>'Crear Pantalla Basada en Servicio Web'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204723130367965699.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15444526658483988.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(204723130367965699.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15444932518483990.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204723130367965699.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15445327883483990.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204723130367965699.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34904519302002538.4001)
,p_branch_name=>'Go To Page 4716'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::P4716_PREV_PAGE_ID:&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15444932518483990.4001)
,p_branch_sequence=>25
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15451923580484038.4001)
,p_branch_name=>'Go To Page 620'
,p_branch_action=>'f?p=&FLOW_ID.:620:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15444932518483990.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(122028012317759802.4001)
,p_branch_action=>'f?p=&APP_ID.:605:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P605_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15452309328484039.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15445327883483990.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P362_OPT'
,p_branch_condition_text=>'R'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15447123675484001.4001)
,p_name=>'P605_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina que contenga la nueva pantalla o introduzca un nuevo n\00FAmero de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15447712088484005.4001)
,p_name=>'P605_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la p\00E1gina si se est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15448423106484007.4001)
,p_name=>'P605_REGION_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>unistr('T\00EDtulo de la Regi\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la regi\00F3n en la que aparecer\00E1 la pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15449111431484009.4001)
,p_name=>'P605_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(default_form_template,default_region_template) from wwv_flow_themes where flow_id = :fb_flow_id',
'and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una plantilla de regi\00F3n para la nueva regi\00F3n de pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22376114956149124.4001)
,p_name=>'P605_WS_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Referencia de Servicio Web:'
,p_source=>'P600_WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indica el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22377024999151938.4001)
,p_name=>'P605_OPERATION_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Operaci\00F3n:')
,p_source=>'P600_OPERATION_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P600_WS_ID'))
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indica la operaci\00F3n. La operaci\00F3n es el m\00E9todo que se va a ejecutar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34903811898990975.4001)
,p_name=>'P605_IS_REST'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>'Is Rest'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45237030953227737.4001)
,p_name=>'P605_PAGE_MODE'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122022025908744875.4001)
,p_name=>'P605_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122024418675756604.4001)
,p_name=>'P605_BREADCRUMB_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P605_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381726584092989012.4001)
,p_name=>'P605_BREADCRUMB_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P605_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P605_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P605_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(404572689103900842.4001)
,p_name=>'P605_GROUP_NAME'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_api.id(15443723344483985.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(15449916947484013.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P605_PAGE_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1941061326797452757.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P605_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(192326127586636396.4001)
,p_computation_sequence=>5
,p_computation_item=>'P605_PAGE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from wwv_flow_shared_web_services where id = :P600_WS_ID'
,p_compute_when=>'P605_PAGE_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165429626996801501.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(192325310617631546.4001)
,p_computation_sequence=>20
,p_computation_item=>'P605_REGION_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_region_title varchar2(4000);',
'begin',
'  l_region_title := :P605_PAGE_NAME;',
'  for c1 in (select name from wwv_flow_ws_operations where id = :P600_OPERATION_ID ) loop',
'    l_region_title := c1.name;',
'  end loop;',
'  return l_region_title;',
'end;'))
,p_compute_when=>'P605_REGION_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34904008220999424.4001)
,p_computation_sequence=>30
,p_computation_item=>'P605_IS_REST'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''doREST''',
'   and id = :P600_OPERATION_ID'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15450304649484026.4001)
,p_validation_name=>'P605_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P605_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(15444932518483990.4001)
,p_associated_item=>wwv_flow_api.id(15447123675484001.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(15450707544484027.4001)
,p_validation_name=>'P605_PAGE_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'P605_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el t\00EDtulo de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(15447712088484005.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45237527287229458.4001)
,p_validation_name=>'P605_PAGE_MODE Not Null'
,p_validation_sequence=>3
,p_validation=>'P605_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(15444932518483990.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(404573126780902107.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P605_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P605_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(15444932518483990.4001)
,p_associated_item=>wwv_flow_api.id(404572689103900842.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1136581968452333624.4001)
,p_validation_name=>'P605_BREADCRUMB_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P605_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P605_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(15444932518483990.4001)
,p_associated_item=>wwv_flow_api.id(122024418675756604.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381728297354002062.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P605_BREADCRUMB_ID'
,p_condition_element=>'P605_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381728570785002062.4001)
,p_event_id=>wwv_flow_api.id(381728297354002062.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_BREADCRUMB_NAME,P605_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381728711832002063.4001)
,p_event_id=>wwv_flow_api.id(381728297354002062.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_BREADCRUMB_NAME,P605_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549717032947753331.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(15444526658483988.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549717110949753332.4001)
,p_event_id=>wwv_flow_api.id(549717032947753331.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1941061625921454398.4001)
,p_name=>'set region name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P605_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941062598462454398.4001)
,p_event_id=>wwv_flow_api.id(1941061625921454398.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P605_PAGE_NAME'
,p_attribute_07=>'P605_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941062007640454398.4001)
,p_event_id=>wwv_flow_api.id(1941061625921454398.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P605_PAGE_NAME'
,p_attribute_07=>'P605_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00606
begin
wwv_flow_api.create_page(
 p_id=>606.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Comentarios del Desarrollador'
,p_step_title=>'Comentarios del Desarrollador'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5048802885667873.4001)
,p_plug_name=>'Comentarios del Desarrollador'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       pages, ',
'       case when length(app_comment) > 200 then',
'           substr(app_comment,1,200)||''...''',
'       else',
'          app_comment',
'       end app_comment,',
'       created_on,',
'       created_by,',
'       to_char(created_on,''YYYY.MM.DD'') linked_created_on',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(5048902946667873.4001)
,p_name=>'Developer Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_download_filename=>'application_comments.csv'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:RP,1236:P1236_ID:#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." class="editDevComment" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5049122900667883.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'javascript:popupURL(''f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'');'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" border="0" alt="&EDIT." title="&EDIT.">'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5049225811667884.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5049311933667887.4001)
,p_db_column_name=>'PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina(s)')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5049413199667887.4001)
,p_db_column_name=>'APP_COMMENT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5049517685667888.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Fecha de Creaci\00F3n')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5049617086667888.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185221631463398633.4001)
,p_db_column_name=>'LINKED_CREATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Creado el'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(777399892767703802.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(784788000174894142.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(777400143178703805.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(786331487669013778.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1000724887721503630.4001)
,p_plug_name=>'Comentarios del Desarrollador'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Utilice Comentarios del Desarrollador para agregar comentarios a una aplicaci\00F3n, a una p\00E1gina o a un grupo de p\00E1ginas en una aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1000724925921503631.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5048802885667873.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:606,RIR:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(125693123853892007.4001)
,p_branch_action=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1000724477798503626.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'606'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(746162431239515825.4001)
,p_name=>'Submit Page on Create Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(386920635912182000.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(746165249577534895.4001)
,p_event_id=>wwv_flow_api.id(746162431239515825.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(746227137432587695.4001)
,p_name=>'Submit Page on Edit/Delete Dialog Close'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(5048802885667873.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(746227441979587719.4001)
,p_event_id=>wwv_flow_api.id(746227137432587695.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00611
begin
wwv_flow_api.create_page(
 p_id=>611.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Aplicaci\00F3n: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23839028027634444.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(23817524863605164.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46514529279030177.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(115191424096008027.4001)
,p_plug_name=>unistr('Copiar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.copy_application (',
'    p_old_app_id    => :P499_OLD_APP_ID,',
'    p_old_app_name  => :P499_OLD_APP_NAME,',
'    p_new_app_id    => :P499_NEW_APP_ID,',
'    p_new_app_name  => :P499_NEW_APP_NAME,',
'    p_copy_deployment => :P499_COPY_DEPLOYMENT',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115191909919008029.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46514529279030177.4001)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar Aplicaci\00F3n')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115192021865008029.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46514529279030177.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115191824495008029.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(46514529279030177.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1137943140511956660.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(115192408479008031.4001)
,p_branch_action=>'f?p=&APP_ID.:499:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(115192021865008029.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590117084684572006.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(115191824495008029.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590117138178572007.4001)
,p_event_id=>wwv_flow_api.id(590117084684572006.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1119157430779390637.4001)
,p_name=>'Submit with Wait Indicator'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(115191909919008029.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1119157525112390638.4001)
,p_event_id=>wwv_flow_api.id(1119157430779390637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'COPY'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1330465520218911739.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(115191909919008029.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select 1 ',
'   from wwv_flows',
'  where id = :P499_OLD_APP_ID',
'    and build_status = ''RUN_AND_HIDDEN'''))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(115346504692769666.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.copy_application (',
'    p_old_application_id => :P499_OLD_APP_ID,',
'    p_new_application_id => :P499_NEW_APP_ID,',
'    p_new_name           => :P499_NEW_APP_NAME,',
'    p_export_sup_objects => :P499_COPY_DEPLOYMENT );',
'',
':FB_FLOW_ID      := :P499_NEW_APP_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P499_NEW_APP_ID;',
':F4000_P1_PAGE   := ''1'';  '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar la aplicaci\00F3n &P499_OLD_APP_ID..')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(115191909919008029.4001)
);
end;
/
prompt --application/pages/page_00616
begin
wwv_flow_api.create_page(
 p_id=>616.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Gr\00E1fico: Atributos de P\00E1gina y de Regi\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Gr\00E1fico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5131626840158646)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1127606797324046.4001)
,p_plug_name=>unistr('Crear Gr\00E1fico')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1196224252544857.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1192927752498551.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44462220958789130.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1128018372324047.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44462220958789130.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1128304724324047.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44462220958789130.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34943418523771495.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44462220958789130.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1128710547324047.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1128304724324047.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1189806160208443.4001)
,p_branch_name=>'Go To Page 616'
,p_branch_action=>'f?p=&APP_ID.:616:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P616_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16664715856266336.4001)
,p_branch_name=>'Go To Page 751'
,p_branch_action=>'f?p=&APP_ID.:751:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34943418523771495.4001)
,p_branch_sequence=>15
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P751_CHART_ENGINE = ''JET_CHART'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1127923813324046.4001)
,p_name=>'P616_APP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1146127999847804.4001)
,p_name=>'P616_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione una p\00E1gina en la que aparecer\00E1 el objeto gr\00E1fico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1148108522861087.4001)
,p_name=>'P616_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si va a crear una p\00E1gina nueva, introduzca un nombre de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1153613595928758.4001)
,p_name=>'P616_BREADCRUMB_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1161717862488304.4001)
,p_name=>'P616_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P616_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45042211008812571.4001)
,p_name=>'P616_PAGE_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); ',
''))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381747942931349239.4001)
,p_name=>'P616_BREADCRUMB_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(1127606797324046.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P616_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P616_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P616_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940941156695741796.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P616_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16957329064421776.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1198007255662893.4001)
,p_validation_name=>'P616_PAGE_ID not null'
,p_validation_sequence=>10
,p_validation=>'P616_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el n\00FAmero de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(1128304724324047.4001)
,p_associated_item=>wwv_flow_api.id(1146127999847804.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1199619853676065.4001)
,p_validation_name=>'P616_PAGE_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P616_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(1128304724324047.4001)
,p_associated_item=>wwv_flow_api.id(1148108522861087.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45042902598816481.4001)
,p_validation_name=>'P616_PAGE_MODE not null'
,p_validation_sequence=>25
,p_validation=>'P616_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(1128304724324047.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1202920461695084.4001)
,p_validation_name=>'P616_BREADCRUMB_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P616_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P616_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(1128304724324047.4001)
,p_associated_item=>wwv_flow_api.id(1161717862488304.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(481365619088094512.4001)
,p_validation_name=>'P616_PAGE_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'trunc(abs(:P616_PAGE_ID)) = :P616_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(1128304724324047.4001)
,p_associated_item=>wwv_flow_api.id(1146127999847804.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381749146433354685.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P616_BREADCRUMB_ID'
,p_condition_element=>'P616_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381749408790354685.4001)
,p_event_id=>wwv_flow_api.id(381749146433354685.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P616_BREADCRUMB_NAME,P616_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381749646677354686.4001)
,p_event_id=>wwv_flow_api.id(381749146433354685.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P616_BREADCRUMB_NAME,P616_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548168788649560270.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1128018372324047.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548169062203560273.4001)
,p_event_id=>wwv_flow_api.id(548168788649560270.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1940939880637740756.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P616_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940940279730740756.4001)
,p_event_id=>wwv_flow_api.id(1940939880637740756.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P616_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P616_PAGE_NAME'
,p_attribute_07=>'P616_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16674031271658752.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Chart Type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P751_CHART_TYPE = ''DOT'' then',
'    :P731_DEFAULT_CHART_TYPE := ''ScatterMarker'';',
'elsif :P751_CHART_TYPE= ''LINE'' then',
'    :P731_DEFAULT_CHART_TYPE := ''2DLine'';',
'elsif :P751_CHART_TYPE = ''CANDLE'' then',
'    :P731_DEFAULT_CHART_TYPE := ''Candlestick'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00617
begin
wwv_flow_api.create_page(
 p_id=>617.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Acceso Directo'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Acceso Directo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47733924859691443.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(115644826701673864.4001)
,p_plug_name=>'Copiar Acceso Directo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115645017438673865.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47733924859691443.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115645209511673866.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47733924859691443.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(115647012720673880.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115645432695673868.4001)
,p_name=>'P617_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(115644826701673864.4001)
,p_prompt=>'Copiar Acceso Directo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SHORTCUT_NAME d, id',
'from WWV_FLOW_SHORTCUTS',
'where flow_id = :fb_flow_id',
'order by upper(SHORTCUT_NAME)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar M\00E9todo Abreviado -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique los componentes que se van a copiar'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115645926125673872.4001)
,p_name=>'P617_SHORTCUT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(115644826701673864.4001)
,p_prompt=>unistr('Nombre de M\00E9todo Abreviado')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre del nuevo componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115646416690673876.4001)
,p_validation_name=>'P617_ID'
,p_validation_sequence=>20
,p_validation=>'P617_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(115645209511673866.4001)
,p_associated_item=>wwv_flow_api.id(115645432695673868.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(115646610323673877.4001)
,p_validation_name=>'P617_SHORTCUT_NAME'
,p_validation_sequence=>30
,p_validation=>'P617_SHORTCUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(115645209511673866.4001)
,p_associated_item=>wwv_flow_api.id(115645926125673872.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590011504514897508.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(115645017438673865.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590011687753897509.4001)
,p_event_id=>wwv_flow_api.id(590011504514897508.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(115646805024673879.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Shortcut'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * from WWV_FLOW_SHORTCUTS where id = :P617_ID) loop',
'insert into WWV_FLOW_SHORTCUTS (',
'    ID,',
'    FLOW_ID,',
'    SHORTCUT_NAME,',
'    SHORTCUT_CONSIDERATION_SEQ,',
'    SHORTCUT_TYPE,',
'    SHORTCUT_CONDITION_TYPE1,',
'    SHORTCUT_CONDITION1,',
'    SHORTCUT_CONDITION_TYPE2,',
'    SHORTCUT_CONDITION2,',
'    BUILD_OPTION,',
'    ERROR_TEXT,',
'    SHORTCUT,',
'    REFERENCE_ID,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON,',
'    COMMENTS)',
'values (',
'    wwv_flow.GET_UNIQUE_ID,',
'    :fb_flow_id,',
'    :P617_SHORTCUT_NAME,',
'    c1.SHORTCUT_CONSIDERATION_SEQ,',
'    c1.SHORTCUT_TYPE,',
'    c1.SHORTCUT_CONDITION_TYPE1,',
'    c1.SHORTCUT_CONDITION1,',
'    c1.SHORTCUT_CONDITION_TYPE2,',
'    c1.SHORTCUT_CONDITION2,',
'    c1.BUILD_OPTION,',
'    c1.ERROR_TEXT,',
'    c1.SHORTCUT,',
'    c1.REFERENCE_ID,',
'    v(''USER''),',
'    sysdate,',
'    c1.COMMENTS);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar el acceso directo'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(115645209511673866.4001)
,p_process_success_message=>unistr('M\00E9todo abreviado copiado')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590011781573897510.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(115645209511673866.4001)
,p_process_success_message=>unistr('M\00E9todo abreviado copiado')
);
end;
/
prompt --application/pages/page_00618
begin
wwv_flow_api.create_page(
 p_id=>618.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Opci\00F3n de Copia de P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44110105120524104.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200885221418238033.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203598727799647411.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18564606387816293.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200885601455238055.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44110105120524104.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200885906224238055.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44110105120524104.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200906803039333407.4001)
,p_branch_name=>'Go To Page 301'
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301,302,305,308,309,315::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P618_COPY_OPTION'
,p_branch_condition_text=>'SAME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200886204418238068.4001)
,p_branch_name=>'Go To Page 621'
,p_branch_action=>'f?p=&APP_ID.:621:&SESSION.::&DEBUG.:621,622,623,625,627,628,671,677,COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200885906224238055.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P618_COPY_OPTION'
,p_branch_condition_text=>'DIFF'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200885432550238047.4001)
,p_name=>'P618_COPY_OPTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200885221418238033.4001)
,p_item_default=>'SAME'
,p_prompt=>unistr('Crear P\00E1gina como Copia de:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COPY_PAGE_OPTION'
,p_lov=>'.'||wwv_flow_api.id(200992128346618114.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifica c\00F3mo copiar una p\00E1gina. Puede copiarla de la aplicaci\00F3n actual o de otra aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614682128425246247.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(200885601455238055.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614682467199246247.4001)
,p_event_id=>wwv_flow_api.id(614682128425246247.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00621
begin
wwv_flow_api.create_page(
 p_id=>621.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: P\00E1gina a Copiar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'function f_NewPageName(){  ',
'var oldPage = html_GetElement("P621_COPY_FROM_PAGE_S").value;',
'var newPageName = oldPage.substring(oldPage.indexOf('':'')+1,oldPage.length);',
'html_GetElement("P621_COPY_TO_PAGE_NAME").value = newPageName;',
'}',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44701729689747300.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200888526697238079.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203150116324615743.4001)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200888929176238082.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44701729689747300.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200889226645238082.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44701729689747300.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200889110035238082.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44701729689747300.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200889800023238085.4001)
,p_branch_name=>'Tab Options'
,p_branch_action=>'f?p=&APP_ID.:671:&SESSION.::&DEBUG.:COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200889226645238082.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P621_TO_USER_INTERFACE_ID,',
'    p_name              => ''TABS'' )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(348317320143739017.4001)
,p_branch_name=>'Skip Tab Options'
,p_branch_action=>'f?p=&APP_ID.:622:&SESSION.::&DEBUG.:COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200889226645238082.4001)
,p_branch_sequence=>15
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_user_interface_dev.supports_feature ( ',
'    p_user_interface_id => :P621_TO_USER_INTERFACE_ID,',
'    p_name              => ''TABS'' )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201036929833101189.4001)
,p_branch_action=>'f?p=&APP_ID.:621:&SESSION.::&DEBUG.:COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P621_BREADCRUMB_ID'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200889527926238083.4001)
,p_branch_action=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200889110035238082.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200912330098369680.4001)
,p_name=>'P621_COPY_FROM_PAGE_S'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>unistr('Copiar de P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name d, id||'':''||name r',
'from wwv_flow_steps',
'where flow_id = :P621_COPY_FROM_FLOW_ID and security_group_id = :flow_security_group_id',
'order by id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar P\00E1gina -')
,p_lov_cascade_parent_items=>'P621_COPY_FROM_FLOW_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'onchange="f_NewPageName();"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200918128544407052.4001)
,p_name=>'P621_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>unistr('Copiar en Nuevo N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el n\00FAmero de la nueva p\00E1gina.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200919109282410953.4001)
,p_name=>'P621_COPY_TO_PAGE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>unistr('Nuevo Nombre de P\00E1gina')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_steps',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el nombre de la nueva p\00E1gina.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201020122290004353.4001)
,p_name=>'P621_BREADCRUMB_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201025614156039833.4001)
,p_name=>'P621_BREADCRUMB_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P621_COPY_TO_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201032519528079282.4001)
,p_name=>'P621_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>'Entrada Principal'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P621_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P621_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P621_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210197205404936550.4001)
,p_name=>'P621_COPY_FROM_PAGE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(213030604400880376.4001)
,p_name=>'P621_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from wwv_flow_visible_flows f',
' where id != :fb_flow_id',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n que contiene la p\00E1gina que desea copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348250608957378310.4001)
,p_name=>'P621_TO_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>'Interfaz de Usuario'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by display_seq'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'USER INTERFACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.display_name,',
'       i.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
' order by 1'))
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la interfaz de usuario para la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348251103134380947.4001)
,p_name=>'P621_TO_UI_TYPE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348253113677406513.4001)
,p_name=>'P621_FROM_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_prompt=>'User Interface'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select count(*)',
'    from wwv_flow_user_interfaces',
'   where flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID ) = 1'))
,p_read_only_when2=>'SQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la interfaz de usuario para la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348255126135461479.4001)
,p_name=>'P621_FROM_UI_TYPE_ID'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(617342549459532471.4001)
,p_name=>'P621_COPY_PUBLIC_REPORTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Copiar Informes P\00FAblicos')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Todos los informes por defecto se copian autom\00E1ticamente sin necesidad de especificarlo; si desea copiar informes p\00FAblicos, deber\00E1 especificarlo en la p\00E1gina. Estas son las opciones disponibles:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong>: copia informes p\00FAblicos en la p\00E1gina.</li>'),
unistr('<li><strong>Desactivado</strong>:no copia informes p\00FAblicos en la p\00E1gina.</li>'),
'</ul>',
'<p />',
unistr('Los informes p\00FAblicos son la configuraci\00F3n de informes compartidos p\00FAblicos que han guardado los usuarios a partir de los informes interactivos o las cuadr\00EDculas interactivas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(617343384352538544.4001)
,p_name=>'P621_DISPLAY_COPY_PUB_RPT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1555955042909298943.4001)
,p_name=>'P621_NAVIGATION_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(200888526697238079.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(209717915047016923.4001)
,p_computation_sequence=>10
,p_computation_item=>'P621_COPY_FROM_PAGE_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(:P621_COPY_FROM_PAGE_S,1,instr(:P621_COPY_FROM_PAGE_S,'':'',1)-1)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(348254211052453337.4001)
,p_computation_sequence=>20
,p_computation_item=>'P621_FROM_USER_INTERFACE_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_interface_id',
'  from wwv_flow_steps',
' where flow_id           = :P621_COPY_FROM_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :P621_COPY_FROM_PAGE_ID'))
,p_compute_when=>':P621_COPY_FROM_PAGE_ID is not null and :P621_COPY_FROM_FLOW_ID is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(348255222230465164.4001)
,p_computation_sequence=>30
,p_computation_item=>'P621_FROM_UI_TYPE_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ui_type_id',
'  from wwv_flow_user_interfaces',
'where flow_id           = :P621_COPY_FROM_FLOW_ID',
'  and id                = :P621_FROM_USER_INTERFACE_ID',
'  and security_group_id = :flow_security_group_id'))
,p_compute_when=>':P621_COPY_FROM_FLOW_ID is not null and :P621_FROM_USER_INTERFACE_ID is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(348251205252384635.4001)
,p_computation_sequence=>40
,p_computation_item=>'P621_TO_UI_TYPE_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ui_type_id',
'  from wwv_flow_user_interfaces',
'where flow_id           = :FB_FLOW_ID',
'  and id                = :P621_TO_USER_INTERFACE_ID',
'  and security_group_id = :flow_security_group_id'))
,p_compute_when=>'P621_TO_USER_INTERFACE_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1555955167333303850.4001)
,p_computation_sequence=>70
,p_computation_item=>'P621_NAVIGATION_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where x.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
'   and x.flow_id           = i.flow_id',
'   and i.id                = :P621_TO_USER_INTERFACE_ID',
'   and i.theme_id          = x.theme_id',
' order by 1'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(348251523825386618.4001)
,p_validation_name=>'Page Contains Interactive Report'
,p_validation_sequence=>1
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_user_interface_dev.supports_feature ( ',
'       p_user_interface_id => :P621_TO_USER_INTERFACE_ID,',
'       p_name              => ''INTERACTIVE_REPORT'' )',
' then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Una p\00E1gina que contiene un informe interactivo s\00F3lo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:P621_COPY_FROM_PAGE_ID is not null and :P621_COPY_FROM_FLOW_ID is not null) ',
'and wwv_flow_wizard_api.ir_report_exists( ',
'        p_flow_id => :P621_COPY_FROM_FLOW_ID, ',
'        p_page_id => :P621_COPY_FROM_PAGE_ID)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(348252116277390138.4001)
,p_validation_name=>'Page Contains Tree'
,p_validation_sequence=>4
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if  wwv_flow_user_interface_dev.supports_feature ( ',
'        p_user_interface_id => :P621_TO_USER_INTERFACE_ID,',
'        p_name              => ''JSTREE'' )',
' then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Una p\00E1gina que contiene un jsTree s\00F3lo se puede copiar en una p\00E1gina con una interfaz de usuario de escritorio.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(:P621_COPY_FROM_PAGE_ID is not null and :P621_COPY_FROM_FLOW_ID is not null) ',
'and wwv_flow_wizard_api.jstree_exists( ',
'        p_flow_id => :P621_COPY_FROM_FLOW_ID, ',
'        p_page_id => :P621_COPY_FROM_PAGE_ID)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(213206125094905243.4001)
,p_validation_name=>'P621_COPY_FROM_FLOW_ID'
,p_validation_sequence=>10
,p_validation=>'P621_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(213030604400880376.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200921514261421811.4001)
,p_validation_name=>'P621_COPY_FROM_PAGE_S'
,p_validation_sequence=>20
,p_validation=>'P621_COPY_FROM_PAGE_S'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(200912330098369680.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200922629152426104.4001)
,p_validation_name=>'P621_COPY_TO_PAGE_ID'
,p_validation_sequence=>30
,p_validation=>'P621_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia en p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(200918128544407052.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200923707466429369.4001)
,p_validation_name=>'P621_COPY_TO_PAGE_NAME'
,p_validation_sequence=>40
,p_validation=>'P621_COPY_TO_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nuevo nombre de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(200919109282410953.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(201035505246094051.4001)
,p_validation_name=>'P621_BREADCRUMB_NAME'
,p_validation_sequence=>50
,p_validation=>'P621_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P621_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(201025614156039833.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(204511228237472376.4001)
,p_validation_name=>'P621_COPY_TO_PAGE_ID must be num'
,p_validation_sequence=>60
,p_validation=>'P621_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La copia en p\00E1gina debe ser num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(200918128544407052.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200925032400436507.4001)
,p_validation_name=>'copy to page does not exist'
,p_validation_sequence=>70
,p_validation=>'select 1 from wwv_flow_steps where id = :P621_COPY_TO_PAGE_ID and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Esta p\00E1gina ya existe.')
,p_validation_condition=>'P621_COPY_TO_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_api.id(200889226645238082.4001)
,p_associated_item=>wwv_flow_api.id(200918128544407052.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614677601291224118.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(200888929176238082.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614677951665224119.4001)
,p_event_id=>wwv_flow_api.id(614677601291224118.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(610892897500688724.4001)
,p_name=>'on copy from app and page change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_COPY_FROM_FLOW_ID,P621_COPY_FROM_PAGE_S'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(610892987273688725.4001)
,p_event_id=>wwv_flow_api.id(610892897500688724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_display_copy_pub_rpt varchar2(1) := ''N'';',
'begin ',
'    :P621_COPY_FROM_PAGE_ID := substr(:P621_COPY_FROM_PAGE_S,1,instr(:P621_COPY_FROM_PAGE_S,'':'',1)-1);',
'    for l_region in (select null',
'                     from wwv_flow_page_plugs',
'                     where flow_id = :P621_COPY_FROM_FLOW_ID',
'                     and page_id = :P621_COPY_FROM_PAGE_ID',
'                     and plug_source_type in ( wwv_flow_region_native.c_ir, wwv_flow_region_native.c_ig ) )',
'    loop',
'        l_display_copy_pub_rpt := ''Y'';',
'        exit;',
'    end loop;',
'    :P621_DISPLAY_COPY_PUB_RPT :=  l_display_copy_pub_rpt;',
'end;'))
,p_attribute_02=>'P621_COPY_FROM_PAGE_S,P621_COPY_FROM_PAGE_ID'
,p_attribute_03=>'P621_COPY_FROM_PAGE_ID,P621_DISPLAY_COPY_PUB_RPT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(610893080106688726.4001)
,p_name=>'if display copy public report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_DISPLAY_COPY_PUB_RPT'
,p_condition_element=>'P621_DISPLAY_COPY_PUB_RPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(610893145592688727.4001)
,p_event_id=>wwv_flow_api.id(610893080106688726.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(610893208341688728.4001)
,p_event_id=>wwv_flow_api.id(610893080106688726.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1331350277607223304.4001)
,p_name=>'Show breadcrumb attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_BREADCRUMB_ID'
,p_condition_element=>'P621_BREADCRUMB_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1331350355257223305.4001)
,p_event_id=>wwv_flow_api.id(1331350277607223304.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_PARENT_ID,P621_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1331350554621223307.4001)
,p_event_id=>wwv_flow_api.id(1331350277607223304.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_PARENT_ID,P621_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00622
begin
wwv_flow_api.create_page(
 p_id=>622.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Plantillas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44716807273797600.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200890329488238085.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(200956404695128712.4001)
,p_name=>'Plantillas'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'q:=q||''select decode(ttype, '';',
'q:=q||''  ''''PAGE'''',wwv_flow_lang.system_message_lit(''''F4000.PAGE''''), '';',
'q:=q||''  ''''REGION'''',wwv_flow_lang.system_message_lit(''''F4000.REGION''''), '';',
'q:=q||''  ''''LABEL'''',wwv_flow_lang.system_message_lit(''''LABEL''''), '';',
'q:=q||''  ''''LIST'''',wwv_flow_lang.system_message_lit(''''F4000.LIST_INITCAP''''), '';',
'q:=q||''  ''''POPUP_LOV'''',wwv_flow_lang.system_message_lit(''''F4000.P371.POPUP_LOV''''), '';',
'q:=q||''  ''''CALENDAR'''',wwv_flow_lang.system_message_lit(''''LEGACY_CALENDAR''''), '';',
'q:=q||''  ''''MENU'''',wwv_flow_lang.system_message_lit(''''F4000.MENU''''), '';',
'q:=q||''  ''''BUTTON'''',wwv_flow_lang.system_message_lit(''''F4000.BUTTON''''), '';',
'q:=q||''  ''''REPORT'''',wwv_flow_lang.system_message_lit(''''REPORT''''), '';',
'q:=q||''  ''''POPUP_LOV'''',wwv_flow_lang.system_message_lit(''''F4000.P371.POPUP_LOV''''), '';',
'q:=q||''  ''''trans-''''||ttype) temp_type, '';  ',
'q:=q||''  tname from_template, '';',
'	',
'  q:=q||''CASE '';',
'	q:=q||''when to_counter = 0 then '';',
'  q:=q||''(SELECT htmldb_item.hidden(1,x.id)||htmldb_item.hidden(2,ta.temp_type)||'';',
'  q:=q||''HTMLDB_ITEM.SELECT_LIST_FROM_QUERY_XL(3, '';',
'  q:=q||'' 	  ta.theme_class_id||'''':''''||ta.id, '';',
'  q:=q||'' 	  ''''SELECT wwv_flow_escape.html(name) d,theme_class_id||'''''''':''''''''||id v FROM wwv_flow_templates_all where flow_id=''''||:fb_flow_id|| '';',
'  q:=q||'' 		 '''' and theme_id in (select max(theme_id) from wwv_flow_user_interfaces where flow_id=''''||:fb_flow_id||'''' and ui_type_id =''''||:P621_TO_UI_TYPE_ID||'''') ''''|| '';    ',
'  q:=q||''  '''' and temp_type = ''''''''''''||x.ttype||'''''''''''' order by 1'''', '';',
'  q:=q||''  ''''title="''''||wwv_flow_lang.system_message(''''F4000.P622.TO_TEMPLATE'''')||''''"'''',''''NO'''',null,null,null,null,''''NO''''	 ) '';',
'  q:=q||'' from wwv_flow_templates_all ta '';',
'  q:=q||'' where ta.flow_id = :fb_flow_id '';',
'  q:=q||'' 	  and theme_id in (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID)'';    ',
'  q:=q||'' 	  and ta.temp_type = x.ttype and rownum = 1) '';',
'  ',
'  q:=q||''when to_counter = 1 then '';',
'  q:=q||''(SELECT htmldb_item.hidden(4,x.id)||htmldb_item.hidden(5,ta.temp_type)||htmldb_item.hidden(6,ta.theme_class_id||'''':''''||ta.id)||to_clob(wwv_flow_escape.html(ta.name)) '';',
'  q:=q||'' from wwv_flow_templates_all ta '';',
'  q:=q||'' where ta.flow_id = :fb_flow_id '';',
'  q:=q||'' 	  and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id and ui_type_id = :P621_TO_UI_TYPE_ID) '';  ',
'  q:=q||'' 	  and ta.theme_class_id = x.THEME_CLASS_ID '';',
'  q:=q||'' 	  and ta.temp_type = x.ttype and rownum = 1) '';',
'',
'  q:=q||''when to_counter > 1 then '';',
'  q:=q||''(SELECT htmldb_item.hidden(1,x.id)||htmldb_item.hidden(2,ta.temp_type)||'';',
'  q:=q||''HTMLDB_ITEM.SELECT_LIST_FROM_QUERY_XL(3, '';',
'  q:=q||''         (select theme_class_id||'''':''''||id from wwv_flow_templates_all where flow_id=:fb_flow_id and theme_class_id = x.THEME_CLASS_ID and name = x.tname and rownum = 1), '';',
'  q:=q||'' 	  ''''SELECT wwv_flow_escape.html(name) d,theme_class_id||'''''''':''''''''||id v FROM wwv_flow_templates_all where flow_id=''''||:fb_flow_id|| '';',
'  q:=q||'' 		 '''' and theme_id in (select max(theme_id) from wwv_flow_user_interfaces where flow_id=''''||:fb_flow_id||''''and ui_type_id =''''||:P621_TO_UI_TYPE_ID||'''') ''''|| '';    ',
'  q:=q||''  '''' and temp_type = ''''''''''''||x.ttype||'''''''''''' order by 1'''', '';',
'  q:=q||''  ''''title="''''||wwv_flow_lang.system_message(''''F4000.P622.TO_TEMPLATE'''')||''''"'''',''''NO'''',null,null,null,null,''''NO''''	 ) '';',
'  q:=q||'' from wwv_flow_templates_all ta '';',
'  q:=q||'' where ta.flow_id = :fb_flow_id '';',
'  q:=q||'' 	  and theme_id in (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id) '';  ',
'  q:=q||'' 	  and ((ta.theme_class_id = x.THEME_CLASS_ID or ta.theme_class_id <> x.THEME_CLASS_ID ) or ta.theme_class_id = 0 or ta.theme_class_id is null) '';',
'  q:=q||'' 	  and ta.temp_type = x.ttype and rownum = 1) '';',
'  q:=q||''end to_template, ''; ',
'',
'   q:=q||''     CASE ''; ',
'   q:=q||''      when to_counter > 1 then '';',
'    q:=q||''         wwv_flow_lang.system_message_lit(''''WARNING_MULTIPLE_MATCHES'''') '';',
'   q:=q||''      when to_counter = 1 then '';',
'   q:=q||''        ''''<span class="a-Icon icon-check"></span>'''''';                                                          ',
'   q:=q||''      when to_counter = 0 then '';',
'  q:=q||''           wwv_flow_lang.system_message_lit(''''WARNING_MISSING_CLASS'''') '';',
'  q:=q||''     end status '';',
'',
'',
'--end if;',
'q:=q||''from ''; ',
'q:=q||''(select '';  ',
'q:=q||''  p.flow_id, '';',
'q:=q||''  ''''PAGE'''' ttype, '';',
'q:=q||''  wwv_flow_escape.html(p.name) tname, '';',
'q:=q||''  p.theme_id, '';',
'q:=q||''  p.theme_class_id, '';',
'q:=q||''  p.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = p.THEME_CLAS'
||'S_ID and is_popup = p.is_popup and temp_type = ''''PAGE'''') to_counter '';',
'q:=q||''from wwv_flow_templates p '';',
'q:=q||''where p.flow_id = :P621_COPY_FROM_FLOW_ID and  '';',
'q:=q||''      id = nvl((select STEP_TEMPLATE from wwv_flow_steps where flow_id = :P621_COPY_FROM_FLOW_ID and id = :P621_COPY_FROM_PAGE_ID), '';',
'q:=q||''           (select t.default_page_template from wwv_flow_steps p, wwv_flow_user_interfaces i, wwv_flow_themes t '';',
'q:=q||''             where p.flow_id  = :P621_COPY_FROM_FLOW_ID and p.id = :P621_COPY_FROM_PAGE_ID and i.flow_id  = p.flow_id '';',
'q:=q||''               and i.id = p.user_interface_id and t.flow_id  = i.flow_id and t.theme_id = i.theme_id)) '';',
'q:=q||''union all '';',
'q:=q||''select distinct '';',
'q:=q||''p.flow_id, '';',
'q:=q||''''''REGION'''' ttype,  '';                                                                                                                    ',
'q:=q||''wwv_flow_escape.html(t.PAGE_PLUG_TEMPLATE_NAME) tname, '';',
'q:=q||''t.theme_id, '';',
'q:=q||''t.theme_class_id, '';',
'q:=q||''t.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = t.THEME_CLAS'
||'S_ID and temp_type = ''''REGION'''') to_counter '';',
'q:=q||''from wwv_flow_page_plugs p, '';',
'q:=q||''     WWV_FLOW_PAGE_PLUG_TEMPLATES t '';',
'q:=q||''where p.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      p.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      p.plug_template = t.id (+) and '';',
'q:=q||''      t.PAGE_PLUG_TEMPLATE_NAME is not null '';  ',
'q:=q||''union all '';',
'q:=q||''select      distinct i.flow_id, '';',
'q:=q||''''''LABEL'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(f.TEMPLATE_NAME) tname, '';',
'q:=q||''f.theme_id, '';',
'q:=q||''f.theme_class_id, '';',
'q:=q||''f.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = f.THEME_CLAS'
||'S_ID and temp_type = ''''LABEL'''') to_counter '';',
'q:=q||''from wwv_flow_field_templates f, '';',
'q:=q||''     wwv_flow_step_items i '';',
'q:=q||''where  '';',
'q:=q||''      i.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''     i.ITEM_FIELD_TEMPLATE = f.id(+) and '';',
'q:=q||''     i.flow_step_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''     template_name is not null '';  ',
'q:=q||''union all '';',
'q:=q||''select a.flow_id, ''''POPUP_LOV'''' ttype, '';',
'q:=q||''wwv_flow_lang.system_message_lit(''''F4000.P371.POPUP_LOV'''') tname, '';',
'q:=q||''a.theme_id, '';',
'q:=q||''a.theme_class_id, '';',
'q:=q||''a.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = a.THEME_CLAS'
||'S_ID and temp_type = ''''POPUP_LOV'''') to_counter '';',
'q:=q||''from WWV_FLOW_POPUP_LOV_TEMPLATE a '';',
'q:=q||''where a.flow_id = :P621_COPY_FROM_FLOW_ID  '';  ',
'q:=q||''and a.theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id =  :P621_COPY_FROM_FLOW_ID and ui_type_id = :P621_FROM_UI_TYPE_ID) '';',
'q:=q||''and exists (select 1 '';',
'q:=q||''              from wwv_flow_step_items i '';',
'q:=q||''              where  '';',
'q:=q||''                    i.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''                    i.flow_step_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''                    display_as like ''''POPUP%'''') '';  ',
'q:=q||''union all '';',
'q:=q||''select   distinct b.flow_id,''''BUTTON'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(b.TEMPLATE_NAME) tname, '';',
'q:=q||''b.theme_id, '';',
'q:=q||''b.theme_class_id, '';',
'q:=q||''b.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = b.theme_clas'
||'s_id and temp_type = ''''BUTTON'''') to_counter '';',
'q:=q||''from wwv_flow_button_templates b, '';',
'q:=q||''(select button_template_id, button_name '';',
'q:=q||'' from WWV_FLOW_STEP_BUTTONS '';',
'q:=q||'' where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID ) u '';',
'q:=q||''where b.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      b.id = u.button_template_id ''; ',
'q:=q||''union all '';',
'q:=q||''select     distinct '';',
'q:=q||''t.flow_id, '';',
'q:=q||''''''CALENDAR'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(t.NAME) tname, '';',
'q:=q||''t.theme_id, '';',
'q:=q||''t.theme_class_id, '';',
'q:=q||''t.id,  ''; ',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = t.theme_clas'
||'s_id and temp_type = ''''CALENDAR'''') to_counter '';',
'q:=q||''from  wwv_flow_cal_templates t, ''; ',
'q:=q||''      wwv_flow_cals c, '';',
'q:=q||''      wwv_flow_page_plugs r '';',
'q:=q||''where t.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      c.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      c.plug_id = r.id and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.flow_Id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      t.id      = c.template_id '';  ',
'q:=q||''union all '';',
'q:=q||''select     distinct '';',
'q:=q||''t.flow_id, '';',
'q:=q||''''''MENU'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(t.NAME) tname, '';',
'q:=q||''t.theme_id, '';',
'q:=q||''t.theme_class_id, '';',
'q:=q||''t.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = t.theme_clas'
||'s_id and temp_type = ''''MENU'''') to_counter '';',
'q:=q||''from wwv_flow_menu_templates t, wwv_flow_page_plugs r '';',
'q:=q||''where t.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.menu_template_id = t.id ''; ',
'q:=q||''union all '';',
'q:=q||''select distinct '';',
'q:=q||''ro.flow_id, '';',
'q:=q||''''''REPORT'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(ro.ROW_TEMPLATE_NAME) tname, '';',
'q:=q||''ro.theme_id, '';',
'q:=q||''ro.theme_class_id, '';',
'q:=q||''ro.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = ro.theme_cla'
||'ss_id and temp_type = ''''REPORT'''') to_counter '';',
'q:=q||''from wwv_flow_row_templates ro, '';',
'q:=q||''     wwv_flow_page_plugs r '';',
'q:=q||''where ro.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.PLUG_QUERY_ROW_TEMPLATE = ro.id '';  ',
'q:=q||''union all '';',
'q:=q||''select distinct t.flow_id, '';',
'q:=q||''       ''''LIST'''' ttype, '';',
'q:=q||''       wwv_flow_escape.html(t.LIST_TEMPLATE_NAME) tname, '';',
'q:=q||''       t.theme_id, '';',
'q:=q||''       t.theme_class_id, '';',
'q:=q||''       t.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flow_user_interfaces where flow_id = :fb_flow_id  and ui_type_id = :P621_TO_UI_TYPE_ID) and theme_class_id = t.theme_clas'
||'s_id and temp_type = ''''LIST'''') to_counter '';',
'q:=q||''from WWV_FLOW_LIST_TEMPLATES t, ''; ',
'q:=q||''     wwv_flow_page_plugs r '';',
'q:=q||''where t.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.list_template_id = t.id) x '';',
'q:=q||''order by 1 '';',
'return q;',
'end;'))
,p_header=>unistr('<p>Al copiar una p\00E1gina de otra aplicaci\00F3n, todas las plantillas utilizadas por esa p\00E1gina se deben asignar a las plantillas de la aplicaci\00F3n actual. Este informe muestra las plantillas de la p\00E1gina de la que est\00E1 copiando. Revise el informe y asigne')
||' la plantilla correcta.</p>'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No se hace referencia a ninguna plantilla en la p\00E1gina desde la que est\00E1 copiando.')
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200963301774317122.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMP_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Plantilla'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200963615975317123.4001)
,p_query_column_id=>2
,p_column_alias=>'FROM_TEMPLATE'
,p_column_display_sequence=>2
,p_column_heading=>'De Plantilla'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(205164829885245414.4001)
,p_query_column_id=>3
,p_column_alias=>'TO_TEMPLATE'
,p_column_display_sequence=>3
,p_column_heading=>'A Plantilla'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(359723632095392352.4001)
,p_query_column_id=>4
,p_column_alias=>'STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203151025674618429.4001)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200890713171238086.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44716807273797600.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200891015733238086.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44716807273797600.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200890915007238086.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44716807273797600.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200891622822238088.4001)
,p_branch_name=>'Go To Page 623'
,p_branch_action=>'f?p=&APP_ID.:623:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200891015733238086.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1      ',
'from (select distinct i.named_lov lov_name, ',
'               i.flow_id,',
'               i.flow_step_id page_id,              ',
'               r.plug_name region,',
'               i.name used',
'    from wwv_flow_step_items i, wwv_flow_page_plugs r',
'    where i.flow_id = :P621_COPY_FROM_FLOW_ID and ',
'          i.flow_step_id = :P621_COPY_FROM_PAGE_ID and',
'          r.page_id = i.flow_step_id and',
'          r.flow_id = i.flow_id and',
'          i.item_plug_id = r.id and',
'          i.named_lov is not null     ',
'    union    ',
'    select distinct l.lov_name lov_name,',
'           c.flow_id flow_id,',
'           r.page_id page_id,',
'           r.plug_name region,',
'           c.column_alias used',
'    from wwv_flow_region_report_column c, wwv_flow_page_plugs r, wwv_flow_lists_of_values$ l',
'    where c.flow_id = :P621_COPY_FROM_FLOW_ID and',
'          r.page_id = :P621_COPY_FROM_PAGE_ID and',
'          c.region_id = r.id and',
'          c.named_lov = l.id and',
'          r.flow_id = c.flow_id    ',
'    union',
'    select distinct k.lov_name lov_name, ',
'           m.flow_id flow_id,',
'           m.page_id page_id,',
'           n.name region,',
'           m.DB_COLUMN_NAME used',
'    from wwv_flow_worksheet_columns m, wwv_flow_lists_of_values$ k, WWV_FLOW_WORKSHEETS n',
'    where m.flow_id = :P621_COPY_FROM_FLOW_ID and',
'          n.page_id = :P621_COPY_FROM_PAGE_ID and',
'          m.rpt_named_lov = k.id and',
'          m.worksheet_id = n.id and',
'          n.flow_id = m.flow_id ',
'    union',
'    select distinct l.lov_name lov_name,',
'           c.flow_id flow_id,',
'           r.page_id page_id,',
'           r.plug_name region,',
'           c.name used',
'    from wwv_flow_region_columns c, wwv_flow_page_plugs r, wwv_flow_lists_of_values$ l',
'    where c.flow_id = :P621_COPY_FROM_FLOW_ID and',
'          r.page_id = :P621_COPY_FROM_PAGE_ID and',
'          c.region_id = r.id and',
'          ( c.lov_id = l.id or c.filter_lov_id = l.id ) and',
'          r.flow_id = c.flow_id ) l'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203809932132686579.4001)
,p_branch_name=>'Go To Page 625'
,p_branch_action=>'f?p=&APP_ID.:625:&SESSION.::&DEBUG.::P625_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200891015733238086.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from (select distinct (select name ',
'                           from WWV_FLOW_LISTS ',
'                          where id = p.plug_source_type ',
'                            and flow_id = :P621_COPY_FROM_FLOW_ID) list_name,',
'               flow_id,',
'               page_id,',
'               plug_name',
'          from wwv_flow_page_plugs p',
'         where plug_source_type = ''NATIVE_LIST''',
'           and page_id = :P621_COPY_FROM_PAGE_ID ',
'           and flow_id = :P621_COPY_FROM_FLOW_ID) l'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203813002612696993.4001)
,p_branch_name=>'Go To Page 627'
,p_branch_action=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::P627_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200891015733238086.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from (select s.scheme',
'from (select required_role scheme',
'        from wwv_flow_steps',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct plug_required_role scheme',
'        from wwv_flow_page_plugs',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct i.security_scheme scheme',
'        from wwv_flow_step_items i',
'        where i.flow_id = :P621_COPY_FROM_FLOW_ID and i.flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct b.security_scheme scheme',
'        from wwv_flow_step_buttons b',
'        where b.flow_id = :P621_COPY_FROM_FLOW_ID and b.flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_validations',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_computations',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_processing',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_branches',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID) s    ',
'where s.scheme is not null',
'and replace(translate(s.scheme,''1234567890'',''0000000000''),''0'') is null) ss'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(208037623645852924.4001)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200891015733238086.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_branches',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203821909454717884.4001)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200891015733238086.4001)
,p_branch_sequence=>50
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200891318893238087.4001)
,p_branch_name=>'Tab Options'
,p_branch_action=>'f?p=&APP_ID.:671:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200890915007238086.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204092612383955288.4001)
,p_name=>'P622_PREV_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(200956404695128712.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348401801060870987.4001)
,p_name=>'P622_FROM_THEME_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(200890329488238085.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348402329946872841.4001)
,p_name=>'P622_TO_THEME_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(200890329488238085.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(348402916360879113.4001)
,p_computation_sequence=>10
,p_computation_item=>'P622_TO_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(theme_id) ',
'  from wwv_flow_user_interfaces',
' where flow_id    = :fb_flow_id ',
'   and ui_type_id = :P621_TO_UI_TYPE_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(348409602126885687.4001)
,p_computation_sequence=>10
,p_computation_item=>'P622_FROM_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(theme_id) ',
'  from wwv_flow_user_interfaces',
' where flow_id    = :P621_COPY_TO_FLOW_ID ',
'   and ui_type_id = :P621_FROM_UI_TYPE_ID'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614676415875216188.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(200890713171238086.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614676731641216189.4001)
,p_event_id=>wwv_flow_api.id(614676415875216188.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205147300802959476.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'handle template mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  la_f03           wwv_flow_global.vc_arr2;',
'  la_f06           wwv_flow_global.vc_arr2;',
'  l_theme_class_id number := null;',
'  l_template_id    number := null;',
'begin',
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_TEMPLATES'');',
'',
'for i in 1..HTMLDB_APPLICATION.G_F04.count loop',
'  ',
'   la_f06 := wwv_flow_utilities.string_to_table2(htmldb_application.g_f06(i));	',
'	l_theme_class_id := la_f06(1);',
'	l_template_id    := la_f06(2);',
'',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''COPY_PAGE_TEMPLATES'',',
'    p_c001              => HTMLDB_APPLICATION.G_F04(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F05(i),',
'    p_c003              => l_template_id,',
'    p_c004              => l_theme_class_id,   ',
'    p_generate_md5      => ''YES'' );',
'end loop;',
'',
' for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'	-- since g_f03 value is theme_class_id||'':''||id, extract each value by turning into an array',
'	la_f03 := wwv_flow_utilities.string_to_table2(htmldb_application.g_f03(i));	',
'	l_theme_class_id := la_f03(1);',
'	l_template_id := la_f03(2);',
'',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''COPY_PAGE_TEMPLATES'',',
'    p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'    p_c003              => l_template_id,',
'    p_c004              => l_theme_class_id,   ',
'    p_generate_md5      => ''YES'' );',
'end loop; ',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la recopilaci\00F3n de plantillas.')
,p_process_when_button_id=>wwv_flow_api.id(200891015733238086.4001)
);
end;
/
prompt --application/pages/page_00623
begin
wwv_flow_api.create_page(
 p_id=>623.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Lista de Valores')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="PageInit_623()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'',
'',
'function f_CopyOption(pThis,pThat){  ',
'  var lCheckValues = new Array(''NO'',''COPY'');',
'  var lTest2 = html_DisableOnValue(pThis,lCheckValues,pThat);',
'  html_GetElement(pThat).disabled = false;',
'  if(lTest2){',
'    html_GetElement(pThat).setAttribute(''onfocus'',''this.blur()'');',
'    }else{',
'    html_GetElement(pThat).setAttribute(''onfocus'','''');',
'  }',
'',
'}',
'',
'',
'function PageInit_623(){',
'var lThis = $x(''reportR201008603702857054'').getElementsByTagName(''TABLE'')[0];',
'var lRows = lThis.rows;',
'for(var i=1;i<lRows.length;i++){',
'var lSelect = lRows[i].cells[2];',
'if(lSelect){',
'	lSelect = lRows[i].cells[2].getElementsByTagName(''SELECT'')[0];',
'	lSelect.onchange()',
'}',
'} ',
'}',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44737115041960719.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(201008603702857054.4001)
,p_name=>'Copiar Listas de Valores'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_LOV'') and',
'   wwv_flow_collection.collection_member_count(p_collection_name => ''COPY_PAGE_LOV'') > 0',
'then',
'  q:=q||''select wwv_flow_item.hidden(3,c003)||wwv_flow_item.display_and_save(4,c004) old_lov_name, '';  ',
'  q:=q||''wwv_flow_item.display_and_save(5,c005) lov_type, '';     ',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(1,c001,''''COPY_SC_OPTION'''',''''onchange="f_CopyOption(this,''''''''id2_''''||rownum||'''''''''''')"'''',''''NO'''',null,null,''''id''''||1||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.COPY_OPTION'''',c004),''''NO'''') copy'
||'_option, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(2,c002,''''NAMED_LOV_RETURNING_ID'''',null,''''YES'''',''''0'''',wwv_flow_lang.system_message(''''COPY_PAGE.SELECT_NAMED_LOV''''),''''id''''||2||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.EXISTING_LOV'''',c004),'''
||'''NO'''') new_lov '';',
'  q:=q||''from htmldb_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_LOV'''''';    ',
'else    ',
'  q:=q||''select wwv_flow_item.hidden(3,l.lov_id)||wwv_flow_item.display_and_save(4,wwv_flow_escape.html(l.lov_name)) old_lov_name, '';  ',
'  q:=q||''wwv_flow_item.display_and_save(5,l.lov_type) lov_type, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(1,''''NO'''',''''COPY_SC_OPTION'''',''''onchange="f_CopyOption(this,''''''''id2_''''||rownum||'''''''''''')"'''',''''NO'''',null,null,''''id''''||1||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.COPY_OPTION'''',wwv_flow_escape.'
||'html(l.lov_name)),''''NO'''') copy_option, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(2,''''0'''',''''NAMED_LOV_RETURNING_ID'''',null,''''YES'''',''''0'''',wwv_flow_lang.system_message(''''COPY_PAGE.SELECT_NAMED_LOV''''),''''id''''||2||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.EXISTING_LOV'''',wwv_fl'
||'ow_escape.html(l.lov_name)),''''NO'''') new_lov ''; ',
'  q:=q||''from ( '';',
'  q:=q||''select distinct i.named_lov lov_name, '';',
'  q:=q||''   l.id lov_id, '';',
'  q:=q||''   decode(substr(l.LOV_QUERY,1,1), '';',
'  q:=q||''          ''''.'''', '';',
'  q:=q||''          wwv_flow_lang.system_message(''''F4000.STATIC''''), '';',
'  q:=q||''          wwv_flow_lang.system_message(''''F4000.DYNAMIC'''')) lov_type '';',
'  q:=q||''from wwv_flow_step_items i, wwv_flow_page_plugs r, wwv_flow_lists_of_values$ l '';',
'  q:=q||''where i.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'  q:=q||''i.flow_step_id = :P621_COPY_FROM_PAGE_ID and '';',
'  q:=q||''r.page_id = i.flow_step_id and '';',
'  q:=q||''r.flow_id = i.flow_id and '';',
'  q:=q||''i.item_plug_id = r.id and '';',
'  q:=q||''i.named_lov = l.lov_name and '';',
'  q:=q||''i.flow_id = l.flow_id and '';',
'  q:=q||''i.named_lov is not null ''; ',
'  q:=q||''union '';',
'  q:=q||''select distinct l.lov_name lov_name, '';',
'  q:=q||''       l.id lov_id, '';',
'  q:=q||''   decode(substr(l.LOV_QUERY,1,1), '';',
'  q:=q||''          ''''.'''', '';',
'  q:=q||''   wwv_flow_lang.system_message(''''F4000.STATIC''''), '';',
'  q:=q||''   wwv_flow_lang.system_message(''''F4000.DYNAMIC'''')) lov_type '';',
'  q:=q||''from wwv_flow_region_report_column c, wwv_flow_page_plugs r, wwv_flow_lists_of_values$ l '';',
'  q:=q||''where c.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'  q:=q||''r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'  q:=q||''c.region_id = r.id and '';',
'  q:=q||''c.named_lov = l.id and '';',
'  q:=q||''r.flow_id = c.flow_id '';',
'  q:=q||''union '';',
'  q:=q||''select distinct l.lov_name lov_name, '';',
'  q:=q||''       l.id lov_id, '';',
'  q:=q||''   decode(substr(l.LOV_QUERY,1,1), '';',
'  q:=q||''          ''''.'''', '';',
'  q:=q||''   wwv_flow_lang.system_message(''''F4000.STATIC''''), '';',
'  q:=q||''   wwv_flow_lang.system_message(''''F4000.DYNAMIC'''')) lov_type '';',
'  q:=q||''from wwv_flow_region_columns c, wwv_flow_page_plugs r, wwv_flow_lists_of_values$ l '';',
'  q:=q||''where c.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'  q:=q||''r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'  q:=q||''c.region_id = r.id and '';',
'  q:=q||''( c.lov_id = l.id or c.filter_lov_id = l.id ) and '';',
'  q:=q||''r.flow_id = c.flow_id '';',
'  q:=q||''union '';',
'  q:=q||''select distinct k.lov_name lov_name,  '';',
'  q:=q||''       k.id lov_id, '';  ',
'  q:=q||''   decode(substr(k.LOV_QUERY,1,1), '';',
'  q:=q||''          ''''.'''', '';',
'  q:=q||''   wwv_flow_lang.system_message(''''F4000.STATIC''''), '';',
'  q:=q||''   wwv_flow_lang.system_message(''''F4000.DYNAMIC'''')) lov_type '';',
'  q:=q||''      from wwv_flow_worksheet_columns m, wwv_flow_lists_of_values$ k, WWV_FLOW_WORKSHEETS n '';',
'  q:=q||''where m.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'  q:=q||''      n.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'  q:=q||''      m.rpt_named_lov = k.id and '';',
'  q:=q||''      m.worksheet_id = n.id and '';',
'  q:=q||''      n.flow_id = m.flow_id ) l'';',
'end if;  ',
'',
'return q;',
'end;'))
,p_header=>unistr('<p>Este informe muestra listas de valores con nombre utilizadas en la p\00E1gina de la que est\00E1 copiando. Revise el informe y seleccione una opci\00F3n de copia. Si selecciona <strong>Usar Existente</strong>, se debe elegir una lista de valores de la aplicac')
||unistr('i\00F3n actual.</p>')
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha utilizado ninguna lista de valores con nombre en la p\00E1gina desde la que est\00E1 copiando.')
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(209879200155062936.4001)
,p_query_column_id=>1
,p_column_alias=>'OLD_LOV_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Lista de Valores'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(209879312727062936.4001)
,p_query_column_id=>2
,p_column_alias=>'LOV_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(209879413949062936.4001)
,p_query_column_id=>3
,p_column_alias=>'COPY_OPTION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Opci\00F3n de Copia')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(209881804095073499.4001)
,p_query_column_id=>4
,p_column_alias=>'NEW_LOV'
,p_column_display_sequence=>4
,p_column_heading=>'Lista de Valores Existentes'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203153712645624124.4001)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226841702582547936.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200892522361238090.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44737115041960719.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200892627545238090.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44737115041960719.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200892718473238090.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44737115041960719.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200893424698238092.4001)
,p_branch_name=>'Go To Page 625'
,p_branch_action=>'f?p=&APP_ID.:625:&SESSION.::&DEBUG.::P625_PREV_PAGE:623&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200892627545238090.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from (select distinct (select name ',
'                           from WWV_FLOW_LISTS ',
'                          where id = p.plug_source_type ',
'                            and flow_id = :P621_COPY_FROM_FLOW_ID) list_name,',
'               flow_id,',
'               page_id,',
'               plug_name',
'          from wwv_flow_page_plugs p',
'         where plug_source_type = ''NATIVE_LIST''',
'           and page_id = :P621_COPY_FROM_PAGE_ID ',
'           and flow_id = :P621_COPY_FROM_FLOW_ID) l'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203827913525737935.4001)
,p_branch_name=>'Go To Page 627'
,p_branch_action=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::P627_PREV_PAGE:623'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200892627545238090.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from (select s.scheme',
'from (select required_role scheme',
'        from wwv_flow_steps',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct plug_required_role scheme',
'        from wwv_flow_page_plugs',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct i.security_scheme scheme',
'        from wwv_flow_step_items i',
'        where i.flow_id = :P621_COPY_FROM_FLOW_ID and i.flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct b.security_scheme scheme',
'        from wwv_flow_step_buttons b',
'        where b.flow_id = :P621_COPY_FROM_FLOW_ID and b.flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_validations',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_computations',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_processing',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_branches',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID) s    ',
'where s.scheme is not null',
'and replace(translate(s.scheme,''1234567890'',''0000000000''),''0'') is null) ss'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(208040117889860783.4001)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:623'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_branches',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203829717335739012.4001)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:623'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200892627545238090.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200893100762238091.4001)
,p_branch_action=>'f?p=&APP_ID.:622:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200892718473238090.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226843922793547961.4001)
,p_name=>'P623_PREV_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(226841702582547936.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(208358013929749022.4001)
,p_validation_name=>'existing lov must be selected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 copy_option,',
'            c002 new_lov,',
'            c003 old_lov',
'     from htmldb_collections where collection_name = ''COPY_PAGE_LOV'') ',
'loop',
' if c1.copy_option = ''EXISTING'' then',
'   if c1.new_lov = ''0'' then	      ',
'     return false;',
'   end if;',
' end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Se debe seleccionar la lista de valores existente.'
,p_when_button_pressed=>wwv_flow_api.id(200892627545238090.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614675866933213084.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(200892522361238090.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614676156919213084.4001)
,p_event_id=>wwv_flow_api.id(614675866933213084.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205219202056650569.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save copy LOV selection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_LOV'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'	if htmldb_application.g_f01(i) = ''EXISTING'' then',
'    htmldb_collection.add_member(',
'      p_collection_name   => ''COPY_PAGE_LOV'',',
'      p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'      p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'      p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'      p_c004              => HTMLDB_APPLICATION.G_F04(i),',
'      p_c005              => HTMLDB_APPLICATION.G_F05(i),',
'      p_generate_md5      => ''YES'' );',
'  else',
'  	htmldb_collection.add_member(',
'      p_collection_name   => ''COPY_PAGE_LOV'',',
'      p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'      p_c002              => 0,',
'      p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'      p_c004              => HTMLDB_APPLICATION.G_F04(i),',
'      p_c005              => HTMLDB_APPLICATION.G_F05(i),',
'      p_generate_md5      => ''YES'' );',
'  end if;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la recopilaci\00F3n de listas de valores.')
,p_process_when_button_id=>wwv_flow_api.id(200892627545238090.4001)
);
end;
/
prompt --application/pages/page_00625
begin
wwv_flow_api.create_page(
 p_id=>625.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Listas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="PageInit_625()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'',
'',
'function f_CopyOption(pThis,pThat){  ',
'  var lCheckValues = new Array(''NO'',''COPY'');',
'  var lTest2 = html_DisableOnValue(pThis,lCheckValues,pThat);',
'  html_GetElement(pThat).disabled = false;',
'  if(lTest2){',
'    html_GetElement(pThat).setAttribute(''onfocus'',''this.blur()'');',
'    }else{',
'    html_GetElement(pThat).setAttribute(''onfocus'','''');',
'  }',
'',
'}',
'',
'',
'function PageInit_625(){',
'var lThis = $x(''reportR201350330187500930'').getElementsByTagName(''TABLE'')[0];',
'var lRows = lThis.rows;',
'for(var i=1;i<lRows.length;i++){',
'var lSelect = lRows[i].cells[1];',
'if(lSelect){',
'	lSelect = lRows[i].cells[1].getElementsByTagName(''SELECT'')[0];',
'	lSelect.onchange()',
'}',
'} ',
'}',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44745812580007335.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(201350330187500930.4001)
,p_name=>'Copiar Listas'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_LIST'') and',
'   wwv_flow_collection.collection_member_count(p_collection_name => ''COPY_PAGE_LIST'') > 0',
'then',
'  q:=q||''select wwv_flow_item.hidden(3,c003)||wwv_flow_item.display_and_save(4,c004) old_list_name, '';   ',
'  q:=q||''wwv_flow_item.select_list_from_lov(1,c001,''''COPY_SC_OPTION'''',''''onchange="f_CopyOption(this,''''''''id2_''''||rownum||'''''''''''')"'''',''''NO'''',null,null,''''id''''||1||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.COPY_OPTION'''',c004),''''NO'''') copy_op'
||'tion, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(2,c002,''''LISTS'''',null,''''YES'''',''''0'''',wwv_flow_lang.system_message(''''COPY_PAGE.SELECT_LIST''''),''''id''''||2||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.EXISTING_LOV'''',c004),''''NO'''') new_list '';    ',
'  q:=q||''from htmldb_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_LIST'''''';  	',
'else	',
'	q:=q||''select wwv_flow_item.hidden(3,l.list_id)||wwv_flow_item.display_and_save(4,wwv_flow_escape.html(l.list_name)) old_list_name, '';	',
'  q:=q||''wwv_flow_item.select_list_from_lov(1,''''NO'''',''''COPY_SC_OPTION'''',''''onchange="f_CopyOption(this,''''''''id2_''''||rownum||'''''''''''')"'''',''''NO'''',null,null,''''id''''||1||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.COPY_OPTION'''',wwv_flow_escape.htm'
||'l(l.list_name)),''''NO'''') copy_option, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(2,''''0'''',''''LISTS'''',null,''''YES'''',''''0'''',wwv_flow_lang.system_message(''''COPY_PAGE.SELECT_LIST''''),''''id''''||2||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.EXISTING_LOV'''',wwv_flow_escape.html(l.list_'
||'name)),''''NO'''') new_list '';      ',
'  q:=q||''from ('';',
'  q:=q||''select distinct (select name from WWV_FLOW_LISTS where id = p.list_id and flow_id = :P621_COPY_FROM_FLOW_ID) list_name, '';',
'  q:=q||''list_id list_id '';',
'  q:=q||''from wwv_flow_page_plugs p '';',
'  q:=q||''where plug_source_type = ''''NATIVE_LIST'''' and '';',
'  q:=q||''page_id = :P621_COPY_FROM_PAGE_ID and '';',
'  q:=q||''flow_id = :P621_COPY_FROM_FLOW_ID) l'';',
'end if;  ',
'',
'return q;',
'end;'))
,p_header=>unistr('<p>Este informe muestra listas utilizadas en la p\00E1gina de la que est\00E1 copiando. Revise el informe y seleccione una opci\00F3n de copia. Si selecciona <strong>Usar Existente</strong>, se debe elegir una lista de la aplicaci\00F3n actual.</p>')
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>unistr('No se ha utilizado ninguna lista en la p\00E1gina de la que est\00E1 copiando.')
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208508500694907623.4001)
,p_query_column_id=>1
,p_column_alias=>'OLD_LIST_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Lista'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208508728637907623.4001)
,p_query_column_id=>2
,p_column_alias=>'COPY_OPTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Opci\00F3n de Copia')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208508821756907623.4001)
,p_query_column_id=>3
,p_column_alias=>'NEW_LIST'
,p_column_display_sequence=>3
,p_column_heading=>'Lista Existente'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203156023035627146.4001)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226852323407582386.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201352124984500939.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44745812580007335.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201352300347500941.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44745812580007335.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201352520850500941.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44745812580007335.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201353123979500951.4001)
,p_branch_name=>'Go To Page 627'
,p_branch_action=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::P627_PREV_PAGE:625&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201352300347500941.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from (select s.scheme',
'from (select required_role scheme',
'        from wwv_flow_steps',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct plug_required_role scheme',
'        from wwv_flow_page_plugs',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct i.security_scheme scheme',
'        from wwv_flow_step_items i',
'        where i.flow_id = :P621_COPY_FROM_FLOW_ID and i.flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct b.security_scheme scheme',
'        from wwv_flow_step_buttons b',
'        where b.flow_id = :P621_COPY_FROM_FLOW_ID and b.flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_validations',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID        ',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_computations',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_processing',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'    union',
'    select distinct security_scheme scheme',
'        from wwv_flow_step_branches',
'        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID) s    ',
'where s.scheme is not null',
'and replace(translate(s.scheme,''1234567890'',''0000000000''),''0'') is null) ss'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(208041606592866953.4001)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:625'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201352300347500941.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_branches',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(204033930148742716.4001)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:625'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201352300347500941.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201352906357500950.4001)
,p_branch_action=>'f?p=&APP_ID.:&P625_PREV_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201352520850500941.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204036211925746951.4001)
,p_name=>'P625_PREV_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(201350330187500930.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(208510609398938586.4001)
,p_validation_name=>'existing list must be selected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 copy_option,',
'            c002 new_list,',
'            c003 old_list',
'     from htmldb_collections where collection_name = ''COPY_PAGE_LIST'') ',
'loop',
' if c1.copy_option = ''EXISTING'' then',
'   if c1.new_list = ''0'' then	      ',
'     return false;',
'   end if;',
' end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Se debe seleccionar la lista existente.'
,p_when_button_pressed=>wwv_flow_api.id(201352300347500941.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614675278893209770.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(201352124984500939.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614675594907209770.4001)
,p_event_id=>wwv_flow_api.id(614675278893209770.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205227711499710077.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save copy list selection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_LIST'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'	if htmldb_application.g_f01(i) = ''EXISTING'' then',
'    htmldb_collection.add_member(',
'      p_collection_name   => ''COPY_PAGE_LIST'',',
'      p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'      p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'      p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'      p_c004              => HTMLDB_APPLICATION.G_F04(i),',
'      p_generate_md5      => ''YES'' );',
'  else',
'  	htmldb_collection.add_member(',
'      p_collection_name   => ''COPY_PAGE_LIST'',',
'      p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'      p_c002              => 0,',
'      p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'      p_c004              => HTMLDB_APPLICATION.G_F04(i),',
'      p_generate_md5      => ''YES'' );',
'  end if;      ',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(201352300347500941.4001)
);
end;
/
prompt --application/pages/page_00627
begin
wwv_flow_api.create_page(
 p_id=>627.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Esquemas de Autorizaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="PageInit_627()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
'function f_CopyOption(pThis,pThat){  ',
'  var lCheckValues = new Array(''NO'',''COPY'');',
'  var lTest2 = html_DisableOnValue(pThis,lCheckValues,pThat);',
'  html_GetElement(pThat).disabled = false;',
'  if(lTest2){',
'    html_GetElement(pThat).setAttribute(''onfocus'',''this.blur()'');',
'    }else{',
'    html_GetElement(pThat).setAttribute(''onfocus'','''');',
'  }',
'',
'}',
'',
'function PageInit_627(){',
'var lThis = $x(''reportR201375019615619697'').getElementsByTagName(''TABLE'')[0];',
'var lRows = lThis.rows;',
'for(var i=1;i<lRows.length;i++){',
'var lSelect = lRows[i].cells[1];',
'if(lSelect){',
'	lSelect = lRows[i].cells[1].getElementsByTagName(''SELECT'')[0];',
'	lSelect.onchange()',
'}',
'} ',
'}',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44753121977038433.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(201375019615619697.4001)
,p_name=>unistr('Copiar Esquemas de Autorizaci\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_SECURITY'') and',
'   wwv_flow_collection.collection_member_count(p_collection_name => ''COPY_PAGE_SECURITY'') > 0',
'then',
'  q:=q||''select wwv_flow_item.hidden(3,c003)||wwv_flow_item.display_and_save(4,c004) old_auth, '';   ',
'  q:=q||''wwv_flow_item.select_list_from_lov(1,c001,''''COPY_SC_OPTION'''',''''onchange="f_CopyOption(this,''''''''id2_''''||rownum||'''''''''''')"'''',''''NO'''',null,null,''''id''''||1||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.COPY_OPTION'''',c004),''''NO'''') copy_op'
||'tion, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(2,c002,''''REQUIRED_ROLE'''',null,''''YES'''',''''0'''',wwv_flow_lang.system_message(''''COPY_PAGE.SELECT_AUTHORIZATION''''),''''id''''||2||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.EXISTING_LOV'''',c004),''''NO'''''
||') new_auth '';    ',
'  q:=q||''from htmldb_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_SECURITY'''''';  	',
'else',
'  q:=q||''select wwv_flow_item.hidden(3,ss.scheme)||wwv_flow_item.display_and_save(4,wwv_flow_escape.html(ss.name)) old_auth, '';  ',
'  q:=q||''wwv_flow_item.select_list_from_lov(1,''''NO'''',''''COPY_SC_OPTION'''',''''onchange="f_CopyOption(this,''''''''id2_''''||rownum||'''''''''''')"'''',''''NO'''',null,null,''''id''''||1||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.COPY_OPTION'''',wwv_flow_escape.htm'
||'l(ss.name)),''''NO'''') copy_option, '';',
'  q:=q||''wwv_flow_item.select_list_from_lov_xl(2,''''0'''',''''REQUIRED_ROLE'''',null,''''YES'''',''''0'''',wwv_flow_lang.system_message(''''COPY_PAGE.SELECT_AUTHORIZATION''''),''''id''''||2||''''_''''||rownum,wwv_flow_lang.system_message(''''F4000.P623.EXISTING_LOV'''',wwv_flow_es'
||'cape.html(ss.name)),''''NO'''') new_auth '';    ',
'  q:=q||''from ( '';',
'  q:=q||''  select s.scheme, '';  ',
'  q:=q||''  (select name from wwv_flow_security_schemes where to_char(id) = replace(s.scheme,''''!'''',null)) name '';    ',
'  q:=q||''  from ( '';',
'  q:=q||''    select to_char(required_role) scheme '';',
'  q:=q||''        from wwv_flow_steps s '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(plug_required_role) scheme '';',
'  q:=q||''        from wwv_flow_page_plugs '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_region_columns '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(i.security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_step_items i '';',
'  q:=q||''        where i.flow_id = :P621_COPY_FROM_FLOW_ID and i.flow_step_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(b.security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_step_buttons b '';',
'  q:=q||''        where b.flow_id = :P621_COPY_FROM_FLOW_ID and b.flow_step_id = :P621_COPY_FROM_PAGE_ID '';        ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_step_validations '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID  '';       ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_step_computations '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_step_processing '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_step_branches '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_page_da_events '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_page_da_actions '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(a.security_scheme) scheme '';',
'  q:=q||''        from wwv_flow_jet_chart_series a, wwv_flow_jet_charts b '';',
'  q:=q||''        where a.flow_id = :P621_COPY_FROM_FLOW_ID '';',
'  q:=q||''        and a.flow_id = b.flow_id '';',
'  q:=q||''        and b.page_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''        and a.chart_id = b.id ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(save_rpt_public_auth_scheme) scheme '';',
'  q:=q||''        from wwv_flow_worksheets '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(download_auth_scheme) scheme '';',
'  q:=q||''        from wwv_flow_worksheets '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(detail_link_auth_scheme) scheme '';',
'  q:=q||''        from wwv_flow_worksheets '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(add_authorization_scheme) scheme '';',
'  q:=q||''        from wwv_flow_interactive_grids '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(update_authorization_scheme) scheme '';',
'  q:=q||''        from wwv_flow_interactive_grids '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(delete_authorization_scheme) scheme '';',
'  q:=q||''        from wwv_flow_interactive_grids '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(public_report_auth_scheme) scheme '';',
'  q:=q||''        from wwv_flow_interactive_grids '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    union '';',
'  q:=q||''    select distinct to_char(download_auth_scheme) scheme '';',
'  q:=q||''        from wwv_flow_interactive_grids '';',
'  q:=q||''        where flow_id = :P621_COPY_FROM_FLOW_ID and page_id = :P621_COPY_FROM_PAGE_ID ''; ',
'  q:=q||''    ) s '';',
'  q:=q||''where s.scheme is not null '';',
'  q:=q||''and replace(translate(s.scheme,''''1234567890'''',''''0000000000''''),''''0'''') is null) ss '';	',
'end if;  ',
'',
'return q;',
'end;'))
,p_header=>unistr('<p>Este informe muestra esquemas de autorizaci\00F3n utilizados en la p\00E1gina de la que est\00E1 copiando. Revise el informe y seleccione una opci\00F3n de copia. Si selecciona <strong>Usar Existente</strong>, se debe elegir un esquema de autorizaci\00F3n de la aplic')
||unistr('aci\00F3n actual.</p>')
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>unistr('No se ha utilizado ning\00FAn esquema de autorizaci\00F3n en la p\00E1gina desde la que est\00E1 copiando.')
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208537316942035331.4001)
,p_query_column_id=>1
,p_column_alias=>'OLD_AUTH'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Autorizaci\00F3n')
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(202925532278510899.4001)
,p_query_column_id=>2
,p_column_alias=>'COPY_OPTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Opci\00F3n de Copia')
,p_display_as=>'WITHOUT_MODIFICATION'
,p_named_lov=>wwv_flow_api.id(201061511357162008)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(208537525615035332.4001)
,p_query_column_id=>3
,p_column_alias=>'NEW_AUTH'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Autorizaci\00F3n Existente')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203363409660632762.4001)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226858224016601431.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201376430653619703.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44753121977038433.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201376618526619704.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44753121977038433.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201376823646619704.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44753121977038433.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(208034521783842920.4001)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:627'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201376618526619704.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_branches',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201377420061619706.4001)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:627&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201376618526619704.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201377217155619706.4001)
,p_branch_action=>'f?p=&APP_ID.:&P627_PREV_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(201376823646619704.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204037719197749080.4001)
,p_name=>'P627_PREV_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(201375019615619697.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(208544328164123786.4001)
,p_validation_name=>'existing auth must be selected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 copy_option,',
'            c002 new_auth,',
'            c003 old_auth',
'     from htmldb_collections where collection_name = ''COPY_PAGE_SECURITY'') ',
'loop',
' if c1.copy_option = ''EXISTING'' then',
'   if c1.new_auth = ''0'' then	      ',
'     return false;',
'   end if;',
' end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe seleccionar el esquema de autorizaci\00F3n existente.')
,p_when_button_pressed=>wwv_flow_api.id(201376618526619704.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614674695380200207.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(201376430653619703.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614674972722200207.4001)
,p_event_id=>wwv_flow_api.id(614674695380200207.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205224505004689267.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save authorization scheme selection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_SECURITY'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'	if htmldb_application.g_f01(i) = ''EXISTING'' then',
'    htmldb_collection.add_member(',
'      p_collection_name   => ''COPY_PAGE_SECURITY'',',
'      p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'      p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'      p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'      p_c004              => HTMLDB_APPLICATION.G_F04(i),     ',
'      p_generate_md5      => ''YES'' );',
'  else',
'    htmldb_collection.add_member(',
'      p_collection_name   => ''COPY_PAGE_SECURITY'',',
'      p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'      p_c002              => 0,',
'      p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'      p_c004              => HTMLDB_APPLICATION.G_F04(i),      ',
'      p_generate_md5      => ''YES'' );',
'  end if;        	      ',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la recopilaci\00F3n de esquemas de autorizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(201376618526619704.4001)
);
end;
/
prompt --application/pages/page_00628
begin
wwv_flow_api.create_page(
 p_id=>628.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pgs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44758727911068532.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203815402254708276.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Copia de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.copy_page_other_app (',
'    p_flow_id_from             => :P621_COPY_FROM_FLOW_ID,',
'    p_page_id_from             => :P621_COPY_FROM_PAGE_ID,    ',
'    p_flow_id_to               => :FB_FLOW_ID,',
'    p_page_id_to               => :P621_COPY_TO_PAGE_ID,',
'    p_page_name_to             => :P621_COPY_TO_PAGE_NAME,',
'    p_navigation_type          => :P621_NAVIGATION_TYPE,',
'    --',
'    p_tab_options              => :P671_TAB_OPTIONS,',
'    p_tab_set                  => :P671_TAB_SET,',
'    p_tab_name                 => :P671_TAB_NAME,',
'    p_tab_label                => :P671_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P671_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P671_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P671_NAVLIST_ENTRY_NAME,',
'    --',
'    p_breadcrumb_id            => :P621_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P621_BREADCRUMB_NAME,',
'    p_parent_breadcrumb        => :P621_PARENT_ID',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203820627331713556.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203816004651708282.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44758727911068532.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203816410327708286.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44758727911068532.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203816214630708286.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44758727911068532.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1556121670239652352.4001)
,p_branch_name=>'Redirect to Page Designer/Component View'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(203816410327708286.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(203817208428708304.4001)
,p_branch_action=>'&P628_PREV_PAGE.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(203816214630708286.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203816618948708288.4001)
,p_name=>'P628_PREV_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203815402254708276.4001)
,p_prompt=>'Prev Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590121308257572049.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(203816004651708282.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590121467366572050.4001)
,p_event_id=>wwv_flow_api.id(590121308257572049.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1331045919131583227.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(203816410327708286.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:P621_COPY_FROM_FLOW_ID or :P621_COPY_FROM_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :P621_COPY_FROM_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :P621_COPY_FROM_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203816820266708299.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy page from another app'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_tab_name   varchar2(32767) := null;',
'  l_tab_set    varchar2(32767) := null;',
'  l_tab_text   varchar2(32767) := null;',
'begin',
'  if :P671_TAB_OPTIONS not in (''NO'') then	',
'     l_tab_name := replace(:P671_TAB_NAME,''%''||''null%'',null);',
'     l_tab_set  := replace(:P671_TAB_SET,''%''||''null%'',null);',
'     l_tab_text := :P671_TAB_LABEL;',
'  end if;',
'',
'  wwv_flow_copy_page.copy_from_other_app ( ',
'      p_flow_id_from             => :P621_COPY_FROM_FLOW_ID,   ',
'      p_page_id_from             => :P621_COPY_FROM_PAGE_ID,',
'      p_flow_id_to               => :FB_FLOW_ID,    ',
'      p_page_id_to               => :P621_COPY_TO_PAGE_ID,',
'      p_page_name_to             => :P621_COPY_TO_PAGE_NAME,',
'      --    ',
'      p_breadcrumb_id            => :P621_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P621_BREADCRUMB_NAME,',
'      p_parent_id                => :P621_PARENT_ID,',
'      --    ',
'      p_tab_set                  => l_tab_set,',
'      p_tab_name                 => l_tab_name,',
'      p_tab_label                => l_tab_text,',
'      --',
'      p_nav_list_id              => :P671_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P671_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P671_NAVLIST_ENTRY_NAME,',
'      --',
'      p_ui_type_id_to            => :P621_TO_UI_TYPE_ID,',
'      p_copy_public_report       => ( :P621_COPY_PUBLIC_REPORTS = ''Y'' )',
'      );',
'  wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',:P621_COPY_TO_PAGE_ID);',
'  ',
'  :F4000_RUN_EDIT_PAGE := :P621_COPY_TO_PAGE_ID;',
'  :FB_FLOW_PAGE_ID     := :P621_COPY_TO_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar la p\00E1gina.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(203816410327708286.4001)
,p_process_success_message=>unistr('La p\00E1gina se ha copiado correctamente.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614669191570188701.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(203816410327708286.4001)
,p_process_when_type=>'NEVER'
,p_process_success_message=>unistr('La p\00E1gina se ha copiado correctamente.')
);
end;
/
prompt --application/pages/page_00631
begin
wwv_flow_api.create_page(
 p_id=>631.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Requisitos'
,p_step_title=>'Requisitos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9962502031090128.4001)
,p_plug_name=>'Requisitos'
,p_region_template_options=>'#DEFAULT#:a-Region--accessibleHeader:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22522507957428340.4001)
,p_plug_name=>'Supporting Object Definition tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24434810845931749.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34008209680873383.4001)
,p_plug_name=>'Requisitos'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>93
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205236700530915015.4001)
,p_plug_name=>unistr('Objetos que se Instalar\00E1n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Para evitar los errores que se pueden producir durante la ejecuci\00F3n de los scripts de instalaci\00F3n debido a objetos existentes, se comprobar\00E1 la existencia de los objetos con los siguientes nombres. Si existe alguno, no se continuar\00E1 con la instala')
||unistr('ci\00F3n y se proporcionar\00E1n los detalles al usuario.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9963004858090139.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34008209680873383.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9962827090090138.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34008209680873383.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P631_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9962710549090138.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(34008209680873383.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P631_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29812512271400219.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40437524893440060.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(9962827090090138.4001)
,p_branch_sequence=>22
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9963622858090145.4001)
,p_branch_action=>'f?p=&APP_ID.:631:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9963811782090145.4001)
,p_name=>'P631_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(9962502031090128.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9964224420090154.4001)
,p_name=>'P631_REQUIRED_NAMES_AVAILABLE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(205236700530915015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombres del Objeto'
,p_source=>'REQUIRED_NAMES_AVAILABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_LIST_MANAGER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name||'' (''||object_type||'')'' a, object_name b',
'from sys.dba_objects',
'where owner = (select owner from wwv_flows where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id)',
'and object_name not like ''BIN$%''',
'and object_name not like ''DR$%''',
'and object_name not like ''SYS_%''',
'and object_type not in (''INDEX'')',
'order by object_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique los nombres de objeto creados por los archivos de instalaci\00F3n de esta aplicaci\00F3n. La instalaci\00F3n no se realiza si estos objetos ya existen en el esquema de an\00E1lisis.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FIRST_ROWSET'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9964409471090154.4001)
,p_name=>'P631_REQUIRED_SYS_PRIVS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(9962502031090128.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'CREATE TABLE:CREATE VIEW:CREATE PROCEDURE:CREATE TRIGGER'
,p_prompt=>'Privilegios del Sistema Necesarios:'
,p_source=>'REQUIRED_SYS_PRIVS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REQUIRED SYSTEM PRIVIELGES'
,p_lov=>'.'||wwv_flow_api.id(38912529512012913.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Identifique los privilegios del sistema necesarios para instalar esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38900417990952801.4001)
,p_name=>'P631_REQUIRED_FREE_KB'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(9962502031090128.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'100'
,p_prompt=>'Espacio Libre Necesario en KB:'
,p_source=>'REQUIRED_FREE_KB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el espacio libre necesario para instalar esta aplicaci\00F3n. Al iniciar la instalaci\00F3n, se comprueba el tablespace por defecto del esquema de an\00E1lisis para asegurarse de que hay suficiente espacio disponible.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29811630495396029.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(69950717341968699.4001)
,p_computation_sequence=>20
,p_computation_item=>'P631_REQUIRED_FREE_KB'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(:P631_REQUIRED_FREE_KB,0)'
,p_compute_when=>'P631_REQUIRED_FREE_KB'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(102914229709649152.4001)
,p_computation_sequence=>30
,p_computation_item=>'P631_REQUIRED_NAMES_AVAILABLE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_names wwv_flow_global.vc_arr2;',
'begin',
'l_names := wwv_flow_utilities.string_to_table2(:P631_REQUIRED_NAMES_AVAILABLE);',
'for i in 1..l_names.count',
'loop',
'  if l_names(i) not like ''"%"'' then',
'    l_names(i) := upper(l_names(i));',
'  end if;',
'end loop;',
'return wwv_flow_utilities.table_to_string2(l_names);',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(9984210865144639.4001)
,p_computation_sequence=>10
,p_computation_item=>'P631_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(38985023858503327.4001)
,p_validation_name=>'P631_REQUIRED_FREE_KB'
,p_validation_sequence=>10
,p_validation=>'P631_REQUIRED_FREE_KB'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El valor debe ser num\00E9rico')
,p_associated_item=>wwv_flow_api.id(38900417990952801.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9964618480090155.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P631_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38963010680348186.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate hidden item with object list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   v varchar2(32767) := null;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'     if rtrim(ltrim(wwv_flow.g_f01(i))) is not null then',
'         if substr(wwv_flow.g_f01(i),1,1) != ''"'' then',
'             wwv_flow.g_f01(i) := upper(wwv_flow.g_f01(i));',
'         end if;',
'         v := v||ltrim(rtrim(wwv_flow.g_f01(i)))||'':'';',
'     end if;',
'   end loop;',
'   :P631_REQUIRED_NAMES_AVAILABLE := v;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido guardar la lista de nombres de objeto.'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9964829919090156.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P631_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9965011083090156.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'631'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(38948503220232456.4001)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  t wwv_flow_global.vc_arr2;',
'begin',
'',
'  htmldb_collection.create_or_truncate_collection(p_collection_name=>''DBOBJ'');',
'',
'  for c1 in (select REQUIRED_NAMES_AVAILABLE from WWV_FLOW_INSTALL where flow_id = :fb_flow_id)',
'     loop',
'     t := wwv_flow_utilities.string_to_table2(c1.REQUIRED_NAMES_AVAILABLE);',
'    ',
'  end loop;',
'  for i in 1..t.count loop',
'     htmldb_collection.add_member(p_collection_name=>''DBOBJ'',p_c001=>t(i));',
'  end loop;',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00632
begin
wwv_flow_api.create_page(
 p_id=>632.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Eliminar Todos los Objetos de Soporte'
,p_step_title=>'Eliminar Todos los Objetos de Soporte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10166819887036977.4001)
,p_plug_name=>'Eliminar Todos los Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_header=>unistr('<p>\00BFSeguro que desea suprimir los scripts de instalaci\00F3n, los mensajes y las opciones asociadas actualmente a esta aplicaci\00F3n?</p>')
,p_plug_footer=>'<p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1119157353856390636.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10167521234036979.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1119157353856390636.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir Todo'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10167405855036979.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1119157353856390636.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10168010923036981.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(10167521234036979.4001)
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23461726939721383.4001)
,p_name=>'P632_CONFIRM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(10166819887036977.4001)
,p_prompt=>'Confirmar'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:;CONFIRM'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para confirmar la eliminaci\00F3n de la definici\00F3n de objetos de soporte de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23464925469739821.4001)
,p_validation_name=>'P632_CONFIRM'
,p_validation_sequence=>10
,p_validation=>'P632_CONFIRM'
,p_validation2=>'CONFIRM'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Confirme la eliminaci\00F3n de la definici\00F3n de los objetos de soporte de esta aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(10167521234036979.4001)
,p_associated_item=>wwv_flow_api.id(23461726939721383.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10172027945057915.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete installer'
,p_process_sql_clob=>'delete from wwv_flow_install where flow_id = :fb_flow_id;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido suprimir la definici\00F3n de instalaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(10167521234036979.4001)
,p_process_success_message=>unistr('Definici\00F3n de Installer suprimida')
);
end;
/
prompt --application/pages/page_00633
begin
wwv_flow_api.create_page(
 p_id=>633.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Estado de Exportaci\00F3n')
,p_step_title=>unistr('Estado de Exportaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10192500937187120.4001)
,p_plug_name=>unistr('Estado de Exportaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Determine si los atributos de despliegue se van a exportar por defecto con la aplicaci\00F3n. Este valor por defecto se puede sustituir durante la exportaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22530616877449806.4001)
,p_plug_name=>'Supporting Object Definition tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24428124304907263.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34018430299992830.4001)
,p_plug_name=>'Exportar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10192800789187121.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34018430299992830.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10192725590187121.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34018430299992830.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_condition=>'P633_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29879809398617034.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10193103948187122.4001)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10193330456187123.4001)
,p_name=>'P633_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(10192500937187120.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10193526370187126.4001)
,p_name=>'P633_INCLUDE_IN_EXPORT_YN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(10192500937187120.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Incluir Definiciones de Objeto de Soporte en Exportaci\00F3n')
,p_source=>'INCLUDE_IN_EXPORT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(388231942990864305.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las definiciones de objeto de soporte se pueden exportar de manera opcional con la aplicaci\00F3n. Se incluyen todas las opciones de configuraci\00F3n y todos los scripts.</p>'),
'<ul>',
'<li>',
unistr('<strong>S\00ED</strong> incluye las definiciones de objeto de soporte en la exportaci\00F3n de la aplicaci\00F3n. No carga autom\00E1ticamente objetos de soporte de cuando se llaman desde una l\00EDnea de comandos.'),
'<li>',
'<li>',
unistr('<strong>No</strong> no incluye las definiciones de objeto de soporte en la exportaci\00F3n.'),
'</li>',
'<li>',
unistr('<strong>S\00ED e Instalar al Importar Autom\00E1ticamente</strong> incluye definiciones de objeto soporte y una llamada para instalar los objetos de soporte en la exportaci\00F3n de la aplicaci\00F3n. Esta opci\00F3n solo es v\00E1lida para instalaciones de la l\00EDnea de coma')
||unistr('ndos. Cuando la aplicaci\00F3n importa desde la l\00EDnea de comandos, instala o actualiza autom\00E1ticamente los objetos de soporte.'),
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(29877832123614117.4001)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(10196611210195014.4001)
,p_computation_sequence=>10
,p_computation_item=>'P633_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10193712500187129.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P633_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10193905630187132.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P633_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(10194128177187132.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'633'
);
end;
/
prompt --application/pages/page_00636
begin
wwv_flow_api.create_page(
 p_id=>636.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Plantilla: Nueva Plantilla'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46420809455675807.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(223170121844454342.4001)
,p_plug_name=>unistr('Copiar Plantilla de Ruta de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(223170504670454347.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(110615031296644849.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(223170722855454347.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(222829818333256486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(223171431079454359.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46420809455675807.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(223171626357454362.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46420809455675807.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(223173401602454396.4001)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(223171626357454362.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(223171822244454365.4001)
,p_name=>'P636_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(223170121844454342.4001)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(223172000285454375.4001)
,p_name=>'P636_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(223170121844454342.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME template_name ',
'from WWV_FLOW_MENU_TEMPLATES',
'where id = :P636_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica la plantilla que se va a copiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(223172521342454378.4001)
,p_name=>'P636_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(223170121844454342.4001)
,p_prompt=>'Nombre Nuevo de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de la nueva plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1004724568137877709.4001)
,p_name=>'P636_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(223170121844454342.4001)
,p_prompt=>'Nuevo Identificador de Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre del nuevo identificador de plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(223173019610454385.4001)
,p_validation_name=>'P636_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P636_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(223171626357454362.4001)
,p_associated_item=>wwv_flow_api.id(223172521342454378.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004724645615877710.4001)
,p_validation_name=>'P636_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P636_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(223171626357454362.4001)
,p_associated_item=>wwv_flow_api.id(1004724568137877709.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004724917422877713.4001)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_menu_templates ',
'         where id = :P636_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_menu_templates',
'            where name = :P636_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(223172521342454378.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1004725084693877714.4001)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_menu_templates ',
'         where id = :P636_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_menu_templates',
'            where internal_name = :P636_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de la plantilla debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(1004724568137877709.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614719636571684667.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(223171431079454359.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614719931228684667.4001)
,p_event_id=>wwv_flow_api.id(614719636571684667.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1004724704051877711.4001)
,p_name=>'set internal name'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P636_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1004724832203877712.4001)
,p_event_id=>wwv_flow_api.id(1004724704051877711.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P636_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P636_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(223173230475454392.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Breadcrumb Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_MENU_TEMPLATES where id = :P636_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'   wwv_flow_templates_util.copy_menu_template(',
'      p_copy_from_flow_id   => :fb_flow_id,',
'      p_flow_id             => :fb_flow_id,',
'      p_from_template_id    => :P636_FROM_TEMPLATE_ID,',
'      p_to_template_name    => :P636_TO_TEMPLATE_NAME,',
'      p_to_internal_name    => :P636_TO_INTERNAL_NAME,',
'      p_to_template_id      => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id         => c1.theme_id,',
'      p_include_subscription  =>false ',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'La plantilla no se ha copiado correctamente.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(223171626357454362.4001)
,p_process_success_message=>'Plantilla Copiada'
);
end;
/
prompt --application/pages/page_00637
begin
wwv_flow_api.create_page(
 p_id=>637.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Exportaci\00F3n de Componente')
,p_step_title=>unistr('Exportaci\00F3n de Componente: Exportar Componentes')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45358911904208810.4001)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45360626926222638.4001)
,p_plug_name=>'Export settings'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(210498514697376542.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(210500012705376564.4001)
,p_name=>'Componentes a Exportar'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select type_name component_type,',
'       name      component_name',
'  from wwv_multi_component_export',
' where flow_id = to_number(:fb_flow_id)',
' order by type_name, name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha seleccionado ning\00FAn componente.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(45400224427666650.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(377667910269420728)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(45400303360666650.4001)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Componente'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(210807226235497362.4001)
,p_plug_name=>'Wizard progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(210787017222419064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747143832911138166.4001)
,p_plug_name=>unistr('Exportaci\00F3n de Componente')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45366518577267523.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45358911904208810.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210501022616376574.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45358911904208810.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar Componentes'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(210811711953512099.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45358911904208810.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2857006017881119.4001)
,p_name=>'P637_EXPORT_ZIP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(45360626926222638.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar como Archivo Zip'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Seleccione <strong>Activado</strong> para exportar los componentes seleccionados como un archivo ZIP que contiene archivos SQL distintos para cada componente.</p>',
'<p>',
unistr('Seleccione <strong>Desactivado</strong> para exportar como un \00FAnico archivo SQL que contiene todos los componentes seleccionados.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2857203482881121.4001)
,p_name=>'P637_WITH_INSTALL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(45360626926222638.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Incluir archivos de instalaci\00F3n')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para generar un archivo ZIP que incluya archivos de instalaci\00F3n espec\00EDficos para los componentes exportados (por ejemplo, install.sql, set_environment.sql y end_environment.sql).</p>'),
'<p>',
unistr('Seleccione <strong>Desactivado</strong> para generar un archivo ZIP sin los archivos de instalaci\00F3n. Se recomienda esta opci\00F3n al guardar los archivos en un sistema de control de versiones, de forma que los archivos de instalaci\00F3n de la aplicaci\00F3n no')
||' se sobrescriban. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210501202704376576.4001)
,p_name=>'P637_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(210498514697376542.4001)
,p_item_default=>'AC'
,p_source=>'AC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210503825380376592.4001)
,p_name=>'P637_DEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(210498514697376542.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210504002922376593.4001)
,p_name=>'P637_MPAGE_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(45360626926222638.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210504514667376594.4001)
,p_name=>'P637_FLASHBACK_MIN_AGO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(45360626926222638.4001)
,p_prompt=>'A partir de'
,p_post_element_text=>'<span class="fielddata">minutos antes (~ 5 minutos de retraso)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifique un tiempo en minutos para volver atr\00E1s en la exportaci\00F3n. Esta opci\00F3n permite volver en el tiempo en la'),
unistr('aplicaci\00F3n, quiz\00E1s para recuperar un objeto suprimido.'),
'</p>',
'',
'<p>',
unistr('Esta utilidad utiliza el paquete <code>dbms_flashback</code>. La asignaci\00F3n de registro de hora a SCN (N\00FAmero de Cambio del Sistema) se refresca'),
unistr('cada 5 minutos aproximadamente, por lo que tal vez tenga que esperar ese espacio de tiempo para obtener la versi\00F3n que est\00E1 buscando.'),
unistr('El tiempo que se mantiene la informaci\00F3n de deshacer depende del par\00E1metro de inicio <code>undo_retention</code> (3 horas por defecto), pero esto'),
unistr('solo afecta al tama\00F1o del tablespace de deshacer.'),
'</p>',
'',
'<p>',
unistr('Mientras que dos bases de datos pueden tener el mismo par\00E1metro <code>undo_retention</code>, puede volver atr\00E1s en el tiempo'),
unistr('en la base de datos con menos transacciones, ya que las transacciones no est\00E1n rellenando el tablespace de deshacer, forzando as\00ED el archivado de los datos'),
unistr('m\00E1s antiguos.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210505027976376597.4001)
,p_name=>'P637_MPAGE_FILE_CHARSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(45360626926222638.4001)
,p_prompt=>'Juego de Caracteres de Archivo'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el juego de caracteres en el que se codificar\00E1 el archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(694679597330238903.4001)
,p_name=>'P637_EXPORT_TRANSLATIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(45360626926222638.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar Traducciones'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows f',
' where f.id in ( select m.translation_flow_id',
'                   from wwv_flow_language_map m',
'                  where m.primary_language_flow_id = :fb_flow_id )'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para exportar los componentes seleccionados para la aplicaci\00F3n de idioma primario y todas las aplicaciones'),
unistr('traducidas. Se crear\00E1 un solo archivo de exportaci\00F3n, que se puede cargar directamente en otra instancia. Recuerde que'),
'necesita sincronizar las aplicaciones traducidas antes de exportar los componentes traducidos para garantizar que las cadenas de texto y',
unistr('el marcador est\00E1n actualizados.'),
'</p>',
'',
'<p>',
unistr('Seleccione <strong>Desactivado</strong> para exportar solo los componentes seleccionados para la aplicaci\00F3n de idioma primario.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2857316078881122.4001)
,p_name=>'Toggle Installation Files'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P637_EXPORT_ZIP'
,p_condition_element=>'P637_EXPORT_ZIP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2857482053881123.4001)
,p_event_id=>wwv_flow_api.id(2857316078881122.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P637_WITH_INSTALL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2857561594881124.4001)
,p_event_id=>wwv_flow_api.id(2857316078881122.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P637_WITH_INSTALL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(210506211284376609.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_components wwv_flow_export_dev.t_components;',
'begin',
'    -- Load selected components into array so we don''t have to query the collection for each language.',
'    select type_name as component,',
'           id        as component_id',
'           bulk collect into l_components',
'      from wwv_multi_component_export',
'     where flow_id   = :FB_FLOW_ID',
'     order by type_name, seq_id;',
'     ',
'     wwv_flow_export_dev.export_components (',
'         p_application_id         => :FB_FLOW_ID,',
'         p_components             => l_components,',
'         p_format                 => case ',
'                                     when :P637_EXPORT_ZIP = ''Y'' then ''ZIP_UNIX'' ',
'                                     else ''UNIX'' ',
'                                     end,',
'         p_export_translations_yn => :P637_EXPORT_TRANSLATIONS,',
'         p_flashback_min_ago      => :P637_FLASHBACK_MIN_AGO, ',
'                                     -- always include install when NOT a zip',
'         p_with_install           => :P637_EXPORT_ZIP != ''Y'' or ',
'                                     -- export install if requested when zip',
'                                     :P637_WITH_INSTALL = ''Y'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al exportar los componentes.'
,p_process_when_button_id=>wwv_flow_api.id(210501022616376574.4001)
,p_process_success_message=>'Componentes compartidos exportados.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(210505811695376606.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c pls_integer;',
'begin',
'  select count(*) into c',
'  from htmldb_collections',
' where collection_name = ''MULTI_COMPONENT_EXPORT''',
'    and n001 = :fb_flow_id;',
'',
'if :request = ''NEW'' or c = 0 then',
'',
'htmldb_collection.create_or_truncate_collection( p_collection_name => ''MULTI_COMPONENT_EXPORT'' );',
'commit;',
'',
'end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(210506012008376607.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete single member'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.delete_member(',
'   p_collection_name => ''MULTI_COMPONENT_EXPORT'',',
'   p_seq             => :P637_DEL );',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido eliminar el componente'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Componente eliminado'
);
end;
/
prompt --application/pages/page_00638
begin
wwv_flow_api.create_page(
 p_id=>638.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('P\00E1ginas en Cach\00E9')
,p_step_title=>unistr('P\00E1ginas en Cach\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450364024461818534.4001)
,p_plug_name=>unistr('P\00E1ginas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<input type="checkbox" name="f01" value="''||p.id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(p.name))||''" />'' cb,',
'       :FB_FLOW_ID application,',
'       p.id, p.name, ',
'       c.LANGUAGE,',
'       c.CACHED_ON,',
'       p.cache_timeout_seconds, ',
'       round((sysdate - c.cached_on) * 3600 * 24,0) cache_age_in_seconds, ',
'       p.CACHE_TIMEOUT_SECONDS - ',
'          round((sysdate - c.cached_on) * 3600 * 24,0) max_age_in_seconds,',
'       decode(greatest((sysdate - c.cached_on) * 3600 * ',
'          24,p.CACHE_TIMEOUT_SECONDS),',
'          p.CACHE_TIMEOUT_SECONDS,m.Unexpired,m.Expired) cache_status,',
'       p.cache_mode, ',
'       decode(p.cache_when_condition_type,null,null,',
'          ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') cache_when_condition_type,',
'       sys.dbms_lob.getlength(c.PAGE_TEXT) page_size',
'  from WWV_FLOW_PAGE_CACHE c,',
'       wwv_flow_steps p,',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired',
' from dual) m',
' where c.flow_id = :fb_flow_id',
'   and c.flow_id = p.flow_id',
'   and c.page_id = p.id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.cache_mode <> ''NOCACHE'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(450364124712818534.4001)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450364308749818538.4001)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450364414883818539.4001)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450364516079818540.4001)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450364618625818541.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450364818432818543.4001)
,p_db_column_name=>'CACHE_TIMEOUT_SECONDS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450365024132818545.4001)
,p_db_column_name=>'CACHE_WHEN_CONDITION_TYPE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450384024944934367.4001)
,p_db_column_name=>'PAGE_SIZE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Tama\00F1o de la P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450388428501992168.4001)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450388621964992170.4001)
,p_db_column_name=>'CACHED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Almacenado en Cach\00E9 el')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450398311372100663.4001)
,p_db_column_name=>'CACHE_AGE_IN_SECONDS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Duraci\00F3n de Cach\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450398405692100664.4001)
,p_db_column_name=>'MAX_AGE_IN_SECONDS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Duraci\00F3n M\00E1xima')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(450398510618100665.4001)
,p_db_column_name=>'CACHE_STATUS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Estado de la Cach\00E9')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(672347912160250209.4001)
,p_db_column_name=>'CACHE_MODE'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>unistr('Modo de Cach\00E9')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(22602312173782467)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(450368313937836519.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(450364024461818534.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:638:&SESSION.:RIR:&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49295704055343012.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(450364024461818534.4001)
,p_button_name=>'PURGE_EXPIRED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Depurar Elementos Vencidos'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(89572211986421497.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(450364024461818534.4001)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Depurar Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225838030129269061.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(450364024461818534.4001)
,p_button_name=>'PURGE_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Depurar Todo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(223952828999646839.4001)
,p_branch_action=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199173766685878413.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(450364024461818534.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199173823733878414.4001)
,p_event_id=>wwv_flow_api.id(1199173766685878413.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225840131776288464.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge cache'
,p_process_sql_clob=>'wwv_flow_page_cache_api.purge_by_application(p_application=>:fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido depurar las p\00E1ginas en cach\00E9.')
,p_process_when_button_id=>wwv_flow_api.id(225838030129269061.4001)
,p_process_success_message=>unistr('P\00E1ginas en cach\00E9 depuradas.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49297622063348213.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge expired'
,p_process_sql_clob=>'wwv_flow_page_cache_api.purge_stale(p_application=>:fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido depurar las p\00E1ginas vencidas')
,p_process_when_button_id=>wwv_flow_api.id(49295704055343012.4001)
,p_process_success_message=>unistr('P\00E1ginas vencidas depuradas')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(89575629086435930.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_page_cache_api.purge_by_page (',
'        p_application => :fb_flow_id,',
'        p_page => wwv_flow.g_f01(j));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido depurar las p\00E1ginas')
,p_process_when_button_id=>wwv_flow_api.id(89572211986421497.4001)
,p_process_when=>'wwv_flow.g_f01.count > 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('P\00E1ginas Depuradas')
);
end;
/
prompt --application/pages/page_00643
begin
wwv_flow_api.create_page(
 p_id=>643.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Separadores'
,p_step_title=>'Separadores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen"> ',
'',
'.tab-structure {',
'	margin: 0;',
'}',
'',
'.tab-structure ul {',
'	margin: 0;',
'	list-style: none;',
'}',
'',
'.tab-structure li {',
'	list-style: none;',
'}',
'',
'.tab-structure .tabset-item {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	-moz-border-radius: 10px;',
'	-webkit-border-radius: 10px;',
'	background-color: #efefef;',
'	border: 1px solid #aaaaaa;',
'	font-size: 12px;',
'	line-height: 16px;',
'	margin: 8px 0;',
'	padding: 12px 0;',
'	min-width: 800px;',
'}',
'',
'.tab-structure .tabset-name {',
'	font-size: 16px;',
'	padding: 12px;',
'}',
'',
'.tab-structure .tabset-name b {',
'	font-size: 16px;',
'}',
'',
'.tab-structure .tab-item {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	width: 100%;',
'	border-bottom: 1px solid #aaaaaa;',
'}',
'',
'.tab-structure .tab-item-last {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	width: 100%;',
'	background-color: #efefef;',
'	margin: -1px 0 0 0;',
'}',
'',
'.tab-structure .tab-item-name {',
'	-moz-border-radius: 4px;',
'	-webkit-border-radius: 4px;',
'	background-color: #566687;',
'	border: 1px solid #2B323F;',
'	color: #FFFFFF;',
'	display: block;',
'	float: left;',
'	font-size: 14px;',
'	font-weight: bold;',
'	line-height: 18px;',
'	margin: 8px 12px 8px 12px;',
'	padding: 8px;',
'	width: 240px;',
'	overflow: none;',
'}',
'',
'.tab-structure .tab-item-name a {',
'	color: #FFFFFF;',
'	font-size: 14px;',
'	font-weight: bold;',
'}',
'',
'.tab-structure .tab-item-name a:hover {',
'	text-decoration: underline;',
'}',
'',
'.tab-structure .tab-item li {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	margin: 4px 12px 4px 12px;',
'	line-height: 20px;',
'	background: url(#IMAGE_PREFIX#htmldb/icons/small_page.gif) no-repeat;',
'}',
'',
'.tab-structure .tab-item li span {',
'	padding-left: 24px;',
'}',
'',
'</style>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46241429639678975.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450481125832473824.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450481508995478483.4001)
,p_plug_name=>'Separadores'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(450482224363492350.4001)
,p_name=>unistr('Visi\00F3n General')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>180
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P643b */ id,',
'       name,',
'       trim(to_char((',
'         select count(*) from wwv_flow_steps where flow_id = f.id),',
'         ''999G999G990'')) pages,',
'       (select count(*) ',
'        from wwv_flow_steps ',
'        where flow_id = f.id and TAB_SET is not null) pages_with_tabs,',
'       (select count(distinct tab_set) ',
'        from wwv_flow_steps ',
'        where flow_id = f.id and TAB_SET is not null) standard_tab_sets',
'from wwv_flows f',
'where id = :fb_flow_id and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato.')
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(450482412919492354.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(450482517310492355.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(450482631078492355.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGES'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1ginas')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(452395519820632941.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGES_WITH_TABS'
,p_column_display_sequence=>4
,p_column_heading=>unistr('P\00E1ginas con Separadores')
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(452396200127655616.4001)
,p_query_column_id=>5
,p_column_alias=>'STANDARD_TAB_SETS'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Juegos de Separadores Est\00E1ndar')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454853911528009195.4001)
,p_plug_name=>'Acerca de los Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una aplicaci\00F3n puede tener p\00E1ginas sin separadores, con uno o con dos niveles de separadores.</p>'),
unistr('<p><strong>Separadores Est\00E1ndar</strong> permite mostrar s\00F3lo un nivel de separadores. Si desea mostrar dos niveles de separadores, defina ambas opciones <strong>Separadores Principales</strong> y <strong>Separadores Est\00E1ndar</strong>.</p>'),
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454861110760103560.4001)
,p_plug_name=>'Juegos de Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Los separadores se agrupan en recopilaciones denominadas juego de separadores. Todos los separadores deben formar parte de un juego de separadores. Un separador est\00E1ndar puede tener una relaci\00F3n de uno a uno con una p\00E1gina o puede ser el "separador a')
||unistr('ctual" de varias p\00E1ginas.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454923029684875386.4001)
,p_plug_name=>'Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452396911340668339.4001)
,p_plug_name=>'Tab Edit'
,p_parent_plug_id=>wwv_flow_api.id(454923029684875386.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.show_tabs (',
'	p_application_id  => :fb_flow_id,',
'	p_security_group_id => :flow_security_group_id,',
'	p_session_id  => :app_session,',
'	p_parent_tabset => :P643_PARENT_TAB);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455256204560571702.4001)
,p_plug_name=>unistr('B\00FAsqueda de Separador')
,p_parent_plug_id=>wwv_flow_api.id(454923029684875386.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455351729241335775.4001)
,p_plug_name=>'Pages with no tabs'
,p_parent_plug_id=>wwv_flow_api.id(454923029684875386.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c number := 0;',
'begin',
'sys.htp.p(''<p><strong>''||wwv_flow_lang.system_message(''F4000_P643_PAGE_NO_TAB'')||'': ''||''</strong></p>'');',
'for c1 in (select id from wwv_flow_steps where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id and tab_set is null and id != 0 order by 1) loop',
'    c := c + 1;',
'    if c < 51 then',
'    if c > 1 then',
'       sys.htp.prn('', ''||c1.id);',
'    else',
'       sys.htp.prn(c1.id);',
'    end if;',
'    end if;',
'end loop;',
'if c > 50 then',
'   sys.htp.prn(''...'');',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''F4000_P643_PAGE_NO_TAB_TTL'',to_char(c,''999G990''))||''</p>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455408006184290313.4001)
,p_plug_name=>'Legend'
,p_parent_plug_id=>wwv_flow_api.id(454923029684875386.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><strong>''||wwv_flow_lang.system_message(''F4000_P643_TAB_DISPLAY'')||''</strong>:</p>'');',
'sys.htp.p(''<ul>'');',
'sys.htp.p(''<li>''||''1 - ''||wwv_flow_lang.system_message(''F4000_P643_ONE_LVL'')||''</li>'');',
'sys.htp.p(''<li>''||''2 - ''||wwv_flow_lang.system_message(''F4000_P643_TWO_LVL'')||''</li>'');',
'sys.htp.p(''<li>''||''0 - ''||wwv_flow_lang.system_message(''F4000_P643_NO_TAB'')||''</li>'');',
'sys.htp.p(''<li>''||''* - ''||wwv_flow_lang.system_message(''F4000_P643_NO_PARENT'')||''</li>'');',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492143803418756709.4001)
,p_plug_name=>'No tabs defined'
,p_parent_plug_id=>wwv_flow_api.id(454923029684875386.4001)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>45
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p>''||wwv_flow_lang.system_message(''NO_TABS_DEFINED'')||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492147327790773200.4001)
,p_plug_name=>'Tab Summary'
,p_parent_plug_id=>wwv_flow_api.id(454923029684875386.4001)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>46
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  t number;',
'  pt number;',
'  ts number;',
'begin',
'  select count(*) into t from wwv_flow_tabs where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id;',
'  select count(distinct tab_set) into ts from wwv_flow_tabs where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id;',
'  select count(*) into pt from wwv_flow_toplevel_tabs where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id;',
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(',
'    ''DEFINED_TABS'',',
'    ''<a href="f?p=4000:123:''||:app_session||'':">''||to_char(t)||''</a>'',',
'    ts,',
'    ''<a href="f?p=4000:331:''||:app_session||'':">''||to_char(pt)||''</a>'')||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454924416141918771.4001)
,p_plug_name=>unistr('Visualizaci\00F3n de Separadores')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454875603791440963.4001)
,p_plug_name=>unistr('Visualizaci\00F3n de Separador Est\00E1ndar')
,p_parent_plug_id=>wwv_flow_api.id(454924416141918771.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(454874132315440955.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(492140130336707768.4001)
,p_plug_header=>unistr('<p>Si todas las condiciones siguientes son verdaderas, se mostrar\00E1 un separador est\00E1ndar en la p\00E1gina.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455042811664478946.4001)
,p_plug_name=>unistr('Visualizaci\00F3n de Separador Principal')
,p_parent_plug_id=>wwv_flow_api.id(454924416141918771.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(455042113172478942.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(492140130336707768.4001)
,p_plug_header=>unistr('<p>Si todas las condiciones siguientes son verdaderas, se mostrar\00E1 en la p\00E1gina un separador principal.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454927020137033454.4001)
,p_plug_name=>unistr('Separadores Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cada separador est\00E1ndar se identifica con una o m\00E1s p\00E1ginas. Cada separador est\00E1ndar define tambi\00E9n un juego de separadores.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(454928204169076179.4001)
,p_name=>unistr('Plantillas de P\00E1gina')
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P643a */ id, NAME, ',
'    decode(',
'        nvl(sys.dbms_lob.instr(box,''#TAB_CELLS#''),0), 0, m.n, m.y)',
'        supports_standard_tabs, ',
'    decode(',
'        nvl(sys.dbms_lob.instr(box,''#PARENT_TAB_CELLS#''),0), 0, m.n, m.y)',
'        Supports_parent_tabs,',
'    (select t.theme_id||''. ''||theme_name tn ',
'     from wwv_flow_themes x',
'     where x.flow_id = :fb_flow_id and t.theme_id= x.theme_id) theme_id,',
'    THEME_CLASS_ID class_id',
'from wwv_flow_templates t,',
'  (select wwv_flow_lang.system_message(''YES'') y,',
'            wwv_flow_lang.system_message(''NO'') n',
'   from dual) m',
'where security_group_id = :flow_security_group_id and',
'    flow_id = :fb_flow_id',
'order by 1'))
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una plantilla de p\00E1gina mostrar\00E1 <strong>separadores est\00E1ndar</strong> si su atributo <strong>Cuerpo de Plantilla</strong> incluye la cadena de sustituci\00F3n <strong>#TAB_CELLS#</strong>.</p>'),
'',
unistr('<p>Una plantilla de p\00E1gina mostrar\00E1 <strong>separadores principales</strong> si su atributo <strong>Cuerpo de Plantilla</strong>incluye la cadena de sustituci\00F3n <strong>#PARENT_TAB_CELLS#</strong>.</p>')))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna plantilla de p\00E1gina.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(454930426595101515.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(454928520697076183.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr(' Nombre de Plantilla de P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.:4307:F4000_P4307_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(454930531456101516.4001)
,p_query_column_id=>3
,p_column_alias=>'SUPPORTS_STANDARD_TABS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Soporta Separadores Est\00E1ndar')
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(454936101857283579.4001)
,p_query_column_id=>4
,p_column_alias=>'SUPPORTS_PARENT_TABS'
,p_column_display_sequence=>4
,p_column_heading=>'Soporta Separadores Principales'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(454928721847076184.4001)
,p_query_column_id=>5
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Theme'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(454937512771324601.4001)
,p_query_column_id=>6
,p_column_alias=>'CLASS_ID'
,p_column_display_sequence=>6
,p_column_heading=>'Clase de Plantilla'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(41972431732112027)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454936915279306395.4001)
,p_plug_name=>'Listas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Como alternativa a los separadores, puede utilizar listas para mostrar controles de separador. Las plantillas de lista facilitan un control mayor con respecto a la generaci\00F3n HTML.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455063002164731164.4001)
,p_plug_name=>'Separadores Principales'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Los separadores principales pueden controlar la visualizaci\00F3n de juegos de separadores est\00E1ndar. Al hacer clic en un separador principal, se mostrar\00E1 el correspondiente separador est\00E1ndar, con la p\00E1gina por defecto como p\00E1gina actual.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455255631656560602.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(455256204560571702.4001)
,p_button_name=>'P643_SET'
,p_button_static_id=>'P643_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and TAB_PARENT_TABSET is not null'))
,p_button_condition_type=>'EXISTS'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(454860614785095226.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(450481508995478483.4001)
,p_button_name=>'CREATE_TAB'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Gestionar Separadores'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455243110523478875.4001)
,p_name=>'P643_PARENT_TAB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(455256204560571702.4001)
,p_item_default=>'0'
,p_prompt=>'Juego de Separadores Principales'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(d,null,''No Parent Tab Set Defined'',d) d, decode(d,null,''No Parent Tab Set Defined'',r) r',
'from (',
'select distinct TAB_PARENT_TABSET d, TAB_PARENT_TABSET r',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    order by 1',
')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Mostrar Todo -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and TAB_PARENT_TABSET is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifique un juego de separadores principal para restringir este informe \00FAnicamente a los separadores que se encuentren debajo del separador principal seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(454851716460991675.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'643'
);
end;
/
prompt --application/pages/page_00645
begin
wwv_flow_api.create_page(
 p_id=>645.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Proceso: Opciones de Proceso'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Proceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45409930519933332.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227736926634696958.4001)
,p_plug_name=>'Copiar Proceso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227770125567964432.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(227766223920945009.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(227779306745025252.4001)
,p_name=>unistr('Procesos de P\00E1gina de Destino')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name,',
'       process_sequence,',
'       wwv_flow_region_layout.get_process_type_desc(flow_id, process_type) as process_type,',
'       process_point',
'from wwv_flow_step_processing',
'where flow_step_id = :P590_COPY_TO_PAGE',
'and flow_id = :fb_flow_id  ',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay ning\00FAn proceso definido actualmente en la p\00E1gina de destino.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(227782802290052363.4001)
,p_query_column_id=>1
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(227782920366052364.4001)
,p_query_column_id=>2
,p_column_alias=>'PROCESS_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(227783026256052364.4001)
,p_query_column_id=>3
,p_column_alias=>'PROCESS_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(227783118217052364.4001)
,p_query_column_id=>4
,p_column_alias=>'PROCESS_POINT'
,p_column_display_sequence=>4
,p_column_heading=>'Punto de Proceso'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(842344044)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227737802879696972.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45409930519933332.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227738024960696973.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45409930519933332.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227772707822978236.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45409930519933332.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(227741024772696994.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(614622805028025586.4001)
,p_branch_action=>'f?p=&APP_ID.:590:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(227772707822978236.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7770918597645303.4001)
,p_name=>'P645_REGION_ID'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Regi\00F3n Editable')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name,',
'       id',
'  from wwv_flow_page_plugs',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :P590_COPY_TO_PAGE',
'   and security_group_id = :WORKSPACE_ID',
'   and plug_source_type  = ''NATIVE_IG''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Regi\00F3n -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_processing sp',
'  join wwv_flow_page_plugs pp',
'    on ( pp.id = sp.region_id and pp.flow_id = sp.flow_id and pp.page_id = sp.flow_step_id )',
' where sp.id                = :P590_ID',
'   and sp.region_id         is not null',
'   and pp.plug_source_type  = ''NATIVE_IG'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una regi\00F3n de la p\00E1gina de destino para asociarla a este proceso.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(227739229332696983.4001)
,p_name=>'P645_PROCESS_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Secuencia de Proceso de P\00E1gina de Destino')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(process_sequence), 0) + 10 as r',
'  from wwv_flow_step_processing',
' where flow_id      = :FB_FLOW_ID',
'   and flow_step_id = :P590_COPY_TO_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(227739718553696984.4001)
,p_name=>'P645_PROCESS_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_prompt=>unistr('Nombre de Proceso de P\00E1gina de Destino')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name',
'from wwv_flow_step_processing',
'where id = :P590_ID and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique el nombre del nuevo componente.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(229229810300201120.4001)
,p_name=>'P645_WHEN_BUTTON_PRESSED'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_prompt=>unistr('Si Se Hace Clic en el Bot\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :P590_COPY_TO_PAGE',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:P590_COPY_TO_PAGE, ui.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n de Bot\00F3n -')
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este componente s\00F3lo se ejecutar\00E1 si un usuario hace clic en este bot\00F3n.'),
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231558429053761318.4001)
,p_name=>'P645_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>'P590_COPY_FROM_PAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina desde la que se copiar\00E1 el proceso.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231559013947766469.4001)
,p_name=>'P645_COPY_FROM_PROCESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_prompt=>'Copiar Proceso:'
,p_source=>'P590_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROCESS_SEQUENCE||''. ''||PROCESS_NAME pname, id',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by PROCESS_SEQUENCE'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Proceso que se va a copiar.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231559928838770715.4001)
,p_name=>'P645_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(227736926634696958.4001)
,p_prompt=>unistr('P\00E1gina de Destino:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P590_COPY_TO_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('P\00E1gina a la que se copiar\00E1 el proceso.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590119056293572026.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(227737802879696972.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590119136231572027.4001)
,p_event_id=>wwv_flow_api.id(590119056293572026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(227740800311696992.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_new_process_id   number;',
'    l_process_sql_clob varchar2(32767);',
'begin',
'    for l_process in (select * from wwv_flow_step_processing where id = :P590_ID)',
'    loop',
'        l_new_process_id   := wwv_flow_id.next_val;',
'        l_process_sql_clob := wwv_flow_utilities.clob_to_varchar2(l_process.process_sql_clob);',
'',
'        wwv_flow_api.create_page_process (',
'            p_id               => l_new_process_id,',
'            p_flow_id          => :FB_FLOW_ID,',
'            p_flow_step_id     => nvl(:P590_COPY_TO_PAGE, l_process.flow_step_id),',
'            p_process_sequence => :P645_PROCESS_SEQUENCE,',
'            p_process_point    => l_process.process_point,',
'            p_process_type     => l_process.process_type,',
'            p_process_name     => :P645_PROCESS_NAME,',
'            p_region_id        => :P645_REGION_ID,',
'            p_process_sql_clob => l_process_sql_clob,',
'            p_attribute_01     => l_process.attribute_01,',
'            p_attribute_02     => l_process.attribute_02,',
'            p_attribute_03     => l_process.attribute_03,',
'            p_attribute_04     => l_process.attribute_04,',
'            p_attribute_05     => l_process.attribute_05,',
'            p_attribute_06     => l_process.attribute_06,',
'            p_attribute_07     => l_process.attribute_07,',
'            p_attribute_08     => l_process.attribute_08,',
'            p_attribute_09     => l_process.attribute_09,',
'            p_attribute_10     => l_process.attribute_10,',
'            p_attribute_11     => l_process.attribute_11,',
'            p_attribute_12     => l_process.attribute_12,',
'            p_attribute_13     => l_process.attribute_13,',
'            p_attribute_14     => l_process.attribute_14,',
'            p_attribute_15     => l_process.attribute_15,',
'            p_process_item_name       => l_process.item_name,',
'            p_process_is_stateful_y_n => l_process.process_is_stateful_y_n,',
'            p_runtime_where_clause    => l_process.runtime_where_clause,',
'            p_return_key_into_item1   => l_process.return_key_into_item1,',
'            p_return_key_into_item2   => l_process.return_key_into_item2,',
'            p_process_error_message   => l_process.process_error_message,',
'            p_error_display_location  => l_process.error_display_location,',
'            p_process_success_message => l_process.process_success_message,',
'            p_process_when_button_id  => :P645_WHEN_BUTTON_PRESSED,',
'            p_process_when            => l_process.process_when,',
'            p_process_when2           => l_process.process_when2,',
'            p_process_when_type       => l_process.process_when_type,',
'            p_exec_cond_for_each_row  => l_process.exec_cond_for_each_row,',
'            p_only_for_changed_rows   => l_process.only_for_changed_rows,',
'            p_security_scheme         => l_process.security_scheme,',
'            p_required_patch          => l_process.required_patch,',
'            p_process_comment         => l_process.process_comment );',
'',
'        if l_process.process_type like ''NATIVE_WEB_SERVICE%'' then',
'            wwv_flow_copy_page.web_services (',
'                p_process_id_from => l_process.id,',
'                p_flow_id_from    => l_process.flow_id,',
'                p_page_id_from    => l_process.flow_step_id,',
'                p_process_id_to   => l_new_process_id,',
'                p_flow_id_to      => :FB_FLOW_ID,',
'                p_page_id_to      => nvl(:P590_COPY_TO_PAGE, l_process.flow_step_id) );',
'        end if;',
'    end loop;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar el proceso'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(227738024960696973.4001)
,p_process_success_message=>'Proceso Copiado'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614621871751011271.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(227738024960696973.4001)
,p_process_success_message=>'Proceso Copiado'
);
end;
/
prompt --application/pages/page_00646
begin
wwv_flow_api.create_page(
 p_id=>646.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Aplicaci\00F3n')
,p_step_title=>unistr('Actualizar Aplicaci\00F3n: Seleccionar Botones para No Ejecutar Validaciones')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208108626900064044.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492048321251709984.4001)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(484017424976766961.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492048518882709988.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1, b.id,  ',
'          (select ''CHECKED'' ',
'             from apex_collections b ',
'            where collection_name = ''UPGRADE_BUTTONS'' ',
'              and n001 = b.id',
'          ),null, '':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''BUTTON_LABEL'',b.button_name)) checked,',
'       b.button_name,',
'       b.button_image_alt button_label,',
'       decode(b.button_action,',
'                  ''SUBMIT'',           wwv_flow_lang.system_message(''DA_NAME.NATIVE_SUBMIT_PAGE''),',
'                  ''REDIRECT_PAGE'',    wwv_flow_lang.system_message(''REDIRECT_TO_PAGE_IN_THIS_APP''),',
'                  ''REDIRECT_URL'',     wwv_flow_lang.system_message(''REDIRECT_TO_URL''),',
'                  ''DEFINED_BY_DA'',    wwv_flow_lang.system_message(''DEFINED_BY_DA''),',
'                                      b.button_action)        button_action',
'  from wwv_flow_step_buttons b',
' where b.flow_id           = :FB_FLOW_ID ',
'   and b.security_group_id = :WORKSPACE_ID',
'   and b.flow_step_id      = :P86_PAGE_ID',
'   and b.button_action in (''SUBMIT'', ''REDIRECT_URL'', ''DEFINED_BY_DA'')',
'   and nvl(b.button_execute_validations,''Y'') = ''Y''                '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492048717947709990.4001)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn bot\00F3n en la p\00E1gina.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492049132636709998.4001)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Nombre del Bot\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492056819041756734.4001)
,p_db_column_name=>'BUTTON_LABEL'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Etiqueta de Bot\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492610112719198102.4001)
,p_db_column_name=>'CHECKED'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(26142329708050846.4001)
,p_db_column_name=>'BUTTON_ACTION'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Acci\00F3n de Bot\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(499670831354971940.4001)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_source=>'Seleccione los botones en los que Ejecutar Validaciones debe estar definido en No (como, por ejemplo, los botones Cancelar que ejecutan en lugar de redireccionar o los botones Suprimir).'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631547518877262184.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747143942014138167.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(615691929413717661.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208108626900064044.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492049727574710001.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208108626900064044.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p646_page is null then',
'  return true;',
'else',
'  for c1 in (select 1 x from wwv_flow_lock_page where locked_by is not null and flow_id = :fb_flow_id and object_id = :p646_page) loop',
'     return false;',
'  end loop;',
'end if;',
'return true;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492069821006806282.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208108626900064044.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(492051219028710016.4001)
,p_branch_action=>'f?p=&APP_ID.:862:&SESSION.::&DEBUG.::P862_PAGE_ID:&P646_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(492049727574710001.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631577928808406908.4001)
,p_name=>'P646_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(631547518877262184.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045580750905367804.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(492048518882709988.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045580803552367805.4001)
,p_event_id=>wwv_flow_api.id(2045580750905367804.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492608422023172491.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Buttons'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_collection_status number;',
'   l_id                number;',
'   l_count             number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''UPGRADE_BUTTONS'');',
'    for i in 1..apex_application.g_f01.count',
'    loop',
'        l_id := apex_application.g_f01(i);',
'        select count(*) into l_count ',
'          from wwv_flow_collections ',
'         where n001            = l_id ',
'           and collection_name = ''UPGRADE_BUTTONS'';',
'        if l_count = 0 then ',
'            l_collection_status := wwv_flow_collection.add_member(',
'                 p_collection_name => ''UPGRADE_BUTTONS'',',
'                 p_n001            => l_id);',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00651
begin
wwv_flow_api.create_page(
 p_id=>651.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Publicar Plantillas: Referencias'
,p_step_title=>'Publicar Plantillas: Referencias'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98889805553830765.4001)
,p_plug_name=>unistr('navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98890918020834332.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98894515296861926.4001)
,p_plug_name=>'Refrescar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las plantillas de suscripci\00F3n para la plantilla maestra seleccionada.</p>'),
unistr('<p>Para refrescar las plantillas de suscripci\00F3n, seleccione las deseadas y haga clic en <strong>Refrescar Selecci\00F3n</strong>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(99143017092392215.4001)
,p_name=>'Plantillas Suscritas'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q                        varchar2(32767) := null;',
'  l_page                   varchar2(2000);',
'  l_pages                  varchar2(2000);',
'  l_region                 varchar2(2000);',
'  l_report                 varchar2(2000);',
'  l_list                   varchar2(2000);',
'  l_label                  varchar2(2000);',
'  l_button                 varchar2(2000);',
'  l_menu                   varchar2(2000);',
'  l_calendar               varchar2(2000);',
'  l_popup_lov              varchar2(4000);',
'begin',
'  select wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'       wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'       wwv_flow_lang.system_message_lit(''REPORT''),',
'       wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'       wwv_flow_lang.system_message_lit(''LABEL''),',
'       wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'       wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'       wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'       wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'')',
'  into l_page,',
'       l_region,',
'       l_report,',
'       l_list,',
'       l_label,',
'       l_button,',
'       l_menu,',
'       l_calendar,',
'       l_popup_lov',
'  from dual;',
'  ',
'  if nvl(:P651_TYPE,''PAGE'') = ''PAGE'' then  		',
'    q:=q||''select wwv_flow_item.checkbox(1,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(name))||''''"'''') ck, '';    ',
'    q:=q||''''''''||l_page||'''''' type, ''; ',
'    q:=q||''flow_id, '';    ',
'    q:=q||''name, '';',
'    q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||name '';',
'    q:=q||''from wwv_flow_templates '';',
'    q:=q||''where id = :p651_reference_id '';',
'    q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'    q:=q||''from wwv_flow_templates '';',
'    q:=q||''where reference_id = :P651_REFERENCE_ID '';    ',
'    q:=q||''and security_group_id = :flow_security_group_id '';',
'    q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';                  ',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''REGION'' then',
'  	q:=q||''select wwv_flow_item.checkbox(2,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(page_plug_template_name))||''''"'''') ck, '';',
'  	q:=q||''''''''||l_region||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''page_plug_template_name name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||page_plug_template_name '';',
'  	q:=q||''from wwv_flow_page_plug_templates '';',
'  	q:=q||''where id = :p651_reference_id '';',
'  	q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'    q:=q||''from wwv_flow_page_plug_templates '';',
'    q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'    q:=q||''and security_group_id = :flow_security_group_id '';',
'    q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(page_plug_template_name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';                   ',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''REPORT'' then',
'  	q:=q||''select wwv_flow_item.checkbox(3,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(row_template_name))||''''"'''') ck, '';',
'  	q:=q||''''''''||l_report||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''row_template_name name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||row_template_name '';',
'    q:=q||''from wwv_flow_row_templates '';',
'    q:=q||''where id = :p651_reference_id '';',
'    q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_row_templates '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(row_template_name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''LIST'' then',
'    q:=q||''select wwv_flow_item.checkbox(4,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(list_template_name))||''''"'''') ck, '';',
'    q:=q||''''''''||l_list||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''list_template_name name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||list_template_name '';',
'  	q:=q||''from wwv_flow_list_templates '';',
'  	q:=q||''where id = :p651_reference_id '';',
'  	q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_list_templates '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(list_template_name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''LABEL'' then',
'    q:=q||''select wwv_flow_item.checkbox(5,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(template_name))||''''"'''') ck, '';',
'    q:=q||''''''''||l_label||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''template_name name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||template_name '';',
'    q:=q||''from wwv_flow_field_templates '';',
'    q:=q||''where id = :p651_reference_id '';',
'    q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_field_templates '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(template_name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''BUTTON'' then',
'    q:=q||''select wwv_flow_item.checkbox(6,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(template_name))||''''"'''') ck, '';',
'    q:=q||''''''''||l_button||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''template_name name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||template_name '';',
'  	q:=q||''from wwv_flow_button_templates '';',
'  	q:=q||''where id = :p651_reference_id '';',
'  	q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_button_templates '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(template_name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''MENU'' then',
'    q:=q||''select wwv_flow_item.checkbox(7,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(name))||''''"'''') ck, '';',
'    q:=q||''''''''||l_menu||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||name '';',
'    q:=q||''from wwv_flow_menu_templates '';',
'    q:=q||''where id = :p651_reference_id '';',
'    q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_menu_templates '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''CALENDAR'' then',
'    q:=q||''select wwv_flow_item.checkbox(8,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(name))||''''"'''') ck, '';',
'    q:=q||''''''''||l_calendar||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||name '';',
'    q:=q||''from wwv_flow_cal_templates '';',
'    q:=q||''where id = :p651_reference_id '';',
'    q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_cal_templates '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(name),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
'  if nvl(:P651_TYPE,''PAGE'') = ''POPUP_LOV'' then',
'    q:=q||''select wwv_flow_item.checkbox(9,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', ''''''||l_popup_lov||'''''')||''''"'''') ck, '';',
'    q:=q||''''''''||l_popup_lov||'''''' type, '';',
'  	q:=q||''flow_id, '';',
'  	q:=q||''''''Popup LOV'''' name, '';',
'  	q:=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||''''''||l_popup_lov||'''''' '';',
'    q:=q||''from wwv_flow_popup_lov_template '';',
'    q:=q||''where id = :p651_reference_id '';',
'    q:=q||''and security_group_id = :flow_security_group_id) copied_from '';',
'  	q:=q||''from wwv_flow_popup_lov_template '';',
'  	q:=q||''where reference_id = :P651_REFERENCE_ID '';',
'  	q:=q||''and security_group_id = :flow_security_group_id '';',
'  	q:=q||''and (:P651_FIND is null or '';',
'    q:=q||''     instr(upper(''''Popup LOV''''),upper(:P651_FIND)) > 0 or '';',
'    q:=q||''     instr(id,:P651_FIND) > 0) '';',
'  end if;',
' ',
'  wwv_flow.debug(''XXX-''||q);  ',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No se ha encontrado ninguna plantilla suscrita.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(103299327829783004.4001)
,p_query_column_id=>1
,p_column_alias=>'CK'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(99143409321392223.4001)
,p_query_column_id=>2
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(99143511302392223.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(99143601001392223.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Plantilla'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(108920713639569804.4001)
,p_query_column_id=>5
,p_column_alias=>'COPIED_FROM'
,p_column_display_sequence=>5
,p_column_heading=>'Copiado de'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108926723644619944.4001)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(98904029803913431.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(98890918020834332.4001)
,p_button_name=>'P651_GO'
,p_button_static_id=>'P651_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(103304301819822790.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(98890918020834332.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(98904221588913432.4001)
,p_branch_action=>'f?p=&APP_ID.:651:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98897332050876266.4001)
,p_name=>'P651_FIND'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(98890918020834332.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca criterios de consulta que no sean sensibles a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98901629326903853.4001)
,p_name=>'P651_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(98890918020834332.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que aparecer\00E1 y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103295714230722294.4001)
,p_name=>'P651_REFERENCE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108926723644619944.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103320806376278163.4001)
,p_name=>'P651_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(108926723644619944.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1194417976889758808.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(99143017092392215.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1194418084763758809.4001)
,p_event_id=>wwv_flow_api.id(1194417976889758808.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(103611114031000150.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- page',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_page_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f01(i));',
'end loop;',
'-- region',
'for i in 1..wwv_flow.g_f02.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_region_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f02(i));',
'end loop;',
'-- report',
'for i in 1..wwv_flow.g_f03.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_report_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f03(i));',
'end loop;',
'-- list',
'for i in 1..wwv_flow.g_f04.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_list_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f04(i));',
'end loop;',
'-- label',
'for i in 1..wwv_flow.g_f05.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_field_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f05(i));',
'end loop;',
'-- button',
'for i in 1..wwv_flow.g_f06.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_button_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f06(i));  ',
'end loop;',
'-- breadcrumb',
'for i in 1..wwv_flow.g_f07.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_menu_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f07(i));',
'end loop;',
'-- calendar',
'for i in 1..wwv_flow.g_f08.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_calendar_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f08(i));',
'end loop;',
'-- popup LOV',
'for i in 1..wwv_flow.g_f09.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_popuplov_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f09(i));  ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar las plantillas de suscripci\00F3n seleccionadas.')
,p_process_when_button_id=>wwv_flow_api.id(103304301819822790.4001)
,p_process_success_message=>unistr('Se han refrescado las plantillas de suscripci\00F3n seleccionadas.')
);
end;
/
prompt --application/pages/page_00652
begin
wwv_flow_api.create_page(
 p_id=>652.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Etiqueta: Nombre'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Etiqueta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91871626479901740.4001)
,p_plug_name=>'Crear Plantilla de Etiqueta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132576120832100122.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(165617402058355880.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91880811503916335.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(132576120832100122.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91889113020926194.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(132576120832100122.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91883830897921915.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(132576120832100122.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(91881127139916336.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589889892427923043.4001)
,p_branch_action=>'f?p=&APP_ID.:941:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(91883830897921915.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87466312950832763.4001)
,p_name=>'P652_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(91871626479901740.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87467627148836828.4001)
,p_name=>'P652_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(91871626479901740.4001)
,p_prompt=>'Clase de Plantilla'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LABEL THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43828319065855502.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91873003407904527.4001)
,p_name=>'P652_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(91871626479901740.4001)
,p_prompt=>'Nombre de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca un nombre para esta plantilla de etiqueta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87470326933846248.4001)
,p_validation_name=>'P652_THEME'
,p_validation_sequence=>10
,p_validation=>'P652_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(91889113020926194.4001)
,p_associated_item=>wwv_flow_api.id(87466312950832763.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87472218753853322.4001)
,p_validation_name=>'P652_NAME'
,p_validation_sequence=>20
,p_validation=>'P652_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(91889113020926194.4001)
,p_associated_item=>wwv_flow_api.id(91873003407904527.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87473505378858994.4001)
,p_validation_name=>'P652_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P652_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(91889113020926194.4001)
,p_associated_item=>wwv_flow_api.id(87467627148836828.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589889659188923041.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(91880811503916335.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589889777673923042.4001)
,p_event_id=>wwv_flow_api.id(589889659188923041.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91916500787064644.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Label Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_field_template(',
'    P_FLOW_ID                  => :FB_FLOW_ID,',
'    P_TEMPLATE_NAME            => :P652_NAME,            ',
'    P_TEMPLATE_BODY1           => ''<label for="#CURRENT_ITEM_NAME#" tabindex="999">'',',
'    P_TEMPLATE_BODY2           => ''</label>'',',
'    P_ON_ERROR_BEFORE_LABEL    => null,',
'    P_ON_ERROR_AFTER_LABEL     => ''<br/>#ERROR_MESSAGE#'',',
'    P_TEMPLATE_COMMENT         => null,',
'    P_THEME_ID                 => :P652_THEME,',
'    P_THEME_CLASS_ID           => :P652_THEME_CLASS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Plantilla creada.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(91889113020926194.4001)
,p_process_success_message=>'Plantilla de etiqueta creada'
);
end;
/
prompt --application/pages/page_00654
begin
wwv_flow_api.create_page(
 p_id=>654.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Im\00E1genes')
,p_step_title=>unistr('Im\00E1genes')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script>',
'',
'function passBack(x, return_item){',
'opener.$x(return_item).value = x;',
'	opener.$x(return_item).focus()',
'	close();',
'}',
'',
'</script>'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.fa-icon-block {',
'    display: inline-block;',
'}',
'.fa-icon-block a,',
'.fa-icon-block a:hover {',
'    text-decoration: none;',
'}',
'.fa-icon-block a {',
'    display: inline-block;',
'    width: 160px;',
'    padding: 8px;',
'    height: 90px;',
'    text-align: center;',
'    border-radius: 2px;',
'    vertical-align: top;',
'}',
'.fa-icon-block a:hover {',
'    background-color: #F8F8F8;',
'    box-shadow: 0 0 0 1px rgba(0,0,0,.1)',
'}',
'.fa-icon-block .fa {',
'    font-size: 42px;',
'    display: inline-block;',
'    color: #707070;',
'    line-height: 1.25;',
'}',
'.fa-icon-block .icon-label {',
'    font-size: 12px;',
'    line-height: 16px;',
'    display: block;',
'    color: #404040;',
'}'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112406926141430926.4001)
,p_plug_name=>'Images'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_popup_images(',
'    p_return_item => :P654_RETURN_ITEM, ',
'    p_image_size  => :P654_ICON_SIZE,',
'    p_show        => :P654_SHOW, ',
'    p_category    => :P654_ICON_CATEGORY);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112644519924330778.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112851914437483431.4001)
,p_plug_name=>'Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_header=>'<p>Haga clic en una imagen para seleccionarla y cerrar esta ventana.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112674814860338798.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(112644519924330778.4001)
,p_button_name=>'P654_GO'
,p_button_static_id=>'P654_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112884404235593950.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(112644519924330778.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112674211051337641.4001)
,p_branch_action=>'f?p=&APP_ID.:654:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2980900959967526.4001)
,p_name=>'P654_RETURN_ITEM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(112644519924330778.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112659232391334369.4001)
,p_name=>'P654_ICON_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(112644519924330778.4001)
,p_item_default=>'64'
,p_prompt=>unistr('Tama\00F1o de Icono')
,p_source=>'64'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'STANDARD ICON SIZES 2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''12x12''	 d, 12  r from dual union all',
'select ''16x16''	 d, 16  r from dual union all',
'select ''20x20''	 d, 20  r from dual union all',
'select ''32x32''	 d, 32  r from dual union all',
'select ''64x64''	 d, 64  r from dual union all',
'select ''128x128'' d, 128 r from dual union all',
'select ''140x90''	 d, 140 r from dual',
'order by 2'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>':P654_SHOW is null or :P654_SHOW = ''STANDARD'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tama\00F1o de imagen de aplicaci\00F3n est\00E1ndar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112869831762564119.4001)
,p_name=>'P654_SHOW'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(112644519924330778.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_icon_library wwv_flow_themes.icon_library%type;',
'begin',
'    select min( icon_library )',
'      into l_icon_library',
'      from wwv_flow_themes t,',
'           wwv_flow_user_interfaces ui',
'     where ui.flow_id = :FB_FLOW_ID',
'       and ui.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and t.flow_id            = ui.flow_id',
'       and t.theme_id           = ui.theme_id',
'       and t.security_group_id  = ui.security_group_id;',
'',
'  return nvl( l_icon_library, ''STANDARD'' );',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IMAGE PREVIEW REPOSITORY'
,p_lov=>'.'||wwv_flow_api.id(2545625667361279.4001)||'.'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las im\00E1genes est\00E1ndar son im\00E1genes que forman parte de la distribuci\00F3n de Oracle Application Express y est\00E1n disponibles para que las utilicen todas las aplicaciones. Las im\00E1genes del espacio de trabajo est\00E1n disponibles en todo el espacio de trabajo')
||unistr('. Las im\00E1genes de aplicaci\00F3n s\00F3lo est\00E1n disponibles para esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1301369975206065008.4001)
,p_name=>'P654_ICON_CATEGORY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(112644519924330778.4001)
,p_prompt=>unistr('Categor\00EDa')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FONT_CATEGORIES'
,p_lov=>'.'||wwv_flow_api.id(1362022415318990531.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Categor\00EDa -')
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>':P654_SHOW is null or :P654_SHOW in ( ''FONTAPEX'', ''FONTAWESOME'' )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la categor\00EDa Font Awesome.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00655
begin
wwv_flow_api.create_page(
 p_id=>655.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Etiqueta: Copiar de'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Etiqueta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46354116636220743.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91949529268203995.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91949814840203997.4001)
,p_plug_name=>'Crear Plantilla de Etiqueta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91950420086204002.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46354116636220743.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91950712227204004.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46354116636220743.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91951032619204005.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46354116636220743.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152132728007993815.4001)
,p_branch_action=>'f?p=&FLOW_ID.:353:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589888846733923033.4001)
,p_branch_action=>'f?p=&APP_ID.:941:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(91951032619204005.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91951320021204006.4001)
,p_name=>'P655_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(91949814840203997.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar la plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(91952006284204015.4001)
,p_validation_name=>'P655_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P655_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(91951320021204006.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-MAY-2002 14:33'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589888625871923031.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(91950420086204002.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589888707934923032.4001)
,p_event_id=>wwv_flow_api.id(589888625871923031.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00656
begin
wwv_flow_api.create_page(
 p_id=>656.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Regiones en Cach\00E9')
,p_step_title=>unistr('Regiones en Cach\00E9')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196271102488602659.4001)
,p_plug_name=>'Regiones'
,p_region_name=>'cachedRegions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   ''<input type="checkbox" name="f01" value="''||r.id||''" title="''||wwv_flow_lang.system_message(''PURGE_LABEL'',wwv_flow_escape.html(r.plug_name))||''"/>'' cb,',
'   r.flow_id application_id,',
'   r.page_id page_id, ',
'   (select name from wwv_flow_steps where flow_id = r.flow_id and id = r.page_id) page_name,',
'   c.region_id, ',
'   r.plug_name region_name,',
'   case',
'     when r.plug_source_type like ''NATIVE%'' then wwv_flow_lang.system_message(''REGION_NAME.''||r.plug_source_type)',
'     else r.plug_source_type',
'   end region_type,',
'   c.language, ',
'  sys.dbms_lob.getlength(c.page_text) text_length, ',
'  cached_on, ',
'  round((sysdate - c.cached_on) * 3600 * 24,0) cache_age_in_seconds, ',
'    r.PLUG_CACHING_MAX_AGE_IN_SEC - round((sysdate - c.cached_on) * 3600 * 24,0) max_age_in_seconds,',
'  decode(greatest((sysdate - c.cached_on) * 3600 * 24,r.PLUG_CACHING_MAX_AGE_IN_SEC),r.PLUG_CACHING_MAX_AGE_IN_SEC,m.Unexpired,m.Expired) cache_status,',
'  r.PLUG_CACHING caching_method,',
'decode(decode(r.PLUG_CACHE_WHEN,null,''N'',''0'',''N'',''Y''),''N'',null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'')',
'   conditional,',
'  c.security_group_id',
'from wwv_flow_page_cache c,',
'     wwv_flow_page_plugs r,',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired',
' from dual) m',
'where c.region_id(+) = r.id and',
'      c.flow_id(+) = r.flow_id and',
'      r.flow_id = :fb_flow_id and ',
'      r.security_group_id = :flow_security_group_id and ',
'      c.region_id is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(196271205259602659.4001)
,p_name=>'Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196271412473602672.4001)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_column_comment=>'<input type="checkbox" title="&CHECK_ALL_MSG." onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196271528787602674.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196271601599602676.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196271730101602676.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196271831948602677.4001)
,p_db_column_name=>'REGION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('N\00FAmero de Regi\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196271929758602678.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Nombre de la Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272010006602679.4001)
,p_db_column_name=>'REGION_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Tipo de Regi\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272109292602680.4001)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272214250602680.4001)
,p_db_column_name=>'TEXT_LENGTH'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Longitud de Texto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272329219602681.4001)
,p_db_column_name=>'CACHED_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Almacenado en Cach\00E9 el')
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272423956602682.4001)
,p_db_column_name=>'CACHE_AGE_IN_SECONDS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Duraci\00F3n de Cach\00E9')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272519587602683.4001)
,p_db_column_name=>'MAX_AGE_IN_SECONDS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272609426602684.4001)
,p_db_column_name=>'CACHE_STATUS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272701873602684.4001)
,p_db_column_name=>'CACHING_METHOD'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('M\00E9todo')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196272928340602686.4001)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196273015543602687.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Security_Group_Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196274501120614084.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(196271102488602659.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:656,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31069420375930052.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(196271102488602659.4001)
,p_button_name=>'PURGE_EXPIRED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Depurar Elementos Vencidos'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32356202211381537.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(196271102488602659.4001)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Depurar Selecci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(31042430351790472.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(196271102488602659.4001)
,p_button_name=>'PURGE_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Depurar Todo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(31044802237790479.4001)
,p_branch_action=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1194417247207758801.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(196271102488602659.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1194417336851758802.4001)
,p_event_id=>wwv_flow_api.id(1194417247207758801.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(31044502232790479.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge all'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P656_PAGE is null then',
'wwv_flow_page_cache_api.purge_regions_by_app(p_application=>:fb_flow_id);',
'else',
'for c1 in (',
'select id ',
'from wwv_flow_page_plugs ',
'where page_id = :P656_PAGE ',
'and flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id) loop',
'    wwv_flow_page_cache_api.purge_regions_by_id (',
'        p_application => :fb_flow_id,',
'        p_region_id => c1.id);',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido depurar las p\00E1ginas en cach\00E9.')
,p_process_when_button_id=>wwv_flow_api.id(31042430351790472.4001)
,p_process_success_message=>unistr('Regiones en cach\00E9 depuradas')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(31070211417955868.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge expired'
,p_process_sql_clob=>'wwv_flow_page_cache_api.purge_expired_regions (p_application => :fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se han podido depurar las regiones en cach\00E9 vencidas')
,p_process_when_button_id=>wwv_flow_api.id(31069420375930052.4001)
,p_process_success_message=>unistr('Regiones en cach\00E9 vencidas depuradas')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(32355328053379541.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_page_cache_api.purge_regions_by_id (',
'        p_application => :fb_flow_id,',
'        p_region_id => wwv_flow.g_f01(j));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido depurar la cach\00E9 de regi\00F3n seleccionada')
,p_process_when_button_id=>wwv_flow_api.id(32356202211381537.4001)
,p_process_success_message=>unistr('Regiones en cach\00E9 seleccionadas depuradas')
);
end;
/
prompt --application/pages/page_00657
begin
wwv_flow_api.create_page(
 p_id=>657.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Etiqueta: Nuevas Plantillas'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Etiqueta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46357218068249526.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(91957200231208656.4001)
,p_name=>'Crear Plantilla de Etiqueta'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id,',
'  template_name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',template_name) to_name,',
'  ''N'' Sub',
'  from WWV_FLOW_FIELD_TEMPLATES ',
'  where flow_id = :P655_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P353_COPY_FROM_THEME ',
' '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No se ha encontrado ninguna plantilla de etiqueta.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291237529606166298.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291237623454166298.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291237703880166298.4001)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'De Nombre'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291237830764166298.4001)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'A Nombre'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291237923679166298.4001)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>unistr('\00BFCopiar?')
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91959331738208667.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91959515709208671.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46357218068249526.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91959828764208671.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46357218068249526.4001)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Plantillas de Etiqueta'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91960120001208672.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46357218068249526.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(152145216972019088.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589889427167923039.4001)
,p_branch_action=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(91960120001208672.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74786905313611371.4001)
,p_name=>'P657_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(91957200231208656.4001)
,p_prompt=>'Copiar en Tema:'
,p_source=>'P353_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291246814285180721.4001)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Debe seleccionar al menos una plantilla que copiar.',
'',
''))
,p_when_button_pressed=>wwv_flow_api.id(91959828764208671.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(291252520303191940.4001)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select template_name',
'                  from WWV_FLOW_FIELD_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(91959828764208671.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589889284496923037.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(91959515709208671.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589889352716923038.4001)
,p_event_id=>wwv_flow_api.id(589889284496923037.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91960529335208674.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy label templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_field_template (',
'      p_copy_from_flow_id  => :P655_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :FB_FLOW_ID,',
'      p_from_template_id   => wwv_flow.g_f01(i),',
'      p_to_template_name   => wwv_flow.g_f02(i),',
'      p_to_template_id     => l_template_id,',
'      p_to_theme_id        => :p657_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) in (''SUBSCRIBE'') then',
'      wwv_flow_copy_metadata.subscribe_field_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar las plantillas de etiqueta.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(91959828764208671.4001)
,p_process_success_message=>'Se han copiado las plantillas de etiqueta.'
);
end;
/
prompt --application/pages/page_00658
begin
wwv_flow_api.create_page(
 p_id=>658.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Lista: Aplicaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44569604990181923.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231046600691526185.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(231136205422723196.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231046807572526186.4001)
,p_plug_name=>'Copiar Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231047020141526188.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44569604990181923.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231047206674526190.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44569604990181923.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231048131509526203.4001)
,p_branch_action=>'f?p=&APP_ID.:602:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P658_COPY_OPTION'
,p_branch_condition_text=>'SAME'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231047908453526202.4001)
,p_branch_action=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(231047206674526190.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P658_COPY_OPTION'
,p_branch_condition_text=>'DIFF'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231047428588526192.4001)
,p_name=>'P658_COPY_OPTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(231046807572526186.4001)
,p_item_default=>'SAME'
,p_prompt=>'Crear Lista como Copia de:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COPY LIST OPTION'
,p_lov=>'.'||wwv_flow_api.id(231048823449529621.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique c\00F3mo copiar una lista. Puede copiarla de la aplicaci\00F3n actual o de otra aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574136029731781516.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(231047020141526188.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574136171651781517.4001)
,p_event_id=>wwv_flow_api.id(574136029731781516.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00660
begin
wwv_flow_api.create_page(
 p_id=>660.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Lista de Valores Est\00E1tica')
,p_step_title=>unistr('Crear Lista de Valores Est\00E1tica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var globalPrefix = ''STATIC2:'';',
'',
'function returnStaticLOV () {',
'',
'    var lovString        = globalPrefix;',
'    var hasDisplayValues = 0;',
'',
'    var displayValues = document.wwv_flow.g_f01;',
'    var returnValues  = document.wwv_flow.g_f02',
'',
'    for ( i = 0; returnValues[i]; i++) {',
'        if (displayValues[i].value!='''') {',
'            hasDisplayValues = 1;',
'        }',
'    }',
'',
'    for ( i = 0; returnValues[i]; i++) {',
'        if (returnValues[i].value!='''') {',
'            if (i>0) {',
'                lovString = lovString + '','';',
'            }',
'            if (hasDisplayValues==1) {',
'                if (displayValues[i].value!='''') {',
'                    lovString = lovString + displayValues[i].value+'';'';',
'                } else {',
'                    lovString = lovString + returnValues[i].value+'';'';                    ',
'                }',
'            }',
'            lovString = lovString + returnValues[i].value;',
'        }',
'    }',
'    if (lovString != ''STATIC2:'') {',
'        var targetField = window.opener.$x($v(''P660_LOV_SOURCE_FIELD''));',
'        setValue(targetField,lovString);',
'        targetField.focus();',
'    }    ',
'',
'    window.close();',
'',
'}',
'',
'function parseLOV () {',
'    var l_seperator = '':'';',
'    var returnFieldName = document.getElementById(''P660_LOV_SOURCE_FIELD'').value;    ',
'    var lovSource = window.opener.document.getElementById(returnFieldName).value;',
'    var returnValues  = document.wwv_flow.g_f02;',
'    var displayValues = document.wwv_flow.g_f01;',
'',
'    if (lovSource.substring(0,6)==''STATIC'') {',
'        if (lovSource.substring(0,7)==''STATIC:'') {',
'            globalPrefix = ''STATIC:'';',
'           l_seperator = globalPrefix ;',
'        }  else if (lovSource.substring(0,8)== globalPrefix ) {',
'            l_seperator = globalPrefix  ;',
'        }',
'        var lovSourceComponents = lovSource.split(l_seperator);',
'        var lovItems = lovSourceComponents[1].split('','');',
'        for ( i = 0; lovItems[i]; i++) {',
'            if (lovItems[i].indexOf('';'')>0) {',
'                var lovItemComponents = lovItems[i].split('';'');',
'                displayValues[i].value = lovItemComponents[0];        ',
'                returnValues[i].value  = lovItemComponents[1];        ',
'            } else {',
'                returnValues[i].value = lovItems[i];        ',
'            }',
'        }',
'    }',
'}',
''))
,p_javascript_code_onload=>'parseLOV();'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42719813681816823.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(176420402139598395.4001)
,p_name=>unistr('Lista de Valores Est\00E1tica')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i,',
'       ''<input type="text" size="32" maxlength="255" value="" name="g_f01" id ="g_f01">'' g01,',
'       ''<input type="text" size="32" maxlength="255" value="" name="g_f02" id ="g_f02">'' g02',
'from   wwv_flow_dual100',
'where  i < 16',
'order  by i'))
,p_header=>unistr('Introduzca valores de visualizaci\00F3n y de retorno est\00E1ticos. Los valores se muestran en el orden en el que se han introducido.  ')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176812318528811250.4001)
,p_query_column_id=>1
,p_column_alias=>'I'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176812406760811251.4001)
,p_query_column_id=>2
,p_column_alias=>'G01'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Valor de Visualizaci\00F3n')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(176812514344811251.4001)
,p_query_column_id=>3
,p_column_alias=>'G02'
,p_column_display_sequence=>3
,p_column_heading=>'Valor de Retorno'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177264010169548398.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42719813681816823.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177113417386746223.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42719813681816823.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:returnStaticLOV()'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177248906565462250.4001)
,p_name=>'P660_LOV_SOURCE_FIELD'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(176420402139598395.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00661
begin
wwv_flow_api.create_page(
 p_id=>661.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Calendario'
,p_step_title=>'Editar Plantilla de Calendario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17909303167190934.4001)
,p_plug_name=>'Formatos de Mes'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17909523758190936.4001)
,p_plug_name=>'Formatos de Hora'
,p_region_name=>'HOUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>310
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17909720651190936.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17909931810190937.4001)
,p_plug_name=>unistr('Formatos de D\00EDa de la Semana')
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17910129677190937.4001)
,p_plug_name=>'Formatos de Tiempo'
,p_region_name=>'TIME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17910526042190937.4001)
,p_plug_name=>'Plantillas de Calendario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de calendario controlan el aspecto y colocaci\00F3n de un calendario. Estas plantillas utilizan las tablas HTML frecuentemente para organizar las fechas.</p>'),
unistr('<p>Puede colocar los atributos de calendario utilizando cadenas de sustituci\00F3n como #DD# y #MONTH#. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).</p>')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17910908424190938.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>710
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n de formato de fecha:</p>'),
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'</ul>',
unistr('<p>Si coloca "I" delante de cualquier cadena, el texto tendr\00E1 may\00FAscula inicial.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17911122903190939.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12991522578387911.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46234415190678960.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17913025405190949.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17912800607190949.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17912213681190947.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17912609970190949.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P661_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17912019745190946.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17926419819190973.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P661_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17912800607190949.4001)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17926617105190973.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P661_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17913025405190949.4001)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30776715995916612.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17933207317256955.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>37
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22157104709090132.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>38
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3711628915280141.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>48
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22190129784182548.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>59
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17927030531190974.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P661_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17927229518190974.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>139
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17927426481190974.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17913220094190950.4001)
,p_name=>'P661_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17913408038190953.4001)
,p_name=>'P661_DAILY_MONTH_TITLE_FORMAT'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_api.id(17909303167190934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Mes')
,p_source=>'DAILY_MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para el t\00EDtulo mensual que aparece en la parte superior de cada d\00EDa. \00C9sta es la primera parte de un calendario que se imprime en la p\00E1gina. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17913824377190955.4001)
,p_name=>'P661_DAILY_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_api.id(17909303167190934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de D\00EDa de la Semana')
,p_source=>'DAILY_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17914308300190955.4001)
,p_name=>'P661_DAILY_MONTH_OPEN_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17909303167190934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Mes'
,p_source=>'DAILY_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17914818538190955.4001)
,p_name=>'P661_DAILY_MONTH_CLOSE_FORMAT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(17909303167190934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Mes'
,p_source=>'DAILY_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en el "Formato de Apertura de Mes".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17915316109190956.4001)
,p_name=>'P661_DAILY_DAY_TITLE_FORMAT'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(17909931810190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa')
,p_source=>'DAILY_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para el t\00EDtulo del d\00EDa, que es lo primero que se imprime detr\00E1s del "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17915821985190956.4001)
,p_name=>'P661_DAILY_DAY_OPEN_FORMAT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_api.id(17909931810190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Apertura de D\00EDa')
,p_source=>'DAILY_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime para cada d\00EDa. Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa ')
||unistr('en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17916325419190956.4001)
,p_name=>'P661_DAILY_DAY_CLOSE_FORMAT'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(17909931810190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Cierre de D\00EDa')
,p_source=>'DAILY_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17916821541190956.4001)
,p_name=>'P661_DAILY_TODAY_OPEN_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(17909931810190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hoy'
,p_source=>'DAILY_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir la fecha actual. Normalmente se trata de una etiqueta HTML que es un contenedor, como un td, y que no coincide exactamente con el "Formato de Apertura de D\00EDa". Incluya cadenas de sustituci\00F3n para incluir')
||unistr(' contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17918812994190958.4001)
,p_name=>'P661_DAILY_TIME_TITLE_FORMAT'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(17910129677190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Tiempo')
,p_source=>'DAILY_TIME_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para formatear un t\00EDtulo de tiempo. Por ejemplo, si desea mostrar la hora y los minutos en la columna de tiempo, puede utilizar HH:MI.'),
unistr('<p> Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  #HH#:#MI#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17919324110190958.4001)
,p_name=>'P661_DAILY_TIME_OPEN_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17910129677190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Tiempo'
,p_source=>'DAILY_TIME_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un tiempo. '),
'',
unistr('<p>Normalmente se trata de una etiqueta HTML que es un contenedor, como un td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17919829636190958.4001)
,p_name=>'P661_DAILY_TIME_CLOSE_FORMAT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(17910129677190937.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Tiempo'
,p_source=>'DAILY_TIME_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un tiempo.  '),
'<p>Normalmente se trata de una etiqueta HTML que cierra la etiqueta utilizada en "Formato de Apertura de Tiempo".',
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17920800891190959.4001)
,p_name=>'P661_DAILY_HOUR_OPEN_FORMAT'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(17909523758190936.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hora'
,p_source=>'DAILY_HOUR_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir una hora. \00C9ste se imprime para cada hora. Normalmente se trata de una etiqueta HTML que es un contenedor, como tr. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista comple')
||unistr('ta en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17921320545190959.4001)
,p_name=>'P661_DAILY_HOUR_CLOSE_FORMAT'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_api.id(17909523758190936.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Hora'
,p_source=>'DAILY_HOUR_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una hora. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de Hora".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17923308184190961.4001)
,p_name=>'P661_STAY'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_api.id(17910526042190937.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17923817764190961.4001)
,p_name=>'P661_ID_NEXT'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_prompt=>'P661_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17924020322190962.4001)
,p_name=>'P661_ID_PREV'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_prompt=>'P661_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17924229786190963.4001)
,p_name=>'P661_ID_COUNT'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_api.id(17909720651190936.4001)
,p_prompt=>'Plantilla de Calendario: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397293327628421296.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P661_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397293620131421296.4001)
,p_event_id=>wwv_flow_api.id(397293327628421296.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(17913025405190949.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397293701094423047.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P661_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397294005920423048.4001)
,p_event_id=>wwv_flow_api.id(397293701094423047.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(17912800607190949.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17924929977190968.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P661_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17925127241190970.4001)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P661_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P661_ID_NEXT'
,p_attribute_10=>'P661_ID_PREV'
,p_attribute_13=>'P661_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17925318273190970.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P661_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la plantilla de calendario.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17925510113190971.4001)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_api.id(17912609970190949.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17925701932190971.4001)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P661_REFERENCE_ID,',
'    p_subscribing_template_id    => :P661_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>'P661_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17925903342190971.4001)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:P661_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'P661_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Identificador de referencia eliminado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17926104695190971.4001)
,p_process_sequence=>32
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P661_REFERENCE_ID,',
'    p_subscribing_template_id    => :P661_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(17912019745190946.4001)
,p_process_when=>':P661_REFERENCE_ID is not null and :P661_REFRESH = ''Y'''
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Plantilla copiada.'
);
end;
/
prompt --application/pages/page_00663
begin
wwv_flow_api.create_page(
 p_id=>663.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Lista: Identificar Lista'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list_create.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46416204991627232.4001)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231161723063771921.4001)
,p_plug_name=>'Copiar Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231162126066771923.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(231136205422723196.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231162304281771925.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46416204991627232.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231162505796771925.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46416204991627232.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(231162707169771926.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46416204991627232.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231190423832832583.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(231162505796771925.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(231163418258771929.4001)
,p_branch_action=>'f?p=&APP_ID.:658:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(231162707169771926.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211669314246693889.4001)
,p_name=>'P659_COPY_FROM_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(231161723063771921.4001)
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n desde la que desea copiar la lista.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231179815605811273.4001)
,p_name=>'P663_LIST_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(231161723063771921.4001)
,p_prompt=>'Nuevo Nombre de Lista'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre de la lista que desea crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231183131881815979.4001)
,p_name=>'P663_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(231161723063771921.4001)
,p_prompt=>'Copiar Lista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(NAME) ln, id',
'from WWV_FLOW_LISTS',
'where flow_id = :P659_COPY_FROM_APPLICATION and',
'     security_group_id = :flow_security_group_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Lista -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P659_COPY_FROM_APPLICATION'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la lista que se va a copiar'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(211924627799726201.4001)
,p_validation_name=>'P659_COPY_FROM_APPLICATION'
,p_validation_sequence=>10
,p_validation=>'P659_COPY_FROM_APPLICATION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('Se debe seleccionar la aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(231162505796771925.4001)
,p_associated_item=>wwv_flow_api.id(211669314246693889.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231205701416882820.4001)
,p_validation_name=>'P663_ID Not Null'
,p_validation_sequence=>20
,p_validation=>'P663_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe seleccionar la lista.'
,p_when_button_pressed=>wwv_flow_api.id(231162505796771925.4001)
,p_associated_item=>wwv_flow_api.id(231183131881815979.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 14-JUN-2006 17:19'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231205930835882826.4001)
,p_validation_name=>'P663_LIST_NAME Not Null'
,p_validation_sequence=>30
,p_validation=>'P663_LIST_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la nueva lista.'
,p_when_button_pressed=>wwv_flow_api.id(231162505796771925.4001)
,p_associated_item=>wwv_flow_api.id(231179815605811273.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 14-JUN-2006 17:19'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574136433748781520.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(231162304281771925.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574136582739781521.4001)
,p_event_id=>wwv_flow_api.id(574136433748781520.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(231189513443829540.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create List'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.copy_list_from_app (',
'    p_copy_from_app_id    => :P659_COPY_FROM_APPLICATION,',
'    p_copy_from_list_id   => :P663_ID,',
'    p_new_list_name       => :P663_LIST_NAME,',
'    p_new_application_id  => :fb_flow_id);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar la lista'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(231162505796771925.4001)
,p_process_success_message=>'Lista Copiada'
);
end;
/
prompt --application/pages/page_00665
begin
wwv_flow_api.create_page(
 p_id=>665.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Calendario de Comentarios del Desarrollador'
,p_step_title=>'Calendario de Comentarios del Desarrollador'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702933455360235067.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702935214678239724.4001)
,p_plug_name=>'Application Comments'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P665a */',
'       trunc(created_on) created_on,',
'       flow_id || '': '' || created_by || '' - '' || count(*) as display_title',
'  from WWV_FLOW_APP_COMMENTS',
' where security_group_id = :flow_security_group_id',
' group by flow_id, trunc(created_on), created_by'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attribute_01=>'CREATED_ON'
,p_attribute_03=>'DISPLAY_TITLE'
,p_attribute_09=>'month:list:navigation'
,p_attribute_13=>'N'
,p_attribute_17=>'Y'
,p_attribute_19=>'N'
,p_attribute_21=>'10'
,p_attribute_22=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217704101671880031.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' wwv_flow_utilities.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar la fecha del calendario.'
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217704512411880032.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' wwv_flow_utilities.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar la fecha del calendario.'
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217704300757880032.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' wwv_flow_utilities.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cambiar la fecha del calendario.'
,p_process_comment=>'Generated 07-JUN-06'
);
end;
/
prompt --application/pages/page_00666
begin
wwv_flow_api.create_page(
 p_id=>666.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Mensajes de Depuraci\00F3n')
,p_step_title=>unistr('Mensajes de Depuraci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(623982424231484061.4001)
,p_plug_name=>unistr('Salida de Depuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select session_id, apex_user, page_view_id, message_timestamp, debug_entries, application_id, page_id, elap elapsed from',
'(',
'select ',
'    session_id,',
'    max(apex_user) apex_user,',
'    page_view_id,',
'     min(message_timestamp) message_timestamp, ',
'    max(page_id) page_id,',
'    max(flow_id) application_id,',
'    count(*) debug_entries,',
'   max(elap) elap',
'from wwv_flow_debug_messages m',
'where security_group_id = :flow_security_group_id ',
'and flow_id = :fb_flow_id',
'group by session_id,  page_view_id',
'union all',
'select ',
'    session_id,',
'    max(apex_user) apex_user,',
'    page_view_id,',
'     min(message_timestamp) message_timestamp, ',
'    max(page_id) page_id,',
'    max(flow_id) application_id,',
'    count(*) debug_entries,',
'   max(elap) elap',
'from wwv_flow_debug_messages2 m',
'where security_group_id = :flow_security_group_id ',
'and flow_id = :fb_flow_id',
'group by session_id, page_view_id',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(623982508550484061.4001)
,p_name=>'Debug Output - Disabled'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623982725835484064.4001)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Sesi\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623982829074484066.4001)
,p_db_column_name=>'APEX_USER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623982931967484066.4001)
,p_db_column_name=>'PAGE_VIEW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Identificador de Vista'
,p_column_link=>'f?p=&APP_ID.:938:&SESSION.::&DEBUG.:RP,RIR:P938_PAGE_VIEW_ID:#PAGE_VIEW_ID#'
,p_column_linktext=>'#PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623983222335484067.4001)
,p_db_column_name=>'DEBUG_ENTRIES'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Entradas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623983314383484067.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623983522277484067.4001)
,p_db_column_name=>'ELAPSED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Segundos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623984406719501366.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(623986004650576482.4001)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Registro de Hora'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(623986821404590758.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(623982424231484061.4001)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:666,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(624014013653929040.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(623982424231484061.4001)
,p_button_name=>'PURGE_DEBUG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Depurar Mensajes de Depuraci\00F3n')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:748:&SESSION.::&DEBUG.:748::'
);
end;
/
prompt --application/pages/page_00667
begin
wwv_flow_api.create_page(
 p_id=>667.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar'
,p_step_title=>'Actualizar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23543620471277777.4001)
,p_plug_name=>'Supporting Object Definition tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(22452018965176093.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24445623838690007.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24527100298108928.4001)
,p_plug_name=>'Detectar Objetos de Soporte Existentes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta consulta determina si los objetos de soporte ya est\00E1n instalados y necesitan actualizaci\00F3n.</p><p />'),
unistr('Identifique la consulta SQL que devuelve al menos una fila si existen objetos de soporte. La consulta no debe devolver ninguna fila si no existe ning\00FAn objeto de soporte.<p />')))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ejemplo:',
'',
'SELECT OBJECT_NAME FROM SYS.USER_OBJECTS WHERE OBJECT_NAME = ''MY_APPLICATION_TABLE'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(380035546592486164.4001)
,p_plug_name=>unistr('Scripts de Actualizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'case when (l.locked_by is null) or  (l.locked_by is not null and l.locked_by = :app_user) then',
'    ''<a href="f?p=4000:865:''||:app_session||''::NO:RP,865:P865_SCRIPT_ID,P865_MODE,F4000_LAST_VIEW:''||s.id||'',EDIT,667">''||',
'    ''<img src="#IMAGE_PREFIX#menu/pencil2_16x16.gif" alt="''||sm.edit||''"></a>''',
'end edit_link,',
's.name,',
's.sequence,',
'lower(nvl(s.last_updated_by,s.created_by)) last_updated_by,',
'nvl(s.last_updated_on, s.created_on) "LAST_UPDATED_ON",',
'sys.dbms_lob.substr(s.script,200,1)||(case when sys.dbms_lob.getlength(s.script) > 200 then ''...'' end) script,',
'case when l.locked_by is null then',
'    ''<span class="a-Icon icon-unlock" ></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''SCRIPT_NAME_UNLOCKED'', wwv_flow_escape.html(s.name))||''</span>''',
'else',
'    ''<span class="a-Icon icon-lock" ></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''SCRIPT_NAME_LOCKED'', wwv_flow_escape.html(s.name))||''</span>''',
'end locked,',
'case when l.locked_by is null then',
'    ''f?p=4000:16:''||:app_session||'':::16:P16_LOCK_SCRIPT_ID:''||s.id',
'else',
'    ''f?p=4000:16:''||:app_session||'':::16:P16_LOCK_ID,P16_LOCK_SCRIPT_ID:''||l.id||'',''||s.id',
'end locked_link',
'from "#OWNER#"."WWV_FLOW_INSTALL_SCRIPTS" s,',
'     wwv_flow_lock_script l,',
'     (select wwv_flow_lang.system_message(''EDIT'') edit',
'      from dual) sm',
'where s.flow_id = :fb_flow_id ',
'and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'and s.id = l.script_id(+)',
'and nvl(s.script_type,''INSTALL'') = ''UPGRADE'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(380035630081486164.4001)
,p_name=>'Upgrade Scripts'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn script de actualizaci\00F3n.')
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>380035630081486164
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(380035832666486172.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(925398888994092867.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>11
,p_column_identifier=>'G'
,p_column_label=>'<br />'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(380035937423486177.4001)
,p_db_column_name=>'NAME'
,p_display_order=>21
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:328:P328_ID,F4000_LAST_VIEW:#ID#,667'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(380036038287486177.4001)
,p_db_column_name=>'SEQUENCE'
,p_display_order=>31
,p_column_identifier=>'C'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(380036162219486177.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>41
,p_column_identifier=>'D'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(380036238021486177.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>51
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(380036320379486178.4001)
,p_db_column_name=>'SCRIPT'
,p_display_order=>61
,p_column_identifier=>'F'
,p_column_label=>'Script'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(858631025874067913.4001)
,p_db_column_name=>'LOCKED_LINK'
,p_display_order=>71
,p_column_identifier=>'I'
,p_column_label=>'LOCKED_LINK'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(858630946975067912.4001)
,p_db_column_name=>'LOCKED'
,p_display_order=>81
,p_column_identifier=>'H'
,p_column_label=>'Bloquear'
,p_column_link=>'#LOCKED_LINK#'
,p_column_linktext=>'#LOCKED#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24527314121108929.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(24527100298108928.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_execute_validations=>'N'
,p_button_condition=>'P667_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24442809434687128.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(380035546592486164.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24443015336687128.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(380035546592486164.4001)
,p_button_name=>'CREATESCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:850:P850_MODE,F4000_LAST_VIEW:UPGRADE,667'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24437723014680262.4001)
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>51
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24527706002108929.4001)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24527927496108929.4001)
,p_name=>'P667_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(24527100298108928.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24528104728108931.4001)
,p_name=>'P667_QUERY'
,p_item_sequence=>690
,p_item_plug_id=>wwv_flow_api.id(24527100298108928.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta para Detectar Objetos de Soporte Existentes:'
,p_source=>'GET_VERSION_SQL_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>14
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Escriba una consulta SQL que devuelva al menos una fila si existen objetos de soporte para esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(24437018512678938.4001)
,p_computation_sequence=>20
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(v(''REQUEST''),1,13)=''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(24544519869152501.4001)
,p_computation_sequence=>30
,p_computation_item=>'P667_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(927015690197639630.4001)
,p_computation_sequence=>30
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'667'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1119156918584390632.4001)
,p_name=>'Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(380035546592486164.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1119157014259390633.4001)
,p_event_id=>wwv_flow_api.id(1119156918584390632.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(380035546592486164.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24528413966108931.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P667_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24528625968108931.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P667_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_INSTALL.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24528806756108931.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'667'
);
end;
/
prompt --application/pages/page_00670
begin
wwv_flow_api.create_page(
 p_id=>670.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Calendario'
,p_step_title=>'Editar Plantilla de Calendario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17284317885778633.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17284900057778634.4001)
,p_plug_name=>'Formatos de Mes'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17285128475778635.4001)
,p_plug_name=>'Formatos de Hora'
,p_region_name=>'HOUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>310
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17285313089778635.4001)
,p_plug_name=>unistr('Formatos de D\00EDa de la Semana')
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17285502189778635.4001)
,p_plug_name=>'Formatos de Tiempo'
,p_region_name=>'TIME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17285715096778635.4001)
,p_plug_name=>'Formatos de Fin de Semana'
,p_region_name=>'END'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>610
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17285906179778635.4001)
,p_plug_name=>'Plantillas de Calendario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de calendario controlan el aspecto y colocaci\00F3n de un calendario. Estas plantillas utilizan las tablas HTML frecuentemente para organizar las fechas.</p>'),
unistr('<p>Puede colocar los atributos de calendario utilizando cadenas de sustituci\00F3n como #DD# y #MONTH#. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).</p>')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17286520844778637.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>710
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n de formato de fecha:</p>'),
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'<li>WTITLE</li>',
'</ul>',
unistr('<p>Si coloca "I" delante de cualquier cadena, el texto tendr\00E1 may\00FAscula inicial.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17286900148778638.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12991522578387911.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46237512121678967.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17289018915778641.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17288816609778641.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17288201639778641.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17288607720778641.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P670_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17288031005778641.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17305417854778663.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P670_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17288816609778641.4001)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17305606451778663.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P670_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17289018915778641.4001)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17932209610248166.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>33
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22157828604097018.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30776531794911691.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3710722551268819.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>45
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22191119179188943.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>56
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17306018604778663.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P670_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17306217099778664.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>139
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17306400038778664.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17289224574778642.4001)
,p_name=>'P670_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17290114977778644.4001)
,p_name=>'P670_WEEKLY_TITLE_FORMAT'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_api.id(17284900057778634.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Mes')
,p_source=>'WEEKLY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para el t\00EDtulo de mes que aparece en la parte superior de cada semana. \00C9sta es la primera parte de un calendario que se imprime en la p\00E1gina. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17290605792778644.4001)
,p_name=>'P670_WEEKLY_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_api.id(17284900057778634.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de D\00EDa de la Semana')
,p_source=>'WEEKLY_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17291125918778645.4001)
,p_name=>'P670_WEEKLY_MONTH_OPEN_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17284900057778634.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Mes'
,p_source=>'WEEKLY_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un mes. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17291615433778645.4001)
,p_name=>'P670_WEEKLY_MONTH_CLOSE_FORMAT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(17284900057778634.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Mes'
,p_source=>'WEEKLY_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una semana. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en el "Formato de Apertura de Mes".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17292128629778645.4001)
,p_name=>'P670_WEEKLY_DAY_TITLE_FORMAT'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa')
,p_source=>'WEEKLY_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para el t\00EDtulo del d\00EDa, que es lo primero que se imprime detr\00E1s del "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17292632210778646.4001)
,p_name=>'P670_WEEKLY_DAY_OPEN_FORMAT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Apertura de D\00EDa')
,p_source=>'WEEKLY_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime para cada d\00EDa. Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa ')
||unistr('en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17293126813778646.4001)
,p_name=>'P670_WEEKLY_DAY_CLOSE_FORMAT'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Cierre de D\00EDa')
,p_source=>'WEEKLY_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17293601124778646.4001)
,p_name=>'P670_WEEKLY_TODAY_OPEN_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hoy'
,p_source=>'WEEKLY_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir la fecha actual. Normalmente se trata de una etiqueta HTML que es un contenedor, como un td, y que no coincide exactamente con el "Formato de Apertura de D\00EDa". Incluya cadenas de sustituci\00F3n para incluir')
||unistr(' contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17294118205778647.4001)
,p_name=>'P670_WEEKLY_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_api.id(17285715096778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Fin de Semana')
,p_source=>'WEEKLY_WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para un d\00EDa de fin de semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17294601791778647.4001)
,p_name=>'P670_WEEKLY_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_api.id(17285715096778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Fin de Semana'
,p_source=>'WEEKLY_WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa de fin de semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como un TD. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas')
||unistr(' de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17295130193778647.4001)
,p_name=>'P670_WEEKLY_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_api.id(17285715096778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Fin de Semana'
,p_source=>'WEEKLY_WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa de fin de semana. \00C9ste es el \00FAltimo elemento de cada fin de semana que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Format')
||'o de Apertura de Fin de Semana". ',
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17295600187778647.4001)
,p_name=>'P670_WEEKLY_TIME_TITLE_FORMAT'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(17285502189778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Tiempo')
,p_source=>'WEEKLY_TIME_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para formatear un t\00EDtulo de tiempo. '),
unistr('<p> Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  #HH:MI#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17296115450778648.4001)
,p_name=>'P670_WEEKLY_TIME_OPEN_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17285502189778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Tiempo'
,p_source=>'WEEKLY_TIME_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un tiempo. '),
'',
unistr('<p>Normalmente se trata de una etiqueta HTML que es un contenedor, como un td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17296606719778648.4001)
,p_name=>'P670_WEEKLY_TIME_CLOSE_FORMAT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(17285502189778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Tiempo'
,p_source=>'WEEKLY_TIME_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un tiempo.  '),
'<p>Normalmente se trata de una etiqueta HTML que cierra la etiqueta utilizada en "Formato de Apertura de Tiempo".',
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17297132581778648.4001)
,p_name=>'P670_WEEK_TITLE_FORMAT'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(17285128475778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Semana')
,p_source=>'WEEK_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se imprimir\00E1 como t\00EDtulo de un calendario de vista semanal.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17297625218778649.4001)
,p_name=>'P670_WEEKLY_HOUR_OPEN_FORMAT'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(17285128475778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hora'
,p_source=>'WEEKLY_HOUR_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir una hora. \00C9ste se imprime para cada hora. Normalmente se trata de una etiqueta HTML que es un contenedor, como tr. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista comple')
||unistr('ta en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17298106208778649.4001)
,p_name=>'P670_WEEKLY_HOUR_CLOSE_FORMAT'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_api.id(17285128475778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Hora'
,p_source=>'WEEKLY_HOUR_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una hora. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de Hora".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17298612993778649.4001)
,p_name=>'P670_DAILY_TITLE_FORMAT'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo Diario')
,p_source=>'DAILY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 como t\00EDtulo de un calendario de vista diaria.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17299115769778650.4001)
,p_name=>'P670_DAILY_OPEN_FORMAT'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura Diario'
,p_source=>'DAILY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa en un calendario de vista diaria.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17299622977778650.4001)
,p_name=>'P670_DAILY_CLOSE_FORMAT'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_api.id(17285313089778635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre Diario'
,p_source=>'DAILY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa en un calendario de vista diaria.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17300627207778651.4001)
,p_name=>'P670_STAY'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_api.id(17285906179778635.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17302820384778654.4001)
,p_name=>'P670_ID_NEXT'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_prompt=>'P670_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17303002558778654.4001)
,p_name=>'P670_ID_PREV'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_prompt=>'P670_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17303214665778654.4001)
,p_name=>'P670_ID_COUNT'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_api.id(17284317885778633.4001)
,p_prompt=>'Plantilla de Calendario: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397294506419434043.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P670_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397294831938434043.4001)
,p_event_id=>wwv_flow_api.id(397294506419434043.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(17289018915778641.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397294912306435746.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P670_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397295227619435746.4001)
,p_event_id=>wwv_flow_api.id(397294912306435746.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(17288816609778641.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17303930471778662.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P670_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17304107753778662.4001)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P670_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P670_ID_NEXT'
,p_attribute_10=>'P670_ID_PREV'
,p_attribute_13=>'P670_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17304311080778662.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P670_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la plantilla de calendario.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17304508027778662.4001)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_api.id(17288607720778641.4001)
);
end;
/
prompt --application/pages/page_00671
begin
wwv_flow_api.create_page(
 p_id=>671.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar P\00E1gina: Separador Opciones')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pgs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44706330167756937.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204069723769908880.4001)
,p_plug_name=>unistr('Copiar P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P621_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(204068913160908875.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(204069723769908880.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
'       tab_step, ',
'       substr(wwv_flow_escape.html(tab_text),1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order  by tab_set, tab_sequence, tab_step'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204069110497908879.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204069216097908879.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204069308825908879.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(204069429085908880.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204094503856962236.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(202931703979545993.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_plug_name=>'List Based Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P621_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204070131230908882.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44706330167756937.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204070309177908883.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44706330167756937.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204070508754908883.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44706330167756937.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(204073118771908901.4001)
,p_branch_name=>'Go To Page 622'
,p_branch_action=>'f?p=&APP_ID.:622:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(204070309177908883.4001)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(204072921980908901.4001)
,p_branch_action=>'621'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(204070508754908883.4001)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(204072401518908898.4001)
,p_name=>'P671_TAB_OPTIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(204069723769908880.4001)
,p_item_default=>'NO'
,p_prompt=>'Opciones de Separador:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TAB_SET_CHOICE_ALL'
,p_lov=>'.'||wwv_flow_api.id(84778506791979282.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Seleccione si la p\00E1gina nueva debe tener separadores.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209392018927383072.4001)
,p_name=>'P671_TAB_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(204069723769908880.4001)
,p_prompt=>'Nombre de Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'' text="''||wwv_flow_escape.html(TAB_TEXT)||''"'' d,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P671_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P671_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el separador designado como actual para la nueva p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209449011093390265.4001)
,p_name=>'P671_TAB_LABEL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(204069723769908880.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca una etiqueta de separador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(209773604082407084.4001)
,p_name=>'P671_TAB_SET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(204069723769908880.4001)
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un juego de separadores identifica una recopilaci\00F3n de separadores. El separador actual se identifica mediante un separador en el juego que identifica esta p\00E1gina como "actual" para este separador. El mismo separador puede ser "actual" para muchas')
||unistr(' p\00E1ginas. Si no hay ninguna p\00E1gina actual para un juego de separadores concreto, este juego aparece sin ning\00FAn separador identificado como actual.</p>'),
unistr('<p>Los separadores actuales aparecen normalmente sin enlaces. Los separadores no actuales aparecen con un enlace. Los separadores que no son actuales son direcciones URL para otras p\00E1ginas cuando la p\00E1gina actual no contiene ning\00FAn elemento de pantal')
||unistr('la. Si la p\00E1gina actual contiene elementos de pantalla, el separador ejecutar\00E1 la p\00E1gina.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1556030297649334047.4001)
,p_name=>'P671_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('Preferencia de Navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1556030765732334048.4001)
,p_name=>'P671_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1556030938615334048.4001)
,p_name=>'P671_NAVLIST_ENTRY_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para la nueva entrada de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1556031492872334048.4001)
,p_name=>'P671_NAVLIST_PARENT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1556031970284334048.4001)
,p_name=>'P671_NEW_PARENT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    case ',
'        when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null)  then ',
'            lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'        else ',
'            lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')'' ',
'    end name,',
'    id',
'  from wwv_flow_list_items',
' start with parent_list_item_id is null',
'        and flow_id = :FB_FLOW_ID',
'        and list_id = :P671_NAVLIST_ID',
' connect by prior id = parent_list_item_id',
'        and prior list_id = list_id',
' order siblings by list_item_display_sequence',
'',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1556032437879334049.4001)
,p_name=>'P671_EXISTING_PARENT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1556030029344334045.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P671_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1556098641748518831.4001)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_ENTRY_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return null;'
,p_compute_when=>'P671_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1556098914886525215.4001)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P671_NEW_PARENT_ID'
,p_compute_when=>'P671_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1556099109208526910.4001)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P671_EXISTING_PARENT_ID'
,p_compute_when=>'P671_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1556097769474498680.4001)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_lists l       ',
' where l.flow_id = :FB_FLOW_ID',
'   and l.flow_id = i.flow_id',
'   and l.id = i.navigation_list_id',
'   and i.id = :P621_TO_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(210912824963545645.4001)
,p_validation_name=>'P671_TAB_SET Not Null'
,p_validation_sequence=>10
,p_validation=>'P671_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar el juego de separadores.'
,p_validation_condition=>'P671_TAB_OPTIONS'
,p_validation_condition2=>'EXISTING:EXISTING2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(204070309177908883.4001)
,p_associated_item=>wwv_flow_api.id(209773604082407084.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JAN-2003 14:01'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(210931601892548412.4001)
,p_validation_name=>'P671_TAB_LABEL Not Null'
,p_validation_sequence=>20
,p_validation=>'P671_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar la etiqueta de separador.'
,p_validation_condition=>'P671_TAB_OPTIONS'
,p_validation_condition2=>'NEW:EXISTING'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(204070309177908883.4001)
,p_associated_item=>wwv_flow_api.id(209449011093390265.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 07-JAN-2003 11:58'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(210949409511550603.4001)
,p_validation_name=>'P671_TAB_NAME'
,p_validation_sequence=>30
,p_validation=>'P671_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar el nombre de separador.'
,p_validation_condition=>'P671_TAB_OPTIONS'
,p_validation_condition2=>'EXISTING2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(204070309177908883.4001)
,p_associated_item=>wwv_flow_api.id(209392018927383072.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1556102525519621809.4001)
,p_validation_name=>'New Entry with no List'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P671_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P671_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(204070309177908883.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1556098268832507723.4001)
,p_validation_name=>'P671_NAVLIST_ENTRY_NAME'
,p_validation_sequence=>70
,p_validation=>'P671_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se necesita un nombre de entrada para las nuevas entradas de men\00FA de navegaci\00F3n.')
,p_validation_condition=>':P621_NAVIGATION_TYPE=''L'' and :P671_NAVLIST_OPTIONS=''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1556030938615334048.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1556102873191626438.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>70
,p_validation=>'P671_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P671_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(204070309177908883.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(210105928717442617.4001)
,p_name=>'Tab Option NO Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NO'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210106214625442619.4001)
,p_event_id=>wwv_flow_api.id(210105928717442617.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_NAME,P671_TAB_LABEL,P671_TAB_SET'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(210191517073448721.4001)
,p_name=>'Tab Option EXISTING Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210191801470448722.4001)
,p_event_id=>wwv_flow_api.id(210191517073448721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_SET,P671_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210192026470448722.4001)
,p_event_id=>wwv_flow_api.id(210191517073448721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(210218222268450250.4001)
,p_name=>'Tab Option EXISTING2 Settings'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210218531003450251.4001)
,p_event_id=>wwv_flow_api.id(210218222268450250.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_SET,P671_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210218725408450251.4001)
,p_event_id=>wwv_flow_api.id(210218222268450250.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(210237427462451704.4001)
,p_name=>'Tab Option NEW Settings'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210237924346451705.4001)
,p_event_id=>wwv_flow_api.id(210237427462451704.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(210237727768451705.4001)
,p_event_id=>wwv_flow_api.id(210237427462451704.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_SET,P671_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614677057243219870.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(204070131230908882.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614677381640219871.4001)
,p_event_id=>wwv_flow_api.id(614677057243219870.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1556035574358352817.4001)
,p_name=>'New Navlist Entry Name'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_condition_element=>'P671_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556036091396352820.4001)
,p_event_id=>wwv_flow_api.id(1556035574358352817.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_ENTRY_NAME,P671_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556035871283352819.4001)
,p_event_id=>wwv_flow_api.id(1556035574358352817.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_ENTRY_NAME,P671_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1556036296402356776.4001)
,p_name=>'Existing NavList Entry'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_condition_element=>'P671_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556036553909356777.4001)
,p_event_id=>wwv_flow_api.id(1556036296402356776.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556036711743356777.4001)
,p_event_id=>wwv_flow_api.id(1556036296402356776.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1556036841063358415.4001)
,p_name=>'Update Tree'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556037103298358415.4001)
,p_event_id=>wwv_flow_api.id(1556036841063358415.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#P671_NAVLIST_PARENT_ID option:contains('' ('')").attr("disabled","disabled");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1556097177222495564.4001)
,p_name=>'Show Navigation Tree'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_condition_element=>'P671_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556097432228495567.4001)
,p_event_id=>wwv_flow_api.id(1556097177222495564.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1556097682957495567.4001)
,p_event_id=>wwv_flow_api.id(1556097177222495564.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00674
begin
wwv_flow_api.create_page(
 p_id=>674.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades'
,p_step_title=>'Utilidades'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30785228682889678.4001)
,p_plug_name=>'Utilidades de Informe Interactivo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(30782715391876326.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177895623943482376.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La p\00E1gina Utilidades incluye enlaces a res\00FAmenes e informes que permiten a los desarrolladores ver una aplicaci\00F3n desde distintas perspectivas.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/application-utilities-page.html#GUID-A2907E49-4563-470E-B110-9BBDA93D0B8EE">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492633831728601029.4001)
,p_plug_name=>unistr('Utilidades Espec\00EDficas de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(492631804585583697.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(693371896293328501.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(177830919883437702.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177886613818301603.4001)
,p_branch_action=>'f?p=&FLOW_ID.:674:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00681
begin
wwv_flow_api.create_page(
 p_id=>681.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Temas'
,p_step_title=>'Historial de Temas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193117419035374956.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(58949101764235429.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193117618253374960.4001)
,p_plug_name=>'Historial de Temas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las recientes modificaciones realizadas en los temas de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193118212618374964.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P681a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_THEMES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193118416085374964.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193118532204374965.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193118629623374966.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193118730291374966.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193118832617374967.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193118905891374968.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193119003064374969.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193119123342374974.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193118011331374962.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193118212618374964.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:681:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00682
begin
wwv_flow_api.create_page(
 p_id=>682.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Entrada de Lista'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Entrada de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47677429898951987.4001)
,p_plug_name=>'Copiar Entrada de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(66003732624671753.4001)
,p_name=>'Entradas de Lista Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select',
'    wwv_flow_escape.html(list_item_link_text) list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,50) list_item_link_target, ',
'    parent_list_item_id,',
'    LIST_ITEM_ICON, list_id',
'  from   ',
'    wwv_flow_list_items ',
'  where  ',
'    list_id = replace(:P682_LIST_ID,''%''||''null%'',null)',
') select ',
'      (level-1)*25 indent,',
'      list_item_link_text,',
'      id,',
'      list_item_display_sequence,',
'      list_item_type,    ',
'      list_item_link_target,',
'      parent_list_item_id,',
'      LIST_ITEM_ICON',
'from list_items i',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence, list_item_link_text'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66003925530671754.4001)
,p_query_column_id=>1
,p_column_alias=>'INDENT'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004022306671754.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<img src="src="#IMAGE_PREFIX#1px_trans.gif" width="#INDENT#" height="1" alt=""">',
'<a href="f?p=&APP_ID.:4052:&SESSION.::&DEBUG.::F4000_P4052_ID:#ID#"> #LIST_ITEM_LINK_TEXT#<a>'))
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004100586671755.4001)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004227988671755.4001)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004314343671755.4001)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004429535671755.4001)
,p_query_column_id=>6
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>7
,p_column_heading=>'Destino'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004515033671755.4001)
,p_query_column_id=>7
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(66004931142671755.4001)
,p_query_column_id=>8
,p_column_alias=>'LIST_ITEM_ICON'
,p_column_display_sequence=>5
,p_column_heading=>'Imagen'
,p_use_as_row_header=>'N'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P4050_SHOW_IMAGE_NAMES'
,p_display_when_condition2=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(886670952420607601.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47677630721951988.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(886670952420607601.4001)
,p_button_name=>'COPY_LIST_ENTRY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Entrada de Lista'
,p_button_position=>'NEXT'
,p_button_condition=>'P682_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47677816933951988.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(886670952420607601.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47678032275951988.4001)
,p_branch_action=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47678226460951988.4001)
,p_name=>'P682_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(47677429898951987.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47678412253951990.4001)
,p_name=>'P682_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(47677429898951987.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lista:'
,p_source=>'LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id from WWV_FLOW_LISTS',
'where id = :p682_list_id',
'and security_group_id = :flow_security_group_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47678619794951990.4001)
,p_name=>'P682_PARENT_LIST_ITEM_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(47677429898951987.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Entrada de Lista Principal:'
,p_source=>'PARENT_LIST_ITEM_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_ITEM_LINK_TEXT, id',
'from WWV_FLOW_LIST_ITEMS',
'where id = :P682_PARENT_LIST_ITEM_ID',
'and list_id = :P682_LIST_ID',
'and security_group_id = :flow_security_group_id'))
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P682_PARENT_LIST_ITEM_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el principal de la entrada de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47678827792951991.4001)
,p_name=>'P682_DISPLAY_SEQUENCE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(47677429898951987.4001)
,p_prompt=>unistr('Secuencia de Visualizaci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   s number;',
'begin',
'   select max(LIST_ITEM_DISPLAY_SEQUENCE) into s',
'   from   WWV_FLOW_LIST_ITEMS ',
'   where  LIST_ID = v(''P682_LIST_ID'');',
'   s := nvl(s,0);',
'   s := trunc(s) + 10;',
'   return s;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la secuencia de la nueva entrada de lista que se crear\00E1.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47679015840951991.4001)
,p_name=>'P682_LINK_TEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(47677429898951987.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nueva Etiqueta de Entrada de Lista'
,p_source=>'LIST_ITEM_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nuevo texto de enlace de la entrada de lista que se crear\00E1.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(47679213175951991.4001)
,p_name=>'P682_LINK_TARGET'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(47677429898951987.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Destino de Enlace:'
,p_source=>'LIST_ITEM_LINK_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el destino del enlace. Para cambiarlo, edite la nueva entrada de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1059807409409457611.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(47677816933951988.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1059807510748457612.4001)
,p_event_id=>wwv_flow_api.id(1059807409409457611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47679523349951992.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_ITEMS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_ITEMS'
,p_attribute_03=>'P682_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47756328301132663.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy List Entry'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.create_list_entry_as_copy (',
'   p_id           => :P682_ID,',
'   p_list_id      => :P682_LIST_ID,',
'   p_new_sequence => :P682_DISPLAY_SEQUENCE,',
'   p_new_text     => :P682_LINK_TEXT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar la entrada de lista'
,p_process_success_message=>'Entrada de lista copiada'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(47679926489951992.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'682'
);
end;
/
prompt --application/pages/page_00685
begin
wwv_flow_api.create_page(
 p_id=>685.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Bifurcaci\00F3n: Opciones de Bifurcaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Bifurcaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46133022676932616.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228250020358897351.4001)
,p_plug_name=>unistr('Copiar Bifurcaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228250418726897353.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(228256415837925869.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(228250621991897354.4001)
,p_name=>unistr('Bifurcaciones de P\00E1gina de Destino')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  branch_name, substr(branch_action, 1, 40) as branch_action, branch_sequence, branch_type, branch_point ',
'from wwv_flow_step_branches',
'where flow_step_id = :P587_COPY_TO_PAGE',
'and flow_id = :fb_flow_id  ',
'and security_group_id = :flow_security_group_id',
'order by branch_point, branch_sequence, id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No hay ninguna bifurcaci\00F3n definida actualmente en la p\00E1gina de destino.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_break_repeat_heading_format=>'<strong>#COLUMN_VALUE#</strong>'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(15655931756563639.4001)
,p_query_column_id=>1
,p_column_alias=>'BRANCH_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228301823240287581.4001)
,p_query_column_id=>2
,p_column_alias=>'BRANCH_ACTION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228301906282287581.4001)
,p_query_column_id=>3
,p_column_alias=>'BRANCH_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228302028111287581.4001)
,p_query_column_id=>4
,p_column_alias=>'BRANCH_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(15652127549539076)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228302129892287582.4001)
,p_query_column_id=>5
,p_column_alias=>'BRANCH_POINT'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Punto de Bifurcaci\00F3n')
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(179397725241870240)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228251206130897357.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46133022676932616.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228251427191897359.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46133022676932616.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(228251614614897359.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46133022676932616.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:587:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(228253427580897372.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228251823759897360.4001)
,p_name=>'P685_BRANCH_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(228250020358897351.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Secuencia de Bifurcaci\00F3n de P\00E1gina de Destino')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(BRANCH_SEQUENCE) + 10',
'from WWV_FLOW_STEP_BRANCHES ',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(228252327918897365.4001)
,p_name=>'P685_BRANCH_POINT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(228250020358897351.4001)
,p_prompt=>unistr('Punto de Bifurcaci\00F3n de P\00E1gina de Destino')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE.BRANCH.POINTS'
,p_lov=>'.'||wwv_flow_api.id(179397725241870240.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nuevo nombre de proceso'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(230867913201911662.4001)
,p_name=>'P685_WHEN_BUTTON_PRESSED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(228250020358897351.4001)
,p_prompt=>unistr('Si Se Hace Clic en el Bot\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :P587_COPY_TO_PAGE',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:P587_COPY_TO_PAGE, ui.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n de Bot\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este componente s\00F3lo se ejecutar\00E1 si un usuario hace clic en este bot\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231020304767325561.4001)
,p_name=>'P685_COPY_BRANCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(228250020358897351.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Copiar Bifurcaci\00F3n:')
,p_source=>'P587_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(BRANCH_SEQUENCE||''. ''||wwv_flow_escape.html(nvl(branch_name, BRANCH_ACTION)),1,90) bname, id ',
'from WWV_FLOW_STEP_BRANCHES ',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id ',
'order by BRANCH_SEQUENCE '))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Bifurcaci\00F3n que se va a copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231565318196824500.4001)
,p_name=>'P685_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(228250020358897351.4001)
,p_prompt=>unistr('Copiar de P\00E1gina:')
,p_source=>'P587_COPY_FROM_PAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina a la que se copiar\00E1 la bifurcaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231573814172832766.4001)
,p_name=>'P685_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(228250020358897351.4001)
,p_prompt=>unistr('P\00E1gina de Destino:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P587_COPY_TO_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('P\00E1gina a la que se copiar\00E1 la bifurcaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(228253015642897367.4001)
,p_validation_name=>'P685_BRANCH_SEQUENCE_NOT_NULL'
,p_validation_sequence=>10
,p_validation=>'P685_BRANCH_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la secuencia de bifurcaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(228251427191897359.4001)
,p_associated_item=>wwv_flow_api.id(228251823759897360.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614709799857532193.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(228251206130897357.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614710074419532194.4001)
,p_event_id=>wwv_flow_api.id(614709799857532193.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(228253204637897368.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy branch'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * from WWV_FLOW_STEP_BRANCHES where id = :p587_id) loop',
'insert into WWV_FLOW_STEP_BRANCHES (',
'    ID,',
'    FLOW_ID,',
'    FLOW_STEP_ID,',
'    BRANCH_NAME,',
'    BRANCH_ACTION,',
'    BRANCH_POINT,',
'    BRANCH_WHEN_BUTTON_ID,',
'    BRANCH_TYPE,',
'    BRANCH_SEQUENCE,',
'    CLEAR_PAGE_CACHE,',
'    BRANCH_CONDITION_TYPE,',
'    BRANCH_CONDITION,',
'    BRANCH_CONDITION_TEXT,',
'    SAVE_STATE_BEFORE_BRANCH_YN,',
'    REQUIRED_PATCH,',
'    SECURITY_SCHEME,',
'    SECURITY_GROUP_ID,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON,',
'    BRANCH_COMMENT)',
'values (',
'    wwv_flow.GET_UNIQUE_ID,',
'    :fb_flow_id,',
'    nvl(:P587_COPY_TO_PAGE,c1.FLOW_STEP_ID),',
'    c1.branch_name,',
'    c1.BRANCH_ACTION,',
'    c1.BRANCH_POINT,',
'    replace(v(''P685_WHEN_BUTTON_PRESSED''),''%null''||''%'',null),',
'    c1.BRANCH_TYPE,',
'    :P685_BRANCH_SEQUENCE,',
'    c1.CLEAR_PAGE_CACHE,',
'    c1.BRANCH_CONDITION_TYPE,',
'    c1.BRANCH_CONDITION,',
'    c1.BRANCH_CONDITION_TEXT,',
'    c1.SAVE_STATE_BEFORE_BRANCH_YN,',
'    c1.REQUIRED_PATCH,',
'    c1.SECURITY_SCHEME,',
'    c1.SECURITY_GROUP_ID,',
'    v(''USER''),',
'    sysdate,',
'    c1.BRANCH_COMMENT);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido copiar la bifurcaci\00F3n')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(228251427191897359.4001)
,p_process_success_message=>unistr('Bifurcaci\00F3n Copiada')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614710219139534151.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(228251427191897359.4001)
,p_process_success_message=>unistr('Bifurcaci\00F3n Copiada')
);
end;
/
prompt --application/pages/page_00686
begin
wwv_flow_api.create_page(
 p_id=>686.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Listas de Valores'
,p_step_title=>'Historial de Listas de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193348132357403916.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193348316791403917.4001)
,p_plug_name=>'Historial de Listas de Valores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las listas de valores de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193348908796403919.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>180
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''LIST OF VALUES'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LISTS_OF_VALUES$''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.LOV_ENTRY'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LIST_OF_VALUES_DATA'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193349113387403920.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349203981403921.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349314233403922.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349411468403923.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349516741403923.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349600400403924.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349727164403925.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349800047403926.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193349906091403927.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193348701585403918.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193348908796403919.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:686:&SESSION.::&DEBUG.:58,RIR::'
);
end;
/
prompt --application/pages/page_00688
begin
wwv_flow_api.create_page(
 p_id=>688.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Exportaci\00F3n de Componente')
,p_step_title=>unistr('Exportaci\00F3n de Componente: Identificar Componentes')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45296119907813721.4001)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45310432636836341.4001)
,p_plug_name=>'Wizard body'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>16
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique los componentes de la aplicaci\00F3n que desea exportar. Se puede utilizar para realizar copias de seguridad o para cargarlos'),
'en otra instancia.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205852032156540401.4001)
,p_plug_name=>'Navigation bar'
,p_parent_plug_id=>wwv_flow_api.id(45310432636836341.4001)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207505712737662253.4001)
,p_plug_name=>'Component Export tabs'
,p_parent_plug_id=>wwv_flow_api.id(45310432636836341.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(207503732215648915.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(205852217711540402.4001)
,p_name=>unistr('Componentes de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       case when sel.id is null then',
'           WWV_FLOW_ITEM.CHECKBOX(',
'               1,',
'               comps.id || '':'' || comps.type_name || '':'' || rawtohex(sys.utl_raw.cast_to_raw(comps.name)),',
'               '''',',
'               '''',',
'               '''',',
'               ''f01_'' || lpad(to_char(rownum), 4, ''0''),',
'               wwv_flow_lang.system_message(''COMPONENT_NAME_LABEL'', wwv_flow_escape.html(comps.name))',
'           )',
'           else '' ''',
'       end as id,',
'       comps.type_name,',
'       comps.name,',
'       comps.last_updated_on last_updated_on,',
'       comps.last_updated_by',
'  from wwv_flow_appl_export_comps comps,',
'       ( select type_name,',
'                id',
'           from wwv_multi_component_export',
'          where flow_id = :FB_FLOW_ID ) sel',
' where (nvl(:P688_COMPONENT,''0'') = ''0'' or :P688_COMPONENT = comps.type_name)',
'   and comps.application_id = :FB_FLOW_ID',
'   and comps.type_name      = sel.type_name (+)',
'   and comps.id             = sel.id        (+)',
'   and (:P688_FIND is null or instr(upper(comps.name), upper(:P688_FIND)) > 0)',
''))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_display_when_condition=>'P688_MODE'
,p_display_when_cond2=>'AC'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn componente.')
,p_query_num_rows_item=>'P688_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(205852512473540403.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<label for="check-all-rows" class="hideMeButHearMe">&P688_CHECK_ALL_TXT.</label><input type="checkbox" id="check-all-rows" onclick="$f_CheckFirstColumn(this)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(413567253271570248.4001)
,p_query_column_id=>2
,p_column_alias=>'TYPE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(377667910269420728)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(205852610480540404.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>' Nombre del Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(205852717317540404.4001)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>4
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(205852813747540404.4001)
,p_query_column_id=>5
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>5
,p_column_heading=>'Desarrollador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(207469307328320096.4001)
,p_name=>'Componentes a Exportar'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       type_name component_type,',
'       name      component_name',
'  from wwv_multi_component_export',
' where flow_id = to_number(:fb_flow_id)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha seleccionado ning\00FAn componente.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(207469528022320200.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-VisuallyHidden">Eliminar</span>'
,p_column_link=>'f?p=&APP_ID.:688:&SESSION.:DELETE:&DEBUG.::P688_DEL:#SEQ_ID#'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_column_alignment=>'CENTER'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(45394019607542208.4001)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(377667910269420728)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(45394304154547275.4001)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207509320403692876.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(207534907524859475.4001)
,p_name=>unistr('Componentes por P\00E1gina')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       case when sel.id is null then',
'           WWV_FLOW_ITEM.CHECKBOX(',
'               1,',
'               comps.id || '':'' || comps.type_name || '':'' || rawtohex(sys.utl_raw.cast_to_raw(comps.name)),',
'               '''',',
'               '''',',
'               '''',',
'               ''f01_'' || lpad(to_char(rownum), 4, ''0''),',
'               wwv_flow_lang.system_message(''COMPONENT_NAME_LABEL'', wwv_flow_escape.html(comps.name))',
'           )',
'           else '' ''',
'       end as id,',
'       comps.type_name,',
'       comps.name,',
'       comps.last_updated_on last_updated_on,',
'       comps.last_updated_by',
'  from wwv_flow_appl_export_comps comps,',
'       ( select type_name,',
'                id',
'           from wwv_multi_component_export',
'          where flow_id = :FB_FLOW_ID ) sel',
' where comps.application_id = :FB_FLOW_ID',
'   and comps.type_name = sel.type_name (+)',
'   and comps.id        = sel.id        (+)',
'   and to_number(:P688_PAGE) member of comps.used_on_pages'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_display_when_condition=>'P688_MODE'
,p_display_when_cond2=>'PD'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn componente.')
,p_query_num_rows_item=>'P688_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(207535219903859478.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(413567304027570249.4001)
,p_query_column_id=>2
,p_column_alias=>'TYPE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(377667910269420728)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(207535306772859478.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(207535432601859478.4001)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>4
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(207535521447859478.4001)
,p_query_column_id=>5
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>5
,p_column_heading=>'Desarrollador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(210789210427426499.4001)
,p_plug_name=>'Wizard progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(210787017222419064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(228937206800547250.4001)
,p_name=>unistr('Estado de Opci\00F3n de Creaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       case when exp.component_id is null then',
'           WWV_FLOW_ITEM.CHECKBOX(',
'               1,',
'               p.id || '':BUILD_OPTION_STATUS:''||rawtohex(sys.utl_raw.cast_to_raw(p.patch_name)),',
'               '''',',
'               '''',',
'               '''',',
'               ''f01_'' ||',
'                   lpad(to_char(rownum), 4, ''0''),',
'               wwv_flow_lang.system_message(''BUILD_OPTION_LABEL'',',
'                   wwv_flow_escape.html(p.patch_name))',
'           )',
'           else '' ''',
'       end as id,',
'       p.patch_name as build_option,',
'       p.patch_status as build_option_status',
'  from wwv_flow_patches p,',
'       (',
'           select id as component_id',
'             from wwv_multi_component_export',
'            where type_name = ''BUILD_OPTION_STATUS''',
'              and flow_id = :FB_FLOW_ID',
'       ) exp',
'where p.id = exp.component_id (+)',
'  and p.security_group_id = :flow_security_group_id',
'  and p.flow_id = :fb_flow_id'))
,p_display_when_condition=>'P688_MODE'
,p_display_when_cond2=>'BO'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_footer=>'<p />'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de creaci\00F3n para esta aplicaci\00F3n.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228937521524547259.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="$f_CheckFirstColumn(this)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228937603295547259.4001)
,p_query_column_id=>2
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Opci\00F3n de Creaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(228937725407547259.4001)
,p_query_column_id=>3
,p_column_alias=>'BUILD_OPTION_STATUS'
,p_column_display_sequence=>3
,p_column_heading=>'Estado a Exportar'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84357332667662999)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747144693303138168.4001)
,p_plug_name=>unistr('Exportaci\00F3n de Componente')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(205854014583540409.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(205852032156540401.4001)
,p_button_name=>'P688_GO'
,p_button_static_id=>'P688_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45326623258956624.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45296119907813721.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45351808132160494.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(228937206800547250.4001)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar a Exportaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(45358027310175453.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207534907524859475.4001)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar a Exportaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(205852907944540404.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205852217711540402.4001)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar a Exportaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(207483303013432369.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207469307328320096.4001)
,p_button_name=>'REMOVE_ALL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Eliminar Todo'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:688:&SESSION.:NEW:&DEBUG.:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_multi_component_export',
' where flow_id = to_number(:fb_flow_id)'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(207498113252624579.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45296119907813721.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(45378312400369862.4001)
,p_branch_action=>'f?p=&APP_ID.:637:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(207498113252624579.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(205854421261540411.4001)
,p_branch_action=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(129696502399576832.4001)
,p_name=>'P688_CHECK_ALL_TXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(207509320403692876.4001)
,p_source=>'wwv_flow_lang.system_message(''APEXIR_CHECK_ALL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205853310062540407.4001)
,p_name=>'P688_ROWS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(205852032156540401.4001)
,p_item_default=>'10'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de elementos que se mostrar\00E1n y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(205853820289540408.4001)
,p_name=>'P688_COMPONENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(205852032156540401.4001)
,p_item_default=>'0'
,p_prompt=>'Componente'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'COMPONENT EXPORT TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, type_name',
'  from wwv_flow_appl_component_types',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Componentes -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>'P688_MODE'
,p_display_when2=>'AC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Visualice todos los componentes o identifique el tipo de componente concreto que desea visualizar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207474713608350254.4001)
,p_name=>'P688_DEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(207509320403692876.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207510531138695929.4001)
,p_name=>'P688_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(207509320403692876.4001)
,p_item_default=>'AC'
,p_source=>'AC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207522105699802167.4001)
,p_name=>'P688_FIND'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(205852032156540401.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_display_when=>'P688_MODE'
,p_display_when2=>'AC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca criterios de consulta que no sean sensibles a may\00FAsculas/min\00FAsculas para el nombre del componente')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207538511810870152.4001)
,p_name=>'P688_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(205852032156540401.4001)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_display_when=>'P688_MODE'
,p_display_when2=>'PD'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Busque la p\00E1gina que desea exportar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(445364221733781607.4001)
,p_computation_sequence=>10
,p_computation_item=>'P688_PAGE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   r varchar2(255) := null;',
'   n number;',
'begin',
'   begin',
'      n := v(''P688_PAGE'');',
'      return :P688_PAGE;',
'   exception when others then',
'   for c1 in (select id from wwv_flow_steps where flow_id = :fb_flow_id and alias = upper(:P688_PAGE)) loop',
'       r := c1.id;',
'   end loop;',
'   return nvl(r,:FB_FLOW_PAGE_ID);',
'   end;',
'end;'))
,p_compute_when=>'Go'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45377409845359617.4001)
,p_validation_name=>'Components selected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_multi_component_export',
' where flow_id = to_number(:fb_flow_id)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Seleccione los componentes que desea exportar.'
,p_when_button_pressed=>wwv_flow_api.id(207498113252624579.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(205854212430540411.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(205854014583540409.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(206919602341115305.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add components to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.add_to_component_export (',
'    p_application_id => :FB_FLOW_ID,',
'    p_selected       => wwv_flow.g_f01 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido agregar componentes a la exportaci\00F3n')
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''ADD_TO_EXPORT''',
'and :P688_MODE in (''AC'',''PD'',''BO'')',
'and wwv_flow.g_f01.count > 0'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Componentes seleccionados agregados para exportaci\00F3n')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(207473519018342362.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete single member'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    htmldb_collection.delete_member(',
'        p_collection_name => ''MULTI_COMPONENT_EXPORT'',',
'        p_seq             => :P688_DEL );',
'    commit;',
'',
'exception',
'    when others then null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido eliminar el componente'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Componente eliminado'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(207471519926333100.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c pls_integer;',
'begin',
'    select count(*) into c',
'      from apex_collections',
'     where collection_name = ''MULTI_COMPONENT_EXPORT''',
'       and n001 = :fb_flow_id',
'       and rownum = 1;',
'',
'    if :REQUEST = ''NEW'' or c = 0 then',
'        if :REQUEST = ''NEW'' then',
'            wwv_flow.g_print_success_message :=',
'                wwv_flow_lang.system_message(''WWV_FLOW_WIZARD_API.ACTION_PROCESSED'');',
'        end if;',
'',
'        htmldb_collection.create_or_truncate_collection(',
'            p_collection_name => ''MULTI_COMPONENT_EXPORT''',
'        );',
'        commit;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00689
begin
wwv_flow_api.create_page(
 p_id=>689.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar Comentarios'
,p_step_title=>'Exportar Comentarios'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_feed.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472184315384691387.4001)
,p_plug_name=>'Export Feedback'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472186518392691417.4001)
,p_plug_name=>'Exportar Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Exporte los comentarios proporcionados por el usuario desde esta instancia de &PRODUCT_NAME. A continuaci\00F3n, puede importarlos a otra instancia y convertir las entradas de comentarios en bugs, funciones o entradas pendientes.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472186928058691420.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472187126773691421.4001)
,p_plug_name=>'Exportar Comentarios'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472187330406691438.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472187126773691421.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486275824769546468.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(472187126773691421.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.:689::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472188419784691549.4001)
,p_branch_action=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472184500698691395.4001)
,p_name=>'P689_TO_DEPLOYMENT_SYSTEM'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472184315384691387.4001)
,p_prompt=>'Sistema de Despliegue'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       deployment_system as d,',
'       deployment_system as r',
'  from wwv_flow_feedback',
' where security_group_id = :WORKSPACE_ID',
'   and deployment_system is not null',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P689_EXPORT_TYPE'
,p_display_when2=>'TO_DEPLOYMENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de los sistemas de despliegue a los que desea exportar las entradas de comentarios.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472185108842691412.4001)
,p_name=>'P689_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472184315384691387.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472185930910691415.4001)
,p_name=>'P689_FILE_CHARSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(472184315384691387.4001)
,p_item_default=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Caracteres de Archivo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472292730911200591.4001)
,p_name=>'P689_EXPORT_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472184315384691387.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Direcci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_feedback_from_others number;',
'begin',
'    -- check if we have already imported feedback from other systems, in that case it''s the development system',
'    select count(*)',
'      into l_feedback_from_others',
'      from dual',
'     where exists ( select 1',
'                      from wwv_flow_feedback',
'                     where security_group_id = :WORKSPACE_ID',
'                       and deployment_system is not null',
'                  );',
'    if l_feedback_from_others > 0 then',
'        return ''TO_DEPLOYMENT'';',
'    else',
'        return ''TO_DEVELOPMENT'';',
'    end if;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'EXPORT_FEEDBACK_TYPE'
,p_lov=>'.'||wwv_flow_api.id(472293315458205653.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indica el prop\00F3sito de la exportaci\00F3n de comentarios. \00C9stos se pueden sincronizar entre las instancias de &PRODUCT_NAME.; y este atributo controla el modo de exportaci\00F3n de los comentarios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472297625941265405.4001)
,p_name=>'P689_FROM_DEPLOYMENT_SYSTEM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472184315384691387.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sistema de Despliegue de Origen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select source_identifier',
'  from wwv_flow_companies',
' where provisioning_company_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P689_EXPORT_TYPE'
,p_display_when2=>'TO_DEVELOPMENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el sistema actual. Este identificador lo puede cambiar el administrador de instancia.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472727114000966503.4001)
,p_name=>'P689_SINCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472184315384691387.4001)
,p_prompt=>'Cambios desde'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_JET'
,p_cSize=>20
,p_cMaxlength=>20
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Exporta todos los comentarios creados o cambiados desde la fecha especificada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
,p_attribute_12=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_13=>'VISIBLE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651512616928755619.4001)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(472187330406691438.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651512780688755620.4001)
,p_event_id=>wwv_flow_api.id(651512616928755619.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472188228701691540.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'do export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_feedback (',
'    p_export_type       => :P689_EXPORT_TYPE,',
'    p_deployment_system => case :P689_EXPORT_TYPE',
'                           when ''TO_DEVELOPMENT'' then :P689_FROM_DEPLOYMENT_SYSTEM',
'                           else :P689_TO_DEPLOYMENT_SYSTEM',
'                           end,',
'    p_since             => to_date(:P689_SINCE, :DATE_TIME_FORMAT),',
'    p_format            => :P689_FORMAT );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al exportar los comentarios. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(472187330406691438.4001)
,p_process_success_message=>'Comentarios exportados.'
);
end;
/
prompt --application/pages/page_00690
begin
wwv_flow_api.create_page(
 p_id=>690.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Cabeceras de Columna de Informe Interactivo'
,p_step_title=>'Editar Cabeceras de Columna de Informe Interactivo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445527532263394024.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445530922576394053.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(445552022491678509.4001)
,p_name=>'Pantalla Tabular'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, region, page, db_column_name, ',
'       display_order, column_label, report_label',
'from',
'(',
'select rc.id,',
'       (select wwv_flow_escape.html(r.plug_name) ',
'          from wwv_flow_worksheets w,',
'               wwv_flow_page_plugs r',
'         where w.security_group_id = :flow_security_group_id',
'           and w.flow_id           = :FB_FLOW_ID',
'           and w.page_id           = r.page_id',
'           and w.region_id         = r.id',
'           and r.security_group_id = :flow_security_group_id',
'           and r.flow_id           = :FB_FLOW_ID',
'           and w.id                = rc.worksheet_id ) REGION,',
'       (select w.page_id ',
'          from wwv_flow_worksheets w',
'         where w.security_group_id = :flow_security_group_id',
'           and w.flow_id           = :FB_FLOW_ID',
'           and w.id                = rc.worksheet_id ) page,',
'       rc.db_column_name,',
'       rc.display_order,',
'       rc.column_label,',
'       rc.report_label',
'  from wwv_flow_worksheet_columns rc',
' where rc.security_group_id = :flow_security_group_id',
'   and rc.flow_id           = :FB_FLOW_ID',
'   and rc.display_text_as  != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and (:P690_COLUMN_CONTAINS is null or',
'        instr(upper(rc.report_label),upper(:P690_COLUMN_CONTAINS)) > 0)',
')',
'where (:P690_PAGE is null or page = :P690_PAGE)',
'order by 3,2,5',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P690_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445552330058678601.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445555703943739822.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445555808826739822.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445552707006678605.4001)
,p_query_column_id=>4
,p_column_alias=>'DB_COLUMN_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Columna'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##7040:#ID#'
,p_column_linktext=>'#DB_COLUMN_NAME#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_ref_column_name=>'DB_COLUMN_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445552830858678605.4001)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_ORDER'
,p_column_display_sequence=>5
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_ref_column_name=>'DISPLAY_ORDER'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445552908911678605.4001)
,p_query_column_id=>6
,p_column_alias=>'COLUMN_LABEL'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Etiqueta de Fila \00DAnica')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_ref_column_name=>'COLUMN_LABEL'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(445553031920678605.4001)
,p_query_column_id=>7
,p_column_alias=>'REPORT_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>'Cabecera de Columna'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_ref_column_name=>'REPORT_LABEL'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555005400739818.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555128930739819.4001)
,p_column_sequence=>2
,p_query_column_name=>'REGION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555205913739819.4001)
,p_column_sequence=>3
,p_query_column_name=>'PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555312181739819.4001)
,p_column_sequence=>4
,p_query_column_name=>'DB_COLUMN_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555417078739820.4001)
,p_column_sequence=>5
,p_query_column_name=>'DISPLAY_ORDER'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555509849739820.4001)
,p_column_sequence=>6
,p_query_column_name=>'COLUMN_LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(445555631306739820.4001)
,p_column_sequence=>7
,p_query_column_name=>'REPORT_LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(445528507238394040.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(445527532263394024.4001)
,p_button_name=>'P690_GO'
,p_button_static_id=>'P690_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(445553218935678616.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(445527532263394024.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(445553923347678633.4001)
,p_branch_action=>'f?p=&APP_ID.:690:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445527916844394034.4001)
,p_name=>'P690_COLUMN_CONTAINS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(445527532263394024.4001)
,p_prompt=>'La Columna Contiene:'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445528731703394040.4001)
,p_name=>'P690_PAGE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(445527532263394024.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtre por n\00FAmero de p\00E1gina. Introduzca el n\00FAmero de p\00E1gina y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445529330083394042.4001)
,p_name=>'P690_ROWS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(445527532263394024.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,25,50,100'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que desea que aparezcan y haga clic en <span class="fielddatabold">Ir</span>.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(445553707768678631.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(445552022491678509.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('No se ha podido procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(445553218935678616.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(445531831385394157.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00697
begin
wwv_flow_api.create_page(
 p_id=>697.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Calendario'
,p_step_title=>'Editar Plantilla de Calendario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_cal.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22161207490144133.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22161419106144134.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22162817201144136.4001)
,p_plug_name=>'Plantillas de Calendario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de calendario controlan el aspecto y colocaci\00F3n de un calendario. Estas plantillas utilizan las tablas HTML frecuentemente para organizar las fechas.</p>'),
unistr('<p>Puede colocar los atributos de calendario utilizando cadenas de sustituci\00F3n como #DD# y #MONTH#. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).</p>')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22163405282144137.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n de formato de fecha:</p>'),
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'</ul>',
unistr('<p>Si coloca "I" delante de cualquier cadena, el texto tendr\00E1 may\00FAscula inicial.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22163600083144137.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22163809613144137.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12991522578387911.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33418028849020737.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P697_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_02=>'NAME'
,p_attribute_03=>'P697_ID'
,p_attribute_04=>'P697_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46233105873678957.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620052512654414383.4001)
,p_plug_name=>'Historial'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_CAL_TEMPLATES',
'where id = :F4000_P697_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P697_ID,',
'      p_component_type => ''Button Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P697_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932807158581193715.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P697_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P697_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22165925902144142.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22165713747144142.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22164704556144141.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33418028849020737.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P697_ID.,&FLOW_PAGE_ID.,CALENDAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates',
'where reference_id = :F4000_P697_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22164521632144140.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33418028849020737.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates',
'where id = :F4000_P697_ID',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22165104505144141.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22165524161144142.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&F4000_P697_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22164914232144141.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22183328150144159.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P697_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22165713747144142.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22183516143144159.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P697_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22165925902144142.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22183714058144159.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22164521632144140.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22182916096144158.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P697_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22182329029144158.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22182525048144158.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30775807899904776.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3709221250249513.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22202122389246662.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22183107094144158.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>130
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22166114485144143.4001)
,p_name=>'F4000_P697_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22166303452144144.4001)
,p_name=>'P697_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Define un nombre que identifica la plantilla <p />',
'',
'Utilice la casilla de control <strong>Se Puede Convertir</strong> para indicar si la plantilla contiene cadenas de texto que hay que convertir.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22166812605144144.4001)
,p_name=>'P697_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22177028263144151.4001)
,p_name=>'P697_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33418028849020737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_CAL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, 0 r from dual',
'union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_cal_templates',
'where flow_id != nvl(:fb_flow_id,0) and flow_id in (',
' select f.id',
' from   wwv_flows f',
' where  security_group_id = :flow_security_group_id',
'  and  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'  and  exists (',
'   select 1 ',
'   from wwv_flow_developers',
'   where userid = :flow_user ',
'     and (flow_id is null or flow_id = f.id)',
'     and security_group_id = :flow_security_group_id)',
')',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22177517891144152.4001)
,p_name=>'P697_STAY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(22162817201144136.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22178016817144152.4001)
,p_name=>'P697_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33418028849020737.4001)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates',
'where reference_id is null',
'and id = :F4000_P697_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22178228747144153.4001)
,p_name=>'P697_THEME_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22178712052144153.4001)
,p_name=>'P697_THEME_CLASS_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22179222292144153.4001)
,p_name=>'P697_TEMPLATE_COMMENTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(22163600083144137.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TEMPLATE_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22179727735144153.4001)
,p_name=>'P697_ID_NEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_prompt=>'P697_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22179910067144154.4001)
,p_name=>'P697_ID_PREV'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_prompt=>'P697_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22180124658144154.4001)
,p_name=>'P697_ID_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(22161207490144133.4001)
,p_prompt=>'Plantilla de Calendario: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(757097111519899233.4001)
,p_name=>'P697_INTERNAL_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104660226859556476.4001)
,p_name=>'P697_THEME_IS_SUBSCRIBED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(22161419106144134.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(189760927926997794.4001)
,p_computation_sequence=>10
,p_computation_item=>'P697_TRANSLATE_THIS_TEMPLATE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P697_TRANSLATE_THIS_TEMPLATE is null or :P697_TRANSLATE_THIS_TEMPLATE = '''' then ',
'    return ''N'';',
'else',
'    return :P697_TRANSLATE_THIS_TEMPLATE;',
'end if;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104660757231561659.4001)
,p_computation_sequence=>20
,p_computation_item=>'P697_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_cal_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P697_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397295711399444974.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P697_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397296002313444975.4001)
,p_event_id=>wwv_flow_api.id(397295711399444974.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(22165925902144142.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397296116247446382.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P697_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397296427668446382.4001)
,p_event_id=>wwv_flow_api.id(397296116247446382.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(22165713747144142.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22180827718144156.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'F4000_P697_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181014425144156.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'F4000_P697_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P697_ID_NEXT'
,p_attribute_10=>'P697_ID_PREV'
,p_attribute_13=>'P697_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181204218144156.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'F4000_P697_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'No se ha podido procesar la plantilla de calendario.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181404137144157.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_api.id(22165524161144142.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181631750144157.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P697_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P697_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(22164521632144140.4001)
,p_process_when=>'P697_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22181809002144157.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:F4000_P697_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'P697_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Identificador de referencia eliminado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22182005033144157.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P697_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P697_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(22164914232144141.4001)
,p_process_when=>':P697_REFERENCE_ID is not null and :P697_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
end;
/
prompt --application/pages/page_00698
begin
wwv_flow_api.create_page(
 p_id=>698.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina Global: Confirmaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina Global')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3236931578294657.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Creaci\00F3n de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_global_page (',
'    p_flow_id => :FB_FLOW_ID);',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(263553511321454694.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3237623143294662.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(263553511321454694.4001)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3237807019294663.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(263553511321454694.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_cattributes=>'tabindex="1"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3238002251294663.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(263553511321454694.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3238731983294665.4001)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548796949221820001.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3238002251294663.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(254160814028480600.4001)
,p_name=>'P698_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3236931578294657.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_zero_exists number;',
'begin',
'    -- optimization to default with page 0 if it''s not used yet',
'    select count(*)',
'      into l_page_zero_exists',
'      from wwv_flow_steps',
'     where flow_id = :FB_FLOW_ID',
'       and id      = 0',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    if l_page_zero_exists = 1 then',
'        return wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1);',
'    else',
'        return 0;',
'    end if;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_tag_attributes=>'tabindex="1"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El n\00FAmero de p\00E1gina es un valor entero que identifica una p\00E1gina en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(254174712925511540.4001)
,p_validation_name=>'P698_PAGE_ID not decimal or negative'
,p_validation_sequence=>10
,p_validation=>'trunc(abs(:P698_PAGE_ID)) = :P698_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P698_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(3237807019294663.4001)
,p_associated_item=>wwv_flow_api.id(254160814028480600.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(255466717346296456.4001)
,p_validation_name=>'page id is still available'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id = :FB_FLOW_ID',
'   and id      = :P698_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina ya est\00E1 en uso.')
,p_validation_condition=>'P698_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_api.id(3237807019294663.4001)
,p_associated_item=>wwv_flow_api.id(254160814028480600.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1059806885051457605.4001)
,p_validation_name=>'Page ID is not null'
,p_validation_sequence=>30
,p_validation=>'P698_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_associated_item=>wwv_flow_api.id(254160814028480600.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548796335338818394.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3237623143294662.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548796600805818396.4001)
,p_event_id=>wwv_flow_api.id(548796335338818394.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3238231008294663.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_global_page (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_page_id           => :P698_PAGE_ID,',
'        p_user_interface_id => :P259_USER_INTERFACE_ID );',
'',
'    wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'', :P698_PAGE_ID);',
'    :F4000_RUN_EDIT_PAGE := :P698_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la p\00E1gina global.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3237807019294663.4001)
,p_process_success_message=>unistr('Se ha creado la p\00E1gina global')
,p_process_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'F4000_P78_NEW_TAB_SET_NAME',
'',
'',
'',
'sleuniss 08.16.2002  changed p_first_item to default of NO_FIRST_ITEM'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(548797682566859586.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La p\00E1gina global se ha creado correctamente.')
);
end;
/
prompt --application/pages/page_00699
begin
wwv_flow_api.create_page(
 p_id=>699.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilidades de Acciones Din\00E1micas')
,p_step_title=>unistr('Todas las Acciones Din\00E1micas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4518805581694342)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47046221608720151.4001)
,p_plug_name=>unistr('Acciones Din\00E1micas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>150
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  dynamic_action_id               dynamic_action_id,',
'        application_id                  application_id,',
'        page_id                         page,',
'        page_name                       page_name,',
'        dynamic_action_name             name,',
'        --',
'        when_event_name                 event,',
'        when_selection_type             element_type,',
'        case ',
'            when when_selection_type = ''Region'' then ',
'                wwv_flow_escape.html(when_region)',
'            when when_selection_type = ''Button'' then ',
'                wwv_flow_escape.html(when_button)',
'            else ',
'                replace(wwv_flow_escape.html(when_element), '','', ''<br />'')',
'        end element,',
'        when_condition || '' '' ||',
'            case when nvl(length(when_expression),0) < 50 then',
'                when_expression',
'            else ',
'                substr(when_expression,0,50) || ''...''',
'            end       triggering_condition,',
'        --',
'        decode(CONDITION_TYPE, null, '''',',
'                                     ''<span class="a-Icon icon-check">'' || wwv_flow_lang.system_message(''CONDITIONAL'') || ''</span>'')    conditional,',
'        build_option                    build_option,',
'        number_of_actions               actions,',
'        LAST_UPDATED_ON       updated,',
'        LAST_UPDATED_BY       updated_by',
' from   apex_application_page_da',
'where   application_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47046318950720151.4001)
,p_name=>'Dynamic Actions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'ANTHONY'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47046524054720174.4001)
,p_db_column_name=>'DYNAMIC_ACTION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47046632692720177.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47046732176720178.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47046832629720178.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5140:#DYNAMIC_ACTION_ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(499198316165945806.4001)
,p_db_column_name=>'EVENT'
,p_display_order=>5
,p_column_identifier=>'Q'
,p_column_label=>'Evento When'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47046908037720178.4001)
,p_db_column_name=>'ELEMENT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Elemento When'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47047012897720179.4001)
,p_db_column_name=>'ELEMENT_TYPE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>unistr('Tipo de Selecci\00F3n When')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47047321224720180.4001)
,p_db_column_name=>'TRIGGERING_CONDITION'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>unistr('Condici\00F3n When')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47047515865720182.4001)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47047611027720182.4001)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47047731951720182.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47047808778720183.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47048829360776083.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>unistr('Identificador de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47050418288848647.4001)
,p_db_column_name=>'ACTIONS'
,p_display_order=>17
,p_column_identifier=>'P'
,p_column_label=>'Acciones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194145001657122752.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(28119925264668131.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194145420808124166.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47046221608720151.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.:699,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4638212560334514.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'699'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00700
begin
wwv_flow_api.create_page(
 p_id=>700.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla e Informe Basados en Servicio Web: Seleccionar Servicio Web y Operaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30025016313145138.4001)
,p_plug_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Seleccione una operaci\00F3n y la definici\00F3n de servicio web sobre las que desea crear la pantalla. Si no tiene ninguna referencia de servicio web definida, ampl\00EDe la regi\00F3n Tareas y cree una.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30025418800145140.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57092125253371601.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(57083604297327751.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204742702765090184.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30025809110145143.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204742702765090184.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30026205258145151.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204742702765090184.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699462838702674742.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204742702765090184.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30030108458145205.4001)
,p_branch_action=>'f?p=&FLOW_ID.:705:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30026205258145151.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30030524987145209.4001)
,p_branch_action=>'f?p=&FLOW_ID.:700:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699462952591676119.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'4700'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699462838702674742.4001)
,p_branch_sequence=>180
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P362_OPT'
,p_branch_condition_text=>'R'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14512124747453805.4001)
,p_name=>'P700_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(30025016313145138.4001)
,p_prompt=>'Interfaz de Usuario'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by display_seq'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'USER INTERFACES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.display_name,',
'       i.id',
'  from wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
' order by 1'))
,p_display_when=>'P259_USER_INTERFACE_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select count(*)',
'    from wwv_flow_user_interfaces',
'   where flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID ) = 1'))
,p_read_only_when2=>'SQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30026626676145154.4001)
,p_name=>'P700_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30025016313145138.4001)
,p_prompt=>unistr('Operaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P700_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P700_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Operaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>'nvl(:P700_WS_ID,''0'') != ''0'' and nvl(:P700_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la operaci\00F3n. La operaci\00F3n es el m\00E9todo que se va a ejecutar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30027313242145172.4001)
,p_name=>'P700_OPERATION_ID_ORIG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(30025016313145138.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30027719013145173.4001)
,p_name=>'P700_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30025016313145138.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Servicio -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193667204652329394.4001)
,p_name=>'P700_WEB_REF_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(30025016313145138.4001)
,p_prompt=>'Tipo de Referencia de Servicio Web'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_REF_TYPE'
,p_lov=>'.'||wwv_flow_api.id(191288700473281420.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'nvl(:P700_WS_ID,''0'') != ''0'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(309346715552014028.4001)
,p_name=>'P700_OUTPUT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(30025016313145138.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193667421274334185.4001)
,p_computation_sequence=>10
,p_computation_item=>'P700_WEB_REF_TYPE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(action,''NONE'') act ',
'             from wwv_flow_shared_web_services',
'            where id = :P700_WS_ID ) loop',
'  if c1.act in (''REST'',''NEW_SCHOOL'') then',
'    return c1.act;',
'  else',
'    return ''MANUAL'';',
'  end if;',
'end loop;'))
,p_compute_when=>'P700_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193922220810743532.4001)
,p_computation_sequence=>30
,p_computation_item=>'P700_OPERATION_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P700_WEB_REF_TYPE = ''REST'' then',
'  for c1 in (select id',
'             from wwv_flow_ws_operations',
'            where ws_id = :P700_WS_ID',
'              and name = ''doREST'' ) loop',
'    return c1.id;',
'  end loop;',
'else',
'  return null;',
'end if;'))
,p_compute_when=>'P700_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(309347002664016405.4001)
,p_computation_sequence=>60
,p_computation_item=>'P700_OUTPUT_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(static_parm_05 ,''x'')',
'  from wwv_flow_shared_web_services',
' where id = :P700_WS_ID'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30028529013145178.4001)
,p_computation_sequence=>10
,p_computation_item=>'P700_OPERATION_ID_ORIG'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P700_OPERATION_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30028911317145187.4001)
,p_validation_name=>'P700_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P700_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(30026205258145151.4001)
,p_associated_item=>wwv_flow_api.id(30027719013145173.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30029321337145192.4001)
,p_validation_name=>'P700_OPERATION_ID'
,p_validation_sequence=>20
,p_validation=>'nvl(:P700_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe seleccionar una operaci\00F3n.')
,p_validation_condition=>'nvl(:P700_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(30026205258145151.4001)
,p_associated_item=>wwv_flow_api.id(30026626676145154.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549718349012753344.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30025809110145143.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549718455269753345.4001)
,p_event_id=>wwv_flow_api.id(549718349012753344.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30029725598145198.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clean up collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_INPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_OUTPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_OUTPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_AUTH_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_ARRAY_PARMS'') then',
'  wwv_flow_collection.delete_collection(''WS_ARRAY_PARMS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'nvl(:P700_OPERATION_ID_ORIG,''x'') != nvl(:P700_OPERATION_ID,''y'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(14512330288455424.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set User Interface'
,p_process_sql_clob=>':P259_USER_INTERFACE_ID := :P700_USER_INTERFACE_ID;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30026205258145151.4001)
,p_process_when=>'P700_USER_INTERFACE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(504399719148542232.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear cache on 705'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'705'
,p_process_when=>'P700_WS_ID'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00701
begin
wwv_flow_api.create_page(
 p_id=>701.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Lista Din\00E1mica')
,p_page_mode=>'NON_MODAL'
,p_step_title=>unistr('Crear Lista Din\00E1mica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213415628923422845)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'570'
,p_dialog_width=>'820'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1445515741805192.4001)
,p_plug_name=>unistr('Crear Lista Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754560332977487448.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754560470865487449.4001)
,p_plug_name=>unistr('Crear Lista Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1445904971805193.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(754560332977487448.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1446102220805193.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(754560332977487448.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1445706955805192.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(754560332977487448.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1448811862805196.4001)
,p_branch_action=>'f?p=&APP_ID.:719:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1445904971805193.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1448615775805196.4001)
,p_branch_action=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1446102220805193.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1446316855805193.4001)
,p_name=>'P701_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario:'
,p_source=>'P542_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica el propietario del esquema de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1446827688805195.4001)
,p_name=>'P701_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabla:'
,p_source=>'P542_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la tabla seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1447824232805196.4001)
,p_name=>'P701_LABEL_COLUMN'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'Columna de etiquetas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P542_OWNER',
'   and table_name = :P542_TABLE'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor de etiqueta.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10730513062133082.4001)
,p_name=>'P701_TARGET_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'Columna de Destino'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor de destino.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10731020681135274.4001)
,p_name=>'P701_TARGET_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10731527261137176.4001)
,p_name=>'P701_IMAGE_ATTR_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'Atributos de Imagen'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor de atributo de imagen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10733111462142119.4001)
,p_name=>'P701_IMAGE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'Columna de Imagen'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor de imagen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14424006325318187.4001)
,p_name=>'P701_IMAGE_ALT_COLUMN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'Atributo Alternativo de Imagen'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor del atributo alternativo de la imagen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14426220439341167.4001)
,p_name=>'P701_IS_CURRENT'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_prompt=>'Es Columna Actual'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov=>'.'||wwv_flow_api.id(84270019143507704.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique si la entrada de enlace es la actual de la p\00E1gina actual. Si no se define este elemento, se evaluar\00E1 la URL de destino para establecer si la entrada de lista es actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14429817500378158.4001)
,p_name=>'P701_ATTRIBUTE_1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14430323388379818.4001)
,p_name=>'P701_ATTRIBUTE_2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14430928929381511.4001)
,p_name=>'P701_ATTRIBUTE_3'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14431502740383406.4001)
,p_name=>'P701_ATTRIBUTE_4'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14432512091386086.4001)
,p_name=>'P701_ATTRIBUTE_5'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14433018324387851.4001)
,p_name=>'P701_ATTRIBUTE_6'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14433523519389369.4001)
,p_name=>'P701_ATTRIBUTE_7'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14434029752391188.4001)
,p_name=>'P701_ATTRIBUTE_8'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14434703910393159.4001)
,p_name=>'P701_ATTRIBUTE_9'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14435210144394936.4001)
,p_name=>'P701_ATTRIBUTE_10'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(1445515741805192.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique la columna que ser\00E1 el valor devuelto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(10772627859497594.4001)
,p_name=>'Target Setting'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P701_TARGET_COLUMN'
,p_condition_element=>'P701_TARGET_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10772928254497600.4001)
,p_event_id=>wwv_flow_api.id(10772627859497594.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_URL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10773525220506235.4001)
,p_event_id=>wwv_flow_api.id(10772627859497594.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_URL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(10773011714502314.4001)
,p_name=>'Target URL Setting'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P701_TARGET_URL'
,p_condition_element=>'P701_TARGET_URL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10773317902502314.4001)
,p_event_id=>wwv_flow_api.id(10773011714502314.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10773703880509585.4001)
,p_event_id=>wwv_flow_api.id(10773011714502314.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_COLUMN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(758615284358655702.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1445706955805192.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(758615371776655703.4001)
,p_event_id=>wwv_flow_api.id(758615284358655702.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1448304048805196.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv_object(',
'    p_application_id => :fb_flow_id,',
'    p_schema => :P542_OWNER,',
'    p_object => :P542_TABLE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Propietario de Esquema no V\00E1lido')
);
end;
/
prompt --application/pages/page_00702
begin
wwv_flow_api.create_page(
 p_id=>702.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Repositorio de Traducci\00F3n')
,p_step_title=>unistr('Repositorio de Traducci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162445917180498617.4001)
,p_plug_name=>unistr('Repositorio de Traducci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.id "ID", ',
'       t."TRANSLATED_FLOW_ID",',
'       t."PAGE_ID",',
'       t."TRANSLATE_TO_LANG_CODE",',
'       t."TRANSLATION_SPECIFIC_TO_ITEM",',
'       sys.dbms_lob.substr(t."TRANSLATE_TO_TEXT",255,1) "TRANSLATE_TO_TEXT",',
'       sys.dbms_lob.substr(t."TRANSLATE_FROM_TEXT",255,1) "TRANSLATE_FROM_TEXT",',
'       t.template_translatable,',
'       c.column_description,',
'       t.created_on created,',
'       t.created_by,',
'       nvl(t.last_updated_on,t.created_on) updated,',
'       nvl(t.last_updated_by,t.created_by) updated_by,',
'       case when ',
'           sys.dbms_lob.compare(translate_to_text,translate_from_text) != 0',
'           or nvl(length(translate_from_text),0) != nvl(length(translate_to_text),0) then ''Y''',
'           else ''N''',
'       end translated       ',
' from WWV_FLOW_TRANSLATABLE_TEXT$ t, ',
'      wwv_flow_translatable_cols$ c',
'where t.translate_from_flow_table = c.table_name',
'  and t.translate_from_flow_column = c.column_name',
'  and (c.template_translatable = ''N'' or (c.template_translatable = ''Y'' and t.template_translatable = ''Y''))',
'  and t.flow_id = :fb_flow_id ',
'  and t.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(162446021231498617.4001)
,p_name=>'Translatable Text'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se ha encontrado texto traducible.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446204401498620.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Editar'
,p_column_link=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.:704:P704_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span>'
,p_column_link_attr=>'class="a-Button a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446322302498621.4001)
,p_db_column_name=>'TRANSLATED_FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n Traducida')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446413263498621.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446503827498622.4001)
,p_db_column_name=>'TRANSLATE_TO_LANG_CODE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446615134498622.4001)
,p_db_column_name=>'TRANSLATION_SPECIFIC_TO_ITEM'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Espec\00EDfico de Elemento')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446707251498623.4001)
,p_db_column_name=>'TRANSLATE_TO_TEXT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Traducir a'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446815541498623.4001)
,p_db_column_name=>'TRANSLATE_FROM_TEXT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Traducir de'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162447020620498626.4001)
,p_db_column_name=>'COLUMN_DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>unistr('Descripci\00F3n de Columna')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162446915311498624.4001)
,p_db_column_name=>'TEMPLATE_TRANSLATABLE'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Plantilla Traducible'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162448803107561521.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162448912602561523.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162449031316561524.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162449108405561525.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(953242475566873701.4001)
,p_db_column_name=>'TRANSLATED'
,p_display_order=>23
,p_column_identifier=>'N'
,p_column_label=>'Traducido'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188999808951178335.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(162445917180498617.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:RP,702,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(327872113487555258.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(162445917180498617.4001)
,p_button_name=>'GRID_EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:891:&SESSION.::&DEBUG.:RP,891::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28700219818217334.4001)
,p_branch_action=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00704
begin
wwv_flow_api.create_page(
 p_id=>704.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Texto Traducible'
,p_page_mode=>'MODAL'
,p_step_title=>'Editar Texto Traducible'
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.apex-item-display-only.faux-textarea {',
'    display: block;',
'    font-weight: normal;',
'    font-size: 12px;',
'    line-height: 16px;',
'    padding: 3px;',
'    border: 1px solid #E0E0E0;',
'    border-radius: 2px;',
'    color: #202020;',
'    background-color: #FFF;',
'    max-width: 100%;',
'    font-family: ''Consolas'', ''Menlo'', monospace;',
'}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28652828679978612.4001)
,p_plug_name=>'Translatable Text'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60924220131746701.4001)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747144731158138169.4001)
,p_plug_name=>'Editar Texto Traducible'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28653412999978613.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(60924220131746701.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28653112910978612.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(60924220131746701.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P704_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28653903725978614.4001)
,p_branch_action=>'f?p=&APP_ID.:702:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28654116085978614.4001)
,p_name=>'P704_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28654301197978616.4001)
,p_name=>'P704_TRANSLATED_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n Traducida:')
,p_source=>'TRANSLATED_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la nueva aplicaci\00F3n traducida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28654504346978617.4001)
,p_name=>'P704_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n de idioma primario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28654906922978618.4001)
,p_name=>'P704_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la p\00E1gina correspondiente al componente que se est\00E1 traduciendo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28655122891978618.4001)
,p_name=>'P704_TRANSLATE_FROM_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_FROM_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28655320517978618.4001)
,p_name=>'P704_TRANSLATE_TO_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_TO_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when_type=>'NEVER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28656301880978619.4001)
,p_name=>'P704_TRANSLATE_TO_TEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Traducir a Texto:'
,p_source=>'TRANSLATE_TO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cMaxlength=>32767
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Identifica el texto traducido.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28656503901978619.4001)
,p_name=>'P704_TRANSLATE_FROM_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Traducir de Texto:'
,p_source=>'TRANSLATE_FROM_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'faux-textarea'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el texto de idioma primario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28656732239978619.4001)
,p_name=>'P704_TEMPLATE_TRANSLATABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Traducible:'
,p_source=>'TEMPLATE_TRANSLATABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la posibilidad de traducir los componentes de la plantilla'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94701704408519820.4001)
,p_name=>'P704_TRANSLATE_TO_LANGUAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Traducir a:'
,p_source=>'TRANSLATE_TO_LANG_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica el idioma al que se convertir\00E1 la cadena.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416034016397152705.4001)
,p_name=>'P704_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(416034313070152708.4001)
,p_name=>'P704_UPDATE_ALL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(28652828679978612.4001)
,p_prompt=>'Actualizar Todo'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX_UPDATE_ALL_STRINGS'
,p_lov=>'.'||wwv_flow_api.id(149088633646846887.4001)||'.'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'to_number(nvl(:P704_COUNT,0)) > 1'
,p_display_when2=>'SQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(416034283913152707.4001)
,p_computation_sequence=>10
,p_computation_item=>'P704_COUNT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_translatable_text$',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id = :FB_FLOW_ID',
'   and sys.dbms_lob.compare(translate_from_text,to_nclob(:P704_TRANSLATE_FROM_TEXT)) = 0',
'   and translate_to_lang_code = :P704_TRANSLATE_TO_LANGUAGE',
'   and translate_from_text is not null'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28657023841978620.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_TRANSLATABLE_TEXT$'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TRANSLATABLE_TEXT$'
,p_attribute_03=>'P704_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(60914420599680543.4001)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P704_UPDATE_ALL,''N'') = ''Y'' then',
'    --',
'    -- All rows where the string matches',
'    --',
'    update wwv_flow_translatable_text$',
'      set translate_to_text = :P704_TRANSLATE_TO_TEXT',
'    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'      and flow_id = :FB_FLOW_ID',
'      and translate_to_lang_code = :P704_TRANSLATE_TO_LANGUAGE',
'      and sys.dbms_lob.compare(translate_from_text,to_nclob(:P704_TRANSLATE_FROM_TEXT)) = 0',
'      and translate_from_text is not null;',
'else',
'    --',
'    -- Only update this specific string',
'    --',
'    update wwv_flow_translatable_text$',
'      set translate_to_text = :P704_TRANSLATE_TO_TEXT',
'    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'      and flow_id = :FB_FLOW_ID',
'      and id = :P704_ID;',
'end if;',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(28653112910978612.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00705
begin
wwv_flow_api.create_page(
 p_id=>705.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla e Informes Basados en Servicio Web: Atributos de P\00E1gina y de Regi\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30032223951154262.4001)
,p_plug_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para especificar informaci\00F3n de la regi\00F3n y de la p\00E1gina.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30033427191154267.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204744409476101591.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30033822808154267.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(204744409476101591.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30034225253154268.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204744409476101591.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30034607655154269.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204744409476101591.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34482328673179131.4001)
,p_branch_action=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30034225253154268.4001)
,p_branch_sequence=>25
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P705_IS_REST'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30041325602154288.4001)
,p_branch_action=>'f?p=&FLOW_ID.:720:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30034225253154268.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(122074902387965153.4001)
,p_branch_action=>'f?p=&APP_ID.:705:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P705_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30041712258154291.4001)
,p_branch_action=>'f?p=&FLOW_ID.:700:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30034607655154269.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30035027504154269.4001)
,p_name=>'P705_REGION_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('T\00EDtulo de Regi\00F3n de Pantalla')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la regi\00F3n en la que aparecer\00E1 la pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30035705718154271.4001)
,p_name=>'P705_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n de Pantalla')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(default_form_template,default_region_template) from wwv_flow_themes where flow_id = :fb_flow_id',
'and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una plantilla de regi\00F3n para la nueva regi\00F3n de pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30036403144154274.4001)
,p_name=>'P705_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina que contenga la nueva pantalla o introduzca un nuevo n\00FAmero de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30037118096154276.4001)
,p_name=>'P705_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la p\00E1gina si se est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30037802765154278.4001)
,p_name=>'P705_WS_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Referencia de Servicio Web:'
,p_source=>'P700_WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nombre de la referencia del servicio Web seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30038505464154279.4001)
,p_name=>'P705_OPERATION_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Operaci\00F3n:')
,p_source=>'P700_OPERATION_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P700_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P700_WS_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>':P700_WEB_REF_TYPE != ''MANUAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Operaci\00F3n (o m\00E9todo) que se va a ejecutar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30334907888513462.4001)
,p_name=>'P705_REGION_NAME2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('T\00EDtulo de Regi\00F3n de Informe')
,p_source=>'Results'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un t\00EDtulo para la regi\00F3n en la que aparecer\00E1 el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30335921394517434.4001)
,p_name=>'P705_REGION_TEMPLATE2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n de Informe')
,p_source=>'select nvl(default_reportr_template,default_region_template) from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una plantilla de regi\00F3n para la regi\00F3n de informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30655522985850543.4001)
,p_name=>'P705_REPORT_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>'Plantilla de Informe'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla de Informe -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione una plantilla de informe.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34476611956117563.4001)
,p_name=>'P705_IS_REST'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>'Is Rest'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45239919985460770.4001)
,p_name=>'P705_PAGE_MODE'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122074027536962928.4001)
,p_name=>'P705_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122078712805979341.4001)
,p_name=>'P705_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P705_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381733743271093757.4001)
,p_name=>'P705_BREADCRUMB_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P705_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P705_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P705_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(404571468475850805.4001)
,p_name=>'P705_GROUP_NAME'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_api.id(30032223951154262.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30039331483154281.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P705_PAGE_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1941064255539468179.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P605_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193673701123498654.4001)
,p_computation_sequence=>5
,p_computation_item=>'P705_PAGE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from wwv_flow_shared_web_services where id = :P700_WS_ID'
,p_compute_when=>'P705_PAGE_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34476814512127753.4001)
,p_computation_sequence=>20
,p_computation_item=>'P705_IS_REST'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''doREST''',
'   and id = :P700_OPERATION_ID'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165437512151825638.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193677214283502452.4001)
,p_computation_sequence=>40
,p_computation_item=>'P705_REGION_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_region_title varchar2(4000);',
'begin',
'  l_region_title := :P705_PAGE_NAME;',
'  for c1 in (select name from wwv_flow_ws_operations where id = :P700_OPERATION_ID ) loop',
'    l_region_title := c1.name;',
'  end loop;',
'  return l_region_title;',
'end;'))
,p_compute_when=>'P705_REGION_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30039728542154281.4001)
,p_validation_name=>'P705_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P705_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(30034225253154268.4001)
,p_associated_item=>wwv_flow_api.id(30036403144154274.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30040126184154282.4001)
,p_validation_name=>'P705_PAGE_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'P705_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el t\00EDtulo de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(30037118096154276.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45240415671462743.4001)
,p_validation_name=>'P705_PAGE_MODE Not Null'
,p_validation_sequence=>3
,p_validation=>'P705_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(30034225253154268.4001)
,p_associated_item=>wwv_flow_api.id(45239919985460770.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30040907715154287.4001)
,p_validation_name=>'P705_REGION_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P705_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el t\00EDtulo de regi\00F3n.')
,p_associated_item=>wwv_flow_api.id(30035027504154269.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(404571964497851948.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P705_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P705_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(30034225253154268.4001)
,p_associated_item=>wwv_flow_api.id(404571468475850805.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381734802587099972.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P705_BREADCRUMB_ID'
,p_condition_element=>'P705_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381735166854099973.4001)
,p_event_id=>wwv_flow_api.id(381734802587099972.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_BREADCRUMB_PARENT_ID,P705_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381735363212099973.4001)
,p_event_id=>wwv_flow_api.id(381734802587099972.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_BREADCRUMB_PARENT_ID,P705_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549718159643753342.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30033822808154267.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549718222051753343.4001)
,p_event_id=>wwv_flow_api.id(549718159643753342.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1941069532605508096.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P705_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941069943048508096.4001)
,p_event_id=>wwv_flow_api.id(1941069532605508096.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P705_PAGE_NAME'
,p_attribute_07=>'P705_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941070401268508097.4001)
,p_event_id=>wwv_flow_api.id(1941069532605508096.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P705_PAGE_NAME'
,p_attribute_07=>'P705_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00707
begin
wwv_flow_api.create_page(
 p_id=>707.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso de Plantilla: Referencias'
,p_step_title=>'Uso de Plantilla: Referencias'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90376501110749469.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90376720437749469.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(90441604076983253.4001)
,p_name=>'Page Template Utilization'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id, page_template, page_type',
'from',
'(',
'select p.name,',
'       p.id,',
'       (select name from WWV_FLOW_TEMPLATES where id = p.step_template and flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id) page_template,',
'       substr(p.PAGE_COMPONENT_MAP,1,2) page_type',
'  from wwv_flow_steps p',
' where (step_template = :P707_TEMPLATE or :P707_PLUG_TEMPLATE = 0)',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(name),upper(:P707_FIND)) > 0 or',
'instr(upper(page_type),upper(:P707_FIND)) > 0 or',
'instr(id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'PAGE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90441806080983279.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90441909976983280.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#ID#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90442022844983280.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_TEMPLATE'
,p_column_display_sequence=>1
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90442109937983280.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGE_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tipo de P\00E1gina')
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(5402514727348886)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(90453125987046347.4001)
,p_name=>'Label Template Utilization'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application, item_name, page_name, page_number, template, id',
'from (',
'select f.flow_id application, ',
'       i.name item_name, ',
'       (select name from wwv_flow_steps where id = i.flow_step_id and flow_id = i.flow_id) page_name,',
'       i.flow_step_id page_number,',
'       f.template_name template, ',
'       f.id',
'from wwv_flow_field_templates f,',
'     wwv_flow_step_items i',
'where',
'i.ITEM_FIELD_TEMPLATE = f.id and',
'i.flow_id = :fb_flow_id and',
'f.flow_id = :fb_flow_id and ',
'f.id = :P707_TEMPLATE and',
':P707_TEMPLATE_TYPE = ''LABEL'' and',
'f.security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(item_name),upper(:P707_FIND)) > 0 or',
'instr(upper(page_name),upper(:P707_FIND)) > 0 or',
'instr(page_number,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'LABEL'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90465624274197175.4001)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>5
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90467014147213197.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90465703320197175.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90467101582213197.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGE_NUMBER'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_NUMBER#'
,p_column_linktext=>'#PAGE_NUMBER#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90465800472197175.4001)
,p_query_column_id=>5
,p_column_alias=>'TEMPLATE'
,p_column_display_sequence=>1
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90453508996046350.4001)
,p_query_column_id=>6
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(90472917919261593.4001)
,p_name=>'List Template Utilization'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id, template_name, id, region_name, page_id, list_name, list_id, referenced_from',
'from ',
'(',
'select ',
'  l.flow_id application_id,',
'  l.list_template_name template_name,',
'  l.id,',
'  p.plug_name region_name,',
'  p.page_id page_id,',
'  null list_name,',
'  null list_id,',
'  m.m referenced_from',
'from ',
'  wwv_flow_list_templates l,',
'  wwv_flow_page_plugs p,',
' (select wwv_flow_lang.system_message(''REGIONS_LIST_TEMPLATE_OVERRIDE'') m from sys.dual) m',
'where ',
'  l.flow_id = :fb_flow_id and',
'  p.list_template_id = l.id and',
'  l.id = :p707_TEMPLATE and',
'  l.security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(region_name),upper(:P707_FIND)) > 0 or',
'instr(upper(list_name),upper(:P707_FIND)) > 0 or',
'instr(page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'LIST'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_header=>unistr('<p>Este informe muestra todas las listas que hacen referencia a la plantilla seleccionada, as\00ED como cualquier regi\00F3n de p\00E1gina que sustituye la plantilla de lista por defecto.</p>')
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90485614334326770.4001)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90485718736326770.4001)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Plantilla'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90473309495261594.4001)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90485807028326770.4001)
,p_query_column_id=>4
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Nombre de la Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90473532243261594.4001)
,p_query_column_id=>5
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID,FB_FLOW_ID:#PAGE_ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#PAGE_ID#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90485915183326770.4001)
,p_query_column_id=>6
,p_column_alias=>'LIST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de la Lista'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:4050:F4000_P4050_LIST_ID,FB_FLOW_ID:#LIST_ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#LIST_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90487309963334953.4001)
,p_query_column_id=>7
,p_column_alias=>'LIST_ID'
,p_column_display_sequence=>6
,p_column_heading=>'List'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(95257919193879204.4001)
,p_query_column_id=>8
,p_column_alias=>'REFERENCED_FROM'
,p_column_display_sequence=>8
,p_column_heading=>'Pantalla de Referencia'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(90524226735850736.4001)
,p_name=>'Popup List of Values'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'  wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') template_name',
' from WWV_FLOW_POPUP_LOV_TEMPLATE',
'where flow_id = :fb_flow_id and',
'security_group_id = :flow_security_group_id'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'POPUP_LOV'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_header=>unistr('<p>S\00F3lo hay una plantilla lista de valores emergente disponible por aplicaci\00F3n.</p>')
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90527503579872357.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90526213491865754.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90526302991865754.4001)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Plantilla'
,p_column_link=>'f?p=&APP_ID.:251:&SESSION.::&DEBUG.:251:F4000_P251_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#TEMPLATE_NAME#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(90759007520249810.4001)
,p_name=>'Calendar Template References'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
't.name,',
'r.plug_name      region_name,',
'r.page_id        page,',
'(select name from wwv_flow_steps where id = r.page_id and flow_id = r.flow_id) page_name',
'from wwv_flow_cal_templates t,',
'     WWV_FLOW_CALS c,',
'     wwv_flow_page_plugs r',
'where c.flow_id = :fb_flow_id and',
'c.plug_id = r.id and',
't.id = c.template_id and',
't.flow_id = :fb_flow_id and',
't.security_group_id = :flow_security_group_id and',
'(',
':P707_FIND is null or ',
'instr(upper(r.plug_name),upper(:P707_FIND)) > 0 or',
'instr(r.page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'CALENDAR'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90759306130249813.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Plantilla'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90760820680253613.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90759512274249814.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96139722167482459.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(90773716749318655.4001)
,p_name=>'Breadcrumb Region'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    t.name template_name,',
'    r.page_id page,',
'    r.plug_name region',
'from wwv_flow_menu_templates t,',
'     wwv_flow_page_plugs r',
'where t.flow_id = :fb_flow_id and',
'      r.menu_template_id = t.id and',
'      t.id = :P707_TEMPLATE and',
'      t.security_group_id = :flow_security_group_id and',
'(',
':P707_FIND is null or ',
'instr(upper(r.plug_name),upper(:P707_FIND)) > 0 or',
'instr(r.page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'MENU'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90774021380318657.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Plantilla'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90774122764318657.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(90774212598318657.4001)
,p_query_column_id=>3
,p_column_alias=>'REGION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(92057426200364488.4001)
,p_name=>'Button Region'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select template_name, template_id, button_name, button_label, region, page',
'from',
'(',
'select ',
'  t.TEMPLATE_NAME template_name,',
'  t.id            template_id,',
'  b.BUTTON_NAME   button_name,',
'  b.button_image_alt button_label,',
'  r.plug_name     region,',
'  r.page_id       page',
'from wwv_flow_button_templates t,',
'     wwv_flow_step_buttons b,',
'     wwv_flow_page_plugs r',
'where ',
'button_template_id = t.id and',
'r.flow_id = :fb_flow_id and',
'b.flow_id = :fb_flow_id and',
't.flow_id = :fb_flow_id and',
'b.BUTTON_PLUG_ID = r.id and',
't.id = :P707_TEMPLATE and',
't.security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(button_name),upper(:P707_FIND)) > 0 or',
'instr(upper(button_label),upper(:P707_FIND)) > 0 or',
'instr(upper(region),upper(:P707_FIND)) > 0 or',
'instr(page,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'BUTTON'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92057604806364490.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Plantilla'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92058305468386886.4001)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Template ID'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92058422034386886.4001)
,p_query_column_id=>3
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Nombre del Bot\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92063018675419028.4001)
,p_query_column_id=>4
,p_column_alias=>'BUTTON_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Etiqueta de Bot\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92057831051364491.4001)
,p_query_column_id=>5
,p_column_alias=>'REGION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92057714956364491.4001)
,p_query_column_id=>6
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(92065626425430729.4001)
,p_name=>'Report Templates'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.ROW_TEMPLATE_NAME template_name,',
'       t.id            template_id,',
'       (select name from wwv_flow_steps ',
'         where id      = r.page_id',
'           and flow_id = r.flow_id) page_name,',
'       r.plug_name     region,',
'       r.page_id       page',
'  from WWV_FLOW_ROW_TEMPLATES t,',
'       wwv_flow_page_plugs r',
' where r.flow_id                 = :fb_flow_id',
'   and t.flow_id                 = :fb_flow_id',
'   and r.PLUG_QUERY_ROW_TEMPLATE = t.id',
'   and t.id                      = :P707_TEMPLATE',
'   and r.plug_source_type        in ( ''NATIVE_SQL_REPORT'',',
'                                      ''NATIVE_TABFORM'' )',
'   and t.security_group_id       = :flow_security_group_id',
'   and (    :P707_FIND                                  is null ',
'         or instr(upper(r.plug_name),upper(:P707_FIND)) > 0',
'         or instr(r.page_id,:P707_FIND)                 > 0 )'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'REPORT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92066026416430729.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de la Plantilla'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92065900788430729.4001)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Template ID'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96137417880471754.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92066216103430729.4001)
,p_query_column_id=>4
,p_column_alias=>'REGION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92066119673430729.4001)
,p_query_column_id=>5
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(468075709995571377.4001)
,p_name=>unistr('Uso de Plantilla de Regi\00F3n')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select max(PAGE_PLUG_TEMPLATE_NAME) x ',
'          from WWV_FLOW_PAGE_PLUG_TEMPLATES ',
'         where id = :P707_TEMPLATE) template_name,',
'       page_id p,',
'       (select name from wwv_flow_steps ',
'         where id = p.page_id and flow_id = p.flow_id) page_name,',
'       p.plug_name,',
'       p.flow_id',
'from   wwv_flow_page_plugs p',
'where  p.flow_id = :FB_FLOW_ID and ',
'       p.plug_template = :P707_TEMPLATE and',
'       p.security_group_id = :flow_security_group_id and',
'(',
':P707_FIND is null or ',
'instr(upper(p.plug_name),upper(:P707_FIND)) > 0 or',
'instr(page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'REGION'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(468076031026571380.4001)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(468076101280571590.4001)
,p_query_column_id=>2
,p_column_alias=>'P'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(468076226292571590.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(468076316488571590.4001)
,p_query_column_id=>4
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Nombre de la Regi\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(468076429662571590.4001)
,p_query_column_id=>5
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90378613017749475.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(90376501110749469.4001)
,p_button_name=>'P707_GO'
,p_button_static_id=>'P707_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90379121871749478.4001)
,p_branch_action=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(90377625336749473.4001)
,p_name=>'P707_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(90376501110749469.4001)
,p_prompt=>'Template:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(90378115026749474.4001)
,p_name=>'P707_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(90376501110749469.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de elementos que se mostrar\00E1n y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(90390006950766464.4001)
,p_name=>'P707_TEMPLATE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(90376501110749469.4001)
,p_prompt=>'Tipo:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TEMPLATE.TYPES.ALL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from dual'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Tipo de plantilla que se muestra.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95927128271424531.4001)
,p_name=>'P707_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(90376501110749469.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca criterios de consulta que no sean sensibles a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(90378827079749477.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(90378613017749475.4001)
);
end;
/
prompt --application/pages/page_00708
begin
wwv_flow_api.create_page(
 p_id=>708.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituir Plantillas: Tipo de Plantilla'
,p_step_title=>'Sustituir Plantillas: Tipo de Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90718104576082094.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_header=>'<p>Este asistente le permite actualizar los componentes que utilizan una plantilla con otra.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168736217450381660.4001)
,p_plug_name=>'replace templates train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(168734227577365586.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208129411943230093.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747144813989138169.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90718529173082095.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208129411943230093.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90718803405082095.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208129411943230093.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90719227955082095.4001)
,p_branch_action=>'f?p=&APP_ID.:711:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(90718803405082095.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(90718420143082094.4001)
,p_name=>'P708_TEMPLATE_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(90718104576082094.4001)
,p_item_default=>'PAGE'
,p_prompt=>'Tipo de Plantilla:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE TYPES PAGE 708'
,p_lov=>'.'||wwv_flow_api.id(168736405114387476.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tipo de plantilla que se sustituye.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(363788421968305553.4001)
,p_name=>'P708_USER_INTERFACE_ID'
,p_is_required=>true
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(90718104576082094.4001)
,p_prompt=>'Interfaz de Usuario:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DISPLAY_NAME as display_value, ID as return_value ',
'  from WWV_FLOW_USER_INTERFACES',
'  where flow_id = :FB_FLOW_ID',
' order by ui_type_id'))
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione la interfaz de usuario'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00711
begin
wwv_flow_api.create_page(
 p_id=>711.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituir Plantillas: Identificar Plantillas'
,p_step_title=>'Sustituir Plantillas: Identificar Plantillas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90719716967082096.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_header=>unistr('<p>Identifique la plantilla que desea sustituir y la plantilla a la que desea cambiar. Se cambiar\00E1n todas las referencias de la plantilla seleccionada.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168736011909379998.4001)
,p_plug_name=>'sustituir proceso de plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(168734227577365586.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(207429407218112199.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747144983803138169.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90720129974082096.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(207429407218112199.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90720418917082096.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(207429407218112199.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90720308023082096.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(207429407218112199.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90721124694082097.4001)
,p_branch_action=>'f?p=&APP_ID.:713:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(90720418917082096.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90720825458082096.4001)
,p_branch_action=>'f?p=&APP_ID.:708:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(90720308023082096.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(90720031816082096.4001)
,p_name=>'P711_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(90719716967082096.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Plantilla:'
,p_source=>'P708_TEMPLATE_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TEMPLATE.TYPES.ALL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from dual'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tipo de plantilla que se sustituye.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94008314352843268.4001)
,p_name=>'P711_CONSOLIDATE_FROM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(90719716967082096.4001)
,p_prompt=>'Cambiar de'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se sustituye.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94009809981851445.4001)
,p_name=>'P711_CONSOLIDATE_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(90719716967082096.4001)
,p_prompt=>'Cambiar a'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la nueva plantilla que sustituir\00E1 todas las incidencias de la plantilla seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(363788203217298965.4001)
,p_name=>'P711_USER_INTERFACE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(90719716967082096.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Interfaz de Usuario:'
,p_source=>'P708_USER_INTERFACE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DISPLAY_NAME as display_value, ID as return_value ',
'  from WWV_FLOW_USER_INTERFACES',
'  where flow_id = :FB_FLOW_ID',
''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96738921415545316.4001)
,p_validation_name=>'P711_CONSOLIDATE_FROM Not Null'
,p_validation_sequence=>1
,p_validation=>'P711_CONSOLIDATE_FROM'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_associated_item=>wwv_flow_api.id(94008314352843268.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-NOV-2007 12:13'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96739129733545322.4001)
,p_validation_name=>'P711_CONSOLIDATE_TO Not Null'
,p_validation_sequence=>2
,p_validation=>'P711_CONSOLIDATE_TO'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_associated_item=>wwv_flow_api.id(94009809981851445.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-NOV-2007 12:13'
);
end;
/
prompt --application/pages/page_00712
begin
wwv_flow_api.create_page(
 p_id=>712.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Gestionar Entradas de Lista Hu\00E9rfanas')
,p_step_title=>unistr('Gestionar Entradas de Lista Hu\00E9rfanas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(40749510927686102.4001)
,p_name=>'Entradas de Lista'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c, list_item_link_text, id, list_item_display_sequence, list_item_type, list_item_link_target, parent_list_item_id, last_updated_on, orphaned',
'from (',
'select',
'    apex_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''F4000.P712.CLEAR_PARENT_ENTRY'')||'' ''||wwv_flow_escape.html(list_item_link_text)||''"'') c,',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,50) list_item_link_target, ',
'    decode(parent_list_item_id,null,null,',
'    nvl((select list_item_link_text from wwv_flow_list_items where id = l.parent_list_item_id and list_id = l.list_id),parent_list_item_id)) parent_list_item_id,',
'    last_updated_on,',
'    decode(parent_list_item_id,null,''N'',decode((select count(*) o from wwv_flow_list_items where id = l.parent_list_item_id and list_id = l.list_id),0,''Y'',''N'')) Orphaned',
'  from   ',
'    wwv_flow_list_items l',
'  where  ',
'    list_id = to_number(replace(:P712_LIST_ID,''%''||''null%'',null)) and',
'    flow_id = :fb_flow_id and',
'    security_group_id = :flow_security_group_id)',
'x',
'where (nvl(:P712_SHOW,''O'') = ''O'' and orphaned = ''Y'') or (nvl(:P712_SHOW,''O'') =''A'')'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna entrada de lista'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40895523205626283.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40749823708686105.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40749926611686105.4001)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40750025198686105.4001)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40750104670686105.4001)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'List Item Type'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40750217868686105.4001)
,p_query_column_id=>6
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>6
,p_column_heading=>'Destino'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40750315965686105.4001)
,p_query_column_id=>7
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Principal'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40750627017686105.4001)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>8
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(40785926388106819.4001)
,p_query_column_id=>9
,p_column_alias=>'ORPHANED'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Hu\00E9rfano')
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40755202185702453.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_col_allignments=>'R:R:L:L:L:R'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:YES'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40977612787446310.4001)
,p_plug_name=>unistr('Entradas de Lista Hu\00E9rfanas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Una entrada de lista hu\00E9rfana es una entrada de lista que tiene un principal que ya no es miembro de la lista actual. Esta situaci\00F3n no es com\00FAn, pero si una entrada de lista se vuelve hu\00E9rfana, utilice esta p\00E1gina para borrar el principal de la e')
||'ntrada.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40756527128702454.4001)
,p_button_sequence=>89
,p_button_plug_id=>wwv_flow_api.id(40755202185702453.4001)
,p_button_name=>'P712_GO'
,p_button_static_id=>'P712_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40896605329630583.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(40755202185702453.4001)
,p_button_name=>'UNPARENT_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Borrar Entrada Principal'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40897308792631543.4001)
,p_branch_action=>'f?p=&APP_ID.:712:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40755521107702453.4001)
,p_name=>'P712_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(40755202185702453.4001)
,p_item_default=>'0'
,p_prompt=>'Lista:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'from wwv_flow_lists',
'where flow_id = :FB_FLOW_ID',
'order by upper(name)'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la lista seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40964611645313579.4001)
,p_name=>'P712_SHOW'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(40755202185702453.4001)
,p_item_default=>'O'
,p_prompt=>'Mostrar'
,p_source=>'O'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ORPHANED_LISTS_DISPLAY'
,p_lov=>'.'||wwv_flow_api.id(94838211998345101.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Mostrar todas las entradas o s\00F3lo las entradas de lista hu\00E9rfanas.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40898220220634868.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unparent checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   update wwv_flow_list_items ',
'   set parent_list_item_id = null',
'   where list_id = :P712_LIST_ID and ',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id and ',
'         flow_id = :fb_flow_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(40896605329630583.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_00713
begin
wwv_flow_api.create_page(
 p_id=>713.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sustituir Plantillas: Confirmar'
,p_step_title=>'Sustituir Plantillas: Confirmar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90721624290082097.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Haga clic en <strong>Terminar</strong> para cambiar todas las referencias del componente de la plantilla identificada por la nueva plantilla. Los valores por defecto de tema no se cambiar\00E1n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168735027708375127.4001)
,p_plug_name=>'replace templates train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(168734227577365586.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208154127798679391.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747145015750138170.4001)
,p_plug_name=>'Sustituir Plantillas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90722023277082098.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208154127798679391.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90722105717082098.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208154127798679391.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90722226490082098.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208154127798679391.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90723031296082098.4001)
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(90722731998082098.4001)
,p_branch_action=>'f?p=&APP_ID.:711:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(90722226490082098.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94001128457790636.4001)
,p_name=>'P713_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(90721624290082097.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Plantilla:'
,p_source=>'P708_TEMPLATE_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TEMPLATE.TYPES.ALL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from dual'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tipo de plantilla que se sustituye.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94063602221114115.4001)
,p_name=>'P713_CONSOLIDATE_FROM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(90721624290082097.4001)
,p_prompt=>'Cambiar de:'
,p_source=>'&P711_CONSOLIDATE_FROM.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla que se va a cambiar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94065016074118141.4001)
,p_name=>'P713_CONSOLIDATE_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(90721624290082097.4001)
,p_prompt=>'Cambiar a:'
,p_source=>'&P711_CONSOLIDATE_TO.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flow_user_interfaces where id = 	:P708_USER_INTERFACE_ID and flow_id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la nueva plantilla que sustituir\00E1 todas las incidencias de la plantilla seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95626402191214620.4001)
,p_name=>'P713_TEMPLATES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(90721624290082097.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Recuento de Plantillas a Sustituir:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'wwv_flow_theme_manager.count_consolidation (',
' p_application_id   => :fb_flow_id,',
' p_consolidate_from => :P711_CONSOLIDATE_FROM,',
' p_consolidate_to   => :P711_CONSOLIDATE_TO,',
' p_template_type    => :P708_TEMPLATE_TYPE);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('N\00FAmero de referencias de plantilla que se van a cambiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(96745917746629481.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'consolidate'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.consolidate_templates (',
'   p_application_id   => :fb_flow_id,',
'   p_consolidate_from => :P711_CONSOLIDATE_FROM,',
'   p_consolidate_to   => :P711_CONSOLIDATE_TO,',
'   p_template_type    => :P708_TEMPLATE_TYPE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido sustituir las plantillas'
,p_process_when_button_id=>wwv_flow_api.id(90722105717082098.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
);
end;
/
prompt --application/pages/page_00714
begin
wwv_flow_api.create_page(
 p_id=>714.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Vistas de Application Express'
,p_step_title=>'Vistas de Application Express'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(200467223102537626)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200451220490287640.4001)
,p_plug_name=>'Vistas de Application Express'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select APEX_VIEW_NAME,',
'       COMMENTS,',
'       PARENT_VIEW,',
'       ''f?p=4000:892:''||:APP_SESSION||',
'          '':::892,893,896:P892_LAST_PAGE,P892_VIEW_NAME,P893_VIEW_NAME,P896_VIEW_NAME:714,''||',
'          APEX_VIEW_NAME ||'',''||APEX_VIEW_NAME||'',''||APEX_VIEW_NAME link,',
'       ''icon-util-apex-views'' icon,',
'       replace(replace(replace(initcap(replace(apex_view_name,''_'','' '')),''Apex'',''APEX''),''Lov'',''LOV''),''Sql'',''SQL'') bname',
'  from APEX_DICTIONARY ',
' where column_id=0'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(200451301656287640.4001)
,p_name=>'Application Express Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#APEX_VIEW_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200451523458287643.4001)
,p_db_column_name=>'APEX_VIEW_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Ver'
,p_column_link=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.:892,893,896:P892_VIEW_NAME,P893_VIEW_NAME,P896_VIEW_NAME:#APEX_VIEW_NAME#,#APEX_VIEW_NAME#,#APEX_VIEW_NAME#'
,p_column_linktext=>'#APEX_VIEW_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200451615389287644.4001)
,p_db_column_name=>'COMMENTS'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200451703550287645.4001)
,p_db_column_name=>'PARENT_VIEW'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Vista Principal'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200817506506772361.4001)
,p_db_column_name=>'BNAME'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>unistr('Nombre del Bot\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200818124036805640.4001)
,p_db_column_name=>'LINK'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1029936832389915801.4001)
,p_db_column_name=>'ICON'
,p_display_order=>17
,p_column_identifier=>'G'
,p_column_label=>'Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200464415221516479.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(200452609222306546.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699069214410849616.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955889819902997309.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Las vistas de &PRODUCT_NAME. son vistas de diccionario de datos que muestran los metadatos para las aplicaciones. En las vistas de &PRODUCT_NAME. no solo puede ver la vista, sino tambi\00E9n los datos que contienen.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200554107948864388.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200451220490287640.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.:714,RIR::'
);
end;
/
prompt --application/pages/page_00716
begin
wwv_flow_api.create_page(
 p_id=>716.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22653722318934005.4001)
,p_name=>unistr('Autenticaci\00F3n B\00E1sica')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, c001 id, c002 name, c003 parm_type, ',
'       c004 item_name, c005 item_label, c006 include',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22653920201934006.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22654028812934006.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22654108673934006.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22654231500934006.4001)
,p_query_column_id=>4
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22654308690934006.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22654416499934006.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22654508900934006.4001)
,p_query_column_id=>7
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>7
,p_column_heading=>'Create'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22654818424934007.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22655018672934007.4001)
,p_plug_name=>'Pantalla e Informe Basados en Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique los nombres y las etiquetas de los elementos creados bas\00E1ndose en los par\00E1metros de autenticaci\00F3n de este servicio.</p>'),
'<p>Si es necesario, edite la etiqueta del elemento.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204748630516126595.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22655919591934008.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204748630516126595.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22656330466934008.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204748630516126595.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22656525143934008.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204748630516126595.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34484027905273522.4001)
,p_branch_action=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22656525143934008.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P705_IS_REST'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34484309335277590.4001)
,p_branch_action=>'f?p=&APP_ID.:882:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22656330466934008.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P705_IS_REST'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(790824814838546266.4001)
,p_branch_action=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22656330466934008.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P700_WEB_REF_TYPE = ''MANUAL'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22657615559934009.4001)
,p_branch_action=>'f?p=&FLOW_ID.:725:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22656330466934008.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22657810486934010.4001)
,p_branch_action=>'f?p=&FLOW_ID.:720:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22656525143934008.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549740786805954508.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(22655919591934008.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549740884771954509.4001)
,p_event_id=>wwv_flow_api.id(549740786805954508.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22656912978934009.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_AUTH_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00719
begin
wwv_flow_api.create_page(
 p_id=>719.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Lista Din\00E1mica')
,p_page_mode=>'NON_MODAL'
,p_step_title=>unistr('Crear Lista Din\00E1mica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'570'
,p_dialog_width=>'820'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1449700853810807.4001)
,p_plug_name=>unistr('Crear Lista Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(758615420776655704.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(758615519441655705.4001)
,p_plug_name=>unistr('Crear Lista Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1450106832810807.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(758615420776655704.4001)
,p_button_name=>'FINISH'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:$v_PopupReturn($v(''P719_LOV_SQL''),''&P464_LIST_SOURCE_FIELD!JS.'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1450310178810807.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(758615420776655704.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1449910073810807.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(758615420776655704.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1450806922810809.4001)
,p_branch_action=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1450310178810807.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1450513796810807.4001)
,p_name=>'P719_LOV_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1449700853810807.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'select * from emp;'
,p_prompt=>'Consulta'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  q varchar2(32767) := null;',
'begin',
'  ',
'  -- Label',
'  q := ''select null as level_value ''||chr(10)||''       , "''||:P701_LABEL_COLUMN||''" as label_value '';',
'  q := q||chr(10);',
' ',
'  -- Target',
'  if :P701_TARGET_COLUMN is not null then',
'      q := q||''       , "''||:P701_TARGET_COLUMN||''" as target_value'';',
'  else',
'      if :P701_TARGET_URL is not null then',
'          q := q||''       , ''''''||:P701_TARGET_URL||'''''' as target_value'';',
'      else',
'          q := q||''       , null as target_value'';',
'      end if;',
'  end if;',
'  q := q||chr(10);',
'  ',
'  -- Is Current',
'    if :P701_IS_CURRENT is not null then',
'        q := q||''       , ''''''||:P701_IS_CURRENT||'''''' as is_current '';',
'    else',
'        q := q||''       , null as is_current '';',
'    end if;',
'  q := q||chr(10);',
'',
'  -- Image',
'  if :P701_IMAGE_COLUMN is not null then',
'      q := q||''       , "''||:P701_IMAGE_COLUMN||''" as image_value '';',
'  else',
'      q := q||''       , null as image_value '';',
'  end if;',
'  q := q||chr(10);',
' ',
'  -- Image Attribute',
'  if :P701_IMAGE_ATTR_COLUMN is not null then',
'      q := q||''       , "''||:P701_IMAGE_ATTR_COLUMN||''" as image_attr_value '';',
'  else',
'      q := q||''       , null as image_attr_value '';      ',
'  end if;',
'  q := q||chr(10);',
'  ',
'  -- Image Alt Attribute',
'  if :P701_IMAGE_ALT_COLUMN is not null then',
'      q := q||''       , "''||:P701_IMAGE_ALT_COLUMN||''" as image_alt_value '';',
'  else',
'      q := q||''       , null as image_alt_value '';      ',
'  end if;',
'  q := q||chr(10);',
'  ',
'  ',
'  q := q||''from '';',
'',
'  for c1 in (select OWNER from wwv_flows where id = :fb_flow_id)',
'  loop',
'      if nvl(upper(c1.owner),''x'') != nvl(upper(:P542_OWNER),''y'') then',
'          -- include owner if it is different from the application owner',
'          q := q||''"''||:P542_OWNER||''".'';',
'      end if;',
'  end loop;',
'  if :P542_TABLE is not null then',
'      q := q||''"''||:P542_TABLE||''"'';',
'  end if;',
'  q := q||chr(10)||''order by 1'';',
'  return q;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ORIG CODE: 2-FEB-2011',
'',
'declare ',
'  q varchar2(32767) := null;',
'begin',
'  if :P701_DISPLAY_COLUMN != upper(:P701_DISPLAY_COLUMN) then',
'     q := ''select "''||:P701_DISPLAY_COLUMN||''" as display_value, '';',
'  else',
'     q := ''select ''||:P701_DISPLAY_COLUMN||'' as display_value, '';',
'  end if;',
'  if :P701_RETURN_COLUMN != upper(:P701_RETURN_COLUMN) then',
'     q := q||''"''||:P701_RETURN_COLUMN||''" as return_value '';',
'  else',
'     q := q||:P701_RETURN_COLUMN||'' as return_value '';',
'  end if;',
'  q := q||chr(10);',
'  q := q||''  from '';',
'  for c1 in (select OWNER from wwv_flows where id = :fb_flow_id) loop',
'     if nvl(upper(c1.owner),''x'') != nvl(upper(:P542_OWNER),''y'') then',
'         -- include owner if it is different from the application owner',
'         q := q||:P542_OWNER||''.'';',
'     end if;',
'  end loop;',
'  if :P542_TABLE != upper(:P542_TABLE) then',
'      q := q||''"''||:P542_TABLE||''"'';',
'  else   q := q||:P542_TABLE;',
'  end if;',
'  q := q||chr(10)||'' order by 1'';',
'  return q;',
'end;'))
);
end;
/
prompt --application/pages/page_00720
begin
wwv_flow_api.create_page(
 p_id=>720.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla e Informes Basados en Servicio Web: Elementos de Entrada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(30062402754215125.4001)
,p_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, c001 id, c002 name, c003 parm_type, ',
'       c004 item_name, c005 item_label, c006 include',
'  from wwv_flow_collections',
' where collection_name = ''WS_INPUT_ITEMS'''))
,p_display_when_condition=>'P720_IS_ARRAY'
,p_display_when_cond2=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_header=>unistr('<p>Identifique los nombres y etiquetas de los elementos creados bas\00E1ndose en los par\00E1metros de entrada de este servicio. Para incluir un elemento, seleccione <strong>S\00ED</strong> en la columna Crear. De lo contrario, seleccione <strong>No</strong>. Si')
||' es necesario, edite la etiqueta del elemento.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30062830105215126.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30062906809215126.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30063019962215127.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30063103634215127.4001)
,p_query_column_id=>4
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30063210649215127.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30063300197215127.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(38878713393887143.4001)
,p_query_column_id=>7
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>7
,p_column_heading=>'Crear'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30063827252215131.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204745712723112011.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(215714610018520039.4001)
,p_plug_name=>unistr('Los par\00E1metros de entrada contienen un tipo de matriz')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los par\00E1metros de entrada de este servicio necesitan un tipo de matriz que no se puede representar creando elementos. No podr\00E1 utilizar el asistente para crear una pantalla en esta referencia de servicio Web.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P720_IS_ARRAY'
,p_plug_display_when_cond2=>'Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30064611509215134.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204745712723112011.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30065420346215136.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204745712723112011.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30065011692215135.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204745712723112011.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22666527607976143.4001)
,p_branch_action=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30065420346215136.4001)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38845031139523270.4001)
,p_branch_action=>'f?p=&FLOW_ID.:705:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30065011692215135.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193720500842028374.4001)
,p_branch_action=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30065420346215136.4001)
,p_branch_sequence=>35
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P700_WEB_REF_TYPE = ''MANUAL'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30067026361215143.4001)
,p_branch_action=>'f?p=&APP_ID.:725:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30065420346215136.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(215716126986524926.4001)
,p_name=>'P720_IS_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(215714610018520039.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549740994811954510.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30064611509215134.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549741067286954511.4001)
,p_event_id=>wwv_flow_api.id(549740994811954510.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30066210996215141.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_INPUT_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30065922327215137.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_OPERATION_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_INPUT_ITEMS'',',
'        p_query           => ''select a.id, a.name, a.parm_type,',
'''''P''''||:pg_id||''''_''''||upper(a.name), initcap(a.name), ''''Y'''' yes_no from wwv_flow_ws_parameters a where a.input_or_output in (''''I'''',''''H'''') and a.type_is_xsd = ''''Y'''' and a.ws_opers_id = :op_id order by a.input_or_output, a.id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P700_WEB_REF_TYPE = ''NEW_SCHOOL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(193695708208737264.4001)
,p_process_sequence=>45
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob  clob;',
'    l_off   number := 1;',
'    l_pos   number := 0;',
'    l_name  varchar2(4000);',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''WS_INPUT_ITEMS'');',
'',
'    for c1 in (select flow_items_comma_delimited',
'                 from wwv_flow_shared_web_services',
'                where id = :P700_WS_ID ) loop',
'        l_clob := c1.flow_items_comma_delimited;',
'    end loop;',
'',
'    l_pos   := sys.dbms_lob.instr(l_clob,'','',1);',
'',
'    if l_pos = 0 then --there are no commas at all',
'        if sys.dbms_lob.getlength(l_clob) > 0 then',
'            l_name := sys.dbms_lob.substr(l_clob,sys.dbms_lob.getlength(l_clob),1);',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_name),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'        end if;',
'    else',
'        loop',
'            exit when l_pos = 0;',
'',
'            l_name := sys.dbms_lob.substr(l_clob,l_pos-l_off,l_off);',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_name),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'            l_off := l_pos + 1;',
'            l_pos := sys.dbms_lob.instr(l_clob,'','',l_off);',
'        end loop;',
'        --need to get the last one',
'        l_name := sys.dbms_lob.substr(l_clob,4000,l_off);',
'        wwv_flow_collection.add_member(',
'            p_collection_name   => ''WS_INPUT_ITEMS'',',
'            p_c001              => ''MANUAL'',',
'            p_c002              => l_name,',
'            p_c003              => ''string'',',
'            p_c004              => upper(l_name),',
'            p_c005              => initcap(l_name),',
'            p_c006              => ''Y'' );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P700_WEB_REF_TYPE = ''MANUAL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(215719201622536514.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate is_array'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_is_array varchar2(1) := ''N'';',
'begin',
'  for c1 in (select count(*), c004',
'               from wwv_flow_collections',
'              where collection_name = ''WS_INPUT_ITEMS''',
'              group by c004',
'             having count(*) > 1 ) loop',
'    l_is_array := ''Y'';',
'    exit;',
'  end loop;',
'  if :P720_WEB_REF_TYPE = ''NEW_SCHOOL'' then',
'    :P720_IS_ARRAY := l_is_array;',
'  else',
'    :P720_IS_ARRAY := ''N'';',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22664916048963322.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate auth item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''ws_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_WS_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_AUTH_ITEMS'',',
'        p_query           => ''select a.id, decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), wwv_flow_lang.system_message(''''AUTHENTICATION''''),',
'''''P''''||:pg_id||''''_''''||upper(decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name)), decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTRO'
||'L_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), ''''Y'''' y_or_n from wwv_flow_ws_parameters a, wwv_flow_ws_operations b, wwv_flow_shared_web_services c where input_or_output = ''''A'''' and a.ws_opers_id = b.id and b.ws_id = c'
||'.id and c.id = :ws_id order by a.name desc'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00722
begin
wwv_flow_api.create_page(
 p_id=>722.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Grupos de Aplicaciones'
,p_step_title=>'Grupos de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91139922499861568)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91619417266324331.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(91618427870317883.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(95535315411805254.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Los grupos de aplicaciones permiten organizar las aplicaciones.</p>',
unistr('<p>Para utilizar grupos de aplicaciones, cree un grupo haciendo clic en <strong>Crear</strong> y, a continuaci\00F3n, asigne aplicaciones a ese grupo.</p>'),
unistr('<p>Para asociar una aplicaci\00F3n a un grupo de aplicaciones, haga clic en <strong>Gestionar Asignaciones</strong> en la lista Tareas.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445610404731601726.4001)
,p_plug_name=>'Grupos de Aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P722a */',
'       id, ',
'       group_name, ',
'       group_comment, ',
'       assigned_applications, ',
'       last_modified, ',
'       round(100*assigned_applications/decode(all_applications,0,1,all_applications)) pct_of_total,',
'       round(100*assigned_applications/decode(all_applications,0,1,all_applications)) graph,',
'       ''icon-util-page-group'' img, ''f?p=4000:726:''||:app_session||'':::RP:FB_FLOW_ID,P726_ID:''||:fb_flow_id||'',''||id img_link,',
'       replace(group_name,''_'','' '')||'' (''|| assigned_applications ||'')'' img_text',
'from ( select id, ',
'              group_name, ',
'              group_comment,',
'              ( select count(*)',
'                  from wwv_flows ',
'                 where security_group_id = :flow_security_group_id ',
'                   and group_id = g.id) Assigned_Applications, ',
'              nvl(updated_on,created_on) last_modified,',
'              a.all_applications',
'         from wwv_flow_application_groups g,',
'              ( select count(*) all_applications ',
'                  from wwv_flow_visible_flows f',
'                 where group_id is not null',
'                   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ) a',
'        where security_group_id = :flow_security_group_id ) x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(445610507272601726.4001)
,p_name=>'Application Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#IMG_LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#GROUP_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445610730447601759.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445610809845601766.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre de Grupo'
,p_column_link=>'f?p=&APP_ID.:726:&SESSION.::&DEBUG.:RP:P726_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445610903706601767.4001)
,p_db_column_name=>'GROUP_COMMENT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445611122645601769.4001)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>unistr('Fecha de Modificaci\00F3n')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445611020228601768.4001)
,p_db_column_name=>'ASSIGNED_APPLICATIONS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Aplicaciones'
,p_column_link=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::IR_GROUPNAME,FB_FLOW_ID:#GROUP_NAME#,&FB_FLOW_ID.'
,p_column_linktext=>'#ASSIGNED_APPLICATIONS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445611422026601772.4001)
,p_db_column_name=>'IMG'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445611513011601773.4001)
,p_db_column_name=>'IMG_LINK'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Enlace de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(445611623877601774.4001)
,p_db_column_name=>'IMG_TEXT'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Texto de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(969098204076943070.4001)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Porcentaje del Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(969098310680943070.4001)
,p_db_column_name=>'GRAPH'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Gr\00E1fico')
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699068624658844542.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91039229518900853.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(445610404731601726.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:726:&SESSION.::&DEBUG.:726 :FB_FLOW_ID:,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_00724
begin
wwv_flow_api.create_page(
 p_id=>724.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Varios Botones'
,p_step_title=>'Suprimir Varios Botones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46083918585647344.4001)
,p_plug_name=>'Seleccione los botones que desea eliminar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    wwv_flow_item.checkbox(1,wwv_flow_escape.html(id),''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(button_name))||''"'') c,',
'    BUTTON_SEQUENCE item_sequence,',
'    BUTTON_NAME name,',
'    BUTTON_IMAGE_ALT display_as,',
'    (select wwv_flow_escape.html(plug_name) n ',
'     from wwv_flow_page_plugs ',
'     where id = b.BUTTON_PLUG_ID)',
'       item_plug_id',
'from WWV_FLOW_STEP_BUTTONS b',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and',
'      security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(46084015923647345.4001)
,p_name=>'Select Buttons to Remove'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46084228791647354.4001)
,p_db_column_name=>'C'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46084632449647356.4001)
,p_db_column_name=>'ITEM_PLUG_ID'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46084309466647355.4001)
,p_db_column_name=>'ITEM_SEQUENCE'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46084421242647355.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46084503913647355.4001)
,p_db_column_name=>'DISPLAY_AS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Etiqueta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51134924470124123.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167682810655584497.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51136715017124126.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(167682810655584497.4001)
,p_button_name=>'P724_GO'
,p_button_static_id=>'P724_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51135603645124124.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(167682810655584497.4001)
,p_button_name=>'REMOVE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Botones'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 x',
'from wwv_flow_step_buttons',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51136014628124125.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(167682810655584497.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51135807601124124.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(167682810655584497.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51147626835144331.4001)
,p_branch_name=>'Go To Page 724'
,p_branch_action=>'f?p=&APP_ID.:724:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51136231273124125.4001)
,p_name=>'P724_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(167682810655584497.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(51137015126124126.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(51137221433124126.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P724_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51137403761124127.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un componente que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(51135603645124124.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199173941813878415.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(46083918585647344.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199174061131878416.4001)
,p_event_id=>wwv_flow_api.id(1199173941813878415.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51137502184124127.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple buttons'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from WWV_FLOW_STEP_BUTTONS',
'   where id = to_number(wwv_flow.g_f01(i)) and',
'         flow_id = :fb_flow_id and',
'         flow_step_id = :fb_flow_page_id and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(51135603645124124.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00725
begin
wwv_flow_api.create_page(
 p_id=>725.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla e Informe Basados en Servicio Web: Resultados de Servicio Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30069027239226823.4001)
,p_plug_name=>'Nodo Base'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_row_count_max=>1000
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato.')
,p_plug_query_break_cols=>'0'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'')',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_header=>unistr('<p>Identifique el nombre del juego de resultados temporal en el que se va a almacenar el resultado de servicio Web y seleccione el \00E1rbol de resultados en el que se va a crear el informe.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30070025233226825.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204758221044190105.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(287124420639303467.4001)
,p_plug_name=>unistr('Ning\00FAn \00C1rbol de Resultados para Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Este servicio Web no tiene ning\00FAn \00E1rbol de resultados en su definici\00F3n que sea adecuado para este informe. Puede que, en su lugar, desee ejecutar el Asistente de Pantallas Basadas en Servicio Web.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'')',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30071203933226827.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204758221044190105.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30072031311226830.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204758221044190105.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30071609780226828.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204758221044190105.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22667215271982081.4001)
,p_branch_action=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30071609780226828.4001)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30073317744226833.4001)
,p_branch_action=>'f?p=&FLOW_ID.:720:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30071609780226828.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30073719709226834.4001)
,p_branch_action=>'f?p=&FLOW_ID.:730:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30165701694063969.4001)
,p_name=>'P725_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30069027239226823.4001)
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P725_ARRAYS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione la parte del documento XML resultante que contiene la informaci\00F3n que desea incluir en el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30167715771134270.4001)
,p_name=>'P725_COLLECTION_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(30069027239226823.4001)
,p_prompt=>unistr('Nombre del Juego de Resultados Temporal (Recopilaci\00F3n)')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''P''||:P705_PAGE_ID||''_''||upper(name)||''_RESULTS''',
'  from wwv_flow_ws_operations',
' where id = :P700_OPERATION_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el nombre del juego de resultados temporal en el que se almacenar\00E1 el documento. El juego de resultados temporal se almacena en una recopilaci\00F3n de &PRODUCT_NAME. en la columna CLOB001 con el nombre proporcionado aqu\00ED.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30170319281163685.4001)
,p_validation_name=>'P725_COLLECTION_NAME'
,p_validation_sequence=>10
,p_validation=>'P725_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar el nombre de la recopilaci\00F3n en la que se debe almacenar el resultado.')
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(30167715771134270.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30171425992175074.4001)
,p_validation_name=>'validate collection name'
,p_validation_sequence=>20
,p_validation=>'P725_COLLECTION_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('El nombre s\00F3lo puede contener caracteres alfanum\00E9ricos y de subrayado "_".')
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(30167715771134270.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30188912775767402.4001)
,p_validation_name=>'P725_ARRAY'
,p_validation_sequence=>30
,p_validation=>'P725_ARRAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe seleccionar una matriz.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(30165701694063969.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549741109138954512.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30071203933226827.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549741206341954513.4001)
,p_event_id=>wwv_flow_api.id(549741109138954512.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00726
begin
wwv_flow_api.create_page(
 p_id=>726.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar Grupo de Aplicaciones'
,p_step_title=>'Crear/Editar Grupo de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91139922499861568)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91042818367932040.4001)
,p_plug_name=>'Grupo de Aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91058306861002658.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(95526603458763922.4001)
,p_name=>'Aplicaciones Asignadas'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="f?p=4000:1:''||:app_session||',
'       ''::::FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE:''||',
'       id||'',''||id||'',''||',
'       ''">''||id||''</a> - ''||wwv_flow_escape.html(f.name) name',
'  from wwv_flow_visible_flows f',
' where group_id = :P726_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and (    :P726_FIND is null',
'         or instr(upper(name),upper(:P726_FIND)) > 0',
'         or instr(id,:P726_FIND) > 0 )'))
,p_display_when_condition=>'select 1 from wwv_flow_application_groups where security_group_id = :flow_security_group_id'
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna aplicaci\00F3n asignada.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>2000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(95527121687764155.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(886496476203981540.4001)
,p_plug_name=>'Grupo de Aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>Para organizar las aplicaciones, as\00EDgnelas a grupos de aplicaciones. Utilice esta p\00E1gina para definir el nombre y la descripci\00F3n de la aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91043425813932041.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(91058306861002658.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:722:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91043206209932041.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(91058306861002658.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P726_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91043115632932041.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(91058306861002658.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P726_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(91043011263932041.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(91058306861002658.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P726_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(91044002139932043.4001)
,p_branch_action=>'f?p=&APP_ID.:722:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91044210601932044.4001)
,p_name=>'P726_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(91042818367932040.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91044430620932055.4001)
,p_name=>'P726_GROUP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(91042818367932040.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre del grupo de aplicaciones.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91044828167932060.4001)
,p_name=>'P726_GROUP_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(91042818367932040.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'GROUP_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una descripci\00F3n para este grupo de aplicaciones.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(91044715805932057.4001)
,p_validation_name=>'P726_GROUP_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P726_GROUP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre de grupo debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(91044430620932055.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91045121219932061.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_03=>'P726_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91370517513741604.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'null deleted group_id'
,p_process_sql_clob=>'update wwv_flows set group_id = null where security_group_id = :flow_security_group_id and group_id = :P726_ID;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error inesperado al procesar grupos de aplicaciones'
,p_process_when_button_id=>wwv_flow_api.id(91043206209932041.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91045305262932062.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_03=>'P726_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_APPLICATION_GROUPS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(91045508955932062.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'726'
,p_process_when_button_id=>wwv_flow_api.id(91043206209932041.4001)
);
end;
/
prompt --application/pages/page_00727
begin
wwv_flow_api.create_page(
 p_id=>727.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Publicar Plantillas'
,p_step_title=>'Publicar Plantillas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94579821771173451.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>121
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94580804933178097.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>131
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94591309182236106.4001)
,p_plug_name=>'Publicar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>41
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las plantillas a las que se han suscrito otras plantillas del espacio de trabajo.</p>'),
unistr('<p>Para publicar el contenido de la plantilla maestra en las plantillas de suscripci\00F3n, seleccione lo que desea publicar y haga clic en <strong>Publicar Selecci\00F3n</strong>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(95255202093864810.4001)
,p_name=>'master template'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>151
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q                        varchar2(32767) := null;',
'    l_page                   varchar2(2000);',
'    l_pages                  varchar2(2000);',
'    l_region                 varchar2(2000);',
'    l_report                 varchar2(2000);',
'    l_list                   varchar2(2000);',
'    l_label                  varchar2(2000);',
'    l_button                 varchar2(2000);',
'    l_menu                   varchar2(2000);',
'    l_calendar               varchar2(2000);',
'    l_popup_lov              varchar2(4000);',
'begin',
'select wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'       wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'       wwv_flow_lang.system_message_lit(''REPORT''),',
'       wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'       wwv_flow_lang.system_message_lit(''LABEL''),',
'       wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'       wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'       wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'       wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'')',
'  into l_page,',
'       l_region,',
'       l_report,',
'       l_list,',
'       l_label,',
'       l_button,',
'       l_menu,',
'       l_calendar,',
'       l_popup_lov',
'  from dual;',
'',
'  if (:P727_SHOW = ''PAGE'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(1,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(name))||''''"'''') ck, '';',
'    q:=q||''''''''||l_page||'''''' type, '';',
'    q:=q||''''''PAGE'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:4307:''''||:flow_session||''''::NO:4307:F4000_P4307_ID:''''||id||''''">''''||wwv_flow_escape.html(name)||''''</a>'''' name, ''; ',
'    q:=q||''(select count(*) from wwv_flow_templates where reference_id = p.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_templates p '';',
'    q:=q||''where p.flow_id = :fb_flow_id '';',
'    q:=q||''and p.security_group_id = :flow_security_group_id '';               ',
'    q:=q||''and (p.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''REGION'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(2,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME))||''''"'''') ck, '';',
'    q:=q||''''''''||l_region||'''''' type, '';',
'    q:=q||''''''REGION'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:4653:''''||:flow_session||''''::NO:4653:F4000_P4653_ID:''''||id||''''">''''||wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME)||''''</a>'''' name, '';',
'    q:=q||''(select count(*) from wwv_flow_page_plug_templates where reference_id = r.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_page_plug_templates r '';',
'    q:=q||''where r.flow_id = :fb_flow_id '';',
'    q:=q||''and r.security_group_id = :flow_security_group_id '';              ',
'    q:=q||''and (r.theme_id = :P727_THEME or :p727_theme = 0) '';                   ',
'  end if;',
'  ',
'  if (:P727_SHOW = ''REPORT'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';',
'    q:=q||''select '';',
'    q:=q||''id, '';    ',
'    q:=q||''wwv_flow_item.checkbox(3,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(ROW_TEMPLATE_NAME))||''''"'''') ck, '';        ',
'    q:=q||''''''''||l_report||'''''' type, '';',
'    q:=q||''''''REPORT'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:4654:''''||:flow_session||''''::NO:4654:F4000_P4654_ID:''''||id||''''">''''||wwv_flow_escape.html(ROW_TEMPLATE_NAME)||''''</a>'''' name, '';      ',
'    q:=q||''(select count(*) from wwv_flow_row_templates where reference_id = ro.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_row_templates ro '';',
'    q:=q||''where ro.flow_id = :fb_flow_id '';',
'    q:=q||''and ro.security_group_id = :flow_security_group_id '';          ',
'    q:=q||''and (ro.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''LIST'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';      ',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(4,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(LIST_TEMPLATE_NAME))||''''"'''') ck, '';',
'    q:=q||''''''''||l_list||'''''' type, '';',
'    q:=q||''''''LIST'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:4655:''''||:flow_session||''''::NO:4655:F4000_P4655_ID:''''||id||''''">''''||wwv_flow_escape.html(LIST_TEMPLATE_NAME)||''''</a>'''' name, '';      ',
'    q:=q||''(select count(*) from wwv_flow_list_templates where reference_id = l.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_list_templates l '';',
'    q:=q||''where l.flow_id = :fb_flow_id '';',
'    q:=q||''and l.security_group_id = :flow_security_group_id '';             ',
'    q:=q||''and (l.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''LABEL'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';      ',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(5,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(TEMPLATE_NAME))||''''"'''') ck, '';',
'    q:=q||''''''''||l_label||'''''' type, '';',
'    q:=q||''''''LABEL'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:85:''''||:flow_session||''''::NO:85:F4000_P85_ID:''''||id||''''">''''||wwv_flow_escape.html(TEMPLATE_NAME)||''''</a>'''' name, '';      ',
'    q:=q||''(select count(*) from wwv_flow_field_templates where reference_id = f.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_field_templates f '';',
'    q:=q||''where f.flow_id = :fb_flow_id '';',
'    q:=q||''and f.security_group_id = :flow_security_group_id '';     ',
'    q :=q||''and (f.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''BUTTON'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';      ',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(6,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(TEMPLATE_NAME))||''''"'''') ck, '';',
'    q:=q||''''''''||l_button||'''''' type, '';',
'    q:=q||''''''BUTTON'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:204:''''||:flow_session||''''::NO:204:F4000_P204_ID:''''||id||''''">''''||wwv_flow_escape.html(TEMPLATE_NAME)||''''</a>'''' name, '';',
'    q:=q||''(select count(*) from wwv_flow_button_templates where reference_id = b.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_button_templates b '';',
'    q:=q||''where b.flow_id = :fb_flow_id '';',
'    q:=q||''and b.security_group_id = :flow_security_group_id '';    ',
'    q:=q||''and (b.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''MENU'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';      ',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(7,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(NAME))||''''"'''') ck, '';',
'    q:=q||''''''''||l_menu||'''''' type, '';',
'    q:=q||''''''MENU'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:289:''''||:flow_session||''''::NO:289:F4000_P289_ID:''''||id||''''">''''||wwv_flow_escape.html(NAME)||''''</a>'''' name, '';      ',
'    q:=q||''(select count(*) from wwv_flow_menu_templates where reference_id = m.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_menu_templates m '';',
'    q:=q||''where m.flow_id = :fb_flow_id '';',
'    q:=q||''and m.security_group_id = :flow_security_group_id '';      ',
'    q:=q||''and (m.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''CALENDAR'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';      ',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(8,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', wwv_flow_escape.html(NAME))||''''"'''') ck, '';',
'    q:=q||''''''''||l_calendar||'''''' type, '';',
'    q:=q||''''''CALENDAR'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:122:''''||:flow_session||''''::NO:122:P122_ID:''''||id||''''">''''||wwv_flow_escape.html(NAME)||''''</a>'''' name, '';      ',
'    q:=q||''(select count(*) from wwv_flow_cal_templates where reference_id = l.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_cal_templates l '';',
'    q:=q||''where l.flow_id = :fb_flow_id '';',
'    q:=q||''and l.security_group_id = :flow_security_group_id '';           ',
'    q:=q||''and (l.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  if (:P727_SHOW = ''POPUP_LOV'') or ',
'     (replace(:P727_SHOW,''0'',null) is null) then',
'    q:=q||''union all '';      ',
'    q:=q||''select '';',
'    q:=q||''id, '';',
'    q:=q||''wwv_flow_item.checkbox(9,id,''''title="''''||wwv_flow_lang.system_message(''''SELECT_ROW_C'''', ''''''||l_popup_lov||'''''')||''''"'''') ck, '';',
'    q:=q||''''''''||l_popup_lov||'''''' type, '';',
'    q:=q||''''''POPUP_LOV'''' rtype, '';',
'    q:=q||''theme_id, '';',
'    q:=q||''''''<a href="f?p=4000:251:''''||:flow_session||''''::NO:251:F4000_P251_ID:''''||id||''''">''||l_popup_lov||''</a>'''' name, '';      ',
'    q:=q||''(select count(*) from wwv_flow_popup_lov_template where reference_id = l.id and security_group_id = :flow_security_group_id) references ''; ',
'    q:=q||''from wwv_flow_popup_lov_template l '';',
'    q:=q||''where l.flow_id = :fb_flow_id '';',
'    q:=q||''and l.security_group_id = :flow_security_group_id '';           ',
'    q:=q||''and (l.theme_id = :P727_THEME or :p727_theme = 0) '';               ',
'  end if;',
'  ',
'  q:=ltrim(q,''union all '');',
'  ',
'  q:=''select x.id, x.ck, x.type, x.rtype, x.theme_id, x.name, x.references from (''||q||'') x '';',
'  q:=q||''where x.references > 0 '';',
'  wwv_flow.debug(''XXX-''||q);',
'  return q;',
'end;'))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay ninguna plantilla disponible para su publicaci\00F3n.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(103296932022736910.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(95272930022939095.4001)
,p_query_column_id=>2
,p_column_alias=>'CK'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(97786124659423013.4001)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(103325312001610914.4001)
,p_query_column_id=>4
,p_column_alias=>'RTYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Rtype'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(103741322462686546.4001)
,p_query_column_id=>5
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Tema'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(103329620406670184.4001)
,p_query_column_id=>6
,p_column_alias=>'NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Plantilla'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(95255827932864817.4001)
,p_query_column_id=>7
,p_column_alias=>'REFERENCES'
,p_column_display_sequence=>6
,p_column_heading=>'Referencias'
,p_column_link=>'f?p=&APP_ID.:651:&SESSION.::&DEBUG.::P651_REFERENCE_ID,P651_TYPE:#ID#,#RTYPE#'
,p_column_linktext=>'#REFERENCES#'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(94588615153218815.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(94580804933178097.4001)
,p_button_name=>'P727_GO'
,p_button_static_id=>'P727_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95285920850974265.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(94580804933178097.4001)
,p_button_name=>'PUBLISH_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Publicar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>'P727_DISPLAY_PUBLISH'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(94588821917218816.4001)
,p_branch_action=>'f?p=&APP_ID.:727:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(94585918139210245.4001)
,p_name=>'P727_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(94580804933178097.4001)
,p_item_default=>'0'
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE TYPES RETURNING NAME'
,p_lov=>'.'||wwv_flow_api.id(282026017647000169.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Tipos -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrinja los resultados seleccionando un tipo de plantilla y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95247531566826047.4001)
,p_name=>'P727_THEME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(94580804933178097.4001)
,p_item_default=>'0'
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tema y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(103695122996100188.4001)
,p_name=>'P727_DISPLAY_PUBLISH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(94580804933178097.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1194417838142758807.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos una plantilla que publicar.'
,p_when_button_pressed=>wwv_flow_api.id(95285920850974265.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1194417497189758803.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(95255202093864810.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1194417513081758804.4001)
,p_event_id=>wwv_flow_api.id(1194417497189758803.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(103608501461864052.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'publish templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- page',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_copy_metadata.push_page_template(p_template_id => wwv_flow.g_f01(i));',
'end loop;',
'-- region',
'for i in 1..wwv_flow.g_f02.count',
'loop',
'  wwv_flow_copy_metadata.push_region_template(p_template_id => wwv_flow.g_f02(i));',
'end loop;',
'-- report',
'for i in 1..wwv_flow.g_f03.count',
'loop',
'  wwv_flow_copy_metadata.push_report_template(p_template_id => wwv_flow.g_f03(i));',
'end loop;',
'-- list',
'for i in 1..wwv_flow.g_f04.count',
'loop',
'  wwv_flow_copy_metadata.push_list_template(p_template_id => wwv_flow.g_f04(i));',
'end loop;',
'-- label',
'for i in 1..wwv_flow.g_f05.count',
'loop',
'  wwv_flow_copy_metadata.push_field_template(p_template_id => wwv_flow.g_f05(i));',
'end loop;',
'-- button',
'for i in 1..wwv_flow.g_f06.count',
'loop',
'  wwv_flow_copy_metadata.push_button_template(p_template_id => wwv_flow.g_f06(i));  ',
'end loop;',
'-- breadcrumb',
'for i in 1..wwv_flow.g_f07.count',
'loop',
'  wwv_flow_copy_metadata.push_menu_template(p_template_id => wwv_flow.g_f07(i));',
'end loop;',
'-- calendar',
'for i in 1..wwv_flow.g_f08.count',
'loop',
'  wwv_flow_copy_metadata.push_calendar_template(p_template_id => wwv_flow.g_f08(i));',
'end loop;',
'-- popup LOV',
'for i in 1..wwv_flow.g_f09.count',
'loop',
'  wwv_flow_copy_metadata.push_popuplov_template(p_template_id => wwv_flow.g_f09(i));  ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al publicar las plantillas seleccionadas.'
,p_process_when_button_id=>wwv_flow_api.id(95285920850974265.4001)
,p_process_success_message=>'Plantillas seleccionadas publicadas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(103697000318131434.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flag for publish button'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_flag  varchar2(255) := ''N'';',
'  l_theme number := nvl(:P727_THEME,0);',
'begin',
'  if replace(:P727_SHOW,''0'',null) is null then',
'    for c1 in (',
'        select 1 from wwv_flow_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_templates',
'                   where security_group_id = :flow_security_group_id)      ',
'        union all',
'        select 1 from wwv_flow_page_plug_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_page_plug_templates',
'                   where security_group_id = :flow_security_group_id)',
'        union all',
'        select 1 from wwv_flow_row_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_row_templates',
'                   where security_group_id = :flow_security_group_id)  ',
'        union all',
'        select 1 from wwv_flow_list_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_list_templates',
'                   where security_group_id = :flow_security_group_id)      ',
'        union all',
'        select 1 from wwv_flow_field_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_field_templates',
'                   where security_group_id = :flow_security_group_id)',
'         union all',
'        select 1 from wwv_flow_button_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_button_templates',
'                   where security_group_id = :flow_security_group_id) ',
'        union all',
'        select 1 from wwv_flow_menu_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_menu_templates',
'                   where security_group_id = :flow_security_group_id)',
'        union all',
'        select 1 from wwv_flow_cal_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_cal_templates',
'                   where security_group_id = :flow_security_group_id)) loop',
'    --',
'        l_flag := ''Y'';',
'    end loop;    ',
'  else',
'    if :P727_SHOW = ''PAGE'' then',
'        for c1 in (select 1 from wwv_flow_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''REGION'' then',
'        for c1 in (select 1 from wwv_flow_page_plug_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_page_plug_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;        ',
'    elsif :P727_SHOW = ''REPORT'' then',
'        for c1 in (select 1 from wwv_flow_row_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_row_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''LIST'' then',
'        for c1 in (select 1 from wwv_flow_list_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_list_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop         ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''LABEL'' then',
'        for c1 in (select 1 from wwv_flow_field_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_field_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''BUTTON'' then',
'        for c1 in (select 1 from wwv_flow_button_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_button_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''MENU'' then',
'        for c1 in (select 1 from wwv_flow_menu_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_menu_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''CALENDAR'' then',
'        for c1 in (select 1 from wwv_flow_cal_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_cal_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;',
'    elsif :P727_SHOW = ''POPUP_LOV'' then',
'        for c1 in (select 1 from wwv_flow_popup_lov_template',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_popup_lov_template',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;        ',
'    end if;    ',
'  end if;',
'  :P727_DISPLAY_PUBLISH := l_flag;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00730
begin
wwv_flow_api.create_page(
 p_id=>730.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla e Informes Basados en Servicio Web: Par\00E1metros de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30098103492544130.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(30219624868893856.4001)
,p_name=>unistr('Par\00E1metros de Resultado a Mostrar')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'',:P730_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where type_is_xsd = ''Y''',
'   and parent_id = :P725_ARRAY'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione los par\00E1metros que se van a incluir en el informe.</p>'),
unistr('<p>Para seleccionar o anular la selecci\00F3n de todos los par\00E1metros, active la casilla de control de la cabecera de columna.</p>'),
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30220326690893876.4001)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30220402743893876.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30298709143154335.4001)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204756604983176009.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30243313187947333.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204756604983176009.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30238010285936991.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204756604983176009.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30235927469932529.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204756604983176009.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30238408044936997.4001)
,p_branch_action=>'f?p=&FLOW_ID.:725:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30238010285936991.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30243718599947334.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'f?p=&FLOW_ID.:735:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30243313187947333.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38828410304413219.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30243313187947333.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30287830427046886.4001)
,p_name=>'P730_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30219624868893856.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_source=>'P725_ARRAY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P725_ARRAYS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifique el \00E1rbol.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30294217445080992.4001)
,p_name=>'P730_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30219624868893856.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30304324343205980.4001)
,p_computation_sequence=>10
,p_computation_item=>'P730_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(38931109545633619.4001)
,p_validation_name=>'P730_CHECKED_ITEMS'
,p_validation_sequence=>10
,p_validation=>'P730_CHECKED_ITEMS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe realizar un informe de al menos un par\00E1metro.')
,p_validation_condition=>'NEXT,FINISH'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(30294217445080992.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549741376379954514.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30235927469932529.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549741437476954515.4001)
,p_event_id=>wwv_flow_api.id(549741376379954514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157780208270618647.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(30219624868893856.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157780392904618648.4001)
,p_event_id=>wwv_flow_api.id(1157780208270618647.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30223816126910289.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00733
begin
wwv_flow_api.create_page(
 p_id=>733.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Estado de Aplicaci\00F3n')
,p_step_title=>unistr('Estado de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_hm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(104385823445160068.4001)
,p_plug_name=>unistr('Estado de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>121
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>unistr('<p>Esta aplicaci\00F3n se ha instalado, pero no se puede editar. Los administradores del espacio de trabajo pueden cambiar el estado de la aplicaci\00F3n mediante las utilidades del espacio de trabajo.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(937789234997878617.4001)
,p_plug_name=>'botones del asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>131
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104398728780246802.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(937789234997878617.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1154362780018168265.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(937789234997878617.4001)
,p_button_name=>'RUN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'&P733_HOME_LINK.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(104389520852197170.4001)
,p_name=>'P733_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(104385823445160068.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero de aplicaci\00F3n actual')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(104396317913234157.4001)
,p_name=>'P733_APPLICATION_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(104385823445160068.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de la Aplicaci\00F3n:')
,p_source=>'select name from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nombre de la aplicaci\00F3n seleccionada')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1154363471558177955.4001)
,p_name=>'P733_HOME_LINK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(104385823445160068.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1154364092879183971.4001)
,p_computation_sequence=>10
,p_computation_item=>'P733_HOME_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_dev.get_run_url (p_application_id => :FB_FLOW_ID )'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(133809402516094387.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unset flow ids'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00734
begin
wwv_flow_api.create_page(
 p_id=>734.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11327922287610512.4001)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(169186610834587350.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11328305829610519.4001)
,p_plug_name=>'Crear Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47256112975729331.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11328524514610520.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47256112975729331.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11328700955610522.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47256112975729331.4001)
,p_button_name=>'create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11328911294610522.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47256112975729331.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11334732433610564.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(574135415655781510.4001)
,p_branch_action=>'f?p=&APP_ID.:464:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(11328911294610522.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11329116792610523.4001)
,p_name=>'P734_DEPLOY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11328305829610519.4001)
,p_prompt=>unistr('\00BFDesea crear regiones de lista?')
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST DEPLOYMENT P529'
,p_lov=>'.'||wwv_flow_api.id(169222400131754330.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si se va a crear una regi\00F3n de lista en la p\00E1gina actual.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11329615065610529.4001)
,p_name=>'P734_REGION_POSITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(11328305829610519.4001)
,p_prompt=>unistr('Posici\00F3n de Regi\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_DISPLAY_POINT'
,p_lov=>'.'||wwv_flow_api.id(131723061838.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Posici\00F3n de Visualizaci\00F3n -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la posici\00F3n de regi\00F3n de la nueva regi\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11330304845610530.4001)
,p_name=>'P734_ENTRY_QUERY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(11328305829610519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta de Lista'
,p_source=>'P464_QUERY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'style="white-space:pre;"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Consulta que se va a utilizar para generar la lista.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11330531923610530.4001)
,p_name=>'P734_LIST_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(11328305829610519.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_list_template from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'and default_list_template is not null) loop',
'',
'   return c1.default_list_template;',
'',
'end loop;',
'',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Lista:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'<div class="htmldbInfoBodyP">Plantilla de lista que se va a utilizar para controlar la apariencia de la lista.</div>'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11331031778610532.4001)
,p_name=>'P734_LIST_NAME2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11328305829610519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Lista'
,p_source=>'&P427_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre de la lista que se va a crear.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11333927013610541.4001)
,p_name=>'P734_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(11328305829610519.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de regi\00F3n para la regi\00F3n nueva.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(184438131566130150.4001)
,p_validation_name=>'Region Position Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'P734_REGION_POSITION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('Se debe seleccionar una posici\00F3n de regi\00F3n.')
,p_validation_condition=>'P734_DEPLOY'
,p_validation_condition2=>'EACH_ENTRY:CURRENT_PAGE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(11328700955610522.4001)
,p_associated_item=>wwv_flow_api.id(11329615065610529.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(12835122215749420.4001)
,p_name=>'List Region Creation Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P734_DEPLOY'
,p_condition_element=>'P734_DEPLOY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CURRENT_PAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12835422514749425.4001)
,p_event_id=>wwv_flow_api.id(12835122215749420.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P734_REGION_POSITION,P734_REGION_TEMPLATE,P734_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12835600998749427.4001)
,p_event_id=>wwv_flow_api.id(12835122215749420.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P734_REGION_POSITION,P734_REGION_TEMPLATE,P734_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574135285411781508.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(11328524514610520.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574135396509781509.4001)
,p_event_id=>wwv_flow_api.id(574135285411781508.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11334921984614841.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create dynamic List'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_list_id        number;',
'   l_required_patch number;',
'   l_target_pages   varchar2(4000);',
'',
'',
'   procedure create_list_region (',
'      p_flow_id       in  number default null,',
'      p_page_id       in varchar2 default null,',
'      p_list_id       in number default null,',
'      p_display_point in varchar2 default null,',
'      p_list_name     in varchar2 default null)',
'   is',
'      l_max_seq number default null;',
'      p number;',
'      l_display_point varchar2(30) := ''REGION_POSITION_01'';',
'      l_region_template  number := null;',
'   begin',
'      if p_page_id is null or p_list_id is null then',
'         return;',
'      end if;',
'      if :P734_REGION_TEMPLATE is not null and :P734_REGION_TEMPLATE != ''0'' then',
'         l_region_template := :P734_REGION_TEMPLATE;',
'      end if;',
'      begin',
'         p := p_page_id;',
'      exception when others then',
'         p := null;',
'      end;',
'      if p is null then ',
'         return;',
'      end if;',
'      if p_display_point is not null and p_display_point != ''0'' then',
'         l_display_point := p_display_point;',
'      end if;',
'           ',
'      select nvl(max(PLUG_DISPLAY_SEQUENCE),0) + 10 into l_max_seq',
'      from wwv_flow_page_plugs ',
'      where flow_id = :fb_flow_id and page_id = p;',
'',
'        if l_max_seq is null then',
'           l_max_seq := 10;',
'        end if;',
'      wwv_flow_api.create_page_plug (',
'        p_id                          => wwv_flow_id.next_val,',
'        p_flow_id                     => p_flow_id,',
'        p_page_id                     => p_page_id,',
'        p_plug_name                   => p_list_name,',
'        p_plug_template               => l_region_template,',
'        p_list_template_id            => :P734_LIST_TEMPLATE_ID,',
'        p_plug_display_sequence       => l_max_seq,',
'        p_plug_display_point          =>l_display_point,',
'        p_plug_source                 => null,',
'        p_plug_source_type            => p_list_id,',
'        p_plug_display_when_condition => null,',
'        p_plug_display_when_cond2     => null,',
'        p_plug_display_condition_type => null,',
'        p_plug_required_role          => null,',
'        p_menu_template_id            => null);',
'   end create_list_region;',
'',
'   ',
'',
'begin',
'    --',
'    -- create list',
'    --',
'    l_list_id := wwv_flow_id.next_val;',
' ',
'',
'    begin',
'        l_required_patch := :P427_REQUIRED_PATCH;',
'    exception when others then ',
'        l_required_patch := null;',
'    end;',
'    ',
'    wwv_flow_api.create_list (',
'            p_id                      => l_list_id,',
'            p_flow_id                 => nv(''FB_FLOW_ID''),',
'            p_name                    => v(''P427_NAME''),',
'            p_list_type               => v(''P464_QUERY_TYPE''),',
'            p_list_query              => v(''P464_QUERY''),',
'            p_list_status             => ''PUBLIC'',',
'            p_required_patch          => l_required_patch);',
'',
'    --',
'    -- create list regions',
'    --',
'    if :P734_DEPLOY = ''CURRENT_PAGE'' then',
'        create_list_region (p_flow_id       => nv(''FB_FLOW_ID''),',
'                            p_page_id       => :fb_flow_page_id, ',
'                            p_list_id       => l_list_id, ',
'                            p_display_point => :P734_REGION_POSITION, ',
'                            p_list_name     => :P427_NAME);',
'    end if;',
'',
'    commit;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la lista din\00E1mica.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(11328700955610522.4001)
,p_process_success_message=>unistr('Lista din\00E1mica creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574135572295781511.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Lista din\00E1mica creada.')
);
end;
/
prompt --application/pages/page_00735
begin
wwv_flow_api.create_page(
 p_id=>735.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla e Informes Basados en Servicio Web: Confirmar'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30075307042239861.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Pantalla e Informe Basados en Servicio Web')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_form_on_ws_rpt (',
'    p_flow_id            => :FB_FLOW_ID,',
'    p_region_template    => replace(:P705_REGION_TEMPLATE,''%''||''null%'',null),',
'    p_region_template2   => replace(:P705_REGION_TEMPLATE2,''%''||''null%'',null),',
'    p_report_template    => replace(:P705_REPORT_TEMPLATE,''%''||''null%'',null),',
'    p_page_id            => :P705_PAGE_ID,',
'    p_page_name          => :P705_PAGE_NAME,',
'    p_region_name        => :P705_REGION_NAME,',
'    p_region_name2       => :P705_REGION_NAME2,',
'    p_ws_id              => :P700_WS_ID,    ',
'    p_operation_id       => :P700_OPERATION_ID,    ',
'    p_collection_name    => nvl(nvl(:P725_COLLECTION_NAME,:P882_COLLECTION),:P848_RESULT_COLLECTION),',
'    p_array              => :P725_ARRAY',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30075701781239865.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204755203813166192.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30076913490239872.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204755203813166192.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30077704485239873.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204755203813166192.4001)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30077323233239873.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204755203813166192.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193723405053133699.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'848'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(30077323233239873.4001)
,p_branch_sequence=>5
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true',
'and :P700_WEB_REF_TYPE = ''MANUAL'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(194249200055831918.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'882'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(30077323233239873.4001)
,p_branch_sequence=>7
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = false',
'and :P700_WEB_REF_TYPE = ''REST'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30079406373239877.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'730'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(30077323233239873.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(38842117156509792.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30077323233239873.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(404572337440870613.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P705_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P705_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(30077704485239873.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549741500110954516.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30076913490239872.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549741605048954517.4001)
,p_event_id=>wwv_flow_api.id(549741500110954516.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30078215150239874.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Form on Web Service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_array_parm varchar2(4000) := null;',
'  l_report_collection_name varchar2(4000) := null;',
'begin',
'  if :P705_IS_REST = ''Y'' then',
'    l_report_collection_name := :P882_COLLECTION;',
'  elsif :P700_WEB_REF_TYPE = ''MANUAL'' then',
'    l_report_collection_name := :P848_RESULT_COLLECTION;',
'  else',
'    l_array_parm := :P725_ARRAY;',
'    l_report_collection_name := :P725_COLLECTION_NAME;',
'  end if;',
'',
'  wwv_flow_wizard_api.create_form_on_ws_rpt (',
'    p_flow_id                  => :FB_FLOW_ID,',
'    p_page_id                  => :P705_PAGE_ID,',
'    p_ws_id                    => :P700_WS_ID,',
'    p_operation_id             => :P700_OPERATION_ID,',
'    p_page_name                => :P705_PAGE_NAME,',
'    p_group_name               => :P705_GROUP_NAME,',
'    p_page_mode                => :P705_PAGE_MODE,',
'    p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'    --',
'    p_tab_set                  => :P4716_TAB_SET,',
'    p_tab_name                 => :P4716_TAB_NAME,',
'    p_tab_text                 => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_result_node              => :P842_NODE_PATH,',
'    p_soap_style               => :P842_SOAP_STYLE,',
'    p_message_format           => :P842_MESSAGE_FORMAT,',
'    p_namespace                => :P842_MESSAGE_NAMESPACE,',
'    --',
'    p_region_title             => :P705_REGION_NAME,',
'    p_region_template          => :P705_REGION_TEMPLATE,    ',
'    p_region_title2            => :P705_REGION_NAME2,',
'    p_region_template2         => :P705_REGION_TEMPLATE2,  ',
'    p_report_template          => :P705_REPORT_TEMPLATE,',
'    p_inputs_collection        => ''WS_INPUT_ITEMS'',',
'    p_auth_collection          => ''WS_AUTH_ITEMS'',',
'    p_array_parm               => l_array_parm,',
'    p_report_collection_name   => l_report_collection_name,',
'    p_array_parms_collection   => ''WS_ARRAY_PARMS'' );',
'',
'  :fb_flow_page_id := :P705_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear la pantalla basada en servicio web.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30077704485239873.4001)
,p_process_success_message=>'La pantalla basada en el servicio web se ha creado correctamente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(122099829969039336.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumb'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :P705_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P705_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => nvl(:P705_BREADCRUMB_NAME, :P705_PAGE_NAME),',
'        p_parent_breadcrumb_entry_id => :P705_BREADCRUMB_PARENT_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30077704485239873.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549741743753954518.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00736
begin
wwv_flow_api.create_page(
 p_id=>736.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Gestionar Asignaciones de Grupos de Aplicaciones'
,p_step_title=>'Gestionar Asignaciones de Grupos de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92250713575351601.4001)
,p_plug_name=>'Finder Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(92255713144370366.4001)
,p_name=>'Aplicaciones'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   apex_item.checkbox2(1,id,null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''ASSIGN_LABEL'',wwv_flow_escape.html(name))) id, ',
'   id app_id,',
'  ''f?p=4000:1:''||:app_session||',
'     ''::''||:DEBUG||',
'    '':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE:''||',
'    f.id||'',''||f.id||'','' link,',
'  name,',
'  owner,',
'  f.LAST_UPDATED_ON,',
'  f.group_id,',
'decode(group_id,null,null,(select max(group_name) n from wwv_flow_application_groups where id = f.group_id)) Groupname,',
'  alias',
'from   wwv_flow_visible_flows f,',
'       (select wwv_flow_lang.system_message(''RUN'') run from dual) sm',
' where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and (   :P736_FIND is null',
'        or instr(upper(name),upper(:P736_FIND)) > 0',
'        or instr(upper(alias),upper(:P736_FIND)) > 0',
'        or instr(id,:P736_FIND) > 0 )',
'   and (   nvl(:P736_GROUP,0) = 0',
'        or group_id = :P736_GROUP',
'        or (group_id is null and nvl(:P736_GROUP,0)=-1))',
'   and (   nvl(:P736_SHOW,''0'')=''0''',
'        or (group_id is null and :P736_SHOW = ''UNASSIGNED'')',
'        or (group_id is not null and :P736_SHOW = ''ASSIGNED''))'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna aplicaci\00F3n.')
,p_query_num_rows_item=>'P736_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256015164370370.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Asignar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92274923805468086.4001)
,p_query_column_id=>2
,p_column_alias=>'APP_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_column_hit_highlight=>'&P736_FIND.'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256130607370371.4001)
,p_query_column_id=>3
,p_column_alias=>'LINK'
,p_column_display_sequence=>2
,p_column_heading=>'Link'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256225634370371.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Nombre de la Aplicaci\00F3n')
,p_column_hit_highlight=>'&P736_FIND.'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256302133370371.4001)
,p_query_column_id=>5
,p_column_alias=>'OWNER'
,p_column_display_sequence=>7
,p_column_heading=>'Propietario'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256422310370371.4001)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>8
,p_column_heading=>'Actualizado'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256522814370371.4001)
,p_query_column_id=>7
,p_column_alias=>'GROUP_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Group ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(92256609920370371.4001)
,p_query_column_id=>8
,p_column_alias=>'GROUPNAME'
,p_column_display_sequence=>6
,p_column_heading=>'Grupo'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(95849815608881641.4001)
,p_query_column_id=>9
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>5
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P736_FIND.'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92315813481644870.4001)
,p_plug_name=>'New Group'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(95832517976778251.4001)
,p_plug_name=>'Grupos de Aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para buscar una aplicaci\00F3n, introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas para el nombre de la aplicaci\00F3n, alias o identificador, seleccione un grupo de aplicaciones o elija que se muestren las aplicaciones asignadas, no asig')
||'nadas o todas y haga clic en <strong>Ir</strong>.</p>',
unistr('<p>Para volver a asignar una aplicaci\00F3n a un nuevo grupo, seleccione el grupo nuevo, seleccione las aplicaciones y haga clic en <strong>Asignar Selecci\00F3n</strong>. Para eliminar una aplicaci\00F3n de un grupo de aplicaciones, seleccione <strong>Anular As')
||unistr('ignaci\00F3n</strong>, seleccione la aplicaci\00F3n y haga clic en <strong>Asignar Selecci\00F3n</strong>.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92254517861362245.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(92250713575351601.4001)
,p_button_name=>'P736_GO'
,p_button_static_id=>'P736_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Definir'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92286728269516607.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(92315813481644870.4001)
,p_button_name=>'ASSIGN_SELECTED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Asignar Selecci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92254732632362246.4001)
,p_branch_action=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92251621540353921.4001)
,p_name=>'P736_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(92250713575351601.4001)
,p_prompt=>unistr('Aplicaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Para buscar una aplicaci\00F3n, introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas del nombre, alias o identificador de la aplicaci\00F3n y haga clic en <strong>Ir</strong>. Para ver todas las aplicaciones, deje el campo en blanco y haga cli')
||'c en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92253308857359677.4001)
,p_name=>'P736_GROUP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(92250713575351601.4001)
,p_prompt=>'Grupo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select group_name, id from wwv_flow_application_groups where security_group_id = :flow_security_group_id order by upper(group_name)'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Reduzca la visualizaci\00F3n seleccionando un grupo de aplicaciones y haciendo clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92262622756392113.4001)
,p_name=>'P736_ROWS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(92250713575351601.4001)
,p_item_default=>'15'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de aplicaciones que desea visualizar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92269803803443316.4001)
,p_name=>'P736_SHOW'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(92250713575351601.4001)
,p_item_default=>'0'
,p_prompt=>'Mostrar'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP GROUPS ASSIGNED UNASSIGNED'
,p_lov=>'.'||wwv_flow_api.id(92271115231446627.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Para filtrar la visualizaci\00F3n, realice una selecci\00F3n y haga clic en <strong>Ir</strong>. Las opciones disponibles incluyen <strong>Todo</strong>, <strong>Asignado</strong> y <strong>No Asignado</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92318613265654258.4001)
,p_name=>'P736_NEW_GROUP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(92315813481644870.4001)
,p_prompt=>'Nuevo Grupo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select group_name, id from wwv_flow_application_groups where security_group_id = :flow_security_group_id order by upper(group_name)'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Anular Asignaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para asignar una aplicaci\00F3n a un grupo:'),
'<ol>',
'<li>En Nuevo Grupo, seleccione un grupo de aplicaciones.</li>',
'<li>Seleccione las aplicaciones que desea asignar.</li>',
unistr('<li>Haga clic en <strong>Asignar Selecci\00F3n</strong>.</li>'),
'</ol>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(94702412176353303.4001)
,p_validation_name=>'Must have selected something'
,p_validation_sequence=>10
,p_validation=>'apex_application.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe realizar una selecci\00F3n para realizar esta acci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(92286728269516607.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(92291905806538512.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'assign checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_id number;',
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        l_id := wwv_flow.g_f01(i);',
'        for c1 in ( select id ',
'                      from wwv_flow_visible_flows f',
'                     where f.id = l_id',
'                       and f.build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') )',
'        loop',
'            if :P736_NEW_GROUP = 0 then',
'                update wwv_flows ',
'                   set group_id = null',
'                 where id = c1.id;',
'            else',
'                update wwv_flows ',
'                   set group_id = :P736_NEW_GROUP ',
'                 where id = c1.id;',
'            end if;',
'        end loop;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error Inesperado'
,p_process_when_button_id=>wwv_flow_api.id(92286728269516607.4001)
,p_process_when=>'P736_NEW_GROUP'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Grupo de aplicaciones asignado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(92257016607371390.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(92254517861362245.4001)
);
end;
/
prompt --application/pages/page_00737
begin
wwv_flow_api.create_page(
 p_id=>737.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Recuentos de Temas por Aplicaci\00F3n')
,p_step_title=>unistr('Recuentos de Temas por Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1311312734739365.4001)
,p_plug_name=>unistr('Valores por Defecto de Plantilla por Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id,',
'       application_name,',
'       theme_count,',
'       (select theme_name||'' - ''||theme_id from wwv_flow_themes where flow_id = x.application_id and theme_id = (select theme_id from wwv_flows where id = x.application_id)) default_theme,',
'(select count(*) from wwv_flow_steps where flow_id = x.application_id) application_pages',
'from',
'(',
'select f.id application_id, ',
'       f.name application_name,',
'       count(*) theme_count',
'  from wwv_flow_visible_flows f,',
'       wwv_flow_themes t',
' where f.id                = t.flow_id',
'   and f.security_group_id = t.security_group_id',
'   and f.build_status      != ''RUN_AND_HIDDEN''',
' group by f.id, ',
'          f.name',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1311413219739365.4001)
,p_name=>'Template Defaults by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1311610011739366.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#APPLICATION_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#APPLICATION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1311723031739367.4001)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la Aplicaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1311902498739367.4001)
,p_db_column_name=>'DEFAULT_THEME'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Tema por Defecto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1312007263739367.4001)
,p_db_column_name=>'APPLICATION_PAGES'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>unistr('P\00E1ginas de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1311814832739367.4001)
,p_db_column_name=>'THEME_COUNT'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Recuento de Temas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702956070640535886.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(139375331345217843.4001)
,p_branch_action=>'f?p=&FLOW_ID.:737:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
end;
/
prompt --application/pages/page_00743
begin
wwv_flow_api.create_page(
 p_id=>743.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Varias Validaciones'
,p_step_title=>'Suprimir Varias Validaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57890309079254724.4001)
,p_name=>'Eliminar Varias Validaciones'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<input type="checkbox" name="f01" id="f01_''||id||''" value="''||id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(VALIDATION_NAME))||''"/>'' c,',
'    VALIDATION_SEQUENCE item_sequence,',
'    VALIDATION_NAME name,',
'    (select name from wwv_flow_step_items where id = ASSOCIATED_ITEM) validate_item,',
'    ( select plug_name',
'        from wwv_flow_page_plugs',
'       where id = v.tabular_form_region_id ) region_name,',
'    associated_column',
'from WWV_FLOW_STEP_VALIDATIONS v',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and ',
'      security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna validaci\00F3n en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57890502294254725.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57890621372254725.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57890725807254725.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57962830568357036.4001)
,p_query_column_id=>4
,p_column_alias=>'VALIDATE_ITEM'
,p_column_display_sequence=>4
,p_column_heading=>'Validar Elemento'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9482305921352598.4001)
,p_query_column_id=>5
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Pantalla Tabular'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(9482531894360168.4001)
,p_query_column_id=>6
,p_column_alias=>'ASSOCIATED_COLUMN'
,p_column_display_sequence=>6
,p_column_heading=>'Validar Columna'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57891007686254725.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57891229469254725.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57893210926254727.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(57891007686254725.4001)
,p_button_name=>'P743_GO'
,p_button_static_id=>'P743_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57892316993254726.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(57891007686254725.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57892100521254726.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(57891007686254725.4001)
,p_button_name=>'REMOVE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Validaciones'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_STEP_VALIDATIONS',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57892521450254726.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(57891007686254725.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57894301637254729.4001)
,p_branch_action=>'f?p=&APP_ID.:743:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57892728387254726.4001)
,p_name=>'P743_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57891007686254725.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57893521131254728.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57893731798254728.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P743_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57893907340254729.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un componente que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(57892100521254726.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157778201707618627.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(57890309079254724.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157778385397618628.4001)
,p_event_id=>wwv_flow_api.id(1157778201707618627.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57894019909254729.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from WWV_FLOW_STEP_VALIDATIONS',
'   where id = to_number(wwv_flow.g_f01(i)) and',
'         flow_id = :fb_flow_id and',
'         flow_step_id = :fb_flow_page_id and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(57892100521254726.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00744
begin
wwv_flow_api.create_page(
 p_id=>744.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Suprimir Varios C\00E1lculos')
,p_step_title=>unistr('Suprimir Varios C\00E1lculos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57939801727326893.4001)
,p_name=>unistr('Seleccione los c\00E1lculos que desea eliminar')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<input type="checkbox" name="f01" id="f01_''||id||''" value="''||id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(COMPUTATION_ITEM))||''"/>'' c,',
'    COMPUTATION_SEQUENCE item_sequence,',
'    COMPUTATION_ITEM name,',
'    COMPUTATION_POINT computation_point',
'from WWV_FLOW_STEP_COMPUTATIONS',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and ',
'      security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn c\00E1lculo en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57940013761326893.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57940104374326893.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57940229953326894.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57953910697341835.4001)
,p_query_column_id=>4
,p_column_alias=>'COMPUTATION_POINT'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Punto de C\00E1lculo')
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(62981024179015035)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57940500729326894.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57940727255326894.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57942200567326895.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(57940500729326894.4001)
,p_button_name=>'P744_GO'
,p_button_static_id=>'P744_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57941308009326894.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(57940500729326894.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57941102697326894.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(57940500729326894.4001)
,p_button_name=>'REMOVE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Eliminar C\00E1lculos')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_step_computations',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57941528227326895.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(57940500729326894.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57943310768326896.4001)
,p_branch_action=>'f?p=&APP_ID.:744:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57941732191326895.4001)
,p_name=>'P744_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57940500729326894.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57942515220326896.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57942721188326896.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P744_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57942916376326896.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un elemento que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(57941102697326894.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157778433268618629.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(57939801727326893.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157778577720618630.4001)
,p_event_id=>wwv_flow_api.id(1157778433268618629.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57943018607326896.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple computations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from WWV_FLOW_STEP_COMPUTATIONS',
'   where id = to_number(wwv_flow.g_f01(i)) and',
'         flow_id = :fb_flow_id and',
'         flow_step_id = :fb_flow_page_id and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(57941102697326894.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00745
begin
wwv_flow_api.create_page(
 p_id=>745.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Varios Procesos'
,p_step_title=>'Suprimir Varios Procesos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57974601364373621.4001)
,p_name=>'Seleccione los procesos que desea eliminar'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<input type="checkbox" name="f01" id="f01_''||id||''" value="''||id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(process_name))||''"/>'' c,',
'    PROCESS_SEQUENCE item_sequence,',
'    PROCESS_NAME name,',
'    PROCESS_POINT process_point',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and ',
'      security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn proceso en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57974804707373621.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57974901203373622.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57975002831373622.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Proceso'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57986706504387971.4001)
,p_query_column_id=>4
,p_column_alias=>'PROCESS_POINT'
,p_column_display_sequence=>4
,p_column_heading=>'Punto de Proceso'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(842344044)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57975305121373622.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57975520501373622.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57977527350373624.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(57975305121373622.4001)
,p_button_name=>'P745_GO'
,p_button_static_id=>'P745_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57976610515373623.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(57975305121373622.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57976420579373623.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(57975305121373622.4001)
,p_button_name=>'REMOVE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Procesos'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57976800945373623.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(57975305121373622.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57978620541373625.4001)
,p_branch_action=>'f?p=&APP_ID.:745:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57977029003373623.4001)
,p_name=>'P745_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57975305121373622.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57977813245373624.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57978005409373624.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P745_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57978201995373624.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un componente que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(57976420579373623.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157778691787618631.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(57974601364373621.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157778711261618632.4001)
,p_event_id=>wwv_flow_api.id(1157778691787618631.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57978320881373625.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple buttons'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from WWV_FLOW_STEP_PROCESSING',
'   where id = to_number(wwv_flow.g_f01(i)) and',
'         flow_id = :fb_flow_id and',
'         flow_step_id = :fb_flow_page_id and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(57976420579373623.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00746
begin
wwv_flow_api.create_page(
 p_id=>746.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Varias Bifurcaciones'
,p_step_title=>'Suprimir Varias Bifurcaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57993700486396506.4001)
,p_name=>'Seleccione las ramas que desea eliminar'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<input type="checkbox" name="f01" id="f01_''||id||''" value="''||id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', coalesce(wwv_flow_escape.html(branch_name), wwv_flow_escape.html(BRANCH_SEQUENCE)))||''"/>'' c,',
'    BRANCH_SEQUENCE item_sequence,',
'    branch_name,',
'    BRANCH_ACTION,',
'    BRANCH_POINT',
'from WWV_FLOW_STEP_BRANCHES',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and',
'      security_group_id = :flow_security_group_id',
'order by branch_point, branch_sequence, id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No se ha definido ninguna bifurcaci\00F3n en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_csv_output=>'N'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57993928708396506.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57994011965396506.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16749603104243261.4001)
,p_query_column_id=>3
,p_column_alias=>'BRANCH_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16749815487265750.4001)
,p_query_column_id=>4
,p_column_alias=>'BRANCH_ACTION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Acci\00F3n')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58009319514412190.4001)
,p_query_column_id=>5
,p_column_alias=>'BRANCH_POINT'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Punto de Bifurcaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(179397725241870240)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57994322954396506.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57994525388396506.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(11286824340344465.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57996323383396508.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(57994322954396506.4001)
,p_button_name=>'P746_GO'
,p_button_static_id=>'P746_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57995418517396507.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(57994322954396506.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57995217491396507.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(57994322954396506.4001)
,p_button_name=>'REMOVE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Bifurcaciones'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_STEP_BRANCHES',
'where flow_id = :fb_flow_id and ',
'      flow_step_id = :fb_flow_page_id and',
'      security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57995621614396507.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(57994322954396506.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57997405112396509.4001)
,p_branch_action=>'f?p=&APP_ID.:746:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57995809976396508.4001)
,p_name=>'P746_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57994322954396506.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57996602568396508.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57996815143396509.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P746_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57997021217396509.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un componente que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(57995217491396507.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157778862794618633.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(57993700486396506.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157778926180618634.4001)
,p_event_id=>wwv_flow_api.id(1157778862794618633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57997108765396509.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple branches'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from WWV_FLOW_STEP_BRANCHES',
'   where id = to_number(wwv_flow.g_f01(i)) and',
'         flow_id = :fb_flow_id and',
'         flow_step_id = :fb_flow_page_id and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(57995217491396507.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00747
begin
wwv_flow_api.create_page(
 p_id=>747.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Varias Regiones'
,p_step_title=>'Suprimir Varias Regiones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(58016928470431041.4001)
,p_name=>'Seleccione las regiones que desea eliminar'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    ''<label for="f01_''||id||''" title="Delete"><input type="checkbox" name="f01" id="f01_''||id||''" value="''||id||''"/></label>'' c,',
'    PLUG_DISPLAY_SEQUENCE item_sequence,',
'    PLUG_NAME name,',
'    (select count(*) from wwv_flow_step_items ',
'     where item_plug_id = r.id) ',
'    items,',
'    (select count(*) from wwv_flow_step_buttons where BUTTON_PLUG_ID = r.id)',
'    buttons',
'from WWV_FLOW_PAGE_PLUGS r',
'where flow_id = :fb_flow_id and ',
'      page_id = :fb_flow_page_id and ',
'      security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna regi\00F3n en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_output_show_link=>'Y'
,p_prn_units=>'POINTS'
,p_prn_paper_size=>'CUSTOM'
,p_prn_orientation=>'VERTICAL'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58017103895431041.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
,p_print_col_align=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58017218857431041.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
,p_print_col_align=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58017322977431041.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la Regi\00F3n')
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
,p_print_col_align=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58026912139446366.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEMS'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Elementos de Regi\00F3n')
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
,p_print_col_align=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58027011294446366.4001)
,p_query_column_id=>5
,p_column_alias=>'BUTTONS'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Botones de Regi\00F3n')
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
,p_print_col_align=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58017525351431041.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58017728601431041.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58665524144692049.4001)
,p_plug_name=>'Button Bar 2'
,p_region_template_options=>'#DEFAULT#:a-Form--leftLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(58019502037431043.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(58017525351431041.4001)
,p_button_name=>'P747_GO'
,p_button_static_id=>'P747_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(58018628002431042.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(58017525351431041.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(58018427920431042.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(58017525351431041.4001)
,p_button_name=>'REMOVE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar Regiones'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plugs',
'where flow_id = :fb_flow_id and ',
'      page_id = :fb_flow_page_id'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(58018815298431042.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(58017525351431041.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(58020627001431044.4001)
,p_branch_action=>'f?p=&APP_ID.:747:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58019030593431043.4001)
,p_name=>'P747_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(58017525351431041.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58029230839451776.4001)
,p_name=>'P747_CASCADE_BUTTONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(58665524144692049.4001)
,p_item_default=>'N'
,p_prompt=>'Suprimir Botones en Cascada'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si selecciona <strong>Activado</strong> tambi\00E9n se suprimir\00E1n los botones de regi\00F3n correspondientes.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58029432416451776.4001)
,p_name=>'P747_CASCADE_ITEMS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(58665524144692049.4001)
,p_item_default=>'N'
,p_prompt=>'Suprimir Elementos en Cascada'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si selecciona <strong>Activado</strong> tambi\00E9n se suprimir\00E1n los elementos de regi\00F3n correspondientes.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170999104157903673.4001)
,p_name=>'P747_CASCADE_TO_LISTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(58665524144692049.4001)
,p_item_default=>'N'
,p_prompt=>unistr('\00BFSuprimir lista asociada y entradas de lista?')
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si tambi\00E9n desea suprimir las listas de regiones correspondientes. Esta opci\00F3n para suprimir la lista correspondiente y las entradas de lista s\00F3lo se proporciona cuando la regi\00F3n que se va a suprimir es la \00FAnica a la que hace referencia la')
||' lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176775922565303872.4001)
,p_name=>'P747_CASCADE_DYN_ACTIONS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(58665524144692049.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Suprimir Acciones Din\00E1micas en Cascada')
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si selecciona <strong>Activado</strong> tambi\00E9n se suprimir\00E1n los elementos de regi\00F3n correspondientes.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(58019808160431043.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(58020021867431044.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P747_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58020215269431044.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un componente que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(58018427920431042.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(58020325403431044.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        wwv_flow_wizard_api.delete_region (',
'            p_region_id          => to_number(wwv_flow.g_f01(i)),',
'            p_flow_id            => :FB_FLOW_ID,',
'            p_page_id            => :FB_FLOW_PAGE_ID,',
'            p_security_group_id  => :FLOW_SECURITY_GROUP_ID,',
'            p_delete_buttons     => (nvl(:P747_CASCADE_BUTTONS,     ''N'') = ''Y''),',
'            p_delete_items       => (nvl(:P747_CASCADE_ITEMS,       ''N'') = ''Y''),',
'            p_delete_sub_regions => false,',
'            p_delete_lists       => (nvl(:P747_CASCADE_TO_LISTS,    ''N'') = ''Y''),',
'            p_delete_dyn_actions => (nvl(:P747_CASCADE_DYN_ACTIONS, ''N'') = ''Y'') );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido suprimir las regiones.'
,p_process_when_button_id=>wwv_flow_api.id(58018427920431042.4001)
,p_process_success_message=>'Regiones suprimidas.'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00748
begin
wwv_flow_api.create_page(
 p_id=>748.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Depurar Depuraci\00F3n')
,p_step_title=>unistr('Depurar Depuraci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(624017424320959563.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(624022903012982746.4001)
,p_plug_name=>unistr('Depurar Datos de Mensaje de Depuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(624022717079977350.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(624017424320959563.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Depurar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(624017621421959564.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(624017424320959563.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(624022016854959581.4001)
,p_branch_action=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624018203447959566.4001)
,p_name=>'P748_PAGE_VIEW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(624022903012982746.4001)
,p_prompt=>'Identificador de Vista'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>12
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el identificador de vista de p\00E1gina del mensaje de depuraci\00F3n. Los identificadores de vista se indican en la p\00E1gina de depuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624025112540023370.4001)
,p_name=>'P748_PURGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(624022903012982746.4001)
,p_item_default=>'ALL'
,p_prompt=>unistr('Opci\00F3n de Depuraci\00F3n:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PURGE_DEBUG_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(624047408693069523.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la opci\00F3n apropiada para depurar los datos de mensajes de depuraci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624025606353049983.4001)
,p_name=>'P748_AGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(624022903012982746.4001)
,p_item_default=>'1'
,p_prompt=>'Anterior a'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PURGE_DEBUG_AGE'
,p_lov=>'.'||wwv_flow_api.id(624059001579304056.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de d\00EDas o semanas de datos de mensajes de depuraci\00F3n que desea depurar para la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(624051020168101221.4001)
,p_validation_name=>'P748_PAGE_VIEW_ID'
,p_validation_sequence=>20
,p_validation=>'P748_PAGE_VIEW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P748_PURGE_OPTION'
,p_validation_condition2=>'IDENTIFIER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(624022717079977350.4001)
,p_associated_item=>wwv_flow_api.id(624018203447959566.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(624028804406058827.4001)
,p_name=>'Hide options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P748_PURGE_OPTION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(624029129584058828.4001)
,p_event_id=>wwv_flow_api.id(624028804406058827.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_AGE,P748_PAGE_VIEW_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(624046026916065410.4001)
,p_name=>'Show Age'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P748_PURGE_OPTION'
,p_condition_element=>'P748_PURGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(624046315566065411.4001)
,p_event_id=>wwv_flow_api.id(624046026916065410.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_AGE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(624046522941065412.4001)
,p_event_id=>wwv_flow_api.id(624046026916065410.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_AGE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(624049628563084744.4001)
,p_name=>'Show Identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P748_PURGE_OPTION'
,p_condition_element=>'P748_PURGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'IDENTIFIER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(624049906496084745.4001)
,p_event_id=>wwv_flow_api.id(624049628563084744.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_PAGE_VIEW_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(624050131052084745.4001)
,p_event_id=>wwv_flow_api.id(624049628563084744.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_PAGE_VIEW_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(624054125755131221.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF :P748_PURGE_OPTION = ''ALL'' THEN',
'    wwv_flow_debug.remove_debug_by_app(p_application_id => :FB_FLOW_ID);',
'  ELSIF :P748_PURGE_OPTION = ''SESSION'' THEN',
'    wwv_flow_debug.remove_session_messages(p_session => :FLOW_SESSION_ID);',
'  ELSIF :P748_PURGE_OPTION = ''AGE'' THEN',
'    wwv_flow_debug.remove_debug_by_age(  p_application_id => :FB_FLOW_ID',
'                                       , p_older_than_days => :P748_AGE);',
'  ELSIF :P748_PURGE_OPTION = ''IDENTIFIER'' THEN',
'    wwv_flow_debug.remove_debug_by_view(  p_application_id => :FB_FLOW_ID',
'                                        , p_view_id => :P748_PAGE_VIEW_ID);',
'  END IF; ',
'END;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00751
begin
wwv_flow_api.create_page(
 p_id=>751.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Gr\00E1fico: Tipo de Gr\00E1fico')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Gr\00E1fico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5131626840158646)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27034725694935254.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1192927752498551.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27748917883013242.4001)
,p_plug_name=>unistr('Crear Gr\00E1fico')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44422412600758339.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27873913869974411.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44422412600758339.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27874329799979051.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(44422412600758339.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279433910337248906.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(44422412600758339.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16672330775497767.4001)
,p_branch_name=>'JET Chart'
,p_branch_action=>'f?p=&APP_ID.:616:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(27874329799979051.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P751_CHART_ENGINE = ''JET_CHART'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27045602483935321.4001)
,p_branch_name=>'Go To Page 751'
,p_branch_action=>'f?p=&APP_ID.:751:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548167215575508186.4001)
,p_branch_name=>'Go To Page 259'
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279433910337248906.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(246501370173305801.4001)
,p_name=>'P751_CHART_ENGINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(27748917883013242.4001)
,p_item_default=>'JET_CHART'
,p_source=>'JET_CHART'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(246501648064305804.4001)
,p_name=>'P751_JET_CHART_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(27748917883013242.4001)
,p_item_default=>'bar'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_api.id(246508417548358609.4001)||'.'
,p_lov_cascade_parent_items=>'P751_CHART_ENGINE'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548166545068506557.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(27873913869974411.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548166819330506558.4001)
,p_event_id=>wwv_flow_api.id(548166545068506557.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00756
begin
wwv_flow_api.create_page(
 p_id=>756.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Tema de Espacio de Trabajo'
,p_page_mode=>'MODAL'
,p_step_title=>'Editar Tema de Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_themes_public.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(136594104464406175.4001)
,p_plug_name=>'Tema de Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(231659227043936677.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747145339825138170.4001)
,p_plug_name=>'Editar Tema de Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(136594628781406177.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(231659227043936677.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(136594327822406176.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(231659227043936677.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P756_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(136594408964406176.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(231659227043936677.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P756_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1429075666603875902.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(231659227043936677.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Tema'
,p_button_position=>'EDIT'
,p_button_condition=>'P756_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(136595100102406181.4001)
,p_branch_name=>'Go To Page 763'
,p_branch_action=>'f?p=&APP_ID.:763:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1429075814189875904.4001)
,p_branch_name=>'Refresh'
,p_branch_action=>'f?p=&APP_ID.:756:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1429075666603875902.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136595322825406182.4001)
,p_name=>'P756_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136595528231406195.4001)
,p_name=>'P756_THEME_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador de Tema del Espacio de Trabajo'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136595900066406196.4001)
,p_name=>'P756_THEME_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Tema del Espacio de Trabajo'
,p_source=>'THEME_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el tema del espacio de trabajo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136596300441406198.4001)
,p_name=>'P756_THEME_DESCRIPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'THEME_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Descripci\00F3n breve del tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1429075997513875905.4001)
,p_name=>'P756_MASTER_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema Maestro'
,p_source=>'select theme_id || '' - '' || theme_name from wwv_flow_themes where id = :P756_REFERENCE_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P756_REFERENCE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1814103094910228111.4001)
,p_name=>'P756_REFERENCE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1815997288324671101.4001)
,p_name=>'P756_MASTER_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(136594104464406175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n Maestra')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id || '' - '' || f.name ',
'from wwv_flow_themes t, wwv_flows f ',
'where t.id = :P756_REFERENCE_ID',
'and t.flow_id = f.id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P756_REFERENCE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(136595826300406196.4001)
,p_validation_name=>'P756_THEME_ID not null'
,p_validation_sequence=>10
,p_validation=>'P756_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El identificador de tema debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(136595528231406195.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(136596219162406197.4001)
,p_validation_name=>'P756_THEME_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P756_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre de tema debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(136595900066406196.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(887629385220273328.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(136594628781406177.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(887629454425273329.4001)
,p_event_id=>wwv_flow_api.id(887629385220273328.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1815997320922671102.4001)
,p_name=>'Submit Refresh'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1429075666603875902.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1815997468500671103.4001)
,p_event_id=>wwv_flow_api.id(1815997320922671102.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(136596620130406198.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P756_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(136604929183422809.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'apply changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.change_workspace_theme (',
'   p_id               => :p756_ID,',
'   p_theme_name       => :P756_THEME_NAME,',
'   p_theme_number     => :P756_THEME_ID,',
'   p_theme_desc       => :P756_THEME_DESCRIPTION);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(136594327822406176.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(136632316865580069.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.delete_workspace_theme (',
'p_id=>:P756_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(136594408964406176.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1429075777767875903.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P756_REFERENCE_ID,',
'    p_subscribing_theme_id => :P756_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar el tema'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1429075666603875902.4001)
,p_process_success_message=>'Tema refrescado'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(887629292092273327.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
end;
/
prompt --application/pages/page_00759
begin
wwv_flow_api.create_page(
 p_id=>759.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(".ui-dialog--apex .ui-dialog-title").text($v("P759_REPORT_TITLE"));'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44390123981733271.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92704600017846940.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92838415529885430.4001)
,p_plug_name=>unistr('navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92836304316872750.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92706216163846947.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44390123981733271.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92706428338846949.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44390123981733271.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(573462085456480668.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(44390123981733271.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92712704681846963.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(92706428338846949.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92712924306846964.4001)
,p_branch_name=>'Breadcrumb Selection'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P759_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2230793669834415.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:759,4700::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(573462085456480668.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P759_REPORT_TYPE'
,p_branch_condition_text=>'MAP_REGION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(573461554244478538.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'4700'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(573462085456480668.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45248916207599281.4001)
,p_name=>'P759_PAGE_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>' :P4700_SELECT_REPORT_TYPE not in ( ''FACETED_SEARCH'', ''SMART_FILTERS'' )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92706609822846949.4001)
,p_name=>'P759_PAGE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P759_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina.<p />'),
'',
unistr('Si identifica un n\00FAmero de p\00E1gina existente, el asistente agrega el componente a esa p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92707119545846952.4001)
,p_name=>'P759_PAGE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92707618796846953.4001)
,p_name=>'P759_FLOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92708116627846953.4001)
,p_name=>'P759_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92708618504846954.4001)
,p_name=>'P759_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P759_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211132023275312611.4001)
,p_name=>'P759_REPORT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_item_default=>'INTERACTIVE'
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CREATE_PAGE_WIZ_REPORT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(229526604906633214.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253076828128538027.4001)
,p_name=>'P759_REPORT_TITLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381538927206153789.4001)
,p_name=>'P759_BREADCRUMB_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P759_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P759_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P759_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403490885667351046.4001)
,p_name=>'P759_GROUP_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(92704600017846940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. '),
unistr('  Los grupos de p\00E1ginas ayudan a los desarrolladores a identificar y gestionar las p\00E1ginas en una aplicaci\00F3n.</p>'),
unistr('<p>Nota: Para crear grupos de p\00E1ginas, vaya a <strong>Utilidades: Grupos de p\00E1ginas</strong> en Utilidades espec\00EDficas de p\00E1gina en la barra lateral derecha.</p>'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940930769336683734.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P759_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(427932604455364939.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(253076931760538028.4001)
,p_computation_sequence=>20
,p_computation_item=>'P759_REPORT_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_title varchar(255);',
'begin',
'  if :P4700_SELECT_REPORT_TYPE = ''INTERACTIVE'' then   ',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.INTERACTIVE'');',
'  elsif :P4700_SELECT_REPORT_TYPE in (''GRID'',''EDITABLE_GRID'') then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.GRID'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''CLASSIC'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.CLASSIC'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''WEBSERVICE'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.WEBSERVICE'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''FACETED_SEARCH'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.FACETED_SEARCH'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''CARD'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.CARDS'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''MAP_REGION'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.MAP_REGION'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''SMART_FILTERS'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.SMART_FILTERS'');',
'  else',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.REPORT'');',
'  end if;',
'  return l_title;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(721860869980555234.4001)
,p_computation_sequence=>30
,p_computation_item=>'P759_PAGE_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_page_dev.get_page_mode(p_application_id => :FB_FLOW_ID, p_page_id => :P759_PAGE_ID);'
,p_compute_when=>'P759_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(92711920286846960.4001)
,p_validation_name=>'Page ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P759_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(92706609822846949.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(92712130932846961.4001)
,p_validation_name=>'Page Name Not Null'
,p_validation_sequence=>20
,p_validation=>'P759_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_validation_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and id = :P759_PAGE_ID'
,p_validation_condition_type=>'NOT_EXISTS'
,p_associated_item=>wwv_flow_api.id(92707119545846952.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'Only verify page names for new pages.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(92712320077846961.4001)
,p_validation_name=>'P759_BREADCRUMB_NAME'
,p_validation_sequence=>30
,p_validation=>'P759_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P759_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(92706428338846949.4001)
,p_associated_item=>wwv_flow_api.id(92708618504846954.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(481362002157042306.4001)
,p_validation_name=>'P759_PAGE_ID positive, whole number'
,p_validation_sequence=>70
,p_validation=>'trunc(abs(:P759_PAGE_ID)) = :P759_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(92706428338846949.4001)
,p_associated_item=>wwv_flow_api.id(92706609822846949.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403491318436353486.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P759_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P759_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(92706428338846949.4001)
,p_associated_item=>wwv_flow_api.id(403490885667351046.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381544407876249072.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P759_BREADCRUMB_ID'
,p_condition_element=>'P759_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381544708425249076.4001)
,p_event_id=>wwv_flow_api.id(381544407876249072.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_BREADCRUMB_PARENT_ID,P759_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381544997823249080.4001)
,p_event_id=>wwv_flow_api.id(381544407876249072.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_BREADCRUMB_PARENT_ID,P759_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549742250903954523.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(92706216163846947.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549742334719954524.4001)
,p_event_id=>wwv_flow_api.id(549742250903954523.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(721860922904555235.4001)
,p_name=>'Page Exists'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P759_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721861042833555236.4001)
,p_event_id=>wwv_flow_api.id(721860922904555235.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_PAGE_MODE,P759_GROUP_NAME,P759_PAGE_NAME,P759_BREADCRUMB_ID,P759_BREADCRUMB_PARENT_ID,P759_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651390457588654203.4001)
,p_name=>'set breadcrumb name'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P759_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651390513563654204.4001)
,p_event_id=>wwv_flow_api.id(651390457588654203.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P759_PAGE_NAME'
,p_attribute_07=>'P759_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00762
begin
wwv_flow_api.create_page(
 p_id=>762.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Tema de Espacio de Trabajo'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Tema de Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(113748409598274541)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes_public.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113593917826945781.4001)
,p_plug_name=>'Crear Tema de Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114836329343856450.4001)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114829600122838504.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208150609528655110.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113595526830948373.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208150609528655110.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113595911048948373.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208150609528655110.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Tema de Espacio de Trabajo'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114803003922764001.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208150609528655110.4001)
,p_button_name=>'REPLACE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sustituir Tema de Espacio de Trabajo'
,p_button_position=>'CREATE'
,p_button_condition=>'P753_CREATE_OR_REPLACE'
,p_button_condition2=>'REPLACE'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113595710630948373.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208150609528655110.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114771108321632793.4001)
,p_branch_name=>'Go To Page 260'
,p_branch_action=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114743605495527921.4001)
,p_name=>'P762_THEME_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(113593917826945781.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre del Tema:'
,p_source=>'&P789_THEME_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre del tema del espacio de trabajo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114744410689529384.4001)
,p_name=>'P762_THEME_NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(113593917826945781.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('N\00FAmero de Tema:')
,p_source=>'&P789_THEME_NUMBER.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero del tema del espacio de trabajo. Estos n\00FAmeros se utilizan para identificar un tema del espacio de trabajo como \00FAnico.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114769930700629816.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create workspace theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.create_new_workspace_theme (',
'   p_app_id           => :P764_FLOW_ID,',
'   p_app_theme_id     => :P764_THEME,',
'   p_theme_name       => :P789_THEME_NAME,',
'   p_theme_number     => :P789_THEME_NUMBER,',
'   p_theme_desc       => :P789_DESCRIPTION,',
'   p_subscribe_theme  => :P764_SUBSCRIBE_THEME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_when_button_id=>wwv_flow_api.id(113595911048948373.4001)
,p_process_success_message=>'Tema de espacio de trabajo creado'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(755296096860836826.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(113595911048948373.4001)
);
end;
/
prompt --application/pages/page_00763
begin
wwv_flow_api.create_page(
 p_id=>763.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Temas de Espacio de Trabajo'
,p_step_title=>'Temas de Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes_public.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113759102026300755.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los temas del espacio de trabajo permiten que se agreguen al repositorio de temas. Est\00E1n disponibles al crear una aplicaci\00F3n o al crear un tema para una aplicaci\00F3n existente.</p>'),
unistr('<p>Para crear un tema de espacio de trabajo, seleccione el tema de una aplicaci\00F3n. Cuando est\00E9 creado no se podr\00E1 editar directamente. Para editarlo, cree una aplicaci\00F3n basada en el tema, edite el tema en esa aplicaci\00F3n y, a continuaci\00F3n, puede crea')
||unistr('r un nuevo tema del espacio de trabajo con el tema de aplicaci\00F3n actualizado (y suprimir el antiguo si ya no le interesa).</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(480600119537691519.4001)
,p_plug_name=>'Temas de Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P763a */',
'       t.id,',
'       t.theme_id,',
'       t.theme_name,',
'       ''<img src="''||decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||id||''&''||',
'         ''p_app_id=''||flow_id)||''" width="150" height="80" alt="" />''',
'       theme_image,',
'       t.theme_description,',
'       t.flow_id application_id,',
'       (select count(*) from wwv_flow_templates where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) page_templates,',
'       (select count(*) from WWV_FLOW_BUTTON_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) button_templates,',
'       (select count(*) from WWV_FLOW_CAL_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) calendar_templates,',
'       (select count(*) from WWV_FLOW_FIELD_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) label_templates,',
'       (select count(*) from WWV_FLOW_LIST_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) list_templates,',
'       (select count(*) from WWV_FLOW_MENU_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) breadcrumb_templates,',
'       (select count(*) from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) region_templates,',
'       (select count(*) from WWV_FLOW_ROW_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) report_templates,',
'       (select count(*) from WWV_FLOW_POPUP_LOV_TEMPLATE where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) POPUP_LOV_template,',
'       decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||t.id||''&''||',
'         ''p_app_id=''||t.flow_id)',
'         img,',
'       t.theme_name img_alt,',
'       ''f?p=4000:756:''||:app_session||''::::P756_ID:''|| t.id img_url,',
'       t.theme_name||'' - ''||t.theme_id img_name',
'  from wwv_flow_themes t,',
'       (select v(''IMAGE_PREFIX'') ip from dual) m',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(480600211834691519.4001)
,p_name=>'Workspace Themes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'IMG_URL'
,p_icon_view_img_src_column=>'IMG'
,p_icon_view_label_column=>'IMG_NAME'
,p_icon_view_alt_text=>'#IMG_ALT#'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480600517421691535.4001)
,p_db_column_name=>'THEME_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>unistr('N\00FAmero')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480600623697691536.4001)
,p_db_column_name=>'THEME_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:756:&SESSION.::&DEBUG.::P756_ID:#ID#'
,p_column_linktext=>'#THEME_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480600719859691537.4001)
,p_db_column_name=>'THEME_IMAGE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480600809657691538.4001)
,p_db_column_name=>'THEME_DESCRIPTION'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480600913607691539.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601010400691540.4001)
,p_db_column_name=>'PAGE_TEMPLATES'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>unistr('Plantillas de<br />P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601104779691542.4001)
,p_db_column_name=>'BUTTON_TEMPLATES'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('Plantillas de<br />Bot\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601230102691543.4001)
,p_db_column_name=>'CALENDAR_TEMPLATES'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Plantillas de<br />Calendario'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601311245691544.4001)
,p_db_column_name=>'LABEL_TEMPLATES'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Plantillas de<br />Etiqueta'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601424800691545.4001)
,p_db_column_name=>'LIST_TEMPLATES'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Plantillas de<br />Lista'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601504350691546.4001)
,p_db_column_name=>'BREADCRUMB_TEMPLATES'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Plantillas de <br />Ruta de Navegaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601606392691547.4001)
,p_db_column_name=>'REGION_TEMPLATES'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>unistr('Plantillas de<br />Regi\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601723540691548.4001)
,p_db_column_name=>'REPORT_TEMPLATES'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>'Plantillas de<br />Informe'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601803967691549.4001)
,p_db_column_name=>'POPUP_LOV_TEMPLATE'
,p_display_order=>14
,p_column_identifier=>'O'
,p_column_label=>'Plantilla de Lista<br />de Valores Emergente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480600408568691534.4001)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480601910183691550.4001)
,p_db_column_name=>'IMG'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480602023059691551.4001)
,p_db_column_name=>'IMG_ALT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Imagen Alternativa'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480602115440691552.4001)
,p_db_column_name=>'IMG_URL'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'URL de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480602212105691553.4001)
,p_db_column_name=>'IMG_NAME'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Nombre de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(574351452965630549.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(702957276965571301.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(480600119537691519.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Tema de Espacio de Trabajo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.:RP,764,789,762:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(116367203339505930.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'763'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(887628962065273324.4001)
,p_name=>'WS Theme Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(480600119537691519.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(887629038218273325.4001)
,p_event_id=>wwv_flow_api.id(887628962065273324.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(480600119537691519.4001)
);
end;
/
prompt --application/pages/page_00764
begin
wwv_flow_api.create_page(
 p_id=>764.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Tema de Espacio de Trabajo: Identificar Tema'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Tema de Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(113748409598274541)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_themes_public.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113640016491074142.4001)
,p_plug_name=>'Crear Tema de Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Seleccione el tema de la aplicaci\00F3n que desea crear en el repositorio de temas del espacio de trabajo.<p/>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114833708218850374.4001)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114829600122838504.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208263500055418849.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113640229824074144.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208263500055418849.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(113640411055074145.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208263500055418849.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(113641824311074151.4001)
,p_branch_action=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(113640411055074145.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(113640631293074146.4001)
,p_name=>'P764_THEME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(113640016491074142.4001)
,p_prompt=>unistr('Tema de Aplicaci\00F3n a Copiar')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P764_FLOW_ID',
'order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P764_FLOW_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el tema que desea copiar en el repositorio de temas del espacio de trabajo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114796815650738962.4001)
,p_name=>'P764_REPLACE_THEME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(113640016491074142.4001)
,p_prompt=>'Sustituir Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select ''some theme'' d, 1 r from dual'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cSize=>64
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
,p_help_text=>'Identifica el nombre del tema del espacio de trabajo que se va a sustituir por el nuevo tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(702957336140571302.4001)
,p_name=>'P764_CREATE_OR_REPLACE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(113640016491074142.4001)
,p_item_default=>'CREATE'
,p_prompt=>'Proceso'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Create New Scheme;CREATE,Replace Existing Scheme;REPLACE'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(702957777293571306.4001)
,p_name=>'P764_FLOW_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(113640016491074142.4001)
,p_prompt=>unistr('Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1429075521663875901.4001)
,p_name=>'P764_SUBSCRIBE_THEME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(113640016491074142.4001)
,p_item_default=>'Y'
,p_prompt=>'Suscribirse a Tema'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si se debe suscribir el tema de espacio de trabajo al tema de aplicaci\00F3n seleccionado. Esto permite refrescar el tema de espacio de trabajo con los cambios realizados en el tema de aplicaci\00F3n seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(702957430369571303.4001)
,p_name=>'Create or Replace Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P764_CREATE_OR_REPLACE'
,p_condition_element=>'P764_CREATE_OR_REPLACE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CREATE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(702957559421571304.4001)
,p_event_id=>wwv_flow_api.id(702957430369571303.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P764_REPLACE_THEME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(702957647814571305.4001)
,p_event_id=>wwv_flow_api.id(702957430369571303.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P764_REPLACE_THEME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(887629650803273331.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(113640229824074144.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(887629754169273332.4001)
,p_event_id=>wwv_flow_api.id(887629650803273331.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00769
begin
wwv_flow_api.create_page(
 p_id=>769.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.card-settings .a-ButtonRegion-col--content, .card-settings .apex-row { display: flex; }',
'.card-settings .card-settings-label { width: 30%; align-self: flex-end; flex-shrink: 0;}',
''))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44419908444757129.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92889911200052980.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1777336117947606.4001)
,p_plug_name=>'Crear para origen de datos local'
,p_parent_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(499916428544768719.4001)
,p_plug_name=>'Valores por Defecto de Interfaz de Usuario'
,p_region_name=>'ui-defaults'
,p_parent_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(59836303269637894.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_required_role=>wwv_flow_api.id(499915500493760557)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(524736691355857801.4001)
,p_plug_name=>'Facetas - Tabla'
,p_region_name=>'fs-table'
,p_parent_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(518606918001408429.4001)
,p_name=>'Informe de faceta para tabla local'
,p_region_name=>'table-fsReport'
,p_parent_plug_id=>wwv_flow_api.id(524736691355857801.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_css_classes=>'margin-sm'
,p_region_sub_css_classes=>'facet-report'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top5 as (',
'  select column_value column_name',
'  from table( wwv_flow_faceted_search_dev.get_top5_facet_columns(',
'              p_table_owner => :P769_TABLE_OWNER,',
'              p_table_name  => :P769_TABLE_NAME ) ) )',
'select wwv_flow_item.hidden( 1, c.column_name )||',
'       case when c.filterable_score >= 20 and',
'            regexp_replace( c.data_type, ''\(\d+\)'', '''' ) not member of wwv_flow_faceted_search_dev.get_date_col_types and -- 19.2 ignore dates',
'            ( coalesce( c.num_distinct, 0) <= 2000 or c.filter_display_as = ''RANGE'' ) -- if not range, ignore columns with too many distinct values',
'       then',
'          apex_item.checkbox2(',
'              p_idx            => 2,',
'              p_value          => c.column_name,',
'              p_attributes     => ''class="u-vh apex-ui-selector-input"'',',
'              p_checked_values => t.column_name,',
'              p_item_id        => ''cb_''||c.column_name) || ''<label class="apex-ui-selector" for="cb_''||c.column_name||''" aria-labelledby="cb_label_''||c.column_name||''"></label>''',
'       end facets,',
'       case when c.filterable_score >= 20 and',
'            c.data_type not member of wwv_flow_faceted_search_dev.get_date_col_types and -- 19.2 ignore dates',
'            ( coalesce( c.num_distinct, 0) <= 2000 or c.filter_display_as = ''RANGE'' ) -- if not range, ignore columns with too many distinct values',
'       then',
'          ''<label for="cb_''||c.column_name||''" id="cb_label_''||c.column_name||''">''||c.column_name||'' (''||lower(c.data_type)||'')</label>''',
'       else',
'          c.column_name||'' (''||lower(c.data_type)||'')''',
'       end column_name,',
'       case when c.filterable_score >= 20 and',
'            regexp_replace( c.data_type, ''\(\d+\)'', '''' ) not member of wwv_flow_faceted_search_dev.get_date_col_types and -- 19.2 ignore dates',
'            ( coalesce( c.num_distinct, 0) <= 2000 or c.filter_display_as = ''RANGE'' ) -- if not range, ignore columns with too many distinct values',
'       then',
'           wwv_flow_item.text_from_lov (',
'               p_value => c.filter_display_as,',
'               p_lov   => ''P769_FACET_TYPE'' )',
'       end facet_type,',
'       c.filterable_score  facet_score,',
'       case when c.is_fk_yn = ''Y'' then',
'           ''Y''',
'       else',
'           c.filter_global_searchable_yn',
'       end include_in_search,',
'       c.num_distinct,',
'       c.num_nulls,',
'       c.avg_col_len',
'from wwv_dictionary_cache_col c, top5 t',
'where c.column_name = t.column_name (+)',
'and c.security_group_id = :workspace_id',
'and c.owner_name = :P769_TABLE_OWNER',
'and c.table_name = :P769_TABLE_NAME',
'and :P769_TABLE_NAME is not null',
'order by c.column_id'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME,P769_REPORT_SOURCE_TYPE,P769_FACET_TYPE_LABEL'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1024
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No hay recomendaciones de faceta.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607220701408432.4001)
,p_query_column_id=>1
,p_column_alias=>'FACETS'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-vh">Seleccionar faceta</span>'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607338080408433.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Columna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607635856408436.4001)
,p_query_column_id=>3
,p_column_alias=>'FACET_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'&P769_FACET_TYPE_LABEL!HTML.'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607701562408437.4001)
,p_query_column_id=>4
,p_column_alias=>'FACET_SCORE'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607450324408434.4001)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE_IN_SEARCH'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Apto para B\00FAsqueda')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607506115408435.4001)
,p_query_column_id=>6
,p_column_alias=>'NUM_DISTINCT'
,p_column_display_sequence=>6
,p_column_heading=>'Distinto'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607061172408430.4001)
,p_query_column_id=>7
,p_column_alias=>'NUM_NULLS'
,p_column_display_sequence=>5
,p_column_heading=>'Valores nulos'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(518607103440408431.4001)
,p_query_column_id=>8
,p_column_alias=>'AVG_COL_LEN'
,p_column_display_sequence=>7
,p_column_heading=>'Longitud Media'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(526872538851502001.4001)
,p_plug_name=>unistr('Informaci\00F3n de faceta')
,p_parent_plug_id=>wwv_flow_api.id(524736691355857801.4001)
,p_region_css_classes=>'padding-sm'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding:a-ButtonRegion--noUI:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('Seleccione el &P769_FACET_TYPE_LABEL!HTML. que desee incluir en este informe. Tenga en cuenta que las recomendaciones de &P769_FACET_TYPE_LABEL!HTML. se basan en estad\00EDsticas de datos de su tabla. Puede refrescar las estad\00EDsticas de columna para prop')
||'orcionar mejores recomendaciones.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3674120617908496444.4001)
,p_plug_name=>'Columnas'
,p_region_name=>'local-columns'
,p_parent_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'FACETED_SEARCH:CARD:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_plug_name=>'Columnas de consulta'
,p_parent_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P759_REPORT_TYPE in (''CLASSIC'',''INTERACTIVE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1777421531947607.4001)
,p_plug_name=>'Crear informe sobre origen de datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'CLASSIC:INTERACTIVE:GRID:FACETED_SEARCH:CARD:MAP_REGION:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1766760634268542.4001)
,p_plug_name=>'Columnas de origen de REST'
,p_parent_plug_id=>wwv_flow_api.id(1777421531947607.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'FACETED_SEARCH:CARD:MAP_REGION:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3568075962555534.4001)
,p_plug_name=>'Crear informe sobre SQL remoto'
,p_parent_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'CLASSIC:INTERACTIVE:GRID:FACETED_SEARCH:CARD:MAP_REGION:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1767127106268546.4001)
,p_plug_name=>'Columnas de SQL remoto'
,p_parent_plug_id=>wwv_flow_api.id(3568075962555534.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'FACETED_SEARCH:CARD:MAP_REGION:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92890126983052980.4001)
,p_plug_name=>'Ejemplo de Consulta SQL'
,p_region_name=>'query-example'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT ENAME, JOB, SAL, COMM',
'FROM   EMP',
'WHERE  DEPTNO = :P2_DEPTNO',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>La variable de enlace de este ejemplo corresponde a un elemento de una aplicaci\00F3n. Utilice la sintaxis de variable de enlace para hacer referencia al estado de la sesi\00F3n de la aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92896323082057997.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92836304316872750.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(651392118449654220.4001)
,p_plug_name=>'Facetas: otro'
,p_region_name=>'fs-other'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P759_REPORT_TYPE'
,p_plug_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(651390764647654206.4001)
,p_name=>'Informe de facetas'
,p_region_name=>'other-fsReport'
,p_parent_plug_id=>wwv_flow_api.id(651392118449654220.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_css_classes=>'margin-sm'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select column_name, data_type',
'    from wwv_flow_table_columns_dev C',
'    where owner = :P769_TABLE_OWNER',
'    and table_name = :P769_TABLE_NAME',
'    and :P769_TABLE_NAME is not null',
'    and :P769_REPORT_SOURCE_TYPE = ''TABLE''',
'    and ( :P769_LOCATION = ''LOCAL'' or :P769_LOCATION is null )',
'    union all',
'    select column_name, data_type',
'    from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''WEB_SOURCE'',',
'        p_web_src_module_id => :P769_WEB_SRC_MODULE_ID,',
'        p_query_type        => null ) )',
'    where :P769_LOCATION = ''WEB_SOURCE''',
'    union all',
'    select column_name, data_type',
'    from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''REMOTE'',',
'        p_remote_server_id  => :P769_REMOTE_SERVER_ID,',
'        p_owner             => :P769_REMOTE_TABLE_OWNER,',
'        p_table_name        => :P769_REMOTE_TABLE_NAME,',
'        p_query_type        => ''TABLE'' ) )',
'    where :P769_LOCATION = ''REMOTE''',
'    )',
'select wwv_flow_item.hidden( 1, c.column_name )||',
'       case when c.data_type = ''VARCHAR2'' then',
'          apex_item.checkbox2(',
'              p_idx            => 2,',
'              p_value          => c.column_name,',
'              p_attributes     => ''class="u-vh apex-ui-selector-input"'',',
'              p_checked_values => null,',
'              p_item_id        => ''cb_''||c.column_name) || ''<label class="apex-ui-selector" for="cb_''||c.column_name||''" aria-labelledby="cb_label_''||c.column_name||''"></label>''',
'       end facets,',
'       case when c.data_type = ''VARCHAR2'' then',
'          ''<label for="cb_''||c.column_name||''" id="cb_label_''||c.column_name||''">''||c.column_name||'' (''||lower(c.data_type)||'')</label>''',
'       else',
'          c.column_name||'' (''||lower(c.data_type)||'')''',
'       end column_name,',
'       case when c.data_type = ''VARCHAR2'' then',
'           wwv_flow_item.text_from_lov (',
'               p_value => ''CHECKBOX'',',
'               p_lov   => ''P769_FACET_TYPE'' )',
'       end facet_type,',
'       case when c.data_type = ''VARCHAR2'' then',
'           ''Y''',
'       end include_in_search',
'from rpt_columns c'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME,P769_REPORT_SOURCE_TYPE,P769_LOCATION,P769_FACET_TYPE_LABEL'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1024
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No hay ninguna columna que seleccionar.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(651390880298654207.4001)
,p_query_column_id=>1
,p_column_alias=>'FACETS'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-vh">Seleccionar faceta</span>'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(651390987121654208.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Columna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(651391049971654209.4001)
,p_query_column_id=>3
,p_column_alias=>'FACET_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'&P769_FACET_TYPE_LABEL!HTML.'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(651391254675654211.4001)
,p_query_column_id=>4
,p_column_alias=>'INCLUDE_IN_SEARCH'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Apto para B\00FAsqueda')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(651392231324654221.4001)
,p_plug_name=>unistr('Informaci\00F3n de faceta')
,p_parent_plug_id=>wwv_flow_api.id(651392118449654220.4001)
,p_region_css_classes=>'padding-sm'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding:a-ButtonRegion--noUI:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('Seleccione el &P769_FACET_TYPE_LABEL!HTML. que desea incluir en este informe. Es posible que se produzcan errores en la p\00E1gina generada si la columna seleccionada contiene demasiados valores distintos.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92890531020052981.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44419908444757129.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(524737249304857807.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(526872538851502001.4001)
,p_button_name=>'RECOMPUTE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'margin-left-md'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92890725727052981.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44419908444757129.4001)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P759_REPORT_TYPE'
,p_button_condition2=>'CARD:MAP_REGION'
,p_button_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13218416932147301.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44419908444757129.4001)
,p_button_name=>'NEXT'
,p_button_static_id=>'next_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'style="display: none;"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(92890903100052981.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44419908444757129.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197716220030805383.4001)
,p_branch_name=>'edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(92890725727052981.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'P759_REPORT_TYPE'
,p_branch_condition_text=>'CARD:MAP_REGION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1902963786940724.4001)
,p_branch_name=>'map region attributes'
,p_branch_action=>'f?p=&APP_ID.:771:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P759_REPORT_TYPE'
,p_branch_condition_text=>'MAP_REGION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13218543286147302.4001)
,p_branch_name=>'card attributes'
,p_branch_action=>'f?p=&APP_ID.:770:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13218416932147301.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :P759_REPORT_TYPE = ''CARD'' ) or',
'( :P759_REPORT_TYPE in ( ''FACETED_SEARCH'', ''SMART_FILTERS'' ) and :P769_FS_DISPLAY_AS = ''CARD'' )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92894714938052993.4001)
,p_branch_name=>'Go To Page 769'
,p_branch_action=>'f?p=&APP_ID.:769:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1766171742268536.4001)
,p_name=>'P769_WEB_SRC_GRID_PK_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1766760634268542.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''WEB_SOURCE'',',
'        p_web_src_module_id => :P769_WEB_SRC_MODULE_ID,',
'        p_query_type        => null ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccione -'
,p_lov_cascade_parent_items=>'P769_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la primera columna que identifica como \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1766270597268537.4001)
,p_name=>'P769_REMOTE_GRID_PK_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1767127106268546.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''REMOTE'',',
'        p_remote_server_id  => :P769_REMOTE_SERVER_ID,',
'        p_owner             => :P769_REMOTE_TABLE_OWNER,',
'        p_table_name        => :P769_REMOTE_TABLE_NAME,',
'        p_query_type        => ''TABLE'' ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'ROWID'
,p_lov_null_value=>'ROWID'
,p_lov_cascade_parent_items=>'P769_REMOTE_SERVER_ID,P769_REMOTE_TABLE_NAME'
,p_ajax_items_to_submit=>'P769_REMOTE_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la primera columna que identifica como \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1777299596947605.4001)
,p_name=>'P769_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_item_default=>'LOCAL'
,p_prompt=>'Origen de Datos'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'CLASSIC:INTERACTIVE:GRID:FACETED_SEARCH:CARD:MAP_REGION:SMART_FILTERS'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Permite seleccionar el tipo de <em>origen de datos</em> del nuevo componente APEX.',
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se originan en la base de datos local.</li>',
'    <li><strong>Servicio de SQL activado para REST</strong><br>',
unistr('    Los datos se originan en una base de datos remota, donde la conexi\00F3n se define utilizando el servicio SQL activado para REST. Para crear o conservar las referencias de SQL activadas para REST, acceda a Componentes compartidos > SQL activado para ')
||'REST.',
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos se originan en un servicio web RESTful que utiliza or\00EDgenes de datos de REST. Para crear o conservar los or\00EDgenes de datos de REST, acceda a Componentes compartidos > Or\00EDgenes de datos de REST.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1777520468947608.4001)
,p_name=>'P769_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1777421531947607.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1778264619947615.4001)
,p_name=>'P769_WEB_SRC_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1766760634268542.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''WEB_SOURCE'',',
'                  p_web_src_module_id => :P769_WEB_SRC_MODULE_ID,',
'                  p_query_type        => null ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P769_COLUMNS_WEB_SOURCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''WEB_SOURCE'',',
'        p_web_src_module_id => :P769_WEB_SRC_MODULE_ID,',
'        p_query_type        => null ) )    ',
' order by 1'))
,p_lov_cascade_parent_items=>'P769_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1909764590049602.4001)
,p_name=>'P769_REMOTE_GRID_PK2_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1767127106268546.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''REMOTE'',',
'        p_remote_server_id  => :P769_REMOTE_SERVER_ID,',
'        p_owner             => :P769_REMOTE_TABLE_OWNER,',
'        p_table_name        => :P769_REMOTE_TABLE_NAME,',
'        p_query_type        => ''TABLE'' ) )',
'  where column_name != :P769_REMOTE_GRID_PK_COLUMN'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P769_REMOTE_GRID_PK_COLUMN'
,p_ajax_items_to_submit=>'P769_REMOTE_SERVER_ID,P769_REMOTE_TABLE_OWNER,P769_REMOTE_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la primera columna que identifica como \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3568144146555535.4001)
,p_name=>'P769_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3568075962555534.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3568360765555537.4001)
,p_name=>'P769_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3568075962555534.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P769_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P769_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3568504268555539.4001)
,p_name=>'P769_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3568075962555534.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P769_REMOTE_SERVER_ID, ''TABLE'', :P769_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P769_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P769_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3569005005555544.4001)
,p_name=>'P769_REMOTE_COLUMNS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1767127106268546.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''REMOTE'',',
'                  p_remote_server_id  => :P769_REMOTE_SERVER_ID,',
'                  p_owner             => :P769_REMOTE_TABLE_OWNER,',
'                  p_table_name        => :P769_REMOTE_TABLE_NAME,',
'                  p_query_type        => ''TABLE'' ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''REMOTE'',',
'        p_remote_server_id  => :P769_REMOTE_SERVER_ID,',
'        p_owner             => :P769_REMOTE_TABLE_OWNER,',
'        p_table_name        => :P769_REMOTE_TABLE_NAME,',
'        p_query_type        => ''TABLE'' ) )'))
,p_lov_cascade_parent_items=>'P769_REMOTE_TABLE_NAME,P769_REMOTE_SERVER_ID'
,p_ajax_items_to_submit=>'P769_REMOTE_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3569406076555548.4001)
,p_name=>'P769_REMOTE_REPORT_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3568075962555534.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. Los informes pueden estar basados en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3569509347555549.4001)
,p_name=>'P769_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3568075962555534.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la regi\00F3n de informe, por ejemplo:'),
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P769_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3801706961328807.4001)
,p_name=>'P769_FACET_TYPE_LABEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92891128395052982.4001)
,p_name=>'P769_SQL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_prompt=>'Introducir Sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la regi\00F3n de informe, por ejemplo:'),
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(92905013563093051.4001)
,p_name=>'P769_RPT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197775927971040043.4001)
,p_name=>'P769_GRID_PK_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3674120617908496444.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P769_TABLE_OWNER',
'   and table_name = :P769_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'ROWID'
,p_lov_null_value=>'ROWID'
,p_lov_cascade_parent_items=>'P769_TABLE_NAME'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la primera columna que identifica como \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197776020317040044.4001)
,p_name=>'P769_GRID_PK2_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3674120617908496444.4001)
,p_prompt=>'Columna de Clave Primaria 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P769_TABLE_OWNER',
'   and table_name = :P769_TABLE_NAME',
'   and column_name <> :P769_GRID_PK_COLUMN'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P769_GRID_PK_COLUMN'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la segunda columna que identifica como \00FAnica una fila de la tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211134980740312640.4001)
,p_name=>'P769_EDITABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4700_SELECT_REPORT_TYPE = ''EDITABLE_GRID'' then',
'    return ''Y'';',
'else',
'    return ''N'';',
'end if;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Edici\00F3n Activada')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P759_REPORT_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si desea activar la edici\00F3n para esta cuadr\00EDcula interactiva.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(499914001139732418.4001)
,p_name=>'P769_USE_UI_DEF'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_item_default=>'Y'
,p_prompt=>'Usar Valores por Defecto de Interfaz de Usuario:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_security_scheme=>wwv_flow_api.id(499915500493760557)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Seleccione si se va a utilizar el diccionario de atributos de valores por defecto de la interfaz de usuario para crear el informe.</div>',
'<div class="htmldbInfoBodyP">El diccionario de atributos de valores por defecto de la interfaz de usuario permite asignar propiedades de interfaz de usuario por defecto a un nombre de columna. Cuando un desarrollador crea una pantalla o un informe me'
||unistr('diante un asistente, el asistente utiliza esta informaci\00F3n para crear valores por defecto para las propiedades de regi\00F3n y elemento.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504767440893923719.4001)
,p_name=>'P769_SELECT_REPORT_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P4700_SELECT_REPORT_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Used in JavaScript on this page as it''s unable to get P4700_SELECT_REPORT_TYPE value in JS.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(579565086275721518.4001)
,p_name=>'P769_OBJECT_TYPE'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(581927749147097304.4001)
,p_name=>'P769_FS_DISPLAY_AS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_item_default=>'CR'
,p_prompt=>'Mostrar como'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P769_FS_DISPLAY_AS'
,p_lov=>'.'||wwv_flow_api.id(592389652645199591.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>'P769_SELECT_REPORT_TYPE'
,p_display_when2=>'FACETED_SEARCH:SMART_FILTERS'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(581927848115097305.4001)
,p_name=>'P769_IS_UT_BASED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(92889911200052980.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1273378170353509871.4001)
,p_name=>'P769_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P769_REPORT_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1273378676300512021.4001)
,p_name=>'P769_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P769_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P769_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P769_TABLE_OWNER,P769_REPORT_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione o introduzca la tabla o vista en la que se basar\00E1 la regi\00F3n. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1273379442960514265.4001)
,p_name=>'P769_COLUMNS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3674120617908496444.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    if :P769_TABLE_OWNER is not null and :P769_TABLE_NAME is not null then',
'        for l_column in (',
'            select column_name',
'              from wwv_flow_table_columns_dev',
'             where owner      = :P769_TABLE_OWNER',
'               and table_name = :P769_TABLE_NAME',
'        ) loop',
'            l_columns := l_columns || l_column.column_name || '':'';',
'        end loop;',
'    end if;',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P769_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P769_TABLE_OWNER',
'   and table_name = :P769_TABLE_NAME',
'   and :P769_TABLE_NAME is not null',
'   and :P769_REPORT_SOURCE_TYPE = ''TABLE'''))
,p_lov_cascade_parent_items=>'P769_TABLE_NAME'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME,P769_REPORT_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1273380552776525827.4001)
,p_name=>'P769_REPORT_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. Los informes pueden estar basados en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3674120800832496446.4001)
,p_name=>'P769_FK_COUNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1777336117947606.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263112728075531437.4001)
,p_name=>'P769_FK1_COL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>'Clave de Consulta 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P769_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P769_TABLE_NAME',
'and c.child_owner = :P769_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_TABLE_NAME,P769_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263112892600531438.4001)
,p_name=>'P769_FK1_DISPLAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>unistr('Columna de Visualizaci\00F3n 1')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P769_TABLE_OWNER',
'and p.child_table = :P769_TABLE_NAME',
'and p.child_column = :P769_FK1_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_FK1_COL'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263113282413531442.4001)
,p_name=>'P769_FK2_COL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>'Clave de Consulta 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P769_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P769_TABLE_NAME',
'and c.child_owner = :P769_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_TABLE_NAME,P769_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263113358753531443.4001)
,p_name=>'P769_FK2_DISPLAY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>unistr('Columna de Visualizaci\00F3n 2')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P769_TABLE_OWNER',
'and p.child_table = :P769_TABLE_NAME',
'and p.child_column = :P769_FK2_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_FK2_COL'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263113521333531445.4001)
,p_name=>'P769_FK3_COL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>'Clave de Consulta 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P769_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P769_TABLE_NAME',
'and c.child_owner = :P769_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_TABLE_NAME,P769_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263113661657531446.4001)
,p_name=>'P769_FK3_DISPLAY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>unistr('Columna de Visualizaci\00F3n 3')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P769_TABLE_OWNER',
'and p.child_table = :P769_TABLE_NAME',
'and p.child_column = :P769_FK3_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_FK3_COL'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263113808720531448.4001)
,p_name=>'P769_FK4_COL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>'Clave de Consulta 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P769_FK_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.child_column, c.position',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P769_TABLE_NAME',
'and c.child_owner = :P769_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_TABLE_NAME,P769_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4263113908987531449.4001)
,p_name=>'P769_FK4_DISPLAY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_prompt=>unistr('Columna de Visualizaci\00F3n 4')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.table_name||''.''||col.column_name d, col.table_name||''.''||col.column_name r',
'from sys.dba_tab_columns col,  wwv_dictionary_cache_fkcon p',
'where col.owner = p.parent_owner',
'and col.table_name = p.parent_table',
'and p.security_group_id = :flow_security_group_id',
'and p.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)',
'and p.child_owner = :P769_TABLE_OWNER',
'and p.child_table = :P769_TABLE_NAME',
'and p.child_column = :P769_FK4_COL',
'order by col.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P769_FK4_COL'
,p_ajax_items_to_submit=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1273389694474757022.4001)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P769_TABLE_OWNER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3568945137555543.4001)
,p_computation_sequence=>60
,p_computation_item=>'P769_REMOTE_SERVER_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(601371775200988601.4001)
,p_computation_sequence=>70
,p_computation_item=>'P769_IS_UT_BASED'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_is_ut boolean;',
'  l_ui_id number;',
'begin',
'    ',
'    -- get user interface ID first as this is needed to check if the theme is UT based',
'    for c1 in (',
'        select id /* get the first displayed user interface */',
'          from wwv_flow_user_interfaces',
'         where flow_id           = :FB_FLOW_ID',
'           and security_group_id = :WORKSPACE_ID',
'           and rownum = 1 ',
'         order by display_seq',
'    ) loop ',
'        l_ui_id := c1.id;',
'    end loop;',
'',
'    -- determine if current app uses UT',
'    l_is_ut := wwv_flow_theme_dev.is_universal_theme ( ',
'        p_application_id => :FB_FLOW_ID, ',
'        p_user_interface_id => l_ui_id );',
'   ',
'    if l_is_ut then ',
'      return ''Y'';',
'    else ',
'      return ''N'';',
'    end if;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3802422838328814.4001)
,p_computation_sequence=>80
,p_computation_item=>'P769_FACET_TYPE_LABEL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P759_REPORT_TYPE = ''FACETED_SEARCH'' then',
'    return wwv_flow_lang.system_message( p_name => ''WIZARD.CREATE.PAGE.FS.FACET'' );',
'else',
'    return wwv_flow_lang.system_message( p_name => ''WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'' );',
'end if;'))
,p_compute_when=>'P759_REPORT_TYPE'
,p_compute_when_text=>'FACETED_SEARCH:SMART_FILTERS'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(92893704068052991.4001)
,p_validation_name=>'Local SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P769_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el SQL de informe.'
,p_validation_condition=>':P769_REPORT_SOURCE_TYPE = ''QUERY'' and :P769_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(92891128395052982.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13191928514026114.4001)
,p_validation_name=>'Remote SQL not null'
,p_validation_sequence=>20
,p_validation=>'P769_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el SQL de informe.'
,p_validation_condition=>':P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' and :P769_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3569509347555549.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114415323458104483.4001)
,p_validation_name=>'Is Valid SQL query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if :P769_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                p_location             => wwv_flow_exec_api.c_location_local_db,',
'                                p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                                p_sql_query            => :P769_SQL );',
'    elsif :P769_LOCATION =  wwv_flow_exec_api.c_location_remote_db then',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                p_location             => wwv_flow_exec_api.c_location_remote_db,',
'                                p_remote_server_id     => :P769_REMOTE_SERVER_ID,',
'                                p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                                p_sql_query            => :P769_REMOTE_SQL );',
'    end if;',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :P769_REPORT_SOURCE_TYPE = ''QUERY'' and :P769_LOCATION = ''LOCAL'' and :P769_SQL is not null ) or',
'( :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' and :P769_LOCATION = ''REMOTE'' and :P769_REMOTE_SQL is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(92891128395052982.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1273391072250786550.4001)
,p_validation_name=>'P769_TABLE_OWNER'
,p_validation_sequence=>40
,p_validation=>'P769_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el propietario de tabla.'
,p_validation_condition=>':P769_REPORT_SOURCE_TYPE = ''TABLE'' and :P769_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1273391254091788000.4001)
,p_validation_name=>'Table Name is not null'
,p_validation_sequence=>50
,p_validation=>'P769_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe especificar el nombre de la tabla.'
,p_validation_condition=>':P769_REPORT_SOURCE_TYPE = ''TABLE'' and :P769_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3569242268555546.4001)
,p_validation_name=>'P769_REMOTE_TABLE_NAME'
,p_validation_sequence=>60
,p_validation=>'P769_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe especificar el nombre de la tabla.'
,p_validation_condition=>':P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' and :P769_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3569376865555547.4001)
,p_validation_name=>'P769_REMOTE_COLUMNS is not null'
,p_validation_sequence=>70
,p_validation=>'P769_REMOTE_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos una columna.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' and',
':P769_LOCATION = ''REMOTE'' and',
':P759_REPORT_TYPE not in ( ''FACETED_SEARCH'', ''CARD'', ''SMART_FILTERS'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3567967052555533.4001)
,p_validation_name=>'P769_WEB_SRC_COLUMNS is not null'
,p_validation_sequence=>80
,p_validation=>'P769_WEB_SRC_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos una columna.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P769_LOCATION = ''WEB_SOURCE'' and',
':P759_REPORT_TYPE not in ( ''FACETED_SEARCH'', ''CARD'', ''SMART_FILTERS'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4263113178156531441.4001)
,p_validation_name=>'P769_FK1_DISPLAY not null'
,p_validation_sequence=>90
,p_validation=>'P769_FK1_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P769_FK1_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(4263112892600531438.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4263113429225531444.4001)
,p_validation_name=>'P769_FK2_DISPLAY'
,p_validation_sequence=>100
,p_validation=>'P769_FK2_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P769_FK2_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(4263113358753531443.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4263113710325531447.4001)
,p_validation_name=>'P769_FK3_DISPLAY not null'
,p_validation_sequence=>110
,p_validation=>'P769_FK3_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P769_FK3_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(4263113661657531446.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(533296418706616301.4001)
,p_validation_name=>'P769_FK4_DISPLAY not null'
,p_validation_sequence=>120
,p_validation=>'P769_FK4_DISPLAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P769_FK4_COL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(4263113908987531449.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1910168795049606.4001)
,p_validation_name=>'REST Data Source Primary Key Column not null'
,p_validation_sequence=>130
,p_validation=>'P769_WEB_SRC_GRID_PK_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>':P769_LOCATION = ''WEB_SOURCE'' and :P769_EDITABLE = ''Y'' and :P759_REPORT_TYPE = ''GRID'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(92890725727052981.4001)
,p_associated_item=>wwv_flow_api.id(1766171742268536.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7124234017441401.4001)
,p_validation_name=>'is valid faceted search  or smart filter source'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_query_type             varchar2(255);',
'    l_table_owner            wwv_flow_global.t_dbms_id;',
'    l_table_name             wwv_flow_global.t_dbms_id;',
'    l_sql                    varchar2(32767);',
'    l_columns                varchar2(32767);',
'    l_is_valid_filter_source boolean;',
'begin',
'',
'    if :P769_LOCATION = ''REMOTE'' then',
'        l_table_owner := :P769_REMOTE_TABLE_OWNER;',
'        l_table_name  := :P769_REMOTE_TABLE_NAME;',
'        l_query_type  := :P769_REMOTE_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_REMOTE_SQL;',
'        l_columns     := :P769_REMOTE_COLUMNS;',
'    elsif :P769_LOCATION = ''LOCAL'' then',
'        l_table_owner := :P769_TABLE_OWNER;',
'        l_table_name  := :P769_TABLE_NAME;',
'        l_query_type  := :P769_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_SQL;',
'        --l_columns     := :P769_COLUMNS;',
'    else',
'        l_columns     := :P769_WEB_SRC_COLUMNS;',
'    end if;',
'',
'    if l_query_type = ''TABLE'' then',
'        l_query_type :=  wwv_flow_exec_api.c_query_type_table;',
'    else',
'        if substr(upper(ltrim(l_sql)),1,6)=''SELECT'' or',
'           substr(upper(ltrim(l_sql)),1,4)=''WITH''   ',
'        then',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_sql_query;',
'        else',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_func_return_sql;',
'        end if;',
'    end if;',
'',
'    l_is_valid_filter_source := wwv_flow_faceted_search_dev.valid_faceted_search_source(',
'        p_parse_as_schema      => wwv_flow_security.flow_owner( ',
'                                            p_flow_id           => :FB_FLOW_ID, ',
'                                            p_security_group_id => wwv_flow_security.g_security_group_id ),',
'        p_location             => coalesce( :P769_LOCATION, wwv_flow_exec_api.c_location_local_db ),',
'        p_query_type           => l_query_type, ',
'        p_table_owner          => l_table_owner,',
'        p_table_name           => l_table_name,',
'        p_sql_plsql_source     => l_sql,',
'        --',
'        p_remote_server_id     => :P769_REMOTE_SERVER_ID,',
'        p_web_source_module_id => :P769_WEB_SRC_MODULE_ID,',
'        --',
'        p_facet_columns        => wwv_flow_string.split(  wwv_flow_string.table_to_string( wwv_flow.g_f02, '':'' ), '':'' ),',
'        p_report_columns       => case when l_columns is not null then',
'                                      wwv_flow_string.split( l_columns, '':'' )',
'                                  end );',
'',
'    if l_is_valid_filter_source then',
'        return true;',
'    else',
'        -- raise validation error if not valid',
'        return false;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'El asistente no puede continuar utilizando el origen del informe. No hay columnas que buscar.'
,p_validation_condition=>'P759_REPORT_TYPE'
,p_validation_condition2=>'FACETED_SEARCH:SMART_FILTERS'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(578366313504453049.4001)
,p_validation_name=>'Chosen Table Exists'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P769_TABLE_NAME',
'   and owner       = :P769_TABLE_OWNER'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P769_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P769_REPORT_SOURCE_TYPE = ''TABLE'' and :P769_LOCATION = ''LOCAL'' and :P769_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1273378676300512021.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549742624015954527.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(92890531020052981.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549742763368954528.4001)
,p_event_id=>wwv_flow_api.id(549742624015954527.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1273380936663528707.4001)
,p_name=>'Toggle Local Table or Query Items'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_REPORT_SOURCE_TYPE'
,p_condition_element=>'P769_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13218696383147303.4001)
,p_event_id=>wwv_flow_api.id(1273380936663528707.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var item_LocalQueryType = apex.item("P769_REPORT_SOURCE_TYPE").getValue(),',
'    isFS = apex.item("P769_SELECT_REPORT_TYPE").getValue() === ''FACETED_SEARCH'',',
'    isSmartFilters = apex.item("P769_SELECT_REPORT_TYPE").getValue() === ''SMART_FILTERS'',',
'    item_LocalTable = apex.item( "P769_TABLE_NAME" ),',
'    isLocalTableNotNull = !item_LocalTable.isEmpty(),',
'    item_ObjectType = apex.item( "P769_OBJECT_TYPE" ).getValue();',
'',
'if ( item_LocalQueryType === ''TABLE'' ) {',
'    apex.item(''P769_SQL'').hide();',
'    apex.region( "query-example" ).element.hide();',
'    ',
'    //show table related components',
'    apex.item( "P769_TABLE_OWNER" ).show();',
'    item_LocalTable.show();',
'    ',
'    if ( apex.region( "local-columns" ) ) {',
'        apex.region( "local-columns" ).element.show();',
'    }',
'',
'    if ( ( isFS || isSmartFilters ) && isLocalTableNotNull ) {',
'        if ( apex.region( "fs-table" ) ) {',
'            apex.region( "fs-table" ).element.show();',
'        }',
'        apex.item( "P769_FS_DISPLAY_AS" ).show();',
'    }',
'',
'    apex.item( "P769_USE_UI_DEF" ).setValue( "Y" );',
'    apex.item( "P769_USE_UI_DEF" ).show();',
'    if ( apex.region( "ui-defaults" ) ) {',
'        apex.region( "ui-defaults" ).element.show();',
'    }',
'} else if ( item_LocalQueryType === ''QUERY'' )  {',
'    //show query related components',
'    apex.item(''P769_SQL'').show();',
'    apex.region( "query-example" ).element.show();',
'    ',
'    apex.item( "P769_TABLE_OWNER" ).hide();',
'    item_LocalTable.hide();',
'    if ( apex.region( "local-columns" ) ) {',
'        apex.region( "local-columns" ).element.hide();',
'    }',
'    ',
'    if ( isFS || isSmartFilters ) {',
'       if ( apex.region( "fs-table" ) ) {',
'           apex.region( "fs-table" ).element.hide();',
'       }',
'       apex.item( "P769_FS_DISPLAY_AS" ).hide();',
'    }',
'',
'    apex.item( "P769_USE_UI_DEF" ).setValue( "N" );',
'    apex.item( "P769_USE_UI_DEF" ).hide();',
'    if ( apex.region( "ui-defaults" ) ) {',
'        apex.region( "ui-defaults" ).element.hide();',
'    }',
'}',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3569644105555550.4001)
,p_name=>'Toggle Remote Table or Query Items'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_REMOTE_REPORT_SOURCE_TYPE'
,p_condition_element=>'P769_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13218785114147304.4001)
,p_event_id=>wwv_flow_api.id(3569644105555550.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var item_RemoteQueryType = apex.item("P769_REMOTE_REPORT_SOURCE_TYPE").getValue(),',
'    isFS = apex.item("P769_SELECT_REPORT_TYPE").getValue() === ''FACETED_SEARCH'',',
'    isSmartFilters = apex.item("P769_SELECT_REPORT_TYPE").getValue() === ''SMART_FILTERS'',',
'    item_RemoteTable = apex.item( "P769_REMOTE_TABLE_NAME" ),',
'    isRemoteTableNotNull = !item_RemoteTable.isEmpty();',
'',
'if ( item_RemoteQueryType === ''TABLE'' ) {',
'    apex.item(''P769_REMOTE_SQL'').hide();',
'    apex.region( "query-example" ).element.hide();',
'    ',
'    //show table related components',
'    apex.item( "P769_REMOTE_TABLE_OWNER" ).show();',
'    item_RemoteTable.show();',
'',
'    if ( apex.region( "fs-other" ) && ( isFS || isSmartFilters ) && isRemoteTableNotNull ) {',
'        apex.region( "fs-other" ).element.show();',
'    }',
'',
'} else if ( item_RemoteQueryType === ''QUERY'' )  {',
'    //show query related components',
'    apex.item(''P769_REMOTE_SQL'').show();',
'    apex.region( "query-example" ).element.show();',
'    ',
'    apex.item( "P769_REMOTE_TABLE_OWNER" ).hide();',
'    item_RemoteTable.hide();',
'',
'    if ( apex.region( "fs-other" ) && ( isFS || isSmartFilters ) ) {',
'       apex.region( "fs-other" ).element.hide();',
'    }',
'',
'    apex.item( "P769_REMOTE_TABLE_NAME" ).setValue( "" );',
'}',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557887859226021604.4001)
,p_name=>'Toggle Grid PK'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_EDITABLE'
,p_condition_element=>'P769_EDITABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557887979907021605.4001)
,p_event_id=>wwv_flow_api.id(557887859226021604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_GRID_PK_COLUMN,P769_GRID_PK2_COLUMN,P769_WEB_SRC_GRID_PK_COLUMN,P769_REMOTE_GRID_PK_COLUMN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557888068555021606.4001)
,p_event_id=>wwv_flow_api.id(557887859226021604.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_GRID_PK_COLUMN,P769_GRID_PK2_COLUMN,P769_REMOTE_GRID_PK_COLUMN,P769_WEB_SRC_GRID_PK_COLUMN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557888166672021607.4001)
,p_name=>'Toggle Grid PK2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_GRID_PK_COLUMN'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item( "P769_EDITABLE" ).getValue() === ''Y'' &&',
'apex.item( "P769_GRID_PK_COLUMN" ).getValue() !== ''ROWID'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557888278669021608.4001)
,p_event_id=>wwv_flow_api.id(557888166672021607.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_GRID_PK2_COLUMN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557888309772021609.4001)
,p_event_id=>wwv_flow_api.id(557888166672021607.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_GRID_PK2_COLUMN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(583671082114804249.4001)
,p_name=>'Save Location in Session state'
,p_event_sequence=>65
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_LOCATION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'cbcho - This is needed for other-fsReport to work as it fetches diffent query based on location item session state.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(583671179603804250.4001)
,p_event_id=>wwv_flow_api.id(583671082114804249.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P769_LOCATION'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1777645229947609.4001)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_LOCATION'
,p_condition_element=>'P769_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1777843580947611.4001)
,p_event_id=>wwv_flow_api.id(1777645229947609.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1777336117947606.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1777776164947610.4001)
,p_event_id=>wwv_flow_api.id(1777645229947609.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1777336117947606.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662392030104758422.4001)
,p_event_id=>wwv_flow_api.id(1777645229947609.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var isFS = apex.item( "P769_SELECT_REPORT_TYPE" ).getValue() === ''FACETED_SEARCH'',',
'    isSmartFilters = apex.item( "P769_SELECT_REPORT_TYPE" ).getValue() === ''SMART_FILTERS'',',
'    isFSCard = apex.item( "P769_FS_DISPLAY_AS" ).getValue() === ''CARD'' || apex.item( "P769_FS_DISPLAY_AS" ).getValue() === ''MAP_REGION'',',
'    item_QueryType = apex.item( "P769_REPORT_SOURCE_TYPE" ).getValue(),',
'    item_ObjectType = apex.item( "P769_OBJECT_TYPE" ).getValue();',
'    ',
'if ( ( isFS || isSmartFilters ) && item_ObjectType === ''TABLE'' ) {',
'    apex.region( "fs-table" ).element.show();',
'    apex.region( "fs-other" ).element.hide();',
'    apex.region( "table-fsReport" ).refresh();',
'} else if ( ( isFS || isSmartFilters ) && item_ObjectType === ''VIEW'' ) {',
'    apex.region( "fs-table" ).element.hide();',
'    apex.region( "fs-other" ).element.show();',
'    apex.region( "other-fsReport" ).refresh();',
'}',
'    ',
'if ( item_QueryType === ''QUERY'' ) {',
'    apex.region( "query-example" ).element.show();',
'} else {',
'    apex.region( "query-example" ).element.hide();',
'}',
'  ',
'if ( ( isFS || isSmartFilters ) && isFSCard && item_QueryType === ''TABLE'' ) {',
'    $( "#next_button" ).show();',
'    $( "#create_button" ).hide();',
'} else {',
'    $( "#next_button" ).hide();',
'    $( "#create_button" ).show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3568669623555540.4001)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_LOCATION'
,p_condition_element=>'P769_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3568863104555542.4001)
,p_event_id=>wwv_flow_api.id(3568669623555540.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3568075962555534.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3568765940555541.4001)
,p_event_id=>wwv_flow_api.id(3568669623555540.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3568075962555534.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13426956115384610.4001)
,p_event_id=>wwv_flow_api.id(3568669623555540.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var isFS = apex.item( "P769_SELECT_REPORT_TYPE" ).getValue() === ''FACETED_SEARCH'',',
'    isSmartFilters = apex.item( "P769_SELECT_REPORT_TYPE" ).getValue() === ''SMART_FILTERS'',',
'    isRemote = apex.item( "P769_LOCATION" ).getValue() === ''REMOTE'',',
'    isRemoteNotNull = !apex.item( "P769_REMOTE_SERVER_ID" ).isEmpty(),',
'    item_Remote_QueryType = apex.item( "P769_REMOTE_REPORT_SOURCE_TYPE" ).getValue(),',
'    isRemoteTableNotNull = !apex.item( "P769_REMOTE_TABLE_NAME" ).isEmpty();',
'',
'if ( apex.region( "fs-other" ) ) {',
'    if ( ( isFS || isSmartFilters ) && isRemote && isRemoteNotNull && item_Remote_QueryType === ''TABLE'' && isRemoteTableNotNull ) {',
'        apex.region( "fs-other" ).element.show();',
'        apex.region( "other-fsReport" ).refresh();',
'    } else {',
'        apex.region( "fs-other" ).element.hide();',
'    }',
'}',
'    ',
'if ( isRemoteNotNull && item_Remote_QueryType === ''QUERY'' ) {',
'    apex.region( "query-example" ).element.show();',
'} else {',
'    apex.region( "query-example" ).element.hide();',
'}',
' ',
'if ( ( isFS || isSmartFilters ) && isRemote ) {',
'    $( "#next_button" ).hide();',
'    $( "#create_button" ).show();',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1777915920947612.4001)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_LOCATION'
,p_condition_element=>'P769_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1778015201947613.4001)
,p_event_id=>wwv_flow_api.id(1777915920947612.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1777421531947607.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1778152562947614.4001)
,p_event_id=>wwv_flow_api.id(1777915920947612.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1777421531947607.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13427092001384611.4001)
,p_event_id=>wwv_flow_api.id(1777915920947612.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var isFS = apex.item( "P769_SELECT_REPORT_TYPE" ).getValue() === ''FACETED_SEARCH'',',
'    isSmartFilters = apex.item( "P769_SELECT_REPORT_TYPE" ).getValue() === ''SMART_FILTERS'',',
'    isWebSource = apex.item( "P769_LOCATION" ).getValue() === "WEB_SOURCE",',
'    isWebSourceNotNull = !apex.item( "P769_WEB_SRC_MODULE_ID" ).isEmpty();',
'',
'if ( apex.region( "fs-other" ) ) {',
'    if ( ( isFS || isSmartFilters ) && isWebSource && isWebSourceNotNull ) {',
'        apex.region( "fs-other" ).element.show();',
'        apex.region( "other-fsReport" ).refresh();',
'    } else {',
'        apex.region( "fs-other" ).element.hide();',
'    }',
'}',
'',
'if ( isWebSource ) {',
'    apex.region( "query-example" ).element.hide();',
'    if ( isFS || isSmartFilters ) {',
'        $( "#next_button" ).hide();',
'        $( "#create_button" ).show();',
'    }',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3943514741140222.4001)
,p_name=>'Remote Server chosen'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_REMOTE_SERVER_ID'
,p_condition_element=>'P769_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3943656367140223.4001)
,p_event_id=>wwv_flow_api.id(3943514741140222.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_REMOTE_REPORT_SOURCE_TYPE'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3943795502140224.4001)
,p_event_id=>wwv_flow_api.id(3943514741140222.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_REMOTE_REPORT_SOURCE_TYPE,P769_REMOTE_SQL,P769_REMOTE_TABLE_OWNER,P769_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3943905528140226.4001)
,p_event_id=>wwv_flow_api.id(3943514741140222.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_REMOTE_REPORT_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_name=>'Set Local Table FK Count and Object Type'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_TABLE_NAME'
,p_condition_element=>'P769_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8700525668617203.4001)
,p_event_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'         p_workspace_name          => l_workspace_name,',
'         p_schema                  => :P769_TABLE_OWNER,',
'         p_table_name              => :P769_TABLE_NAME,',
'         p_flow_id                 => :FB_FLOW_ID,',
'         p_cache_fk_references     => true );',
'',
'end;'))
,p_attribute_02=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674120414506496442.4001)
,p_event_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(579565664736721524.4001)
,p_event_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_obj in (',
'    select object_type',
'    from wwv_flow_tables_views_dev',
'    where owner = :P769_TABLE_OWNER',
'    and object_name = :P769_TABLE_NAME )',
'loop',
'    :P769_OBJECT_TYPE := l_obj.object_type;',
'end loop;'))
,p_attribute_03=>'P769_OBJECT_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674120999381496447.4001)
,p_event_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_FK_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674120738489496445.4001)
,p_event_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_FK_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'from wwv_dictionary_cache_fkcon c',
'where c.child_table = :P769_TABLE_NAME',
'and c.child_owner = :P769_TABLE_OWNER',
'and c.security_group_id = :flow_security_group_id',
'and c.child_owner in (select schema from wwv_flow_company_schemas where security_group_id = :flow_security_group_id)'))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(632193806583032129.4001)
,p_event_id=>wwv_flow_api.id(3674120265171496440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_FK1_COL,P769_FK2_COL,P769_FK3_COL,P769_FK4_COL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2201104657283602.4001)
,p_name=>'Set Map Layer Type'
,p_event_sequence=>115
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_TABLE_NAME'
,p_condition_element=>'P769_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'MAP_REGION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2201247708283603.4001)
,p_event_id=>wwv_flow_api.id(2201104657283602.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select case geometry_type',
'        when ''UNKNOWN'' then ''POINT''',
'        else geometry_type',
'        end',
'    into :P771_LAYER_TYPE',
'    from wwv_dictionary_cache_obj',
'    where object_owner = :P769_TABLE_OWNER',
'    and object_name = :P769_TABLE_NAME',
'    and security_group_id = :WORKSPACE_ID;',
'exception',
'    when no_data_found then',
'        :P771_LAYER_TYPE := null;',
'end;'))
,p_attribute_03=>'P771_LAYER_TYPE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3674121098715496448.4001)
,p_name=>'Local Table Show/Hide Lookup Columns'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_FK_COUNT'
,p_condition_element=>'P769_FK_COUNT'
,p_triggering_condition_type=>'GREATER_THAN'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674121185894496449.4001)
,p_event_id=>wwv_flow_api.id(3674121098715496448.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3674121291972496450.4001)
,p_event_id=>wwv_flow_api.id(3674121098715496448.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4263112659622531436.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1766863195268543.4001)
,p_name=>'REST Data Source chosen'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_WEB_SRC_MODULE_ID'
,p_condition_element=>'P769_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1766931334268544.4001)
,p_event_id=>wwv_flow_api.id(1766863195268543.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1766760634268542.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1767031172268545.4001)
,p_event_id=>wwv_flow_api.id(1766863195268543.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1766760634268542.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1767418760268549.4001)
,p_name=>'Show / Hide Remote Columns'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_REMOTE_REPORT_SOURCE_TYPE,P769_REMOTE_TABLE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P769_REMOTE_REPORT_SOURCE_TYPE").getValue() === "TABLE" &&',
'!apex.item("P769_REMOTE_TABLE_NAME").isEmpty()'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1767511116268550.4001)
,p_event_id=>wwv_flow_api.id(1767418760268549.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1767127106268546.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909600343049601.4001)
,p_event_id=>wwv_flow_api.id(1767418760268549.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1767127106268546.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1909815436049603.4001)
,p_name=>'Show / Hide Remote PK 2'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_REMOTE_GRID_PK_COLUMN'
,p_condition_element=>'P769_REMOTE_GRID_PK_COLUMN'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'ROWID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909914459049604.4001)
,p_event_id=>wwv_flow_api.id(1909815436049603.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_REMOTE_GRID_PK2_COLUMN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1910060070049605.4001)
,p_event_id=>wwv_flow_api.id(1909815436049603.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_REMOTE_GRID_PK2_COLUMN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(187614859225572724.4001)
,p_name=>'Cache info for Local Table'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_OBJECT_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P769_LOCATION").getValue() === "LOCAL" &&',
'apex.item("P769_OBJECT_TYPE").getValue() === "TABLE"'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525303332589948615.4001)
,p_event_id=>wwv_flow_api.id(187614859225572724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(524736691355857801.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662390943400758411.4001)
,p_event_id=>wwv_flow_api.id(187614859225572724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651392118449654220.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525302285258948604.4001)
,p_event_id=>wwv_flow_api.id(187614859225572724.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(518606918001408429.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651391603034654215.4001)
,p_name=>'Facet for Local View'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_OBJECT_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P769_LOCATION").getValue() === "LOCAL" &&',
'apex.item("P769_OBJECT_TYPE").getValue() === "VIEW"'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651391888629654217.4001)
,p_event_id=>wwv_flow_api.id(651391603034654215.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651392118449654220.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662391130590758413.4001)
,p_event_id=>wwv_flow_api.id(651391603034654215.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(524736691355857801.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651392047316654219.4001)
,p_event_id=>wwv_flow_api.id(651391603034654215.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651390764647654206.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(662389933107758401.4001)
,p_name=>'Facet for Remote'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_REMOTE_TABLE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P769_LOCATION").getValue() === "REMOTE" &&',
'apex.item("P769_REMOTE_REPORT_SOURCE_TYPE").getValue() === "TABLE" &&',
'!apex.item("P769_REMOTE_TABLE_NAME").isEmpty()'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662390364724758405.4001)
,p_event_id=>wwv_flow_api.id(662389933107758401.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P769_REMOTE_SERVER_ID,P769_REMOTE_TABLE_OWNER,P769_REMOTE_TABLE_NAME'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662392164358758423.4001)
,p_event_id=>wwv_flow_api.id(662389933107758401.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651392118449654220.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(82706821425738141.4001)
,p_event_id=>wwv_flow_api.id(662389933107758401.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651390764647654206.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(662392319428758425.4001)
,p_name=>'Facet for REST Source'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P769_LOCATION").getValue() === "WEB_SOURCE" &&',
'!apex.item("P769_WEB_SRC_MODULE_ID").isEmpty()'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662392688040758428.4001)
,p_event_id=>wwv_flow_api.id(662392319428758425.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P769_WEB_SRC_MODULE_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662392498012758426.4001)
,p_event_id=>wwv_flow_api.id(662392319428758425.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651392118449654220.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(662392504282758427.4001)
,p_event_id=>wwv_flow_api.id(662392319428758425.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(651390764647654206.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(525302686800948608.4001)
,p_name=>'Reset facet dictionary cache with stats'
,p_event_sequence=>220
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(524737249304857807.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525302730634948609.4001)
,p_event_id=>wwv_flow_api.id(525302686800948608.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.reset_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P769_TABLE_OWNER,',
'        p_table_name               => :P769_TABLE_NAME,',
'        p_flow_id                  => :FB_FLOW_ID,',
'        p_gather_stats             => true,',
'        p_cache_fk_references      => true);',
'end;'))
,p_attribute_02=>'P769_TABLE_OWNER,P769_TABLE_NAME'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(526872696791502002.4001)
,p_event_id=>wwv_flow_api.id(525302686800948608.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.util.showSpinner(''.facet-report'');'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525303106136948613.4001)
,p_event_id=>wwv_flow_api.id(525302686800948608.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(518606918001408429.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(588436141344019906.4001)
,p_name=>'Disable Create button'
,p_event_sequence=>270
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(518606918001408429.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexbeforerefresh'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(639435378169943312.4001)
,p_event_id=>wwv_flow_api.id(588436141344019906.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(92890725727052981.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(588436323282019908.4001)
,p_name=>'Enable Create Button after Facet Refresh'
,p_event_sequence=>280
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(518606918001408429.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(588436426873019909.4001)
,p_event_id=>wwv_flow_api.id(588436323282019908.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(92890725727052981.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(639435741429943316.4001)
,p_name=>'Toggle Facet Recommendations'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_TABLE_NAME'
,p_condition_element=>'P769_TABLE_NAME'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(639435827265943317.4001)
,p_event_id=>wwv_flow_api.id(639435741429943316.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(524736691355857801.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13426340874384604.4001)
,p_event_id=>wwv_flow_api.id(639435741429943316.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(524736691355857801.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(504768756789923732.4001)
,p_event_id=>wwv_flow_api.id(639435741429943316.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_FS_DISPLAY_AS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13426797320384608.4001)
,p_event_id=>wwv_flow_api.id(639435741429943316.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P769_FS_DISPLAY_AS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(581928345849097310.4001)
,p_name=>'Toggle Wizard Buttons'
,p_event_sequence=>325
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P769_FS_DISPLAY_AS'
,p_condition_element=>'P769_FS_DISPLAY_AS'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CARD,MAP_REGION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(581928477305097311.4001)
,p_event_id=>wwv_flow_api.id(581928345849097310.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(13218416932147301.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13192211188026117.4001)
,p_event_id=>wwv_flow_api.id(581928345849097310.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(13218416932147301.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13193288785026127.4001)
,p_event_id=>wwv_flow_api.id(581928345849097310.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(92890725727052981.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13193336836026128.4001)
,p_event_id=>wwv_flow_api.id(581928345849097310.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(92890725727052981.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(13426050618384601.4001)
,p_name=>'show Next button if Card page'
,p_event_sequence=>335
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P759_REPORT_TYPE'
,p_display_when_cond2=>'CARD:MAP_REGION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13426123023384602.4001)
,p_event_id=>wwv_flow_api.id(13426050618384601.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(13218416932147301.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1474230992159765801.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Source Type Preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'WIZARD_SQL_SOURCE_TYPE'
,p_attribute_03=>'P769_REPORT_SOURCE_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(92890725727052981.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(211132435060312615.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_table_owner    wwv_flow_global.t_dbms_id;',
'    l_table_name     wwv_flow_global.t_dbms_id;',
'    l_query_type     wwv_flow_exec_api.t_query_type;',
'    l_sql            varchar2(32767);',
'    l_columns        varchar2(32767);',
'    l_pk_column      wwv_flow_global.t_dbms_id;',
'    l_pk2_column     wwv_flow_global.t_dbms_id;',
'begin',
'    if :P769_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner := :P769_REMOTE_TABLE_OWNER;',
'        l_table_name  := :P769_REMOTE_TABLE_NAME;',
'        l_query_type  := :P769_REMOTE_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_REMOTE_SQL;',
'        l_columns     := :P769_REMOTE_COLUMNS;',
'        l_pk_column   := :P769_REMOTE_GRID_PK_COLUMN;',
'        l_pk2_column  := :P769_REMOTE_GRID_PK2_COLUMN;',
'    elsif :P769_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner := :P769_TABLE_OWNER;',
'        l_table_name  := :P769_TABLE_NAME;',
'        l_query_type  := :P769_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_SQL;',
'        l_columns     := :P769_COLUMNS;',
'        l_pk_column   := :P769_GRID_PK_COLUMN;',
'        l_pk2_column := :P769_GRID_PK2_COLUMN;',
'    else',
'        l_columns     := :P769_WEB_SRC_COLUMNS;',
'        l_pk_column   := :P769_WEB_SRC_GRID_PK_COLUMN;',
'    end if;',
'    ',
'    if l_query_type = ''TABLE'' then',
'        l_query_type := wwv_flow_exec_api.c_query_type_table;',
'    else',
'        if substr(upper(ltrim( l_sql )),1,6)=''SELECT'' or',
'           substr(upper(ltrim( l_sql )),1,4)=''WITH''   ',
'        then',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_sql_query;',
'        else',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_func_return_sql;',
'        end if;',
'    end if;',
'    ',
'    wwv_flow_report_dev.create_report_page (',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P759_PAGE_ID,',
'        p_theme_id                   => :FB_THEME_ID,',
'        p_report_type                => :P759_REPORT_TYPE,',
'        --',
'        p_page_name                  => :P759_PAGE_NAME,',
'        p_page_mode                  => :P759_PAGE_MODE,',
'        p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'        p_use_ui_default             => ( coalesce(:P769_USE_UI_DEF, ''N'') = ''Y'' ),',
'        --',
'        p_tab_options                => :P4716_TAB_OPTIONS,',
'        p_tab_set                    => :P4716_TAB_SET,',
'        p_tab_name                   => :P4716_TAB_NAME,',
'        p_tab_text                   => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id                => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id              => :P759_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P759_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P759_BREADCRUMB_PARENT_ID,',
'        --',
'        p_location                   => :P769_LOCATION,',
'        p_query_type                 => l_query_type,',
'        p_table_owner                => l_table_owner,',
'        p_table_name                 => l_table_name,',
'        p_sql_plsql_source           => l_sql,',
'        p_remote_server_id           => :P769_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P769_WEB_SRC_MODULE_ID,',
'        --',
'        p_columns                    => l_columns,',
'        -- ig',
'        p_pk_column                  => l_pk_column,',
'        p_pk2_column                 => l_pk2_column,',
'        p_is_editable                => ( coalesce(:P769_EDITABLE, ''N'') = ''Y'' ),',
'        -- fs',
'        p_facet_result_region_type   => ''CR'',',
'        p_facet_columns              => wwv_flow_string.split( wwv_flow_string.table_to_string( wwv_flow.g_f02, '':'' ), '':'' ) );',
' ',
'    :FB_FLOW_PAGE_ID       := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la p\00E1gina de informe.#SQLERRM#')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(92890725727052981.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2505389881430337.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set facet columns'
,p_process_sql_clob=>':P770_FACET_COLUMNS := wwv_flow_string.table_to_string( wwv_flow.g_f02, '':'' );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(13218416932147301.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(197726616782835653.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(92890725727052981.4001)
,p_process_success_message=>unistr('La p\00E1gina del informe se ha creado correctamente.')
);
end;
/
prompt --application/pages/page_00770
begin
wwv_flow_api.create_page(
 p_id=>770.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.card-settings .a-ButtonRegion-col--content, .card-settings .apex-row { display: flex; }',
'.card-settings .card-settings-label { width: 30%; align-self: flex-end; flex-shrink: 0;}',
''))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(56920656891903878.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(105390659647199729.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(105397071529204746.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92836304316872750.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12501312155146882.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(56920656891903878.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12501734034146883.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(56920656891903878.4001)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12502169391146883.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(56920656891903878.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:769:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12601818567146988.4001)
,p_branch_name=>'edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(12501734034146883.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2502477727430308.4001)
,p_name=>'P770_LAYOUT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(105390659647199729.4001)
,p_item_default=>'GRID'
,p_prompt=>unistr('Dise\00F1o')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(12784439638072063.4001)||'.'
,p_grid_column=>4
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2502748075430311.4001)
,p_name=>'P770_BADGE_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(105390659647199729.4001)
,p_prompt=>'Columna de placa'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P770_CARD_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select column_name_esc,',
'           column_name,',
'           data_type',
'    from table(wwv_flow_exec_dev.get_query_columns(',
'        p_location          => :P769_LOCATION,',
'        p_query_type        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REPORT_SOURCE_TYPE',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REMOTE_REPORT_SOURCE_TYPE',
'                                    end',
'                                end,',
'        p_owner             =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_OWNER',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_OWNER',
'                                    end',
'                                end,',
'        p_table_name        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_NAME',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_NAME',
'                                    end',
'                                end,',
'        p_sql_query         =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_SQL',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_REMOTE_SQL',
'                                    end',
'                                end,      ',
'        p_web_src_module_id =>  case when :P769_LOCATION = ''WEB_SOURCE'' then',
'                                    :P769_WEB_SRC_MODULE_ID',
'                                end,',
'        p_remote_server_id  =>  case when :P769_LOCATION = ''REMOTE'' then',
'                                    :P769_REMOTE_SERVER_ID',
'                                end )) )',
'select c.column_name_esc column_display,',
'       c.column_name',
'from rpt_columns c'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2505246975430336.4001)
,p_name=>'P770_FACET_COLUMNS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(105390659647199729.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12516887277146913.4001)
,p_name=>'P770_TITLE_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(105390659647199729.4001)
,p_prompt=>unistr('Columna de t\00EDtulo')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P769_TABLE_OWNER',
'       and object_name = :P769_TABLE_NAME',
'       and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P770_CARD_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select column_name_esc,',
'           column_name,',
'           data_type',
'    from table(wwv_flow_exec_dev.get_query_columns(',
'        p_location          => :P769_LOCATION,',
'        p_query_type        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REPORT_SOURCE_TYPE',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REMOTE_REPORT_SOURCE_TYPE',
'                                    end',
'                                end,',
'        p_owner             =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_OWNER',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_OWNER',
'                                    end',
'                                end,',
'        p_table_name        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_NAME',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_NAME',
'                                    end',
'                                end,',
'        p_sql_query         =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_SQL',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_REMOTE_SQL',
'                                    end',
'                                end,      ',
'        p_web_src_module_id =>  case when :P769_LOCATION = ''WEB_SOURCE'' then',
'                                    :P769_WEB_SRC_MODULE_ID',
'                                end,',
'        p_remote_server_id  =>  case when :P769_LOCATION = ''REMOTE'' then',
'                                    :P769_REMOTE_SERVER_ID',
'                                end )) )',
'select c.column_name_esc column_display,',
'       c.column_name',
'from rpt_columns c'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12517290766146914.4001)
,p_name=>'P770_BODY_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(105390659647199729.4001)
,p_prompt=>'Columna de cuerpo'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_2 as description',
'from wwv_dictionary_cache_obj',
'where object_owner = :P769_TABLE_OWNER',
'and object_name = :P769_TABLE_NAME',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P770_CARD_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select column_name_esc,',
'           column_name,',
'           data_type',
'    from table(wwv_flow_exec_dev.get_query_columns(',
'        p_location          => :P769_LOCATION,',
'        p_query_type        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REPORT_SOURCE_TYPE',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REMOTE_REPORT_SOURCE_TYPE',
'                                    end',
'                                end,',
'        p_owner             =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_OWNER',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_OWNER',
'                                    end',
'                                end,',
'        p_table_name        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_NAME',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_NAME',
'                                    end',
'                                end,',
'        p_sql_query         =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_SQL',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_REMOTE_SQL',
'                                    end',
'                                end,      ',
'        p_web_src_module_id =>  case when :P769_LOCATION = ''WEB_SOURCE'' then',
'                                    :P769_WEB_SRC_MODULE_ID',
'                                end,',
'        p_remote_server_id  =>  case when :P769_LOCATION = ''REMOTE'' then',
'                                    :P769_REMOTE_SERVER_ID',
'                                end )) )',
'select c.column_name_esc column_display,',
'       c.column_name',
'from rpt_columns c'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12517649891146914.4001)
,p_name=>'P770_ICON_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(105390659647199729.4001)
,p_prompt=>'Columna de iniciales de icono'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P770_CARD_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select column_name_esc,',
'           column_name,',
'           data_type',
'    from table(wwv_flow_exec_dev.get_query_columns(',
'        p_location          => :P769_LOCATION,',
'        p_query_type        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REPORT_SOURCE_TYPE',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        ''SQL''',
'                                    else :P769_REMOTE_REPORT_SOURCE_TYPE',
'                                    end',
'                                end,',
'        p_owner             =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_OWNER',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_OWNER',
'                                    end',
'                                end,',
'        p_table_name        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_TABLE_NAME',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                        :P769_REMOTE_TABLE_NAME',
'                                    end',
'                                end,',
'        p_sql_query         =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                    case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_SQL',
'                                    end',
'                                when :P769_LOCATION = ''REMOTE'' then',
'                                    case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                        :P769_REMOTE_SQL',
'                                    end',
'                                end,      ',
'        p_web_src_module_id =>  case when :P769_LOCATION = ''WEB_SOURCE'' then',
'                                    :P769_WEB_SRC_MODULE_ID',
'                                end,',
'        p_remote_server_id  =>  case when :P769_LOCATION = ''REMOTE'' then',
'                                    :P769_REMOTE_SERVER_ID',
'                                end )) )',
'select c.column_name_esc column_display,',
'       c.column_name',
'from rpt_columns c'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(12545761895146963.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(12501312155146882.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(12546296239146964.4001)
,p_event_id=>wwv_flow_api.id(12545761895146963.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13409782888142176.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Source Type Preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'WIZARD_SQL_SOURCE_TYPE'
,p_attribute_03=>'P769_REPORT_SOURCE_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12544904219146962.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Card Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_table_owner    wwv_flow_global.t_dbms_id;',
'    l_table_name     wwv_flow_global.t_dbms_id;',
'    l_query_type     varchar2(255);',
'    l_sql            varchar2(32767);',
'begin',
'    if :P769_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner := :P769_TABLE_OWNER;',
'        l_table_name  := :P769_TABLE_NAME;',
'        l_query_type  := :P769_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_SQL;',
'    elsif :P769_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner := :P769_REMOTE_TABLE_OWNER;',
'        l_table_name  := :P769_REMOTE_TABLE_NAME;',
'        l_query_type  := :P769_REMOTE_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_REMOTE_SQL;',
'    end if;',
'    ',
'    if l_query_type = ''TABLE'' then',
'        l_query_type := wwv_flow_exec_api.c_query_type_table;',
'    else',
'        if substr(upper(ltrim( l_sql )),1,6)=''SELECT'' or',
'           substr(upper(ltrim( l_sql )),1,4)=''WITH''   ',
'        then',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_sql_query;',
'        else',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_func_return_sql;',
'        end if;',
'    end if;',
'',
'    wwv_flow_report_dev.create_report_page(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P759_PAGE_ID,',
'        p_theme_id                   => :FB_THEME_ID,',
'        p_report_type                => :P759_REPORT_TYPE,',
'        --',
'        p_page_name                  => :P759_PAGE_NAME,',
'        p_page_mode                  => :P759_PAGE_MODE,',
'        p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'        p_use_ui_default             => ( coalesce(:P769_USE_UI_DEF, ''N'') = ''Y'' ),',
'        --',
'        p_tab_set                    => :P4716_TAB_SET,',
'        p_tab_name                   => :P4716_TAB_NAME,',
'        p_tab_text                   => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id                => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id              => :P759_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P759_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P759_BREADCRUMB_PARENT_ID,',
'        --',
'        p_location                   => :P769_LOCATION,',
'        p_query_type                 => l_query_type,',
'        p_table_owner                => l_table_owner,',
'        p_table_name                 => l_table_name,',
'        p_sql_plsql_source           => l_sql,',
'        --',
'        p_remote_server_id           => :P769_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P769_WEB_SRC_MODULE_ID,',
'        -- fs',
'        p_facet_result_region_type   => ''CARD'',',
'        p_facet_columns              => wwv_flow_string.split( :P770_FACET_COLUMNS, '':'' ),',
'        -- card',
'        p_card_layout_type           => :P770_LAYOUT_TYPE,',
'        p_card_title_column_name     => :P770_TITLE_COLUMN_NAME,',
'        p_card_body_column_name      => :P770_BODY_COLUMN_NAME,',
'        p_card_icon_column_name      => :P770_ICON_COLUMN_NAME,',
'        p_card_badge_column_name     => :P770_BADGE_COLUMN_NAME );',
'                ',
'    :FB_FLOW_PAGE_ID       := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la p\00E1gina de informe.#SQLERRM#')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(12501734034146883.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12544589620146961.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La p\00E1gina del informe se ha creado correctamente.')
);
end;
/
prompt --application/pages/page_00771
begin
wwv_flow_api.create_page(
 p_id=>771.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina')
,p_alias=>'CREATE-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(58932177790855920.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107402180546151771.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107408592428156788.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92836304316872750.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2012171478952183.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(58932177790855920.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2012512760952190.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(58932177790855920.4001)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2012833577952190.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(58932177790855920.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:769:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2018355256952350.4001)
,p_branch_name=>'edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2012512760952190.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1701932920228101.4001)
,p_name=>'P771_FACETED_SEARCH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_item_default=>'N'
,p_prompt=>unistr('P\00E1gina Crear b\00FAsqueda de facetas')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica si se va a crear la p\00E1gina de mapa como p\00E1gina B\00FAsqueda por facetas. La regi\00F3n <strong>B\00FAsqueda por facetas</strong> contendr\00E1 \00FAnicamente una faceta <strong>Buscar</strong>. En el dise\00F1ador de p\00E1ginas se pueden agregar otras facetas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1903121062940726.4001)
,p_name=>'P771_GEOMETRY_COLUMN_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_item_default=>'GEOMETRY'
,p_prompt=>unistr('Tipo de columna de geometr\00EDa')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov=>'.'||wwv_flow_api.id(2214661182663976.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Los objetos espaciales (geometr\00EDas) que se van a mostrar en el mapa pueden tener su origen en una columna <strong>Geometr\00EDa</strong> o en dos columnas <strong>NUMBER</strong>, que contengan los valores de longitud y latitud (solo en capas de <str')
||'ong>puntos</strong> y de <strong>mapa de calor</strong>). </p>',
unistr('    <p> Las columnas Geometr\00EDa pueden ser de los tipos de datos <strong>SDO_GEOMETRY</strong>, <strong>VARCHAR2</strong> o <strong>CLOB</strong>. Las columnas VARCHAR2 y CLOB deben contener la informaci\00F3n de geometr\00EDa en formato GeoJSON.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1903980066940734.4001)
,p_name=>'P771_LON_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>'Columna de longitud'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una columna num\00E9rica que contenga valores de longitud. Los valores de la columna deben encontrarse entre -180 y 180.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1904099367940735.4001)
,p_name=>'P771_LAT_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>'Columna de latitud'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una columna num\00E9rica que contenga valores de latitud. Los valores de la columna deben encontrarse entre -90 y 90.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1904453121940739.4001)
,p_name=>'P771_3D_VALUE_COLUMN_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>'Columna de valor de altura en 3D'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P769_TABLE_OWNER',
'       and object_name = :P769_TABLE_NAME',
'       and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
'   and c003 = ''NUMBER''',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna que contenga el valor para determinar la altura del pol\00EDgono. El mapa visualizar\00E1 la altura en <em>metros</em>. Esta unidad se puede cambiar en el dise\00F1ador de p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2013517544952198.4001)
,p_name=>'P771_LAYER_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_item_default=>'POINT'
,p_prompt=>'Tipo de capa'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'MAP_REGION_LAYER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(2204527800561582.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Tipo de capa de geometr\00EDa espacial que mostrar en el mapa:'),
'</p>',
'<ul>',
'    <li><strong>Puntos</strong>: los puntos (por ejemplo, ubicaciones de clientes o proveedores) se muestran como marcadores. Se puede configurar tanto la forma como el color del marcador.</li>',
unistr('    <li><strong>L\00EDneas</strong>: las l\00EDneas representan funciones como carreteras o rutas. Se puede configurar tanto el estilo como el color del trazo.</li>'),
unistr('    <li><strong>Pol\00EDgonos</strong>: los pol\00EDgonos representan \00E1reas como parcelas, estados o pa\00EDses. Se puede configurar tanto el estilo como el color del trazo y del relleno.</li>'),
unistr('    <li><strong>Mapa de calor</strong>: los mapas de calor se usan para visualizar la densidad de las funciones de punto. Cuantos m\00E1s puntos se agrupen, m\00E1s intenso ser\00E1 el color. Se suelen usar para visualizar la distribuci\00F3n espacial de poblaci\00F3n o')
||' incidentes.</li>',
unistr('    <li><strong>Pol\00EDgonos extruidos</strong>: similares a los pol\00EDgonos, pero los pol\00EDgonos se muestran como objetos extruidos tridimensionales. La altura del objeto en 3D muestra un valor de una columna.</li>'),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2013903746952207.4001)
,p_name=>'P771_TOOLTIP_COLUMN_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>'Columna de Ayuda de Burbuja'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner = :P769_TABLE_OWNER',
'       and object_name = :P769_TABLE_NAME',
'       and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna que contiene el valor <strong>Pista</strong>, que se mostrar\00E1 cuando se pase el mouse sobre una geometr\00EDa espacial del mapa.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2014798306952209.4001)
,p_name=>'P771_VALUE_COLUMN_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>'Columna de valor de color'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si se seleccionan, a las geometr\00EDas espaciales del mapa se les asignar\00E1 un color en funci\00F3n del valor de esta columna.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2015146701952210.4001)
,p_name=>'P771_GEOM_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>unistr('Columna de Geometr\00EDa')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
'   and c003 in (''CLOB'', ''VARCHAR2'', ''SDO_GEOMETRY'' )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna de la geometr\00EDa espacial. Puede ser una columna del tipo SDO_GEOMETRY de Oracle o una columna VARCHAR2 o CLOB, que contenga datos de GeoJSON.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2229940844834407.4001)
,p_name=>'P771_HEAT_VALUE_COLUMN_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(107402180546151771.4001)
,p_prompt=>'Columna de valor de color'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''P771_DESCR_COLUMNS''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si se seleccionan, a las geometr\00EDas espaciales del mapa se les asignar\00E1 un color en funci\00F3n del valor de esta columna.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2230227586834410.4001)
,p_validation_name=>'Geometry Column NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P771_GEOM_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>'P771_GEOMETRY_COLUMN_TYPE'
,p_validation_condition2=>'GEOMETRY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2012512760952190.4001)
,p_associated_item=>wwv_flow_api.id(2015146701952210.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2230397573834411.4001)
,p_validation_name=>'Longitude Column NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P771_LON_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>'P771_GEOMETRY_COLUMN_TYPE'
,p_validation_condition2=>'NUMBER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2012512760952190.4001)
,p_associated_item=>wwv_flow_api.id(1903980066940734.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2230429532834412.4001)
,p_validation_name=>'Latitude Column NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P771_LAT_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>'P771_GEOMETRY_COLUMN_TYPE'
,p_validation_condition2=>'NUMBER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2012512760952190.4001)
,p_associated_item=>wwv_flow_api.id(1904099367940735.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2230609280834414.4001)
,p_validation_name=>'3D Value Column NOT NULL'
,p_validation_sequence=>50
,p_validation=>'P771_3D_VALUE_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>'P771_LAYER_TYPE'
,p_validation_condition2=>'POLYGON_3D'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(2012512760952190.4001)
,p_associated_item=>wwv_flow_api.id(1904453121940739.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2017312691952338.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2012171478952183.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2017858246952345.4001)
,p_event_id=>wwv_flow_api.id(2017312691952338.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1903213181940727.4001)
,p_name=>'Line Layer'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P771_LAYER_TYPE'
,p_condition_element=>'P771_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LINE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1903631944940731.4001)
,p_event_id=>wwv_flow_api.id(1903213181940727.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1903350959940728.4001)
,p_event_id=>wwv_flow_api.id(1903213181940727.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE,P771_3D_VALUE_COLUMN_NAME,P771_HEAT_VALUE_COLUMN_NAME,P771_VALUE_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2230021759834408.4001)
,p_event_id=>wwv_flow_api.id(1903213181940727.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_TOOLTIP_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1206503734248117.4001)
,p_name=>'Polygon Layer'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P771_LAYER_TYPE'
,p_condition_element=>'P771_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLYGON'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206608150248118.4001)
,p_event_id=>wwv_flow_api.id(1206503734248117.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206713552248119.4001)
,p_event_id=>wwv_flow_api.id(1206503734248117.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE,P771_3D_VALUE_COLUMN_NAME,P771_HEAT_VALUE_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1206829944248120.4001)
,p_event_id=>wwv_flow_api.id(1206503734248117.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_VALUE_COLUMN_NAME,P771_TOOLTIP_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1904750171940742.4001)
,p_name=>'3D Polygon Layer'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P771_LAYER_TYPE'
,p_condition_element=>'P771_LAYER_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'POLYGON_3D'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1904808034940743.4001)
,p_event_id=>wwv_flow_api.id(1904750171940742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1904979904940744.4001)
,p_event_id=>wwv_flow_api.id(1904750171940742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE,P771_HEAT_VALUE_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1905038608940745.4001)
,p_event_id=>wwv_flow_api.id(1904750171940742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_3D_VALUE_COLUMN_NAME,P771_VALUE_COLUMN_NAME,P771_TOOLTIP_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1905409845940749.4001)
,p_name=>'Point Layer'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P771_LAYER_TYPE'
,p_condition_element=>'P771_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POINT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2229311354834401.4001)
,p_event_id=>wwv_flow_api.id(1905409845940749.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE,P771_TOOLTIP_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2229465383834402.4001)
,p_event_id=>wwv_flow_api.id(1905409845940749.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_3D_VALUE_COLUMN_NAME,P771_HEAT_VALUE_COLUMN_NAME,P771_VALUE_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2229597589834403.4001)
,p_name=>'Heatmap Layer'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P771_LAYER_TYPE'
,p_condition_element=>'P771_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEATMAP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2229673284834404.4001)
,p_event_id=>wwv_flow_api.id(2229597589834403.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOMETRY_COLUMN_TYPE,P771_HEAT_VALUE_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2229740010834405.4001)
,p_event_id=>wwv_flow_api.id(2229597589834403.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_3D_VALUE_COLUMN_NAME,P771_VALUE_COLUMN_NAME,P771_TOOLTIP_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1903775210940732.4001)
,p_name=>'Geometry Column Type'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P771_GEOMETRY_COLUMN_TYPE'
,p_condition_element=>'P771_GEOMETRY_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1903894828940733.4001)
,p_event_id=>wwv_flow_api.id(1903775210940732.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOM_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1904303253940738.4001)
,p_event_id=>wwv_flow_api.id(1903775210940732.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_LON_COLUMN_NAME,P771_LAT_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1904101195940736.4001)
,p_event_id=>wwv_flow_api.id(1903775210940732.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_LON_COLUMN_NAME,P771_LAT_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1904260899940737.4001)
,p_event_id=>wwv_flow_api.id(1903775210940732.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P771_GEOM_COLUMN_NAME'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2016550050952333.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Map Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_table_owner    wwv_flow_global.t_dbms_id;',
'    l_table_name     wwv_flow_global.t_dbms_id;',
'    l_query_type     varchar2(255);',
'    l_sql            varchar2(32767);',
'',
'    l_geom_col_type  wwv_flow_map_region.t_feature_data_type;',
'begin',
'    if :P769_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner := :P769_TABLE_OWNER;',
'        l_table_name  := :P769_TABLE_NAME;',
'        l_query_type  := :P769_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_SQL;',
'    elsif :P769_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner := :P769_REMOTE_TABLE_OWNER;',
'        l_table_name  := :P769_REMOTE_TABLE_NAME;',
'        l_query_type  := :P769_REMOTE_REPORT_SOURCE_TYPE;',
'        l_sql         := :P769_REMOTE_SQL;',
'    end if;',
'    ',
'    if l_query_type = ''TABLE'' then',
'        l_query_type := wwv_flow_exec_api.c_query_type_table;',
'    else',
'        if substr(upper(ltrim( l_sql )),1,6)=''SELECT'' or',
'           substr(upper(ltrim( l_sql )),1,4)=''WITH''   ',
'        then',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_sql_query;',
'        else',
'            l_query_type :=  wwv_flow_exec_api.c_query_type_func_return_sql;',
'        end if;',
'    end if;',
'',
'    if :P771_GEOMETRY_COLUMN_TYPE = ''NUMBER'' then',
'        l_geom_col_type := wwv_flow_map_region.c_feature_number_columns;',
'    else',
'        l_geom_col_type := wwv_flow_map_region.c_feature_geojson;',
'',
'        for c in (',
'            select c003 ',
'              from wwv_flow_collections',
'             where collection_name = ''P771_DESCR_COLUMNS''',
'               and c002            = :P771_GEOM_COLUMN_NAME',
'               and c003            = ''SDO_GEOMETRY''',
'               and rownum          = 1         ',
'        ) loop',
'            l_geom_col_type := wwv_flow_map_region.c_feature_sdo_geometry;',
'        end loop;',
'    end if;',
'',
'    wwv_flow_map_region_dev.create_map_page(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P759_PAGE_ID,',
'        p_page_name                  => :P759_PAGE_NAME,',
'        p_page_mode                  => :P759_PAGE_MODE,',
'        p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'        --',
'        p_tab_set                    => :P4716_TAB_SET,',
'        p_tab_name                   => :P4716_TAB_NAME,',
'        p_tab_text                   => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id                => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id              => :P759_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P759_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P759_BREADCRUMB_PARENT_ID,',
'        --',
'        p_location                   => :P769_LOCATION,',
'        p_query_type                 => l_query_type,',
'        p_table_owner                => l_table_owner,',
'        p_table_name                 => l_table_name,',
'        p_map_source                 => l_sql,',
'        --',
'        p_remote_server_id           => :P769_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P769_WEB_SRC_MODULE_ID,',
'        --',
'        p_layer_name                 => :P759_PAGE_NAME,',
'        p_layer_type                 => case :P771_LAYER_TYPE',
'                                            when ''POINT''      then wwv_flow_map_region.c_map_layer_points',
'                                            when ''LINE''       then wwv_flow_map_region.c_map_layer_lines',
'                                            when ''POLYGON''    then wwv_flow_map_region.c_map_layer_polygons',
'                                            when ''HEATMAP''    then wwv_flow_map_region.c_map_layer_heat_map',
'                                            when ''POLYGON_3D'' then wwv_flow_map_region.c_map_layer_3d_polygons',
'                                        end,',
'        p_geometry_column_type       => l_geom_col_type,',
'        p_geometry_column            => :P771_GEOM_COLUMN_NAME,',
'        p_longitude_column           => :P771_LON_COLUMN_NAME,',
'        p_latitude_column            => :P771_LAT_COLUMN_NAME,',
'        p_value_column               => case :P771_LAYER_TYPE',
'                                            when ''HEATMAP'' then :P771_HEAT_VALUE_COLUMN_NAME',
'                                            else                :P771_VALUE_COLUMN_NAME',
'                                         end,',
'        p_extrude_value_column       => :P771_3D_VALUE_COLUMN_NAME,',
'        p_tooltip_column             => :P771_TOOLTIP_COLUMN_NAME,',
'        --',
'        p_faceted_search_page        => :P771_FACETED_SEARCH = ''Y'' );',
'                ',
'    :FB_FLOW_PAGE_ID       := :P759_PAGE_ID;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No se ha podido crear la p\00E1gina Mapa.'),
'#SQLERRM#'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2012512760952190.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2016253513952330.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La p\00E1gina Mapa se ha creado correctamente.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1903011447940725.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Describe Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_collection_name varchar2(30) := ''P771_DESCR_COLUMNS'';',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( p_collection_name => c_collection_name );',
'',
'    for c in (',
'        select column_name_esc, column_name, data_type',
'            from table(wwv_flow_exec_dev.get_query_columns(',
'                p_location          => :P769_LOCATION,',
'                p_query_type        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                            case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                                ''SQL''',
'                                            else :P769_REPORT_SOURCE_TYPE',
'                                            end',
'                                        when :P769_LOCATION = ''REMOTE'' then',
'                                            case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                                ''SQL''',
'                                            else :P769_REMOTE_REPORT_SOURCE_TYPE',
'                                            end',
'                                        end,',
'                p_owner             =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                            case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                                :P769_TABLE_OWNER',
'                                            end',
'                                        when :P769_LOCATION = ''REMOTE'' then',
'                                            case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                                :P769_REMOTE_TABLE_OWNER',
'                                            end',
'                                        end,',
'                p_table_name        =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                            case when :P769_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                                :P769_TABLE_NAME',
'                                            end',
'                                        when :P769_LOCATION = ''REMOTE'' then',
'                                            case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''TABLE'' then',
'                                                :P769_REMOTE_TABLE_NAME',
'                                            end',
'                                        end,',
'                p_sql_query         =>  case when :P769_LOCATION = ''LOCAL'' then',
'                                            case when :P769_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                                :P769_SQL',
'                                            end',
'                                        when :P769_LOCATION = ''REMOTE'' then',
'                                            case when :P769_REMOTE_REPORT_SOURCE_TYPE = ''QUERY'' then',
'                                                :P769_REMOTE_SQL',
'                                            end',
'                                        end,      ',
'                p_web_src_module_id =>  case when :P769_LOCATION = ''WEB_SOURCE'' then',
'                                            :P769_WEB_SRC_MODULE_ID',
'                                        end,',
'                p_remote_server_id  =>  case when :P769_LOCATION = ''REMOTE'' then',
'                                            :P769_REMOTE_SERVER_ID',
'                                        end ))',
'    ) loop',
'        wwv_flow_collection.add_member(',
'            p_collection_name => c_collection_name,',
'            p_c001            => c.column_name_esc,',
'            p_c002            => c.column_name,',
'            p_c003            => c.data_type );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00773
begin
wwv_flow_api.create_page(
 p_id=>773.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Acciones Din\00E1micas')
,p_step_title=>unistr('Acciones Din\00E1micas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4518805581694342)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28089708731128416.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28089918151128417.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(28119925264668131.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(196753223215607951.4001)
,p_name=>unistr('Editar Varias Acciones Din\00E1micas')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>125
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.id,',
'       e.id id_display,',
'       e.name,',
'       e.event_sequence,',
'       ''('' || e.bind_event_type || '') '' ||',
'       case e.triggering_element_type ',
'           when ''ITEM'' then e.triggering_element ',
'           when ''REGION'' then p.plug_name',
'           when ''COLUMN'' then p.plug_name || '' (Region) > '' || e.triggering_element',
'           when ''DOM_OBJECT'' then e.triggering_element',
'           when ''JQUERY_SELECTOR'' then e.triggering_element',
'           when ''JAVASCRIPT_EXPRESSION'' then e.triggering_element',
'       end || '' ('' || e.triggering_element_type || '')'' triggering_event_elements,        ',
'       e.triggering_element,',
'       e.triggering_element_type,',
'       e.triggering_region_id,',
'       e.triggering_condition_type,',
'       e.triggering_expression,',
'       decode(e.display_when_type, null, '''',',
'            ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'')    conditional,',
'       e.last_updated_on,',
'       (select count(1) ',
'          from wwv_flow_page_da_actions ',
'         where event_id = e.id ',
'           and event_result = ''TRUE'' ) true_action_count,',
'       (select count(1) ',
'          from wwv_flow_page_da_actions ',
'         where event_id = e.id ',
'           and event_result = ''FALSE'' ) false_action_count',
'  from wwv_flow_page_da_events e,',
'       wwv_flow_page_plugs p',
' where e.triggering_region_id = p.id (+)',
'   and e.security_group_id = :flow_security_group_id',
'   and e.flow_id = :fb_flow_id ',
'   and e.page_id = :fb_flow_page_id',
' order by e.event_sequence'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna acci\00F3n din\00E1mica.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196753520741607953.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196753604523607953.4001)
,p_query_column_id=>2
,p_column_alias=>'ID_DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Editar'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::#5140:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'ID_DISPLAY'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196753726139607953.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196753805234607953.4001)
,p_query_column_id=>4
,p_column_alias=>'EVENT_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>2
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'EVENT_SEQUENCE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196893922250225545.4001)
,p_query_column_id=>5
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>5
,p_column_heading=>'When'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196753920988607953.4001)
,p_query_column_id=>6
,p_column_alias=>'TRIGGERING_ELEMENT'
,p_column_display_sequence=>7
,p_column_heading=>'Element'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_column_width=>16
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'TRIGGERING_ELEMENT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196754001266607953.4001)
,p_query_column_id=>7
,p_column_alias=>'TRIGGERING_ELEMENT_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Selection Type'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(34817614503562438)
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'TRIGGERING_ELEMENT_TYPE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196754113956607953.4001)
,p_query_column_id=>8
,p_column_alias=>'TRIGGERING_REGION_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Region'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(246039671)
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'TRIGGERING_REGION_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196754200169607953.4001)
,p_query_column_id=>9
,p_column_alias=>'TRIGGERING_CONDITION_TYPE'
,p_column_display_sequence=>8
,p_column_heading=>'Condition Type'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(4505805282372682)
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'TRIGGERING_CONDITION_TYPE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196754301713607953.4001)
,p_query_column_id=>10
,p_column_alias=>'TRIGGERING_EXPRESSION'
,p_column_display_sequence=>10
,p_column_heading=>'Expression'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'TRIGGERING_EXPRESSION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196758008817643668.4001)
,p_query_column_id=>11
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>11
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196754524790607954.4001)
,p_query_column_id=>12
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>14
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_ref_column_name=>'LAST_UPDATED_ON'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196870521917094095.4001)
,p_query_column_id=>13
,p_column_alias=>'TRUE_ACTION_COUNT'
,p_column_display_sequence=>12
,p_column_heading=>'Acciones Verdaderas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196870624481094095.4001)
,p_query_column_id=>14
,p_column_alias=>'FALSE_ACTION_COUNT'
,p_column_display_sequence=>13
,p_column_heading=>'Acciones Falsas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196756915774643666.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757009286643667.4001)
,p_column_sequence=>2
,p_query_column_name=>'ID_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757112018643667.4001)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757200958643667.4001)
,p_column_sequence=>4
,p_query_column_name=>'EVENT_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196892929125225543.4001)
,p_column_sequence=>5
,p_query_column_name=>'TRIGGERING_EVENT_ELEMENTS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757308907643667.4001)
,p_column_sequence=>6
,p_query_column_name=>'TRIGGERING_ELEMENT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757406179643667.4001)
,p_column_sequence=>7
,p_query_column_name=>'TRIGGERING_ELEMENT_TYPE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757506338643667.4001)
,p_column_sequence=>8
,p_query_column_name=>'TRIGGERING_REGION_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757620310643667.4001)
,p_column_sequence=>9
,p_query_column_name=>'TRIGGERING_CONDITION_TYPE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757704359643667.4001)
,p_column_sequence=>10
,p_query_column_name=>'TRIGGERING_EXPRESSION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757804753643667.4001)
,p_column_sequence=>11
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196757912384643667.4001)
,p_column_sequence=>12
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196870328828094094.4001)
,p_column_sequence=>13
,p_query_column_name=>'TRUE_ACTION_COUNT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(196870406532094094.4001)
,p_column_sequence=>14
,p_query_column_name=>'FALSE_ACTION_COUNT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28091925885128447.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(28089708731128416.4001)
,p_button_name=>'P773_GO'
,p_button_static_id=>'P773_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28091013424128442.4001)
,p_button_sequence=>25
,p_button_plug_id=>wwv_flow_api.id(28089708731128416.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28090820942128442.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(28089708731128416.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_page_da_events',
' where flow_id=:FB_FLOW_ID ',
'   and page_id=:FB_FLOW_PAGE_ID'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28091226890128442.4001)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_api.id(28089708731128416.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196756613359607977.4001)
,p_branch_action=>'f?p=&APP_ID.:773:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28091421946128443.4001)
,p_name=>'P773_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(28089708731128416.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(28092220754128448.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'773'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(28092410054128449.4001)
,p_computation_sequence=>2
,p_computation_item=>'F4000_P4316_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_PAGE_VALIDATION'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(28092625698128450.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1284939170933602443.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P773_PAGE_ID''),v(''FB_FLOW_PAGE_ID''));'
,p_computation_error_message=>unistr('No se ha podido calcular el valor de la p\00E1gina actual.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(196899102342245227.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(196753223215607951.4001)
,p_validation_name=>'NAME not null'
,p_validation_sequence=>10
,p_validation=>'NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(196986916418015630.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(196753223215607951.4001)
,p_validation_name=>'EVENT_SEQUENCE not null'
,p_validation_sequence=>20
,p_validation=>'EVENT_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La secuencia debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'EVENT_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(196755717298607975.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(196753223215607951.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_PAGE_DA_EVENTS'
,p_attribute_03=>'ID'
,p_process_error_message=>unistr('No se ha podido procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(28090820942128442.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00776
begin
wwv_flow_api.create_page(
 p_id=>776.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Informe Basado en Resultado de Servicio Web: Atributos de P\00E1gina y de Regi\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Informe Basado en Resultado de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_form.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44520323653884508.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114027203797330126.4001)
,p_plug_name=>'Crear Informe Basado en Resultado de Servicio Web'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Identifique el n\00FAmero y el nombre de la p\00E1gina.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114027401232330127.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114028311710330137.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44520323653884508.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114028123140330136.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44520323653884508.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699451484505457010.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(44520323653884508.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114035817522330150.4001)
,p_branch_action=>'4795'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(114028123140330136.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P776_FLOW_STEP_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114036009983330151.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114028123140330136.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114036208849330151.4001)
,p_branch_action=>'f?p=&APP_ID.:776:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P776_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699451580360458920.4001)
,p_branch_action=>'4700'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699451484505457010.4001)
,p_branch_sequence=>100
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45257317371024144.4001)
,p_name=>'P776_PAGE_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114028505109330138.4001)
,p_name=>'P776_REGION_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre para la regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114029008982330139.4001)
,p_name=>'P776_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique un nombre para la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114029509737330140.4001)
,p_name=>'P776_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114030004201330140.4001)
,p_name=>'P776_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina.<p />'),
'',
unistr('Si identifica un n\00FAmero de p\00E1gina existente, el asistente agrega el componente a esa p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114030502631330142.4001)
,p_name=>'P776_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114031023509330142.4001)
,p_name=>'P776_BREADCRUMB_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P776_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114034232623330146.4001)
,p_name=>'P776_REGION_TEMPLATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una plantilla de regi\00F3n para la regi\00F3n en la que aparecer\00E1 el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381582856061964532.4001)
,p_name=>'P776_BREADCRUMB_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P776_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P776_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P776_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403499162057490698.4001)
,p_name=>'P776_GROUP_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(114027203797330126.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940938788586728599.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P776_PAGE_NAME'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114034814076330147.4001)
,p_validation_name=>'Page ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P776_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(114030004201330140.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114035004363330148.4001)
,p_validation_name=>'Page Name Not Null'
,p_validation_sequence=>20
,p_validation=>'P776_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_validation_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and id = :P776_PAGE_ID'
,p_validation_condition_type=>'NOT_EXISTS'
,p_associated_item=>wwv_flow_api.id(114029008982330139.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'Only verify page names for new pages.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45257912411026435.4001)
,p_validation_name=>'P776_PAGE_MODE Not Null'
,p_validation_sequence=>25
,p_validation=>'P776_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(114028123140330136.4001)
,p_associated_item=>wwv_flow_api.id(45257317371024144.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114035220069330148.4001)
,p_validation_name=>'P776_BREADCRUMB_NAME'
,p_validation_sequence=>30
,p_validation=>'P776_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P776_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(114028123140330136.4001)
,p_associated_item=>wwv_flow_api.id(114031023509330142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114035606277330149.4001)
,p_validation_name=>'P776_REGION_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P776_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de regi\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(114028123140330136.4001)
,p_associated_item=>wwv_flow_api.id(114028505109330138.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(481363823890067581.4001)
,p_validation_name=>'P776_PAGE_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'trunc(abs(:P776_PAGE_ID)) = :P776_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(114028123140330136.4001)
,p_associated_item=>wwv_flow_api.id(114030004201330140.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403499606407492351.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P776_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P776_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(114028123140330136.4001)
,p_associated_item=>wwv_flow_api.id(403499162057490698.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381583827289993680.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P776_BREADCRUMB_ID'
,p_condition_element=>'P776_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381584120685993680.4001)
,p_event_id=>wwv_flow_api.id(381583827289993680.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_BREADCRUMB_NAME,P776_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381584303907993681.4001)
,p_event_id=>wwv_flow_api.id(381583827289993680.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_BREADCRUMB_NAME,P776_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549743108592954532.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114028311710330137.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549743238352954533.4001)
,p_event_id=>wwv_flow_api.id(549743108592954532.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1940937423754727337.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P776_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940938392592727338.4001)
,p_event_id=>wwv_flow_api.id(1940937423754727337.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P776_PAGE_NAME'
,p_attribute_07=>'P776_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940937884132727338.4001)
,p_event_id=>wwv_flow_api.id(1940937423754727337.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P776_PAGE_NAME'
,p_attribute_07=>'P776_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00778
begin
wwv_flow_api.create_page(
 p_id=>778.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Informe sobre Servicios Web'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44531023054941145.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114050828132368748.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114051029470368749.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114051918987368750.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44531023054941145.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114052117705368750.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44531023054941145.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114052317233368750.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44531023054941145.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114053300781368751.4001)
,p_branch_action=>'P778_WEB_REF_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_when_button_id=>wwv_flow_api.id(114052117705368750.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114053110668368751.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114052317233368750.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114052515261368751.4001)
,p_name=>'P778_WEB_REF_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_item_default=>'860'
,p_prompt=>'Tipo de Referencia Web:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P778_WEBREF_TYPE'
,p_lov=>'.'||wwv_flow_api.id(114277222597792014.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Seleccione si la referencia Web se ha creado de forma manual o proporcionando un documento WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253078626273538045.4001)
,p_name=>'P778_REST_WS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''REST''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Servicio --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253078729884538046.4001)
,p_name=>'P778_REST_OPERATION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253078954868538048.4001)
,p_name=>'P778_WSDL_WS_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P779_WSDL_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''NEW_SCHOOL''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Servicio --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253079085401538049.4001)
,p_name=>'P778_WSDL_OPERATION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>unistr('Operaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P778_WSDL_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('-- Seleccionar Operaci\00F3n --')
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P778_WSDL_WS_ID'
,p_ajax_items_to_submit=>'P778_WSDL_WS_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la operaci\00F3n. La operaci\00F3n es el m\00E9todo que se va a ejecutar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253079152835538050.4001)
,p_name=>'P778_WSDL_ARRAY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P778_WSDL_OPERATION_ID'))
,p_lov_cascade_parent_items=>'P778_WSDL_OPERATION_ID'
,p_ajax_items_to_submit=>'P778_WSDL_OPERATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(272277507404934701.4001)
,p_name=>'P778_MAN_WS_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB SERVICES OLD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Servicio --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(272277677571934702.4001)
,p_name=>'P778_MAN_SOAP_STYLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_item_default=>'document'
,p_prompt=>'Estilo de SOAP:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.SOAP.STYLE'
,p_lov=>'.'||wwv_flow_api.id(40229315139441290.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el estilo de la respuesta SOAP. El estilo se puede determinar a partir del atributo de estilo del elemento soap:binding de WSDL de esta operaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(272277768861934703.4001)
,p_name=>'P778_MAN_MSG_FORMAT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_item_default=>'literal'
,p_prompt=>'Formato del Mensaje:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.MESSAGE.STYLE'
,p_lov=>'.'||wwv_flow_api.id(40231925790463373.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el formato del mensaje. La codificaci\00F3n se puede determinar a partir del atributo de uso del elemento soap:body del mensaje de salida de WSDL de esta operaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(272277885166934704.4001)
,p_name=>'P778_NODE_PATH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>'Ruta de Acceso del Nodo de Resultados (XPath) '
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la expresi\00F3n XPath al nodo del mensaje de respuesta en el que est\00E1 creando el informe. El nodo es un secundario del elemento soap:Body. Por ejemplo,'),
'<p />/result/myNode'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(272277984965934705.4001)
,p_name=>'P778_MAN_MSG_NAMESAPECE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(114050828132368748.4001)
,p_prompt=>'Espacio de Nombres de Mensaje'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el espacio de nombres para el mensaje de respuesta. Normalmente se puede determinar consultando el atributo targetNamespace de WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(253078886025538047.4001)
,p_computation_sequence=>10
,p_computation_item=>'P778_REST_OPERATION_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_ws_operations',
' where ws_id = :P778_REST_WS_ID',
'   and name = ''doREST'''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(272278139063934707.4001)
,p_validation_name=>'Rest Webservice not null'
,p_validation_sequence=>10
,p_validation=>'P778_REST_WS_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'860'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(272278276818934708.4001)
,p_validation_name=>'WSDL Webservice not null'
,p_validation_sequence=>20
,p_validation=>'P778_WSDL_WS_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'782'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(272278576072934711.4001)
,p_validation_name=>'WSDL Operation ID not null'
,p_validation_sequence=>30
,p_validation=>'nvl(:P778_WSDL_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe seleccionar una operaci\00F3n.')
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'782'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(272278414019934710.4001)
,p_validation_name=>'WSDL Array not null'
,p_validation_sequence=>40
,p_validation=>'P778_WSDL_ARRAY'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Debe seleccionar el nodo base.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'782'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(272278302865934709.4001)
,p_validation_name=>'manual Webservice not'
,p_validation_sequence=>50
,p_validation=>'P778_MAN_WS_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'783'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(272278607658934712.4001)
,p_validation_name=>'manual node path not null'
,p_validation_sequence=>60
,p_validation=>'P778_NODE_PATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe proporcionar la XPath al nodo del informe.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'783'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549884795809989004.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114051918987368750.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549884835102989005.4001)
,p_event_id=>wwv_flow_api.id(549884795809989004.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(272278768576934713.4001)
,p_name=>'display REST items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P778_WEB_REF_TYPE'
,p_condition_element=>'P778_WEB_REF_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'860'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(272278871699934714.4001)
,p_event_id=>wwv_flow_api.id(272278768576934713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_REST_WS_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(272279000141934716.4001)
,p_event_id=>wwv_flow_api.id(272278768576934713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_WSDL_WS_ID,P778_WSDL_OPERATION_ID,P778_WSDL_ARRAY,P778_MAN_WS_ID,P778_MAN_SOAP_STYLE,P778_MAN_MSG_FORMAT,P778_NODE_PATH,P778_MAN_MSG_NAMESAPECE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(272279240823934718.4001)
,p_name=>'Display WSDL items'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P778_WEB_REF_TYPE'
,p_condition_element=>'P778_WEB_REF_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'782'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(272279331356934719.4001)
,p_event_id=>wwv_flow_api.id(272279240823934718.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_WSDL_WS_ID,P778_WSDL_OPERATION_ID,P778_WSDL_ARRAY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(272279541790934721.4001)
,p_event_id=>wwv_flow_api.id(272279240823934718.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_REST_WS_ID,P778_MAN_WS_ID,P778_MAN_SOAP_STYLE,P778_MAN_MSG_FORMAT,P778_MAN_MSG_NAMESAPECE,P778_NODE_PATH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(272279785977934723.4001)
,p_name=>'display manual ittems'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P778_WEB_REF_TYPE'
,p_condition_element=>'P778_WEB_REF_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'783'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(272279817707934724.4001)
,p_event_id=>wwv_flow_api.id(272279785977934723.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_MAN_WS_ID,P778_MAN_SOAP_STYLE,P778_MAN_MSG_FORMAT,P778_NODE_PATH,P778_MAN_MSG_NAMESAPECE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(272280074378934726.4001)
,p_event_id=>wwv_flow_api.id(272279785977934723.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_REST_WS_ID,P778_WSDL_WS_ID,P778_WSDL_OPERATION_ID,P778_WSDL_ARRAY'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00779
begin
wwv_flow_api.create_page(
 p_id=>779.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44534604616954742.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114059531046385729.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114060107277385730.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114061031636385731.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44534604616954742.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114061224849385731.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44534604616954742.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114060811620385731.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44534604616954742.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114063615063385734.4001)
,p_branch_action=>'f?p=&APP_ID.:782:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114061031636385731.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114063807849385734.4001)
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114061224849385731.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114064020861385734.4001)
,p_branch_action=>'f?p=&FLOW_ID.:779:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114061409215385731.4001)
,p_name=>'P779_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114060107277385730.4001)
,p_prompt=>unistr('Operaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P779_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P779_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('-- Seleccionar Operaci\00F3n --')
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P779_WS_ID'
,p_ajax_items_to_submit=>'P779_WS_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la operaci\00F3n. La operaci\00F3n es el m\00E9todo que se va a ejecutar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114061916291385732.4001)
,p_name=>'P779_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114060107277385730.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P779_WSDL_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''NEW_SCHOOL''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Servicio --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114062422047385732.4001)
,p_name=>'P779_ARRAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114060107277385730.4001)
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P779_ARRAYS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P779_OPERATION_ID'))
,p_lov_cascade_parent_items=>'P779_OPERATION_ID'
,p_ajax_items_to_submit=>'P779_OPERATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione la parte del documento XML resultante que contiene la informaci\00F3n que desea incluir en el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114063018695385733.4001)
,p_validation_name=>'P779_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P779_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(114061031636385731.4001)
,p_associated_item=>wwv_flow_api.id(114061916291385732.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114063200898385733.4001)
,p_validation_name=>'P779_OPERATION_ID'
,p_validation_sequence=>20
,p_validation=>'nvl(:P779_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Debe seleccionar una operaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(114061031636385731.4001)
,p_associated_item=>wwv_flow_api.id(114061409215385731.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114063411340385734.4001)
,p_validation_name=>'P779_ARRAY'
,p_validation_sequence=>30
,p_validation=>'P779_ARRAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe seleccionar el nodo base.'
,p_when_button_pressed=>wwv_flow_api.id(114061031636385731.4001)
,p_associated_item=>wwv_flow_api.id(114062422047385732.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549885393002989010.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114060811620385731.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549885460110989011.4001)
,p_event_id=>wwv_flow_api.id(549885393002989010.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00781
begin
wwv_flow_api.create_page(
 p_id=>781.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44541017569043691.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114089415117408247.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114089808659408248.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114090903813408249.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44541017569043691.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114091128182408249.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44541017569043691.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114090728856408249.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44541017569043691.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114094315672408253.4001)
,p_branch_action=>'f?p=&APP_ID.:783:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114090903813408249.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114094523407408253.4001)
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114091128182408249.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114094701080408253.4001)
,p_branch_action=>'f?p=&FLOW_ID.:781:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114091313742408250.4001)
,p_name=>'P781_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114089808659408248.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB SERVICES OLD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Servicio --'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114091802532408250.4001)
,p_name=>'P781_SOAP_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114089808659408248.4001)
,p_item_default=>'document'
,p_prompt=>'Estilo de SOAP:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.SOAP.STYLE'
,p_lov=>'.'||wwv_flow_api.id(40229315139441290.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el estilo de la respuesta SOAP. El estilo se puede determinar a partir del atributo de estilo del elemento soap:binding de WSDL de esta operaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114092301300408251.4001)
,p_name=>'P781_MESSAGE_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114089808659408248.4001)
,p_item_default=>'literal'
,p_prompt=>'Formato del Mensaje:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.MESSAGE.STYLE'
,p_lov=>'.'||wwv_flow_api.id(40231925790463373.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el formato del mensaje. La codificaci\00F3n se puede determinar a partir del atributo de uso del elemento soap:body del mensaje de salida de WSDL de esta operaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114092828994408251.4001)
,p_name=>'P781_MESSAGE_NAMESPACE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(114089808659408248.4001)
,p_prompt=>'Espacio de Nombres de Mensaje'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca el espacio de nombres para el mensaje de respuesta. Normalmente se puede determinar consultando el atributo targetNamespace de WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114093302903408252.4001)
,p_name=>'P781_NODE_PATH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114089808659408248.4001)
,p_prompt=>'Ruta de Acceso del Nodo de Resultados (XPath) '
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la expresi\00F3n XPath al nodo del mensaje de respuesta en el que est\00E1 creando el informe. El nodo es un secundario del elemento soap:Body. Por ejemplo,'),
'<p />/result/myNode'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114093930098408252.4001)
,p_validation_name=>'P781_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P781_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(114090903813408249.4001)
,p_associated_item=>wwv_flow_api.id(114091313742408250.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114094103793408252.4001)
,p_validation_name=>'P781_NODE_PATH'
,p_validation_sequence=>20
,p_validation=>'P781_NODE_PATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe proporcionar la XPath al nodo del informe.'
,p_when_button_pressed=>wwv_flow_api.id(114090903813408249.4001)
,p_associated_item=>wwv_flow_api.id(114093302903408252.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549885165163989008.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114090728856408249.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549885288346989009.4001)
,p_event_id=>wwv_flow_api.id(549885165163989008.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00782
begin
wwv_flow_api.create_page(
 p_id=>782.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114109628559435534.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,null,:P782_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where type_is_xsd = ''Y''',
'   and parent_id = :P778_WSDL_ARRAY'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114109806806435535.4001)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" value="x" onclick="ToggleAll(this)" />'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114109909540435535.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114110007823435535.4001)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114110127018435535.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114110302855435535.4001)
,p_plug_name=>'Informe SQL Basado en Resultado de Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique un nombre de juego de resultados temporal y seleccione los par\00E1metros de la matriz para incluir en el informe.</p>'),
unistr('<p>Para seleccionar o anular la selecci\00F3n de todos los par\00E1metros, active la casilla de control de la cabecera de columna.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206211417199416792.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114111425081435537.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(206211417199416792.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114111630838435537.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206211417199416792.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114111222731435536.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206211417199416792.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114115503474435543.4001)
,p_branch_action=>'f?p=&APP_ID.:786:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114111425081435537.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114115322234435543.4001)
,p_branch_name=>'Go To Page 778'
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114111630838435537.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114111819134435537.4001)
,p_name=>'P782_CHECKED_ITEMS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114109628559435534.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114112010206435537.4001)
,p_name=>'P782_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114109628559435534.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_source=>'P778_WSDL_ARRAY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P778_WSDL_OPERATION_ID'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('\00C9sta es la parte del documento XML resultante que contiene la informaci\00F3n que desea incluir en el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114112513527435538.4001)
,p_name=>'P782_ROW_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114109628559435534.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Informe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la plantilla de informe que va a utilizar esta regi\00F3n de informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114113020191435538.4001)
,p_name=>'P782_ROWS_PER_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(114109628559435534.4001)
,p_item_default=>'15'
,p_prompt=>unistr('Filas por P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas para visualizar por p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114113530441435539.4001)
,p_name=>'P782_RESULT_COLLECTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114109628559435534.4001)
,p_prompt=>unistr('Resultado Almacenado en Recopilaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre del juego de resultados temporal en el que se almacenar\00E1 el resultado del servicio Web. El juego de resultados temporal se almacena en una recopilaci\00F3n de &PRODUCT_NAME. en la columna CLOB001.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(114114103063435541.4001)
,p_computation_sequence=>10
,p_computation_item=>'P782_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(114114308265435541.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114114505374435541.4001)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos un par\00E1metro para el informe.')
,p_when_button_pressed=>wwv_flow_api.id(114111425081435537.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114114731167435542.4001)
,p_validation_name=>'P782_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P782_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar el nombre de la recopilaci\00F3n que contiene el resultado del servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(114111425081435537.4001)
,p_associated_item=>wwv_flow_api.id(114113530441435539.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549885759101989014.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114111222731435536.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549885872378989015.4001)
,p_event_id=>wwv_flow_api.id(549885759101989014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114114811465435542.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(272280362328934729.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report on WS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_report_temp  varchar2(4000) := null;',
'  l_rows_per_pg  varchar2(4000) := null;',
'  l_sql          varchar2(32000);',
'begin',
'  if :P778_WEB_REF_TYPE = ''782'' then',
'    ',
'    l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_WSDL_OPERATION_ID,',
'                p_array_parm                => :P778_WSDL_ARRAY,',
'                p_report_collection_name    => :P782_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );  ',
'',
'    l_report_temp := :P782_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P782_ROWS_PER_PAGE;',
'',
'  elsif :P778_WEB_REF_TYPE = ''860'' then',
'    ',
'  l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_REST_OPERATION_ID,',
'                p_array_parm                => null,',
'                p_report_collection_name    => :P860_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );',
'',
'    l_report_temp := :P860_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P860_ROWS_PER_PAGE;',
'',
'  else',
'',
'    l_sql := wwv_flow_web_services.generate_query_manual(',
'                p_result_node               => :P778_NODE_PATH,',
'                p_soap_style                => :P778_MAN_SOAP_STYLE,',
'                p_message_format            => :P778_MAN_MSG_FORMAT,',
'                p_namespace                 => :P778_MAN_MSG_NAMESAPECE,',
'                p_report_collection_name    => :P783_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_REPORT_ITEMS'');    ',
'',
'    l_report_temp := :P783_ROW_TEMPLATE;                 ',
'    l_rows_per_pg := :P783_ROWS_PER_PAGE;     ',
'               ',
'  end if;        ',
'  ',
'  ',
'  wwv_flow_wizard_api.create_report_on_ws(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :P759_PAGE_ID,',
'      p_page_name                => :P759_PAGE_NAME,',
'      p_group_name               => null,',
'      p_page_mode                => :P759_PAGE_MODE,',
'      p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'      p_region_name              => :P759_PAGE_NAME,',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                        p_application_id => :FB_FLOW_ID,',
'                                        p_theme_id       => :FB_THEME_ID,',
'                                        p_page_type      => :P259_CHOOSE_PAGE_TYPE),',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_report_template          => l_report_temp,',
'      p_rows_per_page            => nvl(l_rows_per_pg,''15''),',
'      --',
'      p_breadcrumb_id            => :P759_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P759_BREADCRUMB_NAME,',
'      p_parent_bc_id             => :P759_BREADCRUMB_PARENT_ID,',
'      --',
'      p_query                    => l_sql );',
'',
'  :fb_flow_page_id       := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00783
begin
wwv_flow_api.create_page(
 p_id=>783.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114125816665452273.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id id, c001 name',
'  from wwv_flow_collections',
' where collection_name = ''WS_REPORT_ITEMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114126016159452274.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114126115123452274.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombres de Par\00E1metro')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114126231695452274.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206215404264479273.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114127304568452275.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206215404264479273.4001)
,p_button_name=>'ADDPARAMETER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114127714203452276.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206215404264479273.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114127930613452276.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206215404264479273.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114127505576452275.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(206215404264479273.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114132024721452280.4001)
,p_branch_name=>'Go To Page 778'
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114127930613452276.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114132211415452280.4001)
,p_branch_action=>'f?p=&APP_ID.:786:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114127714203452276.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114132414590452281.4001)
,p_branch_action=>'f?p=&FLOW_ID.:783:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114127304568452275.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114128102951452276.4001)
,p_name=>'P783_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114125816665452273.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_source=>'P778_NODE_PATH'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('\00C9sta es la parte del documento XML resultante que contiene la informaci\00F3n que desea incluir en el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114128608360452277.4001)
,p_name=>'P783_RESULT_COLLECTION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(114125816665452273.4001)
,p_prompt=>unistr('Resultado Almacenado en Recopilaci\00F3n')
,p_source=>'select static_parm_03 from wwv_flow_shared_web_services where id = :P778_MAN_WS_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre del juego de resultados temporal en el que se almacenar\00E1 el resultado del servicio Web. El juego de resultados temporal se almacena en una recopilaci\00F3n de &PRODUCT_NAME. en la columna CLOB001.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114129115967452277.4001)
,p_name=>'P783_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114125816665452273.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114129328309452277.4001)
,p_name=>'P783_ROW_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114125816665452273.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Informe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la plantilla de informe que va a utilizar esta regi\00F3n de informe.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114129802926452278.4001)
,p_name=>'P783_ROWS_PER_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114125816665452273.4001)
,p_item_default=>'15'
,p_prompt=>unistr('Filas por P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas para visualizar por p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(114130430593452278.4001)
,p_computation_sequence=>10
,p_computation_item=>'P783_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(114130619111452278.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114130805495452279.4001)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos un par\00E1metro para el informe.')
,p_when_button_pressed=>wwv_flow_api.id(114127714203452276.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114131000490452279.4001)
,p_validation_name=>'P783_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P783_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar el nombre de la recopilaci\00F3n que contiene el resultado del servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(114127714203452276.4001)
,p_associated_item=>wwv_flow_api.id(114128608360452277.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549884951288989006.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114127505576452275.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549885063865989007.4001)
,p_event_id=>wwv_flow_api.id(549884951288989006.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114131115607452279.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_REPORT_ITEMS'',',
'  p_seq             => wwv_flow.g_f01,',
'  p_c001            => wwv_flow.g_f02 );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114131322122452279.4001)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add parameter'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.add_member(',
'  p_collection_name => ''WS_REPORT_ITEMS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(114127304568452275.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(272280228175934728.4001)
,p_process_sequence=>25
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report on web service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_report_temp  varchar2(4000) := null;',
'  l_rows_per_pg  varchar2(4000) := null;',
'  l_sql          varchar2(32000);',
'begin',
'  if :P778_WEB_REF_TYPE = ''782'' then',
'    ',
'    l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_WSDL_OPERATION_ID,',
'                p_array_parm                => :P778_WSDL_ARRAY,',
'                p_report_collection_name    => :P782_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );  ',
'',
'    l_report_temp := :P782_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P782_ROWS_PER_PAGE;',
'',
'  elsif :P778_WEB_REF_TYPE = ''860'' then',
'    ',
'  l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_REST_OPERATION_ID,',
'                p_array_parm                => null,',
'                p_report_collection_name    => :P860_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );',
'',
'    l_report_temp := :P860_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P860_ROWS_PER_PAGE;',
'',
'  else',
'',
'    l_sql := wwv_flow_web_services.generate_query_manual(',
'                p_result_node               => :P778_NODE_PATH,',
'                p_soap_style                => :P778_MAN_SOAP_STYLE,',
'                p_message_format            => :P778_MAN_MSG_FORMAT,',
'                p_namespace                 => :P778_MAN_MSG_NAMESAPECE,',
'                p_report_collection_name    => :P783_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_REPORT_ITEMS'');    ',
'',
'    l_report_temp := :P783_ROW_TEMPLATE;                 ',
'    l_rows_per_pg := :P783_ROWS_PER_PAGE;     ',
'               ',
'  end if;        ',
'  ',
'  ',
'  wwv_flow_wizard_api.create_report_on_ws(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :P759_PAGE_ID,',
'      p_page_name                => :P759_PAGE_NAME,',
'      p_group_name               => null,',
'      p_page_mode                => :P759_PAGE_MODE,',
'      p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'      p_region_name              => :P759_PAGE_NAME,',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                        p_application_id => :FB_FLOW_ID,',
'                                        p_theme_id       => :FB_THEME_ID,',
'                                        p_page_type      => :P259_CHOOSE_PAGE_TYPE),',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_report_template          => l_report_temp,',
'      p_rows_per_page            => nvl(l_rows_per_pg,''15''),',
'      --',
'      p_breadcrumb_id            => :P759_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P759_BREADCRUMB_NAME,',
'      p_parent_bc_id             => :P759_BREADCRUMB_PARENT_ID,',
'      --',
'      p_query                    => l_sql );',
'',
'  :fb_flow_page_id       := :P759_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114131721963452280.4001)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create WS_REPORT_ITEMS'
,p_process_sql_clob=>'wwv_flow_collection.create_collection_from_query(''WS_REPORT_ITEMS'',''select null from wwv_flow_dual100 where rownum < 11'');'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_REPORT_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00786
begin
wwv_flow_api.create_page(
 p_id=>786.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Informe Basado en Resultado de Servicio Web: Confirmar'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Informe Basado en Resultado de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_form.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114157723119504876.4001)
,p_plug_name=>unistr('Confirmaci\00F3n de Informe Basado en Resultado de Servicio Web')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_dynamic_query (',
'    p_flow_id         => :FB_FLOW_ID,',
'    p_page_id         => :P759_PAGE_ID,',
'    p_page_name       => :P759_PAGE_NAME,',
'    p_region_template => wwv_flow_theme_dev.get_region_template_id (',
'                             p_application_id => :FB_FLOW_ID,',
'                             p_theme_id       => :FB_THEME_ID,',
'                             p_page_type      => :P259_CHOOSE_PAGE_TYPE),',
'    p_region_name     => :P759_PAGE_NAME );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114158102177504877.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206212504301431946.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114159025887504878.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206212504301431946.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114159214433504879.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206212504301431946.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:782:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114158809792504878.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206212504301431946.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114424203419127075.4001)
,p_branch_name=>'Go To Page 782'
,p_branch_action=>'f?p=&APP_ID.:782:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114159214433504879.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P778_WEB_REF_TYPE'
,p_branch_condition_text=>'779'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114426315886130712.4001)
,p_branch_name=>'Go To Page 783'
,p_branch_action=>'f?p=&APP_ID.:783:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114159214433504879.4001)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P778_WEB_REF_TYPE'
,p_branch_condition_text=>'781'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193965413499488745.4001)
,p_branch_name=>'Go To Page 860'
,p_branch_action=>'f?p=&APP_ID.:860:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114159214433504879.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P778_WEB_REF_TYPE'
,p_branch_condition_text=>'859'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403500957361508757.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P776_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P776_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(114159025887504878.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549743989214954540.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114158809792504878.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549744081882954541.4001)
,p_event_id=>wwv_flow_api.id(549743989214954540.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114623110840640138.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report on ws page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_report_temp  varchar2(4000) := null;',
'  l_rows_per_pg  varchar2(4000) := null;',
'  l_sql          varchar2(32000);',
'begin',
'  if :P778_WEB_REF_TYPE = ''782'' then',
'    ',
'    l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_WSDL_OPERATION_ID,',
'                p_array_parm                => :P778_WSDL_ARRAY,',
'                p_report_collection_name    => :P782_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );  ',
'',
'    l_report_temp := :P782_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P782_ROWS_PER_PAGE;',
'',
'  elsif :P778_WEB_REF_TYPE = ''860'' then',
'    ',
'  l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_REST_OPERATION_ID,',
'                p_array_parm                => null,',
'                p_report_collection_name    => :P860_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );',
'',
'    l_report_temp := :P860_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P860_ROWS_PER_PAGE;',
'',
'  else',
'',
'    l_sql := wwv_flow_web_services.generate_query_manual(',
'                p_result_node               => :P778_NODE_PATH,',
'                p_soap_style                => :P778_MAN_SOAP_STYLE,',
'                p_message_format            => :P778_MAN_MSG_FORMAT,',
'                p_namespace                 => :P778_MAN_MSG_NAMESAPECE,',
'                p_report_collection_name    => :P783_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_REPORT_ITEMS'');    ',
'',
'    l_report_temp := :P783_ROW_TEMPLATE;                 ',
'    l_rows_per_pg := :P783_ROWS_PER_PAGE;     ',
'               ',
'  end if;        ',
'  ',
'  ',
'  wwv_flow_wizard_api.create_report_on_ws(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :P759_PAGE_ID,',
'      p_page_name                => :P759_PAGE_NAME,',
'      p_group_name               => null,',
'      p_page_mode                => :P759_PAGE_MODE,',
'      p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'      p_region_name              => :P759_PAGE_NAME,',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                        p_application_id => :FB_FLOW_ID,',
'                                        p_theme_id       => :FB_THEME_ID,',
'                                        p_page_type      => :P259_CHOOSE_PAGE_TYPE),',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_report_template          => l_report_temp,',
'      p_rows_per_page            => nvl(l_rows_per_pg,''15''),',
'      --',
'      p_breadcrumb_id            => :P759_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P759_BREADCRUMB_NAME,',
'      p_parent_bc_id             => :P759_BREADCRUMB_PARENT_ID,',
'      --',
'      p_query                    => l_sql );',
'',
'  :fb_flow_page_id       := :P759_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la p\00E1gina de informe basado en resultado de servicio Web.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(114159025887504878.4001)
,p_process_success_message=>unistr('P\00E1gina de informe basado en resultado de servicio Web creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(549744143238954542.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina de informe basado en resultado de servicio Web creada.')
);
end;
/
prompt --application/pages/page_00789
begin
wwv_flow_api.create_page(
 p_id=>789.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Tema de Espacio de Trabajo'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Tema de Espacio de Trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(113748409598274541)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes_public.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114756403333593105.4001)
,p_plug_name=>'Crear Tema de Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Puede cambiar el nombre ty n\00FAmero del nuevo tema de espacio de trabajo que se va a crear.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114834314105852056.4001)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114829600122838504.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(137684003798400090.4001)
,p_name=>'Temas de Espacio de Trabajo Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id,',
'       theme_name,',
'       theme_description',
'  from wwv_flow_themes',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11',
' order by theme_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn tema de espacio de trabajo existente.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(137684332022400343.4001)
,p_query_column_id=>1
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('N\00FAmero')
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(137684414330400343.4001)
,p_query_column_id=>2
,p_column_alias=>'THEME_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(137684524098400343.4001)
,p_query_column_id=>3
,p_column_alias=>'THEME_DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Descripci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208166600149775444.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114757517144593119.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208166600149775444.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114757131230593118.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208166600149775444.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114757315478593119.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208166600149775444.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114758708377593124.4001)
,p_branch_action=>'f?p=&FLOW_ID.:762:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114757131230593118.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114757716119593120.4001)
,p_name=>'P789_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114756403333593105.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema Seleccionado:'
,p_source=>'P764_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = :P764_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifica el tema que se va a copiar en el repositorio de temas del espacio de trabajo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114758213017593121.4001)
,p_name=>'P789_THEME_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114756403333593105.4001)
,p_prompt=>'Nombre del Tema'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name',
'from   wwv_flow_themes',
'where  flow_id = :P764_FLOW_ID',
'and security_group_id = :flow_security_group_id and',
'theme_id = :P764_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el tema del espacio de trabajo, este nombre puede ser el mismo o diferente del nombre del tema de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114758404070593122.4001)
,p_name=>'P789_THEME_NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114756403333593105.4001)
,p_prompt=>unistr('N\00FAmero de Tema')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(greatest(theme_id,99),99,theme_id+100,theme_id) theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P764_FLOW_ID',
'and security_group_id = :flow_security_group_id and',
'theme_id = :P764_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El n\00FAmero identifica un tema del espacio de trabajo como \00FAnico. Debe introducir un valor mayor que 100.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(136505718888126524.4001)
,p_name=>'P789_DESCRIPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114756403333593105.4001)
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select THEME_DESCRIPTION',
'  from wwv_flow_themes',
' where flow_id = :P764_FLOW_ID',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P764_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Descripci\00F3n breve del tema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114780106075669981.4001)
,p_validation_name=>'P789_THEME_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P789_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(114758213017593121.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114780311700669982.4001)
,p_validation_name=>'P789_THEME_NUMBER Not Null'
,p_validation_sequence=>20
,p_validation=>'P789_THEME_NUMBER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_associated_item=>wwv_flow_api.id(114758404070593122.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114778827761666818.4001)
,p_validation_name=>'valid theme number'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :P789_THEME_NUMBER < 100 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'El valor debe ser mayor o igual que 100.'
,p_when_button_pressed=>wwv_flow_api.id(114757131230593118.4001)
,p_associated_item=>wwv_flow_api.id(114758404070593122.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114865613768927599.4001)
,p_validation_name=>'theme number unique (edit me)'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_id = :P789_THEME_NUMBER',
'   and security_group_id = 11',
'   and theme_security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El n\00FAmero debe ser \00FAnico en el espacio de trabajo.')
,p_when_button_pressed=>wwv_flow_api.id(114757131230593118.4001)
,p_associated_item=>wwv_flow_api.id(114758404070593122.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(887629817352273333.4001)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114757517144593119.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(887629982602273334.4001)
,p_event_id=>wwv_flow_api.id(887629817352273333.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00794
begin
wwv_flow_api.create_page(
 p_id=>794.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Suprimir Varias Acciones Din\00E1micas')
,p_step_title=>unistr('Suprimir Varias Acciones Din\00E1micas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4518805581694342)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(30448828020739502.4001)
,p_name=>unistr('Eliminar Varias Acciones Din\00E1micas')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<input title="''||wwv_flow_lang.system_message(''SELECT_DYNAMIC_ACTION'')|| ''" type="checkbox" name="f01" id="f01_''||e.id||''" value="''||e.id||''"/>'' c,',
'       e.event_sequence,',
'       e.name,',
'       case e.triggering_element_type ',
'           when ''ITEM'' then e.triggering_element ',
'           when ''REGION'' then p.plug_name',
'           when ''COLUMN'' then p.plug_name || '' (Region) > '' || e.triggering_element',
'           when ''DOM_OBJECT'' then e.triggering_element',
'           when ''JQUERY_SELECTOR'' then e.triggering_element',
'           when ''JAVASCRIPT_EXPRESSION'' then e.triggering_element',
'       end || '' ('' || e.triggering_element_type || '')'' triggering_event_elements,        ',
'       e.triggering_condition_type || nvl2(e.triggering_expression,'' ('' || e.triggering_expression || '')'',null) triggering_condition,',
'       (select count(1) ',
'          from wwv_flow_page_da_actions ',
'         where event_id = e.id ',
'           and event_result = ''TRUE'' ) true_action_count,',
'       (select count(1) ',
'          from wwv_flow_page_da_actions ',
'         where event_id = e.id ',
'           and event_result = ''FALSE'' ) false_action_count',
'  from wwv_flow_page_da_events e,',
'       wwv_flow_page_plugs p',
' where e.triggering_region_id = p.id (+)',
'   and e.security_group_id = :flow_security_group_id',
'   and e.flow_id = :fb_flow_id ',
'   and e.page_id = :fb_flow_page_id',
' order by e.event_sequence '))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna acci\00F3n din\00E1mica en la p\00E1gina.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 21-FEB-2003 18:30:54'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30449019379739508.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196995404279210802.4001)
,p_query_column_id=>2
,p_column_alias=>'EVENT_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(30449225348739508.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196995504131210803.4001)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>4
,p_column_heading=>'Elementos'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196997309089259525.4001)
,p_query_column_id=>5
,p_column_alias=>'TRIGGERING_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Condici\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196995715734210803.4001)
,p_query_column_id=>6
,p_column_alias=>'TRUE_ACTION_COUNT'
,p_column_display_sequence=>6
,p_column_heading=>'Acciones Verdaderas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(196995807866210803.4001)
,p_query_column_id=>7
,p_column_alias=>'FALSE_ACTION_COUNT'
,p_column_display_sequence=>7
,p_column_heading=>'Acciones Falsas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30449413895739508.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30449623033739508.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(28119925264668131.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30451609394739516.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(30449413895739508.4001)
,p_button_name=>'P794_GO'
,p_button_static_id=>'P794_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30450700585739510.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(30449413895739508.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30450512887739510.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30449413895739508.4001)
,p_button_name=>'REMOVE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Eliminar Acciones Din\00E1micas')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_page_da_events',
' where flow_id=:FB_FLOW_ID ',
'   and page_id=:FB_FLOW_PAGE_ID'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30450930063739511.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(30449413895739508.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30452712209739519.4001)
,p_branch_action=>'f?p=&APP_ID.:794:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30451130177739511.4001)
,p_name=>'P794_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30449413895739508.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <strong>Ir</strong> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30451908380739517.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30452110380739517.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P794_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30452326191739518.4001)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar al menos un componente que suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(30450512887739510.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30452430376739518.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete multiple dynamic actions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from wwv_flow_page_da_events',
'   where id = to_number(wwv_flow.g_f01(i)) and',
'         flow_id = :fb_flow_id and',
'         page_id = :fb_flow_page_id and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido procesar la acci\00F3n')
,p_process_when_button_id=>wwv_flow_api.id(30450512887739510.4001)
,p_process_success_message=>unistr('Acci\00F3n Procesada')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00795
begin
wwv_flow_api.create_page(
 p_id=>795.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Acciones Din\00E1micas')
,p_step_title=>unistr('Historial de Acciones Din\00E1micas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4518805581694342)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30456101636900212.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(28119925264668131.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251157000568945486.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PAGE_DA_EVENTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(251157208114945490.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157302120945494.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157417800945496.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157524163945497.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157601145945498.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157715224945500.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157813388945501.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251157910594945502.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(251333828293071502.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251198113829781925.4001)
,p_plug_name=>unistr('Historial de Acciones Din\00E1micas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las acciones din\00E1micas de la p\00E1gina actual.</p>'),
unistr('<p>Elimine el filtro para ver el historial de todas las acciones din\00E1micas en la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251159214897959158.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(251157000568945486.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:795:&SESSION.::&DEBUG.:795,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00796
begin
wwv_flow_api.create_page(
 p_id=>796.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Acci\00F3n Din\00E1mica: En P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Acci\00F3n Din\00E1mica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4518805581694342)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47716515490537386.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>161
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181515302476213202.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181501623296103719.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181515530106213204.4001)
,p_plug_name=>unistr('Copiar Acci\00F3n Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>131
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185991323167292111.4001)
,p_name=>unistr('Copiar de Acci\00F3n Din\00E1mica')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>151
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dynamic_action_name name,',
'       case when_selection_type ',
'           when ''Item'' then when_element ',
'           when ''Region'' then when_region',
'           when ''Button'' then when_button',
'           when ''DOM Object'' then when_element',
'           when ''jQuery Selector'' then when_element',
'           when ''JavaScript Expression'' then when_element',
'       end || '' ('' || when_selection_type || '')'' triggering_event_elements,',
'       when_event_name || '' ('' || when_event_scope || '')'' event_binding,',
'       when_condition || decode(when_expression,null,null,'': '' || when_expression) triggering_event_condition,',
'       number_of_actions',
'  from apex_application_page_da',
' where application_id = to_number(:FB_FLOW_ID)',
'   and page_id = to_number(:FB_FLOW_PAGE_ID)',
'   and dynamic_action_id = to_number(:F4000_P796_COPY_FROM_ID)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185991500273292116.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185991624932292116.4001)
,p_query_column_id=>2
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>3
,p_column_heading=>'Elementos When'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185991719430292116.4001)
,p_query_column_id=>3
,p_column_alias=>'EVENT_BINDING'
,p_column_display_sequence=>2
,p_column_heading=>'Evento When'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185991830368292116.4001)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_CONDITION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Condici\00F3n When')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185991910962292116.4001)
,p_query_column_id=>5
,p_column_alias=>'NUMBER_OF_ACTIONS'
,p_column_display_sequence=>5
,p_column_heading=>'Acciones'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181515714690213204.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47716515490537386.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181523305791386897.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47716515490537386.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(183291802535599097.4001)
,p_branch_action=>'f?p=&APP_ID.:797:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(181523305791386897.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181517801235229773.4001)
,p_name=>'F4000_P796_COPY_FROM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(181515530106213204.4001)
,p_prompt=>'P796 Copy From Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181518003182229775.4001)
,p_name=>'F4000_P796_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(181515530106213204.4001)
,p_prompt=>'P796 Copy From Page Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181524127049386903.4001)
,p_name=>'F4000_P796_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181515530106213204.4001)
,p_prompt=>unistr('P\00E1gina de Destino')
,p_source=>'F4000_P796_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de p\00E1gina en el que se copiar\00E1 este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496793207459087819.4001)
,p_validation_name=>'F4000_P796_COPY_TO_PAGE_ID not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P796_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_when_button_pressed=>wwv_flow_api.id(181523305791386897.4001)
,p_associated_item=>wwv_flow_api.id(181524127049386903.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496793532393094991.4001)
,p_validation_name=>'F4000_P796_COPY_TO_PAGE_ID numeric'
,p_validation_sequence=>30
,p_validation=>'F4000_P796_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('#LABEL# debe ser num\00E9rica')
,p_when_button_pressed=>wwv_flow_api.id(181523305791386897.4001)
,p_associated_item=>wwv_flow_api.id(181524127049386903.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590118869511572024.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(181515714690213204.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590118910256572025.4001)
,p_event_id=>wwv_flow_api.id(590118869511572024.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00797
begin
wwv_flow_api.create_page(
 p_id=>797.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Acci\00F3n Din\00E1mica: Nueva Acci\00F3n Din\00E1mica')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Acci\00F3n Din\00E1mica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4518805581694342)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47717720123548186.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>201
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183290209546582284.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181501623296103719.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183292527731625328.4001)
,p_plug_name=>unistr('Copiar Acci\00F3n Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>131
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185891425321498078.4001)
,p_plug_name=>'When'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42027416946637016.4001)
,p_plug_display_sequence=>141
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185994224730330476.4001)
,p_name=>unistr('Copiar de Acci\00F3n Din\00E1mica')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>181
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dynamic_action_name name,',
'       case when_selection_type ',
'           when ''Item'' then when_element ',
'           when ''Region'' then when_region',
'           when ''Button'' then when_button',
'           when ''DOM Object'' then when_element',
'           when ''jQuery Selector'' then when_element',
'           when ''JavaScript Expression'' then when_element',
'       end || '' ('' || when_selection_type || '')'' triggering_event_elements,',
'       when_event_name,',
'       when_condition || decode(when_expression,null,null,'': '' || when_expression) triggering_event_condition,',
'       number_of_actions',
'  from apex_application_page_da',
' where application_id = to_number(:FB_FLOW_ID)',
'   and page_id = to_number(:FB_FLOW_PAGE_ID)',
'   and dynamic_action_id = to_number(:F4000_P796_COPY_FROM_ID)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185994415979330480.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185994519664330480.4001)
,p_query_column_id=>2
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>4
,p_column_heading=>'Elementos When'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(620194328401571937.4001)
,p_query_column_id=>3
,p_column_alias=>'WHEN_EVENT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre de Evento When'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185994713840330480.4001)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_CONDITION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Condici\00F3n When')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185994809211330480.4001)
,p_query_column_id=>5
,p_column_alias=>'NUMBER_OF_ACTIONS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('N\00FAmero de Acciones')
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(186034418786574670.4001)
,p_name=>unistr('Copiar a Acciones Din\00E1micas de P\00E1gina')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>191
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dynamic_action_name name,',
'       case when_selection_type ',
'           when ''Item'' then when_element ',
'           when ''Region'' then when_region',
'           when ''Button'' then when_button',
'           when ''DOM Object'' then when_element',
'           when ''jQuery Selector'' then when_element',
'           when ''JavaScript Expression'' then when_element',
'       end || '' ('' || when_selection_type || '')'' triggering_event_elements,',
'       when_event_name || '' ('' || when_event_scope || '')'' event_binding,',
'       when_condition || decode(when_expression,null,null,'': '' || when_expression) triggering_event_condition,',
'       number_of_actions',
'  from apex_application_page_da',
' where application_id = to_number(:FB_FLOW_ID)',
'   and page_id = to_number(:F4000_P796_COPY_TO_PAGE_ID)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('La p\00E1gina de destino no contiene acciones din\00E1micas.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186034613409574676.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186034721478574676.4001)
,p_query_column_id=>2
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>3
,p_column_heading=>'Elementos When'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186034816428574676.4001)
,p_query_column_id=>3
,p_column_alias=>'EVENT_BINDING'
,p_column_display_sequence=>2
,p_column_heading=>'Evento When'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186034904918574676.4001)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_CONDITION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Condici\00F3n When')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186035028668574676.4001)
,p_query_column_id=>5
,p_column_alias=>'NUMBER_OF_ACTIONS'
,p_column_display_sequence=>5
,p_column_heading=>'Acciones'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183294013580649582.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47717720123548186.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(427636819611638021.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(47717720123548186.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184548700439307574.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47717720123548186.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(427637621473648031.4001)
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(427636819611638021.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184549230567316278.4001)
,p_branch_action=>'f?p=&APP_ID.:796:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(184548700439307574.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1569431692730466.4001)
,p_name=>'P797_TRIGGERING_BUTTON_ID'
,p_item_sequence=>81
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>unistr('Bot\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from target page and global page */',
'        select case when b.flow_step_id = ui.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = ui.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flow_user_interfaces ui,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :F4000_P796_COPY_TO_PAGE_ID',
'           and ui.id          = p.user_interface_id',
'           and b.flow_id      = ui.flow_id',
'           and b.flow_step_id in (:F4000_P796_COPY_TO_PAGE_ID, ui.global_page_id)',
'         order by x, bn ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Bot\00F3n -')
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el bot\00F3n que disparar\00E1 la acci\00F3n din\00E1mica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3969222860683766.4001)
,p_name=>'P797_BIND_EVENT_TYPE_CUSTOM'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>'Evento Personalizado'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Especifique un nombre de evento JavaScript personalizado si los eventos declarativos proporcionados no son suficientes.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184550602086327013.4001)
,p_name=>'P797_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(183292527731625328.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de la acci\00F3n din\00E1mica para que los desarrolladores puedan identificarla f\00E1cilmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184550800961327015.4001)
,p_name=>'P797_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(183292527731625328.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(event_sequence) + 10',
'  from wwv_flow_page_da_events',
' where flow_id = :fb_flow_id',
'   and page_id = :F4000_P796_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185889713631475757.4001)
,p_name=>'P797_TRIGGERING_REGION_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>unistr('Regi\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when r.page_id = ui.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || r.plug_name || '' ('' || r.plug_display_sequence || '')'' as d,',
'       r.id as r',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P796_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and ui.id               = p.user_interface_id',
'   and r.flow_id           = ui.flow_id',
'   and r.page_id          in (:F4000_P796_COPY_TO_PAGE_ID, ui.global_page_id)',
' order by case when r.page_id = ui.global_page_id then 2 else 1 end, r.plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Regi\00F3n -')
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>''Regi\00F3n'' posee diferentes significados en funci\00F3n del tipo de selecci\00F3n seleccionado.</p>'),
'<ul>',
unistr('<li>Si ''Tipo de Selecci\00F3n'' es ''Regi\00F3n'', especifique el nombre de una regi\00F3n que disparar\00E1 la acci\00F3n din\00E1mica. Por ejemplo, podr\00EDa ser la regi\00F3n ''Informe Interactivo'' utilizada en conjunci\00F3n con un evento ''afterRefresh'' para definir una acci\00F3n din\00E1mic')
||'a que arranque siempre que el informe se refresque.</li>',
unistr('<li>Si ''Tipo de Selecci\00F3n'' es ''Columna'', especifique el nombre de la regi\00F3n de la pantalla tabular que contiene la columna que desea especificar.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185892304374529884.4001)
,p_name=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>unistr('Tipo de Selecci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DYNAMIC ACTION TRIGG ELEM TYPE'
,p_lov=>'.'||wwv_flow_api.id(34817614503562438.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tipo -'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el tipo de selecci\00F3n de los elementos de p\00E1gina que definen cu\00E1ndo arranca la acci\00F3n din\00E1mica. Consulte el texto de ayuda de cada elemento de p\00E1gina para obtener m\00E1s informaci\00F3n y ver ejemplos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186288619009758097.4001)
,p_name=>'P797_TRIGGERING_CONDITION_TYPE'
,p_item_sequence=>185
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>unistr('Condici\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DYNAMIC ACTION CONDITION'
,p_lov=>'.'||wwv_flow_api.id(4505805282372682.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la condici\00F3n para la que se disparar\00E1 la acci\00F3n din\00E1mica. En funci\00F3n de si esta condici\00F3n se cumple o no, se podr\00E1n definir las acciones verdaderas (si se cumple) o falsas (si no se cumplen). Si no se especifica ninguna condici\00F3n, s\00F3lo ar')
||unistr('rancar\00E1n las acciones verdaderas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186288901132762374.4001)
,p_name=>'P797_TRIGGERING_EXPRESSION'
,p_item_sequence=>195
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>'Valor'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el valor correspondiente a la condici\00F3n especificada.</p>'),
'<p>Si utiliza los tipos de condiciones ''en lista'' o ''no en lista'', utilice comas para separar los elementos de la lista.</p>',
unistr('<p>Si utiliza la condici\00F3n ''Expresi\00F3n JavaScript'', el c\00F3digo tiene acceso a los siguientes atributos relacionados con la acci\00F3n din\00E1mica:</p>'),
'<ul>',
unistr('<li><strong>this.triggeringElement</strong>: Referencia al objeto DOM del elemento que dispara la acci\00F3n din\00E1mica.</li>'),
unistr('<li><strong>this.browserEvent</strong>: Objeto de evento que ha disparado el evento: Nota: En la carga, ser\00E1 igual a ''load''.</li>'),
'<li><strong>this.data</strong>: Datos adicionales opcionales que se pueden pasar desde el manejador de eventos.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424651302411323923.4001)
,p_name=>'P797_TRIGGERING_ELEM_ITEM'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Elementos'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when i.flow_step_id = ui.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || i.name || '' ('' || i.prompt || '')'' as d,',
'       i.name as r',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces ui,',
'       wwv_flow_step_items i',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P796_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and ui.id               = p.user_interface_id',
'   and i.flow_id           = ui.flow_id',
'   and i.flow_step_id     in (:F4000_P796_COPY_TO_PAGE_ID, ui.global_page_id)',
' order by case when i.flow_step_id = ui.global_page_id then 2 else 1 end, i.name',
''))
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de uno o varios elementos de p\00E1gina que disparar\00E1n la acci\00F3n din\00E1mica. Si son varios, separe los nombres con una coma.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_11=>','
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424651510030326104.4001)
,p_name=>'P797_TRIGGERING_ELEM_DOM'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Objeto DOM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el identificador de un objeto DOM que disparar\00E1 la acci\00F3n din\00E1mica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(424651719380328851.4001)
,p_name=>'P797_TRIGGERING_ELEM_JQUERY'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Selector de jQuery'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la sintaxis jQuery Selector a fin de devolver uno o varios elementos de p\00E1gina para disparar la acci\00F3n din\00E1mica. La biblioteca jQuery ofrece una sintaxis de selector muy potente que proporciona un modo de acceso sencillo a uno o varios ')
||unistr('elementos de una p\00E1gina.</p>'),
unistr('<p>Consulte la documentaci\00F3n oficial disponible en la p\00E1gina inicial de jQuery para obtener m\00E1s informaci\00F3n acerca de la sintaxis del selector.</p>'),
'<h4>Ejemplos</h4>',
'<dl>',
unistr('    <dt>Para seleccionar un elemento de p\00E1gina con un ID DOM <code>my_id</code></dt>'),
'    <dd><pre>#my_id</pre></dd>',
unistr('    <dt>Para seleccionar todos los elementos de p\00E1gina con una clase <code>my_class</code></dt>'),
'    <dd><pre>.my_class</pre></dd>',
unistr('    <dt>Para seleccionar todos los elementos de p\00E1gina que son entradas</dt>'),
'    <dd><pre>input</pre></dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(496751013973559943.4001)
,p_name=>'P797_BIND_EVENT_TYPE'
,p_is_required=>true
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_prompt=>'Evento'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.UI_COMPONENT_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r,',
'       g,',
'       supported_ui_types',
'  from wwv_flow_javascript_events'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Evento -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el evento que provocar\00E1 que arranque la acci\00F3n din\00E1mica. Para obtener m\00E1s informaci\00F3n sobre eventos espec\00EDficos, consulte la secci\00F3n pertinente en la gu\00EDa de usuario. Los eventos se categorizan de la siguiente forma:</p>'),
'<ul>',
unistr('<li><strong>Eventos de Explorador</strong>: eventos de explorador aut\00F3nomos.</li>'),
'<li><strong>Eventos de Marco</strong>: los eventos de marco se disparan desde el marco de Application Express.</li>',
unistr('<li><strong>Eventos de Componente</strong>: s\00F3lo disponible cuando hay un componente disponible para la aplicaci\00F3n que dispara un evento personalizado. Estos eventos se disparan desde componentes nativos o componentes de plugin que ha instalado en la')
||unistr(' aplicaci\00F3n.</li>'),
unistr('<li><strong>Evento Personalizado</strong>: cualquier evento personalizado que se ha disparado desde la aplicaci\00F3n.</li>'),
'</ul></p>',
unistr('<p>Nota: los eventos mostrados ser\00E1n diferentes seg\00FAn el tipo de interfaz de usuario actual de la p\00E1gina de destino. Si desea seleccionar un evento que corresponda a un tipo diferente, tendr\00E1 la opci\00F3n de seleccionar ''Mostrar No Soportados'',que mostr')
||unistr('ar\00E1 todos los eventos, incluidos los que no corresponden al tipo actual.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FB_FLOW_ID'
,p_attribute_02=>'F4000_P796_COPY_TO_PAGE_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626394418137495846.4001)
,p_name=>'P797_TRIGGERING_ELEMENT'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Element'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(855879959242026311.4001)
,p_name=>'P797_TRIGGERING_ELEM_JS'
,p_item_sequence=>175
,p_item_plug_id=>wwv_flow_api.id(185891425321498078.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n JavaScript')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique la expresi\00F3n JavaScript que se va a evaluar para devolver un solo objeto DOM, una matriz de objetos DOM o un objeto jQuery como elementos que activar\00E1n la acci\00F3n din\00E1mica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(626394923678497491.4001)
,p_validation_name=>'Validate Triggering'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_triggering (',
'        p_page_item_prefix => ''P797_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496785431775000237.4001)
,p_name=>'EVENT REQUIRES SELECTION TYPE'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_BIND_EVENT_TYPE'
,p_condition_element=>'P797_BIND_EVENT_TYPE'
,p_triggering_condition_type=>'NOT_IN_LIST'
,p_triggering_expression=>'apexbeforepagesubmit,unload,resize,ready,orientationchange'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496785703928000239.4001)
,p_event_id=>wwv_flow_api.id(496785431775000237.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496785916964000240.4001)
,p_event_id=>wwv_flow_api.id(496785431775000237.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496786111513000241.4001)
,p_event_id=>wwv_flow_api.id(496785431775000237.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEMENT_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3972000444734133.4001)
,p_name=>'EVENT EQUALS CUSTOM'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_BIND_EVENT_TYPE'
,p_condition_element=>'P797_BIND_EVENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'custom'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3972305616734133.4001)
,p_event_id=>wwv_flow_api.id(3972000444734133.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_BIND_EVENT_TYPE_CUSTOM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3972502984734134.4001)
,p_event_id=>wwv_flow_api.id(3972000444734133.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_BIND_EVENT_TYPE_CUSTOM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3973609102736636.4001)
,p_event_id=>wwv_flow_api.id(3972000444734133.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_BIND_EVENT_TYPE_CUSTOM'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496787622949035575.4001)
,p_name=>'HIDE ALL ELEMENT TYPES'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496787926104035576.4001)
,p_event_id=>wwv_flow_api.id(496787622949035575.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM,P797_TRIGGERING_REGION_ID,P797_TRIGGERING_ELEM_DOM,P797_TRIGGERING_ELEM_JQUERY,P797_TRIGGERING_BUTTON_ID,P797_TRIGGERING_ELEM_JS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496788113819035577.4001)
,p_event_id=>wwv_flow_api.id(496787622949035575.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM,P797_TRIGGERING_REGION_ID,P797_TRIGGERING_ELEM_DOM,P797_TRIGGERING_ELEM_JQUERY,P797_TRIGGERING_BUTTON_ID,P797_TRIGGERING_ELEM_JS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496788231391047398.4001)
,p_name=>'TYPE = REGION'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496788727240047401.4001)
,p_event_id=>wwv_flow_api.id(496788231391047398.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_REGION_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496788500440047400.4001)
,p_event_id=>wwv_flow_api.id(496788231391047398.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_REGION_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1572418326811757.4001)
,p_name=>'TYPE = BUTTON'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'BUTTON'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1572714667811813.4001)
,p_event_id=>wwv_flow_api.id(1572418326811757.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_BUTTON_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1572908844811813.4001)
,p_event_id=>wwv_flow_api.id(1572418326811757.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_BUTTON_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496788812822051515.4001)
,p_name=>'TYPE = ITEM'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496789313415051517.4001)
,p_event_id=>wwv_flow_api.id(496788812822051515.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496789124366051516.4001)
,p_event_id=>wwv_flow_api.id(496788812822051515.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496789724596054916.4001)
,p_name=>'TYPE = DOM OBJECT'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DOM_OBJECT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496790221931054919.4001)
,p_event_id=>wwv_flow_api.id(496789724596054916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_DOM'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496790017034054918.4001)
,p_event_id=>wwv_flow_api.id(496789724596054916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_DOM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496790331176056869.4001)
,p_name=>'TYPE = JQUERY'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'JQUERY_SELECTOR'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496790831508056871.4001)
,p_event_id=>wwv_flow_api.id(496790331176056869.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JQUERY'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496790612936056870.4001)
,p_event_id=>wwv_flow_api.id(496790331176056869.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JQUERY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(855880028582026312.4001)
,p_name=>'TYPE = JAVASCRIPT EXPRESSION'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'JAVASCRIPT_EXPRESSION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(855880163419026313.4001)
,p_event_id=>wwv_flow_api.id(855880028582026312.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(855880287707026314.4001)
,p_event_id=>wwv_flow_api.id(855880028582026312.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496790905680058934.4001)
,p_name=>'condition requires expression'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_CONDITION_TYPE'
,p_condition_element=>'P797_TRIGGERING_CONDITION_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NULL,NOT_NULL,%null%'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496791430022058937.4001)
,p_event_id=>wwv_flow_api.id(496790905680058934.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496791604987058937.4001)
,p_event_id=>wwv_flow_api.id(496790905680058934.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496791208407058936.4001)
,p_event_id=>wwv_flow_api.id(496790905680058934.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496791808793058938.4001)
,p_event_id=>wwv_flow_api.id(496790905680058934.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590118122488572017.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>130
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(183294013580649582.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590118261102572018.4001)
,p_event_id=>wwv_flow_api.id(590118122488572017.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(427641425161715311.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Dynamic Action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_old_event_id              number;',
'    l_new_event_id              number;',
'    l_flow_id                   number;',
'    l_page_id_from              number;',
'    l_page_id_to                number;',
'    --',
'    l_triggering_element_type   wwv_flow_page_da_events.triggering_element_type%type;',
'    l_triggering_region_id      wwv_flow_page_da_events.triggering_region_id%type;',
'    l_triggering_button_id      wwv_flow_page_da_events.triggering_button_id%type;',
'    l_triggering_element        wwv_flow_page_da_events.triggering_element%type;',
'    l_triggering_condition_type wwv_flow_page_da_events.triggering_condition_type%type;',
'    l_triggering_expression     wwv_flow_page_da_events.triggering_expression%type;',
'    --',
'    l_event_result              wwv_flow_page_da_actions.event_result%type;',
'    l_action_sequence           wwv_flow_page_da_actions.action_sequence%type;',
'    l_execute_on_page_init      wwv_flow_page_da_actions.execute_on_page_init%type;',
'    l_action                    wwv_flow_page_da_actions.action%type;',
'    l_affected_elements_type    wwv_flow_page_da_actions.affected_elements_type%type;',
'    l_affected_region_id        wwv_flow_page_da_actions.affected_region_id%type;',
'    l_affected_elements         wwv_flow_page_da_actions.affected_elements%type;',
'    l_attribute_01              wwv_flow_page_da_actions.attribute_01%type;',
'    l_attribute_02              wwv_flow_page_da_actions.attribute_02%type;',
'    l_attribute_03              wwv_flow_page_da_actions.attribute_03%type;',
'    l_attribute_04              wwv_flow_page_da_actions.attribute_04%type;',
'    l_attribute_05              wwv_flow_page_da_actions.attribute_05%type;',
'    l_attribute_06              wwv_flow_page_da_actions.attribute_06%type;',
'    l_attribute_07              wwv_flow_page_da_actions.attribute_07%type;',
'    l_attribute_08              wwv_flow_page_da_actions.attribute_08%type;',
'    l_attribute_09              wwv_flow_page_da_actions.attribute_09%type;',
'    l_attribute_10              wwv_flow_page_da_actions.attribute_10%type;',
'    l_attribute_11              wwv_flow_page_da_actions.attribute_11%type;',
'    l_attribute_12              wwv_flow_page_da_actions.attribute_12%type;',
'    l_attribute_13              wwv_flow_page_da_actions.attribute_13%type;',
'    l_attribute_14              wwv_flow_page_da_actions.attribute_14%type;',
'    l_attribute_15              wwv_flow_page_da_actions.attribute_15%type;',
'    l_da_action_comment         wwv_flow_page_da_actions.da_action_comment%type;',
'begin',
'    l_old_event_id  := to_number(:F4000_P796_COPY_FROM_ID);',
'    l_new_event_id  := wwv_flow_id.next_val;',
'    l_flow_id       := to_number(:FB_FLOW_ID);',
'    l_page_id_from  := to_number(:F4000_P796_COPY_FROM_PAGE_ID);',
'    l_page_id_to    := to_number(:F4000_P796_COPY_TO_PAGE_ID);',
'    --',
'    l_triggering_element_type   := :P797_TRIGGERING_ELEMENT_TYPE;',
'    l_triggering_region_id      := :P797_TRIGGERING_REGION_ID;',
'    l_triggering_button_id      := :P797_TRIGGERING_BUTTON_ID;',
'    l_triggering_element        := :P797_TRIGGERING_ELEMENT;',
'    l_triggering_condition_type := replace(:P797_TRIGGERING_CONDITION_TYPE, ''%null%'', null);',
'    l_triggering_expression     := :P797_TRIGGERING_EXPRESSION;',
'    --',
'    for c1 in (select *',
'                 from wwv_flow_page_da_events',
'                where id = l_old_event_id) loop',
'        wwv_flow_api.create_page_da_event(',
'            p_id                        => l_new_event_id,',
'            p_flow_id                   => l_flow_id,',
'            p_page_id                   => l_page_id_to,',
'            p_name                      => :P797_NAME,',
'            p_event_sequence            => :P797_SEQUENCE,',
'            p_triggering_element_type   => l_triggering_element_type,',
'            p_triggering_region_id      => l_triggering_region_id,',
'            p_triggering_button_id      => l_triggering_button_id,',
'            p_triggering_element        => l_triggering_element,',
'                                           /*wwv_flow_copy_page.change_item_name( p_flow_id_from  => l_flow_id,',
'                                                                                p_page_id_from  => l_page_id_from,',
'                                                                                p_flow_id_to    => l_flow_id,',
'                                                                                p_page_id_to    => l_page_id_to,',
'                                                                                p_source        => c1.triggering_element),*/',
'            p_triggering_condition_type => l_triggering_condition_type,',
'            p_triggering_expression     => l_triggering_expression,',
'                                           /*wwv_flow_copy_page.change_item_name( p_flow_id_from  => l_flow_id,',
'                                                                                p_page_id_from  => l_page_id_from,',
'                                                                                p_flow_id_to    => l_flow_id,',
'                                                                                p_page_id_to    => l_page_id_to,',
'                                                                                p_source        => c1.triggering_expression),*/',
'            p_bind_type                 => c1.bind_type,',
'            p_bind_delegate_to_selector => c1.bind_delegate_to_selector,',
'            p_bind_event_type           => :P797_BIND_EVENT_TYPE,',
'            p_bind_event_type_custom    => :P797_BIND_EVENT_TYPE_CUSTOM,',
'            p_display_when_type         => c1.display_when_type,',
'            p_display_when_cond         => c1.display_when_cond,',
'            p_display_when_cond2        => c1.display_when_cond2,',
'            p_required_patch            => c1.required_patch,',
'            p_security_scheme           => c1.security_scheme,',
'            p_da_event_comment          => c1.da_event_comment',
'        );',
'',
'        -- copy all actions across',
'        for c2 in (select *',
'                     from wwv_flow_page_da_actions',
'                    where event_id = l_old_event_id) loop',
'            wwv_flow_api.create_page_da_action (',
'                p_flow_id                   => l_flow_id,',
'                p_page_id                   => l_page_id_to,',
'                p_event_id                  => l_new_event_id,',
'                p_event_result              => c2.event_result,',
'                p_action_sequence           => c2.action_sequence,',
'                p_execute_on_page_init      => c2.execute_on_page_init,',
'                p_action                    => c2.action,',
'                p_affected_elements_type    => c2.affected_elements_type,',
'                p_affected_region_id        => c2.affected_region_id,',
'                p_affected_button_id        => c2.affected_button_id,',
'                p_affected_elements         => wwv_flow_copy_page.change_item_name( p_flow_id_from  => l_flow_id,',
'                                                                                    p_page_id_from  => l_page_id_from,',
'                                                                                    p_flow_id_to    => l_flow_id,',
'                                                                                    p_page_id_to    => l_page_id_to,',
'                                                                                    p_source        => c2.affected_elements),',
'                p_attribute_01              => c2.attribute_01,',
'                p_attribute_02              => c2.attribute_02,',
'                p_attribute_03              => c2.attribute_03,',
'                p_attribute_04              => c2.attribute_04,',
'                p_attribute_05              => c2.attribute_05,',
'                p_attribute_06              => c2.attribute_06,',
'                p_attribute_07              => c2.attribute_07,',
'                p_attribute_08              => c2.attribute_08,',
'                p_attribute_09              => c2.attribute_09,',
'                p_attribute_10              => c2.attribute_10,',
'                p_attribute_11              => c2.attribute_11,',
'                p_attribute_12              => c2.attribute_12,',
'                p_attribute_13              => c2.attribute_13,',
'                p_attribute_14              => c2.attribute_14,',
'                p_attribute_15              => c2.attribute_15,',
'                p_stop_execution_on_error   => c2.stop_execution_on_error,',
'                p_wait_for_result           => c2.wait_for_result,',
'                p_da_action_comment         => c2.da_action_comment',
'            );',
'        end loop;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fallo al copiar acci\00F3n din\00E1mica.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(427636819611638021.4001)
,p_process_success_message=>unistr('Acci\00F3n din\00E1mica copiada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590118383047572019.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n din\00E1mica copiada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(186290730269799122.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select name,',
'           triggering_element_type,',
'           triggering_condition_type,',
'           triggering_expression,',
'           bind_event_type,',
'           bind_event_type_custom',
'      into :P797_NAME,',
'           :P797_TRIGGERING_ELEMENT_TYPE,',
'           :P797_TRIGGERING_CONDITION_TYPE,',
'           :P797_TRIGGERING_EXPRESSION,',
'           :P797_BIND_EVENT_TYPE,',
'           :P797_BIND_EVENT_TYPE_CUSTOM',
'      from wwv_flow_page_da_events',
'     where flow_id = to_number(:FB_FLOW_ID)',
'       and page_id = to_number(:F4000_P796_COPY_FROM_PAGE_ID)',
'       and security_group_id = to_number(:WORKSPACE_ID)',
'       and id = to_number(:F4000_P796_COPY_FROM_ID);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00800
begin
wwv_flow_api.create_page(
 p_id=>800.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Valores por Defecto del Creador de Aplicaciones'
,p_step_title=>'Valores por Defecto del Creador de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_css_file_urls=>'#IMAGE_PREFIX#css/apex_ui_themes.css'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'AEADM/wkspc_def.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3025029400737489.4001)
,p_plug_name=>'Valores por defecto del creador de aplicaciones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3028402997748766.4001)
,p_plug_name=>'Tema'
,p_region_name=>'THEME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3031729663756548.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'TABS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3075001967824194.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Los valores por defecto del creador de aplicaciones son espec\00EDficos del espacio de trabajo, no de cada desarrollador. Estos valores se utilizan para crear nuevas aplicaciones o componentes.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3089017223979992.4001)
,p_plug_name=>unistr('Globalizaci\00F3n')
,p_region_name=>'G'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46243506288678979.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699068481630841636.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2793828958027300.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3025029400737489.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2793600209027299.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3025029400737489.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P800_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2794000152027300.4001)
,p_branch_action=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2794229156027301.4001)
,p_name=>'P800_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3031729663756548.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2794415961027306.4001)
,p_name=>'P800_DEFAULT_AUTHENTICATION_SC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3031729663756548.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autenticaci\00F3n por Defecto:')
,p_source=>'DEFAULT_AUTHENTICATION_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREATE.APP.AUTH.OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.CLOUD_IDM'') d ,''CLOUD_IDM'' v from dual',
'where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'')d ,:PRODUCT_NAME v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.SSO'') d ,''SSO'' v from dual',
'where wwv_flow_authentication_dev.can_use_sso_yn = ''Y''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'') d,''DBACCOUNT'' v',
'from dual',
'where wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'') d,''DATABASE'' v from dual',
')'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La autenticaci\00F3n es el proceso de establecer las identidades de los usuarios antes de que puedan acceder a una aplicaci\00F3n.<p/>'),
unistr('Identifique el esquema de autenticaci\00F3n que desea utilizar por defecto.'),
'<ul>',
unistr('<li><strong>&PRODUCT_NAME.</strong>: Utiliza las credenciales de la cuenta de usuario creadas y mantenidas con las aplicaciones de administraci\00F3n de servicio de &PRODUCT_NAME. Son las cuentas que se utilizan para la conexi\00F3n al entorno de desarrollo ')
||unistr('de &PRODUCT_NAME. Tambi\00E9n puede crear cuentas en este repositorio de cuentas de usuario para los usuarios finales de las aplicaciones.</li>'),
unistr('<li><strong>Sin autenticaci\00F3n</strong>: Conocida tambi\00E9n como autenticaci\00F3n de base de datos, permite a los usuarios el acceso a la aplicaci\00F3n mediante las credenciales de cuenta almacenadas en la definici\00F3n de modplsql DAD. En la mayor\00EDa de los caso')
||unistr('s, los usuarios al final no tienen que conectarse al acceder a la aplicaci\00F3n. Es el modo m\00E1s r\00E1pido y sencillo de crear una aplicaci\00F3n "p\00FAblica".</li>'),
unistr('<li><strong>Cuenta de base de datos</strong>: Los usuarios que se conectan a la aplicaci\00F3n deben introducir un nombre de esquema de base de datos (nombre de usuario) y su contrase\00F1a para realizar la autenticaci\00F3n. Esta informaci\00F3n de cuenta se gestio')
||'na completamente en la base de datos Oracle.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2794607481027307.4001)
,p_name=>'P800_DEFAULT_APPLICATION_THEME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3028402997748766.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tema de Aplicaci\00F3n por Defecto:')
,p_post_element_text=>'<p />'
,p_source=>'DEFAULT_APPLICATION_THEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'THEME LIST FOR WS PREFERENCES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''|| wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||'')''||',
'       ''<a href="#" ><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme-preview theme_''||t.theme_id||''" alt="''||wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.theme_id) theme_id',
'       from wwv_flow_themes t, wwv_flow_user_interfaces ui ',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P800_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P800_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P800_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P800_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P800_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P800_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P800_SHOW = ''ALL'')',
'        )  ',
'        and ui.flow_id = t.flow_id',
'        and ui.theme_id = t.theme_id',
'        and ui.ui_type_id = :P800_UI_TYPE_ID',
'        order by t.flow_id'))
,p_tag_css_classes=>'apex-pick-theme'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione un tema. Los temas son recopilaciones de plantillas que definen el dise\00F1o y el estilo de toda una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2794816963027307.4001)
,p_name=>'P800_DEFAULT_TABS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3031729663756548.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML DB'
,p_prompt=>unistr('Separadores de Aplicaci\00F3n por Defecto:')
,p_source=>'DEFAULT_TABS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABS (FOR 800)'
,p_lov=>'.'||wwv_flow_api.id(2804200546103254.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione si desea incluir separadores en la aplicaci\00F3n. Seleccione si desea crear separadores de un nivel, de dos niveles o ning\00FAn separador.<p/>'),
'',
unistr('Una aplicaci\00F3n con s\00F3lo un nivel de separadores utiliza un <strong>juego de separadores est\00E1ndar</strong>. Un juego de separadores est\00E1ndar se asocia a un n\00FAmero de p\00E1gina concreto. Puede utilizar separadores est\00E1ndar para enlazar usuarios a una p\00E1gi')
||'na concreta.<p/>',
unistr('Un <strong>juego de separadores principales</strong> funciona como un contenedor para albergar un grupo de separadores est\00E1ndar. Los separadores principales ofrecen a los usuarios otro nivel de navegaci\00F3n, as\00ED como un contexto. Utilice los separadore')
||unistr('s principales para enlazar usuarios a una direcci\00F3n URL concreta asociada a una p\00E1gina determinada.<p/>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3093812637997644.4001)
,p_name=>'P800_DEFAULT_LANGUAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3089017223979992.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&BROWSER_LANGUAGE.'
,p_prompt=>'Idioma por Defecto'
,p_source=>'DEFAULT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Valor por Defecto -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el idioma primario para esta aplicaci\00F3n.<br /><br />'),
unistr('Este atributo identifica el idioma en el que se desarrolla una aplicaci\00F3n. Se trata del idioma base del que se realizan todas las traducciones. ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3095029952002573.4001)
,p_name=>'P800_DEFAULT_LANGUAGE_DERIVED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3089017223979992.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma por Defecto Derivado de'
,p_source=>'DEFAULT_LANGUAGE_DERIVED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGE_DERIVED_FROM'
,p_lov=>'.'||wwv_flow_api.id(73566910745435962.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Valor por Defecto -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifica la forma en la que el motor determina el idioma de la aplicaci\00F3n. El idioma primario de la aplicaci\00F3n puede ser est\00E1tico (es decir, derivado del idioma del explorador Web) o se puede determinar a partir de un elemento o de una preferencia ')
||unistr('del usuario. La configuraci\00F3n de idioma de la base de datos determina la visualizaci\00F3n de fecha y las caracter\00EDsticas de ordenaci\00F3n. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114324124085924919.4001)
,p_name=>'P800_DATE_FORMAT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3089017223979992.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Fecha'
,p_source=>'DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica el formato de fecha que se va a utilizar en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato de fecha se utilizar\00E1 para modificar el valor de sesi\00F3n de base de datos NLS_DATE_FORMAT antes de mostrar o ejecutar cualquier p\00E1gina de la aplicaci\00F3n. Este valor puede ser una cadena de literales que contenga una m\00E1scara de formato d')
||unistr('e fecha v\00E1lida de Oracle o una referencia de elemento mediante una sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de fecha por defecto se derivar\00E1 de la sesi\00F3n de base de datos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li>Mes DD, AAAA</li>',
'<li>&amp;MY_DATE_FORMAT.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170501503547357395.4001)
,p_name=>'P800_TIMESTAMP_FORMAT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3089017223979992.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Registro de Hora'
,p_source=>'TIMESTAMP_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica el formato de registro de hora que se utiliza en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato se utilizar\00E1 para modificar el valor de la sesi\00F3n de base de datos NLS_TIMESTAMP_FORMAT antes de mostrar o ejecutar una p\00E1gina en la aplicaci\00F3n. Este valor puede ser una cadena literal que contiene una m\00E1scara de formato de registro d')
||unistr('e hora de Oracle v\00E1lida o una referencia de elemento a trav\00E9s de la sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de registro de hora por defecto se obtiene de la sesi\00F3n de la base de datos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li>Mes DD, AAAA</li>',
'<li>&amp;MY_TIMESTAMP_FORMAT.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170502017399361325.4001)
,p_name=>'P800_TIMESTAMP_TZ_FORMAT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(3089017223979992.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Zona Horaria de Registro de Hora'
,p_source=>'TIMESTAMP_TZ_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica el formato del registro de hora con zona horaria que se va a utilizar en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato se utilizar\00E1 para modificar el valor de sesi\00F3n de base de datos NLS_TIMESTAMP_TZ_FORMAT antes de mostrar o ejecutar cualquier p\00E1gina en la aplicaci\00F3n. Este valor puede ser una cadena de literales que contenga una m\00E1scara de formato de')
||unistr(' registro de hora con zona horaria v\00E1lida de Oracle o una referencia de elemento mediante una sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de registro de hora con zona horaria por defecto se obtendr\00E1 de la sesi\00F3n de base de d')
||unistr('atos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li>Mes DD, AAAA</li>',
'<li>&amp;MY_TIMESTAMP_TZ_FORMAT.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(202190826419269455.4001)
,p_name=>'P800_SHOW'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3028402997748766.4001)
,p_item_default=>'STANDARD'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Seleccione el tipo de temas que se van a mostrar; por defecto, s\00F3lo se incluyen los temas est\00E1ndar. Para incluir los temas heredados, seleccione los temas "Heredado" o "Todo".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(202192721434302086.4001)
,p_name=>'P800_UI_TYPE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3028402997748766.4001)
,p_item_default=>'1'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Seleccione la interfaz de usuario para la que desea definir el tema por defecto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(764642416918751971.4001)
,p_name=>'P800_DATE_TIME_FORMAT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3089017223979992.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Fecha/Hora'
,p_source=>'DATE_TIME_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica el formato de fecha y hora que se utilizar\00E1 en la aplicaci\00F3n.</p>'),
unistr('<p>Se puede hacer referencia a este formato de fecha y hora en una aplicaci\00F3n mediante la referencia de sustituci\00F3n &amp;APP_DATE_TIME_FORMAT. o en PL/SQL a trav\00E9s de la funci\00F3n v(''APP_DATE_TIME_FORMAT''). Este atributo no modifica ninguno de los valo')
||unistr('res de NLS. Este valor puede ser una cadena de literales que contenga una m\00E1scara de formato de fecha v\00E1lida de Oracle o una referencia de elemento mediante una sintaxis de sustituci\00F3n. Si no se especifica este valor de atributo, una referencia a APP')
||unistr('_DATE_TIME_FORMAT devolver\00E1 el formato de fecha de sesi\00F3n de la base de datos NLS y el formato de hora de NLS.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>Mes DD, RRRR HH24:MI</code></li>',
'<li><code>&amp;MY_DATE_TIME_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2797302876047184.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'seed values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c pls_integer;',
'  l_theme_id number;',
'begin',
'  select count(*) into c ',
'  from wwv_flow_app_build_pref ',
'  where security_group_id = :flow_security_group_id;',
'  ',
'  select ui.theme_id into l_theme_id',
'    from wwv_flows f, wwv_flow_user_interfaces ui ',
'   where f.security_group_id = 12 ',
'     and f.application_type = ''THEME''',
'     and f.id = ui.flow_id',
'     and ui.ui_type_id = 1',
'     and instr('',''||wwv_flow_platform.get_preference(''DEFAULT_THEMES'')||'','','',''||ui.theme_id||'','') > 0;',
' ',
'  if c = 0 then',
'      insert into wwv_flow_app_build_pref ',
'      (default_authentication_scheme, default_application_theme, default_tabs)',
'      values ',
'      (:PRODUCT_NAME,l_theme_id,''SINGLE_LEVEL_TABS'');',
'  end if;',
'  for c1 in (select id,default_authentication_scheme ',
'             from   wwv_flow_app_build_pref ',
'             where  security_group_id = :flow_security_group_id) loop',
'    :P800_ID := c1.id;',
'    if c1.default_authentication_scheme = ''HTML DB'' then',
'        update wwv_flow_app_build_pref',
'           set default_authentication_scheme = :PRODUCT_NAME',
'         where id = c1.id;',
'    end if;',
'  end loop;',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido iniciar los valores #SQLERRM#'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2795126399027307.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_APP_BUILD_PREF'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_BUILD_PREF'
,p_attribute_03=>'P800_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2795302222027308.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APP_BUILD_PREF'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_BUILD_PREF'
,p_attribute_03=>'P800_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_APP_BUILD_PREF.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2795505747027308.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'800'
);
end;
/
prompt --application/pages/page_00801
begin
wwv_flow_api.create_page(
 p_id=>801.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Esquemas de Autenticaci\00F3n')
,p_step_title=>unistr('Esquemas de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47918318810645641.4001)
,p_plug_name=>unistr('Esquemas de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4651a */',
'       case',
'         when a.id = f.authentication_id then',
'            ''icon-sc-authentication-scheme-on''',
'         else',
'            ''icon-sc-authentication-scheme-off''',
'       end as icon_class,',
'       ''f?p=4000:4495:''||:APP_SESSION||'':::RP,4495:P4495_ID:''||a.id as edit_link,',
'       replace(a.name,''_'','' '') as icon_title,',
'       a.name||',
'       case',
'         when a.id = f.authentication_id then '' - ''||wwv_flow_lang.system_message(''CURRENT'')',
'       end as name,',
'       a.scheme_type,',
'       a.id,',
'       a.cookie_name,',
'       a.cookie_path,',
'       a.cookie_domain,',
'       a.use_secure_cookie_yn,',
'       a.help_text,',
'       case when a.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_authentications',
'                         where id                = a.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_authentications',
'          where reference_id      = a.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       a.created_by,',
'       a.created_on,',
'       a.last_updated_by,',
'       a.last_updated_on',
'  from wwv_flow_authentications a,',
'       wwv_flows f',
' where a.flow_id           = :FB_FLOW_ID',
'   and a.security_group_id = :WORKSPACE_ID',
'   and f.id                = a.flow_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47918412797645641.4001)
,p_name=>'Authentication Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(398863113666021219.4001)
,p_db_column_name=>'NAME'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:RP,4495:P4495_ID:#ID#:'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(399114224317043174.4001)
,p_db_column_name=>'SCHEME_TYPE'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Tipo de Esquema'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(346988529123216543)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562182342198331.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562255618198332.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>30
,p_column_identifier=>'U'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(399006525571034147.4001)
,p_db_column_name=>'ID'
,p_display_order=>40
,p_column_identifier=>'J'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(155898325604349752.4001)
,p_db_column_name=>'COOKIE_NAME'
,p_display_order=>50
,p_column_identifier=>'L'
,p_column_label=>'Nombre de Cookie'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(155898427979349755.4001)
,p_db_column_name=>'COOKIE_PATH'
,p_display_order=>60
,p_column_identifier=>'M'
,p_column_label=>'Ruta de Acceso de Cookie'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(155898513392349755.4001)
,p_db_column_name=>'COOKIE_DOMAIN'
,p_display_order=>70
,p_column_identifier=>'N'
,p_column_label=>'Dominio de Cookie'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(155898602987349755.4001)
,p_db_column_name=>'USE_SECURE_COOKIE_YN'
,p_display_order=>80
,p_column_identifier=>'O'
,p_column_label=>'Cookie HTTPS'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(155898703994349756.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>90
,p_column_identifier=>'P'
,p_column_label=>'Texto de Ayuda'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656853828101717526.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>100
,p_column_identifier=>'Q'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656853982117717526.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>110
,p_column_identifier=>'R'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656859293293774521.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>120
,p_column_identifier=>'S'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(222858940690540017.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>130
,p_column_identifier=>'V'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(222859088703540018.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>140
,p_column_identifier=>'W'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(222859136725540019.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>150
,p_column_identifier=>'X'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(222859219289540020.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>160
,p_column_identifier=>'Y'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61795008932189803.4001)
,p_plug_name=>unistr('Esquemas de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un esquema de autenticaci\00F3n es una configuraci\00F3n guardada que puede aplicar a la aplicaci\00F3n.</p>'),
unistr('<p>Para desactivar la autenticaci\00F3n, debe crear y actualizar un esquema <strong>Sin autenticaci\00F3n</strong>.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/establishing-user-identity-through-authentication.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180425906908074887.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(180433926348108856.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188928627610654843.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47918318810645641.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:801,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62399523648756214.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47918318810645641.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:4495:::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_00802
begin
wwv_flow_api.create_page(
 p_id=>802.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cambiar Secuencia de Scripts de Instalaci\00F3n')
,p_step_title=>unistr('Cambiar Secuencia de Scripts de Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_def_common.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(236541617339568977.4001)
,p_plug_name=>'Cambiar Secuencia'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>100
,p_plug_source=>unistr('<p>Cambie la secuencia de los scripts de instalaci\00F3n mediante el incremento en 10 de los n\00FAmeros de secuencia.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(236541808541568977.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(236541617339568977.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(236542010307568977.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(236541617339568977.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cambiar Secuencia'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(236543508820568984.4001)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(236543227474568981.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'resequence installation script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number := 0;',
'begin',
'  for c1 in (',
'    select id, sequence',
'    from wwv_flow_install_scripts',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and nvl(script_type,''INSTALL'') = ''INSTALL''',
'    order by sequence)',
'  loop',
'    s := s + 10;',
'    update wwv_flow_install_scripts',
'    set sequence = s',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id ',
'    and id = c1.id',
'    and sequence != s;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(236542010307568977.4001)
,p_process_success_message=>unistr('Se ha limpiado el script de instalaci\00F3n.')
);
end;
/
prompt --application/pages/page_00815
begin
wwv_flow_api.create_page(
 p_id=>815.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autenticaci\00F3n: M\00E9todo')
,p_step_title=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8428524427164207.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="instructiontext">',
unistr('Puede crear un esquema de autenticaci\00F3n nuevo copiando uno de esta aplicaci\00F3n o de otra aplicaci\00F3n del espacio de trabajo. Posteriormente puede editar el esquema nuevo, cambiando el nombre y cualquier valor para ajustarlo a sus necesidades.'),
'</p>',
'<p class="instructiontext">',
unistr('Tambi\00E9n puede agregar un esquema de autenticaci\00F3n a la aplicaci\00F3n actual seleccionando uno de la galer\00EDa de esquemas proporcionados.'),
'</p>',
'<p class="instructiontext">',
unistr('Tambi\00E9n puede crear un esquema de autenticaci\00F3n nuevo desde el principio siguiendo los pasos del asistente y especificando todos los par\00E1metros. Para crear un esquema de autenticaci\00F3n desde el principio, seleccione "Basado en un esquema preconfigurad')
||unistr('o de la galer\00EDa" y, a continuaci\00F3n, seleccione el tipo de esquema "Personalizado".'),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 26-JUN-2002 03:01:48'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62446113813791403.4001)
,p_plug_name=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Al crear un esquema de autenticaci\00F3n nuevo, hay varias opciones. La mayor\00EDa permiten reutilizar implementaciones que ya existen en la aplicaci\00F3n o otras aplicaciones del espacio de trabajo. Existen incluso algunos esquemas ya probados que se puede')
||'n copiar y permiten empezar a trabajar inmediatamente.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109995619468692916.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109993128340686080.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208125022192147884.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747145769384138171.4001)
,p_plug_name=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62451616123810812.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208125022192147884.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(713325171828085.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208125022192147884.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(403061925280488166.4001)
,p_branch_action=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(713325171828085.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P815_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(403164909828493232.4001)
,p_branch_action=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:RP,4495::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(713325171828085.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P815_ACTION'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62464516123866306.4001)
,p_name=>'F4000_P815_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(62446113813791403.4001)
,p_item_default=>'CREATE'
,p_prompt=>'Crear Esquema:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'    select wwv_flow_lang.system_message(''F4000_P815_SCRATCH'') d,''CREATE'' r,',
'      1 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P815_COPY'') d, ''COPY'' r,',
'      2 ob from dual',
')',
'order by ob'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-TOP'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo mediante el cual desea crear un esquema de autenticaci\00F3n. Haga clic en el enlace Informaci\00F3n que hay a continuaci\00F3n para obtener m\00E1s informaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00816
begin
wwv_flow_api.create_page(
 p_id=>816.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autenticaci\00F3n: Esquema')
,p_step_title=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1251320063887658.4001)
,p_plug_name=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para copiar un esquema de autenticaci\00F3n de otra aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109997807824699042.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109993128340686080.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208126821630157159.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747145864397138172.4001)
,p_plug_name=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1251504424887662.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208126821630157159.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1251804007887667.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208126821630157159.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1257123264918315.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208126821630157159.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1253617234887694.4001)
,p_branch_action=>'818'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1251804007887667.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1253003892887691.4001)
,p_branch_action=>'815'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1257123264918315.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1259804713073810.4001)
,p_name=>'F4000_P816_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1251320063887658.4001)
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||wwv_flow_escape.html(f.name) as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_authentications a',
'                 where a.flow_id = f.id',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n desde la que desea copiar el esquema de autenticaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_00817
begin
wwv_flow_api.create_page(
 p_id=>817.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Gestionar Suscripciones'
,p_step_title=>unistr('Suscripci\00F3n de Esquema de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1379720217641287.4001)
,p_plug_name=>unistr('Suscripci\00F3n de Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina identifica los esquemas de autenticaci\00F3n suscritos en la aplicaci\00F3n.</p>  '),
unistr('<p>Para refrescar un esquema de autenticaci\00F3n, seleccione los esquemas que desea refrescar y a continuaci\00F3n, haga clic en <strong>Refrescar Selecci\00F3n</strong>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1380012919641288.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1384333522660578.4001)
,p_name=>unistr('Suscripci\00F3n de Esquema de Autenticaci\00F3n')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   wwv_flow_item.checkbox(1, id) cb, ',
'   wwv_flow_item.hidden(2, reference_id) hd, ',
'   flow_id, ',
'   name, ',
'   (select t.m1||'' ''||flow_id||'', ''||name ',
'    from wwv_flow_authentications',
'    where id = reference_id) cp_from    ',
'from wwv_flow_authentications s,',
'     (select wwv_flow_lang.system_message(''F4000_P801_FLOW'') m1 from dual) t',
'where flow_id           = :FB_FLOW_ID',
'  and security_group_id = :WORKSPACE_ID',
'  and reference_id      is not null',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn esquema de autenticaci\00F3n suscrito.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48769217233772118.4001)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48769300047772118.4001)
,p_query_column_id=>2
,p_column_alias=>'HD'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48769414799772118.4001)
,p_query_column_id=>3
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48769507312772118.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48769631816772118.4001)
,p_query_column_id=>5
,p_column_alias=>'CP_FROM'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Suscripci\00F3n de')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180439117522144116.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(180433926348108856.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1380811722641296.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1380012919641288.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_authentications',
' where flow_id = :FB_FLOW_ID',
'   and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1382126511641304.4001)
,p_branch_action=>'817'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1380811722641296.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1388220802713630.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh authentication schemes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        wwv_flow_copy_metadata.refresh_authentication (    ',
'            p_subscribing_auth_id => wwv_flow.g_f01(i) );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar los esquemas de autenticaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(1380811722641296.4001)
,p_process_success_message=>unistr('Esquemas de autenticaci\00F3n seleccionados refrescados.')
);
end;
/
prompt --application/pages/page_00818
begin
wwv_flow_api.create_page(
 p_id=>818.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Esquema de Autenticaci\00F3n: Confirmar')
,p_step_title=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1270127414132552.4001)
,p_name=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id, ',
'       name, ',
'       ''<label for="ToName''||rownum||''" class="hideMe508">To Name</label>''||',
'       wwv_flow_item.text (',
'           1,',
'           wwv_flow_lang.system_message(''F4000.P158.COPY_OF'', name),',
'           40,',
'           255,',
'           ''id="ToName''||rownum||''"'') to_name,',
'       ''<label for="copy''||rownum||''" class="hideMe508">Copy</label>''||',
'       wwv_flow_item.select_list (',
'           2,',
'           ''N'',',
'           m_yes||'';Y,''||m_no||'';N''||case when :F4000_P816_COPY_FROM <> :FB_FLOW_ID then '',''||m_copy_sub||'';SUBSCRIBE'' end,',
'           ''id="copy''||rownum||''"'') copy_subscribe,',
'       wwv_flow_item.hidden(3,id) id',
'  from wwv_flow_authentications,',
'       ( select wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'                wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'                wwv_flow_lang.system_message(''F4000_COPY_AND_SUBSCRIBE'') m_copy_sub',
'           from dual )',
'where flow_id           = :F4000_P816_COPY_FROM',
'  and security_group_id = :flow_security_group_id',
'order by 1, 2'))
,p_header=>unistr('<p>Puede elegir entre copiar o copiar y suscribirse a un esquema de autenticaci\00F3n en la aplicaci\00F3n que seleccione como origen de la copia. Al suscribirse a un esquema de autenticaci\00F3n, se coloca una copia de \00E9ste en la aplicaci\00F3n, aunque permite refr')
||unistr('escarlo peri\00F3dicamente para obtener los cambios m\00E1s recientes.</p>')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576727441744013.4001)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576842361744014.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'De Nombre'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923576926294744015.4001)
,p_query_column_id=>3
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'A Nombre'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923577080583744016.4001)
,p_query_column_id=>4
,p_column_alias=>'COPY_SUBSCRIBE'
,p_column_display_sequence=>4
,p_column_heading=>'Copiar'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#COPY_SUBSCRIBE##ID#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(923577196508744017.4001)
,p_query_column_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110000800683706473.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109993128340686080.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208152522818668422.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747145962058138172.4001)
,p_plug_name=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1270316928132553.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208152522818668422.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1270617619132554.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208152522818668422.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Esquema'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1270932119132555.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208152522818668422.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41480412040672877.4001)
,p_branch_action=>'f?p=&FLOW_ID.:801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1271922849132559.4001)
,p_branch_action=>'801'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1270316928132553.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1271615940132558.4001)
,p_branch_action=>'816'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(1270932119132555.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1272501891132562.4001)
,p_validation_name=>'flow id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P816_COPY_FROM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(1270617619132554.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78629723361199740.4001)
,p_validation_name=>'MustHaveSomethingToCopy'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'')',
'     then return null;',
'  end if;',
'end loop;',
'return wwv_flow_lang.system_message(''F4000.P818.VALIDATION'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Debe tener algo que copiar.'
,p_when_button_pressed=>wwv_flow_api.id(1270617619132554.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1287519501295760.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Auth Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for i in 1..wwv_flow.g_f03.count loop',
'        if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'            wwv_flow_copy_util.copy_authentication (',
'                p_copy_from_flow_id      => :F4000_P816_COPY_FROM,',
'                p_flow_id                => :FB_FLOW_ID,',
'                p_from_authentication_id => wwv_flow.g_f03(i),',
'                p_to_authentication_name => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'                p_subscribe              => (wwv_flow.g_f02(i) = ''SUBSCRIBE'') );',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar el esquema de autenticaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(1270617619132554.4001)
,p_process_success_message=>unistr('Esquema de autenticaci\00F3n copiado.')
);
end;
/
prompt --application/pages/page_00821
begin
wwv_flow_api.create_page(
 p_id=>821.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Publicaci\00F3n de Esquema de Autenticaci\00F3n')
,p_step_title=>unistr('Confirmar Publicaci\00F3n de Esquema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(165212042323365850.4001)
,p_plug_name=>'Publish Authentication Scheme Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<ul>'');',
'for c in (select flow_id, name',
'            from wwv_flow_authentications',
'           where reference_id = :F4000_P821_ID',
'             and security_group_id = :flow_security_group_id',
'           order by flow_id, name ) loop',
'   sys.htp.p(''<li>''||',
'             wwv_flow_escape.noop(c.flow_id)||',
'             '' - ''||',
'             wwv_flow_escape.html(c.name)||',
'             ''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_header=>unistr('<p>Ha solicitado el refrescamiento de los siguientes esquemas de autenticaci\00F3n:</p>')
,p_plug_footer=>unistr('<p>Si esto es correcto, haga clic en el bot\00F3n <strong>Refrescar Todo</strong>. De lo contrario, haga clic en <strong>Cancelar</strong>.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932667577858561025.4001)
,p_plug_name=>unistr('Confirmar Publicaci\00F3n de Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932667616071561026.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202454845156190480.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(932667616071561026.4001)
,p_button_name=>'REFRESH_SETUPS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refrescar Todo'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10_69c"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202453017995187867.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(932667616071561026.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_P821_PAGE_ID.:&SESSION.::&DEBUG.::::'
,p_button_cattributes=>'class="button10_69c"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(165213530413365870.4001)
,p_branch_name=>'Go To Page &F4000_P821_PAGE_ID.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_P821_PAGE_ID.:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165820939224441373.4001)
,p_name=>'F4000_P821_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(165212042323365850.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(165893132932489837.4001)
,p_name=>'F4000_P821_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(165212042323365850.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201131046895469054.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Authentication Schemes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.push_authentication (',
'    p_authentication_id => :F4000_P821_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar todos los esquemas de autenticaci\00F3n de suscripci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(202454845156190480.4001)
,p_process_success_message=>unistr('Se han refrescado todos los esquemas de autenticaci\00F3n de suscripci\00F3n.')
);
end;
/
prompt --application/pages/page_00836
begin
wwv_flow_api.create_page(
 p_id=>836.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Calendario'
,p_step_title=>'Editar Plantilla de Calendario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30736404037181311.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12991522578387911.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30736610598181325.4001)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30736820787181326.4001)
,p_plug_name=>'Plantilla de Calendario'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30737221419181328.4001)
,p_plug_name=>'Formatos de Mes'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30737408206181328.4001)
,p_plug_name=>'Formatos de Semana'
,p_region_name=>'WEEK'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30737616215181329.4001)
,p_plug_name=>unistr('Formatos de D\00EDa de la Semana')
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30737832425181329.4001)
,p_plug_name=>unistr('Formatos de D\00EDa del Mes Anterior')
,p_region_name=>'NON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30738007980181329.4001)
,p_plug_name=>'Formatos de Fin de Semana'
,p_region_name=>'END'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30738205604181329.4001)
,p_plug_name=>'Plantillas de Calendario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas de calendario controlan el aspecto y colocaci\00F3n de un calendario. Estas plantillas utilizan las tablas HTML frecuentemente para organizar las fechas.</p>'),
unistr('<p>Puede colocar los atributos de calendario utilizando cadenas de sustituci\00F3n como #DD# y #MONTH#. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).</p>')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30738821398181332.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n de formato de fecha:</p>'),
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>TIME</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'<li>FMHH</li>',
'<li>FMMI</li>',
'</ul>',
unistr('<p>Si coloca "I" delante de cualquier cadena, el texto tendr\00E1 may\00FAscula inicial.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32670615821238675.4001)
,p_plug_name=>'Formatos de Hora'
,p_region_name=>'HOUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32672327596242041.4001)
,p_plug_name=>'Formatos de Tiempo'
,p_region_name=>'TIME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34021815937892872.4001)
,p_plug_name=>unistr('Atributos de D\00EDa')
,p_region_name=>'DATT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46249001042678993.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30741104924181363.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30740911649181362.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30740307605181362.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30740726818181362.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P836_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30740132369181361.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30757501612181430.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P836_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30740911649181362.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30757728889181432.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P836_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30741104924181363.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30758127950181432.4001)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30758314701181433.4001)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30780705699970362.4001)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3696802231121039.4001)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30758530672181433.4001)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30758732438181433.4001)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P836_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30757906580181432.4001)
,p_branch_name=>'Go To Page 836'
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30758900723181433.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30759106723181436.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30741325154181363.4001)
,p_name=>'P836_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30736820787181326.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30741530244181368.4001)
,p_name=>'P836_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30736820787181326.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define un nombre que identifica la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30742209376181373.4001)
,p_name=>'P836_CUSTOM_MONTH_TITLE_FORMAT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Mes')
,p_source=>'CUSTOM_MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para el t\00EDtulo mensual que aparece en la parte superior de cada mes. \00C9sta es la primera parte de un calendario que se imprime en la p\00E1gina. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30742716410181374.4001)
,p_name=>'P836_CUSTOM_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de D\00EDa de la Semana')
,p_source=>'CUSTOM_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30743215850181375.4001)
,p_name=>'P836_CUSTOM_MONTH_OPEN_FORMAT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Mes'
,p_source=>'CUSTOM_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un mes. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30743701101181375.4001)
,p_name=>'P836_CUSTOM_MONTH_CLOSE_FORMAT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Mes'
,p_source=>'CUSTOM_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un mes. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en el "Formato de Apertura de Mes".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30744206412181376.4001)
,p_name=>'P836_CUSTOM_DAY_TITLE_FORMAT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa')
,p_source=>'CUSTOM_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para el t\00EDtulo del d\00EDa, que es lo primero que se imprime detr\00E1s del "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30744700766181377.4001)
,p_name=>'P836_CUSTOM_DAY_OPEN_FORMAT'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Apertura de D\00EDa')
,p_source=>'CUSTOM_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime para cada d\00EDa. Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa ')
||unistr('en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30745225658181378.4001)
,p_name=>'P836_CUSTOM_DAY_CLOSE_FORMAT'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Cierre de D\00EDa')
,p_source=>'CUSTOM_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30745716938181378.4001)
,p_name=>'P836_CUSTOM_TODAY_OPEN_FORMAT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hoy'
,p_source=>'CUSTOM_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir la fecha actual. Normalmente se trata de una etiqueta HTML que es un contenedor, como un td, y que no coincide exactamente con el "Formato de Apertura de D\00EDa". Incluya cadenas de sustituci\00F3n para incluir')
||unistr(' contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30746228616181379.4001)
,p_name=>'P836_CUSTOM_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(30738007980181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Fin de Semana')
,p_source=>'CUSTOM_WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para un d\00EDa de fin de semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30746721401181379.4001)
,p_name=>'P836_CUSTOM_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(30738007980181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Fin de Semana'
,p_source=>'CUSTOM_WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa de fin de semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como un TD. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas')
||unistr(' de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30747207758181380.4001)
,p_name=>'P836_CUSTOM_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(30738007980181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Fin de Semana'
,p_source=>'CUSTOM_WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa de fin de semana. \00C9ste es el \00FAltimo elemento de cada fin de semana que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Format')
||'o de Apertura de Fin de Semana". ',
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30747718454181380.4001)
,p_name=>'P836_CUSTOM_NONDAY_TITLE_FORMAT'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(30737832425181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de D\00EDa del Mes Anterior')
,p_source=>'CUSTOM_NONDAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para formatear el t\00EDtulo de un d\00EDa del mes anterior. Por ejemplo, el primer d\00EDa de un mes es un lunes, pero la semana empieza en domingo. Como domingo no pertenece al mes actual, domingo ser\00EDa un d\00EDa del mes anteri')
||'or.',
unistr('<p> Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  #DD#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30748208700181381.4001)
,p_name=>'P836_CUSTOM_NONDAY_OPEN_FORMAT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(30737832425181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Apertura de D\00EDa del Mes Anterior')
,p_source=>'CUSTOM_NONDAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML para abrir un d\00EDa del mes anterior. Por ejemplo, el primer d\00EDa de un mes es un lunes, pero la semana empieza en domingo. Como domingo no pertenece al mes actual, domingo ser\00EDa un d\00EDa del mes anterior.'),
'',
unistr('<p>Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30748717902181381.4001)
,p_name=>'P836_CUSTOM_NONDAY_CLOSE_FORMAT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(30737832425181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Cierre de D\00EDa del Mes Anterior')
,p_source=>'CUSTOM_NONDAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que cerrar\00E1 un d\00EDa del mes anterior. Por ejemplo, cuando el primer d\00EDa de un mes es un lunes y la semana empieza en domingo, domingo no tendr\00EDa una fecha en el mes actual y por tanto ser\00EDa un d\00EDa del mes anterior.'),
unistr('<p>Normalmente se trata de una etiqueta HTML que cierra la etiqueta utilizada en "Formato de Apertura de D\00EDa del Mes Anterior".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30749724235181382.4001)
,p_name=>'P836_CUSTOM_WEEK_OPEN_FORMAT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(30737408206181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Semana'
,p_source=>'CUSTOM_WEEK_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir una semana. \00C9ste se imprime para cada semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como tr. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista co')
||unistr('mpleta en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30750211397181382.4001)
,p_name=>'P836_CUSTOM_WEEK_CLOSE_FORMAT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(30737408206181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Semana'
,p_source=>'CUSTOM_WEEK_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una semana. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de Semana".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30752726031181390.4001)
,p_name=>'P836_STAY'
,p_item_sequence=>550
,p_item_plug_id=>wwv_flow_api.id(30738205604181329.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30753426836181392.4001)
,p_name=>'P836_THEME_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(30736820787181326.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30753906432181393.4001)
,p_name=>'P836_THEME_CLASS_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(30736820787181326.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43619531898960304.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30754908612181407.4001)
,p_name=>'P836_ID_NEXT'
,p_item_sequence=>520
,p_item_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_prompt=>'P836_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30755120633181415.4001)
,p_name=>'P836_ID_PREV'
,p_item_sequence=>530
,p_item_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_prompt=>'P836_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30755306801181415.4001)
,p_name=>'P836_ID_COUNT'
,p_item_sequence=>540
,p_item_plug_id=>wwv_flow_api.id(30736610598181325.4001)
,p_prompt=>'Plantilla de Calendario: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la plantilla de calendario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32671418985238695.4001)
,p_name=>'P836_CUSTOM_HOUR_OPEN_FORMAT'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(32670615821238675.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Hora'
,p_source=>'CUSTOM_HOUR_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir una hora. \00C9ste se imprime para cada hora. Normalmente se trata de una etiqueta HTML que es un contenedor, como tr. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista comple')
||unistr('ta en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32671916155238696.4001)
,p_name=>'P836_CUSTOM_HOUR_CLOSE_FORMAT'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(32670615821238675.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Hora'
,p_source=>'CUSTOM_HOUR_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una hora. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de Hora".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32672624745242044.4001)
,p_name=>'P836_CUSTOM_TIME_TITLE_FORMAT'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(32672327596242041.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de T\00EDtulo de Tiempo')
,p_source=>'CUSTOM_TIME_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para formatear un t\00EDtulo de tiempo. '),
unistr('<p> Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  #HH:MI#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32673110345242044.4001)
,p_name=>'P836_CUSTOM_TIME_OPEN_FORMAT'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(32672327596242041.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Apertura de Tiempo'
,p_source=>'CUSTOM_TIME_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un tiempo. '),
'',
unistr('<p>Normalmente se trata de una etiqueta HTML que es un contenedor, como un td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32673625667242044.4001)
,p_name=>'P836_CUSTOM_TIME_CLOSE_FORMAT'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(32672327596242041.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Cierre de Tiempo'
,p_source=>'CUSTOM_TIME_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un tiempo.  '),
'<p>Normalmente se trata de una etiqueta HTML que cierra la etiqueta utilizada en "Formato de Apertura de Tiempo".',
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32971704043689629.4001)
,p_name=>'P836_CUSTOM_WK_MONTH_TITLE_FORMAT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato Alternativo de T\00EDtulo de Mes')
,p_source=>'CUSTOM_WK_MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para el t\00EDtulo mensual que aparece en la parte superior de cada mes. \00C9sta es la primera parte de un calendario que se imprime en la p\00E1gina. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32972700842707637.4001)
,p_name=>'P836_CUSTOM_WK_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato Alternativo de D\00EDa de la Semana')
,p_source=>'CUSTOM_WK_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el formato para los nombres de los d\00EDas de la semana que aparecen como cabecera de columna para cada d\00EDa de la semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32973207720721634.4001)
,p_name=>'P836_CUSTOM_WK_MONTH_OPEN_FORMAT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Apertura de Mes'
,p_source=>'CUSTOM_WK_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un mes. \00C9ste se imprime inmediatamente despu\00E9s del "Formato de T\00EDtulo de Mes". Normalmente se trata de una etiqueta HTML que es un contenedor, por ejemplo, una tabla. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32973709929731745.4001)
,p_name=>'P836_CUSTOM_WK_MONTH_CLOSE_FORMAT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(30737221419181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Cierre de Mes'
,p_source=>'CUSTOM_WK_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un mes. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en el "Formato de Apertura de Mes".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32974629771869869.4001)
,p_name=>'P836_CUSTOM_WK_WEEK_OPEN_FORMAT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(30737408206181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Apertura de Semana'
,p_source=>'CUSTOM_WK_WEEK_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir una semana. \00C9ste se imprime para cada semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como tr. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista co')
||unistr('mpleta en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32975113064883973.4001)
,p_name=>'P836_CUSTOM_WK_WEEK_CLOSE_FORMAT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(30737408206181328.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Cierre de Semana'
,p_source=>'CUSTOM_WK_WEEK_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar una semana. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de Semana".'),
unistr(' Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33036502702808166.4001)
,p_name=>'P836_CUSTOM_WK_DAY_TITLE_FORMAT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato Alternativo de T\00EDtulo de D\00EDa')
,p_source=>'CUSTOM_WK_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para el t\00EDtulo del d\00EDa, que es lo primero que se imprime detr\00E1s del "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33037624519814502.4001)
,p_name=>'P836_CUSTOM_WK_DAY_OPEN_FORMAT'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato Alternativo de Apertura de D\00EDa')
,p_source=>'CUSTOM_WK_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa. \00C9ste se imprime para cada d\00EDa. Normalmente se trata de una etiqueta HTML que es un contenedor, como td. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa ')
||unistr('en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33038218070822099.4001)
,p_name=>'P836_CUSTOM_WK_DAY_CLOSE_FORMAT'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato Alternativo de Cierre de D\00EDa')
,p_source=>'CUSTOM_WK_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa. \00C9ste es el \00FAltimo elemento que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Formato de Apertura de D\00EDa". '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33040711191848424.4001)
,p_name=>'P836_CUSTOM_WK_TODAY_OPEN_FORMAT'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(30737616215181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Apertura de Hoy'
,p_source=>'CUSTOM_WK_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir la fecha actual. Normalmente se trata de una etiqueta HTML que es un contenedor, como un td, y que no coincide exactamente con el "Formato de Apertura de D\00EDa". Incluya cadenas de sustituci\00F3n para incluir')
||unistr(' contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33051806099979442.4001)
,p_name=>'P836_CUSTOM_WK_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(30738007980181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato Alternativo de T\00EDtulo de Fin de Semana')
,p_source=>'CUSTOM_WK_WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para un d\00EDa de fin de semana. '),
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n".'),
'',
' Por ejemplo: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33052319258983294.4001)
,p_name=>'P836_CUSTOM_WK_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(30738007980181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Apertura de Fin de Semana'
,p_source=>'CUSTOM_WK_WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para abrir un d\00EDa de fin de semana. Normalmente se trata de una etiqueta HTML que es un contenedor, como un TD. Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas')
||unistr(' de Sustituci\00F3n". Por ejemplo:'),
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33052800343987265.4001)
,p_name=>'P836_CUSTOM_WK_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(30738007980181329.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato Alternativo de Cierre de Fin de Semana'
,p_source=>'CUSTOM_WK_WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para cerrar un d\00EDa de fin de semana. \00C9ste es el \00FAltimo elemento de cada fin de semana que se imprime, por lo tanto, debe cerrar todas las etiquetas HTML que se hayan utilizado, como la etiqueta utilizada en "Format')
||'o de Apertura de Fin de Semana". ',
unistr('Incluya cadenas de sustituci\00F3n para incluir contenido din\00E1mico. Consulte la lista completa en "Cadenas de Sustituci\00F3n". '),
'',
'Por ejemplo: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34024631445991915.4001)
,p_name=>'P836_CUSTOM_MONTH_DAY_HEIGHT_PIX'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_api.id(34021815937892872.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Altura de D\00EDa para el Mes (p\00EDxeles)')
,p_source=>'CUSTOM_MONTH_DAY_HEIGHT_PIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca la altura de cada d\00EDa en p\00EDxeles. Este valor se utilizar\00E1 para calcular la altura del d\00EDa cuando hay menos d\00EDas para mostrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34025123958999262.4001)
,p_name=>'P836_CUSTOM_MONTH_DAY_HEIGHT_PER'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_api.id(34021815937892872.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Altura de D\00EDa para Mes (%)')
,p_source=>'CUSTOM_MONTH_DAY_HEIGHT_PER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca la altura de cada d\00EDa en porcentajes. Este valor se utilizar\00E1 para calcular la altura del d\00EDa cuando haya menos d\00EDas para mostrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34026110714014319.4001)
,p_name=>'P836_CUSTOM_WEEK_DAY_WIDTH_PIX'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_api.id(34021815937892872.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ancho de D\00EDa para Semana (p\00EDxeles)')
,p_source=>'CUSTOM_WEEK_DAY_WIDTH_PIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca la anchura de cada d\00EDa en p\00EDxeles. Este valor se utilizar\00E1 para calcular la anchura del d\00EDa cuando hay menos d\00EDas para mostrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34026628375019445.4001)
,p_name=>'P836_CUSTOM_WEEK_DAY_WIDTH_PER'
,p_item_sequence=>510
,p_item_plug_id=>wwv_flow_api.id(34021815937892872.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ancho de D\00EDa para Semana (%)')
,p_source=>'CUSTOM_WEEK_DAY_WIDTH_PER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca la altura de cada d\00EDa en porcentaje. Este valor se utilizar\00E1 para calcular la altura del d\00EDa cuando hay menos d\00EDas para mostrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397296916378455876.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P836_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397297205455455876.4001)
,p_event_id=>wwv_flow_api.id(397296916378455876.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(30741104924181363.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397297321226457274.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P836_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397297630811457274.4001)
,p_event_id=>wwv_flow_api.id(397297321226457274.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(30740911649181362.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30756009163181421.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P836_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30756206497181427.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P836_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P836_ID_NEXT'
,p_attribute_10=>'P836_ID_PREV'
,p_attribute_13=>'P836_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30756410977181428.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P836_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la plantilla de calendario.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30756627826181428.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_api.id(30740726818181362.4001)
);
end;
/
prompt --application/pages/page_00841
begin
wwv_flow_api.create_page(
 p_id=>841.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Plugins'
,p_step_title=>'Historial de Plugins'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193353032170451678.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(188993730020080349.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193353222689451681.4001)
,p_plug_name=>'Historial de Plugins'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los plugins de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193353829303451686.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_user as developer, ',
'       audit_date,',
'       audit_action as action,',
'       scn,',
'       audit_comment,',
'       flow_table_pk as component_key,',
'       object_name   as component_name',
'  from wwv_flow_builder_audit_trail',
' where flow_ID           = :FB_FLOW_ID',
'   and flow_table        = ''WWV_FLOW_PLUGINS''',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193354005831451687.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354119273451687.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354213467451688.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354324081451689.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354412202451690.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354507636451690.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354621995451691.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193354727150451692.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(192763415498955359)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193353620177451682.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193353829303451686.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.:841,RIR::'
);
end;
/
prompt --application/pages/page_00842
begin
wwv_flow_api.create_page(
 p_id=>842.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla e Informe Basados en Servicio Web: Resultados de Servicio Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193700709314861099.4001)
,p_plug_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Seleccione el estilo de SOAP y el formato del mensaje. Introduzca la referencia de XPath al nodo del resultado sobre el que desea el informe. Introduzca el espacio de nombres del mensaje resultante.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193704508096861117.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204749728916135641.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193700925482861101.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204749728916135641.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193701122640861103.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204749728916135641.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193701331678861104.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204749728916135641.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193705803048861160.4001)
,p_branch_action=>'f?p=&APP_ID.:848:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193701122640861103.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193706019580861184.4001)
,p_branch_action=>'f?p=&APP_ID.:720:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193701331678861104.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193706204117861184.4001)
,p_branch_action=>'f?p=&FLOW_ID.:842:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193701503397861104.4001)
,p_name=>'P842_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(193700709314861099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Referencia de Servicio Web'
,p_source=>'P700_WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEB SERVICES OLD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193702106131861109.4001)
,p_name=>'P842_SOAP_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(193700709314861099.4001)
,p_item_default=>'document'
,p_prompt=>'Estilo de SOAP:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.SOAP.STYLE'
,p_lov=>'.'||wwv_flow_api.id(40229315139441290.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el estilo de la respuesta SOAP. El estilo se puede determinar a partir del atributo de estilo del elemento soap:binding de WSDL de esta operaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193702711384861110.4001)
,p_name=>'P842_MESSAGE_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(193700709314861099.4001)
,p_item_default=>'literal'
,p_prompt=>'Formato del Mensaje:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.MESSAGE.STYLE'
,p_lov=>'.'||wwv_flow_api.id(40231925790463373.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el formato del mensaje. La codificaci\00F3n se puede determinar a partir del atributo de uso del elemento soap:body del mensaje de salida de WSDL de esta operaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193703319465861111.4001)
,p_name=>'P842_MESSAGE_NAMESPACE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(193700709314861099.4001)
,p_prompt=>'Espacio de Nombres de Mensaje'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca el espacio de nombres para el mensaje de respuesta. Normalmente se puede determinar consultando el atributo targetNamespace de WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193703901959861116.4001)
,p_name=>'P842_NODE_PATH'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(193700709314861099.4001)
,p_prompt=>'Ruta de Acceso del Nodo de Resultados (XPath) '
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la expresi\00F3n XPath al nodo del mensaje de respuesta en el que est\00E1 creando el informe. El nodo es un secundario del elemento soap:Body. Por ejemplo,'),
'<p />/result/myNode'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193705400375861132.4001)
,p_validation_name=>'P842_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P842_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(193701122640861103.4001)
,p_associated_item=>wwv_flow_api.id(193701503397861104.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193705627684861160.4001)
,p_validation_name=>'P842_NODE_PATH'
,p_validation_sequence=>20
,p_validation=>'P842_NODE_PATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe proporcionar la XPath al nodo del informe.'
,p_when_button_pressed=>wwv_flow_api.id(193701122640861103.4001)
,p_associated_item=>wwv_flow_api.id(193703901959861116.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549741862163954519.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193700925482861101.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549741938169954520.4001)
,p_event_id=>wwv_flow_api.id(549741862163954519.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00843
begin
wwv_flow_api.create_page(
 p_id=>843.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de Consultas de Informe'
,p_step_title=>'Historial de Consultas de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193366300843375400.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(193369209650497455.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193366701445375459.4001)
,p_plug_name=>'Historial de Consultas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las consultas de informe de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193367318792375493.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>160
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SHARED_QUERIES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193367506810375495.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193367619420375857.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193367726342375859.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193367802322375859.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193367932121375860.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193368017233375861.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193368102211375862.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193368228310375862.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193367117339375468.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193367318792375493.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.:41,RIR::'
);
end;
/
prompt --application/pages/page_00844
begin
wwv_flow_api.create_page(
 p_id=>844.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Dise\00F1os de Informe')
,p_step_title=>unistr('Historial de Dise\00F1os de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193371726595539439.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(193374517232546937.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193371920376539440.4001)
,p_plug_name=>unistr('Historial de Dise\00F1os de Informe')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los dise\00F1os de informe de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193372518912539444.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>160
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_REPORT_LAYOUTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(193372710936539444.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193372822779539445.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193372912106539446.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193373009305539446.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193373112932539447.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193373213180539448.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193373302160539449.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(193373407100539449.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193372321247539443.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(193372518912539444.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:844:&SESSION.::&DEBUG.:41,RIR::'
);
end;
/
prompt --application/pages/page_00847
begin
wwv_flow_api.create_page(
 p_id=>847.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilidades de C\00E1lculo')
,p_step_title=>unistr('Utilidades de C\00E1lculo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193687119709601736.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193688119533608034.4001)
,p_plug_name=>unistr('Utilidades de C\00E1lculo')
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(171769406383685886.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193723107000124788.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
end;
/
prompt --application/pages/page_00848
begin
wwv_flow_api.create_page(
 p_id=>848.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla e Informes Basados en Servicio Web: Par\00E1metros de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(193707208478872103.4001)
,p_name=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id id, c001 name',
'  from wwv_flow_collections',
' where collection_name = ''WS_ARRAY_PARMS'''))
,p_header=>unistr('<p>Especifique un nombre de juego de resultados temporal e introduzca nombres de par\00E1metro desde el \00E1rbol de resultados para incluirlos en el informe. El nombre de la recopilaci\00F3n ya debe estar relleno. Si no lo est\00E1, no ha definido una recopilaci\00F3n ')
||unistr('para almacenar la respuesta de este servicio web. Edite la referencia web para identificar esta recopilaci\00F3n.</p>')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193707402565872106.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193707508072872106.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombres de Par\00E1metro')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193711016260872114.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204752001819146761.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193707804604872108.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204752001819146761.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193707614865872106.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204752001819146761.4001)
,p_button_name=>'ADDPARAMETER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193708018756872108.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204752001819146761.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193708206471872108.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204752001819146761.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193713720764872130.4001)
,p_branch_action=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193708206471872108.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193714122694872132.4001)
,p_branch_action=>'f?p=&FLOW_ID.:848:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193707614865872106.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193722031410093979.4001)
,p_branch_action=>'f?p=&FLOW_ID.:735:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193708018756872108.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193722916912118174.4001)
,p_branch_name=>'Navigation /Tabs Page'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::P4716_PREV_PAGE_ID:&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193708018756872108.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193708420928872108.4001)
,p_name=>'P848_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(193707208478872103.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1rbol de Resultados para Informe:')
,p_source=>'P842_NODE_PATH'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('\00C9sta es la parte del documento XML resultante que contiene la informaci\00F3n que desea incluir en el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193709032530872109.4001)
,p_name=>'P848_RESULT_COLLECTION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(193707208478872103.4001)
,p_prompt=>unistr('Resultado Almacenado en Recopilaci\00F3n')
,p_source=>'select static_parm_03 from wwv_flow_shared_web_services where id = :P700_WS_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el nombre del juego de resultados temporal en el que se almacenar\00E1 el resultado del servicio Web. El juego de resultados temporal se almacena en una recopilaci\00F3n de &PRODUCT_NAME. en la columna CLOB001.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193709613466872111.4001)
,p_name=>'P848_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(193707208478872103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193709810694872111.4001)
,p_name=>'P848_ROW_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(193707208478872103.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Informe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la plantilla de informe que va a utilizar esta regi\00F3n de informe.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193712129655872120.4001)
,p_computation_sequence=>10
,p_computation_item=>'P848_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193712522531872121.4001)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos un par\00E1metro para el informe.')
,p_when_button_pressed=>wwv_flow_api.id(193708018756872108.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193712725668872122.4001)
,p_validation_name=>'P848_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P848_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar el nombre de la recopilaci\00F3n que contiene el resultado del servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(193708018756872108.4001)
,p_associated_item=>wwv_flow_api.id(193709032530872109.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549742002506954521.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193707804604872108.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549742150227954522.4001)
,p_event_id=>wwv_flow_api.id(549742002506954521.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(193712900925872126.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_ARRAY_PARMS'',',
'  p_seq             => wwv_flow.g_f01,',
'  p_c001            => wwv_flow.g_f02 );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(193713121381872127.4001)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add parameter'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.add_member(',
'  p_collection_name => ''WS_ARRAY_PARMS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(193707614865872106.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(193713526101872129.4001)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create WS_REPORT_ITEMS'
,p_process_sql_clob=>'wwv_flow_collection.create_collection_from_query(''WS_ARRAY_PARMS'',''select null from wwv_flow_dual100 where rownum < 11'');'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_ARRAY_PARMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00849
begin
wwv_flow_api.create_page(
 p_id=>849.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Comentarios: Definir')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1ginas de comentarios')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'td_fb.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44683213273657428.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196191122274857782.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Proporcione a los usuarios finales un mecanismo para publicar comentarios generales como respuesta a los administradores y desarrolladores de la aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Provide a mechanism for end users to post general comments back to the application administrators and developers. The posts include useful session state information to help determine where the end user sent the feedback from. Providing such an easy f'
||'eedback loop enhances communication between the user community and the application owners, which leads to greatly improved end user satisfaction.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(233451171129837778.4001)
,p_plug_name=>'Crear Separador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>150
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(233450582559837776.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(233451171129837778.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P849_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58000833527816318.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57999797672816317.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58000190784816318.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58000438712816318.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(505617408566993055.4001)
,p_plug_name=>unistr('Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>160
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3891704745946633046.4001)
,p_plug_name=>'Opciones Admin'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196191726308864525.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44683213273657428.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196192103639864527.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44683213273657428.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(196191921844864527.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44683213273657428.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(515939446961056895.4001)
,p_branch_name=>'edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(196192103639864527.4001)
,p_branch_sequence=>55
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548811099702924177.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(196191921844864527.4001)
,p_branch_sequence=>65
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57993403913813905.4001)
,p_name=>'P849_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3891704745946633046.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n, a la que se ha agregado una lista, para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57993876312813910.4001)
,p_name=>'P849_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3891704745946633046.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 100, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57994720403813912.4001)
,p_name=>'P849_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3891704745946633046.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57995198676813912.4001)
,p_name=>'P849_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3891704745946633046.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que se utiliza como p\00E1gina de administraci\00F3n en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57995872087816314.4001)
,p_name=>'P849_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(233451171129837778.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57996779310816315.4001)
,p_name=>'P849_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(233451171129837778.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57997607996816315.4001)
,p_name=>'P849_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(233451171129837778.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57998501330816316.4001)
,p_name=>'P849_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(233451171129837778.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P849_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P849_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58001581838817623.4001)
,p_name=>'P849_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58002438874817624.4001)
,p_name=>'P849_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58002856620817624.4001)
,p_name=>'P849_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58003795175817625.4001)
,p_name=>'P849_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58004629688817625.4001)
,p_name=>'P849_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P849_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58005553248817626.4001)
,p_name=>'P849_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1153295071514196955.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P849_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98083881973541955.4001)
,p_name=>'P849_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3891704745946633046.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguno -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el esquema de autorizaci\00F3n que se va a utilizar para limitar el acceso a la p\00E1gina de administraci\00F3n y a las p\00E1ginas de la funci\00F3n.</p>'),
unistr('<p><em>Nota: La p\00E1gina de introducci\00F3n de comentarios no utilizar\00E1 el esquema de autorizaci\00F3n, ya que debe permitir el acceso a todos los usuarios. Las p\00E1ginas de mantenimiento de comentarios a las que se accede desde la p\00E1gina de administraci\00F3n incl')
||unistr('uir\00E1n el esquema de autorizaci\00F3n.</em></p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183307887602916627.4001)
,p_name=>'P849_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(196191122274857782.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.FEEDBACK'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196337210193224397.4001)
,p_name=>'P849_NAV_BAR_ENTRY'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(505617408566993055.4001)
,p_item_default=>'return wwv_flow_lang.system_message(''FEEDBACK'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Etiqueta de Barra de Navegaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la nueva entrada de la barra de navegaci\00F3n utilizada para acceder a la nueva p\00E1gina de comentarios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196337612472224398.4001)
,p_name=>'P849_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(196191122274857782.4001)
,p_item_default=>'return wwv_flow_lang.system_message(''FEEDBACK'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina Funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(196337804152224399.4001)
,p_name=>'P849_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(196191122274857782.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de p\00E1gina inicial')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado. Con esta funci\00F3n se crear\00E1n varias p\00E1ginas que empiezan por el n\00FAmero especificado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina disponible que se puede dividir entre 10, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403307849104218560.4001)
,p_name=>'P849_GROUP_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(196191122274857782.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(505638609287220338.4001)
,p_name=>'P849_CREATE_NAV_BAR_ENTRY'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_api.id(505617408566993055.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('\00BFIncluir en barra de navegaci\00F3n?')
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione <strong>Activado</strong> para crear una entrada de la barra de navegaci\00F3n en la aplicaci\00F3n actual para llamar a la nueva p\00E1gina de comentarios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(196394428888552110.4001)
,p_computation_sequence=>5
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57828618824033919.4001)
,p_computation_sequence=>15
,p_computation_item=>'P849_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(484181920767628316.4001)
,p_validation_name=>'P849_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>10
,p_validation=>'P849_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(196337804152224399.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58017503610845881.4001)
,p_validation_name=>'P849_STARTING_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P849_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P849_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(196337804152224399.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(505773113395893155.4001)
,p_validation_name=>'P849_NAV_BAR_ENTRY not null when entry to be created'
,p_validation_sequence=>50
,p_validation=>'P849_NAV_BAR_ENTRY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P849_CREATE_NAV_BAR_ENTRY'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(196337210193224397.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828721007033920.4001)
,p_validation_name=>'P849_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'P849_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57993876312813910.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828869933033921.4001)
,p_validation_name=>'P849_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P849_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P849_ADMIN_PAGE_OPTION = ''NEW''',
'and :P849_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57993876312813910.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58017893983850648.4001)
,p_validation_name=>'P849_STARTING_PAGE_ID and P849_ADMIN_PAGE_ID different'
,p_validation_sequence=>80
,p_validation=>':P849_STARTING_PAGE_ID <> :P849_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina inicial y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828906534033922.4001)
,p_validation_name=>'P849_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>90
,p_validation=>'P849_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57994720403813912.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829002043033923.4001)
,p_validation_name=>'P849_EXISTING_PAGE not null'
,p_validation_sequence=>100
,p_validation=>'P849_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57995198676813912.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235667199444448509.4001)
,p_validation_name=>'P849_EXISTING_PAGE available'
,p_validation_sequence=>110
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P849_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P849_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P849_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57995198676813912.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829155827033924.4001)
,p_validation_name=>'P849_TAB_SET not null'
,p_validation_sequence=>120
,p_validation=>'P849_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P849_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57996779310816315.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829217046033925.4001)
,p_validation_name=>'P849_TAB_LABEL not null'
,p_validation_sequence=>130
,p_validation=>'P849_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P849_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57997607996816315.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829341884033926.4001)
,p_validation_name=>'P849_TAB_NAME not null'
,p_validation_sequence=>140
,p_validation=>'P849_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P849_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(57998501330816316.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58018133570852735.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P849_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P849_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(58001581838817623.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829458300033927.4001)
,p_validation_name=>'P849_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>160
,p_validation=>'P849_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P849_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(58002856620817624.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58018491594854212.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>170
,p_validation=>'P849_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P849_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(196192103639864527.4001)
,p_associated_item=>wwv_flow_api.id(58001581838817623.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(505652625582376395.4001)
,p_name=>'Hide nav bar entry'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_CREATE_NAV_BAR_ENTRY'
,p_condition_element=>'P849_CREATE_NAV_BAR_ENTRY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(505652902719376397.4001)
,p_event_id=>wwv_flow_api.id(505652625582376395.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(505732107414834753.4001)
,p_event_id=>wwv_flow_api.id(505652625582376395.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548810247147922081.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(196191726308864525.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548810561140922081.4001)
,p_event_id=>wwv_flow_api.id(548810247147922081.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1941076716450577908.4001)
,p_name=>'set region name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941077183031577908.4001)
,p_event_id=>wwv_flow_api.id(1941076716450577908.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAV_BAR_ENTRY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P849_PAGE_NAME'
,p_attribute_07=>'P849_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58006952471828381.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_ADMIN_PAGE_OPTION'
,p_condition_element=>'P849_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58007311785828382.4001)
,p_event_id=>wwv_flow_api.id(58006952471828381.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_ADMIN_PAGE_ID,P849_ADMIN_PAGE_NAME,P849_NAVLIST_OPTIONS,P849_TAB_OPTIONS,P849_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58008884056828382.4001)
,p_event_id=>wwv_flow_api.id(58006952471828381.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58007815505828382.4001)
,p_event_id=>wwv_flow_api.id(58006952471828381.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58008301616828382.4001)
,p_event_id=>wwv_flow_api.id(58006952471828381.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_ADMIN_PAGE_ID,P849_ADMIN_PAGE_NAME,P849_NAVLIST_OPTIONS,P849_TAB_OPTIONS,P849_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767256140368435.4001)
,p_event_id=>wwv_flow_api.id(58006952471828381.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767323558368436.4001)
,p_event_id=>wwv_flow_api.id(58006952471828381.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58009501254830395.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58009914669830396.4001)
,p_event_id=>wwv_flow_api.id(58009501254830395.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_ENTRY_NAME,P849_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P849_ADMIN_PAGE_NAME'
,p_attribute_07=>'P849_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58010458329832773.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_TAB_OPTIONS'
,p_condition_element=>'P849_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58010893106832773.4001)
,p_event_id=>wwv_flow_api.id(58010458329832773.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_SET,P849_TAB_LABEL,P849_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100574481045284402.4001)
,p_event_id=>wwv_flow_api.id(58010458329832773.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(233450582559837776.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58012263163834259.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_TAB_OPTIONS'
,p_condition_element=>'P849_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58012675531834260.4001)
,p_event_id=>wwv_flow_api.id(58012263163834259.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_SET,P849_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58013191922834260.4001)
,p_event_id=>wwv_flow_api.id(58012263163834259.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100574510348284403.4001)
,p_event_id=>wwv_flow_api.id(58012263163834259.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(233450582559837776.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58013539769835761.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_TAB_OPTIONS'
,p_condition_element=>'P849_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58013910707835761.4001)
,p_event_id=>wwv_flow_api.id(58013539769835761.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_SET,P849_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58014463955835762.4001)
,p_event_id=>wwv_flow_api.id(58013539769835761.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100574638032284404.4001)
,p_event_id=>wwv_flow_api.id(58013539769835761.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(233450582559837776.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58014887759837448.4001)
,p_name=>'New List'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_NAVLIST_OPTIONS'
,p_condition_element=>'P849_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58015219871837448.4001)
,p_event_id=>wwv_flow_api.id(58014887759837448.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_ENTRY_NAME,P849_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58015782257837448.4001)
,p_event_id=>wwv_flow_api.id(58014887759837448.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_ENTRY_NAME,P849_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58016109018839003.4001)
,p_name=>'Existing List'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_NAVLIST_OPTIONS'
,p_condition_element=>'P849_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58016568916839004.4001)
,p_event_id=>wwv_flow_api.id(58016109018839003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58017062765839004.4001)
,p_event_id=>wwv_flow_api.id(58016109018839003.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(196196508000887588.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create feedback feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P849_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P849_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P849_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P849_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P849_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P849_TAB_SET;',
'    l_admin_page.tab_name                    := :P849_TAB_NAME;',
'    l_admin_page.tab_text                    := :P849_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P849_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P849_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P849_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P849_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P849_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_feedback(',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_starting_page_id         => :P849_STARTING_PAGE_ID,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        p_group_id                 => :P849_GROUP_ID,',
'        p_auth_scheme_id           => :P849_AUTHORIZATION_SCHEME,',
'        --',
'        p_create_nav_bar_entry     => ( :P849_CREATE_NAV_BAR_ENTRY = ''Y'' ),',
'        p_nav_bar_entry_label      => :P849_NAV_BAR_ENTRY,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fallo al crear la p\00E1gina.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(196192103639864527.4001)
,p_process_success_message=>unistr('P\00E1gina creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(548811767838930050.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina creada.')
);
end;
/
prompt --application/pages/page_00850
begin
wwv_flow_api.create_page(
 p_id=>850.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Script: M\00E9todo')
,p_step_title=>'Crear Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4583405881045166.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4594017057105105.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186894901861367649.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747146047919138172.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4605011956160431.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186894901861367649.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4605918535162327.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186894901861367649.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4606104009162328.4001)
,p_branch_name=>'Go To Page 855'
,p_branch_action=>'f?p=&APP_ID.:855:&SESSION.::&DEBUG.:855,857,858::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4605918535162327.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'DATA'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11952795244013811.4001)
,p_branch_name=>'Go To Page 6000'
,p_branch_action=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:6000::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'DATA'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4584906705054818.4001)
,p_name=>'P850_SCRIPT_SOURCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4583405881045166.4001)
,p_item_default=>'SCRATCH'
,p_prompt=>'Origen de script'
,p_source=>'SCRATCH'
,p_source_type=>'STATIC'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CREATE INSTALL SCRIPT OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(4579300425024699.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107247725930060963.4001)
,p_name=>'P850_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4583405881045166.4001)
,p_item_default=>'INSTALL'
,p_prompt=>'Tipo de Script:'
,p_source=>'INSTALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tipo de script de objeto de soporte que est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00851
begin
wwv_flow_api.create_page(
 p_id=>851.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilidades de Validaci\00F3n')
,p_step_title=>unistr('Utilidades de Validaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193765510969904973.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(c1.msg);',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193765723236904975.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193766306782904977.4001)
,p_plug_name=>unistr('Utilidades de Validaci\00F3n')
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(171763620666671065.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00852
begin
wwv_flow_api.create_page(
 p_id=>852.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades de Botones'
,p_step_title=>'Utilidades de Botones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193780823937056410.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193781022092056411.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193781415325056414.4001)
,p_plug_name=>'Utilidades de Botones'
,p_icon_css_classes=>'icon-button-hot '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(171743703949609405.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00853
begin
wwv_flow_api.create_page(
 p_id=>853.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades de Regiones'
,p_step_title=>'Utilidades de Regiones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193868424530501578.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193868629672501583.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193869008528501584.4001)
,p_plug_name=>'Utilidades de Regiones'
,p_icon_css_classes=>'icon-region-native '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_api.id(171723423034567648.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193872009365538664.4001)
,p_plug_name=>unistr('Utilidades de Regi\00F3n de Informe')
,p_icon_css_classes=>'icon-page-ir '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(47104812669691866.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194259130362878464.4001)
,p_plug_name=>'Recuentos de Regiones'
,p_icon_css_classes=>'icon-util-page-views'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(194250609883844198.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00854
begin
wwv_flow_api.create_page(
 p_id=>854.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades de Elementos'
,p_step_title=>'Utilidades de Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193914622944228841.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193914802791228843.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193915221635228844.4001)
,p_plug_name=>'Utilidades de Elementos'
,p_icon_css_classes=>'icon-item-native-text-field '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_api.id(171752432131627079.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00855
begin
wwv_flow_api.create_page(
 p_id=>855.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Script: Atributos de Script'
,p_step_title=>'Crear Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4588418741077284.4001)
,p_plug_name=>'Atributos de Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4592328700099093.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4704822606882630.4001)
,p_name=>unistr('Archivos de Comandos de Instalaci\00F3n Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, sequence',
'  from wwv_flow_install_scripts',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and nvl(script_type,''INSTALL'') = ''INSTALL''',
' order by sequence, name'))
,p_display_when_condition=>'nvl(:P850_MODE,''INSTALL'') = ''INSTALL'''
,p_display_when_cond2=>'SQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se han encontrado archivos de comandos para la aplicaci\00F3n &FB_FLOW_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4705123472882638.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4705208778882638.4001)
,p_query_column_id=>2
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(80959031694279587.4001)
,p_name=>unistr('Scripts de Actualizaci\00F3n Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, sequence',
'  from wwv_flow_install_scripts',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and nvl(script_type,''INSTALL'') = ''UPGRADE''',
' order by sequence, name'))
,p_display_when_condition=>'nvl(:P850_MODE,''INSTALL'') = ''UPGRADE'''
,p_display_when_cond2=>'SQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se han encontrado archivos de comandos para la aplicaci\00F3n &FB_FLOW_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(80959208300279590.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(80959302238279591.4001)
,p_query_column_id=>2
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186896132467385960.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747146198551138172.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4602223599154314.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186896132467385960.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4632815784312931.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186896132467385960.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4603300528157192.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186896132467385960.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4653826444410616.4001)
,p_branch_action=>'f?p=&APP_ID.:857:&SESSION.::&DEBUG.:857::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4632815784312931.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4775600114377655.4001)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_SEQUENCE,P865_MODE:&P855_SCRIPT_SEQUENCE.,NEW'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4632815784312931.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:P850_SCRIPT_SOURCE = ''SCRATCH'' and :P855_USE_EDITOR = ''Y'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(206385023862349178.4001)
,p_branch_name=>'Go To Page 858'
,p_branch_action=>'f?p=&APP_ID.:858:&SESSION.::&DEBUG.:858::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4632815784312931.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'DB'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22671613896025276.4001)
,p_branch_action=>'f?p=&APP_ID.:578:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4632815784312931.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107251502081082457.4001)
,p_branch_action=>'f?p=&APP_ID.:857:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P850_MODE = ''DEINSTALL'' and :P850_SCRIPT_SOURCE = ''FILE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107258308146122090.4001)
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.::P865_MODE:DEINSTALL'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P850_MODE = ''DEINSTALL'' and :P850_SCRIPT_SOURCE = ''SCRATCH'''
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4603515223157195.4001)
,p_branch_action=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4603300528157192.4001)
,p_branch_sequence=>90
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4596328401127352.4001)
,p_name=>'P855_SCRIPT_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Origen de Script:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(4626801323289842.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este es el m\00E9todo que est\00E1 utilizando para crear un script de instalaci\00F3n. Todos los scripts de instalaci\00F3n, excepto el paquete de datos, se pueden editar tras su creaci\00F3n. Para cambiar el tipo de origen del script, vuelva al primer paso de este asis')
||'tente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4598124722135781.4001)
,p_name=>'P855_SCRIPT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca un nombre para el script que va a crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4599409269140731.4001)
,p_name=>'P855_SCRIPT_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(trunc(max(sequence)), 0) + 10 ',
'  from wwv_flow_install_scripts ',
' where flow_id = :FB_FLOW_ID',
'   and nvl(script_type,''INSTALL'') = nvl(:P850_MODE,''INSTALL'')',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un n\00FAmero de secuencia para el script que est\00E1 creando. Los archivos de comandos se ejecutar\00E1n por orden seg\00FAn los n\00FAmeros de secuencia.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22667909000995458.4001)
,p_name=>'P855_USE_EDITOR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_item_default=>'Y'
,p_prompt=>'&nbsp;'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'USE EDITOR'
,p_lov=>'.'||wwv_flow_api.id(22675300914059322.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P850_SCRIPT_SOURCE'
,p_display_when2=>'SCRATCH'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Utilice el editor incorporado para definir el script. Desactive esta opci\00F3n para utilizar un \00E1rea de texto de explorador est\00E1ndar con el que definir o editar el script.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57918312120294922.4001)
,p_name=>'P855_SCRIPT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_item_default=>'INSTALL'
,p_prompt=>'Tipo de Script:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tipo de script de objeto de soporte que est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(534094819493786100.4001)
,p_name=>'P855_OBJECT_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_prompt=>'Propietario de Objeto:'
,p_source=>'wwv_flow_wizard_api.get_flow_owner'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P850_SCRIPT_SOURCE'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica al propietario del objeto de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(535751394655150801.4001)
,p_name=>'P855_OBJECT_TYPE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4588418741077284.4001)
,p_prompt=>'Tipo de Objeto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct object_type d, object_type r',
'  from sys.dba_objects',
' where object_type in (''FUNCTION'',''INDEX'',''PACKAGE'',''PROCEDURE'',''SEQUENCE'',''SYNONYM'',''TABLE'',''TRIGGER'',''VIEW'',''DATABASE LINK'',''TYPE'',''MATERIALIZED VIEW'')',
'   and owner = :P855_OBJECT_OWNER',
' order by 1'))
,p_cSize=>64
,p_cHeight=>11
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P850_SCRIPT_SOURCE'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione uno o varios tipos de objeto de la lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4644709428377386.4001)
,p_validation_name=>'P855_SCRIPT_NAME'
,p_validation_sequence=>10
,p_validation=>'P855_SCRIPT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Especifique un nombre para el script.'
,p_when_button_pressed=>wwv_flow_api.id(4632815784312931.4001)
,p_associated_item=>wwv_flow_api.id(4598124722135781.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4703926977874436.4001)
,p_validation_name=>'Unique script name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_scripts',
' where name = :P855_SCRIPT_NAME',
'   and flow_id = :FB_FLOW_ID',
'   and nvl(script_type, ''INSTALL'') = nvl(:P850_MODE, ''INSTALL'')',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Ya existe un script con ese nombre. Introduzca uno nuevo.'
,p_when_button_pressed=>wwv_flow_api.id(4632815784312931.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(22395021174836096.4001)
,p_validation_name=>'P855_SCRIPT_SEQUENCE is numeric'
,p_validation_sequence=>30
,p_validation=>'P855_SCRIPT_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El valor de secuencia debe ser num\00E9rico.')
,p_when_button_pressed=>wwv_flow_api.id(4632815784312931.4001)
,p_associated_item=>wwv_flow_api.id(4599409269140731.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00857
begin
wwv_flow_api.create_page(
 p_id=>857.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Script: Definir Script'
,p_step_title=>'Crear Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4647418550390545.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4647622907390547.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Seleccione el archivo que se cargar\00E1 como script.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186897304463406270.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747146382260138173.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4648223443390549.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186897304463406270.4001)
,p_button_name=>'CREATE_SCRIPT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Script'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4648028591390549.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186897304463406270.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4647814293390548.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186897304463406270.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107575619357420647.4001)
,p_branch_action=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4648223443390549.4001)
,p_branch_sequence=>25
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'DEINSTALL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32345400816305515.4001)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4648223443390549.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'UPGRADE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4648818072390558.4001)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107281912704227457.4001)
,p_branch_action=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4648028591390549.4001)
,p_branch_sequence=>5
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'DEINSTALL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4648607609390557.4001)
,p_branch_action=>'f?p=&APP_ID.:855:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4648028591390549.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4649730684392983.4001)
,p_name=>'P857_SCRIPT_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4647622907390547.4001)
,p_prompt=>'Archivo'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el archivo que se va a cargar y utilizar como script de instalaci\00F3n para la aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4685021286711920.4001)
,p_name=>'P857_FILE_CHARSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4647622907390547.4001)
,p_prompt=>'Juego de Caracteres de Archivo'
,p_source=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el juego de caracteres con el que el script est\00E1 codificado.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(56582111293173541.4001)
,p_validation_name=>'P857_SCRIPT_FILE not null'
,p_validation_sequence=>10
,p_validation=>'P857_SCRIPT_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Especifique un archivo'
,p_when_button_pressed=>wwv_flow_api.id(4648223443390549.4001)
,p_associated_item=>wwv_flow_api.id(4649730684392983.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4665316850540386.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_clob clob;',
'begin',
'for c1 in (select *',
'             from apex_application_temp_files ',
'            where name = :P857_SCRIPT_FILE)',
'loop',
'',
'  l_clob := wwv_flow_utilities.blob_to_clob( ',
'                p_blob => c1.blob_content, ',
'                p_charset => :P857_FILE_CHARSET );',
'',
'  if :P850_MODE = ''DEINSTALL'' then',
'      update wwv_flow_install',
'         set deinstall_script = l_clob',
'       where flow_id = :fb_flow_id',
'         and security_group_id = :flow_security_group_id;',
'  elsif :P850_MODE = ''UPGRADE'' then',
'      insert into wwv_flow_install_scripts (name, sequence, script_type, script)',
'                                    values (:P855_SCRIPT_NAME,',
'                                            :P855_SCRIPT_SEQUENCE,',
'                                            ''UPGRADE'',',
'                                            l_clob);',
'  else                                            ',
'      insert into wwv_flow_install_scripts (name, sequence, script_type, script)',
'                                    values (:P855_SCRIPT_NAME, ',
'                                            :P855_SCRIPT_SEQUENCE,',
'                                            ''INSTALL'',',
'                                            l_clob);',
'  end if;',
'',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido guardar el script especificado. '
,p_process_when_button_id=>wwv_flow_api.id(4648223443390549.4001)
);
end;
/
prompt --application/pages/page_00858
begin
wwv_flow_api.create_page(
 p_id=>858.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Script: Seleccionar Objetos'
,p_step_title=>'Crear Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(584635221052978322.4001)
,p_plug_name=>'Atributos de Script'
,p_region_name=>'Select Objects'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(584638786957978335.4001)
,p_plug_name=>'progreso'
,p_region_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(584639920493978339.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747146412307138173.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1842855562136354722.4001)
,p_plug_name=>'Advertencia'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('El script se generar\00E1 en funci\00F3n de la versi\00F3n subyacente de Oracle Database, con la sintaxis espec\00EDfica de la versi\00F3n. Si esta aplicaci\00F3n se va a importar en versiones de bases de datos anteriores, debe probar que el script es compatible con version')
||unistr('es anteriores. Por ejemplo, si se generan tablas en Oracle Database 12c, el script puede contener cl\00E1usulas de columnas IDENTITY que no funcionar\00E1n en Oracle Database 11g.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(621103696869076433.4001)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_button_name=>'Clear'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Borrar'
,p_button_redirect_url=>'f?p=&APP_ID.:858:&SESSION.::&DEBUG.:RP:P858_FILTER::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(584640153596978339.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(584639920493978339.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(584640350238978341.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(584639920493978339.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(584640541110978341.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(584639920493978339.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(590329370754334815.4001)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_SEQUENCE,P865_MODE:&P855_SCRIPT_SEQUENCE.,NEW'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(584640350238978341.4001)
,p_branch_sequence=>100
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(584643384080978349.4001)
,p_branch_name=>'Go To Page 855'
,p_branch_action=>'f?p=&APP_ID.:855:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(584640541110978341.4001)
,p_branch_sequence=>90
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584635482286978327.4001)
,p_name=>'P858_SCRIPT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_item_default=>'INSTALL'
,p_prompt=>'Tipo de Script:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tipo de script de objeto de soporte que est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584635909999978329.4001)
,p_name=>'P858_SCRIPT_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Origen de Script:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(4626801323289842.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('M\00E9todo que est\00E1 utilizando para crear un script de instalaci\00F3n. Todos los archivos de comandos de instalaci\00F3n se pueden editar tras su creaci\00F3n. Para cambiar el tipo de origen del script, vuelva al primer paso de este asistente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584636425635978331.4001)
,p_name=>'P858_SCRIPT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'P855_SCRIPT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre del script que va a crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584636917673978332.4001)
,p_name=>'P858_SCRIPT_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia:'
,p_source=>'P855_SCRIPT_SEQUENCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero de secuencia para el script que se va a crear. Los scripts se ejecutar\00E1n por orden seg\00FAn los n\00FAmeros de secuencia.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584637922451978332.4001)
,p_name=>'P858_OBJECT_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario de Objeto:'
,p_source=>'P855_OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifica al propietario del objeto de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584638390816978333.4001)
,p_name=>'P858_OBJECT_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_prompt=>'Tipos de Objetos:'
,p_source=>'replace(:P855_OBJECT_TYPE,'':'','', '')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica los tipos de objeto para el script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(584638526915978333.4001)
,p_name=>'P858_OBJECT'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_prompt=>'Objeto'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name||'' (''||object_type||'')'' d, object_name r',
'  from sys.dba_objects',
' where owner = :P855_OBJECT_OWNER',
'   and object_name not like ''SYS\_%'' escape ''\''',
'   and object_name not like ''APEX$%''',
'   and object_type in (select * from table(wwv_flow_string.split(:P855_OBJECT_TYPE,'':'')))',
'   and (instr(object_name,upper(:P858_FILTER)) > 0 or :P858_FILTER is null)',
' order by object_type, object_name'))
,p_lov_cascade_parent_items=>'P858_FILTER'
,p_ajax_items_to_submit=>'P858_FILTER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione uno o varios objetos de la lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621101924371076416.4001)
,p_name=>'P858_PKG_OPTIONS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_item_default=>'PACKAGE_SPEC:PACKAGE_BODY'
,p_prompt=>'Opciones de Paquete'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Package Specification;PACKAGE_SPEC,Package Body;PACKAGE_BODY'
,p_display_when=>'P858_OBJECT_TYPE'
,p_display_when2=>'PACKAGE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione si desea generar especificaciones de paquete, cuerpos de paquete o ambos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621102373151076420.4001)
,p_name=>'P858_TABLE_OPTIONS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_prompt=>'Opciones de Tabla'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:Include DDL related to tables;TABLE'
,p_display_when=>'P855_OBJECT_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Active esta casilla si desea incluir DDL relacionado con las tablas seleccionadas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621103222388076429.4001)
,p_name=>'P858_FILTER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(584635221052978322.4001)
,p_prompt=>'Filtro'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un criterio de filtro para la lista de objetos y pulse Intro.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(621102099648076417.4001)
,p_validation_name=>'pkg options not null'
,p_validation_sequence=>10
,p_validation=>'P858_PKG_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar una opci\00F3n de paquete.')
,p_validation_condition=>'P858_OBJECT_TYPE'
,p_validation_condition2=>'PACKAGE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(584640350238978341.4001)
,p_associated_item=>wwv_flow_api.id(621101924371076416.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00859
begin
wwv_flow_api.create_page(
 p_id=>859.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Informe sobre Servicios Web'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44544002248058173.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193937726065104070.4001)
,p_plug_name=>'Crear &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193939704734104079.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193937910763104072.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44544002248058173.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193938106162104073.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44544002248058173.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193938311276104073.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44544002248058173.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193941032749104100.4001)
,p_branch_action=>'f?p=&APP_ID.:860:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193938106162104073.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193941418491104103.4001)
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193938311276104073.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193941200615104102.4001)
,p_branch_action=>'f?p=&FLOW_ID.:859:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193938521096104074.4001)
,p_name=>'P859_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(193937726065104070.4001)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193939102525104078.4001)
,p_name=>'P859_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(193937726065104070.4001)
,p_prompt=>'Referencia de Servicio Web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''REST''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Servicio --'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el nombre de la referencia del servicio Web.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193940620915104091.4001)
,p_computation_sequence=>10
,p_computation_item=>'P859_OPERATION_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_ws_operations',
' where ws_id = :P859_WS_ID',
'   and name = ''doREST'''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193940813483104098.4001)
,p_validation_name=>'P859_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P859_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe seleccionar un servicio Web.'
,p_when_button_pressed=>wwv_flow_api.id(193938106162104073.4001)
,p_associated_item=>wwv_flow_api.id(193939102525104078.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549885518294989012.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193937910763104072.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549885632584989013.4001)
,p_event_id=>wwv_flow_api.id(549885518294989012.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00860
begin
wwv_flow_api.create_page(
 p_id=>860.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Informe sobre Servicios Web'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(193942426256118931.4001)
,p_name=>'Crear &P759_REPORT_TITLE.'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'',:P860_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where ws_opers_id = :P778_REST_OPERATION_ID',
'   and input_or_output = ''O'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193942626753118933.4001)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193942712204118933.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(193942817972118933.4001)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193945527367118942.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(114018423833281484.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206216524481494576.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193942932393118933.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206216524481494576.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193943126410118934.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206216524481494576.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193943300739118935.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206216524481494576.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193947830781118958.4001)
,p_branch_name=>'Go To Page 778'
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193943300739118935.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(193948013025118960.4001)
,p_branch_action=>'f?p=&APP_ID.:786:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193943126410118934.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193943508566118935.4001)
,p_name=>'P860_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(193942426256118931.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193943713355118936.4001)
,p_name=>'P860_ROW_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(193942426256118931.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Plantilla de Informe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la plantilla de informe que va a utilizar esta regi\00F3n de informe.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193944330965118939.4001)
,p_name=>'P860_ROWS_PER_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(193942426256118931.4001)
,p_item_default=>'15'
,p_prompt=>unistr('Filas por P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas para visualizar por p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193944924004118940.4001)
,p_name=>'P860_RESULT_COLLECTION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(193942426256118931.4001)
,p_prompt=>unistr('Resultado Almacenado en Recopilaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre del juego de resultados temporal en el que se almacenar\00E1 el resultado del servicio web. El juego de resultados temporal se almacena en una recopilaci\00F3n de &PRODUCT_NAME.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193946620650118952.4001)
,p_computation_sequence=>10
,p_computation_item=>'P860_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(193946807990118953.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.get_theme_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193947217451118955.4001)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos un par\00E1metro para el informe.')
,p_when_button_pressed=>wwv_flow_api.id(193943126410118934.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(193947013095118954.4001)
,p_validation_name=>'P860_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P860_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar el nombre de la recopilaci\00F3n que contiene el resultado del servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(193943126410118934.4001)
,p_associated_item=>wwv_flow_api.id(193944924004118940.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549885914581989016.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193942932393118933.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549886098534989017.4001)
,p_event_id=>wwv_flow_api.id(549885914581989016.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1199172587508878401.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(193942426256118931.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1199172624183878402.4001)
,p_event_id=>wwv_flow_api.id(1199172587508878401.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(193947615142118958.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(272280446899934730.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report on WS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_report_temp  varchar2(4000) := null;',
'  l_rows_per_pg  varchar2(4000) := null;',
'  l_sql          varchar2(32000);',
'begin',
'  if :P778_WEB_REF_TYPE = ''782'' then',
'    ',
'    l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_WSDL_OPERATION_ID,',
'                p_array_parm                => :P778_WSDL_ARRAY,',
'                p_report_collection_name    => :P782_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );  ',
'',
'    l_report_temp := :P782_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P782_ROWS_PER_PAGE;',
'',
'  elsif :P778_WEB_REF_TYPE = ''860'' then',
'    ',
'  l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_REST_OPERATION_ID,',
'                p_array_parm                => null,',
'                p_report_collection_name    => :P860_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );',
'',
'    l_report_temp := :P860_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P860_ROWS_PER_PAGE;',
'',
'  else',
'',
'    l_sql := wwv_flow_web_services.generate_query_manual(',
'                p_result_node               => :P778_NODE_PATH,',
'                p_soap_style                => :P778_MAN_SOAP_STYLE,',
'                p_message_format            => :P778_MAN_MSG_FORMAT,',
'                p_namespace                 => :P778_MAN_MSG_NAMESAPECE,',
'                p_report_collection_name    => :P783_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_REPORT_ITEMS'');    ',
'',
'    l_report_temp := :P783_ROW_TEMPLATE;                 ',
'    l_rows_per_pg := :P783_ROWS_PER_PAGE;     ',
'               ',
'  end if;        ',
'  ',
'  ',
'  wwv_flow_wizard_api.create_report_on_ws(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :P759_PAGE_ID,',
'      p_page_name                => :P759_PAGE_NAME,',
'      p_group_name               => null,',
'      p_page_mode                => :P759_PAGE_MODE,',
'      p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'      p_region_name              => :P759_PAGE_NAME,',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                        p_application_id => :FB_FLOW_ID,',
'                                        p_theme_id       => :FB_THEME_ID,',
'                                        p_page_type      => :P259_CHOOSE_PAGE_TYPE),',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_report_template          => l_report_temp,',
'      p_rows_per_page            => nvl(l_rows_per_pg,''15''),',
'      --',
'      p_breadcrumb_id            => :P759_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P759_BREADCRUMB_NAME,',
'      p_parent_bc_id             => :P759_BREADCRUMB_PARENT_ID,',
'      --',
'      p_query                    => l_sql );',
'',
'  :fb_flow_page_id       := :P759_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00862
begin
wwv_flow_api.create_page(
 p_id=>862.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Aplicaci\00F3n')
,p_step_title=>unistr('Actualizar Aplicaci\00F3n: Seleccionar Validaciones que Ejecutar Siempre')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631609404846532631.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631610423265532635.4001)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(484017424976766961.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631610822607532637.4001)
,p_plug_name=>'Otras Validaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>102
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox( 1,v.id, (',
'          select ''CHECKED'' from apex_collections ',
'           where collection_name = ''UPGRADE_VALIDATIONS2'' ',
'             and n001 = v.id),null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''VALIDATION_LABEL'', v.validation_name)) checkbox,',
'       (select i.name',
'          from wwv_flow_step_items i',
'         where i.flow_id           = :FB_FLOW_ID',
'           and i.security_group_id = :WORKSPACE_ID',
'           and i.name         = v.validation',
'           and i.flow_id      = v.flow_id',
'           and i.flow_step_id = v.flow_step_id ) item_name,',
'       v.id              as validation_id,',
'       v.validation_name,',
'       v.validation_type,',
'       (select wwv_flow_escape.html(b.button_name)||'' (''||',
'               wwv_flow_escape.html(b.BUTTON_IMAGE_ALT)||'')'' button_name',
'          from wwv_flow_step_buttons b',
'         where b.flow_id = :FB_FLOW_ID',
'           and b.id = v.when_button_pressed ) button_name,',
'       v.validation_condition_type condition,',
'       v.validation_condition  cond_exp1,',
'       v.validation_condition2 cond_exp2',
'  from wwv_flow_step_validations v',
' where v.flow_id            = :FB_FLOW_ID',
'   and v.security_group_id  = :WORKSPACE_ID',
'   and v.flow_step_id       = :P862_PAGE_ID',
'   and v.always_execute     = ''N''',
'   and v.id not in (select n001 from apex_collections ',
'                     where collection_name = ''UPGRADE_VALIDATIONS'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(631611005074532639.4001)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ninguna otra validaci\00F3n en la p\00E1gina.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611308815532645.4001)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611131559532642.4001)
,p_db_column_name=>'VALIDATION_NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de Validaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611231096532645.4001)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Bot\00F3n Asociado')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611609350532646.4001)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Elemento Asociado'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611704254532646.4001)
,p_db_column_name=>'VALIDATION_ID'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>unistr('Identificador de Validaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611819113532646.4001)
,p_db_column_name=>'VALIDATION_TYPE'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>unistr('Tipo de Validaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(630881727193397263)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631611928399532647.4001)
,p_db_column_name=>'CONDITION'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>unistr('Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631612002749532648.4001)
,p_db_column_name=>'COND_EXP1'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(631612107668532648.4001)
,p_db_column_name=>'COND_EXP2'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631612413780532650.4001)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_source=>unistr('A continuaci\00F3n se muestran otras validaciones de la p\00E1gina que no est\00E1n definidas en Ejecutar Siempre. Si define cualquier bot\00F3n en No Ejecutar Validaciones, puede que desee que alguna de las validaciones est\00E9 definida en Ejecutar Siempre. Por ejempl')
||unistr('o, si tiene un bot\00F3n Suprimir que no ejecuta validaciones y una validaci\00F3n que realiza una comprobaci\00F3n de privilegios, puede que desee que dicha validaci\00F3n est\00E9 definida en Ejecutar Siempre.')
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747146503577138173.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(631610011605532633.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(631609404846532631.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(631609825725532633.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(631609404846532631.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p862_page is null then',
'  return true;',
'else',
'  for c1 in (select 1 x from wwv_flow_lock_page where locked_by is not null and flow_id = :fb_flow_id and object_id = :p862_page) loop',
'     return false;',
'  end loop;',
'end if;',
'return true;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(631609611212532632.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(631609404846532631.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(631613531793532662.4001)
,p_branch_action=>'f?p=&APP_ID.:383:&SESSION.::&DEBUG.::P383_PAGE_ID:&P862_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(631609825725532633.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(631610221942532634.4001)
,p_name=>'P862_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(631612413780532650.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045580979987367806.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(631610822607532637.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045581047849367807.4001)
,p_event_id=>wwv_flow_api.id(2045580979987367806.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(631613316747532659.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_collection_status number;',
'   l_id                number;',
'   l_count             number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''UPGRADE_VALIDATIONS2'');',
'    for i in 1..apex_application.g_f01.count ',
'    loop',
'        l_id := apex_application.g_f01(i);',
'        select count(*) into l_count ',
'          from wwv_flow_collections ',
'         where n001            = l_id ',
'           and collection_name = ''UPGRADE_VALIDATIONS2'';',
'        if l_count = 0 then ',
'            l_collection_status := wwv_flow_collection.add_member(',
'                 p_collection_name => ''UPGRADE_VALIDATIONS2'',',
'                 p_n001            => l_id);',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00864
begin
wwv_flow_api.create_page(
 p_id=>864.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Regiones Condicionales'
,p_step_title=>'Regiones Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194203124847418277.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194210703308436164.4001)
,p_plug_name=>unistr('Condiciones de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, PLUG_NAME, ',
'PLUG_DISPLAY_WHEN_CONDITION, ',
'PLUG_DISPLAY_WHEN_COND2, ',
'PLUG_DISPLAY_CONDITION_TYPE,',
'id',
'from WWV_FLOW_PAGE_PLUGS',
'where ',
' flow_id = :fb_flow_id and',
' plug_display_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194210801252436164.4001)
,p_name=>'Region Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194211012826436166.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194211122123436167.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Regi\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194211424024436169.4001)
,p_db_column_name=>'PLUG_DISPLAY_CONDITION_TYPE'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194211231307436168.4001)
,p_db_column_name=>'PLUG_DISPLAY_WHEN_CONDITION'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194211325028436168.4001)
,p_db_column_name=>'PLUG_DISPLAY_WHEN_COND2'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(57831562322033948.4001)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194216828191471000.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194210703308436164.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:864:&SESSION.::&DEBUG.:864,RIR::'
);
end;
/
prompt --application/pages/page_00865
begin
wwv_flow_api.create_page(
 p_id=>865.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editor de Script'
,p_step_title=>'Editor de Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_null_script=''"NULL_SCRIPT"'';',
'htmldb_max_script_size=''"MAX_SCRIPT_SIZE"'';',
'function pageSubmit(req) {',
'  apex.builder.plugin.codeEditor.saveSubmit("#codeEditor_widget", "f01", {request: req, showWait: true});',
'}',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".a-Body, .a-Main, .a-EditScreen, .a-EditScreen-body, .a-MonacoEditor").addClass("resize");',
'apex.jQuery(".a-Body").on("resize", function(event) {',
'    var main$, side$;',
'    if (event.target !== this) {',
'        return;',
'    }',
'    main$ = $(this).children(".a-Main");',
'    side$ = $(this).children(".a-Side");',
'    main$.css({display: "block", position: "absolute", top: 0, left: 0});',
'    side$.css({display: "block", position: "absolute", top: 0, right: 0});',
'    apex.util.setOuterHeight( side$, $(this).height() );',
'    apex.util.setOuterWidth( side$, side$.outerWidth() );',
'    apex.util.setOuterHeight( main$, $(this).height() );',
'    apex.util.setOuterWidth( main$, $(this).width() - side$.outerWidth() );',
'    event.stopPropagation();',
'    main$.trigger("resize");',
'    $(this).css({display: "block", position: "relative"});',
'});',
'apex.jQuery("#page_success_msg button").click(function() {',
'    $("body").trigger("resize");',
'});',
'apex.theme.pageResizeInit();'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Body {',
'    display: table;',
'    width: 100%;',
'}',
'.a-Main, .a-Side {',
'    display: table-cell;',
'}'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(857903402130335025)
,p_protection_level=>'C'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4874415838535180.4001)
,p_plug_name=>'Script Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4852514958421306.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P865_MODE'
,p_plug_display_when_cond2=>'EDIT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8320991744121632.4001)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133088306023461536.4001)
,p_plug_name=>'Edit Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(402533935348598952.4001)
,p_plug_name=>unistr('Editar Script de Instalaci\00F3n')
,p_region_name=>'codeEditor'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'from wwv_flow_collections',
'where collection_name = ''INSTALL_SCRIPT_ORIG'''))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P865_MODE'
,p_plug_display_when_cond2=>'EDIT:NEW'
,p_attribute_01=>'DDL'
,p_attribute_02=>'20'
,p_attribute_03=>'N'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(402550986718150677.4001)
,p_plug_name=>'Edit Deinstall Script'
,p_region_name=>'codeEditor'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both"'
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select deinstall_script',
'from wwv_flow_install',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P865_MODE'
,p_plug_display_when_cond2=>'DEINSTALL'
,p_attribute_01=>'DDL'
,p_attribute_02=>'20'
,p_attribute_03=>'N'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537839780223118519.4001)
,p_plug_name=>'Objetos de Base de Datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(537840053704118522.4001)
,p_name=>'Objetos de Base de Datos'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h180'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,seq_id) seq_id,',
'       c002 object_owner,',
'       c003 object_type,',
'       c004 object_name,',
'       c006 status',
'  from wwv_flow_collections',
' where collection_name = ''INSTALL_OBJECTS''',
'   and nvl(c005,''0'') = ''0'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_install_objects',
' where script_id = :P865_SCRIPT_ID',
'   and :P865_MODE = ''EDIT''',
'    or (nvl(:P865_MODE,''x'') != ''EDIT'' and :P850_SCRIPT_SOURCE = ''DB'')'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2'
,p_query_row_count_max=>9999
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(537840627188118528.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(537840232920118524.4001)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Propietario del Objeto'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(537840323291118525.4001)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo de Objeto'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(537840457504118526.4001)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Objeto'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(621100784077076404.4001)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(621102570778076422.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<strong>Nota:</strong> Si agrega o suprime objetos de base de datos o los refresca, se perder\00E1n todos los cambios manuales que aplique al script.')
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(618947315266117442.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(537840053704118522.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Objeto'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:887:&SESSION.::&DEBUG.:887:P887_OBJECT_OWNER:&P865_OBJECT_OWNER.'
,p_button_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(133524400160130453.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8320991744121632.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(133099306975506413.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(8320991744121632.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'&P865_BUTTON_LABEL.'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(615012010767884573.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(537840053704118522.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'CREATE2'
,p_button_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(537838745432118509.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(537840053704118522.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Script de Refrescamiento'
,p_button_position=>'CREATE2'
,p_button_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107283299301623866.4001)
,p_branch_action=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.::P328_ID:&P865_SCRIPT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_328'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40463932174517858.4001)
,p_branch_action=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P865_MODE'
,p_branch_condition_text=>'DEINSTALL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32350120340320553.4001)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>65
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P865_MODE'
,p_branch_condition_text=>'UPGRADE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(47927614335320671.4001)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'UPGRADE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(537841142942118533.4001)
,p_branch_name=>'Go to 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'DELETE,REFRESH,DIALOG'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(80599326089398202.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11488511416108892.4001)
,p_branch_name=>'Go To Page 473'
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9291108602279927.4001)
,p_name=>'P865_MODE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(133088306023461536.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40449916974466128.4001)
,p_name=>'P865_SCRIPT_SEQUENCE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(133088306023461536.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108549999222587142.4001)
,p_name=>'P865_STORE_TEMP_SCRIPT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(133088306023461536.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(133367803441912715.4001)
,p_name=>'P865_MAX_LENGTH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(133088306023461536.4001)
,p_source=>'nvl(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE''),500000)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(133521606398123923.4001)
,p_name=>'P865_SCRIPT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(133088306023461536.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(139588582590810349.4001)
,p_name=>'P865_SCRIPT_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(8320991744121632.4001)
,p_prompt=>'Nombre del Script:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Nombre del script que est\00E1 editando. Puede cambiar el nombre del script editando sus propiedades.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537837987167118501.4001)
,p_name=>'P865_COLLECTION_CREATED'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(8320991744121632.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537838540178118507.4001)
,p_name=>'P865_OBJECT_OWNER'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(537839780223118519.4001)
,p_prompt=>'Propietario de Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P865_OBJECT_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537841276105118534.4001)
,p_name=>'P865_OBJ_COLLECTION_CREATED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(537840053704118522.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(551194954402315302.4001)
,p_name=>'P865_OBJECT_TYPE'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(537839780223118519.4001)
,p_prompt=>'Tipo de Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_display_when=>'P865_OBJECT_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(551195139801322056.4001)
,p_name=>'P865_OBJECT_NAME'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(537839780223118519.4001)
,p_prompt=>'Nombre del Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_display_when=>'P865_OBJECT_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621100502742076402.4001)
,p_name=>'P865_BUTTON_LABEL'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(8320991744121632.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621102298452076419.4001)
,p_name=>'P865_SCRIPT_OPTION'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(8320991744121632.4001)
,p_prompt=>unistr('Opci\00F3n de Script:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P865_SCRIPT_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(686919732026917492.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P865_SCRIPT_OPTION'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Estos elementos muestran las opciones para el script, si generar solo especificaciones de paquete, solo cuerpos de paquete o generar DDL relacionado con las tablas seleccionadas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955893854710997349.4001)
,p_name=>'P865_DEINSTALL_MODE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(133088306023461536.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(621100690493076403.4001)
,p_computation_sequence=>10
,p_computation_item=>'P865_BUTTON_LABEL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P865_MODE,''x'') not in ( ''DEINSTALL'', ''EDIT'' ) or nvl(:P865_DEINSTALL_MODE,''x'') = ''CREATE'' then',
'    return wwv_flow_lang.system_message(''CREATE'');',
'else',
'    return wwv_flow_lang.system_message(''WWV_FLOW_CUSTOMIZE.T_APPLY'');',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(108506090659291320.4001)
,p_computation_sequence=>10
,p_computation_item=>'P865_STORE_TEMP_SCRIPT'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'begin    ',
'    sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'   ',
'    htmldb_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT'');',
'',
'    for i in 1..wwv_flow.g_f01.count loop',
'      sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));        ',
'    end loop;        ',
'    ',
'    htmldb_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT'',',
'        p_clob001         => l_code);',
'',
'    return null;        ',
'end;'))
,p_compute_when=>'CREATE,APPLY_CHANGES,APPLY_CHANGES_328'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(537842773205118549.4001)
,p_name=>'add object closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(618947315266117442.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537842807838118550.4001)
,p_event_id=>wwv_flow_api.id(537842773205118549.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(621100860684076405.4001)
,p_event_id=>wwv_flow_api.id(537842773205118549.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(402533935348598952.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(621101768647076414.4001)
,p_event_id=>wwv_flow_api.id(537842773205118549.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'TRIGGERING_ELEMENT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929195875726394222.4001)
,p_name=>'Apply'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(133099306975506413.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(929195971949394223.4001)
,p_event_id=>wwv_flow_api.id(929195875726394222.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'pageSubmit("APPLY_CHANGES");',
''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(538434480548694551.4001)
,p_process_sequence=>125
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''INSTALL_SCRIPT_ORIG'') then',
'    wwv_flow_collection.delete_collection(''INSTALL_SCRIPT_ORIG'');',
'end if;',
'if wwv_flow_collection.collection_exists(''INSTALL_OBJECTS'') then',
'    wwv_flow_collection.delete_collection(''INSTALL_OBJECTS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P865_COLLECTION_CREATED'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537838356552118505.4001)
,p_process_sequence=>130
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate INSTALL_SCRIPT_ORIG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_clob_arr    wwv_flow.clob_arr;',
'    i             integer;',
'    l_obj_type    varchar2(4000);',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'',
'    if :P865_MODE = ''EDIT'' then',
'        for c1 in (select script',
'                     from wwv_flow_install_scripts',
'                    where id = :P865_SCRIPT_ID',
'                      and security_group_id = :flow_security_group_id) loop',
'            l_code := c1.script;',
'        end loop;   ',
'    elsif :P850_SCRIPT_SOURCE = ''DB'' then',
'        if :P855_OBJECT_TYPE = ''PACKAGE'' and :P858_PKG_OPTIONS <> ''PACKAGE_SPEC:PACKAGE_BODY'' then',
'            l_obj_type := :P858_PKG_OPTIONS;',
'            :P865_SCRIPT_OPTION := l_obj_type;',
'        elsif :P855_OBJECT_TYPE = ''TABLE'' and nvl(:P858_TABLE_OPTIONS,''x'') = ''TABLE'' then',
'            :P865_SCRIPT_OPTION := :P858_TABLE_OPTIONS;',
'            l_obj_type := ''TABLE_RELATED'';',
'        else',
'            l_obj_type := :P855_OBJECT_TYPE;',
'        end if;',
'        l_clob_arr := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                          p_schema      => :P855_OBJECT_OWNER,',
'                          p_object_type => l_obj_type,',
'                          p_objects     => :P858_OBJECT);',
'',
'        for i in 1..l_clob_arr.count loop',
'            l_code := l_code || l_clob_arr(i)||chr(10)||chr(10);',
'        end loop;',
'    end if;',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'        ',
'    :P865_COLLECTION_CREATED := ''Y'';        ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P865_COLLECTION_CREATED is null and (:P865_MODE = ''EDIT'' or nvl(:P850_SCRIPT_SOURCE,''x'')=''DB'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537839813572118520.4001)
,p_process_sequence=>140
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate INSTALL_OBJECTS edit'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n        wwv_flow_global.vc_arr2;',
'    v        wwv_flow_global.vc_arr2;',
'    l_sql    varchar2(32767);',
'begin',
'    n(1) := ''script_id'';',
'    v(1) := :P865_SCRIPT_ID;',
'    ',
'    if wwv_flow_collection.collection_exists(''INSTALL_OBJECTS'') then',
'        wwv_flow_collection.delete_collection(''INSTALL_OBJECTS'');',
'    end if;        ',
'    ',
'    l_sql := q''{select b.id, replace(b.object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) object_owner, b.object_type, b.object_name}''||',
'             ''  from wwv_flow_install_scripts a, wwv_flow_install_objects b''||',
'             '' where a.id = b.script_id''||',
'             ''   and b.script_id = :script_id''||',
'             '' order by object_type, object_name'';',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''INSTALL_OBJECTS'',',
'        p_query           => l_sql,',
'        p_names           => n,',
'        p_values          => v);',
'        ',
'    --populate the object has changed message',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections b',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and exists (select 1',
'                                from sys.dba_objects a',
'                               where a.owner = b.c002',
'                                 and a.object_type = b.c003',
'                                 and a.object_name = b.c004',
'                                 and b.c002 = :P865_OBJECT_OWNER',
'                                 and a.last_ddl_time > ',
'                                     (select nvl(last_updated_on,created_on)',
'                                       from wwv_flow_install_scripts',
'                                      where id = :P865_SCRIPT_ID) ) ',
'    ) loop',
'     ',
'         wwv_flow_collection.update_member_attribute(',
'             p_collection_name => ''INSTALL_OBJECTS'',',
'             p_seq             => c1.seq_id,',
'             p_attr_number     => ''6'',',
'             p_attr_value      => wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED''));',
'             ',
'    end loop;             ',
'    ',
'    --populate object no longer exists',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections a',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and not exists (select 1 ',
'                                    from sys.dba_objects',
'                                   where owner = a.c002',
'                                     and object_type = a.c003',
'                                     and object_name = a.c004) ',
'    ) loop',
'    ',
'         wwv_flow_collection.update_member_attribute(',
'             p_collection_name => ''INSTALL_OBJECTS'',',
'             p_seq             => c1.seq_id,',
'             p_attr_number     => ''6'',',
'             p_attr_value      => wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DELETED''));',
'             ',
'    end loop;',
'',
'    :P865_OBJ_COLLECTION_CREATED := ''Y'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_install_objects',
' where script_id = :P865_SCRIPT_ID',
'   and :P865_MODE = ''EDIT''',
'   and :P865_OBJ_COLLECTION_CREATED is null'))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537839908148118521.4001)
,p_process_sequence=>150
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate INSTALL_OBJECTS new'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_objects     wwv_flow_global.vc_arr2;',
'  l_object_type varchar2(30);',
'  i             number;',
'begin',
'',
'  l_objects := wwv_flow_utilities.string_to_table(:P858_OBJECT);',
'  ',
'  wwv_flow_collection.create_or_truncate_collection(''INSTALL_OBJECTS'');',
'  ',
'  for i in 1.. l_objects.count loop',
'      l_object_type := null;',
'      for c1 in (select object_type',
'                   from sys.dba_objects',
'                  where owner = :P865_OBJECT_OWNER',
'                    and object_name = l_objects(i)) loop',
'          l_object_type := replace(c1.object_type,'' BODY'',null);',
'          exit;',
'      end loop;',
'      wwv_flow_collection.add_member(',
'          p_collection_name => ''INSTALL_OBJECTS'',',
'          p_c001            => ''1'',',
'          p_c002            => :P865_OBJECT_OWNER,',
'          p_c003            => l_object_type,',
'          p_c004            => l_objects(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P850_SCRIPT_SOURCE,''x'') = ''DB'' and nvl(:P865_MODE,''x'') <> ''EDIT'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537841025191118532.4001)
,p_process_sequence=>3
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'do deletes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_clob_arr    wwv_flow.clob_arr;',
'    l_object_types varchar2(32767);',
'    l_objects     varchar2(32767);',
'begin',
'',
'    for i in 1..wwv_flow.g_f01.count loop',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name => ''INSTALL_OBJECTS'',',
'            p_seq             => wwv_flow.g_f01(i),',
'            p_attr_number     => 5,',
'            p_attr_value      => ''1'' );',
'    end loop;',
'    ',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'',
'    for c1 in (select distinct c003 object_type',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')= ''0'' ) loop',
'        l_object_types := l_object_types||c1.object_type||'':'';',
'    end loop;',
'    for c1 in (select c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''0'' ) loop',
'        l_objects := l_objects||c1.object_name||'':'';',
'    end loop;',
'    ',
'    if nvl(:P865_SCRIPT_OPTION,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'        -- only set l_object_types if an object is still not deleted',
'        if length(l_objects) > 0 then',
'            l_object_types := :P865_SCRIPT_OPTION;',
'        end if;',
'    elsif nvl(:P865_SCRIPT_OPTION,''x'') = ''TABLE'' then',
'        -- only set l_object_types if an object is still not deleted',
'        if length(l_objects) > 0 then',
'            l_object_types := ''TABLE_RELATED'';',
'        end if;',
'    else',
'        l_object_types := rtrim(l_object_types,'':'');',
'    end if;',
'',
'    l_clob_arr := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                      p_schema      => :P865_OBJECT_OWNER,',
'                      p_object_type => l_object_types,',
'                      p_objects     => rtrim(l_objects,'':''));',
'',
'    for i in 1..l_clob_arr.count loop',
'        l_code := l_code || l_clob_arr(i)||chr(10)||chr(10);',
'    end loop;',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'        ',
'        ',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(615012010767884573.4001)
,p_process_success_message=>'Los objetos se han eliminado del script.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537840506461118527.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    --process the deletes',
'    for c1 in (select c001 id',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''1'' ) loop',
'        delete from wwv_flow_install_objects',
'         where id = c1.id;',
'    end loop;',
'    ',
'    --process the inserts',
'    for c1 in (select c002 object_owner, c003 object_type, c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and c001 = ''1'' ) loop',
'        insert into wwv_flow_install_objects (script_id, object_owner, object_type, object_name)',
'        values (:P865_SCRIPT_ID, c1.object_owner, c1.object_type, c1.object_name);',
'    end loop;',
'end;',
'        ',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'substr(:REQUEST,1,13) in (''APPLY_CHANGES'') and wwv_flow_collection.collection_exists(''INSTALL_OBJECTS'') and :P865_SCRIPT_ID is not null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(551323800628211346.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'repopulate INSTALL_SCRIPT_ORIG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_clob_arr    wwv_flow.clob_arr;',
'    l_object_types varchar2(32767);',
'    l_objects     varchar2(32767);   ',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'    ',
'    --process deletes for obj that don''t exist',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c006,''x'') = wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DELETED'') ) loop',
'    ',
'        wwv_flow_collection.update_member_attribute(',
'            p_collection_name => ''INSTALL_OBJECTS'',',
'            p_seq             => c1.seq_id,',
'            p_attr_number     => ''5'',',
'            p_attr_value      => ''1'');',
'            ',
'    end loop;',
'    ',
'    for c1 in (select distinct c003 object_type',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')= ''0'' ) loop',
'        l_object_types := l_object_types||c1.object_type||'':'';',
'    end loop;',
'    for c1 in (select c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''0'' ) loop',
'        l_objects := l_objects||c1.object_name||'':'';',
'    end loop;',
'    ',
'    if nvl(:P865_SCRIPT_OPTION,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'        l_object_types := :P865_SCRIPT_OPTION;',
'    elsif nvl(:P865_SCRIPT_OPTION,''x'') = ''TABLE'' then',
'        l_object_types := ''TABLE_RELATED'';        ',
'    else',
'        l_object_types := rtrim(l_object_types,'':'');',
'    end if;    ',
'    ',
'    l_clob_arr := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                      p_schema      => :P865_OBJECT_OWNER,',
'                      p_object_type => l_object_types,',
'                      p_objects     => rtrim(l_objects,'':''));',
'',
'    for i in 1..l_clob_arr.count loop',
'        l_code := l_code || l_clob_arr(i)||chr(10)||chr(10);',
'    end loop;',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'        ',
'    --clear the object changed messages',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c006,''x'') = wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'')) loop',
'        ',
'        wwv_flow_collection.update_member_attribute(',
'            p_collection_name => ''INSTALL_OBJECTS'',',
'            p_seq             => c1.seq_id,',
'            p_attr_number     => ''6'',',
'            p_attr_value      => null);',
'            ',
'    end loop;         ',
'            ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(537838745432118509.4001)
,p_process_success_message=>'El script se ha refrescado de las definiciones de objeto de la base de datos.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107297699656699733.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clob   clob := empty_clob;',
'  l_object_owner varchar2(128) := null;',
'  l_object_type  varchar2(30) := null;',
'  l_script_id    number;',
'  i              number;',
'  l_objects      wwv_flow_global.vc_arr2;',
'begin',
'',
'  for c1 in (select clob001 script',
'             from htmldb_collections',
'             where collection_name = ''INSTALL_SCRIPT'') loop',
'    l_clob := c1.script;',
'  end loop;',
'',
'  if l_clob is not null then',
'    -- Three cases: User creating new install script, user ',
'    -- editing install script, or user editing deinstall script',
'',
'    if :P865_MODE = ''EDIT'' then',
'',
'      update wwv_flow_install_scripts ',
'         set script = l_clob',
'       where id = :P865_SCRIPT_ID',
'         and flow_id = :fb_flow_id',
'         and security_group_id = :flow_security_group_id;',
'',
'    elsif :P865_MODE = ''NEW'' then',
'',
'      if :P850_MODE = ''UPGRADE'' then ',
'        insert into wwv_flow_install_scripts (script, name, sequence, script_type)',
'        values (l_clob, :P865_SCRIPT_NAME, :P865_SCRIPT_SEQUENCE, ''UPGRADE'');',
'      else',
'        l_object_owner := :P865_OBJECT_OWNER;',
'        ',
'        insert into wwv_flow_install_scripts (script, name, sequence, script_type, script_option) ',
'        values (l_clob, :P865_SCRIPT_NAME, :P865_SCRIPT_SEQUENCE, ''INSTALL'', :P865_SCRIPT_OPTION) ',
'        returning id into l_script_id;',
'        ',
'        for c1 in (select c002 object_owner, c003 object_type, c004 object_name',
'                     from wwv_flow_collections',
'                    where collection_name = ''INSTALL_OBJECTS'') loop',
'            insert into wwv_flow_install_objects (script_id, object_owner, object_type, object_name)',
'            values (l_script_id, c1.object_owner, c1.object_type, c1.object_name);',
'        end loop;',
'      end if;',
'',
'    end if;',
'  end if;',
'',
'  if :P865_MODE = ''DEINSTALL'' then',
'',
'    update wwv_flow_install',
'       set deinstall_script = l_clob',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :flow_security_group_id;',
'',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido guardar el script.'
,p_process_when=>'substr(v(''REQUEST''),1,13) in (''APPLY_CHANGES'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Script guardado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4808801106699695.4001)
,p_process_sequence=>120
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'show name and sequence'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P865_MODE = ''EDIT'' then',
'  for c1 in (select name, sequence, script_option',
'               from wwv_flow_install_scripts',
'              where id = :P865_SCRIPT_ID',
'                and security_group_id = :flow_security_group_id)',
'  loop',
'    :P865_SCRIPT_NAME := c1.name;',
'    :P865_SCRIPT_OPTION := c1.script_option;',
'  end loop;',
'  for c1 in (select distinct replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) object_owner, object_type',
'               from wwv_flow_install_objects',
'              where script_id = :P865_SCRIPT_ID',
'              order by 2) loop',
'       if :P865_OBJECT_OWNER is null then',
'           :P865_OBJECT_OWNER := c1.object_owner;',
'       end if;',
'       :P865_OBJECT_TYPE := :P865_OBJECT_TYPE||c1.object_type||'', '';',
'  end loop;',
'  for c1 in (select object_name',
'               from wwv_flow_install_objects',
'              where script_id = :P865_SCRIPT_ID',
'              order by 1) loop',
'      :P865_OBJECT_NAME := :P865_OBJECT_NAME||c1.object_name||'', '';',
'  end loop;',
'  :P865_OBJECT_TYPE := rtrim(:P865_OBJECT_TYPE,'', '');',
'  :P865_OBJECT_NAME := rtrim(:P865_OBJECT_NAME,'', '');',
'elsif :P865_MODE = ''DEINSTALL'' then',
'  :P865_SCRIPT_NAME := wwv_flow_lang.system_message(''INSTALLER.DEINSTALL'');',
'elsif :P865_MODE = ''NEW'' then',
'    :P865_SCRIPT_NAME := :P855_SCRIPT_NAME;',
'    :P865_OBJECT_OWNER := :P855_OBJECT_OWNER;',
'    :P865_OBJECT_TYPE := replace(:P855_OBJECT_TYPE,'':'','', '');',
'    :P865_OBJECT_NAME := replace(:P858_OBJECT,'':'','', '');  ',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00866
begin
wwv_flow_api.create_page(
 p_id=>866.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Procesos Condicionales'
,p_step_title=>'Procesos Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194238612868788833.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194245028663804201.4001)
,p_plug_name=>'Condiciones de Proceso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id, PROCESS_NAME, ',
'PROCESS_WHEN_TYPE,',
'PROCESS_WHEN,',
'PROCESS_WHEN2,',
'id',
'from WWV_FLOW_STEP_PROCESSING',
'where FLOW_ID = :fb_flow_id and',
'process_when_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194245102805804201.4001)
,p_name=>'Process Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194245306516804204.4001)
,p_db_column_name=>'FLOW_STEP_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194245419236804205.4001)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre del Proceso'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5530:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194245501983804205.4001)
,p_db_column_name=>'PROCESS_WHEN_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194245626379804206.4001)
,p_db_column_name=>'PROCESS_WHEN'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194245726209804207.4001)
,p_db_column_name=>'PROCESS_WHEN2'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100576517207284423.4001)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194238222518788832.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194245028663804201.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:866:&SESSION.::&DEBUG.:866,RIR::'
);
end;
/
prompt --application/pages/page_00869
begin
wwv_flow_api.create_page(
 p_id=>869.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Elementos Condicionales'
,p_step_title=>'Elementos Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194518016467362474.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194529205806463891.4001)
,p_plug_name=>'Condiciones de Elemento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, NAME, ',
'DISPLAY_WHEN, ',
'DISPLAY_WHEN2, ',
'DISPLAY_WHEN_TYPE,',
'id',
'from WWV_FLOW_STEP_ITEMS',
'where FLOW_ID = :fb_flow_id and ',
'display_when_type is not null and ',
'display_when_type != ''%''||''null%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194529317355463891.4001)
,p_name=>'Item Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194529529071463893.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194529616580463894.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Elemento'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5120:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194529712450463895.4001)
,p_db_column_name=>'DISPLAY_WHEN'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194529827201463896.4001)
,p_db_column_name=>'DISPLAY_WHEN2'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100575602366284414.4001)
,p_db_column_name=>'DISPLAY_WHEN_TYPE'
,p_display_order=>15
,p_column_identifier=>'G'
,p_column_label=>'Mostrar cuando Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100575761452284415.4001)
,p_db_column_name=>'ID'
,p_display_order=>25
,p_column_identifier=>'H'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194517805082362472.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194529205806463891.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:869:&SESSION.::&DEBUG.:869,RIR::'
);
end;
/
prompt --application/pages/page_00870
begin
wwv_flow_api.create_page(
 p_id=>870.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia de Servicio Web: Tipo de Referencia Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia de Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33395014910549652.4001)
,p_plug_name=>'Crear Referencia de Servicio Web'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En &PRODUCT_NAME. se puede crear referencias de servicio web para servicios web de estilo RESTful, servicios web SOAP basados en un documento WSDL (Lenguaje de Descripci\00F3n de Servicios Web) o de forma manual. Los servicios web de estilo RESTful y ')
||unistr('los de estilo manual precisan de conocimientos detallados sobre el servicio web que normalmente est\00E1 disponible en la documentaci\00F3n del servicio. Las referencias de servicio web basadas en WSDL s\00F3lo necesitan informaci\00F3n sobre la ubicaci\00F3n del docume')
||'nto WSDL.</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46713613329274661.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33396322321549677.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46713613329274661.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33396504974549678.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46713613329274661.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33397322889549691.4001)
,p_branch_name=>'Manual'
,p_branch_action=>'f?p=&APP_ID.:199:&SESSION.::&DEBUG.:199::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33396504974549678.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P870_WEB_REFERENCE_TYPE'
,p_branch_condition_text=>'MANUAL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33397529300549693.4001)
,p_branch_name=>'WSDL'
,p_branch_action=>'f?p=&APP_ID.:580:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P870_WEB_REFERENCE_TYPE'
,p_branch_condition_text=>'WSDL'
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33401318496653812.4001)
,p_branch_name=>'REST'
,p_branch_action=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P870_WEB_REFERENCE_TYPE'
,p_branch_condition_text=>'REST'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33396725785549679.4001)
,p_name=>'P870_WEB_REFERENCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(33395014910549652.4001)
,p_item_default=>'REST'
,p_prompt=>unistr('\00BFQu\00E9 tipo de referencia web desea crear?')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WEB_REFERENCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(33398606197612456.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Seleccione el tipo de referencia web que desea crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614669987242188709.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33396322321549677.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614670079021188710.4001)
,p_event_id=>wwv_flow_api.id(614669987242188709.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00871
begin
wwv_flow_api.create_page(
 p_id=>871.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia Web REST: Detalles de REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia Web REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p871_add_header(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}',
'',
'function p871_remove_header(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    get.addParam(''x02'',seqid);',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });    ',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33402719073674448.4001)
,p_plug_name=>'Crear Referencia Web REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Los servicios web RESTful se basan en una sencilla arquitectura orientada a recursos. El recurso se identifica por medio de la URL,',
unistr('   y el m\00E9todo se describe por medio del m\00E9todo HTTP. Las entradas al servicio se incluyen a veces en la misma URL o'),
unistr('   en la carga \00FAtil HTTP. Tambi\00E9n pueden leerse las entradas en las cabeceras HTTP enviadas con la solicitud</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 31-JUL-2002 20:44:47'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33455017307559580.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22410710903630445.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34124924815112049.4001)
,p_name=>'Cabeceras de Solicitud HTTP'
,p_region_name=>'rest_http_headers'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>210
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       wwv_flow_item.hidden(1, seq_id) || wwv_flow_item.text(2, c001, 32) as name',
'  from wwv_flow_collections',
' where collection_name = ''REST_HTTP_HEADERS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No se ha definido ninguna cabecera de solicitud HTTP.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34125107306112078.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'javascript:p871_remove_header(''#SEQ_ID#'')'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">Eliminar</span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34125227429112078.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202597819671096996.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33404811501674452.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202597819671096996.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34126127924112088.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34124924815112049.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Cabecera'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p871_add_header()'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33462606459698309.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202597819671096996.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33461201348677938.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202597819671096996.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33461514816677941.4001)
,p_branch_action=>'f?p=&FLOW_ID.:870:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33461201348677938.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33462903589698459.4001)
,p_branch_action=>'f?p=&FLOW_ID.:872:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33462606459698309.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33412022816674467.4001)
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33405403626674452.4001)
,p_name=>'P871_BASIC_AUTH'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(33402719073674448.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n B\00E1sica:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si este servicio Web necesita autenticaci\00F3n b\00E1sica. Las credenciales de autenticaci\00F3n b\00E1sica se env\00EDan como parte de la solicitud HTTP sin cifrar. Los servicios Web que utilizan autenticaci\00F3n b\00E1sica, normalmente tambi\00E9n utilizan el protoco')
||unistr('lo HTTPS (SSL) ya que el nombre de usuario y la contrase\00F1a se env\00EDan sin cifrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33406603113674456.4001)
,p_name=>'P871_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(33402719073674448.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33407103289674459.4001)
,p_name=>'P871_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33402719073674448.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Nombre de este servicio web dentro del contexto del creador. Este nombre solo se utiliza en la herramienta Creador de Aplicaciones.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33407619399674459.4001)
,p_name=>'P871_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33402719073674448.4001)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el punto final de URL para el servicio web REST. Puede hacer referencia al estado de sesi\00F3n en la URL con la convenci\00F3n'),
'   <code>&amp;ITEM_NAME.</code>.</p>',
'<p>Por ejemplo:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33408115204674460.4001)
,p_name=>'P871_METHOD'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33402719073674448.4001)
,p_item_default=>'GET'
,p_prompt=>unistr('M\00E9todo HTTP:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REST_HTTP_METHOD'
,p_lov=>'.'||wwv_flow_api.id(33996111639139709.4001)||'.'
,p_cSize=>70
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Elija el m\00E9todo HTTP apropiado para el servicio web REST. El m\00E9todo HTTP describe el m\00E9todo del servicio web.</p>'),
'',
'',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33408620297674460.4001)
,p_name=>'P871_PROXY_OVERRIDE'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(33402719073674448.4001)
,p_prompt=>'Proxy'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esto sustituye al proxy HTTP definido por el sistema para la solicitud. El proxy puede incluir un n\00FAmero de puerto TCP/IP opcional en el que recibe el servidor proxy. Utilice la siguiente sintaxis:</p>'),
'<pre>[http://]host[:port][/]</pre>',
'<p>Por ejemplo:</p>',
'<pre>www-proxy.ejemplo.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33410429025674463.4001)
,p_validation_name=>'P871_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'P871_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_when_button_pressed=>wwv_flow_api.id(33462606459698309.4001)
,p_associated_item=>wwv_flow_api.id(33407103289674459.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:28'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33410602557674464.4001)
,p_validation_name=>'URL Not Null'
,p_validation_sequence=>10
,p_validation=>'P871_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la direcci\00F3n URL del servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(33462606459698309.4001)
,p_associated_item=>wwv_flow_api.id(33407619399674459.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614669701177188707.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33404811501674452.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614669812302188708.4001)
,p_event_id=>wwv_flow_api.id(614669701177188707.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34124530225104138.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create headers collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''REST_HTTP_HEADERS'');',
'wwv_flow_collection.add_member(''REST_HTTP_HEADERS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''REST_HTTP_HEADERS'') or wwv_flow_collection.collection_member_count(''REST_HTTP_HEADERS'') = 0;'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34124713387108788.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_HTTP_HEADERS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02 );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00872
begin
wwv_flow_api.create_page(
 p_id=>872.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia Web REST: Entradas de REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia Web REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="toggleInType();"'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p872_add_parm(){',
'    var repid = apex.jQuery("#rest_input_parms").find("div[id^=report_]").attr("id").replace("report_","").replace("_catch","");',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function p872_remove_parm(seqid){',
'    var repid = apex.jQuery("#rest_input_parms").find("div[id^=report_]").attr("id").replace("report_","").replace("_catch","");',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function toggleInType(){',
'    if ($v(''P872_INPUT_TYPE'') == ''body'' || $v(''P872_INPUT_TYPE'') == ''function''){',
'        apex.item(''P872_SOURCE'').show();',
'        $x_Hide(''rest_input_parms'');',
'        if ($v(''P872_INPUT_TYPE'') == ''function''){',
'          apex.item(''P872_CHECK_PLSQL1'').show();',
'        }',
'    } else if ($v(''P872_INPUT_TYPE'') == ''file''){',
'        $x_Hide(''rest_input_parms'');',
'        apex.item(''P872_SOURCE'').hide();',
'        apex.item(''P872_CHECK_PLSQL1'').hide();',
'    } else {',
'        apex.item(''P872_SOURCE'').hide();',
'        apex.item(''P872_CHECK_PLSQL1'').hide();',
'        $x_Show(''rest_input_parms'');',
'    }',
'}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33462315678691487.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22410710903630445.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(33497325383470083.4001)
,p_name=>unistr('Par\00E1metros de Entrada')
,p_region_name=>'rest_input_parms'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       wwv_flow_item.hidden(1,seq_id) || wwv_flow_item.text(2,c001,32) as name,',
'       wwv_flow_item.select_list_from_lov(3,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null) as type',
'  from wwv_flow_collections',
' where collection_name = ''REST_INPUT_PARMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn par\00E1metro de entrada REST.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33497610076470104.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'javascript:p872_remove_parm(''#SEQ_ID#'')'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">Eliminar</span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33497717625470108.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33497828033470108.4001)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202616810901236408.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>151
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1143245183239567404.4001)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de par\00E1metros de entrada si el m\00E9todo elegido en la p\00E1gina anterior es POST o PUT. De lo contrario, se asume'),
'   que el tipo de entrada es Pares de Nombre y Valor.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33474505513104880.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202616810901236408.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33551019615219399.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33497325383470083.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p872_add_parm();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33475128846121112.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202616810901236408.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33474712439106854.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202616810901236408.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33475007138106857.4001)
,p_branch_action=>'f?p=&FLOW_ID.:871:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33474712439106854.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33475409282121112.4001)
,p_branch_action=>'f?p=&APP_ID.:873:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33475128846121112.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48714130312488044.4001)
,p_name=>'P872_INPUT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1143245183239567404.4001)
,p_item_default=>'nvp'
,p_prompt=>'Tipo de Entrada:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(48714213128492554.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="toggleInType();"'
,p_display_when=>'P871_METHOD'
,p_display_when2=>'POST:PUT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica el tipo de par\00E1metros de entrada que se deben enviar con la solicitud HTTP. Entre las opciones se incluyen:'),
'<br /><br />',
'<ul>',
'    <li><strong>Pares de Nombre y Valor</strong>: varios pares de nombre/valor del tipo de dato especificado.</li>',
unistr('    <li><strong>Cuerpo Especificado con Sustituciones</strong>: carga \00FAtil de texto que puede contener sustituciones de <code>#ITEM_NAME#</code>'),
unistr('        para enviar elementos en estado de sesi\00F3n con la solicitud.</li>'),
'    <li><strong>Elemento de Carga de Archivo</strong></li>',
unistr('    <li><strong>Funci\00F3n Que Devuelve CLOB</strong>: cuerpo de la funci\00F3n PL/SQL que devuelve CLOB.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48753415719155541.4001)
,p_name=>'P872_SOURCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1143245183239567404.4001)
,p_prompt=>'Origen'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_display_when=>'P871_METHOD'
,p_display_when2=>'POST:PUT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Introduzca el origen que se va a utilizar como entrada del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173205910526156182.4001)
,p_name=>'P872_CHECK_PLSQL1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1143245183239567404.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLSQL_VALIDATION'
,p_lov=>'.'||wwv_flow_api.id(111144330433082822.4001)||'.'
,p_display_when=>'P871_METHOD'
,p_display_when2=>'POST:PUT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(173207103778192031.4001)
,p_validation_name=>'check PL/SQL syntax'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    :P872_SOURCE,',
'    :FB_FLOW_ID,',
'    :FLOW_SECURITY_GROUP_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P872_INPUT_TYPE = ''function'' AND (NVL(:P872_CHECK_PLSQL1,''YES'') <> ''NO'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(33475128846121112.4001)
,p_associated_item=>wwv_flow_api.id(48753415719155541.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614670489787188714.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33474505513104880.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614670534064188715.4001)
,p_event_id=>wwv_flow_api.id(614670489787188714.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33558206537946946.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_INPUT_PARMS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03 );',
''))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33496710922447058.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create inputs collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''REST_INPUT_PARMS'');',
'wwv_flow_collection.add_member(''REST_INPUT_PARMS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''REST_INPUT_PARMS'') or wwv_flow_collection.collection_member_count(''REST_INPUT_PARMS'') = 0;'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00873
begin
wwv_flow_api.create_page(
 p_id=>873.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Referencia Web REST: Salidas de REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Referencia Web REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p873_add_parm(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f06]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p873_remove_parm(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f06]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p873_popPath(seqid){',
'    if((apex.jQuery("input:radio[id^=P873_OUTPUT_FORMAT]:checked").val() == ''xml'') && (apex.jQuery("#path"+seqid).val() == '''')){',
'        apex.jQuery("#path"+seqid).val("/"+apex.jQuery("#name"+seqid).val());',
'    }',
'    else if (apex.jQuery("#path"+seqid).val() == ''''){',
'        apex.jQuery("#path"+seqid).val(seqid);',
'    }',
'}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33476926808168262.4001)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22410710903630445.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(33559732443824799.4001)
,p_name=>unistr('Par\00E1metros de Salida')
,p_region_name=>'rest_output_parms'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       wwv_flow_item.hidden(1,seq_id) ||',
'       wwv_flow_item.text(2,c001,25,255,null,''name''||seq_id, wwv_flow_lang.system_message(''NAME'')) as name,',
'       wwv_flow_item.text(6,c005,40,4000,''onfocus=p873_popPath(''||seq_id||'');'',''path''||seq_id,',
'                          wwv_flow_lang.system_message(''PATH'')) as path,',
'       wwv_flow_item.select_list_from_lov(3,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null,',
'                                          ''typ''||seq_id, wwv_flow_lang.system_message(''TYPE'')) as type',
'  from wwv_flow_collections',
' where collection_name = ''REST_OUTPUT_PARMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn par\00E1metro de salida REST.')
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33559907016824838.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'javascript:p873_remove_parm(''#SEQ_ID#'')'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">Eliminar</span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33560013630824842.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46859823955216633.4001)
,p_query_column_id=>3
,p_column_alias=>'PATH'
,p_column_display_sequence=>3
,p_column_heading=>'Ruta de Acceso'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33560128616824842.4001)
,p_query_column_id=>4
,p_column_alias=>'TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202630420476305427.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>151
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1143245206000567405.4001)
,p_plug_name=>'Create REST Web Reference'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Los servicios web RESTful suelen responder con un documento XML o JSON, o una respuesta de texto. Algunos servicios web RESTful permiten',
unistr('   al emisor de la llamada especificar qu\00E9 tipo de respuesta se desea recibir. Elija el formato de salida en la lista y, a continuaci\00F3n, defina los'),
unistr('   par\00E1metros de salida seg\00FAn sea necesario. Para revisar la salida de este servicio web, haga clic en el bot\00F3n <strong>Probar</strong>.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33560310313824846.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202630420476305427.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(345405901176990771.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(202630420476305427.4001)
,p_button_name=>'TEST'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Probar'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:popupURL(''f?p=&APP_ID.:975:&SESSION.::&DEBUG.:::'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33560910527824847.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33559732443824799.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p873_add_parm();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33560711690824847.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202630420476305427.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33560506789824847.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(202630420476305427.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33478307486168272.4001)
,p_branch_action=>'f?p=&APP_ID.:872:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33560506789824847.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33564412292989328.4001)
,p_name=>'P873_OUTPUT_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1143245206000567405.4001)
,p_item_default=>'xml'
,p_prompt=>'Formato de Salida:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REST_OUTPUT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(33563708997950496.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el formato de respuesta esperado del servicio web. Entre las opciones se incluyen:',
'<br /><br />',
'<ul>',
unistr('    <li><strong>XML</strong>: la respuesta se almacenar\00E1 en los par\00E1metros de salida especificados. Introduzca una expresi\00F3n XPath en'),
'        la columna Ruta de Acceso para buscar nodos individuales.</li>',
unistr('    <li><strong>Texto</strong>: la respuesta se almacenar\00E1 en los par\00E1metros de salida especificados. Introduzca un n\00FAmero en la columna'),
unistr('        Ruta de Acceso que corresponde a la posici\00F3n de cada par\00E1metro.</li>'),
unistr('    <li><strong>JSON</strong>: toda la respuesta se almacenar\00E1 en la columna <code>CLOB001</code> de la recopilaci\00F3n'),
unistr('        que especifique. La respuesta se puede analizar a continuaci\00F3n con la API PL/SQL <code>APEX_JSON</code>.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33564706190996940.4001)
,p_name=>'P873_XPATH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1143245206000567405.4001)
,p_prompt=>unistr('XPath a Par\00E1metros de Salida')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una expresi\00F3n XPath en la parte relevante de la respuesta. Ejemplo:'),
'',
'<pre>/ListBucketResult/Contents</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33564900087004734.4001)
,p_name=>'P873_TEXT_DELIM'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1143245206000567405.4001)
,p_item_default=>','
,p_prompt=>unistr('Delimitador de Par\00E1metro')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el car\00E1cter o la secuencia que separa los par\00E1metros que devuelve el servicio web. Utilice <strong>\005Cn</strong> para indicar una nueva l\00EDnea y <strong>\005Ct</strong> para indicar un car\00E1cter de tabulador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33573706845761396.4001)
,p_name=>'P873_NEW_RECORD_DELIM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1143245206000567405.4001)
,p_item_default=>'\n'
,p_prompt=>'Nuevo Delimitador de Registro'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el car\00E1cter o la secuencia que determina un nuevo registro en un texto de respuesta de un servicio web. Utilice <strong>\005Cn</strong> para indicar una nueva l\00EDnea y <strong>\005Ct</strong> para indicar un car\00E1cter de tabulaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35066308999301412.4001)
,p_name=>'P873_XMLNS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1143245206000567405.4001)
,p_prompt=>'Espacio de Nombres de Respuesta'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca el espacio de nombres correspondiente al XPath de respuesta si es necesario. Ejemplo:',
'',
'<pre>http://s3.example.com/doc/2006-03-01/</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(173538819801180850.4001)
,p_validation_name=>'P873_XPATH not null'
,p_validation_sequence=>10
,p_validation=>'P873_XPATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe proporcionar el XPath a los par\00E1metros de salida.')
,p_validation_condition=>'P873_OUTPUT_FORMAT'
,p_validation_condition2=>'xml'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(33560711690824847.4001)
,p_associated_item=>wwv_flow_api.id(33564706190996940.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(173500004134495140.4001)
,p_name=>'Disable text if xml'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P873_OUTPUT_FORMAT'
,p_condition_element=>'P873_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'xml'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173500323922495142.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_NEW_RECORD_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173500500348495144.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_NEW_RECORD_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173501511884506833.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_TEXT_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173501723658510171.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_TEXT_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173504016517517590.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XPATH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173504514224526434.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XPATH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173504224135519839.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XMLNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(173504825998529805.4001)
,p_event_id=>wwv_flow_api.id(173500004134495140.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XMLNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(296133215779241284.4001)
,p_name=>'disable all output items if json'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P873_OUTPUT_FORMAT'
,p_condition_element=>'P873_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'json'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(296133502321241284.4001)
,p_event_id=>wwv_flow_api.id(296133215779241284.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XPATH,P873_XMLNS,P873_TEXT_DELIM,P873_NEW_RECORD_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143245446814567407.4001)
,p_event_id=>wwv_flow_api.id(296133215779241284.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(33559732443824799.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143245335774567406.4001)
,p_event_id=>wwv_flow_api.id(296133215779241284.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(33559732443824799.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(614670638501188716.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33560310313824846.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(614670709990188717.4001)
,p_event_id=>wwv_flow_api.id(614670638501188716.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33562221633916277.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_OUTPUT_PARMS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c005 => wwv_flow.g_f06 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33588401705564025.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create REST web reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_xpath             varchar2(4000) := null;',
'    l_text_parm_delim   varchar2(4000) := null;',
'    l_text_record_delim varchar2(4000) := null;',
'    l_xmlns             varchar2(4000) := null;',
'    l_source            clob := empty_clob();',
'    l_id                number;',
'    l_items             clob;',
'begin',
'    l_id := wwv_flow_id.next_val;',
'    if :P873_OUTPUT_FORMAT = ''xml'' then',
'        l_xpath := :P873_XPATH;',
'        l_xmlns := :P873_XMLNS;',
'    else',
'        l_text_parm_delim := :P873_TEXT_DELIM;',
'        l_text_record_delim := :P873_NEW_RECORD_DELIM;',
'    end if;',
'',
'    if :P872_INPUT_TYPE in (''body'',''function'') then',
'      l_source := :P872_SOURCE;',
'    end if;',
'',
'    wwv_flow_web_services.create_rest_web_reference(',
'        p_id                            => l_id,',
'        p_flow_id                       => :FB_FLOW_ID,',
'        p_name                          => :P871_NAME,',
'        p_url                           => :P871_URL,',
'        p_proxy_override                => :P871_PROXY_OVERRIDE,',
'        p_http_method                   => :P871_METHOD,',
'        p_input_format                  => nvl(:P872_INPUT_TYPE,''nvp''),',
'        p_body                          => l_source,',
'        p_output_format                 => :P873_OUTPUT_FORMAT,',
'        p_xpath                         => l_xpath,',
'        p_xmlns                         => l_xmlns,',
'        p_text_parm_delim               => l_text_parm_delim,',
'        p_text_record_delim             => l_text_record_delim,',
'        p_inputs_collection             => ''REST_INPUT_PARMS'',',
'        p_outputs_collection            => ''REST_OUTPUT_PARMS'',',
'        p_headers_collection            => ''REST_HTTP_HEADERS'',',
'        p_basic_auth                    => :P871_BASIC_AUTH );',
'',
'  if :P872_INPUT_TYPE = ''body'' then',
'    l_items := wwv_flow_web_services.parse( l_source );',
'',
'    update wwv_flow_shared_web_services',
'       set flow_items_comma_delimited = l_items',
'     where id = l_id;',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(33560711690824847.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(614670838286188718.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(33560711690824847.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33562016785914925.4001)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create outputs collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''REST_OUTPUT_PARMS'');',
'wwv_flow_collection.add_member(''REST_OUTPUT_PARMS'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''REST_OUTPUT_PARMS'') or wwv_flow_collection.collection_member_count(''REST_OUTPUT_PARMS'') = 0;'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00875
begin
wwv_flow_api.create_page(
 p_id=>875.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Probar Referencia Web REST'
,p_step_title=>'Probar Referencia Web REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p875_test_rest(){',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P875_TEST_REST'',0);',
'',
'    get.addParam(''x01'',$v(''P875_URL''));',
'    get.addParam(''x02'',$v(''P875_PROXY_OVERRIDE''));',
'    get.addParam(''x03'',$v(''P875_STATIC_PARM_04''));',
'    get.addParam(''x04'',$v(''P875_USERNAME''));',
'    get.addParam(''x05'',$v(''P875_PASSWORD''));',
'    get.addParam(''x06'',encodeURIComponent($v(''P875_SOURCE'')));',
'',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam( ''f01'', apex.jQuery(this).val() );',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam( ''f02'', apex.jQuery(this).val() );',
'        });',
'    apex.jQuery("input[name=f03]").each( function() {',
'        get.addParam( ''f03'', apex.jQuery(this).val() );',
'        });',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam( ''f04'', apex.jQuery(this).val() );',
'        });',
'',
'    gReturn = get.get();',
'    apex.jQuery("#rest_response").show();',
'    apex.jQuery("#rest_response_container").text(gReturn);',
'    get = null;',
'',
'}',
'',
'function clear_response(){',
'    apex.jQuery(''#rest_response_container'').html('' '');',
'}'))
,p_javascript_code_onload=>'apex.jQuery("#rest_response").hide();'
,p_inline_css=>'#rest_response_container:empty {display: none;}'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33595522715462216.4001)
,p_plug_name=>'Detalles de Servicio Web REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(33600829145653306.4001)
,p_name=>unistr('Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(1, c.name) name,',
'       wwv_flow_item.text(2, null, 32, null, ''title="''||wwv_flow_lang.system_message(''F4000.P875.INPUT_PARAM_VAL'',c.name)||''"'') value',
'  from wwv_flow_ws_parameters c, wwv_flow_ws_operations b,',
'       wwv_flow_shared_web_services a ',
' where a.id = :P875_ID ',
'   and b.ws_id = a.id ',
'   and c.ws_opers_id = b.id ',
'   and c.input_or_output = ''I'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33601118995653318.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33807410653550307.4001)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33601419018669314.4001)
,p_plug_name=>'Respuesta'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div class="a-Form-textarea a-Form-textarea--code" id="rest_response_container" style="white-space: pre-line; max-height: 300px; overflow: auto;"></div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33951108113208712.4001)
,p_plug_name=>unistr('Autenticaci\00F3n B\00E1sica')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where ws_id = :P875_ID',
'   and name = ''BASIC_AUTH'''))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(35165822063015371.4001)
,p_name=>'Cabeceras HTTP'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(3, c.name) name,',
'       wwv_flow_item.text(4, null, 32, null, ''title="''||wwv_flow_lang.system_message(''F4000.P875.HTTP_HEADER_VAL'',c.name)||''"'') value',
'  from wwv_flow_ws_parameters c, wwv_flow_ws_operations b,',
'       wwv_flow_shared_web_services a ',
' where a.id = :P875_ID ',
'   and b.ws_id = a.id ',
'   and c.ws_opers_id = b.id ',
'   and c.input_or_output = ''H'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_parameters c, wwv_flow_ws_operations b,',
'       wwv_flow_shared_web_services a ',
' where a.id = :P875_ID ',
'   and b.ws_id = a.id ',
'   and c.ws_opers_id = b.id ',
'   and c.input_or_output = ''H'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(35166017638015376.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(35166116947015377.4001)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176872608832700782.4001)
,p_plug_name=>'Probar Servicio Web REST'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice esta p\00E1gina para probar la referencia de un servicio web REST. Modifique la URL del servicio si contiene referencias al estado de la sesi\00F3n. Introduzca una anulaci\00F3n de proxy si desea utilizar uno concreto para la prueba que realice en esta p')
||unistr('\00E1gina. Facilite credenciales de autenticaci\00F3n b\00E1sica si as\00ED lo solicita el servicio web. Introduzca valores para las cabeceras HTTP y los par\00E1metros de entrada requeridos, y haga clic en Probar. La respuesta aparecer\00E1 en una regi\00F3n que permite despla')
||unistr('zamientos, bajo la regi\00F3n Par\00E1metros de Entrada.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1142727743638397017.4001)
,p_plug_name=>'Referencia de Servicio Web: &P875_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1143245926080567412.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33595805137462218.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1142727743638397017.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(441373805154163796.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1142727743638397017.4001)
,p_button_name=>'CLEAR'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Borrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:clear_response();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33807630309574902.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1142727743638397017.4001)
,p_button_name=>'TEST'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Probar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33595913096462220.4001)
,p_branch_action=>'f?p=&APP_ID.:875:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33596118046462223.4001)
,p_name=>'P875_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33596710726462253.4001)
,p_name=>'P875_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre de referencia de servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33597115805462253.4001)
,p_name=>'P875_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Punto final de URL del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33597501386462254.4001)
,p_name=>'P875_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Anulaci\00F3n de Proxy')
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proxy que se va a utilizar en lugar del que se ha definido a nivel de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33597732766462255.4001)
,p_name=>'P875_STATIC_PARM_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo HTTP')
,p_source=>'STATIC_PARM_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('M\00E9todo HTTP utilizado para realizar la solicitud al servicio web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33597931277462255.4001)
,p_name=>'P875_STATIC_PARM_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Respuesta'
,p_source=>'STATIC_PARM_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Formato de la respuesta que devuelve el servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33951422312212775.4001)
,p_name=>'P875_USERNAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(33951108113208712.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de usuario para la autenticaci\00F3n b\00E1sica HTTP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33951612746219471.4001)
,p_name=>'P875_PASSWORD'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(33951108113208712.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a para la autenticaci\00F3n b\00E1sica HTTP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48946114500284528.4001)
,p_name=>'P875_SOURCE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(33600829145653306.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Origen'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_display_when=>'P875_STATIC_PARM_10'
,p_display_when2=>'nvp'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el origen que se va a utilizar como entrada del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48995230905698899.4001)
,p_name=>'P875_STATIC_PARM_10'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(33595522715462216.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Entrada'
,p_source=>'STATIC_PARM_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(48714213128492554.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'El tipo de entrada que espera el servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48998213506712832.4001)
,p_computation_sequence=>10
,p_computation_item=>'P875_SOURCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P875_STATIC_PARM_10'
,p_compute_when_text=>'function:file'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143245536772567408.4001)
,p_name=>'Test web service'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33807630309574902.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143245638158567409.4001)
,p_event_id=>wwv_flow_api.id(1143245536772567408.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'p875_test_rest();'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33598204436462256.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P875_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
end;
/
prompt --application/pages/page_00876
begin
wwv_flow_api.create_page(
 p_id=>876.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Referencia Web REST'
,p_step_title=>'Editar Referencia Web REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p876_toggleInType();"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'function p876_add_input_parm(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f09]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f10]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function p876_add_output_parm(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f05]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f15]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f06] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f11]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f12]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p876_remove_input_parm(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    get.addParam(''x03'',''update'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f09]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f10]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function p876_remove_output_parm(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    get.addParam(''x03'',''update'');',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f05]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f15]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f06] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f11]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f12]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p876_add_header(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    apex.jQuery("input[name=f07]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f08]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f13]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f14]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}',
'',
'function p876_remove_header(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    get.addParam(''x02'',seqid);',
'    get.addParam(''x03'',''update'');',
'    apex.jQuery("input[name=f07]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f08]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f13]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f14]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}',
'',
'function p876_popPath(seqid){',
'    if((apex.jQuery("input:radio[id^=P876_OUTPUT_FORMAT]:checked").val() == ''xml'') && (apex.jQuery("#path"+seqid).val() == '''')){',
'        apex.jQuery("#path"+seqid).val("/"+apex.jQuery("#name"+seqid).val());',
'    }',
'    else if (apex.jQuery("#path"+seqid).val() == ''''){',
'        apex.jQuery("#path"+seqid).val(seqid);',
'    }',
'}',
'',
'function p876_toggleInType(){',
'    if ($v(''P876_INPUT_TYPE'') == ''body'' || $v(''P876_INPUT_TYPE'') == ''function''){',
'        apex.item(''P876_SOURCE'').show();',
'        $x_Hide(''report_34122700798821352_catch'');',
'    } else if ($v(''P876_INPUT_TYPE'') == ''file''){',
'        $x_Hide(''report_34122700798821352_catch'');',
'        apex.item(''P876_SOURCE'').hide();',
'    } else {',
'        apex.item(''P876_SOURCE'').hide();',
'        $x_Show(''report_34122700798821352_catch'');',
'    }',
'}',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33987329567919152.4001)
,p_plug_name=>'Referencia Web REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34122700798821352.4001)
,p_name=>unistr('Par\00E1metros de Entrada REST')
,p_region_name=>'rest_input_parms'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="#" onclick="p876_remove_input_parm(''||seq_id||'');"><span class="a-Icon icon-remove"></span>'' ||',
'       ''<span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''F4000.P876.DELETE_PARAM'',',
'                                                                       wwv_flow_escape.html( c001 ) ) ||',
'       ''</span></a>'' ||',
'       wwv_flow_item.hidden(1,seq_id)||wwv_flow_item.hidden(9,c003)||wwv_flow_item.hidden(10,c004) as seq_id,',
'       wwv_flow_item.text(2,c001) name,',
'       wwv_flow_item.select_list_from_lov(3,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null) type',
'  from wwv_flow_collections',
' where collection_name = ''REST_INPUT_PARMS''',
'   and c004 != ''D'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn par\00E1metro de entrada para este servicio')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34122911854821356.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34123025766821356.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34123118019821356.4001)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34123206339822961.4001)
,p_name=>unistr('Par\00E1metros de Salida REST')
,p_region_name=>'rest_output_parms'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="#" onclick="p876_remove_output_parm(''||seq_id||'');"><span class="a-Icon icon-remove"></span>'' ||',
'       ''<span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''F4000.P876.DELETE_PARAM'',',
'                                                                       wwv_flow_escape.html( c001 ) ) ||',
'       ''</span></a>'' ||',
'       wwv_flow_item.hidden(4,seq_id)||wwv_flow_item.hidden(11,c003)||wwv_flow_item.hidden(12,c004) as output_seq_id,',
'       wwv_flow_item.text(5,c001,30,255,null,''name''||seq_id) output_name,',
'       wwv_flow_item.text(15,c005,50,4000,''onfocus=p876_popPath(''||seq_id||'');'',''path''||seq_id) path,',
'       wwv_flow_item.select_list_from_lov(6,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null) output_type',
'  from wwv_flow_collections',
' where collection_name = ''REST_OUTPUT_PARMS''',
'   and c004 != ''D'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn par\00E1metro de salida para este servicio')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142728778959397027.4001)
,p_query_column_id=>1
,p_column_alias=>'OUTPUT_SEQ_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142728885541397028.4001)
,p_query_column_id=>2
,p_column_alias=>'OUTPUT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46907806366867170.4001)
,p_query_column_id=>3
,p_column_alias=>'PATH'
,p_column_display_sequence=>3
,p_column_heading=>'Ruta de Acceso'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142728917880397029.4001)
,p_query_column_id=>4
,p_column_alias=>'OUTPUT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34140521388763866.4001)
,p_name=>'Cabeceras de Solicitud HTTP'
,p_region_name=>'rest_http_headers'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="#" onclick="p876_remove_header(''||seq_id||'');"><span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''F4000.P876.DELETE_HEADER'')||''</span></a>''||',
'       wwv_flow_item.hidden(7,seq_id)||wwv_flow_item.hidden(13,c003)||wwv_flow_item.hidden(14,c004) header_seq_id,',
'       wwv_flow_item.text(8,c001) header_name',
'  from wwv_flow_collections',
' where collection_name = ''REST_HTTP_HEADERS''',
'   and c004 != ''D'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se han definido cabeceras HTTP para este servicio'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142729086479397030.4001)
,p_query_column_id=>1
,p_column_alias=>'HEADER_SEQ_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1142729104343397031.4001)
,p_query_column_id=>2
,p_column_alias=>'HEADER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620281521846925739.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(741443157205225826.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34141026153763869.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34140521388763866.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Cabecera'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p876_add_header();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34168919637379005.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34122700798821352.4001)
,p_button_name=>'ADD_I'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro de Entrada')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p876_add_input_parm();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34169300721383051.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34123206339822961.4001)
,p_button_name=>'ADD_O'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro de Salida')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p876_add_output_parm();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33988409371919172.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(620281521846925739.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33988002257919170.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(620281521846925739.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P876_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33988226918919172.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(620281521846925739.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P876_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33991321484919185.4001)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33988614049919173.4001)
,p_name=>'P876_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33988820787919174.4001)
,p_name=>'P876_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Nombre de este servicio web dentro del contexto del creador. Este nombre solo se utiliza en la herramienta Creador de aplicaciones.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33989003279919175.4001)
,p_name=>'P876_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el punto final de URL para el servicio web REST. Puede hacer referencia al estado de sesi\00F3n en la URL con la convenci\00F3n'),
'   <code>&amp;ITEM_NAME.</code>.</p>',
'<p>Por ejemplo:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33989224451919175.4001)
,p_name=>'P876_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Anulaci\00F3n de Proxy')
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esto sustituye al proxy HTTP definido por el sistema para la solicitud. El proxy puede incluir un n\00FAmero de puerto TCP/IP opcional en el'),
'   que recibe el servidor proxy. Utilice la siguiente sintaxis:</p>',
'<pre>[http://]host[:port][/]</pre>',
'<p>Por ejemplo:</p>',
'<pre>www-proxy.ejemplo.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33989427517919175.4001)
,p_name=>'P876_HTTP_METHOD'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo HTTP')
,p_source=>'STATIC_PARM_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_HTTP_METHOD'
,p_lov=>'.'||wwv_flow_api.id(33996111639139709.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Elija el m\00E9todo HTTP apropiado para el servicio web REST. El m\00E9todo HTTP describe el m\00E9todo del servicio web.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33989609797919175.4001)
,p_name=>'P876_OUTPUT_FORMAT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Salida'
,p_source=>'STATIC_PARM_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_OUTPUT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(33563708997950496.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el formato de respuesta esperado del servicio web. Entre las opciones se incluyen:',
'<br /><br />',
'<ul>',
unistr('    <li><strong>XML</strong>: la respuesta se almacenar\00E1 en los par\00E1metros de salida especificados. Introduzca una expresi\00F3n XPath en'),
'        la columna Ruta de Acceso para buscar nodos individuales.</li>',
unistr('    <li><strong>Texto</strong>: la respuesta se almacenar\00E1 en los par\00E1metros de salida especificados. Introduzca un n\00FAmero en la columna'),
unistr('        Ruta de Acceso que corresponde a la posici\00F3n de cada par\00E1metro.</li>'),
unistr('    <li><strong>JSON</strong>: toda la respuesta se almacenar\00E1 en la columna <code>CLOB001</code> de la recopilaci\00F3n'),
unistr('        que especifique. La respuesta se puede analizar a continuaci\00F3n con la API PL/SQL <code>APEX_JSON</code>.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33989831716919175.4001)
,p_name=>'P876_XPATH'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'XPath de Respuesta'
,p_source=>'STATIC_PARM_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una expresi\00F3n XPath en la parte relevante de la respuesta. Ejemplo:'),
'',
'<pre>/ListBucketResult/Contents</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33990023486919176.4001)
,p_name=>'P876_NEW_RECORD_DELIM'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nuevo Delimitador de Registro'
,p_source=>'STATIC_PARM_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el car\00E1cter o la secuencia que determina un nuevo registro en un texto de respuesta de un servicio web. Utilice <strong>\005Cn</strong> para indicar una nueva l\00EDnea y <strong>\005Ct</strong> para indicar un car\00E1cter de tabulaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33990225879919178.4001)
,p_name=>'P876_TEXT_DELIM'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Delimitador de Par\00E1metro')
,p_source=>'STATIC_PARM_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el car\00E1cter o la secuencia que separa los par\00E1metros que devuelve el servicio web. Utilice <strong>\005Cn</strong> para indicar una nueva l\00EDnea y <strong>\005Ct</strong> para indicar un car\00E1cter de tabulador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33993018341075457.4001)
,p_name=>'P876_BASIC_AUTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n B\00E1sica')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si este servicio Web necesita autenticaci\00F3n b\00E1sica. Las credenciales de autenticaci\00F3n b\00E1sica se env\00EDan como parte de la solicitud HTTP sin cifrar. Los servicios Web que utilizan autenticaci\00F3n b\00E1sica, normalmente tambi\00E9n utilizan el protoco')
||unistr('lo HTTPS (SSL) ya que el nombre de usuario y la contrase\00F1a se env\00EDan sin cifrar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35066616748313126.4001)
,p_name=>'P876_XMLNS'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_api.id(33987329567919152.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espacio de Nombres de Respuesta'
,p_source=>'STATIC_PARM_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca el espacio de nombres correspondiente al XPath de respuesta. Ejemplo:',
'',
'<pre>http://s3.example.com/doc/2006-03-01/</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48885832687277527.4001)
,p_name=>'P876_INPUT_TYPE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(34122700798821352.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvp'
,p_prompt=>'Tipo de Entrada'
,p_source=>'STATIC_PARM_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(48714213128492554.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="p876_toggleInType();"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica el tipo de par\00E1metros de entrada que se deben enviar con la solicitud HTTP. Entre las opciones se incluyen:'),
'<br /><br />',
'<ul>',
'    <li><strong>Pares de Nombre y Valor</strong>: varios pares de nombre/valor del tipo de dato especificado.</li>',
unistr('    <li><strong>Cuerpo Especificado con Sustituciones</strong>: carga \00FAtil de texto que puede contener sustituciones de <code>#ITEM_NAME#</code>'),
unistr('        para enviar elementos en estado de sesi\00F3n con la solicitud.</li>'),
'    <li><strong>Elemento de Carga de Archivo</strong></li>',
unistr('    <li><strong>Funci\00F3n Que Devuelve CLOB</strong>: cuerpo de la funci\00F3n PL/SQL que devuelve CLOB.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48886108623308420.4001)
,p_name=>'P876_SOURCE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(34122700798821352.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Origen'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el origen que se va a utilizar como entrada del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33998026493191359.4001)
,p_computation_sequence=>20
,p_computation_item=>'P876_BASIC_AUTH'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''BASIC_AUTH''',
'   and ws_id = :P876_ID'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33990521548919181.4001)
,p_validation_name=>'P876_NAME not null'
,p_validation_sequence=>40
,p_validation=>'P876_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Introduzca un nombre para identificar esta referencia web.'
,p_when_button_pressed=>wwv_flow_api.id(33988226918919172.4001)
,p_associated_item=>wwv_flow_api.id(33988820787919174.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177069020725438332.4001)
,p_validation_name=>'P876_URL'
,p_validation_sequence=>50
,p_validation=>'P876_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Introduzca la direcci\00F3n URL para el servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(33988226918919172.4001)
,p_associated_item=>wwv_flow_api.id(33989003279919175.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177071212806464527.4001)
,p_validation_name=>'P876_XPATH'
,p_validation_sequence=>60
,p_validation=>'P876_XPATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Introduzca una expresi\00F3n XPath a la parte pertinente de la respuesta.')
,p_validation_condition=>'P876_OUTPUT_FORMAT'
,p_validation_condition2=>'xml'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(33988226918919172.4001)
,p_associated_item=>wwv_flow_api.id(33989831716919175.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(176971614437582277.4001)
,p_name=>'output type actions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P876_OUTPUT_FORMAT'
,p_condition_element=>'P876_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'xml'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176971902866582279.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_NEW_RECORD_DELIM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176972126701582280.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_NEW_RECORD_DELIM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176974203749607580.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_TEXT_DELIM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176988908728618446.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_TEXT_DELIM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176974411021609633.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176989415308620334.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176974620718612430.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XMLNS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176989621195622001.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XMLNS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176988132146615735.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.SHOWREQUIRED'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(176989829160624334.4001)
,p_event_id=>wwv_flow_api.id(176971614437582277.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.HIDEREQUIRED'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(295586221424675170.4001)
,p_name=>'disable all output items if json'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P876_OUTPUT_FORMAT'
,p_condition_element=>'P876_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'json'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(295586531813675170.4001)
,p_event_id=>wwv_flow_api.id(295586221424675170.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH,P876_XMLNS,P876_NEW_RECORD_DELIM,P876_TEXT_DELIM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(295596231553833783.4001)
,p_event_id=>wwv_flow_api.id(295586221424675170.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(34123206339822961.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(295593504176831312.4001)
,p_event_id=>wwv_flow_api.id(295586221424675170.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(34123206339822961.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33990612219919183.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P876_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34000814007386355.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''REST_INPUT_PARMS'') then',
'  wwv_flow_collection.delete_collection(''REST_INPUT_PARMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''REST_OUTPUT_PARMS'') then',
'  wwv_flow_collection.delete_collection(''REST_OUTPUT_PARMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''REST_HTTP_HEADERS'') then',
'  wwv_flow_collection.delete_collection(''REST_HTTP_HEADERS'');',
'end if;',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'  p_collection_name => ''REST_INPUT_PARMS'',',
'  p_query => ''select c.name, c.parm_type, c.id, ''''O'''' from wwv_flow_ws_parameters c, wwv_flow_ws_operations b, wwv_flow_shared_web_services a where b.ws_id = a.id and c.ws_opers_id = b.id and c.input_or_output = ''''I'''' and b.name = ''''doREST'''' and a.id'
||' = (select v(''''P876_ID'''') from dual)'' );',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'  p_collection_name => ''REST_OUTPUT_PARMS'',',
'  p_query => ''select c.name, c.parm_type, c.id, ''''O'''', c.path from wwv_flow_ws_parameters c, wwv_flow_ws_operations b, wwv_flow_shared_web_services a where b.ws_id = a.id and c.ws_opers_id = b.id and c.input_or_output = ''''O'''' and b.name = ''''doREST'''' '
||'and a.id = (select v(''''P876_ID'''') from dual)'' );',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'  p_collection_name => ''REST_HTTP_HEADERS'',',
'  p_query => ''select c.name, c.parm_type, c.id, ''''O'''' from wwv_flow_ws_parameters c, wwv_flow_ws_operations b, wwv_flow_shared_web_services a where b.ws_id = a.id and c.ws_opers_id = b.id and c.input_or_output = ''''H'''' and b.name = ''''doREST'''' and a.id'
||' = (select v(''''P876_ID'''') from dual)'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34132610934231019.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection input parms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_INPUT_PARMS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c003 => wwv_flow.g_f09,',
'  p_c004 => wwv_flow.g_f10 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34132401930228406.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection http headers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_HTTP_HEADERS'',',
'  p_seq => wwv_flow.g_f07,',
'  p_c001 => wwv_flow.g_f08,',
'  p_c003 => wwv_flow.g_f13,',
'  p_c004 => wwv_flow.g_f14  );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34132830327236657.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection output parms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_OUTPUT_PARMS'',',
'  p_seq => wwv_flow.g_f04,',
'  p_c001 => wwv_flow.g_f05,',
'  p_c002 => wwv_flow.g_f06,',
'  p_c003 => wwv_flow.g_f11,',
'  p_c004 => wwv_flow.g_f12,',
'  p_c005 => wwv_flow.g_f15 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34173429988779355.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update REST web reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_xpath             varchar2(4000) := null;',
'    l_text_parm_delim   varchar2(4000) := null;',
'    l_text_record_delim varchar2(4000) := null;',
'    l_xmlns             varchar2(4000) := null;',
'    l_source            clob := empty_clob();',
'    l_items             clob;',
'begin',
'    if :P876_OUTPUT_FORMAT = ''xml'' then',
'        l_xpath := :P876_XPATH;',
'        l_xmlns := :P876_XMLNS;',
'    else',
'        l_text_parm_delim := :P876_TEXT_DELIM;',
'        l_text_record_delim := :P876_NEW_RECORD_DELIM;',
'    end if;   ',
'',
'    if :P876_INPUT_TYPE in (''body'',''function'') then',
'      l_source := :P876_SOURCE;',
'    end if;     ',
'',
'    wwv_flow_web_services.update_rest_web_reference(',
'        p_id                            => :P876_ID,',
'        p_flow_id                       => :FB_FLOW_ID,',
'        p_name                          => :P876_NAME,',
'        p_url                           => :P876_URL,',
'        p_proxy_override                => :P876_PROXY_OVERRIDE,',
'        p_http_method                   => :P876_HTTP_METHOD,',
'        p_input_format                  => :P876_INPUT_TYPE,',
'        p_body                          => l_source,',
'        p_output_format                 => :P876_OUTPUT_FORMAT,',
'        p_xpath                         => l_xpath,',
'        p_xmlns                         => l_xmlns,',
'        p_text_parm_delim               => l_text_parm_delim,',
'        p_text_record_delim             => l_text_record_delim,',
'        p_inputs_collection             => ''REST_INPUT_PARMS'',',
'        p_outputs_collection            => ''REST_OUTPUT_PARMS'',',
'        p_headers_collection            => ''REST_HTTP_HEADERS'',',
'        p_basic_auth                    => :P876_BASIC_AUTH );',
'',
'  if :P876_INPUT_TYPE = ''body'' then',
'    l_items := wwv_flow_web_services.parse( l_source );',
'',
'    update wwv_flow_shared_web_services',
'       set flow_items_comma_delimited = l_items',
'     where id = :P876_ID;',
'  end if;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al actualizar la referencia web REST.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(33988226918919172.4001)
,p_process_success_message=>'Referencia web REST actualizada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35187101191302684.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_shared_web_services',
' where id = :P876_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir referencia web de servicio. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Referencia de servicio web suprimida.'
);
end;
/
prompt --application/pages/page_00877
begin
wwv_flow_api.create_page(
 p_id=>877.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('C\00E1lculos Condicionales')
,p_step_title=>unistr('C\00E1lculos Condicionales')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194533823362486778.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194538321296502260.4001)
,p_plug_name=>unistr('Condiciones de C\00E1lculo')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, COMPUTATION_ITEM, ',
'compute_WHEN_TYPE,',
'compute_WHEN,',
'compute_WHEN_text,',
'id',
'from WWV_FLOW_STEP_COMPUTATIONS',
'where FLOW_ID = :fb_flow_id and ',
'compute_when_type is not null and compute_when_type != ''%''||''null%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194538422938502260.4001)
,p_name=>'Computation Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194538631724502264.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194538710618502264.4001)
,p_db_column_name=>'COMPUTATION_ITEM'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Elemento'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5520:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194538806160502265.4001)
,p_db_column_name=>'COMPUTE_WHEN_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194538920265502266.4001)
,p_db_column_name=>'COMPUTE_WHEN'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194539013016502267.4001)
,p_db_column_name=>'COMPUTE_WHEN_TEXT'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100575878725284416.4001)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194533627761486776.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194538321296502260.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:877:&SESSION.::&DEBUG.:877,RIR::'
);
end;
/
prompt --application/pages/page_00878
begin
wwv_flow_api.create_page(
 p_id=>878.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Botones Condicionales'
,p_step_title=>'Botones Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194548307071571000.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194554903107601883.4001)
,p_plug_name=>unistr('Condiciones de Bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,flow_step_id page, BUTTON_NAME, ',
'BUTTON_CONDITION_TYPE,',
'BUTTON_CONDITION, ',
'BUTTON_CONDITION2',
'from WWV_FLOW_STEP_BUTTONS',
'where ',
' flow_id = :fb_flow_id and',
' button_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194555017964601883.4001)
,p_name=>'Button Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194555209934601885.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194555315632601886.4001)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Bot\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5130:#ID#'
,p_column_linktext=>'#BUTTON_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194555407252601887.4001)
,p_db_column_name=>'BUTTON_CONDITION_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194555503299601888.4001)
,p_db_column_name=>'BUTTON_CONDITION'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194555618628601889.4001)
,p_db_column_name=>'BUTTON_CONDITION2'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100575268129284410.4001)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194549828979571012.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194554903107601883.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:878:&SESSION.::&DEBUG.:878,RIR::'
);
end;
/
prompt --application/pages/page_00880
begin
wwv_flow_api.create_page(
 p_id=>880.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla e Informes Basados en Servicio Web: Elementos de Entrada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34477514962171596.4001)
,p_name=>unistr('Elementos para Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, c001 id, c002 name, c003 parm_type, ',
'       c004 item_name, c005 item_label, c006 include',
'  from wwv_flow_collections',
' where collection_name = ''WS_INPUT_ITEMS'''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique los nombres y etiquetas de los elementos creados bas\00E1ndose en los par\00E1metros de entrada de este servicio.</p>'),
unistr('<p>Para incluir un elemento, seleccione <strong>S\00ED</strong> en la columna Crear. De lo contrario, seleccione <strong>No</strong>. Si es necesario, edite la etiqueta del elemento.</p>')))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34477729869171606.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34477802880171609.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34477911465171609.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34478021180171609.4001)
,p_query_column_id=>4
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34478119515171610.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34478221520171610.4001)
,p_query_column_id=>6
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34478312348171610.4001)
,p_query_column_id=>7
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>7
,p_column_heading=>'Crear'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34478606505171611.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204759821999209352.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34479705207171630.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204759821999209352.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34480101031171636.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204759821999209352.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34480319447171637.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204759821999209352.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34481619425171645.4001)
,p_branch_action=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34480101031171636.4001)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34481818026171646.4001)
,p_branch_action=>'f?p=&FLOW_ID.:882:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34480101031171636.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34482016916171646.4001)
,p_branch_action=>'f?p=&FLOW_ID.:705:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34480319447171637.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549740346539954504.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(34479705207171630.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549740495150954505.4001)
,p_event_id=>wwv_flow_api.id(549740346539954504.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34480701279171641.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_INPUT_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34480921974171643.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_OPERATION_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_INPUT_ITEMS'',',
'        p_query           => ''select a.id, decode(a.input_or_output,''''I'''',a.name,''''header:''''||a.name) name, a.parm_type,',
'''''P''''||:pg_id||''''_''''||upper(a.name), initcap(a.name), ''''Y'''' yes_no from wwv_flow_ws_parameters a where a.input_or_output in (''''I'''',''''H'''') and a.ws_opers_id = :op_id order by a.input_or_output, a.id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34481300212171644.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate auth item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''ws_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_WS_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_AUTH_ITEMS'',',
'        p_query           => ''select a.id, decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), wwv_flow_lang.system_message(''''AUTHENTICATION''''),',
'''''P''''||:pg_id||''''_''''||upper(decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name)), decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTRO'
||'L_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), ''''Y'''' y_or_n from wwv_flow_ws_parameters a, wwv_flow_ws_operations b, wwv_flow_shared_web_services c where input_or_output = ''''A'''' and a.ws_opers_id = b.id and b.ws_id = c'
||'.id and c.id = :ws_id order by a.name desc'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00881
begin
wwv_flow_api.create_page(
 p_id=>881.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Utilidades de Rama'
,p_step_title=>'Utilidades de Rama'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194563519648908050.4001)
,p_plug_name=>'Utilidades'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194563731774908053.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(11286824340344465.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194564102318908056.4001)
,p_plug_name=>'Utilidades de Rama'
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(655568879441187677.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(194565421168929524.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_00882
begin
wwv_flow_api.create_page(
 p_id=>882.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Pantalla e Informes Basados en Servicio Web: Par\00E1metros de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla e Informe Basados en Servicio Web'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34485231095302983.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(30094110886480012.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34485806393302986.4001)
,p_name=>unistr('Par\00E1metros de Resultado a Mostrar')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; min-width:600px;"'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''F4000.P765.SELECT_PARAM'',name)||''"'',:P882_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where input_or_output = ''O''',
'   and ws_opers_id = :P700_OPERATION_ID and :P700_OUTPUT_TYPE != ''json'''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione los par\00E1metros que se van a incluir en el informe. Para seleccionar o anular la selecci\00F3n de todos los par\00E1metros, active la casilla de control de la cabecera de columna.</p>'),
unistr('<p>Para la respuesta JSON, solo necesita proporcionar el nombre de la recopilaci\00F3n para almacenar la respuesta.</p>'),
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn par\00E1metro de salida o la respuesta es JSON.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34486004340302986.4001)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34486130346302986.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34486205013302986.4001)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204761317974217569.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34486803108302987.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204761317974217569.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34487225180302988.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204761317974217569.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34487428901302989.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204761317974217569.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34489613335302999.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:735:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34487225180302988.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34490020741303000.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34487225180302988.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34489412567302999.4001)
,p_branch_name=>'Go To Page 880'
,p_branch_action=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34487428901302989.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34488128291302991.4001)
,p_name=>'P882_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34485806393302986.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34510115867651363.4001)
,p_name=>'P882_COLLECTION'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(34485806393302986.4001)
,p_prompt=>unistr('Almacenar Resultados en Recopilaci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''P''||:P705_PAGE_ID||''_''||upper(name)||''_RESULTS''',
'  from wwv_flow_ws_operations',
' where id = :P700_OPERATION_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca el nombre del juego de resultados temporal en el que se almacenar\00E1 el documento. El juego de resultados temporal se almacena en una recopilaci\00F3n de &PRODUCT_NAME. en la columna CLOB001 con el nombre proporcionado aqu\00ED.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34488405250302992.4001)
,p_computation_sequence=>10
,p_computation_item=>'P882_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(34488609457302993.4001)
,p_validation_name=>'P882_CHECKED_ITEMS'
,p_validation_sequence=>10
,p_validation=>'P882_CHECKED_ITEMS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe realizar un informe de al menos un par\00E1metro.')
,p_validation_condition=>':REQUEST in (''NEXT'',''FINISH'') and :P700_OUTPUT_TYPE != ''json'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(34488128291302991.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549740177861954502.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(34486803108302987.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549740213192954503.4001)
,p_event_id=>wwv_flow_api.id(549740177861954502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157780444509618649.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(34485806393302986.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157780569612618650.4001)
,p_event_id=>wwv_flow_api.id(1157780444509618649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34488716382302996.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00883
begin
wwv_flow_api.create_page(
 p_id=>883.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Validaciones Condicionales'
,p_step_title=>'Validaciones Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194569012468949016.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194569206617949017.4001)
,p_plug_name=>unistr('Condiciones de Validaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>97
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, VALIDATION_NAME, ',
'validation_condition_type,',
'VALIDATION_CONDITION,',
'VALIDATION_CONDITION2,',
'id',
'from WWV_FLOW_STEP_VALIDATIONS',
'where FLOW_ID = :fb_flow_id and ',
'validation_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194569432715949018.4001)
,p_name=>'Validation Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194569509084949019.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194569610218949020.4001)
,p_db_column_name=>'VALIDATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Validaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5510:#ID#'
,p_column_linktext=>'#VALIDATION_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194569730953949020.4001)
,p_db_column_name=>'VALIDATION_CONDITION_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194569803078949021.4001)
,p_db_column_name=>'VALIDATION_CONDITION'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194569912944949026.4001)
,p_db_column_name=>'VALIDATION_CONDITION2'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100576178415284419.4001)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194570526842949031.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194569206617949017.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:883:&SESSION.::&DEBUG.:883,RIR::'
);
end;
/
prompt --application/pages/page_00884
begin
wwv_flow_api.create_page(
 p_id=>884.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla Basada en Servicio Web'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla Basada en Servicio Web'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(34891102262899031.4001)
,p_name=>unistr('Elementos para Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(1, seq_id)||wwv_flow_item.hidden(2, c001)||wwv_flow_item.display_and_save(3, c002) name,',
'       wwv_flow_item.display_and_save(4, c003) parm_type, ',
'       wwv_flow_item.text(5, c004) item_name,',
'       wwv_flow_item.text(6, c005) item_label,',
'       wwv_flow_item.select_list_from_lov(7, c006, ''YES_NO_RETURNS_Y_OR_N'', null, ''NO'') include',
'  from wwv_flow_collections',
' where collection_name  = ''WS_INPUT_ITEMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34891521288899054.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34891610471899057.4001)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34891723443899057.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34891800425899057.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(34891902533899057.4001)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>5
,p_column_heading=>'Crear'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34915405860878596.4001)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15577802944637145.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204727225911992852.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(268298157596420325.4001)
,p_name=>unistr('Elementos para Par\00E1metros de Salida')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(11, seq_id)||wwv_flow_item.hidden(12, c001)||wwv_flow_item.display_and_save(13, c002) name,',
'       wwv_flow_item.display_and_save(14, c003) parm_type, ',
'       wwv_flow_item.text(15, c004) item_name,',
'       wwv_flow_item.text(16, c005) item_label,',
'       wwv_flow_item.select_list_from_lov(17, c006, ''YES_NO_RETURNS_Y_OR_N'', null, ''NO'') include',
'  from wwv_flow_collections',
' where collection_name = ''WS_OUTPUT_ITEMS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P600_WEB_REF_TYPE != ''REST'' then',
'    for c1 in (select null',
'               from wwv_flow_collections',
'               where collection_name = ''WS_OUTPUT_ITEMS'')',
'    loop',
'        return true;',
'    end loop;',
'end if;',
'return false;'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'FUNCTION_BODY'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(268298473151420328.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(268298586757420329.4001)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Tipo de Par\00E1metro')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(268298693922420330.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(268298735433420331.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(268298833957420332.4001)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>5
,p_column_heading=>'Incluir'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(280276082609341849.4001)
,p_name=>unistr('Elementos para Par\00E1metros de Salida')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(11, seq_id)||wwv_flow_item.hidden(12, c001)||wwv_flow_item.display_and_save(13, c002) name,',
'       wwv_flow_item.display_and_save(14, c003) parm_type, ',
'       wwv_flow_item.text(15, c004) item_name,',
'       wwv_flow_item.text(16, c005) item_label,',
'       wwv_flow_item.select_list_from_lov(17, c006, ''YES_NO_RETURNS_Y_OR_N'', null, ''NO'') include',
'  from wwv_flow_collections',
' where collection_name = ''WS_OUTPUT_ITEMS'' and :P600_OUTPUT_TYPE != ''json'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P600_WEB_REF_TYPE = ''REST'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'FUNCTION_BODY'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(294925590197882202.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(294925683313882203.4001)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(294925768210882204.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(294925801426882205.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(294925960428882206.4001)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>5
,p_column_heading=>'Crear'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1136581154856333616.4001)
,p_name=>unistr('Autenticaci\00F3n B\00E1sica')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(21, seq_id)||wwv_flow_item.hidden(22, c001)||wwv_flow_item.display_and_save(23, c002) name,',
'       wwv_flow_item.display_and_save(24, c003) parm_type, ',
'       wwv_flow_item.text(25, c004) item_name,',
'       wwv_flow_item.text(26, c005)||wwv_flow_item.hidden(27, c006) item_label',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1136581418880333619.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1136581598760333620.4001)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1136581613488333621.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1136581751402333622.4001)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta de Elemento'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34893116988899072.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204727225911992852.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34893314547899076.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204727225911992852.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(34893523090899076.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204727225911992852.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(34894431684899086.4001)
,p_branch_action=>'f?p=&APP_ID.:703:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34893314547899076.4001)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(294926495695882211.4001)
,p_branch_name=>'Go To Page 600'
,p_branch_action=>'f?p=&APP_ID.:600:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(34893523090899076.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(294926113400882208.4001)
,p_name=>'P884_RESPONSE_COLLECTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(280276082609341849.4001)
,p_prompt=>unistr('Recopilaci\00F3n de Respuestas')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_display_when=>'P600_OUTPUT_TYPE'
,p_display_when2=>'json'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la recopilaci\00F3n para la respuesta.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(927693726038718450.4001)
,p_validation_name=>'P884_RESPONSE_COLLECTION not null'
,p_validation_sequence=>10
,p_validation=>'P884_RESPONSE_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'( :P600_WEB_REF_TYPE = ''REST'' ) and ( :P600_OUTPUT_TYPE = ''json'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(34893314547899076.4001)
,p_associated_item=>wwv_flow_api.id(294926113400882208.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1150182203403222902.4001)
,p_validation_name=>'array input items, cannot create form'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if WSDL, and contain same item name multiple times, this is array input item, raise validation',
'if :P600_WEB_REF_TYPE = ''NEW_SCHOOL'' then',
'    for c1 in (select count(*), c004',
'                 from wwv_flow_collections',
'                where collection_name = ''WS_INPUT_ITEMS''',
'                group by c004',
'               having count(*) > 1 )',
'    loop',
'        return false;',
'    end loop;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Los par\00E1metros de entrada de este servicio necesitan un tipo de matriz que no se puede representar creando elementos. No podr\00E1 utilizar el asistente para crear una pantalla en esta referencia de servicio Web.')
,p_when_button_pressed=>wwv_flow_api.id(34893314547899076.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549718717859753348.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(34893116988899072.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549718847088753349.4001)
,p_event_id=>wwv_flow_api.id(549718717859753348.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34893710601899078.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update input collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_INPUT_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_INPUT_ITEMS'''))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(617313606364937247.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update output collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_OUTPUT_ITEMS'',',
'  p_seq            => wwv_flow.g_f11,',
'  p_c001           => wwv_flow.g_f12,',
'  p_c002           => wwv_flow.g_f13,',
'  p_c003           => wwv_flow.g_f14,',
'  p_c004           => wwv_flow.g_f15,',
'  p_c005           => wwv_flow.g_f16,',
'  p_c006           => wwv_flow.g_f17 );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_OUTPUT_ITEMS'''))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1127760386939483961.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update auth collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_AUTH_ITEMS'',',
'  p_seq                  => wwv_flow.g_f21,',
'  p_c001                 => wwv_flow.g_f22,',
'  p_c002                 => wwv_flow.g_f23,',
'  p_c003                 => wwv_flow.g_f24,',
'  p_c004                 => wwv_flow.g_f25,',
'  p_c005                 => wwv_flow.g_f26,',
'  p_c006                 => wwv_flow.g_f27 );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1124190601999405685.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create form on ws'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_wizard_api.create_form_on_ws (',
'    p_flow_id                 => :FB_FLOW_ID,',
'    p_page_id                 => :P605_PAGE_ID,',
'    p_ws_id                   => :P600_WS_ID,',
'    p_operation_id            => :P600_OPERATION_ID,',
'    p_page_name               => :P605_PAGE_NAME,',
'    p_group_name              => :P605_GROUP_NAME,',
'    p_page_mode               => :P605_PAGE_MODE,',
'    p_user_interface_id       => :P259_USER_INTERFACE_ID,',
'    --',
'    p_tab_set                 => null,',
'    p_tab_name                => null,',
'    p_tab_text                => null,',
'    --',
'    p_region_title            => :P605_REGION_NAME,',
'    p_region_template         => :P605_REGION_TEMPLATE,    ',
'    p_inputs_collection       => ''WS_INPUT_ITEMS'',',
'    p_outputs_collection      => ''WS_OUTPUT_ITEMS'',',
'    p_auth_collection         => ''WS_AUTH_ITEMS'',',
'    p_report_collection_name  => :P884_RESPONSE_COLLECTION );',
'',
'  :fb_flow_page_id := :P605_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(34893314547899076.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1124191265052409526.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumb'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :P605_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P605_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => nvl(:P605_BREADCRUMB_NAME, :P605_PAGE_NAME),',
'        p_parent_breadcrumb_entry_id => :P605_BREADCRUMB_PARENT_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(34893314547899076.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1124190961199408020.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(34893314547899076.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34893913175899083.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection if REST'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_OPERATION_ID;',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'    p_collection_name => ''WS_INPUT_ITEMS'',',
'    p_query           => ''select a.id, decode(a.input_or_output,''''I'''',a.name,''''header:''''||a.name) name, a.parm_type,',
'''''P''''||:pg_id||''''_''''||upper(a.name), initcap(a.name), ''''Y'''' yes_no from wwv_flow_ws_parameters a where a.input_or_output in (''''I'''',''''H'''') and a.ws_opers_id = :op_id order by a.input_or_output, a.id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P600_WEB_REF_TYPE = ''REST'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(268297830369420322.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection if  WSDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_OPERATION_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_INPUT_ITEMS'',',
'        p_query           => ''select id, name, parm_type,',
'''''P''''||:pg_id||''''_''''||upper(name), initcap(name), ''''Y'''' y_or_n from wwv_flow_ws_parameters where input_or_output in (''''I'''',''''H'''') and type_is_xsd = ''''Y'''' and ws_opers_id = :op_id order by input_or_output, id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P600_WEB_REF_TYPE = ''NEW_SCHOOL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(268297988331420323.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection if  Manual'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob  clob;',
'    l_off   number := 1;',
'    l_pos   number := 0;',
'    l_name  varchar2(4000);',
'    l_item_name varchar2(4000);',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''WS_INPUT_ITEMS'');',
'',
'    for c1 in (select flow_items_comma_delimited',
'                 from wwv_flow_shared_web_services',
'                where id = :P600_WS_ID ) loop',
'        l_clob := c1.flow_items_comma_delimited;',
'    end loop;',
'',
'    l_pos   := sys.dbms_lob.instr(l_clob,'','',1);',
'',
'    if l_pos = 0 then --there are no commas at all',
'        if sys.dbms_lob.getlength(l_clob) > 0 then',
'            l_name := sys.dbms_lob.substr(l_clob,sys.dbms_lob.getlength(l_clob),1);',
'            l_item_name := ''P''||:P605_PAGE_ID||''_''||l_name;',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_item_name ),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'        end if;',
'    else',
'        loop',
'            exit when l_pos = 0;',
'',
'            l_name := sys.dbms_lob.substr(l_clob,l_pos-l_off,l_off);',
'            l_item_name := ''P''||:P605_PAGE_ID||''_''||l_name;',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_item_name ),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'            l_off := l_pos + 1;',
'            l_pos := sys.dbms_lob.instr(l_clob,'','',l_off);',
'        end loop;',
'        --need to get the last one',
'        l_name := sys.dbms_lob.substr(l_clob,4000,l_off);',
'        l_item_name := ''P''||:P605_PAGE_ID||''_''||l_name;',
'        wwv_flow_collection.add_member(',
'            p_collection_name   => ''WS_INPUT_ITEMS'',',
'            p_c001              => ''MANUAL'',',
'            p_c002              => l_name,',
'            p_c003              => ''string'',',
'            p_c004              => upper(l_item_name),',
'            p_c005              => initcap(l_name),',
'            p_c006              => ''Y'' );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P600_WEB_REF_TYPE = ''MANUAL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34894117033899083.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate auth item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''ws_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_WS_ID;',
'    ',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_AUTH_ITEMS'',',
'        p_query           => ''select a.id, decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), wwv_flow_lang.system_message(''''AUTHENTICATION''''),',
'''''P''''||:pg_id||''''_''''||upper(decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name)), decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTRO'
||'L_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), ''''Y'''' y_or_n from wwv_flow_ws_parameters a, wwv_flow_ws_operations b, wwv_flow_shared_web_services c where input_or_output = ''''A'''' and a.ws_opers_id = b.id and b.ws_id = c'
||'.id and c.id = :ws_id order by a.name desc'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(280275959156341848.4001)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate outputs collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_OPERATION_ID;',
'   ',
'	if :P600_WEB_REF_TYPE = ''REST'' then',
'		wwv_flow_collection.create_collection_from_query_b(',
'			p_collection_name => ''WS_OUTPUT_ITEMS'',',
'			p_query           => ''select id, name, parm_type,',
'	''''P''''||:pg_id||''''_''''||upper(name), initcap(name), ''''Y'''' y_or_n from wwv_flow_ws_parameters where input_or_output = ''''O'''' and ws_opers_id = :op_id and parm_type!= ''''json'''''',',
'		p_names           => n,',
'		p_values          => v);',
'    else',
'		wwv_flow_collection.create_collection_from_query_b(',
'			p_collection_name => ''WS_OUTPUT_ITEMS'',',
'			p_query           => ''select id, name, parm_type,',
'	''''P''''||:pg_id||''''_''''||upper(name), initcap(name), ''''Y'''' y_or_n from wwv_flow_ws_parameters where input_or_output = ''''O'''' and type_is_xsd = ''''Y'''' and ws_opers_id = :op_id'',',
'		p_names           => n,',
'		p_values          => v);	',
'	end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_OUTPUT_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
null;
end;
/
prompt --application/pages/page_00885
begin
wwv_flow_api.create_page(
 p_id=>885.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Ramas Condicionales'
,p_step_title=>'Ramas Condicionales'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194579329745010939.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(11286824340344465.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194582805564026135.4001)
,p_plug_name=>unistr('Condiciones de Bifurcaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, BRANCH_POINT, ',
'       BRANCH_TYPE, ',
'       BRANCH_SEQUENCE,',
'       branch_name,',
'BRANCH_CONDITION_TYPE,',
'BRANCH_CONDITION,',
'BRANCH_CONDITION_TEXT,',
'id',
'from WWV_FLOW_STEP_BRANCHES',
'where FLOW_ID = :fb_flow_id and',
'branch_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(194582923422026135.4001)
,p_name=>'Branch Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583115017026136.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583219719026137.4001)
,p_db_column_name=>'BRANCH_POINT'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Punto de Bifurcaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583315654026138.4001)
,p_db_column_name=>'BRANCH_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Tipo de Bifurcaci\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583427780026139.4001)
,p_db_column_name=>'BRANCH_SEQUENCE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Secuencia'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_SEQUENCE#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583528981026140.4001)
,p_db_column_name=>'BRANCH_CONDITION_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Tipo de Condici\00F3n')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583603591026141.4001)
,p_db_column_name=>'BRANCH_CONDITION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Expresi\00F3n 1')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(194583726392026141.4001)
,p_db_column_name=>'BRANCH_CONDITION_TEXT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Expresi\00F3n 2')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(16751417190389279.4001)
,p_db_column_name=>'BRANCH_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Nombre de la sucursal'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100576721324284425.4001)
,p_db_column_name=>'ID'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(194579700694010940.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(194582805564026135.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:885:&SESSION.::&DEBUG.:885,RIR::'
);
end;
/
prompt --application/pages/page_00887
begin
wwv_flow_api.create_page(
 p_id=>887.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Objetos de Soporte: Agregar Objeto de Base de Datos'
,p_page_mode=>'MODAL'
,p_step_title=>'Objetos de Soporte: Agregar Objeto de Base de Datos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24897722063538624)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537841333876118535.4001)
,p_plug_name=>'Agregar Objeto de Base de Datos'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537842656900118548.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(616090510052666313.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(537842656900118548.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(616091084340716088.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(537842656900118548.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Agregar Objeto'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537841474050118536.4001)
,p_name=>'P887_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(537841333876118535.4001)
,p_prompt=>'Propietario de Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica al propietario del objeto de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537841565766118537.4001)
,p_name=>'P887_OBJECT_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(537841333876118535.4001)
,p_prompt=>'Tipo de Objeto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct object_type d, object_type r',
'  from sys.dba_objects',
' where object_type in (''FUNCTION'',''INDEX'',''PACKAGE'',''PROCEDURE'',''SEQUENCE'',''SYNONYM'',''TABLE'',''TRIGGER'',''VIEW'',''DATABASE LINK'',''TYPE'',''MATERIALIZED VIEW'')',
'   and owner = :P887_OBJECT_OWNER',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Tipo de Objeto --'
,p_cSize=>64
,p_cHeight=>1
,p_read_only_when=>'P865_SCRIPT_OPTION'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tipo de objeto de la lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537841651115118538.4001)
,p_name=>'P887_OBJECT_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(537841333876118535.4001)
,p_prompt=>'Nombre del Objeto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'  from sys.dba_objects a',
' where object_name not like ''SYS_%''',
'   and object_name not like ''APEX$_%''',
'   and owner = :P887_OBJECT_OWNER',
'   and object_type = :P887_OBJECT_TYPE',
'   and not exists (select 1',
'                     from wwv_flow_collections',
'                    where collection_name = ''INSTALL_OBJECTS''',
'                      and c002 = :P887_OBJECT_OWNER',
'                      and c003 = :P887_OBJECT_TYPE',
'                      and c004 = a.object_name',
'                      and nvl(c005,''0'') <> ''1'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar Objeto --'
,p_lov_cascade_parent_items=>'P887_OBJECT_TYPE'
,p_ajax_items_to_submit=>'P887_OBJECT_OWNER,P887_OBJECT_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un objeto de la lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(621102498116076421.4001)
,p_computation_sequence=>10
,p_computation_item=>'P887_OBJECT_TYPE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if instr(:P865_SCRIPT_OPTION,''PACKAGE'') = 1 then',
'    return ''PACKAGE'';',
'elsif :P865_SCRIPT_OPTION = ''TABLE'' then',
'    return ''TABLE'';',
'else',
'    return null;',
'end if;'))
,p_compute_when=>'P865_SCRIPT_OPTION'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(537842288189118544.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(616090510052666313.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537842345883118545.4001)
,p_event_id=>wwv_flow_api.id(537842288189118544.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537841985859118541.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add object to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'    l_clob_arr    wwv_flow.clob_arr;',
'    l_object_types varchar2(32767);',
'    l_objects     varchar2(32767);',
'begin',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_OBJECTS'',',
'        p_c001            => ''1'',',
'        p_c002            => :P887_OBJECT_OWNER,',
'        p_c003            => :P887_OBJECT_TYPE,',
'        p_c004            => :P887_OBJECT_NAME );',
'    ',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'',
'    for c1 in (select distinct c003 object_type',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')= ''0'' ) loop',
'        l_object_types := l_object_types||c1.object_type||'':'';',
'    end loop;',
'    for c1 in (select c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''0'' ) loop',
'        l_objects := l_objects||c1.object_name||'':'';',
'    end loop;',
'    ',
'    if nvl(:P865_SCRIPT_OPTION,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'        l_object_types := :P865_SCRIPT_OPTION;',
'    elsif nvl(:P865_SCRIPT_OPTION,''x'') = ''TABLE'' then',
'        l_object_types := ''TABLE_RELATED'';        ',
'    else',
'        l_object_types := rtrim(l_object_types,'':'');',
'    end if;        ',
'',
'    l_clob_arr := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                      p_schema      => :P865_OBJECT_OWNER,',
'                      p_object_type => l_object_types,',
'                      p_objects     => rtrim(l_objects,'':''));',
'',
'    for i in 1..l_clob_arr.count loop',
'        l_code := l_code || l_clob_arr(i)||chr(10)||chr(10);',
'    end loop;',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'                ',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(616091084340716088.4001)
,p_process_success_message=>'Los objetos se han agregado al script.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(621033740192190310.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(616091084340716088.4001)
);
end;
/
prompt --application/pages/page_00888
begin
wwv_flow_api.create_page(
 p_id=>888.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Mensajes de Texto: Edici\00F3n de Cuadr\00EDculas')
,p_step_title=>unistr('Mensajes de Texto: Edici\00F3n de Cuadr\00EDculas')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2703891551095236.4001)
,p_plug_name=>unistr('Mensajes de texto de edici\00F3n de cuadr\00EDculas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MESSAGES$'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Mensajes de texto de edici\00F3n de cuadr\00EDcula')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2704054272095238.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2704251449095240.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Mensaje'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>unistr('Introduzca un nombre \00FAnico para el mensaje que va a crear.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2704318157095241.4001)
,p_name=>'MESSAGE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MESSAGE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Idioma'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
,p_is_required=>true
,p_max_length=>50
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(107899321117195063)
,p_lov_display_extra=>true
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>unistr('Seleccione el idioma para el que se utilizar\00E1 este mensaje.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2704487822095242.4001)
,p_name=>'MESSAGE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MESSAGE_TEXT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Texto'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el texto que se va a devolver al llamar a este mensaje de texto.</p>',
'<p>Ejemplo: Impuestos: %0 Importe Total %1',
'</p>'))
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2704599582095243.4001)
,p_name=>'IS_JS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_JS_MESSAGE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Utilizado en JavaScript'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(84259319526460470)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>unistr('Seleccione <strong>S\00ED</strong> si el mensaje se utiliza en llamadas de API <code>apex.lang.*</code> en c\00F3digo JavaScript.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2705188388095249.4001)
,p_name=>'MESSAGE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MESSAGE_COMMENT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2705213737095250.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4900475857688501.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4900989608688506.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Aplicaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(138126827261)
,p_lov_display_extra=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'&FB_FLOW_ID.'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(2703954144095237.4001)
,p_internal_uid=>2703954144095237
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4901514894688512.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(2703891551095236.4001)
,p_validation_name=>'NAME must be unique within app'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where upper(NAME)      = upper(:NAME)',
'   and message_language = :MESSAGE_LANGUAGE',
'   and flow_id          = :FB_FLOW_ID',
'   -- while updating ignore current row',
'   -- while inseting consider all rows',
'   and (id != :ID or :ID is null)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre del mensaje debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4900597564688502.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(2703891551095236.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Grid Edit Text Messages - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han guardado los cambios en los mensajes de texto.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4901611953688513.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(2703891551095236.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Calculate IS_JS_MESSAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_js_message wwv_flow_messages$.is_js_message%type;',
'begin',
'    -- check if the name matches with one of the APEX system messages,',
'    -- in that case we use the same is_js_message setting because the',
'    -- developer just wants provide a different text message in their app.',
'    select is_js_message',
'      into l_is_js_message',
'      from wwv_flow_messages$',
'     where flow_id = 4411',
'       and name    = :NAME;',
'',
'    :IS_JS_MESSAGE := l_is_js_message;',
'exception when no_data_found then ',
'    -- do nothing',
'    null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'FB_FLOW_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'4411'
,p_exec_cond_for_each_row=>'Y'
);
end;
/
prompt --application/pages/page_00889
begin
wwv_flow_api.create_page(
 p_id=>889.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Diccionario de Atributos'
,p_step_title=>'Diccionario de Atributos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253941101711283063.4001)
,p_plug_name=>'Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede utilizar las definiciones de elementos de p\00E1gina y de columnas de informe para actualizar el diccionario de atributos. Tambi\00E9n puede utilizar el diccionario de atributos para actualizar los elementos de p\00E1gina y las columnas de informe.</p>'),
'',
unistr('<p>Los objetos ocultos, los que se encuentren en regiones ocultas y los elementos de bot\00F3n, no se incluyen en el n\00FAmero de elementos y columnas de informe candidatos, ya que no se utilizan en las actualizaciones.</p>'),
'',
unistr('<p>Seleccione la p\00E1gina con la que desee trabajar.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253961620789367687.4001)
,p_plug_name=>unistr('Seleccionar P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   id,',
'   the_flow,',
'   name,',
'   updated,',
'   last_updated_by,',
'   created_on,',
'   nvl(group_name,sm.t_unassigned) group_name,',
'   decode(PAGE_COMPONENT_MAP,',
'         ''01'',sm.apex_tabular_form,',
'         ''02'',sm.apex_form,',
'         ''03'',sm.apex_report,',
'         ''04'',sm.apex_chart,',
'         ''05'',sm.apex_web_service,',
'         ''06'',sm.apex_nav_page,',
'         ''07'',sm.apex_tree,',
'         ''08'',sm.apex_calendar,',
'         ''09'',''URL'',',
'         ''10'',sm.apex_dynamic_html,',
'         ''11'',sm.apex_static_html,',
'         ''12'',sm.apex_login,',
'         ''13'',sm.apex_home,',
'         ''14'',sm.apex_zero,',
'         ''15'',sm.apex_empty_page,',
'         ''16'',sm.apex_dynamic_form,',
'         ''17'',sm.apex_wizard_form,',
'         ''18'',sm.apex_interactive_rpt,',
'         ''19'',sm.apex_map,',
'         ''20'',sm.apex_jstree,',
'         ''21'',sm.apex_ig,',
'         ''unknown'') page_type,',
'   alias,',
'   page_title,',
'   nbr_items,',
'   nbr_report_cols',
'from (',
'select ',
'   p.id,',
'   p.flow_id the_flow,',
'   name,',
'   last_updated_on updated,',
'   lower(last_updated_by) last_updated_by,',
'   created_on,',
'   g.group_name,',
'   PAGE_COMPONENT_MAP,',
'   alias,',
'   step_title page_title,',
'   (select count(*) ',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs r',
'     where nvl(i.display_when_type,''disp'') != ''NEVER''',
'       and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'       and i.security_group_id  = :flow_security_group_id',
'       and i.flow_id            = p.flow_id ',
'       and i.flow_step_id       = p.id',
'       and i.item_plug_id       = r.id  ',
'       and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = p.flow_id ',
'       and r.page_id            = p.id) nbr_items,',
'   (select count(*) ',
'      from wwv_flow_region_report_column rc,',
'           wwv_flow_page_plugs r',
'     where rc.hidden_column = ''N''',
'       and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'       and rc.security_group_id = :flow_security_group_id',
'       and rc.flow_id           = p.flow_id ',
'       and rc.region_id         = r.id',
'       and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = p.flow_id ',
'       and r.page_id            = p.id',
'       and substr(rc.column_alias,1,6) != ''CHECK$''',
'       and substr(rc.column_alias,1,5) != ''LINK$''',
'       and substr(rc.column_alias,1,8) != ''DERIVED$'') +',
'      (select count(*) ',
'         from wwv_flow_worksheet_columns wc,',
'              wwv_flow_worksheets w,',
'              wwv_flow_page_plugs r',
'        where nvl(wc.display_text_as,''disp'') != ''HIDDEN''',
'          and wc.security_group_id = :flow_security_group_id',
'          and wc.flow_id           = p.flow_id ',
'          and wc.worksheet_id      = w.id',
'          and w.security_group_id  = :flow_security_group_id',
'          and w.flow_id            = p.flow_id',
'          and w.page_id            = p.id',
'          and w.region_id          = r.id',
'          and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'          and r.security_group_id  = :flow_security_group_id',
'          and r.flow_id            = p.flow_id ',
'          and r.page_id            = p.id) nbr_report_cols',
'from  wwv_flow_steps p,',
'      WWV_FLOW_PAGE_GROUPS g',
'where p.flow_id = :fb_flow_id and',
'      p.security_group_id = :flow_security_group_id and',
'      p.group_id = g.id (+)',
'),',
'(select wwv_flow_lang.system_message(''REPORT'') apex_report,',
'        wwv_flow_lang.system_message(''DML_FORM'') apex_form,',
'        wwv_flow_lang.system_message(''WEB_SERVICE'') apex_web_service,',
'        wwv_flow_lang.system_message(''F4000_CHART'') apex_chart,',
'        wwv_flow_lang.system_message(''F4000_HELP_TEXT'') apex_help_page,',
'        wwv_flow_lang.system_message(''Dynamic HTML'') apex_dynamic_html,',
'        wwv_flow_lang.system_message(''STATIC_HTML'') apex_static_html,',
'        wwv_flow_lang.system_message(''HTML'') apex_html,',
'        wwv_flow_lang.system_message(''F4000_TREE'') apex_tree,',
'        wwv_flow_lang.system_message(''TABULAR_FORM'') apex_tabular_form,',
'        wwv_flow_lang.system_message(''LEGACY_CALENDAR'') apex_calendar,',
'        wwv_flow_lang.system_message(''LOGIN'') apex_login,',
'        wwv_flow_lang.system_message(''HOME'') apex_home,',
'        wwv_flow_lang.system_message(''GLOBAL_PAGE'') apex_zero,',
'        wwv_flow_lang.system_message(''EMPTY_PAGE'') apex_empty_page,',
'        wwv_flow_lang.system_message(''NAVIGATION_PAGE'') apex_nav_page,',
'        wwv_flow_lang.system_message(''DYNAMIC_FORM'') apex_dynamic_form,',
'        wwv_flow_lang.system_message(''APEX_WIZARD_FORM'') apex_wizard_form,',
'        wwv_flow_lang.system_message(''LAYOUT.MAP'') apex_map,',
'        wwv_flow_lang.system_message(''INTERACTIVE_REPORT'') apex_interactive_rpt,',
'        wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'        wwv_flow_lang.system_message(''F4000_TREE'') apex_jstree,',
'        wwv_flow_lang.system_message(''REGION_NAME.NATIVE_IG'') apex_ig',
'   from dual) sm'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(253961723059367687.4001)
,p_name=>'Select Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962024170367721.4001)
,p_db_column_name=>'THE_FLOW'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Flujo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253961902109367715.4001)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:912:FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962129492367722.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962217597367722.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962332108367723.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962427376367724.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962528841367725.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Nombre de Grupo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962620482367726.4001)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Tipo de P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962712422367730.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253962818123367731.4001)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('T\00EDtulo de P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(428474402993209453.4001)
,p_db_column_name=>'NBR_ITEMS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Elementos Mostrados'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(428474532345209455.4001)
,p_db_column_name=>'NBR_REPORT_COLS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Columnas de Informe Visualizadas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261840224876814137.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253961620789367687.4001)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:889:&SESSION.::&DEBUG.:889,RIR::'
);
end;
/
prompt --application/pages/page_00890
begin
wwv_flow_api.create_page(
 p_id=>890.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Elementos en Uso'
,p_step_title=>'Actualizar Utilizando Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253942829341283227.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(254039201964848724.4001)
,p_name=>'Matched Items'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1,i.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       i.id i_id, ',
'       i.name i_name, ',
'       i.prompt i_label,',
'       case when length(h.help_text) > 20',
'             then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                  '':::908:P908_DISPLAY,P908_ID:IH,''||i.id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(h.help_text,1,20))||''...</a>''',
'              else wwv_flow_escape.html(h.help_text)',
'              end i_help_text,',
'       i.format_mask i_format_mask,',
'       case when length(i.item_default) > 20',
'            then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ID,''||i.id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(i.item_default,1,20))||''...</a>''',
'            else wwv_flow_escape.html(i.item_default)',
'            end i_default,',
'       --',
'       i.format_mask i_format_mask2,',
'       i.cSize i_width,',
'       i.cHeight i_height,',
'       i.data_type i_data_type,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(ad.help_text,1,20))||''...</a>''',
'            else ad.help_text',
'            end c_help_text,',
'       ad.format_mask c_format_mask,',
'       case when length(ad.default_value) > 20',
'            then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADD,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(ad.default_value,1,20))||''...</a>''',
'            else ad.default_value',
'            end c_default_value,',
'       --',
'       ad.form_format_mask c_form_format_mask,',
'       ad.form_display_width c_form_display_width,',
'       ad.form_display_height c_form_display_height,',
'       ad.form_data_type c_form_data_type,',
'       --',
'       case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end check_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''UI_DEF_CUSTOM_ITEM_TYPE'') ct,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'               from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and ((nvl(i.prompt,''0'') != nvl(ad.label,''0'') and',
'         i.prompt != ad.label||'':'') or',
'        nvl(h.help_text,''0'')    != nvl(ad.help_text,''0'') or',
'        nvl(i.format_mask,''0'')  != nvl(ad.format_mask,''0'') or',
'        nvl(i.item_default,''0'') != nvl(ad.default_value,''0'') or',
'        nvl(i.format_mask,''0'')  != nvl(ad.form_format_mask,''0'') or',
'        nvl(i.cSize,0)          != nvl(ad.form_display_width,0) or',
'        nvl(i.cHeight,0)        != nvl(ad.form_display_height,0) or',
'        nvl(i.data_type,''0'')    != nvl(ad.form_data_type,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254122310940324272.4001)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046313271918161.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Origen'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046418881918162.4001)
,p_query_column_id=>3
,p_column_alias=>'I_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046506609918162.4001)
,p_query_column_id=>4
,p_column_alias=>'I_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046630409918162.4001)
,p_query_column_id=>5
,p_column_alias=>'I_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046728112918162.4001)
,p_query_column_id=>6
,p_column_alias=>'I_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Texto de Ayuda'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046828135918162.4001)
,p_query_column_id=>7
,p_column_alias=>'I_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara de Formato General')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254046902461918162.4001)
,p_query_column_id=>8
,p_column_alias=>'I_DEFAULT'
,p_column_display_sequence=>9
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257323504601517587.4001)
,p_query_column_id=>9
,p_column_alias=>'I_FORMAT_MASK2'
,p_column_display_sequence=>8
,p_column_heading=>unistr('M\00E1scara de Formato de Pantalla')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047101494918162.4001)
,p_query_column_id=>10
,p_column_alias=>'I_WIDTH'
,p_column_display_sequence=>10
,p_column_heading=>'Ancho'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047326056918163.4001)
,p_query_column_id=>11
,p_column_alias=>'I_HEIGHT'
,p_column_display_sequence=>11
,p_column_heading=>'Altura'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047428210918163.4001)
,p_query_column_id=>12
,p_column_alias=>'I_DATA_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Tipo de Dato'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(256978025494631439.4001)
,p_query_column_id=>13
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>14
,p_column_heading=>'From Ad'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047529834918163.4001)
,p_query_column_id=>14
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047607544918163.4001)
,p_query_column_id=>15
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>15
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047710364918163.4001)
,p_query_column_id=>16
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>16
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047827634918163.4001)
,p_query_column_id=>17
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>17
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254047916575918163.4001)
,p_query_column_id=>18
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>18
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254048015613918163.4001)
,p_query_column_id=>19
,p_column_alias=>'C_DEFAULT_VALUE'
,p_column_display_sequence=>20
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254048210852918163.4001)
,p_query_column_id=>20
,p_column_alias=>'C_FORM_FORMAT_MASK'
,p_column_display_sequence=>19
,p_column_heading=>'Form Format Mask'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254048321608918163.4001)
,p_query_column_id=>21
,p_column_alias=>'C_FORM_DISPLAY_WIDTH'
,p_column_display_sequence=>21
,p_column_heading=>'Form Display Width'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254048411206918163.4001)
,p_query_column_id=>22
,p_column_alias=>'C_FORM_DISPLAY_HEIGHT'
,p_column_display_sequence=>22
,p_column_heading=>'Form Display Height'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254048507566918163.4001)
,p_query_column_id=>23
,p_column_alias=>'C_FORM_DATA_TYPE'
,p_column_display_sequence=>23
,p_column_heading=>'Form Data Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(254041728575848753.4001)
,p_query_column_id=>24
,p_column_alias=>'CHECK_NAME'
,p_column_display_sequence=>24
,p_column_heading=>'Check Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(428479909619589784.4001)
,p_name=>'Elementos igual que las entradas del diccionario de atributos'
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.id, i.name item_name, ads.syn_name attr_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and (nvl(i.prompt,''0'') = nvl(ad.label,''0'') or',
'        i.prompt = ad.label||'':'')',
'   and nvl(h.help_text,''0'')    = nvl(ad.help_text,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.format_mask,''0'')',
'   and nvl(i.item_default,''0'') = nvl(ad.default_value,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.form_format_mask,''0'')',
'   and nvl(i.cSize,0)          = nvl(ad.form_display_width,0)',
'   and nvl(i.cHeight,0)        = nvl(ad.form_display_height,0)',
'   and nvl(i.data_type,''0'')    = nvl(ad.form_data_type,''0'')',
'order by i.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428480231173589796.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428480412174599939.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428480509176599939.4001)
,p_query_column_id=>3
,p_column_alias=>'ATTR_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Coincidencias'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445249911176766283.4001)
,p_plug_name=>'Actualizar Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los elementos especificados coincidieron con columnas existentes en el diccionario de atributos. Seleccione las que desee actualizar e indique qu\00E9 atributos desea incluir en la actualizaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452543506210546710.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253943415250283229.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253942829341283227.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(258528808540645263.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(253942829341283227.4001)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Diccionario de Atributos'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(258529016347645266.4001)
,p_branch_action=>'f?p=&APP_ID.:890:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253943203971283228.4001)
,p_name=>'P890_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(253942829341283227.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257364716984540128.4001)
,p_name=>'P890_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(253942829341283227.4001)
,p_item_default=>'label:help_text:gen_format_mask:form_format_mask:default:width:height:data_type'
,p_prompt=>unistr('Incluir en Actualizaci\00F3n:')
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Form Format Mask;form_format_mask,Default;default,Width;width,Height;height,Data Type;data_type'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione los atributos que desea incluir en la actualizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(260798009855616314.4001)
,p_validation_name=>'P890_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P890_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar los atributos que incluir en la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(258528808540645263.4001)
,p_associated_item=>wwv_flow_api.id(257364716984540128.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(258529820791658234.4001)
,p_validation_name=>'must select items to update'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos un elemento que actualizar.'
,p_when_button_pressed=>wwv_flow_api.id(258528808540645263.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(258533930282746140.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma      number;',
'   l_item_id    number;',
'   l_column_id  number;',
'begin',
'   for i in 1..apex_application.g_f01.count loop',
'',
'      l_comma     := instr(apex_application.g_f01(i),'','');',
'      l_item_id   := substr(apex_application.g_f01(i),1,l_comma-1);',
'      l_column_id := substr(apex_application.g_f01(i),l_comma+1);',
'',
'      wwv_flow_hint.update_ad_from_items(',
'         p_application_id  => :FB_FLOW_ID,',
'         p_page_id         => :P890_PAGE_ID,',
'         p_item_id         => l_item_id,',
'         p_column_id       => l_column_id,',
'         p_attr_to_include => :P890_INCLUDE_IN_UPDATE );',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al actualizar el diccionario de atributos.'
,p_process_when_button_id=>wwv_flow_api.id(258528808540645263.4001)
,p_process_success_message=>'Diccionario de Atributos Actualizado.'
);
end;
/
prompt --application/pages/page_00891
begin
wwv_flow_api.create_page(
 p_id=>891.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Repositorio de Traducci\00F3n: Edici\00F3n de Cuadr\00EDculas')
,p_step_title=>unistr('Repositorio de Traducci\00F3n: Edici\00F3n de Cuadr\00EDculas')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4348306845399378538.4001)
,p_plug_name=>unistr('Repositorio de Traducci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
't.id,',
't.id id_display,',
't.translated_flow_id,',
't.page_id,',
't.translate_to_lang_code,',
't.translate_from_text,',
'c.column_description,',
't.translate_to_text,',
't.last_updated_by,',
't.last_updated_on,',
't.created_by,',
't.created_on,',
'sys.dbms_lob.substr(t.translate_to_text,255,1) translate_to_text_partial,',
'sys.dbms_lob.substr(t.translate_from_text,255,1) translate_from_text_partial,',
'case when ',
'    sys.dbms_lob.compare(t.translate_to_text,t.translate_from_text) != 0',
'    or nvl(length(t.translate_from_text),0) != nvl(length(t.translate_to_text),0) then ''Y''',
'    else ''N''',
'end translated       ',
' from wwv_flow_translatable_text$ t, ',
'      wwv_flow_translatable_cols$ c',
'where t.translate_from_flow_table = c.table_name',
'  and t.translate_from_flow_column = c.column_name',
'  and (c.template_translatable = ''N'' or (c.template_translatable = ''Y'' and t.template_translatable = ''Y''))',
'  and t.flow_id = :fb_flow_id ',
'  and t.security_group_id = :flow_security_group_id '))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(389678680891049101.4001)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Creado'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(389678770692049102.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(389678874688049103.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(953242540514873702.4001)
,p_name=>'TRANSLATED'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATED'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Traducido'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(84259319526460470)
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(953242610794873703.4001)
,p_name=>'TRANSLATE_TO_TEXT_PARTIAL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_TO_TEXT_PARTIAL'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Traducir a (parcial)'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(953242759959873704.4001)
,p_name=>'TRANSLATE_FROM_TEXT_PARTIAL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_FROM_TEXT_PARTIAL'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Traducir de (parcial)'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307025263378540.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307168452378541.4001)
,p_name=>'ID_DISPLAY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID_DISPLAY'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307284563378542.4001)
,p_name=>'TRANSLATED_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATED_FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Aplicaci\00F3n Traducida')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307373339378543.4001)
,p_name=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307475401378544.4001)
,p_name=>'TRANSLATE_TO_LANG_CODE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_TO_LANG_CODE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Idioma'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307588297378545.4001)
,p_name=>'TRANSLATE_FROM_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_FROM_TEXT'
,p_data_type=>'CLOB'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Traducir de'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307659878378546.4001)
,p_name=>'COLUMN_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_DESCRIPTION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Descripci\00F3n de Columna')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307785032378547.4001)
,p_name=>'TRANSLATE_TO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_TO_TEXT'
,p_data_type=>'CLOB'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Traducir a'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>32767
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307812335378548.4001)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Actualizado por'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348307906013378549.4001)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Actualizado'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4348308041362378550.4001)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Creado por'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(4348306932996378539.4001)
,p_internal_uid=>4348306932996378539
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>true
,p_download_formats=>'HTML'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(389678984963049104.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(4348306845399378538.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Translation Repository - Save Interactive Grid Data'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    if :apex$row_status = ''U'' then',
'        update wwv_flow_translatable_text$',
'           set translate_to_text = :translate_to_text',
'         where id = :id',
'           and flow_id = :fb_flow_id',
'           and security_group_id = :flow_security_group_id;',
'    end if;',
'end;       '))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00892
begin
wwv_flow_api.create_page(
 p_id=>892.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Columnas de Selecci\00F3n de Vistas de Application Express')
,p_step_title=>unistr('Columnas de Selecci\00F3n de Vistas de Application Express')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(200467223102537626)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200466231975530694.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(200452609222306546.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200466404055532100.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200772019591558371.4001)
,p_plug_name=>'Seleccionar Columnas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698583694744530519.4001)
,p_plug_name=>'Comentarios de la Columna'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>140
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200457126484365515.4001)
,p_plug_name=>'Informe de Comentarios de Columna'
,p_parent_plug_id=>wwv_flow_api.id(698583694744530519.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COLUMN_ID,',
'       COLUMN_NAME,',
'       COMMENTS',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_name is not null'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(200457204682365515.4001)
,p_name=>'Application Express View Columns'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200457426539365553.4001)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Nombre de Columna'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200457522278365554.4001)
,p_db_column_name=>'COMMENTS'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Comentarios'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200478202755816974.4001)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Orden de Visualizaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200815329006740821.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200466404055532100.4001)
,p_button_name=>'VIEWS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Vistas'
,p_button_position=>'CREATE'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200555600938881336.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200466404055532100.4001)
,p_button_name=>'FILTER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Filtro'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200663028586485267.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(200466404055532100.4001)
,p_button_name=>'RESULTS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Resultados'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(955890280061997313.4001)
,p_branch_name=>'Go to 714'
,p_branch_action=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200815329006740821.4001)
,p_branch_sequence=>1
,p_branch_condition_type=>'ITEM_IS_NULL'
,p_branch_condition=>'P892_LAST_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(955890345867997314.4001)
,p_branch_name=>'Go to P892_LAST_PAGE'
,p_branch_action=>'P892_LAST_PAGE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_when_button_id=>wwv_flow_api.id(200815329006740821.4001)
,p_branch_sequence=>5
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P892_LAST_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200555827926881337.4001)
,p_branch_action=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200555600938881336.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200663203074485268.4001)
,p_branch_name=>'Go To Page 896'
,p_branch_action=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200663028586485267.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200458414988374478.4001)
,p_name=>'P892_VIEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200466404055532100.4001)
,p_prompt=>'Vista Seleccionada:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Vista seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200569807958940111.4001)
,p_name=>'P892_SELECTED_COLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(200772019591558371.4001)
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_cHeight=>25
,p_tag_attributes=>'style="width:300px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique las columnas que desea incluir en los resultados.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(955890094181997311.4001)
,p_name=>'P892_LAST_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(200466404055532100.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(200774700029590598.4001)
,p_computation_sequence=>10
,p_computation_item=>'P892_SELECTED_COLS'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r varchar2(4000) := null;',
'  c pls_integer := 0;',
'begin',
'for c1 in (',
'   select column_name ',
'     from apex_dictionary ',
'    where apex_view_name = nvl(:P892_VIEW_NAME,''APEX_APPLICATIONS'')',
'    order by column_id) loop',
'  c := c + 1;',
'  if c > 6 then ',
'     exit; ',
'  end if;',
'  r := r||c1.column_name||'':'';',
'end loop;',
'return ltrim(rtrim(r,'':''),'':'');',
'end;'))
,p_compute_when=>'P892_SELECTED_COLS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200776630897627867.4001)
,p_validation_name=>'P892_SELECTED_COLS'
,p_validation_sequence=>10
,p_validation=>'P892_SELECTED_COLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe seleccionar al menos una columna para mostrar.'
,p_validation_condition=>'FILTER,RESULTS'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(200569807958940111.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00893
begin
wwv_flow_api.create_page(
 p_id=>893.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Filtro de Vistas de Application Express'
,p_step_title=>'Filtro de Vistas de Application Express'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(200467223102537626)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200557704370886862.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(200452609222306546.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200557901291886867.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200631913713282323.4001)
,p_plug_name=>'Filtro'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>127
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200816003988752540.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200557901291886867.4001)
,p_button_name=>'COLUMNS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Columnas'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200558324809886868.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(200557901291886867.4001)
,p_button_name=>'RESULTS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Resultados'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200560301814886921.4001)
,p_branch_action=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(200558324809886868.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200558511959886868.4001)
,p_name=>'P893_VIEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200557901291886867.4001)
,p_prompt=>'Vista Seleccionada:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Vista seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200633632330306659.4001)
,p_name=>'P893_COL_01'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Columna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la columna que se utilizar\00E1 en el filtro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200633828011306660.4001)
,p_name=>'P893_CONDITION_01'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>unistr('Condici\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(200640422229340739.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la condici\00F3n que se utilizar\00E1 en el filtro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200634013014306661.4001)
,p_name=>'P893_VALUE_01'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Valor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un valor que se utilizar\00E1 en el filtro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200634225519306661.4001)
,p_name=>'P893_COL_02'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Columna 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200634431529306662.4001)
,p_name=>'P893_CONDITION_02'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>unistr('Condici\00F3n 2')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(200640422229340739.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200634608093306662.4001)
,p_name=>'P893_VALUE_02'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Valor 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200634823684306663.4001)
,p_name=>'P893_COL_03'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Columna 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200635000831306663.4001)
,p_name=>'P893_CONDITION_03'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>unistr('Condici\00F3n 3')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(200640422229340739.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200635219093306664.4001)
,p_name=>'P893_VALUE_03'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Valor 3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200635406697306664.4001)
,p_name=>'P893_COL_04'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Columna 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200635632272306665.4001)
,p_name=>'P893_CONDITION_04'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>unistr('Condici\00F3n 4')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(200640422229340739.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200635818857306665.4001)
,p_name=>'P893_VALUE_04'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(200631913713282323.4001)
,p_prompt=>'Valor 4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(721523065500207302.4001)
,p_name=>'Condition 1 IS NULL / IS NOT NULL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_01'
,p_condition_element=>'P893_CONDITION_01'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721523183251207303.4001)
,p_event_id=>wwv_flow_api.id(721523065500207302.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_01'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721523293616207304.4001)
,p_event_id=>wwv_flow_api.id(721523065500207302.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_01'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721524741232207319.4001)
,p_event_id=>wwv_flow_api.id(721523065500207302.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_01'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(721523306160207305.4001)
,p_name=>'Condition 2 IS NULL / IS NOT NULL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_02'
,p_condition_element=>'P893_CONDITION_02'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721523454047207306.4001)
,p_event_id=>wwv_flow_api.id(721523306160207305.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_02'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721523538820207307.4001)
,p_event_id=>wwv_flow_api.id(721523306160207305.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_02'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721524624208207318.4001)
,p_event_id=>wwv_flow_api.id(721523306160207305.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_02'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(721524154181207313.4001)
,p_name=>'Condition 4 IS NULL / IS NOT NULL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_04'
,p_condition_element=>'P893_CONDITION_04'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721524205971207314.4001)
,p_event_id=>wwv_flow_api.id(721524154181207313.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_04'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721524308433207315.4001)
,p_event_id=>wwv_flow_api.id(721524154181207313.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_04'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721524415971207316.4001)
,p_event_id=>wwv_flow_api.id(721524154181207313.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_04'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(721523691415207308.4001)
,p_name=>'Condition 3 IS NULL / IS NOT NULL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_03'
,p_condition_element=>'P893_CONDITION_03'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721523754414207309.4001)
,p_event_id=>wwv_flow_api.id(721523691415207308.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_03'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721523870918207310.4001)
,p_event_id=>wwv_flow_api.id(721523691415207308.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_03'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(721524514164207317.4001)
,p_event_id=>wwv_flow_api.id(721523691415207308.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_03'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00896
begin
wwv_flow_api.create_page(
 p_id=>896.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Resultados de Vistas de Application Express'
,p_step_title=>'Resultados de Vistas de Application Express'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(200467223102537626)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200566111015923801.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(200452609222306546.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200566321249923802.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(200581025544039760.4001)
,p_name=>'Resultados'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q         varchar2(32767);',
'    l_first   boolean := true;  ',
'    l_columns wwv_flow_t_varchar2;',
'',
'    function assert_valid_condition( p_condition in varchar2 ) return varchar2',
'    is ',
'    begin',
'        if p_condition is null or p_condition in (''>'', ''<'', ''='', ''!='', ''LIKE'', ''NOT LIKE'', ''IS NULL'', ''IS NOT NULL'') then',
'            return p_condition;',
'        else',
'            wwv_flow_error.raise_internal_error( p_error_code => ''WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'' );',
'        end if;',
'    end assert_valid_condition;',
'',
'    procedure add_filter( p_filter in number )',
'    is',
'        l_cond varchar2(255) := assert_valid_condition( v( ''P893_CONDITION_0'' || p_filter ) );',
'        l_col  varchar2(255) := replace(v( ''P893_COL_0'' || p_filter ),''%''||''null%'',null);',
'    begin',
'        if l_col is not null and l_cond is not null then',
'            q := q || '' '' ',
'                   || case when l_first then ''where'' else ''and'' end',
'                   || '' '' ',
'                   || wwv_flow_assert.enquote_name( l_col )',
'                   || '' ''',
'                   || l_cond',
'                   || case when l_cond not in (''IS NULL'', ''IS NOT NULL'') then  '' :P893_VALUE_0'' || p_filter end;',
'                   ',
'            l_first := false;',
'        end if;',
'    end add_filter;',
'    ',
'    function do_escape( p_string in varchar2 ) return varchar2 ',
'    is',
'    begin',
'        return '''''''' || replace( p_string, '''''''', '''''''''''') || '''''''';',
'    end do_escape;',
'begin',
'    wwv_flow_sw_api.check_priv(:G_PARSE_AS_SCHEMA_OVERRIDE);',
'    l_columns := wwv_flow_string.split( nvl( :P892_SELECTED_COLS, ''WORKSPACE'' ), '':'' );',
'    wwv_flow_preferences.reset_sort_preference(p_page_id => :APP_PAGE_ID);',
'  ',
'    q:= ''select '';',
'    for i in 1 .. l_columns.count loop',
'        q := q || case when i > 1 then '','' end || wwv_flow_assert.enquote_name( l_columns( i ) );',
'    end loop;',
'    q := q || '' from ''|| wwv_flow_assert.enquote_name( nvl(:P892_VIEW_NAME,''APEX_WORKSPACES'') );',
'      ',
'    for f in 1 .. 4 loop',
'        add_filter( f );',
'    end loop;',
'    ',
'    :P896_QUERY := replace(replace(replace(replace(replace(replace(replace( ',
'                        q, ',
'                        '':P893_VALUE_01'', do_escape( :P893_VALUE_01 ) ),',
'                        '':P893_VALUE_02'', do_escape( :P893_VALUE_02 ) ),',
'                        '':P893_VALUE_03'', do_escape( :P893_VALUE_03 ) ),',
'                        '':P893_VALUE_04'', do_escape( :P893_VALUE_04 ) ),',
'                        '' from '',wwv_flow.LF||''  from ''),',
'                        '' where '',wwv_flow.LF||'' where ''),',
'                        '' and '',wwv_flow.LF||''   and '');',
'    return q;',
'end;',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>25
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_exp_filename=>'meta.csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'G_PARSE_AS_SCHEMA_OVERRIDE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583004335052558.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583118948052560.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583229060052560.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583327418052560.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583420810052561.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583507478052561.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583606861052561.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583732705052561.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583816253052561.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200583902410052561.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584013856052561.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584128460052561.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584223786052561.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584307407052561.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584418638052561.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584517833052561.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584601952052561.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584718965052561.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584813594052561.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200584925686052561.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585002797052562.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585131778052562.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585223134052562.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585304675052562.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585412836052562.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585509108052562.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585625980052562.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585702761052562.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585818864052562.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200585905530052562.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586023944052562.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586101322052562.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586214937052562.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586323245052562.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586414515052562.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586529034052562.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586610966052563.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586718739052563.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586801402052563.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200586926221052563.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587021396052563.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587101398052563.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587229713052563.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587332082052563.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587428870052563.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587518273052563.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587619466052563.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587705647052563.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587832429052563.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200587932156052563.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588006730052563.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588116717052563.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588211305052564.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588311432052564.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588409006052564.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588519334052564.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588612161052564.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588709502052564.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588825849052564.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(200588909565052564.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(200591119142075800.4001)
,p_plug_name=>'Consulta'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>140
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200816419572757053.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(200566321249923802.4001)
,p_button_name=>'FILTER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Filtro'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200566911694923803.4001)
,p_name=>'P896_VIEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(200566321249923802.4001)
,p_prompt=>'Vista Seleccionada:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Vista seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200591704728081053.4001)
,p_name=>'P896_QUERY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(200591119142075800.4001)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'style="white-space:pre;"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3692064821539.4001)
,p_computation_sequence=>10
,p_computation_item=>'G_PARSE_AS_SCHEMA_OVERRIDE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'     l_owner varchar2(100);',
'begin',
'    if :FB_FLOW_ID is not null then',
'        for c1 in (select owner',
'                     from wwv_flows',
'                    where id = :FB_FLOW_ID',
'                      and security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'            l_owner := c1.owner;',
'            exit;',
'        end loop;        ',
'    else',
'        for c1 in (select first_schema_provisioned',
'                     from wwv_flow_companies',
'                    where provisioning_company_id = :FLOW_SECURITY_GROUP_ID) loop',
'            --',
'            for c2 in (select schema ',
'                         from wwv_flow_company_schemas',
'                        where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                          and schema = c1.first_schema_provisioned) loop',
'                l_owner := c2.schema;',
'                exit;',
'            end loop;',
'        end loop;',
'        --  If null, use the first one found',
'        if l_owner is null then',
'            for c3 in (select schema',
'                         from wwv_flow_company_schemas',
'                        where security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'                l_owner := c3.schema;',
'                exit;',
'            end loop;',
'        end if;',
'    end if;',
'    --',
'    return l_owner;',
'end;'))
);
end;
/
prompt --application/pages/page_00897
begin
wwv_flow_api.create_page(
 p_id=>897.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Uso de Columnas de Informe'
,p_step_title=>'Actualizar Uso de Columnas de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253945008978283231.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(257015121469989867.4001)
,p_name=>'Matched Report Columns'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1,''CR,''||rc.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.column_alias rc_name, ',
'       rc.column_heading  rc_label,',
'       null rc_help_text,',
'       rc.column_format rc_format_mask,',
'       --',
'       rc.column_format rc_format_mask2,',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(ad.help_text,1,20))||''...</a>''',
'            else wwv_flow_escape.html(ad.help_text)',
'            end c_help_text,',
'       ad.format_mask c_format_mask,',
'       --',
'       ad.report_format_mask c_report_format_mask,',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.column_heading,''0'')   != nvl(ad.label,''0'') or',
'        nvl(rc.column_format,''0'')    != nvl(ad.format_mask,''0'') or',
'        nvl(rc.column_format,''0'')    != nvl(ad.report_format_mask,''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )',
'union all',
'select apex_item.checkbox(1,''IR,''||rc.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.db_column_name rc_name, ',
'       rc.report_label rc_label,',
'       case when length(rc.help_text) > 20',
'            then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:IRH,''||rc.id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(rc.help_text,1,20))||''...</a>''',
'            else wwv_flow_escape.html(rc.help_text)',
'            end rc_help_text,',
'       rc.format_mask rc_format_mask,',
'       --',
'       rc.format_mask rc_format_mask2,',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then ''<a href="''||apex_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||substr(ad.help_text,1,20)||''...</a>''',
'            else wwv_flow_escape.html(ad.help_text)',
'            end c_help_text,',
'       ad.format_mask c_format_mask,',
'       --',
'       ad.report_format_mask c_report_format_mask,',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.report_label,''0'')     != nvl(ad.label,''0'') or',
'        nvl(rc.help_text,''0'')        != nvl(ad.help_text,''0'') or',
'        nvl(rc.format_mask,''0'')      != nvl(ad.format_mask,''0'') or',
'        nvl(rc.format_mask,''0'')      != nvl(ad.report_format_mask,''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No se ha encontrado ninguna columna de informe.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257015424276989878.4001)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257015521337989878.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Origen'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257015603409989878.4001)
,p_query_column_id=>3
,p_column_alias=>'RC_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257015700651989878.4001)
,p_query_column_id=>4
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257015823462989878.4001)
,p_query_column_id=>5
,p_column_alias=>'RC_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(259744228997628451.4001)
,p_query_column_id=>6
,p_column_alias=>'RC_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Texto de Ayuda'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257015914224989878.4001)
,p_query_column_id=>7
,p_column_alias=>'RC_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara de Formato')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257106420607377518.4001)
,p_query_column_id=>8
,p_column_alias=>'RC_FORMAT_MASK2'
,p_column_display_sequence=>8
,p_column_heading=>unistr('M\00E1scara de Formato de Informe')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016003282989878.4001)
,p_query_column_id=>9
,p_column_alias=>'RC_REPORT_COL_ALIGN'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Alineaci\00F3n de Columna de Informe')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016132556989878.4001)
,p_query_column_id=>10
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016220959989878.4001)
,p_query_column_id=>11
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016311340989878.4001)
,p_query_column_id=>12
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016431008989878.4001)
,p_query_column_id=>13
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(259744709520641753.4001)
,p_query_column_id=>14
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>14
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016514865989878.4001)
,p_query_column_id=>15
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016610912989878.4001)
,p_query_column_id=>16
,p_column_alias=>'C_REPORT_FORMAT_MASK'
,p_column_display_sequence=>16
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257016722281989878.4001)
,p_query_column_id=>17
,p_column_alias=>'C_REPORT_COL_ALIGN'
,p_column_display_sequence=>17
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(428491506165664497.4001)
,p_name=>'Columnas de informe igual que las entradas del diccionario de atributos'
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.plug_name region_name,',
'       rc.column_alias rc_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.column_heading,''0'')   = nvl(ad.label,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.format_mask,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ',
'union all',
'select r.plug_name region_name,',
'       rc.db_column_name rc_name',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     = ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.report_label,''0'')     = nvl(ad.label,''0'')',
'   and nvl(rc.help_text,''0'')        = nvl(ad.help_text,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.format_mask,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'')',
'order by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna columna de informe.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428491801147664504.4001)
,p_query_column_id=>1
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428491924749664504.4001)
,p_query_column_id=>2
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Columna de Informe'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445211916568256935.4001)
,p_plug_name=>'Actualizar Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las columnas de informe especificadas coincidieron con columnas existentes del diccionario de atributos. Seleccione las que desee actualizar e indique qu\00E9 atributos desea incluir en la actualizaci\00F3n.</p>'),
'',
unistr('<p>Nota: El texto de ayuda s\00F3lo est\00E1 disponible dentro de informes interactivos. Si la actualizaci\00F3n se basa en un informe est\00E1ndar, no se utilizar\00E1 el texto de ayuda.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452546030629591591.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253945624067283234.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253945008978283231.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259739808640528044.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(253945008978283231.4001)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Diccionario de Atributos'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(259740018696528045.4001)
,p_branch_action=>'f?p=&APP_ID.:897:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257013416218884204.4001)
,p_name=>'P897_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(253945008978283231.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257416719109572214.4001)
,p_name=>'P897_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(253945008978283231.4001)
,p_item_default=>'label:help_text:gen_format_mask:rep_format_mask:rep_col_align'
,p_prompt=>unistr('Incluir en Actualizaci\00F3n:')
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Report Format Mask;rep_format_mask,Report Column Alignment;rep_col_align'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Seleccione los atributos que se van a actualizar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(260799525917630412.4001)
,p_validation_name=>'P897_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P897_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar los atributos que incluir en la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(259739808640528044.4001)
,p_associated_item=>wwv_flow_api.id(257416719109572214.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(259740218337530765.4001)
,p_validation_name=>'must select rc to update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos una columna del informe para actualizar.'
,p_when_button_pressed=>wwv_flow_api.id(259739808640528044.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(259740423185532187.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma2     number;',
'   l_rc_type    varchar2(2);',
'   l_rc_id      number;',
'   l_column_id  number;',
'begin',
'   for i in 1..apex_application.g_f01.count loop',
'',
'      l_comma2    := instr(apex_application.g_f01(i),'','',1,2);',
'      l_rc_type   := substr(apex_application.g_f01(i),1,2);',
'      l_rc_id     := substr(apex_application.g_f01(i),4,l_comma2-4);',
'      l_column_id := substr(apex_application.g_f01(i),l_comma2+1);',
'',
'      if l_rc_type = ''CR'' then',
'         wwv_flow_hint.update_ad_from_cr(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P897_INCLUDE_IN_UPDATE );',
'      elsif l_rc_type = ''IR'' then',
'         wwv_flow_hint.update_ad_from_ir(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P897_INCLUDE_IN_UPDATE );',
'      end if;',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al actualizar el diccionario de atributos.'
,p_process_when_button_id=>wwv_flow_api.id(259739808640528044.4001)
,p_process_success_message=>'Diccionario de Atributos Actualizado.'
);
end;
/
prompt --application/pages/page_00901
begin
wwv_flow_api.create_page(
 p_id=>901.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Regi\00F3n: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47958532317857477.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106483721658234044.4001)
,p_plug_name=>unistr('Crear Plantilla de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106508709951315405.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106521705986341929.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47958532317857477.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106523917414345199.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47958532317857477.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19616211009686641.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47958532317857477.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177239400549919148.4001)
,p_branch_action=>'4320'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(106523917414345199.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P901_REGION_TEMPLATES'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(106554600554471715.4001)
,p_branch_action=>'902'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(106523917414345199.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P901_REGION_TEMPLATES'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589946940004621414.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19616211009686641.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106486023371248399.4001)
,p_name=>'F4000_P901_REGION_TEMPLATES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(106483721658234044.4001)
,p_item_default=>'COPY'
,p_prompt=>unistr('Crear Plantilla de Regi\00F3n:')
,p_source=>'COPY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REGION_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_api.id(86595203201245715.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>La creaci\00F3n de plantillas a partir del repositorio de plantillas es una forma r\00E1pida de crear una plantilla nueva. Una vez creada la plantilla desde el repositorio, puede editarla para adaptarla a sus necesidades concretas. La creaci\00F3n de una plan')
||unistr('tilla nueva requiere la codificaci\00F3n de toda la plantilla.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(106698729574838080.4001)
,p_validation_name=>'TYPE'
,p_validation_sequence=>10
,p_validation=>'F4000_P901_REGION_TEMPLATES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la plantilla de regi\00F3n.')
,p_validation_condition=>'CANCEL'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(106486023371248399.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589946769794621412.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(106521705986341929.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589946864777621413.4001)
,p_event_id=>wwv_flow_api.id(589946769794621412.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(106721729297914206.4001)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'901:902:903:904'
,p_process_when_button_id=>wwv_flow_api.id(106521705986341929.4001)
);
end;
/
prompt --application/pages/page_00902
begin
wwv_flow_api.create_page(
 p_id=>902.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Regi\00F3n: Confirmar')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47963414187918518.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106539127080459471.4001)
,p_plug_name=>unistr('Crear Plantilla de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('No se ha encontrado ninguna plantilla de p\00E1gina.')
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(106540621904461810.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106642203907691435.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47963414187918518.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106647404038700884.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47963414187918518.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_cattributes=>'tabindex="1"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(106644818799695705.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47963414187918518.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(93460221326014992.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589947279002621417.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(106644818799695705.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98321416048032372.4001)
,p_name=>'P902_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(106539127080459471.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el nuevo nombre de la plantilla de regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100010309599039923.4001)
,p_name=>'P902_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(106539127080459471.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100084329338045600.4001)
,p_name=>'P902_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(106539127080459471.4001)
,p_prompt=>'Clase de Plantilla'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(42003622222572861.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(100085504189047811.4001)
,p_validation_name=>'P902_NAME'
,p_validation_sequence=>10
,p_validation=>'P902_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(106647404038700884.4001)
,p_associated_item=>wwv_flow_api.id(98321416048032372.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(100087811808050032.4001)
,p_validation_name=>'P902_THEME'
,p_validation_sequence=>20
,p_validation=>'P902_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(106647404038700884.4001)
,p_associated_item=>wwv_flow_api.id(100010309599039923.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(100089119080052181.4001)
,p_validation_name=>'P902_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P902_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(106647404038700884.4001)
,p_associated_item=>wwv_flow_api.id(100084329338045600.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589947022714621415.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(106642203907691435.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589947198954621416.4001)
,p_event_id=>wwv_flow_api.id(589947022714621415.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(106971923719426285.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Region Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_api.create_plug_template (',
'    p_flow_id                   => :fb_flow_id,',
'    p_page_plug_template_name   => :p902_name,',
'    p_template                  => ''#TITLE#<br />#BODY#'',',
'    p_plug_table_bgcolor        => null,',
'    p_plug_heading_bgcolor      => null,',
'    p_plug_font_size            => null,',
'    p_template_comment          => null,',
'    p_theme_id                  => :p902_theme,',
'    p_theme_class_id            => :p902_theme_class)',
'    ;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al crear la plantilla.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(106647404038700884.4001)
,p_process_success_message=>'Plantilla creada.'
);
end;
/
prompt --application/pages/page_00905
begin
wwv_flow_api.create_page(
 p_id=>905.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Vistas de Application Express'
,p_step_title=>'Vistas de Application Express'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(200467223102537626)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201141632019659387.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(200452609222306546.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201141806523661513.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699077543075989890.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(815124700232755186.4001)
,p_plug_name=>'Tree'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'select',
' APEX_VIEW_NAME as title,',
' APEX_VIEW_NAME as value,',
' PARENT_VIEW as parent',
'from "APEX_DICTIONARY"',
'where column_id = 0',
') ',
'select case when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else                           -1',
'       end as status, ',
'       level, ',
'       title as title, ',
'       ''icon-tree-branch'' as icon, ',
'      value as value, ',
'       null as tooltip, ',
'       ''f?p=&APP_ID.:892:''||:APP_SESSION||',
'          ''::NO:892,893,896:P892_LAST_PAGE,P892_VIEW_NAME,P893_VIEW_NAME,P896_VIEW_NAME:905,''|| ',
'          value ||'',''|| value ||'',''|| value as link ',
'from data',
'start with value = :P905_TREE_ROOT',
'connect by prior value = parent',
'order siblings by value'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_translate_title=>'N'
,p_attribute_02=>'S'
,p_attribute_03=>'P892_VIEW_NAME'
,p_attribute_04=>'N'
,p_attribute_06=>'tree815124616117755186'
,p_attribute_07=>'APEX_TREE'
,p_attribute_10=>'"3"'
,p_attribute_11=>'"2"'
,p_attribute_12=>'"4"'
,p_attribute_15=>'"1"'
,p_attribute_20=>'"5"'
,p_attribute_22=>'"6"'
,p_attribute_23=>'LEVEL'
,p_attribute_24=>'"7"'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(955889910111997310.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('Las vistas de &PRODUCT_NAME. son vistas de diccionario de datos que muestran los metadatos para las aplicaciones. En las vistas de &PRODUCT_NAME. no solo puede ver la vista, sino tambi\00E9n los datos que contienen.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201139918369650754.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(201141806523661513.4001)
,p_button_name=>'COLLAPSE_ALL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Reducir Todo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.widget.tree.collapse_all(''tree815124616117755186'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201140103684650755.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(201141806523661513.4001)
,p_button_name=>'EXPAND_ALL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ampliar Todo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.widget.tree.expand_all(''tree815124616117755186'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(201140308965650755.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(201141806523661513.4001)
,p_button_name=>'RESET_TREE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Restablecer \00C1rbol')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:905::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(201140712491650757.4001)
,p_branch_action=>'f?p=&APP_ID.:905:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(201140511828650757.4001)
,p_name=>'P905_TREE_ROOT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(201141806523661513.4001)
,p_source=>'APEX_WORKSPACES'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00906
begin
wwv_flow_api.create_page(
 p_id=>906.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Diccionario de Atributos: Elementos'
,p_step_title=>'Actualizar Diccionario de Atributos: Elementos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253947226137283239.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(257003828835698634.4001)
,p_name=>'Unmatched Items'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1,i.id,''title="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.UPDATE'',wwv_flow_escape.html(i.name) )||''"'') chk,',
'       r.plug_name region_name,',
'       --',
'       i.id i_id, ',
'       i.name i_name, ',
'       i.prompt i_label,',
'       (select case when length(h.help_text) > 20',
'                    then wwv_flow_escape.html(substr(h.help_text,1,20))||',
'                         ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                         '':::908:P908_DISPLAY,P908_ID:IH,''||i.id||',
'                         '''''')" alt="''||wwv_flow_escape.html(m.v)||''" title="''||wwv_flow_escape.html(m.v)||''">...</a>''',
'                    else wwv_flow_escape.html(h.help_text)',
'                    end help_text',
'          from wwv_flow_step_item_help h',
'         where h.security_group_id  = :flow_security_group_id',
'           and h.flow_id      = :FB_FLOW_ID',
'           and h.flow_item_id = i.id ) i_help_text,',
'       i.format_mask i_format_mask,',
'       case when length(i.item_default) > 20',
'            then wwv_flow_escape.html(substr(i.item_default,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ID,''||i.id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v)||''" title="''||wwv_flow_escape.html(m.v)||''">...</a>''',
'            else wwv_flow_escape.html(i.item_default)',
'            end i_default,',
'       --',
'       i.cSize i_width,',
'       i.cHeight i_height,',
'       i.data_type i_data_type,',
'       --',
'       case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end check_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       (select wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''UI_DEF_CUSTOM_ITEM_TYPE'') ct',
'               from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end not in (select syn_name',
'                          from wwv_flow_hnt_col_dict_syn',
'                         where security_group_id  = :flow_security_group_id)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004129687698644.4001)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004209034698644.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004305134698644.4001)
,p_query_column_id=>3
,p_column_alias=>'I_ID'
,p_column_display_sequence=>3
,p_column_heading=>'I Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004402178698644.4001)
,p_query_column_id=>4
,p_column_alias=>'I_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Elemento'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004502899698644.4001)
,p_query_column_id=>5
,p_column_alias=>'I_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004609478698645.4001)
,p_query_column_id=>6
,p_column_alias=>'I_HELP_TEXT'
,p_column_display_sequence=>8
,p_column_heading=>'Texto de Ayuda'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004721485698645.4001)
,p_query_column_id=>7
,p_column_alias=>'I_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara de Formato')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257004823434698645.4001)
,p_query_column_id=>8
,p_column_alias=>'I_DEFAULT'
,p_column_display_sequence=>9
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257005008108698645.4001)
,p_query_column_id=>9
,p_column_alias=>'I_WIDTH'
,p_column_display_sequence=>10
,p_column_heading=>'Ancho'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257005111592698645.4001)
,p_query_column_id=>10
,p_column_alias=>'I_HEIGHT'
,p_column_display_sequence=>11
,p_column_heading=>'Altura'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257005228658698645.4001)
,p_query_column_id=>11
,p_column_alias=>'I_DATA_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Tipo de Dato'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257005314812698645.4001)
,p_query_column_id=>12
,p_column_alias=>'CHECK_NAME'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Pasar\00E1 a Ser')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(258512222599864074.4001)
,p_plug_name=>'Actualizar Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>124
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>unistr('<p>Los elementos especificados no coincidieron con columnas o sin\00F3nimos existentes en el diccionario de atributos. Seleccione los que desee agregar e indique los atributos que desea incluir.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452542626165543035.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253947802114283242.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253947226137283239.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253948107013283242.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(253947226137283239.4001)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Diccionario de Atributos'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253948005853283242.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(253947226137283239.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:890:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(253948706612283243.4001)
,p_branch_action=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(253948107013283242.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257005415114704150.4001)
,p_name=>'P906_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(253947226137283239.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(258512430132864079.4001)
,p_name=>'P906_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(253947226137283239.4001)
,p_item_default=>'label:help_text:gen_format_mask:default:form_format_mask:width:height:data_type'
,p_prompt=>unistr('Incluir en Actualizaci\00F3n:')
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Default;default,Form Format Mask;form_format_mask,Width;width,Height;height,Data Type;data_type'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Identifique los atributos que se van a utilizar en la inserci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(260798300290623018.4001)
,p_validation_name=>'P906_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P906_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar los atributos que incluir en la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(253948107013283242.4001)
,p_associated_item=>wwv_flow_api.id(258512430132864079.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(258534907734786941.4001)
,p_validation_name=>'must select items to insert'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos un elemento que agregar.'
,p_when_button_pressed=>wwv_flow_api.id(253948107013283242.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157779803542618643.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(257003828835698634.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157779965929618644.4001)
,p_event_id=>wwv_flow_api.id(1157779803542618643.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(258535216738789505.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Insert AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..apex_application.g_f01.count loop',
'   wwv_flow_hint.insert_ad_from_items (',
'      p_application_id  => :FB_FLOW_ID,',
'      p_page_id         => :P906_PAGE_ID,',
'      p_item_id         => apex_application.g_f01(i),',
'      p_attr_to_include => :P906_INCLUDE_IN_UPDATE );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al actualizar el diccionario de atributos.'
,p_process_when_button_id=>wwv_flow_api.id(253948107013283242.4001)
,p_process_success_message=>'Diccionario de Atributos Actualizado.'
);
end;
/
prompt --application/pages/page_00907
begin
wwv_flow_api.create_page(
 p_id=>907.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Diccionario de Atributos: Columnas de Informe'
,p_step_title=>'Actualizar Diccionario de Atributos: Columnas de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253949400671283244.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(257303313315274101.4001)
,p_name=>'Unmatched Report Columns'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1,''CR,''||rc.id,''title="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.UPDATE'',wwv_flow_escape.html(rc.column_alias) )||''"'') chk,',
'       r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.column_alias rc_name, ',
'       rc.column_heading rc_label,',
'       null rc_help_text,',
'       rc.column_format rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.u update_title',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       (select wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''CONFIRM.UPDATE_PROCESS'') u',
'          from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias not in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn',
'        where security_group_id  = :flow_security_group_id)',
'   and substr(rc.column_alias,1,6) != ''CHECK$''',
'   and substr(rc.column_alias,1,5) != ''LINK$''',
'   and substr(rc.column_alias,1,8) != ''DERIVED$''',
'union all',
'select apex_item.checkbox(1,''IR,''||rc.id,''title="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.UPDATE'',wwv_flow_escape.html(rc.db_column_name) )||''"'') chk,',
'       r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.db_column_name rc_name, ',
'       rc.report_label rc_label,',
'       case when length(rc.help_text) > 20',
'            then wwv_flow_escape.html(substr(rc.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:IRH,''||rc.id||',
'                 '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'            else rc.help_text',
'            end rc_help_text,',
'       rc.format_mask rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.u update_title',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       (select wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''CONFIRM.UPDATE_PROCESS'') u',
'          from dual) m',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name not in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn',
'        where security_group_id  = :flow_security_group_id)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna columna de informe.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257303606632274112.4001)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257303718577274112.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257303818094274112.4001)
,p_query_column_id=>3
,p_column_alias=>'RC_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257303926131274112.4001)
,p_query_column_id=>4
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257304013660274113.4001)
,p_query_column_id=>5
,p_column_alias=>'RC_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(260804702826831888.4001)
,p_query_column_id=>6
,p_column_alias=>'RC_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Texto de Ayuda'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257304125154274113.4001)
,p_query_column_id=>7
,p_column_alias=>'RC_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara de Formato')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(257304302138274113.4001)
,p_query_column_id=>8
,p_column_alias=>'RC_REPORT_COL_ALIGN'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Alineaci\00F3n de Columna de Informe')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(940659599516194137.4001)
,p_query_column_id=>9
,p_column_alias=>'UPDATE_TITLE'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445244432600744067.4001)
,p_plug_name=>'Actualizar Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las columnas de informe especificadas no coincidieron con columnas o sin\00F3nimos existentes del diccionario de atributos. Seleccione las que desee actualizar e indique qu\00E9 atributos desea incluir en la actualizaci\00F3n.</p>'),
'',
unistr('<p>Nota: El texto de ayuda s\00F3lo est\00E1 disponible dentro de informes interactivos. Si la actualizaci\00F3n se basa en un informe est\00E1ndar, no se utilizar\00E1 el texto de ayuda.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452545823357589521.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253950009857283249.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253949400671283244.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(253950306918283249.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(253949400671283244.4001)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Diccionario de Atributos'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(253950920121283250.4001)
,p_branch_action=>'f?p=&APP_ID.:907:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257127102936646731.4001)
,p_name=>'P907_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(253949400671283244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(258515324770921467.4001)
,p_name=>'P907_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(253949400671283244.4001)
,p_item_default=>'label:help_text:gen_format_mask:rep_format_mask:rep_col_align'
,p_prompt=>unistr('Incluir en Actualizaci\00F3n:')
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Report Format Mask;rep_format_mask,Report Column Alignment;rep_col_align'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Identifique los atributos que se van a utilizar en la inserci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(260804931569840181.4001)
,p_validation_name=>'P907_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>10
,p_validation=>'P907_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar los atributos que incluir en la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(253950306918283249.4001)
,p_associated_item=>wwv_flow_api.id(258515324770921467.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(260805318887846003.4001)
,p_validation_name=>'must select rc to update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos una columna del informe para actualizar.'
,p_when_button_pressed=>wwv_flow_api.id(253950306918283249.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157780090966618645.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(257303313315274101.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157780127656618646.4001)
,p_event_id=>wwv_flow_api.id(1157780090966618645.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(260805523043847181.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_rc_type    varchar2(2);',
'   l_rc_id      number;',
'begin',
'   for i in 1..apex_application.g_f01.count loop',
'',
'      l_rc_type   := substr(apex_application.g_f01(i),1,2);',
'      l_rc_id     := substr(apex_application.g_f01(i),4);',
'',
'      if l_rc_type = ''CR'' then',
'         wwv_flow_hint.insert_ad_from_cr(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_attr_to_include => :P907_INCLUDE_IN_UPDATE );',
'      elsif l_rc_type = ''IR'' then',
'         wwv_flow_hint.insert_ad_from_ir(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_attr_to_include => :P907_INCLUDE_IN_UPDATE );',
'      end if;',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al actualizar el diccionario de atributos.'
,p_process_when_button_id=>wwv_flow_api.id(253950306918283249.4001)
,p_process_success_message=>'Diccionario de Atributos Actualizado.'
);
end;
/
prompt --application/pages/page_00908
begin
wwv_flow_api.create_page(
 p_id=>908.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Ver Detalles de Actualizaci\00F3n de Diccionario de Atributos')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Ver Detalles de Actualizaci\00F3n de Diccionario de Atributos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'300'
,p_dialog_width=>'550'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261974625502984560.4001)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(262095327045921693.4001)
,p_name=>'Texto de Ayuda de Elemento'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select help_text',
'  from wwv_flow_step_item_help',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :FB_FLOW_ID',
'   and flow_item_id      = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'IH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262095609354921709.4001)
,p_query_column_id=>1
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>1
,p_column_heading=>'Texto de Ayuda de Elemento'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(262095818519928660.4001)
,p_name=>'Texto de Ayuda de Columna de Diccionario de Atributos'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select help_text',
'  from wwv_flow_hnt_column_dict',
' where security_group_id = :flow_security_group_id',
'   and column_id         = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'ADH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262096027026928673.4001)
,p_query_column_id=>1
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>1
,p_column_heading=>'Texto de Ayuda de Columna de Diccionario de Atributos'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(262096831810941953.4001)
,p_name=>'Texto de Ayuda de Columna de Informe Interactivo'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select help_text',
'  from wwv_flow_worksheet_columns ',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'IRH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262097031111941959.4001)
,p_query_column_id=>1
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>1
,p_column_heading=>'Texto de Ayuda de Columna de Informe Interactivo'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(262099000951980356.4001)
,p_name=>'Valor por Defecto de Elemento'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>160
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_default',
'  from wwv_flow_step_items',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'ID'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262099402121990165.4001)
,p_query_column_id=>1
,p_column_alias=>'ITEM_DEFAULT'
,p_column_display_sequence=>1
,p_column_heading=>'Valor por Defecto de Elemento'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(262099512164993096.4001)
,p_name=>'Valor por Defecto de Columna de Diccionario de Atributos'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select default_value',
'  from wwv_flow_hnt_column_dict',
' where security_group_id = :flow_security_group_id',
'   and column_id         = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'ADD'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262100030172998264.4001)
,p_query_column_id=>1
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>1
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059809491578457631.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1059809557950457632.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1059809491578457631.4001)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261975027889032552.4001)
,p_name=>'P908_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(261974625502984560.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261975226461032555.4001)
,p_name=>'P908_DISPLAY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(261974625502984560.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1059809663837457633.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1059809557950457632.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1059809795498457634.4001)
,p_event_id=>wwv_flow_api.id(1059809663837457633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00911
begin
wwv_flow_api.create_page(
 p_id=>911.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Aplicaci\00F3n')
,p_step_title=>unistr('Actualizar Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459818721194755532.4001)
,p_plug_name=>'Actualizar Objetos'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 checkbox,',
'       n001 page_id,',
'       c002 page_name,',
'       c003 group_name,',
'       c004 region_name,',
'       c005 name,',
'       c006 additional_info,',
'       c007 page_locked_by',
'  from apex_collections',
' where collection_name = ''UPGRADE_REPORT'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(459818932676755539.4001)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn objeto para la actualizaci\00F3n.')
,p_max_rows_per_page=>'10000'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y_OF_Z'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459819218561755552.4001)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484840606450750527.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(504037023650476602.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'I'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(504037122389476605.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>4
,p_column_identifier=>'J'
,p_column_label=>unistr('Grupo de P\00E1ginas')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484840715006750529.4001)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459840332076901035.4001)
,p_db_column_name=>'NAME'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Nombre del Objeto'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(484840810594750529.4001)
,p_db_column_name=>'ADDITIONAL_INFO'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('Informaci\00F3n Adicional')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(636376719124823054.4001)
,p_db_column_name=>'PAGE_LOCKED_BY'
,p_display_order=>8
,p_column_identifier=>'K'
,p_column_label=>unistr('P\00E1gina Bloqueada por')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459819521566755556.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459819916170755560.4001)
,p_plug_name=>unistr('Actualizar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para actualizar objetos de la aplicaci\00F3n, seleccione Tipo de Actualizaci\00F3n, los objetos que desea actualizar y haga clic en el bot\00F3n Actualizar.'),
'</p>',
'<p>',
unistr('Tenga en cuenta que no se pueden actualizar las p\00E1ginas bloqueadas ni los elementos con formatos de fecha no soportados.'),
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(629199521925023238.4001)
,p_plug_name=>'Value Required updates'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los siguientes elementos tienen validaciones no nulas incondicionales. Si se han seleccionado para su actualizaci\00F3n, el campo Valor Necesario estar\00E1 definido en S\00ED y se suprimir\00E1n las validaciones no nulas ahora innecesarias.</p>'),
'<p>',
unistr('Tenga en cuenta que los elementos de las p\00E1ginas bloqueadas no est\00E1n disponibles para su actualizaci\00F3n.'),
'</p>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'REQUIRED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(629201104395027632.4001)
,p_plug_name=>unistr('Actualizaciones Num\00E9ricas')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los siguientes elementos tienen validaciones num\00E9ricas incondicionales. Si se han seleccionado para su actualizaci\00F3n, el campo Valor Necesario estar\00E1 definido en S\00ED y se suprimir\00E1n las validaciones no nulas ahora innecesarias.</p>'),
'<p>',
unistr('Tenga en cuenta que los elementos de las p\00E1ginas bloqueadas no est\00E1n disponibles para su actualizaci\00F3n.'),
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'NUMBER_FIELD'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(629368723063306478.4001)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Debe revisar estas validaciones por p\00E1gina para determinar las que desea eliminar y sustituir por la configuraci\00F3n de elementos. La validaci\00F3n no nula definir\00E1 el campo Valor Necesario en S\00ED, la validaci\00F3n num\00E9rica cambiar\00E1 el campo Mostrar como a un')
||unistr(' campo num\00E9rico y la validaci\00F3n de fecha v\00E1lida cambiar\00E1 el elemento a un selector de fecha (si a\00FAn no hay ninguno). Tambi\00E9n debe identificar si desea actualizar los botones de la p\00E1gina para que no ejecuten validaciones (por ejemplo, los botones Can')
||unistr('celar o Suprimir) e identificar cualquier otra validaci\00F3n que desee definir para que se ejecute siempre.'),
'</p>',
'<p>',
unistr('Tenga en cuenta que las p\00E1ginas bloqueadas y elementos con formatos de fecha no soportados no est\00E1n disponibles para su actualizaci\00F3n.'),
'</p>',
'<p>',
unistr('Seleccione un n\00FAmero de p\00E1ginas para continuar.'),
'</p>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(629377227228383306.4001)
,p_name=>'for Advanced'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 page,',
'       c002 page_name,',
'       c004 item_name,',
'       c006 validation_type,',
'       c005 validation_name,',
'       c007 button_name,',
'       c008 condition,',
'       c009 additional_info,',
'       c010 page_locked_by',
'  from apex_collections',
' where collection_name = ''ADV_UPGRADE_REPORT''',
' order by n001, c006, c004'))
,p_display_when_condition=>'P911_UPGRADE_TYPE'
,p_display_when_cond2=>'ADVANCED'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn objeto para la actualizaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(636443117577336265.4001)
,p_query_column_id=>1
,p_column_alias=>'PAGE'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(629377704112383372.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(636443221541336265.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre del Elemento'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(630867829252246491.4001)
,p_query_column_id=>4
,p_column_alias=>'VALIDATION_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tipo de Validaci\00F3n')
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(630881727193397263)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(636443312566336265.4001)
,p_query_column_id=>5
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Nombre de Validaci\00F3n')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(629378214516383372.4001)
,p_query_column_id=>6
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Bot\00F3n Asociado')
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(629378319416383373.4001)
,p_query_column_id=>7
,p_column_alias=>'CONDITION'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Condici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(13602414170805697)
,p_lov_show_nulls=>'YES'
,p_lov_null_text=>'&nbsp;'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(636444526460405035.4001)
,p_query_column_id=>8
,p_column_alias=>'ADDITIONAL_INFO'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Informaci\00F3n Adicional')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(636443420452336265.4001)
,p_query_column_id=>9
,p_column_alias=>'PAGE_LOCKED_BY'
,p_column_display_sequence=>8
,p_column_heading=>unistr('P\00E1gina Bloqueada por')
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(615719720175923103.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(459819521566755556.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459819723958755558.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(459819521566755556.4001)
,p_button_name=>'UPGRADE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar'
,p_button_position=>'CREATE'
,p_button_condition=>'P911_UPGRADE_TYPE'
,p_button_condition2=>'ADVANCED'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(615549511693641827.4001)
,p_branch_action=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>129
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459822501986775349.4001)
,p_name=>'P911_UPGRADE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(459819521566755556.4001)
,p_prompt=>unistr('Tipo de Actualizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UPGRADE_APPLICATION_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(484799616606261493.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de actualizaci\00F3n que se va a realizar.')
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(459821216410755578.4001)
,p_validation_name=>'Update requires object selection'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar al menos un objeto para la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(459819723958755558.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(617309980105937210.4001)
,p_validation_name=>'upgrade tabular from to IG check'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_cnt pls_integer := 0;',
'begin',
'    if :P911_UPGRADE_TYPE = ''TABULAR_TO_IG'' then',
'        for i in 1..apex_application.g_f01.count',
'        loop',
'            for l_region in (select plug_source',
'                             from wwv_flow_page_plugs',
'                             where plug_source_type = wwv_flow_region_native.c_tabform',
'                             and flow_id = :fb_flow_id',
'                             and id = apex_application.g_f01(i)',
'                             and security_group_id = wwv_flow_security.g_security_group_id )',
'            loop',
'                if wwv_flow_f4000_util.is_query_with_order_by ( l_region.plug_source ) then',
'                    l_error_cnt := l_error_cnt + 1;',
'                end if;',
'            end loop;',
'        end loop;',
'    ',
'        -- raise error only if all selected tabular form region contains order by clause',
'        if l_error_cnt = apex_application.g_f01.count then',
'            return false;',
'        end if;',
'        return true;',
'    ',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El formato tabular seleccionado contiene la cl\00E1usula order by y no se puede actualizar a la cuadr\00EDcula interactiva.')
,p_when_button_pressed=>wwv_flow_api.id(459819723958755558.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'NOTE: this validation was firing regardless of whether an IG upgrade was occurring, so I moved the "if l_error_cnt.." IF statement inside the main IF statement, to only fire when doing a Tabular Form to IG upgrade'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1952252380076322150.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(459818721194755532.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045580452067367801.4001)
,p_event_id=>wwv_flow_api.id(1952252380076322150.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(459821423542755582.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Selected Objects '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_id                varchar2(4000);',
'    l_region_id         number;',
'    l_count             number;',
'    l_collection_exist  boolean;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'                      p_collection_name => ''OBJECTS_NOT_UPGRADED'');',
'',
'    for i in 1..apex_application.g_f01.count',
'    loop',
'        l_id := apex_application.g_f01(i);',
'        case :P911_UPGRADE_TYPE',
'            when ''DATE_PICKER_JET'' then ',
'                 wwv_flow_upgrade_app.update_datepicker_jet (',
'                     p_flow_id      => :fb_flow_id,',
'                     p_id           => l_id );',
'            when ''NUMBER_FIELD'' then ',
'                 wwv_flow_upgrade_app.update_to_numeric (',
'                     p_flow_id => :fb_flow_id,',
'                     p_item_id => to_number(l_id) );',
'            when ''REQUIRED'' then ',
'                 wwv_flow_upgrade_app.update_to_required (',
'                     p_flow_id => :fb_flow_id,',
'                     p_item_id => to_number(l_id) );',
'            when ''CKEDITOR'' then ',
'                 wwv_flow_upgrade_app.update_to_CKEditor (',
'                     p_flow_id => :fb_flow_id,',
'                     p_item_id => to_number(l_id) );',
'            when ''LOV_NULL_VALUE'' then',
'                 wwv_flow_upgrade_app.update_lov_null_return_value (',
'                     p_flow_id => :fb_flow_id,',
'                     p_item_id => to_number(l_id) );',
'            when ''IR_ROWS_PER_PAGE'' then',
'                 wwv_flow_upgrade_app.update_interactive_report (',
'                     p_type    => :P911_UPGRADE_TYPE,',
'                     p_flow_id => :fb_flow_id,',
'                     p_report_id => to_number(l_id) );',
'            when ''IR_GROUP_BY'' then',
'                 wwv_flow_upgrade_app.update_interactive_report (',
'                     p_type    => :P911_UPGRADE_TYPE,',
'                     p_flow_id => :fb_flow_id,',
'                     p_report_id => to_number(l_id) );',
'            when ''IR_SAVE_PUBLIC'' then',
'                 wwv_flow_upgrade_app.update_interactive_report (',
'                     p_type    => :P911_UPGRADE_TYPE,',
'                     p_flow_id => :fb_flow_id,',
'                     p_report_id => to_number(l_id) );',
'            when ''IR_SUBSCRIBE'' then',
'                 wwv_flow_upgrade_app.update_interactive_report (',
'                     p_type    => :P911_UPGRADE_TYPE,',
'                     p_flow_id => :fb_flow_id,',
'                     p_report_id => to_number(l_id) );',
'            when ''IR_PIVOT'' then',
'                 wwv_flow_upgrade_app.update_interactive_report (',
'                     p_type    => :P911_UPGRADE_TYPE,',
'                     p_flow_id => :fb_flow_id,',
'                     p_report_id => to_number(l_id) );',
'            when ''CALENDAR_TO_CSS_CALENDAR'' then ',
'                 wwv_flow_upgrade_app.update_to_css_calendar (',
'                     p_flow_id         => :fb_flow_id,',
'                     p_region_id       => to_number(l_id));',
'            when ''IR_FIXED_HEADER'' then',
'                 wwv_flow_upgrade_app.update_interactive_report (',
'                     p_type    => :P911_UPGRADE_TYPE,',
'                     p_flow_id => :fb_flow_id,',
'                     p_report_id => to_number(l_id) );',
'            when ''TABULAR_TO_IG'' then',
'                 wwv_flow_upgrade_app.update_tabular_to_ig (',
'                     p_flow_id => :fb_flow_id,',
'                     p_region_id => to_number(l_id) );',
'            when ''SWITCH'' then',
'                 wwv_flow_upgrade_app.update_to_switch (',
'                     p_flow_id => :fb_flow_id,',
'                     p_item_id => to_number(l_id) );',
'            when ''FORM_REGION'' then',
'                 wwv_flow_upgrade_app.update_to_form_region (',
'                     p_flow_id => :fb_flow_id,',
'                     p_page_id => to_number(l_id) );',
'            when ''CSS_CALENDAR_V3_TO_V5'' then ',
'                 wwv_flow_upgrade_app.update_css_calendar_v3_to_v5 (',
'                     p_flow_id         => :fb_flow_id,',
'                     p_region_id       => to_number(l_id));',
'            when ''BUTTON_CONFIRM_LINK_TO_NATIVE'' then',
'                 wwv_flow_upgrade_app.update_button_confirmation (',
'                     p_flow_id   => :fb_flow_id,',
'                     p_button_id => to_number(l_id) );',
'        end case;    ',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido actualizar los objetos seleccionados. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(459819723958755558.4001)
,p_process_success_message=>'Se han actualizado correctamente los objetos seleccionados.'
,p_process_comment=>'identify the list of pages to be locked.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(636374020677785631.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Report Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P911_UPGRADE_TYPE = ''ADVANCED'' then',
'   wwv_flow_upgrade_app.create_adv_report_collection (',
'      p_app_id       => :FB_FLOW_ID,',
'      p_user         => :APP_USER,',
'      p_session_id   => :APP_SESSION);',
'else',
'   wwv_flow_upgrade_app.create_report_collection (',
'      p_upgrade_type => :P911_UPGRADE_TYPE,',
'      p_app_id       => :FB_FLOW_ID,',
'      p_user         => :APP_USER);',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00912
begin
wwv_flow_api.create_page(
 p_id=>912.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Diccionario de Atributos'
,p_step_title=>'Diccionario de Atributos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262745606420610180)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(428477309029372008.4001)
,p_plug_name=>'Gestionar Diccionario de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p/>',
unistr('Puede actualizar la p\00E1gina actual utilizando el diccionario de atributos o utilizar la p\00E1gina actual para actualizar el diccionario de atributos. S\00F3lo se mostrar\00E1n los elementos y las columnas de informe con distintos valores para al menos un atribut')
||'o. Puede elegir los objetos que insertar o actualizar, y los atributos que incluir.',
'<p/>',
unistr('Es posible que el n\00FAmero de elementos y columnas de informe que se puedan utilizar sea inferior al total, ya que los objetos ocultos, los objetos en regiones ocultas y los elementos de bot\00F3n no se incluyen.')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445128905572834709.4001)
,p_plug_name=>'stats'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445193312547849631.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445264628987932285.4001)
,p_plug_name=>unistr('Elementos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>2
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_column_width=>'apex-col--bottomBorder'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(428347522219852565.4001)
,p_name=>'Resumen'
,p_parent_plug_id=>wwv_flow_api.id(445264628987932285.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>25
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v(''P912_I_TOTAL_PAGE_ITEMS'') ti, ',
'       v(''P912_I_DISPLAYED_ITEMS'') ci,',
'       v(''P912_I_POTENTIAL_UPDATES'') mi,',
'       v(''P912_I_IDENTICAL_ATTRIBUTES'') fmi,',
'       v(''P912_I_POTENTIAL_NEW_ENTRIES'') ui',
'  from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428435702665010621.4001)
,p_query_column_id=>1
,p_column_alias=>'TI'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Elementos Totales de P\00E1gina')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428435802326010621.4001)
,p_query_column_id=>2
,p_column_alias=>'CI'
,p_column_display_sequence=>2
,p_column_heading=>'Elementos Mostrados'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428435907070010621.4001)
,p_query_column_id=>3
,p_column_alias=>'MI'
,p_column_display_sequence=>4
,p_column_heading=>'Actualizaciones Potenciales'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428436026329010621.4001)
,p_query_column_id=>4
,p_column_alias=>'FMI'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Atributos Id\00E9nticos')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428436125920010621.4001)
,p_query_column_id=>5
,p_column_alias=>'UI'
,p_column_display_sequence=>3
,p_column_heading=>'Posibles Entradas Nuevas'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(444812425780707388.4001)
,p_plug_name=>unistr('Actualizar P\00E1gina')
,p_parent_plug_id=>wwv_flow_api.id(445264628987932285.4001)
,p_region_css_classes=>'a-Region--touchTop'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>5
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text  varchar2(4000);',
'begin',
'',
'   if :P912_I_POTENTIAL_UPDATES > 0 then',
'      l_text := ''<a href="f?p=4000:921:&APP_SESSION.:::921">'' ||',
'             wwv_flow_lang.system_message(''4000.912.REVIEW.N.ITEMS.FOR.UPDATE'',',
'             :P912_I_POTENTIAL_UPDATES) || ''</a>'';',
'   else',
'      l_text := wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.UPDATE'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-List a-List--links">'');',
'   sys.htp.p(''<li>'' || wwv_flow_escape.noop(l_text) || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(444827907959815706.4001)
,p_plug_name=>'Actualizar Diccionario de Atributos'
,p_parent_plug_id=>wwv_flow_api.id(445264628987932285.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text1  varchar2(4000);',
'   l_text2  varchar2(4000);',
'begin',
'',
'   if :P912_I_POTENTIAL_NEW_ENTRIES > 0 then',
'      l_text1 := ''<a class="a-LinksList-link"  href="f?p=4000:906:&APP_SESSION.:::906"><span class="a-LinksList-label">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'',',
'      :P912_I_POTENTIAL_NEW_ENTRIES) || ''</span></a>'';',
'   else l_text1 := ',
'        wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.INSERT.INTO.AD'');',
'   end if;',
'',
'   if :P912_I_POTENTIAL_UPDATES > 0 then',
'      l_text2 := ''<a class="a-LinksList-link" href="f?p=4000:890:&APP_SESSION.:::890"><span class="a-LinksList-label">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'',',
'      :P912_I_POTENTIAL_UPDATES) || ''</span></a>'';',
'   else l_text2 := ',
'        wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.UPDATE.OF.AD'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-LinksList">'');',
'   sys.htp.p(''<li class="a-LinksList-item">'' || wwv_flow_escape.noop(l_text1) || ''</li>'');',
'   sys.htp.p(''<li class="a-LinksList-item">'' || wwv_flow_escape.noop(l_text2) || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445264907647935567.4001)
,p_plug_name=>'Columnas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>3
,p_plug_new_grid_row=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(428433402956906644.4001)
,p_name=>'Resumen'
,p_parent_plug_id=>wwv_flow_api.id(445264907647935567.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v(''P912_RC_TOTAL_RC'') trc, ',
'       v(''P912_RC_DISPLAYED_RC'') crc,',
'       v(''P912_RC_POTENTIAL_UPDATES'') mrc,',
'       v(''P912_RC_IDENTICAL_ATTRIBUTES'') fmrc,',
'       v(''P912_RC_POTENTIAL_NEW_ENTRIES'')urc',
'  from dual',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428434515862967193.4001)
,p_query_column_id=>1
,p_column_alias=>'TRC'
,p_column_display_sequence=>1
,p_column_heading=>'Total de Columnas de Informe'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428434630602967193.4001)
,p_query_column_id=>2
,p_column_alias=>'CRC'
,p_column_display_sequence=>2
,p_column_heading=>'Columnas de Informe Visualizadas'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428434705097967194.4001)
,p_query_column_id=>3
,p_column_alias=>'MRC'
,p_column_display_sequence=>4
,p_column_heading=>'Actualizaciones Potenciales'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428434803867967194.4001)
,p_query_column_id=>4
,p_column_alias=>'FMRC'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Atributos Id\00E9nticos')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(428434917315967195.4001)
,p_query_column_id=>5
,p_column_alias=>'URC'
,p_column_display_sequence=>3
,p_column_heading=>'Posibles Entradas Nuevas'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445206821107210969.4001)
,p_plug_name=>'Actualizar Diccionario de Atributos'
,p_parent_plug_id=>wwv_flow_api.id(445264907647935567.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>21
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text1  varchar2(4000);',
'   l_text2  varchar2(4000);',
'begin',
'',
'   if :P912_RC_POTENTIAL_NEW_ENTRIES > 0 then',
'      l_text1 := ''<a href="f?p=4000:907:&APP_SESSION.:::907">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'',',
'      :P912_RC_POTENTIAL_NEW_ENTRIES) || ''</a>'';',
'   else l_text1 := ',
'        wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.INSERT.INTO.AD'');',
'   end if;',
'',
'   if :P912_RC_POTENTIAL_UPDATES > 0 then',
'      l_text2 := ''<a href="f?p=4000:897:&APP_SESSION.:::897">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'',',
'      :P912_RC_POTENTIAL_UPDATES) || ''</a>'';',
'   else l_text2 := ',
'        wwv_flow_lang.system_message(''4000.912.0.RC.FOR.UPDATE.OF.AD'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-List a-List--links">'');',
'   sys.htp.p(''<li>'' || l_text1 || ''</li>'');',
'   sys.htp.p(''<li>'' || l_text2 || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(445234512365577430.4001)
,p_plug_name=>unistr('Actualizar P\00E1gina')
,p_parent_plug_id=>wwv_flow_api.id(445264907647935567.4001)
,p_region_css_classes=>'a-Region--touchTop'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>7
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text  varchar2(4000);',
'begin',
'',
'   if :P912_RC_POTENTIAL_UPDATES > 0 then',
'      l_text := ''<a href="f?p=4000:922:&APP_SESSION.:::922">'' ||',
'          wwv_flow_lang.system_message(''4000:912:REVIEW.N.RC.FOR.UPDATE'',',
'          :P912_RC_POTENTIAL_UPDATES) || ''</a>'';',
'   else',
'      l_text := wwv_flow_lang.system_message(''4000:912:0.RC.FOR.UPDATE'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-List a-List--links">'');',
'   sys.htp.p(''<li>'' || wwv_flow_escape.noop(l_text) || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445275611700154288.4001)
,p_name=>'P912_I_TOTAL_PAGE_ITEMS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445275828494154346.4001)
,p_name=>'P912_I_DISPLAYED_ITEMS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445276028113154347.4001)
,p_name=>'P912_I_POTENTIAL_NEW_ENTRIES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445276211981154347.4001)
,p_name=>'P912_I_POTENTIAL_UPDATES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445276430394154348.4001)
,p_name=>'P912_I_IDENTICAL_ATTRIBUTES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445276623399154348.4001)
,p_name=>'P912_RC_TOTAL_RC'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445276814596154349.4001)
,p_name=>'P912_RC_DISPLAYED_RC'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445277023643154350.4001)
,p_name=>'P912_RC_POTENTIAL_NEW_ENTRIES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445277230235154351.4001)
,p_name=>'P912_RC_POTENTIAL_UPDATES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(445277429291154351.4001)
,p_name=>'P912_RC_IDENTICAL_ATTRIBUTES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(445128905572834709.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(445136928953879226.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Item Stats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'',
'select ti.cnt ti, ',
'       di.cnt di,',
'       mi.cnt - fmi.cnt mi,',
'       fmi.cnt fmi,',
'       ui.cnt ui',
'  from',
'(select count(*) cnt',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs r',
'     where i.security_group_id  = :flow_security_group_id',
'       and i.flow_id            = :FB_FLOW_ID ',
'       and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'       and i.item_plug_id       = r.id  ',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID ',
'       and r.page_id            = :FB_FLOW_PAGE_ID) ti,',
'(select count(*) cnt',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs r',
'     where nvl(i.display_when_type,''disp'') != ''NEVER''',
'       and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'       and i.security_group_id  = :flow_security_group_id',
'       and i.flow_id            = :FB_FLOW_ID ',
'       and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'       and i.item_plug_id       = r.id  ',
'       and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID ',
'       and r.page_id            = :FB_FLOW_PAGE_ID) di,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name) mi,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and (nvl(i.prompt,''0'') = nvl(ad.label,''0'') or ',
'        i.prompt = ad.label||'':'')',
'   and nvl(h.help_text,''0'')    = nvl(ad.help_text,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.format_mask,''0'')',
'   and nvl(i.item_default,''0'') = nvl(ad.default_value,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.form_format_mask,''0'')',
'   and nvl(i.cSize,0)          = nvl(ad.form_display_width,0)',
'   and nvl(i.cHeight,0)        = nvl(ad.form_display_height,0)',
'   and nvl(i.data_type,''0'')    = nvl(ad.form_data_type,''0'') ) fmi,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end not in (select syn_name',
'                          from wwv_flow_hnt_col_dict_syn',
'                         where security_group_id  = :flow_security_group_id) ) ui',
')',
'',
'loop',
'   :P912_I_TOTAL_PAGE_ITEMS      := c1.ti;',
'   :P912_I_DISPLAYED_ITEMS       := c1.di;',
'   :P912_I_POTENTIAL_NEW_ENTRIES := c1.ui;	',
'   :P912_I_POTENTIAL_UPDATES     := c1.mi;',
'   :P912_I_IDENTICAL_ATTRIBUTES  := c1.fmi;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(445281727677187338.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Report Column Stats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'',
'select trc1.cnt + trc2.cnt trc, ',
'       crc1.cnt + crc2.cnt crc,',
'       mrc1.cnt + mrc2.cnt - fmrc1.cnt - fmrc2.cnt mrc,',
'       fmrc1.cnt + fmrc2.cnt fmrc,',
'       urc1.cnt + urc2.cnt urc',
'  from',
'(select count(*) cnt',
'      from wwv_flow_region_report_column rc,',
'           wwv_flow_page_plugs r',
'     where rc.security_group_id = :flow_security_group_id',
'       and rc.flow_id           = :FB_FLOW_ID',
'       and rc.region_id         = r.id',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID',
'       and r.page_id            = :FB_FLOW_PAGE_ID) trc1,',
'(select count(*) cnt',
'         from wwv_flow_worksheet_columns wc,',
'              wwv_flow_worksheets w,',
'              wwv_flow_page_plugs r',
'        where wc.security_group_id = :flow_security_group_id',
'          and wc.flow_id           = :FB_FLOW_ID',
'          and wc.worksheet_id      = w.id',
'          and w.security_group_id  = :flow_security_group_id',
'          and w.flow_id            = :FB_FLOW_ID',
'          and w.page_id            = :FB_FLOW_PAGE_ID',
'          and w.region_id          = r.id',
'          and r.security_group_id  = :flow_security_group_id',
'          and r.flow_id            = :FB_FLOW_ID',
'          and r.page_id            = :FB_FLOW_PAGE_ID) trc2,',
'(select count(*) cnt',
'      from wwv_flow_region_report_column rc,',
'           wwv_flow_page_plugs r',
'     where rc.hidden_column = ''N''',
'       and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'       and rc.security_group_id = :flow_security_group_id',
'       and rc.flow_id           = :FB_FLOW_ID',
'       and rc.region_id         = r.id',
'       and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID',
'       and r.page_id            = :FB_FLOW_PAGE_ID',
'       and substr(rc.column_alias,1,6) != ''CHECK$''',
'       and substr(rc.column_alias,1,5) != ''LINK$''',
'       and substr(rc.column_alias,1,8) != ''DERIVED$'' ) crc1,',
'(select count(*) cnt',
'         from wwv_flow_worksheet_columns wc,',
'              wwv_flow_worksheets w,',
'              wwv_flow_page_plugs r',
'        where nvl(wc.display_text_as,''disp'') != ''HIDDEN''',
'          and wc.security_group_id = :flow_security_group_id',
'          and wc.flow_id           = :FB_FLOW_ID',
'          and wc.worksheet_id      = w.id',
'          and w.security_group_id  = :flow_security_group_id',
'          and w.flow_id            = :FB_FLOW_ID',
'          and w.page_id            = :FB_FLOW_PAGE_ID',
'          and w.region_id          = r.id',
'          and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'          and r.security_group_id  = :flow_security_group_id',
'          and r.flow_id            = :FB_FLOW_ID',
'          and r.page_id            = :FB_FLOW_PAGE_ID) crc2,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and substr(rc.column_alias,1,6) != ''CHECK$''',
'   and substr(rc.column_alias,1,5) != ''LINK$''',
'   and substr(rc.column_alias,1,8) != ''DERIVED$''',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id ) mrc1,',
'(select  count(*) cnt',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id) mrc2,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and substr(rc.column_alias,1,6) != ''CHECK$''',
'   and substr(rc.column_alias,1,5) != ''LINK$''',
'   and substr(rc.column_alias,1,8) != ''DERIVED$''',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.column_heading,''0'')   = nvl(ad.label,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.format_mask,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ) fmrc1,',
'(select count(*) cnt',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     = ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.report_label,''0'')     = nvl(ad.label,''0'')',
'   and nvl(rc.help_text,''0'')        = nvl(ad.help_text,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.format_mask,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ) fmrc2,',
'(select count(*) cnt',
'   from wwv_flow_page_plugs r,',
'        wwv_flow_region_report_column rc',
'  where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'    and r.security_group_id  = :flow_security_group_id',
'    and r.flow_id    = :FB_FLOW_ID',
'    and r.page_id    = :FB_FLOW_PAGE_ID',
'    and r.id         = rc.region_id',
'    and rc.hidden_column = ''N''',
'    and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'    and rc.security_group_id  = :flow_security_group_id',
'    and rc.flow_id            = :FB_FLOW_ID',
'    and rc.column_alias not in (',
'        select syn_name',
'          from wwv_flow_hnt_col_dict_syn',
'         where security_group_id  = :flow_security_group_id)',
'    and substr(rc.column_alias,1,6) != ''CHECK$''',
'    and substr(rc.column_alias,1,5) != ''LINK$''',
'    and substr(rc.column_alias,1,8) != ''DERIVED$'' ) urc1,',
'(select count(*) cnt',
'   from wwv_flow_worksheets w,',
'        wwv_flow_page_plugs r,',
'        wwv_flow_worksheet_columns rc',
'  where w.security_group_id = :flow_security_group_id',
'    and w.flow_id           = :FB_FLOW_ID',
'    and w.page_id           = :FB_FLOW_PAGE_ID',
'    and w.region_id         = r.id',
'    and r.security_group_id = :flow_security_group_id',
'    and r.flow_id           = :FB_FLOW_ID ',
'    and r.page_id           = :FB_FLOW_PAGE_ID',
'    and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'    and w.id                = rc.worksheet_id',
'    and rc.display_text_as != ''HIDDEN''',
'    and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'    and rc.security_group_id  = :flow_security_group_id',
'    and rc.flow_id            = :FB_FLOW_ID',
'    and rc.db_column_name not in (',
'        select syn_name',
'          from wwv_flow_hnt_col_dict_syn',
'         where security_group_id  = :flow_security_group_id)) urc2',
')',
'',
'loop',
'   :P912_RC_TOTAL_RC              := c1.trc;',
'   :P912_RC_DISPLAYED_RC          := c1.crc;',
'   :P912_RC_POTENTIAL_NEW_ENTRIES := c1.urc;	',
'   :P912_RC_POTENTIAL_UPDATES     := c1.mrc;',
'   :P912_RC_IDENTICAL_ATTRIBUTES  := c1.fmrc;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00920
begin
wwv_flow_api.create_page(
 p_id=>920.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de P\00E1gina: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47946831821696492.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(121962618064160338.4001)
,p_plug_name=>unistr('Crear Plantilla de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. Cuando cree una plantilla, podr\00E1 modificarla m\00E1s tarde.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(124526607285669191.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(121969012024165564.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(47946831821696492.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(121978026915169802.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47946831821696492.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19458625868751541.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47946831821696492.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(176917219768347992.4001)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(121978026915169802.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P920_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(123695111891184070.4001)
,p_branch_action=>'924'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(121978026915169802.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P920_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589948785670621432.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19458625868751541.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121993303171182395.4001)
,p_name=>'F4000_P920_WIZ_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(121962618064160338.4001)
,p_item_default=>'COPY'
,p_prompt=>unistr('Crear Plantilla de P\00E1gina:')
,p_source=>'COPY'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_api.id(86592719346240927.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'valign="top"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'',
'',
'',
'    select ''Start with a default template'' d,''DEFAULT'' r,1 ob from dual',
'',
'',
'',
'    union',
'',
'',
'',
'    select ''Create a template from scratch'' d,''BLANK'' r, 2 ob from dual',
'',
'',
'',
'    union',
'',
'',
'',
'    select ''Create a copy of a template in another flow'' d, ''COPY'' r,3 ob from dual)',
'',
'',
'',
'order by ob'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589948571712621430.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(121969012024165564.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589948676689621431.4001)
,p_event_id=>wwv_flow_api.id(589948571712621430.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(122204211636376035.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'920:922:924:925'
,p_process_when_button_id=>wwv_flow_api.id(121969012024165564.4001)
);
end;
/
prompt --application/pages/page_00921
begin
wwv_flow_api.create_page(
 p_id=>921.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Elementos Utilizando Diccionario de Atributos'
,p_step_title=>'Actualizar Elementos Utilizando Diccionario de Atributos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(446025920706062430.4001)
,p_name=>'Elementos igual que las entradas del diccionario de atributos'
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.id, i.name item_name, ads.syn_name attr_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and (nvl(i.prompt,''0'') = nvl(ad.label,''0'') or',
'        i.prompt = ad.label||'':'')',
'   and nvl(h.help_text,''0'')    = nvl(ad.help_text,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(nvl(ad.form_format_mask,ad.format_mask),''0'')',
'   and nvl(i.item_default,''0'') = nvl(ad.default_value,''0'')',
'   and nvl(i.cSize,0)          = nvl(ad.form_display_width,0)',
'   and nvl(i.cHeight,0)        = nvl(ad.form_display_height,0)',
'   and nvl(i.data_type,''0'')    = nvl(ad.form_data_type,''0'')',
'order by i.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446026111263062434.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446026218293062437.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Elemento'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446026302912062437.4001)
,p_query_column_id=>3
,p_column_alias=>'ATTR_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Coincidencias'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446026410403062438.4001)
,p_plug_name=>'Actualizar Elementos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los elementos de p\00E1gina especificados coincidieron con columnas en el diccionario de atributos. Seleccione los elementos que desea actualizar e indique qu\00E9 atributos desea incluir en la actualizaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(446026811272062441.4001)
,p_name=>'Matched Items'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1,i.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       i.id i_id, ',
'       i.name i_name, ',
'       i.prompt i_label,',
'       case when length(h.help_text) > 20',
'             then wwv_flow_escape.html(substr(h.help_text,1,20))||',
'                  ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                  '':::908:P908_DISPLAY,P908_ID:IH,''||i.id||',
'                  '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'              else wwv_flow_escape.html(h.help_text)',
'              end i_help_text,',
'       i.format_mask i_format_mask,',
'       case when length(i.item_default) > 20',
'            then wwv_flow_escape.html(substr(i.item_default,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ID,''||i.id||',
'                 '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'            else wwv_flow_escape.html(i.item_default)',
'            end i_default,',
'       --',
'       i.cSize i_width,',
'       i.cHeight i_height,',
'       i.data_type i_data_type,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then wwv_flow_escape.html(substr(ad.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">...</a>''',
'            else wwv_flow_escape.html(ad.help_text)',
'            end c_help_text,',
'       nvl(ad.form_format_mask,ad.format_mask) c_format_mask,',
'       case when length(ad.default_value) > 20',
'            then wwv_flow_escape.html(substr(ad.default_value,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADD,''||ad.column_id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">...</a>''',
'            else wwv_flow_escape.html(ad.default_value)',
'            end c_default_value,',
'       --',
'       ad.form_display_width c_form_display_width,',
'       ad.form_display_height c_form_display_height,',
'       ad.form_data_type c_form_data_type,',
'       --',
'       case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end check_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''UI_DEF_CUSTOM_ITEM_TYPE'') ct,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'               from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and ((nvl(i.prompt,''0'') != nvl(ad.label,''0'') and',
'         i.prompt != ad.label||'':'') or',
'        nvl(h.help_text,''0'')    != nvl(ad.help_text,''0'') or',
'        nvl(i.format_mask,''0'')  != nvl(nvl(ad.form_format_mask,ad.format_mask),''0'') or',
'        nvl(i.item_default,''0'') != nvl(ad.default_value,''0'') or',
'        nvl(i.cSize,0)          != nvl(ad.form_display_width,0) or',
'        nvl(i.cHeight,0)        != nvl(ad.form_display_height,0) or',
'        nvl(i.data_type,''0'')    != nvl(ad.form_data_type,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027032557062449.4001)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027410678062449.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Origen'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027521691062449.4001)
,p_query_column_id=>3
,p_column_alias=>'I_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027611519062449.4001)
,p_query_column_id=>4
,p_column_alias=>'I_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027729118062449.4001)
,p_query_column_id=>5
,p_column_alias=>'I_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027803238062450.4001)
,p_query_column_id=>6
,p_column_alias=>'I_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Texto de Ayuda'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027909816062450.4001)
,p_query_column_id=>7
,p_column_alias=>'I_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara de Formato')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028022012062450.4001)
,p_query_column_id=>8
,p_column_alias=>'I_DEFAULT'
,p_column_display_sequence=>8
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028228843062451.4001)
,p_query_column_id=>9
,p_column_alias=>'I_WIDTH'
,p_column_display_sequence=>9
,p_column_heading=>'Ancho'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028315488062451.4001)
,p_query_column_id=>10
,p_column_alias=>'I_HEIGHT'
,p_column_display_sequence=>10
,p_column_heading=>'Altura'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028423732062451.4001)
,p_query_column_id=>11
,p_column_alias=>'I_DATA_TYPE'
,p_column_display_sequence=>11
,p_column_heading=>'Tipo de Dato'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027112848062449.4001)
,p_query_column_id=>12
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>22
,p_column_heading=>'From Ad'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028527940062451.4001)
,p_query_column_id=>13
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028615811062451.4001)
,p_query_column_id=>14
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028707110062451.4001)
,p_query_column_id=>15
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>14
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028816357062451.4001)
,p_query_column_id=>16
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>15
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446028906697062451.4001)
,p_query_column_id=>17
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>16
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446029018889062451.4001)
,p_query_column_id=>18
,p_column_alias=>'C_DEFAULT_VALUE'
,p_column_display_sequence=>17
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446029326897062452.4001)
,p_query_column_id=>19
,p_column_alias=>'C_FORM_DISPLAY_WIDTH'
,p_column_display_sequence=>20
,p_column_heading=>'Form Display Width'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446029418751062452.4001)
,p_query_column_id=>20
,p_column_alias=>'C_FORM_DISPLAY_HEIGHT'
,p_column_display_sequence=>18
,p_column_heading=>'Form Display Height'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446029503256062452.4001)
,p_query_column_id=>21
,p_column_alias=>'C_FORM_DATA_TYPE'
,p_column_display_sequence=>19
,p_column_heading=>'Form Data Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446027313285062449.4001)
,p_query_column_id=>22
,p_column_alias=>'CHECK_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Check Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446029604289062452.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452537332089497417.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(446029805515062454.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(446029604289062452.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(446030020061062456.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(446029604289062452.4001)
,p_button_name=>'UPDATE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Elementos'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(446032504266062505.4001)
,p_branch_action=>'f?p=&APP_ID.:921:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446030226172062456.4001)
,p_name=>'P921_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(446029604289062452.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446030815183062464.4001)
,p_name=>'P921_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(446029604289062452.4001)
,p_item_default=>'label:help_text:format_mask:default:width:height:data_type'
,p_prompt=>unistr('Incluir en Actualizaci\00F3n:')
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,Format Mask;format_mask,Default;default,Width;width,Height;height,Data Type;data_type'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione los atributos que desea incluir en la actualizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(446031906391062490.4001)
,p_validation_name=>'P921_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P921_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar los atributos que incluir en la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(446030020061062456.4001)
,p_associated_item=>wwv_flow_api.id(446030815183062464.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(446032101276062496.4001)
,p_validation_name=>'must select items to update'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos un elemento que actualizar.'
,p_when_button_pressed=>wwv_flow_api.id(446030020061062456.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(446032315420062497.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma      number;',
'   l_item_id    number;',
'   l_column_id  number;',
'begin',
'   for i in 1..apex_application.g_f01.count loop',
'',
'      l_comma     := instr(apex_application.g_f01(i),'','');',
'      l_item_id   := substr(apex_application.g_f01(i),1,l_comma-1);',
'      l_column_id := substr(apex_application.g_f01(i),l_comma+1);',
'',
'      wwv_flow_hint.update_items_from_ad(',
'         p_application_id  => :FB_FLOW_ID,',
'         p_page_id         => :P921_PAGE_ID,',
'         p_item_id         => l_item_id,',
'         p_column_id       => l_column_id,',
'         p_attr_to_include => :P921_INCLUDE_IN_UPDATE );',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fallo al actualizar elementos de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(446030020061062456.4001)
,p_process_success_message=>unistr('Elementos de P\00E1gina Actualizados.')
);
end;
/
prompt --application/pages/page_00922
begin
wwv_flow_api.create_page(
 p_id=>922.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Actualizar Columnas de Informe Utilizando Diccionario de Atributos'
,p_step_title=>'Actualizar Columnas de Informe Utilizando Diccionario de Atributos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(261841008861828406)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446116420464960314.4001)
,p_plug_name=>'Actualizar Columnas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las columnas de informe especificadas coincidieron con columnas existentes del diccionario de atributos. Seleccione las que desee actualizar e indique qu\00E9 atributos desea incluir en la actualizaci\00F3n.</p>'),
'',
unistr('<p>Nota: El texto de ayuda s\00F3lo est\00E1 disponible dentro de informes interactivos. Si actualiza columnas en un informe est\00E1ndar, el texto de ayuda no se mostrar\00E1. Para los informes est\00E1ndar, si las cabeceras de columnas se basan en PL/SQL, no se sobres')
||unistr('cribir\00E1n; todo lo dem\00E1s, aparte del L/SQL, cambiar\00E1 a Personalizado para que se muestren las nuevas cabeceras de columna.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(446116616462960318.4001)
,p_name=>'Columnas de informe igual que las entradas del diccionario de atributos'
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.plug_name region_name,',
'       rc.column_alias rc_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.column_heading,''0'')   = nvl(ad.label,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(nvl(ad.report_format_mask,ad.format_mask),''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ',
'union all',
'select r.plug_name region_name,',
'       rc.db_column_name rc_name',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     = ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.report_label,''0'')     = nvl(ad.label,''0'')',
'   and nvl(rc.help_text,''0'')        = nvl(ad.help_text,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(nvl(ad.report_format_mask,ad.format_mask),''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'')',
'order by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna columna de informe.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446116827683960333.4001)
,p_query_column_id=>1
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446116927078960334.4001)
,p_query_column_id=>2
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Columna de Informe'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(446117023142960334.4001)
,p_name=>'Matched Report Columns'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select apex_item.checkbox(1,''CR,''||rc.id||'',''||ad.column_id||'',''||r.id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.column_alias rc_name, ',
'       rc.column_heading  rc_label,',
'       null rc_help_text,',
'       rc.column_format rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       null c_help_text,',
'       nvl(ad.report_format_mask,ad.format_mask) c_format_mask,',
'       --',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.column_heading,''0'')   != nvl(ad.label,''0'') or',
'        nvl(rc.column_format,''0'')    != nvl(nvl(ad.report_format_mask,ad.format_mask),''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )',
'union all',
'select apex_item.checkbox(1,''IR,''||rc.id||'',''||ad.column_id||'',''||r.id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.db_column_name rc_name, ',
'       rc.report_label rc_label,',
'       case when length(rc.help_text) > 20',
'            then wwv_flow_escape.html(substr(rc.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:IRH,''||rc.id||',
'                 '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'            else wwv_flow_escape.html(rc.help_text)',
'            end rc_help_text,',
'       rc.format_mask rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then wwv_flow_escape.html(substr(ad.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">...</a>''',
'            else ad.help_text',
'            end c_help_text,',
'       nvl(ad.report_format_mask,ad.format_mask) c_format_mask,',
'       --',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.report_label,''0'')     != nvl(ad.label,''0'') or',
'        nvl(rc.help_text,''0'')        != nvl(ad.help_text,''0'') or',
'        nvl(rc.format_mask,''0'')      != nvl(nvl(ad.report_format_mask,ad.format_mask),''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No se ha encontrado ninguna columna de informe.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117312948960337.4001)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117428955960337.4001)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Origen'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117508279960339.4001)
,p_query_column_id=>3
,p_column_alias=>'RC_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117630828960339.4001)
,p_query_column_id=>4
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117729426960339.4001)
,p_query_column_id=>5
,p_column_alias=>'RC_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117202877960336.4001)
,p_query_column_id=>6
,p_column_alias=>'RC_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Texto de Ayuda'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117825635960339.4001)
,p_query_column_id=>7
,p_column_alias=>'RC_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>unistr('M\00E1scara de Formato')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446117908404960339.4001)
,p_query_column_id=>8
,p_column_alias=>'RC_REPORT_COL_ALIGN'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Alineaci\00F3n de Columna de Informe')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118026871960339.4001)
,p_query_column_id=>9
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118128589960339.4001)
,p_query_column_id=>10
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118205619960339.4001)
,p_query_column_id=>11
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118329695960339.4001)
,p_query_column_id=>12
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118801214960340.4001)
,p_query_column_id=>13
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118414103960339.4001)
,p_query_column_id=>14
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(446118619615960340.4001)
,p_query_column_id=>15
,p_column_alias=>'C_REPORT_COL_ALIGN'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(446119107931960341.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(452545618162588011.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(445192614743849621.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(446119305804960341.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(446119107931960341.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(446119503950960343.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(446119107931960341.4001)
,p_button_name=>'UPDATE_RC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar Columnas de Informe'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(446121630616960369.4001)
,p_branch_action=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446119730353960343.4001)
,p_name=>'P922_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(446119107931960341.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina:')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('P\00E1gina seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446120328210960347.4001)
,p_name=>'P922_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(446119107931960341.4001)
,p_item_default=>'label:help_text:format_mask:rep_col_align'
,p_prompt=>unistr('Incluir en Actualizaci\00F3n:')
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,Format Mask;format_mask,Report Column Alignment;rep_col_align'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identifique los atributos de las columnas de informe que desea actualizar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(446121004834960366.4001)
,p_validation_name=>'P922_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P922_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe seleccionar los atributos que incluir en la actualizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(446119503950960343.4001)
,p_associated_item=>wwv_flow_api.id(446120328210960347.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(446121216648960367.4001)
,p_validation_name=>'must select rc to update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if APEX_APPLICATION.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe seleccionar al menos una columna del informe para actualizar.'
,p_when_button_pressed=>wwv_flow_api.id(446119503950960343.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(446121406081960368.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Report Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma2     number;',
'   l_comma3     number;',
'   l_rc_type    varchar2(2);',
'   l_rc_id      number;',
'   l_column_id  number;',
'   l_region_id  number;',
'begin',
'   for i in 1..apex_application.g_f01.count loop',
'',
'      l_comma2    := instr(apex_application.g_f01(i),'','',1,2);',
'      l_comma3    := instr(apex_application.g_f01(i),'','',1,3);',
'      l_rc_type   := substr(apex_application.g_f01(i),1,2);',
'      l_rc_id     := substr(apex_application.g_f01(i),4,l_comma2-4);',
'      l_column_id := substr(apex_application.g_f01(i),l_comma2+1,l_comma3-l_comma2-1);',
'      l_region_id := substr(apex_application.g_f01(i),l_comma3+1);',
'',
'      if l_rc_type = ''CR'' and instr(:P922_INCLUDE_IN_UPDATE,''label'') > 0 then',
'         wwv_flow_hint.update_cr_ht_from_ad(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_page_id         => :FB_FLOW_PAGE_ID,',
'            p_region_id       => l_region_id);',
'      end if;',
'',
'      if l_rc_type = ''CR'' then',
'         wwv_flow_hint.update_cr_from_ad(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_page_id         => :FB_FLOW_PAGE_ID,',
'            p_region_id       => l_region_id,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P922_INCLUDE_IN_UPDATE );',
'      elsif l_rc_type = ''IR'' then',
'         wwv_flow_hint.update_ir_from_ad(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P922_INCLUDE_IN_UPDATE );',
'      end if;',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fallo al actualizar las columnas del informe.'
,p_process_when_button_id=>wwv_flow_api.id(446119503950960343.4001)
,p_process_success_message=>'Columnas de informe actualizadas.'
);
end;
/
prompt --application/pages/page_00924
begin
wwv_flow_api.create_page(
 p_id=>924.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de P\00E1gina: Nombre')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47955417641843745.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(122592504098427901.4001)
,p_plug_name=>unistr('Crear Plantilla de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Identifique un nombre \00FAnico para la plantilla.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(124560812436697184.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(122604106641450804.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47955417641843745.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(122619509673470584.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47955417641843745.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(122596106164441181.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47955417641843745.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75113514794973621.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589949079007621435.4001)
,p_branch_action=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(122596106164441181.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75073508457839337.4001)
,p_name=>'P924_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(122592504098427901.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre de la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75093529545892703.4001)
,p_name=>'P924_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(122592504098427901.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75095607297905270.4001)
,p_name=>'P924_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(122592504098427901.4001)
,p_prompt=>'Clase de Plantilla'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(41972431732112027.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(88128921579958266.4001)
,p_validation_name=>'P924_NAME'
,p_validation_sequence=>10
,p_validation=>'P924_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(122619509673470584.4001)
,p_associated_item=>wwv_flow_api.id(75073508457839337.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(88130531622961153.4001)
,p_validation_name=>'P924_THEME'
,p_validation_sequence=>20
,p_validation=>'P924_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(122619509673470584.4001)
,p_associated_item=>wwv_flow_api.id(75093529545892703.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(88131707165963502.4001)
,p_validation_name=>'P924_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P924_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(122619509673470584.4001)
,p_associated_item=>wwv_flow_api.id(75095607297905270.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589948875178621433.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(122604106641450804.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589948948760621434.4001)
,p_event_id=>wwv_flow_api.id(589948875178621433.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(124205015113526014.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_template(',
'    P_ID                         => wwv_flow_id.next_val,',
'    P_FLOW_ID                    => :FB_FLOW_ID,',
'    P_THEME_ID                   => :P924_THEME,',
'    P_THEME_CLASS_ID             => :P924_THEME_CLASS,',
'    P_NAME                       => :P924_NAME,',
'    P_HEADER_TEMPLATE            => ',
'''<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">',
'<head>',
'#HEAD#',
'<title>#TITLE#</title>',
'</head>',
'<body #ONLOAD#>#FORM_OPEN#<a name="PAGETOP"></a>'',',
'    P_FOOTER_TEMPLATE            => ''#FORM_CLOSE#<a name="END"></a></body></html>'',',
'    P_SUCCESS_MESSAGE            => null,',
'    P_CURRENT_TAB                => null,',
'    P_CURRENT_TAB_FONT_ATTR      => null,',
'    P_NON_CURRENT_TAB            => null,',
'    P_NON_CURRENT_TAB_FONT_ATTR  => null,',
'    P_CURRENT_IMAGE_TAB          => null,',
'    P_NON_CURRENT_IMAGE_TAB      => null,',
'    P_TOP_CURRENT_TAB            => null,',
'    P_TOP_CURRENT_TAB_FONT_ATTR  => null,',
'    P_TOP_NON_CURR_TAB           => null,',
'    P_TOP_NON_CURR_TAB_FONT_ATTR => null,',
'    P_BOX                        => ''#BOX_BODY#'',',
'    P_NAVIGATION_BAR             => null,',
'    P_BODY_TITLE                 => null,',
'    P_NOTIFICATION_MESSAGE       => null,',
'    P_REGION_TABLE_CATTRIBUTES   => null, ',
'    P_ERROR_PAGE_TEMPLATE        => null,',
'    P_REQUIRED_PATCH             => null,',
'    P_TEMPLATE_COMMENT           => null',
')'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido crear la plantilla'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(122619509673470584.4001)
,p_process_success_message=>'Plantilla Creada'
);
end;
/
prompt --application/pages/page_00929
begin
wwv_flow_api.create_page(
 p_id=>929.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Importar Comentarios'
,p_step_title=>'Importar Comentarios'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208149926450631689.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472699825850672243.4001)
,p_plug_name=>unistr('Archivo no V\00E1lido')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('El archivo no es un archivo de exportaci\00F3n de comentarios de &PRODUCT_NAME. v\00E1lido.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472700016100672245.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472700230157672246.4001)
,p_plug_name=>'Importar Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747146940864138174.4001)
,p_plug_name=>'Importar Comentarios'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(908084617385693502.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472699825850672243.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472700425241672247.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208149926450631689.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472700607089672254.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208149926450631689.4001)
,p_button_name=>'IMPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Importar Comentarios'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472703918886672369.4001)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(472700607089672254.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472700829097672254.4001)
,p_name=>'P929_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472700230157672246.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472702231897672289.4001)
,p_name=>'P929_VERSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472700230157672246.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p929_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472733510724079114.4001)
,p_name=>'P929_FEEDBACK_ORIGIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472700230157672246.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Exportar desde:'
,p_source=>'wwv_flow_imp_parser.get_feedback_origin(:p929_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el sistema desde el que se han exportado los comentarios.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(472703302044672348.4001)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p929_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de &PRODUCT_NAME.)')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(472703531042672354.4001)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de comentarios de &PRODUCT_NAME. v\00E1lido.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472703705055672355.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import feedback'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_imp_parser.parse (',
'        p_file_id => :P929_FILE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al importar los comentarios.'
,p_process_when_button_id=>wwv_flow_api.id(472700607089672254.4001)
,p_process_success_message=>'Comentarios importados.'
);
end;
/
prompt --application/pages/page_00931
begin
wwv_flow_api.create_page(
 p_id=>931.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Lista: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146431708903979941.4001)
,p_plug_name=>'Crear Plantilla de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148049528950021491.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177054803779114133.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146436316525989142.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(177054803779114133.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146439326914992121.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(177054803779114133.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19625019685840569.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(177054803779114133.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177373616310154911.4001)
,p_branch_action=>'4069'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(146439326914992121.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P931_SELECT'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585124586039099808.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19625019685840569.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(147659632655442464.4001)
,p_branch_action=>'935'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(146439326914992121.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P931_SELECT'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146446301114013967.4001)
,p_name=>'F4000_P931_SELECT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(146431708903979941.4001)
,p_item_default=>'COPY'
,p_prompt=>'Crear Plantillas de Lista:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LIST_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_api.id(86596530905253701.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Select Default Templates (recommended), or create a new template from scratch?'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585124301509099806.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(146436316525989142.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585124468241099807.4001)
,p_event_id=>wwv_flow_api.id(585124301509099806.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00933
begin
wwv_flow_api.create_page(
 p_id=>933.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Propiedades de Hoja de C\00E1lculo Web')
,p_step_title=>unistr('Propiedades de Hoja de C\00E1lculo Web')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(488391710691971044)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46252215917678999.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460692301362600895.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460702222727622194.4001)
,p_plug_name=>unistr('Informaci\00F3n Adicional')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460702631385624664.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_name=>'AUTH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460702804504626373.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460730220181687618.4001)
,p_plug_name=>unistr('Informaci\00F3n de Auditor\00EDa')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460761227622002010.4001)
,p_plug_name=>unistr('Propiedades de Hoja de C\00E1lculo Web')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460762716802017768.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice esta p\00E1gina para gestionar las propiedades b\00E1sicas de la hoja de c\00E1lculo web y para suprimir la hoja. La p\00E1gina inicial identifica la p\00E1gina, cuadr\00EDcula de datos o informe que se mostrar\00E1 a los usuarios por defecto. El nombre de la hoja de')
||unistr(' c\00E1lculo web se muestra en la ruta de navegaci\00F3n. Puede cambiar otras propiedades en Propiedades de Hoja de C\00E1lculo Web mientras la hoja de c\00E1lculo web est\00E9 en ejecuci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461282112691512052.4001)
,p_plug_name=>'Logotipo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491291900336598292.4001)
,p_plug_name=>'SQL'
,p_region_name=>'SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(486473228590673445.4001)
,p_name=>'Objetos Sugeridos'
,p_parent_plug_id=>wwv_flow_api.id(491291900336598292.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       object_name, ',
'       object_comment,',
'       ws_app_id',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id and ',
'       ws_app_id = :P933_ID',
' order by 2'))
,p_header=>unistr('<p>Se puede utilizar SQL en las etiquetas SQL e informes. A continuaci\00F3n podr\00E1 consultar una lista de objetos sugeridos que pueden resultar de inter\00E9s para la aplicaci\00F3n.</p>')
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No hay objetos asociados.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(486473508088673456.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Edit'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(486473717504673460.4001)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre del Objeto'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492617106841272111.4001)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Comentario'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(486484231417778369.4001)
,p_query_column_id=>4
,p_column_alias=>'WS_APP_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Application'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492597930783957389.4001)
,p_query_column_id=>5
,p_column_alias=>'LINK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'f?p=&APP_ID.:559:&SESSION.::&DEBUG.:559:P559_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="Edit">'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_derived_column=>'Y'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1259241418996574651.4001)
,p_plug_name=>unistr('Antig\00FCedad')
,p_region_css_classes=>'a-Alert--page a-Alert--noTitle'
,p_icon_css_classes=>'icon-warning'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source=>unistr('Las hojas de c\00E1lculo web est\00E1n en desuso en esta versi\00F3n de APEX. A pesar de que las hojas de c\00E1lculo web seguir\00E1n funcionando por ahora, esta funci\00F3n se eliminar\00E1 de las versiones posteriores de APEX.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(628478600647213097.4001)
,p_button_sequence=>35
,p_button_plug_id=>wwv_flow_api.id(460702804504626373.4001)
,p_button_name=>'DISPLAY_ACL_TABLE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Roles de Control de Acceso'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:popupURL(''f?p=&APP_ID.:119:&APP_SESSION.'')'
,p_button_execute_validations=>'N'
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488278431602936346.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(460702804504626373.4001)
,p_button_name=>'EDIT_ACL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Editar Lista de Control de Acceso'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:934:&SESSION.::&DEBUG.:934::'
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486483208776762369.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(486473228590673445.4001)
,p_button_name=>'APPLY_CHANGE_ADD_OBJECT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Objeto'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460692630113600900.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(460761227622002010.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460749403352767949.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(460761227622002010.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:936:&SESSION.::&DEBUG.:936:P936_ID:&P933_ID.'
,p_button_condition=>'P933_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460692512183600898.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(460761227622002010.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P933_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(44255405487642737.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(460761227622002010.4001)
,p_button_name=>'RUN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ejecutar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'ws?p=&P933_ID.:home:'
,p_button_condition=>'P933_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'launch-aut'
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(506269132243176573.4001)
,p_branch_action=>'f?p=&APP_ID.:559:&SESSION.::&DEBUG.:559::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>5
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGE_ADD_OBJECT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(460692917928600901.4001)
,p_branch_action=>'f?p=&APP_ID.:933:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27380322926550506.4001)
,p_name=>'P933_EMAIL_FROM'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Direcci\00F3n de Origen de Correo Electr\00F3nico de Hoja de C\00E1lculo Web')
,p_source=>'EMAIL_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina la direcci\00F3n de correo electr\00F3nico que se utiliza como direcci\00F3n de origen en la hoja de c\00E1lculo web. Esta direcci\00F3n de correo electr\00F3nico de origen se utiliza al enviar un correo electr\00F3nico desde la descarga de correo electr\00F3nico del i')
||unistr('nforme o cuadr\00EDcula de datos en la hoja de c\00E1lculo web.</p>'),
'Ejemplo:',
'<ul>',
'<li><code>john.doe@example.com</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39475418512848293.4001)
,p_name=>'P933_LDAP_USERNAME_ESCAPING'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Escape de Nombre de Usuario de LDAP'
,p_source=>'LDAP_USERNAME_ESCAPING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LDAP_USERNAME_ESCAPING'
,p_lov=>'.'||wwv_flow_api.id(39475531325852002.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Antes de realizar la sustituci\00F3n <strong>%LDAP_USER%</strong> en el nombre distinguido de LDAP y en la cadena de b\00FAsqueda,'),
'&PRODUCT_NAME. puede omitir caracteres especiales en el nombre de usuario.',
'<p/>',
'Las posibles reglas para omitir son las siguientes:',
'<ul>',
unistr('<li><strong>Est\00E1ndar</strong>:'),
unistr('Omite caracteres adicionales basados en RFC 4514 (para nombres distinguidos) y RFC 4515 (para cadenas de b\00FAsqueda).'),
unistr('Adem\00E1s, omite caracteres Unicode.'),
unistr('\00C9ste es el valor m\00E1s seguro, pero puede causar problemas con algunos servidores de LDAP.</li>'),
unistr('<li><strong>S\00F3lo Caracteres Especiales</strong>:'),
unistr('Omite caracteres especiales basados en RFC 4514 (para nombres distinguidos) y RFC 4515 (para cadenas de b\00FAsqueda).'),
'No omite caracteres Unicode.</li>',
unistr('<li><strong>Sin Omisi\00F3n</strong>:'),
unistr('No omite ning\00FAn car\00E1cter.'),
'Este valor es potencialmente inseguro,',
unistr('a menos que se utilice la <strong>Funci\00F3n de Edici\00F3n de Nombre de Usuario</strong> que ya'),
'omita el nombre de usuario (por ejemplo, con apex_escape.ldap_dn o apex_escape.ldap_search_filter).</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39477908572977943.4001)
,p_name=>'P933_COOKIE_NAME'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Cookie'
,p_source=>'COOKIE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de la cookie de sesi\00F3n que se necesita para identificar una sesi\00F3n de &PRODUCT_NAME., junto con el IDde sesi\00F3n de la URL. Si no se especifica ning\00FAn valor para el nombre de cookie de sesi\00F3n, &PRODUCT_NAME. selecciona un valor por defecto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39478116883980336.4001)
,p_name=>'P933_COOKIE_PATH'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ruta de Acceso de Cookie'
,p_source=>'COOKIE_PATH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributo de ruta de acceso para la cookie de sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39478603162985848.4001)
,p_name=>'P933_COOKIE_DOMAIN'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dominio de Cookie'
,p_source=>'COOKIE_DOMAIN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributo de dominio para la cookie de sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39478821863991240.4001)
,p_name=>'P933_USE_SECURE_COOKIE_YN'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proteger'
,p_source=>'USE_SECURE_COOKIE_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para que el explorador env\00EDe la cookie de gesti\00F3n de sesi\00F3n s\00F3lo cuando el protocolo sea HTTPS. '),
unistr('Seleccione <strong>Desactivado</strong> para que el explorador env\00EDe la cookie de gesti\00F3n de sesi\00F3n cuando el protocolo sea HTTP o HTTPS.'),
'</p>',
'<p>',
unistr('Si SSL est\00E1 configurado en el servidor web,'),
unistr('debe seleccionar <strong>Activado</strong> para reforzar la seguridad de la aplicaci\00F3n evitando el tr\00E1fico HTTP no cifrado.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(342361572482652532.4001)
,p_name=>'P933_COOKIE_TYPE'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de uso compartido de sesi\00F3n')
,p_source=>'COOKIE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION COOKIE SHARING'
,p_lov=>'.'||wwv_flow_api.id(46630896750249951.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Defina qu\00E9 tipo de cookie de sesi\00F3n debe utilizar esta aplicaci\00F3n.'),
unistr('Puede utilizar este atributo para compartir la misma sesi\00F3n de &PRODUCT_NAME. entre varias aplicaciones de un espacio de trabajo.'),
unistr('Con el uso compartido de sesi\00F3n, los usuarios pueden navegar perfectamente entre aplicaciones sin necesidad de iniciar sesi\00F3n varias veces.'),
'</p><p>',
'<ul>',
unistr('    <li><em>Aplicaci\00F3n (no de uso compartido)</em>: la cookie de sesi\00F3n es espec\00EDfica de esta aplicaci\00F3n.'),
'        Las sesiones no se comparten con otras aplicaciones.</li>',
unistr('    <li><em>Uso compartido de espacio de trabajo</em>: la sesi\00F3n se comparte con otras aplicaciones de este espacio de trabajo'),
unistr('        si estas tambi\00E9n tienen <em>tipo de cookie</em> definido en <em>Uso compartido de espacio de trabajo</em>.</li>'),
unistr('    <li><em>Personalizado</em>: defina atributos de cookie de sesi\00F3n personalizados.</li>'),
'</ul>    ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348153522431356508.4001)
,p_name=>'P933_SHOW_RESET_PASSWD_YN'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Mostrar Restablecer Contrase\00F1a')
,p_source=>'SHOW_RESET_PASSWD_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'wwv_flow_ws_security.ws_auth_type(p_websheet_application_id=>:P933_ID) = ''1'' '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Controla la visualizaci\00F3n del enlace Restablecer Contrase\00F1a en la p\00E1gina de conexi\00F3n. Este enlace permite a los usuarios restablecer sus contrase\00F1as. Esta opci\00F3n s\00F3lo funciona si la aplicaci\00F3n utiliza la autenticaci\00F3n de la cuenta de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460693122619600902.4001)
,p_name=>'P933_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Hoja de C\00E1lculo Web:')
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identificador \00FAnico de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460693311067600913.4001)
,p_name=>'P933_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica el nombre de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460693516057600913.4001)
,p_name=>'P933_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(460702222727622194.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario:'
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica al usuario que es el propietario de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460693705158600913.4001)
,p_name=>'P933_DESCRIPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(460702222727622194.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Descripci\00F3n opcional de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460693906220600919.4001)
,p_name=>'P933_STATUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Estado'
,p_source=>'STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION STATUS'
,p_lov=>'.'||wwv_flow_api.id(461314228761951916.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el estado de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460694731638600922.4001)
,p_name=>'P933_CREATED_BY'
,p_is_required=>true
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(460730220181687618.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Creado por:'
,p_source=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Usuario que ha creado la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460694904240600923.4001)
,p_name=>'P933_CREATED_ON'
,p_is_required=>true
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(460730220181687618.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Fecha de Creaci\00F3n:')
,p_source=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Fecha en la que se cre\00F3 la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460695303496600926.4001)
,p_name=>'P933_UPDATED_BY'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(460730220181687618.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Actualizado por:'
,p_source=>'UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Usuario que actualiz\00F3 por \00FAltima vez la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460695510399600926.4001)
,p_name=>'P933_UPDATED_ON'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(460730220181687618.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Actualizado el:'
,p_source=>'UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Fecha en la que se actualiz\00F3 por \00FAltima vez la definici\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460696127940600928.4001)
,p_name=>'P933_HOME_PAGE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina Inicial')
,p_source=>'HOME_PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET HOME PAGE SELECTOR (P933)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :P933_ID and',
'      security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la p\00E1gina inicial de la aplicaci\00F3n. \00C9sta ser\00E1 la p\00E1gina de inicio por defecto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460696501176600930.4001)
,p_name=>'P933_AUTHENTICATION'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Autenticaci\00F3n:')
,p_source=>'AUTHENTICATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WEBSHEET AUTHENTICATION'
,p_lov=>'.'||wwv_flow_api.id(460742018651713171.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el m\00E9todo de autenticaci\00F3n de los usuarios de la aplicaci\00F3n.'),
'<p>',
'<ul>',
'<li>',
unistr('Cuenta de Application Express: autenticaci\00F3n con el nombre de usuario y la contrase\00F1a de la cuenta de un desarrollador.'),
'<li>',
unistr('Single Sign-On: autenticaci\00F3n a trav\00E9s de Oracle AS Single Sign-On. Debe configurarse para la instancia de &PRODUCT_NAME..'),
'<li>',
unistr('LDAP: autenticaci\00F3n a trav\00E9s de un directorio LDAP. Especifique los par\00E1metros adicionales en esta p\00E1gina para configurar este m\00E9todo.'),
'<li>',
unistr('Personalizado: proporcione su propio c\00F3digo para la autenticaci\00F3n y la realizaci\00F3n de algunas tareas de gesti\00F3n de sesiones.'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460696715904600930.4001)
,p_name=>'P933_ACL_TYPE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(460702804504626373.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Lista de Control de Acceso:'
,p_source=>'ACL_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_APP_ACL_TYPE'
,p_lov=>'.'||wwv_flow_api.id(460746220203713213.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Si el tipo de autenticaci\00F3n es &PRODUCT_NAME., elija si la autorizaci\00F3n la determinar\00E1 el rol del espacio de trabajo &PRODUCT_NAME. o bien la lista de control de acceso. Para el resto de tipos de autenticaci\00F3n que no sean el de &PRODUCT_NAME., la aut')
||unistr('orizaci\00F3n la determinar\00E1 la lista de control de acceso siempre.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460696903024600931.4001)
,p_name=>'P933_DATE_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Formato de Fecha de Aplicaci\00F3n')
,p_source=>'DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATE_FORMAT_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el formato de fecha que se va a utilizar en la aplicaci\00F3n.</p>'),
unistr('<p>Este formato de fecha se utiliza para modificar el valor de sesi\00F3n de base de datos <code>NLS_DATE_FORMAT</code> antes de mostrar o ejecutar cualquier p\00E1gina de la aplicaci\00F3n. Este valor puede ser una cadena de literales que contenga una m\00E1scara d')
||unistr('e formato de fecha v\00E1lida de Oracle o una referencia de elemento que utilice una sintaxis de sustituci\00F3n. Si no se especifica ning\00FAn valor, el formato de fecha por defecto se deriva de la sesi\00F3n de base de datos en tiempo de ejecuci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>Mes DD, AAAA</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461282308574512056.4001)
,p_name=>'P933_LOGO_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(461282112691512052.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NONE'
,p_prompt=>'Tipo de Logotipo:'
,p_source=>'LOGO_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_LOGO_TYPES'
,p_lov=>'.'||wwv_flow_api.id(461275327966469166.4001)||'.'
,p_cSize=>60
,p_cMaxlength=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de logotipo utilizado para la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461282917989512058.4001)
,p_name=>'P933_LOGO_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(461282112691512052.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logotipo'
,p_source=>'LOGO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>500
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca una cadena de texto completa que se utilizar\00E1 como el logotipo de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461284116730512060.4001)
,p_name=>'P933_LOGO_IMAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(461282112691512052.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logotipo'
,p_source=>'LOGO_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Cargue una imagen para utilizarla como logotipo de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DB_COLUMN'
,p_attribute_02=>'LOGO_IMAGE_MIMETYPE'
,p_attribute_03=>'LOGO_IMAGE_FILENAME'
,p_attribute_04=>'LOGO_IMAGE_CHARSET'
,p_attribute_05=>'LOGO_IMAGE_LAST_UPDATE'
,p_attribute_06=>'Y'
,p_attribute_07=>'Descargar'
,p_attribute_08=>'inline'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461284710431512062.4001)
,p_name=>'P933_LOGO_IMAGE_ATTRIBUTES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(461282112691512052.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Logotipo'
,p_source=>'LOGO_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Atributos del logotipo. Ejemplo:',
unistr('<pre>width="100" height="20" alt="Logotipo de la Compa\00F1\00EDa"</pre>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461285315230512063.4001)
,p_name=>'P933_LOGO_FILEPATH'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(461282112691512052.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logotipo'
,p_source=>'LOGO_FILEPATH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el nombre completo de la imagen, incluida la extensi\00F3n del nombre de archivo. Por ejemplo:'),
'<pre>/i/oracle.gif</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461285900540512063.4001)
,p_name=>'P933_LOGO_FILEPATH_ATTRIBUTES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(461282112691512052.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Logotipo'
,p_source=>'LOGO_FILEPATH_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Atributos del logotipo. Ejemplo:',
unistr('<pre>width="100" height="20" alt="Logotipo de la Compa\00F1\00EDa"</pre>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461354030473501197.4001)
,p_name=>'P933_ORIG_AUTHENTICATION'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P933_AUTHENTICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461354205183501199.4001)
,p_name=>'P933_LOGOUT_URL'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL de Desconexi\00F3n')
,p_source=>'LOGOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique una URL para convertirla en el atributo LOGOUT URL de esta aplicaci\00F3n. '),
unistr('Se hace referencia a este atributo en enlaces de desconexi\00F3n como &amp;LOGOUT_URL..'),
unistr('<br>Si esta aplicaci\00F3n utiliza la verificaci\00F3n de sesi\00F3n incorporada, se puede utilizar "wwv_flow_custom_auth_std.ws_logout?p_websheet_app_id=&amp;WS_APP_ID.&amp;p_next_url=ws?p=&amp;WS_APP_ID.:home" para llamar a un procedimiento de desconexi\00F3n inco')
||'rporado. ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461354422243501199.4001)
,p_name=>'P933_LDAP_HOST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Host LDAP'
,p_source=>'LDAP_HOST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.HOSTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_01 d,',
'       attribute_01 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_01 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Nombre del host del servidor de directorios LDAP.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461354613976501200.4001)
,p_name=>'P933_LDAP_PORT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Puerto LDAP'
,p_source=>'LDAP_PORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.PORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_02 d,',
'       attribute_02 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_02 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>5
,p_cMaxlength=>20
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('N\00FAmero de puerto del host de directorio LDAP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461354823200501200.4001)
,p_name=>'P933_LDAP_STRING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cadena LDAP'
,p_source=>'LDAP_STRING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.STRINGS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_04 d,',
'       attribute_04 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_04 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el patr\00F3n utilizado para crear el nombre distintivo (DN) totalmente cualificado en DBMS_LDAP.SIMPLE_BIND_S si se va a utilizar el DN exacto; o la base de b\00FAsqueda si no se va a utilizar un DN exacto. Utilice <strong>%LDAP_USER%</strong> co')
||'mo la variable del nombre de usuario. Por ejemplo:',
'<p>',
'<strong>DN Exacto</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=dominio,dc=com',
'</p>',
'<p>',
unistr('<strong>DN no Exacto (Base de B\00FAsqueda)</strong>'),
'</p>',
'<p>',
'dc=dominio,dc=com',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461355003309501201.4001)
,p_name=>'P933_EDIT_FUNCTION'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n de Edici\00F3n de Nombre de Usuario de LDAP')
,p_source=>'LDAP_EDIT_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.USERNAME.EDIT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_07 d,',
'       attribute_07 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_07 is not null',
'   and security_group_id = :WORKSPACE_ID',
' union',
'select ''return wwv_flow_custom_auth_std.ldap_dnprep;'' as d,',
'       ''return wwv_flow_custom_auth_std.ldap_dnprep;'' as r',
'  from dual',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Puede proporcionar m\00E1s c\00F3digo para su ejecuci\00F3n y transformar el nombre de usuario en un formato perfectamente adaptado a la entrada de directorio LDAP o al nombre de usuario LDAP.'),
'La variable de enlace :USERNAME contiene el nombre especificado por el usuario final.',
unistr('Por ejemplo, el siguiente c\00F3digo llama a una funci\00F3n que sustituye todos los "."'' por "_"'' en la cadena DN:</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. omitir\00E1 el nombre de usuario devuelto seg\00FAn el atributo de autenticaci\00F3n <strong>Omisi\00F3n de Nombre de Usuario</strong>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461355210265501201.4001)
,p_name=>'P933_PAGE_SENTRY_FUNCTION'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n de Protecci\00F3n de P\00E1gina')
,p_source=>'PAGE_SENTRY_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta funci\00F3n la ejecuta el motor de &PRODUCT_NAME. antes de mostrar o procesar cada p\00E1gina. Si esta funci\00F3n devuelve un valor falso (indicando por ejemplo que el usuario no est\00E1 conectado), el motor lo redirigir\00E1 a una p\00E1gina de conexi\00F3n.'),
'<br>',
unistr('Si el valor de este campo est\00E1 definido en ''-DATABASE-'' no se eval\00FAa ninguna funci\00F3n. En su lugar, se considera que la sesi\00F3n es v\00E1lida y se obtiene el nombre de usuario a partir del nombre de usuario de sesi\00F3n de la base de datos conectada, como lo ')
||unistr('proporciona la configuraci\00F3n de DAD.'),
'<p>',
unistr('Especifique un cuerpo de la funci\00F3n PL/SQL en uno de estos formatos:'),
'<ul>',
'<li>',
'return function-name;',
'<li>',
'return package.function-name;',
'<li>',
'return schema.package.function-name;',
'<li>',
'return true; /* siempre devuelve un valor verdadero: para pruebas */',
'',
'<li>',
'return false; /* siempre devuelve un valor falso: para pruebas */',
'<li>',
'begin',
'&nbsp;&nbsp;if condition then return true;',
'&nbsp;&nbsp;else return false;',
'&nbsp;&nbsp;end if;',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461355413905501201.4001)
,p_name=>'P933_SESS_VERIFY_FUNCTION'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n de Verificaci\00F3n de Sesi\00F3n')
,p_source=>'SESS_VERIFY_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta funci\00F3n determina si existe o no una sesi\00F3n v\00E1lida.'),
'<p>',
unistr('Especifique un cuerpo de la funci\00F3n PL/SQL en uno de estos formatos:'),
'<ul>',
'<li>',
'return function-name;',
'<li>',
'return package.function-name;',
'<li>',
'return schema.package.function-name;',
'<li>',
'return true; /* siempre devuelve un valor verdadero: para pruebas */',
'<li>',
'return false; /* devuelve un valor falso: para pruebas */',
'<li>',
'begin',
'&nbsp;&nbsp;if condition then return true;',
'&nbsp;&nbsp;else return false;',
'&nbsp;&nbsp;end if;',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461355613340501202.4001)
,p_name=>'P933_PRE_AUTH_PROCESS'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Proceso Anterior a la Autenticaci\00F3n')
,p_source=>'PRE_AUTH_PROCESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca un bloque PL/SQL que se ejecutar\00E1 despu\00E9s de que se ejecute la p\00E1gina de conexi\00F3n y justo antes de que se realice la verificaci\00F3n de credenciales.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461355831507501202.4001)
,p_name=>'P933_AUTH_FUNCTION'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n de Autenticaci\00F3n')
,p_source=>'AUTH_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la funci\00F3n que verificar\00E1 las credenciales de conexi\00F3n del usuario.'),
'<p>',
unistr('Llame a una funci\00F3n PL/SQL que compruebe el nombre de usuario/contrase\00F1a y devuelva un valor booleano.'),
unistr('Introduzca un nombre de funci\00F3n como el siguiente: return fn , donde fn es el nombre de la funci\00F3n, cualificado por nombre de esquema, nombre de paquete, si es necesario. '),
unistr('Esta funci\00F3n debe conseguir que la firma (p_username en varchar2, p_password en varchar2) devuelva un valor booleano.'),
unistr('Los valores de los campos de usuario y contrase\00F1a, introducidos en la p\00E1gina de conexi\00F3n, se transferir\00E1n a la funci\00F3n. ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461356025219501202.4001)
,p_name=>'P933_POST_AUTH_PROCESS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Proceso Posterior a la Autenticaci\00F3n')
,p_source=>'POST_AUTH_PROCESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca un bloque PL/SQL que se ejecutar\00E1 despu\00E9s de la autenticaci\00F3n (verificaci\00F3n de las credenciales de conexi\00F3n).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461356206151501203.4001)
,p_name=>'P933_INVALID_SESSION_URL'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL de Sesi\00F3n no V\00E1lida')
,p_source=>'INVALID_SESSION_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique una URL a la que se redirigir\00E1 &PRODUCT_NAME. si no hay ninguna sesi\00F3n v\00E1lida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484542416766730982.4001)
,p_name=>'P933_ALLOW_PUBLIC_ACCESS_YN'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(460702804504626373.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Permitir Acceso P\00FAblico')
,p_source=>'ALLOW_PUBLIC_ACCESS_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Defina en <strong>Activado</strong> para permitir que los usuarios ejecuten la aplicaci\00F3n en modo de solo lectura sin que sea necesario conectarse. Si se define en <strong>Desactivado</strong>, todos los usuarios deber\00E1n conectarse para ejecutar la a')
||unistr('plicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(491292121807604494.4001)
,p_name=>'P933_ALLOW_SQL_YN'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(491291900336598292.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Permitir SQL'
,p_source=>'ALLOW_SQL_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Permitir el uso de etiquetas e informes SQL en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492081011543945431.4001)
,p_name=>'P933_LOGIN_PAGE_MESSAGE'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(460702222727622194.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje de Conexi\00F3n')
,p_source=>'LOGIN_PAGE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Permite mostrar este mensaje en la p\00E1gina de conexi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(496224304298958207.4001)
,p_name=>'P933_USE_SSL'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Usar SSL:'
,p_source=>'LDAP_USE_SSL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LDAP_SSL_LOV'
,p_lov=>'.'||wwv_flow_api.id(487674627120619297.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Elija si desea utilizar SSL para enlazar al directorio LDAP. Si se elige SSL con la autenticaci\00F3n, deber\00E1 configurar una cartera para la instancia de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(496225529578965544.4001)
,p_name=>'P933_USE_EXACT_DN'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Usar Nombre Distinguido Exacto (DN):'
,p_source=>'LDAP_USE_EXACT_DN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Elija si el nombre distintivo (DN) de LDAP ser\00E1 exacto o no. Si no lo es, se convertir\00E1 en la base de b\00FAsqueda y deber\00E1 proporcionar un filtro de b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(496226023129973102.4001)
,p_name=>'P933_SEARCH_FILTER'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(460702631385624664.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Filtro de B\00FAsqueda')
,p_source=>'LDAP_SEARCH_FILTER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.SEARCH_FILTER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_06 d,',
'       attribute_06 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_06 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el filtro de b\00FAsqueda cuando no utilice un nombre distintivo (DN) exacto. Utilice <strong>%LDAP_USER%</strong> como marcador de posici\00F3n del nombre de usuario. Por ejemplo:'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502719204788191365.4001)
,p_name=>'P933_LANGUAGE'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.get_g_session_lang'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Idioma de la Aplicaci\00F3n por Defecto')
,p_source=>'LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>'.'||wwv_flow_api.id(631619712812572565.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifica el idioma por defecto de la aplicaci\00F3n. Los usuarios tendr\00E1n que cambiar su preferencia de idioma desde la aplicaci\00F3n. Esta lista de idiomas se determina por las versiones traducidas de &PRODUCT_NAME. que est\00E1n instaladas.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502721427775207425.4001)
,p_name=>'P933_TERRITORY'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(460692301362600895.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_territory varchar2(255);',
'begin',
'    l_territory := wwv_flow_lang.get_g_session_territory;',
'    if l_territory is null then',
'        for c1 in (select nls_territory',
'                     from wwv_flow_languages',
'                    where lang_id = nvl(wwv_flow_lang.get_g_session_lang,''en'')) loop',
'            l_territory := c1.nls_territory;',
'            exit;',
'        end loop;',
'    end if;',
'    if l_territory is null then',
'        l_territory := ''AMERICA'';',
'    end if;',
'    return l_territory;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Territorio de la Aplicaci\00F3n por Defecto')
,p_source=>'TERRITORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_TERRITORIES'
,p_lov=>'.'||wwv_flow_api.id(634612723768159258.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el territorio por defecto de la aplicaci\00F3n que controla atributos como el idioma de las fechas y los caracteres num\00E9ricos. Los usuarios podr\00E1n cambiar la preferencia de su territorio desde la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(810143307497917635.4001)
,p_name=>'P933_ALLOW_PUBLIC_ACCESS_ORIG'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(460702804504626373.4001)
,p_item_default=>'N'
,p_prompt=>'Allow Public Access'
,p_source=>'P933_ALLOW_PUBLIC_ACCESS_YN'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Si se define en ''S\00ED'', permite a los usuarios ejecutar la aplicaci\00F3n en el modo de s\00F3lo lectura sin que sea necesario conectarse. Si se define en ''No'', todos los usuarios deber\00E1n conectarse para poder ejecutar la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(461369308712598937.4001)
,p_computation_sequence=>10
,p_computation_item=>'P933_ACL_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'CUSTOM'
,p_compute_when=>'P933_ACL_TYPE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(487242506698622145.4001)
,p_computation_sequence=>20
,p_computation_item=>'P933_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'ltrim(rtrim(:P933_NAME))'
,p_compute_when=>'SAVE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(461370206549617212.4001)
,p_validation_name=>'ACL must contain an admin'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_apex$_schema varchar2(30);',
'begin',
'  for c1 in (select schema',
'               from wwv_flow_company_schemas',
'              where security_group_id = wwv_flow_security.g_security_group_id',
'                and IS_APEX$_SCHEMA = ''Y'' ) loop',
'    wwv_flow_security.g_apex$_schema := c1.schema;',
'  end loop;',
'  return wwv_flow_ws_security.admin_exists(p_username=>null,p_websheet_app_id=>:P933_ID);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe haber un administrador en la lista de control de acceso para poder cambiarla a una lista de tipo personalizado.'
,p_validation_condition=>'P933_ACL_TYPE'
,p_validation_condition2=>'CUSTOM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(460692512183600898.4001)
,p_associated_item=>wwv_flow_api.id(460696715904600930.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(27443931893600442.4001)
,p_validation_name=>'P933_EMAIL_FROM is valid'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at   number;',
'  l_dot  number;',
'begin',
'  l_at := instr(:P933_EMAIL_FROM,''@'');',
'  l_dot := instr(:P933_EMAIL_FROM,''.'',l_at);',
'  if l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1 then',
'      return true;',
'  end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Direcci\00F3n de correo electr\00F3nico no v\00E1lida')
,p_validation_condition=>'P933_EMAIL_FROM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(460692512183600898.4001)
,p_associated_item=>wwv_flow_api.id(27380322926550506.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461367812259581092.4001)
,p_name=>'Set ACL Type to Custom'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_AUTHENTICATION'
,p_condition_element=>'P933_AUTHENTICATION'
,p_triggering_condition_type=>'NOT_IN_LIST'
,p_triggering_expression=>'1,5'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461368401308587375.4001)
,p_event_id=>wwv_flow_api.id(461367812259581092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_ACL_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'CUSTOM'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461368810658590040.4001)
,p_event_id=>wwv_flow_api.id(461367812259581092.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_ACL_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461368129478581092.4001)
,p_event_id=>wwv_flow_api.id(461367812259581092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_ACL_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461360532466520626.4001)
,p_name=>'HIDE ALL LOGO'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_LOGO_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461360828665520628.4001)
,p_event_id=>wwv_flow_api.id(461360532466520626.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_LOGO_TEXT,P933_LOGO_IMAGE,P933_LOGO_IMAGE_ATTRIBUTES,P933_LOGO_FILEPATH,P933_LOGO_FILEPATH_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461361807794532450.4001)
,p_name=>'SHOW LOGO TEXT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_LOGO_TYPE'
,p_condition_element=>'P933_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TEXT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461362103217532451.4001)
,p_event_id=>wwv_flow_api.id(461361807794532450.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_LOGO_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461363609657542446.4001)
,p_name=>'SHOW LOGO IMAGE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_LOGO_TYPE'
,p_condition_element=>'P933_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'IMAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461363914419542447.4001)
,p_event_id=>wwv_flow_api.id(461363609657542446.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_LOGO_IMAGE,P933_LOGO_IMAGE_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461364226972547484.4001)
,p_name=>'SHOW LOGO FILEPATH'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_LOGO_TYPE'
,p_condition_element=>'P933_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILEPATH'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461364503636547485.4001)
,p_event_id=>wwv_flow_api.id(461364226972547484.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_LOGO_FILEPATH,P933_LOGO_FILEPATH_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(491517507101464051.4001)
,p_name=>'Show Sug Obj when ALLOW_SQL_YN = Y'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_ALLOW_SQL_YN'
,p_condition_element=>'P933_ALLOW_SQL_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(491517813043464052.4001)
,p_event_id=>wwv_flow_api.id(491517507101464051.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(486473228590673445.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(491772928076376167.4001)
,p_event_id=>wwv_flow_api.id(491517507101464051.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(486473228590673445.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496363306141516932.4001)
,p_name=>'show/hide LDAP'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_AUTHENTICATION'
,p_condition_element=>'P933_AUTHENTICATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'3'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496363624752516935.4001)
,p_event_id=>wwv_flow_api.id(496363306141516932.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_LDAP_PORT,P933_LDAP_HOST,P933_USE_SSL,P933_USE_EXACT_DN,P933_LDAP_STRING,P933_SEARCH_FILTER,P933_EDIT_FUNCTION,P933_LDAP_USERNAME_ESCAPING'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496363818608516936.4001)
,p_event_id=>wwv_flow_api.id(496363306141516932.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_LDAP_PORT,P933_LDAP_HOST,P933_USE_SSL,P933_USE_EXACT_DN,P933_LDAP_STRING,P933_SEARCH_FILTER,P933_EDIT_FUNCTION,P933_LDAP_USERNAME_ESCAPING'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(496571902078922587.4001)
,p_name=>'show/hide LDAP search filter'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_USE_EXACT_DN'
,p_condition_element=>'P933_USE_EXACT_DN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496572201786922590.4001)
,p_event_id=>wwv_flow_api.id(496571902078922587.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_SEARCH_FILTER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(496572404466922591.4001)
,p_event_id=>wwv_flow_api.id(496571902078922587.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_SEARCH_FILTER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(497813929265135473.4001)
,p_name=>'show/hide Custom Auth'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_AUTHENTICATION'
,p_condition_element=>'P933_AUTHENTICATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'4'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(497814230865135475.4001)
,p_event_id=>wwv_flow_api.id(497813929265135473.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_PAGE_SENTRY_FUNCTION,P933_SESS_VERIFY_FUNCTION,P933_PRE_AUTH_PROCESS,P933_AUTH_FUNCTION,P933_POST_AUTH_PROCESS,P933_INVALID_SESSION_URL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(497814431454135478.4001)
,p_event_id=>wwv_flow_api.id(497813929265135473.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_PAGE_SENTRY_FUNCTION,P933_SESS_VERIFY_FUNCTION,P933_PRE_AUTH_PROCESS,P933_AUTH_FUNCTION,P933_POST_AUTH_PROCESS,P933_INVALID_SESSION_URL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(136606217608942643.4001)
,p_name=>'show/hide allowlist'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_ALLOW_SQL_YN'
,p_condition_element=>'P933_ALLOW_SQL_YN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(342361686952652533.4001)
,p_name=>'If C'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P933_COOKIE_TYPE'
,p_condition_element=>'P933_COOKIE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'C'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(342361707758652534.4001)
,p_event_id=>wwv_flow_api.id(342361686952652533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_COOKIE_NAME,P933_COOKIE_PATH,P933_COOKIE_DOMAIN,P933_USE_SECURE_COOKIE_YN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(342361813461652535.4001)
,p_event_id=>wwv_flow_api.id(342361686952652533.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P933_COOKIE_NAME,P933_COOKIE_PATH,P933_COOKIE_DOMAIN,P933_USE_SECURE_COOKIE_YN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460697112587600933.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WS_APP_AND_AUTH'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APP_AND_AUTH'
,p_attribute_03=>'P933_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460697301171600934.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WS_APP_AND_AUTH'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APP_AND_AUTH'
,p_attribute_03=>'P933_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :WORKSPACE_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_WS_APPLICATIONS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_security_scheme=>wwv_flow_api.id(770886849281707823)
);
end;
/
prompt --application/pages/page_00934
begin
wwv_flow_api.create_page(
 p_id=>934.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Lista de Control de Acceso'
,p_step_title=>'Lista de Control de Acceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(488391710691971044)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488268705271879682.4001)
,p_plug_name=>'Lista de Control de Acceso'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       c001 username,',
'       c002 priv',
'from wwv_flow_collections',
'where collection_name = ''APEX$_ACL'''))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(488268808752879682.4001)
,p_name=>'Access Control List'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(488269016140879688.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>' '
,p_column_link=>'f?p=&APP_ID.:937:&SESSION.::&DEBUG.:937:P937_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT.">'
,p_column_link_attr=>'title="&EDIT."'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(488269128054879692.4001)
,p_db_column_name=>'USERNAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(488269217074879694.4001)
,p_db_column_name=>'PRIV'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Privilegio'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(488361730864557325)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488272100949889692.4001)
,p_plug_name=>unistr('Aplicaci\00F3n &P934_APP_NAME.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>5
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488310913987959684.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Si la aplicaci\00F3n utiliza el tipo de autorizaci\00F3n personalizado, la lista de control de acceso gestionar\00E1 los privilegios de los usuarios de la aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(499054919273520959.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(488272100949889692.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:933:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488369815025660066.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(488272100949889692.4001)
,p_button_name=>'CREATE_ENTRY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Entrada'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:937:&SESSION.::&DEBUG.:937::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488309922513952620.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(488268705271879682.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:934:&SESSION.::&DEBUG.:RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488275312985912061.4001)
,p_name=>'P934_APP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(488272100949889692.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from WWV_FLOW_WS_APPLICATIONS',
'where id = :P933_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488270120557885875.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create ACL collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select schema',
'             from wwv_flow_company_schemas',
'            where security_group_id = :FLOW_SECURITY_GROUP_ID',
'              and IS_APEX$_SCHEMA = ''Y'' ) ',
'loop',
'   wwv_flow_security.g_apex$_schema := c1.schema;',
'end loop;',
'',
'wwv_flow_ws_api.create_acl_collection (',
'    p_ws_app_id => :P933_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la recopilaci\00F3n de ACL.')
,p_process_when=>'P933_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00935
begin
wwv_flow_api.create_page(
 p_id=>935.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Lista: Nombre'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(147496023172173284.4001)
,p_plug_name=>'Crear Plantilla de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148053315795027580.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186375503742161506.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147509416259188851.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186375503742161506.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147517307386195706.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186375503742161506.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(147513229764192676.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186375503742161506.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(100180521813100225.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585125830797099821.4001)
,p_branch_action=>'f?p=&APP_ID.:931:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(147513229764192676.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100183932679112805.4001)
,p_name=>'P935_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(147496023172173284.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifique el nuevo nombre de la plantilla de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100185309954115766.4001)
,p_name=>'P935_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(147496023172173284.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el tema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(100186321382119006.4001)
,p_name=>'P935_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(147496023172173284.4001)
,p_prompt=>'Clase de Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43918610013174571.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique la clase de tema de plantilla.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(100188102467123047.4001)
,p_validation_name=>'P935_NAME'
,p_validation_sequence=>10
,p_validation=>'P935_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(147517307386195706.4001)
,p_associated_item=>wwv_flow_api.id(100183932679112805.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(100190114241126435.4001)
,p_validation_name=>'P935_THEME'
,p_validation_sequence=>20
,p_validation=>'P935_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(147517307386195706.4001)
,p_associated_item=>wwv_flow_api.id(100185309954115766.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(100191221860128658.4001)
,p_validation_name=>'P935_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P935_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(147517307386195706.4001)
,p_associated_item=>wwv_flow_api.id(100186321382119006.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585125654032099819.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(147509416259188851.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585125754207099820.4001)
,p_event_id=>wwv_flow_api.id(585125654032099819.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(147895220712812627.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create List Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_list_template (',
'  p_flow_id                   => v(''fb_flow_id''),',
'  p_list_template_current     => null,',
'  p_list_template_noncurrent  => null,',
'  p_list_template_name        => :p935_name,',
'  p_list_template_before_rows => null,',
'  p_list_template_after_rows  => null,',
'  p_list_template_comment     => null,',
'  p_theme_id                  => :p935_theme,',
'  p_theme_class_id            => :p935_theme_class',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha creado la plantilla.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(147517307386195706.4001)
,p_process_success_message=>'Plantilla creada.'
);
end;
/
prompt --application/pages/page_00936
begin
wwv_flow_api.create_page(
 p_id=>936.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Confirmar Supresi\00F3n')
,p_step_title=>unistr('Confirmar Supresi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(488391710691971044)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(209265315077500411.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460755529728879647.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>21
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Si suprime una aplicaci\00F3n, se suprimir\00E1n tambi\00E9n todos sus componentes.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747147094502138174.4001)
,p_plug_name=>unistr('Confirmar Supresi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460753702239862173.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(209265315077500411.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:933:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460754011589864937.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(209265315077500411.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir Ahora Permanentemente'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(460757929428907926.4001)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460754517953876185.4001)
,p_name=>'P936_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(460755529728879647.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460754712872876187.4001)
,p_name=>'P936_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(460755529728879647.4001)
,p_prompt=>'Nombre:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flow_ws_applications ',
' where id = :P936_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nombre de la aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460754903005876187.4001)
,p_name=>'P936_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(460755529728879647.4001)
,p_prompt=>unistr('P\00E1ginas:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :P936_ID',
'and a.id = p.ws_app_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('N\00FAmero de p\00E1ginas de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460755100492876187.4001)
,p_name=>'P936_DATAGRIDS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(460755529728879647.4001)
,p_prompt=>unistr('Cuadr\00EDculas de Datos:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
' where w.id = a.worksheet_id and',
'       w.security_group_id = :flow_security_group_id and            ',
'       a.websheet_type = ''DATA'' and',
'       a.ws_app_id = :P936_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('N\00FAmero de cuadr\00EDculas de datos de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460755330356876188.4001)
,p_name=>'P936_REPORTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(460755529728879647.4001)
,p_prompt=>'Informes:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
' where w.id = a.worksheet_id and',
'       w.security_group_id = :flow_security_group_id and            ',
'       a.websheet_type = ''REPORT'' and',
'       a.ws_app_id = :P936_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('N\00FAmero de informes de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460754229943870179.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_ws_app (',
'    p_ws_app_id   => :P936_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido suprimir la aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(460754011589864937.4001)
,p_process_success_message=>unistr('Aplicaci\00F3n suprimida.')
);
end;
/
prompt --application/pages/page_00937
begin
wwv_flow_api.create_page(
 p_id=>937.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar: Entrada de Lista de Control de Acceso'
,p_step_title=>'Crear/Editar: Entrada de Lista de Control de Acceso'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(488391710691971044)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(770886849281707823)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488370028184663800.4001)
,p_plug_name=>'Entrada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488373000442703161.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488389715230924996.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si la aplicaci\00F3n utiliza un sistema de autorizaci\00F3n personalizado, la lista de control de acceso gestionar\00E1 los privilegios de los usuarios de la aplicaci\00F3n.</p>'),
'',
'<ul>',
'<li><strong>Lector</strong>: Puede ver el contenido pero no editarlo</li>',
'<li><strong>Contribuyente</strong>: Puede ver y editar el contenido</li>',
unistr('<li><strong>Administrador</strong>: Puede ver y editar el contenido; as\00ED como editar las propiedades de la aplicaci\00F3n y gestionar la lista de control de acceso</li>'),
'</ul>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488375612956735138.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(488373000442703161.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:934:&SESSION.::&DEBUG.:937::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488376200390735140.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(488373000442703161.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'P937_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488375831749735139.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(488373000442703161.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P937_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488376432157735143.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(488373000442703161.4001)
,p_button_name=>'CREATE_AND_CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'P937_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488376004627735140.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(488373000442703161.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P937_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(799460201132658227.4001)
,p_branch_action=>'f?p=&APP_ID.:937:&SESSION.::&DEBUG.::P937_USERNAME,P937_PRIV:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(488376432157735143.4001)
,p_branch_sequence=>5
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(488377211702744236.4001)
,p_branch_action=>'f?p=&APP_ID.:934:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488370606579670883.4001)
,p_name=>'P937_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(488370028184663800.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488370806456670884.4001)
,p_name=>'P937_USERNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(488370028184663800.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifique el nombre de usuario del que desea controlar el acceso.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488371003798670885.4001)
,p_name=>'P937_PRIV'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(488370028184663800.4001)
,p_item_default=>'R'
,p_prompt=>'Privilegio:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_ACL_PRIVS'
,p_lov=>'.'||wwv_flow_api.id(488361730864557325.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifique el nivel de privilegio del usuario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488373620024703167.4001)
,p_name=>'P937_APP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(488373000442703161.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from WWV_FLOW_WS_APPLICATIONS',
'where id = :P933_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(22574625410053244.4001)
,p_computation_sequence=>10
,p_computation_item=>'P937_USERNAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:P937_USERNAME)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488386524702861516.4001)
,p_validation_name=>'Cannot Delete or lesser privilege yourself'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001',
'             from wwv_flow_collections',
'            where collection_name = ''APEX$_ACL''',
'              and n001 = :P937_ID ) loop',
'  if :REQUEST = ''DELETE'' and c1.c001 = upper(:APP_USER) then',
'    return false;',
'  elsif :REQUEST = ''APPLY_CHANGES'' and c1.c001 = upper(:APP_USER) and :P937_PRIV != ''A'' then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No se puede eliminar a s\00ED mismo como administrador.')
,p_validation_condition=>'DELETE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(799462702180734235.4001)
,p_validation_name=>'P937_USERNAME already in ACL'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX$_ACL''',
'   and c001 = upper(:P937_USERNAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'El usuario ya existe en la lista de control de acceso.'
,p_validation_condition=>'CREATE,CREATE_AND_CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(488370806456670884.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(819902412181687576.4001)
,p_validation_name=>'P937_USERNAME is not null'
,p_validation_sequence=>30
,p_validation=>'P937_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe proporcionar el nombre de usuario.'
,p_validation_condition=>'CREATE,CREATE_AND_CREATE_ANOTHER,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(488370806456670884.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488382322007766092.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add/update acl'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_acl_entry(',
'    p_ws_app_id  => :P933_ID,',
'    p_acl_id          => :P937_ID,',
'    p_username   => :P937_USERNAME,',
'    p_priv             => :P937_PRIV );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear una entrada en la lista de control de acceso.'
,p_process_when=>'CREATE,APPLY_CHANGES,CREATE_AND_CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Se ha creado o modificado una entrada de la lista de control de acceso.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(833787506304462555.4001)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create ACL collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select schema',
'             from wwv_flow_company_schemas',
'            where security_group_id = :FLOW_SECURITY_GROUP_ID',
'              and IS_APEX$_SCHEMA = ''Y'' ) ',
'loop',
'   wwv_flow_security.g_apex$_schema := c1.schema;',
'end loop;',
'',
'wwv_flow_ws_api.create_acl_collection (',
'    p_ws_app_id => :P933_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la recopilaci\00F3n de ACL.')
,p_process_when_button_id=>wwv_flow_api.id(488376432157735143.4001)
,p_process_when=>'P933_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488382606900771195.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete acl entry'
,p_process_sql_clob=>'wwv_flow_ws_api.delete_acl_entry(:P937_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir una entrada de la lista de control de acceso.'
,p_process_when_button_id=>wwv_flow_api.id(488376200390735140.4001)
,p_process_success_message=>'Se ha suprimido una entrada de la lista de control de acceso.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488372808623696077.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'load data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 username, c002 priv',
'             from wwv_flow_collections',
'            where collection_name = ''APEX$_ACL''',
'              and n001 = :P937_ID ) loop',
'    :P937_USERNAME := c1.username;',
'    :P937_PRIV := c1.priv;',
'    exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P937_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00938
begin
wwv_flow_api.create_page(
 p_id=>938.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Depurar Datos de Mensaje'
,p_step_title=>'Depurar Datos de Mensaje'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table td {',
'    padding: 4px 8px;',
'}',
'.a-IRR-table td[headers=pct] {',
'    max-width: 120px;',
'}',
'.a-IRR-table td[headers=message] {',
'    max-width: 600px;',
'    overflow-x: auto;',
'}',
'pre {',
'    font-size: 11px;',
'    line-height: 14px;',
'    margin: 0;',
'}',
'.l1, .l2 {',
'    font-weight: bold;',
'    color: red;',
'}',
'.l3 {',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451218303882716102.4001)
,p_plug_name=>'Depurar Datos de Mensaje'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_view_row_number as row_number,',
'       elapsed_seconds,',
'       execution_time,',
'       message,',
'       apex_user,',
'       message_level,',
'       percent_of_max,',
'       message_timestamp,',
'       call_stack',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P938_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(451218413886716102.4001)
,p_name=>'Debug Message Data'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(624005414580721210.4001)
,p_db_column_name=>'ROW_NUMBER'
,p_display_order=>1
,p_column_identifier=>'O'
,p_column_label=>'Fila'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451222708996789635.4001)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>2
,p_column_identifier=>'I'
,p_column_label=>'Tiempo transcurrido'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(624005504204721210.4001)
,p_db_column_name=>'EXECUTION_TIME'
,p_display_order=>3
,p_column_identifier=>'P'
,p_column_label=>unistr('Ejecuci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451218729687716108.4001)
,p_db_column_name=>'MESSAGE'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Mensaje'
,p_column_html_expression=>'<pre class="l#MESSAGE_LEVEL#">#MESSAGE#</pre>'
,p_column_type=>'STRING'
,p_static_id=>'message'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451222805473789636.4001)
,p_db_column_name=>'APEX_USER'
,p_display_order=>5
,p_column_identifier=>'J'
,p_column_label=>'Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451318931989675375.4001)
,p_db_column_name=>'MESSAGE_LEVEL'
,p_display_order=>6
,p_column_identifier=>'N'
,p_column_label=>'Nivel'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(624005626313721211.4001)
,p_db_column_name=>'PERCENT_OF_MAX'
,p_display_order=>7
,p_column_identifier=>'Q'
,p_column_label=>unistr('Gr\00E1fico')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:#cccccc:#777777:100'
,p_static_id=>'pct'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(624005823644721211.4001)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>9
,p_column_identifier=>'S'
,p_column_label=>'Registro de Hora del Mensaje'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2510811144717781.4001)
,p_db_column_name=>'CALL_STACK'
,p_display_order=>11
,p_column_identifier=>'U'
,p_column_label=>'Pila de Llamadas'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451245311743912092.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451250530237002519.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(451245311743912092.4001)
,p_button_name=>'PURGE_DEBUG_VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Depurar Mensajes de Depuraci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:748:&SESSION.::&DEBUG.:748:P748_PURGE_OPTION,P748_PAGE_VIEW_ID:IDENTIFIER,&P938_PAGE_VIEW_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451246326072925685.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(451218303882716102.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:938:&SESSION.::&DEBUG.:RIR,938::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451250708607002526.4001)
,p_branch_action=>'f?p=&FLOW_ID.:938:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(451250530237002519.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451348818339465516.4001)
,p_name=>'P938_APPLICATION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(451245311743912092.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select id||''. ''||name d, id r from wwv_flows where id = :fb_flow_id and security_group_id = :flow_security_group_id'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624001717126655747.4001)
,p_name=>'P938_PAGE_VIEW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(451245311743912092.4001)
,p_prompt=>'Identificador de Vista'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el identificador de la vista de p\00E1gina de mensajes de depuraci\00F3n. Es un n\00FAmero que se incrementa continuamente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624002226823658552.4001)
,p_name=>'P938_PAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(451245311743912092.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero de p\00E1gina asociado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624002701674660730.4001)
,p_name=>'P938_ELAPSED_TIME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(451245311743912092.4001)
,p_prompt=>'Tiempo Transcurrido:'
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Tiempo transcurrido durante la depuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(624003212063663725.4001)
,p_name=>'P938_MAX_EXECUTION_TIME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(451245311743912092.4001)
,p_prompt=>unistr('Tiempo M\00E1ximo de Ejecuci\00F3n')
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Tiempo de m\00E1ximo de ejecuci\00F3n de cualquier paso.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(624004905876690316.4001)
,p_computation_sequence=>1
,p_computation_item=>'P938_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_debug_messages where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select flow_id from wwv_flow_debug_messages2 where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(624004324314676748.4001)
,p_computation_sequence=>10
,p_computation_item=>'P938_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id from wwv_flow_debug_messages where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null',
'union all',
'select page_id from wwv_flow_debug_messages2 where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(624004505399680737.4001)
,p_computation_sequence=>10
,p_computation_item=>'P938_ELAPSED_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(elap),0), ''999G999G999G999G990D00000'') from ',
'(',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages2 where page_view_id = :P938_PAGE_VIEW_ID  and security_group_id = :flow_security_group_id',
') x'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(624004719943684917.4001)
,p_computation_sequence=>10
,p_computation_item=>'P938_MAX_EXECUTION_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(execution_time), 0), ''999G999G999G999G990D00000'')',
'  from ( select extract(second from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) +',
'                extract(minute from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) * 60 as execution_time',
'           from ( select *',
'                    from wwv_flow_debug_messages',
'                   where page_view_id      = :P938_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id',
'                   union all',
'                  select *',
'                    from wwv_flow_debug_messages2',
'                   where page_view_id      = :P938_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id    ',
'                )',
'       )'))
);
end;
/
prompt --application/pages/page_00939
begin
wwv_flow_api.create_page(
 p_id=>939.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Depurar Datos de Mensaje'
,p_step_title=>'Depurar Datos de Mensaje'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table td {',
'    padding: 4px 8px;',
'}',
'.a-IRR-table td[headers=pct] {',
'    max-width: 120px;',
'}',
'.a-IRR-table td[headers=message] {',
'    max-width: 600px;',
'    overflow-x: auto;',
'}',
'pre {',
'    font-size: 11px;',
'    line-height: 14px;',
'    margin: 0;',
'}',
'.l1, .l2 {',
'    font-weight: bold;',
'    color: red;',
'}',
'.l3 {',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451352513130603348.4001)
,p_plug_name=>'Depurar Datos de Mensaje'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_view_row_number as row_number,',
'       elapsed_seconds,',
'       execution_time,',
'       message,',
'       apex_user,',
'       message_level,',
'       percent_of_max,',
'       to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as message_anchor,',
'       message_timestamp,',
'       call_stack',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P939_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Depurar Datos de Mensaje'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(451352700445603348.4001)
,p_name=>'Debug Message Data'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(617483723716172788.4001)
,p_db_column_name=>'ROW_NUMBER'
,p_display_order=>1
,p_column_identifier=>'AB'
,p_column_label=>'Fila'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451353331050603354.4001)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>2
,p_column_identifier=>'I'
,p_column_label=>'Tiempo transcurrido'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(498258020400635102.4001)
,p_db_column_name=>'EXECUTION_TIME'
,p_display_order=>3
,p_column_identifier=>'AA'
,p_column_label=>unistr('Ejecuci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451352831764603349.4001)
,p_db_column_name=>'MESSAGE'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Mensaje'
,p_column_html_expression=>'<a name="#MESSAGE_ANCHOR#"></a><pre class="l#MESSAGE_LEVEL#">#MESSAGE#</pre>'
,p_column_type=>'STRING'
,p_static_id=>'message'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451353429972603354.4001)
,p_db_column_name=>'APEX_USER'
,p_display_order=>5
,p_column_identifier=>'J'
,p_column_label=>'Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451353611951603356.4001)
,p_db_column_name=>'MESSAGE_LEVEL'
,p_display_order=>6
,p_column_identifier=>'N'
,p_column_label=>'Nivel'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(467191202320715772.4001)
,p_db_column_name=>'PERCENT_OF_MAX'
,p_display_order=>7
,p_column_identifier=>'W'
,p_column_label=>unistr('Gr\00E1fico')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_static_id=>'pct'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472243323140883667.4001)
,p_db_column_name=>'MESSAGE_ANCHOR'
,p_display_order=>8
,p_column_identifier=>'Z'
,p_column_label=>'Anclaje de Mensaje'
,p_report_label=>' '
,p_sync_form_label=>'N'
,p_column_link=>'#'
,p_column_linktext=>' '
,p_column_link_attr=>'name="#MESSAGE_ANCHOR#"'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(617483829429172789.4001)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>9
,p_column_identifier=>'AC'
,p_column_label=>'Registro de Hora del Mensaje'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(200166824373034332.4001)
,p_db_column_name=>'CALL_STACK'
,p_display_order=>10
,p_column_identifier=>'AD'
,p_column_label=>'Pila de Llamadas'
,p_column_html_expression=>'<pre>#CALL_STACK#</pre>'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451354120578603361.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451356414894615900.4001)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(713094915430315407.4001)
,p_plug_name=>unistr('Depurar Gr\00E1fico')
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>'<p/>'
);
wwv_flow_api.create_jet_chart(
 p_id=>wwv_flow_api.id(713095083622315408.4001)
,p_region_id=>wwv_flow_api.id(713094915430315407.4001)
,p_chart_type=>'combo'
,p_height=>'120'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'off'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'N'
,p_value_position=>'auto'
,p_sorting=>'value-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(713095194948315409.4001)
,p_chart_id=>wwv_flow_api.id(713095083622315408.4001)
,p_seq=>10
,p_name=>'Serie 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       sum(execution_time) over (order by page_view_row_number) execution_agg',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P939_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
' order by page_view_row_number'))
,p_series_type=>'area'
,p_items_value_column_name=>'EXECUTION_AGG'
,p_items_label_column_name=>'LABEL'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_api.create_jet_chart_series(
 p_id=>wwv_flow_api.id(32660594179289201.4001)
,p_chart_id=>wwv_flow_api.id(713095083622315408.4001)
,p_seq=>30
,p_name=>'Advertencias/errores'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       1 warnings_errors',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P939_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
'   and message_level <= 2',
' order by page_view_row_number'))
,p_series_type=>'line'
,p_items_value_column_name=>'WARNINGS_ERRORS'
,p_items_label_column_name=>'LABEL'
,p_color=>'#ff0000'
,p_line_style=>'solid'
,p_line_type=>'none'
,p_marker_rendered=>'on'
,p_marker_shape=>'circle'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(713095224174315410.4001)
,p_chart_id=>wwv_flow_api.id(713095083622315408.4001)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(713095309706315411.4001)
,p_chart_id=>wwv_flow_api.id(713095083622315408.4001)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'min'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_jet_chart_axis(
 p_id=>wwv_flow_api.id(32660622988289202.4001)
,p_chart_id=>wwv_flow_api.id(713095083622315408.4001)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(811009025873417496.4001)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_help_link (',
'   p_lang           => ''en'',',
'   p_session_id     => :app_session,',
'   p_application_id => 4000,',
'   p_page_id        => wwv_flow.g_flow_step_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451429503306426225.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_button_name=>'P939_SET'
,p_button_static_id=>'P939_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Definir'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451881217044039156.4001)
,p_button_sequence=>25
,p_button_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_button_name=>'SELECT_IDENTIFIER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Seleccionar Identificador de Vista de P\00E1gina')
,p_button_alignment=>'LEFT-CENTER'
,p_button_redirect_url=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451441315314921581.4001)
,p_button_sequence=>26
,p_button_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_button_name=>'SHOW_MOST_RECENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_alignment=>'LEFT-CENTER'
,p_button_redirect_url=>'f?p=&APP_ID.:939:&SESSION.:SET_PAGE_ID:&DEBUG.:939,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451429723882426229.4001)
,p_branch_action=>'f?p=&FLOW_ID.:939:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451426821267403030.4001)
,p_name=>'P939_PAGE_VIEW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_prompt=>unistr('Identificador de Vista de P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el identificador de la vista de p\00E1gina de mensajes de depuraci\00F3n. Es un n\00FAmero que se incrementa continuamente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451950913747400594.4001)
,p_name=>'P939_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Aplicaci\00F3n asociada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451951119981402391.4001)
,p_name=>'P939_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_prompt=>unistr('P\00E1gina:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero de p\00E1gina asociado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461291211053568408.4001)
,p_name=>'P939_ELAPSED_TIME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_prompt=>'Tiempo Transcurrido:'
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Tiempo transcurrido durante la depuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(467194201455792628.4001)
,p_name=>'P939_MAX_EXECUTION_TIME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(451354120578603361.4001)
,p_prompt=>unistr('Tiempo M\00E1ximo de Ejecuci\00F3n')
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Tiempo de ejecuci\00F3n m\00E1ximo de cualquier paso.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(451427505815407951.4001)
,p_computation_sequence=>10
,p_computation_item=>'P939_PAGE_VIEW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(i) x',
'from',
'(',
'select max(page_view_id) i',
'from wwv_flow_debug_messages',
'where security_group_id = :flow_security_group_id',
'union all',
'select max(page_view_id) i',
'from wwv_flow_debug_messages2',
'where security_group_id = :flow_security_group_id',
')'))
,p_compute_when=>'SET_PAGE_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(451951614702419771.4001)
,p_computation_sequence=>20
,p_computation_item=>'P939_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_debug_messages where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select flow_id from wwv_flow_debug_messages2 where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(451952001458434876.4001)
,p_computation_sequence=>30
,p_computation_item=>'P939_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id from wwv_flow_debug_messages where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null',
'union all',
'select page_id from wwv_flow_debug_messages2 where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(461293113954578638.4001)
,p_computation_sequence=>40
,p_computation_item=>'P939_ELAPSED_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(elap),0), ''999G999G999G999G990D00000'') from ',
'(',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages2 where page_view_id = :P939_PAGE_VIEW_ID  and security_group_id = :flow_security_group_id',
') x'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(467196512022833547.4001)
,p_computation_sequence=>50
,p_computation_item=>'P939_MAX_EXECUTION_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(execution_time), 0), ''999G999G999G999G990D00000'')',
'  from ( select extract(second from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) +',
'                extract(minute from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) * 60 as execution_time',
'           from ( select *',
'                    from wwv_flow_debug_messages',
'                   where page_view_id      = :P939_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id',
'                   union all',
'                  select *',
'                    from wwv_flow_debug_messages2',
'                   where page_view_id      = :P939_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id    ',
'                )',
'       )'))
);
end;
/
prompt --application/pages/page_00940
begin
wwv_flow_api.create_page(
 p_id=>940.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Actualizar Configuraci\00F3n de Informes Interactivos')
,p_step_title=>unistr('Actualizar Configuraci\00F3n de Informes Interactivos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_int.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(451360330860759321.4001)
,p_name=>'Update Interactive Report Settings'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'id,',
'page_id,',
'(select p.name',
'   from wwv_flow_steps p',
'  where p.id = w.page_id',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id) page,',
'(select r.plug_name',
'   from wwv_flow_page_plugs r',
'  where r.id = w.region_id',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id) region,',
'--',
'SHOW_SEARCH_BAR,',
'SHOW_SEARCH_TEXTBOX,',
'SHOW_FINDER_DROP_DOWN,',
'REPORT_LIST_MODE, -- TABS = Y, NONE = N',
'SHOW_ROWS_PER_PAGE,',
'SHOW_DISPLAY_ROW_COUNT, --??',
'SHOW_ACTIONS_MENU,',
'--',
'SHOW_SELECT_COLUMNS,',
'SHOW_FILTER,',
'SHOW_SORT,',
'SHOW_CONTROL_BREAK,',
'SHOW_HIGHLIGHT,',
'SHOW_COMPUTATION,',
'SHOW_AGGREGATE,',
'SHOW_NOTIFY, -- Subscription',
'SHOW_CHART,',
'SHOW_GROUP_BY,',
'SHOW_PIVOT,',
'SHOW_FLASHBACK,',
'ALLOW_REPORT_SAVING,',
'SHOW_RESET,',
'SHOW_HELP,',
'SHOW_DOWNLOAD,',
'--',
'ALLOW_SAVE_RPT_PUBLIC,',
'SAVE_RPT_PUBLIC_AUTH_SCHEME, --REQUIRED_ROLE lov',
'--',
'SHOW_CALENDAR,  -- not implemented yet',
'download_formats, -- need multiselect checkboxes',
'search_button_label,',
'max_rows_per_page',
'from wwv_flow_worksheets w',
'where flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id',
'  and (page_id = :P940_PAGE or :P940_PAGE is null)',
'  and (:P940_PAGE_NAME_CONTAINS is null or',
'       upper(:P940_PAGE_NAME_CONTAINS) like ',
'            (select ''%''||upper(p.name)||''%''',
'               from wwv_flow_steps p',
'              where p.id = w.page_id',
'                and flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id) )'))
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p/>',
unistr('* s\00F3lo para p\00E1ginas autenticadas')))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>10
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se han encontrado informes interactivos.'
,p_query_num_rows_item=>'P940_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451360615717759324.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEETS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451360928423759325.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_display_as=>'WITHOUT_MODIFICATION'
,p_column_width=>16
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEETS'
,p_ref_column_name=>'PAGE_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367103866774764.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367218646774764.4001)
,p_query_column_id=>4
,p_column_alias=>'REGION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367328343774764.4001)
,p_query_column_id=>5
,p_column_alias=>'SHOW_SEARCH_BAR'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Barra de B\00FAsqueda')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_cattributes=>'title="Search Bar"'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367413033774765.4001)
,p_query_column_id=>6
,p_column_alias=>'SHOW_SEARCH_TEXTBOX'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Campo de B\00FAsqueda')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367518074774765.4001)
,p_query_column_id=>7
,p_column_alias=>'SHOW_FINDER_DROP_DOWN'
,p_column_display_sequence=>7
,p_column_heading=>'Lista Desplegable del Buscador'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367607783774765.4001)
,p_query_column_id=>8
,p_column_alias=>'REPORT_LIST_MODE'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Lista de Selecci\00F3n de Informes')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:TABS,NONE'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367711426774765.4001)
,p_query_column_id=>9
,p_column_alias=>'SHOW_ROWS_PER_PAGE'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Filas por P\00E1gina')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367805277774765.4001)
,p_query_column_id=>10
,p_column_alias=>'SHOW_DISPLAY_ROW_COUNT'
,p_column_display_sequence=>9
,p_column_heading=>unistr('Selector de Filas por P\00E1gina')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451367917681774765.4001)
,p_query_column_id=>11
,p_column_alias=>'SHOW_ACTIONS_MENU'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Men\00FA de Acciones')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368006968774765.4001)
,p_query_column_id=>12
,p_column_alias=>'SHOW_SELECT_COLUMNS'
,p_column_display_sequence=>11
,p_column_heading=>'Seleccionar Columnas'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368109759774765.4001)
,p_query_column_id=>13
,p_column_alias=>'SHOW_FILTER'
,p_column_display_sequence=>12
,p_column_heading=>'Filtro'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368210963774765.4001)
,p_query_column_id=>14
,p_column_alias=>'SHOW_SORT'
,p_column_display_sequence=>14
,p_column_heading=>'Ordenar'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368323960774765.4001)
,p_query_column_id=>15
,p_column_alias=>'SHOW_CONTROL_BREAK'
,p_column_display_sequence=>15
,p_column_heading=>unistr('Divisi\00F3n de Control')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368410299774765.4001)
,p_query_column_id=>16
,p_column_alias=>'SHOW_HIGHLIGHT'
,p_column_display_sequence=>16
,p_column_heading=>'Resaltar'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368529474774765.4001)
,p_query_column_id=>17
,p_column_alias=>'SHOW_COMPUTATION'
,p_column_display_sequence=>17
,p_column_heading=>'Calcular'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368629136774765.4001)
,p_query_column_id=>18
,p_column_alias=>'SHOW_AGGREGATE'
,p_column_display_sequence=>18
,p_column_heading=>'Agregar'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368705374774765.4001)
,p_query_column_id=>19
,p_column_alias=>'SHOW_NOTIFY'
,p_column_display_sequence=>29
,p_column_heading=>unistr('Suscripci\00F3n *')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368820181774765.4001)
,p_query_column_id=>20
,p_column_alias=>'SHOW_CHART'
,p_column_display_sequence=>19
,p_column_heading=>unistr('Gr\00E1fico')
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451368905727774766.4001)
,p_query_column_id=>21
,p_column_alias=>'SHOW_GROUP_BY'
,p_column_display_sequence=>20
,p_column_heading=>'Agrupar por'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(973962080599400230.4001)
,p_query_column_id=>22
,p_column_alias=>'SHOW_PIVOT'
,p_column_display_sequence=>21
,p_column_heading=>unistr('Din\00E1mica')
,p_use_as_row_header=>'N'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369010379774766.4001)
,p_query_column_id=>23
,p_column_alias=>'SHOW_FLASHBACK'
,p_column_display_sequence=>22
,p_column_heading=>'Flashback'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369121929774766.4001)
,p_query_column_id=>24
,p_column_alias=>'ALLOW_REPORT_SAVING'
,p_column_display_sequence=>23
,p_column_heading=>'Guardar Informe *'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369232103774766.4001)
,p_query_column_id=>25
,p_column_alias=>'SHOW_RESET'
,p_column_display_sequence=>26
,p_column_heading=>'Restablecer'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369322080774766.4001)
,p_query_column_id=>26
,p_column_alias=>'SHOW_HELP'
,p_column_display_sequence=>27
,p_column_heading=>'Ayuda'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369401233774766.4001)
,p_query_column_id=>27
,p_column_alias=>'SHOW_DOWNLOAD'
,p_column_display_sequence=>28
,p_column_heading=>'Descargar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369509385774767.4001)
,p_query_column_id=>28
,p_column_alias=>'ALLOW_SAVE_RPT_PUBLIC'
,p_column_display_sequence=>24
,p_column_heading=>unistr('Guardar Informe P\00FAblico *')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369603610774767.4001)
,p_query_column_id=>29
,p_column_alias=>'SAVE_RPT_PUBLIC_AUTH_SCHEME'
,p_column_display_sequence=>25
,p_column_heading=>unistr('Guardar Informe P\00FAblico: Autorizaci\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(283664112341)
,p_lov_show_nulls=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451369719750774767.4001)
,p_query_column_id=>30
,p_column_alias=>'SHOW_CALENDAR'
,p_column_display_sequence=>30
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(498113714685254746.4001)
,p_query_column_id=>31
,p_column_alias=>'DOWNLOAD_FORMATS'
,p_column_display_sequence=>31
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(633638913941561250.4001)
,p_query_column_id=>32
,p_column_alias=>'SEARCH_BUTTON_LABEL'
,p_column_display_sequence=>32
,p_column_heading=>unistr('Etiqueta del Bot\00F3n de B\00FAsqueda')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>10
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(633639002235561250.4001)
,p_query_column_id=>33
,p_column_alias=>'MAX_ROWS_PER_PAGE'
,p_column_display_sequence=>33
,p_column_heading=>unistr('M\00E1ximo de Filas por P\00E1gina')
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>10
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364208118774759.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364319885774759.4001)
,p_column_sequence=>2
,p_query_column_name=>'PAGE_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364408964774759.4001)
,p_column_sequence=>3
,p_query_column_name=>'PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364522591774759.4001)
,p_column_sequence=>4
,p_query_column_name=>'REGION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364600097774759.4001)
,p_column_sequence=>5
,p_query_column_name=>'SHOW_SEARCH_BAR'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364713313774759.4001)
,p_column_sequence=>6
,p_query_column_name=>'SHOW_SEARCH_TEXTBOX'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364814103774759.4001)
,p_column_sequence=>7
,p_query_column_name=>'SHOW_FINDER_DROP_DOWN'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451364926397774759.4001)
,p_column_sequence=>8
,p_query_column_name=>'REPORT_LIST_MODE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365012728774759.4001)
,p_column_sequence=>9
,p_query_column_name=>'SHOW_ROWS_PER_PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365117911774759.4001)
,p_column_sequence=>10
,p_query_column_name=>'SHOW_DISPLAY_ROW_COUNT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365204754774759.4001)
,p_column_sequence=>11
,p_query_column_name=>'SHOW_ACTIONS_MENU'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365320060774759.4001)
,p_column_sequence=>12
,p_query_column_name=>'SHOW_SELECT_COLUMNS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365419136774759.4001)
,p_column_sequence=>13
,p_query_column_name=>'SHOW_FILTER'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365530135774759.4001)
,p_column_sequence=>14
,p_query_column_name=>'SHOW_SORT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365605544774759.4001)
,p_column_sequence=>15
,p_query_column_name=>'SHOW_CONTROL_BREAK'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365719796774759.4001)
,p_column_sequence=>16
,p_query_column_name=>'SHOW_HIGHLIGHT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365811467774759.4001)
,p_column_sequence=>17
,p_query_column_name=>'SHOW_COMPUTATION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451365928441774759.4001)
,p_column_sequence=>18
,p_query_column_name=>'SHOW_AGGREGATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366012327774759.4001)
,p_column_sequence=>19
,p_query_column_name=>'SHOW_NOTIFY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366131287774759.4001)
,p_column_sequence=>20
,p_query_column_name=>'SHOW_CHART'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366226022774759.4001)
,p_column_sequence=>21
,p_query_column_name=>'SHOW_GROUP_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366321190774759.4001)
,p_column_sequence=>22
,p_query_column_name=>'SHOW_FLASHBACK'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366409799774759.4001)
,p_column_sequence=>23
,p_query_column_name=>'ALLOW_REPORT_SAVING'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366510316774759.4001)
,p_column_sequence=>24
,p_query_column_name=>'SHOW_RESET'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366608710774759.4001)
,p_column_sequence=>25
,p_query_column_name=>'SHOW_HELP'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366720115774760.4001)
,p_column_sequence=>26
,p_query_column_name=>'SHOW_DOWNLOAD'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366809139774762.4001)
,p_column_sequence=>27
,p_query_column_name=>'ALLOW_SAVE_RPT_PUBLIC'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451366900362774762.4001)
,p_column_sequence=>28
,p_query_column_name=>'SAVE_RPT_PUBLIC_AUTH_SCHEME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(451367015409774762.4001)
,p_column_sequence=>29
,p_query_column_name=>'SHOW_CALENDAR'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(498113603476254744.4001)
,p_column_sequence=>30
,p_query_column_name=>'DOWNLOAD_FORMATS'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(633638206182561248.4001)
,p_column_sequence=>31
,p_query_column_name=>'BUTTON_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(633638317134561248.4001)
,p_column_sequence=>32
,p_query_column_name=>'FINDER_ICON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(633610408135533264.4001)
,p_column_sequence=>33
,p_query_column_name=>'ACTIONS_MENU_ICON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(633638516207561248.4001)
,p_column_sequence=>34
,p_query_column_name=>'SEARCH_BUTTON_LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(633638611605561248.4001)
,p_column_sequence=>35
,p_query_column_name=>'MAX_ROWS_PER_PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(622840620376915872.4001)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('Actualice r\00E1pidamente la configuraci\00F3n de informes interactivos de su aplicaci\00F3n. Tenga en cuenta que si desactiva la barra de b\00FAsqueda, la selecci\00F3n de elementos de la barra de b\00FAsqueda no tendr\00E1 ning\00FAn efecto. Del mismo modo, si desactiva el men\00FA A')
||unistr('cciones, las selecciones de dicho men\00FA no tendr\00E1n ning\00FAn efecto.')
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(636405722520344289.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>4
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(636406623360344305.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(636405722520344289.4001)
,p_button_name=>'P940_GO'
,p_button_static_id=>'P940_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(636405931187344293.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(636405722520344289.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451362706591759341.4001)
,p_branch_action=>'f?p=&APP_ID.:940:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(636406126780344298.4001)
,p_name=>'P940_PAGE_NAME_CONTAINS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(636405722520344289.4001)
,p_prompt=>unistr('El Nombre de P\00E1gina Contiene')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(636406826434344306.4001)
,p_name=>'P940_PAGE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(636405722520344289.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Filtre por n\00FAmero de p\00E1gina. Introduzca el n\00FAmero de p\00E1gina y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(636407306561344310.4001)
,p_name=>'P940_ROWS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(636405722520344289.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,25,50,100'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el n\00FAmero de filas que desea que aparezcan y haga clic en <span class="fielddatabold">Ir</span>.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(636413410840397735.4001)
,p_validation_name=>'P940_PAGE'
,p_validation_sequence=>10
,p_validation=>'P940_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La p\00E1gina debe ser num\00E9rica.')
,p_associated_item=>wwv_flow_api.id(636406826434344306.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451362532494759340.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(451360330860759321.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_WORKSHEETS'
,p_attribute_03=>'ID'
,p_process_error_message=>unistr('No se ha podido procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(636405931187344293.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_00941
begin
wwv_flow_api.create_page(
 p_id=>941.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Etiqueta: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Etiqueta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(86610101308085044.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148117308807137199.4001)
,p_plug_name=>'Crear Plantilla de Etiqueta'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p> ')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148381109361516794.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148128521527145987.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(86610101308085044.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148133204343150523.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(86610101308085044.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19623623448813225.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(86610101308085044.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(148387027895523446.4001)
,p_branch_action=>'652'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(148133204343150523.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P941_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177436032410238661.4001)
,p_branch_action=>'655'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(148133204343150523.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P941_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589888574427923030.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19623623448813225.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148146316762163878.4001)
,p_name=>'F4000_P941_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(148117308807137199.4001)
,p_item_default=>'COPY'
,p_prompt=>'Crear Plantillas de Etiqueta:'
,p_source=>'COPY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LABEL_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_api.id(86598309219256908.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Select Default Templates (recommended), or create a new template from scratch?'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589888306940923028.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(148128521527145987.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589888417636923029.4001)
,p_event_id=>wwv_flow_api.id(589888306940923028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00951
begin
wwv_flow_api.create_page(
 p_id=>951.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Informe: M\00E9todo de Creaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47964415357928278.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148597900148976938.4001)
,p_plug_name=>'Crear Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Puede crear plantillas nuevas o copiarlas de otra aplicaci\00F3n. La copia de una plantilla le proporciona un marco que puede modificar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(149016402386939520.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148602015872986544.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47964415357928278.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148604600073991469.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47964415357928278.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19618028371720074.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47964415357928278.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178523509749187981.4001)
,p_branch_action=>'4321'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(148604600073991469.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P951_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(148891919392703708.4001)
,p_branch_action=>'955'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(148604600073991469.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P951_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589890226272923047.4001)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19618028371720074.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148609728147009503.4001)
,p_name=>'F4000_P951_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(148597900148976938.4001)
,p_item_default=>'COPY'
,p_prompt=>'Crear Plantilla de Informe:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_WIZ_TYPE'
,p_lov=>'.'||wwv_flow_api.id(86600327227262164.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo por el que desea crear una nueva plantilla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589890043944923045.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(148602015872986544.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589890169784923046.4001)
,p_event_id=>wwv_flow_api.id(589890043944923045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00955
begin
wwv_flow_api.create_page(
 p_id=>955.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Informe: Nombre'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47970609433973826.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148824528851471404.4001)
,p_plug_name=>'Crear Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(148848329905501340.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106501409747300331.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148830511689475923.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47970609433973826.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148837904548483281.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47970609433973826.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148834024502479671.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47970609433973826.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(87051729414600976.4001)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589946591749621410.4001)
,p_branch_action=>'f?p=&APP_ID.:951:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(148834024502479671.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87278328637619624.4001)
,p_name=>'P955_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(148824528851471404.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifique el nuevo nombre de la plantilla de informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87350923920627724.4001)
,p_name=>'P955_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(148824528851471404.4001)
,p_prompt=>'Tema'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87352618163635541.4001)
,p_name=>'P955_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(148824528851471404.4001)
,p_prompt=>'Clase de Plantilla'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(44022800298370465.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87420722899778867.4001)
,p_name=>'P955_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(148824528851471404.4001)
,p_item_default=>'GENERIC_COLUMNS'
,p_prompt=>'Tipo de Plantilla:'
,p_source=>'GENERIC_COLUMNS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ROW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84775019904954668.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Identifique el tipo de plantilla de informe. Las plantillas de columnas gen\00E9ricas utilizan el mismo formato para todas las columnas de un informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87353605135641235.4001)
,p_validation_name=>'P955_NAME'
,p_validation_sequence=>10
,p_validation=>'P955_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(148837904548483281.4001)
,p_associated_item=>wwv_flow_api.id(87278328637619624.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87362316563644512.4001)
,p_validation_name=>'P955_THEME'
,p_validation_sequence=>20
,p_validation=>'P955_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(148837904548483281.4001)
,p_associated_item=>wwv_flow_api.id(87350923920627724.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87367326952647501.4001)
,p_validation_name=>'P955_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P955_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(148837904548483281.4001)
,p_associated_item=>wwv_flow_api.id(87352618163635541.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(87422105369783290.4001)
,p_validation_name=>'P955_TYPE'
,p_validation_sequence=>40
,p_validation=>'P955_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(148837904548483281.4001)
,p_associated_item=>wwv_flow_api.id(87420722899778867.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589946351512621408.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(148830511689475923.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589946447940621409.4001)
,p_event_id=>wwv_flow_api.id(589946351512621408.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(148871312337631008.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Report Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_api.create_row_template(',
' p_flow_id                    => v(''fb_flow_id''),',
' p_row_template_name          => :P955_NAME,',
' p_theme_id                   => :P955_THEME,',
' p_theme_class_id             => :P955_THEME_CLASS,',
' p_row_template_type          => :P955_TYPE,',
' p_column_heading_template    => NULL,',
' p_row_template1              => NULL,',
' p_row_template_condition1    => NULL,',
' p_row_template_display_cond1 => NULL,',
' p_row_template2              => NULL,',
' p_row_template_condition2    => NULL,',
' p_row_template_display_cond2 => NULL,',
' p_row_template3              => NULL,',
' p_row_template_condition3    => NULL,',
' p_row_template_display_cond3 => NULL,',
' p_row_template4              => NULL,',
' p_row_template_condition4    => NULL,',
' p_row_template_display_cond4 => NULL,',
' p_row_template_before_rows   => NULL,',
' p_row_template_after_rows    => NULL,',
' p_row_template_table_attr    => NULL,',
' p_row_template_comment       => NULL',
');',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido crear la plantilla.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(148837904548483281.4001)
,p_process_success_message=>'Plantilla creada.'
);
end;
/
prompt --application/pages/page_00959
begin
wwv_flow_api.create_page(
 p_id=>959.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Errores'
,p_step_title=>'Errores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(483658311307883464.4001)
,p_plug_name=>'Separadores de Buscador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(6207014968942318.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(483659515251898467.4001)
,p_plug_name=>'Errores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 SQLERRM,',
'	 USERID,',
'	 STEP_ID page,',
'	 SESSION_ID,',
'	 TIME_STAMP,',
'         sqlerrm_component_type,',
'         sqlerrm_component_name',
' from WWV_FLOW_ACTIVITY_LOG',
'where   security_group_id = :flow_security_group_id and',
'  flow_id = :fb_flow_id and',
'  sqlerrm is not null and',
'  time_stamp >= sysdate - 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(483659607062898467.4001)
,p_name=>'Errors'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483659823278898476.4001)
,p_db_column_name=>'SQLERRM'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Mensaje de Error'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483659926102898479.4001)
,p_db_column_name=>'USERID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483660104728898484.4001)
,p_db_column_name=>'PAGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483660213584898484.4001)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Sesi\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483660326568898485.4001)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Fecha'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483660406911898485.4001)
,p_db_column_name=>'SQLERRM_COMPONENT_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(483660532050898485.4001)
,p_db_column_name=>'SQLERRM_COMPONENT_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Componente'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1080990589859523938.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(483659515251898467.4001)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:959:&SESSION.::&DEBUG.:RP,RIR,959:::'
);
end;
/
prompt --application/pages/page_00961
begin
wwv_flow_api.create_page(
 p_id=>961.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Panel de Control'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Panel de Control'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212882205890328007)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(679120268137091247.4001)
,p_plug_name=>unistr('Crear p\00E1gina de panel de control')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_IS_UT_BASED'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(849098835443244723.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(43062373542725339.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(881289130697535824.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1185970413706897571.4001)
,p_plug_name=>'Compatibilidad de Temas'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El panel de control requiere una aplicaci\00F3n basada en el tema universal. '),
unistr('Oracle recomienda actualizar al tema universal. Para obtener m\00E1s informaci\00F3n, consulte la <a rel="noreferrer" href="https://apex.oracle.com/ut" target="_blank">aplicaci\00F3n del tema universal (Universal Theme)</a>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_IS_UT_BASED'
,p_plug_display_when_cond2=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33632435582265451.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(881289130697535824.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33631622127265450.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(881289130697535824.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>'P259_IS_UT_BASED'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33632044205265450.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(881289130697535824.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33638466849265457.4001)
,p_branch_name=>'Go To Navigation/Tab'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(33631622127265450.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33638017359265456.4001)
,p_branch_action=>'f?p=&APP_ID.:961:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P961_BREADCRUMB_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33627072808265444.4001)
,p_name=>'P961_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(679120268137091247.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina de panel de control no utilizado.</p>'),
unistr('<p>El n\00FAmero por defecto es el primer n\00FAmero de p\00E1gina disponible en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33627962342265445.4001)
,p_name=>'P961_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>91
,p_item_plug_id=>wwv_flow_api.id(679120268137091247.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero de la p\00E1gina de panel de control que consiste en varias regiones de gr\00E1ficos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33628824058265446.4001)
,p_name=>'P961_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>111
,p_item_plug_id=>wwv_flow_api.id(679120268137091247.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33629748194265448.4001)
,p_name=>'P961_BREADCRUMB_PARENT_ID'
,p_item_sequence=>121
,p_item_plug_id=>wwv_flow_api.id(679120268137091247.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P961_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P961_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P961_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33630116847265449.4001)
,p_name=>'P961_BC_NAME'
,p_item_sequence=>131
,p_item_plug_id=>wwv_flow_api.id(679120268137091247.4001)
,p_prompt=>unistr('Nombre de entrada de p\00E1gina de panel de control')
,p_source=>'P961_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de ruta de navegaci\00F3n para la p\00E1gina de panel de control.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33633391004265452.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P961_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(33632977911265452.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33634520013265454.4001)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>55
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      select 1',
'      from wwv_flow_page_plugs',
'      where flow_id = :fb_flow_id',
'      and   page_id = :P961_MD_PAGE_ID',
'      and   menu_id is not null',
'      and   nvl(:P961_BREADCRUMB_ID,0)<>0'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina especificada ya tiene una regi\00F3n de ruta de navegaci\00F3n.')
,p_validation_condition=>'wwv_flow_utilities.is_numeric( p_str => :P961_MASTER_PAGE_ID) and wwv_flow_utilities.is_numeric( p_str => :P961_DETAIL_PAGE_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(33631622127265450.4001)
,p_associated_item=>wwv_flow_api.id(33628824058265446.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(275644860296510026.4001)
,p_validation_name=>'breadcrumb name not null'
,p_validation_sequence=>65
,p_validation=>'P961_BC_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P961_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(33631622127265450.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33633754604265453.4001)
,p_validation_name=>'P961_PAGE_ID positive, whole number'
,p_validation_sequence=>75
,p_validation=>'P961_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(33631622127265450.4001)
,p_associated_item=>wwv_flow_api.id(33627072808265444.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(33634177874265453.4001)
,p_validation_name=>'P961_PAGE_ID reserved'
,p_validation_sequence=>85
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P961_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P961_PAGE_ID is not null and',
'wwv_flow_utilities.is_numeric(:P961_PAGE_ID)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(33631622127265450.4001)
,p_associated_item=>wwv_flow_api.id(33627072808265444.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(33634891283265454.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P961_BREADCRUMB_ID'
,p_condition_element=>'P961_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(33635396559265455.4001)
,p_event_id=>wwv_flow_api.id(33634891283265454.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P961_BREADCRUMB_PARENT_ID,P961_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(33635739073265455.4001)
,p_event_id=>wwv_flow_api.id(33634891283265454.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P961_BREADCRUMB_PARENT_ID,P961_BC_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(33636129594265455.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33632435582265451.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(33636630920265455.4001)
,p_event_id=>wwv_flow_api.id(33636129594265455.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(33637079611265456.4001)
,p_name=>'set bc name'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P961_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(33637519633265456.4001)
,p_event_id=>wwv_flow_api.id(33637079611265456.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P961_BC_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P961_PAGE_NAME'
,p_attribute_07=>'P961_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00962
begin
wwv_flow_api.create_page(
 p_id=>962.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Panel de Control'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Panel de Control'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33437611232898208.4001)
,p_plug_name=>'Pantalla Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Este asistente crea un panel de control preliminar basado en datos de ejemplo que podr\00E1 personalizar f\00E1cilmente con el dise\00F1ador de p\00E1ginas. Elija entre distintos dise\00F1os de gr\00E1fico como punto de partida para la p\00E1gina.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(589965723113595784.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(849170476376366596.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(43062373542725339.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33861369457897972.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(589965723113595784.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33861744884897972.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(589965723113595784.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33862112709897974.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(589965723113595784.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33437791787898209.4001)
,p_name=>'P962_DASHBOARD_LAYOUT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(33437611232898208.4001)
,p_prompt=>unistr('Dise\00F1o del panel de control')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P962_DASHBOARD_LAYOUT'
,p_lov=>'.'||wwv_flow_api.id(42907758825155833.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-IconList--layouts'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(33862639275899602.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33861369457897972.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(33862774492899603.4001)
,p_event_id=>wwv_flow_api.id(33862639275899602.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33865413781899630.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create dashboard page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_dashboard_page(',
'    p_app_id                    => :FB_FLOW_ID,',
'    p_user_interface_id         => :P259_USER_INTERFACE_ID,',
'    p_page_id                   => :P961_PAGE_ID,',
'    p_page_name                 => :P961_PAGE_NAME,',
'    p_page_mode                 => wwv_flow_page.c_page_mode_normal,',
'    --',
'    p_dashboard_layout          => :P962_DASHBOARD_LAYOUT,',
'    --',
'    p_tab_set                   => :P4716_TAB_SET,',
'    p_tab_name                  => :P4716_TAB_NAME,',
'    p_tab_text                  => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id               => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id   => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name  => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_breadcrumb_id             => :P961_BREADCRUMB_ID,',
'    p_breadcrumb_name           => :P961_BC_NAME,',
'    p_parent_bc_id              => :P961_BREADCRUMB_PARENT_ID );',
'',
':FB_FLOW_PAGE_ID       := :P961_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P961_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33864143129899617.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_process_error_message=>unistr('Error al crear la p\00E1gina &P961_PAGE_ID..')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(33861744884897972.4001)
,p_process_success_message=>unistr('P\00E1gina de panel de control creada.')
);
end;
/
prompt --application/pages/page_00970
begin
wwv_flow_api.create_page(
 p_id=>970.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copias de seguridad de espacio de trabajo'
,p_step_title=>'Copias de seguridad de espacio de trabajo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62926426521985347.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91648426238781268.4001)
,p_plug_name=>'Copia de Seguridad de Repositorio'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    f.id as application_id, ',
'    f.security_group_id,',
'    f.name as application_name, ',
'    nvl(b.number_of_backups, 0) as number_of_backups, ',
'    b.last_backup_date, ',
'    f.last_updated_on,',
'    ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'' as application_exists, ',
'    b.last_size',
'from wwv_flows f',
'left join ',
'(',
'    select ',
'        b.application_id, ',
'        count(*) over (partition by b.application_id) as number_of_backups,',
'        max(b.created_on) over (partition by b.application_id) as last_backup_date,',
'        last_value(o.doc_size) over (partition by application_id order by b.created_on RANGE BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) as last_size        ',
'        from wwv_flow_backups$ b',
'        join wwv_flow_file_objects$ o on (o.id = b.object_id)',
'        where b.backup_type != ''RESTORE''',
'        and b.security_group_id = :flow_security_group_id',
') b on (b.application_id = f.id)',
'where f.build_status != ''RUN_AND_HIDDEN''    -- don''t back up packaged apps',
'and f.name is not null                      -- don''t back up un-named apps',
'and f.security_group_id = :flow_security_group_id',
'union ',
'select distinct',
'    b.application_id, ',
'    b.security_group_id,',
'    b.application_name, ',
'    count(*) over (partition by b.application_id) as number_of_backups,',
'    max(b.created_on) over (partition by b.application_id) as last_backup_date,',
'    null as last_updated_on, ',
'    null as application_exists, ',
'    last_value(o.doc_size) over (partition by application_id order by b.created_on RANGE BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) as last_size',
'from wwv_flow_backups$ b',
'join wwv_flow_file_objects$ o on (o.id = b.object_id)',
'where b.backup_type != ''RESTORE''',
'and b.security_group_id = :flow_security_group_id',
'and not exists (select 1 from wwv_flows ne where ne.id = b.application_id and ne.security_group_id = b.security_group_id)',
'order by application_id',
';'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_comment=>'generated 31-JUL-2001 13:40:41'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9766127603736090.4001)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>' '
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'DBLISS'
,p_internal_uid=>9766127603736090
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2257131525636740.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>10
,p_column_identifier=>'F'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7516361140099436.4001)
,p_db_column_name=>'NUMBER_OF_BACKUPS'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>unistr('N\00FAmero de copias de seguridad')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2257237951636741.4001)
,p_db_column_name=>'LAST_BACKUP_DATE'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>unistr('\00DAltima Copia de Seguridad')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(13154548816187519.4001)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>50
,p_column_identifier=>'H'
,p_column_label=>unistr('Nombre de la Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP:P971_APPLICATION_ID,FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:#APPLICATION_ID#,#APPLICATION_ID#,#APPLICATION_ID#,#APPLICATION_ID#,'
,p_column_linktext=>'#APPLICATION_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(70878880123225909.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>60
,p_column_identifier=>'I'
,p_column_label=>unistr('\00DAltima Actualizaci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29200189239902101.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>70
,p_column_identifier=>'J'
,p_column_label=>'Identificador de Grupo de Seguridad'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(70879896892225919.4001)
,p_db_column_name=>'APPLICATION_EXISTS'
,p_display_order=>80
,p_column_identifier=>'K'
,p_column_label=>unistr('La aplicaci\00F3n existe')
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(396497640807282701.4001)
,p_db_column_name=>'LAST_SIZE'
,p_display_order=>90
,p_column_identifier=>'L'
,p_column_label=>unistr('\00DAltimo tama\00F1o')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(196343840029240189.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se realizan copias de seguridad autom\00E1ticas como parte del mantenimiento diario. Solo se realizar\00E1n copias de seguridad de las aplicaciones que se han modificado.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-application-backups.html">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239695113641405231.4001)
,p_plug_name=>'Report Current Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :fb_flow_id is null then',
'    sys.htp.prn(''<span class="htmldbRunEdit">''||',
'       wwv_flow_lang.system_message(''no_application_selected'')||''&nbsp;</span>'');',
'else',
'   sys.htp.prn(''<span class="htmldbRunEdit">''||',
'    wwv_flow_lang.system_message(''application'')||'': ''||:fb_flow_id||''&nbsp;</span>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254938142249716219.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Solo se retienen las copias de seguridad de la aplicaci\00F3n m\00E1s recientes de &P970_MAX.. Las copias de seguridad m\00E1s antiguas se suprimir\00E1n para liberar espacio para las siguientes.</p>'),
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7511352165099409.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(62926426521985347.4001)
,p_button_name=>'P970_GO'
,p_button_static_id=>'P73_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Definir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7511783097099411.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(62926426521985347.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7512145213099413.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(62926426521985347.4001)
,p_button_name=>'IMPORT_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Importar archivo'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:459,460:P461_EXPIMP:IMPORT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(395885750682084615.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(91648426238781268.4001)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:RR,970::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7520283268099458.4001)
,p_branch_action=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7512526384099415.4001)
,p_name=>'P970_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(62926426521985347.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta que no sea sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7513492728099422.4001)
,p_name=>'P970_SHOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(62926426521985347.4001)
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(84313028848586180.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tipo de contenido y haga clic en <span class="fielddatabold">Ir</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7514359210099423.4001)
,p_name=>'P970_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(62926426521985347.4001)
,p_prompt=>'Propietario'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct created_by d, created_by r',
'from WWV_FLOW_FILE_OBJECTS$',
'where security_group_id = :flow_security_group_id and',
'deleted_as_of = to_date(''01.01.0001'',''MM.DD.YYYY'') and ',
'       created_by != ''HTMLDB_PUBLIC_USER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Propietarios -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un propietario y haga clic en <span class="fielddatabold">Ir</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184061262969498747.4001)
,p_name=>'P970_MAX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(254938142249716219.4001)
,p_source=>'return wwv_flow_backup.backup_limit();'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7518148009099449.4001)
,p_validation_name=>'File Selection Not Null'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Seleccione los archivos que desea suprimir.'
,p_when_button_pressed=>wwv_flow_api.id(7511783097099411.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7519360245099452.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(91648426238781268.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7519704290099455.4001)
,p_event_id=>wwv_flow_api.id(7519360245099452.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7518900424099451.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i) and',
'           security_group_id = :flow_security_group_id',
'   ;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir los archivos.'
,p_process_when_button_id=>wwv_flow_api.id(7511783097099411.4001)
,p_process_success_message=>'Archivos suprimidos.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7518579045099450.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00971
begin
wwv_flow_api.create_page(
 p_id=>971.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Gestionar copias de seguridad de aplicaci\00F3n')
,p_step_title=>'Gestionar copias de seguridad'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Note how generic this code is. The only thing specific to the example is',
'// the name of the menu (ir_context_menu) and the button class (ir-actions-btn).',
'// It could easily be turned into a function and moved to a JavaScript file to',
'// be used from any number of reports.',
'var i, item,',
'    items = $("#mb_context_menu").menu("option").items, ',
'    // for some reason the list options are getting double encoded when referencing application pages so ',
'    // I had to create two sets of regular expressions to make this work.',
'    regLong =  /\\u002524\w+\\u002524/,',
'    regLongG = /\\u002524(\w+)\\u002524/g,',
'    regDollar = /\$\w+\$/,',
'    regDollarG = /\$(\w+)\$/g;',
'',
'// The URLs used in the menu are not complete as is.',
'// They have $attr$ substitution symbols that act as a template. This code',
'// moves decodes the $ symbol and copies the href to hrefTemplate property',
'// so it can be used each time the menu opens',
'for (i = 0; i < items.length; i++) {',
'    item = items[i];',
'    if ( (item.href && regLong.exec(item.href)) || (item.href && regDollar.exec(item.href)) ) {',
'        console.log(item.href);',
'        item.hrefTemplate = item.href;',
'    }',
'}',
'',
'// When the menu opens',
'$("#mb_context_menu").on("menubeforeopen", function(event, data) {',
'    var i, item, disabled,',
'        items = data.menu.items,',
'        // This is how to get the context. Would be nice if the beforeopen',
'        // event could tell you directly what button opened it',
'        context$ = $(".ir-actions-btn.is-active"); ',
'    // for each menu item',
'    for( i = 0; i < items.length; i++ ) {',
'        item = items[i];',
'        item.disabled = false;',
'        // if it has a template href with the long pattern',
'        if (item.hrefTemplate && regLong.exec(item.hrefTemplate)) {',
'            // This replace function will replace all $name$ tokens with the',
'            // value of attribute "data-name" on the context element.',
'            // If a context attribute doesn''t exist then disable the menu item',
'            item.href = item.hrefTemplate.replace(regLongG, function(m, token) {',
'                var data = context$.attr("data-" + token);',
'                //if (data === undefined || data === "") {',
'                //    item.disabled = true;',
'                //}',
'                return data;',
'            });',
'        }',
'        // if it has a template href with the dollar-sign pattern',
'        if (item.hrefTemplate && regDollar.exec(item.hrefTemplate)) {',
'            // This replace function will replace all $name$ tokens with the',
'            // value of attribute "data-name" on the context element.',
'            // If a context attribute doesn''t exist then disable the menu item',
'            item.href = item.hrefTemplate.replace(regDollarG, function(m, token) {',
'                var data = context$.attr("data-" + token);',
'                //if (data === undefined || data === "") {',
'                //    item.disabled = true;',
'                //}',
'                return data;',
'            });',
'        }',
'    }',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.t-Body-inlineDialogs {border: 0;clip: rect(0 0 0 0);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}',
''))
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12521305294219513.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se realizan copias de seguridad autom\00E1ticas como parte del mantenimiento diario. Solo se realizar\00E1n copias de seguridad de las aplicaciones que se hayan modificado.</p>'),
unistr('<p>Para realizar una copia de seguridad de la aplicaci\00F3n manualmente, fuera del mantenimiento diario, haga clic en <strong>Crear copia de seguridad</strong>.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-application-backups.html">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15097015004914465.4001)
,p_plug_name=>'Informe de Copia de Seguridad'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  b.id as backup_id, ',
'  case ',
'  when b.backup_type = ''RESTORE'' then',
'      ''<span class="a-Icon icon-undo" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.RESTORED'', b.application_id, b.revision)||''</span>''',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is null then',
'      ''<span class="a-Icon icon-unlock" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.UNLOCKED'')||''</span>''',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is not null then',
'      ''<span class="a-Icon icon-lock" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.LOCKED'')||''</span>''',
'  when b.backup_status = ''ERROR'' then ',
'      ''<span class="a-Icon icon-warning" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.APPLICATION_ERROR'', b.revision)||''</span>''',
'  when b.backup_status = ''IN PROGRESS'' then ',
'      ''<span class="a-Icon icon-gear-alt" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.IN_PROGRESS'')||''</span>''',
'  else',
'    b.backup_status',
'  end as status_icon, ',
'  case ',
'  when b.backup_type = ''RESTORE'' then',
'      wwv_flow_lang.system_message(''BU.RESTORED'', b.application_id, b.revision)',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is null then',
'      wwv_flow_lang.system_message(''BU.UNLOCKED'')',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is not null then',
'     wwv_flow_lang.system_message(''BU.LOCKED'')',
'  when b.backup_status = ''ERROR'' then ',
'      wwv_flow_lang.system_message(''BU.APPLICATION_ERROR'', b.revision)',
'  when b.backup_status = ''IN PROGRESS'' then ',
'      wwv_flow_lang.system_message(''BU.IN_PROGRESS'')',
'  else',
'    b.backup_status',
'  end as status_message, ',
'  b.id, ',
'  b.application_id as backup_app_id, ',
'  b.application_name, ',
'  wwv_flow_backup.format_manifest(b.manifest) as manifest, ',
'  b.description, ',
'  b.created_on, ',
'  case when b.backup_type = ''AUTO'' then ''Automated Backup'' else b.created_by end as created_by, ',
'  o.doc_size, ',
'  to_char(b.revision) as revision,',
'  case when backup_type = ''RESTORE'' then ',
'    null',
'  else',
'  ''<button type="button" title="'' || m.msg_actions || ''" aria-label="'' || m.msg_actions || ''" class="a-Button a-Button--noLabel a-Button--iconTextButton a-Button--noUI ir-actions-btn js-menuButton"',
'        data-menu="mb_context_menu"',
'        data-backupid="''||b.id||''"',
'        data-objectid="''||b.object_id||''"',
'        data-flowid="''||b.application_id||''">',
'    <span class="a-Icon icon-menu" aria-hidden="true"></span>',
'    <span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span>',
'</button>''',
'  end',
'  as action,',
'  b.backup_type, ',
'  b.backup_status, ',
'  b.locked_on, ',
'  b.locked_by',
' from wwv_flow_backups$ b',
' left join wwv_flow_file_objects$ o on (o.id = b.object_id)',
'cross join (select wwv_flow_escape.html_attribute(wwv_flow_lang.system_message(''ACTIONS'')) as msg_actions',
'              from sys.dual',
'             where rownum = 1) m',
'where b.application_id = :fb_flow_id',
'  and b.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9832206744401027.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se han creado copias de seguridad para la aplicaci\00F3n &FB_FLOW_ID.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'DBLISS'
,p_internal_uid=>9832206744401027
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7576718880764309.4001)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7577118490764309.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Fecha'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7577955644764310.4001)
,p_db_column_name=>'MANIFEST'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Resumen de cambios'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'CLOB'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7583525815012114.4001)
,p_db_column_name=>'BACKUP_TYPE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7584052922012119.4001)
,p_db_column_name=>'BACKUP_STATUS'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Estado de Copia de Seguridad'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7584891515012127.4001)
,p_db_column_name=>'ID'
,p_display_order=>140
,p_column_identifier=>'O'
,p_column_label=>'Identificador'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_static_id=>'actions_col'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7587179848012150.4001)
,p_db_column_name=>'BACKUP_APP_ID'
,p_display_order=>160
,p_column_identifier=>'R'
,p_column_label=>unistr('ID de aplicaci\00F3n de copia de seguridad')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12523386582219533.4001)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>180
,p_column_identifier=>'U'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12523467966219534.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>190
,p_column_identifier=>'V'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12523594230219535.4001)
,p_db_column_name=>'DOC_SIZE'
,p_display_order=>200
,p_column_identifier=>'W'
,p_column_label=>unistr('Tama\00F1o')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12523694029219536.4001)
,p_db_column_name=>'LOCKED_ON'
,p_display_order=>210
,p_column_identifier=>'X'
,p_column_label=>'Bloqueado el'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12523746197219537.4001)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>220
,p_column_identifier=>'Y'
,p_column_label=>'Bloqueado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(12523868201219538.4001)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>230
,p_column_identifier=>'Z'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(8000903790535604.4001)
,p_db_column_name=>'REVISION'
,p_display_order=>270
,p_column_identifier=>'AF'
,p_column_label=>unistr('Revisi\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(70878553581225906.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>280
,p_column_identifier=>'AG'
,p_column_label=>unistr('Acci\00F3n')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(70878777381225908.4001)
,p_db_column_name=>'STATUS_MESSAGE'
,p_display_order=>300
,p_column_identifier=>'AI'
,p_column_label=>'Estado'
,p_column_html_expression=>'#STATUS_ICON!RAW#'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7508133414098828.4001)
,p_db_column_name=>'BACKUP_ID'
,p_display_order=>310
,p_column_identifier=>'AJ'
,p_column_label=>'ID de copia de seguridad'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25804736597574802.4001)
,p_plug_name=>unistr('Contenedor de cuadro de di\00E1logo en l\00EDnea')
,p_region_css_classes=>'t-Body-inlineDialogs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25804682224574801.4001)
,p_plug_name=>'Backup Menu'
,p_region_name=>'mb_context'
,p_parent_plug_id=>wwv_flow_api.id(25804736597574802.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(25800649414501670.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(70878332483225904.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>Solo se retienen las copias de seguridad de la aplicaci\00F3n m\00E1s recientes de &P971_MAX.. Las copias de seguridad m\00E1s antiguas se suprimir\00E1n para liberar espacio para las siguientes.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(70878988109225910.4001)
,p_plug_name=>unistr('Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'for c in (select last_updated_on from wwv_flows where id = :FB_FLOW_ID) loop',
'    sys.htp.p(wwv_flow_lang.system_message(''BU.LAST_UPDATE'', apex_util.get_since(c.last_updated_on)));',
'end loop;',
'sys.htp.p(''<br/>'');',
'for c in (select max(last_updated_on) as last_updated_on from  wwv_flow_backups$ where application_id = :FB_FLOW_ID) loop',
'    sys.htp.p(wwv_flow_lang.system_message(''BU.LAST_BACKUP'', apex_util.get_since(c.last_updated_on)));',
'end loop;',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(70879913317225920.4001)
,p_plug_name=>unistr('Aplicaci\00F3n no instalada')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('La aplicaci\00F3n &FB_FLOW_ID. no existe en el espacio de trabajo actual. Utilice la acci\00F3n Restaurar para volver a instalar la aplicaci\00F3n a partir de una copia de seguridad.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.flow_exists(:fb_flow_id) = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(70880084338225921.4001)
,p_plug_name=>'Recursos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(392874975855473167.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(397024265857344325.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15097015004914465.4001)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RR,971::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7510314911098850.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15097015004914465.4001)
,p_button_name=>'REMOVE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Eliminar Todo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:978:&SESSION.::&DEBUG.::P978_FLOW_ID:&FB_FLOW_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7578784909764318.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(15097015004914465.4001)
,p_button_name=>'BACKUP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear copia de seguridad'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:972:&SESSION.::&DEBUG.:RP,972::'
,p_button_condition=>'wwv_flow_imp_parser.flow_exists(:fb_flow_id) = 1'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7579129666764322.4001)
,p_name=>'P971_APPLICATION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15097015004914465.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13153488865187508.4001)
,p_name=>'P971_MAX'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15097015004914465.4001)
,p_source=>'return wwv_flow_backup.backup_limit();'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(70879032747225911.4001)
,p_name=>'P971_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(15097015004914465.4001)
,p_source=>'return wwv_flow_backup.backup_limit();'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00972
begin
wwv_flow_api.create_page(
 p_id=>972.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear una copia de seguridad'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear una copia de seguridad'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7582294140012101.4001)
,p_plug_name=>'Copia de seguridad'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P972_SHOW_BACKUP = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7582467942012103.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12524123798219541.4001)
,p_plug_name=>'No hay que realizar ninguna copia de seguridad'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>No ha habido ning\00FAn cambio en la aplicaci\00F3n desde la \00FAltima copia de seguridad.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P972_SHOW_NOTHING = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7592513034173735.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(7582467942012103.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7582588184012104.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7582467942012103.4001)
,p_button_name=>'BACKUP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copia de seguridad'
,p_button_position=>'NEXT'
,p_button_condition=>':P972_SHOW_BACKUP = ''Y'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7583072854012109.4001)
,p_branch_name=>'Refresh Application Backups'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7582378527012102.4001)
,p_name=>'P972_COMMENTS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(7582294140012101.4001)
,p_prompt=>'Comentarios'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7591604665165989.4001)
,p_name=>'P972_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7582294140012101.4001)
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12524225591219542.4001)
,p_name=>'P972_SHOW_BACKUP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7582467942012103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12524599749219545.4001)
,p_name=>'P972_SHOW_NOTHING'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(7582467942012103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7582681841012105.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(7592513034173735.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7582722399012106.4001)
,p_event_id=>wwv_flow_api.id(7582681841012105.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12524422084219544.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INIT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_last_backup   date;',
'  l_last_modified date;',
'  l_backups       number;',
'  l_locks         number;',
'  l_max           number;',
'begin',
'  null;',
'    l_max := wwv_flow_backup.backup_limit(); ',
'    begin    ',
'    select ',
'      max(b.created_on)                              as last_backup_date, ',
'      f.last_updated_on                              as last_modified_date,',
'      count(*)                                       as number_of_backups, ',
'      nvl(sum(decode(b.locked_on, null, 0, 1)), 0)   as number_of_locks ',
'    into ',
'      l_last_backup,',
'      l_last_modified,',
'      l_backups, ',
'      l_locks',
'    from wwv_flow_backups$ b',
'    join wwv_flows f on (f.id = b.application_id)',
'    where b.application_id = :FB_FLOW_ID',
'    group by f.last_updated_on;',
'    exception',
'      when others then ',
'        l_last_backup := null;',
'    end;',
'    ',
'    -- determine which fields and buttons are displayed depending upon the values returned',
'    if l_last_backup is null or l_last_backup < l_last_modified then ',
'      :P972_SHOW_BACKUP  := ''Y'';',
'      :P972_SHOW_NOTHING := ''N'';',
'    else ',
'      :P972_SHOW_BACKUP  := ''N'';',
'      :P972_SHOW_NOTHING := ''Y'';',
'    end if;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7582994315012108.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Backup Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_backup.main(:FB_FLOW_ID, :P972_COMMENTS);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(7582588184012104.4001)
,p_process_success_message=>unistr('Se ha enviado la copia de seguridad de &FB_FLOW_ID. de la aplicaci\00F3n')
);
end;
/
prompt --application/pages/page_00973
begin
wwv_flow_api.create_page(
 p_id=>973.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Detalles de Copia de Seguridad'
,p_page_mode=>'MODAL'
,p_step_title=>'Detalles de Copia de Seguridad'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(7508268365098829.4001)
,p_name=>'Detalles de Copia de Seguridad'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with manifest_summary as (',
'    select wwv_flow_lang.system_message(e.component_type) as component_type,',
'           wwv_flow_lang.system_message(e.action) as action,',
'           e.component_name,',
'           e.last_updated_by, ',
'           to_date(e.last_updated_on, ''YYYYMMDD HH24:MI:SS'') as last_updated_on',
'    from wwv_flow_backups$ j, xmltable(',
'        ''/json/details/row''',
'        passing apex_json.to_xmltype( j.manifest )',
'        columns',
'            component_type    varchar2(100)   path ''component_type/text()'',',
'            action            varchar2(100)   path ''action/text()'',',
'            component_name    varchar2(1000)  path ''component_name/text()'',',
'            last_updated_by   varchar2(100)   path ''last_updated_by/text()'',',
'            last_updated_on   varchar2(100)   path ''last_updated_on/text()'' ) e',
'    where  j.id = :P973_ID',
'    and j.security_group_id = wwv_flow.get_security_group_id()',
'    and j.manifest like ''{%''',
')',
'select * from manifest_summary;'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_backups$ j',
'where  j.id = :P973_ID',
'and j.security_group_id = wwv_flow.get_security_group_id()',
'and j.manifest like ''{%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('<p>Se han actualizado las propiedades de la aplicaci\00F3n. No se han actualizado m\00E1s componentes.</p>')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7508387117098830.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7508436368098831.4001)
,p_query_column_id=>2
,p_column_alias=>'ACTION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7508568209098832.4001)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7508634386098833.4001)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Desarrollador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(7508730704098834.4001)
,p_query_column_id=>5
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>5
,p_column_heading=>'Fecha'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7508858356098835.4001)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(239630035198602786.4001)
,p_plug_name=>unistr('Copia de seguridad de aplicaci\00F3n inicial')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Copia de seguridad de la aplicaci\00F3n inicial</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_backups$ j',
'where  j.id = :P973_ID',
'and j.security_group_id = wwv_flow.get_security_group_id()',
'and j.manifest like ''{%'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21205281332555992.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7508858356098835.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12361412704400654.4001)
,p_name=>'P973_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(239630035198602786.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7508981142098836.4001)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(21205281332555992.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7509088511098837.4001)
,p_event_id=>wwv_flow_api.id(7508981142098836.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_00974
begin
wwv_flow_api.create_page(
 p_id=>974.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Restaurar aplicaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Restaurar aplicaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7585208326012131.4001)
,p_plug_name=>'Restaurar Opciones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si restaura una aplicaci\00F3n que utiliza el ID de aplicaci\00F3n original, la aplicaci\00F3n existente se sobrescribir\00E1 con la copia de seguridad.     '),
'</p>',
'<p>',
unistr('Especifique un nuevo ID de aplicaci\00F3n para restaurar sin sobrescribir la aplicaci\00F3n existente.    '),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7585680269012135.4001)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7585709308012136.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(7585680269012135.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7586250418012141.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(7585680269012135.4001)
,p_button_name=>'RESTORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Restaurar aplicaci\00F3n')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12520960164219509.4001)
,p_branch_name=>'Go Home'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,974:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:&P974_NEW_FLOW_ID.,&P974_NEW_FLOW_ID.,&P974_NEW_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7585326200012132.4001)
,p_name=>'P974_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7586026210012139.4001)
,p_name=>'P974_NEW_FLOW_OPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_item_default=>'REUSE'
,p_prompt=>unistr('Opciones de Instalaci\00F3n de Aplicaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Restore Application ID &FB_FLOW_ID.;REUSE,Auto Assign New Application ID;AUTO,Change Application ID;SPECIFY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo restaurar esta aplicaci\00F3n. Entre las opciones disponibles se incluyen:</p>'),
'',
'<ul>',
unistr('<li><strong>Restaurar identificador de aplicaci\00F3n</strong>: se utilizar\00E1 el ID de aplicaci\00F3n existente.</li>'),
unistr('<li><strong>Asignar autom\00E1ticamente nuevo identificador de aplicaci\00F3n</strong>: se crear\00E1 un nuevo ID de aplicaci\00F3n.</li>'),
unistr('<li><strong>Cambiar identificador de aplicaci\00F3n</strong>: especifique un nuevo ID de aplicaci\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7586376275012142.4001)
,p_name=>'P974_NEW_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_prompt=>unistr('Nueva Aplicaci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique un nuevo ID de aplicaci\00F3n que sea un valor entero que identifique la aplicaci\00F3n. El ID de aplicaci\00F3n debe ser \00FAnico en la instancia de Application Express.'),
'<br><br>',
unistr('Application Express reserva los ID de aplicaci\00F3n incluidos en el rango de 3000 a 9000 para utilizarlos de forma interna<br>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7586923102012148.4001)
,p_name=>'P974_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13153611075187510.4001)
,p_name=>'P974_BACKUP_FIRST'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC:Backup before restoring;Y'
,p_display_when=>'P974_SHOW_BACKUP'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13154179781187515.4001)
,p_name=>'P974_SHOW_BACKUP'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13154217996187516.4001)
,p_name=>'P974_SHOW_NOTHING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13154391769187517.4001)
,p_name=>'P974_NOTHING'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(7585208326012131.4001)
,p_source=>'There have been no changes to the application since the last backup.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P974_SHOW_NOTHING'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(12520158687219501.4001)
,p_computation_sequence=>10
,p_computation_item=>'P974_NEW_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P974_FLOW_ID'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'P974_NEW_FLOW_OPT'
,p_compute_when_text=>'REUSE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(12520234638219502.4001)
,p_computation_sequence=>20
,p_computation_item=>'P974_NEW_FLOW_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_utilities.minimum_free_flow();'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>':P974_NEW_FLOW_OPT = ''AUTO'' and :REQUEST = ''RESTORE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12520340327219503.4001)
,p_validation_name=>'New Flow ID Not Null'
,p_validation_sequence=>20
,p_validation=>'P974_NEW_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la aplicaci\00F3n nueva.')
,p_validation_condition=>'P974_NEW_FLOW_OPT'
,p_validation_condition2=>'SPECIFY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(7586250418012141.4001)
,p_associated_item=>wwv_flow_api.id(7586376275012142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12520502118219505.4001)
,p_validation_name=>'specify new flow not same flow'
,p_validation_sequence=>30
,p_validation=>'ltrim(:P974_NEW_FLOW_ID,''0'') != nvl(:P974_FLOW_ID,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El ID de aplicaci\00F3n nuevo debe ser diferente del ID de aplicaci\00F3n original al utilizar esta opci\00F3n. Para volver a utilizar el mismo ID de aplicaci\00F3n, utilice el bot\00F3n de radio ''Restaurar ID de aplicaci\00F3n de &P974_FLOW_ID.''.')
,p_validation_condition=>':P974_NEW_FLOW_OPT = ''SPECIFY'' and wwv_flow_utilities.is_numeric(:P974_NEW_FLOW_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(7586250418012141.4001)
,p_associated_item=>wwv_flow_api.id(7586376275012142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12520605977219506.4001)
,p_validation_name=>'reserved flow id check'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.get_app_id_reserved_reason (',
'           p_security_group_id => :FLOW_SECURITY_GROUP_ID,',
'           p_application_id    => :P974_NEW_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P974_NEW_FLOW_OPT = ''SPECIFY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(7586250418012141.4001)
,p_associated_item=>wwv_flow_api.id(7586376275012142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12520783627219507.4001)
,p_validation_name=>'cannot import invalid range flow'
,p_validation_sequence=>50
,p_validation=>':P974_NEW_FLOW_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La aplicaci\00F3n que est\00E1 intentando restaurar est\00E1 reservada.')
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P974_FLOW_ID is not null) and (wwv_flow_utilities.is_numeric(:P974_NEW_FLOW_ID) = true)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(7586250418012141.4001)
,p_associated_item=>wwv_flow_api.id(7586376275012142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(12520876989219508.4001)
,p_validation_name=>'P974_NEW_FLOW_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'P974_NEW_FLOW_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de aplicaci\00F3n debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P974_NEW_FLOW_ID is not null and',
':P974_NEW_FLOW_OPT = ''SPECIFY'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(7586250418012141.4001)
,p_associated_item=>wwv_flow_api.id(7586376275012142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7585817710012137.4001)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(7585709308012136.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7585949689012138.4001)
,p_event_id=>wwv_flow_api.id(7585817710012137.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7586491178012143.4001)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P974_NEW_FLOW_OPT'
,p_condition_element=>'P974_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7586530962012144.4001)
,p_event_id=>wwv_flow_api.id(7586491178012143.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7586620776012145.4001)
,p_event_id=>wwv_flow_api.id(7586491178012143.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(13153734280187511.4001)
,p_name=>'Toggle Backup First'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P974_NEW_FLOW_OPT'
,p_condition_element=>'P974_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REUSE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13153856988187512.4001)
,p_event_id=>wwv_flow_api.id(13153734280187511.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_BACKUP_FIRST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13153910875187513.4001)
,p_event_id=>wwv_flow_api.id(13153734280187511.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_BACKUP_FIRST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7586855429012147.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Restore'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_flow_id number;',
'begin',
'  case when :P974_NEW_FLOW_OPT = ''REUSE'' then ',
'    l_new_flow_id := :P974_FLOW_ID;',
'  else -- AUTO',
'    l_new_flow_id := :P974_NEW_FLOW_ID;',
'  end case;',
'',
'  wwv_flow_backup.restore(:P974_ID, :P974_FLOW_ID, l_new_flow_id, nvl(:P974_BACKUP_FIRST, ''N'') = ''Y'');',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(7586250418012141.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13154042218187514.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INIT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_last_backup   date;',
'  l_last_modified date;',
'  l_backups       number;',
'  l_locks         number;',
'begin',
'    select ',
'      max(b.created_on)                              as last_backup_date, ',
'      f.last_updated_on                              as last_modified_date,',
'      count(*)                                       as number_of_backups, ',
'      nvl(sum(decode(b.locked_on, null, 0, 1)), 0)   as number_of_locks ',
'    into ',
'      l_last_backup,',
'      l_last_modified,',
'      l_backups, ',
'      l_locks',
'    from wwv_flow_backups$ b',
'    left join wwv_flows f on (f.id = b.application_id)',
'    where b.application_id = :FB_FLOW_ID',
'    and b.security_group_id = :flow_security_group_id',
'    group by f.last_updated_on;',
'    ',
'    -- determine which fields and buttons are displayed depending upon the values returned',
'    if l_last_backup is null or l_last_backup < l_last_modified then ',
'      :P974_SHOW_BACKUP  := ''Y'';',
'      :P974_SHOW_NOTHING := ''N'';',
'    else ',
'      :P974_SHOW_BACKUP  := ''N'';',
'      :P974_SHOW_NOTHING := ''Y'';',
'    end if;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00975
begin
wwv_flow_api.create_page(
 p_id=>975.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Probar Referencia Web REST'
,p_step_title=>'Probar Referencia Web REST'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="javascript">',
'apex.jQuery(document).ready( function() {',
'',
'    apex.jQuery("#rest_response").hide();',
'});',
'',
'function p975_test_rest(){',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P875_TEST_REST'',0);',
'',
'    get.addParam(''x01'',$v(''P975_URL''));',
'    get.addParam(''x02'',$v(''P975_PROXY_OVERRIDE''));',
'    get.addParam(''x03'',$v(''P975_STATIC_PARM_04''));',
'    get.addParam(''x04'',$v(''P975_USERNAME''));',
'    get.addParam(''x05'',$v(''P975_PASSWORD''));',
'    get.addParam(''x06'',encodeURIComponent($v(''P975_SOURCE'')));',
'',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f03]").each( function() {',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'',
'    gReturn = get.get();',
'    apex.jQuery("#rest_response").show();',
'    apex.jQuery("#rest_response_container").text(gReturn);',
'    get = null;',
'',
'}',
'function clear_response(){',
'    apex.jQuery(''#rest_response_container'').html('' '');',
'}',
'</script>',
''))
,p_inline_css=>'#rest_response_container:empty {display: none;}'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(259646728667715702.4001)
,p_plug_name=>'Detalles de Servicio Web REST'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice esta p\00E1gina para probar la referencia de un servicio web REST '),
unistr('<p>Modifique la URL del servicio si contiene referencias al estado de la sesi\00F3n. Introduzca una anulaci\00F3n de proxy si desea utilizar uno concreto para la prueba que realice en esta p\00E1gina. Facilite credenciales de autenticaci\00F3n b\00E1sica si as\00ED lo solic')
||unistr('ita el servicio web. Introduzca valores para las cabeceras http y los par\00E1metros de entrada requeridos, y haga clic en Probar. La respuesta aparecer\00E1 en una regi\00F3n que permite desplazamientos, bajo la regi\00F3n Par\00E1metros de Entrada.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(259650714124715708.4001)
,p_name=>unistr('Par\00E1metros de Entrada')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(1, c.c001) name,',
'       wwv_flow_item.text(2, null, null, null, null, ''input''||seq_id, wwv_flow_lang.system_message(''F4000_P975_VALUE_FOR'',c.c001)) value',
'  from wwv_flow_collections c',
' where collection_name = ''REST_INPUT_PARMS''',
'   and nvl(:P872_INPUT_TYPE,''nvp'') = ''nvp'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(259650913301715711.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(259651000339715711.4001)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(259651607175715711.4001)
,p_plug_name=>'Response'
,p_region_name=>'rest_respose'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_source=>'<div class="a-Form-textarea a-Form-textarea--code" id="rest_response_container" style="white-space: pre-line; max-height: 300px; overflow: auto;"></div>'
,p_translate_title=>'N'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(259651816639715713.4001)
,p_plug_name=>unistr('Autenticaci\00F3n B\00E1sica')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>125
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P871_BASIC_AUTH'
,p_plug_display_when_cond2=>'Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(259653006116715715.4001)
,p_name=>'Cabeceras HTTP'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>127
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(3, c.c001) name,',
'       wwv_flow_item.text(4, null, null, null, null, ''header''||seq_id, wwv_flow_lang.system_message(''F4000_P975_VALUE_FOR'',c.c001)) value',
'  from wwv_flow_collections c',
' where collection_name = ''REST_HTTP_HEADERS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null from wwv_flow_collections c',
' where collection_name = ''REST_HTTP_HEADERS''',
'   and c001 is not null'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay par\00E1metros de entrada para este servicio.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(259653213006715715.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(259653326608715715.4001)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754559883128487443.4001)
,p_plug_name=>'Detalles de Servicio Web REST'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259646922211715703.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(754559883128487443.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259647127606715703.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(754559883128487443.4001)
,p_button_name=>'CLEAR'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Borrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:clear_response();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259647329730715704.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(754559883128487443.4001)
,p_button_name=>'TEST'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Probar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p975_test_rest();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259647727867715705.4001)
,p_name=>'P975_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(259646728667715702.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'P871_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre de referencia de servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259648221853715705.4001)
,p_name=>'P975_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(259646728667715702.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'P871_URL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Punto final de URL del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259648716285715706.4001)
,p_name=>'P975_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(259646728667715702.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Anulaci\00F3n de Proxy')
,p_source=>'P871_PROXY_OVERRIDE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proxy que se va a utilizar en lugar del que se ha definido a nivel de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259649208273715706.4001)
,p_name=>'P975_STATIC_PARM_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(259646728667715702.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo HTTP')
,p_source=>'P871_METHOD'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('M\00E9todo HTTP utilizado para realizar la solicitud al servicio web.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259650200278715707.4001)
,p_name=>'P975_STATIC_PARM_10'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(259646728667715702.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvp'
,p_prompt=>'Formato de Entrada'
,p_source=>'P872_INPUT_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(48714213128492554.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'El tipo de entrada que espera el servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259651131119715711.4001)
,p_name=>'P975_SOURCE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(259650714124715708.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Origen'
,p_source=>'P872_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'nvl(:P872_INPUT_TYPE,''nvp'') != ''nvp'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el origen que se va a utilizar como entrada del servicio web.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259652023086715714.4001)
,p_name=>'P975_USERNAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(259651816639715713.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de usuario para la autenticaci\00F3n b\00E1sica HTTP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259652526427715714.4001)
,p_name=>'P975_PASSWORD'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(259651816639715713.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a para la autenticaci\00F3n b\00E1sica HTTP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00976
begin
wwv_flow_api.create_page(
 p_id=>976.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Gestionar bloqueo de copia de seguridad'
,p_page_mode=>'MODAL'
,p_step_title=>'Gestionar bloqueo de copia de seguridad'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13152956436187503.4001)
,p_plug_name=>unistr('Informaci\00F3n de desbloqueo')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P976_LOCKED'
,p_plug_display_when_cond2=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si desbloquea una copia de seguridad, se podr\00E1 suprimir durante el mantenimiento diario. Solo se retienen las copias de seguridad de aplicaci\00F3n m\00E1s recientes de &P976_MAX.. '),
unistr('Las copias de seguridad m\00E1s antiguas se suprimir\00E1n para liberar espacio para las nuevas.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20720572618631293.4001)
,p_plug_name=>unistr('Informaci\00F3n de bloqueo')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P976_LOCKED'
,p_plug_display_when_cond2=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Bloquee una copia de seguridad para evitar que se suprima durante el mantenimiento diario.</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20721044561631297.4001)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13138965569619171.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20721044561631297.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13139354387619171.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20721044561631297.4001)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Bloquear copia de seguridad'
,p_button_position=>'NEXT'
,p_button_condition=>'P976_LOCKED'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13152732491187501.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20721044561631297.4001)
,p_button_name=>'UNLOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Desbloquear copia de seguridad'
,p_button_position=>'NEXT'
,p_button_condition=>'P976_LOCKED'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12525043347219550.4001)
,p_branch_name=>'Refresh Parent Page'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'LOCK,UNLOCK'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13137836202619170.4001)
,p_name=>'P976_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20721044561631297.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13138223089619170.4001)
,p_name=>'P976_LOCKED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20721044561631297.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13153363997187507.4001)
,p_name=>'P976_MAX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20721044561631297.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(13142972226619176.4001)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(13138965569619171.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13143332879619177.4001)
,p_event_id=>wwv_flow_api.id(13142972226619176.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(13143890964619177.4001)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P976_NEW_FLOW_OPT'
,p_condition_element=>'P976_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13144223288619178.4001)
,p_event_id=>wwv_flow_api.id(13143890964619177.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P976_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(13144702178619178.4001)
,p_event_id=>wwv_flow_api.id(13143890964619177.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P976_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12524803461219548.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Lock Backup'
,p_process_sql_clob=>'wwv_flow_backup.lock_backup(:P976_ID, :APP_USER);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(13139354387619171.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13152876615187502.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unlock'
,p_process_sql_clob=>'wwv_flow_backup.unlock_backup(:P976_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(13152732491187501.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13153266232187506.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INIT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  :P976_MAX := wwv_flow_backup.backup_limit(); ',
'  ',
'  select decode(locked_on, null, ''N'', ''Y'') ',
'  into :P976_LOCKED ',
'  from wwv_flow_backups$ ',
'  where id = :P976_ID;',
'exception',
'when others then ',
'  :P976_LOCKED := ''Y'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00977
begin
wwv_flow_api.create_page(
 p_id=>977.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir copia de seguridad'
,p_page_mode=>'MODAL'
,p_step_title=>'Suprimir copia de seguridad'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48923393357919167.4001)
,p_plug_name=>unistr('Confirmaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('\00BFSeguro que desea suprimir esta copia de seguridad?</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48923865300919171.4001)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28203933976287923.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(48923865300919171.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28204309221287924.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48923865300919171.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir copia de seguridad'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28209953254287955.4001)
,p_branch_name=>'Refresh Parent Page'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(28204309221287924.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27600598960736905.4001)
,p_name=>'P977_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(48923865300919171.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28205105805287925.4001)
,p_name=>'P977_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48923865300919171.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28207562545287951.4001)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(28203933976287923.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28208042657287954.4001)
,p_event_id=>wwv_flow_api.id(28207562545287951.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28208405819287954.4001)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P977_NEW_FLOW_OPT'
,p_condition_element=>'P977_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28208997691287954.4001)
,p_event_id=>wwv_flow_api.id(28208405819287954.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P977_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28209461077287955.4001)
,p_event_id=>wwv_flow_api.id(28208405819287954.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P977_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(27600493201736904.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Backup'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_backup.remove',
'(',
'    p_application_id    => :P977_FLOW_ID, ',
'    p_security_group_id => wwv_flow_security.g_security_group_id, ',
'    p_backup_id         => :P977_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(27600801265736908.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify Access'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    i number;',
'begin',
'    -- Because the Manage Backups page uses context sensitive menus, the ID an FLOW_ID items are not protected by a checksum.',
'    -- This query will raise an error if a user attempts to access a backup that he is not authorized to access.',
'    select 1',
'    into i',
'    from wwv_flow_backups$ ',
'    where id = :P977_ID',
'    and application_id = :P977_FLOW_ID',
'    and security_group_id = wwv_flow.get_security_group_id();',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00978
begin
wwv_flow_api.create_page(
 p_id=>978.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Eliminar todas las copias de seguridad'
,p_page_mode=>'MODAL'
,p_step_title=>'Eliminar todas las copias de seguridad'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78324472039929637.4001)
,p_plug_name=>unistr('Confirmaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00BFSeguro que desea suprimir todas las copias de seguridad de la aplicaci\00F3n &P978_FLOW_ID.?</p>'),
unistr('<p>Esta operaci\00F3n es irreversible. Seleccione Eliminar todas las copias de seguridad para continuar.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78324943982929641.4001)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29401860173010517.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(78324943982929641.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29402206780010518.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(78324943982929641.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Eliminar todas las copias de seguridad'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29406625170010558.4001)
,p_branch_name=>'Refresh Parent Page'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(29402206780010518.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29403077328010522.4001)
,p_name=>'P978_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(78324943982929641.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(29405672004010556.4001)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(29401860173010517.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29406110541010557.4001)
,p_event_id=>wwv_flow_api.id(29405672004010556.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(29404273458010552.4001)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P978_NEW_FLOW_OPT'
,p_condition_element=>'P978_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29404725299010555.4001)
,p_event_id=>wwv_flow_api.id(29404273458010552.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P978_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29405223656010556.4001)
,p_event_id=>wwv_flow_api.id(29404273458010552.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P978_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29403449469010550.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Backup'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_backup.remove_all',
'(',
'    p_application_id    => :P978_FLOW_ID, ',
'    p_security_group_id => wwv_flow_security.g_security_group_id',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29403825347010551.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify Access'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    i number;',
'begin',
'    -- Because the Manage Backups page uses context sensitive menus, the ID an FLOW_ID items are not protected by a checksum.',
'    -- This query will raise an error if a user attempts to access a backup that he is not authorized to access.',
'    select 1',
'    into i',
'    from wwv_flow_backups$ ',
'    where application_id = :P978_FLOW_ID',
'    and security_group_id = :flow_security_group_id',
'    and rownum = 1;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00979
begin
wwv_flow_api.create_page(
 p_id=>979.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Todos los detalles de copia de seguridad'
,p_page_mode=>'MODAL'
,p_step_title=>'Todos los detalles de copia de seguridad'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(5507013954294272)
,p_step_template=>wwv_flow_api.id(120871216744825711.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(489623016951494467.4001)
,p_name=>'Detalles de Copia de Seguridad'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with manifest_summary as (',
'    select wwv_flow_lang.system_message(e.component_type) as component_type,',
'           wwv_flow_lang.system_message(e.action) as action,',
'           e.component_name,',
'           e.last_updated_by, ',
'           to_date(e.last_updated_on, ''YYYYMMDD HH24:MI:SS'') as last_updated_on',
'    from wwv_flow_backups$ j, xmltable(',
'        ''/json/details/row''',
'        passing apex_json.to_xmltype( j.manifest )',
'        columns',
'            component_type    varchar2(100)   path ''component_type/text()'',',
'            action            varchar2(100)   path ''action/text()'',',
'            component_name    varchar2(1000)  path ''component_name/text()'',',
'            last_updated_by   varchar2(100)   path ''last_updated_by/text()'',',
'            last_updated_on   varchar2(100)   path ''last_updated_on/text()'' ) e',
'    where  j.application_id = :FB_FLOW_ID',
'    and j.security_group_id = wwv_flow.get_security_group_id()',
'    and j.manifest like ''{%''',
')',
'select * from manifest_summary;'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('<p>Se han actualizado las propiedades de la aplicaci\00F3n. No se han actualizado m\00E1s componentes.</p>')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(482115364127395639.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(482115728191395640.4001)
,p_query_column_id=>2
,p_column_alias=>'ACTION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(482116176773395640.4001)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(482116566000395640.4001)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Desarrollador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(482116959440395640.4001)
,p_query_column_id=>5
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>5
,p_column_heading=>'Fecha'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(489623606942494473.4001)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(482117679369395642.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(489623606942494473.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(482118799477395644.4001)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(482117679369395642.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(482119260892395645.4001)
,p_event_id=>wwv_flow_api.id(482118799477395644.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_api.create_page(
 p_id=>1000.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Ejecutar P\00E1gina')
,p_alias=>'RUN_PAGE'
,p_step_title=>unistr('Bifurcar a P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(26658621021615392.4001)
,p_plug_name=>'items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(26648532552401082.4001)
,p_branch_name=>'Branch To Page Identified By Item'
,p_branch_action=>'FB_FLOW_PAGE_ID'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_sequence=>30
,p_branch_condition_type=>'FUNCTION_BODY'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1000_DIRECT_BRANCH = ''TRUE'' then',
'  wwv_flow.g_flow_id := :FB_FLOW_ID;',
'  wwv_flow_security.g_curr_flow_security_group_id := null;',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(26660119336643241.4001)
,p_branch_name=>'Go To Page &FB_FLOW_PAGE_ID.'
,p_branch_action=>'return wwv_flow_dev.get_run_url ('||wwv_flow.LF||
'           p_application_id => :FB_FLOW_ID,'||wwv_flow.LF||
'           p_page_id        => :FB_FLOW_PAGE_ID,'||wwv_flow.LF||
'           p_debug          => :P1000_DEBUG,'||wwv_flow.LF||
'           p_friendly_url   => true );'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_URL'
,p_branch_language=>'PLSQL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(26659210201631136.4001)
,p_name=>'P1000_DIRECT_BRANCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(26658621021615392.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(310413445435299407.4001)
,p_name=>'P1000_DEBUG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(26658621021615392.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(26650103378411579.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flow ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1000_DIRECT_BRANCH := ''FALSE'';',
'for c1 in (',
'  select 1 from wwv_flows f, wwv_flow_steps s ',
'  where f.id = s.flow_id',
'  and f.id = :FB_FLOW_ID',
'  and s.id = :FB_FLOW_PAGE_ID ',
'  and s.protection_level = ''D'' ',
'  and f.PAGE_PROTECTION_ENABLED_Y_N = ''Y'') loop',
'  --',
'  :P1000_DIRECT_BRANCH := ''TRUE'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_api.create_page(
 p_id=>1100.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Consultas de Informe'
,p_step_title=>'Consultas de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62890902382644553.4001)
,p_plug_name=>'Consultas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una consulta de informe es un documento imprimible, que se puede integrar con una aplicaci\00F3n mediante botones, elementos de lista, bifurcaciones o cualquier otro componente de navegaci\00F3n que permita el uso de URL como destinos.</p>'),
'',
unistr('<p>Una consulta de informe est\00E1 basada en una consulta SQL est\00E1ndar. Se puede descargar como documento PDF, documento de Word (basado en RTF), hoja de c\00E1lculo de Excel (basada en HTML) o como archivo HTML. El dise\00F1o de la consulta de informe se puede')
||' personalizar con plantillas RTF.</p>',
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-report-output.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188062721932626087.4001)
,p_plug_name=>'Consultas Almacenadas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    ID,',
'    NAME,',
'    nvl(LAST_UPDATED_ON,CREATED_ON) last_modified,',
'    QUERY_TEXT,',
'    ''icon-sc-reports'' icon_class,',
'    name icon_title,',
'''f?p=4000:1116:''||:app_session||'':::1116,1117,1112:P1116_ID,P1116_INIT:''||id||'',YES'' edit_link,',
'    replace(name,''_'','' '') image_text',
'from WWV_FLOW_SHARED_QUERIES q',
'where flow_id = :fb_flow_id ',
'  and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(188062805545626087.4001)
,p_name=>'Stored Queries '
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188063017618626118.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188063117876626121.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre de Consulta'
,p_column_link=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:1116,1117,1112:P1116_ID,P1116_INIT:#ID#,YES'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188063322079626122.4001)
,p_db_column_name=>'QUERY_TEXT'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Texto de la Consulta'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188063228925626121.4001)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>unistr('Fecha de Modificaci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188063904045632190.4001)
,p_db_column_name=>'IMAGE_TEXT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Texto de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656845777352609914.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656845895582609915.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656845917763609915.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(193370709913516416.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(193369209650497455.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188995926604107717.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(188062721932626087.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:1100,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62964404787843921.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(188062721932626087.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1121:&SESSION.::&DEBUG.:1121::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11547728103324503.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(188062721932626087.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:1110,1112,1113,1114,1115,1116,1117,1118,1119::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11544726731301615.4001)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590044949387250709.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(11547728103324503.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590045284921250710.4001)
,p_event_id=>wwv_flow_api.id(590044949387250709.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590045397449252903.4001)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(62964404787843921.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590045604333252903.4001)
,p_event_id=>wwv_flow_api.id(590045397449252903.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_01110
begin
wwv_flow_api.create_page(
 p_id=>1110.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Consulta de Informe: Definici\00F3n de Consulta de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22559326834649953.4001)
,p_plug_name=>'Crear Consulta de Informe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique un nombre para la consulta de informe y seleccione el formato de salida. Al utilizar Oracle BI Publisher como servidor de impresi\00F3n, puede exportar el informe a PDF, Microsoft Word, Microsoft Excel y HTML. Tambi\00E9n puede permitir que el')
||unistr(' usuario elija el formato de salida en tiempo de ejecuci\00F3n utilizando un elemento de p\00E1gina para definir el formato. El nombre de la consulta de informe ser\00E1 parte de la cadena de solicitud en la direcci\00F3n URL utilizada para descargar la consulta de ')
||unistr('informe. Puede incluir el estado de la sesi\00F3n de la aplicaci\00F3n actual en el informe. Seleccione esta opci\00F3n cuando desee mostrar datos adicionales en el informe. Por ejemplo, puede que desee incluir informaci\00F3n de la cabecera de la orden junto con lo')
||unistr('s detalles de la orden en una pantalla de \00F3rdenes.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22646912407924415.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22638505565903517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206257529956666480.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22559726847649953.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206257529956666480.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22560019529649953.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206257529956666480.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22560401601649954.4001)
,p_branch_action=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22560019529649953.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22684901775053888.4001)
,p_name=>'P1110_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_prompt=>'Nombre de Consulta de Informe'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca un nombre para identificar la consulta del informe. Al hacer referencia a una consulta de informe como destino de enlace, el nombre de la consulta del informe es parte de la cadena de solicitud.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108841010551095869.4001)
,p_name=>'P1110_OUTPUT_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_item_default=>'PDF'
,p_prompt=>'Formato de Salida'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRN_FORMAT'
,p_lov=>'.'||wwv_flow_api.id(16950902829395371.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Derivar de Elemento'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el formato de salida del informe. Los formatos soportados son PDF, Microsoft Word (formato RTF), Microsoft Excel (formato XLS), XML y HTML. Tambi\00E9n puede hacer que un elemento especifique el formato de salida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(108842216784097579.4001)
,p_name=>'P1110_FORMAT_ITEM'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_prompt=>'Elemento'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||wwv_flow_escape.html(name) a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||wwv_flow_escape.html(name) a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_cSize=>25
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determina el formato de salida en tiempo de ejecuci\00F3n. Seleccione el elemento que contendr\00E1 el valor de formato. Los valores v\00E1lidos son PDF, RTF (para abrir el documento en Microsoft Word), XLS (para abrir el documento en Microsoft Excel) y HTM (par')
||'a descargar el documento como archivo HTML).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112563323088659987.4001)
,p_name=>'P1110_ITEMS'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_prompt=>'Seleccionar Elementos'
,p_display_as=>'NATIVE_LIST_MANAGER'
,p_named_lov=>'PRINT_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ('' || t || '') '' d,name r from (',
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where  flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where flow_id = :fb_flow_id',
'order by 4 asc nulls first, 1 asc',
')'))
,p_tag_attributes=>'style="width:250px"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique los elementos a los que desea hacer referencia en la consulta. Haga clic en la flecha arriba y seleccione un elemento de la lista. A continuaci\00F3n, haga clic en <strong>Agregar</strong> para mover el elemento al recuadro de texto. Para eli')
||unistr('minar un elemento, haga clic en \00E9l en el recuadro de texto y en <strong>Eliminar</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FIRST_ROWSET'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112574231839719263.4001)
,p_name=>'P1110_XML_STRUCTURE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_prompt=>unistr('Estado de la Sesi\00F3n')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REPOER_QUERY_XML_STRUCTURE'
,p_lov=>'.'||wwv_flow_api.id(75124227694454957.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onClick="javascript:toggleItemSelector($v(''P1110_XML_STRUCTURE''))"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al activar la opci\00F3n "Estado de la Sesi\00F3n", puede hacer referencia a valores de estado de la sesi\00F3n (como los valores de los elementos de las p\00E1ginas) en la estructura XML de la consulta de informe.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137951911350272633.4001)
,p_name=>'P1110_CONTENT_DISPOSITION'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ATTACHMENT'
,p_prompt=>'Ver Archivo como'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONTENT_DISPOSITION'
,p_lov=>'.'||wwv_flow_api.id(137375920403903467.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Con el atributo <strong>Ver Archivo como</strong> se puede indicar al explorador que muestre un recuadro de di\00E1logo para <strong>abrir o guardar el archivo</strong> al hacer clic en el bot\00F3n de descarga de la consulta de informe o que muestre el docu')
||unistr('mento de consulta de informe en la ventana del explorador. Esta selecci\00F3n est\00E1 incluida en la cabecera HTTP del documento mediante el atributo content-disposition.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(140610909418367185.4001)
,p_name=>'P1110_JS'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(22559326834649953.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="Javascript1.1" type="text/javascript">',
'',
'  function toggleItemSelector(includeItems) {',
'    if (includeItems==''APEX'') {',
'      apex.item(''P1110_ITEMS'').show();',
'    } else {',
'      apex.item(''P1110_ITEMS'').hide();',
'    }',
'  }',
'',
'  toggleItemSelector($v(''P1110_XML_STRUCTURE''));',
'',
'</script>'))
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(63349030638267684.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1120_QUERY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1110_QUERY_SOURCE	'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(113746501980272338.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1110_XML_STRUCTURE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'APEX'
,p_compute_when=>'P1110_ITEMS'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(104970105465892341.4001)
,p_validation_name=>'P1110_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'P1110_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_when_button_pressed=>wwv_flow_api.id(22560019529649953.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-DEC-2006 13:25'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(29606930701498396.4001)
,p_validation_name=>'name unique'
,p_validation_sequence=>12
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_shared_queries',
'where name = :P1110_NAME',
'and flow_id = :fb_flow_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre "&P1110_NAME." ya se est\00E1 utilizando en una consulta de informe existente en esta aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(22560019529649953.4001)
,p_associated_item=>wwv_flow_api.id(22684901775053888.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590012819421897521.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(22559726847649953.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590012961505897522.4001)
,p_event_id=>wwv_flow_api.id(590012819421897521.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846218045726982728.4001)
,p_name=>'Output Format Changes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_OUTPUT_FORMAT'
,p_condition_element=>'P1110_OUTPUT_FORMAT'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846218164951982729.4001)
,p_event_id=>wwv_flow_api.id(846218045726982728.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_FORMAT_ITEM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846218273749982730.4001)
,p_event_id=>wwv_flow_api.id(846218045726982728.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_FORMAT_ITEM'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(105008827329927067.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_collection.collection_exists(''REPORT_QUERIES'') then',
'  htmldb_collection.delete_collection(''REPORT_QUERIES'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1110_NAME'
,p_process_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_01112
begin
wwv_flow_api.create_page(
 p_id=>1112.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Consulta de Prueba'
,p_step_title=>'Consulta de Prueba'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
'function saveBinds(){',
'  var get = new htmldb_Get(null,4000,''SAVE_BINDS'',1112, null, ''wwv_flow.accept'');',
'',
'  apex.jQuery("[name=f01]").each(function(){',
'    get.addParam(''f01'', this.value);',
'  });',
'  apex.jQuery("[name=f02]").each(function(){',
'    get.addParam(''f02'', this.value);',
'  });    ',
'  	        ',
'  var x = get.get(''FULL'');',
'}',
'',
'function testQuery(){',
'  if (document.wwv_flow.f01) {',
'    saveBinds();',
'  }   ',
'  popUp2(''f?p=4000:1120:&SESSION.::&DEBUG.::P1120_QUERY_SOURCE:ITEM'',''800'',''600'');',
'}    ',
'            ',
'</script>  '))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(115636830645483045.4001)
,p_name=>'Editar Consulta de Origen'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_binds sys.dbms_sql.varchar2_table;',
'begin',
'    if (htmldb_collection.collection_exists(''SET_BIND_VALUES'')=false) then',
'        htmldb_collection.create_or_truncate_collection( ',
'            p_collection_name => ''SET_BIND_VALUES'' ',
'        );',
'        l_binds := wwv_flow_utilities.get_binds( :P1117_QUERY_TEXT );',
'        for i in 1 .. l_binds.count loop',
'        htmldb_collection.add_member(',
'            p_collection_name => ''SET_BIND_VALUES'',',
'            p_c001            => l_binds(i),',
'        p_generate_md5    => ''YES'' );',
'        end loop;',
'    end if;',
'    return ''',
'        select c001||wwv_flow_item.hidden(1,c001) c001, wwv_flow_item.text(2,c002) ',
'        from wwv_flow_collections ',
'        where collection_name = ''''SET_BIND_VALUES''''',
'    '';',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>255
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115637030563483133.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115637131643483134.4001)
,p_query_column_id=>2
,p_column_alias=>'WWV_FLOW_ITEM.TEXT(2,C002)'
,p_column_display_sequence=>2
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(115637606986483139.4001)
,p_plug_name=>'Consulta de Prueba'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Haga clic en <strong>Probar Consulta</strong> para asegurarse de que la consulta devuelve el juego de resultados correcto. <p>Si incluye variables de enlace, puede definir los valores de prueba antes de ejecutar la consulta. Estos valores de prueba s'
||unistr('e utilizan en pasos posteriores de este asistente (al exportar la estructura XML de la consulta de informe y al descargar una versi\00F3n de prueba formateada de la consulta de informe). </p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(115653414798569128.4001)
,p_plug_name=>'Consulta de Prueba'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115638523432483157.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(115653414798569128.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115638303090483150.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(115653414798569128.4001)
,p_button_name=>'TEST_QUERY'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Consulta de Prueba'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:testQuery();'
,p_button_cattributes=>'class="htmldbButton"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115638716758483157.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(115653414798569128.4001)
,p_button_name=>'APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(115641031473483171.4001)
,p_branch_action=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(115638716758483157.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115638907242483158.4001)
,p_name=>'P1112_QUERY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(115636830645483045.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta de Origen:'
,p_source=>'P1117_QUERY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>20
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Muestra la sentencia SQL que define la consulta de informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(115814615761014012.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1120_QUERY'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1117_QUERY_TEXT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(115640720360483169.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAVE_BINDS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  for i in 1..wwv_flow.g_f01.count loop   	   ',
'      htmldb_collection.update_member(',
'        p_collection_name => ''SET_BIND_VALUES'',',
'        p_seq             => i,',
'        p_c001            => wwv_flow.g_f01(i),',
'        p_c002            => wwv_flow.g_f02(i)',
'    );',
'  end loop;',
'',
'  htmldb_collection.update_member(',
'    p_collection_name => ''REPORT_QUERIES'',',
'    p_seq             => :P1117_ID,',
'    p_clob001         => :P1117_QUERY_TEXT,',
'    p_c002            => wwv_flow_utilities.table_to_string2(wwv_flow.g_f01,''|''),',
'    p_c003            => wwv_flow_utilities.table_to_string2(wwv_flow.g_f02,''|'')',
'  ); ',
'',
'  commit;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01113
begin
wwv_flow_api.create_page(
 p_id=>1113.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Consulta de Informe: Consultas de Origen'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
'    function saveBinds(){',
'',
'       var get = new htmldb_Get(null,4000,''SAVE_BINDS'',1113, null, ''wwv_flow.accept'');',
'',
'       if (document.wwv_flow.f01.value) {',
'            get.addParam(''f01'', document.wwv_flow.f01.value);',
'            get.addParam(''f02'', document.wwv_flow.f02.value);',
'',
'       } else {',
'    ',
'            var bindNames  = new Array();',
'            var bindValues = new Array();        ',
'        ',
'            bindNames  = document.wwv_flow.f01;    ',
'            bindValues = document.wwv_flow.f02;    ',
'        ',
'            for ( i = 0; i <= bindNames.length-1; i++ ) {',
'                get.addParam(''f01'', bindNames[i].value);',
'                get.addParam(''f02'', bindValues[i].value);',
'	      	    }',
'	      }	    ',
'	      	        ',
'       var x = get.get(''FULL'');',
'    ',
'    }',
'',
'    function testQuery(){',
'        if (document.wwv_flow.f01) {',
'            saveBinds();',
'        }   ',
'        popUp2(''f?p=4000:1120:&SESSION.::&DEBUG.::P1120_QUERY_SOURCE:ITEM'',''800'',''600'');',
'    }    ',
'            ',
'</script>    '))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73645118670639501.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22638505565903517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(73645728367639506.4001)
,p_name=>'Consulta de Informe de Prueba'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_binds sys.dbms_sql.varchar2_table;',
'begin',
'    if (htmldb_collection.collection_exists(''SET_BIND_VALUES'')=false) then',
'        htmldb_collection.create_or_truncate_collection( ',
'            p_collection_name => ''SET_BIND_VALUES'' ',
'        );',
'        l_binds := wwv_flow_utilities.get_binds( :P1113_QUERY );',
'        for i in 1 .. l_binds.count loop',
'        htmldb_collection.add_member(',
'            p_collection_name => ''SET_BIND_VALUES'',',
'            p_c001            => l_binds(i),',
'            p_generate_md5    => ''YES'' );',
'        end loop;',
'    end if;',
'    return ''',
'        select c001||wwv_flow_item.hidden(1,c001) c001, wwv_flow_item.text(2,c002) ',
'        from wwv_flow_collections ',
'        where collection_name = ''''SET_BIND_VALUES''''',
'    '';',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>255
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(73646024983639513.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(73645932350639511.4001)
,p_query_column_id=>2
,p_column_alias=>'WWV_FLOW_ITEM.TEXT(2,C002)'
,p_column_display_sequence=>2
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206272102523753165.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73647213853639531.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206272102523753165.4001)
,p_button_name=>'TEST_QUERY'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Consulta de Prueba'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
,p_button_redirect_url=>'javascript:testQuery();'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73647011976639531.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206272102523753165.4001)
,p_button_name=>'APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(73648720163639549.4001)
,p_branch_action=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(73647011976639531.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(73647410524639532.4001)
,p_name=>'P1113_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(73645728367639506.4001)
,p_prompt=>'Consulta SQL:'
,p_source=>'P1110_QUERY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>18
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'readonly="readonly"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Muestra la sentencia SQL que define la consulta de informe. Para editar la consulta, haga clic en el bot\00F3n <strong>Anterior</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107890716347573671.4001)
,p_name=>'P1113_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(73645728367639506.4001)
,p_prompt=>'Seq'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107910500426644754.4001)
,p_name=>'P1113_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(73645728367639506.4001)
,p_prompt=>'Nombre:'
,p_source=>'P1110_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca un nombre para identificar la consulta del informe. Al hacer referencia a una consulta de informe como destino de enlace, el nombre de la consulta del informe es parte de la cadena de solicitud.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(107894519248583968.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1113_QUERY'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select clob001 from wwv_flow_collections',
'    where collection_name = ''REPORT_QUERIES''',
'    and   seq_id = :P1113_SEQ',
') loop',
'    return wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'end loop;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(73648208266639540.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAVE_BINDS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop   	   ',
'    htmldb_collection.update_member(',
'        p_collection_name => ''SET_BIND_VALUES'',',
'        p_seq             => i,',
'        p_c001            => wwv_flow.g_f01(i),',
'        p_c002            => wwv_flow.g_f02(i)',
'    );',
'end loop;',
'',
'htmldb_collection.update_member(',
'    p_collection_name => ''REPORT_QUERIES'',',
'    p_seq             => :P1113_SEQ,',
'    p_clob001         => :P1113_QUERY,',
'    p_c002            => wwv_flow_utilities.table_to_string2(wwv_flow.g_f01,''|''),',
'    p_c003            => wwv_flow_utilities.table_to_string2(wwv_flow.g_f02,''|'')',
'); ',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01114
begin
wwv_flow_api.create_page(
 p_id=>1114.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Consulta de Informe: Confirmar'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29654907329843282.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22638505565903517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29655310507843282.4001)
,p_plug_name=>'Crear Consulta Compartida'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>unistr('<p>Una consulta de informe se puede descargar como documento PDF, documento de Word (basado en RTF), hoja de c\00E1lculo de Excel (basada en HTML) o como archivo HTML. Para integrar el documento en la aplicaci\00F3n, puede seleccionar la consulta de informe ')
||unistr('como destino para los botones o elementos de lista, o bien, integrarlo en otras partes utilizando la direcci\00F3n URL de descarga como destino.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206270919230739081.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29656009263843283.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206270919230739081.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29656429580843284.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(206270919230739081.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29667029540914287.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(206270919230739081.4001)
,p_button_name=>'TEST_REPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Informe de Prueba'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29656205789843283.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206270919230739081.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(29657308180843285.4001)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(29656429580843284.4001)
,p_branch_sequence=>21
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(74612307143714804.4001)
,p_branch_action=>'f?p=&APP_ID.:1118:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(29656205789843283.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29656614235843284.4001)
,p_name=>'P1114_QUERY_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(29655310507843282.4001)
,p_prompt=>'Nombre de la Consulta:'
,p_source=>'&P1110_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Consulta seleccionada.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41765305345249007.4001)
,p_name=>'P1114_REPORT_LAYOUT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(29655310507843282.4001)
,p_prompt=>unistr('Dise\00F1o de Informe:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (',
'    select report_layout_name',
'    from wwv_flow_report_layouts',
'    where id = :P1118_REPORT_LAYOUT_ID',
') loop',
'    return c1.report_layout_name;',
'end loop;',
'    return wwv_flow_lang.system_message(''NO_LAYOUT'');',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Dise\00F1o de informe seleccionado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41771711017260137.4001)
,p_name=>'P1114_OUTPUT_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(29655310507843282.4001)
,p_item_default=>'PDF'
,p_prompt=>'Formato de Salida:'
,p_source=>'P1110_OUTPUT_FORMAT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PRN_FORMAT'
,p_lov=>'.'||wwv_flow_api.id(16950902829395371.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El atributo de formato especifica el formato de descarga de la consulta de informe. Las consultas de informe se pueden descargar como documento PDF, documento de Word (basado en RTF), hoja de c\00E1lculo de Excel (basada en HTML) o como archivo HTML.  Pa')
||unistr('ra determinar el formato de descarga de la aplicaci\00F3n, seleccione "Derivar de Elemento de P\00E1gina".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41788801760314194.4001)
,p_name=>'P1114_URL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(29655310507843282.4001)
,p_prompt=>unistr('URL (Para integrar este informe, utilice la siguiente direcci\00F3n URL como destino de los botones, elementos de lista, etc):')
,p_source=>'''f?p=&''||''APP_ID.:0:&''||''SESSION.:PRINT_REPORT=''||wwv_flow_utilities.escape_url(:P1114_QUERY_NAME)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'style="border: 3px solid #cccccc;" onClick="this.select();"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las consultas de informe se pueden integrar con una aplicaci\00F3n mediante la direcci\00F3n URL mostrada como destino para botones, entradas de lista de navegaci\00F3n, elementos de lista o cualquier otro tipo de enlace. Haga clic en el campo URL para copiar y ')
||unistr('pegar la direcci\00F3n URL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74681128230118297.4001)
,p_name=>'P1114_FORMAT_ITEM'
,p_item_sequence=>32
,p_item_plug_id=>wwv_flow_api.id(29655310507843282.4001)
,p_prompt=>'Derivar de Elemento:'
,p_source=>'P1110_FORMAT_ITEM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||wwv_flow_escape.html(name) a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||wwv_flow_escape.html(name) a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_display_when=>'P1110_FORMAT_ITEM'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Para determinar el formato de salida en tiempo de ejecuci\00F3n, especifique el elemento de p\00E1gina que contiene la informaci\00F3n de formato.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590013543562897528.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(29656009263843283.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590013617329897529.4001)
,p_event_id=>wwv_flow_api.id(590013543562897528.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29656816156843284.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Report Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'    l_source_queries wwv_flow_global.vc_arr2;',
'    i number;',
'',
'begin',
'    ',
'    i := 0;',
'    ',
'    for c1 in (',
'        select clob001 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'        order by seq_id',
'    ) loop',
'        i := i + 1;',
'        l_source_queries(i) := wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'    end loop;        ',
'    ',
'    wwv_flow_wizard_api.create_report_query (',
'        p_flow_id             => :FB_FLOW_ID,',
'        p_report_query_name   => :P1110_NAME, ',
'        p_report_layout_id    => :P1118_REPORT_LAYOUT_ID,',
'        p_source_queries      => l_source_queries,',
'        p_output_format       => replace(:P1110_OUTPUT_FORMAT,''%n''||''ull%'',null),',
'        p_format_item         => :P1110_FORMAT_ITEM,',
'        p_file_name           => :P1110_NAME, ',
'        p_xml_structure       => nvl(:P1110_XML_STRUCTURE,''STANDARD''),',
'        p_items               => :P1110_ITEMS,',
'        p_content_disposition => :P1110_CONTENT_DISPOSITION',
'    );',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido crear la consulta de informe'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(29656429580843284.4001)
,p_process_success_message=>'Consulta de informe creada'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29675027724932717.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'test report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql_stmnts  wwv_flow_global.vc_arr2;',
'    l_bind_vars   wwv_flow_global.vc_arr2;',
'    l_bind_values wwv_flow_global.vc_arr2;',
'    l_xml_structure varchar2(255);',
'    i number := 0;',
'begin',
'',
'    if :P1112_REPORT_LAYOUT_ID is not null then',
'        l_xml_structure := nvl(:P1110_XML_STRUCTURE,''APEX'');',
'    else',
'        l_xml_structure := ''STANDARD'';',
'    end if;',
'',
'    for c1 in (',
'        select clob001, c002, c003 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'    ) loop',
'        i := i+1;',
'        l_sql_stmnts(i)  := wwv_flow_utilities.clob_to_varchar2(c1.clob001); ',
'        l_bind_vars(i)   := c1.c002;',
'        l_bind_values(i) := c1.c003;',
'',
'    end loop;',
'    ',
'    for c2 in (',
'        select owner from wwv_flows where id = :fb_flow_id',
'    ) loop',
'',
'        wwv_flow_render_query.print_report_query (',
'            p_flow_id       => :fb_flow_id,',
'            p_query_name    => :P1110_NAME,',
'            p_query_owner   => c2.owner,',
'            p_sql_stmnts    => l_sql_stmnts,',
'            p_xml_structure => l_xml_structure,',
'            p_layout_id     => :P1118_REPORT_LAYOUT_ID,',
'            p_format        => :P1110_OUTPUT_FORMAT,',
'            p_items         => :P1111_ITEMS,',
'            p_binds         => l_bind_vars,',
'            p_values        => l_bind_values',
'        );',
'',
'    end loop;',
'    ',
'    wwv_flow.g_page_text_generated := true;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(29667029540914287.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590013763194897530.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(29656429580843284.4001)
,p_process_success_message=>'Consulta de informe creada.'
);
end;
/
prompt --application/pages/page_01115
begin
wwv_flow_api.create_page(
 p_id=>1115.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Consulta de Informe: Descargar Definici\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
'    function saveBinds(){',
'',
'       var get = new htmldb_Get(null,4000,''SAVE_BINDS'',1111, null, ''wwv_flow.accept'');',
'',
'       if (document.wwv_flow.f01.value) {',
'            get.addParam(''f01'', document.wwv_flow.f01.value);',
'            get.addParam(''f02'', document.wwv_flow.f02.value);',
'',
'       } else {',
'    ',
'            var bindNames  = new Array();',
'            var bindValues = new Array();        ',
'        ',
'            bindNames  = document.wwv_flow.f01;    ',
'            bindValues = document.wwv_flow.f02;    ',
'        ',
'    			     for ( i = 0; i <= bindNames.length-1; i++ ) {',
'                get.addParam(''f01'', bindNames[i].value);',
'                get.addParam(''f02'', bindValues[i].value);',
'	      	    }',
'	      }	    ',
'	      	        ',
'       var x = get.get(''FULL'');',
'    ',
'    }',
'',
'    function testQuery(){',
'        if (document.wwv_flow.f01) {',
'            saveBinds();',
'        }   ',
'        popUp2(''f?p=4000:1120:&SESSION.::&DEBUG.::P1120_QUERY_SOURCE:ITEM'',''800'',''600'');',
'    }    ',
'            ',
'</script>    '))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(104932408900744298.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22638505565903517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(104937812288761942.4001)
,p_name=>'Consultas de Origen'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, clob001 c001 ',
'from wwv_flow_collections',
'where collection_name = ''REPORT_QUERIES'''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las consultas de informe se pueden formatear utilizando dise\00F1os de informe basados en RTF y XSL-FO. Desde esta p\00E1gina, descargue el juego de resultados de informe en formato XML o descargue la definici\00F3n de esquema XML de la consulta de informe. S')
||unistr('i utiliza Oracle BI Publisher como servidor de impresi\00F3n, puede utilizar el plugin de Microsoft Word para crear el dise\00F1o a partir de la representaci\00F3n XML del informe o de la definici\00F3n de esquema XML. El plugin tiene una interfaz de arrastrar y sol')
||unistr('tar que simplifica el dise\00F1o. Una consulta de informe puede contener consultas de varios or\00EDgenes si desea combinar diferentes juegos de resultados en el dise\00F1o del informe. Haga clic en el bot\00F3n <strong>Agregar Consulta</strong> para agregar consult')
||unistr('as de or\00EDgenes adicionales. </p>'),
''))
,p_footer=>'<br />'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>255
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha definido ninguna consulta de origen.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(104938125631761948.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(104938232171761948.4001)
,p_query_column_id=>2
,p_column_alias=>'C001'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Definici\00F3n de Consulta de Origen')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(105023929725050771.4001)
,p_query_column_id=>3
,p_column_alias=>'LINK$01'
,p_column_display_sequence=>1
,p_column_link=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.::P1119_SEQ_ID:#SEQ_ID#'
,p_column_linktext=>'<img src=" #IMAGE_PREFIX#menu/pencil16x16.gif" alt="Editar">'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206259627101684610.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>180
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112614802440013522.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(104937812288761942.4001)
,p_button_name=>'P1115_DOWNLOAD'
,p_button_static_id=>'P1115_DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar'
,p_button_alignment=>'LEFT'
,p_request_source=>'DOWNLOAD'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104933717307744313.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206259627101684610.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104934112938744313.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206259627101684610.4001)
,p_button_name=>'ADD_QUERY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Consulta'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145502212082192939.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(206259627101684610.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Consulta de Informe'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104933913371744313.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206259627101684610.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(145502527570192941.4001)
,p_branch_action=>'f?p=&FLOW_ID.:1114:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(145502212082192939.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(104935529298744322.4001)
,p_branch_action=>'f?p=&APP_ID.:1118:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(104933913371744313.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(104935718574744322.4001)
,p_branch_action=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.::P1119_QUERY,P1119_SEQ_ID:,0&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(104934112938744313.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(105021106869044190.4001)
,p_name=>'P1115_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(104937812288761942.4001)
,p_prompt=>'Nombre de Consulta de Informe:'
,p_source=>'P1110_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Al hacer referencia a una consulta de informe como destino de enlace, el nombre de la consulta del informe es parte de la cadena de solicitud.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112613332653003373.4001)
,p_name=>'P1115_XML_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(104937812288761942.4001)
,p_item_default=>'XML'
,p_prompt=>unistr('Origen de Datos para Dise\00F1o de Informe:')
,p_source=>'XML'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'XML_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(112611429059992822.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('El archivo de exportaci\00F3n de la definici\00F3n de informe se puede utilizar como origen de datos para el dise\00F1o del informe. Seleccione si desea exportar la definici\00F3n del informe como archivo XML o esquema XML. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590013398921897526.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(104933717307744313.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590013437146897527.4001)
,p_event_id=>wwv_flow_api.id(590013398921897526.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(112593508178854323.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download xml'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql_stmnts  wwv_flow_global.vc_arr2;',
'    l_bind_vars   wwv_flow_global.vc_arr2;',
'    l_bind_values wwv_flow_global.vc_arr2;',
'    i number := 0;',
'begin',
'    for c1 in (',
'        select clob001, c002, c003 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'    ) loop',
'        i := i+1;',
'        l_sql_stmnts(i)  := wwv_flow_utilities.clob_to_varchar2(c1.clob001); ',
'        l_bind_vars(i)   := c1.c002;',
'        l_bind_values(i) := c1.c003;',
'    end loop;',
'    ',
'    for c2 in (',
'        select owner from wwv_flows where id = :fb_flow_id',
'    ) loop',
'',
'        wwv_flow_render_query.print_report_query (',
'            p_flow_id       => :fb_flow_id,',
'            p_query_name    => :P1110_NAME,',
'            p_query_owner   => c2.owner,',
'            p_sql_stmnts    => l_sql_stmnts,',
'            p_xml_structure => nvl(:P1110_XML_STRUCTURE,''STANDARD''),',
'            p_format        => ''XML'',',
'            p_items         => :P1110_ITEMS,',
'            p_binds         => l_bind_vars,',
'            p_values        => l_bind_values',
'        );',
'',
'    end loop;',
'',
'    wwv_flow.g_page_text_generated := true;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(112614802440013522.4001)
,p_process_when=>'P1115_XML_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'XML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(112603628703917042.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download xsd'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql_stmnts  wwv_flow_global.vc_arr2;',
'    i number := 0;',
'begin',
'    for c1 in (',
'        select clob001, c002, c003 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'    ) loop',
'        i := i+1;',
'        l_sql_stmnts(i)  := wwv_flow_utilities.clob_to_varchar2(c1.clob001); ',
'    end loop;',
'    ',
'    for c2 in (',
'        select owner from wwv_flows where id = :fb_flow_id',
'    ) loop',
'',
'        wwv_flow_render_query.print_report_query (',
'            p_flow_id       => :fb_flow_id,',
'            p_query_name    => :P1110_NAME,',
'            p_query_owner   => c2.owner,',
'            p_sql_stmnts    => l_sql_stmnts,',
'            p_xml_structure => nvl(:P1110_XML_STRUCTURE,''STANDARD''),',
'            p_format        => ''XSD'',',
'            p_items         => :P1110_ITEMS',
'        );',
'',
'    end loop;',
'',
'    wwv_flow.g_page_text_generated := true;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(112614802440013522.4001)
,p_process_when=>'P1115_XML_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'XSD'
);
end;
/
prompt --application/pages/page_01116
begin
wwv_flow_api.create_page(
 p_id=>1116.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Consulta de Informe'
,p_step_title=>'Editar Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
'  htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'  function setSeqIDandSubmit(seqID){',
'    $x(''P1116_SEQ_ID'').value=seqID;  ',
'    doSubmit(''APPLY_CHANGES_EDIT_QUERY'');',
'  }',
'    ',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46250704400678997.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61420914244617042.4001)
,p_plug_name=>'Atributos de Consulta de Informe'
,p_region_name=>'ATTR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61421116921617043.4001)
,p_plug_name=>'Consulta de Informe'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62894422945659915.4001)
,p_plug_name=>'Consultas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Las consultas de informe se presentan con un dise\00F1o RTF incorporado personalizado; si no se selecciona ning\00FAn dise\00F1o de informe, se utiliza un dise\00F1o de informe gen\00E9rico. Se pueden descargar como documento PDF, documento de Word (basado en RTF), h')
||unistr('oja de c\00E1lculo de Excel (basada en HTML) o como archivo HTML. El formato de descarga se puede predefinir en esta p\00E1gina o derivar en tiempo de ejecuci\00F3n seg\00FAn un elemento de aplicaci\00F3n. </p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74700110634292978.4001)
,p_plug_name=>unistr('Estado de la Sesi\00F3n')
,p_region_name=>'SST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114243709381684138.4001)
,p_name=>'Consultas de Origen'
,p_region_name=>'QRY'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id id, clob001 sql_statement ',
'from wwv_flow_collections',
'where collection_name = ''REPORT_QUERIES''',
'order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>255
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna consulta de origen.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114244002320684141.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_link=>'javascript:setSeqIDandSubmit(#ID#)'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114244116335684141.4001)
,p_query_column_id=>2
,p_column_alias=>'SQL_STATEMENT'
,p_column_display_sequence=>2
,p_column_heading=>'Consultas de Origen'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620054021059473578.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_SHARED_QUERIES',
'where id = :P1116_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P1116_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1116_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114308413949865280.4001)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(114243709381684138.4001)
,p_button_name=>'P1116_DOWNLOAD'
,p_button_static_id=>'P1116_DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(146484601467540614.4001)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(114243709381684138.4001)
,p_button_name=>'P1116_TEST_REPORT'
,p_button_static_id=>'P1116_TEST_REPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Informe de Prueba'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(141909011538546623.4001)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(114243709381684138.4001)
,p_button_name=>'ADD_QUERY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Consulta'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61422418015617054.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(61421116921617043.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61422210232617052.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(61421116921617043.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1116_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61422630926617054.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(61421116921617043.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1116_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(61425717065617060.4001)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(61422630926617054.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(62193931559663891.4001)
,p_branch_action=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.::P1117_ID:&P1116_SEQ_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_QUERY'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(63366930432352758.4001)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(61422210232617052.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(136667504014973717.4001)
,p_branch_action=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.::P1117_ID:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(141909011538546623.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61423216748617054.4001)
,p_name=>'P1116_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61423411181617055.4001)
,p_name=>'P1116_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Consulta de Informe'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onChange="document.getElementById(''P1116_URL'').value=''f?p=&''+''APP_ID.:0:&''+''SESSION.:PRINT_REPORT=''+escape(this.value)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'El nombre de la consulta de informe identifica la consulta del informe. Al hacer referencia a una consulta de informe como destino de enlace, el nombre de la consulta del informe es parte de la cadena de solicitud. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61423621795617055.4001)
,p_name=>'P1116_QUERY_TEXT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>120
,p_cMaxlength=>255
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61462132728826639.4001)
,p_name=>'P1116_REPORT_LAYOUT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Dise\00F1o de Informe')
,p_source=>'REPORT_LAYOUT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT_LAYOUTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  wwv_flow_escape.html(report_layout_name) d, ',
'  id r',
'from   wwv_flow_report_layouts',
'where  flow_id = :fb_flow_id ',
'order by upper(report_layout_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Usar Dise\00F1o de Informe Gen\00E9rico')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el dise\00F1o de informe que desea utilizar para formatear los resultados de la consulta de informe. Los dise\00F1os de informe gen\00E9ricos normalmente funcionan con cualquier consulta de informe. Los dise\00F1os de columna con nombre s\00F3lo funcionan con')
||' la consulta de informe para la que se han creado o con las consultas de informe que tienen una lista de columnas compatible.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61478124351994536.4001)
,p_name=>'P1116_FORMAT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Formato de Salida'
,p_source=>'FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRN_FORMAT'
,p_lov=>'.'||wwv_flow_api.id(16950902829395371.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Derivar de Elemento'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el formato de salida del informe. Los formatos soportados son PDF, Microsoft Word (formato RTF), Microsoft Excel (formato XLS) y HTML. Tambi\00E9n puede hacer que un elemento especifique el formato de salida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61484825998014000.4001)
,p_name=>'P1116_FORMAT_ITEM'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Elemento'
,p_source=>'FORMAT_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||wwv_flow_escape.html(name) a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||wwv_flow_escape.html(name) a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_cSize=>17
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Determina el formato de salida en tiempo de ejecuci\00F3n. Seleccione el elemento que contendr\00E1 el valor de formato. Los valores v\00E1lidos son PDF, RTF (para abrir el documento en Microsoft Word), XLS (para abrir el documento en Microsoft Excel) y HTM (par')
||'a descargar el documento como archivo HTML).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61487309853018711.4001)
,p_name=>'P1116_FILE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>':P1116_NAME'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Name'
,p_source=>'OUTPUT_FILE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>40
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62602928430207365.4001)
,p_name=>'P1116_INIT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63342015700234973.4001)
,p_name=>'P1116_URL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('URL de Impresi\00F3n:')
,p_source=>'''f?p=&''||''APP_ID.:0:&''||''SESSION.:PRINT_REPORT=''||wwv_flow_utilities.escape_url(:P1116_NAME)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'style="border: 3px solid #cccccc;" onClick="this.select();"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las consultas de informe se pueden integrar con una aplicaci\00F3n mediante la direcci\00F3n URL mostrada como destino para botones, entradas de lista de navegaci\00F3n, elementos de lista o cualquier otro tipo de enlace. Haga clic en el campo URL de Impresi\00F3n p')
||unistr('ara copiar y pegar la direcci\00F3n URL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(74698930242289156.4001)
,p_name=>'P1116_XML_ITEMS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(74700110634292978.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seleccionar Elementos'
,p_source=>'XML_ITEMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_LIST_MANAGER'
,p_named_lov=>'PRINT_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ('' || t || '') '' d,name r from (',
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where  flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where flow_id = :fb_flow_id',
'order by 4 asc nulls first, 1 asc',
')'))
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'style="width:250px"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Agregue elementos de aplicaci\00F3n y p\00E1gina a la lista de elementos que se deben incluir con la consulta de informe. El estado real de sesi\00F3n de esos elementos s\00F3lo se presentar\00E1 si se definen en el dise\00F1o del informe. Los dise\00F1os gen\00E9ricos incorporados')
||unistr(' no incluyen estado de sesi\00F3n. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FIRST_ROWSET'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75125720206462246.4001)
,p_name=>'P1116_XML_STRUCTURE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(74700110634292978.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Estado de la Sesi\00F3n')
,p_source=>'XML_STRUCTURE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REPOER_QUERY_XML_STRUCTURE'
,p_lov=>'.'||wwv_flow_api.id(75124227694454957.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onclick="toggleItemSelector($v(''P1116_XML_STRUCTURE''));"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Las consultas de informe se procesan como archivos XML con dise\00F1os de informe RTF o XSL-FO para el formato. Los datos XML pueden incluir informaci\00F3n espec\00EDfica de la aplicaci\00F3n y el estado de la sesi\00F3n. Utilice la estructura XML est\00E1ndar para el m\00E1xi')
||unistr('mo de compatibilidad con plantillas RTF de BI Publisher y utilice la estructura XML avanzada para incluir datos espec\00EDficos de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114305804252862421.4001)
,p_name=>'P1116_XML_SOURCE_TYPE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(114243709381684138.4001)
,p_item_default=>'XML'
,p_prompt=>unistr('Origen para Dise\00F1o de Informe:')
,p_source=>'XML'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'XML_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(112611429059992822.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fielddata"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione si desea exportar la definici\00F3n del informe como archivo XML o esquema XML.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(115599109220264779.4001)
,p_name=>'P1116_SEQ_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_prompt=>'Seq Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137949312258263470.4001)
,p_name=>'P1116_CONTENT_DISPOSITION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(61420914244617042.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ATTACHMENT'
,p_prompt=>'Ver Archivo como'
,p_source=>'CONTENT_DISPOSITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONTENT_DISPOSITION'
,p_lov=>'.'||wwv_flow_api.id(137375920403903467.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Con el atributo <strong>Ver Archivo como</strong> se puede indicar al explorador que muestre un recuadro de di\00E1logo para <strong>abrir o guardar el archivo</strong> al hacer clic en el bot\00F3n de descarga de la consulta de informe o que muestre el docu')
||unistr('mento de consulta de informe en la ventana del explorador. Esta selecci\00F3n est\00E1 incluida en la cabecera HTTP del documento mediante el atributo content-disposition.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141628018681489029.4001)
,p_name=>'P1116_JS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(74700110634292978.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="Javascript1.1" type="text/javascript">',
'',
'  function toggleItemSelector(includeItems) {',
'    if (includeItems==''APEX'') {',
'      apex.item(''P1116_XML_ITEMS'').show();',
'    } else {',
'      apex.item(''P1116_XML_ITEMS'').hide();',
'    }',
'  }',
'',
'  toggleItemSelector($v(''P1116_XML_STRUCTURE''));',
'',
'</script>'))
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(61502830510090912.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1120_QUERY'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1116_QUERY_TEXT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62300016478816112.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1116_FILE_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1116_NAME'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(61424719356617058.4001)
,p_validation_name=>'P1116_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1116_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(61423411181617055.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846218310550982731.4001)
,p_name=>'Format Changes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1116_FORMAT'
,p_condition_element=>'P1116_FORMAT'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846218474469982732.4001)
,p_event_id=>wwv_flow_api.id(846218310550982731.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_FORMAT_ITEM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846218522346982733.4001)
,p_event_id=>wwv_flow_api.id(846218310550982731.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_FORMAT_ITEM'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(61425014892617059.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'UPDATE_WWV_FLOW_STORED_QUERIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_QUERIES'
,p_attribute_03=>'P1116_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_STORED_QUERIES.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(116036131951137896.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Source Queries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'    l_source_queries wwv_flow_global.vc_arr2;',
'    i number;    ',
'',
'begin',
'     ',
'    i := 0;',
'    ',
'    for c1 in (',
'        select clob001 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'        order by seq_id',
'    ) loop',
'        i := i + 1;',
'        l_source_queries(i) := wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'    end loop;    ',
'',
'    wwv_flow_wizard_api.update_report_query_sql_stmts (',
'        p_flow_id             => :FB_FLOW_ID,',
'        p_report_query_id     => :P1116_ID,',
'        p_source_queries      => l_source_queries',
'    );',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(61422630926617054.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(61522428142194322.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test Report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql_stmnts  wwv_flow_global.vc_arr2;',
'    l_bind_vars   wwv_flow_global.vc_arr2;',
'    l_bind_values wwv_flow_global.vc_arr2;',
'    l_xml_structure varchar2(255);',
'    i number := 0;    ',
'begin',
'    for c1 in (',
'        select c002 ',
'        from wwv_flow_collections ',
'        where collection_name = ''SET_BIND_VALUES''',
'    ) loop',
'        i := i+1;',
'        l_bind_values(i) := c1.c002;',
'    end loop;',
'',
'    if replace(:P1116_REPORT_LAYOUT_ID,''%''||''null%'',null) is not null then',
'        l_xml_structure := :P1116_XML_STRUCTURE;',
'    else',
'        l_xml_structure := ''ADVANCED'';',
'    end if;',
'',
'    for c1 in (',
'        select clob001, c002, c003 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'    ) loop',
'        i := i+1;',
'        l_sql_stmnts(i)  := wwv_flow_utilities.clob_to_varchar2(c1.clob001); ',
'        l_bind_vars(i)   := c1.c002;',
'        l_bind_values(i) := c1.c003;',
'    end loop;',
'            ',
'    for c2 in (',
'        select owner from wwv_flows where id = :fb_flow_id',
'    ) loop',
'',
'        wwv_flow_render_query.print_report_query(',
'            p_flow_id       => :fb_flow_id,',
'            p_xml_structure => l_xml_structure,',
'            p_layout_id     => replace(:P1116_REPORT_LAYOUT_ID,''%''||''null%'',null),',
'            p_format        => :P1116_FORMAT,',
'            p_sql_stmnts    => l_sql_stmnts,',
'            p_query_name    => :P1116_NAME,',
'            p_query_owner   => c2.owner,',
'            p_items         => null,',
'            p_binds         => l_bind_vars,',
'            p_values        => l_bind_values',
'        );',
'    ',
'    end loop;',
'    wwv_flow.g_page_text_generated := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(146484601467540614.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(62879230114529570.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Download XML'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql_stmnts  wwv_flow_global.vc_arr2;',
'    l_bind_vars   wwv_flow_global.vc_arr2;',
'    l_bind_values wwv_flow_global.vc_arr2;',
'    i number := 0;',
'begin',
'    for c1 in (',
'        select clob001, c002, c003 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'    ) loop',
'        i := i+1;',
'        l_sql_stmnts(i)  := wwv_flow_utilities.clob_to_varchar2(c1.clob001); ',
'        l_bind_vars(i)   := c1.c002;',
'        l_bind_values(i) := c1.c003;',
'    end loop;',
'    ',
'    for c2 in (',
'        select owner from wwv_flows where id = :fb_flow_id',
'    ) loop',
'',
'        wwv_flow_render_query.print_report_query (',
'            p_flow_id       => :fb_flow_id,',
'            p_query_name    => :P1116_NAME,',
'            p_query_owner   => c2.owner,',
'            p_sql_stmnts    => l_sql_stmnts,',
'            p_xml_structure => nvl(:P1116_XML_STRUCTURE,''STANDARD''),',
'            p_format        => ''XML'',',
'            p_items         => :P1116_XML_ITEMS,',
'            p_binds         => l_bind_vars,',
'            p_values        => l_bind_values',
'        );',
'',
'    end loop;',
'    wwv_flow.g_page_text_generated := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(114308413949865280.4001)
,p_process_when=>'P1116_XML_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'XML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114412607181099767.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Download XSD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_sql_stmnts  wwv_flow_global.vc_arr2;',
'    i number := 0;',
'begin',
'    for c1 in (',
'        select clob001, c002, c003 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'    ) loop',
'        i := i+1;',
'        l_sql_stmnts(i)  := wwv_flow_utilities.clob_to_varchar2(c1.clob001); ',
'    end loop;',
'    ',
'    for c2 in (',
'        select owner from wwv_flows where id = :fb_flow_id',
'    ) loop',
'',
'        wwv_flow_render_query.print_report_query (',
'            p_flow_id       => :fb_flow_id,',
'            p_query_name    => :P1116_NAME,',
'            p_query_owner   => c2.owner,',
'            p_sql_stmnts    => l_sql_stmnts,',
'            p_xml_structure => nvl(:P1116_XML_STRUCTURE,''STANDARD''),',
'            p_format        => ''XSD'',',
'            p_items         => :P1116_XML_ITEMS',
'        );',
'',
'    end loop;',
'    wwv_flow.g_page_text_generated := true;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(114308413949865280.4001)
,p_process_when=>'P1116_XML_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'XSD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(61424812868617059.4001)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_STORED_QUERIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_QUERIES'
,p_attribute_03=>'P1116_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114276419134791041.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Source Query Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_num_queries number := 0;  ',
'begin',
'',
'    if :P1116_INIT = ''YES'' then',
'        :P1116_INIT := ''NO'';',
'',
'        htmldb_collection.create_or_truncate_collection( ',
'            p_collection_name => ''REPORT_QUERIES'' ',
'        );',
'        for c1 in (',
'            select sql_statement',
'            from wwv_flow_shared_qry_sql_stmts',
'            where shared_query_id = :P1116_ID',
'            order by id',
'        ) loop',
'            l_num_queries := l_num_queries + 1;',
'            htmldb_collection.add_member(',
'            p_collection_name => ''REPORT_QUERIES'',',
'                p_clob001     => c1.sql_statement',
'            );          ',
'        end loop;',
'',
'        if l_num_queries = 0 then',
'            for c2 in (',
'                select query_text',
'                from wwv_flow_shared_queries where id = :P1116_ID',
'            ) loop',
'                htmldb_collection.add_member(',
'                    p_collection_name => ''REPORT_QUERIES'',',
'                    p_clob001         => c2.query_text',
'                );   ',
'           end loop;      ',
'       end if;',
'',
'   end if; ',
'   ',
' end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01117
begin
wwv_flow_api.create_page(
 p_id=>1117.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Consulta de Origen'
,p_step_title=>'Consulta de Origen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
'    htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'    function downloadXML(){',
'        doSubmit(''DOWNLOAD_XML'');',
'    }       ',
' ',
'    function testReport(){',
'        doSubmit(''TEST_REPORT'');',
'    }   ',
'    ',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61438724381696792.4001)
,p_plug_name=>'Consulta de Origen'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62830324040414239.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Una consulta de informe est\00E1 basada en una consulta SQL est\00E1ndar. Est\00E1n soportadas las variables de enlace, al agregar nuevas variables de enlace o modificar las existentes, haga clic en "Analizar Variables de Enlace" e introduzca los valores de p')
||'rueba antes de exportar la consulta de informe como XML o probar la descarga del informe.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(115646410942539636.4001)
,p_plug_name=>'Consulta de Origen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62396214372938478.4001)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(115646410942539636.4001)
,p_button_name=>'P1117_PARSE_QUERY'
,p_button_static_id=>'P1117_PARSE_QUERY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Definir Variables de Enlace'
,p_request_source=>'APPLY_CHANGES_PARSE_QUERY'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61440231879696793.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(61438724381696792.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473389105467241017.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(61438724381696792.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1117_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61440405281696793.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(61438724381696792.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P1117_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(145908905634217304.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(61438724381696792.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'P1117_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(62290306866794393.4001)
,p_branch_action=>'f?p=&APP_ID.:1112:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(62396214372938478.4001)
,p_branch_sequence=>35
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(145909220006217307.4001)
,p_branch_action=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61441208821696794.4001)
,p_name=>'P1117_QUERY_TEXT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(115646410942539636.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta de Origen:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select clob001 from wwv_flow_collections',
'    where collection_name = ''REPORT_QUERIES''',
'    and   seq_id = :P1117_ID',
') loop',
'    return wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'end loop;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>20
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El texto de la consulta es la sentencia SQL que define la consulta del informe. La sentencia SQL puede hacer referencia a elementos de aplicaci\00F3n y p\00E1gina como variables de enlace.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(61441431881696794.4001)
,p_name=>'P1117_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(115646410942539636.4001)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62412213296985400.4001)
,p_validation_name=>'is valid query'
,p_validation_sequence=>32
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_owner varchar2(4000) := null;',
'begin',
'  l_owner := wwv_flow_security.flow_owner ( ',
'     p_flow_id           =>:FB_FLOW_ID, ',
'     p_security_group_id =>:FLOW_SECURITY_GROUP_ID);',
'         ',
'  return wwv_flow_f4000_util.is_valid_report_query (',
'    p_plug_source      => :P1117_QUERY_TEXT,',
'    p_plug_source_type => wwv_flow_region_native.c_sql_report,',
'    p_owner            => l_owner',
'    );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_api.id(61441208821696794.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(115547320527984227.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_seq number;',
'   l_source_queries wwv_flow_global.vc_arr2;',
'   i number;    ',
'begin',
'   if nvl(:P1117_ID, 0) <> 0 then',
'     l_seq := :P1117_ID;',
'     for c1 in (',
'       select c002, c003 from wwv_flow_collections',
'       where collection_name = ''REPORT_QUERIES''',
'       and seq_id = l_seq )',
'     loop',
'       htmldb_collection.update_member(',
'         p_collection_name => ''REPORT_QUERIES'',',
'         p_seq             => :P1117_ID,',
'         p_clob001         => :P1117_QUERY_TEXT,',
'         p_c002            => c1.c002,',
'         p_c003            => c1.c003 ); ',
'     end loop;  ',
'   else',
'     l_seq := htmldb_collection.add_member(',
'       p_collection_name => ''REPORT_QUERIES'',',
'       p_clob001         => :P1117_QUERY_TEXT);   ',
'   end if;',
'   :P1117_ID := l_seq;',
'     ',
'    i := 0;',
'    ',
'    for c1 in (',
'        select clob001 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'        order by seq_id )',
'    loop',
'        i := i + 1;',
'        l_source_queries(i) := wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'    end loop;    ',
'',
'    wwv_flow_wizard_api.update_report_query_sql_stmts (',
'        p_flow_id             => :FB_FLOW_ID,',
'        p_report_query_id     => :P1116_ID,',
'        p_source_queries      => l_source_queries );',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Consulta de origen procesada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(271204316863846617.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_collection.collection_exists(''SET_BIND_VALUES'') then',
'    htmldb_collection.delete_collection(''SET_BIND_VALUES'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(473389332133248701.4001)
,p_process_sequence=>50
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_source_queries wwv_flow_global.vc_arr2;',
'    i number;    ',
'begin',
'    htmldb_collection.delete_member(',
'      p_collection_name => ''REPORT_QUERIES'',',
'      p_seq             => :P1117_ID );',
'     ',
'    i := 0;',
'    ',
'    for c1 in (',
'        select clob001 ',
'        from wwv_flow_collections ',
'        where collection_name = ''REPORT_QUERIES''',
'        order by seq_id )',
'    loop',
'        i := i + 1;',
'        l_source_queries(i) := wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'    end loop;    ',
'',
'    wwv_flow_wizard_api.update_report_query_sql_stmts (',
'        p_flow_id             => :FB_FLOW_ID,',
'        p_report_query_id     => :P1116_ID,',
'        p_source_queries      => l_source_queries );',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir la consulta.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Consulta suprimida.'
);
end;
/
prompt --application/pages/page_01118
begin
wwv_flow_api.create_page(
 p_id=>1118.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Consulta de Informe: Cargar Dise\00F1o de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112546925661617822.4001)
,p_plug_name=>unistr('Cargar Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Cuando termine el dise\00F1o del informe, gu\00E1rdelo como archivo RTF o XSL-FO. A continuaci\00F3n, vuelva a cargarlo en Application Express con el bot\00F3n <strong>Examinar</strong> de esta p\00E1gina. El archivo se almacena como dise\00F1o de informe junto con los c')
||unistr('omponentes compartidos de la aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112547126422617823.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22638505565903517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206266303861725138.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112551828663617828.4001)
,p_button_sequence=>66
,p_button_plug_id=>wwv_flow_api.id(112546925661617822.4001)
,p_button_name=>'P1118_DELETE_LAYOUT'
,p_button_static_id=>'P1118_DELETE_LAYOUT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_alignment=>'LEFT'
,p_button_condition=>'P1118_REPORT_LAYOUT_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_request_source=>'DELETE_LAYOUT'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112548215559617824.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206266303861725138.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112548418946617824.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206266303861725138.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(112548611190617824.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206266303861725138.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112553402866617830.4001)
,p_branch_action=>'f?p=&APP_ID.:1114:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(112548418946617824.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112553622473617830.4001)
,p_branch_action=>'f?p=&APP_ID.:1118:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(112551828663617828.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112553831307617830.4001)
,p_branch_action=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(112548611190617824.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112548832482617825.4001)
,p_name=>'P1118_LAYOUT_FILE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(112546925661617822.4001)
,p_prompt=>unistr('Archivo de Dise\00F1o de Informe')
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P1118_REPORT_LAYOUT_ID'
,p_display_when_type=>'ITEM_IS_NULL_OR_ZERO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el archivo que desea cargar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_06=>'Y'
,p_attribute_08=>'inline'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112550718235617827.4001)
,p_name=>'P1118_REPORT_LAYOUT_NAME'
,p_item_sequence=>58
,p_item_plug_id=>wwv_flow_api.id(112546925661617822.4001)
,p_prompt=>unistr('Nombre de Dise\00F1o')
,p_source=>':P1110_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'P1118_REPORT_LAYOUT_ID'
,p_display_when_type=>'ITEM_IS_NULL_OR_ZERO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre de dise\00F1o, si es necesario. El valor por defecto es el nombre de la consulta del informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112551423138617827.4001)
,p_name=>'P1118_REPORT_LAYOUT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(112546925661617822.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(112551604063617828.4001)
,p_name=>'P1118_REPORT_LAYOUT'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(112546925661617822.4001)
,p_prompt=>unistr('Dise\00F1o de Informe:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_layout_name ',
'from wwv_flow_report_layouts',
'where id = :P1118_REPORT_LAYOUT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P1118_REPORT_LAYOUT_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nombre del dise\00F1o de informe ya cargado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141530212457212945.4001)
,p_name=>'P1118_GENERIC_LAYOUT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(112546925661617822.4001)
,p_prompt=>unistr('Origen de Dise\00F1o de Informe')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GENERIC_REPORT_LAYOUT'
,p_lov=>'.'||wwv_flow_api.id(141528024100206812.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si se debe utilizar el dise\00F1o de informe incorporado gen\00E9rico o un dise\00F1o de informe personalizado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(141521603060181838.4001)
,p_validation_name=>'P1118_LAYOUT_FILE'
,p_validation_sequence=>10
,p_validation=>'P1118_LAYOUT_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se necesita un archivo de dise\00F1o de informe. ')
,p_validation_condition=>'P1118_GENERIC_LAYOUT'
,p_validation_condition2=>'FILE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(112548418946617824.4001)
,p_associated_item=>wwv_flow_api.id(112548832482617825.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(141522927648188921.4001)
,p_validation_name=>'P1118_REPORT_LAYOUT_NAME'
,p_validation_sequence=>20
,p_validation=>'P1118_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre del dise\00F1o de informe.')
,p_validation_condition=>'P1118_GENERIC_LAYOUT'
,p_validation_condition2=>'FILE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(112548418946617824.4001)
,p_associated_item=>wwv_flow_api.id(112550718235617827.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(146015832439660207.4001)
,p_validation_name=>'report layout name unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_report_layouts',
'where report_layout_name = :P1118_REPORT_LAYOUT_NAME',
'and flow_id = :FB_FLOW_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre del dise\00F1o de informe debe ser \00FAnico')
,p_when_button_pressed=>wwv_flow_api.id(112548418946617824.4001)
,p_associated_item=>wwv_flow_api.id(112550718235617827.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590013846254897531.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(112548215559617824.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590013958497897532.4001)
,p_event_id=>wwv_flow_api.id(590013846254897531.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846218653121982734.4001)
,p_name=>'Generic Layout Changes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1118_GENERIC_LAYOUT'
,p_condition_element=>'P1118_GENERIC_LAYOUT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846218773878982735.4001)
,p_event_id=>wwv_flow_api.id(846218653121982734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1118_REPORT_LAYOUT_NAME,P1118_LAYOUT_FILE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846218834767982736.4001)
,p_event_id=>wwv_flow_api.id(846218653121982734.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1118_REPORT_LAYOUT_NAME,P1118_LAYOUT_FILE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(112552906533617829.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_report_layout    clob;',
'    l_report_layout_id number;',
'    ',
'begin',
'',
'    for c1 in (',
'        select blob_content from wwv_flow_files',
'        where name = :P1118_LAYOUT_FILE',
'    ) loop    ',
'        ',
'        l_report_layout_id := wwv_flow_id.next_val;',
'        l_report_layout    := wwv_flow_utilities.blob_to_clob(c1.blob_content);',
'        ',
'        insert into wwv_flow_report_layouts (',
'            id,',
'            flow_id, ',
'            report_layout_name,',
'            report_layout_type,',
'            page_template',
'        ) values (',
'            l_report_layout_id,',
'            :FB_FLOW_ID,',
'            :P1118_REPORT_LAYOUT_NAME,',
'            ''RTF_FILE'',',
'            l_report_layout',
'        );    ',
'        ',
'        :P1118_REPORT_LAYOUT_ID := l_report_layout_id;',
'        ',
'    end loop;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(112548418946617824.4001)
,p_process_when=>'P1118_REPORT_LAYOUT_ID'
,p_process_when_type=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(112553125928617829.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_report_layouts',
'where id = :P1118_REPORT_LAYOUT_ID;',
'',
':P1118_REPORT_LAYOUT_ID := NULL;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(112551828663617828.4001)
);
end;
/
prompt --application/pages/page_01119
begin
wwv_flow_api.create_page(
 p_id=>1119.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Consulta de Informe: Consultas de Origen'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(104950519530856921.4001)
,p_plug_name=>'Crear Consulta de Informe'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>unistr('<p>Puede introducir la sentencia SQL directamente o hacer clic en <strong>Generador de Consultas</strong> para crear una sentencia SQL haciendo clic y apuntando. Para hacer referencia a las aplicaciones y elementos de aplicaci\00F3n en la sentencia SQL, ')
||'haga referencia a ellos como variables de enlace.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(104950908448856922.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(22638505565903517.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206258323161673966.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107860406978419592.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(104950519530856921.4001)
,p_button_name=>'P1119_TEST_QUERY'
,p_button_static_id=>'P1119_TEST_QUERY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Definir Variables de Enlace'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104951832307856926.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206258323161673966.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107941612855695604.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206258323161673966.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104952004592856926.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(206258323161673966.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(107729406464757103.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(206258323161673966.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition2=>'0'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(105070420262189947.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(206258323161673966.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(104967212953885063.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206258323161673966.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107729732682757111.4001)
,p_branch_action=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(107729406464757103.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(105070719894189948.4001)
,p_branch_action=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(105070420262189947.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(104954922269856956.4001)
,p_branch_action=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(104952004592856926.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107879313698506674.4001)
,p_branch_action=>'f?p=&APP_ID.:1113:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(107860406978419592.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107964918705744557.4001)
,p_branch_action=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(107941612855695604.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(590013217436897525.4001)
,p_branch_action=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(104967212953885063.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(104952211493856927.4001)
,p_name=>'P1119_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(104950519530856921.4001)
,p_prompt=>'Consulta SQL:'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una sentencia SQL para definir la consulta del informe. Puede introducir la sentencia directamente o hacer clic en <b>Consulta</b> para crear una sentencia SQL haciendo clic y apuntando. Para hacer referencia a los elementos de aplicaci\00F3n ')
||unistr('y p\00E1gina, haga referencia a ellos como variables de enlace.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(105037026355106518.4001)
,p_name=>'P1119_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(104950519530856921.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(105038728218116584.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1119_QUERY'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select clob001 from wwv_flow_collections',
'    where collection_name = ''REPORT_QUERIES''',
'    and   seq_id = :P1119_SEQ_ID',
') loop',
'    return wwv_flow_utilities.clob_to_varchar2(c1.clob001);',
'end loop;'))
,p_compute_when=>'P1119_SEQ_ID'
,p_compute_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(104954112903856953.4001)
,p_validation_name=>'P1119_QUERY Not Null'
,p_validation_sequence=>10
,p_validation=>'P1119_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la consulta.'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(104952211493856927.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-DEC-2006 13:25'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(104954525470856954.4001)
,p_validation_name=>'is valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_owner varchar2(4000) := null;',
'begin',
'  l_owner := wwv_flow_security.flow_owner ( ',
'     p_flow_id           =>:FB_FLOW_ID, ',
'     p_security_group_id =>:FLOW_SECURITY_GROUP_ID);',
'         ',
'  return wwv_flow_f4000_util.is_valid_report_query (',
'    p_plug_source      => :P1119_QUERY,',
'    p_plug_source_type => wwv_flow_region_native.c_sql_report,',
'    p_owner            => l_owner',
'    );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(104952211493856927.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590013018468897523.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(104951832307856926.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590013186205897524.4001)
,p_event_id=>wwv_flow_api.id(590013018468897523.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(104954613094856954.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Report Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_seq number;',
'begin',
'  if not htmldb_collection.collection_exists(''REPORT_QUERIES'') then',
'    htmldb_collection.create_or_truncate_collection( ',
'      p_collection_name => ''REPORT_QUERIES'' ',
'    );',
'  end if;  ',
'  if nvl(:P1119_SEQ_ID, 0) <> 0 then',
'    l_seq := :P1119_SEQ_ID;',
'    for c1 in (',
'       select c002, c003 from wwv_flow_collections',
'       where collection_name = ''REPORT_QUERIES''',
'       and seq_id = l_seq )',
'    loop',
'      htmldb_collection.update_member(',
'        p_collection_name => ''REPORT_QUERIES'',',
'        p_seq             => :P1119_SEQ_ID,',
'        p_clob001         => :P1119_QUERY,',
'        p_c002            => c1.c002,',
'        p_c003            => c1.c003 ',
'      );',
'    end loop;',
'  else',
'    l_seq := htmldb_collection.add_member(',
'      p_collection_name => ''REPORT_QUERIES'',',
'      p_clob001         => :P1119_QUERY',
'    );   ',
'  end if;',
'  :P1113_SEQ := l_seq;',
'  :P1119_SEQ_ID := l_seq;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al guardar la consulta SQL'
,p_process_when=>'APPLY_CHANGES,CREATE,NEXT,P1119_TEST_QUERY'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Consulta SQL guardada'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(107946525238718110.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    htmldb_collection.delete_member(',
'      p_collection_name => ''REPORT_QUERIES'',',
'      p_seq             => :P1119_SEQ_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir la consulta'
,p_process_when_button_id=>wwv_flow_api.id(107941612855695604.4001)
,p_process_success_message=>'Consulta suprimida'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(269891415356562349.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_collection.collection_exists(''SET_BIND_VALUES'') then',
'    htmldb_collection.delete_collection(''SET_BIND_VALUES'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01120
begin
wwv_flow_api.create_page(
 p_id=>1120.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Resultados de Prueba de Consulta'
,p_step_title=>'Resultados de Prueba de Consulta'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29560216101040006.4001)
,p_plug_name=>'Results'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_bind_values wwv_flow_global.vc_arr2;',
'    i number := 0;',
'    l_query varchar2(32767);',
'begin',
'    if :P1120_QUERY_SOURCE = ''ITEM'' then',
'        l_query := :P1120_QUERY;',
'    else',
'        for c1 in (',
'            select clob001 ',
'            from wwv_flow_collections ',
'            where collection_name = ''REPORT_QUERY_TEMP''',
'        ) loop',
'            l_query := c1.clob001;',
'        end loop;',
'    end if;',
'',
'    for c2 in (',
'        select c001, c002, clob001 ',
'        from wwv_flow_collections ',
'        where collection_name = ''SET_BIND_VALUES''',
'    ) loop',
'        i := i+1;',
'        l_bind_values(i) := c2.c002;',
'    end loop;',
'',
'    wwv_flow_render_query.print_with_binds(',
'        p_owner             => :P1120_OWNER,',
'        p_query             => l_query,',
'        p_format            => ''HTML'',',
'        p_output            => ''HTP'',',
'        p_values            => l_bind_values        ',
'    );',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29603628446459912.4001)
,p_plug_name=>'Top'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29636209211690904.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(29603628446459912.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29554629644996617.4001)
,p_name=>'P1120_QUERY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(29560216101040006.4001)
,p_source=>'P1113_QUERY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29557931291016015.4001)
,p_name=>'P1120_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(29560216101040006.4001)
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(59284120952502614.4001)
,p_name=>'P1120_QUERY_SOURCE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(29560216101040006.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01121
begin
wwv_flow_api.create_page(
 p_id=>1121.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar Consulta de Informe'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62967104563852575.4001)
,p_plug_name=>'Copiar Consulta de Informe'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(590046711508270381.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62968016369852582.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(590046711508270381.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62968213315852583.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(590046711508270381.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(62970104801852589.4001)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62968418713852584.4001)
,p_name=>'P1121_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(62967104563852575.4001)
,p_prompt=>'Copiar Consulta de Informe'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id',
'from WWV_FLOW_SHARED_QUERIES',
'where flow_id = :fb_flow_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Consulta de Informe -  '
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique los componentes que se van a copiar'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62968931766852587.4001)
,p_name=>'P1121_REPORT_QUERY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(62967104563852575.4001)
,p_prompt=>'Nombre de Consulta de Informe'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre del nuevo componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62969518966852588.4001)
,p_validation_name=>'P1121_ID'
,p_validation_sequence=>20
,p_validation=>'P1121_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(62968213315852583.4001)
,p_associated_item=>wwv_flow_api.id(62968418713852584.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62969719439852588.4001)
,p_validation_name=>'P1121_REPORT_QUERY_NAME'
,p_validation_sequence=>30
,p_validation=>'P1121_REPORT_QUERY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nuevo nombre de consulta de informe.'
,p_when_button_pressed=>wwv_flow_api.id(62968213315852583.4001)
,p_associated_item=>wwv_flow_api.id(62968931766852587.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590014022087897533.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(62968016369852582.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590014169890897534.4001)
,p_event_id=>wwv_flow_api.id(590014022087897533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(62969810792852588.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Report Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_shared_query_id number;',
'  ',
'begin',
'',
'  l_shared_query_id := wwv_flow_id.next_val;',
'  ',
'  for c1 in (select * from wwv_flow_shared_queries where id = :P1121_ID) loop',
'    insert into wwv_flow_shared_queries (',
'     id,',
'     flow_id,',
'     name,',
'     security_group_id,',
'     query_text,',
'     report_layout_id,',
'     format,',
'     format_item,',
'     output_file_name,	',
'     xml_items',
'    )',
'    values (',
'     l_shared_query_id,',
'     :fb_flow_id,',
'     :P1121_REPORT_QUERY_NAME,',
'     c1.security_group_id,',
'     c1.query_text,',
'     c1.report_layout_id,',
'     c1.format,',
'     c1.format_item,',
'     c1.output_file_name,	',
'     c1.xml_items',
'    );',
'    for c2 in (',
'      select * from wwv_flow_shared_qry_sql_stmts',
'      where shared_query_id = :P1121_ID',
'    ) loop',
'      insert into wwv_flow_shared_qry_sql_stmts (',
'         flow_id,',
'         shared_query_id,',
'         security_group_id,',
'         sql_statement',
'      ) values (',
'         c2.flow_id,',
'         l_shared_query_id,',
'         c2.security_group_id,',
'         c2.sql_statement',
'      );',
'    end loop;',
'  end loop;',
'  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar el acceso directo'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(62968213315852583.4001)
,p_process_success_message=>unistr('M\00E9todo abreviado copiado')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590014217600897535.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(62968213315852583.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_01122
begin
wwv_flow_api.create_page(
 p_id=>1122.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Copiar Dise\00F1o de Informe')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Copiar Dise\00F1o de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63108814517977364.4001)
,p_plug_name=>unistr('Copiar Dise\00F1o de Informe')
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(590050704413351910.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63109718403977365.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(590050704413351910.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63109919558977365.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(590050704413351910.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(63111822109977367.4001)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63110108579977365.4001)
,p_name=>'P1122_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(63108814517977364.4001)
,p_prompt=>unistr('Copiar Dise\00F1o de Informe')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_layout_name d, id',
'from WWV_FLOW_REPORT_LAYOUTS',
'where flow_id = :fb_flow_id',
'order by upper(report_layout_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Dise\00F1o de Informe - ')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique los componentes que se van a copiar'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63110614427977366.4001)
,p_name=>'P1122_REPORT_LAYOUT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(63108814517977364.4001)
,p_prompt=>unistr('Nombre de Dise\00F1o de Informe')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nombre del nuevo componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63111203693977366.4001)
,p_validation_name=>'P1122_ID'
,p_validation_sequence=>20
,p_validation=>'P1122_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(63109919558977365.4001)
,p_associated_item=>wwv_flow_api.id(63110108579977365.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63111431811977366.4001)
,p_validation_name=>'P1122_REPORT_LAYOUT_NAME'
,p_validation_sequence=>30
,p_validation=>'P1122_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nuevo nombre de consulta de informe.'
,p_when_button_pressed=>wwv_flow_api.id(63109919558977365.4001)
,p_associated_item=>wwv_flow_api.id(63110614427977366.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(146010218325637204.4001)
,p_validation_name=>'report layout name unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_report_layouts',
'where report_layout_name = :P1122_REPORT_LAYOUT_NAME',
'and flow_id = :FB_FLOW_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre del dise\00F1o de informe debe ser \00FAnico')
,p_when_button_pressed=>wwv_flow_api.id(63109919558977365.4001)
,p_associated_item=>wwv_flow_api.id(63110614427977366.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590015076897897543.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(63109718403977365.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590015184436897544.4001)
,p_event_id=>wwv_flow_api.id(590015076897897543.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63111507604977366.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Report Layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * from wwv_flow_report_layouts where id = :P1122_ID) loop',
'  insert into wwv_flow_report_layouts (',
'   flow_id,',
'   report_layout_name,',
'   report_layout_type,',
'   page_template,',
'   xslfo_column_heading_template,',
'   xslfo_column_template,',
'   xslfo_column_template_width,',
'   report_layout_comment,',
'   reference_id,',
'   security_group_id',
'  )',
'values (',
'   :fb_flow_id,',
'   :P1122_REPORT_LAYOUT_NAME,',
'   c1.report_layout_type,',
'   c1.page_template,',
'   c1.xslfo_column_heading_template,',
'   c1.xslfo_column_template,',
'   c1.xslfo_column_template_width,',
'   c1.report_layout_comment,',
'   c1.reference_id,',
'   c1.security_group_id',
'  );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido copiar el acceso directo'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(63109919558977365.4001)
,p_process_success_message=>unistr('M\00E9todo abreviado copiado')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590015354430897546.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(63109919558977365.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_01207
begin
wwv_flow_api.create_page(
 p_id=>1207.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Interfaz de Usuario'
,p_step_title=>'Interfaz de Usuario'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879423075323511)
,p_css_file_urls=>'#IMAGE_PREFIX#css/apex_ui_themes.css'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274106729097705508.4001)
,p_plug_name=>'Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274108609979705511.4001)
,p_plug_name=>'Indicador de Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(106473613360356705.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274108814642705511.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747147253547138175.4001)
,p_plug_name=>'Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(274109009659705511.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(274108814642705511.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(274109221686705511.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(274108814642705511.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(274109400379705513.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(274108814642705511.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(274110606851705516.4001)
,p_branch_action=>'f?p=&APP_ID.:208:&SESSION.::&DEBUG.::THEME_ID:&P1207_THEME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(274109221686705511.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(274110808604705517.4001)
,p_branch_action=>'f?p=&APP_ID.:1207:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274108100503705510.4001)
,p_name=>'P1207_USER_INTERFACE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>'Interfaz de Usuario:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.id ',
'from wwv_flow_ui_types_dev t, wwv_flow_user_interfaces i',
'where i.ui_type_id = t.id',
'and i.flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'USER INTERFACES (IN CURRENT APP)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''ADD_USER_INTERFACE'') d, 0 r from dual',
'union',
'select i.display_name, t.id ',
'from wwv_flow_ui_types_dev t, wwv_flow_user_interfaces i',
'where i.ui_type_id = t.id',
'and i.flow_id = :fb_flow_id ',
'order by 1',
''))
,p_cHeight=>1
,p_read_only_when=>'P1207_CREATE_NEW'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una interfaz de usuario para la aplicaci\00F3n. Seleccione <strong>Escritorio</strong> para obtener la aplicaci\00F3n dise\00F1ada principalmente para uso de escritorio. Para otras interfaces, como smartphones o tabletas, seleccione la interfaz de usu')
||'ario correspondiente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274461718582108365.4001)
,p_name=>'P1207_UI_TYPE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UI TYPE (UNUSED, RETURNS ID)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_ui_types_dev',
'where id not in (',
'    select t.id ',
'      from wwv_flow_ui_types_dev t, wwv_flow_user_interfaces i',
'     where i.ui_type_id = t.id ',
'      and i.flow_id = :fb_flow_id',
') and id = 1 order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tipo -'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un tipo de interfaz de usuario. Si no aparece ning\00FAn tipo en la lista seleccionada, todas las interfaces de usuario disponibles se asociar\00E1n a la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274461929773108365.4001)
,p_name=>'P1207_DISPLAY_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>'Nombre Mostrado'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Especifique un nombre mostrado para la interfaz de usuario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274462122482108365.4001)
,p_name=>'P1207_DISPLAY_SEQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_seq + 10',
'from wwv_flow_ui_types_dev t, wwv_flow_user_interfaces i',
'where i.ui_type_id = t.id',
'and i.flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Especifique la secuencia de interfaz de usuario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274462618978109773.4001)
,p_name=>'P1207_USE_AUTO_DETECT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Detecci\00F3n Autom\00E1tica')
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>32
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione si la interfaz de usuario se debe detectar autom\00E1ticamente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274462816349109773.4001)
,p_name=>'P1207_IS_DEFAULT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_item_default=>'N'
,p_prompt=>'Default'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274463231865109773.4001)
,p_name=>'P1207_HOME_URL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>unistr('URL de P\00E1gina Inicial')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>4
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la URL para la p\00E1gina que se va a utilizar como p\00E1gina inicial para la interfaz de usuario actual.'),
'',
'<p/>',
unistr('&PRODUCT_NAME. sugiere autom\00E1ticamente un valor para la interfaz de usuario seleccionada,'),
unistr('pero tendr\00E1 que crear la p\00E1gina inicial correspondiente usted mismo.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274463407689109773.4001)
,p_name=>'P1207_LOGIN_URL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>unistr('URL de Conexi\00F3n')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>4
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la URL para la p\00E1gina que se va a utilizar como p\00E1gina de conexi\00F3n para la interfaz de usuario actual.'),
'<p/>',
unistr('&PRODUCT_NAME. sugiere autom\00E1ticamente un valor para la interfaz de usuario seleccionada,'),
unistr('pero tendr\00E1 que crear la p\00E1gina de conexi\00F3n correspondiente usted mismo.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(276436200121330683.4001)
,p_name=>'P1207_UI_TYPE_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(374360710736841547.4001)
,p_name=>'P1207_CREATE_NEW'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(274106729097705508.4001)
,p_prompt=>'Create New'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(276443921397411953.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1207_UI_TYPE_NAME'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'from wwv_flow_ui_types_dev',
'where id = :P1207_UI_TYPE_ID'))
,p_compute_when=>':P1207_USER_INTERFACE_ID=0'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(274110200443705516.4001)
,p_computation_sequence=>10
,p_computation_item=>'THEME_NEXT_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'210'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(276495322469684970.4001)
,p_validation_name=>'P1207_UI_TYPE_ID'
,p_validation_sequence=>10
,p_validation=>'P1207_UI_TYPE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe seleccionar el tipo de interfaz de usuario. '
,p_validation_condition=>':P1207_USER_INTERFACE_ID=0'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(274461718582108365.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(354862430190165651.4001)
,p_validation_name=>'theme exists for selected ui type'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'       from wwv_flow_themes t',
'      where t.security_group_id in (11,12) ',
'        and t.ui_type_id = :P1207_USER_INTERFACE_ID',
'        and t.theme_id not in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'No hay temas adicionales disponibles para el tipo de interfaz de usuario que ha seleccionado.'
,p_validation_condition=>'P1207_USER_INTERFACE_ID'
,p_validation_condition2=>'0'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(274474320919276787.4001)
,p_name=>'show user interface attributes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1207_USER_INTERFACE_ID'
,p_condition_element=>'P1207_USER_INTERFACE_ID'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(274474607731276787.4001)
,p_event_id=>wwv_flow_api.id(274474320919276787.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1207_UI_TYPE_ID,P1207_DISPLAY_NAME,P1207_DISPLAY_SEQ,P1207_USE_AUTO_DETECT,P1207_IS_DEFAULT,P1207_HOME_URL,P1207_LOGIN_URL,P1207_THEME_ID,P1207_GLOBAL_PAGE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(274474817002276787.4001)
,p_event_id=>wwv_flow_api.id(274474320919276787.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1207_UI_TYPE_ID,P1207_DISPLAY_NAME,P1207_DISPLAY_SEQ,P1207_USE_AUTO_DETECT,P1207_IS_DEFAULT,P1207_HOME_URL,P1207_LOGIN_URL,P1207_THEME_ID,P1207_GLOBAL_PAGE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(275454006167125644.4001)
,p_name=>'set display name'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1207_UI_TYPE_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(275454327094125644.4001)
,p_event_id=>wwv_flow_api.id(275454006167125644.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select display_name,',
'           ''f?p=&''||''APP_ID.:HOME_''||name||'':&''||''SESSION.'',',
'           ''f?p=&''||''APP_ID.:LOGIN_''||name||'':&''||''SESSION.''',
'      into :P1207_DISPLAY_NAME,',
'           :P1207_HOME_URL,',
'           :P1207_LOGIN_URL',
'      from wwv_flow_ui_types_dev',
'     where id = :P1207_UI_TYPE_ID;',
'exception when NO_DATA_FOUND then',
'    :P1207_DISPLAY_NAME := null;',
'    :P1207_HOME_URL     := null;',
'    :P1207_LOGIN_URL    := null;',
'end;'))
,p_attribute_02=>'P1207_UI_TYPE_ID'
,p_attribute_03=>'P1207_DISPLAY_NAME,P1207_HOME_URL,P1207_LOGIN_URL'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_01234
begin
wwv_flow_api.create_page(
 p_id=>1234.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Comentarios del Desarrollador: Crear Comentarios'
,p_page_mode=>'MODAL'
,p_step_title=>'Comentarios del Desarrollador'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(123537523367900100.4001)
,p_plug_name=>'Comentarios del Desarrollador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Utilice esta p\00E1gina para agregar comentarios a una aplicaci\00F3n, p\00E1gina o grupo de p\00E1ginas.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(123547514466030042.4001)
,p_plug_name=>'comentarios'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(123545913988020430.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(716353419229823641.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(232634827416535370.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(716353419229823641.4001)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'P1234_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(123537731742900109.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(716353419229823641.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1234_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(123538026288900109.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(716353419229823641.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(232636826854544630.4001)
,p_branch_action=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(232634827416535370.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(123538626655900116.4001)
,p_branch_action=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123538824973900121.4001)
,p_name=>'P1234_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(123537523367900100.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123539019004900121.4001)
,p_name=>'P1234_FLOW_ID'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(123537523367900100.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123539227801900122.4001)
,p_name=>'P1234_PAGES'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(123537523367900100.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina(s) Relevantes')
,p_source=>'PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique las p\00E1ginas a las que se aplica este comentario. Para introducir un comentario que:'),
'<ul>',
unistr('<li>Se aplica a una p\00E1gina concreta, introduzca el n\00FAmero de p\00E1gina</li>'),
unistr('<li>Se aplica a varias p\00E1ginas, introduzca una lista de p\00E1ginas delimitada por comas, por ejemplo:</li>'),
'<pre>1,2,3</pre>',
unistr('<li>No se aplica a una p\00E1gina o grupo de p\00E1ginas, deje este campo en blanco.</li>'),
'<ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_show_quick_picks=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123539426852900122.4001)
,p_name=>'P1234_APP_COMMENT'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_api.id(123537523367900100.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'APP_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Introduzca un comentario de hasta 4000 caracteres.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1142730559897397045.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1234'
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(223964818557185973.4001)
,p_validation_name=>'Relevant pages'
,p_validation_sequence=>5
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_pages_string wwv_flow_global.vc_arr2;',
'l_flag boolean := false;',
'l_count number;',
'begin',
'    l_pages_string := wwv_flow_utilities.string_to_table(to_char(:P1234_PAGES),'','');',
'    if l_pages_string.count > 0 then',
'       for i in 1..l_pages_string.count loop',
'            select 1 into l_count from dual where exists (select 1',
'              from wwv_flow_steps',
'             where flow_id = :FB_FLOW_ID ',
'               and security_group_id = :flow_security_group_id',
'               and (to_char(id) = l_pages_string(i) or lower(name) = lower(l_pages_string(i))));',
'            if l_count <> 0 then',
'              l_flag := true;',
'            else',
'              l_flag := false;',
'              exit;',
'            end if;',
'       end loop;',
'    end if;',
'    return l_flag;',
'exception when no_data_found then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No es una p\00E1gina v\00E1lida.')
,p_validation_condition=>'P1234_PAGES'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(123539227801900122.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(123605305440616599.4001)
,p_validation_name=>'P1234_APP_COMMENT Not Null'
,p_validation_sequence=>10
,p_validation=>'P1234_APP_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un comentario.'
,p_associated_item=>wwv_flow_api.id(123539426852900122.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 14-APR-2006 01:31'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(486766762279194440.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(123538026288900109.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(486766849310194441.4001)
,p_event_id=>wwv_flow_api.id(486766762279194440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(123539830205900124.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APP_COMMENTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_COMMENTS'
,p_attribute_03=>'P1234_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_APP_COMMENTS.'
,p_process_success_message=>'Comentario creado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486766908372194442.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(123537731742900109.4001)
,p_process_success_message=>'Comentario creado.'
);
end;
/
prompt --application/pages/page_01235
begin
wwv_flow_api.create_page(
 p_id=>1235.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Comentarios del Desarrollador: Ver Comentarios'
,p_page_mode=>'MODAL'
,p_step_title=>'Ver Comentarios del Desarrollador'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(123554528709102911.4001)
,p_plug_name=>'comentarios'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_api.id(123545913988020430.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(480642308464787876.4001)
,p_plug_name=>'Comentarios del Desarrollador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id, ',
'       a.flow_id, ',
'       a.pages, ',
'       a.app_comment, ',
'       a.created_on, ',
'       a.created_by,',
'       m.e',
'from WWV_FLOW_APP_COMMENTS a, (select wwv_flow_lang.system_message(''EDIT'') e from dual) m',
'where a.flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(480642409196787876.4001)
,p_name=>'Application Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_max_rows_per_page=>'5'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480642618294787884.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Editar'
,p_column_link=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil2_16x16.gif" alt="#E#">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480642701443787886.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480642810738787887.4001)
,p_db_column_name=>'PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina(s)')
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480642917569787888.4001)
,p_db_column_name=>'APP_COMMENT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480643023768787889.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Fecha de Creaci\00F3n')
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480643110041787890.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1142730609563397046.4001)
,p_db_column_name=>'E'
,p_display_order=>16
,p_column_identifier=>'G'
,p_column_label=>'E'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1142730365473397043.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480648000309840576.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1142730365473397043.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480648917755855006.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(480642308464787876.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(123575520425262395.4001)
,p_branch_action=>'f?p=&FLOW_ID.:1235:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1474234592148765837.4001)
,p_branch_name=>'Go To Page 1235'
,p_branch_action=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.:RP,CIR,1235,1234:IR_PAGES:&FB_FLOW_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SET_CURRENT_PAGE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1142730470924397044.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1235'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(692816214967250924.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(480648000309840576.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(692816344529250925.4001)
,p_event_id=>wwv_flow_api.id(692816214967250924.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1000724298923503624.4001)
,p_name=>'Edit Comment - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(480642308464787876.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1000724344409503625.4001)
,p_event_id=>wwv_flow_api.id(1000724298923503624.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(480642308464787876.4001)
);
end;
/
prompt --application/pages/page_01236
begin
wwv_flow_api.create_page(
 p_id=>1236.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Comentario del Desarrollador'
,p_page_mode=>'MODAL'
,p_step_title=>'Editar Comentario del Desarrollador'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_dialog_width=>'700'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(123556230616110490.4001)
,p_plug_name=>'Comentario del Desarrollador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(123556415458110491.4001)
,p_plug_name=>'comentarios'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(1284942185735713564.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1000723973714503621.4001)
,p_plug_name=>'Barra de Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(123557226812110495.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1000723973714503621.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(123557031897110494.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1000723973714503621.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1236_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(123556820381110494.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1000723973714503621.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1236_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1000724569434503627.4001)
,p_branch_name=>'Return to Parent Page'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123557431204110497.4001)
,p_name=>'P1236_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(123556230616110490.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123557621406110499.4001)
,p_name=>'P1236_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(123556230616110490.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123557826993110501.4001)
,p_name=>'P1236_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(123556230616110490.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1ginas Relevantes:')
,p_source=>'PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique las p\00E1ginas a las que se aplica este comentario. Para introducir un comentario que:'),
'<ul>',
unistr('<li>Se aplica a una p\00E1gina concreta, introduzca el n\00FAmero de p\00E1gina</li>'),
unistr('<li>Se aplica a varias p\00E1ginas, introduzca una lista de p\00E1ginas delimitada por comas, por ejemplo:</li>'),
'<pre>1,2,3</pre>',
unistr('<li>No se aplica a una p\00E1gina o grupo de p\00E1ginas, deje este campo en blanco.</li>'),
'<ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123558020518110501.4001)
,p_name=>'P1236_APP_COMMENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(123556230616110490.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario:'
,p_source=>'APP_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Introduzca o reviste este comentario. Un comentario puede tener hasta 4000 caracteres.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(223968027739226404.4001)
,p_validation_name=>'Relevant pages'
,p_validation_sequence=>5
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_pages_string wwv_flow_global.vc_arr2;',
'l_flag boolean := false;',
'l_count number;',
'begin',
'    l_pages_string := wwv_flow_utilities.string_to_table(to_char(:P1236_PAGES),'','');',
'    if l_pages_string.count > 0 then',
'       for i in 1..l_pages_string.count loop',
'            select 1 into l_count from dual where exists (select 1',
'              from wwv_flow_steps',
'             where flow_id = :FB_FLOW_ID ',
'               and security_group_id = :flow_security_group_id',
'               and (to_char(id) = l_pages_string(i) or lower(name) = lower(l_pages_string(i))));',
'            if l_count <> 0 then',
'              l_flag := true;',
'            else',
'              l_flag := false;',
'              exit;',
'            end if;',
'       end loop;',
'    end if;',
'    return true;',
'exception when no_data_found then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No es una p\00E1gina relevante v\00E1lida')
,p_when_button_pressed=>wwv_flow_api.id(123556820381110494.4001)
,p_associated_item=>wwv_flow_api.id(123557826993110501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(124035417798389112.4001)
,p_validation_name=>'P1236_APP_COMMENT'
,p_validation_sequence=>10
,p_validation=>'P1236_APP_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(123556820381110494.4001)
,p_associated_item=>wwv_flow_api.id(123558020518110501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1000724078717503622.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(123557226812110495.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1000724178029503623.4001)
,p_event_id=>wwv_flow_api.id(1000724078717503622.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(123558218597110505.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_APP_COMMENTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_COMMENTS'
,p_attribute_03=>'P1236_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(123558429165110506.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APP_COMMENTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_COMMENTS'
,p_attribute_03=>'P1236_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_APP_COMMENTS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(123558621993110506.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1234'
,p_process_when_button_id=>wwv_flow_api.id(123557031897110494.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(694385070619237844.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(746156952208367929.4001)
,p_process_sequence=>60
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog on Cancel'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(123557226812110495.4001)
);
end;
/
prompt --application/pages/page_01237
begin
wwv_flow_api.create_page(
 p_id=>1237.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Suprimir Comentarios: Acciones de Comentario'
,p_page_mode=>'MODAL'
,p_step_title=>'Suprimir Comentarios'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(125606014398318403.4001)
,p_plug_name=>'Comentarios del Desarrollador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(125611220070329594.4001)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(1284942185735713564.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(125623624628434962.4001)
,p_name=>'Comentarios del Desarrollador'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 CREATED_BY, count(*) c',
' from	 WWV_FLOW_APP_COMMENTS',
'where    flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group    by created_by'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn comentario.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(125623918473434970.4001)
,p_query_column_id=>1
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>1
,p_column_heading=>'Desarrollador'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(125624022696434970.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Comentarios'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(125625719218442826.4001)
,p_name=>unistr('Comentarios por D\00EDa')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 trunc(created_on) CREATED_ON, count(*) c',
' from	 WWV_FLOW_APP_COMMENTS',
'where    flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group    by trunc(created_on)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn comentario.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(125626402726447548.4001)
,p_query_column_id=>1
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Fecha de Creaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(125625901435442830.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Comentarios'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754559227164487437.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2321634135249176500.4001)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(123545913988020430.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(125618309905392893.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(754559227164487437.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(125618510962392895.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(754559227164487437.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(125628521904462571.4001)
,p_branch_action=>'f?p=&APP_ID.:1238:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(125618309905392893.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(125629125367463594.4001)
,p_branch_action=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125613619901367332.4001)
,p_name=>'P1237_COMMENT_ACTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(125606014398318403.4001)
,p_item_default=>'DATE'
,p_prompt=>unistr('Acci\00F3n:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COMMENT MGT'
,p_lov=>'.'||wwv_flow_api.id(131122619933750813.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione una acci\00F3n y haga clic en <strong>Siguiente</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(754559639707487441.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(125618510962392895.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(754559719302487442.4001)
,p_event_id=>wwv_flow_api.id(754559639707487441.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01238
begin
wwv_flow_api.create_page(
 p_id=>1238.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Comentarios del Desarrollador: Suprimir Comentarios'
,p_page_mode=>'MODAL'
,p_step_title=>'Suprimir Comentarios'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(125615526048372333.4001)
,p_plug_name=>'Comentarios del Desarrollador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(754559304329487438.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2321636842147201443.4001)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(123545913988020430.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(125639426631530146.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(754559304329487438.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir Comentarios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(125638513125526226.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(754559304329487438.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(125666323617661740.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(754559304329487438.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(125639609772530148.4001)
,p_branch_name=>'Go To Previous Page'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(125639426631530146.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125636509877515824.4001)
,p_name=>'P1238_DEVELOPER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(125615526048372333.4001)
,p_prompt=>'Suprimir Comentarios del Desarrollador:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct CREATED_BY display_value, CREATED_BY return_value',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Desarrollador -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>'P1237_COMMENT_ACTIONS'
,p_display_when2=>'DEVELOPER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica los comentarios creados por el desarrollador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125642702436551532.4001)
,p_name=>'P1238_TIME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(125615526048372333.4001)
,p_prompt=>'Suprimir Comentarios Creados el o Antes de la Fecha Seleccionada:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct trunc(CREATED_ON) display_value, to_char(trunc(CREATED_ON) ,''YYYY.MM.DD'') return_value',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'order by 1 desc'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Fecha -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_display_when=>'P1237_COMMENT_ACTIONS'
,p_display_when2=>'DATE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica las distintas fechas de creaci\00F3n de los comentarios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125644810186563230.4001)
,p_name=>'P1238_COUNT'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(125615526048372333.4001)
,p_prompt=>'Recuento de Comentarios:'
,p_source=>'select count(*) from wwv_flow_app_comments where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero total de comentarios registrados para esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(125659932097626337.4001)
,p_validation_name=>'P1238_DEVELOPER'
,p_validation_sequence=>10
,p_validation=>'P1238_DEVELOPER'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Se debe especificar un desarrollador.'
,p_validation_condition=>'P1237_COMMENT_ACTIONS'
,p_validation_condition2=>'DEVELOPER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(125639426631530146.4001)
,p_associated_item=>wwv_flow_api.id(125636509877515824.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(125661119068632040.4001)
,p_validation_name=>'P1238_TIME'
,p_validation_sequence=>20
,p_validation=>'P1238_TIME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar una fecha.'
,p_validation_condition=>'P1237_COMMENT_ACTIONS'
,p_validation_condition2=>'DATE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(125639426631530146.4001)
,p_associated_item=>wwv_flow_api.id(125642702436551532.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(754559420603487439.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(125666323617661740.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(754559520263487440.4001)
,p_event_id=>wwv_flow_api.id(754559420603487439.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(125640604252533114.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete comments'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1237_COMMENT_ACTIONS = ''ALL'' then',
'   delete from wwv_flow_app_comments ',
'   where flow_id = :fb_flow_id;',
'elsif :P1237_COMMENT_ACTIONS = ''DEVELOPER'' then',
'   delete from wwv_flow_app_comments ',
'   where flow_id = :fb_flow_id and created_by = :P1238_DEVELOPER;',
'elsif :P1237_COMMENT_ACTIONS = ''DATE'' then',
'   delete from wwv_flow_app_comments ',
'   where flow_id = :fb_flow_id and trunc(created_on) <= to_date(:P1238_TIME,''YYYY.MM.DD'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se han podido suprimir los comentarios'
,p_process_success_message=>'Comentarios suprimidos.'
);
end;
/
prompt --application/pages/page_01300
begin
wwv_flow_api.create_page(
 p_id=>1300.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_step_title=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15039604745449200.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(493047621227940477.4001)
,p_plug_name=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P1300a */',
'component,',
'page_id,',
'page_name,',
'component_name,',
'component_signature,',
'decode(application_1,0,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') application_1,',
'decode(application_2,0,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') application_2,',
'decode(application_1,0,null,''X'') a_1,',
'decode(application_2,0,null,''X'') a_2',
'from (',
'select page_id,',
'page_name,',
'component,',
'component_name,',
'component_signature,',
'application_1,',
'application_2',
'from apex_component_signatures) q',
'where ',
'(nvl(:P1300_SHOW_DIFFERENCES,''Y'')=''N'' or ',
'(nvl(:P1300_SHOW_DIFFERENCES,''Y'')=''Y'' and application_1 != application_2))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(v(''REQUEST''),''X'') != ''NORUN'' and nvl(:APEX_APPLICATION_1,''0'') != ''0'' and nvl(:APEX_APPLICATION_2,''0'') != ''0'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(493047720816940477.4001)
,p_name=>'Application Comparison'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493047930668941285.4001)
,p_db_column_name=>'COMPONENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Componente'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(15166510896787111)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048010071941286.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048117478941287.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048231120941287.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048303393941287.4001)
,p_db_column_name=>'COMPONENT_SIGNATURE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Detalles'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048430576941288.4001)
,p_db_column_name=>'APPLICATION_1'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Aplicaci\00F3n 1')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048510158941288.4001)
,p_db_column_name=>'APPLICATION_2'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Aplicaci\00F3n 2')
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048607117941289.4001)
,p_db_column_name=>'A_1'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Aplicaci\00F3n 1')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(493048714149941289.4001)
,p_db_column_name=>'A_2'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Aplicaci\00F3n 2')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702937747004311901.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15045710117488602.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(15039604745449200.4001)
,p_button_name=>'P1300_GO'
,p_button_static_id=>'P1300_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27862932602152407.4001)
,p_branch_name=>'Redirect to self (RP)'
,p_branch_action=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(15045710117488602.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15040616173452553.4001)
,p_name=>'APEX_APPLICATION_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15039604745449200.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n 1')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una aplicaci\00F3n para comparar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15040822645452554.4001)
,p_name=>'APEX_APPLICATION_2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(15039604745449200.4001)
,p_prompt=>unistr('Aplicaci\00F3n 2')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una aplicaci\00F3n para comparar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15068211230744414.4001)
,p_name=>'P1300_SHOW_DIFFERENCES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(15039604745449200.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Mostrar S\00F3lo Diferencias')
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica si se mostrar\00E1n s\00F3lo las diferencias o todos los datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15158420902487243.4001)
,p_name=>'APEX_COMPONENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(15039604745449200.4001)
,p_prompt=>'Componente'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP DIFF COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(15166510896787111.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Componentes -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el componente espec\00EDfico para comparar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_01301
begin
wwv_flow_api.create_page(
 p_id=>1301.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Recuentos de Comparaci\00F3n de Aplicaci\00F3n')
,p_step_title=>unistr('Recuentos de Comparaci\00F3n de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(17189801948394308.4001)
,p_name=>unistr('Comparaci\00F3n de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(646287526247383209.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P1301a */',
'component,',
'sum(application_1) application_1_count,',
'sum(application_2) application_2_count,',
'sum(decode(application_2,0,0,decode(application_1,application_2,0,1))) deltas',
'from apex_component_signatures',
'group by component'))
,p_display_when_condition=>'NORUN'
,p_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('El informe no contiene ning\00FAn dato')
,p_query_num_rows_item=>'P1301_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_report_total_text_format=>'&nbsp;'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17190631538394312.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Componente'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(15166510896787111)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17195718044399138.4001)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_1_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n 1')
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17195812258399139.4001)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION_2_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Aplicaci\00F3n 2')
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(17536704069529009.4001)
,p_query_column_id=>4
,p_column_alias=>'DELTAS'
,p_column_display_sequence=>4
,p_column_heading=>'Diferencias'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17190904236394312.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17197222677409954.4001)
,p_plug_name=>'set state'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APEX_COMPONENT := :1301_APEX_COMPONENT;',
':APEX_APPLICATION_1 := :1301_APEX_APPLICATION_1;',
':APEX_APPLICATION_2 := :1301_APEX_APPLICATION_2;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702947203320429957.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17194026633394324.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(17190904236394312.4001)
,p_button_name=>'P1301_GO'
,p_button_static_id=>'P1301_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17192519038394324.4001)
,p_name=>'1301_APEX_COMPONENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17190904236394312.4001)
,p_prompt=>'Componente'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP DIFF COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(15166510896787111.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todos los Componentes -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el componente espec\00EDfico para comparar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17193000172394324.4001)
,p_name=>'1301_APEX_APPLICATION_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17190904236394312.4001)
,p_prompt=>unistr('Aplicaci\00F3n 1')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una aplicaci\00F3n para comparar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17193525392394324.4001)
,p_name=>'1301_APEX_APPLICATION_2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(17190904236394312.4001)
,p_prompt=>unistr('Aplicaci\00F3n 2')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una aplicaci\00F3n para comparar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17194422693394325.4001)
,p_name=>'P1301_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17190904236394312.4001)
,p_item_default=>'50'
,p_prompt=>'Filas'
,p_source=>'50'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el n\00FAmero de aplicaciones que desea visualizar y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17194911948394327.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(17194026633394324.4001)
);
end;
/
prompt --application/pages/page_01310
begin
wwv_flow_api.create_page(
 p_id=>1310.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1ginas de informes de actividad')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1ginas de informes de actividad')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117507451964569407.4001)
,p_plug_name=>'Crear Separador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(117506863394569405.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(117507451964569407.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1310_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57849493242151676.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57849874872151679.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57850292252151679.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57850673145151679.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(758884905432798283.4001)
,p_plug_name=>unistr('Crear p\00E1ginas de informes de actividad')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Incluya una gran cantidad de informes sobre la actividad del usuario final para la aplicaci\00F3n. Con el fin de comprender mejor c\00F3mo se est\00E1 utilizando la aplicaci\00F3n y las \00E1reas de mejora, determine los usuarios m\00E1s activos, las p\00E1ginas m\00E1s utilizadas,')
||unistr(' el rendimiento de las p\00E1ginas y los errores producidos.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(770537390324975510.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3775766002223368423.4001)
,p_plug_name=>'Opciones Admin'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725944806732667144.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(770537390324975510.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725945204229667146.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(770537390324975510.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725945679123667146.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(770537390324975510.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(725948665922667162.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(725944806732667144.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(725949400695667162.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(725945679123667146.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32413796851551883.4001)
,p_name=>'P1310_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3775766002223368423.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n, a la que se ha agregado una lista, para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32414153599551883.4001)
,p_name=>'P1310_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3775766002223368423.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 100, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32415079559551884.4001)
,p_name=>'P1310_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3775766002223368423.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32415451462551884.4001)
,p_name=>'P1310_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3775766002223368423.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que se utiliza como p\00E1gina de administraci\00F3n en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57844562845149244.4001)
,p_name=>'P1310_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(758884905432798283.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57845591955151667.4001)
,p_name=>'P1310_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(117507451964569407.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57846425479151670.4001)
,p_name=>'P1310_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(117507451964569407.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57847312389151672.4001)
,p_name=>'P1310_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(117507451964569407.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57848287610151673.4001)
,p_name=>'P1310_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(117507451964569407.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1310_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P1310_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57851384099153099.4001)
,p_name=>'P1310_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57852288955153100.4001)
,p_name=>'P1310_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57852629105153100.4001)
,p_name=>'P1310_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57853584127153102.4001)
,p_name=>'P1310_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57854406244153103.4001)
,p_name=>'P1310_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P1310_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57855363083153105.4001)
,p_name=>'P1310_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1037339875012925919.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1310_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130089413134346976.4001)
,p_name=>'P1310_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3775766002223368423.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguno -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de autorizaci\00F3n que se va a utilizar para limitar el acceso a la p\00E1gina de administraci\00F3n y a las p\00E1ginas de la funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183306875103905192.4001)
,p_name=>'P1310_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(758884905432798283.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.ACTIVITY_REPORTING'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(725939161009667132.4001)
,p_name=>'P1310_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(758884905432798283.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de p\00E1gina inicial')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado. Esta funci\00F3n crear\00E1 varias p\00E1ginas que empiecen por el n\00FAmero especificado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 10, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(725946192631667153.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57827169067033904.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1310_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(725946560428667154.4001)
,p_validation_name=>'P1310_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P1310_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(725939161009667132.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3775765906333368422.4001)
,p_validation_name=>'P1310_STARTING_PAGE_ID reserved'
,p_validation_sequence=>11
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1310_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1310_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(725939161009667132.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688506607794608724.4001)
,p_validation_name=>'P1310_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>21
,p_validation=>'P1310_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(32414153599551883.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3775765767170368420.4001)
,p_validation_name=>'P1310_ADMIN_PAGE_ID not null'
,p_validation_sequence=>31
,p_validation=>'P1310_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(32415079559551884.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3775765826745368421.4001)
,p_validation_name=>'P1310_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>51
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1310_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1310_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1310_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(32414153599551883.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688506838451608726.4001)
,p_validation_name=>'P1310_STARTING_PAGE_ID and P1310_ADMIN_PAGE_ID different'
,p_validation_sequence=>61
,p_validation=>':P1310_STARTING_PAGE_ID <> :P1310_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina inicial y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688506568227608723.4001)
,p_validation_name=>'P1310_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>71
,p_validation=>'P1310_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(32415079559551884.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(688506734462608725.4001)
,p_validation_name=>'P1310_EXISTING_PAGE not null'
,p_validation_sequence=>81
,p_validation=>'P1310_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(32415451462551884.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235669185981464945.4001)
,p_validation_name=>'P1310_EXISTING_PAGE available'
,p_validation_sequence=>91
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1310_EXISTING_PAGE );',
'exception',
'    when value_error then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1310_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1310_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(32415451462551884.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827287067033905.4001)
,p_validation_name=>'P1310_TAB_SET not null'
,p_validation_sequence=>101
,p_validation=>'P1310_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(57846425479151670.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827377374033906.4001)
,p_validation_name=>'P1310_TAB_LABEL not null'
,p_validation_sequence=>111
,p_validation=>'P1310_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(57847312389151672.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827484879033907.4001)
,p_validation_name=>'P1310_TAB_NAME not null'
,p_validation_sequence=>121
,p_validation=>'P1310_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(57848287610151673.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57932168716392400.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>131
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1310_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1310_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(57851384099153099.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827501722033908.4001)
,p_validation_name=>'P1310_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>141
,p_validation=>'P1310_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1310_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(57852629105153100.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57932454307393997.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>151
,p_validation=>'P1310_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1310_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725945204229667146.4001)
,p_associated_item=>wwv_flow_api.id(57851384099153099.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(725947657473667158.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(725944806732667144.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(725948102099667160.4001)
,p_event_id=>wwv_flow_api.id(725947657473667158.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688506008357608718.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1310_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688506181417608719.4001)
,p_event_id=>wwv_flow_api.id(688506008357608718.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_ADMIN_PAGE_ID,P1310_ADMIN_PAGE_NAME,P1310_NAVLIST_OPTIONS,P1310_TAB_OPTIONS,P1310_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688506450037608722.4001)
,p_event_id=>wwv_flow_api.id(688506008357608718.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688506272493608720.4001)
,p_event_id=>wwv_flow_api.id(688506008357608718.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688506329171608721.4001)
,p_event_id=>wwv_flow_api.id(688506008357608718.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_ADMIN_PAGE_ID,P1310_ADMIN_PAGE_NAME,P1310_NAVLIST_OPTIONS,P1310_TAB_OPTIONS,P1310_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766865982368431.4001)
,p_event_id=>wwv_flow_api.id(688506008357608718.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766973344368432.4001)
,p_event_id=>wwv_flow_api.id(688506008357608718.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57892622623296391.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57893060748296393.4001)
,p_event_id=>wwv_flow_api.id(57892622623296391.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_ENTRY_NAME,P1310_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1310_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1310_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57895673839302787.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TAB_OPTIONS'
,p_condition_element=>'P1310_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57896046343302788.4001)
,p_event_id=>wwv_flow_api.id(57895673839302787.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_SET,P1310_TAB_LABEL,P1310_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768630210368449.4001)
,p_event_id=>wwv_flow_api.id(57895673839302787.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(117506863394569405.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57897241787304815.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TAB_OPTIONS'
,p_condition_element=>'P1310_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57897689348304816.4001)
,p_event_id=>wwv_flow_api.id(57897241787304815.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_SET,P1310_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57898147773304819.4001)
,p_event_id=>wwv_flow_api.id(57897241787304815.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768734085368450.4001)
,p_event_id=>wwv_flow_api.id(57897241787304815.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(117506863394569405.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57898750786306363.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TAB_OPTIONS'
,p_condition_element=>'P1310_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57899173336306366.4001)
,p_event_id=>wwv_flow_api.id(57898750786306363.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_SET,P1310_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57899616494306366.4001)
,p_event_id=>wwv_flow_api.id(57898750786306363.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100574310072284401.4001)
,p_event_id=>wwv_flow_api.id(57898750786306363.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(117506863394569405.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57900043912308424.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_NAVLIST_OPTIONS'
,p_condition_element=>'P1310_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57900406198308425.4001)
,p_event_id=>wwv_flow_api.id(57900043912308424.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_ENTRY_NAME,P1310_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57900914267308425.4001)
,p_event_id=>wwv_flow_api.id(57900043912308424.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_ENTRY_NAME,P1310_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57901361679309862.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_NAVLIST_OPTIONS'
,p_condition_element=>'P1310_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57901741829309862.4001)
,p_event_id=>wwv_flow_api.id(57901361679309862.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57902296922309863.4001)
,p_event_id=>wwv_flow_api.id(57901361679309862.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(725946878775667156.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create activity report feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1310_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1310_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1310_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1310_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1310_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1310_TAB_SET;',
'    l_admin_page.tab_name                    := :P1310_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1310_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1310_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P1310_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1310_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1310_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1310_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_activity_rpt(',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_starting_page_id         => :P1310_STARTING_PAGE_ID,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        p_group_id                 => :P1310_GROUP_ID,',
'        p_auth_scheme_id           => :P1310_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina de conexi\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(725947242002667158.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(725945204229667146.4001)
,p_process_success_message=>unistr('P\00E1ginas de funci\00F3n creadas.')
);
end;
/
prompt --application/pages/page_01311
begin
wwv_flow_api.create_page(
 p_id=>1311.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1gina Opciones de configuraci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1gina Opciones de configuraci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(175455605188021464.4001)
,p_plug_name=>'Crear Separador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>80
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(175455016618021462.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(175455605188021464.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1311_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57953519211452065.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57952315539452064.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57952794285452065.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57953176559452065.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1484850213243557971.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite a los administradores de la aplicaci\00F3n activar o desactivar una funcionalidad espec\00EDfica en la aplicaci\00F3n. Esta funci\00F3n es \00FAtil si se seleccionan funciones que requieren realizar tareas de desarrollo adicionales antes de que las puedan utiliz')
||'ar los usuarios finales.<br>',
unistr('Esta funci\00F3n tambi\00E9n se puede ampliar a funciones espec\00EDficas de la aplicaci\00F3n. Si los desarrolladores definen m\00E1s opciones de creaci\00F3n y las asocian a una funcionalidad espec\00EDfica de la aplicaci\00F3n, se pueden agregar a los valores de configuraci\00F3n pa')
||'ra los administradores. '))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1496502698135735198.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3833711597190819143.4001)
,p_plug_name=>'Opciones Admin'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725968183767759694.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1496502698135735198.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725968532713759695.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1496502698135735198.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(725968925563759695.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1496502698135735198.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(725971942192759705.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(725968183767759694.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(725972790096759706.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(725968925563759695.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57940639200441461.4001)
,p_name=>'P1311_GROUP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1484850213243557971.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57945850496450722.4001)
,p_name=>'P1311_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3833711597190819143.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n, a la que se ha agregado una lista, para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57946249248450723.4001)
,p_name=>'P1311_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3833711597190819143.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 100, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57947137375450723.4001)
,p_name=>'P1311_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3833711597190819143.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57947589907450724.4001)
,p_name=>'P1311_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3833711597190819143.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que se utiliza como p\00E1gina de administraci\00F3n en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57948402962452058.4001)
,p_name=>'P1311_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(175455605188021464.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57949397235452061.4001)
,p_name=>'P1311_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(175455605188021464.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57950200490452062.4001)
,p_name=>'P1311_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(175455605188021464.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57951181711452062.4001)
,p_name=>'P1311_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(175455605188021464.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1311_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P1311_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57954288923453413.4001)
,p_name=>'P1311_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57955152212453417.4001)
,p_name=>'P1311_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57955509258453417.4001)
,p_name=>'P1311_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57956480050453417.4001)
,p_name=>'P1311_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57957333505453418.4001)
,p_name=>'P1311_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P1311_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57958190651453419.4001)
,p_name=>'P1311_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1095293779404379332.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1311_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98082697095531901.4001)
,p_name=>'P1311_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3833711597190819143.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguno -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de autorizaci\00F3n que se va a utilizar para limitar el acceso de la p\00E1gina de administraci\00F3n y la p\00E1gina de la funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183306074030824890.4001)
,p_name=>'P1311_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(1484850213243557971.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.CONFIGURATION_OPTIONS'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(725966072267759691.4001)
,p_name=>'P1311_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1484850213243557971.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 10, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(725966936213759693.4001)
,p_name=>'P1311_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1484850213243557971.4001)
,p_item_default=>'wwv_flow_lang.system_message(''APEX.PAGE_NAME.CONFIGURATION_OPTIONS'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un nombre para la p\00E1gina de funci\00F3n.'),
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(725969424188759697.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57827613559033909.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1311_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(725969802989759697.4001)
,p_validation_name=>'P1311_PAGE_ID positive, whole number'
,p_validation_sequence=>21
,p_validation=>'P1311_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(725966072267759691.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57973882456510114.4001)
,p_validation_name=>'P1311_PAGE_ID reserved'
,p_validation_sequence=>31
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1311_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1311_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(725966072267759691.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827744200033910.4001)
,p_validation_name=>'P1311_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>41
,p_validation=>'P1311_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57946249248450723.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827833382033911.4001)
,p_validation_name=>'P1311_ADMIN_PAGE_ID not null'
,p_validation_sequence=>51
,p_validation=>'P1311_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57946249248450723.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57827968640033912.4001)
,p_validation_name=>'P1311_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>61
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1311_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1311_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1311_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57946249248450723.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57974729385525116.4001)
,p_validation_name=>'P1311_PAGE_ID and P1311_ADMIN_PAGE_ID different'
,p_validation_sequence=>71
,p_validation=>':P1311_PAGE_ID <> :P1311_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina inicial y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828044521033913.4001)
,p_validation_name=>'P1311_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>81
,p_validation=>'P1311_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57947137375450723.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828108676033914.4001)
,p_validation_name=>'P1311_EXISTING_PAGE not null'
,p_validation_sequence=>91
,p_validation=>'P1311_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57947589907450724.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235672067631481561.4001)
,p_validation_name=>'P1311_EXISTING_PAGE available'
,p_validation_sequence=>101
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1311_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1311_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1311_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57947589907450724.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828216769033915.4001)
,p_validation_name=>'P1311_TAB_SET not null'
,p_validation_sequence=>111
,p_validation=>'P1311_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57949397235452061.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828353861033916.4001)
,p_validation_name=>'P1311_TAB_LABEL not null'
,p_validation_sequence=>121
,p_validation=>'P1311_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57950200490452062.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828420931033917.4001)
,p_validation_name=>'P1311_TAB_NAME not null'
,p_validation_sequence=>131
,p_validation=>'P1311_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57951181711452062.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57981643779564523.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>141
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1311_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1311_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57954288923453413.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57828540910033918.4001)
,p_validation_name=>'P1311_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>151
,p_validation=>'P1311_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1311_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57955509258453417.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57981957151565841.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>161
,p_validation=>'P1311_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1311_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(725968532713759695.4001)
,p_associated_item=>wwv_flow_api.id(57954288923453413.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(725970982994759701.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(725968183767759694.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(725971403928759701.4001)
,p_event_id=>wwv_flow_api.id(725970982994759701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57959165537463346.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1311_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57959547648463347.4001)
,p_event_id=>wwv_flow_api.id(57959165537463346.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_ADMIN_PAGE_ID,P1311_ADMIN_PAGE_NAME,P1311_NAVLIST_OPTIONS,P1311_TAB_OPTIONS,P1311_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57961010285463348.4001)
,p_event_id=>wwv_flow_api.id(57959165537463346.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57960044425463347.4001)
,p_event_id=>wwv_flow_api.id(57959165537463346.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57960517728463347.4001)
,p_event_id=>wwv_flow_api.id(57959165537463346.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_ADMIN_PAGE_ID,P1311_ADMIN_PAGE_NAME,P1311_NAVLIST_OPTIONS,P1311_TAB_OPTIONS,P1311_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766685742368429.4001)
,p_event_id=>wwv_flow_api.id(57959165537463346.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766770619368430.4001)
,p_event_id=>wwv_flow_api.id(57959165537463346.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57961477486465370.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57961888433465371.4001)
,p_event_id=>wwv_flow_api.id(57961477486465370.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_ENTRY_NAME,P1311_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1311_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1311_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57962464171467502.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_TAB_OPTIONS'
,p_condition_element=>'P1311_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57962803728467503.4001)
,p_event_id=>wwv_flow_api.id(57962464171467502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_SET,P1311_TAB_LABEL,P1311_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768389108368446.4001)
,p_event_id=>wwv_flow_api.id(57962464171467502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(175455016618021462.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57963213460469214.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_TAB_OPTIONS'
,p_condition_element=>'P1311_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57963682376469214.4001)
,p_event_id=>wwv_flow_api.id(57963213460469214.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_SET,P1311_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57964108652469214.4001)
,p_event_id=>wwv_flow_api.id(57963213460469214.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768441731368447.4001)
,p_event_id=>wwv_flow_api.id(57963213460469214.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(175455016618021462.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57964760647470703.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_TAB_OPTIONS'
,p_condition_element=>'P1311_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57965145620470703.4001)
,p_event_id=>wwv_flow_api.id(57964760647470703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_SET,P1311_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57965637287470704.4001)
,p_event_id=>wwv_flow_api.id(57964760647470703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768556655368448.4001)
,p_event_id=>wwv_flow_api.id(57964760647470703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(175455016618021462.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57966059286472616.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_NAVLIST_OPTIONS'
,p_condition_element=>'P1311_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57966430023472616.4001)
,p_event_id=>wwv_flow_api.id(57966059286472616.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_ENTRY_NAME,P1311_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57966976523472616.4001)
,p_event_id=>wwv_flow_api.id(57966059286472616.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_ENTRY_NAME,P1311_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(57967375011474799.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_NAVLIST_OPTIONS'
,p_condition_element=>'P1311_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57967742665474800.4001)
,p_event_id=>wwv_flow_api.id(57967375011474799.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57968220379474800.4001)
,p_event_id=>wwv_flow_api.id(57967375011474799.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(725970143592759700.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create configuration feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1311_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1311_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1311_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1311_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1311_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1311_TAB_SET;',
'    l_admin_page.tab_name                    := :P1311_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1311_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1311_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P1311_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1311_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1311_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1311_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_configuration(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P1311_PAGE_ID,',
'        p_page_name                  => :P1311_NAME,',
'        p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'        p_group_id                   => :P1311_GROUP_ID,',
'        p_auth_scheme_id             => :P1311_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page                 => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina de conexi\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(725970550953759700.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(725968532713759695.4001)
,p_process_success_message=>unistr('P\00E1gina Funci\00F3n creada.')
);
end;
/
prompt --application/pages/page_01312
begin
wwv_flow_api.create_page(
 p_id=>1312.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1gina Selecci\00F3n de estilo de tema')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1gina Selecci\00F3n de estilo de tema')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(233497677400063868.4001)
,p_plug_name=>'Crear Separador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>80
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(233497088830063866.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(233497677400063868.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1312_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58047447581042409.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58046201219042408.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58046652869042408.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(58047025837042408.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2212130901624527116.4001)
,p_plug_name=>unistr('Crear p\00E1gina de estilo de tema')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Permite a los administradores seleccionar un esquema de color (estilo de tema) por defecto para la aplicaci\00F3n. Los administradores tambi\00E9n pueden elegir si permitir a los usuarios finales seleccionar su propio estilo de tema. Los usuarios finales pue')
||unistr('den simplemente hacer clic en el bot\00F3n Personalizar que aparece en la parte inferior de la p\00E1gina inicial y seleccionar uno de los estilos de tema disponibles. Por ejemplo, los usuarios con discapacidad visual tal vez prefieran utilizar el estilo de ')
||'tema Vista, que tiene un contraste de color mucho mayor.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2223783386516704343.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3891751001453859884.4001)
,p_plug_name=>'Opciones Admin'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(727283456825969155.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2223783386516704343.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(727283838280969156.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2223783386516704343.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(727284206876969156.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2223783386516704343.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(727287216593969161.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(727283456825969155.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(727288010733969161.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(727284206876969156.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58037866782038434.4001)
,p_name=>'P1312_GROUP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2212130901624527116.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58039702853040742.4001)
,p_name=>'P1312_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3891751001453859884.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n, a la que se ha agregado una lista, para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58040195920040742.4001)
,p_name=>'P1312_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3891751001453859884.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 100, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58041087428040747.4001)
,p_name=>'P1312_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3891751001453859884.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58041423801040747.4001)
,p_name=>'P1312_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3891751001453859884.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que se utiliza como p\00E1gina de administraci\00F3n en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58042379158042405.4001)
,p_name=>'P1312_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(233497677400063868.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58043207170042406.4001)
,p_name=>'P1312_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(233497677400063868.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58044132387042406.4001)
,p_name=>'P1312_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(233497677400063868.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58045087574042407.4001)
,p_name=>'P1312_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(233497677400063868.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1312_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P1312_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58048125152043535.4001)
,p_name=>'P1312_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58049028696043536.4001)
,p_name=>'P1312_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58049449811043536.4001)
,p_name=>'P1312_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58050368217043540.4001)
,p_name=>'P1312_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58051218725043541.4001)
,p_name=>'P1312_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P1312_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58052146949043542.4001)
,p_name=>'P1312_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1153341591174422866.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1312_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130095148505362875.4001)
,p_name=>'P1312_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3891751001453859884.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguno -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de autorizaci\00F3n que se va a utilizar para limitar el acceso a la p\00E1gina de administraci\00F3n y a la p\00E1gina de la funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183321432256945121.4001)
,p_name=>'P1312_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2212130901624527116.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.THEME_STYLE_SELECTION'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(727281388437969153.4001)
,p_name=>'P1312_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2212130901624527116.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 10, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(727282298700969154.4001)
,p_name=>'P1312_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2212130901624527116.4001)
,p_item_default=>'wwv_flow_lang.system_message(''APEX.PAGE_NAME.THEME_STYLE_SELECTION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un nombre para la p\00E1gina de funci\00F3n.'),
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(727284779158969158.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(57829560956033928.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1312_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(727285131292969158.4001)
,p_validation_name=>'P1312_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P1312_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(727281388437969153.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58077174040062073.4001)
,p_validation_name=>'P1312_PAGE_ID reserved'
,p_validation_sequence=>21
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1312_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1312_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(727281388437969153.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829615819033929.4001)
,p_validation_name=>'P1312_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>41
,p_validation=>'P1312_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58040195920040742.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829895326033931.4001)
,p_validation_name=>'P1312_ADMIN_PAGE_ID not null'
,p_validation_sequence=>51
,p_validation=>'P1312_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58040195920040742.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829736831033930.4001)
,p_validation_name=>'P1312_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>71
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1312_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1312_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1312_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58040195920040742.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58077451901064593.4001)
,p_validation_name=>'P1312_PAGE_ID and P1312_ADMIN_PAGE_ID different'
,p_validation_sequence=>81
,p_validation=>':P1312_PAGE_ID <> :P1312_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(290807415682640034.4001)
,p_validation_name=>'P1312_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>91
,p_validation=>'P1312_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57829963157033932.4001)
,p_validation_name=>'P1312_EXISTING_PAGE not null'
,p_validation_sequence=>101
,p_validation=>'P1312_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58041423801040747.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235674976042492981.4001)
,p_validation_name=>'P1312_EXISTING_PAGE available'
,p_validation_sequence=>111
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1312_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1312_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1312_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58041423801040747.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57830063242033933.4001)
,p_validation_name=>'P1312_TAB_SET not null'
,p_validation_sequence=>121
,p_validation=>'P1312_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58043207170042406.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57830115124033934.4001)
,p_validation_name=>'P1312_TAB_LABEL not null'
,p_validation_sequence=>131
,p_validation=>'P1312_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58044132387042406.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57830213244033935.4001)
,p_validation_name=>'P1312_TAB_NAME not null'
,p_validation_sequence=>141
,p_validation=>'P1312_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58045087574042407.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58077765156066498.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>151
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1312_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1312_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58048125152043535.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(57830314642033936.4001)
,p_validation_name=>'P1312_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>161
,p_validation=>'P1312_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1312_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58049449811043536.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(58078082658067939.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>171
,p_validation=>'P1312_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1312_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(727283838280969156.4001)
,p_associated_item=>wwv_flow_api.id(58048125152043535.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(727286261525969160.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(727283456825969155.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(727286759939969160.4001)
,p_event_id=>wwv_flow_api.id(727286261525969160.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58053517721048933.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1312_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58053958404048933.4001)
,p_event_id=>wwv_flow_api.id(58053517721048933.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_ADMIN_PAGE_ID,P1312_ADMIN_PAGE_NAME,P1312_NAVLIST_OPTIONS,P1312_TAB_OPTIONS,P1312_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58055423042048934.4001)
,p_event_id=>wwv_flow_api.id(58053517721048933.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58054460362048934.4001)
,p_event_id=>wwv_flow_api.id(58053517721048933.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58054975835048934.4001)
,p_event_id=>wwv_flow_api.id(58053517721048933.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_ADMIN_PAGE_ID,P1312_ADMIN_PAGE_NAME,P1312_NAVLIST_OPTIONS,P1312_TAB_OPTIONS,P1312_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57830565327033938.4001)
,p_event_id=>wwv_flow_api.id(58053517721048933.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(57830488084033937.4001)
,p_event_id=>wwv_flow_api.id(58053517721048933.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58069687584050435.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58070004902050436.4001)
,p_event_id=>wwv_flow_api.id(58069687584050435.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_ENTRY_NAME,P1312_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1312_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1312_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58070879694052138.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_TAB_OPTIONS'
,p_condition_element=>'P1312_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58071255668052138.4001)
,p_event_id=>wwv_flow_api.id(58070879694052138.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_SET,P1312_TAB_LABEL,P1312_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768048691368443.4001)
,p_event_id=>wwv_flow_api.id(58070879694052138.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(233497088830063866.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58071675265053432.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_TAB_OPTIONS'
,p_condition_element=>'P1312_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58072090847053432.4001)
,p_event_id=>wwv_flow_api.id(58071675265053432.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_SET,P1312_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58072531177053432.4001)
,p_event_id=>wwv_flow_api.id(58071675265053432.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768148485368444.4001)
,p_event_id=>wwv_flow_api.id(58071675265053432.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(233497088830063866.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58072919646054904.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_TAB_OPTIONS'
,p_condition_element=>'P1312_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58073384604054905.4001)
,p_event_id=>wwv_flow_api.id(58072919646054904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_SET,P1312_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58073855254054905.4001)
,p_event_id=>wwv_flow_api.id(58072919646054904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775768205215368445.4001)
,p_event_id=>wwv_flow_api.id(58072919646054904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(233497088830063866.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58074328977056549.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_NAVLIST_OPTIONS'
,p_condition_element=>'P1312_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58074761708056549.4001)
,p_event_id=>wwv_flow_api.id(58074328977056549.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_ENTRY_NAME,P1312_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58075289656056552.4001)
,p_event_id=>wwv_flow_api.id(58074328977056549.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_ENTRY_NAME,P1312_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(58075705488057960.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_NAVLIST_OPTIONS'
,p_condition_element=>'P1312_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58076113928057960.4001)
,p_event_id=>wwv_flow_api.id(58075705488057960.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(58076642967057960.4001)
,p_event_id=>wwv_flow_api.id(58075705488057960.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(727285430453969159.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create theme style feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1312_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1312_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1312_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1312_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1312_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1312_TAB_SET;',
'    l_admin_page.tab_name                    := :P1312_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1312_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1312_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P1312_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1312_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1312_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1312_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_theme_style(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P1312_PAGE_ID,',
'        p_page_name                  => :P1312_NAME,',
'        p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'        p_group_id                   => :P1312_GROUP_ID,',
'        p_auth_scheme_id             => :P1312_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page                 => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina de conexi\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(727285898477969159.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina Funci\00F3n creada.')
);
end;
/
prompt --application/pages/page_01313
begin
wwv_flow_api.create_page(
 p_id=>1313.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1gina Acerca de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1gina Acerca de')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_plug_name=>unistr('Crear p\00E1gina Acerca de')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Incluya una p\00E1gina Acerca de esta aplicaci\00F3n, que incorpore una descripci\00F3n de la aplicaci\00F3n, la versi\00F3n de la aplicaci\00F3n y un recuento de p\00E1ginas.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2951228059617727064.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(727447497665022723.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2951228059617727064.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(727447816157022725.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2951228059617727064.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(727448206474022725.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2951228059617727064.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(727451628069022728.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(727447816157022725.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(727451251429022728.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(727447497665022723.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(727452093442022728.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(727448206474022725.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57831086038033943.4001)
,p_name=>'P1313_BUILD_OPTION'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.ABOUT_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Las opciones de creaci\00F3n mostradas se crear\00E1n para soportar esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58029539721963290.4001)
,p_name=>'P1313_NAV_BAR_ENTRY'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_prompt=>unistr('Etiqueta de Barra de Navegaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la nueva entrada de la barra de navegaci\00F3n utilizada para acceder a la nueva p\00E1gina Acerca de.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(58030363964966516.4001)
,p_name=>'P1313_PAGE_GROUP'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(688504922919608707.4001)
,p_name=>'P1313_INCLUDE_NAV_BAR'
,p_is_required=>true
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('\00BFIncluir en barra de navegaci\00F3n?')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione <strong>Activado</strong> para crear una entrada de la barra de navegaci\00F3n en la aplicaci\00F3n actual para llamar a la nueva p\00E1gina Acerca de.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(727445370563022722.4001)
,p_name=>'P1313_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina que se puede dividir entre 10, que es mayor que el n\00FAmero de p\00E1gina m\00E1ximo en esta aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(727446261435022722.4001)
,p_name=>'P1313_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2939575574725549837.4001)
,p_item_default=>'wwv_flow_lang.system_message(''APEX.PAGE_NAME.ABOUT_THIS_APP'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique un nombre para la p\00E1gina.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(727448708057022725.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(727449147120022726.4001)
,p_validation_name=>'P1313_PAGE_ID positive, whole number'
,p_validation_sequence=>20
,p_validation=>'P1313_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(727447816157022725.4001)
,p_associated_item=>wwv_flow_api.id(727445370563022722.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(42006414364842992.4001)
,p_validation_name=>'P1313_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1313_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1313_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(727447816157022725.4001)
,p_associated_item=>wwv_flow_api.id(727445370563022722.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(727450286164022727.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(727447497665022723.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(727450704769022727.4001)
,p_event_id=>wwv_flow_api.id(727450286164022727.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3775766195821368424.4001)
,p_name=>'Show / Hide Nav Bar Entry'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1313_INCLUDE_NAV_BAR'
,p_condition_element=>'P1313_INCLUDE_NAV_BAR'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766231701368425.4001)
,p_event_id=>wwv_flow_api.id(3775766195821368424.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1313_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766348795368426.4001)
,p_event_id=>wwv_flow_api.id(3775766195821368424.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1313_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3775766457731368427.4001)
,p_name=>'Set Nav Bar Entry'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1313_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775766594596368428.4001)
,p_event_id=>wwv_flow_api.id(3775766457731368427.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1313_NAV_BAR_ENTRY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1313_NAME'
,p_attribute_07=>'P1313_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(727449482983022726.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_feature_v3.add_feature_about_page(',
'    p_app_id                   => :FB_FLOW_ID,',
'    p_page_id                  => :P1313_PAGE_ID,',
'    p_name                     => :P1313_NAME,',
'    p_group_id                 => :P1313_PAGE_GROUP,',
'    p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'    --',
'    p_create_nav_bar_entry     => ( :P1313_INCLUDE_NAV_BAR = ''Y'' ),',
'    p_nav_bar_entry_label      => :P1313_NAV_BAR_ENTRY );',
'    ',
':FB_FLOW_PAGE_ID       := :P1313_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P1313_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Se ha creado la p\00E1gina &P1313_PAGE_ID.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(727449812755022726.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('P\00E1gina Funci\00F3n creada.')
);
end;
/
prompt --application/pages/page_01314
begin
wwv_flow_api.create_page(
 p_id=>1314.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1gina Informes de correo electr\00F3nico')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1gina Informes de correo electr\00F3nico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(214194682349417261.4001)
,p_plug_name=>'Crear Separador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(214194093779417259.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(214194682349417261.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1314_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96699085843847887.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96697831897847886.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96698274674847886.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96698652798847886.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(855572135817646137.4001)
,p_plug_name=>unistr('Crear p\00E1gina Informes de correo electr\00F3nico')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Incluya numerosos informes sobre correos electr\00F3nicos en cola de esta aplicaci\00F3n, correos electr\00F3nicos enviados y correos electr\00F3nicos de env\00EDo de errores.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(867224620709823364.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3872453232608216277.4001)
,p_plug_name=>'Opciones Admin'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(96692407707847877.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(867224620709823364.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(96692887646847878.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(867224620709823364.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(96693205214847879.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(867224620709823364.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96723627959847908.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(96692407707847877.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96724051314847908.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(96693205214847879.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96687930854847870.4001)
,p_name=>'P1314_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3872453232608216277.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n (a la que se agrega una lista) para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96688364159847871.4001)
,p_name=>'P1314_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3872453232608216277.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina disponible que se puede dividir entre 100, superior al n\00FAmero de p\00E1gina m\00E1ximo de la aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96689210952847872.4001)
,p_name=>'P1314_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3872453232608216277.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96689608753847872.4001)
,p_name=>'P1314_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3872453232608216277.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que utilizar como p\00E1gina de administraci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96690396693847876.4001)
,p_name=>'P1314_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(855572135817646137.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina sin utilizar.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina disponible que se puede dividir entre 10, superior al n\00FAmero de p\00E1gina m\00E1ximo de la aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96691214064847876.4001)
,p_name=>'P1314_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(855572135817646137.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96693976141847880.4001)
,p_name=>'P1314_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(214194682349417261.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en los separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96694800011847880.4001)
,p_name=>'P1314_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(214194682349417261.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96695721325847881.4001)
,p_name=>'P1314_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(214194682349417261.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96696692489847882.4001)
,p_name=>'P1314_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(214194682349417261.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1314_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P1314_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96699730934847887.4001)
,p_name=>'P1314_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96700651138847888.4001)
,p_name=>'P1314_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96701089663847888.4001)
,p_name=>'P1314_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96701954235847889.4001)
,p_name=>'P1314_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96702877554847889.4001)
,p_name=>'P1314_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P1314_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96703763223847890.4001)
,p_name=>'P1314_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1134027105397773773.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1314_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98081774597529028.4001)
,p_name=>'P1314_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3872453232608216277.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguno -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de autorizaci\00F3n que se va a utilizar para limitar el acceso de la p\00E1gina de administraci\00F3n y las p\00E1ginas de la funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(234206014974800339.4001)
,p_name=>'P1314_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(855572135817646137.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.EMAIL_REPORT'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(96705128780847897.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(96704744621847897.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1314_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96709551441847900.4001)
,p_validation_name=>'P1314_PAGE_ID positive, whole number'
,p_validation_sequence=>20
,p_validation=>'P1314_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96690396693847876.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96710760538847900.4001)
,p_validation_name=>'P1314_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1314_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1314_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96690396693847876.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96708348929847899.4001)
,p_validation_name=>'P1314_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>40
,p_validation=>'P1314_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96688364159847871.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96709956939847900.4001)
,p_validation_name=>'P1314_ADMIN_PAGE_ID not null'
,p_validation_sequence=>50
,p_validation=>'P1314_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96689210952847872.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96710378935847900.4001)
,p_validation_name=>'P1314_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1314_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1314_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1314_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96688364159847871.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96709120419847899.4001)
,p_validation_name=>'P1314_PAGE_ID and P1314_ADMIN_PAGE_ID different'
,p_validation_sequence=>70
,p_validation=>':P1314_PAGE_ID <> :P1314_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina inicial y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96707982126847899.4001)
,p_validation_name=>'P1314_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>80
,p_validation=>'P1314_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96689210952847872.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96708762070847899.4001)
,p_validation_name=>'P1314_EXISTING_PAGE not null'
,p_validation_sequence=>90
,p_validation=>'P1314_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96689608753847872.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235676931256502841.4001)
,p_validation_name=>'P1314_EXISTING_PAGE available'
,p_validation_sequence=>100
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1314_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1314_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1314_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96689608753847872.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96705531993847897.4001)
,p_validation_name=>'P1314_TAB_SET not null'
,p_validation_sequence=>110
,p_validation=>'P1314_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96694800011847880.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96705979309847898.4001)
,p_validation_name=>'P1314_TAB_LABEL not null'
,p_validation_sequence=>120
,p_validation=>'P1314_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96695721325847881.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96706320181847898.4001)
,p_validation_name=>'P1314_TAB_NAME not null'
,p_validation_sequence=>130
,p_validation=>'P1314_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96696692489847882.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96707151229847898.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1314_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1314_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96699730934847887.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96706752755847898.4001)
,p_validation_name=>'P1314_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>150
,p_validation=>'P1314_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1314_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96701089663847888.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96707564692847899.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>160
,p_validation=>'P1314_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1314_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96692887646847878.4001)
,p_associated_item=>wwv_flow_api.id(96699730934847887.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96713252979847903.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(96692407707847877.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96713749279847903.4001)
,p_event_id=>wwv_flow_api.id(96713252979847903.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96714164241847903.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1314_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96714619579847903.4001)
,p_event_id=>wwv_flow_api.id(96714164241847903.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_ADMIN_PAGE_ID,P1314_ADMIN_PAGE_NAME,P1314_NAVLIST_OPTIONS,P1314_TAB_OPTIONS,P1314_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96716135795847904.4001)
,p_event_id=>wwv_flow_api.id(96714164241847903.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96715171882847904.4001)
,p_event_id=>wwv_flow_api.id(96714164241847903.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96715613814847904.4001)
,p_event_id=>wwv_flow_api.id(96714164241847903.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_ADMIN_PAGE_ID,P1314_ADMIN_PAGE_NAME,P1314_NAVLIST_OPTIONS,P1314_TAB_OPTIONS,P1314_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96716653564847904.4001)
,p_event_id=>wwv_flow_api.id(96714164241847903.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96717109444847905.4001)
,p_event_id=>wwv_flow_api.id(96714164241847903.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96717524158847905.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96718082956847905.4001)
,p_event_id=>wwv_flow_api.id(96717524158847905.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_ENTRY_NAME,P1314_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1314_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1314_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96718413125847905.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_TAB_OPTIONS'
,p_condition_element=>'P1314_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96718959554847906.4001)
,p_event_id=>wwv_flow_api.id(96718413125847905.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_SET,P1314_TAB_LABEL,P1314_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767731503368440.4001)
,p_event_id=>wwv_flow_api.id(96718413125847905.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(214194093779417259.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96711806440847901.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_TAB_OPTIONS'
,p_condition_element=>'P1314_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96712305784847902.4001)
,p_event_id=>wwv_flow_api.id(96711806440847901.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_SET,P1314_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96712864909847903.4001)
,p_event_id=>wwv_flow_api.id(96711806440847901.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767850041368441.4001)
,p_event_id=>wwv_flow_api.id(96711806440847901.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(214194093779417259.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96719338813847906.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_TAB_OPTIONS'
,p_condition_element=>'P1314_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96719883918847906.4001)
,p_event_id=>wwv_flow_api.id(96719338813847906.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_SET,P1314_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96720343552847906.4001)
,p_event_id=>wwv_flow_api.id(96719338813847906.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767989151368442.4001)
,p_event_id=>wwv_flow_api.id(96719338813847906.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(214194093779417259.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96720781040847906.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_NAVLIST_OPTIONS'
,p_condition_element=>'P1314_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96721218721847907.4001)
,p_event_id=>wwv_flow_api.id(96720781040847906.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_ENTRY_NAME,P1314_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96721728161847907.4001)
,p_event_id=>wwv_flow_api.id(96720781040847906.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_ENTRY_NAME,P1314_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96722145237847907.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_NAVLIST_OPTIONS'
,p_condition_element=>'P1314_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96722607752847907.4001)
,p_event_id=>wwv_flow_api.id(96722145237847907.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96723195870847908.4001)
,p_event_id=>wwv_flow_api.id(96722145237847907.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(305244353579023870.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set proper values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1314_ADMIN_PAGE_OPTION = ''EXISTING'' then',
'   :P1314_ADMIN_PAGE_ID   := null;',
'   :P1314_ADMIN_PAGE_NAME := null;',
'end if;',
'',
'-- NONE',
'if nvl(:P1314_TAB_OPTIONS,0) = 0 then',
'   :P1314_TAB_SET   := null;',
'   :P1314_TAB_LABEL := null;',
'   :P1314_TAB_NAME  := null;',
'-- NEW TAB ',
'elsif :P1314_TAB_OPTIONS = 1 then',
'   :P1314_TAB_NAME  := null;',
'-- EXISTING TAB',
'elsif :P1314_TAB_OPTIONS = 2 then',
'   :P1314_TAB_LABEL := null;',
'end if;',
'',
'if nvl(:P1314_NAVLIST_OPTIONS,''NONE'') = ''NONE'' then',
'   :P1314_NAVLIST_ID         := null;',
'   :P1314_NAVLIST_ENTRY_NAME := null;',
'   :P1314_NAVLIST_PARENT_ID  := null;',
'   :P1314_NEW_PARENT_ID      := null;',
'   :P1314_EXISTING_PARENT_ID := null;',
'elsif :P1314_NAVLIST_OPTIONS = ''NEW'' then',
'   :P1314_NAVLIST_PARENT_ID  := null;',
'   :P1314_EXISTING_PARENT_ID := null;',
'elsif :P1314_NAVLIST_OPTIONS = '' EXISTING'' then',
'   :P1314_NAVLIST_ENTRY_NAME := null;',
'   :P1314_NAVLIST_PARENT_ID  := null;',
'   :P1314_NEW_PARENT_ID      := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(96692887646847878.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(96711032039847901.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1314_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1314_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1314_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1314_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1314_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1314_TAB_SET;',
'    l_admin_page.tab_name                    := :P1314_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1314_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1314_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P1314_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1314_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1314_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1314_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_email_monitor_page (',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_page_id                  => :P1314_PAGE_ID,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        p_group_id                 => :P1314_GROUP_ID,',
'        p_authorization_scheme     => :P1314_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(96692887646847878.4001)
,p_process_success_message=>unistr('P\00E1gina Informes de correo electr\00F3nico creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(96711475766847901.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(96692887646847878.4001)
,p_process_success_message=>unistr('P\00E1ginas de funci\00F3n creadas.')
);
end;
/
prompt --application/pages/page_01315
begin
wwv_flow_api.create_page(
 p_id=>1315.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear p\00E1ginas de informes de trabajo')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear p\00E1ginas de informes de trabajo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(310971007820289272.4001)
,p_plug_name=>'Crear Separador'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(310970419250289270.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(310971007820289272.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1315_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96788083238872024.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96786875261872023.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96787248621872023.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(96787646460872023.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(952348461288518148.4001)
,p_plug_name=>unistr('Crear p\00E1ginas de informe de trabajo')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Incluya informes sobre trabajos y detalles de ejecuci\00F3n de trabajos en el esquema asociado a esta aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(964000946180695375.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3969229558079088288.4001)
,p_plug_name=>'Opciones Admin'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(96781473344872019.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(964000946180695375.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(96781833745872019.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(964000946180695375.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(96782294745872020.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(964000946180695375.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96812683145872037.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(96781473344872019.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96813060514872037.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(96782294745872020.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96777062012872013.4001)
,p_name=>'P1315_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3969229558079088288.4001)
,p_item_default=>'EXISTING'
,p_prompt=>unistr('Preferencia de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(31963614629360602.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la p\00E1gina de administraci\00F3n (a la que se agrega una lista) para esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96777413170872014.4001)
,p_name=>'P1315_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3969229558079088288.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Administraci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina no utilizado para la p\00E1gina de administraci\00F3n.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina disponible que se puede dividir entre 100, superior al n\00FAmero de p\00E1gina m\00E1ximo de la aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96778359949872016.4001)
,p_name=>'P1315_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3969229558079088288.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de p\00E1gina Administraci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina de administraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96778704715872016.4001)
,p_name=>'P1315_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3969229558079088288.4001)
,p_prompt=>unistr('P\00E1gina Administraci\00F3n existente')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina existente que utilizar como p\00E1gina de administraci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96779455937872018.4001)
,p_name=>'P1315_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(952348461288518148.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('N\00FAmero de p\00E1gina inicial')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un n\00FAmero de p\00E1gina inicial no utilizado. Esta funci\00F3n crear\00E1 varias p\00E1ginas que comiencen con el n\00FAmero especificado.</p>'),
unistr('<p>El valor por defecto es el primer n\00FAmero de p\00E1gina disponible que se puede dividir entre 10, superior al n\00FAmero de p\00E1gina m\00E1ximo de la aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96780291717872018.4001)
,p_name=>'P1315_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(952348461288518148.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96782964110872020.4001)
,p_name=>'P1315_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(310971007820289272.4001)
,p_item_default=>'0'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Opciones de separador:')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si la p\00E1gina de administraci\00F3n se debe incluir en los separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96783864269872021.4001)
,p_name=>'P1315_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(310971007820289272.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96784790739872021.4001)
,p_name=>'P1315_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(310971007820289272.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96785664512872022.4001)
,p_name=>'P1315_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(310971007820289272.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1315_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P1315_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96788741619872024.4001)
,p_name=>'P1315_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('P\00E1gina Administraci\00F3n<br>Preferencia de navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96789697488872025.4001)
,p_name=>'P1315_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96790010129872025.4001)
,p_name=>'P1315_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96790957138872025.4001)
,p_name=>'P1315_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96791862924872026.4001)
,p_name=>'P1315_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P1315_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96792785030872026.4001)
,p_name=>'P1315_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1230803430868645784.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1315_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98076203074505870.4001)
,p_name=>'P1315_SCHEDULER_JOBS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(952348461288518148.4001)
,p_prompt=>'Trabajos'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select job_name d, job_name r',
'  from wwv_flow_jobs_dev',
' where owner = (select owner',
'                  from wwv_flows',
'                 where id = :FB_FLOW_ID',
'                   and security_group_id = :FLOW_SECURITY_GROUP_ID)',
' order by 1'))
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si se selecciona esta opci\00F3n, los informes resultantes se limitar\00E1n \00FAnicamente a los trabajos seleccionados. Si no se selecciona nada, se mostrar\00E1n todos los trabajos con el esquema de an\00E1lisis para la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98077141546505871.4001)
,p_name=>'P1315_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3969229558079088288.4001)
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguno -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el esquema de autorizaci\00F3n que se va a utilizar para limitar el acceso de la p\00E1gina de administraci\00F3n y las p\00E1ginas de la funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(234207917095803396.4001)
,p_name=>'P1315_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(952348461288518148.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.JOB_REPORT'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Con el fin de soportar esta funci\00F3n, se crear\00E1n las opciones de creaci\00F3n mostradas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(96794196789872027.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(96793759916872027.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1315_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96798551568872030.4001)
,p_validation_name=>'P1315_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>20
,p_validation=>'P1315_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96779455937872018.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96799743898872030.4001)
,p_validation_name=>'P1315_STARTING_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1315_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1315_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96779455937872018.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96797365501872029.4001)
,p_validation_name=>'P1315_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>40
,p_validation=>'P1315_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96777413170872014.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96798929833872030.4001)
,p_validation_name=>'P1315_ADMIN_PAGE_ID not null'
,p_validation_sequence=>50
,p_validation=>'P1315_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96778359949872016.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96799351988872030.4001)
,p_validation_name=>'P1315_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1315_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1315_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1315_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96777413170872014.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96798154709872030.4001)
,p_validation_name=>'P1315_STARTING_PAGE_ID and P1315_ADMIN_PAGE_ID different'
,p_validation_sequence=>70
,p_validation=>':P1315_STARTING_PAGE_ID <> :P1315_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de la p\00E1gina inicial y el n\00FAmero de la p\00E1gina Administraci\00F3n deben ser diferentes.')
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96796917097872029.4001)
,p_validation_name=>'P1315_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>80
,p_validation=>'P1315_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96778359949872016.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96797799030872029.4001)
,p_validation_name=>'P1315_EXISTING_PAGE not null'
,p_validation_sequence=>90
,p_validation=>'P1315_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96778704715872016.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235680040104517312.4001)
,p_validation_name=>'P1315_EXISTING_PAGE available'
,p_validation_sequence=>100
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1315_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es una p\00E1gina de la aplicaci\00F3n.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1315_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1315_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96778704715872016.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96794597583872028.4001)
,p_validation_name=>'P1315_TAB_SET not null'
,p_validation_sequence=>110
,p_validation=>'P1315_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96783864269872021.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96794908811872028.4001)
,p_validation_name=>'P1315_TAB_LABEL not null'
,p_validation_sequence=>120
,p_validation=>'P1315_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96784790739872021.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96795336201872028.4001)
,p_validation_name=>'P1315_TAB_NAME not null'
,p_validation_sequence=>130
,p_validation=>'P1315_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96785664512872022.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96796193727872029.4001)
,p_validation_name=>'Nav List with no list available'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P1315_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1315_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96788741619872024.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96795707760872028.4001)
,p_validation_name=>'P1315_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>150
,p_validation=>'P1315_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P1315_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96790010129872025.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(96796561972872029.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>160
,p_validation=>'P1315_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P1315_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(96781833745872019.4001)
,p_associated_item=>wwv_flow_api.id(96788741619872024.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96802214468872032.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(96781473344872019.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96802742487872032.4001)
,p_event_id=>wwv_flow_api.id(96802214468872032.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96803115438872032.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1315_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96803691701872033.4001)
,p_event_id=>wwv_flow_api.id(96803115438872032.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_ADMIN_PAGE_ID,P1315_ADMIN_PAGE_NAME,P1315_NAVLIST_OPTIONS,P1315_TAB_OPTIONS,P1315_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96805112746872033.4001)
,p_event_id=>wwv_flow_api.id(96803115438872032.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96804137611872033.4001)
,p_event_id=>wwv_flow_api.id(96803115438872032.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96804605196872033.4001)
,p_event_id=>wwv_flow_api.id(96803115438872032.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_ADMIN_PAGE_ID,P1315_ADMIN_PAGE_NAME,P1315_NAVLIST_OPTIONS,P1315_TAB_OPTIONS,P1315_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96805691249872034.4001)
,p_event_id=>wwv_flow_api.id(96803115438872032.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96806171616872034.4001)
,p_event_id=>wwv_flow_api.id(96803115438872032.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96806586684872034.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96807059995872034.4001)
,p_event_id=>wwv_flow_api.id(96806586684872034.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_ENTRY_NAME,P1315_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1315_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1315_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96807492402872034.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_TAB_OPTIONS'
,p_condition_element=>'P1315_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96807982319872035.4001)
,p_event_id=>wwv_flow_api.id(96807492402872034.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_SET,P1315_TAB_LABEL,P1315_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767445490368437.4001)
,p_event_id=>wwv_flow_api.id(96807492402872034.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(310970419250289270.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96800844122872031.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_TAB_OPTIONS'
,p_condition_element=>'P1315_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96801312849872031.4001)
,p_event_id=>wwv_flow_api.id(96800844122872031.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_SET,P1315_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96801846571872032.4001)
,p_event_id=>wwv_flow_api.id(96800844122872031.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767565619368438.4001)
,p_event_id=>wwv_flow_api.id(96800844122872031.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(310970419250289270.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96808354035872035.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_TAB_OPTIONS'
,p_condition_element=>'P1315_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96808850015872035.4001)
,p_event_id=>wwv_flow_api.id(96808354035872035.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_SET,P1315_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96809325523872035.4001)
,p_event_id=>wwv_flow_api.id(96808354035872035.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3775767612788368439.4001)
,p_event_id=>wwv_flow_api.id(96808354035872035.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(310970419250289270.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96809737251872035.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_NAVLIST_OPTIONS'
,p_condition_element=>'P1315_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96810297068872036.4001)
,p_event_id=>wwv_flow_api.id(96809737251872035.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_ENTRY_NAME,P1315_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96810758546872036.4001)
,p_event_id=>wwv_flow_api.id(96809737251872035.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_ENTRY_NAME,P1315_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(96811179588872036.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_NAVLIST_OPTIONS'
,p_condition_element=>'P1315_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96811624441872036.4001)
,p_event_id=>wwv_flow_api.id(96811179588872036.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(96812166000872037.4001)
,p_event_id=>wwv_flow_api.id(96811179588872036.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2440118531965605.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set proper values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1315_ADMIN_PAGE_OPTION = ''EXISTING'' then',
'   :P1315_ADMIN_PAGE_ID   := null;',
'   :P1315_ADMIN_PAGE_NAME := null;',
'end if;',
'',
'-- NONE',
'if nvl(:P1315_TAB_OPTIONS,0) = 0 then',
'   :P1315_TAB_SET   := null;',
'   :P1315_TAB_LABEL := null;',
'   :P1315_TAB_NAME  := null;',
'-- NEW TAB ',
'elsif :P1315_TAB_OPTIONS = 1 then',
'   :P1315_TAB_NAME  := null;',
'-- EXISTING TAB',
'elsif :P1315_TAB_OPTIONS = 2 then',
'   :P1315_TAB_LABEL := null;',
'end if;',
'',
'if nvl(:P1315_NAVLIST_OPTIONS,''NONE'') = ''NONE'' then',
'   :P1315_NAVLIST_ID         := null;',
'   :P1315_NAVLIST_ENTRY_NAME := null;',
'   :P1315_NAVLIST_PARENT_ID  := null;',
'   :P1315_NEW_PARENT_ID      := null;',
'   :P1315_EXISTING_PARENT_ID := null;',
'elsif :P1315_NAVLIST_OPTIONS = ''NEW'' then',
'   :P1315_NAVLIST_PARENT_ID  := null;',
'   :P1315_EXISTING_PARENT_ID := null;',
'elsif :P1315_NAVLIST_OPTIONS = '' EXISTING'' then',
'   :P1315_NAVLIST_ENTRY_NAME := null;',
'   :P1315_NAVLIST_PARENT_ID  := null;',
'   :P1315_NEW_PARENT_ID      := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(96781833745872019.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(96800012658872031.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1315_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1315_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1315_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1315_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1315_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1315_TAB_SET;',
'    l_admin_page.tab_name                    := :P1315_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1315_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1315_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P1315_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1315_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1315_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1315_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_job_monitoring (',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_starting_page_id         => :P1315_STARTING_PAGE_ID,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        p_group_id                 => :P1315_GROUP_ID,',
'        p_authorization_scheme     => :P1315_AUTHORIZATION_SCHEME,',
'        --',
'        p_job_list                 => :P1315_SCHEDULER_JOBS,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(96781833745872019.4001)
,p_process_success_message=>unistr('P\00E1ginas de informes de trabajo creadas.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(96800444570872031.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(96781833745872019.4001)
,p_process_success_message=>unistr('P\00E1ginas de funci\00F3n creadas.')
);
end;
/
prompt --application/pages/page_01316
begin
wwv_flow_api.create_page(
 p_id=>1316.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear advertencia de p\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear advertencia de p\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1078344169909827185.4001)
,p_plug_name=>'Compatibilidad de Temas'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta funci\00F3n requiere una aplicaci\00F3n basada en Tema universal. '),
unistr('Oracle recomienda actualizar a Tema universal. Para obtener m\00E1s informaci\00F3n, consulte la <a rel="noreferrer" href="https://apex.oracle.com/ut" target="_blank">aplicaci\00F3n Tema universal</a>.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1089996654802004412.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(126004204630309072.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1089996654802004412.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(126005099464309073.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1089996654802004412.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(126016999508309092.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126025518425309099.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(126004204630309072.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126026007238309100.4001)
,p_event_id=>wwv_flow_api.id(126025518425309099.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126026469218309100.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1316_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126026912614309100.4001)
,p_event_id=>wwv_flow_api.id(126026469218309100.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_ADMIN_PAGE_ID,P1316_ADMIN_PAGE_NAME,P1316_NAVLIST_OPTIONS,P1316_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126028455418309101.4001)
,p_event_id=>wwv_flow_api.id(126026469218309100.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126027414411309100.4001)
,p_event_id=>wwv_flow_api.id(126026469218309100.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126027972234309101.4001)
,p_event_id=>wwv_flow_api.id(126026469218309100.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_ADMIN_PAGE_ID,P1316_ADMIN_PAGE_NAME,P1316_NAVLIST_OPTIONS,P1316_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126028951250309101.4001)
,p_event_id=>wwv_flow_api.id(126026469218309100.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126029440125309101.4001)
,p_event_id=>wwv_flow_api.id(126026469218309100.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126029836496309102.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126030346144309102.4001)
,p_event_id=>wwv_flow_api.id(126029836496309102.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_ENTRY_NAME,P1316_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1316_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1316_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126030794807309102.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_TAB_OPTIONS'
,p_condition_element=>'P1316_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126031765683309103.4001)
,p_event_id=>wwv_flow_api.id(126030794807309102.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_SET,P1316_TAB_LABEL,P1316_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126023601757309096.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_TAB_OPTIONS'
,p_condition_element=>'P1316_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126024666657309099.4001)
,p_event_id=>wwv_flow_api.id(126023601757309096.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_SET,P1316_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126025100219309099.4001)
,p_event_id=>wwv_flow_api.id(126023601757309096.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126032187220309103.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_TAB_OPTIONS'
,p_condition_element=>'P1316_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126033165089309103.4001)
,p_event_id=>wwv_flow_api.id(126032187220309103.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_SET,P1316_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126033677354309104.4001)
,p_event_id=>wwv_flow_api.id(126032187220309103.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126034071004309104.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_NAVLIST_OPTIONS'
,p_condition_element=>'P1316_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126034543410309104.4001)
,p_event_id=>wwv_flow_api.id(126034071004309104.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_ENTRY_NAME,P1316_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126035002672309104.4001)
,p_event_id=>wwv_flow_api.id(126034071004309104.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_ENTRY_NAME,P1316_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(126035439436309105.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_NAVLIST_OPTIONS'
,p_condition_element=>'P1316_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126035924766309105.4001)
,p_event_id=>wwv_flow_api.id(126035439436309105.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(126036440135309105.4001)
,p_event_id=>wwv_flow_api.id(126035439436309105.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01317
begin
wwv_flow_api.create_page(
 p_id=>1317.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('La funci\00F3n ya existe')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('La funci\00F3n ya existe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1312877352198970103.4001)
,p_plug_name=>unistr('La funci\00F3n existe')
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta funci\00F3n ya existe en su aplicaci\00F3n. Si desea reinstalarla, primero debe eliminar las p\00E1ginas existentes, los componentes compartidos y la opci\00F3n de creaci\00F3n <strong>&P1317_BUILD_OPTION.</strong>. Para eliminar los componentes, siga estos paso')
||'s:',
'<ol>',
'  <li>Vaya a Componentes compartidos.</li>',
unistr('  <li>Vaya a L\00F3gica de aplicaci\00F3n > Opciones de creaci\00F3n.</li>'),
'  <li>Haga clic en <strong>&P1317_BUILD_OPTION.</strong>.</li>',
'  <li>Haga clic en <strong>Eliminar componentes</strong>.<br>',
unistr('    &nbsp;&nbsp;Marque la casilla de verificaci\00F3n <em>S\00ED: eliminar componentes</em>.<br>'),
'    &nbsp;&nbsp;Haga clic en <strong>Eliminar componentes</strong>.</li>',
unistr('  <li>En la opci\00F3n de creaci\00F3n Crear/editar, haga clic en <strong>Suprimir</strong>.<br>'),
unistr('    &nbsp;&nbsp;Haga clic en <strong>Suprimir opci\00F3n de creaci\00F3n</strong>.</li>'),
'</ol>',
'</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1324529837091147330.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(234534057995142929.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1324529837091147330.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(234534405523142929.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1324529837091147330.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(231171661894226007.4001)
,p_name=>'P1317_BUILD_OPTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1312877352198970103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(234534996782142938.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(231172029727226011.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1317_BUILD_OPTION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_return varchar2(4000) := wwv_flow_lang.system_message(''FEATURE'')||'': '';',
'begin',
'  if :P259_CHOOSE_PAGE_TYPE = ''ACCESSCONTROL'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.ACCESS_CONTROL'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''FEEDBACK'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.FEEDBACK'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''ACTIVITYREPORTING'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.ACTIVITY_REPORTING'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''EMAILREPORTING'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.EMAIL_REPORT'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''JOBREPORTING'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.JOB_REPORT'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''ABOUTAPP'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.ABOUT_PAGE'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''CONFIGOPTIONS'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.CONFIGURATION_OPTIONS'');',
'  elsif :P259_CHOOSE_PAGE_TYPE = ''THEMESELECTION'' then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.THEME_STYLE_SELECTION'');',
'  end if;',
'',
'  return l_return;',
'end;',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234536663044142941.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(234534057995142929.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234537171563142942.4001)
,p_event_id=>wwv_flow_api.id(234536663044142941.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234537516694142942.4001)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1317_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234538016816142943.4001)
,p_event_id=>wwv_flow_api.id(234537516694142942.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_ADMIN_PAGE_ID,P1317_ADMIN_PAGE_NAME,P1317_NAVLIST_OPTIONS,P1317_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234539528796142944.4001)
,p_event_id=>wwv_flow_api.id(234537516694142942.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234538588607142943.4001)
,p_event_id=>wwv_flow_api.id(234537516694142942.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234539021275142944.4001)
,p_event_id=>wwv_flow_api.id(234537516694142942.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_ADMIN_PAGE_ID,P1317_ADMIN_PAGE_NAME,P1317_NAVLIST_OPTIONS,P1317_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234540005101142944.4001)
,p_event_id=>wwv_flow_api.id(234537516694142942.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234540525516142945.4001)
,p_event_id=>wwv_flow_api.id(234537516694142942.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234540977452142945.4001)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234541444806142945.4001)
,p_event_id=>wwv_flow_api.id(234540977452142945.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_ENTRY_NAME,P1317_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1317_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1317_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234541855230142945.4001)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_TAB_OPTIONS'
,p_condition_element=>'P1317_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234542358953142946.4001)
,p_event_id=>wwv_flow_api.id(234541855230142945.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_SET,P1317_TAB_LABEL,P1317_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234535258277142939.4001)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_TAB_OPTIONS'
,p_condition_element=>'P1317_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234535747667142940.4001)
,p_event_id=>wwv_flow_api.id(234535258277142939.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_SET,P1317_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234536293616142940.4001)
,p_event_id=>wwv_flow_api.id(234535258277142939.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234542701132142946.4001)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_TAB_OPTIONS'
,p_condition_element=>'P1317_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234543237413142946.4001)
,p_event_id=>wwv_flow_api.id(234542701132142946.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_SET,P1317_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234543784311142946.4001)
,p_event_id=>wwv_flow_api.id(234542701132142946.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234544143100142946.4001)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_NAVLIST_OPTIONS'
,p_condition_element=>'P1317_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234544676243142947.4001)
,p_event_id=>wwv_flow_api.id(234544143100142946.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_ENTRY_NAME,P1317_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234545115688142947.4001)
,p_event_id=>wwv_flow_api.id(234544143100142946.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_ENTRY_NAME,P1317_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(234545586806142947.4001)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_NAVLIST_OPTIONS'
,p_condition_element=>'P1317_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234546014965142947.4001)
,p_event_id=>wwv_flow_api.id(234545586806142947.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(234546590771142948.4001)
,p_event_id=>wwv_flow_api.id(234545586806142947.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01400
begin
wwv_flow_api.create_page(
 p_id=>1400.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Dise\00F1os de Informe')
,p_step_title=>unistr('Dise\00F1os de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19186430842313531.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>121
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(193374517232546937.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19219825628510750.4001)
,p_plug_name=>unistr('Dise\00F1os de Informe')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los dise\00F1os de informe se pueden utilizar con una regi\00F3n o consulta de informe para representar los datos en versi\00F3n para impresora, como PDF, Word o Excel. Se puede realizar un dise\00F1o de informe utilizando el plugin Template Builder Word y se pue')
||unistr('de cargar como un archivo de tipo RTF o XSL-FO. Las regiones de informe utilizan un dise\00F1o XSL-FO gen\00E9rico, que es personalizable.</p>  '),
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-report-output.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188068612597706426.4001)
,p_plug_name=>unistr('Dise\00F1os de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>161
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    id,',
'    report_layout_name,',
'    report_layout_type,',
'    last_updated_on,',
'    ''icon-sc-report-layout'' icon_class,',
'    ''f?p=4000:1405:''||:app_session||''::NO:1405:P1405_ID:''||ID edit_link,',
'    replace(replace(report_layout_name,''_'','' ''),''.'','' '') icon_title',
'from   WWV_FLOW_REPORT_LAYOUTS',
'where  flow_id = :FB_FLOW_ID ',
'and security_group_id = :flow_security_group_id',
'order by report_layout_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(188068703311706426.4001)
,p_name=>'Report Layouts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188068904394706429.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:1405:P1405_ID:#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188069015305706430.4001)
,p_db_column_name=>'REPORT_LAYOUT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de Dise\00F1o de Informe')
,p_column_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:1405:P1405_ID:#ID#'
,p_column_linktext=>'#REPORT_LAYOUT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188069121317706430.4001)
,p_db_column_name=>'REPORT_LAYOUT_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Tipo de Dise\00F1o de Informe')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(19274704924460373)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188069214487706431.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Fecha de Modificaci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656847718379640338.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656847890431640338.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656847913801640338.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188996420417134295.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(188068612597706426.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:1400,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19212528748481466.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(188068612597706426.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:1122::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19212314456481465.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(188068612597706426.4001)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:1401,1402,1406::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(64802508667967798.4001)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590049721385341777.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(19212314456481465.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590050089668341778.4001)
,p_event_id=>wwv_flow_api.id(590049721385341777.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590050132649345186.4001)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(19212528748481466.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590050411805345187.4001)
,p_event_id=>wwv_flow_api.id(590050132649345186.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_01401
begin
wwv_flow_api.create_page(
 p_id=>1401.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Dise\00F1o de Informe: Tipo de Dise\00F1o')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Dise\00F1o de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19262412000273146.4001)
,p_plug_name=>unistr('Crear Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>121
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(19267316951407102.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(19263904166280419.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22631312314867604.4001)
,p_plug_name=>unistr('Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>122
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un <strong>dise\00F1o de informe de columnas con nombre/espec\00EDfico de consulta</strong> est\00E1 dise\00F1ado para que funcione con una lista de columnas definida en el juego de resultados de consulta. Este tipo de dise\00F1o se utiliza para dise\00F1os personalizados y')
||unistr(' espec\00EDficos y en casos en los que se requiera un control preciso de la ubicaci\00F3n de los elementos de la p\00E1gina y las columnas de consulta. Un dise\00F1o de informe espec\00EDfico de consulta se dise\00F1a normalmente como plantilla RTF utilizando el plugin de W')
||unistr('ord, Word Template Builder, (se necesita licencia de Oracle BI Publisher), pero tambi\00E9n se puede crear manualmente como archivo RTF o XSL-FO.'),
'<br /><br />',
unistr('Un <strong>dise\00F1o de informe gen\00E9rico</strong> funciona con la mayor\00EDa de juegos de resultados de consulta. El n\00FAmero de columnas se ajusta autom\00E1ticamente al generar el documento imprimible. Se puede definir un n\00FAmero de atributos de dise\00F1o de infor')
||unistr('me de forma declarativa para las regiones del informe utilizando el dise\00F1o por defecto XSL-FO incorporado. Este asistente permite la creaci\00F3n de copias personalizables del dise\00F1o por defecto XSL-FO incorporado si se necesita control adicional sobre e')
||unistr('l dise\00F1o de informe.')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206251930124628625.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>132
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19270027602429073.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206251930124628625.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(19273508125442354.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206251930124628625.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(19273821194442355.4001)
,p_branch_action=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19273508125442354.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1401_LAYOUT_TYPE'
,p_branch_condition_text=>'XSL_GENERIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(87922012615914366.4001)
,p_branch_action=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(19273508125442354.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P1401_LAYOUT_TYPE'
,p_branch_condition_text=>'XSL_GENERIC'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19276201938468960.4001)
,p_name=>'P1401_LAYOUT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(19262412000273146.4001)
,p_item_default=>'XSL_GENERIC'
,p_prompt=>unistr('Tipo de Dise\00F1o de Informe:')
,p_source=>'XSL_GENERIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT.LAYOUT.TYPES'
,p_lov=>'.'||wwv_flow_api.id(19274704924460373.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el tipo de dise\00F1o de informe que desea crear:'),
'<ul>',
unistr('<li><strong>Columnas Gen\00E9ricas</strong> utiliza la plantilla por defecto para rellenar el informe. En el siguiente paso, puede personalizar el c\00F3digo por defecto.'),
'</li>',
'<li><strong>Columnas con Nombre</strong> necesita que descargue un archivo XSL-FO o RTF en el siguiente paso.</li></ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102287804009686219.4001)
,p_validation_name=>'BIP_LICENSE_REQUIRED'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_server        wwv_flow_print_util.t_print_server;',
'begin',
'    l_server   := wwv_flow_print_util.get_print_server (',
'        p_flow_id => :FB_FLOW_ID);',
'    return l_server.server_type = ''ADVANCED'' or (:P1401_LAYOUT_TYPE != ''RTF_FILE'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El uso de dise\00F1os de informe basados en RTF necesita una licencia de Oracle BI Publisher.')
,p_associated_item=>wwv_flow_api.id(19276201938468960.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590014310420897536.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(19270027602429073.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590014489798897537.4001)
,p_event_id=>wwv_flow_api.id(590014310420897536.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01402
begin
wwv_flow_api.create_page(
 p_id=>1402.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Dise\00F1o de Informe: Origen de Dise\00F1o')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Dise\00F1o de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22672623482009564.4001)
,p_plug_name=>unistr('Crear Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>121
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22672823029009564.4001)
,p_plug_name=>unistr('Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>122
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Un <strong>dise\00F1o de informe gen\00E9rico</strong> se puede utilizar en diferentes informes. El n\00FAmero de columnas y de cabeceras de columna se derivan de la definici\00F3n de informe y se ajustan autom\00E1ticamente al generar el documento imprimible. Se puede ')
||unistr('definir un n\00FAmero de atributos de dise\00F1o de informe de forma declarativa para las regiones del informe utilizando el dise\00F1o por defecto XSL-FO incorporado. Este asistente permite la creaci\00F3n de copias personalizables del dise\00F1o por defecto XSL-FO inc')
||unistr('orporado, si se necesita de un control adicional sobre el dise\00F1o de la p\00E1gina.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22673222331009565.4001)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(19263904166280419.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206253106145640649.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>131
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22674122579009566.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206253106145640649.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22673914622009565.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206253106145640649.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Dise\00F1o')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22701918098086891.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206253106145640649.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22674813475009566.4001)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22673914622009565.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22703631257090731.4001)
,p_branch_action=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22701918098086891.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(139905802861866203.4001)
,p_branch_action=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22674617596009566.4001)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(22674122579009566.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22706824771145652.4001)
,p_name=>'P1402_PRINT_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22672623482009564.4001)
,p_prompt=>unistr('Nombre de Dise\00F1o de Informe')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre para identificar el dise\00F1o del informe al asociarlo a una consulta de informe o regi\00F3n de informe. Los dise\00F1os de informe guardados aparecen en Componentes Compartidos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22707029480145653.4001)
,p_name=>'P1402_PRINT_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(22672623482009564.4001)
,p_prompt=>unistr('Dise\00F1o de Informe:')
,p_source=>'wwv_flow_utilities.clob_to_varchar2(wwv_render_report3.g_prn_template);'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">El dise\00F1o del informe es la definici\00F3n basada en XSL-FO del formato de p\00E1gina. Todos los atributos que definen el tama\00F1o de p\00E1gina, la orientaci\00F3n, las fuentes, los estilos, etc., se definen en esta secci\00F3n. </div>'),
'',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n son v\00E1lidas: </div>'),
'<ul class="noIndent">',
'<li>#PAGE_HEADER#</li>',
'<li>#PAGE_HEADERFONT_COLOR#</li>',
'<li>#PAGE_HEADER_FONT_FAMILY#</li>',
'<li>#PAGE_HEADER_FONT_SIZE#</li>',
'<li>#PAGE_HEADER_FONT_WEIGHT#</li>',
'<li>#PAGE_FOOTER#</li>',
'<li>#PAGE_FOOTER_FONT_COLOR#</li>',
'<li>#PAGE_FOOTER_FONT_FAMILY#</li>',
'<li>#PAGE_FOOTER_FONT_SIZE#</li>',
'<li>#PAGE_FOOTER_FONT_WEIGHT#</li>',
'<li>#PAGE_WIDTH#</li>',
'<li>#PAGE_HEIGHT#</li>',
'<li>#HEADER_BG_COLOR#</li>',
'<li>#HEADER_FONT_COLOR#</li>',
'<li>#HEADER_FONT_FAMILY#</li>',
'<li>#HEADER_FONT_SIZE#</li>',
'<li>#HEADER_FONT_WEIGHT#</li>',
'<li>#BODY_BG_COLOR#</li>',
'<li>#BODY_FONT_COLOR#</li>',
'<li>#BODY_FONT_FAMILY#</li>',
'<li>#BODY_FONT_SIZE#</li>',
'<li>#BODY_FONT_WEIGHT#</li>',
'<li>#BORDER_WIDTH#</li>',
'</ul>',
unistr('<div class="htmldbInfoBodyP">Para que el dise\00F1o del informe sea gen\00E9rico, hay subplantillas adicionales definidas que especifican el dise\00F1o de cada columna, cabecera de columna y ancho de columna. En tiempo de ejecuci\00F3n, estas subplantillas se ensamb')
||unistr('lan e incluyen de forma din\00E1mica en el principal dise\00F1o de informe autom\00E1ticamente sustituyendo las siguientes cadenas: </div>'),
'<ul class="noIndent">',
'<li>#PRN_TABLE_CELLS#</li>',
'<li>#PRN_TEMPLATE_BODY_ROW#</li>',
'<li>#PRN_TEMPLATE_HEADER_ROW#</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22707214514145653.4001)
,p_name=>'P1402_REPORT_COLUMN_HEADING'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(22672623482009564.4001)
,p_prompt=>'Cabecera de Columna de Informe:'
,p_source=>'wwv_render_report3.g_prn_template_header_col'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'La cabecera de columna del informe define el aspecto de cada celda de la fila de cabecera del informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22707427995145653.4001)
,p_name=>'P1402_REPORT_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(22672623482009564.4001)
,p_prompt=>'Columna de Informe:'
,p_source=>'wwv_render_report3.g_prn_template_body_col'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'La columna del informe define el aspecto de cada celda para todas las filas del informe. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22707605511145653.4001)
,p_name=>'P1402_REPORT_COLUMN_WIDTH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(22672623482009564.4001)
,p_prompt=>'Ancho de Columna de Informe:'
,p_source=>'wwv_render_report3.g_prn_template_table_cell'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El ancho de columna del informe se calcula en tiempo de ejecuci\00F3n o se puede derivar de la definici\00F3n de columna del informe de una regi\00F3n de informe. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23578711017492629.4001)
,p_validation_name=>'P1402_PRINT_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P1402_PRINT_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre del dise\00F1o.')
,p_when_button_pressed=>wwv_flow_api.id(22673914622009565.4001)
,p_associated_item=>wwv_flow_api.id(22706824771145652.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102690721829277876.4001)
,p_validation_name=>'P1402_PRINT_TEMPLATE'
,p_validation_sequence=>20
,p_validation=>'P1402_PRINT_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el dise\00F1o.')
,p_validation_condition=>'P1401_LAYOUT_TYPE'
,p_validation_condition2=>'XSL_GENERIC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(22673914622009565.4001)
,p_associated_item=>wwv_flow_api.id(22707029480145653.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102709025339307349.4001)
,p_validation_name=>'P1402_REPORT_COLUMN_HEADING'
,p_validation_sequence=>30
,p_validation=>'P1402_REPORT_COLUMN_HEADING'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la cabecera de columna.'
,p_when_button_pressed=>wwv_flow_api.id(22673914622009565.4001)
,p_associated_item=>wwv_flow_api.id(22707214514145653.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102710531226309015.4001)
,p_validation_name=>'P1402_REPORT_COLUMN'
,p_validation_sequence=>40
,p_validation=>'P1402_REPORT_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la columna.'
,p_when_button_pressed=>wwv_flow_api.id(22673914622009565.4001)
,p_associated_item=>wwv_flow_api.id(22707427995145653.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102711905384311046.4001)
,p_validation_name=>'P1402_REPORT_COLUMN_WIDTH'
,p_validation_sequence=>50
,p_validation=>'P1402_REPORT_COLUMN_WIDTH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el ancho de columna.'
,p_when_button_pressed=>wwv_flow_api.id(22673914622009565.4001)
,p_associated_item=>wwv_flow_api.id(22707605511145653.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590014539571897538.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(22674122579009566.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590014601233897539.4001)
,p_event_id=>wwv_flow_api.id(590014539571897538.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23576703960481102.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'wwv_flow_api.create_report_layout (',
'    p_flow_id                     => nv(''FB_FLOW_ID''),',
'    p_report_layout_name          => :P1402_PRINT_TEMPLATE_NAME,',
'    p_report_layout_type          => ''XSL_GENERIC'',',
'    p_page_template               => :P1402_PRINT_TEMPLATE,',
'    p_xslfo_column_heading        => :P1402_REPORT_COLUMN_HEADING,',
'    p_xslfo_column_template       => :P1402_REPORT_COLUMN,',
'    p_xslfo_column_template_width => :P1402_REPORT_COLUMN_WIDTH',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(22673914622009565.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590015265155897545.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(22673914622009565.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_01405
begin
wwv_flow_api.create_page(
 p_id=>1405.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Dise\00F1o de Informe')
,p_step_title=>unistr('Editar Dise\00F1o de Informe')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24414923466637064.4001)
,p_plug_name=>unistr('Atributos de Dise\00F1o de Informe')
,p_region_name=>'L'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24429902451664898.4001)
,p_plug_name=>unistr('Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24435001197674011.4001)
,p_plug_name=>unistr('Dise\00F1o de Informe')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los <strong>dise\00F1os de informe de columna gen\00E9ricos</strong> se pueden editar en esta p\00E1gina. La plantilla de p\00E1gina especifica el aspecto general del documento formateado. Las subplantillas de cabecera de columna de informe, columna de informe y ')
||unistr('ancho de columna se utilizan para personalizar m\00E1s el formato de las cabeceras de columna y columnas.</p>'),
'',
unistr('<p>Los <strong>dise\00F1os de informe de columna con nombre</strong> est\00E1n basados en el archivo. Para cambiarlos, descargue el archivo actual con el bot\00F3n de descarga de esta p\00E1gina y modifique el archivo de la forma necesaria. A continuaci\00F3n, cargue el')
||unistr(' archivo modificado como nuevo dise\00F1o de informe.</p>'),
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24466514104734503.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46251916439678999.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73493529825371212.4001)
,p_plug_name=>unistr('Dise\00F1o de Informe')
,p_region_name=>'F'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1405_REPORT_LAYOUT_TYPE'
,p_plug_display_when_cond2=>'XSL_GENERIC'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620059301928486921.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_REPORT_LAYOUTS',
'where id = :P1405_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P1405_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1405_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(88077819681351644.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(24414923466637064.4001)
,p_button_name=>'P1405_DOWNLOAD'
,p_button_static_id=>'P1405_DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar'
,p_button_alignment=>'LEFT'
,p_button_condition=>'P1405_REPORT_LAYOUT_TYPE'
,p_button_condition2=>'XSL_GENERIC'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_request_source=>'DOWNLOAD'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24415815491637074.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(24429902451664898.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24416028989637075.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(24429902451664898.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1405_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(24416206163637075.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(24429902451664898.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1405_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(24419525986637081.4001)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(24416028989637075.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(88131709189566174.4001)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(24416206163637075.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24416407333637076.4001)
,p_name=>'P1405_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(24414923466637064.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24416601650637076.4001)
,p_name=>'P1405_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(24414923466637064.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24416825978637077.4001)
,p_name=>'P1405_REPORT_LAYOUT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(24414923466637064.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Dise\00F1o de Informe')
,p_source=>'REPORT_LAYOUT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre para identificar el dise\00F1o del informe al asociarlo a una consulta de informe o regi\00F3n de informe. Los dise\00F1os de informe guardados aparecen en Componentes Compartidos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24417002849637077.4001)
,p_name=>'P1405_REPORT_LAYOUT_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(24414923466637064.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Dise\00F1o de Informe:')
,p_source=>'REPORT_LAYOUT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT.LAYOUT.TYPES'
,p_lov=>'.'||wwv_flow_api.id(19274704924460373.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Tipo de dise\00F1o de informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24417403259637077.4001)
,p_name=>'P1405_XSLFO_COLUMN_HEADING_TEMP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(73493529825371212.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cabecera de Columna de Informe:'
,p_source=>'XSLFO_COLUMN_HEADING_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32000
,p_cHeight=>8
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'La cabecera de columna del informe define el aspecto de cada celda de la fila de cabecera del informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24417613138637077.4001)
,p_name=>'P1405_XSLFO_COLUMN_TEMPLATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(73493529825371212.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Columna:'
,p_source=>'XSLFO_COLUMN_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32000
,p_cHeight=>8
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'La columna del informe define el aspecto de cada celda para todas las filas del informe. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24417815077637077.4001)
,p_name=>'P1405_REPORT_LAYOUT_COMMENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(24466514104734503.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Comentario de Dise\00F1o de Informe:')
,p_source=>'REPORT_LAYOUT_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24418014686637078.4001)
,p_name=>'P1405_XSLFO_COLUMN_TEMPLATE_WID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(73493529825371212.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ancho de Plantilla de Columna:'
,p_source=>'XSLFO_COLUMN_TEMPLATE_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32000
,p_cHeight=>4
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('El ancho de columna del informe se calcula en tiempo de ejecuci\00F3n o se puede derivar de la definici\00F3n de columna del informe de una regi\00F3n de informe. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(80051121794611628.4001)
,p_name=>'P1405_PAGE_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(73493529825371212.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de P\00E1gina:')
,p_source=>'PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32000
,p_cHeight=>12
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">El dise\00F1o del informe es la definici\00F3n basada en XSL-FO del formato de p\00E1gina. Todos los atributos que definen el tama\00F1o de p\00E1gina, la orientaci\00F3n, las fuentes, los estilos, etc., se definen en esta secci\00F3n. </div>'),
'',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n son v\00E1lidas: </div>'),
'<ul class="noIndent">',
'<li>#PAGE_HEADER#</li>',
'<li>#PAGE_HEADERFONT_COLOR#</li>',
'<li>#PAGE_HEADER_FONT_FAMILY#</li>',
'<li>#PAGE_HEADER_FONT_SIZE#</li>',
'<li>#PAGE_HEADER_FONT_WEIGHT#</li>',
'<li>#PAGE_FOOTER#</li>',
'<li>#PAGE_FOOTER_FONT_COLOR#</li>',
'<li>#PAGE_FOOTER_FONT_FAMILY#</li>',
'<li>#PAGE_FOOTER_FONT_SIZE#</li>',
'<li>#PAGE_FOOTER_FONT_WEIGHT#</li>',
'<li>#PAGE_WIDTH#</li>',
'<li>#PAGE_HEIGHT#</li>',
'<li>#HEADER_BG_COLOR#</li>',
'<li>#HEADER_FONT_COLOR#</li>',
'<li>#HEADER_FONT_FAMILY#</li>',
'<li>#HEADER_FONT_SIZE#</li>',
'<li>#HEADER_FONT_WEIGHT#</li>',
'<li>#BODY_BG_COLOR#</li>',
'<li>#BODY_FONT_COLOR#</li>',
'<li>#BODY_FONT_FAMILY#</li>',
'<li>#BODY_FONT_SIZE#</li>',
'<li>#BODY_FONT_WEIGHT#</li>',
'<li>#BORDER_WIDTH#</li>',
'</ul>',
unistr('<div class="htmldbInfoBodyP">Para que el dise\00F1o del informe sea gen\00E9rico, hay subplantillas adicionales definidas que especifican el dise\00F1o de cada columna, cabecera de columna y ancho de columna. En tiempo de ejecuci\00F3n, estas subplantillas se ensamb')
||unistr('lan e incluyen de forma din\00E1mica en el principal dise\00F1o de informe autom\00E1ticamente sustituyendo las siguientes cadenas: </div>'),
'<ul class="noIndent">',
'<li>#PRN_TABLE_CELLS#</li>',
'<li>#PRN_TEMPLATE_BODY_ROW#</li>',
'<li>#PRN_TEMPLATE_HEADER_ROW#</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(24418506917637079.4001)
,p_validation_name=>'P1405_REPORT_LAYOUT_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1405_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El nombre del dise\00F1o de informe debe tener alg\00FAn valor.')
,p_associated_item=>wwv_flow_api.id(24416825978637077.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102647402511177723.4001)
,p_validation_name=>'P1405_REPORT_LAYOUT_NAME'
,p_validation_sequence=>20
,p_validation=>'P1405_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre del dise\00F1o de informe.')
,p_when_button_pressed=>wwv_flow_api.id(24416206163637075.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102649828484185269.4001)
,p_validation_name=>'REPORT_LAYOUT_NAME UNIQUE'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_report_layouts',
'where flow_id = :FB_FLOW_ID',
'and report_layout_name = :P1405_REPORT_LAYOUT_NAME',
'and id <> :P1405_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de dise\00F1o de informe debe ser \00FAnico, ya existe un dise\00F1o de informe denominado &P1405_REPORT_LAYOUT_NAME. ')
,p_when_button_pressed=>wwv_flow_api.id(24416206163637075.4001)
,p_associated_item=>wwv_flow_api.id(24416825978637077.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102383802296837045.4001)
,p_validation_name=>'P1405_PAGE_TEMPLATE'
,p_validation_sequence=>40
,p_validation=>'P1405_PAGE_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la plantilla de p\00E1gina. ')
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(24416206163637075.4001)
,p_associated_item=>wwv_flow_api.id(80051121794611628.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102488518460983606.4001)
,p_validation_name=>'P1405_XSLFO_COLUMN_HEADING_TEMP'
,p_validation_sequence=>50
,p_validation=>'P1405_XSLFO_COLUMN_HEADING_TEMP'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la cabecera de columna.'
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(24416206163637075.4001)
,p_associated_item=>wwv_flow_api.id(24417403259637077.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102490530927987245.4001)
,p_validation_name=>'P1405_XSLFO_COLUMN_TEMPLATE'
,p_validation_sequence=>60
,p_validation=>'P1405_XSLFO_COLUMN_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar una plantilla de columna.'
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(24416206163637075.4001)
,p_associated_item=>wwv_flow_api.id(24417613138637077.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102492204392989060.4001)
,p_validation_name=>'P1405_XSLFO_COLUMN_TEMPLATE_WID'
,p_validation_sequence=>70
,p_validation=>'P1405_XSLFO_COLUMN_TEMPLATE_WID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el ancho de columna.'
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(24416206163637075.4001)
,p_associated_item=>wwv_flow_api.id(24418014686637078.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24418804407637079.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_REPORT_LAYOUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_REPORT_LAYOUTS'
,p_attribute_03=>'P1405_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24419023848637080.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_REPORT_LAYOUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_REPORT_LAYOUTS'
,p_attribute_03=>'P1405_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_REPORT_LAYOUTS.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(88132214037567540.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_report_document  blob;',
'    l_file_ext  varchar2(255);',
'    l_mime_type varchar2(255);',
'',
'begin',
'    for c1 in (',
'        select *',
'        from wwv_flow_report_layouts',
'        where id = :P1405_ID',
'    ) loop',
'',
'        if c1.report_layout_type = ''RTF_FILE'' then',
'            l_mime_type  := ''application/rtf'';',
'            l_file_ext   := ''rtf'';',
'        else ',
'            l_mime_type  := ''application/xml'';',
'            l_file_ext   := ''xml'';',
'        end if;',
'',
'        l_report_document := wwv_flow_utilities.clob_to_blob(c1.page_template,wwv_flow_lang.get_db_charset);',
'        wwv_flow.g_page_text_generated := true;',
'        sys.htp.init;',
'        ',
'        wwv_flow_utilities.print_download_header(',
'            p_mime_type =>     l_mime_type,',
'            p_file_name =>     lower(replace(c1.report_layout_name,'' '',''_''))||''.''||l_file_ext,',
'            p_is_attachment => true',
'        );',
'        ',
'        sys.owa_util.http_header_close;',
'        ',
'        wpg_docload.download_file( l_report_document ); ',
'        wwv_flow.g_unrecoverable_error := true;',
'',
'    end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(88077819681351644.4001)
);
end;
/
prompt --application/pages/page_01406
begin
wwv_flow_api.create_page(
 p_id=>1406.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Consulta de Informe: Origen de Dise\00F1o')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Consulta de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(22569212548659511)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87894608610830159.4001)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(19263904166280419.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87895011130830160.4001)
,p_plug_name=>unistr('Crear Dise\00F1o de Consulta de Informe')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cargue el dise\00F1o del informe como archivo RTF o XSL-FO. Los archivos RTF se pueden crear con el plugin de Oracle BI Publisher para MS Word, que simplifica el dise\00F1o del informe mediante una sencilla interfaz de arrastrar y soltar. Este plugin util')
||unistr('iza una versi\00F3n XML del juego de resultados del informe como datos de origen. Estos datos XML se pueden descargar de la p\00E1gina de edici\00F3n de consulta de informe.</p>'),
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206255614587652551.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(87895909442830167.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206255614587652551.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(87896302874830169.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206255614587652551.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Dise\00F1o')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(87896124686830169.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206255614587652551.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(87900217927830178.4001)
,p_branch_action=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(87896124686830169.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87898300109830172.4001)
,p_name=>'P1406_REPORT_LAYOUT_NAME'
,p_item_sequence=>58
,p_item_plug_id=>wwv_flow_api.id(87895011130830160.4001)
,p_prompt=>unistr('Nombre de Dise\00F1o')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1406_REPORT_LAYOUT_ID'
,p_display_when_type=>'ITEM_IS_NULL_OR_ZERO'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre para identificar el dise\00F1o del informe al asociarlo a una consulta de informe o regi\00F3n de informe. Los dise\00F1os de informe guardados aparecen en Componentes Compartidos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87898511267830172.4001)
,p_name=>'P1406_LAYOUT_FILE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(87895011130830160.4001)
,p_prompt=>unistr('Archivo de Dise\00F1o de Informe')
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_display_when=>'P1406_REPORT_LAYOUT_ID'
,p_display_when_type=>'ITEM_IS_NULL_OR_ZERO'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el archivo que contiene el dise\00F1o de informe que desea agregar. Los archivos de dise\00F1o de informe deben tener formato RTF o XSL-FO.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(87898726909830173.4001)
,p_name=>'P1406_REPORT_LAYOUT'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(87895011130830160.4001)
,p_prompt=>unistr('Dise\00F1o de Informe:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_layout_name ',
'from wwv_flow_report_layouts',
'where id = :P1406_REPORT_LAYOUT_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P1406_REPORT_LAYOUT_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102325101547732770.4001)
,p_validation_name=>'P1406_REPORT_LAYOUT_NAME'
,p_validation_sequence=>10
,p_validation=>'P1406_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre del dise\00F1o de informe.')
,p_when_button_pressed=>wwv_flow_api.id(87896302874830169.4001)
,p_associated_item=>wwv_flow_api.id(87898300109830172.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102326711244735599.4001)
,p_validation_name=>'P1406_LAYOUT_FILE'
,p_validation_sequence=>20
,p_validation=>'P1406_LAYOUT_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar un archivo de dise\00F1o de informe.')
,p_when_button_pressed=>wwv_flow_api.id(87896302874830169.4001)
,p_associated_item=>wwv_flow_api.id(87898511267830172.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(102335613584755212.4001)
,p_validation_name=>'REPORT_LAYOUT_NAME UNIQUE'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_report_layouts',
'where flow_id = :FB_FLOW_ID',
'and report_layout_name = :P1406_REPORT_LAYOUT_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de dise\00F1o de informe debe ser \00FAnico, ya existe un dise\00F1o de informe denominado en blanco. ')
,p_when_button_pressed=>wwv_flow_api.id(87896302874830169.4001)
,p_associated_item=>wwv_flow_api.id(87898300109830172.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590014726329897540.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(87895909442830167.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590014812036897541.4001)
,p_event_id=>wwv_flow_api.id(590014726329897540.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(87899507927830176.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_report_layout    clob;',
'    l_report_layout_id number;',
'    l_file_start       varchar2(5);',
'begin',
'',
'    for c1 in ( select filename,',
'                       blob_content',
'                  from wwv_flow_temp_files',
'                 where name = :P1406_LAYOUT_FILE )',
'    loop    ',
'        l_report_layout_id := wwv_flow_id.next_val;',
'        l_report_layout    := wwv_flow_utilities.blob_to_clob(c1.blob_content);',
'        l_file_start       := sys.dbms_lob.substr(l_report_layout, 5);',
'        ',
'        if l_file_start like ''<%'' or l_file_start = ''{\rtf'' then',
'            insert into wwv_flow_report_layouts (',
'                id,',
'                flow_id, ',
'                report_layout_name,',
'                report_layout_type,',
'                page_template',
'            ) values (',
'                l_report_layout_id,',
'                :FB_FLOW_ID,',
'                :P1406_REPORT_LAYOUT_NAME,',
'                :P1401_LAYOUT_TYPE,',
'                l_report_layout',
'            );    ',
'        else',
'            wwv_flow_error.raise_internal_error (',
'                p_error_code => ''F4000.INVALID_FILE_TYPE'',',
'                p0           => c1.filename );',
'        end if;',
'    end loop;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(87896302874830169.4001)
,p_process_when=>'P1406_REPORT_LAYOUT_ID'
,p_process_when_type=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590014925962897542.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(87896302874830169.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_01500
begin
wwv_flow_api.create_page(
 p_id=>1500.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Creador de Aplicaciones'
,p_step_title=>'Creador de Aplicaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.theme.defaultStickyTop = function() {',
'   return $("#apps_irr_wrap_toolbar").outerHeight();',
'}'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Developer Toolbar integration */',
'apex.builder.nameBuilderWindow();',
'apex.jQuery(''#apps_irr_toolbar'').wrap(''<div class="a-IRR-toolbarWrap" id="apps_irr_wrap_toolbar"></div>'');',
'apex.builder.initStickyHeader(''apps_irr_wrap_toolbar'');'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_hm.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2774522728910972.4001)
,p_name=>'Reciente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000P1500b */ substr(name,1,20)||'' - ''||id name, id',
'from wwv_flow_visible_flows f',
'where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by last_updated_on desc'))
,p_display_when_condition=>'P1500_SHOW'
,p_display_when_cond2=>'DATABASE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna aplicaci\00F3n.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>90
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2777108446925756.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_column_link=>'f?p=4000:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:#ID#,#ID#,'
,p_column_linktext=>'#NAME#'
,p_column_link_attr=>'alt="&EDIT." title="&EDIT."'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2774923910910975.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2779905591943838.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3519628466105919.4001)
,p_plug_name=>'Aplicaciones'
,p_region_name=>'apps_irr'
,p_region_css_classes=>'a-IRR-region--responsiveIconViewWide a-IRR-region--showTopBorder a-AppCards a-AppCards--slim a-AppCards--irr'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4000P1500a */',
'app_id,',
'id,',
'img,',
'authentication_scheme,',
'link,',
'name,',
'app_name,',
'owner as app_owner,',
'nvl( image_class, '' '' ) as image_class,',
'case when image_class is null and app_builder_icon_name is null then wwv_flow_4000_ui.get_app_initials( app_name, app_id )',
'     else '' ''',
'end as app_initials,',
'case when image_class is null  and app_builder_icon_name is null then ''u-color-'' || to_char( ora_hash( app_name, 44 ) + 1 ) || ''-bg''',
'     else '' ''',
'end as app_color,',
'case ',
'   when app_builder_icon_name is null then '' ''',
'   else ''<span class="a-AppCards-icon-img" style="background-image: url('''''' ||',
'        wwv_flow_utilities.get_friendly_app_url (',
'            p_application_id => id,',
'            p_url            => ''files/static/v'' || files_version || ''/'' ) ||',
'        wwv_flow_escape.html_attribute(app_builder_icon_name) ||',
'        '''''');"></span>'' ',
'end app_builder_icon_name,',
'build_status,',
'flow_status status,',
'last_updated_on,',
'page_count,',
'manage,',
'updated,',
'last_updated_by,',
'created,',
'created_by,',
'action_buttons,',
'actions,',
'groupname,',
'application_security_scheme,',
'alias,',
'logging,',
'flow_version,',
'global_notification,',
'page_protection_enabled_y_n,',
'rejoin_existing_sessions,',
'flow_language,',
'application_comments,',
'application_type,',
'ui_type',
'from (',
'    select',
'        f.id app_id,',
'        f.id,',
'        -- 2',
'        ''#IMAGE_PREFIX#f_spacer.gif'' img,',
'        -- 3',
'        (select max(name)',
'           from wwv_flow_authentications a',
'          where a.id = f.authentication_id',
'        ) as authentication_scheme,',
'        -- 4',
'        decode(f.build_status,',
'          ''RUN_ONLY'',',
'          ''f?p=4000:733:''||:app_session||''::::FB_FLOW_ID:''||f.id,',
'          ''f?p=4000:1:''||:app_session||''::''||:DEBUG||',
'               '':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||f.id||'',''||f.id||'',''||f.id',
'        ) link,',
'        --',
'        f.name||decode(f.build_status,''RUN_ONLY'','' - ''||sm.run_only,null) name,',
'        --',
'        f.name as app_name,',
'        --f.id||''. ''||f.name||decode(build_status,''RUN_ONLY'','' - ''||sm.run_only,null) app_name,',
'        -- 5',
'        f.app_builder_icon_name,',
'        f.files_version,',
'        f.owner,',
'        null as image_class,',
'        -- 6',
'        decode(f.build_status,',
'          ''RUN_AND_BUILD'', sm.run_and_build,',
'          ''RUN_ONLY'',sm.run_only,',
'          f.build_status) build_status,',
'        -- 6.5',
'        decode(f.flow_status, ',
'            ''AVAILABLE'', sm.available,',
'            ''AVAILABLE_W_EDIT_LINK'', sm.available_with_edit_links,',
'            ''DEVELOPERS_ONLY'', sm.available_to_developers_only,',
'            ''UNAVAILABLE_URL'', sm.unavailable_redirect_to_url, ',
'            ''UNAVAILABLE_PLSQL'', sm.unavailable_plsql,',
'            ''RESTRICTED_ACCESS'', sm.restricted_access,',
'            ''UNAVAILABLE'', sm.unavailable,',
'            f.flow_status) flow_status,',
'        -- 7',
'        f.LAST_UPDATED_ON,',
'        -- 8',
'        (select count(*)',
'          from wwv_flow_steps',
'          where flow_id = f.id)',
'          page_count,',
'        -- 9',
'        f.id manage,',
'        -- 10',
'        f.last_updated_on updated,',
'        lower(f.last_updated_by) last_updated_by,',
'        f.created_on created,',
'        lower(f.created_by) created_by,',
'        -- 16',
'        ''<button type="button" class="a-Button a-Button--noLabel a-Button--withIcon launch-aut a-Button--noUI" data-link="'' || wwv_flow_dev.get_run_url(f.id)||',
'        ''" title="''||wwv_flow_lang.system_message(''RUN_APPLICATION_ID'', f.id)||''" aria-label="''||wwv_flow_lang.system_message(''RUN_APPLICATION_ID'', f.id)||''">''||',
'        ''<span class="a-Icon icon-run-page" aria-hidden="true"></span></button>'' as actions,',
'        decode(group_id,null,sm.t_unassigned,',
'            (select max(group_name) n',
'            from wwv_flow_application_groups',
'            where id = f.group_id))',
'          Groupname,',
'        decode(f.build_status,',
'            ''RUN_ONLY'',',
'            ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(f.id)||''" class="launch-aut a-Button a-Button--noUI a-AppCards-button" title="''||sm.run||''">''||',
'            ''<span class="a-Icon icon-run-page"></span></button>'',',
'            ''RUN_AND_HIDDEN'',',
'              ''<span class="a-Button a-Button--noUI a-AppCards-button" title="''||sm.locked||''"><span class="a-Icon icon-lock"></span><span class="u-VisuallyHidden">''||sm.locked||''</span></span>''||',
'              ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(f.id)||''" class="launch-aut a-Button a-Button--noUI a-AppCards-button" title="''||sm.run||''">''||',
'              ''<span class="a-Icon icon-run-page"></span></button>'',',
'            ''<button onclick="apex.navigation.redirect(''''f?p=4000:1:''||:app_session||''::''||:DEBUG||'':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||f.id||'',''||',
'              f.id||'',''||f.id||'''''');" type="button" class="a-Button a-Button--noUI a-AppCards-button" title="''||sm.edit||''"><span class="a-Icon icon-edit"></span></button>''||',
'            ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(f.id)||''" class="launch-aut a-Button a-Button--noUI a-AppCards-button" title="''||sm.run||''">''||',
'              ''<span class="a-Icon icon-run-page"></span></button>''',
'        ) action_buttons,',
'        -- 17',
'        (select max(name)',
'           from   wwv_flow_security_schemes',
'           where flow_id = f.id and to_char(id) = f.SECURITY_SCHEME)',
'           application_security_scheme,',
'        -- 18',
'        f.ALIAS,',
'        -- 20',
'        f.WEBDB_LOGGING logging,',
'        -- 21',
'        f.FLOW_VERSION,',
'        -- 22',
'        f.GLOBAL_NOTIFICATION,',
'        -- 23',
'        decode(f.PAGE_PROTECTION_ENABLED_Y_N,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          sm.t_no)',
'          PAGE_PROTECTION_ENABLED_Y_N,',
'        -- 24',
'        decode(f.REJOIN_EXISTING_SESSIONS,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          REJOIN_EXISTING_SESSIONS)',
'          REJOIN_EXISTING_SESSIONS,',
'        -- 25',
'        f.FLOW_LANGUAGE,',
'        -- 26',
'        (select sys.dbms_lob.substr(banner,1000,1) from wwv_flow_banner b where id = f.id) application_comments,',
'        -- 28',
'        sm.app_type_database application_type,',
'        (select case',
'                  when count(*) > 1 then min(t.display_name)||'', ''||max(t.display_name)',
'                  else min(t.display_name)',
'                end display_name',
'           from wwv_flow_user_interfaces i, wwv_flow_ui_types_dev t',
'          where i.ui_type_id = t.id',
'            and flow_id = f.id) ui_type',
'    from   wwv_flow_visible_flows f,',
'          (select wwv_flow_lang.system_message(''RUN'') run,',
'                  wwv_flow_lang.system_message(''EDIT'') edit,',
'                  wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'                  wwv_flow_lang.system_message(''F4000_F1500_LOCKED'') locked,',
'                  wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'                  wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                  wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'                  wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'                  wwv_flow_lang.system_message(''APP_TYPE_WEBSHEET'') app_type_websheet,',
'                  wwv_flow_lang.system_message(''APP_TYPE_DATABASE'') app_type_database,',
'                  wwv_flow_lang.system_message(''APP_TYPE_PACKAGED'') app_type_packaged,',
'                  wwv_flow_lang.system_message(''APP_TYPE_PACKAGED_WS'') app_type_packaged_ws,',
'                  wwv_flow_lang.system_message(''AVAILABLE'') available,',
'                  wwv_flow_lang.system_message(''AVAILABLE_WITH_EDIT_LINKS'') available_with_edit_links,',
'                  wwv_flow_lang.system_message(''AVAILABLE_TO_DEVELOPERS_ONLY'') available_to_developers_only,',
'                  wwv_flow_lang.system_message(''RESTRICTED_ACCESS'') restricted_access,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'') unavailable_plsql,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_REDIRECT_TO_URL'') unavailable_redirect_to_url,                                        ',
'',
'                                                  ',
'                  wwv_flow_lang.system_message(''UNAVAILABLE'') unavailable                                                                         ',
'',
'                                   ',
'           from dual) sm',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or (:P1500_SHOW = ''DATABASE''))',
'    union all',
'    select',
'        f.id app_id,',
'        f.id,',
'        -- 2',
'        ''#IMAGE_PREFIX#f_spacer.gif'' img,',
'        -- 3',
'        ''TBD'' authentication_scheme,',
'        -- 4',
'        ''f?p=4000:933:''||:app_session||''::''||:DEBUG||'':RP:P933_ID:''||f.id link,',
'        --',
'        f.name name,',
'        f.name as app_name,',
'        -- 5',
'        null as app_builder_icon_name,',
'        null as files_version,',
'        f.owner,',
'        null as image_class,',
'        -- 6',
'        null build_status,',
'        -- 6.5',
'        decode(f.STATUS, ''AVAILABLE'', sm.available, ''UNAVAILABLE'', sm.unavailable, f.status) flow_status,',
'        -- 7',
'        f.updated_on LAST_UPDATED_ON,',
'        -- 8',
'        (select count(*) c from WWV_FLOW_WS_WEBPAGES where WS_APP_ID = f.id) page_count,',
'        -- 9',
'        f.id manage,',
'        -- 10',
'        f.updated_on updated,',
'        lower(f.updated_by) last_updated_by,',
'        f.created_on created,',
'        lower(f.created_by) created_by,',
'        -- 16',
'        ''<button type="button" data-link="ws?p=''||f.id||'':home:''||:app_session ||',
'          ''" title="''||wwv_flow_lang.system_message(''RUN_APPLICATION_ID'', f.id)||',
'          ''" aria-label="''||wwv_flow_lang.system_message(''RUN_APPLICATION_ID'', f.id)||',
'          ''" class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI launch-aut"><span class="a-Icon icon-run-page" aria-hidden="true"></span></button>'' as actions,',
'        ''N/A''  Groupname,',
'        ''<button onclick="apex.navigation.redirect(''''f?p=4000:933:''||:app_session||''::''||:DEBUG||'':RP:P933_ID:''||f.id||'''''');" class="a-Button a-Button--noUI a-AppCards-button" title="''||',
'            sm.edit||''" type="button"><span class="a-Icon icon-edit"></span></button><button data-link="ws?p=''||f.id||'':home:''||:app_session||''" type="button" class="a-Button a-Button--noUI a-AppCards-button launch-aut" title="''||sm.run||',
'            ''"><span class="a-Icon icon-run-page"></span></button>''  action_buttons,',
'        -- 17',
'        ''N/A'' application_security_scheme,',
'        -- 18',
'        ''N/A'' ALIAS,',
'        -- 20',
'        ''Y''  logging,',
'        -- 21',
'        ''N/A'' FLOW_VERSION,',
'        -- 22',
'        ''N/A'' GLOBAL_NOTIFICATION,',
'        -- 23',
'        ''N/A'' PAGE_PROTECTION_ENABLED_Y_N,',
'        -- 24',
'        ''N/A''  REJOIN_EXISTING_SESSIONS,',
'        -- 25',
'        ''N/A'' FLOW_LANGUAGE,',
'        -- 26',
'        f.DESCRIPTION application_comments,',
'        -- 28',
'        --sm.app_type_websheet application_type,',
'        sm.app_type_websheet application_type,',
'        --',
'        ''Desktop'' ui_type',
'    from  WWV_FLOW_WS_APPLICATIONS f,',
'          (select wwv_flow_lang.system_message(''RUN'') run,',
'                  wwv_flow_lang.system_message(''EDIT'') edit,',
'                  wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'                  wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'                  wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                  wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'                  wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'                  wwv_flow_lang.system_message(''APP_TYPE_WEBSHEET'') app_type_websheet,',
'                  wwv_flow_lang.system_message(''APP_TYPE_DATABASE'') app_type_database,',
'                  wwv_flow_lang.system_message(''APP_TYPE_PACKAGED'') app_type_packaged,',
'                  wwv_flow_lang.system_message(''APP_TYPE_PACKAGED_WS'') app_type_packaged_ws,',
'                  wwv_flow_lang.system_message(''UI_TYPE.DESKTOP'') ui_type,',
'                  wwv_flow_lang.system_message(''AVAILABLE'') available,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE'') unavailable',
'           from sys.dual ) sm',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or :P1500_SHOW = ''WEBSHEET'')',
'      and f.security_group_id = :flow_security_group_id',
'      and exists (',
'           select 1 from wwv_flow_developers',
'           where userid            = :flow_user',
'             and (flow_id is null  or flow_id = f.id)',
'             and security_group_id = :flow_security_group_id)',
')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX mjh4000P1500a */',
'1 x',
'from (',
'    select',
'       1 x',
'    from   wwv_flow_visible_flows f',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or (:P1500_SHOW = ''DATABASE''))',
'    union all',
'    select',
'        1 x',
'    from  WWV_FLOW_WS_APPLICATIONS f',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or :P1500_SHOW = ''WEBSHEET'')',
'      and f.security_group_id = :flow_security_group_id',
'      and exists (',
'           select 1 from wwv_flow_developers',
'           where userid            = :flow_user',
'             and (flow_id is null  or flow_id = f.id)',
'             and security_group_id = :flow_security_group_id)',
')'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_comment=>'decode(greatest(length(f.id),12),12,f.id,substr(f.id,length(f.id)-2))||''. ''||'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3519715528105919.4001)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ninguna aplicaci\00F3n.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AppCards-item">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#LINK#" class="a-AppCards-link">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon a-AppCards-icon--initials #IMAGE_CLASS# #APP_COLOR#" role="presentation" aria-hidden="true">#APP_INITIALS# #APP_BUILDER_ICON_NAME#</span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="card-content-1">',
'      <div class="a-AppCards-name">#APP_NAME#</div>',
'      <div class="a-AppCards-info">#ID#</div>',
'    </div>',
'    </a>',
'    <div class="a-AppCards-actionsContainer">#ACTION_BUTTONS#</div>',
'  </div>',
'</div>'))
,p_icon_view_columns_per_row=>4
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3519905658105931.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520017814105932.4001)
,p_db_column_name=>'LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520113521105932.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520318233105933.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520423605105934.4001)
,p_db_column_name=>'PAGE_COUNT'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>unistr('P\00E1ginas')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520529322105934.4001)
,p_db_column_name=>'MANAGE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Gestionar'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520621184105934.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('Fecha de Actualizaci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520703738105934.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520902515105935.4001)
,p_db_column_name=>'GROUPNAME'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Grupo'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3520811936105934.4001)
,p_db_column_name=>'ACTIONS'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Ejecutar'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3523831823141678.4001)
,p_db_column_name=>'IMG'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>unistr('Imagen de Aplicaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3537807039295421.4001)
,p_db_column_name=>'APP_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Aplicaci\00F3n y Nombre')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3542603454360548.4001)
,p_db_column_name=>'AUTHENTICATION_SCHEME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Esquema de Autenticaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3551214030477137.4001)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Estado de Creaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3581532429261162.4001)
,p_db_column_name=>'APPLICATION_SECURITY_SCHEME'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>unistr('Esquema de Seguridad de Aplicaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3582423125286836.4001)
,p_db_column_name=>'ALIAS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3582600555286836.4001)
,p_db_column_name=>'LOGGING'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Registro'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3582723933286837.4001)
,p_db_column_name=>'FLOW_VERSION'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Versi\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3582821814286837.4001)
,p_db_column_name=>'GLOBAL_NOTIFICATION'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Notificaci\00F3n Global')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3584127543307048.4001)
,p_db_column_name=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>unistr('Protecci\00F3n de P\00E1gina Activada')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3585305688348052.4001)
,p_db_column_name=>'REJOIN_EXISTING_SESSIONS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Volver a Conectar las Sesiones Existentes'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3586309891377567.4001)
,p_db_column_name=>'FLOW_LANGUAGE'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3821105214186324.4001)
,p_db_column_name=>'APPLICATION_COMMENTS'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Comentarios'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3929918685985572.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3942125613042968.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(181276524421267982.4001)
,p_db_column_name=>'APPLICATION_TYPE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_display_condition_type=>'ITEM_IS_ZERO'
,p_display_condition=>'P1500_SHOW'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22888825718150978.4001)
,p_db_column_name=>'IMAGE_CLASS'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'IMAGE_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(33317208953356542.4001)
,p_db_column_name=>'APP_ID'
,p_display_order=>37
,p_column_identifier=>'AK'
,p_column_label=>'APP_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47962908515907364.4001)
,p_db_column_name=>'UI_TYPE'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'Interfaz de Usuario'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(373158432475904924.4001)
,p_db_column_name=>'ACTION_BUTTONS'
,p_display_order=>40
,p_column_identifier=>'AN'
,p_column_label=>'ACTION_BUTTONS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(7056917561001344.4001)
,p_db_column_name=>'APP_OWNER'
,p_display_order=>41
,p_column_identifier=>'AO'
,p_column_label=>unistr('Esquema de An\00E1lisis')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(402738956454884729.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>43
,p_column_identifier=>'AQ'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(932667963082561029.4001)
,p_db_column_name=>'APP_COLOR'
,p_display_order=>53
,p_column_identifier=>'AS'
,p_column_label=>' APP_COLOR'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(932668000526561030.4001)
,p_db_column_name=>'APP_INITIALS'
,p_display_order=>63
,p_column_identifier=>'AT'
,p_column_label=>' APP_INITIALS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(879700787009493829.4001)
,p_db_column_name=>'APP_BUILDER_ICON_NAME'
,p_display_order=>73
,p_column_identifier=>'AV'
,p_column_label=>'Nombre del icono de creador de aplicaciones'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29130217457479689.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(63310734885303893.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_required_role=>wwv_flow_api.id(12510423405283164)
);
end;
/
begin
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48529419219231981.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El creador de aplicaciones permite dise\00F1ar, desarrollar y desplegar aplicaciones atractivas y r\00E1pidas.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-the-app-builder-home-page.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72199818188550801.4001)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-app-builder'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_APP_BUILDER'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_platform.get_preference(''GETTING_STARTED_ENABLED'') = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187075905864335205.4001)
,p_plug_name=>'Home Page Tabs'
,p_region_sub_css_classes=>'app-builder'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(787106333147859999.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(481294291606549740.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(187884704705159557.4001)
,p_name=>'Reciente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000P1500c */ substr(name,1,20)||'' - ''||',
'       decode(greatest(12,length(id)),12,id,',
'       substr(to_char(id),length(to_char(id))-3)) name, id,',
'       ''f?p=4000:933:''||:app_session||''::''||:DEBUG||'':RP:P933_ID:''||',
'          id the_link',
'from  WWV_FLOW_WS_APPLICATIONS f',
'where (nvl(:P1500_SHOW,''0'') = ''0'' or :P1500_SHOW = ''WEBSHEET'')',
'  and security_group_id = :flow_security_group_id',
'  and exists (',
'       select 1 from wwv_flow_developers',
'        where userid            = :flow_user',
'          and (flow_id is null  or flow_id = f.id)',
'          and security_group_id = :flow_security_group_id)',
'order by nvl(updated_on, created_on) desc'))
,p_display_when_condition=>'P1500_SHOW'
,p_display_when_cond2=>'WEBSHEET'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna aplicaci\00F3n.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>90
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(187884900871159579.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_link=>'#THE_LINK#'
,p_column_linktext=>'#NAME#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(187885015244159582.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(455665015881659921.4001)
,p_query_column_id=>3
,p_column_alias=>'THE_LINK'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(187904014130417729.4001)
,p_name=>'Reciente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'a-LinksList--showArrow'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000P1500d */ name, id, the_link, the_date',
'from',
'(',
'select name, ',
'       id,',
'       ''f?p=4000:1:''||:app_session||',
'           ''::NO::FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||',
'           f.id||'',''||f.id||'',''||f.id||'','' the_link,    ',
'       nvl(last_updated_on, created_on) the_date',
'from wwv_flow_visible_flows f',
'where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'union all',
'select substr(name,1,20)||'' - ''||',
'       decode(greatest(12,length(id)),12,id,',
'       substr(to_char(id),length(to_char(id))-3))||''*'' name, ',
'       id,',
'       ''f?p=4000:933:''||:app_session||''::''||:DEBUG||'':RP:P933_ID:''||',
'          id the_link,',
'       nvl(updated_on, created_on) the_date',
'from  WWV_FLOW_WS_APPLICATIONS f',
'where (nvl(:P1500_SHOW,''0'') = ''0'' or :P1500_SHOW = ''WEBSHEET'')',
'  and security_group_id = :flow_security_group_id',
'  and exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user',
'         and (flow_id is null or flow_id = f.id)',
'         and security_group_id = :flow_security_group_id)',
') x',
'order by 4 desc'))
,p_display_when_condition=>'P1500_SHOW'
,p_display_when_cond2=>'0'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ninguna aplicaci\00F3n.')
,p_query_row_count_max=>5
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(187904301093417759.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_link=>'#THE_LINK#'
,p_column_linktext=>'<strong>#ID#</strong> #NAME#'
,p_column_link_attr=>'class="a-LinksList-link"'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(187904418140417760.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(187904532601417760.4001)
,p_query_column_id=>3
,p_column_alias=>'THE_LINK'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(187911209038548687.4001)
,p_query_column_id=>4
,p_column_alias=>'THE_DATE'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(583532143777956101.4001)
,p_plug_name=>'Comenzar Ahora'
,p_region_css_classes=>'u-Block--hero'
,p_region_sub_css_classes=>'a-MediaList--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(583541659513985598.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_required_role=>wwv_flow_api.id(12510423405283164)
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX mjh4000P1500a */',
'1 x',
'from (',
'    select',
'       1 x',
'    from   wwv_flow_visible_flows f',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or (:P1500_SHOW = ''DATABASE''))',
'    union all',
'    select',
'        1 x',
'    from  WWV_FLOW_WS_APPLICATIONS f',
'    where (nvl(:P1500_SHOW,''0'') = ''0'' or :P1500_SHOW = ''WEBSHEET'')',
'      and f.security_group_id = :flow_security_group_id',
'      and exists (',
'           select 1 from wwv_flow_developers',
'           where userid            = :flow_user',
'             and (flow_id is null  or flow_id = f.id)',
'             and security_group_id = :flow_security_group_id)',
')'))
,p_plug_header=>'<h1 class="u-Block-title">Comenzar Ahora</h1>'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(72199919976550802.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(72199818188550801.4001)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Introducci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/go/get_started_app_builder'');'
,p_button_css_classes=>'a-Button--dark'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181175108109610410.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(3519628466105919.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:1500,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4026923083647186.4001)
,p_button_sequence=>21
,p_button_plug_id=>wwv_flow_api.id(3519628466105919.4001)
,p_button_name=>'IMPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Importar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT'
,p_button_condition_type=>'NEVER'
,p_security_scheme=>wwv_flow_api.id(12472323342703137)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486429524043243546.4001)
,p_button_sequence=>31
,p_button_plug_id=>wwv_flow_api.id(3519628466105919.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Exportar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1338904799030874.4001)
,p_button_sequence=>51
,p_button_plug_id=>wwv_flow_api.id(3519628466105919.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_css_classes=>'a-Button--padLeft a-Button--strongLabel'
,p_icon_css_classes=>'icon-right-chevron'
,p_security_scheme=>wwv_flow_api.id(12472323342703137)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42239228505367502.4001)
,p_branch_name=>'Create Database Application'
,p_branch_action=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1338904799030874.4001)
,p_branch_sequence=>1
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1500_SHOW'
,p_branch_condition_text=>'0'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42112802617991009.4001)
,p_branch_name=>'Create Database Application'
,p_branch_action=>'f?p=&APP_ID.:56:&SESSION.:CC:&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID:1,'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1338904799030874.4001)
,p_branch_sequence=>5
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1500_SHOW'
,p_branch_condition_text=>'DATABASE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42223327934301042.4001)
,p_branch_name=>'Create Database Application'
,p_branch_action=>'f?p=&APP_ID.:78:&SESSION.::&DEBUG.:78,279::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1338904799030874.4001)
,p_branch_sequence=>6
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1500_SHOW'
,p_branch_condition_text=>'WEBSHEET'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1317920298973522.4001)
,p_branch_action=>'f?p=&FLOW_ID.:1500:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181284428380429915.4001)
,p_name=>'P1500_SHOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3519628466105919.4001)
,p_item_default=>'0'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486772593681301735.4001)
,p_name=>'P1500_SHOW_DISPLAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3519628466105919.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tipo'
,p_source=>'P1500_SHOW'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APP_TYPE_SELECTION'
,p_lov=>'.'||wwv_flow_api.id(1427060334943927449.4001)||'.'
,p_colspan=>3
,p_display_when=>'P1500_SHOW'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(188943122461031697.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1500_SHOW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
,p_compute_when=>'P1500_SHOW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(446084225930445615.4001)
,p_name=>'IRR DETAILS LINK CLICKED'
,p_event_sequence=>10
,p_triggering_element_type=>'DOM_OBJECT'
,p_triggering_element=>'showDetailsLeft'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446084516482445618.4001)
,p_event_id=>wwv_flow_api.id(446084225930445615.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'li.extra'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446085322944454175.4001)
,p_event_id=>wwv_flow_api.id(446084225930445615.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'DOM_OBJECT'
,p_affected_elements=>'showDetailsLeft'
,p_attribute_01=>'disabled'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446085930216456282.4001)
,p_event_id=>wwv_flow_api.id(446084225930445615.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'DOM_OBJECT'
,p_affected_elements=>'showTerseRight'
,p_attribute_01=>'disabled'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446087308184459400.4001)
,p_event_id=>wwv_flow_api.id(446084225930445615.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'li.list_item div.left'
,p_attribute_01=>'nomargin'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(446096204468515062.4001)
,p_name=>'IRR TERSE LINK CLICKED'
,p_event_sequence=>20
,p_triggering_element_type=>'DOM_OBJECT'
,p_triggering_element=>'showTerseRight'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446097725377530587.4001)
,p_event_id=>wwv_flow_api.id(446096204468515062.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'li.extra'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446097900228532781.4001)
,p_event_id=>wwv_flow_api.id(446096204468515062.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'DOM_OBJECT'
,p_affected_elements=>'showDetailsLeft'
,p_attribute_01=>'disabled'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446101618938613836.4001)
,p_event_id=>wwv_flow_api.id(446096204468515062.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'DOM_OBJECT'
,p_affected_elements=>'showTerseRight'
,p_attribute_01=>'disabled'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(446101827942616436.4001)
,p_event_id=>wwv_flow_api.id(446096204468515062.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'li.list_item div.left'
,p_attribute_01=>'nomargin'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1318808861975245.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>':request = ''GO'' or :request is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(879700937980493831.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Friendly URL Cache'
,p_process_sql_clob=>'wwv_flow_utilities.reset_friendly_url_cache;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01600
begin
wwv_flow_api.create_page(
 p_id=>1600.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'SQL activado para REST'
,p_step_title=>'SQL activado para REST'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(153971260438479912.4001)
,p_plug_name=>'SQL activado para REST'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="border-bottom-width: 0;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Cree un servicio de <strong>SQL activado para REST</strong> para ejecutar SQL o PL/SQL definidos en componentes de &PRODUCT_NAME. en una base de datos remota de Oracle. </p>',
'',
unistr('<p><strong>Requisito:</strong> la base de datos remota debe incluir la versi\00F3n 17.3 de Oracle REST Data Services (ORDS) o posterior en el front-end y tener activada la funci\00F3n <em>SQL activado para REST</em>. Todos los SQL y PL/SQL se env\00EDan a la ins')
||'tancia de ORDS que lo ejecuta en la base de datos remota. </p>',
'',
'<p>Las referencias de SQL activado para REST se almacenan en el nivel de espacio de trabajo y, por lo tanto, son visibles en todas las aplicaciones.</p>',
'',
unistr('<p>Al exportar una aplicaci\00F3n, las referencias de SQL activado para REST utilizadas se agregan al archivo de exportaci\00F3n. Si exporta una aplicaci\00F3n y la importa a otro espacio de trabajo, &PRODUCT_NAME. comprueba si el espacio de trabajo de destino y')
||unistr('a contiene referencias de SQL activado para REST con el mismo <strong>ID est\00E1tico</strong>. Si ya existe una referencia de SQL activado para REST, la aplicaci\00F3n utiliza la referencia existente. Si la referencia no existe, se crea en el espacio de tra')
||'bajo.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157709882691474177.4001)
,p_plug_name=>'SQL activado para REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   id,',
'   server_name,',
'   base_url,',
'   authentication_type,',
'   wwv_flow_utilities.prepare_url(''f?p=4000:1601:'' || :APP_SESSION || '':::1601:P1601_ID:'' || id ) as link,',
'   ''icon-admin-workspace-preferences'' as img,',
'   wwv_flow_utilities.prepare_url(''f?p=4000:1605:'' || :APP_SESSION || ''::''|| :DEBUG || '':1605:P1605_ID:'' || id) as test_link,',
'   prompt_on_install,',
'   LAST_UPDATED_BY updated_by,',
'   LAST_UPDATED_ON updated,',
'   created_by,',
'   created_on created',
'from   wwv_remotesql_servers_dev ',
'where  security_group_id = :flow_security_group_id',
'       '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(157709960601474178.4001)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se han definido servicios de SQL activado para REST para esta aplicaci\00F3n')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#SERVER_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>157709960601474178
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3052575721563938907.4001)
,p_db_column_name=>'SERVER_NAME'
,p_display_order=>10
,p_column_identifier=>'AI'
,p_column_label=>'Nombre de servidor remoto'
,p_column_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP,1601:P1601_ID:#ID#'
,p_column_linktext=>'#SERVER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153984861179443609.4001)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'AF'
,p_column_label=>'URL Base'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3052578113918938931.4001)
,p_db_column_name=>'AUTHENTICATION_TYPE'
,p_display_order=>40
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Autenticaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(154078822199034715)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153984042837443601.4001)
,p_db_column_name=>'PROMPT_ON_INSTALL'
,p_display_order=>50
,p_column_identifier=>'Z'
,p_column_label=>unistr('Solicitar en la instalaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(84282932564530536)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154842584477613405.4001)
,p_db_column_name=>'TEST_LINK'
,p_display_order=>100
,p_column_identifier=>'AK'
,p_column_label=>'Probar'
,p_column_link=>'#TEST_LINK#'
,p_column_linktext=>'<span class="a-Icon icon-test" aria-hidden="true"></span>'
,p_column_link_attr=>'class="a-Button a-Button--noLabel a-Button--withIcon" title="Test REST Enabled SQL service"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153973855601423124.4001)
,p_db_column_name=>'ID'
,p_display_order=>120
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153975442049423125.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>130
,p_column_identifier=>'I'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153975813538423126.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>140
,p_column_identifier=>'J'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153979818872423130.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>150
,p_column_identifier=>'S'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153980278651423131.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>160
,p_column_identifier=>'T'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153984992820443610.4001)
,p_db_column_name=>'IMG'
,p_display_order=>170
,p_column_identifier=>'AG'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(153985068941443611.4001)
,p_db_column_name=>'LINK'
,p_display_order=>180
,p_column_identifier=>'AH'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(201881278673987178.4001)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(154051976265844427.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(353023904549052201.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/accessing-data-remotely-using-rest-enabled-sql.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(153981816740423137.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(157709882691474177.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:1600,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(153982299781423142.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(157709882691474177.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.:1601,1615,1616,1617::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(153983771122423173.4001)
,p_branch_name=>'Go To Page 1600'
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_01601
begin
wwv_flow_api.create_page(
 p_id=>1601.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar servicio de SQL activado para REST'
,p_step_title=>'Editar servicio de SQL activado para REST'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(153986959989443630.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(153988550198443646.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154005373611060238.4001)
,p_plug_name=>'SQL activado para REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(333897496146382780.4001)
,p_plug_name=>'SQL activado para REST'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Las referencias de <strong>SQL activado para REST</strong> permiten ejecutar SQL o PL/SQL en los componentes de &PRODUCT_NAME. en una base de datos remota.</p>',
unistr('<p>La base de datos remota debe incluir la versi\00F3n 17.3 o superior de Oracle REST Data Services (ORDS) en el front-end y tener la funci\00F3n activada de SQL activado para REST. Todos los SQL y PL/SQL se env\00EDan a la instancia de ORDS que los ejecuta en l')
||'a base de datos remota.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(522797333502429241.4001)
,p_plug_name=>unistr('Sesi\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(769522898980777165.4001)
,p_plug_name=>'SQL activado para REST'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154012466182512518.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(769522898980777165.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP,1601::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154012811972512518.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(769522898980777165.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154013205409512518.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(769522898980777165.4001)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(153985174039443612.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(769522898980777165.4001)
,p_button_name=>'APPLY_CHANGES_TEST'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--primary:a-Button--gapRight'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Guardar y probar'
,p_button_position=>'NEXT'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154013634117512519.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(769522898980777165.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(241341925211308330.4001)
,p_branch_name=>'Go To Page 1605'
,p_branch_action=>'f?p=&APP_ID.:1605:&SESSION.::&DEBUG.:RP:P1605_ID,P1605_BACK_TO_PAGE:&P1601_ID.,&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(153985174039443612.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154016320786512532.4001)
,p_branch_name=>'Go To Page 1600'
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP,1600::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'',''Update'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154016749703512532.4001)
,p_branch_name=>'Go To Page 1601'
,p_branch_action=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(310375518625241826.4001)
,p_branch_name=>'Go To Page 1621'
,p_branch_action=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:RP:P1621_ID,P1621_BACK_TO_PAGE:&P1601_CRED_STORE.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_CREDENTIAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48102664737492249.4001)
,p_name=>'P1601_CREDENTIALS_STATIC_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(153986959989443630.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'CREDENTIAL_STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153984709487443608.4001)
,p_name=>'P1601_CRED_STORE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(154005373611060238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credenciales'
,p_post_element_text=>'<a href="#" id="P1601_EDIT_CREDENTIAL_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''EDIT_CREDENTIAL'')" tabindex="0"><span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">Editar'
||' credencial</span></a>'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Introducir credenciales nuevas -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la credencial para autenticar. Para editar la credencial, vaya a <strong>Credenciales web</strong> en <strong>Componentes compartidos</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153985439821443615.4001)
,p_name=>'P1601_CLIENT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(153986959989443630.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID de cliente o nombre de usuario'
,p_source=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Para la autenticaci\00F3n b\00E1sica, introduzca el nombre del usuario de base de datos. Para OAuth2, introduzca el ID de cliente. Esta informaci\00F3n no estar\00E1 cifrada. Los nombres de usuario de la autenticaci\00F3n b\00E1sica aparecer\00E1n en may\00FAsculas. Para incluir un')
||unistr(' nombre de usuario sensible a may\00FAsculas/min\00FAsculas, introduzca un signo de exclamaci\00F3n (!) como prefijo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153985529999443616.4001)
,p_name=>'P1601_SECRET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(153986959989443630.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Secreto de cliente o contrase\00F1a')
,p_source=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a o el secreto del cliente OAuth2. Esta informaci\00F3n se almacena cifrada y no se puede recuperar en texto no cifrado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153985605261443617.4001)
,p_name=>'P1601_SECRET_VERIFY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(153986959989443630.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Verificar secreto de cliente o contrase\00F1a')
,p_source=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a o el secreto del cliente de nuevo para verificar los datos introducidos. Si los dos valores no coinciden, se muestra un mensaje de error.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153985789234443618.4001)
,p_name=>'P1601_CREDENTIALS_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(153986959989443630.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'OAUTH2_CLIENT_CREDENTIALS'
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el tipo de autenticaci\00F3n. Oracle Application Express soporta la autenticaci\00F3n b\00E1sica y los flujos de credenciales de cliente OAuth2.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153987628718443637.4001)
,p_name=>'P1601_AUTH_REQUIRED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(154005373611060238.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Autenticaci\00F3n necesaria')
,p_source=>'AUTH_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'P1601_AUTH_REQUIRED'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(153988391997443644.4001)
,p_name=>'P1601_CREDENTIALS_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(153986959989443630.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Credencial'
,p_source=>'CREDENTIAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre descriptivo para las credenciales.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154006048431512498.4001)
,p_name=>'P1601_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(154005373611060238.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154007391988512510.4001)
,p_name=>'P1601_REMOTE_SERVER_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(154005373611060238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'SERVER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre descriptivo para este servicio SQL activado para REST.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154008223755512511.4001)
,p_name=>'P1601_BASE_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(154005373611060238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Punto Final'
,p_source=>'BASE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la URL base para este servicio de SQL activado para REST. Incluya la ra\00EDz de contexto de ORDS y el prefijo de la URL de esquema, pero <strong>no</strong> agregue <code>/_/sql</code>. Por ejemplo:'),
'<pre>',
'https://{host}:{port}/ords/{schema}',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154010015683512514.4001)
,p_name=>'P1601_PROMPT_ON_INSTALL'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(154005373611060238.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Solicitar en la instalaci\00F3n')
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si desea que se muestren peticiones de datos para este servicio SQL activado para REST cuando se est\00E9 importando la aplicaci\00F3n a otra instancia de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154010941690512516.4001)
,p_name=>'P1601_COMMENT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(153988550198443646.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'SERVER_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249347881467883022.4001)
,p_name=>'P1601_HTTPS_HOST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(153988550198443646.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de host de HTTP'
,p_source=>'HTTPS_HOST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>500
,p_display_when=>'not ( sys.dbms_db_version.version <= 11 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 1 ) )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de host que va a coincidir con el nombre com\00FAn (CN) del certificado de servidor remoto de una solicitud HTTPS. Tambi\00E9n puede ser un nombre de dominio como *.ejemplo.com. Si es nulo, se utilizar\00E1 el nombre de host de la URL especificada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348489209217006010.4001)
,p_name=>'P1601_ORDS_TIMEZONE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(153988550198443646.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Zona Horaria del Servidor'
,p_source=>'ORDS_TIMEZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P1601_ORDS_TIMEZONE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Zona horaria que utiliza el servicio de SQL activado para REST para descodificar los valores DATE y TIMESTAMP. Este valor se actualizar\00E1 con cada operaci\00F3n <strong>de prueba del servicio</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522796518715429233.4001)
,p_name=>'P1601_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(153988550198443646.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador Est\00E1tico')
,p_source=>'SERVER_STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia al servidor remoto en llamadas de API. El ID est\00E1tico tambi\00E9n se utiliza para identificar un servidor remoto existente cuando la aplicaci\00F3n se exporta o importa a otro espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522797185889429239.4001)
,p_name=>'P1601_ORDS_INIT_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(522797333502429241.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo de inicializaci\00F3n')
,p_source=>'ORDS_INIT_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el c\00F3digo de ejecuci\00F3n inmediata tras la conexi\00F3n al servicio de SQL activado para REST y anterior a la ejecuci\00F3n de SQL de componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522797255228429240.4001)
,p_name=>'P1601_ORDS_CLEANUP_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(522797333502429241.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo de limpieza')
,p_source=>'ORDS_CLEANUP_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el c\00F3digo de ejecuci\00F3n inmediata tras la ejecuci\00F3n de SQL de componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(153988290843443643.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1601_CRED_STORE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1601_AUTH_REQUIRED'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(310377232133241843.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1601_CLIENT_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when substr( :P1601_CLIENT_ID, 1, 1 ) = ''!'' then substr( :P1601_CLIENT_ID, 2 ) else upper( :P1601_CLIENT_ID ) end'
,p_compute_when=>'P1601_CREDENTIALS_TYPE'
,p_compute_when_text=>'BASIC'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(153988642196443647.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1601_AUTH_REQUIRED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1601_CRED_STORE is null then ''N'' else ''Y'' end'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154843302877613413.4001)
,p_validation_name=>'Client ID is required'
,p_validation_sequence=>10
,p_validation=>'P1601_CLIENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El ID de cliente o el nombre de usuario son necesarios.'
,p_validation_condition=>'wwv_flow.g_request in ( ''Create'', ''Update'' ) and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(153985439821443615.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249282048443575834.4001)
,p_validation_name=>'Credential name is required'
,p_validation_sequence=>20
,p_validation=>'P1601_CREDENTIALS_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se necesita el nombre de la credencial.'
,p_validation_condition=>'wwv_flow.g_request in ( ''Create'', ''Update'' ) and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(153988391997443644.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249282161166575835.4001)
,p_validation_name=>'Credential name must be unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1601_CREDENTIALS_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de credencial debe ser \00FAnico en la aplicaci\00F3n.')
,p_validation_condition=>'wwv_flow.g_request in ( ''Create'', ''Update'' ) and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(153988391997443644.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154843465078613414.4001)
,p_validation_name=>'Client Secret required'
,p_validation_sequence=>40
,p_validation=>'P1601_SECRET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El secreto del cliente o la contrase\00F1a son necesarios.')
,p_validation_condition=>'wwv_flow.g_request in (''Create'',''Update'') and :P1601_AUTH_REQUIRED =''Y''  and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(153985529999443616.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3052576145524938911.4001)
,p_validation_name=>'Client Secret = Client Secret Verify'
,p_validation_sequence=>50
,p_validation=>'P1601_SECRET'
,p_validation2=>'&P1601_SECRET_VERIFY.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Los secretos del cliente no coinciden.'
,p_validation_condition=>'wwv_flow.g_request in (''Create'',''Update'') and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(153985529999443616.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(537042265155394615.4001)
,p_validation_name=>'Cannot delete used REST Enabled SQL reference'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id',
'  from wwv_remote_servers s',
' where exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
' ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and s.id = :P1601_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El servicio de SQL activado para REST est\00E1 en uso y no se puede suprimir.')
,p_when_button_pressed=>wwv_flow_api.id(154012811972512518.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(153987372769443634.4001)
,p_name=>'Show / Hide Credential region'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_CRED_STORE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P1601_AUTH_REQUIRED").getValue() === ''N'' || apex.item("P1601_CRED_STORE").getValue() !== ""'
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'credentialchange'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(153987508434443636.4001)
,p_event_id=>wwv_flow_api.id(153987372769443634.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(153986959989443630.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310375366720241824.4001)
,p_event_id=>wwv_flow_api.id(153987372769443634.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1601_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310375257040241823.4001)
,p_event_id=>wwv_flow_api.id(153987372769443634.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1601_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48102799568492250.4001)
,p_event_id=>wwv_flow_api.id(153987372769443634.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CREDENTIALS_STATIC_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(153987404389443635.4001)
,p_event_id=>wwv_flow_api.id(153987372769443634.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(153986959989443630.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3052578068380938930.4001)
,p_event_id=>wwv_flow_api.id(153987372769443634.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CLIENT_ID,P1601_SECRET,P1601_SECRET_VERIFY,P1601_CREDENTIALS_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(153987715029443638.4001)
,p_name=>'Authentication Required'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_AUTH_REQUIRED'
,p_condition_element=>'P1601_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(153987839204443639.4001)
,p_event_id=>wwv_flow_api.id(153987715029443638.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CRED_STORE'
,p_attribute_01=>'N'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(153987969302443640.4001)
,p_event_id=>wwv_flow_api.id(153987715029443638.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CRED_STORE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3052577727217938927.4001)
,p_event_id=>wwv_flow_api.id(153987715029443638.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger($("#P1601_CRED_STORE"), "credentialchange")'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3052577805703938928.4001)
,p_event_id=>wwv_flow_api.id(153987715029443638.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger($("#P1601_CRED_STORE"), "credentialchange")'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3052577311421938923.4001)
,p_name=>'Credentials changed'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_CRED_STORE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3052577423757938924.4001)
,p_event_id=>wwv_flow_api.id(3052577311421938923.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger($("#P1601_CRED_STORE"), "credentialchange")'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(249347938803883023.4001)
,p_name=>'Show / Hide HTTPS_HOST'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_BASE_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1601_BASE_URL").startsWith("https://")'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not ( sys.dbms_db_version.version <= 11 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 1 ) )',
''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249348034183883024.4001)
,p_event_id=>wwv_flow_api.id(249347938803883023.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249348116012883025.4001)
,p_event_id=>wwv_flow_api.id(249347938803883023.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249348214178883026.4001)
,p_event_id=>wwv_flow_api.id(249347938803883023.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_HTTPS_HOST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154015043647512524.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from FLOW_REMOTESQL_SERVERS_DEV'
,p_attribute_02=>'WWV_REMOTESQL_SERVERS_DEV'
,p_attribute_03=>'P1601_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154015466867512528.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_REMOTESQL_SERVERS_DEV'
,p_attribute_02=>'WWV_REMOTESQL_SERVERS_DEV'
,p_attribute_03=>'P1601_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>unistr('Error al procesar la acci\00F3n.')
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_01602
begin
wwv_flow_api.create_page(
 p_id=>1602.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilizaci\00F3n de SQL activado para REST')
,p_step_title=>unistr('Utilizaci\00F3n de SQL activado para REST')
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(533155296022172840.4001)
,p_plug_name=>'Referencias de SQL activado para REST sin utilizar'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name remote_server_name',
'  from wwv_remote_servers s',
' where not exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
' ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name remote_server_name',
'  from wwv_remote_servers s',
' where not exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
' ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(533155433132172842.4001)
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se han encontrado referencias sin utilizar a servicios de SQL activados para REST.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>533155433132172842
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533155541909172843.4001)
,p_db_column_name=>'REMOTE_SERVER_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Servicio de SQL activado para REST sin utilizar'
,p_column_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP:P1601_ID:#ID#'
,p_column_linktext=>'#REMOTE_SERVER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533155644412172844.4001)
,p_db_column_name=>'ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(582915147453077309.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(154051976265844427.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(582915356920077309.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestra d\00F3nde se utiliza un servicio de SQL activado para REST en este espacio de trabajo.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(582915942830077311.4001)
,p_plug_name=>unistr('Utilizaci\00F3n de referencia de SQL activado para REST')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding-bottom: 20px"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       p.flow_id                                            the_application,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID,FB_FLOW_ID:''||r.page_id||'',''||p.flow_id) the_page, ',
'       ''#''                                                  the_shared_component,',
'       r.page_id                                            page_id,',
'       p.name                                               page_name,',
'       r.plug_source_type                                   plug_source_type,',
'       r.plug_name                                          plug_name,',
'       null                                                 shared_comp_name,',
'       s.name                                               remote_server_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_remote_servers s',
' where s.id                = r.remote_server_id',
'   and r.page_id           = p.id',
'   and r.flow_id           = p.flow_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = p.security_group_id',
'   and p.security_group_id = :flow_security_group_id',
'   and not exists ( select 1 from wwv_flow_language_map where translation_flow_id = p.flow_id )',
'union all (',
'select rs.id,',
'       p.flow_id                                            the_application,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID,FB_FLOW_ID:''||r.page_id||'',''||p.flow_id) the_page, ',
'       ''#''                                                  the_shared_component,',
'       r.page_id                                            page_id, ',
'       p.name                                               page_name, ',
'       r.plug_source_type                                   plug_source_type, ',
'       r.plug_name || '' - '' || s.name                       plug_name, ',
'       null                                                 shared_comp_name, ',
'       rs.name                                              remote_server_name',
'  from wwv_flow_jet_chart_series s,',
'       wwv_flow_jet_charts c,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_remote_servers rs',
' where rs.id               = s.remote_server_id',
'   and rs.server_type      = ''REMOTE_SQL''',
'   and p.flow_id           = r.flow_id',
'   and s.chart_id          = c.id',
'   and c.region_id         = r.id',
'   and r.page_id           = p.id',
'   and r.flow_id           = p.flow_id',
'   and p.security_group_id = :flow_security_group_id ',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = p.flow_id ) )',
'union all (',
'select s.id,',
'       l.flow_id                                            the_application,',
'       ''#''                                                  the_page,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:4111:''||:flow_session||'':::4111:F4000_P4111_ID,FB_FLOW_ID:''||l.id||'',''||l.flow_id) the_shared_component, ',
'       null                                                 page_id, ',
'       null                                                 page_name, ',
'       wwv_flow_lang.system_message( ''SHARED DYNAMIC LOV'' ) plug_source_type, ',
'       null                                                 plug_name, ',
'       l.lov_name                                           shared_comp_name, ',
'       s.name                                               remote_server_name',
'  from wwv_flow_lists_of_values$ l,',
'       wwv_remote_servers s',
' where s.id = l.remote_server_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = l.security_group_id',
'   and l.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = l.flow_id ) )',
'union all (',
'select s.id,',
'       a.flow_id                                            the_application,',
'       ''#''                                                  the_page,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:7021:''||:flow_session||'':::7021:FB_FLOW_ID,P7021_ID:''||a.flow_id||'',''||a.id) the_shared_component, ',
'       null                                                 page_id, ',
'       null                                                 page_name,',
'       wwv_flow_lang.system_message( ''AUTOMATIONS'' )        plug_source_type, ',
'       null                                                 plug_name, ',
'       a.name                                               shared_comp_name, ',
'       s.name                                               remote_server_name',
'  from wwv_flow_automations a,',
'       wwv_remote_servers s',
' where s.id = a.remote_server_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = a.security_group_id',
'   and a.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = a.flow_id ) )',
'union all (',
'select s.id,',
'       a.flow_id                                            the_application,',
'       ''#''                                                  the_page,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:7022:''||:flow_session||'':::7022:FB_FLOW_ID,P7022_ID:''||a.flow_id||'',''||a.id) the_shared_component, ',
'       null                                                 page_id, ',
'       null                                                 page_name, ',
'       wwv_flow_lang.system_message( ''AUTOMATION_ACTIONS'' ) plug_source_type, ',
'       null                                                 plug_name, ',
'       a.name                                               shared_comp_name, ',
'       s.name                                               remote_server_name',
'from wwv_flow_automation_actions a,',
'     wwv_remote_servers s',
' where s.id = a.remote_server_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = a.security_group_id',
'   and a.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = a.flow_id ) )',
'',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(582916166664077312.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se han encontrado referencias de SQL activado para REST en este espacio de trabajo.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_chart=>'N'
,p_show_pivot=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>582916166664077312
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236247135587284206.4001)
,p_db_column_name=>'REMOTE_SERVER_NAME'
,p_display_order=>10
,p_column_identifier=>'X'
,p_column_label=>'Servicio de SQL activado para REST'
,p_column_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP:P1601_ID:#ID#'
,p_column_linktext=>'#REMOTE_SERVER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236246731553284202.4001)
,p_db_column_name=>'THE_PAGE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('La p\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236246894348284203.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>30
,p_column_identifier=>'U'
,p_column_label=>unistr('Identificador de P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236246947872284204.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>40
,p_column_identifier=>'V'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_link=>'#THE_PAGE#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236247053654284205.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>50
,p_column_identifier=>'W'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(90115721183448606.4001)
,p_db_column_name=>'SHARED_COMP_NAME'
,p_display_order=>60
,p_column_identifier=>'AB'
,p_column_label=>'Nombre de componente compartido'
,p_column_link=>'#THE_SHARED_COMPONENT#'
,p_column_linktext=>'#SHARED_COMP_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(522796475346429232.4001)
,p_db_column_name=>'THE_APPLICATION'
,p_display_order=>70
,p_column_identifier=>'Z'
,p_column_label=>unistr('Identificador de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(90115872380448607.4001)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>80
,p_column_identifier=>'AC'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(538211928069052506)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(90115697906448605.4001)
,p_db_column_name=>'THE_SHARED_COMPONENT'
,p_display_order=>90
,p_column_identifier=>'AA'
,p_column_label=>'El componente compartido'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236247216460284207.4001)
,p_db_column_name=>'ID'
,p_display_order=>100
,p_column_identifier=>'Y'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(533155331173172841.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(533155296022172840.4001)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Suprimir no utilizados'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(533155748387172845.4001)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(533155331173172841.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(533155862905172846.4001)
,p_event_id=>wwv_flow_api.id(533155748387172845.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todas las referencias de SQL activado para REST no utilizadas de su espacio de trabajo?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(533155919210172847.4001)
,p_event_id=>wwv_flow_api.id(533155748387172845.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(525231820034218528.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused references'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_remote_servers s',
' where not exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
'  ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(533155331173172841.4001)
,p_process_success_message=>'Se han suprimido las referencias de SQL activado para REST sin utilizar.'
);
end;
/
prompt --application/pages/page_01603
begin
wwv_flow_api.create_page(
 p_id=>1603.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de SQL activado para REST'
,p_step_title=>'Historial de SQL activado para REST'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(346621888234349034.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(154051976265844427.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(346622097701349034.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestran las modificaciones recientes realizadas en los servicios de SQL activado para REST de este espacio de trabajo.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(346622683611349036.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_REMOTESQL_SERVERS_DEV'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(346622907445349037.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>346622907445349037
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154061684970882361.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154062080353882361.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154062492908882362.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Servicio de SQL activado para REST'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154062805095882363.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154063275261882363.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154063656584882363.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154064007812882364.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154064875136882365.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(346622683611349036.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.:1603,RIR::'
);
end;
/
prompt --application/pages/page_01605
begin
wwv_flow_api.create_page(
 p_id=>1605.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Probar servicio de SQL activado para REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Probar servicio de SQL activado para REST'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154842416459613404.4001)
,p_plug_name=>'Con fallos'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La solicitud de HTTP al servicio de SQL activado para REST no se ha realizado correctamente. Consulte el siguiente mensaje de error para obtener m\00E1s detalles y revisar los atributos de su servicio de SQL activado para REST.</p>'),
'<pre>',
'&P1605_SQL_RESPONSE.</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_IS_ORDS_SERVER = 1 and ( :P1605_HTTP_STATUS is null or :P1605_HTTP_STATUS != 200 ) and :P1605_SQLCODE is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(241342072681308331.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_plug_name=>'Elementos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3052579796272938947.4001)
,p_plug_name=>'Con fallos'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Se ha eliminado el servidor o se ha cambiado la definici\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1605_IS_ORDS_SERVER'
,p_plug_display_when_cond2=>'0'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3052579879184938948.4001)
,p_plug_name=>'Correcto'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El servicio SQL activado para REST est\00E1 disponible. La consulta de prueba ha devuelto el siguiente resultado:</p>'),
'<pre>',
'&P1605_SQL_RESPONSE.',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_IS_ORDS_SERVER = 1 and :P1605_HTTP_STATUS = 200 and :P1605_SQLCODE is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3052579950534938949.4001)
,p_plug_name=>'Con fallos'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La URL de este servidor remoto no apunta a un servicio SQL activado para REST. Compruebe los detalles de la definici\00F3n del servicio SQL activado para REST.</p>'),
'<pre>',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_IS_ORDS_SERVER = 1 and :P1605_HTTP_STATUS between 400 and 599 and not :P1605_HTTP_STATUS = 401'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3052580029732938950.4001)
,p_plug_name=>'Con fallos'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Fallo de autenticaci\00F3n. Compruebe las credenciales de autenticaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_IS_ORDS_SERVER = 1 and :P1605_HTTP_STATUS = 401'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(241342118679308332.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(241342072681308331.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1605_BACK_TO_PAGE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(241342727074308338.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(241342072681308331.4001)
,p_button_name=>'CLOSE_BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1605_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P1605_BACK_TO_PAGE'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(310374134945241812.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(241342072681308331.4001)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Editar servicio de SQL activado para Rest'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP:P1601_ID:&P1605_ID.'
,p_button_condition=>'not ( :P1605_IS_ORDS_SERVER = 1 and :P1605_HTTP_STATUS = 200 and :P1605_SQLCODE is null ) and :P1605_BACK_TO_PAGE is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(241342689452308337.4001)
,p_name=>'P1605_BACK_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3052579187874938941.4001)
,p_name=>'P1605_SQL_RESPONSE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3052579266494938942.4001)
,p_name=>'P1605_HTTP_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3052579342329938943.4001)
,p_name=>'P1605_SQLCODE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3052579498926938944.4001)
,p_name=>'P1605_IS_ORDS_SERVER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3052579621631938946.4001)
,p_name=>'P1605_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3052579079717938940.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(241342271342308333.4001)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(241342118679308332.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241342387912308334.4001)
,p_event_id=>wwv_flow_api.id(241342271342308333.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3052579561518938945.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test ORDS Remote SQL Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_remote_server_dev.test_remote_sql_server(',
'        p_remote_sql_server_id => :P1605_ID,',
'        p_sql_response         => :P1605_SQL_RESPONSE,',
'        p_http_status          => :P1605_HTTP_STATUS,',
'        p_sqlcode              => :P1605_SQLCODE,',
'        p_is_remote_sql        => :P1605_IS_ORDS_SERVER );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01615
begin
wwv_flow_api.create_page(
 p_id=>1615.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear servicio de SQL activado para REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear servicio de SQL activado para REST'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'60%'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(242269813348871847.4001)
,p_plug_name=>'General'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'Proporcione un nombre descriptivo y el punto final de URL de su servicio de SQL activado para REST.'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(242270108216871850.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(249355742923907578.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249345749056883001.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249345985030883003.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(249345749056883001.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249345829405883002.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(249345749056883001.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(249346071188883004.4001)
,p_branch_name=>'Goto Page 1616'
,p_branch_action=>'f?p=&APP_ID.:1616:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(242269986356871848.4001)
,p_name=>'P1615_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(242269813348871847.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca un nombre descriptivo para este servicio SQL activado para REST.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(242270099779871849.4001)
,p_name=>'P1615_ENDPOINT_URL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(242269813348871847.4001)
,p_prompt=>'URL de Punto Final'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la URL base para este servicio de SQL activado para REST. Incluya la ra\00EDz de contexto de ORDS y el prefijo de la URL de esquema, pero <strong>no</strong> agregue <code>/_/sql</code>. Por ejemplo:'),
'<pre>',
'https://{host}:{port}/ords/{schema}',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249346149543883005.4001)
,p_validation_name=>'Name is unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1615_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de servidor remoto debe ser \00FAnico en el espacio de trabajo.')
,p_when_button_pressed=>wwv_flow_api.id(249345985030883003.4001)
,p_associated_item=>wwv_flow_api.id(242269986356871848.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249346298169883006.4001)
,p_validation_name=>'Starts with HTTP or HTTPS'
,p_validation_sequence=>20
,p_validation=>'substr(:P1615_ENDPOINT_URL, 1, 8) = ''https://'' or substr(:P1615_ENDPOINT_URL, 1, 7)  = ''http://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La URL de punto final debe empezar por http:// o https://.'
,p_when_button_pressed=>wwv_flow_api.id(249345985030883003.4001)
,p_associated_item=>wwv_flow_api.id(242270099779871849.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249347718788883021.4001)
,p_validation_name=>'Do not append /_/sql to the URL'
,p_validation_sequence=>30
,p_validation=>'substr( :P1615_ENDPOINT_URL, -6 ) != ''/_/sql'' and substr( :P1615_ENDPOINT_URL, -7 ) != ''/_/sql/'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'No agregue /_/sql a la URL de punto final de servidor remoto de ORDS.'
,p_when_button_pressed=>wwv_flow_api.id(249345985030883003.4001)
,p_associated_item=>wwv_flow_api.id(242270099779871849.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249346309377883007.4001)
,p_validation_name=>'URL after http:// must exist'
,p_validation_sequence=>40
,p_validation=>'length(:P1615_ENDPOINT_URL ) > 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Proporcione un punto final de URL v\00E1lido.')
,p_associated_item=>wwv_flow_api.id(242270099779871849.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(323224988460171028.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(249345829405883002.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(323225007135171029.4001)
,p_event_id=>wwv_flow_api.id(323224988460171028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01616
begin
wwv_flow_api.create_page(
 p_id=>1616.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear servicio de SQL activado para REST - Autenticaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear servicio de SQL activado para REST - Autenticaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(158563443147585227)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(403349869788379589.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Proporcione informaci\00F3n de autenticaci\00F3n para este servicio de SQL activado para REST. Elija las credenciales existentes o introduzca credenciales nuevas.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(190995235628372720.4001)
,p_plug_name=>'Detalles de Credencial'
,p_parent_plug_id=>wwv_flow_api.id(403349869788379589.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491628643988804839.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(249355742923907578.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(498704284828815990.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249362037539932994.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(498704284828815990.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249361654285932993.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(498704284828815990.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(271596699404112726.4001)
,p_branch_name=>'Go To Page 1605'
,p_branch_action=>'f?p=&APP_ID.:1605:&SESSION.::&DEBUG.:RP:P1605_ID:&P1616_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(249362037539932994.4001)
,p_branch_sequence=>5
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P1605_BACK_TO_PAGE is not null and nvl(:P1616_EMPTY_CREDENTIAL,''N'') = ''N'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(348489784702006015.4001)
,p_branch_name=>'Go To Page 1605'
,p_branch_action=>'f?p=&APP_ID.:1605:&SESSION.::&DEBUG.:RP:P1605_ID,P1605_BACK_TO_PAGE:&P1616_ID.,1600&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(249362037539932994.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1616_EMPTY_CREDENTIAL'
,p_branch_condition_text=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(271596706004112727.4001)
,p_branch_name=>'Goto return page'
,p_branch_action=>'f?p=&APP_ID.:&P1605_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1605_BACK_TO_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(249347627785883020.4001)
,p_branch_name=>'Goto Page 1600'
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(190995149344372719.4001)
,p_name=>'P1616_EMPTY_CREDENTIAL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(403349869788379589.4001)
,p_item_default=>'Y'
,p_prompt=>'Almacenar Credenciales'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si se desactiva, la credencial nombrada se crear\00E1 con valores NULL almacenados como <em>ID de cliente</em> y <em>Secreto de cliente</em>. Para utilizar la referencia de SQL activado para REST, las credenciales se deben definir para la sesi\00F3n de APEX ')
||'mediante el procedimiento <strong>APEX_CREDENTIAL.SET_SESSION_CREDENTIALS</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249363261773935959.4001)
,p_name=>'P1616_CREDENTIALS_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(403349869788379589.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Credencial'
,p_source=>'CREDENTIAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre descriptivo para las credenciales.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249364104824935960.4001)
,p_name=>'P1616_CREDENTIALS_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(403349869788379589.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'OAUTH2_CLIENT_CREDENTIALS'
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el tipo de autenticaci\00F3n. Para obtener informaci\00F3n sobre los tipos de autenticaci\00F3n soportados, vaya a <strong>Credenciales web</strong> en <strong>Componentes compartidos</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249365097716935960.4001)
,p_name=>'P1616_CLIENT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(190995235628372720.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador de Cliente'
,p_source=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Para la autenticaci\00F3n b\00E1sica, introduzca el nombre del usuario de base de datos. Para OAuth2, introduzca el ID de cliente. Esta informaci\00F3n no estar\00E1 cifrada. Los nombres de usuario de la autenticaci\00F3n b\00E1sica aparecen en may\00FAsculas. Para incluir un n')
||unistr('ombre de usuario sensible a may\00FAsculas/min\00FAsculas, introduzca un signo de exclamaci\00F3n (!) como prefijo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249365988841935961.4001)
,p_name=>'P1616_SECRET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(190995235628372720.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secreto del Cliente'
,p_source=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a o el secreto del cliente OAuth2. Esta informaci\00F3n se almacena cifrada y no se puede recuperar en texto no cifrado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249366856266935963.4001)
,p_name=>'P1616_SECRET_VERIFY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(190995235628372720.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Verificar secreto del cliente'
,p_source=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a o el secreto del cliente de nuevo para verificar los datos introducidos. Si los dos valores no coinciden, se muestra un mensaje de error.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(249373581170994236.4001)
,p_name=>'P1616_CRED_STORE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(403349869788379589.4001)
,p_prompt=>'Credenciales'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Introducir nuevo -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la credencial para autenticar. Para editar la credencial, vaya a <strong>Credenciales web</strong> en <strong>Componentes compartidos</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348489523387006013.4001)
,p_name=>'P1616_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(403349869788379589.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(310377185455241842.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1616_CLIENT_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when substr( :P1616_CLIENT_ID, 1, 1 ) = ''!'' then substr( :P1616_CLIENT_ID, 2 ) else upper(  :P1616_CLIENT_ID ) end'
,p_compute_when=>'P1616_CREDENTIALS_TYPE'
,p_compute_when_text=>'BASIC'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249346894956883012.4001)
,p_validation_name=>'Credential Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1616_CREDENTIALS_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de credencial debe ser \00FAnico en la aplicaci\00F3n. Este nombre ya est\00E1 en uso.')
,p_validation_condition=>'P1616_CRED_STORE'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_api.id(249362037539932994.4001)
,p_associated_item=>wwv_flow_api.id(249363261773935959.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249346956295883013.4001)
,p_validation_name=>'CLIENT_ID is not null'
,p_validation_sequence=>20
,p_validation=>'P1616_CLIENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El ID de cliente debe tener alg\00FAn valor.')
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(249362037539932994.4001)
,p_associated_item=>wwv_flow_api.id(249365097716935960.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249347012214883014.4001)
,p_validation_name=>'CLIENT_SECRET is not null'
,p_validation_sequence=>30
,p_validation=>'P1616_SECRET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El secreto del cliente debe tener alg\00FAn valor.')
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(249362037539932994.4001)
,p_associated_item=>wwv_flow_api.id(249365988841935961.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249347140280883015.4001)
,p_validation_name=>'CLIENT_SECRET_VERIFY is not null'
,p_validation_sequence=>40
,p_validation=>'P1616_SECRET_VERIFY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La verificaci\00F3n del secreto del cliente debe tener alg\00FAn valor.')
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(249366856266935963.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249347208222883016.4001)
,p_validation_name=>'Client Secrets must match'
,p_validation_sequence=>50
,p_validation=>':P1616_SECRET = :P1616_SECRET_VERIFY'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El secreto del cliente no coincide con la verificaci\00F3n. Compruebe la entrada.')
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(249362037539932994.4001)
,p_associated_item=>wwv_flow_api.id(249366856266935963.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(249281995624575833.4001)
,p_validation_name=>'Credential Name required'
,p_validation_sequence=>60
,p_validation=>'P1616_CREDENTIALS_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Los nombres de credenciales deben tener un valor.'
,p_validation_condition=>'P1616_CRED_STORE'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_api.id(249362037539932994.4001)
,p_associated_item=>wwv_flow_api.id(249363261773935959.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(249346595632883009.4001)
,p_name=>'Credential Chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1616_CRED_STORE'
,p_condition_element=>'P1616_CRED_STORE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249346660574883010.4001)
,p_event_id=>wwv_flow_api.id(249346595632883009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME,P1616_CREDENTIALS_TYPE,P1616_CLIENT_ID,P1616_SECRET,P1616_SECRET_VERIFY,P1616_EMPTY_CREDENTIAL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249346755909883011.4001)
,p_event_id=>wwv_flow_api.id(249346595632883009.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME,P1616_CREDENTIALS_TYPE,P1616_CLIENT_ID,P1616_SECRET,P1616_SECRET_VERIFY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249347335051883017.4001)
,p_event_id=>wwv_flow_api.id(249346595632883009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME,P1616_CREDENTIALS_TYPE,P1616_CLIENT_ID,P1616_SECRET,P1616_SECRET_VERIFY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(713444194371412423.4001)
,p_event_id=>wwv_flow_api.id(249346595632883009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_EMPTY_CREDENTIAL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when client_id is null then ''Y'' else ''N'' end ',
'  from wwv_credentials ',
' where id                = :P1616_CRED_STORE',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
''))
,p_attribute_07=>'P1616_CRED_STORE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(310373432288241805.4001)
,p_name=>'Warn when using BASIC authentication'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1616_CREDENTIALS_TYPE'
,p_condition_element=>'P1616_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'BASIC'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310373521065241806.4001)
,p_event_id=>wwv_flow_api.id(310373432288241805.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_AUTH_BASIC_WARNING'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310373756675241808.4001)
,p_event_id=>wwv_flow_api.id(310373432288241805.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_AUTH_BASIC_WARNING'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310373850815241809.4001)
,p_event_id=>wwv_flow_api.id(310373432288241805.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.message.showErrors([ {',
'   type:       "error",',
'   location:   "inline",',
'   pageItem:   "P1616_CREDENTIALS_TYPE",',
'   message:    apex.lang.formatMessage("APEX.REMOTESQL.OAUTH_IS_RECOMMENDED"),',
'   unsafe:     false',
' }',
' ]);',
''))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310373946466241810.4001)
,p_event_id=>wwv_flow_api.id(310373432288241805.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.clearErrors( "P1616_CREDENTIALS_TYPE" )'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(190995330941372721.4001)
,p_name=>'Show / Hide Credential Details'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1616_EMPTY_CREDENTIAL'
,p_condition_element=>'P1616_EMPTY_CREDENTIAL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(190995493861372722.4001)
,p_event_id=>wwv_flow_api.id(190995330941372721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(190995235628372720.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(190995512230372723.4001)
,p_event_id=>wwv_flow_api.id(190995330941372721.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(190995235628372720.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(249347549250883019.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Remote Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    insert into wwv_remotesql_servers_dev (',
'        server_name,',
'        base_url,',
'        credential_id,',
'        auth_required,',
'        credential_name,',
'        authentication_type,',
'        client_id,',
'        client_secret,',
'        client_secret_verify,',
'        prompt_on_install )',
'    values (',
'        :P1615_NAME,',
'        :P1615_ENDPOINT_URL,',
'        :P1616_CRED_STORE,',
'        ''Y'',',
'        :P1616_CREDENTIALS_NAME,',
'        :P1616_CREDENTIALS_TYPE,',
'        :P1616_CLIENT_ID,',
'        :P1616_SECRET,',
'        :P1616_SECRET_VERIFY,',
'        ''Y'' );',
'        ',
'    select id into :P1616_ID',
'      from wwv_remotesql_servers_dev',
'     where server_name = :P1615_NAME',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'       ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(249362037539932994.4001)
,p_process_success_message=>'Servicio SQL activado para REST creado.'
);
end;
/
prompt --application/pages/page_01620
begin
wwv_flow_api.create_page(
 p_id=>1620.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Credenciales'
,p_step_title=>'Credenciales'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563552508587748)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(308538337233045967.4001)
,p_plug_name=>'Credenciales web'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="border-bottom-width: 0;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilice las <strong>credenciales web</strong> para conectar al SQL activado para REST u otros servicios de REST externos. &PRODUCT_NAME. almacena y cifra de manera segura las credenciales para el uso por parte de los componentes de &PRODUCT_NAME. '
||'No se pueden recuperar las credenciales en texto no cifrado.</p>',
unistr('<p>Las credenciales se almacenan en el nivel de espacio de trabajo y, por lo tanto, son visibles en todas las aplicaciones. Al exportar una aplicaci\00F3n, las credenciales utilizadas se agregan al archivo de exportaci\00F3n.'),
unistr('</p><p>Al importar la aplicaci\00F3n a otro espacio de trabajo, &PRODUCT_NAME. comprueba si el espacio de trabajo de destino ya contiene credenciales con el mismo ID est\00E1tico. Si ya existe una credencial, la aplicaci\00F3n la utiliza. En caso contrario, se c')
||unistr('rea la credencial del archivo de importaci\00F3n en el espacio de trabajo de destino.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(312276959486040232.4001)
,p_plug_name=>'Credenciales'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   id,',
'   name,',
'   static_id,',
'   authentication_type,',
'   wwv_flow_utilities.prepare_url( ''f?p=4000:1621:'' || :APP_SESSION || '':::1621:P1621_BACK_TO_PAGE,P1621_ID:1620,'' || id ) as link,',
'   ''icon-util-security-profiles'' as img,',
'   LAST_UPDATED_BY updated_by,',
'   LAST_UPDATED_ON updated,',
'   created_by,',
'   created_on created',
' from wwv_credentials_dev ',
'where security_group_id = :flow_security_group_id',
'       '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(312277037396040233.4001)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se han definido credenciales en este espacio de trabajo.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>312277037396040233
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154574062197566123.4001)
,p_db_column_name=>'AUTHENTICATION_TYPE'
,p_display_order=>40
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Autenticaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(154078822199034715)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154568407972566117.4001)
,p_db_column_name=>'ID'
,p_display_order=>110
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154568895716566117.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>120
,p_column_identifier=>'I'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154569248272566117.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>130
,p_column_identifier=>'J'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154569674943566118.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>140
,p_column_identifier=>'S'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154570003312566118.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>150
,p_column_identifier=>'T'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154572862302566121.4001)
,p_db_column_name=>'IMG'
,p_display_order=>160
,p_column_identifier=>'AG'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154573283118566122.4001)
,p_db_column_name=>'LINK'
,p_display_order=>170
,p_column_identifier=>'AH'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3052578210569938932.4001)
,p_db_column_name=>'NAME'
,p_display_order=>180
,p_column_identifier=>'AK'
,p_column_label=>'Nombre'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(397074171521399217.4001)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>190
,p_column_identifier=>'AL'
,p_column_label=>unistr('Identificador est\00E1tico')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(356448355468553233.4001)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(154583731613661573.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(712704827760087678.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/managing-credentials.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154574801131566132.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(312276959486040232.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:1600,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154575240742566136.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(312276959486040232.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:1621:P1621_BACK_TO_PAGE:&APP_PAGE_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154576707576566147.4001)
,p_branch_action=>'1620'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_01621
begin
wwv_flow_api.create_page(
 p_id=>1621.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar credencial'
,p_step_title=>'Crear/Editar credencial'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(158563552508587748)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117793092137505918.4001)
,p_plug_name=>'Tokens almacenados'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1621_CREDENTIALS_TYPE'
,p_plug_display_when_cond2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(117792038112505908.4001)
,p_name=>'Tokens de credencial'
,p_parent_plug_id=>wwv_flow_api.id(117793092137505918.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( sum( case when value_type = ''ACCESS_TOKEN'' then 1 else 0 end ), 0 ) as access_tokens,',
'       nvl( sum( case when value_type = ''REFRESH_TOKEN'' then 1 else 0 end ), 0 ) as refresh_tokens,',
'       nvl( sum( case when value_type = ''ID_TOKEN'' then 1 else 0 end ), 0 ) as id_tokens   ',
'  from wwv_credential_instances',
' where credential_id = :P1621_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and session_id is null'))
,p_header=>unistr('Recuento de tokens de acceso, refrescamiento e ID v\00E1lidos para todas las sesiones.')
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792259930505910.4001)
,p_query_column_id=>1
,p_column_alias=>'ACCESS_TOKENS'
,p_column_display_sequence=>1
,p_column_heading=>'Tokens de acceso'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792310894505911.4001)
,p_query_column_id=>2
,p_column_alias=>'REFRESH_TOKENS'
,p_column_display_sequence=>2
,p_column_heading=>'Tokens de refrescamiento'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792420077505912.4001)
,p_query_column_id=>3
,p_column_alias=>'ID_TOKENS'
,p_column_display_sequence=>3
,p_column_heading=>'Tokens de ID'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(117792568458505913.4001)
,p_name=>unistr('Tokens de sesi\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(117793092137505918.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count( distinct session_id ) as distinct_sessions ,',
'       nvl( sum( case when value_type = ''ACCESS_TOKEN'' then 1 else 0 end ), 0 ) as access_tokens,',
'       nvl( sum( case when value_type = ''REFRESH_TOKEN'' then 1 else 0 end ), 0 ) as refresh_tokens,',
'       nvl( sum( case when value_type = ''ID_TOKEN'' then 1 else 0 end ), 0 ) as id_tokens   ',
'  from wwv_credential_instances',
' where credential_id = :P1621_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and session_id is not null'))
,p_header=>unistr('Recuento de tokens de acceso, refrescamiento o ID solo v\00E1lidos para una sesi\00F3n espec\00EDfica.')
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792965575505917.4001)
,p_query_column_id=>1
,p_column_alias=>'DISTINCT_SESSIONS'
,p_column_display_sequence=>1
,p_column_heading=>'Tokens para sesiones'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792685837505914.4001)
,p_query_column_id=>2
,p_column_alias=>'ACCESS_TOKENS'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Tokens de acceso (sesi\00F3n)')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792766698505915.4001)
,p_query_column_id=>3
,p_column_alias=>'REFRESH_TOKENS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Tokens de refrescamiento (sesi\00F3n)')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117792829592505916.4001)
,p_query_column_id=>4
,p_column_alias=>'ID_TOKENS'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tokens de ID (sesi\00F3n)')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(308592151420746764.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488484273956069306.4001)
,p_plug_name=>'Credenciales web'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Almacene credenciales de autenticaci\00F3n para servicios de REST externos o servicios de SQL activado para REST.</p>'),
unistr('<p>El secreto del cliente se almacenar\00E1 cifrado; solo lo puede utilizar &PRODUCT_NAME. y no se puede recuperar en texto no cifrado.</p>'),
unistr('<p>Adem\00E1s, la informaci\00F3n de credenciales no se incluir\00E1 en los archivos de exportaci\00F3n de la aplicaci\00F3n. Despu\00E9s de importar una aplicaci\00F3n en el espacio de trabajo de destino, aparecer\00E1n peticiones de datos para que vuelva a introducir las credenci')
||'ales.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(924109676790463691.4001)
,p_plug_name=>'Credenciales web'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154599371603686563.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(924109676790463691.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1621_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP,1621::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154599745454686565.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(924109676790463691.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P1621_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154600176572686567.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(924109676790463691.4001)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1621_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154600589325686567.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(924109676790463691.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1621_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(117791341683505901.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(924109676790463691.4001)
,p_button_name=>'CLEAR_TOKENS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Borrar tokens'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1621_CREDENTIALS_TYPE'
,p_button_condition2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(310375757614241828.4001)
,p_branch_name=>'Go To Page &P1621_BACK_TO_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P1621_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP,1621::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1621_BACK_TO_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154611279857686609.4001)
,p_branch_name=>'Go To Page 1620'
,p_branch_action=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:RP,1620::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'',''Update'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154611602684686609.4001)
,p_branch_name=>'Go To Page 1621'
,p_branch_action=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1342962966822914.4001)
,p_name=>'P1621_OCI_USER_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>'ID de usuario de OCI'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca el <em>Usuario de OCID</em> de la Infraestructura de Oracle Cloud. &PRODUCT_NAME. no almacena esta informaci\00F3n cifrada.</p> <p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documenta')
||unistr('ci\00F3n de la Infraestructura de Oracle Cloud</a></p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1343058530822915.4001)
,p_name=>'P1621_OCI_PRIVATE_KEY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>'Clave privada de OCI'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca la clave p\00FAblica en formato PEM para la autenticaci\00F3n de OCI. &PRODUCT_NAME. almacena esta informaci\00F3n cifrada y protegida, por lo que no se puede recuperar como texto no cifrado.</p><p><a target="_blank" href="https://docs.cloud.oracle')
||unistr('.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de Infraestructura de Oracle Cloud</a></p>')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1343124181822916.4001)
,p_name=>'P1621_OCI_NAMESPACE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID de arrendamiento de OCI'
,p_source=>'NAMESPACE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el <em>OCID de Arrendamiento</em> de la Infraestructura de Oracle Cloud.</p>',
unistr('<p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de la Infraestructura de Oracle Cloud</a></p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1343282077822917.4001)
,p_name=>'P1621_OCI_FINGERPRINT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Huella de clave p\00FAblica de OCI')
,p_source=>'FINGERPRINT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('<p>Introduzca la <em>huella de clave p\00FAblica RSA</em> para la autenticaci\00F3n de OCI. </p><p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de Infraestructura de Oracle Cloud</a></p>')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1701886111678401.4001)
,p_name=>'P1621_CERTIFICATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>'Certificado'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el certificado en formato PEM.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1701904410678402.4001)
,p_name=>'P1621_CERT_PRIVATE_KEY'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>'Clave Privada'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la clave privada en formato PEM. &PRODUCT_NAME. almacena esta informaci\00F3n cifrada y protegida, por lo que no se puede recuperar como texto no cifrado.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3366837426004641.4001)
,p_name=>'P1621_GENERIC_NAME'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>'Nombre de la Credencial'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione el nombre de la cabecera HTTP o del par\00E1metro de cadena de consulta de URL para usarlo con esta credencial.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3366993821004642.4001)
,p_name=>'P1621_GENERIC_VALUE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>'Secreto de credencial'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Proporcione el valor (secreto) de la credencial.'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3367384134004646.4001)
,p_name=>'P1621_VALID_FOR_URLS'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('V\00E1lido para URL')
,p_source=>'VALID_FOR_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>&PRODUCT_NAME. comprobar\00E1 si la URL, para la que se va a utilizar la credencial en tiempo de ejecuci\00F3n, coincide con una de las URL de esta lista. Si la URL no coincide, &PRODUCT_NAME. emitir\00E1 un error.</p>'),
unistr('<p>Introduzca cada URL en una l\00EDnea nueva. El punto final de URL que se est\00E1 utilizando debe comenzar con una de las URL proporcionadas aqu\00ED.</p>'),
'<p>Por ejemplo:</p>',
'<pre>',
'https://www.example.com/restapis/my-protected-api',
'https://www.example.com/allowed-urls',
'</pre>',
'<p>Si la credencial se utiliza para llamar a un servicio REST en <strong>https://www.example.com/restapis/my-protected-api/restendpoint</strong> o <strong>https://www.example.com/allowed-urls/page1</strong>, se puede utilizar la credencial y la llama'
||unistr('da se producir\00E1 correctamente.</p>'),
unistr('<p>Si la credencial se utiliza para llamar a un servicio REST en <strong>https://localhost/myapis/test</strong> o <strong>https://dev.example.com/myapis/test</strong>, <em>no se puede</em> utilizar la credencial y &PRODUCT_NAME. emitir\00E1 un error.</p>'),
'<p>Tenga en cuenta que, para cambiar este valor, es necesario volver a introducir el secreto del cliente.</p>'))
,p_inline_help_text=>'Tenga en cuenta que, para cambiar este valor, es necesario volver a introducir el secreto de cliente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(55557897779883020.4001)
,p_name=>'P1621_SCOPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1mbito de OAuth')
,p_source=>'SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Los permisos representados por el token de acceso en los t\00E9rminos de OAuth 2.0 se conocen como \00E1mbitos. El par\00E1metro de \00E1mbito le permite a la aplicaci\00F3n expresar el \00E1mbito deseado de la solicitud de acceso. '),
'</p>',
'<p>',
unistr('    Si su servidor de autenticaci\00F3n requiere que se especifique un \00E1mbito para la solicitud de token de acceso, proporci\00F3nelo aqu\00ED. El token de acceso de OAuth2 se pedir\00E1 con el siguiente cuerpo de solicitud:'),
'<pre>',
unistr('grant_type=client_credentials&amp;scope=<strong>{\00E1mbito}</strong>'),
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154587431457686543.4001)
,p_name=>'P1621_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154589647585686551.4001)
,p_name=>'P1621_PROMPT_ON_INSTALL'
,p_is_required=>true
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Solicitar en la instalaci\00F3n')
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si desea que se muestren peticiones de datos para esta credencial cuando se est\00E9 importando la aplicaci\00F3n a otra instancia de &PRODUCT_NAME. Dado que &PRODUCT_NAME. nunca exporta contrase\00F1as o secretos del cliente, las peticiones de instal')
||unistr('aci\00F3n <em>siempre</em> se generan cuando se proporciona un ID de cliente o un nombre de usuario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154593032746686556.4001)
,p_name=>'P1621_CREDENTIALS_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre descriptivo para las credenciales. Este nombre debe ser \00FAnico en el espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154593935882686557.4001)
,p_name=>'P1621_CREDENTIALS_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BASIC'
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el tipo de autenticaci\00F3n aqu\00ED. &PRODUCT_NAME. soporta los siguientes tipos de autenticaci\00F3n:</p>'),
'<ul>',
unistr('    <li><strong>Autenticaci\00F3n b\00E1sica</strong>: env\00EDa un nombre de usuario y una contrase\00F1a en forma de codificaci\00F3n Base64 como la cabecera de la solicitud de <strong>autorizaci\00F3n</strong>.'),
'    </li>',
unistr('    <li><strong>Credenciales de cliente de OAuth2</strong>: &PRODUCT_NAME. intercambia el ID de cliente y el secreto de cliente por un <strong>token de acceso</strong> utilizando una URL de servidor de token. A continuaci\00F3n, se utiliza el token de ac')
||unistr('ceso para realizar la solicitud real. Si el token de acceso caduca, &PRODUCT_NAME. solicitar\00E1 uno nuevo de forma transparente.</li>'),
unistr('    <li><strong>Autenticaci\00F3n nativa de OCI</strong>: &PRODUCT_NAME. firma solicitudes de la API de REST de <em>Oracle Cloud Infrastructure (OCI)</em>, como se describe en la <a href="https://docs.cloud.oracle.com/en-us/iaas/Content/API/Concepts/sign')
||unistr('ingrequests.htm">documentaci\00F3n de OCI</a>. Este tipo solo est\00E1 disponible en Oracle Database 18c y posteriores.</li>'),
'    <li><strong>Cabecera HTTP</strong>: la credencial se agrega a la solicitud de REST como una cabecera HTTP. El nombre de la credencial es el nombre de la cabecera HTTP, el secreto de la credencial es el valor de la cabecera HTTP. &PRODUCT_NAME. no'
||unistr(' agrega estos secretos al log de depuraci\00F3n ni a ning\00FAn otro log.</li>'),
unistr('    <li><strong>Cadena de consulta de URL</strong>: la credencial se agrega a la URL de la solicitud de REST como un par\00E1metro de <em>cadena de consulta</em> (por ejemplo: <strong>?name=value</strong>). Esta opci\00F3n puede ser \00FAtil para las claves de A')
||unistr('PI. &PRODUCT_NAME. no agrega estos secretos al log de depuraci\00F3n ni a ning\00FAn otro log. Sin embargo, el proxy u otros servidores intermediarios registrar\00E1n estas credenciales en sus archivos de log.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154594835374686558.4001)
,p_name=>'P1621_CLIENT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID de cliente o nombre de usuario'
,p_source=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de usuario para la autenticaci\00F3n b\00E1sica y el ID de cliente para el flujo de credenciales de cliente de OAuth2. &PRODUCT_NAME. no almacena esta informaci\00F3n cifrada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154595724346686559.4001)
,p_name=>'P1621_SECRET'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Secreto de cliente o contrase\00F1a')
,p_source=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a para la autenticaci\00F3n b\00E1sica y el secreto de cliente para el flujo de credenciales de cliente de OAuth2. &PRODUCT_NAME. almacena esta informaci\00F3n cifrada, por lo que no se puede recuperar como texto no cifrado.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154596677053686559.4001)
,p_name=>'P1621_SECRET_VERIFY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Verificar secreto de cliente o contrase\00F1a')
,p_source=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Vuelva a introducir la contrase\00F1a o el secreto de cliente para comprobar su entrada.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154597893068686561.4001)
,p_name=>'P1621_COMMENT'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'CREDENTIAL_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(310375632284241827.4001)
,p_name=>'P1621_BACK_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(397074296277399218.4001)
,p_name=>'P1621_CREDENTIALS_STATIC_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia a las credenciales en llamadas de API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537388993086764713.4001)
,p_name=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(308592151420746764.4001)
,p_prompt=>unistr('Solicitar en la instalaci\00F3n')
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si desea que se muestren peticiones de datos para esta credencial cuando se est\00E9 importando la aplicaci\00F3n a otra instancia de &PRODUCT_NAME. Dado que &PRODUCT_NAME. nunca exporta contrase\00F1as o secretos del cliente, las peticiones de instal')
||unistr('aci\00F3n <em>siempre</em> se generan cuando se proporciona un ID de cliente o un nombre de usuario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(537388624465764710.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1621_PROMPT_ON_INSTALL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1621_CLIENT_ID is not null then ''Y'' else :P1621_PROMPT_ON_INSTALL end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1344321356822928.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1621_OCI_USER_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'OCI'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1702074064678403.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1621_CERTIFICATE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'CERTIFICATE_PAIR'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3367561173004648.4001)
,p_computation_sequence=>40
,p_computation_item=>'P1621_GENERIC_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'HTTP_HEADER:HTTP_QUERY_STRING'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154603538915686583.4001)
,p_validation_name=>'Client Secret = Client Secret Verify'
,p_validation_sequence=>30
,p_validation=>'P1621_SECRET'
,p_validation2=>'&P1621_SECRET_VERIFY.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Los secretos del cliente o las contrase\00F1as no coinciden.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.g_request in (''Create'',''Update'')',
'and ( :P1621_SECRET is not null or :P1621_SECRET_VERIFY is not null)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(154595724346686559.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3367418617004647.4001)
,p_validation_name=>'Valid for URLs start with http or https'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_urls wwv_flow_t_varchar2;',
'    l_url  varchar2(32767);',
'begin',
'    l_urls := wwv_flow_string.split( :P1621_VALID_FOR_URLS, chr(10) );',
'    for i in 1 .. l_urls.count loop',
'        l_url := regexp_replace( l_urls( i ), ''^\s+'' );',
'        if not regexp_like (',
'                   srcstr  => l_url,',
'                   pattern => ''^\s*http[s]?://'' )',
'        then',
'            return false;',
'        end if;',
'    end loop;',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Todas las URL de la lista #LABEL# deben comenzar por http:// o https://'
,p_validation_condition=>'Create:Update'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(3367384134004646.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(537042170469394614.4001)
,p_validation_name=>'Delete only unused credentials'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and c.id = :P1621_ID',
'   and ( exists(',
'       select r.credential_id ',
'         from wwv_remote_servers r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id',
'          and r.server_type = ''REMOTE_SQL'' )',
'   or exists(',
'       select r.credential_id ',
'         from wwv_flow_web_src_modules r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id ) )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La credencial est\00E1 en uso y no se puede suprimir.')
,p_when_button_pressed=>wwv_flow_api.id(154599745454686565.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1343355644822918.4001)
,p_name=>'OCI Auth chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1343453914822919.4001)
,p_event_id=>wwv_flow_api.id(1343355644822918.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1343599206822920.4001)
,p_event_id=>wwv_flow_api.id(1343355644822918.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1702150779678404.4001)
,p_name=>'Credential Pair chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CERTIFICATE_PAIR'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1702244998678405.4001)
,p_event_id=>wwv_flow_api.id(1702150779678404.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CERTIFICATE,P1621_CERT_PRIVATE_KEY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1703048758678413.4001)
,p_event_id=>wwv_flow_api.id(1702150779678404.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CERTIFICATE,P1621_CERT_PRIVATE_KEY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(537388104582764705.4001)
,p_name=>'Set prompt on Install'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CLIENT_ID'
,p_condition_element=>'P1621_CLIENT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537389104318764715.4001)
,p_event_id=>wwv_flow_api.id(537388104582764705.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537388337509764707.4001)
,p_event_id=>wwv_flow_api.id(537388104582764705.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537388827863764712.4001)
,p_event_id=>wwv_flow_api.id(537388104582764705.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537388735583764711.4001)
,p_event_id=>wwv_flow_api.id(537388104582764705.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537389086493764714.4001)
,p_event_id=>wwv_flow_api.id(537388104582764705.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(55557938281883021.4001)
,p_name=>'OAuth2 Auth Type chosen'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1703171612678414.4001)
,p_event_id=>wwv_flow_api.id(55557938281883021.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCOPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(55558097396883022.4001)
,p_event_id=>wwv_flow_api.id(55557938281883021.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCOPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1702627895678409.4001)
,p_name=>'BASIC or OAuth2 Type chosen'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1702997118678412.4001)
,p_event_id=>wwv_flow_api.id(1702627895678409.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CLIENT_ID,P1621_SECRET,P1621_SECRET_VERIFY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1703243291678415.4001)
,p_event_id=>wwv_flow_api.id(1702627895678409.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CLIENT_ID,P1621_SECRET,P1621_SECRET_VERIFY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(117791661876505904.4001)
,p_name=>'Confirm Delete Tokens'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(117791341683505901.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(117791743717505905.4001)
,p_event_id=>wwv_flow_api.id(117791661876505904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Todos los tokens almacenados que se han asignado a esta credencial se borrar\00E1n y ser\00E1 necesario volver a obtenerlos de los servidores de autenticaci\00F3n. \00BFDesea continuar?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(117791863403505906.4001)
,p_event_id=>wwv_flow_api.id(117791661876505904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CLEAR_TOKENS'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3367077227004643.4001)
,p_name=>'Generic Type chosen '
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HTTP_HEADER,HTTP_QUERY_STRING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3367136779004644.4001)
,p_event_id=>wwv_flow_api.id(3367077227004643.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_GENERIC_NAME,P1621_GENERIC_VALUE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3367261517004645.4001)
,p_event_id=>wwv_flow_api.id(3367077227004643.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_GENERIC_NAME,P1621_GENERIC_VALUE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154604211844686583.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_CREDENTIALS_DEV'
,p_attribute_02=>'WWV_CREDENTIALS_DEV'
,p_attribute_03=>'P1621_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154604617634686587.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_CREDENTIALS_DEV'
,p_attribute_02=>'WWV_CREDENTIALS_DEV'
,p_attribute_03=>'P1621_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>unistr('Error al procesar la acci\00F3n.')
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(117791908045505907.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Tokens'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_credential.delete_tokens( p_credential_id => :P1621_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(117791341683505901.4001)
,p_process_success_message=>'Se han borrado todos los tokens de acceso, refrescamiento e ID de la credencial "&P1621_CREDENTIALS_NAME.".'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(117793132334505919.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Tokens on Update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_credential.delete_tokens( p_credential_id => :P1621_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(154600176572686567.4001)
,p_process_when=>'P1621_SECRET'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1703466871678417.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Client ID / Client Secret when not displayed'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P1621_CREDENTIALS_TYPE',
'when ''OCI'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_OCI_USER_ID     ,:P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_OCI_PRIVATE_KEY ,:P1621_SECRET);',
'when ''CERTIFICATE_PAIR'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_CERTIFICATE     ,:P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_CERT_PRIVATE_KEY,:P1621_SECRET);',
'when ''HTTP_HEADER'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_GENERIC_NAME,    :P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_GENERIC_VALUE,   :P1621_SECRET);',
'when ''HTTP_QUERY_STRING'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_GENERIC_NAME,    :P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_GENERIC_VALUE,   :P1621_SECRET);',
'end case;',
'',
':P1621_SECRET_VERIFY := :P1621_SECRET;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1621_CREDENTIALS_TYPE'
,p_process_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_process_when2=>'OCI:CERTIFICATE_PAIR:HTTP_HEADER:HTTP_QUERY_STRING'
);
end;
/
prompt --application/pages/page_01622
begin
wwv_flow_api.create_page(
 p_id=>1622.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilizaci\00F3n de credenciales')
,p_step_title=>unistr('Utilizaci\00F3n de credenciales')
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563552508587748)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154844109963613421.4001)
,p_plug_name=>unistr('Utilizaci\00F3n de credenciales')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       c.name as credential_name,',
'       r.name,',
'       1601 as target_page,',
'       null as application_id,',
'       r.id   as component_id,',
'       ''P1601_ID'' as id_item,',
'       wwv_flow_lang.system_message( ''F4000.REMOTE_DATABASE'' ) as comp_type,',
'       :FB_FLOW_ID as flow_id_link',
'  from wwv_credentials c,',
'       wwv_remote_servers r',
' where r.credential_id = c.id',
'   and c.security_group_id = :flow_security_group_id',
'   and r.server_type = ''REMOTE_SQL''',
'union all (',
'    select ',
'       c.name as credential_name,',
'       m.name,',
'       1921 as target_page,',
'       m.flow_id as application_id,',
'       m.id   as component_id,',
'       ''P1921_WEB_SRC_MODULE_ID'' as id_item,',
'       wwv_flow_lang.system_message( ''F4000.WEB_SRC_MODULE'' ) as comp_type,',
'       to_char(m.flow_id) as flow_id_link',
'  from wwv_flow_web_src_modules m,',
'       wwv_credentials c ',
' where m.credential_id = c.id',
'   and c.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = m.flow_id)',
')',
'union all (',
'    select ',
'       c.name as credential_name,',
'       wwv_flow_lang.system_message( ''F4000.APP_PRINT_CREDENTIALS'', f.id ) as name,',
'       4001 as target_page,',
'       f.id as application_id,',
'       null as component_id,',
'       null as id_item,',
'       wwv_flow_lang.system_message( ''F4000.PRINT_CREDENTIALS'' ) as comp_type,',
'       to_char(f.id) as flow_id_link',
'  from wwv_flows f,',
'       wwv_credentials c ',
' where f.print_credential_id = c.id',
'   and c.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = f.id)',
') '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(154844244090613422.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No se han encontrado credenciales utilizadas en este espacio de trabajo.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>154844244090613422
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154844350690613423.4001)
,p_db_column_name=>'NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Nombre del Componente'
,p_column_link=>'f?p=&APP_ID.:#TARGET_PAGE#:&SESSION.::&DEBUG.:RP,#TARGET_PAGE#:FB_FLOW_ID,#ID_ITEM#:#FLOW_ID_LINK#,#COMPONENT_ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154844677922613426.4001)
,p_db_column_name=>'COMP_TYPE'
,p_display_order=>20
,p_column_identifier=>'D'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154844458527613424.4001)
,p_db_column_name=>'TARGET_PAGE'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>unistr('P\00E1gina de destino')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154844587407613425.4001)
,p_db_column_name=>'COMPONENT_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Identificador de componente'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247835098489655842.4001)
,p_db_column_name=>'ID_ITEM'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Elemento de ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(525232950553218539.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>unistr('Identificador de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533153358017172821.4001)
,p_db_column_name=>'CREDENTIAL_NAME'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Credencial'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533153564991172823.4001)
,p_db_column_name=>'FLOW_ID_LINK'
,p_display_order=>80
,p_column_identifier=>'I'
,p_column_label=>'Enlace de ID de flujo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202606216123391382.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(154583731613661573.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(533156043524172848.4001)
,p_plug_name=>'Credenciales sin utilizar'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.name as credential_name',
'  from wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and not exists(',
'       select 1',
'         from wwv_remote_servers r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id )',
'   and not exists(',
'       select 1 ',
'         from wwv_flow_web_src_modules r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id )',
'   and not exists(',
'       select 1 ',
'         from wwv_flows f',
'        where f.print_credential_id = c.id',
'          and f.security_group_id = :flow_security_group_id )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       c.name as credential_name',
'  from wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and not exists(',
'       select r.credential_id ',
'         from wwv_remote_servers r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id',
'          and r.server_type = ''REMOTE_SQL'' )',
'   and not exists(',
'       select r.credential_id ',
'         from wwv_flow_web_src_modules r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id )'))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(533156144563172849.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('Este almac\00E9n de credenciales no se utiliza en la aplicaci\00F3n.')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>533156144563172849
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(537041300458394606.4001)
,p_db_column_name=>'CREDENTIAL_NAME'
,p_display_order=>70
,p_column_identifier=>'A'
,p_column_label=>'Credencial'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3052578742581938937.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Revise d\00F3nde se utilizan las credenciales.</p>'),
'<p>Las credenciales se almacenan en el nivel de espacio de trabajo y, por lo tanto, son visibles en todas las aplicaciones.</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(537041508664394608.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(533156043524172848.4001)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir no utilizados'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154696027791795849.4001)
,p_branch_name=>'Go To Page 1622'
,p_branch_action=>'f?p=&APP_ID.:1622:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(537041677042394609.4001)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(537041508664394608.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537041724290394610.4001)
,p_event_id=>wwv_flow_api.id(537041677042394609.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todas las credenciales no utilizadas de su espacio de trabajo?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537041826589394611.4001)
,p_event_id=>wwv_flow_api.id(537041677042394609.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537041973698394612.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Unused'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and not exists(',
'       select r.credential_id ',
'         from wwv_remote_servers r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id',
'          and r.server_type = ''REMOTE_SQL'' )',
'   and not exists(',
'       select r.credential_id ',
'         from wwv_flow_web_src_modules r',
'        where r.credential_id = c.id',
'          and r.security_group_id = :flow_security_group_id );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(537041508664394608.4001)
,p_process_success_message=>'Se han suprimido las credenciales no utilizadas.'
);
end;
/
prompt --application/pages/page_01623
begin
wwv_flow_api.create_page(
 p_id=>1623.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial de credenciales'
,p_step_title=>'Historial de credenciales'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(158563552508587748)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(501253027122110949.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(154583731613661573.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(501253236589110949.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestran las modificaciones recientes realizadas en las credenciales de este espacio de trabajo.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(501253822499110951.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_CREDENTIALS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(501254046333110952.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>501254046333110952
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154632334332761933.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154632772618761935.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154633199059761936.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154633526324761936.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154633932118761936.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154634312885761937.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(154634716401761937.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154635508943761948.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(501253822499110951.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1623:&SESSION.::&DEBUG.:1623,RIR::'
);
end;
/
prompt --application/pages/page_01700
begin
wwv_flow_api.create_page(
 p_id=>1700.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos heredada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos heredada'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(423953526918849791)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#P1700_LABEL_CASE_SENS_CONTAINER .a-Form-labelContainer").css("display", "none");',
'',
'$("#F4000_P1700_UK_CASE_1_CONTAINER .a-Form-labelContainer").css("display", "none");',
'$("#F4000_P1700_UK_CASE_2_CONTAINER .a-Form-labelContainer").css("display", "none");',
'$("#F4000_P1700_UK_CASE_3_CONTAINER .a-Form-labelContainer").css("display", "none");'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17007612242242623.4001)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16993520375207189.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17009804108278139.4001)
,p_plug_name=>'Crear carga de datos heredada'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Las p\00E1ginas de carga de datos hacen referencia a una definici\00F3n de la carga de datos heredada. Para crear una nueva definici\00F3n de carga de datos heredada, especifique un nombre y seleccione un propietario del esquema, una tabla de destino y hasta ')
||unistr('tres columnas que identifiquen una fila como \00FAnica.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44731705373834941.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17011221424283170.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44731705373834941.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17011413590290370.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44731705373834941.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279439302524313294.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44731705373834941.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(305343028968743639.4001)
,p_branch_action=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17011413590290370.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1700_EXISTS'
,p_branch_condition_text=>'TRUE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(305377426675752473.4001)
,p_branch_action=>'f?p=&APP_ID.:1702:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17011413590290370.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549005609609220759.4001)
,p_branch_name=>'Go To Page 259'
,p_branch_action=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279439302524313294.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(582265480613682825.4001)
,p_branch_name=>'Go To Page 1704 (existing Load selected)'
,p_branch_action=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:RP:F4000_P1700_NAME,P1700_EXISTS:&P1700_EXISTING_DATALOAD.,yes&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17011413590290370.4001)
,p_branch_sequence=>60
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1700_EXISTING_DATALOAD'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17078810027219284.4001)
,p_name=>'F4000_P1700_OWNER'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que se basar\00E1 la pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17079222588279743.4001)
,p_name=>'F4000_P1700_TABLE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>'Nombre de la Tabla'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P1700_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla -'
,p_lov_cascade_parent_items=>'F4000_P1700_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione la tabla que se va a utilizar para la carga de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17079422157298547.4001)
,p_name=>'F4000_P1700_UK_1'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>'Columna 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1700_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1700_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_UNIQUE_COLUMN_LABEL F4000_P1700_UK_1_LABEL"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17079603934302695.4001)
,p_name=>'F4000_P1700_UK_2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>'Columna 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1700_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1700_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_UNIQUE_COLUMN_LABEL F4000_P1700_UK_2_LABEL"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17079819171307130.4001)
,p_name=>'F4000_P1700_UK_3'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>'Columna 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1700_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1700_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_UNIQUE_COLUMN_LABEL F4000_P1700_UK_3_LABEL"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17080011684314403.4001)
,p_name=>'F4000_P1700_UK_CASE_1'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_item_default=>'N'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_CASE_SENS_LABEL F4000_P1700_UK_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17080218048325659.4001)
,p_name=>'F4000_P1700_UK_CASE_2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_CASE_SENS_LABEL F4000_P1700_UK_2_LABEL"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17080408136332286.4001)
,p_name=>'F4000_P1700_UK_CASE_3'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_CASE_SENS_LABEL F4000_P1700_UK_3_LABEL"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146989019358502142.4001)
,p_name=>'P1700_EXISTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_item_default=>'no'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(391306559759598024.4001)
,p_name=>'P1700_LABEL_UNIQUE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>unistr('Columna \00DAnica')
,p_source=>'wwv_flow_lang.system_message(''DATA_LOAD.LABEL_UNIQUE_COLUMN'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique los nombres de columna que se van a utilizar como columna de clave \00FAnica primaria durante el proceso de carga de datos. Puede definir hasta 3 columnas de clave \00FAnica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(582265015802682821.4001)
,p_name=>'P1700_EXISTING_DATALOAD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>'Carga de datos heredada'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    name || '' ('' || wwv_flow_lang.system_message(''WIZARD.FORM.TABLE'') || '' '' || wwv_flow_data_upload.get_owner_name(owner, :FB_FLOW_ID) || ''.'' || table_name || '')'' d, ',
'    name r',
'from wwv_flow_load_tables',
'where flow_id = :FB_FLOW_ID',
'and data_profile_id is null'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Crear Nuevo'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea crear una nueva definici\00F3n de carga de datos o reutilizar una heredada existente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(616343314202812231.4001)
,p_name=>'F4000_P1700_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>unistr('Nombre de la Definici\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4227543636818913710.4001)
,p_name=>'P1700_LABEL_CASE_SENS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(17009804108278139.4001)
,p_prompt=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
,p_source=>'wwv_flow_lang.system_message(''DATA_LOAD.LABEL_CASE_SENSITIVE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_grid_column=>7
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique si la columna de clave \00FAnica seleccionada es sensible a may\00FAsculas/min\00FAsculas. Por defecto, se define en <strong>No</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(510176221330777162.4001)
,p_validation_name=>'F4000_P1700_UK_1 Must Be Different to UK2 or UK3'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P1700_UK_1 <> :F4000_P1700_UK_2 then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar una columna \00FAnica para #LABEL#.')
,p_validation_condition=>':F4000_P1700_UK_1 is not null and :F4000_P1700_UK_2 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(17011413590290370.4001)
,p_associated_item=>wwv_flow_api.id(17079603934302695.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(510405116660813658.4001)
,p_validation_name=>'F4000_P1700_UK_2 Must Be Different to UK3'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P1700_UK_2 <> :F4000_P1700_UK_3 then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar una columna \00FAnica para #LABEL#.')
,p_validation_condition=>':F4000_P1700_UK_2 is not null and :F4000_P1700_UK_3 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(17011413590290370.4001)
,p_associated_item=>wwv_flow_api.id(17079819171307130.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(510547117961833003.4001)
,p_validation_name=>'F4000_P1700_UK_2 Must be Selected'
,p_validation_sequence=>60
,p_validation=>'F4000_P1700_UK_2'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar #LABEL#.'
,p_validation_condition=>':F4000_P1700_UK_3 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(17011413590290370.4001)
,p_associated_item=>wwv_flow_api.id(17079603934302695.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(900569203178913546.4001)
,p_validation_name=>'F4000_P1700_NAME must be unique within application'
,p_validation_sequence=>70
,p_validation=>'select name from wwv_flow_load_tables where upper(name) = upper(:F4000_P1700_NAME) and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# ya existe.'
,p_when_button_pressed=>wwv_flow_api.id(17011413590290370.4001)
,p_associated_item=>wwv_flow_api.id(616343314202812231.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549005050996212189.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(17011221424283170.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549005377580212189.4001)
,p_event_id=>wwv_flow_api.id(549005050996212189.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557592255654827101.4001)
,p_name=>'Show/Hide UK_3'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1700_UK_2'
,p_condition_element=>'F4000_P1700_UK_2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557592373362827102.4001)
,p_event_id=>wwv_flow_api.id(557592255654827101.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557592405077827103.4001)
,p_event_id=>wwv_flow_api.id(557592255654827101.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557592596684827104.4001)
,p_name=>'Enable / Disable UK_2'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1700_UK_1'
,p_condition_element=>'F4000_P1700_UK_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557592608096827105.4001)
,p_event_id=>wwv_flow_api.id(557592596684827104.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_2,F4000_P1700_UK_CASE_2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557592829119827107.4001)
,p_event_id=>wwv_flow_api.id(557592596684827104.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_2,F4000_P1700_UK_3'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557592762226827106.4001)
,p_event_id=>wwv_flow_api.id(557592596684827104.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_2,F4000_P1700_UK_CASE_2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557592900486827108.4001)
,p_name=>'Enable / Disable UK_1'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1700_TABLE_NAME'
,p_condition_element=>'F4000_P1700_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593082587827109.4001)
,p_event_id=>wwv_flow_api.id(557592900486827108.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_1,F4000_P1700_UK_CASE_1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593135430827110.4001)
,p_event_id=>wwv_flow_api.id(557592900486827108.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_1,F4000_P1700_UK_CASE_1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(582265159844682822.4001)
,p_name=>'Show / Hide Create Data Load Definition'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1700_EXISTING_DATALOAD'
,p_condition_element=>'P1700_EXISTING_DATALOAD'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(582265235500682823.4001)
,p_event_id=>wwv_flow_api.id(582265159844682822.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_NAME,F4000_P1700_OWNER,F4000_P1700_TABLE_NAME,F4000_P1700_UK_1,F4000_P1700_UK_CASE_1,F4000_P1700_UK_2,F4000_P1700_UK_CASE_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(582265387176682824.4001)
,p_event_id=>wwv_flow_api.id(582265159844682822.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_NAME,F4000_P1700_OWNER,F4000_P1700_TABLE_NAME,F4000_P1700_UK_1,F4000_P1700_UK_CASE_1,F4000_P1700_UK_2,F4000_P1700_UK_CASE_2,F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(582265633365682827.4001)
,p_event_id=>wwv_flow_api.id(582265159844682822.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_OWNER,F4000_P1700_TABLE_NAME,F4000_P1700_UK_1,F4000_P1700_UK_CASE_1,F4000_P1700_UK_CASE_2,F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17083127080555411.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create load_tables collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''DATA_LOAD_TABLES'');',
'wwv_flow_collection.create_or_truncate_collection(''DATA_LOAD_TABLE_LOOKUPS'');',
'wwv_flow_collection.create_or_truncate_collection(''DATA_LOAD_TABLE_RULES'');',
'wwv_flow_collection.add_member(',
'      p_collection_name => ''DATA_LOAD_TABLES'',',
'      p_c001            => :F4000_P1700_OWNER,',
'      p_c002            => :F4000_P1700_TABLE_NAME,',
'      p_c003            => :F4000_P1700_UK_1,',
'      p_c004            => :F4000_P1700_UK_CASE_1,',
'      p_c005            => :F4000_P1700_UK_2,',
'      p_c006            => :F4000_P1700_UK_CASE_2,',
'      p_c007            => :F4000_P1700_UK_3,',
'      p_c008            => :F4000_P1700_UK_CASE_3);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(17011413590290370.4001)
);
end;
/
prompt --application/pages/page_01701
begin
wwv_flow_api.create_page(
 p_id=>1701.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos heredada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos heredada'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(423953526918849791)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17012831513314497.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16993520375207189.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17083325742583369.4001)
,p_plug_name=>'Agregar Nueva Consulta de Tabla'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(18834028855263521.4001)
,p_name=>'Crear carga de datos heredada'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>11
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id sequence, ',
'       c003 as "COLUMN",',
'       c004 as "TABLE_OWNER",',
'       c005 as "TABLE_LOOKUP", ',
'       c006 as "COLUMN_KEY", ',
'       c007 as "COLUMN_DIS",',
'       c008 as "ALT_COLUMN_DIS_1", ',
'       c009 as "ALT_COLUMN_DIS_2",',
'       ''<a href="''||apex_util.prepare_url(''f?p=&APP_ID.:1701:''||:app_session||',
'       '':DELETE:::P1701_DELETE_LOOKUP:''||seq_id)||''" class="a-Icon icon-remove"></a>'' remove_lookup',
'from apex_collections where collection_name = ''DATA_LOAD_TABLE_LOOKUPS''',
'order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Consultas de Tabla hace coincidir un valor cargado con otra tabla y permite utilizar el valor de clave asociado, en lugar del valor cargado.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(145205131395174371.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>8
,p_column_heading=>'Sequence'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18834525068263534.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN'
,p_column_display_sequence=>1
,p_column_heading=>'Columna de Consulta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(618636017823399891.4001)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18834601325263534.4001)
,p_query_column_id=>4
,p_column_alias=>'TABLE_LOOKUP'
,p_column_display_sequence=>3
,p_column_heading=>'Tabla de Consulta'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#TABLE_OWNER#.#TABLE_LOOKUP#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18834719651263534.4001)
,p_query_column_id=>5
,p_column_alias=>'COLUMN_KEY'
,p_column_display_sequence=>4
,p_column_heading=>'Devolver Columna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18834807885263534.4001)
,p_query_column_id=>6
,p_column_alias=>'COLUMN_DIS'
,p_column_display_sequence=>5
,p_column_heading=>'Cargar Columna'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46095213859693533.4001)
,p_query_column_id=>7
,p_column_alias=>'ALT_COLUMN_DIS_1'
,p_column_display_sequence=>6
,p_column_heading=>'Cargar Columna 2'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(46095330768693535.4001)
,p_query_column_id=>8
,p_column_alias=>'ALT_COLUMN_DIS_2'
,p_column_display_sequence=>7
,p_column_heading=>'Cargar Columna 3'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(137127718049356842.4001)
,p_query_column_id=>9
,p_column_alias=>'REMOVE_LOOKUP'
,p_column_display_sequence=>9
,p_column_heading=>'Suprimir'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44736412832950645.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>51
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(716353221929823639.4001)
,p_plug_name=>unistr('Definici\00F3n de Consulta')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>41
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(618312317852276909.4001)
,p_plug_name=>'Claves Alternativas'
,p_parent_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>41
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17013801647324744.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44736412832950645.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17083505094586916.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44736412832950645.4001)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Agregar Consulta'
,p_button_position=>'CREATE'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17014223810331135.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44736412832950645.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17014016884329187.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44736412832950645.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17014506626335664.4001)
,p_branch_action=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17014223810331135.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549008680008317431.4001)
,p_branch_action=>'f?p=&APP_ID.:1702:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17014016884329187.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9081704488448881.4001)
,p_name=>'F4000_P1701_ALT_KEY_COL_2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9081914185451609.4001)
,p_name=>'F4000_P1701_ALT_DIS_COL_2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_prompt=>'Cargar Columna 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el nombre de la tercera columna que se va a cargar para identificar de forma \00FAnica la columna de retorno, si es necesario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17083929120603307.4001)
,p_name=>'P1701_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17083325742583369.4001)
,p_item_default=>'&F4000_P1700_OWNER.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el esquema propietario de la tabla en la que se va a basar la carga de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17084528044650347.4001)
,p_name=>'P1701_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17083325742583369.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P1700_TABLE_NAME.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica la tabla en la que se va a basar la carga de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17084708875710964.4001)
,p_name=>'F4000_P1701_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17083325742583369.4001)
,p_prompt=>'Agregar Nueva Consulta de Tabla para la Columna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name_esc a, c.column_name b ',
'  from wwv_flow_table_columns_dev c ',
' where c.table_name = :P1701_TABLE_NAME ',
'   and owner = :P1701_OWNER ',
' order by c.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la columna en la que se va a basar la definici\00F3n de consulta de tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17084920650714420.4001)
,p_name=>'F4000_P1701_LOOKUP_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_prompt=>'Devolver Columna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el nombre de la columna devuelta por la consulta de tabla. Este valor se insertar\00E1 en la columna de carga especificada y normalmente se trata del valor clave del principal en una relaci\00F3n de clave ajena. Por ejemplo: DEPTNO')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17085104504719190.4001)
,p_name=>'F4000_P1701_LOOKUP_DIS_COL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_prompt=>'Cargar Columna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el nombre de los usuarios finales de columna que se cargar\00E1n en lugar de la columna de retorno. Se trata de la columna que contiene el valor de visualizaci\00F3n de la tabla de consulta. '),
'Por ejemplo: DNAME'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17085318357723221.4001)
,p_name=>'F4000_P1701_LOOKUP_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_prompt=>'Nombre de Tabla de Consulta'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P1701_LOOKUP_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la tabla que se utilizar\00E1 para esta definici\00F3n de consulta de tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137454508961373080.4001)
,p_name=>'P1701_DELETE_LOOKUP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(616691423253843189.4001)
,p_name=>'F4000_P1701_LOOKUP_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_item_default=>':F4000_P1700_OWNER'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla de Consulta'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Propietario -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione el propietario de la tabla de consulta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(618491915783352012.4001)
,p_name=>'F4000_P1701_ALT_KEY_COL_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(618544123533363765.4001)
,p_name=>'F4000_P1701_ALT_DIS_COL_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_prompt=>'Cargar Columna 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el nombre de la segunda columna que se va a cargar para identificar de forma \00FAnica la columna de retorno, si es necesario. Por ejemplo, para identificar de forma \00FAnica C\00F3digo de Estado, puede que sea necesario cargar Nombre de Estado y Pa\00ED')
||'s.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(940659192303194133.4001)
,p_name=>'P1701_NEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(716353221929823639.4001)
,p_source=>'wwv_flow_lang.system_message(''F4000.P1701.LOOKUP_DEFINITION'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509218212429556965.4001)
,p_validation_name=>'F4000_P1701_COLUMN_NAME Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'F4000_P1701_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(17083505094586916.4001)
,p_associated_item=>wwv_flow_api.id(17084708875710964.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509285709790565660.4001)
,p_validation_name=>'F4000_P1701_LOOKUP_TABLE Must Be Selected'
,p_validation_sequence=>20
,p_validation=>'F4000_P1701_LOOKUP_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(17083505094586916.4001)
,p_associated_item=>wwv_flow_api.id(17085318357723221.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509335517540577346.4001)
,p_validation_name=>'F4000_P1701_LOOKUP_KEY Must Be Selected'
,p_validation_sequence=>30
,p_validation=>'F4000_P1701_LOOKUP_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(17083505094586916.4001)
,p_associated_item=>wwv_flow_api.id(17084920650714420.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509377407282583877.4001)
,p_validation_name=>'F4000_P1701_LOOKUP_DIS_COL Must be Selected'
,p_validation_sequence=>40
,p_validation=>'F4000_P1701_LOOKUP_DIS_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(17083505094586916.4001)
,p_associated_item=>wwv_flow_api.id(17085104504719190.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549007712950312217.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(17013801647324744.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549008023577312217.4001)
,p_event_id=>wwv_flow_api.id(549007712950312217.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557593203070827111.4001)
,p_name=>'Show / Hide Upload Col 3'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1701_ALT_DIS_COL_1'
,p_condition_element=>'F4000_P1701_ALT_DIS_COL_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593390219827112.4001)
,p_event_id=>wwv_flow_api.id(557593203070827111.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557594439552827123.4001)
,p_event_id=>wwv_flow_api.id(557593203070827111.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593466267827113.4001)
,p_event_id=>wwv_flow_api.id(557593203070827111.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557593544743827114.4001)
,p_name=>'Show / Hide Lookup Definiton'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1701_COLUMN_NAME'
,p_condition_element=>'F4000_P1701_COLUMN_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593687169827115.4001)
,p_event_id=>wwv_flow_api.id(557593544743827114.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(716353221929823639.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593965380827118.4001)
,p_event_id=>wwv_flow_api.id(557593544743827114.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(17083505094586916.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593733833827116.4001)
,p_event_id=>wwv_flow_api.id(557593544743827114.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(716353221929823639.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557593859136827117.4001)
,p_event_id=>wwv_flow_api.id(557593544743827114.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(17083505094586916.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557594004878827119.4001)
,p_name=>'Enable / Disable Upload COL 1'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1701_LOOKUP_DIS_COL'
,p_condition_element=>'F4000_P1701_LOOKUP_DIS_COL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557594103722827120.4001)
,p_event_id=>wwv_flow_api.id(557594004878827119.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557594325255827122.4001)
,p_event_id=>wwv_flow_api.id(557594004878827119.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_1,F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557594268295827121.4001)
,p_event_id=>wwv_flow_api.id(557594004878827119.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17088427155810906.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update table_lookups collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_exists boolean := false;',
'begin',
'    if wwv_flow_collection.collection_exists(''DATA_LOAD_TABLE_LOOKUPS'') = FALSE then',
'        wwv_flow_collection.create_collection(''DATA_LOAD_TABLE_LOOKUPS'');',
'    end if;',
'    l_exists := true;',
'    for c2 in (select c001, c002, c003, c004 from apex_collections where collection_name = ''DATA_LOAD_TABLE_LOOKUPS'') ',
'    loop',
'        if (c2.c001 = :P1701_OWNER AND c2.c002 = :P1701_TABLE_NAME AND c2.c003 = :F4000_P1701_COLUMN_NAME) THEN',
'            l_exists := false; ',
'        end if;',
'    end loop;',
'    if l_exists then',
'        wwv_flow_collection.add_member(',
'               p_collection_name => ''DATA_LOAD_TABLE_LOOKUPS'',',
'               p_c001            => :P1701_OWNER,',
'               p_c002            => :P1701_TABLE_NAME,',
'               p_c003            => :F4000_P1701_COLUMN_NAME,',
'               p_c004            => :F4000_P1701_LOOKUP_OWNER,',
'               p_c005            => :F4000_P1701_LOOKUP_TABLE,',
'               p_c006            => :F4000_P1701_LOOKUP_KEY,',
'               p_c007            => :F4000_P1701_LOOKUP_DIS_COL,',
'               p_c008            => :F4000_P1701_ALT_DIS_COL_1,',
'               p_c009            => :F4000_P1701_ALT_DIS_COL_2);',
'    end if;',
'',
'    -- Reset Items',
'    :F4000_P1701_COLUMN_NAME    := null;',
'    :F4000_P1701_LOOKUP_OWNER   := null; ',
'    :F4000_P1701_LOOKUP_KEY     := null;',
'    :F4000_P1701_LOOKUP_DIS_COL := null;',
'    :F4000_P1701_LOOKUP_DIS_COL := null;',
'    :F4000_P1701_ALT_KEY_COL_1  := null;',
'    :F4000_P1701_ALT_DIS_COL_1  := null;',
'    :F4000_P1701_ALT_KEY_COL_2  := null;',
'    :F4000_P1701_ALT_DIS_COL_2  := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(17083505094586916.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(136562502241286039.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove table lookup from the collection'
,p_process_sql_clob=>'wwv_flow_collection.delete_member(''DATA_LOAD_TABLE_LOOKUPS'', :P1701_DELETE_LOOKUP);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_01702
begin
wwv_flow_api.create_page(
 p_id=>1702.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos heredada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos heredada'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(423953526918849791)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17016401048381388.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16993520375207189.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17016720441386960.4001)
,p_plug_name=>unistr('Agregar Regla de Transformaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>51
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44742603098995181.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>61
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(141953803036768756.4001)
,p_name=>'Crear carga de datos heredada'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>31
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, ',
'       c003 as "COLUMN", ',
'       c004 as "SEQUENCE", ',
'       c005 as "TYPE", ',
'       c006 as "NAME",',
'       c007 as "EXPRESSION_1",',
'       c008 as "EXPRESSION_2",',
'       ''<a href="''||apex_util.prepare_url(''f?p=4000:1702:''||:app_session||',
'       '':DELETE:::P1702_DELETE_RULE:''||seq_id)||''" class="a-Icon icon-remove"></a>'' remove_rule',
'from apex_collections where collection_name = ''DATA_LOAD_TABLE_RULES'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Reglas de Transformaci\00F3n permite modificar los datos que se van a cargar antes de insertarlos en la tabla base. Seleccione la columna que desea transformar y, a continuaci\00F3n, la regla deseada que desea aplicarle.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141954117841768758.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Seq Id'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141954211204768758.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN'
,p_column_display_sequence=>5
,p_column_heading=>'Columna(s)'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141954330925768758.4001)
,p_query_column_id=>3
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738619628788343951.4001)
,p_query_column_id=>4
,p_column_alias=>'TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(141003727830690827)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(738619706308343952.4001)
,p_query_column_id=>5
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de Regla'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(240259131041254615.4001)
,p_query_column_id=>6
,p_column_alias=>'EXPRESSION_1'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Expresi\00F3n 1')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(240259208323254615.4001)
,p_query_column_id=>7
,p_column_alias=>'EXPRESSION_2'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Expresi\00F3n 2')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(141954627598768758.4001)
,p_query_column_id=>8
,p_column_alias=>'REMOVE_RULE'
,p_column_display_sequence=>8
,p_column_heading=>'Suprimir'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240063320929645313.4001)
,p_plug_name=>unistr('Sintaxis de Expresi\00F3n PL/SQL')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>71
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240065413095652559.4001)
,p_plug_name=>unistr('Sintaxis de Cuerpo de Funci\00F3n PL/SQL')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>81
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(240066800067658259.4001)
,p_plug_name=>'Sintaxis de Consulta SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>91
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''DATA_LOAD.RULES_SQL_QUERY_EXAMPLES''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17017106373392379.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44742603098995181.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(142502913125800120.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44742603098995181.4001)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Agregar Transformaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17017828190398660.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44742603098995181.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17017319879396246.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44742603098995181.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17020414993442164.4001)
,p_branch_action=>'f?p=&APP_ID.:1701:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17017828190398660.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549006813591231832.4001)
,p_branch_action=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17017319879396246.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23853215218692051.4001)
,p_name=>'F4000_P1702_RULE_EXPR3'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_prompt=>unistr('Condici\00F3n de Recorte')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TRIM_CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(23846801132546001.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(140768001464654766.4001)
,p_name=>'P1702_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_item_default=>'&F4000_P1700_OWNER.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el esquema propietario de la tabla en la que se va a basar la carga de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(140832516355659076.4001)
,p_name=>'P1702_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P1700_TABLE_NAME.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica la tabla en la que se va a basar la carga de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(140939528260672040.4001)
,p_name=>'F4000_P1702_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_prompt=>unistr('Seleccione las columnas para crear una regla de transformaci\00F3n')
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name_esc a, c.column_name b from wwv_flow_table_columns_dev c where c.table_name = :P1702_TABLE_NAME and owner = :P1702_OWNER',
'order by c.column_id'))
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifique la columna en la que se va a basar la definici\00F3n de regla de transformaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141126609737704498.4001)
,p_name=>'F4000_P1702_RULE_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOADING RULES TYPES'
,p_lov=>'.'||wwv_flow_api.id(141003727830690827.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Tipo de Regla de Selecci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de regla de transformaci\00F3n que desea crear:')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141182629608719737.4001)
,p_name=>'F4000_P1702_RULE_EXPR1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Defina la regla de transformaci\00F3n anterior')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141209008268723011.4001)
,p_name=>'F4000_P1702_RULE_EXPR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Defina la regla de transformaci\00F3n anterior')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141341407014732076.4001)
,p_name=>'F4000_P1702_RULE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_prompt=>'Nombre de Regla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la regla de transformaci\00F3n que se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(142171014249781490.4001)
,p_name=>'P1702_DELETE_RULE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(143049231788852803.4001)
,p_name=>'F4000_P1702_RULE_SEQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(17016720441386960.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    s number;',
'begin',
'    select max(c004) into s',
'      from apex_collections ',
'     where collection_name = ''DATA_LOAD_TABLE_RULES'';',
'   s := nvl(s,0);',
'   s := trunc(s) + 10;',
'   return s;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique la secuencia para la regla de transformaci\00F3n. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(508876218092492363.4001)
,p_validation_name=>'F4000_P1702_RULE_SEQ Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'F4000_P1702_RULE_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(143049231788852803.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509013516276510740.4001)
,p_validation_name=>'F4000_P1702_RULE_TYPE Must Be Selected'
,p_validation_sequence=>20
,p_validation=>'F4000_P1702_RULE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(141126609737704498.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509051332553515472.4001)
,p_validation_name=>'F4000_P1702_RULE_NAME Must Be Specified'
,p_validation_sequence=>30
,p_validation=>'F4000_P1702_RULE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(141341407014732076.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(509096717446520559.4001)
,p_validation_name=>'F4000_P1702_COLUMN_NAME Must Be Selected'
,p_validation_sequence=>40
,p_validation=>'F4000_P1702_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(140939528260672040.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(326744006079467860.4001)
,p_validation_name=>'F4000_P1702_RULE_EXPR1'
,p_validation_sequence=>50
,p_validation=>'F4000_P1702_RULE_EXPR1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':F4000_P1702_RULE_TYPE in (''PLSQL_FUNCTION_BODY'',''PLSQL_EXPRESSION'',''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(141182629608719737.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1337910750100622328.4001)
,p_validation_name=>'Validate PLSQL function body'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'     :F4000_P1702_RULE_EXPR1,',
'     :FB_FLOW_ID,',
'     :FLOW_SECURITY_GROUP_ID',
' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST = ''ADD'' and :F4000_P1702_RULE_TYPE = ''PLSQL_FUNCTION_BODY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(141182629608719737.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(557594554385827124.4001)
,p_validation_name=>'Validate SQL Query, SQL and PLSQL expressions'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.validate_plsql_expressions(',
'     :F4000_P1702_RULE_EXPR1,',
'    :F4000_P1702_RULE_TYPE',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST = ''ADD'' and :F4000_P1702_RULE_TYPE in (''PLSQL_EXPRESSION'',''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(142502913125800120.4001)
,p_associated_item=>wwv_flow_api.id(141182629608719737.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(486082505592249567.4001)
,p_name=>'Rule Expression 1'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_RULE_TYPE'
,p_condition_element=>'F4000_P1702_RULE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REPLACE,PLSQL_EXPRESSION,REGULAR_EXPRESSION, SQL_QUERY_SINGLE_VALUE, SQL_QUERY_SEMI_COLON, PLSQL_FUNCTION_BODY, TRIM, LTRIM, RTRIM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(486082805977249571.4001)
,p_event_id=>wwv_flow_api.id(486082505592249567.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(486083004232249572.4001)
,p_event_id=>wwv_flow_api.id(486082505592249567.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(486101913557251786.4001)
,p_name=>'Rule Expression 2'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_RULE_TYPE'
,p_condition_element=>'F4000_P1702_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(486102201017251925.4001)
,p_event_id=>wwv_flow_api.id(486101913557251786.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR2'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(486102424449251925.4001)
,p_event_id=>wwv_flow_api.id(486101913557251786.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR2'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23853832534696991.4001)
,p_name=>'Transformation Rule (trim condition)'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_RULE_TYPE'
,p_condition_element=>'F4000_P1702_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TRIM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23854127612696991.4001)
,p_event_id=>wwv_flow_api.id(23853832534696991.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR3'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23854317588696992.4001)
,p_event_id=>wwv_flow_api.id(23853832534696991.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR3'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549006234878229114.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(17017106373392379.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549006551963229120.4001)
,p_event_id=>wwv_flow_api.id(549006234878229114.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(557594748831827126.4001)
,p_name=>'Show Hide'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_COLUMN_NAME'
,p_condition_element=>'F4000_P1702_COLUMN_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557594800619827127.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_SEQ,F4000_P1702_RULE_NAME,F4000_P1702_RULE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595036628827129.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(142502913125800120.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595790203827136.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(240066800067658259.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595285362827131.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(240063320929645313.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595625710827135.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(240065413095652559.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595366660827132.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(240065413095652559.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595505860827134.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(240063320929645313.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595115672827130.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(142502913125800120.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557595499312827133.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(240066800067658259.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(557594983480827128.4001)
,p_event_id=>wwv_flow_api.id(557594748831827126.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_SEQ,F4000_P1702_RULE_NAME,F4000_P1702_RULE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12685612286745845.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get plsql_expression_2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_position     number;',
'   l_expr_string   varchar2(4000) := null;',
'   type l_arr_int_cols is table of varchar2(255) index by binary_integer;',
'   type l_arr_position is table of number index by binary_integer;',
'   l_arr_pos      l_arr_position;',
'   l_int_cols     l_arr_int_cols;',
'   i              pls_integer := 0;',
'begin',
'    if :F4000_P1702_RULE_TYPE in (''PLSQL_EXPRESSION'', ''PLSQL_FUNCTION_BODY'', ''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'', ''REGULAR_EXPRESSION'') then',
'        for c1 in (select column_name',
'                      from wwv_flow_table_columns_dev',
'                     where table_name = :P1702_TABLE_NAME',
'                      and owner = :P1702_OWNER )',
'        loop',
'            l_position := instr(:F4000_P1702_RULE_EXPR1, '':''||c1.column_name, 1);',
'                while l_position > 0',
'                loop',
'                     if l_int_cols.exists(l_position) = false then',
'                        i := i + 1;',
'                        l_arr_pos(i) := l_position;',
'                        l_int_cols(l_position) := c1.column_name;',
'                    else',
'                        if instr(c1.column_name, l_int_cols(l_position), 1) > 0 then',
'                            l_int_cols(l_position) := c1.column_name;',
'                        end if;',
'                    end if;',
'                    l_position := instr(:F4000_P1702_RULE_EXPR1,'':''||c1.column_name,l_position + 1);',
'                end loop;',
'        end loop;',
'        for i in 1..l_arr_pos.count',
'        loop',
'            l_expr_string := l_expr_string||'':''||l_int_cols(l_arr_pos(i));',
'        end loop;',
'    :F4000_P1702_RULE_EXPR2 := l_expr_string;',
'    end if;',
'    if :F4000_P1702_RULE_TYPE = ''TRIM'' then',
'       :F4000_P1702_RULE_EXPR2 := :F4000_P1702_RULE_EXPR3;',
'    end if;',
' end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(142502913125800120.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(142843330834833638.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update table_rules collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_exists boolean := false;',
'begin',
'    if wwv_flow_collection.collection_exists(''DATA_LOAD_TABLE_RULES'') = FALSE then',
'        wwv_flow_collection.create_collection(''DATA_LOAD_TABLE_RULES'');',
'    end if;',
'    ',
'    l_exists := true;',
'',
'    for c2 in (select c001, c002, c003, c004 from apex_collections where collection_name = ''DATA_LOAD_TABLE_RULES'') ',
'    loop',
'        if (c2.c001 = :P1702_OWNER AND c2.c002 = :P1702_TABLE_NAME AND c2.c003 = :F4000_P1702_COLUMN_NAME) THEN',
'            l_exists := false; ',
'        end if;',
'    end loop;',
'',
'    if l_exists then',
'        wwv_flow_collection.add_member(',
'                p_collection_name => ''DATA_LOAD_TABLE_RULES'',',
'                p_c001            => :P1702_OWNER,',
'                p_c002            => :P1702_TABLE_NAME,',
'                p_c003            => :F4000_P1702_COLUMN_NAME,',
'                p_c004            => :F4000_P1702_RULE_SEQ,',
'                p_c005            => :F4000_P1702_RULE_TYPE,',
'                p_c006            => :F4000_P1702_RULE_NAME,',
'                p_c007            => :F4000_P1702_RULE_EXPR1,',
'                p_c008            => :F4000_P1702_RULE_EXPR2);',
'    end if;',
'',
'    -- Reset Values To Null',
'    :F4000_P1702_COLUMN_NAME := null;',
'    :F4000_P1702_RULE_SEQ    := null;',
'    :F4000_P1702_RULE_TYPE   := null;',
'    :F4000_P1702_RULE_NAME   := null;',
'    :F4000_P1702_RULE_EXPR1  := null;',
'    :F4000_P1702_RULE_EXPR2  := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(142502913125800120.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(142381616111791513.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove table rule from the collection'
,p_process_sql_clob=>'wwv_flow_collection.delete_member(''DATA_LOAD_TABLE_RULES'', :P1702_DELETE_RULE);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
null;
end;
/
prompt --application/pages/page_01704
begin
wwv_flow_api.create_page(
 p_id=>1704.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos heredada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos heredada'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(423953526918849791)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17037621507614405.4001)
,p_plug_name=>'Crear carga de datos heredada'
,p_region_css_classes=>'a-Form--fixedLabelsSmall'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Esta p\00E1gina proporciona una abreviatura descriptiva para cada una de las p\00E1ginas del asistente de carga de datos que se va a crear. Proporcione el nombre de p\00E1gina, el n\00FAmero y los nombres de regiones que se utilizar\00E1n en el asistente de carga de ')
||'datos.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17038732028626860.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16993520375207189.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44760107956072262.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>51
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17037901899618123.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44760107956072262.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17038319214623199.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44760107956072262.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(581438578421388810.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44760107956072262.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1701:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17040932037702539.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(17038319214623199.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17089918440054409.4001)
,p_name=>'F4000_P1704_STEP_1'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Paso 1')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17090131946058289.4001)
,p_name=>'F4000_P1704_STEP_2'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Paso 2')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17090311645061905.4001)
,p_name=>'F4000_P1704_STEP_3'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Paso 3')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17090522727065107.4001)
,p_name=>'F4000_P1704_STEP_4'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Paso 4')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45293322305583986.4001)
,p_name=>'P1704_PAGE_MODE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(306718601132076249.4001)
,p_name=>'F4000_P1704_LABEL_STEP_1'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.SOURCE'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Paso 1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nombre y n\00FAmero de p\00E1gina que se va a utilizar para el paso 1, el paso de origen de carga de datos del asistente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(306745612560079584.4001)
,p_name=>'F4000_P1704_LABEL_STEP_2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.MAPPING'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Paso 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nombre y n\00FAmero de p\00E1gina que se va a utilizar para el paso 2, el paso de asignaci\00F3n de datos/tabla del asistente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(306772620871082020.4001)
,p_name=>'F4000_P1704_LABEL_STEP_3'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.VALIDATION'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Paso 3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nombre y n\00FAmero de p\00E1gina que se va a utilizar para el paso 3, el paso de validaci\00F3n de datos del asistente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(306799630914084925.4001)
,p_name=>'F4000_P1704_LABEL_STEP_4'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.UPLOAD_RESULTS'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Paso 4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nombre y n\00FAmero de p\00E1gina que se va a utilizar para el paso 4, el paso de carga de resultados del asistente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(307157215517194031.4001)
,p_name=>'P1704_BREADCRUMB_ID'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(307326122415318969.4001)
,p_name=>'P1704_BREADCRUMB_NAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.DATA_LOADING'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el nombre de esta entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381603152133221289.4001)
,p_name=>'P1704_BREADCRUMB_PARENT_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P1704_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P1704_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P1704_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402688644236475854.4001)
,p_name=>'P1704_GROUP_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(426368401356372331.4001)
,p_name=>'P1704_PAGE_NAME_LABEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_source=>'wwv_flow_lang.system_message(''F4000.PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Enter a title for the page being created.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(426425401487381808.4001)
,p_name=>'P1704_PAGE_ID_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(17037621507614405.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_lang.system_message(''CONFIRM.DATA_LOAD_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Enter a unique page number for the page being created.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1941075897639553145.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1704_BREADCRUMB_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4501721641479001.4001)
,p_computation_sequence=>10
,p_computation_item=>'P259_USER_INTERFACE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and rownum = 1 ',
' order by display_seq'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4501863895479002.4001)
,p_computation_sequence=>20
,p_computation_item=>'P259_NAVIGATION_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where x.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
'   and x.flow_id           = i.flow_id',
'   and i.id                = :P259_USER_INTERFACE_ID',
'   and i.theme_id          = x.theme_id',
' order by 1'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(510898624980891789.4001)
,p_validation_name=>'Unique Page Numbers Must be Specified'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'begin',
'    for c1 in (select NULL',
'                 from wwv_flow_steps ',
'                where id in (:F4000_P1704_STEP_1,:F4000_P1704_STEP_2,:F4000_P1704_STEP_3,:F4000_P1704_STEP_4)',
'                  and flow_id = :FB_FLOW_ID ',
'                  and security_group_id = wwv_flow_security.g_security_group_id) loop',
'        l_result := FALSE;',
'        exit;',
'    end loop;',
'    return l_result;',
'    --',
'    exception',
'        when others then',
'            return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe especificar unos n\00FAmeros de p\00E1gina \00FAnicos en formato num\00E9rico que no est\00E9 utilizando ya la aplicaci\00F3n "&FB_FLOW_ID.".')
,p_associated_item=>wwv_flow_api.id(426425401487381808.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(512164022893165569.4001)
,p_validation_name=>'Page Numbers Cannot Be the same'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (  :F4000_P1704_STEP_1=:F4000_P1704_STEP_2',
'   or :F4000_P1704_STEP_1=:F4000_P1704_STEP_3 ',
'   or :F4000_P1704_STEP_1=:F4000_P1704_STEP_4',
'   or :F4000_P1704_STEP_2=:F4000_P1704_STEP_3',
'   or :F4000_P1704_STEP_2=:F4000_P1704_STEP_4',
'   or :F4000_P1704_STEP_3=:F4000_P1704_STEP_4 )',
'then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe especificar unos n\00FAmeros \00FAnicos en formato num\00E9rico para cada una de las p\00E1ginas que vaya a crear.')
,p_validation_condition=>':F4000_P1704_STEP_1 is not null and :F4000_P1704_STEP_2 is not null and :F4000_P1704_STEP_3 is not null and :F4000_P1704_STEP_4 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45293818854585647.4001)
,p_validation_name=>'P1704_PAGE_MODE Not Null'
,p_validation_sequence=>110
,p_validation=>'P1704_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(17038319214623199.4001)
,p_associated_item=>wwv_flow_api.id(45293322305583986.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(402736362564769662.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P1704_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1704_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(17038319214623199.4001)
,p_associated_item=>wwv_flow_api.id(402688644236475854.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381604915818238072.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1704_BREADCRUMB_ID'
,p_condition_element=>'P1704_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381605259963238072.4001)
,p_event_id=>wwv_flow_api.id(381604915818238072.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1704_BREADCRUMB_PARENT_ID,P1704_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381605462662238072.4001)
,p_event_id=>wwv_flow_api.id(381604915818238072.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1704_BREADCRUMB_PARENT_ID,P1704_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549009521070329464.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(17037901899618123.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549009804675329464.4001)
,p_event_id=>wwv_flow_api.id(549009521070329464.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01706
begin
wwv_flow_api.create_page(
 p_id=>1706.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos heredada'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos heredada'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(423953526918849791)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44782926666153356.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(307918531793548759.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16993520375207189.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_row_template=>wwv_flow_api.id(506168724401357441.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(308035630108576675.4001)
,p_plug_name=>'Crear carga de datos heredada'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(308069925391584807.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44782926666153356.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(308116127946595025.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44782926666153356.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(308093010631589969.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44782926666153356.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4501981608479003.4001)
,p_branch_name=>'Go to edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:&FB_FLOW_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(308116127946595025.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(538265446997852394.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(308093010631589969.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308196116088610526.4001)
,p_name=>'F4000_P1706_CANCEL_LABEL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(308035630108576675.4001)
,p_item_default=>'wwv_flow_lang.system_message(''CANCEL'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Etiqueta de Bot\00F3n Cancelar')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca el texto que aparecer\00E1 en el bot\00F3n Cancelar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308253830642690345.4001)
,p_name=>'F4000_P1706_CANCEL_BRANCH'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(308035630108576675.4001)
,p_prompt=>unistr('Cancelar Bifurcaci\00F3n de Bot\00F3n a P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el n\00FAmero de p\00E1gina a la que bifurcar cuando el usuario haga clic en Cancelar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308292132504700384.4001)
,p_name=>'F4000_P1706_NEXT_LABEL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(308035630108576675.4001)
,p_item_default=>'wwv_flow_lang.system_message(''NEXT'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Etiqueta de Bot\00F3n Siguiente')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el texto que aparecer\00E1 en el bot\00F3n Siguiente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308319111511703745.4001)
,p_name=>'F4000_P1706_PREVIOUS_LABEL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(308035630108576675.4001)
,p_item_default=>'wwv_flow_lang.system_message(''PREVIOUS'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Etiqueta de Bot\00F3n Anterior')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el texto que aparecer\00E1 en el bot\00F3n Anterior.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308347306447711803.4001)
,p_name=>'F4000_P1706_SUBMIT_LABEL'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(308035630108576675.4001)
,p_item_default=>'wwv_flow_lang.system_message(''F4000.P4731.FINISH'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Etiqueta de Bot\00F3n Terminar')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto que aparecer\00E1 en el bot\00F3n Terminar.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(308382132074719136.4001)
,p_name=>'F4000_P1706_SUBMIT_BRANCH'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(308035630108576675.4001)
,p_prompt=>unistr('Terminar Bifurcaci\00F3n de Bot\00F3n a P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el n\00FAmero de la p\00E1gina a la que bifurcar. Puede elegir volver a bifurcar a la misma p\00E1gina o a cualquier otra p\00E1gina de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549011384662348198.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(308069925391584807.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549011662632348199.4001)
,p_event_id=>wwv_flow_api.id(549011384662348198.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(618358026360311325.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data load wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_data_load_wizard (',
'        p_flow_id              => :FB_FLOW_ID,',
'        --',
'        p_name                     => :F4000_P1700_NAME,',
'        p_owner                    => :F4000_P1700_OWNER,',
'        p_table_name               => :F4000_P1700_TABLE_NAME,',
'        p_exists                   => :P1700_EXISTS,',
'        p_page_mode                => :P1704_PAGE_MODE,',
'        p_group_name               => :P1704_GROUP_NAME,',
'        --',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        p_tab_set                  => :P4716_TAB_SET,',
'        p_tab_name                 => :P4716_TAB_NAME,',
'        p_tab_label                => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --    ',
'        p_breadcrumb_id            => :P1704_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P1704_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id     => :P1704_BREADCRUMB_PARENT_ID,',
'        --',
'        p_page_step_1              => :F4000_P1704_STEP_1,',
'        p_page_step_2              => :F4000_P1704_STEP_2,',
'        p_page_step_3              => :F4000_P1704_STEP_3,',
'        p_page_step_4              => :F4000_P1704_STEP_4,',
'        --',
'        p_page_label_step_1        => :F4000_P1704_LABEL_STEP_1,',
'        p_page_label_step_2        => :F4000_P1704_LABEL_STEP_2,',
'        p_page_label_step_3        => :F4000_P1704_LABEL_STEP_3,',
'        p_page_label_step_4        => :F4000_P1704_LABEL_STEP_4,',
'        --',
'        p_region_name_step_1       => :F4000_P1704_LABEL_STEP_1,',
'        p_region_name_step_2       => :F4000_P1704_LABEL_STEP_2,',
'        p_region_name_step_3       => :F4000_P1704_LABEL_STEP_3,',
'        p_region_name_step_4       => :F4000_P1704_LABEL_STEP_4,',
'        --',
'        p_page_next_label          => :F4000_P1706_NEXT_LABEL,',
'        p_page_previous_label      => :F4000_P1706_PREVIOUS_LABEL,',
'        p_page_cancel_label        => :F4000_P1706_CANCEL_LABEL,',
'        p_page_cancel_branch       => :F4000_P1706_CANCEL_BRANCH,',
'        p_page_finish_label        => :F4000_P1706_SUBMIT_LABEL,',
'        p_page_finish_branch       => :F4000_P1706_SUBMIT_BRANCH );',
'',
'   -- Set Application Items To First New Page of Data Load Wizard - for use on Success Page',
'   :FB_FLOW_PAGE_ID       := :F4000_P1704_STEP_1;',
'   :F4000_RUN_EDIT_PAGE   := :F4000_P1704_STEP_1;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear las la carga de datos heredada.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(308116127946595025.4001)
,p_process_success_message=>'La carga de datos heredada se ha creado correctamente.'
);
end;
/
prompt --application/pages/page_01800
begin
wwv_flow_api.create_page(
 p_id=>1800.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Definiciones de Carga de Datos'
,p_step_title=>'Definiciones de Carga de Datos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2563810357654036.4001)
,p_plug_name=>'Carga de datos heredada'
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_load_tables',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'and data_profile_id is null'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1451393743911801.4001)
,p_plug_name=>'Carga de datos heredada'
,p_parent_plug_id=>wwv_flow_api.id(2563810357654036.4001)
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  name,',
'  table_name,',
'  ''icon-sc-data-loading'' icon_class,',
'       ''f?p=4000:1801:''||:app_session||',
'           ''::NO:1801:P1801_ID:''||id edit_link,',
'  unique_column_1, ',
'  is_uk1_case_sensitive, ',
'  unique_column_2, ',
'  is_uk2_case_sensitive, ',
'  unique_column_3, ',
'  is_uk3_case_sensitive, ',
'  unique_column_1||',
'      decode(unique_column_2,null,null,'', ''||unique_column_2)||',
'      decode(unique_column_3,null,null,'', ''||unique_column_3) key_columns,',
'(select count(*) from wwv_flow_load_table_lookups s where s.load_table_id = l.id ) lookups, ',
'(select count(*) from wwv_flow_load_table_rules s where s.load_table_id = l.id ) rules, ',
'  l.created_on table_created,',
'  l.created_by table_created_by, ',
'  l.last_updated_on, ',
'  l.last_updated_by',
'  from wwv_flow_load_tables l',
' where l.flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and data_profile_id is null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1451634485911804.4001)
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de #MAX_ROW_COUNT# filas; filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1451634485911804
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1451753816911805.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1451804330911806.4001)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nombre de la Tabla'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1451923828911807.4001)
,p_db_column_name=>'LOOKUPS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Consultas'
,p_sync_form_label=>'N'
,p_column_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:1801:P1801_ID:#ID#'
,p_column_linktext=>'#LOOKUPS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452018251911808.4001)
,p_db_column_name=>'RULES'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Reglas'
,p_column_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:1801:P1801_ID:#ID#'
,p_column_linktext=>'#RULES#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452156160911809.4001)
,p_db_column_name=>'TABLE_CREATED'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452230103911810.4001)
,p_db_column_name=>'TABLE_CREATED_BY'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452320118911811.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>unistr('Fecha de Modificaci\00F3n')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452445712911812.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>unistr('Autor de \00FAltima modificaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452531754911813.4001)
,p_db_column_name=>'KEY_COLUMNS'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Columnas de Clave'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452654514911814.4001)
,p_db_column_name=>'IS_UK1_CASE_SENSITIVE'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>unistr('\00BFEs Uk1 sensible a may\00FAsculas/min\00FAsculas?')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452767596911815.4001)
,p_db_column_name=>'IS_UK2_CASE_SENSITIVE'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>unistr('\00BFEs Uk2 sensible a may\00FAsculas/min\00FAsculas?')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452848018911816.4001)
,p_db_column_name=>'IS_UK3_CASE_SENSITIVE'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>unistr('\00BFEs Uk3 sensible a may\00FAsculas/min\00FAsculas?')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1452939389911817.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453019461911818.4001)
,p_db_column_name=>'UNIQUE_COLUMN_1'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>unistr('Columna \00DAnica 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453118131911819.4001)
,p_db_column_name=>'UNIQUE_COLUMN_2'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>unistr('Columna \00DAnica 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453208917911820.4001)
,p_db_column_name=>'UNIQUE_COLUMN_3'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>unistr('Columna \00DAnica 3')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453382525911821.4001)
,p_db_column_name=>'NAME'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:1801:P1801_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453419214911822.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>180
,p_column_identifier=>'R'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15136824324283148.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(15132926917246073.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15698603515328105.4001)
,p_plug_name=>'Carga de Datos'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  l.id,',
'  l.name,',
'  l.target_type,',
'  case l.target_type',
'  when ''TABLE'' then',
'      l.table_name',
'  when ''COLLECTION'' then',
'      l.collection_name',
'  end target_name,',
'  ''icon-sc-data-loading'' icon_class,',
'       ''f?p=4000:1820:''||:app_session||',
'           ''::NO:1820:P1820_ID:''||l.id edit_link,',
'  l.created_on,',
'  l.created_by, ',
'  l.last_updated_on, ',
'  l.last_updated_by',
'  from wwv_flow_load_tables l, wwv_flow_data_profiles p',
' where p.id = l.data_profile_id',
'   and l.flow_id = :fb_flow_id',
'   and l.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(15698721914328105.4001)
,p_name=>'Tables Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de #MAX_ROW_COUNT# filas; filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No hay ninguna definici\00F3n de carga de datos definida en esta aplicaci\00F3n.')
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'PMANIRAHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15698923904328108.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453501874911823.4001)
,p_db_column_name=>'TARGET_TYPE'
,p_display_order=>11
,p_column_identifier=>'AJ'
,p_column_label=>'tipo de objetivo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1633774479940540)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453664171911824.4001)
,p_db_column_name=>'TARGET_NAME'
,p_display_order=>21
,p_column_identifier=>'AK'
,p_column_label=>'Nombre de destino'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480757507141288937.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>31
,p_column_identifier=>'AD'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(675987101392870246.4001)
,p_db_column_name=>'NAME'
,p_display_order=>41
,p_column_identifier=>'AH'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:1820:&SESSION.::&DEBUG.:1820:P1820_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656869556441815422.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>51
,p_column_identifier=>'AI'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(18355828877248864.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>61
,p_column_identifier=>'U'
,p_column_label=>unistr('Fecha de Modificaci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(18355931688248864.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>71
,p_column_identifier=>'V'
,p_column_label=>unistr('Autor de \00FAltima modificaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453761797911825.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>81
,p_column_identifier=>'AL'
,p_column_label=>'Creado el'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1453898249911826.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>91
,p_column_identifier=>'AM'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(500681507068475106.4001)
,p_plug_name=>unistr('Definici\00F3n de Carga de Datos')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una definici\00F3n de carga de datos consta de una definici\00F3n de carga de datos, un perfil de datos y de columnas de perfil de datos. Los datos se pueden cargar en una tabla existente del esquema o en una recopilaci\00F3n. Se pueden definir expresiones SQ')
||unistr('L, consultas SQL, consultas o reglas de transformaci\00F3n para cada columna de perfil de datos. Estas definiciones se usan en el tipo de proceso de la p\00E1gina Carga de natos nativos. </p>'),
'',
unistr('<p>Al crear una definici\00F3n de carga de datos, el asistente permite agregar, si lo desea, una p\00E1gina Carga de datos en la aplicaci\00F3n. Si ya existe una definici\00F3n de carga de datos, puede usar el asistente de creaci\00F3n de p\00E1ginas para agregar una p\00E1gina')
||unistr(' Carga de datos. Se crear\00E1 una \00FAnica p\00E1gina con el proceso de la p\00E1gina Carga de datos nativos para obtener la posibilidad de cargar datos desde un archivo o mediante la opci\00F3n de copiar y pegar y, a continuaci\00F3n, se cargar\00E1n los datos. Esta p\00E1gina p')
||unistr('ermite a los usuarios finales gestionar la carga de los datos. Adem\00E1s, se puede personalizar para que se ajuste a las necesidades de la aplicaci\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2312248175756780281.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/creating-applications-with-data-loading-capability.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(656871080203834340.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(15698603515328105.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:&APP_PAGE_ID.,RR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1619219349859208.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(15698603515328105.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.:1815::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_01801
begin
wwv_flow_api.create_page(
 p_id=>1801.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar carga de datos heredada'
,p_step_title=>'Editar carga de datos heredada'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46335131200026266.4001)
,p_plug_name=>'Alias de Nombre de Columna'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los usuarios finales pueden tener problemas con la correcta identificaci\00F3n de las columnas que se van a cargar en funci\00F3n de los nombres de las columnas de la tabla. Por lo tanto, puede definir alias para cada columna. El usuario final los visuali')
||unistr('zar\00E1 durante la carga de datos de la hoja de c\00E1lculo.</p>'),
unistr('<p>Si se crea una lista de valores, la aplicaci\00F3n selecciona autom\00E1ticamente los alias durante la asignaci\00F3n de columnas de datos; de lo contrario, la aplicaci\00F3n utilizar\00E1 los nombres de las columnas de la tabla. Una vez creada la lista de valores, \00E9')
||unistr('sta se podr\00E1 editar y tambi\00E9n se puede eliminar una columna de la lista.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(96308428780065452.4001)
,p_plug_name=>'Carga de datos heredada'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(96986111642098411.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(129367214868475906.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212980031120458358.4001)
,p_plug_name=>'Gestionar Simultaneidad'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta opci\00F3n ofrece al desarrollador la posibilidad de especificar una columna que se puede utilizar para comprobar la versi\00F3n de los datos de la tabla subyacente. Esto es especialmente importante si se realiza la carga en una tabla que se actualiz')
||'a regularmente.</p>',
unistr('<p>Para cualquier actualizaci\00F3n, la columna utilizada para comprobar la simultaneidad se consultar\00E1 y comparar\00E1 con el valor de la base de datos, para esa columna, antes de confirmar el registro. Si en el tiempo transcurrido entre la consulta del reg')
||unistr('istro y el procesamiento de la carga de datos cambia la columna de simultaneidad, se marcar\00E1 el registro y no se confirmar\00E1. Si no se ha especificado la columna de simultaneidad, la carga de datos actualizar\00E1 siempre todos los registros, pudiendo sob')
||'rescribir los cambios realizados por otros usuarios.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(493074815148585066.4001)
,p_name=>'Consultas de Tabla'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       flow_id, ',
'       load_table_id, ',
'       (select table_name from wwv_flow_load_tables where id = l.load_table_id) table_name, ',
'       load_column_name,',
'       LOOKUP_TABLE_NAME, ',
'       KEY_COLUMN, ',
'       DISPLAY_COLUMN, ',
'       ALTERNATIVE_KEY_COLUMN1, ',
'       ALTERNATIVE_DISPLAY_COLUMN1, ',
'       ALTERNATIVE_KEY_COLUMN2, ',
'       ALTERNATIVE_DISPLAY_COLUMN2, ',
'       INSERT_NEW_VALUE, ',
'       ERROR_MESSAGE,',
'       CREATED_ON, ',
'       CREATED_BY, ',
'       LAST_UPDATED_ON, ',
'       LAST_UPDATED_BY ',
'from WWV_FLOW_LOAD_TABLE_LOOKUPS l',
'where FLOW_ID = :fb_flow_id ',
'and security_group_id = :flow_security_group_id ',
'and LOAD_TABLE_ID = (select ID from WWV_FLOW_LOAD_TABLES where flow_id = :fb_flow_id and name = :P1801_NAME)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No hay definiciones de Tabla de Consulta.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075123218585071.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075217658585071.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Flow Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075310107585071.4001)
,p_query_column_id=>3
,p_column_alias=>'LOAD_TABLE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Load Table Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075431004585071.4001)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Table Name'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075523172585071.4001)
,p_query_column_id=>5
,p_column_alias=>'LOAD_COLUMN_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre de Columna'
,p_column_link=>'f?p=&APP_ID.:1802:&SESSION.::&DEBUG.:1802:P1802_ID:#ID#:'
,p_column_linktext=>'#LOAD_COLUMN_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075604560585071.4001)
,p_query_column_id=>6
,p_column_alias=>'LOOKUP_TABLE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Tabla de Consulta'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075732365585071.4001)
,p_query_column_id=>7
,p_column_alias=>'KEY_COLUMN'
,p_column_display_sequence=>7
,p_column_heading=>'Devolver Columna'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493075804800585071.4001)
,p_query_column_id=>8
,p_column_alias=>'DISPLAY_COLUMN'
,p_column_display_sequence=>8
,p_column_heading=>'Cargar Columna'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(662086205614215009.4001)
,p_query_column_id=>9
,p_column_alias=>'ALTERNATIVE_KEY_COLUMN1'
,p_column_display_sequence=>17
,p_column_heading=>'Alternative Key Column1'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(662086300832215009.4001)
,p_query_column_id=>10
,p_column_alias=>'ALTERNATIVE_DISPLAY_COLUMN1'
,p_column_display_sequence=>9
,p_column_heading=>'Cargar Columna 2'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(38883709640369558.4001)
,p_query_column_id=>11
,p_column_alias=>'ALTERNATIVE_KEY_COLUMN2'
,p_column_display_sequence=>18
,p_column_heading=>'Alternative Key Column2'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(38883829752369558.4001)
,p_query_column_id=>12
,p_column_alias=>'ALTERNATIVE_DISPLAY_COLUMN2'
,p_column_display_sequence=>10
,p_column_heading=>'Cargar Columna 3'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493076120606585073.4001)
,p_query_column_id=>13
,p_column_alias=>'INSERT_NEW_VALUE'
,p_column_display_sequence=>11
,p_column_heading=>'Insertar Nuevo Valor'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493076223605585073.4001)
,p_query_column_id=>14
,p_column_alias=>'ERROR_MESSAGE'
,p_column_display_sequence=>12
,p_column_heading=>'Error Message'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493076314985585073.4001)
,p_query_column_id=>15
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>13
,p_column_heading=>'Created On'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493076423974585073.4001)
,p_query_column_id=>16
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>14
,p_column_heading=>'Created By'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493076506398585073.4001)
,p_query_column_id=>17
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>15
,p_column_heading=>'Last Updated On'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493076607011585073.4001)
,p_query_column_id=>18
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>16
,p_column_heading=>'Last Updated By'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(493385303214695103.4001)
,p_name=>unistr('Reglas de Transformaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 c.ID ID, c.FLOW_ID FLOW_ID,',
'	 c.LOAD_TABLE_ID LOAD_TABLE_ID,',
'	 c.LOAD_COLUMN_NAME LOAD_COLUMN_NAME,',
'	 c.RULE_NAME RULE_NAME,',
'	 c.RULE_TYPE RULE_TYPE,',
'         c.RULE_SEQUENCE RULE_SEQUENCE,',
'	 c.RULE_EXPRESSION1 RULE_EXPRESSION1,',
'	 c.RULE_EXPRESSION2 RULE_EXPRESSION2,',
'         c.ERROR_MESSAGE ERROR_MESSAGE,',
'	 c.CREATED_BY CREATED_BY,',
'	 c.CREATED_ON CREATED_ON,',
'	 c.LAST_UPDATED_BY LAST_UPDATED_BY,',
'	 c.LAST_UPDATED_ON LAST_UPDATED_ON ',
' from	 WWV_FLOW_LOAD_TABLE_RULES c',
'where c.FLOW_ID = :fb_flow_id and security_group_id = :flow_security_group_id and c.load_table_id = (select ID from WWV_FLOW_LOAD_TABLES where flow_id = :fb_flow_id and name = :P1801_NAME)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No hay Reglas de Transformaci\00F3n definidas.')
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493385515152695105.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493385605250695105.4001)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Flow Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493385731027695105.4001)
,p_query_column_id=>3
,p_column_alias=>'LOAD_TABLE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Load Table Id'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493385906416695105.4001)
,p_query_column_id=>4
,p_column_alias=>'LOAD_COLUMN_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Nombre de Columna'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493435222261700674.4001)
,p_query_column_id=>5
,p_column_alias=>'RULE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre de Regla'
,p_column_link=>'f?p=&APP_ID.:1804:&SESSION.::&DEBUG.:1804:P1804_ID:#ID#:'
,p_column_linktext=>'#RULE_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493435303291700675.4001)
,p_query_column_id=>6
,p_column_alias=>'RULE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo de Regla'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(141003727830690827)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493435412279700675.4001)
,p_query_column_id=>7
,p_column_alias=>'RULE_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493435511268700675.4001)
,p_query_column_id=>8
,p_column_alias=>'RULE_EXPRESSION1'
,p_column_display_sequence=>13
,p_column_heading=>unistr('Expresi\00F3n 1')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493435622610700675.4001)
,p_query_column_id=>9
,p_column_alias=>'RULE_EXPRESSION2'
,p_column_display_sequence=>14
,p_column_heading=>unistr('Expresi\00F3n 2')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493386617850695106.4001)
,p_query_column_id=>10
,p_column_alias=>'ERROR_MESSAGE'
,p_column_display_sequence=>8
,p_column_heading=>'Error Message'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493386810369695106.4001)
,p_query_column_id=>11
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>10
,p_column_heading=>'Created By'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493386707074695106.4001)
,p_query_column_id=>12
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>9
,p_column_heading=>'Created On'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493387011522695106.4001)
,p_query_column_id=>13
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>12
,p_column_heading=>'Last Updated By'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(493386918910695106.4001)
,p_query_column_id=>14
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>11
,p_column_heading=>'Last Updated On'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(675812623094852885.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(675812107017852883.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(686207505452915171.4001)
,p_plug_name=>unistr('Definici\00F3n de Carga de Datos')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(937792233418878647.4001)
,p_plug_name=>unistr('Claves \00DAnicas')
,p_parent_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_region_css_classes=>'a-Form--floatColsLeft'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>12
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(937792496146878649.4001)
,p_plug_name=>'Propietario y Nombre de la Tabla'
,p_parent_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(498862119040967671.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(493385303214695103.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Crear Regla de Transformaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1804:&SESSION.::&DEBUG.:1804:P1804_LOAD_TABLE_ID:&P1801_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(498809524103959661.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(493074815148585066.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Crear Consulta de Tabla'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1802:&SESSION.::&DEBUG.:RP,1802:P1802_LOAD_TABLE_ID:&P1801_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217833922942091197.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(46335131200026266.4001)
,p_button_name=>'EDIT_COLUMN_NAMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Editar Lista de Valores'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:1805:F4000_P1805_LIST_ID:&P1801_LOV_NAME.'
,p_button_condition=>'P1801_LOV_NAME'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46336314970049909.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(46335131200026266.4001)
,p_button_name=>'CREATE_COLUMN_NAMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Crear Lista de Valores'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:1805:P1805_TABLE_ID:&P1801_ID.'
,p_button_condition=>'P1801_LOV_NAME'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(686208102280915173.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(96308428780065452.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(686207925691915173.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(96308428780065452.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1801_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(686207815836915173.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(96308428780065452.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1801_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(686207714765915173.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(96308428780065452.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1801_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(686208702198915174.4001)
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187824532164864910.4001)
,p_name=>'P1801_LOV_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(46335131200026266.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lista de Valores de Alias de Columna:'
,p_source=>'COLUMN_NAMES_LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select lov_name, id from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :FB_FLOW_ID'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Lista de valores para los alias de columnas de carga de datos. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(212981105990472890.4001)
,p_name=>'P1801_VERSION_COLUMN_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(212980031120458358.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Columna de Simultaneidad'
,p_source=>'VERSION_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No hay ninguna columna seleccionada-'
,p_lov_cascade_parent_items=>'P1801_TABLE_NAME'
,p_ajax_items_to_submit=>'P1801_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede seleccionar la columna que utilizar\00E1 la funci\00F3n de carga de datos como gesti\00F3n de simultaneidad')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(380392782865619476.4001)
,p_name=>'P1801_SKIP_VALIDATION'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Omitir Validaci\00F3n')
,p_source=>'SKIP_VALIDATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD SKIP VALIDATION'
,p_lov=>'.'||wwv_flow_api.id(380391855980609161.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Uno de los pasos de la carga de datos consiste en validar las acciones que se van a llevar a cabo en los registros que se van a cargar. La mayor parte del tiempo, es posible que el usuario final solo desee cargar sus registros directamente en la tabl'
||unistr('a sin realizar el paso de validaci\00F3n, sobre todo si va a cargar miles de registros.'),
unistr('Defina este valor en S\00ED si desea omitir la validaci\00F3n.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686208932694915176.4001)
,p_name=>'P1801_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686212913230915182.4001)
,p_name=>'P1801_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686213118811915183.4001)
,p_name=>'P1801_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686213328710915184.4001)
,p_name=>'P1801_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario'
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_upload.get_owner_name(',
'                        p_owner_name    => :P1801_OWNER,',
'                        p_flow_id       => :FB_FLOW_ID);'))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Propietario de la tabla en la que se basar\00E1 la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686213508347915185.4001)
,p_name=>'P1801_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Tabla'
,p_source=>'TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Tabla subyacente que se utilizar\00E1 para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686213725156915185.4001)
,p_name=>'P1801_UNIQUE_COLUMN_1'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Columna \00DAnica 1')
,p_source=>'UNIQUE_COLUMN_1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Seleccionar Columna-'
,p_lov_cascade_parent_items=>'P1801_TABLE_NAME'
,p_ajax_items_to_submit=>'P1801_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Nombre de la columna que se va a utilizar como columna de calve \00FAnica primaria durante el proceso de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686213919369915185.4001)
,p_name=>'P1801_IS_UK1_CASE_SENSITIVE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
,p_source=>'IS_UK1_CASE_SENSITIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>' a-Form--floatColsLeft'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique si la columna de clave \00FAnica 1 seleccionada es sensible a may\00FAsculas/min\00FAsculas. Por defecto, se define en <strong>No</strong>.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686214112898915185.4001)
,p_name=>'P1801_UNIQUE_COLUMN_2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Columna \00DAnica 2')
,p_source=>'UNIQUE_COLUMN_2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Seleccionar Columna-'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Si la definici\00F3n de clave \00FAnica de la tabla seleccionada es una clave compuesta, que consta de 2 o m\00E1s columnas, se utilizar\00E1 este nombre de columna como segunda columna de clave \00FAnica durante el proceso de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686214328418915185.4001)
,p_name=>'P1801_IS_UK2_CASE_SENSITIVE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
,p_source=>'IS_UK2_CASE_SENSITIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique si la columna de clave \00FAnica 2 seleccionada es sensible a may\00FAsculas/min\00FAsculas. Por defecto, se define en <strong>No</strong>.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686214509669915185.4001)
,p_name=>'P1801_UNIQUE_COLUMN_3'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Columna \00DAnica 3')
,p_source=>'UNIQUE_COLUMN_3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Seleccionar Columna-'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Si la definici\00F3n de clave \00FAnica de la tabla seleccionada es una calve compuesta, que consta de 2 o m\00E1s columnas, se utilizar\00E1 este nombre de columna como tercera columna de clave \00FAnica durante el proceso de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686214719744915185.4001)
,p_name=>'P1801_IS_UK3_CASE_SENSITIVE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(686207505452915171.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
,p_source=>'IS_UK3_CASE_SENSITIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique si la columna de clave \00FAnica 3 seleccionada es sensible a may\00FAsculas/min\00FAsculas. Por defecto, se define en <strong>No</strong>.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(686215100763915186.4001)
,p_name=>'P1801_COMMENTS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(96986111642098411.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(219503727051655078.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1801'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(386755397326132356.4001)
,p_name=>'skip validation TR option'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1801_SKIP_VALIDATION'
,p_condition_element=>'P1801_SKIP_VALIDATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(386755669179132358.4001)
,p_event_id=>wwv_flow_api.id(386755397326132356.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(493385303214695103.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(386755891151132360.4001)
,p_event_id=>wwv_flow_api.id(386755397326132356.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(493385303214695103.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(386756063741143719.4001)
,p_name=>'skip validation DL option'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1801_SKIP_VALIDATION'
,p_condition_element=>'P1801_SKIP_VALIDATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(386756383317143719.4001)
,p_event_id=>wwv_flow_api.id(386756063741143719.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(493074815148585066.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(386756594594143719.4001)
,p_event_id=>wwv_flow_api.id(386756063741143719.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(493074815148585066.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(386756680636151834.4001)
,p_name=>'skip validation Concurrency option'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1801_SKIP_VALIDATION'
,p_condition_element=>'P1801_SKIP_VALIDATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(386756929759151835.4001)
,p_event_id=>wwv_flow_api.id(386756680636151834.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(212980031120458358.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(386757198881151835.4001)
,p_event_id=>wwv_flow_api.id(386756680636151834.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(212980031120458358.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(686215415998915186.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOAD_TABLES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLES'
,p_attribute_03=>'P1801_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(686215619212915187.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOAD_TABLES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLES'
,p_attribute_03=>'P1801_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(686215813462915187.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1801'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(686207925691915173.4001)
);
end;
/
prompt --application/pages/page_01802
begin
wwv_flow_api.create_page(
 p_id=>1802.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Agregar/Editar Consultas de Tabla'
,p_step_title=>'Agregar/Editar Consultas de Tabla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(693382831264736379.4001)
,p_plug_name=>'Tabla de Carga de Datos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(693546805900748049.4001)
,p_plug_name=>'Consulta de Tabla'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(693572011787749755.4001)
,p_plug_name=>'Mensaje de Error'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(693673315035760103.4001)
,p_plug_name=>unistr('Cl\00E1usula WHERE')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694531718385903026.4001)
,p_plug_name=>'Consulta de Tabla'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694621618170912396.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(693383431777736379.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(694531718385903026.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(693383226454736379.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(694531718385903026.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1802_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(693383102459736379.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(694531718385903026.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1802_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(693383013235736379.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(694531718385903026.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1802_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(693384017518736381.4001)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(693383013235736379.4001)
,p_branch_sequence=>1
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(780702422748930727.4001)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(693383102459736379.4001)
,p_branch_sequence=>11
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693384228748736382.4001)
,p_name=>'P1802_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(693382831264736379.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693384417125736388.4001)
,p_name=>'P1802_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(693382831264736379.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>':fb_flow_id'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693384600650736389.4001)
,p_name=>'P1802_LOAD_TABLE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(693382831264736379.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Tabla de Carga de Datos'
,p_source=>'LOAD_TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME as display_value, ID as return_value ',
'  from WWV_FLOW_LOAD_TABLES',
'where flow_id = :fb_flow_id',
' order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Tabla subyacente para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693384808496736389.4001)
,p_name=>'P1802_LOAD_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(693382831264736379.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Columna'
,p_source=>'LOAD_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc a, column_name b',
'  from wwv_flow_table_columns_dev',
' where table_name = (',
'      select table_name ',
'        from wwv_flow_load_tables ',
'       where id                = :P1802_LOAD_TABLE_ID',
'         and security_group_id = :FLOW_SECURITY_GROUP_ID ) ',
'   and owner = ( ',
'      select wwv_flow_data_upload.get_owner_name( p_owner_name => owner, p_flow_id => :FB_FLOW_ID ) ',
'        from wwv_flow_load_tables ',
'       where id                = :P1802_LOAD_TABLE_ID',
'         and security_group_id = :FLOW_SECURITY_GROUP_ID ) ',
' order by column_id',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Seleccionar Columna-'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Columna de tabla en la que se basar\00E1 la definici\00F3n de consulta de tabla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693385009989736389.4001)
,p_name=>'P1802_LOOKUP_OWNER'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario'
,p_source=>'LOOKUP_OWNER'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_upload.get_owner_name(',
'                        p_owner_name    => :P1802_LOOKUP_OWNER,',
'                        p_flow_id       => :FB_FLOW_ID);'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Propietario -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Propietario de la tabla de consulta.',
'',
'Durante la carga de datos, se puede realizar una consulta para recuperar el valor de otra tabla. '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693385223779736390.4001)
,p_name=>'P1802_LOOKUP_TABLE_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Tabla'
,p_source=>'LOOKUP_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P1802_LOOKUP_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione la tabla de consulta.',
'',
'Durante la carga de datos, se puede realizar una consulta para recuperar el valor de otra tabla. ',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693385400997736390.4001)
,p_name=>'P1802_KEY_COLUMN'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Devolver Columna'
,p_source=>'KEY_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el nombre de la columna devuelta por la consulta de tabla. Este valor se insertar\00E1 en la columna de carga especificada y normalmente se trata del valor clave del principal en una relaci\00F3n de clave ajena. Por ejemplo: DEPTNO')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693385608923736390.4001)
,p_name=>'P1802_DISPLAY_COLUMN'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cargar Columna'
,p_source=>'DISPLAY_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el nombre de los usuarios finales de columna que se cargar\00E1n en lugar de la columna de retorno. Se trata de la columna que contiene el valor de visualizaci\00F3n de la tabla de consulta. '),
'Por ejemplo: DNAME'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693385811322736390.4001)
,p_name=>'P1802_ALTERNATIVE_KEY_COLUMN1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ALTERNATIVE_KEY_COLUMN1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693386031030736390.4001)
,p_name=>'P1802_ALT_DISPLAY_COL1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cargar Columna 2'
,p_source=>'ALTERNATIVE_DISPLAY_COLUMN1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el nombre de la segunda columna que se va a cargar para identificar de forma \00FAnica la columna de retorno, si es necesario. Por ejemplo, para identificar de forma \00FAnica C\00F3digo de Estado, puede que sea necesario cargar Nombre de Estado y Pa\00ED')
||'s.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693386200297736390.4001)
,p_name=>'P1802_ALTERNATIVE_KEY_COLUMN2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ALTERNATIVE_KEY_COLUMN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693386423451736390.4001)
,p_name=>'P1802_ALT_DISPLAY_COL2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cargar Columna 3'
,p_source=>'ALTERNATIVE_DISPLAY_COLUMN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el nombre de la tercera columna que se va a cargar para identificar de forma \00FAnica la columna de retorno, si es necesario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693386631295736390.4001)
,p_name=>'P1802_WHERE_CLAUSE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(693673315035760103.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_source=>'WHERE_CLAUSE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('La cl\00E1usula WHERE se utilizar\00E1 como parte del SQL utilizado para recuperar la columna de retorno de la tabla de consulta.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693386801659736391.4001)
,p_name=>'P1802_INSERT_NEW_VALUE'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(693546805900748049.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Insertar Nuevo Valor'
,p_source=>'INSERT_NEW_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_api.id(15543021487067885.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Si se define en ''No'' (el valor por defecto), no se crear\00E1 un nuevo registro en la tabla de consulta si los valores de la columna de consulta introducidos ya no existen. Si se define en ''S\00ED'', se crear\00E1 un registro en la tabla de consulta utilizando la')
||unistr('s columnas de carga y se recuperar\00E1 la columna de clave de carga del registro reci\00E9n creado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693387030446736391.4001)
,p_name=>'P1802_ERROR_MESSAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(693572011787749755.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mensaje de Error'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El mensaje de error se mostrar\00E1 a los usuarios finales cuando se produzca un error al intentar recuperar la columna de retorno de la tabla de consulta utilizando las columnas de consulta proporcionadas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(693387320562736391.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_03=>'P1802_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(419130103326690553.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'schema owner or not'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1802_LOOKUP_OWNER := wwv_flow_wizard_api.get_owner(',
'                             p_flow_id     => :FB_FLOW_ID,',
'                             p_owner       => :P1802_LOOKUP_OWNER );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(693387521154736392.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_03=>'P1802_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(693387716404736392.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1802'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(693383226454736379.4001)
);
end;
/
prompt --application/pages/page_01804
begin
wwv_flow_api.create_page(
 p_id=>1804.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Agregar/Editar Regla de Tabla'
,p_step_title=>'Agregar/Editar Regla de Tabla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68017006978066809.4001)
,p_plug_name=>'Mensaje de Error'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68109728449073006.4001)
,p_plug_name=>'Tabla de Carga de Datos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68143608148076596.4001)
,p_plug_name=>unistr('Regla de Transformaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68460701484093657.4001)
,p_plug_name=>unistr('Regla de Transformaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(68799700969131291.4001)
,p_plug_name=>'Region Display Selector'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68017604467066810.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(68460701484093657.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68017424045066810.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(68460701484093657.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1804_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68017318691066810.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(68460701484093657.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1804_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(68017210156066810.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(68460701484093657.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1804_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(68018229295066812.4001)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(68017210156066810.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(780763005218935144.4001)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(68017318691066810.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15288428943315710.4001)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(68017424045066810.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23843007488481588.4001)
,p_name=>'P1804_RULE_EXPRESSION3'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(68143608148076596.4001)
,p_prompt=>unistr('Condici\00F3n de Recorte')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TRIM_CONDITIONS'
,p_lov=>'.'||wwv_flow_api.id(23846801132546001.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seg\00FAn el tipo de regla de transformaci\00F3n espec\00EDfico seleccionado anteriormente, introduzca el valor adecuado.'),
unistr('Consulte los ejemplos que se proporcionan a continuaci\00F3n')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68018411168066814.4001)
,p_name=>'P1804_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(68109728449073006.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68018627136066821.4001)
,p_name=>'P1804_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(68109728449073006.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>':fb_flow_id'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68018831291066823.4001)
,p_name=>'P1804_LOAD_TABLE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(68109728449073006.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Tabla'
,p_source=>'LOAD_TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, ID return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where flow_id = :fb_flow_id',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Tabla subyacente para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68019017653066823.4001)
,p_name=>'P1804_LOAD_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(68109728449073006.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Columna'
,p_source=>'LOAD_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc a, column_name b from wwv_flow_table_columns_dev',
'where table_name = (select table_name from wwv_flow_load_tables where id = :P1804_LOAD_TABLE_ID) ',
'and owner = :P1804_OWNER',
'order by column_id'))
,p_lov_cascade_parent_items=>'P1804_LOAD_TABLE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Elija la columna de tabla a la que se aplicar\00E1 la regla de transformaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68019231622066823.4001)
,p_name=>'P1804_RULE_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(68143608148076596.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Regla'
,p_source=>'RULE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de esta regla de transformaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68019416006066823.4001)
,p_name=>'P1804_RULE_TYPE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(68143608148076596.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Regla'
,p_source=>'RULE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOADING RULES TYPES'
,p_lov=>'.'||wwv_flow_api.id(141003727830690827.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el tipo de regla de transformaci\00F3n que desea crear:')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68019625975066824.4001)
,p_name=>'P1804_RULE_SEQUENCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(68143608148076596.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   s number := 0;',
'begin',
'',
'   for c1 in (select max(RULE_SEQUENCE) s',
'              from   wwv_flow_load_table_rules',
'              where  flow_id = nv(''FB_FLOW_ID'') ',
'              and    load_table_id = v(''P1804_LOAD_TABLE_ID'') or v(''P1804_LOAD_TABLE_ID'') is null)loop',
'              s := c1.s;',
'   end loop;',
'      s := nvl(s,0);',
'   return trunc(s) + 10;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Secuencia de Regla'
,p_source=>'RULE_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique la secuencia para la regla de transformaci\00F3n. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68019822836066824.4001)
,p_name=>'P1804_RULE_EXPRESSION1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(68143608148076596.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'RULE_EXPRESSION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seg\00FAn el tipo de regla de transformaci\00F3n espec\00EDfico seleccionado anteriormente, introduzca el valor adecuado.'),
unistr('Consulte los ejemplos que se proporcionan a continuaci\00F3n')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68020003943066824.4001)
,p_name=>'P1804_RULE_EXPRESSION2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(68143608148076596.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'RULE_EXPRESSION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seg\00FAn el tipo de regla de transformaci\00F3n espec\00EDfico seleccionado anteriormente, introduzca el valor adecuado.'),
unistr('Consulte los ejemplos que se proporcionan a continuaci\00F3n')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(68020228499066824.4001)
,p_name=>'P1804_ERROR_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(68017006978066809.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mensaje de Error'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca el texto que debe aparecer en caso de que falle la regla de transformaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122019130902703516.4001)
,p_name=>'P1804_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(68109728449073006.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_owner   varchar2(255) := null;',
'begin',
'  select owner into l_owner from wwv_flow_load_tables where id = :P1804_LOAD_TABLE_ID;',
'  l_owner := wwv_flow_data_upload.get_owner_name(',
'                        p_owner_name    => l_owner,',
'                        p_flow_id       => :FB_FLOW_ID);',
'  return l_owner;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(582267193131682842.4001)
,p_validation_name=>'Validate PL/SQL Function Body'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'     :P1804_RULE_EXPRESSION1,',
'     :FB_FLOW_ID,',
'     :FLOW_SECURITY_GROUP_ID',
' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''SAVE'',''CREATE'') and :P1804_RULE_TYPE = ''PLSQL_FUNCTION_BODY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(68019822836066824.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(582267272162682843.4001)
,p_validation_name=>'Validate PL/SQL and SQL Expressions'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.validate_plsql_expressions(',
'    :P1804_RULE_EXPRESSION1,',
'    :P1804_RULE_TYPE',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''SAVE'',''CREATE'') and :P1804_RULE_TYPE  in (''PLSQL_EXPRESSION'', ''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(68019822836066824.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23849423736609348.4001)
,p_name=>'Rule Expression 1'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1804_RULE_TYPE'
,p_condition_element=>'P1804_RULE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REPLACE,PLSQL_EXPRESSION,REGULAR_EXPRESSION, SQL_QUERY_SINGLE_VALUE, SQL_QUERY_SEMI_COLON, PLSQL_FUNCTION_BODY, TRIM, LTRIM, RTRIM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23849720138609348.4001)
,p_event_id=>wwv_flow_api.id(23849423736609348.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23849903215609348.4001)
,p_event_id=>wwv_flow_api.id(23849423736609348.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23845419786522966.4001)
,p_name=>'Rule Expression 2'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1804_RULE_TYPE'
,p_condition_element=>'P1804_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23845709644522966.4001)
,p_event_id=>wwv_flow_api.id(23845419786522966.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION2'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23845909697522966.4001)
,p_event_id=>wwv_flow_api.id(23845419786522966.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION2'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23846207581538445.4001)
,p_name=>'Rule Expression (trim conditions)'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1804_RULE_TYPE'
,p_condition_element=>'P1804_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TRIM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23846509201538445.4001)
,p_event_id=>wwv_flow_api.id(23846207581538445.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION3'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23846709717538445.4001)
,p_event_id=>wwv_flow_api.id(23846207581538445.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION3'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(68020510214066825.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_03=>'P1804_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1832889557995266926.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Trim Rule for TRIM Transformations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1804_RULE_TYPE = ''TRIM'' then',
'   :P1804_RULE_EXPRESSION3 := :P1804_RULE_EXPRESSION2;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23851620712665155.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'if trim set expression 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1804_RULE_TYPE = ''TRIM'' then',
'   :P1804_RULE_EXPRESSION2 := :P1804_RULE_EXPRESSION3;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12643223518559838.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'plsql_expression_rules'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_expr_string   varchar2(4000) := null;',
'    l_owner         varchar2(255);',
'    l_table_name    varchar2(255);',
'    l_lov_id        number;',
'    l_position      number;',
'    type l_arr_int_cols is table of varchar2(255) index by binary_integer;',
'    type l_arr_position is table of number index by binary_integer;',
'    l_arr_pos      l_arr_position;',
'    l_int_cols     l_arr_int_cols;',
'    i              pls_integer := 0;',
'begin',
' if :P1804_RULE_TYPE in (''PLSQL_EXPRESSION'', ''PLSQL_FUNCTION_BODY'', ''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'', ''REGULAR_EXPRESSION'') then',
'    select owner, table_name, COLUMN_NAMES_LOV_ID into l_owner, l_table_name, l_lov_id',
'     from wwv_flow_load_tables',
'    where id = :P1804_LOAD_TABLE_ID;',
'    if ( instr(l_owner,''#'') = 1 and instr(l_owner,''#'',2) = 7 ) then',
'        select owner into l_owner from wwv_flows where id = :FB_FLOW_ID;',
'    end if;',
'    if l_lov_id is not null then',
'        for c1 in (select lov_return_value  ',
'                    from wwv_flow_list_of_values_data ',
'                   where lov_id = l_lov_id )',
'        loop',
'            l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.lov_return_value, 1);',
'            while l_position > 0',
'            loop',
'                if l_int_cols.exists(l_position) = false then',
'                    i := i + 1;',
'                    l_arr_pos(i) := l_position;',
'                    l_int_cols(l_position) := c1.lov_return_value;',
'                else',
'                    if instr(c1.lov_return_value, l_int_cols(l_position), 1) > 0 then',
'                        l_int_cols(l_position) := c1.lov_return_value;',
'                    end if;',
'                end if;',
'                l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.lov_return_value, l_position + 1);',
'            end loop;',
'        end loop;    ',
'    else',
'        for c1 in (select column_name',
'                   from wwv_flow_table_columns_dev',
'                    where table_name = l_table_name',
'                     and owner = l_owner)',
'        loop',
'            l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.column_name, 1);',
'            while l_position > 0',
'            loop',
'                if l_int_cols.exists(l_position) = false then',
'                    i := i + 1;',
'                    l_arr_pos(i) := l_position;',
'                    l_int_cols(l_position) := c1.column_name;',
'                else',
'                    if instr(c1.column_name, l_int_cols(l_position), 1) > 0 then',
'                        l_int_cols(l_position) := c1.column_name;',
'                    end if;',
'                end if;',
'                l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.column_name, l_position + 1);',
'            end loop;',
'        end loop;',
'    end if;',
'    for i in 1..l_arr_pos.count',
'    loop',
'        l_expr_string := l_expr_string||'':''||l_int_cols(l_arr_pos(i));',
'    end loop; ',
'    :P1804_RULE_EXPRESSION2 := l_expr_string;',
' elsif :P1804_RULE_TYPE = ''TRIM'' then',
'   :P1804_RULE_EXPRESSION2 := :P1804_RULE_EXPRESSION3;',
' end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(68020719781066825.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_03=>'P1804_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(68020926766066825.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1804'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(68017424045066810.4001)
);
end;
/
prompt --application/pages/page_01805
begin
wwv_flow_api.create_page(
 p_id=>1805.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Agregar/Editar Alias de Nombres de Columna'
,p_step_title=>'Agregar/Editar Alias de Nombres de Columna'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46338707145132827.4001)
,p_plug_name=>'Alias de Nombres de Columna'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_owner       varchar(255);',
'   l_table_name  varchar(255);',
'   i pls_integer := 0;',
'begin',
'   select owner , table_name into l_owner, l_table_name  ',
'       from wwv_flow_load_tables ',
'       where id = :P1805_TABLE_ID;',
'   if instr(l_owner, ''#'', 2) > 0 then',
'       if instr(l_owner, ''OWNER'') > 0 then',
'           for c1 in (select owner',
'                     from wwv_flows',
'                     where id = :FB_FLOW_ID',
'                     and security_group_id = wwv_flow_security.g_security_group_id)',
'           loop',
'              l_owner := c1.owner;',
'           end loop;',
'       end if;',
'   end if;',
'   sys.htp.p(''<table class="u-Report" cellspacing="0" cellpadding="0" aria-label="''||wwv_flow_lang.system_message(''DATA_LOAD.COLUMN_NAME_ALIASES'')||''">'');',
'   sys.htp.p(''<tr>'');',
'   sys.htp.p(''<th scope="col">''||wwv_flow_lang.system_message(''DATA_LOAD.RETURN'')||''</th>'');',
'   sys.htp.p(''<th scope="col">''||wwv_flow_lang.system_message(''DATA_LOAD.DISPLAY'')||''</th>'');',
'   sys.htp.p(''<th scope="col">''||wwv_flow_lang.system_message(''DATA_LOAD.SEQUENCE'')||''</th>'');',
'   sys.htp.p(''</tr>'');',
'   ',
'   for c1 in ((select column_name d, column_name r ',
'              from wwv_flow_table_columns_dev',
'              where owner = l_owner and table_name = l_table_name)',
'              --union',
'              --(select ''* ''||lookup_table_name||'' - ''||display_column d, load_column_name r ',
'              --from apex_appl_load_table_lookups where load_table_id = :P1805_TABLE_ID )',
'              union',
'              (select ''* ''||lookup_table_name||'' - ''||alternative_display_column1 d, ''* *''||alternative_display_column1 r ',
'               from apex_appl_load_table_lookups where load_table_id = :P1805_TABLE_ID and alternative_display_column1 is not null)',
'              union',
'              (select ''* ''||lookup_table_name||'' - ''||alternative_display_column2 d, ''* *''||alternative_display_column2 r ',
'               from apex_appl_load_table_lookups where load_table_id = :P1805_TABLE_ID and alternative_display_column2 is not null))',
'    loop',
'      i := i + 1;',
'      sys.htp.p(''<tr><th scope="row" align="left">'');',
'      sys.htp.p(',
'         wwv_flow_ITEM.DISPLAY_AND_SAVE(',
'               p_idx         => 1,',
'               p_value       => c1.r)',
'         );',
'     sys.htp.p(''</th><td colspan="1" rowspan="1" align="left">'');',
'     sys.htp.p(',
'        wwv_flow_ITEM.TEXT(',
'             p_idx         => 2,',
'             p_value       => c1.d,',
'             p_size        => 40,',
'             p_maxlength   => 50,',
'             p_attributes  => ''aria-label="''||wwv_flow_lang.system_message(''DATA_LOAD.DISPLAY'')||'': ''||wwv_flow_escape.html(c1.r)||''"'')',
'          );',
'     sys.htp.p(''</td><td colspan="1" rowspan="1" align="right">'');',
'     sys.htp.p(',
'         wwv_flow_ITEM.TEXT(',
'               p_idx         => 3,',
'               p_value       => (i*10),',
'               p_size        => 8,',
'               p_maxlength   => 10,',
'             p_attributes  => ''aria-label="''||wwv_flow_lang.system_message(''DATA_LOAD.SEQUENCE'')||'': ''||wwv_flow_escape.html(c1.r)||''"'')',
'         );',
'     sys.htp.p(''</td></tr>'');',
'   end loop;',
'   sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'F4000_P1805_LIST_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217639726548776936.4001)
,p_plug_name=>'Alias de Nombre de Columna'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(320717723983124046.4001)
,p_name=>'Alias de Nombres de Columna'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"ID" ID_DISPLAY,',
'"LOV_ID",',
'"FLOW_ID",',
'"LOV_DISP_SEQUENCE",',
'"LOV_DISP_VALUE",',
'"LOV_RETURN_VALUE"',
'from "#OWNER#"."WWV_FLOW_LIST_OF_VALUES_DATA"',
'where LOV_ID = :F4000_P1805_LIST_ID'))
,p_display_when_condition=>'F4000_P1805_LIST_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn alias de nombre de columna.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320720730361124052.4001)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Seleccionar Fila'
,p_column_alignment=>'CENTER'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718021735124049.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718121772124049.4001)
,p_query_column_id=>3
,p_column_alias=>'ID_DISPLAY'
,p_column_display_sequence=>3
,p_column_heading=>'Id'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'ID_DISPLAY'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718230571124049.4001)
,p_query_column_id=>4
,p_column_alias=>'LOV_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Lov Id'
,p_hidden_column=>'Y'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718307946124049.4001)
,p_query_column_id=>5
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Flow Id'
,p_hidden_column=>'Y'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'FLOW_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718422984124049.4001)
,p_query_column_id=>6
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>7
,p_column_heading=>'Secuencia'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_DISP_SEQUENCE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718515827124049.4001)
,p_query_column_id=>7
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Valor de Visualizaci\00F3n')
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_DISP_VALUE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(320718620503124049.4001)
,p_query_column_id=>8
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>6
,p_column_heading=>'Valor de Retorno'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_RETURN_VALUE'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320721604429131930.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320721730230131930.4001)
,p_column_sequence=>2
,p_query_column_name=>'ID_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320721826718131930.4001)
,p_column_sequence=>3
,p_query_column_name=>'LOV_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320721904503131930.4001)
,p_column_sequence=>4
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320722032434131930.4001)
,p_column_sequence=>5
,p_query_column_name=>'LOV_DISP_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320722116503131930.4001)
,p_column_sequence=>6
,p_query_column_name=>'LOV_DISP_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(320722224482131930.4001)
,p_column_sequence=>7
,p_query_column_name=>'LOV_RETURN_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(362060515624359711.4001)
,p_plug_name=>unistr('Varias Columnas de Hoja de C\00E1lculo')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para cargar varias columnas de hoja de c\00E1lculo en una columna de tabla.</p>'),
unistr('<p>Seleccione la columna de tabla y especifique el n\00FAmero de columnas que le gustar\00EDa cargar en esta columna.</p>'),
unistr('<p>Por ejemplo, si desea cargar las columnas FirstName y LastName de la hoja de c\00E1lculo en la columna ENAME de la tabla emp</p>'),
unistr('<p>Seleccione ENAME e introduzca el n\00FAmero 2 como "N\00FAmero de Columnas". Se agregar\00E1n dos alias de columna a la lista anterior con el prefijo APXMC_ </p>'),
unistr('<p>A continuaci\00F3n, podr\00E1 cambiar el nombre y asignar cualquier nombre con el que desee que se muestre el usuario final</p>')))
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P1805_LIST_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3702506016906.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(362060515624359711.4001)
,p_button_name=>'NEW_MULTIPLE_COLUMN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Nuevas Columnas M\00FAltiples')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217640107285780858.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(217639726548776936.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(320718717374124051.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(217639726548776936.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(320718919930124051.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(217639726548776936.4001)
,p_button_name=>'MULTI_ROW_DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''MULTI_ROW_DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217640811357800937.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(217639726548776936.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(320718805036124051.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(217639726548776936.4001)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202544309116870023.4001)
,p_branch_action=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(320718919930124051.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'F4000_P1805_LIST_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(937788020192878605.4001)
,p_branch_name=>'Go To Page 1805'
,p_branch_action=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3702506016906.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(320720824944124052.4001)
,p_branch_name=>'Go To Page 1801'
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46502724403801670.4001)
,p_name=>'P1805_TABLE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(46338707145132827.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274511517617900256.4001)
,p_name=>'P1805_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(46338707145132827.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(274511707912904810.4001)
,p_name=>'P1805_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(46338707145132827.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(320850819932155106.4001)
,p_name=>'F4000_P1805_LIST_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(217639726548776936.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362061303507543654.4001)
,p_name=>'P1805_TABLE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(362060515624359711.4001)
,p_prompt=>'Seleccionar Columna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"LOV_RETURN_VALUE" d,',
'"LOV_RETURN_VALUE" r',
'from "#OWNER#"."WWV_FLOW_LIST_OF_VALUES_DATA"',
'where LOV_ID = :F4000_P1805_LIST_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362061618578567033.4001)
,p_name=>'P1805_COLUMN_ALIAS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(362060515624359711.4001)
,p_prompt=>unistr('N\00FAmero de Columnas')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(320719811830124051.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(320717723983124046.4001)
,p_validation_name=>'LOV_DISP_SEQUENCE not null'
,p_validation_sequence=>50
,p_validation=>'LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# debe tener un valor.'
,p_when_button_pressed=>wwv_flow_api.id(320718805036124051.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'LOV_DISP_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(320720001066124051.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(320717723983124046.4001)
,p_validation_name=>'LOV_DISP_SEQUENCE must be numeric'
,p_validation_sequence=>50
,p_validation=>'LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('#COLUMN_HEADER# debe ser num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(320718805036124051.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'LOV_DISP_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(320720223287124052.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(320717723983124046.4001)
,p_validation_name=>'LOV_DISP_VALUE not null'
,p_validation_sequence=>60
,p_validation=>'LOV_DISP_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# debe tener un valor.'
,p_when_button_pressed=>wwv_flow_api.id(320718805036124051.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'LOV_DISP_VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(864569033590731010.4001)
,p_validation_name=>'Must Specify Column for Multiple Spreadsheet Column Use'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P1805_TABLE_COLUMN is null and :P1805_COLUMN_ALIAS is not null) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar una columna que desee utilizar para la carga de varias hojas de c\00E1lculo.')
,p_when_button_pressed=>wwv_flow_api.id(3702506016906.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(864569290078731012.4001)
,p_validation_name=>'Must Specify Number for Multiple Spreadsheet Column Use'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P1805_TABLE_COLUMN is not null and :P1805_COLUMN_ALIAS is null) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe especificar el n\00FAmero de columnas que desee utilizar para la carga de varias hojas de c\00E1lculo.')
,p_when_button_pressed=>wwv_flow_api.id(3702506016906.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(864569100183731011.4001)
,p_validation_name=>'Must Specify Info  Multiple Spreadsheet Column Use'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P1805_TABLE_COLUMN is null and :P1805_COLUMN_ALIAS is null) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Debe seleccionar una columna y especificar el n\00FAmero de columnas que desea cargar en esa columna elegida.')
,p_when_button_pressed=>wwv_flow_api.id(3702506016906.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(202524620065775431.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create lov of column names'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_lov_id    number := null;',
'  l_lov_name  varchar2(255); ',
'begin',
'  l_lov_name := upper(''LOV_DATALOAD_'');',
'  for c1 in (select name, column_names_lov_id ',
'            from wwv_flow_load_tables',
'            where id = :P1805_TABLE_ID)',
'  loop',
'      l_lov_id := c1.column_names_lov_id;',
'      l_lov_name := l_lov_name ||upper(c1.name);',
'  end loop;',
'',
'  if l_lov_id is not null then',
'      delete from wwv_flow_list_of_values_data',
'      where lov_id = l_lov_id;',
'  else',
'    l_lov_id := wwv_flow_id.next_val;',
'       wwv_flow_api.create_list_of_values (',
'           p_id       => l_lov_id,',
'           p_flow_id  => :FB_FLOW_ID,',
'           p_lov_name => l_lov_name,',
'           p_lov_query=> ''.''||to_char(l_lov_id)||''.'');',
'    update wwv_flow_load_tables set column_names_lov_id = l_lov_id where id = :P1805_TABLE_ID;',
'   end if;',
'  for i in 1..apex_application.g_f01.count',
'  loop',
'     wwv_flow_api.create_static_lov_data (',
'               p_lov_id            => l_lov_id,',
'               p_lov_disp_sequence => apex_application.g_f03(i),',
'               p_lov_disp_value    => apex_application.g_f02(i),',
'               p_lov_return_value  => apex_application.g_f01(i));',
'  end loop;',
'  :F4000_P1805_LIST_ID := l_lov_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(217640811357800937.4001)
,p_process_success_message=>'La lista de valores de nombres de columna se ha creado correctamente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(320720317631124052.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(320717723983124046.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(320718805036124051.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(320720525397124052.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(320717723983124046.4001)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'ApplyMRD'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'MULTI_ROW_DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'#MRD_COUNT# fila(s) suprimida(s).'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(348064900625832396.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete lov if no data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lov_is_empty boolean := true;',
'begin',
'    for c2 in (',
'        select lov_id ',
'          from wwv_flow_list_of_values_data',
'         where flow_id = :FB_FLOW_ID',
'           and lov_id  = :F4000_P1805_LIST_ID',
'           and rownum  = 1 )',
'    loop',
'        l_lov_is_empty := false;',
'    end loop;',
'    ',
'    if l_lov_is_empty then',
'        delete from wwv_flow_lists_of_values$ where id = :F4000_P1805_LIST_ID;',
'        :F4000_P1805_LIST_ID := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(320718919930124051.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3702520197661.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create New Multiple Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_id   number;',
'   l_seq  number;',
'   l_cols number;',
'begin',
'   l_cols := to_number(:P1805_COLUMN_ALIAS);',
'   ',
'   select max(lov_disp_sequence) into l_seq',
'          from wwv_flow_list_of_values_data',
'          where lov_id = :F4000_P1805_LIST_ID',
'          and flow_id = :FB_FLOW_ID;',
'   for i in 1..l_cols',
'   loop',
'       l_id   := wwv_flow_id.next_val;',
'       l_seq  := l_seq + 10;',
'       insert into wwv_flow_list_of_values_data (id, lov_id, lov_disp_value, lov_return_value, LOV_DISP_SEQUENCE ) ',
'          values (l_id, :F4000_P1805_LIST_ID, ''APXMC_''||i||:P1805_TABLE_COLUMN, ''APXMC_''||i||:P1805_TABLE_COLUMN, l_seq);',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3702506016906.4001)
);
end;
/
prompt --application/pages/page_01808
begin
wwv_flow_api.create_page(
 p_id=>1808.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Definici\00F3n de Carga de Datos')
,p_step_title=>unistr('Historial de Definici\00F3n de Carga de Datos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15156216771460781.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(15132926917246073.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(437956428495190433.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DEFINITION'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LOAD_TABLES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DATA_PROFILE'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_DATA_PROFILES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DATA_PROFILE_COLS'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_DATA_PROFILE_COLS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(437956620220190440.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437956720911190443.4001)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437956816339190444.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437956920060190444.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437957020870190444.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437957104464190444.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437957206794190445.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437957307466190445.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(437957423887190445.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(438175120146235308.4001)
,p_plug_name=>unistr('Historial de Definici\00F3n de Carga de Datos')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestran las modificaciones recientes realizadas en las definiciones de carga de datos de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01810
begin
wwv_flow_api.create_page(
 p_id=>1810.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos'
,p_alias=>'CREATE-DATA-LOAD'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1620277601859218.4001)
,p_plug_name=>'Copiar y Pegar'
,p_region_name=>'data'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2566068517581311.4001)
,p_plug_name=>'Datos pegados'
,p_parent_plug_id=>wwv_flow_api.id(1620277601859218.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1810_DATA'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2566115723581312.4001)
,p_plug_name=>'Copiar y Pegar Datos'
,p_parent_plug_id=>wwv_flow_api.id(1620277601859218.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1810_DATA'
,p_plug_header=>'Permite crear definiciones de carga de datos a partir de datos de un archivo CSV de ejemplo'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1907748512746109.4001)
,p_plug_name=>'Origen'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2565134205581302.4001)
,p_plug_name=>'Archivo'
,p_region_name=>'file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1620150868859217.4001)
,p_plug_name=>'Cargar Archivo'
,p_parent_plug_id=>wwv_flow_api.id(2565134205581302.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1810_FILE'
,p_plug_header=>'Permite crear definiciones de carga de datos a partir de un archivo de ejemplo'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2565280041581303.4001)
,p_plug_name=>'Archivo cargado'
,p_parent_plug_id=>wwv_flow_api.id(2565134205581302.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1810_FILE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3852284745950931045.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(4115808439009126.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3852284764378931046.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1611375322809372.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3852284764378931046.4001)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2305524855304240.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3852284764378931046.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1811:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1619609476859212.4001)
,p_branch_name=>'Go To Page 1812'
,p_branch_action=>'f?p=&APP_ID.:1812:&SESSION.::&DEBUG.::P1812_FIRST_LINE:HEADERS&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1611375322809372.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1619577536859211.4001)
,p_name=>'P1810_FILE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1620150868859217.4001)
,p_prompt=>'Archivo de Ejemplo'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_13=>unistr('Arrastre y suelte el archivo de ejemplo aqu\00ED')
,p_attribute_14=>'Los formatos soportados son CSV, XLSX, TXT, XML, JSON'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1619947374859215.4001)
,p_name=>'P1810_DATA'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2566115723581312.4001)
,p_prompt=>'Datos de CSV de ejemplo'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>120
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(4923925522744860.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Copiar y pegar datos delimitados.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1622652636859242.4001)
,p_name=>'P1810_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1907748512746109.4001)
,p_item_default=>'FILE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SAMPLE_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1805213661837379.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Se crear\00E1 una nueva definici\00F3n de carga de datos en funci\00F3n de parte de los datos de ejemplo cargados. Decida si los datos de ejemplo se cargar\00E1n como archivo o si se utilizar\00E1 copiar y pegar con los datos de texto delimitados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104588196499743.4001)
,p_name=>'P1810_MIME_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2565280041581303.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104697976499744.4001)
,p_name=>'P1810_DATA_PASTED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2566068517581311.4001)
,p_item_default=>'wwv_flow_lang.system_message(''DATA.LOAD.PASTED_DATA'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Datos de ejemplo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2565324303581304.4001)
,p_name=>'P1810_FILE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2565280041581303.4001)
,p_prompt=>'Archivo de Ejemplo'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1908357768746115.4001)
,p_validation_name=>'file required'
,p_validation_sequence=>10
,p_validation=>'P1810_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1810_SOURCE_TYPE'
,p_validation_condition2=>'FILE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1611375322809372.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1908498133746116.4001)
,p_validation_name=>'data required'
,p_validation_sequence=>20
,p_validation=>'P1810_DATA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1810_SOURCE_TYPE'
,p_validation_condition2=>'COPY_PASTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1611375322809372.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(607607176710279801.4001)
,p_validation_name=>'invalid file'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_csv ) or',
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_xlsx ) or',
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_xml ) or',
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_json )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El archivo cargado no es v\00E1lido o tiene una extensi\00F3n incorrecta.')
,p_validation_condition=>':P1810_SOURCE_TYPE = ''FILE'' and :P1810_FILE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1907814178746110.4001)
,p_name=>'toggle file or copy paste'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1810_SOURCE_TYPE'
,p_condition_element=>'P1810_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1907992057746111.4001)
,p_event_id=>wwv_flow_api.id(1907814178746110.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2565134205581302.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1908061139746112.4001)
,p_event_id=>wwv_flow_api.id(1907814178746110.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2565134205581302.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1908289840746114.4001)
,p_event_id=>wwv_flow_api.id(1907814178746110.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620277601859218.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1908181265746113.4001)
,p_event_id=>wwv_flow_api.id(1907814178746110.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1620277601859218.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2401278819372912.4001)
,p_name=>'clear file and data'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1810_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2401953067372919.4001)
,p_event_id=>wwv_flow_api.id(2401278819372912.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1810_FILE := null;',
':P1810_FILE_NAME := null;',
':P1810_DATA := null;',
'',
'-- clear column mapping page items',
'htmldb_util.clear_page_cache( p_page_id => 1812 );',
'',
'-- clear columns collection',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD'' );',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );'))
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2402146791372921.4001)
,p_event_id=>wwv_flow_api.id(2401278819372912.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1909245256746124.4001)
,p_name=>'toggle table or collection'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1810_TARGET_TYPE'
,p_condition_element=>'P1810_TARGET_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909342107746125.4001)
,p_event_id=>wwv_flow_api.id(1909245256746124.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_TABLE_OWNER,P1810_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909480643746126.4001)
,p_event_id=>wwv_flow_api.id(1909245256746124.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_TABLE_OWNER,P1810_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909515253746127.4001)
,p_event_id=>wwv_flow_api.id(1909245256746124.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_COLLECTION_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909689678746128.4001)
,p_event_id=>wwv_flow_api.id(1909245256746124.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_COLLECTION_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3755598750775414.4001)
,p_name=>'submit page NEXT and show progress if file'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1611375322809372.4001)
,p_condition_element=>'P1810_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3755622138775415.4001)
,p_event_id=>wwv_flow_api.id(3755598750775414.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1003711736967784942.4001)
,p_name=>'submit page NEXT if copy paste'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1611375322809372.4001)
,p_condition_element=>'P1810_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COPY_PASTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1003711897796784943.4001)
,p_event_id=>wwv_flow_api.id(1003711736967784942.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.widget.textareaClob.uploadNonEmpty(''P1810_DATA'', ''NEXT'');'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2565509421581306.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get filename'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- get the file name',
'select filename, mime_type',
'into :P1810_FILE_NAME, :P1810_MIME_TYPE',
'from apex_application_temp_files ',
'where name = :P1810_FILE;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1611375322809372.4001)
,p_process_when=>'P1810_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'FILE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2400456962372904.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save copy and paste data to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id number;',
'    l_clob   clob;',
'begin',
'    select seq_id, ',
'           clob001',
'      into l_seq_id, ',
'           l_clob',
'      from wwv_flow_collections',
'     where collection_name = ''CLOB_CONTENT'';',
'    ',
'    wwv_flow_collection.update_member(',
'        p_collection_name => ''CLOB_CONTENT'',',
'        p_seq             => l_seq_id,',
'        p_clob001         => l_clob,',
'        p_blob001         => wwv_flow_utilities.clob_to_blob( p_clob => l_clob ) );',
'end; '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1611375322809372.4001)
,p_process_when=>'P1810_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'COPY_PASTE'
);
end;
/
prompt --application/pages/page_01811
begin
wwv_flow_api.create_page(
 p_id=>1811.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos'
,p_alias=>'CREATE-DATA-LOAD1'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3853921091276281832.4001)
,p_plug_name=>'tipo de objetivo'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3853921583171281837.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(4115808439009126.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3853921601599281838.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1640946071350811.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3853921601599281838.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2102195965346919.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3853921601599281838.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1909732795746129.4001)
,p_branch_name=>'Go To Page 1810'
,p_branch_action=>'f?p=&APP_ID.:1810:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1637416551350807.4001)
,p_name=>'P1811_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3853921091276281832.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1637748609350808.4001)
,p_name=>'P1811_TARGET_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3853921091276281832.4001)
,p_item_default=>'TABLE'
,p_prompt=>'tipo de objetivo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.TARGET_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1633774479940540.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si los datos se cargar\00E1n en una tabla o en una recopilaci\00F3n de &PRODUCT_NAME.. Las recopilaciones se suelen utilizar si los datos cargados se deben procesar antes de almacenarse en las tablas de destino.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1638143746350808.4001)
,p_name=>'P1811_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3853921091276281832.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el propietario de la tabla en la que se van a cargar los datos. Si no se selecciona nada, se utilizar\00E1 el esquema de an\00E1lisis de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1639027070350809.4001)
,p_name=>'P1811_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3853921091276281832.4001)
,p_prompt=>'Nombre de la Tabla'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P1811_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla -'
,p_lov_cascade_parent_items=>'P1811_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la tabla en la que se cargar\00E1n los datos. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1639981814350809.4001)
,p_name=>'P1811_COLLECTION_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3853921091276281832.4001)
,p_prompt=>unistr('Nombre de la Recopilaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la recopilaci\00F3n en la que se cargar\00E1n los datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1910326174746135.4001)
,p_validation_name=>'owner required'
,p_validation_sequence=>10
,p_validation=>'P1811_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABLE#.'
,p_validation_condition=>'P1811_TARGET_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1910479432746136.4001)
,p_validation_name=>'table required'
,p_validation_sequence=>20
,p_validation=>'P1811_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1811_TARGET_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1910532104746137.4001)
,p_validation_name=>'collection name required'
,p_validation_sequence=>30
,p_validation=>'P1811_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1811_TARGET_TYPE'
,p_validation_condition2=>'COLLECTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1803812151557118.4001)
,p_validation_name=>'name exists'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_load_tables',
'where name = :P1811_NAME',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otra definici\00F3n de carga de datos ya est\00E1 utilizando el nombre.')
,p_associated_item=>wwv_flow_api.id(1637416551350807.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(607707446113483812.4001)
,p_validation_name=>'Chosen Table Exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P1811_TABLE_NAME',
'   and owner       = :P1811_TABLE_OWNER'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P1811_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P1811_TARGET_TYPE = ''TABLE'' and :P1811_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1639027070350809.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1909052388746122.4001)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1811_FIRST_LINE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909148382746123.4001)
,p_event_id=>wwv_flow_api.id(1909052388746122.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1909883187746130.4001)
,p_name=>'toggle table or collection'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1811_TARGET_TYPE'
,p_condition_element=>'P1811_TARGET_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1909912135746131.4001)
,p_event_id=>wwv_flow_api.id(1909883187746130.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_TABLE_OWNER,P1811_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1910047169746132.4001)
,p_event_id=>wwv_flow_api.id(1909883187746130.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_TABLE_OWNER,P1811_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1910181420746133.4001)
,p_event_id=>wwv_flow_api.id(1909883187746130.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_COLLECTION_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1910264969746134.4001)
,p_event_id=>wwv_flow_api.id(1909883187746130.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_COLLECTION_NAME'
);
end;
/
prompt --application/pages/page_01812
begin
wwv_flow_api.create_page(
 p_id=>1812.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos'
,p_alias=>'CREATE-DATA-LOAD2'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3304651691587419.4001)
,p_plug_name=>unistr('Asignaci\00F3n de Columna')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'  l_columns as (',
'    select ',
'        fc.column_position,    ',
'        case when :P1812_FIRST_LINE = ''HEADERS'' then',
'            fc.column_name',
'        else ',
'            ''COL'' || lpad( rownum,3,''0'')',
'        end as column_name,',
'        case when :P1812_FIRST_LINE = ''HEADERS'' and :P1811_TARGET_TYPE = ''TABLE'' then',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P1811_TABLE_OWNER',
'              and tc.table_name = :P1811_TABLE_NAME',
'              and tc.column_name = fc.column_name )',
'        end as map_tab_col_name,',
'        case when :P1812_FIRST_LINE = ''HEADERS'' and :P1811_TARGET_TYPE = ''COLLECTION'' then',
'            case when fc.column_position <= 50 then',
'                ''C''||lpad( to_char(fc.column_position), 3, ''0'')',
'            end',
'        end as map_collection_col_name,',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char,',
'        ''N'' is_pk',
'    from apex_application_temp_files f,',
'         table( wwv_flow_data_parser.get_columns(',
'                      wwv_flow_data_parser.discover(',
'                          p_content   => f.blob_content,',
'                          p_file_name => f.filename,',
'                          p_xlsx_sheet_name   => ( case when :P1812_FILE_TYPE = 1 and :P1812_XLSX_SHEET is not null then :P1812_XLSX_SHEET end ),',
'                          p_csv_col_delimiter => replace(:P1812_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                          p_file_charset      => coalesce( :P1812_FILE_CHARSET, ''AL32UTF8'' ),',
'                          p_max_rows          => 200,',
'                          p_skip_rows         => :P1812_SKIP_ROWS,',
'                          p_csv_enclosed      => nullif( :P1812_CSV_ENCLOSED, ''None'' ) ) ) ) fc',
'    where f.name = :P1810_FILE',
'    and :P1810_SOURCE_TYPE = ''FILE''',
'  union all',
'  select ',
'        fc.column_position,    ',
'        case when :P1812_FIRST_LINE = ''HEADERS'' then',
'            fc.column_name',
'        else ',
'            ''COL'' || lpad( rownum,3,''0'')',
'        end as column_name,',
'        case when :P1812_FIRST_LINE = ''HEADERS'' and :P1811_TARGET_TYPE = ''TABLE'' then',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P1811_TABLE_OWNER',
'              and tc.table_name = :P1811_TABLE_NAME',
'              and tc.column_name = fc.column_name )',
'        end as map_tab_col_name,',
'        case when :P1812_FIRST_LINE = ''HEADERS'' and :P1811_TARGET_TYPE = ''COLLECTION'' then',
'            case when fc.column_position < 50 then',
'                ''C''||lpad( to_char(fc.column_position), 3, ''0'')',
'            end',
'        end as map_collection_col_name,',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char,',
'        ''N'' is_pk',
'    from apex_collections c,',
'         table( wwv_flow_data_parser.get_columns(',
'                      wwv_flow_data_parser.discover(',
'                          p_content   => c.blob001,',
'                          p_file_name => ''copy_pate_data.csv'',',
'                          p_xlsx_sheet_name  => ( case when :P1812_FILE_TYPE = 1 and :P1812_XLSX_SHEET is not null then :P1812_XLSX_SHEET end ),',
'                          p_csv_col_delimiter => replace(:P1812_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                          p_file_charset      => coalesce( :P1812_FILE_CHARSET, ''AL32UTF8'' ),',
'                          p_max_rows          => 200,',
'                          p_skip_rows         => :P1812_SKIP_ROWS,',
'                          p_csv_enclosed      => nullif( :P1812_CSV_ENCLOSED, ''None'' ) )) ) fc',
'    where c.collection_name=''CLOB_CONTENT''',
'    and :P1810_SOURCE_TYPE = ''COPY_PASTE''  )',
'select',
'    m.seq_id      as column_seq,',
'    c.column_name as column_name,',
'    c.column_name|| '' (''|| initcap(c.data_type) || '')'' as column_name_disp,',
'    m.c002 as tab_col_map,',
'    m.c002 as collection_col_map,',
'    m.c003 as format_mask,',
'    m.c004 as group_char,',
'    m.c005 as decimal_char,',
'    m.c006 as is_pk',
'from l_columns c, wwv_flow_collections m',
'where c.column_name = m.c001 (+)',
'and wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'union',
'select',
'    c.column_position as column_seq,',
'    c.column_name     as column_name,',
'    c.column_name|| '' (''|| initcap(c.data_type) || '')'' as  column_name_disp,',
'    c.map_tab_col_name        as tab_col_map,',
'    c.map_collection_col_name as collection_col_map,',
'    c.format_mask             as format_mask,',
'    c.group_char              as group_char,',
'    c.decimal_char            as decimal_char,',
'    c.is_pk                   as is_pk       ',
'from l_columns c',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3304948301587422.4001)
,p_name=>'COLUMN_SEQ'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_SEQ'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305016704587423.4001)
,p_name=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>20
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305192221587424.4001)
,p_name=>'COLUMN_NAME_DISP'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME_DISP'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Columna de Origen'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305292927587425.4001)
,p_name=>'TAB_COL_MAP'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TAB_COL_MAP'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Asignar a'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(2132493628676085)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Columna no asignada -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1811_TARGET_TYPE'
,p_display_condition2=>'TABLE'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305354292587426.4001)
,p_name=>'COLLECTION_COL_MAP'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLLECTION_COL_MAP'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Asignar a'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_is_required=>false
,p_max_length=>4000
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(3007625702757031)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Columna no asignada -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1811_TARGET_TYPE'
,p_display_condition2=>'COLLECTION'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305446101587427.4001)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('M\00E1scara de Formato')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305586512587428.4001)
,p_name=>'GROUP_CHAR'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_CHAR'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Separador de Grupos'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305674635587429.4001)
,p_name=>'DECIMAL_CHAR'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DECIMAL_CHAR'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Car\00E1cter Decimal')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3305733664587430.4001)
,p_name=>'IS_PK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_PK'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Clave Primaria'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(3304881916587421.4001)
,p_internal_uid=>3304881916587421
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>400
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3902531076112663.4001)
,p_plug_name=>'obtener perfil de archivo y guardar'
,p_parent_plug_id=>wwv_flow_api.id(3304651691587419.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_content        blob;',
'    l_profile_record      wwv_flow_data_parser.t_file_profile;',
'begin',
'    l_profile        := wwv_flow_data_parser.get_file_profile;',
'    l_profile_record := wwv_flow_data_parser.json_to_profile( l_profile );',
'  ',
'    if :P1812_FIRST_LINE is null or :P1812_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_profile_record.file_columns.count loop',
'            l_profile_record.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json(l_profile_record);',
'    end if;',
'    ',
'    -- save file profile in collection for later use',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'    ',
'    :P1812_FILE_TYPE           := l_profile_record.file_type;',
'    :P1812_CSV_COL_DELIMITER   := l_profile_record.csv_delimiter;',
'    :P1812_NEW_COL_DELIMITER   := ( case when l_profile_record.csv_delimiter = chr(9) then ''tab'' else l_profile_record.csv_delimiter end );',
'    :P1812_PARSED_ROW_COUNT    := l_profile_record.parsed_rows;',
'    ',
'    if l_profile_record.file_columns.count <= 10 then',
'        :P1812_PARSED_COLUMN_COUNT := l_profile_record.file_columns.count;',
'    else',
'        :P1812_PARSED_COLUMN_COUNT := 10;',
'    end if;',
'',
'    :P1812_FILE_COLUMN_COUNT   := l_profile_record.file_columns.count;',
'    :P1812_FILE_INVALID        := ''N'';',
'exception',
'    when others then',
'        :P1812_FILE_INVALID := ''Y'';',
'        wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3616624889225788.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3616723432225789.4001)
,p_plug_name=>'Vista Previa'
,p_region_css_classes=>'a-DataLoad-preview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3616791386225790.4001)
,p_plug_name=>unistr('Informaci\00F3n de vista previa')
,p_parent_plug_id=>wwv_flow_api.id(3616723432225789.4001)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p class="desc">Se han analizado las <span id="placeholder_P1812_PARSED_ROW_COUNT">&P1812_PARSED_ROW_COUNT.</span> primeras filas de ejemplo para los tipos de columna. La vista previa que aparece a continuaci\00F3n solo muestra las <span id="placeholder_')
||'P1812_PARSED_COLUMN_COUNT">&P1812_PARSED_COLUMN_COUNT.</span> primeras columnas y 5 filas.</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(3616934009225791.4001)
,p_name=>'Datos Analizados'
,p_region_name=>'preview_table'
,p_parent_plug_id=>wwv_flow_api.id(3616723432225789.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_10by5_preview_query(',
'    p_source_type           => :P1810_SOURCE_TYPE,',
'    p_file_name             => :P1810_FILE,',
'    --',
'    p_max_rows              => 200,',
'    p_csv_delimiter         => replace(:P1812_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'    p_csv_enclosed          => nullif( :P1812_CSV_ENCLOSED, ''None'' ),',
'    p_skip_rows             => :P1812_SKIP_ROWS,',
'    p_file_charset          => coalesce( :P1812_FILE_CHARSET, ''AL32UTF8'' ),',
'    p_xlsx_sheet_name       => case when :P1812_FILE_TYPE = wwv_flow_data_parser.c_file_type_xlsx',
'                               and :P1812_XLSX_SHEET is not null then',
'                                   :P1812_XLSX_SHEET',
'                               end );'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>11
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3307794064587450.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>10
,p_column_heading=>unistr('L\00EDnea')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802138236557101.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>20
,p_column_heading=>'COL001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802254688557102.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>30
,p_column_heading=>'COL002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802350253557103.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>40
,p_column_heading=>'COL003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802489994557104.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>50
,p_column_heading=>'COL004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802573708557105.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>60
,p_column_heading=>'COL005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802602585557106.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>70
,p_column_heading=>'COL006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802786615557107.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>80
,p_column_heading=>'COL007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802843919557108.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>90
,p_column_heading=>'COL008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1802988319557109.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>100
,p_column_heading=>'COL009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1803007910557110.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>110
,p_column_heading=>'COL010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3902593886112664.4001)
,p_plug_name=>unistr('Cargar informaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(3616723432225789.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3618415348225806.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3855917059569648398.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(4115808439009126.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3855917077997648399.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3306310777587436.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3855917077997648399.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear carga de datos'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1999513044366605.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3855917077997648399.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('P\00E1gina Crear y agregar')
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1999902952366608.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3855917077997648399.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1810:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2403673594372936.4001)
,p_branch_name=>'Go To Page 1813'
,p_branch_action=>'f?p=&APP_ID.:1813:&SESSION.::&DEBUG.:1813,4716:P1813_PREV_PAGE:1812'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1999513044366605.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3306580911587438.4001)
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3306310777587436.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2000921822366611.4001)
,p_name=>'P1812_FIRST_LINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3616624889225788.4001)
,p_prompt=>'Cabeceras de columna'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.FIRST_LINE'
,p_lov=>'.'||wwv_flow_api.id(1311667928909742.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P1810_FILE) not in (wwv_flow_data_parser.c_file_type_xml, wwv_flow_data_parser.c_file_type_json) then',
'        return true;',
'    end if;',
'elsif :P1810_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Active esta opci\00F3n si los datos contienen nombres de columna en la primera fila.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2001830944366614.4001)
,p_name=>'P1812_XLSX_SHEET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3616624889225788.4001)
,p_prompt=>'Seleccionar hoja'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_file_name',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P1810_FILE and lower( :P1810_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'  and rownum = 1',
'order by sheet_sequence'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_display_name, sheet_file_name',
'from apex_application_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P1810_FILE and lower( :P1810_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'order by sheet_sequence;'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sheet_cnt number := 0;',
'begin',
'    -- shortcut: return immediately when we don''t have an XLSX file, since invoking wwv_flow_data_parser.get_xlsx_worksheets',
'    -- is an expensive operation leading to nothing',
'    if lower( :P1810_FILE ) not like ''%.xls_'' then',
'        return false;',
'    end if;',
'',
'    select count(*)',
'    into l_sheet_cnt',
'    from apex_application_temp_files f, ',
'         table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                    p_content => f.blob_content ) )',
'    where f.name = :P1810_FILE and lower( :P1810_FILE ) like ''%.xls_''',
'      and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' );',
'    ',
'    -- if there is multiple sheets, display',
'    if ( l_sheet_cnt > 1 ) then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'exception',
'    when others then ',
'        return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El archivo XLSX contiene varias hojas de trabajo. Seleccione la que se deba usar para crear la definici\00F3n de carga de datos. Tenga en cuenta que la hoja de trabajo es un atributo din\00E1mico del proceso de la p\00E1gina Carga de datos, por lo que el usuario')
||' final puede seleccionarla al cargar los datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2002702586366615.4001)
,p_name=>'P1812_CSV_COL_DELIMITER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3616624889225788.4001)
,p_prompt=>'Delimitador de Columna'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_api.id(1963861252255121.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Ninguna (detecci\00F3n autom\00E1tica)')
,p_cSize=>30
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P1810_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P1810_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un car\00E1cter delimitador de columna.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2003630333366616.4001)
,p_name=>'P1812_CSV_ENCLOSED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3616624889225788.4001)
,p_item_default=>'"'
,p_prompt=>'Delimitado por'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_api.id(1966044064255150.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguno'
,p_cSize=>30
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P1810_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P1810_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Elija el car\00E1cter, que puede delimitar los valores de columnas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2004564263366617.4001)
,p_name=>'P1812_FILE_CHARSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3616624889225788.4001)
,p_item_default=>'AL32UTF8'
,p_prompt=>unistr('Codificaci\00F3n de Archivo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_DB_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144802427115692411.4001)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el juego de caracteres en el que se codificar\00E1 el archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2011367079366634.4001)
,p_name=>'P1812_FILE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3902593886112664.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2011742280366636.4001)
,p_name=>'P1812_NEW_COL_DELIMITER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3902593886112664.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2012147299366636.4001)
,p_name=>'P1812_PARSED_ROW_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3902593886112664.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2012583229366637.4001)
,p_name=>'P1812_PARSED_COLUMN_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3902593886112664.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2012924785366637.4001)
,p_name=>'P1812_FILE_COLUMN_COUNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3902593886112664.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3304550936587418.4001)
,p_name=>'P1812_FILE_INVALID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3902593886112664.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3304738644587420.4001)
,p_name=>'P1812_MAPPED_COLUMN_COUNT_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3304651691587419.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(886117878614273007.4001)
,p_name=>'P1812_SKIP_ROWS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3616624889225788.4001)
,p_prompt=>'Omitir filas'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero de filas que omitir desde el comienzo del archivo, antes de que comience el an\00E1lisis de los datos.')
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104464513499742.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1812_FILE_CHARSET'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_bom       raw(4);',
'    l_file_blob blob;',
'    l_charset   varchar2(20) := ''WE8ISO8859P1'';',
'begin ',
'    select f.blob_content',
'      into l_file_blob',
'      from apex_application_temp_files f ',
'     where f.name = :P1810_FILE',
'       and :P1810_SOURCE_TYPE = ''FILE'';',
'',
'    if sys.dbms_lob.getlength( l_file_blob ) > 2 then',
'        l_bom := sys.dbms_lob.substr( lob_loc => l_file_blob, amount => 3, offset => 1 );',
'        if l_bom = hextoraw(''EFBBBF'') then',
'            -- UTF-8 BOM',
'            l_charset := ''AL32UTF8'';',
'        else',
'            -- UTF-16 BOM',
'            if sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FEFF'') then ',
'                l_charset := ''AL16UTF16''; ',
'            elsif sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FFFE'') then ',
'                l_charset := ''AL16UTF16LE''; ',
'            end if; ',
'        end if;',
'    end if;',
'    return l_charset;',
'exception',
'    when NO_DATA_FOUND then',
'        return null;',
'end;'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE   = ''FILE''    and ',
'   :P1810_FILE          is not null and ',
'   :P1812_FILE_CHARSET  is null and',
'   substr( lower ( :P1810_FILE ), -4 ) in ( ''.txt'', ''.csv'', ''.tsv'' ) ',
'then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3306015189587433.4001)
,p_validation_name=>'validate mapping'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_maps   wwv_flow_t_varchar2;',
'    l_table_col_cnt number := 0;',
'begin',
'    -- get column mapping user configured',
'    for l_configure in (',
'        select',
'            c001   column_name,',
'            c002   mapped_column,',
'            c004   group_char,',
'            c005   decimal_char',
'        from wwv_flow_collections',
'        where collection_name = ''APEX$DATALOAD_COLUMNS''',
'        and ( c002 != ''0'' or c002 is not null ))',
'    loop',
'        if l_configure.mapped_column member of l_column_maps then',
'            return wwv_flow_lang.system_message ( ''DATA_LOAD.DUPLICATE_MAPPING'', l_configure.mapped_column );',
'        end if;',
'',
'        -- if group separator defined, decimal character must be defined',
'        if l_configure.group_char is not null then',
'            if l_configure.decimal_char is null then',
'                return wwv_flow_lang.system_message ( ''DATA_LOAD.DECIMAL_CHAR_REQUIRED'', l_configure.mapped_column );',
'            end if;',
'        end if;',
'',
'        wwv_flow_string.push (',
'            p_table => l_column_maps,',
'            p_value => l_configure.mapped_column );',
'    end loop;',
'    ',
'    if l_column_maps is null then',
'        return wwv_flow_lang.system_message( ''DATA.LOAD.COLUMN_MAPPING_REQUIRED'' );',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in ( ''NEXT'', ''CREATE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2013374679366639.4001)
,p_name=>'Shade Headers on Load'
,p_event_sequence=>50
,p_condition_element=>'P1812_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower(:P1810_FILE) like ''%.csv'' or',
'lower(:P1810_FILE) like ''%.txt'' or',
'lower(:P1810_FILE) like ''%.xls_'' or',
':P1810_SOURCE_TYPE = ''COPY_PASTE'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2013899414366643.4001)
,p_event_id=>wwv_flow_api.id(2013374679366639.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2014361836366644.4001)
,p_event_id=>wwv_flow_api.id(2013374679366639.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").removeClass("first-row-headers");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2014790674366644.4001)
,p_name=>'Shade Headers for XML, JSON'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower(:P1810_FILE) like ''%.xml'' or',
'lower(:P1810_FILE) like ''%.json'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2015269367366645.4001)
,p_event_id=>wwv_flow_api.id(2014790674366644.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1003712372264784948.4001)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>75
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_FIRST_LINE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1003712442024784949.4001)
,p_event_id=>wwv_flow_api.id(1003712372264784948.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2404599271372945.4001)
,p_name=>'Refresh XLSX sheet change'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_XLSX_SHEET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2404663336372946.4001)
,p_event_id=>wwv_flow_api.id(2404599271372945.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2404949653372949.4001)
,p_name=>'Refresh Enclosed By Change'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2405096652372950.4001)
,p_event_id=>wwv_flow_api.id(2404949653372949.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3302835519587401.4001)
,p_name=>'Refresh File Charset Change'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_FILE_CHARSET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3302954793587402.4001)
,p_event_id=>wwv_flow_api.id(3302835519587401.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3304088210587413.4001)
,p_name=>'Adjust display of UI items after page load'
,p_event_sequence=>120
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3304179297587414.4001)
,p_event_id=>wwv_flow_api.id(3304088210587413.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// replace column count placeholders in header text of parsed data preview region',
'$( "#placeholder_P1812_PARSED_COLUMN_COUNT" ).text( $v( "P1812_PARSED_COLUMN_COUNT" ) );',
'$( "#placeholder_P1812_PARSED_ROW_COUNT"    ).text( $v( "P1812_PARSED_ROW_COUNT"    ) );',
'',
'// set the column delimiter to the actual value, which ',
'// is being determined *after* the item has been rendered, so the browser does not have the correct state.',
'$s( "P1812_CSV_COL_DELIMITER", $v("P1812_NEW_COL_DELIMITER") );',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3304349937587416.4001)
,p_name=>'Refresh column delimiter change'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3304409171587417.4001)
,p_event_id=>wwv_flow_api.id(3304349937587416.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(886117909085273008.4001)
,p_name=>'Refresh Skip Rows Change'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_SKIP_ROWS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(886118014165273009.4001)
,p_event_id=>wwv_flow_api.id(886117909085273008.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3306607635587439.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_load_id number;',
'begin',
'    l_data_load_id := wwv_flow_data_loader_dev.create_data_load(',
'                        p_application_id      => :FB_FLOW_ID,',
'                        --',
'                        p_column_collection   => ''APEX$DATALOAD_COLUMNS'',',
'                        p_profile_collection  => ''APEX$DATALOAD'',',
'                        --',
'                        p_data_load_name      => :P1811_NAME,',
'                        p_target_type         => :P1811_TARGET_TYPE,',
'                        p_target_schema       => case :P1811_TARGET_TYPE',
'                                                 when ''TABLE'' then',
'                                                     :P1811_TABLE_OWNER',
'                                                 when ''COLLECTION'' then',
'                                                     :OWNER',
'                                                 end,',
'                        p_target_name         => case :P1811_TARGET_TYPE',
'                                                 when ''TABLE'' then',
'                                                     :P1811_TABLE_NAME',
'                                                 when ''COLLECTION'' then',
'                                                     :P1811_COLLECTION_NAME',
'                                                 end );',
'',
'    :P1814_DATA_LOAD_ID := l_data_load_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE, NEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Se ha creado la definici\00F3n de carga de datos.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2403840993372938.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'init columns collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.init_column_collection(',
'    p_column_collection   => ''APEX$DATALOAD_COLUMNS'',',
'    p_profile_collection  => ''APEX$DATALOAD'',',
'    --',
'    p_target_type         => :P1811_TARGET_TYPE,',
'    p_target_schema       => case :P1811_TARGET_TYPE',
'                             when ''TABLE'' then',
'                                 :P1811_TABLE_OWNER',
'                             when ''COLLECTION'' then',
'                                 :OWNER',
'                             end,',
'    p_target_name        => case :P1811_TARGET_TYPE',
'                             when ''TABLE'' then',
'                                 :P1811_TABLE_NAME',
'                             when ''COLLECTION'' then',
'                                 ''WWV_FLOW_COLLECTIONS''',
'                             end );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''NEXT'', ''CREATE'' ) and wwv_flow_collection.collection_member_count(',
'    p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2404064341372940.4001)
,p_process_sequence=>40
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(3304651691587419.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Table Column Mapping - IG Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_seq             => :COLUMN_SEQ,',
'        p_c001            => :COLUMN_NAME,        -- column_name',
'        p_c002            => :TAB_COL_MAP,        -- mapped table column',
'        p_c003            => :FORMAT_MASK,        -- format mask',
'        p_c004            => :GROUP_CHAR,         -- group char',
'        p_c005            => :DECIMAL_CHAR,       -- decimal char',
'        p_c006            => :IS_PK               -- is PK      ',
'        );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''NEXT'', ''CREATE'' ) and wwv_flow_collection.collection_member_count(',
'    p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0 and :P1811_TARGET_TYPE = ''TABLE'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2404140697372941.4001)
,p_process_sequence=>50
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(3304651691587419.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Collection Column Mapping - IG Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_seq             => :COLUMN_SEQ,',
'        p_c001            => :COLUMN_NAME,        -- column_name',
'        p_c002            => :COLLECTION_COL_MAP,  -- mapped collection column',
'        p_c003            => :FORMAT_MASK,        -- format mask',
'        p_c004            => :GROUP_CHAR,         -- group char',
'        p_c005            => :DECIMAL_CHAR,       -- decimal char',
'        p_c006            => :IS_PK               -- is PK      ',
'        );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''NEXT'', ''CREATE'' ) and wwv_flow_collection.collection_member_count(',
'    p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0 and :P1811_TARGET_TYPE = ''COLLECTION'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_01813
begin
wwv_flow_api.create_page(
 p_id=>1813.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos'
,p_alias=>'CREATE-DATA-LOAD3'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4100929396268757.4001)
,p_plug_name=>unistr('P\00E1gina Crear carga de datos')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3857139876327003195.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(4115808439009126.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3857139894755003196.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4100863848450821.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3857139894755003196.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3223477903721392.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3857139894755003196.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3231001280745535.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3857139894755003196.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3306432663587437.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::P4716_PREV_PAGE_ID:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1804015350557120.4001)
,p_name=>'P1813_PREV_PAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4101246730931123.4001)
,p_name=>'P1813_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page( :FB_FLOW_ID, 1 )'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El n\00FAmero de p\00E1gina es un valor entero que identifica una p\00E1gina en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4102153807931127.4001)
,p_name=>'P1813_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre de texto para esta p\00E1gina. Este nombre est\00E1 visible solo durante el proceso de desarrollo de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4103462997931128.4001)
,p_name=>'P1813_PAGE_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE'
,p_lov=>'.'||wwv_flow_api.id(44400703264122475.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: la p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de Di\00E1logo Modal</strong>: la p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li>'),
unistr('<li><strong>Cuadro de Di\00E1logo No Modal</strong>: la p\00E1gina se presenta como un cuadro de di\00E1logo no modal. Un cuadro de di\00E1logo no modal es una ventana de superposici\00F3n situada en el viewport, donde el usuario final puede interactuar con el cuadro de')
||unistr(' di\00E1logo y el contenido de la p\00E1gina que lo inici\00F3. Un cuadro de di\00E1logo no modal puede utilizarse cuando la informaci\00F3n solicitada no es esencial para continuar; el trabajo puede continuar en otro lugar mientras la ventana sigue abierta.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que las opciones Cuadro de Di\00E1logo Modal y Cuadro de Di\00E1logo No Modal solo estar\00E1n disponibles para seleccionarlas cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de Cuadro de Di\00E1l')
||'ogo</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4105203558931129.4001)
,p_name=>'P1813_GROUP_NAME'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. '),
unistr('  Los grupos de p\00E1ginas ayudan a los desarrolladores a identificar y gestionar las p\00E1ginas en una aplicaci\00F3n.</p>'),
unistr('<p>Nota: Para crear grupos de p\00E1ginas, vaya a <strong>Utilidades: Grupos de p\00E1ginas</strong> en Utilidades espec\00EDficas de p\00E1gina en la barra lateral derecha.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4106196592931130.4001)
,p_name=>'P1813_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_cSize=>64
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4107076213931131.4001)
,p_name=>'P1813_BREADCRUMB_PARENT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P1813_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P1813_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P1813_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>64
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la entrada de ruta de navegaci\00F3n principal para la p\00E1gina actual; seleccione "Ninguna Entrada Principal" para la p\00E1gina de nivel superior.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4107933993931131.4001)
,p_name=>'P1813_BREADCRUMB_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4100929396268757.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P1813_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1529003478234246.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1813_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1804151348557121.4001)
,p_computation_sequence=>10
,p_computation_item=>'P259_USER_INTERFACE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id /* get the first displayed user interface */',
'  from wwv_flow_user_interfaces',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and rownum = 1 ',
' order by display_seq'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1804615064557126.4001)
,p_computation_sequence=>20
,p_computation_item=>'P259_NAVIGATION_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_ui_types_dev t',
' where x.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and t.id                = i.ui_type_id',
'   and x.flow_id           = i.flow_id',
'   and i.id                = :P259_USER_INTERFACE_ID',
'   and i.theme_id          = x.theme_id',
' order by 1'))
,p_compute_when=>'P259_NAVIGATION_TYPE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4110583720948107.4001)
,p_validation_name=>'Page ID exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n number;',
'    l_result boolean := TRUE;',
'begin',
'    for c1 in (select NULL',
'                 from wwv_flow_steps ',
'                where id = :P1813_PAGE_ID ',
'                  and flow_id = :FB_FLOW_ID ',
'                  and security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'        l_result := FALSE;',
'        exit;',
'    end loop;',
'    return l_result;',
'    --',
'    exception',
'        when others then',
'            return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El "&P1813_PAGE_ID." de p\00E1gina ya lo est\00E1 utilizando la aplicaci\00F3n "&FB_FLOW_ID." o no es num\00E9rico. Especifique un identificador de p\00E1gina num\00E9rico que no lo est\00E9 utilizando la aplicaci\00F3n actual.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4110836288953331.4001)
,p_validation_name=>'Page ID not decimal or negative'
,p_validation_sequence=>20
,p_validation=>'trunc(abs(:P1813_PAGE_ID)) = :P1813_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4111109234956218.4001)
,p_validation_name=>'Breadcrumb Name Not NUll'
,p_validation_sequence=>30
,p_validation=>'P1813_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P1813_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4111485361958696.4001)
,p_validation_name=>'Valid group name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P1813_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1813_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1804272495557122.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1813_BREADCRUMB_ID'
,p_condition_element=>'P1813_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1804330766557123.4001)
,p_event_id=>wwv_flow_api.id(1804272495557122.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1813_BREADCRUMB_PARENT_ID,P1813_BREADCRUMB_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1804582250557125.4001)
,p_event_id=>wwv_flow_api.id(1804272495557122.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1813_BREADCRUMB_PARENT_ID,P1813_BREADCRUMB_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2104215740499740.4001)
,p_name=>'set breadcrumb name'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1813_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2104334271499741.4001)
,p_event_id=>wwv_flow_api.id(2104215740499740.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1813_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1813_PAGE_NAME'
,p_attribute_07=>'P1813_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3902426265727002.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4100863848450821.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3902527847727003.4001)
,p_event_id=>wwv_flow_api.id(3902426265727002.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01814
begin
wwv_flow_api.create_page(
 p_id=>1814.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos'
,p_alias=>'CREATE-DATA-LOAD4'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48988478992255518.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(312124084119650921.4001)
,p_plug_name=>'Create Data Load'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4115808439009126.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_row_template=>wwv_flow_api.id(506168724401357441.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(312241182434678837.4001)
,p_plug_name=>unistr('P\00E1gina Crear carga de datos')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4102389769460779.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48988478992255518.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4206500383102194.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48988478992255518.4001)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4206987212102194.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48988478992255518.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1805520222557135.4001)
,p_branch_name=>'Go to edit page if from shared component'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:&FB_FLOW_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1813_PREV_PAGE'
,p_branch_condition_text=>'1812'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4215089129102237.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4206987212102194.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1803184892557111.4001)
,p_name=>'P1814_DATA_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(312241182434678837.4001)
,p_item_default=>'FILE'
,p_prompt=>'Cargar datos desde'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.DATA_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(2505800285473362.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si los usuarios de la aplicaci\00F3n proporcionar\00E1n datos mediante la carga de archivos o si se utilizar\00E1 copiar y pegar con los datos de texto delimitados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1803235384557112.4001)
,p_name=>'P1814_MAX_FILE_SIZE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(312241182434678837.4001)
,p_item_default=>'5'
,p_prompt=>unistr('Tama\00F1o m\00E1ximo de archivo (MB)')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el tama\00F1o m\00E1ximo de archivo (en MB) que se deber\00EDa aceptar para la carga de archivos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1803666979557116.4001)
,p_name=>'P1814_DATA_LOAD_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(312241182434678837.4001)
,p_prompt=>'Carga de Datos'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'from wwv_flow_load_tables',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and data_profile_id is not null'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la definici\00F3n de carga de datos que se va a utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2100368842346901.4001)
,p_name=>'P1814_DATA_PROFILE_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(312241182434678837.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2101071968346908.4001)
,p_validation_name=>'If format != CSV, paste text not supported'
,p_validation_sequence=>10
,p_validation=>'P1814_DATA_SOURCE_TYPE'
,p_validation2=>'TEXT'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>unistr('Cargue los datos desde <strong>Archivo</strong> para cargar datos &P1814_DATA_PROFILE_FORMAT.. La opci\00F3n <strong>Pegar datos delimitados</strong> solo est\00E1 soportada para la carga de datos CSV.')
,p_validation_condition=>'P1814_DATA_PROFILE_FORMAT'
,p_validation_condition2=>'CSV'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(1803184892557111.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1803379657557113.4001)
,p_name=>'toggle file size'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1814_DATA_SOURCE_TYPE'
,p_condition_element=>'P1814_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1803417452557114.4001)
,p_event_id=>wwv_flow_api.id(1803379657557113.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1814_MAX_FILE_SIZE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1803541919557115.4001)
,p_event_id=>wwv_flow_api.id(1803379657557113.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1814_MAX_FILE_SIZE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1805606901557136.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4102389769460779.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1805774008557137.4001)
,p_event_id=>wwv_flow_api.id(1805606901557136.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2100420793346902.4001)
,p_name=>'get data format'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1814_DATA_LOAD_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2100532001346903.4001)
,p_event_id=>wwv_flow_api.id(2100420793346902.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select format',
'into :P1814_DATA_PROFILE_FORMAT',
'from wwv_flow_data_profiles p, wwv_flow_load_tables d',
'where p.id = d.data_profile_id',
'and d.id = :P1814_DATA_LOAD_ID',
'and p.flow_id = :FB_FLOW_ID',
'and p.security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_attribute_02=>'P1814_DATA_LOAD_ID'
,p_attribute_03=>'P1814_DATA_PROFILE_FORMAT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P1814_DATA_LOAD_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3755300448775412.4001)
,p_name=>'submit CREATE and show progress'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4206500383102194.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3755417341775413.4001)
,p_event_id=>wwv_flow_api.id(3755300448775412.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1805473204557134.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create loading page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.create_data_load_page(',
'    p_application_id             => :FB_FLOW_ID,',
'    p_page_id                    => :P1813_PAGE_ID,',
'    p_page_name                  => :P1813_PAGE_NAME,',
'    p_group_name                 => :P1813_GROUP_NAME,',
'    p_page_mode                  => :P1813_PAGE_MODE,',
'    p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'    --',
'    p_tab_set                    => :P4716_TAB_SET,',
'    p_tab_name                   => :P4716_TAB_NAME,',
'    p_tab_text                   => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id                => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_breadcrumb_id              => :P1813_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P1813_BREADCRUMB_NAME,',
'    p_parent_breadcrumb_entry_id => :P1813_BREADCRUMB_PARENT_ID,',
'    --',
'    p_data_load_id               => :P1814_DATA_LOAD_ID,',
'    p_data_source_type           => :P1814_DATA_SOURCE_TYPE,',
'    p_max_file_size              => :P1814_MAX_FILE_SIZE );',
'',
':FB_FLOW_PAGE_ID       := :P1813_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P1813_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido crear la p\00E1gina de carga de datos.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4206500383102194.4001)
,p_process_when=>'P1814_DATA_LOAD_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4213390256102230.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close  Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1813_PREV_PAGE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'259'
,p_process_success_message=>unistr('La p\00E1gina de carga de datos se ha creado correctamente.')
);
end;
/
prompt --application/pages/page_01815
begin
wwv_flow_api.create_page(
 p_id=>1815.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear carga de datos - M\00E9todo')
,p_alias=>'CREATE-DATA-LOAD-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear carga de datos - M\00E9todo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685074406077372082.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Al crear una nueva definici\00F3n de carga de datos, tiene dos opciones. Puede crear una nueva definici\00F3n de carga de datos desde el principio o reutilizar implantaciones que ya existan en la aplicaci\00F3n o en otras aplicaciones del espacio de trabajo.<')
||'/p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685075086116372098.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(3306223094711954.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685075334902372098.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685075947472372104.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3302651020698256.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1685075334902372098.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3303013063698258.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1685075334902372098.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3304756298698280.4001)
,p_branch_name=>'Go To Page Copy'
,p_branch_action=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.:1816,1817::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3303013063698258.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1815_CREATE_METHOD'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3305193299698282.4001)
,p_branch_name=>'Go To Page Create'
,p_branch_action=>'f?p=&APP_ID.:1811:&SESSION.::&DEBUG.:RP,1810,1811,1812,1813,APEX$DATALOAD,APEX$DATALOAD_COLUMNS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3303013063698258.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1815_CREATE_METHOD'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3301171893698248.4001)
,p_name=>'P1815_CREATE_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1685074406077372082.4001)
,p_item_default=>'CREATE'
,p_prompt=>'Crear carga de datos:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CREATE_METHOD'
,p_lov=>'.'||wwv_flow_api.id(3313626961776680.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo mediante el cual desea crear la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3303732434698278.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3302651020698256.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3304294513698279.4001)
,p_event_id=>wwv_flow_api.id(3303732434698278.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01816
begin
wwv_flow_api.create_page(
 p_id=>1816.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear carga de datos - Aplicaci\00F3n')
,p_alias=>'CREATE-DATA-LOAD-APPLICATION'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear carga de datos - Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685206841715648152.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para copiar una definici\00F3n de carga de datos de otra aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685207560420648153.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(3306223094711954.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685207770081648153.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685208543132648155.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3368967070872566.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1685207770081648153.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3369340085872567.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1685207770081648153.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3370130567872582.4001)
,p_branch_name=>'Go To Page 1817'
,p_branch_action=>'f?p=&APP_ID.:1817:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3368967070872566.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3367499518872563.4001)
,p_name=>'P1816_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1685206841715648152.4001)
,p_prompt=>unistr('Copiar de aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||f.name as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_load_tables a',
'                 where a.flow_id = f.id',
'                 and data_profile_id is not null',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n cuya definici\00F3n de carga de datos desea copiar.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_01817
begin
wwv_flow_api.create_page(
 p_id=>1817.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear carga de datos - Como copia'
,p_alias=>'CREATE-DATA-LOAD-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear carga de datos - Como copia'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1591625356552601822.4001)
,p_name=>'Crear carga de datos'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ROWID,',
'       id,',
'       name,',
'       case when reference_id is not null then ''Y'' else ''N'' end as is_subscribed,',
'       case',
'         when reference_id is null and :P1816_COPY_FROM = :FB_FLOW_ID then wwv_flow_lang.system_message( ''F4000.P158.COPY_OF'', name )',
'         else name',
'       end as new_name,',
'       case',
'         when :P1816_COPY_FROM = :FB_FLOW_ID then ''N''',
'         when reference_id is not null       then ''Y''',
'         else ''SUBSCRIBE''',
'       end as action',
'  from wwv_flow_load_tables a',
' where flow_id           = :P1816_COPY_FROM',
'   and security_group_id = :WORKSPACE_ID',
'   and data_profile_id is not null',
'   and (',
'       -- Don''t show subscribed data load, because they can''t be copied',
'          (   :P1816_COPY_FROM = :FB_FLOW_ID',
'          and reference_id is null',
'          )',
'       -- Don''t show data load in which have already been copied from another application',
'       or (   :P1816_COPY_FROM <> :FB_FLOW_ID',
'          and not exists ( select 1',
'                             from wwv_flow_load_tables b',
'                            where b.flow_id           = :FB_FLOW_ID',
'                              and b.security_group_id = :WORKSPACE_ID',
'                              and data_profile_id is not null',
'                              and b.name              = a.name',
'                         )',
'          )',
'       )',
' order by name',
''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique la definici\00F3n de la carga de datos que se va a copiar y seleccione la opci\00F3n de copia. Las opciones de copia incluyen:</p>'),
'<ul>',
unistr('    <li><strong>S\00ED</strong>: copia la carga de datos.</li>'),
'    <li><strong>No</strong>: no copia esta carga de datos.</li>',
unistr('    <li><strong>Copiar y suscribir</strong>: la suscripci\00F3n a una carga de datos coloca una copia en su aplicaci\00F3n y define la referencia maestra de la carga de datos.</li>'),
'</ul>',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3374614647928817.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3375021491928819.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3375444452928819.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3375851531928819.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>4
,p_column_heading=>'Suscrito'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3376246078928819.4001)
,p_query_column_id=>5
,p_column_alias=>'NEW_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'A Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3376662401928820.4001)
,p_query_column_id=>6
,p_column_alias=>'ACTION'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(3387269549000655)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685229289886778919.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(3306223094711954.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685229473163778920.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1685230254950778922.4001)
,p_plug_name=>'Crear carga de datos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3379115342928822.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1685229473163778920.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar definici\00F3n de carga de datos')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3379547540928822.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1685229473163778920.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3379971972928823.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1685229473163778920.4001)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular la Selecci\00F3n de Todo')
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3381606484928825.4001)
,p_branch_name=>'Go To Page Data Load Definitions'
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3377131920928820.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(1591625356552601822.4001)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_load_tables',
' where name = :NEW_NAME and :ACTION in (''Y'', ''SUBSCRIBE'')',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and data_profile_id is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Este nombre ya lo est\00E1 utilizando una definici\00F3n de carga de datos existente.')
,p_when_button_pressed=>wwv_flow_api.id(247699430129474724.4001)
,p_only_for_changed_rows=>'N'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3377508710928821.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(1591625356552601822.4001)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_load_tables',
' where static_id = regexp_replace( :NEW_NAME, ''[^a-zA-Z0-9]'', ''_'' ) and :ACTION in (''Y'', ''SUBSCRIBE'')',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and data_profile_id is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El ID est\00E1tico "&NEW_NAME." (derivado del nombre de la definici\00F3n de carga de datos) ya est\00E1 en uso por otra definici\00F3n de carga de datos. Elija otro nombre.')
,p_when_button_pressed=>wwv_flow_api.id(247699430129474724.4001)
,p_only_for_changed_rows=>'N'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3380673082928824.4001)
,p_name=>'Deselect All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3379971972928823.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3381156489928825.4001)
,p_event_id=>wwv_flow_api.id(3380673082928824.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'td[headers=ACTION] select'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3377800779928821.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(1591625356552601822.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Data Load Definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name wwv_flow_load_tables.name%type;',
'    l_id   number;',
'begin',
'    if :ACTION in (''Y'', ''SUBSCRIBE'') then',
'        select name ',
'          into l_name',
'          from wwv_flow_load_tables',
'         where flow_id           = :P1816_COPY_FROM',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'           and id                = :ID;',
'           ',
'        l_id := wwv_flow_data_loader_dev.copy_data_load (',
'            p_from_application_id => :P1816_COPY_FROM,',
'            p_name                => l_name,',
'            p_to_application_id   => :FB_FLOW_ID,',
'            p_to_name             => :NEW_NAME,',
'            p_subscribe           => ( :ACTION = ''SUBSCRIBE'' ));',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(247699430129474724.4001)
,p_only_for_changed_rows=>'N'
,p_process_success_message=>unistr('Se ha copiado la definici\00F3n de carga de datos.')
);
end;
/
prompt --application/pages/page_01820
begin
wwv_flow_api.create_page(
 p_id=>1820.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar carga de datos'
,p_alias=>'EDIT-DATA-LOAD'
,p_step_title=>'Editar carga de datos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2102240269346920.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'WWV_FLOW_LOAD_TABLES'
,p_attribute_02=>'NAME'
,p_attribute_03=>'P1820_ID'
,p_attribute_04=>'P1820_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_DATA_LOAD'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2561095520654008.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2561562676654013.4001)
,p_plug_name=>'Destino'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4804039483918701.4001)
,p_plug_name=>'Advertencia sobre la falta de coincidencia de las columnas de perfil con la tabla de destino'
,p_parent_plug_id=>wwv_flow_api.id(2561562676654013.4001)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('No hay ninguna columna de perfil de datos que coincida con las columnas de la tabla de destino. Al cargar los datos con esta definici\00F3n se generar\00E1 un error. Seleccione la tabla que coincida con la columna del perfil de datos o edite esa columna para')
||' que coincida con el nombre de la columna de la tabla de destino.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1820_TARGET_TYPE'
,p_plug_display_when_cond2=>'TABLE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2561680773654014.4001)
,p_plug_name=>'Manejo de Errores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(97783562090282000.4001)
,p_plug_name=>'Carga de Datos'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(98461244952314959.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130842348178692454.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(494860436524911651.4001)
,p_name=>'Perfil de Datos'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    dp.format,',
'    --dp.csv_separator,',
'    --dp.csv_enclosed,',
'    --dp.default_xlsx_sheet_name,',
'    count( dc.id ) as column_cnt',
'from wwv_flow_data_profiles dp, wwv_flow_data_profile_cols dc',
'where dc.data_profile_id (+) = dp.id',
'  and dp.flow_id           = :FB_FLOW_ID',
'  and dp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and dp.id                = :P1820_DATA_PROFILE_ID',
'group by dp.format'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1820_DATA_PROFILE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041640454953406573.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn perfil de datos.')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1526499224234220.4001)
,p_query_column_id=>1
,p_column_alias=>'FORMAT'
,p_column_display_sequence=>32
,p_column_heading=>'Formato'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2560372526654001.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_CNT'
,p_column_display_sequence=>82
,p_column_heading=>'Columnas'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617080575279095222.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by, last_updated_on, created_by, created_on ',
'    from  wwv_flow_load_tables',
'    where id = :P1820_ID',
'    and flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id)',
'loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P1820_ID,',
'      p_component_type => ''Data Load'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687682638763131719.4001)
,p_plug_name=>'Carga de Datos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_LOAD_TABLES'
,p_query_where=>'security_group_id = :WORKSPACE_ID and flow_id = :FB_FLOW_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1491435915216601.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(494860436524911651.4001)
,p_button_name=>'EDIT_DATA_PROFILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Editar perfil de datos'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:1925:P1925_DATA_PROFILE_ID:&P1820_DATA_PROFILE_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1505175224216609.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(97783562090282000.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1505506467216610.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(97783562090282000.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1820_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1505976442216610.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(97783562090282000.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1820_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3509768116216430.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(2102240269346920.4001)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P1820_ID.,&APP_PAGE_ID.,DATA_LOAD'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where reference_id = :P1820_ID',
' and data_profile_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3510049858217959.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(2102240269346920.4001)
,p_button_name=>'REFRESH_SUB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'NEXT'
,p_button_condition=>'P1820_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3510368465219185.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(2102240269346920.4001)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular Suscripci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'P1820_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1512622436216633.4001)
,p_branch_name=>'Go To Page 1800'
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'SAVE, DELETE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1475715572216581.4001)
,p_name=>'P1820_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(98461244952314959.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1492406330216602.4001)
,p_name=>'P1820_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1493297589216602.4001)
,p_name=>'P1820_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Nombre para la definici\00F3n de carga de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1494187761216602.4001)
,p_name=>'P1820_TABLE_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2561562676654013.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>'Propietario de Tabla'
,p_source=>'OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Esquema de an\00E1lisis -')
,p_cHeight=>1
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Propietario de la tabla, en la que se cargar\00E1n los datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1495007758216603.4001)
,p_name=>'P1820_TABLE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2561562676654013.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>'Nombre de la Tabla'
,p_source=>'TABLE_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_cascade_parent_items=>'P1820_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>255
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nombre de la tabla, en la que se cargar\00E1n los datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1524598699234201.4001)
,p_name=>'P1820_ERROR_COLLECTION_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(2561680773654014.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>unistr('Nombre de la recopilaci\00F3n de errores')
,p_source=>'ERROR_COLLECTION_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca el nombre de la recopilaci\00F3n &PRODUCT_NAME.. Cuando se produzca un error durante la carga de datos, &PRODUCT_NAME. almacenar\00E1 el mensaje de error y la secuencia de filas (en el archivo cargado) como los miembros de recopilaci\00F3n <strong>C00')
||'1</strong> y <strong>N001</strong>. ',
'</p>',
'<p>',
unistr('Utilice la vista APEX_COLLECTIONS para recuperar y procesar esta informaci\00F3n en la aplicaci\00F3n APEX.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1806227022557142.4001)
,p_name=>'P1820_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>unistr('Identificador Est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia a la definici\00F3n de carga de datos en llamadas de API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1806396205557143.4001)
,p_name=>'P1820_TARGET_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2561562676654013.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>'tipo de objetivo'
,p_source=>'TARGET_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.TARGET_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1633774479940540.4001)||'.'
,p_read_only_when=>'P1820_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si los datos se van a cargar en una tabla o en una recopilaci\00F3n de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1806612235557146.4001)
,p_name=>'P1820_COLLECTION_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2561562676654013.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>unistr('Nombre de la Recopilaci\00F3n')
,p_source=>'COLLECTION_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'COLLECTION'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca el nombre de la recopilaci\00F3n de &PRODUCT_NAME. con el que almacenar de forma temporal los datos de la sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1806779933557147.4001)
,p_name=>'P1820_DATA_PROFILE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1806886337557148.4001)
,p_name=>'P1820_LOADING_METHOD'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2561095520654008.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>unistr('M\00E9todo de carga')
,p_source=>'LOADING_METHOD'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.METHOD'
,p_lov=>'.'||wwv_flow_api.id(2101544010414427.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Especifique el m\00E9todo de carga que se va a usar. Los valores posibles son:'),
'</p>',
'<ul>',
unistr('    <li><strong>Agregar</strong>: permite agregar filas a la tabla o recopilaci\00F3n. Si se han definido una o varias columnas de clave principal en el <em>perfil de datos</em>, las filas existentes no se cambiar\00E1n y las nuevas filas se agregar\00E1n. Si el')
||unistr(' perfil de datos no tiene ninguna definici\00F3n de clave principal, todas las filas simplemente se agregar\00E1n.</li>'),
unistr('    <li><strong>Fusionar</strong>: permite fusionar filas en la tabla. El perfil de datos debe tener definida una <em>clave principal</em> para utilizar esta opci\00F3n. Si ya existe una fila para el valor de clave principal especificado, se actualizar\00E1 ')
||unistr('la fila y si no existe, se crear\00E1. Esta opci\00F3n solo est\00E1 disponible para la carga de datos en tablas.</li>'),
unistr('    <li><strong>Sustituir</strong>: se eliminar\00E1n los datos existentes en la recopilaci\00F3n o la tabla de destino antes de cargar los datos nuevos.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1806971649557149.4001)
,p_name=>'P1820_COMMIT_INTERVAL'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2561095520654008.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>unistr('Intervalo de confirmaci\00F3n')
,p_source=>'COMMIT_INTERVAL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Especifique el intervalo de confirmaci\00F3n que se va a utilizar durante la carga de datos. Si no se especifica ning\00FAn intervalo de confirmaci\00F3n, toda la carga de datos ser\00E1 una transacci\00F3n, con una confirmaci\00F3n despu\00E9s de la \00FAltima fila. Si se especifi')
||unistr('ca un intervalo, &PRODUCT_NAME. confirmar\00E1 cada vez que se realice la sincronizaci\00F3n despu\00E9s de que la cantidad de filas especificada se haya procesado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1807078271557150.4001)
,p_name=>'P1820_ERROR_HANDLING'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2561680773654014.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_prompt=>'Cuando se produzca un error'
,p_source=>'ERROR_HANDLING'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA.LOAD.ERROR_HANDLING'
,p_lov=>'.'||wwv_flow_api.id(2102956113429319.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Especifique c\00F3mo gestionar los errores durante la carga de datos. Los valores posibles son:'),
'</p>',
'<ul>',
unistr('    <li><strong>Ignorar</strong>: las filas de error se ignoran de forma silenciosa y la carga de datos simplemente se contin\00FAa realizando.</li>'),
'    <li><strong>Parar</strong>: la carga de datos se para cuando se produce el primer error y se genera un mensaje de error.</li>',
unistr('    <li><strong>Registrar en recopilaci\00F3n</strong>: las filas de error se registran en una recopilaci\00F3n de &PRODUCT_NAME..</li>'),
unistr('    <li><strong>Registrar en log de errores</strong>: las filas de error se registran en una tabla de registro de errores de DML con la funcionalidad de base de datos <strong>Registro de errores de DML</strong>. Esto solo est\00E1 disponible al realizar ')
||unistr('la carga en una tabla y solo si se usa el m\00E9todo <strong>Agregar</strong> <em>sin</em> una clave principal.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2102356851346921.4001)
,p_name=>'P1820_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2563578393654033.4001)
,p_name=>'P1820_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(687682638763131719.4001)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4700971218940005.4001)
,p_name=>'P1820_TABLE_ERR_LOG_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(2561680773654014.4001)
,p_prompt=>'Tabla de registro de errores'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
' and object_type = ''TABLE'''))
,p_lov_cascade_parent_items=>'P1820_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione el nombre de la <em>tabla de registro de errores de DML</em>, que se haya creado antes para la tabla de destino seleccionada. Utilice <strong>DBMS_ERRLOG.CREATE_ERROR_LOG</strong> para crear la tabla de registro de errores.',
'</p>',
'<p>Ejemplo:</p>',
'<pre>',
'begin',
'    dbms_errlog.create_error_log(',
'        dml_table_name => ''<em>{target table}</em>'' );',
'end;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4804111899918702.4001)
,p_name=>'P1820_PROFILE_COL_MATCH_CNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2561562676654013.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4701469159940010.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1820_ERROR_COLLECTION_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1820_TABLE_ERR_LOG_NAME'
,p_compute_when=>':REQUEST = ''SAVE'' and :P1820_TARGET_TYPE = ''TABLE'' and :P1820_ERROR_HANDLING = ''ERROR_LOG'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1506812163216627.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&APP_PAGE_ID.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2561149919654009.4001)
,p_validation_name=>'valid static ID'
,p_validation_sequence=>10
,p_validation=>'P1820_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('El identificador solo puede contener caracteres alfanum\00E9ricos y "_".')
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1806227022557142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3100518337092967.4001)
,p_validation_name=>'name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ NO_INDEX( wwv_flow_load_tables wwv_flow_load_tab_uk2 ) */ 1',
'from wwv_flow_load_tables',
'where name = :P1820_NAME',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and id != :P1820_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otra definici\00F3n de carga de datos ya est\00E1 utilizando el nombre.')
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1493297589216602.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5268996876575503.4001)
,p_validation_name=>'static ID exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ NO_INDEX( wwv_flow_load_tables wwv_flow_load_tab_uk2 ) */ 1',
'from wwv_flow_load_tables',
'where static_id = :P1820_STATIC_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and id != :P1820_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otra definici\00F3n de carga de datos ya est\00E1 utilizando el ID est\00E1tico.')
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1806227022557142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3100833842094692.4001)
,p_validation_name=>'table required'
,p_validation_sequence=>40
,p_validation=>'P1820_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1820_TARGET_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1495007758216603.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(47649011248672701.4001)
,p_validation_name=>'Chosen Table Exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P1820_TABLE_NAME',
'   and owner       = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P1820_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P1820_TARGET_TYPE = ''TABLE'' and :P1820_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1495007758216603.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3101182690095855.4001)
,p_validation_name=>'collection name required'
,p_validation_sequence=>60
,p_validation=>'P1820_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1820_TARGET_TYPE'
,p_validation_condition2=>'COLLECTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1806612235557146.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2561788610654015.4001)
,p_validation_name=>'error collection name required'
,p_validation_sequence=>70
,p_validation=>'P1820_ERROR_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1820_ERROR_HANDLING'
,p_validation_condition2=>'LOG_ROWS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1524598699234201.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4701068399940006.4001)
,p_validation_name=>'error log name required'
,p_validation_sequence=>80
,p_validation=>'P1820_TABLE_ERR_LOG_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1820_ERROR_HANDLING'
,p_validation_condition2=>'ERROR_LOG'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(4700971218940005.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4504760236479031.4001)
,p_validation_name=>'error log not supported'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1820_LOADING_METHOD = ''APPEND'' and',
'   wwv_flow_data_loader_dev.is_pk_profile_col_defined(',
'       p_application_id => :FB_FLOW_ID,',
'       p_data_load_id   => :P1820_ID )',
'then',
'    -- if APPEND and PK defined, DML error log not supported',
'    return false;',
'elsif :P1820_LOADING_METHOD = ''MERGE''  then',
'    -- DML error log not supported for MERGE load',
'    return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La opci\00F3n Registrar en log de errores no est\00E1 soportada para los m\00E9todos de carga Fusionar ni Agregar si se ha definido una columna de clave principal.')
,p_validation_condition=>'P1820_ERROR_HANDLING'
,p_validation_condition2=>'ERROR_LOG'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1807078271557150.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4320117509183303.4001)
,p_validation_name=>'Data Load still referenced'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_data_loader_dev.is_data_load_used(',
'    p_application_id => :FB_FLOW_ID,',
'    p_data_load_id   => :P1820_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Algunos componentes de aplicaci\00F3n hacen referencia a esta definici\00F3n de carga de datos, por lo que no puede suprimirla.')
,p_when_button_pressed=>wwv_flow_api.id(1505506467216610.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5268836072575502.4001)
,p_validation_name=>'loading method not null'
,p_validation_sequence=>110
,p_validation=>'P1820_LOADING_METHOD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1806886337557148.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4504695891479030.4001)
,p_validation_name=>'MERGE, pk required'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.is_pk_profile_col_defined(',
'    p_application_id => :FB_FLOW_ID,',
'    p_data_load_id   => :P1820_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El perfil de datos no tiene definida ninguna columna de clave principal. El m\00E9todo de carga Fusionar debe tener una columna de clave principal.')
,p_validation_condition=>'P1820_LOADING_METHOD'
,p_validation_condition2=>'MERGE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1505976442216610.4001)
,p_associated_item=>wwv_flow_api.id(1806886337557148.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2561213772654010.4001)
,p_name=>'toggle error collection'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_ERROR_HANDLING'
,p_condition_element=>'P1820_ERROR_HANDLING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOG_ROWS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2561355377654011.4001)
,p_event_id=>wwv_flow_api.id(2561213772654010.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_ERROR_COLLECTION_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2561487062654012.4001)
,p_event_id=>wwv_flow_api.id(2561213772654010.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_ERROR_COLLECTION_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4701123962940007.4001)
,p_name=>'toggle error log if target is table'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_ERROR_HANDLING'
,p_condition_element=>'P1820_ERROR_HANDLING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ERROR_LOG'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4701279994940008.4001)
,p_event_id=>wwv_flow_api.id(4701123962940007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_TABLE_ERR_LOG_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4701309464940009.4001)
,p_event_id=>wwv_flow_api.id(4701123962940007.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_TABLE_ERR_LOG_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4804282490918703.4001)
,p_name=>'compute profile col match count'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_TABLE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P1820_TARGET_TYPE").getValue() === "TABLE" &&',
'!apex.item("P1820_TABLE_NAME").isEmpty()'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4804365822918704.4001)
,p_event_id=>wwv_flow_api.id(4804282490918703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'into :P1820_PROFILE_COL_MATCH_CNT',
'from wwv_flow_data_profile_cols p, wwv_flow_table_columns_dev t',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and data_profile_id = :P1820_DATA_PROFILE_ID',
'and p.name = t.column_name',
'and owner = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'and table_name = :P1820_TABLE_NAME;'))
,p_attribute_02=>'P1820_TABLE_OWNER,P1820_TABLE_NAME,P1820_DATA_PROFILE_ID'
,p_attribute_03=>'P1820_PROFILE_COL_MATCH_CNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4805558988918716.4001)
,p_name=>'show no profile col match error'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_TABLE_NAME,P1820_PROFILE_COL_MATCH_CNT'
,p_condition_element=>'P1820_PROFILE_COL_MATCH_CNT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4805648152918717.4001)
,p_event_id=>wwv_flow_api.id(4805558988918716.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4804039483918701.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4805864336918719.4001)
,p_event_id=>wwv_flow_api.id(4805558988918716.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4804039483918701.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(691709681702978123.4001)
,p_name=>'Edit Data Profile'
,p_event_sequence=>120
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(494860436524911651.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(691709780126978124.4001)
,p_event_id=>wwv_flow_api.id(691709681702978123.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(494860436524911651.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2563778350654035.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete data profile'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_data_profiles',
'where id = :P1820_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1505506467216610.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1526209123234218.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(687682638763131719.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Data Load Definition'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE, DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1507948497216628.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1801'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1505506467216610.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2102883628346926.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Data Load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.refresh_data_load (',
'    p_data_load_id => :P1820_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3510049858217959.4001)
,p_process_success_message=>unistr('Se ha refrescado la suscripci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2102943246346927.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe Data Load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.unsubscribe_data_load(',
'    p_data_load_id => :P1820_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3510368465219185.4001)
,p_process_when=>'P1820_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>unistr('Se ha anulado la suscripci\00F3n de la carga de datos.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1805877755557138.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(687682638763131719.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Data Load'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4701813134940014.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set non-dml item values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_data_load in (',
'    select target_type,',
'           loading_method,',
'           error_handling,',
'           error_collection_name',
'    from wwv_flow_load_tables',
'    where id = :P1820_ID',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'loop',
'    if l_data_load.target_type = ''TABLE'' and l_data_load.error_handling = ''ERROR_LOG'' then',
'        :P1820_TABLE_ERR_LOG_NAME := l_data_load.error_collection_name;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1820_ERROR_HANDLING'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ERROR_LOG'
);
end;
/
prompt --application/pages/page_01821
begin
wwv_flow_api.create_page(
 p_id=>1821.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Utilizaci\00F3n de carga de datos')
,p_alias=>'DATA-LOAD-UTILIZATION'
,p_step_title=>unistr('Utilizaci\00F3n de carga de datos')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(1449603451873552)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2101165717346909.4001)
,p_plug_name=>unistr('Utilizaci\00F3n de carga de datos')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    d.id,',
'    d.name data_load_name,',
'    pr.process_name,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) page_target,',
'    p.id page_id,',
'    p.name page_name',
'from wwv_flow_steps p,',
'     wwv_flow_step_processing pr,',
'     wwv_flow_load_tables d',
'where p.id = pr.flow_step_id',
'  and p.flow_id = pr.flow_id',
'  and d.flow_id = p.flow_id',
'  and d.id = pr.attribute_01',
'  and p.flow_id = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id',
'  and pr.process_type = ''NATIVE_DATA_LOADING''',
'  and d.data_profile_id is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Utilizaci\00F3n de carga de datos')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2101269384346910.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('Las definiciones de carga de datos NO se utilizan en la aplicaci\00F3n.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>2101269384346910
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2101393918346911.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2101446231346912.4001)
,p_db_column_name=>'DATA_LOAD_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nombre de carga de datos'
,p_column_link=>'f?p=&APP_ID.:1820:&SESSION.::&DEBUG.:1820:P1820_ID:#ID#'
,p_column_linktext=>'#DATA_LOAD_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2101680699346914.4001)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Nombre del Proceso'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2101794737346915.4001)
,p_db_column_name=>'PAGE_TARGET'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>unistr('Destino de p\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2101889920346916.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2101958264346917.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_link=>'#PAGE_TARGET#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2102040646346918.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestra d\00F3nde se utilizan las <strong>definiciones de carga de datos</strong> en la aplicaci\00F3n.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18038874165191067.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(15132926917246073.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_01901
begin
wwv_flow_api.create_page(
 p_id=>1901.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Or\00EDgenes de Datos de REST')
,p_step_title=>unistr('Or\00EDgenes de Datos de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3290535781489430.4001)
,p_plug_name=>unistr('Or\00EDgenes de Datos de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.name,',
'       m.name as name_link,',
'       rtrim(r.base_url,''/'') || ''/'' || ltrim(m.url_path_prefix, ''/'') as endpoint_url,',
'       count( o.id )                                                 as operations_count,',
'       case when m.credential_id is not null then ''Y'' else ''N'' end   as authentication_required,',
'       r.name                                                        as remote_server_name,',
'       ''icon-sc-web-services''                                        as icon_class_name,',
'       wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':1921:'' || :APP_SESSION || ''::::P1921_WEB_SRC_MODULE_ID:'' || m.id ) as link,',
'       case when m.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_web_src_modules',
'                         where id                = m.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_web_src_modules',
'          where reference_id      = m.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       m.last_updated_on updated,',
'       wwv_flow_lang.system_message( case when m.sync_table_name is not null then ''YES'' else ''NO'' end ) as is_synchronized',
'  from wwv_flow_web_src_modules m,',
'       wwv_flow_web_src_operations o,',
'       wwv_remote_servers r',
' where o.web_src_module_id (+) = m.id',
'   and m.remote_server_id      = r.id',
'   and m.flow_id               = v(''FB_FLOW_ID'')',
' group by m.id, m.name, m.credential_id, r.name, r.base_url, m.url_path_prefix, m.reference_id, m.last_updated_on, m.sync_table_name',
'      '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3290607658489431.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No hay ning\00FAn origen de datos de REST definido en esta aplicaci\00F3n.')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon icon-sc-web-service"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>6
,p_owner=>'ADMIN'
,p_internal_uid=>3290607658489431
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3290785910489432.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(236246600064284201.4001)
,p_db_column_name=>'NAME_LINK'
,p_display_order=>20
,p_column_identifier=>'I'
,p_column_label=>'Nombre de origen de REST'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#NAME_LINK#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3290879918489433.4001)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3290912419489434.4001)
,p_db_column_name=>'OPERATIONS_COUNT'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Operaciones'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3291066768489435.4001)
,p_db_column_name=>'AUTHENTICATION_REQUIRED'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>unistr('Autenticaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3291121378489436.4001)
,p_db_column_name=>'REMOTE_SERVER_NAME'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Nombre de servidor remoto'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3291251817489437.4001)
,p_db_column_name=>'ENDPOINT_URL'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'URL de Punto Final'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3291329775489438.4001)
,p_db_column_name=>'ICON_CLASS_NAME'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Nombre de clase de icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3291442427489439.4001)
,p_db_column_name=>'LINK'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247726827518524634.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247726933892524635.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(719521727236310517.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546917247163857725.4001)
,p_db_column_name=>'IS_SYNCHRONIZED'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Sincronizado'
,p_column_link=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.::P1951_WEB_SRC_MODULE_ID:#ID#'
,p_column_linktext=>'#IS_SYNCHRONIZED#'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(241339500601308306.4001)
,p_plug_name=>unistr('Or\00EDgenes de Datos de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los <strong>or\00EDgenes de datos de REST</strong> act\00FAan como una referencia a uno o varios servicios web externos (REST). Un <strong>origen de datos de REST</strong> puede contener una o varias <strong>operaciones</strong> que son las referencias a ')
||'un servicio web externo concreto. Las configuraciones en el nivel de origen de REST se comparten en todas las operaciones que contiene.',
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(241339699794308307.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(241353531173849237.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1112588947745742893.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/managing-REST-data-sources.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529221957637107539.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3290535781489430.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1904:&SESSION.::&DEBUG.:RP,1904::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3291561610489440.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3290535781489430.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:RP,1941,1942,1943,1944,1946,1905::'
,p_icon_css_classes=>'i icon-right-chevron'
);
end;
/
prompt --application/pages/page_01902
begin
wwv_flow_api.create_page(
 p_id=>1902.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso'
,p_step_title=>'Uso'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(244646616245363335.4001)
,p_plug_name=>unistr('Or\00EDgenes de Datos de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'm.id,',
'wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||r.page_id) the_page, ''#'' the_shared_component, ',
'     r.page_id, p.name page_name,  r.plug_name, r.plug_source_type, m.name module_name',
'from wwv_flow_page_plugs r,',
'     wwv_flow_steps p,',
'     wwv_flow_web_src_modules m',
'where m.id = r.web_src_module_id',
'  and r.page_id = p.id',
'  and r.flow_id = p.flow_id',
'  and m.flow_id = p.flow_id',
'  and p.flow_id = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id',
'union all (',
'select  ',
'm.id,',
'wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||r.page_id) the_page, ''#'' the_shared_component,',
'     r.page_id, p.name page_name, r.plug_name || '' - '' || s.name plug_name, r.plug_source_type, m.name module_name',
'from wwv_flow_jet_chart_series s,',
'     wwv_flow_jet_charts c,',
'     wwv_flow_page_plugs r,',
'     wwv_flow_steps p,',
'     wwv_flow_web_src_modules m',
'where m.id        = s.web_src_module_id',
'  and m.flow_id   = p.flow_id',
'  --',
'  and s.chart_id  = c.id',
'  and c.region_id = r.id',
'  --',
'  and r.page_id   = p.id',
'  and r.flow_id   = p.flow_id',
'  --',
'  and p.flow_id           = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id )',
'union all (',
'select  ',
'm.id,',
'wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||r.page_id) the_page, ''#'' the_shared_component,',
'     r.page_id, p.name page_name, r.plug_name || '' - '' || l.name plug_name, r.plug_source_type, m.name module_name',
'from wwv_flow_map_region_layers l,',
'     wwv_flow_map_regions ma,',
'     wwv_flow_page_plugs r,',
'     wwv_flow_steps p,',
'     wwv_flow_web_src_modules m',
'where m.id                = l.web_src_module_id',
'  and m.flow_id           = p.flow_id',
'  --',
'  and l.map_region_id     = ma.id',
'  and ma.region_id        = r.id',
'  --',
'  and r.page_id           = p.id',
'  and r.flow_id           = p.flow_id',
'  --',
'  and p.flow_id           = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id )',
'union all (',
'select  ',
'm.id,''#'' the_page,',
'wwv_flow_utilities.prepare_url(''f?p=4000:4111:''||:flow_session||'':::4111:F4000_P4111_ID:''||r.id) the_shared_component, ',
'     null page_id, null  page_name,  lov_name plug_name, wwv_flow_lang.system_message(''SHARED DYNAMIC LOV'') plug_source_type, m.name module_name',
'from wwv_flow_lists_of_values$ r,',
'     wwv_flow_web_src_modules m',
'where m.id                = r.web_src_module_id',
'  and m.security_group_id = :flow_security_group_id',
'  and m.flow_id           = r.flow_id',
'  and m.flow_id           = :fb_flow_id )',
'union all (',
'select  ',
'm.id,''#'' the_page,',
'wwv_flow_utilities.prepare_url(''f?p=4000:7021:''||:flow_session||'':::7021:P7021_ID:''||a.id) the_shared_component,  ',
'     null page_id, null  page_name,  a.name plug_name, wwv_flow_lang.system_message(''AUTOMATIONS'') plug_source_type, m.name module_name',
'from wwv_flow_automations a,',
'     wwv_flow_web_src_modules m',
'where m.id                = a.web_src_module_id',
'  and m.security_group_id = :flow_security_group_id',
'  and m.flow_id           = a.flow_id',
'  and m.flow_id           = :fb_flow_id )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(244646688122363336.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No se han encontrado utilizaciones del origen de datos de REST.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>244646688122363336
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241356732342873944.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241339714716308308.4001)
,p_db_column_name=>'THE_PAGE'
,p_display_order=>20
,p_column_identifier=>'J'
,p_column_label=>unistr('La p\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241340112476308312.4001)
,p_db_column_name=>'MODULE_NAME'
,p_display_order=>30
,p_column_identifier=>'N'
,p_column_label=>'Origen de Datos de REST'
,p_column_link=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP:P1921_WEB_SRC_MODULE_ID:#ID#'
,p_column_linktext=>'#MODULE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241340092009308311.4001)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>60
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_link=>'#THE_SHARED_COMPONENT#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241340200546308313.4001)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>70
,p_column_identifier=>'O'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(538211928069052506)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241339884405308309.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>80
,p_column_identifier=>'K'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(241339940558308310.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>90
,p_column_identifier=>'L'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_link=>'#THE_PAGE#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(90115588907448604.4001)
,p_db_column_name=>'THE_SHARED_COMPONENT'
,p_display_order=>100
,p_column_identifier=>'P'
,p_column_label=>'El componente compartido'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(482695581065182211.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra d\00F3nde se utilizan <strong>or\00EDgenes de datos de REST</strong> en la aplicaci\00F3n.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(482695780258182212.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(241353531173849237.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_01903
begin
wwv_flow_api.create_page(
 p_id=>1903.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial'
,p_step_title=>'Historial'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492434589593706643.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_WEB_SRC_MODULES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492434661470706644.4001)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>492434661470706644
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727080561524636.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>10
,p_column_identifier=>'P'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727143136524637.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'Q'
,p_column_label=>unistr('Fecha de auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727210680524638.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'R'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727390643524639.4001)
,p_db_column_name=>'SCN'
,p_display_order=>40
,p_column_identifier=>'S'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727425025524640.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>50
,p_column_identifier=>'T'
,p_column_label=>unistr('Comentario de auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727588179524641.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>60
,p_column_identifier=>'U'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247727684741524642.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>70
,p_column_identifier=>'V'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(730483554413525519.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en los or\00EDgenes de datos de REST de esta aplicaci\00F3n.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(730483753606525520.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(241353531173849237.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_01904
begin
wwv_flow_api.create_page(
 p_id=>1904.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Copiar origen de datos de REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Copiar origen de datos de REST'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529220070888107520.4001)
,p_plug_name=>'Copiar origen de datos de REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(529222064541107540.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529221216685107532.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(529222064541107540.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529221325191107533.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(529222064541107540.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(529222372081107543.4001)
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP:P1921_WEB_SRC_MODULE_ID:&P1904_NEW_WEB_SOURCE_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161025011203385212.4001)
,p_name=>'P1904_NEW_WEB_SOURCE_STATIC_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(529220070888107520.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529220132877107521.4001)
,p_name=>'P1904_WEB_SOURCE_MODULE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(529220070888107520.4001)
,p_prompt=>'Copiar origen de datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id as r',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar origen de datos de REST existente -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529221188532107531.4001)
,p_name=>'P1904_NEW_WEB_SOURCE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(529220070888107520.4001)
,p_prompt=>'Nombre de origen de datos de REST nuevo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529222291853107542.4001)
,p_name=>'P1904_NEW_WEB_SOURCE_MODULE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(529220070888107520.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(161025123717385213.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1904_NEW_WEB_SOURCE_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'regexp_replace( :P1904_NEW_WEB_SOURCE_NAME, ''[^a-zA-Z0-9]'', ''_'' )',
''))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(161024959158385211.4001)
,p_validation_name=>'Module name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_web_src_modules',
' where flow_id = :FB_FLOW_ID',
'   and name = :P1904_NEW_WEB_SOURCE_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Este nombre ya lo est\00E1 utilizando otro origen de datos de REST.')
,p_when_button_pressed=>wwv_flow_api.id(529221216685107532.4001)
,p_associated_item=>wwv_flow_api.id(529221188532107531.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(161025215689385214.4001)
,p_validation_name=>'Module Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_web_src_modules',
' where flow_id = :FB_FLOW_ID',
'   and static_id = :P1904_NEW_WEB_SOURCE_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El ID est\00E1tico "&P1904_NEW_WEB_SOURCE_STATIC_ID." (derivado del nombre de m\00F3dulo) ya est\00E1 en uso por otro origen de datos de REST. Elija otro nombre.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_web_src_modules',
' where flow_id = :FB_FLOW_ID',
'   and name = :P1904_NEW_WEB_SOURCE_NAME'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_api.id(529221216685107532.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(529221475979107534.4001)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(529221325191107533.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(529221593174107535.4001)
,p_event_id=>wwv_flow_api.id(529221475979107534.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(529222160982107541.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name wwv_flow_web_src_modules.name%type;',
'    l_new_id wwv_flow_web_src_modules.id%type;',
'begin',
'    select name ',
'      into l_name',
'      from wwv_flow_web_src_modules',
'     where id                = :P1904_WEB_SOURCE_MODULE_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'',
'    l_new_id := wwv_flow_web_src_dev.copy_web_src_module(',
'        p_from_application_id => :FB_FLOW_ID,',
'        p_name                => l_name,',
'        p_to_application_id   => :FB_FLOW_ID,',
'        p_to_name             => :P1904_NEW_WEB_SOURCE_NAME,',
'        p_subscribe           => false);',
'   ',
'    :P1904_NEW_WEB_SOURCE_MODULE_ID := l_new_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(529221216685107532.4001)
,p_process_success_message=>'Se ha copiado el origen de datos de REST.'
);
end;
/
prompt --application/pages/page_01905
begin
wwv_flow_api.create_page(
 p_id=>1905.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: M\00E9todo')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: M\00E9todo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681773853744673868.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Al crear un nuevo origen de datos de REST, tiene dos opciones. Puede crear un nuevo origen de datos de REST desde el principio o reutilizar implantaciones que ya existan en la aplicaci\00F3n o en otras aplicaciones del espacio de trabajo.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681774533783673884.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(249385562937130742.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681774782569673884.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681775395139673890.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247672514274352485.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1681774782569673884.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247672912889352487.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1681774782569673884.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(247674088776352498.4001)
,p_branch_name=>'Go To Page 1906'
,p_branch_action=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247672912889352487.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1905_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(247674411405352498.4001)
,p_branch_name=>'Go To Page 1941'
,p_branch_action=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP,1941::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247672912889352487.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1905_ACTION'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28032815028072741.4001)
,p_branch_name=>'Go To Page 1908'
,p_branch_action=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.:RP,1908::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247672912889352487.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P1905_ACTION = ''CATALOG'' and :P1905_SINGLE_CATALOG_ID is null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1467580088002245.4001)
,p_branch_name=>'Go To Page 1911'
,p_branch_action=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:RP,1908,1911:P1911_SOURCE_ID,P1911_TYPE:&P1905_SINGLE_CATALOG_ID.,CATALOG'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247672912889352487.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P1905_ACTION = ''CATALOG'' and :P1905_SINGLE_CATALOG_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1467491143002244.4001)
,p_name=>'P1905_SINGLE_CATALOG_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1681773853744673868.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(247671152448352476.4001)
,p_name=>'P1905_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1681773853744673868.4001)
,p_item_default=>'CREATE'
,p_prompt=>'Crear origen de datos de REST:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1905_ACTIONS'
,p_lov=>'.'||wwv_flow_api.id(247678451096396264.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo mediante el cual desea crear el origen de datos de REST.')
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(247656983767093707.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(247672514274352485.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(247657093654093708.4001)
,p_event_id=>wwv_flow_api.id(247656983767093707.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4705533119428540.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Prepare to create from Catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name          varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'    l_first_catalog boolean      := true;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( l_name );',
'',
'    <<catalog_with_services_loop>>',
'    for i in (',
'        select c.id,',
'               count( s.id ) as services_count',
'          from wwv_web_src_catalogs c,',
'               wwv_web_src_catalog_services s',
'         where c.id                = s.catalog_id',
'           and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and c.security_group_id = s.security_group_id',
'         group by c.id )',
'    loop',
'        if l_first_catalog then',
'            :P1905_SINGLE_CATALOG_ID := i.id;',
'            l_first_catalog          := false;',
'        else ',
'            :P1905_SINGLE_CATALOG_ID := null;',
'            exit catalog_with_services_loop;',
'        end if;',
'    end loop catalog_with_services_loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(247672912889352487.4001)
,p_process_when=>'P1905_ACTION'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'CATALOG'
);
end;
/
prompt --application/pages/page_01906
begin
wwv_flow_api.create_page(
 p_id=>1906.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: Aplicaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681839970065775603.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para copiar un origen de datos de REST de otra aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681840688770775604.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(249385562937130742.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681840898431775604.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681841671482775606.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247684236544424706.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1681840898431775604.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247684634985424706.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1681840898431775604.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(247685776109424710.4001)
,p_branch_name=>'Go To Page 1907'
,p_branch_action=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247684236544424706.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(247686121964424710.4001)
,p_branch_name=>'Go To Page 1905'
,p_branch_action=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247684634985424706.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(247682301374424702.4001)
,p_name=>'P1906_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1681839970065775603.4001)
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||f.name as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_web_src_modules a',
'                 where a.flow_id = f.id',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n desde la que desea copiar los plugins.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_01907
begin
wwv_flow_api.create_page(
 p_id=>1907.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear origen de datos de REST: Copia'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear origen de datos de REST: Copia'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1588251353348673008.4001)
,p_name=>'Crear origen de datos de REST'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ROWID,',
'       id,',
'       name,',
'       case when reference_id is not null then ''Y'' else ''N'' end as is_subscribed,',
'       case',
'         when reference_id is null and :P1906_COPY_FROM = :FB_FLOW_ID then wwv_flow_lang.system_message( ''F4000.P158.COPY_OF'', name )',
'         else name',
'       end as new_name,',
'       case',
'         when :P1906_COPY_FROM = :FB_FLOW_ID then ''N''',
'         when reference_id is not null       then ''Y''',
'         else ''SUBSCRIBE''',
'       end as action',
'  from wwv_flow_web_src_modules a',
' where flow_id           = :P1906_COPY_FROM',
'   and security_group_id = :WORKSPACE_ID',
'   and (',
'       -- Don''t show subscribed REST Data Source, because they can''t be copied',
'          (   :P1906_COPY_FROM = :FB_FLOW_ID',
'          and reference_id is null',
'          )',
'       -- Don''t show REST Data Source ins which have already been copied from another application',
'       or (   :P1906_COPY_FROM <> :FB_FLOW_ID',
'          and not exists ( select 1',
'                             from wwv_flow_web_src_modules b',
'                            where b.flow_id           = :FB_FLOW_ID',
'                              and b.security_group_id = :WORKSPACE_ID',
'                              and b.name              = a.name',
'                         )',
'          )',
'       )',
' order by name',
''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique el origen de datos de REST para copiar y seleccione la opci\00F3n de copia. Las opciones de copia incluyen:</p>'),
'<ul>',
unistr('    <li><strong>S\00ED</strong>. Copiar el origen de datos de REST.</li>'),
'    <li><strong>No</strong>. No copiar el origen de datos de REST.</li>',
unistr('    <li><strong>Copiar y suscribir</strong>. La suscripci\00F3n al origen de datos de REST coloca una copia en su aplicaci\00F3n y define la referencia maestra del origen de datos de REST.</li>'),
'</ul>',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161025749003385219.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(247724961632524615.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(247725572553524621.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(247725234313524618.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>4
,p_column_heading=>'Suscrito'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(247725613315524622.4001)
,p_query_column_id=>5
,p_column_alias=>'NEW_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'A Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(247725472450524620.4001)
,p_query_column_id=>6
,p_column_alias=>'ACTION'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(247782857688295098)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1588253035120673025.4001)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(1588251353348673008.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681855286682850105.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(249385562937130742.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681855469959850106.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1681856251746850108.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247699430129474724.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1681855469959850106.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar or\00EDgenes de datos de REST')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247699828884474724.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1681855469959850106.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247698055269474721.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1681855469959850106.4001)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular la Selecci\00F3n de Todo')
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(247701814528474726.4001)
,p_branch_name=>'Go To Page 1901'
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(247702256077474726.4001)
,p_branch_name=>'Go To Page 1906'
,p_branch_action=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(247699828884474724.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(161025581910385217.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(1588251353348673008.4001)
,p_validation_name=>'Module Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_web_src_modules',
' where name = :NEW_NAME and :ACTION in (''Y'', ''SUBSCRIBE'')',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Este nombre ya lo est\00E1 utilizando un origen de datos de REST ya existente.')
,p_when_button_pressed=>wwv_flow_api.id(247699430129474724.4001)
,p_only_for_changed_rows=>'N'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(161025995961385221.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(1588251353348673008.4001)
,p_validation_name=>'Module Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_web_src_modules',
' where static_id = regexp_replace( :NEW_NAME, ''[^a-zA-Z0-9]'', ''_'' ) and :ACTION in (''Y'', ''SUBSCRIBE'')',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El ID est\00E1tico "&NEW_NAME." (derivado del nombre de origen de datos de REST) ya est\00E1 en uso por otro origen de datos de REST. Elija otro nombre.')
,p_when_button_pressed=>wwv_flow_api.id(247699430129474724.4001)
,p_only_for_changed_rows=>'N'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(247725702391524623.4001)
,p_name=>'Deselect All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(247698055269474721.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(247725886042524624.4001)
,p_event_id=>wwv_flow_api.id(247725702391524623.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'td[headers=ACTION] select'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(247697323436474718.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(1588251353348673008.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy REST Data Sources'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name wwv_flow_web_src_modules.name%type;',
'    l_id   number;',
'begin',
'    if :ACTION in (''Y'', ''SUBSCRIBE'') then',
'        select name ',
'          into l_name',
'          from wwv_flow_web_src_modules',
'         where flow_id           = :P1906_COPY_FROM',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'           and id                = :ID;',
'           ',
'        l_id := wwv_flow_web_src_dev.copy_web_src_module (',
'            p_from_application_id => :P1906_COPY_FROM,',
'            p_name                => l_name,',
'            p_to_application_id   => :FB_FLOW_ID,',
'            p_to_name             => :NEW_NAME,',
'            p_subscribe           => ( :ACTION = ''SUBSCRIBE'' ));',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(247699430129474724.4001)
,p_only_for_changed_rows=>'N'
,p_process_success_message=>unistr('Se han copiado los or\00EDgenes de datos de REST.')
);
end;
/
prompt --application/pages/page_01908
begin
wwv_flow_api.create_page(
 p_id=>1908.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: Cat\00E1logo')
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: Cat\00E1logo')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/font-apex/2.2/css/font-apex.min.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-CardView-icon.fa, .a-CardView-icon.fa.fa-lg, .a-CardView-icon.a-Icon {font-size: 32px}',
'.a-CardView-icon {padding:0}',
'.a-CardView-body {padding-top:0}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28033106525072744.4001)
,p_plug_name=>unistr('Cat\00E1logos de origen de REST')
,p_region_name=>'icons'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_span=>9
,p_plug_display_column=>2
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''CATALOG''                     as source_type,',
'       g.id                          as group_id, ',
'       g.name                        as group_name, ',
'       c.id                          as source_id, ',
'       c.name                        as catalog_name, ',
'       substr(c.description, 1, 200) as catalog_description, ',
'       c.version, ',
'       count(s.id)                   as service_count',
'  from WWV_WEB_SRC_CATALOG_GROUPS g,',
'       WWV_WEB_SRC_CATALOGS       c,',
'       wwv_web_src_catalog_services s',
' where c.security_group_id = g.security_group_id',
'   and s.security_group_id = g.security_group_id',
'   and s.catalog_id        = c.id',
'   and c.catalog_group_id  = g.id',
'   and g.security_group_id = :WORKSPACE_ID',
' group by g.id,',
'          g.name, ',
'          c.id, ',
'          c.name, ',
'          c.description, ',
'          c.version',
' '))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_api.create_card(
 p_id=>wwv_flow_api.id(28033258362072745.4001)
,p_region_id=>wwv_flow_api.id(28033106525072744.4001)
,p_layout_type=>'GRID'
,p_component_css_classes=>'a-FA-cards'
,p_title_adv_formatting=>false
,p_title_column_name=>'CATALOG_NAME'
,p_sub_title_adv_formatting=>true
,p_sub_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>&GROUP_NAME.</strong>',
'<br>',
'<br>',
'{case SERVICE_COUNT/}',
'{when 0/}',
'No contiene servicios.',
'{when 1/}',
'Contiene 1 servicio.',
'{otherwise/}',
'Contiene &SERVICE_COUNT. servicios.',
'{endcase/}',
''))
,p_body_adv_formatting=>false
,p_body_column_name=>'CATALOG_DESCRIPTION'
,p_second_body_adv_formatting=>false
,p_badge_column_name=>'VERSION'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'SOURCE_ID'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(28033486619072747.4001)
,p_card_id=>wwv_flow_api.id(28033258362072745.4001)
,p_action_type=>'TITLE'
,p_display_sequence=>20
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:1911:P1911_SOURCE_ID,P1911_TYPE:&SOURCE_ID.,&SOURCE_TYPE.'
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(6176128763901812.4001)
,p_card_id=>wwv_flow_api.id(28033258362072745.4001)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>30
,p_label=>'Agregar Todo '
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1910:&SESSION.:SELECT_ALL:&DEBUG.::P1910_SOURCE_ID,P1910_TYPE:&SOURCE_ID.,&SOURCE_TYPE.'
,p_button_display_type=>'TEXT'
,p_is_hot=>false
);
wwv_flow_api.create_card_action(
 p_id=>wwv_flow_api.id(4004069838287608.4001)
,p_card_id=>wwv_flow_api.id(28033258362072745.4001)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>40
,p_label=>'Examinar'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:1911:P1911_SOURCE_ID,P1911_TYPE:&SOURCE_ID.,&SOURCE_TYPE.'
,p_button_display_type=>'TEXT'
,p_is_hot=>true
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1686174764143052945.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(249385562937130742.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1686252753195997266.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4412518378221665.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1686252753195997266.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
end;
/
prompt --application/pages/page_01909
begin
wwv_flow_api.create_page(
 p_id=>1909.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: Servicios de cat\00E1logo')
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG-SERVICES'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: Servicios de cat\00E1logo')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/pages/page_01910
begin
wwv_flow_api.create_page(
 p_id=>1910.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: Detalles de cat\00E1logo')
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: Detalles de cat\00E1logo')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/font-apex/2.2/css/font-apex.min.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-CardView-icon.fa, .a-CardView-icon.fa.fa-lg, .a-CardView-icon.a-Icon {font-size: 32px}',
'.a-CardView-icon {padding:0}',
'.a-CardView-body {padding-top:0}'))
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1926927304132410.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalog_services cs,',
'       wwv_flow_collections         so',
' where cs.id                = so.n001',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and cs.authentication_type is not null',
'   and so.collection_name   = ''REST_CATALOG_SELECTIONS''',
'   and so.c002              = ''CATALOG'''))
,p_plug_header=>unistr('<p>Algunos de los servicios de cat\00E1logo seleccionados necesitan autenticaci\00F3n. Seleccione una <strong>credencial web</strong> existente o cree una con &PRODUCT_NAME.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4007469840287642.4001)
,p_name=>unistr('Revisar servicios de cat\00E1logo seleccionados')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( cs.details_json,',
'                       ''$.operations[*]''',
'                       columns ( operation  varchar2(255) path ''$.operation'' ) ) op',
'    where cs.security_group_id = :WORKSPACE_ID',
'      and cs.id in (',
'                     select c.n001 as id',
'                       from wwv_flow_collections c',
'                      where collection_name = ''REST_CATALOG_SELECTIONS''',
'                        and c.c002          = ''CATALOG'' )',
'                      group by cs.id',
')',
'select null as cb, ',
'       cs.catalog_id, ',
'       cs.id, ',
'       cs.name, ',
'       cs.icon, ',
'       substr(cs.description, 1, 200) || case when length(cs.description) > 200 then ''...'' else null end as description,',
'       cs.version,',
'       wwv_flow_lang.runtime_message( ''WEB.SOURCE.SERVICE_FROM_CATALOG'' ) as link_title,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')    || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')   || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as operations_html',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so',
' where so.id                = cs.id',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_api.id(4900642989550776.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4007522253287643.4001)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>10
,p_column_heading=>'Cb'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4007625220287644.4001)
,p_query_column_id=>2
,p_column_alias=>'CATALOG_ID'
,p_column_display_sequence=>20
,p_column_heading=>unistr('ID de cat\00E1logo')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4007777652287645.4001)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>30
,p_column_heading=>'Identificador'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4007820421287646.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4007914294287647.4001)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_column_heading=>'Icono'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4008021812287648.4001)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>60
,p_column_heading=>unistr('Descripci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4008190566287649.4001)
,p_query_column_id=>7
,p_column_alias=>'VERSION'
,p_column_display_sequence=>70
,p_column_heading=>unistr('Versi\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2600195888934101.4001)
,p_query_column_id=>8
,p_column_alias=>'LINK_TITLE'
,p_column_display_sequence=>90
,p_column_heading=>unistr('T\00EDtulo de Enlace')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4008210715287650.4001)
,p_query_column_id=>9
,p_column_alias=>'OPERATIONS_HTML'
,p_column_display_sequence=>80
,p_column_heading=>'Operaciones Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1688230994460735294.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(249385562937130742.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1690861990302251926.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4609573941254660.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1690861990302251926.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear or\00EDgenes de datos de REST')
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4609984718254661.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1690861990302251926.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(6176618035901817.4001)
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6176315851901814.4001)
,p_name=>'P1910_SOURCE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1690861990302251926.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'The Source ID and Catalog Type will only be used if the developer choose Select All on Page 1908. If the developer choose specific services from different applications/catalogs then the type really has no purpose because the items will already be inc'
||'luded in the collection.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6176446254901815.4001)
,p_name=>'P1910_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1690861990302251926.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'The Source ID and Catalog Type will only be used if the developer choose Select All on Page 1908. If the developer choose specific services from different applications/catalogs then the type really has no purpose because the items will already be inc'
||'luded in the collection.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6814528733316805.4001)
,p_name=>'P1910_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1926927304132410.4001)
,p_prompt=>'Credencial web'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Crear nuevo -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una credencial web existente para el origen de datos de REST. Se crear\00E1 una nueva credencial web si uno de los servicios de cat\00E1logo necesita autenticaci\00F3n y no se ha seleccionado un valor existente.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6176534622901816.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create REST from Catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_installed_plugins           wwv_flow_t_varchar2;',
'begin',
'    for c in ( ',
'        select c.n001 as id, ',
'               c.c002 as source_type, ',
'               c.n003 as source_id, ',
'               m.name as service_name, ',
'               l.name as catalog_name',
'          from wwv_flow_collections         c,',
'               wwv_web_src_catalog_services m,',
'               wwv_web_src_catalogs         l',
'         where c.n001              = m.id',
'           and m.catalog_id        = l.id',
'           and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and l.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and c.collection_name   = ''REST_CATALOG_SELECTIONS''',
'           and c.c002              = ''CATALOG'' ) ',
'    loop',
'        if c.source_type = ''CATALOG'' then ',
'            wwv_web_src_catalog.rest_source_from_catalog(',
'                p_catalog_id                  => c.source_id,',
'                p_service_id                  => c.id,',
'                p_application_id              => :FB_FLOW_ID,',
'                p_rest_source_name            => c.service_name,',
'                p_credential_id               => :P1910_CREDENTIAL_ID,',
'                p_installed_plugins           => l_installed_plugins  );',
'        end if;',
'    end loop;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4609573941254660.4001)
,p_process_success_message=>unistr('Los or\00EDgenes de datos de REST se han creado correctamente.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6176279155901813.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Select All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if select all was chosen on the Catalog/Application page (1908) ',
'-- then assume that the user wants only the services chosen and ',
'-- not any others that may have been in the cart. Perhaps this is a bad assumption',
'-- but that is what I''m going with. :-D ',
'declare',
'    l_name varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'begin',
'    -- truncate the collection',
'    APEX_COLLECTION.CREATE_OR_TRUNCATE_COLLECTION(l_name);',
'',
'    if :P1910_TYPE = ''CATALOG'' then ',
'        -- loop over the application or catalog and add all of the services to the collection',
'        for c in (',
'            select :P1910_SOURCE_ID as catalog_id, ',
'                s.id,',
'                s.name',
'            from wwv_web_src_catalog_services s',
'            join wwv_web_src_catalogs c on (c.id = s.catalog_id)',
'            where c.security_group_id = :WORKSPACE_ID',
'            and c.id                = :P1910_SOURCE_ID            ',
'        ) loop',
'            -- since the collection was just truncated, don''t worry about checking for duplicates.',
'            -- maybe I should also have an action???   ',
'            apex_collection.add_member(',
'                p_collection_name => l_name,',
'                p_n001 => c.id,              -- ID: the REST_MODULE_ID or CATALOG_SERVICE_ID  ',
'                p_c002 => :P1910_TYPE,       -- SOURCE_TYPE: either ''APPLICATION'' or ''CATALOG''',
'                p_n003 => :P1910_SOURCE_ID   -- SOURCE_ID: the APPLICATION_ID or CATALOG_ID',
'                );',
'        end loop;',
'    else',
'        -- loop over the application or catalog and add all of the services to the collection',
'        for c in (',
'            select :P1909_SOURCE_ID as flow_id, ',
'                m.id,',
'                m.name',
'            from wwv_flow_web_src_modules m',
'            where m.flow_id         = :P1910_SOURCE_ID',
'            and m.security_group_id = :WORKSPACE_ID',
'            order by m.name      ',
'        ) loop',
'            -- since the collection was just truncated, don''t worry about checking for duplicates.',
'            -- maybe I should also have an action???   ',
'            apex_collection.add_member(',
'                p_collection_name => l_name,',
'                p_n001 => c.id,              -- ID: the REST_MODULE_ID or CATALOG_SERVICE_ID  ',
'                p_c002 => :P1910_TYPE,       -- SOURCE_TYPE: either ''APPLICATION'' or ''CATALOG''',
'                p_n003 => :P1910_SOURCE_ID   -- SOURCE_ID: the APPLICATION_ID or CATALOG_ID',
'                );',
'        end loop;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SELECT_ALL'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_01911
begin
wwv_flow_api.create_page(
 p_id=>1911.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: Servicios de cat\00E1logo')
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG-SERVICES1'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: Servicios de cat\00E1logo')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/font-apex/2.2/css/font-apex.min.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.apex-col-6:last-child {border-left:1px solid #403C38}',
'.a-FS-search {border-bottom:0}',
'.a-Region .a-Region-title  {line-height:32px}',
''))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4703569920428520.4001)
,p_plug_name=>'Contenedor Izquierdo '
,p_region_name=>'P1911_LEFT_COL'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174793821995076649.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_span=>6
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5162137573346398.4001)
,p_name=>unistr('Resultados de la B\00FAsqueda')
,p_region_name=>'P1911_RESULTS'
,p_parent_plug_id=>wwv_flow_api.id(4703569920428520.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ ',
'           cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( cs.details_json,',
'                       ''$.operations[*]''',
'                       columns ( operation varchar2(255) path ''$.operation'' ) ) op',
'     where cs.catalog_id        = :P1911_SOURCE_ID     ',
'       and cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by cs.id)',
'select cs.catalog_id, ',
'       cs.id, ',
'       cs.name, ',
'       cs.icon, ',
'       substr(cs.description, 1, 200) || case when length(cs.description) > 200 then ''...'' else null end as description,',
'       cs.version,',
'       wwv_flow_lang.runtime_message( ''WEB.SOURCE.ADD_FROM_CATALOG'' ) as link_title,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')    || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')   || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as operations_html, ',
'       ''fa-plus'' as icon_class -- used by the report to determine what icon to show ',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so',
' where so.id               = cs.id',
'   and cs.catalog_id       = :P1911_SOURCE_ID     ',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and not exists (',
'                    select null ',
'                      from wwv_flow_collections c',
'                     where collection_name = ''REST_CATALOG_SELECTIONS''',
'                       and c.c002          = ''CATALOG''',
'                       and c.n001          = cs.id ) ',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(4900642989550776.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No hay servicios que seleccionar'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4004943022287617.4001)
,p_query_column_id=>1
,p_column_alias=>'CATALOG_ID'
,p_column_display_sequence=>40
,p_column_heading=>unistr('ID de cat\00E1logo')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5164163458346407.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5164548760346408.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005067896287618.4001)
,p_query_column_id=>4
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_column_heading=>'Icono'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005186018287619.4001)
,p_query_column_id=>5
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>60
,p_column_heading=>unistr('Descripci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005262517287620.4001)
,p_query_column_id=>6
,p_column_alias=>'VERSION'
,p_column_display_sequence=>70
,p_column_heading=>unistr('Versi\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1467936331002249.4001)
,p_query_column_id=>7
,p_column_alias=>'LINK_TITLE'
,p_column_display_sequence=>100
,p_column_heading=>unistr('T\00EDtulo de Enlace')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005372853287621.4001)
,p_query_column_id=>8
,p_column_alias=>'OPERATIONS_HTML'
,p_column_display_sequence=>80
,p_column_heading=>'Operaciones Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4006361019287631.4001)
,p_query_column_id=>9
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>90
,p_column_heading=>'Clase de Icono'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5162260383346398.4001)
,p_plug_name=>'Buscar'
,p_parent_plug_id=>wwv_flow_api.id(4703569920428520.4001)
,p_region_template_options=>'a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_api.id(5162137573346398.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'10000'
,p_attribute_13=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4703659840428521.4001)
,p_plug_name=>'Contenedor derecho'
,p_region_name=>'P1911_RIGHT_COL'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174793821995076649.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4005498207287622.4001)
,p_name=>unistr('Servicios de cat\00E1logo seleccionados')
,p_region_name=>'P1911_SELECTED'
,p_parent_plug_id=>wwv_flow_api.id(4703659840428521.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ ',
'           cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( cs.details_json,',
'                       ''$.operations[*]''',
'                       columns ( operation  varchar2(255) path ''$.operation'' ) ) op',
'     where cs.catalog_id        = :P1911_SOURCE_ID     ',
'       and cs.security_group_id = :WORKSPACE_ID',
'     group by cs.id',
'),',
'catalog_selections as (',
'    select c.n001 as id, ',
'           c.seq_id',
'      from wwv_flow_collections c',
'     where collection_name = ''REST_CATALOG_SELECTIONS''',
'       and c.c002          = ''CATALOG''',
')',
'select s.seq_id,',
'       cs.catalog_id, ',
'       cs.id, ',
'       cs.name, ',
'       cs.icon, ',
'       substr(cs.description, 1, 200) || case when length(cs.description) > 200 then ''...'' else null end as description,',
'       cs.version,',
'       wwv_flow_lang.runtime_message( ''WEB.SOURCE.UNADD_FROM_CATALOG'' ) as link_title,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')    || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')   || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as operations_html, ',
'       ''fa-remove'' as icon_class -- used by the report to determine what icon to show ',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so,',
'       catalog_selections           s',
' where so.id                = cs.id',
'   and s.id                 = cs.id',
'   and cs.security_group_id = :WORKSPACE_ID',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_api.id(4900642989550776.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha seleccionado ning\00FAn servicio.')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005507153287623.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Identificador de Secuencia'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005688202287624.4001)
,p_query_column_id=>2
,p_column_alias=>'CATALOG_ID'
,p_column_display_sequence=>20
,p_column_heading=>unistr('ID de cat\00E1logo')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005724426287625.4001)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>30
,p_column_heading=>'Identificador'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005869465287626.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4005983809287627.4001)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_column_heading=>'Icono'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4006060972287628.4001)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>60
,p_column_heading=>unistr('Descripci\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4006192809287629.4001)
,p_query_column_id=>7
,p_column_alias=>'VERSION'
,p_column_display_sequence=>70
,p_column_heading=>unistr('Versi\00F3n')
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1468060544002250.4001)
,p_query_column_id=>8
,p_column_alias=>'LINK_TITLE'
,p_column_display_sequence=>100
,p_column_heading=>unistr('T\00EDtulo de Enlace')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4006280777287630.4001)
,p_query_column_id=>9
,p_column_alias=>'OPERATIONS_HTML'
,p_column_display_sequence=>80
,p_column_heading=>'Operaciones Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4006440627287632.4001)
,p_query_column_id=>10
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>90
,p_column_heading=>'Clase de Icono'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1693231109379146639.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(249385562937130742.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1696025924545599580.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5165329416352612.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1696025924545599580.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5165773943352613.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1696025924545599580.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1465712347002227.4001)
,p_branch_action=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4006750780287635.4001)
,p_name=>'P1911_ACTION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1696025924545599580.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'Item used by dynamic actions to add or remove services from the selected list. The item is not Value Protected because JavaScript is used to set the value and send to the server for further processing. '
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5162771560346398.4001)
,p_name=>'P1911_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5162260383346398.4001)
,p_prompt=>'Buscar'
,p_source=>'NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>false
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_show_chart=>false
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5166147826352619.4001)
,p_name=>'P1911_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1696025924545599580.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'TYPE values should be CATALOG or APPLICATION. '
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5166508289352621.4001)
,p_name=>'P1911_SOURCE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1696025924545599580.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'The source id will either be an Application Id or a REST Catalog Id depending upon the type.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1465625664002226.4001)
,p_validation_name=>'Must have services selected to proceed'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    select 1',
'      from wwv_flow_collections c',
'     where collection_name = ''REST_CATALOG_SELECTIONS''',
'       and c.c002          = ''CATALOG'''))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Seleccione or\00EDgenes de REST del cat\00E1logo para continuar.')
,p_when_button_pressed=>wwv_flow_api.id(5165329416352612.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5004358735368697.4001)
,p_name=>'Add Service to Selected'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1911_LEFT_COL #P1911_RESULTS .a-ContentRowReport-itemWrap'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5006162837368732.4001)
,p_event_id=>wwv_flow_api.id(5004358735368697.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1911_ACTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.id.substring(8, this.triggeringElement.id.length);'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Use P1911_ACTION_ID to add the service to the collection. Same item used to remove a selected service.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5004749188368730.4001)
,p_event_id=>wwv_flow_api.id(5004358735368697.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_name   constant varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'    l_exists          number := 0;',
'begin',
'    -- if the collection does not exist then create it, should never happen',
'    if not wwv_flow_collection.collection_exists(c_name) then',
'        wwv_flow_collection.create_collection(c_name);',
'    end if;',
'',
'    -- add selected values to the collection',
'    -- do I need logic here to prevent duplicates? yes or I could just add a distinct to the cart query',
'    begin',
'        select 1 ',
'          into l_exists ',
'          from wwv_flow_collections c',
'         where collection_name = c_name',
'           and n001            = :P1911_ACTION_ID',
'           and rownum          = 1;',
'    exception',
'        when no_data_found then',
'            l_exists := 0;',
'    end;',
'',
'    if l_exists = 0 then ',
'        wwv_flow_collection.add_member(',
'            p_collection_name => c_name,',
'            p_n001            => :P1911_ACTION_ID, -- ID: the REST_MODULE_ID or CATALOG_SERVICE_ID  ',
'            p_c002            => :P1911_TYPE,       -- SOURCE_TYPE: either ''APPLICATION'' or ''CATALOG''',
'            p_n003            => :P1911_SOURCE_ID   -- SOURCE_ID: the APPLICATION_ID or CATALOG_ID',
'            );',
'    end if;',
'end;'))
,p_attribute_02=>'P1911_ACTION_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5005145702368731.4001)
,p_event_id=>wwv_flow_api.id(5004358735368697.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5162137573346398.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5005623005368731.4001)
,p_event_id=>wwv_flow_api.id(5004358735368697.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4005498207287622.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4006937351287637.4001)
,p_name=>'Remove Service from Selected'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1911_RIGHT_COL #P1911_SELECTED .a-ContentRowReport-itemWrap'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4007010027287638.4001)
,p_event_id=>wwv_flow_api.id(4006937351287637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1911_ACTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.id.substring(8, this.triggeringElement.id.length);'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Use P1911_ACTION_ID to remove the service to the collection. Same item used to add a selected service.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4007188202287639.4001)
,p_event_id=>wwv_flow_api.id(4006937351287637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    c_name   constant varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'    l_seq_id          number;',
'begin',
'    -- determine the seq_id of the collection member',
'    select c.seq_id',
'      into l_seq_id',
'      from wwv_flow_collections c',
'     where collection_name = c_name',
'       and c.n001           = :P1911_ACTION_ID',
'       and rownum           = 1;',
'',
'    -- :P1909_SEQ_ID gets set in the dynamic action javascript code',
'    -- remove the service from the collection using the sequence id',
'    wwv_flow_collection.delete_member (',
'        p_collection_name => c_name,',
'        p_seq             => l_seq_id);',
'exception',
'    when no_data_found then',
'        null; -- if the collection does not contain anything, there is also nothing to remove',
'end;'))
,p_attribute_02=>'P1911_ACTION_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4007228926287640.4001)
,p_event_id=>wwv_flow_api.id(4006937351287637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5162137573346398.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4007397123287641.4001)
,p_event_id=>wwv_flow_api.id(4006937351287637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4005498207287622.4001)
);
end;
/
prompt --application/pages/page_01921
begin
wwv_flow_api.create_page(
 p_id=>1921.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Origen de Datos de REST'
,p_step_title=>'Origen de Datos de REST'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1503302531184421.4001)
,p_plug_name=>unistr('Cat\00E1logo de origen de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalogs         c',
' where c.security_group_id = :WORKSPACE_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2600997936934109.4001)
,p_plug_name=>unistr('Ning\00FAn Cat\00E1logo')
,p_parent_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('Este origen de datos de REST no hace referencia a ning\00FAn cat\00E1logo de origen de REST.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1921_CATALOG_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(3291693434489441.4001)
,p_name=>'Operaciones'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id operation_id,',
'       o.operation,',
'       nullif(o.url_pattern, '' '') as url_pattern,',
'       o.database_operation,',
'       nullif((select count(id) ',
'         from wwv_flow_web_src_params p',
'        where p.web_src_module_id = m.id and web_src_operation_id = o.id',
'          and p.security_group_id = m.security_group_id ',
'          and p.flow_id           = m.flow_id ),0) as parameter_count,',
'       case when o.database_operation in ( ''FETCH_COLLECTION'' ) then',
'       ''<a href="'' ||',
'           wwv_flow_utilities.prepare_url(''f?p=4000:1927:'' || :APP_SESSION || ''::::P1922_ID,P1927_WEB_SRC_OPERATION_ID:'' || o.id || '','' || o.id ) ||',
'           ''" class="a-Button a-Button--noLabel a-Button--withIcon"><span class="a-Icon icon-test" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''apex.websrc.test_operation'')||''</span></a>''',
'       else ''&nbsp;'' end as display_test,',
'       case when m.web_source_type = ''NATIVE_ORDS'' and m.attribute_01 = ''Y'' and o.legacy_ords_fixed_page_size is null then ''<span style="color: red" title="'' || wwv_flow_lang.system_message(''apex.websrc.unknown_ords2_fixed_page_size'')||''" class="a-Ic'
||'on icon-error"></span>''',
'            when m.web_source_type = ''NATIVE_ORDS'' and m.attribute_01 = ''Y'' and o.legacy_ords_fixed_page_size < 50    then ''<span style="color: #FFCB3D" title="'' || wwv_flow_lang.system_message(''apex.websrc.small_ords2_fixed_page_size'')||''" class="a-'
||'Icon icon-warning"></span>''',
'            else null',
'       end as warning_icon_class',
'  from wwv_flow_web_src_operations o, wwv_flow_web_src_modules m',
' where m.id                = o.web_src_module_id',
'   and o.web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and o.flow_id           = :FB_FLOW_ID',
'   and m.flow_id           = o.flow_id',
'       ',
'   '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No hay operaciones definidas.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(117793904241505927.4001)
,p_query_column_id=>1
,p_column_alias=>'OPERATION_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP:P1922_ID:#OPERATION_ID#'
,p_column_linktext=>unistr('<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Editar operaci\00F3n</span>')
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3291802638489443.4001)
,p_query_column_id=>2
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Operaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#OPERATION# #WARNING_ICON_CLASS#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3292217489489447.4001)
,p_query_column_id=>3
,p_column_alias=>'URL_PATTERN'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Patr\00F3n de URL')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3291913060489444.4001)
,p_query_column_id=>4
,p_column_alias=>'DATABASE_OPERATION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Acci\00F3n de Base de Datos')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(225834585600778166)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(345457234158487513.4001)
,p_query_column_id=>5
,p_column_alias=>'PARAMETER_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Par\00E1metros')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242268834746871837.4001)
,p_query_column_id=>6
,p_column_alias=>'DISPLAY_TEST'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Operaci\00F3n de prueba')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(249280242462575816.4001)
,p_query_column_id=>7
,p_column_alias=>'WARNING_ICON_CLASS'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3292099913489445.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3467424016842409.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3467516310842410.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3469297412842427.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3469364086842428.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3802287696901511.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(4900739432788654.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Tareas'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5902041740682520.4001)
,p_plug_name=>unistr('Sincronizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1921_LOCAL_TABLE_NAME'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1373556285674225.4001)
,p_plug_name=>unistr('La tabla de sincronizaci\00F3n no coincide con el perfil de datos')
,p_parent_plug_id=>wwv_flow_api.id(5902041740682520.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('La sincronizaci\00F3n del origen de datos de REST est\00E1 activa, pero la tabla no coincide con el perfil de datos. Navegue hasta <strong>Gestionar sincronizaci\00F3n</strong> para obtener m\00E1s informaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1921_SYNC_LOCAL_TABLE_NAME is not null and :P1921_SYNC_STATUS in (',
'    wwv_flow_web_src_sync.c_columns_cannot_be_synced,',
'    wwv_flow_web_src_sync.c_columns_can_be_synced )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1373683531674226.4001)
,p_plug_name=>'Detalles'
,p_parent_plug_id=>wwv_flow_api.id(5902041740682520.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1373753236674227.4001)
,p_plug_name=>unistr('La tabla de sincronizaci\00F3n no existe')
,p_parent_plug_id=>wwv_flow_api.id(5902041740682520.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('La sincronizaci\00F3n del origen de datos de REST est\00E1 activa, pero la tabla no existe. Navegue hasta <strong>Gestionar sincronizaci\00F3n</strong> para obtener m\00E1s informaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1921_SYNC_LOCAL_TABLE_NAME is not null and :P1921_SYNC_STATUS = wwv_flow_web_src_sync.c_table_does_not_exist'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1855034187679335708.4001)
,p_plug_name=>unistr('La operaci\00F3n de recuperaci\00F3n de filas no existe')
,p_parent_plug_id=>wwv_flow_api.id(5902041740682520.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('La sincronizaci\00F3n del origen de datos de REST est\00E1 activa, pero no hay ninguna operaci\00F3n asignada a la operaci\00F3n de base de datos <strong>Recuperar filas</strong>. Por tanto, la sincronizaci\00F3n no funcionar\00E1.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1921_SYNC_LOCAL_TABLE_NAME is not null and :P1921_SYNC_STATUS = wwv_flow_web_src_sync.c_no_fetch_rows_operation'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(226074768846270104.4001)
,p_name=>unistr('Par\00E1metros')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       direction,',
'       name,',
'       param_type,',
'       value,',
'       is_required,',
'       is_query_param',
'  from wwv_flow_web_src_params',
' where web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and web_src_operation_id is null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1921_WEB_SRC_MODULE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn par\00E1metro.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226074849985270105.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP:P1923_ID:#ID#'
,p_column_linktext=>unistr('<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Editar Par\00E1metro</span>')
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226075646160270113.4001)
,p_query_column_id=>2
,p_column_alias=>'DIRECTION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Direcci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(226101569473456167)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226075245354270109.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226075337267270110.4001)
,p_query_column_id=>4
,p_column_alias=>'PARAM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(226045111811519566)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226075442837270111.4001)
,p_query_column_id=>5
,p_column_alias=>'VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226075568678270112.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>6
,p_column_heading=>'Necesario'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(510292996514814503.4001)
,p_query_column_id=>7
,p_column_alias=>'IS_QUERY_PARAM'
,p_column_display_sequence=>7
,p_column_heading=>unistr('Usar para b\00FAsqueda de filas')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226688576185475247.4001)
,p_plug_name=>unistr('Or\00EDgenes de Datos de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los <strong>or\00EDgenes de datos de REST</strong> act\00FAan como una referencia a uno o varios servicios web externos. Un origen de datos de REST puede contener una o varias <strong>operaciones</strong> que son las referencias a un servicio web externo ')
||'concreto. Las configuraciones en el nivel superior se comparten en todas las operaciones.',
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(247725953433524625.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_02=>'NAME'
,p_attribute_03=>'P1921_WEB_SRC_MODULE_ID'
,p_attribute_04=>'P1921_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_WEB_SRC'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(310374200946241813.4001)
,p_name=>'Perfil de Datos'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    dp.format,',
'    case when dp.is_single_row = ''Y'' then wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.ONE'') else wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.MANY'') end as is_single_row,',
'    count( dc.id ) as column_cnt,',
'    count( case when dc.is_hidden = ''Y'' then null else dc.id end ) as visible_column_cnt,',
'    count( dc.expression1 ) as derived_column_cnt',
'from wwv_flow_data_profiles dp, wwv_flow_data_profile_cols dc',
'where dc.data_profile_id (+) = dp.id',
'  and dp.flow_id           = :FB_FLOW_ID',
'  and dp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and dp.id                = :P1921_DATA_PROFILE_ID',
'group by dp.format, dp.is_single_row',
'    '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1921_DATA_PROFILE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041640454953406573.4001)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(310374313473241814.4001)
,p_query_column_id=>1
,p_column_alias=>'FORMAT'
,p_column_display_sequence=>1
,p_column_heading=>'Formato de Respuesta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(310374424389241815.4001)
,p_query_column_id=>2
,p_column_alias=>'IS_SINGLE_ROW'
,p_column_display_sequence=>2
,p_column_heading=>'Devuelve'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(310374547332241816.4001)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_CNT'
,p_column_display_sequence=>3
,p_column_heading=>'Columnas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(310374644698241817.4001)
,p_query_column_id=>4
,p_column_alias=>'VISIBLE_COLUMN_CNT'
,p_column_display_sequence=>4
,p_column_heading=>'Visible'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(310374743849241818.4001)
,p_query_column_id=>5
,p_column_alias=>'DERIVED_COLUMN_CNT'
,p_column_display_sequence=>5
,p_column_heading=>'Derivado'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(347000660418384441.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
unistr('// ocultar los atributos din\00E1micos inmediatamente despu\00E9s de su representaci\00F3n, '),
'// jQuery.ready puede tardar demasiado tiempo. ',
'apex.builder.dynamicAttributes.hide(''P4651_'');',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(347012236147385572.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P1921_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_type_page_item_name => ''P1921_WEB_SOURCE_TYPE'',',
'        p_page_item_prefix    => ''P1921_'',',
'        p_user_interface_id   => null,',
'        p_is_wizard           => false',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1512474197173406282.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/editing-or-deleting-a-REST-data-source.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247726334107524629.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(247725953433524625.4001)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P1921_WEB_SRC_MODULE_ID.,&APP_PAGE_ID.,WEB_SOURCE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_modules',
' where reference_id = :P1921_WEB_SRC_MODULE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(310374985011241820.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3291693434489441.4001)
,p_button_name=>'ADD_OPERATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar operaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP,1922:P1922_WEB_SRC_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(310375040315241821.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(226074768846270104.4001)
,p_button_name=>'ADD_PARAMETER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP,1923:P1923_WEB_SRC_MODULE_ID,P1923_WEB_SRC_OPERATION_ID:&P1921_WEB_SRC_MODULE_ID.,'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2600249135934102.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_button_name=>'SAVE_TO_CATALOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Guardar en cat\00E1logo')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1924:&SESSION.::&DEBUG.:RR,1924:P1924_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
,p_button_condition=>'P1921_CATALOG_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225951037719615714.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3469364086842428.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'', ''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(310374855235241819.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(310374200946241813.4001)
,p_button_name=>'EDIT_DATA_PROFILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Editar perfil de datos'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:RP:P1925_DATA_PROFILE_ID:&P1921_DATA_PROFILE_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2600342020934103.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_button_name=>'SAVE_TO_CATALOG_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Guardar en cat\00E1logo')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1924:&SESSION.::&DEBUG.:RR,1924:P1924_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
,p_button_condition=>'P1921_CATALOG_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3466756328842402.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3469364086842428.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1504290766184430.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_button_name=>'REFRESH_CATALOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Refrescar desde cat\00E1logo')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1928:&SESSION.::&DEBUG.:RR,1928:P1928_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_web_src_modules     m,',
'       wwv_web_src_catalogs         c,',
'       wwv_web_src_catalog_services s',
' where c.internal_name     = m.catalog_internal_name ',
'   and s.name              = m.catalog_service_name ',
'   and c.security_group_id = m.security_group_id',
'   and c.id                = s.catalog_id',
'   and s.security_group_id = m.security_group_id',
'   --',
'   and m.id                = :P1921_WEB_SRC_MODULE_ID',
'   and m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247726194903524627.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(247725953433524625.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'NEXT'
,p_button_condition=>'P1921_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(538532741160939913.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(247725953433524625.4001)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular Suscripci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'P1921_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3469622984842431.4001)
,p_branch_name=>'Go To Page 1901'
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP,1901,1921,1922,1923::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'SAVE,DELETE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(310376674243241837.4001)
,p_branch_name=>'Go To Page 1621'
,p_branch_action=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:RP:P1621_ID,P1621_BACK_TO_PAGE:&P1921_CREDENTIAL_ID.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_CREDENTIAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(55558378056883025.4001)
,p_branch_name=>'Go To Page 1932'
,p_branch_action=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID,P1932_BACK_TO_PAGE:&P1921_REMOTE_SERVER_ID.,1921&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_REMOTE_SERVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(55558637026883028.4001)
,p_branch_name=>'Go To Page 1932'
,p_branch_action=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID,P1932_BACK_TO_PAGE:&P1921_AUTH_REMOTE_SERVER_ID.,1921&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_AUTH_REMOTE_SERVER'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1219382380332158.4001)
,p_name=>'P1921_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P1921_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1219711993332170.4001)
,p_name=>'P1921_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P1921_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1220156930332170.4001)
,p_name=>'P1921_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P1921_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1220526393332170.4001)
,p_name=>'P1921_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P1921_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1220956210332170.4001)
,p_name=>'P1921_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P1921_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1221393338332171.4001)
,p_name=>'P1921_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P1921_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1221754136332171.4001)
,p_name=>'P1921_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P1921_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1222161949332171.4001)
,p_name=>'P1921_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P1921_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1222515743332171.4001)
,p_name=>'P1921_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P1921_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1222922686332171.4001)
,p_name=>'P1921_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P1921_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1223326620332172.4001)
,p_name=>'P1921_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P1921_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1223776894332172.4001)
,p_name=>'P1921_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P1921_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1224195139332173.4001)
,p_name=>'P1921_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P1921_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1224527544332174.4001)
,p_name=>'P1921_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P1921_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1224882896332174.4001)
,p_name=>'P1921_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(347000660418384441.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P1921_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1373359126674223.4001)
,p_name=>'P1921_SYNC_STATUS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1373494095674224.4001)
,p_name=>'P1921_SYNC_LOCAL_TABLE_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1503497845184422.4001)
,p_name=>'P1921_CATALOG_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_prompt=>unistr('Nombre de Cat\00E1logo')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_web_src_catalogs',
' where internal_name     = :P1921_CATALOG_INTERNAL_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_CATALOG_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el cat\00E1logo de origen de REST desde el que se ha creado el origen de datos de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1503502195184423.4001)
,p_name=>'P1921_CATALOG_SERVICE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Servicio de Cat\00E1logo ')
,p_source=>'CATALOG_SERVICE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_CATALOG_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el servicio del cat\00E1logo de origen de REST desde el que se ha creado el origen de datos de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1503631857184424.4001)
,p_name=>'P1921_CATALOG_INTERNAL_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'CATALOG_INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1503864881184426.4001)
,p_name=>'P1921_CATALOG_LAST_REFRESH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00DAltimo Refrescamiento')
,p_format_mask=>'SINCE'
,p_source=>'LAST_REFRESHED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_CATALOG_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica cu\00E1ndo se refresc\00F3 por \00FAltima vez del cat\00E1logo este origen de datos de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1504178929184429.4001)
,p_name=>'P1921_CATALOG_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1503302531184421.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3292189350489446.4001)
,p_name=>'P1921_WEB_SRC_MODULE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3292408887489449.4001)
,p_name=>'P1921_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre del origen de datos de REST.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3292574859489450.4001)
,p_name=>'P1921_WEB_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de origen de datos de REST'
,p_source=>'WEB_SOURCE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULE_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determina el tipo de origen de datos de REST.',
'<ul>',
unistr('<li>Utilice <strong>HTTP simple</strong> para fuentes de datos de HTTP simples. &PRODUCT_NAME. asume que todos los datos se devuelven con la primera solicitud y que el servidor no soporta el filtrado, la ordenaci\00F3n ni ninguna otra funci\00F3n avanzada de')
||unistr(' servicio REST en el servidor. Todos los par\00E1metros y detalles de llamada se deben configurar manualmente.</li>'),
unistr('<li>Utilice <strong>Oracle REST Data Services</strong> para los servicios RESTful de ORDS (Oracle REST Data Services). Estos servicios REST siguen el <em>est\00E1ndar Oracle REST</em>, lo que significa que las operaciones GET, POST, PUT y DELETE est\00E1n es')
||unistr('tandarizadas. El filtrado y la ordenaci\00F3n del servidor est\00E1n soportados. &PRODUCT_NAME. puede aprovechar estas funciones mediante la delegaci\00F3n de filtros y order by de informe al servicio REST.</li>'),
unistr('<li>Utilice <strong>Oracle REST Data Services (sintaxis heredada)</strong> para servicios que se ejecuten en versiones m\00E1s antiguas de ORDS (Oracle REST Data Services). Estos servicios no son totalmente compatibles con el est\00E1ndar de Oracle REST.</li')
||'>',
'    <li><strong>Servicio REST de las aplicaciones de Oracle Cloud (SaaS)</strong> indica servicios RESTful proporcionados por las aplicaciones de Oracle Cloud (SaaS). Utilice este tipo de servicio web para integrar los servicios REST de Oracle SaaS e'
||unistr('n su aplicaci\00F3n &PRODUCT_NAME. &PRODUCT_NAME. soporta la paginaci\00F3n para estos servicios.</li>'),
'    <li><strong>Servicio REST de Oracle Cloud Infrastructure (OCI)</strong> indica servicios web RESTful proporcionados por Oracle Cloud Infrastructure. Utilice este tipo de servicio web para integrar los servicios REST de OCI (por ejemplo, el acceso'
||unistr(' al almac\00E9n de objetos) en su aplicaci\00F3n &PRODUCT_NAME. &PRODUCT_NAME. soporta la paginaci\00F3n para estos servicios.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3466961035842404.4001)
,p_name=>'P1921_DATA_PROFILE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3467008942842405.4001)
,p_name=>'P1921_URL_PATH_PREFIX'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prefijo de Ruta de Acceso de URL'
,p_source=>'URL_PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    El prefijo de ruta de acceso de URL es espec\00EDfico para este origen de datos de REST. Los puntos finales de URL de todas las operaciones del origen de datos de REST comparten el mismo prefijo de ruta de acceso de URL. Cuando se llama al origen de ')
||'datos de REST, &PRODUCT_NAME. forma la URL de la siguiente manera:',
'</p>',
'<ol>',
'    <li><strong>URL base</strong> del objeto del <strong>servidor remoto</strong></li>',
'    <li><strong>Prefijo de ruta de acceso de URL</strong> del <strong>origen de datos de REST</strong></li>',
unistr('    <li><strong>Patr\00F3n de URL</strong> definido en la <strong>operaci\00F3n</strong> del origen de datos de REST</li>'),
'</ol>',
'<div>',
'    <p>Ejemplo:</p>',
'    <p>',
unistr('        Or\00EDgenes de datos de REST:'),
'        <ol>',
'            <li><code>http://api.example.com:8080/root/<strong>service1/</strong>method1</code></li>',
'            <li><code>http://api.example.com:8080/root/<strong>service2/</strong>method1</code></li>',
'            <li><code>http://api.example.com:8080/root/<strong>service2/</strong>method4</code></li>',
'        </ol> ',
'    </p>',
'    <p>',
unistr('        Como las partes de URL <strong>service1/</strong> o <strong>service2/</strong> son comunes a un origen de datos de REST, se utilizar\00E1n como <strong>prefijo de ruta de acceso de URL</strong>.'),
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3467120952842406.4001)
,p_name=>'P1921_REMOTE_SERVER_ID'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Servidor remoto'
,p_post_element_text=>'<a id="P1921_EDIT_REMOTE_SERVER_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" href="#" onClick="apex.page.submit(''EDIT_REMOTE_SERVER'');" tabindex="0" ><span class="a-Icon icon-edit" aria-hidden="true"></span><span clas'
||'s="u-VisuallyHidden">Editar Servidor Remoto</span></a>'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_REMOTE_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''WEB_SERVICE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Elija un objeto del <strong>servidor remoto</strong> para este origen de datos de REST. &PRODUCT_NAME. divide el punto final de la URL en una primera parte (servidor remoto) y una segunda parte (espec\00EDfica del servicio). Un solo objeto de <strong')
||'>servidor remoto</strong> puede contener varios ',
unistr('    puntos finales de servicio. Se recomienda asignar el mismo objeto de servidor remoto a los m\00F3dulos de origen web, cuando comparten los mismos'),
'    prefijos de servidor, puerto y ruta de acceso de URL.',
'</p>',
'<div>',
'    <p>Ejemplo:</p>',
'    <p>',
unistr('        Or\00EDgenes de datos de REST:'),
'        <ol>',
'            <li><code><strong>http://api.example.com:8080/root/</strong>service1/method1</code></li>',
'            <li><code><strong>http://api.example.com:8080/root/</strong>service2/method1</code></li>',
'            <li><code><strong>http://api.example.com:8080/root/</strong>service2/method4</code></li>',
'        </ol> ',
'    </p>',
'    <p>',
unistr('        Como la parte de la URL <strong>http://api.example.com:8080/root/</strong> es la misma en los tres or\00EDgenes de datos de REST,'),
unistr('        puede utilizarse como objeto de servidor remoto y se le puede dar un nombre. Si en un momento determinado se necesita mover estos tres or\00EDgenes de datos de REST a otro servidor, solo hay que cambiar el objeto de servidor remoto.'),
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3467321476842408.4001)
,p_name=>'P1921_MODULE_COMMENT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3467424016842409.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'MODULE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3467662661842411.4001)
,p_name=>'P1921_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3467516310842410.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credenciales'
,p_post_element_text=>'<a href="#" id="P1921_EDIT_CREDENTIAL_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''EDIT_CREDENTIAL'');" tabindex="0"><span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">Edita'
||'r credencial</span></a>'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione las credenciales almacenadas para autenticaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3467713606842412.4001)
,p_name=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3467516310842410.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Servidor de autenticaci\00F3n')
,p_post_element_text=>'<a href="#" id="P1921_EDIT_AUTH_REMOTE_SERVER_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''EDIT_AUTH_REMOTE_SERVER'');" tabindex="0"><span class="a-Icon icon-edit"></span><span class="u-Visua'
||'llyHidden">Editar Servidor Remoto</span></a>'
,p_source=>'AUTH_REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_AUTHENT_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''AUTHENTICATION''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Si la autenticaci\00F3n debe realizarse en un <em>servidor de autenticaci\00F3n</em> (diferente), cree un objeto de <strong>servidor remoto</strong> para ello y el\00EDjalo aqu\00ED. &PRODUCT_NAME. divide el punto final de la URL en una primera parte (servidor r')
||unistr('emoto) y una segunda parte (espec\00EDfica del servicio). Un solo objeto de <strong>servidor remoto</strong> puede contener varios '),
unistr('    puntos finales de servicio. Se recomienda asignar el mismo objeto de servidor remoto a los or\00EDgenes de datos de REST, cuando comparten los mismos'),
'    prefijos de servidor, puerto y ruta de acceso de URL.',
'</p>',
'<div>',
'    <p>',
'    Ejemplo:        ',
'    </p>',
'    <ol>',
'        <li><code><strong>http://api.example.com:8080/root/</strong>auth/token</code></li>',
'        <li><code><strong>http://api.example.com:8080/root/</strong>auth-prod/token</code></li>',
'    </ol> ',
'    <p>',
unistr('        Como la parte de la URL <strong>http://api.example.com:8080/root/</strong> es la misma para ambos puntos finales de autenticaci\00F3n,'),
'        puede utilizarse como objeto de servidor remoto.',
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3467822098842413.4001)
,p_name=>'P1921_AUTH_URL_PATH_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3467516310842410.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ruta de Acceso de URL'
,p_source=>'AUTH_URL_PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Si la autenticaci\00F3n debe realizarse en un <em>servidor de autenticaci\00F3n</em> (diferente), cree un objeto de <strong>servidor remoto</strong> para ello y el\00EDjalo aqu\00ED. &PRODUCT_NAME. divide el punto final de la URL en una primera parte (servidor r')
||unistr('emoto) y una segunda parte (espec\00EDfica del servicio). Un solo objeto de <strong>servidor remoto</strong> puede contener varios '),
unistr('    puntos finales de servicio. Se recomienda asignar el mismo objeto de servidor remoto a los or\00EDgenes de datos de REST, cuando comparten los mismos'),
'    prefijos de servidor, puerto y ruta de acceso de URL.',
'</p>',
'<div>',
'    <p>',
'    Ejemplo:        ',
'    </p>',
'    <ol>',
'        <li><code>http://api.example.com:8080/root/<strong>auth/token</strong></code></li>',
'        <li><code>http://api.example.com:8080/root/<strong>auth-prod/token</strong></code></li>',
'    </ol> ',
'    <p>',
unistr('        Las partes de la URL <strong>auth/token</strong> y <strong>auth-prod/token</strong> son espec\00EDficas del servicio de autenticaci\00F3n individual y deber\00EDan utilizarse como <strong>prefijo de ruta de acceso de URL</strong>.'),
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3468182432842416.4001)
,p_name=>'P1921_AUTH_REMOTE_SERVER_BASEURL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3467516310842410.4001)
,p_prompt=>'URL Base'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3468650820842421.4001)
,p_name=>'P1921_REMOTE_SERVER_BASEURL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_prompt=>'URL Base'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5901995307682519.4001)
,p_name=>'P1921_NEXT_SYNC_TIMESTAMP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1373683531674226.4001)
,p_prompt=>unistr('Siguiente sincronizaci\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1921_NEXT_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica cu\00E1ndo se realizar\00E1 la pr\00F3xima sincronizaci\00F3n. Tenga en cuenta que las sincronizaciones se inician cada 10 minutos desde las horas en punto. Por lo tanto, una sincronizaci\00F3n puede iniciarse en el minuto 0 de la hora, en el 10, 20, 30, 40 o 50,')
||' pero no entre estos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5902173551682521.4001)
,p_name=>'P1921_LOCAL_TABLE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1373683531674226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de tabla local'
,p_source=>'SYNC_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Los datos se han sincronizado con esta tabla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5902312154682523.4001)
,p_name=>'P1921_LAST_SYNC_TIMESTAMP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1373683531674226.4001)
,p_prompt=>unistr('\00DAltima sincronizaci\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_LAST_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica cu\00E1ndo se realiz\00F3 la \00FAltima sincronizaci\00F3n de la tabla local.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238756151563331834.4001)
,p_name=>'P1921_TIMEOUT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3467424016842409.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Timeout de transferencia de HTTP (segundos)'
,p_source=>'TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Especifique el timeout de transferencia para todas las solicitudes HTTP futuras que se han intentado al leer la respuesta HTTP del servidor web o el servidor proxy.</p><p>Este valor de timeout se puede utilizar para evitar que servidores web ocupa'
||unistr('dos o un gran volumen de tr\00E1fico de red bloqueen la aplicaci\00F3n al recuperar las respuestas. Consulte la documentaci\00F3n para <strong>UTL_HTTP.SET_TRANSFER_TIMEOUT</strong>.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(247726058933524626.4001)
,p_name=>'P1921_REFERENCE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619336473312855719.4001)
,p_name=>'P1921_PASS_ECID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3467424016842409.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Transferir ECID'
,p_source=>'PASS_ECID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica si se debe pasar el ID de contexto de ejecuci\00F3n (ECID) a los servicios web externos para el rastreo completo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619336542244855720.4001)
,p_name=>'P1921_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3467424016842409.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador Est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia al origen de datos de REST en llamadas de API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3403061807595708635.4001)
,p_name=>'P1921_BREADCRUMB_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_source=>'P1921_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3632687031037912650.4001)
,p_name=>'P1921_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3292099913489445.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3403062190966708638.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1921_BREADCRUMB_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1921_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1373252285674222.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1921_SYNC_STATUS'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_web_src_sync.get_table_ddl_sync_status(:P1921_WEB_SRC_MODULE_ID)'
,p_compute_when=>'P1921_SYNC_LOCAL_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(225853558146926501.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1921_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4000219387275820.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&APP_PAGE_ID.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(310377087034241841.4001)
,p_validation_name=>'REST Data Source still referenced'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_module_usage',
' where web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and rownum            = 1',
'union all (',
'select 1 ',
'  from wwv_flow_step_processing',
' where web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and rownum            = 1',
')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Algunos componentes de aplicaci\00F3n hacen referencia a este origen de datos de REST, por lo que no puede suprimirlo.')
,p_when_button_pressed=>wwv_flow_api.id(225951037719615714.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3468240510842417.4001)
,p_name=>'Auth Remote Server changed'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_condition_element=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3468333311842418.4001)
,p_event_id=>wwv_flow_api.id(3468240510842417.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_BASEURL,P1921_AUTH_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3468501882842420.4001)
,p_event_id=>wwv_flow_api.id(3468240510842417.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_BASEURL,P1921_AUTH_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3468453503842419.4001)
,p_event_id=>wwv_flow_api.id(3468240510842417.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_BASEURL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id = :P1921_AUTH_REMOTE_SERVER_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3468707643842422.4001)
,p_name=>'Remote Server Changed'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_REMOTE_SERVER_ID'
,p_condition_element=>'P1921_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3468862131842423.4001)
,p_event_id=>wwv_flow_api.id(3468707643842422.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_REMOTE_SERVER_BASEURL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id = :P1921_REMOTE_SERVER_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1921_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3469122215842426.4001)
,p_event_id=>wwv_flow_api.id(3468707643842422.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_REMOTE_SERVER_BASEURL,P1921_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3468984328842424.4001)
,p_event_id=>wwv_flow_api.id(3468707643842422.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_REMOTE_SERVER_BASEURL,P1921_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(691709405214978021.4001)
,p_name=>'Edit Data Profile'
,p_event_sequence=>35
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(310374200946241813.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(691709505751978022.4001)
,p_event_id=>wwv_flow_api.id(691709405214978021.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(310374200946241813.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(225854073471926506.4001)
,p_name=>'Edit Operation'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(3291693434489441.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225854175481926507.4001)
,p_event_id=>wwv_flow_api.id(225854073471926506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3291693434489441.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226078596643270142.4001)
,p_name=>'Edit Parameter'
,p_event_sequence=>50
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(226074768846270104.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226078666151270143.4001)
,p_event_id=>wwv_flow_api.id(226078596643270142.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(226074768846270104.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(241339064992308301.4001)
,p_name=>'Credential chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_CREDENTIAL_ID'
,p_condition_element=>'P1921_CREDENTIAL_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241339146987308302.4001)
,p_event_id=>wwv_flow_api.id(241339064992308301.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4388690452043556148.4001)
,p_event_id=>wwv_flow_api.id(241339064992308301.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310376411987241835.4001)
,p_event_id=>wwv_flow_api.id(241339064992308301.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1921_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310376580727241836.4001)
,p_event_id=>wwv_flow_api.id(241339064992308301.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1921_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241339212609308303.4001)
,p_event_id=>wwv_flow_api.id(241339064992308301.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1374233058674232.4001)
,p_name=>'Max Requests Per MIn changed'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_USE_RATE_LIMITING'
,p_condition_element=>'P1921_USE_RATE_LIMITING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1374394028674233.4001)
,p_event_id=>wwv_flow_api.id(1374233058674232.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_MAX_REQUESTS_TIMEFRAME,P1921_MAX_REQUESTS,P1921_MAX_REQUESTS_EXC_ACTION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1374876413674238.4001)
,p_event_id=>wwv_flow_api.id(1374233058674232.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_MAX_REQUESTS_TIMEFRAME,P1921_MAX_REQUESTS,P1921_MAX_REQUESTS_EXC_ACTION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3469537577842430.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1921_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3466756328842402.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3403061790443708634.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_dev.remove_web_src_module(',
'        p_web_src_module_id    => :P1921_WEB_SRC_MODULE_ID,',
'        p_application_id       => :FB_FLOW_ID,',
'        p_remove_remote_server => true,',
'        p_remove_data_profile  => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(225951037719615714.4001)
,p_process_success_message=>'Se ha suprimido el origen de datos de REST.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(247726242664524628.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.subscribe_web_src_module (',
'    p_web_src_module_id        => :P1921_WEB_SRC_MODULE_ID,',
'    p_master_web_src_module_id => :P1921_REFERENCE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(247726194903524627.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(538532867300939914.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_web_src_modules',
'   set reference_id = null',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P1921_WEB_SRC_MODULE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(538532741160939913.4001)
,p_process_when=>'P1921_WEB_SRC_MODULE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>unistr('Se ha anulado la suscripci\00F3n del origen de datos de REST.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3466697539842401.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row of WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1921_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5902281160682522.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch last and next sync timestamps'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sync_timestamps as (',
'    select sync_last_run_timestamp,',
'           case when sync_next_run_timestamp is not null then',
'               wwv_flow_web_src_sync_dev.get_actual_execution_timestamp( sync_next_run_timestamp ) at time zone ''00:00''',
'           end as sync_next_run_timestamp',
'      from wwv_flow_web_src_modules',
'     where id                = :P1921_WEB_SRC_MODULE_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'select case ',
'           when sync_next_run_timestamp is not null then',
'               to_char(sync_next_run_timestamp, ''Mon fmdd, '' ) ||',
'               to_char(sync_next_run_timestamp, ''HH24:MI '' ) ||',
'               decode(to_char(sync_next_run_timestamp, ''TZR'' ), ''+00:00'', ''UTC'', to_char(sync_next_run_timestamp, ''TZR'' ) ) ||',
'               '' ('' || htmldb_util.get_since( sync_next_run_timestamp ) || '')''',
'       end,',
'       case',
'           when sync_last_run_timestamp is not null then',
'                      htmldb_util.get_since( sync_last_run_timestamp )',
'       end',
'  into :P1921_NEXT_SYNC_TIMESTAMP,',
'       :P1921_LAST_SYNC_TIMESTAMP',
'  from sync_timestamps;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2600618999934106.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Catalog ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1921_CATALOG_INTERNAL_NAME is null then',
'        :P1921_CATALOG_ID := null;',
'    else',
'        begin',
'            select id',
'              into :P1921_CATALOG_ID',
'              from wwv_web_src_catalogs',
'             where internal_name     = :P1921_CATALOG_INTERNAL_NAME',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and rownum            = 1;',
'        exception',
'            when no_data_found then',
'                 :P1921_CATALOG_ID := null;',
'        end;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01922
begin
wwv_flow_api.create_page(
 p_id=>1922.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Operaci\00F3n de origen de REST')
,p_step_title=>unistr('Editar operaci\00F3n de origen de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3469784605842432.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3500552115076908.4001)
,p_plug_name=>unistr('Operaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3501284674076916.4001)
,p_plug_name=>unistr('Operaci\00F3n de origen de REST')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(242268510007871834.4001)
,p_plug_name=>'Operaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr(' Una <strong>operaci\00F3n</strong> de origen de REST contiene la informaci\00F3n real sobre el manejador de servicio web externo. Para los servicios REST, se realiza una operaci\00F3n mediante la combinaci\00F3n de un patr\00F3n de URL y un verbo HTTP (GET, POST). Un o')
||'rigen de datos de REST puede contener varias operaciones.',
' </p>',
unistr(' <p>Las operaciones se pueden asignar a <strong>operaciones de base de datos</strong>, lo que permite que los componentes &PRODUCT_NAME. seleccionen la operaci\00F3n correcta. Los informes, informes interactivos o calendarios de CSS seleccionar\00E1n la oper')
||unistr('aci\00F3n asignada a la operaci\00F3n de base de datos <em>Recuperar filas</em>.</p>'),
'<p>',
unistr('La configuraci\00F3n definida en el nivel de m\00F3dulo se comparte en todas las operaciones del origen de datos de REST. La configuraci\00F3n en el nivel de operaci\00F3n se aplica solo a esta operaci\00F3n.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249280093175575814.4001)
,p_plug_name=>unistr('Origen de REST de JSON heredado de ORDS: tama\00F1o de p\00E1gina fijo desconocido')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_source=>unistr('<p>Este origen de REST de ORDS utiliza la <em>sintaxis JSON heredada</em>; los datos se devuelven seg\00FAn la p\00E1gina, con un tama\00F1o de p\00E1gina fijo que determina el servidor. Para representar los componentes de Application Express correctamente, Applicat')
||unistr('ion Express debe conocer el <em>tama\00F1o de p\00E1gina</em>. Navegue a la secci\00F3n <strong>Avanzado</strong> y defina el tama\00F1o de la p\00E1gina seg\00FAn corresponda. P\00F3ngase en contacto con el administrador del servicio REST para obtener esa informaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where security_group_id = :FLOW_SECURITY_GROUP_ID and id = :P1922_WEB_SRC_MODULE_ID and web_source_type=''NATIVE_ORDS'' and attribute_01 = ''Y'' and :P1922_ORDS_FIXED_PAGE_SIZE is null and :P1922_ID is not null'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249280151163575815.4001)
,p_plug_name=>unistr('Origen de REST de JSON heredado de ORDS: tama\00F1o de p\00E1gina fijo peque\00F1o')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_source=>unistr('<p>Este origen de datos de REST de ORDS utiliza la <em>sintaxis JSON heredada</em>; los datos se devuelven seg\00FAn la p\00E1gina con un tama\00F1o de p\00E1gina fijo de &P1922_ORDS_FIXED_PAGE_SIZE., determinado por el servidor. Para informes con tama\00F1os de p\00E1gina ')
||unistr('m\00E1s grandes, se necesitar\00E1n varias solicitudes HTTP al servicio REST para representar una p\00E1gina. P\00F3ngase en contacto con el administrador del servicio REST para proporcionar un tama\00F1o de p\00E1gina m\00E1s grande.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where security_group_id = :FLOW_SECURITY_GROUP_ID and id = :P1922_WEB_SRC_MODULE_ID and web_source_type=''NATIVE_ORDS''',
'  and attribute_01 = ''Y''',
'  and :P1922_ORDS_FIXED_PAGE_SIZE < 50'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(310375138083241822.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(922351464945024904.4001)
,p_name=>unistr('Par\00E1metros de operaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       direction,',
'       name,',
'       param_type,',
'       value,',
'       is_required',
'  from wwv_flow_web_src_params',
' where web_src_module_id    = :P1922_WEB_SRC_MODULE_ID',
'   and web_src_operation_id = :P1922_ID',
'   and flow_id              = :FB_FLOW_ID',
'   and security_group_id    = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_condition=>'P1922_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1922_WEB_SRC_MODULE_ID,P1922_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn par\00E1metro.')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(348143672277890310.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP:P1923_ID:#ID#'
,p_column_linktext=>unistr('<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Editar Par\00E1metro</span>')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(348144051871890311.4001)
,p_query_column_id=>2
,p_column_alias=>'DIRECTION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Direcci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(226101569473456167)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(348144427352890311.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(348144819984890311.4001)
,p_query_column_id=>4
,p_column_alias=>'PARAM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(226045111811519566)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(348145273337890312.4001)
,p_query_column_id=>5
,p_column_alias=>'VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Valor'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(348145636845890312.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>6
,p_column_heading=>'Necesario'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3632686677195912646.4001)
,p_plug_name=>unistr('Cach\00E9')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_companies ',
' where provisioning_company_id = :FLOW_SECURITY_GROUP_ID ',
'   and coalesce( content_cache_size_target, to_number(wwv_flow_instance_admin.get_parameter(''CONTENT_CACHE_SIZE_TARGET'') ) ) > 0'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(91187183548358248.4001)
,p_name=>unistr('Contenido de la memoria cach\00E9')
,p_parent_plug_id=>wwv_flow_api.id(3632686677195912646.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count( case when user_name  is not null and valid_until > sysdate then 1 end ) as cached_by_user,',
'       count( case when session_id is not null and valid_until > sysdate then 1 end ) as cached_by_session,',
'       count( case when user_name  is null and session_id is null and valid_until > sysdate then 1 end ) as cached_all_users,',
'       count( case when valid_until <= sysdate then 1 end) as stale_entries',
'from wwv_flow_content_cache1$',
'where component_id = :P1922_ID',
'  and component_type = 1 -- wwv_flow_content_cache.c_comp_web_source',
'   '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_content_cache1$',
'where component_type = 1 -- wwv_flow_content_cache.c_comp_web_source',
'  and component_id = :P1922_ID'))
,p_display_condition_type=>'EXISTS'
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Application Express ya no utiliza entradas desactualizadas. Estas entradas se depurar\00E1n durante la pr\00F3xima ejecuci\00F3n del trabajo nocturno de mantenimiento de APEX.'),
'</p>'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041640454953406573.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(91187294651358249.4001)
,p_query_column_id=>1
,p_column_alias=>'CACHED_BY_USER'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Entradas almacenadas en cach\00E9 por usuario')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(91187390594358250.4001)
,p_query_column_id=>2
,p_column_alias=>'CACHED_BY_SESSION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Entradas almacenadas en cach\00E9 por sesi\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218526975872706501.4001)
,p_query_column_id=>3
,p_column_alias=>'CACHED_ALL_USERS'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Entradas almacenadas en cach\00E9 para todos los usuarios')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(218527126424706503.4001)
,p_query_column_id=>4
,p_column_alias=>'STALE_ENTRIES'
,p_column_display_sequence=>4
,p_column_heading=>'Entradas desactualizadas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(218527070654706502.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3632686677195912646.4001)
,p_button_name=>'PURGE_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Depurar Cach\00E9')
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_content_cache1$',
'where component_type = 1 -- wwv_flow_content_cache.c_comp_web_source',
'  and component_id = :P1922_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3501688362076916.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3501284674076916.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP,1922::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(348146097833890312.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(922351464945024904.4001)
,p_button_name=>'ADD_PARAMETER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP,1923:P1923_WEB_SRC_MODULE_ID,P1923_WEB_SRC_OPERATION_ID:&P1922_WEB_SRC_MODULE_ID.,&P1922_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3501137717076916.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3501284674076916.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1922_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3501080431076915.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3501284674076916.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1922_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3500934236076915.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3501284674076916.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1922_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(218527317192706505.4001)
,p_branch_action=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(218527070654706502.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226688662282475248.4001)
,p_branch_name=>'Go To Page 1921'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1418382946635714.4001)
,p_name=>'P1922_FORCE_RAISE_404_ERROR'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(3469784605842432.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Forzar producci\00F3n de error HTTP-404')
,p_source=>'FORCE_ERROR_FOR_HTTP_404'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si, al ejecutar la solicitud HTTP mediante la operaci\00F3n de base de datos <strong>Recuperar filas</strong>, se obtiene '),
unistr('el c\00F3digo de estado HTTP <strong>404</strong> ("No encontrado"), APEX considera que se ha producido una incidencia "No se ha encontrado ninguna fila", por lo que no genera un error (solo se genera un error cuando est\00E1 activada la opci\00F3n <em>Depurar</')
||unistr('em>). Al activar esta opci\00F3n, se fuerza a que APEX marque <em>siempre</em> las incidencias HTTP-404 como errores.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3504053275076922.4001)
,p_name=>'P1922_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3505105036076971.4001)
,p_name=>'P1922_WEB_SRC_MODULE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3505592693076972.4001)
,p_name=>'P1922_DATA_PROFILE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3506301333076973.4001)
,p_name=>'P1922_DATABASE_OPERATION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Operaci\00F3n de Base de Datos')
,p_source=>'DATABASE_OPERATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_DATABASE_OPERATIONS'
,p_lov=>'.'||wwv_flow_api.id(225834585600778166.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No asignado -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Asigne una <strong>operaci\00F3n de base de datos</strong> a esta operaci\00F3n HTTP. La operaci\00F3n de base de datos es importante para que los componentes de &PRODUCT_NAME. funcionen con el origen de datos de REST. Se asigna un origen de datos de REST (y')
||unistr(' no una operaci\00F3n) a un componente de &PRODUCT_NAME., por lo que busca la operaci\00F3n HTTP seg\00FAn la operaci\00F3n de base de datos que se requiera.'),
'</p>',
'<ul>',
unistr('    <li>Los componentes de visualizaci\00F3n, como informes, gr\00E1ficos, calendarios CSS, etc., siempre utilizar\00E1n la operaci\00F3n HTTP asignada a la operaci\00F3n de base de datos <strong>Recuperar filas</strong>. <strong>APEX_EXEC.OPEN_WEB_SOURCE_QUERY</strong>')
||unistr(' tambi\00E9n utilizar\00E1 la operaci\00F3n de base de datos Recuperar filas.</li>'),
unistr('    <li>Cuando un componente de pantalla inserta, actualiza o suprime filas, utilizar\00E1 las operaciones asignadas a <strong>Insertar fila</strong>, <strong>Actualizar fila</strong> o <strong>Suprimir fila</strong>, respectivamente. En PL/SQL, <strong>')
||'APEX_EXEC.OPEN_WEB_SOURCE_DML_CONTEXT</strong> equivale a una pantalla.</li>',
unistr('    <li>El componente de pantalla utiliza la operaci\00F3n de base de datos <strong>Recuperar una sola fila</strong> cuando se realizan detecciones de actualizaciones perdidas o comprobaciones de operaciones permitidas. La pantalla utiliza esta operaci\00F3n')
||unistr(' para volver a recuperar la fila del servicio REST antes de llevar a cabo la operaci\00F3n de DML.</li>'),
unistr('    <li>Los componentes de &PRODUCT_NAME. no utilizar\00E1n las operaciones que no est\00E9n asignadas a una operaci\00F3n de base de datos. Utilice el procedimiento PL/SQL <strong>APEX_EXEC.EXECUTE_WEB_SOURCE</strong> para ejecutar estas operaciones en un conte')
||'xto PL/SQL.</li>',
'</ul>',
'<p>',
'    <br>',
unistr('    Por ejemplo, los componentes de informes o gr\00E1ficos de &PRODUCT_NAME. requieren una recopilaci\00F3n de filas. Cuando trabaja con'),
unistr('    un origen de datos de REST, &PRODUCT_NAME. buscar\00E1 la operaci\00F3n de base de datos <strong>Recuperar filas</strong> y ejecutar\00E1'),
unistr('    la operaci\00F3n HTTP asignada durante el tiempo de ejecuci\00F3n. Una pantalla buscar\00E1 operaciones de bases de datos de Insertar fila, Actualizar fila o Suprimir fila.'),
'</p>',
'<p>',
unistr('    Cada operaci\00F3n individual puede asignarse solo una vez dentro de un origen de datos de REST. Esta abstracci\00F3n del componente de &PRODUCT_NAME. con respecto a la operaci\00F3n HTTP permite crear una operaci\00F3n nueva con un comportamiento diferente y as')
||unistr('ignarla a la operaci\00F3n de base de datos. Todos los componentes utilizar\00E1n la nueva operaci\00F3n HTTP de forma transparente.'),
'</p>',
'<p>',
unistr('    No existe ninguna restricci\00F3n sobre qu\00E9 operaci\00F3n HTTP (GET, POST, PUT, DELETE) puede asignarse a qu\00E9 operaci\00F3n de base de datos. Una operaci\00F3n HTTP POST puede asignarse a la operaci\00F3n de base de datos Recuperar filas. Sin embargo, para una mayor')
||unistr(' claridad y facilidad de mantenimiento, se recomienda que las API de REST se dise\00F1en de forma que utilicen GET para operaciones de recuperaci\00F3n; y POST, PUT, DELETE, para cambios de datos.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3506734544076973.4001)
,p_name=>'P1922_URL_PATTERN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Patr\00F3n de URL')
,p_source=>'URL_PATTERN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    El <strong>patr\00F3n de URL</strong> constituye la \00FAltima parte de la URL de punto final del servicio web. La combinaci\00F3n entre el patr\00F3n de URL y la operaci\00F3n HTTP (GET, POST, PUT, DELETE) identifica la operaci\00F3n dentro de un origen de datos de RES')
||unistr('T. Un origen de datos de REST puede contener el mismo patr\00F3n de URL para operaciones HTTP diferentes y patrones de URL diferentes para la misma operaci\00F3n HTTP.'),
unistr('    El patr\00F3n de URL tambi\00E9n puede estar vac\00EDo. Utilice un <em>punto</em> (.) en este caso. '),
'</p>',
'<p>',
'        Cuando se llama al origen de datos de REST, &PRODUCT_NAME. forma la URL de la siguiente manera:',
'</p>',
'<p>',
unistr('    El patr\00F3n de URL tambi\00E9n puede contener par\00E1metros, indicados por: param-name o {param-name}. En este caso, el par\00E1metro debe agregarse a los <strong>par\00E1metros del origen de datos de REST</strong>, ya sea en el nivel del m\00F3dulo o en el de la ope')
||unistr('raci\00F3n.'),
'</p>',
'<ol>',
'    <li><strong>URL base</strong> del objeto del <strong>servidor remoto</strong></li> ',
'    <li><strong>Prefijo de ruta de acceso de URL</strong> del <strong>origen de datos de REST</strong></li>',
unistr('    <li><strong>Patr\00F3n de URL</strong> definido en la <strong>operaci\00F3n</strong>del origen de datos de REST</li>'),
'</ol>',
'<p>',
'    <br>',
'    Ejemplo de patrones de URL:',
'</p>',
'<ul>',
'    <li><strong>GET</strong> para <code>http://api.example.com:8080/root/service1/<strong>method1</strong></code></li>',
'    <li><strong>PUT</strong> para <code>http://api.example.com:8080/root/service1/<strong>method1</strong></code></li>',
'    <li><strong>GET</strong> para <code>http://api.example.com:8080/root/service1/<strong>method2</strong></code></li>',
'</ul> ',
'<p>',
'    <br>',
unistr('    Patrones de URL con par\00E1metros:'),
'</p>',
'<ul>',
'    <li>',
unistr('        El patr\00F3n de URL contiene un par\00E1metro <strong>id</strong>:<br>'),
'        <strong>GET</strong> para <code>http://api.example.com:8080/root/service1/<strong>:id</strong></code></li>',
unistr('    <li>El patr\00F3n de URL est\00E1 vac\00EDo:<br>'),
'        <strong>GET</strong> para <code>http://api.example.com:8080/root/service1/<strong>.</strong></code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3507196808076973.4001)
,p_name=>'P1922_REQUEST_BODY_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de cuerpo de solicitud'
,p_post_element_text=>'<a id="P1922_GENERATE_BODY_TEMPLATE" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" href="#"><span class="a-Icon icon-refresh"></span> Generar</a>'
,p_source=>'REQUEST_BODY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>100
,p_cMaxlength=>32760
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca la plantilla de cuerpo de solicitud que se utilizar\00E1 para las solicitudes HTTP POST, PUT, PATCH o DELETE. En la plantilla, puede utilizar marcadores de posici\00F3n (<em>#placeholder-name#</em>)'),
'</p>',
'<ul>',
unistr('    <li>para par\00E1metros de origen de REST de tipo <strong>solicitud/cuerpo de respuesta</strong>. Estos par\00E1metros se ejecutar\00E1n para todas las operaciones.</li>'),
unistr('    <li>para columnas de perfil de datos. Estos par\00E1metros se reemplazar\00E1n cuando se ejecuten las operaciones de base de datos Insertar fila, Actualizar fila o Suprimir fila.</li>'),
'</ul> ',
'<p>',
'    <br>',
unistr('    Tenga en cuenta que aquellos marcadores que presenten valores <em>con tipo de datos, entrecomillados y de escape</em> se reemplazar\00E1n por procesos autom\00E1ticos de DLM (regi\00F3n de pantalla de un servicio REST). Asimismo, los marcadores con valores d')
||unistr('e cadena de <em>escape</em> se reemplazar\00E1n por procesos personalizados de PL/SQL (si se utiliza APEX_EXEC.EXECUTE_WEB_SOURCE). Por tanto, si se utilizan con APEX_EXEC.EXECUTE_WEB_SOURCE, los marcadores deber\00E1n aparecer entrecomillados en la plantill')
||'a excepto si se utilizan con pantallas declarativas.',
'</p>',
'<p>',
unistr('    Ejemplo de plantilla de cuerpo de solicitud: estructura de JSON simple para transferir un objeto. Para las operaciones de base de datos Insertar fila, Actualizar fila o Suprimir fila, las columnas de perfil de datos reemplazar\00E1n a los marcadores ')
||unistr('de posici\00F3n. Para que los marcadores de posici\00F3n no se entrecomillen, el origen de datos de REST se debe utilizar con una regi\00F3n de pantalla.'),
'</p>',
'<pre>',
'{"empno": #EMPNO#, "ename": "#ENAME#", "job": "#JOB#", "sal": #SAL#, "comm": #COMM#, "hiredate": "#HIREDATE#", "deptno": #DEPTNO#}',
'</pre>',
'<p>',
unistr('    Ejemplo de plantilla de cuerpo de solicitud: estructura de JSON m\00E1s compleja para transferir un objeto. Para las operaciones de base de datos Insertar fila, Actualizar fila o Suprimir fila, las columnas de perfil de datos reemplazar\00E1n a los marca')
||unistr('dores de posici\00F3n. Para que se entrecomillen los marcadores de posici\00F3n, deber\00E1 utilizar el origen de datos de REST con el uso personalizado de PL/SQL. Se pueden utilizar marcadores de posici\00F3n adicionales para los <strong>par\00E1metros de origen de RES')
||unistr('T</strong>. Aseg\00FArese de definir estos marcadores como par\00E1metros de tipo <strong>solicitud/cuerpo de respuesta</strong> en el nivel del m\00F3dulo o en el de la operaci\00F3n.'),
'</p>',
'<pre>',
'{ "passed-by": "#USERID#",',
'  "client-id": "APEX-#APEX_INSTANCE#",',
'  "object": {',
'      "empno": #EMPNO#, ',
'      "ename": "#ENAME#", ',
'      "job": "#JOB#", ',
'      "sal": #SAL#, ',
'      "comm": #COMM#, ',
'      "hiredate": "#HIREDATE#", ',
'      "deptno": #DEPTNO# } }',
'</pre>',
'<p>',
unistr('    Haga clic en el bot\00F3n <strong><span class="a-Icon icon-refresh"></span> Generar</strong> para crear una plantilla de cuerpo de solicitud a partir del <em>perfil de datos</em> de la definici\00F3n del origen de datos de REST (el bot\00F3n solo aparecer\00E1 s')
||unistr('i el \00E1rea de texto est\00E1 vac\00EDa).'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3507516611076974.4001)
,p_name=>'P1922_CACHING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3632686677195912646.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cach\00E9')
,p_source=>'CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CACHING_MODE'
,p_lov=>'.'||wwv_flow_api.id(225840272947805161.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Desactivado'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione el modo en el que el motor de &PRODUCT_NAME. puede almacenar en cach\00E9 respuestas de origen de REST en el servidor. Si se puede utilizar el almacenamiento en cach\00E9, el componente se representar\00E1 en funci\00F3n de los resultados almacenados ')
||unistr('en cach\00E9 en lugar de recuperarlos del servicio web de nuevo. Solo se almacenar\00E1n en cach\00E9 las solicitudes HTTP "GET", que reducir\00E1n las solicitudes HTTP caras. Esta funci\00F3n no est\00E1 relacionada con las capacidades de almacenamiento en cach\00E9 del explor')
||'ador.</p>',
'<p>',
'    Las opciones disponibles incluyen:',
'</p>',
'<ul>',
unistr('    <li><strong>Desactivado</strong>: el contenido no se almacena en cach\00E9 ni se recupera del origen de REST para cada solicitud.</li>'),
unistr('    <li><strong>Para todos los usuarios</strong>: el contenido se almacena en cach\00E9 y todos los usuarios lo utilizan.</li>'),
unistr('    <li><strong>Por usuario</strong>: el contenido se almacena en cach\00E9 espec\00EDficamente para cada usuario.</li>'),
unistr('    <li><strong>Por sesi\00F3n</strong>: el contenido se almacena en cach\00E9 espec\00EDficamente para cada sesi\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3507960502076974.4001)
,p_name=>'P1922_INVALIDATE_WHEN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3632686677195912646.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Invalidar cuando'
,p_source=>'INVALIDATE_WHEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifique cu\00E1ndo se debe invalidar el contenido almacenado en cach\00E9. Proporcione el n\00FAmero de minutos o una "cadena de calendarios DBMS_SCHEDULER". En el \00FAltimo caso, se determina la invalidaci\00F3n del contenido almacenado en cach\00E9 a la hora en punto')
||unistr(', a medianoche o en otro momento espec\00EDfico repetido de forma peri\00F3dica.</p>'),
'<p>Ejemplos:</p>',
'<ul>',
unistr('    <li><strong>15</strong>: el contenido expirar\00E1 15 minutos despu\00E9s de su almacenamiento en cach\00E9</li>'),
unistr('    <li><strong>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</strong>: el contenido se almacenar\00E1 en cach\00E9 hasta la pr\00F3xima hora en punto.</li>'),
unistr('    <li><strong>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</strong>: el contenido se almacenar\00E1 en cach\00E9 hasta medianoche.</li>'),
'</ul>',
'<p>',
'    ',
'</p>',
unistr('<p>Consulte la documentaci\00F3n de DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING para obtener m\00E1s informaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3508303664076974.4001)
,p_name=>'P1922_SECURITY_SCHEME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3469784605842432.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Esquema de Seguridad'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3508789886076975.4001)
,p_name=>'P1922_OPERATION_COMMENT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(3469784605842432.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Comentario de operaci\00F3n')
,p_source=>'OPERATION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225853650468926502.4001)
,p_name=>'P1922_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238756237141331835.4001)
,p_name=>'P1922_ALLOW_FETCH_ALL_ROWS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(3469784605842432.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Permitir recuperaci\00F3n de todas las filas')
,p_source=>'ALLOW_FETCH_ALL_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where id = :P1922_WEB_SRC_MODULE_ID and :P1922_DATABASE_OPERATION = ''FETCH_COLLECTION''',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Especifique si los componentes de &PRODUCT_NAME. pueden recuperar todas las filas y ejecutar varias solicitudes HTTP desde esta operaci\00F3n de origen de REST. '),
'</p>',
'<p>',
unistr('   Esto se aplica a or\00EDgenes de REST que devuelven sus datos en formato de p\00E1gina, como Oracle REST Data Services. Por ejemplo, un gr\00E1fico o la vista Agrupar por de Informes interactivos tienen que acceder a todas las filas para calcular los resultad')
||unistr('os correctos. Cuando el servicio REST devuelve los datos en formato de p\00E1gina, se requieren varias solicitudes HTTP al servicio REST. '),
'</p>',
'<p>',
unistr('    Si el origen de REST solo devuelve algunas p\00E1ginas, que se pueden recuperar en unos segundos, esto se acepta en la mayor\00EDa de casos de uso. Para estos servicios, defina el atributo en <strong>Activado</strong>. Por otro lado, cuando el servicio R')
||unistr('EST devuelve miles de filas en cientos de p\00E1ginas, recuperar todas las filas llevar\00EDa demasiado tiempo. Para estos servicios, defina este atributo en <strong>Desactivado</strong>.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238756354056331836.4001)
,p_name=>'P1922_FETCH_ALL_ROWS_TIMEOUT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(3469784605842432.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Recuperar timeout de todas las filas '
,p_post_element_text=>'&nbsp;(en segundos)'
,p_source=>'FETCH_ALL_ROWS_TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where id = :P1922_WEB_SRC_MODULE_ID and :P1922_DATABASE_OPERATION = ''FETCH_COLLECTION''',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el valor de timeout (en segundos) para una operaci\00F3n "recuperar todas las filas". Dado que se solicitar\00E1n varias p\00E1ginas, este valor de timeout debe ser mayor que el valor de timeout de una \00FAnica solicitud especificado a nivel de m\00F3dulo. ')
||unistr('Aseg\00FArese de que sea lo suficientemente alto para permitir la ejecuci\00F3n de varias solicitudes HHTP, y lo suficientemente bajo para evitar que los usuarios finales encuentren p\00E1ginas que se bloquean.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3403059783178708614.4001)
,p_name=>'P1922_ORDS_FIXED_PAGE_SIZE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(3469784605842432.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tama\00F1o de p\00E1gina fijo')
,p_source=>'LEGACY_ORDS_FIXED_PAGE_SIZE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca el tama\00F1o de la ventana de paginaci\00F3n del servicio REST. La paginaci\00F3n del m\00E9todo GET de operaciones HTTP del manejador de recursos equivale al n\00FAmero de filas que se deben devolver en cada p\00E1gina de un juego de resultados de formato JS')
||'ON basado en una consulta de la base de datos.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'10000'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3632686706193912647.4001)
,p_name=>'P1922_MODULE_BASE_URL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_prompt=>'URL base de origen de REST'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.base_url || m.url_path_prefix',
'  from wwv_remote_servers s, ',
'       wwv_flow_web_src_modules m',
' where s.id      = m.remote_server_id ',
'   and m.id      = :P1922_WEB_SRC_MODULE_ID',
'   and m.flow_id = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and s.security_group_id = m.security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3632686934550912649.4001)
,p_name=>'P1922_REST_OPERATION'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3500552115076908.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo HTTP')
,p_source=>'OPERATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_HTTP_METHODS'
,p_lov=>'.'||wwv_flow_api.id(225847729464891335.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Se ejecutar\00E1 una operaci\00F3n o un <em>m\00E9todo</em> HTTP (GET, POST, PUT, DELETE) en el servicio web REST. La combinaci\00F3n de un patr\00F3n de URL y una operaci\00F3n HTTP identifica la operaci\00F3n en un m\00F3dulo de origen de datos de REST. Un origen de datos de ')
||unistr('REST puede contener el mismo patr\00F3n de URL para diferentes operaciones HTTP y diferentes patrones de URL para la misma operaci\00F3n HTTP.'),
'</p>',
'<p>',
unistr('    A continuaci\00F3n, se ofrece una breve explicaci\00F3n sobre los m\00E9todos HTTP y su uso en los servicios REST. Tenga en cuenta que se trata de una norma que los servicios REST deben cumplir, pero que las implementaciones reales pueden ser diferentes. Com')
||unistr('pruebe siempre la documentaci\00F3n del servicio REST al que planea acceder, mediante qu\00E9 m\00E9todos puede llamarlo y c\00F3mo funcionan estos m\00E9todos.'),
'</p>',
'<ul>',
'    <li>',
unistr('        <strong>GET</strong> permite recuperar datos del servicio REST. GET se supone que es idempotente; su llamada no produce ning\00FAn cambio en el lado del servidor. Por este motivo, normalmente puede llamar o almacenar en cach\00E9 las solicitudes GET ')
||unistr('varias veces. Adem\00E1s, las solicitudes GET <em>no</em> suelen tener un cuerpo de solicitud en circunstancias normales.'),
'    </li>',
'    <li>',
unistr('        <strong>POST</strong> se suele utilizar para crear un nuevo recurso en el servidor. No obstante, en la pr\00E1ctica, las solicitudes POST pueden'),
'        llevar a cabo todo tipo de acciones. Las solicitudes POST normalmente necesitan un cuerpo de solicitud para que puedan enviarse.',
'    </li>',
'    <li>',
'        <strong>PUT</strong> se suele utilizar para <em>reemplazar</em> un nuevo recurso en el servidor. Normalmente requiere un cuerpo de solicitud. Tenga en cuenta que debe transferir <em>todos</em> los atributos al servidor; es posible que los atr'
||unistr('ibutos que falten se escriban como valores nulos o vac\00EDos.'),
'    </li>',
'    <li>',
'        <strong>DELETE</strong> se suele utilizar para eliminar un recurso en el servidor. Normalmente no requiere un cuerpo de solicitud.',
'    </li>',
'    <li>',
unistr('        <strong>PATCH</strong> se suele utilizar para <em>cambiar</em> un nuevo recurso en el servidor. No todos los servicios REST ofrecen puntos finales PATCH. Es necesario un cuerpo de solicitud que contenga la informaci\00F3n sobre qu\00E9 atributo debe ')
||unistr('cambiarse y a qu\00E9 valor se debe hacer. PATCH, por lo tanto, permite realizar actualizaciones parciales en un recurso de servidor. Tenga en cuenta que no existe ning\00FAn est\00E1ndar sobre c\00F3mo debe ser un cuerpo de solicitud para un punto final PATCH, por ')
||unistr('lo que debe comprobar la documentaci\00F3n de su servicio REST antes de llamarlo. '),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(987817765017252925.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1922_INVALIDATE_WHEN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1922_CACHING'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3632686826845912648.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1922_URL_PATTERN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'.'
,p_compute_when=>'P1922_URL_PATTERN'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(225853794807926503.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1922_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987817675354252924.4001)
,p_validation_name=>'Validate Calendaring Expression'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_next_run_timestamp timestamp with time zone;',
'    l_minutes            number;',
'begin',
'    begin',
'        l_minutes := to_number( :P1922_INVALIDATE_WHEN );',
'        return null;',
'    exception',
'        -- if not a number, then proceed with validating the calendaring expression',
'        when others then null;',
'    end;',
'',
'    begin',
'        sys.dbms_scheduler.evaluate_calendar_string(',
'            calendar_string   => :P1922_INVALIDATE_WHEN,',
'            start_date        => systimestamp,',
'            return_date_after => systimestamp,',
'            next_run_date     => l_next_run_timestamp );',
'    exception',
'        when others then',
'            return sqlerrm;',
'    end;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1922_CACHING is not null and :REQUEST in (''CREATE'', ''SAVE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3507960502076974.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3501742358076916.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3501688362076916.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3502563773076919.4001)
,p_event_id=>wwv_flow_api.id(3501742358076916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(238756406686331837.4001)
,p_name=>'Fetch All Rows changed'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_ALLOW_FETCH_ALL_ROWS'
,p_condition_element=>'P1922_ALLOW_FETCH_ALL_ROWS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(238756599332331838.4001)
,p_event_id=>wwv_flow_api.id(238756406686331837.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FETCH_ALL_ROWS_TIMEOUT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(238756628982331839.4001)
,p_event_id=>wwv_flow_api.id(238756406686331837.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FETCH_ALL_ROWS_TIMEOUT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(345457032984487511.4001)
,p_name=>'Parameter Dialog closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(922351464945024904.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(345457154129487512.4001)
,p_event_id=>wwv_flow_api.id(345457032984487511.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(922351464945024904.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(619336627441855721.4001)
,p_name=>'GET Operation'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_REST_OPERATION'
,p_condition_element=>'P1922_REST_OPERATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619336738818855722.4001)
,p_event_id=>wwv_flow_api.id(619336627441855721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619336834522855723.4001)
,p_event_id=>wwv_flow_api.id(619336627441855721.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(619336971358855724.4001)
,p_event_id=>wwv_flow_api.id(619336627441855721.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(55558820931883030.4001)
,p_name=>'Generate Request Body Template'
,p_event_sequence=>50
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1922_GENERATE_BODY_TEMPLATE'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(55558979476883031.4001)
,p_event_id=>wwv_flow_api.id(55558820931883030.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1922_REQUEST_BODY_TEMPLATE := wwv_flow_web_src_dev.f4000_build_body_template(',
'        p_web_src_module_id    => :P1922_WEB_SRC_MODULE_ID );',
'end;'))
,p_attribute_02=>'P1922_ID,P1922_WEB_SRC_MODULE_ID'
,p_attribute_03=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(55559015041883032.4001)
,p_name=>'Show / Hide Generate Request Body'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_REQUEST_BODY_TEMPLATE'
,p_condition_element=>'P1922_REQUEST_BODY_TEMPLATE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(55559151045883033.4001)
,p_event_id=>wwv_flow_api.id(55559015041883032.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1922_GENERATE_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(55559261345883034.4001)
,p_event_id=>wwv_flow_api.id(55559015041883032.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1922_GENERATE_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(987817891902252926.4001)
,p_name=>'Show / Hide Cache Expression'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_CACHING'
,p_condition_element=>'P1922_CACHING'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(987817915289252927.4001)
,p_event_id=>wwv_flow_api.id(987817891902252926.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_INVALIDATE_WHEN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(987818042507252928.4001)
,p_event_id=>wwv_flow_api.id(987817891902252926.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_INVALIDATE_WHEN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(987818108910252929.4001)
,p_event_id=>wwv_flow_api.id(987817891902252926.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_INVALIDATE_WHEN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1418473148635715.4001)
,p_name=>'Fetch Rows'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_DATABASE_OPERATION'
,p_condition_element=>'P1922_DATABASE_OPERATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FETCH_COLLECTION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1418511379635716.4001)
,p_event_id=>wwv_flow_api.id(1418473148635715.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FORCE_RAISE_404_ERROR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1418665066635717.4001)
,p_event_id=>wwv_flow_api.id(1418473148635715.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FORCE_RAISE_404_ERROR'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3511185561076981.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_03=>'P1922_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(218527273890706504.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_content_cache.purge_cache(',
'        p_application_id => :FB_FLOW_ID,',
'        p_component_type => wwv_flow_content_cache.c_comp_web_source,',
'        p_component_id   => :P1922_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(218527070654706502.4001)
,p_process_success_message=>unistr('Se ha depurado la cach\00E9 de origen de datos de REST.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3511548576076982.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_03=>'P1922_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3511918173076982.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3501137717076916.4001)
);
end;
/
prompt --application/pages/page_01923
begin
wwv_flow_api.create_page(
 p_id=>1923.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar par\00E1metro de origen de datos de REST')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Editar par\00E1metro de origen de datos de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226075893470270115.4001)
,p_plug_name=>unistr('Par\00E1metro')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226077123308270128.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226077286521270129.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249350328246883047.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>Utilice este cuadro de di\00E1logo para configurar los <em>par\00E1metros de origen de datos de REST</em>. Los par\00E1metros permiten tener partes de URL din\00E1micas o transferir cabeceras de solicitud HTTP adicionales o un cuerpo de solicitud espec\00EDfico al se')
||unistr('rvicio web. Los componentes de Application Express asignan valores a los par\00E1metros antes de llamar al servicio web.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226077814596270135.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(226077286521270129.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Agregar Par\00E1metro')
,p_button_position=>'CREATE'
,p_button_condition=>'P1923_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(206266263324173845.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(226077286521270129.4001)
,p_button_name=>'CREATE_AND_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar y Agregar otro'
,p_button_position=>'CREATE'
,p_button_condition=>'P1923_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226077706432270134.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(226077286521270129.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P1923_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226077919824270136.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(226077286521270129.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'DELETE'
,p_button_condition=>'P1923_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226077306786270130.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(226077286521270129.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(206266439752173847.4001)
,p_branch_action=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP,1923:P1923_FLOW_ID,P1923_WEB_SRC_MODULE_ID,P1923_WEB_SRC_OPERATION_ID:&P1923_FLOW_ID.,&P1923_WEB_SRC_MODULE_ID.,&P1923_WEB_SRC_OPERATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(206266263324173845.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1417954702635710.4001)
,p_name=>'P1923_ARRAY_SEPARATOR_CHAR'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(226077123308270128.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador de Valores'
,p_source=>'ARRAY_SEPARATOR_CHAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el car\00E1cter separador que se va a usar para dividir el valor. Si se deja en blanco, los valores se separar\00E1n mediante el car\00E1cter de dos puntos (":").')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226075903797270116.4001)
,p_name=>'P1923_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076164807270118.4001)
,p_name=>'P1923_WEB_SRC_MODULE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076259637270119.4001)
,p_name=>'P1923_WEB_SRC_OPERATION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'WEB_SRC_OPERATION_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076393541270120.4001)
,p_name=>'P1923_NAME'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre del par\00E1metro. En par\00E1metros de tipo Patr\00F3n de URL, no utilice prefijos con ":" ni los delimite con {}.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Aceptar'
,p_quick_pick_value_01=>'Accept'
,p_quick_pick_label_02=>'Usuario-Agente'
,p_quick_pick_value_02=>'User-Agent'
,p_quick_pick_label_03=>unistr('Autorizaci\00F3n')
,p_quick_pick_value_03=>'Authorization'
,p_quick_pick_label_04=>unistr('Control de cach\00E9')
,p_quick_pick_value_04=>'Cache-Control'
,p_quick_pick_label_05=>'Tipo de contenido'
,p_quick_pick_value_05=>'Content-Type'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076489414270121.4001)
,p_name=>'P1923_PARAM_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HEADER'
,p_prompt=>'Tipo'
,p_source=>'PARAM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione si este par\00E1metro se va a enviar como <em>cabecera de solicitud HTTP</em>, como parte de la URL (<em>variable de patr\00F3n de URL</em>), de la <em>variable de cadena de consulta</em> o como <em>cuerpo de la solicitud</em>. Los par\00E1metros ')
||unistr('de cadena de consulta se agregan a la URL <em>detr\00E1s</em> del signo de interrogaci\00F3n siguiendo el patr\00F3n "nombre=valor", mientras que las variables de patr\00F3n de la URL forman parte de la URL <em>delante</em> del signo de interrogaci\00F3n; simplemente, e')
||unistr('l nombre ser\00E1 reemplazado por el valor.'),
'</p>',
'<p>',
unistr('    Ejemplo de par\00E1metros del tipo <strong>Patr\00F3n de URL</strong>'),
'</p>',
'<ul>',
'    <li>Punto final de URL: <code>http://{server}:{port}/ords/:schema/emp/:deptno</code></li>',
unistr('    <li>Par\00E1metro 1: <em>Variable de patr\00F3n de URL</em> "deptno" con el valor "10"</li>'),
unistr('    <li>Par\00E1metro 2: <em>Variable de patr\00F3n de URL</em> "schema" con el valor "scott"</li>'),
'</ul>',
'<p>',
'<br>',
unistr('    <em>No</em> agregue dos puntos (:) al nombre del par\00E1metro. &PRODUCT_NAME. formar\00E1 la URL para llamar de la siguiente manera:<br>'),
'    <code>http://{server}:{port}/ords/<strong>scott</strong>/emp/<strong>10</strong></code>',
'</p>',
'<p>',
unistr('    Ejemplo de par\00E1metros del tipo <strong>Cadena de solicitud</strong>'),
'</p>',
'<ul>',
'    <li>Punto final de URL: <code>http://{server}:{port}/ords/scott/emp</code></li>',
unistr('    <li>Par\00E1metro 1: <em>Variable de cadena de solicitud</em> "query_filter" con el valor "KING"</li>'),
'</ul>',
'<p>',
'<br>',
unistr('    &PRODUCT_NAME. formar\00E1 la URL para llamar de la siguiente manera:<br>'),
'    <code>http://{server}:{port}/ords/scott/emp?<strong>query_filter</strong>=<strong>KING</strong></code>',
'</p>',
'<p>',
unistr('    Ejemplo de par\00E1metros del tipo <strong>Cabecera HTTP</strong>'),
'</p>',
'<ul>',
'    <li>Punto final de URL: <code>http://{server}:{port}/ords/scott/emp/</code></li>',
unistr('    <li>Par\00E1metro 1: "Accept" con el valor "application/json"</li>'),
unistr('    <li>Par\00E1metro 1: "X-Request-Hdr" con el valor "XY4711"</li>'),
'</ul>',
'<p>',
'    <br>',
unistr('    &PRODUCT_NAME. enviar\00E1 las siguientes cabeceras de solicitud HTTP:<br>'),
'    <code><strong>Accept=application/json<br>',
'          X-Request-Hdr=XY4711</strong></code>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Cabecera HTTP'
,p_quick_pick_value_01=>'HEADER'
,p_quick_pick_label_02=>unistr('Par\00E1metro de URL')
,p_quick_pick_value_02=>'URL_PATTERN'
,p_quick_pick_label_03=>'Cadena de Consulta'
,p_quick_pick_value_03=>'QUERY_STRING'
,p_quick_pick_label_04=>'Cuerpo'
,p_quick_pick_value_04=>'BODY'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076588682270122.4001)
,p_name=>'P1923_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(226077123308270128.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Necesario'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si este par\00E1metro es necesario (se debe definir siempre) o no.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076695853270123.4001)
,p_name=>'P1923_DIRECTION'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'IN'
,p_prompt=>unistr('Direcci\00F3n')
,p_source=>'DIRECTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_DIRECTIONS'
,p_lov=>'.'||wwv_flow_api.id(226101569473456167.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Los par\00E1metros de <strong>entrada</strong> se est\00E1n enviando al origen de datos de REST. Los par\00E1metros de <strong>salida</strong> solo se reciben desde el origen de datos de REST. Los par\00E1metros de <strong>entrada/salida</strong> se est\00E1n enviando y')
||' recibiendo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076748969270124.4001)
,p_name=>'P1923_VALUE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor'
,p_source=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el valor por defecto del par\00E1metro. Cuando el atributo <strong>Est\00E1tico</strong> se define en <strong>S\00ED</strong>, este valor no se puede sustituir en los componentes de &PRODUCT_NAME.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076814483270125.4001)
,p_name=>'P1923_IS_STATIC'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Est\00E1tico')
,p_source=>'IS_STATIC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'P1923_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Determine si el par\00E1metro se puede sustituir en los componentes de &PRODUCT_NAME.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226076951612270126.4001)
,p_name=>'P1923_IS_ARRAY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(226077123308270128.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Varios Valores'
,p_source=>'IS_ARRAY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Determine si este par\00E1metro de cadena de consulta soporta varios valores. Si est\00E1 activado, la cadena de consulta de URL tendr\00E1 un par\00E1metro para cada elemento de la lista de valores separados por comas.'),
'</p>',
'<p>',
unistr('    Ejemplo de valor de par\00E1metro <strong>A:B:C</strong>'),
'</p>',
'<ul>',
'    <li>Varios definidos en <strong>Activado</strong>:<br>http://api.example.com/url/path?param=A&amp;param=B&amp;param=C</li>',
'    <li>Varios definidos en <strong>Desactivado</strong>:<br>http://api.example.com/url/path?param=A:B:C</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226077077301270127.4001)
,p_name=>'P1923_PARAM_COMMENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(226077123308270128.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'PARAM_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226078297307270139.4001)
,p_name=>'P1923_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(226075893470270115.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(310206188885961946.4001)
,p_name=>'P1923_OMIT_WHEN_NULL'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(226077123308270128.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Omitir si el valor est\00E1 vac\00EDo.')
,p_source=>'OMIT_WHEN_NULL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Si se define en <strong>Activado</strong>, &PRODUCT_NAME. solo agregar\00E1 el par\00E1metro a la solicitud si el valor no est\00E1 vac\00EDo. Si se define en <strong>Desactivado</strong>, el par\00E1metro se agregar\00E1 siempre a la solicitud. Esto se aplica solo a pa')
||unistr('r\00E1metros del tipo <em>Cadena de consulta</em>, <em>Cookie</em> o <em>Cabecera HTTP</em>. '),
'</p>',
'<p>',
unistr('    Ejemplo de un par\00E1metro <strong>param2</strong> del tipo Cadena de consulta con un valor vac\00EDo.'),
'</p>',
'<ul>',
unistr('    <li>Omitir cuando el valor est\00E1 vac\00EDo definido en <strong>Desactivado</strong>:<br>'),
'    http://api.example.com/url/path?param1=value1&amp;param2=</li>',
unistr('    <li>Omitir cuando el valor est\00E1 vac\00EDo definido en <strong>Activado</strong>:<br>'),
'    http://api.example.com/url/path?param1=value1</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473241645223135113.4001)
,p_name=>'P1923_IS_QUERY_PARAM'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(226077123308270128.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Usar para b\00FAsqueda de filas')
,p_source=>'IS_QUERY_PARAM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P1923_WEB_SRC_OPERATION_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Si est\00E1 activada la opci\00F3n <strong>Usar para b\00FAsqueda de filas</strong> en un par\00E1metro origen de datos de REST, se transferir\00E1n las consultas de <em>B\00FAsqueda de filas</em> (de informes interactivos, cuadr\00EDculas interactivas o listas de valores e')
||unistr('mergentes) al servicio web con este par\00E1metro. Esto es \00FAtil si el servicio REST soporta los par\00E1metros de <em>b\00FAsqueda</em> o <em>consulta</em>.'),
'</p>',
'<p>Ejemplo:</p>',
'<p>',
unistr('    Se llama a un punto final de servicio REST con un par\00E1metro de consulta "q", por ejemplo <code>http://{server}/path/to/service?p={search-term}</code>. El origen de datos de REST tendr\00E1 definido el par\00E1metro de cadena de consulta <strong>q</strong')
||unistr('>. Si est\00E1 activada la opci\00F3n <strong>Usar para b\00FAsqueda de filas</strong>, se transferir\00E1n los t\00E9rminos de b\00FAsqueda del informe interactivo o de la fila de cuadr\00EDcula interactiva al servicio REST como par\00E1metro <strong>q</strong>.'),
'</p>',
unistr('<p>Solo se pueden usar par\00E1metros definidos en el nivel de origen de REST para la b\00FAsqueda de filas.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(226078373255270140.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1923_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226077610861270133.4001)
,p_validation_name=>'Static value provided'
,p_validation_sequence=>10
,p_validation=>'P1923_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe proporcionar un valor para los par\00E1metros est\00E1ticos.')
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'', ''CREATE'' ) and :P1923_IS_STATIC = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226076748969270124.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(510293007042814504.4001)
,p_validation_name=>'Only one parameter can be IS_QUERY_PARAM'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_params',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and web_src_module_id = :P1923_WEB_SRC_MODULE_ID',
'   and is_query_param    = ''Y''',
'   and (id               != :P1923_ID or :P1923_ID is null)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Solo se puede usar un par\00E1metro para la b\00FAsqueda de filas. Compruebe los par\00E1metros de los dem\00E1s or\00EDgenes de datos de REST.')
,p_validation_condition=>':REQUEST in ( ''APPLY_CHANGES'', ''CREATE'', ''CREATE_AND_ANOTHER'') and :P1923_IS_QUERY_PARAM = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(473241645223135113.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226077490257270131.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(226077306786270130.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226077543820270132.4001)
,p_event_id=>wwv_flow_api.id(226077490257270131.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(348488612236006004.4001)
,p_name=>'Parameter is Static'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_IS_STATIC'
,p_condition_element=>'P1923_IS_STATIC'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(348488797469006005.4001)
,p_event_id=>wwv_flow_api.id(348488612236006004.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_REQUIRED'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(348488847622006006.4001)
,p_event_id=>wwv_flow_api.id(348488612236006004.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_REQUIRED'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(348488976783006007.4001)
,p_name=>'Direction OUT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_DIRECTION'
,p_condition_element=>'P1923_DIRECTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OUT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(348489196596006009.4001)
,p_event_id=>wwv_flow_api.id(348488976783006007.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_STATIC,P1923_IS_REQUIRED,P1923_IS_QUERY_PARAM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(510293102095814505.4001)
,p_event_id=>wwv_flow_api.id(348488976783006007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_QUERY_PARAM'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(348489051273006008.4001)
,p_event_id=>wwv_flow_api.id(348488976783006007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_STATIC,P1923_IS_REQUIRED,P1923_IS_QUERY_PARAM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(310206286551961947.4001)
,p_name=>'IN Parameter can be omitted'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE'
,p_condition_element=>'P1923_PARAM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HEADER,COOKIE,QUERY_STRING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310206327469961948.4001)
,p_event_id=>wwv_flow_api.id(310206286551961947.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_OMIT_WHEN_NULL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(310206564014961950.4001)
,p_event_id=>wwv_flow_api.id(310206286551961947.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_OMIT_WHEN_NULL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(91182456895358201.4001)
,p_event_id=>wwv_flow_api.id(310206286551961947.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_OMIT_WHEN_NULL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(190996669959372734.4001)
,p_name=>'Show Multiple'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE,P1923_OMIT_WHEN_NULL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1923_PARAM_TYPE") === "QUERY_STRING" && $v("P1923_OMIT_WHEN_NULL") === "Y"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(190996736162372735.4001)
,p_event_id=>wwv_flow_api.id(190996669959372734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_ARRAY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(190996813862372736.4001)
,p_event_id=>wwv_flow_api.id(190996669959372734.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_ARRAY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(190996989632372737.4001)
,p_event_id=>wwv_flow_api.id(190996669959372734.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_ARRAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1418002466635711.4001)
,p_name=>'Is Array'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_IS_ARRAY'
,p_condition_element=>'P1923_IS_ARRAY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1418133970635712.4001)
,p_event_id=>wwv_flow_api.id(1418002466635711.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_ARRAY_SEPARATOR_CHAR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1418281293635713.4001)
,p_event_id=>wwv_flow_api.id(1418002466635711.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_ARRAY_SEPARATOR_CHAR'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226078185590270138.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_03=>'P1923_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(348489893226006016.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync new Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1923_WEB_SRC_OPERATION_ID is null then',
'    wwv_flow_web_src_dev.sync_module_attributes(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_web_src_module_id => :P1923_WEB_SRC_MODULE_ID );',
'else ',
'    wwv_flow_web_src_dev.sync_operation_attributes(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_web_src_operation_id => :P1923_WEB_SRC_OPERATION_ID );',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(226077814596270135.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226078405734270141.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_AND_ANOTHER'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226076090077270117.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_03=>'P1923_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01924
begin
wwv_flow_api.create_page(
 p_id=>1924.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Guardar en cat\00E1logo de origen de REST')
,p_alias=>'SAVE-TO-REST-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Guardar en cat\00E1logo de origen de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1466666125002236.4001)
,p_plug_name=>unistr('El origen de datos de REST ya existe en un cat\00E1logo')
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Cuando se vuelva a guardar, la entrada del cat\00E1logo <strong>&P1924_EXIST_CATALOG_NAME!HTML.</strong> se sobrescribir\00E1 con este origen de datos de REST.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1924_CATALOG_SERVICE_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228564397587963139.4001)
,p_plug_name=>unistr('Detalles de Cat\00E1logo')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228600104593880675.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(228656736076645009.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Guarde el origen de datos de REST en un cat\00E1logo de origen de REST. Los cat\00E1logos simplifican el proceso de creaci\00F3n de or\00EDgenes de datos de REST. Si ya se ha guardado un origen de datos de REST en un cat\00E1logo, este se actualizar\00E1'),
unistr('con los \00FAltimos cambios.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2701279242636205.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(228600104593880675.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2701535619636209.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(228600104593880675.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Guardar en cat\00E1logo')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28032755854072740.4001)
,p_branch_name=>'Close Dialog and Show Message'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1466593217002235.4001)
,p_name=>'P1924_CATALOG_SERVICE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1466789611002237.4001)
,p_name=>'P1924_EXIST_CATALOG_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28031165517072724.4001)
,p_name=>'P1924_CATALOG_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_prompt=>unistr('Grupo de cat\00E1logo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CATALOG_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv',
'from WWV_WEB_SRC_CATALOG_GROUPS',
'where security_group_id = :WORKSPACE_ID',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Agregar un nuevo grupo de cat\00E1logo')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from WWV_WEB_SRC_CATALOG_GROUPS ',
'where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Los grupos de cat\00E1logo se utilizan para organizar cat\00E1logos de origen de REST. Seleccione Agregar un grupo de cat\00E1logo nuevo si no se agrega el servicio a un cat\00E1logo existente.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28031264728072725.4001)
,p_name=>'P1924_CATALOG_GROUP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_prompt=>unistr('Nuevo nombre de grupo de cat\00E1logo')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Los nombres de grupos de cat\00E1logo son exclusivos del espacio de trabajo. Especifique un nombre que a\00FAn no exista.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28031386371072726.4001)
,p_name=>'P1924_CATALOG_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_prompt=>unistr('Cat\00E1logo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from wwv_web_src_catalogs',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'and catalog_group_id = :P1924_CATALOG_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Agregar un nuevo cat\00E1logo')
,p_lov_cascade_parent_items=>'P1924_CATALOG_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from WWV_WEB_SRC_CATALOG_GROUPS ',
'where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique el cat\00E1logo al que se agregar\00E1 el servicio. Seleccione Agregar un cat\00E1logo nuevo si no se agrega el servicio a un cat\00E1logo existente.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28031435029072727.4001)
,p_name=>'P1924_CATALOG_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_prompt=>unistr('Nuevo nombre de cat\00E1logo')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Los nombres de cat\00E1logo son exclusivos de un espacio de trabajo. Especifique un nombre que a\00FAn no exista.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28031580237072728.4001)
,p_name=>'P1924_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28032538814072738.4001)
,p_name=>'P1924_SERVICE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(228564397587963139.4001)
,p_prompt=>'Nombre de origen de REST'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Los nombres de cat\00E1logo son exclusivos de un espacio de trabajo. Especifique un nombre que a\00FAn no exista.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28030948212072722.4001)
,p_name=>'Cancel Button'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2701279242636205.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28031014763072723.4001)
,p_event_id=>wwv_flow_api.id(28030948212072722.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28031795691072730.4001)
,p_name=>'Catalog Group ID is null'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1924_CATALOG_GROUP_ID'
,p_condition_element=>'P1924_CATALOG_GROUP_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28032148853072734.4001)
,p_event_id=>wwv_flow_api.id(28031795691072730.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28031838631072731.4001)
,p_event_id=>wwv_flow_api.id(28031795691072730.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_GROUP_NAME,P1924_CATALOG_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28031977845072732.4001)
,p_event_id=>wwv_flow_api.id(28031795691072730.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_GROUP_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28032033019072733.4001)
,p_event_id=>wwv_flow_api.id(28031795691072730.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(28032255431072735.4001)
,p_name=>'Catalog Changed'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1924_CATALOG_ID'
,p_condition_element=>'P1924_CATALOG_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28032387107072736.4001)
,p_event_id=>wwv_flow_api.id(28032255431072735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(28032467891072737.4001)
,p_event_id=>wwv_flow_api.id(28032255431072735.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_NAME'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28031695172072729.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Import from REST Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- there are three scenarios that can happen:',
'-- 1. New Group and New Catalog',
'-- 2. Existing Group and New Catalog',
'-- 3. Existing Group and Existing Catalog ',
'if :P1924_CATALOG_GROUP_ID is null and :P1924_CATALOG_ID is null then',
'    wwv_web_src_catalog.import_from_rest_source (',
'        p_module_id             => :P1924_MODULE_ID,',
'        --',
'        p_group_name            => :P1924_CATALOG_GROUP_NAME,',
'        p_catalog_name          => :P1924_CATALOG_NAME, ',
'        p_catalog_internal_name => :P1924_CATALOG_NAME',
'        );',
'elsif :P1924_CATALOG_GROUP_ID is not null and :P1924_CATALOG_ID is null then',
'    wwv_web_src_catalog.import_from_rest_source (',
'        p_module_id             => :P1924_MODULE_ID,',
'        --',
'        p_group_id              => :P1924_CATALOG_GROUP_ID,',
'        p_catalog_name          => :P1924_CATALOG_NAME, ',
'        p_catalog_internal_name => :P1924_CATALOG_NAME',
'        );',
'else',
'    wwv_web_src_catalog.import_from_rest_source (',
'        p_module_id             => :P1924_MODULE_ID,',
'        p_catalog_id            => :P1924_CATALOG_ID',
'        );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2701535619636209.4001)
,p_process_success_message=>unistr('El origen de datos de REST se ha agregado al cat\00E1logo correctamente')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(28032677310072739.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_catalog_internal_name wwv_flow_web_src_modules.catalog_internal_name%type;',
'    l_catalog_service_name  wwv_flow_web_src_modules.catalog_service_name%type;',
'    --',
'    l_catalog_id            wwv_web_src_catalogs.id%type;',
'    l_catalog_service_id    wwv_web_src_catalog_services.id%type;',
'    l_group_id              wwv_web_src_catalog_groups.id%type;',
'begin',
'    --',
'    -- default the service name to be the same as the module name. Also determine whether this',
'    -- service actually was created based on the catalog. Then we will likely want to save it back',
'    -- to the same catalog.',
'    -- ',
'    select name, ',
'           catalog_internal_name, ',
'           catalog_service_name',
'      into :P1924_SERVICE_NAME, ',
'           l_catalog_internal_name,',
'           l_catalog_service_name',
'      from wwv_flow_web_src_modules ',
'     where id                = :P1924_MODULE_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'',
'    --',
'    -- If the REST Source points to a catalog, let''s fetch its details.',
'    --',
'    if l_catalog_internal_name is not null and l_catalog_service_name is not null then',
'        begin',
'            select id, ',
'                   catalog_group_id,',
'                   name',
'              into l_catalog_id, ',
'                   l_group_id,',
'                   :P1924_EXIST_CATALOG_NAME',
'              from wwv_web_src_catalogs',
'             where internal_name     = l_catalog_internal_name',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'        exception',
'            when no_data_found then',
'                null; -- the referenced catalog is not present in the workspace; do nothing.',
'        end;',
'        if l_catalog_id is not null then',
'            begin',
'                select id',
'                  into l_catalog_service_id',
'                  from wwv_web_src_catalog_services',
'                 where name              = l_catalog_service_name',
'                   and catalog_id        = l_catalog_id',
'                   and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'            exception',
'                when no_data_found then',
'                    null; -- the catalog is there, but the referenced service does not exist; do nothing.',
'            end;',
'        end if;',
'    end if;',
'    --',
'    -- we did not find the catalog service, which the REST Data Source points to.',
'    --',
'    if l_catalog_id is null or l_group_id is null then',
'        begin',
'            select id, ',
'                   catalog_group_id',
'              into l_catalog_id, ',
'                   l_group_id',
'              from wwv_web_src_catalogs',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and rownum = 1;',
'        exception',
'            when no_data_found then',
'                null; -- we don''t have any catalog or group, so all variables remain empty.',
'        end;       ',
'    end if;',
'',
'    :P1924_CATALOG_GROUP_ID   := l_group_id;',
'    :P1924_CATALOG_ID         := l_catalog_id;',
'    :P1924_CATALOG_SERVICE_ID := l_catalog_service_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01925
begin
wwv_flow_api.create_page(
 p_id=>1925.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Perfil de Datos'
,p_page_mode=>'MODAL'
,p_step_title=>'Perfil de Datos'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'    // listen for view change events to find out when grid views are created ',
'    $("#profile_columns").on("interactivegridviewchange", function(event, data) {',
'        if ( data.view === "grid" && data.created ) {',
'            var view = apex.region("profile_columns").widget().interactiveGrid("getViews", "grid"),',
'                menu$ = view.selActionMenu$;',
'',
'            menu$.menu("option").items.push({',
'                type:"action",',
'                label:apex.lang.formatMessage("APEX.WEBSRC.HIDE_COLUMNS"),',
'                action: function(menu, element) {',
'                    var i, records = view.getSelectedRecords(),',
'                        total = 0;',
'                    for ( i = 0; i < records.length; i++) {',
'                        view.model.setValue(records[i], "IS_HIDDEN", "Y" );',
'                    }',
'                }',
'            });',
'            menu$.menu("option").items.push({',
'                type:"action",',
'                label:apex.lang.formatMessage("APEX.WEBSRC.SHOW_COLUMNS"),',
'                action: function(menu, element) {',
'                    var i, records = view.getSelectedRecords(),',
'                        total = 0;',
'                    for ( i = 0; i < records.length; i++) {',
'                        view.model.setValue(records[i], "IS_HIDDEN", "N" );',
'                    }',
'                }',
'            });',
'',
'        }',
'    });',
'});'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1643198339019603.4001)
,p_plug_name=>unistr('Nueva detecci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225857161514926537.4001)
,p_plug_name=>'Columnas'
,p_region_name=>'profile_columns'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       rowid,',
'       data_profile_id,',
'       name,',
'       sequence,',
'       is_primary_key,',
'       is_hidden,',
'       data_type,',
'       column_type,',
'       selector_type,',
'       selector as definition,',
'       case when :P1925_CAN_DELETE_COLUMNS = ''N'' then ''U'' else ''UD'' end as allowed_operations',
'  from wwv_flow_data_profile_cols',
' where flow_id         = :FB_FLOW_ID',
'   and data_profile_id = :P1925_DATA_PROFILE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4703873828940034.4001)
,p_name=>'SELECTOR_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SELECTOR_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Tipo de selector'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(5203249727555533)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_condition=>'P1925_FORMAT'
,p_display_condition2=>'CSV:XLSX'
,p_readonly_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_readonly_condition=>'COLUMN_TYPE'
,p_readonly_condition2=>'DATA'
,p_readonly_for_each_row=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226686705372475229.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>10
,p_value_alignment=>'CENTER'
,p_link_target=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:RP,1926:P1926_DATA_PROFILE_ID,P1926_DATA_PROFILE_COLUMN_ID:&DATA_PROFILE_ID.,&ID.'
,p_link_text=>'<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Editar columna</span>'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226686811546475230.4001)
,p_name=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_PROFILE_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226686952304475231.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>128
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226687058522475232.4001)
,p_name=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Secuencia'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226687176121475233.4001)
,p_name=>'IS_PRIMARY_KEY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_PRIMARY_KEY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>90
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226687236762475234.4001)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Tipo de Dato'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(225929676126476839)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Seleccionar -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226687365646475235.4001)
,p_name=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ROWID'
,p_data_type=>'ROWID'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226687497143475236.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>30
,p_enable_hide=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(226687542527475237.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>20
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_enable_hide=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(238756746319331840.4001)
,p_name=>'COLUMN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Tipo de Columna'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(242159593404725778)
,p_lov_display_extra=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(241340995165308320.4001)
,p_name=>'ALLOWED_OPERATIONS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ALLOWED_OPERATIONS'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>110
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(241343315925308344.4001)
,p_name=>'DEFINITION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DEFINITION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Selector'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_readonly_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_readonly_condition=>'COLUMN_TYPE'
,p_readonly_condition2=>'DATA'
,p_readonly_for_each_row=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3403059846974708615.4001)
,p_name=>'IS_HIDDEN'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_HIDDEN'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Visible'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_condition2=>'Y'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(226686688953475228.4001)
,p_internal_uid=>226686688953475228
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_edit_row_operations_column=>'ALLOWED_OPERATIONS'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No se ha definido ninguna columna.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>true
,p_download_formats=>'HTML'
,p_enable_mail_download=>false
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>500
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225858059630926546.4001)
,p_plug_name=>'Perfil de Datos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225897994729244504.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225899174154244516.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225950832517615712.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Los <strong>perfiles de datos</strong> describen c\00F3mo se analizan los formatos de origen de datos y se convierten en filas y columnas. En el caso del formato de datos XML o JSON, el atributo <strong>Selector de filas</strong> almacena una expresi\00F3n d')
||unistr('e ruta de acceso de XML o JSON que apunta al nodo que contiene la recopilaci\00F3n de filas. Las <strong>columnas de perfil de datos</strong> determinan c\00F3mo se analiza una fila y se convierte en varias columnas.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226688443210475246.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(225899174154244516.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225950605461615710.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(225857161514926537.4001)
,p_button_name=>'RESEQUENCE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cambiar secuencia de columnas'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529291733256976411.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1643198339019603.4001)
,p_button_name=>'REDISCOVER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Volver a detectar perfil de datos'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_operations',
' where web_src_module_id  = :P1921_WEB_SRC_MODULE_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and database_operation = ''FETCH_COLLECTION'''))
,p_button_condition_type=>'EXISTS'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225899226130244517.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(225899174154244516.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P1925_DATA_PROFILE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3403059643022708613.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(225857161514926537.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Agregar Columna'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:RP,1926:P1926_DATA_PROFILE_ID,P1926_FLOW_ID:&P1925_DATA_PROFILE_ID.,&P1925_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(529291992121976413.4001)
,p_branch_name=>'Go To Page 1948'
,p_branch_action=>'f?p=&APP_ID.:1948:&SESSION.::&DEBUG.:RP:P1948_WEB_SRC_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(529291733256976411.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1643010183019602.4001)
,p_name=>'P1925_SAMPLE_RESPONSE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1643198339019603.4001)
,p_prompt=>'Respuesta de ejemplo'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Cuando se vuelva a detectar el perfil de datos, se puede cargar aqu\00ED un ejemplo de la respuesta del servicio REST. Application Express analizar\00E1 esta respuesta en vez de comunicarse con el servicio REST. Esto podr\00EDa utilizarse si la comunicaci\00F3n con ')
||unistr('el servicio REST no es posible o si la autenticaci\00F3n necesaria no est\00E1 disponible durante el tiempo de dise\00F1o.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1813920010055316.4001)
,p_name=>'P1925_SINGLE_ROW_SELECTOR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Selector de fila \00FAnica')
,p_source=>'SINGLE_ROW_SELECTOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('     Esto se utiliza para los servicios REST que devuelvan un objeto simple o una matriz de JSON, seg\00FAn la solicitud real. Introduzca la expresi\00F3n del selector para seleccionar una \00FAnica fila de la respuesta de origen de datos de REST. '),
'</p>',
'<p>',
'    Ejemplo:',
'</p>',
'<ul>',
'    <li>El punto final de un servicio REST devuelve una matriz de JSON: el perfil de datos devuelve una <strong>tabla</strong><br>',
'        <code>http://{server}/path/service/emp</code><br>',
'        <pre>',
'{ "header": { "generated": "2018-10-19", "version": "1.0" },',
'  "body": { "items": [',
'          { "ename": "SMITH", "sal": 200 },',
'          { "ename": "SCOTT", "sal": 100 } ] } }        ',
'        </pre>',
'    </li>',
'    <li>Cuando se agrega un identificador a la URL, solo se devuelve una fila:<br>',
'        <code>http://{server}/path/service/emp/<strong>SMITH</strong></code><br>',
'        <pre>',
'{ "header": { "generated": "2018-10-19", "version": "1.0" },',
'  "body":   { "ename": "SMITH", "sal": 200 } }',
'        </pre>',
'    </li>',
'</ul>',
'<p>',
unistr('    En este caso, utilice <strong>body</strong> como <strong>selector de fila \00FAnica</strong>. El atributo <strong>Selector de filas</strong> (arriba) debe estar definido en <strong>body.items</strong>.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2563962992654037.4001)
,p_name=>'P1925_IS_WEB_SRC_PROFILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7124783422468901.4001)
,p_name=>'P1925_CSV_SEPARATOR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Delimitador de Columna'
,p_source=>'CSV_SEPARATOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_api.id(1963861252255121.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Ninguno (detecci\00F3n autom\00E1tica)')
,p_cSize=>20
,p_cMaxlength=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un car\00E1cter de delimitador de columna. Si no se especifica, &PRODUCT_NAME. detectar\00E1 autom\00E1ticamente uno de los siguientes caracteres, en funci\00F3n del recuento de incidencias en la primera l\00EDnea.'),
'</p>',
'<ul>',
'<li>;</li>',
'<li>,</li>',
'<li>|</li>',
'<li>#</li>',
'<li>[tabulador]</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7124845259468902.4001)
,p_name=>'P1925_CSV_ENCLOSED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Delimitado Opcionalmente por'
,p_source=>'CSV_ENCLOSED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_api.id(1966044064255150.4001)||'.'
,p_cSize=>20
,p_cMaxlength=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione una columna delimitada por un car\00E1cter.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7124913659468903.4001)
,p_name=>'P1925_DEFAULT_XLSX_SHEET_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de hoja por defecto'
,p_source=>'DEFAULT_XLSX_SHEET_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la hoja de trabajo XLSX que analizar por defecto. Si no se define, en la carga de datos se utilizar\00E1 la primera hoja de trabajo encontrada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7125069346468904.4001)
,p_name=>'P1925_SKIP_ROWS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Omitir filas'
,p_source=>'SKIP_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca el n\00FAmero de filas que omitir desde el comienzo del archivo, antes de que comience el an\00E1lisis de los datos.</p> ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7125133422468905.4001)
,p_name=>'P1925_HAS_HEADER_ROW'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('La primera l\00EDnea contiene cabeceras')
,p_source=>'HAS_HEADER_ROW'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Active esta opci\00F3n para los perfiles de datos CSV o XLSX si los datos contienen nombres de columna en la primera fila.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225858181421926547.4001)
,p_name=>'P1925_DATA_PROFILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225858472747926550.4001)
,p_name=>'P1925_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225897751791244502.4001)
,p_name=>'P1925_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre para el perfil de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225897810804244503.4001)
,p_name=>'P1925_FORMAT'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'JSON'
,p_prompt=>'Formato'
,p_source=>'FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1925_DATA_PROFILE_FORMAT'
,p_lov=>'.'||wwv_flow_api.id(607713258081514419.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1925_IS_WEB_SRC_PROFILE = ''N'' then',
'    for l_data_load in (',
'        select id',
'        from wwv_flow_load_tables',
'        where data_profile_id = :P1925_DATA_PROFILE_ID',
'        and flow_id = :FB_FLOW_ID',
'        and security_group_id = :WORKSPACE_ID )',
'    loop',
'        if wwv_flow_data_loader_dev.is_data_load_used(',
'            p_application_id => :FB_FLOW_ID,',
'            p_data_load_id   => l_data_load.id ) then',
'            return true;',
'        end if;',
'    end loop;',
'end if;',
'return false;'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione el formato de datos. En Carga de datos, est\00E1n soportados los formatos CSV, JSON, XLSX y XML. En Or\00EDgenes de datos de REST, se pueden seleccionar los formatos JSON, XML y CSV.'),
'    </p>',
'    <p>Cuando se utilice con un origen de datos REST, la respuesta CSV debe contener cabeceras de columna como primera fila.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225898074590244505.4001)
,p_name=>'P1925_ENCODING'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Codificaci\00F3n')
,p_source=>'ENCODING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Valor por defecto -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una codificaci\00F3n de los datos. Utilice <strong>Valor por defecto</strong> para considerar el archivo como si estuviera codificado en el <em>juego de caracteres de la base de datos</em>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225898168261244506.4001)
,p_name=>'P1925_DECIMAL_CHARACTERS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Caracteres Num\00E9ricos')
,p_source=>'DECIMAL_CHARACTERS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>2
,p_cMaxlength=>2
,p_tag_attributes=>'style="font-family: monospace"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca los caracteres num\00E9ricos que se van a utilizar para analizar los tipos de dato num\00E9ricos. Si no se especifica nada, se utilizar\00E1 "." como car\00E1cter decimal para los perfiles de datos XML y JSON. Para los perfiles de datos CSV y XLSX. se uti')
||unistr('lizar\00E1n los valores por defecto de la sesi\00F3n. '),
'</p>',
'<p>',
'Este atributo funciona como valor por defecto para todas las columnas; cada columna puede tener distintas sustituciones.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225898285554244507.4001)
,p_name=>'P1925_IS_SINGLE_ROW'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Contiene una fila'
,p_source=>'IS_SINGLE_ROW'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione <strong>Activado</strong> si la respuesta contiene <em>siempre</em> una \00FAnica fila y ninguna recopilaci\00F3n. Seleccione <strong>Desactivado</strong> si la respuesta contiene varias filas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225898330426244508.4001)
,p_name=>'P1925_XML_NAMESPACES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espacios de nombres XML'
,p_source=>'XML_NAMESPACES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca la informaci\00F3n de espacio de nombre para analizar respuestas XML aqu\00ED. Utilice el siguiente formato:'),
'</p>',
'<pre>',
'<em>namespace-uri-1</em>=<em>namespace-prefix-1</em><em>CR</em>',
'<em>namespace-uri-2</em>=<em>namespace-prefix-2</em><em>CR</em>',
':',
'</pre>',
'<h2>',
'    Ejemplo:',
'</h2>',
'<pre>',
'http://xmlns.oracle.com/xdb=<strong>xdb</strong>',
'http://www.w3.org/2005/Atom=<strong>atom</strong>',
'</pre>',
'<p>',
'    Los prefijos de espacios de nombres definidos se pueden utilizar en los selectores de columna y fila de perfil de datos.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225898750991244512.4001)
,p_name=>'P1925_PROFILE_COMMENT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(225897994729244504.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario de perfil'
,p_source=>'PROFILE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226131367554626803.4001)
,p_name=>'P1925_ROW_SELECTOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(225858059630926546.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Selector de Filas'
,p_source=>'ROW_SELECTOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Para un perfil de datos que devuelva una tabla, introduzca la expresi\00F3n para seleccionar la recopilaci\00F3n de filas incluida en el origen de datos. Normalmente, la recopilaci\00F3n de filas es una matriz de JSON o una <em>recopilaci\00F3n</em> XML (en XML ')
||unistr('una secuencia de etiquetas con el mismo nombre). Las matrices o las <em>recopilaciones</em> XML anidadas no est\00E1n soportadas.'),
'</p>',
'<p>',
'    Si el selector de filas',
unistr('    hace referencia a un \00FAnico objeto de JSON, el atributo de perfil de datos <strong>Contiene una fila</strong> debe definirse en <strong>S\00ED</strong>. Deje el atributo vac\00EDo o introduzca <strong>"."</strong> si la matriz o el objeto de JSON est\00E1n a ')
||unistr('nivel ra\00EDz. '),
'</p>',
'<h2>',
'    Ejemplo 1:',
'</h2>',
'<pre>',
'{ "items": [',
'    { "ename": "SMITH", "sal": 200 },',
'    { "ename": "SCOTT", "sal": 100 } ] }',
'</pre>',
'<p>',
unistr('    El atributo de JSON contiene una matriz en el atributo <strong>items</strong>, as\00ED que selecci\00F3nelo como selector de filas. Los elementos incluidos en la matriz se considerar\00E1 filas y cada atributo se considerar\00E1 una columna.'),
'</p>',
'<h2>',
'    Ejemplo 2:',
'</h2>',
'<pre>',
'{ "header": { "generated": "2018-10-19", "version": "1.0" },',
'  "body": { "items": [',
'          { "ename": "SMITH", "sal": 200 },',
'          { "ename": "SCOTT", "sal": 100 } ] } }',
'</pre>',
'<p>',
unistr('    El atributo de JSON contiene una matriz en el atributo <strong>body.items</strong>, as\00ED que selecci\00F3nelo como selector de filas. Los elementos incluidos en la matriz se considerar\00E1 filas y cada atributo se considerar\00E1 una columna.'),
'</p>',
' <h2>',
'    Ejemplo 3:',
'</h2>',
'<pre>',
'&lt;xml-document&gt;',
'  &lt;row&gt;',
'    &lt;ename&gt;SMITH&lt;/ename&gt;&lt;sal&gt;200&lt;/sal&gt;',
'  &lt;/row&gt;',
'  &lt;row&gt;',
'    &lt;ename&gt;SCOTT&lt;/ename&gt;&lt;sal&gt;100&lt;/sal&gt;',
'  &lt;/row&gt;',
'&lt;xml-document&gt;',
'</pre>   ',
'    <p>',
unistr('    El atributo de etiqueta XML <strong>/xml-document/row</strong> contiene una <em>recopilaci\00F3n</em>, as\00ED que selecci\00F3nelo como selector de filas. Cada objeto <strong>row</strong> se considerar\00E1 una fila y cada etiqueta secundaria &lt;row&gt; se con')
||unistr('siderar\00E1 una columna.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(241340865499308319.4001)
,p_name=>'P1925_CAN_DELETE_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225857161514926537.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(225950474167615708.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1925_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(7127782300468931.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1925_CSV_ENCLOSED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1925_CSV_ENCLOSED'
,p_compute_when_text=>'None'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4502694639479010.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1925_CSV_SEPARATOR'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'chr(9)'
,p_compute_when=>'P1925_CSV_SEPARATOR'
,p_compute_when_text=>'tab'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2564014108654038.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1925_IS_WEB_SRC_PROFILE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_web_src in (',
'    select id ',
'    from wwv_flow_web_src_modules',
'    where flow_id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'    and data_profile_id = :P1925_DATA_PROFILE_ID )',
'loop',
'    return ''Y'';',
'end loop;',
'return ''N'';'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(241341016963308321.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1925_CAN_DELETE_COLUMNS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''N'' as can_delete from dual where  exists( ',
'    select r.id ',
'      from wwv_flow_page_plugs r, wwv_flow_web_src_modules m',
'     where m.data_profile_id   = :P1925_DATA_PROFILE_ID',
'       and m.id                = r.web_src_module_id',
'       and m.security_group_id = r.security_group_id',
'       and m.flow_id           = r.flow_id',
'       and m.flow_id           = :FB_FLOW_ID )    '))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(225950528415615709.4001)
,p_validation_name=>'Numeric Characters have length of 2'
,p_validation_sequence=>10
,p_validation=>'length( :P1925_DECIMAL_CHARACTERS ) = 2'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Los caracteres num\00E9ricos deben ser dos caracteres exactamente, por ejemplo, ".,"')
,p_associated_item=>wwv_flow_api.id(225898168261244506.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(242269738009871846.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(225857161514926537.4001)
,p_validation_name=>'CLOB not allowed for JSON content on database 12c'
,p_validation_sequence=>20
,p_validation=>'DATA_TYPE'
,p_validation2=>'CLOB'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>unistr('Para perfiles de datos JSON, el tipo de datos CLOB solo est\00E1 soportado en Oracle Database 18c y versiones posteriores.')
,p_validation_condition=>':P1925_FORMAT = ''JSON'' and sys.dbms_db_version.version < 18'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'DATA_TYPE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7126144693468915.4001)
,p_validation_name=>'header row cannot be N if name selector exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_data_profile_cols',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and data_profile_id = :P1925_DATA_PROFILE_ID',
'and :P1925_FORMAT in ( ''CSV'', ''XLSX'' )',
'and column_type = ''DATA''',
'and selector_type = ''NAME'''))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La opci\00F3n La primera l\00EDnea contiene cabeceras no se puede desactivar porque hay columnas basadas en el tipo de selector Nombre.')
,p_validation_condition=>'P1925_HAS_HEADER_ROW'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(7125133422468905.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4502932146479013.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(225857161514926537.4001)
,p_validation_name=>'selector must be num and 1 to 300'
,p_validation_sequence=>40
,p_validation=>'wwv_flow_utilities.is_number( p_number => :DEFINITION ) and :DEFINITION between 1 and 300'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El selector debe ser num\00E9rico y estar comprendido entre 1 y 300.')
,p_validation_condition=>':DEFINITION is not null and :SELECTOR_TYPE = ''SEQ'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(225898414627244509.4001)
,p_name=>'XML Format chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'XML'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225898564652244510.4001)
,p_event_id=>wwv_flow_api.id(225898414627244509.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_XML_NAMESPACES'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225898648442244511.4001)
,p_event_id=>wwv_flow_api.id(225898414627244509.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_XML_NAMESPACES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3403062358479708640.4001)
,p_name=>'Resequence'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(225950605461615710.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403062571723708642.4001)
,p_event_id=>wwv_flow_api.id(3403062358479708640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Las columnas de perfil de datos se volver\00E1n a secuenciar por pasos de 10. \00BFDesea continuar?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403062442014708641.4001)
,p_event_id=>wwv_flow_api.id(3403062358479708640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'RESEQUENCE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1814057496055317.4001)
,p_name=>'Single Row Profile chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_IS_SINGLE_ROW'
,p_condition_element=>'P1925_IS_SINGLE_ROW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1814127997055318.4001)
,p_event_id=>wwv_flow_api.id(1814057496055317.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SINGLE_ROW_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1814244454055319.4001)
,p_event_id=>wwv_flow_api.id(1814057496055317.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SINGLE_ROW_SELECTOR'
,p_client_condition_type=>'NOT_EQUALS'
,p_client_condition_element=>'P1925_FORMAT'
,p_client_condition_expression=>'CSV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1814309221055320.4001)
,p_event_id=>wwv_flow_api.id(1814057496055317.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SINGLE_ROW_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2560563897654003.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(226688443210475246.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2560606381654004.4001)
,p_event_id=>wwv_flow_api.id(2560563897654003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5270198022575515.4001)
,p_name=>'XML or JSON Format chosen'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'XML, JSON'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5270202558575516.4001)
,p_event_id=>wwv_flow_api.id(5270198022575515.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_ROW_SELECTOR,P1925_IS_SINGLE_ROW,P1925_SINGLE_ROW_SELECTOR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5270357968575517.4001)
,p_event_id=>wwv_flow_api.id(5270198022575515.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_ROW_SELECTOR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607706988479483807.4001)
,p_event_id=>wwv_flow_api.id(5270198022575515.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_IS_SINGLE_ROW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7125279847468906.4001)
,p_name=>'CSV or XLSX Format chosen'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CSV, XLSX'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7125373053468907.4001)
,p_event_id=>wwv_flow_api.id(7125279847468906.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SKIP_ROWS,P1925_HAS_HEADER_ROW'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7125459858468908.4001)
,p_event_id=>wwv_flow_api.id(7125279847468906.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SKIP_ROWS,P1925_HAS_HEADER_ROW'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7125568806468909.4001)
,p_name=>'CSV Format chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CSV'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7125673086468910.4001)
,p_event_id=>wwv_flow_api.id(7125568806468909.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_CSV_SEPARATOR,P1925_CSV_ENCLOSED'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7125723899468911.4001)
,p_event_id=>wwv_flow_api.id(7125568806468909.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_CSV_SEPARATOR,P1925_CSV_ENCLOSED'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607706855360483806.4001)
,p_event_id=>wwv_flow_api.id(7125568806468909.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_IS_SINGLE_ROW,P1925_SINGLE_ROW_SELECTOR'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(7125845900468912.4001)
,p_name=>'XLSX Format chosen'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'XLSX'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7125920195468913.4001)
,p_event_id=>wwv_flow_api.id(7125845900468912.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_DEFAULT_XLSX_SHEET_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(7126005707468914.4001)
,p_event_id=>wwv_flow_api.id(7125845900468912.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_DEFAULT_XLSX_SHEET_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4502739754479011.4001)
,p_name=>'set to tab if CSV sep is chr(9)'
,p_event_sequence=>100
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4502843850479012.4001)
,p_event_id=>wwv_flow_api.id(4502739754479011.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_CSV_SEPARATOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'tab'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>':P1925_CSV_SEPARATOR = chr(9)'
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226687617423475238.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(225857161514926537.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Columns - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(225899226130244517.4001)
,p_process_success_message=>'Se han guardado las columnas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225950708073615711.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Re-Sequence Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_data_profile_dev.resequence_columns(',
'        p_data_profile_id => :P1925_DATA_PROFILE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(225950605461615710.4001)
,p_process_success_message=>'Columnas con secuencia cambiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225950382039615707.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_DATA_PROFILES'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILES'
,p_attribute_03=>'P1925_DATA_PROFILE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(529291815946976412.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Rediscover'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sample_response blob;',
'begin',
'    if :P1925_SAMPLE_RESPONSE is not null then',
'        select blob_content',
'          into l_sample_response',
'          from wwv_flow_temp_files',
'         where name = :P1925_SAMPLE_RESPONSE;',
'    end if;',
'    ',
'    wwv_flow_web_src_dev.rediscover( ',
'        p_web_src_module_id => :P1921_WEB_SRC_MODULE_ID,',
'        p_sample_response   => l_sample_response );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(529291733256976411.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(691709150557978018.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(225899226130244517.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225897653516244501.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row of WWV_FLOW_DATA_PROFILES'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILES'
,p_attribute_03=>'P1925_DATA_PROFILE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01926
begin
wwv_flow_api.create_page(
 p_id=>1926.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Columna de perfil de datos'
,p_page_mode=>'MODAL'
,p_step_title=>'Columna de perfil de datos'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4321474631183316.4001)
,p_plug_name=>'Consulta'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4701992042940015.4001)
,p_plug_name=>unistr('Transformaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225899656946244521.4001)
,p_plug_name=>'Columna'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225900987898244534.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225901106053244536.4001)
,p_plug_name=>'Origen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225902044106244545.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225950963282615713.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>Configurar atributos de una <strong>columna de perfil de datos</strong>: las columnas <strong>de datos</strong> tienen un <strong>selector</strong> y contienen valores extra\00EDdos directamente de los datos de origen. Las columnas <strong>Expresi\00F3n S')
||'QL</strong>, <strong>Consulta SQL</strong> o <strong>Consulta</strong> contienen valores derivados de las columnas de datos con expresiones SQL, consultas SQL o consultas de tabla.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225902553246244550.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(225900987898244534.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225902408094244549.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(225900987898244534.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225902339905244548.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(225900987898244534.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'DELETE'
,p_button_condition=>':P1926_DATA_PROFILE_COLUMN_ID is not null and :P1925_CAN_DELETE_COLUMNS is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225901013547244535.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(225900987898244534.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(225950281133615706.4001)
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:RP,1926::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2103442653254230.4001)
,p_name=>'P1926_IS_FILTERABLE'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Se puede filtrar'
,p_source=>'IS_FILTERABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Determina si esta columna se puede filtrar en el servidor. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4321281549183314.4001)
,p_name=>'P1926_DECIMAL_CHAR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225902044106244545.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Car\00E1cter Decimal')
,p_source=>'DECIMAL_CHAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>1
,p_cMaxlength=>1
,p_tag_attributes=>'style="font-family: monospace"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca el car\00E1cter decimal que se va a utilizar para analizar los tipos de dato num\00E9ricos. Este valor sustituye el atributo <strong>Caracteres num\00E9ricos</strong> especificado en el nivel de perfil de datos. '),
'</p>',
'<p>',
unistr('Si no se especifica nada, se utilizar\00E1 "." para los perfiles de datos XML y JSON. Para los perfiles de datos CSV y XLSX, se utilizar\00E1 la configuraci\00F3n de NLS de la sesi\00F3n actual. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4321336252183315.4001)
,p_name=>'P1926_GROUP_CHAR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(225902044106244545.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Car\00E1cter de grupo')
,p_source=>'GROUP_CHAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>1
,p_cMaxlength=>1
,p_tag_attributes=>'style="font-family: monospace"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca el car\00E1cter de grupo que se va a utilizar para analizar los tipos de dato num\00E9ricos. Este valor sustituye el atributo <strong>Caracteres num\00E9ricos</strong> especificado en el nivel de perfil de datos. '),
'</p>',
'<p>',
unistr('Si no se especifica nada, no se utilizar\00E1 ning\00FAn valor para los perfiles de datos XML y JSON. Para los perfiles de datos CSV y XLSX, se utilizar\00E1 la configuraci\00F3n de NLS de la sesi\00F3n actual. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4321508502183317.4001)
,p_name=>'P1926_LOOKUP_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario'
,p_source=>'LOOKUP_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Esquema de an\00E1lisis -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Especifique el propietario de la tabla de consulta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4321628443183318.4001)
,p_name=>'P1926_LOOKUP_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Tabla'
,p_source=>'LOOKUP_TABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique el nombre de la tabla de consulta.</p>',
'<p><strong>Ejemplo:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
unistr('<li>Configure la columna <strong>DNAME_LOADED</strong> como columna <strong>Datos</strong> con el selector de <strong>DNAME</strong> o <strong>4</strong> (en funci\00F3n del tipo de selector).</li>'),
'<li>Utilice <strong>DEPTNO</strong> como nombre de columna de perfil de datos y <strong>Consulta</strong> como tipo de columna.</li>',
'<li>Utilice <strong>DEPT</strong> como <strong>nombre de tabla</strong></li>',
unistr('<li>Utilice <strong>DEPTNO</strong> como <strong>columna de devoluci\00F3n</strong></li>'),
'<li>Utilice <strong>DNAME</strong> como <strong>columna de tabla 1</strong></li>',
'<li>Utilice <strong>DNAME_LOADED</strong> como <strong>columna de datos 1</strong>. Tenga en cuenta que esto hace referencia a la columna del perfil de datos que contenga los datos realmente cargados.</li>',
'</ul>',
'<p>',
'<br>',
unistr('Como consecuencia, &PRODUCT_NAME. consultar\00E1 los valores de <strong>DEPTNO</strong> de la tabla <strong>DEPT</strong>, con los valores cargados de <strong>DNAME</strong>. Estos se cargar\00E1n como columna <strong>DEPTNO</strong> de la tabla de destino.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4321734839183319.4001)
,p_name=>'P1926_LOOKUP_KEY_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Devolver Columna'
,p_source=>'LOOKUP_KEY_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione el valor de columna que se va a devolver y cargar en la tabla de destino. Este valor suele ser el valor de clave principal del principal en una relaci\00F3n de clave ajena.'),
'</p>',
'<p><strong>Ejemplo:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
unistr('<li>Configure la columna <strong>DNAME_LOADED</strong>, como columna <strong>Datos</strong> con el selector de <strong>DNAME</strong> o <strong>4</strong> (en funci\00F3n del tipo de selector).</li>'),
'<li>Utilice <strong>DEPTNO</strong> como nombre de columna de perfil de datos y <strong>Consulta</strong> como tipo de columna.</li>',
'<li>Utilice <strong>DEPT</strong> como <strong>nombre de tabla</strong></li>',
unistr('<li>Utilice <strong>DEPTNO</strong> como <strong>columna de devoluci\00F3n</strong></li>'),
'<li>Utilice <strong>DNAME</strong> como <strong>columna de tabla 1</strong></li>',
'<li>Utilice <strong>DNAME_LOADED</strong> como <strong>columna de datos 1</strong>. Tenga en cuenta que esto hace referencia a la columna del perfil de datos que contenga los datos realmente cargados.</li>',
'</ul>',
'<p>',
'<br>',
unistr('Como consecuencia, &PRODUCT_NAME. consultar\00E1 los valores de <strong>DEPTNO</strong> de la tabla <strong>DEPT</strong>, con los valores cargados de <strong>DNAME</strong>. Estos se cargar\00E1n como columna <strong>DEPTNO</strong> de la tabla de destino.'),
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4321894045183320.4001)
,p_name=>'P1926_LOOKUP_COLUMN1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de tabla 1'
,p_source=>'LOOKUP_COLUMN1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre de la primera columna que usar para recuperar la columna de devoluci\00F3n de la tabla de consulta.</p>'),
'<p><strong>Ejemplo:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
unistr('<li>Configure la columna <strong>DNAME_LOADED</strong> como columna <strong>Datos</strong> con el selector de <strong>DNAME</strong> o <strong>4</strong> (en funci\00F3n del tipo de selector).</li>'),
'<li>Utilice <strong>DEPTNO</strong> como nombre de columna de perfil de datos y <strong>Consulta</strong> como tipo de columna.</li>',
'<li>Utilice <strong>DEPT</strong> como <strong>nombre de tabla</strong></li>',
unistr('<li>Utilice <strong>DEPTNO</strong> como <strong>columna de devoluci\00F3n</strong></li>'),
'<li>Utilice <strong>DNAME</strong> como <strong>columna de tabla 1</strong></li>',
'<li>Utilice <strong>DNAME_LOADED</strong> como <strong>columna de datos 1</strong>. Tenga en cuenta que esto hace referencia a la columna del perfil de datos que contenga los datos realmente cargados.</li>',
'</ul>',
'<p>',
'<br>',
unistr('Como consecuencia, &PRODUCT_NAME. consultar\00E1 los valores de <strong>DEPTNO</strong> de la tabla <strong>DEPT</strong>, con los valores cargados de <strong>DNAME</strong>. Estos se cargar\00E1n como columna <strong>DEPTNO</strong> de la tabla de destino.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4322015218183322.4001)
,p_name=>'P1926_LOOKUP_COLUMN2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de tabla 2'
,p_source=>'LOOKUP_COLUMN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el nombre de la segunda columna que usar para recuperar la columna de devoluci\00F3n de la tabla de consulta. Consulte <strong>Columna de tabla 1</strong> para ver un ejemplo.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4322104981183323.4001)
,p_name=>'P1926_LOOKUP_COLUMN3'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de tabla 3'
,p_source=>'LOOKUP_COLUMN3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el nombre de la tercera columna que usar para recuperar la columna de devoluci\00F3n de la tabla de consulta. Consulte <strong>Columna de tabla 1</strong> para ver un ejemplo.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4322217347183324.4001)
,p_name=>'P1926_LOOKUP_VALUE1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de Datos 1'
,p_source=>'LOOKUP_VALUE1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_DATA_PROFILE_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Seleccione la columna de perfil de datos que coincida con el valor de la primera columna de la tabla de consulta.',
'</p>',
'<p><strong>Ejemplo:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
unistr('<li>Configure la columna <strong>DNAME_LOADED</strong> como columna <strong>Datos</strong> con el selector de <strong>DNAME</strong> o <strong>4</strong> (en funci\00F3n del tipo de selector).</li>'),
'<li>Utilice <strong>DEPTNO</strong> como nombre de columna de perfil de datos y <strong>Consulta</strong> como tipo de columna.</li>',
'<li>Utilice <strong>DEPT</strong> como <strong>nombre de tabla</strong></li>',
unistr('<li>Utilice <strong>DEPTNO</strong> como <strong>columna de devoluci\00F3n</strong></li>'),
'<li>Utilice <strong>DNAME</strong> como <strong>columna de tabla 1</strong></li>',
'<li>Utilice <strong>DNAME_LOADED</strong> como <strong>columna de datos 1</strong>. Tenga en cuenta que esto hace referencia a la columna del perfil de datos que contenga los datos realmente cargados.</li>',
'</ul>',
'<p>',
'<br>',
unistr('Como consecuencia, &PRODUCT_NAME. consultar\00E1 los valores de <strong>DEPTNO</strong> de la tabla <strong>DEPT</strong>, con los valores cargados de <strong>DNAME</strong>. Estos se cargar\00E1n como columna <strong>DEPTNO</strong> de la tabla de destino.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4322312876183325.4001)
,p_name=>'P1926_LOOKUP_VALUE2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de Datos 2'
,p_source=>'LOOKUP_VALUE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_DATA_PROFILE_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Seleccione la columna de perfil de datos que coincida con el valor de la segunda columna de tabla de consulta. Consulte <strong>Columna de datos 1</strong> para ver un ejemplo.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4322430949183326.4001)
,p_name=>'P1926_LOOKUP_VALUE3'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de Datos 3'
,p_source=>'LOOKUP_VALUE3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_DATA_PROFILE_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Seleccione la columna de perfil de datos que coincida con el valor de la tercera columna de tabla de consulta. Consulte <strong>Columna de datos 1</strong> para ver un ejemplo.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4322522889183327.4001)
,p_name=>'P1926_LOOKUP_WHERE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4321474631183316.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_source=>'LOOKUP_WHERE_CLAUSE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Cl\00E1usula WHERE adicional que aplicar a la consulta de b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4702017184940016.4001)
,p_name=>'P1926_TRANSFORM_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4701992042940015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Regla'
,p_source=>'TRANSFORM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA.LOAD.TRANSFORM_TYPE'
,p_lov=>'.'||wwv_flow_api.id(4818478622110870.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione una regla de transformaci\00F3n sencilla para cambiar el valor cargado. Por ejemplo, si los datos de origen contienen datos de columnas en formato de may\00FAsculas y min\00FAsculas, las opciones <strong>A min\00FAsculas</strong> o <strong>A may\00FAscula')
||unistr('s</strong> permiten convertir los datos en las may\00FAsculas o min\00FAsculas que se desee.'),
'    </p>',
'<ul>',
unistr('    <li><strong>Recortar a la izquierda</strong>, <strong>Recortar a la derecha</strong> y <strong>Recortar</strong>:<br> recorta los caracteres especificados en <strong>Expresi\00F3n 1</strong> del lado izquierdo, el lado derecho o de ambos lados del va')
||'lor de datos cargado.</li>',
unistr('    <li><strong>Sustituir</strong>:<br> sustituci\00F3n simple de las incidencias de <strong>Expresi\00F3n&nbsp;1</strong> por <strong>Expresi\00F3n&nbsp;2</strong>.</li>'),
unistr('    <li><strong>A may\00FAsculas</strong>:<br> convierte el valor en may\00FAsculas.</li>'),
unistr('    <li><strong>A min\00FAsculas</strong>:<br> convierte el valor en min\00FAsculas.</li>'),
unistr('    <li><strong>Nulo si</strong>:<br> si el valor cargado es igual a la cadena especificada en <strong>Expresi\00F3n&nbsp;1</strong>, el valor se cargar\00E1 como NULL.</li>'),
unistr('    <li><strong>Expresi\00F3n regular Replace</strong>:<br> aplique la expresi\00F3n regular especificada en <strong>Expresi\00F3n&nbsp;1</strong> y sustituya todas las coincidencias por <strong>Expresi\00F3n&nbsp;2</strong>.</li>'),
unistr('    <li><strong>Expresi\00F3n regular Null If</strong>:<br> si la expresi\00F3n regular especificada en <strong>Expresi\00F3n&nbsp;1</strong> coincide, carga el valor de la columna como NULL.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4703763733940033.4001)
,p_name=>'P1926_SELECTOR_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NAME'
,p_prompt=>'Tipo de selector'
,p_source=>'SELECTOR_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SELECTOR_TYPE'
,p_lov=>'.'||wwv_flow_api.id(5203249727555533.4001)||'.'
,p_display_when=>'P1926_FORMAT'
,p_display_when2=>'CSV:XLSX'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Para los perfiles de datos <strong>CSV</strong> o <strong>XLSX</strong>, especifique si la secuencia de columna (num\00E9rica), el nombre de columna o una expresi\00F3n regular hacen referencia al valor de columna. En las opciones <strong>Nombre</strong>')
||unistr(' o <strong>Expresi\00F3n regular</strong> es necesario que los datos CSV o XLSX contengan nombres de columna en la primera fila. '),
unistr('    La opci\00F3n <strong>Expresi\00F3n regular</strong> resulta \00FAtil si existe posibilidad de que cambien los nombres de columna de los datos cargados.'),
'</p>',
'<p>',
unistr('La opci\00F3n <strong>Secuencia</strong> tiene un efecto positivo en el rendimiento, ya que &PRODUCT_NAME. no tiene que determinar los nombres y las posiciones de las columnas antes de cargar los datos. No obstante, use esta opci\00F3n solo si los datos carg')
||'ados siempre tienen las mismas columnas en la misma secuencia. ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5269072110575504.4001)
,p_name=>'P1926_TRANSFORM_EXPRESSION1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4701992042940015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'EXPRESSION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Proporcione "<strong>Expresi\00F3n 1</strong>" para este tipo de transformaci\00F3n. La expresi\00F3n soporta las sustituciones como Aplicaci\00F3n, Elementos de P\00E1gina y Variables de Sistema. La sem\00E1ntica depende de la regla de transformaci\00F3n seleccionada; consulte')
||unistr(' la ayuda de <strong>Tipo de regla</strong> para obtener m\00E1s informaci\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5269198002575505.4001)
,p_name=>'P1926_TRANSFORM_EXPRESSION2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4701992042940015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'EXPRESSION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Proporcione "<strong>Expresi\00F3n 2</strong>" para este tipo de transformaci\00F3n. La expresi\00F3n soporta las sustituciones como Aplicaci\00F3n, Elementos de P\00E1gina y Variables de Sistema. La sem\00E1ntica depende de la regla de transformaci\00F3n seleccionada; consulte')
||unistr(' la ayuda de <strong>Tipo de regla</strong> para obtener m\00E1s informaci\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5270481138575518.4001)
,p_name=>'P1926_SQL_QUERY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_prompt=>'Consulta SQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la consulta SQL para calcular el valor de esta columna. La consulta SQL debe devolver un solo valor y puede hacer referencia a las columnas del perfil de datos del tipo de columna <strong>Datos</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225899863718244523.4001)
,p_name=>'P1926_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225899980204244524.4001)
,p_name=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225900013374244525.4001)
,p_name=>'P1926_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Nombre con el que se muestra la columna en los componentes de Application Express.</p>',
unistr('<p>Si el perfil de datos forma parte de una <em>definici\00F3n de carga de datos</em>, se usa este nombre para asignar las columnas del perfil de datos a la tabla de destino. Por ejemplo, la columna del perfil de datos <strong>ENAME</strong> se cargar\00E1 e')
||unistr('n la columna <strong>ENAME</strong> de la tabla de destino. Si <em>no existe</em> la columna de perfil en la tabla de destino, se ignorar\00E1 durante la carga de datos.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225900168616244526.4001)
,p_name=>'P1926_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero de secuencia para determinar el orden de las columnas. Si se deja en blanco, la columna se almacenar\00E1 como \00FAltima columna.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225900212164244527.4001)
,p_name=>'P1926_IS_PRIMARY_KEY'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clave Primaria '
,p_source=>'IS_PRIMARY_KEY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Determina si la columna es una columna de clave principal. Una clave principal puede estar formada por varias columnas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225900372390244528.4001)
,p_name=>'P1926_DATA_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Dato'
,p_source=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_PROFILE_DATA_TYPES'
,p_lov=>'.'||wwv_flow_api.id(225929676126476839.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Tipo de dato de la columna que se muestra en los componentes de APEX.</p>',
'<p>',
'<p>Notas:</p>',
'<ul>',
unistr('<li>El tipo <strong>Documento JSON</strong> <em>solo</em> est\00E1 disponible para los perfiles de datos JSON. En Oracle Database 12c, la longitud m\00E1xima del valor de la columna es 4.000 bytes. En Oracle Database 18c o posterior, las columnas <strong>Doc')
||unistr('umento JSON</strong> pueden superar ese l\00EDmite.</li>'),
unistr('<li>En el caso de perfiles de datos JSON, el tipo de columna <strong>Clob</strong> solo est\00E1 disponible para Oracle Database 18c o posterior.</li>'),
unistr('<li>En el caso de perfiles de datos XLSX y CSV, el contenido de las columnas <strong>Clob</strong> tiene un l\00EDmite de 32.767 bytes.</li>'),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225900441757244529.4001)
,p_name=>'P1926_MAX_LENGTH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'4000'
,p_prompt=>unistr('Longitud M\00E1xima')
,p_source=>'MAX_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributo de longitud m\00E1xima para las columnas VARCHAR2.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'32767'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225900888129244533.4001)
,p_name=>'P1926_DATA_PROFILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225901294817244537.4001)
,p_name=>'P1926_FORMAT_MASK'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E1scara de Formato')
,p_source=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA_PROFILE_DATE_FORMAT_MASKS'
,p_lov=>'.'||wwv_flow_api.id(225940310284555905.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('M\00E1scara de formato que se va a utilizar en las columnas NUMBER, DATE y TIMESTAMP. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225901683035244541.4001)
,p_name=>'P1926_HAS_TIME_ZONE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Tiene zona horaria'
,p_source=>'HAS_TIME_ZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Indica si el valor DATE o TIMESTAMP de los <em>datos de origen (respuesta de origen de REST o datos cargados)</em> contiene informaci\00F3n del registro de hora. En caso afirmativo, Application Express respeta la zona horaria y convierte el valor a l')
||unistr('a zona horaria local de la aplicaci\00F3n. En caso contrario, se utiliza el valor sin modificaciones.'),
'</p>',
'<p>',
'   Ejemplos:    ',
'</p>',
'<ul>',
unistr('    <li><code>2019-01-01T20:00:00Z</code> contiene informaci\00F3n sobre la zona horaria</li>'),
unistr('    <li><code>2019-01-01T20:00:00 Europe/Berlin</code> contiene informaci\00F3n sobre la zona horaria</li>'),
unistr('    <li><code>2019-01-01T20:00:00</code> no contiene informaci\00F3n sobre la zona horaria</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225901911120244544.4001)
,p_name=>'P1926_SELECTOR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Selector'
,p_source=>'SELECTOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La expresi\00F3n de <strong>selector</strong> se est\00E1 utilizando para extraer el valor de columna de los datos de origen.'),
'<ul>',
'    <li>Para formatos <strong>XML</strong> y <strong>JSON</strong>, este selector es <em>relativo</em> al <strong>selector de filas</strong> configurado en el nivel de perfil de datos. Utilice XPath-Syntax para XML y expresiones de ruta de acceso JSO'
||'N para formatos JSON.</li>',
unistr('    <li>Para <strong>CSV</strong> o <strong>XLSX</strong>, utilice la secuencia de nombre de columna, en funci\00F3n del atributo <strong>Tipo de selector</strong>.</li> '),
'</ul>',
'<p>',
'<br><strong>Ejemplo de JSON:</strong>',
'</p>',
'<pre>',
'{ "items": [',
'    { "ename": "SMITH", "sal": 200 },',
'    { "ename": "SCOTT", "sal": 100 } ] }',
'</pre>',
'<p>',
unistr('    <strong>items</strong> se utiliza como el atributo de <strong>selector de filas</strong>, as\00ED que seleccione <strong>ename</strong> como el selector para la columna ENAME y <strong>sal</strong> como el selector para la columna SAL. Tenga en cuent')
||'a que el selector no debe hacer referencia a una matriz de JSON.',
'</p>',
'<p>',
'<br><strong>Ejemplo de CSV:</strong></p>',
'<pre>',
'EMPNO   ENAME   SAL ',
'------- ------- --------',
'   7839 KING        5000',
'   7844 FORD        2850',
'      : :              :',
'</pre>',
'<p>',
unistr('    Si se utiliza <strong>Nombre</strong> como tipo se selector, utilice los nombres de columna de la primera l\00EDnea de los datos CSV o XLSX: <strong>EMPNO</strong>, <strong>ENAME</strong> o <strong>SAL</strong>. Si el tipo de selector es <strong>Secu')
||unistr('encia</strong>, utilice <strong>1</strong>, <strong>2</strong> o <strong>3</strong> para hacer referencia a la columna por su n\00FAmero de secuencia. La misma sem\00E1ntica se aplica para perfiles de datos XLSX.'),
'</p>',
'<p>',
unistr('Tenga en cuenta que la opci\00F3n <strong>Secuencia</strong> tiene un efecto positivo en el rendimiento, ya que &PRODUCT_NAME. no tiene que determinar los nombres y las posiciones de las columnas antes de cargar los datos. Use esta opci\00F3n solo si los dat')
||'os cargados siempre tienen las mismas columnas en la misma secuencia. ',
'</p> '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225902140907244546.4001)
,p_name=>'P1926_REMOTE_ATTRIBUTE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225902044106244545.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de atributo remoto'
,p_source=>'REMOTE_ATTRIBUTE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Cuando se env\00EDa el nombre de la columna al servidor de origen de datos de REST para realizar solicitudes de DML, filtro u ordenaci\00F3n, Application Express utiliza el <strong>selector</strong> como nombre de atributo. Este atributo permite configurar u')
||unistr('n nombre alternativo si los nombres de selector y atributo no coinciden. Si no est\00E1 seguro, deje este valor en blanco.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225902211933244547.4001)
,p_name=>'P1926_COLUMN_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225902044106244545.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_source=>'COLUMN_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238756893364331841.4001)
,p_name=>'P1926_COLUMN_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DATA'
,p_prompt=>'Tipo de Columna'
,p_source=>'COLUMN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_PROFILE_COL_TYPES'
,p_lov=>'.'||wwv_flow_api.id(242159593404725778.4001)||'.'
,p_cHeight=>1
,p_read_only_when=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Especifique el tipo de columna. Los valores posibles son:',
'</p>',
'<ul>',
'    <li>Los valores de la columna <strong>Datos</strong> se extraen directamente de los datos de origen (datos cargados o respuesta de Origen de REST). En las columnas <strong>Datos</strong> siempre se necesita que se defina un atributo <strong>Selec'
||'tor</strong>.</li>',
unistr('    <li>Las columnas de <strong>Consulta</strong> se usan para "consultar" un valor de una tabla, en funci\00F3n de (otra) columna <strong>Datos</strong>. Por ejemplo, se puede definir una consulta para devolver el valor <strong>DEPTNO</strong> de la tab')
||unistr('la <strong>DEPT</strong>, en funci\00F3n del valor de la columna de datos <strong>DNAME</strong>.'),
'    </li>',
unistr('    <li>Las columnas de <strong>Expresi\00F3n SQL</strong> realizan el c\00E1lculo de un valor en funci\00F3n de otras <strong>columnas de datos</strong> con una expresi\00F3n SQL.</li>'),
unistr('    <li>Las columnas de <strong>Consulta SQL</strong> ejecutar\00E1n una consulta SQL, que hace referencia a otras <strong>columnas de datos</strong> para recuperar un valor.</li>'),
'</ul> '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(238756939388331842.4001)
,p_name=>'P1926_SQL_EXPRESSION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(225901106053244536.4001)
,p_prompt=>unistr('Expresi\00F3n SQL')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la expresi\00F3n SQL para calcular el valor de esta columna. La expresi\00F3n SQL puede hacer referencia a las columnas del perfil de datos del tipo de columna <strong>Datos</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(242269636643871845.4001)
,p_name=>'P1926_FORMAT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_source=>'select format from wwv_flow_data_profiles where id = :P1926_DATA_PROFILE_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1120461520324744304.4001)
,p_name=>'P1926_REMOTE_DATA_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225902044106244545.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de datos remoto'
,p_source=>'REMOTE_DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Si se especifica, las implantaciones de plugins de origen de REST utilizan este tipo de datos al realizar filtrados u ordenaciones ',
unistr('en el servidor. Esto es \00FAtil si el tipo de datos real de la columna, en el sitio de REST, no est\00E1 disponible en &PRODUCT_NAME.,'),
'para tipos de datos <strong>booleanos</strong> de instancias. ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3403060029900708617.4001)
,p_name=>'P1926_IS_HIDDEN'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(225899656946244521.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Visible'
,p_source=>'IS_HIDDEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si esta columna es una columna oculta o no. Las columnas ocultas no se mostrar\00E1n en el dise\00F1ador de p\00E1ginas y no se podr\00E1n seleccionar para los componentes de Application Express. Sin embargo, si un componente hace referencia a una column')
||unistr('a oculta, funcionar\00E1 como se esperaba.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(225950062157615704.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1926_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(241343754111308348.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1926_SEQUENCE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( max(sequence) + 10, 10 )',
'  from wwv_flow_data_profile_cols',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and data_profile_id = :P1926_DATA_PROFILE_ID'))
,p_compute_when=>'P1926_SEQUENCE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4702891801940024.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1926_MAX_LENGTH'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1926_DATA_TYPE'
,p_compute_when_text=>'VARCHAR2'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(225950102642615705.4001)
,p_validation_name=>'VARCHAR2 has length attribute'
,p_validation_sequence=>10
,p_validation=>'( :P1926_DATA_TYPE = ''VARCHAR2'' and :P1926_MAX_LENGTH is not null ) or :P1926_DATA_TYPE != ''VARCHAR2'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Se necesita una longitud m\00E1xima para las columnas VARCHAR2.')
,p_validation_condition=>'CREATE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(225900441757244529.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5272404876575538.4001)
,p_validation_name=>'DATA column for CSV, XLSX,  selector type not null'
,p_validation_sequence=>20
,p_validation=>'P1926_SELECTOR_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>':P1926_FORMAT in (''CSV'',''XLSX'') and :P1926_COLUMN_TYPE = ''DATA'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(4703763733940033.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5272397133575537.4001)
,p_validation_name=>'DATA column selector not null'
,p_validation_sequence=>30
,p_validation=>'P1926_SELECTOR'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'DATA'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(225901911120244544.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5271560440575529.4001)
,p_validation_name=>'SQL Expression is not null'
,p_validation_sequence=>40
,p_validation=>'P1926_SQL_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_EXPRESSION'' and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(238756939388331842.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(236247753632284212.4001)
,p_validation_name=>'SQL Expression is valid'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_profile_dev.check_sql_expression( ',
'    p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'    p_sql_expression  => :P1926_SQL_EXPRESSION );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_EXPRESSION'' and :P1926_SQL_EXPRESSION is not null and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(238756939388331842.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5271680763575530.4001)
,p_validation_name=>'SQL Query is not null'
,p_validation_sequence=>60
,p_validation=>'P1926_SQL_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_QUERY'' and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(5270481138575518.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5270569183575519.4001)
,p_validation_name=>'SQL Query is valid'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_profile_dev.check_sql_expression( ',
'    p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'    p_sql_expression  => :P1926_SQL_QUERY );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_QUERY'' and :P1926_SQL_QUERY is not null and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(5270481138575518.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(242269432245871843.4001)
,p_validation_name=>'CLOB not allowed for JSON content on database 12c'
,p_validation_sequence=>80
,p_validation=>'P1926_DATA_TYPE'
,p_validation2=>'CLOB'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>unistr('Para perfiles de datos JSON, el tipo de datos CLOB solo est\00E1 soportado en Oracle Database 18c y versiones posteriores.')
,p_validation_condition=>':P1926_FORMAT = ''JSON'' and sys.dbms_db_version.version < 18'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(225900372390244528.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5271909332575533.4001)
,p_validation_name=>'lookup table not null'
,p_validation_sequence=>90
,p_validation=>'P1926_LOOKUP_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'LOOKUP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(4321628443183318.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5272011392575534.4001)
,p_validation_name=>'lookup return column not null'
,p_validation_sequence=>100
,p_validation=>'P1926_LOOKUP_KEY_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'LOOKUP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(4321734839183319.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3754862439775407.4001)
,p_validation_name=>'lookup column, data column not null'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( :P1926_LOOKUP_COLUMN1 is not null and :P1926_LOOKUP_VALUE1 is null ) OR',
'( :P1926_LOOKUP_COLUMN1 is null and :P1926_LOOKUP_VALUE1 is not null ) OR',
'( :P1926_LOOKUP_COLUMN2 is not null and :P1926_LOOKUP_VALUE2 is null ) OR',
'( :P1926_LOOKUP_COLUMN2 is null and :P1926_LOOKUP_VALUE2 is not null ) OR',
'( :P1926_LOOKUP_COLUMN3 is not null and :P1926_LOOKUP_VALUE3 is null ) OR',
'( :P1926_LOOKUP_COLUMN3 is null and :P1926_LOOKUP_VALUE3 is not null ) then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Se deben especificar la columna de tabla de consulta y la columna de datos.'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'LOOKUP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5272117937575535.4001)
,p_validation_name=>'transform expr1 not null'
,p_validation_sequence=>120
,p_validation=>'P1926_TRANSFORM_EXPRESSION1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1926_TRANSFORM_TYPE'
,p_validation_condition2=>'LTRIM:RTRIM:TRIM:REPLACE:NULLIF:REGEXP_NULLIF:REGEXP_REPLACE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(5269072110575504.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5272244299575536.4001)
,p_validation_name=>'transform expr2 not null'
,p_validation_sequence=>130
,p_validation=>'P1926_TRANSFORM_EXPRESSION2'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#'
,p_validation_condition=>'P1926_TRANSFORM_TYPE'
,p_validation_condition2=>'REGEXP_REPLACE:REPLACE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(5269198002575505.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7127616359468930.4001)
,p_validation_name=>'selector type cannot be NAME if has header row = N'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_data_profiles',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and id = :P1926_DATA_PROFILE_ID',
'and :P1926_FORMAT in ( ''CSV'', ''XLSX'' )',
'and has_header_row = ''N'''))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La opci\00F3n Tipo de selector no se puede definir en Nombre, ya que la opci\00F3n La primera l\00EDnea contiene cabeceras est\00E1 desactivada para este perfil de datos.')
,p_validation_condition=>'P1926_SELECTOR_TYPE'
,p_validation_condition2=>'NAME'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(4703763733940033.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4503080488479014.4001)
,p_validation_name=>'selector must be numeric and 1 and 300 if selector type SEQ'
,p_validation_sequence=>150
,p_validation=>'wwv_flow_utilities.is_number( p_number => :P1926_SELECTOR ) and :P1926_SELECTOR between 1 and 300'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El selector debe ser num\00E9rico y estar comprendido entre 1 y 300.')
,p_validation_condition=>':P1926_SELECTOR is not null and :P1926_SELECTOR_TYPE = ''SEQ'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(225901911120244544.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4805970719918720.4001)
,p_validation_name=>'name exists'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_data_profile_cols',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and data_profile_id = :P1926_DATA_PROFILE_ID',
'and ( id != :P1926_DATA_PROFILE_COLUMN_ID OR :P1926_DATA_PROFILE_COLUMN_ID is null )',
'and name = :P1926_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'El nombre ya se utiliza en otra columna.'
,p_validation_condition=>'CREATE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(225900013374244525.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(225900510735244530.4001)
,p_name=>'Data Type VARCHAR2'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_condition_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'VARCHAR2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225900611710244531.4001)
,p_event_id=>wwv_flow_api.id(225900510735244530.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_MAX_LENGTH'
,p_attribute_01=>'N'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225900741631244532.4001)
,p_event_id=>wwv_flow_api.id(225900510735244530.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_MAX_LENGTH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(225901338954244538.4001)
,p_name=>'Data Type NUMBER, DATE or TIMESTAMP'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'":NUMBER:DATE:TIMESTAMP:TIMESTAMP WITH TIME ZONE:TIMESTAMP WITH LOCAL TIME ZONE:".indexOf(":" + $v("P1926_DATA_TYPE") + ":") !== -1 && $v("P1926_COLUMN_TYPE") === "DATA"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225901451818244539.4001)
,p_event_id=>wwv_flow_api.id(225901338954244538.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_FORMAT_MASK'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(225901549610244540.4001)
,p_event_id=>wwv_flow_api.id(225901338954244538.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_FORMAT_MASK'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4320784742183309.4001)
,p_name=>'Data Type DATE or TIMESTAMP'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'":DATE:TIMESTAMP:TIMESTAMP WITH TIME ZONE:TIMESTAMP WITH LOCAL TIME ZONE:".indexOf(":" + $v("P1926_DATA_TYPE") + ":") !== -1 && $v("P1926_COLUMN_TYPE") === "DATA"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4320998470183311.4001)
,p_event_id=>wwv_flow_api.id(4320784742183309.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_HAS_TIME_ZONE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4321130525183313.4001)
,p_event_id=>wwv_flow_api.id(4320784742183309.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_HAS_TIME_ZONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(238757030110331843.4001)
,p_name=>'Column Type Data'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(238757121915331844.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR,P1926_SELECTOR_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(238757285755331845.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR,P1926_SELECTOR_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(238757591547331848.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_EXPRESSION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(238757689805331849.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241343128748308342.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241343218152308343.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4702148169940017.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4701992042940015.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4702244360940018.4001)
,p_event_id=>wwv_flow_api.id(238757030110331843.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4701992042940015.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(241342851401308339.4001)
,p_name=>'Get SQL Expression Data Type'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_SQL_EXPRESSION'
,p_condition_element=>'P1926_SQL_EXPRESSION'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(241342995965308340.4001)
,p_event_id=>wwv_flow_api.id(241342851401308339.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1926_DATA_TYPE := wwv_flow_data_profile_dev.get_sql_expr_datatype( ',
'        p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'        p_sql_expression  => :P1926_SQL_EXPRESSION );',
'    if :P1926_DATA_TYPE = wwv_flow_data_profile.c_datatype_varchar2_vc then ',
'        :P1926_MAX_LENGTH := 4000;',
'    end if;',
'    ',
'end;'))
,p_attribute_02=>'P1926_DATA_PROFILE_ID,P1926_SQL_EXPRESSION'
,p_attribute_03=>'P1926_DATA_TYPE,P1926_MAX_LENGTH'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5270821132575522.4001)
,p_name=>'Get SQL Query data type'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_SQL_QUERY'
,p_condition_element=>'P1926_SQL_QUERY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5270918729575523.4001)
,p_event_id=>wwv_flow_api.id(5270821132575522.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1926_DATA_TYPE := wwv_flow_data_profile_dev.get_sql_expr_datatype( ',
'        p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'        p_sql_expression  => :P1926_SQL_QUERY );',
'    if :P1926_DATA_TYPE = wwv_flow_data_profile.c_datatype_varchar2_vc then ',
'        :P1926_MAX_LENGTH := 4000;',
'    end if;',
'    ',
'end;'))
,p_attribute_02=>'P1926_DATA_PROFILE_ID,P1926_SQL_QUERY'
,p_attribute_03=>'P1926_DATA_TYPE,P1926_MAX_LENGTH'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(658285003836841737.4001)
,p_name=>'Set selector'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P1926_SELECTOR").getValue() === "" && ',
'apex.item("P1926_COLUMN_TYPE").getValue() === "DATA"'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(658285184388841738.4001)
,p_event_id=>wwv_flow_api.id(658285003836841737.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1926_NAME").toLowerCase()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4702915689940025.4001)
,p_name=>'Column Type Lookup'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOOKUP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4703187533940027.4001)
,p_event_id=>wwv_flow_api.id(4702915689940025.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4321474631183316.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1003712082371784945.4001)
,p_event_id=>wwv_flow_api.id(4702915689940025.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4703072995940026.4001)
,p_event_id=>wwv_flow_api.id(4702915689940025.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4321474631183316.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4703250422940028.4001)
,p_name=>'Column Type SQL Expression'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_EXPRESSION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4703359732940029.4001)
,p_event_id=>wwv_flow_api.id(4703250422940028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_EXPRESSION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4703412753940030.4001)
,p_event_id=>wwv_flow_api.id(4703250422940028.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_EXPRESSION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4703540626940031.4001)
,p_event_id=>wwv_flow_api.id(4703250422940028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4321474631183316.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4703635938940032.4001)
,p_event_id=>wwv_flow_api.id(4703250422940028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4701992042940015.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5271000694575524.4001)
,p_name=>'Column Type SQL Query'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5271113004575525.4001)
,p_event_id=>wwv_flow_api.id(5271000694575524.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_QUERY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5271293926575526.4001)
,p_event_id=>wwv_flow_api.id(5271000694575524.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_QUERY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5271345272575527.4001)
,p_event_id=>wwv_flow_api.id(5271000694575524.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4321474631183316.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5271448985575528.4001)
,p_event_id=>wwv_flow_api.id(5271000694575524.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4701992042940015.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5269276602575506.4001)
,p_name=>'display expression1'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_TRANSFORM_TYPE'
,p_condition_element=>'P1926_TRANSFORM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'LTRIM, RTRIM, TRIM, REPLACE, NULLIF, REGEXP_NULLIF, REGEXP_REPLACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5269346711575507.4001)
,p_event_id=>wwv_flow_api.id(5269276602575506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5269430276575508.4001)
,p_event_id=>wwv_flow_api.id(5269276602575506.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5269509269575509.4001)
,p_name=>'display expression2'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_TRANSFORM_TYPE'
,p_condition_element=>'P1926_TRANSFORM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REGEXP_REPLACE, REPLACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5269692476575510.4001)
,p_event_id=>wwv_flow_api.id(5269509269575509.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5269735215575511.4001)
,p_event_id=>wwv_flow_api.id(5269509269575509.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5271781203575531.4001)
,p_name=>'Get Lookup Key Column Data Type'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_LOOKUP_KEY_COLUMN'
,p_condition_element=>'P1926_LOOKUP_KEY_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5271863947575532.4001)
,p_event_id=>wwv_flow_api.id(5271781203575531.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_col in (',
'        select data_type',
'        from wwv_flow_table_columns_dev',
'        where owner = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'        and table_name = :P1926_LOOKUP_TABLE',
'        and column_name = :P1926_LOOKUP_KEY_COLUMN',
'        and data_type <> ''BLOB'' )',
'    loop',
'        :P1926_DATA_TYPE := l_col.data_type;',
'    end loop;',
'',
'    if :P1926_DATA_TYPE = wwv_flow_data_profile.c_datatype_varchar2_vc then ',
'        :P1926_MAX_LENGTH := 4000;',
'    end if;',
'end;'))
,p_attribute_02=>'P1926_LOOKUP_OWNER,P1926_LOOKUP_TABLE,P1926_LOOKUP_KEY_COLUMN'
,p_attribute_03=>'P1926_DATA_TYPE,P1926_MAX_LENGTH'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4503113942479015.4001)
,p_name=>'set selector to null if type change'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_SELECTOR_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4503230245479016.4001)
,p_event_id=>wwv_flow_api.id(4503113942479015.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3754677352775405.4001)
,p_name=>'Set visible to Yes if adding data load column'
,p_event_sequence=>150
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P1925_IS_WEB_SRC_PROFILE = ''N'' and :P1926_DATA_PROFILE_COLUMN_ID is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3754701720775406.4001)
,p_event_id=>wwv_flow_api.id(3754677352775405.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_HIDDEN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5269945498575513.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set transform type if col type SQL Expression or Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1926_COLUMN_TYPE in ( ''SQL_EXPRESSION'', ''SQL_QUERY'' ) then',
'    :P1926_TRANSFORM_TYPE := :P1926_COLUMN_TYPE;',
'',
'    if :P1926_COLUMN_TYPE = ''SQL_EXPRESSION'' then',
'        :P1926_TRANSFORM_EXPRESSION1 := :P1926_SQL_EXPRESSION;',
'    elsif :P1926_COLUMN_TYPE = ''SQL_QUERY'' then',
'        :P1926_TRANSFORM_EXPRESSION1 := :P1926_SQL_QUERY;',
'    end if;',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225949808232615702.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_03=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225899759263244522.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_03=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5270088765575514.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch non-dml item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_prof_col in (',
'    select column_type,',
'           expression1',
'    from wwv_flow_data_profile_cols',
'    where flow_id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'    and data_profile_id = :P1926_DATA_PROFILE_ID',
'    and id = :P1926_DATA_PROFILE_COLUMN_ID )',
'loop',
'    if l_prof_col.column_type = ''SQL_EXPRESSION'' then',
'        :P1926_SQL_EXPRESSION := l_prof_col.expression1;',
'    elsif l_prof_col.column_type = ''SQL_QUERY'' then',
'        :P1926_SQL_QUERY := l_prof_col.expression1;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01927
begin
wwv_flow_api.create_page(
 p_id=>1927.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Probar origen de datos de REST'
,p_step_title=>'Origen de Datos de REST'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(310376765790241838.4001)
,p_plug_name=>'Resultados de la prueba'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra los resultados de prueba de la operaci\00F3n de origen de datos de REST. El separador <strong>Cuerpo de la respuesta</strong> muestra la respuesta raw recibida del servicio web; los <strong>datos</strong> de los resultados despu\00E9s ')
||'de analizar la respuesta raw mediante los metadatos del <em>perfil de datos</em>. El separador <strong>Cabeceras de respuesta</strong> permite recuperar las cabeceras de respuesta HTTP del servicio web.</p>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468890865757100776.4001)
,p_plug_name=>'Correcto'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="max-width: 85vw"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1927_STATUS_CODE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471997775944546730.4001)
,p_plug_name=>'Cuerpo de la Respuesta'
,p_parent_plug_id=>wwv_flow_api.id(468890865757100776.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_region_attributes=>'style="max-width: 100vw;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'select clob001 from wwv_flow_collections where collection_name = ''WEB_SOURCE_INFO'' and c001=''DATA'' and rownum = 1'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'30'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(472057526085098017.4001)
,p_name=>'Datos Analizados'
,p_parent_plug_id=>wwv_flow_api.id(468890865757100776.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="max-width: 100vw"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql varchar2(32767);',
'    l_cnt pls_integer;',
'begin',
'    select count(*) into l_cnt',
'     from wwv_flow_collections',
'    where collection_name = ''WEB_SOURCE_INFO''',
'      and c001            = ''DATA_PROFILE_COLUMNS''',
'      and rownum <= 40;',
'      ',
'    if l_cnt = 0 then l_cnt := 1; end if;',
'',
'    l_sql := ''select '';',
'',
'    for i in 1 .. l_cnt loop',
'        l_sql := l_sql ||',
'            case when i > 1 then '','' end ||',
'            ''c'' || lpad( i, 3, ''0'' );',
'    end loop;',
'    l_sql := l_sql || '' from wwv_flow_collections where collection_name = ''''WEB_SOURCE_DATA'''''';',
'    return l_sql;',
'end;'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>40
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headings varchar2(32767);',
'begin',
'    for c in ( select * from (',
'                   select c002 ',
'                     from wwv_flow_collections',
'                    where collection_name = ''WEB_SOURCE_INFO''',
'                      and c001            = ''DATA_PROFILE_COLUMNS''',
'                    order by seq_id asc ) ',
'               where rownum <= 40 ) loop',
'       l_headings := l_headings || initcap(c.c002) || '':'';',
'    end loop;',
'    return substr( l_headings, 1, length( l_headings ) - 1 );',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_no_data_found=>'No se han encontrado datos al analizar la respuesta de servicio.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236250954871284244.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236251066214284245.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236251105342284246.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236251244450284247.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236251310108284248.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236251464504284249.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(236251523583284250.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265296200871801.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265311214871802.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265455537871803.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265584542871804.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265635773871805.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265719484871806.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265889098871807.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242265995438871808.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266073967871809.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266153731871810.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266214097871811.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266374630871812.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266481784871813.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266577112871814.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266697578871815.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266756378871816.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266899545871817.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242266960143871818.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267094550871819.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267186646871820.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267279147871821.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267375873871822.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267400443871823.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267554898871824.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267674725871825.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267764665871826.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267828445871827.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242267931593871828.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242268083303871829.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242268105007871830.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242268216896871831.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242268342279871832.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242268454785871833.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(694765349523438236.4001)
,p_name=>'Cabeceras de Respuesta'
,p_parent_plug_id=>wwv_flow_api.id(468890865757100776.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="max-width: 100vw"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002 as header_name,',
'       c003 as header_value',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''RESPONSE_HEADERS''',
' order by seq_id asc',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242218489290625631.4001)
,p_query_column_id=>1
,p_column_alias=>'HEADER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de Cabecera'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242218874796625631.4001)
,p_query_column_id=>2
,p_column_alias=>'HEADER_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor de Cabecera'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468890962246100777.4001)
,p_plug_name=>'Fallo'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1927_STATUS_CODE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(468891038148100778.4001)
,p_name=>'Respuesta del Servidor'
,p_parent_plug_id=>wwv_flow_api.id(468890962246100777.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dbms_lob.substr( clob001, 4000, 1 ) as response',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(242219858030625633.4001)
,p_query_column_id=>1
,p_column_alias=>'RESPONSE'
,p_column_display_sequence=>1
,p_column_heading=>'Respuesta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468891505040100783.4001)
,p_plug_name=>'Estado de HTTP'
,p_parent_plug_id=>wwv_flow_api.id(468890962246100777.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p style="text-align: center">',
'<span style="color: red;" class="a-Icon a-Icon--regionIcon icon-error a-Icon--xl"></span>',
'</p>',
'<p style="text-align: center">',
'El servidor ha respondido con &P1927_STATUS_CODE.',
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472057438250098016.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1927_STATUS_CODE'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472098857550311892.4001)
,p_plug_name=>'Resultados de la prueba'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(310376862836241839.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(472098857550311892.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Volver'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP,1927,1922::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(236248174846284216.4001)
,p_name=>'P1927_WEB_SRC_OPERATION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472098857550311892.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(242220240098625634.4001)
,p_name=>'P1927_STATUS_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(468891038148100778.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(242268601782871835.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1927_STATUS_CODE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
'   and rownum          = 1;',
'   ',
''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(236247904415284214.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin    wwv_flow_web_src_dev.test_web_src_operation(',
'        p_web_src_module_id    => :P1921_WEB_SRC_MODULE_ID,',
'        p_web_src_operation_id => :P1927_WEB_SRC_OPERATION_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01928
begin
wwv_flow_api.create_page(
 p_id=>1928.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Refrescar desde cat\00E1logo de origen de REST')
,p_alias=>'REFRESH-FROM-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Refrescar desde cat\00E1logo de origen de REST')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_height=>'400'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(936806476498447829.4001)
,p_plug_name=>'Dialog Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(936806856479447833.4001)
,p_plug_name=>unistr('Refrescar desde cat\00E1logo de origen de REST')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Confirme que desea refrescar el origen de datos de REST desde el cat\00E1logo de origen de REST. Tenga en cuenta que los cambios que se hagan en el origen de datos de REST se sustituir\00E1n despu\00E9s de haber refrescado.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4001102700254175.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(936806476498447829.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4001571807254178.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(936806476498447829.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar desde cat\00E1logo de servicio')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4003078653254221.4001)
,p_branch_name=>'Back to REST Data Source'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4001571807254178.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2983286949967549.4001)
,p_name=>'P1928_MODULE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(936806856479447833.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4003482633287602.4001)
,p_name=>'P1928_SERVICE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(936806856479447833.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4003524501287603.4001)
,p_name=>'P1928_CATALOG_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(936806856479447833.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4003684124287604.4001)
,p_name=>'P1928_CATALOG_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(936806856479447833.4001)
,p_prompt=>unistr('Cat\00E1logo')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre del cat\00E1logo desde el que se refrescar\00E1 este origen de datos de REST.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4003742135287605.4001)
,p_name=>'P1928_SERVICE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(936806856479447833.4001)
,p_prompt=>'Servicio'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de servicio del cat\00E1logo desde el que se refrescar\00E1 este origen de datos de REST.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2983337555967550.4001)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4001102700254175.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4003330527287601.4001)
,p_event_id=>wwv_flow_api.id(2983337555967550.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4003836412287606.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Catalog and Service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select c.id            as catalog_id, ',
'           c.name          as catalog_name, ',
'           s.id            as service_id, ',
'           s.name          as service_name',
'      into :P1928_CATALOG_ID, :P1928_CATALOG_NAME, :P1928_SERVICE_ID, :P1928_SERVICE_NAME',
'      from wwv_flow_web_src_modules     m,',
'           wwv_web_src_catalogs         c,',
'           wwv_web_src_catalog_services s',
'     where c.internal_name     = m.catalog_internal_name ',
'       and s.name              = m.catalog_service_name ',
'       and c.security_group_id = m.security_group_id',
'       and c.id                = s.catalog_id',
'       and s.security_group_id = m.security_group_id',
'       --',
'       and m.id                = :P1928_MODULE_ID',
'       and m.flow_id           = :FB_FLOW_ID',
'       and m.security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4002531688254219.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_installed_plugins  wwv_flow_t_varchar2;',
'    l_credential_id      number;',
'',
'begin',
'    -- if a module_id is passed in then the procedure will refresh from the',
'    -- the catalog instead of creating a new service. But, we need to ',
'    -- provide the catalog_id and service_id. The module saves the names',
'    -- so run a query to get the ids. ',
'    ',
'     wwv_web_src_catalog.rest_source_from_catalog(',
'        p_catalog_id        => :P1928_CATALOG_ID,',
'        p_service_id        => :P1928_SERVICE_ID,',
'        p_credential_id     => l_credential_id,',
'        --',
'        p_application_id    => :FB_FLOW_ID,',
'        p_module_id         => :P1928_MODULE_ID, ',
'        -- just here because no default in the procedure declaration',
'        p_installed_plugins => l_installed_plugins );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar los or\00EDgenes de datos de REST.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4001571807254178.4001)
,p_process_success_message=>'Se ha refrescado el origen de datos de REST.'
);
end;
/
prompt --application/pages/page_01931
begin
wwv_flow_api.create_page(
 p_id=>1931.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Servidores Remotos'
,p_step_title=>'Servidores Remotos'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161024368419385205.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(533145899605135270.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225855266184926518.4001)
,p_plug_name=>'Servidores Remotos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La informaci\00F3n del servidor de origen de datos de REST se almacena como un objeto de <strong>servidor remoto</strong>. Los servidores remotos se pueden compartir en varios or\00EDgenes de datos de REST. Un cambio en las propiedades del servidor remoto')
||unistr(' afectar\00E1 a todos los or\00EDgenes de datos de REST que hagan referencia a ese objeto (por ejemplo, puede cambiar un objeto de servidor remoto de un sistema de prueba a uno de producci\00F3n).</p>'),
'',
unistr('<p>Los servidores remotos se almacenan en el nivel de espacio de trabajo y, por lo tanto, aparecen en todas las aplicaciones. Al exportar una aplicaci\00F3n, los servidores remotos utilizados se agregan al archivo de exportaci\00F3n. Al importar la aplicaci\00F3')
||unistr('n a otro espacio de trabajo, &PRODUCT_NAME. comprueba si el espacio de trabajo de destino ya contiene servidores remotos con el mismo <strong>ID est\00E1tico</strong>. Si el servidor remoto ya existe, la aplicaci\00F3n lo utiliza. De lo contrario, se crean s')
||unistr('ervidores remotos desde el archivo de importaci\00F3n en el espacio de trabajo de destino.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(249349483233883038.4001)
,p_plug_name=>'Servidores Remotos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select s.id,',
'           s.name,',
'           s.server_type,',
'           s.base_url,',
'           s.static_id,',
'           count(m.id) module_references,',
'           count(ma.id) auth_references,',
'           count(f.id) print_references',
'      from wwv_remote_servers s ',
'          left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'          left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'          left outer join wwv_flows f on ( s.id = f.print_remote_server_id )',
'     where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'', ''PRINT_SERVER'' )',
'       and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID in ( m.flow_id, ma.flow_id, f.id ))',
'     group by s.id, s.name, s.server_type, s.base_url, s.static_id, s.credential_id',
') ',
'select ',
'    id,',
'    name,',
'    server_type,',
'    base_url,',
'    static_id,',
'    module_references + auth_references + print_references as references',
'from data'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(249349528073883039.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No se han encontrado servidores remotos en este espacio de trabajo.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>249349528073883039
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(249349684775883040.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(249349718003883041.4001)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID,P1932_BACK_TO_PAGE:#ID#,'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(249349834948883042.4001)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'URL Base'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(249350056390883044.4001)
,p_db_column_name=>'REFERENCES'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Referencias'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(522796703180429235.4001)
,p_db_column_name=>'SERVER_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Tipo de servidor'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(154020705287547277)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(177068151888885504.4001)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>unistr('Identificador est\00E1tico')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(712704529235086539.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/managing-remote-server-objects.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225855133192926517.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(249349483233883038.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP,1932::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(525230224885218512.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused remote servers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for s in (',
'        with data as (',
'            select s.id,',
'                   s.name,',
'                   s.server_type,',
'                   s.base_url,',
'                   case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'                   count(m.id) module_references,',
'                   count(ma.id) auth_references',
'              from wwv_remote_servers s ',
'                  left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'                  left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'             where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'               and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'             group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
'        ) ',
'        select id',
'          from data',
'        where module_references + auth_references = 0 )',
'   loop',
'       delete wwv_remote_servers ',
'        where id                = s.id',
'          and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'         ',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han suprimido los servidores remotos no utilizados.'
);
end;
/
prompt --application/pages/page_01932
begin
wwv_flow_api.create_page(
 p_id=>1932.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Servidor Remoto'
,p_page_mode=>'MODAL'
,p_step_title=>'Editar Servidor Remoto'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225855374821926519.4001)
,p_plug_name=>'General'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225856153590926527.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225856843527926534.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(225857020219926536.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('<p>La informaci\00F3n de servidor de un origen de datos de REST se almacena como un objeto de <strong>servidor remoto</strong>. Los servidores remotos se pueden compartir en varios or\00EDgenes de datos de REST. Un cambio en las propiedades del servidor remo')
||unistr('to afectar\00E1 a todos los or\00EDgenes de REST que hagan referencia a ese objeto. Por ejemplo, al cambiar la <strong>URL base</strong> de un servidor remoto, todos los or\00EDgenes de REST asociados se mueven de un sistema de prueba a uno de producci\00F3n.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225856372419926529.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(225856153590926527.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'P1932_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225856224023926528.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(225856153590926527.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'P1932_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225856518442926531.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(225856153590926527.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'', ''DELETE'');'
,p_button_condition=>'P1932_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(225856433876926530.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(225856153590926527.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.:RP,1932::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(55558467552883026.4001)
,p_branch_action=>'f?p=&APP_ID.:&P1932_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1932_BACK_TO_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3403061389415708630.4001)
,p_branch_name=>'Go To Page 1931'
,p_branch_action=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.:RP,1932::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4560375580142239.4001)
,p_name=>'P1932_PRINT_SERVER_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de servidor de impresi\00F3n')
,p_source=>'PRINT_SERVER_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRINT_SERVER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(6300179213172122.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la opci\00F3n adecuada:'),
'<ul>',
unistr('<li><strong>Oracle Analytics Publisher</strong>: seleccione esta opci\00F3n si est\00E1 utilizando una versi\00F3n con licencia de Oracle Analytics Publisher. Esta opci\00F3n permite utilizar los resultados de la consulta del informe para convertirlos de formato XML')
||unistr(' a RTF con Oracle Analytics Publisher. Selecci\00F3nela si desea cargar plantillas RTF o XSL-FO personalizadas para la impresi\00F3n de informes en &PRODUCT_NAME..</li>'),
unistr('<li><strong>APEX Office Print</strong>: seleccione esta opci\00F3n si est\00E1 utilizando APEX Office Print.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10646317982074436.4001)
,p_name=>'P1932_PRINT_SERVER_TIMEOUT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'300'
,p_prompt=>unistr('Timeout de impresi\00F3n')
,p_source=>'SERVER_TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Define el timeout de transferencia para comunicarse con el servidor de impresi\00F3n en segundos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(55558506502883027.4001)
,p_name=>'P1932_BACK_TO_PAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225855459384926520.4001)
,p_name=>'P1932_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225855755385926523.4001)
,p_name=>'P1932_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para el objeto del servidor remoto aqu\00ED. Los nombres de servidor remoto deben ser \00FAnicos en el espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225855813992926524.4001)
,p_name=>'P1932_BASE_URL'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Punto Final'
,p_source=>'BASE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la URL del punto final del servidor remoto. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225855914889926525.4001)
,p_name=>'P1932_CREDENTIAL_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225856064530926526.4001)
,p_name=>'P1932_SERVER_COMMENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(225856843527926534.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'SERVER_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225856943196926535.4001)
,p_name=>'P1932_HTTPS_HOST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(225856843527926534.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de host de HTTP'
,p_source=>'HTTPS_HOST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>500
,p_display_when=>'wwv_flow_utilities.db_version_is_at_least(''12.2'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de host que va a coincidir con el nombre com\00FAn (CN) del certificado de servidor remoto de una solicitud HTTPS. Tambi\00E9n puede ser un nombre de dominio como *.ejemplo.com. Si es nulo, se utilizar\00E1 el nombre de host de la URL especificada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522796683482429234.4001)
,p_name=>'P1932_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia al servidor remoto en llamadas de API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522796826390429236.4001)
,p_name=>'P1932_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'WEB_SERVICE'
,p_prompt=>'Tipo de servidor'
,p_source=>'SERVER_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SERVER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154020705287547277.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la opci\00F3n apropiada:'),
'<ul>',
unistr('<li><strong>Origen de datos de REST</strong>: seleccione esta opci\00F3n si est\00E1 utilizando el servidor para consumir una API de REST remota.</li>'),
'</ul>',
unistr('<li><strong>Autenticaci\00F3n:</strong>: seleccione esta opci\00F3n si est\00E1 utilizando el servidor remoto para la autenticaci\00F3n.</li>'),
unistr('<li><strong>Servidor de impresi\00F3n</strong>: seleccione esta opci\00F3n si est\00E1 utilizando un servidor de impresi\00F3n externo.</li>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(537043795794394630.4001)
,p_name=>'P1932_PROMPT_ON_INSTALL'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(225855374821926519.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Solicitar en la instalaci\00F3n')
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione <strong>Activado</strong> para que &PRODUCT_NAME. solicite la URL base tras la instalaci\00F3n de la aplicaci\00F3n en otro espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1421872566786014.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1932_PRINT_SERVER_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1932_TYPE'
,p_compute_when_text=>'PRINT_SERVER'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(10646711348074440.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1932_PRINT_SERVER_TIMEOUT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1932_TYPE'
,p_compute_when_text=>'PRINT_SERVER'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1421742524786013.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1932_PRINT_SERVER_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'BIP'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(525232278373218532.4001)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where name = :P1932_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de servidor remoto debe ser \00FAnico')
,p_when_button_pressed=>wwv_flow_api.id(225856224023926528.4001)
,p_associated_item=>wwv_flow_api.id(225855755385926523.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(525232470082218534.4001)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where static_id = :P1932_STATIC_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El ID est\00E1tico del servidor remoto debe ser \00FAnico')
,p_when_button_pressed=>wwv_flow_api.id(225856224023926528.4001)
,p_associated_item=>wwv_flow_api.id(522796683482429234.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(525232563615218535.4001)
,p_validation_name=>'URL must start with http or https'
,p_validation_sequence=>30
,p_validation=>'substr( :P1932_BASE_URL, 1, 8 ) = ''https://'' or substr( :P1932_BASE_URL, 1, 7 ) = ''http://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La URL base debe empezar por http:// o https://'
,p_validation_condition=>'APPLY_CHANGES:CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(225855813992926524.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(537042329937394616.4001)
,p_validation_name=>'Cannot delete used Remote Server'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id',
'  from wwv_remote_servers s ',
' where exists( select 1 from wwv_flow_web_src_modules m where remote_server_id = s.id or auth_remote_server_id = s.id )',
'   and s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and s.id = :P1932_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El servidor remoto est\00E1 en uso y no se puede suprimir.')
,p_when_button_pressed=>wwv_flow_api.id(225856518442926531.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(249348433251883028.4001)
,p_name=>'Show HTTPS HOST for HTTPS URL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_BASE_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1932_BASE_URL").startsWith("https://")'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_utilities.db_version_is_at_least(''12.2'')'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249348581714883029.4001)
,p_event_id=>wwv_flow_api.id(249348433251883028.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(249348633948883030.4001)
,p_event_id=>wwv_flow_api.id(249348433251883028.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(522796914255429237.4001)
,p_name=>'Set Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522797041909429238.4001)
,p_event_id=>wwv_flow_api.id(522796914255429237.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1932_NAME").replace(/[^a-zA-Z0-9]/g, "_")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(10646473304074437.4001)
,p_name=>'On print server'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_TYPE'
,p_condition_element=>'P1932_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PRINT_SERVER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10646576790074438.4001)
,p_event_id=>wwv_flow_api.id(10646473304074437.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_PRINT_SERVER_TIMEOUT,P1932_PRINT_SERVER_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10646607485074439.4001)
,p_event_id=>wwv_flow_api.id(10646473304074437.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_PRINT_SERVER_TIMEOUT,P1932_PRINT_SERVER_TYPE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225858251877926548.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_REMOTE_SERVERS'
,p_attribute_02=>'WWV_REMOTE_SERVERS'
,p_attribute_03=>'P1932_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(225855586024926521.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_REMOTE_SERVERS'
,p_attribute_02=>'WWV_REMOTE_SERVERS'
,p_attribute_03=>'P1932_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01933
begin
wwv_flow_api.create_page(
 p_id=>1933.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso'
,p_step_title=>'Uso'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694160002983515914.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(533145899605135270.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(758990900749057227.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Revise d\00F3nde se utilizan los objetos de servidor remoto en este espacio de trabajo.</p>'),
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(782485117798013747.4001)
,p_plug_name=>'Uso del servidor remoto'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name,',
'       s.server_type,',
'       s.base_url,',
'       m.flow_id as application_id,',
'       m.name as component_name,',
'       1921 as page_id,',
'       ''P1921_WEB_SRC_MODULE_ID'' as item_name,',
'       m.id as item_value ',
'  from wwv_remote_servers s,',
'       wwv_flow_web_src_modules m',
' where s.id = m.remote_server_id',
'   and s.server_type = ''WEB_SERVICE''',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = m.flow_id)',
'union all',
'select s.id,',
'       s.name,',
'       s.server_type,',
'       s.base_url,',
'       m.flow_id as application_id,',
'       m.name as component_name,',
'       1921 as page_id,',
'       ''P1921_WEB_SRC_MODULE_ID'' as item_name,',
'       m.id as item_value',
'  from wwv_remote_servers s,',
'       wwv_flow_web_src_modules m',
' where s.id = m.auth_remote_server_id',
'   and s.server_type = ''AUTHENTICATION''',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = m.flow_id)',
'union all',
'select s.id,',
'       s.name,',
'       s.server_type,',
'       s.base_url,',
'       f.id as application_id,',
'       wwv_flow_lang.system_message( ''F4000.APP_REMOTE_PRINT_SERVER'', f.id ) component_name,',
'       4001 as page_id,',
'       null item_name,',
'       null item_value',
'  from wwv_remote_servers s,',
'       wwv_flows f',
' where s.id = f.print_remote_server_id',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = f.id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(782485162638013748.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No se han encontrado servidores remotos utilizados en este espacio de trabajo.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>782485162638013748
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533136960458130732.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533137382305130737.4001)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533137736880130737.4001)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'URL Base'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533138950303130738.4001)
,p_db_column_name=>'SERVER_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Tipo de servidor'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(154020705287547277)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(529222995957107549.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>unistr('Identificador de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1378288891662029928.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Nombre del Componente'
,p_column_link=>'f?p=&APP_ID.:#PAGE_ID#:&SESSION.::&DEBUG.:Y,#PAGE_ID#:FB_FLOW_ID,#ITEM_NAME#:#APPLICATION_ID#,#ITEM_VALUE#'
,p_column_linktext=>'#COMPONENT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1378288999609029929.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>unistr('Identificador de P\00E1gina')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1378289075149029930.4001)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Nombre del Elemento'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1378289162689029931.4001)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>110
,p_column_identifier=>'M'
,p_column_label=>'Valor de Elemento'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1058364853067349211.4001)
,p_plug_name=>'Servidores remotos sin utilizar'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select s.id,',
'           s.name,',
'           s.server_type,',
'           s.base_url,',
'           case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'           count(m.id) module_references,',
'           count(ma.id) auth_references,',
'           count(f.id) print_references',
'      from wwv_remote_servers s ',
'          left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'          left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'          left outer join wwv_flows f on ( s.id = f.print_remote_server_id )',
'     where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'', ''PRINT_SERVER'' )',
'       and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
') ',
'select ',
'    id,',
'    name,',
'    server_type,',
'    base_url,',
'    auth_required',
'   from data',
'where module_references + auth_references + print_references = 0'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select s.id,',
'           s.name,',
'           s.server_type,',
'           s.base_url,',
'           case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'           count(m.id) module_references,',
'           count(ma.id) auth_references',
'      from wwv_remote_servers s ',
'          left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'          left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'     where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'       and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
') ',
'select ',
'    id,',
'    name,',
'    server_type,',
'    base_url,',
'    auth_required',
'   from data',
'where module_references + auth_references = 0'))
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1058365111904349213.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No se han encontrado servidores remotos sin utilizar en este espacio de trabajo.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>1058365111904349213
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533140427417130741.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533140833852130742.4001)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533141216969130742.4001)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'URL Base'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533141637921130742.4001)
,p_db_column_name=>'AUTH_REQUIRED'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>unistr('Autenticaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533142073386130743.4001)
,p_db_column_name=>'SERVER_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Tipo de servidor'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(154020705287547277)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(533142832128130743.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1058364853067349211.4001)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir no utilizados'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(533143684796130751.4001)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(533142832128130743.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(533144620373130752.4001)
,p_event_id=>wwv_flow_api.id(533143684796130751.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los objetos del servidor remoto no utilizados de su espacio de trabajo?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(533144151502130752.4001)
,p_event_id=>wwv_flow_api.id(533143684796130751.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(533143247618130750.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused remote servers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for s in (',
'        with data as (',
'            select s.id,',
'                   s.name,',
'                   s.server_type,',
'                   s.base_url,',
'                   case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'                   count(m.id) module_references,',
'                   count(ma.id) auth_references',
'              from wwv_remote_servers s ',
'                  left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'                  left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'             where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'               and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'             group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
'        ) ',
'        select id',
'          from data',
'        where module_references + auth_references = 0 )',
'   loop',
'       delete wwv_remote_servers ',
'        where id                = s.id',
'          and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'         ',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(533142832128130743.4001)
,p_process_success_message=>'Se han suprimido los servidores remotos no utilizados.'
);
end;
/
prompt --application/pages/page_01934
begin
wwv_flow_api.create_page(
 p_id=>1934.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial'
,p_step_title=>'Historial'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(533152446813172812.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_REMOTE_SERVERS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(533152585143172813.4001)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>533152585143172813
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533152732484172815.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533152819773172816.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533152687001172814.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>40
,p_column_identifier=>'A'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533152979985172817.4001)
,p_db_column_name=>'SCN'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533153046209172818.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533153165421172819.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(533153201870172820.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1227336961892811571.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(533145899605135270.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1292167859658352884.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('<p>En esta p\00E1gina se muestran las modificaciones recientes realizadas en los servidores remotos de este espacio de trabajo.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(533185100368295695.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused remote servers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for s in (',
'        with data as (',
'            select s.id,',
'                   s.name,',
'                   s.server_type,',
'                   s.base_url,',
'                   case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'                   count(m.id) module_references,',
'                   count(ma.id) auth_references',
'              from wwv_remote_servers s ',
'                  left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'                  left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'             where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'               and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'             group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
'        ) ',
'        select id',
'          from data',
'        where module_references + auth_references = 0 )',
'   loop',
'       delete wwv_remote_servers ',
'        where id                = s.id',
'          and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'         ',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han suprimido los servidores remotos no utilizados.'
);
end;
/
prompt --application/pages/page_01935
begin
wwv_flow_api.create_page(
 p_id=>1935.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Agregar servidor de impresi\00F3n remoto')
,p_alias=>'ADD-REMOTE-PRINT-SERVER'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Agregar servidor de impresi\00F3n remoto')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608889265570440907.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(608916658335678510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608889575089440910.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608908559474641574.4001)
,p_plug_name=>unistr('Agregar servidor de impresi\00F3n remoto')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(609371704658163107.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(608889575089440910.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(608909627053641576.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(608889575089440910.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(608911252260641587.4001)
,p_branch_name=>'Go To Page 1936'
,p_branch_action=>'f?p=&APP_ID.:1936:&SESSION.::&DEBUG.:CR,1936::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(608909627053641576.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608889634955440911.4001)
,p_name=>'P1935_BASE_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(608908559474641574.4001)
,p_prompt=>'URL de Punto Final'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la URL del punto final del servidor de impresi\00F3n externo. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608889961436440914.4001)
,p_name=>'P1935_HTTPS_HOST'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(608908559474641574.4001)
,p_prompt=>'Nombre de host de HTTP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>500
,p_display_when=>'wwv_flow_utilities.db_version_is_at_least(''12.2'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de host que va a coincidir con el nombre com\00FAn (CN) del certificado de servidor remoto de una solicitud HTTPS. Tambi\00E9n puede ser un nombre de dominio como *.ejemplo.com. Si es nulo, se utilizar\00E1 el nombre de host de la URL especificada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608891630760440931.4001)
,p_name=>'P1935_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(608908559474641574.4001)
,p_item_default=>'wwv_flow_lang.system_message( ''F4000.P1935.NAME'', :FB_FLOW_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Nombre'
,p_placeholder=>'255'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para el objeto del servidor remoto aqu\00ED. Los nombres de servidor remoto deben ser \00FAnicos en el espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608891758307440932.4001)
,p_name=>'P1935_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(608908559474641574.4001)
,p_prompt=>unistr('Identificador est\00E1tico')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia al servidor remoto en llamadas de API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608909068580641575.4001)
,p_name=>'P1935_PRINT_SERVER_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(608908559474641574.4001)
,p_prompt=>unistr('Tipo de servidor de impresi\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRINT_SERVER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(6300179213172122.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione el tipo de servidor de impresi\00F3n:'),
'</p>',
'<ul>',
unistr('<li><strong>Oracle Analytics Publisher</strong>: seleccione esta opci\00F3n si est\00E1 utilizando una versi\00F3n con licencia de Oracle Analytics Publisher. Esta opci\00F3n permite utilizar los resultados de la consulta del informe para convertirlos de formato XML')
||unistr(' a RTF con Oracle Analytics Publisher. Selecci\00F3nela si desea cargar plantillas RTF o XSL-FO personalizadas para la impresi\00F3n de informes en &PRODUCT_NAME..</li>'),
unistr('<li><strong>APEX Office Print</strong>: seleccione esta opci\00F3n si est\00E1 utilizando APEX Office Print.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(608892999424440944.4001)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where name = :P1935_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre de servidor remoto debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(608891630760440931.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(608893029688440945.4001)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where static_id = :P1935_STATIC_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El ID est\00E1tico del servidor remoto debe ser \00FAnico')
,p_associated_item=>wwv_flow_api.id(608891758307440932.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(608893108529440946.4001)
,p_validation_name=>'URL must start with http or https'
,p_validation_sequence=>30
,p_validation=>'substr( :P1935_BASE_URL, 1, 8 ) = ''https://'' or substr( :P1935_BASE_URL, 1, 7 ) = ''http://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La URL base debe empezar por http:// o https://'
,p_associated_item=>wwv_flow_api.id(608889634955440911.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(608891832708440933.4001)
,p_name=>'Set Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1935_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608891945092440934.4001)
,p_event_id=>wwv_flow_api.id(608891832708440933.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1935_NAME").replace(/[^a-zA-Z0-9]/g, "_")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(608892295227440937.4001)
,p_name=>'Set Base URL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1935_PRINT_SERVER_TYPE'
,p_condition_element=>'P1935_PRINT_SERVER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AOP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P1935_BASE_URL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608892305809440938.4001)
,p_event_id=>wwv_flow_api.id(608892295227440937.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_BASE_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'https://api.apexofficeprint.com/apex/'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608892405214440939.4001)
,p_event_id=>wwv_flow_api.id(608892295227440937.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_BASE_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(608892555767440940.4001)
,p_name=>'Show HTTPS HOST for HTTPS URL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1935_BASE_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1935_BASE_URL").startsWith("https://")'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608892669125440941.4001)
,p_event_id=>wwv_flow_api.id(608892555767440940.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_HTTPS_HOST'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608892725584440942.4001)
,p_event_id=>wwv_flow_api.id(608892555767440940.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_HTTPS_HOST'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(609371879846163108.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(609371704658163107.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(609371955935163109.4001)
,p_event_id=>wwv_flow_api.id(609371879846163108.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01936
begin
wwv_flow_api.create_page(
 p_id=>1936.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Agregar credenciales del servidor de impresi\00F3n remoto')
,p_alias=>'ADD-REMOTE-PRINT-SERVER-CREDENTIALS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Agregar credenciales del servidor de impresi\00F3n remoto')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608890114414440916.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608891030316440925.4001)
,p_plug_name=>unistr('Autenticaci\00F3n necesaria')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608892801836440943.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(608916658335678510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608912244464641588.4001)
,p_plug_name=>unistr('Agregar credenciales del servidor de impresi\00F3n remoto')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(609371248759163102.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(608890114414440916.4001)
,p_button_name=>'APPLY'
,p_button_static_id=>'CREATE_AND_APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(608913298839641588.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(608890114414440916.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1935:&SESSION.::&DEBUG.:1936::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(609371577554163105.4001)
,p_branch_name=>'Branch To 4001'
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608890203624440917.4001)
,p_name=>'P1936_CREDENTIALS_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(608912244464641588.4001)
,p_item_default=>'P1935_NAME'
,p_item_default_type=>'ITEM'
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre descriptivo para la credencial web. Este nombre debe ser \00FAnico en el espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608890321882440918.4001)
,p_name=>'P1936_CREDENTIALS_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(608912244464641588.4001)
,p_prompt=>unistr('Identificador est\00E1tico')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice el ID est\00E1tico para hacer referencia a la credencial web en llamadas de API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608890495966440919.4001)
,p_name=>'P1936_API_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(608912244464641588.4001)
,p_prompt=>'Clave de API'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_display_when=>'P1935_PRINT_SERVER_TYPE'
,p_display_when2=>'AOP'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la clave API para la autenticaci\00F3n. &PRODUCT_NAME. almacena esta informaci\00F3n cifrada, por lo que no se puede recuperar como texto no cifrado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608890680443440921.4001)
,p_name=>'P1936_PASSWORD'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(608912244464641588.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'P1935_PRINT_SERVER_TYPE'
,p_display_when2=>'BIP'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la contrase\00F1a para la autenticaci\00F3n b\00E1sica. &PRODUCT_NAME. almacena esta informaci\00F3n cifrada, por lo que no se puede recuperar como texto no cifrado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608890733858440922.4001)
,p_name=>'P1936_USERNAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(608912244464641588.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_display_when=>'P1935_PRINT_SERVER_TYPE'
,p_display_when2=>'BIP'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de usuario para la autenticaci\00F3n b\00E1sica. &PRODUCT_NAME. no almacena esta informaci\00F3n cifrada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(608912731401641588.4001)
,p_name=>'P1936_AUTH_REQUIRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(608891030316440925.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Autenticaci\00F3n necesaria')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina si utilizar la autenticaci\00F3n para el servidor de impresi\00F3n remoto. Entre las opciones disponibles se incluyen:</p>'),
'<ul>',
unistr('<li><strong>Activado</strong>: autentique las solicitudes del servidor de impresi\00F3n utilizando una credencial.</li>'),
unistr('<li><strong>Desactivado</strong>: el servidor de impresi\00F3n no necesita ninguna autenticaci\00F3n.</li>'),
'</ul>',
'<br/>',
unistr('<p>Pasos para reutilizar las credenciales existentes para el servidor de impresi\00F3n remoto:</p>'),
'<ul>',
unistr('<li>Desactive <strong>Autenticaci\00F3n necesaria</strong> y cierre el asistente.</li>'),
unistr('<li>En Atributos de aplicaci\00F3n, Impresi\00F3n de informe, active <strong>Autenticaci\00F3n necesaria</strong>.</li>'),
'<li>Seleccione la credencial web existente y guarde.</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(608893399112440948.4001)
,p_validation_name=>'API not null for AOP'
,p_validation_sequence=>20
,p_validation=>'P1936_API_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P1935_PRINT_SERVER_TYPE = ''AOP'' and :P1936_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(608890495966440919.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(608893447684440949.4001)
,p_validation_name=>'Username not null for BIP'
,p_validation_sequence=>30
,p_validation=>'P1936_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P1935_PRINT_SERVER_TYPE = ''BIP'' and :P1936_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(608890733858440922.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(608893536877440950.4001)
,p_validation_name=>'Password not null for BIP'
,p_validation_sequence=>40
,p_validation=>'P1936_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P1935_PRINT_SERVER_TYPE = ''BIP'' and :P1936_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(608890680443440921.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(608891183350440926.4001)
,p_name=>'On Auth Required'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1936_AUTH_REQUIRED'
,p_condition_element=>'P1936_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608891227806440927.4001)
,p_event_id=>wwv_flow_api.id(608891183350440926.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(608912244464641588.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608891318934440928.4001)
,p_event_id=>wwv_flow_api.id(608891183350440926.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(608912244464641588.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(608891401725440929.4001)
,p_name=>'Set Static ID'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1936_CREDENTIALS_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(608891575601440930.4001)
,p_event_id=>wwv_flow_api.id(608891401725440929.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1936_CREDENTIALS_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1936_CREDENTIALS_NAME").replace(/[^a-zA-Z0-9]/g, "_")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(609371122508163101.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Remote Print Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_server_id         number;',
'    l_credential_id     number;',
'    l_client_secret     wwv_credentials_dev.client_secret%type;',
'begin',
'',
'    insert into wwv_remote_servers (',
'        name,',
'        static_id,',
'        base_url,',
'        server_type,',
'        https_host,',
'        prompt_on_install,',
'        print_server_type,',
'        server_timeout',
'    ) values (',
'        :P1935_NAME,',
'        :P1935_STATIC_ID,',
'        :P1935_BASE_URL,',
'        ''PRINT_SERVER'',',
'        :P1935_HTTPS_HOST,',
'        ''Y'',',
'        :P1935_PRINT_SERVER_TYPE,',
'        :P1935_SERVER_TIMEOUT )',
'    returning id into l_server_id;',
'',
'    if :P1936_AUTH_REQUIRED = ''Y'' then',
'    ',
'        insert into wwv_credentials (',
'            name,',
'            static_id,',
'            authentication_type,',
'            client_id,',
'            valid_for_urls,',
'            prompt_on_install',
'        ) values (',
'            :P1936_CREDENTIALS_NAME,',
'            :P1936_CREDENTIALS_STATIC_ID,',
'            case :P1935_PRINT_SERVER_TYPE ',
'                when ''BIP'' then ''BASIC''',
'                when ''AOP'' then ''HTTP_QUERY_STRING''',
'            end,',
'            case :P1935_PRINT_SERVER_TYPE ',
'                when ''BIP'' then :P1936_USERNAME ',
'                when ''AOP'' then ''api_key''',
'            end,',
'            :P1935_BASE_URL,',
'            ''Y'' )',
'        returning id into l_credential_id;',
'',
'        l_client_secret := ',
'            case :P1935_PRINT_SERVER_TYPE ',
'                when ''BIP'' then :P1936_PASSWORD',
'                when ''AOP'' then :P1936_API_KEY',
'            end;',
'',
'        update wwv_credentials_dev ',
'           set client_secret        = l_client_secret,',
'               client_secret_verify = l_client_secret',
'         where id = l_credential_id;',
'',
'    end if;',
'',
'    update wwv_flows',
'       set print_server_type      = ''REMOTE'',',
'           print_remote_server_id = l_server_id,',
'           print_credential_id    = l_credential_id',
'     where id                = :FB_FLOW_ID',
'       and security_group_id = wwv_flow_security.g_security_group_id;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(609371248759163102.4001)
,p_process_success_message=>unistr('El servidor de impresi\00F3n remoto se ha creado y activado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(609371672045163106.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Session State'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1935,1936'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01941
begin
wwv_flow_api.create_page(
 p_id=>1941.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear origen de datos de REST'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear origen de datos de REST'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function hideUrlParameters() {',
'    apex.jQuery( "#url_parameters" ).hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM1_NAME").hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM1_VALUE").hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM2_NAME").hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM2_VALUE").hide();',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM1_NAME", "");',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM1_VALUE", "");',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM2_NAME", "");',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM2_VALUE", "");',
'}',
'',
'function checkUrlParameters( pUrlItem ) {',
'    var lUrl        = apex.item( pUrlItem ).getValue(),',
'        lPathPos    = 0,',
'        lParameters, lParameterItem, i;',
'',
'    hideUrlParameters(); ',
'',
'    lPathPos = lUrl.indexOf( "/", 0 ); i = 1;',
'    while ( lPathPos != -1 && i < 3 ) {',
'        lPathPos = lUrl.indexOf( "/", lPathPos + 1 ); i++;',
'    }',
'',
'    if ( lPathPos === -1 ) {',
'        return;',
'    }',
'',
'    lUrl = lUrl.substr( lPathPos );',
'    lParameters = lUrl.match( /:[0-9A-Za-z_-]+/ig );',
'',
'    if ( lParameters && lParameters.length > 0 ) {',
'        apex.jQuery( "#url_parameters" ).show();',
'        for ( i = 0; i < lParameters.length; i++ ) {',
'            if ( i === 2 ) {',
'                break;',
'            }',
'            lParameterItem = "P" + $v("pFlowStepId") + "_URL_PARAM" + ( i + 1 ) + "_";',
'            apex.item( lParameterItem + "NAME" ).setValue( lParameters[ i ].substring( 1 ) );',
'            apex.item( lParameterItem + "NAME" ).show();',
'            apex.item( lParameterItem + "VALUE" ).show();',
'        }',
'    }',
'}',
''))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(245515811416559833.4001)
,p_plug_name=>unistr('Par\00E1metros de URL')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_plug_name=>'Crear origen de datos de REST: Paso 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3850682582142121726.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(226545212901831813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3850682600570121727.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3850682751787121728.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3850682600570121727.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(247657191615093709.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3850682600570121727.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3850683593072121736.4001)
,p_branch_name=>'Go To Page 1942'
,p_branch_action=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1941_SUCCESS'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226684939516475211.4001)
,p_branch_name=>'Go To Page 1947'
,p_branch_action=>'f?p=&APP_ID.:1947:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P1941_SUCCESS'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161024795460385209.4001)
,p_name=>'P1941_STATIC_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226684053025475202.4001)
,p_name=>'P1941_SUCCESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226684215687475204.4001)
,p_name=>'P1941_MUST_AUTHENTICATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226684463973475206.4001)
,p_name=>'P1941_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(242268950336871838.4001)
,p_name=>'P1941_HTTPS_HOST'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_prompt=>'Nombre de host de HTTP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_display_when=>'not ( sys.dbms_db_version.version <= 11 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 1 ) )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de host que va a coincidir con el nombre com\00FAn (CN) del certificado de servidor remoto de una solicitud HTTPS. Tambi\00E9n puede ser un nombre de dominio como *.ejemplo.com. Si es nulo, se utilizar\00E1 el nombre de host de la URL especificada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245515982963559834.4001)
,p_name=>'P1941_URL_PARAM1_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(245515811416559833.4001)
,p_prompt=>unistr('URL&nbsp;Par\00E1metro&nbsp;1')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245516009215559835.4001)
,p_name=>'P1941_URL_PARAM1_VALUE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(245515811416559833.4001)
,p_prompt=>'Valor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245516162788559836.4001)
,p_name=>'P1941_URL_PARAM2_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(245515811416559833.4001)
,p_prompt=>unistr('URL&nbsp;Par\00E1metro&nbsp;2')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_column=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(245516247192559837.4001)
,p_name=>'P1941_URL_PARAM2_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(245515811416559833.4001)
,p_prompt=>'Valor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3850682166297121722.4001)
,p_name=>'P1941_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre para el origen de datos de REST nuevo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3850682229713121723.4001)
,p_name=>'P1941_ENDPOINT_URL'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_prompt=>'Punto Final de URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el URL de punto final (empieza por http:// o https://) para este origen de datos de REST. <em>No</em> agregue aqu\00ED par\00E1metros de cadena de consulta mediante la adici\00F3n de <strong>?name1=value&amp;name2=value</strong>, ya que est\00E1n configur')
||unistr('ados en la p\00E1gina del asistente <strong>avanzado</strong> tras los detalles de autenticaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3850682801212121729.4001)
,p_name=>'P1941_WEB_SRC_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3850682090247121721.4001)
,p_item_default=>'NATIVE_HTTP'
,p_prompt=>'Tipo de origen de datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULE_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determina el tipo de origen de datos de REST.',
'<ul>',
unistr('<li><strong>HTTP simple</strong> indica una fuente de datos de HTTP simple. &PRODUCT_NAME. asume que todos los datos se devuelven con la primera solicitud y que el servidor no soporta el filtrado, la ordenaci\00F3n ni ninguna otra funci\00F3n avanzada de ser')
||unistr('vicio REST en el servidor. Todos los par\00E1metros y detalles de llamada se deben configurar manualmente.</li>'),
unistr('<li><strong>Oracle REST Data Services</strong> indica servicios REST de ORDS (Oracle REST Data Services). Estos servicios REST siguen el <em>est\00E1ndar de Oracle REST</em>, lo que significa que las operaciones GET, POST, PUT y DELETE est\00E1n estandarizad')
||unistr('as. El filtrado y la ordenaci\00F3n del servidor est\00E1n soportados. &PRODUCT_NAME. puede aprovechar estas funciones mediante la delegaci\00F3n de filtros y order by de informe al servicio REST.</li>'),
'<li><strong>Servicio REST de las aplicaciones de Oracle Cloud (SaaS)</strong> indica servicios web RESTful proporcionados por las aplicaciones de SaaS de Oracle Cloud. Utilice este tipo de servicio web para integrar los servicios REST de Oracle SaaS '
||unistr('en su aplicaci\00F3n &PRODUCT_NAME. &PRODUCT_NAME. soporta la paginaci\00F3n para estos servicios.</li>'),
'<li><strong>Servicio REST de Oracle Cloud Infrastructure (OCI)</strong> indica servicios web RESTful proporcionados por Oracle Cloud Infrastructure. Utilice este tipo de servicio web para integrar los servicios REST de OCI (por ejemplo, el acceso al '
||unistr('almac\00E9n de objetos) en su aplicaci\00F3n &PRODUCT_NAME. &PRODUCT_NAME. soporta la paginaci\00F3n para estos servicios.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(161024878391385210.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1941_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'regexp_replace( :P1941_NAME, ''[^a-zA-Z0-9]'', ''_'' )'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226586723006031727.4001)
,p_validation_name=>'Must start with http or https'
,p_validation_sequence=>10
,p_validation=>'substr(:P1941_ENDPOINT_URL, 1, 7) = ''http://'' or substr(:P1941_ENDPOINT_URL, 1, 8) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La URL de punto final debe empezar por http:// o https://'
,p_when_button_pressed=>wwv_flow_api.id(3850682751787121728.4001)
,p_associated_item=>wwv_flow_api.id(3850682229713121723.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3403062224078708639.4001)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_web_src_modules',
' where flow_id = :FB_FLOW_ID',
'   and name = :P1941_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Este nombre ya lo est\00E1 utilizando otro origen de datos de REST.')
,p_when_button_pressed=>wwv_flow_api.id(3850682751787121728.4001)
,p_associated_item=>wwv_flow_api.id(3850682166297121722.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(161024669452385208.4001)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_web_src_modules',
' where flow_id = :FB_FLOW_ID',
'   and static_id = :P1941_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El ID est\00E1tico "&P1941_STATIC_ID." (derivado del nombre de origen) ya est\00E1 en uso por otro origen de datos de REST. Elija otro nombre.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_web_src_modules',
' where flow_id = :FB_FLOW_ID',
'   and name = :P1941_NAME'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_api.id(3850682751787121728.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(546918881978857741.4001)
,p_validation_name=>'URL Parameter 1 should have a value'
,p_validation_sequence=>40
,p_validation=>'P1941_URL_PARAM1_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El par\00E1metro &P1941_URL_PARAM1_NAME!HTML. debe tener un valor.')
,p_validation_condition=>'P1941_URL_PARAM1_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(3850682751787121728.4001)
,p_associated_item=>wwv_flow_api.id(245516009215559835.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(546918940485857742.4001)
,p_validation_name=>'URL Parameter 2 should have a value'
,p_validation_sequence=>50
,p_validation=>'P1941_URL_PARAM2_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El par\00E1metro &P1942_URL_PARAM2_NAME!HTML. debe tener un valor.')
,p_validation_condition=>'P1941_URL_PARAM2_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(3850682751787121728.4001)
,p_associated_item=>wwv_flow_api.id(245516247192559837.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(245516314359559838.4001)
,p_name=>'Check for URL parameters'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_ENDPOINT_URL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(245516440353559839.4001)
,p_event_id=>wwv_flow_api.id(245516314359559838.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'checkUrlParameters( "P1941_ENDPOINT_URL")'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(242269027885871839.4001)
,p_name=>'Show / Hide HTTPS Host'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_ENDPOINT_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item( "P1941_ENDPOINT_URL" ).getValue().substr( 0, 8 ) === "https://"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'not ( sys.dbms_db_version.version <= 11 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 1 ) )'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(242269150083871840.4001)
,p_event_id=>wwv_flow_api.id(242269027885871839.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(242269260299871841.4001)
,p_event_id=>wwv_flow_api.id(242269027885871839.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(242269367776871842.4001)
,p_event_id=>wwv_flow_api.id(242269027885871839.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1417260770635703.4001)
,p_name=>'Load URL Hint'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_WEB_SRC_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1941_ENDPOINT_URL") === "" && $v("P1941_WEB_SRC_TYPE").substr( 0, 7 ) === ''PLUGIN_'''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1417340722635704.4001)
,p_event_id=>wwv_flow_api.id(1417260770635703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_ENDPOINT_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.default_value',
'  from wwv_flow_plugin_std_attributes a, wwv_flow_plugins p',
' where a.plugin_id         = p.id',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.name              = substr( :P1941_WEB_SRC_TYPE, 8 )',
'   and a.name              = ''ENDPOINT_HINT'''))
,p_attribute_07=>'P1941_WEB_SRC_TYPE'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226684303829475205.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Invoke URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.f4000_test_endpoint_url(',
'    p_application_id   => :FB_FLOW_ID,',
'    p_endpoint_url     => :P1941_ENDPOINT_URL,',
'    p_https_host       => :P1941_HTTPS_HOST,',
'    p_web_source_type  => :P1941_WEB_SRC_TYPE,',
'    p_url_param1_name  => :P1941_URL_PARAM1_NAME,',
'    p_url_param1_value => :P1941_URL_PARAM1_VALUE,',
'    p_url_param2_name  => :P1941_URL_PARAM2_NAME,',
'    p_url_param2_value => :P1941_URL_PARAM2_VALUE,',
'    --',
'    p_param1_name      => :P1944_PARAM_NAME_1,',
'    p_param1_type      => :P1944_PARAM_TYPE_1,',
'    p_param1_value     => :P1944_PARAM_VALUE_1,',
'    p_param2_name      => :P1944_PARAM_NAME_2,',
'    p_param2_type      => :P1944_PARAM_TYPE_2,',
'    p_param2_value     => :P1944_PARAM_VALUE_2,',
'    --',
'    p_auth_required    => :P1941_MUST_AUTHENTICATE,',
'    p_success          => :P1941_SUCCESS,',
'    p_message          => :P1941_MESSAGE );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3850682751787121728.4001)
);
end;
/
prompt --application/pages/page_01942
begin
wwv_flow_api.create_page(
 p_id=>1942.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear origen de datos de REST: Servidor remoto'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear origen de datos de REST: Servidor remoto'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4077235555727990976.4001)
,p_plug_name=>'Crear origen de datos de REST: Paso 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4077236047622990981.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(226545212901831813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4077236066050990982.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226556088489869279.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4077236066050990982.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3850683633351121737.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4077236066050990982.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP,1942::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3850684475700121745.4001)
,p_branch_name=>'Go To Page 1945'
,p_branch_action=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.:RP,:P1945_WEB_SOURCE_TYPE:&P1941_WEB_SRC_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226554539349869273.4001)
,p_name=>'P1942_WEB_SOURCE_PATH'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4077235555727990976.4001)
,p_prompt=>'Ruta de acceso de URL de servicio'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca la ruta de URL espec\00EDfica del servicio para este origen de datos de REST. La URL de punto final HTTP se crea agregando este elemento a la URL base especificada en el objeto del servidor remoto.'),
'</p>',
'<p>',
'    Ejemplos',
'</p>',
'<ul>',
'    <li>/services/customers/</li>',
'    <li>/products/4711/details</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3850683159515121732.4001)
,p_name=>'P1942_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4077235555727990976.4001)
,p_prompt=>'Servidor remoto'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_REMOTE_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''WEB_SERVICE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Crear nuevo -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un objeto existente del <strong>servidor remoto</strong>. La URL de punto final HTTP de un origen de datos de REST est\00E1 formada por el servidor remoto (<strong>URL base</strong>) y la parte espec\00EDfica del servicio. Los servidores remotos s')
||unistr('e almacenan como entidades independientes. Cuando varios or\00EDgenes de datos de REST comparten el mismo servidor remoto, se pueden redirigir f\00E1cilmente a otra ubicaci\00F3n f\00EDsica (por ejemplo, de prueba a producci\00F3n) cambiando la URL base en la definici\00F3n')
||' del servidor remoto.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3850683338280121734.4001)
,p_name=>'P1942_REMOTE_SERVER_URL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4077235555727990976.4001)
,p_prompt=>'URL Base'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Esta es la URL base del objeto del servidor remoto seleccionado. La URL de punto final HTTP de este origen de datos de REST se crea a partir de la URL base y el sufijo de ruta de acceso espec\00EDfica del servicio que se indica a continuaci\00F3n.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3850683495071121735.4001)
,p_name=>'P1942_SERVER_URL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4077235555727990976.4001)
,p_prompt=>'URL Base'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El punto final de URL del origen de datos de REST estar\00E1 formado por la URL base (que empezar\00E1 por http:// o https://) y el sufijo de ruta de acceso al servicio que se agregue. La URL base se almacena como objeto del servidor remoto y se puede com')
||unistr('partir en varios or\00EDgenes de datos de REST. Tenga en cuenta que la URL base puede (y normalmente debe) ser m\00E1s que el puerto y el nombre del servidor. Normalmente, las primeras partes de la ruta de acceso de URL (por ejemplo, la ra\00EDz de contexto) tam')
||unistr('bi\00E9n son espec\00EDficas del servidor.</p>'),
'<p>Ejemplos:</p>',
'<ul>',
'    <li>http://api.example.com:8080/myservices/test/</li>',
'    <li>https://api.example.com/ords/scott/</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(226585781101031717.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1942_SERVER_URL'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url ',
'from wwv_remote_servers',
'where id = :P1942_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_compute_when=>'P1942_REMOTE_SERVER_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226586818431031728.4001)
,p_validation_name=>'Endpoint URL starts with http(s)://'
,p_validation_sequence=>10
,p_validation=>'substr(:P1942_SERVER_URL, 1, 7) = ''http://'' or substr(:P1942_SERVER_URL, 1, 8) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La URL base debe empezar por http:// o https://'
,p_validation_condition=>'P1942_REMOTE_SERVER_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_api.id(226556088489869279.4001)
,p_associated_item=>wwv_flow_api.id(3850683495071121735.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3850683769458121738.4001)
,p_name=>'Remote Server ID chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1942_REMOTE_SERVER_ID'
,p_condition_element=>'P1942_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850683840149121739.4001)
,p_event_id=>wwv_flow_api.id(3850683769458121738.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850684240200121743.4001)
,p_event_id=>wwv_flow_api.id(3850683769458121738.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850683927437121740.4001)
,p_event_id=>wwv_flow_api.id(3850683769458121738.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850684054124121741.4001)
,p_event_id=>wwv_flow_api.id(3850683769458121738.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850684320424121744.4001)
,p_event_id=>wwv_flow_api.id(3850683769458121738.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_REMOTE_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id     = :P1942_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1942_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3850683297983121733.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Find Remote Server ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_service_path varchar2(32767);',
'    l_server_url   varchar2(32767);',
'begin',
'    wwv_flow_web_src_dev.f4000_find_remote_server(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_endpoint_url      => :P1941_ENDPOINT_URL,',
'        p_remote_server_id  => :P1942_REMOTE_SERVER_ID,',
'        p_remote_server_url => :P1942_REMOTE_SERVER_URL,',
'        p_server_url        => l_server_url,',
'        p_service_path      => l_service_path );',
'        ',
'    :P1942_WEB_SOURCE_PATH := coalesce( :P1942_WEB_SOURCE_PATH, l_service_path );',
'    :P1942_SERVER_URL      := coalesce( :P1942_SERVER_URL, l_server_url );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01943
begin
wwv_flow_api.create_page(
 p_id=>1943.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Autenticaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Autenticaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229756918559737172.4001)
,p_plug_name=>unistr('Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4303801606432999814.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(226545212901831813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4303801624860999815.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249280433251575818.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4303801624860999815.4001)
,p_button_name=>'STORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear origen de REST de forma manual'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226568123068008840.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(4303801624860999815.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Avanzado'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226585407168031714.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(4303801624860999815.4001)
,p_button_name=>'DISCOVER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Detectar'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226568544889008841.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4303801624860999815.4001)
,p_button_name=>'BACK_TO_1945'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Volver a 1945'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.:RP,::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id         = case',
'                             when substr(:P1941_WEB_SRC_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                             else to_number(:FB_FLOW_ID)',
'                           end',
'   and p.plugin_type     = ''WEB SOURCE TYPE''',
'   and p.name            = substr(:P1941_WEB_SRC_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id       = p.id',
'   and a.attribute_scope = ''COMPONENT''',
'   and a.show_in_wizard  = ''Y'''))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1703512687971334.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4303801624860999815.4001)
,p_button_name=>'BACK_TO_1942'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP,::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id         = case',
'                             when substr(:P1941_WEB_SRC_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                             else to_number(:FB_FLOW_ID)',
'                           end',
'   and p.plugin_type     = ''WEB SOURCE TYPE''',
'   and p.name            = substr(:P1941_WEB_SRC_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id       = p.id',
'   and a.attribute_scope = ''COMPONENT''',
'   and a.show_in_wizard  = ''Y'''))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(249280698399575820.4001)
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(249280433251575818.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226585607385031716.4001)
,p_branch_name=>'Go To Page 1946'
,p_branch_action=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_PREVIOUS_PAGE,P1946_SHOW_ALL:&APP_PAGE_ID.,N&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(226585407168031714.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226586946017031729.4001)
,p_branch_name=>'Go To Page 1944'
,p_branch_action=>'f?p=&APP_ID.:1944:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(226568123068008840.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1341723934822902.4001)
,p_name=>'P1943_OCI_NAMESPACE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'ID de arrendamiento de OCI'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el <em>OCID de Arrendamiento</em> de la Infraestructura de Oracle Cloud.</p>',
unistr('<p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de la Infraestructura de Oracle Cloud</a></p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1341831635822903.4001)
,p_name=>'P1943_OCI_FINGERPRINT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>unistr('Huella de clave p\00FAblica de OCI')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca la <em>huella de clave p\00FAblica RSA</em> para la autenticaci\00F3n de OCI. </p><p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de Infraestructura de Oracle Cloud</a></p>')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1342216553822907.4001)
,p_name=>'P1943_OCI_PRIVATE_KEY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Clave privada de OCI'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca la <em>huella de clave p\00FAblica RSA en formato PEM</em> para la autenticaci\00F3n de OCI. Application Express almacena esta informaci\00F3n cifrada y protegida, por lo que no se puede recuperar como texto no cifrado.</p><p><a target="_blank" hre')
||unistr('f="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de Infraestructura de Oracle Cloud</a></p>')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1342351857822908.4001)
,p_name=>'P1943_OCI_USER_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'ID de usuario de OCI'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el <em>Usuario de OCID</em> de la Infraestructura de Oracle Cloud. Application Express no almacena esta informaci\00F3n cifrada</p>'),
unistr('<p><a target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Documentaci\00F3n de la Infraestructura de Oracle Cloud</a></p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1342738876822912.4001)
,p_name=>'P1943_DEFAULT_AUTH_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3367618171004649.4001)
,p_name=>'P1943_GENERIC_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre del par\00E1metro de cadena de consulta o de la cabecera HTTP.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3367703087004650.4001)
,p_name=>'P1943_GENERIC_VALUE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Valor'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el valor (secreto) del par\00E1metro de cadena de consulta de URL o de la cabecera HTTP.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226573004468012957.4001)
,p_name=>'P1943_AUTH_REQUIRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Autenticaci\00F3n necesaria')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si el nuevo origen de datos de REST requiere autenticaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226573966511012963.4001)
,p_name=>'P1943_CREDENTIAL_STORE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Credenciales'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
'   and ( authentication_type = ''OCI'' or :P1941_WEB_SRC_TYPE != ''OCI'' )',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Introducir nuevas credenciales -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione las credenciales existentes que se van a utilizar para la autenticaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226574766423012964.4001)
,p_name=>'P1943_AUTH_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Especifique el tipo de autenticaci\00F3n aqu\00ED. Actualmente, Application Express es compatible con los siguientes tipos de autenticaci\00F3n:'),
'</p>',
'<ul>',
unistr('    <li><strong>Autenticaci\00F3n b\00E1sica</strong>: env\00EDa un nombre de usuario y una contrase\00F1a en forma de codificaci\00F3n Base64 como la cabecera de la solicitud de <strong>autorizaci\00F3n</strong>.'),
'    </li>',
unistr('    <li><strong>Credenciales de cliente de OAuth2</strong>: Application Express intercambia el ID de cliente y el secreto de cliente por un <strong>token de acceso</strong> usando una URL de servidor de token. A continuaci\00F3n, se utiliza el token de a')
||unistr('cceso para realizar la solicitud real. Si el token de acceso caduca, Application Express solicitar\00E1 uno nuevo de forma transparente.</li>'),
unistr('    <li><strong>Autenticaci\00F3n nativa de OCI</strong>: Application Express firma solicitudes de la API de REST de <em>Oracle Cloud Infrastructure (OCI)</em>, como se describe en la <a href="https://docs.cloud.oracle.com/en-us/iaas/Content/API/Concepts')
||unistr('/signingrequests.htm">documentaci\00F3n de OCI</a>. Este tipo solo est\00E1 disponible en Oracle Database 18c y posteriores.</li>'),
'    <li><strong>Cabecera HTTP</strong>: la credencial se agrega a la solicitud de REST como una cabecera HTTP. El nombre de la credencial es el nombre de la cabecera HTTP, el secreto de la credencial es el valor de la cabecera HTTP. Application Expre'
||unistr('ss no agrega estos secretos al log de depuraci\00F3n ni a ning\00FAn otro log.</li>'),
unistr('    <li><strong>Cadena de consulta de URL</strong>: la credencial se agrega a la URL de la solicitud de REST como un par\00E1metro de <em>cadena de consulta</em> (por ejemplo: <strong>?name=value</strong>). Esta opci\00F3n puede ser \00FAtil para las claves de A')
||unistr('PI. Application Express no agrega estos secretos al log de depuraci\00F3n ni a ning\00FAn otro log. Sin embargo, el proxy u otros servidores intermediarios registrar\00E1n estas credenciales en sus archivos de log.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226575673475012965.4001)
,p_name=>'P1943_CLIENT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Identificador de Cliente'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el valor "ID de cliente" que se va a utilizar para el flujo de credenciales de cliente de OAuth2. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226576582937012965.4001)
,p_name=>'P1943_CLIENT_SECRET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Secreto del Cliente'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el valor "Secreto del cliente" que se va a utilizar para el flujo de credenciales de cliente de OAuth2. Este valor se almacenar\00E1 cifrado.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226577406815012966.4001)
,p_name=>'P1943_USERNAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de usuario que se va a utilizar para la autenticaci\00F3n b\00E1sica.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226578326052012966.4001)
,p_name=>'P1943_PASSWORD'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la contrase\00F1a que se va a utilizar para la autenticaci\00F3n b\00E1sica. Este valor se almacenar\00E1 cifrado.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226686098649475222.4001)
,p_name=>'P1943_TOKEN_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(229756918559737172.4001)
,p_item_default=>'case when :P1941_WEB_SRC_TYPE = wwv_flow_exec_web_src.c_native_web_src_ords then :P1942_SERVER_URL || ''oauth/token'' else :P1942_SERVER_URL end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'URL de token de OAuth'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el punto final de URL desde el que se solicitar\00E1 el token de acceso OAuth. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(226685177759475213.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1943_AUTH_REQUIRED'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P1941_MUST_AUTHENTICATE'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1341641505822901.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1943_DEFAULT_AUTH_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'OCI'
,p_compute_when=>'P1941_WEB_SRC_TYPE'
,p_compute_when_text=>'OCI'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226588517742031745.4001)
,p_validation_name=>'Client ID required'
,p_validation_sequence=>10
,p_validation=>'P1943_CLIENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El ID de cliente debe tener un valor'
,p_validation_condition=>':P1943_AUTH_TYPE = ''OAUTH2_CLIENT_CREDENTIALS'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226575673475012965.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(397074021607399216.4001)
,p_validation_name=>'Token URL required'
,p_validation_sequence=>20
,p_validation=>'P1943_TOKEN_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La URL de token debe tener un valor'
,p_validation_condition=>':P1943_AUTH_TYPE = ''OAUTH2_CLIENT_CREDENTIALS'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226686098649475222.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226588826445031748.4001)
,p_validation_name=>'Username required'
,p_validation_sequence=>30
,p_validation=>'P1943_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El nombre de usuario debe tener un valor'
,p_validation_condition=>':P1943_AUTH_TYPE = ''BASIC'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226577406815012966.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226588968531031749.4001)
,p_validation_name=>'Password required'
,p_validation_sequence=>40
,p_validation=>'P1943_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('La contrase\00F1a debe tener un valor')
,p_validation_condition=>':P1943_AUTH_TYPE = ''BASIC'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226578326052012966.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226588652149031746.4001)
,p_validation_name=>'Client Secret required'
,p_validation_sequence=>50
,p_validation=>'P1943_CLIENT_SECRET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El secreto del cliente debe tener un valor'
,p_validation_condition=>':P1943_AUTH_TYPE = ''OAUTH2_CLIENT_CREDENTIALS'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226576582937012965.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(226589005405031750.4001)
,p_validation_name=>'Authentication Type required'
,p_validation_sequence=>60
,p_validation=>'P1943_AUTH_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('El tipo de autenticaci\00F3n debe tener un valor')
,p_validation_condition=>':P1943_AUTH_REQUIRED = ''Y'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(226574766423012964.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1342840577822913.4001)
,p_validation_name=>'OCI REST Source needs OCI Auth'
,p_validation_sequence=>70
,p_validation=>'P1943_AUTH_TYPE'
,p_validation2=>'OCI'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Se requiere autenticaci\00F3n de Oracle Cloud Infrastructure (OCI) para el origen de datos de REST de OCI.')
,p_validation_condition=>'P1941_WEB_SRC_TYPE'
,p_validation_condition2=>'OCI'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(226574766423012964.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3200864665268106.4001)
,p_validation_name=>'Generic Name required'
,p_validation_sequence=>100
,p_validation=>'P1943_GENERIC_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor'
,p_validation_condition=>':P1943_AUTH_TYPE in( ''HTTP_HEADER'', ''HTTP_QUERY_STRING'' ) and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3367618171004649.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3200952206268107.4001)
,p_validation_name=>'Generic Value required'
,p_validation_sequence=>110
,p_validation=>'P1943_GENERIC_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor'
,p_validation_condition=>':P1943_AUTH_TYPE in( ''HTTP_HEADER'', ''HTTP_QUERY_STRING'' ) and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3367703087004650.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3850684515431121746.4001)
,p_name=>'Authentication required'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_REQUIRED'
,p_condition_element=>'P1943_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850684660113121747.4001)
,p_event_id=>wwv_flow_api.id(3850684515431121746.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850684732845121748.4001)
,p_event_id=>wwv_flow_api.id(3850684515431121746.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE,P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226584992787031709.4001)
,p_event_id=>wwv_flow_api.id(3850684515431121746.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226585072219031710.4001)
,p_event_id=>wwv_flow_api.id(3850684515431121746.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE,P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3850684835538121749.4001)
,p_name=>'Credentials chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_CREDENTIAL_STORE'
,p_condition_element=>'P1943_CREDENTIAL_STORE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3850684937973121750.4001)
,p_event_id=>wwv_flow_api.id(3850684835538121749.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397072920246399205.4001)
,p_event_id=>wwv_flow_api.id(3850684835538121749.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select authentication_type',
'  from wwv_credentials',
' where id = :P1943_CREDENTIAL_STORE',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1943_CREDENTIAL_STORE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226585147074031711.4001)
,p_name=>'No Credentials chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_CREDENTIAL_STORE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1943_AUTH_REQUIRED") === ''Y'' && $v("P1943_CREDENTIAL_STORE") === '''''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226585258222031712.4001)
,p_event_id=>wwv_flow_api.id(226585147074031711.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226585338588031713.4001)
,p_event_id=>wwv_flow_api.id(226585147074031711.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1943_DEFAULT_AUTH_TYPE")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226584256831031702.4001)
,p_name=>'BASIC Auth for new Credentials'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "BASIC" && $v("P1943_CREDENTIAL_STORE") === "") '
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226584319480031703.4001)
,p_event_id=>wwv_flow_api.id(226584256831031702.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226584482287031704.4001)
,p_event_id=>wwv_flow_api.id(226584256831031702.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226584572970031705.4001)
,p_name=>'OAuth Auth for new Credentials'
,p_event_sequence=>45
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'($v("P1943_AUTH_TYPE") === "OAUTH2_CLIENT_CREDENTIALS" && $v("P1943_CREDENTIAL_STORE") === "") ',
''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226584617925031706.4001)
,p_event_id=>wwv_flow_api.id(226584572970031705.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226584809742031708.4001)
,p_event_id=>wwv_flow_api.id(226584572970031705.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397073250799399208.4001)
,p_name=>'BASIC Auth for existing Credentials'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "BASIC" && $v("P1943_CREDENTIAL_STORE") !== "") '
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397073380731399209.4001)
,p_event_id=>wwv_flow_api.id(397073250799399208.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD,P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397073791635399213.4001)
,p_name=>'OAUTH Auth for existing Credentials'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "OAUTH2_CLIENT_CREDENTIALS" && $v("P1943_CREDENTIAL_STORE") !== "") '
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397073872674399214.4001)
,p_event_id=>wwv_flow_api.id(397073791635399213.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397073958207399215.4001)
,p_event_id=>wwv_flow_api.id(397073791635399213.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1341945702822904.4001)
,p_name=>'OCI Auth'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "OCI" && $v("P1943_CREDENTIAL_STORE") === "") '
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1342017433822905.4001)
,p_event_id=>wwv_flow_api.id(1341945702822904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD,P1943_TOKEN_URL,P1943_CLIENT_ID,P1943_CLIENT_SECRET'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1342563646822910.4001)
,p_event_id=>wwv_flow_api.id(1341945702822904.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_OCI_NAMESPACE,P1943_OCI_FINGERPRINT,P1943_OCI_PRIVATE_KEY,P1943_OCI_USER_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1342116326822906.4001)
,p_event_id=>wwv_flow_api.id(1341945702822904.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_OCI_NAMESPACE,P1943_OCI_FINGERPRINT,P1943_OCI_PRIVATE_KEY,P1943_OCI_USER_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3200515860268103.4001)
,p_name=>'Generic HTTP for new Credentials'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'(($v("P1943_AUTH_TYPE") === "HTTP_HEADER" || $v("P1943_AUTH_TYPE") === "HTTP_QUERY_STRING" ) && $v("P1943_CREDENTIAL_STORE") === "") '
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3200620012268104.4001)
,p_event_id=>wwv_flow_api.id(3200515860268103.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_GENERIC_NAME,P1943_GENERIC_VALUE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3200792284268105.4001)
,p_event_id=>wwv_flow_api.id(3200515860268103.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_GENERIC_NAME,P1943_GENERIC_VALUE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226585513501031715.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store or Discover REST Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.f4000_store_or_discover(',
'    p_application_id   => :FB_FLOW_ID,',
'    --',
'    p_action           => :REQUEST,   -- "DISCOVER" or "STORE"',
'    --',
'    p_web_src_type     => :P1941_WEB_SRC_TYPE,',
'    --',
'    p_server_id        => :P1942_REMOTE_SERVER_ID,',
'    p_server_url       => :P1942_SERVER_URL,',
'    p_service_path     => :P1942_WEB_SOURCE_PATH,',
'    --',
'    p_https_host       => :P1941_HTTPS_HOST,',
'    --',
'    p_auth_required    => ( :P1943_AUTH_REQUIRED = ''Y'' ),',
'    p_cred_store       => :P1943_CREDENTIAL_STORE,',
'    p_token_url        => :P1943_TOKEN_URL,',
'    --',
'    p_auth_type        => :P1943_AUTH_TYPE,',
'    p_client_id        => case when :P1943_AUTH_TYPE = ''OCI''                                 then :P1943_OCI_USER_ID ',
'                               when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_NAME',
'                               else :P1943_CLIENT_ID end,',
'    p_client_secret    => case when :P1943_AUTH_TYPE = ''OCI'' then :P1943_OCI_PRIVATE_KEY ',
'                               when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_VALUE',
'                               else :P1943_CLIENT_SECRET end,',
'    p_username         => :P1943_USERNAME,',
'    p_password         => :P1943_PASSWORD,',
'    p_namespace        => :P1943_OCI_NAMESPACE,',
'    p_fingerprint      => :P1943_OCI_FINGERPRINT,',
'    --',
'    p_url_param_name1  => :P1941_URL_PARAM1_NAME,',
'    p_url_param_type1  => ''URL_PATTERN'',',
'    p_url_param_value1 => :P1941_URL_PARAM1_VALUE,',
'    --',
'    p_url_param_name2  => :P1941_URL_PARAM2_NAME,',
'    p_url_param_type2  => ''URL_PATTERN'',',
'    p_url_param_value2 => :P1941_URL_PARAM2_VALUE,',
'    --',
'    p_module_name      => :P1941_NAME,',
'    --',
'    p_attribute_01     => :P1945_ATTRIBUTE_01,',
'    p_attribute_02     => :P1945_ATTRIBUTE_02,',
'    p_attribute_03     => :P1945_ATTRIBUTE_03,',
'    p_attribute_04     => :P1945_ATTRIBUTE_04,',
'    p_attribute_05     => :P1945_ATTRIBUTE_05,',
'    p_attribute_06     => :P1945_ATTRIBUTE_06,',
'    p_attribute_07     => :P1945_ATTRIBUTE_07,',
'    p_attribute_08     => :P1945_ATTRIBUTE_08,',
'    p_attribute_09     => :P1945_ATTRIBUTE_09,',
'    p_attribute_10     => :P1945_ATTRIBUTE_10,',
'    p_attribute_11     => :P1945_ATTRIBUTE_11,',
'    p_attribute_12     => :P1945_ATTRIBUTE_12,',
'    p_attribute_13     => :P1945_ATTRIBUTE_13,',
'    p_attribute_14     => :P1945_ATTRIBUTE_14,',
'    p_attribute_15     => :P1945_ATTRIBUTE_15 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':STORE:DISCOVER:'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_01944
begin
wwv_flow_api.create_page(
 p_id=>1944.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Par\00E1metros')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Par\00E1metros')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function showNextParameter( pElement, pShow ) {',
'    var lIdx = parseInt( apex.jQuery( pElement ).attr( "id" ).match( /\d*$/ ) ) + 1;',
'    ',
'    if ( lIdx <= 10 ) {',
'        if ( pShow ) {',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_TYPE_"  + lIdx ).show();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_NAME_"  + lIdx ).show();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_VALUE_" + lIdx ).show();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_STATIC_" + lIdx ).show();',
'        } else {',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_TYPE_"  + lIdx ).setValue( null );',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_TYPE_"  + lIdx ).hide();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_NAME_"  + lIdx ).hide();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_VALUE_" + lIdx ).hide();            ',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_STATIC_" + lIdx ).hide();            ',
'        }',
'    }   ',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229808739519718827.4001)
,p_plug_name=>unistr('Par\00E1metros')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span id="LABEL_ROW_2" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_2.</span>',
'<span id="LABEL_ROW_3" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_3.</span>',
'<span id="LABEL_ROW_4" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_4.</span>',
'<span id="LABEL_ROW_5" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_5.</span>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Span tags in region are used to label the different item types in the region, that don''t have a visible label.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(236247361887284208.4001)
,p_plug_name=>unistr('An\00E1lisis')
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(772844574702815533.4001)
,p_plug_name=>unistr('M\00E9todo HTTP')
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4530442089424377798.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(226545212901831813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4530442107852377799.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(249280830061575822.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4530442107852377799.4001)
,p_button_name=>'STORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear origen de REST de forma manual'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226641944692378031.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4530442107852377799.4001)
,p_button_name=>'DISCOVER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Detectar'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226641566399378030.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4530442107852377799.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1943:&SESSION.::&DEBUG.:RP,1944::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(249280975339575823.4001)
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(249280830061575822.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226660173722378094.4001)
,p_branch_name=>'Go To Page 1946'
,p_branch_action=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_PREVIOUS_PAGE,P1946_SHOW_ALL:&APP_PAGE_ID.,N&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(226641944692378031.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1642979377019601.4001)
,p_name=>'P1944_SAMPLE_RESPONSE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(236247361887284208.4001)
,p_prompt=>'Ejemplo de respuesta'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Cargue aqu\00ED un ejemplo de la respuesta del servicio REST. Application Express analizar\00E1 esta respuesta en vez de comunicarse con el servicio REST. Esto podr\00EDa utilizarse si la comunicaci\00F3n con el servicio REST no es posible o si la autenticaci\00F3n nece')
||unistr('saria no est\00E1 disponible durante el tiempo de dise\00F1o.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226664383251383485.4001)
,p_name=>'P1944_PARAM_TYPE_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_prompt=>unistr('Tipo de Par\00E1metro')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226664774190383486.4001)
,p_name=>'P1944_PARAM_NAME_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_prompt=>unistr('Nombre del Par\00E1metro')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226665129383383486.4001)
,p_name=>'P1944_PARAM_VALUE_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_prompt=>'Valor'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226665501361383486.4001)
,p_name=>'P1944_PARAM_TYPE_2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226665984566383486.4001)
,p_name=>'P1944_PARAM_NAME_2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226666398510383487.4001)
,p_name=>'P1944_PARAM_VALUE_2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226666733001383487.4001)
,p_name=>'P1944_PARAM_TYPE_3'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226667164825383487.4001)
,p_name=>'P1944_PARAM_NAME_3'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226667581668383488.4001)
,p_name=>'P1944_PARAM_VALUE_3'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226667915467383488.4001)
,p_name=>'P1944_PARAM_TYPE_4'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226668342295383488.4001)
,p_name=>'P1944_PARAM_NAME_4'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226668757471383488.4001)
,p_name=>'P1944_PARAM_VALUE_4'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226669163228383489.4001)
,p_name=>'P1944_PARAM_TYPE_5'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(226045111811519566.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226669573164383489.4001)
,p_name=>'P1944_PARAM_NAME_5'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226669939412383489.4001)
,p_name=>'P1944_PARAM_VALUE_5'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(236247462853284209.4001)
,p_name=>'P1944_ROW_SELECTOR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(236247361887284208.4001)
,p_prompt=>unistr('Selector de filas (dejar vac\00EDo para la detecci\00F3n autom\00E1tica)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El <strong>selector de filas</strong> indica la expresi\00F3n de la ruta de acceso XML o JSON que navega al atributo JSON o a la etiqueta XML que contiene la matriz de filas. Si no se indica ning\00FAn valor, Application Express intentar\00E1 detectar autom\00E1t')
||'icamente el selector de filas. ',
'</p>',
'<p>Ejemplos de XML:</p>',
'<ul>',
'<li>/rss/channel/item</li>',
'<li>/root/tag/array</li>',
'</ul>',
'<p>',
'    ',
'</p>',
'<p>Ejemplos de JSON:</p>',
'<ul>',
'<li>.</li>',
'<li>items</li>',
'<li>result.items</li>',
'<li>items[0].results</li>',
'</ul>',
'<p>',
'    ',
'</p><p>',
unistr('    No puede utilizar la expresi\00F3n "[*]" en un selector de filas JSON. Por ejemplo, <span style="text-decoration: line-through";>items[*].employees</span> est\00E1 prohibido.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(525230382938218513.4001)
,p_name=>'P1944_SINGLE_ROW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(236247361887284208.4001)
,p_item_default=>'N'
,p_prompt=>'Devuelve'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Single Row;Y,Table;N'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529222451190107544.4001)
,p_name=>'P1944_PARAM_STATIC_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Es est\00E1tico')
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529222567267107545.4001)
,p_name=>'P1944_PARAM_STATIC_2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529222686536107546.4001)
,p_name=>'P1944_PARAM_STATIC_3'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529222726383107547.4001)
,p_name=>'P1944_PARAM_STATIC_4'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529222893827107548.4001)
,p_name=>'P1944_PARAM_STATIC_5'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(229808739519718827.4001)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(772844618826815534.4001)
,p_name=>'P1944_HTTP_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(772844574702815533.4001)
,p_item_default=>'GET'
,p_prompt=>unistr('M\00E9todo HTTP')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:GET;GET,POST;POST'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Elija el m\00E9todo HTTP que se utilizar\00E1 en la detecci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(772844783985815535.4001)
,p_name=>'P1944_REQUEST_BODY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(772844574702815533.4001)
,p_prompt=>'Cuerpo de solicitud'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione una plantilla de cuerpo de solicitud para la solicitud POST. Al utilizar sintaxis #PLACEHOLDER#, aseg\00FArese de declarar los par\00E1metros del tipo de <strong>cuerpo de solicitud/respuesta</strong> anterior.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226649628690378082.4001)
,p_name=>'Remote Server ID chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_REMOTE_SERVER_ID'
,p_condition_element=>'P1944_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226650120336378085.4001)
,p_event_id=>wwv_flow_api.id(226649628690378082.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226651690710378086.4001)
,p_event_id=>wwv_flow_api.id(226649628690378082.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226650638111378085.4001)
,p_event_id=>wwv_flow_api.id(226649628690378082.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226651110426378085.4001)
,p_event_id=>wwv_flow_api.id(226649628690378082.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226652133434378086.4001)
,p_event_id=>wwv_flow_api.id(226649628690378082.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REMOTE_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id     = :P1944_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1944_REMOTE_SERVER_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226652585664378086.4001)
,p_name=>'Authentication required'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_AUTH_REQUIRED'
,p_condition_element=>'P1944_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226653018630378087.4001)
,p_event_id=>wwv_flow_api.id(226652585664378086.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_CREDENTIAL_STORE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226653549128378088.4001)
,p_event_id=>wwv_flow_api.id(226652585664378086.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_CREDENTIAL_STORE,P1944_AUTH_TYPE,P1944_CLIENT_ID,P1944_CLIENT_SECRET,P1944_USERNAME,P1944_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226654051770378089.4001)
,p_event_id=>wwv_flow_api.id(226652585664378086.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_CREDENTIAL_STORE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226654598963378089.4001)
,p_event_id=>wwv_flow_api.id(226652585664378086.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_CREDENTIAL_STORE,P1944_AUTH_TYPE,P1944_CLIENT_ID,P1944_CLIENT_SECRET,P1944_USERNAME,P1944_PASSWORD'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226654941300378090.4001)
,p_name=>'Credentials chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_CREDENTIAL_STORE'
,p_condition_element=>'P1944_CREDENTIAL_STORE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226655464107378090.4001)
,p_event_id=>wwv_flow_api.id(226654941300378090.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_AUTH_TYPE,P1944_CLIENT_ID,P1944_CLIENT_SECRET,P1944_USERNAME,P1944_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226658628213378092.4001)
,p_name=>'No Credentials chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_CREDENTIAL_STORE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1944_AUTH_REQUIRED") === ''Y'' && $v("P1944_CREDENTIAL_STORE") === '''''
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226659170774378093.4001)
,p_event_id=>wwv_flow_api.id(226658628213378092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_AUTH_TYPE,P1944_CLIENT_ID,P1944_CLIENT_SECRET,P1944_USERNAME,P1944_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226659620525378093.4001)
,p_event_id=>wwv_flow_api.id(226658628213378092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_AUTH_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226655881365378090.4001)
,p_name=>'Auth Type "BASIC" chosen'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_AUTH_TYPE'
,p_condition_element=>'P1944_AUTH_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'BASIC'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226656372130378091.4001)
,p_event_id=>wwv_flow_api.id(226655881365378090.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_USERNAME,P1944_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226656846383378091.4001)
,p_event_id=>wwv_flow_api.id(226655881365378090.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_USERNAME,P1944_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226657245962378091.4001)
,p_name=>'Auth Type "OAUTH" chosen'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_AUTH_TYPE'
,p_condition_element=>'P1944_AUTH_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226657744148378091.4001)
,p_event_id=>wwv_flow_api.id(226657245962378091.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_CLIENT_ID,P1944_CLIENT_SECRET'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226658292465378092.4001)
,p_event_id=>wwv_flow_api.id(226657245962378091.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_CLIENT_ID,P1944_CLIENT_SECRET'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226587069087031730.4001)
,p_name=>'Show Parameter 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_1'
,p_condition_element=>'P1944_PARAM_TYPE_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226587113227031731.4001)
,p_event_id=>wwv_flow_api.id(226587069087031730.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226587231623031732.4001)
,p_event_id=>wwv_flow_api.id(226587069087031730.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226587559358031735.4001)
,p_name=>'Show Parameter 3'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_2'
,p_condition_element=>'P1944_PARAM_TYPE_2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226587690838031736.4001)
,p_event_id=>wwv_flow_api.id(226587559358031735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226587770327031737.4001)
,p_event_id=>wwv_flow_api.id(226587559358031735.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226587874394031738.4001)
,p_name=>'Show Parameter 4'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_3'
,p_condition_element=>'P1944_PARAM_TYPE_3'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226587929099031739.4001)
,p_event_id=>wwv_flow_api.id(226587874394031738.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226588034035031740.4001)
,p_event_id=>wwv_flow_api.id(226587874394031738.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(226588232333031742.4001)
,p_name=>'Show Parameter 5'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_4'
,p_condition_element=>'P1944_PARAM_TYPE_4'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226588355941031743.4001)
,p_event_id=>wwv_flow_api.id(226588232333031742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(226588477419031744.4001)
,p_event_id=>wwv_flow_api.id(226588232333031742.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(525230408212218514.4001)
,p_name=>'Change Row Selector'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_ROW_SELECTOR'
,p_condition_element=>'P1944_ROW_SELECTOR'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525230584838218515.4001)
,p_event_id=>wwv_flow_api.id(525230408212218514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_SINGLE_ROW'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(525230626357218516.4001)
,p_event_id=>wwv_flow_api.id(525230408212218514.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_SINGLE_ROW'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(772844865122815536.4001)
,p_name=>'Show Request Body'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_HTTP_METHOD'
,p_condition_element=>'P1944_HTTP_METHOD'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'GET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(772844936572815537.4001)
,p_event_id=>wwv_flow_api.id(772844865122815536.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REQUEST_BODY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(772845004362815538.4001)
,p_event_id=>wwv_flow_api.id(772844865122815536.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REQUEST_BODY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(772845198924815539.4001)
,p_event_id=>wwv_flow_api.id(772844865122815536.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REQUEST_BODY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226649231601378080.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store or Discover REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sample_response blob;',
'begin',
'    if :P1944_SAMPLE_RESPONSE is not null then',
'        select blob_content ',
'          into l_sample_response',
'          from wwv_flow_temp_files',
'         where name = :P1944_SAMPLE_RESPONSE;',
'    end if;',
'                       ',
'    wwv_flow_web_src_dev.f4000_store_or_discover(',
'        p_application_id   => :FB_FLOW_ID,',
'        --',
'        p_action           => :REQUEST,   -- "DISCOVER" or "STORE"',
'        --',
'        p_web_src_type     => :P1941_WEB_SRC_TYPE,',
'        p_http_method      => :P1944_HTTP_METHOD,',
'        p_request_body     => :P1944_REQUEST_BODY,',
'        --',
'        p_server_id        => :P1942_REMOTE_SERVER_ID,',
'        p_server_url       => :P1942_SERVER_URL,',
'        p_service_path     => :P1942_WEB_SOURCE_PATH,',
'        --',
'        p_https_host       => :P1941_HTTPS_HOST,',
'        --',
'        p_auth_required    => ( :P1943_AUTH_REQUIRED = ''Y'' ),',
'        p_cred_store       => :P1943_CREDENTIAL_STORE,',
'        p_token_url        => :P1943_TOKEN_URL,',
'        --',
'        p_auth_type        => :P1943_AUTH_TYPE,',
'        p_client_id        => case when :P1943_AUTH_TYPE = ''OCI''                                 then :P1943_OCI_USER_ID ',
'                                   when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_NAME',
'                                   else :P1943_CLIENT_ID end,',
'        p_client_secret    => case when :P1943_AUTH_TYPE = ''OCI'' then :P1943_OCI_PRIVATE_KEY ',
'                                   when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_VALUE',
'                                   else :P1943_CLIENT_SECRET end,',
'        p_username         => :P1943_USERNAME,',
'        p_password         => :P1943_PASSWORD,',
'        p_namespace        => :P1943_OCI_NAMESPACE,',
'        p_fingerprint      => :P1943_OCI_FINGERPRINT,',
'        --',
'        p_url_param_name1  => :P1944_PARAM_NAME_1,',
'        p_url_param_type1  => :P1944_PARAM_TYPE_1,',
'        p_url_param_value1 => :P1944_PARAM_VALUE_1,',
'        p_url_param_stat1  => :P1944_PARAM_STATIC_1,',
'        --',
'        p_url_param_name2  => :P1944_PARAM_NAME_2,',
'        p_url_param_type2  => :P1944_PARAM_TYPE_2,',
'        p_url_param_value2 => :P1944_PARAM_VALUE_2,',
'        p_url_param_stat2  => :P1944_PARAM_STATIC_2,',
'        --',
'        p_url_param_name3  => :P1944_PARAM_NAME_3,',
'        p_url_param_type3  => :P1944_PARAM_TYPE_3,',
'        p_url_param_value3 => :P1944_PARAM_VALUE_3,',
'        p_url_param_stat3  => :P1944_PARAM_STATIC_3,',
'        --',
'        p_url_param_name4  => :P1944_PARAM_NAME_4,',
'        p_url_param_type4  => :P1944_PARAM_TYPE_4,',
'        p_url_param_value4 => :P1944_PARAM_VALUE_4,',
'        p_url_param_stat4  => :P1944_PARAM_STATIC_4,',
'        --',
'        p_url_param_name5  => :P1944_PARAM_NAME_5,',
'        p_url_param_type5  => :P1944_PARAM_TYPE_5,',
'        p_url_param_value5 => :P1944_PARAM_VALUE_5,',
'        p_url_param_stat5  => :P1944_PARAM_STATIC_5,',
'        --',
'        p_row_selector     => :P1944_ROW_SELECTOR,',
'        p_is_single_row    => case :P1944_SINGLE_ROW when ''Y'' then true when ''N'' then false end,',
'        --',
'        p_module_name      => :P1941_NAME,',
'        --',
'        p_sample_response  => l_sample_response,',
'        --',
'        p_attribute_01     => :P1945_ATTRIBUTE_01,',
'        p_attribute_02     => :P1945_ATTRIBUTE_02,',
'        p_attribute_03     => :P1945_ATTRIBUTE_03,',
'        p_attribute_04     => :P1945_ATTRIBUTE_04,',
'        p_attribute_05     => :P1945_ATTRIBUTE_05,',
'        p_attribute_06     => :P1945_ATTRIBUTE_06,',
'        p_attribute_07     => :P1945_ATTRIBUTE_07,',
'        p_attribute_08     => :P1945_ATTRIBUTE_08,',
'        p_attribute_09     => :P1945_ATTRIBUTE_09,',
'        p_attribute_10     => :P1945_ATTRIBUTE_10,',
'        p_attribute_11     => :P1945_ATTRIBUTE_11,',
'        p_attribute_12     => :P1945_ATTRIBUTE_12,',
'        p_attribute_13     => :P1945_ATTRIBUTE_13,',
'        p_attribute_14     => :P1945_ATTRIBUTE_14,',
'        p_attribute_15     => :P1945_ATTRIBUTE_15 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error durante la detecci\00F3n o el almacenamiento del origen de datos de REST: #SQLERRM#')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':STORE:DISCOVER:'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_01945
begin
wwv_flow_api.create_page(
 p_id=>1945.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear origen de datos de REST: Configuraci\00F3n')
,p_alias=>'CREATE-WEB-SOURCE-SETTINGS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear origen de datos de REST: Configuraci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(348249463253283503.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(348267434074286188.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P1945_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_type_page_item_name => ''P1945_WEB_SOURCE_TYPE'',',
'        p_page_item_prefix    => ''P1945_'',',
'        p_user_interface_id   => null,',
'        p_is_wizard           => true',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4078475012151886933.4001)
,p_plug_name=>'Crear origen de datos de REST'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(226545212901831813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4078475030579886934.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1243693922896095.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4078475030579886934.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1244095110896102.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4078475030579886934.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP,1942::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1248589907896187.4001)
,p_branch_name=>'Go To Page 1943'
,p_branch_action=>'f?p=&APP_ID.:1943:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1703473777971333.4001)
,p_branch_name=>'Go To Page 1943'
,p_branch_action=>'f?p=&APP_ID.:1943:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id         = case',
'                             when substr(:P1941_WEB_SRC_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                             else to_number(:FB_FLOW_ID)',
'                           end',
'   and p.plugin_type     = ''WEB SOURCE TYPE''',
'   and p.name            = substr(:P1941_WEB_SRC_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id       = p.id',
'   and a.attribute_scope = ''COMPONENT''',
'   and a.show_in_wizard  = ''Y'''))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1249113815899063.4001)
,p_name=>'P1945_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P1945_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1249514406899065.4001)
,p_name=>'P1945_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P1945_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1249973619899065.4001)
,p_name=>'P1945_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P1945_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1250311713899066.4001)
,p_name=>'P1945_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P1945_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1250788015899066.4001)
,p_name=>'P1945_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P1945_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1251104920899066.4001)
,p_name=>'P1945_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P1945_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1251522703899066.4001)
,p_name=>'P1945_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P1945_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1251963150899066.4001)
,p_name=>'P1945_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P1945_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1252318155899066.4001)
,p_name=>'P1945_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P1945_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1252775040899067.4001)
,p_name=>'P1945_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P1945_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1253100067899067.4001)
,p_name=>'P1945_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P1945_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1253505694899067.4001)
,p_name=>'P1945_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P1945_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1253916604899067.4001)
,p_name=>'P1945_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P1945_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1254346886899067.4001)
,p_name=>'P1945_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P1945_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1254744691899068.4001)
,p_name=>'P1945_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(348249463253283503.4001)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P1945_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2211638547848934.4001)
,p_name=>'P1945_WEB_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4078475012151886933.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1245517386896178.4001)
,p_name=>'Remote Server ID chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1945_REMOTE_SERVER_ID'
,p_condition_element=>'P1945_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1246062003896180.4001)
,p_event_id=>wwv_flow_api.id(1245517386896178.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1246545066896182.4001)
,p_event_id=>wwv_flow_api.id(1245517386896178.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1247017135896182.4001)
,p_event_id=>wwv_flow_api.id(1245517386896178.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1247572671896184.4001)
,p_event_id=>wwv_flow_api.id(1245517386896178.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1248075722896184.4001)
,p_event_id=>wwv_flow_api.id(1245517386896178.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_REMOTE_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id     = :P1945_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1945_REMOTE_SERVER_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_01946
begin
wwv_flow_api.create_page(
 p_id=>1946.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Detecci\00F3n de origen de datos de REST')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Detecci\00F3n de origen de datos de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226586120007031721.4001)
,p_plug_name=>'Progreso de asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_api.id(226545212901831813.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226685270873475214.4001)
,p_plug_name=>'Correcto'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1946_STATUS_CODE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48101656388492239.4001)
,p_plug_name=>'Perfil de Datos'
,p_parent_plug_id=>wwv_flow_api.id(226685270873475214.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48101703770492240.4001)
,p_name=>'Perfil de Datos'
,p_parent_plug_id=>wwv_flow_api.id(48101656388492239.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_region_attributes=>'style="margin-bottom: 10px"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce( c002, ''.'' ) as row_selector,',
'       case when c003 = ''Y'' then wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.ONE'') else wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.MANY'') end as single_row,',
'       c004 as response_type',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''DATA_PROFILE''',
'   and rownum = 1',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48101890060492241.4001)
,p_query_column_id=>1
,p_column_alias=>'ROW_SELECTOR'
,p_column_display_sequence=>2
,p_column_heading=>'Selector de Filas'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48101945831492242.4001)
,p_query_column_id=>2
,p_column_alias=>'SINGLE_ROW'
,p_column_display_sequence=>3
,p_column_heading=>'Devuelve'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48102011041492243.4001)
,p_query_column_id=>3
,p_column_alias=>'RESPONSE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo de Respuesta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(229850152662472437.4001)
,p_name=>'Columnas de perfil de datos'
,p_parent_plug_id=>wwv_flow_api.id(48101656388492239.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select rownum as sequence,',
'       c002 as column_name,',
'       c003 as is_primary_key,',
'       c004 as data_type,',
'       c005 as max_length,',
'       c006 as format_mask,',
'       c007 as has_time_zone,',
'       c008 as selector',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''DATA_PROFILE_COLUMNS''',
' order by seq_id asc',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226606368877196931.4001)
,p_query_column_id=>1
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226606797600196935.4001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226607069519196935.4001)
,p_query_column_id=>3
,p_column_alias=>'IS_PRIMARY_KEY'
,p_column_display_sequence=>3
,p_column_heading=>'Clave Primaria'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226607415624196937.4001)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo de dato'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226607845047196937.4001)
,p_query_column_id=>5
,p_column_alias=>'MAX_LENGTH'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Longitud M\00E1xima')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226608298659196938.4001)
,p_query_column_id=>6
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>6
,p_column_heading=>unistr('M\00E1scara de Formato')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226608666487196938.4001)
,p_query_column_id=>7
,p_column_alias=>'HAS_TIME_ZONE'
,p_column_display_sequence=>7
,p_column_heading=>'Tiene zona horaria'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226609001538196938.4001)
,p_query_column_id=>8
,p_column_alias=>'SELECTOR'
,p_column_display_sequence=>8
,p_column_heading=>'Selector'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229792181060921168.4001)
,p_plug_name=>'Cuerpo de la Respuesta'
,p_parent_plug_id=>wwv_flow_api.id(226685270873475214.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'select case when sys.dbms_lob.getlength(clob001) > 524288 then to_clob( wwv_flow_lang.system_message(''apex.websrc.response_body_too_large'')) else clob001 end clob001 from wwv_flow_collections where collection_name = ''WEB_SOURCE_INFO'' and c001=''DATA'' '
||'and rownum = 1'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1946_SHOW_ALL'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'SQL'
,p_attribute_02=>'10'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229851843366472454.4001)
,p_plug_name=>'RDS'
,p_parent_plug_id=>wwv_flow_api.id(226685270873475214.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(229851931201472455.4001)
,p_name=>'Datos'
,p_parent_plug_id=>wwv_flow_api.id(226685270873475214.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,',
'       c002,',
'       c003,',
'       c004,',
'       c005,',
'       c006,',
'       c007,',
'       c008,',
'       c009,',
'       c010,',
'       c011,',
'       c012,',
'       c013,',
'       c014,',
'       c015',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_DATA'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headings varchar2(32767);',
'begin',
'    for c in ( select * from (',
'                   select c002 ',
'                     from wwv_flow_collections',
'                    where collection_name = ''WEB_SOURCE_INFO''',
'                      and c001            = ''DATA_PROFILE_COLUMNS''',
'                    order by seq_id asc ) ',
'               where rownum <= 15 ) loop',
'       l_headings := l_headings || initcap(c.c002) || '':'';',
'    end loop;',
'    return substr( l_headings, 1, length( l_headings ) - 1 );',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No se han encontrado datos al analizar la respuesta de servicio.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226610005093196945.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'C001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226610429777196945.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226610842779196946.4001)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226611254239196946.4001)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'C004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226611670304196946.4001)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'C005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226612048551196947.4001)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_column_heading=>'C006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226612495123196947.4001)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_column_heading=>'C007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226612867754196947.4001)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_column_heading=>'C008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226613233610196948.4001)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'C009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226613651422196948.4001)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'C010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226614004025196948.4001)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'C011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226614464010196949.4001)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226614855773196949.4001)
,p_query_column_id=>13
,p_column_alias=>'C013'
,p_column_display_sequence=>13
,p_column_heading=>'C013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226615240311196949.4001)
,p_query_column_id=>14
,p_column_alias=>'C014'
,p_column_display_sequence=>14
,p_column_heading=>'C014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226615666820196950.4001)
,p_query_column_id=>15
,p_column_alias=>'C015'
,p_column_display_sequence=>15
,p_column_heading=>'C015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(229894216737686340.4001)
,p_name=>'Operaciones'
,p_parent_plug_id=>wwv_flow_api.id(226685270873475214.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002 as method,',
'       c003 as url_endpoint,',
'       c004 as database_operation',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''METHODS''',
' order by c002 asc'))
,p_display_when_condition=>'P1946_SHOW_ALL'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226617007286196953.4001)
,p_query_column_id=>1
,p_column_alias=>'METHOD'
,p_column_display_sequence=>1
,p_column_heading=>unistr('M\00E9todo HTTP')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226617451096196954.4001)
,p_query_column_id=>2
,p_column_alias=>'URL_ENDPOINT'
,p_column_display_sequence=>2
,p_column_heading=>'URL de Punto Final'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226617847373196955.4001)
,p_query_column_id=>3
,p_column_alias=>'DATABASE_OPERATION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Acci\00F3n de Base de Datos')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(225834585600778166)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(452559754639812674.4001)
,p_name=>'Cabeceras de Respuesta'
,p_parent_plug_id=>wwv_flow_api.id(226685270873475214.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002 as header_name,',
'       c003 as header_value',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''RESPONSE_HEADERS''',
' order by seq_id asc',
''))
,p_display_when_condition=>'P1946_SHOW_ALL'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226618521824196956.4001)
,p_query_column_id=>1
,p_column_alias=>'HEADER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de Cabecera'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226618941809196956.4001)
,p_query_column_id=>2
,p_column_alias=>'HEADER_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Valor de Cabecera'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226685367362475215.4001)
,p_plug_name=>'Fallo'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1946_STATUS_CODE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(226685443264475216.4001)
,p_name=>'Respuesta del Servidor'
,p_parent_plug_id=>wwv_flow_api.id(226685367362475215.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dbms_lob.substr( clob001, 4000, 1 ) as response',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(226685602377475218.4001)
,p_query_column_id=>1
,p_column_alias=>'RESPONSE'
,p_column_display_sequence=>1
,p_column_heading=>'Respuesta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226685910156475221.4001)
,p_plug_name=>'Estado de HTTP'
,p_parent_plug_id=>wwv_flow_api.id(226685367362475215.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p style="text-align: center">',
'<span style="color: red;" class="a-Icon a-Icon--regionIcon icon-error a-Icon--xl"></span>',
'</p>',
'<p style="text-align: center">',
unistr('Error de detecci\00F3n: &P1946_STATUS_CODE.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229893262666686330.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226586249349031722.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(229893262666686330.4001)
,p_button_name=>'SHOW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('M\00E1s Detalles')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_SHOW_ALL:Y'
,p_button_condition=>':P1946_SHOW_ALL = ''N'' and :P1946_STATUS_CODE is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226683938048475201.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(229893262666686330.4001)
,p_button_name=>'SHOW_LESS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Menos Detalles'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_SHOW_ALL:N'
,p_button_condition=>':P1946_SHOW_ALL = ''Y'' and :P1946_STATUS_CODE is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226616313480196951.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(229893262666686330.4001)
,p_button_name=>'CREATE_MODULE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear origen de datos de REST'
,p_button_position=>'NEXT'
,p_button_condition=>'P1946_STATUS_CODE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226585834019031718.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(229893262666686330.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1946_PREVIOUS_PAGE.:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(226619854736196958.4001)
,p_branch_name=>'Go To Page 1901'
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP,1941,1942.1943,1944,1945,1946::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226585921645031719.4001)
,p_name=>'P1946_PREVIOUS_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(229893262666686330.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226586031765031720.4001)
,p_name=>'P1946_SHOW_ALL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(229893262666686330.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226685714561475219.4001)
,p_name=>'P1946_STATUS_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(226685443264475216.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(226685885175475220.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1946_STATUS_CODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
'   and rownum          = 1',
''))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(226619385683196957.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.store_web_src_module(',
'    p_application_id      => :FB_FLOW_ID,',
'    p_module_name         => :P1941_NAME,',
'    p_web_source_type     => :P1941_WEB_SRC_TYPE,',
'    p_remote_server_id    => :P1942_REMOTE_SERVER_ID,',
'    p_server_base_url     => :P1942_SERVER_URL,',
'    p_url_pattern         => :P1942_WEB_SOURCE_PATH,',
'    p_https_host          => :P1941_HTTPS_HOST,',
'    p_credential_store_id => ( case when :P1943_AUTH_REQUIRED = ''Y'' then :P1943_CREDENTIAL_STORE end ),',
'    p_auth_scheme         => ( case when :P1943_AUTH_REQUIRED = ''Y'' then :P1943_AUTH_TYPE        end ),',
'    p_oauth_token_url     => ( case when :P1943_AUTH_REQUIRED = ''Y'' and :P1943_AUTH_TYPE = wwv_flow_credential_api.c_type_oauth_client_cred ',
'                                    then :P1943_TOKEN_URL end ),',
'    p_client_id           => case when :P1943_AUTH_TYPE = ''OCI''                                 then :P1943_OCI_USER_ID ',
'                                  when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_NAME',
'                                  else :P1943_CLIENT_ID end,',
'    p_client_secret       => case when :P1943_AUTH_TYPE = ''OCI'' then :P1943_OCI_PRIVATE_KEY ',
'                                 when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_VALUE',
'                                 else :P1943_CLIENT_SECRET end,',
'    p_username            => :P1943_USERNAME,',
'    p_password            => :P1943_PASSWORD,',
'    p_namespace           => :P1943_OCI_NAMESPACE,',
'    p_fingerprint         => :P1943_OCI_FINGERPRINT,',
'    --',
'    p_attribute_01        => :P1945_ATTRIBUTE_01,',
'    p_attribute_02        => :P1945_ATTRIBUTE_02,',
'    p_attribute_03        => :P1945_ATTRIBUTE_03,',
'    p_attribute_04        => :P1945_ATTRIBUTE_04,',
'    p_attribute_05        => :P1945_ATTRIBUTE_05,',
'    p_attribute_06        => :P1945_ATTRIBUTE_06,',
'    p_attribute_07        => :P1945_ATTRIBUTE_07,',
'    p_attribute_08        => :P1945_ATTRIBUTE_08,',
'    p_attribute_09        => :P1945_ATTRIBUTE_09,',
'    p_attribute_10        => :P1945_ATTRIBUTE_10,',
'    p_attribute_11        => :P1945_ATTRIBUTE_11,',
'    p_attribute_12        => :P1945_ATTRIBUTE_12,',
'    p_attribute_13        => :P1945_ATTRIBUTE_13,',
'    p_attribute_14        => :P1945_ATTRIBUTE_14,',
'    p_attribute_15        => :P1945_ATTRIBUTE_15 );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(226616313480196951.4001)
,p_process_success_message=>'Se ha creado el origen de datos de REST.'
);
end;
/
prompt --application/pages/page_01947
begin
wwv_flow_api.create_page(
 p_id=>1947.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Fallo de HTTP'
,p_page_mode=>'MODAL'
,p_step_title=>'Fallo de HTTP'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226684897981475210.4001)
,p_plug_name=>'No se ha podido llamar a la URL de punto final.'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p style="text-align: center">',
'<span style="color: red;" class="a-Icon a-Icon--regionIcon icon-error a-Icon--xl"></span>',
'</p>',
'<p style="text-align: center">',
'El servidor remoto ha respondido con ',
'<pre>',
'&P1941_MESSAGE.',
'</pre>',
'</p>',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1941_SUCCESS'
,p_plug_display_when_cond2=>'N_H'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226685077546475212.4001)
,p_plug_name=>'No se ha podido llamar a la URL de punto final.'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p style="text-align: center">',
'<span style="color: red;" class="a-Icon a-Icon--regionIcon icon-error a-Icon--xl"></span>',
'</p>',
'<p>',
'Se ha producido un error durante una llamada a la URL.',
'<pre>',
'&P1941_MESSAGE.',
'</pre></p>',
'',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1941_SUCCESS'
,p_plug_display_when_cond2=>'N_D'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4079543730140707029.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(236247548469284210.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4079543730140707029.4001)
,p_button_name=>'CONTINUE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Continuar'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(226684519446475207.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4079543730140707029.4001)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Atr\00E1s')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP:P1941_MUST_AUTHENTICATE,P1941_SUCCESS,P1941_MESSAGE:,,'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(236247659346284211.4001)
,p_branch_action=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(236247548469284210.4001)
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_01948
begin
wwv_flow_api.create_page(
 p_id=>1948.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Nueva detecci\00F3n de origen de datos de REST')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Nueva detecci\00F3n de origen de datos de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755919982109834575.4001)
,p_plug_name=>'Correcto'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1948_STATUS_CODE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(759026892297280529.4001)
,p_plug_name=>'Cuerpo de la Respuesta'
,p_parent_plug_id=>wwv_flow_api.id(755919982109834575.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'select case when sys.dbms_lob.getlength(clob001) > 524288 then to_clob( wwv_flow_lang.system_message(''apex.websrc.response_body_too_large'')) else clob001 end clob001 from wwv_flow_collections where collection_name = ''WEB_SOURCE_INFO'' and c001=''DATA'' '
||'and rownum = 1'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'SQL'
,p_attribute_02=>'10'
,p_attribute_03=>'Y'
,p_attribute_04=>'VARCHAR2'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(759084863898831798.4001)
,p_name=>'Columnas'
,p_parent_plug_id=>wwv_flow_api.id(755919982109834575.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with new_columns as (',
'    select seq_id,',
'           c002 as name,',
'           c003 as is_primary_key,',
'           c004 as data_type,',
'           c005 as max_length,',
'           c006 as format_mask,',
'           c007 as has_time_zone,',
'           c008 as selector',
'      from wwv_flow_collections ',
'     where collection_name = ''WEB_SOURCE_INFO''',
'       and c001            = ''DATA_PROFILE_COLUMNS''',
'), old_columns as (',
'    select dpc.name,',
'           dpc.data_type',
'      from wwv_flow_data_profile_cols dpc,',
'           wwv_flow_web_src_modules wm',
'     where wm.data_profile_id      = dpc.data_profile_id',
'       and wm.id                   = :P1948_WEB_SRC_MODULE_ID',
'       and wm.security_group_id    = :FLOW_SECURITY_GROUP_ID',
'       and wm.flow_id              = :FB_FLOW_ID',
')',
'select case when o.name is null then 1 else 2 end as orderby,',
'       case when o.name is null then ''font-weight: bold;''',
'            when o.name = n.name then ''color: gray;'' end as new_style,',
'       case when o.name = n.name then ''color: gray;'' end as existing_style,',
'       o.name as existing_column_name,',
'       n.name as new_column_name,',
'       n.data_type,',
'       n.format_mask,',
'       n.selector',
'  from new_columns n, old_columns o',
' where o.name      ( + ) = n.name',
'   and o.data_type ( + ) = n.data_type',
'  order by orderby, n.seq_id asc nulls first'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529219275489107512.4001)
,p_query_column_id=>1
,p_column_alias=>'ORDERBY'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529219372849107513.4001)
,p_query_column_id=>2
,p_column_alias=>'NEW_STYLE'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529219464209107514.4001)
,p_query_column_id=>3
,p_column_alias=>'EXISTING_STYLE'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529218944608107509.4001)
,p_query_column_id=>4
,p_column_alias=>'EXISTING_COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Columna existente'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span style="#EXISTING_STYLE#">#EXISTING_COLUMN_NAME#</span>'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529219039537107510.4001)
,p_query_column_id=>5
,p_column_alias=>'NEW_COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nueva Columna'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span style="#NEW_STYLE#">#NEW_COLUMN_NAME#</span>'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529237118965359406.4001)
,p_query_column_id=>6
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo de dato'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529237918661359406.4001)
,p_query_column_id=>7
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529238766397359407.4001)
,p_query_column_id=>8
,p_column_alias=>'SELECTOR'
,p_column_display_sequence=>5
,p_column_heading=>'Selector'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(759086554602831815.4001)
,p_plug_name=>'RDS'
,p_parent_plug_id=>wwv_flow_api.id(755919982109834575.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(759086642437831816.4001)
,p_name=>'Datos'
,p_parent_plug_id=>wwv_flow_api.id(755919982109834575.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,',
'       c002,',
'       c003,',
'       c004,',
'       c005,',
'       c006,',
'       c007,',
'       c008,',
'       c009,',
'       c010,',
'       c011,',
'       c012,',
'       c013,',
'       c014,',
'       c015',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_DATA'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headings varchar2(32767);',
'begin',
'    for c in ( select * from (',
'                   select c002 ',
'                     from wwv_flow_collections',
'                    where collection_name = ''WEB_SOURCE_INFO''',
'                      and c001            = ''DATA_PROFILE_COLUMNS''',
'                    order by seq_id asc ) ',
'               where rownum <= 15 ) loop',
'       l_headings := l_headings || initcap(c.c002) || '':'';',
'    end loop;',
'    return substr( l_headings, 1, length( l_headings ) - 1 );',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No se han encontrado datos al analizar la respuesta de servicio.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529239764726359409.4001)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'C001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529240158672359410.4001)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529240576953359410.4001)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529240994309359410.4001)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'C004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529241336682359410.4001)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'C005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529241711855359411.4001)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_column_heading=>'C006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529242102972359411.4001)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_column_heading=>'C007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529242537732359411.4001)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_column_heading=>'C008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529242996605359411.4001)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'C009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529243316621359412.4001)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'C010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529243723016359412.4001)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'C011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529244102290359412.4001)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529244588361359412.4001)
,p_query_column_id=>13
,p_column_alias=>'C013'
,p_column_display_sequence=>13
,p_column_heading=>'C013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529244985549359413.4001)
,p_query_column_id=>14
,p_column_alias=>'C014'
,p_column_display_sequence=>14
,p_column_heading=>'C014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529245312343359413.4001)
,p_query_column_id=>15
,p_column_alias=>'C015'
,p_column_display_sequence=>15
,p_column_heading=>'C015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755920078598834576.4001)
,p_plug_name=>'Fallo'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1948_STATUS_CODE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(755920154500834577.4001)
,p_name=>'Respuesta del Servidor'
,p_parent_plug_id=>wwv_flow_api.id(755920078598834576.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dbms_lob.substr( clob001, 4000, 1 ) as response',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(529248953139359419.4001)
,p_query_column_id=>1
,p_column_alias=>'RESPONSE'
,p_column_display_sequence=>1
,p_column_heading=>'Respuesta'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(755920621392834582.4001)
,p_plug_name=>'Estado de HTTP'
,p_parent_plug_id=>wwv_flow_api.id(755920078598834576.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p style="text-align: center">',
'<span style="color: red;" class="a-Icon a-Icon--regionIcon icon-error a-Icon--xl"></span>',
'</p>',
'<p style="text-align: center">',
'El servidor ha respondido con &P1948_STATUS_CODE.',
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(759127973903045691.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529250397334359435.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(759127973903045691.4001)
,p_button_name=>'REPLACE_PROFILE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Sustituir perfil de datos'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_page_plugs',
' where web_src_module_id = :P1948_WEB_SRC_MODULE_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'union all (',
'select 1 ',
'  from wwv_flow_step_processing',
' where web_src_module_id = :P1948_WEB_SRC_MODULE_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
') union all (',
'select 1 from sys.dual where :P1948_STATUS_CODE is not null ',
')'))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529219709093107517.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(759127973903045691.4001)
,p_button_name=>'EXTEND_PROFILE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ampliar perfil de datos'
,p_button_position=>'NEXT'
,p_button_condition=>'P1948_STATUS_CODE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(529250799067359438.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(759127973903045691.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(529253998227359454.4001)
,p_branch_name=>'Go To Page 1921'
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:RP,1948::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529218844894107508.4001)
,p_name=>'P1948_WEB_SRC_MODULE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(759127973903045691.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529249329332359421.4001)
,p_name=>'P1948_STATUS_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(755920154500834577.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(529252317749359441.4001)
,p_name=>'P1948_PREVIOUS_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(759127973903045691.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(529253173284359452.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1948_STATUS_CODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
'   and rownum          = 1',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(529218622052107506.4001)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(529250799067359438.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(529218746566107507.4001)
,p_event_id=>wwv_flow_api.id(529218622052107506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(529219638360107516.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Replace Data Profile Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_profile_id number;',
'begin',
'    select data_profile_id ',
'      into l_data_profile_id',
'      from wwv_flow_web_src_modules',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and id                = :P1948_WEB_SRC_MODULE_ID;',
'',
'    wwv_flow_web_src_dev.store_data_profile_columns(',
'        p_application_id => :FB_FLOW_ID,',
'        p_data_profile_id => l_data_profile_id,',
'        p_replace         => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(529250397334359435.4001)
,p_process_success_message=>'Se han sustituido las columnas de perfil de datos.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(529219906382107519.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Extend Data Profile Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_profile_id number;',
'begin',
'    select data_profile_id ',
'      into l_data_profile_id',
'      from wwv_flow_web_src_modules',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and id                = :P1948_WEB_SRC_MODULE_ID;',
'',
'    wwv_flow_web_src_dev.store_data_profile_columns(',
'        p_application_id => :FB_FLOW_ID,',
'        p_data_profile_id => l_data_profile_id,',
'        p_replace         => false );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(529219709093107517.4001)
,p_process_success_message=>'Las columnas nuevas se han fusionado en el perfil de datos.'
);
end;
/
prompt --application/pages/page_01951
begin
wwv_flow_api.create_page(
 p_id=>1951.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Sincronizaci\00F3n de REST')
,p_alias=>'REST-DATA-SOURCE-SYNCHRONIZATION'
,p_step_title=>unistr('Sincronizaci\00F3n de REST')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function buildInterval() {',
'    var lIntervalString = ''FREQ='' + $v("P1951_INT_FREQUENCY") +',
'                          '';INTERVAL='' + $v("P1951_INT_INTERVAL");',
'    ',
'    if ( $v("P1951_BYDAY") !== "" && $v("P1951_INT_FREQUENCY") !== "DAILY" && $v("P1951_BYDAY") !== "MON:TUE:WED:THU:FRI:SAT:SUN" ) {',
'       lIntervalString =  lIntervalString + ";BYDAY=" + $v("P1951_BYDAY").replace(/:/g,",");',
'    }',
'    if ( $v("P1951_BYHOUR") !== "" && $v("P1951_INT_FREQUENCY") !== "HOURLY") {',
'       lIntervalString =  lIntervalString + ";BYHOUR=" + $v("P1951_BYHOUR");',
'    }',
'    if ( $v("P1951_BYMINUTE") !== "" && $v("P1951_INT_FREQUENCY") !== "MINUTELY" ) {',
'       lIntervalString =  lIntervalString + ";BYMINUTE=" + $v("P1951_BYMINUTE");',
'    }',
'    ',
'    lIntervalString =  lIntervalString + ";BYSECOND=0";',
'    ',
'    return lIntervalString;',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#sync-steps {min-height: 100px;}',
'',
'tr#MESSAGES {width: 200px;}',
'td[headers=MESSAGES] {width: 200px;}',
'',
'.log-messages {',
'    margin: 0px;',
unistr('    max-width: 400px;\00A0}'),
'       '))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1664665857963730.4001)
,p_plug_name=>unistr('El tipo de sincronizaci\00F3n "fusionar" requiere una clave primaria')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>70
,p_plug_source=>unistr('Esta sincronizaci\00F3n utiliza el tipo de sincronizaci\00F3n "Fusi\00F3n", pero no se ha definido una columna de clave primaria para el perfil de datos. Los trabajos de sincronizaci\00F3n se ejecutar\00E1n con errores.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if nvl( :P1951_SYNC_TYPE, ''APPEND'' ) != ''MERGE'' or :P1951_OLD_SYNC_TABLE_NAME is null then',
'        return false;',
'    else',
'        return not wwv_flow_web_src_sync_dev.data_profile_has_primary_key(',
'                       p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3404639650376625.4001)
,p_plug_name=>'Creador de intervalos'
,p_region_name=>'interval-builder'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>40
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Este cuadro de di\00E1logo ayuda a crear una <em>expresi\00F3n de calendario de programador</em> para especificar la frecuencia con la que se ejecutan los trabajos de sincronizaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3405610816376635.4001)
,p_plug_name=>'Detalles'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<a name="sync-details"></a>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3407119919376650.4001)
,p_plug_name=>unistr('Configuraci\00F3n avanzada')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3802161062901510.4001)
,p_plug_name=>unistr('Sincronizaci\00F3n de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('La <strong>sincronizaci\00F3n de REST</strong> permite mantener el contenido de una tabla local sincronizado autom\00E1ticamente con los datos de un servicio REST. La sincronizaci\00F3n se puede disparar manualmente o de forma regular mediante un trabajo de prog')
||'ramador.',
'</p>',
'<p>',
unistr('APEX puede crear la tabla local, seg\00FAn las columnas visibles en el <strong>perfil de datos</strong> del origen de datos de REST. No obstante, la tabla es un <em>objeto visible</em> del esquema de base de datos; es decir, los desarrolladores <em>puede')
||unistr('n</em> agregar \00EDndices, cambiar propiedades f\00EDsicas o, incluso, agregar m\00E1s columnas a la tabla. '),
'</p>',
'<p>',
unistr('Si la tabla <em>no</em> se sincroniza con el perfil de datos, la sincronizaci\00F3n de REST seguir\00E1 trabajando en columnas presentes en la tabla <em>y</em> en el perfil de datos (se ignorar\00E1 el resto de las columnas). No obstante, APEX genera sentencias ')
||unistr('SQL DDL para sincronizar de nuevo las columnas de tabla con el perfil de datos. Estas se pueden agregar a la aplicaci\00F3n como objetos de soporte.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3802859702901517.4001)
,p_plug_name=>unistr('No se ha configurado la sincronizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('A\00FAn no se ha configurado la sincronizaci\00F3n de REST. Proporcione el nombre de una tabla nueva o existente para empezar.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1951_OLD_SYNC_TABLE_NAME'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3803587485901524.4001)
,p_plug_name=>'Guardar como script (objetos de soporte)'
,p_region_name=>'save-script'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4302146574059808.4001)
,p_plug_name=>'Estado de tabla'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1951_SYNC_TABLE_NAME'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1663866411963722.4001)
,p_plug_name=>unistr('Otra sincronizaci\00F3n de REST est\00E1 utilizando la tabla')
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>5
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esto puede provocar conflictos de sincronizaci\00F3n. Compruebe los siguientes or\00EDgenes de datos de REST:<br>'),
'<strong>&P1951_OTHER_SYNC_INFO!HTML.</strong>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist and :P1951_OTHER_SYNC_INFO is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3703185813255331.4001)
,p_plug_name=>unistr('La tabla de sincronizaci\00F3n no existe')
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>25
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('La tabla de sincronizaci\00F3n no existe todav\00EDa.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_table_does_not_exist'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3704694634255346.4001)
,p_plug_name=>unistr('SQL de sincronizaci\00F3n de tabla')
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>65
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_STATUS in ( wwv_flow_web_src_sync.c_table_does_not_exist,',
'                        wwv_flow_web_src_sync.c_columns_can_be_synced,',
'                        wwv_flow_web_src_sync.c_columns_cannot_be_synced)'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3705021633255350.4001)
,p_plug_name=>unistr('La tabla "&P1951_SYNC_TABLE_NAME!HTML." ya est\00E1 lista para la sincronizaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>35
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('La tabla de sincronizaci\00F3n existe y coincide con el perfil de datos.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_is_up_to_date then',
'        return false;',
'    end if;',
'',
'    if nvl( :P1951_SYNC_TYPE, ''APPEND'' ) != ''MERGE''  then',
'        return true;',
'    else',
'        return wwv_flow_web_src_sync_dev.data_profile_has_primary_key(',
'                   p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4301625144059803.4001)
,p_plug_name=>'La tabla "&P1951_SYNC_TABLE_NAME!HTML." es diferente al perfil de datos'
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_icon_css_classes=>'icon-warning'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>55
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('Las columnas de tabla son diferentes al perfil de datos, pero APEX seguir\00E1 sincronizando las columnas presentes en la tabla <em>y</em> en el perfil de datos. Haga clic en <strong>Mostrar SQL</strong> para ver las sentencias ALTER TABLE y ajustar las ')
||'columnas de tabla al perfil de datos.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_columns_can_be_synced'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4302455398059811.4001)
,p_plug_name=>'La tabla necesita cambios de columna manuales'
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>45
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('<p>La tabla de sincronizaci\00F3n existe, pero sus columnas no coinciden con el perfil de datos. Es necesario realizar cambios en las columnas (por ejemplo, un cambio de tipo de dato de VARCHAR2 a NUMBER) de forma manual, y probablemente haya que mover l')
||unistr('os datos. No obstante, APEX seguir\00E1 sincronizando columnas presentes en la tabla <em>y</em> en el perfil de datos.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_columns_cannot_be_synced'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1855034208767335709.4001)
,p_plug_name=>unistr('La operaci\00F3n de recuperaci\00F3n de filas no existe')
,p_parent_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('La sincronizaci\00F3n del origen de datos de REST est\00E1 activa, pero no hay ninguna operaci\00F3n asignada a la operaci\00F3n de base de datos <strong>Recuperar filas</strong>. Por tanto, la sincronizaci\00F3n no funcionar\00E1.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_no_fetch_rows_operation'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4302248671059809.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1951_OLD_SYNC_TABLE_NAME'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(4302959812059816.4001)
,p_name=>'Pasos'
,p_region_name=>'sync-steps'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select pa.id, ',
'       pa.static_id, ',
'       pa.execution_sequence, ',
'       pa.is_active',
'  from wwv_flow_web_src_sync_steps pa, wwv_flow_web_src_comp_params cp',
' where pa.id                = cp.module_sync_step_id (+)',
'   and pa.web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'   and pa.security_group_id = :FLOW_SECURITY_GROUP_ID',
' group by pa.id, pa.static_id, pa.execution_sequence, pa.is_active'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn paso. La sincronizaci\00F3n utilizar\00E1 los par\00E1metros de origen de REST por defecto.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4303016090059817.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1952:&SESSION.::&DEBUG.::P1952_SYNC_STEP_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span>'
,p_column_link_attr=>'title="Edit Synchronization Step"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4303197430059818.4001)
,p_query_column_id=>2
,p_column_alias=>'STATIC_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Identificador Est\00E1tico')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4303255193059819.4001)
,p_query_column_id=>3
,p_column_alias=>'EXECUTION_SEQUENCE'
,p_column_display_sequence=>2
,p_default_sort_column_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(4304329085059830.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_ACTIVE'
,p_column_display_sequence=>4
,p_column_heading=>'Activo'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5517859571157119.4001)
,p_name=>'Log'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.synchronization_id,',
'       l.web_src_sync_static_id,',
'       l.is_job,',
'       wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || l.status ) as status,',
'       l.sync_to_table_owner ||',
'           case when l.sync_to_table_owner is not null then ''.'' end ||',
'           l.sync_to_table_name as sync_to_table,',
'       l.start_timestamp,',
'       l.end_timestamp,',
'       ( select count(*) ',
'           from wwv_flow_webservice_log w ',
'          where w.security_group_id = l.security_group_id ',
'            and w.web_src_module_id = l.web_src_module_id',
'            and w.web_src_sync_id   = l.synchronization_id ) http_requests,',
'       ( select sum(w.resp_content_length) ',
'           from wwv_flow_webservice_log w ',
'          where w.security_group_id = l.security_group_id ',
'            and w.web_src_module_id = l.web_src_module_id',
'            and w.web_src_sync_id = l.synchronization_id ) sum_bytes_received,',
'       to_char( extract (HOUR   from l.end_timestamp - l.start_timestamp) * 60 +',
'                extract (MINUTE from l.end_timestamp - l.start_timestamp) ) || '''''''' ||',
'       to_char( extract( second from l.end_timestamp - l.start_timestamp),''FM00'' ) || ''"'' as dur,',
'       l.processed_row_count,',
'       l.messages',
'  from wwv_flow_websource_sync_log l',
' where l.web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'   and l.flow_id           = :FB_FLOW_ID',
'   and l.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('El log de sincronizaci\00F3n de este origen de datos de REST est\00E1 vac\00EDo.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Descargar log'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5518390346157124.4001)
,p_query_column_id=>1
,p_column_alias=>'SYNCHRONIZATION_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Detalles'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1953:&SESSION.::&DEBUG.:RP,:P1953_WSM_SYNC_ID:#SYNCHRONIZATION_ID#'
,p_column_linktext=>'<span class="a-Icon icon-search"></span>'
,p_column_link_attr=>'title="View HTTP Request Log"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5518408227157125.4001)
,p_query_column_id=>2
,p_column_alias=>'WEB_SRC_SYNC_STATIC_ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID de&nbsp;paso'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5518566292157126.4001)
,p_query_column_id=>3
,p_column_alias=>'IS_JOB'
,p_column_display_sequence=>4
,p_column_heading=>'Trabajo'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5518681569157127.4001)
,p_query_column_id=>4
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3404521938376624.4001)
,p_query_column_id=>5
,p_column_alias=>'SYNC_TO_TABLE'
,p_column_display_sequence=>3
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5518781761157128.4001)
,p_query_column_id=>6
,p_column_alias=>'START_TIMESTAMP'
,p_column_display_sequence=>6
,p_column_heading=>'Iniciado '
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5518831286157129.4001)
,p_query_column_id=>7
,p_column_alias=>'END_TIMESTAMP'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2905946004179142.4001)
,p_query_column_id=>8
,p_column_alias=>'HTTP_REQUESTS'
,p_column_display_sequence=>10
,p_column_heading=>'Solicitudes'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2906054964179143.4001)
,p_query_column_id=>9
,p_column_alias=>'SUM_BYTES_RECEIVED'
,p_column_display_sequence=>11
,p_column_heading=>unistr('Tama\00F1o')
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519275936157133.4001)
,p_query_column_id=>10
,p_column_alias=>'DUR'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Duraci\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519038476157131.4001)
,p_query_column_id=>11
,p_column_alias=>'PROCESSED_ROW_COUNT'
,p_column_display_sequence=>9
,p_column_heading=>'Filas'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519193450157132.4001)
,p_query_column_id=>12
,p_column_alias=>'MESSAGES'
,p_column_display_sequence=>12
,p_column_heading=>'Mensajes'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div class="log-messages">#MESSAGES#</div>'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6292213365932471.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1951_OLD_SYNC_TABLE_NAME'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6669574068375171.4001)
,p_plug_name=>unistr('Sincronizaci\00F3n de REST')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1912360610983083464.4001)
,p_plug_name=>unistr('M\00E1s Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL./htmdb/managing-data-synchronization.html" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4303314867059820.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4302959812059816.4001)
,p_button_name=>'ADD_SYNC_STEP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar paso'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1373830947674228.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5517859571157119.4001)
,p_button_name=>'PURGE_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Depurar log'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2905399506179136.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4302146574059808.4001)
,p_button_name=>'VIEW_SYNC_TABLE'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ver en taller de SQL'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4500:1001:&SESSION.:FOCUS:&DEBUG.:RR,1001:OB_SCHEMA,OB_CURRENT_TYPE,OB_OBJECT_ID:&P1951_SYNC_SCHEMA_NAME.,TABLE,&P1951_SYNC_TABLE_OBJECT_ID.'
,p_button_condition=>':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist and :P1951_OLD_SYNC_TABLE_NAME is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3200568818532836.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6669574068375171.4001)
,p_button_name=>'CLEAR_SYNC'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Borrar configuraci\00F3n')
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1951_OLD_SYNC_TABLE_NAME is null then',
'        return false;',
'    end if;',
'',
'    for c in (',
'        select 1',
'          from wwv_flow_web_src_module_usage',
'         where web_src_module_id    = :P1951_WEB_SRC_MODULE_ID',
'           and security_group_id    = :FLOW_SECURITY_GROUP_ID',
'           and use_local_sync_table = ''Y''',
'           and rownum = 1 )',
'    loop',
'        return false;',
'    end loop;',
'    ',
'    return true;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3402234723376601.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3703185813255331.4001)
,p_button_name=>'SHOW_CREATE_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Mostrar SQL'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3406775981376646.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3404639650376625.4001)
,p_button_name=>'BUILD_INTERVAL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Definir intervalo de ejecuci\00F3n')
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3803834939901527.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3803587485901524.4001)
,p_button_name=>'SAVE_SCRIPT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar Script'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3402593703376604.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3703185813255331.4001)
,p_button_name=>'HIDE_CREATE_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ocultar SQL'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3403550413376614.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4301625144059803.4001)
,p_button_name=>'SHOW_ALTER_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Mostrar SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5903029649682530.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6669574068375171.4001)
,p_button_name=>'REDIRECT_TO_CLEAR_SYNC'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Borrar configuraci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1954:&SESSION.::&DEBUG.::P1954_DIALOG_TYPE:CLEAR_SYNC'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1951_SYNC_TABLE_NAME is null then',
'        return false;',
'    end if;',
'',
'    for i in ( ',
'        select 1 ',
'          from wwv_flow_web_src_module_usage',
'         where web_src_module_id    = :P1951_WEB_SRC_MODULE_ID',
'           and security_group_id    = :FLOW_SECURITY_GROUP_ID',
'           and use_local_sync_table = ''Y''',
'           and rownum               = 1 )',
'    loop',
'        return true;',
'    end loop;',
'    ',
'    return false;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2906244256179145.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4302455398059811.4001)
,p_button_name=>'SHOW_ALTER_TABLE_SQL2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Mostrar SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3803085160901519.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3703185813255331.4001)
,p_button_name=>'ADD_CREATE_SUPP_OBJECTS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Guardar como objeto de soporte'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5903977576682539.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_button_name=>'SHOW_USAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Uso de sincronizaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1954:&SESSION.::&DEBUG.::P1954_DIALOG_TYPE:SHOW_USAGE'
,p_button_condition=>'P1951_SYNC_TABLE_NAME'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3200969683532841.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(6669574068375171.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3403686885376615.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(4301625144059803.4001)
,p_button_name=>'HIDE_ALTER_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ocultar SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3704375012255343.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(3703185813255331.4001)
,p_button_name=>'CREATE_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Tabla'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4302666690059813.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(6669574068375171.4001)
,p_button_name=>'MANUAL_DATA_SYNC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Guardar y ejecutar'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS not in ( wwv_flow_web_src_sync.c_table_does_not_exist, wwv_flow_web_src_sync.c_no_fetch_rows_operation ) and',
':P1951_JOB_STATE is null'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5900100267682501.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(4302455398059811.4001)
,p_button_name=>'HIDE_ALTER_TABLE_SQL2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ocultar SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1375364889674243.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(6669574068375171.4001)
,p_button_name=>'ABORT_JOB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Abortar sincronizaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_JOB_STATE is not null'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3804144280901530.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(4301625144059803.4001)
,p_button_name=>'ADD_ALTER_SUPP_OBJECTS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Guardar como objeto de soporte'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4301904995059806.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(4301625144059803.4001)
,p_button_name=>'ALTER_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Modificar tabla'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4303529234059822.4001)
,p_branch_name=>'Go To Page 1952'
,p_branch_action=>'f?p=&APP_ID.:1952:&SESSION.::&DEBUG.::P1952_SYNC_STEP_ID:&P1951_NEW_SYNC_STEP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4303314867059820.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3804243639901531.4001)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:RP,865:P865_SCRIPT_ID,P865_MODE,F4000_LAST_VIEW:&P1951_SCRIPT_ID.,EDIT,1951&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3803834939901527.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1664257292963726.4001)
,p_branch_action=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:RP,1951:P1951_WEB_SRC_MODULE_ID:&P1951_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3200568818532836.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1375189579674241.4001)
,p_name=>'P1951_JOB_STATE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P1951_JOB_STATE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1375534285674245.4001)
,p_name=>'P1951_JOB_SHOW_STATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_prompt=>'Estado del Trabajo'
,p_pre_element_text=>'<span class="a-Icon icon-redo u-Animate-spin" style="vertical-align: middle;margin-right: 3px;"></span>'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1951_JOB_STATE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Estado del trabajo de sincronizaci\00F3n, si est\00E1 activo:</p>'),
'<ul>',
unistr('    <li><strong>Programado</strong>: el trabajo est\00E1 en cola en el programador de la base de datos, pero a\00FAn no se ha iniciado su ejecuci\00F3n.</li>'),
unistr('    <li><strong>En ejecuci\00F3n</strong>: el trabajo se est\00E1 ejecutando.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1400708118398906.4001)
,p_name=>'P1951_USE_RATE_LIMITING'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_prompt=>unistr('Activar limitaci\00F3n de ratio simple')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Cuando se activa la <strong>limitaci\00F3n de ratio sencilla</strong>, APEX asegura que solo una cantidad limitada de solicitudes HTTP se ejecute en el marco temporal dado. Esta limitaci\00F3n de ratio se basa por completo en el n\00FAmero de solicitudes HTT')
||'P que se ejecutan en un marco temporal: <em>no</em> consulta las cabeceras de respuestas HTTP que ha devuelto el servicio REST.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1401581750400511.4001)
,p_name=>'P1951_MAX_REQUESTS_TIMEFRAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Marco temporal de l\00EDmite de ratio (en segundos)')
,p_source=>'MAX_REQUESTS_TIMEFRAME_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Limitaci\00F3n de ratio sencilla: proporciona el marco temporal, para el que se cuentan las solicitudes HTTP, en segundos. APEX permite especificar un marco temporal de entre 5 y 300 segundos (5 minutos).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'300'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1402379984403051.4001)
,p_name=>'P1951_MAX_REQUESTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Solicitudes HTTP de l\00EDmite de ratio')
,p_source=>'MAX_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Limitaci\00F3n de ratio sencilla. Proporciona el l\00EDmite de solicitudes HTTP para esta sincronizaci\00F3n en el marco temporal especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1403198659405104.4001)
,p_name=>'P1951_MAX_REQUESTS_EXC_ACTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ERROR'
,p_prompt=>unistr('Cuando se excede el l\00EDmite de ratio')
,p_source=>'MAX_REQUESTS_EXCEED_ACTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_MAX_REQUESTS_EXC_ACTION'
,p_lov=>'.'||wwv_flow_api.id(601125790424873502.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div>',
unistr('    Limitaci\00F3n de ratio sencilla: especifique c\00F3mo debe actuar APEX si se alcanzara el m\00E1ximo de solicitudes HTTP en el marco temporal.'),
'</div>',
'<ul>',
unistr('    <li><strong>Espera</strong>: APEX pondr\00E1 <em>en espera</em> la siguiente solicitud hasta que se ajuste de nuevo al l\00EDmite. Tenga en cuenta que el tiempo de espera est\00E1 limitado al tiempo de <strong>timeout de transferencia de HTTP</strong>, o a <')
||unistr('strong>180 segundos</strong>, si no se ha configurado ning\00FAn timeout.</li>'),
unistr('    <li><strong>Emisi\00F3n de error</strong>: APEX <em>abortar\00E1</em> la operaci\00F3n y emitir\00E1 un mensaje de error.</li>'),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1662827990963712.4001)
,p_name=>'P1951_SYNC_MAX_HTTP_REQUESTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1000'
,p_prompt=>unistr('L\00EDmite de solicitud HTTP')
,p_source=>'SYNC_MAX_HTTP_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Si fuera necesario, proporcione un n\00FAmero m\00E1ximo de solicitudes HTTP para cada paso de sincronizaci\00F3n. Si se excediera este l\00EDmite, se detendr\00E1 la sincronizaci\00F3n y se registrar\00E1 como <strong>Incompleta</strong>.'),
'</p>',
'<p>',
unistr('    <em>Tenga en cuenta que, debido al m\00E9todo actual de ejecuci\00F3n, la sincronizaci\00F3n exceder\00E1 el l\00EDmite solo con una solicitud de m\00E1s. Es decir, si se proporciona un l\00EDmite de <strong>10</strong>, la sincronizaci\00F3n se detendr\00E1 despu\00E9s de que se reali')
||'cen 11 solicitudes.</em>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1663994792963723.4001)
,p_name=>'P1951_OTHER_SYNC_INFO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1663866411963722.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1935777712374328.4001)
,p_name=>'P1951_MIN_CADENCE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2901912843179102.4001)
,p_name=>'P1951_OLD_SYNC_INTERVAL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2903192530179114.4001)
,p_name=>'P1951_REPLACE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_item_default=>'DELETE'
,p_prompt=>'Reemplazar tipo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_REPLACE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601128335146874196.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Un tipo de sincronizaci\00F3n de <strong>sustituci\00F3n</strong> vaciar\00E1 la tabla antes de cargar datos nuevos. </p>'),
'<p>',
unistr('    Puede realizarse utilizando una sentencia SQL DELETE (transactionaql), que asegurar\00E1 que no se pierda nada si se produce un error durante la sincronizaci\00F3n.</p>'),
'<p>',
unistr('    Otra opci\00F3n es utilizar una sentencia SQL <em>TRUNCATE</em>, que permite hacer un uso m\00E1s eficiente del almacenamiento. Sin embargo, TRUNCATE no es transaccional, por lo que si se produce un error durante la sincronizaci\00F3n, la tabla permanecer\00E1 v')
||unistr('ac\00EDa.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2903749054179120.4001)
,p_name=>'P1951_TABLE_SYNC_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2905462365179137.4001)
,p_name=>'P1951_SYNC_SCHEMA_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2905660441179139.4001)
,p_name=>'P1951_SYNC_TABLE_OBJECT_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3000455156443099.4001)
,p_name=>'P1951_BREADCRUMB_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_source=>'P1951_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3000786442443105.4001)
,p_name=>'P1951_WEB_SRC_MODULE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3001187163443106.4001)
,p_name=>'P1951_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3001980570443106.4001)
,p_name=>'P1951_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre del origen de datos de REST.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3003754936443112.4001)
,p_name=>'P1951_REMOTE_SERVER_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3005003532443114.4001)
,p_name=>'P1951_URL_PATH_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'URL_PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3404764744376626.4001)
,p_name=>'P1951_INT_FREQUENCY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3404639650376625.4001)
,p_item_default=>'DAILY'
,p_prompt=>'Frecuencia'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SCHEDULE_BUILDER_FREQUENCY'
,p_lov=>'.'||wwv_flow_api.id(601098854036755106.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de repetici\00F3n. Los valores de frecuencia predefinidos posibles son <strong>Semanal</strong>, <strong>Diario</strong>, <strong>Por hora</strong> y <strong>Por minuto</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3405282562376631.4001)
,p_name=>'P1951_INT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3404639650376625.4001)
,p_item_default=>'1'
,p_prompt=>'Intervalo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un valor entero positivo que represente la frecuencia de repetici\00F3n. El valor por defecto es 1, lo que significa que la frecuencia es de cada minuto en por minuto, cada d\00EDa en diario, etc. El valor m\00E1ximo es 999.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3405326581376632.4001)
,p_name=>'P1951_BYDAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3404639650376625.4001)
,p_item_default=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_prompt=>unistr('D\00EDa de ejecuci\00F3n')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SCHEDULE_BUILDER_BYDAY'
,p_lov=>'.'||wwv_flow_api.id(601095219556747684.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el d\00EDa de la semana, de lunes a domingo, con el formato LUN, MAR, etc.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3405456270376633.4001)
,p_name=>'P1951_BYHOUR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3404639650376625.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Hora de ejecuci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la hora a la que el trabajo se va a ejecutar. Los valores v\00E1lidos son de 0 a 23. Por ejemplo, 10 quiere decir a las 10 a.m.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3405583578376634.4001)
,p_name=>'P1951_BYMINUTE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3404639650376625.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Minuto de ejecuci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el minuto en el que el trabajo se va a ejecutar. Los valores v\00E1lidos son de 0 a 59. Por ejemplo, 45 quiere decir 45 minutos despu\00E9s de la hora seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3702757410255327.4001)
,p_name=>'P1951_SYNC_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3703270495255332.4001)
,p_name=>'P1951_SYNC_STATUS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3703404227255334.4001)
,p_name=>'P1951_SYNC_TABLE_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario de tabla local'
,p_source=>'SYNC_TABLE_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Esquema de an\00E1lisis -')
,p_cHeight=>1
,p_display_when=>':P1951_OLD_SYNC_TABLE_NAME is null or :P1951_SYNC_TABLE_OWNER is not null '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el esquema de la tabla local con la que se van a sincronizar los datos. Por defecto, se utiliza la aplicaci\00F3n <em>Esquema de an\00E1lisis</em>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3704822824255348.4001)
,p_name=>'P1951_SQL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3704694634255346.4001)
,p_prompt=>'Crear/cambiar SQL de tabla'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>120
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Este es el SQL para crear la tabla local o para hacer que sea consistente con el perfil de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3801266410901501.4001)
,p_name=>'P1951_SYNC_COMMIT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Intervalo de confirmaci\00F3n')
,p_source=>'SYNC_COMMIT_INTERVAL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el intervalo de confirmaci\00F3n que se va a utilizar durante la sincronizaci\00F3n de REST. Si no se especifica ning\00FAn intervalo de confirmaci\00F3n, toda la sincronizaci\00F3n ser\00E1 una transacci\00F3n, con una confirmaci\00F3n despu\00E9s de la \00FAltima fila. Si se ')
||unistr('especifica un intervalo, APEX confirmar\00E1 cada vez que se realice la sincronizaci\00F3n despu\00E9s de que la cantidad de filas especificada se haya procesado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3802528713901514.4001)
,p_name=>'P1951_OLD_SYNC_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3803619759901525.4001)
,p_name=>'P1951_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3803587485901524.4001)
,p_prompt=>'Nombre del Script'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Proporcione un nombre al script de SQL que se va a guardar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3803777441901526.4001)
,p_name=>'P1951_SCRIPT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3803587485901524.4001)
,p_item_default=>'1'
,p_prompt=>'Tipo de Script'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_SCRIPT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601129636599874441.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si desea almacenar las sentencias de SQL como scripts de instalaci\00F3n o de actualizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
,p_item_comment=>'Static LOV return values must match t_supp_script constants in wwv_flow_web_src_sync_dev package spec.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3804315936901532.4001)
,p_name=>'P1951_SCRIPT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3803587485901524.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3804896981901537.4001)
,p_name=>'P1951_JOB_IS_ACTIVE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Trabajo activo'
,p_source=>'SYNC_IS_ACTIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules thiswm, wwv_flow_web_src_modules masterwm',
' where thiswm.id                = :P1951_WEB_SRC_MODULE_ID',
'   and masterwm.id              = thiswm.reference_id',
'   and masterwm.sync_is_active  = ''Y''',
'   and thiswm.sync_is_active    = ''N''',
'   and thiswm.security_group_id = :FLOW_SECURITY_GROUP_ID',
' '))
,p_read_only_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Una sincronizaci\00F3n inactiva solo puede ejecutarse de forma manual. '),
'</p>',
'<p>',
unistr('    Tenga en cuenta que el trabajo de sincronizaci\00F3n no se puede activar para los or\00EDgenes de datos de REST suscritos, cuando se haya activado el trabajo para el origen de datos de REST maestro. Si el trabajo de sincronizaci\00F3n se activa para un orige')
||unistr('n de datos de REST maestro, se <em>desactivar\00E1</em> para el resto de or\00EDgenes de datos de REST suscritos.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4302356408059810.4001)
,p_name=>'P1951_INCLUDE_DROP_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3704694634255346.4001)
,p_item_default=>'N'
,p_prompt=>'Incluir columnas de borrado'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_columns_can_be_synced'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si desea incluir las sentencias <strong>DROP COLUMN</strong> en el SQL de ALTER TABLE. A pesar de que se ha eliminado una columna del perfil de datos, ser\00EDa recomendable mantener la columna en la tabla local. En este caso, <strong>desacti')
||'ve</strong> el conmutador'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4302707508059814.4001)
,p_name=>'P1951_SYNC_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_item_default=>'APPEND'
,p_prompt=>unistr('Tipo de Sincronizaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_SYNC_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601130955295874684.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione el tipo de sincronizaci\00F3n que se va a utilizar. Los valores posibles son:'),
'</p>',
'<ul>',
'    <li><strong>Agregar</strong>: agregar filas a la tabla local. Se utiliza normalmente cuando no se han definido claves primarias en el perfil de datos.</li>',
unistr('    <li><strong>Fusionar</strong>: fusionar filas en la tabla local. El perfil de datos debe tener definida una <em>clave primaria</em> para utilizar esta opci\00F3n. Si ya existe una fila para el valor de clave primaria dado, se actualizar\00E1 la fila y si')
||unistr(' no existe, se crear\00E1.</li>'),
'    <li><strong>Sustituir</strong>: vaciar la tabla local antes de cargar datos nuevos.</li>',
'',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4302840882059815.4001)
,p_name=>'P1951_SYNC_INTERVAL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Programaci\00F3n de Sincronizaci\00F3n')
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#sync-details" id="P1951_EDIT_SYNC_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" title="Schedule Builder" tabindex="0"><span class="a-Icon icon-utilities-build-interval"></span><span class="u-VisuallyHidden"'
||'>Compilador de programa</span></a><a href="#sync-details" id="P1951_CLEAR_SYNC_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" title="Clear Schedule" tabindex="0"><span class="a-Icon icon-remove"></span><span class="u-'
||'VisuallyHidden">Borrar programa</span></a>',
''))
,p_source=>'SYNC_INTERVAL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>3
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Utilice la <em>sintaxis de calendario de programador de base de datos</em> para definir programas de sincronizaci\00F3n repetitivos, como "todos los martes y viernes a las 4:00 p.m." o "el segundo mi\00E9rcoles de cada mes". '),
'</p>',
'<p>',
unistr('    La sintaxis del calendario puede ser introducida manualmente, o de forma declarativa usando el <strong>creador de intervalos</strong>, para crear expresiones simples. Haga clic en el <em>icono de llave inglesa</em> debajo del \00E1rea de texto de la ')
||unistr('expresi\00F3n de calendario, para abrir el creador de intervalos.'),
'</p>',
'<p>',
unistr('    Para tener m\00E1s programas de ejecuci\00F3n compleja, consulte los detalles sobre la <strong>sintaxis de calendario de programador</strong> en la documentaci\00F3n del paquete PL/SQL <strong>DBMS_SCHEDULER</strong> e introduzca su expresi\00F3n de forma manual')
||'.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4303678738059823.4001)
,p_name=>'P1951_NEW_SYNC_STEP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4302959812059816.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5520240846157143.4001)
,p_name=>'P1951_LAST_SYNC_TIMESTAMP'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_prompt=>unistr('\00DAltima sincronizaci\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1951_LAST_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica cu\00E1ndo se realiz\00F3 la \00FAltima sincronizaci\00F3n de la tabla local.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5520359347157144.4001)
,p_name=>'P1951_NEXT_SYNC_TIMESTAMP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(6292213365932471.4001)
,p_prompt=>unistr('Siguiente sincronizaci\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1951_NEXT_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica cu\00E1ndo se realizar\00E1 la pr\00F3xima sincronizaci\00F3n. Tenga en cuenta que las sincronizaciones se inician cada 10 minutos desde las horas en punto. Por lo tanto, una sincronizaci\00F3n puede iniciarse en el minuto 0 de la hora, en el 10, 20, 30, 40 o 50,')
||' pero no entre estos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5900754686682507.4001)
,p_name=>'P1951_NEW_OR_EXISTING_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_item_default=>'NEW'
,p_prompt=>'Sincronizar a'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_NEW_OR_EXISTING_TABLE'
,p_lov=>'.'||wwv_flow_api.id(601127065669873845.4001)||'.'
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea realizar la sincronizaci\00F3n con una tabla nueva o con una existente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5900899407682508.4001)
,p_name=>'P1951_NEW_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_prompt=>'Nombre de la Tabla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Proporcione el nombre de una tabla nueva con la que sincronizar los datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5900966161682509.4001)
,p_name=>'P1951_EXISTING_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_prompt=>'Nombre de la Tabla'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'  from sys.dba_tables',
' where owner = coalesce( :P1951_SYNC_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name not like ''BIN$%''',
' order by table_name'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P1951_SYNC_TABLE_OWNER'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>60
,p_cMaxlength=>128
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione una tabla existente con la que sincronizar los datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5901776603682517.4001)
,p_name=>'P1951_SHOW_SYNC_TABLE_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3405610816376635.4001)
,p_prompt=>'Sincronizando a'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1951_SHOW_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Los datos se han sincronizado con esta tabla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(319959071716296916.4001)
,p_name=>'P1951_OLD_JOB_IS_ACTIVE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3407119919376650.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3703358673255333.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1951_SYNC_STATUS'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_web_src_sync.get_table_ddl_sync_status(:P1951_WEB_SRC_MODULE_ID)'
,p_compute_when=>'P1951_SYNC_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3704724987255347.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1951_SQL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl( wwv_flow_web_src_sync.get_sync_table_column_sql(:P1951_WEB_SRC_MODULE_ID, :P1951_INCLUDE_DROP_COLUMNS = ''Y''), ''-- no SQL statements'')'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_STATUS in ( wwv_flow_web_src_sync.c_table_does_not_exist, ',
'                        wwv_flow_web_src_sync.c_columns_can_be_synced, ',
'                        wwv_flow_web_src_sync.c_columns_cannot_be_synced )'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3802607184901515.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1951_OLD_SYNC_TABLE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_TABLE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1405671983412668.4001)
,p_computation_sequence=>40
,p_computation_item=>'P1951_USE_RATE_LIMITING'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1951_MAX_REQUESTS is not null then ''Y'' else ''N'' end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5901822600682518.4001)
,p_computation_sequence=>40
,p_computation_item=>'P1951_SHOW_SYNC_TABLE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_TABLE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2902045826179103.4001)
,p_computation_sequence=>50
,p_computation_item=>'P1951_OLD_SYNC_INTERVAL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_INTERVAL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2905710845179140.4001)
,p_computation_sequence=>60
,p_computation_item=>'P1951_SYNC_SCHEMA_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P1951_SYNC_TABLE_OWNER, wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID))'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2905871925179141.4001)
,p_computation_sequence=>70
,p_computation_item=>'P1951_SYNC_TABLE_OBJECT_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'  from sys.dba_objects',
' where owner = :P1951_SYNC_SCHEMA_NAME',
'   and object_name = :P1951_SYNC_TABLE_NAME',
'   and object_type = ''TABLE'''))
,p_compute_when=>'P1951_SYNC_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1375291244674242.4001)
,p_computation_sequence=>80
,p_computation_item=>'P1951_JOB_STATE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_web_src_sync_dev.get_job_status( :P1951_WEB_SRC_MODULE_ID )'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1375672022674246.4001)
,p_computation_sequence=>90
,p_computation_item=>'P1951_JOB_SHOW_STATE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || :P1951_JOB_STATE )'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(319959181737296917.4001)
,p_computation_sequence=>100
,p_computation_item=>'P1951_OLD_JOB_IS_ACTIVE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_JOB_IS_ACTIVE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1935829912374329.4001)
,p_computation_sequence=>110
,p_computation_item=>'P1951_MIN_CADENCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl( wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE''), 0 )'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(90119091852448639.4001)
,p_computation_sequence=>120
,p_computation_item=>'P1921_BREADCRUMB_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_flow_web_src_modules ',
' where id                = :P1951_WEB_SRC_MODULE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(580502062081193402.4001)
,p_computation_sequence=>130
,p_computation_item=>'P1921_WEB_SRC_MODULE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_WEB_SRC_MODULE_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(721524888650207320.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1951_NEW_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper( :P1951_NEW_TABLE_NAME )'
,p_compute_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3804748324901536.4001)
,p_computation_sequence=>20
,p_computation_item=>'P1951_JOB_IS_ACTIVE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2903524746179118.4001)
,p_computation_sequence=>30
,p_computation_item=>'P1951_TABLE_SYNC_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :P1951_REPLACE_TYPE = ''TRUNCATE'' and :P1951_SYNC_TYPE = ''REPLACE'' ',
'    then ''TRUNCATE''',
'    else :P1951_SYNC_TYPE',
'end',
'      '))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5901550579682515.4001)
,p_computation_sequence=>40
,p_computation_item=>'P1951_SYNC_TABLE_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_NEW_TABLE_NAME'
,p_compute_when=>'P1951_NEW_OR_EXISTING_TABLE'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5901699317682516.4001)
,p_computation_sequence=>50
,p_computation_item=>'P1951_SYNC_TABLE_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_EXISTING_TABLE_NAME'
,p_compute_when=>'P1951_NEW_OR_EXISTING_TABLE'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3801543478901504.4001)
,p_validation_name=>'Local Table NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P1951_SYNC_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>'SAVE,MANUAL_DATA_SYNC'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(3702757410255327.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1662745779963711.4001)
,p_validation_name=>'Commit Interval is multiple of 100'
,p_validation_sequence=>20
,p_validation=>'mod( :P1951_SYNC_COMMIT_INTERVAL, 100 ) = 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('#LABEL# debe ser m\00FAltiplo de 100.')
,p_validation_condition=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_SYNC_COMMIT_INTERVAL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(3801266410901501.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3801601054901505.4001)
,p_validation_name=>'Sync Type NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P1951_SYNC_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>':P1951_OLD_SYNC_TABLE_NAME is not null and :REQUEST in (''SAVE'',''MANUAL_DATA_SYNC'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(4302707508059814.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3801970880901508.4001)
,p_validation_name=>'Sync Type "MERGE" only for Primary Key'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_sync_dev.data_profile_has_primary_key( ',
'    p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'El tipo "fusionar" requiere que se defina una columna de clave primaria en el perfil de datos.'
,p_validation_condition=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_SYNC_TYPE = ''MERGE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(4302707508059814.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3804993186901538.4001)
,p_validation_name=>'Sync interval must be greater than BACKGROUND_MIN_EXECUTION_CADENCE'
,p_validation_sequence=>60
,p_validation=>'to_number(wwv_flow_web_src_sync_dev.get_execution_cadence_minutes( p_calendaring_expression => :P1951_SYNC_INTERVAL )) >= to_number(:P1951_MIN_CADENCE)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Deben pasar al menos &P1951_MIN_CADENCE!HTML. minutos entre dos ejecuciones de trabajos.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and',
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_INTERVAL is not null and ',
':P1951_OLD_SYNC_TABLE_NAME is not null and',
'nvl(:P1951_SYNC_INTERVAL, chr(1)) != nvl(:P1951_OLD_SYNC_INTERVAL, chr(1))'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(4302840882059815.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1662904757963713.4001)
,p_validation_name=>'Installation Script name must not exist'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_install_scripts',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1951_SCRIPT_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Ya existe un script de objetos de soporte con este nombre.'
,p_when_button_pressed=>wwv_flow_api.id(3803834939901527.4001)
,p_associated_item=>wwv_flow_api.id(3803619759901525.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5904226730682542.4001)
,p_validation_name=>'New Table does not exist'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'  from sys.dba_tables',
' where owner = nvl( :P1951_SYNC_TABLE_OWNER, wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID))',
'   and table_name = :P1951_NEW_TABLE_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'La tabla &P1951_SYNC_TABLE_NAME!HTML. ya existe.'
,p_validation_condition=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' )  and :P1951_NEW_OR_EXISTING_TABLE = ''NEW'' and :P1951_OLD_SYNC_TABLE_NAME is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(5900899407682508.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3805025722901539.4001)
,p_name=>'Hide all'
,p_event_sequence=>5
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3805136729901540.4001)
,p_event_id=>wwv_flow_api.id(3805025722901539.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY,P1951_BYHOUR,P1951_BYMINUTE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3805259386901541.4001)
,p_name=>'Weekly Frequency chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'WEEKLY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3805374112901542.4001)
,p_event_id=>wwv_flow_api.id(3805259386901541.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY,P1951_BYHOUR,P1951_BYMINUTE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5516815331157109.4001)
,p_name=>'Close New Sync Step DIalog'
,p_event_sequence=>20
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5516958219157110.4001)
,p_event_id=>wwv_flow_api.id(5516815331157109.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4302959812059816.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5517065783157111.4001)
,p_name=>'Close Edit Sync Step DIalog'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(4302959812059816.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5517184250157112.4001)
,p_event_id=>wwv_flow_api.id(5517065783157111.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4302959812059816.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5520890652157149.4001)
,p_name=>'Hide SQL'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5520930493157150.4001)
,p_event_id=>wwv_flow_api.id(5520890652157149.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3402804208376607.4001)
,p_event_id=>wwv_flow_api.id(5520890652157149.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3402593703376604.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3402335945376602.4001)
,p_name=>'Show Create Table SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3402234723376601.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3402458260376603.4001)
,p_event_id=>wwv_flow_api.id(3402335945376602.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3402986281376608.4001)
,p_event_id=>wwv_flow_api.id(3402335945376602.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3402593703376604.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803379941901522.4001)
,p_event_id=>wwv_flow_api.id(3402335945376602.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3803085160901519.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403068884376609.4001)
,p_event_id=>wwv_flow_api.id(3402335945376602.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3402234723376601.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3402687592376605.4001)
,p_name=>'Hide Create Table SQL'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3402593703376604.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3402786069376606.4001)
,p_event_id=>wwv_flow_api.id(3402687592376605.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403381330376612.4001)
,p_event_id=>wwv_flow_api.id(3402687592376605.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3402234723376601.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403401991376613.4001)
,p_event_id=>wwv_flow_api.id(3402687592376605.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3402593703376604.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803439117901523.4001)
,p_event_id=>wwv_flow_api.id(3402687592376605.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3803085160901519.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3403782744376616.4001)
,p_name=>'Show Alter Table SQL'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3403550413376614.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403877295376617.4001)
,p_event_id=>wwv_flow_api.id(3403782744376616.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803252217901521.4001)
,p_event_id=>wwv_flow_api.id(3403782744376616.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3804144280901530.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3403951827376618.4001)
,p_event_id=>wwv_flow_api.id(3403782744376616.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3403686885376615.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3404031784376619.4001)
,p_event_id=>wwv_flow_api.id(3403782744376616.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3403550413376614.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2906320597179146.4001)
,p_name=>'Show Alter Table SQL2'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2906244256179145.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2906425015179147.4001)
,p_event_id=>wwv_flow_api.id(2906320597179146.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2906672692179149.4001)
,p_event_id=>wwv_flow_api.id(2906320597179146.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(5900100267682501.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2906749293179150.4001)
,p_event_id=>wwv_flow_api.id(2906320597179146.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2906244256179145.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3404179351376620.4001)
,p_name=>'Hide Alter Table SQL'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3403686885376615.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3404277765376621.4001)
,p_event_id=>wwv_flow_api.id(3404179351376620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3404325376376622.4001)
,p_event_id=>wwv_flow_api.id(3404179351376620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3403686885376615.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3803189957901520.4001)
,p_event_id=>wwv_flow_api.id(3404179351376620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3804144280901530.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3404405616376623.4001)
,p_event_id=>wwv_flow_api.id(3404179351376620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3403550413376614.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5900263319682502.4001)
,p_name=>'Hide Alter Table SQL2'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(5900100267682501.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5900340590682503.4001)
,p_event_id=>wwv_flow_api.id(5900263319682502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704694634255346.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5900472157682504.4001)
,p_event_id=>wwv_flow_api.id(5900263319682502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(5900100267682501.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5900621593682506.4001)
,p_event_id=>wwv_flow_api.id(5900263319682502.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(2906244256179145.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3404836611376627.4001)
,p_name=>'Show Interval Builder'
,p_event_sequence=>110
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1951_EDIT_SYNC_INTERVAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3404933336376628.4001)
,p_event_id=>wwv_flow_api.id(3404836611376627.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3404639650376625.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3405053842376629.4001)
,p_name=>'Hide Interval Builder'
,p_event_sequence=>120
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3405170593376630.4001)
,p_event_id=>wwv_flow_api.id(3405053842376629.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3404639650376625.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3405892116376637.4001)
,p_name=>'Daily Frequency chosen'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DAILY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3405966480376638.4001)
,p_event_id=>wwv_flow_api.id(3405892116376637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYHOUR,P1951_BYMINUTE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3805480788901543.4001)
,p_event_id=>wwv_flow_api.id(3405892116376637.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3406192278376640.4001)
,p_name=>'Hourly Frequency chosen'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HOURLY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3406277129376641.4001)
,p_event_id=>wwv_flow_api.id(3406192278376640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYMINUTE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3805595994901544.4001)
,p_event_id=>wwv_flow_api.id(3406192278376640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3805616249901545.4001)
,p_event_id=>wwv_flow_api.id(3406192278376640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYHOUR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3805902128901548.4001)
,p_name=>'Minutely Frequency chosen'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'MINUTELY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3806144633901550.4001)
,p_event_id=>wwv_flow_api.id(3805902128901548.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2901870089179101.4001)
,p_event_id=>wwv_flow_api.id(3805902128901548.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYHOUR,P1951_BYMINUTE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3406881060376647.4001)
,p_name=>'Build the interval'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3406775981376646.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3406913402376648.4001)
,p_event_id=>wwv_flow_api.id(3406881060376647.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SYNC_INTERVAL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'buildInterval()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3407083032376649.4001)
,p_event_id=>wwv_flow_api.id(3406881060376647.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3404639650376625.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3801770413901506.4001)
,p_name=>'Reload SQL'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INCLUDE_DROP_COLUMNS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3801857978901507.4001)
,p_event_id=>wwv_flow_api.id(3801770413901506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SQL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'nvl( wwv_flow_web_src_sync.get_sync_table_column_sql(:P1951_WEB_SRC_MODULE_ID, :P1951_INCLUDE_DROP_COLUMNS = ''Y''), ''-- no SQL statements'')'
,p_attribute_07=>'P1951_INCLUDE_DROP_COLUMNS,P1951_WEB_SRC_MODULE_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3803952592901528.4001)
,p_name=>'Open Save Script Dialog'
,p_event_sequence=>180
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3803085160901519.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3804078606901529.4001)
,p_event_id=>wwv_flow_api.id(3803952592901528.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3803587485901524.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3804418057901533.4001)
,p_name=>'Save as Script'
,p_event_sequence=>190
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3804144280901530.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3804613762901535.4001)
,p_event_id=>wwv_flow_api.id(3804418057901533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SCRIPT_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'2'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3804504129901534.4001)
,p_event_id=>wwv_flow_api.id(3804418057901533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3803587485901524.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2902201004179105.4001)
,p_name=>'Clear Sync Interval'
,p_event_sequence=>200
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1951_CLEAR_SYNC_INTERVAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2902318682179106.4001)
,p_event_id=>wwv_flow_api.id(2902201004179105.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SYNC_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2903281473179115.4001)
,p_name=>'Replace Type chosen'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_SYNC_TYPE'
,p_condition_element=>'P1951_SYNC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2903363466179116.4001)
,p_event_id=>wwv_flow_api.id(2903281473179115.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_REPLACE_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2903417011179117.4001)
,p_event_id=>wwv_flow_api.id(2903281473179115.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_REPLACE_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2903817930179121.4001)
,p_name=>'Interval set'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_SYNC_INTERVAL'
,p_condition_element=>'P1951_SYNC_INTERVAL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2903904922179122.4001)
,p_event_id=>wwv_flow_api.id(2903817930179121.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904085462179123.4001)
,p_event_id=>wwv_flow_api.id(2903817930179121.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904718604179130.4001)
,p_event_id=>wwv_flow_api.id(2903817930179121.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904838489179131.4001)
,p_event_id=>wwv_flow_api.id(2903817930179121.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2904963468179132.4001)
,p_name=>'Confirm'
,p_event_sequence=>230
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3200568818532836.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905056432179133.4001)
,p_event_id=>wwv_flow_api.id(2904963468179132.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('Esta acci\00F3n borrar\00E1 toda la configuraci\00F3n de sincronizaci\00F3n. La tabla local NO se borrar\00E1. \00BFDesea continuar?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905163797179134.4001)
,p_event_id=>wwv_flow_api.id(2904963468179132.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CLEAR_SYNC'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5901034004682510.4001)
,p_name=>'New Table chosen'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_NEW_OR_EXISTING_TABLE'
,p_condition_element=>'P1951_NEW_OR_EXISTING_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5901179260682511.4001)
,p_event_id=>wwv_flow_api.id(5901034004682510.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_NEW_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5901440820682514.4001)
,p_event_id=>wwv_flow_api.id(5901034004682510.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_EXISTING_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5901236963682512.4001)
,p_event_id=>wwv_flow_api.id(5901034004682510.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_NEW_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5901336470682513.4001)
,p_event_id=>wwv_flow_api.id(5901034004682510.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_EXISTING_TABLE_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1404085451407882.4001)
,p_name=>'Max Requests Per MIn changed'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_USE_RATE_LIMITING'
,p_condition_element=>'P1951_USE_RATE_LIMITING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1404413427407894.4001)
,p_event_id=>wwv_flow_api.id(1404085451407882.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_MAX_REQUESTS_TIMEFRAME,P1951_MAX_REQUESTS,P1951_MAX_REQUESTS_EXC_ACTION'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1404980068407894.4001)
,p_event_id=>wwv_flow_api.id(1404085451407882.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_MAX_REQUESTS_TIMEFRAME,P1951_MAX_REQUESTS,P1951_MAX_REQUESTS_EXC_ACTION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1664160786963725.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Other Syncs for Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sync_usages varchar2(32767);',
'begin',
'    for s in (',
'        select flow_id,',
'               name',
'          from wwv_flow_web_src_modules',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and ( sync_table_owner  = nvl( :P1951_SYNC_TABLE_OWNER, wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID) ) or ',
'                        ( sync_table_owner is null and :P1951_SYNC_TABLE_OWNER is null ) )',
'           and sync_table_name   = :P1951_OLD_SYNC_TABLE_NAME',
'           and id != :P1951_WEB_SRC_MODULE_ID',
'    ) loop',
'         l_sync_usages := l_sync_usages || case when l_sync_usages is not null then '', '' end',
'                                        || s.name || '' ('' || wwv_flow_lang.system_message( ''APPLICATION'') || '' '' || s.flow_id || '')'';',
'    end loop;',
'    ',
'    :P1951_OTHER_SYNC_INFO := l_sync_usages;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist and :P1951_OLD_SYNC_TABLE_NAME is not null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1406047373417134.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Rate Limiting Items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P1951_MAX_REQUESTS_TIMEFRAME,P1951_MAX_REQUESTS,P1951_MAX_REQUESTS_EXC_ACTION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_USE_RATE_LIMITING = ''N''',
''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3704142050255341.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Apply Changes'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1951_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Se han aplicado los cambios.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1664485903963728.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Disable Sync job on subscribed REST Sources'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.handle_sync_job_subscribed_wsm(',
'        p_master_wsm_job_status   => :P1951_JOB_IS_ACTIVE = ''Y'',',
'        p_web_source_module_id    => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_JOB_IS_ACTIVE = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1663791597963721.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Enable Local Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.set_use_local_sync_table(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID,',
'        p_use_local_sync_table => false);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_SYNC_TABLE_NAME is not null and :P1951_OLD_SYNC_TABLE_NAME is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5520707176157148.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Next Run Timestamp'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync.set_web_src_sync_timestamps(',
'        p_web_source_module_id    => :P1951_WEB_SRC_MODULE_ID,',
'        p_calendaring_expression  => case when :P1951_JOB_IS_ACTIVE = ''Y'' then :P1951_SYNC_INTERVAL end,',
'        p_set_last_run_timestamp  => false,',
'        p_clear_when_null         => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and',
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_OLD_SYNC_TABLE_NAME is not null and',
'( nvl(:P1951_SYNC_INTERVAL, chr(1)) != nvl(:P1951_OLD_SYNC_INTERVAL, chr(1)) or ',
'  nvl(:P1951_JOB_IS_ACTIVE, chr(1)) != nvl(:P1951_OLD_JOB_IS_ACTIVE, chr(1)) ) '))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3704916247255349.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync.execute_sync_table( :P1951_WEB_SRC_MODULE_ID, :P1951_INCLUDE_DROP_COLUMNS = ''Y'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_TABLE,ALTER_TABLE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Se ha creado o cambiado la tabla.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4302596829059812.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Sync'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.clear_web_source_sync(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3200568818532836.4001)
,p_process_success_message=>unistr('Se ha borrado la configuraci\00F3n de sincronizaci\00F3n de REST.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4303451519059821.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Sync Step'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1951_NEW_SYNC_STEP_ID := wwv_flow_web_src_sync_dev.create_new_sync_step(',
'                                   p_application_id       => :FB_FLOW_ID,',
'                                   p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4303314867059820.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5517716244157118.4001)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync Data Manually'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync.execute_due_wsm_data_syncs(',
'        p_web_src_module_id     => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(4302666690059813.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Se ha disparado la sincronizaci\00F3n de REST.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3802948853901518.4001)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Supporting Object script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1951_SCRIPT_ID := wwv_flow_web_src_sync_dev.create_supp_objects_script(',
'                            p_application_id         => :FB_FLOW_ID,',
'                            --',
'                            p_web_source_module_id   => :P1951_WEB_SRC_MODULE_ID,',
'                            p_include_drop_columns   => :P1951_INCLUDE_DROP_COLUMNS = ''Y'',',
'                            p_script_type            => :P1951_SCRIPT_TYPE,',
'                            p_script_name            => :P1951_SCRIPT_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(3803834939901527.4001)
,p_process_success_message=>'Se ha creado el script de objetos de soporte "&P1951_SCRIPT_NAME!HTML.".'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1373990319674229.4001)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_websource_sync_log1$ ',
'     where web_src_module_id = :P1951_WEB_SRC_MODULE_ID ',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'       ',
'    delete wwv_flow_websource_sync_log2$ ',
'     where web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1373830947674228.4001)
,p_process_success_message=>unistr('Se ha depurado el log de sincronizaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1375474215674244.4001)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Abort running sync job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.abort_sync_job( ',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1375364889674243.4001)
,p_process_success_message=>unistr('Se ha abortado la sincronizaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3702673013255326.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch WSM Details'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1951_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2902132912179104.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch last and next sync timestamp'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sync_timestamps as (',
'    select sync_last_run_timestamp,',
'           case when sync_next_run_timestamp is not null then',
'               wwv_flow_web_src_sync_dev.get_actual_execution_timestamp( sync_next_run_timestamp ) at time zone ''00:00''',
'           end as sync_next_run_timestamp',
'      from wwv_flow_web_src_modules',
'     where id                = :P1951_WEB_SRC_MODULE_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'select case ',
'           when sync_next_run_timestamp is not null then',
'               to_char(sync_next_run_timestamp, ''Mon fmdd, '' ) ||',
'               to_char(sync_next_run_timestamp, ''HH24:MI '' ) ||',
'               decode(to_char(sync_next_run_timestamp, ''TZR'' ), ''+00:00'', ''UTC'', to_char(sync_next_run_timestamp, ''TZR'' ) ) ||',
'               '' ('' || htmldb_util.get_since( sync_next_run_timestamp ) || '')''',
'       end,',
'       case',
'           when sync_last_run_timestamp is not null then',
'                      htmldb_util.get_since( sync_last_run_timestamp )',
'       end',
'  into :P1951_NEXT_SYNC_TIMESTAMP,',
'       :P1951_LAST_SYNC_TIMESTAMP',
'  from sync_timestamps;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2903646243179119.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Truncate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case ',
'    when :P1951_TABLE_SYNC_TYPE = ''TRUNCATE'' then',
'        :P1951_SYNC_TYPE := ''REPLACE'';',
'        :P1951_REPLACE_TYPE := ''TRUNCATE'';',
'    when :P1951_TABLE_SYNC_TYPE = ''REPLACE'' then',
'        :P1951_SYNC_TYPE := ''REPLACE'';',
'        :P1951_REPLACE_TYPE := ''DELETE'';',
'    else',
'        :P1951_SYNC_TYPE := :P1951_TABLE_SYNC_TYPE;',
'        :P1951_REPLACE_TYPE := null;',
'end case;',
'       ',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01952
begin
wwv_flow_api.create_page(
 p_id=>1952.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar paso de sincronizaci\00F3n')
,p_alias=>'EDIT-SYNC-STEP'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Editar paso de sincronizaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4303740949059824.4001)
,p_plug_name=>unistr('Par\00E1metros')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id, ',
'       pa.name,',
'       cp.value_type,',
'       cp.value_language,',
'       cp.value',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_params pa, wwv_flow_web_src_sync_steps sp',
' where pa.id = cp.web_src_param_id',
'   and sp.id = cp.module_sync_step_id',
'   and sp.id = :P1952_SYNC_STEP_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P1952_SYNC_STEP_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_sync_steps sp',
' where sp.id = cp.module_sync_step_id',
'   and sp.id = :P1952_SYNC_STEP_ID'))
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Par\00E1metros')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2319784476209543.4001)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4304683024059833.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4304740260059834.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Nombre del Par\00E1metro')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>unistr('Identifica el <em>nombre</em> del par\00E1metro de origen de datos de REST.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4304829191059835.4001)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Tipo de Valor'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(358243382603181986)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la forma en la que se rellena este par\00E1metro.</p><p>Entre las opciones disponibles se incluyen las siguientes:</p>'),
'<ul>',
unistr('    <li><strong>Valor est\00E1tico</strong>: def\00EDnalo seg\00FAn el texto introducido en el <em>valor est\00E1tico</em>.</li>'),
unistr('    <li><strong>Elemento</strong>: def\00EDnalo seg\00FAn el valor retenido en el estado de sesi\00F3n del <em>elemento</em> especificado.</li>'),
unistr('    <li><strong>Consulta SQL (devolver valor \00FAnico)</strong>: def\00EDnalo seg\00FAn el primer valor devuelto de la <em>consulta SQL</em> introducida.</li>'),
unistr('    <li><strong>Expresi\00F3n PL/SQL</strong>: def\00EDnalo seg\00FAn el valor resultante al ejecutar la <em>expresi\00F3n PL/SQL</em> introducida.</li>'),
unistr('    <li><strong>Cuerpo de la funci\00F3n PL/SQL</strong>: def\00EDnalo seg\00FAn el valor devuelto del <em>cuerpo de la funci\00F3n PL/SQL</em> introducido.</li>'),
unistr('    <li><strong>Recopilaci\00F3n (CLOB)</strong>: def\00EDnalo seg\00FAn el valor de columna de CLOB de la primera fila de la <em>recopilaci\00F3n</em> introducida.</li>'),
unistr('    <li><strong>Preferencia</strong>: def\00EDnalo seg\00FAn el valor de la <em>preferencia</em> introducida.</li>'),
unistr('    <li><strong>Nulo</strong>: def\00EDnalo en nulo si no se especifica ning\00FAn valor.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4304949748059836.4001)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Expresi\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>unistr('Proporcione la expresi\00F3n a continuaci\00F3n, seg\00FAn la columna <strong>Tipo de valor </strong>.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4305021843059837.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4305152515059838.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(4304597288059832.4001)
,p_internal_uid=>4304597288059832
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>unistr('No se ha definido ning\00FAn par\00E1metro.')
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4304145200059828.4001)
,p_plug_name=>unistr('Editar paso de sincronizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_WEB_SRC_SYNC_STEPS'
,p_query_where=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4305399667059840.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5516600080157107.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4305533231059842.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(4305399667059840.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5517419820157115.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4305399667059840.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4305456974059841.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4305399667059840.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2905270958179135.4001)
,p_name=>'P1952_EXTERNAL_FILTER_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_prompt=>'Filtro Externo'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_tag_attributes=>'style="width: 100%"'
,p_colspan=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Proporcione una expresi\00F3n de filtro que se va a transferir al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto sin modificaciones. La sintaxis depende del tipo de origen de datos de REST.</p>'),
'<p>',
unistr('    Por ejemplo, Oracle REST Data Services (ORDS) espera la sintaxis de JSON y, por lo tanto, un servicio REST de ORDS aceptar\00E1 el siguiente filtro para devolver solo los informes cuyo atributo "sal" sea inferior a 3000.'),
'</p>',
'<pre>',
'{"sal": {"$lt": 3000}}',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4304273111059829.4001)
,p_name=>'P1952_SYNC_STEP_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4306115270059848.4001)
,p_name=>'P1952_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_prompt=>unistr('Identificador Est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_attributes=>'style="width: 100%"'
,p_colspan=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca un ID est\00E1tico para identificar un paso de sincronizaci\00F3n de forma \00FAnica.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4306210534059849.4001)
,p_name=>'P1952_EXECUTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_prompt=>'Secuencia'
,p_source=>'EXECUTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_begin_on_new_line=>'N'
,p_colspan=>1
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('N\00FAmero de secuencia para determinar el orden de ejecuci\00F3n de los pasos de sincronizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4306389774059850.4001)
,p_name=>'P1952_IS_ACTIVE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_prompt=>'Activo'
,p_source=>'IS_ACTIVE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_colspan=>1
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Si este paso se va a ejecutar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5516045199157101.4001)
,p_name=>'P1952_SYNC_STEP_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5516600080157107.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4304145200059828.4001)
,p_prompt=>'Comentarios'
,p_source=>'SYNC_STEP_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'style="width: 100%"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2902402034179107.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(4303740949059824.4001)
,p_validation_name=>'Validate Code and SQL'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'     l_error varchar2(32767);',
'begin',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then ',
'        l_error := wwv_flow_code_exec_dev.check_code (',
'                       p_type             => :VALUE_TYPE,',
'                       p_return_data_type => wwv_flow_code_exec_dev.c_return_data_type_varchar2,',
'                       p_code             => :VALUE,',
'                       p_language         => coalesce( :VALUE_LANGUAGE, wwv_flow_code_exec.c_plsql ),',
'                       p_application_id   => :FB_FLOW_ID );            ',
'    elsif :VALUE_TYPE = ''SQL_QUERY'' then',
'        l_error := wwv_flow_f4000_util.check_sql(',
'                       p_sql     => :VALUE,',
'                       p_flow_id => :FB_FLOW_ID );',
'    end if;',
'    ',
'    return l_error;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(4305456974059841.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2903014218179113.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(4303740949059824.4001)
,p_validation_name=>'Validate NULL'
,p_validation_sequence=>20
,p_validation=>':VALUE is NULL'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'El tipo de valor NULL no puede tener un valor.'
,p_validation_condition=>'VALUE_TYPE'
,p_validation_condition2=>'NULL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4305456974059841.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2902546536179108.4001)
,p_name=>'NULL Value Type'
,p_event_sequence=>10
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_api.id(4303740949059824.4001)
,p_triggering_element=>'VALUE_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2902896709179111.4001)
,p_event_id=>wwv_flow_api.id(2902546536179108.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2319829401209544.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(4303740949059824.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parameters - Set VALUE_LANGUAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Web Source Parameters should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4305232788059839.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(4303740949059824.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Parameters - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5516579260157106.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(4304145200059828.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Synchronization Step'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5516738383157108.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4305674944059843.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(4304145200059828.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Sync Step'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01953
begin
wwv_flow_api.create_page(
 p_id=>1953.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Log de solicitud HTTP'
,p_alias=>'HTTP-REQUESTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Log de solicitud HTTP'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2904138288179124.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5519335336157134.4001)
,p_name=>'Log de solicitud HTTP'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select http_method,',
'       url,',
'       resp_content_length,',
'       status_code,',
'       request_date,',
'       elapsed_sec',
'  from wwv_flow_webservice_log',
' where web_src_sync_id   = :P1953_WSM_SYNC_ID',
'   and web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se han registrado solicitudes HTTP para esta sincronizaci\00F3n.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519421732157135.4001)
,p_query_column_id=>1
,p_column_alias=>'HTTP_METHOD'
,p_column_display_sequence=>1
,p_column_heading=>unistr('M\00E9todo HTTP')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519534970157136.4001)
,p_query_column_id=>2
,p_column_alias=>'URL'
,p_column_display_sequence=>2
,p_column_heading=>'URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519624559157137.4001)
,p_query_column_id=>3
,p_column_alias=>'RESP_CONTENT_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Longitud del Contenido'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519714612157138.4001)
,p_query_column_id=>4
,p_column_alias=>'STATUS_CODE'
,p_column_display_sequence=>4
,p_column_heading=>unistr('C\00F3digo de Estado')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5520125865157142.4001)
,p_query_column_id=>5
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>6
,p_column_heading=>'Solicitud a partir de'
,p_use_as_row_header=>'N'
,p_column_format=>'YYYY/MM/DD HH24:MI:SS'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5519864543157139.4001)
,p_query_column_id=>6
,p_column_alias=>'ELAPSED_SEC'
,p_column_display_sequence=>5
,p_column_heading=>'Tiempo transcurrido'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2904249830179125.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2904138288179124.4001)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5520029440157141.4001)
,p_name=>'P1953_WSM_SYNC_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5519335336157134.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1375773160674247.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1953_WSM_SYNC_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1953_WSM_SYNC_ID'
,p_compute_when_text=>'-'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2904374683179126.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2904249830179125.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904446690179127.4001)
,p_event_id=>wwv_flow_api.id(2904374683179126.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01954
begin
wwv_flow_api.create_page(
 p_id=>1954.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Uso de sincronizaci\00F3n')
,p_alias=>'CLEAR-SYNCHRONIZATION-SETTINGS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Uso de sincronizaci\00F3n')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5704471149300022.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5903108996682531.4001)
,p_plug_name=>unistr('Borrar informaci\00F3n de sincronizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Este informe muestra componentes de aplicaciones que utilizan la tabla de sincronizaci\00F3n local como origen de datos.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1954_DIALOG_TYPE'
,p_plug_display_when_cond2=>'SHOW_USAGE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5904047098682540.4001)
,p_plug_name=>unistr('Informaci\00F3n de Uso')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Los siguientes componentes de aplicaciones est\00E1n utilizando este origen de datos de REST, con el atributo <strong>Utilizar tabla de sincronizaci\00F3n</strong> activado. Si se borra la sincronizaci\00F3n, el atributo <strong>Utilizar tabla de sincronizaci\00F3n<')
||unistr('/strong> se desactivar\00E1 y los componentes llamar\00E1n al servicio REST directamente.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1954_DIALOG_TYPE'
,p_plug_display_when_cond2=>'CLEAR_SYNC'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(8319668197278032.4001)
,p_name=>'Componentes '
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang_dev.builder_message( component_type_msg ) as component_type,',
'       component_id,',
'       page_id,',
'       region_name,',
'       series_name,',
'       shared_component_name',
'  from wwv_flow_web_src_module_usage',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and web_src_module_id    = :P1951_WEB_SRC_MODULE_ID',
'   and use_local_sync_table = ''Y''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('Ning\00FAn componente de aplicaci\00F3n est\00E1 utilizando la tabla de sincronizaci\00F3n.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5902430957682524.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5902530718682525.4001)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5902691473682526.4001)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5903253422682532.4001)
,p_query_column_id=>4
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la Regi\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5903357610682533.4001)
,p_query_column_id=>5
,p_column_alias=>'SERIES_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre de la Serie'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5903427079682534.4001)
,p_query_column_id=>6
,p_column_alias=>'SHARED_COMPONENT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Nombre de componente compartido'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2800991143120933.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5704471149300022.4001)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5903605869682536.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5704471149300022.4001)
,p_button_name=>'CLEAR_SYNC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Borrar sincronizaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'P1954_DIALOG_TYPE'
,p_button_condition2=>'CLEAR_SYNC'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5903730084682537.4001)
,p_branch_name=>'Go To Page 1951'
,p_branch_action=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:1951:P1951_WEB_SRC_MODULE_ID:&P1951_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5903837157682538.4001)
,p_name=>'P1954_DIALOG_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5903108996682531.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2804421557120958.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2800991143120933.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2804937711120960.4001)
,p_event_id=>wwv_flow_api.id(2804421557120958.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5903533804682535.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Sync'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.clear_web_source_sync(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(5903605869682536.4001)
,p_process_success_message=>unistr('Se ha borrado la sincronizaci\00F3n. Todos los componentes utilizar\00E1n el origen de REST directamente.')
);
end;
/
prompt --application/pages/page_01955
begin
wwv_flow_api.create_page(
 p_id=>1955.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Sincronizaciones'
,p_alias=>'SYNCHRONIZATIONS'
,p_step_title=>'Sincronizaciones'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(809376180227725873.4001)
,p_plug_name=>'Sincronizaciones de REST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.name                                                                    module_name,',
'       nvl( m.sync_table_owner, wwv_flow_lang.system_message(''PARSING_SCHEMA''))  table_owner,',
'       m.sync_table_name                                                         table_name,',
'       m.sync_type,',
'       m.sync_is_active                                                          is_active,',
'       m.sync_interval,',
'       m.sync_last_run_timestamp,',
'       case when m.sync_next_run_timestamp is not null then',
'           wwv_flow_web_src_sync_dev.get_actual_execution_timestamp( m.sync_next_run_timestamp ) at time zone ''00:00'' ',
'       end as sync_next_run_timestamp',
'from wwv_flow_web_src_modules m',
'where m.security_group_id = :flow_security_group_id',
'  and m.flow_id           = :fb_flow_id',
'  and m.sync_table_name   is not null',
''))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(809376252104725874.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se ha encontrado ninguna sincronizaci\00F3n de REST.')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_notify=>'Y'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>809376252104725874
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(564732923534362597.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546916858863857721.4001)
,p_db_column_name=>'IS_ACTIVE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Activo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(564732174506362594.4001)
,p_db_column_name=>'MODULE_NAME'
,p_display_order=>30
,p_column_identifier=>'N'
,p_column_label=>unistr('Sincronizaci\00F3n de REST')
,p_column_link=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:RP,:P1951_WEB_SRC_MODULE_ID:#ID#'
,p_column_linktext=>'#MODULE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546916523539857718.4001)
,p_db_column_name=>'TABLE_OWNER'
,p_display_order=>40
,p_column_identifier=>'Q'
,p_column_label=>'Propietario de Tabla'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546916673844857719.4001)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Nombre de la Tabla'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546916771735857720.4001)
,p_db_column_name=>'SYNC_TYPE'
,p_display_order=>60
,p_column_identifier=>'S'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(601130955295874684)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546916966797857722.4001)
,p_db_column_name=>'SYNC_INTERVAL'
,p_display_order=>70
,p_column_identifier=>'U'
,p_column_label=>'Intervalo'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546917094466857723.4001)
,p_db_column_name=>'SYNC_LAST_RUN_TIMESTAMP'
,p_display_order=>80
,p_column_identifier=>'V'
,p_column_label=>unistr('\00DAltima Ejecuci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(546917177804857724.4001)
,p_db_column_name=>'SYNC_NEXT_RUN_TIMESTAMP'
,p_display_order=>90
,p_column_identifier=>'W'
,p_column_label=>unistr('Siguiente ejecuci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1047425145047544749.4001)
,p_plug_name=>'Sincronizaciones'
,p_region_name=>'Synchronizations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se muestran las <strong>sincronizaciones de REST</strong> definidas en esta aplicaci\00F3n.</p>'),
unistr('<p>Para crear una nueva sincronizaci\00F3n de REST, en primer lugar debe crear un nuevo <strong>origen de datos de REST</strong> para, a continuaci\00F3n, desplazarse a la tarea <strong>Gestionar sincronizaci\00F3n</strong> con el fin de configurar datos como la')
||unistr(' tabla de destino, el m\00E9todo de sincronizaci\00F3n y los datos adicionales.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1047425344240544750.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(241353531173849237.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_01960
begin
wwv_flow_api.create_page(
 p_id=>1960.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Cat\00E1logos de origen de REST')
,p_alias=>'REST-SOURCE-CATALOGS'
,p_step_title=>unistr('Cat\00E1logos de origen de REST')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1466873346002238.4001)
,p_plug_name=>unistr('Cree primero un grupo de cat\00E1logo')
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Los cat\00E1logos de origen de REST se organizan por <em>Grupos</em>. Cree un grupo de cat\00E1logo para gestionar los cat\00E1logos de origen de REST.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups ',
' where security_group_id = :WORKSPACE_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(93647485831975487.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2036513182725270.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(97563383977456410.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los cat\00E1logos de origen de REST permiten que los desarrolladores creen or\00EDgenes de datos de REST utilizando servicios predefinidos.</p>'),
unistr('<p>Cree su propio cat\00E1logo o importe uno existente.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(447638473297252882.4001)
,p_plug_name=>unistr('Cat\00E1logos de origen de REST')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    g.name as group_name, ',
'    g.id as group_id, ',
'    c.name as catalog_name, ',
'    c.id as catalog_id, ',
'    c.description, ',
'    (select count(*) from wwv_web_src_catalog_services s where s.catalog_id = c.id and s.security_group_id = c.security_group_id) as service_count,',
'    c.last_imported_at imported,',
'    nvl(c.last_updated_on,c.created_on) last_modified',
'from wwv_web_src_catalog_groups g ',
'join wwv_web_src_catalogs c on (c.catalog_group_id = g.id and c.security_group_id = g.security_group_id)',
'where g.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(447638575838252882.4001)
,p_name=>'Application Groups'
,p_no_data_found_message=>unistr('Este espacio de trabajo no contiene cat\00E1logos de origen de REST.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'SBKENNED'
,p_internal_uid=>447638575838252882
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2029553017651239.4001)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Grupo'
,p_column_link=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:RP,1961:P1961_ID:#GROUP_ID##ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2030789434651242.4001)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(6177033125901821.4001)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Identificador de Grupo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(6177174656901822.4001)
,p_db_column_name=>'CATALOG_NAME'
,p_display_order=>24
,p_column_identifier=>'N'
,p_column_label=>unistr('Cat\00E1logo')
,p_column_link=>'f?p=&APP_ID.:1962:&SESSION.::&DEBUG.:1963:P1962_ID:#CATALOG_ID#'
,p_column_linktext=>'#CATALOG_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(6177290014901823.4001)
,p_db_column_name=>'CATALOG_ID'
,p_display_order=>34
,p_column_identifier=>'O'
,p_column_label=>unistr('ID de cat\00E1logo')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(6177490665901825.4001)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>54
,p_column_identifier=>'Q'
,p_column_label=>unistr('Descripci\00F3n')
,p_allow_sorting=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(6177519312901826.4001)
,p_db_column_name=>'SERVICE_COUNT'
,p_display_order=>64
,p_column_identifier=>'R'
,p_column_label=>'Contenido'
,p_column_link=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.::P1963_CATALOG_ID:#CATALOG_ID#'
,p_column_linktext=>'#SERVICE_COUNT# servicios'
,p_column_link_attr=>'class="a-Button"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1464820423002218.4001)
,p_db_column_name=>'IMPORTED'
,p_display_order=>74
,p_column_identifier=>'T'
,p_column_label=>'Importado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1466911191002239.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1466873346002238.4001)
,p_button_name=>'CREATE_GROUP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Grupo'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:1961::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2033441015651258.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(447638473297252882.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Cat\00E1logo')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1962:&SESSION.::&DEBUG.:1962::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups ',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1464958518002219.4001)
,p_name=>'Edit Catalog Dialog closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(447638473297252882.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1465084671002220.4001)
,p_event_id=>wwv_flow_api.id(1464958518002219.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(447638473297252882.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1467272603002242.4001)
,p_name=>'Edit Group Dialog closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1466911191002239.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1467394734002243.4001)
,p_event_id=>wwv_flow_api.id(1467272603002242.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'document.location.reload();'
);
end;
/
prompt --application/pages/page_01961
begin
wwv_flow_api.create_page(
 p_id=>1961.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Detalles del grupo de cat\00E1logo')
,p_alias=>'CATALOG-GROUP-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Detalles del grupo de cat\00E1logo')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2054133058988356.4001)
,p_plug_name=>unistr('Detalles del grupo de cat\00E1logo')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOG_GROUPS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Los grupos se utilizan para organizar cat\00E1logos, de manera que los desarrolladores puedan encontrar con m\00E1s facilidad los servicios desde los que crear or\00EDgenes de datos de REST.'),
'</p>'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2059941738988482.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2062342717988507.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2059941738988482.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1961_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2062745375988508.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2059941738988482.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1961_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2060360203988483.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2059941738988482.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2061953528988505.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2059941738988482.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_confirm_message=>unistr('\00BFSuprimir este grupo de cat\00E1logo?')
,p_confirm_style=>'danger'
,p_button_condition=>'P1961_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2054424688988359.4001)
,p_name=>'P1961_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2054842949988412.4001)
,p_name=>'P1961_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Especifique el nombre del grupo de cat\00E1logo.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2055143545988441.4001)
,p_name=>'P1961_ICON'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_prompt=>'Icono'
,p_post_element_text=>'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:1967:&SESSION.::&DEBUG.::P1967_RETURN_ITEM:P1961_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>'
,p_source=>'ICON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Set condition to NEVER for now. We will address icons in a later release. DBB'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2055555089988442.4001)
,p_name=>'P1961_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2054133058988356.4001)
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Describa el objetivo del grupo.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6814291803316802.4001)
,p_validation_name=>'Name is unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_web_src_catalog_groups cg',
' where cg.security_group_id = :WORKSPACE_ID',
'   and cg.id   != :P1961_ID',
'   and cg.name  = :P1961_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# debe ser exclusiva en el espacio de trabajo.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(2054842949988412.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6814384500316803.4001)
,p_validation_name=>'Group must be empty to delete'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs ',
' where security_group_id = :WORKSPACE_ID',
'   and catalog_group_id  = :P1961_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('No puede eliminar un grupo que contenga cat\00E1logos.')
,p_when_button_pressed=>wwv_flow_api.id(2061953528988505.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2060435743988483.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2060360203988483.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2061278071988498.4001)
,p_event_id=>wwv_flow_api.id(2060435743988483.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2063506466988521.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(2054133058988356.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Catalog Group Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2063944806988523.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2063146660988520.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(2054133058988356.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Catalog Group Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01962
begin
wwv_flow_api.create_page(
 p_id=>1962.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Detalles del cat\00E1logo de origen de REST')
,p_alias=>'REST-SOURCE-CATALOG-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Detalles del cat\00E1logo de origen de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2072305345128155.4001)
,p_plug_name=>unistr('Detalles del cat\00E1logo de origen de REST')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2076109690128210.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2078591107128229.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2076109690128210.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1962_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2078902067128229.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2076109690128210.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1962_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2076549350128212.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2076109690128210.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2078172547128227.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2076109690128210.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_confirm_message=>unistr('\00BFSuprimir este cat\00E1logo?')
,p_confirm_style=>'danger'
,p_button_condition=>'P1962_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1502435283184412.4001)
,p_name=>'P1962_CREDENTIAL_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'disabled'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Tipo de credencial web que se utiliza para la autenticaci\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2072650229128156.4001)
,p_name=>'P1962_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2073019332128175.4001)
,p_name=>'P1962_CATALOG_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Grupo'
,p_source=>'CATALOG_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv ',
'from wwv_web_src_catalog_groups ',
'where security_group_id = :WORKSPACE_ID;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un grupo para organizar el cat\00E1logo y ayudar a los desarrolladores a la hora de crear servicios.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2073475059128195.4001)
,p_name=>'P1962_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Los nombres de cat\00E1logo deben ser \00FAnicos en el espacio de trabajo.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2073823429128196.4001)
,p_name=>'P1962_ICON'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Icono'
,p_post_element_text=>'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:1967:&SESSION.::&DEBUG.::P1967_RETURN_ITEM:P1962_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>'
,p_source=>'ICON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Set condition to NEVER for now. We will address icons in a later release. DBB'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2074239369128197.4001)
,p_name=>'P1962_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Describa el cat\00E1logo de origen de REST')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6177863288901829.4001)
,p_name=>'P1962_INTERNAL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Nombre Interno'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('El nombre interno se utiliza para identificar un cat\00E1logo en varias instancias de APEX. Si se importa un cat\00E1logo y ya existe uno con el mismo nombre interno, este \00FAltimo se sobrescribe.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6178096685901831.4001)
,p_name=>'P1962_FORMAT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_default=>'APEX'
,p_source=>'FORMAT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>unistr('Los nombres de cat\00E1logo deben ser exclusivos en el espacio de trabajo.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6817437956316834.4001)
,p_name=>'P1962_ENDPOINT_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Refrescar URL de punto final'
,p_source=>'ENDPOINT_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Proporcione una URL desde la que se pueda descargar el archivo de exportaci\00F3n de cat\00E1logo para refrescar el cat\00E1logo de origen de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6817503729316835.4001)
,p_name=>'P1962_TOKEN_SERVER_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'URL del servidor de token'
,p_source=>'TOKEN_SERVER_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Proporcione la URL de un servidor de token si se utiliza el flujo de <strong>credenciales de cliente OAuth2</strong> para autenticarse en la URL de punto final refrescada.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6817623133316836.4001)
,p_name=>'P1962_PROXY_SERVER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Servidor Proxy'
,p_placeholder=>'- Utilizar proxy de instancia por defecto -'
,p_source=>'PROXY_SERVER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Servidor proxy que se utilizar\00E1 al refrescar el cat\00E1logo de origen de REST. Si no se define, se utilizar\00E1 el proxy de instancia &PRODUCT_NAME. cuando se haya definido.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6817733213316837.4001)
,p_name=>'P1962_CREDENTIAL_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2072305345128155.4001)
,p_prompt=>'Credencial web'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica las credenciales web que se deben utilizar al refrescar un cat\00E1logo. Util\00EDcelas si la URL de punto final refrescada necesita autenticaci\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1467864783002248.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1962_INTERNAL_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P1962_INTERNAL_NAME) '
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6814486012316804.4001)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id   != :P1962_ID',
'   and name  = :P1962_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# debe ser exclusiva en el espacio de trabajo.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(2073475059128195.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1467781037002247.4001)
,p_validation_name=>'Internal Name must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id            != :P1962_ID',
'   and internal_name  = :P1962_INTERNAL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# debe ser exclusiva en el espacio de trabajo.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(6177863288901829.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1503228722184420.4001)
,p_validation_name=>'URL must start with HTTP or HTTPS'
,p_validation_sequence=>30
,p_validation=>':P1962_ENDPOINT_URL like ''http://%'' or :P1962_ENDPOINT_URL like ''https://%'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# debe comenzar con http:// o https://'
,p_validation_condition=>'P1962_ENDPOINT_URL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(2078591107128229.4001)
,p_associated_item=>wwv_flow_api.id(6817437956316834.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2076687109128212.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2076549350128212.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2077411694128219.4001)
,p_event_id=>wwv_flow_api.id(2076687109128212.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1501864116184406.4001)
,p_name=>'Refresh URL entered'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1962_ENDPOINT_URL'
,p_condition_element=>'P1962_ENDPOINT_URL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1501946740184407.4001)
,p_event_id=>wwv_flow_api.id(1501864116184406.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_ID,P1962_PROXY_SERVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502013735184408.4001)
,p_event_id=>wwv_flow_api.id(1501864116184406.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_ID,P1962_PROXY_SERVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1503096295184418.4001)
,p_event_id=>wwv_flow_api.id(1501864116184406.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_ID,P1962_PROXY_SERVER,P1962_CREDENTIAL_TYPE,P1962_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1502130587184409.4001)
,p_name=>'Credential chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1962_CREDENTIAL_ID'
,p_condition_element=>'P1962_CREDENTIAL_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502286633184410.4001)
,p_event_id=>wwv_flow_api.id(1502130587184409.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select authentication_type',
'  from wwv_credentials',
' where id                = :P1962_CREDENTIAL_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P1962_CREDENTIAL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502371589184411.4001)
,p_event_id=>wwv_flow_api.id(1502130587184409.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502810012184416.4001)
,p_event_id=>wwv_flow_api.id(1502130587184409.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502935295184417.4001)
,p_event_id=>wwv_flow_api.id(1502130587184409.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1502523911184413.4001)
,p_name=>'OAuth Creds'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1962_CREDENTIAL_TYPE'
,p_condition_element=>'P1962_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502678639184414.4001)
,p_event_id=>wwv_flow_api.id(1502523911184413.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_TOKEN_SERVER_URL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1502798789184415.4001)
,p_event_id=>wwv_flow_api.id(1502523911184413.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_TOKEN_SERVER_URL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2601039387934110.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear References when deleting catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_web_src_catalog.clear_catalog_references(',
'        p_catalog_id => :P1962_ID',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2078172547128227.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2079612534128235.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(2072305345128155.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form REST Source Catalog Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han aplicado los cambios.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2080097315128237.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,CREATE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2079253647128233.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(2072305345128155.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form REST Source Catalog Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01963
begin
wwv_flow_api.create_page(
 p_id=>1963.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Servicios de cat\00E1logo REST')
,p_alias=>'REST-CATALOG-SERVICES'
,p_step_title=>unistr('Servicios de cat\00E1logo REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/font-apex/2.2/css/font-apex.min.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.xa-CardView-icon.fa, .a-CardView-icon.fa.fa-lg, .a-CardView-icon.a-Icon {font-size: 32px}',
'.xa-CardView-icon {padding:0}',
'.xa-CardView-body {padding-top:0}'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2717167025216206.4001)
,p_plug_name=>unistr('Servicios de cat\00E1logo')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6178169545901832.4001)
,p_plug_name=>'Catalog Services IG'
,p_region_name=>'issues'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( ',
'                      cs.details_json,',
'                      ''$.operations[*]''',
'                      columns ( operation varchar2(255) path ''$.operation'' ) ) op',
'     where cs.catalog_id        = :P1963_CATALOG_ID',
'       and cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by cs.id ',
')',
'select cs.id, ',
'       wwv_flow_page_api.get_url(p_page=>1964, p_items=>''P1964_ID'', p_values=>cs.id) as service_link, ',
'       cs.name, ',
'       cs.description,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')    || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')   || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as labels_html',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so',
' where so.id                = cs.id',
'   and cs.catalog_id        = :P1963_CATALOG_ID',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Servicios IG'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6178303295901834.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Identificador'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>10
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6178465520901835.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:1964:&SESSION.::&DEBUG.:1964:P1964_ID:&ID.'
,p_link_text=>'&NAME.'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6178668784901837.4001)
,p_name=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DESCRIPTION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Descripci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6179085334901841.4001)
,p_name=>'LABELS_HTML'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LABELS_HTML'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HTML_EXPRESSION'
,p_heading=>'Operaciones'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'&LABELS_HTML.'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6179428958901845.4001)
,p_name=>'SERVICE_LINK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SERVICE_LINK'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Enlace al servicio'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(6178257653901833.4001)
,p_internal_uid=>6178257653901833
,p_is_editable=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>unistr('No hay ning\00FAn servicio definido para este cat\00E1logo.')
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>true
,p_icon_view_use_custom=>true
,p_icon_view_custom=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-ContentRowReport-item" data-id="&APEX$ROW_ID.">',
'  <div class="a-ContentRowReport-itemWrap">',
'    <div class="a-ContentRowReport-itemSelection"><span class="u-selector"></span></div>',
'    <!-- div class="a-ContentRowReport-itemIconWrap"><span class="a-CardView-icon u-color &ICON. fa fa-lg fa-apex" aria-hidden="true" title=""></span></div -->',
'    <div class="a-ContentRowReport-itemBody">',
'      <div class="a-ContentRowReport-itemContent">',
'        <h3 class="a-ContentRowReport-itemTitle" id="label_&ID."><a href="&SERVICE_LINK.">&NAME.</a></h3>',
'        <div class="a-ContentRowReport-itemDescription">&DESCRIPTION.</div><div class="a-ContentRowReport-itemDescription">&LABELS_HTML.</div>',
'      </div>',
'      <div class="a-ContentRowReport-itemMisc"><span class="a-User a-User--more" title="&MORE_ASSIGNEES. other assignees"><span class="a-User-initials" role="presentation">&MORE_ASSIGNEES.</span></span></div>',
'      <div class="a-ContentRowReport-itemActions"></div>',
'    </div>',
'  </div>',
'</li>',
''))
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'//',
'// this code was borrowed from Team Development Page 1',
'// ',
'function (options) {',
'/*',
'    // the following code adds an "update" menu after the "actions" menu of the IG toolbar',
'    var $ = apex.jQuery,',
'        toolbarData = $.apex.interactiveGrid.copyDefaultToolbar();',
'',
'    toolbarData.toolbarInsertAfter( "actions_button", {',
'       type: "MENU",',
'       labelKey: "APEX.ISSUES.UPDATE_MENU",',
'       id: "multi_edit_issues",',
'       menu: {',
'           items: [',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.STATUS",',
'                   action:   "open-status-dialog"',
'               },',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.ASSIGNEES",',
'                   action:   "open-assignees-dialog"',
'               },',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.LABELS",',
'                   action:   "open-labels-dialog"',
'               },',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.MILESTONES",',
'                   action:   "open-milestones-dialog"',
'               }',
'           ]',
'       }',
'    });',
'    ',
'    options.toolbarData = toolbarData;',
'*/',
'',
'    // don''t want single row view',
'    apex.util.getNestedObject(options, "views.grid.features").singleRowView = false;',
'',
'    options.defaultIconViewOptions = {',
'        collectionClasses: "a-ContentRowReport a-IssueList",',
'        iconListOptions: {',
'            navigation: false,',
'            tabbableContent: "a"',
'            // comes from row selector when navigation is false',
'            // multiple: true ',
'            // itemSelector: true',
'        }',
'    };',
'',
'    function checkOpen(dialogId) {',
'        if (getSelectedIds()) {',
'            apex.theme.openRegion(dialogId);',
'        } else {',
'            apex.theme.openRegion("noSelectionDialog");',
'        }',
'        return true; // setting focus',
'    }',
'',
'    //',
'    // Actions ',
'    //',
'    options.initActions = function(actions) {',
'',
'        // this changes the iconView button into a details view button. ',
'        // there is a details view option. Not sure why this was necessary. ',
'        // perhaps the feature didn''t exist at the time.',
'        var ig$ = $(actions.context),',
'            iconView = ig$.interactiveGrid("getViews").icon;',
'',
'        iconView.title = apex.lang.getMessage( "APEX.ISSUES.CARDS"); ',
'        iconView.icon = "icon-ig-details";',
'',
'        // this adds keyboard actions to open various dialogs that are not necessary for catalogs.',
'        /* ',
'        actions.add([',
'            {name: "open-status-dialog",',
'            shortcut: "Ctrl+/,S",',
'            action: function (event, elm) {',
'                return checkOpen("statusDialog");',
'            }},',
'            {name: "open-assignees-dialog",',
'            shortcut: "Ctrl+/,A",',
'            action: function (event, elm) {',
'                return checkOpen("assignDialog");',
'            }},',
'            {name: "open-labels-dialog",',
'            shortcut: "Ctrl+/,L",',
'            action: function (event, elm) {',
'                return checkOpen("labelDialog");',
'            }},',
'            {name: "open-milestones-dialog",',
'            shortcut: "Ctrl+/,M",',
'            action: function (event, elm) {',
'                return checkOpen("milestoneDialog");',
'            }}',
'        ]);',
'        */',
'    };',
'',
'    return options;',
'}'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(97466518640657800.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(3816997850663267.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101294189288865252.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Revise los servicios proporcionados por el cat\00E1logo.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2717586700216210.4001)
,p_name=>'P1963_CATALOG_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2717167025216206.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6178999113901840.4001)
,p_name=>'P1963_CATALOG_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6178169545901832.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4003903902287607.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Catalog Name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'into :P1963_CATALOG_NAME',
'from wwv_web_src_catalogs ',
'where id = :P1963_CATALOG_ID',
'and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01964
begin
wwv_flow_api.create_page(
 p_id=>1964.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Servicio de cat\00E1logo de origen de REST')
,p_alias=>'REST-SOURCE-CATALOG-SERVICE'
,p_step_title=>unistr('Servicio de cat\00E1logo de origen de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1504384803184431.4001)
,p_name=>unistr('Or\00EDgenes de REST basados en este servicio')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--horizontalBorders:a-Report--stretch'
,p_region_attributes=>'style="margin-top: 20px;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.flow_id                       as rest_app_id,',
'       m.id                            as rest_source_id,',
'       f.name                          as application_name,',
'       m.name, ',
'       r.base_url || m.url_path_prefix as url,',
'       m.last_refreshed',
'  from wwv_flow_web_src_modules m,',
'       wwv_web_src_catalogs     c,',
'       wwv_remote_servers       r,',
'       wwv_flows                f',
' where c.internal_name        = m.catalog_internal_name',
'   and c.security_group_id    = :WORKSPACE_ID',
'   and r.id                   = m.remote_server_id',
'   and r.security_group_id    = :WORKSPACE_ID',
'   and m.security_group_id    = :WORKSPACE_ID',
'   and m.catalog_service_name = :P1964_NAME',
'   and f.id                   = m.flow_id',
'   and f.security_group_id    = :WORKSPACE_ID',
'   and c.id                   = :P1964_CATALOG_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1964_NAME,P1964_CATALOG_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha creado ning\00FAn origen de REST en este servicio de cat\00E1logo.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1505336684184441.4001)
,p_query_column_id=>1
,p_column_alias=>'REST_APP_ID'
,p_column_display_sequence=>20
,p_column_heading=>unistr('ID de aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1505240243184440.4001)
,p_query_column_id=>2
,p_column_alias=>'REST_SOURCE_ID'
,p_column_display_sequence=>10
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1504942142184437.4001)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>30
,p_column_heading=>unistr('Nombre de aplicaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1504478137184432.4001)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Nombre de origen de REST'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RR,1921:P1921_FLOW_ID,P1921_WEB_SRC_MODULE_ID,FB_FLOW_ID:#REST_APP_ID#,#REST_SOURCE_ID#,#REST_APP_ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1504867076184436.4001)
,p_query_column_id=>5
,p_column_alias=>'URL'
,p_column_display_sequence=>50
,p_column_heading=>'URL de Punto Final'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1504690393184434.4001)
,p_query_column_id=>6
,p_column_alias=>'LAST_REFRESHED'
,p_column_display_sequence=>60
,p_column_heading=>unistr('\00DAltimo Refrescamiento')
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1505148644184439.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2093075006067377.4001)
,p_plug_name=>'Detalles de servicio'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOG_SERVICES'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2982252962967539.4001)
,p_plug_name=>'Operaciones y perfil de datos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2981074726967527.4001)
,p_name=>'Perfil de Datos'
,p_parent_plug_id=>wwv_flow_api.id(2982252962967539.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.name,',
'       col.data_type || case when col.data_type = ''VARCHAR2'' then '' ('' || nvl(col.max_length, 4000) || '')'' end as data_type,',
'       col.is_primary_key,',
'       col.sequence',
'  from wwv_web_src_catalog_services cs, ',
'       json_table( cs.details_json,',
'                   ''$.data_profile.columns[*]''',
'                   columns (',
'                             name           varchar2(255) path ''$.name'',',
'                             data_type      varchar2(255) path ''$.data_type'',',
'                             max_length     number        path ''$.max_length'',',
'                             is_primary_key varchar2(255) path ''$.is_primary_key'',',
'                             sequence       number        path ''$.sequence'' ) ) col',
' where cs.security_group_id = :WORKSPACE_ID',
'   and cs.id                = :P1964_ID ',
'   and cs.catalog_id        = :P1964_CATALOG_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1964_ID,P1964_CATALOG_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981133291967528.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Nombre de columna de perfil de datos'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981256393967529.4001)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>30
,p_column_heading=>'Tipo de Dato'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981413795967531.4001)
,p_query_column_id=>3
,p_column_alias=>'IS_PRIMARY_KEY'
,p_column_display_sequence=>50
,p_column_heading=>'Clave Primaria'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981513074967532.4001)
,p_query_column_id=>4
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>10
,p_default_sort_column_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2981695214967533.4001)
,p_name=>'Operaciones'
,p_parent_plug_id=>wwv_flow_api.id(2982252962967539.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select op.operation,',
'       op.database_operation,',
'       op.url_pattern',
'  from wwv_web_src_catalog_services cs, ',
'       json_table( cs.details_json,',
'                   ''$.operations[*]''',
'                   columns (',
'                             operation               varchar2(255) path ''$.operation'',',
'                             database_operation      varchar2(255) path ''$.database_operation'',',
'                             url_pattern             varchar2(255) path ''$.url_pattern'' ) ) op',
' where cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and cs.id                = :P1964_ID ',
'   and cs.catalog_id        = :P1964_CATALOG_ID',
'',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1964_ID,P1964_CATALOG_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981784082967534.4001)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>20
,p_column_heading=>unistr('M\00E9todo HTTP')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981848108967535.4001)
,p_query_column_id=>2
,p_column_alias=>'DATABASE_OPERATION'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Acci\00F3n de Base de Datos')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(225834585600778166)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2981912112967536.4001)
,p_query_column_id=>3
,p_column_alias=>'URL_PATTERN'
,p_column_display_sequence=>30
,p_column_heading=>unistr('Patr\00F3n de URL')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(103936501160649209.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los datos descriptivos de un servicio de cat\00E1logo pueden editarse. Introduzca un t\00EDtulo y una descripci\00F3n para ayudar a los desarrolladores a determinar el objetivo del servicio.</p>'),
unistr('<p>Otros detalles como los perfiles de datos, operaciones, par\00E1metros, etc. se editan a trav\00E9s de la definici\00F3n original del origen de datos de REST.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2107055731067452.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2107898099067458.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\00BFSuprimir este servicio?'),
''))
,p_confirm_style=>'danger'
,p_button_condition=>'P1964_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2108235893067460.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P1964_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2108652966067462.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P1964_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2717833693216213.4001)
,p_branch_name=>'Go to Page 1960'
,p_branch_action=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:1960::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2107898099067458.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2108905584067462.4001)
,p_branch_name=>'Go To Page 1963'
,p_branch_action=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'SAVE,CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1505437700184442.4001)
,p_name=>'P1964_SOURCE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>'Tipo de origen de REST'
,p_source=>'PLUGIN_INTERNAL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEB_SOURCE_MODULE_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_display_when=>':P1964_SOURCE_TYPE like ''NATIVE%'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Tipo de origen de datos de REST.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1946929175091106.4001)
,p_name=>'P1964_SOURCE_TYPE_PLUGIN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>'Tipo de origen de REST'
,p_source=>'Plug-In'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>':P1964_SOURCE_TYPE not like ''NATIVE%'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Tipo de origen de datos de REST.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2093442129067380.4001)
,p_name=>'P1964_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2093888462067393.4001)
,p_name=>'P1964_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2094238447067400.4001)
,p_name=>'P1964_CATALOG_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_source=>'CATALOG_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2094668440067401.4001)
,p_name=>'P1964_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Los nombres de servicio deben ser \00FAnicos en cada cat\00E1logo de origen de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2095067774067403.4001)
,p_name=>'P1964_ICON'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>'Icono'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:1967:&SESSION.::&DEBUG.::P1967_RETURN_ITEM:P1964_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>',
''))
,p_source=>'ICON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2095462978067404.4001)
,p_name=>'P1964_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Proporcione una descripci\00F3n para este servicio.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2095892244067405.4001)
,p_name=>'P1964_BASE_URL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>'URL Base'
,p_source=>'BASE_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Este atributo determinar\00E1 el objeto de <em>Servidor remoto</em> cuando se creen nuevos or\00EDgenes de datos de REST desde el cat\00E1logo.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2096291242067405.4001)
,p_name=>'P1964_SERVICE_PATH'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>'Ruta de acceso al servicio'
,p_source=>'SERVICE_PATH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Parte <em>espec\00EDfica del servicio</em> de la URL de origen de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2096606413067407.4001)
,p_name=>'P1964_AUTH_SERVER_BASE_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>unistr('URL base de servidor de autenticaci\00F3n')
,p_source=>'AUTH_SERVER_BASE_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_display_when=>'P1964_AUTHENTICATION_TYPE'
,p_display_when2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('<strong>URL base</strong> del servidor de autenticaci\00F3n (<em>Servidor de token</em>) para el origen de datos de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2097052022067407.4001)
,p_name=>'P1964_AUTH_SERVER_URL_PATH'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>unistr('Ruta de acceso a la URL del servidor de autenticaci\00F3n')
,p_source=>'AUTH_SERVER_URL_PATH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_display_when=>'P1964_AUTHENTICATION_TYPE'
,p_display_when2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('<strong>Ruta de acceso de URL</strong> del servidor de autenticaci\00F3n (<em>Servidor de token</em>) para el origen de datos de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2097407377067409.4001)
,p_name=>'P1964_PLUGIN_INTERNAL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_source=>'PLUGIN_INTERNAL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2097840692067411.4001)
,p_name=>'P1964_AUTHENTICATION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_display_when=>'P1964_AUTHENTICATION_TYPE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se crear\00E1 una credencial vac\00EDa de este tipo cuando se cree un origen de datos de REST en el cat\00E1logo. Se deben proporcionar el nombre y el secreto de credencial.')
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2099008057067416.4001)
,p_name=>'P1964_LAST_IMPORTED_AT'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2093075006067377.4001)
,p_prompt=>unistr('Fecha de la \00FAltima importaci\00F3n')
,p_format_mask=>'SINCE'
,p_source=>'LAST_IMPORTED_AT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6814116013316801.4001)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_web_src_catalog_services cs',
'where cs.security_group_id = :WORKSPACE_ID',
'and cs.catalog_id = :P1964_CATALOG_ID',
'and cs.id != nvl(:P1964_ID, 0)',
'and cs.name = :P1964_NAME;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre debe ser exclusivo en el cat\00E1logo')
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(2094668440067401.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1503996366184427.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear References before Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_web_src_catalog.clear_catalog_references(',
'        p_catalog_id => :P1964_CATALOG_ID,',
'        p_service_id => :P1964_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2107898099067458.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2109810599067472.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(2093075006067377.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form REST Catalog Service Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2109438564067470.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(2093075006067377.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form REST Catalog Service Details'
);
end;
/
prompt --application/pages/page_01965
begin
wwv_flow_api.create_page(
 p_id=>1965.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Exportar cat\00E1logo de origen de REST')
,p_alias=>'EXPORT-REST-SOURCE-CATALOG'
,p_step_title=>unistr('Exportar cat\00E1logo de origen de REST')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34199576705245056.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34199976499245057.4001)
,p_plug_name=>unistr('Exportar cat\00E1logo')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34200362051245057.4001)
,p_plug_name=>unistr('Exportar cat\00E1logo')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice esta p\00E1gina para exportar un cat\00E1logo de origen de REST. Una vez exportado, se puede importar en cualquier espacio de trabajo.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(172597665096943717.4001)
,p_plug_name=>unistr('Exportar cat\00E1logo de origen de REST')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3738482091982497.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(172597665096943717.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3738807529982498.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(172597665096943717.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:1965::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3735124868982490.4001)
,p_name=>'P1965_CATALOG_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(34199976499245057.4001)
,p_prompt=>unistr('Cat\00E1logo de origen de REST')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_web_src_catalogs',
' where security_group_id = :WORKSPACE_ID',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar un cat\00E1logo -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el cat\00E1logo que se va a exportar.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3736903539982493.4001)
,p_name=>'P1965_FILE_CHAR_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(34199976499245057.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Caracteres de Archivo:'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado.')
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3740743306982533.4001)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1965_A'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3741289411982535.4001)
,p_event_id=>wwv_flow_api.id(3740743306982533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1965_SELECTED_APPLICATION'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret    varchar(255);',
'begin',
'   select max(name) into l_ret',
'     from wwv_flows ',
'     where id = nvl(:P1965_A,0) ',
'   and security_group_id = :flow_security_group_id;',
'   return l_ret;',
'end;'))
,p_attribute_07=>'P1965_A'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3741729180982539.4001)
,p_event_id=>wwv_flow_api.id(3740743306982533.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1965_PLUGIN_COUNT'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret  number;',
'begin',
'   select count(*) c into l_ret ',
'     from WWV_FLOW_PLUGINS ',
'    where flow_id = nvl(:P1965_A,0) ',
'    and security_group_id = :flow_security_group_id;',
'   return l_ret;',
'end;'))
,p_attribute_07=>'P1965_A'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3742187237982539.4001)
,p_name=>'Submit'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3738482091982497.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3742608656982539.4001)
,p_event_id=>wwv_flow_api.id(3742187237982539.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3740492580982531.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_web_src_catalog.export_catalog(',
'    p_catalog_id => :P1965_CATALOG_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fallo de exportaci\00F3n de cat\00E1logo.')
,p_process_when_button_id=>wwv_flow_api.id(3738482091982497.4001)
,p_process_success_message=>unistr('Cat\00E1logo exportado')
);
end;
/
prompt --application/pages/page_01966
begin
wwv_flow_api.create_page(
 p_id=>1966.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Importar cat\00E1logo REST')
,p_alias=>'IMPORT-REST-CATALOG'
,p_step_title=>unistr('Importar cat\00E1logo REST')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1465142751002221.4001)
,p_plug_name=>unistr('El cat\00E1logo ya existe')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('<p>El archivo de importaci\00F3n contiene un cat\00E1logo con el nombre <strong>&P1966_EXISTING_CATALOG_NAME!HTML.</strong>, que ya existe en el espacio de trabajo. Si contin\00FAa con la importaci\00F3n, el cat\00E1logo de origen de REST existente se sustituir\00E1.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_web_src_catalog.catalog_exists( :P1966_FILE_ID )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212171192300966644.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476721091701007198.4001)
,p_plug_name=>unistr('Archivo no V\00E1lido')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('El archivo importado no es un &PRODUCT_NAME. v\00E1lido. Exportaci\00F3n de cat\00E1logo de origen de REST.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476721281951007200.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476721496008007201.4001)
,p_plug_name=>unistr('Importar cat\00E1logo REST')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(751168206714473129.4001)
,p_plug_name=>unistr('Importar cat\00E1logo REST')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4021888407334980.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(212171192300966644.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4022297156334981.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(212171192300966644.4001)
,p_button_name=>'IMPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Importar cat\00E1logo REST')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4027937002335026.4001)
,p_branch_name=>'Go To Page 1960'
,p_branch_action=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4022297156334981.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465303439002223.4001)
,p_name=>'P1966_EXISTING_CATALOG_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(476721496008007201.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2717702711216212.4001)
,p_name=>'P1966_GROUP_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(476721496008007201.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'              select name as dv, ',
'                     name as rv',
'                from wwv_web_src_catalog_groups',
'               where security_group_id = :WORKSPACE_ID',
'               order by name )',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>unistr('Grupo de cat\00E1logo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, ',
'       name as rv',
'  from wwv_web_src_catalog_groups',
' where security_group_id = :WORKSPACE_ID',
' order by name'))
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un grupo de cat\00E1logo para organizar cat\00E1logos.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2858280615881131.4001)
,p_name=>'P1966_NEW_GROUP_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(476721496008007201.4001)
,p_prompt=>unistr('Grupo de cat\00E1logo')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_web_src_catalog_groups',
'where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Los cat\00E1logos se organizan en <em>Grupos</em>. Como su espacio de trabajo a\00FAn no contiene grupos de cat\00E1logo, deber\00E1 proporcionar un nombre para el nuevo grupo que se cree.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4023938922334993.4001)
,p_name=>'P1966_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(476721496008007201.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4024333787334996.4001)
,p_name=>'P1966_FEEDBACK_ORIGIN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(476721496008007201.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de cat\00E1logo de REST:')
,p_source=>'wwv_flow_imp_parser.get_rest_catalog_name(:p1966_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el nombre del cat\00E1logo de REST que se ha exportado.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4025106188335006.4001)
,p_name=>'P1966_VERSION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(476721496008007201.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p1966_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo de exportaci\00F3n.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1465292170002222.4001)
,p_computation_sequence=>10
,p_computation_item=>'P1966_EXISTING_CATALOG_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_imp_parser.get_rest_catalog_name( :P1966_FILE_ID )'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4026728745335019.4001)
,p_validation_name=>'check export file version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p1966_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de &PRODUCT_NAME.)')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4027100520335020.4001)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo importado no es un &PRODUCT_NAME. v\00E1lido. Exportaci\00F3n de cat\00E1logo de origen de REST.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4027476159335021.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_web_src_catalog.import_catalog (',
'        p_group_name     => nvl(:P1966_NEW_GROUP_NAME, :P1966_GROUP_NAME),     ',
'        p_export_file_id => :P1966_FILE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al importar el cat\00E1logo de origen de REST.')
,p_process_when_button_id=>wwv_flow_api.id(4022297156334981.4001)
,p_process_success_message=>unistr('Cat\00E1logo de origen de REST importado.')
);
end;
/
prompt --application/pages/page_01967
begin
wwv_flow_api.create_page(
 p_id=>1967.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Refrescar cat\00E1logo de origen de REST')
,p_alias=>'REFRESH-REST-SOURCE-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Refrescar cat\00E1logo de origen de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3965103871098186.4001)
,p_plug_name=>unistr('Detalles de Cat\00E1logo')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Los cambios que haya hecho de manera local se perder\00E1n. Confirme que desea refrescar el cat\00E1logo de origen de REST.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3970912551098312.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1919245276109873.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(3970912551098312.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1920033366109876.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3970912551098312.4001)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Refrescar Cat\00E1logo')
,p_button_position=>'NEXT'
,p_button_condition=>'P1967_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1926773452132408.4001)
,p_branch_name=>'Goto 1963'
,p_branch_action=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1503148428184419.4001)
,p_name=>'P1967_ENDPOINT_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_item_source_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_prompt=>'Refrescar desde URL'
,p_source=>'ENDPOINT_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1911593255109861.4001)
,p_name=>'P1967_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_item_source_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1911942607109863.4001)
,p_name=>'P1967_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_item_source_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1926069115132401.4001)
,p_name=>'P1967_LAST_IMPORTED_AT'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_item_source_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_prompt=>unistr('Fecha de la \00FAltima importaci\00F3n')
,p_format_mask=>'SINCE'
,p_source=>'LAST_IMPORTED_AT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6819031627316850.4001)
,p_name=>'P1967_VERSION'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_item_source_plug_id=>wwv_flow_api.id(3965103871098186.4001)
,p_prompt=>unistr('Versi\00F3n')
,p_source=>'VERSION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1967_VERSION'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1922060149109900.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1919245276109873.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1922562852109903.4001)
,p_event_id=>wwv_flow_api.id(1922060149109900.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1926613749132407.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Catalog'
,p_process_sql_clob=>'wwv_web_src_catalog.refresh_catalog(:P1967_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1920033366109876.4001)
,p_process_success_message=>unistr('Se ha refrescado el cat\00E1logo de origen de REST.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1918106204109871.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(3965103871098186.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Catalog Group Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_01968
begin
wwv_flow_api.create_page(
 p_id=>1968.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Grupos de cat\00E1logo de origen de REST')
,p_alias=>'REST-SOURCE-CATALOG-GROUPS'
,p_step_title=>unistr('Grupos de cat\00E1logo de origen de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3811862513186082.4001)
,p_plug_name=>unistr('Grupos de cat\00E1logo de origen de REST')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.id, ',
'       g.name, ',
'       g.description, count(c.id) as catalog_count',
'  from wwv_web_src_catalog_groups g,',
'       wwv_web_src_catalogs       c',
' where g.id                = c.catalog_group_id (+)',
'   and g.security_group_id = :WORKSPACE_ID',
' group by g.id, g.name, g.description'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Grupos de cat\00E1logo de origen de REST')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3812278197186083.4001)
,p_name=>'Report 1'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'DBLISS'
,p_internal_uid=>3812278197186083
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3812332130186088.4001)
,p_db_column_name=>'ID'
,p_display_order=>0
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3813105390186102.4001)
,p_db_column_name=>'NAME'
,p_display_order=>10
,p_column_identifier=>'C'
,p_column_label=>'Nombre de Grupo'
,p_column_link=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:1961:P1961_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3813569911186103.4001)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>unistr('Descripci\00F3n')
,p_allow_sorting=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2983039164967547.4001)
,p_db_column_name=>'CATALOG_COUNT'
,p_display_order=>40
,p_column_identifier=>'E'
,p_column_label=>unistr('Recuento de cat\00E1logos')
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(101383551120726227.4001)
,p_plug_name=>'Acerca de'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice los grupos de cat\00E1logo para organizar los cat\00E1logos en categor\00EDas.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3814992301186107.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3811862513186082.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Grupo'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:1961::'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3813973549186104.4001)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(3811862513186082.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3814424992186106.4001)
,p_event_id=>wwv_flow_api.id(3813973549186104.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3811862513186082.4001)
);
end;
/
prompt --application/pages/page_02100
begin
wwv_flow_api.create_page(
 p_id=>2100.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Objetos de Soporte')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Objetos de Soporte')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37335308785486103.4001)
,p_plug_name=>'Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37444308948836210.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186903532355527837.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(210427823130821687.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747147601400138176.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37335708938486106.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186903532355527837.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37336001160486106.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186903532355527837.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11348931511909152.4001)
,p_branch_action=>'f?p=&APP_ID.:2115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P2100_AVAILABLE_SPACE||:P2100_PRIV_ERROR||:P2100_ERROR is not null'
,p_branch_condition_text=>'SQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37336307162486109.4001)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
'where license_message is not null',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3256723713962127.4001)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13610511055251610.4001)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
,p_branch_sequence=>60
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13612312571261528.4001)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13575105664060846.4001)
,p_branch_action=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15492604582376837.4001)
,p_branch_action=>'f?p=&APP_ID.:2140:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2100_ACTION'
,p_branch_condition_text=>'N'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37335505075486105.4001)
,p_name=>'P2100_WELCOME_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(WELCOME_MESSAGE,',
'              null, wwv_flow_lang.system_message(''INSTALLER.WELCOME_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(WELCOME_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37352005757579887.4001)
,p_name=>'P2100_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_item_default=>'Y'
,p_prompt=>'Instalar Objetos de Soporte:'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Se ha instalado esta definici\00F3n de aplicaci\00F3n, aunque puede que no se hayan creado a\00FAn los objetos de base de datos, las im\00E1genes y los datos iniciales. Seleccione <strong>Activado</strong> para continuar e instalar estos objetos de soporte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37449904362853816.4001)
,p_name=>'P2100_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38881611317544045.4001)
,p_name=>'P2100_PARSING_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis:')
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica el esquema que se utilizar\00E1 para analizar y ejecutar todo el c\00F3digo SQL de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38993601601790274.4001)
,p_name=>'P2100_ERROR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39398131871551592.4001)
,p_name=>'P2100_AVAILABLE_SPACE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39510309884283270.4001)
,p_name=>'P2100_FREE_SPACE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espacio Libre Necesario en KB:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G999G990'') free_kb from wwv_flow_install ',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El siguiente espacio libre debe estar disponible en el tablespace por defecto del esquema de an\00E1lisis.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39517702125545937.4001)
,p_name=>'P2100_PRIV_ERROR'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(219193601192672275.4001)
,p_name=>'P2100_CANCEL_PAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(37335308785486103.4001)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(224758831562879992.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2100_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl(:P2100_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(39014925514948540.4001)
,p_validation_name=>'application exists'
,p_validation_sequence=>10
,p_validation=>'select 1 from wwv_flows where id = :fb_flow_id'
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La aplicaci\00F3n debe estar instalada.')
,p_when_button_pressed=>wwv_flow_api.id(37336001160486106.4001)
,p_associated_item=>wwv_flow_api.id(37449904362853816.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(38889903062645790.4001)
,p_validation_name=>'validate schema'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r boolean := false;',
'begin',
'  for c1 in (select owner from wwv_flows where id = :fb_flow_id) loop',
'    r := wwv_flow_security.current_company_can_build(p_in_schema=>c1.owner);',
'  end loop;',
'  return r;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'No tiene privilegios para analizar como el esquema identificado.'
,p_when_button_pressed=>wwv_flow_api.id(37336001160486106.4001)
,p_associated_item=>wwv_flow_api.id(38881611317544045.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(211565610847095075.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check objects'
,p_process_sql_clob=>':P2100_ERROR := wwv_flow_install_wizard.get_existing_objects(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(211573414535162346.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'system privs'
,p_process_sql_clob=>':P2100_PRIV_ERROR := wwv_flow_install_wizard.get_missing_privs(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(211578026918184866.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'free space'
,p_process_sql_clob=>':P2100_AVAILABLE_SPACE := wwv_flow_install_wizard.get_free_space(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(37336001160486106.4001)
);
end;
/
prompt --application/pages/page_02101
begin
wwv_flow_api.create_page(
 p_id=>2101.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Aceptaci\00F3n de la Licencia')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Aceptaci\00F3n de la Licencia')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37336800919486110.4001)
,p_plug_name=>unistr('Aceptaci\00F3n de la Licencia')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37442730288832905.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186905023266544144.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(211993612959566850.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747147700038138176.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37337207622486111.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186905023266544144.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37337529228486111.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186905023266544144.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37337415093486111.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186905023266544144.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37338113556486113.4001)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37337529228486111.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13651814892479845.4001)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37337529228486111.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13653026666483211.4001)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37337529228486111.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13653630822484402.4001)
,p_branch_action=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37337529228486111.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37337801829486112.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37337415093486111.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37337013732486110.4001)
,p_name=>'P2101_LICENSE_TERMS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37336800919486110.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags(LICENSE_MESSAGE) ',
'  from WWV_FLOW_INSTALL where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37358004418607878.4001)
,p_name=>'P2101_ACCEPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(37336800919486110.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NOT_ACCEPTED'
,p_prompt=>'Aceptar'
,p_source=>'NOT_ACCEPTED'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DEPLOYMENT LICENSE ACCEPTANCE'
,p_lov=>'.'||wwv_flow_api.id(110337521891120166.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(37400015472734017.4001)
,p_validation_name=>'P2101_ACCEPT'
,p_validation_sequence=>10
,p_validation=>'P2101_ACCEPT'
,p_validation2=>'ACCEPTED'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Debe aceptar los t\00E9rminos de la licencia para continuar. De lo contrario, haga clic en Cancelar.')
,p_associated_item=>wwv_flow_api.id(37358004418607878.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02102
begin
wwv_flow_api.create_page(
 p_id=>2102.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Validaciones Previas a la Instalaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Validaciones Previas a la Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37338604142486113.4001)
,p_plug_name=>unistr('Validaciones Previas a la Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<ul>'');',
'for c1 in (select name ',
'             from wwv_flow_install_checks ',
'            where flow_id = :FB_FLOW_ID ',
'            order by sequence)',
'loop',
'  sys.htp.p(''<li>''||wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37445929380842126.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186906420412562271.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212006229367581056.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747147890157138176.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37339004379486114.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186906420412562271.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37339319482486114.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186906420412562271.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37339225015486114.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186906420412562271.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13758211568614355.4001)
,p_branch_action=>'f?p=&APP_ID.:2108:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37339319482486114.4001)
,p_branch_sequence=>21
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P2102_ERRORS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37339906531486116.4001)
,p_branch_action=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37339319482486114.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37339631448486115.4001)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37339225015486114.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13644722333444125.4001)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37339225015486114.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13645514845451434.4001)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37339225015486114.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13646119347452754.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37339225015486114.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(913812388092596.4001)
,p_name=>'P2102_VERIFICATION_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37338604142486113.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(VALIDATION_MESSAGE,',
'              null, wwv_flow_lang.system_message(''INSTALLER.VALIDATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(VALIDATION_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13756207281603606.4001)
,p_name=>'P2102_ERRORS'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(37338604142486113.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(13757116632606356.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2102_ERRORS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13754928275600277.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2102_ERRORS := wwv_flow_install_wizard.run_install_checks (',
'                     p_flow_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(37339319482486114.4001)
);
end;
/
prompt --application/pages/page_02103
begin
wwv_flow_api.create_page(
 p_id=>2103.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Cadenas de Sustituci\00F3n de Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Cadenas de Sustituci\00F3n de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37340424997486117.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_source=>'wwv_flow_install_wizard.configuration_options ( p_flow_id => :FB_FLOW_ID );'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37446331804842815.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206276406164792061.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212001628889571445.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747147948343138176.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37340814925486118.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206276406164792061.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37341119094486118.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206276406164792061.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37341002826486118.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206276406164792061.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37341719241486119.4001)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37341119094486118.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13636318000405090.4001)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37341119094486118.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13637223540406621.4001)
,p_branch_action=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37341119094486118.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37341429307486119.4001)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37341002826486118.4001)
,p_branch_sequence=>8
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8538614107560872.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37341002826486118.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8061331659257144.4001)
,p_name=>'P2103_SS_PROMPTS'
,p_item_sequence=>215
,p_item_plug_id=>wwv_flow_api.id(37340424997486117.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_ss_prompts wwv_flow_global.vc_arr2;',
'begin',
'  for c1 in (select prompt_substitution_01_yn p01,',
'                    prompt_substitution_02_yn p02,',
'                    prompt_substitution_03_yn p03,',
'                    prompt_substitution_04_yn p04,',
'                    prompt_substitution_05_yn p05,',
'                    prompt_substitution_06_yn p06,',
'                    prompt_substitution_07_yn p07,',
'                    prompt_substitution_08_yn p08,',
'                    prompt_substitution_09_yn p09,',
'                    prompt_substitution_10_yn p10,',
'                    prompt_substitution_11_yn p11,',
'                    prompt_substitution_12_yn p12,',
'                    prompt_substitution_13_yn p13,',
'                    prompt_substitution_14_yn p14,',
'                    prompt_substitution_15_yn p15,',
'                    prompt_substitution_16_yn p16,',
'                    prompt_substitution_17_yn p17,',
'                    prompt_substitution_18_yn p18,',
'                    prompt_substitution_19_yn p19,',
'                    prompt_substitution_20_yn p20',
'               from wwv_flow_install',
'              where flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id)',
'  loop',
'    if c1.p01 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''01''; end if;',
'    if c1.p02 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''02''; end if;',
'    if c1.p03 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''03''; end if;',
'    if c1.p04 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''04''; end if;',
'    if c1.p05 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''05''; end if;',
'    if c1.p06 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''06''; end if;',
'    if c1.p07 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''07''; end if;',
'    if c1.p08 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''08''; end if;',
'    if c1.p09 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''09''; end if;',
'    if c1.p10 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''10''; end if;',
'    if c1.p11 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''11''; end if;',
'    if c1.p12 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''12''; end if;',
'    if c1.p13 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''13''; end if;',
'    if c1.p14 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''14''; end if;',
'    if c1.p15 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''15''; end if;',
'    if c1.p16 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''16''; end if;',
'    if c1.p17 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''17''; end if;',
'    if c1.p18 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''18''; end if;',
'    if c1.p19 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''19''; end if;',
'    if c1.p20 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''20''; end if;',
'  end loop;',
'  return wwv_flow_utilities.table_to_string(l_ss_prompts);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8066726605340831.4001)
,p_name=>'P2103_SS_VALUES'
,p_item_sequence=>225
,p_item_plug_id=>wwv_flow_api.id(37340424997486117.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9953209124068431.4001)
,p_name=>'P2103_CONFIG_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37340424997486117.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(CONFIGURATION_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIGURATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(CONFIGURATION_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8066121410339320.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Substitution Strings'
,p_process_sql_clob=>':P2103_SS_VALUES := wwv_flow_utilities.table_to_string2(htmldb_application.g_f01);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(37341119094486118.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6643122210603401.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Sub Strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select substitution_value_01 sv01, install_prompt_01 ss01, ',
'                  substitution_value_02 sv02, install_prompt_02 ss02,',
'                  substitution_value_03 sv03, install_prompt_03 ss03,',
'                  substitution_value_04 sv04, install_prompt_04 ss04,',
'                  substitution_value_05 sv05, install_prompt_05 ss05,',
'                  substitution_value_06 sv06, install_prompt_06 ss06,',
'                  substitution_value_07 sv07, install_prompt_07 ss07,',
'                  substitution_value_08 sv08, install_prompt_08 ss08,',
'                  substitution_value_09 sv09, install_prompt_09 ss09,',
'                  substitution_value_10 sv10, install_prompt_10 ss10,',
'                  substitution_value_11 sv11, install_prompt_11 ss11,',
'                  substitution_value_12 sv12, install_prompt_12 ss12,',
'                  substitution_value_13 sv13, install_prompt_13 ss13,',
'                  substitution_value_14 sv14, install_prompt_14 ss14,',
'                  substitution_value_15 sv15, install_prompt_15 ss15,',
'                  substitution_value_16 sv16, install_prompt_16 ss16,',
'                  substitution_value_17 sv17, install_prompt_17 ss17,',
'                  substitution_value_18 sv18, install_prompt_18 ss18,',
'                  substitution_value_19 sv19, install_prompt_19 ss19,',
'                  substitution_value_20 sv20, install_prompt_20 ss20',
'             from wwv_flows, wwv_flow_install',
'            where wwv_flows.id = wwv_flow_install.flow_id',
'              and wwv_flows.id = :FB_FLOW_ID',
'              and wwv_flows.security_group_id = :flow_security_group_id)',
'loop',
'  :P2103_SUB_VALUE_01 := c1.sv01;',
'  :P2103_SUB_VALUE_02 := c1.sv02;  ',
'  :P2103_SUB_VALUE_03 := c1.sv03;',
'  :P2103_SUB_VALUE_04 := c1.sv04;',
'  :P2103_SUB_VALUE_05 := c1.sv05;',
'  :P2103_SUB_VALUE_06 := c1.sv06;',
'  :P2103_SUB_VALUE_07 := c1.sv07;',
'  :P2103_SUB_VALUE_08 := c1.sv08;',
'  :P2103_SUB_VALUE_09 := c1.sv09;',
'  :P2103_SUB_VALUE_10 := c1.sv10;',
'  :P2103_SUB_VALUE_11 := c1.sv11;',
'  :P2103_SUB_VALUE_12 := c1.sv12;',
'  :P2103_SUB_VALUE_13 := c1.sv13;',
'  :P2103_SUB_VALUE_14 := c1.sv14;',
'  :P2103_SUB_VALUE_15 := c1.sv15;',
'  :P2103_SUB_VALUE_16 := c1.sv16;',
'  :P2103_SUB_VALUE_17 := c1.sv17;',
'  :P2103_SUB_VALUE_18 := c1.sv18;',
'  :P2103_SUB_VALUE_19 := c1.sv19;',
'  :P2103_SUB_VALUE_20 := c1.sv20;',
'  :P2103_SUB_STRING_01 := c1.ss01;',
'  :P2103_SUB_STRING_02 := c1.ss02;  ',
'  :P2103_SUB_STRING_03 := c1.ss03;',
'  :P2103_SUB_STRING_04 := c1.ss04;',
'  :P2103_SUB_STRING_05 := c1.ss05;',
'  :P2103_SUB_STRING_06 := c1.ss06;',
'  :P2103_SUB_STRING_07 := c1.ss07;',
'  :P2103_SUB_STRING_08 := c1.ss08;',
'  :P2103_SUB_STRING_09 := c1.ss09;',
'  :P2103_SUB_STRING_10 := c1.ss10;',
'  :P2103_SUB_STRING_11 := c1.ss11;',
'  :P2103_SUB_STRING_12 := c1.ss12;',
'  :P2103_SUB_STRING_13 := c1.ss13;',
'  :P2103_SUB_STRING_14 := c1.ss14;',
'  :P2103_SUB_STRING_15 := c1.ss15;',
'  :P2103_SUB_STRING_16 := c1.ss16;',
'  :P2103_SUB_STRING_17 := c1.ss17;',
'  :P2103_SUB_STRING_18 := c1.ss18;',
'  :P2103_SUB_STRING_19 := c1.ss19;',
'  :P2103_SUB_STRING_20 := c1.ss20;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_02104
begin
wwv_flow_api.create_page(
 p_id=>2104.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Confirmaci\00F3n de Objetos de Soporte')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Confirmaci\00F3n de Objetos de Soporte')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37342230339486120.4001)
,p_plug_name=>'Install Supporting Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37446702153843751.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206277617030804719.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212010623610588889.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148015335138176.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37342614663486121.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206277617030804719.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37342912222486121.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206277617030804719.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Instalar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37342802551486121.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206277617030804719.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37343531804486123.4001)
,p_branch_action=>'f?p=&APP_ID.:2116:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37342912222486121.4001)
,p_branch_sequence=>30
,p_branch_comment=>'was 2105'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37343217635486122.4001)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37342802551486121.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13647714976460949.4001)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37342802551486121.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13648524673463785.4001)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37342802551486121.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13649300909466392.4001)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37342802551486121.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13649905757467702.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37342802551486121.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2623108412309722.4001)
,p_name=>'P2104_INSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37342230339486120.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(INSTALL_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(INSTALL_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2388203950143011.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.install (',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_install_id  => c1.id,',
'      p_schema      => c1.owner',
'      );',
'  wwv_flow_install_wizard.set_sub_strings (',
'      p_ss_prompts  => wwv_flow_utilities.string_to_table2(:P2103_SS_PROMPTS),',
'      p_ss_values   => wwv_flow_utilities.string_to_table2(:P2103_SS_VALUES),',
'      p_install_id  => c1.id',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido instalar la aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(37342912222486121.4001)
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12749119611490499.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Build Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_patches ',
'   set patch_status = ''EXCLUDE'' ',
' where id in (select build_opt_id ',
'                from wwv_flow_install_build_opt ',
'               where flow_id = :FB_FLOW_ID ',
'                 and security_group_id = :flow_security_group_id) ',
'   and instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') = 0',
'   and security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_patches ',
'   set patch_status = ''INCLUDE'' ',
' where instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') > 0',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(37342912222486121.4001)
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_02105
begin
wwv_flow_api.create_page(
 p_id=>2105.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Estado de la Instalaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Estado de la Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(377954002618182699.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(377954831015190921.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select install_success_message',
'              from wwv_flow_install',
'             where flow_id = :FB_FLOW_ID )',
'loop',
'    sys.htp.p( coalesce ( wwv_flow_escape.html( c1.install_success_message ),',
'                          wwv_flow_lang.system_message( ''INSTALLER.SUCCESS_MESSAGE'' ) ) );',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_'' || :FB_FLOW_ID',
'   and c002 = ''FAIL'''))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(388072293039289606.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select install_failure_message',
'              from wwv_flow_install',
'             where flow_id = :FB_FLOW_ID )',
'loop',
'    sys.htp.p( coalesce( wwv_flow_escape.html( c1.install_failure_message ),',
'                         wwv_flow_lang.system_message( ''INSTALLER.FAILURE_MESSAGE'' ) ) );',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_'' || :FB_FLOW_ID',
'   and c002 = ''FAIL'''))
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(377973404458261750.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(377954002618182699.4001)
,p_button_name=>'INSTALL_SUMMARY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Resumen de Instalaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.::P2106_DEPLOYMENT_FLOW_ID:&FB_FLOW_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(377973106090259463.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(377954002618182699.4001)
,p_button_name=>'EDIT_APPLICATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(377972214270252338.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(377954002618182699.4001)
,p_button_name=>'RUN_APPLICATION'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar Aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'&P2105_HOME_LINK.'
,p_button_css_classes=>'launch-aut'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37345318650486126.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37345002414486125.4001)
,p_branch_action=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38100423673639275.4001)
,p_name=>'P2105_HOME_LINK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(377954002618182699.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(379059830271863924.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2105_HOME_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID )'))
);
end;
/
prompt --application/pages/page_02106
begin
wwv_flow_api.create_page(
 p_id=>2106.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Resumen de Instalaci\00F3n')
,p_step_title=>unistr('Resumen de Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_log.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13830232636866482.4001)
,p_plug_name=>'Errores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select c001 script_name, clob001 errors from htmldb_collections ',
'           where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P2106_DEPLOYMENT_FLOW_ID',
'           and length(clob001) > 0)',
'loop',
'  sys.htp.p(''<strong>''||wwv_flow_escape.html(c1.script_name)||''</strong>'');',
'  sys.htp.p(''<pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.errors);',
'  sys.htp.p(''</pre>'');',
'end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from htmldb_collections ',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P2106_DEPLOYMENT_FLOW_ID',
'   and length(clob001) > 0'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(13832512597889094.4001)
,p_name=>unistr('Resumen de Instalaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 script_name, ',
'       decode(c002, ''SUCCESS'', ',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.SUCCESS''),',
'                    ''FAIL'',',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.FAIL'')) status,        ',
'       to_number(nvl(c003,0)) fail_count,',
'       to_number(nvl(c004,0)) success_count,',
'       c003 + c004 total_count',
'  from htmldb_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P2106_DEPLOYMENT_FLOW_ID',
' order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn resultado del script')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13832811661889098.4001)
,p_query_column_id=>1
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre del Script'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13832905646889098.4001)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Estado'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13833029422889098.4001)
,p_query_column_id=>3
,p_column_alias=>'FAIL_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Sentencias con Errores'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18924823251673657.4001)
,p_query_column_id=>4
,p_column_alias=>'SUCCESS_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Sentencias Correctas'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(18924922101673658.4001)
,p_query_column_id=>5
,p_column_alias=>'TOTAL_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>'Total de Sentencias'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13839317146918771.4001)
,p_plug_name=>unistr('Resumen de Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Esta p\00E1gina muestra informaci\00F3n sobre los resultados de los archivos de comandos de instalaci\00F3n y desinstalaci\00F3n para la aplicaci\00F3n actual.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(24174032175852704.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(24172418538839346.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select id from wwv_flows where id = :P2106_DEPLOYMENT_FLOW_ID'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226817912026257376.4001)
,p_plug_name=>unistr('Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>91
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(97017221654212316.4001)
,p_name=>'P2106_HOME_LINK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(13839317146918771.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138112204575881331.4001)
,p_name=>'P2106_DEPLOYMENT_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13839317146918771.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(226819701076263618.4001)
,p_name=>'P2106_APP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(226817912026257376.4001)
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :FB_FLOW_ID = :P2106_DEPLOYMENT_FLOW_ID ',
'then wwv_flow_builder.get_current_flow_id_and_name',
'else :P2106_DEPLOYMENT_FLOW_NAME',
'end'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(227659704556466343.4001)
,p_name=>'P2106_DEPLOYMENT_FLOW_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(13839317146918771.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_02107
begin
wwv_flow_api.create_page(
 p_id=>2107.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Opciones de Creaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Opciones de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13553928773010793.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13554812974015615.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206279716038832790.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212003713783576519.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>110
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148289883138177.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13558728342029561.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206279716038832790.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13558924167029562.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206279716038832790.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13559100407029562.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(206279716038832790.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13563020162036687.4001)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13558924167029562.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13642028089436385.4001)
,p_branch_action=>'f?p=&APP_ID.:2104:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13558924167029562.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13560910812033924.4001)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13559100407029562.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13640008350430642.4001)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13559100407029562.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13640613544432113.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13559100407029562.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13571505402041833.4001)
,p_name=>'P2107_BUILD_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(13553928773010793.4001)
,p_prompt=>unistr('Opciones de Creaci\00F3n Disponibles:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
' begin ',
'   select id ',
'   bulk collect into l_value',
'   from wwv_flow_patches ',
'   where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and patch_status = ''INCLUDE'';',
'    ',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
' end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INSTALLER BUILD OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name, id from wwv_flow_patches ',
'where id in (select build_opt_id from wwv_flow_install_build_opt',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id)'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('El distribuidor de esta aplicaci\00F3n ha mostrado estas opciones de creaci\00F3n para que las incluya o las excluya en su aplicaci\00F3n. Estos valores se pueden modificar m\00E1s adelante editando directamente las opciones de creaci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20558406177354598.4001)
,p_name=>'P2107_BUILD_OPTIONS_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(13553928773010793.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(BUILD_OPTIONS_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.BUILD_OPTIONS_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(build_options_message))',
'  from wwv_flow_install',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
end;
/
prompt --application/pages/page_02108
begin
wwv_flow_api.create_page(
 p_id=>2108.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Error'
,p_step_title=>'Error'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(13764102611640168.4001)
,p_name=>'Mensajes de Error'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_report_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select failure_message from wwv_flow_install_checks',
'where instr('':''||:P2102_ERRORS||'':'','':''||id||'':'') > 0',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn error.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(13764424151640172.4001)
,p_query_column_id=>1
,p_column_alias=>'FAILURE_MESSAGE'
,p_column_display_sequence=>1
,p_column_heading=>'Mensajes de Error'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(13770925036665517.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206278808288821043.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148399828138177.4001)
,p_plug_name=>'Error'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13766513131652604.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206278808288821043.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(13767421442655065.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206278808288821043.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(13767624786655066.4001)
,p_branch_action=>'f?p=&FLOW_ID.:2102:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(13767421442655065.4001)
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_02109
begin
wwv_flow_api.create_page(
 p_id=>2109.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Vista Previa de Script'
,p_step_title=>'Vista Previa de Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57814432655083261.4001)
,p_plug_name=>unistr('Scripts de Actualizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
' sys.htp.p(''<table>'');',
' for c1 in (select rownum rn, s.* from ',
'             (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'                 and security_group_id = :flow_security_group_id',
'                 and nvl(script_type, ''INSTALL'') = ''UPGRADE''',
'               order by sequence, name) s)',
' loop',
'  sys.htp.p(''<tr><td valign="top"><a name="''||c1.rn||''"></a><span class="fielddatabold">''||c1.name||''</span></td></tr><tr><td><pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.script);',
'  sys.htp.p(''</pre></td></tr>'');',
' end loop;',
' sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''UPGRADE'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(210405822258670878.4001)
,p_plug_name=>unistr('Scripts de Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
' sys.htp.p(''<table>'');',
' for c1 in (select rownum rn, s.* from ',
'             (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'                 and security_group_id = :flow_security_group_id',
'                 and nvl(script_type, ''INSTALL'') = ''INSTALL''',
'               order by sequence, name) s)',
' loop',
'  sys.htp.p(''<tr><td valign="top"><a name="''||c1.rn||''"></a><span class="fielddatabold">''||c1.name||''</span></td></tr><tr><td><pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.script);',
'  sys.htp.p(''</pre></td></tr>'');',
' end loop;',
' sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''INSTALL'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(211272319310208044.4001)
,p_plug_name=>'Resumen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(211369921752360175.4001)
,p_plug_name=>'Requisitos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>21
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''INSTALL'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(211824324061321054.4001)
,p_name=>'Scripts'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>31
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_05'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select rownum rn, s.* from (',
'select name, sys.dbms_lob.getlength(script) len, (sys.dbms_lob.getlength(script) - sys.dbms_lob.getlength(replace(script,unistr(''\000a''),'''')) + 1) lines',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and nvl(:P2109_MODE,''INSTALL'') = nvl(script_type,''INSTALL'')',
'order by sequence, name) s'))
,p_display_when_condition=>'P2109_MODE'
,p_display_when_cond2=>'DEINSTALL'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(249244707741859303.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn script.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(211824324061321054.4001)
,p_plug_column_width=>'align="right"'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(211842529911370009.4001)
,p_query_column_id=>1
,p_column_alias=>'RN'
,p_column_display_sequence=>1
,p_column_heading=>'Rn'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(211824612462321059.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_link=>'##RN#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(211824720672321059.4001)
,p_query_column_id=>3
,p_column_alias=>'LEN'
,p_column_display_sequence=>3
,p_column_heading=>'Length (Bytes)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(211824831759321059.4001)
,p_query_column_id=>4
,p_column_alias=>'LINES'
,p_column_display_sequence=>4
,p_column_heading=>unistr('L\00EDneas')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219171320267554742.4001)
,p_plug_name=>unistr('bot\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227747509610732775.4001)
,p_plug_name=>unistr('Script de Desinstalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
' sys.htp.p(''<table>'');',
' for c1 in (select deinstall_script from wwv_flow_install',
'             where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id)',
' loop',
'  sys.htp.p(''<tr><td><pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.deinstall_script);',
'  sys.htp.p(''</pre></td></tr>'');',
' end loop;',
' sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''DEINSTALL'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(219169723599546223.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(211272319310208044.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(210993907246608422.4001)
,p_name=>'P2109_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(211272319310208044.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211002719292706529.4001)
,p_name=>'P2109_PARSING_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(211272319310208044.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis:')
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica el esquema que se utilizar\00E1 para analizar y ejecutar todo el c\00F3digo SQL de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211005800161719948.4001)
,p_name=>'P2109_FREE_SPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(211369921752360175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espacio Libre Necesario en KB:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G999G990'') free_kb from wwv_flow_install ',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El siguiente espacio libre debe estar disponible en el tablespace por defecto del esquema de an\00E1lisis.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211021728305784821.4001)
,p_name=>'P2109_REQ_SYS_PRIVS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(211369921752360175.4001)
,p_prompt=>'Privilegios del Sistema Necesarios:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(wwv_flow_escape.html(',
'nvl(required_sys_privs,wwv_flow_lang.system_message(''AUTH.NONE''))),'':'', ''<br />'')',
'from wwv_flow_install',
'where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica los privilegios del sistema necesarios para ejecutar los archivos de comandos de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211231405973816221.4001)
,p_name=>'P2109_DB_OBJECT_NAMES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(211369921752360175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombres de Objetos de Base de Datos:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(wwv_flow_escape.html(nvl(required_names_available,wwv_flow_lang.system_message(''AUTH.NONE''))), '':'', ''<br />'')',
'from wwv_flow_install',
'where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica los objetos de base de datos instalados por los archivos de comandos de instalaci\00F3n de esta aplicaci\00F3n. La instalaci\00F3n de objetos de soporte no se realiza si estos objetos existen en el esquema de an\00E1lisis.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211240221603849124.4001)
,p_name=>'P2109_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(211272319310208044.4001)
,p_prompt=>unistr('P\00E1ginas:')
,p_source=>'select count(*) from wwv_flow_steps where flow_id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero de p\00E1ginas en esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211386106908384266.4001)
,p_name=>'P2109_SCRIPT_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(211272319310208044.4001)
,p_prompt=>unistr('Archivos de Comandos de Instalaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) from wwv_flow_install_scripts ',
'where flow_id = :FB_FLOW_ID',
'and nvl(:P2109_MODE,''INSTALL'') = nvl(script_type,''INSTALL'')'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero de archivos de comandos de instalaci\00F3n asociados a esta aplicaci\00F3n. Estos archivos crean los objetos de soporte utilizados por esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(227745200128720584.4001)
,p_name=>'P2109_MODE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(211272319310208044.4001)
,p_item_default=>'INSTALL'
,p_source=>'INSTALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_02110
begin
wwv_flow_api.create_page(
 p_id=>2110.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Desinstalar'
,p_step_title=>'Desinstalar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Add more spacing for checkboxes */',
'.apex-item-option {margin-bottom: 8px;margin-top: 4px;}',
'/* Floating radio group left so help icons shows correctly */',
'.apex-item-group {float: left;}'))
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_del.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37419320197747676.4001)
,p_plug_name=>'Desinstalar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(37693129196139328.4001)
,p_plug_name=>unistr('Mensaje de Desinstalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
'where flow_id = :FB_FLOW_ID and deinstall_message is not null'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227756316845782132.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(227753031474767408.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(923577366660744019.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(923577424457744020.4001)
,p_plug_name=>unistr('Desinstalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37419900654747681.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(923577366660744019.4001)
,p_button_name=>'DEINSTALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Desinstalar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(37419514959747679.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(923577366660744019.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2110_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37420926958747692.4001)
,p_branch_name=>'Go To Page 2111'
,p_branch_action=>'f?p=&APP_ID.:2111:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37419900654747681.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37669115541974537.4001)
,p_branch_name=>'Go To Page 20'
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>'select 1 from WWV_FLOW_INSTALL where FLOW_ID = :fb_flow_id and sys.dbms_lob.getlength(DEINSTALL_SCRIPT) > 2'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(37678007061009999.4001)
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(37419900654747681.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2110_DEINSTALLATION_OPTIONS'
,p_branch_condition_text=>'APPLICATION'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36638523808198046.4001)
,p_name=>'P2110_DEINSTALL_APPLICATION'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(37419320197747676.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero y el nombre de la aplicaci\00F3n que est\00E1 desinstalando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36642706408211917.4001)
,p_name=>'P2110_PARSING_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(37419320197747676.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis')
,p_source=>'select owner from wwv_flows where id = :fb_flow_id and :fb_flow_id is not null'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica el esquema por defecto de la aplicaci\00F3n. El script de desinstalaci\00F3n tambi\00E9n se analizar\00E1 como este esquema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(37420315505747685.4001)
,p_name=>'P2110_DEINSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(37693129196139328.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags(deinstall_message) from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69493630613480452.4001)
,p_name=>'P2110_DEINSTALLATION_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(37419320197747676.4001)
,p_prompt=>unistr('Opciones de Desinstalaci\00F3n')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REMOVE APPLICATION OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(69499523734506806.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Eliminar Definici\00F3n de Aplicaci\00F3n</strong> eliminar\00E1 la aplicaci\00F3n &FB_FLOW_ID. pero dejar\00E1 todos los objetos de soporte creados.</p>'),
unistr('<p><strong>Borrar Objetos de Base de Datos</strong> ejecutar\00E1 el script de desinstalaci\00F3n definido en las definiciones de objeto de soporte de la aplicaci\00F3n &FB_FLOW_ID..</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(168169921686849894.4001)
,p_name=>'P2110_DELETE_FEEDBACK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(37419320197747676.4001)
,p_prompt=>'Suprimir Comentario'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_feedback',
' where application_id = :FB_FLOW_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si tiene previsto volver a crear esta aplicaci\00F3n usando el mismo ID, puede que desee mantener los comentarios. En caso contrario, debe suprimirlos para que en el futuro no se asocien a otra aplicaci\00F3n que use este n\00FAmero de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(224488820267485765.4001)
,p_name=>'P2110_CANCEL_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(37419320197747676.4001)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(123838628142313448.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2111_DEINSTALL_SUCCESS_MESSAGE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(deinstall_success_message,',
'         null, ',
'         wwv_flow_lang.system_message(''INSTALLER.DEINSTALL_SUCCESS_MESSAGE''),',
'         wwv_flow_utilities.esc_non_basic_tags(deinstall_success_message))',
'  from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(138134332682993581.4001)
,p_computation_sequence=>20
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(227686726766501167.4001)
,p_computation_sequence=>30
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(224761712992884009.4001)
,p_computation_sequence=>30
,p_computation_item=>'P2110_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(:P2110_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(69501405857511144.4001)
,p_validation_name=>'P2110_DEINSTALLATION_OPTIONS'
,p_validation_sequence=>10
,p_validation=>'P2110_DEINSTALLATION_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe activar al menos una opci\00F3n.')
,p_associated_item=>wwv_flow_api.id(69493630613480452.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(929198698348394250.4001)
,p_name=>'Deinstall'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(37419900654747681.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157684060391338201.4001)
,p_event_id=>wwv_flow_api.id(929198698348394250.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DEINSTALL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9801909508671111.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deinstall Database Objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.deinstall (',
'      p_install_id  => c1.id,',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_schema      => c1.owner',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido desinstalar la aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(37419900654747681.4001)
,p_process_when=>'DBOBJECTS'
,p_process_when_type=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
,p_process_when2=>'P2110_DEINSTALLATION_OPTIONS'
,p_process_success_message=>unistr('Desinstalaci\00F3n correcta. ')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17816722738661007.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P2110_DELETE_FEEDBACK = ''Y'' then',
'    wwv_flow_api.remove_application (',
'    p_application_id  => :FB_FLOW_ID,',
'    p_delete_feedback => true);',
'else',
'    wwv_flow_api.remove_application (',
'    p_application_id  => :FB_FLOW_ID);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido suprimir la definici\00F3n de aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(37419900654747681.4001)
,p_process_when=>'APPLICATION'
,p_process_when_type=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
,p_process_when2=>'P2110_DEINSTALLATION_OPTIONS'
,p_process_success_message=>unistr('Se ha suprimido la definici\00F3n de aplicaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19186203979302100.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean up on Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.update_cache_with_write (''FB_FLOW_ID'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_NAME'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',null);',
'',
'for c1 in (select min(id) min_id ',
'             from wwv_flows ',
'            where security_group_id = :flow_security_group_id',
'              and build_status = ''RUN_AND_BUILD'') loop',
'   wwv_flow.update_cache_with_write (''FB_FLOW_ID'',c1.min_id);',
'   wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',c1.min_id);',
'   for c2 in (select min(id) p from wwv_flow_steps where flow_id = nv(''FB_FLOW_ID'')) loop',
'      wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',c2.p);',
'      wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',c2.p);',
'   end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido refrescar el estado de la sesi\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(37419900654747681.4001)
,p_process_when=>'P2110_DEINSTALLATION_OPTIONS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APPLICATION:DBOBJECTS'
);
end;
/
prompt --application/pages/page_02111
begin
wwv_flow_api.create_page(
 p_id=>2111.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Desinstalar'
,p_step_title=>'Desinstalar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_del.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18149230028164603.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(923577532211744021.4001)
,p_plug_name=>unistr('Desinstalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923578011411744026.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18149230028164603.4001)
,p_button_name=>'Deinstall_Summary'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Resumen de Desinstalaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923577965972744025.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(18149230028164603.4001)
,p_button_name=>'Application_Builder'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Creador de Aplicaciones'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18152503971176089.4001)
,p_name=>'P2111_DEINSTALL_SUCCESS_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(923577532211744021.4001)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_02115
begin
wwv_flow_api.create_page(
 p_id=>2115.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Error al Instalar Objetos de Soporte'
,p_step_title=>'Error al Instalar Objetos de Soporte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11342631633842985.4001)
,p_plug_name=>'Error'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fallo de comprobaci\00F3n de los siguientes requisitos. La instalaci\00F3n de los objetos de soporte de esta aplicaci\00F3n no puede continuar hasta que se resuelvan estos problemas.</p>  '),
unistr('<p>Para continuar con la instalaci\00F3n despu\00E9s de solucionar los errores, navegue a las definiciones de objeto de soporte de esta aplicaci\00F3n y haga clic en INSTALAR en la secci\00F3n Instalar Objetos de Soporte.</p>'),
unistr('<p>Como alternativa, puede desinstalar la definici\00F3n de aplicaci\00F3n y volver a instalarla despu\00E9s de resolver estos problemas.</p>'),
'<br />',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(205202428675612736.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(211629725214761525.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37438506954816730.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148479864138178.4001)
,p_plug_name=>'Error al Instalar Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11344616096866801.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(205202428675612736.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11345709301874379.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(205202428675612736.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211606205353471924.4001)
,p_name=>'P2115_SPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(11342631633842985.4001)
,p_prompt=>'Espacio Disponible en KB:'
,p_source=>'P2100_AVAILABLE_SPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-TOP'
,p_display_when=>'P2100_AVAILABLE_SPACE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El espacio disponible en el tablespace por defecto del esquema de an\00E1lisis es menor que la cantidad necesaria para instalar los objetos de soporte de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211610506485529012.4001)
,p_name=>'P2115_REQUIRED_PRIVS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(11342631633842985.4001)
,p_prompt=>'Privilegios Necesarios:'
,p_source=>'P2100_PRIV_ERROR'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-TOP'
,p_display_when=>'P2100_PRIV_ERROR'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Para instalar los objetos de soporte de esta aplicaci\00F3n es necesario que se otorguen los siguientes privilegios del sistema al esquema de an\00E1lisis de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211611313758531197.4001)
,p_name=>'P2115_OBJECT_NAMES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(11342631633842985.4001)
,p_prompt=>'Nombres del Objeto:'
,p_source=>'P2100_ERROR'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-TOP'
,p_display_when=>'P2100_ERROR'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La instalaci\00F3n de los objetos de soporte no puede continuar mientras existan objetos de base de datos con estos nombres en el esquema de an\00E1lisis de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_02116
begin
wwv_flow_api.create_page(
 p_id=>2116.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n')
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'window.setTimeout(function() { apex.submit("INSTALL"); }, 100);'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(212286806351687982.4001)
,p_plug_name=>'Instalando Objetos de Soporte...'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1147295105621079968.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(212281521804682913.4001)
,p_branch_action=>'f?p=&APP_ID.:2105:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212278801026676927.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.install (',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_install_id  => c1.id,',
'      p_schema      => c1.owner',
'      );',
'  wwv_flow_install_wizard.set_sub_strings (',
'      p_ss_prompts  => wwv_flow_utilities.string_to_table2(:P2103_SS_PROMPTS),',
'      p_ss_values   => wwv_flow_utilities.string_to_table2(:P2103_SS_VALUES),',
'      p_install_id  => c1.id',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido instalar la aplicaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(212279305527678271.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Build Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_patches ',
'   set patch_status = ''EXCLUDE'' ',
' where id in (select build_opt_id ',
'                from wwv_flow_install_build_opt ',
'               where flow_id = :FB_FLOW_ID ',
'                 and security_group_id = :flow_security_group_id) ',
'   and instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') = 0',
'   and security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_patches ',
'   set patch_status = ''INCLUDE'' ',
' where instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') > 0',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_02117
begin
wwv_flow_api.create_page(
 p_id=>2117.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n')
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'window.setTimeout(function() { apex.submit("INSTALL"); }, 100);'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(219158001286417970.4001)
,p_plug_name=>unistr('Instalando Aplicaci\00F3n...')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1147295105621079968.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(241341826355308329.4001)
,p_branch_name=>'Go To Page 2160'
,p_branch_action=>'f?p=&APP_ID.:2160:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name in ( ''WWV_FLOW_IMPORT_CREDENTIALS'', ''WWV_FLOW_IMPORT_REMOTE_SERVERS'' )',
'   and c003 = ''Y'''))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(80658205422600378.4001)
,p_branch_name=>'Go To Page 2150'
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150,2151,2152:P2150_CANCEL_PAGE:1&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_install_wizard.needs_upgrade (',
'    p_flow_id => :FB_FLOW_ID )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(224538621342138907.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:2100,2101,2102,2103,2104,2105:P2110_CANCEL_PAGE:1&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :FB_FLOW_ID and :FB_FLOW_ID is not null'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491304721302717878.4001)
,p_branch_name=>'Go To Page 733'
,p_branch_action=>'f?p=&APP_ID.:733:&SESSION.::&DEBUG.:2100,2101,2102,2103,2104,2105::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY'''))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(224539224805139928.4001)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:FLOW:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(225087719721396975.4001)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2117_SUBMITTED'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(225086004699383188.4001)
,p_name=>'P2117_SUBMITTED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(219158001286417970.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(225087023053388432.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2117_SUBMITTED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'YES'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(224537317056128290.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from   wwv_flow_company_schemas',
'           where upper(schema) = upper(:P49_PARSE_AS) ',
'           and security_group_id = :flow_security_group_id) loop',
'    wwv_flow_imp_parser.parse (',
'        p_file_id            => :P49_FILE_ID,',
'        p_parse_as_schema    => :P49_PARSE_AS,',
'        p_install_as_flow    => :P49_NEW_FLOW_ID,',
'        p_original_flow_id   => wwv_flow_imp_parser.get_flow_id(:P49_FILE_ID),',
'        p_adjust_offset      => :P49_IMP_FLOW_ID != :P49_NEW_FLOW_ID,',
'        p_new_build_status   => :P49_BUILD_STATUS );',
'end loop;',
'wwv_flow_data_upload.fix_pre42(p_flow_id  => :P49_NEW_FLOW_ID );  ',
'',
':FB_FLOW_ID      := :P49_NEW_FLOW_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P49_NEW_FLOW_ID;',
':F4000_P1_PAGE   := ''1'';'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al instalar la aplicaci\00F3n.')
);
end;
/
prompt --application/pages/page_02120
begin
wwv_flow_api.create_page(
 p_id=>2120.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Vista Previa de Archivo'
,p_step_title=>'Vista Previa de Archivo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(227269707121202197.4001)
,p_plug_name=>'Vista Previa de Archivo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_charset varchar2(100);',
'begin',
'sys.htp.p(''<pre>'');',
'for c1 in (select blob_content, file_charset',
'             from wwv_flow_file_objects$',
'            where id = :P2120_FILE_ID) loop',
'  if c1.file_charset is null then',
'    l_charset := nvl(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''),',
'                   ''utf-8'');',
'else',
'   l_charset := c1.file_charset;',
'end if;',
'wwv_flow_sw_script.escape_sc_clob(',
'    wwv_flow_utilities.blob_to_clob(p_blob    => c1.blob_content,',
'                                    p_charset => l_charset));',
'',
'end loop;',
'sys.htp.p(''</pre>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(227298928563331326.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(227269707121202197.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(227295021722310480.4001)
,p_name=>'P2120_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(227269707121202197.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_02140
begin
wwv_flow_api.create_page(
 p_id=>2140.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Aplicaci\00F3n Instalada')
,p_step_title=>unistr('Aplicaci\00F3n Instalada')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(379113808205930390.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(379115403619948031.4001)
,p_plug_name=>unistr('Aplicaci\00F3n Instalada')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(379115706521958355.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(379113808205930390.4001)
,p_button_name=>'RUN_APP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar Aplicaci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&FB_FLOW_ID.:&F4000_RUN_EDIT_PAGE.:&SESSION.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(379115924528963503.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(379113808205930390.4001)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_02150
begin
wwv_flow_api.create_page(
 p_id=>2150.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Objetos de Soporte')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Objetos de Soporte')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48641830756424111.4001)
,p_plug_name=>'Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48642431472424112.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>200
,p_list_id=>wwv_flow_api.id(57809829707044603.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48680428299599768.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208172022706810323.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148631352138178.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48643130915424118.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208172022706810323.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2150_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48643307915424120.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208172022706810323.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48649222438424132.4001)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
'where license_message is not null',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48648017064424131.4001)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48648612885424132.4001)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48648804255424132.4001)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48648403379424131.4001)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48649005347424132.4001)
,p_branch_action=>'f?p=&APP_ID.:2140:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2150_ACTION'
,p_branch_condition_text=>'N'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48643530611424120.4001)
,p_name=>'P2150_WELCOME_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(UPGRADE_MESSAGE,',
'              null, wwv_flow_lang.system_message(''INSTALLER.UPGRADE_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(UPGRADE_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48643705376424121.4001)
,p_name=>'P2150_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_item_default=>'Y'
,p_prompt=>'Actualizar Objetos de Soporte:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se ha instalado esta definici\00F3n de aplicaci\00F3n, aunque se deben actualizar los objetos de base de datos, las im\00E1genes y los datos iniciales. Seleccione <strong>S\00ED</strong> para continuar e actualizar estos objetos de soporte.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48644227970424122.4001)
,p_name=>'P2150_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48644932245424123.4001)
,p_name=>'P2150_PARSING_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de An\00E1lisis:')
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica el esquema que se utilizar\00E1 para analizar y ejecutar todo el c\00F3digo SQL de esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48645401450424123.4001)
,p_name=>'P2150_ERROR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48645628461424123.4001)
,p_name=>'P2150_AVAILABLE_SPACE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48645803607424123.4001)
,p_name=>'P2150_FREE_SPACE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espacio Libre Necesario en KB:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G999G990'') free_kb from wwv_flow_install ',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El siguiente espacio libre debe estar disponible en el tablespace por defecto del esquema de an\00E1lisis.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48646322222424124.4001)
,p_name=>'P2150_PRIV_ERROR'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48646529119424124.4001)
,p_name=>'P2150_CANCEL_PAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(48641830756424111.4001)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48646824364424125.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2150_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl(:P2150_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48647006850424127.4001)
,p_validation_name=>'application exists'
,p_validation_sequence=>10
,p_validation=>'select 1 from wwv_flows where id = :fb_flow_id'
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La aplicaci\00F3n debe estar instalada.')
,p_when_button_pressed=>wwv_flow_api.id(48643307915424120.4001)
,p_associated_item=>wwv_flow_api.id(48644227970424122.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48647232376424128.4001)
,p_validation_name=>'validate schema'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r boolean := false;',
'begin',
'  for c1 in (select owner from wwv_flows where id = :fb_flow_id) loop',
'    r := wwv_flow_security.current_company_can_build(p_in_schema=>c1.owner);',
'  end loop;',
'  return r;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'No tiene privilegios para analizar como el esquema identificado.'
,p_when_button_pressed=>wwv_flow_api.id(48643307915424120.4001)
,p_associated_item=>wwv_flow_api.id(48644932245424123.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48647323522424128.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check objects'
,p_process_sql_clob=>':P2150_ERROR := wwv_flow_install_wizard.get_existing_objects(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48647515263424129.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'system privs'
,p_process_sql_clob=>':P2150_PRIV_ERROR := wwv_flow_install_wizard.get_missing_privs(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48647726958424130.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'free space'
,p_process_sql_clob=>':P2150_AVAILABLE_SPACE := wwv_flow_install_wizard.get_free_space(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(48643307915424120.4001)
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_02151
begin
wwv_flow_api.create_page(
 p_id=>2151.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Aceptaci\00F3n de la Licencia')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Aceptaci\00F3n de la Licencia')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48655502408443595.4001)
,p_plug_name=>unistr('Aceptaci\00F3n de la Licencia')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48655713415443595.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48656110285443596.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208175920113847459.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148726610138178.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48656819909443596.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208175920113847459.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48657019541443597.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208175920113847459.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48657232350443597.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208175920113847459.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48659106578443598.4001)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48657019541443597.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48658301483443598.4001)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48657019541443597.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48658525878443598.4001)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48657019541443597.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48658700750443598.4001)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48657019541443597.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48658913799443598.4001)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48657232350443597.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48657601512443597.4001)
,p_name=>'P2151_LICENSE_TERMS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48655502408443595.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags(LICENSE_MESSAGE) ',
'  from WWV_FLOW_INSTALL where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48657824400443597.4001)
,p_name=>'P2151_ACCEPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48655502408443595.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NOT_ACCEPTED'
,p_prompt=>'Aceptar'
,p_source=>'NOT_ACCEPTED'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DEPLOYMENT LICENSE ACCEPTANCE'
,p_lov=>'.'||wwv_flow_api.id(110337521891120166.4001)||'.'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48658118530443598.4001)
,p_validation_name=>'P2151_ACCEPT'
,p_validation_sequence=>10
,p_validation=>'P2151_ACCEPT'
,p_validation2=>'ACCEPTED'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>unistr('Debe aceptar los t\00E9rminos de la licencia para continuar. De lo contrario, haga clic en Cancelar.')
,p_associated_item=>wwv_flow_api.id(48657824400443597.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02152
begin
wwv_flow_api.create_page(
 p_id=>2152.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Validaciones Previas a la Instalaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Validaciones Previas a la Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48661831519454947.4001)
,p_plug_name=>unistr('Validaciones Previas a la Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<ul>'');',
'for c1 in (select name ',
'             from wwv_flow_install_checks ',
'            where flow_id = :FB_FLOW_ID ',
'            order by sequence)',
'loop',
'  sys.htp.p(''<li>''||wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48662027703454947.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48662414644454948.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208182509949910780.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148835944138178.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48663126470454948.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208182509949910780.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48663310147454949.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208182509949910780.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48663504623454949.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208182509949910780.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48665411373454951.4001)
,p_branch_action=>'f?p=&APP_ID.:2158:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48663310147454949.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P2152_ERRORS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48665819125454952.4001)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48663310147454949.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48665624160454951.4001)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48663504623454949.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48664808914454951.4001)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48663504623454949.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48665011129454951.4001)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48663504623454949.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48665210872454951.4001)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48663504623454949.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48663729123454949.4001)
,p_name=>'P2152_VERIFICATION_MESSAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48661831519454947.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(VALIDATION_MESSAGE,',
'              null, wwv_flow_lang.system_message(''INSTALLER.VALIDATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(VALIDATION_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48663920671454950.4001)
,p_name=>'P2152_ERRORS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48661831519454947.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48664415975454950.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2152_ERRORS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48664500577454950.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2152_ERRORS := wwv_flow_install_wizard.run_install_checks (',
'                     p_flow_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(48663310147454949.4001)
);
end;
/
prompt --application/pages/page_02153
begin
wwv_flow_api.create_page(
 p_id=>2153.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Cadenas de Sustituci\00F3n de Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Cadenas de Sustituci\00F3n de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51369702989464992.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_source=>'wwv_flow_install_wizard.configuration_options ( p_flow_id => :FB_FLOW_ID );'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51369932294464993.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(51370328183464993.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(210424614987781460.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208183308002919647.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747148944461138179.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51371026164464994.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208183308002919647.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51371210452464994.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208183308002919647.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(51371400869464994.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208183308002919647.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51373702960464997.4001)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(51371210452464994.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51373109189464997.4001)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(51371210452464994.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51373308057464997.4001)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(51371210452464994.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51373525698464997.4001)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(51371400869464994.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(51372916136464996.4001)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(51371400869464994.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51371613099464994.4001)
,p_name=>'P2153_SS_PROMPTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(51369702989464992.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_ss_prompts wwv_flow_global.vc_arr2;',
'begin',
'  for c1 in (select prompt_substitution_01_yn p01,',
'                    prompt_substitution_02_yn p02,',
'                    prompt_substitution_03_yn p03,',
'                    prompt_substitution_04_yn p04,',
'                    prompt_substitution_05_yn p05,',
'                    prompt_substitution_06_yn p06,',
'                    prompt_substitution_07_yn p07,',
'                    prompt_substitution_08_yn p08,',
'                    prompt_substitution_09_yn p09,',
'                    prompt_substitution_10_yn p10,',
'                    prompt_substitution_11_yn p11,',
'                    prompt_substitution_12_yn p12,',
'                    prompt_substitution_13_yn p13,',
'                    prompt_substitution_14_yn p14,',
'                    prompt_substitution_15_yn p15,',
'                    prompt_substitution_16_yn p16,',
'                    prompt_substitution_17_yn p17,',
'                    prompt_substitution_18_yn p18,',
'                    prompt_substitution_19_yn p19,',
'                    prompt_substitution_20_yn p20',
'               from wwv_flow_install',
'              where flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id)',
'  loop',
'    if c1.p01 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''01''; end if;',
'    if c1.p02 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''02''; end if;',
'    if c1.p03 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''03''; end if;',
'    if c1.p04 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''04''; end if;',
'    if c1.p05 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''05''; end if;',
'    if c1.p06 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''06''; end if;',
'    if c1.p07 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''07''; end if;',
'    if c1.p08 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''08''; end if;',
'    if c1.p09 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''09''; end if;',
'    if c1.p10 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''10''; end if;',
'    if c1.p11 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''11''; end if;',
'    if c1.p12 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''12''; end if;',
'    if c1.p13 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''13''; end if;',
'    if c1.p14 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''14''; end if;',
'    if c1.p15 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''15''; end if;',
'    if c1.p16 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''16''; end if;',
'    if c1.p17 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''17''; end if;',
'    if c1.p18 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''18''; end if;',
'    if c1.p19 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''19''; end if;',
'    if c1.p20 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''20''; end if;',
'  end loop;',
'  return wwv_flow_utilities.table_to_string(l_ss_prompts);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51371827752464995.4001)
,p_name=>'P2153_SS_VALUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(51369702989464992.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(51372026014464995.4001)
,p_name=>'P2153_CONFIG_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(51369702989464992.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(CONFIGURATION_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIGURATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(CONFIGURATION_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51372415539464995.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Substitution Strings'
,p_process_sql_clob=>':P2153_SS_VALUES := wwv_flow_utilities.table_to_string2(htmldb_application.g_f01);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(51371210452464994.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(51372604019464996.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Sub Strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select substitution_value_01 sv01, install_prompt_01 ss01, ',
'                  substitution_value_02 sv02, install_prompt_02 ss02,',
'                  substitution_value_03 sv03, install_prompt_03 ss03,',
'                  substitution_value_04 sv04, install_prompt_04 ss04,',
'                  substitution_value_05 sv05, install_prompt_05 ss05,',
'                  substitution_value_06 sv06, install_prompt_06 ss06,',
'                  substitution_value_07 sv07, install_prompt_07 ss07,',
'                  substitution_value_08 sv08, install_prompt_08 ss08,',
'                  substitution_value_09 sv09, install_prompt_09 ss09,',
'                  substitution_value_10 sv10, install_prompt_10 ss10,',
'                  substitution_value_11 sv11, install_prompt_11 ss11,',
'                  substitution_value_12 sv12, install_prompt_12 ss12,',
'                  substitution_value_13 sv13, install_prompt_13 ss13,',
'                  substitution_value_14 sv14, install_prompt_14 ss14,',
'                  substitution_value_15 sv15, install_prompt_15 ss15,',
'                  substitution_value_16 sv16, install_prompt_16 ss16,',
'                  substitution_value_17 sv17, install_prompt_17 ss17,',
'                  substitution_value_18 sv18, install_prompt_18 ss18,',
'                  substitution_value_19 sv19, install_prompt_19 ss19,',
'                  substitution_value_20 sv20, install_prompt_20 ss20',
'             from wwv_flows, wwv_flow_install',
'            where wwv_flows.id = wwv_flow_install.flow_id',
'              and wwv_flows.id = :FB_FLOW_ID',
'              and wwv_flows.security_group_id = :flow_security_group_id)',
'loop',
'  :P2153_SUB_VALUE_01 := c1.sv01;',
'  :P2153_SUB_VALUE_02 := c1.sv02;  ',
'  :P2153_SUB_VALUE_03 := c1.sv03;',
'  :P2153_SUB_VALUE_04 := c1.sv04;',
'  :P2153_SUB_VALUE_05 := c1.sv05;',
'  :P2153_SUB_VALUE_06 := c1.sv06;',
'  :P2153_SUB_VALUE_07 := c1.sv07;',
'  :P2153_SUB_VALUE_08 := c1.sv08;',
'  :P2153_SUB_VALUE_09 := c1.sv09;',
'  :P2153_SUB_VALUE_10 := c1.sv10;',
'  :P2153_SUB_VALUE_11 := c1.sv11;',
'  :P2153_SUB_VALUE_12 := c1.sv12;',
'  :P2153_SUB_VALUE_13 := c1.sv13;',
'  :P2153_SUB_VALUE_14 := c1.sv14;',
'  :P2153_SUB_VALUE_15 := c1.sv15;',
'  :P2153_SUB_VALUE_16 := c1.sv16;',
'  :P2153_SUB_VALUE_17 := c1.sv17;',
'  :P2153_SUB_VALUE_18 := c1.sv18;',
'  :P2153_SUB_VALUE_19 := c1.sv19;',
'  :P2153_SUB_VALUE_20 := c1.sv20;',
'  :P2153_SUB_STRING_01 := c1.ss01;',
'  :P2153_SUB_STRING_02 := c1.ss02;  ',
'  :P2153_SUB_STRING_03 := c1.ss03;',
'  :P2153_SUB_STRING_04 := c1.ss04;',
'  :P2153_SUB_STRING_05 := c1.ss05;',
'  :P2153_SUB_STRING_06 := c1.ss06;',
'  :P2153_SUB_STRING_07 := c1.ss07;',
'  :P2153_SUB_STRING_08 := c1.ss08;',
'  :P2153_SUB_STRING_09 := c1.ss09;',
'  :P2153_SUB_STRING_10 := c1.ss10;',
'  :P2153_SUB_STRING_11 := c1.ss11;',
'  :P2153_SUB_STRING_12 := c1.ss12;',
'  :P2153_SUB_STRING_13 := c1.ss13;',
'  :P2153_SUB_STRING_14 := c1.ss14;',
'  :P2153_SUB_STRING_15 := c1.ss15;',
'  :P2153_SUB_STRING_16 := c1.ss16;',
'  :P2153_SUB_STRING_17 := c1.ss17;',
'  :P2153_SUB_STRING_18 := c1.ss18;',
'  :P2153_SUB_STRING_19 := c1.ss19;',
'  :P2153_SUB_STRING_20 := c1.ss20;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_02154
begin
wwv_flow_api.create_page(
 p_id=>2154.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Actualizar Confirmaci\00F3n de Objetos de Soporte')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Actualizar Confirmaci\00F3n de Objetos de Soporte')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57400804980641675.4001)
,p_plug_name=>'Actualizar Objetos de Soporte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_footer=>'<p /><p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57401014190641675.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57401406093641676.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(57809829707044603.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208184702854946537.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149045171138179.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57402119664641680.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208184702854946537.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2150_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57402323526641681.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208184702854946537.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Instalar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57402515688641681.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208184702854946537.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57404405597641687.4001)
,p_branch_action=>'f?p=&APP_ID.:2166:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57402323526641681.4001)
,p_branch_sequence=>10
,p_branch_comment=>'was 2105'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57404203347641686.4001)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57402515688641681.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57403418013641686.4001)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57402515688641681.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57403621297641686.4001)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57402515688641681.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57403801856641686.4001)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57402515688641681.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57404004136641686.4001)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57402515688641681.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57402703920641682.4001)
,p_name=>'P2154_INSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57400804980641675.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(INSTALL_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(INSTALL_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57402925117641684.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.install (',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_install_id  => c1.id,',
'      p_schema      => c1.owner',
'      );',
'  wwv_flow_install_wizard.set_sub_strings (',
'      p_ss_prompts  => wwv_flow_utilities.string_to_table2(:P2103_SS_PROMPTS),',
'      p_ss_values   => wwv_flow_utilities.string_to_table2(:P2103_SS_VALUES),',
'      p_install_id  => c1.id',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido instalar la aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(57402323526641681.4001)
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57403117851641685.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Build Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_patches ',
'   set patch_status = ''EXCLUDE'' ',
' where id in (select build_opt_id ',
'                from wwv_flow_install_build_opt ',
'               where flow_id = :FB_FLOW_ID ',
'                 and security_group_id = :flow_security_group_id) ',
'   and instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') = 0',
'   and security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_patches ',
'   set patch_status = ''INCLUDE'' ',
' where instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') > 0',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(57402323526641681.4001)
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_02155
begin
wwv_flow_api.create_page(
 p_id=>2155.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Estado de la Instalaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Estado de la Instalaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57408132201645335.4001)
,p_plug_name=>unistr('Estado de la Instalaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57408502346645336.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_api.id(58916220936178306.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_header=>unistr('<p>El archivo importado est\00E1 situado en el repositorio de exportaci\00F3n. A menos que desee volver a instalar, debe eliminarlo.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149191823138179.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from htmldb_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:FB_FLOW_ID',
'   and c002 = ''FAIL'''))
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(923578109427744027.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(923578501489744031.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from htmldb_collections ',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:FB_FLOW_ID',
'   and c002 = ''FAIL'''))
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923578456112744030.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(923578109427744027.4001)
,p_button_name=>'Install_Summary'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Resumen de Instalaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:RP:P2106_DEPLOYMENT_FLOW_ID:&FB_FLOW_ID.:'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923578355511744029.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(923578109427744027.4001)
,p_button_name=>'Edit_Application'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(923578229345744028.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(923578109427744027.4001)
,p_button_name=>'Run_Application'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Ejecutar Aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'&P2155_HOME_LINK.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57409230870645336.4001)
,p_name=>'P2155_SUCCESS_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(923578501489744031.4001)
,p_use_cache_before_default=>'NO'
,p_post_element_text=>'<p />'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(INSTALL_SUCCESS_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.SUCCESS_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(INSTALL_SUCCESS_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57409427322645337.4001)
,p_name=>'P2155_FAILURE_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(747149191823138179.4001)
,p_post_element_text=>'<p />'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(INSTALL_FAILURE_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.FAILURE_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(INSTALL_FAILURE_MESSAGE)) error_message',
'  from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57409624220645337.4001)
,p_name=>'P2155_HOME_LINK'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57408502346645336.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_02157
begin
wwv_flow_api.create_page(
 p_id=>2157.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n: Opciones de Creaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n: Opciones de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57428714672660618.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57428926090660618.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57429328767660619.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(57809829707044603.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208187828958963593.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149214001138179.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57430200537660620.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208187828958963593.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57430414690660620.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208187828958963593.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57430622424660620.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208187828958963593.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57432020019660621.4001)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57430414690660620.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57432606120660622.4001)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57430414690660620.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57431804694660621.4001)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57430622424660620.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57432402776660622.4001)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57430622424660620.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57432214340660622.4001)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57430622424660620.4001)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57430813463660620.4001)
,p_name=>'P2157_BUILD_OPTIONS_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(57428714672660618.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(BUILD_OPTIONS_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.BUILD_OPTIONS_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(build_options_message))',
'  from wwv_flow_install',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57431203450660621.4001)
,p_name=>'P2157_BUILD_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(57428714672660618.4001)
,p_prompt=>unistr('Opciones de Creaci\00F3n Disponibles:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
' begin ',
'   select id ',
'   bulk collect into l_value',
'   from wwv_flow_patches ',
'   where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and patch_status = ''INCLUDE'';',
'    ',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
' end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INSTALLER BUILD OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name, id from wwv_flow_patches ',
'where id in (select build_opt_id from wwv_flow_install_build_opt',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id)'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('El distribuidor de esta aplicaci\00F3n ha mostrado estas opciones de creaci\00F3n para que las incluya o las excluya en su aplicaci\00F3n. Estos valores se pueden modificar m\00E1s adelante editando directamente las opciones de creaci\00F3n de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
end;
/
prompt --application/pages/page_02158
begin
wwv_flow_api.create_page(
 p_id=>2158.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Error'
,p_step_title=>'Error'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(57439125119676748.4001)
,p_name=>'Mensajes de Error'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_report_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select failure_message from wwv_flow_install_checks',
'where instr('':''||:P2152_ERRORS||'':'','':''||id||'':'') > 0',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn error.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(57439306381676749.4001)
,p_query_column_id=>1
,p_column_alias=>'FAILURE_MESSAGE'
,p_column_display_sequence=>1
,p_column_heading=>'Mensajes de Error'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57439618877676749.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(48681713885605105.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208190412597977730.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149377303138180.4001)
,p_plug_name=>'Error'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57440312251676749.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208190412597977730.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57440506406676750.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208190412597977730.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57440824794676750.4001)
,p_branch_action=>'f?p=&FLOW_ID.:2152:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57440506406676750.4001)
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_02160
begin
wwv_flow_api.create_page(
 p_id=>2160.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar aplicaci\00F3n - Credenciales')
,p_step_title=>unistr('Instalar aplicaci\00F3n - Credenciales')
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(24907316279669450)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1573009001030403.4001)
,p_plug_name=>'Credenciales'
,p_region_name=>'ig_credentials'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with imported_credentials as (',
'    select distinct n001 as imported_id,',
'           c002 as is_new,',
'           c003 as prompt_on_install',
'      from wwv_flow_collections',
'     where collection_name = ''WWV_FLOW_IMPORT_CREDENTIALS''',
')',
'select',
'    c.id,',
'    i.is_new,',
'    c.name, ',
'    c.authentication_type,',
'    c.client_id,',
'    c.client_secret,',
'    c.client_secret_verify ',
'from wwv_credentials_dev c, imported_credentials i',
'where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and c.id = i.imported_id',
'  and i.prompt_on_install = ''Y'' ',
'order by name'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_CREDENTIALS''',
'   and c003 = ''Y'''))
,p_plug_footer=>unistr('<p>Esta p\00E1gina solo puede actualizar las credenciales que <em>no</em> estaban presentes en el espacio de trabajo en el momento de importarse la aplicaci\00F3n. Todas las credenciales pueden modificarse utilizando la secci\00F3n <strong>Credencial</strong> de')
||' <strong>Utilidades del espacio de trabajo</strong>. Puede revisar su uso en el separador <strong>Uso</strong> antes de aplicar los cambios.</p>'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1573365246030406.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Nombre de la Credencial'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1573409629030407.4001)
,p_name=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'AUTHENTICATION_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>unistr('Tipo de autenticaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(154078822199034715)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1573568220030408.4001)
,p_name=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CLIENT_ID'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'ID de cliente o nombre de usuario'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1573698106030409.4001)
,p_name=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CLIENT_SECRET'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_PASSWORD'
,p_heading=>unistr('Secreto del cliente o contrase\00F1a')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_is_required=>false
,p_max_length=>255
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1573782751030410.4001)
,p_name=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CLIENT_SECRET_VERIFY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_PASSWORD'
,p_heading=>unistr('Verificar secreto del cliente/contrase\00F1a')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_is_required=>false
,p_max_length=>255
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1573911821030412.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>30
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1574068402030413.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_03=>'Y'
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537042414723394617.4001)
,p_name=>'IS_NEW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_NEW'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Ya existe'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>40
,p_value_alignment=>'CENTER'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537042994888394622.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(1573109468030404.4001)
,p_internal_uid=>1573109468030404
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_max_row_count=>100000
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(53108643940609615.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(209922019649064269.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537043026726394623.4001)
,p_plug_name=>'Servidores Remotos'
,p_region_name=>'ig_remote_servers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with imported_credentials as (',
'    select distinct n001 as imported_id,',
'           c002 as is_new,',
'           c005 as is_overwritten,',
'           c003 as prompt_on_install',
'      from wwv_flow_collections',
'     where collection_name = ''WWV_FLOW_IMPORT_REMOTE_SERVERS''',
')',
'select',
'    r.id,',
'    i.is_new,',
'    i.is_overwritten,',
'    r.name, ',
'    r.base_url,',
'    r.https_host',
'from wwv_remote_servers r, imported_credentials i',
'where r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and r.id = i.imported_id',
'  and i.prompt_on_install = ''Y'' ',
'order by name'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_REMOTE_SERVERS''',
'and c003 = ''Y'''))
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537043227518394625.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537043391440394626.4001)
,p_name=>'IS_NEW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_NEW'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Ya existe'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>40
,p_value_alignment=>'CENTER'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537043485446394627.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Nombre de servidor remoto'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537043536566394628.4001)
,p_name=>'BASE_URL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BASE_URL'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'URL Base'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>500
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537043688159394629.4001)
,p_name=>'HTTPS_HOST'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HTTPS_HOST'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Host de HTTPS'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>500
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>'not ( sys.dbms_db_version.version <= 11 or ( sys.dbms_db_version.version = 12 and sys.dbms_db_version.release = 1 ) )'
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537043942970394632.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537044092457394633.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(537387933896764703.4001)
,p_name=>'IS_OVERWRITTEN'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_OVERWRITTEN'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Valor cambiado'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>50
,p_value_alignment=>'CENTER'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(537043154086394624.4001)
,p_internal_uid=>537043154086394624
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_max_row_count=>100000
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537044270096394635.4001)
,p_plug_name=>'Credenciales'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_CREDENTIALS''',
'and c003 =''Y'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537044362491394636.4001)
,p_plug_name=>'Servidores Remotos'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin-top: 30px"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_REMOTE_SERVERS''',
'and c003 = ''Y'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(537044413217394637.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('<p>Se ha instalado la aplicaci\00F3n. Las siguientes credenciales o servidores remotos son parte del archivo de exportaci\00F3n de la aplicaci\00F3n con el atributo <strong>Solicitar en la instalaci\00F3n</strong> definido como <strong>S\00ED</strong>.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(748887656107282801.4001)
,p_plug_name=>unistr('Instalar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1741886583144640.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(209922019649064269.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1779243628268721.4001)
,p_branch_name=>'Go To Page 2150'
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150,2151,2152:P2150_CANCEL_PAGE:1&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_install_wizard.needs_upgrade (',
'    p_flow_id => :FB_FLOW_ID )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1779582117270051.4001)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:2100,2101,2102,2103,2104,2105:P2110_CANCEL_PAGE:1&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :FB_FLOW_ID and :FB_FLOW_ID is not null'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1779897359271406.4001)
,p_branch_name=>'Go To Page 733'
,p_branch_action=>'f?p=&APP_ID.:733:&SESSION.::&DEBUG.:2100,2101,2102,2103,2104,2105::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY'''))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1780111302272589.4001)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:FLOW:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1574299910030415.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(537043026726394623.4001)
,p_validation_name=>'Verify Client Secret'
,p_validation_sequence=>10
,p_validation=>':CLIENT_SECRET = :CLIENT_SECRET_VERIFY or (:CLIENT_SECRET is null and :CLIENT_SECRET_VERIFY is null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Los secretos del cliente deben coincidir.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(537042515525394618.4001)
,p_name=>'Is New'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1573009001030403.4001)
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'IS_NEW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'load'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537042627331394619.4001)
,p_event_id=>wwv_flow_api.id(537042515525394618.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'CLIENT_ID,CLIENT_SECRET,CLIENT_SECRET_VERIFY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(537042833724394621.4001)
,p_event_id=>wwv_flow_api.id(537042515525394618.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'CLIENT_ID,CLIENT_SECRET,CLIENT_SECRET_VERIFY'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1574118315030414.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(1573009001030403.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Credentials - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_CREDENTIALS_DEV'
,p_attribute_05=>'Y'
,p_attribute_06=>'N'
,p_attribute_08=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1741886583144640.4001)
,p_process_success_message=>'Credenciales actualizadas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(537044128723394634.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(537043026726394623.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Remote Servers - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_REMOTE_SERVERS'
,p_attribute_05=>'Y'
,p_attribute_06=>'N'
,p_attribute_08=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1741886583144640.4001)
);
end;
/
prompt --application/pages/page_02166
begin
wwv_flow_api.create_page(
 p_id=>2166.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Instalar Aplicaci\00F3n')
,p_step_title=>unistr('Instalar Aplicaci\00F3n')
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'window.setTimeout(function() { apex.submit("INSTALL"); }, 100);'
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(57480004151728405.4001)
,p_plug_name=>'Instalando Objetos de Soporte...'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1147295105621079968.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57481723860728407.4001)
,p_branch_action=>'f?p=&APP_ID.:2155:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57481207581728406.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.upgrade (',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_install_id  => c1.id,',
'      p_schema      => c1.owner',
'      );',
'  wwv_flow_install_wizard.set_sub_strings (',
'      p_ss_prompts  => wwv_flow_utilities.string_to_table2(:P2103_SS_PROMPTS),',
'      p_ss_values   => wwv_flow_utilities.string_to_table2(:P2103_SS_VALUES),',
'      p_install_id  => c1.id',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido instalar la aplicaci\00F3n.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57481407136728406.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Build Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_patches ',
'   set patch_status = ''EXCLUDE'' ',
' where id in (select build_opt_id ',
'                from wwv_flow_install_build_opt ',
'               where flow_id = :FB_FLOW_ID ',
'                 and security_group_id = :flow_security_group_id) ',
'   and instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') = 0',
'   and security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_patches ',
'   set patch_status = ''INCLUDE'' ',
' where instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') > 0',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_02222
begin
wwv_flow_api.create_page(
 p_id=>2222.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Nuevo Principal de Entradas de Lista'
,p_step_title=>'Crear Nuevo Principal de Entradas de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33590524192567471.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_col_allignments=>'R:R:L:L:L:R'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:YES'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(33595925671624596.4001)
,p_name=>'Entradas de Lista'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,50) list_item_link_target, ',
'    parent_list_item_id,',
'    required_patch build_option,',
'    LIST_ITEM_DISP_COND_TYPE,',
'    last_updated_on, LIST_ITEM_ICON',
'  from   ',
'    wwv_flow_list_items',
'  where  ',
'    list_id = replace(:P2222_LIST_ID,''%''||''null%'',null)',
') select ',
'      ''<input type="checkbox" name="f01" value="''||id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(list_item_link_text))||''" />'' cb,',
'      (level-1)*25 indent,',
'      list_item_link_text,',
'      id,',
'      list_item_display_sequence,',
'      list_item_type,    ',
'      list_item_link_target,',
'      parent_list_item_id,',
'      decode(greatest(0,build_option),0,''! '','''')||',
'      (select patch_name from WWV_FLOW_PATCHES where id = abs(build_Option))',
'      build_option,',
'      decode(LIST_ITEM_DISP_COND_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
'      last_updated_on,',
'      LIST_ITEM_ICON',
'from list_items',
'start with nvl(parent_list_item_id,0) = nvl(:P2222_START_WITH,0)',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence, list_item_link_text'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1194418302299758812.4001)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596127245624597.4001)
,p_query_column_id=>2
,p_column_alias=>'INDENT'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596224658624598.4001)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:RP:F4000_P4052_ID:#ID#:'
,p_column_linktext=>'#LIST_ITEM_LINK_TEXT#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596316770624598.4001)
,p_query_column_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596427083624598.4001)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596528396624598.4001)
,p_query_column_id=>6
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596613156624598.4001)
,p_query_column_id=>7
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>7
,p_column_heading=>'Destino'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596724296624598.4001)
,p_query_column_id=>8
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596826598624598.4001)
,p_query_column_id=>9
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33596914432624598.4001)
,p_query_column_id=>10
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>10
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33597030598624598.4001)
,p_query_column_id=>11
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>12
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33597113464624598.4001)
,p_query_column_id=>12
,p_column_alias=>'LIST_ITEM_ICON'
,p_column_display_sequence=>9
,p_column_heading=>'Imagen'
,p_use_as_row_header=>'N'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P4050_SHOW_IMAGE_NAMES'
,p_display_when_condition2=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40982312965484269.4001)
,p_plug_name=>'Crear Nuevo Principal de Entradas de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta p\00E1gina se utiliza para gestionar una jerarqu\00EDa de entrada de lista. Utilice la lista de selecci\00F3n <strong>Empezar por</strong> para restringir la vista a un subjuego de la jerarqu\00EDa de entrada de lista.'),
'<p />',
unistr('Para crear un nuevo principal de las entradas, seleccione el nuevo principal, active las casillas de control correspondientes a las entradas de lista que desea mover. Por \00FAltimo, haga clic en el bot\00F3n <strong>Crear Nuevo Principal de Entradas Selecci')
||unistr('onadas</strong> para realizar la acci\00F3n.')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63319801445126819.4001)
,p_plug_name=>'Crear Nuevo Principal'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33591803292567480.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33590524192567471.4001)
,p_button_name=>'P2222_GO'
,p_button_static_id=>'P2222_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63322631574135454.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(63319801445126819.4001)
,p_button_name=>'P2222_REPARENT'
,p_button_static_id=>'P2222_REPARENT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Nuevo Principal de Entradas Seleccionadas'
,p_button_position=>'NEXT'
,p_request_source=>'REPARENT'
,p_request_source_type=>'STATIC'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(33594809048619820.4001)
,p_branch_action=>'f?p=&APP_ID.:2222:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33590819531567476.4001)
,p_name=>'P2222_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(33590524192567471.4001)
,p_item_default=>'0'
,p_prompt=>'Lista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'  from wwv_flow_lists',
' where flow_id = :FB_FLOW_ID',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Lista -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione la lista que desea editar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33591305991567480.4001)
,p_name=>'P2222_NEW_PARENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(63319801445126819.4001)
,p_prompt=>'Crear Nuevo Principal en'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    LIST_ITEM_DISPLAY_SEQUENCE||''. ''||wwv_flow_escape.html(list_item_link_text) d,  ',
'    id',
'  from   ',
'    wwv_flow_list_items',
'  where  ',
'    list_id = replace(:P2222_LIST_ID,''%''||''null%'',null)',
'order by LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguna Entrada Principal -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el nuevo principal para las entradas de lista seleccionadas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63330605910175325.4001)
,p_name=>'P2222_START_WITH'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(33590524192567471.4001)
,p_prompt=>'Empezar por'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2222 LIST ENTRIES START WITH'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P2222_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todas las Entradas -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Restrinja la visualizaci\00F3n a las entradas de lista secundarias de esta entrada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(40234627784482846.4001)
,p_validation_name=>'P2222_NEW_PARENT'
,p_validation_sequence=>10
,p_validation=>'P2222_NEW_PARENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_when_button_pressed=>wwv_flow_api.id(63322631574135454.4001)
,p_associated_item=>wwv_flow_api.id(33591305991567480.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1194418100945758810.4001)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(33595925671624596.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1194418208384758811.4001)
,p_event_id=>wwv_flow_api.id(1194418100945758810.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63332016991178559.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_api.id(33591803292567480.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33727023172435350.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reparent List Entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if  :P2222_NEW_PARENT != 0 then',
'for i in 1..wwv_flow.g_f01.count loop',
'   update wwv_flow_list_items ',
'   set parent_list_item_id = :P2222_NEW_PARENT',
'   where list_id = :P2222_LIST_ID and ',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id and ',
'         flow_id = :fb_flow_id;',
'end loop;',
'else',
'for i in 1..wwv_flow.g_f01.count loop',
'   update wwv_flow_list_items ',
'   set parent_list_item_id = null',
'   where list_id = :P2222_LIST_ID and ',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id and ',
'         flow_id = :fb_flow_id and',
'         :P2222_NEW_PARENT = 0;',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'No se ha podido crear un nuevo principal de las entradas de lista'
,p_process_when_button_id=>wwv_flow_api.id(63322631574135454.4001)
,p_process_when=>'nvl(wwv_flow.g_f01.count,0) != 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Entradas de Lista con Nuevo Principal'
);
end;
/
prompt --application/pages/page_02300
begin
wwv_flow_api.create_page(
 p_id=>2300.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Control de acceso a la aplicaci\00F3n')
,p_step_title=>unistr('Control de acceso a la aplicaci\00F3n')
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_inline_css=>'.code-inline {white-space: normal; font-size: 11px; word-break: break-word;}'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2048320184861301.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(84648730194905207.4001)
,p_plug_name=>'Roles'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2050757180861325.4001)
,p_plug_name=>'Roles Report'
,p_parent_plug_id=>wwv_flow_api.id(84648730194905207.4001)
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.id, r.group_name name, r.static_id, r.group_desc description,',
'    (select count(*)',
'       from wwv_flow_acl_group_users u',
'      where u.group_id          = r.id',
'        and u.security_group_id = r.security_group_id ) assigned_user_count',
'from wwv_flow_fnd_user_groups r',
'where r.flow_id           = :FB_FLOW_ID',
'  and r.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2050828593861326.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se han definido roles de aplicaci\00F3n para esta aplicaci\00F3n')
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'SHAKEEB'
,p_internal_uid=>2050828593861326
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2050958389861327.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2051018825861328.4001)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Rol'
,p_column_link=>'f?p=&APP_ID.:2320:&SESSION.::&DEBUG.:RP,2320:F4000_P2320_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(84538588770706811.4001)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>unistr('Identificador est\00E1tico')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2051122296861329.4001)
,p_db_column_name=>'ASSIGNED_USER_COUNT'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Usuarios'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(724232932501924808.4001)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92468639617325917.4001)
,p_plug_name=>'Asignaciones de rol de usuario'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(342363357189652550.4001)
,p_plug_name=>'User Role Assignments Report'
,p_parent_plug_id=>wwv_flow_api.id(92468639617325917.4001)
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       user_name,',
'       role_names',
'  from apex_appl_acl_users',
' where application_id = :FB_FLOW_ID',
'   and workspace_id   = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(92468021968325911.4001)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CHRISTIAN'
,p_internal_uid=>92468021968325911
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(92468383956325914.4001)
,p_db_column_name=>'USER_NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Nombre de usuario'
,p_column_link=>'f?p=&APP_ID.:2310:&SESSION.::&DEBUG.:RP,2310:P2310_ID:#ID#'
,p_column_linktext=>'#USER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(183818757805773715.4001)
,p_db_column_name=>'ROLE_NAMES'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Roles'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(4348303304260378503.4001)
,p_db_column_name=>'ID'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(732476782572293403.4001)
,p_plug_name=>unistr('Control de acceso a la aplicaci\00F3n')
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1375157107785598382.4001)
,p_plug_name=>'Control de Acceso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El control de acceso requiere que los desarrolladores definan roles y usuarios de aplicaci\00F3n. Dado que los roles se aplican a usuarios, debe crear roles antes de agregar usuarios. Puede asignar usuarios a uno o m\00E1s roles.</p>'),
unistr('<p>Para controlar el acceso a componentes y p\00E1ginas de aplicaci\00F3n, debe crear un esquema de autorizaci\00F3n.</p> '),
'<p>Los roles y los usuarios definidos para las aplicaciones se pueden revisar con las siguientes vistas:<br>',
'<code>APEX_APPL_ACL_USERS<br>',
'APEX_APPL_ACL_USER_ROLES<br>',
'APEX_APPL_ACL_ROLES',
'</code>',
'</p>',
unistr('<p>Utilice la siguiente API para gestionar la configuraci\00F3n de control de acceso:<br>'),
'<code>APEX_ACL</code>',
'</p>',
unistr('<a href="&SYSTEM_HELP_URL./aeapi/APEX_ACL.html" target="_blank">Obtener m\00E1s informaci\00F3n...</a>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95187252405614222.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(342363357189652550.4001)
,p_button_name=>'CREATE_USER_ASSIGNMENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Agregar asignaci\00F3n de rol de usuario')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2310:&SESSION.::&DEBUG.:2310::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_fnd_user_groups r',
'where r.flow_id           = :FB_FLOW_ID',
'  and r.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(715710270785990572.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2050757180861325.4001)
,p_button_name=>'CREATE_ROLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Agregar rol'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2320:&SESSION.::&DEBUG.:2320::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109879628006242535.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(342363357189652550.4001)
,p_button_name=>'CREATE_USER_ASSIGNMENT_DISABLED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Agregar asignaci\00F3n de rol de usuario')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_fnd_user_groups r',
'where r.flow_id           = :FB_FLOW_ID',
'  and r.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(715712323606990586.4001)
,p_branch_action=>'2310'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(715710730315990580.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4911_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(715711087584990581.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2300'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(715711324753990582.4001)
,p_name=>'Refresh after Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(715710270785990572.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(183819485064773722.4001)
,p_name=>'Refresh'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(342363357189652550.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(183819570974773723.4001)
,p_event_id=>wwv_flow_api.id(183819485064773722.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(342363357189652550.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(92467852848325909.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(342363357189652550.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'User Assignments - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02310
begin
wwv_flow_api.create_page(
 p_id=>2310.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Asignaci\00F3n de Usuario')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Asignaci\00F3n de Usuario')
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-EditScreen-body {padding-top: 0;}',
'.apex-item-group--rc {margin: 4px 0}'))
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(84538272731706808.4001)
,p_plug_name=>unistr('Acerca de usuarios de aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="margin: 12px;"'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_source=>unistr('Los usuarios de la aplicaci\00F3n no se exportan como parte de la aplicaci\00F3n. Al desplegar la aplicaci\00F3n, tendr\00E1 que gestionar manualmente sus asignaciones de usuarios a roles. Los roles se exportan como parte de la exportaci\00F3n de una aplicaci\00F3n y se imp')
||unistr('ortan con las importaciones de aplicaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2194001926764519201.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(84538366606706809.4001)
,p_plug_name=>'Atributos de Usuario'
,p_parent_plug_id=>wwv_flow_api.id(2194001926764519201.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2809519452134236128.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95156035557580475.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2809519452134236128.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(''&DELETE_MSG.'', {request:''DELETE''});'
,p_button_execute_validations=>'N'
,p_button_condition=>'P2310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95156478329580479.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2809519452134236128.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar'
,p_button_position=>'NEXT'
,p_button_condition=>'P2310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95156801859580479.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2809519452134236128.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear asignaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'P2310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(95157285184580480.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2809519452134236128.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95154166004580466.4001)
,p_name=>'P2310_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(84538366606706809.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95154930255580470.4001)
,p_name=>'P2310_USER_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(84538366606706809.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de usuario'
,p_source=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_css_classes=>'u-textUpper'
,p_read_only_when=>'P2310_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(95155394255580471.4001)
,p_name=>'P2310_ROLE_IDS'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(84538366606706809.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Rol de Aplicaci\00F3n')
,p_source=>'ROLE_IDS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'APP_ACL_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d,',
'       id r',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by 1'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183819223624773720.4001)
,p_name=>'P2310_APPLICATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(84538366606706809.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'APPLICATION_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(222858806571540016.4001)
,p_computation_sequence=>10
,p_computation_item=>'P2310_USER_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P2310_USER_NAME)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(95158188037580491.4001)
,p_validation_name=>'user name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_acl_group_users u,',
'       wwv_flow_fnd_user_groups g',
' where u.security_group_id = :WORKSPACE_ID',
'   and u.user_name         = upper(:P2310_USER_NAME)',
'   and g.id                = u.group_id',
'   and g.flow_id           = :FB_FLOW_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La asignaci\00F3n de usuario ya existe.  ')
,p_when_button_pressed=>wwv_flow_api.id(95156801859580479.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(95159285570580492.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(95157285184580480.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(95159764749580493.4001)
,p_event_id=>wwv_flow_api.id(95159285570580492.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(95158483332580491.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from APEX_APPL_ACL_USERS'
,p_attribute_02=>'APEX_APPL_ACL_USERS'
,p_attribute_03=>'P2310_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'workspace_id = :WORKSPACE_ID'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(183818896809773716.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'DML'
,p_attribute_02=>'APEX_APPL_ACL_USERS'
,p_attribute_03=>'P2310_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'workspace_id = :WORKSPACE_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(183818948108773717.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_02320
begin
wwv_flow_api.create_page(
 p_id=>2320.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Rol'
,p_page_mode=>'MODAL'
,p_step_title=>'Rol'
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_inline_css=>'.a-EditScreen-body {padding-top: 0;}'
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(244599679538454702.4001)
,p_plug_name=>unistr('Esquemas de autorizaci\00F3n asociados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(212736479171785625.4001)
,p_name=>unistr('Esquemas de autorizaci\00F3n asociados')
,p_parent_plug_id=>wwv_flow_api.id(244599679538454702.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--noBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, scheme_type',
'    from wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    and ( scheme_type in (''NATIVE_IS_IN_GROUP'', ''NATIVE_IS_NOT_IN_GROUP'') )',
'    and instr(attribute_01, :F4000_P2320_NAME, 1) > 0'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'    from wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    and ( scheme_type in (''NATIVE_IS_IN_GROUP'', ''NATIVE_IS_NOT_IN_GROUP'') )',
'    and instr(attribute_01, :F4000_P2320_NAME, 1) > 0'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(212736728217785628.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(212736585906785626.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Esquema de Autorizaci\00F3n')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:RP,4008:F4000_P4008_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(212736645018785627.4001)
,p_query_column_id=>3
,p_column_alias=>'SCHEME_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo de Esquema'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(11239432234132441)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(244599572364454701.4001)
,p_plug_name=>'Aviso'
,p_parent_plug_id=>wwv_flow_api.id(244599679538454702.4001)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--page'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>unistr('Al modificar el nombre o el identificador est\00E1tico del rol, se puede producir un error de los siguientes esquemas de autorizaci\00F3n asociados.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2098848429433938746.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2714365954803655673.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(723638267001587820.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2714365954803655673.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P2320_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(723638614437587821.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2714365954803655673.4001)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P2320_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(723639016963587821.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2714365954803655673.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear rol'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P2320_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(723637864061587818.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2714365954803655673.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2050067757861318.4001)
,p_branch_name=>'Show Roles'
,p_branch_action=>'f?p=&APP_ID.:2300:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177065667019875217.4001)
,p_name=>'F4000_P2320_STATIC_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2098848429433938746.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(723633035202587807.4001)
,p_name=>'F4000_P2320_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2098848429433938746.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(723633423779587810.4001)
,p_name=>'F4000_P2320_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2098848429433938746.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(723633825844587811.4001)
,p_name=>'F4000_P2320_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2098848429433938746.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(723634785936587812.4001)
,p_name=>'F4000_P2320_DESCRIPTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2098848429433938746.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n')
,p_source=>'GROUP_DESC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(723639821255587834.4001)
,p_validation_name=>'name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and group_name        = :F4000_P2320_NAME',
'   and (   :F4000_P2320_ID is null',
'        or id              <> :F4000_P2320_ID )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otro rol ya est\00E1 utilizando #LABEL#.  ')
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(723633825844587811.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177068028295885503.4001)
,p_validation_name=>'Only Valid Characters'
,p_validation_sequence=>40
,p_validation=>'F4000_P2320_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('El identificador solo puede contener caracteres alfanum\00E9ricos y "_".')
,p_associated_item=>wwv_flow_api.id(177065667019875217.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(723641331942587836.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(723637864061587818.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(723641828608587837.4001)
,p_event_id=>wwv_flow_api.id(723641331942587836.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(177067845109885501.4001)
,p_name=>'Update Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P2320_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'F4000_P2320_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(177067906911885502.4001)
,p_event_id=>wwv_flow_api.id(177067845109885501.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$s(''F4000_P2320_STATIC_ID'',$v(''F4000_P2320_NAME'').replace(/\s+/g, ''_'').toUpperCase());'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(723640174318587835.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_FND_USER_GROUPS'
,p_attribute_02=>'WWV_FLOW_FND_USER_GROUPS'
,p_attribute_03=>'F4000_P2320_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    flow_id           = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(723640598242587835.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_02=>'WWV_FLOW_FND_USER_GROUPS'
,p_attribute_03=>'F4000_P2320_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    flow_id           = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n Procesada')
);
end;
/
prompt --application/pages/page_03009
begin
wwv_flow_api.create_page(
 p_id=>3009.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Aplicaci\00F3n: Identificar Destino de Copia')
,p_step_title=>unistr('Crear Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20647615170785101.4001)
,p_plug_name=>unistr('Crear Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20648424521787810.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(139866417493663090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(41970322993525165.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149607092138180.4001)
,p_plug_name=>unistr('Crear Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20647831777785102.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(41970322993525165.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20648216317785103.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(41970322993525165.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20648006978785103.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(41970322993525165.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(23759618480442454.4001)
,p_branch_action=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(20648216317785103.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20648917164804639.4001)
,p_name=>'P3009_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20647615170785101.4001)
,p_item_default=>'0'
,p_prompt=>'Copiar de'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Elegir Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el nombre de la aplicaci\00F3n que desea copiar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20649132055808948.4001)
,p_name=>'P3009_COPY_TO'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20647615170785101.4001)
,p_prompt=>'Copiar en'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca un breve nombre descriptivo para la aplicaci\00F3n para distinguir la nueva aplicaci\00F3n en los informes y listas de selecci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20652902282876073.4001)
,p_name=>'P3009_NEW_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20647615170785101.4001)
,p_prompt=>unistr('Identificador de Nueva Aplicaci\00F3n')
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique un valor entero que identifique la aplicaci\00F3n. El identificador de aplicaci\00F3n debe ser \00FAnico en la instancia de &PRODUCT_NAME.<br /><br />'),
unistr('&PRODUCT_NAME. reserva los identificadores de aplicaci\00F3n incluidos en el rango de 3000 a 9000 para utilizarlos de forma interna.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20653413017879159.4001)
,p_name=>'P3009_COPY_DEPLOYMENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20647615170785101.4001)
,p_item_default=>'N'
,p_prompt=>'Copiar Definiciones de Objeto de Soporte'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Puede copiar las definiciones de objetos de soporte, las opciones de configuraci\00F3n y los scripts en la aplicaci\00F3n. '),
'<p />',
unistr('Seleccione <strong>Activado</strong> para incluir definiciones de objetos de base de datos, definiciones de im\00E1genes y sentencias SQL de datos iniciales encapsulados en un solo archivo.'),
'Seleccione <strong>Desactivado</strong> para no incluir definiciones de objetos de soporte.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(23778031696550324.4001)
,p_computation_sequence=>10
,p_computation_item=>'P84_COPY_FROM_NAME'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flows f',
'where security_group_id = :flow_security_group_id',
'and id = :P3009_COPY_FROM'))
,p_compute_when=>'P3009_COPY_FROM'
,p_compute_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23859315401744351.4001)
,p_validation_name=>'P3009_COPY_FROM'
,p_validation_sequence=>10
,p_validation=>'P3009_COPY_FROM'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('Identifique la aplicaci\00F3n que desea copiar.')
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20648917164804639.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23882630947796115.4001)
,p_validation_name=>'P3009_NEW_APP_ID'
,p_validation_sequence=>20
,p_validation=>'P3009_NEW_APP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20652902282876073.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23882115925782344.4001)
,p_validation_name=>'P3009_NEW_APP_ID positive, whole number'
,p_validation_sequence=>30
,p_validation=>'P3009_NEW_APP_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de aplicaci\00F3n debe ser un n\00FAmero entero y positivo.')
,p_validation_condition=>'P3009_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20652902282876073.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23751328645379097.4001)
,p_validation_name=>'new ID not same as old ID'
,p_validation_sequence=>40
,p_validation=>'ltrim(:P3009_NEW_APP_ID,''0'') != nvl(:P3009_COPY_FROM,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nuevo identificador de aplicaci\00F3n debe ser diferente al identificador de la aplicaci\00F3n actual.')
,p_validation_condition=>'P3009_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23751500379380452.4001)
,p_validation_name=>'reserved app id check'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_utilities.is_available_application_id(',
'    p_security_group_id => :flow_security_group_id,',
'    p_application_id    => :P3009_NEW_APP_ID,',
'    p_check_reserved    => FALSE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Identificador de aplicaci\00F3n reservado.')
,p_validation_condition=>':flow_security_group_id != 10 and wwv_flow_utilities.is_numeric(:P3009_NEW_APP_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20652902282876073.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23751706266382146.4001)
,p_validation_name=>'cannot copy invalid range flow'
,p_validation_sequence=>60
,p_validation=>':P3009_NEW_APP_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La aplicaci\00F3n que est\00E1 intentando copiar est\00E1 reservada.')
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P3009_NEW_APP_ID is not null) and (wwv_flow_utilities.is_numeric(:P3009_NEW_APP_ID))'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20652902282876073.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23751911807383695.4001)
,p_validation_name=>'no deployment exists'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_install_scripts ',
'where flow_id = :P3009_COPY_FROM',
'and security_group_id = :flow_security_group_id'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Debe definir al menos un script de instalaci\00F3n para copiar definiciones de objeto de soporte.')
,p_validation_condition=>'P3009_COPY_DEPLOYMENT'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20653413017879159.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23752116309385057.4001)
,p_validation_name=>'application ID exists'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flows',
'where id = :P3009_NEW_APP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ya existe un nuevo identificador de aplicaci\00F3n.')
,p_validation_condition=>'wwv_flow_utilities.is_numeric(:P3009_NEW_APP_ID) and ltrim(:P3009_NEW_APP_ID,''0'') != nvl(:P3009_COPY_FROM,-1)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(20652902282876073.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23882322504784255.4001)
,p_validation_name=>'Restricted users may not create applications'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.restricted_schema(',
'   p_schema => wwv_flow_user_api.get_default_schema, ',
'   p_security_group_id => wwv_flow_security.g_security_group_id) then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Esquema restringido, puede que no se cree la aplicaci\00F3n.')
,p_validation_condition=>'wwv_flow_security.g_security_group_id <> 10'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(20648216317785103.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(153868110618185944.4001)
,p_name=>'Set Copy To Default Value'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3009_COPY_FROM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(153868416857185945.4001)
,p_event_id=>wwv_flow_api.id(153868110618185944.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3009_COPY_TO'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flows',
'where id = :P3009_COPY_FROM',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P3009_COPY_FROM'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_03890
begin
wwv_flow_api.create_page(
 p_id=>3890.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Prueba de LDAP'
,p_page_mode=>'MODAL'
,p_step_title=>'Prueba de LDAP'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function() {',
'    if ($v("P3890_FIRST_VIEW") === "YES") {',
'        var l_values = parent.LDAPTestGetValues();',
'        $s("P3890_LDAP_HOST"        , l_values.host);',
'        $s("P3890_PORT"             , l_values.port);',
'        $s("P3890_USE_SSL"          , l_values.use_ssl);',
'        $s("P3890_DN"               , l_values.dn_string);',
'        $s("P3890_USE_EXACT_DN"     , l_values.use_dn);',
'        $s("P3890_SEARCH_FILTER"    , l_values.search_filter);',
'        $s("P3890_USERNAME_EDIT"    , l_values.edit_function);',
'        $s("P3890_USERNAME_ESCAPING", l_values.username_escaping);',
'        $s("P3890_FIRST_VIEW"       , "NO");',
'    }',
'})();',
''))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'700'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_auth_preconfig.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49595132114659790.4001)
,p_plug_name=>unistr('Par\00E1metros')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(49600904419727514.4001)
,p_plug_name=>unistr('Credenciales de Conexi\00F3n de Prueba')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(716353189532823638.4001)
,p_plug_name=>'Barra de Botones del Asistente'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(49753202827162326.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(716353189532823638.4001)
,p_button_name=>'FINISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29441316397731287.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(716353189532823638.4001)
,p_button_name=>'TEST_LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Conexi\00F3n de Prueba')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29418308402099980.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(716353189532823638.4001)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(49605110137767049.4001)
,p_branch_action=>'f?p=&APP_ID.:3890:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29410110851944068.4001)
,p_name=>'P3890_USERNAME_ESCAPING'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_prompt=>unistr('Identificaci\00F3n de Nombre de Usuario')
,p_source=>'STD'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LDAP_USERNAME_ESCAPING'
,p_lov=>'.'||wwv_flow_api.id(39475531325852002.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49596318739665432.4001)
,p_name=>'P3890_LDAP_HOST'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_prompt=>'Host LDAP'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca aqu\00ED el nombre del servidor LDAP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49597025665667372.4001)
,p_name=>'P3890_PORT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_item_default=>'389'
,p_prompt=>'Puerto'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero de puerto para el servidor LDAP.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49599919525722432.4001)
,p_name=>'P3890_DN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_item_default=>'cn=%LDAP_USER%,dc=oracle,dc=com'
,p_prompt=>'Cadena de Nombre Distintivo (DN)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la cadena de DN para el servidor LDAP.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49600529914725426.4001)
,p_name=>'P3890_USERNAME_EDIT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_prompt=>unistr('Funci\00F3n de Edici\00F3n de Nombre de Usuario de LDAP')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la funci\00F3n de edici\00F3n de nombre de usuario para el servidor LDAP, si es necesario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49601509613729053.4001)
,p_name=>'P3890_USERNAME'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(49600904419727514.4001)
,p_prompt=>'Usuario'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el nombre de usuario para el servidor LDAP, si es necesario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49602321041732311.4001)
,p_name=>'P3890_PASSWORD'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(49600904419727514.4001)
,p_prompt=>unistr('Contrase\00F1a')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a para el servidor LDAP, si es necesario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(240743322394973385.4001)
,p_name=>'P3890_FIRST_VIEW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_item_default=>'YES'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(487363722302444828.4001)
,p_name=>'P3890_USE_SSL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_prompt=>'Usar SSL:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LDAP_SSL_PLUGIN_LOV'
,p_lov=>'.'||wwv_flow_api.id(29453800248365382.4001)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Elija si desea utilizar SSL para enlazar al directorio LDAP. Si se elige SSL con la autenticaci\00F3n, deber\00E1 configurar una cartera para la instancia de &PRODUCT_NAME..')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(493020915082662128.4001)
,p_name=>'P3890_USE_EXACT_DN'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_item_default=>'Y'
,p_prompt=>'Usar Nombre Distinguido Exacto (DN)'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Elija si el nombre distintivo (DN) de LDAP ser\00E1 exacto o no. Si no lo es, se convertir\00E1 en la base de b\00FAsqueda y deber\00E1 proporcionar un filtro de b\00FAsqueda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(493021432398667143.4001)
,p_name=>'P3890_SEARCH_FILTER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(49595132114659790.4001)
,p_prompt=>unistr('Filtro de B\00FAsqueda')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.SEARCH_FILTER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_06 d,',
'       attribute_06 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_06 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el filtro de b\00FAsqueda cuando no utilice un nombre distintivo (DN) exacto. Utilice <strong>%LDAP_USER%</strong> como variable del nombre de usuario. Por ejemplo:'),
'<br /><br />cn=%LDAP_USER%'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240737320878963405.4001)
,p_validation_name=>'DN must have LDAP_USER'
,p_validation_sequence=>10
,p_validation=>'instr(:P3890_DN,''%LDAP_USER%'') > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La cadena de DN debe contener %LDAP_USER%'
,p_validation_condition=>'P3890_USE_EXACT_DN'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(29441316397731287.4001)
,p_associated_item=>wwv_flow_api.id(49599919525722432.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(493114508342473898.4001)
,p_validation_name=>'DN must have LDAP_USER'
,p_validation_sequence=>30
,p_validation=>'instr(:P3890_SEARCH_FILTER,''%LDAP_USER%'') > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El filtro de b\00FAsqueda debe contener %LDAP_USER%')
,p_validation_condition=>'P3890_USE_EXACT_DN'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(49599919525722432.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(493030726828788558.4001)
,p_name=>'Show/hide Search Filter'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3890_USE_EXACT_DN'
,p_condition_element=>'P3890_USE_EXACT_DN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(493031021135788560.4001)
,p_event_id=>wwv_flow_api.id(493030726828788558.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3890_SEARCH_FILTER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(493031219124788560.4001)
,p_event_id=>wwv_flow_api.id(493030726828788558.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3890_SEARCH_FILTER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(485481857460873367.4001)
,p_name=>'Pass back'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(49753202827162326.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(485482191743873367.4001)
,p_event_id=>wwv_flow_api.id(485481857460873367.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    parent.LDAPTestSetValues ({',
'        host:              $v("P3890_LDAP_HOST"),',
'        port:              $v("P3890_PORT"),',
'        use_ssl:           $v("P3890_USE_SSL"),',
'        dn_string:         $v("P3890_DN"),',
'        use_dn:            $v("P3890_USE_EXACT_DN"),',
'        search_filter:     $v("P3890_SEARCH_FILTER"),',
'        edit_function:     $v("P3890_USERNAME_EDIT"),',
'        username_escaping: $v("P3890_USERNAME_ESCAPING") });'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(485482397239876351.4001)
,p_event_id=>wwv_flow_api.id(485481857460873367.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(485482792483898255.4001)
,p_name=>'close dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(29418308402099980.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(485483028069898255.4001)
,p_event_id=>wwv_flow_api.id(485482792483898255.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(49609818112844982.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.test_ldap_authentication(    ',
'    p_username            => :P3890_USERNAME,',
'    p_password            => :P3890_PASSWORD,',
'    p_ldap_host           => :P3890_LDAP_HOST,',
'    p_ldap_port           => :P3890_PORT,',
'    p_use_ssl             => :P3890_USE_SSL,',
'    p_use_exact_dn        => :P3890_USE_EXACT_DN,',
'    p_ldap_string         => :P3890_DN,',
'    p_search_filter       => :P3890_SEARCH_FILTER,',
'    p_ldap_edit_function  => :P3890_USERNAME_EDIT,',
'    p_username_escaping   => :P3890_USERNAME_ESCAPING,',
'    p_application_id      => nv(''FB_FLOW_ID'') );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Fallo de autenticaci\00F3n'),
'<p>',
'#SQLERRM_TEXT#',
'</p>'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(29441316397731287.4001)
,p_process_success_message=>'Autenticado'
);
end;
/
prompt --application/pages/page_04001
begin
wwv_flow_api.create_page(
 p_id=>4001.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Definici\00F3n de Aplicaci\00F3n')
,p_step_title=>unistr('Editar Definici\00F3n de Aplicaci\00F3n')
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_attr_standard.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(283953577.4001)
,p_plug_name=>unistr('Aplicaci\00F3n &FB_FLOW_ID.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(284956612.4001)
,p_plug_name=>'Nombre'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(407106391.4001)
,p_name=>unistr('Opciones de Creaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name,',
'       patch_status,',
'       decode(patch_status,',
'           ''INCLUDE'',''green'',',
'           ''red'') patch_status_color,',
'       patch_comment',
'from #OWNER#.wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order by 2, 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No hay ninguna opci\00F3n de creaci\00F3n definida.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48903831646773009.4001)
,p_query_column_id=>1
,p_column_alias=>'PATCH_NAME'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Opci\00F3n de Creaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48903906487773009.4001)
,p_query_column_id=>2
,p_column_alias=>'PATCH_STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<b style="color:#PATCH_STATUS_COLOR#">#PATCH_STATUS#</b>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1215661819905752193.4001)
,p_query_column_id=>3
,p_column_alias=>'PATCH_STATUS_COLOR'
,p_column_display_sequence=>3
,p_column_heading=>'Patch Status Color'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48904009439773009.4001)
,p_query_column_id=>4
,p_column_alias=>'PATCH_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Comentario'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85248570290.4001)
,p_plug_name=>'Sustituciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Form--leftLabels:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice cadenas de sustituci\00F3n est\00E1ticas para las frases o etiquetas que aparecen en muchos lugares de la aplicaci\00F3n. Para crear una cadena de sustituci\00F3n, introduzca el nombre en la columna Cadena de Sustituci\00F3n y el valor de cadena en la columna Va')
||unistr('lor de Sustituci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1421934290786015.4001)
,p_plug_name=>unistr('Impresi\00F3n de Informe')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2430011519300734.4001)
,p_plug_name=>'Banner de copyright'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3400696765019501.4001)
,p_plug_name=>unistr('Aplicaci\00F3n web progresiva')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6257403627000045.4001)
,p_plug_name=>'Manejo de Errores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46250108023678996.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>145
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(74090417789091344.4001)
,p_plug_name=>'Disponibilidad'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(84785704645417330.4001)
,p_plug_name=>unistr('Notificaci\00F3n Global')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92874711660553332.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198116031744061165.4001)
,p_plug_name=>'Propiedades'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(274899318766622408.4001)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(274897624522614662.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615321908441503858.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOWS',
'where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :FB_FLOW_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631549507496287263.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Edite la definici\00F3n de aplicaci\00F3n general.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(879700077231493822.4001)
,p_plug_name=>unistr('Icono de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1378289375072029933.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1421934290786015.4001)
,p_button_name=>'ADD_REMOTE_PRINT_SERVER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar servidor de impresi\00F3n remoto')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1935:&SESSION.::&DEBUG.:CR,1935::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40006876470919.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(283953577.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP,1::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40006877470919.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(283953577.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:2110::'
,p_button_condition=>'v(''FB_FLOW_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40006878470920.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(283953577.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''FB_FLOW_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(107950530564729123.4001)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::FB_FLOW_ID:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40006878470920.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id and id = :fb_flow_id and build_status = ''RUN_ONLY'''
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40006881470920.4001)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(17572204941560191.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(40006878470920.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480962819964282124.4001)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480963812953299018.4001)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(42449828569597528.4001)
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(40006882470921.4001)
,p_branch_action=>'9'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480965127460350446.4001)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(388967724.4001)
,p_name=>'F4000_P4001_FLOW_VERSION'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(284956612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n')
,p_source=>'FLOW_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Incluye el n\00FAmero de versi\00F3n de la aplicaci\00F3n en una p\00E1gina. Tambi\00E9n puede unir autom\00E1ticamente la versi\00F3n a la fecha de la \00FAltima modificaci\00F3n utilizando las siguientes m\00E1scaras de formato:<p>'),
'<ul>',
'<li>AAAA.MM.DD</li>',
'<li>MM.DD.AAAA</li>',
'<li>DD.MM.AAAA</li>  ',
'</ul>',
unistr('<p>Si la versi\00F3n de la aplicaci\00F3n utiliza el formato "AAAA.MM.DD", &PRODUCT_NAME. sustituye esta m\00E1scara de formato por la fecha de la \00FAltima modificaci\00F3n de cualquier atributo de aplicaci\00F3n.')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3893122313.4001)
,p_name=>'F4000_P4001_BUILD_STATUS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(74090417789091344.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>unistr('Estado&nbsp;de&nbsp;Creaci\00F3n')
,p_source=>'BUILD_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_api.id(84305510710571518.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifica el estado de creaci\00F3n de la aplicaci\00F3n actual. Las opciones incluyen:<br>'),
unistr('<ul><li><strong>S\00F3lo Ejecutar Aplicaci\00F3n</strong>: Los usuarios s\00F3lo pueden ejecutar la aplicaci\00F3n. Esta opci\00F3n est\00E1 destinada a aplicaciones de una instancia de producci\00F3n.</li>'),
unistr('<li><strong>Ejecutar y Crear Aplicaci\00F3n</strong>: Los desarrolladores y usuarios pueden ejecutar y desarrollar la aplicaci\00F3n.</li>'),
'</ul>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53943804854.4001)
,p_name=>'F4000_P4001_PROXY_SERVER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Servidor Proxy'
,p_source=>'PROXY_SERVER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Utilice este campo para especificar un servidor proxy.<p/>',
unistr('Por ejemplo, puede que el creador de aplicaciones necesite un servidor proxy si se va a utilizar un tipo de origen de regi\00F3n de URL. El origen de regi\00F3n de URL incluye el resultado de la URL (es decir, la p\00E1gina que se devuelve al navegar a la URL) c')
||unistr('omo el origen de regi\00F3n. Si utiliza un firewall y el destino de la URL est\00E1 fuera del firewall relativo al creador de aplicaciones, puede que necesite especificar un servidor proxy.<p/>'),
'Puede hacer referencia a los valores introducidos en este campo desde PL/SQL con la variable de paquete PL/SQL <code>APEX_APPLICATION.G_PROXY_SERVER</code>. Por ejemplo:',
'<pre>www-proxy.example.com</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85250579435.4001)
,p_name=>'SUBSTITUTION_STRING_01'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 1')
,p_source=>'SUBSTITUTION_STRING_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85252581887.4001)
,p_name=>'SUBSTITUTION_VALUE_01'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 1')
,p_source=>'SUBSTITUTION_VALUE_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85255597012.4001)
,p_name=>'F4000_P4001_STRING_TITLE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n')
,p_source=>'''<span class="instructiontext">''||wwv_flow_lang.system_message(''F4000.P4001.SUBSTITUTION_STR'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifique el nombre de la cadena de sustituci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85257601365.4001)
,p_name=>'F4000_P4001_VALUE_TITLE'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n ')
,p_source=>'''<span class="instructiontext">''||wwv_flow_lang.system_message(''F4000.P4001.SUBSTITUTION_VALUE'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifique el valor de sustituci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85264616083.4001)
,p_name=>'SUBSTITUTION_STRING_02'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 2')
,p_source=>'SUBSTITUTION_STRING_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85266616894.4001)
,p_name=>'SUBSTITUTION_STRING_03'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 3')
,p_source=>'SUBSTITUTION_STRING_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85268617706.4001)
,p_name=>'SUBSTITUTION_STRING_04'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 4')
,p_source=>'SUBSTITUTION_STRING_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85270618600.4001)
,p_name=>'SUBSTITUTION_STRING_05'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 5')
,p_source=>'SUBSTITUTION_STRING_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85272619586.4001)
,p_name=>'SUBSTITUTION_STRING_06'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 6')
,p_source=>'SUBSTITUTION_STRING_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85274620362.4001)
,p_name=>'SUBSTITUTION_STRING_07'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 7')
,p_source=>'SUBSTITUTION_STRING_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85276621095.4001)
,p_name=>'SUBSTITUTION_STRING_08'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 8')
,p_source=>'SUBSTITUTION_STRING_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85278624279.4001)
,p_name=>'SUBSTITUTION_VALUE_02'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 2')
,p_source=>'SUBSTITUTION_VALUE_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85282625282.4001)
,p_name=>'SUBSTITUTION_VALUE_03'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 3')
,p_source=>'SUBSTITUTION_VALUE_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85284626749.4001)
,p_name=>'SUBSTITUTION_VALUE_04'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 4')
,p_source=>'SUBSTITUTION_VALUE_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85289634304.4001)
,p_name=>'SUBSTITUTION_VALUE_05'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 5')
,p_source=>'SUBSTITUTION_VALUE_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85291636066.4001)
,p_name=>'SUBSTITUTION_VALUE_06'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 6')
,p_source=>'SUBSTITUTION_VALUE_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85293636755.4001)
,p_name=>'SUBSTITUTION_VALUE_07'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 7')
,p_source=>'SUBSTITUTION_VALUE_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85295637498.4001)
,p_name=>'SUBSTITUTION_VALUE_08'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 8')
,p_source=>'SUBSTITUTION_VALUE_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146826158978.4001)
,p_name=>'F4000_P4001_FLOW_STATUS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(74090417789091344.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'AVAILABLE'
,p_prompt=>'Estado'
,p_source=>'FLOW_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_FLOW_STATUS'
,p_lov=>'.'||wwv_flow_api.id(634347472712995.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifica si la aplicaci\00F3n est\00E1 o no disponible para su uso. <p>'),
'Las opciones incluyen:<br>',
'<ul>',
unistr('<li><strong>Disponible</strong>: La aplicaci\00F3n est\00E1 disponible sin restricciones.</li>'),
unistr('<li><strong>Disponible con barra de herramientas del desarrollador</strong>: La aplicaci\00F3n est\00E1 disponible para su uso. Para los desarrolladores, la barra de herramientas del desarrollador se incluye en cada p\00E1gina. Es necesario que el desarrollador ')
||unistr('est\00E9 conectado al creador de aplicaciones en la misma sesi\00F3n del explorador.</li>'),
unistr('<li><strong>Disponible Solo para Desarrolladores</strong>: La aplicaci\00F3n est\00E1 disponible para los usuarios que tienen privilegios de desarrollador.</li>'),
unistr('<li><strong>Acceso Restringido</strong>: La aplicaci\00F3n est\00E1 disponible para los desarrolladores especificados en Limitar a Lista de Usuarios Separados por Comas.</li>'),
unistr('<li><strong>No Disponible</strong>: La aplicaci\00F3n no se puede ejecutar ni editar. Aparece el mensaje Mensaje para aplicaci\00F3n no disponible cuando los usuarios intentan acceder a la aplicaci\00F3n.</li>'),
unistr('<li><strong>No Disponible (Estado mostrado con PL/SQL)</strong>: La aplicaci\00F3n no se puede ejecutar ni editar.</li>'),
unistr('<li><strong>No Disponible (Redirigir a URL)</strong>: La aplicaci\00F3n no se puede ejecutar. El usuario se enlaza a la URL introducida en Mensaje para aplicaci\00F3n no disponible.</li>'),
'</ul>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146840201714.4001)
,p_name=>'F4000_P4001_FLOW_UNAVAILABLE_TEXT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(74090417789091344.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return wwv_flow_lang.system_message(''F4000_P4001_UNAVAIL'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Mensaje para aplicaci\00F3n no disponible')
,p_source=>'FLOW_UNAVAILABLE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Utilice este atributo junto con el estado.<p/>',
'Si define el estado en <strong>No Disponible</strong>, <strong>No Disponible (Estado Mostrado con PL/SQL)</strong> o <strong>No Disponible (Redirigir a URL)</strong>, se muestra el texto introducido en este atributo.<p/>',
'Si define el estado en <strong>Disponible</strong>, no se muestra el texto introducido en este atributo. '))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(147579121481.4001)
,p_name=>'F4000_P4001_RESTRICT_TO_USER_LIST'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(74090417789091344.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Limitar a lista de usuarios separados por comas (el estado debe ser Acceso Restringido)'
,p_source=>'RESTRICT_TO_USER_LIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice este atributo junto con el estado <strong>Acceso Restringido</strong>. Si define el estado en <strong>Acceso Restringido</strong>, s\00F3lo los usuarios mostrados en este atributo pueden ejecutar la aplicaci\00F3n.<p/> Para utilizar este atributo:'),
'<ol>',
'<li>De la lista Estado, seleccione <strong>Acceso Restringido</strong>.</li>',
unistr('<li>Introduzca una lista delimitada por comas de los usuarios que pueden ejecutar la aplicaci\00F3n en el campo proporcionado.</li>')))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40006870470918.4001)
,p_name=>'FB_UPD_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(284956612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>32
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('N\00FAmero de identificaci\00F3n num\00E9rico (identificador) que identifica la aplicaci\00F3n. Cada aplicaci\00F3n se identifica de forma \00FAnica mediante un identificador.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40006871470918.4001)
,p_name=>'FB_UPD_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(284956612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Proporciona una abreviatura descriptiva para la aplicaci\00F3n para distinguirla de otras aplicaciones en el entorno de desarrollo.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40006873470919.4001)
,p_name=>'FB_UPD_LOGGING'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'YES'
,p_prompt=>'Registro'
,p_source=>'WEBDB_LOGGING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''APPLICATION_ACTIVITY_LOGGING''), ''U'') in (''A'' /* Always */, ''N'' /* Never */)'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Determina si la actividad del usuario se registra en el log de actividades. Si se define en <strong>Activado</strong>, se registran todas las vistas de p\00E1gina, permitiendo que un administrador supervise la actividad del usuario para cada aplicaci\00F3n.<')
||'p/>',
'<p>',
unistr('La desactivaci\00F3n del registro puede ser aconsejable para aplicaciones de grandes vol\00FAmenes.'),
'</p>',
'<p>',
unistr('Este atributo s\00F3lo se puede modificar si la configuraci\00F3n de funci\00F3n "Registro de Actividades de Aplicaciones" en la administraci\00F3n interna de &PRODUCT_NAME. se define en "Usar Configuraci\00F3n de Aplicaci\00F3n".'),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
,p_attribute_04=>'NO'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1378952136513217.4001)
,p_name=>'P4001_ORACLE_TEXT_FUNCTION'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n de Oracle Text')
,p_source=>'ORACLE_TEXT_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La sintaxis de las consultas de Oracle Text es muy compleja y potente, y proporciona un rico conjunto de operadores de consulta para utilizar comodines, b\00FAsquedas parciales, etc.'),
unistr('Pero para los usuarios finales, esta sintaxis suele ser dif\00EDcil de entender; solo desean escribir texto y que las funciones de consulta se apliquen autom\00E1ticamente.</p>'),
unistr('<p>Por este motivo, puede especificar el nombre de una funci\00F3n PL/SQL que convierta la entrada del usuario final en una consulta de Oracle Text. La funci\00F3n toma la entrada del usuario final como VARCHAR2 y devuelve la consulta de Oracle Text como res')
||'ultado.</p>',
'<p>',
unistr('En este ejemplo se usa la <i>b\00FAsqueda parcial</i> de Oracle Text para todas las consultas'),
'</p>',
'<pre>',
'function convert_end_user_search (',
'    p_search in varchar2 )',
'    return varchar2 ',
'is',
'begin',
'    return ''FUZZY({'' || replace( p_search, ''}'', ''\}'' ) || ''}, 30, 2000)'';',
'end;',
'</pre>',
unistr('<p>En este ejemplo se hace uso de la <i>relajaci\00F3n de consulta</i>, que ejecuta las consultas exactas primero y agrega funciones de b\00FAsqueda parcial o de comod\00EDn despu\00E9s, cuando la consulta exacta no devuelve suficientes filas. Todo el proceso es tra')
||'nsparente para el usuario final.',
'</p>',
'<pre>',
'create or replace function convert_end_user_search (',
'    p_search in varchar2 )',
'    return varchar2 ',
'is',
'    c_xml constant varchar2(32767) := ''&lt;query&gt;&lt;textquery>&lt;progression&gt;'' ||',
'                                        ''&lt;seq&gt;  #SEARCH#  &lt;/seq&gt;'' ||',
'                                        ''&lt;seq&gt; ?#SEARCH#  &lt;/seq&gt;'' ||',
'                                        ''&lt;seq&gt;  #SEARCH#% &lt;/seq&gt;'' ||',
'                                        ''&lt;seq&gt; %#SEARCH#% &lt;/seq&gt;'' ||',
'                                      ''&lt;/progression>&lt;/textquery>&lt;/query&gt;'';',
'    l_search varchar2(32767) := p_search;',
'begin',
'    -- remove special characters; irrelevant for full text search',
'    l_search := regexp_replace( l_search, ''[&lt;&gt;{}/()*%&!$?.:,;\+#]'', '''' );',
'',
'    return replace( c_xml, ''#SEARCH#'', l_search );',
'end;',
'</pre>',
unistr('<p>Para obtener m\00E1s informaci\00F3n sobre la sintaxis de las consultas de Oracle Text y la caracter\00EDstica de relajaci\00F3n, consulte <a target="_blank" href="https://docs.oracle.com/database/121/CCAPP/toc.htm">Oracle Text Application Developers Guide</a>.</')
||'p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1422060242786016.4001)
,p_name=>'P4001_PRINT_SERVER_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1421934290786015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de servidor de impresi\00F3n')
,p_source=>'PRINT_SERVER_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP PRINT SERVER TYPE'
,p_lov=>'.'||wwv_flow_api.id(6801471089410875.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Controla el servidor de impresi\00F3n de la aplicaci\00F3n. Esta configuraci\00F3n sustituye la configuraci\00F3n de los servicios de administraci\00F3n. Entre las opciones disponibles se incluyen:</p>'),
'<ul>',
unistr('<li><strong>Impresi\00F3n nativa</strong>. Utilice la impresi\00F3n nativa. No se necesita ning\00FAn servidor de impresi\00F3n externo.</li>'),
unistr('<li><strong>Servidor de impresi\00F3n remoto</strong>. Seleccione un servidor remoto de tipo "servidor de impresi\00F3n" que est\00E9 configurado en las utilidades del espacio de trabajo.</li>'),
unistr('<li><strong>Utilizar configuraci\00F3n de instancia</strong>. Utilice la configuraci\00F3n de la impresi\00F3n de informe definida en los servicios de administraci\00F3n.</li>'),
'</ul>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1422184336786017.4001)
,p_name=>'P4001_PRINT_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1421934290786015.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id',
'  from (select id ',
'          from wwv_remote_servers',
'         where server_type = ''PRINT_SERVER''',
'           and security_group_id = :FLOW_SECURITY_GROUP_ID) a',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>unistr('Servidor de impresi\00F3n remoto')
,p_source=>'PRINT_REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_PRINT_SERVER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''PRINT_SERVER''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione un servidor remoto definido en las utilidades del espacio de trabajo de tipo "servidor de impresi\00F3n".</p>')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1422648082786022.4001)
,p_name=>'P4001_PRINT_AUTH_REQUIRED'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1421934290786015.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Autenticaci\00F3n necesaria')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina si utilizar la autenticaci\00F3n para el servidor de impresi\00F3n remoto. Entre las opciones disponibles se incluyen:</p>'),
'<ol>',
unistr('<li><strong>Activado</strong>. Autentique las solicitudes del servidor de impresi\00F3n utilizando una credencial.</li>'),
unistr('<li><strong>Desactivado</strong>. El servidor de impresi\00F3n no necesita ninguna autenticaci\00F3n.</li>'),
'</ol> '))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1422786998786023.4001)
,p_name=>'P4001_PRINT_CREDENTIAL_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1421934290786015.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credenciales'
,p_source=>'PRINT_CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
' order by name'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Seleccione una credencial definida en las utilidades del espacio de trabajo.</p>'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2430140266300735.4001)
,p_name=>'P4001_COPYRIGHT_BANNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2430011519300734.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Banner de copyright'
,p_source=>'COPYRIGHT_BANNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto de banner de copyright aqu\00ED. Se incluir\00E1 en el archivo de exportaci\00F3n de la aplicaci\00F3n de APEX. Puede usar la cadena de sustituci\00F3n <code>#APP_NAME#</code> para hacer referencia al nombre de aplicaci\00F3n actual, y <code>#YEAR#</code')
||unistr('> para hacer referencia al a\00F1o actual. <br/><br/>Por ejemplo:'),
'<pre>',
'Nombre: #APP_NAME#',
unistr('Copyright (c) 1999, #YEAR#, nombre de la compa\00F1\00EDa.'),
'</pre>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3000410460300301.4001)
,p_name=>'P4001_PWA_IS_INSTALLABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Instalable'
,p_source=>'PWA_IS_INSTALLABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede instalar una aplicaci\00F3n web progresiva en sus dispositivos. Al hacerlo, se agrega un icono a la pantalla de inicio del dispositivo para que parezca una aplicaci\00F3n nativa.</p>'),
unistr('<p>Al activar esta opci\00F3n:</p>'),
'<ul>',
unistr('<li>Agregar\00E1 una nueva entrada a la barra de navegaci\00F3n: Instalar aplicaci\00F3n</li>'),
unistr('<li>Los usuarios podr\00E1n instalar esta aplicaci\00F3n de APEX en sus dispositivos</li>'),
'</ul>'))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3400886204019503.4001)
,p_name=>'P4001_IS_PWA'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Activar aplicaciones web progresivas'
,p_source=>'IS_PWA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las aplicaciones web progresivas son aplicaciones web dise\00F1adas para ser competentes, fiables e instalables.</p>'),
unistr('<p>Al activar esta opci\00F3n:</p>'),
'<ul>',
unistr('<li>Servir\00E1 archivos est\00E1ticos de forma m\00E1s eficiente gracias al almacenamiento en cach\00E9 avanzado</li>'),
unistr('<li>Activar\00E1 opciones de aplicaci\00F3n web progresiva m\00E1s declarativas</li>'),
'</ul>'))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3400995151019504.4001)
,p_name=>'P4001_PWA_MANIFEST_DISPLAY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'standalone'
,p_prompt=>'Mostrar'
,p_source=>'PWA_MANIFEST_DISPLAY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PWA_MANIFEST_DISPLAY'
,p_lov=>'.'||wwv_flow_api.id(1687503362489571.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La visualizaci\00F3n determina el modo de visualizaci\00F3n preferido para la aplicaci\00F3n.</p>'),
unistr('<p>El modo de visualizaci\00F3n modifica en qu\00E9 medida se muestra la interfaz del explorador al usuario, que va desde la vista de explorador (cuando se muestra toda la ventana de explorador) hasta pantalla completa (cuando la aplicaci\00F3n se visualiza a pa')
||'ntalla completa).</p>',
unistr('<p>Nota: Algunos dispositivos y exploradores ignoran este atributo. Oracle APEX solo transmite esta informaci\00F3n al dispositivo que gestiona la aplicaci\00F3n web progresiva correctamente.</p>')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401042160019505.4001)
,p_name=>'P4001_PWA_MANIFEST_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de la aplicaci\00F3n')
,p_source=>'PWA_MANIFEST_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La descripci\00F3n de aplicaci\00F3n explica lo que hace la aplicaci\00F3n.</p>'),
unistr('<p>Se usa para proporcionar m\00E1s informaci\00F3n a los usuarios cuando se les solicita que instalen la aplicaci\00F3n.</p>')))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401172531019506.4001)
,p_name=>'P4001_PWA_MANIFEST_ORIENTATION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'any'
,p_prompt=>unistr('Orientaci\00F3n de la pantalla')
,p_source=>'PWA_MANIFEST_ORIENTATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PWA_MANIFEST_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(1689369179497016.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La orientaci\00F3n de pantalla preferida durante el uso de la aplicaci\00F3n web progresiva. Se aplica sobre todo a dispositivos m\00F3viles.</p>'),
unistr('<p>Nota: Algunos dispositivos y exploradores ignoran este atributo. Oracle APEX solo transmite esta informaci\00F3n al dispositivo que gestiona la aplicaci\00F3n web progresiva correctamente.</p>')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401267018019507.4001)
,p_name=>'P4001_PWA_MANIFEST_THEME_COLOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Color de tema '
,p_source=>'PWA_MANIFEST_THEME_COLOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_COLOR_PICKER'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este atributo define el color de tema por defecto para la aplicaci\00F3n.</p>'),
unistr('<p>Afecta a c\00F3mo el sistema operativo muestra la aplicaci\00F3n (por ejemplo, en el administrador de tareas de Android, el color de tema rodea la aplicaci\00F3n).</p>'),
unistr('<p>Nota: Algunos dispositivos y exploradores ignoran este atributo. Oracle APEX solo transmite esta informaci\00F3n al dispositivo que gestiona la aplicaci\00F3n web progresiva correctamente.</p>')))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401384262019508.4001)
,p_name=>'P4001_PWA_BACKGROUND_COLOR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Color de Fondo'
,p_source=>'PWA_MANIFEST_BACKGROUND_COLOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_COLOR_PICKER'
,p_cSize=>30
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El color de fondo define el color del fondo del marcador de posici\00F3n que mostrar\00E1 la aplicaci\00F3n antes de que se cargue la hoja de estilos.</p>'),
unistr('<p>Por lo tanto, el color de fondo deber\00EDa coincidir con el color de fondo del cuerpo del tema para que exista una transici\00F3n fluida entre el inicio de la aplicaci\00F3n web y la carga del contenido.</p>'),
unistr('<p>Nota: Algunos dispositivos y exploradores ignoran este atributo. Oracle APEX solo transmite esta informaci\00F3n al dispositivo que gestiona la aplicaci\00F3n web progresiva correctamente.</p>')))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401404780019509.4001)
,p_name=>'P4001_PWA_MANIFEST_ICON_URL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Icono'
,p_source=>'PWA_MANIFEST_ICON_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El icono se puede utilizar en la pantalla de inicio de un dispositivo m\00F3vil o de escritorio, entre una lista de otras aplicaciones, o para integrar la aplicaci\00F3n web con el administrador de tareas y las preferencias del sistema de un sistema opera')
||'tivo.</p>',
'<p>El icono debe ser un archivo <code>png</code> o <code>svg</code>.</p>',
unistr('<p>Si el icono es un archivo <code>png</code>, el tama\00F1o recomendado es de 512 x 512 p\00EDxeles.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3401590371019510.4001)
,p_name=>'P4001_PWA_MANIFEST_CUSTOM'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3400696765019501.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Manifiesto personalizado'
,p_source=>'PWA_MANIFEST_CUSTOM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El manifiesto personalizado se utiliza para almacenar propiedades JSON adicionales para el archivo del manifiesta de la aplicaci\00F3n web.</p>'),
unistr('<p>Las propiedades que se encuentran aqu\00ED se utilizar\00E1n para ampliar las opciones declarativas anteriores, sustituyendo las propiedades existentes o agregando otras nuevas.</p>'),
unistr('<p>Para obtener m\00E1s informaci\00F3n sobre c\00F3mo crear un manifiesto personalizado, puede leer las especificaciones del manifiesto de aplicaci\00F3n web: <a href="https://www.w3.org/TR/appmanifest/">https://www.w3.org/TR/appmanifest/</a></p>')))
,p_attribute_01=>'json'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6255524120055403.4001)
,p_name=>'SVAL_09'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 9')
,p_source=>'SUBSTITUTION_VALUE_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6256026890056232.4001)
,p_name=>'SVAL_10'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 10')
,p_source=>'SUBSTITUTION_VALUE_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6256428622056745.4001)
,p_name=>'SVAL_11'
,p_item_sequence=>520
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 11')
,p_source=>'SUBSTITUTION_VALUE_11'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6256831738057618.4001)
,p_name=>'SVAL_12'
,p_item_sequence=>540
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 12')
,p_source=>'SUBSTITUTION_VALUE_12'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6257101394058272.4001)
,p_name=>'SVAL_13'
,p_item_sequence=>560
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 13')
,p_source=>'SUBSTITUTION_VALUE_13'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6257117909985232.4001)
,p_name=>'P4001_ERROR_HANDLING_FUNCTION'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(6257403627000045.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Funci\00F3n de Manejo de Errores')
,p_source=>'ERROR_HANDLING_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que se va a llamar para modificar el mensaje de error y la ubicaci\00F3n de visualizaci\00F3n o para registrar el error si se produce. Puede hacer referencia a una funci\00F3n de paquete o funci\00F3n aut\00F3noma de la base ')
||'de datos. Por ejemplo:',
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
'',
unistr('<p>Al hacer referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.log_apex_error',
'</pre>',
'</p>',
'',
'<p>',
unistr('Nota: el manejo de errores especificado a nivel de p\00E1gina, sobrescribe cualquier funci\00F3n de manejo de errores que se haya especificado aqu\00ED.'),
'</p>',
'',
'<p>Las funciones de manejo de errores deben implantar la siguiente interfaz:',
'',
'<pre>',
unistr('function &lt;nombre de funci\00F3n> ('),
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
'',
'<p>',
unistr('Consulte tambi\00E9n: "apex_error" en Oracle Application Express API Reference'),
'</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6259711915070790.4001)
,p_name=>'SVAL_14'
,p_item_sequence=>580
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 14')
,p_source=>'SUBSTITUTION_VALUE_14'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6260013300071257.4001)
,p_name=>'SVAL_15'
,p_item_sequence=>600
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 15')
,p_source=>'SUBSTITUTION_VALUE_15'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6260515031071740.4001)
,p_name=>'SVAL_16'
,p_item_sequence=>620
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 16')
,p_source=>'SUBSTITUTION_VALUE_16'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6260916763072263.4001)
,p_name=>'SVAL_17'
,p_item_sequence=>640
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 17')
,p_source=>'SUBSTITUTION_VALUE_17'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6261418841072838.4001)
,p_name=>'SVAL_18'
,p_item_sequence=>660
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 18')
,p_source=>'SUBSTITUTION_VALUE_18'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6261921958073689.4001)
,p_name=>'SVAL_19'
,p_item_sequence=>680
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 19')
,p_source=>'SUBSTITUTION_VALUE_19'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6262424382074460.4001)
,p_name=>'SVAL_20'
,p_item_sequence=>700
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Sustituci\00F3n 20')
,p_source=>'SUBSTITUTION_VALUE_20'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6263301657077352.4001)
,p_name=>'SSTRING_09'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 9')
,p_source=>'SUBSTITUTION_STRING_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6263804427078118.4001)
,p_name=>'SSTRING_10'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 10')
,p_source=>'SUBSTITUTION_STRING_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6264106851078773.4001)
,p_name=>'SSTRING_11'
,p_item_sequence=>510
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 11')
,p_source=>'SUBSTITUTION_STRING_11'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6264408929079441.4001)
,p_name=>'SSTRING_12'
,p_item_sequence=>530
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 12')
,p_source=>'SUBSTITUTION_STRING_12'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6264710660079940.4001)
,p_name=>'SSTRING_13'
,p_item_sequence=>550
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 13')
,p_source=>'SUBSTITUTION_STRING_13'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6265012392080423.4001)
,p_name=>'SSTRING_14'
,p_item_sequence=>570
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 14')
,p_source=>'SUBSTITUTION_STRING_14'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6265314470081051.4001)
,p_name=>'SSTRING_15'
,p_item_sequence=>590
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 15')
,p_source=>'SUBSTITUTION_STRING_15'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6265616201081557.4001)
,p_name=>'SSTRING_16'
,p_item_sequence=>610
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 16')
,p_source=>'SUBSTITUTION_STRING_16'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6265917933081999.4001)
,p_name=>'SSTRING_17'
,p_item_sequence=>630
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 17')
,p_source=>'SUBSTITUTION_STRING_17'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6266220357082710.4001)
,p_name=>'SSTRING_18'
,p_item_sequence=>650
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 18')
,p_source=>'SUBSTITUTION_STRING_18'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6266722089083197.4001)
,p_name=>'SSTRING_19'
,p_item_sequence=>670
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 19')
,p_source=>'SUBSTITUTION_STRING_19'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6267424513083951.4001)
,p_name=>'SSTRING_20'
,p_item_sequence=>690
,p_item_plug_id=>wwv_flow_api.id(85248570290.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cadena de Sustituci\00F3n 20')
,p_source=>'SUBSTITUTION_STRING_20'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11227626235013287.4001)
,p_name=>'P4001_PUBLISH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_source=>'PUBLISH_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Las aplicaciones publicadas aparecen en la p\00E1gina Aplicaciones, que est\00E1 disponible para la p\00E1gina de inicio de &PRODUCT_NAME. Las aplicaciones que no est\00E1n publicadas no aparecen en esta p\00E1gina.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(84788616925426806.4001)
,p_name=>'F4000_P4001_GLOBAL_NOTIFICATION'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(84785704645417330.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje que desea que aparezca en la cadena de sustituci\00F3n #GLOBAL_NOTIFICATION# de la p\00E1gina.')
,p_source=>'GLOBAL_NOTIFICATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Puede utilizar una notificaci\00F3n global para comunicar el estado del sistema. Si la plantilla de p\00E1gina contiene una cadena de sustituci\00F3n <code>#GLOBAL_NOTIFICATION#</code>, el texto que se introduzca aqu\00ED se muestra en cada p\00E1gina.<p>'),
unistr('<p>Por ejemplo, suponga que ha introducido el mensaje "Merienda campera del equipo este viernes" en este atributo. Si las plantillas de p\00E1gina soportan la cadena de sustituci\00F3n de notificaci\00F3n global, este mensaje aparecer\00EDa en cada p\00E1gina.<p>'),
unistr('Para crear una notificaci\00F3n global:'),
'<ol>',
unistr('<li>Incluya la cadena de sustituci\00F3n <code>#GLOBAL_NOTIFICATION#</code> en la plantilla de p\00E1gina.</li>'),
unistr('<li>Vaya a la p\00E1gina Editar Aplicaci\00F3n e introduzca un mensaje en el atributo Notificaciones Globales.</li>'),
'<li>Haga clic en <strong>Aplicar Cambios</strong>.</li>',
'</ol>',
''))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91061117381015202.4001)
,p_name=>'P4001_GROUP_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(284956612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Grupo de Aplicaciones'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, id',
'from wwv_flow_application_groups',
'where security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Asignado -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Muestra el grupo de aplicaciones asociado actualmente a esta aplicaci\00F3n.')
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(98291001902600275.4001)
,p_name=>'F4000_P4001_EXACT_SUBSTITUTIONS_ONLY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Sustituciones Exactas'
,p_source=>'EXACT_SUBSTITUTIONS_ONLY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXACT_SUBS_Y_N'
,p_lov=>'.'||wwv_flow_api.id(84908521896674445.4001)||'.'
,p_cHeight=>1
,p_display_when=>'F4000_P4001_EXACT_SUBSTITUTIONS_ONLY'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Determina si est\00E1n soportadas las sustituciones exactas. Utilice sustituciones exactas.<p/> '),
unistr('Tenga en cuenta que las sustituciones no exactas son una funci\00F3n en desuso.<p/> '),
'Las sustituciones exactas utilizan la siguiente sintaxis:',
'<pre>&amp;ITEM.</pre> ',
'Las sustituciones no exactas utilizan la sintaxis:',
'<pre>&amp;ITEM</pre>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>'pawolf/05-apr-2012: Page item will only be visible if the application uses Non Exact Substitutions so that they can change it to yes, but we don''t support that new applications will use No.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(105521529152379239.4001)
,p_name=>'F4000_P4001_ALIAS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(284956612.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Alias de Aplicaci\00F3n')
,p_source=>'ALIAS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Asigna un identificador de aplicaci\00F3n alfanum\00E9rico alternativo. Puede utilizar este identificador en lugar del identificador de aplicaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173032421936291163.4001)
,p_name=>'P4001_ALLOW_FEEDBACK_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Permitir Comentario'
,p_source=>'ALLOW_FEEDBACK_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Activa el soporte de comentarios del usuario final en esta aplicaci\00F3n. Seleccione <strong>S\00ED</strong> o <strong>No</strong>. '),
'<p/>',
unistr('Si activa esta opci\00F3n, debe crear una p\00E1gina de comentarios y un icono en la barra de navegaci\00F3n para llamar a esa p\00E1gina. Si desactiva los comentarios, el icono de la barra de navegaci\00F3n se oculta. Esto permite activar los comentarios para realizar ')
||unistr('pruebas y desactivarlos para producci\00F3n')))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185078809102590512.4001)
,p_name=>'P4001_FRIENDLY_URL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('URL f\00E1ciles de recordar')
,p_source=>'FRIENDLY_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina si las URL generadas para navegar a otras p\00E1ginas de la aplicaci\00F3n deben ser f\00E1ciles de leer. Si se define en <strong>Activado</strong>, se utilizar\00E1 una estructura de directorios basada en la sintaxis de par\00E1metro web est\00E1ndar, el alias')
||unistr(' de p\00E1gina y la aplicaci\00F3n. Si se define en <strong>Desactivado</strong>, se utilizar\00E1 la sintaxis heredada <code>f?p=</code>.</p>'),
unistr('<p>Nota: La URL f\00E1cil de recordar incluir\00E1 el <em>prefijo de ruta de acceso</em> del espacio de trabajo. Para modificar el prefijo de ruta de acceso, vaya a Administraci\00F3n de espacio de trabajo > Gestionar servicio > Definir preferencias de espacio d')
||'e trabajo.</p>',
unistr('<p>Si la URL f\00E1cil de recordar se define en <strong>Activado</strong>, tendr\00E1 acceso a las opciones de la <strong>aplicaci\00F3n web progresiva</strong>.</p>')))
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(191198909190237603.4001)
,p_name=>'P4001_DEFAULT_ERROR_DISPLAY_LOCATION'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(6257403627000045.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_prompt=>unistr('Ubicaci\00F3n por Defecto de Visualizaci\00F3n de Error')
,p_source=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(191207805708435328.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica d\00F3nde se muestran los mensajes de error de las validaciones b\00E1sicas realizadas por &PRODUCT_NAME. o por plugins. Los mensajes de error de validaci\00F3n se pueden mostrar en un \00E1rea de "notificaci\00F3n" (definida como parte de la plantilla de p\00E1g')
||'ina) o en la etiqueta de campo.</p>'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198568215654454253.4001)
,p_name=>'P4001_DEBUGGING'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Depuraci\00F3n')
,p_source=>'APPLICATION_TAB_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Determina si se puede activar el modo de depuraci\00F3n a trav\00E9s de un explorador. Entre las opciones disponibles se incluyen:<p>'),
'<ul>',
unistr('<li><strong>Activado</strong>: permite a la aplicaci\00F3n ejecutarse en modo de depuraci\00F3n desde un explorador en tiempo de ejecuci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong>: impide que la aplicaci\00F3n permita el modo de depuraci\00F3n desde un explorador.</li>'),
'</ul>',
unistr('<p>La ejecuci\00F3n de una aplicaci\00F3n en modo de depuraci\00F3n es \00FAtil si est\00E1 en desarrollo. Para una aplicaci\00F3n de producci\00F3n, Oracle recomienda desactivar la depuraci\00F3n para evitar as\00ED que los usuarios visualicen la l\00F3gica de la aplicaci\00F3n.</p>'),
unistr('<p>La depuraci\00F3n se puede activar mediante programaci\00F3n, independientemente de este valor.</p>'),
unistr('<p>Si la aplicaci\00F3n se ejecuta desde el entorno de desarrollo de &PRODUCT_NAME., la depuraci\00F3n puede estar siempre activada.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'1'
,p_attribute_04=>'0'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(207464222755454577.4001)
,p_name=>'P4001_COMPATIBILITY_MODE'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Modo de Compatibilidad'
,p_source=>'COMPATIBILITY_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.COMPATIBILITY_MODE'
,p_lov=>'.'||wwv_flow_api.id(207464823363457503.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Controla el modo de compatibilidad del motor de tiempo de ejecuci\00F3n de &PRODUCT_NAME. Algunos comportamientos en tiempo de ejecuci\00F3n cambian de una versi\00F3n a otra. Utilice este atributo para obtener un comportamiento espec\00EDfico de la aplicaci\00F3n. Para')
||unistr(' detectar el nuevo comportamiento en una aplicaci\00F3n, defina el modo de compatibilidad de la aplicaci\00F3n en la versi\00F3n actual.'),
'</p>',
'<p>',
unistr('Para obtener m\00E1s informaci\00F3n, consulte el cap\00EDtulo "Changed Behavior - Compatibility Mode" en las notas t\00E9cnicas sobre la versi\00F3n.'),
'</p>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(235689124480474701.4001)
,p_name=>'P4001_EMAIL_FROM'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Direcci\00F3n de Origen de Correo Electr\00F3nico de Aplicaci\00F3n')
,p_source=>'EMAIL_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina la direcci\00F3n de correo electr\00F3nico que se va a utilizar como direcci\00F3n "de origen" en la aplicaci\00F3n.</p>'),
unistr('<p>Esta direcci\00F3n de correo electr\00F3nico de origen se utiliza al enviar correos electr\00F3nicos desde los servicios de suscripci\00F3n o descarga de informes de correo interactivos en la aplicaci\00F3n. Este valor puede ser una cadena literal que contenga un cor')
||unistr('reo electr\00F3nico v\00E1lido o una referencia de sustituci\00F3n est\00E1tica definida en la aplicaci\00F3n que utiliza sintaxis de sustituci\00F3n. Oracle no recomienda utilizar una sustituci\00F3n de elemento en el nivel de p\00E1gina o aplicaci\00F3n, ya que solo funciona en las d')
||unistr('escargas de correo electr\00F3nico, pero no en una suscripci\00F3n.</p>'),
'Ejemplos:',
'<ul>',
'<li><code>john.doe@example.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(538532984883939915.4001)
,p_name=>'P4001_NO_PROXY_DOMAINS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(198116031744061165.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ning\00FAn dominio de proxy')
,p_source=>'NO_PROXY_DOMAINS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>500
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilice este campo para especificar una lista de hosts y dominios para los que no se debe utilizar un proxy. <p/>',
'Puede hacer referencia a los valores introducidos en este campo desde PL/SQL con la variable de paquete PL/SQL <code>APEX_APPLICATION.G_NO_PROXY_DOMAINS</code>. Por ejemplo:',
'<pre>internal.example.com,local.example.com</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(879700556015493827.4001)
,p_name=>'P4001_APP_BUILDER_ICON_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(879700077231493822.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Archivo del Icono'
,p_source=>'APP_BUILDER_ICON_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione el nombre de archivo de una imagen que se muestra como el icono de la aplicaci\00F3n en el creador de aplicaciones. La imagen debe tener 64 x 64 p\00EDxeles, se debe cargar como <strong>Imagen de aplicaci\00F3n</strong> dentro de Componentes comparti')
||unistr('dos y debe estar presente en el nivel ''ra\00EDz'' (es decir, no dentro de una carpeta).')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(95706604629366729.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4001_ALIAS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':FB_UPD_ID'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'F4000_P4001_ALIAS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(486801121465649401.4001)
,p_computation_sequence=>30
,p_computation_item=>'FB_UPD_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'ltrim(rtrim(:FB_UPD_NAME))'
,p_compute_when=>'ApplyChanges'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1423608357786032.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4001_PRINT_REMOTE_SERVER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4001_PRINT_SERVER_TYPE'
,p_compute_when_text=>'REMOTE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1423729749786033.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4001_PRINT_CREDENTIAL_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>':P4001_PRINT_AUTH_REQUIRED != ''Y'' or :P4001_PRINT_SERVER_TYPE != ''REMOTE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3400759685660601.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4001_IS_PWA'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4001_FRIENDLY_URL'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3400856863660602.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4001_PWA_IS_INSTALLABLE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4001_IS_PWA'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3000890206300305.4001)
,p_computation_sequence=>80
,p_computation_item=>'P4001_PWA_MANIFEST_DESCRIPTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3400969185660603.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4001_PWA_MANIFEST_DISPLAY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3401097908660604.4001)
,p_computation_sequence=>100
,p_computation_item=>'P4001_PWA_MANIFEST_ORIENTATION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3401196631660605.4001)
,p_computation_sequence=>110
,p_computation_item=>'P4001_PWA_MANIFEST_THEME_COLOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3401209576660606.4001)
,p_computation_sequence=>120
,p_computation_item=>'P4001_PWA_BACKGROUND_COLOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3401336456660607.4001)
,p_computation_sequence=>130
,p_computation_item=>'P4001_PWA_MANIFEST_ICON_URL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3401497236660608.4001)
,p_computation_sequence=>140
,p_computation_item=>'P4001_PWA_MANIFEST_CUSTOM'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:p4001_pwa_is_installable, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(6951849466786644.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4001_PRINT_AUTH_REQUIRED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case ',
'  when :P4001_PRINT_REMOTE_SERVER_ID is not null and :P4001_PRINT_CREDENTIAL_ID is null then ''N''',
'  else ''Y''',
'end'))
,p_compute_when=>'P4001_PRINT_SERVER_TYPE'
,p_compute_when_text=>'REMOTE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(73224212233840493.4001)
,p_validation_name=>'flow alias valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :F4000_P4001_ALIAS = :FB_UPD_ID then',
'        return true;',
'    else',
'        return not htmldb_util.has_restricted_chars (',
'                       p_value => :F4000_P4001_ALIAS,',
'                       p_check => ''SAFE_COMPONENT_NAME'' );',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El alias de la aplicaci\00F3n no es un identificador de Oracle v\00E1lido.')
,p_validation_condition=>':F4000_P4001_ALIAS is not null and :REQUEST not in (''Cancel'',''Delete'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(105521529152379239.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(235689710893481005.4001)
,p_validation_name=>'P4001_EMAIL_FROM is valid'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_amp  number;',
'  l_at   number;',
'  l_dot  number;',
'begin',
'  l_amp := instr(:P4001_EMAIL_FROM,''&'');',
'  l_dot := instr(:P4001_EMAIL_FROM,''.'',l_amp);',
'  if l_amp > 0 and l_dot > 0 then',
'    return true;',
'  else',
'    l_at := instr(:P4001_EMAIL_FROM,''@'');',
'    l_dot := instr(:P4001_EMAIL_FROM,''.'',l_at);',
'    if l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1 then',
'        return true;',
'    end if;',
'  end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Direcci\00F3n de correo electr\00F3nico no v\00E1lida')
,p_validation_condition=>'P4001_EMAIL_FROM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(235689124480474701.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(879700889530493830.4001)
,p_validation_name=>'Builder Icon valid'
,p_validation_sequence=>40
,p_validation=>'regexp_instr(:P4001_APP_BUILDER_ICON_NAME, ''\.\.|\/|\\'') = 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Nombre de archivo de icono no v\00E1lido. Solo se permiten nombres de archivo simples.')
,p_when_button_pressed=>wwv_flow_api.id(40006878470920.4001)
,p_associated_item=>wwv_flow_api.id(879700556015493827.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1423860740786034.4001)
,p_validation_name=>'Remote Print Server not null'
,p_validation_sequence=>50
,p_validation=>'P4001_PRINT_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# es necesario.'
,p_validation_condition=>'P4001_PRINT_SERVER_TYPE'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(1422184336786017.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1423942806786035.4001)
,p_validation_name=>'Print Credentials not null'
,p_validation_sequence=>60
,p_validation=>'P4001_PRINT_CREDENTIAL_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# es necesario.'
,p_validation_condition=>':P4001_PRINT_SERVER_TYPE = ''REMOTE'' and :P4001_PRINT_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1422786998786023.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8633516027387601.4001)
,p_validation_name=>'P4001_PWA_MANIFEST_CUSTOM is valid JSON'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from dual',
'where :p4001_pwa_manifest_custom is json'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('#LABEL# debe ser un objeto JSON v\00E1lido.')
,p_validation_condition=>'P4001_PWA_MANIFEST_CUSTOM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(3401590371019510.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(538533015324939916.4001)
,p_name=>'Proxy Server'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4001_PROXY_SERVER'
,p_condition_element=>'F4000_P4001_PROXY_SERVER'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538533198743939917.4001)
,p_event_id=>wwv_flow_api.id(538533015324939916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538533256100939918.4001)
,p_event_id=>wwv_flow_api.id(538533015324939916.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538533354137939919.4001)
,p_event_id=>wwv_flow_api.id(538533015324939916.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_NO_PROXY_DOMAINS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1422256128786018.4001)
,p_name=>'On remote server'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PRINT_SERVER_TYPE'
,p_condition_element=>'P4001_PRINT_SERVER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1422331611786019.4001)
,p_event_id=>wwv_flow_api.id(1422256128786018.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_REMOTE_SERVER_ID,P4001_PRINT_AUTH_REQUIRED'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1422451855786020.4001)
,p_event_id=>wwv_flow_api.id(1422256128786018.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_REMOTE_SERVER_ID,P4001_PRINT_AUTH_REQUIRED'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1423437570786030.4001)
,p_event_id=>wwv_flow_api.id(1422256128786018.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#P4001_PRINT_AUTH_REQUIRED"), "credentialchange" );'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1423595884786031.4001)
,p_event_id=>wwv_flow_api.id(1422256128786018.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#P4001_PRINT_AUTH_REQUIRED"), "credentialchange" );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1422832521786024.4001)
,p_name=>'Change Print Authentication'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PRINT_AUTH_REQUIRED'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1422987265786025.4001)
,p_event_id=>wwv_flow_api.id(1422832521786024.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#P4001_PRINT_AUTH_REQUIRED"), "credentialchange" );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1423004640786026.4001)
,p_name=>'credentialchange'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PRINT_AUTH_REQUIRED'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P4001_PRINT_AUTH_REQUIRED").getValue() === "Y" &&',
'apex.item("P4001_PRINT_SERVER_TYPE").getValue() === "REMOTE"'))
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'credentialchange'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1423137728786027.4001)
,p_event_id=>wwv_flow_api.id(1423004640786026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_CREDENTIAL_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1423240441786028.4001)
,p_event_id=>wwv_flow_api.id(1423004640786026.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_CREDENTIAL_ID'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3401614779019511.4001)
,p_name=>'onChange P4001_FRIENDLY_URL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_FRIENDLY_URL'
,p_condition_element=>'P4001_FRIENDLY_URL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3401795425019512.4001)
,p_event_id=>wwv_flow_api.id(3401614779019511.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3400696765019501.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3401880126019513.4001)
,p_event_id=>wwv_flow_api.id(3401614779019511.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3400696765019501.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3401968514019514.4001)
,p_name=>'onChange P4001_IS_PWA'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_IS_PWA'
,p_condition_element=>'P4001_IS_PWA'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3402040895019515.4001)
,p_event_id=>wwv_flow_api.id(3401968514019514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PWA_IS_INSTALLABLE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3500445966641401.4001)
,p_event_id=>wwv_flow_api.id(3401968514019514.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PWA_IS_INSTALLABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3402179940019516.4001)
,p_event_id=>wwv_flow_api.id(3401968514019514.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PWA_IS_INSTALLABLE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3000521749300302.4001)
,p_name=>'onChange P4001_PWA_IS_INSTALLABLE'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PWA_IS_INSTALLABLE'
,p_condition_element=>'P4001_PWA_IS_INSTALLABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3000667075300303.4001)
,p_event_id=>wwv_flow_api.id(3000521749300302.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PWA_MANIFEST_DESCRIPTION,P4001_PWA_MANIFEST_DISPLAY,P4001_PWA_MANIFEST_ORIENTATION,P4001_PWA_MANIFEST_THEME_COLOR,P4001_PWA_BACKGROUND_COLOR,P4001_PWA_MANIFEST_ICON_URL,P4001_PWA_MANIFEST_CUSTOM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3000760730300304.4001)
,p_event_id=>wwv_flow_api.id(3000521749300302.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PWA_MANIFEST_DESCRIPTION,P4001_PWA_MANIFEST_DISPLAY,P4001_PWA_MANIFEST_ORIENTATION,P4001_PWA_MANIFEST_THEME_COLOR,P4001_PWA_BACKGROUND_COLOR,P4001_PWA_MANIFEST_ICON_URL,P4001_PWA_MANIFEST_CUSTOM'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40006868470917.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3803540141636102.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'post validation computation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- this is required to reset the item to null, due to the page validation forcing Y or N',
':P4001_PWA_IS_INSTALLABLE := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4001_IS_PWA'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3401565495660609.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove pwa list entry'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_shared_comp_v3.delete_pwa_install_list_entry (',
'    p_application_id => :fb_flow_id );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where coalesce(:p4001_pwa_is_installable, ''N'') = ''N'' -- set to remove PWA',
'   and pwa_is_installable                       = ''Y'' -- app is curently a pwa',
'   and security_group_id                        = :flow_security_group_id',
'   and id                                       = :fb_flow_id'))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3401640861660610.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pwa list entry'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_shared_comp_v3.create_pwa_install_list_entry (',
'    p_application_id => :fb_flow_id );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where coalesce(:p4001_pwa_is_installable, ''N'') = ''Y'' -- set to add PWA',
'   and coalesce(pwa_is_installable,        ''N'') = ''N'' -- app is not curently a pwa',
'   and security_group_id                        = :flow_security_group_id',
'   and id                                       = :fb_flow_id'))
,p_process_when_type=>'EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(72721927488098078.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(40006869470918.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Aplicaci\00F3n &FB_UPD_ID. procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(72719524240087695.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
);
end;
/
prompt --application/pages/page_04003
begin
wwv_flow_api.create_page(
 p_id=>4003.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Plantillas'
,p_step_title=>'Plantillas'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(54196929426.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9763401034980576.4001)
,p_plug_name=>'Plantillas'
,p_region_css_classes=>'a-Region--sideRegion a-Region--stacked a-Region--flush a-Region--padded'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El motor &PRODUCT_NAME. crea el aspecto de cada p\00E1gina de una aplicaci\00F3n mediante plantillas. Las plantillas definen la forma en que se van a mostrar las p\00E1ginas, los controles de p\00E1gina o los componentes de las p\00E1ginas.</p>'),
'<p>Para editar los atributos de las plantillas, seleccione el nombre de la plantilla. Para realizar una vista previa de una plantilla, haga clic en el icono Ejecutar.</p>',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/creating-custom-themes.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92875519972555730.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(632908701274265897.4001)
,p_plug_name=>'Plantillas'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>80
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4013a */',
'       decode(template_type,',
'           ''PAGE'',wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'           ''REGION'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'           ''LABEL'',wwv_flow_lang.system_message_lit(''LABEL''),',
'           ''LIST'',wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'           ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'           ''CALENDAR'',wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'           ''MENU'',wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'           ''BUTTON'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'           ''REPORT'',wwv_flow_lang.system_message_lit(''REPORT''),',
'           template_type) t,',
'       upper_name,',
'       template_name n,',
'       internal_name,',
'       edit_page,',
'       reference_count c,',
'       last_updated_on,',
'       lower(last_updated_by) last_updated_by,',
'       ( select case',
'                  when x.reference_id is not null then wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.THEME'' )',
'                  else x.subscribed_from',
'                end',
'           from wwv_flow_themes',
'          where flow_id  = :FB_FLOW_ID',
'            and theme_id = x.theme_id',
'       ) as subscribed_from,',
'       subscribers,',
'       decode(is_default,',
'              0, ''N'',',
'              ''Y'' ) as is_default,',
'       decode(is_default,',
'              0,'''',',
'              ''icon-check'' ) as default_css,',
'       theme_id theme,',
'       decode(template_type,',
'           ''REGION'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:538:''||:app_session',
'               ||'':::538:P538_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''PAGE'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:568:''||:app_session',
'               ||'':::568:P568_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''REPORT'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:569:''||:app_session',
'               ||'':::569:P569_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''BUTTON'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:571:''||:app_session',
'               ||'':::571:P571_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''CALENDAR'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:564:''||:app_session',
'               ||'':::564:P564_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''LIST'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:573:''||:app_session',
'               ||'':::573:P573_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''LABEL'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:574:''||:app_session',
'               ||'':::574:P574_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           ''MENU'',',
'           ''<a class="a-Button a-Button--small a-Button--simple" title="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" aria-label="''||wwv_flow_lang.system_message(''TEMPLATE.COPY'',template_name)',
'               ||''" href="''||wwv_flow_utilities.prepare_url(''f?p=4000:636:''||:app_session',
'               ||'':::636:P636_FROM_TEMPLATE_ID:''||tid)',
'               ||''"><span class="a-Icon icon-copy" aria-hidden="true"></span></a>'',',
'           null) copy_template,',
'       case template_type',
'           when ''REGION''   then ''538''',
'           when ''PAGE''     then ''568''',
'           when ''REPORT''   then ''569''',
'           when ''BUTTON''   then ''571''',
'           when ''CALENDAR'' then ''564''',
'           when ''LIST''     then ''573''',
'           when ''LABEL''    then ''574''',
'           when ''MENU''     then ''636''',
'           else null',
'       end as copy_template_page,',
'       tid,',
'       template_type',
'from (  select ''POPUP_LOV'' template_type,',
'            upper(''Popup LOV'') upper_name,',
'            ''251'' edit_page,',
'            ''Popup LOV'' template_name,',
'            ''POPUP_LOV'' internal_name,',
'            case',
'                when plt.theme_id in (  select theme_id',
'                                        from wwv_flow_user_interfaces',
'                                        where flow_id = :fb_flow_id',
'                                          and security_group_id = :flow_security_group_id ) then 1',
'                else 0',
'            end reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_popup_lov_template',
'                              where id                = plt.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_popup_lov_template',
'               where reference_id      = plt.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            case',
'                when plt.theme_id in (  select theme_id',
'                                        from wwv_flow_user_interfaces',
'                                        where flow_id = :fb_flow_id',
'                                          and security_group_id = :flow_security_group_id ) then 1',
'                else 0',
'            end is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_popup_lov_template plt',
'        where plt.flow_id = :fb_flow_id',
'          and plt.security_group_id = :flow_security_group_id',
'        union all',
'        select ''CALENDAR'' template_type,',
'            upper(name) upper_name,',
'            ''697'' edit_page,',
'            name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_cals',
'                where template_id = c.id',
'                    and flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = c.theme_id',
'                        and default_calendar_template = c.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_cal_templates',
'                              where id                = c.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_cal_templates',
'               where reference_id      = c.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = c.theme_id',
'                    and default_calendar_template = c.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_cal_templates c',
'        where c.flow_id = :fb_flow_id ',
'          and c.security_group_id = :flow_security_group_id',
'        union all',
'        select ''MENU'' template_type,',
'            upper(name) upper_name,',
'            ''289'' edit_page,',
'            name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs r',
'                where r.flow_id = :fb_flow_id',
'                    and r.security_group_id = :flow_security_group_id',
'                    and r.menu_template_id = m.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = m.theme_id',
'                        and default_menu_template = m.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_menu_templates',
'                              where id                = m.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_menu_templates',
'               where reference_id      = m.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = m.theme_id',
'                    and default_menu_template = m.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_menu_templates m',
'        where m.flow_id = :fb_flow_id   ',
'          and m.security_group_id = :flow_security_group_id',
'        union all',
'        select ''BUTTON'' template_type,',
'            upper(template_name) upper_name,',
'            ''204'' edit_page,',
'            template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_step_buttons sb',
'                where sb.flow_id = :fb_flow_id',
'                    and sb.security_group_id = :flow_security_group_id',
'                    and sb.button_template_id = b.id )',
'                + ( select count(*)',
'                    from wwv_flow_step_items si',
'                    where flow_id = :fb_flow_id',
'                        and si.security_group_id = :flow_security_group_id',
'                        and si.TAG_ATTRIBUTES = ''template:''||to_char(b.id) )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = b.theme_id',
'                        and default_button_template = b.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_button_templates',
'                              where id                = b.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_button_templates',
'               where reference_id      = b.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = b.theme_id',
'                    and default_button_template = b.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_button_templates b',
'        where b.flow_id = :fb_flow_id',
'          and b.security_group_id = :flow_security_group_id',
'        union all',
'        select ''LABEL'' template_type,',
'            upper(template_name) upper_name,',
'            ''85'' edit_page,',
'            template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_step_items i',
'                where i.flow_id = :fb_flow_id',
'                    and i.security_group_id = :flow_security_group_id',
'                    and i.ITEM_FIELD_TEMPLATE = f.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = f.theme_id',
'                        and default_label_template = f.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_field_templates',
'                              where id                = f.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_field_templates',
'               where reference_id      = f.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = f.theme_id',
'                    and default_label_template = f.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_field_templates f',
'        where f.flow_id = :fb_flow_id',
'          and f.security_group_id = :flow_security_group_id',
'        union all',
'        select ''LIST'' template_type,',
'            upper(list_template_name) upper_name,',
'            ''4655'' edit_page,',
'            l.list_template_name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs p',
'                where p.flow_id = :fb_flow_id',
'                    and p.security_group_id = :flow_security_group_id',
'                    and p.list_template_id = l.id)',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = l.theme_id',
'                        and default_list_template = l.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_list_templates',
'                              where id                = l.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_list_templates',
'               where reference_id      = l.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = l.theme_id',
'                    and default_list_template = l.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_list_templates l',
'        where l.flow_id = :fb_flow_id',
'          and l.security_group_id = :flow_security_group_id',
'        union all',
'        select ''REPORT'' template_type,',
'            upper(row_template_name) upper_name,',
'            case when row_template_type = ''GENERIC_COLUMNS'' then ''258''',
'                else ''4654''',
'            end as edit_page,',
'            row_template_name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs p',
'                where flow_id = :fb_flow_id',
'                    and p.security_group_id = :flow_security_group_id',
'                    and p.PLUG_QUERY_ROW_TEMPLATE = ro.id',
'                    and plug_source_type in (''NATIVE_SQL_REPORT'', ''NATIVE_TABFORM'') )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = ro.theme_id',
'                        and default_report_template = ro.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_row_templates',
'                              where id                = ro.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_row_templates',
'               where reference_id      = ro.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = ro.theme_id',
'                    and default_report_template = ro.id ) is_default,',
'            ro.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_row_templates ro',
'        where ro.flow_id = :fb_flow_id',
'          and ro.security_group_id = :flow_security_group_id',
'        union all',
'        select ''PAGE'' template_type,',
'            upper(name) upper_name,',
'            ''4307'' edit_page,',
'            name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_steps s',
'                where flow_id = :fb_flow_id',
'                    and s.security_group_id = :flow_security_group_id',
'                    and s.step_template = p.id and s.id > 0 )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and DEFAULT_PAGE_TEMPLATE = p.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and error_template=p.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and printer_friendly_template=p.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_templates',
'                              where id                = p.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_templates',
'               where reference_id      = p.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and DEFAULT_PAGE_TEMPLATE=p.id ) is_default,',
'            p.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_templates p',
'        where p.flow_id = :fb_flow_id',
'          and p.security_group_id = :flow_security_group_id',
'        union all',
'        select ''REGION'' template_type,',
'            upper(page_plug_template_name) upper_name,',
'            ''4653'' edit_page,',
'            page_plug_template_name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs p',
'                where p.flow_id = :fb_flow_id',
'                    and p.security_group_id = :flow_security_group_id',
'                    and p.PLUG_TEMPLATE = r.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and default_region_template = r.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_page_plug_templates',
'                              where id                = r.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_page_plug_templates',
'               where reference_id      = r.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and default_region_template = r.id ) is_default,',
'            r.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_page_plug_templates r',
'        where r.flow_id = :fb_flow_id',
'          and r.security_group_id = :flow_security_group_id',
'        ) x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(632908938554265910.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'El informe no ha devuelto ninguna fila.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'DAVID.GALE'
,p_internal_uid=>632908938554265910
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909046901265914.4001)
,p_db_column_name=>'T'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909188428265916.4001)
,p_db_column_name=>'UPPER_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'UPPER_NAME'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
end;
/
begin
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909261009265917.4001)
,p_db_column_name=>'N'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:#EDIT_PAGE#:&SESSION.::&DEBUG.::F4000_P#EDIT_PAGE#_ID:#TID#'
,p_column_linktext=>'#N#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1004723783414877701.4001)
,p_db_column_name=>'INTERNAL_NAME'
,p_display_order=>40
,p_column_identifier=>'T'
,p_column_label=>'Identificador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909344233265917.4001)
,p_db_column_name=>'C'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Referencias'
,p_column_link=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:RP,707:P707_TEMPLATE_TYPE,P707_TEMPLATE,FB_FLOW_ID:#TEMPLATE_TYPE#,#TID#,&FB_FLOW_ID.:'
,p_column_linktext=>'#C#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909463353265917.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'Since'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909516469265917.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1439515255838192553.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>80
,p_column_identifier=>'R'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1439515393018192553.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>90
,p_column_identifier=>'S'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909793905265917.4001)
,p_db_column_name=>'IS_DEFAULT'
,p_display_order=>100
,p_column_identifier=>'H'
,p_column_label=>'Valor por Defecto'
,p_column_html_expression=>'<span class="a-Icon #DEFAULT_CSS#"><span class="u-VisuallyHidden">#IS_DEFAULT#</span></span>'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632909905288265917.4001)
,p_db_column_name=>'THEME'
,p_display_order=>120
,p_column_identifier=>'J'
,p_column_label=>'Tema'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632910044637265917.4001)
,p_db_column_name=>'COPY_TEMPLATE'
,p_display_order=>130
,p_column_identifier=>'K'
,p_column_label=>'Copiar'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632910133471265917.4001)
,p_db_column_name=>'TID'
,p_display_order=>140
,p_column_identifier=>'L'
,p_column_label=>'TID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632910251959265917.4001)
,p_db_column_name=>'TEMPLATE_TYPE'
,p_display_order=>150
,p_column_identifier=>'M'
,p_column_label=>'TEMPLATE_TYPE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632931763595526755.4001)
,p_db_column_name=>'EDIT_PAGE'
,p_display_order=>160
,p_column_identifier=>'N'
,p_column_label=>unistr('Editar P\00E1gina')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632931996059526757.4001)
,p_db_column_name=>'DEFAULT_CSS'
,p_display_order=>170
,p_column_identifier=>'P'
,p_column_label=>'DEFAULT_CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(632932033670526757.4001)
,p_db_column_name=>'COPY_TEMPLATE_PAGE'
,p_display_order=>180
,p_column_identifier=>'Q'
,p_column_label=>'COPY_TEMPLATE_PAGE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(632918839326319900.4001)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(632910504098265927.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(632908701274265897.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(632910717765265927.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(632908701274265897.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202012917814047095.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4003:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43234825947728509.4001)
,p_name=>'P4003_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(632918839326319900.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Seleccione un tema y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138315008861842757.4001)
,p_name=>'P4003_THEME_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(632918839326319900.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_themes',
' where theme_id = :P4003_THEME',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1723456652.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4003'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21863143902.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4307_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_TEMPLATE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(561231806055585456.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4003_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_themes where theme_id = :P4003_THEME and flow_id = :fb_flow_id'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(633078464849272660.4001)
,p_name=>'Copy Template - Dialog Closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(632908701274265897.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(633078744690272671.4001)
,p_event_id=>wwv_flow_api.id(633078464849272660.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(632908701274265897.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(285696016137584400.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create popup lov template if needed'
,p_process_sql_clob=>'insert into wwv_flow_popup_lov_template (id, flow_id) values (wwv_flow_id.next_val, :fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'select 1 from wwv_flow_popup_lov_template where flow_id=:fb_flow_id'
,p_process_when_type=>'NOT_EXISTS'
,p_process_success_message=>'No se ha podido crear la plantilla de lista de valores emergente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(19424430567592003.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_04004
begin
wwv_flow_api.create_page(
 p_id=>4004.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Lista de Valores: Nombre y Tipo'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687482810.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(161740513874429436.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130739713201.4001)
,p_plug_name=>'Crear Lista de Valores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Las listas est\00E1ticas est\00E1n basadas en pares predefinidos de valores de visualizaci\00F3n y de retorno. Las listas din\00E1micas est\00E1n basadas en un origen de datos din\00E1mico de la base de datos local, del SQL, activado para REST o del origen de datos de RE')
||'ST.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44764721724095169.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130743766434.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44764721724095169.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130749204700.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44764721724095169.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202915620672933903.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44764721724095169.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130750206521.4001)
,p_branch_action=>'4080'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130749204700.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':F4000_P4004_TYPE = ''DYNAMIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130753229524.4001)
,p_branch_action=>'4014'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130749204700.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':F4000_P4004_TYPE = ''STATIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(102180411308120840.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202916028815933908.4001)
,p_branch_action=>'137'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(202915620672933903.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130741728686.4001)
,p_name=>'F4000_P4004_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(130739713201.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Asigne un nombre a la lista de valores. Este nombre se utilizar\00E1 cuando desee hacer referencia a esta lista de valores compartida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130742754228.4001)
,p_name=>'F4000_P4004_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(130739713201.4001)
,p_prompt=>'Tipo:'
,p_source=>'DYNAMIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Dynamic;DYNAMIC,Static;STATIC'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione un tipo de lista de valores.</p>',
'<ul>',
unistr('    <li>Una lista de valores <strong>din\00E1mica</strong> define un origen de datos de una base de datos local, del SQL activado para REST o de un origen de datos de REST.</li>'),
unistr('    <li>Una lista de valores <strong>est\00E1tica</strong> se basa en valores de visualizaci\00F3n y de retorno predefinidos.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(130802786435.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4004_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:F4000_P4004_NAME)'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130754234970.4001)
,p_validation_name=>'name required'
,p_validation_sequence=>10
,p_validation=>'F4000_P4004_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la lista de valores.'
,p_associated_item=>wwv_flow_api.id(130741728686.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'fires every time'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78599008311958813.4001)
,p_validation_name=>'NameNotExists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where flow_id = :FB_FLOW_ID ',
'   and upper(lov_name) = upper(:F4000_P4004_NAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Este nombre ya est\00E1 en uso. Introduzca otro.')
,p_validation_condition=>'F4000_P4004_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(130749204700.4001)
,p_associated_item=>wwv_flow_api.id(130741728686.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574039095424616921.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130743766434.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574039138350616922.4001)
,p_event_id=>wwv_flow_api.id(574039095424616921.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04005
begin
wwv_flow_api.create_page(
 p_id=>4005.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Entradas de Barra de Navegaci\00F3n Cl\00E1sicas')
,p_step_title=>unistr('Entradas de Barra de Navegaci\00F3n Cl\00E1sicas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(340509358.4001)
,p_plug_name=>unistr('Entradas de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Las entradas de barra de navegaci\00F3n proporcionan una navegaci\00F3n basada en enlaces de hipertexto. La ubicaci\00F3n se determina mediante plantillas de p\00E1gina.</p>')
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48422127180609962.4001)
,p_plug_name=>unistr('Entradas de Barra de Navegaci\00F3n Cl\00E1sicas')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4005a */ id,',
'       icon_sequence,',
'       icon_image,',
'       substr(icon_target,1,20) icon_target,',
'       ICON_SUBTEXT,',
'       substr(ICON_IMAGE_ALT,1,20) iia,',
'       nvl(begins_on_new_line,''NO'') begins_on_new_line, ',
'       cell_colspan,',
'       (select p.patch_name',
'          from wwv_flow_patches p',
'         where p.id = ib.required_patch',
'           and p.security_group_id = ib.security_group_id',
'         union all',
'        select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',patch_name)|| ''} '' ',
'        patch_name ',
'          from wwv_flow_patches p',
'         where 0-p.id = ib.required_patch',
'           and p.security_group_id = ib.security_group_id ) required_patch,',
'       icon_bar_disp_cond_type,',
'       ''icon-sc-nav-bar'' as icon_class,',
'       substr(ICON_IMAGE_ALT,1,20) img_alt,',
'       ''f?p=4000:4308:''||:app_session||''::::F4000_P4308_ID:''||id icon_link,',
'       sys.htf.escape_sc(substr(nvl(ICON_IMAGE_ALT,icon_subtext),1,20)) icon_title,',
'--',
'       ICON_BAR_DISP_COND_TYPE display_condition,',
'       ICON_BAR_DISP_COND display_expression1,',
'       ICON_BAR_FLOW_COND_INSTR display_expression2,',
'       case when ib.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_icon_bar',
'                         where id                = ib.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_icon_bar',
'          where reference_id      = ib.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers',
'  from wwv_flow_icon_bar ib',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(48422219241609962.4001)
,p_name=>'Navigation Bar Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#ICON_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48422515012609987.4001)
,p_db_column_name=>'ICON_SEQUENCE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Secuencia'
,p_column_link=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.::F4000_P4308_ID:#ID#'
,p_column_linktext=>'#ICON_SEQUENCE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48422624388609987.4001)
,p_db_column_name=>'ICON_IMAGE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48422731746609988.4001)
,p_db_column_name=>'ICON_TARGET'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Destino'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48422800668609988.4001)
,p_db_column_name=>'ICON_SUBTEXT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Texto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48422905137609989.4001)
,p_db_column_name=>'IIA'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Etiqueta ALT'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48423025368609989.4001)
,p_db_column_name=>'BEGINS_ON_NEW_LINE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>unistr('Nueva L\00EDnea')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48423128036609990.4001)
,p_db_column_name=>'CELL_COLSPAN'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>unistr('Ampliaci\00F3n de Columna')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48422416666609982.4001)
,p_db_column_name=>'ID'
,p_display_order=>8
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48423307220609990.4001)
,p_db_column_name=>'ICON_BAR_DISP_COND_TYPE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Mostrar cuando'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48423707986618818.4001)
,p_db_column_name=>'IMG_ALT'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Imagen Alternativa'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(48482610105271026.4001)
,p_db_column_name=>'REQUIRED_PATCH'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188126009288942306.4001)
,p_db_column_name=>'DISPLAY_CONDITION'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>unistr('Condici\00F3n de Visualizaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188126127927942308.4001)
,p_db_column_name=>'DISPLAY_EXPRESSION1'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>unistr('Expresi\00F3n de Visualizaci\00F3n 1')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(188126221924942309.4001)
,p_db_column_name=>'DISPLAY_EXPRESSION2'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>unistr('Expresi\00F3n de Visualizaci\00F3n 2')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655681192100026496.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655681225030026496.4001)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Enlace de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(655681392222026496.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562500119198335.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>32
,p_column_identifier=>'W'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562676523198336.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>42
,p_column_identifier=>'X'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166777223986878260.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(166766500720858594.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188984527877899901.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48422127180609962.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.:4005,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114719722556412769.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48422127180609962.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:485:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90844120863363156.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48422127180609962.4001)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:22,4023,4024,4025,134,135::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1724511323.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4005'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21866143906.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4308_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ICON'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590028931373069351.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(90844120863363156.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590029226438069352.4001)
,p_event_id=>wwv_flow_api.id(590028931373069351.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590029358572071927.4001)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(114719722556412769.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590029676195071929.4001)
,p_event_id=>wwv_flow_api.id(590029358572071927.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_04006
begin
wwv_flow_api.create_page(
 p_id=>4006.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Mensajes de Texto'
,p_step_title=>'Mensajes de Texto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_messages.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34137624724696512.4001)
,p_plug_name=>'Informe de Mensajes de Texto'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4006a */ id,',
'       NAME,',
'       MESSAGE_LANGUAGE,',
'       substr(MESSAGE_TEXT,1,1000) message_text,',
'       length(message_text) message_length,',
'       m.is_js_message,',
'       nvl(nvl(last_updated_on,j.min_date),m.created_on) LAST_UPDATED_on,',
'       last_updated_by',
'  from WWV_FLOW_MESSAGES$ m,',
'(select min(min_date) min_date from (',
'select min(last_updated_on) min_date from wwv_flow_steps where flow_id = :fb_flow_id and last_updated_on is not null',
'union all',
'select min(last_updated_on) min_date from wwv_flow_templates where flow_id = :fb_flow_id and last_updated_on is not null',
'union all',
'select min(last_updated_on) min_date from wwv_flow_tabs where flow_id = :fb_flow_id and last_updated_on is not null',
'union all',
'select min(last_updated_on) min_date from wwv_flow_step_items where flow_id = :fb_flow_id and last_updated_on is not null)) j',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(34137717780696512.4001)
,p_name=>'Text Messages'
,p_max_row_count=>'100000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn mensaje de texto.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34138005352696522.4001)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.::F4000_P4009_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34138122795696522.4001)
,p_db_column_name=>'MESSAGE_LANGUAGE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34138212632696522.4001)
,p_db_column_name=>'MESSAGE_TEXT'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Texto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1119156409779390627.4001)
,p_db_column_name=>'IS_JS_MESSAGE'
,p_display_order=>13
,p_column_identifier=>'G'
,p_column_label=>'Utilizado en JavaScript'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34137908525696519.4001)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34138419478696523.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>33
,p_column_identifier=>'F'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(34138318878696523.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>43
,p_column_identifier=>'E'
,p_column_label=>'Fecha'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(100574748500284405.4001)
,p_db_column_name=>'MESSAGE_LENGTH'
,p_display_order=>53
,p_column_identifier=>'H'
,p_column_label=>'Longitud de Texto'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(80185705259241013.4001)
,p_plug_name=>'Mensajes de Texto'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede utilizar mensajes de texto para crear cadenas de texto traducibles con variables de sustituci\00F3n que se pueden llamar desde paquetes, procedimientos y funciones PL/SQL.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/translating-messages.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188997218470143208.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(34137624724696512.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.:4006,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(44861320647492269.4001)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_api.id(34137624724696512.4001)
,p_button_name=>'GRID_EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:888:&SESSION.::&DEBUG.:RR,888::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10062428169696797.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(34137624724696512.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Mensaje de Texto'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:4009:F4000_P4009_MESSAGE_LANGUAGE:&F4000_P4009_MESSAGE_LANGUAGE.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(540750630.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4006'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(495331285.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4009_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590088996202411698.4001)
,p_name=>'Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(34137624724696512.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(982214740538928401.4001)
,p_event_id=>wwv_flow_api.id(590088996202411698.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(34137624724696512.4001)
);
end;
/
prompt --application/pages/page_04008
begin
wwv_flow_api.create_page(
 p_id=>4008.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Esquema de Autorizaci\00F3n')
,p_step_title=>unistr('Editar Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4584513380.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 09-DEC-2000 21:06:40'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4632583063.4001)
,p_plug_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los esquemas de autorizaci\00F3n permiten proteger aplicaciones, p\00E1ginas y componentes de aplicaciones, y ampliar la seguridad que el esquema de autenticaci\00F3n de aplicaciones proporciona. Puede utilizar esquemas de autorizaci\00F3n para identificar seguri')
||unistr('dad adicional m\00E1s all\00E1 de la autenticaci\00F3n de usuario simple. Por ejemplo, un usuario con derechos de administraci\00F3n puede necesitar acceso a m\00E1s iconos, p\00E1ginas y separadores de la barra de navegaci\00F3n que otros usuarios.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(294253922620.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10863417384563609.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the F4000_P4008_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_type_page_item_name => ''F4000_P4008_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P4008_'',',
'        p_user_interface_id   => null );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11219919761952850.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33435410681829163.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4008_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_02=>'NAME'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'F4000_P4008_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_AUTHORIZATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(72150497869212519.4001)
,p_plug_name=>unistr('Punto de Evaluaci\00F3n')
,p_region_name=>'EVALUATION_POINT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91255107460444101.4001)
,p_plug_name=>unistr('Esquema de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178678919656730458.4001)
,p_plug_name=>unistr('Esquema de Autorizaci\00F3n')
,p_region_name=>'AUTHORIZATION_SCHEME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620052903566430673.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_SECURITY_SCHEMES',
'where id = :F4000_P4008_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4008_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4008_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178753331280914744.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33435410681829163.4001)
,p_button_name=>'PUBLISH_SECURITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Esquema'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4008_ID.,&FLOW_PAGE_ID.,SECURITY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from wwv_flow_security_schemes',
'where reference_id      = :F4000_P4008_ID',
'  and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178748029417904765.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33435410681829163.4001)
,p_button_name=>'REFRESH_SCHEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Esquema'
,p_button_position=>'CLOSE'
,p_button_condition=>'F4000_P4008_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4587513390.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(91255107460444101.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4589513394.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(91255107460444101.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'F4000_P4008_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4591513394.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(91255107460444101.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4008_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4593513395.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(91255107460444101.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4008_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178780115996990463.4001)
,p_branch_action=>'4008'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(178748029417904765.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4577513352.4001)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4579513352.4001)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Delete'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4581513379.4001)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4595513396.4001)
,p_name=>'F4000_P4008_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4584513380.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4599513401.4001)
,p_name=>'F4000_P4008_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4584513380.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4601513402.4001)
,p_name=>'F4000_P4008_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4584513380.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre \00FAnico que identifica este esquema de autorizaci\00F3n.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4603513404.4001)
,p_name=>'F4000_P4008_SCHEME_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Esquema'
,p_source=>'SCHEME_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHORIZATION TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHORIZATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHORIZATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHORIZATION TYPE''',
'       )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tipo de Esquema -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la forma en la que se aplicar\00E1 este esquema de autorizaci\00F3n. Se soportan los siguientes tipos incorporados:</p>'),
'<ul>',
unistr('<li><strong>Consulta SQL Exists</strong>: consulta que hace que se apruebe el esquema de autorizaci\00F3n si devuelve al menos una fila y provoca que \00E9ste falle si no devuelve ninguna</li>'),
unistr('<li><strong>Consulta SQL NOT Exists</strong>: consulta que hace que se apruebe el esquema de autorizaci\00F3n si no devuelve ninguna fila y provoca que \00E9ste falle si devuelve una o m\00E1s filas</li>'),
unistr('<li><strong>Funci\00F3n PL/SQL Que Devuelve Valor Booleano</strong>: cuerpo de la funci\00F3n PL/SQL que devuelve un valor true o false. Un valor false provoca que el esquema de autorizaci\00F3n falle. Un valor true hace que se apruebe.</li>'),
unistr('<li><strong>Elemento en Expresi\00F3n 1 Nulo</strong>: el valor del elemento especificado en la expresi\00F3n 1 es nulo.</li>'),
unistr('<li><strong>Elemento en Expresi\00F3n 1 No Nulo</strong>: el valor del elemento especificado en la expresi\00F3n 1 no es nulo.</li>'),
unistr('<li><strong>Valor de Preferencia en Expresi\00F3n 1 Equivale a Expresi\00F3n 2</strong>: el valor de la preferencia especificada en la expresi\00F3n 1 equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Valor de Preferencia en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2</strong>: el valor de la preferencia especificada en la expresi\00F3n 1 no equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Valor de Elemento en Expresi\00F3n 1 Equivale a Expresi\00F3n 2</strong>: el valor del elemento especificado en la expresi\00F3n 1 equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Valor de Elemento en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2</strong>: el valor del elemento especificado en la expresi\00F3n 1 no equivale a la expresi\00F3n 2.</li>'),
unistr('<li><strong>Est\00E1 en el Grupo</strong>: introduzca un nombre de grupo.'),
unistr('La autorizaci\00F3n es correcta si el grupo est\00E1 activado como un grupo din\00E1mico para la sesi\00F3n (consulte APEX_AUTHORIZATION.ENABLE_DYNAMIC_GROUPS).'),
unistr('Si la aplicaci\00F3n utiliza la autenticaci\00F3n de cuentas de Application Express,'),
unistr('esta comprobaci\00F3n tambi\00E9n incluye los grupos de espacios de trabajo que se otorgan al usuario.'),
unistr('Si se utiliza la autenticaci\00F3n de base de datos, esta comprobaci\00F3n tambi\00E9n incluye los roles de base de datos que se otorgan al usuario.</li>'),
unistr('<li><strong>No Est\00E1 en el Grupo</strong>: el grupo no est\00E1 activado o no se ha otorgado al usuario. Consulte <strong>Est\00E1 en el Grupo</strong> para obtener m\00E1s informaci\00F3n.</li>    '),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4665718741.4001)
,p_name=>'F4000_P4008_ERROR_MESSAGE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje de error de identificaci\00F3n que aparece cuando se ha violado un esquema')
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\00C9ste es el texto de error que aparece cuando este esquema de autorizaci\00F3n se aplica a una p\00E1gina o aplicaci\00F3n.</p>'),
unistr('<p>Si el esquema de autorizaci\00F3n falla (es decir, falla la comprobaci\00F3n de seguridad del usuario actual), aparece este texto.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(294258930514.4001)
,p_name=>'F4000_P4008_COMMENTS'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(294253922620.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_reference_id=>186974523106820907.4001
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10860428467560854.4001)
,p_name=>'P4008_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P4008_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10860606899560854.4001)
,p_name=>'P4008_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P4008_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10860821632560855.4001)
,p_name=>'P4008_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P4008_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10861029786560855.4001)
,p_name=>'P4008_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P4008_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10861216067560855.4001)
,p_name=>'P4008_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P4008_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10861424586560855.4001)
,p_name=>'P4008_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P4008_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10861609092560856.4001)
,p_name=>'P4008_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P4008_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10861822266560856.4001)
,p_name=>'P4008_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P4008_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10862031392560856.4001)
,p_name=>'P4008_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P4008_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10862206377560856.4001)
,p_name=>'P4008_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P4008_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10862409371560857.4001)
,p_name=>'P4008_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P4008_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10862611681560857.4001)
,p_name=>'P4008_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P4008_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10862827170560857.4001)
,p_name=>'P4008_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P4008_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10863017460560857.4001)
,p_name=>'P4008_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P4008_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10863219990560857.4001)
,p_name=>'P4008_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(178678919656730458.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P4008_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35554905595912743.4001)
,p_name=>'F4000_P4008_REFRESH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33435410681829163.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_begin_on_new_line=>'N'
,p_grid_column=>6
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_security_schemes',
'',
'where reference_id is null',
'',
'and id = :F4000_P4008_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(72151521185216365.4001)
,p_name=>'F4000_P4008_CACHING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(72150497869212519.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_USER_BY_PAGE_VIEW'
,p_prompt=>unistr('Validar Esquema de Autorizaci\00F3n:')
,p_source=>'CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTH_SCHEME_CACHING'
,p_lov=>'.'||wwv_flow_api.id(84860700520374929.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Los esquemas de autorizaci\00F3n se eval\00FAan en el primer uso de una sesi\00F3n.'),
unistr('El atributo <em>Validar Esquema de Autorizaci\00F3n</em> controla si las utilizaciones futuras generan nuevas evaluaciones y cu\00E1ndo se puede tomar en su lugar un resultado memorizado.'),
'La siguiente lista describe las opciones disponibles:',
'</p>',
'<ul>',
unistr('<li><strong>Una Vez por Sesi\00F3n:</strong> evaluar solo una vez y utilizar siempre el resultado memorizado posteriormente.</li>'),
unistr('<li><strong>Una Vez por Vista de P\00E1gina:</strong> evaluar una vez para cada solicitud que se procesa. Utilizar el resultado memorizado si se hace referencia al esquema de autorizaci\00F3n en m\00E1s de un componente en la p\00E1gina.</li>'),
unistr('<li><strong>Una Vez por Componente:</strong> evaluar una vez para cada componente que hace referencia al esquema de autorizaci\00F3n, pero guardar el resultado en la sesi\00F3n. Las dem\00E1s solicitudes para presentar o procesar el esquema utilizan el resultado')
||' memorizado.</li>',
unistr('<li><strong>Siempre (Sin Almacenamiento en Cach\00E9):</strong> el esquema de autorizaci\00F3n se evaluar\00E1 siempre.</li>'),
'</ul>',
'<p>',
unistr('El valor por defecto <em>Una Vez por Sesi\00F3n</em> es el m\00E1s eficiente.'),
unistr('Debe seleccionar otro valor si la comprobaci\00F3n de autorizaci\00F3n depende del cambio de estado de la sesi\00F3n u otros factores que no son consistentes en una sesi\00F3n completa.'),
unistr('Las opciones <em>Una Vez por Componente</em> y <em>Siempre (Sin Almacenamiento en Cach\00E9)</em> proporcionan informaci\00F3n adicional sobre el componente que se protege mediante el esquema de autorizaci\00F3n.'),
unistr('En los plugins de autorizaci\00F3n, puede utilizar los atributos <em>component.type</em>, <em>component.id</em> y <em>component.name</em> del par\00E1metro <em>t_authorization</em>.'),
unistr('Para los tipos de esquema <em>Consulta SQL Exists</em> y <em>Funci\00F3n PL/SQL</em> incorporados, hay disponibles variables de enlace <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> y <em>:APP_COMPONENT_NAME</em> equivalentes.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178743827500893941.4001)
,p_name=>'F4000_P4008_REFERENCE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33435410681829163.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n Maestro de Referencia de')
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_SECURITY_SCHEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'')||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_security_schemes',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Utilice este campo para basar este esquema de autorizaci\00F3n en un esquema de autorizaci\00F3n existente en esta aplicaci\00F3n u otra aplicaci\00F3n del espacio de trabajo.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35579814160984745.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4008_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4646630029.4001)
,p_validation_name=>'naming convention on name'
,p_validation_sequence=>10
,p_validation=>'substr(:F4000_P4008_NAME,1,1) not in (''!'',''0'',''1'',''2'',''3'',''4'',''5'',''6'',''7'',''8'',''9'','' '')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nombre del esquema de autorizaci\00F3n no debe empezar por un numeral, ''!'' o un espacio en blanco')
,p_associated_item=>wwv_flow_api.id(4601513402.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178760112798946315.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4008_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de referencia para refrescar el esquema de autorizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(178748029417904765.4001)
,p_associated_item=>wwv_flow_api.id(178743827500893941.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178764630685953193.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P4008_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>unistr('Se debe especificar un esquema de autorizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(178748029417904765.4001)
,p_associated_item=>wwv_flow_api.id(178743827500893941.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10882903317568994.4001)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P4008_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4008_'',',
'        p_user_interface_id => null );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(270498903813546672.4001)
,p_validation_name=>'Name Unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from WWV_FLOW_SECURITY_SCHEMES',
'where security_group_id = :flow_security_group_id ',
'and   flow_id = :FB_FLOW_ID ',
'and   id != nvl(:F4000_P4008_ID, -1)',
'and   name = :F4000_P4008_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('#LABEL# debe ser un valor \00FAnico.')
,p_associated_item=>wwv_flow_api.id(4601513402.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4607513409.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203928541810288817.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P4008_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178770827007970076.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh authorization scheme '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_security_scheme (',
'    p_master_scheme_id         => :F4000_P4008_REFERENCE_ID,',
'    p_subscribing_scheme_id    => :F4000_P4008_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar el esquema de autorizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(178748029417904765.4001)
,p_process_when=>'F4000_P4008_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>unistr('Esquema de autorizaci\00F3n refrescado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203928411578288816.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P4008_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4008_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4609513412.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35584005305003996.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh authorization scheme 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_security_scheme (',
'    p_master_scheme_id         => :F4000_P4008_REFERENCE_ID,',
'    p_subscribing_scheme_id    => :F4000_P4008_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al refrescar el esquema de autorizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(4591513394.4001)
,p_process_when=>':F4000_P4008_REFERENCE_ID is not null and :F4000_P4008_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Esquema de autorizaci\00F3n refrescado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178776823544986968.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_scheme_reference_id (:F4000_P4008_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de referencia en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(4591513394.4001)
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(12850122373753013.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset app authorization cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authorization.reset_cache (',
'    p_save_state => true );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_04009
begin
wwv_flow_api.create_page(
 p_id=>4009.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Mensajes de Texto'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear/Editar: Mensaje de Texto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_dialog_chained=>'N'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_messages.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(478331273.4001)
,p_plug_name=>'Mensaje'
,p_region_css_classes=>'resizable: true'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Los mensajes se han dise\00F1ado para proporcionar servicios de traducci\00F3n para su uso en PL/SQL.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 19-MAY-2000 21:03:13'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(206273416506766642.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619335031686468096.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_MESSAGES$',
'where id = :F4000_P4009_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4009_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4009_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(479331275.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(206273416506766642.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(480331276.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(206273416506766642.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(171883101276015336.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(206273416506766642.4001)
,p_button_name=>'CREATEAGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(482331277.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(206273416506766642.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Mensaje de Texto'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481331277.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(206273416506766642.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(171882921923011838.4001)
,p_branch_name=>'Go To Page 4009'
,p_branch_action=>'f?p=&APP_ID.:4009:&SESSION.:TEST:&DEBUG.:RP,4009:F4000_P4009_MESSAGE_LANGUAGE:&F4000_P4009_MESSAGE_LANGUAGE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(171883101276015336.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'NEVER'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(483331280.4001)
,p_name=>'F4000_P4009_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484331280.4001)
,p_name=>'F4000_P4009_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(485331281.4001)
,p_name=>'F4000_P4009_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre \00FAnico para el mensaje que va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486331281.4001)
,p_name=>'F4000_P4009_MESSAGE_LANGUAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&BROWSER_LANGUAGE.'
,p_prompt=>'Idioma'
,p_source=>'MESSAGE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Seleccione el idioma para el que se utilizar\00E1 este mensaje.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(487331281.4001)
,p_name=>'F4000_P4009_MESSAGE_TEXT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto'
,p_source=>'MESSAGE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el texto que se va a devolver al llamar a este mensaje de texto.</p>',
'<p>Ejemplo: Impuestos: %0 Importe Total %1',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36793912850005171.4001)
,p_name=>'F4000_P4009_PRIMARY_LANGUAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517781159820724707.4001)
,p_name=>'P4009_IS_JS_MESSAGE'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(478331273.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Utilizado en JavaScript'
,p_source=>'IS_JS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione <strong>Activado</strong> si el mensaje se utiliza en llamadas de API <code>apex.lang.*</code> en c\00F3digo JavaScript.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(181025111997044440.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4009_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:F4000_P4009_NAME)'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(38027668285101533.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4009_IS_JS_MESSAGE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_js_message wwv_flow_messages$.is_js_message%type;',
'begin',
'    begin',
'        -- check if the name matches with one of the APEX system messages,',
'        -- in that case we use the same is_js_message setting because the',
'        -- developer just wants provide a different text message in their app.',
'        select is_js_message',
'          into l_is_js_message',
'          from wwv_flow_messages$',
'         where flow_id = 4411',
'           and name    = :F4000_P4009_NAME;',
'',
'        return l_is_js_message;',
'    exception when no_data_found then ',
'        return :P4009_IS_JS_MESSAGE;',
'    end;',
'end;'))
,p_compute_when=>'FB_FLOW_ID'
,p_compute_when_text=>'4411'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(599335264.4001)
,p_validation_name=>'Name must be supplied'
,p_validation_sequence=>10
,p_validation=>'F4000_P4009_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre del mensaje.'
,p_associated_item=>wwv_flow_api.id(485331281.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(601352090.4001)
,p_validation_name=>'Message Text Required'
,p_validation_sequence=>20
,p_validation=>'F4000_P4009_MESSAGE_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el texto del mensaje.'
,p_associated_item=>wwv_flow_api.id(487331281.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114586604868671476.4001)
,p_validation_name=>'name must be unique within application - create'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MESSAGES$',
'where upper(NAME) = upper(:F4000_P4009_NAME)',
'and message_language = :F4000_P4009_MESSAGE_LANGUAGE',
'and FLOW_ID = :fb_flow_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre del mensaje debe ser \00FAnico')
,p_when_button_pressed=>wwv_flow_api.id(482331277.4001)
,p_associated_item=>wwv_flow_api.id(485331281.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114727927266487237.4001)
,p_validation_name=>'name must be unique within application - update'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MESSAGES$',
'where upper(NAME) = upper(:F4000_P4009_NAME)',
'and message_language = :F4000_P4009_MESSAGE_LANGUAGE',
'and id <> :F4000_P4009_ID',
'and FLOW_ID = :fb_flow_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El nombre del mensaje debe ser \00FAnico')
,p_when_button_pressed=>wwv_flow_api.id(481331277.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590015417007897547.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(479331275.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590015547784897548.4001)
,p_event_id=>wwv_flow_api.id(590015417007897547.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488331282.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_MESSAGES$'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MESSAGES$'
,p_attribute_03=>'F4000_P4009_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4009_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(489331283.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_MESSAGES$'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MESSAGES$'
,p_attribute_03=>'F4000_P4009_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590015679101897549.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,DELETE,APPLY_CHANGES'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_process_comment=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
);
end;
/
prompt --application/pages/page_04014
begin
wwv_flow_api.create_page(
 p_id=>4014.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Lista de Valores: Valores Est\00E1ticos o de Consulta')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(689510170.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(161740513874429436.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Sequence:Display Value:Return Value'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'RLL'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(130764307507.4001)
,p_name=>unistr('Crear Lista de Valores Est\00E1tica')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f01" title="''||wwv_flow_lang.system_message(''DISPLAY_VALUE.N'',i)||''">'' g01,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f02" title="''||wwv_flow_lang.system_message(''RETURN_VALUE.N'',i)||''">'' g02',
'from   wwv_flow_dual100',
'where  i < 16',
'order  by i'))
,p_header=>unistr('<p>Introduzca valores de visualizaci\00F3n y de retorno est\00E1ticos. Los valores se muestran en el orden en el que se han introducido. El <strong>Valor de Retorno</strong> no se muestra, sino que es el valor que se devuelve al motor &PRODUCT_NAME.. Si no e')
||unistr('specifica un <strong>Valor de Retorno</strong>, ser\00E1 igual al <strong>Valor de Visualizaci\00F3n</strong>. Se pueden mostrar atributos adicionales entre los que se incluyen controles de opciones de creaci\00F3n y visualizaci\00F3n condicional de nivel de element')
||'o editando la lista de valores.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48477814920770274.4001)
,p_query_column_id=>1
,p_column_alias=>'I'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48477906451770274.4001)
,p_query_column_id=>2
,p_column_alias=>'G01'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Valor de Visualizaci\00F3n')
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48478030779770274.4001)
,p_query_column_id=>3
,p_column_alias=>'G02'
,p_column_display_sequence=>3
,p_column_heading=>'Valor de Retorno'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44768629474106856.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130795542638.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44768629474106856.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130794537566.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44768629474106856.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Lista de Valores'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130797612760.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44768629474106856.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130796609694.4001)
,p_branch_name=>'Go To Page 4110'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(130794537566.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130798614150.4001)
,p_branch_action=>'4004'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130797612760.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130800656059.4001)
,p_name=>'F4000_P4014_N'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(130764307507.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Lista de Valores:'
,p_source=>'F4000_P4004_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Ser\00E1 el nombre de la lista de valores compartida.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(159409002328124590.4001)
,p_validation_name=>'must enter at least one value'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c number;',
'  x number := 0;',
'begin',
'  c := wwv_flow.g_f01.count;',
'  if c > 0 then ',
'     for i in 1..c loop',
'        if wwv_flow.g_f01(i) is not null then',
'          x := x + 1;',
'        end if;',
'     end loop;',
'     if x > 0 then ',
'         return true;',
'     else',
'         return false;',
'     end if;',
'  else ',
'     return false;',
'  end if;',
'exception',
'  when others then c := 0;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Se debe introducir al menos una entrada.'
,p_when_button_pressed=>wwv_flow_api.id(130794537566.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574038708765616918.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130795542638.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574038830634616919.4001)
,p_event_id=>wwv_flow_api.id(574038708765616918.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(130799617858.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create List of Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s int;',
'  r varchar2(4000);',
'begin',
'  select wwv_flow_id.next_val into s from dual;',
'  ',
'  wwv_flow_api.create_list_of_values (',
'      p_id        => s,',
'      p_flow_id   => nv(''FB_FLOW_ID''),',
'      p_lov_name  => upper(v(''F4000_P4004_NAME'')),',
'      p_lov_query => null,',
'      p_location  => ''STATIC'');',
'    ',
'  for i in 1..wwv_flow.g_f01.count loop',
'      begin ',
'          r := nvl(wwv_flow.g_f02(i),wwv_flow.g_f01(i)); ',
'      exception when others then ',
'          r := wwv_flow.g_f01(i);',
'      end;',
'      if wwv_flow.g_f01(i) is not null then',
'          wwv_flow_api.create_static_lov_data (',
'              p_lov_id            => s,',
'              p_lov_disp_sequence => i,',
'              p_lov_disp_value    => wwv_flow.g_f01(i),',
'              p_lov_return_value  => r);',
'      end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la lista de valores est\00E1tica.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(130794537566.4001)
,p_process_success_message=>unistr('Lista de valores est\00E1tica creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574038930528616920.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>unistr('Lista de valores est\00E1tica creada.')
);
end;
/
prompt --application/pages/page_04023
begin
wwv_flow_api.create_page(
 p_id=>4023.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n: Atributos')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(690542997.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(103870209211856610.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(937050648.4001)
,p_name=>unistr('Entradas de Barra de Navegaci\00F3n Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ICON_SEQUENCE, ',
'       decode(icon_image,null,null,sys.htf.img(''&IMAGE_PREFIX.''||ICON_IMAGE)) img, ',
'       substr(ICON_IMAGE_ALT,1,20) a,',
'       decode(ICON_BAR_DISP_COND,',
'          null,wwv_flow_lang.system_message(''F4000.NO''),',
'          wwv_flow_lang.system_message(''F4000.YES'')) is_cond',
'from   wwv_flow_icon_bar',
'where  flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48936711202773185.4001)
,p_query_column_id=>1
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48936821834773186.4001)
,p_query_column_id=>2
,p_column_alias=>'IMG'
,p_column_display_sequence=>2
,p_column_heading=>'Icono'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48936918682773186.4001)
,p_query_column_id=>3
,p_column_alias=>'A'
,p_column_display_sequence=>3
,p_column_heading=>'Texto ALT'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48937025056773186.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_COND'
,p_column_display_sequence=>4
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131995828236.4001)
,p_plug_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46437828557135499.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197011332657417640.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_source=>unistr('<p>Las entradas de barra de navegaci\00F3n permiten a usuarios desplazarse f\00E1cilmente por las p\00E1ginas de una aplicaci\00F3n. La ubicaci\00F3n de una barra de navegaci\00F3n depende de la plantilla de p\00E1gina asociada. Las entradas de barra de navegaci\00F3n pueden ser im')
||unistr('\00E1genes, im\00E1genes con texto en la parte inferior o texto.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506536418928562515.4001)
,p_plug_name=>'Icono Opcional'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(131997838777.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46437828557135499.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(691552414.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46437828557135499.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193677631147123583.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46437828557135499.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(692552421.4001)
,p_branch_action=>'4024'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(691552414.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(196943108267549663.4001)
,p_branch_action=>'f?p=&APP_ID.:392:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(193677631147123583.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(722661038.4001)
,p_name=>'F4000_P4023_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(131995828236.4001)
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>38
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(921834124.4001)
,p_name=>'F4000_P4023_IMG1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(506536418928562515.4001)
,p_prompt=>'Nombre de Imagen de Icono'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>50
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La imagen es el nombre de la imagen.&nbsp; Por ejemplo: wwv_find.gif.&nbsp; El prefijo de la imagen puede ser uno de los siguientes:',
'',
'<ol>',
'',
'<li>&#35;WORKSPACE_FILES&#35;</li>',
'',
'<li>&#35;APP_FILES&#35;</li>',
'',
unistr('<li>nulo (del directorio especificado por el atributo de imagen de la aplicaci\00F3n)</li>'),
'',
'</ol>',
'',
'Ejemplo de nombres de imagen:',
'',
'<pre>',
'',
'&#35;WORKSPACE_FILES&#35;my_image.jpg',
'',
'&#35;APP_FILES&#35;another_image.gif',
'',
'html_db_white.gif',
'',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(922839912.4001)
,p_name=>'F4000_P4023_TEXT1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(131995828236.4001)
,p_prompt=>'Etiqueta de Entrada'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto adicional que aparecer\00E1 con la imagen. Puede incluir texto o utilizar iconos sin texto. Este atributo es opcional y se puede traducir.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(923854364.4001)
,p_name=>'F4000_P4023_ALT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(506536418928562515.4001)
,p_prompt=>'Imagen ALT'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca texto alternativo para los iconos de navegaci\00F3n que son im\00E1genes. Si no especifica un nombre de imagen, aparece este texto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(930896906.4001)
,p_name=>'F4000_P4023_H1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(506536418928562515.4001)
,p_prompt=>'Altura de Imagen'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define la altura de la imagen.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(931900081.4001)
,p_name=>'F4000_P4023_W1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(506536418928562515.4001)
,p_prompt=>'Ancho'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define el ancho de la imagen.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72114714144530024.4001)
,p_validation_name=>'HeightNumeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4023_H1'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La altura debe ser num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(691552414.4001)
,p_associated_item=>wwv_flow_api.id(930896906.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(72116325918533419.4001)
,p_validation_name=>'WidthNumeric'
,p_validation_sequence=>20
,p_validation=>'F4000_P4023_W1'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El ancho debe ser num\00E9rico.')
,p_when_button_pressed=>wwv_flow_api.id(691552414.4001)
,p_associated_item=>wwv_flow_api.id(931900081.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185464304552464966.4001)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4023_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia.'
,p_when_button_pressed=>wwv_flow_api.id(691552414.4001)
,p_associated_item=>wwv_flow_api.id(722661038.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185465322906470190.4001)
,p_validation_name=>'sequence is numberic'
,p_validation_sequence=>40
,p_validation=>'F4000_P4023_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La secuencia debe ser un n\00FAmero.')
,p_when_button_pressed=>wwv_flow_api.id(691552414.4001)
,p_associated_item=>wwv_flow_api.id(722661038.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185467513126486307.4001)
,p_validation_name=>'must have image or text'
,p_validation_sequence=>50
,p_validation=>':F4000_P4023_IMG1 is not null or :F4000_P4023_TEXT1 is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Debe proporcionar una imagen, texto o ambos.'
,p_when_button_pressed=>wwv_flow_api.id(691552414.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573753685869229717.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(131997838777.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573753714566229718.4001)
,p_event_id=>wwv_flow_api.id(573753685869229717.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04024
begin
wwv_flow_api.create_page(
 p_id=>4024.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n: Destino')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(693567012.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(103870209211856610.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(695584447.4001)
,p_plug_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(137389740604.4001)
,p_name=>unistr('Destinos de Entrada de Barra de Navegaci\00F3n Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select icon_sequence, ',
'       substr(icon_target,1,60) icon_target',
'from   wwv_flow_icon_bar',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48761121492772061.4001)
,p_query_column_id=>1
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48761213870772061.4001)
,p_query_column_id=>2
,p_column_alias=>'ICON_TARGET'
,p_column_display_sequence=>2
,p_column_heading=>'Destino'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46442727696173137.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(956248135.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46442727696173137.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(697594360.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46442727696173137.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(939083560.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46442727696173137.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(698594362.4001)
,p_branch_action=>'4025'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(697594360.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(940083562.4001)
,p_branch_action=>'4023'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(939083560.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(938077978.4001)
,p_name=>'F4000_P4023_TARGET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Target: (syntax f?p=application:page:session:request:debug:clearCache:itemNames:itemValues)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>65
,p_cMaxlength=>2000
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_colspan=>3
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(941090545.4001)
,p_name=>'F4000_P4024_P'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(943110344.4001)
,p_name=>'F4000_P4024_ALT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta Alternativa'
,p_source=>'F4000_P4023_ALT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'F4000_P4023_ALT'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el texto alternativo para la imagen.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22228804443016517.4001)
,p_name=>'P4024_URL_OR_FLOW'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_item_default=>'FLOW'
,p_prompt=>'El destino es'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_api.id(84796030957080920.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el destino para esta entrada de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22229420374021153.4001)
,p_name=>'P4024_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el n\00FAmero de p\00E1gina. Para restablecer la paginaci\00F3n, seleccione <span class="fielddatabold">restablecer paginaci\00F3n para esta p\00E1gina</span>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22230301804025267.4001)
,p_name=>'P4024_CLEAR_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Seleccione esta opci\00F3n para restablecer la paginaci\00F3n de la p\00E1gina a la que va a enlazar.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22231209685046384.4001)
,p_name=>'P4024_REQUEST'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto que define el elemento de aplicaci\00F3n incorporado denominado REQUEST. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22232120074049444.4001)
,p_name=>'P4024_CLEAR_CACHE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>unistr('Borrar Cach\00E9')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los n\00FAmeros de p\00E1gina en los que desea borrar el estado de la sesi\00F3n del usuario. Separe las entradas con comas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22233028732051929.4001)
,p_name=>'P4024_ARG_NAMES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Defina estos elementos'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la lista de nombres de elementos de aplicaci\00F3n para los que desea definir el estado de la sesi\00F3n. Separe los elementos con comas. Al definir el estado de la sesi\00F3n se proporciona un valor al elemento mostrado. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22234007392055225.4001)
,p_name=>'P4024_ARG_VALUES'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Con estos valores'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una lista de valores delimitada por comas para los elementos especificados en <span class="fielddatabold">Defina estos elementos</span>. Puede especificar valores est\00E1ticos o sintaxis de sustituci\00F3n (por ejemplo, &amp;APP_ITEM_NAME.). '),
'<pre>&amp;APP_ITEM_NAME.</pre>',
unistr('<div class="htmldbInfoBodyP">Los valores de los elementos que se transfieren a <span class="fielddatabold">f?p=</span> en la direcci\00F3n URL nunca pueden contener un signo de dos puntos (:). Los valores de los elementos tampoco pueden contener comas a ')
||'menos que incluya todo el valor entre caracteres de barra invertida. Por ejemplo:</div>',
'<pre>\1234,56\</pre>',
unistr('<div class="htmldbInfoBodyP">Esto resulta \00FAtil cuando hay que transferir valores decimales donde el car\00E1cter separador de decimales de NLS es una coma.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22235619475106034.4001)
,p_name=>'P4024_URL_TARGET'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Destino de URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Introduzca una direcci\00F3n URL para esta entrada de barra de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(135042203997757993.4001)
,p_name=>'P4024_PINTER_FRIENDLY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRINTER_FRIENDLY)'
,p_lov=>'.'||wwv_flow_api.id(148325219515185885.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para definir la versi\00F3n para impresora.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(940659298610194134.4001)
,p_name=>'P4024_COMMA_SEP1'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Separado por coma1'
,p_source=>'''(''||wwv_flow_lang.system_message(''WS_COMMA_SEP_LIST'')||'')'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(940659388647194135.4001)
,p_name=>'P4024_COMMA_SEP2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Separado por coma1'
,p_source=>'''(''||wwv_flow_lang.system_message(''WS_COMMA_SEP_LIST'')||'')'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(940659435853194136.4001)
,p_name=>'P4024_COMMA_SEP3'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(695584447.4001)
,p_prompt=>'Separado por coma1'
,p_source=>'''(''||wwv_flow_lang.system_message(''WS_COMMA_SEP_LIST'')||'')'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(22238723855173575.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4023_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'  l_pf          varchar2(30) := null;',
'begin',
'if nvl(:P4024_PINTER_FRIENDLY,''N'') = ''YES'' then',
'   l_pf := '':YES'';',
'end if;',
'if :P4024_URL_OR_FLOW = ''FLOW'' then',
'  if :P4024_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4024_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4024_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''',
'         ||:P4024_PAGE_ID||',
'         '':&''||''SESSION.:''||:P4024_REQUEST||',
'         '':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||',
'         '':''||:P4024_ARG_NAMES||',
'         '':''||:P4024_ARG_VALUES||',
'         l_pf;',
'else',
'  return :P4024_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'Next'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(957259216.4001)
,p_validation_name=>'Target Required'
,p_validation_sequence=>10
,p_validation=>'(:P4024_URL_OR_FLOW = ''URL'' and :P4024_URL_TARGET is not null) or (:P4024_URL_OR_FLOW = ''FLOW'' and :P4024_PAGE_ID is not null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Se debe especificar una direcci\00F3n URL o una p\00E1gina como destino.')
,p_when_button_pressed=>wwv_flow_api.id(697594360.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573753415200229715.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(956248135.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573753520719229716.4001)
,p_event_id=>wwv_flow_api.id(573753415200229715.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(385810889376243633.4001)
,p_name=>'URL or Flow Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4024_URL_OR_FLOW'
,p_condition_element=>'P4024_URL_OR_FLOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385810992597243634.4001)
,p_event_id=>wwv_flow_api.id(385810889376243633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_PAGE_ID,P4024_REQUEST,P4024_CLEAR_CACHE,P4024_ARG_NAMES,P4024_ARG_VALUES,P4024_COMMA_SEP1,P4024_COMMA_SEP2,P4024_COMMA_SEP3,P4024_CLEAR_PAGE,P4024_PINTER_FRIENDLY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385811094569243635.4001)
,p_event_id=>wwv_flow_api.id(385810889376243633.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_PAGE_ID,P4024_REQUEST,P4024_CLEAR_CACHE,P4024_ARG_NAMES,P4024_ARG_VALUES,P4024_COMMA_SEP1,P4024_COMMA_SEP2,P4024_COMMA_SEP3,P4024_CLEAR_PAGE,P4024_PINTER_FRIENDLY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385811158041243636.4001)
,p_event_id=>wwv_flow_api.id(385810889376243633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_URL_TARGET'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385811202327243637.4001)
,p_event_id=>wwv_flow_api.id(385810889376243633.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_URL_TARGET'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_04025
begin
wwv_flow_api.create_page(
 p_id=>4025.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n: Condici\00F3n de Visualizaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694570598.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(103870209211856610.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699599737.4001)
,p_plug_name=>unistr('Crear Entrada de Barra de Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Identifique una condici\00F3n de visualizaci\00F3n para esta entrada de barra de navegaci\00F3n y, a continuaci\00F3n, haga clic en <strong>Crear</strong></p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46443208781177145.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(193548722227751980.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46443208781177145.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(948258037.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46443208781177145.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(953148861.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46443208781177145.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(949258039.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(948258037.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(954148863.4001)
,p_branch_action=>'4024'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(953148861.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(944209567.4001)
,p_name=>'F4000_P4023_CONDITION_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(699599737.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista. Esta condici\00F3n se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4023_CONDITION'
,p_attribute_02=>'F4000_P4023_CONDITION_INSTR'
,p_attribute_04=>'F4000_P4023_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4023_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(945212993.4001)
,p_name=>'F4000_P4023_CONDITION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(699599737.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o procesa')
||' el componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(946217758.4001)
,p_name=>'F4000_P4023_CONDITION_INSTR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(699599737.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1678821880973449.4001)
,p_name=>'F4000_P4023_CONDITION_LANG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(699599737.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435039717599654780.4001)
,p_name=>'F4000_P4023_CONDITION_CHECK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(699599737.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573753213413229713.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(193548722227751980.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573753313020229714.4001)
,p_event_id=>wwv_flow_api.id(573753213413229713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(950258662.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create nav bar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.create_icon_bar_item (',
'p_flow_id                  => nv(''FB_FLOW_ID''),',
'p_icon_sequence            => nv(''F4000_P4023_SEQUENCE''),',
'p_icon_image               => v(''F4000_P4023_IMG1''),',
'p_icon_image2              => v(''F4000_P4023_IMG2''),',
'p_icon_image3              => v(''F4000_P4023_IMG3''),',
'p_icon_subtext             => v(''F4000_P4023_TEXT1''),',
'p_icon_subtext2            => v(''F4000_P4023_TEXT2''),',
'p_icon_subtext3            => v(''F4000_P4023_TEXT3''),',
'p_icon_target              => v(''F4000_P4023_TARGET''),',
'p_icon_image_alt           => v(''F4000_P4023_ALT''),',
'p_icon_height              => v(''F4000_P4023_H1''),',
'p_icon_width               => v(''F4000_P4023_W1''),',
'p_icon_height2             => v(''F4000_P4023_H2''),',
'p_icon_width2              => v(''F4000_P4023_W2''),',
'p_icon_height3             => v(''F4000_P4023_H3''),',
'p_icon_width3              => v(''F4000_P4023_W3''),',
'p_icon_bar_disp_cond       => v(''F4000_P4023_CONDITION''),',
'p_icon_bar_disp_cond_type  => replace(v(''F4000_P4023_CONDITION_TYPE''),''0'',null),',
'p_icon_bar_flow_cond_instr => v(''F4000_P4023_CONDITION_INSTR''),',
'p_begins_on_new_line       => ''NO'',',
'p_cell_colspan             => ''1'',',
'p_onclick                  => null,',
'p_required_patch           => null,',
'p_icon_bar_comment         => null);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la entrada de la barra de navegaci\00F3n.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(948258037.4001)
,p_process_success_message=>unistr('Barra de navegaci\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(573755158311229732.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Barra de navegaci\00F3n creada.')
);
end;
/
prompt --application/pages/page_04041
begin
wwv_flow_api.create_page(
 p_id=>4041.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>'&P4041_PAGE_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(215582428597891495)
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(".ui-dialog--apex .ui-dialog-title").text($v("P4041_PAGE_TITLE"));'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(137496770813.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(61344818353755082.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(137512681636.4001)
,p_plug_name=>unistr('Crear P\00E1gina de Informe')
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202169000073126213.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(137513702317.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202169000073126213.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(137519811667.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(202169000073126213.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699455525638526458.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(202169000073126213.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197772656324040010.4001)
,p_branch_name=>'Go To Navigation/Tab'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(137519811667.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(117286323591009257.4001)
,p_branch_action=>'f?p=&APP_ID.:4041:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P4041_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699456041630533753.4001)
,p_branch_action=>'4700'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699455525638526458.4001)
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P362_OPT'
,p_branch_condition_text=>'R'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137445627270.4001)
,p_name=>'F4000_P4703_REPORT_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Informe')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,2)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :F4000_P4703_REPORT_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina.<p />'),
'',
unistr('Si identifica un n\00FAmero de p\00E1gina existente, el asistente agrega el componente a esa p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137447627271.4001)
,p_name=>'F4000_P4703_PAGINATION_SIZE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'15'
,p_prompt=>unistr('Tama\00F1o de Paginaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Indique el n\00FAmero de filas que aparecer\00E1 por p\00E1gina si se va a paginar la regi\00F3n de informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137455627275.4001)
,p_name=>'F4000_P4703_RPT_PLUG_TEMPLATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   r number null;',
'begin',
'',
'for c1 in (select',
'DEFAULT_CHART_TEMPLATE,',
'DEFAULT_FORM_TEMPLATE,',
'DEFAULT_WIZARD_TEMPLATE,',
'DEFAULT_TABFORM_TEMPLATE,',
'DEFAULT_REPORTR_TEMPLATE,',
'DEFAULT_MENUR_TEMPLATE,',
'DEFAULT_REGION_TEMPLATE',
'from wwv_flow_themes where flow_id = :fb_flow_id',
'and theme_id = :fb_theme_id ) loop',
'if :P259_CHOOSE_PAGE_TYPE in (''REPORT'',''CALENDAR'',''TREE'') then',
'   r := c1.DEFAULT_REPORTR_TEMPLATE;',
'elsif :P259_CHOOSE_PAGE_TYPE in (''CHART'') then',
'   r := c1.DEFAULT_CHART_TEMPLATE;',
'elsif :P259_CHOOSE_PAGE_TYPE in (''FORM'') then',
'   r := c1.DEFAULT_FORM_TEMPLATE;',
'elsif :P259_CHOOSE_PAGE_TYPE in (''WIZARD'') then',
'   r := c1.DEFAULT_WIZARD_TEMPLATE;',
'end if;',
'if r is null then',
'   r := c1.DEFAULT_REGION_TEMPLATE;',
'end if;',
'end loop;',
'return r;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca la plantilla de regi\00F3n que contendr\00E1 el informe. La plantilla de regi\00F3n determinar\00E1 el color de fondo de la tabla, de la cabecera y el tama\00F1o de fuente por defecto del informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137516747552.4001)
,p_name=>'F4000_P4041_OWN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P4703_TABLE_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
,p_help_text=>'Identifica el esquema propietario de la tabla o vista en la que se van a basar el informe y la pantalla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137517757361.4001)
,p_name=>'F4000_P4041_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Name:'
,p_source=>'P4703_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la tabla o vista en la que se basan el informe y la pantalla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(137562733639.4001)
,p_name=>'F4000_P4703_REPORT_PAGE_NAME'
,p_item_sequence=>91
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('Nombre de P\00E1gina de Informe')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el t\00EDtulo de la p\00E1gina que contendr\00E1 el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43246702292628594.4001)
,p_name=>'P4703_RPT_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>'Plantilla de Informe'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_dev.get_report_template_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_theme_id       => :FB_THEME_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id ',
'  from wwv_flow_row_templates ',
'where flow_id = :FB_FLOW_ID and',
'  (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de informe que se utilizar\00E1 al representar las filas de este informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45075131193441433.4001)
,p_name=>'P4041_PAGE_MODE'
,p_item_sequence=>92
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina de Informe')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when_type=>'NEVER'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(60706717841800189.4001)
,p_name=>'P4041_USE_UI_DEF3'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>'Usar Valores por Defecto de Interfaz de Usuario:'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Seleccione que se utilicen valores por defecto de interfaz de usuario para crear la pantalla. Si selecciona <strong>No</strong>, el asistente no utiliza los valores por defecto.</div>',
'<div class="htmldbInfoBodyP">Los valores por defecto de interfaz de usuario permiten a los desarrolladores asignar propiedades de interfaz de usuario por defecto a una tabla, columna o vista de un esquema especificado. Cuando un desarrollador crea un'
||unistr('a pantalla o un informe mediante un asistente, el asistente utiliza esta informaci\00F3n para crear valores por defecto para propiedades de regi\00F3n y elemento.</div>  '),
'<div class="htmldbInfoBodyP">Para ver los valores por defecto de interfaz de usuario de esta tabla, seleccione <strong>Ver Valores por Defecto de Interfaz de Usuario</strong> en la lista Tareas.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62772786186299492.4001)
,p_name=>'F4000_P4703_RPT_PLUG_NAME'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('T\00EDtulo de la Regi\00F3n')
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el t\00EDtulo de la regi\00F3n que contendr\00E1 el informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117283121382999195.4001)
,p_name=>'P4041_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117289213716015886.4001)
,p_name=>'P4041_BREADCRUMB_NAME'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'F4000_P4703_REPORT_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(138790507661972386.4001)
,p_name=>'P4041_IMPLEMENTATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'INTERACTIVE'
,p_prompt=>'Tipo de Informe'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4041_REPORT TYPE'
,p_lov=>'.'||wwv_flow_api.id(313152813488687118.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''CLASSIC_REPORT'' )',
'  or ',
'  wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''INTERACTIVE_REPORT'' )',
'  or ',
'  wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''INTERACTIVE_GRID'' ))',
'and :P4041_TYPE <> ''L''',
'and :P4041_TYPE <> ''T''',
''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el tipo de implantaci\00F3n de informe. Entre las opciones se incluyen las siguientes:'),
'<ul>',
unistr('<li><strong>Cuadr\00EDcula Interactiva</strong> crea una cuadr\00EDcula interactiva de solo lectura.</li>'),
'<li><strong>Informe Interactivo</strong> crea un informe interactivo.</li>',
unistr('<li><strong>Informe Cl\00E1sico</strong> crea un informe cl\00E1sico basado en plantilla.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(140578510148320041.4001)
,p_name=>'P4041_REGION_TEMPLATE_CLASSIC_JS'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211134213691312633.4001)
,p_name=>'F4000_P4703_FLOW_STEP_ID'
,p_item_sequence=>93
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina de Formulario')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_display_when=>'P4041_TYPE'
,p_display_when2=>'T'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero de p\00E1gina de la pantalla que se va a generar. Si la p\00E1gina no existe, se crear\00E1.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211134358056312634.4001)
,p_name=>'F4000_P4703_FORM_PAGE_NAME'
,p_item_sequence=>94
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('Nombre de P\00E1gina de Pantalla')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_display_when=>'P4041_TYPE'
,p_display_when2=>'T'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este texto se convierte en el t\00EDtulo, el nombre y el subt\00EDtulo de la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211134470429312635.4001)
,p_name=>'P4039_PAGE_MODE'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina de Pantalla')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  if :P4041_PAGE_MODE <> ''NORMAL'' or not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                                             p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                                             p_application_id    => :FB_FLOW_ID ) then',
'      return true;',
'  else',
'      return false;',
'  end if;',
'end;'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de Di\00E1logo Modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de Di\00E1logo Modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de Cuadro de Di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(220543916551170533.4001)
,p_name=>'P4041_SEARCH_ENABLED'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('B\00FAsqueda Activada')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Indica si debe estar activada una funci\00F3n de b\00FAsqueda en la p\00E1gina Informe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(236471010193137516.4001)
,p_name=>'P4041_PAGE_TITLE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(236522829368417271.4001)
,p_name=>'P4041_PAGE_SUBTITLE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(236525204530474325.4001)
,p_name=>'P4041_WIZARD_TYPE'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348963905903075496.4001)
,p_name=>'P4041_TYPE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_item_default=>'R'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381698223191475161.4001)
,p_name=>'P4041_BREADCRUMB_PARENT_ID'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P4041_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P4041_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P4041_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403535638746981226.4001)
,p_name=>'P4041_GROUP_NAME'
,p_item_sequence=>97
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. '),
unistr('  Los grupos de p\00E1ginas ayudan a los desarrolladores a identificar y gestionar las p\00E1ginas en una aplicaci\00F3n.</p>'),
unistr('<p>Nota: Para crear grupos de p\00E1ginas, vaya a <strong>Utilidades: Grupos de p\00E1ginas</strong> en Utilidades espec\00EDficas de p\00E1gina en la barra lateral derecha.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492836511379343179.4001)
,p_name=>'P4041_REGION_TEMPLATE_IRR_JS'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(137512681636.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(59155819521314850.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P4703_REPORT_PAGE_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940957060681838938.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P4703_REPORT_PAGE_NAME'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(60736312048855253.4001)
,p_computation_sequence=>20
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P4703_TABLE_OWNER'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(60740720705857774.4001)
,p_computation_sequence=>20
,p_computation_item=>'UI_TABLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4703_TABLE_NAME'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165179208932342155.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(236486817513149273.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4041_PAGE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.REPORTWFORM'');'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''CLASSIC_REPORT'' )',
'  or ',
'  wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''INTERACTIVE_REPORT'' ))',
'and :P4041_TYPE = ''R'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(236487209318153098.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4041_PAGE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.FORMNLISTVIEW'');'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''JQM_LIST_VIEW'' )',
'and :P4041_TYPE = ''L'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(268299996606420343.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4041_PAGE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.TABULARFORM'');'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''CLASSIC_REPORT'' )',
'  or ',
'  wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''INTERACTIVE_REPORT'' ))',
'and :P4041_TYPE = ''T'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(236523120957421134.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4041_PAGE_SUBTITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''LIST_VIEW_ATTRIBUTES'');'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''JQM_LIST_VIEW'' )',
'and :P4041_TYPE = ''L'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(236523309958426308.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4041_PAGE_SUBTITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''REPORT_PAGE_ATTRIBUTES'');'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''CLASSIC_REPORT'' )',
'  or ',
'  wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''INTERACTIVE_REPORT'' ))',
'and :P4041_TYPE <> ''L'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(236525529965477738.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4041_WIZARD_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Report'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''CLASSIC_REPORT'' )',
'  or ',
'  wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''INTERACTIVE_REPORT'' ))',
'and :P4041_TYPE <> ''L'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(236525725221480013.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4041_WIZARD_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'List View'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_feature ( ',
'      p_user_interface_id => :P259_USER_INTERFACE_ID,',
'      p_name              => ''JQM_LIST_VIEW'' )',
'and :4041_TYPE = ''L'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(846833228223979744.4001)
,p_computation_sequence=>80
,p_computation_item=>'P4041_PAGE_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_page_dev.get_page_mode(p_application_id => :FB_FLOW_ID, p_page_id => :F4000_P4703_REPORT_PAGE_ID);'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
,p_compute_when=>'F4000_P4703_REPORT_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(140583522268323545.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4041_REGION_TEMPLATE_CLASSIC_JS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'nvl(',
'DEFAULT_REPORTR_TEMPLATE,',
'DEFAULT_REGION_TEMPLATE)',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(492836725231347162.4001)
,p_computation_sequence=>100
,p_computation_item=>'P4041_REGION_TEMPLATE_IRR_JS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(default_irr_template,0) default_irr_template',
'  from wwv_flow_themes ',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and theme_id = :fb_theme_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(115100712622977569.4001)
,p_computation_sequence=>110
,p_computation_item=>'UI_TABLE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id',
'  from wwv_flow_hnt_table_info',
' where schema     = :UI_SCHEMA',
'   and table_name = :UI_TABLE'))
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(61490450896309951.4001)
,p_validation_name=>'page id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4703_REPORT_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(137445627270.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62786011564432373.4001)
,p_validation_name=>'page name not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4703_REPORT_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina de informe.')
,p_associated_item=>wwv_flow_api.id(137562733639.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45075625370444141.4001)
,p_validation_name=>'P4041_PAGE_MODE Not Null'
,p_validation_sequence=>25
,p_validation=>'P4041_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_validation_condition_type=>'NEVER'
,p_when_button_pressed=>wwv_flow_api.id(137519811667.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(116368307440137540.4001)
,p_validation_name=>'F4000_P4703_REPORT_PAGE_ID non numeric'
,p_validation_sequence=>25
,p_validation=>'F4000_P4703_REPORT_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(137519811667.4001)
,p_associated_item=>wwv_flow_api.id(137445627270.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(118184321523451971.4001)
,p_validation_name=>'P4041_BREADCRUMB_NAME'
,p_validation_sequence=>40
,p_validation=>'P4041_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P4041_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(137519811667.4001)
,p_associated_item=>wwv_flow_api.id(117289213716015886.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138659310105557723.4001)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plugs',
' where flow_id                     = :FB_FLOW_ID',
'   and page_id                     = :F4000_P4703_REPORT_PAGE_ID',
'   and menu_id                     is not null',
'   and nvl(:P4041_BREADCRUMB_ID,0) <> 0'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina especificada ya tiene una regi\00F3n de ruta de navegaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(137519811667.4001)
,p_associated_item=>wwv_flow_api.id(117283121382999195.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403536188998982842.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P4041_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4041_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(137519811667.4001)
,p_associated_item=>wwv_flow_api.id(403535638746981226.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(211134833242312639.4001)
,p_validation_name=>'Form page name cannot be null'
,p_validation_sequence=>80
,p_validation=>'F4000_P4703_FORM_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina de pantalla.')
,p_validation_condition=>'P4041_TYPE'
,p_validation_condition2=>'T'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(15129227351412178.4001)
,p_name=>'Region Template Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4041_IMPLEMENTATION'
,p_condition_element=>'P4041_IMPLEMENTATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INTERACTIVE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(15129505086412204.4001)
,p_event_id=>wwv_flow_api.id(15129227351412178.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4703_RPT_TEMPLATE,F4000_P4703_PAGINATION_SIZE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(15129713009412209.4001)
,p_event_id=>wwv_flow_api.id(15129227351412178.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4703_RPT_TEMPLATE,F4000_P4703_PAGINATION_SIZE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(15324526806040053.4001)
,p_event_id=>wwv_flow_api.id(15129227351412178.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4703_RPT_PLUG_TEMPLATE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P4041_REGION_TEMPLATE_IRR_JS'')'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(15324703735042790.4001)
,p_event_id=>wwv_flow_api.id(15129227351412178.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4703_RPT_PLUG_TEMPLATE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P4041_REGION_TEMPLATE_CLASSIC_JS'')'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(384659454420812000.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4041_BREADCRUMB_ID'
,p_condition_element=>'P4041_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384659724092812001.4001)
,p_event_id=>wwv_flow_api.id(384659454420812000.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4041_BREADCRUMB_NAME,P4041_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(384659969713812002.4001)
,p_event_id=>wwv_flow_api.id(384659454420812000.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4041_BREADCRUMB_NAME,P4041_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549172276608876688.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(137513702317.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549172534855876688.4001)
,p_event_id=>wwv_flow_api.id(549172276608876688.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(699340430168482582.4001)
,p_name=>'Page Exists'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :F4000_P4703_REPORT_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(699340710561482584.4001)
,p_event_id=>wwv_flow_api.id(699340430168482582.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4041_PAGE_MODE,P4041_GROUP_NAME,F4000_P4703_REPORT_PAGE_NAME,P4041_BREADCRUMB_ID,P4041_BREADCRUMB_PARENT_ID,P4041_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1940957310997842211.4001)
,p_name=>'set region name'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4703_REPORT_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940958252028842212.4001)
,p_event_id=>wwv_flow_api.id(1940957310997842211.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4703_RPT_PLUG_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P4703_REPORT_PAGE_NAME'
,p_attribute_07=>'F4000_P4703_REPORT_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940957781052842212.4001)
,p_event_id=>wwv_flow_api.id(1940957310997842211.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4041_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P4703_REPORT_PAGE_NAME'
,p_attribute_07=>'F4000_P4703_REPORT_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_04045
begin
wwv_flow_api.create_page(
 p_id=>4045.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Uso de Esquema de Autorizaci\00F3n')
,p_step_title=>unistr('Uso de Esquema de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(302846562287.4001)
,p_plug_name=>'Select Authorization Scheme'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(302908262054.4001)
,p_name=>'Authorization  Scheme Utilization'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_4000_ui.get_auth_scheme_util( ',
'    p_get_all => nvl(:f4000_p4045_ss,''ALL'') = ''ALL'' );',
''))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>3
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_query_num_rows_item=>'P4045_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498625429770416.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Punto'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498712752770416.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48498816499770417.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Descripci\00F3n')
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62168501615011061.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(62154210909909582.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180467215987332900.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_api.id(180462022520306486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188929421292671891.4001)
,p_button_sequence=>25
,p_button_plug_id=>wwv_flow_api.id(302846562287.4001)
,p_button_name=>'P4045_GO'
,p_button_static_id=>'P4045_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(302915279073.4001)
,p_branch_action=>'4045'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(302848583138.4001)
,p_name=>'F4000_P4045_SS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(302846562287.4001)
,p_item_default=>'ALL'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST.SECURITY.SCHEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, to_char(id) id',
'  from wwv_flow_security_schemes',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''MUST_NOT_BE_PUBLIC_USER'' name, ''MUST_NOT_BE_PUBLIC_USER'' id',
'  from sys.dual',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Todos los Esquemas de Autorizaci\00F3n -')
,p_lov_null_value=>'ALL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este componente se presente o se procese.</p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(54653115169971891.4001)
,p_name=>'P4045_ROWS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(302846562287.4001)
,p_item_default=>'20'
,p_prompt=>'Filas'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_api.id(84800803131139158.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifique el n\00FAmero de filas que aparecer\00E1n en el informe.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(54675923546154116.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_04046
begin
wwv_flow_api.create_page(
 p_id=>4046.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Esquemas de Autorizaci\00F3n por P\00E1gina')
,p_step_title=>unistr('Esquemas de Autorizaci\00F3n por P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(62159807886965497.4001)
,p_name=>unistr('P\00E1ginas con Esquemas de Autorizaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id,',
'  a.name,',
'  nvl(decode(instr(required_role,''!''),',
'           1,''{NOT}'',',
'           null)||',
'    sec.name,',
'    required_role) r',
'from ',
'    wwv_flow_steps a, ',
'    wwv_flow_security_schemes sec',
'where replace(required_role,''!'',null) = to_char(sec.id(+))',
'and a.flow_id = :fb_flow_id',
'and required_role is not null ',
'and a.security_group_id = :flow_security_group_id',
''))
,p_display_when_condition=>'P4046_OPT'
,p_display_when_cond2=>'1'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>50
,p_query_no_data_found=>unistr('No se ha encontrado ninguna p\00E1gina con esquemas de autorizaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(62160303032965524.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(62160525519965525.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(62185907867164222.4001)
,p_query_column_id=>3
,p_column_alias=>'R'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Esquema de Autorizaci\00F3n')
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(62163422000988557.4001)
,p_name=>unistr('P\00E1ginas sin Esquemas de Autorizaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT id,name',
'FROM ',
'   wwv_flow_steps',
'WHERE ((wwv_flow_steps.required_role is null and wwv_flow_steps.flow_id = :FB_FLOW_ID))',
'and security_group_id = :flow_security_group_id',
''))
,p_display_when_condition=>'P4046_OPT'
,p_display_when_cond2=>'2'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>50
,p_query_no_data_found=>unistr('No se ha encontrado ninguna p\00E1gina que no tenga esquemas de autorizaci\00F3n.')
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(62163621613988561.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(62163706422988561.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62166416590996453.4001)
,p_name=>'P4046_OPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(62159807886965497.4001)
,p_item_default=>'1'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_04047
begin
wwv_flow_api.create_page(
 p_id=>4047.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('M\00E9todos Abreviados')
,p_step_title=>unistr('M\00E9todos Abreviados')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471994393.4001)
,p_plug_name=>unistr('M\00E9todos Abreviados')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice los accesos directos para escribir una vez el c\00F3digo que se utiliza con frecuencia y hacer referencia a este en muchas ubicaciones de la aplicaci\00F3n. Tambi\00E9n permiten la generaci\00F3n din\00E1mica de c\00F3digo en ubicaciones que habitualmente solo so')
||unistr('portan texto est\00E1tico.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-shortcuts.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184800416391237029.4001)
,p_plug_name=>unistr('M\00E9todos Abreviados')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select shortcut_name, ',
'       shortcut_type, ',
'       sys.dbms_lob.substr(SHORTCUT,512,1) shortcut_text,',
'       id,',
'       ''icon-sc-shortcut'' icon_class,',
'       replace(shortcut_name,''_'','' '') alt,',
'       ''f?p=4000:4048:''||:app_session||''::NO::F4000_P4048_ID:''||ID link,',
'       replace(shortcut_name,''_'','' '') icon_title,',
'       case when reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_shortcuts',
'                         where id                = s.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_shortcuts',
'          where reference_id      = s.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers',
'from   WWV_FLOW_SHORTCUTS s',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(184800502564237029.4001)
,p_name=>'Shortcuts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(184800717912237035.4001)
,p_db_column_name=>'SHORTCUT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4048:&SESSION.::&DEBUG.::F4000_P4048_ID:#ID#'
,p_column_linktext=>'#SHORTCUT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(184800831230237036.4001)
,p_db_column_name=>'SHORTCUT_TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(184800916994237037.4001)
,p_db_column_name=>'SHORTCUT_TEXT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Texto de M\00E9todo Abreviado')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(184801029924237037.4001)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(184804332325260074.4001)
,p_db_column_name=>'ALT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Alternativo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(184804408127260075.4001)
,p_db_column_name=>'LINK'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340561932096198329.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>17
,p_column_identifier=>'K'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562015585198330.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>27
,p_column_identifier=>'L'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656717225906281249.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>37
,p_column_identifier=>'I'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656717581534286878.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>47
,p_column_identifier=>'J'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186549210348731768.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(186543329326722942.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188991005685016539.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(184800416391237029.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.:4047,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115662705243734978.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(184800416391237029.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90872727490393442.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(184800416391237029.4001)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(463978632.4001)
,p_branch_action=>'4048'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(465978634.4001)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(467978638.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4048_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(557923157.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4047'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590011398952897506.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(90872727490393442.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590011452554897507.4001)
,p_event_id=>wwv_flow_api.id(590011398952897506.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590019836054960386.4001)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(115662705243734978.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590020181496960410.4001)
,p_event_id=>wwv_flow_api.id(590019836054960386.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(179421209808554499.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
);
end;
/
prompt --application/pages/page_04048
begin
wwv_flow_api.create_page(
 p_id=>4048.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('M\00E9todos Abreviados')
,p_step_title=>'Editar Acceso Directo'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213468022923563047)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(418978588.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(525681934.4001)
,p_plug_name=>'Origen'
,p_region_name=>'SRC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(530699890.4001)
,p_plug_name=>unistr('M\00E9todos Abreviados')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Los m\00E9todos abreviados constituyen un repositorio de HTML est\00E1tico o din\00E1mico compartido. Son cadenas de sustituci\00F3n que se ampl\00EDan mediante la sintaxis: "SHORTCUT_NAME". Los m\00E9todos abreviados se utilizan en las siguientes ubicaciones:'),
'<ul>',
unistr('<li>Origen de regi\00F3n para las regiones del tipo HTML_WITH_SHORTCUTS</li>'),
unistr('<li>Plantillas de regi\00F3n, cabeceras y pies de p\00E1gina de regi\00F3n</li>'),
'<li>Etiquetas de elementos</li>',
'<li>Valor por defecto de elemento</li>',
'<li>Texto posterior al elemento</li>',
'<li>Texto de ayuda del elemento</li>',
unistr('<li>Cabecera HTML de una p\00E1gina</li>'),
'</ul>'))
,p_plug_query_num_rows=>10
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:R'
,p_plug_query_number_formats=>':::999,999,990'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(544791081.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33428223869359883.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_SHORTCUTS'
,p_attribute_02=>'SHORTCUT_NAME'
,p_attribute_03=>'F4000_P4048_ID'
,p_attribute_04=>'F4000_P4048_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_SHORTCUT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46252909255679001.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(93334400585521646.4001)
,p_plug_name=>unistr('M\00E9todo Abreviado')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167217503879480109.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'CONF'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183169630693815096.4001)
,p_plug_name=>'Sustituciones de Elemento'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La creaci\00F3n de m\00E9todos abreviados en etiquetas de elementos de p\00E1gina y atributos de texto posterior al elemento de elementos de p\00E1gina puede incluir las siguientes cadenas de sustituci\00F3n:'),
'<span class="tiny">',
'<br />#CURRENT_FORM_ELEMENT#',
'<br />#CURRENT_ITEM_ID#',
'<br />#CURRENT_ITEM_NAME#',
'<br />#CURRENT_ITEM_HELP_TEXT#',
'</span>',
''))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615485504460192258.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_SHORTCUTS ',
'where id = :F4000_P4048_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id=> :F4000_P4048_ID,',
'      p_component_type=> ''Shortcuts'',',
'      p_last_updated_by=> c1.last_updated_by,',
'      p_last_updated_on=> c1.last_updated_on,',
'      p_created_by=> c1.created_by,',
'      p_created_on=> c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185103611672100533.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33428223869359883.4001)
,p_button_name=>'COPY_SHORTCUT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Refrescar M\00E9todo Abreviado')
,p_button_position=>'BOTTOM'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_shortcuts',
'',
'where id = :F4000_P4048_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185095622707075273.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33428223869359883.4001)
,p_button_name=>'PUBLISH_SHORTCUT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Publicar M\00E9todo Abreviado')
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4048_ID.,&FLOW_PAGE_ID.,SHORTCUT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_shortcuts',
'',
'where reference_id = :F4000_P4048_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(421978593.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(93334400585521646.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(423978594.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(93334400585521646.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4048_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(425978595.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(93334400585521646.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4048_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(427978595.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(93334400585521646.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4048_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185107516612104106.4001)
,p_branch_action=>'4048'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(185103611672100533.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(411978585.4001)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(413978587.4001)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Delete'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(415978587.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429978599.4001)
,p_name=>'F4000_P4048_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(418978588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435978610.4001)
,p_name=>'F4000_P4048_SHORTCUT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(418978588.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'SHORTCUT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El nombre del m\00E9todo abreviado identifica el m\00E9todo y es el nombre mediante el que se hace referencia al mismo. Para hacer referencia a un m\00E9todo abreviado, utilice la sintaxis "SHORTCUT_NAME" donde se permita un m\00E9todo abreviado. El nombre aparecer\00E1')
||unistr(' en may\00FAsculas autom\00E1ticamente. Todas las referencias a m\00E9todos abreviados deben estar en may\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439978615.4001)
,p_name=>'F4000_P4048_SHORTCUT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(525681934.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML_TEXT'
,p_prompt=>'Tipo'
,p_source=>'SHORTCUT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHORTCUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84752421139794200.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El tipo de m\00E9todo abreviado identifica lo que hay en el texto. Este campo es necesario.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(449978619.4001)
,p_name=>'F4000_P4048_BUILD_OPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(167217503879480109.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'BUILD_OPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451978620.4001)
,p_name=>'F4000_P4048_ERROR_TEXT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(525681934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Error'
,p_source=>'ERROR_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si se produce un error durante el procesamiento de un m\00E9todo abreviado, aparecer\00E1 el siguiente texto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(453978622.4001)
,p_name=>'F4000_P4048_SHORTCUT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(525681934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo Abreviado')
,p_source=>'SHORTCUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Texto del acceso directo. El acceso directo debe tener menos de 30.000 caracteres. El texto se procesa seg\00FAn el tipo de acceso directo.'),
'',
unistr('Las cadenas de sustituci\00F3n de soporte incluyen #PAGE_TITLE# (t\00EDtulo de la p\00E1gina actual), #CURRENT_FORM_ELEMENT# (n\00FAmero del elemento de pantalla HTML actual), #CURRENT_ITEM_ID# (identificador generado del elemento actual), #CURRENT_ITEM_NAME# y #CUR')
||'RENT_ITEM_HELP_TEXT#.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(542789374.4001)
,p_name=>'F4000_P4048_COMMENTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(544791081.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2406579956684625.4001)
,p_name=>'F4000_P4048_SHORTCUT_LANG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(525681934.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P4048_SHORTCUT_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35617601399036187.4001)
,p_name=>'F4000_P4048_REFRESH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(33428223869359883.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_shortcuts',
'',
'where reference_id is null',
'',
'and id = :F4000_P4048_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185065508719001406.4001)
,p_name=>'F4000_P4048_REFERENCE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(33428223869359883.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E9todo Abreviado Maestro de Referencia de')
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_SHORTCUTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_SHORTCUT'')||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(shortcut_name) d, id r',
'from   wwv_flow_shortcuts',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede basar la definici\00F3n de m\00E9todo abreviado en un m\00E9todo abreviado existente en esta explicaci\00F3n o en otro en el esquema de espacios de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35623116914044215.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4048_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185112530833112696.4001)
,p_validation_name=>'F4000_P4048_SHORTCUT_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4048_SHORTCUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(435978610.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-MAR-2002 14:24'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185122511208121784.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4048_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de referencia para refrescar el m\00E9todo abreviado.')
,p_when_button_pressed=>wwv_flow_api.id(185103611672100533.4001)
,p_associated_item=>wwv_flow_api.id(185065508719001406.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185130927586129409.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P4048_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>unistr('Se debe especificar el m\00E9todo abreviado que desea refrescar.')
,p_when_button_pressed=>wwv_flow_api.id(185103611672100533.4001)
,p_associated_item=>wwv_flow_api.id(185065508719001406.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(373231310358857202.4001)
,p_validation_name=>'check pl/sql'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    :F4000_P4048_SHORTCUT,',
'    :FB_FLOW_ID,',
'    :FLOW_SECURITY_GROUP_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4048_SHORTCUT_TYPE = ''FUNCTION_BODY'' and :F4000_P4048_SHORTCUT_LANG = ''PLSQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(425978595.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(455978628.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHORTCUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHORTCUTS'
,p_attribute_03=>'F4000_P4048_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185137100185157284.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh shortcut 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_shortcut (',
'    p_master_shortcut_id         => :F4000_P4048_REFERENCE_ID,',
'    p_subscribing_shortcut_id    => :F4000_P4048_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar el acceso directo.'
,p_process_when_button_id=>wwv_flow_api.id(185103611672100533.4001)
,p_process_when=>'F4000_P4048_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>unistr('M\00E9todo abreviado copiado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(457978630.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHORTCUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHORTCUTS'
,p_attribute_03=>'F4000_P4048_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35628129841053429.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh shortcut 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_shortcut (',
'    p_master_shortcut_id         => :F4000_P4048_REFERENCE_ID,',
'    p_subscribing_shortcut_id    => :F4000_P4048_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar el acceso directo.'
,p_process_when_button_id=>wwv_flow_api.id(425978595.4001)
,p_process_when=>':F4000_P4048_REFERENCE_ID is not null and :F4000_P4048_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('M\00E9todo abreviado copiado.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185140903623170925.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_shortcut_reference_id (:F4000_P4048_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de referencia en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(425978595.4001)
,p_process_when=>'F4000_P4048_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
);
end;
/
prompt --application/pages/page_04050
begin
wwv_flow_api.create_page(
 p_id=>4050.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Detalles de Lista'
,p_step_title=>'Detalles de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1496810553895860.4001)
,p_plug_name=>'Origen: Consulta de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    nvl(list_type,''STATIC'') <> ''STATIC''',
'union',
'select 1 from dual where :F4000_P4050_LIST_ID is null'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7343623237319542.4001)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10642027128440827.4001)
,p_plug_name=>unistr('Origen: Entradas de Lista Est\00E1tica')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select /* APEX 4000P4050a */',
'    list_item_link_text list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,60) list_item_link_target, ',
'    list_item_link_target full_link_target,',
'    parent_list_item_id,',
'    decode(parent_list_item_id,null,null,',
'        (select list_item_link_text ',
'         from wwv_flow_list_items',
'         where id = l.parent_list_item_id)) parent_entry,',
'    required_patch build_option,',
'    LIST_ITEM_DISP_COND_TYPE,',
'    last_updated_on, LIST_ITEM_ICON, list_id,',
'    nvl(translate_list_text_y_n, ''N'') as translate_list_text_y_n,',
'    case ltrim(l.security_scheme,''!'')',
'      when ''MUST_NOT_BE_PUBLIC_USER'' then security_scheme',
'      else',
'        ( select case when l.security_scheme like ''!%'' then ''!'' end || auth.name',
'            from wwv_flow_security_schemes auth',
'           where auth.id                = ltrim(l.security_scheme,''!'')',
'             and auth.security_group_id = l.security_group_id )',
'    end authorization_scheme',
'  from   ',
'    wwv_flow_list_items l',
'  where  ',
'    list_id = replace(:F4000_P4050_LIST_ID,''%''||''null%'',null)',
') select ',
'      (level-1)*25 indent,',
'      list_item_link_text,',
'      id,',
'      parent_entry,',
'      level,',
'      list_item_display_sequence,',
'      list_item_type,    ',
'      list_item_link_target,',
'      parent_list_item_id,',
'      decode(greatest(0,build_option),0,''! '','''')||',
'      (select patch_name from WWV_FLOW_PATCHES where id = abs(build_Option))',
'      build_option,',
'      decode(LIST_ITEM_DISP_COND_TYPE,null,null,''<span class="a-Icon icon-check" role="img" aria-label="''||o.yes||''"></span>'') conditional,',
'      last_updated_on,',
'      LIST_ITEM_ICON,',
'      ''<a href="''||apex_util.prepare_url(''f?p=4000:682:''||:app_session||',
'        ''::::P682_ID:''||id)||''" aria-label="''||wwv_flow_escape.html_attribute(wwv_flow_lang.system_message(''F4000.COPY_LIST_ENTRY_X'', list_item_link_text))||''">''||',
'        ''<span class="a-Icon icon-copy" aria-hidden="true"></span></a>'' copy,',
'      i.authorization_scheme,',
'      i.translate_list_text_y_n',
'from list_items i,',
'    (select wwv_flow_escape.html(wwv_flow_lang.system_message(''COPY_LIST_ENTRY'')) copy_list_entry',
'     from dual) m,',
'    (select wwv_flow_escape.html(wwv_flow_lang.system_message(''CONDITIONAL'')) conditional',
'     from dual) n,',
'    (select wwv_flow_escape.html(wwv_flow_lang.system_message(''F4000.YES'')) yes',
'     from dual) o',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence, list_item_link_text'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    nvl(list_type,''STATIC'') = ''STATIC''',
'union',
'select 1 from dual where :F4000_P4050_LIST_ID is null'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(10642116325440827.4001)
,p_name=>'List Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_display_row_count=>'Y'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642307563440840.4001)
,p_db_column_name=>'INDENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'INDENT'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642602514440846.4001)
,p_db_column_name=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642410369440844.4001)
,p_db_column_name=>'LIST_ITEM_LINK_TEXT'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:4052:F4000_P4052_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#LIST_ITEM_LINK_TEXT#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642515928440846.4001)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>' '
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642705432440846.4001)
,p_db_column_name=>'LIST_ITEM_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Tipo de Elemento de Lista'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642815142440846.4001)
,p_db_column_name=>'LIST_ITEM_LINK_TARGET'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Destino'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10642918115440847.4001)
,p_db_column_name=>'PARENT_LIST_ITEM_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Identificador Principal'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10643314277440847.4001)
,p_db_column_name=>'LIST_ITEM_ICON'
,p_display_order=>8
,p_column_identifier=>'K'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10643107022440847.4001)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Condicional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10643021541440847.4001)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(206353202285953005.4001)
,p_db_column_name=>'TRANSLATE_LIST_TEXT_Y_N'
,p_display_order=>20
,p_column_identifier=>'P'
,p_column_label=>'Atributos traducibles'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10643206900440847.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>30
,p_column_identifier=>'J'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10643405107440847.4001)
,p_db_column_name=>'COPY'
,p_display_order=>40
,p_column_identifier=>'L'
,p_column_label=>'Copiar'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10647829105527648.4001)
,p_db_column_name=>'PARENT_ENTRY'
,p_display_order=>50
,p_column_identifier=>'M'
,p_column_label=>'Entrada Principal'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(10647903775527649.4001)
,p_db_column_name=>'LEVEL'
,p_display_order=>60
,p_column_identifier=>'N'
,p_column_label=>'Nivel'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14046913595627081.4001)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>70
,p_column_identifier=>'O'
,p_column_label=>unistr('Esquema de Autorizaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33434828256111704.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(33430506092105266.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'F4000_P4050_LIST_ID'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188592621192722225.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(62973516530710918.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188598218337740337.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466869405573124318.4001)
,p_plug_name=>'Entradas de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Las listas pueden contener un n\00FAmero indeterminado de entradas de lista. Edite la lista para definir el nombre y la plantilla.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(567419733996994739.4001)
,p_plug_name=>unistr('Origen: Entradas de Lista Est\00E1tica')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select /* APEX 4000P4050a */',
'    list_item_link_text list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,60) list_item_link_target, ',
'    list_item_link_target full_link_target,',
'    parent_list_item_id,',
'    decode(parent_list_item_id,null,null,',
'        (select list_item_link_text ',
'         from wwv_flow_list_items',
'         where id = l.parent_list_item_id)) parent_entry,',
'    required_patch build_option,',
'    LIST_ITEM_DISP_COND_TYPE,',
'    last_updated_on, LIST_ITEM_ICON, list_id,',
'    case ltrim(l.security_scheme,''!'')',
'      when ''MUST_NOT_BE_PUBLIC_USER'' then security_scheme',
'      else',
'        ( select case when l.security_scheme like ''!%'' then ''!'' end || auth.name',
'            from wwv_flow_security_schemes auth',
'           where auth.id                = ltrim(l.security_scheme,''!'')',
'             and auth.security_group_id = l.security_group_id )',
'    end authorization_scheme',
'  from   ',
'    wwv_flow_list_items l',
'  where  ',
'    list_id = replace(:F4000_P4050_LIST_ID,''%''||''null%'',null)',
') select ',
'      (level-1)*25 indent,',
'      list_item_link_text,',
'      id,',
'      parent_entry,',
'      level,',
'      list_item_display_sequence,',
'      list_item_type,    ',
'      list_item_link_target,',
'      parent_list_item_id,',
'      decode(greatest(0,build_option),0,''! '','''')||',
'      (select patch_name from WWV_FLOW_PATCHES where id = abs(build_Option))',
'      build_option,',
'      decode(LIST_ITEM_DISP_COND_TYPE,null,null,''<span class="a-Icon icon-check"></span>'') conditional,',
'      last_updated_on,',
'      LIST_ITEM_ICON,',
'      ''<a href="''||apex_util.prepare_url(''f?p=4000:682:''||:app_session||',
'        ''::::P682_ID:''||id)||''">''||',
'        ''<img src="#IMAGE_PREFIX#f_spacer.gif" ''||',
'        ''border="0" height="1" width="1" title="''||',
'        m.copy_list_entry||',
'        ''" alt="''||m.copy_list_entry||''" class="iconSmall copy"></a>'' copy,',
'      i.authorization_scheme',
'from list_items i,',
'    (select wwv_flow_escape.html(wwv_flow_lang.system_message(''COPY_LIST_ENTRY'')) copy_list_entry',
'     from dual) m,',
'    (select wwv_flow_escape.html(wwv_flow_lang.system_message(''CONDITIONAL'')) conditional',
'     from dual) n',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id '))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'F4000_P4050_LIST_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567419961522994741.4001)
,p_name=>'INDENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'INDENT'
,p_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420035017994742.4001)
,p_name=>'LIST_ITEM_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_LINK_TEXT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Nombre'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420121598994743.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420277094994744.4001)
,p_name=>'PARENT_ENTRY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARENT_ENTRY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Entrada Principal'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420347264994745.4001)
,p_name=>'LEVEL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LEVEL'
,p_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Nivel'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420415193994746.4001)
,p_name=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Secuencia'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>50
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420542502994747.4001)
,p_name=>'LIST_ITEM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Tipo de Elemento de Lista'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420641723994748.4001)
,p_name=>'LIST_ITEM_LINK_TARGET'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_LINK_TARGET'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Destino'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>240
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420745320994749.4001)
,p_name=>'PARENT_LIST_ITEM_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARENT_LIST_ITEM_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>100
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567420888240994750.4001)
,p_name=>'BUILD_OPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BUILD_OPTION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>110
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757093933013899201.4001)
,p_name=>'CONDITIONAL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITIONAL'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Condicional'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757094067063899202.4001)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Actualizado'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>130
,p_value_alignment=>'CENTER'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757094153462899203.4001)
,p_name=>'LIST_ITEM_ICON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_ICON'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>150
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757094240030899204.4001)
,p_name=>'COPY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COPY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Copiar'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'HTML'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757094355062899205.4001)
,p_name=>'AUTHORIZATION_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'AUTHORIZATION_SCHEME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Autorizaci\00F3n')
,p_heading_alignment=>'CENTER'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757094456624899206.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_label=>'Acciones'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>20
,p_value_alignment=>'CENTER'
,p_enable_hide=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(757094509738899207.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_enable_hide=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(567419848617994740.4001)
,p_internal_uid=>567419848617994740
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_max_row_count=>100000
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:ACTIONS_MENU:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164653227365265461.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(188598218337740337.4001)
,p_button_name=>'grid_view'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Edici\00F3n de Cuadr\00EDculas')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.::F4000_P145_LIST_ID:&F4000_P4050_LIST_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    nvl(list_type,''STATIC'') = ''STATIC'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(46780420950057077.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(188598218337740337.4001)
,p_button_name=>'EDIT_LIST'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Editar Lista'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4051:&SESSION.::&DEBUG.:RP:F4000_P4051_ID,F4000_LAST_VIEW:&F4000_P4050_LIST_ID.,4050'
,p_button_condition=>'F4000_P4050_LIST_ID'
,p_button_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10001417059466535.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(188598218337740337.4001)
,p_button_name=>'CREATE_LIST_ITEM'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Entrada'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:4052::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    nvl(list_type,''STATIC'') = ''STATIC'''))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1499003515035673.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(188598218337740337.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_lists',
'where  id = :F4000_P4050_LIST_ID ',
'and    nvl(list_type,''STATIC'') <> ''STATIC'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(757094701911899209.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(188598218337740337.4001)
,p_button_name=>'ApplyChanges_Static'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(448041105.4001)
,p_branch_action=>'4052'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(419962916.4001)
,p_branch_action=>'4050'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(423984514.4001)
,p_name=>'F4000_P4050_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(188598218337740337.4001)
,p_item_default=>'0'
,p_prompt=>'Lista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'  from wwv_flow_lists',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Lista -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la lista que desea editar. La lista aparecer\00E1 autom\00E1ticamente. Debe crear o seleccionar una lista para poder agregar elementos de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1497810694980982.4001)
,p_name=>'P4050_LIST_QUERY'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1496810553895860.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select list_query from wwv_flow_lists',
'where id = :F4000_P4050_LIST_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cMaxlength=>32767
,p_cHeight=>14
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una consulta SQL de lista o una funci\00F3n que devuelva una consulta SQL para generar una lista din\00E1mica.</p>'),
'<strong>Sintaxis de Consulta SQL:</strong>',
'<pre>',
'select level, labelValue label, ',
'       [targetValue]            target, ',
'       [is_current]             is_current_list_entry,',
'       [imageValue]             image, ',
'       [imageAttributeValue]    image_attribute,',
'       [imageAltValue]          image_alt_attribute,',
'       [attribute1]             attribute1,',
'       [attribute2]             attribute2,',
'       [attribute3]             attribute3,',
'       [attribute4]             attribute4,',
'       [attribute5]             attribute5,',
'       [attribute6]             attribute6,',
'       [attribute7]             attribute7,',
'       [attribute8]             attribute8,',
'       [attribute9]             attribute9,',
'       [attribute10]            attribute10',
'from ...',
'where ...',
'order by ...',
'</pre>',
'',
unistr('<strong>Funci\00F3n que Devuelve una Sintaxis de Consulta SQL:</strong>'),
'<pre>',
'RETURN',
'''select level, labelValue label,''||',
'''       [targetValue]         target,''|| ',
'''       [is_current]          is_current_list_entry,''||',
'''       [imageValue]          image,''||',
'''       [imageAttributeValue] image_attribute, ''||',
'''       [imageAltValue]       image_alt_attribute,''||',
'''       [attribute1]          attribute1,''||',
'''       [attribute2]          attribute2,''||',
'''       [attribute3]          attribute3,''||',
'''       [attribute4]          attribute4,''||',
'''       [attribute5]          attribute5,''||',
'''       [attribute6]          attribute6,''||',
'''       [attribute7]          attribute7,''||',
'''       [attribute8]          attribute8,''||',
'''       [attribute9]          attribute9,''||',
'''       [attribute10]         attribute10''||',
'''from ...''||',
'''where ...''||',
'''order by ...'';',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4050_EDITOR_MODE'
,p_item_comment=>'nvl(v(''P464_QUERY''),''x'') != ''.'''
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10697604668749425.4001)
,p_name=>'P4050_QUERY_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1496810553895860.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'SQL_QUERY'
,p_prompt=>'Consultar Tipo de Origen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select list_type from wwv_flow_lists',
' where id = :F4000_P4050_LIST_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLASH_CHART_QUERY_TYPE'
,p_lov=>'.'||wwv_flow_api.id(6026412205740110.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el tipo de origen de consulta.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(78408500074861201.4001)
,p_name=>'P4050_EDITOR_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1496810553895860.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'case when :P4050_QUERY_TYPE = ''SQL_QUERY'' then ''SQL'' else ''PLSQL_FUNCTION_BODY'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(149045113458990015.4001)
,p_name=>'P4050_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(7343623237319542.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(167582505770236737.4001)
,p_name=>'P4050_LIST_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(7343623237319542.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(replace(name,''_'','' ''),''.'','' '') name ',
'  from wwv_flow_lists ',
' where id = :F4000_P4050_LIST_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(115523130383306993.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4050'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(420962917.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4051_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(450041106.4001)
,p_computation_sequence=>30
,p_computation_item=>'F4000_P4052_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1499725725070526.4001)
,p_validation_name=>'is_valid_list_query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.is_valid_list_query(',
'    p_query      => :P4050_LIST_QUERY,',
'    p_query_type => :P4050_QUERY_TYPE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'F4000_P4050_LIST_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(1499003515035673.4001)
,p_associated_item=>wwv_flow_api.id(1497810694980982.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590034104321112145.4001)
,p_name=>'Edit List - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(46780420950057077.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590034427665112145.4001)
,p_event_id=>wwv_flow_api.id(590034104321112145.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(78408616580861202.4001)
,p_name=>'On P4050_QUERY_TYPE Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4050_QUERY_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(78408738623861203.4001)
,p_event_id=>wwv_flow_api.id(78408616580861202.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4050_EDITOR_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P4050_QUERY_TYPE'').getValue() === ''SQL_QUERY'' ? ''SQL'' : ''PLSQL_FUNCTION_BODY'''
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1500204516083343.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LISTS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from dual',
'            where :F4000_P4050_LIST_ID is null',
'            or exists (select 1 from wwv_flow_lists',
'                        where security_group_id = :flow_security_group_id ',
'                          and flow_id = :FB_FLOW_ID',
'                       and id = :F4000_P4050_LIST_ID))',
'loop',
'/*    wwv_flow_dml.process(',
'           p_action      => replace(wwv_flow.g_request,''CREATE_STATIC'',''CREATE''),',
'           p_table_owner => ''#OWNER#'',',
'           p_table_name  => ''WWV_FLOW_LISTS'',',
'           p_rowid       => v(''P84_LIST_ID''),',
'           p_alt_rowid   => ''ID''); */',
'',
'    update wwv_flow_lists',
'       set list_query = v(''P4050_LIST_QUERY''),',
'           list_type  = v(''P4050_QUERY_TYPE'')',
'     where id = v(''F4000_P4050_LIST_ID'');',
'',
'    exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when_button_id=>wwv_flow_api.id(1499003515035673.4001)
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(757094688276899208.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(567419733996994739.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Source: Static List Entries - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(757094701911899209.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(149048410519026991.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CheckIfChangedFlow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4050_FLOW_ID is not null',
'   then :F4000_P4050_LIST_ID := ''0'';',
'end if;',
':P4050_FLOW_ID := :FB_FLOW_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'nvl(:P4050_FLOW_ID,''-1'') != nvl(:FB_FLOW_ID,''-1'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_04051
begin
wwv_flow_api.create_page(
 p_id=>4051.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar: Lista'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear/Editar: Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(405962901.4001)
,p_plug_name=>'Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Una lista es una recopilaci\00F3n compartida de enlaces y cada enlace se denomina entrada de lista. Puede controlar el aspecto de una lista mediante plantillas de lista. La lista se agrega a la p\00E1gina creando una regi\00F3n de lista. Al suprimir una lista se')
||unistr(' eliminar\00E1n las regiones de referencia.<br /><br />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(263554303056480689.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(406962903.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(263554303056480689.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(408962904.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(263554303056480689.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'v(''F4000_P4051_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(409962904.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(263554303056480689.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'v(''F4000_P4051_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(407962904.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(263554303056480689.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4051_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(410962907.4001)
,p_name=>'F4000_P4051_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(405962901.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(411962908.4001)
,p_name=>'F4000_P4051_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(405962901.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(412962908.4001)
,p_name=>'F4000_P4051_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(405962901.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Introduzca un nombre para la lista que est\00E1 creando. Se permiten los nombres de lista con caracteres num\00E9ricos y alfanum\00E9ricos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31570844258.4001)
,p_name=>'F4000_P4051_LIST_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(405962901.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'PUBLIC'
,p_prompt=>'Status'
,p_source=>'LIST_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31571860834.4001)
,p_name=>'F4000_P4051_LIST_DISPLAYED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(405962901.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_DEFAULT'
,p_prompt=>'Displayed'
,p_source=>'LIST_DISPLAYED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'can we remove this?'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32341246561.4001)
,p_name=>'F4000_P4051_REQUIRED_PATCH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(405962901.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10712018169711111.4001)
,p_validation_name=>'F4000_P4051_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4051_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(412962908.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-MAY-2002 16:30'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10712319854711118.4001)
,p_validation_name=>'F4000_P4051_FLOW_ID Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4051_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(411962908.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-MAY-2002 16:30'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63028048345309923.4001)
,p_validation_name=>'Current Navigation Menu List'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_user_interfaces',
'where navigation_list_id = :F4000_P4051_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Las listas del men\00FA de navegaci\00F3n no se pueden suprimir si se les hace referencia en los atributos de interfaz de usuario.')
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_when_button_pressed=>wwv_flow_api.id(407962904.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2702210161095220.4001)
,p_validation_name=>'Used Navigation Menu List'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps s',
' where s.navigation_list_id = :F4000_P4051_ID',
'   and s.flow_id = :fb_flow_id',
'   and s.security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Las listas del men\00FA de navegaci\00F3n no se pueden suprimir si se les hace referencia en las p\00E1ginas de aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(407962904.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(63028108989309924.4001)
,p_validation_name=>'Current Navigation Bar List'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_user_interfaces',
'where nav_bar_list_id = :F4000_P4051_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Las listas de la barra de navegaci\00F3n no se pueden suprimir si se les hace referencia en los atributos de interfaz de usuario.')
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_when_button_pressed=>wwv_flow_api.id(407962904.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(574039420756616925.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(406962903.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(574039528966616926.4001)
,p_event_id=>wwv_flow_api.id(574039420756616925.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(413962912.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_LISTS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_lists',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4051_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_LISTS'',',
'  p_rowid       => v(''F4000_P4051_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(167848003708478278.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from WWV_FLOW_PAGE_PLUGS',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :fb_flow_id',
'   and list_id           = :F4000_P4051_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido realizar la supresi\00F3n en cascada de la lista para las regiones correspondientes.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(407962904.4001)
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Regiones de referencia eliminadas.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(414962913.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LISTS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4051_ID is null',
'or exists (select 1 from wwv_flow_lists',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4051_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LISTS'',',
'p_rowid       => v(''F4000_P4051_ID''),',
'p_return_item1_name => ''F4000_P4050_LIST_ID'',',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la lista.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Lista procesada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(83542926653500950.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear cache for F4000_P4050_LIST_ID'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4000_P4050_LIST_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(407962904.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(574039694277616927.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Create,Delete,ApplyChanges'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04052
begin
wwv_flow_api.create_page(
 p_id=>4052.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar: Entrada de Lista'
,p_step_title=>'Crear/Editar: Entrada de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(430041099.4001)
,p_plug_name=>'Entrada'
,p_region_name=>'E'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 17-FEB-2000 00:12:44'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(53980942183.4001)
,p_plug_name=>'Atributos Definidos por el Usuario'
,p_region_name=>'ATT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n #A01# - #A10# son atributos opcionales de una plantilla de lista, que se pueden utilizar para hacer referencia a atributos definidos por el usuario de las entradas de lista 1 - 10, respectivamente. Haga clic en <strong>Atri')
||unistr('butos de Plantilla de Lista</strong> para ver una descripci\00F3n m\00E1s significativa de las cadenas de sustituci\00F3n que se utilizan en las plantillas de lista disponibles en la aplicaci\00F3n actual.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62089494403.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117870675835.4001)
,p_plug_name=>'Entrada de Lista Actual'
,p_region_name=>'CUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3927618305147337.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6318908261115812.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(6276618987043262.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'v(''F4000_P4052_ID'') is not null'
,p_plug_display_when_cond2=>'SQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11914530632270079.4001)
,p_plug_name=>'Destino'
,p_region_name=>'TEX'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46254030791679003.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91214122594391523.4001)
,p_plug_name=>'Entrada de Lista'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(121190512604224652.4001)
,p_plug_name=>'Recuento de Clics'
,p_region_name=>'CLI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145764027504126720.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_name=>'AUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(149873601043426764.4001)
,p_name=>'Entradas de Lista'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select ',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    parent_list_item_id',
'  from   wwv_flow_list_items',
'  where  list_id = replace(:F4000_P4050_LIST_ID,''%''||''null%'',null)',
') ',
'  select',
'    substr(''......................................'',0,(level-1)*3) indent,',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    parent_list_item_id',
'from list_items',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence, list_item_link_text'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha definido ninguna entrada de lista'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(149873900034426778.4001)
,p_query_column_id=>1
,p_column_alias=>'INDENT'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(149874016710426779.4001)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#LIST_ITEM_DISPLAY_SEQUENCE##INDENT##LIST_ITEM_LINK_TEXT#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(149874130758426779.4001)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(149874214013426779.4001)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(149874321856426780.4001)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(149874424822426780.4001)
,p_query_column_id=>6
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(173343408947359829.4001)
,p_name=>unistr('Elementos de P\00E1gina')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.name item_name',
'from wwv_flow_step_items i,',
'     wwv_flow_page_plugs r',
'where i.flow_id = :fb_flow_id and',
'      i.flow_step_id = :fb_flow_page_id and',
'      i.security_group_id = :flow_security_group_id and',
'      i.item_plug_id(+) = r.id',
'order by r.plug_name, i.ITEM_SEQUENCE, i.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento de p\00E1gina.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(173343611809359833.4001)
,p_query_column_id=>1
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466869601203132495.4001)
,p_plug_name=>'Entrada de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Defina la entrada de lista. Cada una de ellas suele estar compuesta por un enlace a una p\00E1gina de esta aplicaci\00F3n o una URL.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615280628695471882.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LIST_ITEMS',
'where id = :F4000_P4052_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4052_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(925159348439646118.4001)
,p_plug_name=>'Recursos de desarrolladores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>132
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(26512283167477231.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(212143516770567204.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_button_name=>'VIEW_UTILIZATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ver uso de lista'
,p_button_redirect_url=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:RP,RIR:IR_LIST_ID,F4000_LAST_VIEW:&F4000_P4052_LIST_ID.,4052'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1500322967122760213.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_button_name=>'LIST_TEMP_ATTRIBUTES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Atributos de Plantilla de Lista'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:RP:P50_LIST_ID,P50_LIST_TEMPLATE_ID:&F4000_P4052_LIST_ID.,'
,p_icon_css_classes=>'i icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75363617837907452.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75363526977907452.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(431041099.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(432041100.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4052_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(433041100.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4052_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(464203883.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'CreateAgain'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4052_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30361126085886687.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Entrada de Lista'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4052_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75373303591907501.4001)
,p_branch_action=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.::F4000_P4052_ID:&P4052_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(75363526977907452.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75373611266907503.4001)
,p_branch_action=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.::F4000_P4052_ID:&P4052_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(75363617837907452.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75382726163973412.4001)
,p_branch_action=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4052_RETURN_TO_PAGE = ''1'' and upper(:REQUEST) != ''DELETE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(54187577144.4001)
,p_branch_action=>'4052'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CreateAgain'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(50153016595557639.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435041100.4001)
,p_name=>'F4000_P4052_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(436041100.4001)
,p_name=>'F4000_P4052_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4050_LIST_ID.'
,p_prompt=>'Lista:'
,p_source=>'LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LISTS'
,p_lov=>'select wwv_flow_escape.html(name) d, id from wwv_flow_lists where flow_id = :FB_FLOW_ID order by upper(name)'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione una lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(437041101.4001)
,p_name=>'F4000_P4052_LIST_ITEM_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'LINK'
,p_prompt=>'Entry Type'
,p_source=>'LIST_ITEM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(440041101.4001)
,p_name=>'F4000_P4052_LIST_ITEM_LINK_TEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta de Entrada de Lista'
,p_source=>'LIST_ITEM_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique el texto del enlace. La visualizaci\00F3n de este texto de enlace est\00E1 controlada por plantillas de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(441041102.4001)
,p_name=>'F4000_P4052_LIST_ITEM_LINK_TARGET'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL Target ( <a class="itemlink" href="javascript:setValue(''F4000_P4052_LIST_ITEM_LINK_TARGET'',''f?p=&FB_FLOW_ID.:&FB_FLOW_PAGE_ID.:&amp;SESSION.'');">f?p=&FB_FLOW_ID.:&FB_FLOW_PAGE_ID.:&amp;SESSION.</a> )'
,p_source=>'LIST_ITEM_LINK_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(442041104.4001)
,p_name=>'F4000_P4052_LIST_ITEM_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen/Clase'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:654:&SESSION.::::P654_RETURN_ITEM:F4000_P4052_LIST_ITEM_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>',
''))
,p_source=>'LIST_ITEM_ICON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifique un nombre de archivo de imagen o la clase de icono del icono asociado a esta entrada de lista.',
'<br><br>',
'<strong>Uso de Tema universal</strong>',
'<br>',
unistr('La mayor\00EDa de las aplicaciones de Tema universal utilizan la biblioteca de iconos de fuente APEX. Para seleccionar un icono, utilice el selector de iconos incorporado y seleccione un icono de la ventana emergente. Consulte los ejemplos a continuaci\00F3n')
||':<br><br>',
'<ul>',
'    <li><code>fa-cloud</code>: muestra el icono de la nube</li>',
unistr('    <li><code>fa-exclamation-circle u-danger-text</code>: muestra un icono de una exclamaci\00F3n roja</li>'),
'</ul>',
'<br>',
unistr('Puede consultar otros ejemplos en la p\00E1gina <a rel="noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Iconos</a> de la <a rel="noreferrer" href="https://apex.oracle.com/ut" target="_blank">aplicaci\00F3n de ejemplo de Tema universal</a>')
||'.',
'',
'<br><br>',
'<strong>Uso de un tema personalizado o heredado</strong>',
'<br>',
unistr('Tambi\00E9n puede introducir la ruta de acceso de imagen completa si el tema de aplicaci\00F3n no utiliza una biblioteca de iconos.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(463184292.4001)
,p_name=>'F4000_P4052_LIST_ITEM_DISPLAY_SEQUENCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   s number;',
'begin',
'   select max(LIST_ITEM_DISPLAY_SEQUENCE) into s',
'   from   WWV_FLOW_LIST_ITEMS ',
'   where  LIST_ID = v(''F4000_P4052_LIST_ID'');',
'   s := nvl(s,0);',
'   s := trunc(s) + 10;',
'   return s;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Secuencia'
,p_source=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32343314046.4001)
,p_name=>'F4000_P4052_REQUIRED_PATCH'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(3927618305147337.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Seleccione una opci\00F3n de creaci\00F3n para este componente.</div>'),
unistr('<div class="htmldbInfoBodyP">Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32370803678.4001)
,p_name=>'F4000_P4052_LIST_ITEM_ICON_ATTRIBUTES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos'
,p_source=>'LIST_ITEM_ICON_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct LIST_ITEM_ICON_ATTRIBUTES d, LIST_ITEM_ICON_ATTRIBUTES r',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifique los atributos de imagen (como width="12" height="12") para la imagen del elemento de lista.',
'<p />',
unistr('Utilice la cadena de sustituci\00F3n #LIST_LABEL# para hacer referencia al texto de la etiqueta de lista. Esta cadena de sustituci\00F3n permite definir autom\00E1ticamente el atributo de imagen del t\00EDtulo seg\00FAn el valor del texto de la etiqueta de lista. Por ej')
||'emplo: ',
'<pre>...title="#LIST_LABEL#"...</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46356878453.4001)
,p_name=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(117870675835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Entrada de Lista Actual para Condici\00F3n')
,p_source=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">En funci\00F3n de la selecci\00F3n anterior, defina una condici\00F3n para evaluarla. Cuando esta condici\00F3n es verdadera, el elemento de lista es actual.'),
'</div>',
unistr('<div class="htmldbInfoBodyP">Los elementos actuales utilizan la plantilla actual. Los elementos no actuales utilizan la plantilla no actual. Si la condici\00F3n identificada aqu\00ED es verdadera, el elemento es actual. Puede hacer que un elemento de la list')
||unistr('a utilice la plantilla actual que proporcionar\00E1 a los usuarios una indicaci\00F3n visual de que el elemento de la lista actual est\00E1 "seleccionado" o es de alg\00FAn modo "actual".</div>'),
unistr('<div class="htmldbInfoBodyP">Utilice comas para separar varias p\00E1ginas, si hay varias p\00E1ginas actuales para este elemento de lista. Por ejemplo:</div>'),
'<pre>',
'5,6,12,15',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53981946409.4001)
,p_name=>'F4000_P4052_LIST_TEXT_01'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1.'
,p_source=>'LIST_TEXT_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53982987938.4001)
,p_name=>'F4000_P4052_LIST_TEXT_02'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2.'
,p_source=>'LIST_TEXT_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53983988598.4001)
,p_name=>'F4000_P4052_LIST_TEXT_03'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3.'
,p_source=>'LIST_TEXT_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53984989492.4001)
,p_name=>'F4000_P4052_LIST_TEXT_04'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4.'
,p_source=>'LIST_TEXT_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53985990198.4001)
,p_name=>'F4000_P4052_LIST_TEXT_05'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5.'
,p_source=>'LIST_TEXT_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53986990876.4001)
,p_name=>'F4000_P4052_LIST_TEXT_06'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'6.'
,p_source=>'LIST_TEXT_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53987991555.4001)
,p_name=>'F4000_P4052_LIST_TEXT_07'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'7.'
,p_source=>'LIST_TEXT_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53988992499.4001)
,p_name=>'F4000_P4052_LIST_TEXT_08'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'8.'
,p_source=>'LIST_TEXT_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53989994310.4001)
,p_name=>'F4000_P4052_LIST_TEXT_09'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'9.'
,p_source=>'LIST_TEXT_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53990995131.4001)
,p_name=>'F4000_P4052_LIST_TEXT_10'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'10.'
,p_source=>'LIST_TEXT_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributos adicionales a los que se puede acceder a trav\00E9s de la plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62087474089.4001)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_COND_TYPE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(62089494403.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'LIST_ITEM_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n Especificada -')
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Seleccione un tipo de condici\00F3n de la lista que se debe cumplir para presentar este componente como procesado.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4052_LIST_ITEM_DISP_CONDITION'
,p_attribute_02=>'F4000_P4052_LIST_ITEM_DISP_CONDITION2'
,p_attribute_04=>'F4000_P4052_LIST_ITEM_DISP_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4052_LIST_ITEM_DISP_COND_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62088475548.4001)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_CONDITION'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(62089494403.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'LIST_ITEM_DISP_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especi')
||'ficada, se presenta o procesa el componente.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(85177002763.4001)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_CONDITION2'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(62089494403.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'LIST_ITEM_DISP_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117862616204.4001)
,p_name=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(117870675835.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TARGET_PAGE'
,p_prompt=>unistr('Entrada de Lista Actual para Tipo de P\00E1ginas')
,p_source=>'LIST_ITEM_CURRENT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM_CURRENT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84729824360877320.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Especifique cu\00E1ndo esta entrada de lista debe ser actual en funci\00F3n del tipo de p\00E1gina.</div>'),
unistr('<div class="htmldbInfoBodyP">Los elementos de lista pueden ser actuales o no actuales. Los elementos de lista actuales utilizan la plantilla actual, los elementos de lista no actuales utilizan la plantilla de elemento de lista no actual. La condici\00F3n')
||' y las plantillas reales se definen en atributos posteriores.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293178618453.4001)
,p_name=>'F4000_P4052_SECURITY_SCHEME'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(145764027504126720.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este componente se presente o se procese.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(919320760230919.4001)
,p_name=>'P4052_PARENT_LIST_ITEM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Entrada de Lista Principal'
,p_source=>'PARENT_LIST_ITEM_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_item_link_text) d, id from (',
'select lpad('' '',4*(level-1),''.'')|| list_item_link_text list_item_link_text, id',
'from ( ',
'  select id, parent_list_item_id, list_item_display_sequence, list_item_link_text',
'  from wwv_flow_list_items i',
'  where flow_id = :FB_FLOW_ID',
'  and list_id = :F4000_P4052_LIST_ID',
'  and id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :F4000_P4052_LIST_ID',
'    start with id = :F4000_P4052_ID ',
'    connect by prior id = parent_list_item_id',
'  ))',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence',
')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Elemento de Lista Principal -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :F4000_P4052_LIST_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el elemento principal para esta entrada de lista. Utilice este atributo si est\00E1 creando una lista jer\00E1rquica.'),
unistr('<p>Para crear una lista jer\00E1rquica, debe seleccionar una plantilla de lista que soporte las listas jer\00E1rquicas. Para determinar qu\00E9 plantillas de lista soportan las listas jer\00E1rquicas, busque plantillas que utilicen la regla de nomenclatura "con Subl')
||unistr('ista". Para obtener m\00E1s informaci\00F3n sobre la visualizaci\00F3n de elementos de listas jer\00E1rquicas, consulte la ayuda de elementos de plantillas de lista.')))
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2318341207209529.4001)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_COND_LANG'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(62089494403.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2319038303209536.4001)
,p_name=>'F4000_P4052_LIST_ITEM_CURRENT_LANG'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(117870675835.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'LIST_ITEM_CURRENT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14498429652085716.4001)
,p_name=>'P4052_LIST_ITEM_ICON_ALT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributo Alternativo'
,p_source=>'LIST_ITEM_ICON_ALT_ATTRIBUTE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifique el atributo alt para la imagen del elemento de lista.',
'<p />',
unistr('Utilice la cadena de sustituci\00F3n #LIST_LABEL# para hacer referencia al texto de la etiqueta de lista. Esta cadena de sustituci\00F3n permite definir autom\00E1ticamente el atributo alt de la imagen seg\00FAn el valor del texto de la etiqueta de lista. Por ejempl')
||'o: ',
'<pre>...alt="#LIST_LABEL#"...</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17439931431603834.4001)
,p_name=>'P4052_URL_TARGET'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_prompt=>'Destino de URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un destino de URL para esta entrada de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17445520536714188.4001)
,p_name=>'P4052_PAGE_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el n\00FAmero de p\00E1gina. Active la casilla que hay junto al n\00FAmero de p\00E1gina si desea restablecer la paginaci\00F3n para esa p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17446401751727725.4001)
,p_name=>'P4052_REQUEST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto en el que desea definir el elemento de aplicaci\00F3n incorporado REQUEST. \00C9ste es tambi\00E9n el elemento definido con el nombre de un bot\00F3n en el que se ha hecho clic.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17448018636751567.4001)
,p_name=>'P4052_CLEAR_CACHE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_prompt=>unistr('Borrar Cach\00E9')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca los n\00FAmeros de p\00E1gina, separados por comas, para los que desea que se limpie el estado de la sesi\00F3n del usuario. Por ejemplo:'),
'<p />',
'10,11,12',
'<p />',
unistr('Tambi\00E9n puede restablecer una recopilaci\00F3n incluyendo un nombre de recopilaci\00F3n.  '),
'<p />',
unistr('Para restablecer la paginaci\00F3n de todos los informes en la p\00E1gina de destino, puede introducir las letras "RP".')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17448608032757919.4001)
,p_name=>'P4052_ARG_NAMES'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_prompt=>'Defina estos elementos'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la lista de nombres de elementos de aplicaci\00F3n, separados por una coma, para los que desea definir el estado de la sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17449222576762100.4001)
,p_name=>'P4052_ARG_VALUES'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_prompt=>'Con estos valores'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una lista de valores delimitada por comas para los elementos especificados en <span class="fielddatabold">Defina estos elementos</span>. Puede especificar valores est\00E1ticos o sintaxis de sustituci\00F3n (por ejemplo, &amp;APP_ITEM_NAME.). '),
'<pre>&amp;APP_ITEM_NAME.</pre>',
unistr('<div class="htmldbInfoBodyP">Los valores de los elementos que se transfieren a <span class="fielddatabold">f?p=</span> en la direcci\00F3n URL nunca pueden contener un signo de dos puntos (:). Los valores de los elementos tampoco pueden contener comas a ')
||'menos que incluya todo el valor entre caracteres de barra invertida. Por ejemplo:</div>',
'<pre>\1234,56\</pre>',
unistr('<div class="htmldbInfoBodyP">Esto resulta \00FAtil cuando hay que transferir valores decimales donde el car\00E1cter separador de decimales de NLS es una coma.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17851616965567403.4001)
,p_name=>'P4052_URL_OR_FLOW'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_item_default=>'FLOW'
,p_prompt=>'tipo de objetivo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_api.id(84796030957080920.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Destino -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de objetivo. El destino es una p\00E1gina de la aplicaci\00F3n actual o cualquier direcci\00F3n URL v\00E1lida. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17891605592018345.4001)
,p_name=>'P4052_CLEAR_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para restablecer la paginaci\00F3n a la que est\00E1 enlazada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36306628512525530.4001)
,p_name=>'P4052_LIST_ITEM_STATUS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'PUBLIC'
,p_prompt=>'Sequence'
,p_source=>'LIST_ITEM_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(36308222410533252.4001)
,p_name=>'P4052_ITEM_DISPLAYED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(430041099.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_DEFAULT'
,p_prompt=>'ITEM_DISPLAYED'
,p_source=>'ITEM_DISPLAYED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40799027386265055.4001)
,p_name=>'P4052_N'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_prompt=>'Name:'
,p_source=>'select substr(LIST_ITEM_LINK_TEXT,1,50) n from WWV_FLOW_LIST_ITEMS where id = :F4000_P4052_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(57731626458856526.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la entrada de lista'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75371127504907483.4001)
,p_name=>'P4052_ID_NEXT'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_prompt=>'P4052_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75371520005907484.4001)
,p_name=>'P4052_ID_PREV'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_prompt=>'P4052_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75371929675907487.4001)
,p_name=>'P4052_ID_COUNT'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_prompt=>'List Entry: '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(57731626458856526.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Edite la entrada de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75382021184962574.4001)
,p_name=>'P4052_RETURN_TO_PAGE'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_api.id(91214122594391523.4001)
,p_prompt=>'Return To Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'F4000_P4052_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121186724909203707.4001)
,p_name=>'F4000_P4052_LIST_COUNTCLICKS_Y_N'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(121190512604224652.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Contar Clics'
,p_source=>'LIST_COUNTCLICKS_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.RETURNS.Y'
,p_lov=>'.'||wwv_flow_api.id(84886607679518894.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No: No contar clics'
,p_lov_null_value=>'N'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si se trata de un enlace a una p\00E1gina externa (por ejemplo www.google.com) puede contar los clics. Consulte la documentaci\00F3n de API para el procedimiento "Z".')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121187420596205732.4001)
,p_name=>'F4000_P4052_LIST_COUNTCLICKS_CAT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(121190512604224652.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Categor\00EDa de Recuento de Clics')
,p_source=>'LIST_COUNTCLICKS_CAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Consulte la documentaci\00F3n de API para el procedimiento "Z".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(206894593488094516.4001)
,p_name=>'P4052_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(theme_name)||'' - ''||theme_id theme_name, theme_id',
'  from wwv_flow_themes',
'where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'order by upper(theme_name)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un tema asociado a esta aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(206915873780097187.4001)
,p_name=>'P4052_LIST_TEMPLATE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_prompt=>'Plantilla de Lista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_template_name) ',
'       || decode( ref_count,',
'                  null,',
'                  '''',',
'                  '' ('' || apex_lang.message( ''APEX.SC.REFERENCES'', ref_count ) || '')''',
'          ) as list_template_name,',
'       id',
'  from wwv_flow_list_templates l, ',
'         ( select count(*) ref_count, list_template_id',
'             from (',
'                    -- Lists in regions',
'                    select list_template_id as list_template_id',
'                      from wwv_flow_page_plugs p',
'                     where p.flow_id = :fb_flow_id',
'                       and p.page_id != 0',
'                       and p.security_group_id = :flow_security_group_id',
'                       and p.list_id           = :F4000_P4052_LIST_ID',
'',
'                    union all',
'                    -- Application Navigation List',
'                    select navigation_list_template_id as list_template_id',
'                      from wwv_flow_user_interfaces ui',
'                     where ui.flow_id = :fb_flow_id',
'                       and ui.security_group_id  = :flow_security_group_id',
'                       and ui.navigation_list_id = :F4000_P4052_LIST_ID',
'                    ',
'                    union all',
'                    -- Page may have customized navigation list',
'                    select navigation_list_template_id as list_template_id',
'                      from wwv_flow_steps s',
'                     where s.flow_id = :fb_flow_id',
'                       and s.security_group_id  = :flow_security_group_id',
'                       and s.navigation_list_id = :F4000_P4052_LIST_ID',
'',
'                    union all',
'                    -- Navigation Bar List',
'                    select nav_bar_list_template_id as list_template_id',
'                      from wwv_flow_user_interfaces ui',
'                     where ui.flow_id = :fb_flow_id',
'                       and ui.security_group_id = :flow_security_group_id',
'                       and ui.nav_bar_list_id   = :F4000_P4052_LIST_ID',
'                )',
'            group by list_template_id',
'          ) ref',
'',
' where l.flow_id = :fb_flow_id',
'   and l.id = ref.list_template_id (+)',
'   and l.security_group_id = :flow_security_group_id',
'   and l.theme_id = :P4052_THEME_ID',
'',
'order by ref.ref_count desc nulls last, list_template_name asc;'))
,p_lov_cascade_parent_items=>'P4052_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de lista que desea ver. Los atributos de cadena de sustituci\00F3n se mostrar\00E1n autom\00E1ticamente para la plantilla de lista seleccionada. Las descripciones de los atributos ayudan a los desarrolladores a comprender el uso de las ca')
||unistr('denas de sustituci\00F3n opcionales #A01# - #A10# dentro de una plantilla de lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(237447905222885171.4001)
,p_name=>'P4052_PRINTER_FRIENDLY'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(11914530632270079.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRINTER_FRIENDLY)'
,p_lov=>'.'||wwv_flow_api.id(148325219515185885.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para definir la versi\00F3n para impresora.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435040000513654781.4001)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_CONDITION_CHECK'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(62089494403.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1062699820597914280.4001)
,p_name=>'P4052_TRANSLATE_LIST_TEXT_Y_N'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(53980942183.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_LIST_TEXT_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17513103500929880.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4052_LIST_ITEM_LINK_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'begin',
'',
'if :P4052_URL_OR_FLOW = ''FLOW'' then',
'  if :P4052_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4052_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4052_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''||:P4052_PAGE_ID||'':&''||''SESSION.:''||:P4052_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P4052_ARG_NAMES||'':''||:P4052_ARG_VALUES||'':''||:P4052_PRINTER_FRIENDLY;',
'elsif :P4052_URL_OR_FLOW = ''0'' then',
'  return null; ',
'else',
'  return :P4052_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2140868191029758142.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_compute_when_text=>'TARGET_PAGE:NEVER:ALWAYS'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(212143214231567201.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4052_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select max(theme_id) as current_theme_id ',
'            from wwv_flow_user_interfaces ',
'           where flow_id = :fb_flow_id',
'             and ui_type_id = t.ui_type_id)',
'  from WWV_FLOW_THEMES t',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20973901829489688.4001)
,p_validation_name=>'Must have page if FLOW target'
,p_validation_sequence=>10
,p_validation=>'P4052_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la p\00E1gina.')
,p_validation_condition=>':REQUEST not in (''Cancel'',''Delete'') and :P4052_URL_OR_FLOW = ''FLOW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(17445520536714188.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(159757522215341520.4001)
,p_validation_name=>'is_numeric_sequence'
,p_validation_sequence=>20
,p_validation=>'F4000_P4052_LIST_ITEM_DISPLAY_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El valor de secuencia debe ser num\00E9rico')
,p_validation_condition=>':REQUEST not in (''Cancel'',''Delete'') and :P4052_URL_OR_FLOW = ''FLOW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(463184292.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8127115046963671.4001)
,p_validation_name=>'parent id != id'
,p_validation_sequence=>30
,p_validation=>':P4052_PARENT_LIST_ITEM_ID <> :F4000_P4052_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'El elemento principal debe ser diferente del elemento actual.'
,p_when_button_pressed=>wwv_flow_api.id(433041100.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178794902235835620.4001)
,p_validation_name=>'F4000_P4052_LIST_ITEM_LINK_TEXT'
,p_validation_sequence=>40
,p_validation=>'F4000_P4052_LIST_ITEM_LINK_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la etiqueta de entrada de lista.'
,p_validation_condition=>':REQUEST not in (''Cancel'',''Delete'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(440041101.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(14604001900749488.4001)
,p_name=>'Item Current Type Setting'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_condition_element=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TARGET_PAGE,NEVER,ALWAYS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(14604317235749499.4001)
,p_event_id=>wwv_flow_api.id(14604001900749488.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(14604505742749500.4001)
,p_event_id=>wwv_flow_api.id(14604001900749488.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397298120318466523.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4052_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397298405505466524.4001)
,p_event_id=>wwv_flow_api.id(397298120318466523.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(75363617837907452.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397298526898468334.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4052_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397298814170468334.4001)
,p_event_id=>wwv_flow_api.id(397298526898468334.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(75363526977907452.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(385812165106243646.4001)
,p_name=>'URL or Flow Change flow'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4052_URL_OR_FLOW'
,p_condition_element=>'P4052_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'FLOW,0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385812252882243647.4001)
,p_event_id=>wwv_flow_api.id(385812165106243646.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_URL_TARGET'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846498626474131701.4001)
,p_event_id=>wwv_flow_api.id(385812165106243646.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_URL_TARGET'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(385812394304243648.4001)
,p_name=>'URL or Flow Change url'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4052_URL_OR_FLOW'
,p_condition_element=>'P4052_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'URL,0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385812472153243649.4001)
,p_event_id=>wwv_flow_api.id(385812394304243648.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_PAGE_ID,P4052_REQUEST,P4052_CLEAR_CACHE,P4052_ARG_NAMES,P4052_ARG_VALUES'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385812575761243650.4001)
,p_event_id=>wwv_flow_api.id(385812394304243648.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_PAGE_ID,P4052_REQUEST,P4052_CLEAR_CACHE,P4052_ARG_NAMES,P4052_ARG_VALUES'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62894500692211647.4001)
,p_name=>'Get Template Attributes Descriptions'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4052_LIST_TEMPLATE_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62894664611211648.4001)
,p_event_id=>wwv_flow_api.id(62894500692211647.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var updateLabel = function ( pData ) {',
'    var key,',
'        SEP = ''. '';',
'',
'    var updateLabelText = function ( num, content ) {',
'        var PREFIX  = ''#F4000_P4052_LIST_TEXT_0'',',
'            POSTFIX = ''_LABEL'';',
'        $( PREFIX + num + POSTFIX ).text( content );',
'    }',
'',
'    var resetAllLabels = function(){',
'        var i = 0;',
'        for ( i = 0; i < 10; i++ ) {',
'            updateLabelText( i, i + SEP );',
'        }',
'    };',
'',
'    resetAllLabels();',
'',
'    for ( key in pData ) {',
'        if ( pData.hasOwnProperty( key ) ) {',
'            updateLabelText( key, key + SEP + pData[ key ] );',
'        }',
'    }',
'};',
'',
'apex.server.process (''getAttrDesc'', {',
'    pageItems: "#P4052_LIST_TEMPLATE_ID"',
'    }, {',
'    success: function( pData ) {',
'        updateLabel( pData );',
'    }',
'});'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(212143328323567202.4001)
,p_name=>'Set Default List Template ID'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NEVER'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(212143401763567203.4001)
,p_event_id=>wwv_flow_api.id(212143328323567202.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( ''#P4052_LIST_TEMPLATE_ID'' ).find( ''option'' ).each(function(){',
'    var option$ = $( this );',
'',
'    if ( option$.text().indexOf( ''*)'' ) > -1 ) {',
'        apex.item( ''P4052_LIST_TEMPLATE_ID'' ).setValue( option$.val() )',
'    }',
'})'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184075320258520274.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_ITEMS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_ITEMS'
,p_attribute_03=>'F4000_P4052_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(444041105.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'  l_dummy varchar2(255);',
'  l_url_parts wwv_flow_global.vc_arr2;',
'begin',
'',
'for c1 in (select list_item_link_target',
'             from wwv_flow_list_items',
'            where id = :F4000_P4052_ID',
'            and security_group_id = wwv_flow_security.g_security_group_id) loop',
'',
'wwv_flow_builder.split_url(',
'  p_url         => c1.list_item_link_target,',
'  p_flow        => l_dummy,',
'  p_page        => :P4052_PAGE_ID,',
'  p_session     => l_dummy,',
'  p_request     => :P4052_REQUEST,',
'  p_debug       => l_dummy,',
'  p_clear_cache => :P4052_CLEAR_CACHE,',
'  p_arg_names   => :P4052_ARG_NAMES,',
'  p_arg_values  => :P4052_ARG_VALUES,',
'  p_success_msg => l_dummy );',
'',
'  if :P4052_PAGE_ID is null then',
'    if c1.list_item_link_target is not null then',
'      :P4052_URL_TARGET := c1.list_item_link_target;',
'      :P4052_URL_OR_FLOW := ''URL'';',
'    else',
'      :P4052_URL_OR_FLOW := ''0'';',
'      :P4052_URL_TARGET := null;',
'    end if;',
'  else',
'    :P4052_URL_TARGET := null;',
'    :P4052_URL_OR_FLOW := ''FLOW'';',
'    if instr(:P4052_CLEAR_CACHE,''RP'') = 1 then',
'      :P4052_CLEAR_PAGE := ''YES'';',
'      :P4052_CLEAR_CACHE := ltrim(replace(:P4052_CLEAR_CACHE,''RP'',null),'','');',
'    else',
'      :P4052_CLEAR_PAGE := null;',
'    end if;',
'    -- Printer Friendly Check',
'    l_url_parts := wwv_flow_utilities.string_to_table(c1.list_item_link_target);',
'',
'    if l_url_parts.exists(9) then',
'      :P4052_PRINTER_FRIENDLY := l_url_parts(9);',
'    else',
'      :P4052_PRINTER_FRIENDLY := null;',
'    end if;',
'',
'  end if;',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(75372911895907497.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_LIST_ITEMS'
,p_attribute_03=>'F4000_P4052_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_attribute_08=>'LIST_ITEM_LINK_TEXT'
,p_attribute_09=>'P4052_ID_NEXT'
,p_attribute_10=>'P4052_ID_PREV'
,p_attribute_13=>'P4052_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and list_id = :F4000_P4050_LIST_ID'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(445041105.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LIST_ITEMS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4052_ID is null',
'or exists (select 1 from wwv_flow_list_items',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4052_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LIST_ITEMS'',',
'p_rowid       => v(''F4000_P4052_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(466209724.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Cache if Create Again'
,p_process_sql_clob=>'wwv_flow.null_step_cache(4052);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al borrar la cach\00E9 de p\00E1gina.')
,p_process_when=>'CreateAgain'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(62894711438211649.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getAttrDesc'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  apex_json.open_object;',
'',
'  for c1 in (',
'    select A01_LABEL,',
'       A02_LABEL,',
'       A03_LABEL,',
'       A04_LABEL,',
'       A05_LABEL,',
'       A06_LABEL,',
'       A07_LABEL,',
'       A08_LABEL,',
'       A09_LABEL,',
'       A10_LABEL',
'  from WWV_FLOW_LIST_TEMPLATES',
' where id = :P4052_LIST_TEMPLATE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id = :FB_FLOW_ID )',
'',
'  loop',
'    apex_json.write( ''1'', c1.A01_LABEL );',
'    apex_json.write( ''2'', c1.A02_LABEL );',
'    apex_json.write( ''3'', c1.A03_LABEL );',
'    apex_json.write( ''4'', c1.A04_LABEL );',
'    apex_json.write( ''5'', c1.A05_LABEL );',
'    apex_json.write( ''6'', c1.A06_LABEL );',
'    apex_json.write( ''7'', c1.A07_LABEL );',
'    apex_json.write( ''8'', c1.A08_LABEL );',
'    apex_json.write( ''9'', c1.A09_LABEL );',
'    apex_json.write( ''10'',c1.A10_LABEL );',
'  end loop;',
'  ',
'  apex_json.close_object;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04053
begin
wwv_flow_api.create_page(
 p_id=>4053.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Cambiar Lista'
,p_step_title=>'Cambiar Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213210808239773454)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6431204217672901.4001)
,p_plug_name=>'Elemento de Lista: &P4053_LIST_ITEM_LINK_TEXT.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(6488926081057707.4001)
,p_name=>'Lista Principal'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>160
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',24*(level-1),''&nbsp;'') || list_item_link_text list_item_link_text',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'start with id = :P4053_ID',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041645860037406591.4001)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6497208812081188.4001)
,p_query_column_id=>1
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8401214118571915.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6431204217672901.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8435422523631181.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6431204217672901.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8216221523533289.4001)
,p_branch_action=>'f?p=&APP_ID.:4053:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P4053_LIST_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8435600488631185.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(8435422523631181.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6448009206759577.4001)
,p_name=>'P4053_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6488926081057707.4001)
,p_prompt=>'ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6452205658777400.4001)
,p_name=>'P4053_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6488926081057707.4001)
,p_prompt=>'Lista'
,p_source=>'select list_id from wwv_flow_list_items where id = :P4053_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LISTS'
,p_lov=>'select wwv_flow_escape.html(name) d, id from wwv_flow_lists where flow_id = :FB_FLOW_ID order by upper(name)'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione una lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6464113895874499.4001)
,p_name=>'P4053_PARENT_LIST_ITEM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(6488926081057707.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Elemento de Lista Principal'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select parent_list_item_id from wwv_flow_list_items',
'where id = :P4053_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PARENT_LIST.LIST_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :P4053_LIST_ID',
'    start with id = :P4053_ID ',
'    connect by prior id = parent_list_item_id',
')',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P4053_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn Elemento de Lista Principal -')
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P4053_LIST_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si dispone de una lista jer\00E1rquica, utilice este atributo para identificar un elemento principal de los elementos de la lista. Para visualizar una lista jer\00E1rquica se necesita una plantilla de lista en que aparezcan las listas jer\00E1rquicas. Consulte e')
||unistr('l texto de ayuda de la plantilla de lista para obtener m\00E1s informaci\00F3n sobre la visualizaci\00F3n de elementos de listas jer\00E1rquicas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8338513482325738.4001)
,p_name=>'P4053_OLD_LIST_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6488926081057707.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Old List Id'
,p_source=>'select list_id from wwv_flow_list_items where id = :P4053_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8430619836611491.4001)
,p_name=>'P4053_LIST_ITEM_LINK_TEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6431204217672901.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'select list_item_link_text from wwv_flow_list_items where id = :P4053_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifique el texto del enlace del elemento de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(8389505844522205.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update parent list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_list_items',
'set list_id = :P4053_LIST_ID',
'where list_id = :P4053_OLD_LIST_ID',
'and id in (',
'    select id',
'    from wwv_flow_list_items',
'    where flow_id = :FB_FLOW_ID',
'    start with id = :P4053_ID',
'    connect by prior id = parent_list_item_id ',
');',
'',
'if :P4053_PARENT_LIST_ITEM_ID=0 then',
'    update wwv_flow_list_items set parent_list_item_id = NULL',
'    where id = :P4053_ID;',
'else',
'    update wwv_flow_list_items set parent_list_item_id = :P4053_PARENT_LIST_ITEM_ID',
'    where id = :P4053_ID;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fallo al actualizar la lista principal para los elementos de lista actuales y los elementos de sublista asociados.',
'',
''))
,p_process_when_button_id=>wwv_flow_api.id(8435422523631181.4001)
,p_process_success_message=>unistr('La actualizaci\00F3n de la lista principal para los elementos de lista actuales y los elementos de sublista asociados se ha realizado correctamente.')
);
end;
/
prompt --application/pages/page_04069
begin
wwv_flow_api.create_page(
 p_id=>4069.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Lista: Copiar de'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12244490384.4001)
,p_plug_name=>'Crear Plantilla de Lista'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177345505779114236.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186372503218123509.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(12264554878.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186372503218123509.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178299516222547816.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(186372503218123509.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177347717095117687.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186372503218123509.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154528428531099650.4001)
,p_branch_action=>'f?p=&FLOW_ID.:412:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(585124829857099811.4001)
,p_branch_action=>'f?p=&APP_ID.:931:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177347717095117687.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12255533342.4001)
,p_name=>'F4000_P4069_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(12244490384.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar plantillas.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178316719733575591.4001)
,p_validation_name=>'F4000_P4069_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4069_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(12255533342.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-FEB-2002 11:14'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(585124605775099809.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(12264554878.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(585124771388099810.4001)
,p_event_id=>wwv_flow_api.id(585124605775099809.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04070
begin
wwv_flow_api.create_page(
 p_id=>4070.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_step_title=>unistr('Esquemas de Autorizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4627541309.4001)
,p_plug_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La autorizaci\00F3n para aplicaciones, p\00E1ginas y para la mayor parte del resto de los componentes se gestiona mediante los esquemas de autorizaci\00F3n.</p>'),
unistr('<p>El esquema de autorizaci\00F3n se asocia a una aplicaci\00F3n, p\00E1gina o cualquier otro componente de la p\00E1gina de atributos del componente.</p>'),
unistr('<p>Los esquemas de autorizaci\00F3n son comprobaciones de aprobaci\00F3n/fallo. Los tipos de esquema de autorizaci\00F3n comunes son: consultas SQL Exists y Not Exists y funci\00F3n PL/SQL que devuelve un valor booleano.</p>'),
unistr('<p>El resultado satisfactorio o de error de los esquemas de autorizaci\00F3n se almacenar\00E1 en cach\00E9 en cada sesi\00F3n o en cada vista de p\00E1gina con el fin de mejorar el rendimiento.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/providing-security-through-authorization.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47949307778486335.4001)
,p_plug_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4070a */',
'       NAME,',
'       scheme_type st,',
'       caching,',
'       id,',
'       ERROR_MESSAGE,',
'       case when a.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_security_schemes',
'                         where id                = a.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_security_schemes',
'          where reference_id      = a.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       ''icon-sc-authorization-scheme'' icon_class,',
'       replace(name,''_'','' '') icon_title,',
'       ''f?p=4000:4008:''||:flow_SESSION||''::NO::F4000_P4008_ID:''||ID edit_link,',
'       replace(name,''_'','' '') img_name,',
'       last_updated_by,',
'       last_updated_on,',
'       created_by,',
'       created_on',
'  from WWV_FLOW_SECURITY_SCHEMES a',
' where flow_id = :fb_flow_ID',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47949429235486335.4001)
,p_name=>'Authorization Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47949605902486429.4001)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:4008:F4000_P4008_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47949715644486435.4001)
,p_db_column_name=>'ST'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(11239432234132441)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47949916504486436.4001)
,p_db_column_name=>'CACHING'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Cach\00E9')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(84860700520374929)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562394549198333.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>14
,p_column_identifier=>'S'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340562407259198334.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>24
,p_column_identifier=>'T'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47950030313486437.4001)
,p_db_column_name=>'ID'
,p_display_order=>34
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47952131945502695.4001)
,p_db_column_name=>'IMG_NAME'
,p_display_order=>44
,p_column_identifier=>'I'
,p_column_label=>'Nombre de Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47954105495544256.4001)
,p_db_column_name=>'ERROR_MESSAGE'
,p_display_order=>54
,p_column_identifier=>'J'
,p_column_label=>'Mensaje de Error'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47954321014544281.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>64
,p_column_identifier=>'L'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47954412974544282.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>74
,p_column_identifier=>'M'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47954610343545682.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>84
,p_column_identifier=>'N'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47954710964545682.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>94
,p_column_identifier=>'O'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656867620569786669.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>104
,p_column_identifier=>'P'
,p_column_label=>'Clase de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656867711958786669.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>114
,p_column_identifier=>'Q'
,p_column_label=>unistr('T\00EDtulo de Icono')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656867883500786669.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>124
,p_column_identifier=>'R'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180461031739299652.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(180462022520306486.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(115177118264903056.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47949307778486335.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:493:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188928919776662007.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47949307778486335.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:4070,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90884429006403343.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(47949307778486335.4001)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:184,185,186,188::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4613513414.4001)
,p_branch_action=>'4008'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4617513415.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4008_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(199670330190175566.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4070'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590130201968619590.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(90884429006403343.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590130582152619590.4001)
,p_event_id=>wwv_flow_api.id(590130201968619590.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_04080
begin
wwv_flow_api.create_page(
 p_id=>4080.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear lista de valores: origen de datos'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(107113896747926973.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155583899503222824.4001)
,p_plug_name=>'Crear &F4000_P4004_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(64471324421117450.4001)
,p_plug_name=>'Crear para origen de datos local'
,p_parent_plug_id=>wwv_flow_api.id(155583899503222824.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(64471409835117451.4001)
,p_plug_name=>'Crear lista de valores en origen de datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(155583899503222824.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(66262064265725378.4001)
,p_plug_name=>'Crear lista de valores en SQL remoto'
,p_parent_plug_id=>wwv_flow_api.id(155583899503222824.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155584115286222824.4001)
,p_plug_name=>'Ejemplo de Consulta SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT ename d, ',
'       empno r',
'  FROM emp ',
' ORDER BY 1',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de consulta SQL para rellenar esta lista de valores. Normalmente, las consultas de lista de valores tienen este formato:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155590311385227841.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(161740513874429436.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62694601289169857.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(107113896747926973.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62695038308169864.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(107113896747926973.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62695406624169864.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(107113896747926973.4001)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4004:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8966161347715512.4001)
,p_branch_name=>'Go To Page 4081'
,p_branch_action=>'f?p=&APP_ID.:4081:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(62695038308169864.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1691437837640582.4001)
,p_name=>'P4080_FUNC_BODY_LANG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(64471324421117450.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23200271467325527.4001)
,p_name=>'P4080_FUNC_BODY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(64471324421117450.4001)
,p_prompt=>unistr('Introduzca un cuerpo de la funci\00F3n que devuelva una consulta SQL')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la lista de valores, por ejemplo:'),
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_04=>'N'
,p_attribute_06=>'P4080_FUNC_BODY_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62696138761169874.4001)
,p_name=>'P4080_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(155583899503222824.4001)
,p_item_default=>'LOCAL'
,p_prompt=>'Origen de Datos'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Permite seleccionar el tipo de <em>origen de datos</em> de la nueva lista de valores de APEX.',
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se originan en la base de datos local.</li>',
'    <li><strong>Servicio de SQL activado para REST</strong><br>',
unistr('    Los datos se originan en una base de datos remota, donde la conexi\00F3n se define utilizando el servicio SQL activado para REST. Para crear o conservar las referencias de SQL activadas para REST, acceda a Componentes compartidos > SQL activado para ')
||'REST.',
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos se originan en un servicio web RESTful que se ha definido utilizando or\00EDgenes de datos de REST. Para crear o conservar los or\00EDgenes de datos de REST, acceda a Componentes compartidos.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62697783862169888.4001)
,p_name=>'P4080_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(64471324421117450.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Table;TABLE,SQL Query;SQL,Function Returning SQL;FUNC_BODY_RETURNING_SQL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. La lista de valores que utiliza un origen de datos de una base de datos local puede estar basada en una tabla, en consultas SQL o en una funci\00F3n PL/SQL que devuelva SQL. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62699004973169889.4001)
,p_name=>'P4080_TABLE_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(64471324421117450.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P4080_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear una lista de valores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62699936633169891.4001)
,p_name=>'P4080_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(64471324421117450.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4080_TABLE_OWNER',
'   and :P4080_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P4080_TABLE_OWNER,P4080_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62703092726169894.4001)
,p_name=>'P4080_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(64471324421117450.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la lista de valores, por ejemplo:'),
'<pre>',
'select ename, empno',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62710063600169925.4001)
,p_name=>'P4080_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(64471409835117451.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el origen de datos de REST en el que est\00E9 soportada la recuperaci\00F3n de una recopilaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62711699254169926.4001)
,p_name=>'P4080_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(66262064265725378.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el servidor de la base de datos remota.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62712070268169926.4001)
,p_name=>'P4080_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(66262064265725378.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Table;TABLE,SQL Query;SQL'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. La lista de valores que utiliza un origen de datos de un servicio de SQL activado para REST puede estar basada en una tabla o en consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62712957037169927.4001)
,p_name=>'P4080_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(66262064265725378.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la lista de valores, por ejemplo:'),
'<pre>',
'select ename, empno',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P4080_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62713888294169928.4001)
,p_name=>'P4080_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(66262064265725378.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4080_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P4080_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear una lista de valores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62714764004169928.4001)
,p_name=>'P4080_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(66262064265725378.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4080_REMOTE_SERVER_ID, ''TABLE'', :P4080_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P4080_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P4080_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62717698513169951.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4080_TABLE_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(62718010802169951.4001)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4080_TABLE_OWNER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62719607435169960.4001)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P4080_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el SQL.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''SQL'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62703092726169894.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23200409731325529.4001)
,p_validation_name=>'Function Body Not Null'
,p_validation_sequence=>20
,p_validation=>'P4080_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el cuerpo de la funci\00F3n.')
,p_validation_condition=>':P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(23200271467325527.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62720075044169961.4001)
,p_validation_name=>'is valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P4080_SQL );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''SQL'' and :P4080_LOCATION = ''LOCAL'' and :P4080_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62703092726169894.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(23200571197325530.4001)
,p_validation_name=>'is valid code'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location               => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type             => wwv_flow_exec_api.c_query_type_func_return_sql,',
'                            p_function_body          => :P4080_FUNC_BODY,',
'                            p_function_body_language => :P4080_FUNC_BODY_LANG );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and',
':P4080_LOCATION = ''LOCAL'' and ',
':P4080_FUNC_BODY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(23200271467325527.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62720891942169961.4001)
,p_validation_name=>'P4080_TABLE_OWNER is not null'
,p_validation_sequence=>50
,p_validation=>'P4080_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el propietario de tabla.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62699004973169889.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62721225061169962.4001)
,p_validation_name=>'P4080_TABLE_NAME is not null'
,p_validation_sequence=>60
,p_validation=>'P4080_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe especificar el nombre de la tabla.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62699936633169891.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62718882922169960.4001)
,p_validation_name=>'P4080_REMOTE_TABLE_NAME is not null'
,p_validation_sequence=>70
,p_validation=>'P4080_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe especificar el nombre de la tabla.'
,p_validation_condition=>':P4080_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62714764004169928.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21193465435792704.4001)
,p_validation_name=>'P4080_REMOTE_SQL is not null'
,p_validation_sequence=>80
,p_validation=>'P4080_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de SQL.'
,p_validation_condition=>':P4080_REMOTE_SOURCE_TYPE = ''SQL'' and :P4080_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62712957037169927.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(21193398293792703.4001)
,p_validation_name=>'P4080_WEB_SRC_MODULE_ID is not null'
,p_validation_sequence=>90
,p_validation=>'P4080_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4080_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62710063600169925.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62721623073169962.4001)
,p_validation_name=>'P4080_COLUMNS is not null'
,p_validation_sequence=>100
,p_validation=>'P4080_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos una columna.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62719266551169960.4001)
,p_validation_name=>'P4080_REMOTE_COLUMNS is not null'
,p_validation_sequence=>110
,p_validation=>'P4080_REMOTE_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos una columna.'
,p_validation_condition=>':P4080_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62718448247169952.4001)
,p_validation_name=>'P4080_WEB_SRC_COLUMNS is not null'
,p_validation_sequence=>120
,p_validation=>'P4080_WEB_SRC_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos una columna.'
,p_validation_condition=>'P4080_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485482335307043.4001)
,p_validation_name=>'P4080_REMOTE_SERVER_ID is not null'
,p_validation_sequence=>130
,p_validation=>'P4080_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4080_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(62695038308169864.4001)
,p_associated_item=>wwv_flow_api.id(62711699254169926.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23199395266325518.4001)
,p_name=>'SOURCE TYPE CHANGE HIDE ALL'
,p_event_sequence=>11
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23200372430325528.4001)
,p_event_id=>wwv_flow_api.id(23199395266325518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_SQL,P4080_FUNC_BODY_LANG,P4080_FUNC_BODY,P4080_SQL,P4080_TABLE_OWNER,P4080_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23199658881325521.4001)
,p_event_id=>wwv_flow_api.id(23199395266325518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(155584115286222824.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62724368003169967.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(62694601289169857.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62724840160169979.4001)
,p_event_id=>wwv_flow_api.id(62724368003169967.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62725255941169982.4001)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62725789398169983.4001)
,p_event_id=>wwv_flow_api.id(62725255941169982.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62729252547169989.4001)
,p_event_id=>wwv_flow_api.id(62725255941169982.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(155584115286222824.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23199798892325522.4001)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23199988055325524.4001)
,p_event_id=>wwv_flow_api.id(23199798892325522.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_TABLE_OWNER,P4080_TABLE_NAME'
,p_attribute_01=>'N'
);
end;
/
begin
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(23198490781325509.4001)
,p_name=>'SOURCE TYPE = FUNC_BODY'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23198510758325510.4001)
,p_event_id=>wwv_flow_api.id(23198490781325509.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_FUNC_BODY_LANG,P4080_FUNC_BODY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62738845679169997.4001)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_LOCATION'
,p_condition_element=>'P4080_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62739338668169997.4001)
,p_event_id=>wwv_flow_api.id(62738845679169997.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(64471324421117450.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62739890783169998.4001)
,p_event_id=>wwv_flow_api.id(62738845679169997.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(64471324421117450.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62740736327169999.4001)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_LOCATION'
,p_condition_element=>'P4080_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62741212427169999.4001)
,p_event_id=>wwv_flow_api.id(62740736327169999.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(66262064265725378.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62741797280169999.4001)
,p_event_id=>wwv_flow_api.id(62740736327169999.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(66262064265725378.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62742172505170000.4001)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_LOCATION'
,p_condition_element=>'P4080_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62742642829170000.4001)
,p_event_id=>wwv_flow_api.id(62742172505170000.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(64471409835117451.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62743140616170000.4001)
,p_event_id=>wwv_flow_api.id(62742172505170000.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(64471409835117451.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(62732690000169992.4001)
,p_name=>'REMOTE SOURCE TYPE = SQL'
,p_event_sequence=>115
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_REMOTE_SOURCE_TYPE,P4080_REMOTE_SERVER_ID'
,p_condition_element=>'P4080_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62733177106169993.4001)
,p_event_id=>wwv_flow_api.id(62732690000169992.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62733624986169993.4001)
,p_event_id=>wwv_flow_api.id(62732690000169992.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(155584115286222824.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62734105204169993.4001)
,p_event_id=>wwv_flow_api.id(62732690000169992.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_TABLE_OWNER,P4080_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62734654502169993.4001)
,p_event_id=>wwv_flow_api.id(62732690000169992.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_TABLE_OWNER,P4080_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62735158648169994.4001)
,p_event_id=>wwv_flow_api.id(62732690000169992.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(155584115286222824.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(62735619121169994.4001)
,p_event_id=>wwv_flow_api.id(62732690000169992.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(21193579919792705.4001)
,p_name=>'Remote Server chosen'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_REMOTE_SERVER_ID'
,p_condition_element=>'P4080_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21193707120792707.4001)
,p_event_id=>wwv_flow_api.id(21193579919792705.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SOURCE_TYPE,P4080_REMOTE_SQL,P4080_REMOTE_TABLE_OWNER,P4080_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21193939564792709.4001)
,p_event_id=>wwv_flow_api.id(21193579919792705.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(62723989987169966.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Source Type Preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'WIZARD_SQL_SOURCE_TYPE'
,p_attribute_03=>'P4080_SOURCE_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(62695038308169864.4001)
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
,p_process_comment=>'commented out as source type changed to be ''SQL'' not ''QUERY'''
);
end;
/
prompt --application/pages/page_04081
begin
wwv_flow_api.create_page(
 p_id=>4081.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear lista de valores: asignaciones de columnas'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Lista de Valores'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_javascript_code_onload=>'//apex.region("column_info").call("getActions").set("edit", true);'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8966275624715513.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(161740513874429436.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8966394636715514.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(104836580260625037.4001)
,p_plug_name=>unistr('Asignaci\00F3n de Columna')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(663117390211931018.4001)
,p_plug_name=>'Consultas Definidas con Varias Columnas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Si al crear un listado de valores basado en una consulta SQL de m\00E1s de 2 columnas desea mostrar estas columnas adicionales en un elemento que las soporte (por ejemplo, el Popup LOV), deber\00E1 a\00F1adiras expl\00EDcitamente despu\00E9s de haber creado el LOV. Para')
||unistr(' ello, vaya a la p\00E1gina de edici\00F3n y seleccione "Seleccionar Columnas" dentro de "Mostrar Columnas Adicionales", donde podr\00E1 seleccionar las columnas adicionales que desea mostrar.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if ( :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE in ( ''SQL'', ''FUNC_BODY_RETURNING_SQL'' )',
'         or ',
'         :P4080_LOCATION = ''REMOTE'' and :P4080_REMOTE_SOURCE_TYPE = ''SQL'' ) ',
'    then ',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                 p_location               => :P4080_LOCATION,',
'                                 p_remote_server_id       => case when :P4080_LOCATION = ''REMOTE'' then :P4080_REMOTE_SERVER_ID end,',
'                                 p_query_type             => :P4080_SOURCE_TYPE,',
'                                 p_sql_query              => case ',
'                                                                 when :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE = ''SQL'' then :P4080_SQL',
'                                                                 when :P4080_LOCATION = ''REMOTE'' and :P4080_REMOTE_SOURCE_TYPE = ''SQL'' then :P4080_REMOTE_SQL',
'                                                             end,',
'                                 p_function_body          => case ',
'                                                                 when :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4080_FUNC_BODY',
'                                                             end,',
'                                 p_function_body_language => case ',
'                                                                 when :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4080_FUNC_BODY_LANG',
'                                                             end );',
'                                ',
'        return case when l_describe_result.query_columns.count > 2 then true else false end;',
'',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8966487532715515.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(8966394636715514.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8966537405715516.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(8966394636715514.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8966611408715517.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(8966394636715514.4001)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4080:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21185764186624645.4001)
,p_name=>'P4081_RETURN_COLUMN'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(104836580260625037.4001)
,p_prompt=>'Devolver Columna'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4080_LOCATION,',
'                  p_query_type             => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4080_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_TABLE_OWNER',
'                                                  when ''REMOTE'' then :P4080_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_TABLE_NAME',
'                                                  when ''REMOTE'' then :P4080_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_SQL',
'                                                  when ''REMOTE'' then :P4080_REMOTE_SQL',
'                                              end,             ',
'                  p_function_body          => :P4080_FUNC_BODY,',
'                  p_function_body_language => :P4080_FUNC_BODY_LANG,',
'                  p_remote_server_id       => to_number(:P4080_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4080_WEB_SRC_MODULE_ID)',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina la columna que se utilizar\00E1 como valor de retorno en la lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21186197082624653.4001)
,p_name=>'P4081_DISPLAY_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(104836580260625037.4001)
,p_prompt=>unistr('Columna de Visualizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4080_LOCATION,',
'                  p_query_type             => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4080_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_TABLE_OWNER',
'                                                  when ''REMOTE'' then :P4080_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_TABLE_NAME',
'                                                  when ''REMOTE'' then :P4080_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4080_LOCATION ',
'                                                  when ''LOCAL'' then :P4080_SQL',
'                                                  when ''REMOTE'' then :P4080_REMOTE_SQL',
'                                              end,             ',
'                  p_function_body          => :P4080_FUNC_BODY,',
'                  p_function_body_language => :P4080_FUNC_BODY_LANG,',
'                  p_remote_server_id       => to_number(:P4080_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4080_WEB_SRC_MODULE_ID)',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina la columna que se utilizar\00E1 como valor de visualizaci\00F3n en la lista de valores. Nota: Las columnas de visualizaci\00F3n adicionales pueden definirse tras la creaci\00F3n de la lista de valores para los tipos de elemento que soportan la visualizaci\00F3n d')
||'e varias columnas (como la lista de valores emergente).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(8966754951715518.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(8966487532715515.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(8966866217715519.4001)
,p_event_id=>wwv_flow_api.id(8966754951715518.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21193104939792701.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Default Return and Display Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type             wwv_flow_exec_api.t_data_type;',
'    l_return_value_found    boolean := false;',
'    l_display_value_found   boolean := false;',
'    l_table_name            varchar2(128);',
'    l_table_owner           varchar2(128);',
'    l_source_type           wwv_flow_lists_of_values$.source_type%type;',
'    l_sql                   varchar2(32767);',
'    l_describe_result       wwv_flow_exec_dev.t_describe_result;',
'    l_column                wwv_flow_exec_api.t_column;',
'begin',
'',
'    if :P4080_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner   := :P4080_TABLE_OWNER;',
'        l_table_name    := :P4080_TABLE_NAME;',
'        l_source_type   := :P4080_SOURCE_TYPE;',
'        l_sql           := :P4080_SQL;',
'    elsif :P4080_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner   := :P4080_REMOTE_TABLE_OWNER;',
'        l_table_name    := :P4080_REMOTE_TABLE_NAME;',
'        l_source_type   := :P4080_REMOTE_SOURCE_TYPE;',
'        l_sql           := :P4080_REMOTE_SQL;',
'    end if;',
'',
'    -- parse and describe query',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                              p_location               => :P4080_LOCATION,',
'                              p_query_type             => l_source_type,',
'                              p_owner                  => l_table_owner,           ',
'                              p_table_name             => l_table_name,            ',
'                              p_sql_query              => l_sql,              ',
'                              p_function_body          => :P4080_FUNC_BODY,',
'                              p_function_body_language => :P4080_FUNC_BODY_LANG,',
'                              p_remote_server_id       => :P4080_REMOTE_SERVER_ID,',
'                              p_web_src_module_id      => :P4080_WEB_SRC_MODULE_ID );',
'    ',
'    for i in 1 .. l_describe_result.query_columns.count loop',
'',
'        l_column := l_describe_result.query_columns( i );',
'',
'        -- We only support the following data types for LOVs',
'        if l_column.data_type in ( ',
'                wwv_flow_exec_api.c_data_type_varchar2, ',
'                wwv_flow_exec_api.c_data_type_number,',
'                wwv_flow_exec_api.c_data_type_date,',
'                wwv_flow_exec_api.c_data_type_timestamp,',
'                wwv_flow_exec_api.c_data_type_timestamp_tz,',
'                wwv_flow_exec_api.c_data_type_timestamp_ltz,',
'                wwv_flow_exec_api.c_data_type_interval_y2m,',
'                wwv_flow_exec_api.c_data_type_interval_d2s,',
'                wwv_flow_exec_api.c_data_type_clob,',
'                wwv_flow_exec_api.c_data_type_rowid ) ',
'        then',
'            -- If this is the first number column, assume it''s the return value',
'            if l_column.data_type = wwv_flow_exec_api.c_data_type_number and not l_return_value_found then',
'                :P4081_RETURN_COLUMN := l_column.name;',
'                l_return_value_found := true;',
'            end if;',
'',
'            -- If this is the first text column, assume it''s the primary display value',
'            if l_column.data_type = wwv_flow_exec_api.c_data_type_varchar2 and not l_display_value_found then',
'                :P4081_DISPLAY_COLUMN := l_column.name;',
'                l_display_value_found := true;',
'            end if;',
'',
'            -- stop looking when we''ve got both display and return',
'            if l_return_value_found and l_display_value_found then ',
'                exit;',
'            end if;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21190462109691831.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.create_dynamic_lov(',
'    p_lov_name               => :F4000_P4004_NAME,',
'    p_location               => :P4080_LOCATION,',
'    p_source_type            => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4080_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4080_TABLE_OWNER',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_TABLE_OWNER',
'                                end,',
'    p_table_name             => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4080_TABLE_NAME',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_TABLE_NAME',
'                                end,',
'    p_sql_query              => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then',
'                                        case :P4080_SOURCE_TYPE',
'                                            when wwv_flow_exec_api.c_query_type_sql_query then :P4080_SQL',
'                                            when wwv_flow_exec_api.c_query_type_func_return_sql then :P4080_FUNC_BODY',
'                                        end',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_SQL',
'                                end,',
'    p_function_body_language => case',
'                                  when :P4080_LOCATION = wwv_flow_exec_api.c_location_local_db',
'                                   and :P4080_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_func_return_sql',
'                                  then :P4080_FUNC_BODY_LANG',
'                                end,',
'    p_web_src_module_id      => to_number(:P4080_WEB_SRC_MODULE_ID),',
'    p_remote_server_id       => to_number(:P4080_REMOTE_SERVER_ID),',
'    p_return_column          => :P4081_RETURN_COLUMN,',
'    p_display_column         => :P4081_DISPLAY_COLUMN',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(8966537405715516.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4368263449268577.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_process_error_message=>'Error al crear la lista de valores.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(8966537405715516.4001)
,p_process_success_message=>'La lista de valores se ha creado correctamente.'
);
end;
/
prompt --application/pages/page_04082
begin
wwv_flow_api.create_page(
 p_id=>4082.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Seleccionar columnas de visualizaci\00F3n adicionales')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Seleccionar columnas de visualizaci\00F3n adicionales')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20214923591919128.4001)
,p_plug_name=>'Seleccionar Columnas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(421568269617510633.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73082888039504666.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(421568269617510633.4001)
,p_button_name=>'UPDATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Actualizar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(73083254460504669.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(421568269617510633.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20997955128632618.4001)
,p_name=>'P4082_SELECT_COLUMNS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20214923591919128.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return varchar2(32767);',
'    ',
'    procedure add_value (',
'        p_value     in     varchar2,',
'        p_return    in out varchar2 )',
'    is',
'        l_return_array  wwv_flow_t_varchar2 := apex_string.split(p_return,'':'');',
'    begin',
'        if p_value is not null then',
'            -- Check if column has already been added',
'            for i in 1..l_return_array.count loop',
'                if l_return_array(i) = p_value then ',
'                    return;',
'                end if;',
'            end loop;',
'            ',
'            if p_return is not null then',
'                p_return := p_return||'':'';',
'            end if;',
'       ',
'            p_return := p_return || p_value;  ',
'        end if;',
'    end add_value;',
'begin',
'    -- if collection already exists (because additional columns are already defined),',
'    -- pre-fill these values',
'    for c1 in (select c001 column_name ',
'                 from wwv_flow_collections ',
'                where collection_name = ''LOV_COL_INFO'') ',
'    loop',
'        add_value( c1.column_name, l_return );',
'    end loop;',
'  ',
'    -- if collection doesn''t exist, pre-fill with any columns defined in column mapping',
'    if l_return is null then',
'        add_value( :P4111_RETURN_COLUMN, l_return );',
'        add_value( :P4111_DISPLAY_COLUMN, l_return );',
'        add_value( :P4111_DEFAULT_SORT_COLUMN, l_return );',
'        add_value( :P4111_GROUP_COLUMN, l_return );',
'        add_value( :P4111_ICON_COLUMN, l_return );',
'        add_value( :P4111_ORACLE_TEXT_COLUMN, l_return );',
'    end if;',
'    ',
'    return l_return;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                => :P4111_LOCATION,',
'                  p_query_type              => case :P4111_LOCATION ',
'                                                   when ''LOCAL'' then :P4111_SOURCE_TYPE',
'                                                   when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                               end,',
'                  p_owner                   => case :P4111_LOCATION ',
'                                                   when ''LOCAL'' then :P4111_QUERY_OWNER',
'                                                   when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                               end,       ',
'                  p_table_name              => case :P4111_LOCATION ',
'                                                   when ''LOCAL'' then :P4111_QUERY_TABLE',
'                                                   when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                               end,',
'                  p_sql_query               => case :P4111_LOCATION ',
'                                                   when ''LOCAL'' then :P4111_LOV_QUERY_SQL',
'                                                   when ''REMOTE'' then :P4111_REMOTE_SQL',
'                                                   when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                               end,             ',
'                  p_function_body           => case :P4111_LOCATION',
'                                                   when ''LOCAL'' then :P4111_LOV_QUERY_FUNC_BODY',
'                                                   when ''REMOTE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                               end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                 when ''LOCAL''  then :P4111_LOV_QUERY_FUNC_LANG',
'                                                 when ''REMOTE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_PLSQL, P4111_REMOTE_SERVER_ID, P4111_WEB_SRC_'
||'MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SOURCE_POST_PROC_PLSQL, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>18
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4469240629653229.4001)
,p_validation_name=>'DISALLOW REMOVE FOR COLUMNS USED IN MAPPINGS'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_shuttle_columns           wwv_flow_t_varchar2;',
'    l_check_return              boolean := :P4111_RETURN_COLUMN is not null;',
'    l_check_display             boolean := :P4111_DISPLAY_COLUMN is not null;',
'    l_check_default_sort        boolean := :P4111_DEFAULT_SORT_COLUMN is not null;',
'    l_check_group               boolean := :P4111_GROUP_COLUMN is not null;',
'    l_check_icon                boolean := :P4111_ICON_COLUMN is not null;',
'    l_return_ok                 boolean := not l_check_return;',
'    l_display_ok                boolean := not l_check_display;',
'    l_default_sort_ok           boolean := not l_check_default_sort;',
'    l_group_ok                  boolean := not l_check_group;',
'    l_icon_ok                   boolean := not l_check_icon;',
'    i                           int;',
'    l_error                     varchar2(4000);',
'begin ',
'    l_shuttle_columns := apex_string.split(:P4082_SELECT_COLUMNS,'':'');',
'    ',
'    if l_shuttle_columns.count > 0 then ',
'        i := l_shuttle_columns.first;',
'        loop',
'            -- return column',
'            if l_check_return and not l_return_ok then ',
'                if l_shuttle_columns( i ) = :P4111_RETURN_COLUMN then ',
'                    l_return_ok := true;',
'                end if;',
'            end if;',
'            ',
'            -- display column',
'            if l_check_display and not l_display_ok then ',
'                if l_shuttle_columns( i ) = :P4111_DISPLAY_COLUMN then ',
'                    l_display_ok := true;',
'                end if;',
'            end if;',
'',
'            -- default sort',
'            if l_check_default_sort and not l_default_sort_ok then ',
'                if l_shuttle_columns( i ) = :P4111_DEFAULT_SORT_COLUMN then ',
'                    l_default_sort_ok := true;',
'                end if;',
'            end if;',
'',
'            -- group',
'            if l_check_group and not l_group_ok then ',
'                if l_shuttle_columns( i ) = :P4111_GROUP_COLUMN then ',
'                    l_group_ok := true;',
'                end if;',
'            end if;',
' ',
'            -- icon',
'            if l_check_icon and not l_icon_ok then ',
'                if l_shuttle_columns( i ) = :P4111_ICON_COLUMN then ',
'                    l_icon_ok := true;',
'                end if;',
'            end if;',
'            ',
'            exit when i = l_shuttle_columns.last;',
'            i := l_shuttle_columns.next(i);',
'        end loop;',
'    end if;',
'    ',
'    if not l_return_ok or ',
'       not l_display_ok or ',
'       not l_default_sort_ok or',
'       not l_group_ok or',
'       not l_icon_ok       ',
'    then ',
'        l_error := ''You cannot remove the following columns, as they are defined in the ''''Column Mappings'''' for this List of Values: '';',
'        l_error := l_error || case when not l_return_ok       then :P4111_RETURN_COLUMN || '', '' end ||',
'                              case when not l_display_ok      then :P4111_DISPLAY_COLUMN || '', '' end ||',
'                              case when not l_default_sort_ok then :P4111_DEFAULT_SORT_COLUMN || '', '' end ||',
'                              case when not l_group_ok        then :P4111_GROUP_COLUMN || '', '' end ||',
'                              case when not l_icon_ok         then :P4111_ICON_COLUMN end;',
'        return l_error;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(73082888039504666.4001)
,p_associated_item=>wwv_flow_api.id(20997955128632618.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(20999217583632631.4001)
,p_name=>'CANCEL BUTTON CLICKED'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(73083254460504669.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20999375822632632.4001)
,p_event_id=>wwv_flow_api.id(20999217583632631.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20999687257632635.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update LOV Column Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.update_column_collection(',
'    p_collection_name        => ''LOV_COL_INFO'',',
'    p_new_columns            => :P4082_SELECT_COLUMNS,',
'    p_location               => :P4111_LOCATION,',
'    p_source_type            => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_OWNER',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_OWNER',
'                                end,',
'    p_table_name             => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_TABLE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_NAME',
'                                end,',
'    p_sql_query              => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_SQL',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SQL',
'                                    when wwv_flow_exec_api.c_location_web_source then :P4111_SOURCE_POST_PROC_SQL',
'                                end,',
'    p_function_body          => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_FUNC_BODY',
'                                    when wwv_flow_exec_api.c_location_web_source then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                end,',
'    p_function_body_language => case :P4111_LOCATION',
'                                   when ''LOCAL''  then :P4111_LOV_QUERY_FUNC_LANG',
'                                   when ''REMOTE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                end,    ',
'    p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'    p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'    p_where_clause           => case :P4111_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_LOCAL_WHERE ',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_WHERE',
'                                    when wwv_flow_exec_api.c_location_web_source then :P4111_SOURCE_POST_PROC_WHERE',
'                                end,',
'    p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE,',
'    p_return_column          => :P4111_RETURN_COLUMN );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(73084821026504677.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('La informaci\00F3n de columna se ha actualizado correctamente.')
);
end;
/
prompt --application/pages/page_04083
begin
wwv_flow_api.create_page(
 p_id=>4083.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar valores de par\00E1metro de origen de datos de REST')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Editar valores de par\00E1metro de origen de datos de REST')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4437481313497226.4001)
,p_plug_name=>unistr('Editar valores de par\00E1metro de origen de datos de REST')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4444768135497245.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4445185941497245.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4444768135497245.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4447119598497250.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(4444768135497245.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P4083_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465248613917843.4001)
,p_name=>'P4083_VALUE_STATIC'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor Est\00E1tico')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''STATIC'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el valor est\00E1tico utilizado como origen para este valor de par\00E1metro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465382459917844.4001)
,p_name=>'P4083_VALUE_ITEM'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Elemento'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''ITEM'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina o aplicaci\00F3n utilizado como origen para este valor de par\00E1metro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465412992917845.4001)
,p_name=>'P4083_VALUE_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''SQL_QUERY'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la consulta SQL que se ha utilizado como origen para este valor de par\00E1metro. Si el sistema devuelve m\00E1s de una fila, se utilizar\00E1 el valor de la primera fila.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465580604917846.4001)
,p_name=>'P4083_VALUE_PLSQL_EXPRESSION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n PL/SQL')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''EXPRESSION'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una expresi\00F3n PL/SQL que produzca un valor utilizado como origen para este valor de par\00E1metro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465652780917847.4001)
,p_name=>'P4083_VALUE_PLSQL_FUNC_BODY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''FUNCTION_BODY'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelva un valor utilizado como origen para este valor de par\00E1metro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465784271917848.4001)
,p_name=>'P4083_VALUE_COLLECTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Recopilaci\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''COLLECTION'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el nombre de la recopilaci\00F3n. El origen para este valor de par\00E1metro se basar\00E1 en el valor de la columna CLOB de la primera fila de la recopilaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1465830105917849.4001)
,p_name=>'P4083_VALUE_PREFERENCE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preferencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''PREFERENCE'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la preferencia de usuario que se utilizar\00E1 como origen para este valor de par\00E1metro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2319907728209545.4001)
,p_name=>'P4083_VALUE_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'VALUE_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4437746057497227.4001)
,p_name=>'P4083_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4438165902497232.4001)
,p_name=>'P4083_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4438505627497237.4001)
,p_name=>'P4083_WEB_SRC_PARAM_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_prompt=>'Nombre'
,p_source=>'WEB_SRC_PARAM_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_flow_web_src_params'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4438988247497237.4001)
,p_name=>'P4083_SHARED_LOV_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'SHARED_LOV_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4439301963497237.4001)
,p_name=>'P4083_VALUE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_prompt=>'Tipo'
,p_source=>'VALUE_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_COMP_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_api.id(358243382603181986.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el modo de relleno de datos del par\00E1metro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4439708773497237.4001)
,p_name=>'P4083_VALUE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'VALUE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4440133478497238.4001)
,p_name=>'P4083_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4440546118497238.4001)
,p_name=>'P4083_LAST_UPDATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'LAST_UPDATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4440982335497238.4001)
,p_name=>'P4083_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4441323230497239.4001)
,p_name=>'P4083_CREATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_item_source_plug_id=>wwv_flow_api.id(4437481313497226.4001)
,p_source=>'CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2320083998209546.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4083_VALUE_LANGUAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P4083_VALUE_TYPE in ( ''EXPRESSION'', ''FUNCTION_BODY'' ) then wwv_flow_code_exec.c_plsql end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4467972988653216.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4083_VALUE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return case :P4083_VALUE_TYPE ',
'           when ''STATIC'' then        :P4083_VALUE_STATIC',
'           when ''ITEM'' then          :P4083_VALUE_ITEM',
'           when ''SQL_QUERY'' then     :P4083_VALUE_SQL',
'           when ''EXPRESSION'' then    :P4083_VALUE_PLSQL_EXPRESSION',
'           when ''FUNCTION_BODY'' then :P4083_VALUE_PLSQL_FUNC_BODY',
'           when ''COLLECTION'' then    :P4083_VALUE_COLLECTION',
'           when ''PREFERENCE'' then    :P4083_VALUE_PREFERENCE',
'       end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468007595653217.4001)
,p_validation_name=>'P4083_VALUE_STATIC not null'
,p_validation_sequence=>10
,p_validation=>'P4083_VALUE_STATIC'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'STATIC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465248613917843.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468195404653218.4001)
,p_validation_name=>'P4083_VALUE_ITEM not null'
,p_validation_sequence=>20
,p_validation=>'P4083_VALUE_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'ITEM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465382459917844.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468258796653219.4001)
,p_validation_name=>'P4083_VALUE_SQL not null'
,p_validation_sequence=>30
,p_validation=>'P4083_VALUE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465412992917845.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468349540653220.4001)
,p_validation_name=>'P4083_VALUE_PLSQL_EXPRESSION not null'
,p_validation_sequence=>40
,p_validation=>'P4083_VALUE_PLSQL_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'PLSQL_EXPRESSION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465580604917846.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468439281653221.4001)
,p_validation_name=>'P4083_VALUE_PLSQL_FUNC_BODY not null'
,p_validation_sequence=>50
,p_validation=>'P4083_VALUE_PLSQL_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'PLSQL_FUNCTION_BODY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465652780917847.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468559596653222.4001)
,p_validation_name=>'P4083_VALUE_COLLECTION not null'
,p_validation_sequence=>60
,p_validation=>'P4083_VALUE_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'COLLECTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465784271917848.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4468609984653223.4001)
,p_validation_name=>'P4083_VALUE_PREFERENCE not null'
,p_validation_sequence=>70
,p_validation=>'P4083_VALUE_PREFERENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'PREFERENCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(4447119598497250.4001)
,p_associated_item=>wwv_flow_api.id(1465830105917849.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4445239075497245.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4445185941497245.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4446021760497248.4001)
,p_event_id=>wwv_flow_api.id(4445239075497245.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1465953680917850.4001)
,p_name=>'VALUE TYPE CHANGE - HIDE ALL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4466478432653201.4001)
,p_event_id=>wwv_flow_api.id(1465953680917850.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_STATIC,P4083_VALUE_ITEM,P4083_VALUE_SQL,P4083_VALUE_PLSQL_EXPRESSION,P4083_VALUE_PLSQL_FUNC_BODY,P4083_VALUE_COLLECTION,P4083_VALUE_PREFERENCE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4466547127653202.4001)
,p_name=>'VALUE TYPE CHANGE = STATIC'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4466640786653203.4001)
,p_event_id=>wwv_flow_api.id(4466547127653202.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_STATIC'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4466755893653204.4001)
,p_name=>'VALUE TYPE CHANGE = ITEM'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4466897578653205.4001)
,p_event_id=>wwv_flow_api.id(4466755893653204.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_ITEM'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4466912660653206.4001)
,p_name=>'VALUE TYPE CHANGE = SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4467022298653207.4001)
,p_event_id=>wwv_flow_api.id(4466912660653206.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4467147319653208.4001)
,p_name=>'VALUE TYPE CHANGE = EXPRESSION'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXPRESSION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4467239361653209.4001)
,p_event_id=>wwv_flow_api.id(4467147319653208.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_PLSQL_EXPRESSION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4467335536653210.4001)
,p_name=>'VALUE TYPE CHANGE = FUNCTION BODY'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNCTION_BODY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4467484037653211.4001)
,p_event_id=>wwv_flow_api.id(4467335536653210.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_PLSQL_FUNC_BODY'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4467511307653212.4001)
,p_name=>'VALUE TYPE CHANGE = COLLECTION'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COLLECTION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4467647234653213.4001)
,p_event_id=>wwv_flow_api.id(4467511307653212.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_COLLECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4467789725653214.4001)
,p_name=>'VALUE TYPE CHANGE = PREFERENCE'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PREFERENCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4467858881653215.4001)
,p_event_id=>wwv_flow_api.id(4467789725653214.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_PREFERENCE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4448385987497251.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(4437481313497226.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Edit REST Source Parameter Values'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4448720632497251.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4447940845497251.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(4437481313497226.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit REST Source Parameter Values'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04100
begin
wwv_flow_api.create_page(
 p_id=>4100.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Elementos de Aplicaci\00F3n')
,p_step_title=>unistr('Elementos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(337416713.4001)
,p_plug_name=>unistr('Elementos de Aplicaci\00F3n')
,p_region_css_classes=>'a-Region--flush a-Region--stacked a-Region--sideRegion a-Region--padded'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice elementos de aplicaci\00F3n para mantener el estado de la sesi\00F3n. Los elementos de aplicaci\00F3n se pueden definir mediante c\00E1lculos o procesos, o bien transfiriendo valores en una URL. Utilice los c\00E1lculos "En nueva instancia" para definir el va')
||unistr('lor de los elementos una vez para una sesi\00F3n. Utilice elementos de aplicaci\00F3n para mantener el estado de la sesi\00F3n que no se muestra ni es espec\00EDfico de ninguna p\00E1gina.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-application-level-items.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_column_width=>' '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3727517093871356.4001)
,p_plug_name=>unistr('Elementos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4100a */',
'       name,',
'       scope,',
'       ''icon-sc-app-item'' ICON,',
'       replace(name,''_'','' '') alt,',
'       ''f?p=4000:4303:''||:flow_SESSION||''::::F4000_P4303_ID:''||id link,',
'       wwv_flow_computation.get_computation_points( :FB_FLOW_ID, name ) as comps,',
'       id,',
'       (select count(*) ',
'        from wwv_flow_computations ',
'        where security_group_id = :flow_security_group_id and ',
'              flow_id = :fb_flow_id and',
'              name = computation_item) application_computations,',
'       (select count(*) ',
'        from wwv_flow_step_computations ',
'        where security_group_id = :flow_security_group_id and ',
'              flow_id = :fb_flow_id and',
'              name = computation_item) page_computations,',
'       (select count(*)',
'        from WWV_FLOW_PROCESSING',
'        where security_group_id = :flow_security_group_id and ',
'              flow_id = :fb_flow_id and',
'              instr(upper(sys.dbms_lob.substr(',
'              PROCESS_SQL_CLOB,4000,1)),',
'              '':''||upper(name)) > 0) application_processes,',
'       (select count(*)',
'        from WWV_FLOW_STEP_PROCESSING',
'        where security_group_id = :flow_security_group_id and ',
'              flow_id = :fb_flow_id and',
'              instr(upper(sys.dbms_lob.substr(',
'              PROCESS_SQL_CLOB,4000,1)),',
'              '':''||upper(name)) > 0) page_processes,',
'       nvl(LAST_UPDATED_BY,created_by) last_updated_by,',
'       nvl(last_updated_on,created_on) last_updated,',
'       PROTECTION_LEVEL,',
'       escape_on_http_output',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3727618522871356.4001)
,p_name=>'Application Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('En esta aplicaci\00F3n no existen elementos de nivel de aplicaci\00F3n.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3727827243871363.4001)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.::F4000_P4303_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3728228054871365.4001)
,p_db_column_name=>'COMPS'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>'Calculado en'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3728324116871365.4001)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3728031846871364.4001)
,p_db_column_name=>'ALT'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Alternativo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3728125803871364.4001)
,p_db_column_name=>'LINK'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3731417624925492.4001)
,p_db_column_name=>'APPLICATION_COMPUTATIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3731813946933809.4001)
,p_db_column_name=>'PAGE_COMPUTATIONS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('C\00E1lculos de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3732521611964395.4001)
,p_db_column_name=>'APPLICATION_PROCESSES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Procesos de Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3733114816971915.4001)
,p_db_column_name=>'PAGE_PROCESSES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Procesos de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3735108283998409.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3735205133998410.4001)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(25715705946585298.4001)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Nivel de Protecci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(109261519627066371)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2373191992105007.4001)
,p_db_column_name=>'ESCAPE_ON_HTTP_OUTPUT'
,p_display_order=>23
,p_column_identifier=>'P'
,p_column_label=>'Caracteres Especiales de Escape'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(211620524264413267.4001)
,p_db_column_name=>'SCOPE'
,p_display_order=>33
,p_column_identifier=>'N'
,p_column_label=>unistr('\00C1mbito')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(211617631947367477)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(646379152524037984.4001)
,p_db_column_name=>'ICON'
,p_display_order=>43
,p_column_identifier=>'O'
,p_column_label=>'ICONO'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(22760811789529877.4001)
,p_name=>'Reciente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_css_classes=>'a-Region--flush a-Region--stacked a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name p, id',
'from WWV_FLOW_ITEMS',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.set_region_column_width(
 p_id=>wwv_flow_api.id(22760811789529877.4001)
,p_plug_column_width=>' '
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22761020113529878.4001)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4303:&SESSION.::&DEBUG.::FB_FLOW_ID,F4000_P4303_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(22761126515529878.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47809708314106355.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47807005066095922.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188872800198792603.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3727517093871356.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:4100,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3730112944886257.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(3727517093871356.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:4303::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1966713122.4001)
,p_branch_action=>'4100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522454896.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4100'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21875143921.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4303_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_PAGE_ITEM'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
prompt --application/pages/page_04101
begin
wwv_flow_api.create_page(
 p_id=>4101.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_step_title=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(344696366.4001)
,p_plug_name=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice los c\00E1lculos de aplicaci\00F3n para asignar valores a elementos de p\00E1gina y aplicaci\00F3n.<p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/understanding-application-computations.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47828322653545689.4001)
,p_plug_name=>'navigation'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(47827519966525945.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47836101365827708.4001)
,p_plug_name=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4101a */',
'computation_sequence,',
'computation_point a,',
'computation_item,',
'computation_type b,',
'(select p.patch_name',
'   from wwv_flow_patches p',
'  where p.id = c.required_patch',
'    and p.security_group_id = c.security_group_id',
' union all',
' select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',patch_name)|| ''} '' ',
'        patch_name ',
'   from wwv_flow_patches p',
'  where 0-p.id = c.required_patch',
'    and p.security_group_id = c.security_group_id ) as required_patch,',
'compute_when,',
'substr(computation,1,100) computation,',
'id,',
'''icon-sc-app-computation'' icon,',
'''f?p=4000:4304:''||:flow_session||''::::F4000_P4304_ID:''||id link,',
'    nvl(last_updated_by,created_by) last_updated_by,',
'    nvl(last_updated_on,created_on) last_updated_on',
' from wwv_flow_computations c',
'where flow_id = :fb_flow_id',
'  and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47836204953827708.4001)
,p_name=>'Application Computations'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#COMPUTATION_ITEM#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47836615965827723.4001)
,p_db_column_name=>'COMPUTATION_ITEM'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.::F4000_P4304_ID:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47836404739827721.4001)
,p_db_column_name=>'COMPUTATION_SEQUENCE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47836528038827722.4001)
,p_db_column_name=>'A'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Punto'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(48425308522403722)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47836730424827724.4001)
,p_db_column_name=>'B'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84926512995804334)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47837214412827726.4001)
,p_db_column_name=>'ID'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47837031613827725.4001)
,p_db_column_name=>'COMPUTE_WHEN'
,p_display_order=>9
,p_column_identifier=>'G'
,p_column_label=>'Calcular cuando'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47837109389827726.4001)
,p_db_column_name=>'COMPUTATION'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>unistr('C\00E1lculo')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47837311524827727.4001)
,p_db_column_name=>'ICON'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47837421584827728.4001)
,p_db_column_name=>'LINK'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47839810485863843.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47839921815863845.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47999803968158806.4001)
,p_db_column_name=>'REQUIRED_PATCH'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188878423026922160.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47836101365827708.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.:4101,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90835422810354181.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(47836101365827708.4001)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:4304::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1970713124.4001)
,p_branch_action=>'4101'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4797179695.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4101'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
end;
/
prompt --application/pages/page_04110
begin
wwv_flow_api.create_page(
 p_id=>4110.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Listas de Valores'
,p_step_title=>'Listas de Valores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(394086908.4001)
,p_plug_name=>'Lista de Valores'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se pueden utilizar tanto elementos de p\00E1gina como campos de informe para hacer referencia a una lista de valores. La lista de valores controla los valores mostrados y limita la selecci\00F3n del usuario. Las listas de valores pueden ser est\00E1ticas (bas')
||unistr('adas en los valores introducidos) o din\00E1micas (basadas en distintos or\00EDgenes de datos de la base de datos local, del SQL activado para REST o del origen de datos de REST).</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/creating-lists-of-values-at-the-application-level.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1548308438182178.4001)
,p_plug_name=>'Listas de Valores'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4110a */',
'       ''icon-sc-lov'' icon_class,',
'       ''f?p=4000:4111:''||:app_session||''::NO:4111:F4000_P4111_ID:''||ID edit_link,',
'       replace(replace(lov_name,''_'','' ''),''.'','' '') icon_title,',
'       ID,',
'       flow_id, ',
'       lov_name,',
'       case location',
'           when ''LOCAL'' then ',
'               case when source_type <> ''LEGACY_SQL'' then ',
'                   system_message."LOCAL" ',
'               else ',
'                   system_message."LEGACY_SQL" ',
'               end',
'           when ''REMOTE''     then system_message."REST_ENABLED_SQL"',
'           when ''WEB_SOURCE'' then system_message."WEB_SOURCE"',
'           when ''STATIC''     then system_message."STATIC"',
'       end lov_type,',
'       nvl(last_updated_on,created_on) LAST_UPDATED_ON,',
'       last_updated_by,',
'       decode(substr(lov_query,1,1),''.'','''',',
'         decode(substr(upper(lov_query),1,6),''STATIC'','''',substr(lov_query,1,3500)))',
'       LOV_QUERY,',
'       case when substr(lov_query,1,1) = ''.'' then',
'           (select count(*)',
'              from   wwv_flow_list_of_values_data',
'             where  lov_id = l.id and security_group_id = :flow_security_group_id)',
'       end entry_count,',
'       case when l.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_lists_of_values$',
'                         where id                = l.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_lists_of_values$',
'          where reference_id      = l.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers',
'from   WWV_FLOW_LISTS_OF_VALUES$ l,',
'(select ',
'wwv_flow_lang.system_message(''F4000.STATIC'')           "STATIC",',
'wwv_flow_lang.system_message(''F4000.LOCAL'')            "LOCAL",',
'wwv_flow_lang.system_message(''F4000.LEGACY_SQL'')       "LEGACY_SQL",',
'wwv_flow_lang.system_message(''F4000.REST_ENABLED_SQL'') "REST_ENABLED_SQL",',
'wwv_flow_lang.system_message(''F4000.WEB_SOURCE'')       "WEB_SOURCE"',
'from dual) system_message',
'where  flow_id = :FB_FLOW_ID and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1548412223182178.4001)
,p_name=>'Lists of Values'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>'No se ha encontrado ninguna lista de valores.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1548702627182185.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1548905125182185.4001)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1549021708182185.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1549113598182186.4001)
,p_db_column_name=>'LOV_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Nombre'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#LOV_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1549225783182186.4001)
,p_db_column_name=>'LOV_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1549419300182186.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1549500296182186.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1551205210206584.4001)
,p_db_column_name=>'LOV_QUERY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Consulta'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'STRING'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1556001972271876.4001)
,p_db_column_name=>'ENTRY_COUNT'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Recuento de Entradas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340561708125198327.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>22
,p_column_identifier=>'S'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340561864259198328.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>32
,p_column_identifier=>'T'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656703198583098697.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>42
,p_column_identifier=>'P'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656707978041167011.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>52
,p_column_identifier=>'Q'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(115612724617589113.4001)
,p_name=>'Editado Recientemente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(replace(replace(LOV_NAME,''_'','' ''),''.'','' '')) n, id',
'from WWV_FLOW_LISTS_OF_VALUES$',
'where last_updated_on is not null ',
'and flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by LAST_UPDATED_ON DESC'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se ha encontrado ninguna lista de valores editada recientemente.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115616313667595495.4001)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4111:&SESSION.::&DEBUG.:4111:F4000_P4111_ID:#ID#'
,p_column_linktext=>'#N#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(115620702370601654.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203038606023376563.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(203029530177365353.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188987204899959490.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1548308438182178.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.:4110,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30370320039998454.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1548308438182178.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:603:&SESSION.::&DEBUG.:603:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30370505625003721.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1548308438182178.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:4004,4007,4014,137,138,139,4080,4081,4082::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(308985838.4001)
,p_branch_action=>'4110'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(130828990069.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4110'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(309985839.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4111_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9261215880081440.4001)
,p_name=>'Dialog Closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1548308438182178.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9261328238081441.4001)
,p_event_id=>wwv_flow_api.id(9261215880081440.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'TRIGGERING_ELEMENT'
);
end;
/
prompt --application/pages/page_04111
begin
wwv_flow_api.create_page(
 p_id=>4111.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Listas de Valores con Nombre'
,p_step_title=>'Editar Lista de Valores'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Used to hold variable values for page Dynamic Actions',
'var p4111 = {};',
'',
'// Store column mapping values, so we can try to set them back again following a refresh',
'function storeColumnMappings(){',
'    p4111.columnMappingValues = {',
'        ''P4111_RETURN_COLUMN'':       apex.item( ''P4111_RETURN_COLUMN'' ).getValue(),',
'        ''P4111_DISPLAY_COLUMN'':      apex.item( ''P4111_DISPLAY_COLUMN'' ).getValue(),',
'        ''P4111_GROUP_COLUMN'':        apex.item( ''P4111_GROUP_COLUMN'' ).getValue(),',
'        ''P4111_ICON_COLUMN'':         apex.item( ''P4111_ICON_COLUMN'' ).getValue(),',
'        ''P4111_DEFAULT_SORT_COLUMN'': apex.item( ''P4111_DEFAULT_SORT_COLUMN'' ).getValue(),',
'        ''P4111_ORACLE_TEXT_COLUMN'':  apex.item( ''P4111_ORACLE_TEXT_COLUMN'' ).getValue(),        ',
'    };',
'}',
'',
'// Set column mapping value',
'function setColumnMappings( pItemName ){',
'    var lValue = p4111.columnMappingValues[ pItemName ];',
'    if ( lValue ) {',
'        apex.item( pItemName ).setValue( lValue );',
'    }',
'}',
'',
'// Checks if the current source definition is a valid one (has everything defined that needs to be, to get column information).',
'function isValidSourceDefinition(){ ',
'    var lLocation           = apex.item( ''P4111_LOCATION'' ),',
'        lSourceType         = apex.item( ''P4111_SOURCE_TYPE'' ),',
'        lLovQuerySQL        = apex.item( ''P4111_LOV_QUERY_SQL'' ),',
'        lLovQueryFunc       = apex.item( ''P4111_LOV_QUERY_FUNC_BODY'' ),',
'        lQueryTable         = apex.item( ''P4111_QUERY_TABLE'' ),',
'        lRemoteSourceType   = apex.item( ''P4111_REMOTE_SOURCE_TYPE'' ),',
'        lRemoteSQL          = apex.item( ''P4111_REMOTE_SQL'' ),',
'        lRemoteTableName    = apex.item( ''P4111_REMOTE_TABLE_NAME'' ),',
'        lWebSrcModule       = apex.item( ''P4111_WEB_SRC_MODULE_ID'' );',
'    ',
'    switch ( lLocation.getValue() ) {',
'        case ''LOCAL'':      ',
'            switch ( lSourceType.getValue() ) {',
'                case ''SQL'':',
'                    return !lLovQuerySQL.isEmpty();',
'                    break;',
'                case ''FUNC_BODY_RETURNING_SQL'':',
'                    return !lLovQueryFunc.isEmpty();',
'                    break;',
'                case ''TABLE'':',
'                    return !lQueryTable.isEmpty();',
'            };',
'            break;',
'        case ''REMOTE'':',
'            switch ( lRemoteSourceType.getValue() ) {',
'                case ''SQL'':',
'                    return !lRemoteSQL.isEmpty();',
'                    break;',
'                case ''TABLE'':',
'                    return !lRemoteTableName.isEmpty();',
'            };',
'            break;',
'        case ''WEB_SOURCE'':',
'                return !lWebSrcModule.isEmpty();',
'            break;',
'    }',
'    ',
'    return false;',
'}'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(395110922.4001)
,p_plug_name=>'Lista de Valores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Las listas de valores pueden ser est\00E1ticas, con valores de visualizaci\00F3n y de retorno codificados, o din\00E1micas, basadas en distintos or\00EDgenes de datos. Se soportan los or\00EDgenes de datos de la base de datos local, del SQL activado para REST y del orig')
||'en de datos de REST.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(396113952.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:L:L:L'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:NO'
,p_plug_query_number_formats=>':::::'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(397115560.4001)
,p_plug_name=>'Lista de Valores: &P4111_N.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(63176833274.4001)
,p_name=>unistr('Origen: Valores Est\00E1ticos')
,p_region_name=>'SRC'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       lov_disp_sequence, ',
'       substr(lov_disp_value,1,100) lov_disp_value, ',
'       lov_return_value, ',
'       decode(lov_disp_cond_type,null,null,''<span class="a-Icon icon-check"></span>'') lov_disp_cond_type,',
'       last_updated_on',
'from   wwv_flow_list_of_values_data',
'where  lov_id = :F4000_P4111_ID',
'  and  flow_id = :FB_FLOW_ID',
'  and  security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'NEVER'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'&nbsp;'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932666891452561018.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48658118900771489.4001)
,p_query_column_id=>2
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48658227777771489.4001)
,p_query_column_id=>3
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Mostrar'
,p_column_link=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:RP:F4000_P4113_ID:#ID#:'
,p_column_linktext=>'#LOV_DISP_VALUE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48658309251771489.4001)
,p_query_column_id=>4
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Devolver'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48658432295771489.4001)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISP_COND_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(113978927691693005.4001)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>6
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1483115269307020.4001)
,p_plug_name=>unistr('Columnas de visualizaci\00F3n adicionales')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>unistr('Se pueden definir columnas de visualizaci\00F3n adicionales para los tipos de elementos que soporten varias columnas de visualizaci\00F3n, como las listas de valores emergentes. En los tipos de elementos que no soporten varias columnas, estas se ignorar\00E1n. A')
||unistr('l agregar columnas de visualizaci\00F3n adicionales, garantice que la columna de devoluci\00F3n se incluye en la lista de columnas. La columna de devoluci\00F3n se puede definir en no visible y no apta para la b\00FAsqueda si no desea que se muestre a los usuarios.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9499495849275742.4001)
,p_plug_name=>unistr('Grupo de influencia de columnas de visualizaci\00F3n adicionales')
,p_region_name=>'COL_IG'
,p_parent_plug_id=>wwv_flow_api.id(1483115269307020.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       n002 display_sequence,',
'       c001 column_name, ',
'       c002 heading,',
'       c003 format_mask,',
'       c004 data_type,',
'       c005 is_visible,',
'       c006 is_searchable,',
'       c007 column_comment,',
'       seq_id',
'  from apex_collections',
' where collection_name = ''LOV_COL_INFO'''))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(9499648783275744.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(9499785522275745.4001)
,p_name=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Nombre de Columna'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(9499841474275746.4001)
,p_name=>'HEADING'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HEADING'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Cabecera'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>60
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(9499995556275747.4001)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>10
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>10
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(9500146418275749.4001)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('M\00E1scara de Formato')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>60
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(9500255407275750.4001)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Tipo de Dato'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(20213169868919110.4001)
,p_name=>'ROW_ACTIONS'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>1
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(20996402546632603.4001)
,p_name=>'IS_VISIBLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_VISIBLE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Visible'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(21123426452823701.4001)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>140
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(23197628206325501.4001)
,p_name=>'IS_SEARCHABLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_SEARCHABLE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>unistr('Apto para B\00FAsqueda')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(23197949678325504.4001)
,p_name=>'COLUMN_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_COMMENT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Comentario de Columna'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_width=>60
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(9499596054275743.4001)
,p_internal_uid=>9499596054275743
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>unistr('No se han definido columnas de visualizaci\00F3n adicionales.')
,p_show_toolbar=>true
,p_toolbar_buttons=>'RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'HTML'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20215412492919133.4001)
,p_plug_name=>unistr('Asignaci\00F3n de Columna')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33426411524290175.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>300
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_LISTS_OF_VALUES$'
,p_attribute_02=>'LOV_NAME'
,p_attribute_03=>'F4000_P4111_ID'
,p_attribute_04=>'F4000_P4111_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_LOV'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46251304866678998.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202306103707329518.4001)
,p_plug_name=>'Origen'
,p_region_name=>'SRC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists_of_values$',
' where id = :F4000_P4111_ID ',
'   and location <> ''STATIC''',
'union',
'select 1 ',
'  from dual ',
' where :F4000_P4111_ID is null'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(399144664.4001)
,p_plug_name=>unistr('Ejemplo: Lista de valores din\00E1mica en funci\00F3n que devuelve SQL')
,p_parent_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Funci\00F3n que devuelve una consulta SQL con dos columnas:'),
'<pre>',
'if :MY_ITEM=''10'' then',
'    return ''SELECT ename, empno FROM emp WHERE depno = 10 ORDER BY 1'';',
'else',
'    return ''SELECT ename, empno FROM emp WHERE depno = :MY_ITEM ORDER BY 1'';',
'end if;',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73945327537305242.4001)
,p_plug_name=>'Origen de datos local'
,p_parent_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(73951063066307275.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4111_SOURCE_TYPE_HIDDEN'
,p_plug_display_when_cond2=>'LEGACY_SQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1461332165917804.4001)
,p_name=>unistr('Par\00E1metros de origen de REST')
,p_parent_plug_id=>wwv_flow_api.id(73951063066307275.4001)
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id,',
'       p.name,',
'       p.is_query_param,',
'       cp.value_type,',
'       cp.value',
'  from wwv_flow_web_src_comp_params cp,',
'       wwv_flow_web_src_params p',
' where p.id = cp.web_src_param_id',
'   and cp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and cp.flow_id = nv(''FB_FLOW_ID'')',
'   and cp.shared_lov_id = :F4000_P4111_ID',
' order by p.name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = nv(''FB_FLOW_ID'')',
'   and shared_lov_id     = :F4000_P4111_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No hay ning\00FAn par\00E1metro definido para el origen de datos de REST seleccionado.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1461400182917805.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4083:&SESSION.::&DEBUG.:RP,4083:P4083_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil" alt="Edit #NAME#">'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1463021423917821.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(510295765939814531.4001)
,p_query_column_id=>3
,p_column_alias=>'IS_QUERY_PARAM'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Usar para b\00FAsqueda')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1462438593917815.4001)
,p_query_column_id=>4
,p_column_alias=>'VALUE_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(358243382603181986)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1462508157917816.4001)
,p_query_column_id=>5
,p_column_alias=>'VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Valor'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20215619883919135.4001)
,p_plug_name=>'Atributos avanzados de origen de datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(73951063066307275.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(75743329779916863.4001)
,p_plug_name=>'SQL remoto'
,p_parent_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4111_SOURCE_TYPE_HIDDEN'
,p_plug_display_when_cond2=>'LEGACY_SQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20212831971919107.4001)
,p_plug_name=>unistr('Almacenamiento en cach\00E9 remoto')
,p_parent_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(125268524262083710.4001)
,p_plug_name=>unistr('Ejemplo: Listas de Valores Din\00E1micas Basadas en Consultas SQL')
,p_parent_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ejemplo 1 (con variable de enlace): ',
'<pre>',
'SELECT ename d, empno r',
'FROM  emp ',
'WHERE depno = :my_item ',
'ORDER BY 1',
'</pre>',
unistr('Ejemplo 2 (la consulta contiene una consulta en l\00EDnea, se debe asegurar primero de que la cl\00E1usula FROM de la sentencia SQL no forma parte de la consulta en l\00EDnea):'),
'<pre>',
'SELECT c1, c2 ',
'  FROM ',
'(SELECT decode(',
'         (SELECT count(*) ',
'            FROM emp2 b ',
'           WHERE a.ename = b.ename), ',
'          1, ''+'' || ename, ename) c1, ',
'         ename c2 ',
'   FROM emp a)</pre>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(233330927108902814.4001)
,p_name=>'Uso'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id as page_id,',
'       to_char(flow_step_id)||''. ''||wwv_flow_escape.html(substr(name,1,15)) as page',
'  from wwv_flow_step_items ',
' where flow_id = :fb_flow_id ',
'   and named_lov = (select max(lov_name) from wwv_flow_lists_of_values$ where id = :F4000_P4111_ID)',
' union',
'select a.page_id,',
'       to_char(a.page_id)||''. ''||wwv_flow_escape.html(substr(a.plug_name,1,15)) as page',
'  from wwv_flow_page_plugs a,',
'       wwv_flow_region_report_column b,',
'       wwv_flow_lists_of_values$ c',
' where a.id = b.region_id',
'   and c.id = b.named_lov',
'   and a.flow_id = :fb_flow_id',
'   and c.id = :F4000_P4111_ID',
' union',
'select r.page_id,',
'       to_char(r.page_id)||''. ''||wwv_flow_escape.html(substr(r.plug_name,1,15)) as page',
'  from wwv_flow_worksheet_columns c,',
'       wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r',
' where c.flow_id       = to_number(:FB_FLOW_ID)',
'   and c.rpt_named_lov = to_number(:F4000_P4111_ID)',
'   and w.id            = c.worksheet_id',
'   and r.id            = w.region_id',
' union',
'select a.page_id,',
'       to_char(a.page_id)||''. ''||wwv_flow_escape.html(substr(a.plug_name,1,15)) as page',
'  from wwv_flow_page_plugs a,',
'       wwv_flow_region_columns b,',
'       wwv_flow_lists_of_values$ c',
' where a.id = b.region_id',
'   and ( b.lov_id = c.id or b.filter_lov_id = c.id )',
'   and a.flow_id = :fb_flow_id',
'   and c.id = :F4000_P4111_ID',
' order by page_id, page'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No se ha utilizado esta lista de valores.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932666743622561017.4001)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(233331531178902828.4001)
,p_query_column_id=>2
,p_column_alias=>'PAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP,:FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(350215855993563251.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>400
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615278327394452603.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>410
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LISTS_OF_VALUES$',
'where id = :F4000_P4111_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4111_ID,',
'      p_component_type => ''List of Values'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(712080000591813402.4001)
,p_plug_name=>unistr('Origen: Valores Est\00E1ticos')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       lov_id,',
'       lov_disp_sequence, ',
'       lov_disp_value, ',
'       lov_template,',
'       lov_return_value, ',
'       decode(lov_disp_cond_type,null,null,''<span class="a-Icon icon-check"></span>'') lov_disp_cond_type,',
'       last_updated_on',
'from   wwv_flow_list_of_values_data',
'where  lov_id = :F4000_P4111_ID',
'  and  flow_id = :FB_FLOW_ID',
'  and  security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'F4000_P4111_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_lists_of_values$',
' where id = to_number(:F4000_P4111_ID)',
'   and location <> ''STATIC''',
' union',
'select null',
'  from sys.dual',
' where :F4000_P4111_ID is null'))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(109877556624242514.4001)
,p_name=>'LOV_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_TEMPLATE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Plantilla de globalizaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_height=>6
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567418956578994731.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567419076212994732.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567419448188994736.4001)
,p_name=>'LOV_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_DISP_COND_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Condicional'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'HTML'
,p_enable_filter=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(567419657230994738.4001)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Actualizado'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(712080217605813404.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:RP:F4000_P4113_ID:&ID.'
,p_link_text=>'<span class="a-Icon icon-edit" title="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(712080320008813405.4001)
,p_name=>'LOV_DISP_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_DISP_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Secuencia'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(712080489276813406.4001)
,p_name=>'LOV_DISP_VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_DISP_VALUE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Mostrar'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(712080547723813407.4001)
,p_name=>'LOV_RETURN_VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_RETURN_VALUE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Devolver'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(714513527369810143.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(714513644443810144.4001)
,p_name=>'LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4111_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(712080143327813403.4001)
,p_internal_uid=>712080143327813403
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_max_row_count=>100000
,p_show_nulls_as=>'-'
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202117306273446159.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33426411524290175.4001)
,p_button_name=>'PUBLISH_LOV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Lista de Valores'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4111_ID.,&APP_PAGE_ID.,LOV:'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_lists_of_values$',
'where reference_id = :F4000_P4111_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(202120612291457307.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33426411524290175.4001)
,p_button_name=>'COPY_LOV'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Lista de Valores'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_lists_of_values$',
'',
'where id = :F4000_P4111_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10345212253298998.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(712080000591813402.4001)
,p_button_name=>'CREATE_STATIC_VALUE'
,p_button_static_id=>'CREATE_STATIC_VALUE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Crear Entrada'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:4113::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9496177960275709.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_button_name=>'CONVERT_LEGACY_SQL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Convertir SQL heredado'
,p_button_position=>'HELP'
,p_button_condition=>'P4111_SOURCE_TYPE_HIDDEN'
,p_button_condition2=>'LEGACY_SQL'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(290985826.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(397115560.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63589945603.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(397115560.4001)
,p_button_name=>'CREATE_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Crear Lista de Valores Est\00E1tica')
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4111_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(87511229484617914.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(397115560.4001)
,p_button_name=>'CONVERT_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Convertir en Est\00E1tico')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_lists_of_values$ where id=:F4000_P4111_ID and',
'substr(upper(ltrim(lov_query)),1,6)=''STATIC'''))
,p_button_condition_type=>'EXISTS'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(398127928.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(397115560.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Lista de Valores de Consulta'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4111_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(291985826.4001)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(397115560.4001)
,p_button_name=>'Delete'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4111_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(292985826.4001)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(397115560.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4111_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20999087932632629.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1483115269307020.4001)
,p_button_name=>'SELECT_ADDITIONAL_COLUMNS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary:a-Button--gapRight:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Seleccionar Columnas'
,p_button_position=>'RIGHT_OF_TITLE'
,p_button_redirect_url=>'f?p=&APP_ID.:4082:&SESSION.::&DEBUG.:RP,4082::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(202121001451457313.4001)
,p_branch_name=>'Go To Page 4111'
,p_branch_action=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(202120612291457307.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9496383543275711.4001)
,p_branch_name=>'Go To Page 4111'
,p_branch_action=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CONVERT_LEGACY_SQL'',''REFRESH_COLUMN_INFO'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(294985827.4001)
,p_branch_name=>'Go To Page 4110'
,p_branch_action=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1504522732960740.4001)
,p_branch_name=>'Go To Page 4111'
,p_branch_action=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(292985826.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4111_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(295985827.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(296985827.4001)
,p_branch_action=>'4110'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Cancel'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(297985833.4001)
,p_name=>'F4000_P4111_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(396113952.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(299985834.4001)
,p_name=>'F4000_P4111_LOV_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(396113952.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'LOV_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(300985834.4001)
,p_name=>'P4111_LOV_QUERY_HIDDEN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'LOV_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1481401320307003.4001)
,p_name=>'P4111_SOURCE_POST_PROC_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de procesamiento posterior'
,p_source=>'SOURCE_POST_PROCESSING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov=>'.'||wwv_flow_api.id(601113045750817318.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione c\00F3mo procesar posteriormente los datos de origen de REST recuperados en la base de datos local.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1481681766307005.4001)
,p_name=>'P4111_SOURCE_POST_PROC_WHERE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cl\00E1usula where de procesamiento posterior')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'' ) ',
'then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1481905921307008.4001)
,p_name=>'P4111_SOURCE_POST_PROC_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta SQL de procesamiento posterior'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''SQL'' ) ',
'then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta SQL para transformar los datos recuperados del origen de datos de REST. Seleccione de la pseudotabla #APEX$SOURCE_DATA# y especifique las columnas disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1u')
||unistr('sula WITH SQL no est\00E1 soportada aqu\00ED.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1482059431307009.4001)
,p_name=>'P4111_SRC_POST_PROC_FUNC_BODY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cuerpo de la funci\00F3n de procesamiento posterior que devuelve una consulta SQL')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' ) ',
'then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un cuerpo de la funci\00F3n, donde la consulta SQL devuelta transforma los datos recuperados del origen de REST. La consulta SQL devuelta por el cuerpo de la funci\00F3n debe seleccionar de la pseudotabla #APEX$SOURCE_DATA# y leer las columnas dis')
||unistr('ponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1usula WITH SQL no est\00E1 soportada aqu\00ED.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4111_SRC_POST_PROC_FUNC_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1483438977307023.4001)
,p_name=>'P4111_HIDDEN_ADDITIONAL_COL_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1483115269307020.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1484196749307030.4001)
,p_name=>'P4111_LOCAL_WHERE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''TABLE'' then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1484201460307031.4001)
,p_name=>'P4111_WHERE_CLAUSE_HIDDEN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_WHERE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1484388646307032.4001)
,p_name=>'P4111_REMOTE_WHERE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''REMOTE'' and :P4111_SOURCE_TYPE_HIDDEN = ''TABLE'' then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1484575580307034.4001)
,p_name=>'P4111_GROUP_SORT_DIRECTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ASC'
,p_prompt=>unistr('Direcci\00F3n de Orden del Grupo')
,p_source=>'GROUP_SORT_DIRECTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SORT_DIRECTIONS'
,p_lov=>'.'||wwv_flow_api.id(601135878417900624.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina la direcci\00F3n de ordenaci\00F3n para la columna del grupo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1503825536956068.4001)
,p_name=>'P4111_RETURN_TO_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(395110922.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1511439672159230.4001)
,p_name=>'P4111_COMMENTS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(350215855993563251.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'LOV_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecer\00E1n nunca cuando se est\00E9 ejecutando la aplicaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1568830406713219.4001)
,p_name=>'P4111_LOV_QUERY_FUNC_LANG'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''FUNC_BODY_RETURNING_SQL'' then ',
'   return :P4111_FUNC_BODY_LANG_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1663011480963714.4001)
,p_name=>'P4111_USE_LOCAL_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Utilizar tabla de sincronizaci\00F3n')
,p_source=>'USE_LOCAL_SYNC_TABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_modules',
' where id                 = :P4111_WEB_SRC_MODULE_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and sync_table_name   is not null',
''))
,p_read_only_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Active esta opci\00F3n para utilizar la tabla local, que se configura en la secci\00F3n <strong>Sincronizaci\00F3n de REST</strong> del origen de datos de REST, en lugar de comunicarse con el servicio REST externo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1672964397329624.4001)
,p_name=>'P4111_SRC_POST_PROC_FUNC_LANG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_prompt=>'Idioma'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' ) ',
'then ',
'    return :P4111_FUNC_BODY_LANG_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2320180550209547.4001)
,p_name=>'P4111_FUNC_BODY_LANG_HIDDEN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FUNCTION_BODY_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4439479327967228.4001)
,p_name=>'P4111_LOV_QUERY_FUNC_BODY'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cuerpo de la funci\00F3n que devuelve SQL')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''FUNC_BODY_RETURNING_SQL'' then ',
'   return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>8000
,p_cHeight=>15
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Consulta SQL de lista de valores con el formato:',
'<pre>',
unistr('select [valor de visualizaci\00F3n], [valor de retorno]'),
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'Por ejemplo:',
'<pre>',
'select ename, empno ',
'  from emp ',
' where depno = :my_item ',
' order by 1',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4111_LOV_QUERY_FUNC_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9446885770950044.4001)
,p_name=>'P4111_LOCATION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Origen de Datos'
,p_source=>'LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9474354598187800.4001)
,p_name=>'P4111_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then ',
'    return :P4111_SOURCE_TYPE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(601107956819795211.4001)||'.'
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. La lista de valores puede estar basada en una tabla, en una consulta SQL o en un cuerpo de la funci\00F3n que devuelve una consulta SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9475606571187803.4001)
,p_name=>'P4111_QUERY_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario de Tabla/Vista'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return coalesce(:P4111_QUERY_OWNER_HIDDEN, wwv_flow_security.flow_owner(',
'        p_flow_id           => :FB_FLOW_ID,',
'        p_security_group_id => wwv_flow_security.g_security_group_id ));',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9476514751187804.4001)
,p_name=>'P4111_QUERY_TABLE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Tabla/Vista'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then ',
'    return :P4111_QUERY_TABLE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4111_QUERY_OWNER',
'   and :P4111_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P4111_QUERY_OWNER'
,p_ajax_items_to_submit=>'P4111_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9479941132189824.4001)
,p_name=>'P4111_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(73951063066307275.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Origen de Datos de REST'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9481590790191485.4001)
,p_name=>'P4111_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Servicio de SQL activado para REST'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9481940949191488.4001)
,p_name=>'P4111_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_SOURCE_TYPE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(601107956819795211.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. La lista de valores puede estar basada en tablas o consultas SQL. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9482874028191489.4001)
,p_name=>'P4111_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la lista de valores, por ejemplo:'),
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P4111_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9483702025191489.4001)
,p_name=>'P4111_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario de Tabla/Vista'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_QUERY_OWNER_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4111_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P4111_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear la lista de valores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9484614427191490.4001)
,p_name=>'P4111_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Tabla/Vista'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_QUERY_TABLE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4111_REMOTE_SERVER_ID, ''TABLE'', :P4111_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P4111_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P4111_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear una lista de valores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9496533107275713.4001)
,p_name=>'P4111_LOV_QUERY_SQL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Consulta SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN in (''SQL'',''LEGACY_SQL'') then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>8000
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Consulta SQL de lista de valores con el formato:',
'<pre>',
unistr('select [valor de visualizaci\00F3n], [valor de retorno]'),
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'Por ejemplo:',
'<pre>',
'select ename, empno ',
'  from emp ',
' where depno = :my_item ',
' order by 1',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11466741156432841.4001)
,p_name=>'P4111_EXTERNAL_FILTER_EXPR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Filtro Externo'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione una expresi\00F3n de filtro que se va a transferir al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto sin modificaciones. La sintaxis depende del tipo de origen de datos de REST. Por ejemplo, Oracle REST Data Services (O')
||'RDS) espera la sintaxis de JSON.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11466887559432842.4001)
,p_name=>'P4111_EXTERNAL_ORDER_BY_EXPR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20215619883919135.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Order by externo'
,p_source=>'EXTERNAL_ORDER_BY_EXPR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione un orden por expresi\00F3n que se va a transferir al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto sin modificaciones. La sintaxis depende del tipo de origen de datos de REST. Por ejemplo, Oracle REST Data Services (OR')
||'DS) espera la sintaxis de JSON.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11466961272432843.4001)
,p_name=>'P4111_REMOTE_SQL_CACHING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20212831971919107.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Cach\00E9')
,p_source=>'REMOTE_SQL_CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CACHING_MODE'
,p_lov=>'.'||wwv_flow_api.id(225840272947805161.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Desactivado'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione c\00F3mo puede el motor de Application Express almacenar datos en cach\00E9 en la base datos local. Si se puede utilizar el almacenamiento en cach\00E9, se representar\00E1 la lista de valores seg\00FAn los resultados almacenados en cach\00E9, en lugar de recuper')
||unistr('arlos de la base de datos remota. Los resultados almacenados en cach\00E9 mejorar\00E1n el rendimiento en gran medida, especialmente si hay latencia entre la base de datos local y la remota.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11467018910432844.4001)
,p_name=>'P4111_REMOTE_SQL_INVALIDATE_WHEN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20212831971919107.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Timeout de Cach\00E9')
,p_source=>'REMOTE_SQL_INVALIDATE_WHEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca cu\00E1ndo se deben invalidar los datos almacenados en cach\00E9.'),
'        Proporcione la cantidad de minutos o una cadena de calendario DBMS_SCHEDULER.',
unistr('        Para la cadena de calendario DBMS_SCHEDULER, puede definir que los datos almacenados en cach\00E9 se invaliden a la hora en punto, a medianoche o en cualquier otro punto en el tiempo espec\00EDfico recurrente.'),
unistr('        Consulte la documentaci\00F3n sobre DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING para obtener m\00E1s detalles.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11467490901432848.4001)
,p_name=>'P4111_OPTIMIZER_HINT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(73945327537305242.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Indicaci\00F3n de Optimizador')
,p_source=>'OPTIMIZER_HINT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la indicaci\00F3n de optimizador de Oracle, que se agrega a la sentencia superior al ejecutar la consulta SQL. Las indicaciones son instrucciones para el optimizador. Al escribir SQL, puede que ya conozca datos que el optimizador desconozca')
||unistr('. Gracias a las indicaciones, podr\00E1 tomar decisiones que normalmente toma el optimizador, y que pueden tener como consecuencia la selecci\00F3n de un plan que supone un costo mayor.</p>'),
'',
unistr('<p>Por ejemplo, si ya sabe que un \00EDndice es m\00E1s selectivo para ciertas consultas, podr\00E1 elegir un plan de ejecuci\00F3n m\00E1s eficaz que el plan que podr\00EDa elegir el optimizador. En tal caso, utilice las indicaciones para forzar al optimizador a utilizar e')
||unistr('l plan de ejecuci\00F3n \00F3ptimo.</p>'),
'',
'<p>Ejemplo:</p>',
unistr('<p>Al acceder a la tabla <code>employees</code>, trate de utilizar el \00EDndice <code>emp_department_ix</code>:</p>'),
'<pre>INDEX (employees emp_department_ix)</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19531770866272706.4001)
,p_name=>'P4111_AUTH_TEST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(75743329779916863.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return case ',
'    when wwv_flow_exec_remote.test_authentication( :P4111_REMOTE_SERVER_ID ) is null then ',
'        ''COMM_FAILURE''',
'    when not wwv_flow_exec_remote.test_authentication( :P4111_REMOTE_SERVER_ID ) then',
'        ''AUTH_FAILURE''',
'    when wwv_flow_exec_remote.test_authentication( :P4111_REMOTE_SERVER_ID ) then',
'        ''AUTH_PASSED''',
'    end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P4111_LOCATION'
,p_display_when2=>'REMOTE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20214151972919120.4001)
,p_name=>'P4111_RETURN_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Devolver'
,p_source=>'RETURN_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4111_LOCATION,',
'                  p_query_type             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_TABLE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                  when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                              end,             ',
'                  p_function_body          => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                              end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Defina la columna que se utilizar\00E1 como valor de retorno en la lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20216380459919142.4001)
,p_name=>'P4111_DISPLAY_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mostrar'
,p_source=>'DISPLAY_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4111_LOCATION,',
'                  p_query_type             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_TABLE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                  when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                              end,             ',
'                  p_function_body          => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                              end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL''     then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE''     then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Defina la columna que se utilizar\00E1 como valor de visualizaci\00F3n en la lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20216431316919143.4001)
,p_name=>'P4111_GROUP_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Grupo'
,p_source=>'GROUP_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4111_LOCATION,',
'                  p_query_type             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_TABLE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                  when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                              end,             ',
'                  p_function_body          => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                              end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE''     then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No definido -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Defina la columna que se utilizar\00E1 como valor del grupo en la lista de valores. Si el tipo de elemento lo soporta, este valor agrupar\00E1 la informaci\00F3n.</p>'),
unistr('<p>Nota: Los tipos de elementos nativos soportados actualmente en APEX son Lista de valores emergente con varias columnas mostradas y Lista de selecci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20216595069919144.4001)
,p_name=>'P4111_ICON_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icono'
,p_source=>'ICON_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4111_LOCATION,',
'                  p_query_type             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_TABLE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                  when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                              end,             ',
'                  p_function_body          => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                              end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE''     then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No definido -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Defina la columna que se utilizar\00E1 como columna de icono de la lista de valores. La columna tiene que proporcionar un valor que se corresponda con un nombre de clase CSS para el icono. Si el tipo de elemento lo soporta, se mostrar\00E1 un icono con la')
||' lista de valores.</p>',
unistr('<p>Nota: Actualmente en APEX el \00FAnico tipo de elemento nativo soportado es Lista de valores emergente.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20217141923919150.4001)
,p_name=>'P4111_DEFAULT_SORT_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ordenaci\00F3n por defecto')
,p_source=>'DEFAULT_SORT_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4111_LOCATION,',
'                  p_query_type             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_TABLE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                  when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                              end,             ',
'                  p_function_body          => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                              end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE''     then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Utilizar Ordenar por de la consulta'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Defina la columna que se utilizar\00E1 como columna de ordenaci\00F3n por defecto en la lista de valores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20996296341632601.4001)
,p_name=>'P4111_DEFAULT_SORT_DIRECTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ASC'
,p_prompt=>unistr('Direcci\00F3n de ordenaci\00F3n')
,p_source=>'DEFAULT_SORT_DIRECTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SORT_DIRECTIONS'
,p_lov=>'.'||wwv_flow_api.id(601135878417900624.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Defina la direcci\00F3n de ordenaci\00F3n para la ordenaci\00F3n por defecto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23201457449325539.4001)
,p_name=>'P4111_SOURCE_TYPE_HIDDEN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SOURCE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23201573811325540.4001)
,p_name=>'P4111_QUERY_OWNER_HIDDEN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23201601896325541.4001)
,p_name=>'P4111_QUERY_TABLE_HIDDEN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(202306103707329518.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_TABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35649405675079864.4001)
,p_name=>'F4000_P4111_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33426411524290175.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where reference_id is null',
'   and id = :F4000_P4111_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40783720601998105.4001)
,p_name=>'P4111_N'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(397115560.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'select LOV_NAME from WWV_FLOW_LISTS_OF_VALUES$ where id =  :F4000_P4111_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el nombre de la lista de valores'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(104438100298823819.4001)
,p_name=>'P4111_ORIG_LOV_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(396113952.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(202159909119506526.4001)
,p_name=>'F4000_P4111_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33426411524290175.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lista de Valores Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_LOVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_LOV'')||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(LOV_NAME) d, id r',
'from   wwv_flow_lists_of_values$',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique una suscripci\00F3n a otra lista de valores. Para cargar autom\00E1ticamente una nueva copia de la lista de valores maestra seleccionada,'),
'haga clic en <strong>Refrescar</strong>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NOT_ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(510295804664814532.4001)
,p_name=>'P4111_ORACLE_TEXT_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20215412492919133.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columna de Oracle Text'
,p_source=>'ORACLE_TEXT_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location               => :P4111_LOCATION,',
'                  p_query_type             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                              end,',
'                  p_owner                  => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                              end,       ',
'                  p_table_name             => case :P4111_LOCATION ',
'                                                  when ''LOCAL''  then :P4111_QUERY_TABLE',
'                                                  when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                              end,',
'                  p_sql_query              => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                  when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                              end,             ',
'                  p_function_body          => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                              end,',
'                  p_function_body_language => case :P4111_LOCATION',
'                                                  when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                  when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                              end,',
'                  p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_where_clause           => case :P4111_LOCATION ',
'                                                  when ''LOCAL''      then :P4111_LOCAL_WHERE ',
'                                                  when ''REMOTE''     then :P4111_REMOTE_WHERE',
'                                                  when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                              end,',
'                  p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No definido -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4111_LOCATION'
,p_display_when2=>'LOCAL:REMOTE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione una columna indexada por un \00EDndice de Oracle Text.'),
'</p>',
'<p>',
unistr('    B\00FAsqueda de fila devuelve resultados basados en el operador de Oracle Text introducido, siempre que se haya creado el \00EDndice de Oracle Text correspondiente para la columna. Esta opci\00F3n solo se debe activar si existe el \00EDndice necesario y los usua')
||unistr('rios finales han recibido formaci\00F3n sobre c\00F3mo utilizar los operadores de b\00FAsqueda de Oracle Text. Para simplificar la sintaxis de Oracle Text para usuarios finales, puede especificar una funci\00F3n para Valores de componente de Nombre de funci\00F3n de PL/')
||unistr('SQL de Oracle Text en Componentes compartidos, Atributos de aplicaci\00F3n.'),
'</p>',
unistr('<p>Nota: Actualmente en APEX, el \00FAnico tipo de elemento nativo soportado es Lista de valores emergente.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(104450218961876535.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4111_ORIG_LOV_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select lov_name from wwv_flow_lists_of_values$ where id=:F4000_P4111_ID'
,p_compute_when=>'F4000_P4111_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(23201774898325542.4001)
,p_computation_sequence=>5
,p_computation_item=>'P4111_SOURCE_TYPE_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    if (:P4111_SOURCE_TYPE_HIDDEN in (''TABLE'',''SQL'',''FUNC_BODY_RETURNING_SQL'')) then',
'        return :P4111_SOURCE_TYPE;',
'    else',
'        return :P4111_SOURCE_TYPE_HIDDEN;     -- for legacy P4111_SOURCE_TYPE is not displayed, ',
'                                              -- so just set back to itself.    ',
'    end if;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_SOURCE_TYPE;',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2320291263209548.4001)
,p_computation_sequence=>15
,p_computation_item=>'P4111_FUNC_BODY_LANG_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'        return case when :P4111_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4111_LOV_QUERY_FUNC_LANG end;',
'    elsif :P4111_LOCATION = ''WEB_SOURCE'' then',
'        return case when :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4111_SRC_POST_PROC_FUNC_LANG end;',
'    end if;',
'',
'    return null;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(9496916949275717.4001)
,p_computation_sequence=>25
,p_computation_item=>'P4111_LOV_QUERY_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    if :P4111_SOURCE_TYPE_HIDDEN in (''SQL'',''LEGACY_SQL'') then',
'        return :P4111_LOV_QUERY_SQL;',
'    elsif :P4111_SOURCE_TYPE_HIDDEN = ''FUNC_BODY_RETURNING_SQL'' then',
'        return :P4111_LOV_QUERY_FUNC_BODY;',
'    end if;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_SQL;',
'elsif :P4111_LOCATION = ''WEB_SOURCE'' then',
'    if :P4111_SOURCE_POST_PROC_TYPE = ''SQL'' then',
'        return :P4111_SOURCE_POST_PROC_SQL;',
'    elsif :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then',
'        return :P4111_SRC_POST_PROC_FUNC_BODY;',
'    end if;',
'end if;',
'',
''))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(663117061643931015.4001)
,p_computation_sequence=>35
,p_computation_item=>'P4111_GROUP_COLUMN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Clear group column when default sort is null (order in query)'
,p_computation_error_message=>unistr('La columna de ordenaci\00F3n por defecto es nula, pero no se ha podido borrar la columna de grupo.')
,p_compute_when=>'P4111_DEFAULT_SORT_COLUMN'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1484488258307033.4001)
,p_computation_sequence=>45
,p_computation_item=>'P4111_WHERE_CLAUSE_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return :P4111_LOCAL_WHERE;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_WHERE;',
'elsif :P4111_LOCATION = ''WEB_SOURCE'' then',
'    return :P4111_SOURCE_POST_PROC_WHERE;',
'end if;',
'',
''))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(23201877744325543.4001)
,p_computation_sequence=>55
,p_computation_item=>'P4111_QUERY_OWNER_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return wwv_flow_lov_dev.get_table_owner(:P4111_QUERY_OWNER);',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_TABLE_OWNER;',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(23201933601325544.4001)
,p_computation_sequence=>65
,p_computation_item=>'P4111_QUERY_TABLE_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return :P4111_QUERY_TABLE;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_TABLE_NAME;',
'end if;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(58679708573256876.4001)
,p_computation_sequence=>75
,p_computation_item=>'F4000_P4111_LOV_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:F4000_P4111_LOV_NAME)'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35658203506095984.4001)
,p_computation_sequence=>40
,p_computation_item=>'F4000_P4111_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(202262221502184510.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4111_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el identificador de referencia para refrescar la lista de valores.'
,p_when_button_pressed=>wwv_flow_api.id(202120612291457307.4001)
,p_associated_item=>wwv_flow_api.id(202159909119506526.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(202271106609206645.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P4111_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la lista de valores que desea refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(202120612291457307.4001)
,p_associated_item=>wwv_flow_api.id(202159909119506526.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78604504333995558.4001)
,p_validation_name=>'LovNameMand'
,p_validation_sequence=>30
,p_validation=>'F4000_P4111_LOV_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la lista de valores.'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(299985834.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78602631083984314.4001)
,p_validation_name=>'LOVnameUnique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where flow_id = to_number(:FB_FLOW_ID) ',
'   and upper(lov_name) = upper(:F4000_P4111_LOV_NAME)',
'   and id != to_number(:F4000_P4111_ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'El nombre ya existe. Introduzca otro nombre.'
,p_validation_condition=>'F4000_P4111_LOV_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(299985834.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1261521852603722.4001)
,p_validation_name=>'P4111_LOV_QUERY_SQL Not Null'
,p_validation_sequence=>50
,p_validation=>'P4111_LOV_QUERY_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_SOURCE_TYPE_HIDDEN = ''LEGACY_SQL'' or ',
':P4111_SOURCE_TYPE = ''SQL'' and :P4111_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(9496533107275713.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485773525307046.4001)
,p_validation_name=>'P4111_LOV_QUERY_FUNC_BODY Not Null'
,p_validation_sequence=>60
,p_validation=>'P4111_LOV_QUERY_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P4111_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and :P4111_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(4439479327967228.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2824717245544456.4001)
,p_validation_name=>'valid LOV query'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if upper(substr(trim(:P4111_LOV_QUERY_SQL),1,6)) = ''SELECT'' then',
'        return wwv_flow_f4000_util.is_valid_lov_query(:P4111_LOV_QUERY_SQL);',
'    else',
'        return null;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4111_SOURCE_TYPE_HIDDEN = ''LEGACY_SQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(9496533107275713.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1260667749598995.4001)
,p_validation_name=>'P4111_QUERY_TABLE is not null'
,p_validation_sequence=>80
,p_validation=>'P4111_QUERY_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P4111_SOURCE_TYPE = ''TABLE'' and :P4111_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(9476514751187804.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485687373307045.4001)
,p_validation_name=>'P4111_REMOTE_SERVER_ID is not null'
,p_validation_sequence=>90
,p_validation=>'P4111_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4111_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(9481590790191485.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1260925876600182.4001)
,p_validation_name=>'P4111_REMOTE_TABLE_NAME is not null'
,p_validation_sequence=>100
,p_validation=>'P4111_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P4111_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4111_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(9484614427191490.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1261214981601363.4001)
,p_validation_name=>'P4111_REMOTE_SQL is not null'
,p_validation_sequence=>110
,p_validation=>'P4111_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P4111_REMOTE_SOURCE_TYPE = ''SQL'' and :P4111_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485574003307044.4001)
,p_validation_name=>'P4111_WEB_SRC_MODULE_ID is not null'
,p_validation_sequence=>120
,p_validation=>'P4111_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4111_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(9479941132189824.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485294120307041.4001)
,p_validation_name=>'P4111_RETURN_COLUMN not null'
,p_validation_sequence=>130
,p_validation=>'P4111_RETURN_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(20214151972919120.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485387244307042.4001)
,p_validation_name=>'P4111_DISPLAY_COLUMN not null'
,p_validation_sequence=>140
,p_validation=>'P4111_DISPLAY_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(20216380459919142.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_api.id(170786031904296885.4001)
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485815796307047.4001)
,p_validation_name=>'P4111_SOURCE_POST_PROC_WHERE not null'
,p_validation_sequence=>160
,p_validation=>'P4111_SOURCE_POST_PROC_WHERE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION = ''WEB_SOURCE'' and',
':P4111_SOURCE_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(1481681766307005.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1485923103307048.4001)
,p_validation_name=>'P4111_SOURCE_POST_PROC_SQL not null'
,p_validation_sequence=>170
,p_validation=>'P4111_SOURCE_POST_PROC_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION = ''WEB_SOURCE'' and',
':P4111_SOURCE_POST_PROC_TYPE = ''SQL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(1481905921307008.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1486070129307049.4001)
,p_validation_name=>'P4111_SRC_POST_PROC_FUNC_BODY not null'
,p_validation_sequence=>180
,p_validation=>'P4111_SRC_POST_PROC_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION = ''WEB_SOURCE'' and',
':P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(292985826.4001)
,p_associated_item=>wwv_flow_api.id(1482059431307009.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2701380099095211.4001)
,p_validation_name=>'Prevent used LOV deletion'
,p_validation_sequence=>190
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_used_on_pages     varchar2(4000);',
'    l_used_on_pages_msg varchar2(4000);',
'begin    ',
'    l_used_on_pages := wwv_flow_lov_dev.lov_used_on_pages( :F4000_P4111_ID );',
'    if l_used_on_pages is not null then',
'        l_used_on_pages_msg := wwv_flow_lang.system_message(''P4111_USED_ON_PAGES'',l_used_on_pages);',
'    end if;',
'    return l_used_on_pages_msg;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(291985826.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1479591516915265404.4001)
,p_name=>'Refresh Grid'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(712080000591813402.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1479591668347265405.4001)
,p_event_id=>wwv_flow_api.id(1479591516915265404.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(712080000591813402.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9446966051950045.4001)
,p_name=>'ON LOCATION CHANGE HIDE ALL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9447016627950046.4001)
,p_event_id=>wwv_flow_api.id(9446966051950045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(73945327537305242.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9447100599950047.4001)
,p_event_id=>wwv_flow_api.id(9446966051950045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(73951063066307275.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9447226373950048.4001)
,p_event_id=>wwv_flow_api.id(9446966051950045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(75743329779916863.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437849918967212.4001)
,p_event_id=>wwv_flow_api.id(9446966051950045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(399144664.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437968298967213.4001)
,p_event_id=>wwv_flow_api.id(9446966051950045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(125268524262083710.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20215928130919138.4001)
,p_event_id=>wwv_flow_api.id(9446966051950045.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20212831971919107.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9447399675950049.4001)
,p_name=>'LOCATION = LOCAL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_condition_element=>'P4111_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9447400847950050.4001)
,p_event_id=>wwv_flow_api.id(9447399675950049.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(73945327537305242.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9495322763275701.4001)
,p_name=>'LOCATION = REMOTE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_condition_element=>'P4111_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23202036615325545.4001)
,p_event_id=>wwv_flow_api.id(9495322763275701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9495483697275702.4001)
,p_event_id=>wwv_flow_api.id(9495322763275701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(75743329779916863.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20216169683919140.4001)
,p_event_id=>wwv_flow_api.id(9495322763275701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20212831971919107.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(9495541356275703.4001)
,p_name=>'LOCATION = WEB_SOURCE'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_condition_element=>'P4111_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(23202194381325546.4001)
,p_event_id=>wwv_flow_api.id(9495541356275703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_WEB_SRC_MODULE_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(9495678016275704.4001)
,p_event_id=>wwv_flow_api.id(9495541356275703.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(73951063066307275.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4436855444967202.4001)
,p_name=>'SOURCE TYPE CHANGE HIDE ALL'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4436999952967203.4001)
,p_event_id=>wwv_flow_api.id(4436855444967202.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_QUERY_OWNER,P4111_QUERY_TABLE,P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_OPTIMIZER_HINT,P4111_LOCAL_WHERE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437461818967208.4001)
,p_event_id=>wwv_flow_api.id(4436855444967202.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(399144664.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437528211967209.4001)
,p_event_id=>wwv_flow_api.id(4436855444967202.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(125268524262083710.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4437074517967204.4001)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437114804967205.4001)
,p_event_id=>wwv_flow_api.id(4437074517967204.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_SQL,P4111_OPTIMIZER_HINT'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437675016967210.4001)
,p_event_id=>wwv_flow_api.id(4437074517967204.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(125268524262083710.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4439512303967229.4001)
,p_name=>'SOURCE TYPE = PLSQL'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4439635810967230.4001)
,p_event_id=>wwv_flow_api.id(4439512303967229.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_OPTIMIZER_HINT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437777413967211.4001)
,p_event_id=>wwv_flow_api.id(4439512303967229.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(399144664.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4437201738967206.4001)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4437392903967207.4001)
,p_event_id=>wwv_flow_api.id(4437201738967206.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_QUERY_OWNER,P4111_QUERY_TABLE,P4111_LOCAL_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4439973878967233.4001)
,p_name=>'SOURCE TYPE = LEGACY_SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LEGACY_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4440041070967234.4001)
,p_event_id=>wwv_flow_api.id(4439973878967233.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4440169513967235.4001)
,p_event_id=>wwv_flow_api.id(4439973878967233.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(399144664.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4440210903967236.4001)
,p_event_id=>wwv_flow_api.id(4439973878967233.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(125268524262083710.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4438269217967216.4001)
,p_name=>'REMOTE SERVER CHANGES'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_REMOTE_SERVER_ID'
,p_condition_element=>'P4111_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4438389418967217.4001)
,p_event_id=>wwv_flow_api.id(4438269217967216.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4438501274967219.4001)
,p_event_id=>wwv_flow_api.id(4438269217967216.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4438629320967220.4001)
,p_event_id=>wwv_flow_api.id(4438269217967216.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE,P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20212940887919108.4001)
,p_event_id=>wwv_flow_api.id(4438269217967216.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20212831971919107.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4438484798967218.4001)
,p_event_id=>wwv_flow_api.id(4438269217967216.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20213046613919109.4001)
,p_event_id=>wwv_flow_api.id(4438269217967216.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20212831971919107.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4438769047967221.4001)
,p_name=>'REMOTE SOURCE TYPE CHANGE'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P4111_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4438834555967222.4001)
,p_event_id=>wwv_flow_api.id(4438769047967221.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4438908807967223.4001)
,p_event_id=>wwv_flow_api.id(4438769047967221.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4439042872967224.4001)
,p_event_id=>wwv_flow_api.id(4438769047967221.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4439269347967226.4001)
,p_event_id=>wwv_flow_api.id(4438769047967221.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(11467118814432845.4001)
,p_name=>'REMOTE CACHING CHANGES'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_REMOTE_SQL_CACHING'
,p_condition_element=>'P4111_REMOTE_SQL_CACHING'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(11467281034432846.4001)
,p_event_id=>wwv_flow_api.id(11467118814432845.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL_INVALIDATE_WHEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(11467338718432847.4001)
,p_event_id=>wwv_flow_api.id(11467118814432845.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL_INVALIDATE_WHEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(11467518747432849.4001)
,p_name=>'WEB SRC MODULE CHANGES'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_WEB_SRC_MODULE_ID'
,p_condition_element=>'P4111_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(11467676239432850.4001)
,p_event_id=>wwv_flow_api.id(11467518747432849.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20215619883919135.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20212276678919101.4001)
,p_event_id=>wwv_flow_api.id(11467518747432849.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(20215619883919135.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(21000182695632640.4001)
,p_name=>'SOURCE ITEMS CHANGE'
,p_event_sequence=>155
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_QUERY_TABLE, P4111_WEB_SRC_MODULE_ID, P4111_REMOTE_SERVER_ID, P4111_REMOTE_SOURCE_TYPE, P4111_REMOTE_TABLE_OWNER, P4111_REMOTE_TABLE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Disable and clear column related controls when any source item is changed.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4470218907653239.4001)
,p_event_id=>wwv_flow_api.id(21000182695632640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'//has to be done before clear',
'storeColumnMappings();'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21000373569632642.4001)
,p_event_id=>wwv_flow_api.id(21000182695632640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'wwv_flow_collection.truncate_collection( ''LOV_COL_INFO'' );'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21000417639632643.4001)
,p_event_id=>wwv_flow_api.id(21000182695632640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(9499495849275742.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21000533436632644.4001)
,p_event_id=>wwv_flow_api.id(21000182695632640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21000986508632648.4001)
,p_event_id=>wwv_flow_api.id(21000182695632640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21001064272632649.4001)
,p_event_id=>wwv_flow_api.id(21000182695632640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(20999087932632629.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(688654437560399026.4001)
,p_name=>'SOURCE COLUMN CHANGE'
,p_event_sequence=>165
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SQL, P4111_SOURCE_POST_PROC_SQL,P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY,P4111_SOURCE_POST_PROC_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Disable and clear column related controls when any source item is changed.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688654565543399027.4001)
,p_event_id=>wwv_flow_api.id(688654437560399026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'//has to be done before clear',
'storeColumnMappings();'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1389541671697745.4001)
,p_event_id=>wwv_flow_api.id(688654437560399026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_table_name            varchar2(128);',
'    l_table_owner           varchar2(128);',
'    l_source_type           wwv_flow_lists_of_values$.source_type%type;',
'    l_sql                   varchar2(32767);',
'    l_func_body             varchar2(32767);',
'    l_func_body_language    wwv_flow_code_exec.t_language;',
'    l_describe_result       wwv_flow_exec_dev.t_describe_result;',
'    l_column                wwv_flow_exec_api.t_column;',
'    l_column_matched        boolean;',
'    --',
'    c_collection_name       varchar2(12) := ''LOV_COL_INFO'';',
'begin',
'    if :P4111_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner        := :P4111_QUERY_OWNER;',
'        l_table_name         := :P4111_QUERY_TABLE;',
'        l_source_type        := :P4111_SOURCE_TYPE;',
'        l_sql                := :P4111_LOV_QUERY_SQL;',
'        l_func_body          := :P4111_LOV_QUERY_FUNC_BODY;',
'        l_func_body_language := :P4111_LOV_QUERY_FUNC_LANG;',
'    elsif :P4111_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner   := :P4111_REMOTE_TABLE_OWNER;',
'        l_table_name    := :P4111_REMOTE_TABLE_NAME;',
'        l_source_type   := :P4111_REMOTE_SOURCE_TYPE;',
'        l_sql           := :P4111_REMOTE_SQL;',
'    elsif :P4111_LOCATION = wwv_flow_exec_api.c_location_web_source then',
'        l_sql                := :P4111_SOURCE_POST_PROC_SQL;',
'        l_func_body          := :P4111_SRC_POST_PROC_FUNC_BODY;',
'        l_func_body_language := :P4111_SRC_POST_PROC_FUNC_LANG;',
'    end if;',
'',
'    -- parse and describe query',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                              p_location               => :P4111_LOCATION,',
'                              p_query_type             => l_source_type,',
'                              p_owner                  => l_table_owner,           ',
'                              p_table_name             => l_table_name,            ',
'                              p_sql_query              => l_sql,              ',
'                              p_function_body          => l_func_body,     ',
'                              p_function_body_language => l_func_body_language,',
'                              p_remote_server_id       => :P4111_REMOTE_SERVER_ID,',
'                              p_web_src_module_id      => :P4111_WEB_SRC_MODULE_ID,',
'                              p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE );',
'    ',
'    -- loop over columns in collection',
'    for l_column_collection in ( select seq_id,',
'                                        c001 column_name ',
'                                   from wwv_flow_collections',
'                                  where collection_name = c_collection_name )',
'    loop ',
'        l_column_matched := false;',
'        -- loop over page columns',
'        for i in 1 .. l_describe_result.query_columns.count loop',
'            l_column := l_describe_result.query_columns( i );',
'            if l_column.name = l_column_collection.column_name then ',
'                l_column_matched := true;',
'                exit;',
'            end if;',
'        end loop;        ',
'        ',
'        -- column not in shuttle columns, delete it from the collection',
'        if not l_column_matched then',
'            wwv_flow_collection.delete_member(',
'                p_collection_name => c_collection_name,',
'                p_seq             => l_column_collection.seq_id );',
'        end if;',
'    end loop;',
'end;'))
,p_attribute_02=>'P4111_LOCATION,P4111_QUERY_OWNER,P4111_QUERY_TABLE,P4111_SOURCE_TYPE,P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_SOURCE_TYPE,P4111_REMOTE_SQL,P4111_SOURCE_POST_'
||'PROC_SQL,P4111_SRC_POST_PROC_FUNC_BODY,P4111_REMOTE_SERVER_ID,P4111_WEB_SRC_MODULE_ID,P4111_SOURCE_POST_PROC_TYPE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1389623643697746.4001)
,p_event_id=>wwv_flow_api.id(688654437560399026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(9499495849275742.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688654846070399030.4001)
,p_event_id=>wwv_flow_api.id(688654437560399026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688654993453399031.4001)
,p_event_id=>wwv_flow_api.id(688654437560399026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(688655033867399032.4001)
,p_event_id=>wwv_flow_api.id(688654437560399026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(20999087932632629.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(20996501334632604.4001)
,p_name=>'SOURCE ITEMS CHANGE - GET NEW COLUMN INFO'
,p_event_sequence=>175
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_QUERY_TABLE, P4111_LOV_QUERY_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_WEB_SRC_MODULE_ID, P4111_REMOTE_SERVER_ID, P4111_REMOTE_SOURCE_TYPE, P4111_REMOTE_SQL, P4111_REMOTE_TABLE_OWNER,'
||' P4111_REMOTE_TABLE_NAME, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY,P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'isValidSourceDefinition()'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Enabled and refresh column related controls when any source items are changed, and the current source definition is a valid one (has everything defined that needs to be to get column information).'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20996611252632605.4001)
,p_event_id=>wwv_flow_api.id(20996501334632604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21000784603632646.4001)
,p_event_id=>wwv_flow_api.id(20996501334632604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(21001164155632650.4001)
,p_event_id=>wwv_flow_api.id(20996501334632604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(20999087932632629.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(20999466262632633.4001)
,p_name=>'CLOSE DIALOG'
,p_event_sequence=>185
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1483115269307020.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484049193307029.4001)
,p_event_id=>wwv_flow_api.id(20999466262632633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_HIDDEN_ADDITIONAL_COL_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(1)',
'  from apex_collections',
' where collection_name = ''LOV_COL_INFO'''))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(20999596825632634.4001)
,p_event_id=>wwv_flow_api.id(20999466262632633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(9499495849275742.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1482140275307010.4001)
,p_name=>'SOURCE POST PROCESSING TYPE CHANGE HIDE ALL'
,p_event_sequence=>195
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1482250856307011.4001)
,p_event_id=>wwv_flow_api.id(1482140275307010.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_WHERE,P4111_SOURCE_POST_PROC_SQL,P4111_SRC_POST_PROC_FUNC_LANG,P4111_SRC_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1482395108307012.4001)
,p_name=>'SOURCE POST PROCESSING TYPE = WHERE'
,p_event_sequence=>205
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_condition_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WHERE_ORDER_BY_CLAUSE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1482477242307013.4001)
,p_event_id=>wwv_flow_api.id(1482395108307012.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1482544110307014.4001)
,p_name=>'SOURCE POST PROCESSING TYPE = SQL'
,p_event_sequence=>215
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_condition_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1482671291307015.4001)
,p_event_id=>wwv_flow_api.id(1482544110307014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1461053545917801.4001)
,p_event_id=>wwv_flow_api.id(1482544110307014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_SQL'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_lov_dev.get_post_processing_sql_query(',
'    p_location               => :P4111_LOCATION,',
'    p_query_type             => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case :P4111_LOCATION',
'                                  when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_OWNER',
'                                  when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_OWNER',
'                                end,         ',
'    p_table_name             => case :P4111_LOCATION',
'                                  when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_TABLE',
'                                  when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_NAME',
'                                end,            ',
'    p_sql_query              => case :P4111_LOCATION',
'                                  when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_SQL',
'                                  when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SQL',
'                                end,',
'    p_function_body          => :P4111_LOV_QUERY_FUNC_BODY,',
'    p_function_body_language => :P4111_LOV_QUERY_FUNC_LANG,',
'    p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'    p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID) );'))
,p_attribute_07=>'P4111_LOCATION,P4111_SOURCE_TYPE,P4111_REMOTE_SOURCE_TYPE,P4111_QUERY_OWNER,P4111_REMOTE_TABLE_OWNER,P4111_QUERY_TABLE,P4111_REMOTE_TABLE_NAME,P4111_LOV_QUERY_SQL,P4111_REMOTE_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SERVE'
||'R_ID,P4111_WEB_SRC_MODULE_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1482712875307016.4001)
,p_name=>'SOURCE POST PROCESSING TYPE = PLSQL'
,p_event_sequence=>225
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_condition_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1482844235307017.4001)
,p_event_id=>wwv_flow_api.id(1482712875307016.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SRC_POST_PROC_FUNC_LANG,P4111_SRC_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1461111669917802.4001)
,p_event_id=>wwv_flow_api.id(1482712875307016.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SRC_POST_PROC_FUNC_BODY'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''return q''''~''||chr(13)||',
'        wwv_flow_lov_dev.get_post_processing_sql_query(',
'            p_location               => :P4111_LOCATION,',
'            p_query_type             => case :P4111_LOCATION',
'                                            when wwv_flow_exec_api.c_location_local_db then :P4111_SOURCE_TYPE',
'                                            when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SOURCE_TYPE',
'                                        end,',
'            p_owner                  => case :P4111_LOCATION',
'                                          when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_OWNER',
'                                          when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_OWNER',
'                                        end,         ',
'            p_table_name             => case :P4111_LOCATION',
'                                          when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_TABLE',
'                                          when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_NAME',
'                                        end,            ',
'            p_sql_query              => case :P4111_LOCATION',
'                                          when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_SQL',
'                                          when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SQL',
'                                        end,',
'            p_function_body          => :P4111_LOV_QUERY_FUNC_BODY,',
'            p_function_body_language => :P4111_LOV_QUERY_FUNC_LANG,',
'            p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'            p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID) )||',
'        chr(13)||''~'''';'';',
''))
,p_attribute_07=>'P4111_LOCATION,P4111_SOURCE_TYPE,P4111_REMOTE_SOURCE_TYPE,P4111_QUERY_OWNER,P4111_REMOTE_TABLE_OWNER,P4111_QUERY_TABLE,P4111_REMOTE_TABLE_NAME,P4111_LOV_QUERY_SQL,P4111_REMOTE_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SERVE'
||'R_ID,P4111_WEB_SRC_MODULE_ID,P4111_SRC_POST_PROC_FUNC_LANG'
,p_attribute_08=>'N'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1483589861307024.4001)
,p_name=>'SHOW / HIDE COLUMN IG'
,p_event_sequence=>235
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_HIDDEN_ADDITIONAL_COL_COUNT'
,p_condition_element=>'P4111_HIDDEN_ADDITIONAL_COL_COUNT'
,p_triggering_condition_type=>'GREATER_THAN'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1483669713307025.4001)
,p_event_id=>wwv_flow_api.id(1483589861307024.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(9499495849275742.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1483734117307026.4001)
,p_event_id=>wwv_flow_api.id(1483589861307024.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(9499495849275742.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1484826845307037.4001)
,p_name=>'GROUP COLUMN CHANGES'
,p_event_sequence=>245
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_GROUP_COLUMN'
,p_condition_element=>'P4111_GROUP_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484943637307038.4001)
,p_event_id=>wwv_flow_api.id(1484826845307037.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1485069072307039.4001)
,p_event_id=>wwv_flow_api.id(1484826845307037.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1465060645917841.4001)
,p_name=>'WEB SOURCE PARAM DIALOG CLOSSE'
,p_event_sequence=>255
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1461332165917804.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1465182744917842.4001)
,p_event_id=>wwv_flow_api.id(1465060645917841.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1461332165917804.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4470082448653237.4001)
,p_name=>'SET SOURCE ITEMS AFTER REFRESH'
,p_event_sequence=>265
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_ORACLE_TEXT_COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4469757345653234.4001)
,p_event_id=>wwv_flow_api.id(4470082448653237.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'setColumnMappings( this.triggeringElement.id );'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(19531886461272707.4001)
,p_name=>'REMOTE SQL AUTH CHECK'
,p_event_sequence=>275
,p_condition_element=>'P4111_AUTH_TEST'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'AUTH_FAILURE,COMM_FAILURE'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'REMOTE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(19531961987272708.4001)
,p_event_id=>wwv_flow_api.id(19531886461272707.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lAuthTest = apex.item( ''P4111_AUTH_TEST'' ).getValue();',
'',
'if ( lAuthTest === ''AUTH_FAILURE'' ) {',
'    apex.message.showErrors({',
'            type:       ''error'',',
'            location:   ''page'',',
'            message:    ''&"APP_TEXT$APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV".'',',
'            unsafe:     false',
'    });',
'} else if ( lAuthTest === ''COMM_FAILURE'' ) {',
'    apex.message.showErrors({',
'            type:       ''error'',',
'            location:   ''page'',',
'            message:    ''&"APP_TEXT$APEX.REMOTESQL.COMMUNICATION_FAILURE".'',',
'            unsafe:     false',
'    });    ',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(663116787013931012.4001)
,p_name=>'DEFAULT SORT DEFINED'
,p_event_sequence=>285
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_DEFAULT_SORT_COLUMN'
,p_condition_element=>'P4111_DEFAULT_SORT_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(663116816588931013.4001)
,p_event_id=>wwv_flow_api.id(663116787013931012.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(663116980068931014.4001)
,p_event_id=>wwv_flow_api.id(663116787013931012.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(255005309062399740.4001)
,p_name=>'DISABLE SAVE BUTTON ON QUERY KEY PRESS'
,p_event_sequence=>295
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'keypress'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION <> ''STATIC'' and',
':P4111_SOURCE_TYPE <> ''LEGACY_SQL'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(255005444121399741.4001)
,p_event_id=>wwv_flow_api.id(255005309062399740.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(292985826.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(255005506628399742.4001)
,p_name=>'ENABLE SAVE BUTTON ON LEAVE QUERY ITEM'
,p_event_sequence=>305
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'blur'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION <> ''STATIC'' and',
':P4111_SOURCE_TYPE <> ''LEGACY_SQL'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(255005687009399743.4001)
,p_event_id=>wwv_flow_api.id(255005506628399742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(292985826.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1663199442963715.4001)
,p_name=>'Use Local Table Enabled'
,p_event_sequence=>315
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_USE_LOCAL_TABLE'
,p_condition_element=>'P4111_USE_LOCAL_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1663281334963716.4001)
,p_event_id=>wwv_flow_api.id(1663199442963715.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_EXTERNAL_FILTER_EXPR,P4111_EXTERNAL_ORDER_BY_EXPR'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1663547549963719.4001)
,p_event_id=>wwv_flow_api.id(1663199442963715.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1461332165917804.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1663331417963717.4001)
,p_event_id=>wwv_flow_api.id(1663199442963715.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1461332165917804.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1663497778963718.4001)
,p_event_id=>wwv_flow_api.id(1663199442963715.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_EXTERNAL_FILTER_EXPR,P4111_EXTERNAL_ORDER_BY_EXPR'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2701444639095212.4001)
,p_name=>'Delete LOV'
,p_event_sequence=>325
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(291985826.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2701598298095213.4001)
,p_event_id=>wwv_flow_api.id(2701444639095212.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'&DELETE_MSG.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2701720452095215.4001)
,p_event_id=>wwv_flow_api.id(2701444639095212.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'Delete'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20999152427632630.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SET STATE OF ITEMS USED IN COLUMN DIALOG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Referenced in LOV on modal page item P4082_SELECT_COLUMNS, so must be set in ',
'    -- session state on load in case the dialog is opened immediately',
'    apex_util.set_session_state(''P4111_LOCATION'',:P4111_LOCATION);',
'    apex_util.set_session_state(''P4111_SOURCE_TYPE'',:P4111_SOURCE_TYPE);',
'    apex_util.set_session_state(''P4111_REMOTE_SOURCE_TYPE'',:P4111_REMOTE_SOURCE_TYPE);',
'    apex_util.set_session_state(''P4111_QUERY_OWNER'',:P4111_QUERY_OWNER);',
'    apex_util.set_session_state(''P4111_REMOTE_TABLE_OWNER'',:P4111_REMOTE_TABLE_OWNER);',
'    apex_util.set_session_state(''P4111_QUERY_TABLE'',:P4111_QUERY_TABLE);',
'    apex_util.set_session_state(''P4111_REMOTE_TABLE_NAME'',:P4111_REMOTE_TABLE_NAME);',
'    apex_util.set_session_state(''P4111_LOV_QUERY_SQL'',:P4111_LOV_QUERY_SQL);',
'    apex_util.set_session_state(''P4111_REMOTE_SQL'',:P4111_REMOTE_SQL);',
'    apex_util.set_session_state(''P4111_LOV_QUERY_FUNC_LANG'',:P4111_LOV_QUERY_FUNC_LANG);',
'    apex_util.set_session_state(''P4111_LOV_QUERY_FUNC_BODY'',:P4111_LOV_QUERY_FUNC_BODY);',
'    apex_util.set_session_state(''P4111_REMOTE_SERVER_ID'',:P4111_REMOTE_SERVER_ID);',
'    apex_util.set_session_state(''P4111_WEB_SRC_MODULE_ID'',:P4111_WEB_SRC_MODULE_ID);',
'    apex_util.set_session_state(''P4111_SOURCE_POST_PROC_SQL'',:P4111_SOURCE_POST_PROC_SQL);',
'    apex_util.set_session_state(''P4111_SRC_POST_PROC_FUNC_LANG'',:P4111_SRC_POST_PROC_FUNC_LANG);',
'    apex_util.set_session_state(''P4111_SRC_POST_PROC_FUNC_BODY'',:P4111_SRC_POST_PROC_FUNC_BODY);',
'    apex_util.set_session_state(''P4111_LOCAL_WHERE'',:P4111_LOCAL_WHERE);',
'    apex_util.set_session_state(''P4111_REMOTE_WHERE'',:P4111_REMOTE_WHERE);',
'    apex_util.set_session_state(''P4111_SOURCE_POST_PROC_WHERE'',:P4111_SOURCE_POST_PROC_WHERE);',
'    apex_util.set_session_state(''P4111_SOURCE_POST_PROC_TYPE'',:P4111_SOURCE_POST_PROC_TYPE);',
'',
'    -- Referenced in default value on modal page item P4082_SELECT_COLUMNS, so',
'    -- also must be set',
'    apex_util.set_session_state(''P4111_RETURN_COLUMN'',:P4111_RETURN_COLUMN);',
'    apex_util.set_session_state(''P4111_DISPLAY_COLUMN'',:P4111_DISPLAY_COLUMN);',
'    apex_util.set_session_state(''P4111_GROUP_COLUMN'',:P4111_GROUP_COLUMN);',
'    apex_util.set_session_state(''P4111_ICON_COLUMN'',:P4111_ICON_COLUMN);',
'    apex_util.set_session_state(''P4111_DEFAULT_SORT_COLUMN'', :P4111_DEFAULT_SORT_COLUMN);',
'    apex_util.set_session_state(''P4111_ORACLE_TEXT_COLUMN'', :P4111_ORACLE_TEXT_COLUMN);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(301985835.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_LISTS_OF_VALUES$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_lists_of_values$',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4111_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_LISTS_OF_VALUES$'',',
'  p_rowid       => v(''F4000_P4111_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9498262582275730.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CREATE LOV COL INFO COLLECTION'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.create_coll_from_lov_columns(',
'    p_collection_name       => ''LOV_COL_INFO'',',
'    p_lov_id                => to_number(:F4000_P4111_ID) );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(9496222651275710.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Legacy SQL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.convert_legacy_lov(',
'    p_lov_id => to_number(:F4000_P4111_ID));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al convertir el SQL heredado.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(9496177960275709.4001)
,p_process_success_message=>'La lista de valores de SQL heredado se ha convertido a SQL.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(202284215642232821.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_lov (',
'    p_master_lov_id         => :F4000_P4111_REFERENCE_ID,',
'    p_subscribing_lov_id    => :F4000_P4111_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar la lista de valores.'
,p_process_when_button_id=>wwv_flow_api.id(202120612291457307.4001)
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_success_message=>'Lista de valores refrescada. '
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(302985836.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LISTS_OF_VALUES$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from dual',
'where :F4000_P4111_ID is null',
'or exists (select 1 from wwv_flow_lists_of_values$',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4111_ID)) loop',
'wwv_flow_dml.process(',
'p_action => replace(replace(wwv_flow.g_request,',
'                            ''CREATE_STATIC'',''CREATE''),',
'                            ''REFRESH_COLUMN_INFO'',''UPDATE''),',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LISTS_OF_VALUES$'',',
'p_rowid       => v(''F4000_P4111_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>':REQUEST IN (''Create'',''ApplyChanges'',''Delete'',''REFRESH_COLUMN_INFO'',''CREATE_STATIC'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(87513231047656264.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert to Static LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if substr(upper(ltrim(:P4111_LOV_QUERY_HIDDEN)), 1, 6) = ''STATIC'' then',
'        wwv_flow_lov_dev.create_named_lov (',
'            p_id      => :F4000_P4111_ID,',
'            p_flow_id => :FB_FLOW_ID,',
'            p_name    => :F4000_P4111_LOV_NAME,',
'            p_query   => :P4111_LOV_QUERY_HIDDEN );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('No se ha podido convertir la lista de valores en una lista de valores est\00E1tica.')
,p_process_when_button_id=>wwv_flow_api.id(87511229484617914.4001)
,p_process_success_message=>unistr('Lista de valores convertida a lista de valores est\00E1tica.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(410891997.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade update to wwv_flow_step_items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_step_items ',
'  set named_lov = upper(:F4000_P4111_LOV_NAME)',
'  where ',
'   (upper(named_lov) = upper(:P4111_ORIG_LOV_NAME)',
'    or lov = ''.''||:F4000_P4111_ID||''.'')',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35663612551107064.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh LOV 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_lov (',
'    p_master_lov_id         => :F4000_P4111_REFERENCE_ID,',
'    p_subscribing_lov_id    => :F4000_P4111_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la lista de valores.'
,p_process_when_button_id=>wwv_flow_api.id(292985826.4001)
,p_process_when=>':F4000_P4111_REFERENCE_ID is not null and :F4000_P4111_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Lista de valores copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(202293227491242525.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_lov_reference_id (:F4000_P4111_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de referencia en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(292985826.4001)
,p_process_when=>'F4000_P4111_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(567419190309994733.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(712080000591813402.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Source: Static Values - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23198298652325507.4001)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(9499495849275742.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'UPDATE ADDITIONAL COLUMN INFO COLLECTION'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_lov_collection varchar2(12) := ''LOV_COL_INFO'';',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''U'' then',
'        /* can''t use update_member as we have to pass all member attributes to avoid values being lost,',
'           however values for non-editable columns (column_name and data_type) are null',
'        apex_collection.update_member (',
'            p_collection_name   => c_lov_col_name,',
'            p_seq               => l_seq_id,',
'            p_c001              => :COLUMN_NAME,',
'            p_c002              => :DATA_TYPE,',
'            p_c003              => :LABEL,',
'            p_c004              => :COLUMN_ROLE,',
'            p_c005              => :DEFAULT_SORT );',
'        */',
'  ',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 1,',
'            p_number_value       => :ID );',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 2,',
'            p_number_value       => :DISPLAY_SEQUENCE );',
'        -- skip query_column_name: read only',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 2,',
'            p_attr_value        => :HEADING );      ',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 3,',
'            p_attr_value        => :FORMAT_MASK );',
'        -- skip data_type: read only  ',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 5,',
'            p_attr_value        => :IS_VISIBLE );',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 6,',
'            p_attr_value        => :IS_SEARCHABLE );',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 7,',
'            p_attr_value        => :COLUMN_COMMENT );',
'    when ''D'' then  ',
'        wwv_flow_collection.delete_member (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID );',
'',
'    end case;',
'end;'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4111_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'STATIC'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23201242310325537.4001)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UPDATE LOV COLUMN INFO'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.save_column_info_from_coll(',
'    p_collection_name       => ''LOV_COL_INFO'',',
'    p_lov_id                => nv(''F4000_P4111_ID'') );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(292985826.4001)
,p_process_when=>'P4111_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'STATIC'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1663630736963720.4001)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync REST Data Source Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.synchronize_web_src_parameters(',
'    p_web_src_module_id => :P4111_WEB_SRC_MODULE_ID,',
'    p_shared_lov_id     => :F4000_P4111_ID,',
'    p_use_local_table   => ( :P4111_USE_LOCAL_TABLE = ''Y'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(292985826.4001)
,p_process_when=>'P4111_WEB_SRC_MODULE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_04113
begin
wwv_flow_api.create_page(
 p_id=>4113.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Listas de Valores Est\00E1ticas')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear/Editar: Entrada de Lista de Valores Est\00E1tica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213211113434774960)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63182855698.4001)
,p_plug_name=>'Entrada'
,p_region_name=>'E'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 13-JUN-2000 11:36:34'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(63205897861.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(63243999508.4001)
,p_name=>'Entradas de Lista de Valores Existentes'
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>160
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lov_disp_sequence,lov_disp_value,lov_return_value',
'from wwv_flow_list_of_values_data',
'where lov_id = :F4000_P4113_LOV_ID',
'order by lov_disp_sequence'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48848907653772539.4001)
,p_query_column_id=>1
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48849027974772540.4001)
,p_query_column_id=>2
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Mostrar'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48849113018772540.4001)
,p_query_column_id=>3
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Devolver'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5358920086062640.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16848629696670874.4001)
,p_plug_name=>unistr('Globalizaci\00F3n')
,p_region_name=>'G'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46259112084679012.4001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145747221614947109.4001)
,p_plug_name=>unistr('Listas de Valores Est\00E1ticas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Edite valores de visualizaci\00F3n y de retorno para una entrada de lista de valores.</p>')
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'R:L:L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167154021724274310.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'CONFIG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620050103042392721.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>170
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LIST_OF_VALUES_DATA',
'where id = :F4000_P4113_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4113_ID,',
'      p_component_type => ''List of Values'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4113_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63183855701.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63184855701.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'F4000_P4113_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63185855701.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4113_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63249147840.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4113_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(63186855702.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4113_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(63250160883.4001)
,p_branch_action=>'4113'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_AGAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63187855704.4001)
,p_name=>'F4000_P4113_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63188855706.4001)
,p_name=>'F4000_P4113_LOV_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4111_ID.'
,p_prompt=>'Lov Id'
,p_source=>'LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63189855707.4001)
,p_name=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4113_LOV_DISP_SEQUENCE.'
,p_prompt=>'Secuencia'
,p_source=>'LOV_DISP_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63190855707.4001)
,p_name=>'F4000_P4113_LOV_DISP_VALUE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Visualizaci\00F3n')
,p_source=>'LOV_DISP_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Este texto se muestra para el usuario. Se devuelve el valor de retorno.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63191855708.4001)
,p_name=>'F4000_P4113_LOV_RETURN_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor de Retorno'
,p_source=>'LOV_RETURN_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique el valor de retorno para esta entrada de lista de valores.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63192855709.4001)
,p_name=>'F4000_P4113_LOV_DISP_COND_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(63205897861.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'LOV_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Seleccione un tipo de condici\00F3n de la lista que se debe cumplir para presentar este componente como procesado.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4113_LOV_DISP_COND'
,p_attribute_02=>'F4000_P4113_LOV_DISP_COND2'
,p_attribute_04=>'F4000_P4113_LOV_DISP_COND_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4113_LOV_DISP_COND_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63193855709.4001)
,p_name=>'F4000_P4113_LOV_DISP_COND'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(63205897861.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'LOV_DISP_COND'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o proc')
||'esa el componente.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(63194855710.4001)
,p_name=>'F4000_P4113_REQUIRED_PATCH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(167154021724274310.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(116264468029.4001)
,p_name=>'F4000_P4113_TEMP_SEQ'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2006656883568365.4001)
,p_name=>'F4000_P4113_LOV_DISP_COND_LANG'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(63205897861.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16664818316645684.4001)
,p_name=>'P4113_LOV_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(16848629696670874.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla'
,p_source=>'LOV_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice esta plantilla opcional durante el desarrollo de entradas de lista de valores que necesiten traducci\00F3n y si desea simplificar el texto de la traducci\00F3n. Utilice la cadena de sustituci\00F3n #DISPLAY_VALUE#. El valor mostrado ser\00E1 este atributo co')
||unistr('n el valor mostrado sustituido en todas las instancias de la cadena de sustituci\00F3n #DISPLAY_VALUE#.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18143617754868675.4001)
,p_name=>'F4000_P4113_LOV_DISP_COND2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(63205897861.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'LOV_DISP_COND2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75394607108090542.4001)
,p_name=>'P4113_ID_NEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75395028902090543.4001)
,p_name=>'P4113_ID_PREV'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(5358920086062640.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75395409777090546.4001)
,p_name=>'P4113_ID_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(63182855698.4001)
,p_prompt=>unistr('Entrada de Lista de Valores Est\00E1tica: ')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'F4000_P4113_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica la lista de valores compartida.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75401929560144771.4001)
,p_name=>'P4113_RETURN_TO_PAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(145747221614947109.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435040326620654782.4001)
,p_name=>'F4000_P4113_LOV_DISP_COND_CHECK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(63205897861.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(116281665962.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( max( lov_disp_sequence ), 0 ) + 10 as seq',
'  from wwv_flow_list_of_values_data',
' where lov_id = :F4000_P4111_ID'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'v(''F4000_P4113_ID'') is null or 1 = 1'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185781508782421843.4001)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia.'
,p_validation_condition=>'Create, Apply Changes, CREATE_AGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63189855707.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185782107527430954.4001)
,p_validation_name=>'sequence is numeric'
,p_validation_sequence=>20
,p_validation=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La secuencia debe ser num\00E9rica.')
,p_validation_condition=>'Create, Apply Changes, CREATE_AGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63189855707.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185782702810438973.4001)
,p_validation_name=>'display value required'
,p_validation_sequence=>30
,p_validation=>'F4000_P4113_LOV_DISP_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el valor de visualizaci\00F3n.')
,p_validation_condition=>'Create, Apply Changes, CREATE_AGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(63190855707.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397299812269483058.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4113_ID_PREV'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397300218156484728.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4113_ID_NEXT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1479591354673265402.4001)
,p_name=>'Close Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(63183855701.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1479591414906265403.4001)
,p_event_id=>wwv_flow_api.id(1479591354673265402.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63195855710.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'F4000_P4113_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(75396423970090553.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'F4000_P4113_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'LOV_DISP_SEQUENCE'
,p_attribute_08=>'LOV_DISP_VALUE'
,p_attribute_09=>'P4113_ID_NEXT'
,p_attribute_10=>'P4113_ID_PREV'
,p_attribute_13=>'P4113_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and lov_id = :F4000_P4111_ID'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(63196855712.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'F4000_P4113_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1479591228851265401.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_AGAIN'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
end;
/
prompt --application/pages/page_04200
begin
wwv_flow_api.create_page(
 p_id=>4200.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Elementos de P\00E1gina')
,p_step_title=>unistr('Elementos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16848818234914469.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(98042408475113688.4001)
,p_name=>'Elementos'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    null e,',
'    item_sequence,',
'    name,',
'    prompt,',
'    item_plug_id,',
'    csize,',
'    cheight,',
'    post_element_text,',
'    substr(source,1,50) source,',
'    source_type,',
'    display_as,',
'    id,',
'    decode(display_when_type,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
'    last_updated_on,',
'    flow_step_id',
' from wwv_flow_step_items',
'where flow_id = :fb_flow_id',
'  and flow_step_id = :fb_flow_page_id',
'  and (nvl(:F4000_P4200_REGION,''0'') = ''0'' or item_plug_id = :F4000_P4200_REGION)',
'  and (:P4200_NAME is null or instr(upper(name),upper(:P4200_NAME)) > 0)'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn elemento.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48508426502770512.4001)
,p_query_column_id=>1
,p_column_alias=>'E'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5120:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48508502756770512.4001)
,p_query_column_id=>2
,p_form_element_id=>1
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48508607837770512.4001)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48508710738770512.4001)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48508916596770513.4001)
,p_query_column_id=>5
,p_form_element_id=>4
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(246039671)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48509219269770513.4001)
,p_query_column_id=>6
,p_form_element_id=>7
,p_column_alias=>'CSIZE'
,p_column_display_sequence=>9
,p_column_heading=>'Ancho'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>4
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48509316511770513.4001)
,p_query_column_id=>7
,p_form_element_id=>8
,p_column_alias=>'CHEIGHT'
,p_column_display_sequence=>10
,p_column_heading=>'Altura'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>4
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48509619296770514.4001)
,p_query_column_id=>8
,p_form_element_id=>11
,p_column_alias=>'POST_ELEMENT_TEXT'
,p_column_display_sequence=>13
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48509707809770514.4001)
,p_query_column_id=>9
,p_column_alias=>'SOURCE'
,p_column_display_sequence=>14
,p_column_heading=>'Origen'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48509821073770514.4001)
,p_query_column_id=>10
,p_column_alias=>'SOURCE_TYPE'
,p_column_display_sequence=>15
,p_column_heading=>'Tipo de Origen'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(129889837649)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48509919269770514.4001)
,p_query_column_id=>11
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>16
,p_column_heading=>'Mostrar como'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(29353308376249352)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48510005701770514.4001)
,p_query_column_id=>12
,p_form_element_id=>12
,p_column_alias=>'ID'
,p_column_display_sequence=>17
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_pk_col_source_type=>'T'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26249126630395035.4001)
,p_query_column_id=>13
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>18
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291233609430160509.4001)
,p_query_column_id=>14
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>19
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(35202962770289006.4001)
,p_query_column_id=>15
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>29
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(99250617384852982.4001)
,p_column_sequence=>1
,p_query_column_name=>'E'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98829407997314132.4001)
,p_column_sequence=>2
,p_query_column_name=>'ITEM_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98829508654314132.4001)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'ESCAPE_SC'
,p_column_width=>25
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98829615929314132.4001)
,p_column_sequence=>4
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98829728546314132.4001)
,p_column_sequence=>5
,p_query_column_name=>'ITEM_FIELD_TEMPLATE'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select template_name, id from   wwv_flow_field_templates where  security_group_id = :flow_security_group_id and flow_id = :fb_flow_id order by 1'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98829809771314132.4001)
,p_column_sequence=>6
,p_query_column_name=>'ITEM_PLUG_ID'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select htf.escape_sc(plug_name) plug_name, id from wwv_flow_page_plugs where flow_id = :FB_FLOW_ID and page_id = :FB_FLOW_PAGE_ID'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98829913784314132.4001)
,p_column_sequence=>7
,p_query_column_name=>'BEGIN_ON_NEW_LINE'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'NO,YES'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98830000787314132.4001)
,p_column_sequence=>8
,p_query_column_name=>'BEGIN_ON_NEW_FIELD'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'NO,YES'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98830130517314133.4001)
,p_column_sequence=>9
,p_query_column_name=>'CSIZE'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98830208836314133.4001)
,p_column_sequence=>10
,p_query_column_name=>'CHEIGHT'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(172785914093319482.4001)
,p_column_sequence=>11
,p_query_column_name=>'COLSPAN'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(172786008996319482.4001)
,p_column_sequence=>12
,p_query_column_name=>'ROWSPAN'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(180076425087585073.4001)
,p_column_sequence=>13
,p_query_column_name=>'POST_ELEMENT_TEXT'
,p_display_as=>'TEXT'
,p_column_width=>20
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98830313709314133.4001)
,p_column_sequence=>14
,p_query_column_name=>'SOURCE'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98830420971314133.4001)
,p_column_sequence=>15
,p_query_column_name=>'SOURCE_TYPE'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(99876222250083593.4001)
,p_column_sequence=>16
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(98830614264314133.4001)
,p_column_sequence=>17
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(26249000751395029.4001)
,p_column_sequence=>18
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(291233521791160504.4001)
,p_column_sequence=>19
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164567101376192924.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(186703109122914661.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_column_width=>'valign="top" width="150"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16852318019923959.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_button_name=>'P4200_GO'
,p_button_static_id=>'P4200_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16850804859920075.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(98141506810626290.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_items where flow_id=:FB_FLOW_ID and flow_step_id=:FB_FLOW_PAGE_ID',
'and (nvl(:F4000_P4200_REGION,''0'') = ''0'' or item_plug_id = :F4000_P4200_REGION)'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16849828970917657.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(159570307718511757.4001)
,p_branch_action=>'f?p=&APP_ID.:4200:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9072927018187941.4001)
,p_name=>'F4000_P4200_REGION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Regi\00F3n')
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGE REGIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name, id from (',
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id,',
'       upper(plug_name) pn,',
'       1 x',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
'union',
'select wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'') ||',
'       r.plug_name || '' ('' || r.plug_display_sequence || '')'' as plug_name,',
'       r.id,',
'       upper(r.plug_name) pn,',
'       2 x',
'  from wwv_flow_steps p,',
'       wwv_flow_user_interfaces i,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and i.id                = p.user_interface_id',
'   and i.global_page_id   <> :fb_flow_page_id',
'   and r.flow_id           = i.flow_id',
'   and r.page_id           = i.global_page_id',
' order by 4, 3) v'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todas las Regiones -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Para filtrar elementos por regi\00F3n, seleccione un nombre de regi\00F3n y haga clic en <span class="fielddatabold">Ir</span>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16851409708921485.4001)
,p_name=>'P4200_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1gina. Para cambiarlo, seleccione o introduzca un nuevo n\00FAmero y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(124763229344960898.4001)
,p_name=>'P4200_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16848818234914469.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice este campo para filtrar los elementos que se deben editar. Solo se mostrar\00E1n los elementos en los que el nombre contiene el valor introducido en este campo. Introduzca un valor y pulse Ir.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46338379090.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4200'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16853903951929357.4001)
,p_computation_sequence=>3
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(157517531288825510.4001)
,p_computation_sequence=>14
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.get_theme_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(78534713928126652.4001)
,p_validation_name=>'P4200_PAGE_ID'
,p_validation_sequence=>10
,p_validation=>'P4200_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La p\00E1gina debe ser num\00E9rica.')
,p_associated_item=>wwv_flow_api.id(16851409708921485.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2795412228977144.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(98042408475113688.4001)
,p_validation_name=>'ITEM_SEQUENCE cannot be null'
,p_validation_sequence=>30
,p_validation=>'ITEM_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La secuencia no puede ser nula.'
,p_when_button_pressed=>wwv_flow_api.id(98141506810626290.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'ITEM_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(98104317390550195.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(98400331937339235.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(98042408475113688.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_STEP_ITEMS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al procesar la actualizaci\00F3n de varias filas de los elementos de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(98141506810626290.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(78536323063138757.4001)
,p_process_sequence=>5
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set fb_flow_page_id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if v(''P4200_PAGE_ID'') != v(''FB_FLOW_PAGE_ID'') then',
'  :FB_FLOW_PAGE_ID := nvl(v(''P4200_PAGE_ID''),:FB_FLOW_PAGE_ID);',
'  :F4000_P4200_REGION := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'NEXT,PREVIOUS'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
end;
/
prompt --application/pages/page_04201
begin
wwv_flow_api.create_page(
 p_id=>4201.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Procesos de P\00E1gina')
,p_step_title=>unistr('Procesos de P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(426031913.4001)
,p_name=>unistr('Procesos de P\00E1gina')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       ''<a href="f?p=4000:4500:''||:flow_session||'':::::#5530:''||id||''">''||',
'       ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'' edit_link,',
'        process_sequence,',
'        process_point,',
'        process_name,',
'        PROCESS_WHEN_BUTTON_ID,',
'        process_when_type,',
'        REQUIRED_PATCH,',
'  decode(PROCESS_WHEN_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
' LAST_UPDATED_ON',
'from   wwv_flow_step_processing',
'where  flow_id = :fb_flow_id and ',
'       flow_step_id = :fb_flow_page_id and',
'       process_name not like ''FSP_PROCESS_STATE_%''',
'order  by process_point, process_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No existe ning\00FAn proceso para la p\00E1gina &FB_FLOW_PAGE_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100576437111284422.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>11
,p_column_heading=>'Rowid'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693814057771673.4001)
,p_query_column_id=>2
,p_form_element_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693129423771672.4001)
,p_query_column_id=>3
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>2
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693211177771672.4001)
,p_query_column_id=>4
,p_form_element_id=>1
,p_column_alias=>'PROCESS_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>4
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693315325771672.4001)
,p_query_column_id=>5
,p_form_element_id=>2
,p_column_alias=>'PROCESS_POINT'
,p_column_display_sequence=>4
,p_column_heading=>'Punto'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(9405302986939246)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693414109771672.4001)
,p_query_column_id=>6
,p_form_element_id=>3
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693520360771673.4001)
,p_query_column_id=>7
,p_form_element_id=>4
,p_column_alias=>'PROCESS_WHEN_BUTTON_ID'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Si Se Hace Clic en el Bot\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(6214918033450806)
,p_lov_show_nulls=>'YES'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693628002771673.4001)
,p_query_column_id=>8
,p_column_alias=>'PROCESS_WHEN_TYPE'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48693730234771673.4001)
,p_query_column_id=>9
,p_column_alias=>'REQUIRED_PATCH'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26254524299404361.4001)
,p_query_column_id=>10
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>9
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291201406336084444.4001)
,p_query_column_id=>11
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>10
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100657302548135310.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100659626807138218.4001)
,p_column_sequence=>2
,p_query_column_name=>'EDIT_LINK'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100656730647135309.4001)
,p_column_sequence=>3
,p_query_column_name=>'PROCESS_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100656812859135309.4001)
,p_column_sequence=>4
,p_query_column_name=>'PROCESS_POINT'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'Before Header;BEFORE_HEADER,After Header;AFTER_HEADER,Before Regions;BEFORE_BOX_BODY,After Regions;AFTER_BOX_BODY,Before Footer;BEFORE_FOOTER,After Footer;AFTER_FOOTER,After Page Submit - Before Computations and Validations;ON_SUBMIT_BEFORE_COMPUTATI'
||'ON,After Page Submit - After Computations and Validations;AFTER_SUBMIT,Before Showing page items (deprecated);BEFORE_SHOW_ITEMS,After showing page items (deprecated);AFTER_SHOW_ITEMS,After Header on Error Pages;AFTER_ERROR_HEADER,Before Footer on Err'
||'or Pages;BEFORE_ERROR_FOOTER,After Authentication (on new instance);AFTER_AUTHENTICATION'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100656928689135310.4001)
,p_column_sequence=>5
,p_query_column_name=>'PROCESS_NAME'
,p_display_as=>'TEXT'
,p_column_width=>30
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100657021305135310.4001)
,p_column_sequence=>6
,p_query_column_name=>'PROCESS_WHEN_BUTTON_ID'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select button_name, id from   wwv_flow_step_buttons where  flow_id = :FB_FLOW_ID and flow_step_id = :FB_FLOW_PAGE_ID order by 1'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100657130130135310.4001)
,p_column_sequence=>7
,p_query_column_name=>'PROCESS_WHEN_TYPE'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100657209293135310.4001)
,p_column_sequence=>8
,p_query_column_name=>'REQUIRED_PATCH'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(26254423200404354.4001)
,p_column_sequence=>9
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(291201324757084441.4001)
,p_column_sequence=>10
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11323907521500458.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(11322022496485821.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17973318147218768.4001)
,p_plug_name=>'pagebuttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100668205700156816.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17976405811224748.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(100668205700156816.4001)
,p_button_name=>'P4201_GO'
,p_button_static_id=>'P4201_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100688112207183234.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(100668205700156816.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_condition=>'select 1 from wwv_flow_step_processing where flow_id=:FB_FLOW_ID and flow_step_id=:FB_FLOW_PAGE_ID'
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17973921610219857.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(100668205700156816.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17974525420220906.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(100668205700156816.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2823582376.4001)
,p_branch_name=>'Go To Page 4201'
,p_branch_action=>'f?p=&APP_ID.:4201:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17975332692222998.4001)
,p_name=>'P4201_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100668205700156816.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46339387509.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4201'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17979605942234258.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17981120487238435.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P4201_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2795017853959822.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(426031913.4001)
,p_validation_name=>'PROCESS_SEQUENCE cannot be null'
,p_validation_sequence=>10
,p_validation=>'PROCESS_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La secuencia no puede ser nula.'
,p_when_button_pressed=>wwv_flow_api.id(100688112207183234.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'PROCESS_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(100667109367155147.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(426031913.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_STEP_PROCESSING'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al actualizar los procesos de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(100688112207183234.4001)
,p_process_success_message=>unistr('#MRU_COUNT# proceso(s) de p\00E1gina(s) actualizado(s).')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_04202
begin
wwv_flow_api.create_page(
 p_id=>4202.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Bifurcaciones'
,p_step_title=>'Bifurcaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(433188910.4001)
,p_name=>'Bifurcaciones'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>92
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="f?p=4000:4500:''||:flow_session||'':::::#5540:''||id||''">''||',
'       ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'' edit_link,',
'       branch_point, ',
'       branch_sequence,',
'       branch_name,',
'       branch_when_button_id,',
'       branch_action, ',
'       branch_type,',
'       decode(BRANCH_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
'       decode(BRANCH_WHEN_BUTTON_ID,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') button_condition,',
'       required_patch,',
'       id, LAST_UPDATED_ON',
'from   wwv_flow_step_branches ',
'where  flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order  by branch_point, branch_sequence, id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No existe ninguna bifurcaci\00F3n para la p\00E1gina &FB_FLOW_PAGE_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'       initcap(replace(decode(branch_type,',
'                  ''REDIRECT_URL'',''BRANCH_TO_URL'',',
'                  ''BRANCH_TO_STEP'',''BRANCH_TO_PAGE'',',
'                  branch_type),''_'','' '')) branch_type,'))
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100576634208284424.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>13
,p_column_heading=>'Rowid'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48522731200770593.4001)
,p_query_column_id=>2
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48522815064770593.4001)
,p_query_column_id=>3
,p_form_element_id=>1
,p_column_alias=>'BRANCH_POINT'
,p_column_display_sequence=>2
,p_column_heading=>'Punto'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(185544520425574805)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48522906260770593.4001)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'BRANCH_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(16743823637128528.4001)
,p_query_column_id=>5
,p_column_alias=>'BRANCH_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48523013589770593.4001)
,p_query_column_id=>6
,p_form_element_id=>3
,p_column_alias=>'BRANCH_WHEN_BUTTON_ID'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Si Se Hace Clic en el Bot\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name, id',
'  from wwv_flow_step_buttons',
' where  flow_id     = :FB_FLOW_ID',
'   and flow_step_id = :FB_FLOW_PAGE_ID',
'order by 1'))
,p_lov_show_nulls=>'YES'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48523132745770593.4001)
,p_query_column_id=>7
,p_form_element_id=>4
,p_column_alias=>'BRANCH_ACTION'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Acci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXTAREA'
,p_column_width=>40
,p_column_height=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48523217112770594.4001)
,p_query_column_id=>8
,p_column_alias=>'BRANCH_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(15652127549539076)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26211308420318562.4001)
,p_query_column_id=>9
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>10
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26211426138318562.4001)
,p_query_column_id=>10
,p_column_alias=>'BUTTON_CONDITION'
,p_column_display_sequence=>11
,p_column_heading=>unistr('Espec\00EDfico de Bot\00F3n')
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27451126983339324.4001)
,p_query_column_id=>11
,p_column_alias=>'REQUIRED_PATCH'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48523422804770594.4001)
,p_query_column_id=>12
,p_form_element_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291209904031095167.4001)
,p_query_column_id=>13
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>12
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100549920210977824.4001)
,p_column_sequence=>1
,p_query_column_name=>'EDIT_LINK'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100550012596977824.4001)
,p_column_sequence=>2
,p_query_column_name=>'BRANCH_POINT'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'BEFORE_COMPUTATION,BEFORE_VALIDATION,BEFORE_PROCESSING,AFTER_PROCESSING,BEFORE_HEADER'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100550117860977825.4001)
,p_column_sequence=>3
,p_query_column_name=>'BRANCH_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>3
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(16742916662128525.4001)
,p_column_sequence=>4
,p_query_column_name=>'BRANCH_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100550519719977825.4001)
,p_column_sequence=>5
,p_query_column_name=>'BRANCH_WHEN_BUTTON_ID'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select button_name, id from   wwv_flow_step_buttons where  flow_id = :FB_FLOW_ID and flow_step_id = :FB_FLOW_PAGE_ID order by 1'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100550201498977825.4001)
,p_column_sequence=>6
,p_query_column_name=>'BRANCH_ACTION'
,p_display_as=>'TEXT'
,p_column_width=>40
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100550300858977825.4001)
,p_column_sequence=>7
,p_query_column_name=>'BRANCH_TYPE'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(26211013138318555.4001)
,p_column_sequence=>8
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(26211126071318555.4001)
,p_column_sequence=>9
,p_query_column_name=>'BUTTON_CONDITION'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(27450901464339313.4001)
,p_column_sequence=>10
,p_query_column_name=>'REQUIRED_PATCH'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100616610865056892.4001)
,p_column_sequence=>11
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(291209831369095164.4001)
,p_column_sequence=>12
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11288015467351342.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_api.id(11286824340344465.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100597416786045279.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17255030963686489.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(100597416786045279.4001)
,p_button_name=>'P4202_GO'
,p_button_static_id=>'P4202_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17253204644678877.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(100597416786045279.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100622015699061261.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(100597416786045279.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
,p_button_condition=>'select 1 from wwv_flow_step_branches where flow_id=:FB_FLOW_ID and flow_step_id=:FB_FLOW_PAGE_ID'
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17252632217677408.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(100597416786045279.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(100622415150061265.4001)
,p_branch_name=>'Go To Page 4202'
,p_branch_action=>'f?p=&APP_ID.:4202:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>23
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17253922305684009.4001)
,p_name=>'P4202_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100597416786045279.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46344407352.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4202'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21890143945.4001)
,p_computation_sequence=>2
,p_computation_item=>'F4000_P4313_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_PAGE_BRANCH'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17257218412701820.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17259026854713687.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P4202_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2794827765953241.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(433188910.4001)
,p_validation_name=>'BRANCH_SEQUENCE cannot be null'
,p_validation_sequence=>10
,p_validation=>'BRANCH_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La secuencia no puede ser nula.'
,p_when_button_pressed=>wwv_flow_api.id(100622015699061261.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'BRANCH_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(100624900599068064.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(433188910.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_STEP_BRANCHES'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al actualizar las bifurcaciones de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(100622015699061261.4001)
,p_process_success_message=>'#MRU_COUNT# bifurcacion(es) actualizada(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_04203
begin
wwv_flow_api.create_page(
 p_id=>4203.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Botones'
,p_step_title=>'Botones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(411248736.4001)
,p_name=>'Botones'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  id,',
'''<a href="f?p=4000:4500:''||:flow_session||''::::#5130:''||id||''">''||',
'       ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'' e,',
' button_sequence,',
' button_name,',
' button_image_alt,',
' button_plug_id,',
' BUTTON_ALIGNMENT,',
' BUTTON_IMAGE_ATTRIBUTES,',
' BUTTON_CATTRIBUTES,',
' BUTTON_REDIRECT_URL,',
' decode(BUTTON_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
'last_updated_on',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order  by button_position, button_plug_id, button_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No existe ning\00FAn bot\00F3n para la p\00E1gina &FB_FLOW_PAGE_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48608301394771167.4001)
,p_query_column_id=>1
,p_form_element_id=>11
,p_column_alias=>'ID'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48607228040771166.4001)
,p_query_column_id=>2
,p_column_alias=>'E'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48607304744771166.4001)
,p_query_column_id=>3
,p_form_element_id=>1
,p_column_alias=>'BUTTON_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>4
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48607400519771166.4001)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48607502430771166.4001)
,p_query_column_id=>5
,p_form_element_id=>3
,p_column_alias=>'BUTTON_IMAGE_ALT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48607617135771166.4001)
,p_query_column_id=>6
,p_form_element_id=>4
,p_column_alias=>'BUTTON_PLUG_ID'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(246039671)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48607723399771166.4001)
,p_query_column_id=>7
,p_form_element_id=>5
,p_column_alias=>'BUTTON_ALIGNMENT'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48608011487771167.4001)
,p_query_column_id=>8
,p_form_element_id=>8
,p_column_alias=>'BUTTON_IMAGE_ATTRIBUTES'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48608130618771167.4001)
,p_query_column_id=>9
,p_form_element_id=>9
,p_column_alias=>'BUTTON_CATTRIBUTES'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48608214007771167.4001)
,p_query_column_id=>10
,p_form_element_id=>10
,p_column_alias=>'BUTTON_REDIRECT_URL'
,p_column_display_sequence=>10
,p_column_heading=>'URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6996704015547818.4001)
,p_query_column_id=>11
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>12
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(6996821497547820.4001)
,p_query_column_id=>12
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>13
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100526011429908900.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100328604957227880.4001)
,p_column_sequence=>2
,p_query_column_name=>'E'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100328704130227880.4001)
,p_column_sequence=>3
,p_query_column_name=>'BUTTON_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100328817911227880.4001)
,p_column_sequence=>4
,p_query_column_name=>'BUTTON_NAME'
,p_display_as=>'TEXT'
,p_column_width=>20
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100329129800227881.4001)
,p_column_sequence=>5
,p_query_column_name=>'BUTTON_IMAGE_ALT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100328926636227880.4001)
,p_column_sequence=>6
,p_query_column_name=>'BUTTON_PLUG_ID'
,p_display_as=>'SELECT_LIST_FROM_QUERY'
,p_inline_lov=>'select htf.escape_sc(plug_name) plug_name, id from wwv_flow_page_plugs where flow_id = :FB_FLOW_ID and (page_id = :FB_FLOW_PAGE_ID or page_id=0)'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(101571505214904883.4001)
,p_column_sequence=>7
,p_query_column_name=>'BUTTON_ALIGNMENT'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'LEFT,RIGHT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100329229728227881.4001)
,p_column_sequence=>8
,p_query_column_name=>'BUTTON_POSITION'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'LEFT_OF_TITLE,RIGHT_OF_TITLE,ABOVE_BOX,TOP,BOTTOM,TOP_AND_BOTTOM,BELOW_BOX,TEMPLATE_DEFAULT,REGION_TEMPLATE_CHANGE,REGION_TEMPLATE_CLOSE,REGION_TEMPLATE_COPY,REGION_TEMPLATE_CREATE,REGION_TEMPLATE_CREATE2,REGION_TEMPLATE_DELETE,REGION_TEMPLATE_EDIT,R'
||'EGION_TEMPLATE_EXPAND,REGION_TEMPLATE_HELP,REGION_TEMPLATE_NEXT,REGION_TEMPLATE_PREVIOUS'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(101590813625956295.4001)
,p_column_sequence=>9
,p_query_column_name=>'BUTTON_IMAGE_ATTRIBUTES'
,p_display_as=>'TEXT'
,p_column_width=>12
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(164305727416912914.4001)
,p_column_sequence=>10
,p_query_column_name=>'BUTTON_CATTRIBUTES'
,p_display_as=>'TEXT'
,p_column_width=>18
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100329318818227881.4001)
,p_column_sequence=>11
,p_query_column_name=>'BUTTON_REDIRECT_URL'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(6996528228547816.4001)
,p_column_sequence=>12
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(6996609389547816.4001)
,p_column_sequence=>13
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16360105418155785.4001)
,p_plug_name=>'Navigate'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(16353308133052510.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167682320566577899.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17238615192568431.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(167682320566577899.4001)
,p_button_name=>'P4203_GO'
,p_button_static_id=>'P4203_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100519724899903060.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(167682320566577899.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_condition=>'select 1 from wwv_flow_step_buttons where flow_id=:FB_FLOW_ID and flow_step_id=:FB_FLOW_PAGE_ID'
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17240414977577779.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(167682320566577899.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17241120172579335.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(167682320566577899.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179897363.4001)
,p_branch_name=>'Go To Page 4203'
,p_branch_action=>'f?p=&APP_ID.:4203:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17237706535565890.4001)
,p_name=>'P4203_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(167682320566577899.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46336362302.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4203'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17242517532588006.4001)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17245813985605897.4001)
,p_computation_sequence=>40
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P4203_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(107896115445183880.4001)
,p_validation_name=>'valid button name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_condition boolean := true;',
'  l_val       varchar2(4000);',
'  l_len       number;',
'begin',
'  for i in 1..wwv_flow.g_f02.count',
'  loop                    ',
'    l_len := nvl(length(wwv_flow.g_f02(i)),0);',
'    l_val := wwv_flow.g_f02(i);',
'    if l_val is null then',
'      l_condition := false; ',
'    else',
'    for j in 1..l_len loop',
'       if instr(''abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_'',substr(l_val,j,1)) = 0 then',
'          l_condition := false;                        ',
'       end if;',
'       if l_condition = false then',
'          return l_condition;',
'       end if;              ',
'    end loop;',
'    end if;',
'  end loop;',
'  return l_condition;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El nombre de bot\00F3n s\00F3lo puede contener caracteres alfanum\00E9ricos y de subrayado "_".')
,p_when_button_pressed=>wwv_flow_api.id(100519724899903060.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6990707849264056.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(411248736.4001)
,p_validation_name=>'BUTTON_NAME'
,p_validation_sequence=>20
,p_validation=>'BUTTON_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #COLUMN_HEADER#.'
,p_when_button_pressed=>wwv_flow_api.id(100519724899903060.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'BUTTON_NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2794605602946854.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(411248736.4001)
,p_validation_name=>'BUTTON_SEQUENCE cannot be null'
,p_validation_sequence=>30
,p_validation=>'BUTTON_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La secuencia no puede ser nula.'
,p_when_button_pressed=>wwv_flow_api.id(100519724899903060.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'BUTTON_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(100533221629921569.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(411248736.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_STEP_BUTTONS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Error al actualizar los botones'
,p_process_when_button_id=>wwv_flow_api.id(100519724899903060.4001)
,p_process_success_message=>'#MRU_COUNT# boton(es) actualizado(s).'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_04204
begin
wwv_flow_api.create_page(
 p_id=>4204.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('C\00E1lculos de P\00E1gina')
,p_step_title=>unistr('C\00E1lculos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(438320456.4001)
,p_name=>unistr('C\00E1lculos')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>2
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="f?p=4000:4500:''||:flow_session||'':::::#5520:''||id||''">''||',
'      ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'' edit_link,',
'      computation_sequence, ',
'      computation_item, ',
'      computation_point, ',
'      computation_type, ',
'      /*computation_processed,*/',
'      compute_when_type,',
'      REQUIRED_PATCH,',
'      id,',
'      decode(COMPUTE_WHEN_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden>''||wwv_flow_lang.system_message(''YES'')||''</span>"'') conditional,',
'      LAST_UPDATED_ON',
'from   wwv_flow_step_computations',
'where  flow_id = :FB_FLOW_ID and flow_step_id = :FB_FLOW_PAGE_ID',
'order  by computation_point, computation_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No existe ning\00FAn c\00E1lculo para la p\00E1gina &FB_FLOW_PAGE_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100575978403284417.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>11
,p_column_heading=>'Rowid'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748205975771984.4001)
,p_query_column_id=>2
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748310816771984.4001)
,p_query_column_id=>3
,p_form_element_id=>1
,p_column_alias=>'COMPUTATION_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748424232771984.4001)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'COMPUTATION_ITEM'
,p_column_display_sequence=>3
,p_column_heading=>'Elemento'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748510363771984.4001)
,p_query_column_id=>5
,p_form_element_id=>3
,p_column_alias=>'COMPUTATION_POINT'
,p_column_display_sequence=>4
,p_column_heading=>'Punto'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(62981024179015035)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748630675771984.4001)
,p_query_column_id=>6
,p_form_element_id=>4
,p_column_alias=>'COMPUTATION_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Tipo de C\00E1lculo')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(62977815884897285)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748732532771984.4001)
,p_query_column_id=>7
,p_column_alias=>'COMPUTE_WHEN_TYPE'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748824880771984.4001)
,p_query_column_id=>8
,p_column_alias=>'REQUIRED_PATCH'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48748914902771984.4001)
,p_query_column_id=>9
,p_form_element_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26275810811441136.4001)
,p_query_column_id=>10
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>9
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291205516017088887.4001)
,p_query_column_id=>11
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>10
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100712510152254353.4001)
,p_column_sequence=>1
,p_query_column_name=>'EDIT_LINK'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100712623168254353.4001)
,p_column_sequence=>2
,p_query_column_name=>'COMPUTATION_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100712703256254353.4001)
,p_column_sequence=>3
,p_query_column_name=>'COMPUTATION_ITEM'
,p_display_as=>'TEXT'
,p_column_width=>20
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100712801174254353.4001)
,p_column_sequence=>4
,p_query_column_name=>'COMPUTATION_POINT'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'On New Instance;ON_NEW_INSTANCE,Before Header;BEFORE_HEADER,After Header;AFTER_HEADER,Before Region(s);BEFORE_BOX_BODY,After Region(s);AFTER_BOX_BODY,Before Footer;BEFORE_FOOTER,After Footer;AFTER_FOOTER,After Submit;AFTER_SUBMIT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100712905443254353.4001)
,p_column_sequence=>5
,p_query_column_name=>'COMPUTATION_TYPE'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'Static Assignment;STATIC_ASSIGNMENT,PLSQL Function Body;FUNCTION_BODY,SQL Query;QUERY,SQL Expression;SQL_EXPRESION,PLSQL Expression;PLSQL_EXPRESSION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100713123261254354.4001)
,p_column_sequence=>6
,p_query_column_name=>'COMPUTE_WHEN_TYPE'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100713201757254354.4001)
,p_column_sequence=>7
,p_query_column_name=>'REQUIRED_PATCH'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100713430938254354.4001)
,p_column_sequence=>8
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(26275728884441129.4001)
,p_column_sequence=>9
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(291205424121088884.4001)
,p_column_sequence=>10
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17447904926516756.4001)
,p_plug_name=>'Navigate'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>0
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17446232715505772.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100770207074323319.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11915512812057482.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(100770207074323319.4001)
,p_button_name=>'P4204_GO'
,p_button_static_id=>'P4204_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18035725139400654.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(100770207074323319.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100802610626343600.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(100770207074323319.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_condition=>'select 1 from wwv_flow_step_computations where flow_id=:FB_FLOW_ID and flow_step_id=:FB_FLOW_PAGE_ID'
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18035122368399853.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(100770207074323319.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(176049025849574474.4001)
,p_branch_action=>'f?p=&APP_ID.:4204:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18036330333402095.4001)
,p_name=>'P4204_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100770207074323319.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46342404418.4001)
,p_computation_sequence=>2
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4204'
,p_computation_comment=>'last view allows edits to return to the page they came from.'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(18032713926387899.4001)
,p_computation_sequence=>3
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2793609711919694.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(438320456.4001)
,p_validation_name=>'COMPUTATION_SEQUENCE cannot be null'
,p_validation_sequence=>10
,p_validation=>'COMPUTATION_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La secuencia no puede ser nula'
,p_when_button_pressed=>wwv_flow_api.id(100802610626343600.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'COMPUTATION_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(100807917617348787.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(438320456.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_STEP_COMPUTATIONS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al actualizar los c\00E1lculos de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(100802610626343600.4001)
,p_process_success_message=>unistr('#MRU_COUNT# c\00E1lculo(s) de p\00E1gina actualizado(s).')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_04205
begin
wwv_flow_api.create_page(
 p_id=>4205.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Validaciones'
,p_step_title=>'Validaciones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(445254203.4001)
,p_name=>'Validaciones'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="f?p=4000:4500:''||:flow_session||'':::::#5510:''||id||''">''||',
'       ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'' edit_link,',
' validation_sequence, ',
' validation_name,',
' validation_type validation_type_display,',
' nvl(always_execute, ''Y'') as always_execute,',
' error_display_location,',
' decode(VALIDATION_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') ',
' VALIDATION_CONDITION_TYPE,',
' REQUIRED_PATCH,',
' id,',
' LAST_UPDATED_ON',
'from   wwv_flow_step_validations',
'where  flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order  by validation_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No existe ninguna validaci\00F3n en la p\00E1gina &FB_FLOW_PAGE_ID..')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(100576004989284418.4001)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>11
,p_column_heading=>'Rowid'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879213370772727.4001)
,p_query_column_id=>2
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879316690772727.4001)
,p_query_column_id=>3
,p_form_element_id=>1
,p_column_alias=>'VALIDATION_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>4
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879423075772727.4001)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(186006220761935176.4001)
,p_query_column_id=>5
,p_column_alias=>'VALIDATION_TYPE_DISPLAY'
,p_column_display_sequence=>4
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(131915151655)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(460525617754570148.4001)
,p_query_column_id=>6
,p_column_alias=>'ALWAYS_EXECUTE'
,p_column_display_sequence=>5
,p_column_heading=>'Ejecutar Siempre'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879604546772727.4001)
,p_query_column_id=>7
,p_form_element_id=>3
,p_column_alias=>'ERROR_DISPLAY_LOCATION'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Ubicaci\00F3n de Visualizaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(175855211406623797)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879716860772727.4001)
,p_query_column_id=>8
,p_column_alias=>'VALIDATION_CONDITION_TYPE'
,p_column_display_sequence=>7
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879823115772727.4001)
,p_query_column_id=>9
,p_column_alias=>'REQUIRED_PATCH'
,p_column_display_sequence=>8
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48879932420772727.4001)
,p_query_column_id=>10
,p_form_element_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291196817445078396.4001)
,p_query_column_id=>11
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>10
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100831427963368010.4001)
,p_column_sequence=>1
,p_query_column_name=>'EDIT_LINK'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100831515664368010.4001)
,p_column_sequence=>2
,p_query_column_name=>'VALIDATION_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>4
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100831623488368010.4001)
,p_column_sequence=>3
,p_query_column_name=>'VALIDATION_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(186005730705935170.4001)
,p_column_sequence=>4
,p_query_column_name=>'VALIDATION_TYPE_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(460525003472570141.4001)
,p_column_sequence=>5
,p_query_column_name=>'ALWAYS_EXECUTE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(174580332526533316.4001)
,p_column_sequence=>6
,p_query_column_name=>'ERROR_DISPLAY_LOCATION'
,p_display_as=>'SELECT_LIST'
,p_inline_lov=>'INLINE_WITH_FIELD_AND_NOTIFICATION,INLINE_WITH_FIELD,INLINE_IN_NOTIFICATION,ON_ERROR_PAGE'
,p_lov_show_nulls=>'YES'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100831824074368011.4001)
,p_column_sequence=>7
,p_query_column_name=>'VALIDATION_CONDITION_TYPE'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100831931529368011.4001)
,p_column_sequence=>8
,p_query_column_name=>'REQUIRED_PATCH'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100832012925368011.4001)
,p_column_sequence=>9
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(291196707041078393.4001)
,p_column_sequence=>10
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100834206390369253.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>130
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164619720964229382.4001)
,p_plug_name=>unistr('Navegaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_api.id(186826132498329280.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18047003284441664.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(100834206390369253.4001)
,p_button_name=>'P4205_GO'
,p_button_static_id=>'P4205_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18045426355438810.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(100834206390369253.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100868020631393852.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(100834206390369253.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'select 1 from wwv_flow_step_validations where flow_id=:FB_FLOW_ID and flow_step_id=:FB_FLOW_PAGE_ID'
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18044822892437825.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(100834206390369253.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2839582442.4001)
,p_branch_name=>'Go To Page 4205'
,p_branch_action=>'f?p=&APP_ID.:4205:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18046030857440150.4001)
,p_name=>'P4205_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100834206390369253.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46341402112.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4205'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(18042802114431853.4001)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17243204950020271.4001)
,p_computation_sequence=>40
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P4205_PAGE_ID''),:FB_FLOW_PAGE_ID);'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'GO'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(200179518666515856.4001)
,p_validation_name=>'validation names not null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f02.count loop',
'    if wwv_flow.g_f02(i) is null then',
'        return false;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Todas las validaciones necesitan un nombre de validaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(100868020631393852.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2782308148881381.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(445254203.4001)
,p_validation_name=>'VALIDATION_SEQUENCE cannot be null'
,p_validation_sequence=>20
,p_validation=>'VALIDATION_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'La secuencia no puede ser nula'
,p_when_button_pressed=>wwv_flow_api.id(100868020631393852.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'VALIDATION_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(100899005490415187.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(445254203.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_STEP_VALIDATIONS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al actualizar las validaciones de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(100868020631393852.4001)
,p_process_success_message=>unistr('#MRU_COUNT# validacion(es) de p\00E1gina actualizada(s).')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_04207
begin
wwv_flow_api.create_page(
 p_id=>4207.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Procesos de Aplicaci\00F3n')
,p_step_title=>unistr('Procesos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(342616740.4001)
,p_plug_name=>unistr('Procesos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los procesos de aplicaci\00F3n ejecutan la l\00F3gica PL/SQL en puntos espec\00EDficos para cada p\00E1gina de una aplicaci\00F3n, o como definan las condiciones en las que est\00E1n definidas para iniciarse. Tenga en cuenta que los procesos "Devoluci\00F3n de llamada de AJA')
||unistr('X" solo se inician cuando se llaman desde AJAX o por procesos "Ejecutar devoluci\00F3n de llamada de AJAX" definidos para p\00E1ginas concretas.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/understanding-application-processes.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4034623932624575.4001)
,p_plug_name=>'Navigate'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4020210037479119.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47814230554191364.4001)
,p_plug_name=>unistr('Procesos de Aplicaci\00F3n')
,p_region_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4207a */',
'       p.process_sequence,',
'       p.process_point,',
'       p.process_name, ',
'       decode(greatest(sys.dbms_lob.getlength(p.process_sql_clob),200),',
'          150,sys.dbms_lob.substr(p.process_sql_clob,2000,1),',
'          sys.dbms_lob.substr(p.process_sql_clob,200,1)||'' ...'')',
'          process_sql_clob,',
'       p.id,',
'       ''icon-sc-app-process'' icon,',
'       ''f?p=4000:4309:''||:app_session||''::::F4000_P4309_ID:''||p.id edit_link,',
'       replace(p.process_name,''_'','' '') icon_image_alt_text,',
'       security_scheme,',
'       nvl(p.last_updated_by,p.created_by) last_updated_by,',
'       nvl(p.last_updated_on,p.created_on) last_updated_on',
'from   #OWNER#.wwv_flow_processing p',
'where  p.flow_id = :fb_flow_id',
'and p.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(47814307723191364.4001)
,p_name=>'Application Processes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#ICON_IMAGE_ALT_TEXT#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47814518445191373.4001)
,p_db_column_name=>'PROCESS_SEQUENCE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Secuencia'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47814616624191379.4001)
,p_db_column_name=>'PROCESS_POINT'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Punto'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(179311318624565491)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47814705631191381.4001)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4309:&SESSION.::&DEBUG.::F4000_P4309_ID:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47814821233191381.4001)
,p_db_column_name=>'PROCESS_SQL_CLOB'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Texto'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47814932002191382.4001)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47819912573240062.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47820023832240063.4001)
,p_db_column_name=>'ICON_IMAGE_ALT_TEXT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Texto Alternativo de Imagen de Icono'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47820317595240064.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47820423338240067.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(646445089785466043.4001)
,p_db_column_name=>'ICON'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'ICONO'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(620834540482373108.4001)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>23
,p_column_identifier=>'N'
,p_column_label=>unistr('Esquema de Autorizaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(283664112341)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188876303146831279.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47814230554191364.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.:4207,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90816218739334112.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(47814230554191364.4001)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:147,148,150::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1984713202.4001)
,p_branch_action=>'4207'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(591284026.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4207'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21903143963.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4309_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_FLOW_PROCESS'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590026245805029674.4001)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(90816218739334112.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590026508359029674.4001)
,p_event_id=>wwv_flow_api.id(590026245805029674.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_04303
begin
wwv_flow_api.create_page(
 p_id=>4303.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear/Editar: Elemento de Aplicaci\00F3n')
,p_step_title=>unistr('Crear/Editar: Elemento de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454431825.4001)
,p_plug_name=>unistr('Elemento de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455433462.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456444407.4001)
,p_plug_name=>unistr('Elementos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Se utilizan elementos de nivel de aplicaci\00F3n para mantener el estado de la sesi\00F3n. Los elementos de la aplicaci\00F3n se pueden definir mediante c\00E1lculos o procesos, o bien transfiriendo valores en una direcci\00F3n URL. Utilice los c\00E1lculos "En Nueva Instan')
||unistr('cia" para definir el valor de los elementos una vez para una sesi\00F3n. Utilice elementos de aplicaci\00F3n para mantener el estado de la sesi\00F3n, que no se muestra ni es espec\00EDfico de ninguna p\00E1gina.')
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17312310527965891.4001)
,p_plug_name=>'Seguridad'
,p_region_name=>'S'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46261714381679017.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>22
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62049781536334954.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62050080142337727.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'CO'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615490023292207195.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_ITEMS',
'where id = :F4000_P4303_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4303_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4303_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21934143985.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(454431825.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21935143985.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(454431825.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4303_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21936143985.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(454431825.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4303_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21937143985.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(454431825.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Elemento de Aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4303_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21939143985.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21940143985.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(808206684.4001)
,p_name=>'F4000_P4303_ITEM_COMMENT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(62050080142337727.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'ITEM_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9174630521.4001)
,p_name=>'F4000_P4303_REQUIRED_PATCH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(62049781536334954.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21941143986.4001)
,p_name=>'F4000_P4303_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(455433462.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21942143986.4001)
,p_name=>'F4000_P4303_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(455433462.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21943143987.4001)
,p_name=>'F4000_P4303_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(455433462.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca un nombre al crear un nuevo elemento o cambie el nombre de un elemento existente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2373270202105008.4001)
,p_name=>'P4303_ESCAPE_ON_HTTP_OUTPUT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(17312310527965891.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Caracteres Especiales de Escape'
,p_source=>'ESCAPE_ON_HTTP_OUTPUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este elemento controla si el valor del elemento de aplicaci\00F3n se identificar\00E1 autom\00E1ticamente en las sustituciones, por ejemplo, al hacer referencia al elemento mediante <code>&amp;G_ITEM.</code>.'),
unistr('Para evitar ataques de scripts de sitios (XSS), def\00EDnalo en <em>Activado</em>.'),
unistr('Si necesita representar etiquetas HTML almacenadas en el elemento de aplicaci\00F3n,'),
'puede definir este indicador en <em>Desactivado</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17314311266994460.4001)
,p_name=>'P4303_PROTECTION_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(17312310527965891.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'I'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
,p_source=>'PROTECTION_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL D'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(PAGE_PROTECTION_ENABLED_Y_N,''N'') p from wwv_flows where id = :FB_FLOW_ID) loop',
'    if c1.p = ''Y'' then',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_APPLICATION'''') d, ''''B'''' r',
'                  from dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_USER'''') d, ''''P'''' r',
'                  from dual union all               ',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_SESSION'''') d, ''''S'''' r',
'                  from dual union all               ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from dual'';',
'    else',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from dual union all ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from dual'';',
'    end if;',
'end loop;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione Protecci\00F3n de Estado de la Sesi\00F3n para este elemento:'),
'<ul>',
unistr('<li><strong>No Restringido</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL o en una pantalla. No se necesita total de control en la direcci\00F3n URL.</li><br />       '),
unistr('<li><strong>Restringido: No se puede definir desde el explorador</strong>. El elemento no se puede modificar a trav\00E9s de la direcci\00F3n URL o POSTDATA. Utilice esta opci\00F3n cuando desee restringir la manera en que se puede definir el valor del elemento ')
||unistr('para procesos internos, c\00E1lculos, etc. Siempre se tiene en cuenta este atributo, aplicable s\00F3lo a elementos que no se pueden utilizar como elementos de entrada de datos, incluso si la protecci\00F3n de estado de la sesi\00F3n est\00E1 desactivada. Este atributo ')
||unistr('se puede utilizar para elementos de aplicaci\00F3n o para elementos de p\00E1gina con cualquiera de estos tipos "Mostrar como":'),
'<br />',
'<ul>',
unistr('<li>S\00F3lo Visualizaci\00F3n (No guarda el estado)</li>'),
'<li>Campo de Texto (Desactivado, no guarda el estado)</li>                          ',
unistr('<li>Parar e Iniciar Tabla HTML (Muestra s\00F3lo etiquetas)</li>'),
'</li></ul>',
unistr('<li><strong>Total de Control Necesario: Nivel de Aplicaci\00F3n</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico del espacio de trabajo y ')
||unistr('la aplicaci\00F3n. Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados por cualquier usuario que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.')
||'</li>',
unistr('<li><strong>Total de Control Necesario: Nivel de Usuario</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico del espacio de trabajo, la a')
||unistr('plicaci\00F3n y el usuario. Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados por el mismo usuario designado que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pe')
||unistr('ro en otra sesi\00F3n.</li>      '),
unistr('<li><strong>Total de Control Necesario: Nivel de Sesi\00F3n</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico de la sesi\00F3n actual. Utilice ')
||unistr('esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados en la sesi\00F3n actual.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(211618610714373977.4001)
,p_name=>'P4303_SCOPE'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(455433462.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1mbito')
,p_source=>'SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_ITEM_SCOPE'
,p_lov=>'.'||wwv_flow_api.id(211617631947367477.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifique <em>Global</em> si la sesi\00F3n de &PRODUCT_NAME. se comparte entre m\00E1s de una aplicaci\00F3n y el valor del elemento debe ser el mismo para todas las aplicaciones.'),
'<br/>',
unistr('De lo contrario, especifique <em>Aplicaci\00F3n</em> (\00E9ste es el valor por defecto).'),
'</p>',
'<p>',
unistr('Las aplicaciones pueden compartir la misma sesi\00F3n si sus autenticaciones tienen los mismos <em>atributos de cookies de sesi\00F3n</em>.'),
unistr('El atributo <em>\00C1mbito</em> de los elementos de las aplicaciones debe ser el mismo en dichas aplicaciones.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361951120886513562.4001)
,p_name=>'P4303_DATA_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(17312310527965891.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'VARCHAR'
,p_prompt=>'Tipo de Dato'
,p_source=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:NUMBER;NUMBER,VARCHAR;VARCHAR'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>':fb_flow_id between 4000 and 4999'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Si se define un valor como num\00E9rico se garantiza que cuando se defina el estado de la sesi\00F3n, \00E9ste sea num\00E9rico.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62012316248584175.4001)
,p_validation_name=>'F4000_P4303_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4303_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(21942143986.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 08-JUN-2001 11:09'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62012510270584176.4001)
,p_validation_name=>'F4000_P4303_NAME Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4303_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_associated_item=>wwv_flow_api.id(21943143987.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 08-JUN-2001 11:09'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(69315223364661257.4001)
,p_validation_name=>'item not exists'
,p_validation_sequence=>30
,p_validation=>'not wwv_flow_builder.is_item_name_used(p_flow=>:FB_FLOW_ID,p_name=>upper(:F4000_P4303_NAME))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nombre del elemento ya lo est\00E1 utilizando un elemento de aplicaci\00F3n o de p\00E1gina existente.')
,p_when_button_pressed=>wwv_flow_api.id(21937143985.4001)
,p_associated_item=>wwv_flow_api.id(21943143987.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(70258610007099366.4001)
,p_validation_name=>'item name not dup on edit'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_builder.is_item_name_duplicate(',
'  p_flow=>:FB_FLOW_ID,p_id=>:F4000_P4303_ID,p_name=>:F4000_P4303_NAME)'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El nombre del elemento ya lo est\00E1 utilizando otro elemento de aplicaci\00F3n o p\00E1gina.  ')
,p_when_button_pressed=>wwv_flow_api.id(21936143985.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(107687001406716203.4001)
,p_validation_name=>'valid item name'
,p_validation_sequence=>50
,p_validation=>'F4000_P4303_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('El nombre "&F4000_P4303_NAME." s\00F3lo puede contener caracteres alfanum\00E9ricos y de subrayado "_".')
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(21943143987.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21946143987.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_ITEMS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_items',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4303_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_ITEMS'',',
'  p_rowid       => v(''F4000_P4303_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21947143988.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ITEMS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4303_ID is null',
'or exists (select 1 from wwv_flow_items',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4303_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_ITEMS'',',
'p_rowid       => v(''F4000_P4303_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>'Elemento procesado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(62220711958189689.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'warn on long name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:F4000_P4303_NAME) > 30 then',
'   wwv_flow.g_notification := ''Warning... flow items with names longer then 30 bytes can not be used as bind variables.'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(21937143985.4001)
);
end;
/
prompt --application/pages/page_04304
begin
wwv_flow_api.create_page(
 p_id=>4304.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear/Editar: C\00E1lculos')
,p_step_title=>unistr('Crear/Editar: C\00E1lculo de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_comp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(474996958.4001)
,p_plug_name=>unistr('C\00E1lculo de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(475005575.4001)
,p_plug_name=>'Elemento'
,p_region_name=>'I'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(476008649.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(81008210556197147.4001)
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(477016621.4001)
,p_plug_name=>unistr('C\00E1lculos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Los c\00E1lculos de aplicaci\00F3n se realizan para cada p\00E1gina en el punto de c\00E1lculo, excepto los c\00E1lculos En Nueva Instancia que se ejecutan al crear una sesi\00F3n l\00F3gica nueva.</p>  <p>Si desea definir un elemento igual que el valor de otro elemento, uti')
||unistr('lice la sintaxis &amp;ITEM_NAME. en el campo de c\00E1lculo con el tipo de c\00E1lculo "Asignaci\00F3n Est\00E1tica".</p> ')
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46262726407679018.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145703210893876094.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145705302698879924.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_name=>'AUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(81008210556197147.4001)
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167082316394200777.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185533214224429562.4001)
,p_plug_name=>unistr('C\00E1lculo')
,p_region_name=>'COM'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203952522346859792.4001)
,p_plug_name=>'Frecuencia'
,p_region_name=>'FRE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615500923207226126.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_COMPUTATIONS',
'where id = :F4000_P4304_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4304_ID,',
'      p_component_type => ''Application Computations'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21949143988.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(474996958.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21950143988.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(474996958.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4304_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21951143988.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(474996958.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4304_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21952143988.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(474996958.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear C\00E1lculo')
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4304_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(36784333218.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(21950143988.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21953143989.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(480505568.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'v(''FB_FLOW_PAGE_ID'') is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21954143989.4001)
,p_branch_action=>'4101'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9175636984.4001)
,p_name=>'F4000_P4304_REQUIRED_PATCH'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(167082316394200777.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente.<p/>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21956143990.4001)
,p_name=>'F4000_P4304_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(475005575.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21957143990.4001)
,p_name=>'F4000_P4304_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(475005575.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21958143990.4001)
,p_name=>'F4000_P4304_COMPUTATION_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(475005575.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>'COMPUTATION_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21959143990.4001)
,p_name=>'F4000_P4304_COMPUTATION_ITEM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(475005575.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Elemento de C\00E1lculo')
,p_source=>'COMPUTATION_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'COMPUTATION_ITEM'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''APPLICATION'')||'': ''||name d, name v',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select wwv_flow_lang.system_message(''PAGE'')||'': ''||flow_step_id||'' ''||name d, name v',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un elemento de nivel de aplicaci\00F3n o de p\00E1gina al que afecta este c\00E1lculo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21960143991.4001)
,p_name=>'F4000_P4304_COMPUTATION_POINT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(203952522346859792.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ON_NEW_INSTANCE'
,p_prompt=>unistr('Punto de C\00E1lculo')
,p_source=>'COMPUTATION_POINT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_COMPUTATION_POINTS'
,p_lov=>'.'||wwv_flow_api.id(48425308522403722.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione uno de los puntos de proceso predefinidos en los que se debe realizar el c\00E1lculo. La selecci\00F3n de <strong>Despu\00E9s de Ejecuci\00F3n</strong> hace que se ejecute el c\00E1lculo s\00F3lo despu\00E9s de que aparezca y se ejecute la p\00E1gina. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21962143992.4001)
,p_name=>'F4000_P4304_COMPUTATION_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(185533214224429562.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'STATIC_ASSIGNMENT'
,p_prompt=>unistr('Tipo de C\00E1lculo')
,p_source=>'COMPUTATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP COMPUTATION TYPES'
,p_lov=>'.'||wwv_flow_api.id(84926512995804334.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la forma en la que se realizar\00E1 este c\00E1lculo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21964143992.4001)
,p_name=>'F4000_P4304_COMPUTATION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(185533214224429562.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00E1lculo')
,p_source=>'COMPUTATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la l\00F3gica de c\00E1lculo que corresponde al tipo de c\00E1lculo, &nbsp;por ejemplo:'),
'<UL>',
unistr('<LI>C\00E1lculo de Consulta:'),
'<pre>select to_char(sysdate,''YYYYMMDD'') from dual</pre></LI>',
'<LI>SQL_EXPRESION: ',
'<pre>to_char(sysdate,''YYYYMMDD'')</pre></LI>',
'<LI>STATIC_ASSIGNMENT: ',
'<pre>HELLO</pre></LI>',
'<LI>PLSQL_EXPRESSION: ',
'<pre>365 &gt; v(''DAYS_ELAPSED'')</pre></LI>',
'</UL>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21965143993.4001)
,p_name=>'F4000_P4304_COMPUTATION_COMMENT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(145703210893876094.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMPUTATION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21966143993.4001)
,p_name=>'F4000_P4304_COMPUTE_WHEN'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(476008649.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'COMPUTE_WHEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice este atributo para controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n seleccionado. Si se cumple la condici\00F3n especificada, se presenta o procesa el ')
||'componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21967143993.4001)
,p_name=>'F4000_P4304_COMPUTE_WHEN_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(476008649.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'COMPUTE_WHEN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista que se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4304_COMPUTE_WHEN'
,p_attribute_02=>'F4000_P4304_COMPUTE_WHEN_TEXT'
,p_attribute_04=>'F4000_P4304_COMPUTE_WHEN_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4304_COMPUTE_WHEN_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130028238902.4001)
,p_name=>'F4000_P4304_COMPUTATION_ERROR_MESSAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(185533214224429562.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Mensaje de Error de C\00E1lculo')
,p_source=>'COMPUTATION_ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el texto para que aparezca un mensaje de error si falla el c\00E1lculo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(275598274926.4001)
,p_name=>'F4000_P4304_COMPUTE_WHEN_TEXT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(476008649.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'COMPUTE_WHEN_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2100734087586209.4001)
,p_name=>'F4000_P4304_COMPUTE_WHEN_LANG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(476008649.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2103320729627592.4001)
,p_name=>'F4000_P4304_COMPUTATION_LANG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(185533214224429562.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'COMPUTATION_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P4304_COMPUTATION_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(147184318455081486.4001)
,p_name=>'F4000_P4304_SECURITY_SCHEME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(145705302698879924.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este componente se presente o se procese.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435040930119654784.4001)
,p_name=>'F4000_P4304_COMPUTE_WHEN_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(476008649.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36678931215035872.4001)
,p_validation_name=>'item must exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null from (select 1',
'                    from wwv_flow_items',
'                   where flow_id = :FB_FLOW_ID',
'                     and name = upper(v(''F4000_P4304_COMPUTATION_ITEM''))',
'                   union all',
'                   select 1',
'                     from wwv_flow_step_items',
'                    where flow_id = :FB_FLOW_ID',
'                      and name = upper(v(''F4000_P4304_COMPUTATION_ITEM'')))'))
,p_validation_type=>'EXISTS'
,p_error_message=>'El elemento no existe'
,p_validation_condition=>'Create, Apply Changes'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21959143990.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(36680815762040916.4001)
,p_validation_name=>'must supply computation'
,p_validation_sequence=>20
,p_validation=>'F4000_P4304_COMPUTATION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el c\00E1lculo.')
,p_validation_condition=>'Create, Apply Changes'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21964143992.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21968143993.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_COMPUTATIONS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_computations',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4304_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_COMPUTATIONS'',',
'  p_rowid       => v(''F4000_P4304_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21969143994.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_COMPUTATIONS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4304_ID is null',
'or exists (select 1 from wwv_flow_computations',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4304_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_COMPUTATIONS'',',
'p_rowid       => v(''F4000_P4304_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04305
begin
wwv_flow_api.create_page(
 p_id=>4305.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Separador Est\00E1ndar')
,p_step_title=>unistr('Editar Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(462588551.4001)
,p_plug_name=>unistr('Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(463590414.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(464604042.4001)
,p_plug_name=>'Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Cuando se utilizan separadores est\00E1ndar, la p\00E1gina se asocia a un juego de separadores (o a una recopilaci\00F3n de separadores relacionados). Cada separador del juego de separadores identifica una p\00E1gina que se designa como actual (o seleccionada). Pued')
||unistr('e especificar otras p\00E1ginas para que sean la actual para un separador con el atributo Separador tambi\00E9n Actual para P\00E1ginas. Si desea utilizar dos niveles de separadores, debe especificar un juego de separadores principales en el atributo Juego de Se')
||'paradores Principales.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33940909982.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'CONDITIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(303236693948.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46263816985679020.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46720126060136757.4001)
,p_plug_name=>unistr('Im\00E1genes')
,p_region_name=>'IMG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46766726670181982.4001)
,p_plug_name=>'Juego de Separadores Principales'
,p_region_name=>'P'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145717022514901086.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_name=>'AUTH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167043408008174269.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180275209988934962.4001)
,p_plug_name=>unistr('Actual para P\00E1ginas')
,p_region_name=>'CURR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615476809776127566.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_TABS ',
'where id = :F4000_P4305_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4305_ID,',
'      p_component_type => ''Tab'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21971143994.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(462588551.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21972143994.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(462588551.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4305_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21973143994.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(462588551.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4305_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21974143994.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(462588551.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4305_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(21976143995.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(241522187.4001)
,p_name=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(180275209988934962.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Separador Tambi\00E9n Actual para P\00E1ginas')
,p_source=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">En el caso de que un separador corresponda a m\00E1s de una p\00E1gina, muestre todas las p\00E1ginas que son "actuales" delimitadas por comas. Por ejemplo:</div>'),
'<pre>12,13,33</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4508871236.4001)
,p_name=>'F4000_P4305_TAB_DISP_COND_TEXT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(33940909982.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'TAB_DISP_COND_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9176653287.4001)
,p_name=>'F4000_P4305_REQUIRED_PATCH'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(167043408008174269.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</div>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11123716925.4001)
,p_name=>'F4000_P4305_TAB_PARENT_TABSET'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(46766726670181982.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego&nbsp;de&nbsp;Separadores&nbsp;Principales'
,p_source=>'TAB_PARENT_TABSET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PARENT_TABSETS'
,p_lov=>'select distinct wwv_flow_escape.html(tab_set) d, tab_set r from wwv_flow_toplevel_tabs where flow_id = :fb_flow_id order by 1'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores Principales -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Un juego de separadores principales funciona como contenedor de un grupo de separadores est\00E1ndar. Si la aplicaci\00F3n utiliza dos niveles de separadores, debe seleccionar un juego de separadores principales.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21978143995.4001)
,p_name=>'F4000_P4305_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21979143996.4001)
,p_name=>'F4000_P4305_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n asociada a este separador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21980143996.4001)
,p_name=>'F4000_P4305_TAB_SET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Juego de Separadores Est\00E1ndar')
,p_source=>'TAB_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABSETS WITH EMPTY SETS UNIONED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d) d, r',
'  from wwv_flow_tabset_view2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Juego de Separadores Est\00E1ndar -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione los juegos de separadores est\00E1ndar a los que se agregar\00E1 esta entrada de separador.')
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fixed spelling of label 01.22.02 -- Scott S.',
'',
'',
'',
'',
'',
'',
'',
'sleuniss: previous query',
'',
'',
'',
'select distinct tab_set from wwv_flow_tabs where flow_id = &FB_FLOW_ID order by 1'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21981143996.4001)
,p_name=>'F4000_P4305_TAB_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>'TAB_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'TAB_SEQUENCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct tab_sequence a, tab_sequence b',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21982143997.4001)
,p_name=>'F4000_P4305_TAB_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Separador'
,p_source=>'TAB_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre \00FAnico para este separador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21983143997.4001)
,p_name=>'F4000_P4305_TAB_IMAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(46720126060136757.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen de Separador Actual'
,p_source=>'TAB_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Especifique la imagen que se mostrar\00E1 cuando el separador sea actual. Por ejemplo:</div>'),
'<pre>',
'   tab1.gif',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21984143997.4001)
,p_name=>'F4000_P4305_TAB_TEXT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta de Separador'
,p_source=>'TAB_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto que aparece como separador (si no se han utilizado im\00E1genes de separador). Si se utilizan im\00E1genes de separador, este nombre se convierte en el texto alternativo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21985143998.4001)
,p_name=>'F4000_P4305_TAB_STEP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(180275209988934962.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina de Separador')
,p_source=>'TAB_STEP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>4
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el identificador de la p\00E1gina a la que navegar\00E1 el usuario cuando seleccione este separador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33939893897.4001)
,p_name=>'F4000_P4305_TAB_PLSQL_CONDITION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(33940909982.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'TAB_PLSQL_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o procesa')
||' el componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64067896247.4001)
,p_name=>'F4000_P4305_DISPLAY_CONDITION_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(33940909982.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'DISPLAY_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n de Visualizaci\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista. Este tipo de condici\00F3n se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4305_TAB_PLSQL_CONDITION'
,p_attribute_02=>'F4000_P4305_TAB_DISP_COND_TEXT'
,p_attribute_04=>'F4000_P4305_TAB_PLSQL_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4305_DISPLAY_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(219831439971.4001)
,p_name=>'F4000_P4305_TAB_NON_CURRENT_IMAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(46720126060136757.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen&nbsp;de Separador no Actual'
,p_source=>'TAB_NON_CURRENT_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Especifique la imagen que aparece cuando el separador no es actual. Por ejemplo:</div>',
'<pre>',
'   tab_inactive.gif',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(219831439972.4001)
,p_name=>'F4000_P4305_TAB_IMAGE_ATTRIBUTES'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(46720126060136757.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos&nbsp;de&nbsp;Imagen'
,p_source=>'TAB_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Incluya atributos de imagen. Por ejemplo:',
'<pre>border="0" width="34" height="22"</pre>',
'<div class="htmldbInfoBodyP">Los atributos de imagen se incluyen en la etiqueta HTML &lt;img&gt;.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293048221908.4001)
,p_name=>'F4000_P4305_SECURITY_SCHEME'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(145717022514901086.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este componente se presente o se procese.</p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(303238700264.4001)
,p_name=>'F4000_P4305_TAB_COMMENT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(303236693948.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TAB_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'mike added 01.08.01'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2202391078381358.4001)
,p_name=>'F4000_P4305_DISPLAY_CONDITION_LANG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(33940909982.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(23659613323072909.4001)
,p_name=>'P4305_OLD_TABSET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(463590414.4001)
,p_prompt=>'Old Tabset'
,p_source=>'F4000_P4305_TAB_SET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435041226594654785.4001)
,p_name=>'F4000_P4305_TAB_PLSQL_CONDITION_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(33940909982.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(49389322403096293.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4305_TAB_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:F4000_P4305_TAB_NAME,'''''''','''')'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25924427102259776.4001)
,p_validation_name=>'tab name not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4305_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21982143997.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25925228964269781.4001)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4305_TAB_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21981143996.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25925821476277086.4001)
,p_validation_name=>'sequence is numeric'
,p_validation_sequence=>30
,p_validation=>'F4000_P4305_TAB_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La secuencia debe ser num\00E9rica.')
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21981143996.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25926414681284558.4001)
,p_validation_name=>'tab label not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P4305_TAB_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la etiqueta.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21984143997.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(25927028449307478.4001)
,p_validation_name=>'page exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id = :FB_FLOW_ID',
'   and id = :F4000_P4305_TAB_STEP'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('Se debe especificar una p\00E1gina existente.')
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(21985143998.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8009122126989976.4001)
,p_validation_name=>'tab also current for pages'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :TAB_ALSO_CURRENT_FOR_PAGES is null then',
'return true;',
'elsif rtrim(translate(:TAB_ALSO_CURRENT_FOR_PAGES,''0123456789, '',''00000000000''),''0'') is not null then',
'return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Utilice n\00FAmeros de p\00E1gina y comas. Por ejemplo: 1,2,3')
,p_associated_item=>wwv_flow_api.id(241522187.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21986143998.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_TABS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_tabs',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4305_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_TABS'',',
'  p_rowid       => v(''F4000_P4305_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(21987143998.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_TABS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4305_ID is null',
'or exists (select 1 from wwv_flow_tabs',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4305_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_TABS'',',
'p_rowid       => v(''F4000_P4305_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>'Elemento de separador "&F4000_P4305_TAB_NAME." procesado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23666808353137702.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Move assoc pages to new tabset'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_tab_page      varchar2(30);',
'    l_also_cur_for  varchar2(4000);',
'begin',
'    for c1 in (select TAB_STEP,TAB_ALSO_CURRENT_FOR_PAGES',
'                 from wwv_flow_tabs',
'                where id = :F4000_P4305_ID)',
'    loop',
'        l_tab_page      :=  c1.TAB_STEP;',
'        l_also_cur_for  :=  c1.TAB_ALSO_CURRENT_FOR_PAGES;',
'        exit;',
'    end loop;',
'                   ',
'    wwv_flow_tab_mgr.update_tab_pages(',
'            p_tab_id        => :F4000_P4305_ID,',
'            p_tab_set       => :F4000_P4305_TAB_SET,',
'            p_flow          => :F4000_P4305_FLOW_ID,',
'            p_tab_page      => l_tab_page,',
'            p_also_cur_for  => l_also_cur_for);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':REQUEST = ''ApplyChanges'' AND :F4000_P4305_TAB_SET != :P4305_OLD_TABSET'
);
end;
/
prompt --application/pages/page_04307
begin
wwv_flow_api.create_page(
 p_id=>4307.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Plantilla'
,p_step_title=>unistr('Editar Plantilla de P\00E1gina')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'  htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'//-->',
'</script>',
'',
''))
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_templates t, wwv_flow_themes th',
'where t.id = :F4000_P4307_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_page.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(541989765.4001)
,p_plug_name=>'button box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(542993683.4001)
,p_plug_name=>unistr('Definici\00F3n')
,p_region_name=>'TEMP'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(543003816.4001)
,p_plug_name=>'Subplantilla'
,p_region_name=>'SUBTEMP'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_header=>unistr('Introduzca el HTML para las subplantillas a continuaci\00F3n. Las subplantillas se colocar\00E1n dentro del cuerpo de la plantilla de p\00E1gina mediante cadenas de sustituci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(544005752.4001)
,p_plug_name=>unistr('Atributos de Separadores Est\00E1ndar')
,p_region_name=>'STDTAB'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  flow_id = :fb_flow_id',
'and    nvl(navigation_type,''T'') = ''L'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(545007733.4001)
,p_plug_name=>'Atributos de Separadores Principal'
,p_region_name=>'PARTAB'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  flow_id = :fb_flow_id',
'and    nvl(navigation_type,''T'') = ''L'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(547026858.4001)
,p_plug_name=>unistr('Plantillas de P\00E1gina')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las plantillas definen el aspecto de una p\00E1gina. Cada plantilla consta de una plantilla de cabecera, una plantilla de cuerpo y una plantilla de pie de p\00E1gina, as\00ED como de un n\00FAmero de definiciones de subplantillas.</p>'),
''))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(548047061.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1257318030.4001)
,p_plug_name=>'Atributos de Separador Basado en Imagen'
,p_region_name=>'IMGTAB'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(131914703603.4001)
,p_plug_name=>unistr('Dise\00F1o')
,p_region_name=>'GRID'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33421119555122202.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4307_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_TEMPLATES'
,p_attribute_02=>'NAME'
,p_attribute_03=>'F4000_P4307_ID'
,p_attribute_04=>'F4000_P4307_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34390928027007081.4001)
,p_plug_name=>'Hoja de Estilo en Cascada'
,p_region_name=>'CSS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(34407606078341355.4001)
,p_plug_name=>'JavaScript'
,p_region_name=>'JAVASCRIPT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46265504325679023.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>180
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(53603513531407414.4001)
,p_plug_name=>unistr('Cuadro de Di\00E1logo')
,p_region_name=>'DIALOG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>215
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92883220926574957.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(153171308852373878.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117321519519339260.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117385421687588488.4001)
,p_plug_name=>unistr('Control de Plantilla de P\00E1gina de Error')
,p_region_name=>'ERROR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>240
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117398103762627232.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>260
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161865231402504850.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_name=>'T'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>265
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_region_layout.page_template_substitution(',
'   p_flow=>:FB_FLOW_ID,   ',
'   p_template_id=>:F4000_P4307_ID );',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings=>'Flow:Region:Page'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>unistr('<font class="fielddata">No se ha encontrado ning\00FAn uso.</font>')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n se utilizan en las plantillas para hacer referencia a los valores del componente. Este informe detalla el uso de la cadena de sustituci\00F3n para esta plantilla.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(262121216799808381.4001)
,p_plug_name=>'Posiciones'
,p_region_name=>'DISPLAY_POINT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ROWID",',
'       "FLOW_ID",',
'       "PAGE_TEMPLATE_ID",',
'       "NAME",',
'       "PLACEHOLDER",',
'       "HAS_GRID_SUPPORT",',
'       "HAS_REGION_SUPPORT",',
'       "HAS_ITEM_SUPPORT",',
'       "HAS_BUTTON_SUPPORT",',
'       "GLV_NEW_ROW",',
'       "MAX_FIXED_GRID_COLUMNS"',
'  from wwv_flow_page_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and page_template_id  = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4307_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Posiciones'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cree posiciones para la plantilla de esta p\00E1gina. Las posiciones permiten identificar d\00F3nde se mostrar\00E1n los componentes (regiones, elementos, botones) en la plantilla de esta p\00E1gina.'),
'<br />',
unistr('Las posiciones pueden utilizarse para restringir la ubicaci\00F3n de las regiones, elementos y botones en la plantilla de esta p\00E1gina al configurar qu\00E9 tipo de componente est\00E1 soportado en una posici\00F3n.'),
'<br />',
unistr('La <strong>sustituci\00F3n de plantilla</strong> de una posici\00F3n no puede ser una de las cadenas de sustituci\00F3n de la p\00E1gina reservada; por ejemplo, NOTIFICATION_MESSAGE. Consulte la secci\00F3n <strong>Cadenas de sustituci\00F3n</strong> a continuaci\00F3n para obt')
||'ener la lista completa.'))
);
wwv_flow_api.create_region_column_group(
 p_id=>wwv_flow_api.id(2103274483292119.4001)
,p_heading=>unistr('Presentaci\00F3n de dise\00F1o de cuadr\00EDcula')
);
wwv_flow_api.create_region_column_group(
 p_id=>wwv_flow_api.id(4311638742030101.4001)
,p_heading=>'Soporte de tipo de componente'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2101874581292105.4001)
,p_name=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ROWID'
,p_data_type=>'ROWID'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2101910896292106.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102087818292107.4001)
,p_name=>'PAGE_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4307_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102178764292108.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Nombre de posici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102230538292109.4001)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Sustituci\00F3n de Plantilla')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102308595292110.4001)
,p_name=>'HAS_GRID_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_GRID_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>unistr('Soporte de Cuadr\00EDcula')
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(2103274483292119.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102446912292111.4001)
,p_name=>'HAS_REGION_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_REGION_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Regiones'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(4311638742030101.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102504905292112.4001)
,p_name=>'HAS_ITEM_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_ITEM_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Elementos'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(4311638742030101.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102641659292113.4001)
,p_name=>'HAS_BUTTON_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_BUTTON_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Botones'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(4311638742030101.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102706624292114.4001)
,p_name=>'GLV_NEW_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GLV_NEW_ROW'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Nueva Fila'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>140
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(2103274483292119.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102860268292115.4001)
,p_name=>'MAX_FIXED_GRID_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MAX_FIXED_GRID_COLUMNS'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>unistr('M\00E1ximo de Columnas de Cuadr\00EDcula Fijas	')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>130
,p_value_alignment=>'RIGHT'
,p_group_id=>wwv_flow_api.id(2103274483292119.4001)
,p_use_group_for=>'BOTH'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4307_GRID_MAX_COLUMNS'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2102964446292116.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(2103031133292117.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(2101731088292104.4001)
,p_internal_uid=>2101731088292104
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615297506447484334.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>270
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_TEMPLATES',
'where id = :F4000_P4307_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4307_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(629607275487003693.4001)
,p_name=>'Opciones de Plantilla'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and page_template_id   = :F4000_P4307_ID',
'   and security_group_id  = :WORKSPACE_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4307_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(629608124580003710.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(629607769259003709.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(687938418135089853.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(629607865055003709.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(687938578411089856.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(687938670197089856.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(688591550788660687.4001)
,p_name=>'Opciones de Plantilla Global'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_parent_plug_id=>wwv_flow_api.id(629607275487003693.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>280
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o, wwv_flow_templates t',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.virtual_template_id   is null',
'   and o.template_types = ''PAGE''',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P4307_ID   ',
'   and o.security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4307_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688592244361660689.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
end;
/
begin
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688592067235660689.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688591714058660689.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688592154564660689.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688591870913660689.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688591900965660689.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2104757477592773343.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>15
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4307_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4307_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75342716186817071.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(541989765.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(75342608829817071.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(541989765.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(165188919623029588.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33421119555122202.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4307_ID.,&FLOW_PAGE_ID.,PAGE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_templates',
'',
'where reference_id = :F4000_P4307_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(163582115209140770.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33421119555122202.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_templates',
'where id = :F4000_P4307_ID',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(629608248623003711.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(629607275487003693.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_PAGE_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P4307_THEME.,&F4000_P4307_ID.,PAGE'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22002144001.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(541989765.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22003144001.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(541989765.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:298:&SESSION.::&DEBUG.::P298_ID:&F4000_P4307_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''F4000_P4307_ID'') is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22004144002.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(541989765.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''F4000_P4307_ID'') is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22005144002.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(541989765.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''F4000_P4307_ID'') is null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30628311052631110.4001)
,p_branch_name=>'Go To Page 149'
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4307_ID.,PAGE,4307:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4307_PUBLISH'
,p_branch_condition_text=>'PUBLISH'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75354001488817237.4001)
,p_branch_action=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.::F4000_P4307_ID:&P4307_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(75342608829817071.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(75354425649817240.4001)
,p_branch_action=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.::F4000_P4307_ID:&P4307_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(75342716186817071.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(112551849596702847.4001)
,p_branch_action=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4307_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22007144002.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(610545004.4001)
,p_branch_action=>'920'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Copy'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22008144002.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(513170525.4001)
,p_name=>'F4000_P4307_MESSAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(543003816.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Notificaci\00F3n')
,p_source=>'MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML o texto que se sustituir\00E1 al hacer referencia a la cadena #NOTIFICATION_MESSAGE# en la cabecera, cuerpo o pie de p\00E1gina de la plantilla.</div>'),
'<p>',
unistr('<div class="htmldbInfoBodyP">Las siguientes cadenas de sustituci\00F3n est\00E1n soportadas en la subplantilla de notificaci\00F3n:'),
'<ul>',
'  <li>#MESSAGE#</li>',
'  <li>#NOTIFICATION_MESSAGE_HEADER#</li>',
'</ul>',
'</p>',
'<p>',
unistr('<div class="htmldbInfoBodyP">Utilice la cadena de sustituci\00F3n #MESSAGE# para indicar en qu\00E9 parte del mensaje de notificaci\00F3n aparecer\00E1 el cuerpo del mensaje.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>',
'&lt;table&gt;&lt;tr&gt;&lt;td&gt;#MESSAGE#&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(802929285.4001)
,p_name=>'F4000_P4307_TEMPLATE_COMMENT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(117398103762627232.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.</div>')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1493920202.4001)
,p_name=>'F4000_P4307_SUCCESS_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(543003816.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mensaje Correcto'
,p_source=>'SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que sustituir\00E1 a la cadena #SUCCESS_MESSAGE# en el cuerpo, cabecera o pie de p\00E1gina de la plantilla. <br /><br />'),
'Por ejemplo:',
'<pre>',
'&lt;b&gt;#SUCCESS_MESSAGE#&lt;/b&gt;',
'</pre>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1494929072.4001)
,p_name=>'F4000_P4307_CURRENT_TAB'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(544005752.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador Actual'
,p_source=>'CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML o texto que se sustituir\00E1 por el separador est\00E1ndar seleccionado actualmente.'),
'<br /><br />',
'Por ejemplo:',
'<br /><pre>',
'&lt;td&gt;#TAB_LABEL#&lt;/td&gt;',
'</pre>',
unistr('Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles:'),
'<br />',
'<ul>',
unistr('<li>#TAB_LABEL# - necesaria, muestra el texto de visualizaci\00F3n del separador</li>'),
'<li>#TAB_IMAGE# - nombre de archivo de imagen</li>',
'<li>#TAB_INLINE_EDIT# - permite a los desarrolladores de aplicaciones editar el separador</li>',
unistr('<li>#TAB_LINK# - Si hace clic en este separador, ir\00E1 a este enlace</li>'),
unistr('<li>#TAB_NAME# - Nombre del separador, no el texto de visualizaci\00F3n</li>'),
'<li>#TAB_NAME_ENCODED# - Nombre del separador codificado</li>',
'<li>#TAB_FONT_ATTRIBUTES# - Incluye el texto especificado en el atributo de plantilla</li>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1495931144.4001)
,p_name=>'F4000_P4307_NON_CURRENT_TAB'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(544005752.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Separador Est\00E1ndar no Actual')
,p_source=>'NON_CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML o texto que se sustituir\00E1 por los separadores est\00E1ndar no seleccionados.'),
'<br /><br />',
'Por ejemplo:',
'<br /><pre>',
'&lt;td&gt;&lt;a href="#TAB_LINK#"&gt;#TAB_LABEL#&lt;/a&gt;&lt;/td&gt;',
'</pre>',
unistr('Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles:'),
'<br />',
'<ul>',
unistr('<li>#TAB_LABEL# - necesaria, muestra el texto de visualizaci\00F3n del separador</li>'),
'<li>#TAB_IMAGE# - nombre de archivo de imagen</li>',
'<li>#TAB_INLINE_EDIT# - permite a los desarrolladores de aplicaciones editar el separador</li>',
unistr('<li>#TAB_LINK# - Si hace clic en este separador, ir\00E1 a este enlace</li>'),
unistr('<li>#TAB_NAME# - Nombre del separador, no el texto de visualizaci\00F3n</li>'),
'<li>#TAB_NAME_ENCODED# - Nombre del separador codificado</li>',
'<li>#TAB_FONT_ATTRIBUTES# - Incluye el texto especificado en el atributo de plantilla</li>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1553920202.4001)
,p_name=>'F4000_P4307_BODY_TITLE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(117321519519339260.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'<b>Body Title</b> (Use #BODY_TITLE#, expands header BODY_TITLE substitution string)'
,p_source=>'BODY_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'select 1 from WWV_FLOW_TEMPLATES where BODY_TITLE is not null and id = :F4000_P4307_ID'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2148881144.4001)
,p_name=>'F4000_P4307_NON_CURRENT_IMAGE_TAB'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(1257318030.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador de Imagen no Actual'
,p_source=>'NON_CURRENT_IMAGE_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML que se utilizar\00E1 para indicar que un separador de imagen no est\00E1 seleccionado actualmente. Incluya la cadena de sustituci\00F3n #TAB_TEXT# para que aparezca el nombre mostrado del separador.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8029292853.4001)
,p_name=>'F4000_P4307_BOX'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(542993683.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cuerpo'
,p_source=>'BOX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML que constituye el cuerpo del documento HTML. Incluya cadenas de sustituci\00F3n para definir la colocaci\00F3n del contenido del cuerpo y las posiciones adicionales para las regiones.</p>'),
'',
'Por ejemplo: <br />',
'',
'<pre>',
'   &lt;body #ONLOAD#&gt;',
'      #FORM_OPEN#',
'      #BOX_BODY#',
'      #FORM_CLOSE#',
'      #GENERATED_CSS#',
'      #APEX_JAVASCRIPT#',
'      #THEME_JAVASCRIPT#',
'      #TEMPLATE_JAVASCRIPT#',
'      #APPLICATION_JAVASCRIPT#',
'      #PAGE_JAVASCRIPT#',
'      #GENERATED_JAVASCRIPT#',
'   &lt;/body&gt;',
'</pre>',
unistr('<p>Debe incluir al menos #BOX_BODY#, #FORM_OPEN# y #FORM_CLOSE# en esta secci\00F3n de la plantilla. Se permiten las siguientes cadenas de sustituci\00F3n en el cuerpo de plantilla:'),
'<ul>',
'<li>#BOX_BODY#</li>',
'<li>#GENERATED_CSS#</li>',
'<li>#GENERATED_JAVASCRIPT#</li>',
'<li>#ONLOAD#</li>',
'<li>#TITLE# </li>',
'<li>#PAGE_STATIC_ID#</li>',
'<li>#TOP_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#SIDE_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#NAVIGATION_BAR#</li> ',
'<li>#NOTIFICATION_MESSAGE#</li>',
'<li>#SUCCESS_MESSAGE#</li>',
'<li>#GLOBAL_NOTIFICATION#</li>',
'<li>#APEX_CSS#</li>',
'<li>#THEME_CSS#</li>',
'<li>#TEMPLATE_CSS#</li>',
'<li>#THEME_STYLE_CSS#</li>',
'<li>#APPLICATION_CSS#</li>',
'<li>#PAGE_CSS#</li>',
'<li>#PAGE_CSS_CLASSES#</li>',
'<li>#APEX_JAVASCRIPT#</li>',
'<li>#THEME_JAVASCRIPT#</li>',
'<li>#TEMPLATE_JAVASCRIPT#</li>',
'<li>#APPLICATION_JAVASCRIPT#</li>',
'<li>#PAGE_JAVASCRIPT#</li>',
'<li>#DEVELOPER_TOOLBAR#</li>',
'<li>#SCREEN_READER_TOGGLE#</li>',
'<li>#HIGH_CONTRAST_TOGGLE#</li>',
'<li>#LANGUAGE_SELECTOR#</li>',
'<li>#WELCOME_USER#</li>',
'<li>#HOME_LINK#</li>',
'<li>#LOGOUT_URL#</li>',
'<li>#LOGIN_URL#</li>',
'<li>#REQUESTED_URL#</li>',
'<li>#PAGE_TRANSITION#</li>',
'<li>#POPUP_TRANSITION#</li>',
'<li>#EXPAND_COLLAPSE_NAV_LABEL#</li>',
'<li>#EXPAND_COLLAPSE_SIDE_COL_LABEL#</li>',
'<li>#OUTDATED_BROWSER#</li>',
'<li>#APP_VERSION#</li>',
'<li>#LOGO#</li>',
'<li>#PARENT_TAB_CELLS#</li>',
'<li>#TAB_CELLS#</li>',
'<li>#FORM_OPEN#</li>',
'<li>#FORM_CLOSE#</li>',
'</ul>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8029292854.4001)
,p_name=>'F4000_P4307_NAVIGATION_BAR'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(543003816.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Barra de Navegaci\00F3n')
,p_source=>'NAVIGATION_BAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Introduzca el HTML o texto que se sustituir\00E1 al hacer referencia a la cadena #NAVIGATION_BAR# en la cabecera, cuerpo o pie de p\00E1gina de la plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Utilice la cadena de sustituci\00F3n #BAR_BODY# para indicar d\00F3nde aparecen las entradas de la barra de navegaci\00F3n.</div>'),
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>',
'&lt;table class="navBar"&gt;&lt;tr&gt;#BAR_BODY#&lt;/tr&gt;&lt;/table&gt;',
'</pre>',
unistr('<div class="htmldbInfoBodyP">La cadena de sustituci\00F3n #BAR_BODY# generar\00E1 las celdas de tabla HTML correspondientes.</div>')))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11495931144.4001)
,p_name=>'F4000_P4307_CURRENT_IMAGE_TAB'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(1257318030.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador de Imagen Actual'
,p_source=>'CURRENT_IMAGE_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML que se utilizar\00E1 para indicar que un separador de imagen est\00E1 seleccionado actualmente. Incluya la cadena de sustituci\00F3n #TAB_TEXT# para que aparezca el nombre mostrado del separador.'),
'<br /><br />',
'Por ejemplo:',
'<pre>',
'&lt;td&gt;#TAB_TEXT#&lt;/td&gt;',
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14949290722.4001)
,p_name=>'F4000_P4307_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(544005752.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Fuente de Separador Actual'
,p_source=>'CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'select 1 from wwv_flow_templates where CURRENT_TAB_FONT_ATTR is not null and id = :F4000_P4307_ID'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo es parte de la subplantilla de separador est\00E1ndar. Este valor sustituye a la cadena de sustituci\00F3n #TAB_FONT_ATTRIBUTES#.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'example: face=arial size=-1 color=white'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14959311442.4001)
,p_name=>'F4000_P4307_NON_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(544005752.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Fuente de Separador no Actual'
,p_source=>'NON_CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'select 1 from wwv_flow_templates where NON_CURRENT_TAB_FONT_ATTR is not null and id = :F4000_P4307_ID'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo es parte de la subplantilla de separador est\00E1ndar. Este valor sustituye a la cadena de sustituci\00F3n #TAB_FONT_ATTRIBUTES#.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21494929072.4001)
,p_name=>'F4000_P4307_TOP_CURRENT_TAB'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(545007733.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador Principal Actual'
,p_source=>'TOP_CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML o texto que se sustituir\00E1 por los separadores est\00E1ndar seleccionados.'),
'<br /><br />',
'Por ejemplo:',
'<br /><pre>',
'&lt;td&gt;&lt;a href="#TAB_LINK#"&gt;#TAB_LABEL#&lt;/a&gt;&lt;/td&gt;',
'</pre>',
unistr('Este atributo forma parte de la subplantilla del Separador Principal y ampl\00EDa la cadena de sustituci\00F3n #PARENT_TAB_CELLS#. '),
'<br /><br />',
unistr('Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles:'),
'<ul>',
'<li>#TAB_LABEL# - necesaria, representa la etiqueta de un separador</li>',
'<li>#TAB_IMAGE# - nombre de archivo de imagen</li>',
unistr('<li>#TAB_INLINE_EDIT# - incluye el enlace que permite a los desarrolladores realizar ediciones en l\00EDnea</li>'),
'<li>#TAB_LINK# - enlace utilizado para un separador</li>',
unistr('<li>#TAB_NAME# - nombre \00FAnico de un separador</li>'),
'<li>#TAB_NAME_ENCODED# - nombre codificado de un separador</li>',
'<li>#TAB_FONT_ATTRIBUTES# - atributos de fuente adicionales definidos para un separador</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21495931144.4001)
,p_name=>'F4000_P4307_TOP_NON_CURRENT_TAB'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(545007733.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Separador Principal no Actual'
,p_source=>'TOP_NON_CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el HTML o texto que se sustituir\00E1 por los separadores est\00E1ndar no seleccionados.'),
'<br /><br />',
'Por ejemplo:',
'<br /><pre>',
'&lt;td&gt;&lt;a href="#TAB_LINK#"&gt;#TAB_LABEL#&lt;/a&gt;&lt;/td&gt;',
'</pre>',
unistr('Este atributo forma parte de la subplantilla del Separador Principal y ampl\00EDa la cadena de sustituci\00F3n #PARENT_TAB_CELLS#. '),
'<br /><br />',
unistr('Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles:'),
'<ul>',
'<li>#TAB_LABEL# - necesaria, representa la etiqueta de un separador</li>',
'<li>#TAB_IMAGE# - nombre de archivo de imagen</li>',
unistr('<li>#TAB_INLINE_EDIT# - incluye el enlace que permite a los desarrolladores realizar ediciones en l\00EDnea</li>'),
'<li>#TAB_LINK# - enlace utilizado para un separador</li>',
unistr('<li>#TAB_NAME# - nombre \00FAnico de un separador</li>'),
'<li>#TAB_NAME_ENCODED# - nombre codificado de un separador</li>',
'<li>#TAB_FONT_ATTRIBUTES# - atributos de fuente adicionales definidos para un separador</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22009144002.4001)
,p_name=>'F4000_P4307_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(117321519519339260.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22011144003.4001)
,p_name=>'F4000_P4307_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica un nombre para esta plantilla.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22012144003.4001)
,p_name=>'F4000_P4307_HEADER_TEMPLATE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(542993683.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cabecera'
,p_source=>'HEADER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('En la secci\00F3n de cabecera de la plantilla, introduzca el HTML que constituye la secci\00F3n <code>&lt;HEAD&gt;</code> del documento HTML. Es decir, todas las etiquetas HTML necesarias antes del cuerpo del documento HTML. Incluya cadenas de sustituci\00F3n pa')
||unistr('ra incorporar contenido din\00E1mico. Por ejemplo: <br />'),
'<pre>',
'&lt;html&gt;',
' &lt;head&gt;',
'   &lt;title&gt;#TITLE#&lt;/title&gt;',
'   #APEX_CSS#',
'   #THEME_CSS#',
'   #TEMPLATE_CSS#',
'   #THEME_STYLE_CSS#',
'   #APPLICATION_CSS#',
'   #PAGE_CSS#',
'   #HEAD#',
' &lt;/head&gt;',
'</pre>',
unistr('Se recomienda incluir como m\00EDnimo #TITLE# y #HEAD# en esta secci\00F3n de la plantilla. Se soportan las siguientes cadenas de sustituci\00F3n en la cabecera de la plantilla:'),
'',
'<ul>',
'<li>#TITLE# </li>',
'<li>#HEAD#</li>',
'<li>#ONLOAD#</li>',
'<li>#PAGE_STATIC_ID#</li>',
'<li>#TOP_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#SIDE_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#NAVIGATION_BAR#</li> ',
'<li>#NOTIFICATION_MESSAGE#</li>',
'<li>#SUCCESS_MESSAGE#</li>',
'<li>#GLOBAL_NOTIFICATION#</li>',
'<li>#APEX_CSS#</li>',
'<li>#THEME_CSS#</li>',
'<li>#TEMPLATE_CSS#</li>',
'<li>#THEME_STYLE_CSS#</li>',
'<li>#APPLICATION_CSS#</li>',
'<li>#PAGE_CSS#</li>',
'<li>#PAGE_CSS_CLASSES#</li>',
'<li>#APEX_JAVASCRIPT#</li>',
'<li>#THEME_JAVASCRIPT#</li>',
'<li>#TEMPLATE_JAVASCRIPT#</li>',
'<li>#APPLICATION_JAVASCRIPT#</li>',
'<li>#PAGE_JAVASCRIPT#</li>',
'<li>#DEVELOPER_TOOLBAR#</li>',
'<li>#SCREEN_READER_TOGGLE#</li>',
'<li>#HIGH_CONTRAST_TOGGLE#</li>',
'<li>#LANGUAGE_SELECTOR#</li>',
'<li>#WELCOME_USER#</li>',
'<li>#HOME_LINK#</li>',
'<li>#LOGOUT_URL#</li>',
'<li>#LOGIN_URL#</li>',
'<li>#REQUESTED_URL#</li>',
'<li>#PAGE_TRANSITION#</li>',
'<li>#POPUP_TRANSITION#</li>',
'<li>#EXPAND_COLLAPSE_NAV_LABEL#</li>',
'<li>#EXPAND_COLLAPSE_SIDE_COL_LABEL#</li>',
'<li>#OUTDATED_BROWSER#</li>',
'<li>#APP_VERSION#</li>',
'<li>#LOGO#</li>',
'<li>#PARENT_TAB_CELLS#</li>',
'<li>#TAB_CELLS#</li>',
'<li>#CUSTOMIZE#</li>',
'<li>#FORM_OPEN#</li>',
'<li>#FORM_CLOSE#</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22013144004.4001)
,p_name=>'F4000_P4307_FOOTER_TEMPLATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(542993683.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Pie de P\00E1gina')
,p_source=>'FOOTER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El pie de p\00E1gina es la tercera secci\00F3n de la plantilla de p\00E1gina que aparece despu\00E9s del cuerpo.</p>'),
'',
unistr('<p>Se soportan las siguientes cadenas de sustituci\00F3n en el pie de p\00E1gina de la plantilla:'),
'',
'<ul>',
'<li>#GENERATED_CSS#</li>',
'<li>#GENERATED_JAVASCRIPT#</li>',
'<li>#PAGE_STATIC_ID#</li>',
'<li>#TOP_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#SIDE_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#NAVIGATION_BAR#</li> ',
'<li>#NOTIFICATION_MESSAGE#</li>',
'<li>#SUCCESS_MESSAGE#</li>',
'<li>#GLOBAL_NOTIFICATION#</li>',
'<li>#APEX_CSS#</li>',
'<li>#THEME_CSS#</li>',
'<li>#TEMPLATE_CSS#</li>',
'<li>#THEME_STYLE_CSS#</li>',
'<li>#APPLICATION_CSS#</li>',
'<li>#PAGE_CSS#</li>',
'<li>#PAGE_CSS_CLASSES#</li>',
'<li>#APEX_JAVASCRIPT#</li>',
'<li>#THEME_JAVASCRIPT#</li>',
'<li>#TEMPLATE_JAVASCRIPT#</li>',
'<li>#APPLICATION_JAVASCRIPT#</li>',
'<li>#PAGE_JAVASCRIPT#</li>',
'<li>#DEVELOPER_TOOLBAR#</li>',
'<li>#SCREEN_READER_TOGGLE#</li>',
'<li>#HIGH_CONTRAST_TOGGLE#</li>',
'<li>#LANGUAGE_SELECTOR#</li>',
'<li>#WELCOME_USER#</li>',
'<li>#HOME_LINK#</li>',
'<li>#LOGOUT_URL#</li>',
'<li>#LOGIN_URL#</li>',
'<li>#REQUESTED_URL#</li>',
'<li>#PAGE_TRANSITION#</li>',
'<li>#POPUP_TRANSITION#</li>',
'<li>#EXPAND_COLLAPSE_NAV_LABEL#</li>',
'<li>#EXPAND_COLLAPSE_SIDE_COL_LABEL#</li>',
'<li>#OUTDATED_BROWSER#</li>',
'<li>#APP_VERSION#</li>',
'<li>#LOGO#</li>',
'<li>#PARENT_TAB_CELLS#</li>',
'<li>#TAB_CELLS#</li>',
'<li>#CUSTOMIZE#</li>',
'<li>#FORM_OPEN#</li>',
'<li>#FORM_CLOSE#</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(50737423740.4001)
,p_name=>'F4000_P4307_RETURN_TO_PAGE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(547026858.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(131640028108.4001)
,p_name=>'F4000_P4307_REG_TAB_CATTR'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Atributos de Tabla de Regi\00F3n')
,p_source=>'REGION_TABLE_CATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('<p>Si el motor &PRODUCT_NAME. muestra regiones en varias columnas en la misma posici\00F3n de regi\00F3n, &PRODUCT_NAME. presentar\00E1 una tabla HTML. Este atributo permite controlar los atributos de la etiqueta &lt;table&gt;.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(214949290722.4001)
,p_name=>'F4000_P4307_TOP_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(545007733.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Fuente de Separador Principal Actual'
,p_source=>'TOP_CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'select 1 from wwv_flow_templates where TOP_CURRENT_TAB_FONT_ATTR is not null and id = :F4000_P4307_ID'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo forma parte de la subplantilla del Separador Principal y ampl\00EDa la cadena de sustituci\00F3n #PARENT_TAB_CELLS#. Un "separador actual" es el actual para la p\00E1gina actual. Este atributo controla la fuente utilizada para visualizar el text')
||'o del separador principal.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'example: face=arial size=-1 color=white'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(214959311442.4001)
,p_name=>'F4000_P4307_TOP_NON_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(545007733.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Fuente de Separador Principal No Actual'
,p_source=>'TOP_NON_CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'select 1 from wwv_flow_templates where TOP_NON_CURRENT_TAB_FONT_ATTR is not null and id = :F4000_P4307_ID'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo forma parte de la subplantilla del Separador Principal y ampl\00EDa la cadena de sustituci\00F3n #PARENT_TAB_CELLS#. Un "separador no actual" es el que NO es actual para la p\00E1gina actual. Este atributo controla la fuente utilizada para visua')
||'lizar el texto del separador principal. </p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3691714003171.4001)
,p_name=>'P4307_DIALOG_CANCEL_CODE'
,p_item_sequence=>1340
,p_item_plug_id=>wwv_flow_api.id(34407606078341355.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo de Cancelaci\00F3n de Cuadro de Di\00E1logo')
,p_source=>'DIALOG_JS_CANCEL_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el c\00F3digo JavaScript para cancelar la p\00E1gina de cuadro de di\00E1logo. La cadena de sustituci\00F3n se sustituir\00E1 por su valor respectivo en el momento de la presentaci\00F3n.<p/>'),
unistr('La llamada de JavaScript por defecto para cancelar el cuadro de di\00E1logo es:<p/><strong>'),
'apex.navigation.dialog.cancel(#IS_MODAL#);</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4312042879030105.4001)
,p_name=>'P4307_BREADCRUMB_DP_TEMP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(262121216799808381.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4312119707030106.4001)
,p_name=>'P4307_SIDEBAR_DP_TEMP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(262121216799808381.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24140521005219980.4001)
,p_name=>'P4307_TRANSLATABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30626103986543906.4001)
,p_name=>'P4307_PUBLISH'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(547026858.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PUBLISH_ON_SAVE'
,p_lov=>'.'||wwv_flow_api.id(763360160878777085.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Active esta casilla para publicar esta plantilla despu\00E9s de aplicar los cambios.'),
''))
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31558329325911721.4001)
,p_name=>'P4307_BREADCRUMB_DISPLAY_POINT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(262121216799808381.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Posici\00F3n de ruta de navegaci\00F3n')
,p_source=>'BREADCRUMB_DEF_REG_POS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from (',
'    select lov_disp_value d,',
'           lov_return_value r,',
'           1 seq1,',
'           lov_disp_sequence seq2',
'      from wwv_flow_lists_of_values$ lov',
'      join wwv_flow_list_of_values_data lovd on lovd.lov_id = lov.id',
'     where lov.lov_name = ''REGION_DISPLAY_POINT''',
'       and lov.flow_id = :FB_FLOW_ID',
'       and lov.security_group_id = :flow_security_group_id',
'    ',
'    union all',
'    ',
'    select name d,',
'           placeholder r,',
'           2 seq1,',
'           id seq2',
'      from wwv_flow_page_tmpl_disp_points',
'     where flow_id           = :FB_FLOW_ID',
'       and page_template_id  = :F4000_P4307_ID',
'       and security_group_id = :WORKSPACE_ID',
')',
'',
'order by seq1, seq2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se aplica a los componentes generados que utilizan rutas de navegaci\00F3n. Define el lugar de la p\00E1gina donde se colocan las rutas de navegaci\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(31567909286934250.4001)
,p_name=>'P4307_SIDEBAR_DISPLAY_POINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(262121216799808381.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Posici\00F3n de barra lateral')
,p_source=>'SIDEBAR_DEF_REG_POS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from (',
'    select lov_disp_value d,',
'           lov_return_value r,',
'           1 seq1,',
'           lov_disp_sequence seq2',
'      from wwv_flow_lists_of_values$ lov',
'      join wwv_flow_list_of_values_data lovd on lovd.lov_id = lov.id',
'     where lov.lov_name = ''REGION_DISPLAY_POINT''',
'       and lov.flow_id = :FB_FLOW_ID',
'       and lov.security_group_id = :flow_security_group_id',
'    ',
'    union all',
'    ',
'    select name d,',
'           placeholder r,',
'           2 seq1,',
'           id seq2',
'      from wwv_flow_page_tmpl_disp_points',
'     where flow_id           = :FB_FLOW_ID',
'       and page_template_id  = :F4000_P4307_ID',
'       and security_group_id = :WORKSPACE_ID',
')',
'',
'order by seq1, seq2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Se aplica a los componentes generados que utilizan barras laterales. Define el lugar de la p\00E1gina donde se colocan las barras laterales.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33911014789412987.4001)
,p_name=>'F4000_P4307_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33421119555122202.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P4307_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34391125123007081.4001)
,p_name=>'P4307_CSS_FILE_URLS'
,p_item_sequence=>930
,p_item_plug_id=>wwv_flow_api.id(34390928027007081.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#<')
||unistr('/code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para obtener una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se muestra en modo de depuraci\00F3n. Tambi\00E9n tiene acce')
||unistr('so a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
unistr('<p>Las URL de archivo que introduzca aqu\00ED sustituir\00E1n a la cadena de sustituci\00F3n <code>#TEMPLATE_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/mycss/main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que, cuando se cambie la versi\00F3n de la aplicaci\00F3n (y se incremente la versi\00F3n), se indicar\00E1 al explorador que siempre')
||unistr(' cargue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34391627520007082.4001)
,p_name=>'P4307_INLINE_CSS'
,p_item_sequence=>940
,p_item_plug_id=>wwv_flow_api.id(34390928027007081.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('En L\00EDnea')
,p_source=>'INLINE_CSS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo de la hoja de estilo en cascada que se va a utilizar en esta p\00E1gina. Considere introducirlo en un archivo externo para evitar la duplicaci\00F3n y aprovechar el almacenamiento en cach\00E9 del explorador de los archivos est\00E1ticos.</p>'),
'',
unistr('<p>El c\00F3digo que introduzca aqu\00ED sustituye a la cadena de sustituci\00F3n <code>#TEMPLATE_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
unistr('<p>Nota: No es necesario incluir las etiquetas <code>style</code> de apertura o de cierre. S\00F3lo incluya el c\00F3digo de la hoja de estilo en cascada.</p>'),
'',
'<p>',
'Ejemplo para definir la clase CSS <code>display_only</code> en negrita',
'<pre>',
'.display_only {',
'  font-weight:bold;',
'}',
'</pre>',
'</p>'))
,p_attribute_01=>'CSS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34407825067341355.4001)
,p_name=>'P4307_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(34407606078341355.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo JavaScript para el c\00F3digo que se va a cargar en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code> ')
||unistr('para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a la caden')
||unistr('a de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
unistr('<p>Las URL de archivo JavaScript que introduzca aqu\00ED sustituir\00E1n a la cadena de sustituci\00F3n <code>#TEMPLATE_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre. Incluya solo la URL.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de /myjs/minified/ para vistas de p\00E1gina normales y main.js de /myjs/ en el modo de depuraci\00F3n.'),
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca se utiliza tambi\00E9n desde una llamada de solicitud de RequireJS. El nombre de definici\00F3n debe coincidir con el que se utilice en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global')
||' que muestre la biblioteca. Solo se aplica al utilizar RequireJS. Esto evita que RequireJS cargue la biblioteca una segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que, cuando se cambie la versi\00F3n de la aplicaci\00F3n (y se incremente la versi\00F3n), se indicar\00E1 al explorador que siempre')
||unistr(' cargue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38294618517561859.4001)
,p_name=>'P4307_JAVASCRIPT_CODE'
,p_item_sequence=>960
,p_item_plug_id=>wwv_flow_api.id(34407606078341355.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Declaraci\00F3n de Funci\00F3n y Variable Global')
,p_source=>'JAVASCRIPT_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript (por ejemplo, declaraciones de variables globales o funciones) que se utilizar\00E1 en esta plantilla de p\00E1gina. Considere la posibilidad de colocarlo en un archivo externo para evitar la duplicaci\00F3n y para aprovechar e')
||unistr('l almacenamiento en cach\00E9 del explorador de los archivos est\00E1ticos.</p>'),
'',
unistr('<p>El c\00F3digo introducido aqu\00ED sustituir\00E1 a la cadena de sustituci\00F3n <code>#TEMPLATE_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'',
unistr('<p>Nota: No es necesario incluir etiquetas de <code>script</code> de apertura y cierre. Incluya s\00F3lo el c\00F3digo JavaScript.</p>'),
'',
'<p>Para hacer referencia a un acceso directo, utilice &quot;SHORTCUTNAME&quot;.</p>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38295131330565573.4001)
,p_name=>'P4307_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>970
,p_item_plug_id=>wwv_flow_api.id(34407606078341355.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ejecutar Cuando Se Cargue la P\00E1gina')
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript que se ejecutar\00E1 cuando se cargue la p\00E1gina. Este c\00F3digo se ejecuta despu\00E9s del c\00F3digo JavaScript generado por &PRODUCT_NAME.</p>'),
'',
unistr('<p>El c\00F3digo que introduzca aqu\00ED sustituye la cadena de sustituci\00F3n <code>#GENERATED_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'',
unistr('<p>Nota: No es necesario agregar etiquetas de <code>script</code> de apertura y cierre, solo el c\00F3digo JavaScript.</p>'),
''))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(38986814262975620.4001)
,p_name=>'P4307_NAVBAR_ENTRY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(543003816.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Entrada de Barra de Navegaci\00F3n')
,p_source=>'NAVBAR_ENTRY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para cada entrada de la barra de navegaci\00F3n se sustituir\00E1 lo siguiente en #BAR_BODY# de la barra de navegaci\00F3n. Utilice las siguientes cadenas de sustituci\00F3n para componer la subplantilla de entradas de barra de navegaci\00F3n.'),
'<ul class="noIndent">',
'<li>#LINK#: Enlace de entrada</li>',
'<li>#TEXT#: Subtexto de entrada</li>',
unistr('<li>#IMAGE#: Imagen de entrada (se incluir\00E1n argumentos ALT, HEIGHT y WIDTH de imagen HTML con la etiqueta IMG HTML cuando se proporcione con la entrada de barra de navegaci\00F3n)'),
'<li>#WIDTH#: Ancho de la imagen</li>',
'<li>#HEIGHT#: Altura de la imagen</li>',
'<li>#COLSPAN#: Valor de COLSPAN de HTML</li>',
'<li>#ALT#: Texto alternativo de la imagen</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(39616011051963782.4001)
,p_name=>'P4307_IS_POPUP'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Tipo de Plantilla'
,p_source=>'IS_POPUP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(361310216348385184.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica el tipo de plantilla de p\00E1gina. Cuando se define en <strong>P\00E1gina de Cuadro de Di\00E1logo</strong>, la plantilla solo est\00E1 disponible para que la seleccione una p\00E1gina que tenga el modo de p\00E1gina Cuadro de Di\00E1logo Modal o No Modal. Cuando se')
||unistr(' define en <strong>P\00E1gina Normal</strong>, la plantilla solo est\00E1 disponible para que la seleccione una p\00E1gina que tenga el modo de p\00E1gina Normal.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40806100730333001.4001)
,p_name=>'P4307_N'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(541989765.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'select substr(name,1,80) from WWV_FLOW_TEMPLATES where id =:F4000_P4307_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la plantilla'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41971024675100523.4001)
,p_name=>'P4307_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tema al que est\00E1 asociada esta plantilla. Un tema es un grupo de plantillas que proporcionan el dise\00F1o y el estilo a una aplicaci\00F3n.')
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41975001866122334.4001)
,p_name=>'P4307_THEME_CLASS_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(41972431732112027.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.<p />',
'Utilice la casilla de control <strong>Se puede convertir</strong> para indicar si esta plantilla contiene cadenas de texto que hay que convertir. ',
'</div>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(44400104182090696.4001)
,p_name=>'P4307_DIALOG_JS_INIT_CODE'
,p_item_sequence=>1300
,p_item_plug_id=>wwv_flow_api.id(34407606078341355.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo de Inicializaci\00F3n de Cuadro de Di\00E1logo')
,p_source=>'DIALOG_JS_INIT_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el c\00F3digo JavaScript para inicializar la p\00E1gina como un cuadro de di\00E1logo. Las cadenas de sustituci\00F3n se sustituyen por sus valores respectivos en el momento de la presentaci\00F3n. Por ejemplo, #DIALOG_ATTRIBUTES# se sustituye por los atribut')
||unistr('os personalizados definidos en el elemento de atributos de cuadro de di\00E1logo en Editar P\00E1gina.<p/>'),
unistr('La llamada de JavaScript por defecto para inicializar un cuadro de di\00E1logo es:<p/><strong>'),
'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53603824389412903.4001)
,p_name=>'P4307_DIALOG_WIDTH'
,p_item_sequence=>1305
,p_item_plug_id=>wwv_flow_api.id(53603513531407414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ancho'
,p_source=>'DIALOG_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el ancho por defecto de un cuadro de di\00E1logo, en p\00EDxeles o porcentaje. Esta configuraci\00F3n la sobrescribe el ancho del cuadro de di\00E1logo especificado en el nivel de p\00E1gina.<p/>'),
unistr('Para una p\00E1gina que utiliza una interfaz de usuario de escritorio, el valor se define en p\00EDxeles, por ejemplo, 500. Para una p\00E1gina que utiliza la interfaz de usuario Smartphone jQuery Mobile, el valor debe definirse en porcentaje, por ejemplo, 80%.<')
||'p/>',
'',
unistr('La cadena de sustituci\00F3n #DIALOG_WIDTH# del c\00F3digo de inicializaci\00F3n del cuadro de di\00E1logo se sustituir\00E1 por el ancho del cuadro de di\00E1logo especificado.')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53604016194416715.4001)
,p_name=>'P4307_DIALOG_MAX_WIDTH'
,p_item_sequence=>1320
,p_item_plug_id=>wwv_flow_api.id(53603513531407414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ancho M\00E1ximo')
,p_source=>'DIALOG_MAX_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el ancho m\00E1ximo por defecto del cuadro de di\00E1logo, en p\00EDxeles. Esta configuraci\00F3n la sobrescribe el ancho m\00E1ximo del cuadro de di\00E1logo especificado en el nivel de p\00E1gina.<p/>'),
'',
unistr('Para una p\00E1gina que utiliza una interfaz de usuario Smartphone jQuery Mobile, el ancho m\00E1ximo es 500.<p/>'),
'',
unistr('La cadena de sustituci\00F3n #DIALOG_MAX_WIDTH# del c\00F3digo de inicializaci\00F3n del cuadro de di\00E1logo se sustituir\00E1 por el ancho m\00E1ximo del cuadro de di\00E1logo especificado. ')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75351815043817215.4001)
,p_name=>'P4307_ID_NEXT'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(117321519519339260.4001)
,p_prompt=>'P4307_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75352216490817217.4001)
,p_name=>'P4307_ID_PREV'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(117321519519339260.4001)
,p_prompt=>'P4307_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75352613675817220.4001)
,p_name=>'P4307_ID_COUNT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(541989765.4001)
,p_prompt=>unistr('Plantilla de P\00E1gina: ')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Edite la plantilla de p\00E1gina.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(89504404889471393.4001)
,p_name=>'P4307_DIALOG_HEIGHT'
,p_item_sequence=>1310
,p_item_plug_id=>wwv_flow_api.id(53603513531407414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Altura'
,p_source=>'DIALOG_HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la altura del cuadro de di\00E1logo, en p\00EDxeles, por ejemplo, <strong><i>500</i></strong>. Esta configuraci\00F3n se sobrescribir\00E1 por la altura del cuadro de di\00E1logo especificada en el nivel de p\00E1gina.<p/> La cadena de sustituci\00F3n #DIALOG_HEIGHT#')
||unistr(' en el c\00F3digo de inicializaci\00F3n del cuadro de di\00E1logo de la plantilla de p\00E1gina se sustituir\00E1 por la altura del cuadro de di\00E1logo especificada.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(117381119974574119.4001)
,p_name=>'F4000_P4307_ERROR_PAGE_TEMPLATE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(117385421687588488.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de P\00E1gina de Error')
,p_source=>'ERROR_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este atributo al dise\00F1ar una p\00E1gina de plantilla como una plantilla de error. Las cadenas de sustituci\00F3n soportadas son:</p>'),
'<ul>',
'<li>#MESSAGE# y #ADDITIONAL_INFO#: Coloca el mensaje de error. </li>',
unistr('<li>#TECHNICAL_INFO#: Muestra la informaci\00F3n detallada del error interno que s\00F3lo podr\00E1n ver los desarrolladores.</li>'),
unistr('<li>#BACK_LINK#: Muestra un enlace a la p\00E1gina anterior. </li>'),
'<li>#OK# and #RETURN_TO_APPLICATION#: Devuelve cadenas de texto traducidas. </li>',
'</ul>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162671431587462663.4001)
,p_name=>'F4000_P4307_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(33421119555122202.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select d, r from (',
'select flow_id||'' : ''||wwv_flow_escape.html(name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id) and security_group_id = :flow_security_group_id)',
')',
'order by 1',
')'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>',
''))
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203351726181564628.4001)
,p_name=>'P4307_GRID_TEMPLATE'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Contenedor'
,p_source=>'GRID_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica la marca para iniciar un nuevo dise\00F1o. Debe incluir al menos #ROWS# en esta plantilla. Se permiten las siguientes cadenas de sustituci\00F3n en la plantilla de contenedor:</p>'),
'<ul>',
unistr('<li><strong>#USED_COLUMNS_NUMBER#</strong>: N\00FAmero de columnas utilizadas. Por ejemplo: 1, 2, 3, ...</li>'),
unistr('<li><strong>#USED_COLUMNS_ALPHA#</strong>: Car\00E1cter alfab\00E9tico que representa el n\00FAmero de columnas utilizadas. Por ejemplo: a, b, c, ...</li>'),
unistr('<li><strong>#USED_COLUMNS_ALPHA_MINUS#</strong>: Car\00E1cter alfab\00E9tico que representa el n\00FAmero de columnas utilizadas que se reducen en una columna de cuadr\00EDcula. Por ejemplo, dos columnas de cuadr\00EDcula devolver\00E1n "a".</li>'),
unistr('<li><strong>#USED_COLUMNS_WORD#</strong>: Palabra que representa el n\00FAmero de columnas utilizadas. Por ejemplo: uno, dos, tres, ...</li>'),
unistr('<li><strong>#USED_COLUMNS_PLURAL#</strong>: Se sustituye por "s" si el n\00FAmero de columnas de cuadr\00EDcula es mayor que uno. Util\00EDcelo si el dise\00F1o necesita un nombre de clase "column" para una columna y "columns" si se especifican varias columnas. Por ')
||'ejemplo: class="#USED_COLUMNS_WORD# column#USED_COLUMNS_PLURAL#"</li>',
'<li><strong>#ROWS#</strong>: Sustituido por "Plantilla de Fila".</li>',
'</ul>',
'<p>',
'Ejemplo:',
'<pre>',
'&lt;div class="ui-grid-#USED_COLUMNS_ALPHA_MINUS#"&gt;#ROWS#&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203352930914577600.4001)
,p_name=>'P4307_GRID_ROW_TEMPLATE'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Fila'
,p_source=>'GRID_ROW_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica la marca para iniciar una nueva fila de dise\00F1o. Debe incluir al menos #COLUMNS# en esta plantilla. Se permiten las siguientes cadenas de sustituci\00F3n en la plantilla de fila:</p>'),
'<ul>',
'<li><strong>#COLUMNS#</strong>: sustituido por "Plantilla de columna".</li>',
unistr('<li><strong>#CSS_CLASSES#</strong>: sustituido por el valor especificado como "Clases CSS de filas". Esto permite una mayor personalizaci\00F3n de una fila de dise\00F1o con clases CSS.</li>'),
'</ul>',
'<p>',
'Ejemplo:',
'<pre>',
'&lt;div class="row"&gt;#COLUMNS#&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203353124660580498.4001)
,p_name=>'P4307_GRID_COLUMN_TEMPLATE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Columna'
,p_source=>'GRID_COLUMN_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica la marca para iniciar una nueva columna de dise\00F1o. Debe incluir al menos #CONTENT# en esta plantilla. Se permiten las siguientes cadenas de sustituci\00F3n en la plantilla de columna:</p>'),
'<ul>',
unistr('<li><strong>#COLUMN_NUMBER#</strong>: N\00FAmero de la columna. Por ejemplo: 1, 2, 3, ...</li>'),
unistr('<li><strong>#COLUMN_ALPHA#</strong>: Car\00E1cter alfab\00E9tico que representa la columna. Por ejemplo: a, b, c, ...</li>'),
'<li><strong>#COLUMN_WORD#</strong>: Palabra que representa la columna. Por ejemplo: uno, dos, tres, ...</li>',
unistr('<li><strong>#COLUMN_PLURAL#</strong>: Se sustituye por "s" si la columna es mayor que uno. Util\00EDcela si el dise\00F1o necesita un nombre de clase "column" para la primera columna y "columns" para las siguientes columnas. Por ejemplo: class="#COLUMN_WORD#')
||' column#COLUMN_PLURAL#"</li>',
unistr('<li><strong>#COLUMN_SPAN_NUMBER#</strong>: N\00FAmero de la ampliaci\00F3n de columna. Por ejemplo: 1, 2, 3, ...</li>'),
unistr('<li><strong>#COLUMN_SPAN_ALPHA#</strong>: Car\00E1cter alfab\00E9tico que representa la ampliaci\00F3n de columna . Por ejemplo: a, b, c, ...</li>'),
unistr('<li><strong>#COLUMN_SPAN_WORD#</strong>: Palabra que representa la ampliaci\00F3n de columna. Por ejemplo: uno, dos, tres, ...</li>'),
unistr('<li><strong>#COLUMN_SPAN_PLURAL#</strong>: Se sustituye por "s" si la ampliaci\00F3n de columna es mayor que uno. Util\00EDcela si el dise\00F1o necesita un nombre de clase "column" para la ampliaci\00F3n de una columna y "columns" si se especifican varias columnas.')
||' Por ejemplo: class="#COLUMN_SPAN_WORD# column#COLUMN_SPAN_PLURAL#"</li>',
unistr('<li><strong>#CSS_CLASSES#</strong>: se sustituye por el valor especificado como "Clases CSS de Columna". Esto permite personalizar a\00FAn m\00E1s una columna con clases CSS.</li>'),
unistr('<li><strong>#ATTRIBUTES#</strong>: Se sustituye por el valor especificado como "Atributos de Columna". Esto permite personalizar a\00FAn m\00E1s una columna.</li>'),
unistr('<li><strong>#FIRST_LAST_COLUMN_ATTRIBUTES#</strong>: Se sustituye por el valor especificado en "Atributos de Primera Columna" y "Atributos de \00DAltima Columna", dependiendo de si es la primera o la \00FAltima columna.</li>'),
unistr('<li><strong>#CONTENT#</strong>: Se sustituye por las regiones, elementos de p\00E1gina o botones que aparecen en la columna.</li>'),
'</ul>',
'<p>',
'Ejemplo:',
'<pre>',
'&lt;div class="#COLUMN_SPAN_WORD# column#COLUMN_SPAN_PLURAL# #CSS_CLASSES#"&gt;#CONTENT#&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203354207813618760.4001)
,p_name=>'P4307_GRID_FIRST_COLUMN_ATTRIBUTES'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Primera Columna'
,p_source=>'GRID_FIRST_COLUMN_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Especifique el valor que debe sustituir a #FIRST_LAST_COLUMN_ATTRIBUTES# en la plantilla de columna si es la primera columna de dise\00F1o.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203354927210624892.4001)
,p_name=>'P4307_GRID_LAST_COLUMN_ATTRIBUTES'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Atributos de \00DAltima Columna')
,p_source=>'GRID_LAST_COLUMN_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Especifique el valor que debe sustituir a #FIRST_LAST_COLUMN_ATTRIBUTES# en la plantilla de columna si es la \00FAltima columna de dise\00F1o.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203355117074629639.4001)
,p_name=>'P4307_GRID_JAVASCRIPT_DEBUG_CODE'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo de Depuraci\00F3n JavaScript')
,p_source=>'GRID_JAVASCRIPT_DEBUG_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>C\00F3digo JavaScript que se ejecuta para proporcionar ayuda de dise\00F1o adicional al hacer clic en los botones "Mostrar Columnas de Dise\00F1o" y "Ocultar Columnas de Dise\00F1o" en la barra de herramientas del desarrollador. El c\00F3digo JavaScript se debe regis')
||'trar en los eventos JavaScript "apex-devbar-grid-debug-on" y "apex-devbar-grid-debug-off".',
'</p>',
'<p>',
'El siguiente ejemplo registra las funciones de JavaScript showLayoutColumns y hideLayoutColumns para los eventos anteriores.',
'<pre>',
'apex.jQuery(document)',
'    .on("apex-devbar-grid-debug-on", showLayoutColumns)',
'    .on("apex-devbar-grid-debug-off", hideLayoutColumns);',
'</pre>',
'</p>',
''))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203355426982640216.4001)
,p_name=>'P4307_GRID_TYPE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_prompt=>'Tipo'
,p_source=>'GRID_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GRID_LAYOUT.TYPE'
,p_lov=>'.'||wwv_flow_api.id(203356809012666718.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica el tipo de dise\00F1o.'),
'</p>',
'<ul>',
unistr('<li><strong>Tabla HTML</strong>: Utiliza tablas HTML para colocar regiones, elementos de p\00E1gina y botones.</li>'),
unistr('<li><strong>N\00FAmero Fijo de Columnas</strong>: Se utiliza para dise\00F1os que dividen la pantalla en un n\00FAmero fijo de columnas de dise\00F1o.</li>'),
unistr('<li><strong>N\00FAmero Variable de Columnas</strong>: Se utiliza para dise\00F1os que pueden mostrar hasta "n" columnas de dise\00F1o, seg\00FAn c\00F3mo se colocan las regiones, elementos de p\00E1gina y botones.</li>'),
'</ul>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203358119194674228.4001)
,p_name=>'P4307_GRID_ALWAYS_USE_MAX_COLUMNS'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Usar Siempre M\00E1ximo de Columnas')
,p_source=>'GRID_ALWAYS_USE_MAX_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique <strong>Activado</strong> si el dise\00F1o siempre puede utilizar el n\00FAmero m\00E1ximo de columnas de cuadr\00EDcula para una posici\00F3n de visualizaci\00F3n. Especifique <strong>Desactivado</strong> si el n\00FAmero m\00E1ximo de columnas es para la pantalla comp')
||unistr('leta y cada posici\00F3n reduce las columnas disponibles.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203359230180684370.4001)
,p_name=>'P4307_GRID_HAS_COLUMN_SPAN'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Tiene Ampliaci\00F3n de Columna')
,p_source=>'GRID_HAS_COLUMN_SPAN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique <strong>Activado</strong> si el dise\00F1o soporta que se abarquen varias columnas de dise\00F1o. Esta opci\00F3n est\00E1 soportada por la mayor\00EDa de dise\00F1os "N\00FAmero Fijo de Columnas".')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203360312496692505.4001)
,p_name=>'P4307_GRID_EMIT_EMPTY_LEADING_COLS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Emitir Columnas Iniciales Vac\00EDas')
,p_source=>'GRID_EMIT_EMPTY_LEADING_COLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique <strong>Activado</strong> para rellenar las columnas de dise\00F1o iniciales no utilizadas con una columna de dise\00F1o vac\00EDa. En casi todas las ocasiones, debe estar definida en <strong>Activado</strong> para los dise\00F1os "N\00FAmero fijo de columna')
||'s".'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203361328874700145.4001)
,p_name=>'P4307_GRID_EMIT_EMPTY_TRAILING_COLS'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Emitir Columnas Finales Vac\00EDas')
,p_source=>'GRID_EMIT_EMPTY_TRAILING_COLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique <strong>Activado</strong> para rellenar las columnas de dise\00F1o finales no utilizadas con una columna de dise\00F1o vac\00EDa para incluir siempre el n\00FAmero m\00E1ximo de columnas de dise\00F1o.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203362430143729887.4001)
,p_name=>'P4307_GRID_MAX_COLUMNS'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E1ximo de Columnas')
,p_format_mask=>'90'
,p_source=>'GRID_MAX_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>2
,p_cMaxlength=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>unistr('Especifica el n\00FAmero m\00E1ximo de columnas soportado por el dise\00F1o.')
,p_attribute_01=>'1'
,p_attribute_02=>'99'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(359736513076708169.4001)
,p_name=>'P4307_DIALOG_CLOSE_CODE'
,p_item_sequence=>1330
,p_item_plug_id=>wwv_flow_api.id(34407606078341355.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo de Cierre de Cuadro de Di\00E1logo')
,p_source=>'DIALOG_JS_CLOSE_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca c\00F3digo JavaScript para cerrar la p\00E1gina del cuadro de di\00E1logo. Las cadenas de sustituci\00F3n se sustituir\00E1n por sus respectivos valores en el momento de la presentaci\00F3n.<p/>'),
unistr('La llamada de JavaScript por defecto para cerrar un cuadro de di\00E1logo es:<p/><strong>'),
'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(360927825279161478.4001)
,p_name=>'P4307_DIALOG_CSS_CLASSES'
,p_item_sequence=>1340
,p_item_plug_id=>wwv_flow_api.id(53603513531407414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clases CSS'
,p_source=>'DIALOG_CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca clases CSS adicionales que desee que se apliquen al cuadro de di\00E1logo como una lista delimitada por espacios. Por ejemplo: <p/>'),
'',
'<strong>ui-dialog--wizard</strong><p/><p/>',
'',
unistr('Cualquier incidencia de la cadena de sustituci\00F3n #DIALOG_CSS_CLASSES# en la plantilla de p\00E1gina se sustituir\00E1 por los valores especificados en este campo. Este valor se puede sobrescribir en el nivel de p\00E1gina.  ')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(629608491435003712.4001)
,p_name=>'P4307_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(629607275487003693.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text  ',
'  from wwv_flow_template_options o, wwv_flow_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and template_types = ''PAGE''',
'   and (page_template_id = :F4000_P4307_ID or page_template_id is NULL)',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P4307_ID',
'order by advanced_group nulls first, group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(629608608008003713.4001)
,p_name=>'P4307_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>235
,p_item_plug_id=>wwv_flow_api.id(629607275487003693.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.page_template_id',
'   and page_template_id = :F4000_P4307_ID',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(741443279094225827.4001)
,p_name=>'P4307_GRID_ALWAYS_EMIT'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Representar Siempre Dise\00F1o')
,p_source=>'GRID_ALWAYS_EMIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique <strong>Activado</strong> para representar siempre el dise\00F1o, aunque solo se utilice la primera columna del dise\00F1o. Especifique <strong>Desactivado</strong> para mostrar solo el dise\00F1o cuando se utiliza m\00E1s de una columna.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(864568260573731002.4001)
,p_name=>'P4307_DIALOG_BROWSER_FRAME'
,p_item_sequence=>1350
,p_item_plug_id=>wwv_flow_api.id(53603513531407414.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Permitir Embeber en Marcos'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
'begin ',
'   select dialog_browser_frame ',
'   bulk collect into l_value ',
'   from wwv_flow_templates ',
'   where id = :F4000_P4307_ID',
'   and flow_id = :FB_FLOW_ID ',
'   and security_group_id = :flow_security_group_id;',
'',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DIALOG_PAGE_MODE_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(887851591470130537.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Las opciones de marco del explorador de nivel de plantilla de p\00E1gina se muestran a continuaci\00F3n, junto con el valor actual para cada una.'),
unistr('Active la casilla situada junto a un modo de p\00E1gina para utilizar este atributo y controlar si el explorador puede mostrar las p\00E1ginas de la aplicaci\00F3n dentro de un marco.'),
unistr('El valor actual ser\00E1 el valor por defecto para cada cuadro de di\00E1logo modal y no modal que utilice esta plantilla de p\00E1gina.'),
'<p/>',
'<p>',
unistr('Esta opci\00F3n de visualizaci\00F3n de p\00E1ginas en marcos puede ser utilizada de forma incorrecta mediante "clickjacking" (secuestro de clics).'),
unistr('En este caso, el usuario no autorizado utiliza varias capas para enga\00F1ar a un usuario para que haga clic en un bot\00F3n o enlace a otra p\00E1gina cuando en realidad intentaba hacer clic en la p\00E1gina del nivel superior.'),
unistr('Es decir, el usuario no autorizado secuestra los clics (o las pulsaciones de teclas) que van a la p\00E1gina y las redirecciona a otra.'),
'<p/>',
'<p>',
unistr('Application Express embebe los cuadros de di\00E1logo modales en iframes.'),
unistr('Si define el atributo de seguridad de la aplicaci\00F3n <em>Marco de Explorador</em> en "Denegar",'),
unistr('al activar <em>Permitir Embeber en Marco</em> para "Cuadro de Di\00E1logo Modal" se utilizar\00E1 "Permitir del Mismo Origen" para las p\00E1ginas de cuadro de di\00E1logo que utilizan esta plantilla. '),
'</p>'))
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1004724448190877708.4001)
,p_name=>'P4307_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1564192840347583631.4001)
,p_name=>'P4307_GRID_DEFAULT_LABEL_COL_SPAN'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(131914703603.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ampliaci\00F3n de Columna de Etiqueta por Defecto')
,p_format_mask=>'90'
,p_source=>'GRID_DEFAULT_LABEL_COL_SPAN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>2
,p_cMaxlength=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>unistr('Especifica el n\00FAmero por defecto de columnas de dise\00F1o que ocupa una etiqueta de elemento si no se especifica en el nivel de elemento. La plantilla de etiqueta debe incluir las cadenas de sustituci\00F3n <code>#LABEL_COLUMN_SPAN_[NUMBER|ALPHA|WORD|PLURAL')
||']#</code> y <code>#ITEM_COLUMN_SPAN_[NUMBER|ALPHA|WORD|PLURAL]#</code>.'
,p_attribute_01=>'1'
,p_attribute_02=>'99'
,p_attribute_03=>'right'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104756311530753955.4001)
,p_name=>'P4307_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(548047061.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2179038879875746694.4001)
,p_name=>'P4307_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>238
,p_item_plug_id=>wwv_flow_api.id(629607275487003693.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P4307_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104756918394760735.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4307_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P4307_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;',
''))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34382100375905921.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4307_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(30630018119718339.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4307_PUBLISH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5389218572782507.4001)
,p_validation_name=>'#HEAD# included'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_start number;',
'    l_end   number;',
'    l_head  varchar2(32767);',
'    l_error varchar2(255);',
'begin',
'    l_start := instr(upper(:F4000_P4307_HEADER_TEMPLATE),''<HEAD'');',
'    l_end   := instr(upper(:F4000_P4307_HEADER_TEMPLATE),''</HEAD>'');',
'    l_head  := substr(:F4000_P4307_HEADER_TEMPLATE,l_start,l_end);',
'',
'    if l_start = 0 or l_end = 0 then',
'        return wwv_flow_lang.system_message(''F4000.HEADER_VALIDATION1'');',
'    elsIf instr(l_head,''#HEAD#'') = 0 then',
'        return wwv_flow_lang.system_message(''F4000.HEADER_VALIDATION2'');',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error.'
,p_associated_item=>wwv_flow_api.id(22012144003.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(132386007512842231.4001)
,p_validation_name=>'#BOX_BODY# included'
,p_validation_sequence=>30
,p_validation=>'nvl(instr(:F4000_P4307_BOX,''#BODY#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La plantilla debe proporcionar la sustituci\00F3n BODY.')
,p_associated_item=>wwv_flow_api.id(8029292853.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(163591311590173316.4001)
,p_validation_name=>'reference is not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P4307_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(163582115209140770.4001)
,p_associated_item=>wwv_flow_api.id(162671431587462663.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(163709929625529582.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>50
,p_validation=>'F4000_P4307_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(163582115209140770.4001)
,p_associated_item=>wwv_flow_api.id(162671431587462663.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203382712859041824.4001)
,p_validation_name=>'P4307_GRID_MAX_COLUMNS is not null'
,p_validation_sequence=>60
,p_validation=>'P4307_GRID_MAX_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203378009291921898.4001)
,p_validation_name=>'P4307_GRID_TEMPLATE contains #ROWS#'
,p_validation_sequence=>80
,p_validation=>'nvl(instr(:P4307_GRID_TEMPLATE, ''#ROWS#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('#LABEL# debe contener la sustituci\00F3n #ROWS#.')
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(203351726181564628.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203378303684924520.4001)
,p_validation_name=>'P4307_GRID_ROW_TEMPLATE contains #COLUMNS#'
,p_validation_sequence=>90
,p_validation=>'nvl(instr(:P4307_GRID_ROW_TEMPLATE, ''#COLUMNS#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('#LABEL# debe contener la sustituci\00F3n #COLUMNS#.')
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(203352930914577600.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203379202988985610.4001)
,p_validation_name=>'P4307_GRID_COLUMN_TEMPLATE contains #CONTENT#'
,p_validation_sequence=>100
,p_validation=>'nvl(instr(:P4307_GRID_COLUMN_TEMPLATE, ''#CONTENT#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('#LABEL# debe contener la sustituci\00F3n #CONTENT#.')
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(203353124660580498.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(135893110531224286.4001)
,p_validation_name=>'Dialog Init Code NOT NULL'
,p_validation_sequence=>140
,p_validation=>'P4307_DIALOG_JS_INIT_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#LABEL# debe tener alg\00FAn valor si el tipo de plantilla es P\00E1gina de Cuadro de Di\00E1logo. El valor por defecto es:<p/><p/>'),
'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'))
,p_validation_condition=>'P4307_IS_POPUP'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(44400104182090696.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3782840599861.4001)
,p_validation_name=>'Dialog Closure Code NOT NULL'
,p_validation_sequence=>150
,p_validation=>'P4307_DIALOG_CLOSE_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#LABEL# debe tener alg\00FAn valor si el tipo de plantilla es P\00E1gina de Cuadro de Di\00E1logo. El valor por defecto es:<p/><p/>'),
'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'))
,p_validation_condition=>'P4307_IS_POPUP'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3782844604517.4001)
,p_validation_name=>'Dialog Cancel Code NOT NULL'
,p_validation_sequence=>160
,p_validation=>'P4307_DIALOG_CANCEL_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('#LABEL# debe tener alg\00FAn valor si el tipo de plantilla es p\00E1gina de cuadro de di\00E1logo. El valor por defecto es:<p/><p/>'),
'apex.navigation.dialog.cancel(#IS_MODAL#);'))
,p_validation_condition=>'P4307_IS_POPUP'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177290396349915730.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(262121216799808381.4001)
,p_validation_name=>'Reserved template substitutions'
,p_validation_sequence=>170
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':placeholder not in (',
'    ''AFTER_HEADER'', ',
'    ''BEFORE_FOOTER'',',
'    ''BODY_1'',',
'    ''BODY_2'',',
'    ''BODY_3'',',
'    ''LEGACY_ORPHAN_COMPONENTS'',',
'    ''APEX_CSS'',',
'    ''APEX_JAVASCRIPT'',',
'    ''APP_VERSION'',',
'    ''APPLICATION_CSS'',',
'    ''APPLICATION_JAVASCRIPT'',',
'    ''APPLICATION_TABS'',',
'    ''BODY_TITLE'',',
'    ''BUILT_WITH_LOVE_USING_APEX'',',
'    ''CLOSE_NOTIFICATION'',',
'    ''CUSTOMIZE'',',
'    ''DEVELOPER_TOOLBAR'',',
'    ''DIALOG_CSS_CLASSES'',',
'    ''ENVIRONMENT_BANNER'',',
'    ''ERROR_MESSAGE_HEADING'',',
'    ''EXPAND_COLLAPSE_NAV_LABEL'',',
'    ''EXPAND_COLLAPSE_SIDE_COL_LABEL'',',
'    ''FAVICONS'',',
'    ''FLOW_NAME'',',
'    ''FLOW_VERSION'',',
'    ''FORM_CLOSE'',',
'    ''FORM_OPEN'',',
'    ''GENERATED_CSS'',',
'    ''GENERATED_JAVASCRIPT'',',
'    ''GLOBAL_NOTIFICATION'',',
'    ''HIGH_CONTRAST_TOGGLE'',',
'    ''HOME_LINK'',',
'    ''LANGUAGE_SELECTOR'',',
'    ''LOGIN_URL'',',
'    ''LOGO'',',
'    ''LOGOUT_URL'',',
'    ''MESSAGE'',',
'    ''NAVIGATION_BAR'',',
'    ''NOTIFICATION_MESSAGE'',',
'    ''ONLOAD'',',
'    ''OUTDATED_BROWSER'',',
'    ''PAGE_CSS'',',
'    ''PAGE_CSS_CLASSES'',',
'    ''PAGE_JAVASCRIPT'',',
'    ''PAGE_STATIC_ID'',',
'    ''PAGE_TRANSITION'',',
'    ''PARENT_TAB_CELLS'',',
'    ''POPUP_TRANSITION'',',
'    ''REQUESTED_URL'',',
'    ''RTL_CLASS'',',
'    ''SCREEN_READER_TOGGLE'',',
'    ''SIDE_GLOBAL_NAVIGATION_LIST'',',
'    ''SUCCESS_MESSAGE'',',
'    ''SUCCESS_MESSAGE_HEADING'',',
'    ''TAB_CELLS'',',
'    ''TEMPLATE_CSS'',',
'    ''TEMPLATE_JAVASCRIPT'',',
'    ''TEXT_DIRECTION'',',
'    ''THEME_CSS'',',
'    ''THEME_JAVASCRIPT'',',
'    ''THEME_STYLE_CSS'',',
'    ''TITLE'',',
'    ''TOP_GLOBAL_NAVIGATION_LIST'',',
'    ''WELCOME_USER'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Esta es una sustituci\00F3n de plantilla reservada.')
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(203371716603791882.4001)
,p_name=>'Hide All'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(203372001728791883.4001)
,p_event_id=>wwv_flow_api.id(203371716603791882.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_GRID_ALWAYS_USE_MAX_COLUMNS,P4307_GRID_HAS_COLUMN_SPAN,P4307_GRID_ALWAYS_EMIT,P4307_GRID_EMIT_EMPTY_LEADING_COLS,P4307_GRID_EMIT_EMPTY_TRAILING_COLS,P4307_GRID_DEFAULT_LABEL_COL_SPAN,P4307_GRID_FIRST_COLUMN_ATTRIBUTES,P4307_GRID_LAST_COLUMN_ATT'
||'RIBUTES,F4000_P4307_REG_TAB_CATTR,P4307_GRID_TEMPLATE,P4307_GRID_ROW_TEMPLATE,P4307_GRID_COLUMN_TEMPLATE,P4307_GRID_JAVASCRIPT_DEBUG_CODE,P4307_GRID_MAX_COLUMNS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(203372103920797720.4001)
,p_name=>'HTML Table Grid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_condition_element=>'P4307_GRID_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(203372417830797720.4001)
,p_event_id=>wwv_flow_api.id(203372103920797720.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4307_REG_TAB_CATTR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(203372512709809707.4001)
,p_name=>'Fixed and Variable Column Grid'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_condition_element=>'P4307_GRID_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'FIXED,VARIABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(203372810467809707.4001)
,p_event_id=>wwv_flow_api.id(203372512709809707.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_GRID_MAX_COLUMNS,P4307_GRID_HAS_COLUMN_SPAN,P4307_GRID_ALWAYS_EMIT,P4307_GRID_EMIT_EMPTY_LEADING_COLS,P4307_GRID_EMIT_EMPTY_TRAILING_COLS,P4307_GRID_DEFAULT_LABEL_COL_SPAN,P4307_GRID_FIRST_COLUMN_ATTRIBUTES,P4307_GRID_LAST_COLUMN_ATTRIBUTES,P43'
||'07_GRID_TEMPLATE,P4307_GRID_ROW_TEMPLATE,P4307_GRID_COLUMN_TEMPLATE,P4307_GRID_JAVASCRIPT_DEBUG_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(203373005914817236.4001)
,p_name=>'Fixed Column Grid'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_condition_element=>'P4307_GRID_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FIXED'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(203373322249817236.4001)
,p_event_id=>wwv_flow_api.id(203373005914817236.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_GRID_ALWAYS_USE_MAX_COLUMNS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397301320019494740.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4307_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397301624186494740.4001)
,p_event_id=>wwv_flow_api.id(397301320019494740.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(75342716186817071.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397301725560496413.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4307_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397302029758496413.4001)
,p_event_id=>wwv_flow_api.id(397301725560496413.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(75342608829817071.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(129634725104310153.4001)
,p_name=>'Visibility of Modal/Non-Modal Option'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_IS_POPUP'
,p_condition_element=>'P4307_IS_POPUP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(129635004062310163.4001)
,p_event_id=>wwv_flow_api.id(129634725104310153.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_DIALOG_JS_INIT_CODE,P4307_DIALOG_CLOSE_CODE,P4307_DIALOG_CANCEL_CODE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(129635207478310166.4001)
,p_event_id=>wwv_flow_api.id(129634725104310153.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_DIALOG_JS_INIT_CODE,P4307_DIALOG_CLOSE_CODE,P4307_DIALOG_CANCEL_CODE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(129635403809312255.4001)
,p_event_id=>wwv_flow_api.id(129634725104310153.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(53603513531407414.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(629612944755097534.4001)
,p_name=>'refresh template options'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(629608248623003711.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751894112772807.4001)
,p_event_id=>wwv_flow_api.id(629612944755097534.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(629607275487003693.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4307:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(629613307981103974.4001)
,p_name=>'refresh template options after refresh'
,p_event_sequence=>90
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(629607275487003693.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751986339772808.4001)
,p_event_id=>wwv_flow_api.id(629613307981103974.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(629607275487003693.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4307:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2103325728292120.4001)
,p_name=>'onSave Positions'
,p_event_sequence=>100
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(262121216799808381.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridsave'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4312280572030107.4001)
,p_event_id=>wwv_flow_api.id(2103325728292120.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_BREADCRUMB_DP_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_BREADCRUMB_DISPLAY_POINT").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4312376050030108.4001)
,p_event_id=>wwv_flow_api.id(2103325728292120.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_SIDEBAR_DP_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_SIDEBAR_DISPLAY_POINT").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2103469641292121.4001)
,p_event_id=>wwv_flow_api.id(2103325728292120.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_BREADCRUMB_DISPLAY_POINT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4312486868030109.4001)
,p_name=>'afterRefresh P4307_BREADCRUMB_DISPLAY_POINT'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_BREADCRUMB_DISPLAY_POINT'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4312505270030110.4001)
,p_event_id=>wwv_flow_api.id(4312486868030109.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_BREADCRUMB_DISPLAY_POINT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_BREADCRUMB_DP_TEMP").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4312637583030111.4001)
,p_name=>'afterRefresh P4307_SIDEBAR_DISPLAY_POINT'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_SIDEBAR_DISPLAY_POINT'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4312749277030112.4001)
,p_event_id=>wwv_flow_api.id(4312637583030111.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_SIDEBAR_DISPLAY_POINT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_SIDEBAR_DP_TEMP").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22014144004.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_templates',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4307_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_TEMPLATES'',',
'  p_rowid       => v(''F4000_P4307_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(75353619195817232.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_TEMPLATES'
,p_attribute_03=>'F4000_P4307_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'NAME'
,p_attribute_09=>'P4307_ID_NEXT'
,p_attribute_10=>'P4307_ID_PREV'
,p_attribute_13=>'P4307_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(162744514301306294.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_page_template (',
'    p_master_template_id         => :F4000_P4307_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4307_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(163582115209140770.4001)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(:F4000_P4307_REFERENCE_ID,0)<>0 ',
'and not wwv_flow_page.is_read_only'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22015144004.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4307_ID is null',
'or exists (select 1 from wwv_flow_templates',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4307_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_TEMPLATES'',',
'p_rowid       => v(''F4000_P4307_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Plantilla de p\00E1gina procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(886492862328981504.4001)
,p_process_sequence=>55
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Dialog Browser Frame Setting'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'begin',
'  update wwv_flow_templates',
'     set dialog_browser_frame = :P4307_DIALOG_BROWSER_FRAME',
'   where id = :F4000_P4307_ID',
'     and flow_id = :FB_FLOW_ID',
'     and security_group_id = :flow_security_group_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al actualizar la configuraci\00F3n de marco del explorador de cuadro de di\00E1logo.')
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34063422379622171.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_page_template (',
'    p_master_template_id         => :F4000_P4307_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4307_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>':F4000_P4307_REFERENCE_ID is not null and :F4000_P4307_REFRESH = ''Y'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2179039248041757453.4001)
,p_process_sequence=>65
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_page_tmplopt_presets(:F4000_P4307_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P4307_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P4307_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(163701720388488269.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_page_reference_id (:F4000_P4307_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>':F4000_P4307_REFERENCE_ID = ''0'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2103150213292118.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(262121216799808381.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Positions - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2103672480292123.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(262121216799808381.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :placeholder'
,p_process_sql_clob=>':placeholder := upper(:placeholder);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4307_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177290406014915731.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(262121216799808381.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'trim pound'
,p_process_sql_clob=>':placeholder := trim( both ''#'' from :placeholder );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4307_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
);
end;
/
prompt --application/pages/page_04308
begin
wwv_flow_api.create_page(
 p_id=>4308.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Entrada de Barra de Navegaci\00F3n')
,p_step_title=>unistr('Editar Entrada de Barra de Navegaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213263531591941060)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457499110.4001)
,p_plug_name=>'button box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458502857.4001)
,p_plug_name=>unistr('Visualizaci\00F3n de Entrada')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459517222.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las entradas de barra de navegaci\00F3n, normalmente iconos gr\00E1ficos, se utilizan para proporcionar navegaci\00F3n a nivel de aplicaci\00F3n. Las entradas de barra de navegaci\00F3n se muestran en todas las p\00E1ginas, aunque tambi\00E9n se pueden mostrar de forma condi')
||'cional.</p>',
'',
unistr('<p>La ubicaci\00F3n de una barra de navegaci\00F3n se identifica en una plantilla de nivel de p\00E1gina y en la cadena de sustituci\00F3n (#NAVIGATION_BAR#).</p>')))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460530239.4001)
,p_plug_name=>'Condiciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(81008210556197147.4001)
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461549004.4001)
,p_plug_name=>'Destino'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33343906966817956.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUB'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_ICON_BAR'
,p_attribute_02=>'ICON_IMAGE_ALT'
,p_attribute_03=>'F4000_P4308_ID'
,p_attribute_04=>'F4000_P4308_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_NAVBAR'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46257412080679009.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(112450309806494185.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145711905273893908.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167051831503178663.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195827117454955907.4001)
,p_plug_name=>'Imagen de Entrada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197051508527618833.4001)
,p_plug_name=>'Entrada de Comentario'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Las entradas de la barra de navegaci\00F3n se pueden identificar como entradas de comentarios. Los comentarios estar\00E1n activados o desactivados en el nivel de la aplicaci\00F3n de forma que se pueden activar para realizar pruebas y desactivar en tareas de')
||unistr(' producci\00F3n. Si el atributo de nivel de aplicaci\00F3n est\00E1 desactivado, no se mostrar\00E1 la entrada de la barra de navegaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615341607888588885.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>110
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_ICON_BAR',
'where id = :F4000_P4308_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4308_ID,',
'      p_component_type => ''Navigation Bar'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(925158746310624162.4001)
,p_plug_name=>'Recursos de desarrolladores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_05'
,p_list_id=>wwv_flow_api.id(26512283167477231.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200951627971903655.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33343906966817956.4001)
,p_button_name=>'COPY_NAVBAR'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Refrescar Barra de Navegaci\00F3n')
,p_button_position=>'BOTTOM'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_icon_bar',
' where id = :F4000_P4308_ID',
'   and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(200947320221891904.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33343906966817956.4001)
,p_button_name=>'PUSH_NAVBAR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Publicar Barra de Navegaci\00F3n')
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4308_ID.,&FLOW_PAGE_ID.,NAVBAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_icon_bar',
' where reference_id = :F4000_P4308_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148586029317925560.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(457499110.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(148585905863925560.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(457499110.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22017144004.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(457499110.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22018144005.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(457499110.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4308_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22019144005.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(457499110.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4308_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22020144005.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(457499110.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4308_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(148593512524925649.4001)
,p_branch_action=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.::F4000_P4308_ID:&P4308_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(148585905863925560.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(148593919899925652.4001)
,p_branch_action=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.::F4000_P4308_ID:&P4308_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(148586029317925560.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(200952015038903658.4001)
,p_branch_action=>'4308'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(200951627971903655.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(119001127005800137.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(819585597.4001)
,p_name=>'F4000_P4308_ICON_BAR_COMMENT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(112450309806494185.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'ICON_BAR_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9169568864.4001)
,p_name=>'F4000_P4308_REQUIRED_PATCH'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(167051831503178663.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22024144006.4001)
,p_name=>'F4000_P4308_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(33343906966817956.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22026144007.4001)
,p_name=>'F4000_P4308_ICON_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(458502857.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>'ICON_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22027144007.4001)
,p_name=>'F4000_P4308_ICON_IMAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(195827117454955907.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen'
,p_source=>'ICON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La imagen es el nombre de la imagen.&nbsp; Por ejemplo: wwv_find.gif.&nbsp; El prefijo de la imagen puede ser uno de los siguientes:',
'',
'<ol>',
'',
'<li>&#35;WORKSPACE_IMAGES&#35;</li>',
'',
'<li>&#35;APP_IMAGES&#35;</li>',
'',
unistr('<li>nulo (del directorio especificado por el atributo de imagen de la aplicaci\00F3n)</li>'),
'',
'</ol>',
'',
'Ejemplo de nombres de imagen:',
'',
'<pre>',
'',
'&#35;WORKSPACE_IMAGES&#35;my_image.jpg',
'',
'&#35;APP_IMAGES&#35;another_image.gif',
'',
'html_db_white.gif',
'',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22028144007.4001)
,p_name=>'F4000_P4308_ICON_TARGET'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icon Target'
,p_source=>'ICON_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22029144008.4001)
,p_name=>'F4000_P4308_ICON_IMAGE_ALT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(195827117454955907.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen de Icono Alternativa'
,p_source=>'ICON_IMAGE_ALT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este texto se agrega a la etiqueta alternativa de la imagen.&nbsp; El texto alternativo se muestra al pasar el cursor sobre la imagen. Si este elemento Barra de Iconos no tiene imagen, sino s\00F3lo texto, aqu\00ED es donde se especifica ese texto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22030144008.4001)
,p_name=>'F4000_P4308_ICON_HEIGHT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(195827117454955907.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Altura de Imagen'
,p_source=>'ICON_HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Puede definir los atributos de altura y ancho de la imagen.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22031144008.4001)
,p_name=>'F4000_P4308_ICON_WIDTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(195827117454955907.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ancho'
,p_source=>'ICON_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Puede definir los atributos de altura y ancho de la imagen.&nbsp; '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22035144009.4001)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(460530239.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'ICON_BAR_DISP_COND'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o proc')
||'esa el componente.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22036144010.4001)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND_TYPE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(460530239.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'ICON_BAR_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n Especificada -')
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Seleccione un tipo de condici\00F3n de la lista que se debe cumplir para presentar este componente como procesado.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4308_ICON_BAR_DISP_COND'
,p_attribute_02=>'F4000_P4308_ICON_BAR_FLOW_COND_INSTR'
,p_attribute_04=>'F4000_P4308_ICON_BAR_DISP_COND_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4308_ICON_BAR_DISP_COND_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22037144010.4001)
,p_name=>'F4000_P4308_ICON_BAR_FLOW_COND_INSTR'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(460530239.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'ICON_BAR_FLOW_COND_INSTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22038144010.4001)
,p_name=>'F4000_P4308_BEGINS_ON_NEW_LINE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(458502857.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NO'
,p_prompt=>unistr('Empieza en una Nueva L\00EDnea')
,p_source=>'BEGINS_ON_NEW_LINE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov=>'.'||wwv_flow_api.id(84270019143507704.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Los iconos de navegaci\00F3n se muestran en celdas de tabla, si define Empieza en una Nueva L\00EDnea en S\00ED, se crear\00E1 una nueva fila de tabla.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22039144010.4001)
,p_name=>'F4000_P4308_CELL_COLSPAN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(458502857.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>unistr('Ampliaci\00F3n de Columna de Celda')
,p_source=>'CELL_COLSPAN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Por defecto, cada entrada de barra de navegaci\00F3n abarca una celda (es decir, ampliaci\00F3n de columna de datos de tabla HTML=1).&nbsp; Si el HTML necesita una ampliaci\00F3n de columna diferente, puede definirla con este control.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293034139962.4001)
,p_name=>'F4000_P4308_SECURITY_SCHEME'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(145711905273893908.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este componente se presente o se procese.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8220271440001.4001)
,p_name=>'F4000_P4308_ICON_SUBTEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(458502857.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta de Entrada'
,p_source=>'ICON_SUBTEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Por cada icono de barra de navegaci\00F3n se puede definir un subtexto opcional que aparecer\00E1 debajo del icono.&nbsp; Por ejemplo un icono de ayuda puede mostrar el texto "ayuda" debajo del mismo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2206168622404716.4001)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND_LANG'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(460530239.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22257618866437042.4001)
,p_name=>'P4308_URL_OR_FLOW'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_item_default=>'FLOW'
,p_prompt=>'tipo de objetivo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_api.id(84796030957080920.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un destino para esta entrada de barra de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22258504799442417.4001)
,p_name=>'P4308_PAGE_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el n\00FAmero de p\00E1gina. Active la casilla que hay junto al n\00FAmero de p\00E1gina si desea restablecer la paginaci\00F3n para esa p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22259803675460991.4001)
,p_name=>'P4308_CLEAR_PAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para restablecer la paginaci\00F3n a la que est\00E1 enlazada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22260829995468664.4001)
,p_name=>'P4308_REQUEST'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto en el que desea definir el elemento de aplicaci\00F3n incorporado denominado REQUEST. \00C9ste es tambi\00E9n el elemento definido con el nombre de un bot\00F3n en el que se ha hecho clic.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22261712118472912.4001)
,p_name=>'P4308_CLEAR_CACHE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_prompt=>unistr('Borrar Cach\00E9')
,p_post_element_text=>unistr('<span class="instructionText">(n\00FAmeros de p\00E1gina separados por comas)</span>')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca los n\00FAmeros de p\00E1gina, separados por comas, para los que desea que se limpie el estado de la sesi\00F3n del usuario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22262727009477231.4001)
,p_name=>'P4308_ARG_NAMES'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_prompt=>'Defina estos elementos'
,p_post_element_text=>'<span class="instructionText">(lista de nombres separados por comas)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la lista de nombres de elementos de aplicaci\00F3n, separados por una coma, para los que desea definir el estado de la sesi\00F3n (proporcionar un valor al elemento mostrado).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22263604976480339.4001)
,p_name=>'P4308_ARG_VALUES'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_prompt=>'Con estos valores'
,p_post_element_text=>'<span class="instructionText">(lista de valores separados por comas)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una lista de valores delimitada por comas para los elementos especificados en <span class="fielddatabold">Defina estos elementos</span>. Puede especificar valores est\00E1ticos o sintaxis de sustituci\00F3n (por ejemplo, &amp;APP_ITEM_NAME.). '),
'<pre>&amp;APP_ITEM_NAME.</pre>',
unistr('<div class="htmldbInfoBodyP">Los valores de los elementos que se transfieren a <span class="fielddatabold">f?p=</span> en la direcci\00F3n URL nunca pueden contener un signo de dos puntos (:). Los valores de los elementos tampoco pueden contener comas a ')
||'menos que incluya todo el valor entre caracteres de barra invertida. Por ejemplo:</div>',
'<pre>\1234,56\</pre>',
unistr('<div class="htmldbInfoBodyP">Esto resulta \00FAtil cuando hay que transferir valores decimales donde el car\00E1cter separador de decimales de NLS es una coma.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22269307925519078.4001)
,p_name=>'P4308_URL_TARGET'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_prompt=>'Destino de URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique la direcci\00F3n URL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35744908558245590.4001)
,p_name=>'F4000_P4308_REFRESH'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(33343906966817956.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_icon_bar',
'',
'where reference_id is null',
'',
'and id = :F4000_P4308_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106505115489517485.4001)
,p_name=>'P4308_PRINTER_FRIENDLY'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(461549004.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PRINTER_FRIENDLY)'
,p_lov=>'.'||wwv_flow_api.id(148325219515185885.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para definir la versi\00F3n para impresora.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148591414867925615.4001)
,p_name=>'P4308_ID_NEXT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(457499110.4001)
,p_prompt=>'P4308_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148591712078925620.4001)
,p_name=>'P4308_ID_PREV'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(457499110.4001)
,p_prompt=>'P4308_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(148592132491925621.4001)
,p_name=>'P4308_ID_COUNT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(457499110.4001)
,p_prompt=>unistr('Entrada de Barra de Navegaci\00F3n: ')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el icono de barra de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173928305516662714.4001)
,p_name=>'P4308_NAV_ENTRY_IS_FEEDBACK_YN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(197051508527618833.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('\00BFEs Entrada de Comentarios?')
,p_source=>'NAV_ENTRY_IS_FEEDBACK_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Indica que esta entrada de la barra de navegaci\00F3n es un enlace a una p\00E1gina en la que se recopilan comentarios a los que se puede acceder desde el m\00F3dulo de desarrollo de equipo. Los comentarios estar\00E1n activados o desactivados en el nivel de la apli')
||unistr('caci\00F3n de forma que se pueden activar para realizar pruebas y desactivar en tareas de producci\00F3n. Si el atributo de nivel de la aplicaci\00F3n est\00E1 desactivado, no se mostrar\00E1 la entrada de la barra de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(197056626676709192.4001)
,p_name=>'P4308_FEEDBACK_ENABLED'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(197051508527618833.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Comentarios Activados por Aplicaci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'   nvl(allow_feedback_yn,''N''),',
'   ''N'',wwv_flow_lang.system_message(''NO''),',
'   ''Y'',wwv_flow_lang.system_message(''YES'')) allow_feedback',
'from wwv_flows',
'where security_group_id = :flow_security_group_id and',
'          id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica si los comentarios est\00E1n activados en la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(200963313439917546.4001)
,p_name=>'F4000_P4308_REFERENCE_ID'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(33343906966817956.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Hacer Referencia a Barra de Navegaci\00F3n Maestra desde')
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_NAVBARS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''LAYOUT.T_NO''))||'' '' ||wwv_flow_lang.system_message(''NAVBAR'')||',
'''  -'' d, 0 r from dual union all',
'select flow_id||'' : ''||',
'icon_image_alt d,',
'id r',
'from   wwv_flow_icon_bar',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique una entrada de barra de navegaci\00F3n a la que suscribirse.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435041518929654786.4001)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND_CHECK'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(460530239.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(22308631230658229.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4308_ICON_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'begin',
'',
'if :P4308_URL_OR_FLOW = ''FLOW'' then',
'  if :P4308_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4308_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4308_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''||:P4308_PAGE_ID||'':&''||''SESSION.:''||:P4308_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P4308_ARG_NAMES||'':''||:P4308_ARG_VALUES||'':''||:P4308_PRINTER_FRIENDLY;',
'else',
'  return :P4308_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'Create,ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35755306389261804.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4308_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(22318216563720245.4001)
,p_validation_name=>'Target Required'
,p_validation_sequence=>10
,p_validation=>'(:P4308_URL_OR_FLOW = ''URL'' and :P4308_URL_TARGET is not null) or (:P4308_URL_OR_FLOW = ''FLOW'' and :P4308_PAGE_ID is not null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Se debe especificar la direcci\00F3n URL o p\00E1gina como destino.')
,p_validation_condition=>'Create,ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(201030209496995288.4001)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4308_ICON_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la secuencia.'
,p_associated_item=>wwv_flow_api.id(22026144007.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(201034923717003950.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4308_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de referencia para refrescar la barra de navegaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(200951627971903655.4001)
,p_associated_item=>wwv_flow_api.id(200963313439917546.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(201039407542011420.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>40
,p_validation=>'F4000_P4308_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>unistr('Se debe especificar la barra de navegaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(200951627971903655.4001)
,p_associated_item=>wwv_flow_api.id(200963313439917546.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(29795621712493576.4001)
,p_validation_name=>'sequence must be numeric'
,p_validation_sequence=>50
,p_validation=>'F4000_P4308_ICON_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La secuencia debe ser un n\00FAmero.')
,p_validation_condition=>'ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(22026144007.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(79925008243460498.4001)
,p_validation_name=>'HeightNumeric'
,p_validation_sequence=>60
,p_validation=>'F4000_P4308_ICON_HEIGHT'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La altura debe ser num\00E9rica.')
,p_validation_condition=>'ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(22030144008.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(79926119325463712.4001)
,p_validation_name=>'WidthNumeric'
,p_validation_sequence=>70
,p_validation=>'F4000_P4308_ICON_WIDTH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('El ancho debe ser num\00E9rico.')
,p_validation_condition=>'ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(22031144008.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(114970116502901828.4001)
,p_validation_name=>'either image or subtext'
,p_validation_sequence=>80
,p_validation=>'return :F4000_P4308_ICON_IMAGE is not null or :F4000_P4308_ICON_SUBTEXT is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Debe proporcionar una imagen o subtexto.'
,p_validation_condition=>'Create,ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(8220271440001.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397302832270507728.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4308_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397303116209507728.4001)
,p_event_id=>wwv_flow_api.id(397302832270507728.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(148586029317925560.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397303205390509427.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4308_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397303511890509429.4001)
,p_event_id=>wwv_flow_api.id(397303205390509427.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(148585905863925560.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(385811634721243641.4001)
,p_name=>'URL or Flow Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4308_URL_OR_FLOW'
,p_condition_element=>'P4308_URL_OR_FLOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385811702814243642.4001)
,p_event_id=>wwv_flow_api.id(385811634721243641.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_URL_TARGET'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385811877002243643.4001)
,p_event_id=>wwv_flow_api.id(385811634721243641.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_URL_TARGET'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385811935593243644.4001)
,p_event_id=>wwv_flow_api.id(385811634721243641.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_PAGE_ID,P4308_REQUEST,P4308_CLEAR_CACHE,P4308_ARG_NAMES,P4308_ARG_VALUES,P4308_CLEAR_PAGE,P4308_PRINTER_FRIENDLY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385812010092243645.4001)
,p_event_id=>wwv_flow_api.id(385811634721243641.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_PAGE_ID,P4308_REQUEST,P4308_CLEAR_CACHE,P4308_ARG_NAMES,P4308_ARG_VALUES,P4308_CLEAR_PAGE,P4308_PRINTER_FRIENDLY'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184076129018005316.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_ICON_BAR'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_ICON_BAR'
,p_attribute_03=>'F4000_P4308_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22040144011.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'  l_dummy varchar2(255);',
'  l_url_parts wwv_flow_global.vc_arr2;',
'begin',
'',
'for c1 in (select icon_target',
'             from wwv_flow_icon_bar',
'            where id = :F4000_P4308_ID',
'              and security_group_id = wwv_flow_security.g_security_group_id) loop',
'',
'wwv_flow_builder.split_url(',
'  p_url         => c1.icon_target,',
'  p_flow        => l_dummy,',
'  p_page        => :P4308_PAGE_ID,',
'  p_session     => l_dummy,',
'  p_request     => :P4308_REQUEST,',
'  p_debug       => l_dummy,',
'  p_clear_cache => :P4308_CLEAR_CACHE,',
'  p_arg_names   => :P4308_ARG_NAMES,',
'  p_arg_values  => :P4308_ARG_VALUES,',
'  p_success_msg => l_dummy );',
'',
'  -- Printer Friendly Check',
'  l_url_parts := wwv_flow_utilities.string_to_table(c1.icon_target);',
'  if l_url_parts.exists(9) then',
'    :P4308_PRINTER_FRIENDLY := l_url_parts(9);',
'  else',
'    :P4308_PRINTER_FRIENDLY := null;',
'  end if;',
'',
'  if :P4308_PAGE_ID is null then',
'    :P4308_URL_TARGET := c1.icon_target;',
'    :P4308_URL_OR_FLOW := ''URL'';',
'  else',
'    :P4308_URL_TARGET := null;',
'    :P4308_URL_OR_FLOW := ''FLOW'';',
'    if instr(:P4308_CLEAR_CACHE,''RP'') = 1 then',
'      :P4308_CLEAR_PAGE := ''YES'';',
'      :P4308_CLEAR_CACHE := ltrim(replace(:P4308_CLEAR_CACHE,''RP'',null),'','');',
'    else',
'      :P4308_CLEAR_PAGE := null;',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(148593117500925633.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_ICON_BAR'
,p_attribute_03=>'F4000_P4308_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'ICON_SEQUENCE'
,p_attribute_09=>'P4308_ID_NEXT'
,p_attribute_10=>'P4308_ID_PREV'
,p_attribute_13=>'P4308_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201053200844029745.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'referesh navbar 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_navbar (',
'    p_master_navbar_id         => :F4000_P4308_REFERENCE_ID,',
'    p_subscribing_navbar_id    => :F4000_P4308_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar la barra de navegaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(200951627971903655.4001)
,p_process_when=>'F4000_P4308_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>unistr('Barra de navegaci\00F3n copiada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22041144011.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ICON_BAR'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4308_ID is null',
'or exists (select 1 from wwv_flow_icon_bar',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4308_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_ICON_BAR'',',
'p_rowid       => v(''F4000_P4308_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35764514128288584.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh navbar 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_navbar (',
'    p_master_navbar_id         => :F4000_P4308_REFERENCE_ID,',
'    p_subscribing_navbar_id    => :F4000_P4308_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al copiar la barra de navegaci\00F3n.')
,p_process_when=>':F4000_P4308_REFERENCE_ID is not null and :F4000_P4308_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Barra de navegaci\00F3n copiada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(201063006008042542.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_navbar_reference_id (:F4000_P4308_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de referencia en nulo.'
,p_process_when=>'F4000_P4308_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
);
end;
/
prompt --application/pages/page_04309
begin
wwv_flow_api.create_page(
 p_id=>4309.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Proceso de Aplicaci\00F3n')
,p_step_title=>unistr('Editar Proceso de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(470940026.4001)
,p_plug_name=>unistr('Proceso de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471942214.4001)
,p_plug_name=>'Origen'
,p_region_name=>'PROC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_menu_template_id=>wwv_flow_api.id(10071028536455972.4001)
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('No existe ninguna opci\00F3n para este men\00FA.')
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472946689.4001)
,p_plug_name=>'Condiciones'
,p_region_name=>'COND'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(60628322026519501.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473950010.4001)
,p_plug_name=>unistr('Procesos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Se pueden utilizar los procesos de aplicaci\00F3n para realizar acciones necesarias en todas las p\00E1ginas. Se puede hacer referencia a elementos de p\00E1gina y aplicaci\00F3n mediante la sintaxis :ITEM_NAME (variable de enlace). El texto de proceso se trata como')
||unistr(' bloque PL/SQL an\00F3nimo. &PRODUCT_NAME. colocar\00E1 "begin" y "end;" alrededor de este c\00F3digo. Si necesita declarar variables locales, deber\00E1 hacerlo mediante un bloque "declare", "begin" y "end".')
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46258417365679010.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146358621670654951.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(146360716710657189.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_name=>'AUTH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(60628322026519501.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179022502185802099.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'CONFIG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179321217295576377.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615490518574215323.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PROCESSING',
'where id = :F4000_P4309_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4309_ID,',
'      p_component_type => ''Application Process'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22043144011.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(470940026.4001)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22044144011.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(470940026.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4309_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22045144012.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(470940026.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4309_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22046144012.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(470940026.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4309_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(91800322412064357.4001)
,p_branch_action=>'f?p=&APP_ID.:4309:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4309_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22048144012.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(168466319275144038.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(22043144011.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22049144012.4001)
,p_branch_action=>'4207'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(22043144011.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803951768.4001)
,p_name=>'F4000_P4309_PROCESS_COMMENT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(146358621670654951.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'PROCESS_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n, \00FAnicamente son para uso de los desarrolladores de aplicaciones.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(9170594471.4001)
,p_name=>'F4000_P4309_REQUIRED_PATCH'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(179022502185802099.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22050144013.4001)
,p_name=>'F4000_P4309_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(179321217295576377.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22051144013.4001)
,p_name=>'F4000_P4309_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(179321217295576377.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'class="tabledata"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica el nombre y el ID de la aplicaci\00F3n propietaria del proceso.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22052144013.4001)
,p_name=>'F4000_P4309_PROCESS_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(179321217295576377.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>'PROCESS_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22053144014.4001)
,p_name=>'F4000_P4309_PROCESS_POINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(179321217295576377.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BEFORE_HEADER'
,p_prompt=>'Punto de Proceso'
,p_source=>'PROCESS_POINT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLOW.PROCESS.TYPE'
,p_lov=>'.'||wwv_flow_api.id(179311318624565491.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Para un proceso de nivel de aplicaci\00F3n, esto identifica el punto durante el procesamiento de cada p\00E1gina de la aplicaci\00F3n en el que se ejecuta este proceso. Tenga en cuenta que la opci\00F3n Devoluci\00F3n de Llamada de AJAX solo se ejecuta cuando lo soli')
||unistr('cita un proceso de p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22054144014.4001)
,p_name=>'F4000_P4309_PROCESS_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(179321217295576377.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'PROCESS_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Identifica el nombre del proceso para los desarrolladores de aplicaciones.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22055144014.4001)
,p_name=>'F4000_P4309_PROCESS_SQL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(471942214.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo')
,p_source=>'PROCESS_SQL_CLOB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>30000
,p_cHeight=>16
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el c\00F3digo PL/SQL de su proceso de solicitud. El c\00F3digo se ajustar\00E1 autom\00E1ticamente con un bloque "<code>Begin</code>" y "<code>End;</code>".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4309_PROCESS_CLOB_LANGUAGE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22056144014.4001)
,p_name=>'F4000_P4309_PROCESS_ERROR_MESSAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(471942214.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mensaje de Error de Proceso'
,p_source=>'PROCESS_ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el texto para un mensaje de error que puede aparecer si el proceso falla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22057144015.4001)
,p_name=>'F4000_P4309_PROCESS_WHEN'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(472946689.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'PROCESS_WHEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo permite controlar de forma condicional las circunstancias bajo las que se debe arrancar este proceso. Introduzca valores en este atributo seg\00FAn el tipo de condici\00F3n concreto seleccionado. El proceso s\00F3lo se arrancar\00E1 si se cumple la ')
||unistr('condici\00F3n especificada.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22058144015.4001)
,p_name=>'F4000_P4309_PROCESS_WHEN_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(472946689.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'PROCESS_WHEN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Seleccione un tipo de condici\00F3n de la lista que se debe cumplir para que se procese este componente.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4309_PROCESS_WHEN'
,p_attribute_02=>'F4000_P4309_'
,p_attribute_04=>'F4000_P4309_PROCESS_WHEN_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4309_PROCESS_WHEN_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1567784322713208.4001)
,p_name=>'P4309_PROCESS_CLOB_LANGUAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(471942214.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'PROCESS_CLOB_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2300219343421105.4001)
,p_name=>'F4000_P4309_PROCESS_WHEN_LANG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(472946689.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4295631883163712.4001)
,p_name=>'P4309_ERROR_DISPLAY_LOCATION'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(471942214.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'INLINE_IN_NOTIFICATION'
,p_prompt=>unistr('Ubicaci\00F3n de Visualizaci\00F3n de Mensaje de Error')
,p_source=>'ERROR_DISPLAY_LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PROCESS_ERROR_DISPLAY_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(4297030283172730.4001)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'F4000_P4309_PROCESS_POINT'
,p_display_when2=>'ON_SUBMIT_BEFORE_COMPUTATION:AFTER_SUBMIT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>La <strong>ubicaci\00F3n de visualizaci\00F3n de error</strong> identifica d\00F3nde aparecer\00E1 el mensaje de error del proceso. Los mensajes de error del proceso pueden aparecer en una p\00E1gina de error o en l\00EDnea con la p\00E1gina existente en el \00E1rea de "notifica')
||unistr('ci\00F3n" (definida como parte de la plantilla de p\00E1gina).</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4836709962963406.4001)
,p_name=>'P4309_CHECK_SYNTAX'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(471942214.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLSQL_VALIDATION'
,p_lov=>'.'||wwv_flow_api.id(111144330433082822.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17787105784947386.4001)
,p_name=>'F4000_P4309_'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(472946689.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'PROCESS_WHEN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91797521458045167.4001)
,p_name=>'F4000_P4309_STAY'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(473950010.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('<p>Active esta casilla para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(146368811522674873.4001)
,p_name=>'F4000_P4309_SECURITY_SCHEME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(146360716710657189.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este proceso se ejecute.</p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(195096709473544728.4001)
,p_name=>'F4000_P4309_PROCESS_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(179321217295576377.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'PLSQL'
,p_prompt=>'Tipo'
,p_source=>'PROCESS_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PLSQL_ANONYMOUS_BLOCK'
,p_lov=>'.'||wwv_flow_api.id(84783318827001758.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Identifica el tipo de proceso. <strong>Bloque An\00F3nimo PL/SQL</strong>:</p><BLOCKQUOTE>Ejecuta un proceso PL/SQL. </BLOCKQUOTE>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435041823893654787.4001)
,p_name=>'F4000_P4309_PROCESS_WHEN_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(472946689.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(171393802931702648.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4309_PROCESS_SQL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.remove_trailing_whitespace(:F4000_P4309_PROCESS_SQL)'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'F4000_P4309_PROCESS_SQL'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(171398124916707597.4001)
,p_validation_name=>'process_sql must be less than 30,000'
,p_validation_sequence=>30
,p_validation=>'length(:F4000_P4309_PROCESS_SQL) <= 30000'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('La aplicaci\00F3n no puede exceder de 30.000 bytes.')
,p_validation_condition=>'ApplyChanges,Apply Changes,Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4835631325938298.4001)
,p_validation_name=>'Syntax Check'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code (',
'           p_type     => wwv_flow_code_exec_dev.c_check_block,',
'           p_code     => :F4000_P4309_PROCESS_SQL,',
'           p_language => :P4309_PROCESS_CLOB_LANGUAGE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P4309_CHECK_SYNTAX, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(22045144012.4001)
,p_associated_item=>wwv_flow_api.id(22055144014.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22059144015.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PROCESSING'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PROCESSING'
,p_attribute_03=>'F4000_P4309_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22060144015.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_PROCESSING'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4309_ID is null',
'or exists (select 1 from wwv_flow_processing',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4309_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_PROCESSING'',',
'p_rowid       => v(''F4000_P4309_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04310
begin
wwv_flow_api.create_page(
 p_id=>4310.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Comentarios de Aplicaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Comentarios de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213220627333807318)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_app_com.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62329311242879281.4001)
,p_plug_name=>'Comentarios'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(590132738684647897.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22062144016.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(590132738684647897.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22064144016.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(590132738684647897.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_condition=>'v(''F4000_P4310_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(22065144016.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(590132738684647897.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>'v(''F4000_P4310_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22067144017.4001)
,p_branch_action=>'9'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22069144017.4001)
,p_name=>'F4000_P4310_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(62329311242879281.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22070144017.4001)
,p_name=>'F4000_P4310_BANNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(62329311242879281.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'BANNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cMaxlength=>32767
,p_cHeight=>12
,p_tag_attributes=>'style="width:465px;"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecer\00E1n nunca cuando se est\00E9 ejecutando la aplicaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(590116752384572003.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(22062144016.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(590116858254572004.4001)
,p_event_id=>wwv_flow_api.id(590116752384572003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22071144018.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_BANNER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_banner',
'where security_group_id = :flow_security_group_id and',
'      id = :F4000_P4310_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_BANNER'',',
'  p_rowid       => v(''F4000_P4310_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(22072144018.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_BANNER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4310_ID is null',
'or exists (select 1 from wwv_flow_banner',
'                   where security_group_id = :flow_security_group_id and',
'      id = :F4000_P4310_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_BANNER'',',
'p_rowid       => v(''F4000_P4310_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(590116923491572005.4001)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Create,ApplyChanges'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04318
begin
wwv_flow_api.create_page(
 p_id=>4318.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Separadores Principales'
,p_step_title=>'Editar Separador Principal'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466864847.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>3
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(467876613.4001)
,p_plug_name=>'Separadores Principales'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>21
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Los separadores principales son los padres de los separadores est\00E1ndar y necesitan que \00E9stos \00FAltimos existan para visualizarse. Los separadores principales no actuales se muestran como enlaces.'),
unistr('<p>Un separador de nivel principal es actual si la p\00E1gina actual pertenece a un juego de separadores cuyo padre es el separador de nivel principal. El juego de separadores actual se define mediante el campo "Actual en Juego de Separadores Est\00E1ndar".')))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468886629.4001)
,p_plug_name=>'Destino de Separador'
,p_region_name=>'TAR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>94
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(469888520.4001)
,p_plug_name=>unistr('Visualizaci\00F3n Condicional de Separadores')
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>96
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_row_template=>wwv_flow_api.id(118965217531999309.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46261023725679016.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>2
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91892922055192842.4001)
,p_plug_name=>'Separador Principal'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(119249815723896591.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(145723531128912349.4001)
,p_plug_name=>unistr('Autorizaci\00F3n')
,p_region_name=>'AUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>97
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(167029827418165358.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>98
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185569318248518897.4001)
,p_plug_name=>'Atributos de Imagen'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>95
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11089289914.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(91892922055192842.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11090289914.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(91892922055192842.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4318_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11091289914.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(91892922055192842.4001)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4318_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(11092289914.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(91892922055192842.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4318_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11094289915.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(576386928.4001)
,p_name=>'F4000_P4318_DISPLAY_CONDITION'
,p_item_sequence=>36
,p_item_plug_id=>wwv_flow_api.id(469888520.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'DISPLAY_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Este atributo permite controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o proc')
||'esa el componente.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11096289920.4001)
,p_name=>'F4000_P4318_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11097289920.4001)
,p_name=>'F4000_P4318_FLOW_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11098289921.4001)
,p_name=>'F4000_P4318_TAB_SET'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Separadores Principales:'
,p_source=>'TAB_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Permite agrupar separadores en un solo juego. Todos los separadores de un juego aparecen si el separador aprueba la condici\00F3n de visualizaci\00F3n. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11099289921.4001)
,p_name=>'F4000_P4318_TAB_SEQUENCE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Secuencia'
,p_source=>'TAB_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11100289921.4001)
,p_name=>'F4000_P4318_TAB_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'TAB_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la entrada de separador individual. Se utiliza para hacer referencia al separador de forma interna. \00C9ste no es el texto mostrado ni la etiqueta del separador.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11101289922.4001)
,p_name=>'F4000_P4318_TAB_IMAGE'
,p_item_sequence=>6
,p_item_plug_id=>wwv_flow_api.id(185569318248518897.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen'
,p_source=>'TAB_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Si el separador es una imagen y no es un separador de texto, introduzca un nombre de archivo (sin prefijo) en este campo. Por ejemplo, miseparador.gif. \00C9sta es la imagen del separador actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11102289922.4001)
,p_name=>'F4000_P4318_TAB_NON_CURRENT_IMAGE'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_api.id(185569318248518897.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imagen no Actual'
,p_source=>'TAB_NON_CURRENT_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Imagen opcional utilizada para un separador no actual. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11103289922.4001)
,p_name=>'F4000_P4318_TAB_IMAGE_ATTRIBUTES'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_api.id(185569318248518897.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Imagen'
,p_source=>'TAB_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Atributos HTML adicionales para la imagen, si se ha utilizado, por ejemplo, width="14" height="18".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11104289923.4001)
,p_name=>'F4000_P4318_TAB_TEXT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta'
,p_source=>'TAB_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('\00C9ste es el nombre mostrado del separador si no se utiliza una imagen. Se utiliza como etiqueta de imagen alternativa si se utiliza una imagen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11105289923.4001)
,p_name=>'F4000_P4318_TAB_TARGET'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Target<br> (Syntax: f?p=application:page:session:request:debug:clearCache:itemNames:itemValues:printerFriendly)(Example f?p=3000:3001:&amp;SESSION.)'
,p_source=>'TAB_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11106289924.4001)
,p_name=>'F4000_P4318_REQUIRED_PATCH'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_api.id(167029827418165358.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11107289924.4001)
,p_name=>'F4000_P4318_TAB_COMMENT'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_api.id(119249815723896591.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TAB_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11132399142.4001)
,p_name=>'F4000_P4318_CURRENT_ON_TABSET'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_api.id(466864847.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Actual en Juego de Separadores Est\00E1ndar')
,p_source=>'CURRENT_ON_TABSET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Juego de Separadores Est\00E1ndar -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica el separador secundario (separador est\00E1ndar correspondiente) de este separador principal.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(64149671474.4001)
,p_name=>'F4000_P4318_DISPLAY_CONDITION_TYPE'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_api.id(469888520.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Condici\00F3n de Visualizaci\00F3n de Separador')
,p_source=>'DISPLAY_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Separador No Condicional -'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<P>Seleccione una de las condiciones predefinidas si desea que este separador aparezca s\00F3lo en determinadas situaciones:</P>'),
'',
'<UL>',
'',
unistr('<LI>CURRENT_PAGE_NOT_EQUALS_CONDITION: el separador s\00F3lo aparecer\00E1 si la p\00E1gina actual no es la p\00E1gina especificada en el campo Condici\00F3n de Visualizaci\00F3n.</LI>'),
'',
unistr('<LI>CURRENT_PAGE_EQUALS_CONDITION: el separador s\00F3lo aparecer\00E1 si la p\00E1gina actual es la p\00E1gina especificada en el campo Condici\00F3n de Visualizaci\00F3n.</LI>'),
'',
unistr('<LI>CURRENT_PAGE_NOT_IN_CONDITION: el separador s\00F3lo aparecer\00E1 si la p\00E1gina actual no est\00E1 en la lista de p\00E1ginas especificadas en el campo Condici\00F3n de Visualizaci\00F3n (lista de p\00E1ginas separadas por comas).</LI>'),
'',
unistr('<LI>CURRENT_PAGE_IN_CONDITION: el separador s\00F3lo aparecer\00E1 si la p\00E1gina actual est\00E1 en la lista de p\00E1ginas especificadas en el campo Condici\00F3n de Visualizaci\00F3n (lista de p\00E1ginas separadas por comas).</LI>'),
'',
unistr('<LI>USER_IS_NOT_PUBLIC_USER: el separador s\00F3lo aparecer\00E1&nbsp;si el usuario actual no es el usuario p\00FAblico. No se necesita ninguna entrada en el campo Condici\00F3n de Visualizaci\00F3n.</LI>'),
'',
unistr('<LI>USER_IS_PUBLIC_USER: el separador s\00F3lo aparecer\00E1&nbsp;si el usuario actual es el usuario p\00FAblico. No se necesita ninguna entrada en el campo Condici\00F3n de Visualizaci\00F3n.</LI>'),
'',
unistr('<LI>EXISTS: el separador s\00F3lo aparecer\00E1 si la consulta del campo Condici\00F3n de Visualizaci\00F3n devuelve al menos una fila.</LI>'),
'',
unistr('<LI>ITEM_IS_NOT_NULL: el separador s\00F3lo aparecer\00E1 si el elemento identificado en el campo Condici\00F3n de Visualizaci\00F3n no es nulo.</LI>'),
'',
unistr('<LI>ITEM_IS_NULL:&nbsp;el separador s\00F3lo aparecer\00E1 si el elemento identificado en el campo Condici\00F3n de Visualizaci\00F3n es nulo.</LI>'),
'',
unistr('<LI>NOT_EXISTS: el separador s\00F3lo aparecer\00E1 si la consulta del campo Condici\00F3n de Visualizaci\00F3n no devuelve filas.</LI>'),
'',
unistr('<LI>PLSQL_EXPRESSION: el separador s\00F3lo aparecer\00E1 si la expresi\00F3n PL/SQL del campo Condici\00F3n de Visualizaci\00F3n se eval\00FAa como verdadera.</LI>'),
'',
unistr('<LI>SQL_EXPRESSION: el separador s\00F3lo aparecer\00E1 si la expresi\00F3n SQL del campo Condici\00F3n de Visualizaci\00F3n se eval\00FAa como verdadera.</LI></UL>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4318_DISPLAY_CONDITION'
,p_attribute_02=>'F4000_P4318_DISPLAY_CONDITION2'
,p_attribute_04=>'F4000_P4318_DISPLAY_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4318_DISPLAY_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293052246378.4001)
,p_name=>'F4000_P4318_SECURITY_SCHEME'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_api.id(145723531128912349.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autorizaci\00F3n')
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1 from dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'    from wwv_flow_security_schemes where flow_id = :FB_FLOW_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'    from   wwv_flow_security_schemes',
'    where flow_id = :FB_FLOW_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se necesita autorizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Puede seleccionar un esquema de autorizaci\00F3n que debe dar un resultado TRUE para que este componente se presente o se procese.</p>')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2302783387436909.4001)
,p_name=>'F4000_P4318_DISPLAY_CONDITION_LANG'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_api.id(469888520.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17468309780745161.4001)
,p_name=>'F4000_P4318_DISPLAY_CONDITION2'
,p_item_sequence=>56
,p_item_plug_id=>wwv_flow_api.id(469888520.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'DISPLAY_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21535509380480556.4001)
,p_name=>'P4318_PAGE_ID'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>14
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el n\00FAmero de p\00E1gina. Active la casilla que hay junto al n\00FAmero de p\00E1gina si desea restablecer la paginaci\00F3n para esa p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21536421631493496.4001)
,p_name=>'P4318_CLEAR_PAGE'
,p_item_sequence=>48
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para restablecer la paginaci\00F3n a la que est\00E1 enlazada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21537300984497027.4001)
,p_name=>'P4318_REQUEST'
,p_item_sequence=>58
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca el texto en el que desea definir el elemento de aplicaci\00F3n incorporado denominado REQUEST. \00C9ste es tambi\00E9n el elemento definido con el nombre de un bot\00F3n en el que se ha hecho clic.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21538213451500649.4001)
,p_name=>'P4318_CLEAR_CACHE'
,p_item_sequence=>68
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_prompt=>unistr('Borrar Cach\00E9')
,p_post_element_text=>unistr('<span class="instructionText">(n\00FAmeros de p\00E1gina separados por comas)</span>')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca los n\00FAmeros de p\00E1gina, separados por comas, para los que desea que se limpie el estado de la sesi\00F3n del usuario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21539125918504264.4001)
,p_name=>'P4318_ARG_NAMES'
,p_item_sequence=>78
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_prompt=>'Defina estos elementos'
,p_post_element_text=>'<span class="instructionText">(lista de nombres separados por comas)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la lista de nombres de elementos de aplicaci\00F3n, separados por una coma, para los que desea definir el estado de la sesi\00F3n (proporcionar un valor al elemento mostrado).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21540024317513227.4001)
,p_name=>'P4318_ARG_VALUES'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_prompt=>'Con estos valores'
,p_post_element_text=>'<span class="instructionText">(lista de valores separados por comas)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una lista de valores delimitada por comas para los elementos especificados en <span class="fielddatabold">Defina estos elementos</span>. Puede especificar valores est\00E1ticos o sintaxis de sustituci\00F3n (por ejemplo, &amp;APP_ITEM_NAME.). '),
'<pre>&amp;APP_ITEM_NAME.</pre>',
unistr('<div class="htmldbInfoBodyP">Los valores de los elementos que se transfieren a <span class="fielddatabold">f?p=</span> en la direcci\00F3n URL nunca pueden contener un signo de dos puntos (:). Los valores de los elementos tampoco pueden contener comas a ')
||'menos que incluya todo el valor entre caracteres de barra invertida. Por ejemplo:</div>',
'<pre>\1234,56\</pre>',
unistr('<div class="htmldbInfoBodyP">Esto resulta \00FAtil cuando hay que transferir valores decimales donde el car\00E1cter separador de decimales de NLS es una coma.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77640609408595060.4001)
,p_name=>'P4318_URL_OR_FLOW'
,p_item_sequence=>11.5
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_item_default=>'FLOW'
,p_prompt=>'tipo de objetivo'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_api.id(84796030957080920.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tipo de objetivo para este separador principal.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(77648318674616570.4001)
,p_name=>'P4318_URL_TARGET'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_api.id(468886629.4001)
,p_prompt=>'Destino de URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la direcci\00F3n URL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435043900011654795.4001)
,p_name=>'F4000_P4318_DISPLAY_CONDITION_CHECK'
,p_item_sequence=>46
,p_item_plug_id=>wwv_flow_api.id(469888520.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(21546424111598369.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4318_TAB_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'begin',
'',
'if :P4318_URL_OR_FLOW = ''FLOW'' then',
'  if :P4318_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4318_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4318_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''||:P4318_PAGE_ID||'':&''||''SESSION.:''||:P4318_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P4318_ARG_NAMES||'':''||:P4318_ARG_VALUES;',
'else',
'  return :P4318_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'Create,Apply_Changes'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240569720533263131.4001)
,p_validation_name=>'F4000_P4318_TAB_SEQUENCE not null'
,p_validation_sequence=>5
,p_validation=>'F4000_P4318_TAB_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el n\00FAmero de la secuencia.')
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(11099289921.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240568002394248467.4001)
,p_validation_name=>'F4000_P4318_TAB_SEQUENCE is numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4318_TAB_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La secuencia debe ser un n\00FAmero.')
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(11099289921.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240571806381287495.4001)
,p_validation_name=>'F4000_P4318_TAB_NAME not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4318_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre del separador.'
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(11100289921.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(240575519204366837.4001)
,p_validation_name=>'F4000_P4318_TAB_TEXT not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4318_TAB_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la etiqueta de separador.'
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(11104289923.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846498751146131702.4001)
,p_name=>'URL or Flow Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4318_URL_OR_FLOW'
,p_condition_element=>'P4318_URL_OR_FLOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846498865378131703.4001)
,p_event_id=>wwv_flow_api.id(846498751146131702.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_URL_TARGET'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846498978490131704.4001)
,p_event_id=>wwv_flow_api.id(846498751146131702.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_URL_TARGET'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846499014488131705.4001)
,p_event_id=>wwv_flow_api.id(846498751146131702.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_PAGE_ID,P4318_REQUEST,P4318_CLEAR_CACHE,P4318_ARG_NAMES,P4318_ARG_VALUES.P4318_CLEAR_PAGE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846499156151131706.4001)
,p_event_id=>wwv_flow_api.id(846498751146131702.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_PAGE_ID,P4318_REQUEST,P4318_CLEAR_CACHE,P4318_ARG_NAMES,P4318_ARG_VALUES,P4318_CLEAR_PAGE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184082828343506519.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_FLOW_TOPLEVEL_TABS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TOPLEVEL_TABS'
,p_attribute_03=>'F4000_P4318_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11108289924.4001)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'  l_dummy varchar2(255);',
'begin',
'',
'for c1 in (select tab_target',
'             from wwv_flow_toplevel_tabs',
'            where id = :F4000_P4318_ID',
'            and security_group_id = wwv_flow_security.g_security_group_id) loop',
'',
'wwv_flow_builder.split_url(',
'  p_url         => c1.tab_target,',
'  p_flow        => l_dummy,',
'  p_page        => :P4318_PAGE_ID,',
'  p_session     => l_dummy,',
'  p_request     => :P4318_REQUEST,',
'  p_debug       => l_dummy,',
'  p_clear_cache => :P4318_CLEAR_CACHE,',
'  p_arg_names   => :P4318_ARG_NAMES,',
'  p_arg_values  => :P4318_ARG_VALUES,',
'  p_success_msg => l_dummy );',
'',
'  if :P4318_PAGE_ID is null then',
'    if c1.tab_target is not null then',
'      :P4318_URL_TARGET := c1.tab_target;',
'      :P4318_URL_OR_FLOW := ''URL'';',
'    else',
'      :P4318_URL_OR_FLOW := ''0'';',
'      :P4318_URL_TARGET := null;',
'    end if;',
'  else',
'    :P4318_URL_TARGET := null;',
'    :P4318_URL_OR_FLOW := ''FLOW'';',
'    if instr(:P4318_CLEAR_CACHE,''RP'') = 1 then',
'      :P4318_CLEAR_PAGE := ''YES'';',
'      :P4318_CLEAR_CACHE := ltrim(replace(:P4318_CLEAR_CACHE,''RP'',null),'','');',
'    else',
'      :P4318_CLEAR_PAGE := null;',
'    end if;',
'  end if;',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(11109289924.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_TOPLEVEL_TABS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4318_ID is null',
'or exists (select 1 from wwv_flow_toplevel_tabs',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4318_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_TOPLEVEL_TABS'',',
'p_rowid       => v(''F4000_P4318_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n de separador principal &F4000_P4318_TAB_NAME. procesada.')
);
end;
/
prompt --application/pages/page_04320
begin
wwv_flow_api.create_page(
 p_id=>4320.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plantilla de Regi\00F3n: Copiar de')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Plantilla de Regi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(267682922.4001)
,p_plug_name=>unistr('Crear Plantilla de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>' '
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>unistr('No se ha encontrado ninguna plantilla de p\00E1gina.')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47959921151873200.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177290315823957583.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(274749605.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(47959921151873200.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177879730880992221.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47959921151873200.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177245107894925820.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47959921151873200.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(151482332258001583.4001)
,p_branch_action=>'f?p=&FLOW_ID.:498:&SESSION.::&DEBUG.:498::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177879730880992221.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177245501542925829.4001)
,p_branch_action=>'901'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(177245107894925820.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(270704481.4001)
,p_name=>'F4000_P4320_COPY_FROM_FLOW_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(267682922.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que desea copiar plantillas de regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177909802031012438.4001)
,p_validation_name=>'F4000_P4320_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4320_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_validation_comment=>'generated 18-FEB-2002 17:00'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589947406131621419.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(274749605.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589947581029621420.4001)
,p_event_id=>wwv_flow_api.id(589947406131621419.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04321
begin
wwv_flow_api.create_page(
 p_id=>4321.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plantilla de Informe: Copiar de'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(381176857.4001)
,p_plug_name=>'Crear Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>92
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>unistr('<p>Seleccione la aplicaci\00F3n que contiene las plantillas que desea copiar.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47965624839940518.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>102
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178585413354262292.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(320074633987.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(394437439.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(47965624839940518.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178567722323240273.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47965624839940518.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178565114358237978.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47965624839940518.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178568125379240276.4001)
,p_branch_action=>'343'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(178567722323240273.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(589890586342923050.4001)
,p_branch_action=>'f?p=&APP_ID.:951:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178565114358237978.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(384253953.4001)
,p_name=>'F4000_P4321_COPY_FROM_FLOW_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(381176857.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde la que se va a copiar el nuevo informe.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178573604093251417.4001)
,p_validation_name=>'F4000_P4321_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4321_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la copia de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(384253953.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-FEB-2002 13:06'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(589890306211923048.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(394437439.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(589890435109923049.4001)
,p_event_id=>wwv_flow_api.id(589890306211923048.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04400
begin
wwv_flow_api.create_page(
 p_id=>4400.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Plugins'
,p_step_title=>'Plugins'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(27795916812844315.4001)
,p_name=>'Editado Recientemente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name name,',
'       id',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and last_updated_on   is not null',
' order by last_updated_on desc',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('Ning\00FAn plugin encontrado')
,p_query_row_count_max=>10
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Imprimir'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Aplicaci\00F3n &FB_FLOW_ID.: &FB_FLOW_NAME.')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27796127997844319.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,4410:P4410_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'N'
,p_print_col_width=>'50'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(27796228142844319.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27796304762844319.4001)
,p_plug_name=>'Informe de Plugin'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4400a */ p.id, ',
'       p.name,',
'       p.display_name,',
'       p.plugin_type,',
'       ( select count(*)',
'           from wwv_flow_step_items',
'          where flow_id       = p.flow_id',
'            and display_as    = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''ITEM TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_region_columns',
'          where flow_id       = p.flow_id',
'            and item_type     = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''ITEM TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_page_plugs',
'          where flow_id          = p.flow_id',
'            and plug_source_type = ''PLUGIN_''||p.name',
'            and p.plugin_type    = ''REGION TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_region_report_column',
'          where flow_id       = p.flow_id',
'            and display_as    = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''REPORT COLUMN TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_processing',
'          where flow_id       = p.flow_id',
'            and process_type  = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''PROCESS TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_step_processing',
'          where flow_id       = p.flow_id',
'            and process_type  = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''PROCESS TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_page_da_events  e,',
'                wwv_flow_page_da_actions a',
'          where e.flow_id     = p.flow_id',
'            and a.event_id    = e.id',
'            and a.action      = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''DYNAMIC ACTION''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_security_schemes',
'          where flow_id       = p.flow_id',
'            and scheme_type   = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''AUTHORIZATION TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_web_src_modules',
'          where flow_id         = p.flow_id',
'            and web_source_type = ''PLUGIN_''||p.name',
'            and p.plugin_type   = ''WEB SOURCE TYPE''',
'       ) +       ',
'       ( select count(*)',
'           from wwv_flow_authentications',
'          where flow_id       = p.flow_id',
'            and scheme_type   = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''AUTHENTICATION TYPE''',
'       ) as ref,',
'       case when p.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_plugins',
'                         where id                = p.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_plugins',
'          where reference_id      = p.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       p.version_identifier,',
'       p.about_url,',
'       p.plugin_comment,',
'       p.help_text,',
'       p.last_updated_on,',
'       p.last_updated_by,',
'       --',
'       ''icon-sc-plugin'' as icon_class,',
'       p.display_name                             as icon_title,',
'       ''f?p=4000:4410:''||:app_session||''::NO:4410:P4410_ID:''||p.id as edit_link',
'  from wwv_flow_plugins p',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(27796519609844319.4001)
,p_name=>'Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('Ning\00FAn plugin encontrado.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27796610594844321.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27816028761928582.4001)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>2
,p_column_identifier=>'J'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,4410:P4410_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27796726333844322.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Nombre Interno'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(32848825202511722.4001)
,p_db_column_name=>'PLUGIN_TYPE'
,p_display_order=>4
,p_column_identifier=>'N'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(32850007287563326)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27816115563928583.4001)
,p_db_column_name=>'VERSION_IDENTIFIER'
,p_display_order=>5
,p_column_identifier=>'K'
,p_column_label=>unistr('Versi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27816222669928583.4001)
,p_db_column_name=>'ABOUT_URL'
,p_display_order=>6
,p_column_identifier=>'L'
,p_column_label=>'Acerca de URL'
,p_column_link=>'#ABOUT_URL#'
,p_column_linktext=>'#ABOUT_URL#'
,p_column_link_attr=>'target="_blank"'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340561585027198325.4001)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>16
,p_column_identifier=>'R'
,p_column_label=>'Suscrito desde'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1340561688389198326.4001)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>26
,p_column_identifier=>'S'
,p_column_label=>'Suscriptores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27796928916844322.4001)
,p_db_column_name=>'REF'
,p_display_order=>36
,p_column_identifier=>'D'
,p_column_label=>'Referencias'
,p_column_link=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:RP,4420,CIR:IR_DISPLAY_NAME:#DISPLAY_NAME#'
,p_column_linktext=>'#REF#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27797115083844322.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>46
,p_column_identifier=>'F'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27797023408844322.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>56
,p_column_identifier=>'E'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(28181600244446878.4001)
,p_db_column_name=>'PLUGIN_COMMENT'
,p_display_order=>66
,p_column_identifier=>'M'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27797412280844323.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>76
,p_column_identifier=>'I'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(135880018019765024.4001)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>86
,p_column_identifier=>'O'
,p_column_label=>'Texto de Ayuda'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656759561042314130.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>96
,p_column_identifier=>'P'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656759603814314130.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>106
,p_column_identifier=>'Q'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27798318837844327.4001)
,p_plug_name=>'Plugins'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un plugin es una ampliaci\00F3n de los tipos incorporados de &PRODUCT_NAME. Utilice los plugins para el uso declarativo de nuevos tipos de esquema de autorizaci\00F3n y de autenticaci\00F3n, de proceso de acci\00F3n din\00E1mica, de regi\00F3n y de elemento en la aplicac')
||unistr('i\00F3n.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/implementing-plug-ins.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27883916853665983.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(27943608569240649.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188995524741097691.4001)
,p_plug_name=>'navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(188993730020080349.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188992318414039122.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(27796304762844319.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:4400,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(429270928966650613.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(27796304762844319.4001)
,p_button_name=>'VIEW_REPOSITORY'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ver Repositorio de Plugin'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:window.open(''http://apex.oracle.com/plugins211'', ''_blank'');void(0);'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27885315646703424.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(27796304762844319.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Importar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:RP,460:P460_FILE_TYPE:PLUGIN'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28078910841897614.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(27796304762844319.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:RP,4402,4404,4406,4410::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_04402
begin
wwv_flow_api.create_page(
 p_id=>4402.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plugin: M\00E9todo')
,p_step_title=>unistr('Crear Plugin: M\00E9todo')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434103354337321418.4001)
,p_plug_name=>'Crear Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Al crear un nuevo plugin, tiene dos opciones. Puede crear un nuevo plugin desde el principio o reutilizar implantaciones que ya existan en la aplicaci\00F3n o en otras aplicaciones del espacio de trabajo.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434104034376321434.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1434105688733324411.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434104283162321434.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434104895732321440.4001)
,p_plug_name=>'Crear Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434104409431321435.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1434104283162321434.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434104635838321439.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1434104283162321434.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1434105352327321468.4001)
,p_branch_name=>'Go To Page 816'
,p_branch_action=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1434104635838321439.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4402_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1434105524301321474.4001)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,4410::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1434104635838321439.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4402_ACTION'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1434103585895321420.4001)
,p_name=>'P4402_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1434103354337321418.4001)
,p_item_default=>'CREATE'
,p_prompt=>'Crear Plugin:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4402.ACTION'
,p_lov=>'.'||wwv_flow_api.id(1434173283114513679.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione el m\00E9todo mediante el cual desea crear un plugin.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_04404
begin
wwv_flow_api.create_page(
 p_id=>4404.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Plugin: Aplicaci\00F3n')
,p_step_title=>unistr('Crear Plugin: Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434158319547350901.4001)
,p_plug_name=>'Crear Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_header=>unistr('<p>Utilice esta p\00E1gina para copiar un plugin de otra aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434159038252350902.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1434105688733324411.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434159247913350902.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434160020964350904.4001)
,p_plug_name=>'Crear Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434159464309350902.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1434159247913350902.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434159608808350902.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1434159247913350902.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434159851620350902.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1434159247913350902.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1434160521315350908.4001)
,p_branch_name=>'Go To Page 4406'
,p_branch_action=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1434159608808350902.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1434160701938350908.4001)
,p_branch_name=>'Go To Page 4402'
,p_branch_action=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1434159851620350902.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1434158563533350901.4001)
,p_name=>'P4404_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1434158319547350901.4001)
,p_prompt=>unistr('Copiar de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||f.name as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_plugins a',
'                 where a.flow_id = f.id',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione la aplicaci\00F3n desde la que desea copiar los plugins.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_04406
begin
wwv_flow_api.create_page(
 p_id=>4406.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Plugin: Copiar'
,p_step_title=>'Crear Plugin: Copiar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1340559765582198307.4001)
,p_name=>'Crear Plugin'
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       plugin_type,',
'       display_name,',
'       case when reference_id is not null then ''Y'' end as is_subscribed,',
'       case',
'         when reference_id is null and :P4404_COPY_FROM = :FB_FLOW_ID then wwv_flow_lang.system_message( ''F4000.P158.COPY_OF'', display_name )',
'         else display_name',
'       end as to_display_name,',
'       case',
'         when :P4404_COPY_FROM = :FB_FLOW_ID then ''N''',
'         when reference_id is not null       then ''Y''',
'         else ''SUBSCRIBE''',
'       end as action',
'  from wwv_flow_plugins a',
' where flow_id           = :P4404_COPY_FROM',
'   and security_group_id = :WORKSPACE_ID',
'   and (',
'       -- Don''t show subscribed plug-ins, because they can''t be copied',
'          (   :P4404_COPY_FROM = :FB_FLOW_ID',
'          and reference_id is null',
'          )',
'       -- Don''t show plug-ins which have already been copied from another application',
'       or (   :P4404_COPY_FROM <> :FB_FLOW_ID',
'          and not exists ( select 1',
'                             from wwv_flow_plugins b',
'                            where b.flow_id           = :FB_FLOW_ID',
'                              and b.security_group_id = :WORKSPACE_ID',
'                              and b.plugin_type       = a.plugin_type',
'                              and b.name              = a.name',
'                         )',
'          )',
'       )',
' order by plugin_type, display_name',
''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique el plugin que desea copiar y seleccione la opci\00F3n de copia. Entre las opciones de copia se incluyen:</p>'),
'<ul>',
unistr('    <li><strong>S\00ED.</strong> Copiar el plugin.</li>'),
'    <li><strong>No.</strong> No copiar este plugin.</li>',
unistr('    <li><strong>Copiar y Suscribir.</Strong> La suscripci\00F3n a un plugin incluye una copia del mismo en la aplicaci\00F3n y define la referencia maestra del plugin.</li>'),
'</ul>',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>999
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('No hay ning\00FAn plugin disponible o ya se han copiado todos.')
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1340559827601198308.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1340559918145198309.4001)
,p_query_column_id=>2
,p_column_alias=>'PLUGIN_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32850007287563326)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1340560021525198310.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1340560722930198317.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>4
,p_column_heading=>'Suscrito'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1340560194906198311.4001)
,p_query_column_id=>5
,p_column_alias=>'TO_DISPLAY_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'A Nombre'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1340560284075198312.4001)
,p_query_column_id=>6
,p_column_alias=>'ACTION'
,p_column_display_sequence=>6
,p_column_heading=>unistr('\00BFCopiar?')
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(1434176433131599379)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340561447354198324.4001)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_api.id(1340559765582198307.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434163698916375404.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(1434105688733324411.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434163882193375405.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1434164663980375407.4001)
,p_plug_name=>'Crear Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1340561087128198320.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1340561447354198324.4001)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular la Selecci\00F3n de Todo')
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434164055823375405.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1434163882193375405.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434164291946375406.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1434163882193375405.4001)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copiar Plugins'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1434164460554375406.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1434163882193375405.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1434165712968375419.4001)
,p_branch_name=>'Go To Page 4400'
,p_branch_action=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1434166193582375420.4001)
,p_branch_name=>'Go To Page 4404'
,p_branch_action=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1434164460554375406.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1340561103171198321.4001)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1340561087128198320.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1340561200400198322.4001)
,p_event_id=>wwv_flow_api.id(1340561103171198321.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'td[headers=ACTION] select'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1340560585862198315.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(1340559765582198307.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy plug-ins'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :ACTION in (''Y'', ''SUBSCRIBE'') then',
'        wwv_flow_copy_util.copy_plugin (',
'            p_from_application_id => :P4404_COPY_FROM,',
'            p_from_plugin_id      => :ID,',
'            p_to_application_id   => :FB_FLOW_ID,',
'            p_to_display_name     => :TO_DISPLAY_NAME,',
'            p_subscribe           => ( :ACTION = ''SUBSCRIBE'' ));',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1434164291946375406.4001)
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Plugins copiados.'
);
end;
/
prompt --application/pages/page_04410
begin
wwv_flow_api.create_page(
 p_id=>4410.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear/Editar: Plugin'
,p_step_title=>'Crear/Editar: Plugin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'/* For read only we want to show the code in monospace and with spaces */',
'#P4410_PLSQL_CODE_DISPLAY {',
'  font-family: monospace;',
'  white-space: pre;',
'}',
'</style>',
'',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4410_REFERENCE_ID'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5261005290655272.4001)
,p_plug_name=>'Soportado para'
,p_region_name=>'WORKS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27899611028734555.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'PLUGIN_NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27899831305734555.4001)
,p_plug_name=>'Origen'
,p_region_name=>'SOURCE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27900213448734557.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27900816654734558.4001)
,p_plug_name=>'Plugin: &P4410_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27901032534734559.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_name=>'INFORMATION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27935931959010930.4001)
,p_plug_name=>'Devoluciones de Llamada'
,p_region_name=>'CALLBACKS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27941016095186035.4001)
,p_plug_name=>'Plugins'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un plugin es una ampliaci\00F3n de los tipos incorporados de &PRODUCT_NAME. Utilice los plugin para el uso declarativo de nuevos tipos de elemento, regi\00F3n, proceso y acci\00F3n din\00E1mica en la aplicaci\00F3n.</p> '),
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27942831164228303.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(27884204995681439.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(29873113508481210.4001)
,p_name=>'Archivos'
,p_region_name=>'FILES'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       security_group_id,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       round( sys.dbms_lob.getLength(file_content) / 1024 / 1024, 2 )  as file_size_in_mb,',
'       file_charset,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'           p_scope      => ''PLUGIN'',',
'           p_app_id     => :fb_flow_id,',
'           p_plugin_id  => :P4410_ID,',
'           p_file_name  => file_name ) as reference,',
'       -- unescaping URL to keep whitespaces in G_BC_PARENT_LABEL',
'       utl_url.unescape(apex_page.get_url(',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,P118_ID,G_BC_PARENT_LABEL'',',
'           p_values      => ''PLUGIN,'' || flow_id || '','' || plugin_id || '','' || id || '','' || :P4410_DISPLAY_NAME',
'       )) as edit_link,',
'       nvl(last_updated_on, created_on)                 as updated,',
'       nvl(lower(last_updated_by), lower(created_by))   as updated_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_plugin_files f)',
' where flow_id           = :fb_flow_id',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :workspace_id'))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn archivo.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29877510794584509.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3567173693979613.4001)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>11
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29873408985481212.4001)
,p_query_column_id=>3
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Nombre de Archivo'
,p_use_as_row_header=>'N'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29873530227481212.4001)
,p_query_column_id=>4
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>31
,p_column_heading=>'Tipo MIME'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29895523719796329.4001)
,p_query_column_id=>5
,p_column_alias=>'FILE_SIZE'
,p_column_display_sequence=>51
,p_column_heading=>unistr('Tama\00F1o de Archivo')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(21699475293753946.4001)
,p_query_column_id=>6
,p_column_alias=>'FILE_SIZE_IN_MB'
,p_column_display_sequence=>61
,p_column_heading=>unistr('Tama\00F1o de archivo en MB')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(21699558694753947.4001)
,p_query_column_id=>7
,p_column_alias=>'FILE_CHARSET'
,p_column_display_sequence=>41
,p_column_heading=>'Juego de Caracteres de Archivo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29873603248481212.4001)
,p_query_column_id=>8
,p_column_alias=>'FILE_CONTENT'
,p_column_display_sequence=>81
,p_column_heading=>'Archivo'
,p_use_as_row_header=>'N'
,p_column_format=>'DOWNLOAD:WWV_FLOW_PLUGIN_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME:LAST_UPDATED_ON:FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(21699665166753948.4001)
,p_query_column_id=>9
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>71
,p_column_heading=>'Referencia'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(21699727731753949.4001)
,p_query_column_id=>10
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>91
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(21699861698753950.4001)
,p_query_column_id=>11
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>101
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(3565962651979601.4001)
,p_query_column_id=>12
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>111
,p_column_heading=>'Actualizado por'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33327228999114743.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33340707031647637.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_PLUGINS'
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'P4410_ID'
,p_attribute_04=>'P4410_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_PLUGIN'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46888818357161021.4001)
,p_plug_name=>'Texto de Ayuda'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48467930491898431.4001)
,p_name=>'Atributos Personalizados'
,p_region_name=>'CUST_ATTRIBUTES'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id,',
'       a.attribute_scope,',
'       a.attribute_sequence,',
'       a.display_sequence,',
'       a.prompt,',
'       a.is_required,',
'       a.default_value,',
'       a.attribute_type,',
'       d.prompt as depending_on_prompt',
'  from wwv_flow_plugin_attributes a,',
'       wwv_flow_plugin_attributes d',
' where a.plugin_id         = :P4410_ID',
'   and a.security_group_id = :WORKSPACE_ID',
'   and d.id (+)            = a.depending_on_attribute_id'))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn atributo.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48468100478898440.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48468705126910020.4001)
,p_query_column_id=>2
,p_column_alias=>'ATTRIBUTE_SCOPE'
,p_column_display_sequence=>3
,p_column_heading=>unistr('\00C1mbito')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32688601172502165)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48468808229910037.4001)
,p_query_column_id=>3
,p_column_alias=>'ATTRIBUTE_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Atributo'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(451251025866010763.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>5
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48468927141910037.4001)
,p_query_column_id=>5
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>2
,p_column_heading=>'Etiqueta'
,p_column_link=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_4415'',set:{''P4410_ATTRIBUTE_ID'':''#ID#''}});'
,p_column_linktext=>'#PROMPT#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48469008549910037.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>7
,p_column_heading=>'Necesario'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(161084231163549216.4001)
,p_query_column_id=>7
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>8
,p_column_heading=>'Valor por Defecto'
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262037604939319214.4001)
,p_query_column_id=>8
,p_column_alias=>'ATTRIBUTE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(28057124498012298)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(262037930350336033.4001)
,p_query_column_id=>9
,p_column_alias=>'DEPENDING_ON_PROMPT'
,p_column_display_sequence=>9
,p_column_heading=>'Depende de'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(48655727964692661.4001)
,p_name=>'Eventos'
,p_region_name=>'EVENTS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       plugin_id,',
'       display_name,',
'       name,',
'       flow_id',
'  from wwv_flow_plugin_events',
' where plugin_id = to_number(:P4410_ID)',
'   and security_group_id = to_number(:workspace_id)'))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>unistr('No se ha definido ning\00FAn evento.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48657903770692695.4001)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48656014506692677.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PLUGIN_EVENTS'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48656204923692680.4001)
,p_query_column_id=>3
,p_column_alias=>'PLUGIN_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Plugin Id'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_column_default=>'P4410_ID'
,p_column_default_type=>'ITEM'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_PLUGIN_EVENTS'
,p_ref_column_name=>'PLUGIN_ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48656428828692680.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>60
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PLUGIN_EVENTS'
,p_ref_column_name=>'DISPLAY_NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48656305294692680.4001)
,p_query_column_id=>5
,p_column_alias=>'NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Nombre Interno'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>45
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PLUGIN_EVENTS'
,p_ref_column_name=>'NAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(179295330406014920.4001)
,p_query_column_id=>6
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Flow Id'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_column_default=>'FB_FLOW_ID'
,p_column_default_type=>'ITEM'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(48661419222709068.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(48661511906709072.4001)
,p_column_sequence=>2
,p_query_column_name=>'PLUGIN_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(48661721075709072.4001)
,p_column_sequence=>3
,p_query_column_name=>'DISPLAY_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(48661605547709072.4001)
,p_column_sequence=>4
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(179294922920014917.4001)
,p_column_sequence=>5
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(439386704233826730.4001)
,p_plug_name=>unistr('Atributos Est\00E1ndar')
,p_region_name=>'STD_ATTRIBUTES'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(538625467201238345.4001)
,p_plug_name=>'URL de Archivo para Cargar'
,p_region_name=>'FILE_URLS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620042529567315148.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>160
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PLUGINS',
'where id = :P4410_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P4410_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(791007298727651108.4001)
,p_name=>unistr('Metadatos Adicionales de Atributo Est\00E1ndar')
,p_region_name=>'STD_ATTRIBUTE_DETAILS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select   a.id,',
'       lvd.lov_disp_value   as display_name,',
'         a.name             as internal_name,',
'         a.is_required,',
'         a.default_value,',
'         d.prompt           as depending_on_attribute',
'  from',
'       wwv_flow_plugins               p,',
'       wwv_flow_plugin_attributes     d,',
'       wwv_flow_plugin_std_attributes a,',
'       wwv_flow_list_of_values_data   lvd, ',
'       WWV_FLOW_LISTS_OF_VALUES$      lv',
' where a.plugin_id         = :P4410_ID',
'   and p.id                = a.plugin_id',
'   and a.security_group_id = :WORKSPACE_ID',
'   and d.id (+)            = a.depending_on_attribute_id',
'   and a.name              = lvd.lov_return_value',
'   and lvd.lov_id          = lv.id ',
'   and lvd.flow_id         = 4000',
'   and lv.lov_name         = case when p.plugin_type = ''ITEM TYPE'' then ''PLUGIN.ITEM_ATTRIBUTES''',
'                                  when p.plugin_type = ''REGION TYPE'' then ''PLUGIN.REGION_ATTRIBUTES''',
'                                  when p.plugin_type = ''WEB SOURCE TYPE'' then ''PLUGIN.WEB_SOURCE_ATTRIBUTES''',
'                                  when p.plugin_type = ''DYNAMIC ACTION'' then ''PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'' end',
''))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha seleccionado ning\00FAn atributo est\00E1ndar con detalles adicionales.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(791007519136651111.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(791008596495651121.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Atributo Est\00E1ndar')
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4411:&SESSION.::&DEBUG.:RP,4411:P4411_PLUGIN_ID,P4411_NAME,P4411_ID,P4411_PLUGIN_TYPE:&P4410_ID.,#INTERNAL_NAME#,#ID#,&P4410_PLUGIN_TYPE.'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(791008614330651122.4001)
,p_query_column_id=>3
,p_column_alias=>'INTERNAL_NAME'
,p_column_display_sequence=>5
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(791008031523651116.4001)
,p_query_column_id=>4
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>3
,p_column_heading=>'Necesario'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(791008111392651117.4001)
,p_query_column_id=>5
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(791008769882651123.4001)
,p_query_column_id=>6
,p_column_alias=>'DEPENDING_ON_ATTRIBUTE'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Seg\00FAn Atributo Personalizado')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48437800027915146.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48467930491898431.4001)
,p_button_name=>'ADD_ATTRIBUTE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Atributo'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''APPLY_CHANGES_CREATE_4415''});'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48656805235692689.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(48655727964692661.4001)
,p_button_name=>'ADD_EVENT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Evento'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:addRow();'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48656707021692689.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(48655727964692661.4001)
,p_button_name=>'DELETE_EVENT'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Eventos'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE_EVENT'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_events',
' where plugin_id = to_number(:P4410_ID)',
'   and security_group_id = to_number(:workspace_id)'))
,p_button_condition_type=>'EXISTS'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30855910247544017.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(29873113508481210.4001)
,p_button_name=>'FILES_DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir Todos los Archivos'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_files',
' where flow_id           = :P4410_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32723802886376952.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33340707031647637.4001)
,p_button_name=>'PUBLISH_PLUGIN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plugin'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,149:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P4410_ID.,&APP_PAGE_ID.,PLUGIN'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where reference_id = :P4410_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30855713266542663.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(29873113508481210.4001)
,p_button_name=>'FILES_DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Descargar como Zip'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_files',
' where flow_id           = :P4410_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(32723606028376952.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33340707031647637.4001)
,p_button_name=>'REFRESH_PLUGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Plugin'
,p_button_position=>'NEXT'
,p_button_condition=>'P4410_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29870024711418146.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(29873113508481210.4001)
,p_button_name=>'CREATE_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear Archivo'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:RP,118:P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,G_BC_PARENT_LABEL:PLUGIN,&P4410_FLOW_ID.,&P4410_ID.,&P4410_DISPLAY_NAME.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27902718197734562.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(27900816654734558.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27903106352734562.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(27900816654734558.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>':P4410_ID is not null and NVL(:P4410_IS_IN_USE, ''N'') = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(27902501930734562.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(27900816654734558.4001)
,p_button_name=>'apply_changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P4410_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(28077802830866929.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(27900816654734558.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Plugin'
,p_button_position=>'NEXT'
,p_button_condition=>'P4410_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30858131573592203.4001)
,p_branch_name=>'Reset Pagination after delete all files'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30855910247544017.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(437419308521420527.4001)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:RP,4415:P4415_ID:&P4410_ATTRIBUTE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4415'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(437422211207440225.4001)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:RP,4415:P4415_PLUGIN_ID:&P4410_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_4415'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(437441811656922826.4001)
,p_branch_action=>'f?p=&APP_ID.:4440:&SESSION.::&DEBUG.:RP,4440:P4440_ID:&P4410_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4440'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32732406702828279.4001)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(32723606028376952.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28054007984885220.4001)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'DELETE_EVENT,ADD_EVENT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27942313933204406.4001)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(27902501930734562.4001)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4410_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(28078125776866929.4001)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(28077802830866929.4001)
,p_branch_sequence=>90
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48839616468976683.4001)
,p_branch_action=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1401713408619804.4001)
,p_name=>'P4410_PROCESS_COMPONENT_TYPES'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5261005290655272.4001)
,p_item_default=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_prompt=>'Tipo de Componente'
,p_source=>'P4410_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_PROCESS_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(1800185422847060.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica si el plugin se muestra en el creador un componente soportado para los procesos de p\00E1gina y las acciones de automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1417035605635701.4001)
,p_name=>'P4410_WEB_SOURCE_ATTRIBUTES'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.WEB_SOURCE_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(1416444037632936.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Para los plugins de origen de datos de REST, identifique los atributos que se aplican a este plugin:',
'</p>',
'<p>',
'<ul>',
'    <li>Punto final por defecto: punto final o prefijo de la URL que se va a proponer para el nuevo origen de datos de REST.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2210655951848924.4001)
,p_name=>'P4410_WSM_CAPABILITIES'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Procedimiento de capacidades de origen de REST'
,p_source=>'WSM_CAPABILITIES_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL para obtener las <em>capacidades</em> de origen de datos de REST. Puede hacer referencia a un procedimiento de bloque de c\00F3digo PL/SQL an\00F3nimo, un procedimiento de paquete o un procedimiento aut\00F3nomo e')
||'n la base de datos. Por ejemplo:',
'<pre>',
'capabilities_web_source',
'</pre>',
'</p>',
'',
unistr('<p>Al hacer referencia a un procedimiento aut\00F3nomo o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#. capabilities_web_source',
'</pre></p>',
'',
'<p>Los procedimientos de capacidades de plugin de tipo de origen de datos de REST deben implantar la siguiente interfaz:',
'',
'<pre>',
'procedure capabilities_web_source (',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_result in out nocopy apex_plugin.t_web_source_capabilities );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2211252101848930.4001)
,p_name=>'P4410_WSM_FETCH'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Procedimiento de recuperaci\00F3n de origen de REST')
,p_source=>'WSM_FETCH_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que implanta la operaci\00F3n de <em>recuperaci\00F3n de filas</em>. Puede hacer referencia a un procedimiento de bloque de c\00F3digo PL/SQL an\00F3nimo, un procedimiento de paquete o un procedimiento aut\00F3nomo en la ')
||'base de datos. Por ejemplo:',
'<pre>',
'fetch_web_source',
'</pre>',
'</p>',
'',
unistr('<p>Al hacer referencia a un procedimiento aut\00F3nomo o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#. fetch_web_source',
'</pre></p>',
'',
unistr('<p>Los procedimientos de recuperaci\00F3n de plugin de tipo de origen de datos de REST deben implantar la siguiente interfaz:'),
'',
'<pre>',
'procedure fetch_web_source(',
'    p_plugin     in            apex_plugin.t_plugin,',
'    p_web_source in            apex_plugin.t_web_source,',
'    p_params     in            apex_plugin.t_web_source_fetch_params,',
'    p_result     in out nocopy apex_plugin.t_web_source_fetch_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2211342826848931.4001)
,p_name=>'P4410_WSM_DML'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Procedimiento de DML de origen de REST'
,p_source=>'WSM_DML_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que implanta las operaciones de <em>DML</em> (insertar, actualizar o suprimir filas). Puede hacer referencia a un procedimiento de bloque de c\00F3digo PL/SQL an\00F3nimo, un procedimiento de paquete o un proc')
||unistr('edimiento aut\00F3nomo en la base de datos. Por ejemplo:'),
'<pre>',
'dml_web_source',
'</pre>',
'</p>',
'',
unistr('<p>Al hacer referencia a un procedimiento aut\00F3nomo o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#. dml_web_source',
'</pre></p>',
'',
'<p>Los procedimientos de DML de plugin de tipo de origen de datos de REST deben implantar la siguiente interfaz:',
'',
'<pre>',
'procedure dml_web_source (',
'    p_plugin     in            apex_plugin.t_plugin,',
'    p_web_source in            apex_plugin.t_web_source,',
'    p_params     in            apex_plugin.t_web_source_dml_params,',
'    p_result     in out nocopy apex_plugin.t_web_source_dml_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2211440908848932.4001)
,p_name=>'P4410_WSM_EXECUTE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Procedimiento de ejecuci\00F3n de origen de REST')
,p_source=>'WSM_EXECUTE_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que implanta la operaci\00F3n de <em>ejecuci\00F3n</em> que se llama cuando se utiliza <strong>APEX_EXEC.EXECUTE_WEB_SOURCE</strong>. Puede hacer referencia a un procedimiento de bloque de c\00F3digo PL/SQL an\00F3nim')
||unistr('o, un procedimiento de paquete o un procedimiento aut\00F3nomo en la base de datos. Por ejemplo:'),
'<pre>',
'execute_web_source',
'</pre>',
'</p>',
'',
unistr('<p>Al hacer referencia a un procedimiento aut\00F3nomo o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#. execute_web_source',
'</pre></p>',
'',
unistr('<p>Los procedimientos de ejecuci\00F3n de plugin de tipo de origen de datos de REST deben implantar la siguiente interfaz:'),
'',
'<pre>',
'procedure execute_web_source(',
'    p_plugin     in            apex_plugin.t_plugin,',
'    p_web_source in            apex_plugin.t_web_source,',
'    p_result     in out nocopy apex_plugin.t_web_source_execute_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2211502762848933.4001)
,p_name=>'P4410_WSM_DISCOVER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Procedimiento de detecci\00F3n de origen de REST')
,p_source=>'WSM_DISCOVER_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que implanta la operaci\00F3n de <em>detecci\00F3n</em> que se llama cuando se crea un nuevo origen de datos de REST, para determinar los tipos de dato, las columnas y las operaciones. Puede hacer referencia a')
||unistr(' un procedimiento de bloque de c\00F3digo PL/SQL an\00F3nimo, un procedimiento de paquete o un procedimiento aut\00F3nomo en la base de datos. Por ejemplo:'),
'<pre>',
'discover_web_source',
'</pre>',
'</p>',
'',
unistr('<p>Al hacer referencia a un procedimiento aut\00F3nomo o a un paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#. discover_web_source',
'</pre></p>',
'',
unistr('<p>Los procedimientos de detecci\00F3n de plugin de tipo de origen de datos de REST deben implantar la siguiente interfaz:'),
'',
'<pre>',
'procedure discover_web_source (',
'    p_plugin         in            apex_plugin.t_plugin,',
'    p_web_source     in            apex_plugin.t_web_source,',
'    p_params         in            apex_plugin.t_web_source_discover_params,',
'    p_result         in out nocopy apex_plugin.t_web_source_discover_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5260303643635873.4001)
,p_name=>'P4410_SUPPORTED_UI_TYPES'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5261005290655272.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DESKTOP'
,p_prompt=>'Interfaz de Usuario'
,p_source=>'SUPPORTED_UI_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'UI TYPES (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name',
'  from wwv_flow_ui_types_dev',
' order by 1'))
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Especifica si el plugin se muestra en el compilador como un componente soportado para las diferentes interfaces de usuario.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14861902600280221.4001)
,p_name=>'P4410_SUBSCRIBE_PLUGIN_SETTINGS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(33340707031647637.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Suscribir Configuraci\00F3n de Componente')
,p_source=>'SUBSCRIBE_PLUGIN_SETTINGS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifica si la configuraci\00F3n de componente del plugin se debe refrescar con la configuraci\00F3n de componente del plugin suscrito en la aplicaci\00F3n maestra si se est\00E1 refrescando el plugin.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20527901230873212.4001)
,p_name=>'P4410_SUBSTITUTE_ATTRIBUTES'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(48467930491898431.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Sustituir Valores de Atributo'
,p_source=>'SUBSTITUTE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los valores de atributo personalizado especificados por el desarrollador pueden contener elementos a los que se hace referencia con la sintaxis de sustituci\00F3n; por ejemplo, <code>&amp;P1_DNAME.</code>'),
'</p>',
unistr('<p>Si los valores de atributos de sustituci\00F3n se definen en <strong>Activado</strong>, &PRODUCT_NAME. sustituir\00E1 autom\00E1ticamente esas referencias por su valor real antes de llamar al plugin.'),
'</p>',
unistr('<p>Si los valores de atributos de sustituci\00F3n se definen en <strong>Desactivado</strong>, los valores se escriben sin cambios en los atributos de tipo de registro <code>attribute_01 - attribute_25</code> de <code>p_plugin, p_item, p_region, ...</code')
||unistr('> y el desarrollador de plugins es responsable de sustituir esas referencias de sintaxis de sustituci\00F3n por una llamada a <code>apex_plugin_util.replace_substitutions</code> o realizar sustituciones similares.'),
'</p>',
unistr('<p>Un caso de uso para <strong>Desactivado</strong> es si el atributo de plugin personalizado se utiliza como plantilla y la sintaxis de sustituci\00F3n se utiliza para hacer referencia a elementos de p\00E1gina y columnas de la sentencia SQL ejecutada por e')
||unistr('l plugin. Puesto que los valores de columna de la sentencia SQL no est\00E1n disponibles en el momento de llamar al plugin, el plugin debe realizar la sustituci\00F3n.'),
'</p>',
'<p>Ejemplo para sustituir manualmente los valores de columna de cada fila:</p>',
'<pre>',
'/* Read data */',
'l_column_value_list := apex_plugin_util.get_data2 (',
'                           p_sql_statement => p_region.source,',
'                           p_region        => p_region );',
'/* Emit rows */',
'for l_row_num in 1 .. l_column_value_list( 1 ).value_list.count loop',
'    begin',
'        -- Assign the column values of the current row',
'        -- into session state',
'        apex_plugin_util.set_component_values (',
'            p_column_value_list => l_column_value_list,',
'            p_row_num           => l_row_num );',
'',
'        ...',
'',
'        -- Link Attribute: Replace substitution variables',
'        -- (including column values of the current row)',
'        l_link := apex_plugin_util.replace_substitutions(',
'                      p_value => p_region.attribute_01 );',
'        ...',
'',
'        apex_plugin_util.clear_component_values;',
'    exception when others then',
'        apex_plugin_util.clear_component_values;',
'        raise;',
'    end;',
'end loop;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27903303099734563.4001)
,p_name=>'P4410_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27903506683734563.4001)
,p_name=>'P4410_DISPLAY_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre del plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27905505067734569.4001)
,p_name=>'P4410_PLSQL_CODE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(27899831305734555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo PL/SQL')
,p_source=>'PLSQL_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>25
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un bloque de c\00F3digo PL/SQL an\00F3nimo que contenga funciones para presentar, validar y ejecutar devoluciones de llamada de AJAX para el plugin.</p>'),
'',
unistr('<p>Por motivos de rendimiento, tambi\00E9n puede almacenar este c\00F3digo en un paquete PL/SQL en la base de datos.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTIONS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27906008506734569.4001)
,p_name=>'P4410_PLUGIN_COMMENT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(27900213448734557.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'PLUGIN_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecer\00E1n nunca cuando se est\00E9 ejecutando la aplicaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27912623836772078.4001)
,p_name=>'P4410_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre Interno'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>40
,p_read_only_when=>'P4410_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un nombre interno para el plugin. &PRODUCT_NAME. utiliza este nombre de forma interna para identificar el plugin y no es visible. El nombre interno debe ser \00FAnico en la aplicaci\00F3n actual.</p>'),
'',
unistr('<p>Se recomienda utilizar el nombre de dominio de la organizaci\00F3n como prefijo en los nombres de plugins para crear un nombre \00FAnico global. Por ejemplo, el nombre de dominio "miempresa.com" utilizado como prefijo en un plugin de tipo elemento llamado')
||unistr(' ''ControlDeslizante'' dar\00EDa lugar a un nombre interno como el siguiente: <code>COM.MIEMPRESA.CONTROLDESLIZANTE</code></p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27932030733896986.4001)
,p_name=>'P4410_VERSION_IDENTIFIER'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(27901032534734559.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n')
,p_source=>'VERSION_IDENTIFIER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Cadena que identifica la versi\00F3n del plugin.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27932216666902439.4001)
,p_name=>'P4410_ABOUT_URL'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(27901032534734559.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Acerca de URL'
,p_source=>'ABOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('URL de la p\00E1gina inicial de los autores del plugin o de documentaci\00F3n adicional acerca del plugin.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27936619062026066.4001)
,p_name=>'P4410_IMAGE_PREFIX'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(29873113508481210.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prefijo de Archivo'
,p_source=>'IMAGE_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determina la ruta de acceso virtual que utiliza el servidor web para apuntar a los archivos del plugin.</p>',
'',
unistr('<p>No especifique nada que haga referencia a los archivos que est\00E1n almacenados con la definici\00F3n del plugin en la base de datos.</p>'),
'',
unistr('<p>Por motivos de rendimiento, tambi\00E9n puede almacenar sus archivos de plugin en el servidor web. Utilice <code>&#35;IMAGE_PREFIX&#35;</code> o cualquier URL v\00E1lida para hacer referencia a ellos.</p>'),
'',
'<p>Ejemplos:',
'<ul>',
'  <li>/myFiles/</li>',
'  <li>http://example.com/myFiles/</li>',
'  <li>&#35;IMAGE_PREFIX&#35;myFiles/</li>',
'</li>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27936921271036180.4001)
,p_name=>'P4410_RENDER_FUNCTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n/Procedimiento de Representaci\00F3n')
,p_source=>'RENDER_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n o el procedimiento PL/SQL que se va a llamar para representar el plugin. Puede hacer referencia a un procedimiento o una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, un procedimiento o una funci\00F3n de paquete, o u')
||unistr('n procedimiento o una funci\00F3n aut\00F3noma de la base de datos. Por ejemplo:'),
'<pre>',
'render_slider',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a una funci\00F3n o un procedimiento aut\00F3nomo o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejempl')
||'o:',
'<pre>',
'#OWNER#.render_slider',
'</pre></p>',
'',
unistr('<p>Los procedimientos de representaci\00F3n de plugins de tipo elemento deben implantar la siguiente interfaz:'),
'',
'<pre>',
'procedimiento &lt;nombre de procedimiento> (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_render_param,',
'    p_result in out nocopy apex_plugin.t_item_render_result )',
'</pre>',
'</p>',
'',
unistr('<p>Las funciones de representaci\00F3n de plugins de tipo regi\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_region              in apex_plugin.t_region,',
'    p_plugin              in apex_plugin.t_plugin,',
'    p_is_printer_friendly in boolean )',
'    return apex_plugin.t_region_render_result',
'</pre>',
'</p>',
'',
unistr('<p>Las funciones de representaci\00F3n de plugins de acci\00F3n din\00E1mica deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_dynamic_action in apex_plugin.t_dynamic_action,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_dynamic_action_render_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27937216900044386.4001)
,p_name=>'P4410_AJAX_FUNCTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n/Procedimiento AJAX')
,p_source=>'AJAX_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento o de la funci\00F3n PL/SQL que utiliza el plugin para cargar datos adicionales con una llamada de Ajax. Puede hacer referencia a un procedimiento o una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, a un procedimie')
||unistr('nto o una funci\00F3n de paquete, o a un procedimiento o una funci\00F3n aut\00F3noma de la base de datos. Por ejemplo:'),
'<pre>',
'ajax_slider',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a un procedimiento o una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejempl')
||'o:',
'<pre>',
'#OWNER#.ajax_slider',
'</pre></p>',
'',
unistr('<p>La devoluci\00F3n de llamada del procedimiento Ajax se comporta de la misma forma que un proceso de devoluci\00F3n de llamada de Ajax y puede acceder a las variables globales <code>apex_application.g_x01 - g_x10</code> gen\00E9ricas para transferir datos desd')
||unistr('e el explorador al backend. Tambi\00E9n puede leer y definir el estado de la sesi\00F3n igual que un proceso de devoluci\00F3n de llamada de Ajax.</p>'),
'',
unistr('<p>Para llamar a la funci\00F3n de devoluci\00F3n de llamada de Ajax desde Javascript, utilice la misma t\00E9cnica que con los procesos de devoluci\00F3n de llamada de Ajax. En lugar de <code>APPLICATION_PROCESS=[process name]</code>, utilice <code>PLUGIN=[p_ajax_i')
||unistr('dentifier]</code>, donde p_ajax_identifier es el valor generado con la funci\00F3n apex_plugin.get_ajax_identifier en la funci\00F3n de representaci\00F3n.</p>'),
'',
'<p>Los procedimientos Ajax de plugin de tipo elemento deben implantar la siguiente interfaz:',
'',
'<pre>',
'procedimiento &lt;nombre de procedimiento> (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_ajax_param,',
'    p_result in out nocopy apex_plugin.t_item_ajax_result )',
'</pre>',
'</p>',
'',
unistr('<p>Las funciones Ajax de plugin de tipo regi\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_region in apex_plugin.t_region,',
'    p_plugin in apex_plugin.t_plugin )',
'    return apex_plugin.t_region_ajax_result',
'</pre>',
'</p>',
'',
unistr('<p>Las funciones Ajax de plugin de acci\00F3n din\00E1mica deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_dynamic_action in apex_plugin.t_dynamic_action,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_dynamic_action_ajax_result',
'</pre>',
'</p>',
'',
'',
unistr('<p>Las funciones Ajax de plugin de esquema de autenticaci\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_authentication_ajax_result',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27937500062049023.4001)
,p_name=>'P4410_VALIDATION_FUNCTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Procedimiento de Validaci\00F3n')
,p_source=>'VALIDATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que puede utilizar el plugin para realizar validaciones b\00E1sicas de los datos ejecutados. Puede hacer referencia a un procedimiento del bloque de c\00F3digo PL/SQL an\00F3nimo, a un procedimiento de paquete o a')
||unistr(' un procedimiento aut\00F3nomo de la base de datos. Por ejemplo:'),
'<pre>',
'validate_slider',
'</pre></p>',
'',
unistr('<p>Cuando haga referencia a un procedimiento aut\00F3nomo o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.validate_slider',
'</pre></p>',
'',
unistr('<p>La devoluci\00F3n de llamada del procedimiento de validaci\00F3n se realiza despu\00E9s de las comprobaciones b\00E1sicas que realiza &PRODUCT_NAME. y antes de que se procesen las validaciones definidas por el usuario. Utilice el marcador de posici\00F3n <em>#LABEL#<')
||unistr('/em> en el mensaje de error si desea obtener la etiqueta actual del elemento de p\00E1gina. Si el <code>mensaje</code> contiene un valor despu\00E9s de la llamada, aparece en la <em>ubicaci\00F3n de visualizaci\00F3n de errores por defecto</em> definida a nivel de l')
||unistr('a aplicaci\00F3n. Para sobrescribir la ubicaci\00F3n por defecto, <code>display_location</code> puede contener uno de los valores constantes definidos en <code>apex_plugin</code>. Si desea mostrar el error en un elemento de p\00E1gina diferente al actual que ya ')
||unistr('se ha procesado, defina <code>page_item_name</code> en el nombre de ese elemento de p\00E1gina.</p> '),
'',
unistr('<p>El procedimiento de validaci\00F3n de plugin de tipo elemento debe implantar la siguiente interfaz:'),
'',
'<pre>',
'procedimiento &lt;nombre de procedimiento> (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_validation_param,',
'    p_result in out nocopy apex_plugin.t_item_validation_result )',
'</pre>',
'</p>',
'',
unistr('<p>Los plugins de tipo regi\00F3n no admiten funciones de validaci\00F3n.</p>'),
'',
unistr('<p>Los plugins de acciones din\00E1micas no admiten funciones de validaci\00F3n.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27941328817186038.4001)
,p_name=>'P4410_RETURN_TO_PAGE'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(27941016095186035.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_display_when=>'P4410_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28059502690081686.4001)
,p_name=>'P4410_IS_IN_USE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28080920238928776.4001)
,p_name=>'P4410_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28102822026383415.4001)
,p_name=>'P4410_CHECK_PLSQL_CODE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(27899831305734555.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLSQL_VALIDATION'
,p_lov=>'.'||wwv_flow_api.id(111144330433082822.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28184221546490809.4001)
,p_name=>'P4410_PLUGIN_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ITEM TYPE'
,p_prompt=>'Tipo'
,p_source=>'PLUGIN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.TYPE'
,p_lov=>'.'||wwv_flow_api.id(32850007287563326.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_read_only_when=>'P4410_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define el tipo de componente que puede utilizar este plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32722907487376946.4001)
,p_name=>'P4410_REFRESH'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(33340707031647637.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_begin_on_new_line=>'N'
,p_display_when=>'P4410_REFERENCE_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(32723128238376948.4001)
,p_name=>'P4410_REFERENCE_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(33340707031647637.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hacer Referencia a Plugin Maestro desde'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_PLUGINS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.flow_id||'' : ''||wwv_flow_escape.html(p.display_name) as d,',
'       p.id as r',
'  from wwv_flow_plugins p,',
'       wwv_flows f',
' where p.flow_id          != to_number(:FB_FLOW_ID)',
'   and p.security_group_id = to_number(:WORKSPACE_ID)',
'   and f.id                = p.flow_id',
'   and f.build_status     not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- sin plugin -'
,p_cSize=>30
,p_cMaxlength=>2000
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('<p>Utilice este campo para basar este plugin en un plugin existente en esta aplicaci\00F3n u otra aplicaci\00F3n del espacio de trabajo.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46889517103170172.4001)
,p_name=>'P4410_HELP_TEXT'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(46888818357161021.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Especifique el texto de ayuda para este plugin. Este texto ayuda a los usuarios del plugin a comprender c\00F3mo funciona.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(331874103528635393.4001)
,p_name=>'P4410_SESSION_SENTRY_FUNCTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n de Protecci\00F3n de Sesi\00F3n')
,p_source=>'SESSION_SENTRY_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que el plugin puede utilizar para realizar la verificaci\00F3n de protecci\00F3n de la sesi\00F3n. Puede hacer referencia a una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, una funci\00F3n de paquete o una funci\00F3n aut\00F3nom')
||'a de la base de datos. Por ejemplo:',
'<pre>',
'check_ldap_session_sentry',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.check_ldap_session_sentry',
'</pre></p>',
'',
unistr('<p>Las funciones de protecci\00F3n de la sesi\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin,',
'    p_is_public_page in boolean )',
'    return apex_plugin.t_authentication_sentry_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(331889920151640177.4001)
,p_name=>'P4410_AUTHENTICATION_FUNCTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n de Autenticaci\00F3n')
,p_source=>'AUTHENTICATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que el plugin puede utilizar para realizar la verificaci\00F3n de las credenciales de usuario introducidas. Puede hacer referencia a una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, una funci\00F3n de paquete o un')
||unistr('a funci\00F3n aut\00F3noma de la base de datos. Por ejemplo:'),
'<pre>',
'authenticate_ldap',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.authenticate_ldap',
'</pre></p>',
'',
unistr('<p>Las funciones de autenticaci\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'     p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin,',
'    p_password       in varchar2 )',
'    return apex_plugin.t_authentication_auth_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(331906101235644222.4001)
,p_name=>'P4410_POST_LOGOUT_FUNCTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n Posterior a la Desconexi\00F3n')
,p_source=>'POST_LOGOUT_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que el plugin llama despu\00E9s de que &PRODUCT_NAME. haya terminado la sesi\00F3n actual. Utilice esta funci\00F3n para desconectarse de otros sistemas como un servidor de Single Sign-On.</p>'),
unistr('<p>Puede hacer referencia a una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, una funci\00F3n de paquete o una funci\00F3n aut\00F3noma de la base de datos. Por ejemplo:'),
'<pre>',
'logout_sso',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.logout_sso',
'</pre></p>',
'',
unistr('<p>Las funciones posteriores a la desconexi\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_authentication_logout_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(332034113880685678.4001)
,p_name=>'P4410_AUTHENTICATION_ATTRIBUTES'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.AUTHENTICATION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(332110302021701175.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para los plugins de tipo Esquema de Autenticaci\00F3n, identifique los atributos que se aplican a este plugin:'),
'</p>',
'<p>',
'<ul>',
unistr('    <li>Tiene Atributo de Sesi\00F3n No V\00E1lida: el campo Detenci\00F3n de Sesi\00F3n en Caso de Error est\00E1 disponible para la acci\00F3n.</li>'),
unistr('    <li>Tiene P\00E1gina de Conexi\00F3n en Aplicaci\00F3n: los usuarios se conectan a trav\00E9s de una p\00E1gina de esta aplicaci\00F3n.</li>'),
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366692012369682701.4001)
,p_name=>'P4410_PROCESS_ATTRIBUTES'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.PROCESS_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(366693502933776161.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para los plugins de tipo Proceso, seleccione lo siguiente para activar opciones como se describe aqu\00ED:'),
'</p>',
'<p>',
'<ul>',
unistr('<li>Regi\00F3n: si se activa, se puede ejecutar un proceso para cada fila de una pantalla tabular.</li>'),
unistr('<li>Regi\00F3n Necesaria: este atributo hace que \00E9ste sea un valor necesario.</li>'),
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366988906394505193.4001)
,p_name=>'P4410_IS_DEPRECATED'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'En desuso'
,p_source=>'IS_DEPRECATED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(392528513648169636.4001)
,p_name=>'P4410_INVALID_SESSION_FUNCTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de funci\00F3n de sesi\00F3n no v\00E1lido')
,p_source=>'INVALID_SESSION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que el plugin llama si se ha detectado una sesi\00F3n no v\00E1lida. Utilice esta funci\00F3n para llamar, por ejemplo, un servidor de Single Sign-On.</p>'),
unistr('<p>Puede hacer referencia a una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, una funci\00F3n de paquete o una funci\00F3n aut\00F3noma de la base de datos. Por ejemplo:'),
'<pre>',
'invalid_sso_session',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.invalid_sso_session',
'</pre></p>',
'',
unistr('<p>Las funciones de sesi\00F3n no v\00E1lida deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_authentication_inval_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(437419030769408004.4001)
,p_name=>'P4410_ATTRIBUTE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(437441631957919189.4001)
,p_name=>'P4410_FILE_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(437472122129256922.4001)
,p_name=>'P4410_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(27900816654734558.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P4410_DISPLAY_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Plugin actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439387710252837916.4001)
,p_name=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.ITEM_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(439387913761867364.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Para los plugins de tipo Elemento, identifique los atributos que se aplican a este plugin:',
'</p>',
'<p>',
'<ul>',
unistr('<li>Es Widget Visible: el widget est\00E1 visible.</li>'),
unistr('<li>Elemento de Pantalla Est\00E1ndar: el widget se presenta como un elemento de pantalla HTML (p. ej., entrada, selecci\00F3n o \00E1rea de texto). Si no est\00E1 activada, <code>apex_plugin_util.get_element_attributes</code> agregar\00E1 autom\00E1ticamente <code>aria-lab')
||unistr('elledby</code> para permitir que el elemento de pantalla no est\00E1ndar se etiquete de modo adecuado, de forma que sea accesible para los lectores de pantalla. Nota: se basa en la sustituci\00F3n <code>#LABEL_ID#</code> que se est\00E1 definiendo en la plantill')
||unistr('a de etiqueta correspondiente del elemento. Tambi\00E9n se debe activar el atributo Es Widget Visible.</li>'),
unistr('<li>Estado de Sesi\00F3n Cambiable: el valor de un elemento se puede cambiar en el estado de la sesi\00F3n. Se debe activar el atributo Es Widget Visible.</li>'),
unistr('<li>Tiene Atributo de Solo Lectura: el usuario puede especificar una condici\00F3n "Solo Lectura" para el elemento. Se debe activar el atributo Es Widget Visible para que se active este atributo.</li>'),
unistr('<li>Tiene Atributo de Caracteres Especiales de Escape: el elemento tiene el campo Caracteres Especiales de Escape en la secci\00F3n Seguridad cuando se edita el elemento. Se debe activar el atributo Es Widget Visible.</li>'),
'<li>Tiene Atributos de Listas de Valores: el elemento tiene atributos de listas de valores. Se debe activar el atributo Es Widget Visible.</li>',
unistr('<li>Tiene Atributos de Origen: el elemento tiene atributos relacionados con el origen como Origen Usado, Tipo de Origen y M\00E1scara de Formato.</li>'),
unistr('<li>M\00E1scara de Formato Solo para Fecha: para elementos que manejan informaci\00F3n de fecha, el campo emergente M\00E1scara de Formato restringe las selecciones de fecha mostrando los valores de fecha que se pueden seleccionar. Se debe activar Tiene Atributo')
||'s de Origen.</li>',
unistr('<li>M\00E1scara de Formato Solo para N\00FAmero: para elementos que manejan informaci\00F3n num\00E9rica, el campo emergente M\00E1scara de Formato restringe las selecciones num\00E9ricas mostrando los valores num\00E9ricos que se pueden seleccionar.</li>'),
unistr('<li>Tiene Atributos de Elemento: el elemento tiene atributos de elemento como Alineaci\00F3n Horizontal/Vertical, Atributos de Elemento de Pantalla HTML, Texto Anterior al Elemento y Texto Posterior al Elemento.</li>'),
'<li>Tiene Atributos de Ancho: se puede controlar el ancho del elemento.</li>',
'<li>Tiene Atributo de Altura: se puede controlar la altura del elemento.</li>',
unistr('<li>Tiene Atributo de Opci\00F3n de Elemento: el elemento permite la especificaci\00F3n de atributos de opci\00F3n adicionales al presentar elementos de selecci\00F3n m\00FAltiple como grupos de botones de radio de casillas de control.</li>'),
unistr('<li>Tiene Atributo de Marcador de Posici\00F3n: el elemento soporta la especificaci\00F3n de texto de marcador de posici\00F3n, que se muestra en el elemento.</li>'),
unistr('<li>Tiene Atributo de Cifrado de Estado de Sesi\00F3n: al editar el elemento, el valor Almac\00E9n cifrado en el estado de la sesi\00F3n se muestra en la regi\00F3n Seguridad.</li>'),
'<li>Tiene Lista de Valores: el elemento tiene una lista de valores asociada. Se debe activar el atributo Es Widget Visible.</li>',
'<li>Lista de Valores Necesaria: para elementos que manejan listas de valores, se debe definir una lista de valores. Se debe activar el atributo Tiene Lista de Valores.</li>',
unistr('<li>Tiene Atributos Nulos de Visualizaci\00F3n de Lista de Valores: el elemento est\00E1 asociado a una lista de valores que puede incluir valores nulos. Se debe activar el atributo Tiene Lista de Valores.</li>'),
'<li>Tiene Atributos de Lista de Valores en Cascada: el elemento tiene atributos relacionados con listas de valores en cascada. Se debe activar el atributo Tiene Lista de Valores.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439396713209952288.4001)
,p_name=>'P4410_REGION_ATTRIBUTES'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.REGION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(439394121736945367.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para los plugins de tipo Regi\00F3n, seleccione lo siguiente para activar opciones como se describe aqu\00ED:'),
'</p>',
'<p>',
'<ul>',
unistr('<li>El Origen de Regi\00F3n es una Sentencia SQL: el origen de regi\00F3n es una sentencia SQL. Si se activa, se puede especificar un n\00FAmero m\00EDnimo y m\00E1ximo de columnas que puede devolver la consulta y se muestran ejemplos de SQL para ayudar al usuario.</li>'),
unistr('<li>El Origen de Regi\00F3n Es Texto sin Formato: el origen de regi\00F3n es texto sin formato.</li>'),
unistr('<li>Origen de Regi\00F3n Necesario: si el origen de regi\00F3n es una sentencia SQL, este atributo hace que \00E9ste sea un valor necesario.</li>'),
unistr('<li>Tiene Atributo "Elementos de P\00E1gina Que Ejecutar": si el origen de regi\00F3n es una sentencia SQL, este atributo permite especificar los elementos de p\00E1gina que se deben definir en el estado de la sesi\00F3n al ejecutar una llamada Ajax para esa regi\00F3n.')
||'</li>',
unistr('<li>Tiene Atributo "N\00FAmero de Filas Recuperadas": la regi\00F3n tiene los campos N\00FAmero de Filas Recuperadas en la secci\00F3n Avanzado al editar la regi\00F3n.</li>'),
unistr('<li>Tiene Atributo "Mensaje No se ha encontrado ning\00FAn dato": la regi\00F3n tiene el campo Mensaje No se ha encontrado ning\00FAn dato en la secci\00F3n Avanzado al editar la regi\00F3n.</li>'),
unistr('<li>Tiene Atributo "Caracteres Especiales de Escape": la regi\00F3n tiene el campo Caracteres Especiales de Escape en la secci\00F3n Seguridad cuando se edita la regi\00F3n.</li>'),
unistr('<li>Tiene "Columnas de Regi\00F3n": la regi\00F3n permite especificar atributos personalizados adicionales para cada columna de la sentencia SQL de origen de la regi\00F3n.</li>'),
unistr('<li>Tiene Atributo de Columna "Cabecera": las columnas de la regi\00F3n tienen el campo Cabecera en la secci\00F3n Cabecera cuando se edita la columna.</li>'),
unistr('<li>Tiene Atributo de Columna "Alineaci\00F3n de Cabecera": las columnas de la regi\00F3n tienen el campo Alineaci\00F3n en la secci\00F3n Cabecera cuando se edita la columna.</li>'),
unistr('<li>Tiene Atributo de Columna "Alineaci\00F3n": las columnas de la regi\00F3n tienen el campo Alineaci\00F3n de Columna en la secci\00F3n Dise\00F1o cuando se edita la columna.</li>'),
unistr('<li>Tiene Atributo de Columna "Clases CSS": las columnas de la regi\00F3n tienen el campo Clases CSS en la secci\00F3n Aspecto cuando se edita la columna.</li>'),
unistr('<li>Tiene Atributo de Columna "Atributos Personalizados": las columnas de la regi\00F3n tienen el campo Atributos Personalizados en la secci\00F3n Avanzado cuando se edita la columna.</li>'),
unistr('<li>Tiene Atributo de Columna "Caracteres Especiales de Escape": las columnas de la regi\00F3n tienen el campo Caracteres Especiales de Escape en la secci\00F3n Seguridad cuando se edita la columna.</li>'),
unistr('<li>Tiene el Atributo "C\00F3digo JavaScript de Inicializaci\00F3n": el campo C\00F3digo JavaScript de Inicializaci\00F3n est\00E1 disponible para la acci\00F3n.</li>'),
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439400226200993952.4001)
,p_name=>'P4410_DYNAMIC_ACTION_ATTRIBUTES'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(439399613733990280.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para los plugins de tipo Acci\00F3n din\00E1mica, identifique los atributos que se aplican a este plugin:'),
'</p>',
'<p>',
'<ul>',
unistr('<li>Para elementos: La acci\00F3n din\00E1mica soporta la selecci\00F3n de elementos como elementos afectados.</li>'),
unistr('<li>Para bot\00F3n: La acci\00F3n din\00E1mica soporta la selecci\00F3n de un bot\00F3n como elemento afectado.</li>'),
unistr('<li>Para regi\00F3n: La acci\00F3n din\00E1mica soporta la selecci\00F3n de una regi\00F3n como elemento afectado.</li>'),
unistr('<li>Para selector de jQuery: La acci\00F3n din\00E1mica soporta la especificaci\00F3n de un selector de jQuery como elemento afectado.</li>'),
unistr('<li>Para expresi\00F3n JavaScript: La acci\00F3n din\00E1mica soporta la especificaci\00F3n de una expresi\00F3n JavaScript como elemento afectado.</li>'),
unistr('<li>Para elemento disparador: La acci\00F3n din\00E1mica soporta la selecci\00F3n del elemento disparador como elemento afectado.</li>'),
unistr('<li>Para origen de evento: La acci\00F3n din\00E1mica soporta la selecci\00F3n del origen de evento como elemento afectado.</li>'),
unistr('<li>Elemento afectado necesario: La acci\00F3n din\00E1mica necesita que se especifique un elemento afectado.</li>'),
unistr('<li>Activar "Disparar al inicializar": Define el valor por defecto para el campo Disparar al inicializar de la acci\00F3n.</li>'),
unistr('<li>Tiene el atributo "Detenci\00F3n de sesi\00F3n en caso de error": El campo Detenci\00F3n de sesi\00F3n en caso de error est\00E1 disponible para la acci\00F3n.</li>'),
unistr('<li>Tiene el atributo "Espera de resultados": El campo Espera de Resultados est\00E1 disponible para la acci\00F3n.</li>'),
unistr('<li>Tiene el atributo "C\00F3digo JavaScript de inicializaci\00F3n": El campo C\00F3digo JavaScript de inicializaci\00F3n est\00E1 disponible para la acci\00F3n.</li>    '),
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(439423826798637462.4001)
,p_name=>'P4410_STANDARD_ATTRIBUTES'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(439386704233826730.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'STANDARD_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471055523670047848.4001)
,p_name=>'P4410_EXECUTION_FUNCTION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n de Ejecuci\00F3n')
,p_source=>'EXECUTION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que se va a llamar para ejecutar el plugin. Puede hacer referencia a una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, una funci\00F3n de paquete o una funci\00F3n aut\00F3noma de la base de datos. Por ejemplo:'),
'<pre>',
'execute_email',
'</pre></p>',
'',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.execute_email',
'</pre></p>',
'',
unistr('<p>Las funciones de ejecuci\00F3n de plugins de tipo proceso deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_process in apex_plugin.t_process,',
'    p_plugin  in apex_plugin.t_plugin )',
'    return apex_plugin.t_process_exec_result',
'</pre>',
'</p>',
'',
unistr('<p>Las funciones de ejecuci\00F3n de plugins de tipo autorizaci\00F3n deben implantar la siguiente interfaz:'),
'',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_authorization in apex_plugin.t_authorization,',
'    p_plugin        in apex_plugin.t_plugin )',
'    return apex_plugin.t_authorization_exec_result',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492593534398392048.4001)
,p_name=>'P4410_IS_QUICK_PICK'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Lista de Valores'
,p_source=>'IS_QUICK_PICK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502499335047935711.4001)
,p_name=>'P4410_ITEM_COMPONENT_TYPES'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5261005290655272.4001)
,p_item_default=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_prompt=>'Tipo de Componente'
,p_source=>'P4410_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_ITEM_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(513667640463524657.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica si el plugin se muestra en el creador como un componente soportado para los elementos de p\00E1gina, las columnas de cuadr\00EDcula interactiva y las facetas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502499417457935712.4001)
,p_name=>'P4410_SUPPORTED_COMP_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5261005290655272.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SUPPORTED_COMPONENT_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(573060960895794186.4001)
,p_name=>'P4410_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(538625467201238345.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'JavaScript'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivos JavaScript para el c\00F3digo que se va a cargar en este plugin. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code>')
||unistr(' para incluir <code>.min</code>, o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a la cad')
||unistr('ena de sustituci\00F3n <code>#PLUGIN_FILES#</code> si desea sustituir el valor del prefijo de archivo del plugin.</p>'),
'',
unistr('<p>Las URL de archivo JavaScript que ha introducido aqu\00ED se emitir\00E1n en la cadena de sustituci\00F3n <code>#GENERATED_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre, solo la URL del archivo.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>#PLUGIN_FILES#main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de #PLUGIN_FILES#minified/ para vistas de p\00E1gina normales y main.js de #PLUGIN_FILES# en modo de depuraci\00F3n.'),
'      <pre>#PLUGIN_FILES##MIN_DIRECTORY#main#MIN#.js</pre>',
'  <li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca tambi\00E9n se utiliza desde una llamada obligatoria RequireJS. El nombre de definici\00F3n debe coincidir con lo que se utiliza en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global exp')
||'uesto por la biblioteca. Solo se aplica cuando se utiliza RequireJS. Esto evita que RequireJS cargue esa biblioteca por segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS, la configuraci\00F3n de Oracle JET RequireJS y el paquete de m\00F3dulo com\00FAn de JET antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(573061496548800093.4001)
,p_name=>'P4410_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(538625467201238345.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hoja de Estilo en Cascada'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar con este plugin. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#')
||unistr('</code> para incluir <code>.min</code>, o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a')
||unistr(' la cadena de sustituci\00F3n <code>#PLUGIN_FILES#</code> para sustituirla por el valor del prefijo del archivo de plugin.</p>'),
'',
unistr('<p>Las URL de archivo que introduzca aqu\00ED se emitir\00E1n en la cadena de sustituci\00F3n <code>#APEX_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre, solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>#PLUGIN_FILES#main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de #PLUGIN_FILES#minified/ para vistas de p\00E1ginas normales y main.css de #PLUGIN_FILES# en modo de depuraci\00F3n.'),
'      <pre>#PLUGIN_FILES##MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]#PLUGIN_FILES#smartphone.css</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(579718874159783420.4001)
,p_name=>'P4410_IS_LEGACY'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Heredada'
,p_source=>'IS_LEGACY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626801217275300456.4001)
,p_name=>'P4410_CATEGORY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(27899611028734555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Categor\00EDa')
,p_source=>'CATEGORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.CATEGORY'
,p_lov=>'.'||wwv_flow_api.id(626799404677287430.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Categor\00EDa -')
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica la categor\00EDa de la interfaz de usuario en la que aparecer\00E1 el plugin.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1587735358919175023.4001)
,p_name=>'P4410_META_DATA_FUNCTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Procedimiento de Metadatos'
,p_source=>'META_DATA_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que se va a llamar para obtener metadatos din\00E1micos acerca del plugin. Puede hacer referencia a un procedimiento de bloque de c\00F3digo PL/SQL an\00F3nimo, un procedimiento de paquete o un procedimiento aut\00F3n')
||'omo en la base de datos. Por ejemplo:',
'<pre>',
'meta_data_slider',
'</pre></p>',
'',
unistr('<p>Al hacer referencia a un procedimiento aut\00F3nomo o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>',
'#OWNER#.meta_data_slider',
'</pre></p>',
'',
'<p>Los procedimientos de metadatos de plugin de tipo de elemento deben implantar la siguiente interfaz:',
'',
'<pre>',
'procedure &lt;nombre del procedimiento> (',
'   p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_meta_data_param,',
'    p_result in out nocopy apex_plugin.t_item_meta_data_result )',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1587735477451175024.4001)
,p_name=>'P4410_API_VERSION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(27935931959010930.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'2'
,p_prompt=>'Interfaz de API'
,p_source=>'API_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Procedure;2,Function [deprecated];1'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si el plugin de tipo de elemento utiliza la FUNCI\00D3N en desuso seg\00FAn las API para realizar las devoluciones de llamada de plugin o si utiliza el nuevo PROCEDIMIENTO seg\00FAn las API. Nota: Para que un plugin de tipo de elemento soporte column')
||unistr('as de cuadr\00EDcula interactiva, debe implantar el PROCEDIMIENTO seg\00FAn las API.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(28060022823115846.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4410_IS_IN_USE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when wwv_flow_plugin_dev.is_in_use(:P4410_ID) then ''Y'' end'
,p_compute_when=>'P4410_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1580179561039736504.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4410_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper( :P4410_NAME )'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48633209198507489.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4410_REFERENCE_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>'P4410_REFERENCE_ID'
,p_compute_when_text=>'undefined'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(491906922347677938.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4410_VERSION_IDENTIFIER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1.0'
,p_compute_when=>':REQUEST = ''CREATE'' and :P4410_VERSION_IDENTIFIER is null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(492593632308392049.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4410_IS_QUICK_PICK'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_IS_QUICK_PICK'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(366989218243514982.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4410_IS_DEPRECATED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_IS_DEPRECATED'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(579718925674783421.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4410_IS_LEGACY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_IS_LEGACY'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(28102505057378500.4001)
,p_validation_name=>'check PL/SQL syntax'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql (',
'           p_sql               => ''declare''||chr(10)||:P4410_PLSQL_CODE||chr(10)||''begin null; end;'',',
'           p_flow_id           => :P4410_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P4410_CHECK_PLSQL_CODE, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(27905505067734569.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(27946303815296046.4001)
,p_validation_name=>'Still in use?'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_plugin_dev.is_in_use(:P4410_ID) = false'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'El plugin sigue en uso. Utilice el enlace Uso en Tareas para editar estas incidencias antes de suprimir el plugin.'
,p_when_button_pressed=>wwv_flow_api.id(27903106352734562.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(626801810480307940.4001)
,p_validation_name=>'P4410_CATEGORY is not null if Dynamic Action'
,p_validation_sequence=>30
,p_validation=>'P4410_CATEGORY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'DYNAMIC ACTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(626801217275300456.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(26600118045023669.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_validation_name=>'DISPLAY_NAME is not null'
,p_validation_sequence=>40
,p_validation=>'DISPLAY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# debe tener un valor.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'DISPLAY_NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(26600326356026125.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_validation_name=>'NAME is not null'
,p_validation_sequence=>50
,p_validation=>'NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# debe tener un valor.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(26600600645037559.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_validation_name=>'NAME don''t allow dots'
,p_validation_sequence=>60
,p_validation=>'NAME'
,p_validation2=>'.'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'#COLUMN_HEADER# no puede contener puntos.'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(439411826209419649.4001)
,p_name=>'Hide all except of SQL Attributes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439412121211419652.4001)
,p_event_id=>wwv_flow_api.id(439411826209419649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_CATEGORY,P4410_API_VERSION,P4410_RENDER_FUNCTION,P4410_META_DATA_FUNCTION,P4410_SESSION_SENTRY_FUNCTION,P4410_INVALID_SESSION_FUNCTION,P4410_AUTHENTICATION_FUNCTION,P4410_AJAX_FUNCTION,P4410_POST_LOGOUT_FUNCTION,P4410_VALIDATION_FUNCTION,P4410_'
||'EXECUTION_FUNCTION,P4410_RENDER_FUNCTION,P4410_ITEM_COMPONENT_TYPES,P4410_PROCESS_COMPONENT_TYPES,P4410_PAGE_ITEM_ATTRIBUTES,P4410_REGION_ATTRIBUTES,P4410_DYNAMIC_ACTION_ATTRIBUTES,P4410_AUTHENTICATION_ATTRIBUTES,P4410_PROCESS_ATTRIBUTES,P4410_WEB_SO'
||'URCE_ATTRIBUTES,P4410_WSM_CAPABILITIES,P4410_WSM_FETCH,P4410_WSM_DML,P4410_WSM_EXECUTE,P4410_WSM_DISCOVER'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(471131805144530744.4001)
,p_event_id=>wwv_flow_api.id(439411826209419649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483229712016058629.4001)
,p_event_id=>wwv_flow_api.id(439411826209419649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483229918595060541.4001)
,p_event_id=>wwv_flow_api.id(439411826209419649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(29873113508481210.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538625595312238346.4001)
,p_event_id=>wwv_flow_api.id(439411826209419649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(538625467201238345.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(47348904121291950.4001)
,p_name=>'Item Type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(47349412564303889.4001)
,p_event_id=>wwv_flow_api.id(47348904121291950.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_RENDER_FUNCTION,P4410_META_DATA_FUNCTION,P4410_AJAX_FUNCTION,P4410_VALIDATION_FUNCTION,P4410_ITEM_COMPONENT_TYPES,P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439450931515329471.4001)
,p_event_id=>wwv_flow_api.id(47348904121291950.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_PAGE_ITEM_ATTRIBUTES_01'').trigger(''change'');'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(471130828777518584.4001)
,p_event_id=>wwv_flow_api.id(47348904121291950.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483230128292063358.4001)
,p_event_id=>wwv_flow_api.id(47348904121291950.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483230301411065030.4001)
,p_event_id=>wwv_flow_api.id(47348904121291950.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(29873113508481210.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(538625603789238347.4001)
,p_event_id=>wwv_flow_api.id(47348904121291950.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(538625467201238345.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1587735535586175025.4001)
,p_name=>'Item Type - API Version'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P4410_ID is not null and :P4410_API_VERSION = 1'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1587735680553175026.4001)
,p_event_id=>wwv_flow_api.id(1587735535586175025.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_API_VERSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(439412221492427734.4001)
,p_name=>'Region Type'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439412503742427736.4001)
,p_event_id=>wwv_flow_api.id(439412221492427734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_RENDER_FUNCTION,P4410_AJAX_FUNCTION,P4410_REGION_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439451111906333254.4001)
,p_event_id=>wwv_flow_api.id(439412221492427734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_REGION_ATTRIBUTES'').trigger(''change'');'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(471131419212525328.4001)
,p_event_id=>wwv_flow_api.id(439412221492427734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483230510069067582.4001)
,p_event_id=>wwv_flow_api.id(439412221492427734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483230715610069113.4001)
,p_event_id=>wwv_flow_api.id(439412221492427734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(29873113508481210.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573414526671205502.4001)
,p_event_id=>wwv_flow_api.id(439412221492427734.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(538625467201238345.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(439412610195433998.4001)
,p_name=>'Dynamic Actions'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DYNAMIC ACTION'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439412923139433998.4001)
,p_event_id=>wwv_flow_api.id(439412610195433998.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_CATEGORY,P4410_RENDER_FUNCTION,P4410_AJAX_FUNCTION,P4410_DYNAMIC_ACTION_ATTRIBUTES'
,p_attribute_01=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439451326797337521.4001)
,p_event_id=>wwv_flow_api.id(439412610195433998.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_DYNAMIC_ACTION_ATTRIBUTES'').trigger(''change'');'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(618931207756408201.4001)
,p_event_id=>wwv_flow_api.id(439412610195433998.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483230922882071212.4001)
,p_event_id=>wwv_flow_api.id(439412610195433998.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483231128769072944.4001)
,p_event_id=>wwv_flow_api.id(439412610195433998.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(29873113508481210.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573414662208205503.4001)
,p_event_id=>wwv_flow_api.id(439412610195433998.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(538625467201238345.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(471055129080040003.4001)
,p_name=>'Process Type'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PROCESS TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(471055408404040010.4001)
,p_event_id=>wwv_flow_api.id(471055129080040003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_EXECUTION_FUNCTION,P4410_PROCESS_ATTRIBUTES,P4410_PROCESS_COMPONENT_TYPES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(375221322912099826.4001)
,p_event_id=>wwv_flow_api.id(471055129080040003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(29873113508481210.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(366691611531652666.4001)
,p_event_id=>wwv_flow_api.id(471055129080040003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(10801908044286535.4001)
,p_name=>'Authorization Type'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AUTHORIZATION TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(10802230415286539.4001)
,p_event_id=>wwv_flow_api.id(10801908044286535.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_EXECUTION_FUNCTION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(331962206691664754.4001)
,p_name=>'Authentication Type'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AUTHENTICATION TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(331962506669664758.4001)
,p_event_id=>wwv_flow_api.id(331962206691664754.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SESSION_SENTRY_FUNCTION,P4410_INVALID_SESSION_FUNCTION,P4410_AUTHENTICATION_FUNCTION,P4410_AJAX_FUNCTION,P4410_POST_LOGOUT_FUNCTION,P4410_AUTHENTICATION_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(331994601282672606.4001)
,p_event_id=>wwv_flow_api.id(331962206691664754.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(445176402174363503.4001)
,p_name=>'Enable/Disable Page Item Is Visible Checkboxes'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:VISIBLE:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(445176724561363507.4001)
,p_event_id=>wwv_flow_api.id(445176402174363503.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORM_ELEMENT],input[value=SESSION_STATE],input[value=QUICKPICK],input[value=ESCAPE_OUTPUT],input[value=READONLY],input[value=LOV]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').prop("disabled",false);'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(445176907219363511.4001)
,p_event_id=>wwv_flow_api.id(445176402174363503.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORM_ELEMENT],input[value=SESSION_STATE],input[value=QUICKPICK],input[value=ESCAPE_OUTPUT],input[value=READONLY],input[value=LOV]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').attr({"disabled":true, "checked":false});'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(445183512058479868.4001)
,p_name=>'Enable/Disable Page Item Source Checkboxes'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:SOURCE:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(445183802908479868.4001)
,p_event_id=>wwv_flow_api.id(445183512058479868.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORMAT_MASK_DATE],input[value=FORMAT_MASK_NUMBER],input[value=FILTER]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').prop("disabled",false);'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(445184023120479875.4001)
,p_event_id=>wwv_flow_api.id(445183512058479868.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORMAT_MASK_DATE],input[value=FORMAT_MASK_NUMBER],input[value=FILTER]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').attr({"disabled":true, "checked":false});'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(439437108210840247.4001)
,p_name=>'Enable/Disable Region Source Type Checkboxes'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_REGION_ATTRIBUTES'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439437431648840248.4001)
,p_event_id=>wwv_flow_api.id(439437108210840247.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lList         = $v(''P4410_REGION_ATTRIBUTES'').split('':''),',
'    lSourceTypes  = [''SOURCE_PLAIN'', ''SOURCE_HTML'', ''SOURCE_SQL'', ''SOURCE_PLSQL'', ''SOURCE_PLSQL_FUNCTION''],',
'    lSourceTypeIdx= (function() {',
'                        //',
'                        // return the index position of the selected source type',
'                        //',
'                        for (var i=0; i < lList.length; i++) {',
'                           var lIdx = lSourceTypes.indexOf(lList[i]);',
'                           if (lIdx >= 0) {',
'                               return lIdx;',
'                           }',
'                        }',
'                        return -1;',
'                     })();',
'    lShowRequired = false;',
'',
'if (lSourceTypeIdx >= 0) {',
'  //',
'  // disable every type but the selected source type',
'  // ',
'  for (var lIdx=0; lIdx < lSourceTypes.length; lIdx++) {',
'    if (lIdx !== lSourceTypeIdx) {',
'      apex.jQuery(''#P4410_REGION_ATTRIBUTES input[value=''+lSourceTypes[lIdx]+'']'').prop({"disabled":true,"checked":false});',
'    } ',
'  }',
'  //',
'  // disable AJAX_ITEMS_TO_SUBMIT if type is SOURCE_PLAIN or SOURCE_HTML',
'  //',
'  apex.jQuery(''#P4410_REGION_ATTRIBUTES input[value=AJAX_ITEMS_TO_SUBMIT]'').prop(',
'    ( $.inArray( lSourceTypes[lSourceTypeIdx], [ ''SOURCE_PLAIN'', ''SOURCE_HTML'' ]) !== -1 )',
'    ? {"disabled":true,"checked":false}',
'    : {"disabled":false});',
'  //',
'  // do show required',
'  //',
'  lShowRequired = true;',
'} else {',
'  //',
'  // no type selected -> enable all types',
'  //',
'  for (var lIdx=0; lIdx < lSourceTypes.length; lIdx++) {',
'    apex.jQuery(''#P4410_REGION_ATTRIBUTES input[value=''+lSourceTypes[lIdx]+'']'').prop({"disabled":false,"checked":false});',
'  }',
'}',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(366787330074911526.4001)
,p_name=>'Enable/Disable Process Type Checkboxes'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PROCESS_ATTRIBUTES'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(366787620564911791.4001)
,p_event_id=>wwv_flow_api.id(366787330074911526.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lList = $v( "P4410_PROCESS_ATTRIBUTES" ).split( ":" ),',
'    lRegionRequired$ = $( "#P4410_PROCESS_ATTRIBUTES input[value=REGION_REQUIRED]" );',
'',
'if ( $.inArray( "REGION", lList ) >= 0 ) {',
'    lRegionRequired$.prop( "disabled", false );',
'} else {',
'    lRegionRequired$.prop({ "disabled": true, "checked": false });',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(439413623579504041.4001)
,p_name=>'Show LOV Attributes'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:LOV:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439417003849573994.4001)
,p_event_id=>wwv_flow_api.id(439413623579504041.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_REQUIRED],#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_DISPLAY_NULL],#P4410_PAGE_ITEM_ATTRIBUTES input[value=CASCADING_LOV],#P4410_PAGE_ITEM_ATTRIBUTES input[value=JOIN_LOV]'').attr({"disabled":t'
||'rue, "checked":false});'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(439415101032544808.4001)
,p_event_id=>wwv_flow_api.id(439413623579504041.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_REQUIRED],#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_DISPLAY_NULL],#P4410_PAGE_ITEM_ATTRIBUTES input[value=CASCADING_LOV],#P4410_PAGE_ITEM_ATTRIBUTES input[value=JOIN_LOV]'').prop("disabled",fa'
||'lse);'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(17942703399432375.4001)
,p_name=>'Show/Hide Subscribe Component Settings'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_REFERENCE_ID'
,p_condition_element=>'P4410_REFERENCE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(17943012786432380.4001)
,p_event_id=>wwv_flow_api.id(17942703399432375.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SUBSCRIBE_PLUGIN_SETTINGS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(17943213430432381.4001)
,p_event_id=>wwv_flow_api.id(17942703399432375.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SUBSCRIBE_PLUGIN_SETTINGS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(30856001959545797.4001)
,p_name=>'Delete all Files'
,p_event_sequence=>150
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30855910247544017.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(30856509493545801.4001)
,p_event_id=>wwv_flow_api.id(30856001959545797.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir todos los archivos?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(30856304040545798.4001)
,p_event_id=>wwv_flow_api.id(30856001959545797.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FILES_DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1480713002888676910.4001)
,p_name=>'Has Region Columns'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_REGION_ATTRIBUTES'
,p_condition_element=>'P4410_REGION_ATTRIBUTES'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'SOURCE_LOCATION,SOURCE_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480713167678676911.4001)
,p_event_id=>wwv_flow_api.id(1480713002888676910.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P4410_REGION_ATTRIBUTES input[value=COLUMNS]'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480713201987676912.4001)
,p_event_id=>wwv_flow_api.id(1480713002888676910.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P4410_REGION_ATTRIBUTES input[value=COLUMNS]'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1480712302150676903.4001)
,p_name=>'Region Column Attributes'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_REGION_ATTRIBUTES'
,p_condition_element=>'P4410_REGION_ATTRIBUTES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COLUMNS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480712447587676904.4001)
,p_event_id=>wwv_flow_api.id(1480712302150676903.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'JAVASCRIPT_EXPRESSION'
,p_affected_elements=>'$( "#P4410_REGION_ATTRIBUTES" ).children( "input[value=COLUMN_HEADING],input[value=HEADING_ALIGNMENT],input[value^=VALUE_]" )'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480712890257676908.4001)
,p_event_id=>wwv_flow_api.id(1480712302150676903.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'JAVASCRIPT_EXPRESSION'
,p_affected_elements=>'$( "#P4410_REGION_ATTRIBUTES" ).children( "input[value=COLUMN_HEADING],input[value=HEADING_ALIGNMENT],input[value^=VALUE_]" )'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2210794207848925.4001)
,p_name=>'REST Data Source Type'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB SOURCE TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2211195111848929.4001)
,p_event_id=>wwv_flow_api.id(2210794207848925.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_WSM_CAPABILITIES,P4410_WSM_FETCH,P4410_WSM_DML,P4410_WSM_EXECUTE,P4410_WSM_DISCOVER,P4410_WEB_SOURCE_ATTRIBUTES'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1417160362635702.4001)
,p_event_id=>wwv_flow_api.id(2210794207848925.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(439386704233826730.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(439466610220411226.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P4410_STANDARD_ATTRIBUTES := case :P4410_PLUGIN_TYPE',
'                                    when ''ITEM TYPE''           then :P4410_PAGE_ITEM_ATTRIBUTES',
'                                    when ''REPORT COLUMN TYPE''  then :P4410_PAGE_ITEM_ATTRIBUTES',
'                                    when ''REGION TYPE''         then :P4410_REGION_ATTRIBUTES',
'                                    when ''WEB SOURCE TYPE''     then :P4410_WEB_SOURCE_ATTRIBUTES',
'                                    when ''PROCESS TYPE''        then :P4410_PROCESS_ATTRIBUTES',
'                                    when ''DYNAMIC ACTION''      then v(''P4410_DYNAMIC_ACTION_ATTRIBUTES'')',
'                                    when ''AUTHENTICATION TYPE'' then v(''P4410_AUTHENTICATION_ATTRIBUTES'')',
'                                  end;',
'',
'    if '':''||:P4410_STANDARD_ATTRIBUTES||'':'' not like ''%:LOV:%'' and',
'       '':''||:P4410_STANDARD_ATTRIBUTES||'':'' not like ''%:SOURCE_SQL:%''',
'    then',
'        :P4410_SQL_MIN_COLUMN_COUNT := null;',
'        :P4410_SQL_MAX_COLUMN_COUNT := null;',
'        :P4410_SQL_EXAMPLES         := null;',
'    end if;',
'    ',
'    :P4410_SUPPORTED_COMP_TYPES := case :P4410_PLUGIN_TYPE',
'                                     when ''ITEM TYPE''    then :P4410_ITEM_COMPONENT_TYPES',
'                                     when ''PROCESS TYPE'' then :P4410_PROCESS_COMPONENT_TYPES',
'                                   end;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(27908610123734606.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGINS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGINS'
,p_attribute_03=>'P4410_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'P4410_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(791008837851651124.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize additional standard attribute meta data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.synchronize_std_attributes (',
'        p_application_id => to_number(:FB_FLOW_ID),',
'        p_plugin_type    => :P4410_PLUGIN_TYPE,',
'        p_plugin_name    => :P4410_NAME);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'apply_changes:CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(24025130578997830.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize standard attribute values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.synchronize_attribute_columns (',
'        p_application_id => to_number(:FB_FLOW_ID),',
'        p_plugin_type    => :P4410_PLUGIN_TYPE,',
'        p_plugin_name    => :P4410_NAME,',
'        p_action         => ''PLUGIN'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(15066327223640442.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Plug-in Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.delete_plugin_settings (',
'        p_application_id => :P4410_FLOW_ID,',
'        p_plugin_type    => :P4410_PLUGIN_TYPE,',
'        p_plugin         => ''PLUGIN_'' || :P4410_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(27903106352734562.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(32730610240734651.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh plugin (with apply changes)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.subscribe_plugin (',
'    p_master_plugin_id      => :P4410_REFERENCE_ID,',
'    p_subscribing_plugin_id => :P4410_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar plugin.'
,p_process_when_button_id=>wwv_flow_api.id(27902501930734562.4001)
,p_process_when=>':P4410_REFERENCE_ID is not null and :P4410_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plugin refrescado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(32730421883728557.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh plugin (manual)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.subscribe_plugin (',
'    p_master_plugin_id      => :P4410_REFERENCE_ID,',
'    p_subscribing_plugin_id => :P4410_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al refrescar plugin.'
,p_process_when_button_id=>wwv_flow_api.id(32723606028376952.4001)
,p_process_when=>'P4410_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Plugin refrescado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48657524902692694.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_PLUGIN_EVENTS'
,p_attribute_03=>'ID'
,p_process_error_message=>unistr('No se ha podido procesar la actualizaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(27902501930734562.4001)
,p_process_success_message=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48657720971692694.4001)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(48655727964692661.4001)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'ApplyMRD'
,p_attribute_02=>'WWV_FLOW_PLUGIN_EVENTS'
,p_attribute_03=>'ID'
,p_process_error_message=>unistr('No se ha podido procesar la supresi\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(48656707021692689.4001)
,p_process_success_message=>'#MRD_COUNT# fila(s) suprimida(s).'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30856727586553252.4001)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete all files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_plugin_files',
'     where flow_id           = :P4410_FLOW_ID',
'       and plugin_id         = :P4410_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30855910247544017.4001)
,p_process_success_message=>'Archivos suprimidos'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30856901744555241.4001)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'PLUGIN_COM.ORACLE.APEX.DOWNLOAD_AS_ZIP'
,p_process_name=>'Download Files as Zip'
,p_attribute_01=>'plugin_files.zip'
,p_attribute_02=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name,',
'       file_content',
'  from wwv_flow_plugin_files',
' where flow_id           = :P4410_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(30855713266542663.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(27908232345734599.4001)
,p_process_sequence=>90
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGINS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGINS'
,p_attribute_03=>'P4410_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error al recuperar la fila.'
);
end;
/
prompt --application/pages/page_04411
begin
wwv_flow_api.create_page(
 p_id=>4411.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Atributo Est\00E1ndar de Plugin de Metadatos')
,p_step_title=>unistr('Editar Atributo Est\00E1ndar de Plugin de Metadatos')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4411_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885670354491824879.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885689667799324159.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Edite metadatos adicionales para los atributos est\00E1ndar de plugin. En funci\00F3n de estos datos, el dise\00F1ador de p\00E1ginas validar\00E1 los valores de atributos y mostrar\00E1n texto y ejemplos de ayuda.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885690376111326555.4001)
,p_plug_name=>'Ejemplos y Texto de Ayuda'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885693371964401096.4001)
,p_plug_name=>'Plugin: &P4411_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885699281370507840.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885709874827158803.4001)
,p_plug_name=>'Valor por Defecto'
,p_region_name=>'DEFAULT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>157
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(885751479252954694.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1008572563940076363.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1026674371687481642.4001)
,p_plug_name=>unistr('Condici\00F3n')
,p_region_name=>'TRIGGERING_EVENT_CONDITION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>179
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1098958249230563891.4001)
,p_plug_name=>'Soportado para'
,p_region_name=>'UI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>189
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(837273289146611816.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(885693371964401096.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(837274072985611818.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(885693371964401096.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>':P4411_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(837343803566611952.4001)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>149
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(791008994665651125.4001)
,p_name=>'P4411_DISPLAY_NAME_ITEM'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_prompt=>unistr('Atributo Est\00E1ndar')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ITEM_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(439387913761867364.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P4411_PLUGIN_TYPE'
,p_display_when2=>'ITEM TYPE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique la etiqueta que se muestra para ese atributo en el creador Application Express.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(791009042670651126.4001)
,p_name=>'P4411_PLUGIN_TYPE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(791009195646651127.4001)
,p_name=>'P4411_DISPLAY_NAME_REGION'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_prompt=>unistr('Atributo Est\00E1ndar')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.REGION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(439394121736945367.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P4411_PLUGIN_TYPE'
,p_display_when2=>'REGION TYPE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique la etiqueta que se muestra para ese atributo en el creador Application Express.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(791009234426651128.4001)
,p_name=>'P4411_DISPLAY_NAME_DYNACT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_prompt=>unistr('Atributo Est\00E1ndar')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_api.id(439399613733990280.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P4411_PLUGIN_TYPE'
,p_display_when2=>'DYNAMIC ACTION'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique la etiqueta que se muestra para ese atributo en el creador Application Express.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(791009891502651134.4001)
,p_name=>'P4411_DEPENDING_ON_HAS_TO_EXIST'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(1026674371687481642.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Evaluar Siempre'
,p_source=>'DEPENDING_ON_HAS_TO_EXIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se define en <strong>Activado</strong>, siempre se evaluar\00E1 la condici\00F3n y, como requisito, siempre se tendr\00E1 que representar el atributo del que depende. Si se define en <strong>Desactivado</strong>, la condici\00F3n tambi\00E9n se eval\00FAa cuando se ha')
||unistr('ya representado el atributo del que depende. Aun as\00ED, si el atributo del que depende NO se ha representado, la condici\00F3n no se eval\00FAa.</p>'),
'',
unistr('<p>Esto puede resultar \00FAtil si, por ejemplo, el atributo del que depende posee una condici\00F3n (por ejemplo, solo soporta determinados tipos de componentes) y si desea que el atributo actual se represente en el caso de que su condici\00F3n falle.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837264113304611792.4001)
,p_name=>'P4411_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837264402593611800.4001)
,p_name=>'P4411_IS_IN_USE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837265250046611801.4001)
,p_name=>'P4411_PLUGIN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plugin Id'
,p_source=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837265664654611801.4001)
,p_name=>'P4411_FLOW_ID'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837268702458611807.4001)
,p_name=>'P4411_NAME'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(885670354491824879.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Especifique la etiqueta que se muestra para ese atributo en el creador Application Express.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837271178916611814.4001)
,p_name=>'P4411_HELP_TEXT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(885690376111326555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Especifique el texto de ayuda para este atributo de plugin. El texto de ayuda se muestra como ayuda sensible al contexto para el atributo en el creador.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837272079297611815.4001)
,p_name=>'P4411_EXAMPLES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(885690376111326555.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ejemplos'
,p_source=>'EXAMPLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Especifique ejemplos para este atributo de plugin. Los ejemplos se muestran como parte de la ayuda sensible al contexto para el atributo en el creador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837276019325611820.4001)
,p_name=>'P4411_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(885693371964401096.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  from wwv_flow_plugins',
' where id = :P4411_PLUGIN_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Plugins seleccionados.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837281586765611836.4001)
,p_name=>'P4411_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(885699281370507840.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Necesario'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique si este atributo debe contener un valor.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837285105475611841.4001)
,p_name=>'P4411_SQL_MIN_COLUMN_COUNT'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(885699281370507840.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00EDnimo de Columnas')
,p_source=>'SQL_MIN_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_display_when=>'P4411_NAME'
,p_display_when2=>'SOURCE_PLSQL_FUNCTION:SOURCE_SQL:LOV:SOURCE_PLSQL'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero m\00EDnimo de columnas que tiene que seleccionar la consulta SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837286061813611842.4001)
,p_name=>'P4411_SQL_MAX_COLUMN_COUNT'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_api.id(885699281370507840.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E1ximo de Columnas')
,p_source=>'SQL_MAX_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_display_when=>'P4411_NAME'
,p_display_when2=>'SOURCE_PLSQL_FUNCTION:SOURCE_SQL:LOV:SOURCE_PLSQL'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero m\00E1ximo de columnas que puede seleccionar la consulta SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837292118883611851.4001)
,p_name=>'P4411_DEFAULT_VALUE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(885709874827158803.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor por Defecto'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique un valor por defecto para este atributo de plugin. El valor por defecto se utiliza cuando se crea un nuevo componente que utiliza este plugin.</p>',
'<p>',
unistr('Utilice Y y N para los atributos de tipo "S\00ED/No".'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837293390646611852.4001)
,p_name=>'P4411_ATTRIBUTE_COMMENT'
,p_item_sequence=>131
,p_item_plug_id=>wwv_flow_api.id(885751479252954694.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'ATTRIBUTE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecer\00E1n nunca cuando se est\00E9 ejecutando la aplicaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837297569655611861.4001)
,p_name=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(1026674371687481642.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Depende de'
,p_source=>'DEPENDING_ON_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt,',
'       id',
'  from wwv_flow_plugin_attributes ca',
' where plugin_id       = to_number(:P4411_PLUGIN_ID)',
'   and attribute_scope = ''COMPONENT'' ',
' order by attribute_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Dependiente -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el atributo del que depende el atributo actual. Por ejemplo, muestre \00FAnicamente el atributo actual si "Orientaci\00F3n" es igual a "VERTICAL".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837298436974611865.4001)
,p_name=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(1026674371687481642.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'DEPENDING_ON_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.CONDITION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(189411726584965751.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n que se debe cumplir para que represente este atributo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837299328301611869.4001)
,p_name=>'P4411_DEPENDING_ON_EXPRESSION'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(1026674371687481642.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n')
,p_source=>'DEPENDING_ON_EXPRESSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los valores de este atributo en funci\00F3n del tipo de condici\00F3n espec\00EDfica seleccionada. Si ha seleccionado "en lista" o "no en lista", introduzca los valores separados por una coma. No agregue un espacio en blanco antes o despu\00E9s de la coma')
||unistr(' si ese espacio no est\00E1 incluido en el valor que desea comparar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837301894706611872.4001)
,p_name=>'P4411_SUPPORTED_COMP_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1098958249230563891.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SUPPORTED_COMPONENT_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837303146154611873.4001)
,p_name=>'P4411_SUPPORTED_UI_TYPES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1098958249230563891.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Interfaz de Usuario'
,p_source=>'SUPPORTED_UI_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'UI TYPES (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name',
'  from wwv_flow_ui_types_dev',
' order by 1'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica las interfaces de usuario para las que se mostrar\00E1 el atributo de plugin en el creador. Si no se define ninguna interfaz de usuario, se mostrar\00E1 siempre.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(837306319081611902.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(837306770271611902.4001)
,p_computation_sequence=>80
,p_computation_item=>'P4411_DEPENDING_ON_EXPRESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_compute_when_text=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(791009349206651129.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4411_DISPLAY_NAME_ITEM'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4411_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(791009453432651130.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4411_DISPLAY_NAME_REGION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4411_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(791009555092651131.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4411_DISPLAY_NAME_DYNACT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4411_NAME'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(837312359249611911.4001)
,p_validation_name=>'P4411_DEPENDING_ON_CONDITION_TYPE not null'
,p_validation_sequence=>240
,p_validation=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(837298436974611865.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(837312796893611912.4001)
,p_validation_name=>'P4411_DEPENDING_ON_EXPRESSION not null'
,p_validation_sequence=>250
,p_validation=>'P4411_DEPENDING_ON_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_validation_condition2=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(837299328301611869.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(837334909933611940.4001)
,p_name=>'Condition'
,p_event_sequence=>175
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_condition_element=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837336922911611941.4001)
,p_event_id=>wwv_flow_api.id(837334909933611940.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(845305462628934503.4001)
,p_event_id=>wwv_flow_api.id(837334909933611940.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837335498081611941.4001)
,p_event_id=>wwv_flow_api.id(837334909933611940.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837336415830611941.4001)
,p_event_id=>wwv_flow_api.id(837334909933611940.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837335904226611941.4001)
,p_event_id=>wwv_flow_api.id(837334909933611940.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_CONDITION_TYPE,P4411_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(845305310758934502.4001)
,p_event_id=>wwv_flow_api.id(837334909933611940.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(837337399890611942.4001)
,p_name=>'Condition Type'
,p_event_sequence=>185
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_condition_element=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'EQUALS,NOT_EQUALS,IN_LIST,NOT_IN_LIST'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837337858168611942.4001)
,p_event_id=>wwv_flow_api.id(837337399890611942.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837338340207611942.4001)
,p_event_id=>wwv_flow_api.id(837337399890611942.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(837314230198611913.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_STD_ATTRIBUTES'
,p_attribute_03=>'P4411_ID'
,p_attribute_04=>'ID'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(837313833612611913.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P4411_IS_IN_USE'
,p_process_sql_clob=>':P4411_IS_IN_USE := case when wwv_flow_plugin_dev.is_in_use(:P4411_PLUGIN_ID) then ''Y'' end;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4411_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(837314609240611914.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_STD_ATTRIBUTES'
,p_attribute_03=>'P4411_ID'
,p_attribute_04=>'ID'
,p_attribute_09=>'P4411_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_PLUGIN_ATTRIBUTES.'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04415
begin
wwv_flow_api.create_page(
 p_id=>4415.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Atributo de Plugin'
,p_step_title=>'Editar Atributo de Plugin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48406905308213111.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48426218615712391.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Un atributo de plugin se utiliza para solicitar al desarrollador m\00E1s datos en el generador cuando se usa el plugin.</p>')
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48426926927714787.4001)
,p_plug_name=>'Ejemplos y Texto de Ayuda'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48429922780789328.4001)
,p_plug_name=>'Plugin: &P4415_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48435832186896072.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48446425643547035.4001)
,p_plug_name=>'Valor por Defecto'
,p_region_name=>'DEFAULT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>157
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48488030069342926.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(171309114756464595.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(184705009472204046.4001)
,p_name=>unistr('Lista de Valores Est\00E1tica')
,p_region_name=>'STATIC_LOV'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>155
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_sequence,',
'       display_value,',
'       return_value,',
'       id',
'  from wwv_flow_plugin_attr_values',
' where plugin_attribute_id = to_number(:P4415_ID)',
'   and security_group_id   = to_number(:WORKSPACE_ID)',
' order by display_sequence, display_value'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No se han definido valores.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(184705316368204050.4001)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(184705413106204050.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Mostrar'
,p_column_link=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_4416'',set:{''P4415_ATTRIBUTE_VALUE_ID'':''#ID#''}});'
,p_column_linktext=>'#DISPLAY_VALUE#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(184705516154204051.4001)
,p_query_column_id=>3
,p_column_alias=>'RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Devolver'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(184706703632230704.4001)
,p_query_column_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(189410922503869874.4001)
,p_plug_name=>unistr('Condici\00F3n')
,p_region_name=>'TRIGGERING_EVENT_CONDITION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>179
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261694800046952123.4001)
,p_plug_name=>'Soportado para'
,p_region_name=>'UI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>189
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(361914528060159138.4001)
,p_plug_name=>'Lista de Valores de Componente'
,p_region_name=>'COMPONENT_LOV'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'WORKSPACE_ID'
,p_plug_display_when_cond2=>'10'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184715709275364731.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(184705009472204046.4001)
,p_button_name=>'ADD_VALUE_CREATE_MODE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Valor'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''INSERT''});'
,p_button_condition=>':P4415_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(186269904054873930.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(184705009472204046.4001)
,p_button_name=>'ADD_VALUE_UPDATE_MODE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Agregar Valor'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''APPLY_CHANGES_CREATE_4416''});'
,p_button_condition=>':P4415_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48407527404213125.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48407317470213118.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>':P4415_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48407222371213118.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>':P4415_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48407120986213118.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>':P4415_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48415410595256026.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>':P4415_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48451130677610984.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48451017903610984.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184834804613527132.4001)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:4416:P4416_ID:&P4415_ATTRIBUTE_VALUE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4416'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184835319850531488.4001)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:4416:P4416_PLUGIN_ATTRIBUTE_ID:&P4415_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''INSERT'', ''APPLY_CHANGES_CREATE_4416'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48415825963269832.4001)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:4415:P4415_PLUGIN_ID:&P4415_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48415410595256026.4001)
,p_branch_sequence=>51
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48453932471611004.4001)
,p_branch_name=>'Go To Page 4415'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.::P4415_ID:&P4415_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48451130677610984.4001)
,p_branch_sequence=>54
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48453713720611003.4001)
,p_branch_name=>'Go To Page 4415'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.::P4415_ID:&P4415_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(48451017903610984.4001)
,p_branch_sequence=>55
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48427804332727252.4001)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>61
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4415_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(48408107125213133.4001)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>149
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24177601344122901.4001)
,p_name=>'P4415_COLUMN_DATA_TYPES'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipos de Dato'
,p_source=>'COLUMN_DATA_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.ATTRIBUTE.COLUMN_DATA_TYPES'
,p_lov=>'.'||wwv_flow_api.id(24174232595113027.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifica los tipos de dato de los que tiene que estar formada la columna seleccionada. Si se ha seleccionado el tipo de dato "Varchar2", la columna puede ser de cualquier tipo de dato excepto del tipo "Blob" y "Bfile", ya que todos estos tipos de d'
||unistr('ato se pueden convertir a "Varchar2". Si no se ha seleccionado ning\00FAn tipo de dato, la columna seleccionada puede ser de cualquier tipo de dato.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48408318304213142.4001)
,p_name=>'P4415_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48408508921213164.4001)
,p_name=>'P4415_PLUGIN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plugin Id'
,p_source=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48408925689213174.4001)
,p_name=>'P4415_ATTRIBUTE_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_next_sequence number;',
'begin',
'    select coalesce(max(attribute_sequence), 0)+1',
'      into l_next_sequence',
'      from wwv_flow_plugin_attributes',
'     where plugin_id       = to_number(:P4415_PLUGIN_ID)',
'       and attribute_scope = :P4415_ATTRIBUTE_SCOPE;',
'',
'    return l_next_sequence;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Atributo'
,p_source=>'ATTRIBUTE_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>2
,p_cHeight=>1
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Secuencia que est\00E1 correlacionada con las columnas de <code>ATTRIBUTE_XX</code> (por ejemplo, en <code>APEX_APPLICATION_PAGE_ITEMS</code>) y con los tipos PL/SQL definidos en el paquete <code>apex_plugin</code></p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48409303076213175.4001)
,p_name=>'P4415_PROMPT'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta'
,p_source=>'PROMPT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique la etiqueta que se muestra para ese atributo en el creador Application Express.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48409725092213176.4001)
,p_name=>'P4415_HELP_TEXT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(48426926927714787.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Especifique el texto de ayuda para este atributo de plugin. El texto de ayuda se muestra como ayuda sensible al contexto para el atributo en el creador.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48409929706213176.4001)
,p_name=>'P4415_ATTRIBUTE_TYPE'
,p_is_required=>true
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEXT'
,p_prompt=>'Tipo'
,p_source=>'ATTRIBUTE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.TYPE'
,p_lov=>'.'||wwv_flow_api.id(28057124498012298.4001)||'.'
,p_cHeight=>1
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el tipo que debe tener el atributo cuando se muestra en el creador de &PRODUCT_NAME. El tipo tambi\00E9n se utiliza para verificar los datos introducidos cuando el desarrollador los define o los modifica, y lo utiliza tambi\00E9n el asesor par')
||unistr('a comprobar la aplicaci\00F3n. Se soportan los siguientes tipos:'),
'<ul>',
unistr('<li><strong>Casillas de Control</strong>: Lista predefinida de casillas de control en la que el usuario puede realizar una selecci\00F3n. Los valores de todas las casillas de control activadas se almacenan como una cadena separada por dos puntos.</li>'),
unistr('<li><strong>Color</strong>: Para un c\00F3digo de color hexadecimal con soporte de selector de color en el dise\00F1ador de p\00E1ginas. Ejemplos: #FF0000, #000000</li>'),
unistr('<li><strong>HTML</strong>: Para los datos HTML con soporte de editor de c\00F3digos en el dise\00F1ador de p\00E1ginas. El valor almacenado tambi\00E9n se puede convertir.</li>'),
unistr('<li><strong>Icono</strong>: Para las clases CCS de icono con soporte de selector de icono en el dise\00F1ador de p\00E1ginas.</li>'),
unistr('<li><strong>Entero</strong>: N\00FAmero sin ning\00FAn componente decimal. Ejemplos: 15, -12</li>'),
unistr('<li><strong>JavaScript</strong>: Para c\00F3digo JavaScript con soporte de editor de c\00F3digos en el dise\00F1ador de p\00E1ginas.</li>'),
unistr('<li><strong>Enlace a URL/P\00E1gina de Destino</strong>: Para un enlace con soporte de creador de enlaces en el dise\00F1ador de p\00E1ginas.</li>'),
unistr('<li><strong>N\00FAmero</strong>: N\00FAmero con un componente decimal opcional. Ejemplos: 531.98, -363.55, 214</li>'),
unistr('<li><strong>C\00F3digo PL/SQL</strong>: Bloque de c\00F3digo PL/SQL an\00F3nimo. Ejemplo:<pre>begin'),
'    update emp set sal=sal*1.1;',
'end;</pre></li>',
unistr('<li><strong>Expresi\00F3n PL/SQL Que Devuelve BOOLEANO</strong>: C\00F3digo PL/SQL simple que devuelve TRUE o FALSE. Ejemplo:<pre>case when :P7_CATEGORY=''computer'' then true else false end</pre></li>'),
unistr('<li><strong>Expresi\00F3n PL/SQL Que Devuelve VARCHAR2</strong>: C\00F3digo PL/SQL simple que devuelve una cadena de resultados. Ejemplo:<pre>case when :P7_CATEGORY=''computer'' then ''Y'' else ''N'' end</pre></li>'),
unistr('<li><strong>Cuerpo de la Funci\00F3n PL/SQL Que Devuelve VALOR BOOLEANO</strong>: C\00F3digo PL/SQL avanzado que devuelve TRUE o FALSE. Ejemplo:<pre>declare'),
'    l_price number;',
'begin',
'    select product_price',
'      into l_price',
'      from demo_products',
'     where id = :P7_ID;',
'',
'    return case when calculate_new_price(l_price) > 1000 then true else false end;',
'end;</pre></li>',
unistr('<li><strong>Cuerpo de la Funci\00F3n PL/SQL que Devuelve VARCHAR2</strong>: C\00F3digo PL/SQL avanzado que devuelve una cadena de resultados. Ejemplo:<pre>declare'),
'    l_price number;',
'begin',
'    select product_price',
'      into l_price',
'      from demo_products',
'     where id = :P7_ID;',
'',
'    return calculate_new_price(l_price);',
'end;</pre></li>',
unistr('<li><strong>Elemento de P\00E1gina</strong>: Nombre de un elemento de p\00E1gina.</li>'),
unistr('<li><strong>Elementos de P\00E1gina</strong>: Lista de elementos de p\00E1gina delimitada por comas.</li>'),
unistr('<li><strong>N\00FAmero de P\00E1gina</strong>: Identifica una p\00E1gina en &PRODUCT_NAME..</li>'),
unistr('<li><strong>N\00FAmeros de P\00E1gina</strong>: Lista de p\00E1ginas delimitada por comas en &PRODUCT_NAME..</li>'),
unistr('<li><strong>Columna de Sentencia SQL de Regi\00F3n</strong>: Lista de columnas utilizadas en la sentencia SQL de regi\00F3n en la que el usuario puede realizar una selecci\00F3n. Este tipo de atributo solo est\00E1 disponible para los plugins Tipo de Regi\00F3n.</li>'),
unistr('<li><strong>Consulta SQL</strong>: Sentencia SQL con el n\00FAmero especificado de columnas en la sentencia.</li>'),
unistr('<li><strong>Lista de Selecci\00F3n</strong>: Lista de valores predefinida en la que el usuario puede realizar una selecci\00F3n.</li>'),
unistr('<li><strong>Texto</strong>: Para datos alfanum\00E9ricos. El valor almacenado tambi\00E9n se puede convertir.</li>'),
unistr('<li><strong>\00C1rea de Texto</strong>: Para datos alfanum\00E9ricos de varias l\00EDneas. El valor almacenado tambi\00E9n se puede convertir.</li>'),
unistr('<li><strong>XML</strong>: Para datos XML con soporte de editor de c\00F3digos en el dise\00F1ador de p\00E1ginas. El valor almacenado tambi\00E9n se puede convertir.</li>'),
'<li><s'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48410328970213177.4001)
,p_name=>'P4415_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Necesario'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique si este atributo debe contener un valor.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48410920133213178.4001)
,p_name=>'P4415_DEFAULT_VALUE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(48446425643547035.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor por Defecto'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique un valor por defecto para este atributo de plugin. El valor por defecto se utiliza cuando se crea un nuevo componente que utiliza este plugin.</p>',
'<p>',
unistr('Utilice Y y N para los atributos de tipo "S\00ED/No".'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48411131268213180.4001)
,p_name=>'P4415_DISPLAY_LENGTH'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ancho de Visualizaci\00F3n')
,p_source=>'DISPLAY_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique la longitud (en caracteres) que se mostrar\00E1 para este atributo en el creador de Application Express.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'9999'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48411323772213180.4001)
,p_name=>'P4415_MAX_LENGTH'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Longitud M\00E1xima')
,p_source=>'MAX_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el n\00FAmero m\00E1ximo de caracteres que los usuarios pueden introducir en este atributo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'99999'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48411901310213183.4001)
,p_name=>'P4415_ATTRIBUTE_SCOPE'
,p_is_required=>true
,p_item_sequence=>28
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'COMPONENT'
,p_prompt=>unistr('\00C1mbito')
,p_source=>'ATTRIBUTE_SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.SCOPE'
,p_lov=>'.'||wwv_flow_api.id(32688601172502165.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>15
,p_cHeight=>1
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('El \00E1mbito del atributo puede ser Aplicaci\00F3n o Componente. Si se define en Aplicaci\00F3n, el atributo s\00F3lo se puede definir una vez para la aplicaci\00F3n. Si se define en Componente, el atributo se puede definir cada vez que se hace referencia al plugin en ')
||'un componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48412325717213184.4001)
,p_name=>'P4415_SQL_MIN_COLUMN_COUNT'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00EDnimo de Columnas')
,p_source=>'SQL_MIN_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero m\00EDnimo de columnas que tiene que seleccionar la consulta SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48412508641213185.4001)
,p_name=>'P4415_SQL_MAX_COLUMN_COUNT'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('M\00E1ximo de Columnas')
,p_source=>'SQL_MAX_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('N\00FAmero m\00E1ximo de columnas que puede seleccionar la consulta SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48412708248213186.4001)
,p_name=>'P4415_IS_TRANSLATABLE'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Traducible'
,p_source=>'IS_TRANSLATABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si este atributo se incluye o no en el archivo de traducci\00F3n de XLIFF.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48426502736712403.4001)
,p_name=>'P4415_RETURN_TO_PAGE'
,p_item_sequence=>910
,p_item_plug_id=>wwv_flow_api.id(48426218615712391.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48433504997850407.4001)
,p_name=>'P4415_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  from wwv_flow_plugins',
' where id = :P4415_PLUGIN_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Plugins seleccionados.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48452709508610987.4001)
,p_name=>'P4415_ID_NEXT'
,p_item_sequence=>920
,p_item_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_prompt=>'P4415_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48452905290610993.4001)
,p_name=>'P4415_ID_PREV'
,p_item_sequence=>930
,p_item_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_prompt=>'P4415_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48453124751610999.4001)
,p_name=>'P4415_ID_COUNT'
,p_item_sequence=>940
,p_item_plug_id=>wwv_flow_api.id(48429922780789328.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48488324692343018.4001)
,p_name=>'P4415_ATTRIBUTE_COMMENT'
,p_item_sequence=>131
,p_item_plug_id=>wwv_flow_api.id(48488030069342926.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'ATTRIBUTE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecer\00E1n nunca cuando se est\00E9 ejecutando la aplicaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48608823932224997.4001)
,p_name=>'P4415_IS_IN_USE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(179294009802986782.4001)
,p_name=>'P4415_FLOW_ID'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184840503059564465.4001)
,p_name=>'P4415_ATTRIBUTE_VALUE_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attribute Value Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189411104013869899.4001)
,p_name=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(189410922503869874.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'DEPENDING_ON_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.CONDITION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(189411726584965751.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n que se debe cumplir para que represente este atributo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189411326157869917.4001)
,p_name=>'P4415_DEPENDING_ON_EXPRESSION'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(189410922503869874.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n')
,p_source=>'DEPENDING_ON_EXPRESSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca los valores de este atributo en funci\00F3n del tipo de condici\00F3n espec\00EDfica seleccionada. Si ha seleccionado "en lista" o "no en lista", introduzca los valores separados por una coma. No agregue un espacio en blanco antes o despu\00E9s de la coma')
||unistr(' si ese espacio no est\00E1 incluido en el valor que desea comparar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189417128063022926.4001)
,p_name=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(189410922503869874.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Depende de'
,p_source=>'DEPENDING_ON_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt,',
'       id',
'  from wwv_flow_plugin_attributes',
' where plugin_id       = to_number(:P4415_PLUGIN_ID)',
'   and attribute_scope = :P4415_ATTRIBUTE_SCOPE',
'   and id             <> nvl(to_number(:P4415_ID), -1)',
' order by attribute_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Dependiente -'
,p_lov_cascade_parent_items=>'P4415_ATTRIBUTE_SCOPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione el atributo del que depende el atributo actual. Por ejemplo, muestre \00FAnicamente el atributo actual si "Orientaci\00F3n" es igual a "VERTICAL".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261695022819952154.4001)
,p_name=>'P4415_SUPPORTED_UI_TYPES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(261694800046952123.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Interfaz de Usuario'
,p_source=>'SUPPORTED_UI_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'UI TYPES (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name',
'  from wwv_flow_ui_types_dev',
' order by 1'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica las interfaces de usuario para las que se mostrar\00E1 el atributo de plugin en el creador. Si no se define ninguna interfaz de usuario, se mostrar\00E1 siempre.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261696518877976860.4001)
,p_name=>'P4415_IS_COMMON'
,p_is_required=>true
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>unistr('Com\00FAn')
,p_source=>'IS_COMMON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si este atributo se debe mostrar siempre en el editor de propiedades del dise\00F1ador de p\00E1ginas o solo si se muestran atributos avanzados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361901122073943577.4001)
,p_name=>'P4415_TEXT_CASE'
,p_item_sequence=>175
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Definir May\00FAsculas/Min\00FAsculas de Texto')
,p_source=>'TEXT_CASE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_SET_TEXT_CASE'
,p_lov=>'.'||wwv_flow_api.id(361901313057946615.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Cambios'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>unistr('Especifique si el valor de atributo de plugin introducido se debe almacenar siempre en may\00FAscula o min\00FAscula.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361902914728962164.4001)
,p_name=>'P4415_NULL_TEXT'
,p_item_sequence=>205
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto Nulo de Lista de Valores'
,p_source=>'NULL_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el texto que se debe mostrar al principio de la lista. Este valor tambi\00E9n se muestra cuando el valor de atributo es nulo. Si no introduce ning\00FAn texto, se muestra como ''- Select -''.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361905701764998545.4001)
,p_name=>'P4415_LOV_TYPE'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'STATIC'
,p_prompt=>'Tipo de LOV'
,p_source=>'LOV_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_LOV_TYPE'
,p_lov=>'.'||wwv_flow_api.id(361905807263001770.4001)||'.'
,p_cHeight=>1
,p_read_only_when=>'WORKSPACE_ID'
,p_read_only_when2=>'10'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361907202171028717.4001)
,p_name=>'P4415_LOV_COMPONENT_TYPE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(361914528060159138.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Componente'
,p_source=>'LOV_COMPONENT_TYPE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace( lpad( '' '', ( level - 1 ) * 2 ), '' '', ''&nbsp;'' ) || wwv_flow_escape.html( wwv_flow_lang.system_message( singular_title )) as d,',
'       id',
'  from wwv_pe_component_types',
' start with parent_component_type_id is null',
'connect by prior id = parent_component_type_id',
'  order siblings by display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361907421987049969.4001)
,p_name=>'P4415_LOV_COMPONENT_TYPE_SCOPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(361914528060159138.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00C1mbito')
,p_source=>'LOV_COMPONENT_TYPE_SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_LOV_SCOPE'
,p_lov=>'.'||wwv_flow_api.id(361909922032072224.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Aplicaci\00F3n')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361908431895060539.4001)
,p_name=>'P4415_LOV_COMP_TYPE_ON_DELETE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(361914528060159138.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Al Suprimir Comportamiento'
,p_source=>'LOV_COMPONENT_TYPE_ON_DELETE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_LOV_ON_DELETE'
,p_lov=>'.'||wwv_flow_api.id(361908530213065178.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Emitir Error'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361911515708083243.4001)
,p_name=>'P4415_DEPRECATED_VALUES'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(189410922503869874.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Mostrar Atributo En desuso para los Valores'
,p_source=>'DEPRECATED_VALUES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_display_when=>'WORKSPACE_ID'
,p_display_when2=>'10'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362600600277420823.4001)
,p_name=>'P4415_PARENT_ATTRIBUTE_ID'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributo Principal'
,p_source=>'PARENT_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt,',
'       id',
'  from wwv_flow_plugin_attributes',
' where plugin_id      = to_number(:P4415_PLUGIN_ID)',
'   and id            <> nvl(to_number(:P4415_ID), -1)',
'   and attribute_type = case :P4415_ATTRIBUTE_TYPE',
'                          when ''TABLE''  then ''OWNER''',
'                          when ''COLUMN'' then ''TABLE''',
'                        end',
' order by attribute_sequence'))
,p_lov_cascade_parent_items=>'P4415_ATTRIBUTE_TYPE'
,p_ajax_items_to_submit=>'P4415_ID,P4415_PLUGIN_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451251527298039490.4001)
,p_name=>'P4415_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(48406905308213111.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>':P4415_ATTRIBUTE_SEQUENCE*10'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Secuencia de Visualizaci\00F3n')
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_cHeight=>1
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia de visualizaci\00F3n para este atributo de plugin en el creador de &PRODUCT_NAME.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492593772231392050.4001)
,p_name=>'P4415_EXAMPLES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48426926927714787.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ejemplos'
,p_source=>'EXAMPLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Especifique ejemplos para este atributo de plugin. Los ejemplos se muestran como parte de la ayuda sensible al contexto para el atributo en el creador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502499517782935713.4001)
,p_name=>'P4415_ITEM_COMPONENT_TYPES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(261694800046952123.4001)
,p_prompt=>'Tipo de Componente'
,p_source=>'P4415_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_ITEM_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_api.id(513667640463524657.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id          = :P4415_PLUGIN_ID',
'   and plugin_type = ''ITEM TYPE'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifica si se muestra el atributo de plugin en el generador para elementos de p\00E1gina y columnas de cuadr\00EDcula interactiva. Si no se define ning\00FAn tipo soportado, se mostrar\00E1 siempre.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502499655346935714.4001)
,p_name=>'P4415_SUPPORTED_COMP_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(261694800046952123.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'SUPPORTED_COMPONENT_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502499874499935716.4001)
,p_name=>'P4415_DEPEND_ON_HAS_TO_EXIST'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(189410922503869874.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Evaluar Siempre'
,p_source=>'DEPENDING_ON_HAS_TO_EXIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se define en <strong>Activado</strong>, siempre se evaluar\00E1 la condici\00F3n y, como requisito, siempre se tendr\00E1 que representar el atributo del que depende. Si se define en <strong>Desactivado</strong>, la condici\00F3n tambi\00E9n se eval\00FAa cuando se ha')
||unistr('ya representado el atributo del que depende. Aun as\00ED, si el atributo del que depende NO se ha representado, la condici\00F3n no se eval\00FAa.</p>'),
'',
unistr('<p>Esto puede resultar \00FAtil si, por ejemplo, el atributo del que depende posee una condici\00F3n (por ejemplo, solo soporta determinados tipos de componentes) y si desea que el atributo actual se represente en el caso de que su condici\00F3n falle.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(907492157679523347.4001)
,p_name=>'P4415_SHOW_IN_WIZARD'
,p_is_required=>true
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Mostrar en Asistente'
,p_source=>'SHOW_IN_WIZARD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si este atributo se debe mostrar en el asistente de creaci\00F3n si se crea un nuevo componente basado en el plugin actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1474235115866765843.4001)
,p_name=>'P4415_UNIT'
,p_item_sequence=>195
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Unidad'
,p_source=>'UNIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el texto que se va a mostrar como unidad (p. ej., p\00EDxeles) para el valor del atributo en el dise\00F1ador de p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1499432283349055529.4001)
,p_name=>'P4415_REFERENCE_SCOPE'
,p_is_required=>true
,p_item_sequence=>215
,p_item_plug_id=>wwv_flow_api.id(48435832186896072.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'COMPONENT'
,p_prompt=>'Incluir Columnas en Selector de Elementos'
,p_source=>'REFERENCE_SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id           = :P4415_PLUGIN_ID',
'   and plugin_type in ( ''REGION TYPE'', ''PROCESS TYPE'' )',
'   and instr (',
'           '':'' || standard_attributes || '':'',',
'           '':'' || case when plugin_type = ''REGION TYPE'' then ''SOURCE_SQL'' else ''REGION_REQUIRED'' end || '':''',
'       ) > 0'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique <strong>Activado</strong> si el selector de elementos del dise\00F1ador de p\00E1ginas tambi\00E9n debe incluir columnas de la regi\00F3n actual.</p>'),
'',
unistr('<p>Nota: para que esto funcione, debe realizar sustituciones manuales en su c\00F3digo de plugin y tambi\00E9n debe definir el indicador <em>Sustituir Valores de Atributo</em> del nivel de plugin en <strong>Desactivado</strong>. Consulte la ayuda de dicho at')
||unistr('ributo para obtener m\00E1s informaci\00F3n sobre c\00F3mo realizar sustituciones manuales.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'ROW'
,p_attribute_03=>'Yes'
,p_attribute_04=>'COMPONENT'
,p_attribute_05=>'No'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48618425494963471.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4415_DEFAULT_VALUE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NVL(:P4415_DEFAULT_VALUE, ''N'')'
,p_compute_when=>'P4415_ATTRIBUTE_TYPE'
,p_compute_when_text=>'CHECKBOX'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(189424813386359234.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(189425130486373640.4001)
,p_computation_sequence=>80
,p_computation_item=>'P4415_DEPENDING_ON_EXPRESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_compute_when_text=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(24183904264284602.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4415_COLUMN_DATA_TYPES'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>'P4415_ATTRIBUTE_TYPE'
,p_compute_when_text=>'REGION SOURCE COLUMN:COLUMN'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(361913323866125091.4001)
,p_computation_sequence=>100
,p_computation_item=>'P4415_LOV_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''SELECT LIST'', ''CHECKBOXES'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(362034932398032753.4001)
,p_computation_sequence=>110
,p_computation_item=>'P4415_TEXT_CASE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1499432325867055530.4001)
,p_computation_sequence=>120
,p_computation_item=>'P4415_REFERENCE_SCOPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'COMPONENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4415_ATTRIBUTE_TYPE not in ( ''LINK'', ''TEXT'', ''TEXTAREA'', ''PAGE ITEM'', ''PAGE ITEMS'', ''SQL'', ''HTML'', ''JAVASCRIPT'', ''XML'' )',
'and :P4415_ATTRIBUTE_TYPE not like ''PLSQL%'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1474235438551765846.4001)
,p_computation_sequence=>130
,p_computation_item=>'P4415_UNIT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''NUMBER'', ''INTEGER'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1474234888784765840.4001)
,p_computation_sequence=>140
,p_computation_item=>'P4415_IS_TRANSLATABLE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'', ''HTML'', ''XML'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1474234991152765841.4001)
,p_computation_sequence=>150
,p_computation_item=>'P4415_DISPLAY_LENGTH'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'', ''NUMBER'', ''INTEGER'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1474235093312765842.4001)
,p_computation_sequence=>160
,p_computation_item=>'P4415_MAX_LENGTH'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'', ''NUMBER'', ''INTEGER'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(362608418115488549.4001)
,p_computation_sequence=>170
,p_computation_item=>'P4415_PARENT_ATTRIBUTE_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>'P4415_ATTRIBUTE_TYPE'
,p_compute_when_text=>'TABLE:COLUMN'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(502499771942935715.4001)
,p_computation_sequence=>180
,p_computation_item=>'P4415_SUPPORTED_COMP_TYPES'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4415_ITEM_COMPONENT_TYPES'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13739400846552942.4001)
,p_validation_name=>'P4415_ATTRIBUTE_SEQUENCE max attribute check'
,p_validation_sequence=>210
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_plugin_type       wwv_flow_plugins.plugin_type%type;',
'    l_max_attribute_seq number;',
'begin',
'    select plugin_type',
'      into l_plugin_type',
'      from wwv_flow_plugins',
'     where id                = :P4415_PLUGIN_ID',
'       and flow_id           = :P4415_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    l_max_attribute_seq := wwv_flow_plugin_dev.get_max_custom_attributes (',
'                               p_plugin_type     => l_plugin_type,',
'                               p_attribute_scope => :P4415_ATTRIBUTE_SCOPE );',
'',
'    if to_number(:P4415_ATTRIBUTE_SEQUENCE) not between 1 and l_max_attribute_seq then',
'        return wwv_flow_lang.system_message(''APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'', 1, l_max_attribute_seq);',
'    end if;',
'',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'#LABEL# debe ser inferior a 15'
,p_associated_item=>wwv_flow_api.id(48408925689213174.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48466230220803781.4001)
,p_validation_name=>'P4415_DEFAULT_VALUE is not null when IS_REQUIRED'
,p_validation_sequence=>220
,p_validation=>'P4415_DEFAULT_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar un valor si el atributo es necesario y el tipo es "Lista de Selecci\00F3n" o "Casillas de Control".')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4415_ATTRIBUTE_TYPE in (''SELECT LIST'', ''CHECKBOXES'')',
'and :P4415_IS_REQUIRED = ''Y''',
'and :P4415_LOV_TYPE    = ''STATIC'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(48410920133213178.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48618605670976611.4001)
,p_validation_name=>'P4415_DEFAULT_VALUE for Checkbox'
,p_validation_sequence=>230
,p_validation=>':P4415_DEFAULT_VALUE IN (''Y'', ''N'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'El valor de una casilla de control debe ser S o N.'
,p_validation_condition=>'P4415_ATTRIBUTE_TYPE'
,p_validation_condition2=>'CHECKBOX'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(48410920133213178.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(189424216456331790.4001)
,p_validation_name=>'P4415_DEPENDING_ON_CONDITION_TYPE not null'
,p_validation_sequence=>240
,p_validation=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(189411104013869899.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(189424525245343796.4001)
,p_validation_name=>'P4415_DEPENDING_ON_EXPRESSION not null'
,p_validation_sequence=>250
,p_validation=>'P4415_DEPENDING_ON_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_validation_condition2=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(189411326157869917.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(362608628023499110.4001)
,p_validation_name=>'P4415_PARENT_ATTRIBUTE_ID not null'
,p_validation_sequence=>260
,p_validation=>'P4415_PARENT_ATTRIBUTE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4415_ATTRIBUTE_TYPE'
,p_validation_condition2=>'TABLE:COLUMN'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(362600600277420823.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(362036302421046663.4001)
,p_validation_name=>'P4415_DEPENDING_ON_CONDITION_TYPE is not null'
,p_validation_sequence=>270
,p_validation=>'P4415_LOV_COMPONENT_TYPE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar un valor.'
,p_validation_condition=>'P4415_LOV_TYPE'
,p_validation_condition2=>'COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(361907202171028717.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(48621123827142757.4001)
,p_validation_name=>'P4415_ATTRIBUTE_SEQUENCE unique'
,p_validation_sequence=>570
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes',
' where plugin_id          = :P4415_PLUGIN_ID',
'   and attribute_scope    = :P4415_ATTRIBUTE_SCOPE',
'   and attribute_sequence = :P4415_ATTRIBUTE_SEQUENCE',
'   and (  :P4415_ID is null',
'       or id <> :P4415_ID',
'       )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El atributo ya est\00E1 en uso para este \00E1mbito.')
,p_validation_condition=>'P4415_ATTRIBUTE_SEQUENCE'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_associated_item=>wwv_flow_api.id(48408925689213174.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48471419334989784.4001)
,p_name=>'Hide all'
,p_event_sequence=>0
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'This action will also hide the P4415_MAX_LENGTH and P4415_SQL_MAX_COLUMN_COUNT because they are in the same table row'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48471832279003073.4001)
,p_event_id=>wwv_flow_api.id(48471419334989784.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_LOV_TYPE,P4415_IS_TRANSLATABLE,P4415_DISPLAY_LENGTH,P4415_MAX_LENGTH,P4415_SQL_MIN_COLUMN_COUNT,P4415_SQL_MAX_COLUMN_COUNT,P4415_PARENT_ATTRIBUTE_ID,P4415_COLUMN_DATA_TYPES,P4415_TEXT_CASE,P4415_UNIT,P4415_NULL_TEXT,P4415_REFERENCE_SCOPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48473017781027212.4001)
,p_name=>'Type is Select List,Checkboxes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'SELECT LIST,CHECKBOXES'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48473430248030853.4001)
,p_event_id=>wwv_flow_api.id(48473017781027212.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_LOV_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(362050805940081043.4001)
,p_event_id=>wwv_flow_api.id(48473017781027212.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>11
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_LOV_TYPE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v( "P4415_LOV_TYPE" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Needed to trigger the dynamic action on LOV TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1480724267628735033.4001)
,p_name=>'Type is Select List'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SELECT LIST'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480724104603735032.4001)
,p_event_id=>wwv_flow_api.id(1480724267628735033.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_REQUIRED'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v( "P4415_IS_REQUIRED" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Needed to trigger the dynamic action on IS_REQUIRED'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48473601074041340.4001)
,p_name=>'Type is SQL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Will also show P4415_SQL_MAX_COLUMN_COUNT because they are in the same table row'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48474026700048672.4001)
,p_event_id=>wwv_flow_api.id(48473601074041340.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_SQL_MIN_COLUMN_COUNT,P4415_SQL_MAX_COLUMN_COUNT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48480115375177875.4001)
,p_name=>'Type is Text,Textarea,HTML,XML - Translatable'
,p_event_sequence=>45
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,TEXTAREA,HTML,XML'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48480526457181134.4001)
,p_event_id=>wwv_flow_api.id(48480115375177875.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_TRANSLATABLE,P4415_REFERENCE_SCOPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1474234694573765838.4001)
,p_name=>'Type is Text,Textarea - Text Case'
,p_event_sequence=>55
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,TEXTAREA'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1474234773227765839.4001)
,p_event_id=>wwv_flow_api.id(1474234694573765838.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_TEXT_CASE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48474217612065002.4001)
,p_name=>'Type is Text,Textarea,Number,Integer'
,p_event_sequence=>65
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,TEXTAREA,NUMBER,INTEGER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Will also show P4415_MAX_LENGTH, because they are in the same table row.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48474600774069632.4001)
,p_event_id=>wwv_flow_api.id(48474217612065002.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DISPLAY_LENGTH,P4415_MAX_LENGTH'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1474235247602765844.4001)
,p_name=>'Type is Text,Number,Integer - Unit'
,p_event_sequence=>75
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,NUMBER,INTEGER'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Will also show P4415_MAX_LENGTH, because they are in the same table row.'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1474235352771765845.4001)
,p_event_id=>wwv_flow_api.id(1474235247602765844.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_UNIT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48479325717152479.4001)
,p_name=>'Type is SQL,PLSQL,PLSQL Expression*,PLSQL Function Body*,JavaScript'
,p_event_sequence=>85
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'SQL,PLSQL,PLSQL EXPRESSION,PLSQL EXPRESSION BOOLEAN,PLSQL FUNCTION BODY,PLSQL FUNCTION BODY BOOLEAN,JAVASCRIPT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48479702992155394.4001)
,p_event_id=>wwv_flow_api.id(48479325717152479.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_TRANSLATABLE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(837441566044841426.4001)
,p_event_id=>wwv_flow_api.id(48479325717152479.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>11
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_REFERENCE_SCOPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48617531119946167.4001)
,p_name=>'Type is Yes/No'
,p_event_sequence=>95
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CHECKBOX'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48617914973950978.4001)
,p_event_id=>wwv_flow_api.id(48617531119946167.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_REQUIRED'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48618221207952775.4001)
,p_event_id=>wwv_flow_api.id(48617531119946167.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_REQUIRED'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(24178727363158746.4001)
,p_name=>'Type is Region Source Column'
,p_event_sequence=>105
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION SOURCE COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(24179001137158750.4001)
,p_event_id=>wwv_flow_api.id(24178727363158746.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_COLUMN_DATA_TYPES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(362604428648452136.4001)
,p_name=>'Type is Table'
,p_event_sequence=>115
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(362604701612452136.4001)
,p_event_id=>wwv_flow_api.id(362604428648452136.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_PARENT_ATTRIBUTE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(362602816873448719.4001)
,p_name=>'Type is Column'
,p_event_sequence=>125
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COLUMN'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(362603110252448742.4001)
,p_event_id=>wwv_flow_api.id(362602816873448719.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_PARENT_ATTRIBUTE_ID,P4415_COLUMN_DATA_TYPES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1499432466760055531.4001)
,p_name=>'Type is Page Item(s),Link'
,p_event_sequence=>135
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'PAGE ITEM,PAGE ITEMS,LINK'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1499432571726055532.4001)
,p_event_id=>wwv_flow_api.id(1499432466760055531.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_REFERENCE_SCOPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(361916804904180878.4001)
,p_name=>'Lov Type - Hide Regions'
,p_event_sequence=>145
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_LOV_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(361917101944180879.4001)
,p_event_id=>wwv_flow_api.id(361916804904180878.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(361914528060159138.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(361981505496711010.4001)
,p_event_id=>wwv_flow_api.id(361916804904180878.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(184705009472204046.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(362000330652822309.4001)
,p_name=>'Lov Type = STATIC'
,p_event_sequence=>155
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_LOV_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(   $.inArray( $v( "P4415_ATTRIBUTE_TYPE" ), [ "SELECT LIST", "CHECKBOXES" ]) >= 0',
'&& $v( "P4415_LOV_TYPE" ) === "STATIC" )'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(361981309162709233.4001)
,p_event_id=>wwv_flow_api.id(362000330652822309.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(184705009472204046.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(361998325326811272.4001)
,p_name=>'Lov Type = COMPONENT'
,p_event_sequence=>165
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_LOV_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(   $v( "P4415_ATTRIBUTE_TYPE" ) === "SELECT LIST"',
' && $v( "P4415_LOV_TYPE" ) === "COMPONENT"',
')'))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(361917318523180879.4001)
,p_event_id=>wwv_flow_api.id(361998325326811272.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(361914528060159138.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(189417804261072808.4001)
,p_name=>'Condition'
,p_event_sequence=>175
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_condition_element=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(502499922503935717.4001)
,p_event_id=>wwv_flow_api.id(189417804261072808.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(502500073031935718.4001)
,p_event_id=>wwv_flow_api.id(189417804261072808.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(189418125190072818.4001)
,p_event_id=>wwv_flow_api.id(189417804261072808.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(189418324512072821.4001)
,p_event_id=>wwv_flow_api.id(189417804261072808.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_CONDITION_TYPE,P4415_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(189418608894083622.4001)
,p_name=>'Condition Type'
,p_event_sequence=>185
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_condition_element=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'EQUALS,NOT_EQUALS,IN_LIST,NOT_IN_LIST'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(189418901899083624.4001)
,p_event_id=>wwv_flow_api.id(189418608894083622.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(189419116866083625.4001)
,p_event_id=>wwv_flow_api.id(189418608894083622.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(48635511669536590.4001)
,p_name=>'Default ATTRIBUTE_SCOPE'
,p_event_sequence=>195
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_SCOPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(48635911453545942.4001)
,p_event_id=>wwv_flow_api.id(48635511669536590.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ATTRIBUTE_SEQUENCE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce(max(attribute_sequence), 0)+1 as next_attribute_sequence',
'  from wwv_flow_plugin_attributes',
' where plugin_id       = to_number(:P4415_PLUGIN_ID)',
'   and attribute_scope = :P4415_ATTRIBUTE_SCOPE'))
,p_attribute_07=>'P4415_PLUGIN_ID,P4415_ATTRIBUTE_SCOPE'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(451258919080093934.4001)
,p_name=>'Default Display Sequence'
,p_event_sequence=>205
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_SEQUENCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(451259208102093936.4001)
,p_event_id=>wwv_flow_api.id(451258919080093934.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DISPLAY_SEQUENCE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P4415_ATTRIBUTE_SEQUENCE'')*10'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397304208637519828.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>215
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4415_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397304531723519830.4001)
,p_event_id=>wwv_flow_api.id(397304208637519828.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(48451130677610984.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397304614178521429.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>225
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4415_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397304904527521430.4001)
,p_event_id=>wwv_flow_api.id(397304614178521429.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(48451017903610984.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(361980408863692925.4001)
,p_name=>'Null Text'
,p_event_sequence=>235
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_IS_REQUIRED'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v( "P4415_IS_REQUIRED" ) === "N" && $v( "P4415_ATTRIBUTE_TYPE" ) === "SELECT LIST"'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(361980705585692926.4001)
,p_event_id=>wwv_flow_api.id(361980408863692925.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_NULL_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(361980906569692926.4001)
,p_event_id=>wwv_flow_api.id(361980408863692925.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_NULL_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48413203431213188.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_03=>'P4415_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48453528653611000.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_03=>'P4415_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'ATTRIBUTE_SCOPE'
,p_attribute_08=>'ATTRIBUTE_SEQUENCE'
,p_attribute_09=>'P4415_ID_NEXT'
,p_attribute_10=>'P4415_ID_PREV'
,p_attribute_13=>'P4415_ID_COUNT'
,p_attribute_14=>'plugin_id = :P4415_PLUGIN_ID'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(17172608303187792.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P4415_IS_IN_USE'
,p_process_sql_clob=>':P4415_IS_IN_USE := case when wwv_flow_plugin_dev.is_in_use(:P4415_PLUGIN_ID) then ''Y'' end;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4415_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(361912018962099809.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P4415_LOV_TYPE = ''STATIC'' or :P4415_LOV_TYPE is null then',
'        :P4415_LOV_COMPONENT_TYPE_ID    := null;',
'        :P4415_LOV_COMPONENT_TYPE_SCOPE := null;',
'        :P4415_LOV_COMP_TYPE_ON_DELETE  := null;',
'    end if;',
'',
'    if :P4415_LOV_TYPE = ''COMPONENT'' or :P4415_LOV_TYPE is null then',
'        delete from wwv_flow_plugin_attr_values',
'         where plugin_attribute_id = :P4415_ID',
'           and security_group_id   = :WORKSPACE_ID;',
'    end if;',
'',
'    if :P4415_LOV_TYPE is null then',
'        :P4415_NULL_TEXT := null;',
'    end if;',
'',
'    if v( ''P4415_DEPENDING_ON_ATTRIBUTE_ID'' ) is null then',
'        :P4415_DEPEND_ON_HAS_TO_EXIST := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48413404729213191.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_03=>'P4415_ID'
,p_attribute_04=>'ID'
,p_attribute_09=>'P4415_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'No se ha podido procesar la fila de la tabla WWV_FLOW_PLUGIN_ATTRIBUTES.'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48608501983209265.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize attribute values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_plugin in',
'      ( select flow_id,',
'               plugin_type,',
'               name',
'          from wwv_flow_plugins',
'         where id = to_number(:P4415_PLUGIN_ID) )',
'    loop',
'        wwv_flow_plugin_dev.synchronize_attribute_columns (',
'            p_application_id => l_plugin.flow_id,',
'            p_plugin_type    => l_plugin.plugin_type,',
'            p_plugin_name    => l_plugin.name,',
'            p_action         => ''ATTRIBUTES'' );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48413623569213191.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'4415'
,p_process_when_button_id=>wwv_flow_api.id(48407317470213118.4001)
);
null;
end;
/
prompt --application/pages/page_04416
begin
wwv_flow_api.create_page(
 p_id=>4416.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Valor de Atributo de Plugin'
,p_step_title=>'Editar Valor de Atributo de Plugin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes a,',
'       wwv_flow_plugins p',
' where a.id                = :P4416_PLUGIN_ATTRIBUTE_ID',
'   and a.security_group_id = :WORKSPACE_ID',
'   and p.id                = a.plugin_id',
'   and reference_id        is not null'))
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184653017765027772.4001)
,p_plug_name=>'Entrada'
,p_region_name=>'ENTRY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 13-JUN-2000 11:36:34'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184658130596027795.4001)
,p_plug_name=>'Atributo: &P4416_PLUGIN_ATTRIBUTE_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184661911544027806.4001)
,p_plug_name=>'Valor del Atributo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Edite valores de visualizaci\00F3n y de retorno para una entrada de valor de atributo.</p>')
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'R:L:L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(690213795029382242.4001)
,p_plug_name=>'Anclaje'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184658518831027797.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184659114740027798.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4416_ID                  is not null',
'and nvl(:P4416_IS_IN_USE, ''N'') = ''N''',
'and not wwv_flow_region.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184658327013027796.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>':P4416_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184658723225027797.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>':P4416_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184658927484027797.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Crear y Crear Otro'
,p_button_position=>'NEXT'
,p_button_condition=>':P4416_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184659512726027798.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184659331693027798.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184665626629027936.4001)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.::P4416_ID:&P4416_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(184659331693027798.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184665802053027938.4001)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.::P4416_ID:&P4416_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(184659512726027798.4001)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184666028053027938.4001)
,p_branch_name=>'Go To Page 4416'
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4416_RETURN_TO_PAGE = ''YES'' and upper(:request) != ''DELETE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184722216772433152.4001)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:4416:P4416_PLUGIN_ATTRIBUTE_ID:&P4416_PLUGIN_ATTRIBUTE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(184658927484027797.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(184666430682027939.4001)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184653222746027780.4001)
,p_name=>'P4416_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184653630382027783.4001)
,p_name=>'P4416_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_next_sequence number;',
'begin',
'    select coalesce(max(display_sequence), 0)+10',
'      into l_next_sequence',
'      from wwv_flow_plugin_attr_values',
'     where plugin_attribute_id = to_number(:P4416_PLUGIN_ATTRIBUTE_ID);',
'',
'    return l_next_sequence;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Secuencia'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Especifique la secuencia de este valor. La secuencia determina el orden en el que se muestran los valores.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184654218916027785.4001)
,p_name=>'P4416_DISPLAY_VALUE'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor de Visualizaci\00F3n')
,p_source=>'DISPLAY_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Este texto se muestra para el usuario. Se devuelve el valor de retorno.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184654800785027786.4001)
,p_name=>'P4416_RETURN_VALUE'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor de Retorno'
,p_source=>'RETURN_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_read_only_when=>'P4416_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el valor de retorno para esta entrada de lista de selecci\00F3n. El valor de retorno se almacena en la columna atribute_xx.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184659715969027799.4001)
,p_name=>'P4416_ID_NEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_prompt=>'P4416_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184659919751027800.4001)
,p_name=>'P4416_ID_PREV'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_prompt=>'P4416_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184660128721027800.4001)
,p_name=>'P4416_ID_COUNT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(57731626458856526.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifica el valor del atributo de plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184662127656027898.4001)
,p_name=>'P4416_RETURN_TO_PAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(184661911544027806.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184721501058419139.4001)
,p_name=>'P4416_FLOW_ID'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184727714357508187.4001)
,p_name=>'P4416_PLUGIN_ATTRIBUTE_NAME'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(184658130596027795.4001)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt',
'  from wwv_flow_plugin_attributes',
' where id = to_number(:P4416_PLUGIN_ATTRIBUTE_ID)'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Atributo actual.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184801318559237892.4001)
,p_name=>'P4416_PLUGIN_ATTRIBUTE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'PLUGIN_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(366993328761570859.4001)
,p_name=>'P4416_IS_DEPRECATED'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'En desuso'
,p_source=>'IS_DEPRECATED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517780551564724701.4001)
,p_name=>'P4416_IS_QUICK_PICK'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Lista de Valores'
,p_source=>'IS_QUICK_PICK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si el valor se debe mostrar como opci\00F3n de selecci\00F3n r\00E1pida en el dise\00F1ador de p\00E1ginas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(517780621466724702.4001)
,p_name=>'P4416_HELP_TEXT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique el texto de ayuda para este valor. El texto de ayuda del valor se muestra como parte de la ayuda sensible al contexto para el atributo en el creador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(782866828622960460.4001)
,p_name=>'P4416_IS_IN_USE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(184653017765027772.4001)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(366993521213574351.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4416_IS_DEPRECATED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4416_IS_DEPRECATED'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397306015479540740.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4416_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397306328730540740.4001)
,p_event_id=>wwv_flow_api.id(397306015479540740.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(184659512726027798.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397306421020542400.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4416_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397306701534542401.4001)
,p_event_id=>wwv_flow_api.id(397306421020542400.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(184659331693027798.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184665024225027932.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_03=>'P4416_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184665223103027934.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_03=>'P4416_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'DISPLAY_SEQUENCE'
,p_attribute_08=>'DISPLAY_VALUE'
,p_attribute_09=>'P4416_ID_NEXT'
,p_attribute_10=>'P4416_ID_PREV'
,p_attribute_13=>'P4416_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and plugin_attribute_id = :P4416_PLUGIN_ATTRIBUTE_ID'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(783000913880116947.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set is-in-use'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_plugin_id number;',
'begin',
'    if :P4416_ID is null then',
'        :P4416_IS_IN_USE := ''N'';',
'    else',
'        select plugin_id',
'          into l_plugin_id',
'          from wwv_flow_plugin_attributes',
'         where id = :P4416_PLUGIN_ATTRIBUTE_ID;',
'',
'        :P4416_IS_IN_USE := case when wwv_flow_plugin_dev.is_in_use(l_plugin_id) then ''Y'' end;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(184665418260027934.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_03=>'P4416_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04420
begin
wwv_flow_api.create_page(
 p_id=>4420.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso de Plugin'
,p_step_title=>unistr('Utilizaci\00F3n de Plugin')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27854530209326914.4001)
,p_plug_name=>unistr('Utilizaci\00F3n de Plugin')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra los elementos de p\00E1gina y las regiones que se representar\00E1n utilizando el plugin seleccionado de la aplicaci\00F3n actual.</p>'),
'',
unistr('<p>Para editar elementos de p\00E1gina o regiones, seleccione el nombre del elemento o la regi\00F3n.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(27858112567431339.4001)
,p_plug_name=>unistr('Utilizaci\00F3n de Plugin')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       object_type,',
'       coalesce (',
'           object_url,',
'           ''f?p=4000:4500:''||:APP_SESSION||''::NO:1:FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:''||app_id||'',''||page_id||'',''||app_id||'',''||page_id||''#''||component_type||'':''||component_id',
'           ) as object_url,',
'       object_name,',
'       page_id,',
'       page_name,',
'       region_title',
'  from (',
'        select /* APEX 4000P4420a */ p.display_name            as display_name,',
'               wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') as object_type,',
'               to_char(null)                                   as object_url,',
'               i.name                                          as object_name,',
'               5120                                            as component_type,',
'               i.id                                            as component_id,',
'               i.flow_id                                       as app_id,',
'               i.flow_step_id                                  as page_id,',
'               pg.name                                         as page_name,',
'               r.plug_name                                     as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_step_items i,',
'               wwv_flow_steps      pg,',
'               wwv_flow_page_plugs r',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''ITEM TYPE''',
'           and i.flow_id           = p.flow_id',
'           and i.display_as        = ''PLUGIN_''||p.name',
'           and pg.flow_id          = i.flow_id',
'           and pg.id               = i.flow_step_id',
'           and r.id (+)            = i.item_plug_id',
'        union all',
'        select p.display_name                                      as display_name,',
'               wwv_flow_lang.system_message(''F4000.REPORT_COLUMN'') as object_type,',
'               to_char(null)                                       as object_url,',
'               c.name                                              as object_name,',
'               7940                                                as component_type,',
'               c.id                                                as component_id,',
'               c.flow_id                                           as app_id,',
'               pg.id                                               as page_id,',
'               pg.name                                             as page_name,',
'               r.plug_name                                         as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_region_columns c,',
'               wwv_flow_page_plugs r,',
'               wwv_flow_steps      pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''ITEM TYPE''',
'           and c.flow_id           = p.flow_id',
'           and c.item_type         = ''PLUGIN_''||p.name',
'           and r.id                = c.region_id',
'           and pg.flow_id          = r.flow_id',
'           and pg.id               = r.page_id',
'        union all',
'        select p.display_name                               as display_name,',
'               wwv_flow_lang.system_message(''F4000.REGION'') as object_type,',
'               to_char(null)                                as object_url,',
'               r.plug_name                                  as object_name,',
'               5110                                         as component_type,',
'               r.id                                         as component_id,',
'               r.flow_id                                    as app_id,',
'               r.page_id                                    as page_id,',
'               pg.name                                      as page_name,',
'               null                                         as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_page_plugs r,',
'               wwv_flow_steps      pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''REGION TYPE''',
'           and r.flow_id           = p.flow_id',
'           and r.plug_source_type  = ''PLUGIN_''||p.name',
'           and pg.flow_id          = r.flow_id',
'           and pg.id               = r.page_id',
'        union all',
'        select p.display_name                                       as display_name,',
'               wwv_flow_lang.system_message(''F4000.DYNAMIC ACTION'') as object_type,',
'               to_char(null)                                        as object_url,',
'               e.name                                               as object_name,',
'               5150                                                 as component_type,',
'               a.id                                                 as component_id,',
'               a.flow_id                                            as app_id,',
'               e.page_id                                            as page_id,',
'               pg.name                                              as page_name,',
'               null                                                 as region_title',
'          from wwv_flow_plugins         p,',
'               wwv_flow_page_da_events  e,',
'               wwv_flow_page_da_actions a,',
'               wwv_flow_steps           pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''DYNAMIC ACTION''',
'           and e.flow_id           = p.flow_id',
'           and a.event_id          = e.id',
'           and a.action            = ''PLUGIN_''||p.name',
'           and pg.flow_id          = e.flow_id',
'           and pg.id               = e.page_id',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''PAGE PROCESS'')  as object_type,',
'               to_char(null)                                 as object_url,',
'               pr.process_name                               as object_name,',
'               5530                                          as component_type,',
'               pr.id                                         as component_id,',
'               pr.flow_id                                    as app_id,',
'               pr.flow_step_id                               as page_id,',
'               pg.name                                       as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_step_processing pr,',
'               wwv_flow_steps      pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and pr.flow_id          = p.flow_id',
'           and pr.process_type     = ''PLUGIN_''||p.name',
'           and pg.flow_id          = pr.flow_id',
'           and pg.id               = pr.flow_step_id',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''APPLICACTION_PROCESS'') as object_type,',
'               ''f?p=4000:4309:''||:APP_SESSION||''::NO:RP,4309:''||''F4000_P4309_ID,FB_FLOW_ID:''||pr.id||'',''||pr.flow_id as object_url,',
'               pr.process_name                               as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               pr.flow_id                                    as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_processing pr',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and pr.flow_id          = p.flow_id',
'           and pr.process_type     = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''SECURITY_SCHEME'') as object_type,',
'               ''f?p=4000:4008:''||:APP_SESSION||''::NO:RP,4008:''||''F4000_P4008_ID,FB_FLOW_ID:''||s.id||'',''||s.flow_id as object_url,',
'               s.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               s.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_security_schemes s',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''AUTHORIZATION TYPE''',
'           and s.flow_id           = p.flow_id',
'           and s.scheme_type       = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''AUTHENTICATION SCHEME'') as object_type,',
'               ''f?p=4000:4495:''||:APP_SESSION||''::NO:RP,4495:''||''P4495_ID,FB_FLOW_ID:''||a.id||'',''||a.flow_id as object_url,',
'               a.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               a.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_authentications a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''AUTHENTICATION TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.scheme_type       = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''F4000.WEB_SOURCE'') as object_type,',
'               ''f?p=4000:1921:''||:APP_SESSION||''::NO:RP,1921:''||''P1921_WEB_SRC_MODULE_ID,FB_FLOW_ID:''||a.id||'',''||a.flow_id as object_url,',
'               a.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               a.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins         p,',
'               wwv_flow_web_src_modules a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''WEB SOURCE TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.web_source_type   = ''PLUGIN_''||p.name',
'    )',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(27858227168431340.4001)
,p_name=>'xxx'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'PATRICK'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27863717183464545.4001)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(33458616286623587.4001)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>2
,p_column_identifier=>'J'
,p_column_label=>'Nombre del Componente'
,p_column_link=>'#OBJECT_URL#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(33458409566623582.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>3
,p_column_identifier=>'H'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27858730043431347.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27858805774431347.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(27858902448431347.4001)
,p_db_column_name=>'REGION_TITLE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(33460724289665621.4001)
,p_db_column_name=>'OBJECT_URL'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'URL de Componente'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188994928073089183.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(188993730020080349.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188995107426092721.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(27858112567431339.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:4420,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27855510704326916.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4420:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_04445
begin
wwv_flow_api.create_page(
 p_id=>4445.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Valores de Componente'
,p_step_title=>'Valores por Defecto de Componente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14886004355621915.4001)
,p_plug_name=>unistr('Informe de Configuraci\00F3n de Componentes')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       p.display_name,',
'       s.plugin_type,',
'       s.last_updated_on,',
'       s.last_updated_by,',
'       --',
'       ''icon-sc-component-settings''                as icon_class,',
'       p.display_name                              as icon_title,',
'       apex_util.prepare_url(''f?p=4000:4446:''||:app_session||''::NO:4446:P4446_ID:''||s.id) as edit_link',
'  from wwv_flow_plugin_settings s,',
'       ( select plugin_type,',
'                name_with_prefix as plugin,',
'                display_name',
'           from wwv_flow_native_plugins',
'          union all',
'         select plugin_type,',
'                ''PLUGIN_'' || name as plugin,',
'                display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as display_name',
'           from wwv_flow_plugins',
'          where flow_id = to_number(:FB_FLOW_ID)',
'            and security_group_id = to_number(:WORKSPACE_ID)',
'       ) p',
' where s.flow_id           = :FB_FLOW_ID',
'   and s.security_group_id = :flow_security_group_id',
'   and p.plugin_type       = s.plugin_type',
'   and p.plugin            = s.plugin'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(14886206368621919.4001)
,p_name=>'Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('Ning\00FAn plugin encontrado.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14886330425621923.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14892402487772202.4001)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>2
,p_column_identifier=>'M'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4446:&SESSION.::&DEBUG.:4446:P4446_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14891621215654597.4001)
,p_db_column_name=>'PLUGIN_TYPE'
,p_display_order=>4
,p_column_identifier=>'K'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(32850007287563326)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14891727994654598.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>5
,p_column_identifier=>'L'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14886604074621927.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'E'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14887014071621927.4001)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Editar Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656766879368365174.4001)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>19
,p_column_identifier=>'N'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(656766960710365174.4001)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14887816467621931.4001)
,p_plug_name=>'Valores de Componente'
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice la configuraci\00F3n de componentes para definir los valores de nivel de aplicaci\00F3n para los componentes de &PRODUCT_NAME. incorporados y los plugins instalados.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-component-settings.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''), ''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14889427929621935.4001)
,p_plug_name=>'navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(14972101971160040.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14888615562621933.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(14886004355621915.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:4445,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_04446
begin
wwv_flow_api.create_page(
 p_id=>4446.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Valores de Componente'
,p_step_title=>'Valores por Defecto de Componente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where :P4446_PLUGIN             like ''PLUGIN\_%'' escape ''\''',
'   and flow_id                   = :P4446_FLOW_ID',
'   and plugin_type               = :P4446_PLUGIN_TYPE',
'   and name                      = substr(:P4446_PLUGIN, 8) /* remove PLUGIN_ */',
'   and reference_id              is not null',
'   and subscribe_plugin_settings = ''Y''',
'   and security_group_id         = :WORKSPACE_ID'))
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14898706748797192.4001)
,p_plug_name=>'Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14905826791797203.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PLUGIN_SETTINGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Utilice la configuraci\00F3n de componentes para definir los valores de nivel de aplicaci\00F3n para los componentes de &PRODUCT_NAME. incorporados y los plugins instalados.</p>')
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
unistr('// ocultar los atributos din\00E1micos inmediatamente despu\00E9s de su presentaci\00F3n, '),
'// jQuery.ready puede tardar demasiado tiempo. ',
'apex.builder.dynamicAttributes.hide(''P4446_'');',
'</script>'))
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14913024434797214.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_type_value        => :P4446_PLUGIN,',
'        p_page_item_prefix  => ''P4446_'',',
'        p_user_interface_id => null,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14922127573797230.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PLUGIN_SETTINGS',
'where id = :P4446_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P4446_ID,',
'      p_component_type => ''Plugin Settings'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1059809137210457628.4001)
,p_plug_name=>'Valores de Componente'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14899112152797192.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(14898706748797192.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14898924648797192.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(14898706748797192.4001)
,p_button_name=>'apply_changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(14952320934834332.4001)
,p_branch_action=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(14898924648797192.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14894129215797177.4001)
,p_name=>'P4446_ID'
,p_data_type=>'NUMBER'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14894329466797178.4001)
,p_name=>'P4446_PLUGIN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_prompt=>'Nombre:'
,p_source=>'PLUGIN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name_with_prefix as plugin',
'  from wwv_flow_native_plugins',
' where plugin_type = :P4446_PLUGIN_TYPE',
' union all',
'select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as display_name,',
'       ''PLUGIN_'' || name as plugin',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and plugin_type       = :P4446_PLUGIN_TYPE',
'   and security_group_id = to_number(:WORKSPACE_ID)'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Nombre del plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14895526113797182.4001)
,p_name=>'P4446_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14895711239797182.4001)
,p_name=>'P4446_PLUGIN_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'PLUGIN_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>'Define el tipo de componente que puede utilizar este plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14906019221797206.4001)
,p_name=>'P4446_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14906216730797207.4001)
,p_name=>'P4446_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14906411672797207.4001)
,p_name=>'P4446_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14906622795797207.4001)
,p_name=>'P4446_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14906806961797207.4001)
,p_name=>'P4446_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14907511436797208.4001)
,p_name=>'P4446_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14907706020797208.4001)
,p_name=>'P4446_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14907919092797208.4001)
,p_name=>'P4446_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14908104024797208.4001)
,p_name=>'P4446_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14908314605797209.4001)
,p_name=>'P4446_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14908503879797209.4001)
,p_name=>'P4446_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14908704195797209.4001)
,p_name=>'P4446_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14908918167797209.4001)
,p_name=>'P4446_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14909118039797209.4001)
,p_name=>'P4446_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14909317130797209.4001)
,p_name=>'P4446_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_item_source_plug_id=>wwv_flow_api.id(14905826791797203.4001)
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(14924401663797237.4001)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :P4446_FLOW_ID,',
'        p_page_id           => null,',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_plugin_name       => :P4446_PLUGIN,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application,',
'        p_page_item_prefix  => ''P4446_'',',
'        p_user_interface_id => null );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203928983585288821.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :P4446_FLOW_ID,',
'        p_page_id           => null,',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_plugin_name       => :P4446_PLUGIN,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application,',
'        p_page_item_prefix  => ''P4446_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(361064779276469332.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(14905826791797203.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Settings'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Se ha cambiado la configuraci\00F3n de componente.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(361062219812469307.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(14905826791797203.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Component Settings'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203929078611288822.4001)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id    => :P4446_FLOW_ID,',
'        p_page_id           => null,',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_plugin_name       => :P4446_PLUGIN,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04447
begin
wwv_flow_api.create_page(
 p_id=>4447.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de Configuraci\00F3n de Componente')
,p_step_title=>'Historial de Valores por Defecto de Componente'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14969311395141286.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(14972101971160040.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14969527739141287.4001)
,p_plug_name=>unistr('Historial de Configuraci\00F3n de Componente')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en la configuraci\00F3n de componente de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''), ''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14970101127141289.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_user as developer, ',
'       audit_date,',
'       audit_action as action,',
'       scn,',
'       audit_comment,',
'       flow_table_pk as component_key,',
'       object_name   as component_name',
'  from wwv_flow_builder_audit_trail',
' where flow_ID           = :FB_FLOW_ID',
'   and flow_table        = ''WWV_FLOW_PLUGIN_SETTINGS''',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(14970325211141289.4001)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14970926660141290.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>9
,p_column_identifier=>'R'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14971032570141290.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>10
,p_column_identifier=>'S'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(192763415498955359)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14970723623141289.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>11
,p_column_identifier=>'N'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14970620866141289.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14970814404141290.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>13
,p_column_identifier=>'Q'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14970411115141289.4001)
,p_db_column_name=>'SCN'
,p_display_order=>14
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(14970525590141289.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>15
,p_column_identifier=>'J'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(14969921499141287.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(14970101127141289.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4447:&SESSION.::&DEBUG.:4447,RIR::'
);
end;
/
prompt --application/pages/page_04450
begin
wwv_flow_api.create_page(
 p_id=>4450.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Instalar Plugin'
,p_step_title=>'Instalar Plugin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30496813883469143.4001)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(37899301707472090.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30497027132469156.4001)
,p_plug_name=>'Instalar Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cuando se instala un plugin en la aplicaci\00F3n actual, el nuevo plugin sobrescribe los existentes que tengan el mismo nombre. Si la instalaci\00F3n es correcta, el plugin se instala de forma permanente. Si surgen errores, se realiza un rollback de las a')
||'cciones, y no se registran cambios permanentes.</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30497613484469157.4001)
,p_plug_name=>unistr('Archivo de Plugin no V\00E1lido')
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('El archivo no es un archivo de exportaci\00F3n de plugin de &PRODUCT_NAME. v\00E1lido.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198921711591824186.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149800997138181.4001)
,p_plug_name=>'Instalar Plugin'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30498322998469231.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(198921711591824186.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30498724327469233.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(198921711591824186.4001)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Instalar Plugin'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30503532021469247.4001)
,p_branch_action=>'f?p=&APP_ID.:4446:&SESSION.::&DEBUG.:RP,4446:P4446_ID:&P4450_PLUGIN_SETTINGS_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''INSTALL'', ''REPLACE'') and :P4450_PLUGIN_SETTINGS_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(15061504573548776.4001)
,p_branch_action=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30503923791469248.4001)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30498322998469231.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30504110237469248.4001)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:PLUGIN:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(30498724327469233.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:P4450_NEW_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = :P4450_PLUGIN_TYPE',
'   and name              = :P4450_NAME'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(15034323919525891.4001)
,p_name=>'P4450_PLUGIN_SETTINGS_ID'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30498920995469234.4001)
,p_name=>'P4450_ACTION'
,p_item_sequence=>118
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Acci\00F3n:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- does the plugin already exist?',
'    for c1 in (',
'        select 1 dummy',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:P4450_NEW_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = :P4450_PLUGIN_TYPE',
'           and name              = :P4450_NAME )',
'    loop',
'        return wwv_flow_lang.system_message(''F4000.P4450.ACTION_REPLACE'', :P4450_NEW_FLOW_ID);',
'    end loop;',
'',
'    -- doesn''t exist yet',
'    return wwv_flow_lang.system_message(''F4000.P4450.ACTION_CREATE'', :P4450_NEW_FLOW_ID);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Acci\00F3n que se realiza al pulsar el bot\00F3n "Instalar Plugin".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30499429719469237.4001)
,p_name=>'P4450_NAME'
,p_item_sequence=>112
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre Interno:'
,p_source=>'wwv_flow_imp_parser.get_plugin_name(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nombre interno que hace referencia al plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30499925768469238.4001)
,p_name=>'P4450_FILE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30500113807469238.4001)
,p_name=>'P4450_IMP_VERSION'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Versi\00F3n de Archivo de Exportaci\00F3n:')
,p_source=>'wwv_flow_imp_parser.get_version(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la versi\00F3n del archivo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30500623799469239.4001)
,p_name=>'P4450_NEW_FLOW_ID'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Instalar en Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Puede instalar el plugin en la misma aplicaci\00F3n de origen o en una aplicaci\00F3n diferente en el espacio de trabajo. Deje el identificador de aplicaci\00F3n como est\00E1 o seleccione otro.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30520028289737590.4001)
,p_name=>'P4450_DISPLAY_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'wwv_flow_imp_parser.get_plugin_display_name(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nombre del plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30559014501263350.4001)
,p_name=>'P4450_PLUGIN_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(30497027132469156.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name:'
,p_source=>'wwv_flow_imp_parser.get_plugin_type(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Nombre del plugin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30502907671469245.4001)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El archivo no es un archivo de exportaci\00F3n de temas de &PRODUCT_NAME. v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(30498724327469233.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(30503130205469245.4001)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p4450_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de la aplicaci\00F3n.)')
,p_when_button_pressed=>wwv_flow_api.id(30498724327469233.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30503204642469245.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_owner wwv_flows.owner%type;',
'begin',
'    select owner',
'      into l_owner',
'      from wwv_flows',
'     where id                = to_number(:P4450_NEW_FLOW_ID)',
'       and security_group_id = to_number(:WORKSPACE_ID);',
'',
'    wwv_flow_imp_parser.parse (',
'        p_file_id          => :P4450_FILE_ID,',
'        p_parse_as_schema  => l_owner,',
'        p_install_as_flow  => :P4450_NEW_FLOW_ID,',
'        p_original_flow_id => null,',
'        p_adjust_offset    => true );',
'',
'    -- after import we have to synchronize existing references of this plugin',
'    wwv_flow_plugin_dev.synchronize_attribute_columns (',
'        p_application_id => :FB_FLOW_ID,',
'        p_plugin_type    => :P4450_PLUGIN_TYPE,',
'        p_plugin_name    => :P4450_NAME );',
'',
'    -- get imported plugin id to redirect to the new plugin',
'    :FB_FLOW_ID := :P4450_NEW_FLOW_ID;',
'',
'    -- try to get the plug-in setting ID if the plug-in contains custom attributes of scope "Application"',
'    select min(id)',
'      into :P4450_PLUGIN_SETTINGS_ID',
'      from wwv_flow_plugin_settings',
'     where flow_id           = to_number(:FB_FLOW_ID)',
'       and plugin_type       = :P4450_PLUGIN_TYPE',
'       and plugin            = ''PLUGIN_'' || :P4450_NAME',
'       and security_group_id = to_number(:WORKSPACE_ID);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al instalar plugin.'
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Plugin instalado.'
);
end;
/
prompt --application/pages/page_04460
begin
wwv_flow_api.create_page(
 p_id=>4460.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Exportar Plugin'
,p_step_title=>'Exportar Plugin'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_plugins.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30467118077262612.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30467517871262613.4001)
,p_plug_name=>'Exportar Plugin'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NUMERIC'
,p_plug_display_when_condition=>'P4460_A'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30467903423262613.4001)
,p_plug_name=>'Exportar Plugin'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Utilice esta p\00E1gina para exportar una definici\00F3n de plugin a un archivo. Una vez exportado un plugin, puede importarse a cualquier aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168865206468961273.4001)
,p_plug_name=>'Exportar Plugin'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486290602680795598.4001)
,p_plug_name=>unistr('Elegir Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(30468611840262614.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168865206468961273.4001)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486290330815784758.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168865206468961273.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:4460::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30468809262262615.4001)
,p_name=>'P4460_A'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(486290602680795598.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST EXPORTABLE FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30469301789262618.4001)
,p_name=>'P4460_PLUGIN_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30467517871262613.4001)
,p_prompt=>'Plugin'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       id           as r',
'  from wwv_flow_plugins',
' where flow_id           = nvl(:P4460_A,0) ',
'   and security_group_id = :flow_security_group_id',
' order by display_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccione un Plugin -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P4460_A'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica un plug-in de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30469812914262619.4001)
,p_name=>'P4460_FILE_CHAR_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(30467517871262613.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Caracteres de Archivo:'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30470314777262620.4001)
,p_name=>'P4460_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(30467517871262613.4001)
,p_item_default=>'UNIX'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486401428406809601.4001)
,p_name=>'P4460_SELECTED_APPLICATION'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(30467517871262613.4001)
,p_prompt=>unistr('Aplicaci\00F3n Seleccionada')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P4460_A'
,p_display_when_type=>'ITEM_IS_NUMERIC'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486403214123824439.4001)
,p_name=>'P4460_PLUGIN_COUNT'
,p_item_sequence=>6
,p_item_plug_id=>wwv_flow_api.id(30467517871262613.4001)
,p_prompt=>unistr('Plugins disponibles para su exportaci\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P4460_A'
,p_display_when_type=>'ITEM_IS_NUMERIC'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero de plugins definidos en la aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(937791513581878640.4001)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4460_A'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937791693547878641.4001)
,p_event_id=>wwv_flow_api.id(937791513581878640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4460_SELECTED_APPLICATION'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret    varchar(255);',
'begin',
'   select max(name) into l_ret',
'     from wwv_flows ',
'     where id = nvl(:P4460_A,0) ',
'   and security_group_id = :flow_security_group_id;',
'   return l_ret;',
'end;'))
,p_attribute_07=>'P4460_A'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937791776752878642.4001)
,p_event_id=>wwv_flow_api.id(937791513581878640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4460_PLUGIN_COUNT'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret  number;',
'begin',
'   select count(*) c into l_ret ',
'     from WWV_FLOW_PLUGINS ',
'    where flow_id = nvl(:P4460_A,0) ',
'    and security_group_id = :flow_security_group_id;',
'   return l_ret;',
'end;'))
,p_attribute_07=>'P4460_A'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651511805049755611.4001)
,p_name=>'Submit'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(30468611840262614.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651511932562755612.4001)
,p_event_id=>wwv_flow_api.id(651511805049755611.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(30471029145262622.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_plugin (',
'    p_application_id => :P4460_A,',
'    p_plugin_id      => :P4460_PLUGIN_ID,',
'    p_format         => :P4460_FORMAT );',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fallo de Exportaci\00F3n de Plugin')
,p_process_when_button_id=>wwv_flow_api.id(30468611840262614.4001)
,p_process_success_message=>'Plugin exportado'
);
end;
/
prompt --application/pages/page_04461
begin
wwv_flow_api.create_page(
 p_id=>4461.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina: Tipo')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186978113297847057.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(803056200412798212.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4461_HAS_PLUGINS > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(803058216788798234.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(808644729415608533.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4461_HAS_PLUGINS > 0'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(891321926981813357.4001)
,p_plug_name=>unistr('Ning\00FAn Plugin Instalado')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4461_HAS_PLUGINS = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'"NO_PLUGINS_INSTALLED"'
,p_attribute_01=>'Y'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(803056418441798219.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186978113297847057.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(803056631603798223.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(186978113297847057.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>':P4461_HAS_PLUGINS > 0'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(803056832438798223.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186978113297847057.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(803059401950798254.4001)
,p_branch_action=>'f?p=&APP_ID.:4462:&SESSION.::&DEBUG.:4462:P4462_REGION_TYPE:&P4461_REGION_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548816384435936105.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(803056832438798223.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(279482016116565321.4001)
,p_name=>'P4461_SHOW_UNSUPPORTED'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(803056200412798212.4001)
,p_item_default=>'N'
,p_prompt=>'Mostrar No Soportado'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('El valor por defecto <strong>Desactivado</strong>, s\00F3lo mostrar\00E1 los tipos de regiones dise\00F1ados para la interfaz de usuario de la p\00E1gina actual. Si especifica <strong>Activado</strong>, tambi\00E9n se mostrar\00E1 cualquier tipo de regi\00F3n adicional que se h')
||unistr('aya dise\00F1ado para otras interfaces de usuario.'),
'</p>',
unistr('<p>Los tipos de regiones que no est\00E1n soportados para la interfaz de usuario actual de la p\00E1gina pueden tener problemas inesperados de tiempo de ejecuci\00F3n. Oracle no garantiza ni proporciona soporte relacionado con el uso de los tipos de regiones no ')
||unistr('soportados y su uso es a discreci\00F3n del propio usuario.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803057521712798229.4001)
,p_name=>'P4461_REGION_TYPE'
,p_is_required=>true
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(803056200412798212.4001)
,p_prompt=>'Plugin:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d ||',
'       case when is_supported = ''N'' then '' '' || wwv_flow_lang.system_message(''BUILDER.UNSUPPORTED_COMPONENT'') end as d,',
'       r',
'  from ( select display_name      as d,',
'                ''PLUGIN_'' || name as r,',
'                case when instr (',
'                              '':'' || supported_ui_types || '':'',',
'                              ( select '':'' || wwv_flow_user_interface_dev.get_ui_type(:FB_FLOW_ID, :P259_USER_INTERFACE_ID) || '':''',
'                                  from dual )',
'                              ) > 0 then ''Y'' else ''N''',
'                end              as is_supported',
'           from wwv_flow_plugins',
'          where flow_id           = to_number(:FB_FLOW_ID)',
'            and security_group_id = to_number(:WORKSPACE_ID)',
'            and plugin_type       = ''REGION TYPE''',
'          order by 3 desc, d',
'       )',
' where :P4461_SHOW_UNSUPPORTED = ''Y''',
'    or is_supported = ''Y'''))
,p_lov_cascade_parent_items=>'P4461_SHOW_UNSUPPORTED'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Identifique el plugin de regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(890988701916796627.4001)
,p_name=>'P4461_HAS_PLUGINS'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(803056200412798212.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(891045908149798440.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4461_HAS_PLUGINS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''REGION TYPE'''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548816505355939215.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(803056418441798219.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548816842091939215.4001)
,p_event_id=>wwv_flow_api.id(548816505355939215.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(803059130066798252.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Region Source and Settings pages'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'4464,4465'
);
end;
/
prompt --application/pages/page_04462
begin
wwv_flow_api.create_page(
 p_id=>4462.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Calendario: Atributos de P\00E1gina y de Regi\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186979513212865996.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(803532016443852706.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(803538605128852727.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(808644729415608533.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(803532201386852710.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(186979513212865996.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(803532422799852711.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(186979513212865996.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(803957103097900749.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(186979513212865996.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10796602262168008.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(803957103097900749.4001)
,p_branch_sequence=>5
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4462_REGION_TYPE like ''NATIVE_CSS_CALENDAR'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(557887742466021603.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'f?p=&APP_ID.:4700:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(803957103097900749.4001)
,p_branch_sequence=>15
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4462_REGION_TYPE like ''NATIVE_%'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(805145525410068025.4001)
,p_branch_name=>'Go To Page 4461'
,p_branch_action=>'f?p=&APP_ID.:4461:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(803957103097900749.4001)
,p_branch_sequence=>25
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(805352016238103218.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(803532422799852711.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45359931356853360.4001)
,p_name=>'P4462_PAGE_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381744299693210069.4001)
,p_name=>'P4462_BREADCRUMB_PARENT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P4462_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P4462_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P4462_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(393569811325386552.4001)
,p_name=>'P4462_REGION_TYPE_DISPLAY_NAME'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>unistr('Tipo de Regi\00F3n')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REGION.TYPES (FOR DISPLAY ONLY - INCLUDES LEGACY VALUES)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(wwv_flow_lang.system_message(''REGION_NAME.''||name_with_prefix), display_name) D,',
'       name_with_prefix R',
'  from wwv_flow_native_plugins',
' where plugin_type = ''REGION TYPE''',
' union all',
'select display_name||wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') D,',
'       ''PLUGIN_''||name R',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''REGION TYPE''',
' union all',
'select wwv_flow_lang.system_message(''DYNAMIC_QUERY'') D, ''DYNAMIC_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'') D, ''SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR'') D, ''REGION_DISPLAY_SELECTOR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||initcap(wwv_flow_lang.system_message(''STRUCTURED_QUERY''))||'')'' D, ''STRUCTURED_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||wwv_flow_lang.system_message(''FUNCTION_BODY_RETURNING_QUERY'')||'')'' D,''FUNCTION_RETURNING_SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'') D, ''STATIC_TEXT'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''PLSQL_PROCEDURE'')||'' (''||wwv_flow_lang.system_message(''ANONYMOUS_BLOCK'')||'')'' D, ''PLSQL_PROCEDURE'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''WEB_SERVICE_RESULT'')) D,''WEB_SERVICE'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''WEB_SERVICE_RESULT'')) D,''SQL_QUERY_WS'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''HELP_TEXT'')) D, ''HELP_TEXT'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'')||'' (''||wwv_flow_lang.system_message(''ESCAPE_SC'')||'')'' D, ''STATIC_TEXT_ESCAPE_SC'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'')||'' (''||wwv_flow_lang.system_message(''WITH_SHORTCUTS'')||'')'' D, ''STATIC_TEXT_WITH_SHORTCUTS'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||wwv_flow_lang.system_message(''UPDATEABLE_REPORT'')||'')'' D, ''UPDATABLE_SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''URL'') D, ''URL'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''F4000_TREE'')) D, ''JSTREE'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''LEGACY_CALENDAR'') D, ''CALENDAR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''CALENDAR_EASY_TYPE'') D, ''EASY_CALENDAR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''REGION_NAME.NATIVE_LIST'') D, ''LIST'' R from dual',
'order by 1'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403471962713186069.4001)
,p_name=>'P4462_GROUP_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803532616257852711.4001)
,p_name=>'P4462_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si identifica un nuevo n\00FAmero de p\00E1gina, el asistente crea una nueva p\00E1gina.<p />'),
'',
unistr('Si identifica un n\00FAmero de p\00E1gina existente, el asistente agrega el componente a esa p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803533117626852714.4001)
,p_name=>'P4462_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nombre para la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803533620151852715.4001)
,p_name=>'P4462_APPLICATION'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803534129210852715.4001)
,p_name=>'P4462_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803535132242852717.4001)
,p_name=>'P4462_REGION_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(803536600073852723.4001)
,p_name=>'P4462_BREADCRUMB_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P4462_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(808952923799701596.4001)
,p_name=>'P4462_REGION_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(803532016443852706.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940947858376789974.4001)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4462_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(393570107210398326.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4462_REGION_TYPE_DISPLAY_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4462_REGION_TYPE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(803540002453852737.4001)
,p_validation_name=>'P4462_BREADCRUMB_NAME'
,p_validation_sequence=>30
,p_validation=>'P4462_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P4462_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_api.id(803532422799852711.4001)
,p_associated_item=>wwv_flow_api.id(803536600073852723.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(803540825498852738.4001)
,p_validation_name=>'P4462_PAGE_ID positive, whole number'
,p_validation_sequence=>70
,p_validation=>'trunc(abs(:P4462_PAGE_ID)) = :P4462_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(803532422799852711.4001)
,p_associated_item=>wwv_flow_api.id(803532616257852711.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45360427905854979.4001)
,p_validation_name=>'P4462_PAGE_MODE Not Null'
,p_validation_sequence=>80
,p_validation=>'P4462_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(803532422799852711.4001)
,p_associated_item=>wwv_flow_api.id(45359931356853360.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403472473654188544.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P4462_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4462_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(803532422799852711.4001)
,p_associated_item=>wwv_flow_api.id(403471962713186069.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381744656221214386.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4462_BREADCRUMB_ID'
,p_condition_element=>'P4462_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381744933278214386.4001)
,p_event_id=>wwv_flow_api.id(381744656221214386.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4462_BREADCRUMB_NAME,P4462_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381745138367214387.4001)
,p_event_id=>wwv_flow_api.id(381744656221214386.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4462_BREADCRUMB_NAME,P4462_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548817264327946666.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(803532201386852710.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548817544529946667.4001)
,p_event_id=>wwv_flow_api.id(548817264327946666.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1940948117820791651.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4462_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940949050301791652.4001)
,p_event_id=>wwv_flow_api.id(1940948117820791651.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4462_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P4462_PAGE_NAME'
,p_attribute_07=>'P4462_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940948573341791652.4001)
,p_event_id=>wwv_flow_api.id(1940948117820791651.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4462_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P4462_PAGE_NAME'
,p_attribute_07=>'P4462_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_04464
begin
wwv_flow_api.create_page(
 p_id=>4464.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina: Origen')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187105929975955961.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(806074518462251001.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'0'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(397074514353399221.4001)
,p_plug_name=>unistr('Com\00FAn')
,p_parent_plug_id=>wwv_flow_api.id(806074518462251001.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(397074607782399222.4001)
,p_plug_name=>'SQL local'
,p_parent_plug_id=>wwv_flow_api.id(806074518462251001.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(524540495258261462.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(806074518462251001.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4464_SUPPORTS_DATASOURCES'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(526332736732870909.4001)
,p_plug_name=>'SQL activado para REST'
,p_parent_plug_id=>wwv_flow_api.id(806074518462251001.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4464_SUPPORTS_DATASOURCES'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(397076797163399243.4001)
,p_plug_name=>'Detalles de SQL remoto'
,p_parent_plug_id=>wwv_flow_api.id(526332736732870909.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(806098725692251060.4001)
,p_plug_name=>'process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(808644729415608533.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(806101101634251077.4001)
,p_plug_name=>'Ejemplos SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_plugin in (',
'        select sql_examples',
'          from wwv_flow_plugins',
'         where flow_id = case',
'                           when :P4462_REGION_TYPE like ''NATIVE_%'' then 4411',
'                           else to_number(:FB_FLOW_ID)',
'                         end',
'           and plugin_type = ''REGION TYPE''',
'           and name        = substr(:P4462_REGION_TYPE, 8)',
'           and sql_examples is not null )',
'    loop',
'        sys.htp.p(l_plugin.sql_examples);',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(806826114365367649.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(187105929975955961.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(280275646009341845.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(187105929975955961.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id         = case',
'                             when substr(:P4462_REGION_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                             else to_number(:FB_FLOW_ID)',
'                           end',
'   and p.plugin_type     = ''REGION TYPE''',
'   and p.name            = substr(:P4462_REGION_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id       = p.id',
'   and a.attribute_scope = ''COMPONENT''',
'   and a.show_in_wizard  = ''Y'''))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(806856724408370576.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(187105929975955961.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id         = case',
'                             when substr(:P4462_REGION_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                             else to_number(:FB_FLOW_ID)',
'                           end',
'   and p.plugin_type     = ''REGION TYPE''',
'   and p.name            = substr(:P4462_REGION_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id       = p.id',
'   and a.attribute_scope = ''COMPONENT''',
'   and a.show_in_wizard  = ''Y'''))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(806841419560369170.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(187105929975955961.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(807716513167480894.4001)
,p_branch_action=>'f?p=&APP_ID.:4465:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(806856724408370576.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1272642094230365201.4001)
,p_branch_name=>'Stay on Page 4464'
,p_branch_action=>'f?p=&APP_ID.:4464:&SESSION.::&DEBUG.:RP:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(806889305839374647.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(806841419560369170.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(397074733676399223.4001)
,p_name=>'P4464_SUPPORTS_DATASOURCES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(397077395652399249.4001)
,p_name=>'P4464_PLG_SOURCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522763343335313871.4001)
,p_name=>'P4464_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(524540495258261462.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522763770994313873.4001)
,p_name=>'P4464_WEB_SRC_COLUMNS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(524540495258261462.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''WEB_SOURCE'',',
'                  p_web_src_module_id => :P4464_WEB_SRC_MODULE_ID,',
'                  p_query_type        => null ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''WEB_SOURCE'',',
'        p_web_src_module_id => :P4464_WEB_SRC_MODULE_ID,',
'        p_query_type        => null ) )    ',
' order by 1'))
,p_lov_cascade_parent_items=>'P4464_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522764983844315376.4001)
,p_name=>'P4464_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(526332736732870909.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522765363698315376.4001)
,p_name=>'P4464_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(397076797163399243.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. Los informes pueden estar basados en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522766289905315377.4001)
,p_name=>'P4464_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(397076797163399243.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la regi\00F3n de informe, por ejemplo:'),
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P4464_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522767119930315378.4001)
,p_name=>'P4464_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(397076797163399243.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4464_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P4464_REMOTE_SERVER_ID,P4464_REMOTE_SOURCE_TYPE'
,p_ajax_items_to_submit=>'P4464_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522768078621315379.4001)
,p_name=>'P4464_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(397076797163399243.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4464_REMOTE_SERVER_ID, ''TABLE'', :P4464_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P4464_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P4464_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522768989586315379.4001)
,p_name=>'P4464_REMOTE_COLUMNS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(397076797163399243.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''REMOTE'',',
'                  p_remote_server_id  => :P4464_REMOTE_SERVER_ID,',
'                  p_owner             => :P4464_REMOTE_TABLE_OWNER,',
'                  p_table_name        => :P4464_REMOTE_TABLE_NAME,',
'                  p_query_type        => ''TABLE'' ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''REMOTE'',',
'        p_remote_server_id  => :P4464_REMOTE_SERVER_ID,',
'        p_owner             => :P4464_REMOTE_TABLE_OWNER,',
'        p_table_name        => :P4464_REMOTE_TABLE_NAME,',
'        p_query_type        => ''TABLE'' ) )'))
,p_lov_cascade_parent_items=>'P4464_REMOTE_TABLE_NAME,P4464_REMOTE_SERVER_ID'
,p_ajax_items_to_submit=>'P4464_REMOTE_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522773449492325473.4001)
,p_name=>'P4464_LOCATION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_item_default=>'LOCAL'
,p_prompt=>'Origen de Datos'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P4464_SUPPORTS_DATASOURCES'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522793346176429201.4001)
,p_name=>'P4464_PLG_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522793439245429202.4001)
,p_name=>'P4464_PLG_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522793501728429203.4001)
,p_name=>'P4464_PLG_COLUMNS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(522793688015429204.4001)
,p_name=>'P4464_PLG_SOURCE_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(651998855340245741.4001)
,p_name=>'P4464_IS_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(397074514353399221.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687430472357925008.4001)
,p_name=>'P4464_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(397074607782399222.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_display_when=>'P4464_IS_SQL'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. Las regiones pueden estar basadas en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687431146207929251.4001)
,p_name=>'P4464_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(397074607782399222.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_display_when=>'P4464_IS_SQL'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que va a crear una regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687432012839934620.4001)
,p_name=>'P4464_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(397074607782399222.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P4464_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4464_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P4464_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'P4464_IS_SQL'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la regi\00F3n. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(687484204304472237.4001)
,p_name=>'P4464_COLUMNS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(397074607782399222.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from wwv_flow_table_columns_dev',
'        where owner      = :P4464_TABLE_OWNER',
'          and table_name = :P4464_TABLE_NAME',
'    ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seleccionar Columnas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P4464_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P4464_TABLE_OWNER',
'   and table_name = :P4464_TABLE_NAME'))
,p_lov_cascade_parent_items=>'P4464_TABLE_NAME'
,p_ajax_items_to_submit=>'P4464_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>10
,p_display_when=>'P4464_IS_SQL'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(806084002494251030.4001)
,p_name=>'P4464_SOURCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(397074607782399222.4001)
,p_prompt=>unistr('Introduzca el origen de la regi\00F3n:')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>120
,p_cMaxlength=>32767
,p_cHeight=>13
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el origen de la regi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(651998463599245737.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4464_SOURCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_plugin_dev.build_sql_statement (',
'               p_application_id => :FB_FLOW_ID,',
'               p_table_owner    => :P4464_TABLE_OWNER,',
'               p_table_name     => :P4464_TABLE_NAME,',
'               p_columns        => :P4464_COLUMNS ); ',
'end;'))
,p_compute_when=>':P4464_SOURCE_TYPE = ''TABLE'' and :P4464_SUPPORTS_DATASOURCES = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522793702975429205.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4464_PLG_SOURCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4464_LOCATION ',
'    when ''REMOTE'' then :P4464_REMOTE_SQL',
'    when ''WEB_SOURCE'' then null',
'    when ''LOCAL'' then :P4464_SOURCE end'))
,p_compute_when=>'P4464_SUPPORTS_DATASOURCES'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522793890211429206.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4464_PLG_TABLE_OWNER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4464_LOCATION ',
'    when ''REMOTE'' then :P4464_REMOTE_TABLE_OWNER',
'    when ''WEB_SOURCE'' then null',
'    when ''LOCAL'' then :P4464_TABLE_OWNER end'))
,p_compute_when=>'P4464_SUPPORTS_DATASOURCES'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522793937570429207.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4464_PLG_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4464_LOCATION ',
'    when ''REMOTE'' then :P4464_REMOTE_TABLE_NAME',
'    when ''WEB_SOURCE'' then null',
'    when ''LOCAL'' then :P4464_TABLE_NAME end'))
,p_compute_when=>'P4464_SUPPORTS_DATASOURCES'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522794120358429209.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4464_PLG_COLUMNS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4464_LOCATION ',
'    when ''REMOTE''     then :P4464_REMOTE_COLUMNS',
'    when ''WEB_SOURCE'' then :P4464_WEB_SRC_COLUMNS',
'    when ''LOCAL''      then :P4464_COLUMNS end'))
,p_compute_when=>'P4464_SUPPORTS_DATASOURCES'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522794205013429210.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4464_PLG_SOURCE_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4464_LOCATION ',
'    when ''REMOTE'' then :P4464_REMOTE_SOURCE_TYPE',
'    when ''WEB_SOURCE'' then null',
'    when ''LOCAL'' then :P4464_SOURCE_TYPE end'))
,p_compute_when=>'P4464_SUPPORTS_DATASOURCES'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(651998936858245742.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4464_IS_SQL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when wwv_flow_plugin_dev.has_standard_attribute (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_type    => ''REGION TYPE'',',
'           p_plugin_name    => :P4462_REGION_TYPE,',
'           p_feature        => ''SOURCE_SQL'' ) then ''Y''',
'  when wwv_flow_plugin_dev.has_standard_attribute (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_type    => ''REGION TYPE'',',
'           p_plugin_name    => :P4462_REGION_TYPE,',
'           p_feature        => ''SOURCE_LOCATION'' ) then ''Y''',
'  else ''N''',
'end'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522795806656429226.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4464_REMOTE_SERVER_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(522796078841429228.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4464_WEB_SRC_MODULE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
);
end;
/
begin
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(397074821365399224.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4464_SUPPORTS_DATASOURCES'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when wwv_flow_plugin_dev.has_standard_attribute (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_type    => ''REGION TYPE'',',
'           p_plugin_name    => :P4462_REGION_TYPE,',
'           p_feature        => ''SOURCE_LOCATION'' ) then ''Y''',
'  else ''N''',
'end'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(651999022138245743.4001)
,p_validation_name=>'P4464_TABLE_NAME is not null'
,p_validation_sequence=>10
,p_validation=>'P4464_PLG_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Seleccione una tabla.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4464_PLG_SOURCE_TYPE = ''TABLE''',
'and wwv_flow_plugin_dev.is_required (',
'        p_application_id => :FB_FLOW_ID,',
'        p_plugin_type    => ''REGION TYPE'',',
'        p_plugin_name    => :P4462_REGION_TYPE,',
'        p_feature        => ''SOURCE'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(687485334666519876.4001)
,p_validation_name=>'P4464_COLUMNS is not null'
,p_validation_sequence=>20
,p_validation=>'P4464_PLG_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe seleccionar al menos una columna.'
,p_validation_condition=>' :P4464_PLG_SOURCE_TYPE = ''TABLE'' and :P4464_PLG_TABLE_NAME is not null or :P4464_LOCATION = ''WEB_SOURCE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(610851122767282102.4001)
,p_validation_name=>'Chosen Table exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P4464_TABLE_OWNER',
'   and object_name = :P4464_TABLE_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P4464_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST IN (''Next'', ''CREATE'' ) and :P4464_SOURCE_TYPE = ''TABLE'' and :P4464_TABLE_NAME is not null and',
':P4464_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(687432012839934620.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(651998384901245736.4001)
,p_validation_name=>'Validate Columns'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.validate_region_source (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_name    => :P4462_REGION_TYPE,',
'           p_region_source  => :P4464_SOURCE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4464_SUPPORTS_DATASOURCES = ''N'' and (',
':P4464_SOURCE_TYPE = ''TABLE'' and :P4464_TABLE_NAME is not null and :P4464_COLUMNS is not null )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(806104522043251090.4001)
,p_validation_name=>'Validate query source'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.validate_region_source (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_name    => :P4462_REGION_TYPE,',
'           p_region_source  => :P4464_SOURCE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4464_SUPPORTS_DATASOURCES = ''N'' and ( :P4464_SOURCE_TYPE is null or :P4464_SOURCE_TYPE = ''QUERY'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(806856724408370576.4001)
,p_associated_item=>wwv_flow_api.id(806084002494251030.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(522794326859429211.4001)
,p_validation_name=>'Validate Source and Columns (multiple data sources)'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.validate_region_source (',
'           p_application_id    => :FB_FLOW_ID,',
'           p_plugin_name       => :P4462_REGION_TYPE,',
'           p_source_type       => case :P4464_PLG_SOURCE_TYPE',
'                                      when ''QUERY'' then wwv_flow_exec_api.c_query_type_sql_query',
'                                      when ''TABLE'' then wwv_flow_exec_api.c_query_type_table end,',
'           p_location          => case :P4464_LOCATION ',
'                                      when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                      when ''REMOTE''     then wwv_flow_exec_api.c_location_remote_db',
'                                      else                   wwv_flow_exec_api.c_location_local_db end,',
'           p_remote_server_id  => :P4464_REMOTE_SERVER_ID,',
'           p_table_owner       => :P4464_PLG_TABLE_OWNER,',
'           p_table_name        => :P4464_PLG_TABLE_NAME,',
'           p_region_source     => :P4464_PLG_SOURCE,',
'           p_column_names      => :P4464_PLG_COLUMNS,',
'           p_web_src_module_id => :P4464_WEB_SRC_MODULE_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4464_SUPPORTS_DATASOURCES'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(806856724408370576.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548818472498957211.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(806826114365367649.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548818742029957211.4001)
,p_event_id=>wwv_flow_api.id(548818472498957211.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(687433648081945759.4001)
,p_name=>'Local Query'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_SOURCE_TYPE'
,p_condition_element=>'P4464_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(687433987893945770.4001)
,p_event_id=>wwv_flow_api.id(687433648081945759.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_SOURCE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(687434172578945781.4001)
,p_event_id=>wwv_flow_api.id(687433648081945759.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_SOURCE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397074995766399225.4001)
,p_name=>'Local SQL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_LOCATION'
,p_condition_element=>'P4464_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075038644399226.4001)
,p_event_id=>wwv_flow_api.id(397074995766399225.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(397074607782399222.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075162750399227.4001)
,p_event_id=>wwv_flow_api.id(397074995766399225.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(397074607782399222.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522796339675429231.4001)
,p_event_id=>wwv_flow_api.id(397074995766399225.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(806101101634251077.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397075239360399228.4001)
,p_name=>'Remote SQL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_LOCATION'
,p_condition_element=>'P4464_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075399751399229.4001)
,p_event_id=>wwv_flow_api.id(397075239360399228.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(526332736732870909.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075440088399230.4001)
,p_event_id=>wwv_flow_api.id(397075239360399228.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(526332736732870909.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522796238916429230.4001)
,p_event_id=>wwv_flow_api.id(397075239360399228.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(806101101634251077.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522794692390429214.4001)
,p_event_id=>wwv_flow_api.id(397075239360399228.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397075528118399231.4001)
,p_name=>'REST Data Source'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_LOCATION'
,p_condition_element=>'P4464_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075603275399232.4001)
,p_event_id=>wwv_flow_api.id(397075528118399231.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(524540495258261462.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075765746399233.4001)
,p_event_id=>wwv_flow_api.id(397075528118399231.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(524540495258261462.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397077125256399247.4001)
,p_event_id=>wwv_flow_api.id(397075528118399231.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(806101101634251077.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522794597397429213.4001)
,p_event_id=>wwv_flow_api.id(397075528118399231.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397075840657399234.4001)
,p_name=>'Remote Query'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P4464_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397075969236399235.4001)
,p_event_id=>wwv_flow_api.id(397075840657399234.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397076048860399236.4001)
,p_event_id=>wwv_flow_api.id(397075840657399234.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397076137977399237.4001)
,p_name=>'Remote Table'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P4464_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397076234585399238.4001)
,p_event_id=>wwv_flow_api.id(397076137977399237.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_REMOTE_TABLE_OWNER,P4464_REMOTE_TABLE_NAME,P4464_REMOTE_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397076391420399239.4001)
,p_event_id=>wwv_flow_api.id(397076137977399237.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_REMOTE_TABLE_OWNER,P4464_REMOTE_TABLE_NAME,P4464_REMOTE_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397076566638399241.4001)
,p_name=>'Remote Server'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_REMOTE_SERVER_ID'
,p_condition_element=>'P4464_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397076624650399242.4001)
,p_event_id=>wwv_flow_api.id(397076566638399241.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(397076797163399243.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397076862071399244.4001)
,p_event_id=>wwv_flow_api.id(397076566638399241.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(397076797163399243.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(522794857696429216.4001)
,p_name=>'Local Table'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4464_SOURCE_TYPE'
,p_condition_element=>'P4464_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522794966152429217.4001)
,p_event_id=>wwv_flow_api.id(522794857696429216.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_TABLE_OWNER,P4464_TABLE_NAME,P4464_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(522795029609429218.4001)
,p_event_id=>wwv_flow_api.id(522794857696429216.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4464_TABLE_OWNER,P4464_TABLE_NAME,P4464_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1340564023689198350.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Source Type Preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'WIZARD_SQL_SOURCE_TYPE'
,p_attribute_03=>'P4464_PLG_SOURCE_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(806856724408370576.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(280275784458341846.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page (classic, local db)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'	wwv_flow_wizard_api.create_region_plugin_page (',
'        p_flow_id                  => :FB_FLOW_ID,',
'        --',
'        p_page_id                  => :P4462_PAGE_ID,',
'        p_page_name                => :P4462_PAGE_NAME,',
'        p_group_name               => :P4462_GROUP_NAME,',
'        p_page_mode                => :P4462_PAGE_MODE,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        --',
'        p_tab_set                  => :P4716_TAB_SET,',
'        p_tab_name                 => :P4716_TAB_NAME,',
'        p_tab_label                => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id            => :P4462_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P4462_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id     => :P4462_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_name              => :P4462_PAGE_NAME,',
'        p_region_type              => :P4462_REGION_TYPE,',
'        p_region_source            => :P4464_SOURCE );',
'',
'  :FB_FLOW_PAGE_ID       := :P4462_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P4462_PAGE_ID;      ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(280275646009341845.4001)
,p_process_when=>'P4464_SUPPORTS_DATASOURCES'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(522794489720429212.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page (multiple data sources)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'	wwv_flow_wizard_api.create_region_plugin_page (',
'        p_flow_id                  => :FB_FLOW_ID,',
'        --',
'        p_page_id                  => :P4462_PAGE_ID,',
'        p_page_name                => :P4462_PAGE_NAME,',
'        p_group_name               => :P4462_GROUP_NAME,',
'        p_page_mode                => :P4462_PAGE_MODE,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        --',
'        p_tab_set                  => :P4716_TAB_SET,',
'        p_tab_name                 => :P4716_TAB_NAME,',
'        p_tab_label                => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id            => :P4462_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P4462_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id     => :P4462_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_name              => :P4462_PAGE_NAME,',
'        p_region_type              => :P4462_REGION_TYPE,',
'        --',
'        p_source_type              => case :P4464_PLG_SOURCE_TYPE',
'                                          when ''QUERY'' then wwv_flow_exec_api.c_query_type_sql_query',
'                                          when ''TABLE'' then wwv_flow_exec_api.c_query_type_table end,',
'        p_location                 => case :P4464_LOCATION ',
'                                          when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                          when ''REMOTE''     then wwv_flow_exec_api.c_location_remote_db',
'                                          else                   wwv_flow_exec_api.c_location_local_db end,',
'        p_remote_server_id         => :P4464_REMOTE_SERVER_ID,',
'        p_table_owner              => :P4464_PLG_TABLE_OWNER,',
'        p_table_name               => :P4464_PLG_TABLE_NAME,',
'        p_region_source            => :P4464_PLG_SOURCE,',
'        p_column_names             => :P4464_PLG_COLUMNS,',
'        p_web_src_module_id        => :P4464_WEB_SRC_MODULE_ID );',
'',
'  :FB_FLOW_PAGE_ID       := :P4462_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P4462_PAGE_ID;      ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(280275646009341845.4001)
,p_process_when=>'P4464_SUPPORTS_DATASOURCES'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(280275801453341847.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(280275646009341845.4001)
);
end;
/
prompt --application/pages/page_04465
begin
wwv_flow_api.create_page(
 p_id=>4465.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina: Configuraci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187102106679892443.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(807113004417409648.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
unistr('// ocultar los atributos din\00E1micos inmediatamente despu\00E9s de su representaci\00F3n, jQuery.ready puede tardar demasiado tiempo. '),
'apex.builder.dynamicAttributes.hide(''P4475_'');',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(807118017022409662.4001)
,p_plug_name=>'position'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(808644729415608533.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Seq:Label'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(807118429488409664.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type              => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_type_value               => :P4462_REGION_TYPE,',
'        p_page_item_prefix         => ''P4465_'',',
'        p_source_type              => case :P4464_PLG_SOURCE_TYPE',
'                                          when ''QUERY'' then wwv_flow_exec_api.c_query_type_sql_query',
'                                          when ''TABLE'' then wwv_flow_exec_api.c_query_type_table end,',
'        p_location                 => case :P4464_LOCATION ',
'                                          when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                          when ''REMOTE''     then wwv_flow_exec_api.c_location_remote_db',
'                                          else                   wwv_flow_exec_api.c_location_local_db end,',
'        p_remote_server_id         => :P4464_REMOTE_SERVER_ID,',
'        p_table_owner              => :P4464_PLG_TABLE_OWNER,',
'        p_table_name               => :P4464_PLG_TABLE_NAME,',
'        p_region_source            => :P4464_PLG_SOURCE,',
'        p_column_names             => :P4464_PLG_COLUMNS,',
'        p_web_src_module_id        => :P4464_WEB_SRC_MODULE_ID,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        p_is_wizard                => true );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(807113220075409652.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(187102106679892443.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(807113800106409654.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(187102106679892443.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(807113630655409653.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(187102106679892443.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(698536494191422536.4001)
,p_branch_name=>'Source Option'
,p_branch_action=>'f?p=&APP_ID.:4464:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(807113630655409653.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.get_standard_attributes (',
'    p_application_id => :FB_FLOW_ID,',
'    p_plugin_type    => ''REGION TYPE'',',
'    p_plugin_name    => :P4462_REGION_TYPE ) like ''%:SOURCE%'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(807120210961409676.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4464:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(807113630655409653.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13716727690913997.4001)
,p_name=>'P4465_ATTRIBUTE_16'
,p_item_sequence=>221
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13716905166913997.4001)
,p_name=>'P4465_ATTRIBUTE_17'
,p_item_sequence=>222
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13717132644913998.4001)
,p_name=>'P4465_ATTRIBUTE_18'
,p_item_sequence=>223
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13717327135913998.4001)
,p_name=>'P4465_ATTRIBUTE_19'
,p_item_sequence=>224
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13717501980913998.4001)
,p_name=>'P4465_ATTRIBUTE_20'
,p_item_sequence=>225
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13717721073913998.4001)
,p_name=>'P4465_ATTRIBUTE_21'
,p_item_sequence=>226
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13717907493913998.4001)
,p_name=>'P4465_ATTRIBUTE_22'
,p_item_sequence=>227
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13718110308913998.4001)
,p_name=>'P4465_ATTRIBUTE_23'
,p_item_sequence=>228
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13718317858913999.4001)
,p_name=>'P4465_ATTRIBUTE_24'
,p_item_sequence=>229
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13718529693913999.4001)
,p_name=>'P4465_ATTRIBUTE_25'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(514943906444998835.4001)
,p_name=>'P4465_CSS_CAL_NEW_PAGE'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_prompt=>unistr('Agregar Crear P\00E1gina')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1=0 and (:P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'') ',
'and (wwv_flow_user_interface_dev.is_desktop_ui(p_application_id => :FB_FLOW_ID, p_user_interface_id => :P259_USER_INTERFACE_ID))'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique si se crear\00E1 una nueva p\00E1gina de pantalla junto con la p\00E1gina de calendario. Esta pantalla se utilizar\00E1 para agregar eventos en el calendario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(514944062867998836.4001)
,p_name=>'P4465_CSS_CAL_EDIT_PAGE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_prompt=>unistr('Agregar Editar P\00E1gina')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'1=0 and :P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'' and (wwv_flow_user_interface_dev.is_desktop_ui(p_application_id => :FB_FLOW_ID, p_user_interface_id => :P259_USER_INTERFACE_ID))'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique si se crear\00E1 una nueva p\00E1gina de pantalla junto con la p\00E1gina de calendario. Esta pantalla se utilizar\00E1 para editar eventos en el calendario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(514944143380998837.4001)
,p_name=>'P4465_CSS_CAL_DRAG_CODE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_prompt=>unistr('Generar C\00F3digo de Arrastrar y Soltar')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'1=0 and (:P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'') and (wwv_flow_user_interface_dev.is_desktop_ui(p_application_id => :FB_FLOW_ID, p_user_interface_id => :P259_USER_INTERFACE_ID))'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique si el calendario agregar\00E1 el c\00F3digo para Arrastrar y Soltar, que se utilizar\00E1 para actualizar los registros de eventos cuando un usuario final arrastra y suelta eventos de una fecha a otra.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(514944274575998838.4001)
,p_name=>'P4465_CSS_CAL_EDIT_MOB'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_prompt=>unistr('Agregar Crear/Editar P\00E1gina')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'1=0 and :P4462_REGION_TYPE = ''NATIVE_CSS_CALENDAR'' and :P4464_SOURCE_TYPE = ''TABLE'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifique si se crear\00E1 una nueva p\00E1gina de pantalla junto con la p\00E1gina de calendario. Esta pantalla se utilizar\00E1 para editar y crear eventos')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- bug #30418104: remove JQM references',
'-- and (wwv_flow_user_interface_dev.is_jqm_ui(p_application_id => :FB_FLOW_ID, p_user_interface_id => :P259_USER_INTERFACE_ID))'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807114002951409654.4001)
,p_name=>'P4465_ATTRIBUTE_11'
,p_item_sequence=>211
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807114201517409656.4001)
,p_name=>'P4465_ATTRIBUTE_12'
,p_item_sequence=>212
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807114421683409656.4001)
,p_name=>'P4465_ATTRIBUTE_13'
,p_item_sequence=>213
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807114609954409657.4001)
,p_name=>'P4465_ATTRIBUTE_14'
,p_item_sequence=>214
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807114800744409657.4001)
,p_name=>'P4465_ATTRIBUTE_15'
,p_item_sequence=>215
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807115005471409657.4001)
,p_name=>'P4465_ATTRIBUTE_01'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807115219657409658.4001)
,p_name=>'P4465_ATTRIBUTE_02'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807115406177409658.4001)
,p_name=>'P4465_ATTRIBUTE_09'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807115629827409658.4001)
,p_name=>'P4465_ATTRIBUTE_03'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807115805697409658.4001)
,p_name=>'P4465_ATTRIBUTE_05'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807116022446409658.4001)
,p_name=>'P4465_ATTRIBUTE_06'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807116224956409658.4001)
,p_name=>'P4465_ATTRIBUTE_10'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807116404818409659.4001)
,p_name=>'P4465_ATTRIBUTE_08'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807116618765409659.4001)
,p_name=>'P4465_ATTRIBUTE_04'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(807116826172409659.4001)
,p_name=>'P4465_ATTRIBUTE_07'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(807113004417409648.4001)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(807119219808409673.4001)
,p_validation_name=>'Validate Plugin Attributes (classic, local DB)'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P4462_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4465_'',',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        p_region_source     => :P4464_SOURCE );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>'P4464_SUPPORTS_DATASOURCES'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(522795201980429220.4001)
,p_validation_name=>'Validate Plugin Attributes (multiple sources)'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P4462_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4465_'',',
'        p_user_interface_id => :P259_USER_INTERFACE_ID,',
'        --',
'        p_source_type       => case :P4464_PLG_SOURCE_TYPE',
'                                   when ''QUERY'' then wwv_flow_exec_api.c_query_type_sql_query',
'                                   when ''TABLE'' then wwv_flow_exec_api.c_query_type_table end,',
'        p_location          => case :P4464_LOCATION ',
'                                   when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                   when ''REMOTE''     then wwv_flow_exec_api.c_location_remote_db',
'                                   else                   wwv_flow_exec_api.c_location_local_db end,',
'        p_remote_server_id  => :P4464_REMOTE_SERVER_ID,',
'        p_table_owner       => :P4464_PLG_TABLE_OWNER,',
'        p_table_name        => :P4464_PLG_TABLE_NAME,',
'        p_region_source     => :P4464_PLG_SOURCE,',
'        p_web_src_module_id => :P4464_WEB_SRC_MODULE_ID );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>'P4464_SUPPORTS_DATASOURCES'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548819076284963778.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(807113220075409652.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548819389521963778.4001)
,p_event_id=>wwv_flow_api.id(548819076284963778.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203929131121288823.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P4462_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4465_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(268297299969420316.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page (multiple data sources)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_region_plugin_page (',
'        p_flow_id                  => :FB_FLOW_ID,',
'        --',
'        p_page_id                  => :P4462_PAGE_ID,',
'        p_page_name                => :P4462_PAGE_NAME,',
'        p_group_name               => :P4462_GROUP_NAME,',
'        p_page_mode                => :P4462_PAGE_MODE,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        --',
'        p_tab_set                  => :P4716_TAB_SET,',
'        p_tab_name                 => :P4716_TAB_NAME,',
'        p_tab_label                => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id            => :P4462_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P4462_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id     => :P4462_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_name              => :P4462_PAGE_NAME,',
'        p_region_type              => :P4462_REGION_TYPE,',
'        --',
'        p_source_type              => case :P4464_PLG_SOURCE_TYPE',
'                                          when ''QUERY'' then wwv_flow_exec_api.c_query_type_sql_query',
'                                          when ''TABLE'' then wwv_flow_exec_api.c_query_type_table end,',
'        p_location                 => case :P4464_LOCATION ',
'                                          when ''WEB_SOURCE'' then wwv_flow_exec_api.c_location_web_source',
'                                          when ''REMOTE''     then wwv_flow_exec_api.c_location_remote_db',
'                                          else                   wwv_flow_exec_api.c_location_local_db end,',
'        p_remote_server_id         => :P4464_REMOTE_SERVER_ID,',
'        p_table_owner              => :P4464_PLG_TABLE_OWNER,',
'        p_table_name               => :P4464_PLG_TABLE_NAME,',
'        p_region_source            => :P4464_PLG_SOURCE,',
'        p_column_names             => :P4464_PLG_COLUMNS,',
'        p_web_src_module_id        => :P4464_WEB_SRC_MODULE_ID,',
'        --',
'        p_attribute_01             => :P4465_ATTRIBUTE_01,',
'        p_attribute_02             => :P4465_ATTRIBUTE_02,',
'        p_attribute_03             => :P4465_ATTRIBUTE_03,',
'        p_attribute_04             => :P4465_ATTRIBUTE_04,',
'        p_attribute_05             => :P4465_ATTRIBUTE_05,',
'        p_attribute_06             => :P4465_ATTRIBUTE_06,',
'        p_attribute_07             => :P4465_ATTRIBUTE_07,',
'        p_attribute_08             => :P4465_ATTRIBUTE_08,',
'        p_attribute_09             => :P4465_ATTRIBUTE_09,',
'        p_attribute_10             => :P4465_ATTRIBUTE_10,',
'        p_attribute_11             => :P4465_ATTRIBUTE_11,',
'        p_attribute_12             => :P4465_ATTRIBUTE_12,',
'        p_attribute_13             => :P4465_ATTRIBUTE_13,',
'        p_attribute_14             => :P4465_ATTRIBUTE_14,',
'        p_attribute_15             => :P4465_ATTRIBUTE_15,',
'        p_attribute_16             => :P4465_ATTRIBUTE_16,',
'        p_attribute_17             => :P4465_ATTRIBUTE_17,',
'        p_attribute_18             => :P4465_ATTRIBUTE_18,',
'        p_attribute_19             => :P4465_ATTRIBUTE_19,',
'        p_attribute_20             => :P4465_ATTRIBUTE_20,',
'        p_attribute_21             => :P4465_ATTRIBUTE_21,',
'        p_attribute_22             => :P4465_ATTRIBUTE_22,',
'        p_attribute_23             => :P4465_ATTRIBUTE_23,',
'        p_attribute_24             => :P4465_ATTRIBUTE_24,',
'        p_attribute_25             => :P4465_ATTRIBUTE_25 );',
'',
'  :FB_FLOW_PAGE_ID       := :P4462_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P4462_PAGE_ID;      ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(807113800106409654.4001)
,p_process_when=>'P4464_SUPPORTS_DATASOURCES'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(522795974285429227.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page (classic, local db)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_region_plugin_page (',
'        p_flow_id                  => :FB_FLOW_ID,',
'        --',
'        p_page_id                  => :P4462_PAGE_ID,',
'        p_page_name                => :P4462_PAGE_NAME,',
'        p_group_name               => :P4462_GROUP_NAME,',
'        p_page_mode                => :P4462_PAGE_MODE,',
'        p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'        --',
'        p_tab_set                  => :P4716_TAB_SET,',
'        p_tab_name                 => :P4716_TAB_NAME,',
'        p_tab_label                => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --',
'        p_breadcrumb_id            => :P4462_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P4462_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id     => :P4462_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_name              => :P4462_PAGE_NAME,',
'        p_region_type              => :P4462_REGION_TYPE,',
'        p_region_source            => :P4464_SOURCE,',
'        --',
'        p_attribute_01             => :P4465_ATTRIBUTE_01,',
'        p_attribute_02             => :P4465_ATTRIBUTE_02,',
'        p_attribute_03             => :P4465_ATTRIBUTE_03,',
'        p_attribute_04             => :P4465_ATTRIBUTE_04,',
'        p_attribute_05             => :P4465_ATTRIBUTE_05,',
'        p_attribute_06             => :P4465_ATTRIBUTE_06,',
'        p_attribute_07             => :P4465_ATTRIBUTE_07,',
'        p_attribute_08             => :P4465_ATTRIBUTE_08,',
'        p_attribute_09             => :P4465_ATTRIBUTE_09,',
'        p_attribute_10             => :P4465_ATTRIBUTE_10,',
'        p_attribute_11             => :P4465_ATTRIBUTE_11,',
'        p_attribute_12             => :P4465_ATTRIBUTE_12,',
'        p_attribute_13             => :P4465_ATTRIBUTE_13,',
'        p_attribute_14             => :P4465_ATTRIBUTE_14,',
'        p_attribute_15             => :P4465_ATTRIBUTE_15,',
'        p_attribute_16             => :P4465_ATTRIBUTE_16,',
'        p_attribute_17             => :P4465_ATTRIBUTE_17,',
'        p_attribute_18             => :P4465_ATTRIBUTE_18,',
'        p_attribute_19             => :P4465_ATTRIBUTE_19,',
'        p_attribute_20             => :P4465_ATTRIBUTE_20,',
'        p_attribute_21             => :P4465_ATTRIBUTE_21,',
'        p_attribute_22             => :P4465_ATTRIBUTE_22,',
'        p_attribute_23             => :P4465_ATTRIBUTE_23,',
'        p_attribute_24             => :P4465_ATTRIBUTE_24,',
'        p_attribute_25             => :P4465_ATTRIBUTE_25 );',
'',
'  :FB_FLOW_PAGE_ID       := :P4462_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P4462_PAGE_ID;      ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(807113800106409654.4001)
,p_process_when=>'P4464_SUPPORTS_DATASOURCES'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(268297321921420317.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close of Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(807113800106409654.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203929235988288824.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P4462_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4465_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04495
begin
wwv_flow_api.create_page(
 p_id=>4495.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar Esquema de Autenticaci\00F3n')
,p_step_title=>unistr('Editar Esquema de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(27816729931938405)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function LDAPTestGetValues() {',
'    return {',
'        host: $v("P4495_ATTRIBUTE_01"),',
'        port: $v("P4495_ATTRIBUTE_02"),',
'        use_ssl: $v("P4495_ATTRIBUTE_03"),',
'        dn_string: $v("P4495_ATTRIBUTE_04"),',
'        use_dn: $v("P4495_ATTRIBUTE_05"),',
'        search_filter: $v("P4495_ATTRIBUTE_06"),',
'        edit_function: $v("P4495_ATTRIBUTE_07"),',
'        username_escaping: $v("P4495_ATTRIBUTE_08")',
'    };',
'}',
'function LDAPTestSetValues(pLDAPValues) {',
'    $s("P4495_ATTRIBUTE_01", pLDAPValues.host);',
'    $s("P4495_ATTRIBUTE_02", pLDAPValues.port);',
'    $s("P4495_ATTRIBUTE_03", pLDAPValues.use_ssl);',
'    $s("P4495_ATTRIBUTE_04", pLDAPValues.dn_string);',
'    $s("P4495_ATTRIBUTE_05", pLDAPValues.use_dn);',
'    $s("P4495_ATTRIBUTE_06", pLDAPValues.search_filter);',
'    $s("P4495_ATTRIBUTE_07", pLDAPValues.edit_function);',
'    $s("P4495_ATTRIBUTE_08", pLDAPValues.username_escaping);',
'}'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(125788308327200146.4001)
,p_plug_name=>'Real Application Security'
,p_region_name=>'RAS'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_required_role=>wwv_flow_api.id(125788121598195155)
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(315239623539491637.4001)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>180
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345781625941052324.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
unistr('// ocultar los atributos din\00E1micos inmediatamente despu\00E9s de su representaci\00F3n, '),
'// jQuery.ready puede tardar demasiado tiempo. ',
'apex.builder.dynamicAttributes.hide(''P4651_'');',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345785730519052338.4001)
,p_plug_name=>unistr('Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345787019175052342.4001)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P4495_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_type_page_item_name => ''P4495_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P4495_'',',
'        p_user_interface_id   => null,',
'        p_is_wizard           => ( :P4495_ID is null )',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345787207892052343.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345873610535069243.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_AUTHENTICATIONS'
,p_attribute_02=>'NAME'
,p_attribute_03=>'P4495_ID'
,p_attribute_04=>'P4495_REFERENCE_ID'
,p_attribute_05=>'F4000_P4495'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345889721617072434.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345906632699075659.4001)
,p_plug_name=>unistr('Sesi\00F3n no V\00E1lida')
,p_region_name=>'INVALID_SESSION'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(462984315510460759.4001)
,p_plug_name=>'Region to make it easier show/hide from apex_builder.js'
,p_region_name=>'INVALID_SESSION_ATTRIBUTES'
,p_parent_plug_id=>wwv_flow_api.id(345906632699075659.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345924009281078364.4001)
,p_plug_name=>unistr('Procesamiento de Conexi\00F3n')
,p_region_name=>'LOGIN_PROCESSING'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345944618631081002.4001)
,p_plug_name=>unistr('Uso compartido de sesi\00F3n')
,p_region_name=>'SESSION_COOKIE_ATTRIBUTES'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(345961628328083848.4001)
,p_plug_name=>unistr('URL Posterior a la Desconexi\00F3n')
,p_region_name=>'POST_LOGOUT_URL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(348704723086404030.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(350195718995582647.4001)
,p_plug_name=>unistr('Esquema de Autenticaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La autenticaci\00F3n es el proceso que establece la identidad de cada usuario antes de que pueda acceder a la aplicaci\00F3n. Puede ser necesaria la introducci\00F3n de un nombre de usuario y una contrase\00F1a por parte del usuario o podr\00EDa implicar el uso de ce')
||'rtificados digitales o de una clave segura.</p>',
'',
unistr('<p>Utilice esta p\00E1gina para crear o editar esquemas de autenticaci\00F3n y definir el que utiliza su aplicaci\00F3n. El esquema de autenticaci\00F3n actual determina la forma en que la aplicaci\00F3n identifica y verifica al usuario final. Dependiendo del tipo de es')
||unistr('quema de autenticaci\00F3n seleccionado, podr\00E1 utilizar diferentes configuraciones y enlaces de programa para ajustar la autenticaci\00F3n de la aplicaci\00F3n.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(530943617040934909.4001)
,p_plug_name=>'Origen'
,p_region_name=>'SOURCE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(345873831230069245.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(345873610535069243.4001)
,p_button_name=>'PUBLISH_SCHEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Esquema'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:821:&SESSION.::&DEBUG.::F4000_P821_ID,F4000_P821_PAGE_ID:&P4495_ID.,801'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ result_cache */',
'       1',
'  from wwv_flow_authentications',
' where reference_id      = :P4495_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(345874024900069245.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(345873610535069243.4001)
,p_button_name=>'REFRESH_SCHEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar Esquema'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ result_cache */',
'       1 ',
'  from wwv_flow_authentications',
' where id                = :P4495_ID',
'   and reference_id      is not null',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(345786103000052340.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4495_PAGE_MODE'
,p_button_condition2=>'NORMAL'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(349533325173480285.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                 = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and authentication_id <> :P4495_ID'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(29414822038032931.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'LDAP_Test'
,p_button_static_id=>'ldap_test_button'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Conexi\00F3n LDAP de Prueba')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3890:&SESSION.::&DEBUG.:3890:P3890_FIRST_VIEW:YES'
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(367654722935524231.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'MAKE_CURRENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Convertir en Esquema Actual'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where :P4495_ID          is not null',
'   and id                 = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and (   authentication_id is null',
'        or authentication_id <> :P4495_ID)'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(345785910825052339.4001)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P4495_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(366683525818383144.4001)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Esquema de Autenticaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'P4495_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1145873507341466275.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(345785730519052338.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition=>'P4495_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(372433627502055491.4001)
,p_branch_action=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(345874024900069245.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(372546725902064436.4001)
,p_branch_action=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4495_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(372226129795046638.4001)
,p_branch_action=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4495_PAGE_MODE'
,p_branch_condition_text=>'NORMAL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1146014811066486259.4001)
,p_branch_action=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1145873507341466275.4001)
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125790700667219995.4001)
,p_name=>'P4495_RAS_MODE'
,p_is_required=>true
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(125788308327200146.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Modo RAS'
,p_source=>'RAS_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REAL APPLICATION SECURITY MODE'
,p_lov=>'.'||wwv_flow_api.id(125789401878207743.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Defina c\00F3mo debe utilizarse Real Application Security en esta aplicaci\00F3n.'),
'<p/>',
unistr('Si se define <em>Modo RAS</em> en <em>Desactivado</em>, Real Application Security no se utiliza por costumbre en la aplicaci\00F3n.'),
unistr('Cuando se define en <em>Usuarios Internos</em>, &PRODUCT_NAME. asume que todos los usuarios son internos y transfiere <em>false</em> a trav\00E9s del par\00E1metro <em>is_external</em> a <em>dbms_xs_sessions.assign_user</em>.'),
unistr('Los usuarios de peso ligero pueden configurarse definiendo el atributo en <em>Externo</em>. En ese caso, <em>true</em> se transfiere a trav\00E9s de <em>is_external</em>.'),
'<p/>',
'Si activa <em>Modo RAS</em>,',
unistr('aseg\00FArese de que los usuarios adquieren privilegios para acceder a los objetos del esquema de la aplicaci\00F3n.'),
unistr('Para <em>Usuarios Externos</em>, puede otorgar privilegios de base de datos, por ejemplo, a un <em>Rol de Aplicaci\00F3n Din\00E1mica RAS</em> y configurarlo en este esquema de autenticaci\00F3n como <em>Rol Din\00E1mico</em>.'),
unistr('Tambi\00E9n puede activar roles a trav\00E9s de una llamada a <em>apex_authorization.enable_dynamic_groups</em>, p. ej., en un procedimiento posterior a la autenticaci\00F3n.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125790910144230797.4001)
,p_name=>'P4495_RAS_DYNAMIC_ROLES'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(125788308327200146.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Roles Din\00E1micos')
,p_source=>'RAS_DYNAMIC_ROLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'RAS_DYNAMIC_ROLES'
,p_lov=>'select name n,name v from sys.dba_xs_dynamic_roles where system_defined=''NO'' order by 1'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Configure los Roles Din\00E1micos de Real Application Security para usuarios de autenticaci\00F3n.'),
'&PRODUCT_NAME. activa estos roles al conectarse,',
unistr('al transferirlos a trav\00E9s del par\00E1metro <em>enable_dynamic_roles</em> de <em>sys.dbms_xs_sessions.assign_user</em>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(125791103890233778.4001)
,p_name=>'P4495_RAS_NAMESPACES'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(125788308327200146.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Espacios de Nombres'
,p_source=>'RAS_NAMESPACES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'RAS_NAMESPACE_TEMPLATES'
,p_lov=>'select name n,name v from sys.dba_xs_ns_templates where name not like ''XS$%'' order by 1'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Configure las Plantillas de Espacio de Nombres de Real Application Security para usuarios de autenticaci\00F3n.'),
'&PRODUCT_NAME. activa estos espacios de nombres al conectarse,',
unistr('al transferirlos a trav\00E9s del par\00E1metro <em>namespaces</em> de <em>sys.dbms_xs_sessions.assign_user</em>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(315240024514495330.4001)
,p_name=>'P4495_PAGE_MODE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(315239623539491637.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(342360883478652525.4001)
,p_name=>'P4495_COOKIE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(345944618631081002.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo'
,p_source=>'COOKIE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION COOKIE SHARING'
,p_lov=>'.'||wwv_flow_api.id(46630896750249951.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Defina qu\00E9 tipo de cookie de sesi\00F3n debe utilizar esta aplicaci\00F3n.'),
unistr('Puede utilizar este atributo para compartir la misma sesi\00F3n de &PRODUCT_NAME. entre varias aplicaciones de un espacio de trabajo.'),
unistr('Con el uso compartido de sesi\00F3n, los usuarios pueden navegar perfectamente entre aplicaciones sin necesidad de iniciar sesi\00F3n varias veces.'),
'</p><p>',
'<ul>',
unistr('    <li><em>Aplicaci\00F3n (no de uso compartido)</em>: la cookie de sesi\00F3n es espec\00EDfica de esta aplicaci\00F3n.'),
'        Las sesiones no se comparten con otras aplicaciones.</li>',
unistr('    <li><em>Uso compartido de espacio de trabajo</em>: la sesi\00F3n se comparte con otras aplicaciones de este espacio de'),
unistr('         trabajo si estas tambi\00E9n tienen <em>tipo de cookie</em> definido en <em>Uso compartido de espacio de trabajo</em>.</li>'),
unistr('    <li><em>Personalizado</em>: defina atributos de cookie de sesi\00F3n personalizados.</li>'),
'</ul>    ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345781809729052326.4001)
,p_name=>'P4495_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(345889721617072434.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345782504523052330.4001)
,p_name=>'P4495_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P4495_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345782711740052331.4001)
,p_name=>'P4495_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P4495_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345782916842052331.4001)
,p_name=>'P4495_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P4495_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345783102579052332.4001)
,p_name=>'P4495_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P4495_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345783305255052332.4001)
,p_name=>'P4495_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P4495_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345783521998052332.4001)
,p_name=>'P4495_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P4495_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345783708314052332.4001)
,p_name=>'P4495_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P4495_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345783932506052332.4001)
,p_name=>'P4495_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P4495_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345784119391052334.4001)
,p_name=>'P4495_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P4495_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345784303772052334.4001)
,p_name=>'P4495_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P4495_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345784506476052334.4001)
,p_name=>'P4495_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P4495_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345784718827052334.4001)
,p_name=>'P4495_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P4495_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345784925535052334.4001)
,p_name=>'P4495_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P4495_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345785121864052335.4001)
,p_name=>'P4495_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P4495_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345785314557052335.4001)
,p_name=>'P4495_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(345781625941052324.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P4495_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345874209190069246.4001)
,p_name=>'P4495_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(345873610535069243.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Esquema de Autenticaci\00F3n Maestro de Referencia de')
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.flow_id||'': ''||wwv_flow_escape.html(a.name) as d,',
'       a.id as r',
'  from wwv_flow_authentications a,',
'       wwv_flows f',
' where a.id                <> to_number(:P4495_ID)',
'   and a.security_group_id = to_number(:WORKSPACE_ID)',
'   and f.id                = a.flow_id',
'   and f.build_status     not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- no hay esquema de autenticaci\00F3n -')
,p_cSize=>32
,p_cMaxlength=>255
,p_colspan=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione una aplicaci\00F3n a cuyo esquema de autenticaci\00F3n desea suscribir este esquema.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345874730496069247.4001)
,p_name=>'P4495_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(345873610535069243.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_begin_on_new_line=>'N'
,p_display_when=>'P4495_REFERENCE_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345890420333072437.4001)
,p_name=>'P4495_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(345889721617072434.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'ABOVE'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345891325506072438.4001)
,p_name=>'P4495_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(345889721617072434.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Los desarrolladores de aplicaciones utilizan este nombre para hacer referencia al esquema de autenticaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345908228187075663.4001)
,p_name=>'P4495_INVALID_SESSION_URL'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(462984315510460759.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'INVALID_SESSION_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique una URL a la que &PRODUCT_NAME. debe redireccionar si la funci\00F3n de protecci\00F3n de sesi\00F3n devuelve un valor falso. Normalmente ser\00E1 una URL a una p\00E1gina de conexi\00F3n o un portal de Single Sign-On.'),
'<p/>',
'Ejemplo: f?p=&amp;APP_ID.:101:&amp;SESSION'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345924211605078366.4001)
,p_name=>'P4495_HELP_TEXT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(345924009281078364.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Texto de Ayuda'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Texto mostrado en la ventana emergente de ayuda, disponible en la p\00E1gina de conexi\00F3n. Debe ofrecer orientaci\00F3n y enlaces a recursos para ayudar a los usuarios de la p\00E1gina de conexi\00F3n incorporada de &PRODUCT_NAME., espec\00EDfica para el tipo de autentic')
||unistr('aci\00F3n que utiliza la aplicaci\00F3n (Puertas Abiertas, cuenta de &PRODUCT_NAME. o LDAP).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345927811351078376.4001)
,p_name=>'P4495_PRE_AUTH_PROCESS'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(345924009281078364.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre del Procedimiento Anterior a la Autenticaci\00F3n')
,p_source=>'PRE_AUTH_PROCESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique el nombre del procedimiento que ejecutar\00E1 despu\00E9s de que se ejecute la p\00E1gina de conexi\00F3n y justo antes de que se realice la verificaci\00F3n de credenciales. El procedimiento se puede definir en el atributo <em>C\00F3digo PL/SQL</em> o en la mis')
||'ma base de datos.',
'<p/>',
unistr('Los esquemas de autenticaci\00F3n en los que la comprobaci\00F3n de credenciales se realiza fuera de &PRODUCT_NAME., normalmente no ejecutan el procedimiento de autenticaci\00F3n anterior. Algunos ejemplos son: <em>Variable de Cabecera HTTP</em>, <em>Oracle Appl')
||unistr('ication Server Single Sign-On</em> y esquemas de autenticaci\00F3n personalizados que utilizan <tt>apex_authentication.post_login</tt> en lugar de <tt>apex_authentication.login</tt>.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345944805782081003.4001)
,p_name=>'P4495_USE_SECURE_COOKIE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(345944618631081002.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Proteger'
,p_source=>'USE_SECURE_COOKIE_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para que el explorador env\00EDe la cookie de gesti\00F3n de sesi\00F3n s\00F3lo cuando el protocolo sea HTTPS. '),
unistr('Seleccione <strong>Desactivado</strong> para que el explorador env\00EDe la cookie de gesti\00F3n de sesi\00F3n cuando el protocolo sea HTTP o HTTPS.'),
'</p>',
'<p>',
unistr('Si SSL est\00E1 configurado en el servidor web,'),
unistr('debe seleccionar <strong>Activado</strong> para reforzar la seguridad de la aplicaci\00F3n evitando el tr\00E1fico HTTP no cifrado.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345945321610081005.4001)
,p_name=>'P4495_COOKIE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(345944618631081002.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Cookie'
,p_source=>'COOKIE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de la cookie de sesi\00F3n que se necesita para identificar una sesi\00F3n de &PRODUCT_NAME., junto con el identificador de sesi\00F3n de la URL. Si no se especifica ning\00FAn valor para el nombre de cookie de sesi\00F3n, &PRODUCT_NAME. selecciona un valor por d')
||'efecto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345945819177081005.4001)
,p_name=>'P4495_COOKIE_PATH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(345944618631081002.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Ruta de Acceso de Cookie'
,p_source=>'COOKIE_PATH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributo de ruta de acceso para la cookie de sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345946314278081007.4001)
,p_name=>'P4495_COOKIE_DOMAIN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(345944618631081002.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dominio de Cookie'
,p_source=>'COOKIE_DOMAIN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Atributo de dominio para la cookie de sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(345961832512083848.4001)
,p_name=>'P4495_LOGOUT_URL'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(345961628328083848.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'LOGOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la URL a la que se debe redirigir la aplicaci\00F3n despu\00E9s de que &PRODUCT_NAME. haya limpiado la sesi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(346057922272119929.4001)
,p_name=>'P4495_POST_AUTH_PROCESS'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(345924009281078364.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre del Procedimiento Posterior a la Autenticaci\00F3n')
,p_source=>'POST_AUTH_PROCESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifique el nombre del procedimiento que ejecutar\00E1 el procedimiento de conexi\00F3n (API de conexi\00F3n) de &PRODUCT_NAME. despu\00E9s del paso de autenticaci\00F3n (verificaci\00F3n de credenciales de conexi\00F3n).'),
unistr('El procedimiento de conexi\00F3n ejecutar\00E1 este c\00F3digo despu\00E9s de verificar las credenciales del usuario,'),
unistr('pero antes de registrar el usuario en la sesi\00F3n y redireccionarse a la p\00E1gina de aplicaci\00F3n deseada.'),
unistr('El procedimiento se puede definir en el atributo "C\00F3digo PL/SQL" o en la propia base de datos.'),
'</p>',
'<p>',
'En el ejemplo siguiente se elimina el dominio del nombre de usuario autenticado, por ejemplo, transforma <code>JOHNDOE@EXAMPLE.COM</code> en <code>JOHNDOE</code>:',
'<pre>',
'apex_custom_auth.set_user (',
'    p_user => regexp_replace(:APP_USER, ''@.*'', null) );',
'</pre>    ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(346898909384210784.4001)
,p_name=>'P4495_SCHEME_TYPE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(345889721617072434.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Esquema'
,p_source=>'SCHEME_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHENTICATION_SCHEME_TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHENTICATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHENTICATION TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo se aplicar\00E1 este esquema de autenticaci\00F3n. Se soportan los siguientes tipos incorporados (se pueden ampliar mediante plugins):</p>'),
'<ul>',
unistr('<li><strong>Credenciales de puertas abiertas</strong>: Permiten a cualquier usuario acceder a la aplicaci\00F3n mediante una p\00E1gina de conexi\00F3n que capture un nombre de usuario.</li>'),
unistr('<li><strong>Cuentas de &PRODUCT_NAME.</strong>: Las credenciales de cuenta de &PRODUCT_NAME. son cuentas de usuario internas (tambi\00E9n denominadas cuentas de "usuario de cookie") creadas y gestionadas en el repositorio de usuarios de &PRODUCT_NAME. Al')
||unistr(' utilizar este m\00E9todo, la aplicaci\00F3n se autentica con estas cuentas.</li>'),
unistr('<li><strong>Cuentas de base de datos</strong>: Este esquema de autenticaci\00F3n necesita que exista un usuario de base de datos (esquema) en la base de datos local. Al utilizar este m\00E9todo, se utilizan el nombre de usuario y la contrase\00F1a de la cuenta d')
||'e la base de datos para autenticar el usuario.</li>',
unistr('<li><strong>Directorio LDAP</strong>. Autenticaci\00F3n de usuario/contrase\00F1a con una solicitud de autenticaci\00F3n a un servidor LDAP.</li>'),
unistr('<li><strong>Sin Autenticaci\00F3n (utilizando DAD)</strong>. Adopta el usuario de base de datos actual.</li>'),
unistr('<li><strong>Oracle Application Server Single Sign-On</strong>. Delega la autenticaci\00F3n al servidor de Oracle AS Single Sign-On (SSO). Para utilizar este esquema de autenticaci\00F3n, el sitio debe estar registrado como aplicaci\00F3n asociada de mod_osso con')
||' el servidor SSO y debe haber un SDK de SSO PL/SQL instalado en la base de datos.</li>',
unistr('<li><strong>Personalizado</strong>. Permite crear un esquema de autenticaci\00F3n personalizado desde cero, lo que le permite tener un control total sobre su interfaz de autenticaci\00F3n.</li>'),
unistr('<li><strong>Variable de cabecera HTTP</strong>. Autenticaci\00F3n externa, en la que el nombre de usuario se almacena en una variable de cabecera HTTP definida por el servidor web.'),
unistr('<li><strong>Conexi\00F3n SAML</strong>. Soporta la autenticaci\00F3n con un proveedor de identidad de SAML2. En primer lugar, los administradores de instancia deben activar este esquema de autenticaci\00F3n e introducir los par\00E1metros de configuraci\00F3n. </li>'),
unistr('<li><strong>Inicio de sesi\00F3n en medios sociales</strong>. Soporta la autenticaci\00F3n con los proveedores de identidad Google, Facebook, OpenID Connect gen\00E9rico y OAuth2 gen\00E9rico.</li>  '),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(348704930096404032.4001)
,p_name=>'P4495_COMMENTS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(348704723086404030.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecer\00E1n nunca cuando se est\00E9 ejecutando la aplicaci\00F3n.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(364146420886050573.4001)
,p_name=>'P4495_INVALID_SESSION_TYPE'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(462984315510460759.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'LOGIN'
,p_prompt=>'Ir a:'
,p_source=>'INVALID_SESSION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4495_INVALID_SESSION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(364180307858056288.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica a d\00F3nde se redirecciona &PRODUCT_NAME. si la sesi\00F3n no es v\00E1lida. Esto sucede si la funci\00F3n de protecci\00F3n o la funci\00F3n de verificaci\00F3n devuelve un valor falso, en solicitudes de p\00E1ginas normales (no en solicitudes AJAX).</p>'),
'',
unistr('<p>Nota: Si se utiliza el tipo de esquema de autenticaci\00F3n "Personalizado", la funci\00F3n de protecci\00F3n es una propiedad disponible en el esquema de autenticaci\00F3n. Para los tipos de esquema de autenticaci\00F3n de plugin, lo define el desarrollador de plugi')
||unistr('ns en la devoluci\00F3n de llamada de funci\00F3n de protecci\00F3n de sesi\00F3n.</p>'),
'',
'<ul>',
unistr('<li><strong>P\00E1gina de conexi\00F3n</strong>: URL de conexi\00F3n definida en las propiedades de la aplicaci\00F3n.</li>'),
unistr('<li><strong>P\00E1gina de conexi\00F3n incorporada</strong>: el valor <code>wwv_flow_custom_auth_std.login_page</code> proporcionado por &PRODUCT_NAME.</li>'),
'<li><strong>URL</strong>: especifique una URL personalizada, por ejemplo, <code>/login.html</code> o <code>f?p=&amp;APP_ID.:101:&amp;APP_SESSION.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(369399109064719016.4001)
,p_name=>'P4495_LOGOUT_TYPE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(345961628328083848.4001)
,p_item_default=>'HOME'
,p_prompt=>'Ir a:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4495_LOGOUT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(369466420839722403.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique a d\00F3nde se debe redireccionar &PRODUCT_NAME. despu\00E9s de la desconexi\00F3n.'),
'<ul>',
unistr('<li>P\00E1gina Inicial. Valor de Enlace de P\00E1gina Inicial en las propiedades de la aplicaci\00F3n.</li>'),
'<li>URL. Se muestra un elemento adicional donde puede introducir cualquier URL, por ejemplo, f?p=&amp;APP_ID.:1</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(372342614689051784.4001)
,p_name=>'P4495_RETURN_TO_PAGE'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(350195718995582647.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(378152604158663779.4001)
,p_name=>'P4495_VERIFICATION_FUNCTION'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(345906632699075659.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Nombre de Funci\00F3n de Verificaci\00F3n')
,p_source=>'VERIFICATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca el nombre de la funci\00F3n a la que se llama despu\00E9s de que se haya realizado correctamente la funci\00F3n de protecci\00F3n de sesi\00F3n.'),
unistr('La funci\00F3n se puede definir en el atributo "C\00F3digo PL/SQL" o directamente en la base de datos.'),
unistr('Su resultado booleano determina si la sesi\00F3n es a\00FAn v\00E1lida o no.'),
unistr('Esta funci\00F3n se puede utilizar por ejemplo para restringir el uso de una aplicaci\00F3n a determinadas horas laborables.'),
'</p>',
'<p>',
'Ejemplo:',
'<pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(414185518003152116.4001)
,p_name=>'P4495_SWITCH_IN_SESSION_YN'
,p_is_required=>true
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(345924009281078364.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>unistr('Cambiar en sesi\00F3n')
,p_source=>'SWITCH_IN_SESSION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para activar el cambio del esquema de autenticaci\00F3n por defecto a este esquema en la sesi\00F3n de &PRODUCT_NAME. actual. Seleccione <strong>Desactivado</strong> si el esquema de autenticaci\00F3n no se debe activar en ti')
||unistr('empo de ejecuci\00F3n.'),
'</p><p>',
unistr('Si se activa, el esquema de autenticaci\00F3n de la sesi\00F3n actual se puede cambiar transfiriendo <strong>APEX_AUTHENTICATION=scheme name</strong> en un par\00E1metro de solicitud de URL.'),
'</p>',
'<h3>Ejemplo</h3>',
'<p>',
unistr('El desarrollador agrega un bot\00F3n con la etiqueta "Conectar con OAuth2" a la p\00E1gina de conexi\00F3n de la aplicaci\00F3n, lo que redirige a'),
'<pre>',
'f?p=&amp;APP_ID.:1:&amp;APP_SESSION.:APEX_AUTHENTICATION=OAuth2-Scheme',
'</pre>',
unistr('donde "OAuth2-Scheme" es el nombre del esquema de autenticaci\00F3n. Al procesar la solicitud (y asumiendo que "Cambiar en sesi\00F3n" est\00E1 activado), &PRODUCT_NAME. registra el esquema en la sesi\00F3n y lo utiliza para todas las solicitudes futuras.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(530943827162934913.4001)
,p_name=>'P4495_CHECK_PLSQL_CODE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(530943617040934909.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLSQL_VALIDATION'
,p_lov=>'.'||wwv_flow_api.id(111144330433082822.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(530944009026934914.4001)
,p_name=>'P4495_PLSQL_CODE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(530943617040934909.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('C\00F3digo PL/SQL')
,p_source=>'PLSQL_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un bloque de c\00F3digo PL/SQL an\00F3nimo que contenga funciones y procedimientos para verificar si la sesi\00F3n es v\00E1lida, los puntos anteriores y posteriores a la autenticaci\00F3n y otros puntos de entrada de autenticaci\00F3n.</p>'),
'',
unistr('<p>Por motivos de rendimiento, tambi\00E9n puede almacenar este c\00F3digo en un paquete PL/SQL en la base de datos.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTIONS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(377859318657639619.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4495_LOGOUT_TYPE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P4495_LOGOUT_URL is null then ''HOME'' else ''URL'' end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(345977422225091560.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4495_COOKIE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P4495_COOKIE_NAME,'' '',''_''))'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1147516411224072964.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4495_USE_SECURE_COOKIE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4495_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(315550412221501053.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4495_PAGE_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'NORMAL'
,p_compute_when=>'P4495_PAGE_MODE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(374153603803237837.4001)
,p_validation_name=>'Is current scheme'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and authentication_id = :P4495_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El esquema de autenticaci\00F3n seleccionado es el esquema de autenticaci\00F3n actual de la aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(349533325173480285.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(345788224582052346.4001)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name       => :P4495_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4495_'',',
'        p_user_interface_id => null );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(462266921407188030.4001)
,p_validation_name=>'Invalid Session URL is not null'
,p_validation_sequence=>30
,p_validation=>'P4495_INVALID_SESSION_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>'P4495_INVALID_SESSION_TYPE'
,p_validation_condition2=>'URL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(345908228187075663.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(531003323966936870.4001)
,p_validation_name=>'check PL/SQL syntax'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql (',
'           p_sql               => ''declare''||chr(10)||:P4495_PLSQL_CODE||chr(10)||''begin null; end;'',',
'           p_flow_id           => :P4495_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P4495_CHECK_PLSQL_CODE, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(530944009026934914.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1145735812704429996.4001)
,p_name=>'Show/Hide Source'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_SCHEME_TYPE'
,p_condition_element=>'P4495_SCHEME_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_CUSTOM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P4495_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1145736113257429997.4001)
,p_event_id=>wwv_flow_api.id(1145735812704429996.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(530943617040934909.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1145736316248429998.4001)
,p_event_id=>wwv_flow_api.id(1145735812704429996.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(530943617040934909.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(364705910637132731.4001)
,p_name=>'Invalid Session Type = URL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_INVALID_SESSION_TYPE'
,p_condition_element=>'P4495_INVALID_SESSION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364371805632082974.4001)
,p_event_id=>wwv_flow_api.id(364705910637132731.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_INVALID_SESSION_URL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(364706229305132731.4001)
,p_event_id=>wwv_flow_api.id(364705910637132731.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_INVALID_SESSION_URL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(368053200388565038.4001)
,p_name=>'Confirm Make Current'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(367654722935524231.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(368053514510565040.4001)
,p_event_id=>wwv_flow_api.id(368053200388565038.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFDesea convertir &#x27;&P4495_NAME.&#x27; en el esquema de autenticaci\00F3n actual de la aplicaci\00F3n?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(368146920474570916.4001)
,p_event_id=>wwv_flow_api.id(368053200388565038.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'MAKE_CURRENT'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(369613519238731420.4001)
,p_name=>'Logout Type = URL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_LOGOUT_TYPE'
,p_condition_element=>'P4495_LOGOUT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(369613816315731421.4001)
,p_event_id=>wwv_flow_api.id(369613519238731420.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_LOGOUT_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(369614017428731421.4001)
,p_event_id=>wwv_flow_api.id(369613519238731420.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_LOGOUT_URL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(29416016725040869.4001)
,p_name=>'Show/hide LDAP Test'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_SCHEME_TYPE'
,p_condition_element=>'P4495_SCHEME_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_LDAP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29416302656040878.4001)
,p_event_id=>wwv_flow_api.id(29416016725040869.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(29414822038032931.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(29416722241048043.4001)
,p_event_id=>wwv_flow_api.id(29416016725040869.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(29414822038032931.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(125819924873349888.4001)
,p_name=>'Enable/Disable RAS attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_RAS_MODE'
,p_condition_element=>'P4495_RAS_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(125820217815349896.4001)
,p_event_id=>wwv_flow_api.id(125819924873349888.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_RAS_DYNAMIC_ROLES,P4495_RAS_NAMESPACES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(125820425507349898.4001)
,p_event_id=>wwv_flow_api.id(125819924873349888.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_RAS_DYNAMIC_ROLES,P4495_RAS_NAMESPACES'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(342360905305652526.4001)
,p_name=>'When C'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_COOKIE_TYPE'
,p_condition_element=>'P4495_COOKIE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'C'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(342361013070652527.4001)
,p_event_id=>wwv_flow_api.id(342360905305652526.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_COOKIE_NAME,P4495_COOKIE_PATH,P4495_COOKIE_DOMAIN,P4495_USE_SECURE_COOKIE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(342361203414652529.4001)
,p_event_id=>wwv_flow_api.id(342360905305652526.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_COOKIE_NAME,P4495_COOKIE_PATH,P4495_COOKIE_DOMAIN,P4495_USE_SECURE_COOKIE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(462442818646262938.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cleanup'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if wwv_flow_plugin_dev.has_standard_attribute (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_type    => wwv_flow_plugin.c_plugin_type_authentication,',
'           p_plugin_name    => :P4495_SCHEME_TYPE,',
'           p_feature        => ''INVALID_SESSION'' )',
'    then',
'        :P4495_INVALID_SESSION_TYPE := nvl(:P4495_INVALID_SESSION_TYPE, ''LOGIN'');',
'    else',
'        :P4495_INVALID_SESSION_TYPE := null;',
'    end if;',
'',
'    -- if it''s not a URL type, clear the page item',
'    if nvl(:P4495_INVALID_SESSION_TYPE, ''PAGE'') <> ''URL'' then',
'        :P4495_INVALID_SESSION_URL := null;',
'    end if;',
'',
'    -- if it''s not a URL type, clear the page item',
'    if nvl(:P4495_LOGOUT_TYPE, ''PAGE'') <> ''URL'' then',
'        :P4495_LOGOUT_URL := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(342361487079652531.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Cookie Attributes Based On Type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4495_COOKIE_NAME       := case :P4495_COOKIE_TYPE',
'                            when ''W'' then ''&''||''WORKSPACE_COOKIE.''',
'                            end;',
':P4495_COOKIE_PATH       := null;',
':P4495_COOKIE_DOMAIN     := null;',
':P4495_USE_SECURE_COOKIE := ''N'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4495_COOKIE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'C'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203930117076288833.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name       => :P4495_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4495_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(345788508103052347.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_AUTHENTICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHENTICATIONS'
,p_attribute_03=>'P4495_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'P4495_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(401476602790283024.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Login Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_ui in ( select id',
'                    from wwv_flow_user_interfaces i',
'                   where flow_id           = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and not exists (',
'                         select 1',
'                           from wwv_flow_steps p',
'                          where flow_id           = :FB_FLOW_ID',
'                            and security_group_id = :WORKSPACE_ID',
'                            and user_interface_id = i.id',
'                            and upper(alias)      like ''LOGIN%'' )',
'                )',
'    loop',
'        wwv_flow_wizard_api.create_login_page2 (',
'            p_fb_flow_id        => :FB_FLOW_ID,',
'            p_user_interface_id => l_ui.id );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from dual',
' where :P4495_INVALID_SESSION_TYPE = ''LOGIN''',
'   and not exists ( select 1',
'                      from wwv_flow_steps',
'                     where flow_id           = :FB_FLOW_ID',
'                       and security_group_id = :WORKSPACE_ID',
'                       and upper(alias)      like ''LOGIN%''',
'                  )'))
,p_process_when_type=>'EXISTS'
,p_process_success_message=>unistr('P\00E1gina de conexi\00F3n creada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(346412714831155629.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh plugin (with apply changes)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_authentication (',
'    p_master_auth_id      => :P4495_REFERENCE_ID,',
'    p_subscribing_auth_id => :P4495_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P4495_REFERENCE_ID is not null and :P4495_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Esquema de autenticaci\00F3n refrescado.')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(346457011845164169.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh plugin (manual)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_authentication (',
'    p_master_auth_id      => :P4495_REFERENCE_ID,',
'    p_subscribing_auth_id => :P4495_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(345874024900069245.4001)
,p_process_when=>'P4495_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>unistr('Esquema de autenticaci\00F3n refrescado.')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(368499211432615551.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Make Current Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    update wwv_flows',
'       set authentication_id = :P4495_ID,',
'           authentication    = ''PLUGIN''',
'     where id                = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE:MAKE_CURRENT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Esquema de autenticaci\00F3n activado como esquema de autenticaci\00F3n actual.')
,p_security_scheme=>wwv_flow_api.id(317822338466)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(345788330523052347.4001)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_AUTHENTICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHENTICATIONS'
,p_attribute_03=>'P4495_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2203930263809288834.4001)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name       => :P4495_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04500
begin
wwv_flow_api.create_page(
 p_id=>4500.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Dise\00F1ador de P\00E1ginas')
,p_step_title=>unistr('Dise\00F1ador de P\00E1ginas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#JQUERYUI_DIRECTORY#ui/widgets/#MIN_DIRECTORY#tabs#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#commandHistory#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#templateOptionsHelper#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#pe.model#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p4500#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#pe.callbacks#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.peMessagesView#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.peSearch#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#gridlayout#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.gallery#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.tree#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.dump#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.propertyEditor#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.lovDialog#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.pdPropertyEditor#MIN#.js',
'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.glv#MIN#.js',
'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.colorpicker#MIN#.js',
'[require requirejs]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.toolbar#MIN#.js',
'[require requirejs]#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js'))
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_step_template=>wwv_flow_api.id(384711093594980574.4001)
,p_page_css_classes=>'apex-page-designer'
,p_required_role=>wwv_flow_api.id(74845831538733642)
,p_help_text=>'bldr_pg_def_about.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3705300509478.4001)
,p_plug_name=>'APEX 5 Main Control Bar'
,p_region_css_classes=>'a-ControlBar apex-app-builder a-Toolbar--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3700518577643.4001)
,p_plug_name=>'Control Bar - Page Select Region'
,p_parent_plug_id=>wwv_flow_api.id(3705300509478.4001)
,p_region_css_classes=>'a-ControlBar-col'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3700537613973.4001)
,p_plug_name=>'Page Select Form'
,p_parent_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_region_css_classes=>'a-PageSelect'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(''<button id="go_to_page_lov" class="a-Button a-Button--noUI a-Button--noLabel a-PageSelect-menuButton" type="button" title="''||wwv_flow_lang.system_message(''APEX.POPUP_LOV.ICON_TEXT'', wwv_flow_lang.system_message(''PAGE_FINDER''))||''" aria-'
||'label="''||wwv_flow_lang.system_message(''APEX.POPUP_LOV.ICON_TEXT'', wwv_flow_lang.system_message(''PAGE_FINDER''))||''">'');',
'sys.htp.prn(''<span class="a-Icon icon-page" aria-hidden="true"></span>'');',
'sys.htp.prn(''<span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span>'');',
'sys.htp.prn(''</button>'');',
'sys.htp.prn(''<label for="go_to_page" class="visuallyhidden">''||wwv_flow_lang.system_message(''PAGE_FINDER'')||''</label>'');',
'sys.htp.prn(''<input type="text" id="go_to_page" class="a-PageSelect-input" value="''||:FB_FLOW_PAGE_ID||''"/>'');',
'sys.htp.p(''<div class="a-PageSelect-buttons">'');',
'sys.htp.p(''<button type="button" class="a-Button a-Button--pageNav a-Button--icon a-Button--noLabel js-actionButton" data-action="pd-goto-next-page" id="pd_next_page" aria-label="''||wwv_flow_lang.message(''PD.NAV_NEXT_PAGE'')||''" title="''||wwv_flow_lan'
||'g.message(''PD.NAV_NEXT_PAGE'')||''"><span class="a-Icon icon-up-chevron" aria-hidden="true"></span></button>'');',
'sys.htp.p(''<button type="button" class="a-Button a-Button--pageNav a-Button--icon a-Button--noLabel js-actionButton" data-action="pd-goto-prev-page" id="pd_prev_page" aria-label="''||wwv_flow_lang.message(''PD.NAV_PREV_PAGE'')||''" title="''||wwv_flow_lan'
||'g.message(''PD.NAV_PREV_PAGE'')||''"><span class="a-Icon icon-down-chevron" aria-hidden="true"></span></button>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3734482699681.4001)
,p_plug_name=>'Create Menu'
,p_region_name=>'createMenu'
,p_parent_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(3734458575652.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3767961827915.4001)
,p_plug_name=>'Utilitiies Menu'
,p_region_name=>'utilitiesMenu'
,p_parent_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(3741507057557.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(3712705120335.4001)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48577912101738240.4001)
,p_plug_name=>unistr('Ruta de Navegaci\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(3705300509478.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_api.id(6341600034528019.4001)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(3705314539083.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3707738215039.4001)
,p_plug_name=>'Global JavaScript variables'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_allow_team_dev varchar2( 1 );',
'begin',
'    sys.htp.p(''<script type="text/javascript">'');',
'',
'    select /*+ result_cache */',
'           nvl( allow_team_development_yn, ''Y'' )',
'      into l_allow_team_dev',
'      from wwv_flow_companies',
'     where provisioning_company_id = :WORKSPACE_ID;',
'     ',
'    sys.htp.p(',
'        ''var gTeamDevEnabled = '' || wwv_flow_javascript.add_value( l_allow_team_dev = ''Y'', false ) ||',
'        '', gBuilderLang = '' || wwv_flow_escape.js_literal( wwv_flow.g_flow_language ) ||',
'        '', gIsInternal  = '' || wwv_flow_javascript.add_value( :WORKSPACE_ID = 10, false ) ||',
'        '', gIsReadOnly  = '' || wwv_flow_javascript.add_value( false, false ) ||',
'        '', gLanguage    = '' || wwv_flow_javascript.add_value( wwv_flow.g_flow_language, false ) ||',
'        '', gApexVersion = '' || wwv_flow_javascript.add_value( wwv_flows_release, false ) ||',
'        '';'' );',
'',
'    wwv_flow_json.initialize_clob_output;',
'    wwv_flow_json.open_object;',
'    for l_preferences in ( select preference_name,',
'                                  attribute_value',
'                             from wwv_flow_preferences$',
'                            where user_id = wwv_flow.g_user',
'                              and security_group_id = :WORKSPACE_ID',
'                              and preference_name in ( ''PD_PE_KEEP_LABELS_ABOVE'',',
'                                                       ''PD_PE_SHOW_ALL'',',
'                                                       ''PD_GAL_SHOW_UNSUP'',',
'                                                       ''PD_GAL_CUR_TAB'',',
'                                                       ''PD_GLV_HIDE_LEGACY'',',
'                                                       ''PD_GLV_HIDE_GLOBAL'',',
'                                                       ''PD_GLV_HIDE_BTNS'',',
'                                                       ''PD_GLV_HIDE_ITEMS'',',
'                                                       ''PD_GLV_HIDE_EMPTY'',',
'                                                       ''PD_TAB_LAYOUT_2'',',
'                                                       ''PD_TAB_LAYOUT_3'',',
'                                                       ''PD_TWO_COLUMN_MODE'',',
'                                                       ''CODE_EDITOR_SETTINGS'',',
'                                                       ''CODE_LANGUAGE'',',
'                                                       ''PD_PE_CODE_EDITOR_DLG_W'',',
'                                                       ''PD_PE_CODE_EDITOR_DLG_H'',',
'                                                       ''PD_GROUP_BY_COMPONENT_TYPE'',',
'                                                       ''PD_ENABLE_TOOLTIPS'',',
'                                                       ''PD_ENABLE_LAYOUT_VIEW'') )',
'    loop',
'        wwv_flow_json.write(l_preferences.preference_name, l_preferences.attribute_value);',
'    end loop;',
'    wwv_flow_json.close_object;',
'    ',
'    sys.htp.prn(''var gPreferences = '' || wwv_flow_json.get_clob_output(p_free => true) || '';'');',
'    sys.htp.p(''</script>'');',
'',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3710342843565.4001)
,p_plug_name=>'Lock Dialog'
,p_region_name=>'lockDialog'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(461857790551605627.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_06'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p id="lockDialogIntroUnlocked">Al bloquear una p\00E1gina, se le proporciona acceso exclusivo para realizar modificaciones en la p\00E1gina y sus componentes. Otros desarrolladores no pueden cambiar la p\00E1gina hasta que la desbloquee. Puede introducir un com')
||unistr('entario para permitir que otros desarrolladores conozcan el motivo por el que ha bloqueado la p\00E1gina.</p>'),
unistr('<p id="lockDialogIntroOwned">Ha bloqueado esta p\00E1gina. Puede desbloquear la p\00E1gina para permitir a otros desarrolladores realizar cambios en la misma o puede actualizar el comentario de bloqueo.</p>'),
unistr('<p id="lockDialogIntroLocked">Otro desarrollador ha bloqueado actualmente esta p\00E1gina. No podr\00E1 editar esta p\00E1gina hasta que la haya desbloqueado.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48564602512738202.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(150655275868720205.4001)
,p_plug_name=>'Message Dialog'
,p_region_name=>'pdMessagesDialog'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>'<div id="pdMessages" class="padding-md"></div>'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203904827661009901.4001)
,p_plug_name=>'[Splitter] Main'
,p_region_name=>'sp_main'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_api.id(177373906751600776.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attribute_01=>'#sp_main_content'
,p_attribute_02=>'horizontal'
,p_attribute_03=>'begin'
,p_attribute_04=>'290'
,p_attribute_05=>'N'
,p_attribute_08=>'280'
,p_attribute_09=>'N'
,p_attribute_12=>'Divisor Izquierdo'
,p_attribute_13=>'Y'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203905025078009915.4001)
,p_plug_name=>'Page Elements'
,p_region_name=>'left_col'
,p_parent_plug_id=>wwv_flow_api.id(203904827661009901.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(226071526010722245.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203905223102009916.4001)
,p_plug_name=>'Page Elements - Container'
,p_parent_plug_id=>wwv_flow_api.id(203905025078009915.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340563172981198341.4001)
,p_plug_name=>'Left Column Tree'
,p_region_name=>'trees'
,p_parent_plug_id=>wwv_flow_api.id(203905223102009916.4001)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1094670710611261973.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340563217684198342.4001)
,p_plug_name=>unistr('Presentaci\00F3n')
,p_region_name=>'renderTree_container'
,p_parent_plug_id=>wwv_flow_api.id(1340563172981198341.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-rendering'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(280299836211526841.4001)
,p_plug_name=>'Rendering Toolbar'
,p_parent_plug_id=>wwv_flow_api.id(1340563217684198342.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1494054703785077894.4001)
,p_plug_name=>unistr('Presentaci\00F3n')
,p_region_name=>'r_rendering_tree'
,p_parent_plug_id=>wwv_flow_api.id(1340563217684198342.4001)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="PDrenderingTree"></div>'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340563351308198343.4001)
,p_plug_name=>unistr('Acciones Din\00E1micas')
,p_region_name=>'dynActTree_container'
,p_parent_plug_id=>wwv_flow_api.id(1340563172981198341.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-dynact'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(280299977196526842.4001)
,p_plug_name=>'Dynamic Actions Toolbar'
,p_parent_plug_id=>wwv_flow_api.id(1340563351308198343.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1494055203061088419.4001)
,p_plug_name=>unistr('Acciones Din\00E1micas')
,p_region_name=>'r_da_tree'
,p_parent_plug_id=>wwv_flow_api.id(1340563351308198343.4001)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="PDdynamicActionTree"></div>'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340563430729198344.4001)
,p_plug_name=>'Procesamiento'
,p_region_name=>'procTree_container'
,p_parent_plug_id=>wwv_flow_api.id(1340563172981198341.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-processing'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(280300071991526843.4001)
,p_plug_name=>'Processing Toolbar'
,p_parent_plug_id=>wwv_flow_api.id(1340563430729198344.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1494055572937094000.4001)
,p_plug_name=>'Procesamiento'
,p_region_name=>'r_processing_tree'
,p_parent_plug_id=>wwv_flow_api.id(1340563430729198344.4001)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="PDprocessingTree"></div>'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340563522501198345.4001)
,p_plug_name=>unistr('Componentes Compartidos de P\00E1gina')
,p_region_name=>'sharedComp_container'
,p_parent_plug_id=>wwv_flow_api.id(1340563172981198341.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-shared-components'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(280300175072526844.4001)
,p_plug_name=>'Page Shared Components Toolbar'
,p_parent_plug_id=>wwv_flow_api.id(1340563522501198345.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1493954211520964691.4001)
,p_plug_name=>unistr('Componentes Compartidos de P\00E1gina')
,p_region_name=>'r_shared_comp_tree'
,p_parent_plug_id=>wwv_flow_api.id(1340563522501198345.4001)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="PDsharedCompTree"></div>'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203906404237009921.4001)
,p_plug_name=>'[Splitter] Right'
,p_region_name=>'sp_right'
,p_parent_plug_id=>wwv_flow_api.id(203904827661009901.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(177373906751600776.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attribute_01=>'#sp_right_content'
,p_attribute_02=>'horizontal'
,p_attribute_03=>'end'
,p_attribute_04=>'290'
,p_attribute_05=>'N'
,p_attribute_08=>'200'
,p_attribute_09=>'N'
,p_attribute_12=>'Divisor Derecho'
,p_attribute_13=>'Y'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203907003331009924.4001)
,p_plug_name=>'Primary Editor'
,p_region_name=>'top_col'
,p_parent_plug_id=>wwv_flow_api.id(203906404237009921.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(226071526010722245.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203907206229009924.4001)
,p_plug_name=>'Editor Tabs'
,p_region_name=>'editor_tabs'
,p_parent_plug_id=>wwv_flow_api.id(203907003331009924.4001)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs a-Tabs--pageDesignerPrimaryTabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1094670710611261973.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(113729401479047174.4001)
,p_plug_name=>'Dump'
,p_region_name=>'dump'
,p_parent_plug_id=>wwv_flow_api.id(203907206229009924.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="dumpContent" style="height: 100%; overflow: auto;"></div>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(142989453942607541.4001)
,p_plug_name=>'Mensajes'
,p_region_name=>'messages'
,p_parent_plug_id=>wwv_flow_api.id(203907206229009924.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-messages'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="messages-container" class="resize u-ScrollingViewport"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Set to Condition NEVER by Shakeeb on 12-4-2019. We moved Messages into an inline dialog for 20.1. Will delete this region once I demo to team.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203907414821009925.4001)
,p_plug_name=>unistr('Dise\00F1o')
,p_region_name=>'grid_layout'
,p_parent_plug_id=>wwv_flow_api.id(203907206229009924.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203907623449009926.4001)
,p_plug_name=>'Layout Toolbar'
,p_parent_plug_id=>wwv_flow_api.id(203907414821009925.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar-pageColumn--gridLayout a-Toolbar--simple'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157687726908338238.4001)
,p_plug_name=>'[Divisor] GLV'
,p_region_name=>'sp_glv'
,p_parent_plug_id=>wwv_flow_api.id(203907414821009925.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(177373906751600776.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'#sp_glv_content'
,p_attribute_02=>'vertical'
,p_attribute_03=>'end'
,p_attribute_04=>'200'
,p_attribute_05=>'N'
,p_attribute_08=>'140'
,p_attribute_09=>'N'
,p_attribute_12=>unistr('Divisor de Galer\00EDa')
,p_attribute_13=>'Y'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203921031629597761.4001)
,p_plug_name=>'Drag and Drop Editor'
,p_region_name=>'glv-viewport-container'
,p_parent_plug_id=>wwv_flow_api.id(1157687726908338238.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="glv-viewport" class="dark-scroll resize u-ScrollingViewport a-GridLayout-wrapper">',
'  <div id="glv"></div>',
'</div>',
'<div id="glvMenu"></div>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1157688004078338241.4001)
,p_plug_name=>'TabHolder'
,p_parent_plug_id=>wwv_flow_api.id(1157687726908338238.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'For proper sizing tabs must be in a container div that is sized.'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203912509681231815.4001)
,p_plug_name=>unistr('Galer\00EDa')
,p_region_name=>'gallery-tabs'
,p_parent_plug_id=>wwv_flow_api.id(1157688004078338241.4001)
,p_region_css_classes=>'resize ui-tabs--subTabButtons a-Toolbar--simple'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(183219627032331552.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3694511958291.4001)
,p_plug_name=>'Regiones'
,p_region_name=>'cg-regions'
,p_parent_plug_id=>wwv_flow_api.id(203912509681231815.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3694514965509.4001)
,p_plug_name=>'Elementos'
,p_region_name=>'cg-items'
,p_parent_plug_id=>wwv_flow_api.id(203912509681231815.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
begin
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3694524975718.4001)
,p_plug_name=>'Botones'
,p_region_name=>'cg-buttons'
,p_parent_plug_id=>wwv_flow_api.id(203912509681231815.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(226343526195304018.4001)
,p_plug_name=>'Ayuda'
,p_region_name=>'help'
,p_parent_plug_id=>wwv_flow_api.id(203907206229009924.4001)
,p_icon_css_classes=>'icon-help'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="help-container" class="a-HelpRegion resize u-ScrollingViewport"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(361877912555473789.4001)
,p_plug_name=>unistr('B\00FAsqueda de P\00E1gina')
,p_region_name=>'search'
,p_parent_plug_id=>wwv_flow_api.id(203907206229009924.4001)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3344151064196342.4001)
,p_plug_name=>unistr('Barra de Herramientas de B\00FAsqueda')
,p_parent_plug_id=>wwv_flow_api.id(361877912555473789.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar-pageColumn--search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3344283174196343.4001)
,p_plug_name=>unistr('Barra de B\00FAsqueda')
,p_parent_plug_id=>wwv_flow_api.id(3344151064196342.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn--searchBar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3344377146196344.4001)
,p_plug_name=>unistr('Opciones de b\00FAsqueda')
,p_parent_plug_id=>wwv_flow_api.id(3344151064196342.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn--searchOptions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3344471875196345.4001)
,p_plug_name=>unistr('Resultados de la B\00FAsqueda')
,p_region_name=>'search-container'
,p_parent_plug_id=>wwv_flow_api.id(361877912555473789.4001)
,p_region_css_classes=>'resize u-ScrollingViewport'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'aria-live="polite"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1341168555477845045.4001)
,p_plug_name=>'Right Column Pane'
,p_region_name=>'right_col'
,p_parent_plug_id=>wwv_flow_api.id(203906404237009921.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(226071526010722245.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1524154516324670408.4001)
,p_plug_name=>'Property Editor Tabs'
,p_region_name=>'peTabs'
,p_parent_plug_id=>wwv_flow_api.id(1341168555477845045.4001)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(183219627032331552.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7800382557215003.4001)
,p_plug_name=>'Attributes'
,p_region_name=>'peAttributesTabPanel'
,p_parent_plug_id=>wwv_flow_api.id(1524154516324670408.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7800501277215005.4001)
,p_plug_name=>'Property Editor - Attributes'
,p_parent_plug_id=>wwv_flow_api.id(7800382557215003.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="peAttributes" class="resize"></div>',
'<div id="pe_attributes_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7800658140215006.4001)
,p_plug_name=>'Property Editor Attributes Toolbar'
,p_region_name=>'peAttributesToolbar'
,p_parent_plug_id=>wwv_flow_api.id(7800382557215003.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7800873921215008.4001)
,p_plug_name=>'Printing'
,p_region_name=>'pePrintingTabPanel'
,p_parent_plug_id=>wwv_flow_api.id(1524154516324670408.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7800994639215009.4001)
,p_plug_name=>'Property Editor Attributes Toolbar'
,p_region_name=>'pePrintingToolbar'
,p_parent_plug_id=>wwv_flow_api.id(7800873921215008.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7801104432215011.4001)
,p_plug_name=>'Property Editor - Printing'
,p_parent_plug_id=>wwv_flow_api.id(7800873921215008.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="pePrinting" class="resize"></div>',
'<div id="pe_printing_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1524154122429670404.4001)
,p_plug_name=>'Component Properties'
,p_region_name=>'peComponentProperties'
,p_parent_plug_id=>wwv_flow_api.id(1524154516324670408.4001)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1341168630800845046.4001)
,p_plug_name=>'Property Editor Toolbar'
,p_region_name=>'peMainToolbar'
,p_parent_plug_id=>wwv_flow_api.id(1524154122429670404.4001)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795802901076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1524154068172670403.4001)
,p_plug_name=>'Property Editor'
,p_parent_plug_id=>wwv_flow_api.id(1524154122429670404.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="peMain" class="resize"></div>',
'<div id="pe_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385808069211243605.4001)
,p_plug_name=>unistr('Ejecutar P\00E1gina')
,p_region_name=>'runDialogOpenMsg'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Se han guardado los cambios.</p>',
unistr('<p>Error al abrir un ventana para ejecutar la p\00E1gina.</p>'),
'<p>Si aparece un mensaje bloqueado emergente del explorador, puede selecciona',
'permitir o denegar mensajes emergentes, o simplemente ignorar el mensaje.',
unistr('Este cuadro de di\00E1logo siempre proporciona una segunda oportunidad de ejecutar la p\00E1gina.'),
unistr('Si permite los mensajes emergentes, no volver\00E1 a aparecer este mensaje.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(385808170912243606.4001)
,p_plug_name=>unistr('Enfocar P\00E1gina')
,p_region_name=>'runDialogFocusMsg'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se han guardo los cambios y se ha ejecutado la p\00E1gina.</p>'),
unistr('<p>Error al enfocar la ventana de la aplicaci\00F3n para la p\00E1gina.</p>'),
'<p>Nota: algunos exploradores no permiten que se enfoque un separador en otra ventana',
unistr('si no es el separador activo. Si este es el caso, tendr\00E1 que cambiar manualmente'),
unistr('al separador o ventana de la aplicaci\00F3n.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(651997817665245731.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3344283174196343.4001)
,p_button_name=>'CLEAR_PAGE_SEARCH'
,p_button_static_id=>'CLEAR_PAGE_SEARCH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Borrar'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-remove'
,p_button_cattributes=>'aria-controls="search-container"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7800771314215007.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7800658140215006.4001)
,p_button_name=>'GOTO_GROUP_ATTR'
,p_button_static_id=>'peAttributesGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>'Ir a Grupo'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_attributes_goto_group_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7801034657215010.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(7800994639215009.4001)
,p_button_name=>'GOTO_GROUP_PRINT'
,p_button_static_id=>'pePrintingGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>'Ir a Grupo'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_printing_goto_group_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1157688133261338242.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(280299836211526841.4001)
,p_button_name=>'RENDERING_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Men\00FA Presentaci\00F3n')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDrenderingTreeMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1157688259884338243.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(280299977196526842.4001)
,p_button_name=>'DA_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Men\00FA Acciones Din\00E1micas')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDdynamicActionTreeMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1157688362643338244.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(280300071991526843.4001)
,p_button_name=>'PROCESSING_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Men\00FA Procesamiento')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDprocessingTreeMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1157688604793338247.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(280300175072526844.4001)
,p_button_name=>'SHARED_COMPONENTS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Men\00FA Componentes Compartidos de P\00E1gina')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDsharedCompTreeMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1341168930067845049.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1341168630800845046.4001)
,p_button_name=>'GOTO_GROUP_MAIN'
,p_button_static_id=>'peGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>'Ir a Grupo'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_goto_group_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3694510953653.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(203912509681231815.4001)
,p_button_name=>'GALLERY_MENU'
,p_button_static_id=>'galleryMenuBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Men\00FA Galer\00EDa')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'a-Button--simple '
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="galleryMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(204039413666958409.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(203907623449009926.4001)
,p_button_name=>'GLV_MENU'
,p_button_static_id=>'glvMenuBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>unistr('Men\00FA Dise\00F1o')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'a-Button--simple '
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="glvMenu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(48563428122738189.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'GO'
,p_button_static_id=>'go_to_page_button'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_position=>'NEXT'
,p_button_css_classes=>' a-Button--goToPageButton a-Button--pillEnd'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(150654840937720201.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'SHOW_MESSAGES'
,p_button_static_id=>'pdShowMessagesBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3781715377307.4001)
,p_button_image_alt=>'Mostrar Mensajes'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-pd-messages'
,p_button_cattributes=>'style="display:none"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705913948159.4001)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'LOCK'
,p_button_static_id=>'button-lock'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Bloquear'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapLeft a-Button--simple'
,p_icon_css_classes=>'icon-unlock'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(136021117712580811.4001)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'UNDO'
,p_button_static_id=>'button-undo'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Deshacer'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--pillStart a-Button--gapLeft a-Button--padLeft js-actionButton a-Button--simple'
,p_icon_css_classes=>'icon-undo'
,p_button_cattributes=>'data-action="pd-undo"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(136021815073589540.4001)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'REDO'
,p_button_static_id=>'button-redo'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Rehacer'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--pillEnd js-actionButton a-Button--simple'
,p_icon_css_classes=>'icon-redo'
,p_button_cattributes=>'data-action="pd-redo"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705393924440.4001)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'CREATE_MENU'
,p_button_static_id=>'menu-create'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapLeft a-Button--simple'
,p_icon_css_classes=>'icon-plus'
,p_button_cattributes=>'data-menu="createMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705373911136.4001)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'UTILITIES_MENU'
,p_button_static_id=>'menu-utilities'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3705362896815.4001)
,p_button_image_alt=>'Utilidades'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-tools'
,p_button_cattributes=>'data-menu="utilitiesMenu_menu"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705398937273.4001)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'TEAM_DEV_MENU'
,p_button_static_id=>'menu-team-dev'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3770144455858.4001)
,p_button_image_alt=>'Desarrollo de Equipos'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'select 1 from wwv_flow_companies where nvl(ALLOW_TEAM_DEVELOPMENT_YN, ''Y'') = ''Y'' and provisioning_company_id = :FLOW_SECURITY_GROUP_ID'
,p_button_condition_type=>'EXISTS'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-users'
,p_button_cattributes=>'data-menu="teamDevMenu" disabled style="display: none"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705396934374.4001)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'SHARED_COMP'
,p_button_static_id=>'menu-shared-components'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Componentes Compartidos'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-shared-components'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705918956180.4001)
,p_button_sequence=>170
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'SAVE_PAGE'
,p_button_static_id=>'button-save-page'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Guardar'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--iconTopAction js-actionButton a-Button--savePage'
,p_button_cattributes=>'data-action="pd-save-page" disabled'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3705920960782.4001)
,p_button_sequence=>180
,p_button_plug_id=>wwv_flow_api.id(3700518577643.4001)
,p_button_name=>'RUN_PAGE'
,p_button_static_id=>'button-save-run-page'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Guardar y Ejecutar P\00E1gina')
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--iconTopAction js-actionButton a-Button--runPage'
,p_icon_css_classes=>'icon-run-page'
,p_button_cattributes=>'data-action="pd-save-run-page" disabled'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(385901226436802236.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(203907623449009926.4001)
,p_button_name=>'GLV_DISPLAY_FROM_PAGE'
,p_button_static_id=>'glvDispFromPageBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Mostrar desde P\00E1gina')
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'a-Button--simple a-Button--pillStart js-actionButton'
,p_icon_css_classes=>'icon-zoom-page'
,p_button_cattributes=>'data-action="glv-disp-from-page" disabled'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(385901489451807019.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(203907623449009926.4001)
,p_button_name=>'GLV_DISPLAY_FROM_HERE'
,p_button_static_id=>'glvDispFromHereBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>unistr('Mostrar desde Aqu\00ED')
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'a-Button--simple a-Button--pillEnd js-actionButton'
,p_icon_css_classes=>'icon-zoom-region'
,p_button_cattributes=>'data-action="glv-disp-from-region" disabled'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(394428806332743893.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(203907623449009926.4001)
,p_button_name=>'GLV_EXPAND_RESTORE'
,p_button_static_id=>'glvExpandRestoreBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Ampliar'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_css_classes=>'a-Button--simple a-Button--gapLeft js-actionButton'
,p_icon_css_classes=>'icon-maximize'
,p_button_cattributes=>'data-action="pd-expand-restore"'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3708102043021.4001)
,p_name=>'P4500_CURRENT_APP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48564602512738202.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1gina. Para ver otra p\00E1gina, seleccione o introduzca un nuevo n\00FAmero de p\00E1gina y haga clic en <strong>Ir</strong>.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3710346923664.4001)
,p_name=>'P4500_DLG_LOCK_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3710342843565.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentario'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3711685408090.4001)
,p_name=>'P4500_DLG_LOCK_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3710342843565.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Bloqueo Propiedad de'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(93372822814585113.4001)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361878703986669565.4001)
,p_name=>'P4500_LOCAL_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3344283174196343.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Buscar'
,p_placeholder=>unistr('P\00E1gina de b\00FAsqueda...')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>255
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--search'
,p_item_icon_css_classes=>'a-Icon icon-search'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361879015280831539.4001)
,p_name=>'P4500_MATCH_CASE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3344377146196344.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P4500_MATCH_CASE'
,p_lov=>'.'||wwv_flow_api.id(687435969419956417.4001)||'.'
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--inline'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(361879604663897172.4001)
,p_name=>'P4500_IS_REGEXP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3344377146196344.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P4500_IS_REGEXP'
,p_lov=>'.'||wwv_flow_api.id(687426829609667755.4001)||'.'
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_css_classes=>'a-Form-fieldContainer--inline'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(48579902612738246.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4500'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48582011193738251.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => apex_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dual',
' where :FB_FLOW_ID is null',
'union all',
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'intersect',
'select 1',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3785910874387.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getDistinctValues'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_distinct_values (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_component_type_id => wwv_flow.g_x01,',
'        p_property_id       => wwv_flow.g_x02 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3786198819950.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPageItems'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_page_items (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x01 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3786207134291.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_pages (',
'        p_application_id => :FB_FLOW_ID,',
'        p_include_global => wwv_flow.g_x01 = ''Y'',',
'        p_filter_type    => wwv_flow.g_x02,',
'        p_filter_id      => wwv_flow.g_x03 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3787259718152.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getDbObjects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_db_objects (',
'        p_application_id   => :FB_FLOW_ID,',
'        p_type             => wwv_flow.g_x01,',
'        p_owner            => wwv_flow.g_x02,',
'        p_include_public   => ( wwv_flow.g_x03 = ''Y'' ),',
'        p_remote_server_id => wwv_flow.g_x04 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(379983509886592218.4001)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getNewComponentId'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_new_component_id (',
'        p_count => wwv_flow.g_x01 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3710681876314.4001)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getCodeCompleteList'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_f4000_plugins.emit_code_complete_list (',
'        p_application_id => :FB_FLOW_ID,',
'        p_type           => wwv_flow.g_widget_name,',
'        p_search_prefix  => wwv_flow.g_x01,',
'        p_parent         => wwv_flow.g_x02,',
'        p_grand_parent   => wwv_flow.g_x03 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(58466930233192809.4001)
,p_process_sequence=>50
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPageData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_page_data (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page           => wwv_flow.g_x01 );',
'    :FB_FLOW_PAGE_ID := wwv_flow.g_x01;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48624806507914277.4001)
,p_process_sequence=>60
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getSharedData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_shared_data (',
'        p_application_id => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(391308403502598043.4001)
,p_process_sequence=>70
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getWorkspaceData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_workspace_data;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(48608915034907292.4001)
,p_process_sequence=>80
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getStaticData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_static_data;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(402665328061568915.4001)
,p_process_sequence=>90
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getAdditionalData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_page_id constant number := to_number( wwv_flow.g_x01 );',
'',
'    l_count   pls_integer;',
'    l_page_id number;',
'begin',
'    ',
'    wwv_flow_json.open_object;',
'',
'    -- Get previous page id',
'    begin',
'        select id',
'          into l_page_id',
'          from ( select id',
'                   from wwv_flow_steps',
'                  where flow_id = :FB_FLOW_ID',
'                    and security_group_id = :WORKSPACE_ID',
'                    and id                < c_page_id',
'                  order by id desc',
'               )',
'         where rownum <= 1;',
'        wwv_flow_json.  write( ''prevPageId'', to_char( l_page_id ));',
'    exception when no_data_found then null;',
'    end;',
'',
'    -- Get next page id',
'    begin',
'        select id',
'          into l_page_id',
'          from ( select id',
'                   from wwv_flow_steps',
'                  where flow_id = :FB_FLOW_ID',
'                    and security_group_id = :WORKSPACE_ID',
'                    and id                > c_page_id',
'                  order by id',
'               )',
'         where rownum <= 1;',
'        wwv_flow_json.  write( ''nextPageId'', to_char( l_page_id ));',
'    exception when no_data_found then null;',
'    end;',
'    ',
'    select count(*)',
'      into l_count',
'      from wwv_flow_app_comments',
'     where flow_id            = :FB_FLOW_ID',
'       and security_group_id  = :WORKSPACE_ID',
'       and instr( '','' || replace( replace( pages, '' '', null ), '':'', '','' ) || '','' , '','' || c_page_id || '','' ) > 0;',
'',
'    wwv_flow_json.  write( ''comments'', l_count );',
'',
'    wwv_flow_json.  open_object( ''teamDev'' );',
'    ',
'    ',
'    select count(*)',
'      into l_count',
'      from wwv_flow_feedback',
'     where application_id            = :FB_FLOW_ID',
'       and page_id                   = c_page_id',
'       and security_group_id         = :WORKSPACE_ID',
'       and nvl( feedback_status, 0 ) < 3;',
'',
'    wwv_flow_json.    write( ''feedback'', l_count );',
'    ',
'    --',
'    ',
'     select count(*)',
'      into l_count',
'      from wwv_flow_issues',
'     where application_id            = :FB_FLOW_ID',
'       and page_id                   = c_page_id',
'       and security_group_id         = :WORKSPACE_ID',
'       and status = ''OPEN'';',
'',
'    wwv_flow_json.    write( ''issues'', l_count );',
'    ',
'    wwv_flow_json.write( ''todos'', 0 );',
'    wwv_flow_json.write( ''features'', 0 );',
'    wwv_flow_json.write( ''bugs'', 0 );',
'    ',
'',
'',
'    wwv_flow_json.close_all;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(703162813604905314.4001)
,p_process_sequence=>120
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'setPreference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.set_preference (',
'        p_preference_name   => wwv_flow.g_x01,',
'        p_preference_value  => wwv_flow.g_x02 );',
'end;        '))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(139325814856024145.4001)
,p_process_sequence=>130
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validateProperty'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.validate_browser_property (',
'        p_application_id       => :FB_FLOW_ID,',
'        p_property_id          => wwv_flow.g_x01,',
'        p_property_type        => wwv_flow.g_x02,',
'        p_sql_min_column_count => wwv_flow.g_x03,',
'        p_sql_max_column_count => wwv_flow.g_x04,',
'        p_value                => wwv_flow.g_x05,',
'        p_location             => wwv_flow.g_x06,',
'        p_query_type           => wwv_flow.g_x07,',
'        p_table_owner          => wwv_flow.g_x08,',
'        p_table_name           => wwv_flow.g_x09,',
'        p_sql_query            => wwv_flow.g_x09,',
'        p_function_body        => wwv_flow.g_x09,',
'        p_web_source_query_id  => wwv_flow.g_x09,',
'        p_include_rowid_column => ( wwv_flow.g_x10 = ''Y'' ),',
'        p_optimizer_hint       => wwv_flow.g_x11,',
'        p_remote_database_id   => wwv_flow.g_x12 );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(381488768716741713.4001)
,p_process_sequence=>140
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lockPage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.lock_page (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x02,',
'        p_comment        => wwv_flow.g_x03 );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(381489365105890681.4001)
,p_process_sequence=>150
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlockPage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.unlock_page (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x02 );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3791708414403.4001)
,p_process_sequence=>160
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'writePageData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.write_page_data (',
'        p_application_id => wwv_flow.g_x01,',
'        p_page_id        => wwv_flow.g_x02,',
'        p_data           => wwv_flow.g_f01 );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_04650
begin
wwv_flow_api.create_page(
 p_id=>4650.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Regiones de P\00E1gina')
,p_step_title=>'Regiones'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(698674781428105900.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(418707548.4001)
,p_name=>'Regiones'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sys.htf.anchor(''f?p=4000:4500:''||:flow_session||''::NO:::#5110:''||ID,',
'  ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'') edit_link,',
'  plug_display_sequence, ',
'  plug_name,  ',
'  plug_source_type,',
'  (select count(*)',
'     from wwv_flow_step_items i',
'    where i.flow_id      = p.flow_id',
'      and i.flow_step_id = p.page_id',
'      and i.item_plug_id = p.id) item_count,',
'  (select count(*)',
'     from wwv_flow_step_buttons b',
'    where b.flow_id        = p.flow_id',
'      and b.flow_step_id   = p.page_id',
'      and b.button_plug_id = p.id) button_count,',
'  id,',
'  decode(PLUG_DISPLAY_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
'last_updated_on',
' from wwv_flow_page_plugs p',
'where flow_id = :FB_FLOW_ID',
'  and page_id = :FB_FLOW_PAGE_ID',
'order by plug_display_point, plug_display_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48577530497771003.4001)
,p_query_column_id=>1
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>1
,p_column_heading=>'Editar'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48577627834771003.4001)
,p_query_column_id=>2
,p_form_element_id=>1
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48577805784771003.4001)
,p_query_column_id=>3
,p_form_element_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la Regi\00F3n')
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48578032741771003.4001)
,p_query_column_id=>4
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Tipo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(32361488916)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48578119782771003.4001)
,p_query_column_id=>5
,p_column_alias=>'ITEM_COUNT'
,p_column_display_sequence=>6
,p_column_heading=>'Elementos'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48578230961771003.4001)
,p_query_column_id=>6
,p_column_alias=>'BUTTON_COUNT'
,p_column_display_sequence=>7
,p_column_heading=>'Botones'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48578421892771004.4001)
,p_query_column_id=>7
,p_form_element_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>9
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(26238628522362292.4001)
,p_query_column_id=>8
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>10
,p_column_heading=>'Condicional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(291243517700174338.4001)
,p_query_column_id=>9
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>11
,p_column_heading=>'Actualizado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100005919902466250.4001)
,p_column_sequence=>1
,p_query_column_name=>'EDIT_LINK'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100006016012466250.4001)
,p_column_sequence=>2
,p_query_column_name=>'PLUG_DISPLAY_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>3
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100006230327466250.4001)
,p_column_sequence=>3
,p_query_column_name=>'PLUG_NAME'
,p_display_as=>'TEXT'
,p_column_width=>20
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(157957824790049969.4001)
,p_column_sequence=>4
,p_query_column_name=>'PLUG_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100167123613679041.4001)
,p_column_sequence=>5
,p_query_column_name=>'PLUG_SOURCE_TYPE'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100180811686709766.4001)
,p_column_sequence=>6
,p_query_column_name=>'ITEM_COUNT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100187711929721122.4001)
,p_column_sequence=>7
,p_query_column_name=>'BUTTON_COUNT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(91993221082284048.4001)
,p_column_sequence=>8
,p_query_column_name=>'PLUG_DISPLAY_POINT'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(100228400558798175.4001)
,p_column_sequence=>9
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(26238507758362284.4001)
,p_column_sequence=>10
,p_query_column_name=>'CONDITIONAL'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(291243412102174334.4001)
,p_column_sequence=>11
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14027700703875354.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(13987931263515071.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(100032432459533854.4001)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17219915997426667.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(100032432459533854.4001)
,p_button_name=>'P4650_GO'
,p_button_static_id=>'P4650_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17218426256420224.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(100032432459533854.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100101705003610470.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(100032432459533854.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
,p_button_condition=>'select 1 from wwv_flow_page_plugs where flow_id=:FB_FLOW_ID and page_id=:FB_FLOW_PAGE_ID'
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(17217820715418639.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(100032432459533854.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3499326697.4001)
,p_branch_name=>'Go To Page 4650'
,p_branch_action=>'f?p=&APP_ID.:4650:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17219004569423388.4001)
,p_name=>'P4650_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(100032432459533854.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('P\00E1gina')
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>44
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que desea editar. A continuaci\00F3n, haga clic en <span class="fielddatabold">Ir</span> para editar la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(46335340741.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4650'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3500326697.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4651_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17221232274431453.4001)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_f4000_util.get_next_app_page;'
,p_computation_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare p number := 1;',
'begin',
'if wwv_flow.g_request = ''PREVIOUS'' then',
'  select max(id) into p from wwv_flow_steps where id < :FB_FLOW_PAGE_ID',
'  and flow_id = :FB_FLOW_ID;',
'  return p;',
'elsif wwv_flow.g_request = ''NEXT'' then',
'  select min(id) into p from wwv_flow_steps where id > :FB_FLOW_PAGE_ID',
'  and flow_id = :FB_FLOW_ID;',
'  return p;',
'end if;',
'end;',
'',
''))
,p_computation_error_message=>unistr('No se ha podido calcular la p\00E1gina siguiente o anterior.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(17224009464453247.4001)
,p_computation_sequence=>40
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return nvl(v(''P4650_PAGE_ID''),v(''FB_FLOW_PAGE_ID''));'
,p_computation_error_message=>unistr('No se ha podido calcular el valor de la p\00E1gina actual.')
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(157603917492925633.4001)
,p_computation_sequence=>50
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.get_theme_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(493110729411375909.4001)
,p_validation_name=>'P4650_PAGE_ID is numeric'
,p_validation_sequence=>10
,p_validation=>'P4650_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La p\00E1gina debe ser num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(17219915997426667.4001)
,p_associated_item=>wwv_flow_api.id(17219004569423388.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(493110905563397366.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(418707548.4001)
,p_validation_name=>'Region not null'
,p_validation_sequence=>20
,p_validation=>'PLUG_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de regi\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(100101705003610470.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'PLUG_NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(100225326210795060.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(418707548.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'mru'
,p_attribute_02=>'WWV_FLOW_PAGE_PLUGS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>unistr('Error al actualizar las regiones de p\00E1gina.')
,p_process_when_button_id=>wwv_flow_api.id(100101705003610470.4001)
,p_process_success_message=>unistr('#MRU_COUNT# region(es) de p\00E1gina actualizada(s).')
,p_security_scheme=>wwv_flow_api.id(34674432490821717)
);
end;
/
prompt --application/pages/page_04653
begin
wwv_flow_api.create_page(
 p_id=>4653.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Plantillas de Regi\00F3n')
,p_step_title=>unistr('Editar Plantilla de Regi\00F3n')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plug_templates t, wwv_flow_themes th',
'where t.id = :F4000_P4653_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_reg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(686703536.4001)
,p_plug_name=>'Region Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(687705197.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(688720308.4001)
,p_plug_name=>unistr('Plantillas de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Las plantillas de regi\00F3n controlan el aspecto y colocaci\00F3n de los atributos de regi\00F3n.  '),
unistr('Puede colocar los atributos de regi\00F3n utilizando cadenas de sustituci\00F3n como <strong>#BODY#</strong> y <strong>#EDIT#</strong>. Las cadenas de sustituci\00F3n de plantillas deben estar en may\00FAsculas y empezar y terminar por un s\00EDmbolo de almohadilla (#).')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(689725477.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33424815586234511.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4653_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_attribute_02=>'PAGE_PLUG_TEMPLATE_NAME'
,p_attribute_03=>'F4000_P4653_ID'
,p_attribute_04=>'F4000_P4653_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(69539118475360417.4001)
,p_plug_name=>unistr('Dise\00F1o')
,p_region_name=>'FORM_TABLE_ATTRIBUTES'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92906206971788557.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(153210815104527139.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117326511432403116.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(164213211890458701.4001)
,p_plug_name=>unistr('Definici\00F3n')
,p_region_name=>'DEFINITION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166001904678450845.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_name=>'SUBSTITUTION_STRINGS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_region_layout.region_template_substitution(',
'   p_flow=>:FB_FLOW_ID,',
'   p_template_id=>:F4000_P4653_ID );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n se utilizan en las plantillas para hacer referencia a los valores del componente. Este informe detalla el uso de la cadena de sustituci\00F3n para esta plantilla.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(170537816680150865.4001)
,p_plug_name=>'Subregiones'
,p_region_name=>'SUB_REGIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(170543402060241250.4001)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(266470409881026219.4001)
,p_plug_name=>'Posiciones'
,p_region_name=>'DISPLAY_POINT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ROWID",',
'       "FLOW_ID",',
'       "PLUG_TEMPLATE_ID",',
'       "NAME",',
'       "PLACEHOLDER",',
'       "HAS_GRID_SUPPORT",',
'       "HAS_REGION_SUPPORT",',
'       "HAS_ITEM_SUPPORT",',
'       "HAS_BUTTON_SUPPORT",',
'       "GLV_NEW_ROW",',
'       "MAX_FIXED_GRID_COLUMNS"',
'  from wwv_flow_plug_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and plug_template_id  = :F4000_P4653_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4653_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Posiciones'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cree posiciones para la plantilla de esta regi\00F3n. Las posiciones permiten identificar d\00F3nde se mostrar\00E1n los componentes (regiones, elementos, botones) en la plantilla de esta regi\00F3n.'),
'<br />',
unistr('Las posiciones pueden utilizarse para restringir la ubicaci\00F3n de las regiones, elementos y botones en la plantilla de esta regi\00F3n al configurar qu\00E9 tipo de componente est\00E1 soportado en una posici\00F3n.'),
'<br />',
unistr('La <strong>sustituci\00F3n de plantilla</strong> de una posici\00F3n no puede ser una de las cadenas de sustituci\00F3n de la p\00E1gina reservada; por ejemplo, REGION_STATIC_ID. Consulte la secci\00F3n <strong>Cadenas de sustituci\00F3n</strong> a continuaci\00F3n para obtener')
||' la lista completa.'))
);
wwv_flow_api.create_region_column_group(
 p_id=>wwv_flow_api.id(6452467564509957.4001)
,p_heading=>unistr('Presentaci\00F3n de dise\00F1o de cuadr\00EDcula')
);
wwv_flow_api.create_region_column_group(
 p_id=>wwv_flow_api.id(8660831823247939.4001)
,p_heading=>'Soporte de tipo de componente'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4312819678030113.4001)
,p_name=>'PLUG_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLUG_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4653_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4312983675030114.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4313073125030115.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451067662509943.4001)
,p_name=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ROWID'
,p_data_type=>'ROWID'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451103977509944.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451371845509946.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Nombre de posici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451423619509947.4001)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Sustituci\00F3n de Plantilla')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451501676509948.4001)
,p_name=>'HAS_GRID_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_GRID_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>unistr('Soporte de Cuadr\00EDcula')
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(6452467564509957.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451639993509949.4001)
,p_name=>'HAS_REGION_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_REGION_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Regiones'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>80
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(8660831823247939.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451697986509950.4001)
,p_name=>'HAS_ITEM_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_ITEM_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Elementos'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(8660831823247939.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451834740509951.4001)
,p_name=>'HAS_BUTTON_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_BUTTON_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Botones'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(8660831823247939.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6451899705509952.4001)
,p_name=>'GLV_NEW_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GLV_NEW_ROW'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Nueva Fila'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>130
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_api.id(6452467564509957.4001)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6452053349509953.4001)
,p_name=>'MAX_FIXED_GRID_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MAX_FIXED_GRID_COLUMNS'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>unistr('M\00E1ximo de Columnas de Cuadr\00EDcula Fijas	')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_group_id=>wwv_flow_api.id(6452467564509957.4001)
,p_use_group_for=>'BOTH'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4653_GRID_MAX_COLUMNS'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(6450924169509942.4001)
,p_internal_uid=>6450924169509942
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(549191974509047647.4001)
,p_name=>'Opciones de Plantilla'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and region_template_id = :F4000_P4653_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4653_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(655608505930654510.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(655608766462654510.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.::P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688540765250413736.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(655608890588654511.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688540886765413736.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688540925771413736.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(655680133816025797.4001)
,p_name=>'Opciones de Plantilla Global'
,p_region_name=>'THEME_TEMPLATE_OPTIONS'
,p_parent_plug_id=>wwv_flow_api.id(549191974509047647.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o, wwv_flow_page_plug_templates t',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.security_group_id  = :WORKSPACE_ID',
'   and o.region_template_id is null',
'   and o.template_types = ''REGION''',
'   and t.theme_id = o.theme_id',
'   and t.id = :F4000_P4653_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4653_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(655680313391025800.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(655680581771025801.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688541780480424574.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(655680686478025801.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688541815620424574.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688541970285424574.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615306603461492922.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where id = :F4000_P4653_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4653_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932807207016193716.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4653_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4653_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1094586036782933029.4001)
,p_plug_name=>'JavaScript'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1094586347046933032.4001)
,p_plug_name=>'Hoja de Estilo en Cascada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57515028086887716.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(686703536.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(57514913787887716.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(686703536.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
end;
/
begin
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166448303431073862.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33424815586234511.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4653_ID.,&FLOW_PAGE_ID.,REGION'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plug_templates',
'where reference_id = :F4000_P4653_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164060102283696912.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33424815586234511.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_page_plug_templates',
'',
'where id = :F4000_P4653_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(549198858048077684.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(549191974509047647.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_REGION_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P4653_THEME.,&F4000_P4653_ID.,REGION'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3610655866.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(686703536.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3611655866.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(686703536.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:307:&SESSION.::&DEBUG.::P307_ID:&F4000_P4653_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4653_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3612655867.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(686703536.4001)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4653_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3613655867.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(686703536.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4653_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30855228922454855.4001)
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4653_ID.,REGION,4653'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4653_PUBLISH'
,p_branch_condition_text=>'Y'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57520814607887767.4001)
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.::F4000_P4653_ID:&P4653_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57514913787887716.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57521200495887768.4001)
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.::F4000_P4653_ID:&P4653_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(57515028086887716.4001)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(57647007515633459.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4653:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4653_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164060500846696916.4001)
,p_branch_name=>'Go To Page 4653'
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(164060102283696912.4001)
,p_branch_sequence=>50
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(352622128785729197.4001)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3617655868.4001)
,p_name=>'F4000_P4653_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(117326511432403116.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3619655869.4001)
,p_name=>'F4000_P4653_PAGE_PLUG_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(687705197.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'PAGE_PLUG_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifica un nombre para esta plantilla.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3620655869.4001)
,p_name=>'F4000_P4653_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(164213211890458701.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla'
,p_source=>'TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>16
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Las plantillas de regi\00F3n proporcionan el aspecto de una parte de una p\00E1gina denominada regi\00F3n. Utilice cadenas de sustituci\00F3n para indicar la existencia y la ubicaci\00F3n de un componente dentro de la regi\00F3n.</div>'),
unistr('<div class="htmldbInfoBodyP">#BODY# es la \00FAnica cadena de sustituci\00F3n necesaria. Identifica el lugar donde se coloca el origen de la regi\00F3n. Todas las dem\00E1s cadenas de sustituci\00F3n son opcionales.</div>'),
unistr('<div class="htmldbInfoBodyP">Las siguientes son cadenas de sustituci\00F3n v\00E1lidas:'),
'<ul class="noIndent">',
'<li>#TITLE#</li>',
'<li>#PAGE_TITLE#</li>',
'<li>#EXPAND#</li>',
'<li>#CHANGE#</li>',
'<li>#BODY#</li>',
'<li>#SUB_REGION_HEADERS#</li>',
'<li>#SUB_REGIONS#</li>',
'<li>#FORM_OPEN#</li> ',
'<li>#FORM_CLOSE#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'<li>#REGION_CSS_CLASSES#</li>',
'<li>#REGION_ATTRIBUTES#</li>',
'<li>#REGION_HEADER#</li>',
'<li>#REGION_FOOTER#</li>',
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Tambi\00E9n puede utilizar las siguientes cadenas de sustituci\00F3n para especificar posiciones de botones dentro de esta regi\00F3n:</div>'),
'<ul class="noIndent">',
'<li>#EDIT#</li>',
'<li>#CLOSE#</li>',
'<li>#CREATE#</li>',
'<li>#CREATE2#</li>',
'<li>#EXPAND#</li>',
'<li>#HELP#</li>',
'<li>#DELETE#</li>',
'<li>#COPY#</li>',
'<li>#NEXT#</li>',
'<li>#PREVIOUS#</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3621655869.4001)
,p_name=>'F4000_P4653_TEMPLATE_COMMENT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(689725477.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.</div>')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(12774423472920724.4001)
,p_name=>'F4000_P4653_RETURN_TO_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(688720308.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24146906189471199.4001)
,p_name=>'P4653_TRANSLATABLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(687705197.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30854803942419329.4001)
,p_name=>'P4653_PUBLISH'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(688720308.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PUBLISH_ON_SAVE'
,p_lov=>'.'||wwv_flow_api.id(763360160878777085.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para publicar la plantilla despu\00E9s de aplicar los cambios.')
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34404508114932740.4001)
,p_name=>'F4000_P4653_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(33424815586234511.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_page_plug_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P4653_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40811004586362518.4001)
,p_name=>'P4653_N'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(686703536.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PLUG_TEMPLATE_NAME from WWV_FLOW_PAGE_PLUG_TEMPLATES',
' where id = :F4000_P4653_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre de la plantilla'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41994108838502830.4001)
,p_name=>'P4653_THEME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(687705197.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tema al que est\00E1 asociada esta plantilla. Un tema es un grupo de plantillas que proporcionan el dise\00F1o y el estilo a una aplicaci\00F3n.')
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42008624431583032.4001)
,p_name=>'P4653_THEME_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(687705197.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(42003622222572861.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico de esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.<p />',
'Utilice la casilla de control <strong>Se puede convertir</strong> para indicar si esta plantilla contiene cadenas de texto que hay que convertir. ',
'</div>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57518300201887745.4001)
,p_name=>'P4653_ID_NEXT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(689725477.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57518731059887749.4001)
,p_name=>'P4653_ID_PREV'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(689725477.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57519105074887750.4001)
,p_name=>'P4653_ID_COUNT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(686703536.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Haga clic en los botones Siguiente y Anterior para navegar entre las plantillas.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(69546102516367776.4001)
,p_name=>'F4000_P4653_TEMPLATE2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(69539118475360417.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Atributos de Tabla HTML: Se utilizan al presentar los elementos de las regiones para controlar el formato.'
,p_source=>'TEMPLATE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Los elementos de p\00E1gina aparecen en las regiones. Cada elemento forma parte de una tabla HTML si el tipo de dise\00F1o de la plantilla de p\00E1gina est\00E1 definido en "Tabla". Puede definir los atributos de esta tabla con este atr')
||'ibuto.</div>',
'<div class="htmldbInfoBodyP">Por ejemplo:</div>',
'<pre>class="instructiontext"</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164022700752309091.4001)
,p_name=>'F4000_P4653_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(33424815586234511.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id||'' : ''||wwv_flow_escape.html(page_plug_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Plantilla -'
,p_cSize=>50
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en esta aplicaci\00F3n u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>'),
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>',
''))
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170538701358165364.4001)
,p_name=>'P4653_SUB_PLUG_HEADER_TEMPLATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(170537816680150865.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Cabecera'
,p_source=>'SUB_PLUG_HEADER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Las plantillas de cabecera de subregi\00F3n en combinaci\00F3n con las plantillas de entrada de cabecera de subregi\00F3n ofrecen la posibilidad de generar una lista de t\00EDtulos de regi\00F3n de todas las subregiones de la regi\00F3n actual.<')
||'/div>',
unistr('<div class="htmldbInfoBodyP">#ENTRIES# es una \00FAnica cadena de sustituci\00F3n obligatoria. Identifica el lugar en el que se deben colocar las entradas de cabecera de subregi\00F3n. Todas las dem\00E1s cadenas de sustituci\00F3n son opcionales.</div>'),
unistr('<div class="htmldbInfoBodyP">A continuaci\00F3n, se enumeran cadenas de sustituci\00F3n v\00E1lidas:'),
'<ul class="noIndent">',
'<li>#ENTRIES#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Utilice #SUB_REGION_HEADERS# en la plantilla de regi\00F3n para colocar la salida de esta plantilla.</div>'),
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170539214995178768.4001)
,p_name=>'P4653_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(170537816680150865.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Entrada de Cabecera'
,p_source=>'SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Las plantillas de entrada de cabecera de subregi\00F3n en combinaci\00F3n con las plantillas de cabecera de subregi\00F3n ofrecen la posibilidad de generar una lista de t\00EDtulos de regi\00F3n de todas las subregiones de la regi\00F3n actual.<')
||'/div>',
unistr('<div class="htmldbInfoBodyP">A continuaci\00F3n, se enumeran cadenas de sustituci\00F3n v\00E1lidas:'),
'<ul class="noIndent">',
'<li>#SUB_REGION_ID#</li>',
'<li>#SUB_REGION_TITLE#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Utilice #ENTRIES# en la plantilla de cabecera de subregi\00F3n para colocar la salida de esta plantilla.</div>'),
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(170539727462182389.4001)
,p_name=>'P4653_SUB_PLUG_TEMPLATE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(170537816680150865.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla'
,p_source=>'SUB_PLUG_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Las plantillas de subregi\00F3n ofrecen la posibilidad de encapsular las subregiones con c\00F3digo HTML adicional.</div>'),
unistr('<div class="htmldbInfoBodyP">#SUB_REGION# es la \00FAnica cadena de sustituci\00F3n obligatoria. Identifica el lugar en el que se debe colocar el origen de la subregi\00F3n. Todas las dem\00E1s cadenas de sustituci\00F3n son opcionales.</div>'),
unistr('<div class="htmldbInfoBodyP">A continuaci\00F3n, se enumeran cadenas de sustituci\00F3n v\00E1lidas:'),
'<ul class="noIndent">',
'<li>#SUB_REGION#</li>',
'<li>#SUB_REGION_ID#</li>',
'<li>#SUB_REGION_TITLE#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
unistr('<div class="htmldbInfoBodyP">Utilice #SUB_REGIONS# en la plantilla de regi\00F3n para colocar la salida de esta plantilla.</div>'),
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(625519632348486259.4001)
,p_name=>'P4653_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>235
,p_item_plug_id=>wwv_flow_api.id(549191974509047647.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       css_classes as r,',
'       (select default_template_options from wwv_flow_page_plug_templates where id = :F4000_P4653_ID) default_template_options,',
'       null,',
'       help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o',
' where flow_id = :FB_FLOW_ID',
'   and region_template_id = :F4000_P4653_ID ',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(625523659851665177.4001)
,p_name=>'P4653_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(549191974509047647.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text ',
'  from wwv_flow_template_options o, wwv_flow_page_plug_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and o.template_types = ''REGION''',
'   and (o.region_template_id = :F4000_P4653_ID or o.region_template_id is NULL)',
'   and t.theme_id = o.theme_id',
'   and t.id = :F4000_P4653_ID',
'order by advanced_group nulls first, group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094586109106933030.4001)
,p_name=>'P4653_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1094586036782933029.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo JavaScript para el c\00F3digo que se va a cargar en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code> ')
||unistr('para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a la caden')
||unistr('a de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre. Incluya solo la URL.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de /myjs/minified/ para vistas de p\00E1gina normales y main.js de /myjs/ en el modo de depuraci\00F3n.'),
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca se utiliza tambi\00E9n desde una llamada de solicitud de RequireJS. El nombre de definici\00F3n debe coincidir con el que se utilice en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global')
||' que muestre la biblioteca. Solo se aplica al utilizar RequireJS. Esto evita que RequireJS cargue la biblioteca una segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que, cuando se cambie la versi\00F3n de la aplicaci\00F3n (y se incremente la versi\00F3n), se indicar\00E1 al explorador que siempre')
||unistr(' cargue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094586251166933031.4001)
,p_name=>'P4653_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1094586036782933029.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ejecutar Cuando Se Cargue la P\00E1gina')
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript que se ejecutar\00E1 cuando se cargue la p\00E1gina. Este c\00F3digo se ejecuta despu\00E9s del c\00F3digo JavaScript generado por &PRODUCT_NAME..</p>'),
'',
unistr('<p>Nota: No es necesario agregar etiquetas <code>script</code> de apertura o de cierre, solo el c\00F3digo JavaScript.</p>'),
''))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094586405660933033.4001)
,p_name=>'P4653_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1094586347046933032.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar para esta plantilla de p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci')
||unistr('\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n t')
||unistr('iene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/mycss/main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), se indica al explorador que siempre ca')
||unistr('rgue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1331350003570223302.4001)
,p_name=>'P4653_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(687705197.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.')
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2046920621895584502.4001)
,p_name=>'P4653_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>245
,p_item_plug_id=>wwv_flow_api.id(549191974509047647.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P4653_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104768030368830011.4001)
,p_name=>'P4653_THEME_IS_SUBSCRIBED'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(687705197.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104768571245833700.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4653_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_page_plug_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P4653_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34460128768983948.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4653_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164067032755719714.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4653_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(164060102283696912.4001)
,p_associated_item=>wwv_flow_api.id(164022700752309091.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(150712331006210623.4001)
,p_validation_name=>'TemplateNameMand'
,p_validation_sequence=>30
,p_validation=>'F4000_P4653_PAGE_PLUG_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(3612655867.4001)
,p_associated_item=>wwv_flow_api.id(3619655869.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(177290555869915732.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(266470409881026219.4001)
,p_validation_name=>'Reserved template substitutions'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':placeholder not in (',
'    ''TOP'',',
'    ''TOP_AND_BOTTOM'',',
'    ''ABOVE_BOX'',',
'    ''TEMPLATE_DEFAULT'',',
'    ''BELOW_BOX'',',
'    ''BOTTOM'',',
'    ''RIGHT_OF_IR_SEARCH_BAR'',',
'    ''LEFT_OF_TITLE'',',
'    ''RIGHT_OF_TITLE'',',
'    ''ENTRIES'',',
'    ''FIRST_ROW_FETCHED'',',
'    ''FORM_CLOSE'',',
'    ''FORM_OPEN'',',
'    ''ICON_CSS_CLASSES'',',
'    ''INTERNET_PAGINATION'',',
'    ''LAST_ROW_FETCHED'',',
'    ''PAGE_TITLE'',',
'    ''REGION_ATTRIBUTES'',',
'    ''REGION_CSS_CLASSES'',',
'    ''REGION_FOOTER'',',
'    ''REGION_HEADER'',',
'    ''REGION_ID'',',
'    ''REGION_SEQUENCE_ID'',',
'    ''REGION_STATIC_ID'',',
'    ''ROW_RANGES'',',
'    ''ROW_RANGES_IN_SELECT_LIST'',',
'    ''ROWS_FETCHED'',',
'    ''SUB_REGION_HEADERS'',',
'    ''SUB_REGION_ICON_CSS_CLASSES'',',
'    ''SUB_REGION_ID'',',
'    ''SUB_REGION_TITLE'',',
'    ''TIMING'',',
'    ''TITLE'',',
'    ''TOTAL_ROWS'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Esta es una sustituci\00F3n de plantilla reservada.')
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397307220112551594.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4653_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397307508996551594.4001)
,p_event_id=>wwv_flow_api.id(397307220112551594.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(57515028086887716.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397307627731553768.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4653_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397307920753553768.4001)
,p_event_id=>wwv_flow_api.id(397307627731553768.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(57514913787887716.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549337276767384341.4001)
,p_name=>'refresh template options'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(549198858048077684.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2380796919090129201.4001)
,p_event_id=>wwv_flow_api.id(549337276767384341.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(549191974509047647.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4653:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549341968105426394.4001)
,p_name=>'refresh template options after edit'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(549191974509047647.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2380797005199129202.4001)
,p_event_id=>wwv_flow_api.id(549341968105426394.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(549191974509047647.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4653:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3622655870.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_page_plug_templates',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4653_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  p_rowid       => v(''F4000_P4653_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(57520116652887760.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_attribute_03=>'F4000_P4653_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'PAGE_PLUG_TEMPLATE_NAME'
,p_attribute_09=>'P4653_ID_NEXT'
,p_attribute_10=>'P4653_ID_PREV'
,p_attribute_13=>'P4653_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164085714109849931.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_region_template (',
'    p_master_template_id         => :F4000_P4653_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4653_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(164060102283696912.4001)
,p_process_when=>'F4000_P4653_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3623655870.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4653_ID is null',
'or exists (select 1 from wwv_flow_page_plug_templates',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4653_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'p_rowid       => v(''F4000_P4653_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Plantilla de regi\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34415815650944401.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_region_template (',
'    p_master_template_id         => :F4000_P4653_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4653_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when=>':F4000_P4653_REFERENCE_ID is not null and :F4000_P4653_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2046920780635584503.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_region_tmplopt_presets(:F4000_P4653_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P4653_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P4653_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164079525613753399.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_region_reference_id (:F4000_P4653_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when=>'F4000_P4653_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NULL'
,p_process_success_message=>'Identificador de referencia eliminado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4313197422030116.4001)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(266470409881026219.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Positions - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177290695973915733.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(266470409881026219.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :placeholder'
,p_process_sql_clob=>':placeholder := upper(:placeholder);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4653_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177290796098915734.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(266470409881026219.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'trim pound'
,p_process_sql_clob=>':placeholder := trim( both ''#'' from :placeholder );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4653_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
);
end;
/
prompt --application/pages/page_04654
begin
wwv_flow_api.create_page(
 p_id=>4654.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Plantilla de Informe'
,p_step_title=>'Editar Plantilla de Informe'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_row_templates t, wwv_flow_themes th',
'where t.id = :F4000_P4654_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(333463912.4001)
,p_plug_name=>'Editar Plantilla de Informe'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(334466077.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(335468967.4001)
,p_plug_name=>'Plantillas de Fila'
,p_region_name=>'ROW'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(336494473.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(337523805.4001)
,p_plug_name=>'Plantillas de Informe'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Las plantillas de informe proporcionan control de plantilla sobre los resultados de una fila de una consulta SQL. Se pueden definir plantillas de informe para dar formato a una fila completa o una columna concreta. Las plantillas de informe que defin'
||unistr('en una celda son m\00E1s peque\00F1as porque s\00F3lo tienen que definir cada celda, sin embargo, todas las celdas son iguales. Utilice sustituciones de nombre de columna, por ejemplo, #ENAME# #JOB#, o sustituciones de posici\00F3n de fila #1# #2# para sustituir val')
||unistr('ores de columna. Las condiciones de plantilla de informe permiten utilizar una plantilla de fila espec\00EDfica basada en valores de columna de fila o estado de sesi\00F3n. Por ejemplo, "#SAL# > 1000" o "''#ENAME#'' = ''SMITH''" (Observe el uso de comillas para ')
||unistr('las cadenas de texto). Para hacer referencia a un n\00FAmero de fila, utilice #ROWNUM#.'),
'',
''))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46650415178.4001)
,p_plug_name=>unistr('Antes de la primera fila de texto y despu\00E9s de la \00FAltima')
,p_region_name=>'BA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4323409658151759.4001)
,p_plug_name=>unistr('Paginaci\00F3n')
,p_region_name=>'PG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14467922958338901.4001)
,p_plug_name=>'Cabeceras de Columna'
,p_region_name=>'COL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14532616069639696.4001)
,p_plug_name=>'Atributos Obsoletos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'  r boolean := false;',
'',
'begin',
'',
'  for c1 in (select ROW_TEMPLATE_TABLE_ATTRIBUTES from WWV_FLOW_ROW_TEMPLATES where id = :F4000_P4654_ID) loop',
'',
'     if c1.ROW_TEMPLATE_TABLE_ATTRIBUTES = ''OMIT'' or c1.ROW_TEMPLATE_TABLE_ATTRIBUTES is null then',
'',
'        r := false;',
'',
'     else',
'',
'        r := true;',
'',
'     end if;',
'',
'end loop;',
'',
'return r;',
'',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>unistr('<span class="instructiontext">Este atributo est\00E1 obsoleto, int\00E9grelo en la plantilla anterior.</span>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46255923216679006.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>2
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92905500045786517.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(932807384840193717.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4654_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4654_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1094587077987933039.4001)
,p_plug_name=>'Javascript'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1094587181132933040.4001)
,p_plug_name=>'Hoja de Estilo en Cascada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_name=>'Opciones de Plantilla'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and report_template_id = :F4000_P4654_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4654_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499573102904561723.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499572911898561723.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499572670243561719.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499573018445561723.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499572774230561723.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499572806960561723.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1499573840880561732.4001)
,p_name=>'Opciones de Plantilla Global'
,p_parent_plug_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and virtual_template_id is null',
'   and template_types     = ''REPORT''',
'   and security_group_id  = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4654_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499574595413561735.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499574386321561734.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499574018426561733.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499574449514561735.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499574116809561734.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1499574270401561734.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1517532632413488001.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4654_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_02=>'ROW_TEMPLATE_NAME'
,p_attribute_03=>'F4000_P4654_ID'
,p_attribute_04=>'F4000_P4654_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1499573297318561724.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_REPORT_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P4654_THEME_ID.,&F4000_P4654_ID.,REPORT'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(304434608.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(333463912.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(305434612.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(333463912.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4654_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(306434612.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(333463912.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4654_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(307434612.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(333463912.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4654_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164357816901006904.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1517532632413488001.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_row_templates',
'',
'where id = :F4000_P4654_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166460709234094432.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1517532632413488001.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4654_ID.,&FLOW_PAGE_ID.,REPORT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_row_templates',
'',
'where reference_id = :F4000_P4654_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(50733365791.4001)
,p_branch_action=>'4654'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>21
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4654_RETUEN_TO_SELF'
,p_branch_condition_text=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164358200863006907.4001)
,p_branch_action=>'4654'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(164357816901006904.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(309434620.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(311434626.4001)
,p_name=>'F4000_P4654_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(313434632.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(334466077.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Plantilla'
,p_source=>'ROW_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Introduzca un nombre para esta plantilla de fila.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(314434632.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr><td>#1#</td><td>#2#</td><td>#3#</td><td>#4#</td><td>#5#</td></tr>'
,p_prompt=>'Plantilla de Fila 1'
,p_source=>'ROW_TEMPLATE1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Define la plantilla de fila. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul>',
unistr('<li>#COLUMN_VALUE#: se sustituir\00E1 por el valor de una columna</li>'),
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
unistr('<p>Tambi\00E9n puede utilizar la sintaxis de n\00FAmero de columna para hacer referencia a las columnas por la posici\00F3n en la lista de selecci\00F3n de la consulta, como por ejemplo #1#, #2#.</p>'),
unistr('<p>Un ejemplo t\00EDpico ser\00EDa:</p>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(315434634.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Fila 1')
,p_source=>'ROW_TEMPLATE_CONDITION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00F3lo se utiliza si la condici\00F3n de fila est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite formatear filas seg\00FAn los datos de dicha fila.</p>'),
unistr('<p>Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</p>'),
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
unistr('<p>Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(316434634.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Fila 2'
,p_source=>'ROW_TEMPLATE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Define la plantilla de fila. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul>',
unistr('<li>#COLUMN_VALUE#: se sustituir\00E1 por el valor de una columna</li>'),
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
unistr('<p>Tambi\00E9n puede utilizar la sintaxis de n\00FAmero de columna para hacer referencia a las columnas por la posici\00F3n en la lista de selecci\00F3n de la consulta, como por ejemplo #1#, #2#.</p>'),
unistr('<p>Un ejemplo t\00EDpico ser\00EDa:</p>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(317434634.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Fila 2')
,p_source=>'ROW_TEMPLATE_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00F3lo se utiliza si la condici\00F3n de fila est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite formatear filas seg\00FAn los datos de dicha fila.</p>'),
unistr('<p>Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</p>'),
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
unistr('<p>Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(318434635.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE3'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Fila 3'
,p_source=>'ROW_TEMPLATE3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Define la plantilla de fila. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul>',
unistr('<li>#COLUMN_VALUE#: se sustituir\00E1 por el valor de una columna</li>'),
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
unistr('<p>Tambi\00E9n puede utilizar la sintaxis de n\00FAmero de columna para hacer referencia a las columnas por la posici\00F3n en la lista de selecci\00F3n de la consulta, como por ejemplo #1#, #2#.</p>'),
unistr('<p>Un ejemplo t\00EDpico ser\00EDa:</p>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(319434635.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION3'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Fila 3')
,p_source=>'ROW_TEMPLATE_CONDITION3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00F3lo se utiliza si la condici\00F3n de fila est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite formatear filas seg\00FAn los datos de dicha fila.</p>'),
unistr('<p>Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</p>'),
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
unistr('<p>Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(320434635.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE4'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Fila 4'
,p_source=>'ROW_TEMPLATE4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Define la plantilla de fila. Aqu\00ED puede utilizar las siguientes cadenas de sustituci\00F3n:'),
'<ul>',
unistr('<li>#COLUMN_VALUE#: se sustituir\00E1 por el valor de una columna</li>'),
unistr('<li>#ALIGNMENT#: especificada por el usuario, determina la alineaci\00F3n de una columna</li>'),
unistr('<li>#COLNUM#: n\00FAmero de columna actual</li>'),
'<li>#COLUMN_HEADER#: cabecera de columna</li>',
unistr('<li>#COLCOUNT#: n\00FAmero de columnas</li>'),
unistr('<li>#ROWNUM#: n\00FAmero de fila actual</li>'),
'</ul>',
unistr('<p>Tambi\00E9n puede utilizar la sintaxis de n\00FAmero de columna para hacer referencia a las columnas por la posici\00F3n en la lista de selecci\00F3n de la consulta, como por ejemplo #1#, #2#.</p>'),
unistr('<p>Un ejemplo t\00EDpico ser\00EDa:</p>'),
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(321434636.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION4'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Expresi\00F3n de Plantilla de Fila 4')
,p_source=>'ROW_TEMPLATE_CONDITION4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>S\00F3lo se utiliza si la condici\00F3n de fila est\00E1 definida en Usar Basado en Expresi\00F3n PL/SQL. Permite formatear filas seg\00FAn los datos de dicha fila.</p>'),
unistr('<p>Por ejemplo, para mostrar un valor en negrita si el salario es mayor que 2000, puede utilizar la siguiente condici\00F3n de plantilla de fila:</p>'),
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
unistr('<p>Tambi\00E9n puede utilizar aqu\00ED la cadena de sustituci\00F3n #ROWNUM#.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(322434638.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COMMENT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(336494473.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'ROW_TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46651420058.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_BEFORE_ROWS'
,p_item_sequence=>112
,p_item_plug_id=>wwv_flow_api.id(46650415178.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table>'
,p_prompt=>'Antes de Filas'
,p_source=>'ROW_TEMPLATE_BEFORE_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML que aparecer\00E1 una vez al principio de una plantilla de informe.</p>'),
unistr('<p>El uso m\00E1s com\00FAn de este atributo es abrir una tabla HTML:</p>'),
'<pre>&lt;table&gt;</pre>',
unistr('<p>Tambi\00E9n puede especificar aqu\00ED cabeceras de columna de tabla:</p>'),
'<pre>&lt;th&gt;#1#&lt;/th&gt;&lt;th&gt;#2#&lt;/th&gt;&lt;th&gt;#3#&lt;/th&gt;</pre>',
unistr('<p>Si desea mostrar la paginaci\00F3n encima de los informes, la plantilla debe especificar la siguiente cadena de sustituci\00F3n:</p>'),
'<pre>#TOP_PAGINATION#</pre>',
unistr('La cadena de sustituci\00F3n #TOP_PAGINATION# genera el HTML que se inicia con una etiqueta de apertura &lt;tr&gt; y termina en una etiqueta de cierre &lt;/tr&gt;. Normalmente, se incluir\00EDa una etiqueta de tabla abierta y la cadena de sustituci\00F3n #TOP_PA')
||'GINATION#, como se muestra en el siguiente ejemplo:</p>',
'<pre>&lt;table&gt;#TOP_PAGINATION#</pre>',
unistr('<p>Tambi\00E9n puede utilizar la cadena de sustituci\00F3n #CSV_LINK# para exportar el informe a formato CSV a fin de utilizarlo en una hoja de c\00E1lculo.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46652431799.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_AFTER_ROWS'
,p_item_sequence=>114
,p_item_plug_id=>wwv_flow_api.id(46650415178.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>unistr('Despu\00E9s de Filas')
,p_source=>'ROW_TEMPLATE_AFTER_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este texto se muestra despu\00E9s de la \00FAltima fila. Normalmente, aqu\00ED se cierra la etiqueta de tabla HTML.</p>'),
'<p>Por ejemplo:</p>',
'<pre>&lt;/table&gt;</pre>',
unistr('<p>Las siguientes cadenas de sustituci\00F3n est\00E1n disponibles:</p>'),
'<ul>',
unistr('<li>#PAGINATION# - Se sustituye por el atributo de paginaci\00F3n</li>'),
unistr('<li>#COLCOUNT# - N\00FAmero de columnas HTML que se ampl\00EDan</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(46653434128.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_TABLE_ATTRIBUTES'
,p_item_sequence=>116
,p_item_plug_id=>wwv_flow_api.id(14532616069639696.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'OMIT'
,p_prompt=>'Atributos de Tabla (uso obsoleto: Omitir para no tener aplicaciones abiertas y cerrar una tabla)'
,p_source=>'ROW_TEMPLATE_TABLE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>100
,p_cMaxlength=>255
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Obsoleto. Utilice Omitir para un valor para desactivar esta funci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(50732358732.4001)
,p_name=>'F4000_P4654_RETUEN_TO_SELF'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(337523805.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Al activar esta casilla, despu\00E9s de aplicar los cambios en la plantilla, volver\00E1 a la p\00E1gina de edici\00F3n de plantilla y no a la p\00E1gina que estaba visualizando antes de editar la plantilla. Utilice esta funci\00F3n para editar la plantilla en una ventana y')
||unistr(' ejecutar la aplicaci\00F3n en otra.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4324032514158298.4001)
,p_name=>'F4000_P4654_PAGINATION_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(4323409658151759.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de Paginaci\00F3n')
,p_source=>'PAGINATION_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este atributo se aplica a la subplantilla de paginaci\00F3n completa. Puede realizar m\00E1s modificaciones en cada uno de los elementos de la subplantilla a continuaci\00F3n.</p>'),
'<p>Por ejemplo:</p>',
'<pre>&lt;span class="instructiontext"&gt;#TEXT#&lt;/span&gt;</pre>',
unistr('<p>Utilice la cadena de sustituci\00F3n #TEXT# donde desee que se muestre la subplantilla de paginaci\00F3n</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4327402217187418.4001)
,p_name=>'F4000_P4654_NEXT_PAGE_TEMPLATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(4323409658151759.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de P\00E1gina Siguiente')
,p_source=>'NEXT_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML para modificar c\00F3mo aparece la parte "P\00E1gina Siguiente" de la subplantilla de paginaci\00F3n.</p>'),
'<p>Por ejemplo:</p>',
'<pre>&lt;a href="#LINK#"&gt;siguiente&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4328218494192112.4001)
,p_name=>'F4000_P4654_PREV_PAGE_TEMPLATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(4323409658151759.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de P\00E1gina Anterior')
,p_source=>'PREVIOUS_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML para modificar c\00F3mo aparece la parte "P\00E1gina Anterior" de la subplantilla de paginaci\00F3n.</p>'),
'<p>Por ejemplo:</p>',
'<pre>&lt;a href="#LINK#"&gt;anterior&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4329112737199962.4001)
,p_name=>'F4000_P4654_PREV_SET_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(4323409658151759.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Juego Anterior'
,p_source=>'PREVIOUS_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML para modificar c\00F3mo aparece la parte "Juego Anterior" de la subplantilla de paginaci\00F3n.</p>'),
'<p>Por ejemplo:</p>',
'<pre>&lt;a href="#LINK#"&gt;juego anterior&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4329821741202564.4001)
,p_name=>'F4000_P4654_NEXT_SET_TEMPLATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(4323409658151759.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Juego Siguiente'
,p_source=>'NEXT_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el HTML para modificar c\00F3mo aparece la parte "Juego Siguiente" de la subplantilla de paginaci\00F3n.</p>'),
'<p>Por ejemplo:</p>',
'<pre>&lt;a href="#LINK#"&gt;juego siguiente&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(14466107721334507.4001)
,p_name=>'F4000_P4654_COLUMN_HEADING_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(14467922958338901.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Cabecera de Columna'
,p_source=>'COLUMN_HEADING_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este atributo se utiliza s\00F3lo con plantillas de columnas gen\00E9ricas. Utilice esta plantilla para colorear cada celda de cabecera de columna. El texto de este atributo debe incluir ayuda para indicar d\00F3nde se va a colorear el texto de la cabecera de')
||' celda.</p>',
'',
'<p>Si no introduce una plantilla de cabecera de columna, se aplica una por defecto. Si no desea ninguna cabecera de columna, introduzca "OMIT".</p>',
'<p>',
'Por ejemplo:</p>',
'<pre>',
' &lt;th #ALIGNMENT#&gt;#COLUMN_HEADER#&lt;/th&gt;',
'</pre>',
unistr('<p>El soporte de las cabeceras de columna con plantillas de fila (columna con nombre) se interrumpir\00E1 con la siguiente versi\00F3n. Las cabeceras de las plantillas de fila se deben definir en "Antes de Filas" con las sustituciones #1# de posici\00F3n de colu')
||'mna.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30680411168394404.4001)
,p_name=>'P4654_TRANSLATABLE'
,p_item_sequence=>32
,p_item_plug_id=>wwv_flow_api.id(334466077.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34519123555031875.4001)
,p_name=>'F4000_P4654_REFRESH'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(1517532632413488001.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_row_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P4654_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79198417617521783.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_TYPE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(334466077.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NAMED_COLUMNS'
,p_prompt=>'Tipo de Plantilla'
,p_source=>'ROW_TEMPLATE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ROW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(84775019904954668.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra el tipo de plantilla: <strong>Columnas con Nombre</strong> o <strong>Columnas Gen\00E9ricas</strong>.</p>'),
'',
unistr('<p>Las plantillas del tipo Columnas con Nombre hacen referencia a nombres de columna en la plantilla, mientras que las plantillas del tipo Columnas Gen\00E9ricas hacen referencia a #COLUMN_VALUE# en la plantilla.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79216121209611292.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND1'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Fila 1')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Puede seleccionar una condici\00F3n que se debe cumplir para aplicar esta plantilla de fila. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79221416884628515.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND2'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Fila 2')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Puede seleccionar una condici\00F3n que se debe cumplir para aplicar esta plantilla de fila. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79222113433630086.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND3'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Fila 3')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Puede seleccionar una condici\00F3n que se debe cumplir para aplicar esta plantilla de fila. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(79222810845631287.4001)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND4'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_api.id(335468967.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>unistr('Condici\00F3n de Plantilla de Fila 4')
,p_source=>'ROW_TEMPLATE_DISPLAY_COND4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_api.id(84871821607428292.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Condici\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Puede seleccionar una condici\00F3n que se debe cumplir para aplicar esta plantilla de fila. Puede seleccionar n\00FAmeros de fila pares o impares, o bien proporcionar una expresi\00F3n PL/SQL.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(91279426390006921.4001)
,p_name=>'P4654_THEME_ID'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(334466077.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tema'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica una recopilaci\00F3n de plantillas que definen el aspecto de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(93879326521016469.4001)
,p_name=>'P4654_THEME_CLASS_ID'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(334466077.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(44022800298370465.4001)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('La clase de plantilla identifica el uso espec\00EDfico de esta plantilla. La clase de plantilla se utiliza al cambiar de tema. Se realiza una coincidencia de clases de plantilla al cambiar de tema, permitiendo realizar el cambio de tema sin tener que asi')
||'gnar todas las plantillas de forma manual.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164372613373020267.4001)
,p_name=>'F4000_P4654_REFERENCE_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(1517532632413488001.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Informe Maestro de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REPORT_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||wwv_flow_escape.html(row_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_row_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede seleccionar una plantilla existente en esta aplicaci\00F3n u otra plantilla en el esquema de espacios de trabajo. Al seleccionar una plantilla existente, se convertir\00E1 en un suscriptor a esa plantilla.</p>'),
'',
'<p>Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <strong>Refrescar</strong>.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094587257527933041.4001)
,p_name=>'P4654_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1094587077987933039.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo JavaScript para el c\00F3digo que se va a cargar en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code> ')
||unistr('para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n tiene acceso a la caden')
||unistr('a de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>script</code> de apertura o de cierre. Incluya solo la URL.',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.js de /myjs/minified/ para vistas de p\00E1gina normales y main.js de /myjs/ en el modo de depuraci\00F3n.'),
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si la biblioteca se utiliza tambi\00E9n desde una llamada de solicitud de RequireJS. El nombre de definici\00F3n debe coincidir con el que se utilice en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global')
||' que muestre la biblioteca. Solo se aplica al utilizar RequireJS. Esto evita que RequireJS cargue la biblioteca una segunda vez.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.'),
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.'),
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que, cuando se cambie la versi\00F3n de la aplicaci\00F3n (y se incremente la versi\00F3n), se indicar\00E1 al explorador que siempre')
||unistr(' cargue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094587300769933042.4001)
,p_name=>'P4654_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1094587181132933040.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada que se van a cargar para esta plantilla de p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea. Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci')
||unistr('\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n. Tambi\00E9n t')
||unistr('iene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
'',
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>',
'',
'<p>',
'Ejemplos:',
'<ul>',
unistr('  <li>Referencia de archivo est\00E1ndar'),
'      <pre>/mycss/main.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n.'),
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Consulta de medios condicional',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
unistr('  <li>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n, de forma que cuando se cambia la versi\00F3n de la aplicaci\00F3n (y se incrementa la versi\00F3n), se indica al explorador que siempre ca')
||unistr('rgue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.'),
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1094587408055933043.4001)
,p_name=>'P4654_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1094587077987933039.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ejecutar Cuando Se Cargue la P\00E1gina')
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript que se ejecutar\00E1 cuando se cargue la p\00E1gina. Este c\00F3digo se ejecuta despu\00E9s del c\00F3digo JavaScript generado por &PRODUCT_NAME..</p>'),
'',
unistr('<p>Nota: No es necesario agregar etiquetas <code>script</code> de apertura o de cierre, solo el c\00F3digo JavaScript.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1499573466654561729.4001)
,p_name=>'P4654_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select o.display_name as d,',
'         o.css_classes as r,',
'         null default_template_options,',
'         null,',
'         o.help_text,',
'         (select display_name ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) group_name,',
'         (select is_advanced ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) advanced_group,',
'         (select null_text ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) null_text          ',
'    from wwv_flow_template_options o, wwv_flow_row_templates t',
'   where o.flow_id = :FB_FLOW_ID',
'     and template_types = ''REPORT''',
'     and (o.report_template_id = :F4000_P4654_ID or o.report_template_id is NULL)',
'     and t.theme_id = o.theme_id',
'     and t.id = :F4000_P4654_ID     ',
'  order by group_name nulls first, display_name',
''))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1499573659126561731.4001)
,p_name=>'P4654_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>235
,p_item_plug_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_row_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.report_template_id',
'   and report_template_id = :F4000_P4654_ID',
'order by group_name nulls first, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104786427191065739.4001)
,p_name=>'P4654_THEME_IS_SUBSCRIBED'
,p_item_sequence=>225
,p_item_plug_id=>wwv_flow_api.id(334466077.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104787120662069906.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4654_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_row_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P4654_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34527315145035803.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4654_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164421208592067969.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4654_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(164357816901006904.4001)
,p_associated_item=>wwv_flow_api.id(164372613373020267.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164431029498073482.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>10
,p_validation=>'F4000_P4654_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(164357816901006904.4001)
,p_associated_item=>wwv_flow_api.id(164372613373020267.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846499535666131710.4001)
,p_name=>'Cond 4 Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND4'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND4'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846499615362131711.4001)
,p_event_id=>wwv_flow_api.id(846499535666131710.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846499761800131712.4001)
,p_event_id=>wwv_flow_api.id(846499535666131710.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846499837540131713.4001)
,p_name=>'Cond 3 Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND3'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND3'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846500045628131715.4001)
,p_event_id=>wwv_flow_api.id(846499837540131713.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846500177557131716.4001)
,p_event_id=>wwv_flow_api.id(846499837540131713.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846500211556131717.4001)
,p_name=>'Cond 2 Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND2'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND2'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846500645156131721.4001)
,p_event_id=>wwv_flow_api.id(846500211556131717.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846500949666131724.4001)
,p_event_id=>wwv_flow_api.id(846500211556131717.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(846500475003131719.4001)
,p_name=>'Cond 1 Change'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND1'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND1'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846500782834131722.4001)
,p_event_id=>wwv_flow_api.id(846500475003131719.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(846500829611131723.4001)
,p_event_id=>wwv_flow_api.id(846500475003131719.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2395319162935114201.4001)
,p_name=>'Refresh Template Options'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1499573297318561724.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2395319292890114202.4001)
,p_event_id=>wwv_flow_api.id(2395319162935114201.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4654:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2395319393342114203.4001)
,p_name=>'Refresh Template Options after Edit'
,p_event_sequence=>60
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2395319427479114204.4001)
,p_event_id=>wwv_flow_api.id(2395319393342114203.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1499572493724561712.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4654:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(323434642.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_ROW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_row_templates',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4654_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_ROW_TEMPLATES'',',
'  p_rowid       => v(''F4000_P4654_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164455400600086959.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P4654_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4654_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(164357816901006904.4001)
,p_process_when=>'F4000_P4654_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(324434648.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ROW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4654_ID is null',
'or exists (select 1 from wwv_flow_row_templates',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4654_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_ROW_TEMPLATES'',',
'p_rowid       => v(''F4000_P4654_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Cambios en la plantilla de fila &F4000_P4654_ROW_TEMPLATE_NAME. procesados.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(34536928287044948.4001)
,p_process_sequence=>25
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P4654_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4654_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(306434612.4001)
,p_process_when=>':F4000_P4654_REFERENCE_ID is not null and :F4000_P4654_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164466811371097141.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_report_reference_id (:F4000_P4654_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when_button_id=>wwv_flow_api.id(306434612.4001)
,p_process_when=>'F4000_P4654_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
);
end;
/
prompt --application/pages/page_04655
begin
wwv_flow_api.create_page(
 p_id=>4655.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Plantillas de Lista'
,p_step_title=>'Editar Plantilla de Lista'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_list_templates t, wwv_flow_themes th',
'where t.id = :F4000_P4655_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt_list.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(53950891417.4001)
,p_plug_name=>unistr('Definici\00F3n de la Plantilla')
,p_region_name=>'ELE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'generated 30-MAY-2000 13:41:50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(863509230394959.4001)
,p_plug_name=>'Entrada de Sublista'
,p_region_name=>'SLI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(878916409690360.4001)
,p_plug_name=>'Antes de Entrada de Sublista'
,p_region_name=>'BSL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(881526929702883.4001)
,p_plug_name=>'Tras Entrada de Sublista'
,p_region_name=>'ASL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(33420204617089509.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4655_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_02=>'LIST_TEMPLATE_NAME'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'F4000_P4655_REFERENCE_ID'
,p_attribute_05=>'SUBSCRIBE_TEMPLATE'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46257112265679008.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61176810813006870.4001)
,p_plug_name=>'Plantillas de Lista'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una lista es una recopilaci\00F3n con nombre de enlaces. Puede controlar el aspecto de una lista a trav\00E9s de las plantillas de lista.</p>'),
unistr('<p>Cada elemento de lista tiene una condici\00F3n de visualizaci\00F3n que permite controlar cu\00E1ndo aparece. Al utilizar atributos de plantilla, tambi\00E9n puede definir un elemento de lista para que sea "actual" o "no actual" para una p\00E1gina espec\00EDfica.</p>')))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_item=>'F4000_P4769_ROWS'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato.')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(91234309210412885.4001)
,p_plug_name=>'Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(92904708571779507.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92837202675352059.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(116536510836697402.4001)
,p_plug_name=>'Nombre'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(116537606954699246.4001)
,p_plug_name=>'Antes de Entrada de Lista'
,p_region_name=>'BEF'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(116542925057706036.4001)
,p_plug_name=>unistr('Despu\00E9s de Entrada de Lista')
,p_region_name=>'AFT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(116550701119717119.4001)
,p_plug_name=>'Comentarios'
,p_region_name=>'COM'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(117210727055660187.4001)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(166159828806299946.4001)
,p_plug_name=>unistr('Cadenas de Sustituci\00F3n')
,p_region_name=>'SS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.list_template_sub_str(',
'    p_list_template_id => :F4000_P4655_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198130607764423244.4001)
,p_plug_name=>'Definiciones de Plantilla para Primera Entrada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(362350814362123456.4001)
,p_plug_name=>'JavaScript'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(362356910300179127.4001)
,p_plug_name=>'Hoja de Estilo en Cascada'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615449124546848074.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LIST_TEMPLATES',
'where id = :F4000_P4655_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4655_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(620324697529117358.4001)
,p_name=>'Opciones de Plantilla'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name display_name_no_link,',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o',
' where flow_id            = :FB_FLOW_ID',
'   and list_template_id   = :F4000_P4655_ID',
'   and security_group_id  = :WORKSPACE_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4655_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(620325418890117364.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932805706834193701.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME_NO_LINK'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_display_when_cond_type=>'NEVER'
,p_lov_show_nulls=>'YES'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(620324991839117364.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'YES'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688539200169377196.4001)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Secuencia'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(620325099275117364.4001)
,p_query_column_id=>5
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>5
,p_column_heading=>'Clases CSS'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688539303700377198.4001)
,p_query_column_id=>6
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Grupo'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688539446719377198.4001)
,p_query_column_id=>7
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>7
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(688592842784673826.4001)
,p_name=>'Opciones de Plantilla Global'
,p_parent_plug_id=>wwv_flow_api.id(620324697529117358.4001)
,p_template=>wwv_flow_api.id(689970285456172024.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  (select display_name ',
'   from wwv_flow_template_opt_groups',
'   where o.group_id = id) group_name,',
'  o.is_advanced',
'  from wwv_flow_template_options o,',
'       wwv_flow_list_templates t',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.virtual_template_id is NULL',
'   and o.template_types = ''LIST''',
'   and o.security_group_id  = :WORKSPACE_ID',
'   and o.theme_id = t.theme_id',
'   and t.id = :F4000_P4655_ID    ',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4655_DEFAULT_TEMPLATE_OPTIONS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha definido ninguna opci\00F3n de plantilla')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688593596508673828.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688593324266673828.4001)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688593074156673826.4001)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Secuencia'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688593488945673828.4001)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>4
,p_column_heading=>'Clases CSS'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688593150623673826.4001)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Grupo'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(688593293048673826.4001)
,p_query_column_id=>6
,p_column_alias=>'IS_ADVANCED'
,p_column_display_sequence=>6
,p_column_heading=>'Is Advanced'
,p_hidden_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_plug_name=>'Descripciones de Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>125
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_header=>unistr('Las cadenas de sustituci\00F3n #A01# - #A20# son atributos opcionales que se pueden utilizar en una plantilla de lista, para hacer referencia a valores de componentes. Utilice los atributos siguientes para especificar una descripci\00F3n m\00E1s significativa de')
||unistr(' las cadenas de sustituci\00F3n que se utilizan en la plantilla de lista actual.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2104731459324667496.4001)
,p_plug_name=>unistr('Suscripci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>25
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4655_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4655_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(189859532094856279.4001)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(189859422332856279.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166454708756084778.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(33420204617089509.4001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Publicar Plantilla'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4655_ID.,&FLOW_PAGE_ID.,LIST'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_list_templates',
'',
'where reference_id = :F4000_P4655_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(164147432233017788.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(33420204617089509.4001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Refrescar'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_list_templates',
'',
'where id = :F4000_P4655_ID',
'',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(620325525881117365.4001)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_api.id(620324697529117358.4001)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar Opci\00F3n de Plantilla')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:406:&SESSION.::&DEBUG.:406:P406_THEME_ID,P406_LIST_TEMPLATE_ID,P406_TEMPLATE_TYPES:&P4655_THEME_ID.,&F4000_P4655_ID.,LIST'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53951891421.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53952891421.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.::P278_ID:&F4000_P4655_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''F4000_P4655_ID'') is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53953891421.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''F4000_P4655_ID'') is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(53954891422.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''F4000_P4655_ID'') is null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(189865230056856313.4001)
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.::F4000_P4655_ID:&P4655_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(189859422332856279.4001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(189865623363856315.4001)
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.::F4000_P4655_ID:&P4655_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(189859532094856279.4001)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(164147824403017790.4001)
,p_branch_action=>'4655'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(164147432233017788.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(27882730416277606.4001)
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4655_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(117338403992438825.4001)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53955891424.4001)
,p_name=>'F4000_P4655_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(117210727055660187.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53957891426.4001)
,p_name=>'F4000_P4655_LIST_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(116536510836697402.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'LIST_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Define un nombre que identifica la plantilla.<p />',
'Utilice la casilla de control <strong>Se Puede Convertir</strong> para indicar que la plantilla contiene cadenas de texto que hay que convertir.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53958891427.4001)
,p_name=>'F4000_P4655_LIST_TEMPLATE_CURRENT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(53950891417.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr><td><img src=#IMAGE_PREFIX##IMAGE# border=0 #IMAGE_ATTR#></td><td><a href="#LINK#">#TEXT#</a></td></tr>'
,p_prompt=>'Plantilla de Lista Actual'
,p_source=>'LIST_TEMPLATE_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML o texto que se sustituir\00E1 en la plantilla de lista seleccionada (o actual). ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53959891427.4001)
,p_name=>'F4000_P4655_LIST_TEMPLATE_NONCURRENT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(53950891417.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr><td><img src=#IMAGE_PREFIX##IMAGE# border=0 #IMAGE_ATTR#></td><td><a href="#LINK#">#TEXT#</a></td></tr>'
,p_prompt=>'Plantilla de Lista No Actual'
,p_source=>'LIST_TEMPLATE_NONCURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML o texto que se sustituir\00E1 en la plantilla de lista no seleccionada (o no actual). ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53960891429.4001)
,p_name=>'F4000_P4655_LIST_TEMPLATE_BEFORE_ROWS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(116537606954699246.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table>'
,p_prompt=>'Plantilla de Lista Antes de Filas (por ejemplo &lt;table&gt; &lt;tr&gt;)'
,p_source=>'LIST_TEMPLATE_BEFORE_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca el HTML que aparece antes de cualquier elemento de la lista. Puede utilizar este atributo para abrir una tabla HTML o una fila de la tabla HTML.',
'',
unistr('Puede utilizar la cadena de sustituci\00F3n #COMPONENT_CSS_CLASSES# para solicitar una clase CSS a la plantilla de ruta de navegaci\00F3n. Las clases CSS de componente se definen en la p\00E1gina de edici\00F3n de regi\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53961891429.4001)
,p_name=>'F4000_P4655_LIST_TEMPLATE_AFTER_ROWS'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(116542925057706036.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>unistr('Plantilla de Lista Despu\00E9s de Filas (por ejemplo &lt;/tr&gt; &lt;/table&gt;)')
,p_source=>'LIST_TEMPLATE_AFTER_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('\00C9ste es el HTML que aparece despu\00E9s de mostrar todos los elementos de la lista. Puede utilizar este atributo para cerrar una tabla HTML abierta en el atributo Antes de Elementos de Lista.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(53962891430.4001)
,p_name=>'F4000_P4655_LIST_TEMPLATE_COMMENT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(116550701119717119.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'LIST_TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>unistr('Comentarios o notas del desarrollador. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(866504953459981.4001)
,p_name=>'P4655_BETWEEN_ITEMS'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(53950891417.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Entre Elementos de Lista'
,p_source=>'BETWEEN_ITEMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('\00C9ste es el HTML que aparece entre los elementos de la lista. Si no se especifica el HTML, se ignorar\00E1 este atributo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(870702192534844.4001)
,p_name=>'P4655_BEFORE_SUB_LIST'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(878916409690360.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Sublista para Antes de Filas'
,p_source=>'BEFORE_SUB_LIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el HTML que aparece antes de cualquier elemento de sublista. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(873918084586721.4001)
,p_name=>'P4655_BETWEEN_SUB_LIST_ITEMS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(863509230394959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Entre Elementos de Sublista'
,p_source=>'BETWEEN_SUB_LIST_ITEMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('\00C9ste es el HTML que aparece entre los elementos de la sublista. Si no se especifica ning\00FAn HTML, se ignorar\00E1 este atributo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(877229653675208.4001)
,p_name=>'P4655_SUB_LIST_ITEM_NONCURRENT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(863509230394959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Sublista No Actual'
,p_source=>'SUB_LIST_ITEM_NONCURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML o texto que se sustituir\00E1 para la plantilla de sublista no seleccionada (o no actual). ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(882722558711005.4001)
,p_name=>'P4655_SUB_LIST_ITEM_CURRENT'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(863509230394959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Sublista Actual'
,p_source=>'SUB_LIST_ITEM_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML o texto que se sustituir\00E1 para la plantilla de sublista seleccionada (o actual). ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(891205420743950.4001)
,p_name=>'P4655_AFTER_SUB_LIST'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(881526929702883.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Plantilla de Sublista para Despu\00E9s de Filas')
,p_source=>'AFTER_SUB_LIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el HTML que aparece despu\00E9s de cualquier elemento de sublista. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1432809553325533.4001)
,p_name=>'P4655_TEMP_CURR_W_CHILD'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(53950891417.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Lista Actual con Elementos de Sublista'
,p_source=>'ITEM_TEMPLATE_CURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('HTML o texto que se sustituir\00E1 para la plantilla de lista seleccionada (o actual) que se utiliza cuando el elemento tiene elementos de sublista. Si no se especifica, se utilizar\00E1 la plantilla de elementos de lista actual. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1494705819579926.4001)
,p_name=>'P4655_ITEM_TEMPLATE_NONCURR_W_CHILD'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(53950891417.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Lista No Actual con Elementos de Sublista'
,p_source=>'ITEM_TEMPLATE_NONCURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('HTML o texto que se sustituir\00E1 para la plantilla de lista no seleccionada (o no actual) que se utiliza cuando el elemento tiene elementos de sublista. Si no se especifica, se utilizar\00E1 la plantilla de elementos de lista actual. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1501303357626555.4001)
,p_name=>'P4655_SUB_TEMPLATE_CURR_W_CHILD'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(863509230394959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Sublista Actual con Elementos de Sublista'
,p_source=>'SUB_TEMPLATE_CURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('HTML o texto que se sustituir\00E1 para la plantilla de sublista seleccionada (o actual) que se utiliza cuando un elemento tiene entradas de sublista. Si no se especifica, se utilizar\00E1 la plantilla de elementos de sublista actual. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1505327729643081.4001)
,p_name=>'P4655_SUB_TEMPLATE_NONCURR_W_CHILD'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(863509230394959.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Sublista No Actual con Elementos de Sublista'
,p_source=>'SUB_TEMPLATE_NONCURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('HTML o texto que se sustituir\00E1 para la plantilla de lista no seleccionada (o no actual) que se utiliza cuando el elemento tiene elementos de sublista. Si no se especifica, se utilizar\00E1 la plantilla de elementos de lista actual. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(24152211131529435.4001)
,p_name=>'P4655_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(116536510836697402.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TRANSLATABLE_Y'
,p_lov=>'.'||wwv_flow_api.id(84791208054045923.4001)||'.'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27877514008263344.4001)
,p_name=>'F4000_P4655_RETURN_TO_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(61176810813006870.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla de control para volver a esta p\00E1gina despu\00E9s de aplicar los cambios.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(35406214013635329.4001)
,p_name=>'F4000_P4655_REFRESH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(33420204617089509.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REFRESH_Y'
,p_lov=>'.'||wwv_flow_api.id(86078519684815185.4001)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'',
'from wwv_flow_list_templates',
'',
'where reference_id is null',
'',
'and id = :F4000_P4655_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(40824816501451172.4001)
,p_name=>'P4655_N'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre:'
,p_source=>'select LIST_TEMPLATE_NAME from WWV_FLOW_LIST_TEMPLATES where id = :F4000_P4655_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre de la plantilla'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43851908984899903.4001)
,p_name=>'P4655_THEME_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(116536510836697402.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Tema:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indica el tema del que es miembro la plantilla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43939103789248532.4001)
,p_name=>'P4655_TEMPLATE_CLASS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(116536510836697402.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Clase de Plantilla'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST THEME CLASS ID'
,p_lov=>'.'||wwv_flow_api.id(43918610013174571.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Identificado -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Identifica un uso espec\00EDfico para esta plantilla.</div>'),
unistr('<div class="htmldbInfoBodyP">Cuando se cambia a un nuevo tema, todas las plantillas de un tema se asignan a las plantillas correspondientes del otro tema. El creador de aplicaciones realiza esta asignaci\00F3n de plantillas mediante la asignaci\00F3n de iden')
||'tificadores de clase de plantilla.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(164153822587028317.4001)
,p_name=>'F4000_P4655_REFERENCE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(33420204617089509.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla Maestra de Referencia de'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from(',
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -''  d, 0 r, 1 ob',
'  from dual ',
' union all',
'select flow_id||'' : ''||wwv_flow_escape.html(list_template_name)||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r,2 ob',
'  from wwv_flow_list_templates',
' where flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'    select f.id',
'      from wwv_flows f',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID and',
'           build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'       and exists (',
'               select 1 ',
'                 from wwv_flow_developers',
'                where userid = :FLOW_USER ',
'                  and ( flow_id is null or flow_id = f.id )',
'                  and security_group_id = :FLOW_SECURITY_GROUP_ID)',
'',
'))',
'order by ob,d'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Puede seleccionar una plantilla existente en este espacio de trabajo u otra plantilla en el esquema del espacio de trabajo. Al seleccionar una plantilla existente, se convierte en suscriptor de esa plantilla.</div>',
'<div class="htmldbInfoBodyP">Para cargar una nueva copia de cualquier plantilla maestra, haga clic en <span class="fielddatabold">Refrescar</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189863125869856297.4001)
,p_name=>'P4655_ID_NEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(117210727055660187.4001)
,p_prompt=>'P4655_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189863505587856298.4001)
,p_name=>'P4655_ID_PREV'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(117210727055660187.4001)
,p_prompt=>'P4655_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(189863819454856300.4001)
,p_name=>'P4655_ID_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(91234309210412885.4001)
,p_prompt=>'Plantillas de Lista: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Edite una plantilla de lista.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198130823001427613.4001)
,p_name=>'P4655_FIRST_LIST_TEMPLATE_NONCURRENT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(198130607764423244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Lista No Actual (Primera)'
,p_source=>'FIRST_LIST_TEMPLATE_NONCURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si se define, se utilizar\00E1 para el primer elemento de lista. '),
'<p/>',
'Introduzca el HTML o el texto que se va a sustituir para la plantilla de lista no seleccionada (o no actual).'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198131100622430662.4001)
,p_name=>'P4655_FIRST_LIST_TEMPLATE_CURRENT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(198130607764423244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Lista Actual (Primera)'
,p_source=>'FIRST_LIST_TEMPLATE_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si se define, se utilizar\00E1 para el primer elemento de lista. '),
'<p/>',
'Introduzca el HTML o el texto que se va a sustituir para la plantilla de lista seleccionada (o actual).'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198131414128434500.4001)
,p_name=>'P4655_F_ITEM_TEMPLATE_CURR_W_CHILD'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(198130607764423244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Lista Actual con Elementos de Sublista (Primera)'
,p_source=>'F_ITEM_TEMPLATE_CURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si se define, se utilizar\00E1 para el primer elemento de lista.'),
'<p/>',
'HTML o texto que se va a sustituir para la plantilla de lista seleccionada (o actual) que se utiliza cuando el elemento tiene elementos de sublista.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198131625210437755.4001)
,p_name=>'P4655_FITEM_TEMPLATE_NONCURR_W_CHILD'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(198130607764423244.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla de Lista No Actual con Elementos de Sublista (Primera)'
,p_source=>'FITEM_TEMPLATE_NONCURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si se define, se utilizar\00E1 para el primer elemento de lista. '),
'<p/>',
unistr('HTML o texto que se sustituir\00E1 para la plantilla de lista no seleccionada (o no actual) que se utiliza cuando el elemento tiene elementos de sublista.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362351229679132568.4001)
,p_name=>'P4655_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(362350814362123456.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362356523832165685.4001)
,p_name=>'P4655_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(362350814362123456.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Ejecutar Cuando Se Cargue la P\00E1gina')
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362357400312191793.4001)
,p_name=>'P4655_CSS_FILE_URLS'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(362356910300179127.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL de Archivo'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(362357711730201651.4001)
,p_name=>'P4655_INLINE_CSS'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(362356910300179127.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('En L\00EDnea')
,p_source=>'INLINE_CSS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>15
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'CSS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628726730040564066.4001)
,p_name=>'P4655_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(620324697529117358.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla Predefinida:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select o.display_name as d,',
'         o.css_classes as r,',
'         null default_template_options,',
'         null,',
'         o.help_text,',
'         (select display_name ',
'          from wwv_flow_template_opt_groups',
'          where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group,',
'       (select null_text ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) null_text  ',
'    from wwv_flow_template_options o,',
'         wwv_flow_list_templates t',
'   where o.flow_id = :FB_FLOW_ID',
'     and o.template_types = ''LIST''',
'     and (o.list_template_id = :F4000_P4655_ID or o.list_template_id is NULL)',
'     and o.theme_id = t.theme_id',
'     and t.id = :F4000_P4655_ID        ',
'  order by advanced_group nulls first, group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(628727081637569112.4001)
,p_name=>'P4655_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(620324697529117358.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Opciones de Plantilla por Defecto:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_list_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.list_template_id',
'   and list_template_id = :F4000_P4655_ID',
'order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1145991925650648502.4001)
,p_name=>'P4655_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(116536510836697402.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identificador'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identificador de plantilla, que se utiliza al alternar y cambiar la versi\00F3n de los temas y no se puede modificar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1449462967556055532.4001)
,p_name=>'P4655_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(620324697529117358.4001)
,p_source=>'F4000_P4655_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480976054644303108.4001)
,p_name=>'P4655_A01_LABEL'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A01#')
,p_source=>'A01_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A01#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480976225407303110.4001)
,p_name=>'P4655_A02_LABEL'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A02#')
,p_source=>'A02_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A02#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480976490053303110.4001)
,p_name=>'P4655_A03_LABEL'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A03#')
,p_source=>'A03_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A03#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480976660937303111.4001)
,p_name=>'P4655_A04_LABEL'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A04#')
,p_source=>'A04_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A04#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480976827847303111.4001)
,p_name=>'P4655_A05_LABEL'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A05#')
,p_source=>'A05_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A05#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480977012044303111.4001)
,p_name=>'P4655_A06_LABEL'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A06#')
,p_source=>'A06_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A06#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480977242318303111.4001)
,p_name=>'P4655_A07_LABEL'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A07#')
,p_source=>'A07_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A07#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480977468973303111.4001)
,p_name=>'P4655_A08_LABEL'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A08#')
,p_source=>'A08_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A08#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480977697345303111.4001)
,p_name=>'P4655_A09_LABEL'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A09#')
,p_source=>'A09_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A09#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480977837986303112.4001)
,p_name=>'P4655_A10_LABEL'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(1480974873547287737.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Descripci\00F3n de #A10#')
,p_source=>'A10_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique una breve descripci\00F3n para la cadena de sustituci\00F3n #A10#, con el fin de ayudar a comprender su uso en la plantilla de lista actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2104719075582639696.4001)
,p_name=>'P4655_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(116536510836697402.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2104721203868650107.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4655_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_list_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P4655_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;',
''))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(35423021764646951.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4655_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164167822994058498.4001)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4655_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Para refrescar la plantilla, se debe especificar el identificador de referencia.'
,p_when_button_pressed=>wwv_flow_api.id(164147432233017788.4001)
,p_associated_item=>wwv_flow_api.id(164153822587028317.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(164172311564063782.4001)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P4655_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Se debe especificar la plantilla que se va a refrescar.'
,p_when_button_pressed=>wwv_flow_api.id(164147432233017788.4001)
,p_associated_item=>wwv_flow_api.id(164153822587028317.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(150708028965162693.4001)
,p_validation_name=>'NameMand'
,p_validation_sequence=>30
,p_validation=>'F4000_P4655_LIST_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre de la plantilla.'
,p_when_button_pressed=>wwv_flow_api.id(53953891421.4001)
,p_associated_item=>wwv_flow_api.id(53957891426.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397308601327565118.4001)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4655_ID_PREV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397308917097565118.4001)
,p_event_id=>wwv_flow_api.id(397308601327565118.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(189859532094856279.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(397309007215566768.4001)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4655_ID_NEXT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(397309312777566769.4001)
,p_event_id=>wwv_flow_api.id(397309007215566768.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(189859422332856279.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(620342650349327812.4001)
,p_name=>'refresh template options after edit'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(620324697529117358.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751207435772801.4001)
,p_event_id=>wwv_flow_api.id(620342650349327812.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(620324697529117358.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4655:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(620343070098332770.4001)
,p_name=>'refresh template options'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(620325525881117365.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2087751396515772802.4001)
,p_event_id=>wwv_flow_api.id(620343070098332770.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(620324697529117358.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'  apex.navigation.redirect(''f?p=4000:4655:&SESSION.::&DEBUG.'');',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(53963891433.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(189864825006856309.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'LIST_TEMPLATE_NAME'
,p_attribute_09=>'P4655_ID_NEXT'
,p_attribute_10=>'P4655_ID_PREV'
,p_attribute_13=>'P4655_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164182328576086354.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'referesh template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_list_template (',
'    p_master_template_id         => :F4000_P4655_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4655_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(164147432233017788.4001)
,p_process_when=>'F4000_P4655_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(53964891433.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LIST_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(35430002355655896.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_list_template (',
'    p_master_template_id         => :F4000_P4655_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4655_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al copiar la plantilla.'
,p_process_when_button_id=>wwv_flow_api.id(53953891421.4001)
,p_process_when=>':F4000_P4655_REFERENCE_ID is not null and :F4000_P4655_REFRESH = ''Y'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plantilla copiada.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1449463095706055533.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_list_tmplopt_presets(:F4000_P4655_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P4655_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P4655_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(164178515218077277.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_list_reference_id (:F4000_P4655_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al definir el identificador de plantilla en nulo.'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
);
end;
/
prompt --application/pages/page_04656
begin
wwv_flow_api.create_page(
 p_id=>4656.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso de Plantilla'
,p_step_title=>'Uso de Plantilla'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212879727923324936)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_rpts.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133434464852.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(12437772301.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(304382492121.4001)
,p_plug_name=>'Uso de Plantilla'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra el uso de plantillas en la aplicaci\00F3n actual para todos los tipos de plantillas. El n\00FAmero de la columna Referencias indica el n\00FAmero total de p\00E1ginas que utilizan la plantilla espec\00EDfica.</p>'),
unistr('<p>Para ver detalles adicionales, haga clic en el n\00FAmero. Para editar una plantilla, haga clic en el nombre de la plantilla.</p>'),
''))
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_break_cols=>'1:2'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5297711133003335.4001)
,p_name=>'Uso de Plantilla'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>5
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q           varchar2(32767) := null;',
'    l_page      varchar2(512);',
'    l_pages     varchar2(512);',
'    l_region    varchar2(512);',
'    l_report    varchar2(512);',
'    l_list      varchar2(512);',
'    l_label     varchar2(512);',
'    l_button    varchar2(512);',
'    l_menu      varchar2(512);',
'    l_calendar  varchar2(512);',
'begin',
'select wwv_flow_lang.system_message_lit(''CONFIRM.PAGES''),',
'       wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'       wwv_flow_lang.system_message_lit(''REPORT''),',
'       wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'       wwv_flow_lang.system_message_lit(''LABEL''),',
'       wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'       wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'       wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'')',
'  into l_page,',
'       l_region,',
'       l_report,',
'       l_list,',
'       l_label,',
'       l_button,',
'       l_menu,',
'       l_calendar',
'  from dual;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Page'') = ''Page'') then',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_page||'''''' ttype, '';     ',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4307:''||:FLOW_SESSION||''::NO:4307:F4000_P4307_ID:''''||id, '';',
'      q :=q||'' wwv_flow_escape.html(name)) tname, ''; ',
'      q :=q||'' wwv_flow_theme_manager.get_page_util(:fb_flow_id,p.id)  utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.page_template_ref_count(:fb_flow_id,p.id) references ''; ',
'      q :=q||''from wwv_flow_templates p '';',
'      q :=q||''where p.flow_id = :fb_flow_id '';',
'      q :=q||''  and p.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (p.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Region'') = ''Region'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_region||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4653:''''||:flow_session||''''::NO:4653:F4000_P4653_ID:''''||id, '';',
'      q :=q||'' wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME)) tname, '';',
'      q :=q||'' wwv_flow_theme_manager.get_region_util(:fb_flow_id,r.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.region_template_ref_count(:fb_flow_id,r.id) references ''; ',
'      q :=q||''from wwv_flow_page_plug_templates r '';',
'      q :=q||''where r.flow_id = :fb_flow_id '';',
'      q :=q||''  and r.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (r.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'    ',
'    if (nvl(:F4000_P4656_SHOW,''Report'') = ''Report'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_report||'''''' ttype, '';     ',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4654:''''||:flow_session||''''::NO:4654:F4000_P4654_ID:''''||id, '';',
'      q :=q||'' wwv_flow_escape.html(ROW_TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_report_util(:fb_flow_id,ro.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.report_template_ref_count(:fb_flow_id,ro.id) references ''; ',
'      q :=q||''from wwv_flow_row_templates ro '';',
'      q :=q||''where ro.flow_id = :fb_flow_id '';',
'      q :=q||''  and ro.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (ro.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''List'') = ''List'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';            ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_list||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4655:''||:FLOW_SESSION||''::NO:4655:F4000_P4655_ID:''''||id, '';      ',
'      q :=q||''wwv_flow_escape.html(LIST_TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_list_util(:fb_flow_id,l.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.list_template_ref_count(:fb_flow_id,l.id) references ''; ',
'      q :=q||''from wwv_flow_list_templates l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''  and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (l.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Field'') = ''Field'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_label||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:85:''''||:flow_session||''''::NO:85:F4000_P85_ID:''''||id, '';',
'      q :=q||''wwv_flow_escape.html(TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_field_util(:fb_flow_id,f.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.label_template_ref_count(:fb_flow_id,f.id) references ''; ',
'      q :=q||''from wwv_flow_field_templates f '';',
'      q :=q||''where f.flow_id = :fb_flow_id '';',
'      q :=q||''  and f.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (f.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Button'') = ''Button'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_button||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:204:''||:FLOW_SESSION||''::NO:204:F4000_P204_ID:''''||id, '';',
'      q :=q||''wwv_flow_escape.html(TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_button_util(:fb_flow_id,b.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.button_template_ref_count(:fb_flow_id,b.id) references ''; ',
'      q :=q||''from wwv_flow_button_templates b '';',
'      q :=q||''where b.flow_id = :fb_flow_id '';',
'      q :=q||''  and b.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (b.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Menu'') = ''Menu'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_menu||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:289:''||:FLOW_SESSION||''::NO:289:F4000_P289_ID:''''||id, '';',
'      q :=q||''wwv_flow_escape.html(NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_menu_util(:fb_flow_id,m.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.breadcrumb_template_ref_count(:fb_flow_id,m.id) references ''; ',
'      q :=q||''from wwv_flow_menu_templates m '';',
'      q :=q||''where m.flow_id = :fb_flow_id '';',
'      q :=q||''  and m.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (m.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Calendar'') = ''Calendar'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';            ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_calendar||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:122:''||:FLOW_SESSION||''::NO:122:P122_ID:''''||id, '';      ',
'      q :=q||''wwv_flow_escape.html(NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_cal_util(:fb_flow_id,l.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.calendar_template_ref_count(:fb_flow_id,l.id) references ''; ',
'      q :=q||''from wwv_flow_cal_templates l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''  and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (l.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    q := ltrim(q,''union all '');',
'    wwv_flow.debug(''XXX-''||q);',
'    q := ''select flow_id, theme_id, ttype, tname, utilization, references from (''||q||'') x where (:P4656_FIND is null or instr(upper(tname),upper(:P4656_FIND))>0)'';',
'    return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>6
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'1:2'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48825931314772408.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>5
,p_column_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48826023690772408.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>3
,p_column_heading=>'Tema'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48826100249772408.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>1
,p_column_heading=>'Tipo'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48826220199772408.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48826311255772408.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>4
,p_column_heading=>'Referencias'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48826422081772409.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114597106818824335.4001)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>2
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1599000348644951291.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_api.id(1598999842830947024.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5308530733024627.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(114597106818824335.4001)
,p_button_name=>'F4000_P4656_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114610217423836695.4001)
,p_branch_name=>'Go To Page 4656'
,p_branch_action=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GO'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(96115914230357187.4001)
,p_branch_action=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5306702494022579.4001)
,p_name=>'F4000_P4656_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114597106818824335.4001)
,p_prompt=>'Mostrar'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE_REPORT_ON'
,p_lov=>'.'||wwv_flow_api.id(84836411424340211.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todas las Plantillas -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Seleccione el tipo de plantilla que aparecer\00E1 y haga clic en <strong>Ir</strong>. Las opciones incluyen: <strong>Plantillas con Referencia</strong>, <strong>Plantillas sin Referencia</strong> y <strong>Todas las Plantillas</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62036901141708268.4001)
,p_name=>'P4656_THEME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(114597106818824335.4001)
,p_item_default=>'0'
,p_prompt=>'Tema'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un tema y haga clic en <strong>Ir</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(96064730928917258.4001)
,p_name=>'P4656_FIND'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(114597106818824335.4001)
,p_prompt=>'Nombre de la Plantilla'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca criterios de consulta que no sean sensibles a may\00FAsculas/min\00FAsculas para el nombre de la plantilla y haga clic en <strong>Ir</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_04700
begin
wwv_flow_api.create_page(
 p_id=>4700.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina')
,p_alias=>'WIZARDS'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_welcome_text=>' '
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.wizard-selection {',
'    display: block;',
'	float: left;',
'    width: 200px;',
'    height: 150px;',
'}'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5171110750420607.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44222430720621627.4001)
,p_plug_name=>'wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4294802795572966.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44222430720621627.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1670605725184234738.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44222430720621627.4001)
,p_button_name=>'HELP_R'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./htmdb/creating-report-create-page-wizard.html#GUID-0B017672-7523-412D-ADB2-E299D6CFACF5'');'
,p_button_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_button_condition2=>'REPORT'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1670605851393234739.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44222430720621627.4001)
,p_button_name=>'HELP_F'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./htmdb/using-a-wizard-to-create-a-form.html#GUID-A4B9D6BA-6C59-4B0A-88E1-E36D0682FFAE'');'
,p_button_condition=>'P259_CHOOSE_PAGE_TYPE'
,p_button_condition2=>'FORM'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21647132395619736.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(44222430720621627.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(21145714846754966.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(44222430720621627.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10796103039149268.4001)
,p_branch_name=>'Go To Page 4462'
,p_branch_action=>'f?p=&APP_ID.:4462:&SESSION.::&DEBUG.:4462,4464,4465,4466:P4462_REGION_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4700_SELECT_REPORT_TYPE LIKE ''NATIVE_%'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22101330287842647.4001)
,p_branch_name=>'Classic Report Page'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759,769,4716:P759_REPORT_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'CLASSIC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22105404576854204.4001)
,p_branch_name=>'Report and Form Page'
,p_branch_action=>'f?p=&APP_ID.:4041:&SESSION.::&DEBUG.:4703,4041,4775,4039,4776,4777,4778,4783,443,4735,4736:P4041_TYPE,F4000_P4703_REPORT_PAGE_ID:R,'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'REPORTANDFORM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22107726393860536.4001)
,p_branch_name=>'Form on Procedure'
,p_branch_action=>'f?p=&APP_ID.:4810:&SESSION.::&DEBUG.:4810,4711:P4810_FORM_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FORMONPROC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22108710248865269.4001)
,p_branch_name=>'Form Page'
,p_branch_action=>'f?p=&APP_ID.:4810:&SESSION.::&DEBUG.:4810,4812,4735,4736:P4810_FORM_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FORM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22110928256870511.4001)
,p_branch_name=>'Form & Report'
,p_branch_action=>'f?p=&APP_ID.:4041:&SESSION.::&DEBUG.:4703,4041,4775,4039,4776,4777,4778,4783,443,4735,4736:P4041_TYPE,F4000_P4703_REPORT_PAGE_ID:R,'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FORM_ON_A_TABLE_WITH_REPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(348967221928311756.4001)
,p_branch_name=>'Form on Table with Listview'
,p_branch_action=>'f?p=&APP_ID.:4041:&SESSION.::&DEBUG.:4703,4041,4775,4039,4776,4777,4778,4783,443,4735,4736:P4041_TYPE,F4000_P4703_REPORT_PAGE_ID,P4041_IMPLEMENTATION:L,,LISTVIEW'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FORM_ON_A_TABLE_WITH_LISTVIEW'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22113305661882902.4001)
,p_branch_name=>'Form on Web Service Page'
,p_branch_action=>'f?p=&APP_ID.:605:&SESSION.::&DEBUG.:600,605,884::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FORMWS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(30112130307712656.4001)
,p_branch_name=>'Report and Form on Web Service Page'
,p_branch_action=>'f?p=&APP_ID.:700:&SESSION.::&DEBUG.:700,705,720,725,730,735,842,848::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'REPORTANDFORMWS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22114218475886563.4001)
,p_branch_name=>'Summary Page'
,p_branch_action=>'f?p=&APP_ID.:5100:&SESSION.::&DEBUG.:5100,5105,5110,303,SUMMARY_ITEM:F4000_P5100_PAGE_ID:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'SUMMARY'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22116331634890347.4001)
,p_branch_name=>'Form on SQL Query Page'
,p_branch_action=>'f?p=&APP_ID.:4810:&SESSION.::&DEBUG.:4810,4811,4812:P4810_FORM_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FORMONSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22119022069897073.4001)
,p_branch_name=>'Go To Page 107'
,p_branch_action=>'f?p=&APP_ID.:107:&SESSION.::&DEBUG.:107,108,109,110,111,141,CREATE_WIZARD::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>170
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'SIMPLE_WIZARD'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(22120105923901843.4001)
,p_branch_name=>'Tree Page'
,p_branch_action=>'f?p=&APP_ID.:112:&SESSION.::&DEBUG.:112,114,116,117,119,120,126,68::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>180
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'TREE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92932625655219550.4001)
,p_branch_name=>'Interactive Report'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759,769,4716:P759_REPORT_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>190
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'INTERACTIVE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114181117637582457.4001)
,p_branch_name=>'Report on Web Service'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:776,778,779,781,782,783,786,859,860,759,4716:P759_REPORT_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>200
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'WEBSERVICE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(197774156774040025.4001)
,p_branch_name=>'Interactive Grid'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759, 769, 4716:P759_REPORT_TYPE:GRID&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>210
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'GRID:EDITABLE_GRID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(187614709871572723.4001)
,p_branch_name=>'Faceted Search'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759,769,770,4716:P759_REPORT_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>220
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'FACETED_SEARCH'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3801373968328803.4001)
,p_branch_name=>'Smart Filters'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759,769,770,4716:P759_REPORT_TYPE:&P4700_SELECT_REPORT_TYPE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>230
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'SMART_FILTERS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1510935992491401.4001)
,p_branch_name=>'Card'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759,769,770,4716:P759_REPORT_TYPE:&P4700_SELECT_REPORT_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21647132395619736.4001)
,p_branch_sequence=>240
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'CARD'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(581438300034388808.4001)
,p_branch_name=>'Legacy Data Load Page'
,p_branch_action=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:1700,1701,1702,1704,1706::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>250
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4700_SELECT_REPORT_TYPE'
,p_branch_condition_text=>'LEGACY_DATA_LOAD'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(549120082730622856.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(21145714846754966.4001)
,p_branch_sequence=>200
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21144028914749580.4001)
,p_name=>'P4700_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5171110750420607.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(367798712386844514.4001)
,p_name=>'P4700_SELECT_REPORT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5171110750420607.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'  when :P259_CHOOSE_PAGE_TYPE = ''REPORT'' and :P4700_SELECT_REPORT_TYPE is null then',
'      if wwv_flow_user_interface_dev.is_desktop_ui (',
'             p_application_id   =>  :FB_FLOW_ID,',
'             p_user_interface_id => :P259_USER_INTERFACE_ID ) then',
'          return ''INTERACTIVE'';',
'      else',
'          return ''NATIVE_JQM_LIST_VIEW'';',
'      end if;',
'  when :P259_CHOOSE_PAGE_TYPE = ''FORM'' and :P4700_SELECT_REPORT_TYPE is null then',
'      if wwv_flow_user_interface_dev.is_desktop_ui (',
'             p_application_id   =>  :FB_FLOW_ID,',
'             p_user_interface_id => :P259_USER_INTERFACE_ID ) then',
'          return ''REPORTANDFORM'';',
'      else',
'          return ''FORM_ON_A_TABLE_WITH_LISTVIEW'';',
'      end if;',
'  else return :P4700_SELECT_REPORT_TYPE;',
'end case;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'4700 PAGE TYPE'
,p_lov=>'.'||wwv_flow_api.id(21175516989935412.4001)||'.'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(367862129614540063.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4700_SELECT_REPORT_TYPE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- changing some page type strings to the original strings due to logic in subsequent wizard pages',
'case :P4700_SELECT_REPORT_TYPE',
'  when ''CSSCALENDAR''  then return ''NATIVE_CSS_CALENDAR'';',
'  when ''EZCALENDAR''   then return ''EASY_CALENDAR'';',
'  when ''LISTVIEW''     then return ''NATIVE_JQM_LIST_VIEW'';',
'  when ''REFLOW''       then return ''NATIVE_JQM_REFLOW'';',
'  when ''COLUMNTOGGLE'' then return ''NATIVE_JQM_COLUMN_TOGGLE'';',
'  when ''LISTVIEWFORM'' then return ''FORM_ON_A_TABLE_WITH_LISTVIEW'';',
'  else return :P4700_SELECT_REPORT_TYPE;',
'end case;',
'',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549119404647620851.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4294802795572966.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549119796226620851.4001)
,p_event_id=>wwv_flow_api.id(549119404647620851.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04711
begin
wwv_flow_api.create_page(
 p_id=>4711.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla Basada en Procedimiento: Propietario y Nombre del Procedimiento'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Pantalla Basada en Procedimiento'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212960930328524322)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(720615740.4001)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(70041819940286906.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2453004906.4001)
,p_plug_name=>'Crear Pantalla Basada en Procedimiento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>92
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>' '
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202500015619528133.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>102
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(272280672540934732.4001)
,p_name=>'Seleccione los argumentos del procedimiento que se van a incluir en la pantalla:'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>102
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767);',
'begin',
'    q := ''select '';',
'    q :=q||''wwv_flow_item.select_list_from_lov(3,''''YES'''',''''YES_NO_RETURNS_YES_OR_NO'''',null,''''NO'''') include, '';',
'    q :=q||''x.argument_name || '';',
'    q :=q||''wwv_flow_item.hidden(1,x.argument_name), ''; ',
'    q :=q||''wwv_flow_item.text(2,initcap(replace( ltrim(x.argument_name, ''''P_''''),''''_'''','''' ''''))) prompt, '';',
'    q :=q||''wwv_flow_item.text(4) def, '';',
'    q :=q||''wwv_flow_item.select_list_from_lov(5,''''NATIVE_TEXT_FIELD'''', '';',
'    q :=q||''''''FORM_ON_SP.ITEM_DISPLAY_TYPES'''',null,''''NO'''') typ '';',
'    q :=q||''from ( '';',
'    q :=q||''select '';',
'    q :=q||''argument_name, '';',
'    q :=q||''sequence '';',
'    q :=q||''from sys.dba_arguments '';',
'    q :=q||''where owner = :F4000_P4711_OWNER '';',
'    q :=q||''and argument_name is not null '';',
'    if instr(:P4711_PROCEDURE,''.'') > 0 then',
'      q := q||'' and object_name=substr(:P4711_PROCEDURE,instr(:P4711_PROCEDURE,''''.'''')+1)'';',
'      q := q||'' and package_name=substr(:P4711_PROCEDURE,1,instr(:P4711_PROCEDURE,''''.'''')-1)'';      ',
'   else',
'      q := q||'' and object_name = :P4711_PROCEDURE '';     ',
'      q := q||'' and package_name is null '';     ',
'   end if;',
'   q := q||'' order by sequence) x'';',
'  --end if;',
'  return q;',
'end;',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'F4000_P4711_OWNER,P4711_PROCEDURE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_plug_query_max_columns=>60
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>unistr('- no se ha seleccionado ning\00FAn procedimiento -')
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272280781943934733.4001)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Incluir'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272280849221934734.4001)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Argumento'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272280929818934735.4001)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Etiqueta'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281036795934736.4001)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Valor por Defecto'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281163871934737.4001)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Tipo de Visualizaci\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281222319934738.4001)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>unistr('Tipo de Visualizaci\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281321180934739.4001)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281485149934740.4001)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281528715934741.4001)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281600257934742.4001)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281766190934743.4001)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281896763934744.4001)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272281972744934745.4001)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272282013021934746.4001)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272282121156934747.4001)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272282234625934748.4001)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272282317506934749.4001)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(272282414734934750.4001)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271287297341801.4001)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271301990341802.4001)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271400844341803.4001)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271516806341804.4001)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271616360341805.4001)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271772737341806.4001)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271841054341807.4001)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280271907091341808.4001)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272081663341809.4001)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272158689341810.4001)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272296157341811.4001)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272374056341812.4001)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272497659341813.4001)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272556479341814.4001)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272621247341815.4001)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272701489341816.4001)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272839353341817.4001)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280272980614341818.4001)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273018537341819.4001)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273111810341820.4001)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273202143341821.4001)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273313406341822.4001)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273456760341823.4001)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273589586341824.4001)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273640077341825.4001)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273733342341826.4001)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273879321341827.4001)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280273992945341828.4001)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274030331341829.4001)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274159750341830.4001)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274250825341831.4001)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274326415341832.4001)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274475021341833.4001)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274525717341834.4001)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274657266341835.4001)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274771733341836.4001)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274824337341837.4001)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280274995425341838.4001)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280275043710341839.4001)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280275141608341840.4001)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280275270871341841.4001)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(280275307937341842.4001)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(90324882520.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(202500015619528133.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(499002992.4001)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_api.id(202500015619528133.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699453842665497359.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(202500015619528133.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(92239008997703090.4001)
,p_branch_action=>'4711'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699453981723498929.4001)
,p_branch_name=>'Go To Page 4716'
,p_branch_action=>'4716'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699453842665497359.4001)
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P362_OPT'
,p_branch_condition_text=>'R'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504039625.4001)
,p_name=>'F4000_P4711_OWNER'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(2453004906.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Procedimiento'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Esquema -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifique el propietario del procedimiento en el que va a crear la pantalla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16115405899134718.4001)
,p_name=>'P4711_PROCEDURE'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(2453004906.4001)
,p_prompt=>'Nombre del Procedimiento Almacenado'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct decode(package_name,null,null,package_name||''.'')||object_name n,',
'',
'decode(package_name,null,null,package_name||''.'')||object_name v from sys.dba_arguments a ',
'where owner = :F4000_P4711_OWNER',
'and (exists (select null',
'               from sys.dba_tab_privs',
'              where (grantee = (select owner',
'                                 from wwv_flows',
'                                where id = :FB_FLOW_ID) or grantee=''PUBLIC'')',
'                and privilege = ''EXECUTE''',
'                and (table_name = a.object_name or table_name = a.package_name)',
'                and owner = a.owner)',
'or exists (select null',
'             from wwv_flows',
'            where owner = :F4000_P4711_OWNER',
'              and id = :FB_FLOW_ID))'))
,p_lov_cascade_parent_items=>'F4000_P4711_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione un procedimiento o procedimiento empaquetado para que lo utilice la pantalla.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16141222362603091.4001)
,p_name=>'P4711_PREV_PROC'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_api.id(2453004906.4001)
,p_prompt=>'P4711_PREV_PROC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(16140910587599618.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4711_PREV_PROC'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':P4711_PROCEDURE'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(61074918596154786.4001)
,p_validation_name=>'Select Schema Owner'
,p_validation_sequence=>10
,p_validation=>'F4000_P4711_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el propietario del esquema.'
,p_validation_condition=>'Next'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(504039625.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16115916288137722.4001)
,p_validation_name=>'Select Procedure'
,p_validation_sequence=>20
,p_validation=>'P4711_PROCEDURE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el procedimiento almacenado.'
,p_when_button_pressed=>wwv_flow_api.id(499002992.4001)
,p_associated_item=>wwv_flow_api.id(16115405899134718.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16116121483139194.4001)
,p_validation_name=>'proc exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_point   number;',
'  l_pack    varchar2(2000);',
'  l_obj     varchar2(2000);',
'begin',
'  l_point := instr(:P4711_PROCEDURE,''.'');',
'  if l_point > 0 then',
'    l_pack := substr(:P4711_PROCEDURE,0,l_point-1);',
'	l_obj  := substr(:P4711_PROCEDURE,l_point+1);',
'	for c in ( select 1 from sys.dba_arguments',
'		  	   where owner = :F4000_P4711_OWNER',
'			    and object_name = l_obj',
'			    and package_name = l_pack ) loop',
'	  return TRUE;',
'	end loop;',
'  else',
'	for c in ( select * from sys.dba_arguments',
'		  	   where owner = :F4000_P4711_OWNER',
'			    and object_name = :P4711_PROCEDURE ) loop',
'	  return TRUE;',
'	end loop;',
'  end if;',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No se ha encontrado el procedimiento especificado. Seleccione un nombre de procedimiento de almacenamiento v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(499002992.4001)
,p_associated_item=>wwv_flow_api.id(16115405899134718.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549137794796772197.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(90324882520.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549138025806772197.4001)
,p_event_id=>wwv_flow_api.id(549137794796772197.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(567415950055994701.4001)
,p_name=>'Refresh arguments'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4711_PROCEDURE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(567416001390994702.4001)
,p_event_id=>wwv_flow_api.id(567415950055994701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(272280672540934732.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(16122422493262465.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create or truncate the collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--wwv_flow_collection.create_or_truncate_collection(''SP_WIZARD'');',
'wwv_flow_collection.create_or_truncate_collection(''SP_WIZARD'');',
'for i in 1..wwv_flow.g_f01.count loop',
'   wwv_flow_collection.add_member(',
'    p_collection_name => ''SP_WIZARD'',',
'    p_c001            => wwv_flow.g_f01(i),',
'    p_c002            => wwv_flow.g_f02(i),',
'    p_c003            => wwv_flow.g_f03(i),',
'    p_c004            => wwv_flow.g_f04(i),',
'    p_c005            => wwv_flow.g_f05(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(499002992.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(280275434195341843.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create form on procedure'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_wizard_api.create_form_on_sp (',
'     p_flow_id                  => :fb_FLOW_ID,',
'     p_page_id                  => :F4000_P4810_PAGE_ID,',
'     p_page_name                => :F4000_P4810_PAGE_NAME,',
'     p_group_name               => :P4810_GROUP_NAME,',
'     p_page_mode                => :P4810_PAGE_MODE,',
'     p_user_interface_id        => :P259_USER_INTERFACE_ID,',
'     --',
'     p_tab_set                  => :P4716_TAB_SET,',
'     p_tab_name                 => :P4716_TAB_NAME,',
'     p_tab_text                 => :P4716_TAB_LABEL,',
'     --',
'     p_nav_list_id              => :P4716_NAVLIST_ID,',
'     p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'     p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'     --',
'     p_region_title             => :F4000_P4810_PAGE_NAME,  ',
'     p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'													p_application_id => :FB_FLOW_ID,',
'													p_theme_id       => :FB_THEME_ID,',
'													p_page_type      => ''FORM'' ),',
'     p_procedure                => :P4711_PROCEDURE, ',
'     p_schema                   => :F4000_P4711_OWNER,',
'     p_collection_name          => ''SP_WIZARD'',',
'     p_cancel_branch            => :P4810_CANCEL_BRANCH,',
'     p_submit_branch            => :P4810_BRANCH,   ',
'     p_cancel_button_name       => wwv_flow_lang.system_message(''WWV_SPELING.BUTTON_CANCEL''),',
'     p_submit_button_name       => wwv_flow_lang.system_message(''WWV_SPELING.BUTTON_SUBMIT'')',
'  );',
'  ',
'  :fb_flow_page_id := :F4000_P4810_PAGE_ID;  ',
'  ',
'--',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :F4000_P4810_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P4810_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P4810_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_entry_id => :P4810_BREADCRUMB_PARENT_ID );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(499002992.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(280275538049341844.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(499002992.4001)
);
end;
/
prompt --application/pages/page_04714
begin
wwv_flow_api.create_page(
 p_id=>4714.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina en Blanco: Atributos de P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina en Blanco')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212963412798528796)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(608337641.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:C'
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132688599973.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(82926628922893097.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42466224675965489.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(381003909461896135.4001)
,p_plug_name=>unistr('Regiones de Contenido Est\00E1tico Opcionales')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(614500480.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42466224675965489.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10" tabindex="2"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(279435319167260053.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(42466224675965489.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(612474497.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(42466224675965489.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_cattributes=>'class="button10" '
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(116972132035620753.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(614500480.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(548121646771304076.4001)
,p_branch_action=>'f?p=&APP_ID.:259:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(279435319167260053.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(611371779.4001)
,p_name=>'F4000_P4714_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El n\00FAmero de p\00E1gina es un valor entero que identifica una p\00E1gina en una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45358207874833799.4001)
,p_name=>'P4714_PAGE_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE'
,p_lov=>'.'||wwv_flow_api.id(44400703264122475.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: la p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de Di\00E1logo Modal</strong>: la p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li>'),
unistr('<li><strong>Cuadro de Di\00E1logo No Modal</strong>: la p\00E1gina se presenta como un cuadro de di\00E1logo no modal. Un cuadro de di\00E1logo no modal es una ventana de superposici\00F3n situada en el viewport, donde el usuario final puede interactuar con el cuadro de')
||unistr(' di\00E1logo y el contenido de la p\00E1gina que lo inici\00F3. Un cuadro de di\00E1logo no modal puede utilizarse cuando la informaci\00F3n solicitada no es esencial para continuar; el trabajo puede continuar en otro lugar mientras la ventana sigue abierta.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que las opciones Cuadro de Di\00E1logo Modal y Cuadro de Di\00E1logo No Modal solo estar\00E1n disponibles para seleccionarlas cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de Cuadro de Di\00E1l')
||'ogo</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(107202930576742219.4001)
,p_name=>'F4000_P4714_ALIAS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se puede utilizar un alias de p\00E1gina en lugar de un n\00FAmero de p\00E1gina en determinadas ubicaciones en &PRODUCT_NAME.. Por ejemplo, la p\00E1gina 1 tiene un alias definido como "home". Al utilizar la sintaxis f?p, estos dos ejemplos son equivalentes: '),
'<pre>f?p=123:1:...</pre>',
'<pre>f?p=123:home:...</pre>',
unistr('Recuerde que tambi\00E9n puede utilizar un alias de p\00E1gina en la bifurcaci\00F3n de p\00E1gina.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381004166354896138.4001)
,p_name=>'P4714_REGION_01'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(381003909461896135.4001)
,p_prompt=>unistr('Regi\00F3n 1')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de la primera regi\00F3n que se va a crear. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381004682058896146.4001)
,p_name=>'P4714_REGION_02'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(381003909461896135.4001)
,p_prompt=>'2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de regi\00F3n de la segunda regi\00F3n html que se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381005138249896146.4001)
,p_name=>'P4714_REGION_03'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(381003909461896135.4001)
,p_prompt=>'3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de regi\00F3n de la tercera regi\00F3n html que se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381005622898896146.4001)
,p_name=>'P4714_REGION_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(381003909461896135.4001)
,p_prompt=>'4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de regi\00F3n de la cuarta regi\00F3n html que se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381006198480896147.4001)
,p_name=>'P4714_REGION_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(381003909461896135.4001)
,p_prompt=>'5'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de regi\00F3n de la quinta regi\00F3n html que se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381027966737033221.4001)
,p_name=>'P4714_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Necesario. Especifique un nombre de texto para esta p\00E1gina. Este nombre est\00E1 visible s\00F3lo durante el proceso de desarrollo de la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381034459840072652.4001)
,p_name=>'P4714_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No utilizar rutas de navegaci\00F3n en la p\00E1gina -')
,p_cSize=>64
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381035796511185388.4001)
,p_name=>'P4714_BREADCRUMB_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381121676728870736.4001)
,p_name=>'P4714_BREADCRUMB_PARENT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P4714_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P4714_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P4714_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione la entrada de ruta de navegaci\00F3n principal para la p\00E1gina actual; seleccione "Ninguna Entrada Principal" para la p\00E1gina de nivel superior.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381238650784985168.4001)
,p_name=>'P4714_PAGE_TITLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403332396511418235.4001)
,p_name=>'P4714_GROUP_NAME'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(608337641.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. '),
unistr('  Los grupos de p\00E1ginas ayudan a los desarrolladores a identificar y gestionar las p\00E1ginas en una aplicaci\00F3n.</p>'),
unistr('<p>Nota: Para crear grupos de p\00E1ginas, vaya a <strong>Utilidades: Grupos de p\00E1ginas</strong> en Utilidades espec\00EDficas de p\00E1gina en la barra lateral derecha.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(381238894530987691.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4714_PAGE_TITLE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4714_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1940954007252823356.4001)
,p_computation_sequence=>90
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4714_PAGE_NAME'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(83097228826664922.4001)
,p_validation_name=>'page not exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n number;',
'    l_result boolean := TRUE;',
'begin',
'    for c1 in (select NULL',
'                 from wwv_flow_steps ',
'                where id = :F4000_P4714_PAGE_ID ',
'                  and flow_id = :FB_FLOW_ID ',
'                  and security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'        l_result := FALSE;',
'        exit;',
'    end loop;',
'    return l_result;',
'    --',
'    exception',
'        when others then',
'            return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El "&F4000_P4714_PAGE_ID." de p\00E1gina ya lo est\00E1 utilizando la aplicaci\00F3n "&FB_FLOW_ID." o no es num\00E9rico. Especifique un identificador de p\00E1gina num\00E9rico que no lo est\00E9 utilizando la aplicaci\00F3n actual.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(176608014564934094.4001)
,p_validation_name=>'F4000_P4714_PAGE_ID Not Null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4714_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(611371779.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 16-FEB-2002 23:07'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(107404616711356449.4001)
,p_validation_name=>'alias not used'
,p_validation_sequence=>40
,p_validation=>'select 1 from wwv_flow_steps where upper(alias) = upper(:F4000_P4714_ALIAS) and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('El alias &F4000_P4714_ALIAS. ya se est\00E1 utilizando en una p\00E1gina existente de esta aplicaci\00F3n.')
,p_validation_condition=>'F4000_P4714_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(107202930576742219.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(73269730203243115.4001)
,p_validation_name=>'alias is valid'
,p_validation_sequence=>50
,p_validation=>':F4000_P4714_ALIAS is null or wwv_flow_utilities.is_valid_identifier(:F4000_P4714_ALIAS)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El alias de p\00E1gina no es un identificador de Oracle v\00E1lido.')
,p_when_button_pressed=>wwv_flow_api.id(614500480.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45358704423835396.4001)
,p_validation_name=>'P4714_PAGE_MODE Not Null'
,p_validation_sequence=>60
,p_validation=>'P4714_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(614500480.4001)
,p_associated_item=>wwv_flow_api.id(45358207874833799.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(481340500810944496.4001)
,p_validation_name=>'F4000_P4714_PAGE_ID not decimal or negative'
,p_validation_sequence=>70
,p_validation=>'trunc(abs(:F4000_P4714_PAGE_ID)) = :F4000_P4714_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(614500480.4001)
,p_associated_item=>wwv_flow_api.id(611371779.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(387541348042578602.4001)
,p_validation_name=>'P4714_BREADCRUMB_NAME Not NUll'
,p_validation_sequence=>80
,p_validation=>'P4714_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_validation_condition=>'P4714_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_associated_item=>wwv_flow_api.id(381035796511185388.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403332801882419612.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P4714_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4714_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(614500480.4001)
,p_associated_item=>wwv_flow_api.id(403332396511418235.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381132487906179544.4001)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4714_BREADCRUMB_ID'
,p_condition_element=>'P4714_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381132725850179544.4001)
,p_event_id=>wwv_flow_api.id(381132487906179544.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4714_BREADCRUMB_PARENT_ID,P4714_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381132938137179545.4001)
,p_event_id=>wwv_flow_api.id(381132487906179544.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4714_BREADCRUMB_PARENT_ID,P4714_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548084012575241788.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(612474497.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548084370069241796.4001)
,p_event_id=>wwv_flow_api.id(548084012575241788.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1940954332499824802.4001)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4714_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1940954732664824802.4001)
,p_event_id=>wwv_flow_api.id(1940954332499824802.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4714_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P4714_PAGE_NAME'
,p_attribute_07=>'P4714_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_04716
begin
wwv_flow_api.create_page(
 p_id=>4716.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina: Men\00FA/Separadores de Navegaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11511713242614593)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#P4716_NAVLIST_PARENT_ID option:contains('' ('')").attr("disabled","disabled");',
'apex.util.getTopApex().jQuery(".ui-dialog--apex .ui-dialog-title").text($v("P4716_PAGE_TITLE"));'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5439406785188009.4001)
,p_plug_name=>unistr('Crear P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(5438818215188007.4001)
,p_name=>'Separadores'
,p_parent_plug_id=>wwv_flow_api.id(5439406785188009.4001)
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P4716_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No existe ning\00FAn separador ni ning\00FAn juego de separadores.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5439024987188008.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5439118949188008.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>unistr('P\00E1gina')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5439202581188008.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Separador'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(5439300381188008.4001)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Tambi\00E9n&nbsp;Actual&nbsp;para')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6783914938961087.4001)
,p_plug_name=>'progress'
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_app_id  constant number := wwv_flow_security.get_translated_flow_id;',
'    c_page_id constant number := wwv_flow_security.get_translated_id( :P4716_PREV_PAGE_ID );',
'begin',
'    -- Get the progress train from our previous wizard step and render the same progress',
'    -- train on this shared "Navigation Menu" wizard page. This will avoid that we have',
'    -- to have x number of conditional progress train regions on this page.',
'    for l_list in ( select id as region_id,',
'                           list_id,',
'                           list_template_id,',
'                           region_sub_css_classes,',
'                           component_template_options',
'                      from wwv_flow_page_plugs',
'                     where flow_id = c_app_id',
'                       and page_id = c_page_id',
'                       and plug_display_point = ''REGION_POSITION_01'' )',
'    loop',
'        wwv_flow_region_native.render_list (',
'            p_region_id               => l_list.region_id,',
'            p_list_id                 => l_list.list_id,',
'            p_list_template_id        => l_list.list_template_id,',
'            p_region_sub_css_classes  => l_list.region_sub_css_classes,',
'            p_region_template_options => l_list.component_template_options );',
'        exit;',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(44009705261558987.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(925258843485540203.4001)
,p_plug_name=>'List Based Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P259_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5439602032188009.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(44009705261558987.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5439802675188010.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(44009705261558987.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5440008510188010.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(44009705261558987.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5446523773188018.4001)
,p_branch_name=>'Go To Next Wizard Page'
,p_branch_action=>'declare'||wwv_flow.LF||
'    l_list_id                    number;'||wwv_flow.LF||
'    l_list_item_display_sequence number;'||wwv_flow.LF||
'begin'||wwv_flow.LF||
'    -- 1) Get the progress train from our previous wizard step'||wwv_flow.LF||
'    -- 2) In that process train, find the list item entry for our current page,'||wwv_flow.LF||
'    --    this query will always find two entries (Navigation Menu, Tabs). We are'||wwv_flow.LF||
'    --    just interested in the last entry.'||wwv_flow.LF||
'    select max( li.list_id ),'||wwv_flow.LF||
'           max( li.list_item_display_sequence )'||wwv_flow.LF||
'      into l_list_id,'||wwv_flow.LF||
'           l_list_item_display_sequence'||wwv_flow.LF||
'      from wwv_flow_page_plugs r,'||wwv_flow.LF||
'           wwv_flow_list_items li'||wwv_flow.LF||
'     where r.flow_id            = :APP_ID'||wwv_flow.LF||
'       and r.page_id            = :P4716_PREV_PAGE_ID'||wwv_flow.LF||
'       and r.plug_display_point = ''REGION_POSITION_01'''||wwv_flow.LF||
'       and li.list_id           = r.list_id'||wwv_flow.LF||
'       and li.list_item_current_for_pages = :APP_PAGE_ID;'||wwv_flow.LF||
''||wwv_flow.LF||
'    -- 3) Based on that list item entry, find the target page of the next valid wizard step in the list'||wwv_flow.LF||
'    for l_items in ('||wwv_flow.LF||
'        select list_item_current_for_pages as next_page_id,'||wwv_flow.LF||
'               list_item_disp_cond_type,'||wwv_flow.LF||
'               list_item_disp_condition,'||wwv_flow.LF||
'               list_item_disp_condition2'||wwv_flow.LF||
'          from wwv_flow_list_items'||wwv_flow.LF||
'         where list_id                    = l_list_id'||wwv_flow.LF||
'           and list_item_display_sequence > l_list_item_display_sequence'||wwv_flow.LF||
'         order by list_item_display_sequence )'||wwv_flow.LF||
'    loop'||wwv_flow.LF||
'        if wwv_flow_conditions.standard_condition ('||wwv_flow.LF||
'               p_condition_type => l_items.list_item_disp_cond_type,'||wwv_flow.LF||
'               p_condition      => l_items.list_item_disp_condition,'||wwv_flow.LF||
'               p_condition2     => l_items.list_item_disp_condition2 )'||wwv_flow.LF||
'        then'||wwv_flow.LF||
'            -- For the confirmation page of the master-detail wizard we have to set the previous page'||wwv_flow.LF||
'            --:P35_PREV_PAGE := :APP_PAGE_ID;'||wwv_flow.LF||
'            --'||wwv_flow.LF||
'            return case'||wwv_flow.LF||
'                     -- If the next process step is used by multiple pages, use the first page for navigation'||wwv_flow.LF||
'                     when instr( l_items.next_page_id, '','' ) > 0 then'||wwv_flow.LF||
'                          substr( l_items.next_page_id, 1, instr( l_items.next_page_id, '','' ) - 1 )'||wwv_flow.LF||
'                     when instr( l_items.next_page_id, '':'' ) > 0 then'||wwv_flow.LF||
'                          substr( l_items.next_page_id, 1, instr( l_items.next_page_id, '':'' ) - 1 )'||wwv_flow.LF||
'                     else l_items.next_page_id'||wwv_flow.LF||
'                   end;'||wwv_flow.LF||
'        end if;'||wwv_flow.LF||
'    end loop;'||wwv_flow.LF||
'    return null;'||wwv_flow.LF||
'end;'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_branch_language=>'PLSQL'
,p_branch_when_button_id=>wwv_flow_api.id(5439802675188010.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5446908760188018.4001)
,p_branch_name=>'Go To Previous Wizard Page'
,p_branch_action=>'f?p=&APP_ID.:&P4716_PREV_PAGE_ID.:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(5440008510188010.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5440211507188010.4001)
,p_name=>'P4716_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5439406785188009.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Juego de Separadores'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Juego de Separadores -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el juego de separadores que desea utilizar en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5440714773188011.4001)
,p_name=>'P4716_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5439406785188009.4001)
,p_item_default=>'0'
,p_prompt=>'Opciones de Separador:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(35310611267199336.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Especifique si esta p\00E1gina deber\00EDa tener separadores y haga clic en <strong>Siguiente</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5441711984188012.4001)
,p_name=>'P4716_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5439406785188009.4001)
,p_prompt=>'Nueva Etiqueta de Separador'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca la etiqueta del separador que se va a crear. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5442201058188012.4001)
,p_name=>'P4716_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(5439406785188009.4001)
,p_prompt=>'Usar Separador'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P4716_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Separador -'
,p_lov_cascade_parent_items=>'P4716_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Seleccione el separador que se va a designar como "actual" en esta p\00E1gina.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(925258727506540202.4001)
,p_name=>'P4716_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(925258843485540203.4001)
,p_item_default=>'NONE'
,p_prompt=>unistr('Preferencia de Navegaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(925221062390507339.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo desea que esta p\00E1gina se integre en el men\00FA de navegaci\00F3n.<p/>'),
'<ul>',
unistr('    <li><strong>No asociar esta p\00E1gina a una entrada de men\00FA de navegaci\00F3n</strong>: la nueva p\00E1gina no ser\00E1 actual ni se resaltar\00E1 para ninguna entrada de men\00FA.</li>'),
unistr('    <li><strong>Crear una nueva entrada de men\00FA de navegaci\00F3n</strong>: los usuarios podr\00E1n navegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. La nueva entrada se puede colocar en cualquier lugar en la jerarqu\00EDa existente.</li>'),
unistr('    <li><strong>Identificar una entrada de men\00FA de navegaci\00F3n existente que ser\00E1 actual para esta p\00E1gina</strong>: utilice esta opci\00F3n cuando desee que la nueva p\00E1gina resalte una entrada de men\00FA de nivel superior existente. Los usuarios no podr\00E1n na')
||unistr('vegar a la nueva p\00E1gina directamente desde el men\00FA de navegaci\00F3n. Por lo tanto, deber\00E1 crear o definir un control de navegaci\00F3n en la p\00E1gina de nivel superior seleccionada, como un bot\00F3n o un enlace en un informe, para ir a esta nueva p\00E1gina.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(925259067142540205.4001)
,p_name=>'P4716_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(925258843485540203.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>7
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un principal de navegaci\00F3n para la nueva p\00E1gina. Al crear un nuevo elemento de navegaci\00F3n, el nuevo elemento enlaza a'),
unistr('la nueva p\00E1gina. El nuevo elemento se puede agregar en el nivel superior, al no seleccionar ning\00FAn elemento principal, o se puede mostrar como un secundario'),
'de un elemento existente. </p>',
'',
unistr('<p>Al seleccionar el elemento sin crear uno nuevo, el elemento seleccionado determina qu\00E9 elemento de nivel superior se muestra'),
'como elemento "actual".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(925259133577540206.4001)
,p_name=>'P4716_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(925258843485540203.4001)
,p_prompt=>unistr('Nueva Entrada de Men\00FA de Navegaci\00F3n')
,p_source=>'P4714_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Introduzca un nombre para el nuevo control de men\00FA.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(936748980980404408.4001)
,p_name=>'P4716_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(925258843485540203.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(969051498795554601.4001)
,p_name=>'P4716_PREV_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(6783914938961087.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(969051719295554604.4001)
,p_name=>'P4716_PAGE_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(6783914938961087.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1340197749667591930.4001)
,p_name=>'P4716_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(925258843485540203.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Existente')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P4716_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione un control de men\00FA existente para que se muestre como el control de men\00FA activo al presentar la nueva p\00E1gina. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1340201294813626612.4001)
,p_name=>'P4716_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(925258843485540203.4001)
,p_prompt=>unistr('Entrada de Men\00FA de Navegaci\00F3n Principal')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
' start with list_id = :P4716_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un control de men\00FA existente si desea agregar una entrada de men\00FA para la nueva p\00E1gina a este control de men\00FA. '),
unistr('Cuando no se seleccione un control de men\00FA existente, se crear\00E1 un control de men\00FA para la nueva p\00E1gina en el nivel superior.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5443705390188015.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4716_TAB_SET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4716_TAB_OPTIONS'
,p_compute_when_text=>'0'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5443919237188016.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4716_TAB_NAME'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4716_TAB_OPTIONS'
,p_compute_when_text=>'1'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5444100706188016.4001)
,p_computation_sequence=>30
,p_computation_item=>'P4716_TAB_LABEL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4716_TAB_OPTIONS'
,p_compute_when_text=>'2'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(940899910291433100.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return null;'
,p_compute_when=>'P4716_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1340221674681794212.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4716_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4716_NEW_PARENT_ID'
,p_compute_when=>'P4716_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1340221956836801876.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4716_EXISTING_PARENT_ID'
,p_compute_when=>'P4716_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(969051846428554605.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4716_PAGE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_prev_page in (select step_title',
'                    from wwv_flow_steps',
'                    where flow_id = :APP_TRANSLATION_ID',
'                    and id = ( select wwv_flow_security.get_translated_id( :P4716_PREV_PAGE_ID ) from dual ))',
'loop',
'    return wwv_flow_session_state.do_raw_substitutions( p_string => l_prev_page.step_title);',
'end loop;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(936755246151435875.4001)
,p_computation_sequence=>40
,p_computation_item=>'P4716_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id',
'from wwv_flow_lists l, wwv_flow_user_interfaces i',
'where l.flow_id = :FB_FLOW_ID',
'and l.flow_id = i.flow_id',
'and l.id = i.navigation_list_id',
'and i.id = :P259_USER_INTERFACE_ID'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5444326089188016.4001)
,p_validation_name=>'tab set not null'
,p_validation_sequence=>10
,p_validation=>'P4716_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P4716_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_api.id(5439802675188010.4001)
,p_associated_item=>wwv_flow_api.id(5440211507188010.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5444515315188016.4001)
,p_validation_name=>'tab label not null'
,p_validation_sequence=>20
,p_validation=>'P4716_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P4716_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(5439802675188010.4001)
,p_associated_item=>wwv_flow_api.id(5441711984188012.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5444716260188016.4001)
,p_validation_name=>'tab name not null'
,p_validation_sequence=>30
,p_validation=>'P4716_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar #LABEL#.'
,p_validation_condition=>'P4716_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(5439802675188010.4001)
,p_associated_item=>wwv_flow_api.id(5442201058188012.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1104689937872514441.4001)
,p_validation_name=>'New Entry with no List'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P4716_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P4716_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(925258727506540202.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(937697826722470958.4001)
,p_validation_name=>'P4716_NAVLIST_ENTRY_NAME'
,p_validation_sequence=>50
,p_validation=>'P4716_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se necesita un nombre de entrada para los nuevos elementos de navegaci\00F3n')
,p_validation_condition=>':P259_NAVIGATION_TYPE=''L'' and :P4716_NAVLIST_OPTIONS=''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(925259133577540206.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1104689811335514440.4001)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>60
,p_validation=>'P4716_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Debe asociar una lista de men\00FAs de navegaci\00F3n para utilizar esta preferencia. Vaya a Componentes Compartidos, Atributos de Interfaz de Usuario, seleccione la interfaz de usuario adecuada y, a continuaci\00F3n, seleccione una lista de men\00FAs de navegaci\00F3n.')
||'<br>',
unistr('Tambi\00E9n puede no asociar esta p\00E1gina a una entrada del men\00FA de navegaci\00F3n.')))
,p_validation_condition=>'P4716_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(925258727506540202.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5444809065188016.4001)
,p_name=>'Tab Option 0 Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_TAB_OPTIONS'
,p_condition_element=>'P4716_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5445119643188017.4001)
,p_event_id=>wwv_flow_api.id(5444809065188016.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_SET,P4716_TAB_LABEL,P4716_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5445227826188017.4001)
,p_name=>'Tab Option 1 Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_TAB_OPTIONS'
,p_condition_element=>'P4716_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5445530793188017.4001)
,p_event_id=>wwv_flow_api.id(5445227826188017.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_SET,P4716_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5445712868188017.4001)
,p_event_id=>wwv_flow_api.id(5445227826188017.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(5445816848188017.4001)
,p_name=>'Tab Option 2 Settings'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_TAB_OPTIONS'
,p_condition_element=>'P4716_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5446102367188018.4001)
,p_event_id=>wwv_flow_api.id(5445816848188017.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_SET,P4716_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(5446329768188018.4001)
,p_event_id=>wwv_flow_api.id(5445816848188017.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(548119885642282099.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(5439602032188009.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(548120199421282099.4001)
,p_event_id=>wwv_flow_api.id(548119885642282099.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(936775814888831027.4001)
,p_name=>'P4716_NAVLIST_ENTRY_NAME'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_condition_element=>'P4716_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(936776136685831028.4001)
,p_event_id=>wwv_flow_api.id(936775814888831027.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NAVLIST_ENTRY_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(936776335190831028.4001)
,p_event_id=>wwv_flow_api.id(936775814888831027.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NAVLIST_ENTRY_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(936776455074838833.4001)
,p_name=>'P4716_NEW_PARENT_ID'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_condition_element=>'P4716_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(936776715832838833.4001)
,p_event_id=>wwv_flow_api.id(936776455074838833.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(936776950625838833.4001)
,p_event_id=>wwv_flow_api.id(936776455074838833.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1340208425559737369.4001)
,p_name=>'P4716_EXISTING_PARENT_ID'
,p_event_sequence=>65
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_condition_element=>'P4716_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1340208725480737371.4001)
,p_event_id=>wwv_flow_api.id(1340208425559737369.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1340209077932743788.4001)
,p_event_id=>wwv_flow_api.id(1340208425559737369.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(937688684994293883.4001)
,p_name=>'Update Tree'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937688942786293885.4001)
,p_event_id=>wwv_flow_api.id(937688684994293883.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#P4716_NEW_PARENT_ID option:contains('' ('')").attr("disabled","disabled");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1119158641361390649.4001)
,p_name=>'Set Dialog Title'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1119158745964390650.4001)
,p_event_id=>wwv_flow_api.id(1119158641361390649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.parent.$( "#apex_dialog_page" ).dialog( "option", "title", "&P4716_PAGE_TITLE!JS." );'
);
end;
/
prompt --application/pages/page_04722
begin
wwv_flow_api.create_page(
 p_id=>4722.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: P\00E1gina Actual')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(680079518.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Item:Seq:Region'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(985967059.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>unistr('<div class="htmldbInfoBodyP">Debe definir una "p\00E1gina actual" para este separador. Cuando el usuario haga clic en el separador, la aplicaci\00F3n se bifurcar\00E1 a esta p\00E1gina.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(137385505969.4001)
,p_name=>'Juegos de Separadores Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_step, wwv_flow_escape.html(substr(tab_text,1,30)) tab_text, TAB_ALSO_CURRENT_FOR_PAGES',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'           security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48629207759771310.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48629306426771310.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48629415625771310.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>3
,p_column_heading=>unistr('P\00E1gina')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48629505756771310.4001)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199996925491685170.4001)
,p_query_column_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Separador tambi\00E9n Actual para P\00E1ginas')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46534921875718778.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(199994127784676324.4001)
,p_name=>unistr('P\00E1ginas Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name ',
'from wwv_flow_steps ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199994703403676341.4001)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(199994819564676342.4001)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130416677537.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46534921875718778.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130411585073.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46534921875718778.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101093920424829050.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46534921875718778.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130418785046.4001)
,p_branch_action=>'4723'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130411585073.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1829407077332002.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4723:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101094305835829054.4001)
,p_branch_action=>'96'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101093920424829050.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130414639866.4001)
,p_name=>'F4000_P4722_CURRENT_PAGE'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(985967059.4001)
,p_prompt=>unistr('Separador Actual para P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>16
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la p\00E1gina que actualiza este separador. Necesario. Cuando el usuario hace clic en este separador, la aplicaci\00F3n navegar\00E1 a este n\00FAmero de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130435396582.4001)
,p_name=>'F4000_P4722_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(985967059.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130423109743.4001)
,p_validation_name=>'Tab Current Page must not be null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4722_CURRENT_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina actual.')
,p_associated_item=>wwv_flow_api.id(130414639866.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8021411222024630.4001)
,p_validation_name=>'validate also current for'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4722_CURRENT_PAGE is null then',
'return true;',
'elsif rtrim(translate(:F4000_P4722_CURRENT_PAGE,''0123456789, '',''00000000000''),''0'') is not null then',
'return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Especifique los n\00FAmeros de p\00E1gina separados por comas, por ejemplo: 1,2,3')
,p_associated_item=>wwv_flow_api.id(130414639866.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573756645794229747.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130416677537.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573756771417229748.4001)
,p_event_id=>wwv_flow_api.id(573756645794229747.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04723
begin
wwv_flow_api.create_page(
 p_id=>4723.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Secuencia e Im\00E1genes')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(682087822.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Item:Seq:Region'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130419789518.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>unistr('<p>Identifique la secuencia de separador y los atributos de imagen opcionales. Si no se proporcionan im\00E1genes, el separador se mostrar\00E1 como texto.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(130421823300.4001)
,p_name=>'Juego de Separadores'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>310
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_sequence "Sequence", tab_text "TabName",tab_step "PageName" from wwv_flow_tabs ',
'where flow_id = :FB_FLOW_ID ',
'and tab_set = :f4000_p4722_tabset',
'and security_group_id = :flow_security_group_id',
'order by 1, 2'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48927608288773128.4001)
,p_query_column_id=>1
,p_column_alias=>'Sequence'
,p_column_display_sequence=>1
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48927717393773128.4001)
,p_query_column_id=>2
,p_column_alias=>'TabName'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre de Separador'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48927808793773129.4001)
,p_query_column_id=>3
,p_column_alias=>'PageName'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Nombre de la P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46535508846724523.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>320
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130422866033.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46535508846724523.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130428277483.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(46535508846724523.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130427275874.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(46535508846724523.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130429278854.4001)
,p_branch_action=>'4724'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130428277483.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130430280034.4001)
,p_branch_action=>'4722'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130427275874.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130432369096.4001)
,p_name=>'F4000_P4722_TAB_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(130419789518.4001)
,p_item_default=>'10'
,p_prompt=>'Secuencia'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'  s number := 0;',
'',
'begin',
'',
'  for c1 in (select max(tab_sequence) s',
'',
'             from wwv_flow_tabs',
'',
'             where flow_id = :FB_FLOW_ID',
'',
'             and tab_set = :F4000_P4722_TABSET',
'',
'             ) loop',
'',
'          s := c1.s;',
'',
'  end loop;',
'',
'',
'',
'  return trunc(s) + 10;',
'',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130433377035.4001)
,p_name=>'F4000_P4723_TS'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(130419789518.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Separadores:'
,p_source=>'F4000_P4722_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el juego de separadores seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130434386486.4001)
,p_name=>'F4000_P4723_TN'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(130419789518.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta:'
,p_source=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la etiqueta del separador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130436450411.4001)
,p_name=>'F4000_P4722_CURRENT_IMAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(130419789518.4001)
,p_prompt=>'Imagen Actual'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Define la imagen que aparece cuando se selecciona el separador (o es "actual"). No prefije la imagen. Se agregar\00E1 un prefijo de forma autom\00E1tica.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130438459104.4001)
,p_name=>'F4000_P4722_NON_CURRENT_IMAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(130419789518.4001)
,p_prompt=>'Imagen no Actual'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Define la imagen que aparece cuando el separador no est\00E1 seleccionado (o "no es actual"). Si desea utilizar la misma imagen independientemente de si el separador est\00E1 seleccionado, introduzca el mismo nombre de imagen que')
||unistr(' especific\00F3 en Imagen Actual.</div>'),
unistr('<div class="htmldbInfoBodyP">No prefije la imagen. Se agregar\00E1 un prefijo de forma autom\00E1tica.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130439464122.4001)
,p_name=>'F4000_P4722_IMAGE_ATTRIBUTES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(130419789518.4001)
,p_prompt=>'Atributos de Imagen'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Los atributos de imagen especifican la altura y el ancho de la imagen, por ejemplo:</div>',
'<pre>height="20" width="50"</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185776224880388599.4001)
,p_validation_name=>'Sequence is numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4722_TAB_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('Se debe introducir una secuencia num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(130428277483.4001)
,p_associated_item=>wwv_flow_api.id(130432369096.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185777009081393480.4001)
,p_validation_name=>'Sequence Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4722_TAB_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe introducir una secuencia num\00E9rica.')
,p_when_button_pressed=>wwv_flow_api.id(130428277483.4001)
,p_associated_item=>wwv_flow_api.id(130432369096.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573756418841229745.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130422866033.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573756569343229746.4001)
,p_event_id=>wwv_flow_api.id(573756418841229745.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04724
begin
wwv_flow_api.create_page(
 p_id=>4724.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Est\00E1ndar: Condiciones de Visualizaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear Separador Est\00E1ndar')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(683094383.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100922117111440207.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'Item:Seq:Region'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130441495589.4001)
,p_plug_name=>unistr('Crear Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(283597086572.4001)
,p_name=>unistr('Elementos de P\00E1gina Existentes')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, item_sequence, (select plug_name from wwv_flow_page_plugs where id = item_plug_id) item_plug_id',
'from   wwv_flow_step_items',
'where  flow_id = :FB_FLOW_ID ',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'and security_group_id = :flow_security_group_id',
'order  by name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48893700809772777.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Elemento'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48893825234772777.4001)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48893908730772777.4001)
,p_query_column_id=>3
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Regi\00F3n')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46536700451741043.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130443503109.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46536700451741043.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(101366802088325250.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46536700451741043.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130444509860.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(46536700451741043.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(101367204560325253.4001)
,p_branch_action=>'92'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(101366802088325250.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130445511451.4001)
,p_branch_action=>'4723'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130444509860.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130448555739.4001)
,p_name=>'F4000_P4722_DISPLAY_CONDITION'
,p_item_sequence=>29
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice este atributo para controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o pr')
||'ocesa el componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130449564532.4001)
,p_name=>'F4000_P4722_CONDITION_TYPE'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n de Visualizaci\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista. Esta condici\00F3n se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4722_DISPLAY_CONDITION'
,p_attribute_02=>'F4000_P4722_DISPLAY_CONDITION_TEXT'
,p_attribute_04=>'F4000_P4722_DISPLAY_CONDITION_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'F4000_P4722_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130450570735.4001)
,p_name=>'F4000_P4722_BUILD_OPTION'
,p_item_sequence=>59
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130451602030.4001)
,p_name=>'F4000_P4724_TN'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Separador:'
,p_source=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre del separador seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130452610308.4001)
,p_name=>'F4000_P4724_TCP'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Actual para P\00E1gina:')
,p_source=>'F4000_P4722_CURRENT_PAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la p\00E1gina de aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130453615959.4001)
,p_name=>'F4000_P4724_TS'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Separadores:'
,p_source=>'F4000_P4722_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el juego de separadores seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(283591027500.4001)
,p_name=>'F4000_P4722_DISPLAY_CONDITION_TEXT'
,p_item_sequence=>49
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2304966721464434.4001)
,p_name=>'F4000_P4722_CONDITION_LANG'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435044829650654798.4001)
,p_name=>'F4000_P4722_DISPLAY_CONDITION_CHECK'
,p_item_sequence=>39
,p_item_plug_id=>wwv_flow_api.id(130441495589.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573756235976229743.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130443503109.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573756307595229744.4001)
,p_event_id=>wwv_flow_api.id(573756235976229743.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04725
begin
wwv_flow_api.create_page(
 p_id=>4725.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Separador Principal: Separador Principal'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Separador Principal'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(684379911.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100804924518345585.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'TabSet:Seq:Name:Target'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130505887827.4001)
,p_plug_name=>'Crear Separador Principal '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>unistr('<p>Un separador principal funciona como contenedor de un grupo de separadores est\00E1ndar. Los separadores principales proporcionan a los usuarios otro nivel de navegaci\00F3n, as\00ED como un sistema de localizaci\00F3n en la aplicaci\00F3n. Utilice la etiqueta de sep')
||unistr('arador principal para especificar el texto de visualizaci\00F3n del separador.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(137383461413.4001)
,p_name=>'Separadores Principales Existentes'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>200
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_name, tab_text',
'from   wwv_flow_toplevel_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48628609033771307.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48628722487771307.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48628815663771307.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48628905084771307.4001)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Etiqueta'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46507423720877216.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>210
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130510928901.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(46507423720877216.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130511932578.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46507423720877216.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130512938502.4001)
,p_branch_action=>'4726'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130513963435.4001)
,p_name=>'F4000_P4725_TABSET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(130505887827.4001)
,p_prompt=>'Juego de Separadores Principales'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PARENT_TABSETS'
,p_lov=>'select distinct wwv_flow_escape.html(tab_set) d, tab_set r from wwv_flow_toplevel_tabs where flow_id = :fb_flow_id order by 1'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ning\00FAn separador seleccionado -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>':F4000_LAST_VIEW != ''9000'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el juego de separadores de nivel principal al que pertenece este nuevo separador. Un juego de separadores identifica un grupo de separadores que aparecen juntos.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130514966502.4001)
,p_name=>'F4000_P4725_NEW_TABSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(130505887827.4001)
,p_prompt=>unistr('Nuevo Juego de Separadores Principales (si no existe ning\00FAn juego de separadores)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>':F4000_LAST_VIEW != 9000'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Introduzca un nombre en este atributo para crear un juego de separadores principales nuevo.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130516975869.4001)
,p_name=>'F4000_P4725_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(130505887827.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130520055184.4001)
,p_name=>'F4000_P4725_DISPLAY_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(130505887827.4001)
,p_prompt=>'Etiqueta de Separador Principal'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define el texto que aparece en el separador. Si el separador es una imagen, introduzca texto para describir el separador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(130562454599.4001)
,p_computation_sequence=>1
,p_computation_item=>'F4000_P4725_TABSET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&F4000_P4725_NEW_TABSET.'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'v(''F4000_P4725_NEW_TABSET'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130579542330.4001)
,p_validation_name=>'Display Text Required'
,p_validation_sequence=>10
,p_validation=>'F4000_P4725_DISPLAY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la etiqueta de separador principal.'
,p_associated_item=>wwv_flow_api.id(130520055184.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130580554748.4001)
,p_validation_name=>'Tab set must be supplied'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'replace(v(''F4000_P4725_TABSET''),''%null''||''%'',null) is not null or',
'',
'replace(v(''F4000_P4725_TABSET''),''%null''||''%'',null) is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Se debe especificar el juego de separadores o un juego nuevo.'
,p_associated_item=>wwv_flow_api.id(130514966502.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573755732842229738.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130510928901.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573755846131229739.4001)
,p_event_id=>wwv_flow_api.id(573755732842229738.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04726
begin
wwv_flow_api.create_page(
 p_id=>4726.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Separador Principal: Destino'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Separador Principal'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(685388405.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100804924518345585.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'TabSet:Seq:Name:Target'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130522096221.4001)
,p_plug_name=>'Crear Separador Principal'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130523097735.4001)
,p_plug_name=>'Separador Principal'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>201
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique la p\00E1gina a la que se debe llamar cuando un usuario seleccione este separador de nivel principal.</p>'),
'<center><img src="#IMAGE_PREFIX#wwv_parent_tab_wiz.gif" alt="" /></center>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(137384486592.4001)
,p_name=>'Destinos de Separador Existente'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>200
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_name, wwv_flow_escape.html(tab_target) target',
'from   wwv_flow_toplevel_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1,2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48717109682771759.4001)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Juego de Separadores'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48717219952771759.4001)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Secuencia'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48717314629771759.4001)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48717427595771759.4001)
,p_query_column_id=>4
,p_column_alias=>'TARGET'
,p_column_display_sequence=>4
,p_column_heading=>'Destino'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46508826883906543.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130530157719.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46508826883906543.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130531162744.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(46508826883906543.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130532164072.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(46508826883906543.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130533165918.4001)
,p_branch_action=>'4727'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130531162744.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130534167198.4001)
,p_branch_action=>'4725'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130532164072.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130524107490.4001)
,p_name=>'F4000_P4725_TARGET_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130525116304.4001)
,p_name=>'F4000_P4725_TARGET_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_prompt=>unistr('P\00E1gina')
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'nowrap="nowrap" style="white-space:nowrap;"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina de aplicaci\00F3n que desea llamar cuando el usuario seleccione este separador. Se crear\00E1 una direcci\00F3n URL con la sintaxis f?p. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130527127174.4001)
,p_name=>'F4000_P4725_TARGET_REQUEST'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_prompt=>'Solicitud'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Al seleccionar un separador principal, se llama a una p\00E1gina de aplicaci\00F3n mediante una direcci\00F3n URL con el formato de sintaxis <code>f?p</code>. Si desea incluir el componente REQUEST en esta direcci\00F3n URL, introd\00FAzcalo')
||unistr(' aqu\00ED. Por ejemplo: </div>'),
'<pre> ref: f?p=application:page:session:request:debug:clearCache:itemNames:itemValues:printerFriendly</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130558328062.4001)
,p_name=>'F4000_P4726_TN'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Etiqueta de Separador:'
,p_source=>'F4000_P4725_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica la etiqueta del separador.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130559406469.4001)
,p_name=>'F4000_P4726_TS'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Separadores:'
,p_source=>'F4000_P4725_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el juego de separadores seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21290121856492063.4001)
,p_name=>'P4726_CLEAR_PAGE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_prompt=>'('
,p_post_element_text=>')'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_api.id(84877500529450588.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Active esta casilla para restablecer la paginaci\00F3n a la que est\00E1 enlazada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21292432030504395.4001)
,p_name=>'P4726_ARG_NAMES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_prompt=>'Defina estos elementos'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Defina el estado de la sesi\00F3n para estos elementos de aplicaci\00F3n. Al definir el estado de la sesi\00F3n se proporciona un valor a los elementos de la lista. Separe los distintos nombres de elementos con comas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21293511036507851.4001)
,p_name=>'P4726_ARG_VALUES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_prompt=>'Con estos valores'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una lista de valores delimitada por comas para los elementos especificados en <span class="fielddatabold">Defina estos elementos</span>. Puede especificar valores est\00E1ticos o sintaxis de sustituci\00F3n (por ejemplo, &amp;APP_ITEM_NAME.). '),
'<pre>&amp;APP_ITEM_NAME.</pre>',
unistr('<div class="htmldbInfoBodyP">Los valores de los elementos que se transfieren a <span class="fielddatabold">f?p=</span> en la direcci\00F3n URL nunca pueden contener un signo de dos puntos (:). Los valores de los elementos tampoco pueden contener comas a ')
||'menos que incluya todo el valor entre caracteres de barra invertida. Por ejemplo:</div>',
'<pre>\1234,56\</pre>',
unistr('<div class="htmldbInfoBodyP">Esto resulta \00FAtil cuando hay que transferir valores decimales donde el car\00E1cter separador de decimales de NLS es una coma.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(21526423691342700.4001)
,p_name=>'P4726_CLEAR_CACHE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(130522096221.4001)
,p_prompt=>unistr('Borrar Cach\00E9 (p\00E1gina, p\00E1gina)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Limpie la cach\00E9 de estas p\00E1ginas. Separe las distintas p\00E1ginas con comas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130581583629.4001)
,p_validation_name=>'Flow ID Required'
,p_validation_sequence=>10
,p_validation=>'F4000_P4725_TARGET_FLOW'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(130524107490.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130582585040.4001)
,p_validation_name=>'Page ID Required'
,p_validation_sequence=>20
,p_validation=>'F4000_P4725_TARGET_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el identificador de p\00E1gina.')
,p_associated_item=>wwv_flow_api.id(130525116304.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573755550406229736.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130530157719.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573755623445229737.4001)
,p_event_id=>wwv_flow_api.id(573755550406229736.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04727
begin
wwv_flow_api.create_page(
 p_id=>4727.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear Separador Principal: Secuencia y Visualizaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>'Crear Separador Principal'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(686394994.4001)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(100804924518345585.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_plug_query_headings=>'TabSet:Seq:Name:Target'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130553981766.4001)
,p_plug_name=>'Crear Separador Principal'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(130554984359.4001)
,p_plug_name=>'Separador Principal'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>101
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identifique la secuencia. Utilice el listado de otros separadores de este juego de separadores para determinar el n\00FAmero de secuencia. Si la visualizaci\00F3n de los separadores es condicional, identifique una opci\00F3n de creaci\00F3n o una condici\00F3n.</p>'),
'<center><img src="#IMAGE_PREFIX#wwv_parent_tab_wiz.gif" /></center>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46511822428933590.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>101
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130555061264.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(46511822428933590.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130557067755.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(46511822428933590.4001)
,p_button_name=>'CreateParentTab'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear Separador Principal'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(130556065048.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(46511822428933590.4001)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130586692998.4001)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(130561436671.4001)
,p_branch_action=>'4726'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(130556065048.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130519051336.4001)
,p_name=>'F4000_P4725_SEQUENCE'
,p_item_sequence=>1.1
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_prompt=>'Secuencia'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la secuencia para este componente. La secuencia determina el orden de evaluaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130544254553.4001)
,p_name=>'F4000_P4725_DISPLAY_CONDITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Utilice este atributo para controlar de forma condicional si se presenta o procesa un componente. Introduzca los valores en este atributo en funci\00F3n del tipo de condici\00F3n concreto seleccionado. Si se cumple la condici\00F3n especificada, se presenta o pr')
||'ocesa el componente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130563543200.4001)
,p_name=>'F4000_P4727_TN'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de Separador:'
,p_source=>'F4000_P4725_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifica el nombre del separador seleccionado.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130583662977.4001)
,p_name=>'F4000_P4725_CONDITION_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un tipo de condici\00F3n de la lista. Esta condici\00F3n se debe cumplir para presentar o procesar este componente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4725_DISPLAY_CONDITION'
,p_attribute_02=>'F4000_P4725_DISPLAY_CONDITION2'
,p_attribute_04=>'F4000_P4725_DISPLAY_CONDITION_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'F4000_P4725_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(130584673664.4001)
,p_name=>'F4000_P4725_BUILD_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<div class="htmldbInfoBodyP">Seleccione una opci\00F3n de creaci\00F3n para este componente. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.</div>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2307536599478302.4001)
,p_name=>'F4000_P4725_CONDITION_LANG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(17589829151313563.4001)
,p_name=>'F4000_P4725_DISPLAY_CONDITION2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(435045129305654799.4001)
,p_name=>'F4000_P4725_DISPLAY_CONDITION_CHECK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(130553981766.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(130585677858.4001)
,p_validation_name=>'sequence is numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4725_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La secuencia debe ser num\00E9rica.')
,p_associated_item=>wwv_flow_api.id(130519051336.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185780111075413036.4001)
,p_validation_name=>'Sequence Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4725_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe especificar una secuencia num\00E9rica.')
,p_validation_condition=>'Back,Cancel'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(130519051336.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(573755230701229733.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(130555061264.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(573755379646229734.4001)
,p_event_id=>wwv_flow_api.id(573755230701229733.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(130560434983.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create parent tab set'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  n varchar2(300); ',
'  t varchar2(4000);',
'  l_current_on_tabset varchar2(255);',
'  l_clear_cache varchar2(4000);',
'  c_pt  number;',
'  c_st  number;',
'  ts    varchar2(4000);',
'  l_no_parent_tab boolean := false;',
'  l_parent_tab_tabset varchar2(255);',
'begin',
'n := replace(v(''F4000_P4725_DISPLAY_TEXT''),''?'',null);',
'n := replace(n,'' '',null);',
'n := replace(n,''&'',null);',
'n := replace(n,''='',null);',
'n := replace(n,''%'',null);',
'n := ''T_''||upper(substr(n,1,30));',
'if :P4726_CLEAR_PAGE = ''YES'' then',
'  l_clear_cache := ''RP,''||:P4726_CLEAR_CACHE;',
'else',
'  l_clear_cache := :P4726_CLEAR_CACHE;',
'end if;',
't := ''f?p=&''||''APP_ID.''||'':''||',
'v(''F4000_P4725_TARGET_PAGE'')||'':''||',
'''&''||''SESSION.:''||',
'v(''F4000_P4725_TARGET_REQUEST'')||'':&''||''DEBUG.:''||',
'rtrim(l_clear_cache,'','')||'':''||',
':P4726_ARG_NAMES||'':''||',
':P4726_ARG_VALUES;',
'',
'if replace(vrn(''F4000_P197_STD_TABSET''),''%''||''null%'',null) is null then',
'  select count(*) into c_pt from WWV_FLOW_TOPLEVEL_TABS where FLOW_ID = :fb_flow_id;',
'  select count(distinct TAB_SET), nvl(max(tab_set),''TS1'') ts into c_st, ts from WWV_FLOW_TABS where flow_id = :fb_flow_id;',
'  if c_pt = 0 and c_st = 1 then',
'    -- no parent tabs exist',
'    -- only one stand tab set exists',
'    l_current_on_tabset := ts;',
'    l_no_parent_tab := true;',
'  else',
'    l_current_on_tabset := n;',
'  end if;',
'else',
'  l_current_on_tabset := vrn(''F4000_P197_STD_TABSET'');',
'end if;',
'',
'',
'l_parent_tab_tabset := v(''F4000_P4725_TABSET'');',
'',
'wwv_flow_api.create_toplevel_tab(',
'  p_flow_id=>nv(''FB_FLOW_ID''),',
'  p_tab_set=> l_parent_tab_tabset,',
'  p_tab_sequence=>nv(''F4000_P4725_SEQUENCE''),',
'  p_tab_name=>n,',
'  p_tab_image=>null,',
'  p_tab_non_current_image=>null,',
'  p_tab_image_attributes=>null,',
'  p_tab_text=>v(''F4000_P4725_DISPLAY_TEXT''),',
'  p_tab_target=>t,',
'  p_current_on_tabset=>l_current_on_tabset,',
'  p_display_condition=>v(''F4000_P4725_DISPLAY_CONDITION''),',
'  p_display_condition2=>v(''F4000_P4725_DISPLAY_CONDITION2''),',
'  p_display_condition_type=>vrn(''F4000_P4725_CONDITION_TYPE''),',
'  p_required_patch=>vrn(''F4000_P4725_BUILD_OPTION''),',
'  p_tab_comment=>null);',
'',
'',
'if l_no_parent_tab then',
'   -- setting current for parent tabset',
'   update wwv_flow_tabs',
'   set    TAB_PARENT_TABSET = l_parent_tab_tabset',
'   where  flow_id = :fb_flow_id and',
'          TAB_SET = ts;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear el separador principal &F4000_P4725_DISPLAY_TEXT..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(130557067755.4001)
,p_process_success_message=>'Separador principal &F4000_P4725_DISPLAY_TEXT. creado.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(573755449668229735.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Separador principal &F4000_P4725_DISPLAY_TEXT. creado.'
);
end;
/
prompt --application/pages/page_04735
begin
wwv_flow_api.create_page(
 p_id=>4735.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear pantalla: Origen de datos'
,p_page_mode=>'MODAL'
,p_step_title=>'Origen de Datos'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212960427558523531)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46020452357316101.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94490455112611952.4001)
,p_plug_name=>'Origen de Datos'
,p_region_name=>'data_source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3377880030506578.4001)
,p_plug_name=>'SQL local'
,p_parent_plug_id=>wwv_flow_api.id(94490455112611952.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1674702362724023.4001)
,p_plug_name=>'Columnas'
,p_parent_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4735_PAGE_TYPE'
,p_plug_display_when_cond2=>'FORM_REPORT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(501516972457327691.4001)
,p_plug_name=>'Valores por Defecto de Interfaz de Usuario'
,p_parent_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(59836303269637894.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_required_role=>wwv_flow_api.id(499915500493760557)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3377965444506579.4001)
,p_plug_name=>'Origen de Datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(94490455112611952.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5168619875114506.4001)
,p_plug_name=>'SQL activado para REST'
,p_parent_plug_id=>wwv_flow_api.id(94490455112611952.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1675018763724026.4001)
,p_plug_name=>'Columnas'
,p_parent_plug_id=>wwv_flow_api.id(5168619875114506.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4735_PAGE_TYPE'
,p_plug_display_when_cond2=>'FORM_REPORT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94490670895611952.4001)
,p_plug_name=>'Ejemplo de Consulta SQL'
,p_region_name=>'sql_example'
,p_parent_plug_id=>wwv_flow_api.id(94490455112611952.4001)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT ENAME, JOB, SAL, COMM',
'FROM   EMP',
'WHERE  DEPTNO = :P2_DEPTNO',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>La variable de enlace de este ejemplo corresponde a un elemento de una aplicaci\00F3n. Utilice la sintaxis de variable de enlace para hacer referencia al estado de la sesi\00F3n de la aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94496866994616969.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(61344818353755082.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1601299444558995.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(46020452357316101.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1601644874558997.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(46020452357316101.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1602029737558998.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(46020452357316101.4001)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1674648243724022.4001)
,p_branch_name=>'Branch to Form Columns'
,p_branch_action=>'f?p=&APP_ID.:4736:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1601644874558997.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1602723468559010.4001)
,p_name=>'P4735_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(94490455112611952.4001)
,p_item_default=>'LOCAL'
,p_prompt=>'Origen de Datos'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Permite seleccionar el tipo de <em>origen de datos</em> del nuevo componente APEX.',
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se originan en la base de datos local.</li>',
'    <li><strong>Servicio de SQL activado para REST</strong><br>',
unistr('    Los datos se originan en una base de datos remota, donde la conexi\00F3n se define utilizando el servicio SQL activado para REST. Para crear o conservar las referencias de SQL activadas para REST, acceda a Componentes compartidos, SQL activado para R')
||'EST.',
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos se originan en un servicio web RESTful que utiliza or\00EDgenes de datos de REST. Para crear o conservar los or\00EDgenes de datos de REST, acceda a Componentes compartidos, Or\00EDgenes de datos de REST.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1604312861559016.4001)
,p_name=>'P4735_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. Los informes pueden estar basados en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1605267453559017.4001)
,p_name=>'P4735_RPT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1605673309559017.4001)
,p_name=>'P4735_TABLE_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P4735_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1606595742559018.4001)
,p_name=>'P4735_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4735_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P4735_TABLE_OWNER,P4735_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la pantalla. Si se especifica manualmente, tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1609699925559021.4001)
,p_name=>'P4735_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la regi\00F3n de informe, por ejemplo:'),
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1610579398559022.4001)
,p_name=>'P4735_USE_UI_DEF'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(3377880030506578.4001)
,p_item_default=>'Y'
,p_prompt=>'Usar Valores por Defecto de Interfaz de Usuario:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(84259319526460470.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_security_scheme=>wwv_flow_api.id(499915500493760557)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Seleccione si se va a utilizar el diccionario de atributos de valores por defecto de la interfaz de usuario para crear el informe.</div>',
'<div class="htmldbInfoBodyP">El diccionario de atributos de valores por defecto de la interfaz de usuario permite asignar propiedades de interfaz de usuario por defecto a un nombre de columna. Cuando un desarrollador crea una pantalla o un informe me'
||unistr('diante un asistente, el asistente utiliza esta informaci\00F3n para crear valores por defecto para las propiedades de regi\00F3n y elemento.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1616715194559033.4001)
,p_name=>'P4735_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3377965444506579.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1618316092559035.4001)
,p_name=>'P4735_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5168619875114506.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1618775410559035.4001)
,p_name=>'P4735_REMOTE_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5168619875114506.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de la nueva p\00E1gina. Los informes pueden estar basados en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1619613049559035.4001)
,p_name=>'P4735_REMOTE_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5168619875114506.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que producir\00E1 los resultados para la regi\00F3n de informe, por ejemplo:'),
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P4735_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1620504898559036.4001)
,p_name=>'P4735_REMOTE_TABLE_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5168619875114506.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4735_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P4735_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1621490013559036.4001)
,p_name=>'P4735_REMOTE_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(5168619875114506.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4735_REMOTE_SERVER_ID, ''TABLE'', :P4735_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P4735_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P4735_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el propietario de la tabla en la que va a crear un informe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1674468560724020.4001)
,p_name=>'P4735_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(94490455112611952.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1703148062002986.4001)
,p_name=>'P4735_WEB_SRC_COLUMNS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(3377965444506579.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''WEB_SOURCE'',',
'                  p_web_src_module_id => :P4735_WEB_SRC_MODULE_ID,',
'                  p_query_type        => null ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Seleccione las columnas que se mostrar\00E1n en el informe')
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''WEB_SOURCE'',',
'        p_web_src_module_id => :P4735_WEB_SRC_MODULE_ID,',
'        p_query_type        => null ) )    ',
' order by 1'))
,p_lov_cascade_parent_items=>'P4735_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_display_when=>'P4735_PAGE_TYPE'
,p_display_when2=>'FORM_REPORT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1703940060005132.4001)
,p_name=>'P4735_REMOTE_SQL_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1675018763724026.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select column_name',
'         from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location          => ''REMOTE'',',
'                  p_remote_server_id  => :P4735_REMOTE_SERVER_ID,',
'                  p_owner             => :P4735_REMOTE_TABLE_OWNER,',
'                  p_table_name        => :P4735_REMOTE_TABLE_NAME,',
'                  p_query_type        => ''TABLE'' ) ) ) loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    ',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Seleccione las columnas que se mostrar\00E1n en el informe')
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'        p_location          => ''REMOTE'',',
'        p_remote_server_id  => :P4735_REMOTE_SERVER_ID,',
'        p_owner             => :P4735_REMOTE_TABLE_OWNER,',
'        p_table_name        => :P4735_REMOTE_TABLE_NAME,',
'        p_query_type        => ''TABLE'' ) )'))
,p_lov_cascade_parent_items=>'P4735_REMOTE_TABLE_NAME,P4735_REMOTE_SERVER_ID'
,p_ajax_items_to_submit=>'P4735_REMOTE_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1704757948006518.4001)
,p_name=>'P4735_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1674702362724023.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    if :P4735_TABLE_OWNER is not null and :P4735_TABLE_NAME is not null then',
'        for l_column in (',
'            select column_name',
'              from wwv_flow_table_columns_dev',
'             where owner      = :P4735_TABLE_OWNER',
'               and table_name = :P4735_TABLE_NAME',
'        ) loop',
'            l_columns := l_columns || l_column.column_name || '':'';',
'        end loop;',
'    end if;',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Seleccione las columnas que se mostrar\00E1n en el informe')
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P4735_TABLE_OWNER',
'   and table_name = :P4735_TABLE_NAME',
'   and :P4735_TABLE_NAME is not null',
'   and :P4735_SOURCE_TYPE = ''TABLE'''))
,p_lov_cascade_parent_items=>'P4735_TABLE_NAME'
,p_ajax_items_to_submit=>'P4735_TABLE_OWNER,P4735_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1623923964559054.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4735_REMOTE_SERVER_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4735_LOCATION'
,p_compute_when_text=>'REMOTE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1624799896559059.4001)
,p_computation_sequence=>70
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4735_TABLE_OWNER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1813529926055312.4001)
,p_computation_sequence=>80
,p_computation_item=>'P4735_PAGE_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P4700_SELECT_REPORT_TYPE = ''FORM'' then ''FORM'' else ''FORM_REPORT'' end'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1626353627559064.4001)
,p_validation_name=>'Local SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P4735_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la consulta SQL.'
,p_validation_condition=>':P4735_SOURCE_TYPE = ''QUERY'' and :P4735_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1609699925559021.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1676944879724045.4001)
,p_validation_name=>'Remote SQL Not Null'
,p_validation_sequence=>20
,p_validation=>'P4735_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar la consulta SQL.'
,p_validation_condition=>':P4735_REMOTE_SOURCE_TYPE = ''QUERY'' and :P4735_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1619613049559035.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1627551528559065.4001)
,p_validation_name=>'Local Table Owner Not Null'
,p_validation_sequence=>30
,p_validation=>'P4735_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el propietario de tabla.'
,p_validation_condition=>':P4735_SOURCE_TYPE = ''TABLE'' and :P4735_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1627923968559066.4001)
,p_validation_name=>'Table Name Not Null'
,p_validation_sequence=>40
,p_validation=>'P4735_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe especificar el nombre de la tabla.'
,p_validation_condition=>':P4735_SOURCE_TYPE = ''TABLE'' and :P4735_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1625595999559063.4001)
,p_validation_name=>'Remote Table Name Not Null'
,p_validation_sequence=>50
,p_validation=>'P4735_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe especificar el nombre de la tabla.'
,p_validation_condition=>':P4735_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4735_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1676705449724043.4001)
,p_validation_name=>'REST Enabled SQL ID Not Null'
,p_validation_sequence=>60
,p_validation=>'P4735_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'El servicio de SQL activado para REST debe tener un valor.'
,p_validation_condition=>'P4735_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1618316092559035.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1676635199724042.4001)
,p_validation_name=>'REST Data Source ID Not Null'
,p_validation_sequence=>70
,p_validation=>'P4735_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe elegir un origen de datos de REST.'
,p_validation_condition=>'P4735_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1616715194559033.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1626764607559064.4001)
,p_validation_name=>'Local SQL query is valid'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P4735_SQL );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4735_SOURCE_TYPE = ''QUERY'' and :P4735_LOCATION = ''LOCAL'' and :P4735_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1609699925559021.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1676806740724044.4001)
,p_validation_name=>'Remote SQL query is valid'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_remote_db,',
'                            p_remote_server_id     => :P4735_REMOTE_SERVER_ID,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P4735_REMOTE_SQL );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4735_REMOTE_SOURCE_TYPE = ''QUERY'' and :P4735_LOCATION = ''REMOTE'' and :P4735_REMOTE_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1619613049559035.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(578366447807453050.4001)
,p_validation_name=>'Chosen Table Exists'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P4735_TABLE_OWNER',
'   and object_name = :P4735_TABLE_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La tabla &P4735_TABLE_NAME!HTML. no existe. Tenga en cuenta que el nombre de la tabla es sensible a may\00FAsculas/min\00FAsculas.')
,p_validation_condition=>':P4735_SOURCE_TYPE = ''TABLE'' and :P4735_LOCATION = ''LOCAL'' and :P4735_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1601644874558997.4001)
,p_associated_item=>wwv_flow_api.id(1606595742559018.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1631027007559069.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1601299444558995.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1631505230559075.4001)
,p_event_id=>wwv_flow_api.id(1631027007559069.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1631981899559080.4001)
,p_name=>'show report source attributes'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4735_SOURCE_TYPE'
,p_condition_element=>'P4735_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1674908335724025.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1632363850559080.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1632824111559081.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1633350284559082.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_TABLE_OWNER,P4735_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1633879007559082.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_TABLE_OWNER,P4735_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1636366296559084.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_USE_UI_DEF'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1674884597724024.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1636867597559084.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_USE_UI_DEF'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1637341015559084.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_USE_UI_DEF'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1637855685559084.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_USE_UI_DEF'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1638321414559085.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(501516972457327691.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1638879365559085.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(501516972457327691.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1673955853724015.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1673763916724013.4001)
,p_event_id=>wwv_flow_api.id(1631981899559080.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1639204253559085.4001)
,p_name=>'show remote report source attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4735_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P4735_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1639790266559085.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1675251466724028.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SQL_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1640716581559086.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_TABLE_OWNER,P4735_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1641217259559086.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_TABLE_OWNER,P4735_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1642202591559087.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1675168694724027.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SQL_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1674283177724018.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1674357591724019.4001)
,p_event_id=>wwv_flow_api.id(1639204253559085.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1645483986559090.4001)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4735_LOCATION'
,p_condition_element=>'P4735_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1645942433559090.4001)
,p_event_id=>wwv_flow_api.id(1645483986559090.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3377880030506578.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1646465650559090.4001)
,p_event_id=>wwv_flow_api.id(1645483986559090.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3377880030506578.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1646985004559090.4001)
,p_event_id=>wwv_flow_api.id(1645483986559090.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1673472528724010.4001)
,p_event_id=>wwv_flow_api.id(1645483986559090.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1647320398559091.4001)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4735_LOCATION'
,p_condition_element=>'P4735_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1647877409559091.4001)
,p_event_id=>wwv_flow_api.id(1647320398559091.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5168619875114506.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1648357354559091.4001)
,p_event_id=>wwv_flow_api.id(1647320398559091.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5168619875114506.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1673595815724011.4001)
,p_event_id=>wwv_flow_api.id(1647320398559091.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1648770038559091.4001)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4735_LOCATION'
,p_condition_element=>'P4735_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1649267244559091.4001)
,p_event_id=>wwv_flow_api.id(1648770038559091.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3377965444506579.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1649701516559092.4001)
,p_event_id=>wwv_flow_api.id(1648770038559091.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3377965444506579.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1673672526724012.4001)
,p_event_id=>wwv_flow_api.id(1648770038559091.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1650195814559092.4001)
,p_name=>'Remote Server chosen'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4735_REMOTE_SERVER_ID'
,p_condition_element=>'P4735_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1650605120559092.4001)
,p_event_id=>wwv_flow_api.id(1650195814559092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1651163483559092.4001)
,p_event_id=>wwv_flow_api.id(1650195814559092.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1651605907559093.4001)
,p_event_id=>wwv_flow_api.id(1650195814559092.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SOURCE_TYPE,P4735_REMOTE_SQL,P4735_REMOTE_TABLE_OWNER,P4735_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1652159409559093.4001)
,p_event_id=>wwv_flow_api.id(1650195814559092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4735_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1674146890724017.4001)
,p_event_id=>wwv_flow_api.id(1650195814559092.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1674072283724016.4001)
,p_event_id=>wwv_flow_api.id(1650195814559092.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1673227206724008.4001)
,p_name=>'Show / Hide SQL Example'
,p_event_sequence=>140
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(94490455112611952.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'show_hide_sql_example'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1673371038724009.4001)
,p_event_id=>wwv_flow_api.id(1673227206724008.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lShow = false;',
'',
'     if ( $v("P4735_LOCATION") === "REMOTE" && $v("P4735_REMOTE_SOURCE_TYPE") === "QUERY" ) { lShow = true; }',
'else if ( $v("P4735_LOCATION") === "LOCAL"  && $v("P4735_SOURCE_TYPE")        === "QUERY" ) { lShow = true; }',
'',
'if ( lShow ) {',
'    $("#sql_example").show(); ',
'} else {',
'    $("#sql_example").hide(); ',
'}'))
);
end;
/
prompt --application/pages/page_04736
begin
wwv_flow_api.create_page(
 p_id=>4736.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear pantalla: Columnas y clave primaria'
,p_page_mode=>'MODAL'
,p_step_title=>'Crear pantalla: Columnas y clave primaria'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(212960427558523531)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47742690711448322.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(96212693466744173.4001)
,p_plug_name=>'Columnas de Pantalla'
,p_region_name=>'data_source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(96219105348749190.4001)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(61344818353755082.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1722957868132236.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(47742690711448322.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1723306282132236.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(47742690711448322.4001)
,p_button_name=>'Create'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1723779522132237.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(47742690711448322.4001)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4735:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1675493313724030.4001)
,p_name=>'P4736_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(96212693466744173.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1675668436724032.4001)
,p_name=>'P4736_PK_BY_ROWID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(96212693466744173.4001)
,p_item_default=>'PKCOLS'
,p_prompt=>'Tipo de Clave Primaria'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PRIMARY_KEY_TYPE'
,p_lov=>'.'||wwv_flow_api.id(11186021931343531.4001)||'.'
,p_read_only_when=>':P4735_LOCATION = ''WEB_SOURCE'' or :P4736_SOURCE_TYPE=''QUERY'''
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1675700767724033.4001)
,p_name=>'P4736_PK_COLUMN_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(96212693466744173.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''P4736_FORM_COLUMNS_DATA''',
' order by seq_id asc'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1675890175724034.4001)
,p_name=>'P4736_PK_COLUMN_2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(96212693466744173.4001)
,p_prompt=>'Columna de Clave Secundaria'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''P4736_FORM_COLUMNS_DATA''',
' order by seq_id asc'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Columna -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1731034429132257.4001)
,p_name=>'P4736_FORM_COLUMNS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(96212693466744173.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_columns varchar2(32767);',
'begin',
'    for l_column in (',
'       select c002 column_name',
'         from wwv_flow_collections ',
'        where collection_name = ''P4736_FORM_COLUMNS_DATA'' )',
'    loop',
'        l_columns := l_columns || l_column.column_name || '':'';',
'    end loop;',
'    return l_columns;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Seleccione las columnas que se mostrar\00E1n en la pantalla')
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''P4736_FORM_COLUMNS_DATA''',
' order by seq_id asc'))
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una o m\00E1s columnas para incluirlas en la regi\00F3n. Seleccione todas las columnas que aparecer\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1675334434724029.4001)
,p_computation_sequence=>10
,p_computation_item=>'P4736_FORM_COLUMNS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4735_LOCATION',
'    when ''LOCAL'' then :P4735_COLUMNS',
'    when ''REMOTE'' then :P4735_REMOTE_SQL_COLUMNS',
'    when ''WEB_SOURCE'' then :P4735_WEB_SRC_COLUMNS end'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1675565635724031.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4736_SOURCE_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4735_LOCATION',
'    when ''LOCAL'' then :P4735_SOURCE_TYPE',
'    when ''REMOTE'' then coalesce(:P4735_REMOTE_SOURCE_TYPE, case when :P4735_REMOTE_TABLE_NAME is not null then ''TABLE'' else ''QUERY'' end) end'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1812735757055304.4001)
,p_validation_name=>'Form Columns Not Null'
,p_validation_sequence=>10
,p_validation=>'P4736_FORM_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Una pantalla debe tener al menos una columna.'
,p_when_button_pressed=>wwv_flow_api.id(1723306282132236.4001)
,p_associated_item=>wwv_flow_api.id(1731034429132257.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1812901930055306.4001)
,p_validation_name=>'Primary Key Col1 Not Null'
,p_validation_sequence=>20
,p_validation=>'P4736_PK_COLUMN_1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe elegirse al menos una columna de clave primaria.'
,p_validation_condition=>'P4736_PK_BY_ROWID'
,p_validation_condition2=>'PKCOLS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(1723306282132236.4001)
,p_associated_item=>wwv_flow_api.id(1675700767724033.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20813317718966806.4001)
,p_validation_name=>'Secondary PK != First PK'
,p_validation_sequence=>30
,p_validation=>':P4736_PK_COLUMN_2 is null or :P4736_PK_COLUMN_2 != coalesce( :P4736_PK_COLUMN_1, ''"'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'La columna de clave secundaria debe ser diferente de la columna de clave primaria'
,p_when_button_pressed=>wwv_flow_api.id(1723306282132236.4001)
,p_associated_item=>wwv_flow_api.id(1675890175724034.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1743207562132272.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1722957868132236.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1743704311132273.4001)
,p_event_id=>wwv_flow_api.id(1743207562132272.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1744186784132273.4001)
,p_name=>'show report source attributes'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_SOURCE_TYPE'
,p_condition_element=>'P4736_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1750137748132279.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1744685314132273.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1745111008132274.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1745677939132275.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_TABLE_OWNER,P4736_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1746180132132275.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_TABLE_OWNER,P4736_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1746659816132276.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_USE_UI_DEF'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1749692095132279.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1747185328132276.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_USE_UI_DEF'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1747692286132277.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_USE_UI_DEF'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1748165431132277.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_USE_UI_DEF'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1750627055132279.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1751134668132280.4001)
,p_event_id=>wwv_flow_api.id(1744186784132273.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1751513545132280.4001)
,p_name=>'show remote report source attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P4736_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1752078614132280.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1755588356132284.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SQL_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1752501674132281.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_TABLE_OWNER,P4736_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1753033123132281.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_TABLE_OWNER,P4736_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1753567074132282.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1755069013132283.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SQL_COLUMNS'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1754056133132283.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1754583045132283.4001)
,p_event_id=>wwv_flow_api.id(1751513545132280.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1755962062132284.4001)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_LOCATION'
,p_condition_element=>'P4736_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1757411140132285.4001)
,p_event_id=>wwv_flow_api.id(1755962062132284.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1757988676132285.4001)
,p_event_id=>wwv_flow_api.id(1755962062132284.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1758328605132285.4001)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_LOCATION'
,p_condition_element=>'P4736_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1759845875132286.4001)
,p_event_id=>wwv_flow_api.id(1758328605132285.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1760233741132286.4001)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_LOCATION'
,p_condition_element=>'P4736_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1761703273132287.4001)
,p_event_id=>wwv_flow_api.id(1760233741132286.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1762101951132287.4001)
,p_name=>'Remote Server chosen'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_REMOTE_SERVER_ID'
,p_condition_element=>'P4736_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1763663945132288.4001)
,p_event_id=>wwv_flow_api.id(1762101951132287.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1764112438132288.4001)
,p_event_id=>wwv_flow_api.id(1762101951132287.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1764613137132289.4001)
,p_event_id=>wwv_flow_api.id(1762101951132287.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SOURCE_TYPE,P4736_REMOTE_SQL,P4736_REMOTE_TABLE_OWNER,P4736_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1763139880132288.4001)
,p_event_id=>wwv_flow_api.id(1762101951132287.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1765150477132289.4001)
,p_event_id=>wwv_flow_api.id(1762101951132287.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1762611953132288.4001)
,p_event_id=>wwv_flow_api.id(1762101951132287.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#data_source"), "show_hide_sql_example");'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1765519837132289.4001)
,p_name=>'Show / Hide SQL Example'
,p_event_sequence=>140
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(96212693466744173.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'show_hide_sql_example'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1766059994132290.4001)
,p_event_id=>wwv_flow_api.id(1765519837132289.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lShow = false;',
'',
'     if ( $v("P4736_LOCATION") === "REMOTE" && $v("P4736_REMOTE_SOURCE_TYPE") === "QUERY" ) { lShow = true; }',
'else if ( $v("P4736_LOCATION") === "LOCAL"  && $v("P4736_SOURCE_TYPE")        === "QUERY" ) { lShow = true; }',
'',
'if ( lShow ) {',
'    $("#sql_example").show(); ',
'} else {',
'    $("#sql_example").hide(); ',
'}'))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1675926515724035.4001)
,p_name=>'Switch PK Type '
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_PK_BY_ROWID'
,p_condition_element=>'P4736_PK_BY_ROWID'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ROWID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1676019016724036.4001)
,p_event_id=>wwv_flow_api.id(1675926515724035.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_PK_COLUMN_1,P4736_PK_COLUMN_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1676176398724037.4001)
,p_event_id=>wwv_flow_api.id(1675926515724035.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_PK_COLUMN_1,P4736_PK_COLUMN_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1676226278724038.4001)
,p_name=>'First PK Column chosen'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4736_PK_COLUMN_1'
,p_condition_element=>'P4736_PK_COLUMN_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1676348981724039.4001)
,p_event_id=>wwv_flow_api.id(1676226278724038.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_PK_COLUMN_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1676480493724040.4001)
,p_event_id=>wwv_flow_api.id(1676226278724038.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_PK_COLUMN_2'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1599825281532813.4001)
,p_name=>'Hide ROWID selector for REST Sources or SQL Queries'
,p_event_sequence=>170
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P4735_LOCATION = ''WEB_SOURCE'' or :P4736_SOURCE_TYPE = ''QUERY'''
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1599930471532814.4001)
,p_event_id=>wwv_flow_api.id(1599825281532813.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4736_PK_BY_ROWID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(591301835161123901.4001)
,p_name=>'Create'
,p_event_sequence=>180
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1723306282132236.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(591301907481123902.4001)
,p_event_id=>wwv_flow_api.id(591301835161123901.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'Create'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1813453753055311.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Form and Report Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_pk_columns         wwv_flow_t_varchar2 := wwv_flow_t_varchar2( 1 );',
'    l_form_columns       wwv_flow_t_varchar2;',
'    l_rpt_columns        wwv_flow_t_varchar2;',
'    l_rpt_page_id        number;',
'',
'    l_rpt_impl           wwv_flow_form_region_dev.t_report_implementation;',
'begin',
'    l_form_columns := wwv_flow_string.split( :P4736_FORM_COLUMNS, '':'' );',
'    l_rpt_columns  := wwv_flow_string.split( case :P4735_LOCATION',
'                                                 when ''LOCAL''      then :P4735_COLUMNS',
'                                                 when ''REMOTE''     then :P4735_REMOTE_SQL_COLUMNS',
'                                                 when ''WEB_SOURCE'' then :P4735_WEB_SRC_COLUMNS end, '':'' );',
'',
'    if :P4736_PK_BY_ROWID = ''ROWID'' then',
'        l_pk_columns( 1 ) := ''ROWID'';',
'',
'        if ''ROWID'' not member of l_form_columns then',
'            l_form_columns.extend( 1 );',
'            l_form_columns( l_form_columns.count ) := ''ROWID'';',
'            l_rpt_columns.extend( 1 );',
'            l_rpt_columns( l_rpt_columns.count ) := ''ROWID'';',
'        end if;',
'    else',
'        l_pk_columns( 1 ) := :P4736_PK_COLUMN_1;',
'        if :P4736_PK_COLUMN_2 is not null then',
'            l_pk_columns.extend( 1 );',
'            l_pk_columns( 2 ) := :P4736_PK_COLUMN_2;',
'        end if;',
'    end if;',
'',
'    if :P4700_SELECT_REPORT_TYPE = ''FORM'' then',
'        l_rpt_page_id := :F4000_P4810_PAGE_ID;',
'    ',
'        wwv_flow_form_region_dev.create_form_page(',
'            p_flow_id                    => :FB_FLOW_ID,',
'            p_page_id                    => l_rpt_page_id,',
'            p_page_name                  => :F4000_P4810_PAGE_NAME,',
'            p_group_name                 => :P4810_GROUP_NAME,',
'            p_page_mode                  => :P4810_PAGE_MODE,',
'            p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'            --',
'            p_tab_set                    => :P4716_TAB_SET,',
'            p_tab_name                   => :P4716_TAB_NAME,',
'            p_tab_text                   => :P4716_TAB_LABEL,',
'            --',
'            p_nav_list_id                => :P4716_NAVLIST_ID,',
'            p_nav_list_parent_item_id    => :P4716_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name   => :P4716_NAVLIST_ENTRY_NAME,',
'            --',
'            p_breadcrumb_id              => :P4810_BREADCRUMB_ID,',
'            p_breadcrumb_entry_name      => :P4810_BREADCRUMB_NAME,',
'            p_parent_breadcrumb_entry_id => :P4810_BREADCRUMB_PARENT_ID,',
'            --',
'            p_region_title               => :F4000_P4810_PAGE_NAME,',
'            p_region_template            => wwv_flow_theme_dev.get_region_template_id (',
'                                                p_application_id => :FB_FLOW_ID,',
'                                                p_theme_id       => :FB_THEME_ID,',
'                                                p_page_type      => ''FORM''), ',
'            --',
'            p_location                   => :P4735_LOCATION,',
'            p_query_type                 => case :P4736_SOURCE_TYPE',
'                                                when ''TABLE'' then wwv_flow_exec_api.c_query_type_table',
'                                                else              wwv_flow_exec_api.c_query_type_sql_query end,',
'            p_table_owner                => case :P4735_LOCATION',
'                                                when ''LOCAL'' then :P4735_TABLE_OWNER',
'                                                when ''REMOTE'' then :P4735_REMOTE_TABLE_OWNER end,',
'            p_table_name                 => case :P4735_LOCATION',
'                                                when ''LOCAL'' then :P4735_TABLE_NAME',
'                                                when ''REMOTE'' then :P4735_REMOTE_TABLE_NAME end,',
'            p_sql_plsql_source           => case :P4735_LOCATION',
'                                                when ''LOCAL'' then :P4735_SQL',
'                                                when ''REMOTE'' then :P4735_REMOTE_SQL end,',
'            p_remote_server_id           => case :P4735_LOCATION  ',
'                                                when ''REMOTE'' then :P4735_REMOTE_SERVER_ID end,',
'            p_web_source_module_id       => case :P4735_LOCATION  ',
'                                                when ''WEB_SOURCE'' then :P4735_WEB_SRC_MODULE_ID end,',
'            --',
'            p_primary_key_columns        => l_pk_columns,',
'            p_form_columns               => l_form_columns,',
'            --',
'            p_branch                     => :P4810_BRANCH,',
'            p_cancel_branch              => :P4810_CANCEL_BRANCH );',
'',
'    else',
'        l_rpt_page_id := :F4000_P4703_REPORT_PAGE_ID;',
'',
'        if :P4041_IMPLEMENTATION = ''INTERACTIVE'' then ',
'            l_rpt_impl := wwv_flow_form_region_dev.c_report_impl_interactive;',
'        elsif :P4041_IMPLEMENTATION = ''CLASSIC'' then ',
'            l_rpt_impl := wwv_flow_form_region_dev.c_report_impl_classic;',
'        elsif :P4041_IMPLEMENTATION = ''IG'' then',
'            l_rpt_impl := wwv_flow_form_region_dev.c_report_impl_ig;',
'        elsif :P4041_IMPLEMENTATION = ''LISTVIEW'' then',
'            l_rpt_impl := wwv_flow_form_region_dev.c_report_impl_listview;',
'        end if;          ',
'',
'        wwv_flow_form_region_dev.create_form_and_report_pages(',
'            p_flow_id                    => :FB_FLOW_ID,',
'            p_form_page_id               => :F4000_P4703_FLOW_STEP_ID,',
'            p_report_page_id             => l_rpt_page_id,',
'            p_form_page_name             => :F4000_P4703_FORM_PAGE_NAME,',
'            p_report_page_name           => :F4000_P4703_REPORT_PAGE_NAME,',
'            --',
'            p_report_implementation      => l_rpt_impl,',
'',
'            p_form_page_mode             => :P4039_PAGE_MODE,',
'            p_report_page_mode           => wwv_flow_page.c_page_mode_normal,',
'            p_group_name                 => :P4041_GROUP_NAME,',
'            p_user_interface_id          => :P259_USER_INTERFACE_ID,',
'            --',
'            p_tab_set                    => :P4716_TAB_SET,',
'            p_tab_name                   => :P4716_TAB_NAME,',
'            p_tab_text                   => :P4716_TAB_LABEL,',
'            --',
'            p_nav_list_id                => :P4716_NAVLIST_ID,',
'            p_nav_list_parent_item_id    => :P4716_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name   => :P4716_NAVLIST_ENTRY_NAME,',
'            --',
'            p_breadcrumb_id              => :P4041_BREADCRUMB_ID,',
'            p_breadcrumb_entry_name      => :P4041_BREADCRUMB_NAME,',
'            p_parent_breadcrumb_entry_id => :P4041_BREADCRUMB_PARENT_ID,',
'            --',
'            p_location                   => :P4735_LOCATION,',
'            p_query_type                 => case :P4736_SOURCE_TYPE',
'                                                when ''TABLE'' then wwv_flow_exec_api.c_query_type_table',
'                                                else              wwv_flow_exec_api.c_query_type_sql_query end,',
'            p_table_owner                => case :P4735_LOCATION',
'                                                when ''LOCAL'' then :P4735_TABLE_OWNER',
'                                                when ''REMOTE'' then :P4735_REMOTE_TABLE_OWNER end,',
'            p_table_name                 => case :P4735_LOCATION',
'                                                when ''LOCAL'' then :P4735_TABLE_NAME',
'                                                when ''REMOTE'' then :P4735_REMOTE_TABLE_NAME end,',
'            p_sql_plsql_source           => case :P4735_LOCATION',
'                                                when ''LOCAL'' then :P4735_SQL',
'                                                when ''REMOTE'' then :P4735_REMOTE_SQL end,',
'            p_remote_server_id           => case :P4735_LOCATION  ',
'                                                when ''REMOTE'' then :P4735_REMOTE_SERVER_ID end,',
'            p_web_source_module_id       => case :P4735_LOCATION  ',
'                                                when ''WEB_SOURCE'' then :P4735_WEB_SRC_MODULE_ID end,',
'            --',
'            p_primary_key_columns        => l_pk_columns,',
'            p_form_columns               => l_form_columns,',
'            p_report_columns             => l_rpt_columns,',
'            --',
'            p_rpt_region_template        => wwv_flow_theme_dev.get_region_template_id (',
'                                                 p_application_id => :FB_FLOW_ID,',
'                                                 p_theme_id       => :FB_THEME_ID,',
'                                                 p_page_type      => ''REPORT'' ), ',
'            p_rpt_template               => case when l_rpt_impl = wwv_flow_form_region_dev.c_report_impl_classic',
'                                                 then wwv_flow_theme_dev.get_report_template_id(',
'                                                     p_application_id => :FB_FLOW_ID,',
'                                                     p_theme_id       => :FB_THEME_ID ) end,',
'            p_rpt_region_name            => wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME''),',
'            p_form_region_template       => wwv_flow_theme_dev.get_region_template_id (',
'                                                p_application_id => :FB_FLOW_ID,',
'                                                p_theme_id       => :FB_THEME_ID,',
'                                                p_page_type      => ''FORM''), ',
'            p_form_region_name           => :F4000_P4703_FORM_PAGE_NAME );',
'    end if;',
'    ',
'    ',
'    ',
'    ',
'    :fb_flow_page_id       := l_rpt_page_id;',
'    :F4000_RUN_EDIT_PAGE   := l_rpt_page_id;    ',
'end;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1723306282132236.4001)
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1828781730661010.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1723306282132236.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(20813269737966805.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Form Columns to Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_collection_name constant varchar2(23) := ''P4736_FORM_COLUMNS_DATA'';',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( ',
'        p_collection_name => c_collection_name );',
'    ',
'    for c in (',
'        select column_name_esc,',
'               column_name',
'          from table(wwv_flow_exec_dev.get_query_columns(',
'              p_location          => :P4735_LOCATION,',
'              p_query_type        => case when :P4736_SOURCE_TYPE = ''QUERY'' then ''SQL'' else :P4736_SOURCE_TYPE end,',
'              p_owner             => case when :P4736_SOURCE_TYPE = ''TABLE'' then ',
'                                          case when :P4735_LOCATION = ''REMOTE'' then :P4735_REMOTE_TABLE_OWNER ',
'                                               when :P4735_LOCATION = ''LOCAL'' then :P4735_TABLE_OWNER end',
'                                     end,',
'              p_table_name        => case when :P4736_SOURCE_TYPE = ''TABLE'' then ',
'                                          case when :P4735_LOCATION = ''REMOTE'' then :P4735_REMOTE_TABLE_NAME ',
'                                               when :P4735_LOCATION = ''LOCAL'' then :P4735_TABLE_NAME end',
'                                     end,',
'              p_sql_query         => case when :P4736_SOURCE_TYPE = ''QUERY'' then ',
'                                          case when :P4735_LOCATION = ''REMOTE'' then :P4735_REMOTE_SQL',
'                                               when :P4735_LOCATION = ''LOCAL'' then :P4735_SQL end',
'                                     end,      ',
'              p_web_src_module_id => case when :P4735_LOCATION   = ''WEB_SOURCE'' then :P4735_WEB_SRC_MODULE_ID end,',
'              p_remote_server_id  => case when :P4735_LOCATION   = ''REMOTE'' then :P4735_REMOTE_SERVER_ID end ))',
'    ) loop',
'        wwv_flow_collection.add_member(',
'            p_collection_name => c_collection_name,',
'            p_c001            => c.column_name_esc,',
'            p_c002            => c.column_name );',
'    end loop;',
'end;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04750
begin
wwv_flow_api.create_page(
 p_id=>4750.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Exportaci\00F3n de XLIFF')
,p_step_title=>unistr('Exportaci\00F3n de XLIFF')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6098825384679471.4001)
,p_plug_name=>unistr('Exportaci\00F3n de XLIFF')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para exportar un archivo XLIFF para una aplicaci\00F3n o p\00E1gina determinadas, seleccione la aplicaci\00F3n y la asignaci\00F3n (y, opcionalmente, la p\00E1gina) y haga clic en <strong>Exportar Archivo XLIFF para Aplicaci\00F3n</strong> o <strong>Exportar Archivo XLIF')
||unistr('F para P\00E1gina</strong>.</p>'),
unistr('<p>Antes de exportar las traducciones XLIFF de una aplicaci\00F3n, debe haber terminado la asignaci\00F3n de traducci\00F3n de aplicaci\00F3n, as\00ED como la extracci\00F3n de todo el texto traducible.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6099113886679478.4001)
,p_plug_name=>unistr('Descargar archivo XLIFF para aplicaci\00F3n completa')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>130
,p_plug_source=>' '
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6130403796816817.4001)
,p_plug_name=>unistr('Exportaci\00F3n de XLIFF')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>95
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6147923891898273.4001)
,p_plug_name=>unistr('Descargar archivo XLIFF para p\00E1gina de aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_plug_source=>' '
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6161126755955912.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6147923891898273.4001)
,p_button_name=>'GENERATEXLIFFFORPAGE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Exportar Archivo XLIFF para P\00E1gina')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:apex.submit(''GENERATEXLIFFFORPAGE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6132706351826979.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(6130403796816817.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6099321355679479.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(6130403796816817.4001)
,p_button_name=>'GenerateXLIFFTranslation'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Exportar Archivo XLIFF para Aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.submit(''GenerateXLIFFTranslation'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(6157202597930040.4001)
,p_branch_action=>'4750'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''F4000_P4750_XLIFF_FLOW_PAGE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6099730213679481.4001)
,p_name=>'F4000_P4750_XLIFF_FLOW'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(6099113886679478.4001)
,p_prompt=>'Idioma'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES_MAPPED_TO_FB_FLOW_ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov(translation_flow_language_code,''I18N_LANGUAGES_LOCALES'') d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'NULL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el idioma de la descarga en el archivo XLIFF.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' &gt;&gt; ''||translation_flow_id||',
'           '' (''||htf.escape_sc(translation_flow_language_code)||'')'' d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 2'))
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6149710516903903.4001)
,p_name=>'F4000_P4750_XLIFF_FLOW_PAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(6147923891898273.4001)
,p_prompt=>'Idioma'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES_MAPPED_TO_FB_FLOW_ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov(translation_flow_language_code,''I18N_LANGUAGES_LOCALES'') d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el idioma de la descarga en el archivo XLIFF.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6152111686913714.4001)
,p_name=>'F4000_P4750_XLIFF_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(6147923891898273.4001)
,p_prompt=>unistr('P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id||'' ''||wwv_flow_escape.html(s.name) n, s.id',
'',
'  from wwv_flow_steps s, wwv_flow_language_map m',
'',
' where s.flow_id = m.primary_language_flow_id',
'',
'   and m.translation_flow_id = :F4000_P4750_XLIFF_FLOW_PAGE',
'',
'   and s.security_group_id = :flow_security_group_id',
'',
'   and m.security_group_id = :flow_security_group_id',
'',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_null_value=>'NULL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Identifica la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(13212519502137882.4001)
,p_name=>'F4000_P4750_PRIMARY_FLOW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(6147923891898273.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42168716185947321.4001)
,p_name=>'P4750_XLIFF_FLOW_TARGET_INCL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(6099113886679478.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'XLIFF_TARGET_INCLUDE'
,p_lov=>'.'||wwv_flow_api.id(42166827828941188.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Al activar esta casilla, se incluir\00E1n los elementos de destino y el c\00F3digo de idioma correspondiente en el archivo XLIFF generado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42171314931956385.4001)
,p_name=>'P4750_XLIFF_PAGE_TARGET_INCL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(6147923891898273.4001)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'XLIFF_TARGET_INCLUDE'
,p_lov=>'.'||wwv_flow_api.id(42166827828941188.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Al activar esta casilla, se incluir\00E1n los elementos de destino y el c\00F3digo de idioma correspondiente en el archivo XLIFF generado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(102653403370395954.4001)
,p_name=>'P4750_XLIFF_ELEMENTS_INCLUDE'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_api.id(6099113886679478.4001)
,p_prompt=>'Exportar:'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'XLIFF_ELEMENTS_INCLUDE'
,p_lov=>'.'||wwv_flow_api.id(102649602892386356.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione la exportaci\00F3n de todos los elementos traducibles de la aplicaci\00F3n o s\00F3lo aquellos que sean nuevos o actualizados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(106850704601454149.4001)
,p_name=>'P4750_XLIFF_PAGE_ELEMENTS_INCL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(6147923891898273.4001)
,p_prompt=>'Exportar:'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'XLIFF_ELEMENTS_INCLUDE'
,p_lov=>'.'||wwv_flow_api.id(102649602892386356.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione la exportaci\00F3n de todos los elementos traducibles de la p\00E1gina o s\00F3lo aquellos que sean nuevos o actualizados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6108605041732046.4001)
,p_validation_name=>'Flow not null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4750_XLIFF_FLOW = ''NULL'' then',
'',
'    return FALSE;',
'',
'else',
'',
'    return TRUE;',
'',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe especificar la aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(6099321355679479.4001)
,p_associated_item=>wwv_flow_api.id(6099730213679481.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6164223769964525.4001)
,p_validation_name=>'Flow not null for page export'
,p_validation_sequence=>10
,p_validation=>':F4000_P4750_XLIFF_FLOW_PAGE <> ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>unistr('Se debe especificar la aplicaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(6161126755955912.4001)
,p_associated_item=>wwv_flow_api.id(6149710516903903.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(43443229444071712.4001)
,p_validation_name=>'Check that flow language is set'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lang_set boolean := FALSE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flows',
'                where id = :FB_FLOW_ID',
'                  and upper(nvl(flow_language,''%NULL%'')) <> ''%NULL%'') loop',
'        l_lang_set := TRUE;',
'        exit;',
'    end loop;',
'    --',
'    return l_lang_set;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('No se puede generar el archivo XLIFF si no se ha definido el idioma primario de la aplicaci\00F3n. Edite los atributos de la aplicaci\00F3n &FB_FLOW_ID. y defina el idioma primario de la aplicaci\00F3n.')
,p_validation_condition=>'GENERATEXLIFFFORPAGE:GenerateXLIFFTranslation'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6166006931969143.4001)
,p_validation_name=>'Page not null'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4750_XLIFF_PAGE = ''NULL'' then',
'',
'    return false;',
'',
'else',
'',
'    return true;',
'',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe especificar la p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(6161126755955912.4001)
,p_associated_item=>wwv_flow_api.id(6152111686913714.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(13215421842157545.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Translation Flow ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select translation_flow_id',
'                 from wwv_flow_language_map',
'                where primary_language_flow_id = :F4000_P4750_PRIMARY_FLOW) loop',
'        :F4000_P4750_XLIFF_FLOW_PAGE := c1.translation_flow_id;',
'        --',
'        exit;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'F4000_P4750_PRIMARY_FLOW'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6100628798679496.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate XLIFF'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select primary_language_flow_id',
'                 from wwv_flow_language_map',
'                where translation_flow_id = :F4000_P4750_XLIFF_FLOW) loop',
'        --',
'        wwv_flow_xliff.print_translation_document(',
'            p_flow_id             => c1.primary_language_flow_id,',
'            p_translation_flow_id => :F4000_P4750_XLIFF_FLOW,',
'            p_include_target      => nvl(:P4750_XLIFF_FLOW_TARGET_INCL,''N''),',
'            p_include_all         => nvl(:P4750_XLIFF_ELEMENTS_INCLUDE, ''N'' ));',
'',
'        --',
'        exit;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al generar el archivo XLIFF.'
,p_process_when_button_id=>wwv_flow_api.id(6099321355679479.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6180403215024787.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate XLIFF for page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select primary_language_flow_id',
'                 from wwv_flow_language_map',
'                where translation_flow_id = :F4000_P4750_XLIFF_FLOW_PAGE) loop',
'        --',
'        wwv_flow_xliff.print_translation_document(',
'            p_flow_id => c1.primary_language_flow_id,',
'            p_translation_flow_id => :F4000_P4750_XLIFF_FLOW_PAGE,',
'            p_page_id             => :F4000_P4750_XLIFF_PAGE,',
'            p_include_target      => nvl(:P4750_XLIFF_PAGE_TARGET_INCL,''N''),',
'            p_include_all         => nvl(:P4750_XLIFF_PAGE_ELEMENTS_INCL, ''N'' ));',
'        --',
'        exit;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al generar el archivo XLIFF.'
,p_process_when_button_id=>wwv_flow_api.id(6161126755955912.4001)
);
end;
/
prompt --application/pages/page_04751
begin
wwv_flow_api.create_page(
 p_id=>4751.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Asignaciones de Idioma'
,p_step_title=>unistr('Asignaciones de Idioma de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(371234255.4001)
,p_plug_name=>unistr('Asignaciones de Idioma de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Las aplicaciones traducidas se publican como nuevas aplicaciones. Debe especificar un identificador de aplicaci\00F3n de idioma primario y un identificador de aplicaci\00F3n de idioma traducido para cada aplicaci\00F3n y cada idioma que desee traducir.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30840328417229054.4001)
,p_plug_name=>unistr('Asignaciones de Idioma de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4751a */',
'       ID,',
'       primary_language_flow_id,',
'       translation_flow_id,',
'       translation_flow_language_code,',
'       translation_image_directory,',
'       translation_comments,',
'       decode((select count(*) c',
'                 from wwv_flows f',
'                where f.id = m.translation_flow_id ),',
'              0, ''No'',',
'              ''Yes'' ) as translated_application_exists,',
'       (select created_on',
'          from wwv_flows f',
'         where f.id = m.translation_flow_id ) as translation_created,',
'       m.created_on as created,',
'       m.created_by as created_by,',
'       m.last_updated_on as updated,',
'       m.last_updated_by as updated_by',
'  from WWV_FLOW_LANGUAGE_MAP m',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(30840414634229054.4001)
,p_name=>'Application Language Mappings'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30840608692229064.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30840729780229065.4001)
,p_db_column_name=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n Primaria')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30840823240229065.4001)
,p_db_column_name=>'TRANSLATION_FLOW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Aplicaci\00F3n Traducida')
,p_column_link=>'f?p=&APP_ID.:4754:&SESSION.::&DEBUG.::P4754_ID:#ID#:'
,p_column_linktext=>'#TRANSLATION_FLOW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30840924055229066.4001)
,p_db_column_name=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(107899321117195063)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30841026860229066.4001)
,p_db_column_name=>'TRANSLATION_IMAGE_DIRECTORY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Ruta de Acceso de la Imagen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(30841109962229066.4001)
,p_db_column_name=>'TRANSLATION_COMMENTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Comentario de Traducci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162404706149956872.4001)
,p_db_column_name=>'TRANSLATED_APPLICATION_EXISTS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('La aplicaci\00F3n existe')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162404931776964263.4001)
,p_db_column_name=>'TRANSLATION_CREATED'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Publicado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162449716444603203.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162449820975603206.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162449901795603206.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(162450012311603207.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1030166014964015783.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(30840328417229054.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8258120720657693.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(30840328417229054.4001)
,p_button_name=>'CREATE_MAP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4754:&SESSION.::&DEBUG.:4754::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_04754
begin
wwv_flow_api.create_page(
 p_id=>4754.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Editar Asignaciones de Idioma'
,p_step_title=>unistr('Crear/Editar: Asignaci\00F3n de Idioma de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9918913505546139.4001)
,p_plug_name=>'Botones del Asistente'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61713417943886213.4001)
,p_plug_name=>'Application Language Mapping'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>unistr('<p>Para realizar una traducci\00F3n, se deber\00E1 crear un ID de aplicaci\00F3n \00FAnico para la aplicaci\00F3n traducida. Utilice esta p\00E1gina para asignar un ID de aplicaci\00F3n existente a un ID de aplicaci\00F3n de traducci\00F3n. Tenga en cuenta que, si se suprime una asigna')
||unistr('ci\00F3n de aplicaci\00F3n, se suprimir\00E1n tambi\00E9n todas las aplicaciones traducidas correspondientes.<p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(101558816609853494.4001)
,p_name=>unistr('Asignaciones de Idioma de Aplicaci\00F3n')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id,',
'       translation_flow_id,',
'       translation_flow_language_code,',
'       translation_image_directory',
'  from WWV_FLOW_LANGUAGE_MAP',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID',
' order by translation_flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'El informe no ha devuelto ninguna fila.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48769922686772122.4001)
,p_query_column_id=>1
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Aplicaci\00F3n Primaria')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48770029804772122.4001)
,p_query_column_id=>2
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Aplicaci\00F3n Traducida')
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48770123365772122.4001)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>3
,p_column_heading=>'Idioma'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(107899321117195063)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48770207508772122.4001)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATION_IMAGE_DIRECTORY'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Directorio de Im\00E1genes')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747149928010138181.4001)
,p_plug_name=>unistr('Crear/Editar Asignaci\00F3n de Idioma de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2901592737.4001)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(9918913505546139.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4751:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2902592737.4001)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(9918913505546139.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P4754_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2903592737.4001)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(9918913505546139.4001)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''P4754_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2904592738.4001)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_api.id(9918913505546139.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''P4754_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2905592738.4001)
,p_branch_action=>'4751'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'Create:Delete'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2906592738.4001)
,p_branch_action=>'4751'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2908592739.4001)
,p_name=>'P4754_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2909592741.4001)
,p_name=>'P4754_PRIMARY_LANGUAGE_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n de Idioma Primario')
,p_source=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n que se va a traducir.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2910592741.4001)
,p_name=>'P4754_TRANSLATION_FLOW_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n de Traducci\00F3n')
,p_source=>'TRANSLATION_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un valor entero \00FAnico que identifique una aplicaci\00F3n. El identificador de aplicaci\00F3n debe ser exclusivo en la instancia de &PRODUCT_NAME..'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2911592741.4001)
,p_name=>'P4754_TRANS_LANGUAGE_CODE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Idioma'
,p_source=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Seleccione el idioma que se va a traducir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>unistr('Portugu\00E9s Brasile\00F1o')
,p_quick_pick_value_01=>'pt-br'
,p_quick_pick_label_02=>'Chino (China)'
,p_quick_pick_value_02=>'zh-cn'
,p_quick_pick_label_03=>unistr('Chino (Taiw\00E1n)')
,p_quick_pick_value_03=>'zh-tw'
,p_quick_pick_label_04=>unistr('Ingl\00E9s')
,p_quick_pick_value_04=>'en'
,p_quick_pick_label_05=>unistr('Franc\00E9s')
,p_quick_pick_value_05=>'fr'
,p_quick_pick_label_06=>unistr('Alem\00E1n')
,p_quick_pick_value_06=>'de'
,p_quick_pick_label_07=>'Italiano'
,p_quick_pick_value_07=>'it'
,p_quick_pick_label_08=>unistr('Japon\00E9s')
,p_quick_pick_value_08=>'ja'
,p_quick_pick_label_09=>'Coreano'
,p_quick_pick_value_09=>'ko'
,p_quick_pick_label_10=>unistr('Espa\00F1ol')
,p_quick_pick_value_10=>'es'
,p_quick_pick_link_attr=>'class="itemlink"'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2912592741.4001)
,p_name=>'P4754_TRANSLATION_COMMENTS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'TRANSLATION_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca comentarios o notas aqu\00ED. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33941917888.4001)
,p_name=>'P4754_TRANSLATION_IMAGE_DIRECTORY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Directorio de Im\00E1genes')
,p_source=>'TRANSLATION_IMAGE_DIRECTORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el directorio de donde se obtienen las im\00E1genes. A menos que est\00E9 utilizando archivos est\00E1ticos del directorio de im\00E1genes que se convierten, puede dejar este campo en blanco. \00C9sta es la opci\00F3n por defecto y la m\00E1s com\00FAn.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(123305263008447102.4001)
,p_name=>'P4754_DIRECTION_RIGHT_TO_LEFT'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Direcci\00F3n del Documento')
,p_source=>'DIRECTION_RIGHT_TO_LEFT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RIGHT-TO-LEFT'
,p_lov=>'.'||wwv_flow_api.id(124580607576171078.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Defina la direcci\00F3n del documento de izquierda a derecha o de derecha a izquierda.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(519713912454234734.4001)
,p_name=>'P4754_ORIG_TRANS_FLOW_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P4754_TRANSLATION_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(519740931155240165.4001)
,p_name=>'P4754_ORIG_TRANS_LANG_CODE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(61713417943886213.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'P4754_TRANS_LANGUAGE_CODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(16652408402607797.4001)
,p_validation_name=>'primary language not null'
,p_validation_sequence=>10
,p_validation=>'P4754_PRIMARY_LANGUAGE_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Debe especificar un identificador de aplicaci\00F3n de idioma primario.')
,p_validation_condition=>'Cancel'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(2909592741.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20464617086406041.4001)
,p_validation_name=>'trans flow id must not end in zero'
,p_validation_sequence=>25
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return boolean := TRUE;',
'begin',
'    if mod(v(''P4754_TRANSLATION_FLOW_ID''),10) = 0 then',
'        l_return := FALSE;',
'    end if;',
'    return l_return;',
'exception ',
'    when others then',
'        return l_return;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La aplicaci\00F3n de traducci\00F3n no debe terminar en cero.')
,p_validation_condition=>'Cancel'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(2910592741.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13159032423681475.4001)
,p_validation_name=>'translation flow must not already exist'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return boolean := TRUE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flows',
'                where id = :P4754_TRANSLATION_FLOW_ID) loop',
'        l_return := FALSE;',
'        exit;',
'    end loop;',
'    return l_return;',
'exception',
'    when others then',
'        return l_return;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ya existe una aplicaci\00F3n con este ID.')
,p_validation_condition=>'Create,ApplyChanges'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(2910592741.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(13237722820735479.4001)
,p_validation_name=>'translation mapping must not already exist'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return boolean := TRUE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flow_language_map',
'                where translation_flow_id = :P4754_TRANSLATION_FLOW_ID) loop',
'        l_return := FALSE;',
'        exit;',
'    end loop;',
'    return l_return;',
'exception',
'    when others then',
'        return l_return;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ya existe una aplicaci\00F3n de traducci\00F3n con este ID.')
,p_when_button_pressed=>wwv_flow_api.id(2904592738.4001)
,p_associated_item=>wwv_flow_api.id(2910592741.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(636237718854328099.4001)
,p_validation_name=>'P4754_TRANSLATION_FLOW_ID'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if trunc(:P4754_TRANSLATION_FLOW_ID) = :P4754_TRANSLATION_FLOW_ID then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception when others then',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('La aplicaci\00F3n de traducci\00F3n debe ser un valor entero.')
,p_validation_condition=>'trim(:P4754_TRANSLATION_FLOW_ID) is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2910592741.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2913592742.4001)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_LANGUAGE_MAP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from wwv_flow_language_map',
'where security_group_id = :flow_security_group_id and',
'      primary_language_flow_id = :FB_FLOW_ID and',
'      id = :P4754_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_LANGUAGE_MAP'',',
'  p_rowid       => :P4754_ID,',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
,p_process_when_type=>'NEVER'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(520357119661407165.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LANGUAGE_MAP'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LANGUAGE_MAP'
,p_attribute_03=>'P4754_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :flow_security_group_id and primary_language_flow_id = :FB_FLOW_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error al recuperar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(76904415523844751.4001)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete translated applications when mapping deleted'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- If the mapping is deleted, also delete any translated flows ',
'-- that use this mapping as well as text from the translation repository',
'--',
'wwv_flow.g_import_in_progress := true;',
'',
'for c1 in (select translation_flow_id',
'             from WWV_FLOW_LANGUAGE_MAP ',
'            where security_group_id = :flow_security_group_id ',
'              and primary_language_flow_id =  :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'              and translation_flow_id = :P4754_TRANSLATION_FLOW_ID) loop',
'',
'   delete from wwv_flows ',
'    where id = c1.translation_flow_id ',
'      and security_group_id = :flow_security_group_id;',
'',
'   --',
'   -- Delete any seeded text associated with the mapping being deleted',
'   --',
'   delete from wwv_flow_translatable_text$',
'    where flow_id = :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'      and security_group_id = :flow_security_group_id',
'      and translated_flow_id = c1.translation_flow_id;',
'',
'  delete from wwv_flows_reserved',
'   where id = c1.translation_flow_id;',
'',
'end loop;',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(2902592737.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2914592742.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LANGUAGE_MAP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from dual',
'where :P4754_ID is null',
'or exists (select 1 from wwv_flow_language_map',
'                   where security_group_id = :flow_security_group_id and',
'      primary_language_flow_id = :FB_FLOW_ID and',
'      id = :P4754_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LANGUAGE_MAP'',',
'p_rowid       => v(''P4754_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_when_type=>'NEVER'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(521237001409534326.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update translatable_text when translation mapping ID or language code changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_nls_num_parm    constant varchar2(100) := ''NLS_NUMERIC_CHARACTERS=''''.,'''''';',
'    c_nls_num_fmt2    constant varchar2(100) := ''999999999999999999999999999999.999999999999999999999999999999'';',
'begin',
'--',
'-- If the mapped application ID changes or the translated language code changes,',
'-- then first delete any associated translated applications and then',
'-- also update the translatable text repository',
'--',
'-- This process must occur before the Automatic DML on WWV_FLOW_LANGUAGE_MAP occurs',
'',
'if ( :P4754_ORIG_TRANS_FLOW_ID <> :P4754_TRANSLATION_FLOW_ID ) or ',
'   ( :P4754_ORIG_TRANS_LANG_CODE <> :P4754_TRANS_LANGUAGE_CODE ) then',
'   ',
'   ',
'	wwv_flow.g_import_in_progress := true;',
'	',
'	for c1 in (select translation_flow_id',
'				 from wwv_flow_language_map',
'				where security_group_id = :flow_security_group_id ',
'				  and primary_language_flow_id =  :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'				  and translation_flow_id = :P4754_ORIG_TRANS_FLOW_ID) loop',
'	',
'	   delete from wwv_flows ',
'		where id = c1.translation_flow_id ',
'		  and security_group_id = :flow_security_group_id;',
'		  ',
'    end loop;',
'    ',
'    --',
'    -- Then, update the existing data in the translatable text repository',
'    --',
'    update wwv_flow_translatable_text$',
'       set translated_flow_id = :P4754_TRANSLATION_FLOW_ID,',
'           translate_to_lang_code = :P4754_TRANS_LANGUAGE_CODE,',
'           translate_to_id = to_number(trunc(translate_to_id) || ''.'' || :P4754_TRANSLATION_FLOW_ID, c_nls_num_fmt2, c_nls_num_parm)',
'     where flow_id = :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'       and translated_flow_id = :P4754_ORIG_TRANS_FLOW_ID',
'       and translate_to_lang_code = :P4754_ORIG_TRANS_LANG_CODE',
'       and security_group_id = :flow_security_group_id;',
'',
'',
'    --',
'    -- Lastly, if the ID changed, then remove the old one from the reserved table and add the new one',
'    --',
'    if ( :P4754_ORIG_TRANS_FLOW_ID <> :P4754_TRANSLATION_FLOW_ID ) then',
'       delete from wwv_flows_reserved',
'         where id = :P4754_ORIG_TRANS_FLOW_ID;',
'       --',
'       insert into wwv_flows_reserved( id, created_on, created_by)',
'       values( :P4754_TRANSLATION_FLOW_ID, sysdate, :APP_USER );',
'    end if;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2903592737.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(520489126372418593.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LANGUAGE_MAP'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LANGUAGE_MAP'
,p_attribute_03=>'P4754_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :flow_security_group_id and primary_language_flow_id = :FB_FLOW_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error al procesar la fila.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04756
begin
wwv_flow_api.create_page(
 p_id=>4756.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Traducciones Din\00E1micas')
,p_step_title=>unistr('Traducciones Din\00E1micas')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(25239076706.4001)
,p_name=>unistr('Traducciones Din\00E1micas')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  q varchar2(32767) := null;',
'begin',
'  q := ''select '''''''' as e,'';',
'  q :=q||'' id,translate_from_text,translate_to_lang_code,translate_to_text',
''';',
'  q :=q||'' from   WWV_FLOW_DYNAMIC_TRANSLATIONS$'';',
'  q :=q||'' where  security_group_id = :flow_security_group_id and flow_id = :FB_FLOW_ID '';',
'  if :F4000_P4756_LANGUAGE != ''NULL'' then',
'      q :=q||'' and translate_to_lang_code = :F4000_P4756_LANGUAGE '';',
'  end if;',
'  if :F4000_P4756_FIND is not null then',
'      q :=q||''   and (instr(upper(translate_from_text),upper(:F4000_P4756_FIND))>0 or instr(upper(translate_to_text),upper(:F4000_P4756_FIND))>0) '';',
'  end if;',
'  q :=q||'' order  by 3'';',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna traducci\00F3n din\00E1mica.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48539606052770706.4001)
,p_query_column_id=>1
,p_column_alias=>'E'
,p_column_display_sequence=>1
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48539728590770706.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48539802305770707.4001)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATE_FROM_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Traducir de'
,p_column_link=>'f?p=&APP_ID.:4757:&SESSION.::&DEBUG.::F4000_P4757_ID:#ID#:'
,p_column_linktext=>'#TRANSLATE_FROM_TEXT#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48539911172770707.4001)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATE_TO_LANG_CODE'
,p_column_display_sequence=>4
,p_column_heading=>'Idioma'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48540013505770707.4001)
,p_query_column_id=>5
,p_column_alias=>'TRANSLATE_TO_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Traducir a'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25240089058.4001)
,p_plug_name=>unistr('Traducciones Din\00E1micas')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Las traducciones din\00E1micas permiten que el c\00F3digo PL/SQL personalizado realice traducciones con la funci\00F3n <code>APEX_LANG.LANG</code>. Esta tabla asigna valores del idioma primario a otro idioma nacional.</p>')
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'0'
,p_plug_query_no_data_found=>unistr('No se ha encontrado ning\00FAn dato.')
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188061024872596772.4001)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(465706408.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(188061024872596772.4001)
,p_button_name=>'F4000_P4756_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ir'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188999509859169126.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(188061024872596772.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4756:&SESSION.::&DEBUG.:RP,4756::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8276308778692096.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(188061024872596772.4001)
,p_button_name=>'CREATE_NEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4757:&SESSION.::&DEBUG.:4757::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25235072502.4001)
,p_branch_action=>'4757'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25236072502.4001)
,p_branch_action=>'4756'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(463694999.4001)
,p_name=>'F4000_P4756_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(188061024872596772.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca texto para buscar en traducciones din\00E1micas guardadas. \00C9ste se introduce en el idioma primario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(466725053.4001)
,p_name=>'F4000_P4756_LANGUAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(188061024872596772.4001)
,p_prompt=>'Idioma'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Todo -'
,p_lov_null_value=>'NULL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el idioma al que se va a traducir.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(25237072502.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4757_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
prompt --application/pages/page_04757
begin
wwv_flow_api.create_page(
 p_id=>4757.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear/Editar Traducci\00F3n Din\00E1mica')
,p_step_title=>unistr('Crear/Editar Traducci\00F3n Din\00E1mica')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(25241119284.4001)
,p_plug_name=>'Dynamic Translations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las traducciones din\00E1micas se utilizan en listas de valores y en el c\00F3digo escrito en PL/SQL. Se puede llamar'),
unistr('   a traducciones din\00E1micas con el paquete <code>APEX_LANG</code>.')))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(61710711910641976.4001)
,p_plug_name=>unistr('Traducciones Din\00E1micas')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(886492934541981505.4001)
,p_plug_name=>unistr('Crear/Editar Traducci\00F3n Din\00E1mica')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25218072493.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(61710711910641976.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4756:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25219072493.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(61710711910641976.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4757_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25221072493.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(61710711910641976.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4757_ID'') is null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(25220072493.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(61710711910641976.4001)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4757_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25222072493.4001)
,p_branch_action=>'4756'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(25223072494.4001)
,p_branch_action=>'4757'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(467932441.4001)
,p_name=>'F4000_P4757_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(25241119284.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n de idioma primario.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25225072498.4001)
,p_name=>'F4000_P4757_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(25241119284.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25226072498.4001)
,p_name=>'F4000_P4757_TRANSLATE_FROM_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(25241119284.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Traducir de Texto'
,p_source=>'TRANSLATE_FROM_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el texto en el idioma primario que se va a traducir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25227072499.4001)
,p_name=>'F4000_P4757_TRANSLATE_TO_LANG_CODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(25241119284.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4756_LANGUAGE.'
,p_prompt=>'Idioma'
,p_source=>'TRANSLATE_TO_LANG_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_api.id(107899321117195063.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Idioma -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione el idioma al que traducir.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25228072499.4001)
,p_name=>'F4000_P4757_TRANSLATE_TO_TEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(25241119284.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Traducir a Texto'
,p_source=>'TRANSLATE_TO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca el texto traducido en el idioma de destino.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(88279301555756952.4001)
,p_validation_name=>'LangMand'
,p_validation_sequence=>10
,p_validation=>'F4000_P4757_TRANSLATE_TO_LANG_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el idioma.'
,p_validation_condition=>'Create,Apply Changes'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(25227072499.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25229072500.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_DYNAMIC_TRANSLATIONS$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_dynamic_translations$',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4757_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_DYNAMIC_TRANSLATIONS$'',',
'  p_rowid       => v(''F4000_P4757_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(25230072500.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_DYNAMIC_TRANSLATIONS$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4757_ID is null',
'or exists (select 1 from wwv_flow_dynamic_translations$',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4757_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_DYNAMIC_TRANSLATIONS$'',',
'p_rowid       => v(''F4000_P4757_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al procesar la fila.'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
end;
/
prompt --application/pages/page_04758
begin
wwv_flow_api.create_page(
 p_id=>4758.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Archivos de Traducci\00F3n XLIFF')
,p_step_title=>unistr('Archivos de Traducci\00F3n XLIFF')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5297413578239257.4001)
,p_plug_name=>'Repositorio XLIFF'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Para cargar uno o varios archivos traducidos XLIFF, haga clic en "Cargar Archivos". Los archivos deben estar codificados en UTF-8.  Para suprimir un archivo del repositorio, marque la casilla de control que hay junto al nombre de archivo y haga cl'
||unistr('ic en "Suprimir Selecci\00F3n".</p>'),
unistr('<p>Para aplicar los archivos XLIFF, marque las filas que desea aplicar y elija una asignaci\00F3n de traducci\00F3n de la columna "Aplicar a Traducci\00F3n" y, a continuaci\00F3n, haga clic en "Aplicar Selecci\00F3n". El archivo XLIFF se analizar\00E1 y los contenidos se ap')
||unistr('licar\00E1n al repositorio de traducci\00F3n. Una vez ha finalizado este proceso, necesitar\00E1 publicar la aplicaci\00F3n de cada traducci\00F3n.</p>'),
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5309600462294735.4001)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(637355708555846594.4001)
,p_name=>'Archivos XLIFF'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FILENAME",',
'"TITLE",',
'"DOC_SIZE",',
'"CREATED_BY",',
'"CREATED_ON",',
'null translation_mapping',
'from wwv_flow_file_objects$',
'where file_type = ''XLIFF''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and flow_id = :FB_FLOW_ID',
'  '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se ha encontrado ning\00FAn archivo XLIFF.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(638083509688903634.4001)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Seleccionar Fila'
,p_column_alignment=>'CENTER'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(637356031628846596.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'ID'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(637356414896846598.4001)
,p_query_column_id=>3
,p_column_alias=>'FILENAME'
,p_column_display_sequence=>3
,p_column_heading=>'Nombre de Archivo'
,p_use_as_row_header=>'N'
,p_column_link=>'p?n=#ID#&p_mime_type=text/xml'
,p_column_linktext=>'#FILENAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'FILENAME'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(637356524359846598.4001)
,p_query_column_id=>4
,p_column_alias=>'TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'TITLE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(637356700090846598.4001)
,p_query_column_id=>5
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>5
,p_column_heading=>unistr('Tama\00F1o del Documento')
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'DOC_SIZE'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(637356908879846598.4001)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>7
,p_column_heading=>'Creado por'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'CREATED_BY'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(637357017623846598.4001)
,p_query_column_id=>7
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>6
,p_column_heading=>'Creado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>12
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'CREATED_ON'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(638488202536946133.4001)
,p_query_column_id=>8
,p_column_alias=>'TRANSLATION_MAPPING'
,p_column_display_sequence=>8
,p_column_heading=>unistr('Aplicar a Traducci\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_api.id(640493208817215668)
,p_lov_show_nulls=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(637454225871851507.4001)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(637454629852851512.4001)
,p_column_sequence=>2
,p_query_column_name=>'FILENAME'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(637454717319851512.4001)
,p_column_sequence=>3
,p_query_column_name=>'TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(637454927736851512.4001)
,p_column_sequence=>4
,p_query_column_name=>'DOC_SIZE'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(637455105787851512.4001)
,p_column_sequence=>5
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(637455216901851512.4001)
,p_column_sequence=>6
,p_query_column_name=>'CREATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_region_rpt_cols(
 p_id=>wwv_flow_api.id(638488107392946132.4001)
,p_column_sequence=>7
,p_query_column_name=>'TRANSLATION_MAPPING'
,p_display_as=>'TEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(166433417238786023.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5309600462294735.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5632329390234879.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(5309600462294735.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Suprimir Selecci\00F3n')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_file_objects$ f',
' where f.security_group_id = :flow_security_group_id',
'       and f.file_type = ''XLIFF''',
'       and f.flow_id = :FB_FLOW_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(639244705897053912.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(5309600462294735.4001)
,p_button_name=>'APPLY_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Aplicar Selecci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_file_objects$ f',
' where f.security_group_id = :flow_security_group_id',
'       and f.file_type = ''XLIFF''',
'       and f.flow_id = :FB_FLOW_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(750332303862462709.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(5309600462294735.4001)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Publicar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.::P385_ACTION:PUBLISH:'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5607822876062701.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(5309600462294735.4001)
,p_button_name=>'UPLOADXLIFF'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cargar Archivos'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4760:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5608124177062703.4001)
,p_branch_action=>'4760'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(5607822876062701.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(653980526497953088.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(637355708555846594.4001)
,p_validation_name=>'Translation Mapping Not Null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :APEX$ROW_SELECTOR = ''X'' then',
'    if :TRANSLATION_MAPPING is null then',
'        return FALSE;',
'    end if;',
'end if;',
'return TRUE;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Se debe especificar la asignaci\00F3n de traducci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(639244705897053912.4001)
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'TRANSLATION_MAPPING'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(639350626806069474.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(637355708555846594.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked Files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_file_objects$',
' where id = :ID',
' and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al suprimir los archivos.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(5632329390234879.4001)
,p_process_when=>'APEX$ROW_SELECTOR'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'X'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Archivos suprimidos.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(640273130587193506.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(637355708555846594.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Checked Files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :TRANSLATION_MAPPING is not null then',
'wwv_flow_xliff.apply_xliff_file(',
'    p_flow_id => :FB_FLOW_ID,',
'    p_translation_flow_id => :TRANSLATION_MAPPING,',
'    p_file_id             => :ID );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al aplicar los archivos.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(639244705897053912.4001)
,p_process_when=>'APEX$ROW_SELECTOR'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'X'
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'Archivos aplicados.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(657364723670198316.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(637355708555846594.4001)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'MRU'
,p_attribute_02=>'WWV_FLOW_FILES'
,p_attribute_03=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(639244705897053912.4001)
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_04760
begin
wwv_flow_api.create_page(
 p_id=>4760.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Carga de XLIFF'
,p_step_title=>'Carga de XLIFF'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(634586126292406991.4001)
,p_plug_name=>'XLIFF Upload'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cargue hasta diez archivos traducidos XLIFF en el repositorio XLIFF. Los archivos XLIFF cargados en el repositorio de archivos XLIFF <strong>s\00F3lo</strong> deben ser archivos traducidos que fueron generados por primera vez mediante la operaci\00F3n Exp')
||unistr('ortaci\00F3n de XLIFF.'),
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694679936718238907.4001)
,p_plug_name=>'Carga de XLIFF'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694680033925238908.4001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(635724214190554879.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(694680033925238908.4001)
,p_button_name=>'UPLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Cargar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5617525918158240.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(694680033925238908.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4758:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(749387221468363783.4001)
,p_branch_action=>'f?p=&APP_ID.:4758:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(634756618720433125.4001)
,p_name=>'P4760_FILE1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'1'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(634881424392444267.4001)
,p_name=>'P4760_FILE2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'2'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(634896430626446061.4001)
,p_name=>'P4760_FILE3'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'3'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(634911413442450549.4001)
,p_name=>'P4760_FILE4'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'4'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(634975204915457535.4001)
,p_name=>'P4760_FILE5'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'5'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(650852126863404431.4001)
,p_name=>'P4760_FILE6'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'6'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(650878531365405696.4001)
,p_name=>'P4760_FILE7'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'7'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(650932903445407071.4001)
,p_name=>'P4760_FILE8'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'8'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(650955507254408191.4001)
,p_name=>'P4760_FILE9'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'9'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(651000612449409728.4001)
,p_name=>'P4760_FILE10'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(634586126292406991.4001)
,p_prompt=>'10'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(5627501770208037.4001)
,p_validation_name=>'File Not Null'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (',
':P4760_FILE1 is null and  ',
':P4760_FILE2 is null and ',
':P4760_FILE3 is null and ',
':P4760_FILE4 is null and ',
':P4760_FILE5 is null and ',
':P4760_FILE6 is null and ',
':P4760_FILE7 is null and ',
':P4760_FILE8 is null and ',
':P4760_FILE9 is null and ',
':P4760_FILE10 is null) then',
'    return FALSE;',
'else',
'    return TRUE;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Se debe especificar al menos un archivo.'
,p_when_button_pressed=>wwv_flow_api.id(635724214190554879.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(636002313114601872.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update attributes of files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4760_FILE1 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE1;',
'    commit;',
'end if;',
'',
'if :P4760_FILE2 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE2;',
'    commit;',
'end if;',
'',
'if :P4760_FILE3 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE3;',
'    commit;',
'end if;',
'',
'if :P4760_FILE4 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE4;',
'    commit;',
'end if;',
'',
'if :P4760_FILE5 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE5;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE6 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE6;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE7 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE7;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE8 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE8;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE9 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE9;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE10 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE10;',
'    commit;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al cargar los archivos.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(635724214190554879.4001)
,p_process_success_message=>'Los archivos se han cargado correctamente.'
);
end;
/
prompt --application/pages/page_04761
begin
wwv_flow_api.create_page(
 p_id=>4761.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Traducir Aplicaci\00F3n')
,p_step_title=>unistr('Traducir Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213331522315193801)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#how-to-translate .rc-content,',
'#translations .rc-content {',
'height: 456px;}',
'#translations .rc-content {',
'padding: 0;',
'}',
'#translations .rc-content table {',
'width: 100%; }',
'</style>'))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(689897690.4001)
,p_plug_name=>unistr('Traducci\00F3n')
,p_region_name=>'how-to-translate'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(165943028704262550.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1591026164633612.4001)
,p_plug_name=>unistr('Traducci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las aplicaciones se pueden traducir de un idioma principal a otros idiomas. Cada traducci\00F3n tiene como resultado la creaci\00F3n de una nueva aplicaci\00F3n traducida. Todas las traducciones requieren una asignaci\00F3n con la que se identifica el idioma de d')
||unistr('estino, as\00ED como el ID de la aplicaci\00F3n traducida. Las aplicaciones traducidas no pueden editarse directamente en el creador de aplicaciones.<p/>'),
'',
unistr('<p>Una vez establecidas las asignaciones de traducci\00F3n, el texto traducible de la aplicaci\00F3n se extrae a un repositorio de traducci\00F3n. Dicho repositorio puede exportarse posteriormente a un archivo XLIFF para su traducci\00F3n.</p>'),
'',
unistr('<p>Cuando el archivo XLIFF se completa con las traducciones, un archivo por idioma, se carga de nuevo el archivo XLIFF en el repositorio de traducci\00F3n. El \00FAltimo paso consiste en publicar cada aplicaci\00F3n traducida desde el repositorio de traducci\00F3n.<')
||'/p>',
'',
unistr('<p>La aplicaci\00F3n traducida deber\00E1 sincronizarse cuando se modifique la aplicaci\00F3n principal desde que fuese publicada la \00FAltima versi\00F3n traducida. Es necesario incluso realizar una sincronizaci\00F3n de las modificaciones realizadas en la l\00F3gica de la ap')
||unistr('licaci\00F3n. Para sincronizar, es necesario extraer y publicar la aplicaci\00F3n traducida.</p>'),
'',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/understanding-the-translation-process.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1632930076767224.4001)
,p_plug_name=>unistr('Utilidades de Traducci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>55
,p_list_id=>wwv_flow_api.id(165621520543370755.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694679486622238902.4001)
,p_plug_name=>'Traducciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>34
,p_plug_new_grid_row=>false
,p_plug_column_width=>'apex-col--leftBorder'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(694679334842238901.4001)
,p_plug_name=>'Traducciones No Activadas'
,p_parent_plug_id=>wwv_flow_api.id(694679486622238902.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( wwv_flow_lang.system_message( ''F4000.P4761.TRANSLATIONS_NOT_USED'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p=&APP_ID.:506:'' || :APP_SESSION || '':::506:FB_FLOW_ID:'' || :fb_flow_id ) ) );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows f,',
'       wwv_flow_language_map m',
' where f.id = m.primary_language_flow_id',
'   and f.security_group_id = :flow_security_group_id',
'   and f.id = :fb_flow_id',
'   and nvl( f.flow_language_derived_from, ''0'' ) = ''0'''))
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(746836409020161499.4001)
,p_name=>'Translations'
,p_region_name=>'translations'
,p_parent_plug_id=>wwv_flow_api.id(694679486622238902.4001)
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>35
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.translation_flow_language_code,',
'       nvl((select decode(sign(difference),-1,''Y'',''N'')',
'         from ',
'       (select (f2.created_on - f1.last_updated_on) difference, f2.id',
'         from wwv_flows f1, wwv_flows f2, wwv_flow_language_map m',
'        where f1.id = :FB_FLOW_ID',
'          and f1.id = m.primary_language_flow_id',
'          and f2.id = m.translation_flow_id) x',
'        where x.id = m.translation_flow_id),''Y'') requires_synchronization,',
'       (select created_on',
'          from wwv_flows f',
'         where f.id = m.translation_flow_id) translation_created',
'from wwv_flow_language_map m',
'where m.primary_language_flow_id = :fb_flow_id',
'  and m.security_group_id = :flow_security_group_id'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>unistr('No se ha encontrado ninguna traducci\00F3n.')
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(746836804088161503.4001)
,p_query_column_id=>1
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>1
,p_column_heading=>'Idioma'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(107899321117195063)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(746836910588161504.4001)
,p_query_column_id=>2
,p_column_alias=>'REQUIRES_SYNCHRONIZATION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Necesita Sincronizaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(746837021017161504.4001)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATION_CREATED'
,p_column_display_sequence=>3
,p_column_heading=>'Publicado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3107005878.4001)
,p_branch_action=>'4761'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9487269104.4001)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3109052268.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_NAME'
,p_computation_type=>'QUERY'
,p_computation=>'select replace(name,'' '',''&nbsp;'') n from wwv_flows where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3108044387.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl(:F4000_P4761_FLOW,:FB_FLOW_ID)'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
end;
/
prompt --application/pages/page_04810
begin
wwv_flow_api.create_page(
 p_id=>4810.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Crear Pantalla'
,p_page_mode=>'MODAL'
,p_step_title=>'&P4810_FORM_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214164216163913779)
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(".ui-dialog--apex .ui-dialog-title").text($v("P4810_FORM_TITLE"));'
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(62564216313265888.4001)
,p_plug_name=>'Crear Pantalla Basada en &P4810_FORM_TITLE.'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(70051917736316183.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(70041819940286906.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204689511245704691.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62564984463274761.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204689511245704691.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(62565215934279144.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204689511245704691.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699461085305645926.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(204689511245704691.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(111179230796743121.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(62565215934279144.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P4810_PAGE_ID) = false'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1813803139055315.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs for Local Procedure'
,p_branch_action=>'f?p=&APP_ID.:4735:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(62565215934279144.4001)
,p_branch_sequence=>45
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P4810_PAGE_ID)'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(122120008367373713.4001)
,p_branch_name=>'Go To Page 4810'
,p_branch_action=>'f?p=&APP_ID.:4810:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>55
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P4810_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699461134932647437.4001)
,p_branch_name=>'Go To Page 4700'
,p_branch_action=>'4700'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699461085305645926.4001)
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P362_OPT'
,p_branch_condition_text=>'R'
,p_required_patch=>wwv_flow_api.id(121426746309283317.4001)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45096608695801288.4001)
,p_name=>'P4810_PAGE_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62566116715293014.4001)
,p_name=>'F4000_P4810_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :FB_FLOW_ID,',
'                                 p_page_id => :F4000_P4810_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una p\00E1gina que contenga la nueva pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62566422570302995.4001)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la p\00E1gina si \00E9sta se va a crear.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(62567018386328312.4001)
,p_name=>'F4000_P4810_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select default_region_template from wwv_flow_themes ',
'where flow_id = :fb_flow_id',
'and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca una plantilla para la regi\00F3n que contendr\00E1 la nueva pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(70020620455081714.4001)
,p_name=>'F4000_P4810_REGION_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_item_default=>'wwv_flow_lang.system_message(p_name=>''F4000_P4810_PAGE_NAME'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la regi\00F3n que contenga la nueva pantalla.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122119130053370532.4001)
,p_name=>'P4810_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122121704030377193.4001)
,p_name=>'P4810_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'F4000_P4810_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253076062499538019.4001)
,p_name=>'P4810_FORM_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_item_default=>'TABLE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253076198237538020.4001)
,p_name=>'P4810_BRANCH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>unistr('Bifurcar Aqu\00ED al Ejecutar')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione una p\00E1gina a la que bifurcar cuando haya terminado el procesamiento de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253076277432538021.4001)
,p_name=>'P4810_CANCEL_BRANCH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>unistr('Cancelar e Ir a la P\00E1gina')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d    ',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253076418773538023.4001)
,p_name=>'P4810_FORM_TITLE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381723748638942175.4001)
,p_name=>'P4810_BREADCRUMB_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P4810_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P4810_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P4810_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403510526813630484.4001)
,p_name=>'P4810_GROUP_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(62564216313265888.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. '),
unistr('  Los grupos de p\00E1ginas ayudan a los desarrolladores a identificar y gestionar las p\00E1ginas en una aplicaci\00F3n.</p>'),
unistr('<p>Nota: Para crear grupos de p\00E1ginas, vaya a <strong>Utilidades: Grupos de p\00E1ginas</strong> en Utilidades espec\00EDficas de p\00E1gina en la barra lateral derecha.</p>'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1941056335309424092.4001)
,p_computation_sequence=>50
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P4810_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165312001678491434.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1223475038963011311.4001)
,p_computation_sequence=>10
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.flow_owner ( ',
'               p_flow_id           =>:FB_FLOW_ID, ',
'               p_security_group_id =>:FLOW_SECURITY_GROUP_ID);'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(253076536321538024.4001)
,p_computation_sequence=>20
,p_computation_item=>'P4810_FORM_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_title varchar2(255);',
'begin',
'  if :P4700_SELECT_REPORT_TYPE = ''FORM'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.FORMONTABLE'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''FORMONSQL'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.FORMONSQL'');',
'  elsif :P4700_SELECT_REPORT_TYPE = ''FORMONPROC'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.FORMONPROCEDURE'');',
'  end if;',
'  return l_title;',
'end;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45097100285805209.4001)
,p_validation_name=>'P4810_PAGE_MODE Not Null'
,p_validation_sequence=>10
,p_validation=>'P4810_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(62565215934279144.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62575820071480597.4001)
,p_validation_name=>'Page ID positive, whole number'
,p_validation_sequence=>10
,p_validation=>'F4000_P4810_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(62565215934279144.4001)
,p_associated_item=>wwv_flow_api.id(62566116715293014.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(62576113845485651.4001)
,p_validation_name=>'Page Name Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4810_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de p\00E1gina.')
,p_validation_condition=>'not wwv_flow_wizard_api.page_exists ( p_flow_id => :FB_FLOW_ID, p_page_id => :F4000_P4810_PAGE_ID )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(62566422570302995.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(70024324984092997.4001)
,p_validation_name=>'Region Name Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4810_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de regi\00F3n.')
,p_validation_condition_type=>'NEVER'
,p_associated_item=>wwv_flow_api.id(70020620455081714.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138676824481599754.4001)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      select 1',
'      from wwv_flow_page_plugs',
'      where flow_id = :fb_flow_id',
'      and   page_id = :F4000_P4810_PAGE_ID',
'      and   menu_id is not null',
'      and   nvl(:P4810_BREADCRUMB_ID,0)<>0'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina especificada ya tiene una regi\00F3n de ruta de navegaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(62565215934279144.4001)
,p_associated_item=>wwv_flow_api.id(122119130053370532.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403511372300636657.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P4810_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4810_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(62565215934279144.4001)
,p_associated_item=>wwv_flow_api.id(403510526813630484.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(253077068906538029.4001)
,p_validation_name=>'cancel branch not null'
,p_validation_sequence=>40
,p_validation=>'P4810_CANCEL_BRANCH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la cancelaci\00F3n de bifurcaci\00F3n.')
,p_validation_condition_type=>'NEVER'
,p_when_button_pressed=>wwv_flow_api.id(62565215934279144.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(253077191765538030.4001)
,p_validation_name=>'Submit branch cannot be null.'
,p_validation_sequence=>50
,p_validation=>'P4810_BRANCH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la ejecuci\00F3n de bifurcaci\00F3n.')
,p_validation_condition_type=>'NEVER'
,p_when_button_pressed=>wwv_flow_api.id(62565215934279144.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381725487070950284.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4810_BREADCRUMB_ID'
,p_condition_element=>'P4810_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381725706866950289.4001)
,p_event_id=>wwv_flow_api.id(381725487070950284.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4810_BREADCRUMB_PARENT_ID,P4810_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381725972775950293.4001)
,p_event_id=>wwv_flow_api.id(381725487070950284.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4810_BREADCRUMB_PARENT_ID,P4810_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549715396302753314.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(62564984463274761.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549715492666753315.4001)
,p_event_id=>wwv_flow_api.id(549715396302753314.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(699431213651168693.4001)
,p_name=>'Page Exists'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :FB_FLOW_ID,',
'                                 p_page_id => :F4000_P4810_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(699431544828168693.4001)
,p_event_id=>wwv_flow_api.id(699431213651168693.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4810_PAGE_MODE,P4810_GROUP_NAME,P4810_BREADCRUMB_ID,P4810_BREADCRUMB_PARENT_ID,P4810_BREADCRUMB_NAME,F4000_P4810_PAGE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1941056693930427187.4001)
,p_name=>'set region name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4810_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941057537558427191.4001)
,p_event_id=>wwv_flow_api.id(1941056693930427187.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4810_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P4810_PAGE_NAME'
,p_attribute_07=>'F4000_P4810_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941057043997427187.4001)
,p_event_id=>wwv_flow_api.id(1941056693930427187.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4810_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P4810_PAGE_NAME'
,p_attribute_07=>'F4000_P4810_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(253077244460538031.4001)
,p_name=>'show branches if normal'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4810_PAGE_MODE'
,p_condition_element=>'P4810_PAGE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NORMAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(253077351048538032.4001)
,p_event_id=>wwv_flow_api.id(253077244460538031.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4810_BRANCH,P4810_CANCEL_BRANCH'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(253077410131538033.4001)
,p_event_id=>wwv_flow_api.id(253077244460538031.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4810_BRANCH,P4810_CANCEL_BRANCH'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_04850
begin
wwv_flow_api.create_page(
 p_id=>4850.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
,p_step_title=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_inline_css=>'.code-inline {white-space: normal; font-size: 11px; word-break: break-word;}'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(659452654063607863.4001)
,p_plug_name=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La configuraci\00F3n de la aplicaci\00F3n permite a los desarrolladores definir las opciones de configuraci\00F3n de nivel de aplicaci\00F3n.</p>'),
'',
unistr('<p>Puede utilizar las siguientes API de la aplicaci\00F3n para acceder a la configuraci\00F3n de la aplicaci\00F3n:</p>'),
'',
'<p><strong>Para definir un valor para un ajuste:</strong>',
'<code class="code-inline">apex_app_setting.<br>set_value()</code></p>',
'',
'<p><strong>Para obtener el valor de un ajuste:</strong>',
'<code class="code-inline">apex_app_setting.<br>get_value()</code></p>',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-app-settings.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(663191276316602128.4001)
,p_plug_name=>unistr('Informe de configuraci\00F3n de aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       is_required,',
'       valid_values,',
'       value,',
'       on_upgrade_keep_value,',
'       comments,',
'       (select p.patch_name',
'          from wwv_flow_patches p',
'         where p.id = s.required_patch',
'           and p.security_group_id = s.security_group_id',
'        union all',
'        select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',patch_name)|| ''} '' ',
'               patch_name ',
'          from wwv_flow_patches p',
'         where 0-p.id = s.required_patch',
'           and p.security_group_id = s.security_group_id ) as required_patch,',
'       ''a-Icon icon-util-gear'' img,',
'       wwv_flow_utilities.prepare_url(''f?p=''||:APP_ID||'':4851:''||:FLOW_SESSION||''::NO::F4000_P4851_ID:''||ID) link,',
'       created_on,',
'       created_by,',
'       last_updated_on,',
'       last_updated_by',
'from wwv_flow_app_settings s',
'where flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(663191354226602129.4001)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha definido ninguna configuraci\00F3n para esta aplicaci\00F3n')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>663191354226602129
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(659455242914551039.4001)
,p_db_column_name=>'ID'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(659466226407559701.4001)
,p_db_column_name=>'NAME'
,p_display_order=>193
,p_column_identifier=>'X'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4851:&SESSION.::&DEBUG.:RP,4851:F4000_P4851_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(659466409712559703.4001)
,p_db_column_name=>'VALUE'
,p_display_order=>203
,p_column_identifier=>'Z'
,p_column_label=>'Valor'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524768890490188216.4001)
,p_db_column_name=>'IS_REQUIRED'
,p_display_order=>213
,p_column_identifier=>'AI'
,p_column_label=>'Necesario'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524768988975188217.4001)
,p_db_column_name=>'VALID_VALUES'
,p_display_order=>223
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Valores V\00E1lidos')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524771791998188245.4001)
,p_db_column_name=>'ON_UPGRADE_KEEP_VALUE'
,p_display_order=>233
,p_column_identifier=>'AM'
,p_column_label=>'Mantener valor al actualizar'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(659466568974559704.4001)
,p_db_column_name=>'COMMENTS'
,p_display_order=>243
,p_column_identifier=>'AA'
,p_column_label=>'Comentarios'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524771978805188247.4001)
,p_db_column_name=>'REQUIRED_PATCH'
,p_display_order=>253
,p_column_identifier=>'AN'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(659466678035559705.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>263
,p_column_identifier=>'AB'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(659461245250551053.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>273
,p_column_identifier=>'S'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524769098525188218.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>283
,p_column_identifier=>'AK'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(524769101778188219.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>293
,p_column_identifier=>'AL'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(275642861173510006.4001)
,p_db_column_name=>'IMG'
,p_display_order=>303
,p_column_identifier=>'AO'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(275642992681510007.4001)
,p_db_column_name=>'LINK'
,p_display_order=>313
,p_column_identifier=>'AP'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(659463232081551063.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(663191276316602128.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4850:&SESSION.::&DEBUG.:4910,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(659463668767551063.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(663191276316602128.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear valor'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4851:&SESSION.::&DEBUG.:4851::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(659465550091551069.4001)
,p_branch_action=>'4910'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(659464787648551068.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4911_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(659465121897551068.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4910'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(659508237433651406.4001)
,p_name=>'Refresh after Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(663191276316602128.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(659508377745651407.4001)
,p_event_id=>wwv_flow_api.id(659508237433651406.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(663191276316602128.4001)
);
end;
/
prompt --application/pages/page_04851
begin
wwv_flow_api.create_page(
 p_id=>4851.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Detalles de la configuraci\00F3n de la aplicaci\00F3n')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Valor de aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_inline_css=>'.a-EditScreen-body {padding-top: 0;}'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(224900616502191331.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>' '
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(659491575818183010.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>' '
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1275009101187899937.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1276927482838254567.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by, last_updated_on, created_by, created_on ',
'    from WWV_FLOW_APP_SETTINGS ',
'    where id = :F4000_P4851_ID',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id)',
'loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id                 => :F4000_P4851_ID,',
'      p_last_updated_by    => c1.last_updated_by,',
'      p_last_updated_on    => c1.last_updated_on,',
'      p_created_by         => c1.created_by,',
'      p_created_on         => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4851_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(659499040691635276.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1275009101187899937.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'v(''F4000_P4851_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(659499425611635277.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1275009101187899937.4001)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4851_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(659499891212635277.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1275009101187899937.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear valor de aplicaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4851_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(659498663294635274.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1275009101187899937.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(57818688735990561.4001)
,p_name=>'F4000_P4851_REQUIRED_PATCH'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(224900616502191331.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una opci\00F3n de creaci\00F3n para este componente.<p/>Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(524768673200188214.4001)
,p_name=>'F4000_P4851_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor Necesario'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(524768706335188215.4001)
,p_name=>'F4000_P4851_VALID_VALUES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valores V\00E1lidos')
,p_source=>'VALID_VALUES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca valores v\00E1lidos separados por comas. Si se ha definido as\00ED, Application Express solo acepta valores v\00E1lidos al cambiar la configuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(659492293967635269.4001)
,p_name=>'F4000_P4851_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(659507705606651401.4001)
,p_name=>'F4000_P4851_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre descriptivo para este valor de aplicaci\00F3n. La configuraci\00F3n de aplicaci\00F3n permite a los desarrolladores definir las opciones de configuraci\00F3n de nivel de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(659507876349651402.4001)
,p_name=>'F4000_P4851_VALUE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valor'
,p_source=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el valor por defecto para este valor de aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(659507965963651403.4001)
,p_name=>'F4000_P4851_COMMENTS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(659508452659651408.4001)
,p_name=>'F4000_P4851_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(724232577429924804.4001)
,p_name=>'P4851_ON_UPGRADE_KEEP_VALUE'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(659491575818183010.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Mantener valor al actualizar'
,p_source=>'ON_UPGRADE_KEEP_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si el valor de configuraci\00F3n de aplicaci\00F3n en la aplicaci\00F3n desplegada se debe mantener o se debe sobrescribir con el valor especificado cuando se actualiza la aplicaci\00F3n. La selecci\00F3n de <strong>Activado</strong> para mantener el valor de')
||unistr('splegado es \00FAtil si la aplicaci\00F3n soporta la configuraci\00F3n de aplicaci\00F3n (a trav\00E9s de la API <code>APEX_APP_SETTING.SET_VALUE</code>) para cambiar el valor de configuraci\00F3n de aplicaci\00F3n en la aplicaci\00F3n desplegada y all\00ED donde desee respetar esos va')
||unistr('lores despu\00E9s de la actualizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(618161397257156838.4001)
,p_validation_name=>'valid name'
,p_validation_sequence=>10
,p_validation=>'F4000_P4851_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('#LABEL# solo puede contener caracteres alfanum\00E9ricos y de subrayado "_".')
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(659507705606651401.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(618161497447156839.4001)
,p_validation_name=>'name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_app_settings',
'where name = upper(:F4000_P4851_NAME)',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and ( id != :F4000_P4851_ID or :F4000_P4851_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otro valor de aplicaci\00F3n ya est\00E1 utilizando el nombre.  ')
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(524769391908188221.4001)
,p_validation_name=>'value required'
,p_validation_sequence=>30
,p_validation=>'F4000_P4851_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Puede que el valor &F4000_P4851_NAME. de configuraci\00F3n de la aplicaci\00F3n no est\00E9 defino como nulo')
,p_validation_condition=>'F4000_P4851_IS_REQUIRED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(524769282896188220.4001)
,p_validation_name=>'is value valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_valid_value in (',
'    select column_value',
'    from table( wwv_flow_string.split( :F4000_P4851_VALID_VALUES, '','' ) ) )',
'loop',
'    if :F4000_P4851_VALUE = trim(l_valid_value.column_value) then',
'        return true;',
'    end if;',
'end loop;',
'',
'-- if value not one of the valid value',
'return false;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El valor &F4000_P4851_NAME. de configuraci\00F3n de la aplicaci\00F3n no es v\00E1lido.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4851_VALID_VALUES is not null and',
':F4000_P4851_VALUE is not null and',
':REQUEST != ''Delete'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(659508860217651412.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(659498663294635274.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(659508916024651413.4001)
,p_event_id=>wwv_flow_api.id(659508860217651412.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(659501430368635281.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_APP_SETTING'
,p_attribute_02=>'WWV_FLOW_APP_SETTINGS'
,p_attribute_03=>'F4000_P4851_ID'
,p_attribute_04=>'ID'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(659508093254651404.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_02=>'WWV_FLOW_APP_SETTINGS'
,p_attribute_03=>'F4000_P4851_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(659508135714651405.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_04860
begin
wwv_flow_api.create_page(
 p_id=>4860.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Plantillas de correo electr\00F3nico')
,p_step_title=>unistr('Plantillas de correo electr\00F3nico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_inline_css=>'.code-inline {white-space: normal; font-size: 11px; word-break: break-word;}'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487196643709213274.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2306436841283369.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1340410279495045514.4001)
,p_plug_name=>unistr('Plantillas de correo electr\00F3nico')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La aplicaci\00F3n puede enviar correos electr\00F3nicos mediante las plantillas de correo electr\00F3nico que se definen en esta pantalla.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-email-templates.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1344148901748039779.4001)
,p_plug_name=>unistr('Informe de plantillas de correo electr\00F3nico')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       subject,',
'       static_id,',
'       comments,',
'       created_on,',
'       created_by,',
'       last_updated_on,',
'       last_updated_by',
'from wwv_flow_email_templates',
'where flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1344148979658039780.4001)
,p_name=>'Build Options'
,p_no_data_found_message=>unistr('No se han definido plantillas de correo electr\00F3nico para esta aplicaci\00F3n')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1344148979658039780
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(680959332520437687.4001)
,p_db_column_name=>'ID'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(680960154480437688.4001)
,p_db_column_name=>'NAME'
,p_display_order=>193
,p_column_identifier=>'X'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:RP,4861:F4000_P4861_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(446736640682201412.4001)
,p_db_column_name=>'SUBJECT'
,p_display_order=>203
,p_column_identifier=>'AL'
,p_column_label=>'Asunto'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(680960949155437689.4001)
,p_db_column_name=>'COMMENTS'
,p_display_order=>213
,p_column_identifier=>'AA'
,p_column_label=>'Comentarios'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(680961326881437690.4001)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>223
,p_column_identifier=>'AB'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(680959790441437688.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>233
,p_column_identifier=>'S'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(620207530378182231.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>243
,p_column_identifier=>'AI'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(620207611569182232.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>253
,p_column_identifier=>'AJ'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(693723440750042145.4001)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>263
,p_column_identifier=>'AK'
,p_column_label=>unistr('Identificador est\00E1tico')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(680962100362437694.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1344148901748039779.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.:4910,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2200577474471402.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1344148901748039779.4001)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(680962541348437694.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1344148901748039779.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear plantilla de correo electr\00F3nico')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:4861::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(680965063874437699.4001)
,p_branch_action=>'4910'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(680963377908437697.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4911_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(680963756327437697.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4910'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(680964047689437698.4001)
,p_name=>'Refresh after Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(1344148901748039779.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(680964558061437699.4001)
,p_event_id=>wwv_flow_api.id(680964047689437698.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1344148901748039779.4001)
);
end;
/
prompt --application/pages/page_04861
begin
wwv_flow_api.create_page(
 p_id=>4861.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Detalles de la Plantilla de Correo Electr\00F3nico')
,p_step_title=>unistr('Detalles de la Plantilla de Correo Electr\00F3nico')
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(91429205691059841)
,p_inline_css=>'.sample-btn {width: 100%; display: block; margin-bottom: 8px; margin-left: 0 !important; text-align: left;}'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(218252253865877505.4001)
,p_plug_name=>'Plantillas de muestra'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Empiece por cargar una plantilla de correo electr\00F3nico de ejemplo.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(413799296758117483.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Defina el formato HTML y los formatos de texto sin formato para los correos electr\00F3nicos que desea enviar.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./HTMDB/managing-email-templates.htm">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(481182180273329903.4001)
,p_plug_name=>'Uso de API de ejemplo'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="api"></div>'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620207911554182235.4001)
,p_plug_name=>'Texto sin formato'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620208118464182237.4001)
,p_plug_name=>'Formato HTML'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40361794223464001.4001)
,p_plug_name=>'Avanzado'
,p_parent_plug_id=>wwv_flow_api.id(620208118464182237.4001)
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620208219513182238.4001)
,p_plug_name=>'Comentarios'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(620208848205182244.4001)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(681116845925664404.4001)
,p_plug_name=>unistr('Identificaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(681117531703664406.4001)
,p_plug_name=>'Detalles de Plantilla'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(40362328235464007.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(40361794223464001.4001)
,p_button_name=>'RESTORE_HTML'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cargar HTML por defecto'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-undo'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(218252429784877507.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(218252253865877505.4001)
,p_button_name=>'LOAD_ORDER_DETAILS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Cargar detalles de solicitud'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'sample-btn'
,p_icon_css_classes=>'icon-load-sample'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(218252503160877508.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(218252253865877505.4001)
,p_button_name=>'LOAD_EVENT_REMINDER'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>'Cargar recordatorio de evento'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'sample-btn'
,p_icon_css_classes=>'icon-load-sample'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(100576992718284427.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(218252253865877505.4001)
,p_button_name=>'LOAD_SCHEDULED_OUTAGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_image_alt=>unistr('Cargar interrupci\00F3n programada')
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'sample-btn'
,p_icon_css_classes=>'icon-load-sample'
,p_grid_new_row=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681117952155664406.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(681117531703664406.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681117422344664406.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(681117531703664406.4001)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>unistr('\00BFDesea suprimir esta plantilla de correo electr\00F3nico?')
,p_confirm_style=>'warning'
,p_button_condition=>'F4000_P4861_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681117353209664406.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(681117531703664406.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4861_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(681117279243664406.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(681117531703664406.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear plantilla de correo electr\00F3nico')
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4861_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(620208962722182245.4001)
,p_branch_name=>'Branch to Templates Page'
,p_branch_action=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_branch_condition=>'RESTORE_HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(446736559362201411.4001)
,p_name=>'F4000_P4861_SUBJECT'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(681116845925664404.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Asunto de correo electr\00F3nico')
,p_source=>'SUBJECT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Las cadenas de sustituci\00F3n se utilizan con el formato <code>#STRING_NAME#</code>. Se pueden transferir valores para estas cadenas con la API de <code>APEX_MAIL</code>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681120398494664411.4001)
,p_name=>'F4000_P4861_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(681116845925664404.4001)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681121138469664443.4001)
,p_name=>'F4000_P4861_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(681116845925664404.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681121579555664443.4001)
,p_name=>'F4000_P4861_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(681116845925664404.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Nombre de la Plantilla'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681121989585664444.4001)
,p_name=>'F4000_P4861_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(681116845925664404.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Identificador est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Este identificador se utiliza en la llamada API <code>APEX_MAIL</code> para hacer referencia a esta plantilla.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681122356863664444.4001)
,p_name=>'F4000_P4861_COMMENTS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(620208219513182238.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681122782009664445.4001)
,p_name=>'F4000_P4861_TEXT_TEMPLATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(620207911554182235.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Contenido'
,p_source=>'TEXT_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Las cadenas de sustituci\00F3n se utilizan con el formato <code>#STRING_NAME#</code>. Se pueden transferir valores para estas cadenas con la API <code>APEX_MAIL</code>.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681124744435664446.4001)
,p_name=>'F4000_P4861_HTML_TEMPLATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40361794223464001.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plantilla HTML'
,p_source=>'HTML_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cHeight=>12
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cadenas de sustituci\00F3n:</p>'),
'',
'<ul>',
unistr('<li>Cadenas globales (definidas autom\00E1ticamente):'),
'        <ul>',
'            <li><code>#APP_NAME#</code></li>',
'            <li><code>#APP_URL#</code></li>',
'            <li><code>#APEX_HOST#</code></li>',
'        </ul></li>',
'',
'<li>Cadenas de plantilla:',
'        <ul>',
'            <li><code>#BODY#</code></li>',
'            <li><code>#BEFORE_ROWS#</code></li>',
'            <li><code>#ROWS#</code></li>',
'            <li><code>#AFTER_ROWS#</code></li>',
'            <li><code>#ACTION_LINK#</code></li>',
'        </ul></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681125178547664446.4001)
,p_name=>'F4000_P4861_HTML_HEADER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(620208118464182237.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cabecera'
,p_source=>'HTML_HEADER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Las cadenas de sustituci\00F3n se utilizan con el formato <code>#STRING_NAME#</code>. Se pueden transferir valores para estas cadenas con la API <code>APEX_MAIL</code>.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681125548202664447.4001)
,p_name=>'F4000_P4861_HTML_BODY'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(620208118464182237.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cuerpo'
,p_source=>'HTML_BODY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede utilizar marcadores b\00E1sicos para dar formato al cuerpo de su correo electr\00F3nico.</p>'),
unistr('<p>Las cadenas de sustituci\00F3n se utilizan con el formato <code>#STRING_NAME#</code>. Se pueden transferir valores para estas cadenas con la API <code>APEX_MAIL</code>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(681125979457664447.4001)
,p_name=>'F4000_P4861_HTML_FOOTER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(620208118464182237.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Pie de P\00E1gina')
,p_source=>'HTML_FOOTER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>2
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('<p>Las cadenas de sustituci\00F3n se utilizan con el formato <code>#STRING_NAME#</code>. Se pueden transferir valores para estas cadenas con la API <code>APEX_MAIL</code>.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(620207869381182234.4001)
,p_validation_name=>'Internal Name must be Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_email_templates',
'where static_id = upper(:F4000_P4861_STATIC_ID)',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and ( id != :F4000_P4861_ID or :F4000_P4861_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Otra plantilla de correo electr\00F3nico ya est\00E1 utilizando el nombre interno.  ')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(693723517414042146.4001)
,p_validation_name=>'Only Valid Characters'
,p_validation_sequence=>20
,p_validation=>'F4000_P4861_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>unistr('El identificador solo puede contener caracteres alfanum\00E9ricos y "_".')
,p_associated_item=>wwv_flow_api.id(681121989585664444.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3102636038440426.4001)
,p_validation_name=>'Email Template in use'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_processing',
' where flow_id           = :FB_FLOW_ID',
'   and attribute_11      = :F4000_P4861_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and process_type      = ''NATIVE_SEND_EMAIL''',
'union all (',
'select 1',
'  from wwv_flow_automation_actions',
' where flow_id           = :FB_FLOW_ID',
'   and attribute_11      = :F4000_P4861_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and action_type       = ''NATIVE_SEND_EMAIL''',
')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La plantilla de correo electr\00F3nico est\00E1 en uso en un proceso de p\00E1gina o una acci\00F3n de automatizaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(681117422344664406.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(40361878504464002.4001)
,p_name=>'Update Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4861_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'keyup'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'F4000_P4861_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(40361971123464003.4001)
,p_event_id=>wwv_flow_api.id(40361878504464002.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$s(''F4000_P4861_STATIC_ID'',$v(''F4000_P4861_NAME'').replace(/\s+/g, ''_'').toUpperCase());'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(177068213385885505.4001)
,p_name=>'Set Default HTML Template'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(40362328235464007.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(177068397091885506.4001)
,p_event_id=>wwv_flow_api.id(177068213385885505.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_mail.get_default_html_template'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(218253182235877514.4001)
,p_name=>'Load Order Details Sample'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(218252429784877507.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253215205877515.4001)
,p_event_id=>wwv_flow_api.id(218253182235877514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_HEADER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HEADER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253337981877516.4001)
,p_event_id=>wwv_flow_api.id(218253182235877514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_BODY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(481181914965329901.4001)
,p_event_id=>wwv_flow_api.id(218253182235877514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_SUBJECT'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253477851877517.4001)
,p_event_id=>wwv_flow_api.id(218253182235877514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_FOOTER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.FOOTER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253576691877518.4001)
,p_event_id=>wwv_flow_api.id(218253182235877514.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_TEXT_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(218253634134877519.4001)
,p_name=>'Load Event Reminder Sample'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(218252503160877508.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253789725877520.4001)
,p_event_id=>wwv_flow_api.id(218253634134877519.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_HEADER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HEADER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253805031877521.4001)
,p_event_id=>wwv_flow_api.id(218253634134877519.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_BODY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(481182048498329902.4001)
,p_event_id=>wwv_flow_api.id(218253634134877519.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_SUBJECT'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218253984047877522.4001)
,p_event_id=>wwv_flow_api.id(218253634134877519.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_FOOTER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.FOOTER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(218254044156877523.4001)
,p_event_id=>wwv_flow_api.id(218253634134877519.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_TEXT_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(100577052930284428.4001)
,p_name=>'Load Scheduled Outage Sample'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(100576992718284427.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100577143626284429.4001)
,p_event_id=>wwv_flow_api.id(100577052930284428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_HEADER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HEADER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100577248602284430.4001)
,p_event_id=>wwv_flow_api.id(100577052930284428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_BODY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100577381971284431.4001)
,p_event_id=>wwv_flow_api.id(100577052930284428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_FOOTER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.FOOTER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100577461608284432.4001)
,p_event_id=>wwv_flow_api.id(100577052930284428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_TEXT_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(100577525161284433.4001)
,p_event_id=>wwv_flow_api.id(100577052930284428.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_SUBJECT'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(483371065390969312.4001)
,p_name=>'API'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4861_STATIC_ID,F4000_P4861_SUBJECT,F4000_P4861_HTML_HEADER,F4000_P4861_HTML_BODY,F4000_P4861_HTML_FOOTER,F4000_P4861_TEXT_TEMPLATE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(483371122535969313.4001)
,p_event_id=>wwv_flow_api.id(483371065390969312.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#api'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_placeholders        wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'    l_output              varchar2( 32767 );   ',
'',
'    l_max_placeholder_len pls_integer := 0;',
'begin',
'    l_output := q''~',
'<pre>begin',
'    apex_mail.send (',
'        p_to                 => email_address_of_user,',
'        p_template_static_id => ''~'' || :F4000_P4861_STATIC_ID || q''~'',',
'        p_placeholders       => ''{'' ||',
'~'';',
'',
'    wwv_flow_template_dev.template_placeholders( p_template => :F4000_P4861_SUBJECT,       p_placeholders => l_placeholders, p_ignore_placeholders => null );',
'    wwv_flow_template_dev.template_placeholders( p_template => :F4000_P4861_HTML_HEADER,   p_placeholders => l_placeholders, p_ignore_placeholders => null );',
'    wwv_flow_template_dev.template_placeholders( p_template => :F4000_P4861_HTML_BODY,     p_placeholders => l_placeholders, p_ignore_placeholders => null );',
'    wwv_flow_template_dev.template_placeholders( p_template => :F4000_P4861_HTML_FOOTER,   p_placeholders => l_placeholders, p_ignore_placeholders => null );',
'    wwv_flow_template_dev.template_placeholders( p_template => :F4000_P4861_TEXT_TEMPLATE, p_placeholders => l_placeholders, p_ignore_placeholders => null );',
'    ',
'    for i in 1 .. l_placeholders.count loop',
'        l_max_placeholder_len := greatest( l_max_placeholder_len, length( l_placeholders( i ) ) );',
'    end loop;',
'',
'    for i in 1 .. l_placeholders.count loop',
'        l_output := l_output ||',
'            ''        ''''   '' ||',
'            case when i = 1 then '' '' else '','' end ||',
'            case when l_placeholders( i ) = ''MY_APPLICATION_LINK'' then',
'              rpad( ''"'' || l_placeholders( i ) || ''":'''''', l_max_placeholder_len + 4 ) || '' || apex_json.stringify( apex_mail.get_instance_url || apex_page.get_url( some_page_number )) ||'' ',
'            else',
'              rpad( ''"'' || l_placeholders( i ) || ''":'''''', l_max_placeholder_len + 4 ) || '' || apex_json.stringify( some_value ) ||'' ',
'            end || wwv_flow.LF;',
'    end loop;',
'    l_output := l_output ||',
'q''~        ''}'' );',
'end;</pre>~'';',
'',
'    return l_output;',
'end;'))
,p_attribute_07=>'F4000_P4861_STATIC_ID,F4000_P4861_SUBJECT,F4000_P4861_HTML_HEADER,F4000_P4861_HTML_BODY,F4000_P4861_HTML_FOOTER,F4000_P4861_TEXT_TEMPLATE'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(681128740869664453.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_EMAIL_TEMPLATES'
,p_attribute_02=>'WWV_FLOW_EMAIL_TEMPLATES'
,p_attribute_03=>'F4000_P4861_ID'
,p_attribute_04=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4861_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(681129138062664453.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_02=>'WWV_FLOW_EMAIL_TEMPLATES'
,p_attribute_03=>'F4000_P4861_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(681129571001664454.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(681117422344664406.4001)
);
end;
/
prompt --application/pages/page_04862
begin
wwv_flow_api.create_page(
 p_id=>4862.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Uso'
,p_alias=>'UTILIZATION'
,p_step_title=>'Uso'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(213347710073256556)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3103040285440430.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    t.id                    template_id,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) ',
'                            the_url,',
'    p.id                    page_id, ',
'    p.name                  page_name, ',
'    wwv_flow_lang.system_message(''PAGE PROCESS'') ',
'                            process_type,',
'    pr.process_name         process_name,',
'    t.name                  template_name',
'from wwv_flow_steps           p,',
'     wwv_flow_step_processing pr,',
'     wwv_flow_email_templates t',
'where t.id = pr.attribute_11',
'  and pr.process_type     = ''NATIVE_SEND_EMAIL''',
'  and pr.flow_step_id     = p.id',
'  and pr.flow_id          = p.flow_id',
'  and p.flow_id           = t.flow_id',
'  and t.security_group_id = :flow_security_group_id',
'union all (',
'select  ',
'    t.id,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:7022:''||:flow_session||'':::7021,7022:P7021_ID,P7022_AUTOMATION_ID,P7022_ID:''||a.id || '','' || a.id || '','' || am.id) ',
'                               the_url,  ',
'    null                       page_id, ',
'    null                       page_name,  ',
'    wwv_flow_lang.system_message(''AUTOMATION_ACTIONS'') ',
'                               process_type,',
'    a.name || '' - '' || am.name process_name,',
'    t.name                     template_name',
'from wwv_flow_automations        a,',
'     wwv_flow_automation_actions am,',
'     wwv_flow_email_templates    t ',
'where t.id                 = am.attribute_11',
'  and am.action_type       = ''NATIVE_SEND_EMAIL''',
'  and am.automation_id     = a.id',
'  and a.flow_id            = t.flow_id',
'  and a.security_group_id  = :flow_security_group_id',
')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Uso'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2406388620825309.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se han encontrado usos para la plantilla de correo electr\00F3nico.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>2406388620825309
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406435252825310.4001)
,p_db_column_name=>'TEMPLATE_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID de plantilla'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406596323825311.4001)
,p_db_column_name=>'THE_URL'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'La URL'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2407059330825316.4001)
,p_db_column_name=>'TEMPLATE_NAME'
,p_display_order=>30
,p_column_identifier=>'G'
,p_column_label=>'Nombre de la Plantilla'
,p_column_link=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:4861:F4000_P4861_ID:#TEMPLATE_ID#'
,p_column_linktext=>'#TEMPLATE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406698500825312.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406758551825313.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406873085825314.4001)
,p_db_column_name=>'PROCESS_TYPE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Tipo de Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406968686825315.4001)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Nombre del Componente'
,p_column_link=>'#THE_URL#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484996226588456413.4001)
,p_plug_name=>'Uso'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra d\00F3nde se utilizan <strong>plantillas de correo electr\00F3nico</strong> en la aplicaci\00F3n.'),
'</p>',
'<p>',
unistr('Tenga en cuenta que el uso de plantillas en el c\00F3digo PL/SQL (Package APEX_MAIL) no est\00E1 enumerado en esta p\00E1gina.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(484996425781456414.4001)
,p_plug_name=>'separadores'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2306436841283369.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
end;
/
prompt --application/pages/page_04863
begin
wwv_flow_api.create_page(
 p_id=>4863.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Historial de plantilla de correo electr\00F3nico')
,p_alias=>'EMAIL-TEMPLATE-HISTORY'
,p_step_title=>unistr('Historial de plantilla de correo electr\00F3nico')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3104865324440448.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''BU.EMAIL_TEMPLATES'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_EMAIL_TEMPLATES''',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Nuevo'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3105027003440450.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se ha encontrado historial para las plantillas de correo electr\00F3nico.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'CCZARSKI'
,p_internal_uid=>3105027003440450
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2405656268825302.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>10
,p_column_identifier=>'B'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2405766151825303.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2405567018825301.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406172324825307.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406200357825308.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>50
,p_column_identifier=>'H'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2405835522825304.4001)
,p_db_column_name=>'SCN'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Scn'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2405916383825305.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2406026302825306.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195748512769210350.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(2306436841283369.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(195748697203210351.4001)
,p_plug_name=>unistr('Historial de plantilla de correo electr\00F3nico')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Esta p\00E1gina muestra las modificaciones recientes realizadas en las plantillas de correo electr\00F3nico de esta aplicaci\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_04900
begin
wwv_flow_api.create_page(
 p_id=>4900.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Exportar Aplicaci\00F3n')
,p_alias=>'EXPORTAPP'
,p_step_title=>unistr('Exportar Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(380536008.4001)
,p_plug_name=>'Acerca de'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Al exportar una aplicaci\00F3n, se exportan todos sus atributos (incluidas las plantillas, p\00E1ginas, regiones, elementos, botones,'),
'etc.) a un solo archivo.</p>',
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/exporting-an-application-and-application-components.html">Obtener m\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'' and ',
'nvl(:FB_FB_EXPORT_FLOW_ID,0) != 0'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(680503331.4001)
,p_plug_name=>unistr('Exportar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_source=>' '
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(39183122032.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(12802829107.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(158039218985780349.4001)
,p_plug_name=>'Tareas'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(158038003748775992.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(168863605513942093.4001)
,p_plug_name=>unistr('Exportar Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(168869025093061269.4001)
,p_name=>unistr('Exportaciones Recientes a Repositorio de Exportaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select title as application,',
'       case',
'           when bytes < 1024 * 1024 then',
'               to_char(bytes / 1024, ''fm999G990'') || ''KB''',
'           else to_char(bytes / 1024 / 1024, ''fm999G999G990'') || ''MB''',
'       end as doc_size,',
'       created_on',
'  from (',
'select title,',
'       created_on,',
'       nvl( doc_size, 0 ) as bytes',
'  from WWV_FLOW_FILE_OBJECTS$ o',
' where flow_id = :FB_FB_EXPORT_FLOW_ID',
'   and file_type = ''FLOW_EXPORT''',
'   and security_group_id = :flow_security_group_id',
' order by created_on desc',
'       )',
' where rownum <= 10'))
,p_display_when_condition=>'FB_FB_EXPORT_FLOW_ID'
,p_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>unistr('No se ha encontrado ninguna exportaci\00F3n para esta aplicaci\00F3n.')
,p_query_row_count_max=>10
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Imprimir'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'MILLIMETERS'
,p_prn_paper_size=>'A4'
,p_prn_width_units=>'PERCENTAGE'
,p_prn_width=>297
,p_prn_height=>210
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(168869304377061274.4001)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre de Archivo'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(932668108778561031.4001)
,p_query_column_id=>2
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Tama\00F1o de Archivo')
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(168869414702061274.4001)
,p_query_column_id=>3
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Creado'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(194296805342590236.4001)
,p_plug_name=>unistr('Preferencias de Exportaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(486282025733641382.4001)
,p_plug_name=>unistr('Elegir Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(47282706020505243.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(168863605513942093.4001)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:RP,4900::'
,p_button_cattributes=>'class="button8_69c" onMouseUp="javascript:this.disabled=false;"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6923471041.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(168863605513942093.4001)
,p_button_name=>'ExportFlow'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Exportar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(64241520463572558.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(6923471041.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186781008440066252.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4900:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(486379404165452528.4001)
,p_branch_name=>'Go To Page 4900'
,p_branch_action=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:FB_FB_EXPORT_FLOW_ID,0) = 0'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(791781102.4001)
,p_name=>'F4000_P4900_OWNER_OVERRIDE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_prompt=>unistr('Sustituci\00F3n&nbsp;de&nbsp;Usuario')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Por defecto, la aplicaci\00F3n pertenece al propietario identificado en el propietario del atributo de la aplicaci\00F3n. Utilice este atributo si desea importar la aplicaci\00F3n como un propietario de esquema distinto al de exportaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1721949240.4001)
,p_name=>'F4000_P4900_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_source=>'UNIX'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>Base de Datos</strong> para que, en lugar de descargarse, el archivo resultante se guarde en el repositorio de exportaci\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'unix=chr(10),dos=chr(13)||chr(10) after each row'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6926471043.4001)
,p_name=>'FB_FB_EXPORT_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(486282025733641382.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000L1 */ distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Aplicaci\00F3n -')
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n que se va a exportar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2857155191881120.4001)
,p_name=>'P4900_EXPORT_ZIP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar como ZIP'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Seleccione <strong>Activado</strong> para exportar la aplicaci\00F3n como un archivo ZIP que contiene archivos distintos para cada p\00E1gina, componente compartido, etc.</p>'),
'',
'<p>',
unistr('Seleccione <strong>Desactivado</strong> para exportar como un \00FAnico archivo SQL que contiene toda la aplicaci\00F3n.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18891404558260052.4001)
,p_name=>'F4000_P4900_SET_RUN_ONLY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>unistr('Sustituci\00F3n&nbsp;de&nbsp;Estado&nbsp;de&nbsp;Creaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_api.id(84305510710571518.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el estado de creaci\00F3n de la aplicaci\00F3n exportada. Las opciones incluyen:<br>'),
unistr('<ul><li><strong>Solo Ejecutar Aplicaci\00F3n</strong>: los usuarios solo pueden ejecutar la aplicaci\00F3n. Esta opci\00F3n est\00E1 destinada a aplicaciones de una instancia de producci\00F3n.</li>'),
unistr('<li><strong>Ejecutar y Crear Aplicaci\00F3n</strong>: los desarrolladores y usuarios pueden ejecutar y desarrollar la aplicaci\00F3n.</li>'),
'</ul></p>',
unistr('<p>Nota: Este ajuste se puede cambiar al importar mediante la interfaz web de &PRODUCT_NAME. pero no a trav\00E9s de la interfaz de l\00EDnea de comandos.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(19748423599833275.4001)
,p_name=>'P4900_PRIVATE_REPORTS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar Informes Privados'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se van a incluir informes privados con la aplicaci\00F3n. Estas son las opciones disponibles:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye informes privados en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye informes privados en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Los informes privados son la configuraci\00F3n personalizada privada guardada por los usuarios a partir de un informe interactivo o una cuadr\00EDcula interactiva.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(25717725405973450.4001)
,p_name=>'P4900_EXP_DEPLOYMENT_METADATA'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'Y'
,p_prompt=>'Exportar Definiciones de Objeto de Soporte'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(388231942990864305.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si desea exportar las definiciones de objeto de soporte con la aplicaci\00F3n. Entre las opciones disponibles se incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>S\00ED</strong>: incluye las definiciones de objeto de soporte en la exportaci\00F3n de la aplicaci\00F3n. No carga autom\00E1ticamente objetos de soporte cuando se llaman desde una l\00EDnea de comandos.'),
'</li>',
unistr('<li><strong>No</strong>: no incluye las definiciones de objeto de soporte en la exportaci\00F3n.</li>'),
unistr('</li><strong>S\00ED e Instalar al importar autom\00E1ticamente</strong>: incluye definiciones de objeto de soporte y una llamada para instalar los objetos de soporte en la exportaci\00F3n de la aplicaci\00F3n. Esta opci\00F3n solo es v\00E1lida para instalaciones de la l\00EDne')
||unistr('a de comandos. Cuando la aplicaci\00F3n importa desde la l\00EDnea de comandos, instala o cambia de versi\00F3n autom\00E1ticamente los objetos de soporte.'),
'</ul>',
'<p />',
unistr('Las definiciones de objetos de soporte incluyen todas las opciones de configuraci\00F3n y scripts y permiten que una exportaci\00F3n de aplicaci\00F3n incluya definiciones de objetos de base de datos, definiciones de im\00E1genes y sentencias SQL de datos iniciales ')
||'encapsuladas en un solo archivo.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(28916903130872699.4001)
,p_name=>'P4900_ORIGINAL_IDS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar con ID Originales'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si el archivo de exportaci\00F3n debe contener los ID de componente de aplicaci\00F3n actuales o los de la \00FAltima importaci\00F3n de esta aplicaci\00F3n. Las opciones disponibles incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye los ID de la \00FAltima importaci\00F3n.</li>'),
'<li><strong>Desactivado</strong> incluye los ID actuales de los componentes.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45083820509961243.4001)
,p_name=>'P4900_FLASHBK_FLOW_AS_OF'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_prompt=>'A partir de'
,p_post_element_text=>'<span class="fielddata">minutos antes (~ 5 minutos de retraso)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_display_when=>'F4000_P4900_FORMAT'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Especifique un tiempo en minutos para volver atr\00E1s en la exportaci\00F3n. Esta opci\00F3n permite volver en el tiempo en la aplicaci\00F3n, quiz\00E1s para recuperar un objeto suprimido.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Esta utilidad utiliza el <code>paquete dbms_flashback</code>. La asignaci\00F3n de registro de hora a SCN (N\00FAmero de Cambio del Sistema) se refresca cada 5 minutos aproximadamente, por lo que tal vez tenga que esperar ese esp')
||unistr('acio de tiempo para obtener la versi\00F3n que est\00E1 buscando. El tiempo que se mantiene la informaci\00F3n de deshacer depende del par\00E1metro de inicio <code>undo_retention</code> (tres horas por defecto), pero esto s\00F3lo afecta al tama\00F1o del tablespace de des')
||'hacer.</div>',
unistr('<div class="htmldbInfoBodyP">Mientras que dos bases de datos pueden tener el mismo par\00E1metro <code>undo_retention</code>, puede volver atr\00E1s en el tiempo en la base de datos con menos transacciones, ya que las transacciones no est\00E1n rellenando el tab')
||unistr('lespace de deshacer, forzando as\00ED el archivado de los datos m\00E1s antiguos.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(48525920521551162.4001)
,p_name=>'P4900_NOTIFICATIONS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar Suscripciones de Informe'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se va a incluir la configuraci\00F3n de suscripci\00F3n de informes interactivos o cuadr\00EDculas interactivas en la aplicaci\00F3n. Entre las opciones disponibles, se incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye suscripciones de informes para los informes que exporta en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye suscripciones de informes para los informes en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Esto se limita a la configuraci\00F3n de la suscripci\00F3n que no ha caducado de todos los usuarios de todos los informes interactivos o cuadr\00EDculas interactivas de la aplicaci\00F3n.'),
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(124195606865896920.4001)
,p_name=>'P4900_EXPORT_COMMENTS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'Y'
,p_prompt=>'Exportar Comentarios del Desarrollador'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se incluyen comentarios del desarrollador en la exportaci\00F3n de la aplicaci\00F3n. Las opciones disponibles incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye comentarios del desarrollador en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye comentarios del desarrollador en la exportaci\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(160646506742945585.4001)
,p_name=>'F4000_P4900_FILE_CHARSET'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Juego de Caracteres de Archivo:'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_api.id(144796827445692396.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('El archivo de exportaci\00F3n se codificar\00E1 con el juego de caracteres especificado. Cuando importe este archivo, tendr\00E1 que especificar el mismo juego de caracteres.  ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(193576832187147918.4001)
,p_name=>'P4900_PUBLIC_REPORTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Exportar Informes P\00FAblicos')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si va a incluir informes p\00FAblicos en la aplicaci\00F3n. Las opciones disponibles son:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye informes p\00FAblicos en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye informes p\00FAblicos en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Los informes p\00FAblicos son la configuraci\00F3n de los informes compartidos p\00FAblicos que han guardado los usuarios del informe interactivo o cuadr\00EDcula interactiva.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(198614502120573324.4001)
,p_name=>'P4900_DEBUGGING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>unistr('Depuraci\00F3n')
,p_source=>'select nvl(APPLICATION_TAB_SET,1) debugging from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione una de las siguientes opciones:',
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> exporta la aplicaci\00F3n con la depuraci\00F3n activada.</li> '),
unistr('<li><strong>Desactivado</strong> exporta la aplicaci\00F3n con la depuraci\00F3n desactivada.</li>  '),
'</ul>',
'<p />',
unistr('La depuraci\00F3n es una funci\00F3n \00FAtil para las aplicaciones en desarrollo. Sin embargo, para una aplicaci\00F3n de producci\00F3n, la mejor pr\00E1ctica es'),
unistr('desactivar la depuraci\00F3n para evitar as\00ED que los usuarios visualicen la l\00F3gica de la aplicaci\00F3n.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'1'
,p_attribute_04=>'0'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486299829306900642.4001)
,p_name=>'P4900_PAGE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Recuento de P\00E1ginas:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(count(*),''999G999G999G990'') c',
'from wwv_flow_steps ',
'where flow_id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1ginas en la aplicaci\00F3n que est\00E1 seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486300122165908138.4001)
,p_name=>'P4900_SELECTED_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n Seleccionada:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(486370108957349929.4001)
,p_name=>'P4900_APPLICATION_SCHEMA'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(680503331.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner ',
'from wwv_flows ',
'where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica al propietario del esquema de base de datos de la aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(535545301221838705.4001)
,p_name=>'P4900_EXPORT_TRANSLATIONS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(194296805342590236.4001)
,p_item_default=>'Y'
,p_prompt=>'Exportar Traducciones'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se van a incluir traducciones con la exportaci\00F3n de la aplicaci\00F3n. Las opciones disponibles incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye las asignaciones de traducci\00F3n y todo el texto del repositorio de traducci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye asignaciones de traducci\00F3n ni el repositorio de traducci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Los mensajes de texto de traducci\00F3n y las traducciones din\00E1micas se incluir\00E1n siempre en la exportaci\00F3n de la aplicaci\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(168872412851123884.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FB_EXPORT_FLOW_ID.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(486379904427471521.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FB_EXPORT_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FLOW_ID.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(362405205819170865.4001)
,p_validation_name=>'FB_FB_EXPORT_FLOW_ID Must Have Value'
,p_validation_sequence=>5
,p_validation=>'FB_FB_EXPORT_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_when_button_pressed=>wwv_flow_api.id(6923471041.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45221530343799739.4001)
,p_validation_name=>'P4900_FLASHBK_FLOW_AS_OF is numeric'
,p_validation_sequence=>10
,p_validation=>'P4900_FLASHBK_FLOW_AS_OF'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('"A partir de" debe ser num\00E9rico.')
,p_validation_condition=>':P4900_FLASHBK_FLOW_AS_OF is not null and :REQUEST = ''ExportFlow'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(45083820509961243.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(937789531661878620.4001)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'FB_FB_EXPORT_FLOW_ID'
,p_condition_element=>'FB_FB_EXPORT_FLOW_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937789649281878621.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4900_SELECTED_APPLICATION'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_ret   varchar2(255);',
'begin',
'  select name into l_ret',
'    from wwv_flows ',
'    where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'  return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937790023199878625.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(680503331.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937789702085878622.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4900_PAGE_COUNT'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ret   varchar2(255);',
'begin',
'select to_char(count(*),''999G999G999G990'') c into l_ret',
'from wwv_flow_steps ',
'where flow_id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937790112257878626.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(194296805342590236.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937789841664878623.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4900_APPLICATION_SCHEMA'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret varchar2(255);',
'begin',
'   select owner into l_ret',
'from wwv_flows ',
'where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937789976927878624.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(680503331.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(937790237408878627.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(194296805342590236.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2505229083246085701.4001)
,p_event_id=>wwv_flow_api.id(937789531661878620.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :FB_FLOW_ID := :FB_FB_EXPORT_FLOW_ID;',
'end;'))
,p_attribute_02=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(651513226431755625.4001)
,p_name=>'Submit'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(6923471041.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(651513321581755626.4001)
,p_event_id=>wwv_flow_api.id(651513226431755625.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ExportFlow'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(72827100072386496.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FB_EXPORT_FLOW_ID or :FB_FB_EXPORT_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FB_EXPORT_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :FB_FB_EXPORT_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(6924471042.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_application (',
'    p_application_id            => :FB_FB_EXPORT_FLOW_ID,',
'    p_format                 => case ',
'                                when :P4900_EXPORT_ZIP = ''Y'' then ''ZIP_UNIX'' ',
'                                else ''UNIX'' ',
'                                end,',
'    p_owner_override            => :F4000_P4900_OWNER_OVERRIDE,',
'    p_export_sup_objects        => :P4900_EXP_DEPLOYMENT_METADATA,',
'    p_export_components         => nvl(:P4900_EXPORT_COMMENTS,''N''),',
'    p_export_ir_public_reports  => nvl(:P4900_PUBLIC_REPORTS,''N''),',
'    p_export_ir_private_reports => nvl(:P4900_PRIVATE_REPORTS,''N''),',
'    p_export_ir_notifications   => nvl(:P4900_NOTIFICATIONS,''N''),',
'    p_export_translations       => nvl(:P4900_EXPORT_TRANSLATIONS,''N''),',
'    p_build_status_override     => case',
'                                   when :F4000_P4900_SET_RUN_ONLY = ''RUN_ONLY'' then ''YES''',
'                                   else ''NO''',
'                                   end,',
'    p_debugging_override        => :P4900_DEBUGGING,',
'    p_with_original_ids         => :P4900_ORIGINAL_IDS,',
'    p_flashback_min_ago         => :P4900_FLASHBK_FLOW_AS_OF );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al exportar el flujo &FB_FB_EXPORT_FLOW_ID.. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_api.id(6923471041.4001)
,p_process_when=>'wwv_flow.g_request = ''ExportFlow'' and :F4000_P4900_FORMAT != ''XML'' '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Aplicaci\00F3n &FB_FB_EXPORT_FLOW_ID. exportada.')
);
end;
/
prompt --application/pages/page_04905
begin
wwv_flow_api.create_page(
 p_id=>4905.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Servidor de despliegue remoto'
,p_step_title=>'Servidor de despliegue remoto'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_help_text=>'deploy_import.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45445616494031715.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48314023675949547.4001)
,p_plug_name=>'Servidor de despliegue'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<p class="u-tC">Seleccione un servicio de SQL activado para REST existente o cree uno nuevo.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(750143103004641521.4001)
,p_plug_name=>'Despliegue remoto'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3001471245503399.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45445616494031715.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3001844622503400.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45445616494031715.4001)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./htmdb/importing-export-files.html'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3002260983503401.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(45445616494031715.4001)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3002650181503401.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45445616494031715.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3012045320503429.4001)
,p_branch_name=>'Go To Page 4906'
,p_branch_action=>'f?p=&APP_ID.:4906:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3002260983503401.4001)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(11007566129042201.4001)
,p_branch_name=>'Create Remote Server'
,p_branch_action=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.:RP,1615,1616:P1605_BACK_TO_PAGE:4905&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_REMOTE_SERVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3012803587503430.4001)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(3001471245503399.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2700336969358302.4001)
,p_name=>'P4905_SERVER_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_prompt=>'Servidor de despliegue'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="apex.submit(''CREATE_REMOTE_SERVER'');" aria-label="&APP_TEXT$P4905_BUTTON_ALT_LABEL." type="button" id="P4905_CREATE_REMOTE_SERVER_BUTTON" title="&APP_TEXT$P4905_BUTTON_ALT_LABEL." class="a-Button a-Button--noLabel a-Button--withIcon '
||'a-Button--small">',
'    <span class="a-Icon icon-plus" aria-hidden="true"></span>',
'</button>'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id v',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :flow_security_group_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Seleccionar servicio de SQL activado para REST --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione un servicio SQL activado para REST en la lista o haga clic en el icono m\00E1s para crear uno nuevo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
,p_item_comment=>'<a id="P4905_CREATE_REMOTE_SERVER_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''CREATE_REMOTE_SERVER'')"><span class="a-Icon icon-plus"></span></a>'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(271597133785112731.4001)
,p_name=>'P4905_CREDENTIAL_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500668364724419686.4001)
,p_name=>'P4905_CREDENTIAL_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_prompt=>unistr('Tipo de autenticaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_api.id(154078822199034715.4001)||'.'
,p_cHeight=>1
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Muestra el tipo de autenticaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(500680947492429346.4001)
,p_name=>'P4905_CREDENTIAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_prompt=>'Nombre de la Credencial'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Muestra un nombre descriptivo para las credenciales.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(501154122788434523.4001)
,p_name=>'P4905_EMPTY_CREDENTIAL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Almac\00E9n de credenciales vac\00EDo')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Indica si la credencial est\00E1 almacenada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(501157752331440928.4001)
,p_name=>'P4905_CLIENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_prompt=>'Identificador de Cliente'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when=>'P4905_EMPTY_CREDENTIAL'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Para la autenticaci\00F3n b\00E1sica, introduzca el nombre del usuario de base de datos. Para OAuth2, introduzca el ID de cliente. Esta informaci\00F3n no estar\00E1 cifrada. Los nombres de usuario de la autenticaci\00F3n b\00E1sica aparecer\00E1n en may\00FAsculas. Para incluir un')
||unistr(' nombre de usuario sensible a may\00FAsculas/min\00FAsculas, introduzca un signo de exclamaci\00F3n (!) como prefijo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(501159234880447965.4001)
,p_name=>'P4905_CLIENT_SECRET'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_prompt=>'Secreto del Cliente'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'nvl(:P4905_SERVER_ID,''0'') <> ''0'' and nvl(:P4905_EMPTY_CREDENTIAL,''N'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca la contrase\00F1a o el secreto del cliente OAuth2. Esta informaci\00F3n se almacena cifrada y no se puede recuperar en texto no cifrado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(508759940964208131.4001)
,p_name=>'P4905_ENDPOINT_URL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(48314023675949547.4001)
,p_prompt=>'URL de Punto Final'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Muestra la URL base para este servicio de SQL activado para REST.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11601005038734806.4001)
,p_validation_name=>'Validate Remote Server'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if nvl(:P4905_EMPTY_CREDENTIAL,''N'') = ''Y'' then',
'        wwv_flow_credential.set_session_credentials(',
'            p_credential_id => :P4905_CREDENTIAL_ID,',
'            p_client_id     => :P4905_CLIENT_ID,',
'            p_client_secret => :P4905_CLIENT_SECRET );',
'    end if;',
'    return wwv_flow_remote_deploy_dev.validate_deployment_server(p_server_id => :P4905_SERVER_ID);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(3002260983503401.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3011039171503427.4001)
,p_name=>'Submit page'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3002260983503401.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3011586047503428.4001)
,p_event_id=>wwv_flow_api.id(3011039171503427.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(271597099581112730.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select base_url, credential_name, authentication_type, client_id, ',
'           decode(client_id,null,''Y'',''N'') empty_credential, credential_id',
'      into :P4905_ENDPOINT_URL, :P4905_CREDENTIAL_NAME, :P4905_CREDENTIAL_TYPE,',
'           :P4905_CLIENT_ID, :P4905_EMPTY_CREDENTIAL, :P4905_CREDENTIAL_ID',
'      from wwv_remotesql_servers_dev ',
'     where id = :P4905_SERVER_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4905_SERVER_ID'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/pages/page_04906
begin
wwv_flow_api.create_page(
 p_id=>4906.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Opciones de despliegue remoto'
,p_step_title=>'Opciones de despliegue remoto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_inline_css=>'.a-Region .a-Region-title {font-weight: 600;}'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2701833594358317.4001)
,p_plug_name=>'Sustituciones de despliegue'
,p_region_css_classes=>'margin-top-md margin-bottom-lg'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3300547964231734.4001)
,p_plug_name=>unistr('Desplegar aplicaci\00F3n')
,p_region_css_classes=>'margin-top-lg'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_source=>' '
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50246390315203481.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(197597352626318639.4001)
,p_plug_name=>unistr('Preferencias de Exportaci\00F3n')
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4801045459171794.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(50246390315203481.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4801476496171795.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(50246390315203481.4001)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Ayuda'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL./htmdb/importing-export-files.html'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4801850489171795.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(50246390315203481.4001)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Desplegar'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4802242863171795.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(50246390315203481.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4905:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3328579702728517.4001)
,p_branch_name=>'Go To Page 4906'
,p_branch_action=>'f?p=&APP_ID.:4907:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4801850489171795.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3328989556728518.4001)
,p_branch_action=>'f?p=&FLOW_ID.:4906:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2702648440358325.4001)
,p_name=>'P4906_WORKSPACE_OVERRIDE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_prompt=>unistr('Sustituci\00F3n&nbsp;de espacio de trabajo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value d, x.column_value r',
'  from table(wwv_flow_remote_deploy_dev.get_workspaces(p_server_id=>:P4905_SERVER_ID)) x'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el espacio de trabajo en el que se debe desplegar la aplicaci\00F3n en la lista. Si esta no tiene entradas, el usuario de base de datos asociado a la conexi\00F3n SQL activada para REST no se asignar\00E1 a ning\00FAn espacio de trabajo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2702738661358326.4001)
,p_name=>'P4906_RESPONSE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2702891819358327.4001)
,p_name=>'P4906_OVERWRITE_APP'
,p_item_sequence=>62
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Sobrescribir aplicaci\00F3n existente')
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si desea sobrescribir la aplicaci\00F3n en el sistema de destino. Las opciones disponibles son:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong>: la aplicaci\00F3n se desplegar\00E1 con el mismo ID que esta aplicaci\00F3n y se sobrescribir\00E1n en el sistema de destino.</li>'),
unistr('<li><strong>Desactivado</strong>: debe especificar el ID de aplicaci\00F3n para el sistema de destino.</li>'),
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2703331270358332.4001)
,p_name=>'P4906_ALIAS_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_item_default=>'select alias from wwv_flows where id = :FB_FLOW_ID'
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>unistr('Sustituci\00F3n de alias de aplicaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nuevo ID de aplicaci\00F3n alfanum\00E9rico alternativo. Puede utilizar este ID en lugar del ID de aplicaci\00F3n. El valor se define por defecto como el alias de aplicaci\00F3n de la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2703481285358333.4001)
,p_name=>'P4906_KEEP_SESSIONS'
,p_item_sequence=>63
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_item_default=>'Y'
,p_prompt=>'Mantener sesiones'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si desea que se mantengan las sesiones al sobrescribir la aplicaci\00F3n en el sistema de destino. Las opciones disponibles son:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> mantiene las sesiones asociadas a la aplicaci\00F3n que se va a sobrescribir en el sistema de destino.</li>'),
unistr('<li><strong>Desactivado</strong> no mantiene las sesiones asociadas a la aplicaci\00F3n que se va a sobrescribir en el sistema de destino.</li>'),
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3301408187728455.4001)
,p_name=>'P4906_SELECTED_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3300547964231734.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n Seleccionada:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la aplicaci\00F3n seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3302340904728460.4001)
,p_name=>'P4906_PAGE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3300547964231734.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Recuento de p\00E1ginas:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(count(*),''999G999G999G990'') c',
'from wwv_flow_steps ',
'where flow_id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero de p\00E1ginas en la aplicaci\00F3n que est\00E1 seleccionada actualmente.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3303234454728462.4001)
,p_name=>'P4906_APPLICATION_SCHEMA'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(3300547964231734.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Propietario:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner ',
'from wwv_flows ',
'where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>unistr('Identifica al propietario del esquema de base de datos de la aplicaci\00F3n seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3304189616728462.4001)
,p_name=>'F4000_P4906_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(3300547964231734.4001)
,p_source=>'UNIX'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione un formato de archivo. Las opciones incluyen:',
'<ul>',
unistr('<li>Seleccione <strong>DOS</strong> para que las l\00EDneas del archivo resultante terminen con retornos de carro y saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>UNIX</strong> para que las l\00EDneas del archivo resultante terminen con saltos de l\00EDnea.</li>'),
unistr('<li>Seleccione <strong>Base de Datos</strong> para que, en lugar de descargarse, el archivo resultante se guarde en el repositorio de exportaci\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'unix=chr(10),dos=chr(13)||chr(10) after each row'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3305021371728465.4001)
,p_name=>'F4000_P4906_OWNER_OVERRIDE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_prompt=>unistr('Sustituci\00F3n&nbsp;de&nbsp;Usuario')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value d, x.column_value r',
'  from table (wwv_flow_remote_deploy_dev.get_schemas(p_server_id=>:P4905_SERVER_ID)) x'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Utilice este atributo para importar la aplicaci\00F3n en los esquemas disponibles definidos por su conexi\00F3n SQL activada para REST. Si no hay entradas que seleccionar, la conexi\00F3n no se asignar\00E1 a ning\00FAn espacio de trabajo y no se podr\00E1 desplegar la apli')
||unistr('caci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3305971648728467.4001)
,p_name=>'F4000_P4906_SET_RUN_ONLY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3300547964231734.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>unistr('Sustituci\00F3n&nbsp;de&nbsp;Estado&nbsp;de&nbsp;Creaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_api.id(84305510710571518.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el estado de creaci\00F3n de la aplicaci\00F3n exportada. Las opciones incluyen:<br>'),
unistr('<ul><li><strong>Solo Ejecutar Aplicaci\00F3n</strong>: los usuarios solo pueden ejecutar la aplicaci\00F3n. Esta opci\00F3n est\00E1 destinada a aplicaciones de una instancia de producci\00F3n.</li>'),
unistr('<li><strong>Ejecutar y Crear Aplicaci\00F3n</strong>: los desarrolladores y usuarios pueden ejecutar y desarrollar la aplicaci\00F3n.</li>'),
'</ul></p>',
unistr('<p>Nota: Este ajuste se puede cambiar al importar mediante la interfaz web de &PRODUCT_NAME. pero no a trav\00E9s de la interfaz de l\00EDnea de comandos.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3307776924728470.4001)
,p_name=>'P4906_FLASHBK_FLOW_AS_OF'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3300547964231734.4001)
,p_prompt=>'A partir de'
,p_post_element_text=>'<span class="fielddata">minutos antes (~ 5 minutos de retraso)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_display_when=>'F4000_P4906_FORMAT'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div class="htmldbInfoBodyP">Especifique un tiempo en minutos para volver atr\00E1s en la exportaci\00F3n. Esta opci\00F3n permite volver en el tiempo en la aplicaci\00F3n, quiz\00E1s para recuperar un objeto suprimido.</div>'),
'',
unistr('<div class="htmldbInfoBodyP">Esta utilidad utiliza el <code>paquete dbms_flashback</code>. La asignaci\00F3n de registro de hora a SCN (N\00FAmero de Cambio del Sistema) se refresca cada 5 minutos aproximadamente, por lo que tal vez tenga que esperar ese esp')
||unistr('acio de tiempo para obtener la versi\00F3n que est\00E1 buscando. El tiempo que se mantiene la informaci\00F3n de deshacer depende del par\00E1metro de inicio <code>undo_retention</code> (tres horas por defecto), pero esto s\00F3lo afecta al tama\00F1o del tablespace de des')
||'hacer.</div>',
unistr('<div class="htmldbInfoBodyP">Mientras que dos bases de datos pueden tener el mismo par\00E1metro <code>undo_retention</code>, puede volver atr\00E1s en el tiempo en la base de datos con menos transacciones, ya que las transacciones no est\00E1n rellenando el tab')
||unistr('lespace de deshacer, forzando as\00ED el archivado de los datos m\00E1s antiguos.</div>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3313097473728485.4001)
,p_name=>'P4906_EXP_DEPLOYMENT_METADATA'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(197597352626318639.4001)
,p_item_default=>'Y'
,p_prompt=>'Exportar Definiciones de Objeto de Soporte'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(388231942990864305.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si desea exportar las definiciones de objeto de soporte con la aplicaci\00F3n. Entre las opciones disponibles se incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>S\00ED</strong> incluye las definiciones de objeto de soporte en la exportaci\00F3n de la aplicaci\00F3n. No carga autom\00E1ticamente objetos de soporte cuando se llaman desde una l\00EDnea de comandos.'),
'</li>',
unistr('<li><strong>No</strong> no incluye las definiciones de objeto de soporte en la exportaci\00F3n.</li>'),
unistr('</li><strong>S\00ED e Instalar al Importar Autom\00E1ticamente</strong> incluye definiciones de objeto de soporte y una llamada para instalar los objetos de soporte en la exportaci\00F3n de la aplicaci\00F3n. Esta opci\00F3n solo es v\00E1lida para instalaciones de la l\00EDnea')
||unistr(' de comandos. Cuando la aplicaci\00F3n importa desde la l\00EDnea de comandos, instala o actualiza autom\00E1ticamente los objetos de soporte.'),
'</ul>',
'<p />',
unistr('Las definiciones de objeto de soporte incluyen todas las opciones de configuraci\00F3n y scripts y permiten que una exportaci\00F3n de aplicaci\00F3n incluya definiciones de objetos de base de datos, definiciones de im\00E1genes y sentencias SQL de datos iniciales e')
||'ncapsuladas en un solo archivo.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3313961472728487.4001)
,p_name=>'P4906_PUBLIC_REPORTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(197597352626318639.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Exportar Informes P\00FAblicos')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si va a incluir informes p\00FAblicos en la aplicaci\00F3n. Las opciones disponibles son:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye informes p\00FAblicos en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye informes p\00FAblicos en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Los informes p\00FAblicos son la configuraci\00F3n de los informes compartidos p\00FAblicos que han guardado los usuarios del informe interactivo o cuadr\00EDcula interactiva.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3314888068728487.4001)
,p_name=>'P4906_PRIVATE_REPORTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(197597352626318639.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar Informes Privados'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se van a incluir informes privados con la aplicaci\00F3n. Estas son las opciones disponibles:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye informes privados en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye informes privados en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Los informes privados son la configuraci\00F3n personalizada privada guardada por los usuarios a partir de un informe interactivo o una cuadr\00EDcula interactiva.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3315740386728488.4001)
,p_name=>'P4906_NOTIFICATIONS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(197597352626318639.4001)
,p_item_default=>'N'
,p_prompt=>'Exportar Suscripciones de Informe'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se va a incluir la configuraci\00F3n de suscripci\00F3n de informes interactivos o cuadr\00EDculas interactivas en la aplicaci\00F3n. Entre las opciones disponibles, se incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye suscripciones de informes para los informes que exporta en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye suscripciones de informes para los informes en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Esto se limita a la configuraci\00F3n de la suscripci\00F3n que no ha caducado de todos los usuarios de todos los informes interactivos o cuadr\00EDculas interactivas de la aplicaci\00F3n.'),
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3316658864728489.4001)
,p_name=>'P4906_EXPORT_COMMENTS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(197597352626318639.4001)
,p_item_default=>'Y'
,p_prompt=>'Exportar Comentarios del Desarrollador'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se incluyen comentarios del desarrollador en la exportaci\00F3n de la aplicaci\00F3n. Las opciones disponibles incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye comentarios del desarrollador en la exportaci\00F3n de la aplicaci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye comentarios del desarrollador en la exportaci\00F3n.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3317553743728490.4001)
,p_name=>'P4906_EXPORT_TRANSLATIONS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(197597352626318639.4001)
,p_item_default=>'Y'
,p_prompt=>'Exportar Traducciones'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se van a incluir traducciones con la exportaci\00F3n de la aplicaci\00F3n. Las opciones disponibles incluyen:'),
'<p />',
'<ul>',
unistr('<li><strong>Activado</strong> incluye las asignaciones de traducci\00F3n y todo el texto del repositorio de traducci\00F3n.</li>'),
unistr('<li><strong>Desactivado</strong> no incluye asignaciones de traducci\00F3n ni el repositorio de traducci\00F3n.</li>'),
'</ul>',
'<p />',
unistr('Los mensajes de texto de traducci\00F3n y las traducciones din\00E1micas se incluir\00E1n siempre en la exportaci\00F3n de la aplicaci\00F3n.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(11007638655042202.4001)
,p_name=>'P4906_ID_OVERRIDE'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(2701833594358317.4001)
,p_prompt=>unistr('Sustituci\00F3n de ID de aplicaci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique un nuevo ID de aplicaci\00F3n en el sistema de destino.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3320987612728502.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FB_EXPORT_FLOW_ID.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(3321307553728502.4001)
,p_computation_sequence=>20
,p_computation_item=>'FB_FB_EXPORT_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FLOW_ID.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3321737659728503.4001)
,p_validation_name=>'P4906_FLASHBK_FLOW_AS_OF is numeric'
,p_validation_sequence=>10
,p_validation=>'P4906_FLASHBK_FLOW_AS_OF'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('"A partir de" debe ser num\00E9rico.')
,p_validation_condition=>':P4906_FLASHBK_FLOW_AS_OF is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4801850489171795.4001)
,p_associated_item=>wwv_flow_api.id(3307776924728470.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2704968014358348.4001)
,p_validation_name=>'ID is numeric'
,p_validation_sequence=>20
,p_validation=>'P4906_ID_OVERRIDE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La sustituci\00F3n de ID de aplicaci\00F3n debe ser num\00E9rica.')
,p_validation_condition=>'nvl(:P4906_OVERWRITE_APP,''N'') = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4801850489171795.4001)
,p_associated_item=>wwv_flow_api.id(11007638655042202.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11600713382734803.4001)
,p_validation_name=>'ID not null'
,p_validation_sequence=>30
,p_validation=>'P4906_ID_OVERRIDE'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>unistr('Se debe especificar la sustituci\00F3n del ID de aplicaci\00F3n.')
,p_validation_condition=>'nvl(:P4906_OVERWRITE_APP,''N'') = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4801850489171795.4001)
,p_associated_item=>wwv_flow_api.id(11007638655042202.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11600850475734804.4001)
,p_validation_name=>'OWNER not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P4906_OWNER_OVERRIDE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Seleccione un propietario para la aplicaci\00F3n.')
,p_associated_item=>wwv_flow_api.id(3305021371728465.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11600986283734805.4001)
,p_validation_name=>'Workspace not null'
,p_validation_sequence=>50
,p_validation=>'P4906_WORKSPACE_OVERRIDE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Seleccione un espacio de trabajo.'
,p_associated_item=>wwv_flow_api.id(2702648440358325.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11600611005734802.4001)
,p_validation_name=>'Validate Alias'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_remote_deploy_dev.is_valid_alias(',
'    p_server_id => :P4905_SERVER_ID,',
'    p_alias     => :P4906_ALIAS_OVERRIDE);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Este alias ya existe en el espacio de trabajo &P4906_WORKSPACE_OVERRIDE..'
,p_validation_condition=>'nvl(:P4906_OVERWRITE_APP,''N'') = ''N'' and :P4906_ALIAS_OVERRIDE is not null and :F4000_P4906_OWNER_OVERRIDE is not null and :P4906_WORKSPACE_OVERRIDE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4801850489171795.4001)
,p_associated_item=>wwv_flow_api.id(2703331270358332.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(11601192824734807.4001)
,p_validation_name=>'Validate app id'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_app_id varchar2(30);',
'begin',
'    if nvl(:P4906_OVERWRITE_APP,''N'') = ''N'' then',
'        l_app_id := :P4906_ID_OVERRIDE;',
'    else',
'        l_app_id := :FB_FLOW_ID;',
'    end if;',
'    ',
'    return wwv_flow_remote_deploy_dev.is_valid_app_id(',
'               p_server_id => :P4905_SERVER_ID,',
'               p_app_id    => l_app_id,',
'               p_workspace => :P4906_WORKSPACE_OVERRIDE);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(4801850489171795.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3323286651728507.4001)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'FB_FB_EXPORT_FLOW_ID'
,p_condition_element=>'FB_FB_EXPORT_FLOW_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3323618716728510.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_SELECTED_APPLICATION'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_ret   varchar2(255);',
'begin',
'  select name into l_ret',
'    from wwv_flows ',
'    where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'  return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3324111688728511.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3300547964231734.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3324621745728512.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_PAGE_COUNT'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ret   varchar2(255);',
'begin',
'select to_char(count(*),''999G999G999G990'') c into l_ret',
'from wwv_flow_steps ',
'where flow_id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3325166974728512.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(197597352626318639.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3325673042728513.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_APPLICATION_SCHEMA'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret varchar2(255);',
'begin',
'   select owner into l_ret',
'from wwv_flows ',
'where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3326142166728513.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3300547964231734.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3326687319728514.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(197597352626318639.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3327184141728515.4001)
,p_event_id=>wwv_flow_api.id(3323286651728507.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :FB_FLOW_ID := :FB_FB_EXPORT_FLOW_ID;',
'end;'))
,p_attribute_02=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2704050985358339.4001)
,p_name=>'Submit Page'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(4801850489171795.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2704184957358340.4001)
,p_event_id=>wwv_flow_api.id(2704050985358339.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(11008096182042206.4001)
,p_name=>'Toggle Items'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4906_OVERWRITE_APP'
,p_condition_element=>'P4906_OVERWRITE_APP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(11008150093042207.4001)
,p_event_id=>wwv_flow_api.id(11008096182042206.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_KEEP_SESSIONS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(11600541271734801.4001)
,p_event_id=>wwv_flow_api.id(11008096182042206.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_ID_OVERRIDE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2705170735358350.4001)
,p_event_id=>wwv_flow_api.id(11008096182042206.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_ID_OVERRIDE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(11008277459042208.4001)
,p_event_id=>wwv_flow_api.id(11008096182042206.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_KEEP_SESSIONS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3322864568728505.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FB_EXPORT_FLOW_ID or :FB_FB_EXPORT_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FB_EXPORT_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :FB_FB_EXPORT_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3322481540728504.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deploy App Remotely'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_remote_deploy_dev.deploy (',
'    p_application_id            => :FB_FB_EXPORT_FLOW_ID,',
'    p_server_id                 => :P4905_SERVER_ID,',
'    p_owner_override            => :F4000_P4906_OWNER_OVERRIDE,',
'    p_workspace_override        => :P4906_WORKSPACE_OVERRIDE,',
'    p_app_id_override           => :P4906_ID_OVERRIDE,',
'    p_alias_override            => :P4906_ALIAS_OVERRIDE,',
'    p_overwrite_app             => :P4906_OVERWRITE_APP,',
'    p_keep_sessions             => nvl(:P4906_KEEP_SESSIONS,''N''),',
'    p_export_sup_objects        => :P4906_EXP_DEPLOYMENT_METADATA,',
'    p_export_comments           => nvl(:P4906_EXPORT_COMMENTS,''N''),',
'    p_export_ir_public_reports  => nvl(:P4906_PUBLIC_REPORTS,''N''),',
'    p_export_ir_private_reports => nvl(:P4906_PRIVATE_REPORTS,''N''),',
'    p_export_ir_notifications   => nvl(:P4906_NOTIFICATIONS,''N''),',
'    p_export_translations       => nvl(:P4906_EXPORT_TRANSLATIONS,''N''),',
'    p_build_status_override     => case',
'                                   when :F4000_P4906_SET_RUN_ONLY = ''RUN_ONLY'' then ''YES''',
'                                   else ''NO''',
'                                   end,',
'    p_flashback_min_ago         => :P4906_FLASHBK_FLOW_AS_OF);',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al desplegar de forma remota la aplicaci\00F3n &FB_FB_EXPORT_FLOW_ID.. #SQLERRM#')
,p_process_when_button_id=>wwv_flow_api.id(4801850489171795.4001)
,p_process_success_message=>unistr('La aplicaci\00F3n &FB_FB_EXPORT_FLOW_ID. se ha desplegado de forma remota.')
);
end;
/
prompt --application/pages/page_04907
begin
wwv_flow_api.create_page(
 p_id=>4907.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Despliegue remoto correcto'
,p_step_title=>'Despliegue remoto correcto'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213300727323081712)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229957875453617761.4001)
,p_plug_name=>unistr('Aplicaci\00F3n desplegada de forma remota')
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P4906_OVERWRITE_APP,''N'') = ''Y'' then',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''APEX.REMOTEDEPLOY.SUCCESS'', :FB_FLOW_ID ) || ''</p>'' );',
'else',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''APEX.REMOTEDEPLOY.SUCCESS2'', :FB_FLOW_ID, :P4906_ID_OVERRIDE ) || ''</p>'' );',
'end if;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(229958372944635937.4001)
,p_plug_name=>'app success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10765277646068677.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(229958372944635937.4001)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Editar Aplicaci\00F3n')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10770719760068691.4001)
,p_branch_action=>'f?p=&FB_FLOW_ID.:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'RUN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10771519710068692.4001)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'VIEW'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(10771123657068691.4001)
,p_branch_action=>'f?p=4000:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT'
,p_save_state_before_branch_yn=>'Y'
);
end;
/
prompt --application/pages/page_04910
begin
wwv_flow_api.create_page(
 p_id=>4910.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Opciones de Creaci\00F3n')
,p_step_title=>unistr('Opciones de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(299056867.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--padded:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las opciones de creaci\00F3n permiten a los desarrolladores activar y desactivar los componentes y la funcionalidad de la aplicaci\00F3n condicionalmente si la aplicaci\00F3n est\00E1 instalada o en tiempo de ejecuci\00F3n mediante las API <code>GET_BUILD_OPTION_STAT')
||'US</code> y <code>SET_BUILD_OPTION_STATUS</code>.</p>',
unistr('<p>Puede aplicar las opciones de creaci\00F3n a la mayor\00EDa de los componentes (como p\00E1ginas, regiones, elementos, validaciones, etc.) para incluirlos o excluirlos de la aplicaci\00F3n en tiempo de ejecuci\00F3n:</p>'),
unistr('<p><strong>Incluir</strong>: los componentes est\00E1n activados y forman parte de la aplicaci\00F3n.</p>'),
unistr('<p><strong>Excluir</strong>: los componentes est\00E1n desactivados y no forman parte de la aplicaci\00F3n.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/using-build-options-to-control-configuration.html">M\00E1s informaci\00F3n...</a></p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3738622552051132.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   flow_id, ',
'   patch_name,',
'   replace(patch_name,''_'','' '') build_option_name,',
'   wwv_flow_lang.system_message(patch_status) as patch_status,',
'   on_upgrade_keep_status,',
'   substr(patch_comment,1,500) patch_comment, ',
'   id,',
'   decode(patch_status,',
'          ''EXCLUDE'', ''u-danger-text'',',
'          ''u-success-text'') as patch_class,',
'   decode (patch_status,',
'      ''EXCLUDE'',''icon-sc-build-option-off u-danger-text'',',
'      ''icon-sc-build-option-on u-success-text'') img,',
'   replace(patch_name,''_'', '' '') alt,',
'   ''f?p=4000:4911:''||:FLOW_SESSION||''::NO::F4000_P4911_ID:''||ID link,',
'   LAST_UPDATED_BY updated_by,',
'   LAST_UPDATED_ON updated,',
'   created_by,',
'   created_on created,',
'   (select count(*)',
'       from wwv_flow_steps s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) pages,',
'   (select count(*)',
'       from wwv_flow_step_items s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_items, ',
'   (select count(*)',
'       from wwv_flow_step_buttons s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_buttons,',
'   (select count(*)',
'       from WWV_FLOW_STEP_BRANCHES s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_branches,',
'   (select count(*)',
'       from WWV_FLOW_STEP_COMPUTATIONS s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_computations,',
'   (select count(*)',
'       from WWV_FLOW_STEP_PROCESSING s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_processes,',
'   (select count(*)',
'       from WWV_FLOW_STEP_VALIDATIONS s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_validations,',
'   (select count(*)',
'      from wwv_flow_page_da_events s',
'     where s.flow_id = :fb_flow_id and',
'           s.security_group_id = :flow_security_group_id and',
'           b.id = s.REQUIRED_PATCH) page_dynamic_actions,',
'   (select count(*)',
'      from wwv_flow_page_da_actions s',
'     where s.flow_id = :fb_flow_id and',
'           s.security_group_id = :flow_security_group_id and',
'           b.id = s.build_option_id) page_dynamic_action_actions,',
'   (select count(*) ',
'       from wwv_flow_card_actions a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) page_card_actions,',
'   wwv_flow_lang.system_message(nvl(DEFAULT_ON_EXPORT,patch_status)) DEFAULT_ON_EXPORT,',
'   FEATURE_IDENTIFIER',
'from   WWV_FLOW_PATCHES b',
'where  flow_id = :FB_FLOW_ID and',
'       security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3738700462051133.4001)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se han definido opciones de creaci\00F3n para esta aplicaci\00F3n')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#PATCH_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739013673051137.4001)
,p_db_column_name=>'PATCH_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:4911:F4000_P4911_ID:#ID#'
,p_column_linktext=>'#PATCH_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3738902120051137.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739129869051137.4001)
,p_db_column_name=>'PATCH_STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Estado'
,p_column_html_expression=>'<span class="#PATCH_CLASS#">#PATCH_STATUS#</span>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(337328430321153006.4001)
,p_db_column_name=>'ON_UPGRADE_KEEP_STATUS'
,p_display_order=>13
,p_column_identifier=>'W'
,p_column_label=>'Mantener Estado al Actualizar'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739223534051138.4001)
,p_db_column_name=>'PATCH_COMMENT'
,p_display_order=>23
,p_column_identifier=>'D'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739312786051138.4001)
,p_db_column_name=>'ID'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739430626051138.4001)
,p_db_column_name=>'IMG'
,p_display_order=>43
,p_column_identifier=>'F'
,p_column_label=>'Imagen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739511995051138.4001)
,p_db_column_name=>'ALT'
,p_display_order=>53
,p_column_identifier=>'G'
,p_column_label=>'Alternativo'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739626916051139.4001)
,p_db_column_name=>'LINK'
,p_display_order=>63
,p_column_identifier=>'H'
,p_column_label=>'Enlace'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739718316051139.4001)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>73
,p_column_identifier=>'I'
,p_column_label=>'Actualizado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3739815957051139.4001)
,p_db_column_name=>'UPDATED'
,p_display_order=>83
,p_column_identifier=>'J'
,p_column_label=>'Actualizado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3742107609149600.4001)
,p_db_column_name=>'BUILD_OPTION_NAME'
,p_display_order=>93
,p_column_identifier=>'K'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3742830512184595.4001)
,p_db_column_name=>'PAGES'
,p_display_order=>103
,p_column_identifier=>'L'
,p_column_label=>unistr('P\00E1ginas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3742929557184595.4001)
,p_db_column_name=>'PAGE_ITEMS'
,p_display_order=>113
,p_column_identifier=>'M'
,p_column_label=>unistr('Elementos de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3743004257184596.4001)
,p_db_column_name=>'PAGE_BUTTONS'
,p_display_order=>123
,p_column_identifier=>'N'
,p_column_label=>unistr('Botones de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3743901469204578.4001)
,p_db_column_name=>'PAGE_BRANCHES'
,p_display_order=>133
,p_column_identifier=>'O'
,p_column_label=>unistr('Bifurcaciones de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3744019193204578.4001)
,p_db_column_name=>'PAGE_COMPUTATIONS'
,p_display_order=>143
,p_column_identifier=>'P'
,p_column_label=>unistr('C\00E1lculos de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3744111943204578.4001)
,p_db_column_name=>'PAGE_PROCESSES'
,p_display_order=>153
,p_column_identifier=>'Q'
,p_column_label=>unistr('Procesos de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3744222625204579.4001)
,p_db_column_name=>'PAGE_VALIDATIONS'
,p_display_order=>163
,p_column_identifier=>'R'
,p_column_label=>unistr('Validaciones de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(196342407305337777.4001)
,p_db_column_name=>'PAGE_DYNAMIC_ACTIONS'
,p_display_order=>173
,p_column_identifier=>'U'
,p_column_label=>unistr('Acciones Din\00E1micas de P\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1569137845713222.4001)
,p_db_column_name=>'PAGE_DYNAMIC_ACTION_ACTIONS'
,p_display_order=>183
,p_column_identifier=>'AB'
,p_column_label=>unistr('Acci\00F3n din\00E1mica de p\00E1gina: acciones')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47907532686539828.4001)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>193
,p_column_identifier=>'S'
,p_column_label=>'Creado por'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(47907617818539829.4001)
,p_db_column_name=>'CREATED'
,p_display_order=>203
,p_column_identifier=>'T'
,p_column_label=>'Creado'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176251254950916912.4001)
,p_db_column_name=>'DEFAULT_ON_EXPORT'
,p_display_order=>223
,p_column_identifier=>'X'
,p_column_label=>unistr('Valor por Defecto en la Exportaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(176251348847916913.4001)
,p_db_column_name=>'FEATURE_IDENTIFIER'
,p_display_order=>233
,p_column_identifier=>'Y'
,p_column_label=>unistr('Identificador de funci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(222860555034540033.4001)
,p_db_column_name=>'PATCH_CLASS'
,p_display_order=>243
,p_column_identifier=>'Z'
,p_column_label=>'Parche CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1512041137491412.4001)
,p_db_column_name=>'PAGE_CARD_ACTIONS'
,p_display_order=>253
,p_column_identifier=>'AA'
,p_column_label=>unistr('Acciones de tarjeta de p\00E1gina')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47910018534564133.4001)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(47909111131552473.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188926110828413443.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(3738622552051132.4001)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Restablecer'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:4910,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(10080222113732957.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(3738622552051132.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:4911::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7641161832.4001)
,p_branch_action=>'4910'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(7642161833.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4911_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(146376031581502626.4001)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4910'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_04911
begin
wwv_flow_api.create_page(
 p_id=>4911.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear/Editar: Opciones de Creaci\00F3n')
,p_step_title=>unistr('Crear/Editar: Opci\00F3n de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213481614528579568)
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(439547742.4001)
,p_plug_name=>'Atributos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(52412001060114527.4001)
,p_name=>'Componentes Asociados'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''F4000.PAGE'') component, ',
'       c.name component_name, ',
'       p.PATCH_NAME build_option,',
'       c.id page_number',
'from wwv_flow_steps c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_COMPUTATION'') component, ',
'       c.COMPUTATION_ITEM component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_computations c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.P203.PROCESSING'') component, ',
'       c.PROCESS_NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_processing c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.P203.ICONBAR'') component, ',
'       c.ICON_IMAGE||'' - ''||ICON_SUBTEXT component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from WWV_FLOW_ICON_BAR c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.LIST_INITCAP'') component, ',
'       c.NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_lists c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.LIST_ITEM'') component, ',
'       c.LIST_ITEM_LINK_TEXT component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from WWV_FLOW_LIST_ITEMS c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.P203.LOVDATA'') component, ',
'       c.LOV_DISP_VALUE component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_list_of_values_data c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.P203.PGTEMP'') component, ',
'       c.name component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_templates c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID      ',
'union all',
'select wwv_flow_lang.system_message(''F4000.P203.CONCATENATED_FILE'') component, ',
'       c.combined_file_url component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_combined_files c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID ',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_REGION'') component, ',
'       c.plug_name component_name, ',
'       p.PATCH_NAME build_option,',
'       c.page_id page_number',
'from wwv_flow_page_plugs c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID ',
'union all',
'select wwv_flow_lang.system_message(''F4000.REGION_COLUMNS'') component, ',
'       c.name component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_region_columns c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID ',
'union all',
'select wwv_flow_lang.system_message(''F4000.REGION_COLUMNS'') component, ',
'       c.column_heading component_name, ',
'       p.PATCH_NAME build_option,',
'       (select PAGE_ID from wwv_flow_page_plugs x where x.id = c.REGION_ID) page_number',
'from wwv_flow_region_report_column c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID       ',
'union all',
'select wwv_flow_lang.system_message(''F4000.REGION_COLUMNS'') component, ',
'       c.column_label component_name, ',
'       p.PATCH_NAME build_option,',
'       c.page_id page_number',
'from wwv_flow_worksheet_columns c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID  ',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_BUTTON'') component, ',
'       c.BUTTON_NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       c.flow_step_id page_number',
'from WWV_FLOW_STEP_BUTTONS c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') component, ',
'       c.NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       c.flow_step_id page_number',
'from WWV_FLOW_STEP_ITEMS c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID      ',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_COMPUTATION'') component, ',
'       c.COMPUTATION_ITEM component_name, ',
'       p.PATCH_NAME build_option,',
'       c.FLOW_STEP_ID page_number',
'from wwv_flow_step_computations c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID         ',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_PROCESS'') component, ',
'       c.process_name component_name, ',
'       p.PATCH_NAME build_option,',
'       c.FLOW_STEP_ID page_number',
'from wwv_flow_step_processing c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID        ',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_VALIDATION'') component, ',
'       c.validation_name component_name, ',
'       p.PATCH_NAME build_option,',
'       c.FLOW_STEP_ID page_number',
'from wwv_flow_step_validations c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.P203.PAGEBRANCH'') component, ',
'       c.branch_name component_name, ',
'       p.PATCH_NAME build_option,',
'       c.FLOW_STEP_ID page_number',
'from wwv_flow_step_branches c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_DYNAMIC_ACTION'') component, ',
'       c.name component_name, ',
'       p.PATCH_NAME build_option,',
'       c.page_ID page_number',
'from wwv_flow_page_da_events c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID ',
'union all',
'select wwv_flow_lang.system_message(''F4000.PAGE_DYNAMIC_ACTION_ACTION'') component, ',
'       case substr(c.action, 1, 7)',
'       when ''NATIVE_'' then',
'           ( select display_name from wwv_flow_plugins where flow_id = 4411 and plugin_type = ''DYNAMIC ACTION'' and name = substr(c.action, 8) )',
'       when ''PLUGIN_'' then',
'           ( select display_name from wwv_flow_plugins where flow_id = c.flow_id and plugin_type = ''DYNAMIC ACTION'' and name = substr(c.action, 8) )',
'       else c.action',
'       end || '' ('' || e.name || '')'' component_name,',
'       p.patch_name build_option,',
'       c.page_id page_number',
'from wwv_flow_page_da_actions c, WWV_FLOW_PATCHES p, wwv_flow_page_da_events e',
'where p.id              = c.build_option_id and',
'      c.flow_id         = :FB_FLOW_ID and',
'      c.build_option_id = :F4000_P4911_ID and',
'      e.id              = c.event_id',
'union all',
'select wwv_flow_lang.system_message(''CHART_SERIES'')||'' - JET'' component, ',
'       c.name component_name, ',
'       p.PATCH_NAME build_option,',
'       PAGE_ID page_number',
'from wwv_flow_jet_chart_series c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID      ',
'union all',
'select wwv_flow_lang.system_message(''CONFIRM.TABS'') component, ',
'       c.TAB_NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from WWV_FLOW_TABS c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID   ',
'union all',
'select wwv_flow_lang.system_message(''LAYOUT.T_PARENT_TAB'') component, ',
'       c.TAB_NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from WWV_FLOW_TOPLEVEL_TABS c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID ',
'union all',
'select wwv_flow_lang.system_message(''APPLICATION_SETTINGS'') component, ',
'       c.NAME component_name, ',
'       p.PATCH_NAME build_option,',
'       null page_number',
'from wwv_flow_app_settings c, WWV_FLOW_PATCHES p',
'where p.id = c.required_patch and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.required_patch = :F4000_P4911_ID',
'union all',
'select wwv_flow_lang.system_message(''CARD_ACTIONS'') component, ',
'       a.action_type component_name, ',
'       p.PATCH_NAME build_option,',
'       a.page_id page_number',
'from wwv_flow_card_actions a, WWV_FLOW_PATCHES p',
'where p.id = a.build_option_id and',
'      a.flow_id = :FB_FLOW_ID and',
'      a.build_option_id = :F4000_P4911_ID ',
''))
,p_display_when_condition=>'F4000_P4911_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(710588709092275240.4001)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Componente'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(710588829823275241.4001)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre del Componente'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(710589025159275243.4001)
,p_query_column_id=>3
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>3
,p_column_heading=>unistr('Opci\00F3n de Creaci\00F3n')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(710589252544275245.4001)
,p_query_column_id=>4
,p_column_alias=>'PAGE_NUMBER'
,p_column_display_sequence=>4
,p_column_heading=>unistr('N\00FAmero de P\00E1gina')
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179892122974870284.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Utilice las opciones de creaci\00F3n para activar o desactivar la funcionalidad en una aplicaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(615517525809264669.4001)
,p_plug_name=>unistr('Opci\00F3n de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617435907459619299.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_api.id(29434107863295859.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PATCHES ',
'where id = :F4000_P4911_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id                 => :F4000_P4911_ID,',
'      p_component_type     => ''Region'',',
'      p_last_updated_by    => c1.last_updated_by,',
'      p_last_updated_on    => c1.last_updated_on,',
'      p_created_by         => c1.created_by,',
'      p_created_on         => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4911_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(690213637713382241.4001)
,p_plug_name=>'Anclaje'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(54178613300055452.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(52412001060114527.4001)
,p_button_name=>'REMOVE_COMPONENTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary:a-Button--gapRight:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Eliminar componentes'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:232:&SESSION.::&DEBUG.:RP,232:F4000_P232_ID:&F4000_P4911_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7622161824.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(615517525809264669.4001)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7623161824.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(615517525809264669.4001)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:235:&SESSION.::&DEBUG.:RP,235:F4000_P235_ID:&F4000_P4911_ID.'
,p_button_condition=>'v(''F4000_P4911_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7624161824.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(615517525809264669.4001)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'v(''F4000_P4911_ID'') is not null'
,p_button_condition2=>'SQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(7625161824.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(615517525809264669.4001)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Crear Opci\00F3n de Creaci\00F3n')
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4911_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7626161825.4001)
,p_branch_action=>'4910'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'',''Update'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7627161825.4001)
,p_branch_action=>'4911'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(7628161825.4001)
,p_branch_action=>'4910'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7629161827.4001)
,p_name=>'F4000_P4911_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7630161828.4001)
,p_name=>'F4000_P4911_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>unistr('Aplicaci\00F3n')
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica la aplicaci\00F3n a la que se aplica esta opci\00F3n de creaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7631161828.4001)
,p_name=>'F4000_P4911_PATCH_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'PATCH_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Introduzca un nombre descriptivo para esta opci\00F3n de creaci\00F3n. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7632161828.4001)
,p_name=>'F4000_P4911_PATCH_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'EXCLUDE'
,p_prompt=>'Estado'
,p_source=>'PATCH_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'INCLUDE_EXCLUDE'
,p_lov=>'.'||wwv_flow_api.id(84357332667662999.4001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccionar un estado:',
'<ul>',
unistr('<li><strong>Incluir</strong>: utilizar esta funci\00F3n.'),
unistr('<li><strong>Excluir</strong>: no utilizar ning\00FAn atributo marcado con esta opci\00F3n de creaci\00F3n.'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7633161829.4001)
,p_name=>'F4000_P4911_PATCH_COMMENT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comentarios'
,p_source=>'PATCH_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Introduzca comentarios o notas. Estos comentarios no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(99780102618637453.4001)
,p_name=>'F4000_P4911_DEFAULT_ON_EXPORT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Valor por Defecto en la Exportaci\00F3n')
,p_source=>'DEFAULT_ON_EXPORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'INCLUDE_EXCLUDE'
,p_lov=>'.'||wwv_flow_api.id(84357332667662999.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Igual que el Estado Actual -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>unistr('Cuando se exporte esta aplicaci\00F3n, defina la opci\00F3n de creaci\00F3n en este valor.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(837441767383841428.4001)
,p_name=>'P4911_ON_UPGRADE_KEEP_STATUS'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(439547742.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Mantener Estado al Actualizar'
,p_source=>'ON_UPGRADE_KEEP_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione si el estado de la opci\00F3n de creaci\00F3n en la aplicaci\00F3n desplegada se debe mantener o se debe sobrescribir con el estado especificado cuando se cambia la versi\00F3n de la aplicaci\00F3n. La selecci\00F3n de <strong>Activado</strong> para mantener el e')
||unistr('stado desplegado es \00FAtil si la aplicaci\00F3n soporta la configuraci\00F3n de la opci\00F3n de creaci\00F3n (a trav\00E9s de la API <code>APEX_UTIL.SET_BUILD_OPTION_STATUS</code>) para activar o desactivar la opci\00F3n de creaci\00F3n en la aplicaci\00F3n desplegada y all\00ED donde d')
||unistr('esee respetar esa configuraci\00F3n despu\00E9s del cambio de versi\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(51239426654464570.4001)
,p_validation_name=>'name not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4911_PATCH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Se debe especificar el nombre.'
,p_validation_condition=>'Create,Update'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(7631161828.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(231171031401226001.4001)
,p_validation_name=>'Name Unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
'where security_group_id = :flow_security_group_id ',
'and   flow_id = :FB_FLOW_ID ',
'and   id != nvl(:F4000_P4911_ID, -1)',
'and   patch_name = :F4000_P4911_PATCH_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('#LABEL# debe ser un valor \00FAnico.')
,p_associated_item=>wwv_flow_api.id(7631161828.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7634161830.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_PATCHES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_patches',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4911_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_PATCHES'',',
'  p_rowid       => v(''F4000_P4911_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al recuperar la fila.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7635161830.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_PATCHES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4911_ID is null',
'or exists (select 1 from wwv_flow_patches',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4911_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_PATCHES'',',
'p_rowid       => v(''F4000_P4911_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al procesar la acci\00F3n para la opci\00F3n de creaci\00F3n &F4000_P4911_PATCH_NAME..')
,p_process_success_message=>unistr('Acci\00F3n procesada para la opci\00F3n de creaci\00F3n &F4000_P4911_PATCH_NAME..')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(122460306888034212.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete cascade'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_steps set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_computations set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID; ',
'update wwv_flow_processing set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update WWV_FLOW_ICON_BAR set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_lists set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update WWV_FLOW_LIST_ITEMS set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_list_of_values_data set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_templates set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_combined_files set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_page_plugs set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update WWV_FLOW_STEP_BUTTONS set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update WWV_FLOW_STEP_ITEMS set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_page_da_events set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_page_da_actions set build_option_id = null where flow_id = :FB_FLOW_ID and abs(build_option_id) = :F4000_P4911_ID;',
'update wwv_flow_step_computations set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_step_processing set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_step_validations set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update wwv_flow_step_branches set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update WWV_FLOW_TABS set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;',
'update WWV_FLOW_TOPLEVEL_TABS set required_patch = null where flow_id = :FB_FLOW_ID and abs(required_patch) = :F4000_P4911_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(7623161824.4001)
);
end;
/
prompt --application/pages/page_05100
begin
wwv_flow_api.create_page(
 p_id=>5100.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Resumen: Atributos de P\00E1gina')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina de Resumen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214168830839927421)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8598000754817441.4001)
,p_plug_name=>unistr('Identificar Atributos de P\00E1gina')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Utilice este asistente para crear o ampliar una p\00E1gina de resumen. Las p\00E1ginas de resumen muestran una representaci\00F3n de s\00F3lo lectura de los elementos de otras p\00E1ginas y se utilizan normalmente en los asistentes de confirmaci\00F3n. Las p\00E1ginas de ori')
||unistr('gen son las p\00E1ginas que contienen elementos de s\00F3lo visualizaci\00F3n que aparecen en la p\00E1gina de resumen. Si ya existe una p\00E1gina de resumen, introduzca la p\00E1gina o selecci\00F3nela en la b\00FAsqueda emergente. Para crear una p\00E1gina de resumen nueva, introduz')
||unistr('ca una nueva p\00E1gina y especifique el nombre.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8781222616974433.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(8771208191950732.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204699818789801481.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8787124180988585.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204699818789801481.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8791617038995945.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204699818789801481.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(699461649385656036.4001)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(204699818789801481.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8792032586995947.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'5105'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(8791617038995945.4001)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12343123418191418.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(8791617038995945.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = false'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(122275014083513804.4001)
,p_branch_action=>'f?p=&APP_ID.:5100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P5100_BREADCRUMB_ID'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(699461747669657337.4001)
,p_branch_action=>'4700'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(699461649385656036.4001)
,p_branch_sequence=>160
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P362_OPT'
,p_branch_condition_text=>'R'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(7586415417512335.4001)
,p_name=>'F4000_P5100_PREV_SRC_PAGE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>'P5100 Prev Src Page Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8614626153866490.4001)
,p_name=>'F4000_P5100_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>unistr('N\00FAmero de P\00E1gina')
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :FB_FLOW_ID,',
'                                 p_page_id => :F4000_P5100_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nuevo n\00FAmero de p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8744303281892238.4001)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>unistr('Nombre de la P\00E1gina')
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P5100_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para una nueva p\00E1gina de resumen; el nombre de una p\00E1gina de resumen existente no cambiar\00E1.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8865915363144954.4001)
,p_name=>'F4000_P5100_SRC_PAGE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>unistr('P\00E1gina de Origen')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||wwv_flow_escape.html(name) n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar P\00E1gina -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la p\00E1gina que contiene elementos para que aparezcan en la p\00E1gina de resumen')
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(45246131772546431.4001)
,p_name=>'P5100_PAGE_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_item_default=>'NORMAL'
,p_prompt=>unistr('Modo de P\00E1gina')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_api.id(1497542689968615899.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_user_interface_id => :P259_USER_INTERFACE_ID,',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el modo de p\00E1gina, de acuerdo con las siguientes opciones: <p/>'),
'<ul>',
unistr('<li><strong>Normal</strong>: La p\00E1gina aparece como una p\00E1gina de aplicaci\00F3n de &PRODUCT_NAME. normal.</li>'),
unistr('<li><strong>Cuadro de di\00E1logo modal</strong>: La p\00E1gina aparece como un cuadro de di\00E1logo modal. Un cuadro de di\00E1logo modal es una ventana de superposici\00F3n situada en el viewport, que permanece activa y centrada hasta que el usuario final la cierra. ')
||unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que se cierra el cuadro de di\00E1logo.</li></ul>'),
'<br><p>',
unistr('Tenga en cuenta que la opci\00F3n Cuadro de di\00E1logo modal solo estar\00E1 disponible para seleccionarla cuando el tema de aplicaci\00F3n actual contenga al menos una plantilla de p\00E1gina del tipo <strong>P\00E1gina de cuadro de di\00E1logo</strong>.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122273620878506380.4001)
,p_name=>'P5100_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Ruta de Navegaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No agregar regiones de ruta de navegaci\00F3n a la p\00E1gina -')
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = false',
'and',
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si desea utilizar un control de navegaci\00F3n de ruta en la p\00E1gina y cu\00E1l es el que desea utilizar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(122277027155518222.4001)
,p_name=>'P5100_BREADCRUMB_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>'Nombre de Entrada'
,p_source=>'F4000_P5100_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el nombre de la entrada de la ruta de navegaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381730383902045547.4001)
,p_name=>'P5100_BREADCRUMB_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>'Entrada Principal'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P5100_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P5100_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Ninguna Entrada Principal'
,p_lov_cascade_parent_items=>'P5100_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403516230632685401.4001)
,p_name=>'P5100_GROUP_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8598000754817441.4001)
,p_prompt=>unistr('Grupo de P\00E1ginas')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Grupo de P\00E1ginas -')
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identifique el nombre del grupo de p\00E1ginas que desea asociar a esta p\00E1gina. Los grupos de p\00E1ginas ayudan a los desarrolladores a gestionar las p\00E1ginas en una aplicaci\00F3n. Para crear un grupo de p\00E1ginas, introduzca el nombre. Para utilizar un grupo de ')
||unistr('p\00E1ginas existente, seleccione el nombre de la lista de valores.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(10248518797082293.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P5105_SRC_REGION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1941058841116438792.4001)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P5100_PAGE_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(7631102078170839.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P5100_PREV_SRC_PAGE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':F4000_P5100_SRC_PAGE_ID'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(9118702944366261.4001)
,p_validation_name=>'SOURCE_PAGE_ID_NOT_NULL'
,p_validation_sequence=>1
,p_validation=>'F4000_P5100_SRC_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la p\00E1gina de origen.')
,p_associated_item=>wwv_flow_api.id(8865915363144954.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144944129193057216.4001)
,p_validation_name=>'F4000_P5100_PAGE_ID  positive, whole number'
,p_validation_sequence=>1
,p_validation=>'F4000_P5100_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>unistr('El n\00FAmero de p\00E1gina debe ser un n\00FAmero entero y positivo.')
,p_when_button_pressed=>wwv_flow_api.id(8791617038995945.4001)
,p_associated_item=>wwv_flow_api.id(8614626153866490.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 05-AUG-2003 09:52'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144944325332057220.4001)
,p_validation_name=>'F4000_P5100_PAGE_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'F4000_P5100_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de la p\00E1gina de resumen.')
,p_associated_item=>wwv_flow_api.id(8744303281892238.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 05-AUG-2003 09:52'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(45246628321548010.4001)
,p_validation_name=>'P5100_PAGE_MODE Not Null'
,p_validation_sequence=>3
,p_validation=>'P5100_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el modo de p\00E1gina.')
,p_when_button_pressed=>wwv_flow_api.id(8791617038995945.4001)
,p_associated_item=>wwv_flow_api.id(45246131772546431.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(70475623184954674.4001)
,p_validation_name=>'has_items'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_items',
'where flow_step_id = replace(:F4000_P5100_SRC_PAGE_ID,''%''||''null%'',null)',
'and flow_id = :FB_FLOW_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('No se ha encontrado ning\00FAn elemento en la p\00E1gina seleccionada.')
,p_validation_condition=>'F4000_P5100_SRC_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(8791617038995945.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(9121515225375700.4001)
,p_validation_name=>'SOURCE_PAGE_ID_EXISTS'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_steps',
'',
'where flow_id = :FB_FLOW_ID',
'',
'and id = :F4000_P5100_SRC_PAGE_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('El identificador de p\00E1gina de origen debe ser un identificador de p\00E1gina v\00E1lido.')
,p_validation_condition=>'F4000_P5100_SRC_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(8865915363144954.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(138696220035702532.4001)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      select 1',
'      from wwv_flow_page_plugs',
'      where flow_id = :fb_flow_id',
'      and   page_id = :F4000_P5100_PAGE_ID',
'      and   menu_id is not null',
'      and   nvl(:P5100_BREADCRUMB_ID,0)<>0'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('La p\00E1gina especificada ya tiene una regi\00F3n de ruta de navegaci\00F3n.')
,p_when_button_pressed=>wwv_flow_api.id(8791617038995945.4001)
,p_associated_item=>wwv_flow_api.id(122273620878506380.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(403516792027687440.4001)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P5100_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P5100_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(8791617038995945.4001)
,p_associated_item=>wwv_flow_api.id(403516230632685401.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(381731076631052149.4001)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5100_BREADCRUMB_ID'
,p_condition_element=>'P5100_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381731326560052149.4001)
,p_event_id=>wwv_flow_api.id(381731076631052149.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_BREADCRUMB_NAME,P5100_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(381731575436052149.4001)
,p_event_id=>wwv_flow_api.id(381731076631052149.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_BREADCRUMB_NAME,P5100_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549187397672939024.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(8787124180988585.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549187606052939024.4001)
,p_event_id=>wwv_flow_api.id(549187397672939024.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(699437523366200411.4001)
,p_name=>'Page Exists'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :FB_FLOW_ID,',
'                                 p_page_id => :F4000_P5100_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(699437832070200412.4001)
,p_event_id=>wwv_flow_api.id(699437523366200411.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_PAGE_MODE,P5100_GROUP_NAME,P5100_BREADCRUMB_ID,P5100_BREADCRUMB_PARENT_ID,P5100_BREADCRUMB_NAME,F4000_P5100_PAGE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1941059144529440365.4001)
,p_name=>'set region name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P5100_PAGE_NAME'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1941059549021440366.4001)
,p_event_id=>wwv_flow_api.id(1941059144529440365.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P5100_PAGE_NAME'
,p_attribute_07=>'F4000_P5100_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2337319753250933.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'5105:5110'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7614715444089544.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''SUMMARY_ITEM'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':F4000_P5100_SRC_PAGE_ID != :F4000_P5100_PREV_SRC_PAGE_ID'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_05105
begin
wwv_flow_api.create_page(
 p_id=>5105.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Resumen: Atributos de Elemento')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina de Resumen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214168830839927421)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8881521352202994.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(8771208191950732.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8887931654258960.4001)
,p_plug_name=>'Identificar Atributos de Elemento'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se pueden copiar elementos en la p\00E1gina de resumen como elementos de s\00F3lo visualizaci\00F3n desde todas las regiones de la p\00E1gina de origen o s\00F3lo de la regi\00F3n especificada en ''Regi\00F3n de Origen''. Se pueden copiar elementos en una regi\00F3n nueva en la p\00E1')
||unistr('gina de resumen o, si se ha seleccionado una p\00E1gina existente, en cualquiera de las regiones definidas en dicha p\00E1gina. Las definiciones de atributo de campo y etiqueta de los elementos de origen se pueden mantener o sobrescribir cambiando la alineac')
||unistr('i\00F3n y el uso de plantillas.</p>'),
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204703424938822175.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8995431011984066.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204703424938822175.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9132913489414281.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204703424938822175.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(8998725255991869.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204703424938822175.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8981129774715655.4001)
,p_branch_action=>'5105'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'F4000_P5105_SRC_REGION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9133306570414283.4001)
,p_branch_action=>'5110'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(9132913489414281.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(8999106624991871.4001)
,p_branch_action=>'5100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(8998725255991869.4001)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(272569925883335510.4001)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'5100'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(8998725255991869.4001)
,p_branch_sequence=>15
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(12349808322198476.4001)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(8998725255991869.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = false'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2080410972521915.4001)
,p_name=>'F4000_P5105_FIELD_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>'Plantilla de Etiqueta'
,p_source=>'select DEFAULT_LABEL_TEMPLATE from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FIELDTEMPLATE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where  flow_id = :fb_flow_id and ',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Igual que el Elemento de Origen'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('<p>Una plantilla de campo de etiqueta permite identificar una definici\00F3n compartida de c\00F3mo va a aparecer una etiqueta de campo.</p>')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2108924509576442.4001)
,p_name=>'F4000_P5105_LABEL_ALIGNMENT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>unistr('Alineaci\00F3n&nbsp;de&nbsp;Etiqueta')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LABEL_ALIGNMENT'
,p_lov=>'.'||wwv_flow_api.id(84757522618851451.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Igual que el Elemento de Origen'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo controla d\00F3nde aparece la etiqueta. Las etiquetas que aparecen "ENCIMA" se muestran en la misma celda de la tabla HTML que el elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2123126198621219.4001)
,p_name=>'F4000_P5105_TAG_ATTRIBUTES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>'Atributos de Campo '
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct TAG_ATTRIBUTES d, TAG_ATTRIBUTES v',
'from   wwv_flow_step_items',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>25
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Para cada tipo de etiqueta, agregue el siguiente texto en la etiqueta generada. Esto permite la inserci\00F3n de JavaScript. Aseg\00FArese de que el c\00F3digo no entre en conflicto con el JavaScript generado. Esto se ha implantado para los tipos de elemento de ')
||unistr('TEXT, TEXTAREA, FILE y PASSWORD. Los botones (no mostrados como im\00E1genes) tambi\00E9n soportan atributos de separadores.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2128920362639158.4001)
,p_name=>'F4000_P5105_FIELD_ALIGNMENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>unistr('Alineaci\00F3n&nbsp;de&nbsp;Campo')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FIELD_ALIGNMENT'
,p_lov=>'.'||wwv_flow_api.id(84354125395660958.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Igual que el Elemento de Origen'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Utilice este atributo con otros atributos de visualizaci\00F3n para controlar la forma en la que cada elemento aparece en la p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2272517720099890.4001)
,p_name=>'F4000_P5105_REGION_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_item_default=>'replace(wwv_flow_lang.system_message(''F4350_SUMMARY''),'':'',null)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>unistr('Nombre de la Regi\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el nombre para las nuevas regiones; si se ha seleccionado una regi\00F3n existente, el nombre no cambiar\00E1.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2275808446104241.4001)
,p_name=>'F4000_P5105_REGION_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>unistr('Plantilla de Regi\00F3n')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select default_region_template from wwv_flow_themes ',
'where flow_id = :fb_flow_id and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, t.r from (',
'select wwv_flow_escape.html(page_plug_template_name) d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id = :FB_FLOW_ID and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order  by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Sin Plantilla'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la plantilla de regi\00F3n para la regi\00F3n de resumen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2319414386223038.4001)
,p_name=>'F4000_P5105_REGION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>unistr('Regi\00F3n de Resumen')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as d, id',
'  from wwv_flow_page_plugs',
' where flow_id = :FB_FLOW_ID',
'   and page_id = :F4000_P5100_PAGE_ID',
' order by plug_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Nueva Regi\00F3n')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una regi\00F3n para la p\00E1gina de resumen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8894520643279237.4001)
,p_name=>'F4000_P5105_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>unistr('P\00E1gina de Resumen:')
,p_source=>':F4000_P5100_PAGE_ID || '' - '' || :F4000_P5100_PAGE_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('\00C9sta es la p\00E1gina de resumen que ha especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8900025363307421.4001)
,p_name=>'F4000_P5105_SRC_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_prompt=>unistr('P\00E1gina de Origen:')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name',
'',
'from wwv_flow_steps',
'',
'where id = :F4000_P5100_SRC_PAGE_ID',
'',
'and flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('\00C9sta es la p\00E1gina de origen que ha especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(8958022300627958.4001)
,p_name=>'F4000_P5105_SRC_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(8887931654258960.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Regi\00F3n de Origen')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as d, id',
'  from wwv_flow_page_plugs',
' where flow_id = :FB_FLOW_ID',
'   and page_id = :F4000_P5100_SRC_PAGE_ID',
' order by plug_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Todas las Regiones'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una regi\00F3n para limitar la lista de elementos a una regi\00F3n concreta')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(165232800939462897.4001)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_user_interface_id => :P259_USER_INTERFACE_ID )'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(144955300413096219.4001)
,p_validation_name=>'RegionNameMandWhenNewRegion'
,p_validation_sequence=>20
,p_validation=>'F4000_P5105_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el nombre de regi\00F3n.')
,p_validation_condition=>'F4000_P5105_REGION_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_api.id(9132913489414281.4001)
,p_associated_item=>wwv_flow_api.id(2272517720099890.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549187996964946924.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(8995431011984066.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549188267783946925.4001)
,p_event_id=>wwv_flow_api.id(549187996964946924.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_05110
begin
wwv_flow_api.create_page(
 p_id=>5110.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear P\00E1gina de Resumen: Elementos de Resumen')
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear P\00E1gina de Resumen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(214168830839927421)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2260526790080521.4001)
,p_name=>unistr('Seleccionar Elementos a Incluir en P\00E1gina de Resumen')
,p_template=>wwv_flow_api.id(42025417508627628.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with collection_values as (',
'    select c005 item_id,',
'           c001 unordered_checked,',
'           c002 item_name,',
'           c003 display_as,',
'           c004 plug_name',
'      from wwv_flow_collections',
'     where collection_name = ''SUMMARY_ITEM'' ),',
'collection_values_checked as (',
'    select item_id,',
'           ( select c2.unordered_checked',
'               from collection_values c2',
'              where c1.item_id = c2.unordered_checked ) item_id_checked,',
'           item_name,',
'           display_as,',
'           plug_name',
'      from collection_values c1 ),',
'item_values as (',
'    select to_char(i.id) item_id,',
'           null          item_id_checked,',
'           i.name        item_name,',
'           i.display_as  display_as,',
'           p.plug_name   plug_name',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs p',
'     where i.item_plug_id   =  p.id',
'       and i.flow_step_id   =  :F4000_P5100_SRC_PAGE_ID',
'       and i.flow_id        =  :FB_FLOW_ID',
'       and i.display_as not in ( ''NATIVE_HIDDEN'',',
'                                 ''NATIVE_DISPLAY_IMAGE'',',
'                                 ''NATIVE_PASSWORD'',',
'                                 ''NATIVE_STOP_AND_START_HTML_TABLE'' )',
'       and (nvl(:F4000_P5105_SRC_REGION,0) = 0 or i.item_plug_id = :F4000_P5105_SRC_REGION)',
'     order by p.plug_display_sequence, i.item_sequence ),',
'columns as (',
'    select *',
'      from collection_values_checked',
'     union all',
'    select *',
'      from item_values',
'     where not exists ( select null from collection_values_checked ))',
'select wwv_flow_item.checkbox(1,item_id,''title="''||wwv_flow_lang.system_message(''INCLUDE_LABEL'',item_name)||''"'',item_id_checked) c,',
'       wwv_flow_item.display_and_save(2,item_name) n,',
'       wwv_flow_item.hidden(3,display_as)||',
'       wwv_flow_item.text_from_lov (',
'           display_as,',
'           ''ITEM_TYPES (REQUIRES APPLICATION CONTEXT)'' ) dl,',
'       wwv_flow_item.display_and_save(4,plug_name) p,',
'       wwv_flow_item.hidden(5,item_id) id',
'  from columns'))
,p_header=>unistr('<p>Seleccione los elementos que desea incluir en la p\00E1gina de resumen. Todos los elementos seleccionados se copiar\00E1n en la p\00E1gina de resumen, el tipo de visualizaci\00F3n se convertir\00E1 en texto de solo visualizaci\00F3n o lista de valores de solo visualizaci')
||unistr('\00F3n para todos los elementos de origen de lista de valores.</p>')
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48527607412770638.4001)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48527729248770638.4001)
,p_query_column_id=>2
,p_column_alias=>'N'
,p_column_display_sequence=>2
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(274033123105742648.4001)
,p_query_column_id=>3
,p_column_alias=>'DL'
,p_column_display_sequence=>3
,p_column_heading=>'Mostrar'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48527901834770639.4001)
,p_query_column_id=>4
,p_column_alias=>'P'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Regi\00F3n')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(48528015058770639.4001)
,p_query_column_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9174523536493468.4001)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(8771208191950732.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(204705432342833768.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9177207050497577.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(204705432342833768.4001)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9187008912507569.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(204705432342833768.4001)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9247013470612899.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(204705432342833768.4001)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9187401298507571.4001)
,p_branch_action=>'303'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(9187008912507569.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(9182831134502213.4001)
,p_branch_action=>'5105'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(9247013470612899.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2388118408844121.4001)
,p_name=>'F4000_P5110_SRC_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2260526790080521.4001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name',
'',
'from wwv_flow_steps',
'',
'where id = :F4000_P5100_SRC_PAGE_ID',
'',
'and flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('\00C9sta es la p\00E1gina de resumen que ha especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2393100939852195.4001)
,p_name=>'F4000_P5110_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2260526790080521.4001)
,p_source=>':F4000_P5100_PAGE_ID || '' - '' || :F4000_P5100_PAGE_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('\00C9sta es la p\00E1gina de origen que ha especificado.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2412912523922790.4001)
,p_validation_name=>'ITEM_SELECTED'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Se debe especificar al menos un elemento para el resumen.'
,p_validation_condition=>'Next'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(549716605498753327.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(9177207050497577.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(549716703224753328.4001)
,p_event_id=>wwv_flow_api.id(549716605498753327.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(7577401144252723.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  function array_element( ',
'      p_vcarr in wwv_flow_global.vc_arr2,',
'      p_index in number )',
'      return varchar2',
'  is',
'      l_return_value varchar2(4000) := NULL;',
'  begin',
'      if p_vcarr is not null then',
'          l_return_value := substr(p_vcarr( p_index ), 1, 4000);',
'      end if;',
'      return l_return_value;  ',
'  exception',
'      when others then',
'          return NULL;',
'  end;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''SUMMARY_ITEM'');',
'  ',
'  for i in 1..wwv_flow.g_f05.count',
'  loop    ',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''SUMMARY_ITEM'',',
'        p_c001            => array_element(wwv_flow.g_f01,i),',
'        p_c002            => wwv_flow.g_f02(i),',
'        p_c003            => wwv_flow.g_f03(i),',
'        p_c004            => wwv_flow.g_f04(i),',
'        p_c005            => wwv_flow.g_f05(i));',
'  end loop; ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al crear la recopilaci\00F3n de elementos de resumen.')
);
end;
/
prompt --application/pages/page_06000
begin
wwv_flow_api.create_page(
 p_id=>6000.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Paquete de datos: seleccionar tablas'
,p_alias=>'DATA-PACKAGE-SELECT-TABLES1'
,p_step_title=>'Paquete de datos: seleccionar tablas'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(117814363885361293)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(3200591188196688)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6301071404752397.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(264955122693003915.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(264955200008003916.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(264955787061003922.4001)
,p_plug_name=>'Tablas'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252876725633187309.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(264955200008003916.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252877119702187312.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(264955200008003916.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252877465257187313.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(264955200008003916.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(252881030025187325.4001)
,p_branch_name=>'Go To Page 6001'
,p_branch_action=>'f?p=&APP_ID.:6001:&SESSION.::&DEBUG.:6001:P6001_SCRIPT_NAME,P6001_SCRIPT_SEQUENCE,P6001_OBJECT_OWNER:&P6000_SCRIPT_NAME.,&P6000_SCRIPT_SEQUENCE.,&P6000_OBJECT_OWNER.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(252877119702187312.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(252881410270187325.4001)
,p_branch_name=>'Go To Page 850'
,p_branch_action=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(252877465257187313.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1706301228626367.4001)
,p_name=>'P6000_SCRIPT_TYPE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_item_default=>'INSTALL'
,p_prompt=>'Tipo de Script:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tipo de script de objeto de soporte que est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1707125394629439.4001)
,p_name=>'P6000_SCRIPT_SOURCE_TYPE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Origen de Script:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(4626801323289842.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este es el m\00E9todo que est\00E1 utilizando para crear un script de instalaci\00F3n. Todos los scripts de instalaci\00F3n, excepto el paquete de datos, se pueden editar tras su creaci\00F3n. Para cambiar el tipo de origen del script, vuelva al primer paso de este asis')
||'tente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252878157813187313.4001)
,p_name=>'P6000_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un nombre para el script que va a crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252878562175187316.4001)
,p_name=>'P6000_SCRIPT_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(sequence),0) + 10',
'  from wwv_flow_install_scripts ',
' where flow_id = :FB_FLOW_ID;'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Secuencia'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un n\00FAmero de secuencia para el script que est\00E1 creando. Los archivos de comandos se ejecutar\00E1n por orden seg\00FAn los n\00FAmeros de secuencia.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252878936309187316.4001)
,p_name=>'P6000_OBJECT_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_item_default=>'wwv_flow_wizard_api.get_flow_owner'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Propietario del Objeto'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el usuario de base de datos propietario del objeto.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252879725225187317.4001)
,p_name=>'P6000_TABLES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select listagg(d,'':'') tables from (',
'select object_name d',
'   from wwv_flow_install_objects',
'  where flow_id = :FB_FLOW_ID',
'    and object_type = ''TABLE''',
'    and upper(object_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d',
'   from apex_application_lovs',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select db_table_name d',
'   from apex_application_page_db_items',
'  where application_id = :FB_FLOW_ID',
'  and upper(db_table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select r.table_name d',
'   from apex_application_page_regions r, sys.dba_tables t',
'  where r.application_id = :FB_FLOW_ID',
'    and r.table_name = t.table_name',
'    and r.table_owner = t.owner',
'    and upper(r.table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d',
'   from apex_application_page_chart_s',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'order by d )'))
,p_item_default_type=>'SQL_QUERY_COLON'
,p_prompt=>'Tablas'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'  from sys.dba_objects',
' where owner = :P6000_OBJECT_OWNER',
'   and object_name not like ''SYS\_%'' escape ''\''',
'   and object_name not like ''APEX$%''',
'   and object_type = ''TABLE''',
'   --and object_type in (select * from table(wwv_flow_string.split(:P855_OBJECT_TYPE,'':'')))',
'   --and (instr(object_name,upper(:P858_FILTER)) > 0 or :P858_FILTER is null)',
'   and upper(object_name) like ''%''  || upper(:P6000_FILTER) ||''%''',
'union',
'select object_name d,',
'        object_name r',
'   from wwv_flow_install_objects',
'  where flow_id = :FB_FLOW_ID',
'    and object_type = ''TABLE''',
'    and upper(object_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d,',
'        table_name r',
'   from apex_application_lovs',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select db_table_name d,',
'        db_table_name r',
'   from apex_application_page_db_items',
'  where application_id = :FB_FLOW_ID',
'  and upper(db_table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select r.table_name d,',
'        r.table_name r',
'   from apex_application_page_regions r, sys.dba_tables t',
'  where r.application_id = :FB_FLOW_ID',
'    and r.table_name = t.table_name',
'    and r.table_owner = t.owner',
'    and upper(r.table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d,',
'        table_name r',
'   from apex_application_page_chart_s',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'  order by d'))
,p_lov_cascade_parent_items=>'P6000_FILTER'
,p_ajax_items_to_submit=>'P6000_OBJECT_OWNER'
,p_ajax_optimize_refresh=>'N'
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Note: Los datos de la tabla se empaquetar\00E1n en el orden especificado. Las tablas secundarias que se basan en los datos de claves ajenas deben aparecer despu\00E9s de las tablas principales.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(265280529031302202.4001)
,p_name=>'P6000_FILTER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(264955787061003922.4001)
,p_prompt=>'Filtro'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Introduzca un criterio de filtro para la lista de objetos y pulse Intro.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1712556321736470.4001)
,p_validation_name=>'P6000_SCRIPT_NAME'
,p_validation_sequence=>10
,p_validation=>'P6000_SCRIPT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Especifique un nombre para el script.'
,p_when_button_pressed=>wwv_flow_api.id(252877119702187312.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2218821802597630.4001)
,p_validation_name=>'Must select a table'
,p_validation_sequence=>20
,p_validation=>'P6000_TABLES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Debe seleccionar al menos una tabla.'
,p_associated_item=>wwv_flow_api.id(252879725225187317.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2218905897597631.4001)
,p_name=>'Set Focus'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2219099767597632.4001)
,p_event_id=>wwv_flow_api.id(2218905897597631.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6000_SCRIPT_NAME'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(252880140974187324.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean coll'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if wwv_flow_collection.collection_exists(''DATA_MIG_TABLE_COLUMNS'') then ',
'        wwv_flow_collection.delete_collection (',
'            p_collection_name => ''DATA_MIG_TABLE_COLUMNS'');',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(252877119702187312.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(252950369766747003.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  cursor c_values is ',
'    select t.column_value as table_name',
'      from',
'        table ( apex_string.split(:P6000_TABLES, '':'') ) t',
'     where t.column_value is not null;',
'',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(''DATA_MIG_TABLES'');',
'    --save table names into new collection',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --c004 -> configure columns flag Y/N, default N',
'    --n001 -> Rownum',
'    ',
'    for c in c_values loop',
'        wwv_flow_collection.add_member(',
'            p_collection_name => ''DATA_MIG_TABLES'',',
'            p_c001            => c.table_name,',
'            p_c002            => ''N'',',
'            p_c003            => null,',
'            p_c004            => ''N'',',
'            p_n001            =>  10000',
'        );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_06001
begin
wwv_flow_api.create_page(
 p_id=>6001.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Paquete de datos: tablas'
,p_alias=>'DATA-PACKAGE-ALL-TABLES'
,p_step_title=>'Paquete de datos: tablas'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(117814363885361293)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(3200591188196688)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8104450044586612.4001)
,p_plug_name=>'progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(4589709522084091.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(252923282316646394.4001)
,p_plug_name=>unistr('Migraci\00F3n de datos: tablas')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with the_counts as',
'  (select ac.c001 table_name,',
'          (select count(*) ',
'            from wwv_flow_collections ac2',
'            inner join table(wwv_data_pkg_int.supported_data_types) sdt',
'              on ac2.c003 like sdt.column_value',
'          where ac2.collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'            and ac2.c001 = ac.c001',
'            and ac2.c006 = ''Y'') collection_columns,',
'          (select count(*)',
'            from dba_tab_columns dtc',
'            where dtc.owner = :P6001_OBJECT_OWNER',
'              and dtc.table_name = ac.c001) total_columns,',
'          (select count(*)',
'            from sys.dba_tab_columns dtc',
'            inner join table(wwv_data_pkg_int.supported_data_types) sdt',
'              on dtc.data_type like sdt.column_value',
'            where dtc.owner = :P6001_OBJECT_OWNER',
'              and dtc.table_name = ac.c001) supported_columns',
'    from wwv_flow_collections ac',
'    where collection_name = ''DATA_MIG_TABLES'')',
'select seq_id,',
'       c001,',
'       c003,',
'       n001,',
'       case when the_counts.collection_columns = 0 then the_counts.supported_columns',
'         else the_counts.collection_columns',
'         end included_columns,',
'       the_counts.total_columns',
'from wwv_flow_collections ac',
'inner join the_counts on the_counts.table_name = ac.c001',
'where collection_name = ''DATA_MIG_TABLES''',
'order by c001'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_page_header=>unistr('Migraci\00F3n de datos: tablas')
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(252923369323646394.4001)
,p_name=>'Data Migration - Tables'
,p_max_row_count=>'1000'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_report_saving=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_select_columns=>'N'
,p_show_filter=>'N'
,p_show_sort=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'EDIAZ@INSUM.CA'
,p_internal_uid=>252923369323646394
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252924107654646396.4001)
,p_db_column_name=>'SEQ_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Configuraci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252924541313646396.4001)
,p_db_column_name=>'C001'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tablas'
,p_column_link=>'f?p=&APP_ID.:6002:&SESSION.::&DEBUG.:6002:P6002_TABLE_SEQ_ID:#SEQ_ID#'
,p_column_linktext=>'#C001#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252945359624646409.4001)
,p_db_column_name=>'N001'
,p_display_order=>56
,p_column_identifier=>'BC'
,p_column_label=>'Filas'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252952040432747020.4001)
,p_db_column_name=>'C003'
,p_display_order=>76
,p_column_identifier=>'BF'
,p_column_label=>unistr('Cl\00E1usula WHERE')
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(258271548702096317.4001)
,p_db_column_name=>'INCLUDED_COLUMNS'
,p_display_order=>86
,p_column_identifier=>'BI'
,p_column_label=>'Columnas incluidas'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(271870302483321804.4001)
,p_db_column_name=>'TOTAL_COLUMNS'
,p_display_order=>96
,p_column_identifier=>'BJ'
,p_column_label=>'Columnas'
,p_column_html_expression=>'#INCLUDED_COLUMNS# de #TOTAL_COLUMNS#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_help_text=>unistr('N\00FAmero de columnas incluidas/N\00FAmero de columnas totales en la tabla')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(252950169471747001.4001)
,p_plug_name=>'Crear Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(277162631434148119.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1850656139316149662.4001)
,p_plug_name=>unistr('Informaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('El tipo de datos BLOB no est\00E1 soportado actualmente para exportaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select null ',
'   from sys.dba_tab_columns dtc ',
'  where dtc.owner = :P6001_OBJECT_OWNER ',
'    and dtc.table_name in (select c001 from wwv_flow_collections where collection_name = ''DATA_MIG_TABLES'') ',
'    and dtc.data_type = ''BLOB'''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252956392155753203.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(277162631434148119.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252957160251753203.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(277162631434148119.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252957567189753204.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(277162631434148119.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(253033270703155539.4001)
,p_branch_name=>'Branch to page 473'
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:473::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(252957160251753203.4001)
,p_branch_sequence=>60
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1801857337826835.4001)
,p_name=>'P6001_SCRIPT_TYPE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(252923282316646394.4001)
,p_item_default=>'INSTALL'
,p_prompt=>'Tipo de Script:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_api.id(57799129745997268.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifica el tipo de script de objeto de soporte que est\00E1 creando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1802692994831795.4001)
,p_name=>'P6001_SOURCE_SCRIPT_TYPE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(252923282316646394.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tipo de Origen de Script:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(4626801323289842.4001)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Este es el m\00E9todo que est\00E1 utilizando para crear un script de instalaci\00F3n. Todos los scripts de instalaci\00F3n, excepto el paquete de datos, se pueden editar tras su creaci\00F3n. Para cambiar el tipo de origen del script, vuelva al primer paso de este asis')
||'tente.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252950476480747004.4001)
,p_name=>'P6001_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(252923282316646394.4001)
,p_prompt=>'Nombre:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre del script que va a crear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252950581573747005.4001)
,p_name=>'P6001_SCRIPT_SEQUENCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(252923282316646394.4001)
,p_prompt=>'Secuencia:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica el n\00FAmero de secuencia para el script que se va a crear. Los scripts se ejecutar\00E1n por orden seg\00FAn los n\00FAmeros de secuencia.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252950645802747006.4001)
,p_name=>'P6001_OBJECT_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(252923282316646394.4001)
,p_prompt=>'Propietario de Objeto:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica al propietario del objeto de base de datos.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(271870415773321805.4001)
,p_name=>'P6001_REMOVE_AFTER_LOAD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(252923282316646394.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Eliminar despu\00E9s de carga')
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Cuando est\00E9 activado, este conmutador crear\00E1 un script que eliminar\00E1 los archivos est\00E1ticos generados al instalar la aplicaci\00F3n. Puede actualizar manualmente el script generado para cambiar esta configuraci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2218797231597629.4001)
,p_validation_name=>'At least one column included'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'   and c006 = ''Y''',
' union',
' select count(*)',
'   from sys.dba_tab_columns dtc, wwv_flow_collections ac,',
'        table(wwv_data_pkg_int.supported_data_types) sdt',
'  where dtc.owner = :P6001_OBJECT_OWNER',
'    and dtc.data_type like sdt.column_value',
'    and dtc.table_name = ac.c001',
'    and ac.collection_name = ''DATA_MIG_TABLES''',
' having count(*) > 0'))
,p_validation_type=>'EXISTS'
,p_error_message=>'No hay columnas incluidas en este paquete de datos.'
,p_when_button_pressed=>wwv_flow_api.id(252957160251753203.4001)
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(252951635156747016.4001)
,p_name=>'OnDialogClosed - Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(252923282316646394.4001)
,p_bind_type=>'live'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(252951749013747017.4001)
,p_event_id=>wwv_flow_api.id(252951635156747016.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(252923282316646394.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2219125773597633.4001)
,p_name=>'Set Focus'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2219215217597634.4001)
,p_event_id=>wwv_flow_api.id(2219125773597633.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6001_REMOVE_AFTER_LOAD'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(252951385370747013.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Execute Data Package'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'l_table_rec         wwv_data_pkg_int.t_data_migration;',
'l_table_recs        wwv_data_pkg_int.t_data_migration_tab;',
'',
'l_column_rec        wwv_data_pkg_int.t_column_info default null;',
'',
'l_script_id         number;',
'l_script_name       varchar2(4000) := :P6001_SCRIPT_NAME;',
'',
'c_app_id            number := :FB_FLOW_ID;',
'l_sequence          number := :P6001_SCRIPT_SEQUENCE;',
'',
'l_count             number;',
'l_count_1           number;',
'',
'l_count_nw number;',
'',
'cursor c_tables is ',
'    select *',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLES'';',
'',
'begin',
'    -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'',
'    l_count_1   := 0;',
'    l_count     := 0;',
'    ',
'    --loop through the selected tables',
'    for c in c_tables loop',
'        l_count := l_count + 1;',
'        l_table_rec.table_owner     := :P6001_OBJECT_OWNER;',
'        l_table_rec.table_name      := trim(c.c001);',
'        l_table_rec.where_clause    := nvl(c.c003, null);',
'        l_table_rec.number_of_rows  := c.n001;',
'        ',
'        --loop through the columns of that table',
'        for col in (select * ',
'                      from wwv_flow_collections ',
'                     where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'                       and c001 = c.c001) loop',
'',
'            -- add  override value',
'            if col.c004 is not null then',
'                l_column_rec.value_override := col.c004;',
'            end if;',
'',
'            -- add data masking',
'            if (col.c006 = ''Y'') then',
'                l_count_1 := l_count_1 + 1;',
'                l_column_rec.column_name    := col.c002;',
'                if col.c005 = ''Y'' then',
'                    l_column_rec.column_mask := true;',
'                    l_column_rec.redact_exp  := col.c020; -- REDACT_EXP',
'                    l_column_rec.redact_type := col.c021; -- REDACT_TYPE',
'                    l_column_rec.func_parms  := col.c022; -- FUNCTION_PARMS',
'                    l_column_rec.regexp_pat  := col.c023; -- REGEXP_PATTERN',
'                    l_column_rec.regexp_rep  := col.c024; -- REGEXP_REPLACE_STR',
'                    l_column_rec.regexp_pos  := col.c025; -- REGEXP_POSITION',
'                    l_column_rec.regexp_occ  := col.c026; -- REGEXP_OCCURANCE',
'                    l_column_rec.regexp_matp := col.c027; -- REGEXP_MATCH_PARM  ',
'                else',
'                    l_column_rec.column_mask := false;',
'                end if;',
'',
'                l_table_rec.column_tab(l_count_1) := l_column_rec;',
'                l_column_rec := null;',
'            end if;',
'        end loop; ',
'',
'        l_table_recs(l_count)       := l_table_rec;',
'        ',
'        l_table_rec := null;',
'        ',
'        l_count_1 := 0;',
'    end loop; ',
'',
'    ',
'    wwv_data_pkg_int.create_data_migration( ',
'        p_target_app_id         =>  c_app_id,',
'        p_tables                =>  l_table_recs,',
'        p_script_name           =>  l_script_name,',
'        p_sequence              =>  l_sequence,',
'        p_remove_after_load     => nvl(:P6001_REMOVE_AFTER_LOAD,''Y'') = ''Y'',',
'        p_script_id             => l_script_id);',
'',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error al crear paquete de datos.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(252957160251753203.4001)
,p_process_success_message=>unistr('Se ha creado el script de instalaci\00F3n de paquete de datos y se ha agregado el paquete de datos a los componentes compartidos.')
);
end;
/
prompt --application/pages/page_06002
begin
wwv_flow_api.create_page(
 p_id=>6002.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Paquete de datos: configuraci\00F3n de tabla')
,p_alias=>'DATA-PKG-TABLE-CONFIGURATION'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Datos: configuraci\00F3n de tabla')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(117814363885361293)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(3200591188196688)
,p_dialog_height=>'700'
,p_dialog_width=>'1100'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(252952317441747023.4001)
,p_plug_name=>'Columnas'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dtc.column_name,',
'       dtc.column_id,',
'        dtc.data_type,',
'        case when dtc.data_type in (''CHAR'',''VARCHAR2'',''NUMBER'') then ''(''||dtc.data_length||'')''',
'             else null',
'        end data_length,',
'       nvl( (select ac.c005',
'          from wwv_flow_collections ac',
'         where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'           and ac.c001 = :P6002_TABLE_NAME',
'           and ac.c002 = column_name) ,''N'')as mask_flag,',
'        nvl( (select ac.c006 ',
'          from wwv_flow_collections ac',
'         where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'           and ac.c001 = :P6002_TABLE_NAME',
'           and ac.c002 = column_name ) ,''N'') as included,',
'       ''config'' as config,',
'       nvl2(sdt.column_value,''Y'',''N'') is_supported',
'from sys.dba_tab_cols dtc',
'left outer join table(wwv_data_pkg_int.supported_data_types) sdt',
'  on dtc.data_type like sdt.column_value',
'where dtc.table_name = :P6002_TABLE_NAME',
' and owner = :P6002_OBJECT_OWNER',
' and hidden_column = ''NO''',
'order by dtc.column_name;'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P6002_TABLE_SEQ_ID,P6002_OBJECT_OWNER,P6002_TABLE_NAME'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Columnas'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(252952482704747024.4001)
,p_max_row_count=>'1000000'
,p_allow_report_saving=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_select_columns=>'N'
,p_show_filter=>'N'
,p_show_sort=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'EDIAZ@INSUM.CA'
,p_internal_uid=>252952482704747024
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252952869022747028.4001)
,p_db_column_name=>'CONFIG'
,p_display_order=>10
,p_column_identifier=>'D'
,p_column_label=>unistr('Configuraci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252952557487747025.4001)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Nombre de Columna'
,p_column_link=>'f?p=&APP_ID.:6003:&SESSION.::&DEBUG.:6003:P6003_COLUMN_NAME,P6003_OBJECT_OWNER,P6003_DATA_TYPE,P6003_OBJECT_NAME,P6003_TABLE_SEQ_ID,P6003_DATA_TYPE_DISPLAY:#COLUMN_NAME#,&P6002_OBJECT_OWNER.,#DATA_TYPE#,&P6002_TABLE_NAME.,&P6002_TABLE_SEQ_ID.,#DATA_T'
||'YPE# #DATA_LENGTH#'
,p_column_linktext=>'#COLUMN_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252952693116747026.4001)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Tipo de Dato'
,p_column_html_expression=>'#DATA_TYPE# #DATA_LENGTH#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(252952734057747027.4001)
,p_db_column_name=>'MASK_FLAG'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>unistr('Con m\00E1scara')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :P6002_OBJECT_OWNER ) loop',
'    return true;',
'end loop;',
'return false;'))
,p_display_condition2=>'PLSQL'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(258270825808096310.4001)
,p_db_column_name=>'INCLUDED'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Incluidos'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265280456140302201.4001)
,p_db_column_name=>'IS_SUPPORTED'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Soportados'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_help_text=>unistr('Solo se incluir\00E1n los tipos de datos soportados en el paquete de datos.')
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(265281068918302207.4001)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2218551482597627.4001)
,p_db_column_name=>'DATA_LENGTH'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Longitud de Datos'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(277097272295955910.4001)
,p_plug_name=>unistr('Migraci\00F3n de datos')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(277102291650031131.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(295357732045140549.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252896602500636217.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(277102291650031131.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(252897485899636217.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(277102291650031131.4001)
,p_button_name=>'SAVE_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar tabla'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252898947686636218.4001)
,p_name=>'P6002_OBJECT_OWNER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_item_default=>'wwv_flow_wizard_api.get_flow_owner'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252899378364636218.4001)
,p_name=>'P6002_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_prompt=>'Nombre de la Tabla:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name as d,',
'    table_name as r',
'from all_tables',
'where table_name like ''%WWV_DG%'';'))
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Identifica la tabla actual que se est\00E1 configurando.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252899783923636218.4001)
,p_name=>'P6002_WHERE_C'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una cl\00E1usula where opcional para filtrar el n\00FAmero de filas exportadas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252900190195636218.4001)
,p_name=>'P6002_ROWNUM'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_prompt=>'Filas'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca en la tabla el n\00FAmero m\00E1ximo de filas que desea exportar.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252902579612636222.4001)
,p_name=>'P6002_NUM_TABLES_LEFT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252902986287636222.4001)
,p_name=>'P6002_TABLES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252903362875636222.4001)
,p_name=>'P6002_SCRIPT_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252903759375636222.4001)
,p_name=>'P6002_TABLE_SEQUENCE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252904163494636222.4001)
,p_name=>'P6002_TABLE_SEQ_ID'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252904555255636222.4001)
,p_name=>'P6002_OVR_COLUMN_CONCAT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(295357732045140549.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2218441447597626.4001)
,p_computation_sequence=>10
,p_computation_item=>'P6002_OBJECT_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_wizard_api.get_flow_owner'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(252918678795636237.4001)
,p_name=>'Enable Function Parameters'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6002_REDACT_TYPE'
,p_condition_element=>'P6002_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PARTIAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(252919105755636238.4001)
,p_event_id=>wwv_flow_api.id(252918678795636237.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_FUNCTION_PARMS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(252919609095636238.4001)
,p_event_id=>wwv_flow_api.id(252918678795636237.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_FUNCTION_PARMS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(252920018679636238.4001)
,p_name=>'Enable REGEXP Items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6002_REDACT_TYPE'
,p_condition_element=>'P6002_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGEXP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(252920569771636239.4001)
,p_event_id=>wwv_flow_api.id(252920018679636238.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_REGEXP_PATTERN,P6002_REGEXP_REPLACE_STR,P6002_REGEXP_POSITION,P6002_REGEXP_OCCURANCE,P6002_REGEXP_MATCH_PARM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(252921043540636239.4001)
,p_event_id=>wwv_flow_api.id(252920018679636238.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_REGEXP_PATTERN,P6002_REGEXP_REPLACE_STR,P6002_REGEXP_POSITION,P6002_REGEXP_OCCURANCE,P6002_REGEXP_MATCH_PARM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(252951401517747014.4001)
,p_name=>'OnClick - Close Modal'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(252896602500636217.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(252951562240747015.4001)
,p_event_id=>wwv_flow_api.id(252951401517747014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(252950755625747007.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select c001,',
'           c003,',
'           n001',
'      into :P6002_TABLE_NAME,',
'           :P6002_WHERE_C,',
'           :P6002_ROWNUM',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLES''',
'       and seq_id = :P6002_TABLE_SEQ_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(258270961966096311.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add all table columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor data_columns is',
'        select dtc.*, sdt.column_value supported_type',
'          from sys.dba_tab_cols dtc',
'          left outer join table(wwv_data_pkg_int.supported_data_types) sdt',
'            on dtc.data_type like sdt.column_value',
'         where table_name = :P6002_TABLE_NAME',
'           and dtc.owner = :P6002_OBJECT_OWNER',
'           and dtc.hidden_column = ''NO''',
'           and not exists (select null ',
'                             from wwv_flow_collections ',
'                            where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'                              and c001 = :P6002_TABLE_NAME);',
'begin',
'    -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c007 => supported column data type',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'    --n001 -> data_length',
'',
'',
'    if not wwv_flow_collection.collection_exists(''DATA_MIG_TABLE_COLUMNS'') then ',
'        wwv_flow_collection.create_collection(''DATA_MIG_TABLE_COLUMNS'');',
'    end if;',
'',
'        for i in data_columns loop',
'            wwv_flow_collection.add_member(',
'                p_collection_name => ''DATA_MIG_TABLE_COLUMNS'',',
'                p_c001            => :P6002_TABLE_NAME,',
'                p_c002            => i.column_name,',
'                p_c003            => i.data_type,',
'                p_c004            => null,',
'                p_c005            => ''N'',',
'                p_c006            => case when i.supported_type is not null then ''Y''',
'                                          else ''N''',
'                                          end,',
'                p_c007            => case when i.supported_type is not null then ''Y''',
'                                          else ''N''',
'                                          end,                          ',
'                p_n001            => i.data_length',
'            );',
'        end loop;',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(252917464030636229.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Table Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''1'',',
'        p_number_value  => :P6002_ROWNUM',
'    );',
'',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''2'',',
'        p_attr_value  => ''Y''',
'    );',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''3'',',
'        p_attr_value  => :P6002_WHERE_C',
'    );',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''4'',',
'        p_attr_value  => ''Y''',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CANCEL'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(252951229781747012.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'On Finish - Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(252897485899636217.4001)
);
end;
/
prompt --application/pages/page_06003
begin
wwv_flow_api.create_page(
 p_id=>6003.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Datos: configuraci\00F3n de columna')
,p_alias=>'DATA-COLUMN-CONFIGURATION'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Datos: configuraci\00F3n de columna')
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_api.id(117814363885361293)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(3200591188196688)
,p_dialog_height=>'700'
,p_dialog_width=>'1100'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(252953643742747036.4001)
,p_plug_name=>unistr('Informaci\00F3n de columna')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(257883755982505706.4001)
,p_plug_name=>'Opciones de Enmascaramiento de Datos'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>'style = "display: none"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(257885602378505725.4001)
,p_plug_name=>unistr('Sustituci\00F3n de datos')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P6003_SUPPORTED_OVERRIDE'
,p_plug_display_when_cond2=>'1'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(534966138498506506.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(257864105664475376.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(534966138498506506.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:6002:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(257864551491475376.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(534966138498506506.4001)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar Columna'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(258270724558096309.4001)
,p_branch_name=>'Go To Page 6002'
,p_branch_action=>'f?p=&APP_ID.:6002:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2218641625597628.4001)
,p_name=>'P6003_DATA_TYPE_DISPLAY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_prompt=>'Tipo de Dato:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el tipo de dato de la columna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(252953794637747037.4001)
,p_name=>'P6003_OBJECT_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257885716383505726.4001)
,p_name=>'P6003_NEW_COL_VALUE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(257885602378505725.4001)
,p_prompt=>unistr('Valor de sustituci\00F3n de columna')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('El formato del valor de sustituci\00F3n debe coincidir con el par\00E1metro NLS de la sesi\00F3n de base de datos subyacente para dicho tipo de datos.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257885894549505727.4001)
,p_name=>'P6003_OBJECT_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257885991901505728.4001)
,p_name=>'P6003_DATA_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifica el tipo de datos de la columna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257886156338505730.4001)
,p_name=>'P6003_COLUMN_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_prompt=>'Nombre de Columna:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_grid_column=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifica el nombre de la columna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257886327792505732.4001)
,p_name=>'P6003_MASK_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_prompt=>'Columna con enmascaramiento'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :P6003_OBJECT_OWNER ) loop',
'    return true;',
'end loop;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Elija si desea configurar el enmascaramiento de datos para esta columna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257890026826534593.4001)
,p_name=>'P6003_REDACT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Introduzca un nombre \00FAnico para la pol\00EDtica de redacci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257892735663542093.4001)
,p_name=>'P6003_REDACT_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_prompt=>unistr('Tipo de Funci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:Full;FULL,Partial;PARTIAL,Regular Expression;REGEXP,Random;RANDOM,None;NONE'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('-- Seleccionar Tipo de Redacci\00F3n --')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione una funci\00F3n que defina el tipo de redacci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257893831907549867.4001)
,p_name=>'P6003_FUNCTION_PARMS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_prompt=>unistr('Par\00E1metros de Funci\00F3n')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_FUNC_PARMS'
,p_lov=>'.'||wwv_flow_api.id(1633884855696516.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca o seleccione en la lista emergente c\00F3mo debe aparecer la redacci\00F3n de la columna. Consulte el apartado sobre sintaxis para realizar la redacci\00F3n de datos parcial en Oracle Database Advanced Security Guide 12c Release 1 (12.1) para obtener ')
||unistr('m\00E1s informaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257894619082551512.4001)
,p_name=>'P6003_REGEXP_PATTERN'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_prompt=>unistr('Patr\00F3n de Expresi\00F3n Regular')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_PATTERN'
,p_lov=>'.'||wwv_flow_api.id(1638174978696518.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca o seleccione en la lista emergente una expresi\00F3n regular que coincida con los datos que se van a redactar. Si se da una coincidencia, se redactar\00E1 con una expresi\00F3n regular especificada en el campo Cadena de Sustituci\00F3n de Expresi\00F3n Regula')
||'r.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257895415360553165.4001)
,p_name=>'P6003_REGEXP_REPLACE_STR'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_prompt=>unistr('Cadena de Sustituci\00F3n de Expresi\00F3n Regular')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_REPL_STR'
,p_lov=>'.'||wwv_flow_api.id(1640893349696518.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Introduzca o seleccione en la lista emergente c\00F3mo desea sustituir los datos que se van a redactar. Puede optar por cualquier tipo de dato CHAR, VARCHAR2, NCHAR o NVARCHAR2. La cadena regexp_replace_string puede contener hasta 500 referencias hacia a')
||unistr('tr\00E1s a subexpresiones con el formato \005Cn, donde n es un n\00FAmero del 1 al 9. Si desea incluir una barra invertida (\005C) en la configuraci\00F3n regexp_replace_string, debe ir precedida por el car\00E1cter de escape, que tambi\00E9n es una barra invertida. Por ejemplo')
||unistr(', para sustituir literalmente el patr\00F3n de coincidencia por \005C2 (en lugar de sustituirlo por la segunda subexpresi\00F3n de coincidencia del patr\00F3n de coincidencia) debe introducir \005C\005C2 en la configuraci\00F3n de regexp_replace_string. Para obtener m\00E1s informa')
||unistr('ci\00F3n, consulte Oracle Database SQL Language Reference.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257896275457554730.4001)
,p_name=>'P6003_REGEXP_POSITION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_item_default=>'1'
,p_prompt=>unistr('Posici\00F3n de Expresi\00F3n Regular')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la posici\00F3n inicial para la b\00FAsqueda de cadena. Se trata de un valor entero positivo que indica el car\00E1cter de los datos de column_name, donde Oracle Database debe iniciar la b\00FAsqueda. El valor por defecto es 1, lo que significa que Oracle')
||unistr(' Database comienza la b\00FAsqueda en el primer car\00E1cter de los datos de column_name.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257897063825556111.4001)
,p_name=>'P6003_REGEXP_OCCURANCE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Incidencia de Expresi\00F3n Regular')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un valor entero no negativo para especificar la incidencia para realizar la operaci\00F3n de b\00FAsqueda y sustituci\00F3n. Si introduce 0, se sustituir\00E1n todas las incidencias.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(257897806647557623.4001)
,p_name=>'P6003_REGEXP_MATCH_PARM'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(257883755982505706.4001)
,p_prompt=>unistr('Par\00E1metro de Coincidencias con Expresi\00F3n Regular')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGEXP_MATCH_PARAM'
,p_lov=>'.'||wwv_flow_api.id(1644350231696519.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('-- Seleccionar Par\00E1metro de Coincidencia --')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el comportamiento de la coincidencia por defecto de la funci\00F3n. El comportamiento de este par\00E1metro es el mismo para esta funci\00F3n que para la funci\00F3n SQL REGEXP_REPLACE.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(258269958935096301.4001)
,p_name=>'P6003_INCLUDE_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_prompt=>'Incluir Columna'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_read_only_when=>'P6003_SUPPORTED_DATA_TYPE'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifique si desea incluir esta columna'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(258270120118096303.4001)
,p_name=>'P6003_TABLE_SEQ_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(258271640625096318.4001)
,p_name=>'P6003_SUPPORTED_OVERRIDE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(257885602378505725.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(282947558378837921.4001)
,p_name=>'P6003_LENGTH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>':P6003_LENGTH is not null and :P6003_DATA_TYPE in (''VARCHAR2'', ''CHAR'', ''NUMBER'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_help_text=>'Identifica la longitud de la columna.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(282947605104837922.4001)
,p_name=>'P6003_FORMAT_MASK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(257885602378505725.4001)
,p_prompt=>unistr('M\00E1scara de Formato')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P6003_FORMAT_MASK'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Identifica la m\00E1scara de formato aplicada seg\00FAn el tipo de datos de la columna.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(282947726440837923.4001)
,p_name=>'P6003_SUPPORTED_DATA_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(252953643742747036.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(258271736663096319.4001)
,p_validation_name=>'Override value matches column data type format mask'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_timestamp         timestamp;',
'    l_timestamp_tz      timestamp with time zone;',
'    l_timestamp_ltz     timestamp with local time zone;',
'    l_date              date;',
'    l_data_length       number;',
'begin',
'    select data_length',
'      into l_data_length',
'      from sys.dba_tab_cols',
'     where table_name = :P6003_OBJECT_NAME',
'       and owner = :P6003_OBJECT_OWNER',
'       and column_name = :P6003_COLUMN_NAME',
'       and hidden_column = ''NO'';',
'    ',
'    if (:P6003_DATA_TYPE in (''VARCHAR2'', ''CHAR'', ''NUMBER'')) then',
'        if length(:P6003_NEW_COL_VALUE) > l_data_length then',
'            return false;',
'        else',
'            return true;',
'        end if;',
'    elsif (:P6003_DATA_TYPE = ''DATE'') then',
'        begin',
'            select to_date(:P6003_NEW_COL_VALUE)',
'              into l_date',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    elsif (:P6003_DATA_TYPE = ''TIMESTAMP(%)'') then',
'        begin',
'            select to_timestamp(:P6003_NEW_COL_VALUE)',
'              into l_timestamp',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    elsif (:P6003_DATA_TYPE = ''TIMESTAMP(%) WITH TIME ZONE'') then',
'        begin',
'            select to_timestamp_tz(:P6003_NEW_COL_VALUE)',
'              into l_timestamp_tz',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    elsif (:P6003_DATA_TYPE = ''TIMESTAMP(%) WITH LOCAL TIME ZONE'') then',
'        begin',
'            select cast(:P6003_NEW_COL_VALUE as timestamp with local time zone) ',
'              into l_timestamp_ltz',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('El valor de sustituci\00F3n no coincide con la m\00E1scara de formato del tipo de datos de columna o la longitud m\00E1xima.')
,p_associated_item=>wwv_flow_api.id(257885716383505726.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(257899337354569846.4001)
,p_name=>'Enable Function Parameters'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6003_REDACT_TYPE'
,p_condition_element=>'P6003_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PARTIAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(257899761239569847.4001)
,p_event_id=>wwv_flow_api.id(257899337354569846.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_FUNCTION_PARMS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(257900206417569847.4001)
,p_event_id=>wwv_flow_api.id(257899337354569846.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_FUNCTION_PARMS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(257900622085580383.4001)
,p_name=>'Enable REGEXP Items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6003_REDACT_TYPE'
,p_condition_element=>'P6003_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGEXP'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(257901050569580384.4001)
,p_event_id=>wwv_flow_api.id(257900622085580383.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_REGEXP_PATTERN,P6003_REGEXP_REPLACE_STR,P6003_REGEXP_POSITION,P6003_REGEXP_OCCURANCE,P6003_REGEXP_MATCH_PARM'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(257901590062580384.4001)
,p_event_id=>wwv_flow_api.id(257900622085580383.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_REGEXP_PATTERN,P6003_REGEXP_REPLACE_STR,P6003_REGEXP_POSITION,P6003_REGEXP_OCCURANCE,P6003_REGEXP_MATCH_PARM'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(258271251396096314.4001)
,p_name=>'OnChange - Toggle Data Redaction Fields'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6003_MASK_COLUMN'
,p_condition_element=>'P6003_MASK_COLUMN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(258271394211096315.4001)
,p_event_id=>wwv_flow_api.id(258271251396096314.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(257883755982505706.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(271870186393321802.4001)
,p_event_id=>wwv_flow_api.id(258271251396096314.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(257885602378505725.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(258271418169096316.4001)
,p_event_id=>wwv_flow_api.id(258271251396096314.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(257883755982505706.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(271870017759321801.4001)
,p_event_id=>wwv_flow_api.id(258271251396096314.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(257885602378505725.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(271870236701321803.4001)
,p_event_id=>wwv_flow_api.id(258271251396096314.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_NEW_COL_VALUE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(258270004138096302.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Column in Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id          number;',
'    l_count     number;',
'    l_redact_action varchar2(128);',
'begin',
'',
'        -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'    ',
'    if not wwv_flow_collection.collection_exists(''DATA_MIG_TABLE_COLUMNS'') then ',
'        wwv_flow_collection.create_collection(''DATA_MIG_TABLE_COLUMNS'');',
'    end if;',
'',
'    --check if column info already exists in collection',
'    select count(seq_id)',
'      into l_count',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'       and c001 = :P6003_OBJECT_NAME',
'       and c002 = :P6003_COLUMN_NAME;',
'    ',
'    if l_count = 0 then',
'        --add column info as new collection row ',
'        wwv_flow_collection.add_member(',
'            p_collection_name => ''DATA_MIG_TABLE_COLUMNS'',',
'            p_c001            => :P6003_OBJECT_NAME,',
'            p_c002            => :P6003_COLUMN_NAME,',
'            p_c003            => :P6003_DATA_TYPE,',
'            p_c004            => :P6003_NEW_COL_VALUE,',
'            p_c005            => :P6003_MASK_COLUMN,',
'            p_c006            => :P6003_INCLUDE_COLUMN,',
'            p_c007            => :P6003_SUPPORTED_DATA_TYPE,',
'            p_c020            => ''1=1'',',
'            p_c021            => :P6003_REDACT_TYPE,',
'            p_c022            => :P6003_FUNCTION_PARMS,',
'            p_c023            => :P6003_REGEXP_PATTERN,',
'            p_c024            => :P6003_REGEXP_REPLACE_STR,',
'            p_c025            => :P6003_REGEXP_POSITION,',
'            p_c026            => :P6003_REGEXP_OCCURANCE,',
'            p_c027            => :P6003_REGEXP_MATCH_PARM,',
'            p_n001            => :P6003_LENGTH',
'        );',
'    else',
'        select seq_id',
'          into l_seq_id',
'          from wwv_flow_collections',
'         where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'           and c001 = :P6003_OBJECT_NAME',
'           and c002 = :P6003_COLUMN_NAME;',
'        ',
'        wwv_flow_collection.update_member (',
'            p_collection_name => ''DATA_MIG_TABLE_COLUMNS'',',
'            p_seq             => l_seq_id,',
'            p_c001            => :P6003_OBJECT_NAME,',
'            p_c002            => :P6003_COLUMN_NAME,',
'            p_c003            => :P6003_DATA_TYPE,',
'            p_c004            => :P6003_NEW_COL_VALUE,',
'            p_c005            => :P6003_MASK_COLUMN,',
'            p_c006            => :P6003_INCLUDE_COLUMN,',
'            p_c007            => :P6003_SUPPORTED_DATA_TYPE,',
'            p_c020            => ''1=1'',',
'            p_c021            => :P6003_REDACT_TYPE,',
'            p_c022            => :P6003_FUNCTION_PARMS,',
'            p_c023            => :P6003_REGEXP_PATTERN,',
'            p_c024            => :P6003_REGEXP_REPLACE_STR,',
'            p_c025            => :P6003_REGEXP_POSITION,',
'            p_c026            => :P6003_REGEXP_OCCURANCE,',
'            p_c027            => :P6003_REGEXP_MATCH_PARM,',
'            p_n001            => :P6003_LENGTH',
'        );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(257886078225505729.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Redaction Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor c_column is ',
'    select *',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'       and c001 = :P6003_OBJECT_NAME',
'       and c002 = :P6003_COLUMN_NAME;',
'begin',
'        -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c007 => supported data type Y/N',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'    --n001 -> data_length   ',
'',
'    for c in c_column loop',
'        :P6003_NEW_COL_VALUE := c.c004;',
'        :P6003_MASK_COLUMN := c.c005;',
'        :P6003_INCLUDE_COLUMN := c.c006;',
'        :P6003_REDACT_TYPE := c.c021;',
'        :P6003_FUNCTION_PARMS := c.c022;',
'        :P6003_REGEXP_PATTERN := c.c023;',
'        :P6003_REGEXP_REPLACE_STR := c.c024;',
'        :P6003_REGEXP_POSITION := c.c025;',
'        :P6003_REGEXP_OCCURANCE := c.c026;',
'        :P6003_REGEXP_MATCH_PARM := c.c027;',
'        :P6003_LENGTH := c.n001;',
'        :P6003_SUPPORTED_DATA_TYPE := c.c007;',
'',
'        case  ',
'            when c.c003 = ''DATE'' then ',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_DATE_FORMAT'';',
'            when c.c003 like ''TIMESTAMP(%)'' then',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_TIMESTAMP_FORMAT'';',
'            when c.c003 like ''TIMESTAMP(%) WITH TIME ZONE'' then',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_TIMESTAMP_TZ_FORMAT'';      ',
'            when c.c003 like ''TIMESTAMP(%) WITH LOCAL TIME ZONE'' then',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_TIMESTAMP_FORMAT'';        ',
'            else :P6003_FORMAT_MASK := null;',
'        end case;',
'    end loop;',
'',
'    select count(*) ',
'      into :P6003_SUPPORTED_OVERRIDE',
'      from table(wwv_data_pkg_int.supported_override_types)',
'      where :P6003_DATA_TYPE like column_value;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_07020
begin
wwv_flow_api.create_page(
 p_id=>7020.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Automatizaciones'
,p_alias=>'AUTOMATIONS'
,p_step_title=>'Automatizaciones'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function runAutomation( pId ) {',
'    $s("P7020_ID", pId);',
'    apex.submit(''PLAY'');',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1379958984188245.4001)
,p_plug_name=>unistr('Copiar automatizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2533191240513173.4001)
,p_plug_name=>'Informe de automatizaciones '
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       FLOW_ID,',
'       SECURITY_GROUP_ID,',
'       NAME,',
'       STATIC_ID,',
'       TRIGGER_TYPE,',
'       POLLING_INTERVAL,',
'       POLLING_LAST_RUN_TIMESTAMP,',
'       POLLING_NEXT_RUN_TIMESTAMP,',
'       POLLING_STATUS,',
'       case polling_status',
'           when ''ACTIVE'' then ''icon-check''',
'           when ''DISABLED'' then ''icon-error''',
'           when ''ERROR''    then ''icon-warning'' end as status_icon,',
'       RESULT_TYPE,',
'       LOCATION,',
'       null as play_button',
'  from WWV_FLOW_AUTOMATIONS',
' where flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Informe de automatizaciones '
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(2533511338513173.4001)
,p_name=>'Report 1'
,p_max_row_count_message=>unistr('El recuento m\00E1ximo de filas de este informe es #MAX_ROW_COUNT# filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
,p_no_data_found_message=>'No se han encontrado automatizaciones.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'MARC'
,p_internal_uid=>2533511338513173
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2534875345513178.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nombre'
,p_column_link=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.::P7021_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2535299980513178.4001)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Identificador Est\00E1tico')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2536079157513178.4001)
,p_db_column_name=>'TRIGGER_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Tipo'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1355426926728029)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2536411083513178.4001)
,p_db_column_name=>'POLLING_INTERVAL'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('Expresi\00F3n de programaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2536876646513178.4001)
,p_db_column_name=>'POLLING_LAST_RUN_TIMESTAMP'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('\00DAltima Ejecuci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2537283890513178.4001)
,p_db_column_name=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Siguiente ejecuci\00F3n')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2537635665513178.4001)
,p_db_column_name=>'POLLING_STATUS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Estado de programaci\00F3n')
,p_column_html_expression=>'<span class="a-Icon #STATUS_ICON#"></span>&nbsp;#POLLING_STATUS#'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1358229692738259)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2538080396513179.4001)
,p_db_column_name=>'RESULT_TYPE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Ejecutar acciones cuando'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1356468048734066)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2538431779513179.4001)
,p_db_column_name=>'LOCATION'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Ubicaci\00F3n')
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(3842073961668883)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2533603144513175.4001)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2534096746513177.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>33
,p_column_identifier=>'B'
,p_column_label=>'Identificador de Flujo'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(2534417521513178.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>43
,p_column_identifier=>'C'
,p_column_label=>'Identificador de Grupo de Seguridad'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29895748922987850.4001)
,p_db_column_name=>'PLAY_BUTTON'
,p_display_order=>53
,p_column_identifier=>'N'
,p_column_label=>'Ejecutar'
,p_column_link=>'javascript:runAutomation(''#ID#'');'
,p_column_linktext=>'<span class="a-Icon icon-run-script"></span>'
,p_column_link_attr=>'title="Run Automation: #NAME#"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1379177251188237.4001)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>63
,p_column_identifier=>'O'
,p_column_label=>'Icono de estado'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2900862523394601.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2700189206621868.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2900983179394602.4001)
,p_plug_name=>'Automatizaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Las automatizaciones inician un juego secuencial de acciones basado en un programa. Se utilizan para supervisar datos y, posteriormente, realizar la acci\00F3n adecuada. Por ejemplo, la aprobaci\00F3n autom\00E1tica de solicitudes espec\00EDficas y el env\00EDo de alert')
||unistr('as de correo electr\00F3nico.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(2901080518394603.4001)
,p_name=>'Editado Recientemente'
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P7020b */ replace(replace(name,''_'','' ''),''.'','' '') name, id',
'from  wwv_flow_automations',
'where flow_id = :fb_flow_id',
'and last_updated_on is not null',
'and security_group_id = :flow_security_group_id',
'order by last_updated_on desc'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_automations ',
' where flow_id = :fb_flow_id',
'   and last_updated_on is not null',
'   and security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(11667910335347890.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2901192108394604.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Nombre'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.::P7021_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(2901253412394605.4001)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(29895294190987845.4001)
,p_name=>unistr('\00DAltimas 24 horas')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--large'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select count(id) as executions,',
'           nvl( sum(successful_row_count + error_row_count), 0)  as rows_processed',
'      from wwv_flow_automation_log',
'     where security_group_id = :WORKSPACE_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and start_timestamp   >= systimestamp - interval ''1'' day',
')',
'select executions,',
'       case when rows_processed < 1000                   then to_char(rows_processed)',
'            when rows_processed between 1000 and 1000000 then floor( rows_processed / 100 ) / 10    || ''K''',
'            else                                              floor( rows_processed / 100000 ) / 10 || ''M'' ',
'       end as rows_processed',
'  from data',
'  '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(1041640454953406573.4001)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29895383069987846.4001)
,p_query_column_id=>1
,p_column_alias=>'EXECUTIONS'
,p_column_display_sequence=>10
,p_column_heading=>'Ejecuciones'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(29895471954987847.4001)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>20
,p_column_heading=>'Filas Procesadas'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1934466572374315.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1934093123374311.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_button_name=>'COPY_AUTOMATION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Copiar automatizaci\00F3n')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1933766281374308.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2533191240513173.4001)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Copiar'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2550221776513183.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2533191240513173.4001)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:7030:&SESSION.::&DEBUG.:7030,7031'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1935114906374322.4001)
,p_branch_name=>'Go To Page 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021,7020:P7021_ID:&P7020_COPY_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1934093123374311.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1380091207188246.4001)
,p_name=>'P7020_FROM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_prompt=>unistr('Copiar automatizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :P7020_APPLICATIONS'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_lov_cascade_parent_items=>'P7020_APPLICATIONS'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la automatizaci\00F3n que se va a copiar')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1380188239188247.4001)
,p_name=>'P7020_COPY_NEW_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_prompt=>'Nombre Nuevo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione un nombre para la automatizaci\00F3n copiada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1380273100188248.4001)
,p_name=>'P7020_COPY_NEW_STATIC_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_prompt=>unistr('Nuevo Identificador Est\00E1tico')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione un ID est\00E1tico para la automatizaci\00F3n copiada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1380348778188249.4001)
,p_name=>'P7020_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_item_default=>'THIS'
,p_prompt=>'Copiar de'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7020_COPY_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(601116568254832030.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Si se va a copiar la automatizaci\00F3n de esta o de otra aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1380432360188250.4001)
,p_name=>'P7020_APPLICATIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_prompt=>'Aplicaciones'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la aplicaci\00F3n desde donde se va a copiar la automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1926315765406302.4001)
,p_name=>'P7020_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2533191240513173.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1935012768374321.4001)
,p_name=>'P7020_COPY_NEW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1379958984188245.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1377761480188223.4001)
,p_validation_name=>'Can execute Automation ID'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automations',
' where id                = :P7020_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>unistr('La automatizaci\00F3n no existe.')
,p_validation_condition=>'PLAY'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1934171122374312.4001)
,p_validation_name=>'Copy From Automation must be not NULL'
,p_validation_sequence=>20
,p_validation=>'P7020_FROM_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se requiere una automatizaci\00F3n para copiar.')
,p_when_button_pressed=>wwv_flow_api.id(1934093123374311.4001)
,p_associated_item=>wwv_flow_api.id(1380091207188246.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1934247886374313.4001)
,p_validation_name=>'New Name must be not null'
,p_validation_sequence=>30
,p_validation=>'P7020_COPY_NEW_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_when_button_pressed=>wwv_flow_api.id(1934093123374311.4001)
,p_associated_item=>wwv_flow_api.id(1380188239188247.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1934320286374314.4001)
,p_validation_name=>'New Static ID must be not null'
,p_validation_sequence=>40
,p_validation=>'P7020_COPY_NEW_STATIC_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_when_button_pressed=>wwv_flow_api.id(1934093123374311.4001)
,p_associated_item=>wwv_flow_api.id(1380273100188248.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1934723236374318.4001)
,p_validation_name=>'New Name must not yet exist'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P7020_COPY_NEW_NAME;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ya existe el nombre de la nueva automatizaci\00F3n. ')
,p_when_button_pressed=>wwv_flow_api.id(1934093123374311.4001)
,p_associated_item=>wwv_flow_api.id(1380188239188247.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1934821394374319.4001)
,p_validation_name=>'New Static ID must not yet exist'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and static_id         = :P7020_COPY_NEW_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ya existe el ID est\00E1tico de la nueva automatizaci\00F3n. ')
,p_when_button_pressed=>wwv_flow_api.id(1934093123374311.4001)
,p_associated_item=>wwv_flow_api.id(1380188239188247.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1933013795374301.4001)
,p_name=>'This App'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7020_COPY_SOURCE'
,p_condition_element=>'P7020_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1933135420374302.4001)
,p_event_id=>wwv_flow_api.id(1933013795374301.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1933528357374306.4001)
,p_event_id=>wwv_flow_api.id(1933013795374301.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1933463560374305.4001)
,p_event_id=>wwv_flow_api.id(1933013795374301.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':FB_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1933603263374307.4001)
,p_event_id=>wwv_flow_api.id(1933013795374301.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1933829550374309.4001)
,p_name=>'Copy Automation'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1933766281374308.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1935296164374323.4001)
,p_event_id=>wwv_flow_api.id(1933829550374309.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS,P7020_FROM_ID,P7020_COPY_NEW_ID,P7020_COPY_NEW_NAME,P7020_COPY_NEW_STATIC_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1935373169374324.4001)
,p_event_id=>wwv_flow_api.id(1933829550374309.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_COPY_SOURCE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'THIS'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1933915141374310.4001)
,p_event_id=>wwv_flow_api.id(1933829550374309.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1379958984188245.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1934547498374316.4001)
,p_name=>'Cancel Copy Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1934466572374315.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1934695503374317.4001)
,p_event_id=>wwv_flow_api.id(1934547498374316.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1379958984188245.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1926284457406301.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_automation.execute_due_automations( p_automation_id => :P7020_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'PLAY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Ejecuci\00F3n de automatizaci\00F3n iniciada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1934960443374320.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P7020_COPY_NEW_ID :=wwv_flow_automation_dev.copy(',
'                    p_id           => :P7020_FROM_ID,',
'                    p_to_name      => :P7020_COPY_NEW_NAME,',
'                    p_to_static_id => :P7020_COPY_NEW_STATIC_ID,',
'                    p_to_flow_id   => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1934093123374311.4001)
,p_process_success_message=>unistr('Automatizaci\00F3n copiada.')
);
end;
/
prompt --application/pages/page_07021
begin
wwv_flow_api.create_page(
 p_id=>7021.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar automatizaci\00F3n')
,p_alias=>'EDIT-AUTOMATION'
,p_step_title=>unistr('Editar automatizaci\00F3n')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'function buildInterval() {',
'    var lIntervalString = ''FREQ='' + $v("P7021_INT_FREQUENCY") +',
'                          '';INTERVAL='' + $v("P7021_INT_INTERVAL");',
'    ',
'    if ( $v("P7021_BYDAY") !== "" && $v("P7021_INT_FREQUENCY") !== "DAILY" && $v("P7021_BYDAY") !== "MON:TUE:WED:THU:FRI:SAT:SUN" ) {',
'       lIntervalString =  lIntervalString + ";BYDAY=" + $v("P7021_BYDAY").replace(/:/g,",");',
'    }',
'    if ( $v("P7021_BYHOUR") !== "" && $v("P7021_INT_FREQUENCY") !== "HOURLY") {',
'       lIntervalString =  lIntervalString + ";BYHOUR=" + $v("P7021_BYHOUR");',
'    }',
'    if ( $v("P7021_BYMINUTE") !== "" && $v("P7021_INT_FREQUENCY") !== "MINUTELY" ) {',
'       lIntervalString =  lIntervalString + ";BYMINUTE=" + $v("P7021_BYMINUTE");',
'    }',
'        ',
'    return lIntervalString;',
'}'))
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1807698834591844.4001)
,p_plug_name=>unistr('Ejecuci\00F3n de acci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>'style="padding-top: 10px"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2513514643671712.4001)
,p_plug_name=>unistr('Par\00E1metros relacionados con consultas')
,p_parent_plug_id=>wwv_flow_api.id(1807698834591844.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2517114410671748.4001)
,p_plug_name=>'Solo para datos encontrados'
,p_parent_plug_id=>wwv_flow_api.id(2513514643671712.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2513640627671713.4001)
,p_plug_name=>unistr('Par\00E1metros Comunes')
,p_parent_plug_id=>wwv_flow_api.id(1807698834591844.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2065703853407625.4001)
,p_plug_name=>unistr('Cuerpo de la funci\00F3n que devuelve un valor booleano')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2066950595407637.4001)
,p_plug_name=>'Local'
,p_parent_plug_id=>wwv_flow_api.id(2065703853407625.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2067168170407639.4001)
,p_plug_name=>'Remoto'
,p_parent_plug_id=>wwv_flow_api.id(2065703853407625.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2500558986513154.4001)
,p_plug_name=>unistr('Configuraci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTOMATIONS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2901312169394606.4001)
,p_plug_name=>unistr('Automatizaci\00F3n: &P7021_NAME.')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2901494873394607.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2901534819394608.4001)
,p_plug_name=>'Nombre'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4800138856119501.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4800456594119504.4001)
,p_plug_name=>'Automatizaciones'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Las <strong>automatizaciones</strong> inician un juego secuencial de procesos. Se utilizan para supervisar datos y, posteriormente, realizar la acci\00F3n adecuada (por ejemplo, la aprobaci\00F3n autom\00E1tica de solicitudes espec\00EDficas y el env\00EDo de alertas de')
||unistr(' correo electr\00F3nico).'),
'</p>',
'<p>',
unistr('Las <strong>acciones de automatizaci\00F3n</strong> se disparan una vez por cada fila devuelta por el origen de automatizaci\00F3n. Una acci\00F3n puede hacer referencia a los valores de cada columna para cada fila usando la sintaxis de variable de enlace.</p>'),
'<p>',
unistr('Despu\00E9s de <em>importar</em> una aplicaci\00F3n, se <em>desactivar\00E1n</em> las automatizaciones para evitar que se ejecuten varias a la vez. La automatizaci\00F3n debe estar activada, en esta p\00E1gina o con el paquete <strong>APEX_AUTOMATION</strong>.</p>'),
unistr('<p><a target="_blank" href="&SYSTEM_HELP_URL./htmdb/managing-automations.html">M\00E1s informaci\00F3n ...</a></p>'),
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4803374779119533.4001)
,p_plug_name=>unistr('Ejecuci\00F3n de c\00F3digo adicional')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4803890382119538.4001)
,p_plug_name=>'Acciones'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTOMATION_ACTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'automation_id = :P7021_ID and  ',
'flow_id = :FB_FLOW_ID and  ',
'security_group_id = :flow_security_group_id'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Acciones'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804039241119540.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_link_target=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_7021'',set:{''P7021_ACTION_ID'':''&ID.''}});'
,p_link_text=>'<span class="a-Icon icon-edit" title="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804163839119541.4001)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804275890119542.4001)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804317400119543.4001)
,p_name=>'AUTOMATION_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'AUTOMATION_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804423459119544.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Nombre'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804541306119545.4001)
,p_name=>'EXECUTION_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'EXECUTION_SEQUENCE'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>unistr('Secuencia de Ejecuci\00F3n')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804675812119546.4001)
,p_name=>'ACTION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>unistr('Tipo de Acci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(362343527524601835)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804747120119547.4001)
,p_name=>'ACTION_CLOB'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_CLOB'
,p_data_type=>'CLOB'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('CLOB de acci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>32767
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804885799119548.4001)
,p_name=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_01'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 01'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4804959696119549.4001)
,p_name=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_02'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 02'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(4805006066119550.4001)
,p_name=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_03'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 03'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5813956115534501.4001)
,p_name=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_04'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 04'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814085723534502.4001)
,p_name=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_05'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 05'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814117196534503.4001)
,p_name=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_06'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 06'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814269683534504.4001)
,p_name=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_07'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 07'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814321181534505.4001)
,p_name=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_08'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 08'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>180
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814496797534506.4001)
,p_name=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_09'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 09'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>190
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814536296534507.4001)
,p_name=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_10'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 10'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>200
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814671610534508.4001)
,p_name=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_11'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 11'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>210
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814715906534509.4001)
,p_name=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_12'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 12'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>220
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814822881534510.4001)
,p_name=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_13'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 13'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>230
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5814986034534511.4001)
,p_name=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_14'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 14'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>240
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815062608534512.4001)
,p_name=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_15'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Atributo 15'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>250
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815166754534513.4001)
,p_name=>'LOCATION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOCATION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>unistr('Ubicaci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>260
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(3842073961668883)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815218564534514.4001)
,p_name=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REMOTE_SERVER_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'ID de servidor remoto'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>270
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815373703534515.4001)
,p_name=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'WEB_SRC_MODULE_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>unistr('ID de m\00F3dulo de origen web')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>280
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815411031534516.4001)
,p_name=>'WEB_SRC_OPERATION_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'WEB_SRC_OPERATION_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>unistr('ID de operaci\00F3n de origen web')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>290
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815558620534517.4001)
,p_name=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ERROR_MESSAGE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Mensaje de Error'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>300
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815678589534518.4001)
,p_name=>'STOP_EXECUTION_ON_ERROR'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'STOP_EXECUTION_ON_ERROR'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>310
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815712882534519.4001)
,p_name=>'CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITION_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Tipo de Condici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>320
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
end;
/
begin
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815818983534520.4001)
,p_name=>'CONDITION_EXPR1'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITION_EXPR1'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Expresi\00F3n de condici\00F3n 1')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>330
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5815959127534521.4001)
,p_name=>'CONDITION_EXPR2'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITION_EXPR2'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Expresi\00F3n de condici\00F3n 2')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>340
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816055949534522.4001)
,p_name=>'EXEC_COND_FOR_EACH_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'EXEC_COND_FOR_EACH_ROW'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Ejecutar condici\00F3n para cada fila')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>350
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>1
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816113084534523.4001)
,p_name=>'BUILD_OPTION_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BUILD_OPTION_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>unistr('ID de opci\00F3n de creaci\00F3n')
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>360
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816229551534524.4001)
,p_name=>'ACTION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_COMMENT'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Comentario de acci\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>370
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816379685534525.4001)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Creado por'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>380
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816493910534526.4001)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER_JET'
,p_heading=>'Creado el'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>390
,p_value_alignment=>'CENTER'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
,p_attribute_12=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_13=>'VISIBLE'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816505519534527.4001)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('\00DAltima Actualizaci\00F3n por')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>400
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816685002534528.4001)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER_JET'
,p_heading=>unistr('\00DAltima Actualizaci\00F3n el')
,p_heading_alignment=>'CENTER'
,p_display_sequence=>410
,p_value_alignment=>'CENTER'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
,p_attribute_12=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_13=>'VISIBLE'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816725864534529.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(5816809960534530.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(4803910563119539.4001)
,p_internal_uid=>4803910563119539
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>unistr('Haga clic en <strong>Agregar acci\00F3n</strong> para crear la primera acci\00F3n.')
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5426552263545892.4001)
,p_plug_name=>'Creador de intervalos'
,p_region_name=>'interval-builder'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>110
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p>Este cuadro de di\00E1logo ayuda a crear una <em>expresi\00F3n de calendario de programador</em> sencilla para especificar la frecuencia con la que se ejecuta la automatizaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5702933124970087.4001)
,p_plug_name=>unistr('Condici\00F3n de servidor')
,p_region_name=>'COND'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_api.id(60628322026519501.4001)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>'(null)'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(96107915683078518.4001)
,p_plug_name=>'Origen'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2903682401394629.4001)
,p_plug_name=>'origen de datos remoto'
,p_parent_plug_id=>wwv_flow_api.id(96107915683078518.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2064319266407611.4001)
,p_plug_name=>'detalles del origen de datos remoto'
,p_parent_plug_id=>wwv_flow_api.id(2903682401394629.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2903704119394630.4001)
,p_plug_name=>'Origen de datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(96107915683078518.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2063557467407603.4001)
,p_plug_name=>'Detalles de origen de REST'
,p_parent_plug_id=>wwv_flow_api.id(2903704119394630.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2514185254671718.4001)
,p_plug_name=>'Guarde los cambios'
,p_parent_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Debe guardar los cambios para poder editar los detalles del origen de datos de REST.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6353168577393099.4001)
,p_plug_name=>unistr('Par\00E1metros de origen de REST')
,p_parent_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id, ',
'       pa.name,',
'       cp.value_type,',
'       cp.value_language,',
'       cp.value',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_params pa',
' where pa.id                = cp.web_src_param_id',
'    -- ',
'   and cp.automation_id     = :P7021_ID',
'   and cp.security_group_id = :WORKSPACE_ID',
'   and cp.flow_id           = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P7021_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params cp',
' where cp.automation_id = :P7021_ID'))
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Par\00E1metros')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(1567495226713205.4001)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6354110652393108.4001)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6354167888393109.4001)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>unistr('Nombre de par\00E1metro de origen de REST')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>unistr('Identifica el <em>nombre</em> del par\00E1metro de origen de datos de REST.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6354256819393110.4001)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Tipo de Valor'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_api.id(358243382603181986)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la forma en la que se rellena este par\00E1metro.</p><p>Entre las opciones disponibles se incluyen las siguientes:</p>'),
'<ul>',
unistr('    <li><strong>Valor est\00E1tico</strong>: def\00EDnalo seg\00FAn el texto introducido en el <em>valor est\00E1tico</em>.</li>'),
unistr('    <li><strong>Elemento</strong>: def\00EDnalo seg\00FAn el valor retenido en el estado de sesi\00F3n del <em>elemento</em> especificado.</li>'),
unistr('    <li><strong>Consulta SQL (devolver valor \00FAnico)</strong>: def\00EDnalo seg\00FAn el primer valor devuelto de la <em>consulta SQL</em> introducida.</li>'),
unistr('    <li><strong>Expresi\00F3n PL/SQL</strong>: def\00EDnalo seg\00FAn el valor resultante al ejecutar la <em>expresi\00F3n PL/SQL</em> introducida.</li>'),
unistr('    <li><strong>Cuerpo de la funci\00F3n PL/SQL</strong>: def\00EDnalo seg\00FAn el valor devuelto del <em>cuerpo de la funci\00F3n PL/SQL</em> introducido.</li>'),
unistr('    <li><strong>Recopilaci\00F3n (CLOB)</strong>: def\00EDnalo seg\00FAn el valor de columna de CLOB de la primera fila de la <em>recopilaci\00F3n</em> introducida.</li>'),
unistr('    <li><strong>Preferencia</strong>: def\00EDnalo seg\00FAn el valor de la <em>preferencia</em> introducida.</li>'),
unistr('    <li><strong>Nulo</strong>: def\00EDnalo en nulo si no se especifica ning\00FAn valor.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6354377376393111.4001)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>unistr('Expresi\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>unistr('Proporcione la expresi\00F3n a continuaci\00F3n, seg\00FAn la columna <strong>Tipo de valor </strong>.')
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6354449471393112.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(6354580143393113.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_display_condition_type=>'NEVER'
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(6354024916393107.4001)
,p_internal_uid=>6354024916393107
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>unistr('No se ha definido ning\00FAn par\00E1metro.')
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4995340600973144.4001)
,p_plug_name=>'origen de datos local'
,p_parent_plug_id=>wwv_flow_api.id(96107915683078518.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5817521371534537.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(4803890382119538.4001)
,p_button_name=>'ADD_ACTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Agregar acci\00F3n')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:7022:&SESSION.::&DEBUG.:7022:P7022_AUTOMATION_ID:&P7021_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2022286112169334.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5426552263545892.4001)
,p_button_name=>'BUILD_INTERVAL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Definir intervalo de ejecuci\00F3n')
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2529714709513169.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(2901312169394606.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2530582957513170.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(2901312169394606.4001)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P7021_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2530968069513170.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(2901312169394606.4001)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Guardar cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P7021_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2531343429513170.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(2901312169394606.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P7021_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2064814695407616.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(2901312169394606.4001)
,p_button_name=>'PLAY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Guardar y ejecutar'
,p_button_position=>'NEXT'
,p_button_condition=>'P7021_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(5817141222534533.4001)
,p_branch_name=>'Go to Page 7022'
,p_branch_action=>'f?p=&APP_ID.:7022:&SESSION.::&DEBUG.:7022:P7022_ID:&P7021_ACTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_7021'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2065397326407621.4001)
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.::P7021_ID:&P7021_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(2064814695407616.4001)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1379229546188238.4001)
,p_branch_name=>'Go To Page 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021:P7021_ID,P7021_RETURN_TO_PAGE:&P7021_ID.,&P7021_RETURN_TO_PAGE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'', ''SAVE'') and :P7021_RETURN_TO_PAGE = ''YES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2531625419513170.4001)
,p_branch_name=>'Go To Page 7020'
,p_branch_action=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.:7021::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1377476877188220.4001)
,p_name=>'P7021_TABLE_USELOCALSYNCTABLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_source=>'USE_LOCAL_SYNC_TABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1561714301645591.4001)
,p_name=>'P7021_CONDITION_LANG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(5702933124970087.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1562580979647574.4001)
,p_name=>'P7021_CONDITION_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(5702933124970087.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1567001921713201.4001)
,p_name=>'P7021_FUNCTION_BODY_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Idioma'
,p_source=>'FUNCTION_BODY_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1567123283713202.4001)
,p_name=>'P7021_REMOTE_FUNC_BODY_LANG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1567229026713203.4001)
,p_name=>'P7021_POST_PROC_FUNC_BODY_LANG'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1805210902591820.4001)
,p_name=>'P7021_REMOTE_INCLUDE_ROWID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_prompt=>'Incluir columna ROWID'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Especifica si la pseudocolumna ROWID se debe seleccionar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1805381557591821.4001)
,p_name=>'P7021_POST_PROCESS_ORDERBY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_prompt=>unistr('Cl\00E1usula ORDER BY')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una cl\00E1usula ORDER BY de SQL v\00E1lida para ordenar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1805468247591822.4001)
,p_name=>'P7021_POST_PROCESS_WHERE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1805546008591823.4001)
,p_name=>'P7021_POST_PROCESS_QUERY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_prompt=>'Consulta SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca una consulta SQL para transformar los datos recuperados del origen de datos de REST. Seleccione de la pseudotabla #APEX$SOURCE_DATA# y especifique las columnas disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1u')
||unistr('sula WITH SQL no est\00E1 soportada aqu\00ED.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1805670814591824.4001)
,p_name=>'P7021_POST_PROC_FUNC_BODY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_prompt=>unistr('Cuerpo de la funci\00F3n que devuelve una consulta SQL')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un cuerpo de la funci\00F3n, donde la consulta SQL devuelta transforma los datos recuperados del origen de REST. La consulta SQL devuelta por el cuerpo de la funci\00F3n debe seleccionar de la pseudotabla #APEX$SOURCE_DATA# y leer las columnas dis')
||unistr('ponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1usula WITH SQL no est\00E1 soportada aqu\00ED.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P7021_POST_PROC_FUNC_BODY_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1807990044591847.4001)
,p_name=>'P7021_OLD_LOCATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(96107915683078518.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1920697193175901.4001)
,p_name=>'P7021_RETURN_TO_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(4800456594119504.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RETURN_TO_PAGE_Y'
,p_lov=>'.'||wwv_flow_api.id(84870610048415471.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1935415110374325.4001)
,p_name=>'P7021_MIN_CADENCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2901534819394608.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2022634549169338.4001)
,p_name=>'P7021_INT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(5426552263545892.4001)
,p_item_default=>'1'
,p_prompt=>'Intervalo'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un valor entero positivo que represente la frecuencia de repetici\00F3n. El valor por defecto es 1, lo que significa que la frecuencia es de cada minuto en por minuto, cada d\00EDa en diario, etc. El valor m\00E1ximo es 999.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2023526259169347.4001)
,p_name=>'P7021_INT_FREQUENCY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(5426552263545892.4001)
,p_item_default=>'DAILY'
,p_prompt=>'Frecuencia'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SCHEDULE_BUILDER_FREQUENCY'
,p_lov=>'.'||wwv_flow_api.id(601098854036755106.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de repetici\00F3n. Los valores de frecuencia predefinidos posibles son <strong>Semanal</strong>, <strong>Diario</strong>, <strong>Por hora</strong> y <strong>Por minuto</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2024443788169347.4001)
,p_name=>'P7021_BYDAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(5426552263545892.4001)
,p_item_default=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_prompt=>unistr('D\00EDa de ejecuci\00F3n')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SCHEDULE_BUILDER_BYDAY'
,p_lov=>'.'||wwv_flow_api.id(601095219556747684.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el d\00EDa de la semana, de lunes a domingo, con el formato LUN, MAR, etc.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2025340909169348.4001)
,p_name=>'P7021_BYHOUR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(5426552263545892.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Hora de ejecuci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca la hora a la que el trabajo se va a ejecutar. Los valores v\00E1lidos son de 0 a 23. Por ejemplo, 10 quiere decir a las 10 a.m.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2026284504169348.4001)
,p_name=>'P7021_BYMINUTE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(5426552263545892.4001)
,p_item_default=>'0'
,p_prompt=>unistr('Minuto de ejecuci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el minuto en el que el trabajo se va a ejecutar. Los valores v\00E1lidos son de 0 a 59. Por ejemplo, 45 quiere decir 45 minutos despu\00E9s de la hora seleccionada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2063305422407601.4001)
,p_name=>'P7021_REMOTE_WHERE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Donde'
,p_source=>'QUERY_WHERE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2063401132407602.4001)
,p_name=>'P7021_REMOTE_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Ordenar por'
,p_source=>'QUERY_ORDER_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca una expresi\00F3n ORDER BY de SQL v\00E1lida para ordenar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2064555861407613.4001)
,p_name=>'P7021_OLD_POLLING_STATUS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2065645269407624.4001)
,p_name=>'P7021_SOURCE_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_default=>'QUERY'
,p_prompt=>'Acciones iniciadas el'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7021_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601093532765741216.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex- apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique el tipo de origen de datos para esta automatizaci\00F3n.'),
'<ul>',
unistr('    <li><strong>Consulta</strong>: se ejecutar\00E1 una consulta SQL. Las acciones de automatizaci\00F3n se pueden ejecutar cuando se encuentran datos (para cada fila), o bien cuando no se encuentran datos (una vez).</li>'),
unistr('    <li><strong>PL/SQL que devuelve un valor booleano</strong>: se ejecuta un cuerpo de funci\00F3n PL/SQL. Si devuelve <strong>true</strong>, las acciones de automatizaci\00F3n se ejecutan una vez.</li>'),
unistr('    <li><strong>Siempre</strong>: las acciones de automatizaci\00F3n se ejecutan siempre. El uso de esta opci\00F3n est\00E1 recomendado con el tipo <strong>Programaci\00F3n</strong>, para ejecutar las acciones seg\00FAn una programaci\00F3n, independientemente de la presen')
||'cia de determinados datos.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2065864931407626.4001)
,p_name=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2065703853407625.4001)
,p_item_default=>'LOCAL'
,p_prompt=>unistr('Ubicaci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_LOCATIONS'
,p_lov=>'.'||wwv_flow_api.id(601110993871808630.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione d\00F3nde se va a ejecutar la funci\00F3n PL/SQL que devuelve un valor booleano.'),
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
unistr('    Ejecuta el cuerpo de la funci\00F3n PL/SQL en la base de datos local.</li>'),
'    <li><strong>Servicio SQL activado para REST</strong><br>',
unistr('    Ejecuta el cuerpo de la funci\00F3n PL/SQL en una base de datos remota, donde la conexi\00F3n se define usando SQL activado para REST. Para crear o mantener referencias SQL activadas para REST, vaya a Componentes compartidos > SQL activado para REST.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2065976767407627.4001)
,p_name=>'P7021_LOCAL_FUNC_BODY_BOOLEAN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2066950595407637.4001)
,p_prompt=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve un valor booleano')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano que se ejecute cuando se ejecute la automatizaci\00F3n. Si el cuerpo de la funci\00F3n devuelve <strong>true</strong>, las acciones se ejecutar\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'BOOLEAN'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P7021_LOCAL_FUNCBODYBOOL_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2066030221407628.4001)
,p_name=>'P7021_REMOTE_PLSQL_BOOLEAN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2067168170407639.4001)
,p_prompt=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve un valor booleano')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Proporcione un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano que se ejecute cuando se ejecute la automatizaci\00F3n. Si el cuerpo de la funci\00F3n devuelve <strong>true</strong>, las acciones se ejecutar\00E1n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'BOOLEAN'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_05=>'P7021_PLSQL_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2066153096407629.4001)
,p_name=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2067168170407639.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione una referencia de SQL activado para REST.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2320310780209549.4001)
,p_name=>'P7021_LOCAL_FUNCBODYBOOL_LANG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2066950595407637.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2500964129513156.4001)
,p_name=>'P7021_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2901534819394608.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2501319977513158.4001)
,p_name=>'P7021_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2901534819394608.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2502179976513160.4001)
,p_name=>'P7021_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2901534819394608.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Nombre de esta automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2502532715513160.4001)
,p_name=>'P7021_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2901534819394608.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Identificador Est\00E1tico')
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('ID est\00E1tico para esta automatizaci\00F3n. El ID est\00E1tico se utiliza cuando se ejecuta manualmente la automatizaci\00F3n con el paquete <strong>APEX_AUTOMATION</strong> (<strong>APEX_AUTOMATION.EXECUTE</strong>).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2503305198513160.4001)
,p_name=>'P7021_TRIGGER_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Tipo'
,p_source=>'TRIGGER_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_TRIGGER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1355426926728029.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las automatizaciones con una <strong>programaci\00F3n</strong> se ejecutar\00E1n autom\00E1ticamente seg\00FAn la frecuencia seleccionada. Si se selecciona <strong>A petici\00F3n</strong>, la automatizaci\00F3n solo se ejecutar\00E1 cuando se la llame expl\00EDcitamente mediante el')
||' paquete APEX_AUTOMATION.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2503723575513160.4001)
,p_name=>'P7021_POLLING_INTERVAL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Expresi\00F3n de programaci\00F3n')
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#sync-details" id="P7021_EDIT_POLLING_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" title="Schedule Builder" tabindex="0"><span class="a-Icon icon-utilities-build-interval"></span><span class="u-VisuallyHidd'
||'en">Compilador de programa</span></a><a href="#sync-details" id="P7021_CLEAR_POLLING_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon"  tabindex="0" title="Clear Schedule"><span class="a-Icon icon-remove"></span><span cl'
||'ass="u-VisuallyHidden">Borrar programa</span></a>',
''))
,p_source=>'POLLING_INTERVAL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Utilice la <em>sintaxis de calendario de programador de base de datos</em> para definir programas de ejecuci\00F3n repetitivos, como "todos los martes y viernes a las 4:00 p.m." o "el segundo mi\00E9rcoles de cada mes". '),
'</p>',
'<p>',
unistr('    La sintaxis del calendario puede ser introducida manualmente, o de forma declarativa usando el <strong>creador de intervalos</strong>, para crear expresiones simples. Haga clic en el <em>icono de llave inglesa</em> debajo del \00E1rea de texto de la ')
||unistr('expresi\00F3n de calendario, para abrir el creador de intervalos.'),
'</p>',
'<p>',
unistr('    Para tener m\00E1s programas de ejecuci\00F3n compleja, consulte los detalles sobre la <strong>sintaxis de calendario de programador</strong> en la documentaci\00F3n del paquete PL/SQL <strong>DBMS_SCHEDULER</strong> e introduzca su expresi\00F3n de forma manual')
||'.',
'</p>',
'<p>',
unistr('    Esta instancia de &PRODUCT_NAME. se ha configurado para que se necesiten al menos &P7021_MIN_CADENCE. minutos entre dos ejecuciones de automatizaci\00F3n.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2504190914513160.4001)
,p_name=>'P7021_POLL_LAST_RUN_TIMESTAMP'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_is_query_only=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('\00DAltima Ejecuci\00F3n')
,p_format_mask=>'SINCE'
,p_source=>'POLLING_LAST_RUN_TIMESTAMP'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P7021_POLL_LAST_RUN_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Indica cuando se ha ejecutado esta automatizaci\00F3n por \00FAltima vez.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2504959513513161.4001)
,p_name=>'P7021_POLL_NEXT_RUN_TIMESTAMP'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_is_query_only=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Vencimiento de pr\00F3xima ejecuci\00F3n')
,p_format_mask=>'SINCE'
,p_source=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P7021_POLL_NEXT_RUN_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Indica <em>para cu\00E1ndo</em> est\00E1 programada la pr\00F3xima ejecuci\00F3n. Tenga en cuenta que las ejecuciones de automatizaci\00F3n se inician con un trabajo de coordinaci\00F3n, que se ejecuta a intervalos regulares. As\00ED que la automatizaci\00F3n se ejecutar\00E1 realmente')
||unistr(' hasta unos minutos <em>despu\00E9s</em> del momento de ejecuci\00F3n previsto.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2505746718513161.4001)
,p_name=>'P7021_POLLING_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Estado de programaci\00F3n')
,p_source=>'POLLING_STATUS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_POLLING_STATUS'
,p_lov=>'.'||wwv_flow_api.id(1358229692738259.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indica el estado de esta programaci\00F3n de automatizaci\00F3n.'),
'<ul>',
unistr('    <li><strong>Activo</strong>: la programaci\00F3n est\00E1 activa y la automatizaci\00F3n se ejecutar\00E1 seg\00FAn la <strong>expresi\00F3n de la programaci\00F3n</strong>.</li>'),
unistr('    <li><strong>Desactivado</strong>: la programaci\00F3n no se ejecutar\00E1. No obstante, la automatizaci\00F3n se puede ejecutar mediante el paquete PL/SQL <strong>APEX_AUTOMATION</strong>.</li>'),
unistr('    <li><strong>Error</strong>: la programaci\00F3n est\00E1 desactivada porque se ha producido un error durante la \00FAltima ejecuci\00F3n. No obstante, la automatizaci\00F3n se puede seguir ejecutando mediante la llamada al paquete PL/SQL <strong>APEX_AUTOMATION</str')
||'ong>.</li> ',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2506127162513161.4001)
,p_name=>'P7021_RESULT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2513514643671712.4001)
,p_item_default=>'ROWS'
,p_prompt=>'Ejecutar acciones cuando'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601105473256773090.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique si las acciones de automatizaci\00F3n se deben ejecutar cuando la consulta <em>devuelve filas</em> o cuando la consulta <em>no devuelve filas</em>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2510517742513163.4001)
,p_name=>'P7021_SOURCE_POST_PROCESSING'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_default=>'NONE'
,p_prompt=>'Tipo de procesamiento posterior'
,p_source=>'SOURCE_POST_PROCESSING'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov=>'.'||wwv_flow_api.id(601113045750817318.4001)||'.'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione c\00F3mo procesar posteriormente los datos de origen de REST recuperados en la base de datos local.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2510932862513163.4001)
,p_name=>'P7021_INCLUDE_ROWID_COLUMN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Incluir columna ROWID'
,p_source=>'INCLUDE_ROWID_COLUMN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Especifica si la pseudocolumna ROWID se debe seleccionar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2512504424513163.4001)
,p_name=>'P7021_PK_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2517114410671748.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_source=>'PK_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location               => :P7021_LOCATION,',
'      p_query_type             => case :P7021_LOCATION ',
'                                      when ''LOCAL''  then :P7021_LOCAL_DATA_SOURCE_TYPE',
'                                      when ''REMOTE'' then :P7021_REMOTE_DATA_SOURCE_TYPE end,',
'      p_owner                  => case :P7021_LOCATION ',
'                                      when ''LOCAL''  then :P7021_TABLE_OWNER',
'                                      when ''REMOTE'' then :P7021_REMOTE_TABLE_OWNER end,',
'      p_table_name             => case :P7021_LOCATION ',
'                                      when ''LOCAL''  then :P7021_TABLE_NAME',
'                                      when ''REMOTE'' then :P7021_REMOTE_TABLE_NAME end,',
'      p_sql_query              => case ',
'                                      when :P7021_LOCATION = ''LOCAL''      and :P7021_LOCAL_DATA_SOURCE_TYPE  = ''SQL'' then :P7021_SQL',
'                                      when :P7021_LOCATION = ''REMOTE''     and :P7021_REMOTE_DATA_SOURCE_TYPE = ''SQL'' then :P7021_REMOTE_SQL',
'                                      when :P7021_LOCATION = ''WEB_SOURCE'' and :P7021_SOURCE_POST_PROCESSING  = ''SQL'' then :P7021_POST_PROCESS_QUERY',
'                                  end,      ',
'      p_function_body          => case ',
'                                      when :P7021_LOCATION = ''LOCAL''      and :P7021_LOCAL_DATA_SOURCE_TYPE  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY',
'                                      when :P7021_LOCATION = ''REMOTE''     and :P7021_REMOTE_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY',
'                                      when :P7021_LOCATION = ''WEB_SOURCE'' and :P7021_SOURCE_POST_PROCESSING  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_POST_PROC_FUNC_BODY',
'                                  end,      ',
'      p_function_body_language => case ',
'                                    when :P7021_LOCATION = ''LOCAL''      and :P7021_LOCAL_DATA_SOURCE_TYPE  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY_LANGUAGE',
'                                    when :P7021_LOCATION = ''REMOTE''     and :P7021_REMOTE_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY_LANG',
'                                    when :P7021_LOCATION = ''WEB_SOURCE'' and :P7021_SOURCE_POST_PROCESSING  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_POST_PROC_FUNC_BODY_LANG',
'                                  end,      ',
'      p_web_src_module_id      => case when :P7021_LOCATION = ''WEB_SOURCE'' then :P7021_WEB_SRC_MODULE_ID end,',
'      p_remote_server_id       => case when :P7021_LOCATION = ''REMOTE''     then :P7021_REMOTE_SERVER_ID end,',
'      p_post_processing_type   => case when :P7021_LOCATION = ''WEB_SOURCE'' then ',
'                                      case when :P7021_SOURCE_POST_PROCESSING != ''NONE'' then :P7021_SOURCE_POST_PROCESSING end ',
'                                  end ))',
'union all',
'select ''ROWID (Varchar2)'' column_name_esc,',
'       ''ROWID''            column_name',
'  from sys.dual',
' where case :P7021_LOCATION',
'           when ''LOCAL''  then :P7021_INCLUDE_ROWID_COLUMN ',
'           when ''REMOTE'' then :P7021_REMOTE_INCLUDE_ROWID end = ''Y'' ',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_display_when=>'P7021_SOURCE_TYPE'
,p_display_when2=>'QUERY'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique la columna de <em>clave primaria</em> dentro del resultado de la consulta. El valor de esta columna se agregar\00E1 a los mensajes de log, para permitir la correlaci\00F3n de los mensajes de log con las filas de origen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2512935171513163.4001)
,p_name=>'P7021_MAX_ROWS_TO_PROCESS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(2517114410671748.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('M\00E1ximo de Filas para Procesar')
,p_source=>'MAX_ROWS_TO_PROCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>18
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Si se especifica un valor para <strong>M\00E1ximo de filas para procesar</strong>, la ejecuci\00F3n de la automatizaci\00F3n se detendr\00E1 cuando se alcance ese m\00E1ximo y la automatizaci\00F3n se registrar\00E1 como <strong>Incompleta</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2513319851513164.4001)
,p_name=>'P7021_COMMIT_EACH_ROW'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(2517114410671748.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_default=>'N'
,p_prompt=>'Confirmar'
,p_source=>'COMMIT_EACH_ROW'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7021_COMMIT_EACH_ROW'
,p_lov=>'.'||wwv_flow_api.id(601100928341755832.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Especifique si desea confirmar cuando se hayan ejecutado las acciones de cada fila o si desea confirmar solo una vez cuando se hayan procesado todas las filas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2513364469671710.4001)
,p_name=>'P7021_TABLE_RESULT_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2513514643671712.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_source=>'RESULT_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2513732961513164.4001)
,p_name=>'P7021_ERROR_HANDLING_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(2513640627671713.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Manejo de errores de la acci\00F3n')
,p_source=>'ERROR_HANDLING_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7021_ERROR_HANDLING_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601102221885756461.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione qu\00E9 debe suceder cuando la automatizaci\00F3n detecte un error:</p>'),
'<ul>',
unistr('    <li><strong>Ignorar</strong>: permite ignorar el error y continuar procesando la automatizaci\00F3n</li>'),
unistr('    <li><strong>Abortar automatizaci\00F3n</strong>: permite abortar la automatizaci\00F3n, pero dejarla activada</li>'),
unistr('    <li><strong>Desactivar automatizaci\00F3n</strong>: permite abortar la automatizaci\00F3n y desactivarla</li>'),
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2514111507513164.4001)
,p_name=>'P7021_CODE_SNIPPET'
,p_source_data_type=>'CLOB'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4803374779119533.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('C\00F3digo PL/SQL ejecutable')
,p_source=>'CODE_SNIPPET'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un bloque de c\00F3digo PL/SQL an\00F3nimo que contenga los procedimientos que llamar para la inicializaci\00F3n o la limpieza de la automatizaci\00F3n, o antes del procesamiento de la acci\00F3n de cada fila.</p>'),
'',
unistr('<p>Por motivos de rendimiento, tambi\00E9n puede almacenar este c\00F3digo en un paquete PL/SQL en la base de datos.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTIONS'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2514525609513164.4001)
,p_name=>'P7021_INIT_PROC_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4803374779119533.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Nombre del procedimiento de inicializaci\00F3n')
,p_source=>'INIT_PROC_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Proporcione el nombre de un <strong>procedimiento de inicializaci\00F3n</strong>, que est\00E9 definido como objeto PL/SQL en el esquema de la base de datos, o en el <strong>c\00F3digo ejecutable</strong> anterior. APEX ejecutar\00E1 ese procedimiento al principio d')
||unistr('e una ejecuci\00F3n de automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2514913691513164.4001)
,p_name=>'P7021_BEFORE_PROCESSING_PROC_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(4803374779119533.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Nombre del procedimiento de procesamiento antes de ejecuci\00F3n de la fila')
,p_source=>'BEFORE_PROCESSING_PROC_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Proporcione el nombre de un <strong>procedimiento de procesamiento antes de ejecuci\00F3n de la fila</strong>, que est\00E1 definido como objeto PL/SQL en el esquema de la base de datos, o en el <strong>c\00F3digo ejecutable</strong> anterior. APEX ejecutar\00E1 ese')
||' procedimiento para cada fila antes de empezar a ejecutar las acciones definidas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2515106339671728.4001)
,p_name=>'P7021_OLD_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2903704119394630.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2515319851513164.4001)
,p_name=>'P7021_TEARDOWN_PROC_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(4803374779119533.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Nombre del procedimiento de limpieza'
,p_source=>'TEARDOWN_PROC_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Proporcione el nombre de un <strong>procedimiento de limpieza</strong>, que est\00E1 definido como objeto PL/SQL en el esquema de la base de datos, o en el <strong>c\00F3digo ejecutable</strong> anterior. APEX ejecutar\00E1 ese procedimiento al final de la ejecu')
||unistr('ci\00F3n de automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2516192325671738.4001)
,p_name=>'P7021_OLD_PK_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2517114410671748.4001)
,p_prompt=>'Columna de Clave Primaria'
,p_post_element_text=>'<span class="display_only apex-item-display-only"><span style="color: #477D8A" title="Save Query in order to change the Primary Column" class="a-Icon icon-info"></span> <span>Guardar la consulta para cambiar la columna primaria.</span></span>'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2516992345513165.4001)
,p_name=>'P7021_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4800138856119501.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n -')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para esta automatizaci\00F3n.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si se activa o no un componente en una aplicaci\00F3n.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2517392135671750.4001)
,p_name=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_prompt=>unistr('Utilizar tabla de sincronizaci\00F3n')
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_modules',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P7021_WEB_SRC_MODULE_ID',
'   and sync_table_name  is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Active esta opci\00F3n para utilizar la tabla local, que se configura en la secci\00F3n Sincronizaci\00F3n de REST del <strong>origen de datos de REST</strong>, en lugar de comunicarse con el servicio REST externo.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2903863001394631.4001)
,p_name=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(601107956819795211.4001)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el tipo de origen de la automatizaci\00F3n. Las automatizaciones pueden estar basadas en tablas, en consultas SQL o en funciones PL/SQL que devuelva una consulta SQL. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2904340376394636.4001)
,p_name=>'P7021_FUNCTION_BODY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_prompt=>unistr('Introducir un cuerpo de la funci\00F3n que devuelve una consulta SQL')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique un cuerpo de la funci\00F3n que devuelve una consulta SQL que ser\00E1 el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n, por ejemplo:'),
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>',
unistr('Los valores de columna se pueden usar en las acciones de automatizaci\00F3n con sintaxis de variable de enlace (por ejemplo, <strong>:EMPNO</strong>). ')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P7021_FUNCTION_BODY_LANGUAGE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3218301351025544.4001)
,p_name=>'P7021_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(96107915683078518.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_default=>'LOCAL'
,p_prompt=>'Origen de Datos'
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group is-query'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione el <em>origen de datos</em> para esta automatizaci\00F3n.'),
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se obtienen de la base de datos local.</li>',
'    <li><strong>Servicio de SQL activado para REST</strong><br>',
unistr('    Los datos se obtienen de una base de datos remota, donde la conexi\00F3n se define usando SQL activado para REST. Para crear o mantener referencias SQL activadas para REST, vaya a Componentes compartidos > SQL activado para REST.'),
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos proceden de un servicio web de RESTful definido con los or\00EDgenes de datos de REST. Para crear o mantener los or\00EDgenes de datos de REST, vaya a Componentes compartidos > Or\00EDgenes de datos de REST.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3221292817025548.4001)
,p_name=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'QUERY_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_api.id(601107956819795211.4001)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas, consultas SQL o funciones PL/SQL que devuelvan una consulta SQL. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3222573974025549.4001)
,p_name=>'P7021_TABLE_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_source=>'QUERY_OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('Esquema de An\00E1lisis')
,p_lov_cascade_parent_items=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que se va a basar esta automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3223498365025549.4001)
,p_name=>'P7021_TABLE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_source=>'QUERY_TABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P7021_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P7021_TABLE_OWNER, wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P7021_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>128
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3224760802025550.4001)
,p_name=>'P7021_SQL'
,p_source_data_type=>'CLOB'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_source=>'QUERY_SOURCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que ser\00E1 el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n, por ejemplo:'),
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
unistr('Los valores de columna se pueden usar en las acciones de automatizaci\00F3n con sintaxis de variable de enlace (por ejemplo, <strong>:EMPNO</strong>). '),
unistr('Adem\00E1s de los datos de su consulta, puede utilizar <strong>APEX_AUTOMATION.GET_LAST_RUN</strong> para hacer referencia al registro de hora de la ejecuci\00F3n anterior de esta automatizaci\00F3n. Esto es \00FAtil para evitar procesar los datos dos veces.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3240000858025566.4001)
,p_name=>'P7021_WEB_SRC_MODULE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(2903704119394630.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Origen de Datos de REST'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Elija un origen de datos de REST. Las acciones se ejecutar\00E1n seg\00FAn el resultado de la acci\00F3n de la base de datos <em>Recuperar filas</em> de este origen de REST.'),
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3242897007025568.4001)
,p_name=>'P7021_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2903682401394629.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Elija el servicio SQL activado para REST en el que ejecutar la consulta. Las acciones de automatizaci\00F3n se ejecutar\00E1n seg\00FAn los resultados de esta consulta.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4501791612659931.4001)
,p_name=>'P7021_REMOTE_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que ser\00E1 el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n, por ejemplo:'),
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
unistr('Los valores de columna se pueden usar en acciones de automatizaci\00F3n con sintaxis de variable de enlace (por ejemplo, <strong>:EMPNO</strong>).')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P7021_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4502664655659932.4001)
,p_name=>'P7021_REMOTE_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7021_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P7021_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que se va a basar esta automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4503534755659932.4001)
,p_name=>'P7021_REMOTE_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7021_REMOTE_SERVER_ID, ''TABLE'', :P7021_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P7021_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P7021_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4801309424119513.4001)
,p_name=>'P7021_AUTOMATION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4800138856119501.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Comentarios'
,p_source=>'AUTOMATION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4803162714119531.4001)
,p_name=>'P7021_QUERY_WHERE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Cl\00E1usula WHERE')
,p_source=>'QUERY_WHERE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4803209177119532.4001)
,p_name=>'P7021_QUERY_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Cl\00E1usula Order By')
,p_source=>'QUERY_ORDER_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca una expresi\00F3n ORDER BY de SQL v\00E1lida para ordenar los registros recuperados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4803499169119534.4001)
,p_name=>'P7021_EXTERNAL_FILTER_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Filtro Externo'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione la expresi\00F3n order by que se va a transferir al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto tal cual. La sintaxis depende del tipo de origen de datos de REST. Por ejemplo, Oracle REST Data Services (ORDS) espe')
||'ra la sintaxis de JSON.</p>',
'',
'<strong>Ejemplos</strong><br/>',
unistr('<p>Para un servicio REST de ORDS, ordene por el atributo "job" en sentido ascendente y, a continuaci\00F3n, por "ename", en sentido descendente.</p>'),
'<pre>{"job": "asc", "ename": "desc"}</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4803531735119535.4001)
,p_name=>'P7021_EXTERNAL_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(2063557467407603.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>'Order by externo'
,p_source=>'EXTERNAL_ORDER_BY_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione la expresi\00F3n order by que se va a transferir al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto tal cual. La sintaxis depende del tipo de origen de datos de REST. Por ejemplo, Oracle REST Data Services (ORDS) espe')
||'ra la sintaxis de JSON.</p>',
'',
'<strong>Ejemplos</strong><br />',
unistr('<p>Para un servicio REST de ORDS, ordene por el atributo "job" en sentido ascendente y, a continuaci\00F3n, por "ename", en sentido descendente.</p>'),
'<pre>{"job": "asc", "ename": "desc"}</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4803650621119536.4001)
,p_name=>'P7021_OPTIMIZER_HINT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(4995340600973144.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Indicaci\00F3n de Optimizador')
,p_source=>'OPTIMIZER_HINT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la indicaci\00F3n de optimizador de Oracle, que se agrega a la sentencia superior al ejecutar la consulta SQL.'),
unistr('        Las indicaciones son instrucciones para el optimizador. Al escribir SQL, puede que ya conozca datos que el optimizador desconozca. Gracias a las indicaciones, podr\00E1 tomar decisiones que normalmente toma el optimizador,'),
unistr('        y que pueden tener como consecuencia la selecci\00F3n de un plan que supone un costo mayor.</p>'),
unistr('        <p>Por ejemplo, si ya sabe que un \00EDndice es m\00E1s selectivo para ciertas consultas, podr\00E1 elegir un plan de ejecuci\00F3n m\00E1s eficaz que el plan que podr\00EDa elegir el optimizador.'),
unistr('        En tal caso, utilice las indicaciones para forzar al optimizador a utilizar el plan de ejecuci\00F3n \00F3ptimo.</p>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4904612338945005.4001)
,p_name=>'P7021_REMOTE_FUNC_BODY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(2064319266407611.4001)
,p_prompt=>unistr('Introducir un cuerpo de la funci\00F3n que devuelve una consulta SQL')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifique el cuerpo de la funci\00F3n que devuelve una consulta SQL que ser\00E1 el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n, por ejemplo:'),
'</p>',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>',
'<p>',
unistr('Los valores de columna pueden utilizarse dentro de las acciones de automatizaci\00F3n con una sintaxis de variable de enlace (por ejemplo, <strong>:EMPNO</strong>). '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P7021_REMOTE_SERVER_ID'
,p_attribute_06=>'P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5703206634023402.4001)
,p_name=>'P7021_CONDITION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(5702933124970087.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'CONDITION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Seleccione en la lista un tipo de condici\00F3n que se debe cumplir para ejecutar esta automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P7021_CONDITION_EXPR1'
,p_attribute_02=>'P7021_CONDITION_EXPR2'
,p_attribute_04=>'P7021_CONDITION_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'P7021_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5704110366023405.4001)
,p_name=>'P7021_CONDITION_EXPR1'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(5702933124970087.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'CONDITION_EXPR1'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Este atributo permite controlar de forma condicional las circunstancias en las que se ejecutar\00E1 esta automatizaci\00F3n. Introduzca valores en este atributo seg\00FAn el tipo de condici\00F3n concreto seleccionado. La automatizaci\00F3n solo se ejecutar\00E1 si se cumpl')
||unistr('e la condici\00F3n especificada.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5705092234023406.4001)
,p_name=>'P7021_CONDITION_EXPR2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(5702933124970087.4001)
,p_item_source_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'CONDITION_EXPR2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(5817324123534535.4001)
,p_name=>'P7021_ACTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4803890382119538.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(141809210566435713.4001)
,p_name=>'P7021_OLD_POLLING_INTERVAL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(2500558986513154.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2065002605407618.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7021_POLLING_STATUS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'DISABLED'
,p_compute_when=>'P7021_TRIGGER_TYPE'
,p_compute_when_text=>'API'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1808074633591848.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7021_OLD_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_LOCATION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2064654390407614.4001)
,p_computation_sequence=>30
,p_computation_item=>'P7021_OLD_POLLING_STATUS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_POLLING_STATUS'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(141809352383435714.4001)
,p_computation_sequence=>40
,p_computation_item=>'P7021_OLD_POLLING_INTERVAL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_POLLING_INTERVAL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2515207817671729.4001)
,p_computation_sequence=>50
,p_computation_item=>'P7021_OLD_WEB_SRC_MODULE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_WEB_SRC_MODULE_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2516282847671739.4001)
,p_computation_sequence=>60
,p_computation_item=>'P7021_OLD_PK_COLUMN_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_PK_COLUMN_NAME'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2513232130671709.4001)
,p_computation_sequence=>70
,p_computation_item=>'P7021_SOURCE_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P7021_TABLE_RESULT_TYPE',
'    when ''ROWS'' then ''QUERY''',
'    when ''NO_ROWS'' then ''QUERY''',
'    when ''FUNC_BODY_RETURNING_BOOLEAN'' then ''FUNC_BODY_RETURNING_BOOLEAN''',
'    when ''ALWAYS'' then ''ALWAYS'' end'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2513443220671711.4001)
,p_computation_sequence=>80
,p_computation_item=>'P7021_RESULT_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P7021_TABLE_RESULT_TYPE in ( ''ROWS'', ''NO_ROWS'' ) then :P7021_TABLE_RESULT_TYPE end'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1377585382188221.4001)
,p_computation_sequence=>90
,p_computation_item=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_TABLE_USELOCALSYNCTABLE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1935527246374326.4001)
,p_computation_sequence=>100
,p_computation_item=>'P7021_MIN_CADENCE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE''),0)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987817015076252918.4001)
,p_validation_name=>'Local Automation PL/SQL is not null'
,p_validation_sequence=>20
,p_validation=>'P7021_LOCAL_FUNC_BODY_BOOLEAN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' )  and ',
':P7021_LOCATION    =  ''LOCAL''                       and ',
':P7021_SOURCE_TYPE =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2065976767407627.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987817160796252919.4001)
,p_validation_name=>'Remote Automation PL/SQL is not null'
,p_validation_sequence=>30
,p_validation=>'P7021_REMOTE_PLSQL_BOOLEAN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and',
':P7021_LOCATION    =  ''REMOTE''                     and ',
':P7021_SOURCE_TYPE =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2066030221407628.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987817445072252922.4001)
,p_validation_name=>'Remote Automation PL/SQL Remote Server is not null'
,p_validation_sequence=>40
,p_validation=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# debe tener un valor.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST            in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_LOCATION     =  ''REMOTE''                     and ',
':P7021_SOURCE_TYPE  =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2066153096407629.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987816905081252917.4001)
,p_validation_name=>'Automation PL/SQL'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_location        wwv_flow_exec_api.t_location;',
'    l_error           varchar2(32767);',
'begin',
'    l_location   := case :P7021_LOCATION',
'                        when ''LOCAL''                   then wwv_flow_exec_api.c_location_local_db',
'                        when ''REMOTE''                  then wwv_flow_exec_api.c_location_remote_db end;',
'',
'    l_error := wwv_flow_exec_dev.check_code (',
'                   p_code                   => :P7021_SQL,',
'                   p_location               => l_location,',
'                   p_language               => wwv_flow_code_exec.c_plsql,',
'                   p_return_data_type       => wwv_flow_code_exec_dev.c_return_data_type_boolean,',
'                   p_type                   => wwv_flow_code_exec_dev.c_check_func_body,',
'                   --',
'                   p_remote_server_id       => case when l_location = wwv_flow_exec_api.c_location_remote_db then :P7021_REMOTE_SERVER_ID end,',
'                   p_application_id         => :FB_FLOW_ID );',
'',
'    return l_error;   ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_SOURCE_TYPE =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987816604192252914.4001)
,p_validation_name=>'Automation Query'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_automation_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'return wwv_flow_automation_dev.validate_automation_query(',
'           p_location             => :P7021_LOCATION,',
'           p_remote_server_id     => :P7021_REMOTE_SERVER_ID,',
'           p_web_src_module_id    => :P7021_WEB_SRC_MODULE_ID,',
'           --',
'           p_table_owner          => :P7021_TABLE_OWNER,',
'           p_table_name           => :P7021_TABLE_NAME,',
'           p_where_clause         => :P7021_QUERY_WHERE,',
'           p_order_by_clause      => :P7021_QUERY_ORDER_BY,',
'           p_sql_plsql            => :P7021_SQL,',
'           p_language             => :P7021_FUNCTION_BODY_LANGUAGE,',
'           p_optimizer_hint       => :P7021_OPTIMIZER_HINT,',
'           --',
'           p_source_post_process  => :P7021_SOURCE_POST_PROCESSING,',
'',
'           p_local_query_type     => :P7021_LOCAL_DATA_SOURCE_TYPE,',
'           p_remote_query_type    => :P7021_REMOTE_DATA_SOURCE_TYPE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_SOURCE_TYPE =  ''QUERY'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2052770649333327.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(6353168577393099.4001)
,p_validation_name=>'Web Source Parameters: Validate Code'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error varchar2(32767);',
'begin',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then ',
'        l_error := wwv_flow_code_exec_dev.check_code (',
'                       p_type             => :VALUE_TYPE,',
'                       p_return_data_type => wwv_flow_code_exec_dev.c_return_data_type_varchar2,',
'                       p_code             => :VALUE,',
'                       p_language         => coalesce( :VALUE_LANGUAGE, wwv_flow_code_exec.c_plsql ),',
'                       p_application_id   => :FB_FLOW_ID );            ',
'    elsif :VALUE_TYPE = ''SQL_QUERY'' then',
'        l_error := wwv_flow_f4000_util.check_sql(',
'                       p_sql               => :VALUE,',
'                       p_flow_id           => :FB_FLOW_ID );',
'    end if;',
'    ',
'    return l_error;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and',
':P7021_LOCATION =  ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2053157453333328.4001)
,p_tabular_form_region_id=>wwv_flow_api.id(6353168577393099.4001)
,p_validation_name=>'Web Source Parameters: Validate NULL'
,p_validation_sequence=>100
,p_validation=>':VALUE is NULL'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'El tipo de valor NULL no puede tener un valor.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':VALUE_TYPE     = ''NULL''                        and',
':P7021_LOCATION = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1402989705294846.4001)
,p_validation_name=>'Minimum Execution Cadence'
,p_validation_sequence=>110
,p_validation=>'to_number( wwv_flow_automation_dev.get_execution_cadence_minutes( :P7021_POLLING_INTERVAL ) ) >= to_number( :P7021_MIN_CADENCE )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Las automatizaciones no se pueden ejecutar con una frecuencia superior a cada &P7021_MIN_CADENCE!HTML. minutos.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_POLLING_STATUS =  ''ACTIVE'' and ',
':P7021_TRIGGER_TYPE   =  ''POLLING'' and ',
'wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE'') is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2503723575513160.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4477107233299402.4001)
,p_validation_name=>'Must have Actions to Activate'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automation_actions',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and automation_id     = :P7021_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'No se pueden activar las automatizaciones sin acciones.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7021_OLD_POLLING_STATUS != :P7021_POLLING_STATUS and ',
':P7021_POLLING_STATUS      = ''ACTIVE''              and ',
':REQUEST                  in (''PLAY'', ''CREATE'', ''SAVE'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(987817511087252923.4001)
,p_validation_name=>'Validate Code Snippets'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code(',
'    p_type     => wwv_flow_code_exec_dev.c_check_procedures,',
'    p_code     => :P7021_CODE_SNIPPET,',
'    p_language => wwv_flow_code_exec.c_plsql );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST            in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_CODE_SNIPPET is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(2514111507513164.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2902582587394618.4001)
,p_name=>'Location Local'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCATION'
,p_condition_element=>'P7021_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2902610672394619.4001)
,p_event_id=>wwv_flow_api.id(2902582587394618.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4995340600973144.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2902895461394621.4001)
,p_event_id=>wwv_flow_api.id(2902582587394618.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4995340600973144.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2902722617394620.4001)
,p_event_id=>wwv_flow_api.id(2902582587394618.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2902967394394622.4001)
,p_name=>'Location Remote'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCATION'
,p_condition_element=>'P7021_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2903949527394632.4001)
,p_event_id=>wwv_flow_api.id(2902967394394622.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2903682401394629.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904039171394633.4001)
,p_event_id=>wwv_flow_api.id(2902967394394622.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2903682401394629.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2903222006394625.4001)
,p_name=>'Location REST Data Source'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCATION'
,p_condition_element=>'P7021_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904163348394634.4001)
,p_event_id=>wwv_flow_api.id(2903222006394625.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2903704119394630.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904274877394635.4001)
,p_event_id=>wwv_flow_api.id(2903222006394625.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2903704119394630.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1807056316591838.4001)
,p_event_id=>wwv_flow_api.id(2903222006394625.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_SOURCE_POST_PROCESSING'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2903515460394628.4001)
,p_event_id=>wwv_flow_api.id(2903222006394625.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2904788266394640.4001)
,p_name=>'show table attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904894944394641.4001)
,p_event_id=>wwv_flow_api.id(2904788266394640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2904962571394642.4001)
,p_event_id=>wwv_flow_api.id(2904788266394640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_SQL,P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY,P7021_OPTIMIZER_HINT'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2905059188394643.4001)
,p_name=>'show SQL attributes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905181789394644.4001)
,p_event_id=>wwv_flow_api.id(2905059188394643.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_SQL,P7021_OPTIMIZER_HINT'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2065192016407619.4001)
,p_event_id=>wwv_flow_api.id(2905059188394643.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN,P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2905356488394646.4001)
,p_name=>'show Function Body attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905466413394647.4001)
,p_event_id=>wwv_flow_api.id(2905356488394646.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2065213911407620.4001)
,p_event_id=>wwv_flow_api.id(2905356488394646.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN,P7021_SQL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2905614283394649.4001)
,p_name=>'show remote data source attributes'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_SERVER_ID'
,p_condition_element=>'P7021_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2064415121407612.4001)
,p_event_id=>wwv_flow_api.id(2905614283394649.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2064319266407611.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2905703213394650.4001)
,p_event_id=>wwv_flow_api.id(2905614283394649.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2064319266407611.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4904403141945003.4001)
,p_name=>'show remote table attributes'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4904570740945004.4001)
,p_event_id=>wwv_flow_api.id(4904403141945003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_TABLE_OWNER,P7021_REMOTE_TABLE_NAME,P7021_REMOTE_INCLUDE_ROWID,P7021_REMOTE_WHERE,P7021_REMOTE_ORDER_BY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2064078410407608.4001)
,p_event_id=>wwv_flow_api.id(4904403141945003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_SQL,P7021_REMOTE_FUNC_BODY,P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4904869136945007.4001)
,p_name=>'show remote SQL attributes'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4904905064945008.4001)
,p_event_id=>wwv_flow_api.id(4904869136945007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_SQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2064112903407609.4001)
,p_event_id=>wwv_flow_api.id(4904869136945007.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_TABLE_OWNER,P7021_REMOTE_TABLE_NAME,P7021_REMOTE_INCLUDE_ROWID,P7021_REMOTE_WHERE,P7021_REMOTE_ORDER_BY,P7021_REMOTE_FUNC_BODY,,P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(4905238548945011.4001)
,p_name=>'show remote PL/SQL attributes'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(4905358190945012.4001)
,p_event_id=>wwv_flow_api.id(4905238548945011.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_FUNC_BODY,P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2064202392407610.4001)
,p_event_id=>wwv_flow_api.id(4905238548945011.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_TABLE_OWNER,P7021_REMOTE_TABLE_NAME,P7021_REMOTE_INCLUDE_ROWID,P7021_REMOTE_WHERE,P7021_REMOTE_ORDER_BY,P7021_REMOTE_SQL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1805867519591826.4001)
,p_name=>'Post Processing NONE'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1805902367591827.4001)
,p_event_id=>wwv_flow_api.id(1805867519591826.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE,P7021_POST_PROCESS_QUERY,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1806035175591828.4001)
,p_name=>'Post Processing WHERE'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WHERE_ORDER_BY_CLAUSE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1806143747591829.4001)
,p_event_id=>wwv_flow_api.id(1806035175591828.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1806327369591831.4001)
,p_event_id=>wwv_flow_api.id(1806035175591828.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_QUERY,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1806422379591832.4001)
,p_name=>'Post Processing SQL'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1806576586591833.4001)
,p_event_id=>wwv_flow_api.id(1806422379591832.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_QUERY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1806665454591834.4001)
,p_event_id=>wwv_flow_api.id(1806422379591832.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1806714271591835.4001)
,p_name=>'Post Processing PLSQL'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1806856140591836.4001)
,p_event_id=>wwv_flow_api.id(1806714271591835.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1806900970591837.4001)
,p_event_id=>wwv_flow_api.id(1806714271591835.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE,P7021_POST_PROCESS_QUERY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2027541351184808.4001)
,p_name=>'Show Interval Builder'
,p_event_sequence=>150
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P7021_EDIT_POLLING_INTERVAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2027943196184811.4001)
,p_event_id=>wwv_flow_api.id(2027541351184808.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5426552263545892.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2028336622186323.4001)
,p_name=>'Build the interval'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(2022286112169334.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2028723998186324.4001)
,p_event_id=>wwv_flow_api.id(2028336622186323.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'buildInterval()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2029236271186324.4001)
,p_event_id=>wwv_flow_api.id(2028336622186323.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5426552263545892.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2029600049187879.4001)
,p_name=>'Hide Components on load'
,p_event_sequence=>170
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2030053948187879.4001)
,p_event_id=>wwv_flow_api.id(2029600049187879.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(5426552263545892.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2515087259671727.4001)
,p_event_id=>wwv_flow_api.id(2029600049187879.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2514185254671718.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2516477406671741.4001)
,p_event_id=>wwv_flow_api.id(2029600049187879.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_OLD_PK_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2030443946192921.4001)
,p_name=>'Clear Sync Interval'
,p_event_sequence=>180
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P7021_CLEAR_POLLING_INTERVAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2030872752192922.4001)
,p_event_id=>wwv_flow_api.id(2030443946192921.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2032854750210526.4001)
,p_name=>'Hide all'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2033246075210527.4001)
,p_event_id=>wwv_flow_api.id(2032854750210526.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY,P7021_BYHOUR,P7021_BYMINUTE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2033637835212081.4001)
,p_name=>'Weekly Frequency chosen'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'WEEKLY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2034043183212081.4001)
,p_event_id=>wwv_flow_api.id(2033637835212081.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY,P7021_BYHOUR,P7021_BYMINUTE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2034470438213547.4001)
,p_name=>'Daily Frequency chosen'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DAILY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2034838703213547.4001)
,p_event_id=>wwv_flow_api.id(2034470438213547.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYHOUR,P7021_BYMINUTE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2035351162213547.4001)
,p_event_id=>wwv_flow_api.id(2034470438213547.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2035726316214660.4001)
,p_name=>'Hourly Frequency chosen'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HOURLY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2036196639214660.4001)
,p_event_id=>wwv_flow_api.id(2035726316214660.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYMINUTE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2036697823214660.4001)
,p_event_id=>wwv_flow_api.id(2035726316214660.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2037110477214661.4001)
,p_event_id=>wwv_flow_api.id(2035726316214660.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYHOUR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2037581936216081.4001)
,p_name=>'Minutely Frequency chosen'
,p_event_sequence=>230
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'MINUTELY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2037958621216081.4001)
,p_event_id=>wwv_flow_api.id(2037581936216081.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2038490775216081.4001)
,p_event_id=>wwv_flow_api.id(2037581936216081.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYHOUR,P7021_BYMINUTE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1807344842591841.4001)
,p_name=>'Show / Hide Polling interval'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_TRIGGER_TYPE'
,p_condition_element=>'P7021_TRIGGER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLLING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1807424976591842.4001)
,p_event_id=>wwv_flow_api.id(1807344842591841.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL,P7021_POLLING_STATUS'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1807536655591843.4001)
,p_event_id=>wwv_flow_api.id(1807344842591841.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL,P7021_POLLING_STATUS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2063670005407604.4001)
,p_name=>'REST Source chosen'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_WEB_SRC_MODULE_ID'
,p_condition_element=>'P7021_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2063892277407606.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2063557467407603.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1377122281188217.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_HAS_LOCAL_SYNC_TABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2063741979407605.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2063557467407603.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2514579304671722.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6353168577393099.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1377325561188219.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_USE_LOCAL_SYNC_TABLE,P7021_EXTERNAL_FILTER_EXPR,P7021_EXTERNAL_ORDER_BY,P7021_SOURCE_POST_PROCESSING,P7021_POST_PROCESS_WHERE,P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_QUERY,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1376213496188208.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_HAS_LOCAL_SYNC_TABLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Y'' ',
'  from wwv_flow_web_src_modules',
' where id                = :P7021_WEB_SRC_MODULE_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and sync_table_name   is not null'))
,p_attribute_07=>'P7021_WEB_SRC_MODULE_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2514835773671725.4001)
,p_event_id=>wwv_flow_api.id(2063670005407604.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2514185254671718.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2065492605407622.4001)
,p_name=>'Hide "Error"'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_POLLING_STATUS'
,p_condition_element=>'P7021_POLLING_STATUS'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'ERROR'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2065544206407623.4001)
,p_event_id=>wwv_flow_api.id(2065492605407622.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P7021_POLLING_STATUS_2'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2066254576407630.4001)
,p_name=>'PL/SQL Location LOCAL'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_condition_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2066358010407631.4001)
,p_event_id=>wwv_flow_api.id(2066254576407630.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2066950595407637.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2067519970407643.4001)
,p_event_id=>wwv_flow_api.id(2066254576407630.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2067168170407639.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2066632600407634.4001)
,p_event_id=>wwv_flow_api.id(2066254576407630.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2067229994407640.4001)
,p_name=>'PL/SQL Location Remote'
,p_event_sequence=>280
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_condition_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2067390120407641.4001)
,p_event_id=>wwv_flow_api.id(2067229994407640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2067168170407639.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2067603953407644.4001)
,p_event_id=>wwv_flow_api.id(2067229994407640.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2066950595407637.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2067797042407645.4001)
,p_name=>'PL/SQL Remote Server chosen'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_condition_element=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2067893552407646.4001)
,p_event_id=>wwv_flow_api.id(2067797042407645.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_PLSQL_BOOLEAN'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2067979495407647.4001)
,p_event_id=>wwv_flow_api.id(2067797042407645.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_PLSQL_BOOLEAN'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2068073728407648.4001)
,p_name=>'Source Type QUERY'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_TYPE'
,p_condition_element=>'P7021_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2068118677407649.4001)
,p_event_id=>wwv_flow_api.id(2068073728407648.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(96107915683078518.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2068279107407650.4001)
,p_event_id=>wwv_flow_api.id(2068073728407648.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2065703853407625.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2513716108671714.4001)
,p_event_id=>wwv_flow_api.id(2068073728407648.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2513514643671712.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2514759707671724.4001)
,p_event_id=>wwv_flow_api.id(2068073728407648.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_LOCATION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'LOCAL'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2516619889671743.4001)
,p_event_id=>wwv_flow_api.id(2068073728407648.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'SQL'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2512482455671701.4001)
,p_name=>'Source Type Function Body'
,p_event_sequence=>310
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_TYPE'
,p_condition_element=>'P7021_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2512505861671702.4001)
,p_event_id=>wwv_flow_api.id(2512482455671701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(96107915683078518.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2512652892671703.4001)
,p_event_id=>wwv_flow_api.id(2512482455671701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2065703853407625.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2513822897671715.4001)
,p_event_id=>wwv_flow_api.id(2512482455671701.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2513514643671712.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2512989046671706.4001)
,p_name=>'Source Type ALWAYS'
,p_event_sequence=>320
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_TYPE'
,p_condition_element=>'P7021_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ALWAYS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2513051284671707.4001)
,p_event_id=>wwv_flow_api.id(2512989046671706.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(96107915683078518.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2513121537671708.4001)
,p_event_id=>wwv_flow_api.id(2512989046671706.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2065703853407625.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2513994134671716.4001)
,p_event_id=>wwv_flow_api.id(2512989046671706.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2513514643671712.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2515831622671735.4001)
,p_name=>'Hide PK column'
,p_event_sequence=>340
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.is-query'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2515987148671736.4001)
,p_event_id=>wwv_flow_api.id(2515831622671735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_PK_COLUMN_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2516584987671742.4001)
,p_event_id=>wwv_flow_api.id(2515831622671735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_PK_COLUMN_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2516399734671740.4001)
,p_event_id=>wwv_flow_api.id(2515831622671735.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_OLD_PK_COLUMN_NAME'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2516778140671744.4001)
,p_name=>'ROWS Type'
,p_event_sequence=>350
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_RESULT_TYPE'
,p_condition_element=>'P7021_RESULT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ROWS'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2516835601671745.4001)
,p_event_id=>wwv_flow_api.id(2516778140671744.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2517114410671748.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2516999592671746.4001)
,p_event_id=>wwv_flow_api.id(2516778140671744.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(2517114410671748.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2517002835671747.4001)
,p_event_id=>wwv_flow_api.id(2516778140671744.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_MAX_ROWS_TO_PROCESS'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1375523210188201.4001)
,p_name=>'Use Local Sync Table'
,p_event_sequence=>360
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_condition_element=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1375620100188202.4001)
,p_event_id=>wwv_flow_api.id(1375523210188201.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_EXTERNAL_FILTER_EXPR,P7021_EXTERNAL_ORDER_BY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1376130620188207.4001)
,p_event_id=>wwv_flow_api.id(1375523210188201.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6353168577393099.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1375858039188204.4001)
,p_event_id=>wwv_flow_api.id(1375523210188201.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(6353168577393099.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1375921993188205.4001)
,p_event_id=>wwv_flow_api.id(1375523210188201.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_EXTERNAL_FILTER_EXPR,P7021_EXTERNAL_ORDER_BY'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1376582071188211.4001)
,p_name=>'Show / Hide Use-Local Sync Table'
,p_event_sequence=>370
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_HAS_LOCAL_SYNC_TABLE'
,p_condition_element=>'P7021_HAS_LOCAL_SYNC_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1376981790188215.4001)
,p_event_id=>wwv_flow_api.id(1376582071188211.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1376605774188212.4001)
,p_event_id=>wwv_flow_api.id(1376582071188211.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_USE_LOCAL_SYNC_TABLE'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1376862264188214.4001)
,p_event_id=>wwv_flow_api.id(1376582071188211.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_USE_LOCAL_SYNC_TABLE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1376721105188213.4001)
,p_event_id=>wwv_flow_api.id(1376582071188211.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2532500787513171.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(2500558986513154.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Edit Automation'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Se han aplicado los cambios.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5816927654534531.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(4803890382119538.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Actions - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1567328351713204.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(6353168577393099.4001)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Parameters - VALUE_LANGUAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Web Source Parameters should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2053448886333329.4001)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(6353168577393099.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Parameters - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1807724155591845.4001)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear REST Source Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_web_src_comp_params',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and automation_id     = :P7021_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Par\00E1metros borrados')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :P7021_LOCATION != ''WEB_SOURCE'' or ',
'  :P7021_TABLE_RESULT_TYPE in (''ALWAYS'', ''FUNC_BODY_RETURNING_BOOLEAN'' ) or',
'  nvl( :P7021_OLD_WEB_SRC_MODULE_ID, -1 ) != :P7021_WEB_SRC_MODULE_ID ) and :REQUEST in (''SAVE'', ''PLAY'' )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1807875798591846.4001)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync REST Source Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.add_web_source_params(',
'    p_flow_id                 => :FB_FLOW_ID,',
'    p_web_source_module_id    => :P7021_WEB_SRC_MODULE_ID,',
'    p_database_operation      => wwv_flow_plugin_api.c_db_operation_fetch_rows,',
'    p_automation_id           => :P7021_ID );',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7021_LOCATION                               = ''WEB_SOURCE''                and ',
':REQUEST                                     in ( ''CREATE'', ''SAVE'', ''PLAY'') and',
'(',
'    coalesce( :P7021_OLD_LOCATION, ''X'' )         != :P7021_LOCATION          or',
'    coalesce( :P7021_OLD_WEB_SRC_MODULE_ID, -1 ) != :P7021_WEB_SRC_MODULE_ID )',
''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2064709286407615.4001)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Status and Next Run Date'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- 1. Status changed from Disabled/Error to Active',
'if :P7021_OLD_POLLING_STATUS in (''DISABLED'',''ERROR'') and ',
'   :P7021_POLLING_STATUS = ''ACTIVE'' ',
'then',
'    wwv_flow_automation.set_job_status(',
'        p_automation_id      => :P7021_ID,',
'        p_status             => wwv_flow_automation.c_status_active );',
'--        ',
'-- 2. Execution schedule changed for active automation',
'elsif :P7021_POLLING_STATUS = ''ACTIVE'' and ',
'      :P7021_POLLING_INTERVAL is not null and ',
'      nvl( :P7021_OLD_POLLING_INTERVAL, ''X'' ) != nvl( :P7021_POLLING_INTERVAL, ''X'' ) ',
'then',
'    wwv_flow_automation.set_job_status(',
'        p_automation_id      => :P7021_ID,',
'        p_status             => wwv_flow_automation.c_status_active );',
'--',
'-- 3. Status changed from Active to Disabled / Error or Type changed to API: disable automation',
'elsif :P7021_TRIGGER_TYPE = ''API'' or :P7021_OLD_POLLING_STATUS = ''ACTIVE'' and :P7021_POLLING_STATUS in (''DISABLED'',''ERROR'') then',
'    wwv_flow_automation.set_job_status(',
'        p_automation_id      => :P7021_ID,',
'        p_status             => wwv_flow_automation.c_status_disabled );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'PLAY,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2064903543407617.4001)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Play automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_automation.execute_due_automations( p_automation_id => :P7021_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(2064814695407616.4001)
,p_process_success_message=>unistr('Ejecuci\00F3n de automatizaci\00F3n iniciada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2515564925671732.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Distribute items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P7021_SOURCE_TYPE = ''QUERY'' then',
'    ',
'        if :P7021_LOCATION = ''REMOTE'' then',
'            :P7021_REMOTE_TABLE_OWNER      := :P7021_TABLE_OWNER;',
'            :P7021_REMOTE_TABLE_NAME       := :P7021_TABLE_NAME;',
'            :P7021_REMOTE_DATA_SOURCE_TYPE := :P7021_LOCAL_DATA_SOURCE_TYPE;',
'            :P7021_REMOTE_WHERE            := :P7021_QUERY_WHERE;',
'            :P7021_REMOTE_ORDER_BY         := :P7021_QUERY_ORDER_BY;',
'',
'            case :P7021_REMOTE_DATA_SOURCE_TYPE',
'                when ''SQL''                     then :P7021_REMOTE_SQL := :P7021_SQL;',
'                when ''FUNC_BODY_RETURNING_SQL'' then',
'                    :P7021_REMOTE_FUNC_BODY      := :P7021_SQL; ',
'                    :P7021_REMOTE_FUNC_BODY_LANG := :P7021_FUNCTION_BODY_LANGUAGE;',
'                else null;',
'            end case;',
'            :P7021_REMOTE_INCLUDE_ROWID   := :P7021_INCLUDE_ROWID_COLUMN;',
'            :P7021_SQL                    := null;',
'            :P7021_TABLE_NAME             := null;',
'            :P7021_TABLE_OWNER            := null;',
'            :P7021_QUERY_WHERE            := null;',
'            :P7021_QUERY_ORDER_BY         := null;',
'            ',
'        elsif :P7021_LOCATION = ''LOCAL'' then',
'            case :P7021_LOCAL_DATA_SOURCE_TYPE',
'                when ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY := :P7021_SQL;',
'                else null;',
'            end case;',
'            ',
'        elsif :P7021_LOCATION = ''WEB_SOURCE'' then',
'            if :P7021_SOURCE_POST_PROCESSING = ''WHERE_ORDER_BY_CLAUSE'' then',
'                :P7021_POST_PROCESS_WHERE            := :P7021_QUERY_WHERE;',
'                :P7021_POST_PROCESS_ORDER_BY         := :P7021_QUERY_ORDER_BY;',
'            elsif :P7021_SOURCE_POST_PROCESSING = ''SQL'' then',
'                :P7021_POST_PROCESS_QUERY            := :P7021_SQL;',
'            elsif :P7021_SOURCE_POST_PROCESSING = ''FUNC_BODY_RETURNING_SQL'' then',
'                :P7021_POST_PROC_FUNC_BODY_LANG      := :P7021_FUNCTION_BODY_LANGUAGE;',
'                :P7021_POST_PROC_FUNC_BODY           := :P7021_SQL;',
'            end if;',
'',
'            :P7021_SOURCE_POST_PROCESSING := coalesce( :P7021_SOURCE_POST_PROCESSING, ''NONE'' );',
'',
'            :P7021_SQL                    := null;',
'            :P7021_TABLE_NAME             := null;',
'            :P7021_TABLE_OWNER            := null;',
'            :P7021_QUERY_WHERE            := null;',
'            :P7021_QUERY_ORDER_BY         := null;            ',
'        end if;',
'',
'    elsif :P7021_SOURCE_TYPE = ''FUNC_BODY_RETURNING_BOOLEAN'' then',
'        :P7021_FUNC_BODY_BOOL_LOCATION := :P7021_LOCATION;',
'',
'        if :P7021_FUNC_BODY_BOOL_LOCATION = ''LOCAL'' then',
'            :P7021_LOCAL_FUNC_BODY_BOOLEAN      := :P7021_SQL;',
'            :P7021_LOCAL_FUNCBODYBOOL_LANG      := :P7021_FUNCTION_BODY_LANGUAGE;',
'        else ',
'            :P7021_REMOTE_PLSQL_BOOLEAN     := :P7021_SQL;',
'            :P7021_LOCAL_PLSQL_BOOLEAN      := null;',
'            :P7021_PLSQL_REMOTE_SERVER_ID   := :P7021_REMOTE_SERVER_ID;',
'        end if;',
'        :P7021_SQL := null;',
'    elsif :P7021_SOURCE_TYPE = ''ALWAYS'' then',
'        :P7021_LOCATION                := null;',
'        :P7021_SQL                     := null;',
'        :P7021_LOCAL_FUNC_BODY_BOOLEAN := null;',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(2532145098513171.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(2500558986513154.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Automation'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1808270756591850.4001)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Consolidate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    procedure clear_wsm is',
'    begin',
'        :P7021_SOURCE_POST_PROCESSING := null;',
'        :P7021_WEB_SRC_MODULE_ID      := null;',
'    end clear_wsm;',
'    ',
'    procedure clear_table is',
'    begin',
'        :P7021_TABLE_NAME             := null;',
'        :P7021_TABLE_OWNER            := null;',
'        :P7021_QUERY_WHERE            := null;',
'        :P7021_QUERY_ORDER_BY         := null;        ',
'        :P7021_OPTIMIZER_HINT         := null;',
'        :P7021_INCLUDE_ROWID_COLUMN   := ''N'';',
'    end clear_table;',
'',
'begin',
'    if :P7021_SOURCE_TYPE = ''QUERY'' then',
'',
'        :P7021_TABLE_RESULT_TYPE := :P7021_RESULT_TYPE;',
'',
'        if :P7021_LOCATION = ''REMOTE'' then',
'            :P7021_REMOTE_DATA_SOURCE_TYPE := coalesce( :P7021_REMOTE_DATA_SOURCE_TYPE, ''TABLE'' );',
'            --',
'            :P7021_TABLE_OWNER             := :P7021_REMOTE_TABLE_OWNER;',
'            :P7021_TABLE_NAME              := :P7021_REMOTE_TABLE_NAME;',
'            :P7021_LOCAL_DATA_SOURCE_TYPE  := :P7021_REMOTE_DATA_SOURCE_TYPE;',
'            :P7021_SQL                     := case :P7021_REMOTE_DATA_SOURCE_TYPE',
'                                                  when ''SQL''                     then :P7021_REMOTE_SQL',
'                                                  when ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY end;',
'            :P7021_FUNCTION_BODY_LANGUAGE  := case when :P7021_REMOTE_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY_LANG end;',
'            :P7021_INCLUDE_ROWID_COLUMN    := case when :P7021_REMOTE_DATA_SOURCE_TYPE = ''TABLE'' then :P7021_REMOTE_INCLUDE_ROWID else ''N'' end;',
'            :P7021_QUERY_WHERE             := :P7021_REMOTE_WHERE;',
'            :P7021_QUERY_ORDER_BY          := :P7021_REMOTE_ORDER_BY;',
'            clear_wsm;',
'        elsif :P7021_LOCATION = ''LOCAL'' then',
'            :P7021_REMOTE_SERVER_ID       := null;',
'            :P7021_LOCAL_DATA_SOURCE_TYPE := coalesce( :P7021_LOCAL_DATA_SOURCE_TYPE, ''TABLE'' );',
'            :P7021_SQL                    := case :P7021_LOCAL_DATA_SOURCE_TYPE',
'                                                 when ''SQL''                     then :P7021_SQL',
'                                                 when ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY end;',
'            :P7021_FUNCTION_BODY_LANGUAGE := case when :P7021_LOCAL_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY_LANGUAGE end;',
'            :P7021_INCLUDE_ROWID_COLUMN   := case when :P7021_LOCAL_DATA_SOURCE_TYPE = ''TABLE'' then :P7021_INCLUDE_ROWID_COLUMN else ''N'' end;',
'            clear_wsm;',
'        elsif :P7021_LOCATION = ''WEB_SOURCE'' then',
'            if :P7021_OLD_WEB_SRC_MODULE_ID = :P7021_WEB_SRC_MODULE_ID then',
'                if :P7021_SOURCE_POST_PROCESSING = ''WHERE_ORDER_BY_CLAUSE'' then',
'                    :P7021_QUERY_WHERE            := :P7021_POST_PROCESS_WHERE;',
'                    :P7021_QUERY_ORDER_BY         := :P7021_POST_PROCESS_ORDER_BY;',
'                    :P7021_FUNCTION_BODY_LANGUAGE := null;',
'                elsif :P7021_SOURCE_POST_PROCESSING = ''SQL'' then',
'                    :P7021_SQL                    := :P7021_POST_PROCESS_QUERY;',
'                    :P7021_FUNCTION_BODY_LANGUAGE := null;',
'                elsif :P7021_SOURCE_POST_PROCESSING = ''FUNC_BODY_RETURNING_SQL'' then',
'                    :P7021_SQL                    := :P7021_POST_PROC_FUNC_BODY;',
'                    :P7021_FUNCTION_BODY_LANGUAGE := :P7021_POST_PROC_FUNC_BODY_LANG;',
'                end if;',
'            else',
'                 :P7021_SOURCE_POST_PROCESSING := null;',
'                 :P7021_FUNCTION_BODY_LANGUAGE := null;',
'            end if;',
'            :P7021_REMOTE_SERVER_ID           := null;',
'            :P7021_INCLUDE_ROWID_COLUMN       := ''N'';',
'            :P7021_SOURCE_POST_PROCESSING     := nullif ( :P7021_SOURCE_POST_PROCESSING, ''NONE'' );',
'            :P7021_TABLE_USELOCALSYNCTABLE    := null;',
'            for i in (',
'                 select 1',
'                   from wwv_flow_web_src_modules',
'                  where security_group_id = :WORKSPACE_ID',
'                    and flow_id           = :FB_FLOW_ID',
'                    and id                = :P7021_WEB_SRC_MODULE_ID',
'                    and sync_table_name  is not null )',
'            loop',
'                :P7021_TABLE_USELOCALSYNCTABLE := coalesce(:P7021_USE_LOCAL_SYNC_TABLE,''N'');',
'            end loop;',
'            ',
'            ',
'        end if;',
'',
'    elsif :P7021_SOURCE_TYPE = ''FUNC_BODY_RETURNING_BOOLEAN'' then',
'        :P7021_LOCATION          := :P7021_FUNC_BODY_BOOL_LOCATION;',
'        :P7021_TABLE_RESULT_TYPE := ''FUNC_BODY_RETURNING_BOOLEAN'';',
'',
'        if :P7021_FUNC_BODY_BOOL_LOCATION = ''LOCAL'' then',
'            :P7021_SQL                    := :P7021_LOCAL_FUNC_BODY_BOOLEAN;',
'            :P7021_FUNCTION_BODY_LANGUAGE := :P7021_LOCAL_FUNCBODYBOOL_LANG;',
'            :P7021_REMOTE_SERVER_ID       := null;',
'        else ',
'            :P7021_SQL                    := :P7021_REMOTE_PLSQL_BOOLEAN;',
'            :P7021_FUNCTION_BODY_LANGUAGE := null;',
'            :P7021_REMOTE_SERVER_ID       := :P7021_PLSQL_REMOTE_SERVER_ID;',
'        end if;',
'        ',
'        clear_table;',
'        clear_wsm;',
'',
'    elsif :P7021_SOURCE_TYPE = ''ALWAYS'' then',
'        :P7021_TABLE_RESULT_TYPE      := ''ALWAYS'';',
'        :P7021_SQL                    := null;',
'        :P7021_REMOTE_SERVER_ID       := null;',
'        :P7021_FUNCTION_BODY_LANGUAGE := null;',
'        clear_wsm;',
'        clear_table;',
'    end if;',
'    ',
'    :P7021_POLL_LAST_RUN_TIMESTAMP := null;',
'    :P7021_POLL_NEXT_RUN_TIMESTAMP := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_07022
begin
wwv_flow_api.create_page(
 p_id=>7022.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Editar acci\00F3n de automatizaci\00F3n')
,p_alias=>'EDIT-AUTOMATION-ACTION'
,p_step_title=>unistr('Editar acci\00F3n de automatizaci\00F3n')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(689605897838965863.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1409136117910718.4001)
,p_plug_name=>unistr('Definir configuraci\00F3n de plugin')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>85
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P7022_ACTION_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_process_type,',
'        p_type_page_item_name => ''P7022_ACTION_TYPE'',',
'        p_page_item_prefix    => ''P7022_'',',
'        p_user_interface_id   => null,',
'        p_is_wizard           => false',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1409470037910721.4001)
,p_plug_name=>unistr('C\00F3digo')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>45
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29895161562987844.4001)
,p_plug_name=>' Ejemplos'
,p_parent_plug_id=>wwv_flow_api.id(1409470037910721.4001)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Ejemplo 1: enviar un correo electr\00F3nico. Esto supone que existe una plantilla de correo electr\00F3nico llamada <strong>ORDER</strong>, con marcadores de posici\00F3n que se utilizan en el par\00E1metro '),
'    <strong>p_placeholders</strong>.',
'</p>',
'<pre>',
'begin',
'    apex_mail.send (',
'        p_template_static_id => ''ORDER'',',
'        p_placeholders       => ''{ "ORDER_NUMBER": '' || :ORDER_NUMBER ||',
'                                  ''"ORDER_DATE":"''   || to_char( :ORDER_DATE, ''YYYY-MM-DD'' ) || ''", ''',
'                                  ''"ORDER_TOTAL":''   || :ORDER_TOTAL || ',
'                                ''}'',',
'        p_to                 => ''some_user@somewhere.com'' );',
'end;',
'</pre>',
'<p>',
unistr('    Ejemplo 2: insertar una fila en otra tabla. Si el valor :SAL es NULO, escriba un mensaje de advertencia en el log de automatizaci\00F3n.'),
'</p>',
'<pre>',
'begin',
'    insert into other_table( empno, ename, sal )',
'                     values( :EMPNO, :ENAME, :SAL );',
'    if :SAL is null then',
unistr('        apex_automation.log_warn( ''EMPNO '' || :EMPNO ||\00A0'' has a NULL Salary'');'),
'    end if;',
'end;',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90115922532448608.4001)
,p_plug_name=>unistr('C\00F3digo local')
,p_parent_plug_id=>wwv_flow_api.id(1409470037910721.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(90116067165448609.4001)
,p_plug_name=>unistr('C\00F3digo remoto')
,p_parent_plug_id=>wwv_flow_api.id(1409470037910721.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1410170163910728.4001)
,p_plug_name=>unistr('Acci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTOMATION_ACTIONS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1733465727290719.4001)
,p_plug_name=>'Manejo de Errores'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>55
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1733554992290720.4001)
,p_plug_name=>unistr('Condici\00F3n de servidor')
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>65
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1733611964290721.4001)
,p_plug_name=>'Avanzado'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>75
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1734379323290728.4001)
,p_plug_name=>unistr('Editar Acci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1927189008406310.4001)
,p_plug_name=>unistr('Editar Acci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('El c\00F3digo PL/SQL de la acci\00F3n se ejecutar\00E1 una vez por cada fila devuelta por la consulta de automatizaci\00F3n. Las variables de enlace se pueden utilizar para hacer referencia a los valores de las columnas de la consulta de automatizaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1936683460374337.4001)
,p_plug_name=>unistr('Enviar configuraci\00F3n de correo electr\00F3nico')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3704459976120823.4001)
,p_plug_name=>unistr('Cuadr\00EDcula de marcadores de posici\00F3n')
,p_parent_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 placeholder,',
'       c002 value',
'  from wwv_flow_collections',
' where collection_name = ''P7022_EMAIL_PLACEHOLDER_COLL''',
'   and :P7022_ACTION_TYPE = ''NATIVE_SEND_EMAIL''',
'   and :P7022_EMAIL_TEMPLATE_ID is not null'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P7022_EMAIL_TEMPLATE_ID,P7022_ACTION_TYPE'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Cuadr\00EDcula de marcadores de posici\00F3n')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3704944171120828.4001)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>unistr('Marcador de Posici\00F3n')
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3705010549120829.4001)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Columna o valor'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3705148834120830.4001)
,p_name=>'APEX$ROW_ACTION'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3705213310120831.4001)
,p_name=>'APEX$ROW_SELECTOR'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
);
wwv_flow_api.create_region_column(
 p_id=>wwv_flow_api.id(3705605985120835.4001)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_api.create_interactive_grid(
 p_id=>wwv_flow_api.id(3704544776120824.4001)
,p_internal_uid=>3704544776120824
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>unistr('No se ha definido ning\00FAn marcador de posici\00F3n.')
,p_show_toolbar=>true
,p_toolbar_buttons=>'SAVE'
,p_add_button_label=>unistr('Agregar marcador de posici\00F3n')
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>380
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.initialSelection = false;',
'    return options;',
'}',
''))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5817463665534536.4001)
,p_plug_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(5938210987232439.4001)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(348707341969499917.4001)
,p_plug_name=>unistr('Configuraci\00F3n de acci\00F3n')
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
unistr('// ocultar los atributos din\00E1micos inmediatamente despu\00E9s de su representaci\00F3n, '),
'// jQuery.ready puede tardar demasiado tiempo. ',
'apex.builder.dynamicAttributes.hide(''P4651_'');',
'</script>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3704015479120819.4001)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_button_name=>'SET_PLACEHOLDERS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Definir valores de marcador de posici\00F3n')
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="margin-top:8px"'
,p_grid_new_row=>'N'
,p_grid_column=>8
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1735507194290740.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1734379323290728.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7022:P7021_ID:&P7022_AUTOMATION_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1735615488290741.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1734379323290728.4001)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Suprimir'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P7022_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1734085091290725.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1734379323290728.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
,p_button_condition=>'P7022_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1734148271290726.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1734379323290728.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'NEXT'
,p_button_condition=>'P7022_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1805022861591818.4001)
,p_branch_name=>'Back to 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7022:P7021_ID:&P7022_AUTOMATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1400711910572550.4001)
,p_name=>'P7022_CONDITION_LANG'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(1733554992290720.4001)
,p_prompt=>'Idioma'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1403594152592939.4001)
,p_name=>'P7022_CONDITION_CHECK'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(1733554992290720.4001)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CONDITION_CHECK'
,p_lov=>'.'||wwv_flow_api.id(435017812694464482.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1409356763910720.4001)
,p_name=>'P7022_ACTION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_default=>'NATIVE_PLSQL'
,p_prompt=>'Tipo'
,p_source=>'ACTION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''PROCESS.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type               = ''PROCESS TYPE''',
'           and supported_component_types like ''%APEX_APPL_AUTOMATION_ACTIONS%''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id                   = to_number(:FB_FLOW_ID)',
'           and security_group_id         = to_number(:WORKSPACE_ID)',
'           and plugin_type               = ''PROCESS TYPE''',
'           and supported_component_types like ''%APEX_APPL_AUTOMATION_ACTIONS%''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el tipo de acci\00F3n.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1409543908910722.4001)
,p_name=>'P7022_REMOTE_PLSQL_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(90116067165448609.4001)
,p_prompt=>unistr('C\00F3digo PL/SQL (se ejecuta en el servicio de SQL activado para REST)')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Proporcione el c\00F3digo PL/SQL que se va a ejecutar. Los valores de las columnas de la consulta de automatizaci\00F3n est\00E1n disponibles como variables de enlace, por nombre de columna, por ejemplo <strong>:EMPNO</strong>, <strong>:ENAME</strong>, etc. ')
||unistr('Adem\00E1s, APEX proporciona las siguientes variables de enlace gen\00E9ricas:'),
'</p>',
'<ul>',
'    <li><strong>APEX$AUTOMATION_ROW_PK</strong>: si se ha definido una columna de clave primaria, esta variable de enlace contiene el valor de la clave primaria.</li>',
unistr('  <li><strong>APEX$AUTOMATION_ROW_NUM</strong>: para las automatizaciones basadas en una consulta, esta variable de enlace contiene el n\00FAmero de fila actual.</li>'),
unistr(' <li><strong>APEX$AUTOMATION_ERROR_ROWS</strong>: para las automatizaciones basadas en una consulta, esta variable de enlace contiene el n\00FAmero de filas en las que las acciones han producido errores.</li>'),
unistr('      <li><strong>APEX$AUTOMATION_LASTRUN_ISO</strong>: contiene el registro de hora de la ejecuci\00F3n de la automatizaci\00F3n <em>anterior</em>, con el formato <strong>AAAA-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong>.</li>      '),
'</ul>',
'<p style="padding-top: 10px">',
unistr('    Tenga en cuenta que el paquete <strong>APEX_AUTOMATION</strong> podr\00EDa no estar disponible en el servicio SQL activado para REST. Para agregar mensajes al log de ejecuci\00F3n (<strong>LOG_WARN</strong>, <strong>LOG_INFO</strong>, <strong>LOG_ERROR</')
||unistr('strong>), cree <em>otra</em> acci\00F3n que se ejecute en la <em>base de datos local.</em>'),
'</p>'))
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_05=>'P7022_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1409907400910726.4001)
,p_name=>'P7022_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>'Nombre'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca un nombre para la acci\00F3n de automatizaci\00F3n.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1410334092910730.4001)
,p_name=>'P7022_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1410699192910733.4001)
,p_name=>'P7022_AUTOMATION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'AUTOMATION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1410817116910735.4001)
,p_name=>'P7022_EXECUTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ceil( ( max( execution_sequence ) + 1 ) / 10 ) * 10',
'  from wwv_flow_automation_actions',
' where automation_id     = :P7022_AUTOMATION_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>unistr('Secuencia de Ejecuci\00F3n')
,p_source=>'EXECUTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Especifique la secuencia de ejecuci\00F3n. Los n\00FAmeros m\00E1s altos se ejecutar\00E1n despu\00E9s que los n\00FAmeros m\00E1s bajos.')
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1567511807713206.4001)
,p_name=>'P7022_ACTION_CLOB_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(90115922532448608.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>'Idioma'
,p_source=>'ACTION_CLOB_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Seleccione el lenguaje que se va a utilizar para evaluar el c\00F3digo de programaci\00F3n introducido.')
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1706926079115518.4001)
,p_name=>'P7022_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1707292559115535.4001)
,p_name=>'P7022_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1707644450115535.4001)
,p_name=>'P7022_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1708053886115535.4001)
,p_name=>'P7022_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1708485452115536.4001)
,p_name=>'P7022_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1708847040115536.4001)
,p_name=>'P7022_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1709227594115536.4001)
,p_name=>'P7022_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1709653251115537.4001)
,p_name=>'P7022_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1710048534115538.4001)
,p_name=>'P7022_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1710435123115538.4001)
,p_name=>'P7022_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1710818746115538.4001)
,p_name=>'P7022_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1711265457115539.4001)
,p_name=>'P7022_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1711699180115540.4001)
,p_name=>'P7022_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1712058068115543.4001)
,p_name=>'P7022_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1712489517115543.4001)
,p_name=>'P7022_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(348707341969499917.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_api.id(566053095724681231.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1731838233290703.4001)
,p_name=>'P7022_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1409470037910721.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_default=>'LOCAL'
,p_prompt=>unistr('Ubicaci\00F3n')
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_LOCATIONS'
,p_lov=>'.'||wwv_flow_api.id(601110993871808630.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si su c\00F3digo PL/SQL se debe ejecutar en la <em>base de datos local</em> o en un <em>servicio SQL activado para REST</em>.')
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1731977565290704.4001)
,p_name=>'P7022_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(90116067165448609.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>'Referencia de SQL activada para REST'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Elija el servicio SQL activado para REST donde ejecutar el c\00F3digo PL/SQL.')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732231184290707.4001)
,p_name=>'P7022_ERROR_MESSAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(1733465727290719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>'Mensaje de Error'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca un mensaje de error que aparecer\00E1 en el log de automatizaci\00F3n cuando el procesamiento falle. Utilice #SQLERRM# como marcador de posici\00F3n para el mensaje de error ORA real.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732309344290708.4001)
,p_name=>'P7022_STOP_EXECUTION_ON_ERROR'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(1733465727290719.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_default=>'Y'
,p_prompt=>unistr('Detenci\00F3n de Sesi\00F3n en Caso de Error')
,p_source=>'STOP_EXECUTION_ON_ERROR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Active esta opci\00F3n cuando el procesamiento de la fila actual se deba detener cuando se produzca un error. Las acciones posteriores no se procesar\00E1n en este caso.')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732420639290709.4001)
,p_name=>'P7022_CONDITION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(1733554992290720.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>unistr('Tipo de Condici\00F3n')
,p_source=>'CONDITION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_api.id(13602414170805697.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Seleccionar Tipo de Condici\00F3n -')
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un tipo de condici\00F3n en la lista que se debe cumplir para ejecutar esta acci\00F3n.'),
'',
''))
,p_attribute_01=>'P7022_CONDITION_EXPR1'
,p_attribute_02=>'P7022_CONDITION_EXPR2'
,p_attribute_04=>'P7022_CONDITION_CHECK'
,p_attribute_05=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'P7022_CONDITION_LANG'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732505426290710.4001)
,p_name=>'P7022_CONDITION_EXPR1'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(1733554992290720.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>unistr('Expresi\00F3n 1')
,p_source=>'CONDITION_EXPR1'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Este atributo permite controlar de forma condicional las circunstancias en las que se ejecutar\00E1 esta acci\00F3n. Introduzca valores en este atributo seg\00FAn el tipo de condici\00F3n concreta seleccionada. La acci\00F3n solo se ejecutar\00E1 si se cumple la condici\00F3n e')
||'specificada.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732633499290711.4001)
,p_name=>'P7022_CONDITION_EXPR2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(1733554992290720.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>unistr('Expresi\00F3n 2')
,p_source=>'CONDITION_EXPR2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Algunos tipos de condici\00F3n necesitan dos expresiones para la comparaci\00F3n. Introduzca aqu\00ED la segunda expresi\00F3n o elemento.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732712865290712.4001)
,p_name=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(1733554992290720.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_default=>'Y'
,p_prompt=>'Ejecutar para cada fila'
,p_source=>'EXEC_COND_FOR_EACH_ROW'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('<p>Especifique si la condici\00F3n se debe ejecutar para cada fila o solo una vez.</p>')
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732811511290713.4001)
,p_name=>'P7022_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(1733611964290721.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>unistr('Opci\00F3n de Creaci\00F3n')
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ninguna Opci\00F3n de Creaci\00F3n - ')
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para esta acci\00F3n.</p>'),
unistr('<p>Las opciones de creaci\00F3n son valores predefinidos que determinan si se activa o no un componente en una aplicaci\00F3n.</p>')))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1732940692290714.4001)
,p_name=>'P7022_ACTION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(1733611964290721.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_prompt=>'Comentarios'
,p_source=>'ACTION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1736536337290750.4001)
,p_name=>'P7022_LOCAL_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(90115922532448608.4001)
,p_prompt=>unistr('C\00F3digo')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Proporcione el c\00F3digo PL/SQL que se va a ejecutar. Los valores de las columnas de la consulta de automatizaci\00F3n est\00E1n disponibles como variables de enlace, por nombre de columna, por ejemplo <strong>:EMPNO</strong>, <strong>:ENAME</strong>, etc. ')
||unistr('Adem\00E1s, &PRODUCT_NAME. proporciona las siguientes variables de enlace gen\00E9ricas:'),
'</p>',
'<ul>',
'    <li><strong>APEX$AUTOMATION_ROW_PK</strong>: si se ha definido una columna de clave primaria, esta variable de enlace contiene el valor de la clave primaria.</li>',
unistr('    <li><strong>APEX$AUTOMATION_ROW_NUM</strong>: para las automatizaciones basadas en una consulta, esta variable de enlace contiene el n\00FAmero de fila actual.</li>'),
unistr('    <li><strong>APEX$AUTOMATION_ERROR_ROWS</strong>: para las automatizaciones basadas en una consulta, esta variable de enlace contiene el n\00FAmero de filas en las que las acciones han producido errores.</li>'),
unistr('      <li><strong>APEX$AUTOMATION_LASTRUN_ISO</strong>: contiene el registro de hora de la ejecuci\00F3n de la automatizaci\00F3n <em>anterior</em>, con el formato <strong>AAAA-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong>.</li>      '),
'</ul>',
'<p>',
'    ',
'</p>',
'<p>',
unistr('    Para escribir mensajes en el log de ejecuci\00F3n, use los procedimientos <strong>LOG_INFO</strong>, <strong>LOG_WARN</strong> o <strong>LOG_ERROR</strong> en el paquete <strong>APEX_AUTOMATION</strong>.'),
'</p>'))
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1803598788591803.4001)
,p_name=>'P7022_CODE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1409470037910721.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'ACTION_CLOB'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1804727916591815.4001)
,p_name=>'P7022_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_item_source_plug_id=>wwv_flow_api.id(1410170163910728.4001)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937001282374341.4001)
,p_name=>'P7022_EMAIL_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_item_default=>'''&''||''APP_EMAIL.'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'De'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca la direcci\00F3n de correo electr\00F3nico que se muestra como remitente del correo electr\00F3nico. Debe ser una direcci\00F3n de correo electr\00F3nico v\00E1lida. De lo contrario, no se enviar\00E1 el mensaje. Utilice sintaxis de sustituci\00F3n si desea utilizar un v')
||unistr('alor din\00E1mico.'),
'</p>',
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937161460374342.4001)
,p_name=>'P7022_EMAIL_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'A'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para introducir los destinatarios de correo electr\00F3nico, especifique una o varias direcciones de correo electr\00F3nico. Para introducir varias direcciones de correo electr\00F3nico, utilice una lista separada por comas. Utilice la sintaxis de sustituci\00F3n si')
||unistr(' desea utilizar un valor din\00E1mico.</p>'),
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937213913374343.4001)
,p_name=>'P7022_EMAIL_CC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Cc'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para introducir los destinatarios de correo electr\00F3nico en copia, especifique una o varias direcciones de correo electr\00F3nico. Para introducir varias direcciones de correo electr\00F3nico, utilice una lista separada por comas. Utilice la sintaxis de susti')
||unistr('tuci\00F3n si desea utilizar un valor din\00E1mico.'),
'</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937358335374344.4001)
,p_name=>'P7022_EMAIL_BCC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Cco'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Para introducir los destinatarios de correo electr\00F3nico en copia oculta, especifique una o varias direcciones de correo electr\00F3nico. Para introducir varias direcciones de correo electr\00F3nico, utilice una lista separada por comas. Utilice la sintaxis d')
||unistr('e sustituci\00F3n si desea utilizar un valor din\00E1mico.'),
'</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937411156374345.4001)
,p_name=>'P7022_EMAIL_REPLYTO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Responder a'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca la direcci\00F3n de correo a la que se deben enviar las respuestas. Si no se especifica, se utilizar\00E1 la direcci\00F3n de correo electr\00F3nico introducida en <strong>De</strong>. Utilice la sintaxis de sustituci\00F3n si desea utilizar un valor din\00E1mico')
||'.</p>',
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937527798374346.4001)
,p_name=>'P7022_EMAIL_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>unistr('Plantilla de correo electr\00F3nico')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_email_templates',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Ninguna Plantilla -'
,p_cHeight=>1
,p_colspan=>7
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Elija una plantilla de correo electr\00F3nico. Use el bot\00F3n <strong>Definir valores de marcador de posici\00F3n</strong> para asignar valores est\00E1ticos o de columna a los marcadores de posici\00F3n de la plantilla de correo electr\00F3nico. Para asignar un valor de ')
||unistr('columna, utilice sintaxis de sustituci\00F3n, como <code>&amp;COLUMN_NAME.<code>')
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937602033374347.4001)
,p_name=>'P7022_EMAIL_PLACEHOLDERS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>unistr('Nombres de los marcadores de posici\00F3n de la plantilla junto con los valores, para la sustituci\00F3n. Se almacenar de forma interna como una cadena JSON.')
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937708719374348.4001)
,p_name=>'P7022_EMAIL_LANG_OVERRIDE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>unistr('Sustituci\00F3n de idioma')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se especifica un c\00F3digo de idioma, el proceso buscar\00E1 la plantilla a partir de una traducci\00F3n de aplicaci\00F3n para este idioma. Si no existe ninguna traducci\00F3n, el proceso utilizar\00E1 el idioma principal de la aplicaci\00F3n. La sintaxis de sustituci\00F3n')
||unistr(' est\00E1 soportada.</p>'),
unistr('<p>La jerarqu\00EDa de c\00F3digo de idiomas est\00E1 soportada. Si se especifica un valor "fr-ca" (Franc\00E9s - Canad\00E1), pero solo existe una traducci\00F3n para "fr" (franc\00E9s), se utilizar\00E1 esa traducci\00F3n igualmente.</p>')))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937828893374349.4001)
,p_name=>'P7022_EMAIL_SUBJECT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Asunto'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>120
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el asunto del correo electr\00F3nico. Utilice sintaxis de sustituci\00F3n, como <code>&amp;P6_PRODUCT_NAME.</code>, si desea incluir un valor din\00E1mico.')
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1937960503374350.4001)
,p_name=>'P7022_EMAIL_BODY_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Cuerpo - Texto sin Formato'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>65
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto del correo electr\00F3nico. Se utilizar\00E1 la versi\00F3n de texto sin formato en caso de que el cliente de correo electr\00F3nico del destinatario no soporte la visualizaci\00F3n de texto enriquecido. Utilice sintaxis de sustituci\00F3n (ejemplo: <')
||unistr('code>&amp;P6_PRODUCT_NAME.</code>) si desea incluir contenido din\00E1mico en el texto.</p>'),
unistr('<p><em>Nota: La especificaci\00F3n SMTP/MIME establece que ninguna l\00EDnea debe tener m\00E1s de 1000 caracteres. Para cumplir esta restricci\00F3n, debe agregar caracteres de retorno de carro o salto de l\00EDnea para dividir el texto en p\00E1rrafos de hasta 1000 caract')
||unistr('eres. Si no lo hace, se pueden producir mensajes de correo electr\00F3nico err\00F3neos (como mensajes parciales o con signos de exclamaci\00F3n extra\00F1os).</em></p>')))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3702247340120801.4001)
,p_name=>'P7022_EMAIL_BODY_HTML'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Cuerpo - HTML'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca texto que genere un mensaje HTML de varias partes que incluya tanto texto sin formato como contenido HTML. La configuraci\00F3n y las capacidades del cliente de correo electr\00F3nico del destinatario determinar\00E1n lo que se muestra. Aunque la m')
||unistr('ayor\00EDa de los clientes de correo electr\00F3nico actuales lee correo electr\00F3nico con formato HTML, recuerde que algunos usuarios desactivan esta funci\00F3n para evitar problemas de seguridad. Utilice la sintaxis de sustituci\00F3n (por ejemplo, <code>&amp;P6_PR')
||unistr('ODUCT_NAME.</code>) si desea incluir contenido din\00E1mico en el texto.</p>'),
unistr('<p>Al hacer referencia a im\00E1genes con etiquetas &lt;img /&gt;, recuerde que, para que el destinatario pueda ver las im\00E1genes, su cliente de correo electr\00F3nico debe poder acceder a ellas. Supongamos, por ejemplo, que hace referencia a una imagen en la')
||' red denominada hello.gif de la siguiente manera:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>En este ejemplo, la imagen no se adjunta al correo electr\00F3nico, sino que se hace referencia a ella en el correo electr\00F3nico. Para verla, el destinatario debe poder acceder a ella con un explorador web. Si la imagen est\00E1 dentro de un firewall y el ')
||unistr('destinatario est\00E1 fuera, no se mostrar\00E1 la imagen. Por este motivo, evite utilizar im\00E1genes. Si tiene que incluir im\00E1genes, aseg\00FArese de incluir el atributo ALT para proporcionar una descripci\00F3n de texto por si no se puede acceder a la imagen.</p>'),
unistr('<p><em>Nota: La especificaci\00F3n SMTP/MIME establece que ninguna l\00EDnea debe tener m\00E1s de 1000 caracteres. Para cumplir esta restricci\00F3n, debe agregar caracteres de retorno de carro o salto de l\00EDnea para dividir el texto en p\00E1rrafos de hasta 1000 caract')
||unistr('eres. Si no lo hace, se pueden producir mensajes de correo electr\00F3nico err\00F3neos (como mensajes parciales o con signos de exclamaci\00F3n extra\00F1os).</em></p>')))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3702317872120802.4001)
,p_name=>'P7022_EMAIL_ATTACH_QUERY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(1936683460374337.4001)
,p_prompt=>'Anexo - SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>65
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una sentencia SQL que devuelva uno o m\00E1s objetos binarios grandes que se adjunten como archivos al mensaje de correo electr\00F3nico.</p>'),
unistr('<p>Si la columna content_id contiene un valor nulo, los archivos asociados ser\00E1n archivos adjuntos normales. Por lo general, los archivos como documentos o archivos .zip se adjuntan de esta forma.</p>'),
unistr('<p>Si el valor de content_id no es nulo, entonces el archivo asociado se marcar\00E1 como adjunto en l\00EDnea. El valor de la columna content_id se utilizar\00E1 como CID (identificador de contenido) del archivo adjunto. Este valor de CID se puede utilizar en e')
||unistr('l c\00F3digo HTML del mensaje de correo electr\00F3nico para embeber im\00E1genes directamente en el contenido de correo electr\00F3nico. Tenga en cuenta que es posible que algunos clientes de correo electr\00F3nico no muestren los archivos adjuntos en l\00EDnea autom\00E1ticam')
||unistr('ente. Oracle Application Express no aplica la conformidad con estos est\00E1ndares.</p>'),
'<p></p>',
'<p>La sentencia SQL debe tener el siguiente formato:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
unistr('<p>Las columnas mime_type y content_id son opcionales. Si content_id est\00E1 presente, el archivo se adjuntar\00E1 en l\00EDnea y el valor de content_id se utilizar\00E1 para el CID del archivo adjunto.</p>'),
unistr('<p>Si la columna content_id contiene el valor ''my_inline_content'', la imagen se puede embeber en el mensaje de correo electr\00F3nico usando el siguiente HTML:</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'SQL'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(108345209529984210.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7022_REMOTE_SERVER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P7022_LOCATION'
,p_compute_when_text=>'LOCAL'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1736036609290745.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7022_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'LOCAL'
,p_compute_when=>'P7022_LOCATION'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1804863853591816.4001)
,p_computation_sequence=>20
,p_computation_item=>'P7022_FLOW_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1501304193184401.4001)
,p_computation_sequence=>30
,p_computation_item=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1736409816290749.4001)
,p_validation_name=>'Validate Remote PL/SQL Code'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_exec_dev.check_code (',
'               p_location         => ''REMOTE'',',
'               p_remote_server_id => :P7022_REMOTE_SERVER_ID,',
'               p_code             => :P7022_CODE,',
'               p_language         => wwv_flow_code_exec.c_plsql );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql and :P7022_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1409543908910722.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1804033152591808.4001)
,p_validation_name=>'Validate Local Code'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_code_exec_dev.check_code (',
'               p_code     => :P7022_CODE,',
'               p_language => :P7022_ACTION_CLOB_LANGUAGE );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql and :P7022_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1736536337290750.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
begin
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1804381817591811.4001)
,p_validation_name=>'Code is required'
,p_validation_sequence=>30
,p_validation=>'P7022_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se requiere c\00F3digo PL/SQL')
,p_validation_condition=>':REQUEST in (''CREATE'', ''APPLY_CHANGES'' ) and :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3703533064120814.4001)
,p_validation_name=>'Email Subject is required'
,p_validation_sequence=>40
,p_validation=>'P7022_EMAIL_SUBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P7022_EMAIL_TEMPLATE_ID is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1937828893374349.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3706972053120848.4001)
,p_validation_name=>'Email From is required'
,p_validation_sequence=>50
,p_validation=>'P7022_EMAIL_FROM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1937001282374341.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3707027010120849.4001)
,p_validation_name=>'Email To is required'
,p_validation_sequence=>60
,p_validation=>'P7022_EMAIL_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1937161460374342.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3703640637120815.4001)
,p_validation_name=>'Email Body Plain Text is required'
,p_validation_sequence=>70
,p_validation=>'P7022_EMAIL_BODY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P7022_EMAIL_TEMPLATE_ID is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1937960503374350.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(3703883833120817.4001)
,p_validation_name=>'Email Placeholders are valid JSON'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_values wwv_flow_json.t_values;',
'begin',
'    wwv_flow_json.parse(',
'        p_values => l_values,',
'        p_source => coalesce( :P7022_EMAIL_PLACEHOLDERS, ''{}'' ) );',
'',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('#LABEL# no es un objeto JSON v\00E1lido.')
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P7022_EMAIL_TEMPLATE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(1937602033374347.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1409669859910723.4001)
,p_name=>'Execute Code'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_ACTION_TYPE'
,p_condition_element=>'P7022_ACTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_PLSQL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1409764006910724.4001)
,p_event_id=>wwv_flow_api.id(1409669859910723.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1409470037910721.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1735392609290738.4001)
,p_event_id=>wwv_flow_api.id(1409669859910723.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1409470037910721.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1733756061290722.4001)
,p_name=>'REST Enabled SQL Reference'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_LOCATION'
,p_condition_element=>'P7022_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(90116420313448613.4001)
,p_event_id=>wwv_flow_api.id(1733756061290722.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(90115922532448608.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1733838030290723.4001)
,p_event_id=>wwv_flow_api.id(1733756061290722.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(90116067165448609.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(90116331048448612.4001)
,p_event_id=>wwv_flow_api.id(1733756061290722.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(90116067165448609.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1803309431591801.4001)
,p_event_id=>wwv_flow_api.id(1733756061290722.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(90115922532448608.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1735719758290742.4001)
,p_name=>'Confirm'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1735615488290741.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1735823568290743.4001)
,p_event_id=>wwv_flow_api.id(1735719758290742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>unistr('\00BFSeguro que desea suprimir esta acci\00F3n?')
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1735943089290744.4001)
,p_event_id=>wwv_flow_api.id(1735719758290742.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(90116530888448614.4001)
,p_name=>'Remote Server Chosen'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_REMOTE_SERVER_ID'
,p_condition_element=>'P7022_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(90116629180448615.4001)
,p_event_id=>wwv_flow_api.id(90116530888448614.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_REMOTE_PLSQL_CODE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(90116710734448616.4001)
,p_event_id=>wwv_flow_api.id(90116530888448614.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_REMOTE_PLSQL_CODE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1936307267374334.4001)
,p_name=>'Send Email'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_ACTION_TYPE'
,p_condition_element=>'P7022_ACTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_SEND_EMAIL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1936452688374335.4001)
,p_event_id=>wwv_flow_api.id(1936307267374334.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(348707341969499917.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1936805327374339.4001)
,p_event_id=>wwv_flow_api.id(1936307267374334.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1936683460374337.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1936583392374336.4001)
,p_event_id=>wwv_flow_api.id(1936307267374334.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(348707341969499917.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1936774874374338.4001)
,p_event_id=>wwv_flow_api.id(1936307267374334.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1936683460374337.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3702516007120804.4001)
,p_name=>'Email Template chosen'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_EMAIL_TEMPLATE_ID'
,p_condition_element=>'P7022_EMAIL_TEMPLATE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3702629436120805.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_LANG_OVERRIDE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3702742207120806.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_LANG_OVERRIDE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3706534848120844.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3704015479120819.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3706613462120845.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(3704015479120819.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3702861461120807.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_SUBJECT,P7022_EMAIL_BODY_TEXT,P7022_EMAIL_BODY_HTML'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3702969573120808.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_SUBJECT,P7022_EMAIL_BODY_TEXT,P7022_EMAIL_BODY_HTML'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3703175773120810.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_LANG_OVERRIDE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3706706670120846.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P7022_EMAIL_SUBJECT", "");',
'$s("P7022_EMAIL_BODY_TEXT", "");',
'$s("P7022_EMAIL_BODY_HTML","");'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3703030757120809.4001)
,p_event_id=>wwv_flow_api.id(3702516007120804.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_placeholders     wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'    l_placeholder_json varchar2(32767)     := :P7022_EMAIL_PLACEHOLDERS;',
'',
'    l_old_placeholders wwv_flow_json.t_values;',
'    l_old_value        varchar2(32767);',
'begin',
'    l_placeholders := wwv_flow_template_dev.email_template_placeholders(',
'                          p_application_id    => :FB_FLOW_ID,',
'                          p_email_template_id => :P7022_EMAIL_TEMPLATE_ID );',
'',
'    if l_placeholder_json is not null then',
'        begin',
'            wwv_flow_json.parse( p_source => l_placeholder_json, p_values => l_old_placeholders );',
'        exception',
'            when others then',
'                null;',
'                -- if the template placeholders is invalid JSON, we cannot preserve any of',
'                -- the old values, so we do nothing and build the JSON anew.',
'        end;',
'    end if;',
'',
'    l_placeholder_json := ''{'' || wwv_flow.LF;',
'    for i in 1 .. l_placeholders.count loop',
'        l_old_value        := wwv_flow_json.get_varchar2( ',
'                                  p_values => l_old_placeholders, ',
'                                  p_path   => l_placeholders( i ) );',
'        l_placeholder_json := l_placeholder_json || ''    ''',
'                                                 || wwv_flow_json.stringify( l_placeholders( i ) ) ',
'                                                 || '':'' ',
'                                                 -- to have item and column substitutions working, the "&" character',
'                                                 -- must not be escaped to \u0026. Since WWV_FLOW_JSON.STRINGIFY does that,',
'                                                 -- we''ll revert it here.',
'                                                 || replace( wwv_flow_json.stringify( l_old_value ), ''\u0026'', ''&'' )',
'                                                 || case when i < l_placeholders.count then '','' end',
'                                                 || wwv_flow.LF;',
'    end loop;',
'    l_placeholder_json := l_placeholder_json || ''}'';',
'',
'    return l_placeholder_json;',
'end;',
''))
,p_attribute_07=>'P7022_EMAIL_TEMPLATE_ID,P7022_EMAIL_PLACEHOLDERS'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3704156927120820.4001)
,p_name=>'Open Placeholders dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(3704015479120819.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3704380215120822.4001)
,p_event_id=>wwv_flow_api.id(3704156927120820.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_values      wwv_flow_json.t_values;',
'    l_members     wwv_flow_t_varchar2;',
'    l_member_name varchar2(4000);',
'begin',
'    wwv_flow_json.parse( p_values => l_values, p_source => :P7022_EMAIL_PLACEHOLDERS );',
'    wwv_flow_collection.create_or_truncate_collection( ''P7022_EMAIL_PLACEHOLDER_COLL'');',
'    l_members := wwv_flow_json.get_members( p_values => l_values, p_path => ''.'' );',
'    for i in 1 .. l_members.count loop',
'        l_member_name := l_members( i );',
'        continue when l_member_name is null;',
'',
'        --',
'        -- revert JSON escaping for attribute names; otherwise we would see escaped placeholder',
'        -- names in the edit dialog. Placeholder names will be re-escaped when the placeholder dialog',
'        -- is closed and the JSON is generated again.',
'        --',
'        if substr( l_member_name, 1, 1 ) = ''"'' then',
'            l_member_name := replace( substr( l_member_name, 2, length( l_member_name ) - 2 ), ''\"'', ''"'');',
'        end if;',
'        ',
'        wwv_flow_collection.add_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'',',
'                                        p_c001            => l_member_name,',
'                                        p_c002            => wwv_flow_json.get_varchar2( p_values => l_values, p_path => l_members( i ) ) );',
'    end loop;',
'end;',
''))
,p_attribute_02=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_TEMPLATE_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3704834447120827.4001)
,p_event_id=>wwv_flow_api.id(3704156927120820.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704459976120823.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3704206259120821.4001)
,p_event_id=>wwv_flow_api.id(3704156927120820.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704459976120823.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(3706079552120839.4001)
,p_name=>'Save Placeholders: Copy Placeholders from to Item (JSON)'
,p_event_sequence=>80
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(3704459976120823.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridsave'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3706133162120840.4001)
,p_event_id=>wwv_flow_api.id(3706079552120839.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_placeholder_json varchar2(32767);',
'    l_first            boolean := true;',
'    l_added_keys       wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'begin',
'    l_placeholder_json := ''{'';',
'    for pl in (',
'        select c001 placeholder,',
'               c002 value',
'          from wwv_flow_collections',
'         where collection_name = ''P7022_EMAIL_PLACEHOLDER_COLL'' )',
'    loop',
'        if not pl.placeholder member of l_added_keys then',
'            l_placeholder_json := l_placeholder_json || case when not l_first then '','' end ',
'                                                    || wwv_flow.LF || ''    ''',
'                                                    || wwv_flow_json.stringify( pl.placeholder ) ',
'                                                    || '':'' ',
'                                                    -- to have item and column substitutions working, the "&" character',
'                                                    -- must not be escaped to \u0026. Since WWV_FLOW_JSON.STRINGIFY does that,',
'                                                    -- we''ll revert that here.',
'                                                    || replace( wwv_flow_json.stringify( pl.value ), ''\u0026'', ''&'' );',
'            l_first := false;',
'            wwv_flow_string.push( l_added_keys, pl.placeholder );',
'        end if;',
'    end loop;',
'    l_placeholder_json := l_placeholder_json || wwv_flow.LF || ''}'';',
'',
'    :P7022_EMAIL_PLACEHOLDERS := l_placeholder_json;',
'end;'))
,p_attribute_03=>'P7022_EMAIL_PLACEHOLDERS'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(3706280109120841.4001)
,p_event_id=>wwv_flow_api.id(3706079552120839.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3704459976120823.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1501640651184404.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Condition for each row'
,p_process_sql_clob=>':P7022_EXEC_COND_FOR_EACH_ROW := case when :P7022_CONDITION_TYPE is null then null else :P7022_EXEC_COND_FOR_EACH_ROW end;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'APPLY_CHANGES:CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1735408536290739.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_api.id(1410170163910728.4001)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Action'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1804231622591810.4001)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load "Load and Remote" Code'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7022_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'    :P7022_LOCAL_CODE := :P7022_CODE;',
'else',
'    :P7022_REMOTE_PLSQL_CODE := :P7022_CODE;',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3703409029120813.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Send Email Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  :P7022_EMAIL_FROM            := :P7022_ATTRIBUTE_01;',
'  :P7022_EMAIL_TO              := :P7022_ATTRIBUTE_02;',
'  :P7022_EMAIL_CC              := :P7022_ATTRIBUTE_03;',
'  :P7022_EMAIL_BCC             := :P7022_ATTRIBUTE_04;',
'  :P7022_EMAIL_REPLYTO         := :P7022_ATTRIBUTE_05;',
'  :P7022_EMAIL_SUBJECT         := :P7022_ATTRIBUTE_06;',
'  :P7022_EMAIL_BODY_TEXT       := :P7022_ATTRIBUTE_07;',
'  :P7022_EMAIL_BODY_HTML       := :P7022_ATTRIBUTE_08;',
'  :P7022_EMAIL_ATTACH_QUERY    := :P7022_ATTRIBUTE_09;',
'  :P7022_EMAIL_TEMPLATE_ID     := :P7022_ATTRIBUTE_11;',
'  :P7022_EMAIL_PLACEHOLDERS    := :P7022_ATTRIBUTE_12;',
'  :P7022_EMAIL_LANG_OVERRIDE   := :P7022_ATTRIBUTE_13;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P7022_ACTION_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NATIVE_SEND_EMAIL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1410208284910729.4001)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_api.id(1410170163910728.4001)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form WWV_FLOW_AUTOMATION_ACTIONS'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3703228772120811.4001)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Send Email Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P7022_ATTRIBUTE_01 := :P7022_EMAIL_FROM;',
'    :P7022_ATTRIBUTE_02 := :P7022_EMAIL_TO;',
'    :P7022_ATTRIBUTE_03 := :P7022_EMAIL_CC;',
'    :P7022_ATTRIBUTE_04 := :P7022_EMAIL_BCC;',
'    :P7022_ATTRIBUTE_05 := :P7022_EMAIL_REPLYTO;',
'    :P7022_ATTRIBUTE_06 := :P7022_EMAIL_SUBJECT;',
'    :P7022_ATTRIBUTE_07 := :P7022_EMAIL_BODY_TEXT;',
'    :P7022_ATTRIBUTE_08 := :P7022_EMAIL_BODY_HTML;',
'    :P7022_ATTRIBUTE_09 := :P7022_EMAIL_ATTACH_QUERY;',
'    :P7022_ATTRIBUTE_10 := ''N'';',
'    :P7022_ATTRIBUTE_11 := :P7022_EMAIL_TEMPLATE_ID;',
'    :P7022_ATTRIBUTE_12 := :P7022_EMAIL_PLACEHOLDERS;',
'    :P7022_ATTRIBUTE_13 := :P7022_EMAIL_LANG_OVERRIDE;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P7022_ACTION_TYPE = ''NATIVE_SEND_EMAIL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1567619929713207.4001)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Execute Code Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql then',
'        if :P7022_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'            :P7022_CODE := :P7022_LOCAL_CODE;',
'        else',
'            :P7022_CODE                 := :P7022_REMOTE_PLSQL_CODE;',
'            :P7022_ACTION_CLOB_LANGUAGE := null;',
'        end if;',
'    else',
'        :P7022_CODE                 := null;',
'        :P7022_ACTION_CLOB_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(3705927437120838.4001)
,p_process_sequence=>40
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_api.id(3704459976120823.4001)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Copy Placeholders Grid to Collection'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        :SEQ_ID := wwv_flow_collection.add_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'', p_c001 => :PLACEHOLDER, p_c002 => :VALUE );',
'    when ''U'' then',
'        wwv_flow_collection.update_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'', p_seq => :SEQ_ID, p_c001 => :PLACEHOLDER, p_c002 => :VALUE );',
'    when ''D'' then',
'        wwv_flow_collection.delete_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'', p_seq => :SEQ_ID );',
'    end case;',
'end;'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
);
end;
/
prompt --application/pages/page_07025
begin
wwv_flow_api.create_page(
 p_id=>7025.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Log de Ejecuci\00F3n')
,p_alias=>'EXECUTION-LOG'
,p_step_title=>unistr('Log de Ejecuci\00F3n')
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1926493800406303.4001)
,p_plug_name=>unistr('Borrar log de automatizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_api.id(557449278618308550.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Depurar todas las entradas del log para la automatizaci\00F3n seleccionada.</p>')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4278350131923238.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2700189206621868.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5817615693534538.4001)
,p_plug_name=>unistr('Log de Ejecuci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id,',
'       a.name automation_name,',
'       l.is_job,',
'       l.status,',
'       l.start_timestamp,',
'       l.end_timestamp,',
'       l.successful_row_count,',
'       l.error_row_count,',
'       l.security_group_id,',
'       (select count(1) from wwv_flow_automation_msg_log where log_id = l.id) msg_count',
'  from wwv_flow_automations a, wwv_flow_automation_log l',
' where a.flow_id = :fb_flow_id',
'   and a.security_group_id = :flow_security_group_id  ',
'   and a.id = l.automation_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>unistr('Log de Ejecuci\00F3n')
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(5817715858534539.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se han registrado ejecuciones de automatizaci\00F3n.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>5817715858534539
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5817884178534540.4001)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3100190697149801.4001)
,p_db_column_name=>'AUTOMATION_NAME'
,p_display_order=>20
,p_column_identifier=>'J'
,p_column_label=>unistr('Automatizaci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818073345534542.4001)
,p_db_column_name=>'IS_JOB'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Programado'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818124649534543.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_api.id(2000855720872191)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818268993534544.4001)
,p_db_column_name=>'START_TIMESTAMP'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Iniciar Registro de Hora'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818394529534545.4001)
,p_db_column_name=>'END_TIMESTAMP'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Terminar Registro de Hora'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818430301534546.4001)
,p_db_column_name=>'SUCCESSFUL_ROW_COUNT'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Filas correctas'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818533192534547.4001)
,p_db_column_name=>'ERROR_ROW_COUNT'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Filas con errores'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5818887816534550.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Identificador de Grupo de Seguridad'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3100282407149802.4001)
,p_db_column_name=>'MSG_COUNT'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Mensajes'
,p_column_link=>'f?p=&APP_ID.:7026:&SESSION.::&DEBUG.:7026:P7026_LOG_ID:#ID#'
,p_column_linktext=>'#MSG_COUNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29895556730987848.4001)
,p_plug_name=>unistr('Log de Ejecuci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Revise la informaci\00F3n registrada sobre las ejecuciones de automatizaci\00F3n anteriores. El log contiene registros de hora de inicio y finalizaci\00F3n, as\00ED como detalles sobre las filas procesadas (de forma correcta y con errores). Desglose en los <stron')
||'g>mensajes</strong> para ver los distintos mensajes de las filas procesadas.</p>',
unistr('<p>&PRODUCT_NAME. depura la informaci\00F3n de log por defecto cada 14 d\00EDas. Se pueden configurar otros per\00EDodos de retenci\00F3n en los servicios de administraci\00F3n.</p>')))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1926957076406308.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1926493800406303.4001)
,p_button_name=>'CLEAR_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Borrar Log'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1926603486406305.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(5817615693534538.4001)
,p_button_name=>'OPEN_CLEAR_LOG'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Depurar log'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1926510639406304.4001)
,p_name=>'P7025_AUTOMATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1926493800406303.4001)
,p_prompt=>unistr('Automatizaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1926753216406306.4001)
,p_name=>'Open Clear Log Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1926603486406305.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1926893253406307.4001)
,p_event_id=>wwv_flow_api.id(1926753216406306.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1926493800406303.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1927072386406309.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Automation Log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_automation_msg_log1$',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'     ',
'    delete wwv_flow_automation_msg_log2$',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    delete wwv_flow_automation_log1$ ',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'       ',
'    delete wwv_flow_automation_log2$ ',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'     ',
'    :P7025_AUTOMATION := null; ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CLEAR_LOG'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('El log de automatizaci\00F3n se ha borrado.')
);
end;
/
prompt --application/pages/page_07026
begin
wwv_flow_api.create_page(
 p_id=>7026.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Mensajes de Log'
,p_alias=>'LOG-MESSAGES'
,p_step_title=>'Mensajes de Log'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(1379381290188239.4001)
,p_name=>unistr('Ejecuci\00F3n de automatizaci\00F3n')
,p_template=>wwv_flow_api.id(174794400314076650.4001)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--noBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.name,',
'       l.start_timestamp,',
'       l.status',
'  from wwv_flow_automations a,',
'       wwv_flow_automation_log l',
' where a.id                = l.automation_id',
'   and a.security_group_id = :flow_security_group_id  ',
'   and l.security_group_id = :flow_security_group_id  ',
'   and l.id                = :P7026_LOG_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(82408032331628644.4001)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1379451249188240.4001)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>unistr('Automatizaci\00F3n')
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1379528031188241.4001)
,p_query_column_id=>2
,p_column_alias=>'START_TIMESTAMP'
,p_column_display_sequence=>20
,p_column_heading=>unistr('Registro de hora de inicio de la ejecuci\00F3n')
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(1379681945188242.4001)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>30
,p_column_heading=>'Estado'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(2000855720872191)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3101396571149813.4001)
,p_plug_name=>'Mensajes de Log'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select log_id,',
'       action_id,',
'       message_type,',
'       message,',
'       pk_value,',
'       message_timestamp,',
'       security_group_id',
'  from wwv_flow_automation_msg_log',
' where security_group_id = :flow_security_group_id  ',
'   and log_id = :P7026_LOG_ID',
'',
'  '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Mensajes de Log'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3101586625149815.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No existen mensajes de detalle disponibles para esta ejecuci\00F3n.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>3101586625149815
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3101671491149816.4001)
,p_db_column_name=>'LOG_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Identificador de Log'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3101700606149817.4001)
,p_db_column_name=>'ACTION_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>unistr('Identificador de Acci\00F3n')
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3101849886149818.4001)
,p_db_column_name=>'MESSAGE_TYPE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Tipo de Mensaje'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(4601034447346038)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3101992033149819.4001)
,p_db_column_name=>'MESSAGE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Mensaje'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3102093627149820.4001)
,p_db_column_name=>'PK_VALUE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Valor de Clave Primaria '
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3102163225149821.4001)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Registro de hora'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3102280991149822.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Identificador de Grupo de Seguridad'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4477052522299401.4001)
,p_plug_name=>'Mensajes de Log'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Revise los mensajes de detalle generados durante la ejecuci\00F3n de la automatizaci\00F3n. Se generar\00E1 un '),
unistr('mensaje por cada error que se produzca durante la ejecuci\00F3n de las acciones de automatizaci\00F3n. '),
'Los procedimientos <strong>LOG_INFO</strong>, <strong>LOG_WARN</strong>',
'o <strong>LOG_ERROR</strong> de <strong>APEX_AUTOMATION</strong>',
unistr('tambi\00E9n generar\00E1n mensajes de log.'),
'</p>',
'<p>',
unistr('Un mensaje de log contiene el registro de hora del mensaje, el tipo de mensaje (informaci\00F3n, advertencia,'),
'error), el mensaje real y (opcionalmente) el valor de clave primaria de la fila para la que ',
'se ha generado el mensaje.',
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(7678852160115842.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2700189206621868.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3101474004149814.4001)
,p_name=>'P7026_LOG_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(7678852160115842.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_07027
begin
wwv_flow_api.create_page(
 p_id=>7027.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Historial'
,p_alias=>'HISTORY'
,p_step_title=>'Historial'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3104354856149843.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''AUTOMATION'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_AUTOMATIONS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''AUTOMATION ACTION'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_AUTOMATION_ACTIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Historial'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(3104443872149844.4001)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>unistr('No se ha encontrado informaci\00F3n de historial.')
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'N'
,p_owner=>'ADMIN'
,p_internal_uid=>3104443872149844
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3104544445149845.4001)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Desarrollador'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3104676270149846.4001)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>unistr('Fecha de Auditor\00EDa')
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3104767829149847.4001)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>unistr('Acci\00F3n')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5012446025058001.4001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Tipo de Objeto'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_api.id(1387977807801823)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(5012535112058002.4001)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Nombre del Componente'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3104849534149848.4001)
,p_db_column_name=>'SCN'
,p_display_order=>90
,p_column_identifier=>'D'
,p_column_label=>'Scn'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3104972238149849.4001)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>100
,p_column_identifier=>'E'
,p_column_label=>unistr('Comentario de Auditor\00EDa')
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(3105052040149850.4001)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>110
,p_column_identifier=>'F'
,p_column_label=>'Clave de Componente'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(12679063870106035.4001)
,p_plug_name=>'Navegar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_api.id(2700189206621868.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29895658509987849.4001)
,p_plug_name=>'Historial'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>unistr('En esta p\00E1gina se muestran las modificaciones recientes realizadas en las automatizaciones de esta aplicaci\00F3n.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_07030
begin
wwv_flow_api.create_page(
 p_id=>7030.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear automatizaci\00F3n')
,p_alias=>'CREATE-AUTOMATION1'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear automatizaci\00F3n')
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'div#P7030_POLLING_STARTAT_DAILY_CONTAINER span.apex-quick-picks {display: inline; padding-left: 5px; }'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1482219015184018.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4284423226001546.4001)
,p_plug_name=>unistr('Detalles de automatizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1480696327184002.4001)
,p_plug_name=>'Detalles de sondeo'
,p_parent_plug_id=>wwv_flow_api.id(4284423226001546.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1407895539910705.4001)
,p_plug_name=>'Intervalo personalizado'
,p_parent_plug_id=>wwv_flow_api.id(1480696327184002.4001)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1482361436184019.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1482219015184018.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1377917386188225.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1482219015184018.4001)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1484112867184037.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1482219015184018.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1482418259184020.4001)
,p_branch_action=>'f?p=&APP_ID.:7031:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1482361436184019.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1379028918188236.4001)
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021:P7021_ID:&P7030_NEW_AUTOMATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1377917386188225.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P7030_RESULT_TYPE'
,p_branch_condition_text=>'ALWAYS'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1377873956188224.4001)
,p_name=>'P7030_RESULT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4284423226001546.4001)
,p_item_default=>'QUERY'
,p_prompt=>'Acciones iniciadas el'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7030_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601121722896835768.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si la ejecuci\00F3n de las acciones de automatizaci\00F3n se debe iniciar seg\00FAn una <strong>consulta</strong> (las acciones pueden usar las filas devueltas) o si las acciones se deben ejecutar <strong>siempre</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1378610163188232.4001)
,p_name=>'P7030_MIN_CADENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4284423226001546.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1378947340188235.4001)
,p_name=>'P7030_NEW_AUTOMATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4284423226001546.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1407471175910701.4001)
,p_name=>'P7030_POLLING_PREDEFINED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1480696327184002.4001)
,p_item_default=>'T1H'
,p_prompt=>unistr('Planificaci\00F3n de Ejecuci\00F3n')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7030_POLLING_PREDEFINED'
,p_lov=>'.'||wwv_flow_api.id(601117964216834048.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione un programa de ejecuci\00F3n para la nueva automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1480507758184001.4001)
,p_name=>'P7030_POLLING_STARTAT_HOURLY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(1407895539910705.4001)
,p_prompt=>unistr('Minuto de ejecuci\00F3n')
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>2
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el minuto de ejecuci\00F3n, de 0 a 59.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_02=>'59'
,p_attribute_03=>'left'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1482139156184017.4001)
,p_name=>'P7030_POLLING_INTERVAL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1407895539910705.4001)
,p_item_default=>'1'
,p_prompt=>'Intervalo'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique el intervalo de ejecuci\00F3n. Por ejemplo, si se ha elegido <strong>Diario</strong> como valor de <strong>Frecuencia</strong> y se introduce <strong>2</strong> aqu\00ED, la automatizaci\00F3n se ejecutar\00E1 cada dos d\00EDas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4284549488001547.4001)
,p_name=>'P7030_AUTOMATION_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4284423226001546.4001)
,p_prompt=>'Nombre'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca un nombre para la nueva automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4284616068001548.4001)
,p_name=>'P7030_AUTOMATION_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4284423226001546.4001)
,p_item_default=>'POLLING'
,p_prompt=>'Tipo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_TRIGGER_TYPE'
,p_lov=>'.'||wwv_flow_api.id(1355426926728029.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Las automatizaciones con una <strong>programaci\00F3n</strong> se ejecutar\00E1n autom\00E1ticamente seg\00FAn la frecuencia seleccionada. Si se selecciona <strong>A petici\00F3n</strong>, la automatizaci\00F3n solo se ejecutar\00E1 cuando se llame expl\00EDcitamente mediante el pa')
||'quete <strong>APEX_AUTOMATION</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4284714832001549.4001)
,p_name=>'P7030_POLLING_INTERVAL_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1407895539910705.4001)
,p_item_default=>'HOURLY'
,p_prompt=>'Frecuencia'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7030_POLLING_INTERVAL_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601120036396834677.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si la programaci\00F3n de ejecuci\00F3n se debe establecer sobre una base diaria, por horas o por minutos. Se pueden definir programaciones m\00E1s avanzadas en las p\00E1ginas de edici\00F3n una vez que se haya creado la automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4284826933001550.4001)
,p_name=>'P7030_POLLING_STARTAT_DAILY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1407895539910705.4001)
,p_prompt=>unistr('Tiempo de Ejecuci\00F3n')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Especifique la hora de ejecuci\00F3n con el formato <strong>HH24:MI</strong>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Medianoche'
,p_quick_pick_value_01=>'00:00'
,p_quick_pick_label_02=>'6:00 a.m.'
,p_quick_pick_value_02=>'06:00'
,p_quick_pick_label_03=>'Tarde'
,p_quick_pick_value_03=>'12:00'
,p_quick_pick_label_04=>'6:00 p.m.'
,p_quick_pick_value_04=>'18:00'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4477275252299403.4001)
,p_name=>'P7030_SCHEDULER_EXPRESSION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(1407895539910705.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(4477385851299404.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7030_SCHEDULER_EXPRESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rtrim( case :P7030_POLLING_PREDEFINED ',
'        when ''15M''      then ''FREQ=MINUTELY;INTERVAL=15''',
'        when ''T1H''      then ''FREQ=HOURLY;INTERVAL=1;BYMINUTE=0''',
'        when ''MIDNIGHT'' then ''FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=0''',
'        when ''CUSTOM''   then ''FREQ='' || :P7030_POLLING_INTERVAL_TYPE || '';'' ||',
'                                        ''INTERVAL=''  || :P7030_POLLING_INTERVAL || '';'' ||',
'                                        case :P7030_POLLING_INTERVAL_TYPE',
'                                            when ''DAILY'' then ',
'                                                ''BYHOUR=''   || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMHH24'' ) || ',
'                                                '';'' ||',
'                                                ''BYMINUTE='' || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMMI'' )',
'                                            when ''HOURLY'' then',
'                                                ''BYMINUTE='' || :P7030_POLLING_STARTAT_HOURLY',
'                                        end',
'    end, '';'' )'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_date date;',
'begin',
'    l_dummy_date := to_date( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1935605700374327.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7030_MIN_CADENCE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE''),0)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1408083237910707.4001)
,p_validation_name=>'Is valid time'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_date date;',
'begin',
'    l_dummy_date := to_date( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Las horas deben tener el formato hh:mm, por ejemplo, 14:00'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7030_AUTOMATION_TYPE = ''POLLING'' and :P7030_POLLING_INTERVAL_TYPE = ''DAILY'' and',
':P7030_POLLING_PREDEFINED = ''CUSTOM'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1482361436184019.4001)
,p_associated_item=>wwv_flow_api.id(4284826933001550.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1408302835910710.4001)
,p_validation_name=>'Not more frequent than BACKGROUND_MIN_EXECUTION_CADENCE'
,p_validation_sequence=>20
,p_validation=>'to_number( wwv_flow_automation_dev.get_execution_cadence_minutes( :P7030_SCHEDULER_EXPRESSION ) ) >= to_number( :P7030_MIN_CADENCE )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Las automatizaciones no se pueden ejecutar con una frecuencia superior a cada &P7030_MIN_CADENCE!HTML. minutos.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7030_POLLING_INTERVAL_TYPE = ''MINUTELY'' and :P7030_AUTOMATION_TYPE = ''POLLING'' and ',
':P7030_POLLING_PREDEFINED = ''CUSTOM'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(1482361436184019.4001)
,p_associated_item=>wwv_flow_api.id(1482139156184017.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1501795377184405.4001)
,p_validation_name=>'Automation Name is unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_automations',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P7030_AUTOMATION_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>unistr('Ya existe ese nombre de automatizaci\00F3n')
,p_validation_condition=>'NEXT:CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(4284549488001547.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1480735517184003.4001)
,p_name=>'Automation Type'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_AUTOMATION_TYPE'
,p_condition_element=>'P7030_AUTOMATION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLLING'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480880293184004.4001)
,p_event_id=>wwv_flow_api.id(1480735517184003.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1480696327184002.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1480973671184005.4001)
,p_event_id=>wwv_flow_api.id(1480735517184003.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1480696327184002.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1481052251184006.4001)
,p_name=>'Interval "MINUTELY"'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_condition_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'MINUTELY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1481670583184012.4001)
,p_event_id=>wwv_flow_api.id(1481052251184006.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY,P7030_POLLING_STARTAT_DAILY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484503383184041.4001)
,p_event_id=>wwv_flow_api.id(1481052251184006.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY,P7030_POLLING_STARTAT_HOURLY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1408861371910715.4001)
,p_event_id=>wwv_flow_api.id(1481052251184006.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'15'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1481881118184014.4001)
,p_name=>'Interval "HOURLY"'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_condition_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOURLY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1481902724184015.4001)
,p_event_id=>wwv_flow_api.id(1481881118184014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1482054210184016.4001)
,p_event_id=>wwv_flow_api.id(1481881118184014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484641960184042.4001)
,p_event_id=>wwv_flow_api.id(1481881118184014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484859877184044.4001)
,p_event_id=>wwv_flow_api.id(1481881118184014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1408998062910716.4001)
,p_event_id=>wwv_flow_api.id(1481881118184014.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'1'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1481364447184009.4001)
,p_name=>'Interval "DAILY"'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_condition_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DAILY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1481483690184010.4001)
,p_event_id=>wwv_flow_api.id(1481364447184009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1407959778910706.4001)
,p_event_id=>wwv_flow_api.id(1481364447184009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484456947184040.4001)
,p_event_id=>wwv_flow_api.id(1481364447184009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'12:00'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484752306184043.4001)
,p_event_id=>wwv_flow_api.id(1481364447184009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1409081251910717.4001)
,p_event_id=>wwv_flow_api.id(1481364447184009.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'1'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1484221707184038.4001)
,p_name=>'Cancel'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1484112867184037.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1484305893184039.4001)
,p_event_id=>wwv_flow_api.id(1484221707184038.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1407562176910702.4001)
,p_name=>'Custom Interval Chosen'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_PREDEFINED'
,p_condition_element=>'P7030_POLLING_PREDEFINED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1407685185910703.4001)
,p_event_id=>wwv_flow_api.id(1407562176910702.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1407895539910705.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1407736354910704.4001)
,p_event_id=>wwv_flow_api.id(1407562176910702.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1407895539910705.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1378096245188226.4001)
,p_name=>'Result Type'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_RESULT_TYPE'
,p_condition_element=>'P7030_RESULT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1378123256188227.4001)
,p_event_id=>wwv_flow_api.id(1378096245188226.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(1482361436184019.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1378411527188230.4001)
,p_event_id=>wwv_flow_api.id(1378096245188226.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(1377917386188225.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1378263947188228.4001)
,p_event_id=>wwv_flow_api.id(1378096245188226.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(1377917386188225.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1378368125188229.4001)
,p_event_id=>wwv_flow_api.id(1378096245188226.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_api.id(1482361436184019.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1378717517188233.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_automation_id    number;    ',
'begin',
'    :P7030_NEW_AUTOMATION_ID := wwv_flow_automation_dev.create_wizard (',
'                                    p_flow_id           => :FB_FLOW_ID,',
'                                    --',
'                                    p_name              => :P7030_AUTOMATION_NAME,',
'                                    p_trigger_type      => :P7030_AUTOMATION_TYPE,',
'                                    p_polling_interval  => :P7030_SCHEDULER_EXPRESSION,',
'                                    --',
'                                    p_result_type       => ''ALWAYS'',',
'                                    p_location          => null,',
'                                    p_remote_server_id  => null,',
'                                    p_web_src_module_id => null,',
'                                    p_query_type        => null,',
'                                    p_query_source      => null,',
'                                    p_query_owner       => null,',
'                                    p_query_table       => null,',
'                                    --',
'                                    p_pk_column_name    => null ); ',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(1377917386188225.4001)
,p_process_when=>'P7030_RESULT_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ALWAYS'
,p_process_success_message=>unistr('Se ha creado la automatizaci\00F3n. Ahora debe crear <em>acciones</em> para que se ejecuten cuando se ejecute la automatizaci\00F3n.')
);
end;
/
prompt --application/pages/page_07031
begin
wwv_flow_api.create_page(
 p_id=>7031.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Crear automatizaci\00F3n')
,p_alias=>'CREATE-AUTOMATION'
,p_page_mode=>'MODAL'
,p_step_title=>unistr('Crear automatizaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(93464502376707648)
,p_step_template=>wwv_flow_api.id(689065306389965836.4001)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(45759350624876133.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94229353380171984.4001)
,p_plug_name=>unistr('Crear automatizaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3116778298066610.4001)
,p_plug_name=>'Crear para origen de datos local'
,p_parent_plug_id=>wwv_flow_api.id(94229353380171984.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3116863712066611.4001)
,p_plug_name=>'Crear informe sobre origen de datos de REST'
,p_parent_plug_id=>wwv_flow_api.id(94229353380171984.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4907518142674538.4001)
,p_plug_name=>'Crear informe sobre SQL remoto'
,p_parent_plug_id=>wwv_flow_api.id(94229353380171984.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94229569163171984.4001)
,p_plug_name=>'Ejemplo de Consulta SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(399849897040726767.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT ENAME, JOB, SAL, COMM',
'  FROM EMPLOYEE_CHANGES',
' WHERE UPDATED_ON > APEX_AUTOMATION.GET_LAST_RUN',
'</pre>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>unistr('<p><strong>APEX_AUTOMATION.GET_LAST_RUN</strong> devuelve el registro de hora de la ejecuci\00F3n de la automatizaci\00F3n anterior, por lo que se puede utilizar para procesar solo los registros que no est\00E1n siendo procesados por las automatizaciones anterio')
||'res.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(94235765262177001.4001)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(92836304316872750.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1340033910119016.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(45759350624876133.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1340421143119017.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(45759350624876133.4001)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Crear'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1340891475119017.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(45759350624876133.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:7030:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(1408121517910708.4001)
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021:P7021_ID:&P7031_NEW_AUTOMATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1341581006119025.4001)
,p_name=>'P7031_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(94229353380171984.4001)
,p_item_default=>'LOCAL'
,p_prompt=>'Origen de Datos'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_api.id(3842073961668883.4001)||'.'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('    Seleccione el <em>origen de datos</em> para la nueva automatizaci\00F3n.'),
'</p>',
'<ul>',
'    <li><strong>Base de datos local</strong><br>',
'    Los datos se obtienen de la base de datos local.</li>',
'    <li><strong>Servicio SQL activado para REST</strong><br>',
unistr('    Los datos se obtienen de una base de datos remota, donde la conexi\00F3n se define usando SQL activado para REST. Para crear o mantener referencias SQL activadas para REST, vaya a Componentes compartidos > SQL activado para REST.'),
'    </li>',
'    <li><strong>Origen de datos de REST</strong><br>',
unistr('    Los datos proceden de un servicio web de RESTful definido con los or\00EDgenes de datos de REST. Para crear o mantener los or\00EDgenes de datos de REST, vaya a Componentes compartidos > Or\00EDgenes de datos de REST.'),
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1344416432119033.4001)
,p_name=>'P7031_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3116778298066610.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas o consultas SQL. Se pueden configurar m\00E1s opciones en la p\00E1gina de edici\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1345743577119035.4001)
,p_name=>'P7031_TABLE_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(3116778298066610.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P7031_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que se va a basar esta automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1346687732119035.4001)
,p_name=>'P7031_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3116778298066610.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P7031_TABLE_OWNER',
'   and :P7031_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Valor -'
,p_lov_cascade_parent_items=>'P7031_TABLE_OWNER,P7031_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1347963424119036.4001)
,p_name=>'P7031_SQL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3116778298066610.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que ser\00E1 el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n, por ejemplo:'),
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
unistr('Los valores de columna se pueden usar en acciones de automatizaci\00F3n con sintaxis de variable de enlace (por ejemplo, <strong>:EMPNO</strong>). Adem\00E1s de los datos de la consulta, puede utilizar <strong>APEX_AUTOMATION.GET_LAST_RUN</strong> para hacer')
||unistr(' referencia al registro de hora de la <em>ejecuci\00F3n anterior</em> de esta automatizaci\00F3n. Esto es \00FAtil para evitar procesar los datos dos veces.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1363610750119068.4001)
,p_name=>'P7031_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3116863712066611.4001)
,p_prompt=>'Origen de Datos de REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id = :FB_FLOW_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1366462296119070.4001)
,p_name=>'P7031_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4907518142674538.4001)
,p_prompt=>'Servicio de SQL activado para REST'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar -'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Seleccione una referencia de SQL activado para REST.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1366857840119070.4001)
,p_name=>'P7031_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4907518142674538.4001)
,p_item_default=>'TABLE'
,p_prompt=>'Tipo de Origen'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(141264908196813501.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas o consultas SQL.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1367741822119070.4001)
,p_name=>'P7031_REMOTE_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4907518142674538.4001)
,p_prompt=>'Introduzca una sentencia SELECT de SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_api.id(561549716994252345.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique la consulta SQL que ser\00E1 el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n, por ejemplo:'),
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
unistr('Los valores de columna se pueden usar en acciones de automatizaci\00F3n con sintaxis de variable de enlace (por ejemplo, <strong>:EMPNO</strong>).')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P7031_REMOTE_SERVER_ID'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1368611592119070.4001)
,p_name=>'P7031_REMOTE_TABLE_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4907518142674538.4001)
,p_prompt=>'Propietario de Tabla/Vista'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7031_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Esquema Actual'
,p_lov_cascade_parent_items=>'P7031_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione el propietario de la tabla en la que se va a basar esta automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1369572098119071.4001)
,p_name=>'P7031_REMOTE_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(4907518142674538.4001)
,p_prompt=>'Nombre de Tabla/Vista'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7031_REMOTE_SERVER_ID, ''TABLE'', :P7031_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Seleccionar Tabla o Vista -'
,p_lov_cascade_parent_items=>'P7031_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P7031_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione la tabla o vista en la que se basar\00E1 la automatizaci\00F3n.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1408292598910709.4001)
,p_name=>'P7031_NEW_AUTOMATION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(94229353380171984.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1408410223910711.4001)
,p_name=>'P7031_WEB_SRC_RESULT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3116863712066611.4001)
,p_item_default=>'ROWS'
,p_prompt=>'Tipo de Resultado'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601105473256773090.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si las acciones de automatizaci\00F3n se deben ejecutar cuando el servicio <em>devuelve filas</em> (Datos encontrados) o cuando la <em>consulta no devuelve filas</em> (No se ha encontrado ning\00FAn dato).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1484930150184045.4001)
,p_name=>'P7031_RESULT_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3116778298066610.4001)
,p_item_default=>'ROWS'
,p_prompt=>'Ejecutar acciones cuando'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601105473256773090.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Seleccione si las acciones de automatizaci\00F3n se deben ejecutar cuando la consulta <em>devuelve filas</em> o cuando la consulta <em>no devuelve filas</em>.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1485324427184049.4001)
,p_name=>'P7031_REMOTE_RESULT_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(4907518142674538.4001)
,p_item_default=>'ROWS'
,p_prompt=>'Tipo de Resultado'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_api.id(601105473256773090.4001)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Especifique si las acciones de automatizaci\00F3n se deben ejecutar cuando el origen de datos <em>devuelve filas</em> (Datos encontrados) o cuando la <em>consulta no devuelve filas</em> (No se ha encontrado ning\00FAn dato).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1377410808119092.4001)
,p_computation_sequence=>50
,p_computation_item=>'P7031_TABLE_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1377894340119092.4001)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7031_TABLE_OWNER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1376619329119090.4001)
,p_computation_sequence=>60
,p_computation_item=>'P7031_REMOTE_SERVER_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(1380687782119094.4001)
,p_validation_name=>'Is Valid Automation Query'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_automation_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'return wwv_flow_automation_dev.validate_automation_query(',
'           p_location             => :P7031_LOCATION,',
'           p_remote_server_id     => :P7031_REMOTE_SERVER_ID,',
'           p_web_src_module_id    => :P7031_WEB_SRC_MODULE_ID,',
'           --',
'           p_table_owner          => case :P7031_LOCATION',
'                                         when ''LOCAL''  then :P7031_TABLE_OWNER ',
'                                         when ''REMOTE'' then :P7031_REMOTE_TABLE_OWNER end,',
'           p_table_name           => case :P7031_LOCATION',
'                                         when ''LOCAL''  then :P7031_TABLE_NAME ',
'                                         when ''REMOTE'' then :P7031_REMOTE_TABLE_NAME end,',
'           p_where_clause         => null,',
'           p_order_by_clause      => null,',
'           p_sql_plsql            => case :P7031_LOCATION',
'                                         when ''LOCAL''  then :P7031_SQL ',
'                                         when ''REMOTE'' then :P7031_REMOTE_SQL end,',
'           p_language             => ''PLSQL'',',
'           p_optimizer_hint       => null,',
'           --',
'           p_source_post_process  => null,',
'',
'           p_local_query_type     => case :P7031_SOURCE_TYPE',
'                                        when ''QUERY'' then ''SQL''',
'                                        else :P7031_SOURCE_TYPE end,',
'           p_remote_query_type    => case :P7031_REMOTE_SOURCE_TYPE',
'                                        when ''QUERY'' then ''SQL''',
'                                        else :P7031_REMOTE_SOURCE_TYPE end );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_api.id(1340421143119017.4001)
,p_associated_item=>wwv_flow_api.id(1347963424119036.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1384591848119099.4001)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1340033910119016.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1385062308119104.4001)
,p_event_id=>wwv_flow_api.id(1384591848119099.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1385482908119107.4001)
,p_name=>'Show attributes for source "SQL"'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_SOURCE_TYPE'
,p_condition_element=>'P7031_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1390492324119111.4001)
,p_event_id=>wwv_flow_api.id(1385482908119107.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(94229569163171984.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1385913558119107.4001)
,p_event_id=>wwv_flow_api.id(1385482908119107.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1386957334119108.4001)
,p_event_id=>wwv_flow_api.id(1385482908119107.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_TABLE_OWNER,P7031_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1485004985184046.4001)
,p_event_id=>wwv_flow_api.id(1385482908119107.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_RESULT_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1483033194184026.4001)
,p_name=>'Show attributes for source "TABLE"'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_SOURCE_TYPE'
,p_condition_element=>'P7031_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1483283525184028.4001)
,p_event_id=>wwv_flow_api.id(1483033194184026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_SQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1483413723184030.4001)
,p_event_id=>wwv_flow_api.id(1483033194184026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_TABLE_OWNER,P7031_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1483532025184031.4001)
,p_event_id=>wwv_flow_api.id(1483033194184026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(94229569163171984.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1485143815184047.4001)
,p_event_id=>wwv_flow_api.id(1483033194184026.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_RESULT_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1395854463119113.4001)
,p_name=>'show remote source attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P7031_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1396329813119114.4001)
,p_event_id=>wwv_flow_api.id(1395854463119113.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1396868674119114.4001)
,p_event_id=>wwv_flow_api.id(1395854463119113.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_TABLE_OWNER,P7031_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1397318711119114.4001)
,p_event_id=>wwv_flow_api.id(1395854463119113.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_TABLE_OWNER,P7031_REMOTE_TABLE_NAME'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1397841937119114.4001)
,p_event_id=>wwv_flow_api.id(1395854463119113.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SQL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1398327308119114.4001)
,p_event_id=>wwv_flow_api.id(1395854463119113.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(94229569163171984.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1398802374119114.4001)
,p_event_id=>wwv_flow_api.id(1395854463119113.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(94229569163171984.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1403434134119132.4001)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_LOCATION'
,p_condition_element=>'P7031_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1403924801119132.4001)
,p_event_id=>wwv_flow_api.id(1403434134119132.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3116778298066610.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1404443367119132.4001)
,p_event_id=>wwv_flow_api.id(1403434134119132.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3116778298066610.4001)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1405417287119133.4001)
,p_event_id=>wwv_flow_api.id(1403434134119132.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1406887016119133.4001)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_LOCATION'
,p_condition_element=>'P7031_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1407321219119133.4001)
,p_event_id=>wwv_flow_api.id(1406887016119133.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4907518142674538.4001)
,p_attribute_01=>'N'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1407843134119133.4001)
,p_event_id=>wwv_flow_api.id(1406887016119133.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(4907518142674538.4001)
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1408263565119134.4001)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_LOCATION'
,p_condition_element=>'P7031_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1408794745119134.4001)
,p_event_id=>wwv_flow_api.id(1408263565119134.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3116863712066611.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1409267912119134.4001)
,p_event_id=>wwv_flow_api.id(1408263565119134.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(3116863712066611.4001)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1409790381119134.4001)
,p_event_id=>wwv_flow_api.id(1408263565119134.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1410136177119134.4001)
,p_name=>'Remote Server chosen'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_REMOTE_SERVER_ID'
,p_condition_element=>'P7031_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1410622070119134.4001)
,p_event_id=>wwv_flow_api.id(1410136177119134.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE,P7031_REMOTE_RESULT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1411100138119134.4001)
,p_event_id=>wwv_flow_api.id(1410136177119134.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1411656612119134.4001)
,p_event_id=>wwv_flow_api.id(1410136177119134.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE,P7031_REMOTE_SQL,P7031_REMOTE_TABLE_OWNER,P7031_REMOTE_TABLE_NAME,P7031_REMOTE_RESULT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1412126899119135.4001)
,p_event_id=>wwv_flow_api.id(1410136177119134.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1408590684910712.4001)
,p_name=>'Web Source Module chosen'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_WEB_SRC_MODULE_ID'
,p_condition_element=>'P7031_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1408632360910713.4001)
,p_event_id=>wwv_flow_api.id(1408590684910712.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_RESULT_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1408752890910714.4001)
,p_event_id=>wwv_flow_api.id(1408590684910712.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_RESULT_TYPE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1401497341619801.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_item_prefix constant varchar2(15) := ''P7031_'' ||',
'                                          case when :P7031_LOCATION = ''REMOTE'' then ''REMOTE_'' end;',
'',
'    l_automation_id number;',
'    l_query_type       wwv_flow_automations.query_type%type;',
'    l_query_owner      wwv_flow_automations.query_owner%type;',
'    l_query_table      wwv_flow_automations.query_table%type;',
'    l_query_source     wwv_flow_automations.query_source%type;',
'    l_result_type      wwv_flow_automations.result_type%type;',
'    ',
'    l_polling_interval varchar2(32767);',
'begin',
'    case :P7030_POLLING_PREDEFINED ',
'        when ''15M''      then l_polling_interval := ''FREQ=MINUTELY;INTERVAL=15'';',
'        when ''T1H''      then l_polling_interval := ''FREQ=HOURLY;INTERVAL=1;BYMINUTE=0'';',
'        when ''MIDNIGHT'' then l_polling_interval := ''FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=0'';',
'        when ''CUSTOM''   then',
'            l_polling_interval := ''FREQ=''      || :P7030_POLLING_INTERVAL_TYPE || '';'' ||',
'                                  ''INTERVAL=''  || :P7030_POLLING_INTERVAL || '';'' ||',
'                                  case :P7030_POLLING_INTERVAL_TYPE',
'                                      when ''DAILY'' then ',
'                                          ''BYHOUR=''   || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMHH24'' ) || ',
'                                          '';'' ||',
'                                          ''BYMINUTE='' || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMMI'' )',
'                                      when ''HOURLY'' then',
'                                          ''BYMINUTE='' || :P7030_POLLING_STARTAT_HOURLY',
'                                  end;',
'    end case;    ',
'',
'    if :P7031_LOCATION in ( ''LOCAL'', ''REMOTE'' ) then',
'        l_query_type  := v( c_item_prefix || ''SOURCE_TYPE'' );',
'        l_result_type := v( c_item_prefix || ''RESULT_TYPE'' );',
'        ',
'        case l_query_type',
'        when ''TABLE'' then',
'            l_query_owner := v( c_item_prefix || ''TABLE_OWNER'' );',
'            l_query_table := v( c_item_prefix || ''TABLE_NAME'' );',
'        when ''QUERY'' then',
'            l_query_source := v( c_item_prefix || ''SQL'' );',
'            l_query_type   := ''SQL'';',
'        end case;',
'    elsif :P7031_LOCATION = ''WEB_SOURCE'' then',
'        l_result_type := v( ''P7031_WEB_SRC_RESULT_TYPE'' );',
'    end if;',
'',
'    :P7031_NEW_AUTOMATION_ID := wwv_flow_automation_dev.create_wizard (',
'                                    p_flow_id           => :FB_FLOW_ID,',
'                                    --',
'                                    p_name              => :P7030_AUTOMATION_NAME,',
'                                    p_trigger_type      => :P7030_AUTOMATION_TYPE,',
'                                    p_polling_interval  => rtrim(l_polling_interval,'';'' ),',
'                                    --',
'                                    p_result_type       => l_result_type,',
'                                    p_location          => :P7031_LOCATION,',
'                                    p_remote_server_id  => :P7031_REMOTE_SERVER_ID,',
'                                    p_web_src_module_id => :P7031_WEB_SRC_MODULE_ID,',
'                                    p_query_type        => l_query_type,',
'                                    p_query_source      => l_query_source,',
'                                    p_query_owner       => l_query_owner,',
'                                    p_query_table       => l_query_table,',
'                                    --',
'                                    p_pk_column_name    => null ); ',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Se ha creado la automatizaci\00F3n y tiene el estado "Desactivado". Ahora debe crear <em>acciones</em> para que se ejecuten cuando se ejecute la automatizaci\00F3n.')
);
end;
/
prompt --application/pages/page_07777
begin
wwv_flow_api.create_page(
 p_id=>7777.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Elementos de Contrase\00F1a')
,p_step_title=>unistr('Elementos de Contrase\00F1a')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_util_cross_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15991103646058130.4001)
,p_plug_name=>unistr('Elementos de Contrase\00F1a')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P7777a */',
'    f.id                            application_id,',
'    f.name                          application_name,',
'    p.id                            page_id,',
'    p.name                          page_name,',
'    --',
'    i.name                          item_name,',
'    (select plug_name',
'     from wwv_flow_page_plugs',
'     where id = i.ITEM_PLUG_ID)     region,',
'    i.PROMPT                        label,',
'    --',
'    i.id                            item_id,',
'    case i.is_persistent when ''N'' then m.m_yes else m.m_no end dnss,',
'    decode(i.encrypt_session_state_yn,''Y'',m.m_yes,m.m_no) encrypt_state,',
'    decode(nvl(p.AUTOCOMPLETE_ON_OFF,''ON''),',
'       ''ON'',m_on,',
'       ''OFF'',m_off,',
'       p.AUTOCOMPLETE_ON_OFF) AUTOCOMPLETE_ON_OFF,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',m.m_no,',
'      case i.is_persistent when ''N'' then m_no else m_yes end) at_risk,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',''N'',',
'      case i.is_persistent when ''N'' then ''N'' else ''Y'' end) at_risk_code',
'from wwv_flow_step_items i,',
'     wwv_flow_steps p,',
'     wwv_flows f,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''F4000_ON'') m_on,',
'       wwv_flow_lang.system_message(''F4000_OFF'') m_off',
'from dual) m',
'where i.flow_step_id = p.id and',
'      i.flow_id = f.id and',
'      i.flow_id = p.flow_id and',
'      i.display_as = ''NATIVE_PASSWORD'' and',
'      i.security_group_id = :flow_security_group_id and',
'      i.flow_id = f.id and',
'      p.flow_id = i.flow_id and',
'      f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(15991228349058130.4001)
,p_name=>'Password Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15991424526058152.4001)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1,4015,RP:FB_FLOW_ID,F4000_P1_FLOW:#APPLICATION_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#APPLICATION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15991511431058152.4001)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la Aplicaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15991619847058152.4001)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('P\00E1gina')
,p_column_link=>'#PAGE_LINK#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15991725247058153.4001)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Nombre de la P\00E1gina')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15991831587058153.4001)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Nombre del Elemento'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:1:FB_FLOW_ID,F4000_P1_FLOW,FB_FLOW_PAGE_ID:#APPLICATION_ID#,#APPLICATION_ID#,#PAGE_ID##5120:#ITEM_ID#'
,p_column_linktext=>'#ITEM_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15992012541058153.4001)
,p_db_column_name=>'REGION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Regi\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15992108837058153.4001)
,p_db_column_name=>'LABEL'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Etiqueta'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15992209394058153.4001)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Item ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(435148310342536430.4001)
,p_db_column_name=>'DNSS'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'No guarda el estado'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15992315624058153.4001)
,p_db_column_name=>'ENCRYPT_STATE'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Cifrar Estado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15992404096058154.4001)
,p_db_column_name=>'AUTOCOMPLETE_ON_OFF'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>unistr('Terminar Autom\00E1ticamente')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15992521637058154.4001)
,p_db_column_name=>'AT_RISK'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'En Riesgo'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(487114910098693160.4001)
,p_db_column_name=>'AT_RISK_CODE'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>unistr('C\00F3digo en peligro')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(222858147672540009.4001)
,p_plug_name=>'Password Items'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se recomienda que ninguno de los elementos de tipo contrase\00F1a guarde el estado de la sesi\00F3n. Para definir un elemento de contrase\00F1a para que no guarde el estado, edite el elemento y defina el atributo <strong>Mostrar como</strong> en un tipo de el')
||unistr('emento de contrase\00F1a que no guarde el estado. Para los elementos de tipo contrase\00F1a que necesitan que se mantenga el estado de la sesi\00F3n entre las vistas de p\00E1gina, se recomienda cifrar el estado de la sesi\00F3n. Para cifrar el estado de la sesi\00F3n del e')
||'lemento, edite el elemento y ajuste el atributo de elemento <strong>Cifrado</strong>.</p>',
'',
unistr('<p>Tambi\00E9n se recomienda que en las p\00E1ginas con contrase\00F1as se desactive la terminaci\00F3n autom\00E1tica de la pantalla HTML. Para llevar esto a cabo, edite los atributos de p\00E1gina haciendo clic en el n\00FAmero de p\00E1gina y, a continuaci\00F3n, en el icono de edic')
||unistr('i\00F3n de atributos de p\00E1gina, y defina el atributo <strong>Terminaci\00F3n autom\00E1tica de pantalla</strong> en <strong>Desactivada</strong>.</p>'),
'',
unistr('<p>Los elementos de contrase\00F1a en riesgo son elementos que guardan el estado y no est\00E1n cifrados.</p>')))
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702955313727525460.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1116538526541900834.4001)
,p_name=>'P7777_AT_RISK_LABEL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15991103646058130.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(34301224356833701.4001)
,p_computation_sequence=>10
,p_computation_item=>'P7777_AT_RISK_LABEL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''AT_RISK_LABEL'')'
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_api.create_page(
 p_id=>8000.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Buscar'
,p_step_title=>'Buscar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_searchResults#MIN#.js'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(30710309677866793.4001)
,p_plug_name=>'Buscar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174795123140076650.4001)
,p_plug_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(33628013409955025.4001)
,p_name=>'Search Result'
,p_region_name=>'search_results'
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select path,',
'       attribute_name,',
'       ''<pre>''||wwv_flow_escape.html_trunc(attribute_value,3980)||''</pre>'' as attribute_value,',
'       ''<button type="button" class="a-Button edit-button" data-link="'' ||',
'       wwv_flow_utilities.prepare_url( link_url ) || ''"'' ||',
'       case when component_type_id is not null then',
'         '' data-appid="''       || flow_id || ''"'' ||',
'         '' data-pageid="''      || page_id || ''"'' ||',
'         '' data-typeid="''      || component_type_id || ''"'' ||',
'         '' data-componentid="'' || component_id || ''"''',
'       end ||',
'       ''>'' || wwv_flow_lang.system_message( ''VIEW_IN_BUILDER'' ) || ''</button>'' as view_button',
'  from wwv_flow_search_result_dev',
' order by order_value,',
'          attribute_name'))
,p_display_when_condition=>':P8000_SEARCH is not null and :P8000_START_SEARCH = ''0'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(33634627411119986.4001)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No se ha encontrado nada con el t\00E9rmino de b\00FAsqueda <strong>&P8000_SEARCH.</strong>')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_break_repeat_heading_format=>'<span style="white-space:nowrap;"><strong>#COLUMN_VALUE#</strong></span>'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33635410152218990.4001)
,p_query_column_id=>1
,p_column_alias=>'PATH'
,p_column_display_sequence=>1
,p_column_heading=>'Ruta de Acceso'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33635502250218990.4001)
,p_query_column_id=>2
,p_column_alias=>'ATTRIBUTE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Atributo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(33635613519218990.4001)
,p_query_column_id=>3
,p_column_alias=>'ATTRIBUTE_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Valor'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P8000_SEARCH.'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(690213935224382244.4001)
,p_query_column_id=>4
,p_column_alias=>'VIEW_BUTTON'
,p_column_display_sequence=>4
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#VIEW_BUTTON#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(33630423630995815.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(30710309677866793.4001)
,p_button_name=>'P8000_GO'
,p_button_static_id=>'P8000_GO'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Buscar'
,p_button_alignment=>'LEFT-CENTER'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(385809145843243616.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(30710309677866793.4001)
,p_button_name=>'P8000_CLOSE'
,p_button_static_id=>'P8000_CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cerrar'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'SEARCH'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(30710630455872765.4001)
,p_name=>'P8000_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(30710309677866793.4001)
,p_prompt=>'Buscar'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el t\00E9rmino que est\00E1 buscando. Si coloca el prefijo <pre>regexp:</pre> en el t\00E9rmino de b\00FAsqueda, puede realizar una b\00FAsqueda de expresiones regulares. Consulte la documentaci\00F3n de la base de datos Oracle para obtener m\00E1s informaci\00F3n sob')
||'re la sintaxis de las expresiones regulares.',
'</p>',
'<p>Ejemplo:',
'<pre>regexp:(P1_NAME)|(P2_NAME)</pre>',
unistr('Encontrar\00E1 todas las ocurrencias de P1_NAME y P2_NAME. '),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(33748409937455691.4001)
,p_name=>'P8000_CASE_SENSITIVE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(30710309677866793.4001)
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CASE SENSITIVE'
,p_lov=>'.'||wwv_flow_api.id(574890434307383427.4001)||'.'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione esta opci\00F3n si el t\00E9rmino de b\00FAsqueda que est\00E1 intentando encontrar es sensible a may\00FAsculas/min\00FAsculas.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(34118613284626227.4001)
,p_name=>'P8000_CURRENT_PAGE_ONLY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(30710309677866793.4001)
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CURRENT PAGE ONLY'
,p_lov=>'.'||wwv_flow_api.id(574892035638384809.4001)||'.'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Seleccione esta opci\00F3n si solo desea buscar en la p\00E1gina actual el t\00E9rmino de b\00FAsqueda que ha introducido.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1157686899566338229.4001)
,p_name=>'P8000_START_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(30710309677866793.4001)
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1157686979614338230.4001)
,p_computation_sequence=>10
,p_computation_item=>'P8000_START_SEARCH'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(385809233568243617.4001)
,p_name=>'CloseWindow'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(385809145843243616.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(385809378838243618.4001)
,p_event_id=>wwv_flow_api.id(385809233568243617.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.close();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157687042687338231.4001)
,p_name=>'Start Search'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157687165348338232.4001)
,p_event_id=>wwv_flow_api.id(1157687042687338231.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v("P8000_START_SEARCH") === "1") {',
'    $s("P8000_START_SEARCH","0");',
'    doSearch();',
'}',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157687243160338233.4001)
,p_name=>'Search'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(33630423630995815.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157687308267338234.4001)
,p_event_id=>wwv_flow_api.id(1157687243160338233.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'doSearch();'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1157687459299338235.4001)
,p_name=>'Enter'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8000_SEARCH'
,p_bind_type=>'bind'
,p_bind_event_type=>'keypress'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1157687509627338236.4001)
,p_event_id=>wwv_flow_api.id(1157687459299338235.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.browserEvent.which === 13) {',
'    doSearch();',
'}'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(33630019690985289.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Perform search'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- let''s perform the search',
'    wwv_flow_builder_search_dev.search_application (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => case when :P8000_CURRENT_PAGE_ONLY = ''Y'' then :FB_FLOW_PAGE_ID end,',
'        p_case_sensitive => (nvl(:P8000_CASE_SENSITIVE, ''N'') = ''Y''),',
'        p_search_string  => :P8000_SEARCH );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P8000_SEARCH'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_08101
begin
wwv_flow_api.create_page(
 p_id=>8101.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Asesor'
,p_step_title=>'Asesor'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_searchResults#MIN#.js'
,p_step_template=>wwv_flow_api.id(19943204431962826.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(171875619216973594.4001)
,p_name=>unistr('Resultados de Comprobaci\00F3n')
,p_template=>wwv_flow_api.id(208928010704475743.4001)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select path,',
'       attribute_name,',
'       check_description,',
'       category_description,',
'       ''<pre>''||wwv_flow_escape.html_trunc(message_text, 3880)||''</pre>'' as message_text,',
'       help_text,',
'       ''<pre>''||wwv_flow_escape.html_trunc(attribute_value, 3880)||''</pre>'' as attribute_value,',
'       ''<button type="button" class="a-Button edit-button" data-link="'' ||',
'       wwv_flow_utilities.prepare_url( link_url ) || ''"'' ||',
'       case when component_type_id is not null then',
'         '' data-appid="''       || flow_id || ''"'' ||',
'         '' data-pageid="''      || page_id || ''"'' ||',
'         '' data-typeid="''      || component_type_id || ''"'' ||',
'         '' data-componentid="'' || component_id || ''"''',
'       end ||',
'       ''>'' || wwv_flow_lang.system_message( ''VIEW_IN_BUILDER'' ) || ''</button>'' as view_button',
'  from wwv_flow_advisor_result_dev',
' where flow_id       = :FB_FLOW_ID',
'   and :P8101_FILTER is not null',
'   and instr('':''||:P8101_FILTER||'':'', '':''||check_id||'':'') > 0',
' order by order_value,',
'          attribute_name,',
'          check_description'))
,p_display_when_condition=>'P8101_HAS_RESULT'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(33634627411119986.4001)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>unistr('No se han encontrado errores ni advertencias para las comprobaciones y categor\00EDas especificadas.')
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_break_repeat_heading_format=>'<span style="white-space:nowrap;"><strong>#COLUMN_VALUE#</strong></span>'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171875832581973594.4001)
,p_query_column_id=>1
,p_column_alias=>'PATH'
,p_column_display_sequence=>1
,p_column_heading=>'Ruta de Acceso'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171875918473973594.4001)
,p_query_column_id=>2
,p_column_alias=>'ATTRIBUTE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Atributo'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172065624337353870.4001)
,p_query_column_id=>3
,p_column_alias=>'CHECK_DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Comprobar'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171885706724034537.4001)
,p_query_column_id=>4
,p_column_alias=>'CATEGORY_DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>unistr('Categor\00EDa')
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171885815843034537.4001)
,p_query_column_id=>5
,p_column_alias=>'MESSAGE_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Mensaje'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(172065724192353870.4001)
,p_query_column_id=>6
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(171876019380973594.4001)
,p_query_column_id=>7
,p_column_alias=>'ATTRIBUTE_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Valor'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(690214074709382245.4001)
,p_query_column_id=>8
,p_column_alias=>'VIEW_BUTTON'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#VIEW_BUTTON#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(172043008895384369.4001)
,p_plug_name=>'Filtrar Resultado'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Se muestran los resultados de las comprobaciones que ha realizado. Puede filtrarlos desactivando alguna categor\00EDa o categor\00EDas espec\00EDficas en Filtrar Resultados y haciendo clic en el bot\00F3n Aplicar Filtro.'),
'</p> ',
'<p>',
unistr('Para solucionar los problemas identificados, haga clic en el enlace Ver de cada resultado. Despu\00E9s de solucionar los problemas, puede utilizar el bot\00F3n <em>Realizar Comprobaci\00F3n</em> para volver a ejecutar el informe o la vista, o el bot\00F3n <em>Compro')
||'baciones que Realizar</em> para seleccionar otras comprobaciones que realizar.',
'</p> ',
''))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P8101_HAS_RESULT'
,p_plug_display_when_cond2=>'Y'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(172072727716723789.4001)
,p_plug_name=>'Sin Errores'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(770240542605907344.4001)
,p_plug_display_sequence=>30
,p_plug_source=>'<p>No se han encontrado errores ni advertencias para las comprobaciones especificadas.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P8101_HAS_RESULT'
,p_plug_display_when_cond2=>'N'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_plug_name=>unistr('Comprobar P\00E1ginas')
,p_region_name=>'configuration'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>El asesor realiza varias comprobaciones en su aplicaci\00F3n, incluidos errores de programaci\00F3n, problemas de seguridad, control de calidad y otras mejores pr\00E1cticas. Para obtener la lista de comprobaciones, consulte <em>Comprobaciones que Realizar</e')
||unistr('m>. Cuando lo haya ejecutado, se volver\00E1 a aplicar la configuraci\00F3n anterior en el pr\00F3ximo uso.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1253548469643954909.4001)
,p_plug_name=>unistr('P\00E1ginas editadas en los \00FAltimos 7 d\00EDas')
,p_region_name=>'last_pages'
,p_parent_plug_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289324822177903547.4001)
,p_plug_name=>unistr('Editadas por M\00ED')
,p_parent_plug_id=>wwv_flow_api.id(1253548469643954909.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0;',
'begin',
'for c1 in (',
'select id',
'from wwv_flow_steps ',
'where flow_id = :fb_flow_id and ',
'          security_group_id = :flow_security_group_id and',
'          nvl(last_updated_on,created_on) > sysdate - 7 and',
'          nvl(last_updated_by,created_by) = :APP_USER',
'order by nvl(last_updated_on,created_on) desc ) loop',
'  c := c + 1;',
'  if c > 1 then sys.htp.prn('', ''); end if;',
'  sys.htp.prn(to_char(c1.id));',
'  if c > 100 then exit; end if;',
'end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289325063575903547.4001)
,p_plug_name=>unistr('Todas las P\00E1ginas Editadas')
,p_parent_plug_id=>wwv_flow_api.id(1253548469643954909.4001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0;',
'begin',
'for c1 in (',
'select id',
'from wwv_flow_steps ',
'where flow_id = :fb_flow_id and ',
'          security_group_id = :flow_security_group_id and',
'          nvl(last_updated_on,created_on) > sysdate - 7',
'order by nvl(last_updated_on,created_on) desc ) loop',
'  c := c + 1;',
'  if c > 1 then sys.htp.prn('', ''); end if;',
'  sys.htp.prn(to_char(c1.id));',
'  if c > 300 then exit; end if;',
'end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_plug_name=>'Comprobaciones que Realizar'
,p_region_name=>'checks_to_perform'
,p_parent_plug_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(689970285456172024.4001)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289319229814864296.4001)
,p_plug_name=>'left checkboxes'
,p_parent_plug_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289320081911864300.4001)
,p_plug_name=>'right checkboxes'
,p_parent_plug_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>16
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1289324123074903542.4001)
,p_plug_name=>'Check Page'
,p_parent_plug_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('Especifique una lista separada por comas de las p\00E1ginas que desea comprobar. Si desea comprobar todas las p\00E1ginas, d\00E9jela en blanco')
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(172079732629904948.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(172043008895384369.4001)
,p_button_name=>'FILTER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Aplicar Filtro'
,p_button_position=>'EDIT'
,p_button_condition=>'P8101_HAS_RESULT'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1289323892563901246.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_button_name=>'PERFORM_CHECK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Realizar Comprobaci\00F3n')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1289318688677864288.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_button_name=>'SELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Seleccionar Todo'
,p_button_position=>'TOP'
,p_button_alignment=>'LEFT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(1289318896947864292.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>unistr('Anular la Selecci\00F3n de Todo')
,p_button_position=>'TOP'
,p_button_alignment=>'LEFT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(171878324327973609.4001)
,p_branch_name=>'Go To Page 8101'
,p_branch_action=>'f?p=&APP_ID.:8101:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(1289323892563901246.4001)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(172058710420170031.4001)
,p_name=>'P8101_HAS_RESULT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(504967428701627048.4001)
,p_name=>'P8101_FILTER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(172043008895384369.4001)
,p_prompt=>'Filtrar Resultado'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.HIERARCHICAL_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r, l',
'  from (select ''<strong>''||wwv_flow_escape.html(wwv_flow_lang.system_message(''ADVISOR.CATEGORY.''||code))||''</strong> (''||l.message_count||'')'' as d,',
'               c.id        as r,',
'               1           as l,',
'               category_id,',
'               order_seq',
'          from ( select category_id,',
'                        count(*) as message_count',
'                   from wwv_flow_advisor_result_dev',
'                  where flow_id = :FB_FLOW_ID',
'                  group by category_id',
'                 having count(*) > 0',
'               ) l,',
'               wwv_flow_advisor_categories c',
'         where c.id = l.category_id',
'         union all',
'        select wwv_flow_escape.html(description)||'' (''||l.message_count||'')'' as d,',
'               c.id        as r,',
'               2           as l,',
'               c.category_id,',
'               order_seq',
'          from ( select check_id,',
'                        count(*) as message_count',
'                   from wwv_flow_advisor_result_dev',
'                  where flow_id = :FB_FLOW_ID',
'                  group by check_id',
'                 having count(*) > 0',
'               ) l,',
'               ( select id,',
'                        nvl(description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||code)) as description,',
'                        category_id,',
'                        order_seq',
'                   from wwv_flow_advisor_checks',
'               ) c',
'         where c.id = l.check_id',
'       )',
' order by category_id, l, order_seq'))
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(566010921977401124.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289319099571864292.4001)
,p_name=>'P8101_ALL_CHECKS'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289319416451864298.4001)
,p_name=>'P8101_ERROR_CHECKS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1289319229814864296.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Errores:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''ERROR''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('    <dt>Referencias con sintaxis de sustituci\00F3n</dt>'),
unistr('    <dd>\00BFExiste el elemento o la columna de pantalla tabular a los que se hace referencia con ''&amp;P999_NAME.''?</dd>'),
'    <dt>Referencias con sintaxis de columna</dt>',
unistr('    <dd>\00BFExiste la columna de informe a la que se hace referencia con #NAME#?</dd>'),
'    <dt>Referencias con sintaxis de variable de enlace</dt>',
unistr('    <dd>\00BFExiste el elemento o la columna a los que se hace referencia con '':P999_NAME''?</dd>'),
unistr('    <dt>Referencias declarativas de elementos de aplicaci\00F3n, elementos de p\00E1gina, columnas o filtros de informe interactivo</dt>'),
unistr('    <dd>\00BFExisten los elementos y alias de columna especificados?</dd>'),
unistr('    <dt>Existe n\00FAmero de p\00E1gina de referencia</dt>'),
unistr('    <dd>\00BFExiste el n\00FAmero de p\00E1gina al que se hace referencia?</dd>'),
unistr('    <dt>Es c\00F3digo SQL o PL/SQL v\00E1lido</dt>'),
unistr('    <dd>Verifica si la sentencia SQL o el c\00F3digo PL/SQL es v\00E1lido.</dd>'),
unistr('    <dt>Los procesos Recuperaci\00F3n, DML, MR* son v\00E1lidos</dt>'),
unistr('    <dd>Verifique que la cl\00E1usula where de la tabla, columnas y tiempo de ejecuci\00F3n son v\00E1lidas.</dd>'),
'    <dt>Rama incondicional antes que otras ramas</dt>',
unistr('    <dd>\00BFExiste una rama incondicional antes de otra rama? Si es as\00ED, la otra no se llegar\00E1 a ejecutar.</dd>'),
unistr('    <dt>Existe el bot\00F3n al que se hace referencia en Si se hace clic en el bot\00F3n</dt>'),
unistr('    <dd>\00BFExiste el bot\00F3n al que se hace referencia en "Si se hace clic en el bot\00F3n" de un proceso o validaci\00F3n?</dd>'),
unistr('    <dt>El bot\00F3n no es compatible con las acciones din\00E1micas</dt>'),
unistr('    <dd>Los botones con un identificador definido en ''Atributos de bot\00F3n'' o los botones basados en plantilla que hacen referencia a una plantilla de bot\00F3n que no contiene la cadena de sustituci\00F3n #BUTTON_ID# no son compatibles con las acciones din\00E1mi')
||'cas.</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289319600666864299.4001)
,p_name=>'P8101_SECURITY_CHECKS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(1289319229814864296.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Seguridad:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''SECURITY''',
'            and chk.category_id = cat.id',
'            and chk.code        <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('    <dt>Uso incorrecto de sintaxis de sustituci\00F3n</dt>'),
unistr('    <dd>Comprueba si el c\00F3digo SQL o PL/SQL contiene una referencia de aplicaci\00F3n, elemento de p\00E1gina o columna de pantalla tabular con la sintaxis de sustituci\00F3n (ejemplo &NAME.). Dicha referencia de elemento o columna tiene el potencial para la iny')
||unistr('ecci\00F3n SQL. Adem\00E1s, el rendimiento general de la aplicaci\00F3n es superior al utilizar variables de enlace en lugar de sustituciones de elementos en SQL y PL/SQL.</dd>'),
unistr('    <dt>Atributos de aplicaci\00F3n que se pueden bloquear</dt>'),
unistr('    <dd>Informa de los atributos de nivel de aplicaci\00F3n que se pueden bloquear para mejorar la seguridad.</dd>'),
unistr('    <dt>Autorizaci\00F3n</dt>'),
'    <dd>Informa sobre las autorizaciones que faltan o son inconsistentes.</dd>',
unistr('    <dt>Protecci\00F3n de estado de la sesi\00F3n</dt>'),
unistr('    <dd>Informa de la protecci\00F3n de estado de la sesi\00F3n que falta.</dd>'),
unistr('    <dt>Configuraci\00F3n de seguridad del explorador</dt>'),
'    <dd>Informa de los atributos de seguridad que se pueden bloquear para proteger al explorador del cliente.</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_item_comment=>'CNEUMUEL: MISSING_SYS_PREFIX is only enabled for builder apps'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289319879223864300.4001)
,p_name=>'P8101_WARNING_CHECKS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(1289319229814864296.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Advertencias:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''WARNING''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and ( chk.code      <> ''APEX_CODE_SMELL'' or :WORKSPACE_ID between 10 and 20 )        ',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('    <dt>El elemento de referencia est\00E1 en la p\00E1gina actual</dt>'),
unistr('    <dd>\00BFPertenecen los elementos de p\00E1gina a los que se hace referencia en componentes de la p\00E1gina a la p\00E1gina actual?</dd>'),
unistr('    <dt>El elemento de referencia es el elemento de p\00E1gina de la p\00E1gina de destino</dt>'),
unistr('    <dd>\00BFEs el elemento de p\00E1gina definido en el enlace un elemento de p\00E1gina de la p\00E1gina de destino?</dd>'),
unistr('    <dt>Referencias de elemento de p\00E1gina en una cadena</dt>'),
unistr('    <dd>Busque los patrones ''P999_NAME'' y "P999_NAME" y verifique si son elementos de p\00E1gina v\00E1lidos. Un nombre de elemento de p\00E1gina como una cadena se puede utilizar en JavaScript, V, NV o cualquier otra llamada de funci\00F3n o procedimiento que neces')
||unistr('ite un nombre de elemento de p\00E1gina.</dd>'),
unistr('    <dt>El n\00FAmero de p\00E1gina Borrar cach\00E9 es igual a la p\00E1gina de destino o actual</dt>'),
unistr('    <dd>\00BFCoincide el n\00FAmero de p\00E1gina Borrar cach\00E9 de un enlace con la p\00E1gina actual o de destino? Esta comprobaci\00F3n no se realiza si se especifican varios n\00FAmeros de p\00E1gina Borrar cach\00E9.</dd>'),
'    <dt>Longitud de elemento o nombre de columna de pantalla tabular</dt>',
unistr('    <dd>La aplicaci\00F3n, los elementos de p\00E1gina y las columnas de pantalla tabular deben tener como m\00E1ximo 30 caracteres; de lo contrario, no se puede hacer referencia a los mismos con la sintaxis de variable de enlace.</dd>'),
unistr('    <dt>Referencias inconsistentes entre las acciones din\00E1micas y los botones</dt>'),
unistr('    <dd>Los botones a los que hacen referencia las acciones din\00E1micas con una acci\00F3n no est\00E1n definidos por acci\00F3n din\00E1mica o los botones con una acci\00F3n definida por acci\00F3n din\00E1mica no tienen su correspondiente acci\00F3n din\00E1mica.</dd>'),
'    <dt>Elementos protegidos en llamadas AJAX</dt>',
unistr('    <dd>No se debe hacer referencia a los elementos que tienen la protecci\00F3n de estado de la sesi\00F3n activada en "Elementos de p\00E1gina que ejecutar" de los elementos, los informes interactivos o las acciones din\00E1micas. No se pueden ejecutar sin un valo')
||unistr('r de total de control v\00E1lido.</dd>'),
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289320295084864300.4001)
,p_name=>'P8101_PERFORMANCE_CHECKS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(1289320081911864300.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Rendimiento:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''PERFORMANCE''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('    <dt>Funci\00F3n V utilizada en sentencias SQL</dt>'),
'    <dd>El uso de V/NV/DV en sentencias SQL puede dar como resultado problemas de rendimiento. Utilice en su lugar la sintaxis de variable de enlace.</dd>',
'    <dt>La interfaz de usuario incluye JavaScript de compatibilidad</dt>',
unistr('    <dd>La interfaz de usuario incluye JavaScript de compatibilidad, JavaScript de APEX que ya no se soporta/en desuso o migraci\00F3n de jQuery</dd>'),
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289320450173864301.4001)
,p_name=>'P8101_USABILITY_CHECKS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(1289320081911864300.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Uso:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''USABILITY''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('    <dt>La autorizaci\00F3n de p\00E1gina de destino est\00E1 definida tambi\00E9n para el componente actual</dt>'),
unistr('    <dd>Si una p\00E1gina de destino tiene un esquema de autorizaci\00F3n asociado, \00BFtiene el componente procesado el mismo esquema de autorizaci\00F3n? Si no, el usuario podr\00E1 visualizar un separador, pero obtendr\00E1 un error al hacer clic en \00E9l.</dd>'),
'    <dt>Elemento o columna de validaciones asociado</dt>',
unistr('    <dd>Comprueba si el elemento o la columna de pantalla tabular de la expresi\00F3n de validaci\00F3n coincide con el elemento/columna asociados. Tambi\00E9n comprueba si se selecciona un elemento/columna asociados cuando es necesario, como por ejemplo cuando ')
||unistr('las validaciones se van a mostrar "En l\00EDnea con campo".</dd>'),
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289320632943864301.4001)
,p_name=>'P8101_QA_CHECKS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(1289320081911864300.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Control de Calidad:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''QA''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('    <dt>Identificador de aplicaci\00F3n de c\00F3digo fuente</dt>'),
unistr('    <dd>\00BFSe ha codificado en enlaces el identificador de aplicaci\00F3n actual?</dd>'),
'    <dt>El informe tiene un orden por defecto</dt>',
unistr('    <dd>Es la "Secuencia de ordenaci\00F3n" definida al menos para una columna del informe o la sentencia SQL que contiene la cl\00E1usula ORDER BY.</dd>'),
unistr('    <dt>Elemento de p\00E1gina con texto de ayuda</dt>'),
unistr('    <dd>\00BFTodos los elementos de p\00E1gina con una plantilla de etiqueta de tipo "Etiqueta opcional con ayuda" o "Etiqueta necesaria con ayuda" tienen texto de ayuda?</dd>'),
'    <dt>Valores de atributo en desuso</dt>',
unistr('    <dd>Indica atributos de p\00E1gina y de componentes de p\00E1gina cuyos valores definidos est\00E1n en desuso.</dd>'),
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1289324354932903543.4001)
,p_name=>'P8101_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1289324123074903542.4001)
,p_prompt=>unistr('P\00E1gina(s)')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>32767
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Introduzca el n\00FAmero o n\00FAmeros de p\00E1gina a los que se limitar\00E1 la comprobaci\00F3n. Para comprobar todas las p\00E1ginas, no introduzca ning\00FAn valor.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(1703136529372369148.4001)
,p_name=>'P8101_ACCESSIBILITY_CHECKS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(1289320081911864300.4001)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Accesibilidad:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''ACCESSIBILITY''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_api.id(561549638722251517.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>Accesibilidad de estilo de tema probada</dt>',
unistr('    <dd>\00BFSu aplicaci\00F3n usa un estilo de tema cuya accesibilidad se haya probado? Los estilos de tema cuya accesibilidad no se haya probado pueden causar m\00E1s problemas, como contrastes de color con intensidad insuficiente.</dd>'),
unistr('    <dt>La p\00E1gina tiene t\00EDtulo</dt>'),
unistr('    <dd>\00BFLa p\00E1gina tiene t\00EDtulo? En aras de la accesibilidad, es importante asignar t\00EDtulos de p\00E1gina relevantes para que los usuarios se hagan una idea del contenido y el objetivo de la p\00E1gina en la que se encuentren. Nota: Esta comprobaci\00F3n no incl')
||unistr('uye las p\00E1ginas globales ni las que carecen de regi\00F3n.</dd>'),
unistr('    <dt>La regi\00F3n tiene fila de cabecera</dt>'),
unistr('    <dd>Las regiones que admiten cabeceras de fila deben disponer de una columna con el atributo "Usar como cabecera de fila" definido en S\00ED.</dd>'),
unistr('    <dt>El tipo de gr\00E1fico soporta la accesibilidad</dt>'),
unistr('    <dd>\00BFUtiliza tipos de gr\00E1ficos antiguos que soportan un nivel de accesibilidad limitado? Deber\00EDa cambiarlos por nuestros nuevos gr\00E1ficos basados en Oracle JET.</dd>'),
unistr('    <dt>El elemento de p\00E1gina tiene etiqueta</dt>'),
unistr('    <dd>\00BFSe ha definido una etiqueta para el elemento? Por ejemplo, definir el texto ''Marcador de posici\00F3n de valor'' no es suficiente para mejorar la accesibilidad de un elemento al asignarle la etiqueta.</dd>'),
unistr('    <dt>El elemento de p\00E1gina no causa ning\00FAn cambio de contexto inesperado</dt>'),
unistr('    <dd>Ciertos valores de elementos de p\00E1gina pueden provocar cambios inesperados de contexto para el usuario, por ejemplo, listas de selecci\00F3n que env\00EDen la p\00E1gina despu\00E9s de seleccionar un valor. A menos que el usuario sepa de antemano que esto va')
||' a ocurrir, esto presenta un problema de accesibilidad.</dd>',
'    <dt>El elemento Mostrar imagen tiene texto alternativo de imagen definido</dt>',
unistr('    <dd>Los elementos de la p\00E1gina Mostrar imagen deben indicar texto, o una columna (en funci\00F3n de la configuraci\00F3n de Basado en), que se utilizar\00E1 como texto alternativo de la imagen. Es muy importante para mejorar la accesibilidad, puesto que, de ')
||unistr('no ser as\00ED, a algunos usuarios podr\00EDa resultarles imposible percibir el contenido de la imagen.</dd>'),
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1289332684453915182.4001)
,p_computation_sequence=>30
,p_computation_item=>'P8101_ALL_CHECKS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(32767);',
'    procedure add (',
'        p_checks in varchar2 )',
'    is',
'    begin',
'        if p_checks is not null then',
'            l_result := l_result||',
'                        case when l_result is not null then '':'' end||',
'                        p_checks;',
'        end if;',
'    end add;',
'begin',
'    add(:P8101_ERROR_CHECKS);',
'    add(:P8101_SECURITY_CHECKS);',
'    add(:P8101_WARNING_CHECKS);',
'    add(:P8101_PERFORMANCE_CHECKS);',
'    add(:P8101_QA_CHECKS);',
'    add(:P8101_USABILITY_CHECKS);',
'    add(:P8101_ACCESSIBILITY_CHECKS);',
'    return l_result;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(1289333036545916435.4001)
,p_computation_sequence=>30
,p_computation_item=>'P8101_ALL_CHECKS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    l_result := wwv_flow_preferences.get_preference(''ADVISOR_CHECKS'');',
'',
'    if l_result is null then',
'        for l_check in (',
'            select code',
'              from wwv_flow_advisor_checks',
'             where is_default = ''Y'' )',
'        loop',
'            l_result := case when l_result is not null then l_result||'':'' end||',
'                        l_check.code;',
'        end loop;',
'    end if;',
'    --',
'    return l_result;',
'end;'))
,p_compute_when=>'P8101_ALL_CHECKS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1253548558373954910.4001)
,p_name=>'Perform Check'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1289323892563901246.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253548649011954911.4001)
,p_event_id=>wwv_flow_api.id(1253548558373954910.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PERFORM_CHECK'
,p_attribute_02=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1253548729095954912.4001)
,p_name=>'Select All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1289318688677864288.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253548824088954913.4001)
,p_event_id=>wwv_flow_api.id(1253548729095954912.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(":checkbox").prop("checked", true);',
''))
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1253548997962954914.4001)
,p_name=>'Select None'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_api.id(1289318896947864292.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253549050315954915.4001)
,p_event_id=>wwv_flow_api.id(1253548997962954914.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(":checkbox").prop("checked", false);'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1253549100966954916.4001)
,p_name=>'Collapse/Expand "Check Pages"'
,p_event_sequence=>40
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v( "P8101_HAS_RESULT" ) === ""'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253549377829954918.4001)
,p_event_id=>wwv_flow_api.id(1253549100966954916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// If no result is displayed we always want to see the "Check Page(s)" region!',
'this.affectedElements.collapsible( "expand" );'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253549208328954917.4001)
,p_event_id=>wwv_flow_api.id(1253549100966954916.4001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1289323958309903542.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// As soon as we have performed a check, we do want to hide the check details',
'this.affectedElements.collapsible( "collapse" );'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253549496513954919.4001)
,p_event_id=>wwv_flow_api.id(1253549100966954916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1253548469643954909.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Avoid clutter',
'this.affectedElements.collapsible( "collapse" );'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1253549522170954920.4001)
,p_event_id=>wwv_flow_api.id(1253549100966954916.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(1289318474075864284.4001)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Avoid clutter',
'this.affectedElements.collapsible( "collapse" );'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1289333372117920049.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Set preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'ADVISOR_CHECKS'
,p_attribute_03=>'P8101_ALL_CHECKS'
,p_process_when_button_id=>wwv_flow_api.id(1289323892563901246.4001)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1289335637278921844.4001)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Perform checks'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_pages        varchar2(32767);',
'    l_temp_list    wwv_flow_global.vc_arr2;',
'    l_page_id_list wwv_flow_global.n_arr;',
'    l_count        number;',
'begin',
'    if :P8101_PAGE_ID is not null then',
'        -- set all whitespace to a comma',
'        l_pages := replace(replace(replace(replace(replace(:P8101_PAGE_ID,'' '','',''),chr(10),'' ''),chr(13),null),'':'','',''),'';'','','');',
'        -- create table of pages',
'        l_temp_list := wwv_flow_utilities.string_to_table2(:P8101_PAGE_ID, '','');',
'        for i in 1 .. l_temp_list.count',
'        loop',
'            if l_temp_list(i) is not null and wwv_flow_utilities.is_numeric(l_temp_list(i)) then',
'                l_page_id_list(l_page_id_list.count+1) := l_temp_list(i);',
'            end if;',
'        end loop;',
'    end if;',
'    ',
'    -- let''s perform the check',
'    wwv_flow_advisor_dev.check_application (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id_list   => l_page_id_list,',
'        p_check_list     => wwv_flow_utilities.string_to_table(:P8101_ALL_CHECKS) );',
'',
'    -- verify result',
'    select count(*)',
'      into l_count',
'      from wwv_flow_advisor_result_dev;',
'    ',
'    :P8101_HAS_RESULT := case when l_count > 0 then ''Y'' else ''N'' end;',
'',
'    -- re-initialize filter checkboxes',
'    :P8101_FILTER := null;',
'    for l_filter in ( select category_id as val',
'                        from wwv_flow_advisor_result_dev',
'                       where flow_id = :FB_FLOW_ID',
'                       union',
'                      select check_id as val',
'                        from wwv_flow_advisor_result_dev',
'                       where flow_id = :FB_FLOW_ID )',
'    loop',
'        :P8101_FILTER := :P8101_FILTER ||',
'                         case when :P8101_FILTER is not null then '':'' end ||',
'                         l_filter.val;',
'    end loop;',
'',
'exception when others then',
'    wwv_flow_error.raise_internal_error (',
'        p_error_message => sqlerrm );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(1289323892563901246.4001)
);
end;
/
prompt --application/pages/page_09000
begin
wwv_flow_api.create_page(
 p_id=>9000.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>'Gestionar Separadores'
,p_step_title=>'Gestionar Separadores'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">             ',
'.tabmgrPageCur{                     ',
'    font-size: 8pt;                 ',
'    height:70px;                    ',
'    width:60px;                     ',
'    text-align:center;              ',
'    border:1px #9cadcc solid;       ',
'    color:#9cadcc;    ',
'    text-overflow:elipsis;',
'    overflow:hidden;',
'    white-space:normal;',
'}                                   ',
'                                    ',
'.tabmgrPageAlsoCur{                 ',
'    font-size: 8pt;                 ',
'    height:70px;                    ',
'    width:60px;                     ',
'    text-align:center;              ',
'    border:1px #cccccc solid;       ',
'    color:#9cadcc;                  ',
'    float:left;                     ',
'    margin-right:10px;              ',
'    text-overflow:elipsis;',
'    overflow:hidden;',
'    white-space:normal;',
'                                    ',
'}                                   ',
'                                    ',
'.tabmgrAddPage{                     ',
'    font-size: 8pt;                 ',
'    padding:3px;                    ',
'    height:70px;                    ',
'    width:60px;                     ',
'    text-align:center;              ',
'    border:1px #999999 dashed;      ',
'    background-color:#eeeeee;       ',
'}                                   ',
'                                    ',
'.tabmgrStdOn{                       ',
'    font-size: 8pt;                 ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    padding-left:5px;               ',
'    padding-right:5px;              ',
'    text-align:center;              ',
'    font-weight:bold;               ',
'    background-color:#9cadcc;       ',
'    color:#ffffff;                  ',
'    font-size:8pt;                  ',
'}                                   ',
'                                    ',
'.tabmgrStdOff{                      ',
'    font-size: 8pt;                 ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    padding-left:5px;               ',
'    padding-right:5px;              ',
'    text-align:center;              ',
'    background-color:#9cadcc;       ',
'    color:#222222;                  ',
'}                                   ',
'',
'.tabmgrStdOff a:link,.tabmgrStdOff a:visited{color:#222222;}',
'                                 ',
'.tabmgrStdAdd{                      ',
'    font-size: 8pt;                 ',
'    height:20px;                    ',
'    width: 50px;                    ',
'    background-color:#eeeeee;       ',
'    border:1px #999999 dashed;      ',
'    padding: 3px;                   ',
'    text-align:center;              ',
'}                                   ',
'                                    ',
'.tabmgrPntOn{                       ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:65px;                     ',
'    text-align:center;              ',
'    font-weight:bold;               ',
'    background-color:#9cadcc;       ',
'    color:#ffffff;                  ',
'}                                   ',
'                                    ',
'.tabmgrPntOff{                      ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:50px;                     ',
'    text-align:center;              ',
'    background-color:#9cadcc;       ',
'    color:#ffffff;                  ',
'    border-left:1px #9cadcc solid;  ',
'    border-top:1px #9cadcc solid;   ',
'    border-right:1px #9cadcc solid; ',
'    background-color:#cccccc;       ',
'    color:#000000                   ',
'}                                   ',
'                                    ',
'.tabmgrPntAdd{                      ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:30px;                     ',
'    text-align:center;              ',
'    color:#ffffff;                  ',
'    border-left:1px #999999 dashed; ',
'    border-top:1px #999999 dashed;  ',
'    border-right:1px #999999 dashed;',
'    background-color:#eeeeee;}      ',
'                                    ',
'.tabmgrPntNoneOn{                   ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:80px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    font-weight:bold;               ',
'    color:#ffffff;                  ',
'    border-left: 2px #cccccc dashed;',
'    border-top:  2px #cccccc dashed;',
'    border-right:2px #cccccc dashed;',
'    background-color:#9cadcc;       ',
'}                                   ',
'                                    ',
'.tabmgrPntNoneOff{                  ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:70px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    color:#ffffff;                  ',
'    border-left: 2px #9cadcc dashed;',
'    border-top:  2px #9cadcc dashed;',
'    border-right:2px #9cadcc dashed;',
'    background-color:#cccccc;       ',
'}                                   ',
'                                    ',
'.tabmgrPntPseudoOn{                 ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:50px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    font-weight:bold;               ',
'    color:#ffffff;                  ',
'    border-left: 2px #cccccc dashed;',
'    border-top:  2px #cccccc dashed;',
'    border-right:2px #cccccc dashed;',
'    background-color:#9cadcc;       ',
'}                                   ',
'                                    ',
'.tabmgrPntPseudoOff{                ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:50px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    color:#ffffff;                  ',
'    border-left: 2px #9cadcc dashed;',
'    border-top:  2px #9cadcc dashed;',
'    border-right:2px #9cadcc dashed;',
'    background-color:#cccccc;       ',
'}                                                                    ',
'',
'#tabInfo td{padding-right:5px;}',
'                                    ',
'</style>                            '))
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28723731200606674.4001)
,p_plug_name=>'Tareas de Separador Principal'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(165884427300110704.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from WWV_FLOW_TOPLEVEL_TABS where flow_id = :fb_flow_id'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(28903824226344284.4001)
,p_plug_name=>'Separadores'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra una representaci\00F3n gr\00E1fica de los separadores definidos en la aplicaci\00F3n.</p>'),
unistr('<p>Utilice separadores est\00E1ndar para enlazar usuarios a una p\00E1gina concreta. Un separador principal funciona como contenedor de un grupo de separadores est\00E1ndar. Los separadores principales proporcionan a los usuarios otro nivel de navegaci\00F3n as\00ED com')
||unistr('o un sistema de localizaci\00F3n en la aplicaci\00F3n.</p>'),
unistr('<p>Haga clic en <strong>Agregar</strong> en la fila superior para agregar separadores principales. Haga clic en <strong>Agregar</strong> en la fila inferior para agregar separadores est\00E1ndar.</p> '),
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(35063524529617959.4001)
,p_plug_name=>unistr('Tareas de Separador Est\00E1ndar')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(35060712015585948.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(40991013498419203.4001)
,p_plug_name=>'Tab List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.tabs(',
'    p_flow          => :fb_flow_id,',
'    p_session       => :SESSION,',
'    p_img_prefix    => ''#IMAGE_PREFIX#'',',
'    p_current_stab  => :F4000_CUR_STD_TAB,',
'    p_current_page  => :F4000_P9000_PAGE,',
'    p_current_ptab  => :F4000_P9000_CUR_PTAB',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_header=>unistr('Haga clic en un nombre de separador para actualizarlo. Cuando haya seleccionado un separador, podr\00E1 cambiar sus propiedades.')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(46196824027657446.4001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(5297709875.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(168712225287236339.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(50286210849589701.4001)
,p_plug_name=>'advertencia'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_flow number;',
'   l_page number;',
'   j int; x varchar2(4000);',
'   l_pg_found boolean := false;',
'begin',
'for c1 in (select TAB_TARGET from wwv_flow_toplevel_tabs',
'            where id = :F4000_P9000_CUR_PTAB',
'              and security_group_id = :flow_security_group_id ) loop',
'   --sys.htp.p(c1.tab_target);',
'   if instr(c1.tab_target,'':'') > 0 and ',
'      upper(substr(c1.tab_target,1,4))=''F?P='' then',
'      x := substr(c1.tab_target,5);',
'      j := instr(x,'':''); ',
'      l_flow := substr(x,1,j-1); ',
'      x := substr(x,j+1); ',
'      j := instr(x,'':'');',
'      l_page := substr(x,1,j-1); ',
'   end if;',
'   --sys.htp.p(l_flow);',
'   --sys.htp.p(l_page);',
'   for c2 in (select 1 from wwv_flow_steps ',
'               where flow_id = l_flow',
'                 and security_group_id = :flow_security_group_id',
'                 and id = l_page ) loop',
'    l_pg_found := true;',
'   end loop;',
'   if not l_pg_found then',
'      sys.htp.p(''<span class="instructiontext">''||',
'          wwv_flow_lang.system_message(p_name=>''TAB_MANAGER.WARNING'',p0=>wwv_flow_escape.html(c1.tab_target)));',
'   end if;',
'end loop;',
'exception when others then',
'   null;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_row_template=>wwv_flow_api.id(79387910442923002.4001)
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'0'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185885705983544002.4001)
,p_plug_name=>'Tareas de Separador Principal'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>No existe ning\00FAn separador principal.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>'select 1 from WWV_FLOW_TOPLEVEL_TABS where flow_id = :fb_flow_id'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(41486418275203439.4001)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(41048805076292043.4001)
,p_name=>'F4000_P9000_CUR_PTAB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(40991013498419203.4001)
,p_prompt=>'F4000_P9000_CUR_PTAB'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(49331618592021132.4001)
,p_name=>'F4000_P9000_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(40991013498419203.4001)
,p_prompt=>'F4000_P9000_PAGE'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(36278805375348469.4001)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'9000'
,p_computation_error_message=>'No se ha podido calcular el valor del elemento.'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(49500503766225514.4001)
,p_validation_name=>'F4000_CUR_STD_TAB not null'
,p_validation_sequence=>10
,p_validation=>'F4000_CUR_STD_TAB'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar el separador est\00E1ndar.')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(1143101075566434579.4001)
,p_name=>'refresh Tab List'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(40991013498419203.4001)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(1143101340209434585.4001)
,p_event_id=>wwv_flow_api.id(1143101075566434579.4001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:9000:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ];',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(50384724324720175.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR Page 77'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'77'
);
end;
/
prompt --application/pages/page_09005
begin
wwv_flow_api.create_page(
 p_id=>9005.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Gestor de Separadores: Agregar P\00E1ginas')
,p_step_title=>unistr('Agregar Asociaci\00F3n de Separador')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213240607818867991)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42885205674387110.4001)
,p_plug_name=>unistr('Asociaci\00F3n de Separador')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Seleccione la p\00E1gina que se va a mostrar al hacer clic en el separador. Tambi\00E9n puede introducir otras p\00E1ginas que mostrar\00E1n este separador como actual.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(42915318577426701.4001)
,p_plug_name=>unistr('Agregar Asociaci\00F3n de Separador')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>140
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(44157316349655128.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(44170624445666940.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Aplicar Cambios'
,p_button_position=>'CREATE'
,p_button_cattributes=>' tabindex="2"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(44157728149655143.4001)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(44157316349655128.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(44171029730666942.4001)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_api.id(44170624445666940.4001)
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42888532619389835.4001)
,p_name=>'F4000_P9005_TAB'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_prompt=>'Separador:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Nombre del separador actual que va a editar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42891525287393167.4001)
,p_name=>'F4000_P9005_TAB_SET'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_prompt=>unistr('Separador Est\00E1ndar - Juego de Separadores:')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Juego de separadores al que pertenece el separador que est\00E1 editando actualmente. Los juegos de separadores son recopilaciones de separadores relacionados.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42895216014397540.4001)
,p_name=>'F4000_P9005_TAB_ID'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(42992521725531592.4001)
,p_name=>'F4000_P9005_CUR_PAGE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_prompt=>unistr('P\00E1gina Actual')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ID||''-''||NAME D,ID R',
'',
'FROM WWV_FLOW_STEPS',
'',
'WHERE FLOW_ID = :FB_FLOW_ID'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_api.id(452656722938220607.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifique la p\00E1gina para la que este separador es actual. Cuando un usuario hace clic en el separador, ir\00E1 a esta p\00E1gina.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(43699306320918662.4001)
,p_name=>'F4000_P9005_ALSO_CUR'
,p_item_sequence=>6
,p_item_plug_id=>wwv_flow_api.id(42915318577426701.4001)
,p_prompt=>unistr('Tambi\00E9n Actual para P\00E1ginas (lista de p\00E1ginas delimitadas por comas)')
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TAB_ALSO_CURRENT_FOR_PAGES',
'',
'  from wwv_flow_tabs',
'',
' where id = :F4000_P9005_TAB_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>6
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indique los n\00FAmeros de p\00E1gina que har\00E1n (adem\00E1s del atributo de p\00E1gina actual) que este separador sea "actual". El separador actual es el separador seleccionado. Por ejemplo:'),
'',
'<pre>',
'',
'3,4,8',
'',
'</pre>',
'',
unistr('La lista anterior har\00EDa que las p\00E1ginas 3, 4 y 8 fueran tambi\00E9n actuales para el separador proporcionado.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186016712712056941.4001)
,p_validation_name=>'Current page not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P9005_CUR_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Se debe especificar la p\00E1gina actual')
,p_when_button_pressed=>wwv_flow_api.id(44170624445666940.4001)
,p_associated_item=>wwv_flow_api.id(42992521725531592.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186019305224064245.4001)
,p_validation_name=>'Current page must be a number'
,p_validation_sequence=>20
,p_validation=>'F4000_P9005_CUR_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>unistr('La p\00E1gina actual debe ser num\00E9rica')
,p_when_button_pressed=>wwv_flow_api.id(44170624445666940.4001)
,p_associated_item=>wwv_flow_api.id(42992521725531592.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(248922131113274331.4001)
,p_validation_name=>'ensure proper also current for page numbers'
,p_validation_sequence=>30
,p_validation=>'return true;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Valor no v\00E1lido. Utilice n\00FAmeros de p\00E1ginas correctamente delimitadas')
,p_associated_item=>wwv_flow_api.id(.4001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(42938228029467909.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'POPULATE TAB INFO'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TAB_TEXT,TAB_SET,TAB_STEP',
'into :F4000_P9005_TAB,:F4000_P9005_TAB_SET,:F4000_P9005_CUR_PAGE',
'from wwv_flow_tabs',
'where id = :F4000_P9005_TAB_ID'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(44147020176641548.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UPDATE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.update_tab_pages(',
'        p_tab_id        => :F4000_P9005_TAB_ID,',
'        p_tab_set       => :F4000_P9005_TAB_SET,',
'        p_flow          => :fb_flow_id,',
'        p_tab_page      => :F4000_P9005_CUR_PAGE,',
'        p_also_cur_for  => :F4000_P9005_ALSO_CUR);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(44170624445666940.4001)
);
end;
/
prompt --application/pages/page_09006
begin
wwv_flow_api.create_page(
 p_id=>9006.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Configurar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_step_title=>unistr('Configurar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109644632478757939.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109642120442735590.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110815404272935626.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n del Estado de Sesi\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114201125450070219.4001)
,p_plug_name=>unistr('Atributos de P\00E1gina y de Elemento')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Seleccione los atributos de seguridad para p\00E1ginas y elementos. Puede aceptar los valores por defecto mostrados aqu\00ED o realizar nuevas selecciones. Tenga en cuenta que el valor seleccionado para una categor\00EDa de atributos se aplicar\00E1 a todas las p')
||unistr('\00E1ginas y elementos de la aplicaci\00F3n.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208201821610056060.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747150046530138181.4001)
,p_plug_name=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109624632275452566.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208201821610056060.4001)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109648706122797609.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208201821610056060.4001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(651364628215578370.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Siguiente'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109628129074470573.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208201821610056060.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(110713302730648390.4001)
,p_branch_action=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110817930758945836.4001)
,p_name=>'P9006_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110815404272935626.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110818806994948415.4001)
,p_name=>'P9006_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110815404272935626.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110852702080117376.4001)
,p_name=>'P9006_PAGE_LEVEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114201125450070219.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'C'
,p_prompt=>unistr('Protecci\00F3n de Acceso a P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_api.id(17255429593772638.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No Actualizar P\00E1ginas -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la protecci\00F3n de acceso a p\00E1gina:'),
'<ul>',
unistr('<li><strong>No Restringido</strong>: La p\00E1gina se puede solicitar mediante una direcci\00F3n URL con o sin argumentos de estado de la sesi\00F3n (Solicitud, Borrar '),
'',
unistr('Cach\00E9, Nombre/Valor).</li>'),
unistr('<li><strong>Los Argumentos Deben Tener Total de Control</strong>: Si los argumentos Solicitud, Borrar Cach\00E9 o Nombre/Valor aparecen en la direcci\00F3n URL, tambi\00E9n '),
'',
unistr('se debe proporcionar el total de control. El tipo de total de control debe ser compatible con el atributo Protecci\00F3n de Estado de la Sesi\00F3n m\00E1s exigente de todos los '),
'',
'elementos que se han transferido como argumentos.</li>',
unistr('<li><strong>No se Permiten Argumentos</strong>: Se puede utilizar una direcci\00F3n URL para solicitar la p\00E1gina pero no se permiten los argumentos Solicitud, Borrar Cach\00E9 o '),
'',
'Nombre/Valor.</li>',
unistr('<li><strong>No Hay Acceso a URL</strong>: No se puede acceder a la p\00E1gina mediante una direcci\00F3n URL; sin embargo, la p\00E1gina puede ser el destino de un tipo de bifurcaci\00F3n '),
'',
unistr('Bifurcar a P\00E1gina, que no efect\00FAa un redireccionamiento a la direcci\00F3n URL.</li> '),
'</ul>      '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110853923551123561.4001)
,p_name=>'P9006_APP_ITEM_LEVEL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(114201125450070219.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'S'
,p_prompt=>unistr('Protecci\00F3n de Elemento de Aplicaci\00F3n')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_api.id(17287012676783081.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No Actualizar Elementos de Aplicaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione Protecci\00F3n de Estado de la Sesi\00F3n:'),
'<ul>',
unistr('<li><strong>No Restringido</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL o en una pantalla. No se necesita total de control en la direcci\00F3n URL.</li><br />       '),
unistr('<li><strong>Restringido: No se puede definir desde el explorador</strong>. El elemento no se puede modificar a trav\00E9s de la direcci\00F3n URL o POSTDATA. Utilice esta opci\00F3n cuando desee restringir la manera en que se puede definir el valor del elemento ')
||unistr('para procesos internos, c\00E1lculos, etc. Siempre se tiene en cuenta este atributo, aplicable s\00F3lo a elementos que no se pueden utilizar como elementos de entrada de datos, aunque la protecci\00F3n de estado de la sesi\00F3n est\00E9 desactivada. Este atributo se p')
||unistr('uede utilizar para elementos de aplicaci\00F3n o para elementos de p\00E1gina con cualquiera de estos tipos "Mostrar como":'),
'<br />',
'<ul>',
unistr('<li>S\00F3lo Visualizaci\00F3n (no guarda el estado)</li>               '),
'<li>Campo de Texto (Desactivado, no guarda el estado)</li>                          ',
unistr('<li>Parar e Iniciar Tabla HTML (Muestra s\00F3lo etiquetas)</li>'),
'</li></ul>',
unistr('<li><strong>Total de Control Necesario: Nivel de Aplicaci\00F3n</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico del espacio de trabajo y ')
||unistr('la aplicaci\00F3n. Un total de control de nivel de usuario o un total de control de nivel de sesi\00F3n tambi\00E9n ser\00E1n suficientes (consulte los puntos siguientes). Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones UR')
||unistr('L con totales de control generados por cualquier usuario que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.</li>'),
unistr('<li><strong>Total de Control Necesario: Nivel de Usuario</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico del espacio de trabajo, la a')
||unistr('plicaci\00F3n y el usuario. Un total de control de nivel de sesi\00F3n tambi\00E9n es suficiente (consulte el punto siguiente). Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados por e')
||unistr('l mismo usuario designado que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.</li>      '),
unistr('<li><strong>Total de Control Necesario: Nivel de Sesi\00F3n</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico de la sesi\00F3n actual. Utilice ')
||unistr('esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados en la sesi\00F3n actual.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110854500826126459.4001)
,p_name=>'P9006_DISPLAY_ONLY_ITEM_LEVEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(114201125450070219.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'S'
,p_prompt=>unistr('Protecci\00F3n de Elemento de S\00F3lo Visualizaci\00F3n de P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_api.id(17287012676783081.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- No Actualizar Elementos de S\00F3lo Visualizaci\00F3n -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione Protecci\00F3n de Estado de la Sesi\00F3n:'),
'<ul>',
unistr('<li><strong>No Restringido</strong>: El elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL o en una pantalla. No se necesita total de control en la direcci\00F3n URL.</li>'),
unistr('<li><strong>Restringido: No se puede definir desde el explorador</strong>. El elemento no se puede modificar a trav\00E9s de una direcci\00F3n URL o POSTDATA. Utilice este atributo cuando desee restringir la manera en que se puede definir el valor del elemen')
||unistr('to para procesos internos, c\00E1lculos, etc. Siempre se tiene en cuenta este atributo, incluso si la protecci\00F3n de estado de la sesi\00F3n est\00E1 desactivada. Este atributo se puede utilizar con cualquiera de estos tipos "Mostrar como": '),
'<br />',
'<ul>',
unistr('<li>S\00F3lo Visualizaci\00F3n (no guarda el estado)</li>'),
'<li>Mostrar como Texto (no guarda el estado)</li>                               ',
'<li>Mostrar como Texto (basado en la lista de valores, no guarda el estado)</li>                 ',
'<li>Mostrar como Texto (basado en PLSQL, no guarda el estado)</li>               ',
'<li>Campo de Texto (Desactivado, no guarda el estado)</li>                          ',
unistr('<li>Parar e Iniciar Tabla HTML (Muestra s\00F3lo etiquetas)</li>'),
'</ul>',
unistr('<li><strong>Total de Control Necesario: Nivel de Aplicaci\00F3n</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico d')
||unistr('el espacio de trabajo y la aplicaci\00F3n. Un total de control de nivel de usuario o un total de control de nivel de sesi\00F3n tambi\00E9n ser\00E1n suficientes (consulte los puntos siguientes). Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo')
||unistr(' mediante direcciones URL con totales de control generados por cualquier usuario que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.</li>'),
unistr('<li><strong>Total de Control Necesario: Nivel de Usuario</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico del ')
||unistr('espacio de trabajo, la aplicaci\00F3n y el usuario. Un total de control de nivel de sesi\00F3n tambi\00E9n es suficiente (consulte el punto siguiente). Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de')
||unistr(' control generados por el mismo usuario designado que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.</li>         '),
unistr('<li><strong>Total de Control Necesario: Nivel de Sesi\00F3n</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico de la')
||unistr(' sesi\00F3n actual. Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados en la sesi\00F3n actual.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110856609615138431.4001)
,p_name=>'P9006_DATA_ENTRY_ITEM_LEVEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(114201125450070219.4001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'S'
,p_prompt=>unistr('Protecci\00F3n de Elemento de Entrada de Datos de P\00E1gina')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL NO RESTRICTED'
,p_lov=>'.'||wwv_flow_api.id(109314413723246310.4001)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Actualizar Elementos de Entrada de Datos -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la protecci\00F3n de estado de la sesi\00F3n:'),
'<ul>',
unistr('<li><strong>No Restringido</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL o en una pantalla. No se necesita total de control en la direcci\00F3n URL.</li>               ')
||' ',
unistr('<li><strong>Total de Control Necesario: Nivel de Aplicaci\00F3n</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico d')
||unistr('el espacio de trabajo y la aplicaci\00F3n. Un total de control de nivel de usuario o un total de control de nivel de sesi\00F3n tambi\00E9n ser\00E1n suficientes (consulte las secciones siguientes). Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s')
||unistr('\00F3lo mediante direcciones URL con totales de control generados por cualquier usuario que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.</li>'),
unistr('<li><strong>Total de Control Necesario: Nivel de Usuario</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico del ')
||unistr('espacio de trabajo, la aplicaci\00F3n y el usuario. Un total de control de nivel de sesi\00F3n tambi\00E9n es suficiente (consulte la secci\00F3n siguiente). Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales ')
||unistr('de control generados por el mismo usuario designado que ejecute la misma aplicaci\00F3n en el espacio de trabajo actual pero en otra sesi\00F3n.</li>           '),
unistr('<li><strong>Total de Control Necesario: Nivel de Sesi\00F3n</strong>: El estado de la sesi\00F3n del elemento se puede definir transfiriendo el nombre o el valor del elemento en una direcci\00F3n URL si tambi\00E9n se proporciona un total de control espec\00EDfico de la')
||unistr(' sesi\00F3n actual. Utilice esta opci\00F3n cuando desee que el elemento se pueda definir s\00F3lo mediante direcciones URL con totales de control generados en la sesi\00F3n actual.</li>                                                                   </ul>')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
prompt --application/pages/page_09007
begin
wwv_flow_api.create_page(
 p_id=>9007.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Activar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_step_title=>unistr('Activar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(262753407599695606)
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114268211484422739.4001)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109642120442735590.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114268403942422739.4001)
,p_plug_name=>'Botones'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114311809575869982.4001)
,p_plug_name=>'Definir Atributos'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(114371329791585494.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(137847231212506770.4001)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ALL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Confirme su solicitud de actualizar los atributos de p\00E1gina y elemento y de activar la protecci\00F3n de estado de la sesi\00F3n para la aplicaci\00F3n. La siguiente lista resume las actualizaciones que se van a realizar.</p>')
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114321320975996219.4001)
,p_name=>unistr('P\00E1ginas a Actualizar')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 nvl(PROTECTION_LEVEL,''N'') Protection,',
'         count(*) c',
' from	 WWV_FLOW_STEPS p',
'where flow_id = :fb_flow_id',
'and nvl(PROTECTION_LEVEL,''N'') <> :P9006_PAGE_LEVEL',
'and replace(:P9006_PAGE_LEVEL,''%''||''null%'',null) is not null',
'and security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL'))
,p_display_when_condition=>'replace(:P9006_PAGE_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se actualizar\00E1 ninguna p\00E1gina.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114321529882996221.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Protecci\00F3n de Acceso a P\00E1gina')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17255429593772638)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114321628588996221.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Recuento de P\00E1ginas')
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114323008424011520.4001)
,p_name=>unistr('Elementos de Aplicaci\00F3n a Actualizar')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 nvl(PROTECTION_LEVEL,''N'') Protection, ',
'         count(*) c',
' from	 WWV_FLOW_ITEMS p',
'where flow_id = :fb_flow_id',
'and nvl(PROTECTION_LEVEL,''N'') <> :P9006_APP_ITEM_LEVEL',
'and replace(:P9006_APP_ITEM_LEVEL,''%''||''null%'',null) is not null',
'and name <> ''FSP_AFTER_LOGIN_URL''',
'group by PROTECTION_LEVEL'))
,p_display_when_condition=>'replace(:P9006_APP_ITEM_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se actualizar\00E1 ning\00FAn elemento de aplicaci\00F3n.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114323229654011521.4001)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114323317757011521.4001)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Recuento de P\00E1ginas')
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114323818121014305.4001)
,p_name=>'Elementos de Entrada de Datos a Actualizar'
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 flow_step_id "Page",',
'         nvl(PROTECTION_LEVEL,''N'') Protection,         ',
'         count(*) c',
' from	 WWV_FLOW_STEP_ITEMS p',
' where flow_id = :fb_flow_id',
'   and (   display_as not in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'       and not (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'               and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'               )',
'       )',
' and nvl(PROTECTION_LEVEL,''N'') <> :P9006_DATA_ENTRY_ITEM_LEVEL',
' and replace(:P9006_DATA_ENTRY_ITEM_LEVEL,''%''||''null%'',null) is not null',
' group by flow_step_id, nvl(PROTECTION_LEVEL,''N'')'))
,p_display_when_condition=>'replace(:P9006_DATA_ENTRY_ITEM_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se actualizar\00E1 ning\00FAn elemento de entrada de datos.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114324316292014307.4001)
,p_query_column_id=>1
,p_column_alias=>'Page'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114324023616014307.4001)
,p_query_column_id=>2
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114324126697014307.4001)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Recuento de Elementos'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(114326619075033547.4001)
,p_name=>unistr('Elementos de S\00F3lo Visualizaci\00F3n a Actualizar')
,p_template=>wwv_flow_api.id(399849897040726767.4001)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 flow_step_id "Page",',
'         nvl(PROTECTION_LEVEL,''N'') Protection, ',
'         count(*) c',
' from	 WWV_FLOW_STEP_ITEMS p',
' where flow_id = :fb_flow_id',
'   and (  display_as in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'       or (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'          and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'          )',
'       )',
'   and nvl(PROTECTION_LEVEL,''N'') <> :P9006_DISPLAY_ONLY_ITEM_LEVEL',
'   and replace(:P9006_DISPLAY_ONLY_ITEM_LEVEL,''%''||''null%'',null) is not null',
'group by flow_step_id, nvl(PROTECTION_LEVEL,''N'')'))
,p_display_when_condition=>'replace(:P9006_DISPLAY_ONLY_ITEM_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(123728124628276646.4001)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('No se actualizar\00E1 ning\00FAn elemento de s\00F3lo visualizaci\00F3n.')
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114327113310033549.4001)
,p_query_column_id=>1
,p_column_alias=>'Page'
,p_column_display_sequence=>1
,p_column_heading=>unistr('P\00E1gina')
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114326814977033548.4001)
,p_query_column_id=>2
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n del Elemento')
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(17287012676783081)
,p_lov_show_nulls=>'NO'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(114326913105033549.4001)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Recuento de Elementos'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(114526816263221046.4001)
,p_plug_name=>'Activar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>20
,p_plug_source=>unistr('<p>Confirme la solicitud de activar la protecci\00F3n de estado de la sesi\00F3n. Esta acci\00F3n no modificar\00E1 los atributos de p\00E1gina o de elemento.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ENABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208204218278064557.4001)
,p_plug_name=>'Wizard Buttons - Enable'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ENABLE'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208208215077082588.4001)
,p_plug_name=>'Wizard Buttons - Set'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ALL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747150140279138182.4001)
,p_plug_name=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114529304320255412.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208204218278064557.4001)
,p_button_name=>'Cancel2'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114268818793422743.4001)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(208208215077082588.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114528018734250167.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208204218278064557.4001)
,p_button_name=>'ENABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Activar'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''N'''
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114268611722422740.4001)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(208208215077082588.4001)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114528627045252549.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208204218278064557.4001)
,p_button_name=>'PREVIOUS2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(114269007397422743.4001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(208208215077082588.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114286228922497084.4001)
,p_branch_action=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114528627045252549.4001)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ENABLE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114287113123501951.4001)
,p_branch_action=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(114269007397422743.4001)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ALL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(114270422033422748.4001)
,p_branch_action=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114269207753422744.4001)
,p_name=>'P9007_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114269722522422745.4001)
,p_name=>'P9007_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114361329951471975.4001)
,p_name=>'P9007_PAGE_LEVEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114466403273479258.4001)
,p_name=>'P9007_APP_ITEM_LEVEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114467313662482290.4001)
,p_name=>'P9007_DATA_ENTRY_ITEM_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114467925090485520.4001)
,p_name=>'P9007_DISPLAY_ONLY_ITEM_LEVEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(114468605828489480.4001)
,p_name=>'P9007_PAGE_ITEM_ESCAPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(114268403942422739.4001)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114270230740422747.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set application attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from wwv_flows where id = :FB_FLOW_ID',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'           and id not between 4000 and 4999) loop',
'    --',
'    update wwv_flows set page_protection_enabled_y_n = ''Y''',
'           where nvl(page_protection_enabled_y_n,''N'') = ''N'' and',
'           id = :FB_FLOW_ID;           ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al activar la protecci\00F3n de estado de la sesi\00F3n.')
,p_process_when=>'SET,ENABLE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Protecci\00F3n de estado de la sesi\00F3n activada.  ')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114283732685469729.4001)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update page and item attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from wwv_flows where id = :FB_FLOW_ID',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'           and id not between 4000 and 4999) loop',
'    --    ',
'    update wwv_flow_steps',
'       set protection_level = :P9006_PAGE_LEVEL',
'     where flow_id = :FB_FLOW_ID ',
'       and replace(:P9006_PAGE_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_items',
'       set protection_level = :P9006_APP_ITEM_LEVEL',
'     where name <> ''FSP_AFTER_LOGIN_URL''',
'       and flow_id = :FB_FLOW_ID ',
'       and replace(:P9006_APP_ITEM_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_step_items',
'       set protection_level = :P9006_DATA_ENTRY_ITEM_LEVEL',
'     where (   display_as not in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'           and not (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'                   and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'                   )',
'           )',
'       and flow_id = :FB_FLOW_ID',
'       and replace(:P9006_DATA_ENTRY_ITEM_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_step_items',
'       set protection_level = :P9006_DISPLAY_ONLY_ITEM_LEVEL',
'     where (  display_as in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'           or (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'              and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'              )',
'           )',
'       and flow_id = :FB_FLOW_ID ',
'       and replace(:P9006_DISPLAY_ONLY_ITEM_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_step_items',
'       set escape_on_http_input = :P9006_PAGE_ITEM_ESCAPE',
'     where flow_id = :FB_FLOW_ID ',
'       and replace(:P9006_PAGE_ITEM_ESCAPE,''%''||''null%'',null) is not null;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al actualizar los atributos de seguridad de estado de la sesi\00F3n de p\00E1gina y elemento.')
,p_process_when_button_id=>wwv_flow_api.id(114268611722422740.4001)
,p_process_when=>'P525_LEVEL'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ALL'
,p_process_success_message=>unistr('<p />Atributos de seguridad de estado de la sesi\00F3n de p\00E1gina y de elemento actualizados.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(114376500842662215.4001)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select decode(:P9006_PAGE_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGES'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGES'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''C'',wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM''),',
'''U'',wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED''),',
'''D'',wwv_flow_lang.system_message(''NO_URL_ACCESS'')) val from dual) loop',
'  :P9007_PAGE_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_APP_ITEM_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_APPLICATION_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_APPLICATION_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''B'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_WORKSPACE''),',
'''P'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_USER''), ',
'''S'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_SESSION''),',
'''I'',wwv_flow_lang.system_message(''RESTRICTED_NO_SET_FROM_BROWSER'')) val from dual) loop',
'  :P9007_APP_ITEM_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_DATA_ENTRY_ITEM_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DATA_ENTRY_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DATA_ENTRY_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''B'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_WORKSPACE''),',
'''P'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_USER''), ',
'''S'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_SESSION''),',
'''I'',wwv_flow_lang.system_message(''RESTRICTED_NO_SET_FROM_BROWSER'')) val from dual) loop',
'  :P9007_DATA_ENTRY_ITEM_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_DISPLAY_ONLY_ITEM_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''B'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_WORKSPACE''),',
'''P'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_USER''), ',
'''S'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_SESSION''),',
'''I'',wwv_flow_lang.system_message(''RESTRICTED_NO_SET_FROM_BROWSER'')) val from dual) loop',
'  :P9007_DISPLAY_ONLY_ITEM_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_PAGE_ITEM_ESCAPE,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGE_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGE_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''F4000.NO''),',
'''Y'',wwv_flow_lang.system_message(''F4000.YES'')) val from dual) loop',
'  :P9007_PAGE_ITEM_ESCAPE := c1.val;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_09008
begin
wwv_flow_api.create_page(
 p_id=>9008.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Desactivar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_step_title=>unistr('Desactivar Protecci\00F3n de Estado de la Sesi\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(702688271851047856.4001)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109520210095194155.4001)
,p_plug_name=>'Desactivar'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_api.id(109521305294221172.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1141992015120113961.4001)
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La desactivaci\00F3n de la protecci\00F3n de estado de la sesi\00F3n es adecuada normalmente en aplicaciones que no tratan con informaci\00F3n altamente confidencial.</p>'),
unistr('<p>Si la funci\00F3n est\00E1 desactivada, se utilizan las siguientes reglas de seguridad de estado de la sesi\00F3n:</p>')))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(109645406637759954.4001)
,p_plug_name=>'Progreso'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(40778201261099606.4001)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(109642120442735590.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(40780006081223991.4001)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110814830114933628.4001)
,p_plug_name=>unistr('Controles de Protecci\00F3n del Estado de Sesi\00F3n de la Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(42025417508627628.4001)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111855318025791886.4001)
,p_plug_name=>unistr('Desactivando Protecci\00F3n de Estado de la Sesi\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_source=>unistr('<p>La desactivaci\00F3n de la funci\00F3n s\00F3lo cambia el atributo de la aplicaci\00F3n, no cambia ninguno de los atributos de p\00E1gina o elemento relacionados con la seguridad de estado de la sesi\00F3n; dichos atributos se ignorar\00E1n cuando la aplicaci\00F3n se ejecute co')
||unistr('n la funci\00F3n desactivada, pero volver\00E1n a aplicarse cuando vuelva a activar la protecci\00F3n de estado de la sesi\00F3n.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(208210118110102377.4001)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(689274781922315777.4001)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(747150238761138182.4001)
,p_plug_name=>unistr('Definir Protecci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_api.id(703488066986172098.4001)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109524813726275298.4001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(208210118110102377.4001)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_image_alt=>'Cancelar'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109524628805275296.4001)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(208210118110102377.4001)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(183227826797404355.4001)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Terminar'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''Y'''
,p_button_condition_type=>'EXISTS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(109619118460401290.4001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(208210118110102377.4001)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(354034308421865099.4001)
,p_button_image_alt=>'Anterior'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(109595321586127705.4001)
,p_branch_action=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110816015354938887.4001)
,p_name=>'P9008_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(110814830114933628.4001)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Aplicaci\00F3n:')
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>unistr('Este atributo identifica la aplicaci\00F3n actual.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(110816918638942316.4001)
,p_name=>'P9008_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(110814830114933628.4001)
,p_item_default=>'N'
,p_prompt=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n:')
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_api.id(91439803955181562.4001)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(561547836135222071.4001)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indica si la protecci\00F3n de estado de la sesi\00F3n est\00E1 activada o desactivada. Si est\00E1 activada, utiliza los atributos de p\00E1gina <i>Protecci\00F3n de Acceso a P\00E1gina</i> y los atributos de elemento <i>Protecci\00F3n de Estado de la Sesi\00F3n</i> junto con los tota')
||unistr('les de control colocados en las direcciones URL "f?p=". Esta funci\00F3n impide la manipulaci\00F3n de direcciones URL y el acceso no autorizado al estado de la sesi\00F3n, as\00ED como su modificaci\00F3n. '),
'<p />',
unistr('Si est\00E1 desactivada, los atributos de elemento y de p\00E1gina relacionadas con la protecci\00F3n de estado de la sesi\00F3n se ignoran y los totales de control no se incluyen en las direcciones URL "f?p=" generadas.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(110698229152438343.4001)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set session state security Standard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from wwv_flows where id = :FB_FLOW_ID ',
'  and nvl(page_protection_enabled_y_n,''N'') = ''Y'' ) loop',
'    update wwv_flows set page_protection_enabled_y_n = ''N'' ',
'          where id = :FB_FLOW_ID ',
'          and security_group_id = wwv_flow_security.g_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Error al desactivar la protecci\00F3n de estado de la sesi\00F3n de la aplicaci\00F3n.')
,p_process_when_button_id=>wwv_flow_api.id(109524628805275296.4001)
,p_process_success_message=>unistr('Protecci\00F3n de estado de la sesi\00F3n de la aplicaci\00F3n desactivada.')
);
end;
/
prompt --application/pages/page_09009
begin
wwv_flow_api.create_page(
 p_id=>9009.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_step_title=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15031017595405628.4001)
,p_plug_name=>unistr('Informes de Comparaci\00F3n de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(15030113309394959.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47651812435054562.4001)
,p_plug_name=>'Seguridad'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_api.id(47648606548052805.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(47659104994090209.4001)
,p_plug_name=>'Interfaz de Usuario'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_api.id(47656832568088745.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162364406853895742.4001)
,p_plug_name=>unistr('Atributos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_api.id(162360828277873558.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(693422331030340241.4001)
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(698800915639413302.4001)
,p_plug_name=>'Region Container'
,p_region_css_classes=>'apex-grid--tableBased'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(208928010704475743.4001)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(699069038663848517.4001)
,p_plug_name=>'Utilidades del Espacio de Trabajo'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>161
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(2778715503937249.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_09010
begin
wwv_flow_api.create_page(
 p_id=>9010.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Atributos de Aplicaci\00F3n por Aplicaci\00F3n')
,p_step_title=>unistr('Atributos de Aplicaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(11501804013545635)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1285400196517282.4001)
,p_plug_name=>unistr('Atributos de Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9010a */',
'ID, ',
'SECURITY_GROUP_ID,',
'OWNER,',
'"NAME",',
'LAST_UPDATED_BY, LAST_UPDATED_ON,',
'(select count(*) from wwv_flow_steps where flow_id = f.id) pages,',
'CHARSET,',
'FLOW_LANGUAGE,',
'nvl(APPLICATION_TAB_SET,1) APPLICATION_TAB_SET,',
'(select BANNER ',
'from WWV_FLOW_BANNER b',
'where b.id = f.id) application_comment,',
'  (select count(*) c from wwv_flow_page_plugs where flow_id = f.id) regions,',
'  (select count(*) c from wwv_flow_step_items where flow_id = f.id) +',
'  (select count(*) c from wwv_flow_items where flow_id = f.id)  items,',
'  (select count(*) c from wwv_flow_step_buttons where flow_id = f.id) buttons,',
'  (select count(*) c from wwv_flow_step_branches where flow_id = f.id) branches,',
'  (select count(*) c from wwv_flow_step_validations where flow_id = f.id) validations,',
'  (select count(*) c from wwv_flow_step_processing where flow_id = f.id) +',
'  (select count(*) c from wwv_flow_processing where flow_id = f.id) processes,',
'  (select count(*) c from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = f.id) lists_of_values,',
'  (select count(*) c from wwv_flow_page_plugs where flow_id = f.id and plug_source_type = ''NATIVE_IR'') interactive_reports,',
'(select count(*) c from wwv_flow_page_plugs where flow_id = f.id and plug_source_type in (''NATIVE_SQL_REPORT'', ''NATIVE_TABFORM'')) ',
'  classic_reports,',
'SECURITY_SCHEME,',
'replace(replace(AUTHENTICATION,''CUSTOM2'',wwv_flow_lang.system_message(''AUTHENTICATION SCHEME'')),''COOKIE'',''INTERNAL'') authentication,',
'  (select count(*) c from wwv_flow_authentications where flow_id = f.id) authorization_schemes,',
'  (select count(*) c from WWV_FLOW_SECURITY_SCHEMES where flow_id = f.id) authentication_schemes',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1285528456517282.4001)
,p_name=>'Application Attributes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1285725043517289.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1285818266517289.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'SECURITY_GROUP_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1285903514517289.4001)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Esquema de An\00E1lisis')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286029046517290.4001)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286100408517290.4001)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Actualizado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286205356517290.4001)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Fecha'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286322799517290.4001)
,p_db_column_name=>'PAGES'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('P\00E1ginas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286413808517290.4001)
,p_db_column_name=>'CHARSET'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Juego de Caracteres'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286507095517290.4001)
,p_db_column_name=>'FLOW_LANGUAGE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Idioma'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1286602361517291.4001)
,p_db_column_name=>'APPLICATION_TAB_SET'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Depuraci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1288230732533568.4001)
,p_db_column_name=>'APPLICATION_COMMENT'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Comentario de Aplicaci\00F3n')
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1296500529619366.4001)
,p_db_column_name=>'REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Regiones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1296609383619366.4001)
,p_db_column_name=>'ITEMS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Elementos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1296732635619366.4001)
,p_db_column_name=>'BUTTONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Botones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1296818103619366.4001)
,p_db_column_name=>'BRANCHES'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Bifurcaciones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1296925281619367.4001)
,p_db_column_name=>'VALIDATIONS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Validaciones'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1297022202619367.4001)
,p_db_column_name=>'PROCESSES'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Procesos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1297111885619367.4001)
,p_db_column_name=>'LISTS_OF_VALUES'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Listas de Valores'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1297221426619367.4001)
,p_db_column_name=>'INTERACTIVE_REPORTS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Informes Interactivos'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1297310456619367.4001)
,p_db_column_name=>'CLASSIC_REPORTS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>unistr('Informes Cl\00E1sicos')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1300429450665635.4001)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Esquema de Seguridad'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1300508052665636.4001)
,p_db_column_name=>'AUTHENTICATION'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>unistr('Autenticaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1300632697665636.4001)
,p_db_column_name=>'AUTHORIZATION_SCHEMES'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>unistr('Esquemas de Autorizaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1300702863665636.4001)
,p_db_column_name=>'AUTHENTICATION_SCHEMES'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>unistr('Esquemas de Autenticaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702929941780192950.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_09012
begin
wwv_flow_api.create_page(
 p_id=>9012.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Opciones de Creaci\00F3n por Aplicaci\00F3n')
,p_step_title=>unistr('Opciones de Creaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_util_cross_app.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1293121700583306.4001)
,p_plug_name=>unistr('Opciones de Creaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9012a */',
'       wwv_flows.id,',
'       "WWV_FLOW_BUILD_OPTIONS".FLOW_ID           as "FLOW_ID",',
'       "WWV_FLOW_BUILD_OPTIONS".PATCH_NAME        as "PATCH_NAME",',
'       "WWV_FLOW_BUILD_OPTIONS".SECURITY_GROUP_ID as "SECURITY_GROUP_ID",',
'       "WWV_FLOW_BUILD_OPTIONS".PATCH_STATUS      as "PATCH_STATUS",',
'       "WWV_FLOW_BUILD_OPTIONS".PATCH_COMMENT     as "PATCH_COMMENT",',
'       "WWV_FLOWS".NAME                           as "NAME" ',
'  from wwv_flow_visible_flows   "WWV_FLOWS",',
'       "WWV_FLOW_BUILD_OPTIONS" "WWV_FLOW_BUILD_OPTIONS" ',
' where WWV_FLOW_BUILD_OPTIONS.FLOW_ID           = WWV_FLOWS.ID',
'   and WWV_FLOW_BUILD_OPTIONS.SECURITY_GROUP_ID = WWV_FLOWS.SECURITY_GROUP_ID',
'   and WWV_FLOWS.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1293214501583306.4001)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1293512113583308.4001)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#FLOW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1294013273583309.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'G'
,p_column_label=>unistr('Nombre de la Aplicaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1293622398583309.4001)
,p_db_column_name=>'PATCH_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Opci\00F3n de Creaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:RP,1,RIR,CIR:FB_FLOW_ID,F4000_P1_FLOW,IR_PATCH_NAME:#ID#,#ID#,#PATCH_NAME#'
,p_column_linktext=>'#PATCH_NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1293730437583309.4001)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'SECURITY_GROUP_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1293827025583309.4001)
,p_db_column_name=>'PATCH_STATUS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1293905668583309.4001)
,p_db_column_name=>'PATCH_COMMENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Comentario'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1293417316583308.4001)
,p_db_column_name=>'ID'
,p_display_order=>7
,p_column_identifier=>'A'
,p_column_label=>'Identificador'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702932627302212342.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_09014
begin
wwv_flow_api.create_page(
 p_id=>9014.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Perfiles de Seguridad por Aplicaci\00F3n')
,p_step_title=>'Perfiles de Seguridad'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1302730874700602.4001)
,p_plug_name=>unistr('Perfiles de Seguridad por Aplicaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9014a */ id,',
'  name, ',
'  OWNER parse_as, ',
'  SECURITY_SCHEME,',
'  (select count(*) c from wwv_flow_authentications where flow_id = f.id) aset,',
'  (select count(*) c from WWV_FLOW_SECURITY_SCHEMES where flow_id = f.id) ss,',
'  (select count(*) c from WWV_FLOW_steps where flow_id = f.id) pages,',
'  --',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id and display_as like ''NATIVE_PASSWORD'') ',
'   password_items,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id and display_as like ''NATIVE_PASSWORD''',
'     and is_persistent = ''N'')',
'   password_items_no_state,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id ',
'   and display_as = ''NATIVE_PASSWORD''',
'   and is_persistent <> ''N''',
'   and nvl(ENCRYPT_SESSION_STATE_YN,''N'') = ''N'')',
'   at_risk_password_items,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id and display_as like ''NATIVE_PASSWORD'' ',
'     and nvl(ENCRYPT_SESSION_STATE_YN,''N'') = ''Y'') ',
'   encrypted_password_items,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id ',
'   and nvl(ENCRYPT_SESSION_STATE_YN,''N'') = ''Y'') ',
'   encrypted_items',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<br /><p>Los elementos de contrase\00F1a que suponen un riesgo son elementos de tipo Contrase\00F1a que guardan el estado de la sesi\00F3n y no cifran el estado guardado. La seguridad de estos elementos de contrase\00F1a se puede mejorar si no se guarda el estado o ')
||'se guarda cifrado.</p>',
''))
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1302829764700602.4001)
,p_name=>'Security Profiles by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303014156700603.4001)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303119499700604.4001)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Nombre'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303206511700604.4001)
,p_db_column_name=>'PARSE_AS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Esquema de An\00E1lisis')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303300290700604.4001)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>unistr('Esquema de Autorizaci\00F3n de<br />Nivel de Aplicaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303500712700605.4001)
,p_db_column_name=>'ASET'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Esquemas de<br />Autenticaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303604536700605.4001)
,p_db_column_name=>'SS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Esquemas de<br/>Autorizaci\00F3n')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1303731349700605.4001)
,p_db_column_name=>'PAGES'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>unistr('P\00E1ginas')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15974320568537590.4001)
,p_db_column_name=>'PASSWORD_ITEMS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>unistr('Elementos de Contrase\00F1a')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15983104123570700.4001)
,p_db_column_name=>'PASSWORD_ITEMS_NO_STATE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>unistr('Elementos de Contrase\00F1a sin Estado')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15983212340570701.4001)
,p_db_column_name=>'ENCRYPTED_PASSWORD_ITEMS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>unistr('Elementos de Contrase\00F1a Cifrada')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15983323127570701.4001)
,p_db_column_name=>'ENCRYPTED_ITEMS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Elementos Cifrados'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(15985201493655103.4001)
,p_db_column_name=>'AT_RISK_PASSWORD_ITEMS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>unistr('Elementos de Contrase\00F1a en Riesgo')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702954370001516801.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/pages/page_09015
begin
wwv_flow_api.create_page(
 p_id=>9015.4001
,p_user_interface_id=>wwv_flow_api.id(4970031699302343.4001)
,p_name=>unistr('Esquemas de Autenticaci\00F3n por Aplicaci\00F3n')
,p_step_title=>unistr('Esquemas de Autenticaci\00F3n')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(213425326892450628)
,p_step_template=>wwv_flow_api.id(386677207130845076.4001)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1305702192713900.4001)
,p_plug_name=>unistr('Esquemas de Autorizaci\00F3n')
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(646287526247383209.4001)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9015a */',
'  f.id flow,  ',
'  f.name application_name,',
'  a.name,',
'  case',
'    when a.id = f.authentication_id then  ',
'      wwv_flow_lang.system_message(''F4350.CURRENT'')',
'    else',
'      wwv_flow_lang.system_message(''F4350.AVAILABLE'')',
'  end status,',
'  a.help_text as description ',
' from wwv_flow_visible_flows f,',
'      wwv_flow_authentications a',
'where a.security_group_id = f.security_group_id',
'  and a.flow_id           = f.id',
'  and f.build_status      != ''RUN_AND_HIDDEN''',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(1305831271713900.4001)
,p_name=>'Authorization Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
,p_no_data_found_message=>unistr('No se ha encontrado ning\00FAn dato.')
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1306009273713902.4001)
,p_db_column_name=>'FLOW'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>unistr('Aplicaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1,4015,RP:FB_FLOW_ID,F4000_P1_FLOW:#FLOW#,#FLOW#'
,p_column_linktext=>'#FLOW#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1306115727713902.4001)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>unistr('Nombre de la Aplicaci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1306225409713902.4001)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>unistr('Nombre de Esquema de Autenticaci\00F3n')
,p_column_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:RP,1,4015,801,CIR,RIR:FB_FLOW_ID,F4000_P1_FLOW,IRC_NAME:#FLOW#,#FLOW#,#NAME#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1306317599713902.4001)
,p_db_column_name=>'STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Estado'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1306407405713903.4001)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Descripci\00F3n')
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(702954735784520575.4001)
,p_plug_name=>unistr('Informes de Aplicaci\00F3n Cruzados')
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(174794400314076650.4001)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(702923103587108064.4001)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(697214733556634905.4001)
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
